# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class NBAP_CommonDataTypes:

    _name_  = 'NBAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 20, 3, 2, 1, 3]
    
    _obj_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'Criticality',
        'MessageDiscriminator',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProcedureID',
        'ProtocolIE-ID',
        'TransactionID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'MessageDiscriminator',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProcedureID',
        'ProtocolIE-ID',
        'TransactionID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< MessageDiscriminator >-----#
    MessageDiscriminator = ENUM(name='MessageDiscriminator', mode=MODE_TYPE)
    MessageDiscriminator._cont = ASN1Dict([('common', 0), ('dedicated', 1)])
    MessageDiscriminator._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProcedureID >-----#
    ProcedureID = SEQ(name='ProcedureID', mode=MODE_TYPE)
    _ProcedureID_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    _ProcedureID_ddMode = ENUM(name='ddMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProcedureID_ddMode._cont = ASN1Dict([('tdd', 0), ('fdd', 1), ('common', 2)])
    _ProcedureID_ddMode._ext = []
    ProcedureID._cont = ASN1Dict([
        ('procedureCode', _ProcedureID_procedureCode),
        ('ddMode', _ProcedureID_ddMode),
        ])
    ProcedureID._ext = None
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TransactionID >-----#
    TransactionID = CHOICE(name='TransactionID', mode=MODE_TYPE)
    _TransactionID_shortTransActionId = INT(name='shortTransActionId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransactionID_shortTransActionId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _TransactionID_longTransActionId = INT(name='longTransActionId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransactionID_longTransActionId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    TransactionID._cont = ASN1Dict([
        ('shortTransActionId', _TransactionID_shortTransActionId),
        ('longTransActionId', _TransactionID_longTransActionId),
        ])
    TransactionID._ext = None
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessfull-outcome', 2), ('outcome', 3)])
    TriggeringMessage._ext = None
    
    _all_ = [
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        Criticality,
        MessageDiscriminator,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        _ProcedureID_procedureCode,
        _ProcedureID_ddMode,
        ProcedureID,
        ProtocolIE_ID,
        _TransactionID_shortTransActionId,
        _TransactionID_longTransActionId,
        TransactionID,
        TriggeringMessage,
    ]

class NBAP_Constants:

    _name_  = 'NBAP-Constants'
    _oid_   = [0, 4, 0, 0, 20, 3, 2, 1, 4]
    
    _obj_ = [
        'id-audit',
        'id-auditRequired',
        'id-blockResource',
        'id-cellDeletion',
        'id-cellReconfiguration',
        'id-cellSetup',
        'id-cellSynchronisationInitiation',
        'id-cellSynchronisationReconfiguration',
        'id-cellSynchronisationReporting',
        'id-cellSynchronisationTermination',
        'id-cellSynchronisationFailure',
        'id-commonMeasurementFailure',
        'id-commonMeasurementInitiation',
        'id-commonMeasurementReport',
        'id-commonMeasurementTermination',
        'id-commonTransportChannelDelete',
        'id-commonTransportChannelReconfigure',
        'id-commonTransportChannelSetup',
        'id-compressedModeCommand',
        'id-dedicatedMeasurementFailure',
        'id-dedicatedMeasurementInitiation',
        'id-dedicatedMeasurementReport',
        'id-dedicatedMeasurementTermination',
        'id-downlinkPowerControl',
        'id-downlinkPowerTimeslotControl',
        'id-errorIndicationForCommon',
        'id-errorIndicationForDedicated',
        'id-informationExchangeFailure',
        'id-informationExchangeInitiation',
        'id-informationExchangeTermination',
        'id-informationReporting',
        'id-BearerRearrangement',
        'id-mBMSNotificationUpdate',
        'id-physicalSharedChannelReconfiguration',
        'id-privateMessageForCommon',
        'id-privateMessageForDedicated',
        'id-radioLinkAddition',
        'id-radioLinkDeletion',
        'id-radioLinkFailure',
        'id-radioLinkPreemption',
        'id-radioLinkRestoration',
        'id-radioLinkSetup',
        'id-reset',
        'id-resourceStatusIndication',
        'id-cellSynchronisationAdjustment',
        'id-synchronisedRadioLinkReconfigurationCancellation',
        'id-synchronisedRadioLinkReconfigurationCommit',
        'id-synchronisedRadioLinkReconfigurationPreparation',
        'id-systemInformationUpdate',
        'id-unblockResource',
        'id-unSynchronisedRadioLinkReconfiguration',
        'id-radioLinkActivation',
        'id-radioLinkParameterUpdate',
        'id-uEStatusUpdate',
        'id-secondaryULFrequencyReporting',
        'id-secondaryULFrequencyUpdate',
        'id-uEStatusUpdateConfirmation',
        'maxNrOfCodes',
        'maxNrOfDLTSs',
        'maxNrOfDLTSLCRs',
        'maxNrOfErrors',
        'maxNrOfTFs',
        'maxNrOfTFCs',
        'maxNrOfRLs',
        'maxNrOfRLs-1',
        'maxNrOfRLs-2',
        'maxNrOfRLSets',
        'maxNrOfDPCHs',
        'maxNrOfDPCHsPerRL-1',
        'maxNrOfDPCHLCRs',
        'maxNrOfDPCHsLCRPerRL-1',
        'maxNrOfDPCHs768',
        'maxNrOfDPCHs768PerRL-1',
        'maxNrOfSCCPCHs',
        'maxNrOfSCCPCHsinExt',
        'maxNrOfSCCPCHs768',
        'maxNrOfDCHs',
        'maxNrOfDSCHs',
        'maxNrOfFACHs',
        'maxNrOfCCTrCHs',
        'maxNrOfPDSCHs',
        'maxNrOfHSPDSCHs',
        'maxNrOfHSPDSCHs768',
        'maxNrOfPUSCHs',
        'maxNrOfPUSCHs-1',
        'maxNrOfPDSCHSets',
        'maxNrOfPRACHLCRs',
        'maxNrOfPUSCHSets',
        'maxNrOfSCCPCHLCRs',
        'maxNrOfSCCPCHsLCRinExt',
        'maxNrOfULTSs',
        'maxNrOfULTSLCRs',
        'maxNrOfUSCHs',
        'maxNrOfSlotFormatsPRACH',
        'maxCellinNodeB',
        'maxCCPinNodeB',
        'maxCTFC',
        'maxLocalCellinNodeB',
        'maxFPACHCell',
        'maxRACHCell',
        'maxPLCCHCell',
        'maxPRACHCell',
        'maxSCCPCHCell',
        'maxSCCPCHCellinExt',
        'maxSCCPCHCellinExtLCR',
        'maxSCCPCHCell768',
        'maxSCPICHCell',
        'maxTTI-count',
        'maxIBSEG',
        'maxIB',
        'maxFACHCell',
        'maxRateMatching',
        'maxHS-PDSCHCodeNrComp-1',
        'maxHS-SCCHCodeNrComp-1',
        'maxNrOfCellSyncBursts',
        'maxNrOfReceptsPerSyncFrame',
        'maxNrOfMeasNCell',
        'maxNrOfMeasNCell-1',
        'maxNrOfSF',
        'maxTGPS',
        'maxCommunicationContext',
        'maxNrOfLevels',
        'maxNoSat',
        'maxNoGPSItems',
        'maxNrOfHSSCCHs',
        'maxNrOfHSSICHs',
        'maxNrOfHSSICHs-1',
        'maxNrOfSyncFramesLCR',
        'maxNrOfReceptionsperSyncFrameLCR',
        'maxNrOfSyncDLCodesLCR',
        'maxNrOfHSSCCHCodes',
        'maxNrOfMACdFlows',
        'maxNrOfMACdFlows-1',
        'maxNrOfMACdPDUIndexes',
        'maxNrOfMACdPDUIndexes-1',
        'maxNrOfMACdPDUSize',
        'maxNrOfNIs',
        'maxNrOfPriorityQueues',
        'maxNrOfPriorityQueues-1',
        'maxNrOfHARQProcesses',
        'maxNrOfContextsOnUeList',
        'maxNrOfCellPortionsPerCell',
        'maxNrOfCellPortionsPerCell-1',
        'maxNrOfPriorityClasses',
        'maxNrOfSatAlmanac-maxNoSat',
        'maxNrOfE-AGCHs',
        'maxNrOfEDCHMACdFlows',
        'maxNrOfEDCHMACdFlows-1',
        'maxNrOfE-RGCHs-E-HICHs',
        'maxNrOfEDCH-HARQ-PO-QUANTSTEPs',
        'maxNrOfEDCHHARQProcesses2msEDCH',
        'maxNrOfEDPCCH-PO-QUANTSTEPs',
        'maxNrOfBits-MACe-PDU-non-scheduled',
        'maxNrOfRefETFCIs',
        'maxNrOfRefETFCI-PO-QUANTSTEPs',
        'maxNrofSigSeqRGHI-1',
        'maxNoOfLogicalChannels',
        'maxNrOfCombEDPDCH',
        'maxE-RUCCHCell',
        'maxNrOfEAGCHCodes',
        'maxNrOfRefBetas',
        'maxNrOfE-PUCHSlots',
        'maxNrOfEAGCHs',
        'maxNrOfHS-DSCH-TBSs-HS-SCCHless',
        'maxNrOfHS-DSCH-TBSs',
        'maxNrOfEHICHCodes',
        'maxNrOfE-PUCHSlotsLCR',
        'maxNrOfEPUCHcodes',
        'maxNrOfEHICHs',
        'maxNrOfCommonMACFlows',
        'maxNrOfCommonMACFlows-1',
        'maxNrOfPagingMACFlow',
        'maxNrOfPagingMACFlow-1',
        'maxNrOfcommonMACQueues',
        'maxNrOfpagingMACQueues',
        'maxNrOfHS-DSCHTBSsE-PCH',
        'maxGANSSSat',
        'maxNoGANSS',
        'maxSgnType',
        'maxFrequencyinCell',
        'maxFrequencyinCell-1',
        'maxHSDPAFrequency',
        'maxHSDPAFrequency-1',
        'maxNrOfHSSCCHsinExt',
        'maxGANSSSatAlmanac',
        'maxGANSSClockMod',
        'maxNrOfEDCHRLs',
        'maxERNTItoRelease',
        'maxNrOfCommonEDCH',
        'maxNrOfCommonHRNTI',
        'maxNrOfCommonMACFlowsLCR',
        'maxNrOfCommonMACFlowsLCR-1',
        'maxNrOfHSSCCHsLCR',
        'maxNrOfEDCHMACdFlowsLCR',
        'maxNrOfEDCHMACdFlowsLCR-1',
        'maxNrOfEAGCHsLCR',
        'maxNrOfEHICHsLCR',
        'maxnrofERUCCHsLCR',
        'maxNrOfHSDSCH-1',
        'maxNrOfHSDSCH',
        'maxGANSS-1',
        'maxNoOfTBSs-Mapping-HS-DSCH-SPS',
        'maxNoOfTBSs-Mapping-HS-DSCH-SPS-1',
        'maxNoOfHS-DSCH-TBSsLCR',
        'maxNoOfRepetition-Period-LCR',
        'maxNoOfRepetitionPeriod-SPS-LCR-1',
        'maxNoOf-HS-SICH-SPS',
        'maxNoOf-HS-SICH-SPS-1',
        'maxNoOfNon-HS-SCCH-Assosiated-HS-SICH',
        'maxNoOfNon-HS-SCCH-Assosiated-HS-SICH-Ext',
        'maxMBMSServiceSelect',
        'maxNrOfCellPortionsPerCellLCR',
        'maxNrOfCellPortionsPerCellLCR-1',
        'maxNrOfEDCH-1',
        'maxNoOfCommonH-RNTI',
        'maxNrOfCommonMACFlowsLCRExt',
        'maxofERNTI',
        'maxNrOfDCHMeasurementOccasionPatternSequence',
        'maxNrOfULCarriersLCR-1',
        'maxFreqBandsTDD',
        'maxnoofPRACHEUL',
        'maxIGPInfo',
        'maxNrofConcatenatedDCH',
        'id-AICH-Information',
        'id-AICH-InformationItem-ResourceStatusInd',
        'id-BCH-Information',
        'id-BCH-InformationItem-ResourceStatusInd',
        'id-BCCH-ModificationTime',
        'id-BlockingPriorityIndicator',
        'id-Cause',
        'id-CCP-InformationItem-AuditRsp',
        'id-CCP-InformationList-AuditRsp',
        'id-CCP-InformationItem-ResourceStatusInd',
        'id-Cell-InformationItem-AuditRsp',
        'id-Cell-InformationItem-ResourceStatusInd',
        'id-Cell-InformationList-AuditRsp',
        'id-CellParameterID',
        'id-CFN',
        'id-C-ID',
        'id-CommonMeasurementAccuracy',
        'id-CommonMeasurementObjectType-CM-Rprt',
        'id-CommonMeasurementObjectType-CM-Rqst',
        'id-CommonMeasurementObjectType-CM-Rsp',
        'id-CommonMeasurementType',
        'id-CommonPhysicalChannelID',
        'id-CommonPhysicalChannelType-CTCH-SetupRqstFDD',
        'id-CommonPhysicalChannelType-CTCH-SetupRqstTDD',
        'id-CommunicationControlPortID',
        'id-ConfigurationGenerationID',
        'id-CRNC-CommunicationContextID',
        'id-CriticalityDiagnostics',
        'id-DCHs-to-Add-FDD',
        'id-DCH-AddList-RL-ReconfPrepTDD',
        'id-DCHs-to-Add-TDD',
        'id-DCH-DeleteList-RL-ReconfPrepFDD',
        'id-DCH-DeleteList-RL-ReconfPrepTDD',
        'id-DCH-DeleteList-RL-ReconfRqstFDD',
        'id-DCH-DeleteList-RL-ReconfRqstTDD',
        'id-DCH-FDD-Information',
        'id-DCH-TDD-Information',
        'id-DCH-InformationResponse',
        'id-FDD-DCHs-to-Modify',
        'id-TDD-DCHs-to-Modify',
        'id-DCH-ModifyList-RL-ReconfRqstTDD',
        'id-DCH-RearrangeList-Bearer-RearrangeInd',
        'id-DedicatedMeasurementObjectType-DM-Rprt',
        'id-DedicatedMeasurementObjectType-DM-Rqst',
        'id-DedicatedMeasurementObjectType-DM-Rsp',
        'id-DedicatedMeasurementType',
        'id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        'id-DL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        'id-DL-CCTrCH-InformationList-RL-SetupRqstTDD',
        'id-DL-DPCH-InformationItem-RL-AdditionRqstTDD',
        'id-DL-DPCH-InformationList-RL-SetupRqstTDD',
        'id-DL-DPCH-Information-RL-ReconfPrepFDD',
        'id-DL-DPCH-Information-RL-ReconfRqstFDD',
        'id-DL-DPCH-Information-RL-SetupRqstFDD',
        'id-DL-DPCH-TimingAdjustment',
        'id-DL-ReferencePowerInformationItem-DL-PC-Rqst',
        'id-DLReferencePower',
        'id-DLReferencePowerList-DL-PC-Rqst',
        'id-Unused-ProtocolIE-ID-87',
        'id-Unused-ProtocolIE-ID-89',
        'id-Unused-ProtocolIE-ID-91',
        'id-Unused-ProtocolIE-ID-93',
        'id-DSCHs-to-Add-TDD',
        'id-DSCH-Information-DeleteList-RL-ReconfPrepTDD',
        'id-DSCH-Information-ModifyList-RL-ReconfPrepTDD',
        'id-DSCH-InformationResponse',
        'id-Unused-ProtocolIE-ID-106',
        'id-DSCH-TDD-Information',
        'id-Unused-ProtocolIE-ID-108',
        'id-Unused-ProtocolIE-ID-112',
        'id-DSCH-RearrangeList-Bearer-RearrangeInd',
        'id-End-Of-Audit-Sequence-Indicator',
        'id-FACH-Information',
        'id-FACH-InformationItem-ResourceStatusInd',
        'id-FACH-ParametersList-CTCH-ReconfRqstTDD',
        'id-FACH-ParametersListIE-CTCH-SetupRqstFDD',
        'id-FACH-ParametersListIE-CTCH-SetupRqstTDD',
        'id-IndicationType-ResourceStatusInd',
        'id-Local-Cell-ID',
        'id-Local-Cell-Group-InformationItem-AuditRsp',
        'id-Local-Cell-Group-InformationItem-ResourceStatusInd',
        'id-Local-Cell-Group-InformationItem2-ResourceStatusInd',
        'id-Local-Cell-Group-InformationList-AuditRsp',
        'id-Local-Cell-InformationItem-AuditRsp',
        'id-Local-Cell-InformationItem-ResourceStatusInd',
        'id-Local-Cell-InformationItem2-ResourceStatusInd',
        'id-Local-Cell-InformationList-AuditRsp',
        'id-AdjustmentPeriod',
        'id-MaxAdjustmentStep',
        'id-MaximumTransmissionPower',
        'id-MeasurementFilterCoefficient',
        'id-MeasurementID',
        'id-MessageStructure',
        'id-MIB-SB-SIB-InformationList-SystemInfoUpdateRqst',
        'id-NodeB-CommunicationContextID',
        'id-NeighbouringCellMeasurementInformation',
        'id-P-CCPCH-Information',
        'id-P-CCPCH-InformationItem-ResourceStatusInd',
        'id-P-CPICH-Information',
        'id-P-CPICH-InformationItem-ResourceStatusInd',
        'id-P-SCH-Information',
        'id-PCCPCH-Information-Cell-ReconfRqstTDD',
        'id-PCCPCH-Information-Cell-SetupRqstTDD',
        'id-PCH-Parameters-CTCH-ReconfRqstTDD',
        'id-PCH-ParametersItem-CTCH-SetupRqstFDD',
        'id-PCH-ParametersItem-CTCH-SetupRqstTDD',
        'id-PCH-Information',
        'id-PDSCH-Information-AddListIE-PSCH-ReconfRqst',
        'id-PDSCH-Information-ModifyListIE-PSCH-ReconfRqst',
        'id-PDSCHSets-AddList-PSCH-ReconfRqst',
        'id-PDSCHSets-DeleteList-PSCH-ReconfRqst',
        'id-PDSCHSets-ModifyList-PSCH-ReconfRqst',
        'id-PICH-Information',
        'id-PICH-Parameters-CTCH-ReconfRqstTDD',
        'id-PowerAdjustmentType',
        'id-PRACH-Information',
        'id-PrimaryCCPCH-Information-Cell-ReconfRqstFDD',
        'id-PrimaryCCPCH-Information-Cell-SetupRqstFDD',
        'id-PrimaryCPICH-Information-Cell-ReconfRqstFDD',
        'id-PrimaryCPICH-Information-Cell-SetupRqstFDD',
        'id-PrimarySCH-Information-Cell-ReconfRqstFDD',
        'id-PrimarySCH-Information-Cell-SetupRqstFDD',
        'id-PrimaryScramblingCode',
        'id-SCH-Information-Cell-ReconfRqstTDD',
        'id-SCH-Information-Cell-SetupRqstTDD',
        'id-PUSCH-Information-AddListIE-PSCH-ReconfRqst',
        'id-PUSCH-Information-ModifyListIE-PSCH-ReconfRqst',
        'id-PUSCHSets-AddList-PSCH-ReconfRqst',
        'id-PUSCHSets-DeleteList-PSCH-ReconfRqst',
        'id-PUSCHSets-ModifyList-PSCH-ReconfRqst',
        'id-RACH-Information',
        'id-RACH-ParametersItem-CTCH-SetupRqstFDD',
        'id-RACH-ParameterItem-CTCH-SetupRqstTDD',
        'id-ReportCharacteristics',
        'id-Reporting-Object-RL-FailureInd',
        'id-Reporting-Object-RL-RestoreInd',
        'id-RL-InformationItem-DM-Rprt',
        'id-RL-InformationItem-DM-Rqst',
        'id-RL-InformationItem-DM-Rsp',
        'id-RL-InformationItem-RL-AdditionRqstFDD',
        'id-RL-informationItem-RL-DeletionRqst',
        'id-RL-InformationItem-RL-FailureInd',
        'id-RL-InformationItem-RL-PreemptRequiredInd',
        'id-RL-InformationItem-RL-ReconfPrepFDD',
        'id-RL-InformationItem-RL-ReconfRqstFDD',
        'id-RL-InformationItem-RL-RestoreInd',
        'id-RL-InformationItem-RL-SetupRqstFDD',
        'id-RL-InformationList-RL-AdditionRqstFDD',
        'id-RL-informationList-RL-DeletionRqst',
        'id-RL-InformationList-RL-PreemptRequiredInd',
        'id-RL-InformationList-RL-ReconfPrepFDD',
        'id-RL-InformationList-RL-ReconfRqstFDD',
        'id-RL-InformationList-RL-SetupRqstFDD',
        'id-RL-InformationResponseItem-RL-AdditionRspFDD',
        'id-RL-InformationResponseItem-RL-ReconfReady',
        'id-RL-InformationResponseItem-RL-ReconfRsp',
        'id-RL-InformationResponseItem-RL-SetupRspFDD',
        'id-RL-InformationResponseList-RL-AdditionRspFDD',
        'id-RL-InformationResponseList-RL-ReconfReady',
        'id-RL-InformationResponseList-RL-ReconfRsp',
        'id-RL-InformationResponseList-RL-SetupRspFDD',
        'id-RL-InformationResponse-RL-AdditionRspTDD',
        'id-RL-InformationResponse-RL-SetupRspTDD',
        'id-RL-Information-RL-AdditionRqstTDD',
        'id-RL-Information-RL-ReconfRqstTDD',
        'id-RL-Information-RL-ReconfPrepTDD',
        'id-RL-Information-RL-SetupRqstTDD',
        'id-RL-ReconfigurationFailureItem-RL-ReconfFailure',
        'id-RL-Set-InformationItem-DM-Rprt',
        'id-RL-Set-InformationItem-DM-Rsp',
        'id-RL-Set-InformationItem-RL-FailureInd',
        'id-RL-Set-InformationItem-RL-RestoreInd',
        'id-S-CCPCH-Information',
        'id-S-CPICH-Information',
        'id-SCH-Information',
        'id-S-SCH-Information',
        'id-Secondary-CCPCHListIE-CTCH-ReconfRqstTDD',
        'id-Secondary-CCPCH-parameterListIE-CTCH-SetupRqstTDD',
        'id-Secondary-CCPCH-Parameters-CTCH-ReconfRqstTDD',
        'id-SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD',
        'id-SecondaryCPICH-InformationItem-Cell-SetupRqstFDD',
        'id-SecondaryCPICH-InformationList-Cell-ReconfRqstFDD',
        'id-SecondaryCPICH-InformationList-Cell-SetupRqstFDD',
        'id-SecondarySCH-Information-Cell-ReconfRqstFDD',
        'id-SecondarySCH-Information-Cell-SetupRqstFDD',
        'id-SegmentInformationListIE-SystemInfoUpdate',
        'id-SFN',
        'id-SignallingBearerRequestIndicator',
        'id-ShutdownTimer',
        'id-Start-Of-Audit-Sequence-Indicator',
        'id-Successful-RL-InformationRespItem-RL-AdditionFailureFDD',
        'id-Successful-RL-InformationRespItem-RL-SetupFailureFDD',
        'id-SyncCase',
        'id-SyncCaseIndicatorItem-Cell-SetupRqstTDD-PSCH',
        'id-T-Cell',
        'id-TargetCommunicationControlPortID',
        'id-TimeSlotConfigurationList-Cell-ReconfRqstTDD',
        'id-TimeSlotConfigurationList-Cell-SetupRqstTDD',
        'id-TransmissionDiversityApplied',
        'id-TypeOfError',
        'id-UARFCNforNt',
        'id-UARFCNforNd',
        'id-UARFCNforNu',
        'id-UL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        'id-UL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        'id-UL-CCTrCH-InformationList-RL-SetupRqstTDD',
        'id-UL-DPCH-InformationItem-RL-AdditionRqstTDD',
        'id-UL-DPCH-InformationList-RL-SetupRqstTDD',
        'id-UL-DPCH-Information-RL-ReconfPrepFDD',
        'id-UL-DPCH-Information-RL-ReconfRqstFDD',
        'id-UL-DPCH-Information-RL-SetupRqstFDD',
        'id-Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD',
        'id-Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD',
        'id-Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD',
        'id-Unsuccessful-RL-InformationResp-RL-SetupFailureTDD',
        'id-USCH-Information-Add',
        'id-USCH-Information-DeleteList-RL-ReconfPrepTDD',
        'id-USCH-Information-ModifyList-RL-ReconfPrepTDD',
        'id-USCH-InformationResponse',
        'id-USCH-Information',
        'id-USCH-RearrangeList-Bearer-RearrangeInd',
        'id-Active-Pattern-Sequence-Information',
        'id-AICH-ParametersListIE-CTCH-ReconfRqstFDD',
        'id-AdjustmentRatio',
        'id-Not-Used-320',
        'id-Not-Used-322',
        'id-FACH-ParametersListIE-CTCH-ReconfRqstFDD',
        'id-CauseLevel-PSCH-ReconfFailure',
        'id-CauseLevel-RL-AdditionFailureFDD',
        'id-CauseLevel-RL-AdditionFailureTDD',
        'id-CauseLevel-RL-ReconfFailure',
        'id-CauseLevel-RL-SetupFailureFDD',
        'id-CauseLevel-RL-SetupFailureTDD',
        'id-Not-Used-330',
        'id-Not-Used-332',
        'id-Closed-Loop-Timing-Adjustment-Mode',
        'id-CommonPhysicalChannelType-CTCH-ReconfRqstFDD',
        'id-Compressed-Mode-Deactivation-Flag',
        'id-Not-Used-336',
        'id-Not-Used-342',
        'id-Not-Used-343',
        'id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        'id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        'id-DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        'id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        'id-DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        'id-DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        'id-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'id-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD',
        'id-DL-DPCH-InformationModify-AddListIE-RL-ReconfPrepTDD',
        'id-DL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD',
        'id-DL-DPCH-InformationModify-ModifyListIE-RL-ReconfPrepTDD',
        'id-DL-TPC-Pattern01Count',
        'id-DPC-Mode',
        'id-DPCHConstant',
        'id-Unused-ProtocolIE-ID-94',
        'id-Unused-ProtocolIE-ID-110',
        'id-Unused-ProtocolIE-ID-111',
        'id-FACH-ParametersList-CTCH-SetupRsp',
        'id-Limited-power-increase-information-Cell-SetupRqstFDD',
        'id-PCH-Parameters-CTCH-SetupRsp',
        'id-PCH-ParametersItem-CTCH-ReconfRqstFDD',
        'id-Not-Used-376',
        'id-PICH-ParametersItem-CTCH-ReconfRqstFDD',
        'id-PRACHConstant',
        'id-PRACH-ParametersListIE-CTCH-ReconfRqstFDD',
        'id-PUSCHConstant',
        'id-RACH-Parameters-CTCH-SetupRsp',
        'id-Unused-ProtocolIE-ID-443',
        'id-Synchronisation-Configuration-Cell-ReconfRqst',
        'id-Synchronisation-Configuration-Cell-SetupRqst',
        'id-Transmission-Gap-Pattern-Sequence-Information',
        'id-UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        'id-UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        'id-UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        'id-UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        'id-UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        'id-UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        'id-UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'id-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-InformationModify-AddListIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-InformationModify-ModifyListIE-RL-ReconfPrepTDD',
        'id-Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD',
        'id-Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD',
        'id-CommunicationContextInfoItem-Reset',
        'id-CommunicationControlPortInfoItem-Reset',
        'id-ResetIndicator',
        'id-Unused-ProtocolIE-ID-417',
        'id-Unused-ProtocolIE-ID-418',
        'id-Unused-ProtocolIE-ID-419',
        'id-Unused-ProtocolIE-ID-142',
        'id-TimingAdvanceApplied',
        'id-CFNReportingIndicator',
        'id-SFNReportingIndicator',
        'id-InnerLoopDLPCStatus',
        'id-TimeslotISCPInfo',
        'id-PICH-ParametersItem-CTCH-SetupRqstTDD',
        'id-PRACH-ParametersItem-CTCH-SetupRqstTDD',
        'id-CCTrCH-InformationItem-RL-FailureInd',
        'id-CCTrCH-InformationItem-RL-RestoreInd',
        'id-CauseLevel-SyncAdjustmntFailureTDD',
        'id-CellAdjustmentInfo-SyncAdjustmntRqstTDD',
        'id-CellAdjustmentInfoItem-SyncAdjustmentRqstTDD',
        'id-CellSyncBurstInfoList-CellSyncReconfRqstTDD',
        'id-CellSyncBurstTransInit-CellSyncInitiationRqstTDD',
        'id-CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD',
        'id-CellSyncBurstTransReconfiguration-CellSyncReconfRqstTDD',
        'id-CellSyncBurstMeasReconfiguration-CellSyncReconfRqstTDD',
        'id-CellSyncBurstTransInfoList-CellSyncReconfRqstTDD',
        'id-CellSyncBurstMeasInfoList-CellSyncReconfRqstTDD',
        'id-CellSyncBurstTransReconfInfo-CellSyncReconfRqstTDD',
        'id-CellSyncInfo-CellSyncReprtTDD',
        'id-CSBTransmissionID',
        'id-CSBMeasurementID',
        'id-IntStdPhCellSyncInfoItem-CellSyncReprtTDD',
        'id-NCyclesPerSFNperiod',
        'id-NRepetitionsPerCyclePeriod',
        'id-SyncFrameNumber',
        'id-SynchronisationReportType',
        'id-SynchronisationReportCharacteristics',
        'id-Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD',
        'id-LateEntranceCellSyncInfoItem-CellSyncReprtTDD',
        'id-ReferenceClockAvailability',
        'id-ReferenceSFNoffset',
        'id-InformationExchangeID',
        'id-InformationExchangeObjectType-InfEx-Rqst',
        'id-InformationType',
        'id-InformationReportCharacteristics',
        'id-InformationExchangeObjectType-InfEx-Rsp',
        'id-InformationExchangeObjectType-InfEx-Rprt',
        'id-IPDLParameter-Information-Cell-ReconfRqstFDD',
        'id-IPDLParameter-Information-Cell-SetupRqstFDD',
        'id-IPDLParameter-Information-Cell-ReconfRqstTDD',
        'id-IPDLParameter-Information-Cell-SetupRqstTDD',
        'id-DL-DPCH-LCR-Information-RL-SetupRqstTDD',
        'id-DwPCH-LCR-Information',
        'id-DwPCH-LCR-InformationList-AuditRsp',
        'id-DwPCH-LCR-Information-Cell-SetupRqstTDD',
        'id-DwPCH-LCR-Information-Cell-ReconfRqstTDD',
        'id-DwPCH-LCR-Information-ResourceStatusInd',
        'id-maxFACH-Power-LCR-CTCH-SetupRqstTDD',
        'id-maxFACH-Power-LCR-CTCH-ReconfRqstTDD',
        'id-FPACH-LCR-Information',
        'id-FPACH-LCR-Information-AuditRsp',
        'id-FPACH-LCR-InformationList-AuditRsp',
        'id-FPACH-LCR-InformationList-ResourceStatusInd',
        'id-FPACH-LCR-Parameters-CTCH-SetupRqstTDD',
        'id-FPACH-LCR-Parameters-CTCH-ReconfRqstTDD',
        'id-PCCPCH-LCR-Information-Cell-SetupRqstTDD',
        'id-PCH-Power-LCR-CTCH-SetupRqstTDD',
        'id-PCH-Power-LCR-CTCH-ReconfRqstTDD',
        'id-PICH-LCR-Parameters-CTCH-SetupRqstTDD',
        'id-PRACH-LCR-ParametersList-CTCH-SetupRqstTDD',
        'id-RL-InformationResponse-LCR-RL-SetupRspTDD',
        'id-Secondary-CCPCH-LCR-parameterList-CTCH-SetupRqstTDD',
        'id-TimeSlot',
        'id-TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD',
        'id-TimeSlotConfigurationList-LCR-Cell-SetupRqstTDD',
        'id-TimeslotISCP-LCR-InfoList-RL-SetupRqstTDD',
        'id-TimeSlotLCR-CM-Rqst',
        'id-UL-DPCH-LCR-Information-RL-SetupRqstTDD',
        'id-DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD',
        'id-UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD',
        'id-TimeslotISCP-InformationList-LCR-RL-AdditionRqstTDD',
        'id-DL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD',
        'id-DL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD',
        'id-DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'id-TimeslotISCPInfoList-LCR-DL-PC-RqstTDD',
        'id-UL-DPCH-LCR-InformationAddListIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-LCR-InformationModify-AddList',
        'id-UL-TimeslotLCR-Information-RL-ReconfPrepTDD',
        'id-UL-SIRTarget',
        'id-PDSCH-AddInformation-LCR-PSCH-ReconfRqst',
        'id-PDSCH-AddInformation-LCR-AddListIE-PSCH-ReconfRqst',
        'id-Unused-ProtocolIE-ID-26',
        'id-Unused-ProtocolIE-ID-27',
        'id-PDSCH-ModifyInformation-LCR-PSCH-ReconfRqst',
        'id-PDSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst',
        'id-PUSCH-AddInformation-LCR-PSCH-ReconfRqst',
        'id-PUSCH-AddInformation-LCR-AddListIE-PSCH-ReconfRqst',
        'id-PUSCH-ModifyInformation-LCR-PSCH-ReconfRqst',
        'id-PUSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst',
        'id-timeslotInfo-CellSyncInitiationRqstTDD',
        'id-SyncReportType-CellSyncReprtTDD',
        'id-Power-Local-Cell-Group-InformationItem-AuditRsp',
        'id-Power-Local-Cell-Group-InformationItem-ResourceStatusInd',
        'id-Power-Local-Cell-Group-InformationItem2-ResourceStatusInd',
        'id-Power-Local-Cell-Group-InformationList-AuditRsp',
        'id-Power-Local-Cell-Group-InformationList-ResourceStatusInd',
        'id-Power-Local-Cell-Group-InformationList2-ResourceStatusInd',
        'id-Power-Local-Cell-Group-ID',
        'id-PUSCH-Info-DM-Rqst',
        'id-PUSCH-Info-DM-Rsp',
        'id-PUSCH-Info-DM-Rprt',
        'id-InitDL-Power',
        'id-cellSyncBurstRepetitionPeriod',
        'id-ReportCharacteristicsType-OnModification',
        'id-SFNSFNMeasurementValueInformation',
        'id-SFNSFNMeasurementThresholdInformation',
        'id-TUTRANGPSMeasurementValueInformation',
        'id-TUTRANGPSMeasurementThresholdInformation',
        'id-Rx-Timing-Deviation-Value-LCR',
        'id-RL-InformationResponse-LCR-RL-AdditionRspTDD',
        'id-DL-PowerBalancing-Information',
        'id-DL-PowerBalancing-ActivationIndicator',
        'id-DL-PowerBalancing-UpdatedIndicator',
        'id-CCTrCH-Initial-DL-Power-RL-SetupRqstTDD',
        'id-CCTrCH-Initial-DL-Power-RL-AdditionRqstTDD',
        'id-CCTrCH-Initial-DL-Power-RL-ReconfPrepTDD',
        'id-IPDLParameter-Information-LCR-Cell-SetupRqstTDD',
        'id-IPDLParameter-Information-LCR-Cell-ReconfRqstTDD',
        'id-HS-PDSCH-HS-SCCH-E-AGCH-E-RGCH-E-HICH-MaxPower-PSCH-ReconfRqst',
        'id-HS-PDSCH-HS-SCCH-ScramblingCode-PSCH-ReconfRqst',
        'id-HS-PDSCH-FDD-Code-Information-PSCH-ReconfRqst',
        'id-HS-SCCH-FDD-Code-Information-PSCH-ReconfRqst',
        'id-HS-PDSCH-TDD-Information-PSCH-ReconfRqst',
        'id-Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'id-Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'id-Delete-From-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'id-bindingID',
        'id-RL-Specific-DCH-Info',
        'id-transportlayeraddress',
        'id-DelayedActivation',
        'id-DelayedActivationList-RL-ActivationCmdFDD',
        'id-DelayedActivationInformation-RL-ActivationCmdFDD',
        'id-DelayedActivationList-RL-ActivationCmdTDD',
        'id-DelayedActivationInformation-RL-ActivationCmdTDD',
        'id-neighbouringTDDCellMeasurementInformationLCR',
        'id-SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD',
        'id-SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD',
        'id-SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD',
        'id-SYNCDlCodeIdMeasReconfigurationLCR-CellSyncReconfRqstTDD',
        'id-SYNCDlCodeIdMeasInfoList-CellSyncReconfRqstTDD',
        'id-SyncDLCodeIdsMeasInfoList-CellSyncReprtTDD',
        'id-SyncDLCodeIdThreInfoLCR',
        'id-NSubCyclesPerCyclePeriod-CellSyncReconfRqstTDD',
        'id-DwPCH-Power',
        'id-AccumulatedClockupdate-CellSyncReprtTDD',
        'id-Angle-Of-Arrival-Value-LCR',
        'id-HSDSCH-FDD-Information',
        'id-HSDSCH-FDD-Information-Response',
        'id-HSDSCH-Information-to-Modify',
        'id-HSDSCH-RNTI',
        'id-HSDSCH-TDD-Information',
        'id-HSDSCH-TDD-Information-Response',
        'id-HSPDSCH-RL-ID',
        'id-PrimCCPCH-RSCP-DL-PC-RqstTDD',
        'id-Unused-ProtocolIE-ID-64',
        'id-PDSCH-RL-ID',
        'id-HSDSCH-RearrangeList-Bearer-RearrangeInd',
        'id-UL-Synchronisation-Parameters-LCR',
        'id-HSDSCH-FDD-Update-Information',
        'id-HSDSCH-TDD-Update-Information',
        'id-DL-DPCH-TimeSlotFormat-LCR-ModifyItem-RL-ReconfPrepTDD',
        'id-UL-DPCH-TimeSlotFormat-LCR-ModifyItem-RL-ReconfPrepTDD',
        'id-TDD-TPC-UplinkStepSize-LCR-RL-SetupRqstTDD',
        'id-TDD-TPC-UplinkStepSize-LCR-RL-AdditionRqstTDD',
        'id-TDD-TPC-DownlinkStepSize-RL-AdditionRqstTDD',
        'id-TDD-TPC-UplinkStepSize-InformationAdd-LCR-RL-ReconfPrepTDD',
        'id-TDD-TPC-UplinkStepSize-InformationModify-LCR-RL-ReconfPrepTDD',
        'id-TDD-TPC-DownlinkStepSize-InformationModify-RL-ReconfPrepTDD',
        'id-TDD-TPC-DownlinkStepSize-InformationAdd-RL-ReconfPrepTDD',
        'id-CCTrCH-Maximum-DL-Power-RL-SetupRqstTDD',
        'id-CCTrCH-Minimum-DL-Power-RL-SetupRqstTDD',
        'id-CCTrCH-Maximum-DL-Power-RL-AdditionRqstTDD',
        'id-CCTrCH-Minimum-DL-Power-RL-AdditionRqstTDD',
        'id-CCTrCH-Maximum-DL-Power-InformationAdd-RL-ReconfPrepTDD',
        'id-CCTrCH-Minimum-DL-Power-InformationAdd-RL-ReconfPrepTDD',
        'id-CCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfPrepTDD',
        'id-CCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfPrepTDD',
        'id-Maximum-DL-Power-Modify-LCR-InformationModify-RL-ReconfPrepTDD',
        'id-Minimum-DL-Power-Modify-LCR-InformationModify-RL-ReconfPrepTDD',
        'id-DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD',
        'id-CCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfRqstTDD',
        'id-CCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfRqstTDD',
        'id-Initial-DL-Power-TimeslotLCR-InformationItem',
        'id-Maximum-DL-Power-TimeslotLCR-InformationItem',
        'id-Minimum-DL-Power-TimeslotLCR-InformationItem',
        'id-HS-DSCHProvidedBitRateValueInformation',
        'id-HS-DSCHRequiredPowerValueInformation',
        'id-HS-DSCHRequiredPowerValue',
        'id-TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmission',
        'id-HS-SICH-Reception-Quality',
        'id-HS-SICH-Reception-Quality-Measurement-Value',
        'id-HSSICH-Info-DM-Rprt',
        'id-HSSICH-Info-DM-Rqst',
        'id-HSSICH-Info-DM-Rsp',
        'id-Best-Cell-Portions-Value',
        'id-Primary-CPICH-Usage-for-Channel-Estimation',
        'id-Secondary-CPICH-Information-Change',
        'id-NumberOfReportedCellPortions',
        'id-CellPortion-InformationItem-Cell-SetupRqstFDD',
        'id-CellPortion-InformationList-Cell-SetupRqstFDD',
        'id-TimeslotISCP-LCR-InfoList-RL-ReconfPrepTDD',
        'id-Secondary-CPICH-Information',
        'id-Received-total-wide-band-power-For-CellPortion',
        'id-Unidirectional-DCH-Indicator',
        'id-TimingAdjustmentValueLCR',
        'id-multipleRL-dl-DPCH-InformationList',
        'id-multipleRL-dl-DPCH-InformationModifyList',
        'id-multipleRL-ul-DPCH-InformationList',
        'id-multipleRL-ul-DPCH-InformationModifyList',
        'id-RL-ID',
        'id-SAT-Info-Almanac-ExtItem',
        'id-HSDPA-Capability',
        'id-HSDSCH-Resources-Information-AuditRsp',
        'id-HSDSCH-Resources-Information-ResourceStatusInd',
        'id-HSDSCH-MACdFlows-to-Add',
        'id-HSDSCH-MACdFlows-to-Delete',
        'id-HSDSCH-Information-to-Modify-Unsynchronised',
        'id-TnlQos',
        'id-Received-total-wide-band-power-For-CellPortion-Value',
        'id-Transmitted-Carrier-Power-For-CellPortion',
        'id-Transmitted-Carrier-Power-For-CellPortion-Value',
        'id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortion',
        'id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue',
        'id-UpPTSInterferenceValue',
        'id-PrimaryCCPCH-RSCP-Delta',
        'id-MeasurementRecoveryBehavior',
        'id-MeasurementRecoveryReportingIndicator',
        'id-MeasurementRecoverySupportIndicator',
        'id-Tstd-indicator',
        'id-multiple-RL-Information-RL-ReconfPrepTDD',
        'id-multiple-RL-Information-RL-ReconfRqstTDD',
        'id-DL-DPCH-Power-Information-RL-ReconfPrepFDD',
        'id-F-DPCH-Information-RL-ReconfPrepFDD',
        'id-F-DPCH-Information-RL-SetupRqstFDD',
        'id-Additional-S-CCPCH-Parameters-CTCH-ReconfRqstTDD',
        'id-Additional-S-CCPCH-Parameters-CTCH-SetupRqstTDD',
        'id-Additional-S-CCPCH-LCR-Parameters-CTCH-ReconfRqstTDD',
        'id-Additional-S-CCPCH-LCR-Parameters-CTCH-SetupRqstTDD',
        'id-MICH-CFN',
        'id-MICH-Information-AuditRsp',
        'id-MICH-Information-ResourceStatusInd',
        'id-MICH-Parameters-CTCH-ReconfRqstFDD',
        'id-MICH-Parameters-CTCH-ReconfRqstTDD',
        'id-MICH-Parameters-CTCH-SetupRqstFDD',
        'id-MICH-Parameters-CTCH-SetupRqstTDD',
        'id-Modification-Period',
        'id-NI-Information-NotifUpdateCmd',
        'id-S-CCPCH-InformationListExt-AuditRsp',
        'id-S-CCPCH-InformationListExt-ResourceStatusInd',
        'id-S-CCPCH-LCR-InformationListExt-AuditRsp',
        'id-S-CCPCH-LCR-InformationListExt-ResourceStatusInd',
        'id-HARQ-Preamble-Mode',
        'id-Initial-DL-DPCH-TimingAdjustment',
        'id-Initial-DL-DPCH-TimingAdjustment-Allowed',
        'id-DLTransmissionBranchLoadValue',
        'id-Power-Local-Cell-Group-choice-CM-Rqst',
        'id-Power-Local-Cell-Group-choice-CM-Rsp',
        'id-Power-Local-Cell-Group-choice-CM-Rprt',
        'id-SynchronisationIndicator',
        'id-HSDPA-And-EDCH-CellPortion-Information-PSCH-ReconfRqst',
        'id-Unused-ProtocolIE-ID-659',
        'id-HS-DSCHRequiredPowerValue-For-Cell-Portion',
        'id-HS-DSCHRequiredPowerValueInformation-For-CellPortion',
        'id-HS-DSCHProvidedBitRateValueInformation-For-CellPortion',
        'id-E-AGCH-And-E-RGCH-E-HICH-FDD-Scrambling-Code',
        'id-E-AGCH-FDD-Code-Information',
        'id-E-DCH-Capability',
        'id-E-DCH-FDD-DL-Control-Channel-Information',
        'id-E-DCH-FDD-Information',
        'id-E-DCH-FDD-Information-Response',
        'id-E-DCH-FDD-Information-to-Modify',
        'id-E-DCH-MACdFlows-to-Add',
        'id-E-DCH-MACdFlows-to-Delete',
        'id-E-DCH-Resources-Information-AuditRsp',
        'id-E-DCH-Resources-Information-ResourceStatusInd',
        'id-E-DCH-RL-Indication',
        'id-E-DCH-RL-Set-ID',
        'id-E-DPCH-Information-RL-ReconfPrepFDD',
        'id-E-DPCH-Information-RL-SetupRqstFDD',
        'id-E-RGCH-E-HICH-FDD-Code-Information',
        'id-Serving-E-DCH-RL-ID',
        'id-UL-DPDCH-Indicator-For-E-DCH-Operation',
        'id-FDD-S-CCPCH-FrameOffset-CTCH-SetupRqstFDD',
        'id-E-DPCH-Information-RL-ReconfRqstFDD',
        'id-Maximum-Target-ReceivedTotalWideBandPower',
        'id-E-DCHProvidedBitRateValueInformation',
        'id-HARQ-Preamble-Mode-Activation-Indicator',
        'id-RL-Specific-E-DCH-Info',
        'id-E-DCH-CapacityConsumptionLaw',
        'id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp',
        'id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp',
        'id-E-DCH-RearrangeList-Bearer-RearrangeInd',
        'id-Unused-ProtocolIE-ID-691',
        'id-multipleRL-dl-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'id-Target-NonServing-EDCH-To-Total-EDCH-Power-Ratio',
        'id-CellPortion-InformationItem-Cell-ReconfRqstFDD',
        'id-CellPortion-InformationList-Cell-ReconfRqstFDD',
        'id-multiple-PUSCH-InfoList-DM-Rsp',
        'id-multiple-PUSCH-InfoList-DM-Rprt',
        'id-Reference-ReceivedTotalWideBandPower',
        'id-E-DCH-Serving-Cell-Change-Info-Response',
        'id-HS-DSCH-Serving-Cell-Change-Info',
        'id-HS-DSCH-Serving-Cell-Change-Info-Response',
        'id-Serving-Cell-Change-CFN',
        'id-E-DCH-HARQ-Combining-Capability',
        'id-E-DCH-TTI2ms-Capability',
        'id-E-DCH-SF-Capability',
        'id-E-DCH-FDD-Update-Information',
        'id-F-DPCH-Capability',
        'id-E-DCH-Non-serving-Relative-Grant-Down-CommandsValue',
        'id-HSSICH-SIRTarget',
        'id-multiple-HSSICHMeasurementValueList-TDD-DM-Rsp',
        'id-PLCCH-Information-AuditRsp',
        'id-PLCCH-Information-ResourceStatusInd',
        'id-PLCCH-Information-RL-ReconfPrepTDDLCR',
        'id-PLCCH-Information-UL-TimeslotLCR-Info',
        'id-PLCCH-InformationList-AuditRsp',
        'id-PLCCH-InformationList-ResourceStatusInd',
        'id-PLCCH-Parameters-CTCH-ReconfRqstTDD',
        'id-S-CCPCH-768-Parameters-CTCH-SetupRqstTDD',
        'id-PICH-768-Parameters-CTCH-SetupRqstTDD',
        'id-PRACH-768-Parameters-CTCH-SetupRqstTDD',
        'id-S-CCPCH-768-Parameters-CTCH-ReconfRqstTDD',
        'id-PICH-768-Parameters-CTCH-ReconfRqstTDD',
        'id-MICH-768-Parameters-CTCH-ReconfRqstTDD',
        'id-CommonPhysicalChannelID768-CommonTrChDeletionReq',
        'id-S-CCPCH-768-InformationList-AuditRsp',
        'id-S-CCPCH-768-Information-AuditRsp',
        'id-neighbouringTDDCellMeasurementInformation768',
        'id-PCCPCH-768-Information-Cell-SetupRqstTDD',
        'id-SCH-768-Information-Cell-SetupRqstTDD',
        'id-SCH-768-Information-Cell-ReconfRqstTDD',
        'id-PCCPCH-768-Information-Cell-ReconfRqstTDD',
        'id-P-CCPCH-768-Information-AuditRsp',
        'id-PICH-768-Information-AuditRsp',
        'id-PRACH-768-InformationList-AuditRsp',
        'id-SCH-768-Information-AuditRsp',
        'id-MICH-768-Information-AuditRsp',
        'id-PRACH-768-Information',
        'id-S-CCPCH-768-Information-ResourceStatusInd',
        'id-P-CCPCH-768-Information-ResourceStatusInd',
        'id-PICH-768-Information-ResourceStatusInd',
        'id-PRACH-768-InformationList-ResourceStatusInd',
        'id-SCH-768-Information-ResourceStatusInd',
        'id-MICH-768-Information-ResourceStatusInd',
        'id-S-CCPCH-768-InformationList-ResourceStatusInd',
        'id-UL-DPCH-768-Information-RL-SetupRqstTDD',
        'id-DL-DPCH-768-Information-RL-SetupRqstTDD',
        'id-DL-DPCH-InformationItem-768-RL-AdditionRqstTDD',
        'id-UL-DPCH-InformationItem-768-RL-AdditionRqstTDD',
        'id-UL-DPCH-768-InformationAddItemIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-768-InformationAddListIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-768-InformationModify-AddItem',
        'id-UL-DPCH-768-InformationModify-AddList',
        'id-UL-Timeslot768-Information-RL-ReconfPrepTDD',
        'id-DL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD',
        'id-DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD',
        'id-DL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD',
        'id-DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD',
        'id-DL-Timeslot-768-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'id-DPCH-ID768-DM-Rqst',
        'id-multiple-DedicatedMeasurementValueList-768-TDD-DM-Rsp',
        'id-DPCH-ID768-DM-Rsp',
        'id-Rx-Timing-Deviation-Value-768',
        'id-DPCH-ID768-DM-Rprt',
        'id-PDSCH-AddInformation-768-PSCH-ReconfRqst',
        'id-PDSCH-ModifyInformation-768-PSCH-ReconfRqst',
        'id-PUSCH-AddInformation-768-PSCH-ReconfRqst',
        'id-PUSCH-ModifyInformation-768-PSCH-ReconfRqst',
        'id-dL-HS-PDSCH-Timeslot-Information-768-PSCH-ReconfRqst',
        'id-hS-SCCH-Information-768-PSCH-ReconfRqst',
        'id-hS-SCCH-InformationModify-768-PSCH-ReconfRqst',
        'id-hsSCCH-Specific-Information-ResponseTDD768',
        'id-E-DPCH-Information-RL-AdditionReqFDD',
        'id-PDSCH-Timeslot-Format-PSCH-ReconfRqst-LCR',
        'id-PUSCH-Timeslot-Format-PSCH-ReconfRqst-LCR',
        'id-E-DCH-PowerOffset-for-SchedulingInfo',
        'id-HSDSCH-Configured-Indicator',
        'id-Rx-Timing-Deviation-Value-384-ext',
        'id-RTWP-ReportingIndicator',
        'id-RTWP-CellPortion-ReportingIndicator',
        'id-Received-Scheduled-EDCH-Power-Share-Value',
        'id-Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value',
        'id-Received-Scheduled-EDCH-Power-Share',
        'id-Received-Scheduled-EDCH-Power-Share-For-CellPortion',
        'id-tFCI-Presence',
        'id-HSSICH-TPC-StepSize',
        'id-E-RUCCH-InformationList-AuditRsp',
        'id-E-RUCCH-InformationList-ResourceStatusInd',
        'id-E-DCH-TDD-CapacityConsumptionLaw',
        'id-E-RUCCH-Information',
        'id-E-DCH-Information',
        'id-E-DCH-Information-Response',
        'id-E-DCH-Information-Reconfig',
        'id-E-PUCH-Information-PSCH-ReconfRqst',
        'id-Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'id-Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'id-Delete-From-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'id-E-HICH-Information-PSCH-ReconfRqst',
        'id-E-HICH-TimeOffset',
        'id-Maximum-Generated-ReceivedTotalWideBandPowerInOtherCells',
        'id-E-DCH-Serving-RL-ID',
        'id-E-RUCCH-768-InformationList-AuditRsp',
        'id-E-RUCCH-768-InformationList-ResourceStatusInd',
        'id-E-RUCCH-768-Information',
        'id-E-DCH-768-Information',
        'id-E-DCH-768-Information-Reconfig',
        'id-E-PUCH-Information-768-PSCH-ReconfRqst',
        'id-Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst',
        'id-Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst',
        'id-E-HICH-Information-768-PSCH-ReconfRqst',
        'id-ExtendedPropagationDelay',
        'id-Extended-Round-Trip-Time-Value',
        'id-AlternativeFormatReportingIndicator',
        'id-DCH-Indicator-For-E-DCH-HSDPA-Operation',
        'id-Reference-ReceivedTotalWideBandPowerReporting',
        'id-Reference-ReceivedTotalWideBandPowerSupportIndicator',
        'id-ueCapability-Info',
        'id-MAChs-ResetIndicator',
        'id-Fast-Reconfiguration-Mode',
        'id-Fast-Reconfiguration-Permission',
        'id-BroadcastReference',
        'id-BroadcastCommonTransportBearerIndication',
        'id-ContinuousPacketConnectivityDTX-DRX-Capability',
        'id-ContinuousPacketConnectivityDTX-DRX-Information',
        'id-ContinuousPacketConnectivityHS-SCCH-less-Capability',
        'id-ContinuousPacketConnectivityHS-SCCH-less-Information',
        'id-ContinuousPacketConnectivityHS-SCCH-less-Information-Response',
        'id-CPC-Information',
        'id-MIMO-Capability',
        'id-MIMO-PilotConfiguration',
        'id-MBSFN-Cell-ParameterID-Cell-SetupRqstTDD',
        'id-MBSFN-Cell-ParameterID-Cell-ReconfRqstTDD',
        'id-S-CCPCH-Modulation',
        'id-HS-PDSCH-Code-Change-Grant',
        'id-HS-PDSCH-Code-Change-Indicator',
        'id-SYNC-UL-Partition-LCR',
        'id-E-DCH-LCR-Information',
        'id-E-DCH-LCR-Information-Reconfig',
        'id-E-PUCH-Information-LCR-PSCH-ReconfRqst',
        'id-Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Delete-From-E-HICH-Resource-Pool-PSCH-ReconfRqst',
        'id-E-HICH-TimeOffsetLCR',
        'id-SixtyfourQAM-DL-Capability',
        'id-SixteenQAM-UL-Capability',
        'id-HSDSCH-MACdPDU-SizeCapability',
        'id-HSDSCH-MACdPDUSizeFormat',
        'id-MaximumMACdPDU-SizeExtended',
        'id-F-DPCH-SlotFormat',
        'id-F-DPCH-SlotFormatCapability',
        'id-LCRTDD-uplink-Physical-Channel-Capability',
        'id-Extended-RNC-ID',
        'id-Max-UE-DTX-Cycle',
        'id-Secondary-CCPCH-SlotFormat-Extended',
        'id-MBSFN-Only-Mode-Indicator-Cell-SetupRqstTDD-LCR',
        'id-MBSFN-Only-Mode-Capability',
        'id-Time-Slot-Parameter-ID',
        'id-Additional-failed-HS-SICH',
        'id-Additional-missed-HS-SICH',
        'id-Additional-total-HS-SICH',
        'id-Additional-HS-SICH-Reception-Quality-Measurement-Value',
        'id-GANSS-Common-Data',
        'id-GANSS-Information',
        'id-GANSS-Generic-Data',
        'id-TUTRANGANSSMeasurementThresholdInformation',
        'id-TUTRANGANSSMeasurementValueInformation',
        'id-ModulationPO-MBSFN',
        'id-Enhanced-FACH-Capability',
        'id-Enhanced-PCH-Capability',
        'id-HSDSCH-Common-System-InformationFDD',
        'id-HSDSCH-Common-System-Information-ResponseFDD',
        'id-HSDSCH-Paging-System-InformationFDD',
        'id-HSDSCH-Paging-System-Information-ResponseFDD',
        'id-MBMS-Capability',
        'id-Ext-Reference-E-TFCI-PO',
        'id-Ext-Max-Bits-MACe-PDU-non-scheduled',
        'id-HARQ-MemoryPartitioningInfoExtForMIMO',
        'id-MIMO-ActivationIndicator',
        'id-MIMO-Mode-Indicator',
        'id-MIMO-N-M-Ratio',
        'id-IPMulticastIndication',
        'id-IPMulticastDataBearerIndication',
        'id-TransportBearerNotSetupIndicator',
        'id-TransportBearerNotRequestedIndicator',
        'id-TimeSlotConfigurationList-LCR-CTCH-SetupRqstTDD',
        'id-Cell-Frequency-List-Information-LCR-MulFreq-AuditRsp',
        'id-Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp',
        'id-Cell-Frequency-List-LCR-MulFreq-Cell-SetupRqstTDD',
        'id-UARFCN-Adjustment',
        'id-Cell-Frequency-List-Information-LCR-MulFreq-ResourceStatusInd',
        'id-Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd',
        'id-UPPCHPositionLCR',
        'id-UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD',
        'id-UPPCH-LCR-InformationList-AuditRsp',
        'id-UPPCH-LCR-InformationItem-AuditRsp',
        'id-UPPCH-LCR-InformationList-ResourceStatusInd',
        'id-UPPCH-LCR-InformationItem-ResourceStatusInd',
        'id-multipleFreq-dL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst',
        'id-number-Of-Supported-Carriers',
        'id-multipleFreq-HSPDSCH-InformationList-ResponseTDDLCR',
        'id-Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD',
        'id-multipleFreq-HS-DSCH-Resources-InformationList-AuditRsp',
        'id-multipleFreq-HS-DSCH-Resources-InformationList-ResourceStatusInd',
        'id-UARFCNSpecificCauseList',
        'id-tSN-Length',
        'id-MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst',
        'id-multicarrier-number',
        'id-Extended-HS-SCCH-ID',
        'id-Extended-HS-SICH-ID',
        'id-HSSICH-InfoExt-DM-Rqst',
        'id-Delete-From-HS-SCCH-Resource-PoolExt-PSCH-ReconfRqst',
        'id-HS-SCCH-InformationExt-LCR-PSCH-ReconfRqst',
        'id-HS-SCCH-InformationModifyExt-LCR-PSCH-ReconfRqst',
        'id-PowerControlGAP',
        'id-MBSFN-SpecialTimeSlot-LCR',
        'id-Common-MACFlows-to-DeleteFDD',
        'id-Paging-MACFlows-to-DeleteFDD',
        'id-E-TFCI-Boost-Information',
        'id-SixteenQAM-UL-Operation-Indicator',
        'id-SixtyfourQAM-UsageAllowedIndicator',
        'id-SixtyfourQAM-DL-UsageIndicator',
        'id-Default-Serving-Grant-in-DTX-Cycle2',
        'id-Maximum-Target-ReceivedTotalWideBandPower-LCR',
        'id-E-DPDCH-PowerInterpolation',
        'id-Extended-E-DCH-LCRTDD-PhysicalLayerCategory',
        'id-MultipleFreq-E-DCH-Resources-InformationList-AuditRsp',
        'id-MultipleFreq-E-DCH-Resources-InformationList-ResourceStatusInd',
        'id-MultipleFreq-E-PUCH-Timeslot-InformationList-LCR-PSCH-ReconfRqst',
        'id-MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst',
        'id-Extended-E-HICH-ID-TDD',
        'id-ContinuousPacketConnectivityHS-SCCH-less-Deactivate-Indicator',
        'id-E-DCH-MACdPDU-SizeCapability',
        'id-E-DCH-MACdPDUSizeFormat',
        'id-MaximumNumber-Of-Retransmission-for-Scheduling-Info-LCRTDD',
        'id-E-DCH-RetransmissionTimer-for-SchedulingInfo-LCRTDD',
        'id-E-HICH-TimeOffset-Extension',
        'id-MultipleFreq-E-HICH-TimeOffsetLCR',
        'id-E-PUCH-PowerControlGAP',
        'id-HSDSCH-TBSizeTableIndicator',
        'id-E-DCH-DL-Control-Channel-Change-Information',
        'id-E-DCH-DL-Control-Channel-Grant-Information',
        'id-DGANSS-Corrections-Req',
        'id-UE-with-enhanced-HS-SCCH-support-indicator',
        'id-AdditionalTimeSlotListLCR',
        'id-AdditionalMeasurementValueList',
        'id-E-AGCH-Table-Choice',
        'id-PLCCH-parameters',
        'id-E-RUCCH-parameters',
        'id-E-RUCCH-768-parameters',
        'id-HS-Cause',
        'id-E-Cause',
        'id-Common-EDCH-Capability',
        'id-E-AI-Capability',
        'id-Common-EDCH-System-InformationFDD',
        'id-Common-UL-MACFlows-to-DeleteFDD',
        'id-Common-EDCH-MACdFlows-to-DeleteFDD',
        'id-Common-EDCH-System-Information-ResponseFDD',
        'id-Cell-ERNTI-Status-Information',
        'id-Enhanced-UE-DRX-Capability',
        'id-Enhanced-UE-DRX-InformationFDD',
        'id-TransportBearerRequestIndicator',
        'id-SixtyfourQAM-DL-MIMO-Combined-Capability',
        'id-E-RNTI',
        'id-MinimumReducedE-DPDCH-GainFactor',
        'id-GANSS-Time-ID',
        'id-GANSS-AddIonoModelReq',
        'id-GANSS-EarthOrientParaReq',
        'id-GANSS-AddNavigationModelsReq',
        'id-GANSS-AddUTCModelsReq',
        'id-GANSS-AuxInfoReq',
        'id-GANSS-SBAS-ID',
        'id-GANSS-ID',
        'id-GANSS-Additional-Ionospheric-Model',
        'id-GANSS-Earth-Orientation-Parameters',
        'id-GANSS-Additional-Time-Models',
        'id-GANSS-Additional-Navigation-Models',
        'id-GANSS-Additional-UTC-Models',
        'id-GANSS-Auxiliary-Information',
        'id-ERACH-CM-Rqst',
        'id-ERACH-CM-Rsp',
        'id-ERACH-CM-Rprt',
        'id-EDCH-RACH-Report-Value',
        'id-EDCH-RACH-Report-IncrDecrThres',
        'id-EDCH-RACH-Report-ThresholdInformation',
        'id-E-DPCCH-Power-Boosting-Capability',
        'id-HSDSCH-Common-System-InformationLCR',
        'id-HSDSCH-Common-System-Information-ResponseLCR',
        'id-HSDSCH-Paging-System-InformationLCR',
        'id-HSDSCH-Paging-System-Information-ResponseLCR',
        'id-Common-MACFlows-to-DeleteLCR',
        'id-Paging-MACFlows-to-DeleteLCR',
        'id-Common-EDCH-System-InformationLCR',
        'id-Common-UL-MACFlows-to-DeleteLCR',
        'id-Common-EDCH-MACdFlows-to-DeleteLCR',
        'id-Common-EDCH-System-Information-ResponseLCR',
        'id-Enhanced-UE-DRX-CapabilityLCR',
        'id-Enhanced-UE-DRX-InformationLCR',
        'id-HSDSCH-PreconfigurationSetup',
        'id-HSDSCH-PreconfigurationInfo',
        'id-NoOfTargetCellHS-SCCH-Order',
        'id-EnhancedHSServingCC-Abort',
        'id-Additional-HS-Cell-Information-RL-Setup',
        'id-Additional-HS-Cell-Information-Response',
        'id-Additional-HS-Cell-Information-RL-Addition',
        'id-Additional-HS-Cell-Change-Information-Response',
        'id-Additional-HS-Cell-Information-RL-Reconf-Prep',
        'id-Additional-HS-Cell-Information-RL-Reconf-Req',
        'id-Additional-HS-Cell-Information-RL-Param-Upd',
        'id-Multi-Cell-Capability-Info',
        'id-IMB-Parameters',
        'id-MACes-Maximum-Bitrate-LCR',
        'id-Semi-PersistentScheduling-CapabilityLCR',
        'id-E-DCH-Semi-PersistentScheduling-Information-LCR',
        'id-HS-DSCH-Semi-PersistentScheduling-Information-LCR',
        'id-Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-ContinuousPacketConnectivity-DRX-CapabilityLCR',
        'id-ContinuousPacketConnectivity-DRX-InformationLCR',
        'id-ContinuousPacketConnectivity-DRX-Information-ResponseLCR',
        'id-CPC-InformationLCR',
        'id-HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR',
        'id-E-DCH-Semi-PersistentScheduling-Information-ResponseLCR',
        'id-E-AGCH-UE-Inactivity-Monitor-Threshold',
        'id-IdleIntervalInformation',
        'id-GANSS-alm-keplerianNAVAlmanac',
        'id-GANSS-alm-keplerianReducedAlmanac',
        'id-GANSS-alm-keplerianMidiAlmanac',
        'id-GANSS-alm-keplerianGLONASS',
        'id-GANSS-alm-ecefSBASAlmanac',
        'id-HSSICH-ReferenceSignal-InformationLCR',
        'id-MIMO-ReferenceSignal-InformationListLCR',
        'id-MIMO-SFMode-For-HSPDSCHDualStream',
        'id-MIMO-SFMode-Supported-For-HSPDSCHDualStream',
        'id-UE-Selected-MBMS-Service-Information',
        'id-MultiCarrier-HSDSCH-Physical-Layer-Category',
        'id-Common-E-DCH-HSDPCCH-Capability',
        'id-DL-RLC-PDU-Size-Format',
        'id-HSSICH-ReferenceSignal-InformationModifyLCR',
        'id-schedulingPriorityIndicator',
        'id-TimeSlotMeasurementValueListLCR',
        'id-UE-SupportIndicatorExtension',
        'id-Single-Stream-MIMO-ActivationIndicator',
        'id-Single-Stream-MIMO-Capability',
        'id-Single-Stream-MIMO-Mode-Indicator',
        'id-Dual-Band-Capability-Info',
        'id-UE-AggregateMaximumBitRate',
        'id-UE-AggregateMaximumBitRate-Enforcement-Indicator',
        'id-MIMO-Power-Offset-For-S-CPICH-Capability',
        'id-MIMO-PilotConfigurationExtension',
        'id-TxDiversityOnDLControlChannelsByMIMOUECapability',
        'id-ULTimeslotISCPValue-For-CellPortion',
        'id-UpPTSInterferenceValue-For-CellPortion',
        'id-Best-Cell-Portions-ValueLCR',
        'id-Transmitted-Carrier-Power-For-CellPortion-ValueLCR',
        'id-Received-total-wide-band-power-For-CellPortion-ValueLCR',
        'id-UL-TimeslotISCP-For-CellPortion-Value',
        'id-HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR',
        'id-HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR',
        'id-E-DCHProvidedBitRateValueInformation-For-CellPortion',
        'id-UpPTSInterference-For-CellPortion-Value',
        'id-NumberOfReportedCellPortionsLCR',
        'id-CellPortion-CapabilityLCR',
        'id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue',
        'id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortion',
        'id-ActivationInformation',
        'id-Additional-EDCH-Cell-Information-RL-Setup-Req',
        'id-Additional-EDCH-Cell-Information-Response',
        'id-Additional-EDCH-Cell-Information-RL-Add-Req',
        'id-Additional-EDCH-Cell-Information-Response-RL-Add',
        'id-Additional-EDCH-Cell-Information-RL-Reconf-Prep',
        'id-Additional-EDCH-Cell-Information-RL-Reconf-Req',
        'id-Additional-EDCH-Cell-Information-Bearer-Rearrangement',
        'id-Additional-EDCH-Cell-Information-RL-Param-Upd',
        'id-Additional-EDCH-Preconfiguration-Information',
        'id-EDCH-Indicator',
        'id-HS-DSCH-SPS-Reservation-Indicator',
        'id-E-DCH-SPS-Reservation-Indicator',
        'id-MultipleFreq-HARQ-MemoryPartitioning-InformationList',
        'id-Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR-Ext',
        'id-RepetitionPeriodIndex',
        'id-MidambleShiftLCR',
        'id-MaxHSDSCH-HSSCCH-Power-per-CELLPORTION',
        'id-DormantModeIndicator',
        'id-DiversityMode',
        'id-TransmitDiversityIndicator',
        'id-NonCellSpecificTxDiversity',
        'id-Cell-Capability-Container',
        'id-E-RNTI-List-Request',
        'id-E-RNTI-List',
        'id-PowerControlGAP-For-CellFACHLCR',
        'id-UL-Synchronisation-Parameters-For-FACHLCR',
        'id-HS-DSCH-SPS-Operation-Indicator',
        'id-HSDSCH-RNTI-For-FACH',
        'id-E-RNTI-For-FACH',
        'id-Out-of-Sychronization-Window',
        'id-Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst',
        'id-E-HICH-TimeOffset-ReconfFailureTDD',
        'id-HSSCCH-TPC-StepSize',
        'id-TS0-CapabilityLCR',
        'id-UE-TS0-CapabilityLCR',
        'id-Common-System-Information-ResponseLCR',
        'id-Additional-EDCH-Cell-Information-ResponseRLReconf',
        'id-Multicell-EDCH-InformationItemIEs',
        'id-Multicell-EDCH-RL-Specific-InformationItemIEs',
        'id-Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext',
        'id-Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext',
        'id-Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext',
        'id-Initial-DL-Transmission-Power',
        'id-Maximum-DL-Power',
        'id-Minimum-DL-Power',
        'id-DCH-MeasurementOccasion-Information',
        'id-AssociatedPhsicalChannelID',
        'id-DGNSS-ValidityPeriod',
        'id-PhysicalChannelID-for-CommonERNTI-RequestedIndicator',
        'id-PrecodingWeightSetRestriction',
        'id-Treset-Usage-Indicator',
        'id-Non-Serving-RL-Preconfig-Info',
        'id-Non-Serving-RL-Preconfig-Setup',
        'id-Non-Serving-RL-Preconfig-Removal',
        'id-Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup',
        'id-Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList',
        'id-Ul-common-E-DCH-MACflow-Specific-InfoListLCR-Ext',
        'id-CommonMACFlow-Specific-InfoList-ResponseLCR-Ext',
        'id-Enabling-Delay-Ext-LCR',
        'id-OrdinalNumberOfFrequency',
        'id-Multicell-EDCH-Restriction',
        'id-completeAlmanacProvided',
        'id-ganss-Delta-T',
        'id-Cell-Capability-Container-TDD-LCR',
        'id-Multi-Carrier-EDCH-Setup',
        'id-Multi-Carrier-EDCH-Reconfigure',
        'id-Multi-Carrier-EDCH-Response',
        'id-SNPL-Carrier-Group-Indicator',
        'id-MU-MIMO-Capability-ContainerLCR',
        'id-MU-MIMO-InformationLCR',
        'id-MU-MIMO-Information-Response',
        'id-MU-MIMO-Information-To-ReconfigureLCR',
        'id-HS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext',
        'id-Adaptive-Special-Burst-Power-CapabilityLCR',
        'id-Usefulness-Of-Battery-Optimization',
        'id-Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory',
        'id-Common-HSDSCH-RNTI-List',
        'id-CommonEDCH-AdditionalTransmissionBackOff',
        'id-In-Sync-Information-LCR',
        'id-Puncturing-Handling-in-First-Rate-Matching-Stage',
        'id-ERNTI-Release-Status',
        'id-UE-Status-Update-Confirm-Indicator',
        'id-Max-RTWP-perCellPortion-InformationList-LCR-PSCH-ReconfRqst',
        'id-AOA-per-CELL-Portion-LCR',
        'id-UL-CLTD-Information',
        'id-UL-CLTD-Information-Reconf',
        'id-UL-CLTD-State-Update-Information',
        'id-Affected-HSDSCH-Serving-Cell-List',
        'id-Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order',
        'id-CPC-RecoveryReport',
        'id-FTPICH-Information',
        'id-FTPICH-Information-Reconf',
        'id-UE-RF-Band-CapabilityLCR',
        'id-E-AGCH-PowerOffset',
        'id-E-RGCH-PowerOffset',
        'id-E-HICH-PowerOffset',
        'id-UE-transmission-power-headroom',
        'id-MIMO-withfourtransmitantennas-ActivationIndicator',
        'id-MIMO-withfourtransmitantennas-Mode-Indicator',
        'id-MIMO-withfourtransmitantennas-PilotConfiguration',
        'id-DualStream-MIMO-withfourtransmitantennas-ActivationIndicator',
        'id-DualStream-MIMO-withfourtransmitantennas-Mode-Indicator',
        'id-UL-MIMO-Information',
        'id-UL-MIMO-Reconfiguration',
        'id-UL-MIMO-DL-Control-Channel-Information',
        'id-SixtyfourQAM-UL-Operation-Indicator',
        'id-Common-E-DCH-Implicit-Release-Timer',
        'id-Multiflow-Information',
        'id-Multiflow-Reconfiguration',
        'id-Multiflow-OrdinalNumberOfFrequency',
        'id-Concurrent-Deployment-of-2msand10ms-TTI',
        'id-Common-EDH-Preamble-Control-Information-extension-Type1',
        'id-Common-EDH-Preamble-Control-Information-extension-Type2',
        'id-Common-EDH-Preamble-Control-Information-extension-Type3',
        'id-NodeB-Triggered-HSDPCCH-Transmission-Information',
        'id-Per-HARQ-Activiation-and-Deactiviation',
        'id-Coffset',
        'id-Common-E-DCH-MAC-d-flow-info-Concurrent-TTI',
        'id-Serving-Grant-Value-for-Concurrent-Deployment-of-2msand10ms-TTI',
        'id-Two-ms-Grant-E-DCH-RACH-Resources',
        'id-Two-ms-Overridden-E-DCH-RACH-Resources',
        'id-Two-ms-Denied-E-DCH-RACH-Resources',
        'id-Further-Enhanced-UE-DRX-InformationFDD',
        'id-Common-E-RGCH-Operation-Indicator',
        'id-Common-E-RGCH-InfoFDD',
        'id-PrecoderWeightSetRestriction',
        'id-Non-rectangular-resource-allocation-indicator',
        'id-Non-rectangular-resource-timeslot-set',
        'id-UE-Support-of-non-rectangular-resource-allocation',
        'id-DBDS-CorrectionsReq',
        'id-DBDS-Corrections',
        'id-BDS-IonosphericGridModelReq',
        'id-BDS-Ionospheric-Grid-Model',
        'id-GANSS-alm-keplerianBDSAlmanac',
        'id-Assisting-RepetitionFactors',
        'id-UE-Measurement-Forwarding',
        'id-UPH-Filtering-Measurement-Forwarding-Request',
        'id-TTI-Update-Indicator',
        'id-CQI-Feedback-Cycle2',
        'id-CQI-Cycle-Switch-Timer',
        'id-UE-DRX-Cycle2',
        'id-Inactivity-Threshold-for-UE-DRX-Cycle2',
        'id-DTX-Information2',
        'id-BCH-Parameters',
        'id-BCH-Parameters-CTCH-SetupRsp',
        'id-BCH-Parameters-CTCH-ReconfRqstFDD',
        'id-BCH-mappedOnSCCPCH-Indication',
        'id-DCH-ENH-Information',
        'id-DCH-ENH-Information-Reconf',
        'id-Gainfactors-10ms-mode',
        'id-E-DCH-Decoupling-Indication',
        'id-Radio-Links-without-DPCH-FDPCH-Indication',
        'id-UL-DPCCH2-Information',
        'id-UL-DPCCH2-Information-Reconf',
        'id-ImplicitGrantHandling',
        'id-MinimumTEBSthreshold',
        'id-ActivationDelay',
        'id-Fast-TTI-switching-Mode-synchronized',
        'id-Fast-TTI-switching-Mode-unsynchronized',
        'id-Fast-TTI-switching-Mode-Supported',
        'id-Dual-Band-EDCH-Capability',
        'id-Improved-Synchronized-Indicator',
        'id-Downlink-TPC-enhancements-Information',
        'id-Downlink-TPC-enhancements-Reconf',
        'id-TPC-slot-position',
        'id-E-RNTI-Set',
        'id-DL-TBS',
        'id-Dual-Cell-EDCH-Enhancements-Information',
        'id-HS-SCCH-DRX-InformationFDD',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-audit',
        'id-auditRequired',
        'id-blockResource',
        'id-cellDeletion',
        'id-cellReconfiguration',
        'id-cellSetup',
        'id-cellSynchronisationInitiation',
        'id-cellSynchronisationReconfiguration',
        'id-cellSynchronisationReporting',
        'id-cellSynchronisationTermination',
        'id-cellSynchronisationFailure',
        'id-commonMeasurementFailure',
        'id-commonMeasurementInitiation',
        'id-commonMeasurementReport',
        'id-commonMeasurementTermination',
        'id-commonTransportChannelDelete',
        'id-commonTransportChannelReconfigure',
        'id-commonTransportChannelSetup',
        'id-compressedModeCommand',
        'id-dedicatedMeasurementFailure',
        'id-dedicatedMeasurementInitiation',
        'id-dedicatedMeasurementReport',
        'id-dedicatedMeasurementTermination',
        'id-downlinkPowerControl',
        'id-downlinkPowerTimeslotControl',
        'id-errorIndicationForCommon',
        'id-errorIndicationForDedicated',
        'id-informationExchangeFailure',
        'id-informationExchangeInitiation',
        'id-informationExchangeTermination',
        'id-informationReporting',
        'id-BearerRearrangement',
        'id-mBMSNotificationUpdate',
        'id-physicalSharedChannelReconfiguration',
        'id-privateMessageForCommon',
        'id-privateMessageForDedicated',
        'id-radioLinkAddition',
        'id-radioLinkDeletion',
        'id-radioLinkFailure',
        'id-radioLinkPreemption',
        'id-radioLinkRestoration',
        'id-radioLinkSetup',
        'id-reset',
        'id-resourceStatusIndication',
        'id-cellSynchronisationAdjustment',
        'id-synchronisedRadioLinkReconfigurationCancellation',
        'id-synchronisedRadioLinkReconfigurationCommit',
        'id-synchronisedRadioLinkReconfigurationPreparation',
        'id-systemInformationUpdate',
        'id-unblockResource',
        'id-unSynchronisedRadioLinkReconfiguration',
        'id-radioLinkActivation',
        'id-radioLinkParameterUpdate',
        'id-uEStatusUpdate',
        'id-secondaryULFrequencyReporting',
        'id-secondaryULFrequencyUpdate',
        'id-uEStatusUpdateConfirmation',
        'maxNrOfCodes',
        'maxNrOfDLTSs',
        'maxNrOfDLTSLCRs',
        'maxNrOfErrors',
        'maxNrOfTFs',
        'maxNrOfTFCs',
        'maxNrOfRLs',
        'maxNrOfRLs-1',
        'maxNrOfRLs-2',
        'maxNrOfRLSets',
        'maxNrOfDPCHs',
        'maxNrOfDPCHsPerRL-1',
        'maxNrOfDPCHLCRs',
        'maxNrOfDPCHsLCRPerRL-1',
        'maxNrOfDPCHs768',
        'maxNrOfDPCHs768PerRL-1',
        'maxNrOfSCCPCHs',
        'maxNrOfSCCPCHsinExt',
        'maxNrOfSCCPCHs768',
        'maxNrOfDCHs',
        'maxNrOfDSCHs',
        'maxNrOfFACHs',
        'maxNrOfCCTrCHs',
        'maxNrOfPDSCHs',
        'maxNrOfHSPDSCHs',
        'maxNrOfHSPDSCHs768',
        'maxNrOfPUSCHs',
        'maxNrOfPUSCHs-1',
        'maxNrOfPDSCHSets',
        'maxNrOfPRACHLCRs',
        'maxNrOfPUSCHSets',
        'maxNrOfSCCPCHLCRs',
        'maxNrOfSCCPCHsLCRinExt',
        'maxNrOfULTSs',
        'maxNrOfULTSLCRs',
        'maxNrOfUSCHs',
        'maxNrOfSlotFormatsPRACH',
        'maxCellinNodeB',
        'maxCCPinNodeB',
        'maxCTFC',
        'maxLocalCellinNodeB',
        'maxFPACHCell',
        'maxRACHCell',
        'maxPLCCHCell',
        'maxPRACHCell',
        'maxSCCPCHCell',
        'maxSCCPCHCellinExt',
        'maxSCCPCHCellinExtLCR',
        'maxSCCPCHCell768',
        'maxSCPICHCell',
        'maxTTI-count',
        'maxIBSEG',
        'maxIB',
        'maxFACHCell',
        'maxRateMatching',
        'maxHS-PDSCHCodeNrComp-1',
        'maxHS-SCCHCodeNrComp-1',
        'maxNrOfCellSyncBursts',
        'maxNrOfReceptsPerSyncFrame',
        'maxNrOfMeasNCell',
        'maxNrOfMeasNCell-1',
        'maxNrOfSF',
        'maxTGPS',
        'maxCommunicationContext',
        'maxNrOfLevels',
        'maxNoSat',
        'maxNoGPSItems',
        'maxNrOfHSSCCHs',
        'maxNrOfHSSICHs',
        'maxNrOfHSSICHs-1',
        'maxNrOfSyncFramesLCR',
        'maxNrOfReceptionsperSyncFrameLCR',
        'maxNrOfSyncDLCodesLCR',
        'maxNrOfHSSCCHCodes',
        'maxNrOfMACdFlows',
        'maxNrOfMACdFlows-1',
        'maxNrOfMACdPDUIndexes',
        'maxNrOfMACdPDUIndexes-1',
        'maxNrOfMACdPDUSize',
        'maxNrOfNIs',
        'maxNrOfPriorityQueues',
        'maxNrOfPriorityQueues-1',
        'maxNrOfHARQProcesses',
        'maxNrOfContextsOnUeList',
        'maxNrOfCellPortionsPerCell',
        'maxNrOfCellPortionsPerCell-1',
        'maxNrOfPriorityClasses',
        'maxNrOfSatAlmanac-maxNoSat',
        'maxNrOfE-AGCHs',
        'maxNrOfEDCHMACdFlows',
        'maxNrOfEDCHMACdFlows-1',
        'maxNrOfE-RGCHs-E-HICHs',
        'maxNrOfEDCH-HARQ-PO-QUANTSTEPs',
        'maxNrOfEDCHHARQProcesses2msEDCH',
        'maxNrOfEDPCCH-PO-QUANTSTEPs',
        'maxNrOfBits-MACe-PDU-non-scheduled',
        'maxNrOfRefETFCIs',
        'maxNrOfRefETFCI-PO-QUANTSTEPs',
        'maxNrofSigSeqRGHI-1',
        'maxNoOfLogicalChannels',
        'maxNrOfCombEDPDCH',
        'maxE-RUCCHCell',
        'maxNrOfEAGCHCodes',
        'maxNrOfRefBetas',
        'maxNrOfE-PUCHSlots',
        'maxNrOfEAGCHs',
        'maxNrOfHS-DSCH-TBSs-HS-SCCHless',
        'maxNrOfHS-DSCH-TBSs',
        'maxNrOfEHICHCodes',
        'maxNrOfE-PUCHSlotsLCR',
        'maxNrOfEPUCHcodes',
        'maxNrOfEHICHs',
        'maxNrOfCommonMACFlows',
        'maxNrOfCommonMACFlows-1',
        'maxNrOfPagingMACFlow',
        'maxNrOfPagingMACFlow-1',
        'maxNrOfcommonMACQueues',
        'maxNrOfpagingMACQueues',
        'maxNrOfHS-DSCHTBSsE-PCH',
        'maxGANSSSat',
        'maxNoGANSS',
        'maxSgnType',
        'maxFrequencyinCell',
        'maxFrequencyinCell-1',
        'maxHSDPAFrequency',
        'maxHSDPAFrequency-1',
        'maxNrOfHSSCCHsinExt',
        'maxGANSSSatAlmanac',
        'maxGANSSClockMod',
        'maxNrOfEDCHRLs',
        'maxERNTItoRelease',
        'maxNrOfCommonEDCH',
        'maxNrOfCommonHRNTI',
        'maxNrOfCommonMACFlowsLCR',
        'maxNrOfCommonMACFlowsLCR-1',
        'maxNrOfHSSCCHsLCR',
        'maxNrOfEDCHMACdFlowsLCR',
        'maxNrOfEDCHMACdFlowsLCR-1',
        'maxNrOfEAGCHsLCR',
        'maxNrOfEHICHsLCR',
        'maxnrofERUCCHsLCR',
        'maxNrOfHSDSCH-1',
        'maxNrOfHSDSCH',
        'maxGANSS-1',
        'maxNoOfTBSs-Mapping-HS-DSCH-SPS',
        'maxNoOfTBSs-Mapping-HS-DSCH-SPS-1',
        'maxNoOfHS-DSCH-TBSsLCR',
        'maxNoOfRepetition-Period-LCR',
        'maxNoOfRepetitionPeriod-SPS-LCR-1',
        'maxNoOf-HS-SICH-SPS',
        'maxNoOf-HS-SICH-SPS-1',
        'maxNoOfNon-HS-SCCH-Assosiated-HS-SICH',
        'maxNoOfNon-HS-SCCH-Assosiated-HS-SICH-Ext',
        'maxMBMSServiceSelect',
        'maxNrOfCellPortionsPerCellLCR',
        'maxNrOfCellPortionsPerCellLCR-1',
        'maxNrOfEDCH-1',
        'maxNoOfCommonH-RNTI',
        'maxNrOfCommonMACFlowsLCRExt',
        'maxofERNTI',
        'maxNrOfDCHMeasurementOccasionPatternSequence',
        'maxNrOfULCarriersLCR-1',
        'maxFreqBandsTDD',
        'maxnoofPRACHEUL',
        'maxIGPInfo',
        'maxNrofConcatenatedDCH',
        'id-AICH-Information',
        'id-AICH-InformationItem-ResourceStatusInd',
        'id-BCH-Information',
        'id-BCH-InformationItem-ResourceStatusInd',
        'id-BCCH-ModificationTime',
        'id-BlockingPriorityIndicator',
        'id-Cause',
        'id-CCP-InformationItem-AuditRsp',
        'id-CCP-InformationList-AuditRsp',
        'id-CCP-InformationItem-ResourceStatusInd',
        'id-Cell-InformationItem-AuditRsp',
        'id-Cell-InformationItem-ResourceStatusInd',
        'id-Cell-InformationList-AuditRsp',
        'id-CellParameterID',
        'id-CFN',
        'id-C-ID',
        'id-CommonMeasurementAccuracy',
        'id-CommonMeasurementObjectType-CM-Rprt',
        'id-CommonMeasurementObjectType-CM-Rqst',
        'id-CommonMeasurementObjectType-CM-Rsp',
        'id-CommonMeasurementType',
        'id-CommonPhysicalChannelID',
        'id-CommonPhysicalChannelType-CTCH-SetupRqstFDD',
        'id-CommonPhysicalChannelType-CTCH-SetupRqstTDD',
        'id-CommunicationControlPortID',
        'id-ConfigurationGenerationID',
        'id-CRNC-CommunicationContextID',
        'id-CriticalityDiagnostics',
        'id-DCHs-to-Add-FDD',
        'id-DCH-AddList-RL-ReconfPrepTDD',
        'id-DCHs-to-Add-TDD',
        'id-DCH-DeleteList-RL-ReconfPrepFDD',
        'id-DCH-DeleteList-RL-ReconfPrepTDD',
        'id-DCH-DeleteList-RL-ReconfRqstFDD',
        'id-DCH-DeleteList-RL-ReconfRqstTDD',
        'id-DCH-FDD-Information',
        'id-DCH-TDD-Information',
        'id-DCH-InformationResponse',
        'id-FDD-DCHs-to-Modify',
        'id-TDD-DCHs-to-Modify',
        'id-DCH-ModifyList-RL-ReconfRqstTDD',
        'id-DCH-RearrangeList-Bearer-RearrangeInd',
        'id-DedicatedMeasurementObjectType-DM-Rprt',
        'id-DedicatedMeasurementObjectType-DM-Rqst',
        'id-DedicatedMeasurementObjectType-DM-Rsp',
        'id-DedicatedMeasurementType',
        'id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        'id-DL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        'id-DL-CCTrCH-InformationList-RL-SetupRqstTDD',
        'id-DL-DPCH-InformationItem-RL-AdditionRqstTDD',
        'id-DL-DPCH-InformationList-RL-SetupRqstTDD',
        'id-DL-DPCH-Information-RL-ReconfPrepFDD',
        'id-DL-DPCH-Information-RL-ReconfRqstFDD',
        'id-DL-DPCH-Information-RL-SetupRqstFDD',
        'id-DL-DPCH-TimingAdjustment',
        'id-DL-ReferencePowerInformationItem-DL-PC-Rqst',
        'id-DLReferencePower',
        'id-DLReferencePowerList-DL-PC-Rqst',
        'id-Unused-ProtocolIE-ID-87',
        'id-Unused-ProtocolIE-ID-89',
        'id-Unused-ProtocolIE-ID-91',
        'id-Unused-ProtocolIE-ID-93',
        'id-DSCHs-to-Add-TDD',
        'id-DSCH-Information-DeleteList-RL-ReconfPrepTDD',
        'id-DSCH-Information-ModifyList-RL-ReconfPrepTDD',
        'id-DSCH-InformationResponse',
        'id-Unused-ProtocolIE-ID-106',
        'id-DSCH-TDD-Information',
        'id-Unused-ProtocolIE-ID-108',
        'id-Unused-ProtocolIE-ID-112',
        'id-DSCH-RearrangeList-Bearer-RearrangeInd',
        'id-End-Of-Audit-Sequence-Indicator',
        'id-FACH-Information',
        'id-FACH-InformationItem-ResourceStatusInd',
        'id-FACH-ParametersList-CTCH-ReconfRqstTDD',
        'id-FACH-ParametersListIE-CTCH-SetupRqstFDD',
        'id-FACH-ParametersListIE-CTCH-SetupRqstTDD',
        'id-IndicationType-ResourceStatusInd',
        'id-Local-Cell-ID',
        'id-Local-Cell-Group-InformationItem-AuditRsp',
        'id-Local-Cell-Group-InformationItem-ResourceStatusInd',
        'id-Local-Cell-Group-InformationItem2-ResourceStatusInd',
        'id-Local-Cell-Group-InformationList-AuditRsp',
        'id-Local-Cell-InformationItem-AuditRsp',
        'id-Local-Cell-InformationItem-ResourceStatusInd',
        'id-Local-Cell-InformationItem2-ResourceStatusInd',
        'id-Local-Cell-InformationList-AuditRsp',
        'id-AdjustmentPeriod',
        'id-MaxAdjustmentStep',
        'id-MaximumTransmissionPower',
        'id-MeasurementFilterCoefficient',
        'id-MeasurementID',
        'id-MessageStructure',
        'id-MIB-SB-SIB-InformationList-SystemInfoUpdateRqst',
        'id-NodeB-CommunicationContextID',
        'id-NeighbouringCellMeasurementInformation',
        'id-P-CCPCH-Information',
        'id-P-CCPCH-InformationItem-ResourceStatusInd',
        'id-P-CPICH-Information',
        'id-P-CPICH-InformationItem-ResourceStatusInd',
        'id-P-SCH-Information',
        'id-PCCPCH-Information-Cell-ReconfRqstTDD',
        'id-PCCPCH-Information-Cell-SetupRqstTDD',
        'id-PCH-Parameters-CTCH-ReconfRqstTDD',
        'id-PCH-ParametersItem-CTCH-SetupRqstFDD',
        'id-PCH-ParametersItem-CTCH-SetupRqstTDD',
        'id-PCH-Information',
        'id-PDSCH-Information-AddListIE-PSCH-ReconfRqst',
        'id-PDSCH-Information-ModifyListIE-PSCH-ReconfRqst',
        'id-PDSCHSets-AddList-PSCH-ReconfRqst',
        'id-PDSCHSets-DeleteList-PSCH-ReconfRqst',
        'id-PDSCHSets-ModifyList-PSCH-ReconfRqst',
        'id-PICH-Information',
        'id-PICH-Parameters-CTCH-ReconfRqstTDD',
        'id-PowerAdjustmentType',
        'id-PRACH-Information',
        'id-PrimaryCCPCH-Information-Cell-ReconfRqstFDD',
        'id-PrimaryCCPCH-Information-Cell-SetupRqstFDD',
        'id-PrimaryCPICH-Information-Cell-ReconfRqstFDD',
        'id-PrimaryCPICH-Information-Cell-SetupRqstFDD',
        'id-PrimarySCH-Information-Cell-ReconfRqstFDD',
        'id-PrimarySCH-Information-Cell-SetupRqstFDD',
        'id-PrimaryScramblingCode',
        'id-SCH-Information-Cell-ReconfRqstTDD',
        'id-SCH-Information-Cell-SetupRqstTDD',
        'id-PUSCH-Information-AddListIE-PSCH-ReconfRqst',
        'id-PUSCH-Information-ModifyListIE-PSCH-ReconfRqst',
        'id-PUSCHSets-AddList-PSCH-ReconfRqst',
        'id-PUSCHSets-DeleteList-PSCH-ReconfRqst',
        'id-PUSCHSets-ModifyList-PSCH-ReconfRqst',
        'id-RACH-Information',
        'id-RACH-ParametersItem-CTCH-SetupRqstFDD',
        'id-RACH-ParameterItem-CTCH-SetupRqstTDD',
        'id-ReportCharacteristics',
        'id-Reporting-Object-RL-FailureInd',
        'id-Reporting-Object-RL-RestoreInd',
        'id-RL-InformationItem-DM-Rprt',
        'id-RL-InformationItem-DM-Rqst',
        'id-RL-InformationItem-DM-Rsp',
        'id-RL-InformationItem-RL-AdditionRqstFDD',
        'id-RL-informationItem-RL-DeletionRqst',
        'id-RL-InformationItem-RL-FailureInd',
        'id-RL-InformationItem-RL-PreemptRequiredInd',
        'id-RL-InformationItem-RL-ReconfPrepFDD',
        'id-RL-InformationItem-RL-ReconfRqstFDD',
        'id-RL-InformationItem-RL-RestoreInd',
        'id-RL-InformationItem-RL-SetupRqstFDD',
        'id-RL-InformationList-RL-AdditionRqstFDD',
        'id-RL-informationList-RL-DeletionRqst',
        'id-RL-InformationList-RL-PreemptRequiredInd',
        'id-RL-InformationList-RL-ReconfPrepFDD',
        'id-RL-InformationList-RL-ReconfRqstFDD',
        'id-RL-InformationList-RL-SetupRqstFDD',
        'id-RL-InformationResponseItem-RL-AdditionRspFDD',
        'id-RL-InformationResponseItem-RL-ReconfReady',
        'id-RL-InformationResponseItem-RL-ReconfRsp',
        'id-RL-InformationResponseItem-RL-SetupRspFDD',
        'id-RL-InformationResponseList-RL-AdditionRspFDD',
        'id-RL-InformationResponseList-RL-ReconfReady',
        'id-RL-InformationResponseList-RL-ReconfRsp',
        'id-RL-InformationResponseList-RL-SetupRspFDD',
        'id-RL-InformationResponse-RL-AdditionRspTDD',
        'id-RL-InformationResponse-RL-SetupRspTDD',
        'id-RL-Information-RL-AdditionRqstTDD',
        'id-RL-Information-RL-ReconfRqstTDD',
        'id-RL-Information-RL-ReconfPrepTDD',
        'id-RL-Information-RL-SetupRqstTDD',
        'id-RL-ReconfigurationFailureItem-RL-ReconfFailure',
        'id-RL-Set-InformationItem-DM-Rprt',
        'id-RL-Set-InformationItem-DM-Rsp',
        'id-RL-Set-InformationItem-RL-FailureInd',
        'id-RL-Set-InformationItem-RL-RestoreInd',
        'id-S-CCPCH-Information',
        'id-S-CPICH-Information',
        'id-SCH-Information',
        'id-S-SCH-Information',
        'id-Secondary-CCPCHListIE-CTCH-ReconfRqstTDD',
        'id-Secondary-CCPCH-parameterListIE-CTCH-SetupRqstTDD',
        'id-Secondary-CCPCH-Parameters-CTCH-ReconfRqstTDD',
        'id-SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD',
        'id-SecondaryCPICH-InformationItem-Cell-SetupRqstFDD',
        'id-SecondaryCPICH-InformationList-Cell-ReconfRqstFDD',
        'id-SecondaryCPICH-InformationList-Cell-SetupRqstFDD',
        'id-SecondarySCH-Information-Cell-ReconfRqstFDD',
        'id-SecondarySCH-Information-Cell-SetupRqstFDD',
        'id-SegmentInformationListIE-SystemInfoUpdate',
        'id-SFN',
        'id-SignallingBearerRequestIndicator',
        'id-ShutdownTimer',
        'id-Start-Of-Audit-Sequence-Indicator',
        'id-Successful-RL-InformationRespItem-RL-AdditionFailureFDD',
        'id-Successful-RL-InformationRespItem-RL-SetupFailureFDD',
        'id-SyncCase',
        'id-SyncCaseIndicatorItem-Cell-SetupRqstTDD-PSCH',
        'id-T-Cell',
        'id-TargetCommunicationControlPortID',
        'id-TimeSlotConfigurationList-Cell-ReconfRqstTDD',
        'id-TimeSlotConfigurationList-Cell-SetupRqstTDD',
        'id-TransmissionDiversityApplied',
        'id-TypeOfError',
        'id-UARFCNforNt',
        'id-UARFCNforNd',
        'id-UARFCNforNu',
        'id-UL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        'id-UL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        'id-UL-CCTrCH-InformationList-RL-SetupRqstTDD',
        'id-UL-DPCH-InformationItem-RL-AdditionRqstTDD',
        'id-UL-DPCH-InformationList-RL-SetupRqstTDD',
        'id-UL-DPCH-Information-RL-ReconfPrepFDD',
        'id-UL-DPCH-Information-RL-ReconfRqstFDD',
        'id-UL-DPCH-Information-RL-SetupRqstFDD',
        'id-Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD',
        'id-Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD',
        'id-Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD',
        'id-Unsuccessful-RL-InformationResp-RL-SetupFailureTDD',
        'id-USCH-Information-Add',
        'id-USCH-Information-DeleteList-RL-ReconfPrepTDD',
        'id-USCH-Information-ModifyList-RL-ReconfPrepTDD',
        'id-USCH-InformationResponse',
        'id-USCH-Information',
        'id-USCH-RearrangeList-Bearer-RearrangeInd',
        'id-Active-Pattern-Sequence-Information',
        'id-AICH-ParametersListIE-CTCH-ReconfRqstFDD',
        'id-AdjustmentRatio',
        'id-Not-Used-320',
        'id-Not-Used-322',
        'id-FACH-ParametersListIE-CTCH-ReconfRqstFDD',
        'id-CauseLevel-PSCH-ReconfFailure',
        'id-CauseLevel-RL-AdditionFailureFDD',
        'id-CauseLevel-RL-AdditionFailureTDD',
        'id-CauseLevel-RL-ReconfFailure',
        'id-CauseLevel-RL-SetupFailureFDD',
        'id-CauseLevel-RL-SetupFailureTDD',
        'id-Not-Used-330',
        'id-Not-Used-332',
        'id-Closed-Loop-Timing-Adjustment-Mode',
        'id-CommonPhysicalChannelType-CTCH-ReconfRqstFDD',
        'id-Compressed-Mode-Deactivation-Flag',
        'id-Not-Used-336',
        'id-Not-Used-342',
        'id-Not-Used-343',
        'id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        'id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        'id-DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        'id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        'id-DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        'id-DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        'id-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'id-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD',
        'id-DL-DPCH-InformationModify-AddListIE-RL-ReconfPrepTDD',
        'id-DL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD',
        'id-DL-DPCH-InformationModify-ModifyListIE-RL-ReconfPrepTDD',
        'id-DL-TPC-Pattern01Count',
        'id-DPC-Mode',
        'id-DPCHConstant',
        'id-Unused-ProtocolIE-ID-94',
        'id-Unused-ProtocolIE-ID-110',
        'id-Unused-ProtocolIE-ID-111',
        'id-FACH-ParametersList-CTCH-SetupRsp',
        'id-Limited-power-increase-information-Cell-SetupRqstFDD',
        'id-PCH-Parameters-CTCH-SetupRsp',
        'id-PCH-ParametersItem-CTCH-ReconfRqstFDD',
        'id-Not-Used-376',
        'id-PICH-ParametersItem-CTCH-ReconfRqstFDD',
        'id-PRACHConstant',
        'id-PRACH-ParametersListIE-CTCH-ReconfRqstFDD',
        'id-PUSCHConstant',
        'id-RACH-Parameters-CTCH-SetupRsp',
        'id-Unused-ProtocolIE-ID-443',
        'id-Synchronisation-Configuration-Cell-ReconfRqst',
        'id-Synchronisation-Configuration-Cell-SetupRqst',
        'id-Transmission-Gap-Pattern-Sequence-Information',
        'id-UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        'id-UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        'id-UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        'id-UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        'id-UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        'id-UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        'id-UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'id-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-InformationModify-AddListIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-InformationModify-ModifyListIE-RL-ReconfPrepTDD',
        'id-Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD',
        'id-Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD',
        'id-CommunicationContextInfoItem-Reset',
        'id-CommunicationControlPortInfoItem-Reset',
        'id-ResetIndicator',
        'id-Unused-ProtocolIE-ID-417',
        'id-Unused-ProtocolIE-ID-418',
        'id-Unused-ProtocolIE-ID-419',
        'id-Unused-ProtocolIE-ID-142',
        'id-TimingAdvanceApplied',
        'id-CFNReportingIndicator',
        'id-SFNReportingIndicator',
        'id-InnerLoopDLPCStatus',
        'id-TimeslotISCPInfo',
        'id-PICH-ParametersItem-CTCH-SetupRqstTDD',
        'id-PRACH-ParametersItem-CTCH-SetupRqstTDD',
        'id-CCTrCH-InformationItem-RL-FailureInd',
        'id-CCTrCH-InformationItem-RL-RestoreInd',
        'id-CauseLevel-SyncAdjustmntFailureTDD',
        'id-CellAdjustmentInfo-SyncAdjustmntRqstTDD',
        'id-CellAdjustmentInfoItem-SyncAdjustmentRqstTDD',
        'id-CellSyncBurstInfoList-CellSyncReconfRqstTDD',
        'id-CellSyncBurstTransInit-CellSyncInitiationRqstTDD',
        'id-CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD',
        'id-CellSyncBurstTransReconfiguration-CellSyncReconfRqstTDD',
        'id-CellSyncBurstMeasReconfiguration-CellSyncReconfRqstTDD',
        'id-CellSyncBurstTransInfoList-CellSyncReconfRqstTDD',
        'id-CellSyncBurstMeasInfoList-CellSyncReconfRqstTDD',
        'id-CellSyncBurstTransReconfInfo-CellSyncReconfRqstTDD',
        'id-CellSyncInfo-CellSyncReprtTDD',
        'id-CSBTransmissionID',
        'id-CSBMeasurementID',
        'id-IntStdPhCellSyncInfoItem-CellSyncReprtTDD',
        'id-NCyclesPerSFNperiod',
        'id-NRepetitionsPerCyclePeriod',
        'id-SyncFrameNumber',
        'id-SynchronisationReportType',
        'id-SynchronisationReportCharacteristics',
        'id-Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD',
        'id-LateEntranceCellSyncInfoItem-CellSyncReprtTDD',
        'id-ReferenceClockAvailability',
        'id-ReferenceSFNoffset',
        'id-InformationExchangeID',
        'id-InformationExchangeObjectType-InfEx-Rqst',
        'id-InformationType',
        'id-InformationReportCharacteristics',
        'id-InformationExchangeObjectType-InfEx-Rsp',
        'id-InformationExchangeObjectType-InfEx-Rprt',
        'id-IPDLParameter-Information-Cell-ReconfRqstFDD',
        'id-IPDLParameter-Information-Cell-SetupRqstFDD',
        'id-IPDLParameter-Information-Cell-ReconfRqstTDD',
        'id-IPDLParameter-Information-Cell-SetupRqstTDD',
        'id-DL-DPCH-LCR-Information-RL-SetupRqstTDD',
        'id-DwPCH-LCR-Information',
        'id-DwPCH-LCR-InformationList-AuditRsp',
        'id-DwPCH-LCR-Information-Cell-SetupRqstTDD',
        'id-DwPCH-LCR-Information-Cell-ReconfRqstTDD',
        'id-DwPCH-LCR-Information-ResourceStatusInd',
        'id-maxFACH-Power-LCR-CTCH-SetupRqstTDD',
        'id-maxFACH-Power-LCR-CTCH-ReconfRqstTDD',
        'id-FPACH-LCR-Information',
        'id-FPACH-LCR-Information-AuditRsp',
        'id-FPACH-LCR-InformationList-AuditRsp',
        'id-FPACH-LCR-InformationList-ResourceStatusInd',
        'id-FPACH-LCR-Parameters-CTCH-SetupRqstTDD',
        'id-FPACH-LCR-Parameters-CTCH-ReconfRqstTDD',
        'id-PCCPCH-LCR-Information-Cell-SetupRqstTDD',
        'id-PCH-Power-LCR-CTCH-SetupRqstTDD',
        'id-PCH-Power-LCR-CTCH-ReconfRqstTDD',
        'id-PICH-LCR-Parameters-CTCH-SetupRqstTDD',
        'id-PRACH-LCR-ParametersList-CTCH-SetupRqstTDD',
        'id-RL-InformationResponse-LCR-RL-SetupRspTDD',
        'id-Secondary-CCPCH-LCR-parameterList-CTCH-SetupRqstTDD',
        'id-TimeSlot',
        'id-TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD',
        'id-TimeSlotConfigurationList-LCR-Cell-SetupRqstTDD',
        'id-TimeslotISCP-LCR-InfoList-RL-SetupRqstTDD',
        'id-TimeSlotLCR-CM-Rqst',
        'id-UL-DPCH-LCR-Information-RL-SetupRqstTDD',
        'id-DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD',
        'id-UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD',
        'id-TimeslotISCP-InformationList-LCR-RL-AdditionRqstTDD',
        'id-DL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD',
        'id-DL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD',
        'id-DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'id-TimeslotISCPInfoList-LCR-DL-PC-RqstTDD',
        'id-UL-DPCH-LCR-InformationAddListIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-LCR-InformationModify-AddList',
        'id-UL-TimeslotLCR-Information-RL-ReconfPrepTDD',
        'id-UL-SIRTarget',
        'id-PDSCH-AddInformation-LCR-PSCH-ReconfRqst',
        'id-PDSCH-AddInformation-LCR-AddListIE-PSCH-ReconfRqst',
        'id-Unused-ProtocolIE-ID-26',
        'id-Unused-ProtocolIE-ID-27',
        'id-PDSCH-ModifyInformation-LCR-PSCH-ReconfRqst',
        'id-PDSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst',
        'id-PUSCH-AddInformation-LCR-PSCH-ReconfRqst',
        'id-PUSCH-AddInformation-LCR-AddListIE-PSCH-ReconfRqst',
        'id-PUSCH-ModifyInformation-LCR-PSCH-ReconfRqst',
        'id-PUSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst',
        'id-timeslotInfo-CellSyncInitiationRqstTDD',
        'id-SyncReportType-CellSyncReprtTDD',
        'id-Power-Local-Cell-Group-InformationItem-AuditRsp',
        'id-Power-Local-Cell-Group-InformationItem-ResourceStatusInd',
        'id-Power-Local-Cell-Group-InformationItem2-ResourceStatusInd',
        'id-Power-Local-Cell-Group-InformationList-AuditRsp',
        'id-Power-Local-Cell-Group-InformationList-ResourceStatusInd',
        'id-Power-Local-Cell-Group-InformationList2-ResourceStatusInd',
        'id-Power-Local-Cell-Group-ID',
        'id-PUSCH-Info-DM-Rqst',
        'id-PUSCH-Info-DM-Rsp',
        'id-PUSCH-Info-DM-Rprt',
        'id-InitDL-Power',
        'id-cellSyncBurstRepetitionPeriod',
        'id-ReportCharacteristicsType-OnModification',
        'id-SFNSFNMeasurementValueInformation',
        'id-SFNSFNMeasurementThresholdInformation',
        'id-TUTRANGPSMeasurementValueInformation',
        'id-TUTRANGPSMeasurementThresholdInformation',
        'id-Rx-Timing-Deviation-Value-LCR',
        'id-RL-InformationResponse-LCR-RL-AdditionRspTDD',
        'id-DL-PowerBalancing-Information',
        'id-DL-PowerBalancing-ActivationIndicator',
        'id-DL-PowerBalancing-UpdatedIndicator',
        'id-CCTrCH-Initial-DL-Power-RL-SetupRqstTDD',
        'id-CCTrCH-Initial-DL-Power-RL-AdditionRqstTDD',
        'id-CCTrCH-Initial-DL-Power-RL-ReconfPrepTDD',
        'id-IPDLParameter-Information-LCR-Cell-SetupRqstTDD',
        'id-IPDLParameter-Information-LCR-Cell-ReconfRqstTDD',
        'id-HS-PDSCH-HS-SCCH-E-AGCH-E-RGCH-E-HICH-MaxPower-PSCH-ReconfRqst',
        'id-HS-PDSCH-HS-SCCH-ScramblingCode-PSCH-ReconfRqst',
        'id-HS-PDSCH-FDD-Code-Information-PSCH-ReconfRqst',
        'id-HS-SCCH-FDD-Code-Information-PSCH-ReconfRqst',
        'id-HS-PDSCH-TDD-Information-PSCH-ReconfRqst',
        'id-Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'id-Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'id-Delete-From-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'id-bindingID',
        'id-RL-Specific-DCH-Info',
        'id-transportlayeraddress',
        'id-DelayedActivation',
        'id-DelayedActivationList-RL-ActivationCmdFDD',
        'id-DelayedActivationInformation-RL-ActivationCmdFDD',
        'id-DelayedActivationList-RL-ActivationCmdTDD',
        'id-DelayedActivationInformation-RL-ActivationCmdTDD',
        'id-neighbouringTDDCellMeasurementInformationLCR',
        'id-SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD',
        'id-SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD',
        'id-SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD',
        'id-SYNCDlCodeIdMeasReconfigurationLCR-CellSyncReconfRqstTDD',
        'id-SYNCDlCodeIdMeasInfoList-CellSyncReconfRqstTDD',
        'id-SyncDLCodeIdsMeasInfoList-CellSyncReprtTDD',
        'id-SyncDLCodeIdThreInfoLCR',
        'id-NSubCyclesPerCyclePeriod-CellSyncReconfRqstTDD',
        'id-DwPCH-Power',
        'id-AccumulatedClockupdate-CellSyncReprtTDD',
        'id-Angle-Of-Arrival-Value-LCR',
        'id-HSDSCH-FDD-Information',
        'id-HSDSCH-FDD-Information-Response',
        'id-HSDSCH-Information-to-Modify',
        'id-HSDSCH-RNTI',
        'id-HSDSCH-TDD-Information',
        'id-HSDSCH-TDD-Information-Response',
        'id-HSPDSCH-RL-ID',
        'id-PrimCCPCH-RSCP-DL-PC-RqstTDD',
        'id-Unused-ProtocolIE-ID-64',
        'id-PDSCH-RL-ID',
        'id-HSDSCH-RearrangeList-Bearer-RearrangeInd',
        'id-UL-Synchronisation-Parameters-LCR',
        'id-HSDSCH-FDD-Update-Information',
        'id-HSDSCH-TDD-Update-Information',
        'id-DL-DPCH-TimeSlotFormat-LCR-ModifyItem-RL-ReconfPrepTDD',
        'id-UL-DPCH-TimeSlotFormat-LCR-ModifyItem-RL-ReconfPrepTDD',
        'id-TDD-TPC-UplinkStepSize-LCR-RL-SetupRqstTDD',
        'id-TDD-TPC-UplinkStepSize-LCR-RL-AdditionRqstTDD',
        'id-TDD-TPC-DownlinkStepSize-RL-AdditionRqstTDD',
        'id-TDD-TPC-UplinkStepSize-InformationAdd-LCR-RL-ReconfPrepTDD',
        'id-TDD-TPC-UplinkStepSize-InformationModify-LCR-RL-ReconfPrepTDD',
        'id-TDD-TPC-DownlinkStepSize-InformationModify-RL-ReconfPrepTDD',
        'id-TDD-TPC-DownlinkStepSize-InformationAdd-RL-ReconfPrepTDD',
        'id-CCTrCH-Maximum-DL-Power-RL-SetupRqstTDD',
        'id-CCTrCH-Minimum-DL-Power-RL-SetupRqstTDD',
        'id-CCTrCH-Maximum-DL-Power-RL-AdditionRqstTDD',
        'id-CCTrCH-Minimum-DL-Power-RL-AdditionRqstTDD',
        'id-CCTrCH-Maximum-DL-Power-InformationAdd-RL-ReconfPrepTDD',
        'id-CCTrCH-Minimum-DL-Power-InformationAdd-RL-ReconfPrepTDD',
        'id-CCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfPrepTDD',
        'id-CCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfPrepTDD',
        'id-Maximum-DL-Power-Modify-LCR-InformationModify-RL-ReconfPrepTDD',
        'id-Minimum-DL-Power-Modify-LCR-InformationModify-RL-ReconfPrepTDD',
        'id-DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD',
        'id-CCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfRqstTDD',
        'id-CCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfRqstTDD',
        'id-Initial-DL-Power-TimeslotLCR-InformationItem',
        'id-Maximum-DL-Power-TimeslotLCR-InformationItem',
        'id-Minimum-DL-Power-TimeslotLCR-InformationItem',
        'id-HS-DSCHProvidedBitRateValueInformation',
        'id-HS-DSCHRequiredPowerValueInformation',
        'id-HS-DSCHRequiredPowerValue',
        'id-TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmission',
        'id-HS-SICH-Reception-Quality',
        'id-HS-SICH-Reception-Quality-Measurement-Value',
        'id-HSSICH-Info-DM-Rprt',
        'id-HSSICH-Info-DM-Rqst',
        'id-HSSICH-Info-DM-Rsp',
        'id-Best-Cell-Portions-Value',
        'id-Primary-CPICH-Usage-for-Channel-Estimation',
        'id-Secondary-CPICH-Information-Change',
        'id-NumberOfReportedCellPortions',
        'id-CellPortion-InformationItem-Cell-SetupRqstFDD',
        'id-CellPortion-InformationList-Cell-SetupRqstFDD',
        'id-TimeslotISCP-LCR-InfoList-RL-ReconfPrepTDD',
        'id-Secondary-CPICH-Information',
        'id-Received-total-wide-band-power-For-CellPortion',
        'id-Unidirectional-DCH-Indicator',
        'id-TimingAdjustmentValueLCR',
        'id-multipleRL-dl-DPCH-InformationList',
        'id-multipleRL-dl-DPCH-InformationModifyList',
        'id-multipleRL-ul-DPCH-InformationList',
        'id-multipleRL-ul-DPCH-InformationModifyList',
        'id-RL-ID',
        'id-SAT-Info-Almanac-ExtItem',
        'id-HSDPA-Capability',
        'id-HSDSCH-Resources-Information-AuditRsp',
        'id-HSDSCH-Resources-Information-ResourceStatusInd',
        'id-HSDSCH-MACdFlows-to-Add',
        'id-HSDSCH-MACdFlows-to-Delete',
        'id-HSDSCH-Information-to-Modify-Unsynchronised',
        'id-TnlQos',
        'id-Received-total-wide-band-power-For-CellPortion-Value',
        'id-Transmitted-Carrier-Power-For-CellPortion',
        'id-Transmitted-Carrier-Power-For-CellPortion-Value',
        'id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortion',
        'id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue',
        'id-UpPTSInterferenceValue',
        'id-PrimaryCCPCH-RSCP-Delta',
        'id-MeasurementRecoveryBehavior',
        'id-MeasurementRecoveryReportingIndicator',
        'id-MeasurementRecoverySupportIndicator',
        'id-Tstd-indicator',
        'id-multiple-RL-Information-RL-ReconfPrepTDD',
        'id-multiple-RL-Information-RL-ReconfRqstTDD',
        'id-DL-DPCH-Power-Information-RL-ReconfPrepFDD',
        'id-F-DPCH-Information-RL-ReconfPrepFDD',
        'id-F-DPCH-Information-RL-SetupRqstFDD',
        'id-Additional-S-CCPCH-Parameters-CTCH-ReconfRqstTDD',
        'id-Additional-S-CCPCH-Parameters-CTCH-SetupRqstTDD',
        'id-Additional-S-CCPCH-LCR-Parameters-CTCH-ReconfRqstTDD',
        'id-Additional-S-CCPCH-LCR-Parameters-CTCH-SetupRqstTDD',
        'id-MICH-CFN',
        'id-MICH-Information-AuditRsp',
        'id-MICH-Information-ResourceStatusInd',
        'id-MICH-Parameters-CTCH-ReconfRqstFDD',
        'id-MICH-Parameters-CTCH-ReconfRqstTDD',
        'id-MICH-Parameters-CTCH-SetupRqstFDD',
        'id-MICH-Parameters-CTCH-SetupRqstTDD',
        'id-Modification-Period',
        'id-NI-Information-NotifUpdateCmd',
        'id-S-CCPCH-InformationListExt-AuditRsp',
        'id-S-CCPCH-InformationListExt-ResourceStatusInd',
        'id-S-CCPCH-LCR-InformationListExt-AuditRsp',
        'id-S-CCPCH-LCR-InformationListExt-ResourceStatusInd',
        'id-HARQ-Preamble-Mode',
        'id-Initial-DL-DPCH-TimingAdjustment',
        'id-Initial-DL-DPCH-TimingAdjustment-Allowed',
        'id-DLTransmissionBranchLoadValue',
        'id-Power-Local-Cell-Group-choice-CM-Rqst',
        'id-Power-Local-Cell-Group-choice-CM-Rsp',
        'id-Power-Local-Cell-Group-choice-CM-Rprt',
        'id-SynchronisationIndicator',
        'id-HSDPA-And-EDCH-CellPortion-Information-PSCH-ReconfRqst',
        'id-Unused-ProtocolIE-ID-659',
        'id-HS-DSCHRequiredPowerValue-For-Cell-Portion',
        'id-HS-DSCHRequiredPowerValueInformation-For-CellPortion',
        'id-HS-DSCHProvidedBitRateValueInformation-For-CellPortion',
        'id-E-AGCH-And-E-RGCH-E-HICH-FDD-Scrambling-Code',
        'id-E-AGCH-FDD-Code-Information',
        'id-E-DCH-Capability',
        'id-E-DCH-FDD-DL-Control-Channel-Information',
        'id-E-DCH-FDD-Information',
        'id-E-DCH-FDD-Information-Response',
        'id-E-DCH-FDD-Information-to-Modify',
        'id-E-DCH-MACdFlows-to-Add',
        'id-E-DCH-MACdFlows-to-Delete',
        'id-E-DCH-Resources-Information-AuditRsp',
        'id-E-DCH-Resources-Information-ResourceStatusInd',
        'id-E-DCH-RL-Indication',
        'id-E-DCH-RL-Set-ID',
        'id-E-DPCH-Information-RL-ReconfPrepFDD',
        'id-E-DPCH-Information-RL-SetupRqstFDD',
        'id-E-RGCH-E-HICH-FDD-Code-Information',
        'id-Serving-E-DCH-RL-ID',
        'id-UL-DPDCH-Indicator-For-E-DCH-Operation',
        'id-FDD-S-CCPCH-FrameOffset-CTCH-SetupRqstFDD',
        'id-E-DPCH-Information-RL-ReconfRqstFDD',
        'id-Maximum-Target-ReceivedTotalWideBandPower',
        'id-E-DCHProvidedBitRateValueInformation',
        'id-HARQ-Preamble-Mode-Activation-Indicator',
        'id-RL-Specific-E-DCH-Info',
        'id-E-DCH-CapacityConsumptionLaw',
        'id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp',
        'id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp',
        'id-E-DCH-RearrangeList-Bearer-RearrangeInd',
        'id-Unused-ProtocolIE-ID-691',
        'id-multipleRL-dl-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'id-Target-NonServing-EDCH-To-Total-EDCH-Power-Ratio',
        'id-CellPortion-InformationItem-Cell-ReconfRqstFDD',
        'id-CellPortion-InformationList-Cell-ReconfRqstFDD',
        'id-multiple-PUSCH-InfoList-DM-Rsp',
        'id-multiple-PUSCH-InfoList-DM-Rprt',
        'id-Reference-ReceivedTotalWideBandPower',
        'id-E-DCH-Serving-Cell-Change-Info-Response',
        'id-HS-DSCH-Serving-Cell-Change-Info',
        'id-HS-DSCH-Serving-Cell-Change-Info-Response',
        'id-Serving-Cell-Change-CFN',
        'id-E-DCH-HARQ-Combining-Capability',
        'id-E-DCH-TTI2ms-Capability',
        'id-E-DCH-SF-Capability',
        'id-E-DCH-FDD-Update-Information',
        'id-F-DPCH-Capability',
        'id-E-DCH-Non-serving-Relative-Grant-Down-CommandsValue',
        'id-HSSICH-SIRTarget',
        'id-multiple-HSSICHMeasurementValueList-TDD-DM-Rsp',
        'id-PLCCH-Information-AuditRsp',
        'id-PLCCH-Information-ResourceStatusInd',
        'id-PLCCH-Information-RL-ReconfPrepTDDLCR',
        'id-PLCCH-Information-UL-TimeslotLCR-Info',
        'id-PLCCH-InformationList-AuditRsp',
        'id-PLCCH-InformationList-ResourceStatusInd',
        'id-PLCCH-Parameters-CTCH-ReconfRqstTDD',
        'id-S-CCPCH-768-Parameters-CTCH-SetupRqstTDD',
        'id-PICH-768-Parameters-CTCH-SetupRqstTDD',
        'id-PRACH-768-Parameters-CTCH-SetupRqstTDD',
        'id-S-CCPCH-768-Parameters-CTCH-ReconfRqstTDD',
        'id-PICH-768-Parameters-CTCH-ReconfRqstTDD',
        'id-MICH-768-Parameters-CTCH-ReconfRqstTDD',
        'id-CommonPhysicalChannelID768-CommonTrChDeletionReq',
        'id-S-CCPCH-768-InformationList-AuditRsp',
        'id-S-CCPCH-768-Information-AuditRsp',
        'id-neighbouringTDDCellMeasurementInformation768',
        'id-PCCPCH-768-Information-Cell-SetupRqstTDD',
        'id-SCH-768-Information-Cell-SetupRqstTDD',
        'id-SCH-768-Information-Cell-ReconfRqstTDD',
        'id-PCCPCH-768-Information-Cell-ReconfRqstTDD',
        'id-P-CCPCH-768-Information-AuditRsp',
        'id-PICH-768-Information-AuditRsp',
        'id-PRACH-768-InformationList-AuditRsp',
        'id-SCH-768-Information-AuditRsp',
        'id-MICH-768-Information-AuditRsp',
        'id-PRACH-768-Information',
        'id-S-CCPCH-768-Information-ResourceStatusInd',
        'id-P-CCPCH-768-Information-ResourceStatusInd',
        'id-PICH-768-Information-ResourceStatusInd',
        'id-PRACH-768-InformationList-ResourceStatusInd',
        'id-SCH-768-Information-ResourceStatusInd',
        'id-MICH-768-Information-ResourceStatusInd',
        'id-S-CCPCH-768-InformationList-ResourceStatusInd',
        'id-UL-DPCH-768-Information-RL-SetupRqstTDD',
        'id-DL-DPCH-768-Information-RL-SetupRqstTDD',
        'id-DL-DPCH-InformationItem-768-RL-AdditionRqstTDD',
        'id-UL-DPCH-InformationItem-768-RL-AdditionRqstTDD',
        'id-UL-DPCH-768-InformationAddItemIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-768-InformationAddListIE-RL-ReconfPrepTDD',
        'id-UL-DPCH-768-InformationModify-AddItem',
        'id-UL-DPCH-768-InformationModify-AddList',
        'id-UL-Timeslot768-Information-RL-ReconfPrepTDD',
        'id-DL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD',
        'id-DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD',
        'id-DL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD',
        'id-DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD',
        'id-DL-Timeslot-768-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'id-DPCH-ID768-DM-Rqst',
        'id-multiple-DedicatedMeasurementValueList-768-TDD-DM-Rsp',
        'id-DPCH-ID768-DM-Rsp',
        'id-Rx-Timing-Deviation-Value-768',
        'id-DPCH-ID768-DM-Rprt',
        'id-PDSCH-AddInformation-768-PSCH-ReconfRqst',
        'id-PDSCH-ModifyInformation-768-PSCH-ReconfRqst',
        'id-PUSCH-AddInformation-768-PSCH-ReconfRqst',
        'id-PUSCH-ModifyInformation-768-PSCH-ReconfRqst',
        'id-dL-HS-PDSCH-Timeslot-Information-768-PSCH-ReconfRqst',
        'id-hS-SCCH-Information-768-PSCH-ReconfRqst',
        'id-hS-SCCH-InformationModify-768-PSCH-ReconfRqst',
        'id-hsSCCH-Specific-Information-ResponseTDD768',
        'id-E-DPCH-Information-RL-AdditionReqFDD',
        'id-PDSCH-Timeslot-Format-PSCH-ReconfRqst-LCR',
        'id-PUSCH-Timeslot-Format-PSCH-ReconfRqst-LCR',
        'id-E-DCH-PowerOffset-for-SchedulingInfo',
        'id-HSDSCH-Configured-Indicator',
        'id-Rx-Timing-Deviation-Value-384-ext',
        'id-RTWP-ReportingIndicator',
        'id-RTWP-CellPortion-ReportingIndicator',
        'id-Received-Scheduled-EDCH-Power-Share-Value',
        'id-Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value',
        'id-Received-Scheduled-EDCH-Power-Share',
        'id-Received-Scheduled-EDCH-Power-Share-For-CellPortion',
        'id-tFCI-Presence',
        'id-HSSICH-TPC-StepSize',
        'id-E-RUCCH-InformationList-AuditRsp',
        'id-E-RUCCH-InformationList-ResourceStatusInd',
        'id-E-DCH-TDD-CapacityConsumptionLaw',
        'id-E-RUCCH-Information',
        'id-E-DCH-Information',
        'id-E-DCH-Information-Response',
        'id-E-DCH-Information-Reconfig',
        'id-E-PUCH-Information-PSCH-ReconfRqst',
        'id-Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'id-Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'id-Delete-From-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'id-E-HICH-Information-PSCH-ReconfRqst',
        'id-E-HICH-TimeOffset',
        'id-Maximum-Generated-ReceivedTotalWideBandPowerInOtherCells',
        'id-E-DCH-Serving-RL-ID',
        'id-E-RUCCH-768-InformationList-AuditRsp',
        'id-E-RUCCH-768-InformationList-ResourceStatusInd',
        'id-E-RUCCH-768-Information',
        'id-E-DCH-768-Information',
        'id-E-DCH-768-Information-Reconfig',
        'id-E-PUCH-Information-768-PSCH-ReconfRqst',
        'id-Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst',
        'id-Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst',
        'id-E-HICH-Information-768-PSCH-ReconfRqst',
        'id-ExtendedPropagationDelay',
        'id-Extended-Round-Trip-Time-Value',
        'id-AlternativeFormatReportingIndicator',
        'id-DCH-Indicator-For-E-DCH-HSDPA-Operation',
        'id-Reference-ReceivedTotalWideBandPowerReporting',
        'id-Reference-ReceivedTotalWideBandPowerSupportIndicator',
        'id-ueCapability-Info',
        'id-MAChs-ResetIndicator',
        'id-Fast-Reconfiguration-Mode',
        'id-Fast-Reconfiguration-Permission',
        'id-BroadcastReference',
        'id-BroadcastCommonTransportBearerIndication',
        'id-ContinuousPacketConnectivityDTX-DRX-Capability',
        'id-ContinuousPacketConnectivityDTX-DRX-Information',
        'id-ContinuousPacketConnectivityHS-SCCH-less-Capability',
        'id-ContinuousPacketConnectivityHS-SCCH-less-Information',
        'id-ContinuousPacketConnectivityHS-SCCH-less-Information-Response',
        'id-CPC-Information',
        'id-MIMO-Capability',
        'id-MIMO-PilotConfiguration',
        'id-MBSFN-Cell-ParameterID-Cell-SetupRqstTDD',
        'id-MBSFN-Cell-ParameterID-Cell-ReconfRqstTDD',
        'id-S-CCPCH-Modulation',
        'id-HS-PDSCH-Code-Change-Grant',
        'id-HS-PDSCH-Code-Change-Indicator',
        'id-SYNC-UL-Partition-LCR',
        'id-E-DCH-LCR-Information',
        'id-E-DCH-LCR-Information-Reconfig',
        'id-E-PUCH-Information-LCR-PSCH-ReconfRqst',
        'id-Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Delete-From-E-HICH-Resource-Pool-PSCH-ReconfRqst',
        'id-E-HICH-TimeOffsetLCR',
        'id-SixtyfourQAM-DL-Capability',
        'id-SixteenQAM-UL-Capability',
        'id-HSDSCH-MACdPDU-SizeCapability',
        'id-HSDSCH-MACdPDUSizeFormat',
        'id-MaximumMACdPDU-SizeExtended',
        'id-F-DPCH-SlotFormat',
        'id-F-DPCH-SlotFormatCapability',
        'id-LCRTDD-uplink-Physical-Channel-Capability',
        'id-Extended-RNC-ID',
        'id-Max-UE-DTX-Cycle',
        'id-Secondary-CCPCH-SlotFormat-Extended',
        'id-MBSFN-Only-Mode-Indicator-Cell-SetupRqstTDD-LCR',
        'id-MBSFN-Only-Mode-Capability',
        'id-Time-Slot-Parameter-ID',
        'id-Additional-failed-HS-SICH',
        'id-Additional-missed-HS-SICH',
        'id-Additional-total-HS-SICH',
        'id-Additional-HS-SICH-Reception-Quality-Measurement-Value',
        'id-GANSS-Common-Data',
        'id-GANSS-Information',
        'id-GANSS-Generic-Data',
        'id-TUTRANGANSSMeasurementThresholdInformation',
        'id-TUTRANGANSSMeasurementValueInformation',
        'id-ModulationPO-MBSFN',
        'id-Enhanced-FACH-Capability',
        'id-Enhanced-PCH-Capability',
        'id-HSDSCH-Common-System-InformationFDD',
        'id-HSDSCH-Common-System-Information-ResponseFDD',
        'id-HSDSCH-Paging-System-InformationFDD',
        'id-HSDSCH-Paging-System-Information-ResponseFDD',
        'id-MBMS-Capability',
        'id-Ext-Reference-E-TFCI-PO',
        'id-Ext-Max-Bits-MACe-PDU-non-scheduled',
        'id-HARQ-MemoryPartitioningInfoExtForMIMO',
        'id-MIMO-ActivationIndicator',
        'id-MIMO-Mode-Indicator',
        'id-MIMO-N-M-Ratio',
        'id-IPMulticastIndication',
        'id-IPMulticastDataBearerIndication',
        'id-TransportBearerNotSetupIndicator',
        'id-TransportBearerNotRequestedIndicator',
        'id-TimeSlotConfigurationList-LCR-CTCH-SetupRqstTDD',
        'id-Cell-Frequency-List-Information-LCR-MulFreq-AuditRsp',
        'id-Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp',
        'id-Cell-Frequency-List-LCR-MulFreq-Cell-SetupRqstTDD',
        'id-UARFCN-Adjustment',
        'id-Cell-Frequency-List-Information-LCR-MulFreq-ResourceStatusInd',
        'id-Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd',
        'id-UPPCHPositionLCR',
        'id-UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD',
        'id-UPPCH-LCR-InformationList-AuditRsp',
        'id-UPPCH-LCR-InformationItem-AuditRsp',
        'id-UPPCH-LCR-InformationList-ResourceStatusInd',
        'id-UPPCH-LCR-InformationItem-ResourceStatusInd',
        'id-multipleFreq-dL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst',
        'id-number-Of-Supported-Carriers',
        'id-multipleFreq-HSPDSCH-InformationList-ResponseTDDLCR',
        'id-Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD',
        'id-multipleFreq-HS-DSCH-Resources-InformationList-AuditRsp',
        'id-multipleFreq-HS-DSCH-Resources-InformationList-ResourceStatusInd',
        'id-UARFCNSpecificCauseList',
        'id-tSN-Length',
        'id-MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst',
        'id-multicarrier-number',
        'id-Extended-HS-SCCH-ID',
        'id-Extended-HS-SICH-ID',
        'id-HSSICH-InfoExt-DM-Rqst',
        'id-Delete-From-HS-SCCH-Resource-PoolExt-PSCH-ReconfRqst',
        'id-HS-SCCH-InformationExt-LCR-PSCH-ReconfRqst',
        'id-HS-SCCH-InformationModifyExt-LCR-PSCH-ReconfRqst',
        'id-PowerControlGAP',
        'id-MBSFN-SpecialTimeSlot-LCR',
        'id-Common-MACFlows-to-DeleteFDD',
        'id-Paging-MACFlows-to-DeleteFDD',
        'id-E-TFCI-Boost-Information',
        'id-SixteenQAM-UL-Operation-Indicator',
        'id-SixtyfourQAM-UsageAllowedIndicator',
        'id-SixtyfourQAM-DL-UsageIndicator',
        'id-Default-Serving-Grant-in-DTX-Cycle2',
        'id-Maximum-Target-ReceivedTotalWideBandPower-LCR',
        'id-E-DPDCH-PowerInterpolation',
        'id-Extended-E-DCH-LCRTDD-PhysicalLayerCategory',
        'id-MultipleFreq-E-DCH-Resources-InformationList-AuditRsp',
        'id-MultipleFreq-E-DCH-Resources-InformationList-ResourceStatusInd',
        'id-MultipleFreq-E-PUCH-Timeslot-InformationList-LCR-PSCH-ReconfRqst',
        'id-MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst',
        'id-Extended-E-HICH-ID-TDD',
        'id-ContinuousPacketConnectivityHS-SCCH-less-Deactivate-Indicator',
        'id-E-DCH-MACdPDU-SizeCapability',
        'id-E-DCH-MACdPDUSizeFormat',
        'id-MaximumNumber-Of-Retransmission-for-Scheduling-Info-LCRTDD',
        'id-E-DCH-RetransmissionTimer-for-SchedulingInfo-LCRTDD',
        'id-E-HICH-TimeOffset-Extension',
        'id-MultipleFreq-E-HICH-TimeOffsetLCR',
        'id-E-PUCH-PowerControlGAP',
        'id-HSDSCH-TBSizeTableIndicator',
        'id-E-DCH-DL-Control-Channel-Change-Information',
        'id-E-DCH-DL-Control-Channel-Grant-Information',
        'id-DGANSS-Corrections-Req',
        'id-UE-with-enhanced-HS-SCCH-support-indicator',
        'id-AdditionalTimeSlotListLCR',
        'id-AdditionalMeasurementValueList',
        'id-E-AGCH-Table-Choice',
        'id-PLCCH-parameters',
        'id-E-RUCCH-parameters',
        'id-E-RUCCH-768-parameters',
        'id-HS-Cause',
        'id-E-Cause',
        'id-Common-EDCH-Capability',
        'id-E-AI-Capability',
        'id-Common-EDCH-System-InformationFDD',
        'id-Common-UL-MACFlows-to-DeleteFDD',
        'id-Common-EDCH-MACdFlows-to-DeleteFDD',
        'id-Common-EDCH-System-Information-ResponseFDD',
        'id-Cell-ERNTI-Status-Information',
        'id-Enhanced-UE-DRX-Capability',
        'id-Enhanced-UE-DRX-InformationFDD',
        'id-TransportBearerRequestIndicator',
        'id-SixtyfourQAM-DL-MIMO-Combined-Capability',
        'id-E-RNTI',
        'id-MinimumReducedE-DPDCH-GainFactor',
        'id-GANSS-Time-ID',
        'id-GANSS-AddIonoModelReq',
        'id-GANSS-EarthOrientParaReq',
        'id-GANSS-AddNavigationModelsReq',
        'id-GANSS-AddUTCModelsReq',
        'id-GANSS-AuxInfoReq',
        'id-GANSS-SBAS-ID',
        'id-GANSS-ID',
        'id-GANSS-Additional-Ionospheric-Model',
        'id-GANSS-Earth-Orientation-Parameters',
        'id-GANSS-Additional-Time-Models',
        'id-GANSS-Additional-Navigation-Models',
        'id-GANSS-Additional-UTC-Models',
        'id-GANSS-Auxiliary-Information',
        'id-ERACH-CM-Rqst',
        'id-ERACH-CM-Rsp',
        'id-ERACH-CM-Rprt',
        'id-EDCH-RACH-Report-Value',
        'id-EDCH-RACH-Report-IncrDecrThres',
        'id-EDCH-RACH-Report-ThresholdInformation',
        'id-E-DPCCH-Power-Boosting-Capability',
        'id-HSDSCH-Common-System-InformationLCR',
        'id-HSDSCH-Common-System-Information-ResponseLCR',
        'id-HSDSCH-Paging-System-InformationLCR',
        'id-HSDSCH-Paging-System-Information-ResponseLCR',
        'id-Common-MACFlows-to-DeleteLCR',
        'id-Paging-MACFlows-to-DeleteLCR',
        'id-Common-EDCH-System-InformationLCR',
        'id-Common-UL-MACFlows-to-DeleteLCR',
        'id-Common-EDCH-MACdFlows-to-DeleteLCR',
        'id-Common-EDCH-System-Information-ResponseLCR',
        'id-Enhanced-UE-DRX-CapabilityLCR',
        'id-Enhanced-UE-DRX-InformationLCR',
        'id-HSDSCH-PreconfigurationSetup',
        'id-HSDSCH-PreconfigurationInfo',
        'id-NoOfTargetCellHS-SCCH-Order',
        'id-EnhancedHSServingCC-Abort',
        'id-Additional-HS-Cell-Information-RL-Setup',
        'id-Additional-HS-Cell-Information-Response',
        'id-Additional-HS-Cell-Information-RL-Addition',
        'id-Additional-HS-Cell-Change-Information-Response',
        'id-Additional-HS-Cell-Information-RL-Reconf-Prep',
        'id-Additional-HS-Cell-Information-RL-Reconf-Req',
        'id-Additional-HS-Cell-Information-RL-Param-Upd',
        'id-Multi-Cell-Capability-Info',
        'id-IMB-Parameters',
        'id-MACes-Maximum-Bitrate-LCR',
        'id-Semi-PersistentScheduling-CapabilityLCR',
        'id-E-DCH-Semi-PersistentScheduling-Information-LCR',
        'id-HS-DSCH-Semi-PersistentScheduling-Information-LCR',
        'id-Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'id-ContinuousPacketConnectivity-DRX-CapabilityLCR',
        'id-ContinuousPacketConnectivity-DRX-InformationLCR',
        'id-ContinuousPacketConnectivity-DRX-Information-ResponseLCR',
        'id-CPC-InformationLCR',
        'id-HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR',
        'id-E-DCH-Semi-PersistentScheduling-Information-ResponseLCR',
        'id-E-AGCH-UE-Inactivity-Monitor-Threshold',
        'id-IdleIntervalInformation',
        'id-GANSS-alm-keplerianNAVAlmanac',
        'id-GANSS-alm-keplerianReducedAlmanac',
        'id-GANSS-alm-keplerianMidiAlmanac',
        'id-GANSS-alm-keplerianGLONASS',
        'id-GANSS-alm-ecefSBASAlmanac',
        'id-HSSICH-ReferenceSignal-InformationLCR',
        'id-MIMO-ReferenceSignal-InformationListLCR',
        'id-MIMO-SFMode-For-HSPDSCHDualStream',
        'id-MIMO-SFMode-Supported-For-HSPDSCHDualStream',
        'id-UE-Selected-MBMS-Service-Information',
        'id-MultiCarrier-HSDSCH-Physical-Layer-Category',
        'id-Common-E-DCH-HSDPCCH-Capability',
        'id-DL-RLC-PDU-Size-Format',
        'id-HSSICH-ReferenceSignal-InformationModifyLCR',
        'id-schedulingPriorityIndicator',
        'id-TimeSlotMeasurementValueListLCR',
        'id-UE-SupportIndicatorExtension',
        'id-Single-Stream-MIMO-ActivationIndicator',
        'id-Single-Stream-MIMO-Capability',
        'id-Single-Stream-MIMO-Mode-Indicator',
        'id-Dual-Band-Capability-Info',
        'id-UE-AggregateMaximumBitRate',
        'id-UE-AggregateMaximumBitRate-Enforcement-Indicator',
        'id-MIMO-Power-Offset-For-S-CPICH-Capability',
        'id-MIMO-PilotConfigurationExtension',
        'id-TxDiversityOnDLControlChannelsByMIMOUECapability',
        'id-ULTimeslotISCPValue-For-CellPortion',
        'id-UpPTSInterferenceValue-For-CellPortion',
        'id-Best-Cell-Portions-ValueLCR',
        'id-Transmitted-Carrier-Power-For-CellPortion-ValueLCR',
        'id-Received-total-wide-band-power-For-CellPortion-ValueLCR',
        'id-UL-TimeslotISCP-For-CellPortion-Value',
        'id-HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR',
        'id-HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR',
        'id-E-DCHProvidedBitRateValueInformation-For-CellPortion',
        'id-UpPTSInterference-For-CellPortion-Value',
        'id-NumberOfReportedCellPortionsLCR',
        'id-CellPortion-CapabilityLCR',
        'id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue',
        'id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortion',
        'id-ActivationInformation',
        'id-Additional-EDCH-Cell-Information-RL-Setup-Req',
        'id-Additional-EDCH-Cell-Information-Response',
        'id-Additional-EDCH-Cell-Information-RL-Add-Req',
        'id-Additional-EDCH-Cell-Information-Response-RL-Add',
        'id-Additional-EDCH-Cell-Information-RL-Reconf-Prep',
        'id-Additional-EDCH-Cell-Information-RL-Reconf-Req',
        'id-Additional-EDCH-Cell-Information-Bearer-Rearrangement',
        'id-Additional-EDCH-Cell-Information-RL-Param-Upd',
        'id-Additional-EDCH-Preconfiguration-Information',
        'id-EDCH-Indicator',
        'id-HS-DSCH-SPS-Reservation-Indicator',
        'id-E-DCH-SPS-Reservation-Indicator',
        'id-MultipleFreq-HARQ-MemoryPartitioning-InformationList',
        'id-Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR-Ext',
        'id-RepetitionPeriodIndex',
        'id-MidambleShiftLCR',
        'id-MaxHSDSCH-HSSCCH-Power-per-CELLPORTION',
        'id-DormantModeIndicator',
        'id-DiversityMode',
        'id-TransmitDiversityIndicator',
        'id-NonCellSpecificTxDiversity',
        'id-Cell-Capability-Container',
        'id-E-RNTI-List-Request',
        'id-E-RNTI-List',
        'id-PowerControlGAP-For-CellFACHLCR',
        'id-UL-Synchronisation-Parameters-For-FACHLCR',
        'id-HS-DSCH-SPS-Operation-Indicator',
        'id-HSDSCH-RNTI-For-FACH',
        'id-E-RNTI-For-FACH',
        'id-Out-of-Sychronization-Window',
        'id-Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst',
        'id-E-HICH-TimeOffset-ReconfFailureTDD',
        'id-HSSCCH-TPC-StepSize',
        'id-TS0-CapabilityLCR',
        'id-UE-TS0-CapabilityLCR',
        'id-Common-System-Information-ResponseLCR',
        'id-Additional-EDCH-Cell-Information-ResponseRLReconf',
        'id-Multicell-EDCH-InformationItemIEs',
        'id-Multicell-EDCH-RL-Specific-InformationItemIEs',
        'id-Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext',
        'id-Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext',
        'id-Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext',
        'id-Initial-DL-Transmission-Power',
        'id-Maximum-DL-Power',
        'id-Minimum-DL-Power',
        'id-DCH-MeasurementOccasion-Information',
        'id-AssociatedPhsicalChannelID',
        'id-DGNSS-ValidityPeriod',
        'id-PhysicalChannelID-for-CommonERNTI-RequestedIndicator',
        'id-PrecodingWeightSetRestriction',
        'id-Treset-Usage-Indicator',
        'id-Non-Serving-RL-Preconfig-Info',
        'id-Non-Serving-RL-Preconfig-Setup',
        'id-Non-Serving-RL-Preconfig-Removal',
        'id-Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup',
        'id-Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList',
        'id-Ul-common-E-DCH-MACflow-Specific-InfoListLCR-Ext',
        'id-CommonMACFlow-Specific-InfoList-ResponseLCR-Ext',
        'id-Enabling-Delay-Ext-LCR',
        'id-OrdinalNumberOfFrequency',
        'id-Multicell-EDCH-Restriction',
        'id-completeAlmanacProvided',
        'id-ganss-Delta-T',
        'id-Cell-Capability-Container-TDD-LCR',
        'id-Multi-Carrier-EDCH-Setup',
        'id-Multi-Carrier-EDCH-Reconfigure',
        'id-Multi-Carrier-EDCH-Response',
        'id-SNPL-Carrier-Group-Indicator',
        'id-MU-MIMO-Capability-ContainerLCR',
        'id-MU-MIMO-InformationLCR',
        'id-MU-MIMO-Information-Response',
        'id-MU-MIMO-Information-To-ReconfigureLCR',
        'id-HS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext',
        'id-Adaptive-Special-Burst-Power-CapabilityLCR',
        'id-Usefulness-Of-Battery-Optimization',
        'id-Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory',
        'id-Common-HSDSCH-RNTI-List',
        'id-CommonEDCH-AdditionalTransmissionBackOff',
        'id-In-Sync-Information-LCR',
        'id-Puncturing-Handling-in-First-Rate-Matching-Stage',
        'id-ERNTI-Release-Status',
        'id-UE-Status-Update-Confirm-Indicator',
        'id-Max-RTWP-perCellPortion-InformationList-LCR-PSCH-ReconfRqst',
        'id-AOA-per-CELL-Portion-LCR',
        'id-UL-CLTD-Information',
        'id-UL-CLTD-Information-Reconf',
        'id-UL-CLTD-State-Update-Information',
        'id-Affected-HSDSCH-Serving-Cell-List',
        'id-Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order',
        'id-CPC-RecoveryReport',
        'id-FTPICH-Information',
        'id-FTPICH-Information-Reconf',
        'id-UE-RF-Band-CapabilityLCR',
        'id-E-AGCH-PowerOffset',
        'id-E-RGCH-PowerOffset',
        'id-E-HICH-PowerOffset',
        'id-UE-transmission-power-headroom',
        'id-MIMO-withfourtransmitantennas-ActivationIndicator',
        'id-MIMO-withfourtransmitantennas-Mode-Indicator',
        'id-MIMO-withfourtransmitantennas-PilotConfiguration',
        'id-DualStream-MIMO-withfourtransmitantennas-ActivationIndicator',
        'id-DualStream-MIMO-withfourtransmitantennas-Mode-Indicator',
        'id-UL-MIMO-Information',
        'id-UL-MIMO-Reconfiguration',
        'id-UL-MIMO-DL-Control-Channel-Information',
        'id-SixtyfourQAM-UL-Operation-Indicator',
        'id-Common-E-DCH-Implicit-Release-Timer',
        'id-Multiflow-Information',
        'id-Multiflow-Reconfiguration',
        'id-Multiflow-OrdinalNumberOfFrequency',
        'id-Concurrent-Deployment-of-2msand10ms-TTI',
        'id-Common-EDH-Preamble-Control-Information-extension-Type1',
        'id-Common-EDH-Preamble-Control-Information-extension-Type2',
        'id-Common-EDH-Preamble-Control-Information-extension-Type3',
        'id-NodeB-Triggered-HSDPCCH-Transmission-Information',
        'id-Per-HARQ-Activiation-and-Deactiviation',
        'id-Coffset',
        'id-Common-E-DCH-MAC-d-flow-info-Concurrent-TTI',
        'id-Serving-Grant-Value-for-Concurrent-Deployment-of-2msand10ms-TTI',
        'id-Two-ms-Grant-E-DCH-RACH-Resources',
        'id-Two-ms-Overridden-E-DCH-RACH-Resources',
        'id-Two-ms-Denied-E-DCH-RACH-Resources',
        'id-Further-Enhanced-UE-DRX-InformationFDD',
        'id-Common-E-RGCH-Operation-Indicator',
        'id-Common-E-RGCH-InfoFDD',
        'id-PrecoderWeightSetRestriction',
        'id-Non-rectangular-resource-allocation-indicator',
        'id-Non-rectangular-resource-timeslot-set',
        'id-UE-Support-of-non-rectangular-resource-allocation',
        'id-DBDS-CorrectionsReq',
        'id-DBDS-Corrections',
        'id-BDS-IonosphericGridModelReq',
        'id-BDS-Ionospheric-Grid-Model',
        'id-GANSS-alm-keplerianBDSAlmanac',
        'id-Assisting-RepetitionFactors',
        'id-UE-Measurement-Forwarding',
        'id-UPH-Filtering-Measurement-Forwarding-Request',
        'id-TTI-Update-Indicator',
        'id-CQI-Feedback-Cycle2',
        'id-CQI-Cycle-Switch-Timer',
        'id-UE-DRX-Cycle2',
        'id-Inactivity-Threshold-for-UE-DRX-Cycle2',
        'id-DTX-Information2',
        'id-BCH-Parameters',
        'id-BCH-Parameters-CTCH-SetupRsp',
        'id-BCH-Parameters-CTCH-ReconfRqstFDD',
        'id-BCH-mappedOnSCCPCH-Indication',
        'id-DCH-ENH-Information',
        'id-DCH-ENH-Information-Reconf',
        'id-Gainfactors-10ms-mode',
        'id-E-DCH-Decoupling-Indication',
        'id-Radio-Links-without-DPCH-FDPCH-Indication',
        'id-UL-DPCCH2-Information',
        'id-UL-DPCCH2-Information-Reconf',
        'id-ImplicitGrantHandling',
        'id-MinimumTEBSthreshold',
        'id-ActivationDelay',
        'id-Fast-TTI-switching-Mode-synchronized',
        'id-Fast-TTI-switching-Mode-unsynchronized',
        'id-Fast-TTI-switching-Mode-Supported',
        'id-Dual-Band-EDCH-Capability',
        'id-Improved-Synchronized-Indicator',
        'id-Downlink-TPC-enhancements-Information',
        'id-Downlink-TPC-enhancements-Reconf',
        'id-TPC-slot-position',
        'id-E-RNTI-Set',
        'id-DL-TBS',
        'id-Dual-Cell-EDCH-Enhancements-Information',
        'id-HS-SCCH-DRX-InformationFDD',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-audit >-----#
    id_audit = INT(name='id-audit', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_audit._val = 0
    
    #-----< id-auditRequired >-----#
    id_auditRequired = INT(name='id-auditRequired', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_auditRequired._val = 1
    
    #-----< id-blockResource >-----#
    id_blockResource = INT(name='id-blockResource', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_blockResource._val = 2
    
    #-----< id-cellDeletion >-----#
    id_cellDeletion = INT(name='id-cellDeletion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_cellDeletion._val = 3
    
    #-----< id-cellReconfiguration >-----#
    id_cellReconfiguration = INT(name='id-cellReconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_cellReconfiguration._val = 4
    
    #-----< id-cellSetup >-----#
    id_cellSetup = INT(name='id-cellSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_cellSetup._val = 5
    
    #-----< id-cellSynchronisationInitiation >-----#
    id_cellSynchronisationInitiation = INT(name='id-cellSynchronisationInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_cellSynchronisationInitiation._val = 45
    
    #-----< id-cellSynchronisationReconfiguration >-----#
    id_cellSynchronisationReconfiguration = INT(name='id-cellSynchronisationReconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_cellSynchronisationReconfiguration._val = 46
    
    #-----< id-cellSynchronisationReporting >-----#
    id_cellSynchronisationReporting = INT(name='id-cellSynchronisationReporting', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_cellSynchronisationReporting._val = 47
    
    #-----< id-cellSynchronisationTermination >-----#
    id_cellSynchronisationTermination = INT(name='id-cellSynchronisationTermination', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_cellSynchronisationTermination._val = 48
    
    #-----< id-cellSynchronisationFailure >-----#
    id_cellSynchronisationFailure = INT(name='id-cellSynchronisationFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_cellSynchronisationFailure._val = 49
    
    #-----< id-commonMeasurementFailure >-----#
    id_commonMeasurementFailure = INT(name='id-commonMeasurementFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_commonMeasurementFailure._val = 6
    
    #-----< id-commonMeasurementInitiation >-----#
    id_commonMeasurementInitiation = INT(name='id-commonMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_commonMeasurementInitiation._val = 7
    
    #-----< id-commonMeasurementReport >-----#
    id_commonMeasurementReport = INT(name='id-commonMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_commonMeasurementReport._val = 8
    
    #-----< id-commonMeasurementTermination >-----#
    id_commonMeasurementTermination = INT(name='id-commonMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_commonMeasurementTermination._val = 9
    
    #-----< id-commonTransportChannelDelete >-----#
    id_commonTransportChannelDelete = INT(name='id-commonTransportChannelDelete', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_commonTransportChannelDelete._val = 10
    
    #-----< id-commonTransportChannelReconfigure >-----#
    id_commonTransportChannelReconfigure = INT(name='id-commonTransportChannelReconfigure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_commonTransportChannelReconfigure._val = 11
    
    #-----< id-commonTransportChannelSetup >-----#
    id_commonTransportChannelSetup = INT(name='id-commonTransportChannelSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_commonTransportChannelSetup._val = 12
    
    #-----< id-compressedModeCommand >-----#
    id_compressedModeCommand = INT(name='id-compressedModeCommand', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_compressedModeCommand._val = 14
    
    #-----< id-dedicatedMeasurementFailure >-----#
    id_dedicatedMeasurementFailure = INT(name='id-dedicatedMeasurementFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_dedicatedMeasurementFailure._val = 16
    
    #-----< id-dedicatedMeasurementInitiation >-----#
    id_dedicatedMeasurementInitiation = INT(name='id-dedicatedMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_dedicatedMeasurementInitiation._val = 17
    
    #-----< id-dedicatedMeasurementReport >-----#
    id_dedicatedMeasurementReport = INT(name='id-dedicatedMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_dedicatedMeasurementReport._val = 18
    
    #-----< id-dedicatedMeasurementTermination >-----#
    id_dedicatedMeasurementTermination = INT(name='id-dedicatedMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_dedicatedMeasurementTermination._val = 19
    
    #-----< id-downlinkPowerControl >-----#
    id_downlinkPowerControl = INT(name='id-downlinkPowerControl', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_downlinkPowerControl._val = 20
    
    #-----< id-downlinkPowerTimeslotControl >-----#
    id_downlinkPowerTimeslotControl = INT(name='id-downlinkPowerTimeslotControl', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_downlinkPowerTimeslotControl._val = 38
    
    #-----< id-errorIndicationForCommon >-----#
    id_errorIndicationForCommon = INT(name='id-errorIndicationForCommon', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_errorIndicationForCommon._val = 35
    
    #-----< id-errorIndicationForDedicated >-----#
    id_errorIndicationForDedicated = INT(name='id-errorIndicationForDedicated', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_errorIndicationForDedicated._val = 21
    
    #-----< id-informationExchangeFailure >-----#
    id_informationExchangeFailure = INT(name='id-informationExchangeFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_informationExchangeFailure._val = 40
    
    #-----< id-informationExchangeInitiation >-----#
    id_informationExchangeInitiation = INT(name='id-informationExchangeInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_informationExchangeInitiation._val = 41
    
    #-----< id-informationExchangeTermination >-----#
    id_informationExchangeTermination = INT(name='id-informationExchangeTermination', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_informationExchangeTermination._val = 42
    
    #-----< id-informationReporting >-----#
    id_informationReporting = INT(name='id-informationReporting', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_informationReporting._val = 43
    
    #-----< id-BearerRearrangement >-----#
    id_BearerRearrangement = INT(name='id-BearerRearrangement', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_BearerRearrangement._val = 50
    
    #-----< id-mBMSNotificationUpdate >-----#
    id_mBMSNotificationUpdate = INT(name='id-mBMSNotificationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_mBMSNotificationUpdate._val = 53
    
    #-----< id-physicalSharedChannelReconfiguration >-----#
    id_physicalSharedChannelReconfiguration = INT(name='id-physicalSharedChannelReconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_physicalSharedChannelReconfiguration._val = 37
    
    #-----< id-privateMessageForCommon >-----#
    id_privateMessageForCommon = INT(name='id-privateMessageForCommon', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_privateMessageForCommon._val = 36
    
    #-----< id-privateMessageForDedicated >-----#
    id_privateMessageForDedicated = INT(name='id-privateMessageForDedicated', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_privateMessageForDedicated._val = 22
    
    #-----< id-radioLinkAddition >-----#
    id_radioLinkAddition = INT(name='id-radioLinkAddition', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkAddition._val = 23
    
    #-----< id-radioLinkDeletion >-----#
    id_radioLinkDeletion = INT(name='id-radioLinkDeletion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkDeletion._val = 24
    
    #-----< id-radioLinkFailure >-----#
    id_radioLinkFailure = INT(name='id-radioLinkFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkFailure._val = 25
    
    #-----< id-radioLinkPreemption >-----#
    id_radioLinkPreemption = INT(name='id-radioLinkPreemption', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkPreemption._val = 39
    
    #-----< id-radioLinkRestoration >-----#
    id_radioLinkRestoration = INT(name='id-radioLinkRestoration', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkRestoration._val = 26
    
    #-----< id-radioLinkSetup >-----#
    id_radioLinkSetup = INT(name='id-radioLinkSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkSetup._val = 27
    
    #-----< id-reset >-----#
    id_reset = INT(name='id-reset', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_reset._val = 13
    
    #-----< id-resourceStatusIndication >-----#
    id_resourceStatusIndication = INT(name='id-resourceStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_resourceStatusIndication._val = 28
    
    #-----< id-cellSynchronisationAdjustment >-----#
    id_cellSynchronisationAdjustment = INT(name='id-cellSynchronisationAdjustment', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_cellSynchronisationAdjustment._val = 44
    
    #-----< id-synchronisedRadioLinkReconfigurationCancellation >-----#
    id_synchronisedRadioLinkReconfigurationCancellation = INT(name='id-synchronisedRadioLinkReconfigurationCancellation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_synchronisedRadioLinkReconfigurationCancellation._val = 29
    
    #-----< id-synchronisedRadioLinkReconfigurationCommit >-----#
    id_synchronisedRadioLinkReconfigurationCommit = INT(name='id-synchronisedRadioLinkReconfigurationCommit', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_synchronisedRadioLinkReconfigurationCommit._val = 30
    
    #-----< id-synchronisedRadioLinkReconfigurationPreparation >-----#
    id_synchronisedRadioLinkReconfigurationPreparation = INT(name='id-synchronisedRadioLinkReconfigurationPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_synchronisedRadioLinkReconfigurationPreparation._val = 31
    
    #-----< id-systemInformationUpdate >-----#
    id_systemInformationUpdate = INT(name='id-systemInformationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_systemInformationUpdate._val = 32
    
    #-----< id-unblockResource >-----#
    id_unblockResource = INT(name='id-unblockResource', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_unblockResource._val = 33
    
    #-----< id-unSynchronisedRadioLinkReconfiguration >-----#
    id_unSynchronisedRadioLinkReconfiguration = INT(name='id-unSynchronisedRadioLinkReconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_unSynchronisedRadioLinkReconfiguration._val = 34
    
    #-----< id-radioLinkActivation >-----#
    id_radioLinkActivation = INT(name='id-radioLinkActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkActivation._val = 51
    
    #-----< id-radioLinkParameterUpdate >-----#
    id_radioLinkParameterUpdate = INT(name='id-radioLinkParameterUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkParameterUpdate._val = 52
    
    #-----< id-uEStatusUpdate >-----#
    id_uEStatusUpdate = INT(name='id-uEStatusUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_uEStatusUpdate._val = 54
    
    #-----< id-secondaryULFrequencyReporting >-----#
    id_secondaryULFrequencyReporting = INT(name='id-secondaryULFrequencyReporting', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_secondaryULFrequencyReporting._val = 55
    
    #-----< id-secondaryULFrequencyUpdate >-----#
    id_secondaryULFrequencyUpdate = INT(name='id-secondaryULFrequencyUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_secondaryULFrequencyUpdate._val = 56
    
    #-----< id-uEStatusUpdateConfirmation >-----#
    id_uEStatusUpdateConfirmation = INT(name='id-uEStatusUpdateConfirmation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureCode')))
    id_uEStatusUpdateConfirmation._val = 57
    
    #-----< maxNrOfCodes >-----#
    maxNrOfCodes = INT(name='maxNrOfCodes', mode=MODE_VALUE)
    maxNrOfCodes._val = 10
    
    #-----< maxNrOfDLTSs >-----#
    maxNrOfDLTSs = INT(name='maxNrOfDLTSs', mode=MODE_VALUE)
    maxNrOfDLTSs._val = 15
    
    #-----< maxNrOfDLTSLCRs >-----#
    maxNrOfDLTSLCRs = INT(name='maxNrOfDLTSLCRs', mode=MODE_VALUE)
    maxNrOfDLTSLCRs._val = 6
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name='maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< maxNrOfTFs >-----#
    maxNrOfTFs = INT(name='maxNrOfTFs', mode=MODE_VALUE)
    maxNrOfTFs._val = 32
    
    #-----< maxNrOfTFCs >-----#
    maxNrOfTFCs = INT(name='maxNrOfTFCs', mode=MODE_VALUE)
    maxNrOfTFCs._val = 1024
    
    #-----< maxNrOfRLs >-----#
    maxNrOfRLs = INT(name='maxNrOfRLs', mode=MODE_VALUE)
    maxNrOfRLs._val = 16
    
    #-----< maxNrOfRLs-1 >-----#
    maxNrOfRLs_1 = INT(name='maxNrOfRLs-1', mode=MODE_VALUE)
    maxNrOfRLs_1._val = 15
    
    #-----< maxNrOfRLs-2 >-----#
    maxNrOfRLs_2 = INT(name='maxNrOfRLs-2', mode=MODE_VALUE)
    maxNrOfRLs_2._val = 14
    
    #-----< maxNrOfRLSets >-----#
    maxNrOfRLSets = INT(name='maxNrOfRLSets', mode=MODE_VALUE)
    maxNrOfRLSets._val = 16
    
    #-----< maxNrOfDPCHs >-----#
    maxNrOfDPCHs = INT(name='maxNrOfDPCHs', mode=MODE_VALUE)
    maxNrOfDPCHs._val = 240
    
    #-----< maxNrOfDPCHsPerRL-1 >-----#
    maxNrOfDPCHsPerRL_1 = INT(name='maxNrOfDPCHsPerRL-1', mode=MODE_VALUE)
    maxNrOfDPCHsPerRL_1._val = 239
    
    #-----< maxNrOfDPCHLCRs >-----#
    maxNrOfDPCHLCRs = INT(name='maxNrOfDPCHLCRs', mode=MODE_VALUE)
    maxNrOfDPCHLCRs._val = 240
    
    #-----< maxNrOfDPCHsLCRPerRL-1 >-----#
    maxNrOfDPCHsLCRPerRL_1 = INT(name='maxNrOfDPCHsLCRPerRL-1', mode=MODE_VALUE)
    maxNrOfDPCHsLCRPerRL_1._val = 95
    
    #-----< maxNrOfDPCHs768 >-----#
    maxNrOfDPCHs768 = INT(name='maxNrOfDPCHs768', mode=MODE_VALUE)
    maxNrOfDPCHs768._val = 480
    
    #-----< maxNrOfDPCHs768PerRL-1 >-----#
    maxNrOfDPCHs768PerRL_1 = INT(name='maxNrOfDPCHs768PerRL-1', mode=MODE_VALUE)
    maxNrOfDPCHs768PerRL_1._val = 479
    
    #-----< maxNrOfSCCPCHs >-----#
    maxNrOfSCCPCHs = INT(name='maxNrOfSCCPCHs', mode=MODE_VALUE)
    maxNrOfSCCPCHs._val = 8
    
    #-----< maxNrOfSCCPCHsinExt >-----#
    maxNrOfSCCPCHsinExt = INT(name='maxNrOfSCCPCHsinExt', mode=MODE_VALUE)
    maxNrOfSCCPCHsinExt._val = 232
    
    #-----< maxNrOfSCCPCHs768 >-----#
    maxNrOfSCCPCHs768 = INT(name='maxNrOfSCCPCHs768', mode=MODE_VALUE)
    maxNrOfSCCPCHs768._val = 480
    
    #-----< maxNrOfDCHs >-----#
    maxNrOfDCHs = INT(name='maxNrOfDCHs', mode=MODE_VALUE)
    maxNrOfDCHs._val = 128
    
    #-----< maxNrOfDSCHs >-----#
    maxNrOfDSCHs = INT(name='maxNrOfDSCHs', mode=MODE_VALUE)
    maxNrOfDSCHs._val = 32
    
    #-----< maxNrOfFACHs >-----#
    maxNrOfFACHs = INT(name='maxNrOfFACHs', mode=MODE_VALUE)
    maxNrOfFACHs._val = 8
    
    #-----< maxNrOfCCTrCHs >-----#
    maxNrOfCCTrCHs = INT(name='maxNrOfCCTrCHs', mode=MODE_VALUE)
    maxNrOfCCTrCHs._val = 16
    
    #-----< maxNrOfPDSCHs >-----#
    maxNrOfPDSCHs = INT(name='maxNrOfPDSCHs', mode=MODE_VALUE)
    maxNrOfPDSCHs._val = 256
    
    #-----< maxNrOfHSPDSCHs >-----#
    maxNrOfHSPDSCHs = INT(name='maxNrOfHSPDSCHs', mode=MODE_VALUE)
    maxNrOfHSPDSCHs._val = 16
    
    #-----< maxNrOfHSPDSCHs768 >-----#
    maxNrOfHSPDSCHs768 = INT(name='maxNrOfHSPDSCHs768', mode=MODE_VALUE)
    maxNrOfHSPDSCHs768._val = 32
    
    #-----< maxNrOfPUSCHs >-----#
    maxNrOfPUSCHs = INT(name='maxNrOfPUSCHs', mode=MODE_VALUE)
    maxNrOfPUSCHs._val = 256
    
    #-----< maxNrOfPUSCHs-1 >-----#
    maxNrOfPUSCHs_1 = INT(name='maxNrOfPUSCHs-1', mode=MODE_VALUE)
    maxNrOfPUSCHs_1._val = 255
    
    #-----< maxNrOfPDSCHSets >-----#
    maxNrOfPDSCHSets = INT(name='maxNrOfPDSCHSets', mode=MODE_VALUE)
    maxNrOfPDSCHSets._val = 256
    
    #-----< maxNrOfPRACHLCRs >-----#
    maxNrOfPRACHLCRs = INT(name='maxNrOfPRACHLCRs', mode=MODE_VALUE)
    maxNrOfPRACHLCRs._val = 8
    
    #-----< maxNrOfPUSCHSets >-----#
    maxNrOfPUSCHSets = INT(name='maxNrOfPUSCHSets', mode=MODE_VALUE)
    maxNrOfPUSCHSets._val = 256
    
    #-----< maxNrOfSCCPCHLCRs >-----#
    maxNrOfSCCPCHLCRs = INT(name='maxNrOfSCCPCHLCRs', mode=MODE_VALUE)
    maxNrOfSCCPCHLCRs._val = 8
    
    #-----< maxNrOfSCCPCHsLCRinExt >-----#
    maxNrOfSCCPCHsLCRinExt = INT(name='maxNrOfSCCPCHsLCRinExt', mode=MODE_VALUE)
    maxNrOfSCCPCHsLCRinExt._val = 88
    
    #-----< maxNrOfULTSs >-----#
    maxNrOfULTSs = INT(name='maxNrOfULTSs', mode=MODE_VALUE)
    maxNrOfULTSs._val = 15
    
    #-----< maxNrOfULTSLCRs >-----#
    maxNrOfULTSLCRs = INT(name='maxNrOfULTSLCRs', mode=MODE_VALUE)
    maxNrOfULTSLCRs._val = 6
    
    #-----< maxNrOfUSCHs >-----#
    maxNrOfUSCHs = INT(name='maxNrOfUSCHs', mode=MODE_VALUE)
    maxNrOfUSCHs._val = 32
    
    #-----< maxNrOfSlotFormatsPRACH >-----#
    maxNrOfSlotFormatsPRACH = INT(name='maxNrOfSlotFormatsPRACH', mode=MODE_VALUE)
    maxNrOfSlotFormatsPRACH._val = 8
    
    #-----< maxCellinNodeB >-----#
    maxCellinNodeB = INT(name='maxCellinNodeB', mode=MODE_VALUE)
    maxCellinNodeB._val = 256
    
    #-----< maxCCPinNodeB >-----#
    maxCCPinNodeB = INT(name='maxCCPinNodeB', mode=MODE_VALUE)
    maxCCPinNodeB._val = 256
    
    #-----< maxCTFC >-----#
    maxCTFC = INT(name='maxCTFC', mode=MODE_VALUE)
    maxCTFC._val = 16777215
    
    #-----< maxLocalCellinNodeB >-----#
    maxLocalCellinNodeB = INT(name='maxLocalCellinNodeB', mode=MODE_VALUE)
    maxLocalCellinNodeB._val = 256
    
    #-----< maxFPACHCell >-----#
    maxFPACHCell = INT(name='maxFPACHCell', mode=MODE_VALUE)
    maxFPACHCell._val = 8
    
    #-----< maxRACHCell >-----#
    maxRACHCell = INT(name='maxRACHCell', mode=MODE_VALUE)
    maxRACHCell._val = 16
    
    #-----< maxPLCCHCell >-----#
    maxPLCCHCell = INT(name='maxPLCCHCell', mode=MODE_VALUE)
    maxPLCCHCell._val = 16
    
    #-----< maxPRACHCell >-----#
    maxPRACHCell = INT(name='maxPRACHCell', mode=MODE_VALUE)
    maxPRACHCell._val = 16
    
    #-----< maxSCCPCHCell >-----#
    maxSCCPCHCell = INT(name='maxSCCPCHCell', mode=MODE_VALUE)
    maxSCCPCHCell._val = 32
    
    #-----< maxSCCPCHCellinExt >-----#
    maxSCCPCHCellinExt = INT(name='maxSCCPCHCellinExt', mode=MODE_VALUE)
    maxSCCPCHCellinExt._val = 208
    
    #-----< maxSCCPCHCellinExtLCR >-----#
    maxSCCPCHCellinExtLCR = INT(name='maxSCCPCHCellinExtLCR', mode=MODE_VALUE)
    maxSCCPCHCellinExtLCR._val = 64
    
    #-----< maxSCCPCHCell768 >-----#
    maxSCCPCHCell768 = INT(name='maxSCCPCHCell768', mode=MODE_VALUE)
    maxSCCPCHCell768._val = 480
    
    #-----< maxSCPICHCell >-----#
    maxSCPICHCell = INT(name='maxSCPICHCell', mode=MODE_VALUE)
    maxSCPICHCell._val = 32
    
    #-----< maxTTI-count >-----#
    maxTTI_count = INT(name='maxTTI-count', mode=MODE_VALUE)
    maxTTI_count._val = 4
    
    #-----< maxIBSEG >-----#
    maxIBSEG = INT(name='maxIBSEG', mode=MODE_VALUE)
    maxIBSEG._val = 16
    
    #-----< maxIB >-----#
    maxIB = INT(name='maxIB', mode=MODE_VALUE)
    maxIB._val = 64
    
    #-----< maxFACHCell >-----#
    maxFACHCell = INT(name='maxFACHCell', mode=MODE_VALUE)
    maxFACHCell._val = 256
    
    #-----< maxRateMatching >-----#
    maxRateMatching = INT(name='maxRateMatching', mode=MODE_VALUE)
    maxRateMatching._val = 256
    
    #-----< maxHS-PDSCHCodeNrComp-1 >-----#
    maxHS_PDSCHCodeNrComp_1 = INT(name='maxHS-PDSCHCodeNrComp-1', mode=MODE_VALUE)
    maxHS_PDSCHCodeNrComp_1._val = 15
    
    #-----< maxHS-SCCHCodeNrComp-1 >-----#
    maxHS_SCCHCodeNrComp_1 = INT(name='maxHS-SCCHCodeNrComp-1', mode=MODE_VALUE)
    maxHS_SCCHCodeNrComp_1._val = 127
    
    #-----< maxNrOfCellSyncBursts >-----#
    maxNrOfCellSyncBursts = INT(name='maxNrOfCellSyncBursts', mode=MODE_VALUE)
    maxNrOfCellSyncBursts._val = 10
    
    #-----< maxNrOfReceptsPerSyncFrame >-----#
    maxNrOfReceptsPerSyncFrame = INT(name='maxNrOfReceptsPerSyncFrame', mode=MODE_VALUE)
    maxNrOfReceptsPerSyncFrame._val = 16
    
    #-----< maxNrOfMeasNCell >-----#
    maxNrOfMeasNCell = INT(name='maxNrOfMeasNCell', mode=MODE_VALUE)
    maxNrOfMeasNCell._val = 96
    
    #-----< maxNrOfMeasNCell-1 >-----#
    maxNrOfMeasNCell_1 = INT(name='maxNrOfMeasNCell-1', mode=MODE_VALUE)
    maxNrOfMeasNCell_1._val = 95
    
    #-----< maxNrOfSF >-----#
    maxNrOfSF = INT(name='maxNrOfSF', mode=MODE_VALUE)
    maxNrOfSF._val = 8
    
    #-----< maxTGPS >-----#
    maxTGPS = INT(name='maxTGPS', mode=MODE_VALUE)
    maxTGPS._val = 6
    
    #-----< maxCommunicationContext >-----#
    maxCommunicationContext = INT(name='maxCommunicationContext', mode=MODE_VALUE)
    maxCommunicationContext._val = 1048575
    
    #-----< maxNrOfLevels >-----#
    maxNrOfLevels = INT(name='maxNrOfLevels', mode=MODE_VALUE)
    maxNrOfLevels._val = 256
    
    #-----< maxNoSat >-----#
    maxNoSat = INT(name='maxNoSat', mode=MODE_VALUE)
    maxNoSat._val = 16
    
    #-----< maxNoGPSItems >-----#
    maxNoGPSItems = INT(name='maxNoGPSItems', mode=MODE_VALUE)
    maxNoGPSItems._val = 8
    
    #-----< maxNrOfHSSCCHs >-----#
    maxNrOfHSSCCHs = INT(name='maxNrOfHSSCCHs', mode=MODE_VALUE)
    maxNrOfHSSCCHs._val = 32
    
    #-----< maxNrOfHSSICHs >-----#
    maxNrOfHSSICHs = INT(name='maxNrOfHSSICHs', mode=MODE_VALUE)
    maxNrOfHSSICHs._val = 4
    
    #-----< maxNrOfHSSICHs-1 >-----#
    maxNrOfHSSICHs_1 = INT(name='maxNrOfHSSICHs-1', mode=MODE_VALUE)
    maxNrOfHSSICHs_1._val = 3
    
    #-----< maxNrOfSyncFramesLCR >-----#
    maxNrOfSyncFramesLCR = INT(name='maxNrOfSyncFramesLCR', mode=MODE_VALUE)
    maxNrOfSyncFramesLCR._val = 512
    
    #-----< maxNrOfReceptionsperSyncFrameLCR >-----#
    maxNrOfReceptionsperSyncFrameLCR = INT(name='maxNrOfReceptionsperSyncFrameLCR', mode=MODE_VALUE)
    maxNrOfReceptionsperSyncFrameLCR._val = 8
    
    #-----< maxNrOfSyncDLCodesLCR >-----#
    maxNrOfSyncDLCodesLCR = INT(name='maxNrOfSyncDLCodesLCR', mode=MODE_VALUE)
    maxNrOfSyncDLCodesLCR._val = 32
    
    #-----< maxNrOfHSSCCHCodes >-----#
    maxNrOfHSSCCHCodes = INT(name='maxNrOfHSSCCHCodes', mode=MODE_VALUE)
    maxNrOfHSSCCHCodes._val = 4
    
    #-----< maxNrOfMACdFlows >-----#
    maxNrOfMACdFlows = INT(name='maxNrOfMACdFlows', mode=MODE_VALUE)
    maxNrOfMACdFlows._val = 8
    
    #-----< maxNrOfMACdFlows-1 >-----#
    maxNrOfMACdFlows_1 = INT(name='maxNrOfMACdFlows-1', mode=MODE_VALUE)
    maxNrOfMACdFlows_1._val = 7
    
    #-----< maxNrOfMACdPDUIndexes >-----#
    maxNrOfMACdPDUIndexes = INT(name='maxNrOfMACdPDUIndexes', mode=MODE_VALUE)
    maxNrOfMACdPDUIndexes._val = 8
    
    #-----< maxNrOfMACdPDUIndexes-1 >-----#
    maxNrOfMACdPDUIndexes_1 = INT(name='maxNrOfMACdPDUIndexes-1', mode=MODE_VALUE)
    maxNrOfMACdPDUIndexes_1._val = 7
    
    #-----< maxNrOfMACdPDUSize >-----#
    maxNrOfMACdPDUSize = INT(name='maxNrOfMACdPDUSize', mode=MODE_VALUE)
    maxNrOfMACdPDUSize._val = 32
    
    #-----< maxNrOfNIs >-----#
    maxNrOfNIs = INT(name='maxNrOfNIs', mode=MODE_VALUE)
    maxNrOfNIs._val = 256
    
    #-----< maxNrOfPriorityQueues >-----#
    maxNrOfPriorityQueues = INT(name='maxNrOfPriorityQueues', mode=MODE_VALUE)
    maxNrOfPriorityQueues._val = 8
    
    #-----< maxNrOfPriorityQueues-1 >-----#
    maxNrOfPriorityQueues_1 = INT(name='maxNrOfPriorityQueues-1', mode=MODE_VALUE)
    maxNrOfPriorityQueues_1._val = 7
    
    #-----< maxNrOfHARQProcesses >-----#
    maxNrOfHARQProcesses = INT(name='maxNrOfHARQProcesses', mode=MODE_VALUE)
    maxNrOfHARQProcesses._val = 8
    
    #-----< maxNrOfContextsOnUeList >-----#
    maxNrOfContextsOnUeList = INT(name='maxNrOfContextsOnUeList', mode=MODE_VALUE)
    maxNrOfContextsOnUeList._val = 16
    
    #-----< maxNrOfCellPortionsPerCell >-----#
    maxNrOfCellPortionsPerCell = INT(name='maxNrOfCellPortionsPerCell', mode=MODE_VALUE)
    maxNrOfCellPortionsPerCell._val = 64
    
    #-----< maxNrOfCellPortionsPerCell-1 >-----#
    maxNrOfCellPortionsPerCell_1 = INT(name='maxNrOfCellPortionsPerCell-1', mode=MODE_VALUE)
    maxNrOfCellPortionsPerCell_1._val = 63
    
    #-----< maxNrOfPriorityClasses >-----#
    maxNrOfPriorityClasses = INT(name='maxNrOfPriorityClasses', mode=MODE_VALUE)
    maxNrOfPriorityClasses._val = 16
    
    #-----< maxNrOfSatAlmanac-maxNoSat >-----#
    maxNrOfSatAlmanac_maxNoSat = INT(name='maxNrOfSatAlmanac-maxNoSat', mode=MODE_VALUE)
    maxNrOfSatAlmanac_maxNoSat._val = 16
    
    #-----< maxNrOfE-AGCHs >-----#
    maxNrOfE_AGCHs = INT(name='maxNrOfE-AGCHs', mode=MODE_VALUE)
    maxNrOfE_AGCHs._val = 32
    
    #-----< maxNrOfEDCHMACdFlows >-----#
    maxNrOfEDCHMACdFlows = INT(name='maxNrOfEDCHMACdFlows', mode=MODE_VALUE)
    maxNrOfEDCHMACdFlows._val = 8
    
    #-----< maxNrOfEDCHMACdFlows-1 >-----#
    maxNrOfEDCHMACdFlows_1 = INT(name='maxNrOfEDCHMACdFlows-1', mode=MODE_VALUE)
    maxNrOfEDCHMACdFlows_1._val = 7
    
    #-----< maxNrOfE-RGCHs-E-HICHs >-----#
    maxNrOfE_RGCHs_E_HICHs = INT(name='maxNrOfE-RGCHs-E-HICHs', mode=MODE_VALUE)
    maxNrOfE_RGCHs_E_HICHs._val = 32
    
    #-----< maxNrOfEDCH-HARQ-PO-QUANTSTEPs >-----#
    maxNrOfEDCH_HARQ_PO_QUANTSTEPs = INT(name='maxNrOfEDCH-HARQ-PO-QUANTSTEPs', mode=MODE_VALUE)
    maxNrOfEDCH_HARQ_PO_QUANTSTEPs._val = 6
    
    #-----< maxNrOfEDCHHARQProcesses2msEDCH >-----#
    maxNrOfEDCHHARQProcesses2msEDCH = INT(name='maxNrOfEDCHHARQProcesses2msEDCH', mode=MODE_VALUE)
    maxNrOfEDCHHARQProcesses2msEDCH._val = 8
    
    #-----< maxNrOfEDPCCH-PO-QUANTSTEPs >-----#
    maxNrOfEDPCCH_PO_QUANTSTEPs = INT(name='maxNrOfEDPCCH-PO-QUANTSTEPs', mode=MODE_VALUE)
    maxNrOfEDPCCH_PO_QUANTSTEPs._val = 8
    
    #-----< maxNrOfBits-MACe-PDU-non-scheduled >-----#
    maxNrOfBits_MACe_PDU_non_scheduled = INT(name='maxNrOfBits-MACe-PDU-non-scheduled', mode=MODE_VALUE)
    maxNrOfBits_MACe_PDU_non_scheduled._val = 19982
    
    #-----< maxNrOfRefETFCIs >-----#
    maxNrOfRefETFCIs = INT(name='maxNrOfRefETFCIs', mode=MODE_VALUE)
    maxNrOfRefETFCIs._val = 8
    
    #-----< maxNrOfRefETFCI-PO-QUANTSTEPs >-----#
    maxNrOfRefETFCI_PO_QUANTSTEPs = INT(name='maxNrOfRefETFCI-PO-QUANTSTEPs', mode=MODE_VALUE)
    maxNrOfRefETFCI_PO_QUANTSTEPs._val = 29
    
    #-----< maxNrofSigSeqRGHI-1 >-----#
    maxNrofSigSeqRGHI_1 = INT(name='maxNrofSigSeqRGHI-1', mode=MODE_VALUE)
    maxNrofSigSeqRGHI_1._val = 39
    
    #-----< maxNoOfLogicalChannels >-----#
    maxNoOfLogicalChannels = INT(name='maxNoOfLogicalChannels', mode=MODE_VALUE)
    maxNoOfLogicalChannels._val = 16
    
    #-----< maxNrOfCombEDPDCH >-----#
    maxNrOfCombEDPDCH = INT(name='maxNrOfCombEDPDCH', mode=MODE_VALUE)
    maxNrOfCombEDPDCH._val = 12
    
    #-----< maxE-RUCCHCell >-----#
    maxE_RUCCHCell = INT(name='maxE-RUCCHCell', mode=MODE_VALUE)
    maxE_RUCCHCell._val = 16
    
    #-----< maxNrOfEAGCHCodes >-----#
    maxNrOfEAGCHCodes = INT(name='maxNrOfEAGCHCodes', mode=MODE_VALUE)
    maxNrOfEAGCHCodes._val = 4
    
    #-----< maxNrOfRefBetas >-----#
    maxNrOfRefBetas = INT(name='maxNrOfRefBetas', mode=MODE_VALUE)
    maxNrOfRefBetas._val = 8
    
    #-----< maxNrOfE-PUCHSlots >-----#
    maxNrOfE_PUCHSlots = INT(name='maxNrOfE-PUCHSlots', mode=MODE_VALUE)
    maxNrOfE_PUCHSlots._val = 13
    
    #-----< maxNrOfEAGCHs >-----#
    maxNrOfEAGCHs = INT(name='maxNrOfEAGCHs', mode=MODE_VALUE)
    maxNrOfEAGCHs._val = 32
    
    #-----< maxNrOfHS-DSCH-TBSs-HS-SCCHless >-----#
    maxNrOfHS_DSCH_TBSs_HS_SCCHless = INT(name='maxNrOfHS-DSCH-TBSs-HS-SCCHless', mode=MODE_VALUE)
    maxNrOfHS_DSCH_TBSs_HS_SCCHless._val = 4
    
    #-----< maxNrOfHS-DSCH-TBSs >-----#
    maxNrOfHS_DSCH_TBSs = INT(name='maxNrOfHS-DSCH-TBSs', mode=MODE_VALUE)
    maxNrOfHS_DSCH_TBSs._val = 90
    
    #-----< maxNrOfEHICHCodes >-----#
    maxNrOfEHICHCodes = INT(name='maxNrOfEHICHCodes', mode=MODE_VALUE)
    maxNrOfEHICHCodes._val = 4
    
    #-----< maxNrOfE-PUCHSlotsLCR >-----#
    maxNrOfE_PUCHSlotsLCR = INT(name='maxNrOfE-PUCHSlotsLCR', mode=MODE_VALUE)
    maxNrOfE_PUCHSlotsLCR._val = 5
    
    #-----< maxNrOfEPUCHcodes >-----#
    maxNrOfEPUCHcodes = INT(name='maxNrOfEPUCHcodes', mode=MODE_VALUE)
    maxNrOfEPUCHcodes._val = 16
    
    #-----< maxNrOfEHICHs >-----#
    maxNrOfEHICHs = INT(name='maxNrOfEHICHs', mode=MODE_VALUE)
    maxNrOfEHICHs._val = 32
    
    #-----< maxNrOfCommonMACFlows >-----#
    maxNrOfCommonMACFlows = INT(name='maxNrOfCommonMACFlows', mode=MODE_VALUE)
    maxNrOfCommonMACFlows._val = 8
    
    #-----< maxNrOfCommonMACFlows-1 >-----#
    maxNrOfCommonMACFlows_1 = INT(name='maxNrOfCommonMACFlows-1', mode=MODE_VALUE)
    maxNrOfCommonMACFlows_1._val = 7
    
    #-----< maxNrOfPagingMACFlow >-----#
    maxNrOfPagingMACFlow = INT(name='maxNrOfPagingMACFlow', mode=MODE_VALUE)
    maxNrOfPagingMACFlow._val = 4
    
    #-----< maxNrOfPagingMACFlow-1 >-----#
    maxNrOfPagingMACFlow_1 = INT(name='maxNrOfPagingMACFlow-1', mode=MODE_VALUE)
    maxNrOfPagingMACFlow_1._val = 3
    
    #-----< maxNrOfcommonMACQueues >-----#
    maxNrOfcommonMACQueues = INT(name='maxNrOfcommonMACQueues', mode=MODE_VALUE)
    maxNrOfcommonMACQueues._val = 8
    
    #-----< maxNrOfpagingMACQueues >-----#
    maxNrOfpagingMACQueues = INT(name='maxNrOfpagingMACQueues', mode=MODE_VALUE)
    maxNrOfpagingMACQueues._val = 8
    
    #-----< maxNrOfHS-DSCHTBSsE-PCH >-----#
    maxNrOfHS_DSCHTBSsE_PCH = INT(name='maxNrOfHS-DSCHTBSsE-PCH', mode=MODE_VALUE)
    maxNrOfHS_DSCHTBSsE_PCH._val = 2
    
    #-----< maxGANSSSat >-----#
    maxGANSSSat = INT(name='maxGANSSSat', mode=MODE_VALUE)
    maxGANSSSat._val = 64
    
    #-----< maxNoGANSS >-----#
    maxNoGANSS = INT(name='maxNoGANSS', mode=MODE_VALUE)
    maxNoGANSS._val = 8
    
    #-----< maxSgnType >-----#
    maxSgnType = INT(name='maxSgnType', mode=MODE_VALUE)
    maxSgnType._val = 8
    
    #-----< maxFrequencyinCell >-----#
    maxFrequencyinCell = INT(name='maxFrequencyinCell', mode=MODE_VALUE)
    maxFrequencyinCell._val = 12
    
    #-----< maxFrequencyinCell-1 >-----#
    maxFrequencyinCell_1 = INT(name='maxFrequencyinCell-1', mode=MODE_VALUE)
    maxFrequencyinCell_1._val = 11
    
    #-----< maxHSDPAFrequency >-----#
    maxHSDPAFrequency = INT(name='maxHSDPAFrequency', mode=MODE_VALUE)
    maxHSDPAFrequency._val = 8
    
    #-----< maxHSDPAFrequency-1 >-----#
    maxHSDPAFrequency_1 = INT(name='maxHSDPAFrequency-1', mode=MODE_VALUE)
    maxHSDPAFrequency_1._val = 7
    
    #-----< maxNrOfHSSCCHsinExt >-----#
    maxNrOfHSSCCHsinExt = INT(name='maxNrOfHSSCCHsinExt', mode=MODE_VALUE)
    maxNrOfHSSCCHsinExt._val = 224
    
    #-----< maxGANSSSatAlmanac >-----#
    maxGANSSSatAlmanac = INT(name='maxGANSSSatAlmanac', mode=MODE_VALUE)
    maxGANSSSatAlmanac._val = 36
    
    #-----< maxGANSSClockMod >-----#
    maxGANSSClockMod = INT(name='maxGANSSClockMod', mode=MODE_VALUE)
    maxGANSSClockMod._val = 4
    
    #-----< maxNrOfEDCHRLs >-----#
    maxNrOfEDCHRLs = INT(name='maxNrOfEDCHRLs', mode=MODE_VALUE)
    maxNrOfEDCHRLs._val = 4
    
    #-----< maxERNTItoRelease >-----#
    maxERNTItoRelease = INT(name='maxERNTItoRelease', mode=MODE_VALUE)
    maxERNTItoRelease._val = 256
    
    #-----< maxNrOfCommonEDCH >-----#
    maxNrOfCommonEDCH = INT(name='maxNrOfCommonEDCH', mode=MODE_VALUE)
    maxNrOfCommonEDCH._val = 32
    
    #-----< maxNrOfCommonHRNTI >-----#
    maxNrOfCommonHRNTI = INT(name='maxNrOfCommonHRNTI', mode=MODE_VALUE)
    maxNrOfCommonHRNTI._val = 4
    
    #-----< maxNrOfCommonMACFlowsLCR >-----#
    maxNrOfCommonMACFlowsLCR = INT(name='maxNrOfCommonMACFlowsLCR', mode=MODE_VALUE)
    maxNrOfCommonMACFlowsLCR._val = 256
    
    #-----< maxNrOfCommonMACFlowsLCR-1 >-----#
    maxNrOfCommonMACFlowsLCR_1 = INT(name='maxNrOfCommonMACFlowsLCR-1', mode=MODE_VALUE)
    maxNrOfCommonMACFlowsLCR_1._val = 255
    
    #-----< maxNrOfHSSCCHsLCR >-----#
    maxNrOfHSSCCHsLCR = INT(name='maxNrOfHSSCCHsLCR', mode=MODE_VALUE)
    maxNrOfHSSCCHsLCR._val = 256
    
    #-----< maxNrOfEDCHMACdFlowsLCR >-----#
    maxNrOfEDCHMACdFlowsLCR = INT(name='maxNrOfEDCHMACdFlowsLCR', mode=MODE_VALUE)
    maxNrOfEDCHMACdFlowsLCR._val = 256
    
    #-----< maxNrOfEDCHMACdFlowsLCR-1 >-----#
    maxNrOfEDCHMACdFlowsLCR_1 = INT(name='maxNrOfEDCHMACdFlowsLCR-1', mode=MODE_VALUE)
    maxNrOfEDCHMACdFlowsLCR_1._val = 255
    
    #-----< maxNrOfEAGCHsLCR >-----#
    maxNrOfEAGCHsLCR = INT(name='maxNrOfEAGCHsLCR', mode=MODE_VALUE)
    maxNrOfEAGCHsLCR._val = 256
    
    #-----< maxNrOfEHICHsLCR >-----#
    maxNrOfEHICHsLCR = INT(name='maxNrOfEHICHsLCR', mode=MODE_VALUE)
    maxNrOfEHICHsLCR._val = 256
    
    #-----< maxnrofERUCCHsLCR >-----#
    maxnrofERUCCHsLCR = INT(name='maxnrofERUCCHsLCR', mode=MODE_VALUE)
    maxnrofERUCCHsLCR._val = 32
    
    #-----< maxNrOfHSDSCH-1 >-----#
    maxNrOfHSDSCH_1 = INT(name='maxNrOfHSDSCH-1', mode=MODE_VALUE)
    maxNrOfHSDSCH_1._val = 32
    
    #-----< maxNrOfHSDSCH >-----#
    maxNrOfHSDSCH = INT(name='maxNrOfHSDSCH', mode=MODE_VALUE)
    maxNrOfHSDSCH._val = 33
    
    #-----< maxGANSS-1 >-----#
    maxGANSS_1 = INT(name='maxGANSS-1', mode=MODE_VALUE)
    maxGANSS_1._val = 7
    
    #-----< maxNoOfTBSs-Mapping-HS-DSCH-SPS >-----#
    maxNoOfTBSs_Mapping_HS_DSCH_SPS = INT(name='maxNoOfTBSs-Mapping-HS-DSCH-SPS', mode=MODE_VALUE)
    maxNoOfTBSs_Mapping_HS_DSCH_SPS._val = 4
    
    #-----< maxNoOfTBSs-Mapping-HS-DSCH-SPS-1 >-----#
    maxNoOfTBSs_Mapping_HS_DSCH_SPS_1 = INT(name='maxNoOfTBSs-Mapping-HS-DSCH-SPS-1', mode=MODE_VALUE)
    maxNoOfTBSs_Mapping_HS_DSCH_SPS_1._val = 3
    
    #-----< maxNoOfHS-DSCH-TBSsLCR >-----#
    maxNoOfHS_DSCH_TBSsLCR = INT(name='maxNoOfHS-DSCH-TBSsLCR', mode=MODE_VALUE)
    maxNoOfHS_DSCH_TBSsLCR._val = 64
    
    #-----< maxNoOfRepetition-Period-LCR >-----#
    maxNoOfRepetition_Period_LCR = INT(name='maxNoOfRepetition-Period-LCR', mode=MODE_VALUE)
    maxNoOfRepetition_Period_LCR._val = 4
    
    #-----< maxNoOfRepetitionPeriod-SPS-LCR-1 >-----#
    maxNoOfRepetitionPeriod_SPS_LCR_1 = INT(name='maxNoOfRepetitionPeriod-SPS-LCR-1', mode=MODE_VALUE)
    maxNoOfRepetitionPeriod_SPS_LCR_1._val = 3
    
    #-----< maxNoOf-HS-SICH-SPS >-----#
    maxNoOf_HS_SICH_SPS = INT(name='maxNoOf-HS-SICH-SPS', mode=MODE_VALUE)
    maxNoOf_HS_SICH_SPS._val = 4
    
    #-----< maxNoOf-HS-SICH-SPS-1 >-----#
    maxNoOf_HS_SICH_SPS_1 = INT(name='maxNoOf-HS-SICH-SPS-1', mode=MODE_VALUE)
    maxNoOf_HS_SICH_SPS_1._val = 3
    
    #-----< maxNoOfNon-HS-SCCH-Assosiated-HS-SICH >-----#
    maxNoOfNon_HS_SCCH_Assosiated_HS_SICH = INT(name='maxNoOfNon-HS-SCCH-Assosiated-HS-SICH', mode=MODE_VALUE)
    maxNoOfNon_HS_SCCH_Assosiated_HS_SICH._val = 4
    
    #-----< maxNoOfNon-HS-SCCH-Assosiated-HS-SICH-Ext >-----#
    maxNoOfNon_HS_SCCH_Assosiated_HS_SICH_Ext = INT(name='maxNoOfNon-HS-SCCH-Assosiated-HS-SICH-Ext', mode=MODE_VALUE)
    maxNoOfNon_HS_SCCH_Assosiated_HS_SICH_Ext._val = 44
    
    #-----< maxMBMSServiceSelect >-----#
    maxMBMSServiceSelect = INT(name='maxMBMSServiceSelect', mode=MODE_VALUE)
    maxMBMSServiceSelect._val = 256
    
    #-----< maxNrOfCellPortionsPerCellLCR >-----#
    maxNrOfCellPortionsPerCellLCR = INT(name='maxNrOfCellPortionsPerCellLCR', mode=MODE_VALUE)
    maxNrOfCellPortionsPerCellLCR._val = 256
    
    #-----< maxNrOfCellPortionsPerCellLCR-1 >-----#
    maxNrOfCellPortionsPerCellLCR_1 = INT(name='maxNrOfCellPortionsPerCellLCR-1', mode=MODE_VALUE)
    maxNrOfCellPortionsPerCellLCR_1._val = 255
    
    #-----< maxNrOfEDCH-1 >-----#
    maxNrOfEDCH_1 = INT(name='maxNrOfEDCH-1', mode=MODE_VALUE)
    maxNrOfEDCH_1._val = 32
    
    #-----< maxNoOfCommonH-RNTI >-----#
    maxNoOfCommonH_RNTI = INT(name='maxNoOfCommonH-RNTI', mode=MODE_VALUE)
    maxNoOfCommonH_RNTI._val = 256
    
    #-----< maxNrOfCommonMACFlowsLCRExt >-----#
    maxNrOfCommonMACFlowsLCRExt = INT(name='maxNrOfCommonMACFlowsLCRExt', mode=MODE_VALUE)
    maxNrOfCommonMACFlowsLCRExt._val = 248
    
    #-----< maxofERNTI >-----#
    maxofERNTI = INT(name='maxofERNTI', mode=MODE_VALUE)
    maxofERNTI._val = 256
    
    #-----< maxNrOfDCHMeasurementOccasionPatternSequence >-----#
    maxNrOfDCHMeasurementOccasionPatternSequence = INT(name='maxNrOfDCHMeasurementOccasionPatternSequence', mode=MODE_VALUE)
    maxNrOfDCHMeasurementOccasionPatternSequence._val = 6
    
    #-----< maxNrOfULCarriersLCR-1 >-----#
    maxNrOfULCarriersLCR_1 = INT(name='maxNrOfULCarriersLCR-1', mode=MODE_VALUE)
    maxNrOfULCarriersLCR_1._val = 5
    
    #-----< maxFreqBandsTDD >-----#
    maxFreqBandsTDD = INT(name='maxFreqBandsTDD', mode=MODE_VALUE)
    maxFreqBandsTDD._val = 16
    
    #-----< maxnoofPRACHEUL >-----#
    maxnoofPRACHEUL = INT(name='maxnoofPRACHEUL', mode=MODE_VALUE)
    maxnoofPRACHEUL._val = 16
    
    #-----< maxIGPInfo >-----#
    maxIGPInfo = INT(name='maxIGPInfo', mode=MODE_VALUE)
    maxIGPInfo._val = 320
    
    #-----< maxNrofConcatenatedDCH >-----#
    maxNrofConcatenatedDCH = INT(name='maxNrofConcatenatedDCH', mode=MODE_VALUE)
    maxNrofConcatenatedDCH._val = 3
    
    #-----< id-AICH-Information >-----#
    id_AICH_Information = INT(name='id-AICH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AICH_Information._val = 0
    
    #-----< id-AICH-InformationItem-ResourceStatusInd >-----#
    id_AICH_InformationItem_ResourceStatusInd = INT(name='id-AICH-InformationItem-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AICH_InformationItem_ResourceStatusInd._val = 1
    
    #-----< id-BCH-Information >-----#
    id_BCH_Information = INT(name='id-BCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCH_Information._val = 7
    
    #-----< id-BCH-InformationItem-ResourceStatusInd >-----#
    id_BCH_InformationItem_ResourceStatusInd = INT(name='id-BCH-InformationItem-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCH_InformationItem_ResourceStatusInd._val = 8
    
    #-----< id-BCCH-ModificationTime >-----#
    id_BCCH_ModificationTime = INT(name='id-BCCH-ModificationTime', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCCH_ModificationTime._val = 9
    
    #-----< id-BlockingPriorityIndicator >-----#
    id_BlockingPriorityIndicator = INT(name='id-BlockingPriorityIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BlockingPriorityIndicator._val = 10
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 13
    
    #-----< id-CCP-InformationItem-AuditRsp >-----#
    id_CCP_InformationItem_AuditRsp = INT(name='id-CCP-InformationItem-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCP_InformationItem_AuditRsp._val = 14
    
    #-----< id-CCP-InformationList-AuditRsp >-----#
    id_CCP_InformationList_AuditRsp = INT(name='id-CCP-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCP_InformationList_AuditRsp._val = 15
    
    #-----< id-CCP-InformationItem-ResourceStatusInd >-----#
    id_CCP_InformationItem_ResourceStatusInd = INT(name='id-CCP-InformationItem-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCP_InformationItem_ResourceStatusInd._val = 16
    
    #-----< id-Cell-InformationItem-AuditRsp >-----#
    id_Cell_InformationItem_AuditRsp = INT(name='id-Cell-InformationItem-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_InformationItem_AuditRsp._val = 17
    
    #-----< id-Cell-InformationItem-ResourceStatusInd >-----#
    id_Cell_InformationItem_ResourceStatusInd = INT(name='id-Cell-InformationItem-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_InformationItem_ResourceStatusInd._val = 18
    
    #-----< id-Cell-InformationList-AuditRsp >-----#
    id_Cell_InformationList_AuditRsp = INT(name='id-Cell-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_InformationList_AuditRsp._val = 19
    
    #-----< id-CellParameterID >-----#
    id_CellParameterID = INT(name='id-CellParameterID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellParameterID._val = 23
    
    #-----< id-CFN >-----#
    id_CFN = INT(name='id-CFN', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CFN._val = 24
    
    #-----< id-C-ID >-----#
    id_C_ID = INT(name='id-C-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_C_ID._val = 25
    
    #-----< id-CommonMeasurementAccuracy >-----#
    id_CommonMeasurementAccuracy = INT(name='id-CommonMeasurementAccuracy', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonMeasurementAccuracy._val = 39
    
    #-----< id-CommonMeasurementObjectType-CM-Rprt >-----#
    id_CommonMeasurementObjectType_CM_Rprt = INT(name='id-CommonMeasurementObjectType-CM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonMeasurementObjectType_CM_Rprt._val = 31
    
    #-----< id-CommonMeasurementObjectType-CM-Rqst >-----#
    id_CommonMeasurementObjectType_CM_Rqst = INT(name='id-CommonMeasurementObjectType-CM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonMeasurementObjectType_CM_Rqst._val = 32
    
    #-----< id-CommonMeasurementObjectType-CM-Rsp >-----#
    id_CommonMeasurementObjectType_CM_Rsp = INT(name='id-CommonMeasurementObjectType-CM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonMeasurementObjectType_CM_Rsp._val = 33
    
    #-----< id-CommonMeasurementType >-----#
    id_CommonMeasurementType = INT(name='id-CommonMeasurementType', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonMeasurementType._val = 34
    
    #-----< id-CommonPhysicalChannelID >-----#
    id_CommonPhysicalChannelID = INT(name='id-CommonPhysicalChannelID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonPhysicalChannelID._val = 35
    
    #-----< id-CommonPhysicalChannelType-CTCH-SetupRqstFDD >-----#
    id_CommonPhysicalChannelType_CTCH_SetupRqstFDD = INT(name='id-CommonPhysicalChannelType-CTCH-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonPhysicalChannelType_CTCH_SetupRqstFDD._val = 36
    
    #-----< id-CommonPhysicalChannelType-CTCH-SetupRqstTDD >-----#
    id_CommonPhysicalChannelType_CTCH_SetupRqstTDD = INT(name='id-CommonPhysicalChannelType-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonPhysicalChannelType_CTCH_SetupRqstTDD._val = 37
    
    #-----< id-CommunicationControlPortID >-----#
    id_CommunicationControlPortID = INT(name='id-CommunicationControlPortID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommunicationControlPortID._val = 40
    
    #-----< id-ConfigurationGenerationID >-----#
    id_ConfigurationGenerationID = INT(name='id-ConfigurationGenerationID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConfigurationGenerationID._val = 43
    
    #-----< id-CRNC-CommunicationContextID >-----#
    id_CRNC_CommunicationContextID = INT(name='id-CRNC-CommunicationContextID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CRNC_CommunicationContextID._val = 44
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 45
    
    #-----< id-DCHs-to-Add-FDD >-----#
    id_DCHs_to_Add_FDD = INT(name='id-DCHs-to-Add-FDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCHs_to_Add_FDD._val = 48
    
    #-----< id-DCH-AddList-RL-ReconfPrepTDD >-----#
    id_DCH_AddList_RL_ReconfPrepTDD = INT(name='id-DCH-AddList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_AddList_RL_ReconfPrepTDD._val = 49
    
    #-----< id-DCHs-to-Add-TDD >-----#
    id_DCHs_to_Add_TDD = INT(name='id-DCHs-to-Add-TDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCHs_to_Add_TDD._val = 50
    
    #-----< id-DCH-DeleteList-RL-ReconfPrepFDD >-----#
    id_DCH_DeleteList_RL_ReconfPrepFDD = INT(name='id-DCH-DeleteList-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_DeleteList_RL_ReconfPrepFDD._val = 52
    
    #-----< id-DCH-DeleteList-RL-ReconfPrepTDD >-----#
    id_DCH_DeleteList_RL_ReconfPrepTDD = INT(name='id-DCH-DeleteList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_DeleteList_RL_ReconfPrepTDD._val = 53
    
    #-----< id-DCH-DeleteList-RL-ReconfRqstFDD >-----#
    id_DCH_DeleteList_RL_ReconfRqstFDD = INT(name='id-DCH-DeleteList-RL-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_DeleteList_RL_ReconfRqstFDD._val = 54
    
    #-----< id-DCH-DeleteList-RL-ReconfRqstTDD >-----#
    id_DCH_DeleteList_RL_ReconfRqstTDD = INT(name='id-DCH-DeleteList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_DeleteList_RL_ReconfRqstTDD._val = 55
    
    #-----< id-DCH-FDD-Information >-----#
    id_DCH_FDD_Information = INT(name='id-DCH-FDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_FDD_Information._val = 56
    
    #-----< id-DCH-TDD-Information >-----#
    id_DCH_TDD_Information = INT(name='id-DCH-TDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_TDD_Information._val = 57
    
    #-----< id-DCH-InformationResponse >-----#
    id_DCH_InformationResponse = INT(name='id-DCH-InformationResponse', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_InformationResponse._val = 59
    
    #-----< id-FDD-DCHs-to-Modify >-----#
    id_FDD_DCHs_to_Modify = INT(name='id-FDD-DCHs-to-Modify', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FDD_DCHs_to_Modify._val = 62
    
    #-----< id-TDD-DCHs-to-Modify >-----#
    id_TDD_DCHs_to_Modify = INT(name='id-TDD-DCHs-to-Modify', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_DCHs_to_Modify._val = 63
    
    #-----< id-DCH-ModifyList-RL-ReconfRqstTDD >-----#
    id_DCH_ModifyList_RL_ReconfRqstTDD = INT(name='id-DCH-ModifyList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_ModifyList_RL_ReconfRqstTDD._val = 65
    
    #-----< id-DCH-RearrangeList-Bearer-RearrangeInd >-----#
    id_DCH_RearrangeList_Bearer_RearrangeInd = INT(name='id-DCH-RearrangeList-Bearer-RearrangeInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_RearrangeList_Bearer_RearrangeInd._val = 135
    
    #-----< id-DedicatedMeasurementObjectType-DM-Rprt >-----#
    id_DedicatedMeasurementObjectType_DM_Rprt = INT(name='id-DedicatedMeasurementObjectType-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DedicatedMeasurementObjectType_DM_Rprt._val = 67
    
    #-----< id-DedicatedMeasurementObjectType-DM-Rqst >-----#
    id_DedicatedMeasurementObjectType_DM_Rqst = INT(name='id-DedicatedMeasurementObjectType-DM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DedicatedMeasurementObjectType_DM_Rqst._val = 68
    
    #-----< id-DedicatedMeasurementObjectType-DM-Rsp >-----#
    id_DedicatedMeasurementObjectType_DM_Rsp = INT(name='id-DedicatedMeasurementObjectType-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DedicatedMeasurementObjectType_DM_Rsp._val = 69
    
    #-----< id-DedicatedMeasurementType >-----#
    id_DedicatedMeasurementType = INT(name='id-DedicatedMeasurementType', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DedicatedMeasurementType._val = 70
    
    #-----< id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD >-----#
    id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD = INT(name='id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD._val = 72
    
    #-----< id-DL-CCTrCH-InformationList-RL-AdditionRqstTDD >-----#
    id_DL_CCTrCH_InformationList_RL_AdditionRqstTDD = INT(name='id-DL-CCTrCH-InformationList-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationList_RL_AdditionRqstTDD._val = 73
    
    #-----< id-DL-CCTrCH-InformationList-RL-SetupRqstTDD >-----#
    id_DL_CCTrCH_InformationList_RL_SetupRqstTDD = INT(name='id-DL-CCTrCH-InformationList-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationList_RL_SetupRqstTDD._val = 76
    
    #-----< id-DL-DPCH-InformationItem-RL-AdditionRqstTDD >-----#
    id_DL_DPCH_InformationItem_RL_AdditionRqstTDD = INT(name='id-DL-DPCH-InformationItem-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationItem_RL_AdditionRqstTDD._val = 77
    
    #-----< id-DL-DPCH-InformationList-RL-SetupRqstTDD >-----#
    id_DL_DPCH_InformationList_RL_SetupRqstTDD = INT(name='id-DL-DPCH-InformationList-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationList_RL_SetupRqstTDD._val = 79
    
    #-----< id-DL-DPCH-Information-RL-ReconfPrepFDD >-----#
    id_DL_DPCH_Information_RL_ReconfPrepFDD = INT(name='id-DL-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_Information_RL_ReconfPrepFDD._val = 81
    
    #-----< id-DL-DPCH-Information-RL-ReconfRqstFDD >-----#
    id_DL_DPCH_Information_RL_ReconfRqstFDD = INT(name='id-DL-DPCH-Information-RL-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_Information_RL_ReconfRqstFDD._val = 82
    
    #-----< id-DL-DPCH-Information-RL-SetupRqstFDD >-----#
    id_DL_DPCH_Information_RL_SetupRqstFDD = INT(name='id-DL-DPCH-Information-RL-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_Information_RL_SetupRqstFDD._val = 83
    
    #-----< id-DL-DPCH-TimingAdjustment >-----#
    id_DL_DPCH_TimingAdjustment = INT(name='id-DL-DPCH-TimingAdjustment', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_TimingAdjustment._val = 21
    
    #-----< id-DL-ReferencePowerInformationItem-DL-PC-Rqst >-----#
    id_DL_ReferencePowerInformationItem_DL_PC_Rqst = INT(name='id-DL-ReferencePowerInformationItem-DL-PC-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_ReferencePowerInformationItem_DL_PC_Rqst._val = 84
    
    #-----< id-DLReferencePower >-----#
    id_DLReferencePower = INT(name='id-DLReferencePower', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLReferencePower._val = 85
    
    #-----< id-DLReferencePowerList-DL-PC-Rqst >-----#
    id_DLReferencePowerList_DL_PC_Rqst = INT(name='id-DLReferencePowerList-DL-PC-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLReferencePowerList_DL_PC_Rqst._val = 86
    
    #-----< id-Unused-ProtocolIE-ID-87 >-----#
    id_Unused_ProtocolIE_ID_87 = INT(name='id-Unused-ProtocolIE-ID-87', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_87._val = 87
    
    #-----< id-Unused-ProtocolIE-ID-89 >-----#
    id_Unused_ProtocolIE_ID_89 = INT(name='id-Unused-ProtocolIE-ID-89', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_89._val = 89
    
    #-----< id-Unused-ProtocolIE-ID-91 >-----#
    id_Unused_ProtocolIE_ID_91 = INT(name='id-Unused-ProtocolIE-ID-91', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_91._val = 91
    
    #-----< id-Unused-ProtocolIE-ID-93 >-----#
    id_Unused_ProtocolIE_ID_93 = INT(name='id-Unused-ProtocolIE-ID-93', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_93._val = 93
    
    #-----< id-DSCHs-to-Add-TDD >-----#
    id_DSCHs_to_Add_TDD = INT(name='id-DSCHs-to-Add-TDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCHs_to_Add_TDD._val = 96
    
    #-----< id-DSCH-Information-DeleteList-RL-ReconfPrepTDD >-----#
    id_DSCH_Information_DeleteList_RL_ReconfPrepTDD = INT(name='id-DSCH-Information-DeleteList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_Information_DeleteList_RL_ReconfPrepTDD._val = 98
    
    #-----< id-DSCH-Information-ModifyList-RL-ReconfPrepTDD >-----#
    id_DSCH_Information_ModifyList_RL_ReconfPrepTDD = INT(name='id-DSCH-Information-ModifyList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_Information_ModifyList_RL_ReconfPrepTDD._val = 100
    
    #-----< id-DSCH-InformationResponse >-----#
    id_DSCH_InformationResponse = INT(name='id-DSCH-InformationResponse', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_InformationResponse._val = 105
    
    #-----< id-Unused-ProtocolIE-ID-106 >-----#
    id_Unused_ProtocolIE_ID_106 = INT(name='id-Unused-ProtocolIE-ID-106', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_106._val = 106
    
    #-----< id-DSCH-TDD-Information >-----#
    id_DSCH_TDD_Information = INT(name='id-DSCH-TDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_TDD_Information._val = 107
    
    #-----< id-Unused-ProtocolIE-ID-108 >-----#
    id_Unused_ProtocolIE_ID_108 = INT(name='id-Unused-ProtocolIE-ID-108', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_108._val = 108
    
    #-----< id-Unused-ProtocolIE-ID-112 >-----#
    id_Unused_ProtocolIE_ID_112 = INT(name='id-Unused-ProtocolIE-ID-112', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_112._val = 112
    
    #-----< id-DSCH-RearrangeList-Bearer-RearrangeInd >-----#
    id_DSCH_RearrangeList_Bearer_RearrangeInd = INT(name='id-DSCH-RearrangeList-Bearer-RearrangeInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_RearrangeList_Bearer_RearrangeInd._val = 136
    
    #-----< id-End-Of-Audit-Sequence-Indicator >-----#
    id_End_Of_Audit_Sequence_Indicator = INT(name='id-End-Of-Audit-Sequence-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_End_Of_Audit_Sequence_Indicator._val = 113
    
    #-----< id-FACH-Information >-----#
    id_FACH_Information = INT(name='id-FACH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FACH_Information._val = 116
    
    #-----< id-FACH-InformationItem-ResourceStatusInd >-----#
    id_FACH_InformationItem_ResourceStatusInd = INT(name='id-FACH-InformationItem-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FACH_InformationItem_ResourceStatusInd._val = 117
    
    #-----< id-FACH-ParametersList-CTCH-ReconfRqstTDD >-----#
    id_FACH_ParametersList_CTCH_ReconfRqstTDD = INT(name='id-FACH-ParametersList-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FACH_ParametersList_CTCH_ReconfRqstTDD._val = 120
    
    #-----< id-FACH-ParametersListIE-CTCH-SetupRqstFDD >-----#
    id_FACH_ParametersListIE_CTCH_SetupRqstFDD = INT(name='id-FACH-ParametersListIE-CTCH-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FACH_ParametersListIE_CTCH_SetupRqstFDD._val = 121
    
    #-----< id-FACH-ParametersListIE-CTCH-SetupRqstTDD >-----#
    id_FACH_ParametersListIE_CTCH_SetupRqstTDD = INT(name='id-FACH-ParametersListIE-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FACH_ParametersListIE_CTCH_SetupRqstTDD._val = 122
    
    #-----< id-IndicationType-ResourceStatusInd >-----#
    id_IndicationType_ResourceStatusInd = INT(name='id-IndicationType-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IndicationType_ResourceStatusInd._val = 123
    
    #-----< id-Local-Cell-ID >-----#
    id_Local_Cell_ID = INT(name='id-Local-Cell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Local_Cell_ID._val = 124
    
    #-----< id-Local-Cell-Group-InformationItem-AuditRsp >-----#
    id_Local_Cell_Group_InformationItem_AuditRsp = INT(name='id-Local-Cell-Group-InformationItem-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Local_Cell_Group_InformationItem_AuditRsp._val = 2
    
    #-----< id-Local-Cell-Group-InformationItem-ResourceStatusInd >-----#
    id_Local_Cell_Group_InformationItem_ResourceStatusInd = INT(name='id-Local-Cell-Group-InformationItem-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Local_Cell_Group_InformationItem_ResourceStatusInd._val = 3
    
    #-----< id-Local-Cell-Group-InformationItem2-ResourceStatusInd >-----#
    id_Local_Cell_Group_InformationItem2_ResourceStatusInd = INT(name='id-Local-Cell-Group-InformationItem2-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Local_Cell_Group_InformationItem2_ResourceStatusInd._val = 4
    
    #-----< id-Local-Cell-Group-InformationList-AuditRsp >-----#
    id_Local_Cell_Group_InformationList_AuditRsp = INT(name='id-Local-Cell-Group-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Local_Cell_Group_InformationList_AuditRsp._val = 5
    
    #-----< id-Local-Cell-InformationItem-AuditRsp >-----#
    id_Local_Cell_InformationItem_AuditRsp = INT(name='id-Local-Cell-InformationItem-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Local_Cell_InformationItem_AuditRsp._val = 125
    
    #-----< id-Local-Cell-InformationItem-ResourceStatusInd >-----#
    id_Local_Cell_InformationItem_ResourceStatusInd = INT(name='id-Local-Cell-InformationItem-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Local_Cell_InformationItem_ResourceStatusInd._val = 126
    
    #-----< id-Local-Cell-InformationItem2-ResourceStatusInd >-----#
    id_Local_Cell_InformationItem2_ResourceStatusInd = INT(name='id-Local-Cell-InformationItem2-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Local_Cell_InformationItem2_ResourceStatusInd._val = 127
    
    #-----< id-Local-Cell-InformationList-AuditRsp >-----#
    id_Local_Cell_InformationList_AuditRsp = INT(name='id-Local-Cell-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Local_Cell_InformationList_AuditRsp._val = 128
    
    #-----< id-AdjustmentPeriod >-----#
    id_AdjustmentPeriod = INT(name='id-AdjustmentPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdjustmentPeriod._val = 129
    
    #-----< id-MaxAdjustmentStep >-----#
    id_MaxAdjustmentStep = INT(name='id-MaxAdjustmentStep', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaxAdjustmentStep._val = 130
    
    #-----< id-MaximumTransmissionPower >-----#
    id_MaximumTransmissionPower = INT(name='id-MaximumTransmissionPower', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaximumTransmissionPower._val = 131
    
    #-----< id-MeasurementFilterCoefficient >-----#
    id_MeasurementFilterCoefficient = INT(name='id-MeasurementFilterCoefficient', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementFilterCoefficient._val = 132
    
    #-----< id-MeasurementID >-----#
    id_MeasurementID = INT(name='id-MeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementID._val = 133
    
    #-----< id-MessageStructure >-----#
    id_MessageStructure = INT(name='id-MessageStructure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MessageStructure._val = 115
    
    #-----< id-MIB-SB-SIB-InformationList-SystemInfoUpdateRqst >-----#
    id_MIB_SB_SIB_InformationList_SystemInfoUpdateRqst = INT(name='id-MIB-SB-SIB-InformationList-SystemInfoUpdateRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIB_SB_SIB_InformationList_SystemInfoUpdateRqst._val = 134
    
    #-----< id-NodeB-CommunicationContextID >-----#
    id_NodeB_CommunicationContextID = INT(name='id-NodeB-CommunicationContextID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NodeB_CommunicationContextID._val = 143
    
    #-----< id-NeighbouringCellMeasurementInformation >-----#
    id_NeighbouringCellMeasurementInformation = INT(name='id-NeighbouringCellMeasurementInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeighbouringCellMeasurementInformation._val = 455
    
    #-----< id-P-CCPCH-Information >-----#
    id_P_CCPCH_Information = INT(name='id-P-CCPCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_P_CCPCH_Information._val = 144
    
    #-----< id-P-CCPCH-InformationItem-ResourceStatusInd >-----#
    id_P_CCPCH_InformationItem_ResourceStatusInd = INT(name='id-P-CCPCH-InformationItem-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_P_CCPCH_InformationItem_ResourceStatusInd._val = 145
    
    #-----< id-P-CPICH-Information >-----#
    id_P_CPICH_Information = INT(name='id-P-CPICH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_P_CPICH_Information._val = 146
    
    #-----< id-P-CPICH-InformationItem-ResourceStatusInd >-----#
    id_P_CPICH_InformationItem_ResourceStatusInd = INT(name='id-P-CPICH-InformationItem-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_P_CPICH_InformationItem_ResourceStatusInd._val = 147
    
    #-----< id-P-SCH-Information >-----#
    id_P_SCH_Information = INT(name='id-P-SCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_P_SCH_Information._val = 148
    
    #-----< id-PCCPCH-Information-Cell-ReconfRqstTDD >-----#
    id_PCCPCH_Information_Cell_ReconfRqstTDD = INT(name='id-PCCPCH-Information-Cell-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCCPCH_Information_Cell_ReconfRqstTDD._val = 150
    
    #-----< id-PCCPCH-Information-Cell-SetupRqstTDD >-----#
    id_PCCPCH_Information_Cell_SetupRqstTDD = INT(name='id-PCCPCH-Information-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCCPCH_Information_Cell_SetupRqstTDD._val = 151
    
    #-----< id-PCH-Parameters-CTCH-ReconfRqstTDD >-----#
    id_PCH_Parameters_CTCH_ReconfRqstTDD = INT(name='id-PCH-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCH_Parameters_CTCH_ReconfRqstTDD._val = 155
    
    #-----< id-PCH-ParametersItem-CTCH-SetupRqstFDD >-----#
    id_PCH_ParametersItem_CTCH_SetupRqstFDD = INT(name='id-PCH-ParametersItem-CTCH-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCH_ParametersItem_CTCH_SetupRqstFDD._val = 156
    
    #-----< id-PCH-ParametersItem-CTCH-SetupRqstTDD >-----#
    id_PCH_ParametersItem_CTCH_SetupRqstTDD = INT(name='id-PCH-ParametersItem-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCH_ParametersItem_CTCH_SetupRqstTDD._val = 157
    
    #-----< id-PCH-Information >-----#
    id_PCH_Information = INT(name='id-PCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCH_Information._val = 158
    
    #-----< id-PDSCH-Information-AddListIE-PSCH-ReconfRqst >-----#
    id_PDSCH_Information_AddListIE_PSCH_ReconfRqst = INT(name='id-PDSCH-Information-AddListIE-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCH_Information_AddListIE_PSCH_ReconfRqst._val = 161
    
    #-----< id-PDSCH-Information-ModifyListIE-PSCH-ReconfRqst >-----#
    id_PDSCH_Information_ModifyListIE_PSCH_ReconfRqst = INT(name='id-PDSCH-Information-ModifyListIE-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCH_Information_ModifyListIE_PSCH_ReconfRqst._val = 162
    
    #-----< id-PDSCHSets-AddList-PSCH-ReconfRqst >-----#
    id_PDSCHSets_AddList_PSCH_ReconfRqst = INT(name='id-PDSCHSets-AddList-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCHSets_AddList_PSCH_ReconfRqst._val = 163
    
    #-----< id-PDSCHSets-DeleteList-PSCH-ReconfRqst >-----#
    id_PDSCHSets_DeleteList_PSCH_ReconfRqst = INT(name='id-PDSCHSets-DeleteList-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCHSets_DeleteList_PSCH_ReconfRqst._val = 164
    
    #-----< id-PDSCHSets-ModifyList-PSCH-ReconfRqst >-----#
    id_PDSCHSets_ModifyList_PSCH_ReconfRqst = INT(name='id-PDSCHSets-ModifyList-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCHSets_ModifyList_PSCH_ReconfRqst._val = 165
    
    #-----< id-PICH-Information >-----#
    id_PICH_Information = INT(name='id-PICH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PICH_Information._val = 166
    
    #-----< id-PICH-Parameters-CTCH-ReconfRqstTDD >-----#
    id_PICH_Parameters_CTCH_ReconfRqstTDD = INT(name='id-PICH-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PICH_Parameters_CTCH_ReconfRqstTDD._val = 168
    
    #-----< id-PowerAdjustmentType >-----#
    id_PowerAdjustmentType = INT(name='id-PowerAdjustmentType', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PowerAdjustmentType._val = 169
    
    #-----< id-PRACH-Information >-----#
    id_PRACH_Information = INT(name='id-PRACH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRACH_Information._val = 170
    
    #-----< id-PrimaryCCPCH-Information-Cell-ReconfRqstFDD >-----#
    id_PrimaryCCPCH_Information_Cell_ReconfRqstFDD = INT(name='id-PrimaryCCPCH-Information-Cell-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimaryCCPCH_Information_Cell_ReconfRqstFDD._val = 175
    
    #-----< id-PrimaryCCPCH-Information-Cell-SetupRqstFDD >-----#
    id_PrimaryCCPCH_Information_Cell_SetupRqstFDD = INT(name='id-PrimaryCCPCH-Information-Cell-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimaryCCPCH_Information_Cell_SetupRqstFDD._val = 176
    
    #-----< id-PrimaryCPICH-Information-Cell-ReconfRqstFDD >-----#
    id_PrimaryCPICH_Information_Cell_ReconfRqstFDD = INT(name='id-PrimaryCPICH-Information-Cell-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimaryCPICH_Information_Cell_ReconfRqstFDD._val = 177
    
    #-----< id-PrimaryCPICH-Information-Cell-SetupRqstFDD >-----#
    id_PrimaryCPICH_Information_Cell_SetupRqstFDD = INT(name='id-PrimaryCPICH-Information-Cell-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimaryCPICH_Information_Cell_SetupRqstFDD._val = 178
    
    #-----< id-PrimarySCH-Information-Cell-ReconfRqstFDD >-----#
    id_PrimarySCH_Information_Cell_ReconfRqstFDD = INT(name='id-PrimarySCH-Information-Cell-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimarySCH_Information_Cell_ReconfRqstFDD._val = 179
    
    #-----< id-PrimarySCH-Information-Cell-SetupRqstFDD >-----#
    id_PrimarySCH_Information_Cell_SetupRqstFDD = INT(name='id-PrimarySCH-Information-Cell-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimarySCH_Information_Cell_SetupRqstFDD._val = 180
    
    #-----< id-PrimaryScramblingCode >-----#
    id_PrimaryScramblingCode = INT(name='id-PrimaryScramblingCode', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimaryScramblingCode._val = 181
    
    #-----< id-SCH-Information-Cell-ReconfRqstTDD >-----#
    id_SCH_Information_Cell_ReconfRqstTDD = INT(name='id-SCH-Information-Cell-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCH_Information_Cell_ReconfRqstTDD._val = 183
    
    #-----< id-SCH-Information-Cell-SetupRqstTDD >-----#
    id_SCH_Information_Cell_SetupRqstTDD = INT(name='id-SCH-Information-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCH_Information_Cell_SetupRqstTDD._val = 184
    
    #-----< id-PUSCH-Information-AddListIE-PSCH-ReconfRqst >-----#
    id_PUSCH_Information_AddListIE_PSCH_ReconfRqst = INT(name='id-PUSCH-Information-AddListIE-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_Information_AddListIE_PSCH_ReconfRqst._val = 185
    
    #-----< id-PUSCH-Information-ModifyListIE-PSCH-ReconfRqst >-----#
    id_PUSCH_Information_ModifyListIE_PSCH_ReconfRqst = INT(name='id-PUSCH-Information-ModifyListIE-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_Information_ModifyListIE_PSCH_ReconfRqst._val = 186
    
    #-----< id-PUSCHSets-AddList-PSCH-ReconfRqst >-----#
    id_PUSCHSets_AddList_PSCH_ReconfRqst = INT(name='id-PUSCHSets-AddList-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCHSets_AddList_PSCH_ReconfRqst._val = 187
    
    #-----< id-PUSCHSets-DeleteList-PSCH-ReconfRqst >-----#
    id_PUSCHSets_DeleteList_PSCH_ReconfRqst = INT(name='id-PUSCHSets-DeleteList-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCHSets_DeleteList_PSCH_ReconfRqst._val = 188
    
    #-----< id-PUSCHSets-ModifyList-PSCH-ReconfRqst >-----#
    id_PUSCHSets_ModifyList_PSCH_ReconfRqst = INT(name='id-PUSCHSets-ModifyList-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCHSets_ModifyList_PSCH_ReconfRqst._val = 189
    
    #-----< id-RACH-Information >-----#
    id_RACH_Information = INT(name='id-RACH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RACH_Information._val = 190
    
    #-----< id-RACH-ParametersItem-CTCH-SetupRqstFDD >-----#
    id_RACH_ParametersItem_CTCH_SetupRqstFDD = INT(name='id-RACH-ParametersItem-CTCH-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RACH_ParametersItem_CTCH_SetupRqstFDD._val = 196
    
    #-----< id-RACH-ParameterItem-CTCH-SetupRqstTDD >-----#
    id_RACH_ParameterItem_CTCH_SetupRqstTDD = INT(name='id-RACH-ParameterItem-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RACH_ParameterItem_CTCH_SetupRqstTDD._val = 197
    
    #-----< id-ReportCharacteristics >-----#
    id_ReportCharacteristics = INT(name='id-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportCharacteristics._val = 198
    
    #-----< id-Reporting-Object-RL-FailureInd >-----#
    id_Reporting_Object_RL_FailureInd = INT(name='id-Reporting-Object-RL-FailureInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Reporting_Object_RL_FailureInd._val = 199
    
    #-----< id-Reporting-Object-RL-RestoreInd >-----#
    id_Reporting_Object_RL_RestoreInd = INT(name='id-Reporting-Object-RL-RestoreInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Reporting_Object_RL_RestoreInd._val = 200
    
    #-----< id-RL-InformationItem-DM-Rprt >-----#
    id_RL_InformationItem_DM_Rprt = INT(name='id-RL-InformationItem-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_DM_Rprt._val = 202
    
    #-----< id-RL-InformationItem-DM-Rqst >-----#
    id_RL_InformationItem_DM_Rqst = INT(name='id-RL-InformationItem-DM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_DM_Rqst._val = 203
    
    #-----< id-RL-InformationItem-DM-Rsp >-----#
    id_RL_InformationItem_DM_Rsp = INT(name='id-RL-InformationItem-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_DM_Rsp._val = 204
    
    #-----< id-RL-InformationItem-RL-AdditionRqstFDD >-----#
    id_RL_InformationItem_RL_AdditionRqstFDD = INT(name='id-RL-InformationItem-RL-AdditionRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_RL_AdditionRqstFDD._val = 205
    
    #-----< id-RL-informationItem-RL-DeletionRqst >-----#
    id_RL_informationItem_RL_DeletionRqst = INT(name='id-RL-informationItem-RL-DeletionRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_informationItem_RL_DeletionRqst._val = 206
    
    #-----< id-RL-InformationItem-RL-FailureInd >-----#
    id_RL_InformationItem_RL_FailureInd = INT(name='id-RL-InformationItem-RL-FailureInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_RL_FailureInd._val = 207
    
    #-----< id-RL-InformationItem-RL-PreemptRequiredInd >-----#
    id_RL_InformationItem_RL_PreemptRequiredInd = INT(name='id-RL-InformationItem-RL-PreemptRequiredInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_RL_PreemptRequiredInd._val = 286
    
    #-----< id-RL-InformationItem-RL-ReconfPrepFDD >-----#
    id_RL_InformationItem_RL_ReconfPrepFDD = INT(name='id-RL-InformationItem-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_RL_ReconfPrepFDD._val = 208
    
    #-----< id-RL-InformationItem-RL-ReconfRqstFDD >-----#
    id_RL_InformationItem_RL_ReconfRqstFDD = INT(name='id-RL-InformationItem-RL-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_RL_ReconfRqstFDD._val = 209
    
    #-----< id-RL-InformationItem-RL-RestoreInd >-----#
    id_RL_InformationItem_RL_RestoreInd = INT(name='id-RL-InformationItem-RL-RestoreInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_RL_RestoreInd._val = 210
    
    #-----< id-RL-InformationItem-RL-SetupRqstFDD >-----#
    id_RL_InformationItem_RL_SetupRqstFDD = INT(name='id-RL-InformationItem-RL-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_RL_SetupRqstFDD._val = 211
    
    #-----< id-RL-InformationList-RL-AdditionRqstFDD >-----#
    id_RL_InformationList_RL_AdditionRqstFDD = INT(name='id-RL-InformationList-RL-AdditionRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationList_RL_AdditionRqstFDD._val = 212
    
    #-----< id-RL-informationList-RL-DeletionRqst >-----#
    id_RL_informationList_RL_DeletionRqst = INT(name='id-RL-informationList-RL-DeletionRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_informationList_RL_DeletionRqst._val = 213
    
    #-----< id-RL-InformationList-RL-PreemptRequiredInd >-----#
    id_RL_InformationList_RL_PreemptRequiredInd = INT(name='id-RL-InformationList-RL-PreemptRequiredInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationList_RL_PreemptRequiredInd._val = 237
    
    #-----< id-RL-InformationList-RL-ReconfPrepFDD >-----#
    id_RL_InformationList_RL_ReconfPrepFDD = INT(name='id-RL-InformationList-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationList_RL_ReconfPrepFDD._val = 214
    
    #-----< id-RL-InformationList-RL-ReconfRqstFDD >-----#
    id_RL_InformationList_RL_ReconfRqstFDD = INT(name='id-RL-InformationList-RL-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationList_RL_ReconfRqstFDD._val = 215
    
    #-----< id-RL-InformationList-RL-SetupRqstFDD >-----#
    id_RL_InformationList_RL_SetupRqstFDD = INT(name='id-RL-InformationList-RL-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationList_RL_SetupRqstFDD._val = 216
    
    #-----< id-RL-InformationResponseItem-RL-AdditionRspFDD >-----#
    id_RL_InformationResponseItem_RL_AdditionRspFDD = INT(name='id-RL-InformationResponseItem-RL-AdditionRspFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseItem_RL_AdditionRspFDD._val = 217
    
    #-----< id-RL-InformationResponseItem-RL-ReconfReady >-----#
    id_RL_InformationResponseItem_RL_ReconfReady = INT(name='id-RL-InformationResponseItem-RL-ReconfReady', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseItem_RL_ReconfReady._val = 218
    
    #-----< id-RL-InformationResponseItem-RL-ReconfRsp >-----#
    id_RL_InformationResponseItem_RL_ReconfRsp = INT(name='id-RL-InformationResponseItem-RL-ReconfRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseItem_RL_ReconfRsp._val = 219
    
    #-----< id-RL-InformationResponseItem-RL-SetupRspFDD >-----#
    id_RL_InformationResponseItem_RL_SetupRspFDD = INT(name='id-RL-InformationResponseItem-RL-SetupRspFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseItem_RL_SetupRspFDD._val = 220
    
    #-----< id-RL-InformationResponseList-RL-AdditionRspFDD >-----#
    id_RL_InformationResponseList_RL_AdditionRspFDD = INT(name='id-RL-InformationResponseList-RL-AdditionRspFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseList_RL_AdditionRspFDD._val = 221
    
    #-----< id-RL-InformationResponseList-RL-ReconfReady >-----#
    id_RL_InformationResponseList_RL_ReconfReady = INT(name='id-RL-InformationResponseList-RL-ReconfReady', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseList_RL_ReconfReady._val = 222
    
    #-----< id-RL-InformationResponseList-RL-ReconfRsp >-----#
    id_RL_InformationResponseList_RL_ReconfRsp = INT(name='id-RL-InformationResponseList-RL-ReconfRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseList_RL_ReconfRsp._val = 223
    
    #-----< id-RL-InformationResponseList-RL-SetupRspFDD >-----#
    id_RL_InformationResponseList_RL_SetupRspFDD = INT(name='id-RL-InformationResponseList-RL-SetupRspFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseList_RL_SetupRspFDD._val = 224
    
    #-----< id-RL-InformationResponse-RL-AdditionRspTDD >-----#
    id_RL_InformationResponse_RL_AdditionRspTDD = INT(name='id-RL-InformationResponse-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponse_RL_AdditionRspTDD._val = 225
    
    #-----< id-RL-InformationResponse-RL-SetupRspTDD >-----#
    id_RL_InformationResponse_RL_SetupRspTDD = INT(name='id-RL-InformationResponse-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponse_RL_SetupRspTDD._val = 226
    
    #-----< id-RL-Information-RL-AdditionRqstTDD >-----#
    id_RL_Information_RL_AdditionRqstTDD = INT(name='id-RL-Information-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_AdditionRqstTDD._val = 227
    
    #-----< id-RL-Information-RL-ReconfRqstTDD >-----#
    id_RL_Information_RL_ReconfRqstTDD = INT(name='id-RL-Information-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_ReconfRqstTDD._val = 228
    
    #-----< id-RL-Information-RL-ReconfPrepTDD >-----#
    id_RL_Information_RL_ReconfPrepTDD = INT(name='id-RL-Information-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_ReconfPrepTDD._val = 229
    
    #-----< id-RL-Information-RL-SetupRqstTDD >-----#
    id_RL_Information_RL_SetupRqstTDD = INT(name='id-RL-Information-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_SetupRqstTDD._val = 230
    
    #-----< id-RL-ReconfigurationFailureItem-RL-ReconfFailure >-----#
    id_RL_ReconfigurationFailureItem_RL_ReconfFailure = INT(name='id-RL-ReconfigurationFailureItem-RL-ReconfFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_ReconfigurationFailureItem_RL_ReconfFailure._val = 236
    
    #-----< id-RL-Set-InformationItem-DM-Rprt >-----#
    id_RL_Set_InformationItem_DM_Rprt = INT(name='id-RL-Set-InformationItem-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_InformationItem_DM_Rprt._val = 238
    
    #-----< id-RL-Set-InformationItem-DM-Rsp >-----#
    id_RL_Set_InformationItem_DM_Rsp = INT(name='id-RL-Set-InformationItem-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_InformationItem_DM_Rsp._val = 240
    
    #-----< id-RL-Set-InformationItem-RL-FailureInd >-----#
    id_RL_Set_InformationItem_RL_FailureInd = INT(name='id-RL-Set-InformationItem-RL-FailureInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_InformationItem_RL_FailureInd._val = 241
    
    #-----< id-RL-Set-InformationItem-RL-RestoreInd >-----#
    id_RL_Set_InformationItem_RL_RestoreInd = INT(name='id-RL-Set-InformationItem-RL-RestoreInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_InformationItem_RL_RestoreInd._val = 242
    
    #-----< id-S-CCPCH-Information >-----#
    id_S_CCPCH_Information = INT(name='id-S-CCPCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_Information._val = 247
    
    #-----< id-S-CPICH-Information >-----#
    id_S_CPICH_Information = INT(name='id-S-CPICH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CPICH_Information._val = 249
    
    #-----< id-SCH-Information >-----#
    id_SCH_Information = INT(name='id-SCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCH_Information._val = 251
    
    #-----< id-S-SCH-Information >-----#
    id_S_SCH_Information = INT(name='id-S-SCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_SCH_Information._val = 253
    
    #-----< id-Secondary-CCPCHListIE-CTCH-ReconfRqstTDD >-----#
    id_Secondary_CCPCHListIE_CTCH_ReconfRqstTDD = INT(name='id-Secondary-CCPCHListIE-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Secondary_CCPCHListIE_CTCH_ReconfRqstTDD._val = 257
    
    #-----< id-Secondary-CCPCH-parameterListIE-CTCH-SetupRqstTDD >-----#
    id_Secondary_CCPCH_parameterListIE_CTCH_SetupRqstTDD = INT(name='id-Secondary-CCPCH-parameterListIE-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Secondary_CCPCH_parameterListIE_CTCH_SetupRqstTDD._val = 258
    
    #-----< id-Secondary-CCPCH-Parameters-CTCH-ReconfRqstTDD >-----#
    id_Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD = INT(name='id-Secondary-CCPCH-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD._val = 259
    
    #-----< id-SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD >-----#
    id_SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD = INT(name='id-SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD._val = 260
    
    #-----< id-SecondaryCPICH-InformationItem-Cell-SetupRqstFDD >-----#
    id_SecondaryCPICH_InformationItem_Cell_SetupRqstFDD = INT(name='id-SecondaryCPICH-InformationItem-Cell-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryCPICH_InformationItem_Cell_SetupRqstFDD._val = 261
    
    #-----< id-SecondaryCPICH-InformationList-Cell-ReconfRqstFDD >-----#
    id_SecondaryCPICH_InformationList_Cell_ReconfRqstFDD = INT(name='id-SecondaryCPICH-InformationList-Cell-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryCPICH_InformationList_Cell_ReconfRqstFDD._val = 262
    
    #-----< id-SecondaryCPICH-InformationList-Cell-SetupRqstFDD >-----#
    id_SecondaryCPICH_InformationList_Cell_SetupRqstFDD = INT(name='id-SecondaryCPICH-InformationList-Cell-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryCPICH_InformationList_Cell_SetupRqstFDD._val = 263
    
    #-----< id-SecondarySCH-Information-Cell-ReconfRqstFDD >-----#
    id_SecondarySCH_Information_Cell_ReconfRqstFDD = INT(name='id-SecondarySCH-Information-Cell-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondarySCH_Information_Cell_ReconfRqstFDD._val = 264
    
    #-----< id-SecondarySCH-Information-Cell-SetupRqstFDD >-----#
    id_SecondarySCH_Information_Cell_SetupRqstFDD = INT(name='id-SecondarySCH-Information-Cell-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondarySCH_Information_Cell_SetupRqstFDD._val = 265
    
    #-----< id-SegmentInformationListIE-SystemInfoUpdate >-----#
    id_SegmentInformationListIE_SystemInfoUpdate = INT(name='id-SegmentInformationListIE-SystemInfoUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SegmentInformationListIE_SystemInfoUpdate._val = 266
    
    #-----< id-SFN >-----#
    id_SFN = INT(name='id-SFN', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFN._val = 268
    
    #-----< id-SignallingBearerRequestIndicator >-----#
    id_SignallingBearerRequestIndicator = INT(name='id-SignallingBearerRequestIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SignallingBearerRequestIndicator._val = 138
    
    #-----< id-ShutdownTimer >-----#
    id_ShutdownTimer = INT(name='id-ShutdownTimer', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ShutdownTimer._val = 269
    
    #-----< id-Start-Of-Audit-Sequence-Indicator >-----#
    id_Start_Of_Audit_Sequence_Indicator = INT(name='id-Start-Of-Audit-Sequence-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Start_Of_Audit_Sequence_Indicator._val = 114
    
    #-----< id-Successful-RL-InformationRespItem-RL-AdditionFailureFDD >-----#
    id_Successful_RL_InformationRespItem_RL_AdditionFailureFDD = INT(name='id-Successful-RL-InformationRespItem-RL-AdditionFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Successful_RL_InformationRespItem_RL_AdditionFailureFDD._val = 270
    
    #-----< id-Successful-RL-InformationRespItem-RL-SetupFailureFDD >-----#
    id_Successful_RL_InformationRespItem_RL_SetupFailureFDD = INT(name='id-Successful-RL-InformationRespItem-RL-SetupFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Successful_RL_InformationRespItem_RL_SetupFailureFDD._val = 271
    
    #-----< id-SyncCase >-----#
    id_SyncCase = INT(name='id-SyncCase', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SyncCase._val = 274
    
    #-----< id-SyncCaseIndicatorItem-Cell-SetupRqstTDD-PSCH >-----#
    id_SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH = INT(name='id-SyncCaseIndicatorItem-Cell-SetupRqstTDD-PSCH', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH._val = 275
    
    #-----< id-T-Cell >-----#
    id_T_Cell = INT(name='id-T-Cell', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_T_Cell._val = 276
    
    #-----< id-TargetCommunicationControlPortID >-----#
    id_TargetCommunicationControlPortID = INT(name='id-TargetCommunicationControlPortID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetCommunicationControlPortID._val = 139
    
    #-----< id-TimeSlotConfigurationList-Cell-ReconfRqstTDD >-----#
    id_TimeSlotConfigurationList_Cell_ReconfRqstTDD = INT(name='id-TimeSlotConfigurationList-Cell-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSlotConfigurationList_Cell_ReconfRqstTDD._val = 277
    
    #-----< id-TimeSlotConfigurationList-Cell-SetupRqstTDD >-----#
    id_TimeSlotConfigurationList_Cell_SetupRqstTDD = INT(name='id-TimeSlotConfigurationList-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSlotConfigurationList_Cell_SetupRqstTDD._val = 278
    
    #-----< id-TransmissionDiversityApplied >-----#
    id_TransmissionDiversityApplied = INT(name='id-TransmissionDiversityApplied', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmissionDiversityApplied._val = 279
    
    #-----< id-TypeOfError >-----#
    id_TypeOfError = INT(name='id-TypeOfError', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TypeOfError._val = 508
    
    #-----< id-UARFCNforNt >-----#
    id_UARFCNforNt = INT(name='id-UARFCNforNt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UARFCNforNt._val = 280
    
    #-----< id-UARFCNforNd >-----#
    id_UARFCNforNd = INT(name='id-UARFCNforNd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UARFCNforNd._val = 281
    
    #-----< id-UARFCNforNu >-----#
    id_UARFCNforNu = INT(name='id-UARFCNforNu', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UARFCNforNu._val = 282
    
    #-----< id-UL-CCTrCH-InformationItem-RL-SetupRqstTDD >-----#
    id_UL_CCTrCH_InformationItem_RL_SetupRqstTDD = INT(name='id-UL-CCTrCH-InformationItem-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationItem_RL_SetupRqstTDD._val = 284
    
    #-----< id-UL-CCTrCH-InformationList-RL-AdditionRqstTDD >-----#
    id_UL_CCTrCH_InformationList_RL_AdditionRqstTDD = INT(name='id-UL-CCTrCH-InformationList-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationList_RL_AdditionRqstTDD._val = 285
    
    #-----< id-UL-CCTrCH-InformationList-RL-SetupRqstTDD >-----#
    id_UL_CCTrCH_InformationList_RL_SetupRqstTDD = INT(name='id-UL-CCTrCH-InformationList-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationList_RL_SetupRqstTDD._val = 288
    
    #-----< id-UL-DPCH-InformationItem-RL-AdditionRqstTDD >-----#
    id_UL_DPCH_InformationItem_RL_AdditionRqstTDD = INT(name='id-UL-DPCH-InformationItem-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationItem_RL_AdditionRqstTDD._val = 289
    
    #-----< id-UL-DPCH-InformationList-RL-SetupRqstTDD >-----#
    id_UL_DPCH_InformationList_RL_SetupRqstTDD = INT(name='id-UL-DPCH-InformationList-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationList_RL_SetupRqstTDD._val = 291
    
    #-----< id-UL-DPCH-Information-RL-ReconfPrepFDD >-----#
    id_UL_DPCH_Information_RL_ReconfPrepFDD = INT(name='id-UL-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_Information_RL_ReconfPrepFDD._val = 293
    
    #-----< id-UL-DPCH-Information-RL-ReconfRqstFDD >-----#
    id_UL_DPCH_Information_RL_ReconfRqstFDD = INT(name='id-UL-DPCH-Information-RL-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_Information_RL_ReconfRqstFDD._val = 294
    
    #-----< id-UL-DPCH-Information-RL-SetupRqstFDD >-----#
    id_UL_DPCH_Information_RL_SetupRqstFDD = INT(name='id-UL-DPCH-Information-RL-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_Information_RL_SetupRqstFDD._val = 295
    
    #-----< id-Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD >-----#
    id_Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD = INT(name='id-Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD._val = 296
    
    #-----< id-Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD >-----#
    id_Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD = INT(name='id-Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD._val = 297
    
    #-----< id-Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD >-----#
    id_Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD = INT(name='id-Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD._val = 300
    
    #-----< id-Unsuccessful-RL-InformationResp-RL-SetupFailureTDD >-----#
    id_Unsuccessful_RL_InformationResp_RL_SetupFailureTDD = INT(name='id-Unsuccessful-RL-InformationResp-RL-SetupFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unsuccessful_RL_InformationResp_RL_SetupFailureTDD._val = 301
    
    #-----< id-USCH-Information-Add >-----#
    id_USCH_Information_Add = INT(name='id-USCH-Information-Add', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_Information_Add._val = 302
    
    #-----< id-USCH-Information-DeleteList-RL-ReconfPrepTDD >-----#
    id_USCH_Information_DeleteList_RL_ReconfPrepTDD = INT(name='id-USCH-Information-DeleteList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_Information_DeleteList_RL_ReconfPrepTDD._val = 304
    
    #-----< id-USCH-Information-ModifyList-RL-ReconfPrepTDD >-----#
    id_USCH_Information_ModifyList_RL_ReconfPrepTDD = INT(name='id-USCH-Information-ModifyList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_Information_ModifyList_RL_ReconfPrepTDD._val = 306
    
    #-----< id-USCH-InformationResponse >-----#
    id_USCH_InformationResponse = INT(name='id-USCH-InformationResponse', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_InformationResponse._val = 309
    
    #-----< id-USCH-Information >-----#
    id_USCH_Information = INT(name='id-USCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_Information._val = 310
    
    #-----< id-USCH-RearrangeList-Bearer-RearrangeInd >-----#
    id_USCH_RearrangeList_Bearer_RearrangeInd = INT(name='id-USCH-RearrangeList-Bearer-RearrangeInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_RearrangeList_Bearer_RearrangeInd._val = 141
    
    #-----< id-Active-Pattern-Sequence-Information >-----#
    id_Active_Pattern_Sequence_Information = INT(name='id-Active-Pattern-Sequence-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Active_Pattern_Sequence_Information._val = 315
    
    #-----< id-AICH-ParametersListIE-CTCH-ReconfRqstFDD >-----#
    id_AICH_ParametersListIE_CTCH_ReconfRqstFDD = INT(name='id-AICH-ParametersListIE-CTCH-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AICH_ParametersListIE_CTCH_ReconfRqstFDD._val = 316
    
    #-----< id-AdjustmentRatio >-----#
    id_AdjustmentRatio = INT(name='id-AdjustmentRatio', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdjustmentRatio._val = 317
    
    #-----< id-Not-Used-320 >-----#
    id_Not_Used_320 = INT(name='id-Not-Used-320', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Not_Used_320._val = 320
    
    #-----< id-Not-Used-322 >-----#
    id_Not_Used_322 = INT(name='id-Not-Used-322', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Not_Used_322._val = 322
    
    #-----< id-FACH-ParametersListIE-CTCH-ReconfRqstFDD >-----#
    id_FACH_ParametersListIE_CTCH_ReconfRqstFDD = INT(name='id-FACH-ParametersListIE-CTCH-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FACH_ParametersListIE_CTCH_ReconfRqstFDD._val = 323
    
    #-----< id-CauseLevel-PSCH-ReconfFailure >-----#
    id_CauseLevel_PSCH_ReconfFailure = INT(name='id-CauseLevel-PSCH-ReconfFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_PSCH_ReconfFailure._val = 324
    
    #-----< id-CauseLevel-RL-AdditionFailureFDD >-----#
    id_CauseLevel_RL_AdditionFailureFDD = INT(name='id-CauseLevel-RL-AdditionFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_RL_AdditionFailureFDD._val = 325
    
    #-----< id-CauseLevel-RL-AdditionFailureTDD >-----#
    id_CauseLevel_RL_AdditionFailureTDD = INT(name='id-CauseLevel-RL-AdditionFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_RL_AdditionFailureTDD._val = 326
    
    #-----< id-CauseLevel-RL-ReconfFailure >-----#
    id_CauseLevel_RL_ReconfFailure = INT(name='id-CauseLevel-RL-ReconfFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_RL_ReconfFailure._val = 327
    
    #-----< id-CauseLevel-RL-SetupFailureFDD >-----#
    id_CauseLevel_RL_SetupFailureFDD = INT(name='id-CauseLevel-RL-SetupFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_RL_SetupFailureFDD._val = 328
    
    #-----< id-CauseLevel-RL-SetupFailureTDD >-----#
    id_CauseLevel_RL_SetupFailureTDD = INT(name='id-CauseLevel-RL-SetupFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_RL_SetupFailureTDD._val = 329
    
    #-----< id-Not-Used-330 >-----#
    id_Not_Used_330 = INT(name='id-Not-Used-330', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Not_Used_330._val = 330
    
    #-----< id-Not-Used-332 >-----#
    id_Not_Used_332 = INT(name='id-Not-Used-332', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Not_Used_332._val = 332
    
    #-----< id-Closed-Loop-Timing-Adjustment-Mode >-----#
    id_Closed_Loop_Timing_Adjustment_Mode = INT(name='id-Closed-Loop-Timing-Adjustment-Mode', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Closed_Loop_Timing_Adjustment_Mode._val = 333
    
    #-----< id-CommonPhysicalChannelType-CTCH-ReconfRqstFDD >-----#
    id_CommonPhysicalChannelType_CTCH_ReconfRqstFDD = INT(name='id-CommonPhysicalChannelType-CTCH-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonPhysicalChannelType_CTCH_ReconfRqstFDD._val = 334
    
    #-----< id-Compressed-Mode-Deactivation-Flag >-----#
    id_Compressed_Mode_Deactivation_Flag = INT(name='id-Compressed-Mode-Deactivation-Flag', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Compressed_Mode_Deactivation_Flag._val = 335
    
    #-----< id-Not-Used-336 >-----#
    id_Not_Used_336 = INT(name='id-Not-Used-336', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Not_Used_336._val = 336
    
    #-----< id-Not-Used-342 >-----#
    id_Not_Used_342 = INT(name='id-Not-Used-342', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Not_Used_342._val = 342
    
    #-----< id-Not-Used-343 >-----#
    id_Not_Used_343 = INT(name='id-Not-Used-343', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Not_Used_343._val = 343
    
    #-----< id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD >-----#
    id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD = INT(name='id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._val = 346
    
    #-----< id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD >-----#
    id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD = INT(name='id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._val = 347
    
    #-----< id-DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD >-----#
    id_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD = INT(name='id-DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._val = 348
    
    #-----< id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD >-----#
    id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD = INT(name='id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._val = 349
    
    #-----< id-DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD >-----#
    id_DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD = INT(name='id-DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._val = 350
    
    #-----< id-DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD >-----#
    id_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD = INT(name='id-DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._val = 351
    
    #-----< id-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD >-----#
    id_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = INT(name='id-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._val = 352
    
    #-----< id-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD >-----#
    id_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD = INT(name='id-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD._val = 353
    
    #-----< id-DL-DPCH-InformationModify-AddListIE-RL-ReconfPrepTDD >-----#
    id_DL_DPCH_InformationModify_AddListIE_RL_ReconfPrepTDD = INT(name='id-DL-DPCH-InformationModify-AddListIE-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationModify_AddListIE_RL_ReconfPrepTDD._val = 355
    
    #-----< id-DL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD >-----#
    id_DL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD = INT(name='id-DL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD._val = 356
    
    #-----< id-DL-DPCH-InformationModify-ModifyListIE-RL-ReconfPrepTDD >-----#
    id_DL_DPCH_InformationModify_ModifyListIE_RL_ReconfPrepTDD = INT(name='id-DL-DPCH-InformationModify-ModifyListIE-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationModify_ModifyListIE_RL_ReconfPrepTDD._val = 357
    
    #-----< id-DL-TPC-Pattern01Count >-----#
    id_DL_TPC_Pattern01Count = INT(name='id-DL-TPC-Pattern01Count', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_TPC_Pattern01Count._val = 358
    
    #-----< id-DPC-Mode >-----#
    id_DPC_Mode = INT(name='id-DPC-Mode', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DPC_Mode._val = 450
    
    #-----< id-DPCHConstant >-----#
    id_DPCHConstant = INT(name='id-DPCHConstant', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DPCHConstant._val = 359
    
    #-----< id-Unused-ProtocolIE-ID-94 >-----#
    id_Unused_ProtocolIE_ID_94 = INT(name='id-Unused-ProtocolIE-ID-94', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_94._val = 94
    
    #-----< id-Unused-ProtocolIE-ID-110 >-----#
    id_Unused_ProtocolIE_ID_110 = INT(name='id-Unused-ProtocolIE-ID-110', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_110._val = 110
    
    #-----< id-Unused-ProtocolIE-ID-111 >-----#
    id_Unused_ProtocolIE_ID_111 = INT(name='id-Unused-ProtocolIE-ID-111', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_111._val = 111
    
    #-----< id-FACH-ParametersList-CTCH-SetupRsp >-----#
    id_FACH_ParametersList_CTCH_SetupRsp = INT(name='id-FACH-ParametersList-CTCH-SetupRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FACH_ParametersList_CTCH_SetupRsp._val = 362
    
    #-----< id-Limited-power-increase-information-Cell-SetupRqstFDD >-----#
    id_Limited_power_increase_information_Cell_SetupRqstFDD = INT(name='id-Limited-power-increase-information-Cell-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Limited_power_increase_information_Cell_SetupRqstFDD._val = 369
    
    #-----< id-PCH-Parameters-CTCH-SetupRsp >-----#
    id_PCH_Parameters_CTCH_SetupRsp = INT(name='id-PCH-Parameters-CTCH-SetupRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCH_Parameters_CTCH_SetupRsp._val = 374
    
    #-----< id-PCH-ParametersItem-CTCH-ReconfRqstFDD >-----#
    id_PCH_ParametersItem_CTCH_ReconfRqstFDD = INT(name='id-PCH-ParametersItem-CTCH-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCH_ParametersItem_CTCH_ReconfRqstFDD._val = 375
    
    #-----< id-Not-Used-376 >-----#
    id_Not_Used_376 = INT(name='id-Not-Used-376', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Not_Used_376._val = 376
    
    #-----< id-PICH-ParametersItem-CTCH-ReconfRqstFDD >-----#
    id_PICH_ParametersItem_CTCH_ReconfRqstFDD = INT(name='id-PICH-ParametersItem-CTCH-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PICH_ParametersItem_CTCH_ReconfRqstFDD._val = 380
    
    #-----< id-PRACHConstant >-----#
    id_PRACHConstant = INT(name='id-PRACHConstant', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRACHConstant._val = 381
    
    #-----< id-PRACH-ParametersListIE-CTCH-ReconfRqstFDD >-----#
    id_PRACH_ParametersListIE_CTCH_ReconfRqstFDD = INT(name='id-PRACH-ParametersListIE-CTCH-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRACH_ParametersListIE_CTCH_ReconfRqstFDD._val = 383
    
    #-----< id-PUSCHConstant >-----#
    id_PUSCHConstant = INT(name='id-PUSCHConstant', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCHConstant._val = 384
    
    #-----< id-RACH-Parameters-CTCH-SetupRsp >-----#
    id_RACH_Parameters_CTCH_SetupRsp = INT(name='id-RACH-Parameters-CTCH-SetupRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RACH_Parameters_CTCH_SetupRsp._val = 385
    
    #-----< id-Unused-ProtocolIE-ID-443 >-----#
    id_Unused_ProtocolIE_ID_443 = INT(name='id-Unused-ProtocolIE-ID-443', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_443._val = 443
    
    #-----< id-Synchronisation-Configuration-Cell-ReconfRqst >-----#
    id_Synchronisation_Configuration_Cell_ReconfRqst = INT(name='id-Synchronisation-Configuration-Cell-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Synchronisation_Configuration_Cell_ReconfRqst._val = 393
    
    #-----< id-Synchronisation-Configuration-Cell-SetupRqst >-----#
    id_Synchronisation_Configuration_Cell_SetupRqst = INT(name='id-Synchronisation-Configuration-Cell-SetupRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Synchronisation_Configuration_Cell_SetupRqst._val = 394
    
    #-----< id-Transmission-Gap-Pattern-Sequence-Information >-----#
    id_Transmission_Gap_Pattern_Sequence_Information = INT(name='id-Transmission-Gap-Pattern-Sequence-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Transmission_Gap_Pattern_Sequence_Information._val = 395
    
    #-----< id-UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD >-----#
    id_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD = INT(name='id-UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._val = 396
    
    #-----< id-UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD >-----#
    id_UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD = INT(name='id-UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._val = 397
    
    #-----< id-UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD >-----#
    id_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD = INT(name='id-UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._val = 398
    
    #-----< id-UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD >-----#
    id_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD = INT(name='id-UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._val = 399
    
    #-----< id-UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD >-----#
    id_UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD = INT(name='id-UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._val = 400
    
    #-----< id-UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD >-----#
    id_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD = INT(name='id-UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._val = 401
    
    #-----< id-UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD >-----#
    id_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = INT(name='id-UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._val = 402
    
    #-----< id-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD >-----#
    id_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD = INT(name='id-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD._val = 403
    
    #-----< id-UL-DPCH-InformationModify-AddListIE-RL-ReconfPrepTDD >-----#
    id_UL_DPCH_InformationModify_AddListIE_RL_ReconfPrepTDD = INT(name='id-UL-DPCH-InformationModify-AddListIE-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationModify_AddListIE_RL_ReconfPrepTDD._val = 405
    
    #-----< id-UL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD >-----#
    id_UL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD = INT(name='id-UL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD._val = 406
    
    #-----< id-UL-DPCH-InformationModify-ModifyListIE-RL-ReconfPrepTDD >-----#
    id_UL_DPCH_InformationModify_ModifyListIE_RL_ReconfPrepTDD = INT(name='id-UL-DPCH-InformationModify-ModifyListIE-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationModify_ModifyListIE_RL_ReconfPrepTDD._val = 407
    
    #-----< id-Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD >-----#
    id_Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD = INT(name='id-Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD._val = 408
    
    #-----< id-Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD >-----#
    id_Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD = INT(name='id-Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD._val = 409
    
    #-----< id-CommunicationContextInfoItem-Reset >-----#
    id_CommunicationContextInfoItem_Reset = INT(name='id-CommunicationContextInfoItem-Reset', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommunicationContextInfoItem_Reset._val = 412
    
    #-----< id-CommunicationControlPortInfoItem-Reset >-----#
    id_CommunicationControlPortInfoItem_Reset = INT(name='id-CommunicationControlPortInfoItem-Reset', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommunicationControlPortInfoItem_Reset._val = 414
    
    #-----< id-ResetIndicator >-----#
    id_ResetIndicator = INT(name='id-ResetIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResetIndicator._val = 416
    
    #-----< id-Unused-ProtocolIE-ID-417 >-----#
    id_Unused_ProtocolIE_ID_417 = INT(name='id-Unused-ProtocolIE-ID-417', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_417._val = 417
    
    #-----< id-Unused-ProtocolIE-ID-418 >-----#
    id_Unused_ProtocolIE_ID_418 = INT(name='id-Unused-ProtocolIE-ID-418', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_418._val = 418
    
    #-----< id-Unused-ProtocolIE-ID-419 >-----#
    id_Unused_ProtocolIE_ID_419 = INT(name='id-Unused-ProtocolIE-ID-419', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_419._val = 419
    
    #-----< id-Unused-ProtocolIE-ID-142 >-----#
    id_Unused_ProtocolIE_ID_142 = INT(name='id-Unused-ProtocolIE-ID-142', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_142._val = 142
    
    #-----< id-TimingAdvanceApplied >-----#
    id_TimingAdvanceApplied = INT(name='id-TimingAdvanceApplied', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimingAdvanceApplied._val = 287
    
    #-----< id-CFNReportingIndicator >-----#
    id_CFNReportingIndicator = INT(name='id-CFNReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CFNReportingIndicator._val = 6
    
    #-----< id-SFNReportingIndicator >-----#
    id_SFNReportingIndicator = INT(name='id-SFNReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFNReportingIndicator._val = 11
    
    #-----< id-InnerLoopDLPCStatus >-----#
    id_InnerLoopDLPCStatus = INT(name='id-InnerLoopDLPCStatus', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InnerLoopDLPCStatus._val = 12
    
    #-----< id-TimeslotISCPInfo >-----#
    id_TimeslotISCPInfo = INT(name='id-TimeslotISCPInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeslotISCPInfo._val = 283
    
    #-----< id-PICH-ParametersItem-CTCH-SetupRqstTDD >-----#
    id_PICH_ParametersItem_CTCH_SetupRqstTDD = INT(name='id-PICH-ParametersItem-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PICH_ParametersItem_CTCH_SetupRqstTDD._val = 167
    
    #-----< id-PRACH-ParametersItem-CTCH-SetupRqstTDD >-----#
    id_PRACH_ParametersItem_CTCH_SetupRqstTDD = INT(name='id-PRACH-ParametersItem-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRACH_ParametersItem_CTCH_SetupRqstTDD._val = 20
    
    #-----< id-CCTrCH-InformationItem-RL-FailureInd >-----#
    id_CCTrCH_InformationItem_RL_FailureInd = INT(name='id-CCTrCH-InformationItem-RL-FailureInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_InformationItem_RL_FailureInd._val = 46
    
    #-----< id-CCTrCH-InformationItem-RL-RestoreInd >-----#
    id_CCTrCH_InformationItem_RL_RestoreInd = INT(name='id-CCTrCH-InformationItem-RL-RestoreInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_InformationItem_RL_RestoreInd._val = 47
    
    #-----< id-CauseLevel-SyncAdjustmntFailureTDD >-----#
    id_CauseLevel_SyncAdjustmntFailureTDD = INT(name='id-CauseLevel-SyncAdjustmntFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_SyncAdjustmntFailureTDD._val = 420
    
    #-----< id-CellAdjustmentInfo-SyncAdjustmntRqstTDD >-----#
    id_CellAdjustmentInfo_SyncAdjustmntRqstTDD = INT(name='id-CellAdjustmentInfo-SyncAdjustmntRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellAdjustmentInfo_SyncAdjustmntRqstTDD._val = 421
    
    #-----< id-CellAdjustmentInfoItem-SyncAdjustmentRqstTDD >-----#
    id_CellAdjustmentInfoItem_SyncAdjustmentRqstTDD = INT(name='id-CellAdjustmentInfoItem-SyncAdjustmentRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellAdjustmentInfoItem_SyncAdjustmentRqstTDD._val = 494
    
    #-----< id-CellSyncBurstInfoList-CellSyncReconfRqstTDD >-----#
    id_CellSyncBurstInfoList_CellSyncReconfRqstTDD = INT(name='id-CellSyncBurstInfoList-CellSyncReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellSyncBurstInfoList_CellSyncReconfRqstTDD._val = 482
    
    #-----< id-CellSyncBurstTransInit-CellSyncInitiationRqstTDD >-----#
    id_CellSyncBurstTransInit_CellSyncInitiationRqstTDD = INT(name='id-CellSyncBurstTransInit-CellSyncInitiationRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellSyncBurstTransInit_CellSyncInitiationRqstTDD._val = 422
    
    #-----< id-CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD >-----#
    id_CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD = INT(name='id-CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD._val = 423
    
    #-----< id-CellSyncBurstTransReconfiguration-CellSyncReconfRqstTDD >-----#
    id_CellSyncBurstTransReconfiguration_CellSyncReconfRqstTDD = INT(name='id-CellSyncBurstTransReconfiguration-CellSyncReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellSyncBurstTransReconfiguration_CellSyncReconfRqstTDD._val = 424
    
    #-----< id-CellSyncBurstMeasReconfiguration-CellSyncReconfRqstTDD >-----#
    id_CellSyncBurstMeasReconfiguration_CellSyncReconfRqstTDD = INT(name='id-CellSyncBurstMeasReconfiguration-CellSyncReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellSyncBurstMeasReconfiguration_CellSyncReconfRqstTDD._val = 425
    
    #-----< id-CellSyncBurstTransInfoList-CellSyncReconfRqstTDD >-----#
    id_CellSyncBurstTransInfoList_CellSyncReconfRqstTDD = INT(name='id-CellSyncBurstTransInfoList-CellSyncReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellSyncBurstTransInfoList_CellSyncReconfRqstTDD._val = 426
    
    #-----< id-CellSyncBurstMeasInfoList-CellSyncReconfRqstTDD >-----#
    id_CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD = INT(name='id-CellSyncBurstMeasInfoList-CellSyncReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD._val = 427
    
    #-----< id-CellSyncBurstTransReconfInfo-CellSyncReconfRqstTDD >-----#
    id_CellSyncBurstTransReconfInfo_CellSyncReconfRqstTDD = INT(name='id-CellSyncBurstTransReconfInfo-CellSyncReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellSyncBurstTransReconfInfo_CellSyncReconfRqstTDD._val = 428
    
    #-----< id-CellSyncInfo-CellSyncReprtTDD >-----#
    id_CellSyncInfo_CellSyncReprtTDD = INT(name='id-CellSyncInfo-CellSyncReprtTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellSyncInfo_CellSyncReprtTDD._val = 429
    
    #-----< id-CSBTransmissionID >-----#
    id_CSBTransmissionID = INT(name='id-CSBTransmissionID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSBTransmissionID._val = 430
    
    #-----< id-CSBMeasurementID >-----#
    id_CSBMeasurementID = INT(name='id-CSBMeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSBMeasurementID._val = 431
    
    #-----< id-IntStdPhCellSyncInfoItem-CellSyncReprtTDD >-----#
    id_IntStdPhCellSyncInfoItem_CellSyncReprtTDD = INT(name='id-IntStdPhCellSyncInfoItem-CellSyncReprtTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntStdPhCellSyncInfoItem_CellSyncReprtTDD._val = 432
    
    #-----< id-NCyclesPerSFNperiod >-----#
    id_NCyclesPerSFNperiod = INT(name='id-NCyclesPerSFNperiod', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NCyclesPerSFNperiod._val = 433
    
    #-----< id-NRepetitionsPerCyclePeriod >-----#
    id_NRepetitionsPerCyclePeriod = INT(name='id-NRepetitionsPerCyclePeriod', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRepetitionsPerCyclePeriod._val = 434
    
    #-----< id-SyncFrameNumber >-----#
    id_SyncFrameNumber = INT(name='id-SyncFrameNumber', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SyncFrameNumber._val = 437
    
    #-----< id-SynchronisationReportType >-----#
    id_SynchronisationReportType = INT(name='id-SynchronisationReportType', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SynchronisationReportType._val = 438
    
    #-----< id-SynchronisationReportCharacteristics >-----#
    id_SynchronisationReportCharacteristics = INT(name='id-SynchronisationReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SynchronisationReportCharacteristics._val = 439
    
    #-----< id-Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD >-----#
    id_Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD = INT(name='id-Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD._val = 440
    
    #-----< id-LateEntranceCellSyncInfoItem-CellSyncReprtTDD >-----#
    id_LateEntranceCellSyncInfoItem_CellSyncReprtTDD = INT(name='id-LateEntranceCellSyncInfoItem-CellSyncReprtTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LateEntranceCellSyncInfoItem_CellSyncReprtTDD._val = 119
    
    #-----< id-ReferenceClockAvailability >-----#
    id_ReferenceClockAvailability = INT(name='id-ReferenceClockAvailability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReferenceClockAvailability._val = 435
    
    #-----< id-ReferenceSFNoffset >-----#
    id_ReferenceSFNoffset = INT(name='id-ReferenceSFNoffset', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReferenceSFNoffset._val = 436
    
    #-----< id-InformationExchangeID >-----#
    id_InformationExchangeID = INT(name='id-InformationExchangeID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeID._val = 444
    
    #-----< id-InformationExchangeObjectType-InfEx-Rqst >-----#
    id_InformationExchangeObjectType_InfEx_Rqst = INT(name='id-InformationExchangeObjectType-InfEx-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeObjectType_InfEx_Rqst._val = 445
    
    #-----< id-InformationType >-----#
    id_InformationType = INT(name='id-InformationType', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationType._val = 446
    
    #-----< id-InformationReportCharacteristics >-----#
    id_InformationReportCharacteristics = INT(name='id-InformationReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationReportCharacteristics._val = 447
    
    #-----< id-InformationExchangeObjectType-InfEx-Rsp >-----#
    id_InformationExchangeObjectType_InfEx_Rsp = INT(name='id-InformationExchangeObjectType-InfEx-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeObjectType_InfEx_Rsp._val = 448
    
    #-----< id-InformationExchangeObjectType-InfEx-Rprt >-----#
    id_InformationExchangeObjectType_InfEx_Rprt = INT(name='id-InformationExchangeObjectType-InfEx-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeObjectType_InfEx_Rprt._val = 449
    
    #-----< id-IPDLParameter-Information-Cell-ReconfRqstFDD >-----#
    id_IPDLParameter_Information_Cell_ReconfRqstFDD = INT(name='id-IPDLParameter-Information-Cell-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IPDLParameter_Information_Cell_ReconfRqstFDD._val = 451
    
    #-----< id-IPDLParameter-Information-Cell-SetupRqstFDD >-----#
    id_IPDLParameter_Information_Cell_SetupRqstFDD = INT(name='id-IPDLParameter-Information-Cell-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IPDLParameter_Information_Cell_SetupRqstFDD._val = 452
    
    #-----< id-IPDLParameter-Information-Cell-ReconfRqstTDD >-----#
    id_IPDLParameter_Information_Cell_ReconfRqstTDD = INT(name='id-IPDLParameter-Information-Cell-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IPDLParameter_Information_Cell_ReconfRqstTDD._val = 453
    
    #-----< id-IPDLParameter-Information-Cell-SetupRqstTDD >-----#
    id_IPDLParameter_Information_Cell_SetupRqstTDD = INT(name='id-IPDLParameter-Information-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IPDLParameter_Information_Cell_SetupRqstTDD._val = 454
    
    #-----< id-DL-DPCH-LCR-Information-RL-SetupRqstTDD >-----#
    id_DL_DPCH_LCR_Information_RL_SetupRqstTDD = INT(name='id-DL-DPCH-LCR-Information-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_LCR_Information_RL_SetupRqstTDD._val = 74
    
    #-----< id-DwPCH-LCR-Information >-----#
    id_DwPCH_LCR_Information = INT(name='id-DwPCH-LCR-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DwPCH_LCR_Information._val = 78
    
    #-----< id-DwPCH-LCR-InformationList-AuditRsp >-----#
    id_DwPCH_LCR_InformationList_AuditRsp = INT(name='id-DwPCH-LCR-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DwPCH_LCR_InformationList_AuditRsp._val = 90
    
    #-----< id-DwPCH-LCR-Information-Cell-SetupRqstTDD >-----#
    id_DwPCH_LCR_Information_Cell_SetupRqstTDD = INT(name='id-DwPCH-LCR-Information-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DwPCH_LCR_Information_Cell_SetupRqstTDD._val = 97
    
    #-----< id-DwPCH-LCR-Information-Cell-ReconfRqstTDD >-----#
    id_DwPCH_LCR_Information_Cell_ReconfRqstTDD = INT(name='id-DwPCH-LCR-Information-Cell-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DwPCH_LCR_Information_Cell_ReconfRqstTDD._val = 99
    
    #-----< id-DwPCH-LCR-Information-ResourceStatusInd >-----#
    id_DwPCH_LCR_Information_ResourceStatusInd = INT(name='id-DwPCH-LCR-Information-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DwPCH_LCR_Information_ResourceStatusInd._val = 101
    
    #-----< id-maxFACH-Power-LCR-CTCH-SetupRqstTDD >-----#
    id_maxFACH_Power_LCR_CTCH_SetupRqstTDD = INT(name='id-maxFACH-Power-LCR-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_maxFACH_Power_LCR_CTCH_SetupRqstTDD._val = 154
    
    #-----< id-maxFACH-Power-LCR-CTCH-ReconfRqstTDD >-----#
    id_maxFACH_Power_LCR_CTCH_ReconfRqstTDD = INT(name='id-maxFACH-Power-LCR-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_maxFACH_Power_LCR_CTCH_ReconfRqstTDD._val = 174
    
    #-----< id-FPACH-LCR-Information >-----#
    id_FPACH_LCR_Information = INT(name='id-FPACH-LCR-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FPACH_LCR_Information._val = 290
    
    #-----< id-FPACH-LCR-Information-AuditRsp >-----#
    id_FPACH_LCR_Information_AuditRsp = INT(name='id-FPACH-LCR-Information-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FPACH_LCR_Information_AuditRsp._val = 292
    
    #-----< id-FPACH-LCR-InformationList-AuditRsp >-----#
    id_FPACH_LCR_InformationList_AuditRsp = INT(name='id-FPACH-LCR-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FPACH_LCR_InformationList_AuditRsp._val = 22
    
    #-----< id-FPACH-LCR-InformationList-ResourceStatusInd >-----#
    id_FPACH_LCR_InformationList_ResourceStatusInd = INT(name='id-FPACH-LCR-InformationList-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FPACH_LCR_InformationList_ResourceStatusInd._val = 311
    
    #-----< id-FPACH-LCR-Parameters-CTCH-SetupRqstTDD >-----#
    id_FPACH_LCR_Parameters_CTCH_SetupRqstTDD = INT(name='id-FPACH-LCR-Parameters-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FPACH_LCR_Parameters_CTCH_SetupRqstTDD._val = 312
    
    #-----< id-FPACH-LCR-Parameters-CTCH-ReconfRqstTDD >-----#
    id_FPACH_LCR_Parameters_CTCH_ReconfRqstTDD = INT(name='id-FPACH-LCR-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FPACH_LCR_Parameters_CTCH_ReconfRqstTDD._val = 314
    
    #-----< id-PCCPCH-LCR-Information-Cell-SetupRqstTDD >-----#
    id_PCCPCH_LCR_Information_Cell_SetupRqstTDD = INT(name='id-PCCPCH-LCR-Information-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCCPCH_LCR_Information_Cell_SetupRqstTDD._val = 456
    
    #-----< id-PCH-Power-LCR-CTCH-SetupRqstTDD >-----#
    id_PCH_Power_LCR_CTCH_SetupRqstTDD = INT(name='id-PCH-Power-LCR-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCH_Power_LCR_CTCH_SetupRqstTDD._val = 457
    
    #-----< id-PCH-Power-LCR-CTCH-ReconfRqstTDD >-----#
    id_PCH_Power_LCR_CTCH_ReconfRqstTDD = INT(name='id-PCH-Power-LCR-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCH_Power_LCR_CTCH_ReconfRqstTDD._val = 458
    
    #-----< id-PICH-LCR-Parameters-CTCH-SetupRqstTDD >-----#
    id_PICH_LCR_Parameters_CTCH_SetupRqstTDD = INT(name='id-PICH-LCR-Parameters-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PICH_LCR_Parameters_CTCH_SetupRqstTDD._val = 459
    
    #-----< id-PRACH-LCR-ParametersList-CTCH-SetupRqstTDD >-----#
    id_PRACH_LCR_ParametersList_CTCH_SetupRqstTDD = INT(name='id-PRACH-LCR-ParametersList-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRACH_LCR_ParametersList_CTCH_SetupRqstTDD._val = 461
    
    #-----< id-RL-InformationResponse-LCR-RL-SetupRspTDD >-----#
    id_RL_InformationResponse_LCR_RL_SetupRspTDD = INT(name='id-RL-InformationResponse-LCR-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponse_LCR_RL_SetupRspTDD._val = 463
    
    #-----< id-Secondary-CCPCH-LCR-parameterList-CTCH-SetupRqstTDD >-----#
    id_Secondary_CCPCH_LCR_parameterList_CTCH_SetupRqstTDD = INT(name='id-Secondary-CCPCH-LCR-parameterList-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Secondary_CCPCH_LCR_parameterList_CTCH_SetupRqstTDD._val = 465
    
    #-----< id-TimeSlot >-----#
    id_TimeSlot = INT(name='id-TimeSlot', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSlot._val = 495
    
    #-----< id-TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD >-----#
    id_TimeSlotConfigurationList_LCR_Cell_ReconfRqstTDD = INT(name='id-TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSlotConfigurationList_LCR_Cell_ReconfRqstTDD._val = 466
    
    #-----< id-TimeSlotConfigurationList-LCR-Cell-SetupRqstTDD >-----#
    id_TimeSlotConfigurationList_LCR_Cell_SetupRqstTDD = INT(name='id-TimeSlotConfigurationList-LCR-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSlotConfigurationList_LCR_Cell_SetupRqstTDD._val = 467
    
    #-----< id-TimeslotISCP-LCR-InfoList-RL-SetupRqstTDD >-----#
    id_TimeslotISCP_LCR_InfoList_RL_SetupRqstTDD = INT(name='id-TimeslotISCP-LCR-InfoList-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeslotISCP_LCR_InfoList_RL_SetupRqstTDD._val = 468
    
    #-----< id-TimeSlotLCR-CM-Rqst >-----#
    id_TimeSlotLCR_CM_Rqst = INT(name='id-TimeSlotLCR-CM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSlotLCR_CM_Rqst._val = 469
    
    #-----< id-UL-DPCH-LCR-Information-RL-SetupRqstTDD >-----#
    id_UL_DPCH_LCR_Information_RL_SetupRqstTDD = INT(name='id-UL-DPCH-LCR-Information-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_LCR_Information_RL_SetupRqstTDD._val = 470
    
    #-----< id-DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD >-----#
    id_DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD = INT(name='id-DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD._val = 472
    
    #-----< id-UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD >-----#
    id_UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD = INT(name='id-UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD._val = 473
    
    #-----< id-TimeslotISCP-InformationList-LCR-RL-AdditionRqstTDD >-----#
    id_TimeslotISCP_InformationList_LCR_RL_AdditionRqstTDD = INT(name='id-TimeslotISCP-InformationList-LCR-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeslotISCP_InformationList_LCR_RL_AdditionRqstTDD._val = 474
    
    #-----< id-DL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD >-----#
    id_DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD = INT(name='id-DL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD._val = 475
    
    #-----< id-DL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD >-----#
    id_DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD = INT(name='id-DL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD._val = 477
    
    #-----< id-DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    id_DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD = INT(name='id-DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD._val = 479
    
    #-----< id-TimeslotISCPInfoList-LCR-DL-PC-RqstTDD >-----#
    id_TimeslotISCPInfoList_LCR_DL_PC_RqstTDD = INT(name='id-TimeslotISCPInfoList-LCR-DL-PC-RqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeslotISCPInfoList_LCR_DL_PC_RqstTDD._val = 480
    
    #-----< id-UL-DPCH-LCR-InformationAddListIE-RL-ReconfPrepTDD >-----#
    id_UL_DPCH_LCR_InformationAddListIE_RL_ReconfPrepTDD = INT(name='id-UL-DPCH-LCR-InformationAddListIE-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_LCR_InformationAddListIE_RL_ReconfPrepTDD._val = 481
    
    #-----< id-UL-DPCH-LCR-InformationModify-AddList >-----#
    id_UL_DPCH_LCR_InformationModify_AddList = INT(name='id-UL-DPCH-LCR-InformationModify-AddList', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_LCR_InformationModify_AddList._val = 483
    
    #-----< id-UL-TimeslotLCR-Information-RL-ReconfPrepTDD >-----#
    id_UL_TimeslotLCR_Information_RL_ReconfPrepTDD = INT(name='id-UL-TimeslotLCR-Information-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_TimeslotLCR_Information_RL_ReconfPrepTDD._val = 485
    
    #-----< id-UL-SIRTarget >-----#
    id_UL_SIRTarget = INT(name='id-UL-SIRTarget', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_SIRTarget._val = 510
    
    #-----< id-PDSCH-AddInformation-LCR-PSCH-ReconfRqst >-----#
    id_PDSCH_AddInformation_LCR_PSCH_ReconfRqst = INT(name='id-PDSCH-AddInformation-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCH_AddInformation_LCR_PSCH_ReconfRqst._val = 486
    
    #-----< id-PDSCH-AddInformation-LCR-AddListIE-PSCH-ReconfRqst >-----#
    id_PDSCH_AddInformation_LCR_AddListIE_PSCH_ReconfRqst = INT(name='id-PDSCH-AddInformation-LCR-AddListIE-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCH_AddInformation_LCR_AddListIE_PSCH_ReconfRqst._val = 487
    
    #-----< id-Unused-ProtocolIE-ID-26 >-----#
    id_Unused_ProtocolIE_ID_26 = INT(name='id-Unused-ProtocolIE-ID-26', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_26._val = 26
    
    #-----< id-Unused-ProtocolIE-ID-27 >-----#
    id_Unused_ProtocolIE_ID_27 = INT(name='id-Unused-ProtocolIE-ID-27', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_27._val = 27
    
    #-----< id-PDSCH-ModifyInformation-LCR-PSCH-ReconfRqst >-----#
    id_PDSCH_ModifyInformation_LCR_PSCH_ReconfRqst = INT(name='id-PDSCH-ModifyInformation-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCH_ModifyInformation_LCR_PSCH_ReconfRqst._val = 488
    
    #-----< id-PDSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst >-----#
    id_PDSCH_ModifyInformation_LCR_ModifyListIE_PSCH_ReconfRqst = INT(name='id-PDSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCH_ModifyInformation_LCR_ModifyListIE_PSCH_ReconfRqst._val = 489
    
    #-----< id-PUSCH-AddInformation-LCR-PSCH-ReconfRqst >-----#
    id_PUSCH_AddInformation_LCR_PSCH_ReconfRqst = INT(name='id-PUSCH-AddInformation-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_AddInformation_LCR_PSCH_ReconfRqst._val = 490
    
    #-----< id-PUSCH-AddInformation-LCR-AddListIE-PSCH-ReconfRqst >-----#
    id_PUSCH_AddInformation_LCR_AddListIE_PSCH_ReconfRqst = INT(name='id-PUSCH-AddInformation-LCR-AddListIE-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_AddInformation_LCR_AddListIE_PSCH_ReconfRqst._val = 491
    
    #-----< id-PUSCH-ModifyInformation-LCR-PSCH-ReconfRqst >-----#
    id_PUSCH_ModifyInformation_LCR_PSCH_ReconfRqst = INT(name='id-PUSCH-ModifyInformation-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_ModifyInformation_LCR_PSCH_ReconfRqst._val = 492
    
    #-----< id-PUSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst >-----#
    id_PUSCH_ModifyInformation_LCR_ModifyListIE_PSCH_ReconfRqst = INT(name='id-PUSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_ModifyInformation_LCR_ModifyListIE_PSCH_ReconfRqst._val = 493
    
    #-----< id-timeslotInfo-CellSyncInitiationRqstTDD >-----#
    id_timeslotInfo_CellSyncInitiationRqstTDD = INT(name='id-timeslotInfo-CellSyncInitiationRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_timeslotInfo_CellSyncInitiationRqstTDD._val = 496
    
    #-----< id-SyncReportType-CellSyncReprtTDD >-----#
    id_SyncReportType_CellSyncReprtTDD = INT(name='id-SyncReportType-CellSyncReprtTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SyncReportType_CellSyncReprtTDD._val = 497
    
    #-----< id-Power-Local-Cell-Group-InformationItem-AuditRsp >-----#
    id_Power_Local_Cell_Group_InformationItem_AuditRsp = INT(name='id-Power-Local-Cell-Group-InformationItem-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Power_Local_Cell_Group_InformationItem_AuditRsp._val = 498
    
    #-----< id-Power-Local-Cell-Group-InformationItem-ResourceStatusInd >-----#
    id_Power_Local_Cell_Group_InformationItem_ResourceStatusInd = INT(name='id-Power-Local-Cell-Group-InformationItem-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Power_Local_Cell_Group_InformationItem_ResourceStatusInd._val = 499
    
    #-----< id-Power-Local-Cell-Group-InformationItem2-ResourceStatusInd >-----#
    id_Power_Local_Cell_Group_InformationItem2_ResourceStatusInd = INT(name='id-Power-Local-Cell-Group-InformationItem2-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Power_Local_Cell_Group_InformationItem2_ResourceStatusInd._val = 500
    
    #-----< id-Power-Local-Cell-Group-InformationList-AuditRsp >-----#
    id_Power_Local_Cell_Group_InformationList_AuditRsp = INT(name='id-Power-Local-Cell-Group-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Power_Local_Cell_Group_InformationList_AuditRsp._val = 501
    
    #-----< id-Power-Local-Cell-Group-InformationList-ResourceStatusInd >-----#
    id_Power_Local_Cell_Group_InformationList_ResourceStatusInd = INT(name='id-Power-Local-Cell-Group-InformationList-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Power_Local_Cell_Group_InformationList_ResourceStatusInd._val = 502
    
    #-----< id-Power-Local-Cell-Group-InformationList2-ResourceStatusInd >-----#
    id_Power_Local_Cell_Group_InformationList2_ResourceStatusInd = INT(name='id-Power-Local-Cell-Group-InformationList2-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Power_Local_Cell_Group_InformationList2_ResourceStatusInd._val = 503
    
    #-----< id-Power-Local-Cell-Group-ID >-----#
    id_Power_Local_Cell_Group_ID = INT(name='id-Power-Local-Cell-Group-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Power_Local_Cell_Group_ID._val = 504
    
    #-----< id-PUSCH-Info-DM-Rqst >-----#
    id_PUSCH_Info_DM_Rqst = INT(name='id-PUSCH-Info-DM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_Info_DM_Rqst._val = 505
    
    #-----< id-PUSCH-Info-DM-Rsp >-----#
    id_PUSCH_Info_DM_Rsp = INT(name='id-PUSCH-Info-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_Info_DM_Rsp._val = 506
    
    #-----< id-PUSCH-Info-DM-Rprt >-----#
    id_PUSCH_Info_DM_Rprt = INT(name='id-PUSCH-Info-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_Info_DM_Rprt._val = 507
    
    #-----< id-InitDL-Power >-----#
    id_InitDL_Power = INT(name='id-InitDL-Power', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InitDL_Power._val = 509
    
    #-----< id-cellSyncBurstRepetitionPeriod >-----#
    id_cellSyncBurstRepetitionPeriod = INT(name='id-cellSyncBurstRepetitionPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cellSyncBurstRepetitionPeriod._val = 511
    
    #-----< id-ReportCharacteristicsType-OnModification >-----#
    id_ReportCharacteristicsType_OnModification = INT(name='id-ReportCharacteristicsType-OnModification', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportCharacteristicsType_OnModification._val = 512
    
    #-----< id-SFNSFNMeasurementValueInformation >-----#
    id_SFNSFNMeasurementValueInformation = INT(name='id-SFNSFNMeasurementValueInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFNSFNMeasurementValueInformation._val = 513
    
    #-----< id-SFNSFNMeasurementThresholdInformation >-----#
    id_SFNSFNMeasurementThresholdInformation = INT(name='id-SFNSFNMeasurementThresholdInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFNSFNMeasurementThresholdInformation._val = 514
    
    #-----< id-TUTRANGPSMeasurementValueInformation >-----#
    id_TUTRANGPSMeasurementValueInformation = INT(name='id-TUTRANGPSMeasurementValueInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TUTRANGPSMeasurementValueInformation._val = 515
    
    #-----< id-TUTRANGPSMeasurementThresholdInformation >-----#
    id_TUTRANGPSMeasurementThresholdInformation = INT(name='id-TUTRANGPSMeasurementThresholdInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TUTRANGPSMeasurementThresholdInformation._val = 516
    
    #-----< id-Rx-Timing-Deviation-Value-LCR >-----#
    id_Rx_Timing_Deviation_Value_LCR = INT(name='id-Rx-Timing-Deviation-Value-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Rx_Timing_Deviation_Value_LCR._val = 520
    
    #-----< id-RL-InformationResponse-LCR-RL-AdditionRspTDD >-----#
    id_RL_InformationResponse_LCR_RL_AdditionRspTDD = INT(name='id-RL-InformationResponse-LCR-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponse_LCR_RL_AdditionRspTDD._val = 51
    
    #-----< id-DL-PowerBalancing-Information >-----#
    id_DL_PowerBalancing_Information = INT(name='id-DL-PowerBalancing-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_PowerBalancing_Information._val = 28
    
    #-----< id-DL-PowerBalancing-ActivationIndicator >-----#
    id_DL_PowerBalancing_ActivationIndicator = INT(name='id-DL-PowerBalancing-ActivationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_PowerBalancing_ActivationIndicator._val = 29
    
    #-----< id-DL-PowerBalancing-UpdatedIndicator >-----#
    id_DL_PowerBalancing_UpdatedIndicator = INT(name='id-DL-PowerBalancing-UpdatedIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_PowerBalancing_UpdatedIndicator._val = 30
    
    #-----< id-CCTrCH-Initial-DL-Power-RL-SetupRqstTDD >-----#
    id_CCTrCH_Initial_DL_Power_RL_SetupRqstTDD = INT(name='id-CCTrCH-Initial-DL-Power-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Initial_DL_Power_RL_SetupRqstTDD._val = 517
    
    #-----< id-CCTrCH-Initial-DL-Power-RL-AdditionRqstTDD >-----#
    id_CCTrCH_Initial_DL_Power_RL_AdditionRqstTDD = INT(name='id-CCTrCH-Initial-DL-Power-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Initial_DL_Power_RL_AdditionRqstTDD._val = 518
    
    #-----< id-CCTrCH-Initial-DL-Power-RL-ReconfPrepTDD >-----#
    id_CCTrCH_Initial_DL_Power_RL_ReconfPrepTDD = INT(name='id-CCTrCH-Initial-DL-Power-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Initial_DL_Power_RL_ReconfPrepTDD._val = 519
    
    #-----< id-IPDLParameter-Information-LCR-Cell-SetupRqstTDD >-----#
    id_IPDLParameter_Information_LCR_Cell_SetupRqstTDD = INT(name='id-IPDLParameter-Information-LCR-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IPDLParameter_Information_LCR_Cell_SetupRqstTDD._val = 41
    
    #-----< id-IPDLParameter-Information-LCR-Cell-ReconfRqstTDD >-----#
    id_IPDLParameter_Information_LCR_Cell_ReconfRqstTDD = INT(name='id-IPDLParameter-Information-LCR-Cell-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IPDLParameter_Information_LCR_Cell_ReconfRqstTDD._val = 42
    
    #-----< id-HS-PDSCH-HS-SCCH-E-AGCH-E-RGCH-E-HICH-MaxPower-PSCH-ReconfRqst >-----#
    id_HS_PDSCH_HS_SCCH_E_AGCH_E_RGCH_E_HICH_MaxPower_PSCH_ReconfRqst = INT(name='id-HS-PDSCH-HS-SCCH-E-AGCH-E-RGCH-E-HICH-MaxPower-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_PDSCH_HS_SCCH_E_AGCH_E_RGCH_E_HICH_MaxPower_PSCH_ReconfRqst._val = 522
    
    #-----< id-HS-PDSCH-HS-SCCH-ScramblingCode-PSCH-ReconfRqst >-----#
    id_HS_PDSCH_HS_SCCH_ScramblingCode_PSCH_ReconfRqst = INT(name='id-HS-PDSCH-HS-SCCH-ScramblingCode-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_PDSCH_HS_SCCH_ScramblingCode_PSCH_ReconfRqst._val = 523
    
    #-----< id-HS-PDSCH-FDD-Code-Information-PSCH-ReconfRqst >-----#
    id_HS_PDSCH_FDD_Code_Information_PSCH_ReconfRqst = INT(name='id-HS-PDSCH-FDD-Code-Information-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_PDSCH_FDD_Code_Information_PSCH_ReconfRqst._val = 524
    
    #-----< id-HS-SCCH-FDD-Code-Information-PSCH-ReconfRqst >-----#
    id_HS_SCCH_FDD_Code_Information_PSCH_ReconfRqst = INT(name='id-HS-SCCH-FDD-Code-Information-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_SCCH_FDD_Code_Information_PSCH_ReconfRqst._val = 525
    
    #-----< id-HS-PDSCH-TDD-Information-PSCH-ReconfRqst >-----#
    id_HS_PDSCH_TDD_Information_PSCH_ReconfRqst = INT(name='id-HS-PDSCH-TDD-Information-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_PDSCH_TDD_Information_PSCH_ReconfRqst._val = 526
    
    #-----< id-Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst >-----#
    id_Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst = INT(name='id-Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst._val = 527
    
    #-----< id-Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst >-----#
    id_Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst = INT(name='id-Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst._val = 528
    
    #-----< id-Delete-From-HS-SCCH-Resource-Pool-PSCH-ReconfRqst >-----#
    id_Delete_From_HS_SCCH_Resource_Pool_PSCH_ReconfRqst = INT(name='id-Delete-From-HS-SCCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Delete_From_HS_SCCH_Resource_Pool_PSCH_ReconfRqst._val = 529
    
    #-----< id-bindingID >-----#
    id_bindingID = INT(name='id-bindingID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_bindingID._val = 102
    
    #-----< id-RL-Specific-DCH-Info >-----#
    id_RL_Specific_DCH_Info = INT(name='id-RL-Specific-DCH-Info', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Specific_DCH_Info._val = 103
    
    #-----< id-transportlayeraddress >-----#
    id_transportlayeraddress = INT(name='id-transportlayeraddress', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_transportlayeraddress._val = 104
    
    #-----< id-DelayedActivation >-----#
    id_DelayedActivation = INT(name='id-DelayedActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DelayedActivation._val = 231
    
    #-----< id-DelayedActivationList-RL-ActivationCmdFDD >-----#
    id_DelayedActivationList_RL_ActivationCmdFDD = INT(name='id-DelayedActivationList-RL-ActivationCmdFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DelayedActivationList_RL_ActivationCmdFDD._val = 232
    
    #-----< id-DelayedActivationInformation-RL-ActivationCmdFDD >-----#
    id_DelayedActivationInformation_RL_ActivationCmdFDD = INT(name='id-DelayedActivationInformation-RL-ActivationCmdFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DelayedActivationInformation_RL_ActivationCmdFDD._val = 233
    
    #-----< id-DelayedActivationList-RL-ActivationCmdTDD >-----#
    id_DelayedActivationList_RL_ActivationCmdTDD = INT(name='id-DelayedActivationList-RL-ActivationCmdTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DelayedActivationList_RL_ActivationCmdTDD._val = 234
    
    #-----< id-DelayedActivationInformation-RL-ActivationCmdTDD >-----#
    id_DelayedActivationInformation_RL_ActivationCmdTDD = INT(name='id-DelayedActivationInformation-RL-ActivationCmdTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DelayedActivationInformation_RL_ActivationCmdTDD._val = 235
    
    #-----< id-neighbouringTDDCellMeasurementInformationLCR >-----#
    id_neighbouringTDDCellMeasurementInformationLCR = INT(name='id-neighbouringTDDCellMeasurementInformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_neighbouringTDDCellMeasurementInformationLCR._val = 58
    
    #-----< id-SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD >-----#
    id_SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD = INT(name='id-SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD._val = 543
    
    #-----< id-SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD >-----#
    id_SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD = INT(name='id-SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD._val = 544
    
    #-----< id-SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD >-----#
    id_SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD = INT(name='id-SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD._val = 545
    
    #-----< id-SYNCDlCodeIdMeasReconfigurationLCR-CellSyncReconfRqstTDD >-----#
    id_SYNCDlCodeIdMeasReconfigurationLCR_CellSyncReconfRqstTDD = INT(name='id-SYNCDlCodeIdMeasReconfigurationLCR-CellSyncReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SYNCDlCodeIdMeasReconfigurationLCR_CellSyncReconfRqstTDD._val = 546
    
    #-----< id-SYNCDlCodeIdMeasInfoList-CellSyncReconfRqstTDD >-----#
    id_SYNCDlCodeIdMeasInfoList_CellSyncReconfRqstTDD = INT(name='id-SYNCDlCodeIdMeasInfoList-CellSyncReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SYNCDlCodeIdMeasInfoList_CellSyncReconfRqstTDD._val = 547
    
    #-----< id-SyncDLCodeIdsMeasInfoList-CellSyncReprtTDD >-----#
    id_SyncDLCodeIdsMeasInfoList_CellSyncReprtTDD = INT(name='id-SyncDLCodeIdsMeasInfoList-CellSyncReprtTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SyncDLCodeIdsMeasInfoList_CellSyncReprtTDD._val = 548
    
    #-----< id-SyncDLCodeIdThreInfoLCR >-----#
    id_SyncDLCodeIdThreInfoLCR = INT(name='id-SyncDLCodeIdThreInfoLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SyncDLCodeIdThreInfoLCR._val = 549
    
    #-----< id-NSubCyclesPerCyclePeriod-CellSyncReconfRqstTDD >-----#
    id_NSubCyclesPerCyclePeriod_CellSyncReconfRqstTDD = INT(name='id-NSubCyclesPerCyclePeriod-CellSyncReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NSubCyclesPerCyclePeriod_CellSyncReconfRqstTDD._val = 550
    
    #-----< id-DwPCH-Power >-----#
    id_DwPCH_Power = INT(name='id-DwPCH-Power', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DwPCH_Power._val = 551
    
    #-----< id-AccumulatedClockupdate-CellSyncReprtTDD >-----#
    id_AccumulatedClockupdate_CellSyncReprtTDD = INT(name='id-AccumulatedClockupdate-CellSyncReprtTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AccumulatedClockupdate_CellSyncReprtTDD._val = 552
    
    #-----< id-Angle-Of-Arrival-Value-LCR >-----#
    id_Angle_Of_Arrival_Value_LCR = INT(name='id-Angle-Of-Arrival-Value-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Angle_Of_Arrival_Value_LCR._val = 521
    
    #-----< id-HSDSCH-FDD-Information >-----#
    id_HSDSCH_FDD_Information = INT(name='id-HSDSCH-FDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_FDD_Information._val = 530
    
    #-----< id-HSDSCH-FDD-Information-Response >-----#
    id_HSDSCH_FDD_Information_Response = INT(name='id-HSDSCH-FDD-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_FDD_Information_Response._val = 531
    
    #-----< id-HSDSCH-Information-to-Modify >-----#
    id_HSDSCH_Information_to_Modify = INT(name='id-HSDSCH-Information-to-Modify', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Information_to_Modify._val = 534
    
    #-----< id-HSDSCH-RNTI >-----#
    id_HSDSCH_RNTI = INT(name='id-HSDSCH-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_RNTI._val = 535
    
    #-----< id-HSDSCH-TDD-Information >-----#
    id_HSDSCH_TDD_Information = INT(name='id-HSDSCH-TDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_TDD_Information._val = 536
    
    #-----< id-HSDSCH-TDD-Information-Response >-----#
    id_HSDSCH_TDD_Information_Response = INT(name='id-HSDSCH-TDD-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_TDD_Information_Response._val = 537
    
    #-----< id-HSPDSCH-RL-ID >-----#
    id_HSPDSCH_RL_ID = INT(name='id-HSPDSCH-RL-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSPDSCH_RL_ID._val = 541
    
    #-----< id-PrimCCPCH-RSCP-DL-PC-RqstTDD >-----#
    id_PrimCCPCH_RSCP_DL_PC_RqstTDD = INT(name='id-PrimCCPCH-RSCP-DL-PC-RqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimCCPCH_RSCP_DL_PC_RqstTDD._val = 542
    
    #-----< id-Unused-ProtocolIE-ID-64 >-----#
    id_Unused_ProtocolIE_ID_64 = INT(name='id-Unused-ProtocolIE-ID-64', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_64._val = 64
    
    #-----< id-PDSCH-RL-ID >-----#
    id_PDSCH_RL_ID = INT(name='id-PDSCH-RL-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCH_RL_ID._val = 66
    
    #-----< id-HSDSCH-RearrangeList-Bearer-RearrangeInd >-----#
    id_HSDSCH_RearrangeList_Bearer_RearrangeInd = INT(name='id-HSDSCH-RearrangeList-Bearer-RearrangeInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_RearrangeList_Bearer_RearrangeInd._val = 553
    
    #-----< id-UL-Synchronisation-Parameters-LCR >-----#
    id_UL_Synchronisation_Parameters_LCR = INT(name='id-UL-Synchronisation-Parameters-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_Synchronisation_Parameters_LCR._val = 554
    
    #-----< id-HSDSCH-FDD-Update-Information >-----#
    id_HSDSCH_FDD_Update_Information = INT(name='id-HSDSCH-FDD-Update-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_FDD_Update_Information._val = 555
    
    #-----< id-HSDSCH-TDD-Update-Information >-----#
    id_HSDSCH_TDD_Update_Information = INT(name='id-HSDSCH-TDD-Update-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_TDD_Update_Information._val = 556
    
    #-----< id-DL-DPCH-TimeSlotFormat-LCR-ModifyItem-RL-ReconfPrepTDD >-----#
    id_DL_DPCH_TimeSlotFormat_LCR_ModifyItem_RL_ReconfPrepTDD = INT(name='id-DL-DPCH-TimeSlotFormat-LCR-ModifyItem-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_TimeSlotFormat_LCR_ModifyItem_RL_ReconfPrepTDD._val = 558
    
    #-----< id-UL-DPCH-TimeSlotFormat-LCR-ModifyItem-RL-ReconfPrepTDD >-----#
    id_UL_DPCH_TimeSlotFormat_LCR_ModifyItem_RL_ReconfPrepTDD = INT(name='id-UL-DPCH-TimeSlotFormat-LCR-ModifyItem-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_TimeSlotFormat_LCR_ModifyItem_RL_ReconfPrepTDD._val = 559
    
    #-----< id-TDD-TPC-UplinkStepSize-LCR-RL-SetupRqstTDD >-----#
    id_TDD_TPC_UplinkStepSize_LCR_RL_SetupRqstTDD = INT(name='id-TDD-TPC-UplinkStepSize-LCR-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_UplinkStepSize_LCR_RL_SetupRqstTDD._val = 560
    
    #-----< id-TDD-TPC-UplinkStepSize-LCR-RL-AdditionRqstTDD >-----#
    id_TDD_TPC_UplinkStepSize_LCR_RL_AdditionRqstTDD = INT(name='id-TDD-TPC-UplinkStepSize-LCR-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_UplinkStepSize_LCR_RL_AdditionRqstTDD._val = 561
    
    #-----< id-TDD-TPC-DownlinkStepSize-RL-AdditionRqstTDD >-----#
    id_TDD_TPC_DownlinkStepSize_RL_AdditionRqstTDD = INT(name='id-TDD-TPC-DownlinkStepSize-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_DownlinkStepSize_RL_AdditionRqstTDD._val = 562
    
    #-----< id-TDD-TPC-UplinkStepSize-InformationAdd-LCR-RL-ReconfPrepTDD >-----#
    id_TDD_TPC_UplinkStepSize_InformationAdd_LCR_RL_ReconfPrepTDD = INT(name='id-TDD-TPC-UplinkStepSize-InformationAdd-LCR-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_UplinkStepSize_InformationAdd_LCR_RL_ReconfPrepTDD._val = 563
    
    #-----< id-TDD-TPC-UplinkStepSize-InformationModify-LCR-RL-ReconfPrepTDD >-----#
    id_TDD_TPC_UplinkStepSize_InformationModify_LCR_RL_ReconfPrepTDD = INT(name='id-TDD-TPC-UplinkStepSize-InformationModify-LCR-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_UplinkStepSize_InformationModify_LCR_RL_ReconfPrepTDD._val = 564
    
    #-----< id-TDD-TPC-DownlinkStepSize-InformationModify-RL-ReconfPrepTDD >-----#
    id_TDD_TPC_DownlinkStepSize_InformationModify_RL_ReconfPrepTDD = INT(name='id-TDD-TPC-DownlinkStepSize-InformationModify-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_DownlinkStepSize_InformationModify_RL_ReconfPrepTDD._val = 565
    
    #-----< id-TDD-TPC-DownlinkStepSize-InformationAdd-RL-ReconfPrepTDD >-----#
    id_TDD_TPC_DownlinkStepSize_InformationAdd_RL_ReconfPrepTDD = INT(name='id-TDD-TPC-DownlinkStepSize-InformationAdd-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_DownlinkStepSize_InformationAdd_RL_ReconfPrepTDD._val = 566
    
    #-----< id-CCTrCH-Maximum-DL-Power-RL-SetupRqstTDD >-----#
    id_CCTrCH_Maximum_DL_Power_RL_SetupRqstTDD = INT(name='id-CCTrCH-Maximum-DL-Power-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Maximum_DL_Power_RL_SetupRqstTDD._val = 567
    
    #-----< id-CCTrCH-Minimum-DL-Power-RL-SetupRqstTDD >-----#
    id_CCTrCH_Minimum_DL_Power_RL_SetupRqstTDD = INT(name='id-CCTrCH-Minimum-DL-Power-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Minimum_DL_Power_RL_SetupRqstTDD._val = 568
    
    #-----< id-CCTrCH-Maximum-DL-Power-RL-AdditionRqstTDD >-----#
    id_CCTrCH_Maximum_DL_Power_RL_AdditionRqstTDD = INT(name='id-CCTrCH-Maximum-DL-Power-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Maximum_DL_Power_RL_AdditionRqstTDD._val = 569
    
    #-----< id-CCTrCH-Minimum-DL-Power-RL-AdditionRqstTDD >-----#
    id_CCTrCH_Minimum_DL_Power_RL_AdditionRqstTDD = INT(name='id-CCTrCH-Minimum-DL-Power-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Minimum_DL_Power_RL_AdditionRqstTDD._val = 570
    
    #-----< id-CCTrCH-Maximum-DL-Power-InformationAdd-RL-ReconfPrepTDD >-----#
    id_CCTrCH_Maximum_DL_Power_InformationAdd_RL_ReconfPrepTDD = INT(name='id-CCTrCH-Maximum-DL-Power-InformationAdd-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Maximum_DL_Power_InformationAdd_RL_ReconfPrepTDD._val = 571
    
    #-----< id-CCTrCH-Minimum-DL-Power-InformationAdd-RL-ReconfPrepTDD >-----#
    id_CCTrCH_Minimum_DL_Power_InformationAdd_RL_ReconfPrepTDD = INT(name='id-CCTrCH-Minimum-DL-Power-InformationAdd-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Minimum_DL_Power_InformationAdd_RL_ReconfPrepTDD._val = 572
    
    #-----< id-CCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfPrepTDD >-----#
    id_CCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfPrepTDD = INT(name='id-CCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfPrepTDD._val = 573
    
    #-----< id-CCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfPrepTDD >-----#
    id_CCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfPrepTDD = INT(name='id-CCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfPrepTDD._val = 574
    
    #-----< id-Maximum-DL-Power-Modify-LCR-InformationModify-RL-ReconfPrepTDD >-----#
    id_Maximum_DL_Power_Modify_LCR_InformationModify_RL_ReconfPrepTDD = INT(name='id-Maximum-DL-Power-Modify-LCR-InformationModify-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Maximum_DL_Power_Modify_LCR_InformationModify_RL_ReconfPrepTDD._val = 575
    
    #-----< id-Minimum-DL-Power-Modify-LCR-InformationModify-RL-ReconfPrepTDD >-----#
    id_Minimum_DL_Power_Modify_LCR_InformationModify_RL_ReconfPrepTDD = INT(name='id-Minimum-DL-Power-Modify-LCR-InformationModify-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Minimum_DL_Power_Modify_LCR_InformationModify_RL_ReconfPrepTDD._val = 576
    
    #-----< id-DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD >-----#
    id_DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD = INT(name='id-DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD._val = 577
    
    #-----< id-CCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfRqstTDD >-----#
    id_CCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfRqstTDD = INT(name='id-CCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfRqstTDD._val = 578
    
    #-----< id-CCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfRqstTDD >-----#
    id_CCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfRqstTDD = INT(name='id-CCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfRqstTDD._val = 579
    
    #-----< id-Initial-DL-Power-TimeslotLCR-InformationItem >-----#
    id_Initial_DL_Power_TimeslotLCR_InformationItem = INT(name='id-Initial-DL-Power-TimeslotLCR-InformationItem', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Initial_DL_Power_TimeslotLCR_InformationItem._val = 580
    
    #-----< id-Maximum-DL-Power-TimeslotLCR-InformationItem >-----#
    id_Maximum_DL_Power_TimeslotLCR_InformationItem = INT(name='id-Maximum-DL-Power-TimeslotLCR-InformationItem', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Maximum_DL_Power_TimeslotLCR_InformationItem._val = 581
    
    #-----< id-Minimum-DL-Power-TimeslotLCR-InformationItem >-----#
    id_Minimum_DL_Power_TimeslotLCR_InformationItem = INT(name='id-Minimum-DL-Power-TimeslotLCR-InformationItem', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Minimum_DL_Power_TimeslotLCR_InformationItem._val = 582
    
    #-----< id-HS-DSCHProvidedBitRateValueInformation >-----#
    id_HS_DSCHProvidedBitRateValueInformation = INT(name='id-HS-DSCHProvidedBitRateValueInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCHProvidedBitRateValueInformation._val = 583
    
    #-----< id-HS-DSCHRequiredPowerValueInformation >-----#
    id_HS_DSCHRequiredPowerValueInformation = INT(name='id-HS-DSCHRequiredPowerValueInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCHRequiredPowerValueInformation._val = 585
    
    #-----< id-HS-DSCHRequiredPowerValue >-----#
    id_HS_DSCHRequiredPowerValue = INT(name='id-HS-DSCHRequiredPowerValue', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCHRequiredPowerValue._val = 586
    
    #-----< id-TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmission >-----#
    id_TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmission = INT(name='id-TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmission', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmission._val = 587
    
    #-----< id-HS-SICH-Reception-Quality >-----#
    id_HS_SICH_Reception_Quality = INT(name='id-HS-SICH-Reception-Quality', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_SICH_Reception_Quality._val = 588
    
    #-----< id-HS-SICH-Reception-Quality-Measurement-Value >-----#
    id_HS_SICH_Reception_Quality_Measurement_Value = INT(name='id-HS-SICH-Reception-Quality-Measurement-Value', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_SICH_Reception_Quality_Measurement_Value._val = 589
    
    #-----< id-HSSICH-Info-DM-Rprt >-----#
    id_HSSICH_Info_DM_Rprt = INT(name='id-HSSICH-Info-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_Info_DM_Rprt._val = 590
    
    #-----< id-HSSICH-Info-DM-Rqst >-----#
    id_HSSICH_Info_DM_Rqst = INT(name='id-HSSICH-Info-DM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_Info_DM_Rqst._val = 591
    
    #-----< id-HSSICH-Info-DM-Rsp >-----#
    id_HSSICH_Info_DM_Rsp = INT(name='id-HSSICH-Info-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_Info_DM_Rsp._val = 592
    
    #-----< id-Best-Cell-Portions-Value >-----#
    id_Best_Cell_Portions_Value = INT(name='id-Best-Cell-Portions-Value', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Best_Cell_Portions_Value._val = 593
    
    #-----< id-Primary-CPICH-Usage-for-Channel-Estimation >-----#
    id_Primary_CPICH_Usage_for_Channel_Estimation = INT(name='id-Primary-CPICH-Usage-for-Channel-Estimation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Primary_CPICH_Usage_for_Channel_Estimation._val = 594
    
    #-----< id-Secondary-CPICH-Information-Change >-----#
    id_Secondary_CPICH_Information_Change = INT(name='id-Secondary-CPICH-Information-Change', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Secondary_CPICH_Information_Change._val = 595
    
    #-----< id-NumberOfReportedCellPortions >-----#
    id_NumberOfReportedCellPortions = INT(name='id-NumberOfReportedCellPortions', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberOfReportedCellPortions._val = 596
    
    #-----< id-CellPortion-InformationItem-Cell-SetupRqstFDD >-----#
    id_CellPortion_InformationItem_Cell_SetupRqstFDD = INT(name='id-CellPortion-InformationItem-Cell-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellPortion_InformationItem_Cell_SetupRqstFDD._val = 597
    
    #-----< id-CellPortion-InformationList-Cell-SetupRqstFDD >-----#
    id_CellPortion_InformationList_Cell_SetupRqstFDD = INT(name='id-CellPortion-InformationList-Cell-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellPortion_InformationList_Cell_SetupRqstFDD._val = 598
    
    #-----< id-TimeslotISCP-LCR-InfoList-RL-ReconfPrepTDD >-----#
    id_TimeslotISCP_LCR_InfoList_RL_ReconfPrepTDD = INT(name='id-TimeslotISCP-LCR-InfoList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeslotISCP_LCR_InfoList_RL_ReconfPrepTDD._val = 599
    
    #-----< id-Secondary-CPICH-Information >-----#
    id_Secondary_CPICH_Information = INT(name='id-Secondary-CPICH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Secondary_CPICH_Information._val = 600
    
    #-----< id-Received-total-wide-band-power-For-CellPortion >-----#
    id_Received_total_wide_band_power_For_CellPortion = INT(name='id-Received-total-wide-band-power-For-CellPortion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Received_total_wide_band_power_For_CellPortion._val = 601
    
    #-----< id-Unidirectional-DCH-Indicator >-----#
    id_Unidirectional_DCH_Indicator = INT(name='id-Unidirectional-DCH-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unidirectional_DCH_Indicator._val = 602
    
    #-----< id-TimingAdjustmentValueLCR >-----#
    id_TimingAdjustmentValueLCR = INT(name='id-TimingAdjustmentValueLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimingAdjustmentValueLCR._val = 603
    
    #-----< id-multipleRL-dl-DPCH-InformationList >-----#
    id_multipleRL_dl_DPCH_InformationList = INT(name='id-multipleRL-dl-DPCH-InformationList', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multipleRL_dl_DPCH_InformationList._val = 604
    
    #-----< id-multipleRL-dl-DPCH-InformationModifyList >-----#
    id_multipleRL_dl_DPCH_InformationModifyList = INT(name='id-multipleRL-dl-DPCH-InformationModifyList', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multipleRL_dl_DPCH_InformationModifyList._val = 605
    
    #-----< id-multipleRL-ul-DPCH-InformationList >-----#
    id_multipleRL_ul_DPCH_InformationList = INT(name='id-multipleRL-ul-DPCH-InformationList', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multipleRL_ul_DPCH_InformationList._val = 606
    
    #-----< id-multipleRL-ul-DPCH-InformationModifyList >-----#
    id_multipleRL_ul_DPCH_InformationModifyList = INT(name='id-multipleRL-ul-DPCH-InformationModifyList', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multipleRL_ul_DPCH_InformationModifyList._val = 607
    
    #-----< id-RL-ID >-----#
    id_RL_ID = INT(name='id-RL-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_ID._val = 608
    
    #-----< id-SAT-Info-Almanac-ExtItem >-----#
    id_SAT_Info_Almanac_ExtItem = INT(name='id-SAT-Info-Almanac-ExtItem', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SAT_Info_Almanac_ExtItem._val = 609
    
    #-----< id-HSDPA-Capability >-----#
    id_HSDPA_Capability = INT(name='id-HSDPA-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDPA_Capability._val = 610
    
    #-----< id-HSDSCH-Resources-Information-AuditRsp >-----#
    id_HSDSCH_Resources_Information_AuditRsp = INT(name='id-HSDSCH-Resources-Information-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Resources_Information_AuditRsp._val = 611
    
    #-----< id-HSDSCH-Resources-Information-ResourceStatusInd >-----#
    id_HSDSCH_Resources_Information_ResourceStatusInd = INT(name='id-HSDSCH-Resources-Information-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Resources_Information_ResourceStatusInd._val = 612
    
    #-----< id-HSDSCH-MACdFlows-to-Add >-----#
    id_HSDSCH_MACdFlows_to_Add = INT(name='id-HSDSCH-MACdFlows-to-Add', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_MACdFlows_to_Add._val = 613
    
    #-----< id-HSDSCH-MACdFlows-to-Delete >-----#
    id_HSDSCH_MACdFlows_to_Delete = INT(name='id-HSDSCH-MACdFlows-to-Delete', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_MACdFlows_to_Delete._val = 614
    
    #-----< id-HSDSCH-Information-to-Modify-Unsynchronised >-----#
    id_HSDSCH_Information_to_Modify_Unsynchronised = INT(name='id-HSDSCH-Information-to-Modify-Unsynchronised', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Information_to_Modify_Unsynchronised._val = 615
    
    #-----< id-TnlQos >-----#
    id_TnlQos = INT(name='id-TnlQos', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TnlQos._val = 616
    
    #-----< id-Received-total-wide-band-power-For-CellPortion-Value >-----#
    id_Received_total_wide_band_power_For_CellPortion_Value = INT(name='id-Received-total-wide-band-power-For-CellPortion-Value', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Received_total_wide_band_power_For_CellPortion_Value._val = 617
    
    #-----< id-Transmitted-Carrier-Power-For-CellPortion >-----#
    id_Transmitted_Carrier_Power_For_CellPortion = INT(name='id-Transmitted-Carrier-Power-For-CellPortion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Transmitted_Carrier_Power_For_CellPortion._val = 618
    
    #-----< id-Transmitted-Carrier-Power-For-CellPortion-Value >-----#
    id_Transmitted_Carrier_Power_For_CellPortion_Value = INT(name='id-Transmitted-Carrier-Power-For-CellPortion-Value', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Transmitted_Carrier_Power_For_CellPortion_Value._val = 619
    
    #-----< id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortion >-----#
    id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortion = INT(name='id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortion._val = 620
    
    #-----< id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue >-----#
    id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue = INT(name='id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue._val = 621
    
    #-----< id-UpPTSInterferenceValue >-----#
    id_UpPTSInterferenceValue = INT(name='id-UpPTSInterferenceValue', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UpPTSInterferenceValue._val = 622
    
    #-----< id-PrimaryCCPCH-RSCP-Delta >-----#
    id_PrimaryCCPCH_RSCP_Delta = INT(name='id-PrimaryCCPCH-RSCP-Delta', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimaryCCPCH_RSCP_Delta._val = 623
    
    #-----< id-MeasurementRecoveryBehavior >-----#
    id_MeasurementRecoveryBehavior = INT(name='id-MeasurementRecoveryBehavior', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementRecoveryBehavior._val = 624
    
    #-----< id-MeasurementRecoveryReportingIndicator >-----#
    id_MeasurementRecoveryReportingIndicator = INT(name='id-MeasurementRecoveryReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementRecoveryReportingIndicator._val = 625
    
    #-----< id-MeasurementRecoverySupportIndicator >-----#
    id_MeasurementRecoverySupportIndicator = INT(name='id-MeasurementRecoverySupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementRecoverySupportIndicator._val = 626
    
    #-----< id-Tstd-indicator >-----#
    id_Tstd_indicator = INT(name='id-Tstd-indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Tstd_indicator._val = 627
    
    #-----< id-multiple-RL-Information-RL-ReconfPrepTDD >-----#
    id_multiple_RL_Information_RL_ReconfPrepTDD = INT(name='id-multiple-RL-Information-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_RL_Information_RL_ReconfPrepTDD._val = 628
    
    #-----< id-multiple-RL-Information-RL-ReconfRqstTDD >-----#
    id_multiple_RL_Information_RL_ReconfRqstTDD = INT(name='id-multiple-RL-Information-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_RL_Information_RL_ReconfRqstTDD._val = 629
    
    #-----< id-DL-DPCH-Power-Information-RL-ReconfPrepFDD >-----#
    id_DL_DPCH_Power_Information_RL_ReconfPrepFDD = INT(name='id-DL-DPCH-Power-Information-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_Power_Information_RL_ReconfPrepFDD._val = 630
    
    #-----< id-F-DPCH-Information-RL-ReconfPrepFDD >-----#
    id_F_DPCH_Information_RL_ReconfPrepFDD = INT(name='id-F-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F_DPCH_Information_RL_ReconfPrepFDD._val = 631
    
    #-----< id-F-DPCH-Information-RL-SetupRqstFDD >-----#
    id_F_DPCH_Information_RL_SetupRqstFDD = INT(name='id-F-DPCH-Information-RL-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F_DPCH_Information_RL_SetupRqstFDD._val = 632
    
    #-----< id-Additional-S-CCPCH-Parameters-CTCH-ReconfRqstTDD >-----#
    id_Additional_S_CCPCH_Parameters_CTCH_ReconfRqstTDD = INT(name='id-Additional-S-CCPCH-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_S_CCPCH_Parameters_CTCH_ReconfRqstTDD._val = 633
    
    #-----< id-Additional-S-CCPCH-Parameters-CTCH-SetupRqstTDD >-----#
    id_Additional_S_CCPCH_Parameters_CTCH_SetupRqstTDD = INT(name='id-Additional-S-CCPCH-Parameters-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_S_CCPCH_Parameters_CTCH_SetupRqstTDD._val = 634
    
    #-----< id-Additional-S-CCPCH-LCR-Parameters-CTCH-ReconfRqstTDD >-----#
    id_Additional_S_CCPCH_LCR_Parameters_CTCH_ReconfRqstTDD = INT(name='id-Additional-S-CCPCH-LCR-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_S_CCPCH_LCR_Parameters_CTCH_ReconfRqstTDD._val = 635
    
    #-----< id-Additional-S-CCPCH-LCR-Parameters-CTCH-SetupRqstTDD >-----#
    id_Additional_S_CCPCH_LCR_Parameters_CTCH_SetupRqstTDD = INT(name='id-Additional-S-CCPCH-LCR-Parameters-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_S_CCPCH_LCR_Parameters_CTCH_SetupRqstTDD._val = 636
    
    #-----< id-MICH-CFN >-----#
    id_MICH_CFN = INT(name='id-MICH-CFN', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MICH_CFN._val = 637
    
    #-----< id-MICH-Information-AuditRsp >-----#
    id_MICH_Information_AuditRsp = INT(name='id-MICH-Information-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MICH_Information_AuditRsp._val = 638
    
    #-----< id-MICH-Information-ResourceStatusInd >-----#
    id_MICH_Information_ResourceStatusInd = INT(name='id-MICH-Information-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MICH_Information_ResourceStatusInd._val = 639
    
    #-----< id-MICH-Parameters-CTCH-ReconfRqstFDD >-----#
    id_MICH_Parameters_CTCH_ReconfRqstFDD = INT(name='id-MICH-Parameters-CTCH-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MICH_Parameters_CTCH_ReconfRqstFDD._val = 640
    
    #-----< id-MICH-Parameters-CTCH-ReconfRqstTDD >-----#
    id_MICH_Parameters_CTCH_ReconfRqstTDD = INT(name='id-MICH-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MICH_Parameters_CTCH_ReconfRqstTDD._val = 641
    
    #-----< id-MICH-Parameters-CTCH-SetupRqstFDD >-----#
    id_MICH_Parameters_CTCH_SetupRqstFDD = INT(name='id-MICH-Parameters-CTCH-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MICH_Parameters_CTCH_SetupRqstFDD._val = 642
    
    #-----< id-MICH-Parameters-CTCH-SetupRqstTDD >-----#
    id_MICH_Parameters_CTCH_SetupRqstTDD = INT(name='id-MICH-Parameters-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MICH_Parameters_CTCH_SetupRqstTDD._val = 643
    
    #-----< id-Modification-Period >-----#
    id_Modification_Period = INT(name='id-Modification-Period', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Modification_Period._val = 644
    
    #-----< id-NI-Information-NotifUpdateCmd >-----#
    id_NI_Information_NotifUpdateCmd = INT(name='id-NI-Information-NotifUpdateCmd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NI_Information_NotifUpdateCmd._val = 645
    
    #-----< id-S-CCPCH-InformationListExt-AuditRsp >-----#
    id_S_CCPCH_InformationListExt_AuditRsp = INT(name='id-S-CCPCH-InformationListExt-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_InformationListExt_AuditRsp._val = 646
    
    #-----< id-S-CCPCH-InformationListExt-ResourceStatusInd >-----#
    id_S_CCPCH_InformationListExt_ResourceStatusInd = INT(name='id-S-CCPCH-InformationListExt-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_InformationListExt_ResourceStatusInd._val = 647
    
    #-----< id-S-CCPCH-LCR-InformationListExt-AuditRsp >-----#
    id_S_CCPCH_LCR_InformationListExt_AuditRsp = INT(name='id-S-CCPCH-LCR-InformationListExt-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_LCR_InformationListExt_AuditRsp._val = 648
    
    #-----< id-S-CCPCH-LCR-InformationListExt-ResourceStatusInd >-----#
    id_S_CCPCH_LCR_InformationListExt_ResourceStatusInd = INT(name='id-S-CCPCH-LCR-InformationListExt-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_LCR_InformationListExt_ResourceStatusInd._val = 649
    
    #-----< id-HARQ-Preamble-Mode >-----#
    id_HARQ_Preamble_Mode = INT(name='id-HARQ-Preamble-Mode', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HARQ_Preamble_Mode._val = 650
    
    #-----< id-Initial-DL-DPCH-TimingAdjustment >-----#
    id_Initial_DL_DPCH_TimingAdjustment = INT(name='id-Initial-DL-DPCH-TimingAdjustment', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Initial_DL_DPCH_TimingAdjustment._val = 651
    
    #-----< id-Initial-DL-DPCH-TimingAdjustment-Allowed >-----#
    id_Initial_DL_DPCH_TimingAdjustment_Allowed = INT(name='id-Initial-DL-DPCH-TimingAdjustment-Allowed', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Initial_DL_DPCH_TimingAdjustment_Allowed._val = 652
    
    #-----< id-DLTransmissionBranchLoadValue >-----#
    id_DLTransmissionBranchLoadValue = INT(name='id-DLTransmissionBranchLoadValue', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLTransmissionBranchLoadValue._val = 653
    
    #-----< id-Power-Local-Cell-Group-choice-CM-Rqst >-----#
    id_Power_Local_Cell_Group_choice_CM_Rqst = INT(name='id-Power-Local-Cell-Group-choice-CM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Power_Local_Cell_Group_choice_CM_Rqst._val = 654
    
    #-----< id-Power-Local-Cell-Group-choice-CM-Rsp >-----#
    id_Power_Local_Cell_Group_choice_CM_Rsp = INT(name='id-Power-Local-Cell-Group-choice-CM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Power_Local_Cell_Group_choice_CM_Rsp._val = 655
    
    #-----< id-Power-Local-Cell-Group-choice-CM-Rprt >-----#
    id_Power_Local_Cell_Group_choice_CM_Rprt = INT(name='id-Power-Local-Cell-Group-choice-CM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Power_Local_Cell_Group_choice_CM_Rprt._val = 656
    
    #-----< id-SynchronisationIndicator >-----#
    id_SynchronisationIndicator = INT(name='id-SynchronisationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SynchronisationIndicator._val = 657
    
    #-----< id-HSDPA-And-EDCH-CellPortion-Information-PSCH-ReconfRqst >-----#
    id_HSDPA_And_EDCH_CellPortion_Information_PSCH_ReconfRqst = INT(name='id-HSDPA-And-EDCH-CellPortion-Information-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDPA_And_EDCH_CellPortion_Information_PSCH_ReconfRqst._val = 658
    
    #-----< id-Unused-ProtocolIE-ID-659 >-----#
    id_Unused_ProtocolIE_ID_659 = INT(name='id-Unused-ProtocolIE-ID-659', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_659._val = 659
    
    #-----< id-HS-DSCHRequiredPowerValue-For-Cell-Portion >-----#
    id_HS_DSCHRequiredPowerValue_For_Cell_Portion = INT(name='id-HS-DSCHRequiredPowerValue-For-Cell-Portion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCHRequiredPowerValue_For_Cell_Portion._val = 660
    
    #-----< id-HS-DSCHRequiredPowerValueInformation-For-CellPortion >-----#
    id_HS_DSCHRequiredPowerValueInformation_For_CellPortion = INT(name='id-HS-DSCHRequiredPowerValueInformation-For-CellPortion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCHRequiredPowerValueInformation_For_CellPortion._val = 661
    
    #-----< id-HS-DSCHProvidedBitRateValueInformation-For-CellPortion >-----#
    id_HS_DSCHProvidedBitRateValueInformation_For_CellPortion = INT(name='id-HS-DSCHProvidedBitRateValueInformation-For-CellPortion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCHProvidedBitRateValueInformation_For_CellPortion._val = 662
    
    #-----< id-E-AGCH-And-E-RGCH-E-HICH-FDD-Scrambling-Code >-----#
    id_E_AGCH_And_E_RGCH_E_HICH_FDD_Scrambling_Code = INT(name='id-E-AGCH-And-E-RGCH-E-HICH-FDD-Scrambling-Code', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_AGCH_And_E_RGCH_E_HICH_FDD_Scrambling_Code._val = 663
    
    #-----< id-E-AGCH-FDD-Code-Information >-----#
    id_E_AGCH_FDD_Code_Information = INT(name='id-E-AGCH-FDD-Code-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_AGCH_FDD_Code_Information._val = 664
    
    #-----< id-E-DCH-Capability >-----#
    id_E_DCH_Capability = INT(name='id-E-DCH-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Capability._val = 665
    
    #-----< id-E-DCH-FDD-DL-Control-Channel-Information >-----#
    id_E_DCH_FDD_DL_Control_Channel_Information = INT(name='id-E-DCH-FDD-DL-Control-Channel-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_FDD_DL_Control_Channel_Information._val = 666
    
    #-----< id-E-DCH-FDD-Information >-----#
    id_E_DCH_FDD_Information = INT(name='id-E-DCH-FDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_FDD_Information._val = 667
    
    #-----< id-E-DCH-FDD-Information-Response >-----#
    id_E_DCH_FDD_Information_Response = INT(name='id-E-DCH-FDD-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_FDD_Information_Response._val = 668
    
    #-----< id-E-DCH-FDD-Information-to-Modify >-----#
    id_E_DCH_FDD_Information_to_Modify = INT(name='id-E-DCH-FDD-Information-to-Modify', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_FDD_Information_to_Modify._val = 669
    
    #-----< id-E-DCH-MACdFlows-to-Add >-----#
    id_E_DCH_MACdFlows_to_Add = INT(name='id-E-DCH-MACdFlows-to-Add', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_MACdFlows_to_Add._val = 670
    
    #-----< id-E-DCH-MACdFlows-to-Delete >-----#
    id_E_DCH_MACdFlows_to_Delete = INT(name='id-E-DCH-MACdFlows-to-Delete', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_MACdFlows_to_Delete._val = 671
    
    #-----< id-E-DCH-Resources-Information-AuditRsp >-----#
    id_E_DCH_Resources_Information_AuditRsp = INT(name='id-E-DCH-Resources-Information-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Resources_Information_AuditRsp._val = 672
    
    #-----< id-E-DCH-Resources-Information-ResourceStatusInd >-----#
    id_E_DCH_Resources_Information_ResourceStatusInd = INT(name='id-E-DCH-Resources-Information-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Resources_Information_ResourceStatusInd._val = 673
    
    #-----< id-E-DCH-RL-Indication >-----#
    id_E_DCH_RL_Indication = INT(name='id-E-DCH-RL-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_RL_Indication._val = 674
    
    #-----< id-E-DCH-RL-Set-ID >-----#
    id_E_DCH_RL_Set_ID = INT(name='id-E-DCH-RL-Set-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_RL_Set_ID._val = 675
    
    #-----< id-E-DPCH-Information-RL-ReconfPrepFDD >-----#
    id_E_DPCH_Information_RL_ReconfPrepFDD = INT(name='id-E-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DPCH_Information_RL_ReconfPrepFDD._val = 676
    
    #-----< id-E-DPCH-Information-RL-SetupRqstFDD >-----#
    id_E_DPCH_Information_RL_SetupRqstFDD = INT(name='id-E-DPCH-Information-RL-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DPCH_Information_RL_SetupRqstFDD._val = 677
    
    #-----< id-E-RGCH-E-HICH-FDD-Code-Information >-----#
    id_E_RGCH_E_HICH_FDD_Code_Information = INT(name='id-E-RGCH-E-HICH-FDD-Code-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RGCH_E_HICH_FDD_Code_Information._val = 678
    
    #-----< id-Serving-E-DCH-RL-ID >-----#
    id_Serving_E_DCH_RL_ID = INT(name='id-Serving-E-DCH-RL-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Serving_E_DCH_RL_ID._val = 679
    
    #-----< id-UL-DPDCH-Indicator-For-E-DCH-Operation >-----#
    id_UL_DPDCH_Indicator_For_E_DCH_Operation = INT(name='id-UL-DPDCH-Indicator-For-E-DCH-Operation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPDCH_Indicator_For_E_DCH_Operation._val = 680
    
    #-----< id-FDD-S-CCPCH-FrameOffset-CTCH-SetupRqstFDD >-----#
    id_FDD_S_CCPCH_FrameOffset_CTCH_SetupRqstFDD = INT(name='id-FDD-S-CCPCH-FrameOffset-CTCH-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FDD_S_CCPCH_FrameOffset_CTCH_SetupRqstFDD._val = 681
    
    #-----< id-E-DPCH-Information-RL-ReconfRqstFDD >-----#
    id_E_DPCH_Information_RL_ReconfRqstFDD = INT(name='id-E-DPCH-Information-RL-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DPCH_Information_RL_ReconfRqstFDD._val = 682
    
    #-----< id-Maximum-Target-ReceivedTotalWideBandPower >-----#
    id_Maximum_Target_ReceivedTotalWideBandPower = INT(name='id-Maximum-Target-ReceivedTotalWideBandPower', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Maximum_Target_ReceivedTotalWideBandPower._val = 683
    
    #-----< id-E-DCHProvidedBitRateValueInformation >-----#
    id_E_DCHProvidedBitRateValueInformation = INT(name='id-E-DCHProvidedBitRateValueInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCHProvidedBitRateValueInformation._val = 684
    
    #-----< id-HARQ-Preamble-Mode-Activation-Indicator >-----#
    id_HARQ_Preamble_Mode_Activation_Indicator = INT(name='id-HARQ-Preamble-Mode-Activation-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HARQ_Preamble_Mode_Activation_Indicator._val = 685
    
    #-----< id-RL-Specific-E-DCH-Info >-----#
    id_RL_Specific_E_DCH_Info = INT(name='id-RL-Specific-E-DCH-Info', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Specific_E_DCH_Info._val = 686
    
    #-----< id-E-DCH-CapacityConsumptionLaw >-----#
    id_E_DCH_CapacityConsumptionLaw = INT(name='id-E-DCH-CapacityConsumptionLaw', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_CapacityConsumptionLaw._val = 687
    
    #-----< id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp >-----#
    id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp = INT(name='id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp._val = 688
    
    #-----< id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp >-----#
    id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp = INT(name='id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp._val = 689
    
    #-----< id-E-DCH-RearrangeList-Bearer-RearrangeInd >-----#
    id_E_DCH_RearrangeList_Bearer_RearrangeInd = INT(name='id-E-DCH-RearrangeList-Bearer-RearrangeInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_RearrangeList_Bearer_RearrangeInd._val = 690
    
    #-----< id-Unused-ProtocolIE-ID-691 >-----#
    id_Unused_ProtocolIE_ID_691 = INT(name='id-Unused-ProtocolIE-ID-691', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_691._val = 691
    
    #-----< id-multipleRL-dl-CCTrCH-InformationModifyList-RL-ReconfRqstTDD >-----#
    id_multipleRL_dl_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = INT(name='id-multipleRL-dl-CCTrCH-InformationModifyList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multipleRL_dl_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._val = 692
    
    #-----< id-Target-NonServing-EDCH-To-Total-EDCH-Power-Ratio >-----#
    id_Target_NonServing_EDCH_To_Total_EDCH_Power_Ratio = INT(name='id-Target-NonServing-EDCH-To-Total-EDCH-Power-Ratio', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Target_NonServing_EDCH_To_Total_EDCH_Power_Ratio._val = 693
    
    #-----< id-CellPortion-InformationItem-Cell-ReconfRqstFDD >-----#
    id_CellPortion_InformationItem_Cell_ReconfRqstFDD = INT(name='id-CellPortion-InformationItem-Cell-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellPortion_InformationItem_Cell_ReconfRqstFDD._val = 694
    
    #-----< id-CellPortion-InformationList-Cell-ReconfRqstFDD >-----#
    id_CellPortion_InformationList_Cell_ReconfRqstFDD = INT(name='id-CellPortion-InformationList-Cell-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellPortion_InformationList_Cell_ReconfRqstFDD._val = 695
    
    #-----< id-multiple-PUSCH-InfoList-DM-Rsp >-----#
    id_multiple_PUSCH_InfoList_DM_Rsp = INT(name='id-multiple-PUSCH-InfoList-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_PUSCH_InfoList_DM_Rsp._val = 696
    
    #-----< id-multiple-PUSCH-InfoList-DM-Rprt >-----#
    id_multiple_PUSCH_InfoList_DM_Rprt = INT(name='id-multiple-PUSCH-InfoList-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_PUSCH_InfoList_DM_Rprt._val = 697
    
    #-----< id-Reference-ReceivedTotalWideBandPower >-----#
    id_Reference_ReceivedTotalWideBandPower = INT(name='id-Reference-ReceivedTotalWideBandPower', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Reference_ReceivedTotalWideBandPower._val = 698
    
    #-----< id-E-DCH-Serving-Cell-Change-Info-Response >-----#
    id_E_DCH_Serving_Cell_Change_Info_Response = INT(name='id-E-DCH-Serving-Cell-Change-Info-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Serving_Cell_Change_Info_Response._val = 699
    
    #-----< id-HS-DSCH-Serving-Cell-Change-Info >-----#
    id_HS_DSCH_Serving_Cell_Change_Info = INT(name='id-HS-DSCH-Serving-Cell-Change-Info', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCH_Serving_Cell_Change_Info._val = 700
    
    #-----< id-HS-DSCH-Serving-Cell-Change-Info-Response >-----#
    id_HS_DSCH_Serving_Cell_Change_Info_Response = INT(name='id-HS-DSCH-Serving-Cell-Change-Info-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCH_Serving_Cell_Change_Info_Response._val = 701
    
    #-----< id-Serving-Cell-Change-CFN >-----#
    id_Serving_Cell_Change_CFN = INT(name='id-Serving-Cell-Change-CFN', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Serving_Cell_Change_CFN._val = 702
    
    #-----< id-E-DCH-HARQ-Combining-Capability >-----#
    id_E_DCH_HARQ_Combining_Capability = INT(name='id-E-DCH-HARQ-Combining-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_HARQ_Combining_Capability._val = 703
    
    #-----< id-E-DCH-TTI2ms-Capability >-----#
    id_E_DCH_TTI2ms_Capability = INT(name='id-E-DCH-TTI2ms-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_TTI2ms_Capability._val = 704
    
    #-----< id-E-DCH-SF-Capability >-----#
    id_E_DCH_SF_Capability = INT(name='id-E-DCH-SF-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_SF_Capability._val = 705
    
    #-----< id-E-DCH-FDD-Update-Information >-----#
    id_E_DCH_FDD_Update_Information = INT(name='id-E-DCH-FDD-Update-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_FDD_Update_Information._val = 706
    
    #-----< id-F-DPCH-Capability >-----#
    id_F_DPCH_Capability = INT(name='id-F-DPCH-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F_DPCH_Capability._val = 707
    
    #-----< id-E-DCH-Non-serving-Relative-Grant-Down-CommandsValue >-----#
    id_E_DCH_Non_serving_Relative_Grant_Down_CommandsValue = INT(name='id-E-DCH-Non-serving-Relative-Grant-Down-CommandsValue', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Non_serving_Relative_Grant_Down_CommandsValue._val = 708
    
    #-----< id-HSSICH-SIRTarget >-----#
    id_HSSICH_SIRTarget = INT(name='id-HSSICH-SIRTarget', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_SIRTarget._val = 709
    
    #-----< id-multiple-HSSICHMeasurementValueList-TDD-DM-Rsp >-----#
    id_multiple_HSSICHMeasurementValueList_TDD_DM_Rsp = INT(name='id-multiple-HSSICHMeasurementValueList-TDD-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_HSSICHMeasurementValueList_TDD_DM_Rsp._val = 710
    
    #-----< id-PLCCH-Information-AuditRsp >-----#
    id_PLCCH_Information_AuditRsp = INT(name='id-PLCCH-Information-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLCCH_Information_AuditRsp._val = 711
    
    #-----< id-PLCCH-Information-ResourceStatusInd >-----#
    id_PLCCH_Information_ResourceStatusInd = INT(name='id-PLCCH-Information-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLCCH_Information_ResourceStatusInd._val = 712
    
    #-----< id-PLCCH-Information-RL-ReconfPrepTDDLCR >-----#
    id_PLCCH_Information_RL_ReconfPrepTDDLCR = INT(name='id-PLCCH-Information-RL-ReconfPrepTDDLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLCCH_Information_RL_ReconfPrepTDDLCR._val = 713
    
    #-----< id-PLCCH-Information-UL-TimeslotLCR-Info >-----#
    id_PLCCH_Information_UL_TimeslotLCR_Info = INT(name='id-PLCCH-Information-UL-TimeslotLCR-Info', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLCCH_Information_UL_TimeslotLCR_Info._val = 714
    
    #-----< id-PLCCH-InformationList-AuditRsp >-----#
    id_PLCCH_InformationList_AuditRsp = INT(name='id-PLCCH-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLCCH_InformationList_AuditRsp._val = 715
    
    #-----< id-PLCCH-InformationList-ResourceStatusInd >-----#
    id_PLCCH_InformationList_ResourceStatusInd = INT(name='id-PLCCH-InformationList-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLCCH_InformationList_ResourceStatusInd._val = 716
    
    #-----< id-PLCCH-Parameters-CTCH-ReconfRqstTDD >-----#
    id_PLCCH_Parameters_CTCH_ReconfRqstTDD = INT(name='id-PLCCH-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLCCH_Parameters_CTCH_ReconfRqstTDD._val = 717
    
    #-----< id-S-CCPCH-768-Parameters-CTCH-SetupRqstTDD >-----#
    id_S_CCPCH_768_Parameters_CTCH_SetupRqstTDD = INT(name='id-S-CCPCH-768-Parameters-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_768_Parameters_CTCH_SetupRqstTDD._val = 718
    
    #-----< id-PICH-768-Parameters-CTCH-SetupRqstTDD >-----#
    id_PICH_768_Parameters_CTCH_SetupRqstTDD = INT(name='id-PICH-768-Parameters-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PICH_768_Parameters_CTCH_SetupRqstTDD._val = 719
    
    #-----< id-PRACH-768-Parameters-CTCH-SetupRqstTDD >-----#
    id_PRACH_768_Parameters_CTCH_SetupRqstTDD = INT(name='id-PRACH-768-Parameters-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRACH_768_Parameters_CTCH_SetupRqstTDD._val = 720
    
    #-----< id-S-CCPCH-768-Parameters-CTCH-ReconfRqstTDD >-----#
    id_S_CCPCH_768_Parameters_CTCH_ReconfRqstTDD = INT(name='id-S-CCPCH-768-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_768_Parameters_CTCH_ReconfRqstTDD._val = 721
    
    #-----< id-PICH-768-Parameters-CTCH-ReconfRqstTDD >-----#
    id_PICH_768_Parameters_CTCH_ReconfRqstTDD = INT(name='id-PICH-768-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PICH_768_Parameters_CTCH_ReconfRqstTDD._val = 722
    
    #-----< id-MICH-768-Parameters-CTCH-ReconfRqstTDD >-----#
    id_MICH_768_Parameters_CTCH_ReconfRqstTDD = INT(name='id-MICH-768-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MICH_768_Parameters_CTCH_ReconfRqstTDD._val = 723
    
    #-----< id-CommonPhysicalChannelID768-CommonTrChDeletionReq >-----#
    id_CommonPhysicalChannelID768_CommonTrChDeletionReq = INT(name='id-CommonPhysicalChannelID768-CommonTrChDeletionReq', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonPhysicalChannelID768_CommonTrChDeletionReq._val = 724
    
    #-----< id-S-CCPCH-768-InformationList-AuditRsp >-----#
    id_S_CCPCH_768_InformationList_AuditRsp = INT(name='id-S-CCPCH-768-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_768_InformationList_AuditRsp._val = 725
    
    #-----< id-S-CCPCH-768-Information-AuditRsp >-----#
    id_S_CCPCH_768_Information_AuditRsp = INT(name='id-S-CCPCH-768-Information-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_768_Information_AuditRsp._val = 726
    
    #-----< id-neighbouringTDDCellMeasurementInformation768 >-----#
    id_neighbouringTDDCellMeasurementInformation768 = INT(name='id-neighbouringTDDCellMeasurementInformation768', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_neighbouringTDDCellMeasurementInformation768._val = 727
    
    #-----< id-PCCPCH-768-Information-Cell-SetupRqstTDD >-----#
    id_PCCPCH_768_Information_Cell_SetupRqstTDD = INT(name='id-PCCPCH-768-Information-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCCPCH_768_Information_Cell_SetupRqstTDD._val = 728
    
    #-----< id-SCH-768-Information-Cell-SetupRqstTDD >-----#
    id_SCH_768_Information_Cell_SetupRqstTDD = INT(name='id-SCH-768-Information-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCH_768_Information_Cell_SetupRqstTDD._val = 729
    
    #-----< id-SCH-768-Information-Cell-ReconfRqstTDD >-----#
    id_SCH_768_Information_Cell_ReconfRqstTDD = INT(name='id-SCH-768-Information-Cell-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCH_768_Information_Cell_ReconfRqstTDD._val = 730
    
    #-----< id-PCCPCH-768-Information-Cell-ReconfRqstTDD >-----#
    id_PCCPCH_768_Information_Cell_ReconfRqstTDD = INT(name='id-PCCPCH-768-Information-Cell-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCCPCH_768_Information_Cell_ReconfRqstTDD._val = 731
    
    #-----< id-P-CCPCH-768-Information-AuditRsp >-----#
    id_P_CCPCH_768_Information_AuditRsp = INT(name='id-P-CCPCH-768-Information-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_P_CCPCH_768_Information_AuditRsp._val = 732
    
    #-----< id-PICH-768-Information-AuditRsp >-----#
    id_PICH_768_Information_AuditRsp = INT(name='id-PICH-768-Information-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PICH_768_Information_AuditRsp._val = 733
    
    #-----< id-PRACH-768-InformationList-AuditRsp >-----#
    id_PRACH_768_InformationList_AuditRsp = INT(name='id-PRACH-768-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRACH_768_InformationList_AuditRsp._val = 734
    
    #-----< id-SCH-768-Information-AuditRsp >-----#
    id_SCH_768_Information_AuditRsp = INT(name='id-SCH-768-Information-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCH_768_Information_AuditRsp._val = 735
    
    #-----< id-MICH-768-Information-AuditRsp >-----#
    id_MICH_768_Information_AuditRsp = INT(name='id-MICH-768-Information-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MICH_768_Information_AuditRsp._val = 736
    
    #-----< id-PRACH-768-Information >-----#
    id_PRACH_768_Information = INT(name='id-PRACH-768-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRACH_768_Information._val = 737
    
    #-----< id-S-CCPCH-768-Information-ResourceStatusInd >-----#
    id_S_CCPCH_768_Information_ResourceStatusInd = INT(name='id-S-CCPCH-768-Information-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_768_Information_ResourceStatusInd._val = 738
    
    #-----< id-P-CCPCH-768-Information-ResourceStatusInd >-----#
    id_P_CCPCH_768_Information_ResourceStatusInd = INT(name='id-P-CCPCH-768-Information-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_P_CCPCH_768_Information_ResourceStatusInd._val = 739
    
    #-----< id-PICH-768-Information-ResourceStatusInd >-----#
    id_PICH_768_Information_ResourceStatusInd = INT(name='id-PICH-768-Information-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PICH_768_Information_ResourceStatusInd._val = 740
    
    #-----< id-PRACH-768-InformationList-ResourceStatusInd >-----#
    id_PRACH_768_InformationList_ResourceStatusInd = INT(name='id-PRACH-768-InformationList-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRACH_768_InformationList_ResourceStatusInd._val = 741
    
    #-----< id-SCH-768-Information-ResourceStatusInd >-----#
    id_SCH_768_Information_ResourceStatusInd = INT(name='id-SCH-768-Information-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCH_768_Information_ResourceStatusInd._val = 742
    
    #-----< id-MICH-768-Information-ResourceStatusInd >-----#
    id_MICH_768_Information_ResourceStatusInd = INT(name='id-MICH-768-Information-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MICH_768_Information_ResourceStatusInd._val = 743
    
    #-----< id-S-CCPCH-768-InformationList-ResourceStatusInd >-----#
    id_S_CCPCH_768_InformationList_ResourceStatusInd = INT(name='id-S-CCPCH-768-InformationList-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_768_InformationList_ResourceStatusInd._val = 744
    
    #-----< id-UL-DPCH-768-Information-RL-SetupRqstTDD >-----#
    id_UL_DPCH_768_Information_RL_SetupRqstTDD = INT(name='id-UL-DPCH-768-Information-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_768_Information_RL_SetupRqstTDD._val = 745
    
    #-----< id-DL-DPCH-768-Information-RL-SetupRqstTDD >-----#
    id_DL_DPCH_768_Information_RL_SetupRqstTDD = INT(name='id-DL-DPCH-768-Information-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_768_Information_RL_SetupRqstTDD._val = 746
    
    #-----< id-DL-DPCH-InformationItem-768-RL-AdditionRqstTDD >-----#
    id_DL_DPCH_InformationItem_768_RL_AdditionRqstTDD = INT(name='id-DL-DPCH-InformationItem-768-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationItem_768_RL_AdditionRqstTDD._val = 747
    
    #-----< id-UL-DPCH-InformationItem-768-RL-AdditionRqstTDD >-----#
    id_UL_DPCH_InformationItem_768_RL_AdditionRqstTDD = INT(name='id-UL-DPCH-InformationItem-768-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationItem_768_RL_AdditionRqstTDD._val = 748
    
    #-----< id-UL-DPCH-768-InformationAddItemIE-RL-ReconfPrepTDD >-----#
    id_UL_DPCH_768_InformationAddItemIE_RL_ReconfPrepTDD = INT(name='id-UL-DPCH-768-InformationAddItemIE-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_768_InformationAddItemIE_RL_ReconfPrepTDD._val = 749
    
    #-----< id-UL-DPCH-768-InformationAddListIE-RL-ReconfPrepTDD >-----#
    id_UL_DPCH_768_InformationAddListIE_RL_ReconfPrepTDD = INT(name='id-UL-DPCH-768-InformationAddListIE-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_768_InformationAddListIE_RL_ReconfPrepTDD._val = 750
    
    #-----< id-UL-DPCH-768-InformationModify-AddItem >-----#
    id_UL_DPCH_768_InformationModify_AddItem = INT(name='id-UL-DPCH-768-InformationModify-AddItem', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_768_InformationModify_AddItem._val = 751
    
    #-----< id-UL-DPCH-768-InformationModify-AddList >-----#
    id_UL_DPCH_768_InformationModify_AddList = INT(name='id-UL-DPCH-768-InformationModify-AddList', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_768_InformationModify_AddList._val = 752
    
    #-----< id-UL-Timeslot768-Information-RL-ReconfPrepTDD >-----#
    id_UL_Timeslot768_Information_RL_ReconfPrepTDD = INT(name='id-UL-Timeslot768-Information-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_Timeslot768_Information_RL_ReconfPrepTDD._val = 753
    
    #-----< id-DL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD >-----#
    id_DL_DPCH_768_InformationAddItem_RL_ReconfPrepTDD = INT(name='id-DL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_768_InformationAddItem_RL_ReconfPrepTDD._val = 754
    
    #-----< id-DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD >-----#
    id_DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD = INT(name='id-DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD._val = 755
    
    #-----< id-DL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD >-----#
    id_DL_DPCH_768_InformationModify_AddItem_RL_ReconfPrepTDD = INT(name='id-DL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_768_InformationModify_AddItem_RL_ReconfPrepTDD._val = 756
    
    #-----< id-DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD >-----#
    id_DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD = INT(name='id-DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD._val = 757
    
    #-----< id-DL-Timeslot-768-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    id_DL_Timeslot_768_InformationModify_ModifyList_RL_ReconfPrepTDD = INT(name='id-DL-Timeslot-768-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_Timeslot_768_InformationModify_ModifyList_RL_ReconfPrepTDD._val = 758
    
    #-----< id-DPCH-ID768-DM-Rqst >-----#
    id_DPCH_ID768_DM_Rqst = INT(name='id-DPCH-ID768-DM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DPCH_ID768_DM_Rqst._val = 759
    
    #-----< id-multiple-DedicatedMeasurementValueList-768-TDD-DM-Rsp >-----#
    id_multiple_DedicatedMeasurementValueList_768_TDD_DM_Rsp = INT(name='id-multiple-DedicatedMeasurementValueList-768-TDD-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_DedicatedMeasurementValueList_768_TDD_DM_Rsp._val = 760
    
    #-----< id-DPCH-ID768-DM-Rsp >-----#
    id_DPCH_ID768_DM_Rsp = INT(name='id-DPCH-ID768-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DPCH_ID768_DM_Rsp._val = 761
    
    #-----< id-Rx-Timing-Deviation-Value-768 >-----#
    id_Rx_Timing_Deviation_Value_768 = INT(name='id-Rx-Timing-Deviation-Value-768', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Rx_Timing_Deviation_Value_768._val = 762
    
    #-----< id-DPCH-ID768-DM-Rprt >-----#
    id_DPCH_ID768_DM_Rprt = INT(name='id-DPCH-ID768-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DPCH_ID768_DM_Rprt._val = 763
    
    #-----< id-PDSCH-AddInformation-768-PSCH-ReconfRqst >-----#
    id_PDSCH_AddInformation_768_PSCH_ReconfRqst = INT(name='id-PDSCH-AddInformation-768-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCH_AddInformation_768_PSCH_ReconfRqst._val = 764
    
    #-----< id-PDSCH-ModifyInformation-768-PSCH-ReconfRqst >-----#
    id_PDSCH_ModifyInformation_768_PSCH_ReconfRqst = INT(name='id-PDSCH-ModifyInformation-768-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCH_ModifyInformation_768_PSCH_ReconfRqst._val = 765
    
    #-----< id-PUSCH-AddInformation-768-PSCH-ReconfRqst >-----#
    id_PUSCH_AddInformation_768_PSCH_ReconfRqst = INT(name='id-PUSCH-AddInformation-768-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_AddInformation_768_PSCH_ReconfRqst._val = 766
    
    #-----< id-PUSCH-ModifyInformation-768-PSCH-ReconfRqst >-----#
    id_PUSCH_ModifyInformation_768_PSCH_ReconfRqst = INT(name='id-PUSCH-ModifyInformation-768-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_ModifyInformation_768_PSCH_ReconfRqst._val = 767
    
    #-----< id-dL-HS-PDSCH-Timeslot-Information-768-PSCH-ReconfRqst >-----#
    id_dL_HS_PDSCH_Timeslot_Information_768_PSCH_ReconfRqst = INT(name='id-dL-HS-PDSCH-Timeslot-Information-768-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_dL_HS_PDSCH_Timeslot_Information_768_PSCH_ReconfRqst._val = 768
    
    #-----< id-hS-SCCH-Information-768-PSCH-ReconfRqst >-----#
    id_hS_SCCH_Information_768_PSCH_ReconfRqst = INT(name='id-hS-SCCH-Information-768-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_hS_SCCH_Information_768_PSCH_ReconfRqst._val = 769
    
    #-----< id-hS-SCCH-InformationModify-768-PSCH-ReconfRqst >-----#
    id_hS_SCCH_InformationModify_768_PSCH_ReconfRqst = INT(name='id-hS-SCCH-InformationModify-768-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_hS_SCCH_InformationModify_768_PSCH_ReconfRqst._val = 770
    
    #-----< id-hsSCCH-Specific-Information-ResponseTDD768 >-----#
    id_hsSCCH_Specific_Information_ResponseTDD768 = INT(name='id-hsSCCH-Specific-Information-ResponseTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_hsSCCH_Specific_Information_ResponseTDD768._val = 771
    
    #-----< id-E-DPCH-Information-RL-AdditionReqFDD >-----#
    id_E_DPCH_Information_RL_AdditionReqFDD = INT(name='id-E-DPCH-Information-RL-AdditionReqFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DPCH_Information_RL_AdditionReqFDD._val = 772
    
    #-----< id-PDSCH-Timeslot-Format-PSCH-ReconfRqst-LCR >-----#
    id_PDSCH_Timeslot_Format_PSCH_ReconfRqst_LCR = INT(name='id-PDSCH-Timeslot-Format-PSCH-ReconfRqst-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCH_Timeslot_Format_PSCH_ReconfRqst_LCR._val = 775
    
    #-----< id-PUSCH-Timeslot-Format-PSCH-ReconfRqst-LCR >-----#
    id_PUSCH_Timeslot_Format_PSCH_ReconfRqst_LCR = INT(name='id-PUSCH-Timeslot-Format-PSCH-ReconfRqst-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PUSCH_Timeslot_Format_PSCH_ReconfRqst_LCR._val = 780
    
    #-----< id-E-DCH-PowerOffset-for-SchedulingInfo >-----#
    id_E_DCH_PowerOffset_for_SchedulingInfo = INT(name='id-E-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_PowerOffset_for_SchedulingInfo._val = 782
    
    #-----< id-HSDSCH-Configured-Indicator >-----#
    id_HSDSCH_Configured_Indicator = INT(name='id-HSDSCH-Configured-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Configured_Indicator._val = 783
    
    #-----< id-Rx-Timing-Deviation-Value-384-ext >-----#
    id_Rx_Timing_Deviation_Value_384_ext = INT(name='id-Rx-Timing-Deviation-Value-384-ext', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Rx_Timing_Deviation_Value_384_ext._val = 786
    
    #-----< id-RTWP-ReportingIndicator >-----#
    id_RTWP_ReportingIndicator = INT(name='id-RTWP-ReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RTWP_ReportingIndicator._val = 787
    
    #-----< id-RTWP-CellPortion-ReportingIndicator >-----#
    id_RTWP_CellPortion_ReportingIndicator = INT(name='id-RTWP-CellPortion-ReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RTWP_CellPortion_ReportingIndicator._val = 788
    
    #-----< id-Received-Scheduled-EDCH-Power-Share-Value >-----#
    id_Received_Scheduled_EDCH_Power_Share_Value = INT(name='id-Received-Scheduled-EDCH-Power-Share-Value', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Received_Scheduled_EDCH_Power_Share_Value._val = 789
    
    #-----< id-Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value >-----#
    id_Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value = INT(name='id-Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value._val = 790
    
    #-----< id-Received-Scheduled-EDCH-Power-Share >-----#
    id_Received_Scheduled_EDCH_Power_Share = INT(name='id-Received-Scheduled-EDCH-Power-Share', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Received_Scheduled_EDCH_Power_Share._val = 791
    
    #-----< id-Received-Scheduled-EDCH-Power-Share-For-CellPortion >-----#
    id_Received_Scheduled_EDCH_Power_Share_For_CellPortion = INT(name='id-Received-Scheduled-EDCH-Power-Share-For-CellPortion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Received_Scheduled_EDCH_Power_Share_For_CellPortion._val = 792
    
    #-----< id-tFCI-Presence >-----#
    id_tFCI_Presence = INT(name='id-tFCI-Presence', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_tFCI_Presence._val = 793
    
    #-----< id-HSSICH-TPC-StepSize >-----#
    id_HSSICH_TPC_StepSize = INT(name='id-HSSICH-TPC-StepSize', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_TPC_StepSize._val = 794
    
    #-----< id-E-RUCCH-InformationList-AuditRsp >-----#
    id_E_RUCCH_InformationList_AuditRsp = INT(name='id-E-RUCCH-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RUCCH_InformationList_AuditRsp._val = 795
    
    #-----< id-E-RUCCH-InformationList-ResourceStatusInd >-----#
    id_E_RUCCH_InformationList_ResourceStatusInd = INT(name='id-E-RUCCH-InformationList-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RUCCH_InformationList_ResourceStatusInd._val = 796
    
    #-----< id-E-DCH-TDD-CapacityConsumptionLaw >-----#
    id_E_DCH_TDD_CapacityConsumptionLaw = INT(name='id-E-DCH-TDD-CapacityConsumptionLaw', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_TDD_CapacityConsumptionLaw._val = 797
    
    #-----< id-E-RUCCH-Information >-----#
    id_E_RUCCH_Information = INT(name='id-E-RUCCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RUCCH_Information._val = 798
    
    #-----< id-E-DCH-Information >-----#
    id_E_DCH_Information = INT(name='id-E-DCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Information._val = 799
    
    #-----< id-E-DCH-Information-Response >-----#
    id_E_DCH_Information_Response = INT(name='id-E-DCH-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Information_Response._val = 800
    
    #-----< id-E-DCH-Information-Reconfig >-----#
    id_E_DCH_Information_Reconfig = INT(name='id-E-DCH-Information-Reconfig', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Information_Reconfig._val = 801
    
    #-----< id-E-PUCH-Information-PSCH-ReconfRqst >-----#
    id_E_PUCH_Information_PSCH_ReconfRqst = INT(name='id-E-PUCH-Information-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_PUCH_Information_PSCH_ReconfRqst._val = 802
    
    #-----< id-Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst >-----#
    id_Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst = INT(name='id-Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst._val = 803
    
    #-----< id-Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst >-----#
    id_Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst = INT(name='id-Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst._val = 804
    
    #-----< id-Delete-From-E-AGCH-Resource-Pool-PSCH-ReconfRqst >-----#
    id_Delete_From_E_AGCH_Resource_Pool_PSCH_ReconfRqst = INT(name='id-Delete-From-E-AGCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Delete_From_E_AGCH_Resource_Pool_PSCH_ReconfRqst._val = 805
    
    #-----< id-E-HICH-Information-PSCH-ReconfRqst >-----#
    id_E_HICH_Information_PSCH_ReconfRqst = INT(name='id-E-HICH-Information-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_HICH_Information_PSCH_ReconfRqst._val = 806
    
    #-----< id-E-HICH-TimeOffset >-----#
    id_E_HICH_TimeOffset = INT(name='id-E-HICH-TimeOffset', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_HICH_TimeOffset._val = 807
    
    #-----< id-Maximum-Generated-ReceivedTotalWideBandPowerInOtherCells >-----#
    id_Maximum_Generated_ReceivedTotalWideBandPowerInOtherCells = INT(name='id-Maximum-Generated-ReceivedTotalWideBandPowerInOtherCells', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Maximum_Generated_ReceivedTotalWideBandPowerInOtherCells._val = 808
    
    #-----< id-E-DCH-Serving-RL-ID >-----#
    id_E_DCH_Serving_RL_ID = INT(name='id-E-DCH-Serving-RL-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Serving_RL_ID._val = 809
    
    #-----< id-E-RUCCH-768-InformationList-AuditRsp >-----#
    id_E_RUCCH_768_InformationList_AuditRsp = INT(name='id-E-RUCCH-768-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RUCCH_768_InformationList_AuditRsp._val = 810
    
    #-----< id-E-RUCCH-768-InformationList-ResourceStatusInd >-----#
    id_E_RUCCH_768_InformationList_ResourceStatusInd = INT(name='id-E-RUCCH-768-InformationList-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RUCCH_768_InformationList_ResourceStatusInd._val = 811
    
    #-----< id-E-RUCCH-768-Information >-----#
    id_E_RUCCH_768_Information = INT(name='id-E-RUCCH-768-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RUCCH_768_Information._val = 812
    
    #-----< id-E-DCH-768-Information >-----#
    id_E_DCH_768_Information = INT(name='id-E-DCH-768-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_768_Information._val = 813
    
    #-----< id-E-DCH-768-Information-Reconfig >-----#
    id_E_DCH_768_Information_Reconfig = INT(name='id-E-DCH-768-Information-Reconfig', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_768_Information_Reconfig._val = 814
    
    #-----< id-E-PUCH-Information-768-PSCH-ReconfRqst >-----#
    id_E_PUCH_Information_768_PSCH_ReconfRqst = INT(name='id-E-PUCH-Information-768-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_PUCH_Information_768_PSCH_ReconfRqst._val = 815
    
    #-----< id-Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst >-----#
    id_Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst = INT(name='id-Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst._val = 816
    
    #-----< id-Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst >-----#
    id_Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst = INT(name='id-Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst._val = 817
    
    #-----< id-E-HICH-Information-768-PSCH-ReconfRqst >-----#
    id_E_HICH_Information_768_PSCH_ReconfRqst = INT(name='id-E-HICH-Information-768-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_HICH_Information_768_PSCH_ReconfRqst._val = 818
    
    #-----< id-ExtendedPropagationDelay >-----#
    id_ExtendedPropagationDelay = INT(name='id-ExtendedPropagationDelay', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedPropagationDelay._val = 819
    
    #-----< id-Extended-Round-Trip-Time-Value >-----#
    id_Extended_Round_Trip_Time_Value = INT(name='id-Extended-Round-Trip-Time-Value', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_Round_Trip_Time_Value._val = 820
    
    #-----< id-AlternativeFormatReportingIndicator >-----#
    id_AlternativeFormatReportingIndicator = INT(name='id-AlternativeFormatReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AlternativeFormatReportingIndicator._val = 821
    
    #-----< id-DCH-Indicator-For-E-DCH-HSDPA-Operation >-----#
    id_DCH_Indicator_For_E_DCH_HSDPA_Operation = INT(name='id-DCH-Indicator-For-E-DCH-HSDPA-Operation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_Indicator_For_E_DCH_HSDPA_Operation._val = 822
    
    #-----< id-Reference-ReceivedTotalWideBandPowerReporting >-----#
    id_Reference_ReceivedTotalWideBandPowerReporting = INT(name='id-Reference-ReceivedTotalWideBandPowerReporting', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Reference_ReceivedTotalWideBandPowerReporting._val = 823
    
    #-----< id-Reference-ReceivedTotalWideBandPowerSupportIndicator >-----#
    id_Reference_ReceivedTotalWideBandPowerSupportIndicator = INT(name='id-Reference-ReceivedTotalWideBandPowerSupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Reference_ReceivedTotalWideBandPowerSupportIndicator._val = 824
    
    #-----< id-ueCapability-Info >-----#
    id_ueCapability_Info = INT(name='id-ueCapability-Info', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ueCapability_Info._val = 825
    
    #-----< id-MAChs-ResetIndicator >-----#
    id_MAChs_ResetIndicator = INT(name='id-MAChs-ResetIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MAChs_ResetIndicator._val = 826
    
    #-----< id-Fast-Reconfiguration-Mode >-----#
    id_Fast_Reconfiguration_Mode = INT(name='id-Fast-Reconfiguration-Mode', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Fast_Reconfiguration_Mode._val = 827
    
    #-----< id-Fast-Reconfiguration-Permission >-----#
    id_Fast_Reconfiguration_Permission = INT(name='id-Fast-Reconfiguration-Permission', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Fast_Reconfiguration_Permission._val = 828
    
    #-----< id-BroadcastReference >-----#
    id_BroadcastReference = INT(name='id-BroadcastReference', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastReference._val = 829
    
    #-----< id-BroadcastCommonTransportBearerIndication >-----#
    id_BroadcastCommonTransportBearerIndication = INT(name='id-BroadcastCommonTransportBearerIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastCommonTransportBearerIndication._val = 830
    
    #-----< id-ContinuousPacketConnectivityDTX-DRX-Capability >-----#
    id_ContinuousPacketConnectivityDTX_DRX_Capability = INT(name='id-ContinuousPacketConnectivityDTX-DRX-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContinuousPacketConnectivityDTX_DRX_Capability._val = 831
    
    #-----< id-ContinuousPacketConnectivityDTX-DRX-Information >-----#
    id_ContinuousPacketConnectivityDTX_DRX_Information = INT(name='id-ContinuousPacketConnectivityDTX-DRX-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContinuousPacketConnectivityDTX_DRX_Information._val = 832
    
    #-----< id-ContinuousPacketConnectivityHS-SCCH-less-Capability >-----#
    id_ContinuousPacketConnectivityHS_SCCH_less_Capability = INT(name='id-ContinuousPacketConnectivityHS-SCCH-less-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContinuousPacketConnectivityHS_SCCH_less_Capability._val = 833
    
    #-----< id-ContinuousPacketConnectivityHS-SCCH-less-Information >-----#
    id_ContinuousPacketConnectivityHS_SCCH_less_Information = INT(name='id-ContinuousPacketConnectivityHS-SCCH-less-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContinuousPacketConnectivityHS_SCCH_less_Information._val = 834
    
    #-----< id-ContinuousPacketConnectivityHS-SCCH-less-Information-Response >-----#
    id_ContinuousPacketConnectivityHS_SCCH_less_Information_Response = INT(name='id-ContinuousPacketConnectivityHS-SCCH-less-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContinuousPacketConnectivityHS_SCCH_less_Information_Response._val = 835
    
    #-----< id-CPC-Information >-----#
    id_CPC_Information = INT(name='id-CPC-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPC_Information._val = 836
    
    #-----< id-MIMO-Capability >-----#
    id_MIMO_Capability = INT(name='id-MIMO-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_Capability._val = 837
    
    #-----< id-MIMO-PilotConfiguration >-----#
    id_MIMO_PilotConfiguration = INT(name='id-MIMO-PilotConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_PilotConfiguration._val = 838
    
    #-----< id-MBSFN-Cell-ParameterID-Cell-SetupRqstTDD >-----#
    id_MBSFN_Cell_ParameterID_Cell_SetupRqstTDD = INT(name='id-MBSFN-Cell-ParameterID-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSFN_Cell_ParameterID_Cell_SetupRqstTDD._val = 841
    
    #-----< id-MBSFN-Cell-ParameterID-Cell-ReconfRqstTDD >-----#
    id_MBSFN_Cell_ParameterID_Cell_ReconfRqstTDD = INT(name='id-MBSFN-Cell-ParameterID-Cell-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSFN_Cell_ParameterID_Cell_ReconfRqstTDD._val = 842
    
    #-----< id-S-CCPCH-Modulation >-----#
    id_S_CCPCH_Modulation = INT(name='id-S-CCPCH-Modulation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_CCPCH_Modulation._val = 843
    
    #-----< id-HS-PDSCH-Code-Change-Grant >-----#
    id_HS_PDSCH_Code_Change_Grant = INT(name='id-HS-PDSCH-Code-Change-Grant', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_PDSCH_Code_Change_Grant._val = 844
    
    #-----< id-HS-PDSCH-Code-Change-Indicator >-----#
    id_HS_PDSCH_Code_Change_Indicator = INT(name='id-HS-PDSCH-Code-Change-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_PDSCH_Code_Change_Indicator._val = 845
    
    #-----< id-SYNC-UL-Partition-LCR >-----#
    id_SYNC_UL_Partition_LCR = INT(name='id-SYNC-UL-Partition-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SYNC_UL_Partition_LCR._val = 846
    
    #-----< id-E-DCH-LCR-Information >-----#
    id_E_DCH_LCR_Information = INT(name='id-E-DCH-LCR-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_LCR_Information._val = 847
    
    #-----< id-E-DCH-LCR-Information-Reconfig >-----#
    id_E_DCH_LCR_Information_Reconfig = INT(name='id-E-DCH-LCR-Information-Reconfig', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_LCR_Information_Reconfig._val = 848
    
    #-----< id-E-PUCH-Information-LCR-PSCH-ReconfRqst >-----#
    id_E_PUCH_Information_LCR_PSCH_ReconfRqst = INT(name='id-E-PUCH-Information-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_PUCH_Information_LCR_PSCH_ReconfRqst._val = 852
    
    #-----< id-Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    id_Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst = INT(name='id-Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst._val = 853
    
    #-----< id-Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    id_Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst = INT(name='id-Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst._val = 854
    
    #-----< id-Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    id_Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst = INT(name='id-Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst._val = 855
    
    #-----< id-Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    id_Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst = INT(name='id-Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst._val = 856
    
    #-----< id-Delete-From-E-HICH-Resource-Pool-PSCH-ReconfRqst >-----#
    id_Delete_From_E_HICH_Resource_Pool_PSCH_ReconfRqst = INT(name='id-Delete-From-E-HICH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Delete_From_E_HICH_Resource_Pool_PSCH_ReconfRqst._val = 857
    
    #-----< id-E-HICH-TimeOffsetLCR >-----#
    id_E_HICH_TimeOffsetLCR = INT(name='id-E-HICH-TimeOffsetLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_HICH_TimeOffsetLCR._val = 858
    
    #-----< id-SixtyfourQAM-DL-Capability >-----#
    id_SixtyfourQAM_DL_Capability = INT(name='id-SixtyfourQAM-DL-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixtyfourQAM_DL_Capability._val = 860
    
    #-----< id-SixteenQAM-UL-Capability >-----#
    id_SixteenQAM_UL_Capability = INT(name='id-SixteenQAM-UL-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixteenQAM_UL_Capability._val = 861
    
    #-----< id-HSDSCH-MACdPDU-SizeCapability >-----#
    id_HSDSCH_MACdPDU_SizeCapability = INT(name='id-HSDSCH-MACdPDU-SizeCapability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_MACdPDU_SizeCapability._val = 864
    
    #-----< id-HSDSCH-MACdPDUSizeFormat >-----#
    id_HSDSCH_MACdPDUSizeFormat = INT(name='id-HSDSCH-MACdPDUSizeFormat', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_MACdPDUSizeFormat._val = 865
    
    #-----< id-MaximumMACdPDU-SizeExtended >-----#
    id_MaximumMACdPDU_SizeExtended = INT(name='id-MaximumMACdPDU-SizeExtended', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaximumMACdPDU_SizeExtended._val = 866
    
    #-----< id-F-DPCH-SlotFormat >-----#
    id_F_DPCH_SlotFormat = INT(name='id-F-DPCH-SlotFormat', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F_DPCH_SlotFormat._val = 870
    
    #-----< id-F-DPCH-SlotFormatCapability >-----#
    id_F_DPCH_SlotFormatCapability = INT(name='id-F-DPCH-SlotFormatCapability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F_DPCH_SlotFormatCapability._val = 871
    
    #-----< id-LCRTDD-uplink-Physical-Channel-Capability >-----#
    id_LCRTDD_uplink_Physical_Channel_Capability = INT(name='id-LCRTDD-uplink-Physical-Channel-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LCRTDD_uplink_Physical_Channel_Capability._val = 872
    
    #-----< id-Extended-RNC-ID >-----#
    id_Extended_RNC_ID = INT(name='id-Extended-RNC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_RNC_ID._val = 873
    
    #-----< id-Max-UE-DTX-Cycle >-----#
    id_Max_UE_DTX_Cycle = INT(name='id-Max-UE-DTX-Cycle', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Max_UE_DTX_Cycle._val = 874
    
    #-----< id-Secondary-CCPCH-SlotFormat-Extended >-----#
    id_Secondary_CCPCH_SlotFormat_Extended = INT(name='id-Secondary-CCPCH-SlotFormat-Extended', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Secondary_CCPCH_SlotFormat_Extended._val = 876
    
    #-----< id-MBSFN-Only-Mode-Indicator-Cell-SetupRqstTDD-LCR >-----#
    id_MBSFN_Only_Mode_Indicator_Cell_SetupRqstTDD_LCR = INT(name='id-MBSFN-Only-Mode-Indicator-Cell-SetupRqstTDD-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSFN_Only_Mode_Indicator_Cell_SetupRqstTDD_LCR._val = 878
    
    #-----< id-MBSFN-Only-Mode-Capability >-----#
    id_MBSFN_Only_Mode_Capability = INT(name='id-MBSFN-Only-Mode-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSFN_Only_Mode_Capability._val = 879
    
    #-----< id-Time-Slot-Parameter-ID >-----#
    id_Time_Slot_Parameter_ID = INT(name='id-Time-Slot-Parameter-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Time_Slot_Parameter_ID._val = 880
    
    #-----< id-Additional-failed-HS-SICH >-----#
    id_Additional_failed_HS_SICH = INT(name='id-Additional-failed-HS-SICH', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_failed_HS_SICH._val = 881
    
    #-----< id-Additional-missed-HS-SICH >-----#
    id_Additional_missed_HS_SICH = INT(name='id-Additional-missed-HS-SICH', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_missed_HS_SICH._val = 882
    
    #-----< id-Additional-total-HS-SICH >-----#
    id_Additional_total_HS_SICH = INT(name='id-Additional-total-HS-SICH', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_total_HS_SICH._val = 883
    
    #-----< id-Additional-HS-SICH-Reception-Quality-Measurement-Value >-----#
    id_Additional_HS_SICH_Reception_Quality_Measurement_Value = INT(name='id-Additional-HS-SICH-Reception-Quality-Measurement-Value', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_SICH_Reception_Quality_Measurement_Value._val = 884
    
    #-----< id-GANSS-Common-Data >-----#
    id_GANSS_Common_Data = INT(name='id-GANSS-Common-Data', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Common_Data._val = 887
    
    #-----< id-GANSS-Information >-----#
    id_GANSS_Information = INT(name='id-GANSS-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Information._val = 888
    
    #-----< id-GANSS-Generic-Data >-----#
    id_GANSS_Generic_Data = INT(name='id-GANSS-Generic-Data', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Generic_Data._val = 889
    
    #-----< id-TUTRANGANSSMeasurementThresholdInformation >-----#
    id_TUTRANGANSSMeasurementThresholdInformation = INT(name='id-TUTRANGANSSMeasurementThresholdInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TUTRANGANSSMeasurementThresholdInformation._val = 890
    
    #-----< id-TUTRANGANSSMeasurementValueInformation >-----#
    id_TUTRANGANSSMeasurementValueInformation = INT(name='id-TUTRANGANSSMeasurementValueInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TUTRANGANSSMeasurementValueInformation._val = 891
    
    #-----< id-ModulationPO-MBSFN >-----#
    id_ModulationPO_MBSFN = INT(name='id-ModulationPO-MBSFN', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ModulationPO_MBSFN._val = 892
    
    #-----< id-Enhanced-FACH-Capability >-----#
    id_Enhanced_FACH_Capability = INT(name='id-Enhanced-FACH-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_FACH_Capability._val = 895
    
    #-----< id-Enhanced-PCH-Capability >-----#
    id_Enhanced_PCH_Capability = INT(name='id-Enhanced-PCH-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_PCH_Capability._val = 896
    
    #-----< id-HSDSCH-Common-System-InformationFDD >-----#
    id_HSDSCH_Common_System_InformationFDD = INT(name='id-HSDSCH-Common-System-InformationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Common_System_InformationFDD._val = 897
    
    #-----< id-HSDSCH-Common-System-Information-ResponseFDD >-----#
    id_HSDSCH_Common_System_Information_ResponseFDD = INT(name='id-HSDSCH-Common-System-Information-ResponseFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Common_System_Information_ResponseFDD._val = 898
    
    #-----< id-HSDSCH-Paging-System-InformationFDD >-----#
    id_HSDSCH_Paging_System_InformationFDD = INT(name='id-HSDSCH-Paging-System-InformationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Paging_System_InformationFDD._val = 899
    
    #-----< id-HSDSCH-Paging-System-Information-ResponseFDD >-----#
    id_HSDSCH_Paging_System_Information_ResponseFDD = INT(name='id-HSDSCH-Paging-System-Information-ResponseFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Paging_System_Information_ResponseFDD._val = 900
    
    #-----< id-MBMS-Capability >-----#
    id_MBMS_Capability = INT(name='id-MBMS-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Capability._val = 901
    
    #-----< id-Ext-Reference-E-TFCI-PO >-----#
    id_Ext_Reference_E_TFCI_PO = INT(name='id-Ext-Reference-E-TFCI-PO', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ext_Reference_E_TFCI_PO._val = 902
    
    #-----< id-Ext-Max-Bits-MACe-PDU-non-scheduled >-----#
    id_Ext_Max_Bits_MACe_PDU_non_scheduled = INT(name='id-Ext-Max-Bits-MACe-PDU-non-scheduled', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ext_Max_Bits_MACe_PDU_non_scheduled._val = 903
    
    #-----< id-HARQ-MemoryPartitioningInfoExtForMIMO >-----#
    id_HARQ_MemoryPartitioningInfoExtForMIMO = INT(name='id-HARQ-MemoryPartitioningInfoExtForMIMO', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HARQ_MemoryPartitioningInfoExtForMIMO._val = 904
    
    #-----< id-MIMO-ActivationIndicator >-----#
    id_MIMO_ActivationIndicator = INT(name='id-MIMO-ActivationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_ActivationIndicator._val = 905
    
    #-----< id-MIMO-Mode-Indicator >-----#
    id_MIMO_Mode_Indicator = INT(name='id-MIMO-Mode-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_Mode_Indicator._val = 906
    
    #-----< id-MIMO-N-M-Ratio >-----#
    id_MIMO_N_M_Ratio = INT(name='id-MIMO-N-M-Ratio', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_N_M_Ratio._val = 907
    
    #-----< id-IPMulticastIndication >-----#
    id_IPMulticastIndication = INT(name='id-IPMulticastIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IPMulticastIndication._val = 908
    
    #-----< id-IPMulticastDataBearerIndication >-----#
    id_IPMulticastDataBearerIndication = INT(name='id-IPMulticastDataBearerIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IPMulticastDataBearerIndication._val = 909
    
    #-----< id-TransportBearerNotSetupIndicator >-----#
    id_TransportBearerNotSetupIndicator = INT(name='id-TransportBearerNotSetupIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransportBearerNotSetupIndicator._val = 910
    
    #-----< id-TransportBearerNotRequestedIndicator >-----#
    id_TransportBearerNotRequestedIndicator = INT(name='id-TransportBearerNotRequestedIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransportBearerNotRequestedIndicator._val = 911
    
    #-----< id-TimeSlotConfigurationList-LCR-CTCH-SetupRqstTDD >-----#
    id_TimeSlotConfigurationList_LCR_CTCH_SetupRqstTDD = INT(name='id-TimeSlotConfigurationList-LCR-CTCH-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSlotConfigurationList_LCR_CTCH_SetupRqstTDD._val = 912
    
    #-----< id-Cell-Frequency-List-Information-LCR-MulFreq-AuditRsp >-----#
    id_Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp = INT(name='id-Cell-Frequency-List-Information-LCR-MulFreq-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp._val = 913
    
    #-----< id-Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp >-----#
    id_Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp = INT(name='id-Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp._val = 914
    
    #-----< id-Cell-Frequency-List-LCR-MulFreq-Cell-SetupRqstTDD >-----#
    id_Cell_Frequency_List_LCR_MulFreq_Cell_SetupRqstTDD = INT(name='id-Cell-Frequency-List-LCR-MulFreq-Cell-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Frequency_List_LCR_MulFreq_Cell_SetupRqstTDD._val = 915
    
    #-----< id-UARFCN-Adjustment >-----#
    id_UARFCN_Adjustment = INT(name='id-UARFCN-Adjustment', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UARFCN_Adjustment._val = 916
    
    #-----< id-Cell-Frequency-List-Information-LCR-MulFreq-ResourceStatusInd >-----#
    id_Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd = INT(name='id-Cell-Frequency-List-Information-LCR-MulFreq-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd._val = 917
    
    #-----< id-Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd >-----#
    id_Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd = INT(name='id-Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd._val = 918
    
    #-----< id-UPPCHPositionLCR >-----#
    id_UPPCHPositionLCR = INT(name='id-UPPCHPositionLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UPPCHPositionLCR._val = 919
    
    #-----< id-UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD >-----#
    id_UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD = INT(name='id-UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD._val = 920
    
    #-----< id-UPPCH-LCR-InformationList-AuditRsp >-----#
    id_UPPCH_LCR_InformationList_AuditRsp = INT(name='id-UPPCH-LCR-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UPPCH_LCR_InformationList_AuditRsp._val = 921
    
    #-----< id-UPPCH-LCR-InformationItem-AuditRsp >-----#
    id_UPPCH_LCR_InformationItem_AuditRsp = INT(name='id-UPPCH-LCR-InformationItem-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UPPCH_LCR_InformationItem_AuditRsp._val = 922
    
    #-----< id-UPPCH-LCR-InformationList-ResourceStatusInd >-----#
    id_UPPCH_LCR_InformationList_ResourceStatusInd = INT(name='id-UPPCH-LCR-InformationList-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UPPCH_LCR_InformationList_ResourceStatusInd._val = 923
    
    #-----< id-UPPCH-LCR-InformationItem-ResourceStatusInd >-----#
    id_UPPCH_LCR_InformationItem_ResourceStatusInd = INT(name='id-UPPCH-LCR-InformationItem-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UPPCH_LCR_InformationItem_ResourceStatusInd._val = 924
    
    #-----< id-multipleFreq-dL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst >-----#
    id_multipleFreq_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst = INT(name='id-multipleFreq-dL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multipleFreq_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst._val = 925
    
    #-----< id-number-Of-Supported-Carriers >-----#
    id_number_Of_Supported_Carriers = INT(name='id-number-Of-Supported-Carriers', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_number_Of_Supported_Carriers._val = 926
    
    #-----< id-multipleFreq-HSPDSCH-InformationList-ResponseTDDLCR >-----#
    id_multipleFreq_HSPDSCH_InformationList_ResponseTDDLCR = INT(name='id-multipleFreq-HSPDSCH-InformationList-ResponseTDDLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multipleFreq_HSPDSCH_InformationList_ResponseTDDLCR._val = 927
    
    #-----< id-Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD >-----#
    id_Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD = INT(name='id-Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD._val = 928
    
    #-----< id-multipleFreq-HS-DSCH-Resources-InformationList-AuditRsp >-----#
    id_multipleFreq_HS_DSCH_Resources_InformationList_AuditRsp = INT(name='id-multipleFreq-HS-DSCH-Resources-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multipleFreq_HS_DSCH_Resources_InformationList_AuditRsp._val = 929
    
    #-----< id-multipleFreq-HS-DSCH-Resources-InformationList-ResourceStatusInd >-----#
    id_multipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd = INT(name='id-multipleFreq-HS-DSCH-Resources-InformationList-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd._val = 930
    
    #-----< id-UARFCNSpecificCauseList >-----#
    id_UARFCNSpecificCauseList = INT(name='id-UARFCNSpecificCauseList', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UARFCNSpecificCauseList._val = 931
    
    #-----< id-tSN-Length >-----#
    id_tSN_Length = INT(name='id-tSN-Length', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_tSN_Length._val = 932
    
    #-----< id-MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst >-----#
    id_MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst = INT(name='id-MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst._val = 933
    
    #-----< id-multicarrier-number >-----#
    id_multicarrier_number = INT(name='id-multicarrier-number', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multicarrier_number._val = 934
    
    #-----< id-Extended-HS-SCCH-ID >-----#
    id_Extended_HS_SCCH_ID = INT(name='id-Extended-HS-SCCH-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_HS_SCCH_ID._val = 935
    
    #-----< id-Extended-HS-SICH-ID >-----#
    id_Extended_HS_SICH_ID = INT(name='id-Extended-HS-SICH-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_HS_SICH_ID._val = 936
    
    #-----< id-HSSICH-InfoExt-DM-Rqst >-----#
    id_HSSICH_InfoExt_DM_Rqst = INT(name='id-HSSICH-InfoExt-DM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_InfoExt_DM_Rqst._val = 937
    
    #-----< id-Delete-From-HS-SCCH-Resource-PoolExt-PSCH-ReconfRqst >-----#
    id_Delete_From_HS_SCCH_Resource_PoolExt_PSCH_ReconfRqst = INT(name='id-Delete-From-HS-SCCH-Resource-PoolExt-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Delete_From_HS_SCCH_Resource_PoolExt_PSCH_ReconfRqst._val = 938
    
    #-----< id-HS-SCCH-InformationExt-LCR-PSCH-ReconfRqst >-----#
    id_HS_SCCH_InformationExt_LCR_PSCH_ReconfRqst = INT(name='id-HS-SCCH-InformationExt-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_SCCH_InformationExt_LCR_PSCH_ReconfRqst._val = 939
    
    #-----< id-HS-SCCH-InformationModifyExt-LCR-PSCH-ReconfRqst >-----#
    id_HS_SCCH_InformationModifyExt_LCR_PSCH_ReconfRqst = INT(name='id-HS-SCCH-InformationModifyExt-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_SCCH_InformationModifyExt_LCR_PSCH_ReconfRqst._val = 940
    
    #-----< id-PowerControlGAP >-----#
    id_PowerControlGAP = INT(name='id-PowerControlGAP', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PowerControlGAP._val = 941
    
    #-----< id-MBSFN-SpecialTimeSlot-LCR >-----#
    id_MBSFN_SpecialTimeSlot_LCR = INT(name='id-MBSFN-SpecialTimeSlot-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSFN_SpecialTimeSlot_LCR._val = 942
    
    #-----< id-Common-MACFlows-to-DeleteFDD >-----#
    id_Common_MACFlows_to_DeleteFDD = INT(name='id-Common-MACFlows-to-DeleteFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_MACFlows_to_DeleteFDD._val = 943
    
    #-----< id-Paging-MACFlows-to-DeleteFDD >-----#
    id_Paging_MACFlows_to_DeleteFDD = INT(name='id-Paging-MACFlows-to-DeleteFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Paging_MACFlows_to_DeleteFDD._val = 944
    
    #-----< id-E-TFCI-Boost-Information >-----#
    id_E_TFCI_Boost_Information = INT(name='id-E-TFCI-Boost-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_TFCI_Boost_Information._val = 945
    
    #-----< id-SixteenQAM-UL-Operation-Indicator >-----#
    id_SixteenQAM_UL_Operation_Indicator = INT(name='id-SixteenQAM-UL-Operation-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixteenQAM_UL_Operation_Indicator._val = 946
    
    #-----< id-SixtyfourQAM-UsageAllowedIndicator >-----#
    id_SixtyfourQAM_UsageAllowedIndicator = INT(name='id-SixtyfourQAM-UsageAllowedIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixtyfourQAM_UsageAllowedIndicator._val = 947
    
    #-----< id-SixtyfourQAM-DL-UsageIndicator >-----#
    id_SixtyfourQAM_DL_UsageIndicator = INT(name='id-SixtyfourQAM-DL-UsageIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixtyfourQAM_DL_UsageIndicator._val = 948
    
    #-----< id-Default-Serving-Grant-in-DTX-Cycle2 >-----#
    id_Default_Serving_Grant_in_DTX_Cycle2 = INT(name='id-Default-Serving-Grant-in-DTX-Cycle2', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Default_Serving_Grant_in_DTX_Cycle2._val = 949
    
    #-----< id-Maximum-Target-ReceivedTotalWideBandPower-LCR >-----#
    id_Maximum_Target_ReceivedTotalWideBandPower_LCR = INT(name='id-Maximum-Target-ReceivedTotalWideBandPower-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Maximum_Target_ReceivedTotalWideBandPower_LCR._val = 950
    
    #-----< id-E-DPDCH-PowerInterpolation >-----#
    id_E_DPDCH_PowerInterpolation = INT(name='id-E-DPDCH-PowerInterpolation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DPDCH_PowerInterpolation._val = 951
    
    #-----< id-Extended-E-DCH-LCRTDD-PhysicalLayerCategory >-----#
    id_Extended_E_DCH_LCRTDD_PhysicalLayerCategory = INT(name='id-Extended-E-DCH-LCRTDD-PhysicalLayerCategory', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_E_DCH_LCRTDD_PhysicalLayerCategory._val = 952
    
    #-----< id-MultipleFreq-E-DCH-Resources-InformationList-AuditRsp >-----#
    id_MultipleFreq_E_DCH_Resources_InformationList_AuditRsp = INT(name='id-MultipleFreq-E-DCH-Resources-InformationList-AuditRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultipleFreq_E_DCH_Resources_InformationList_AuditRsp._val = 953
    
    #-----< id-MultipleFreq-E-DCH-Resources-InformationList-ResourceStatusInd >-----#
    id_MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd = INT(name='id-MultipleFreq-E-DCH-Resources-InformationList-ResourceStatusInd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd._val = 954
    
    #-----< id-MultipleFreq-E-PUCH-Timeslot-InformationList-LCR-PSCH-ReconfRqst >-----#
    id_MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst = INT(name='id-MultipleFreq-E-PUCH-Timeslot-InformationList-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst._val = 955
    
    #-----< id-MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst >-----#
    id_MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst = INT(name='id-MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst._val = 956
    
    #-----< id-Extended-E-HICH-ID-TDD >-----#
    id_Extended_E_HICH_ID_TDD = INT(name='id-Extended-E-HICH-ID-TDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_E_HICH_ID_TDD._val = 957
    
    #-----< id-ContinuousPacketConnectivityHS-SCCH-less-Deactivate-Indicator >-----#
    id_ContinuousPacketConnectivityHS_SCCH_less_Deactivate_Indicator = INT(name='id-ContinuousPacketConnectivityHS-SCCH-less-Deactivate-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContinuousPacketConnectivityHS_SCCH_less_Deactivate_Indicator._val = 958
    
    #-----< id-E-DCH-MACdPDU-SizeCapability >-----#
    id_E_DCH_MACdPDU_SizeCapability = INT(name='id-E-DCH-MACdPDU-SizeCapability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_MACdPDU_SizeCapability._val = 959
    
    #-----< id-E-DCH-MACdPDUSizeFormat >-----#
    id_E_DCH_MACdPDUSizeFormat = INT(name='id-E-DCH-MACdPDUSizeFormat', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_MACdPDUSizeFormat._val = 960
    
    #-----< id-MaximumNumber-Of-Retransmission-for-Scheduling-Info-LCRTDD >-----#
    id_MaximumNumber_Of_Retransmission_for_Scheduling_Info_LCRTDD = INT(name='id-MaximumNumber-Of-Retransmission-for-Scheduling-Info-LCRTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaximumNumber_Of_Retransmission_for_Scheduling_Info_LCRTDD._val = 961
    
    #-----< id-E-DCH-RetransmissionTimer-for-SchedulingInfo-LCRTDD >-----#
    id_E_DCH_RetransmissionTimer_for_SchedulingInfo_LCRTDD = INT(name='id-E-DCH-RetransmissionTimer-for-SchedulingInfo-LCRTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_RetransmissionTimer_for_SchedulingInfo_LCRTDD._val = 962
    
    #-----< id-E-HICH-TimeOffset-Extension >-----#
    id_E_HICH_TimeOffset_Extension = INT(name='id-E-HICH-TimeOffset-Extension', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_HICH_TimeOffset_Extension._val = 963
    
    #-----< id-MultipleFreq-E-HICH-TimeOffsetLCR >-----#
    id_MultipleFreq_E_HICH_TimeOffsetLCR = INT(name='id-MultipleFreq-E-HICH-TimeOffsetLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultipleFreq_E_HICH_TimeOffsetLCR._val = 964
    
    #-----< id-E-PUCH-PowerControlGAP >-----#
    id_E_PUCH_PowerControlGAP = INT(name='id-E-PUCH-PowerControlGAP', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_PUCH_PowerControlGAP._val = 965
    
    #-----< id-HSDSCH-TBSizeTableIndicator >-----#
    id_HSDSCH_TBSizeTableIndicator = INT(name='id-HSDSCH-TBSizeTableIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_TBSizeTableIndicator._val = 966
    
    #-----< id-E-DCH-DL-Control-Channel-Change-Information >-----#
    id_E_DCH_DL_Control_Channel_Change_Information = INT(name='id-E-DCH-DL-Control-Channel-Change-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_DL_Control_Channel_Change_Information._val = 967
    
    #-----< id-E-DCH-DL-Control-Channel-Grant-Information >-----#
    id_E_DCH_DL_Control_Channel_Grant_Information = INT(name='id-E-DCH-DL-Control-Channel-Grant-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_DL_Control_Channel_Grant_Information._val = 968
    
    #-----< id-DGANSS-Corrections-Req >-----#
    id_DGANSS_Corrections_Req = INT(name='id-DGANSS-Corrections-Req', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DGANSS_Corrections_Req._val = 969
    
    #-----< id-UE-with-enhanced-HS-SCCH-support-indicator >-----#
    id_UE_with_enhanced_HS_SCCH_support_indicator = INT(name='id-UE-with-enhanced-HS-SCCH-support-indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_with_enhanced_HS_SCCH_support_indicator._val = 970
    
    #-----< id-AdditionalTimeSlotListLCR >-----#
    id_AdditionalTimeSlotListLCR = INT(name='id-AdditionalTimeSlotListLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalTimeSlotListLCR._val = 971
    
    #-----< id-AdditionalMeasurementValueList >-----#
    id_AdditionalMeasurementValueList = INT(name='id-AdditionalMeasurementValueList', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalMeasurementValueList._val = 972
    
    #-----< id-E-AGCH-Table-Choice >-----#
    id_E_AGCH_Table_Choice = INT(name='id-E-AGCH-Table-Choice', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_AGCH_Table_Choice._val = 978
    
    #-----< id-PLCCH-parameters >-----#
    id_PLCCH_parameters = INT(name='id-PLCCH-parameters', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLCCH_parameters._val = 981
    
    #-----< id-E-RUCCH-parameters >-----#
    id_E_RUCCH_parameters = INT(name='id-E-RUCCH-parameters', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RUCCH_parameters._val = 982
    
    #-----< id-E-RUCCH-768-parameters >-----#
    id_E_RUCCH_768_parameters = INT(name='id-E-RUCCH-768-parameters', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RUCCH_768_parameters._val = 983
    
    #-----< id-HS-Cause >-----#
    id_HS_Cause = INT(name='id-HS-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_Cause._val = 984
    
    #-----< id-E-Cause >-----#
    id_E_Cause = INT(name='id-E-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_Cause._val = 985
    
    #-----< id-Common-EDCH-Capability >-----#
    id_Common_EDCH_Capability = INT(name='id-Common-EDCH-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDCH_Capability._val = 987
    
    #-----< id-E-AI-Capability >-----#
    id_E_AI_Capability = INT(name='id-E-AI-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_AI_Capability._val = 988
    
    #-----< id-Common-EDCH-System-InformationFDD >-----#
    id_Common_EDCH_System_InformationFDD = INT(name='id-Common-EDCH-System-InformationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDCH_System_InformationFDD._val = 989
    
    #-----< id-Common-UL-MACFlows-to-DeleteFDD >-----#
    id_Common_UL_MACFlows_to_DeleteFDD = INT(name='id-Common-UL-MACFlows-to-DeleteFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_UL_MACFlows_to_DeleteFDD._val = 990
    
    #-----< id-Common-EDCH-MACdFlows-to-DeleteFDD >-----#
    id_Common_EDCH_MACdFlows_to_DeleteFDD = INT(name='id-Common-EDCH-MACdFlows-to-DeleteFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDCH_MACdFlows_to_DeleteFDD._val = 991
    
    #-----< id-Common-EDCH-System-Information-ResponseFDD >-----#
    id_Common_EDCH_System_Information_ResponseFDD = INT(name='id-Common-EDCH-System-Information-ResponseFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDCH_System_Information_ResponseFDD._val = 992
    
    #-----< id-Cell-ERNTI-Status-Information >-----#
    id_Cell_ERNTI_Status_Information = INT(name='id-Cell-ERNTI-Status-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_ERNTI_Status_Information._val = 993
    
    #-----< id-Enhanced-UE-DRX-Capability >-----#
    id_Enhanced_UE_DRX_Capability = INT(name='id-Enhanced-UE-DRX-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_UE_DRX_Capability._val = 994
    
    #-----< id-Enhanced-UE-DRX-InformationFDD >-----#
    id_Enhanced_UE_DRX_InformationFDD = INT(name='id-Enhanced-UE-DRX-InformationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_UE_DRX_InformationFDD._val = 995
    
    #-----< id-TransportBearerRequestIndicator >-----#
    id_TransportBearerRequestIndicator = INT(name='id-TransportBearerRequestIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransportBearerRequestIndicator._val = 996
    
    #-----< id-SixtyfourQAM-DL-MIMO-Combined-Capability >-----#
    id_SixtyfourQAM_DL_MIMO_Combined_Capability = INT(name='id-SixtyfourQAM-DL-MIMO-Combined-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixtyfourQAM_DL_MIMO_Combined_Capability._val = 997
    
    #-----< id-E-RNTI >-----#
    id_E_RNTI = INT(name='id-E-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RNTI._val = 998
    
    #-----< id-MinimumReducedE-DPDCH-GainFactor >-----#
    id_MinimumReducedE_DPDCH_GainFactor = INT(name='id-MinimumReducedE-DPDCH-GainFactor', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MinimumReducedE_DPDCH_GainFactor._val = 999
    
    #-----< id-GANSS-Time-ID >-----#
    id_GANSS_Time_ID = INT(name='id-GANSS-Time-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Time_ID._val = 1000
    
    #-----< id-GANSS-AddIonoModelReq >-----#
    id_GANSS_AddIonoModelReq = INT(name='id-GANSS-AddIonoModelReq', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_AddIonoModelReq._val = 1001
    
    #-----< id-GANSS-EarthOrientParaReq >-----#
    id_GANSS_EarthOrientParaReq = INT(name='id-GANSS-EarthOrientParaReq', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_EarthOrientParaReq._val = 1002
    
    #-----< id-GANSS-AddNavigationModelsReq >-----#
    id_GANSS_AddNavigationModelsReq = INT(name='id-GANSS-AddNavigationModelsReq', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_AddNavigationModelsReq._val = 1003
    
    #-----< id-GANSS-AddUTCModelsReq >-----#
    id_GANSS_AddUTCModelsReq = INT(name='id-GANSS-AddUTCModelsReq', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_AddUTCModelsReq._val = 1004
    
    #-----< id-GANSS-AuxInfoReq >-----#
    id_GANSS_AuxInfoReq = INT(name='id-GANSS-AuxInfoReq', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_AuxInfoReq._val = 1005
    
    #-----< id-GANSS-SBAS-ID >-----#
    id_GANSS_SBAS_ID = INT(name='id-GANSS-SBAS-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_SBAS_ID._val = 1006
    
    #-----< id-GANSS-ID >-----#
    id_GANSS_ID = INT(name='id-GANSS-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_ID._val = 1007
    
    #-----< id-GANSS-Additional-Ionospheric-Model >-----#
    id_GANSS_Additional_Ionospheric_Model = INT(name='id-GANSS-Additional-Ionospheric-Model', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_Ionospheric_Model._val = 1008
    
    #-----< id-GANSS-Earth-Orientation-Parameters >-----#
    id_GANSS_Earth_Orientation_Parameters = INT(name='id-GANSS-Earth-Orientation-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Earth_Orientation_Parameters._val = 1009
    
    #-----< id-GANSS-Additional-Time-Models >-----#
    id_GANSS_Additional_Time_Models = INT(name='id-GANSS-Additional-Time-Models', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_Time_Models._val = 1010
    
    #-----< id-GANSS-Additional-Navigation-Models >-----#
    id_GANSS_Additional_Navigation_Models = INT(name='id-GANSS-Additional-Navigation-Models', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_Navigation_Models._val = 1011
    
    #-----< id-GANSS-Additional-UTC-Models >-----#
    id_GANSS_Additional_UTC_Models = INT(name='id-GANSS-Additional-UTC-Models', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_UTC_Models._val = 1012
    
    #-----< id-GANSS-Auxiliary-Information >-----#
    id_GANSS_Auxiliary_Information = INT(name='id-GANSS-Auxiliary-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Auxiliary_Information._val = 1013
    
    #-----< id-ERACH-CM-Rqst >-----#
    id_ERACH_CM_Rqst = INT(name='id-ERACH-CM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ERACH_CM_Rqst._val = 1014
    
    #-----< id-ERACH-CM-Rsp >-----#
    id_ERACH_CM_Rsp = INT(name='id-ERACH-CM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ERACH_CM_Rsp._val = 1015
    
    #-----< id-ERACH-CM-Rprt >-----#
    id_ERACH_CM_Rprt = INT(name='id-ERACH-CM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ERACH_CM_Rprt._val = 1016
    
    #-----< id-EDCH-RACH-Report-Value >-----#
    id_EDCH_RACH_Report_Value = INT(name='id-EDCH-RACH-Report-Value', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_RACH_Report_Value._val = 1017
    
    #-----< id-EDCH-RACH-Report-IncrDecrThres >-----#
    id_EDCH_RACH_Report_IncrDecrThres = INT(name='id-EDCH-RACH-Report-IncrDecrThres', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_RACH_Report_IncrDecrThres._val = 1018
    
    #-----< id-EDCH-RACH-Report-ThresholdInformation >-----#
    id_EDCH_RACH_Report_ThresholdInformation = INT(name='id-EDCH-RACH-Report-ThresholdInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_RACH_Report_ThresholdInformation._val = 1019
    
    #-----< id-E-DPCCH-Power-Boosting-Capability >-----#
    id_E_DPCCH_Power_Boosting_Capability = INT(name='id-E-DPCCH-Power-Boosting-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DPCCH_Power_Boosting_Capability._val = 1020
    
    #-----< id-HSDSCH-Common-System-InformationLCR >-----#
    id_HSDSCH_Common_System_InformationLCR = INT(name='id-HSDSCH-Common-System-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Common_System_InformationLCR._val = 1021
    
    #-----< id-HSDSCH-Common-System-Information-ResponseLCR >-----#
    id_HSDSCH_Common_System_Information_ResponseLCR = INT(name='id-HSDSCH-Common-System-Information-ResponseLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Common_System_Information_ResponseLCR._val = 1222
    
    #-----< id-HSDSCH-Paging-System-InformationLCR >-----#
    id_HSDSCH_Paging_System_InformationLCR = INT(name='id-HSDSCH-Paging-System-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Paging_System_InformationLCR._val = 1023
    
    #-----< id-HSDSCH-Paging-System-Information-ResponseLCR >-----#
    id_HSDSCH_Paging_System_Information_ResponseLCR = INT(name='id-HSDSCH-Paging-System-Information-ResponseLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Paging_System_Information_ResponseLCR._val = 1024
    
    #-----< id-Common-MACFlows-to-DeleteLCR >-----#
    id_Common_MACFlows_to_DeleteLCR = INT(name='id-Common-MACFlows-to-DeleteLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_MACFlows_to_DeleteLCR._val = 1025
    
    #-----< id-Paging-MACFlows-to-DeleteLCR >-----#
    id_Paging_MACFlows_to_DeleteLCR = INT(name='id-Paging-MACFlows-to-DeleteLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Paging_MACFlows_to_DeleteLCR._val = 1026
    
    #-----< id-Common-EDCH-System-InformationLCR >-----#
    id_Common_EDCH_System_InformationLCR = INT(name='id-Common-EDCH-System-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDCH_System_InformationLCR._val = 1027
    
    #-----< id-Common-UL-MACFlows-to-DeleteLCR >-----#
    id_Common_UL_MACFlows_to_DeleteLCR = INT(name='id-Common-UL-MACFlows-to-DeleteLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_UL_MACFlows_to_DeleteLCR._val = 1028
    
    #-----< id-Common-EDCH-MACdFlows-to-DeleteLCR >-----#
    id_Common_EDCH_MACdFlows_to_DeleteLCR = INT(name='id-Common-EDCH-MACdFlows-to-DeleteLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDCH_MACdFlows_to_DeleteLCR._val = 1029
    
    #-----< id-Common-EDCH-System-Information-ResponseLCR >-----#
    id_Common_EDCH_System_Information_ResponseLCR = INT(name='id-Common-EDCH-System-Information-ResponseLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDCH_System_Information_ResponseLCR._val = 1030
    
    #-----< id-Enhanced-UE-DRX-CapabilityLCR >-----#
    id_Enhanced_UE_DRX_CapabilityLCR = INT(name='id-Enhanced-UE-DRX-CapabilityLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_UE_DRX_CapabilityLCR._val = 1031
    
    #-----< id-Enhanced-UE-DRX-InformationLCR >-----#
    id_Enhanced_UE_DRX_InformationLCR = INT(name='id-Enhanced-UE-DRX-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_UE_DRX_InformationLCR._val = 1032
    
    #-----< id-HSDSCH-PreconfigurationSetup >-----#
    id_HSDSCH_PreconfigurationSetup = INT(name='id-HSDSCH-PreconfigurationSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_PreconfigurationSetup._val = 1033
    
    #-----< id-HSDSCH-PreconfigurationInfo >-----#
    id_HSDSCH_PreconfigurationInfo = INT(name='id-HSDSCH-PreconfigurationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_PreconfigurationInfo._val = 1034
    
    #-----< id-NoOfTargetCellHS-SCCH-Order >-----#
    id_NoOfTargetCellHS_SCCH_Order = INT(name='id-NoOfTargetCellHS-SCCH-Order', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NoOfTargetCellHS_SCCH_Order._val = 1035
    
    #-----< id-EnhancedHSServingCC-Abort >-----#
    id_EnhancedHSServingCC_Abort = INT(name='id-EnhancedHSServingCC-Abort', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EnhancedHSServingCC_Abort._val = 1036
    
    #-----< id-Additional-HS-Cell-Information-RL-Setup >-----#
    id_Additional_HS_Cell_Information_RL_Setup = INT(name='id-Additional-HS-Cell-Information-RL-Setup', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_RL_Setup._val = 1037
    
    #-----< id-Additional-HS-Cell-Information-Response >-----#
    id_Additional_HS_Cell_Information_Response = INT(name='id-Additional-HS-Cell-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_Response._val = 1038
    
    #-----< id-Additional-HS-Cell-Information-RL-Addition >-----#
    id_Additional_HS_Cell_Information_RL_Addition = INT(name='id-Additional-HS-Cell-Information-RL-Addition', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_RL_Addition._val = 1039
    
    #-----< id-Additional-HS-Cell-Change-Information-Response >-----#
    id_Additional_HS_Cell_Change_Information_Response = INT(name='id-Additional-HS-Cell-Change-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Change_Information_Response._val = 1040
    
    #-----< id-Additional-HS-Cell-Information-RL-Reconf-Prep >-----#
    id_Additional_HS_Cell_Information_RL_Reconf_Prep = INT(name='id-Additional-HS-Cell-Information-RL-Reconf-Prep', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_RL_Reconf_Prep._val = 1041
    
    #-----< id-Additional-HS-Cell-Information-RL-Reconf-Req >-----#
    id_Additional_HS_Cell_Information_RL_Reconf_Req = INT(name='id-Additional-HS-Cell-Information-RL-Reconf-Req', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_RL_Reconf_Req._val = 1042
    
    #-----< id-Additional-HS-Cell-Information-RL-Param-Upd >-----#
    id_Additional_HS_Cell_Information_RL_Param_Upd = INT(name='id-Additional-HS-Cell-Information-RL-Param-Upd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_RL_Param_Upd._val = 1043
    
    #-----< id-Multi-Cell-Capability-Info >-----#
    id_Multi_Cell_Capability_Info = INT(name='id-Multi-Cell-Capability-Info', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multi_Cell_Capability_Info._val = 1044
    
    #-----< id-IMB-Parameters >-----#
    id_IMB_Parameters = INT(name='id-IMB-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IMB_Parameters._val = 1045
    
    #-----< id-MACes-Maximum-Bitrate-LCR >-----#
    id_MACes_Maximum_Bitrate_LCR = INT(name='id-MACes-Maximum-Bitrate-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MACes_Maximum_Bitrate_LCR._val = 1046
    
    #-----< id-Semi-PersistentScheduling-CapabilityLCR >-----#
    id_Semi_PersistentScheduling_CapabilityLCR = INT(name='id-Semi-PersistentScheduling-CapabilityLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Semi_PersistentScheduling_CapabilityLCR._val = 1047
    
    #-----< id-E-DCH-Semi-PersistentScheduling-Information-LCR >-----#
    id_E_DCH_Semi_PersistentScheduling_Information_LCR = INT(name='id-E-DCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Semi_PersistentScheduling_Information_LCR._val = 1048
    
    #-----< id-HS-DSCH-Semi-PersistentScheduling-Information-LCR >-----#
    id_HS_DSCH_Semi_PersistentScheduling_Information_LCR = INT(name='id-HS-DSCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCH_Semi_PersistentScheduling_Information_LCR._val = 1049
    
    #-----< id-Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    id_Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst = INT(name='id-Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst._val = 1050
    
    #-----< id-Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    id_Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst = INT(name='id-Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst._val = 1051
    
    #-----< id-Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    id_Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst = INT(name='id-Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst._val = 1052
    
    #-----< id-ContinuousPacketConnectivity-DRX-CapabilityLCR >-----#
    id_ContinuousPacketConnectivity_DRX_CapabilityLCR = INT(name='id-ContinuousPacketConnectivity-DRX-CapabilityLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContinuousPacketConnectivity_DRX_CapabilityLCR._val = 1053
    
    #-----< id-ContinuousPacketConnectivity-DRX-InformationLCR >-----#
    id_ContinuousPacketConnectivity_DRX_InformationLCR = INT(name='id-ContinuousPacketConnectivity-DRX-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContinuousPacketConnectivity_DRX_InformationLCR._val = 1054
    
    #-----< id-ContinuousPacketConnectivity-DRX-Information-ResponseLCR >-----#
    id_ContinuousPacketConnectivity_DRX_Information_ResponseLCR = INT(name='id-ContinuousPacketConnectivity-DRX-Information-ResponseLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContinuousPacketConnectivity_DRX_Information_ResponseLCR._val = 1055
    
    #-----< id-CPC-InformationLCR >-----#
    id_CPC_InformationLCR = INT(name='id-CPC-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPC_InformationLCR._val = 1056
    
    #-----< id-HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR >-----#
    id_HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR = INT(name='id-HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR._val = 1057
    
    #-----< id-E-DCH-Semi-PersistentScheduling-Information-ResponseLCR >-----#
    id_E_DCH_Semi_PersistentScheduling_Information_ResponseLCR = INT(name='id-E-DCH-Semi-PersistentScheduling-Information-ResponseLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Semi_PersistentScheduling_Information_ResponseLCR._val = 1058
    
    #-----< id-E-AGCH-UE-Inactivity-Monitor-Threshold >-----#
    id_E_AGCH_UE_Inactivity_Monitor_Threshold = INT(name='id-E-AGCH-UE-Inactivity-Monitor-Threshold', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_AGCH_UE_Inactivity_Monitor_Threshold._val = 1059
    
    #-----< id-IdleIntervalInformation >-----#
    id_IdleIntervalInformation = INT(name='id-IdleIntervalInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IdleIntervalInformation._val = 1063
    
    #-----< id-GANSS-alm-keplerianNAVAlmanac >-----#
    id_GANSS_alm_keplerianNAVAlmanac = INT(name='id-GANSS-alm-keplerianNAVAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianNAVAlmanac._val = 1064
    
    #-----< id-GANSS-alm-keplerianReducedAlmanac >-----#
    id_GANSS_alm_keplerianReducedAlmanac = INT(name='id-GANSS-alm-keplerianReducedAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianReducedAlmanac._val = 1065
    
    #-----< id-GANSS-alm-keplerianMidiAlmanac >-----#
    id_GANSS_alm_keplerianMidiAlmanac = INT(name='id-GANSS-alm-keplerianMidiAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianMidiAlmanac._val = 1066
    
    #-----< id-GANSS-alm-keplerianGLONASS >-----#
    id_GANSS_alm_keplerianGLONASS = INT(name='id-GANSS-alm-keplerianGLONASS', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianGLONASS._val = 1067
    
    #-----< id-GANSS-alm-ecefSBASAlmanac >-----#
    id_GANSS_alm_ecefSBASAlmanac = INT(name='id-GANSS-alm-ecefSBASAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_ecefSBASAlmanac._val = 1068
    
    #-----< id-HSSICH-ReferenceSignal-InformationLCR >-----#
    id_HSSICH_ReferenceSignal_InformationLCR = INT(name='id-HSSICH-ReferenceSignal-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_ReferenceSignal_InformationLCR._val = 1070
    
    #-----< id-MIMO-ReferenceSignal-InformationListLCR >-----#
    id_MIMO_ReferenceSignal_InformationListLCR = INT(name='id-MIMO-ReferenceSignal-InformationListLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_ReferenceSignal_InformationListLCR._val = 1071
    
    #-----< id-MIMO-SFMode-For-HSPDSCHDualStream >-----#
    id_MIMO_SFMode_For_HSPDSCHDualStream = INT(name='id-MIMO-SFMode-For-HSPDSCHDualStream', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_SFMode_For_HSPDSCHDualStream._val = 1072
    
    #-----< id-MIMO-SFMode-Supported-For-HSPDSCHDualStream >-----#
    id_MIMO_SFMode_Supported_For_HSPDSCHDualStream = INT(name='id-MIMO-SFMode-Supported-For-HSPDSCHDualStream', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_SFMode_Supported_For_HSPDSCHDualStream._val = 1073
    
    #-----< id-UE-Selected-MBMS-Service-Information >-----#
    id_UE_Selected_MBMS_Service_Information = INT(name='id-UE-Selected-MBMS-Service-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Selected_MBMS_Service_Information._val = 1074
    
    #-----< id-MultiCarrier-HSDSCH-Physical-Layer-Category >-----#
    id_MultiCarrier_HSDSCH_Physical_Layer_Category = INT(name='id-MultiCarrier-HSDSCH-Physical-Layer-Category', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultiCarrier_HSDSCH_Physical_Layer_Category._val = 1077
    
    #-----< id-Common-E-DCH-HSDPCCH-Capability >-----#
    id_Common_E_DCH_HSDPCCH_Capability = INT(name='id-Common-E-DCH-HSDPCCH-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_E_DCH_HSDPCCH_Capability._val = 1078
    
    #-----< id-DL-RLC-PDU-Size-Format >-----#
    id_DL_RLC_PDU_Size_Format = INT(name='id-DL-RLC-PDU-Size-Format', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_RLC_PDU_Size_Format._val = 1079
    
    #-----< id-HSSICH-ReferenceSignal-InformationModifyLCR >-----#
    id_HSSICH_ReferenceSignal_InformationModifyLCR = INT(name='id-HSSICH-ReferenceSignal-InformationModifyLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_ReferenceSignal_InformationModifyLCR._val = 1080
    
    #-----< id-schedulingPriorityIndicator >-----#
    id_schedulingPriorityIndicator = INT(name='id-schedulingPriorityIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_schedulingPriorityIndicator._val = 1081
    
    #-----< id-TimeSlotMeasurementValueListLCR >-----#
    id_TimeSlotMeasurementValueListLCR = INT(name='id-TimeSlotMeasurementValueListLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSlotMeasurementValueListLCR._val = 1082
    
    #-----< id-UE-SupportIndicatorExtension >-----#
    id_UE_SupportIndicatorExtension = INT(name='id-UE-SupportIndicatorExtension', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_SupportIndicatorExtension._val = 1085
    
    #-----< id-Single-Stream-MIMO-ActivationIndicator >-----#
    id_Single_Stream_MIMO_ActivationIndicator = INT(name='id-Single-Stream-MIMO-ActivationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Single_Stream_MIMO_ActivationIndicator._val = 1088
    
    #-----< id-Single-Stream-MIMO-Capability >-----#
    id_Single_Stream_MIMO_Capability = INT(name='id-Single-Stream-MIMO-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Single_Stream_MIMO_Capability._val = 1089
    
    #-----< id-Single-Stream-MIMO-Mode-Indicator >-----#
    id_Single_Stream_MIMO_Mode_Indicator = INT(name='id-Single-Stream-MIMO-Mode-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Single_Stream_MIMO_Mode_Indicator._val = 1090
    
    #-----< id-Dual-Band-Capability-Info >-----#
    id_Dual_Band_Capability_Info = INT(name='id-Dual-Band-Capability-Info', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Dual_Band_Capability_Info._val = 1091
    
    #-----< id-UE-AggregateMaximumBitRate >-----#
    id_UE_AggregateMaximumBitRate = INT(name='id-UE-AggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_AggregateMaximumBitRate._val = 1092
    
    #-----< id-UE-AggregateMaximumBitRate-Enforcement-Indicator >-----#
    id_UE_AggregateMaximumBitRate_Enforcement_Indicator = INT(name='id-UE-AggregateMaximumBitRate-Enforcement-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_AggregateMaximumBitRate_Enforcement_Indicator._val = 1093
    
    #-----< id-MIMO-Power-Offset-For-S-CPICH-Capability >-----#
    id_MIMO_Power_Offset_For_S_CPICH_Capability = INT(name='id-MIMO-Power-Offset-For-S-CPICH-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_Power_Offset_For_S_CPICH_Capability._val = 1101
    
    #-----< id-MIMO-PilotConfigurationExtension >-----#
    id_MIMO_PilotConfigurationExtension = INT(name='id-MIMO-PilotConfigurationExtension', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_PilotConfigurationExtension._val = 1102
    
    #-----< id-TxDiversityOnDLControlChannelsByMIMOUECapability >-----#
    id_TxDiversityOnDLControlChannelsByMIMOUECapability = INT(name='id-TxDiversityOnDLControlChannelsByMIMOUECapability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TxDiversityOnDLControlChannelsByMIMOUECapability._val = 1103
    
    #-----< id-ULTimeslotISCPValue-For-CellPortion >-----#
    id_ULTimeslotISCPValue_For_CellPortion = INT(name='id-ULTimeslotISCPValue-For-CellPortion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULTimeslotISCPValue_For_CellPortion._val = 1104
    
    #-----< id-UpPTSInterferenceValue-For-CellPortion >-----#
    id_UpPTSInterferenceValue_For_CellPortion = INT(name='id-UpPTSInterferenceValue-For-CellPortion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UpPTSInterferenceValue_For_CellPortion._val = 1105
    
    #-----< id-Best-Cell-Portions-ValueLCR >-----#
    id_Best_Cell_Portions_ValueLCR = INT(name='id-Best-Cell-Portions-ValueLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Best_Cell_Portions_ValueLCR._val = 1106
    
    #-----< id-Transmitted-Carrier-Power-For-CellPortion-ValueLCR >-----#
    id_Transmitted_Carrier_Power_For_CellPortion_ValueLCR = INT(name='id-Transmitted-Carrier-Power-For-CellPortion-ValueLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Transmitted_Carrier_Power_For_CellPortion_ValueLCR._val = 1107
    
    #-----< id-Received-total-wide-band-power-For-CellPortion-ValueLCR >-----#
    id_Received_total_wide_band_power_For_CellPortion_ValueLCR = INT(name='id-Received-total-wide-band-power-For-CellPortion-ValueLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Received_total_wide_band_power_For_CellPortion_ValueLCR._val = 1108
    
    #-----< id-UL-TimeslotISCP-For-CellPortion-Value >-----#
    id_UL_TimeslotISCP_For_CellPortion_Value = INT(name='id-UL-TimeslotISCP-For-CellPortion-Value', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_TimeslotISCP_For_CellPortion_Value._val = 1109
    
    #-----< id-HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR >-----#
    id_HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR = INT(name='id-HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR._val = 1110
    
    #-----< id-HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR >-----#
    id_HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR = INT(name='id-HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR._val = 1111
    
    #-----< id-E-DCHProvidedBitRateValueInformation-For-CellPortion >-----#
    id_E_DCHProvidedBitRateValueInformation_For_CellPortion = INT(name='id-E-DCHProvidedBitRateValueInformation-For-CellPortion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCHProvidedBitRateValueInformation_For_CellPortion._val = 1112
    
    #-----< id-UpPTSInterference-For-CellPortion-Value >-----#
    id_UpPTSInterference_For_CellPortion_Value = INT(name='id-UpPTSInterference-For-CellPortion-Value', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UpPTSInterference_For_CellPortion_Value._val = 1113
    
    #-----< id-NumberOfReportedCellPortionsLCR >-----#
    id_NumberOfReportedCellPortionsLCR = INT(name='id-NumberOfReportedCellPortionsLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberOfReportedCellPortionsLCR._val = 1114
    
    #-----< id-CellPortion-CapabilityLCR >-----#
    id_CellPortion_CapabilityLCR = INT(name='id-CellPortion-CapabilityLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellPortion_CapabilityLCR._val = 1115
    
    #-----< id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue >-----#
    id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue = INT(name='id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue._val = 1116
    
    #-----< id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortion >-----#
    id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortion = INT(name='id-TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortion._val = 1117
    
    #-----< id-ActivationInformation >-----#
    id_ActivationInformation = INT(name='id-ActivationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivationInformation._val = 1119
    
    #-----< id-Additional-EDCH-Cell-Information-RL-Setup-Req >-----#
    id_Additional_EDCH_Cell_Information_RL_Setup_Req = INT(name='id-Additional-EDCH-Cell-Information-RL-Setup-Req', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_RL_Setup_Req._val = 1120
    
    #-----< id-Additional-EDCH-Cell-Information-Response >-----#
    id_Additional_EDCH_Cell_Information_Response = INT(name='id-Additional-EDCH-Cell-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_Response._val = 1121
    
    #-----< id-Additional-EDCH-Cell-Information-RL-Add-Req >-----#
    id_Additional_EDCH_Cell_Information_RL_Add_Req = INT(name='id-Additional-EDCH-Cell-Information-RL-Add-Req', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_RL_Add_Req._val = 1122
    
    #-----< id-Additional-EDCH-Cell-Information-Response-RL-Add >-----#
    id_Additional_EDCH_Cell_Information_Response_RL_Add = INT(name='id-Additional-EDCH-Cell-Information-Response-RL-Add', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_Response_RL_Add._val = 1123
    
    #-----< id-Additional-EDCH-Cell-Information-RL-Reconf-Prep >-----#
    id_Additional_EDCH_Cell_Information_RL_Reconf_Prep = INT(name='id-Additional-EDCH-Cell-Information-RL-Reconf-Prep', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_RL_Reconf_Prep._val = 1124
    
    #-----< id-Additional-EDCH-Cell-Information-RL-Reconf-Req >-----#
    id_Additional_EDCH_Cell_Information_RL_Reconf_Req = INT(name='id-Additional-EDCH-Cell-Information-RL-Reconf-Req', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_RL_Reconf_Req._val = 1125
    
    #-----< id-Additional-EDCH-Cell-Information-Bearer-Rearrangement >-----#
    id_Additional_EDCH_Cell_Information_Bearer_Rearrangement = INT(name='id-Additional-EDCH-Cell-Information-Bearer-Rearrangement', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_Bearer_Rearrangement._val = 1126
    
    #-----< id-Additional-EDCH-Cell-Information-RL-Param-Upd >-----#
    id_Additional_EDCH_Cell_Information_RL_Param_Upd = INT(name='id-Additional-EDCH-Cell-Information-RL-Param-Upd', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_RL_Param_Upd._val = 1127
    
    #-----< id-Additional-EDCH-Preconfiguration-Information >-----#
    id_Additional_EDCH_Preconfiguration_Information = INT(name='id-Additional-EDCH-Preconfiguration-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Preconfiguration_Information._val = 1128
    
    #-----< id-EDCH-Indicator >-----#
    id_EDCH_Indicator = INT(name='id-EDCH-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_Indicator._val = 1129
    
    #-----< id-HS-DSCH-SPS-Reservation-Indicator >-----#
    id_HS_DSCH_SPS_Reservation_Indicator = INT(name='id-HS-DSCH-SPS-Reservation-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCH_SPS_Reservation_Indicator._val = 1131
    
    #-----< id-E-DCH-SPS-Reservation-Indicator >-----#
    id_E_DCH_SPS_Reservation_Indicator = INT(name='id-E-DCH-SPS-Reservation-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_SPS_Reservation_Indicator._val = 1132
    
    #-----< id-MultipleFreq-HARQ-MemoryPartitioning-InformationList >-----#
    id_MultipleFreq_HARQ_MemoryPartitioning_InformationList = INT(name='id-MultipleFreq-HARQ-MemoryPartitioning-InformationList', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultipleFreq_HARQ_MemoryPartitioning_InformationList._val = 1133
    
    #-----< id-Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR-Ext >-----#
    id_Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR_Ext = INT(name='id-Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR-Ext', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR_Ext._val = 1134
    
    #-----< id-RepetitionPeriodIndex >-----#
    id_RepetitionPeriodIndex = INT(name='id-RepetitionPeriodIndex', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RepetitionPeriodIndex._val = 1135
    
    #-----< id-MidambleShiftLCR >-----#
    id_MidambleShiftLCR = INT(name='id-MidambleShiftLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MidambleShiftLCR._val = 1136
    
    #-----< id-MaxHSDSCH-HSSCCH-Power-per-CELLPORTION >-----#
    id_MaxHSDSCH_HSSCCH_Power_per_CELLPORTION = INT(name='id-MaxHSDSCH-HSSCCH-Power-per-CELLPORTION', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaxHSDSCH_HSSCCH_Power_per_CELLPORTION._val = 1137
    
    #-----< id-DormantModeIndicator >-----#
    id_DormantModeIndicator = INT(name='id-DormantModeIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DormantModeIndicator._val = 1138
    
    #-----< id-DiversityMode >-----#
    id_DiversityMode = INT(name='id-DiversityMode', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DiversityMode._val = 1139
    
    #-----< id-TransmitDiversityIndicator >-----#
    id_TransmitDiversityIndicator = INT(name='id-TransmitDiversityIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmitDiversityIndicator._val = 1140
    
    #-----< id-NonCellSpecificTxDiversity >-----#
    id_NonCellSpecificTxDiversity = INT(name='id-NonCellSpecificTxDiversity', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NonCellSpecificTxDiversity._val = 1141
    
    #-----< id-Cell-Capability-Container >-----#
    id_Cell_Capability_Container = INT(name='id-Cell-Capability-Container', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Capability_Container._val = 1142
    
    #-----< id-E-RNTI-List-Request >-----#
    id_E_RNTI_List_Request = INT(name='id-E-RNTI-List-Request', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RNTI_List_Request._val = 1143
    
    #-----< id-E-RNTI-List >-----#
    id_E_RNTI_List = INT(name='id-E-RNTI-List', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RNTI_List._val = 1144
    
    #-----< id-PowerControlGAP-For-CellFACHLCR >-----#
    id_PowerControlGAP_For_CellFACHLCR = INT(name='id-PowerControlGAP-For-CellFACHLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PowerControlGAP_For_CellFACHLCR._val = 1145
    
    #-----< id-UL-Synchronisation-Parameters-For-FACHLCR >-----#
    id_UL_Synchronisation_Parameters_For_FACHLCR = INT(name='id-UL-Synchronisation-Parameters-For-FACHLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_Synchronisation_Parameters_For_FACHLCR._val = 1147
    
    #-----< id-HS-DSCH-SPS-Operation-Indicator >-----#
    id_HS_DSCH_SPS_Operation_Indicator = INT(name='id-HS-DSCH-SPS-Operation-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCH_SPS_Operation_Indicator._val = 1148
    
    #-----< id-HSDSCH-RNTI-For-FACH >-----#
    id_HSDSCH_RNTI_For_FACH = INT(name='id-HSDSCH-RNTI-For-FACH', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_RNTI_For_FACH._val = 1149
    
    #-----< id-E-RNTI-For-FACH >-----#
    id_E_RNTI_For_FACH = INT(name='id-E-RNTI-For-FACH', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RNTI_For_FACH._val = 1150
    
    #-----< id-Out-of-Sychronization-Window >-----#
    id_Out_of_Sychronization_Window = INT(name='id-Out-of-Sychronization-Window', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Out_of_Sychronization_Window._val = 1151
    
    #-----< id-Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst >-----#
    id_Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst = INT(name='id-Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst._val = 1152
    
    #-----< id-E-HICH-TimeOffset-ReconfFailureTDD >-----#
    id_E_HICH_TimeOffset_ReconfFailureTDD = INT(name='id-E-HICH-TimeOffset-ReconfFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_HICH_TimeOffset_ReconfFailureTDD._val = 1153
    
    #-----< id-HSSCCH-TPC-StepSize >-----#
    id_HSSCCH_TPC_StepSize = INT(name='id-HSSCCH-TPC-StepSize', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSCCH_TPC_StepSize._val = 1154
    
    #-----< id-TS0-CapabilityLCR >-----#
    id_TS0_CapabilityLCR = INT(name='id-TS0-CapabilityLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TS0_CapabilityLCR._val = 1155
    
    #-----< id-UE-TS0-CapabilityLCR >-----#
    id_UE_TS0_CapabilityLCR = INT(name='id-UE-TS0-CapabilityLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_TS0_CapabilityLCR._val = 1156
    
    #-----< id-Common-System-Information-ResponseLCR >-----#
    id_Common_System_Information_ResponseLCR = INT(name='id-Common-System-Information-ResponseLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_System_Information_ResponseLCR._val = 1157
    
    #-----< id-Additional-EDCH-Cell-Information-ResponseRLReconf >-----#
    id_Additional_EDCH_Cell_Information_ResponseRLReconf = INT(name='id-Additional-EDCH-Cell-Information-ResponseRLReconf', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_ResponseRLReconf._val = 1158
    
    #-----< id-Multicell-EDCH-InformationItemIEs >-----#
    id_Multicell_EDCH_InformationItemIEs = INT(name='id-Multicell-EDCH-InformationItemIEs', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multicell_EDCH_InformationItemIEs._val = 1159
    
    #-----< id-Multicell-EDCH-RL-Specific-InformationItemIEs >-----#
    id_Multicell_EDCH_RL_Specific_InformationItemIEs = INT(name='id-Multicell-EDCH-RL-Specific-InformationItemIEs', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multicell_EDCH_RL_Specific_InformationItemIEs._val = 1160
    
    #-----< id-Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext >-----#
    id_Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext = INT(name='id-Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext._val = 1161
    
    #-----< id-Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext >-----#
    id_Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext = INT(name='id-Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext._val = 1162
    
    #-----< id-Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext >-----#
    id_Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext = INT(name='id-Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext._val = 1163
    
    #-----< id-Initial-DL-Transmission-Power >-----#
    id_Initial_DL_Transmission_Power = INT(name='id-Initial-DL-Transmission-Power', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Initial_DL_Transmission_Power._val = 1164
    
    #-----< id-Maximum-DL-Power >-----#
    id_Maximum_DL_Power = INT(name='id-Maximum-DL-Power', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Maximum_DL_Power._val = 1165
    
    #-----< id-Minimum-DL-Power >-----#
    id_Minimum_DL_Power = INT(name='id-Minimum-DL-Power', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Minimum_DL_Power._val = 1166
    
    #-----< id-DCH-MeasurementOccasion-Information >-----#
    id_DCH_MeasurementOccasion_Information = INT(name='id-DCH-MeasurementOccasion-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_MeasurementOccasion_Information._val = 1167
    
    #-----< id-AssociatedPhsicalChannelID >-----#
    id_AssociatedPhsicalChannelID = INT(name='id-AssociatedPhsicalChannelID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AssociatedPhsicalChannelID._val = 1168
    
    #-----< id-DGNSS-ValidityPeriod >-----#
    id_DGNSS_ValidityPeriod = INT(name='id-DGNSS-ValidityPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DGNSS_ValidityPeriod._val = 1169
    
    #-----< id-PhysicalChannelID-for-CommonERNTI-RequestedIndicator >-----#
    id_PhysicalChannelID_for_CommonERNTI_RequestedIndicator = INT(name='id-PhysicalChannelID-for-CommonERNTI-RequestedIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PhysicalChannelID_for_CommonERNTI_RequestedIndicator._val = 1170
    
    #-----< id-PrecodingWeightSetRestriction >-----#
    id_PrecodingWeightSetRestriction = INT(name='id-PrecodingWeightSetRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrecodingWeightSetRestriction._val = 1171
    
    #-----< id-Treset-Usage-Indicator >-----#
    id_Treset_Usage_Indicator = INT(name='id-Treset-Usage-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Treset_Usage_Indicator._val = 1172
    
    #-----< id-Non-Serving-RL-Preconfig-Info >-----#
    id_Non_Serving_RL_Preconfig_Info = INT(name='id-Non-Serving-RL-Preconfig-Info', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Non_Serving_RL_Preconfig_Info._val = 1173
    
    #-----< id-Non-Serving-RL-Preconfig-Setup >-----#
    id_Non_Serving_RL_Preconfig_Setup = INT(name='id-Non-Serving-RL-Preconfig-Setup', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Non_Serving_RL_Preconfig_Setup._val = 1174
    
    #-----< id-Non-Serving-RL-Preconfig-Removal >-----#
    id_Non_Serving_RL_Preconfig_Removal = INT(name='id-Non-Serving-RL-Preconfig-Removal', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Non_Serving_RL_Preconfig_Removal._val = 1175
    
    #-----< id-Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup >-----#
    id_Additional_E_DCH_Non_Serving_RL_Preconfiguration_Setup = INT(name='id-Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_E_DCH_Non_Serving_RL_Preconfiguration_Setup._val = 1176
    
    #-----< id-Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList >-----#
    id_Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList = INT(name='id-Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList._val = 1177
    
    #-----< id-Ul-common-E-DCH-MACflow-Specific-InfoListLCR-Ext >-----#
    id_Ul_common_E_DCH_MACflow_Specific_InfoListLCR_Ext = INT(name='id-Ul-common-E-DCH-MACflow-Specific-InfoListLCR-Ext', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ul_common_E_DCH_MACflow_Specific_InfoListLCR_Ext._val = 1178
    
    #-----< id-CommonMACFlow-Specific-InfoList-ResponseLCR-Ext >-----#
    id_CommonMACFlow_Specific_InfoList_ResponseLCR_Ext = INT(name='id-CommonMACFlow-Specific-InfoList-ResponseLCR-Ext', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonMACFlow_Specific_InfoList_ResponseLCR_Ext._val = 1179
    
    #-----< id-Enabling-Delay-Ext-LCR >-----#
    id_Enabling_Delay_Ext_LCR = INT(name='id-Enabling-Delay-Ext-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enabling_Delay_Ext_LCR._val = 1180
    
    #-----< id-OrdinalNumberOfFrequency >-----#
    id_OrdinalNumberOfFrequency = INT(name='id-OrdinalNumberOfFrequency', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OrdinalNumberOfFrequency._val = 1181
    
    #-----< id-Multicell-EDCH-Restriction >-----#
    id_Multicell_EDCH_Restriction = INT(name='id-Multicell-EDCH-Restriction', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multicell_EDCH_Restriction._val = 1183
    
    #-----< id-completeAlmanacProvided >-----#
    id_completeAlmanacProvided = INT(name='id-completeAlmanacProvided', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_completeAlmanacProvided._val = 1184
    
    #-----< id-ganss-Delta-T >-----#
    id_ganss_Delta_T = INT(name='id-ganss-Delta-T', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ganss_Delta_T._val = 1185
    
    #-----< id-Cell-Capability-Container-TDD-LCR >-----#
    id_Cell_Capability_Container_TDD_LCR = INT(name='id-Cell-Capability-Container-TDD-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Capability_Container_TDD_LCR._val = 1186
    
    #-----< id-Multi-Carrier-EDCH-Setup >-----#
    id_Multi_Carrier_EDCH_Setup = INT(name='id-Multi-Carrier-EDCH-Setup', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multi_Carrier_EDCH_Setup._val = 1187
    
    #-----< id-Multi-Carrier-EDCH-Reconfigure >-----#
    id_Multi_Carrier_EDCH_Reconfigure = INT(name='id-Multi-Carrier-EDCH-Reconfigure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multi_Carrier_EDCH_Reconfigure._val = 1188
    
    #-----< id-Multi-Carrier-EDCH-Response >-----#
    id_Multi_Carrier_EDCH_Response = INT(name='id-Multi-Carrier-EDCH-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multi_Carrier_EDCH_Response._val = 1189
    
    #-----< id-SNPL-Carrier-Group-Indicator >-----#
    id_SNPL_Carrier_Group_Indicator = INT(name='id-SNPL-Carrier-Group-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SNPL_Carrier_Group_Indicator._val = 1190
    
    #-----< id-MU-MIMO-Capability-ContainerLCR >-----#
    id_MU_MIMO_Capability_ContainerLCR = INT(name='id-MU-MIMO-Capability-ContainerLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MU_MIMO_Capability_ContainerLCR._val = 1191
    
    #-----< id-MU-MIMO-InformationLCR >-----#
    id_MU_MIMO_InformationLCR = INT(name='id-MU-MIMO-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MU_MIMO_InformationLCR._val = 1192
    
    #-----< id-MU-MIMO-Information-Response >-----#
    id_MU_MIMO_Information_Response = INT(name='id-MU-MIMO-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MU_MIMO_Information_Response._val = 1193
    
    #-----< id-MU-MIMO-Information-To-ReconfigureLCR >-----#
    id_MU_MIMO_Information_To_ReconfigureLCR = INT(name='id-MU-MIMO-Information-To-ReconfigureLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MU_MIMO_Information_To_ReconfigureLCR._val = 1194
    
    #-----< id-HS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext >-----#
    id_HS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext = INT(name='id-HS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext._val = 1195
    
    #-----< id-Adaptive-Special-Burst-Power-CapabilityLCR >-----#
    id_Adaptive_Special_Burst_Power_CapabilityLCR = INT(name='id-Adaptive-Special-Burst-Power-CapabilityLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Adaptive_Special_Burst_Power_CapabilityLCR._val = 1196
    
    #-----< id-Usefulness-Of-Battery-Optimization >-----#
    id_Usefulness_Of_Battery_Optimization = INT(name='id-Usefulness-Of-Battery-Optimization', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Usefulness_Of_Battery_Optimization._val = 1197
    
    #-----< id-Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory >-----#
    id_Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory = INT(name='id-Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory._val = 1198
    
    #-----< id-Common-HSDSCH-RNTI-List >-----#
    id_Common_HSDSCH_RNTI_List = INT(name='id-Common-HSDSCH-RNTI-List', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_HSDSCH_RNTI_List._val = 1199
    
    #-----< id-CommonEDCH-AdditionalTransmissionBackOff >-----#
    id_CommonEDCH_AdditionalTransmissionBackOff = INT(name='id-CommonEDCH-AdditionalTransmissionBackOff', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonEDCH_AdditionalTransmissionBackOff._val = 1200
    
    #-----< id-In-Sync-Information-LCR >-----#
    id_In_Sync_Information_LCR = INT(name='id-In-Sync-Information-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_In_Sync_Information_LCR._val = 1201
    
    #-----< id-Puncturing-Handling-in-First-Rate-Matching-Stage >-----#
    id_Puncturing_Handling_in_First_Rate_Matching_Stage = INT(name='id-Puncturing-Handling-in-First-Rate-Matching-Stage', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Puncturing_Handling_in_First_Rate_Matching_Stage._val = 1202
    
    #-----< id-ERNTI-Release-Status >-----#
    id_ERNTI_Release_Status = INT(name='id-ERNTI-Release-Status', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ERNTI_Release_Status._val = 1203
    
    #-----< id-UE-Status-Update-Confirm-Indicator >-----#
    id_UE_Status_Update_Confirm_Indicator = INT(name='id-UE-Status-Update-Confirm-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Status_Update_Confirm_Indicator._val = 1204
    
    #-----< id-Max-RTWP-perCellPortion-InformationList-LCR-PSCH-ReconfRqst >-----#
    id_Max_RTWP_perCellPortion_InformationList_LCR_PSCH_ReconfRqst = INT(name='id-Max-RTWP-perCellPortion-InformationList-LCR-PSCH-ReconfRqst', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Max_RTWP_perCellPortion_InformationList_LCR_PSCH_ReconfRqst._val = 1205
    
    #-----< id-AOA-per-CELL-Portion-LCR >-----#
    id_AOA_per_CELL_Portion_LCR = INT(name='id-AOA-per-CELL-Portion-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AOA_per_CELL_Portion_LCR._val = 1206
    
    #-----< id-UL-CLTD-Information >-----#
    id_UL_CLTD_Information = INT(name='id-UL-CLTD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CLTD_Information._val = 1208
    
    #-----< id-UL-CLTD-Information-Reconf >-----#
    id_UL_CLTD_Information_Reconf = INT(name='id-UL-CLTD-Information-Reconf', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CLTD_Information_Reconf._val = 1209
    
    #-----< id-UL-CLTD-State-Update-Information >-----#
    id_UL_CLTD_State_Update_Information = INT(name='id-UL-CLTD-State-Update-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CLTD_State_Update_Information._val = 1211
    
    #-----< id-Affected-HSDSCH-Serving-Cell-List >-----#
    id_Affected_HSDSCH_Serving_Cell_List = INT(name='id-Affected-HSDSCH-Serving-Cell-List', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Affected_HSDSCH_Serving_Cell_List._val = 1212
    
    #-----< id-Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order >-----#
    id_Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order = INT(name='id-Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order._val = 1213
    
    #-----< id-CPC-RecoveryReport >-----#
    id_CPC_RecoveryReport = INT(name='id-CPC-RecoveryReport', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPC_RecoveryReport._val = 1214
    
    #-----< id-FTPICH-Information >-----#
    id_FTPICH_Information = INT(name='id-FTPICH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FTPICH_Information._val = 1215
    
    #-----< id-FTPICH-Information-Reconf >-----#
    id_FTPICH_Information_Reconf = INT(name='id-FTPICH-Information-Reconf', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FTPICH_Information_Reconf._val = 1216
    
    #-----< id-UE-RF-Band-CapabilityLCR >-----#
    id_UE_RF_Band_CapabilityLCR = INT(name='id-UE-RF-Band-CapabilityLCR', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_RF_Band_CapabilityLCR._val = 1217
    
    #-----< id-E-AGCH-PowerOffset >-----#
    id_E_AGCH_PowerOffset = INT(name='id-E-AGCH-PowerOffset', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_AGCH_PowerOffset._val = 1218
    
    #-----< id-E-RGCH-PowerOffset >-----#
    id_E_RGCH_PowerOffset = INT(name='id-E-RGCH-PowerOffset', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RGCH_PowerOffset._val = 1219
    
    #-----< id-E-HICH-PowerOffset >-----#
    id_E_HICH_PowerOffset = INT(name='id-E-HICH-PowerOffset', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_HICH_PowerOffset._val = 1220
    
    #-----< id-UE-transmission-power-headroom >-----#
    id_UE_transmission_power_headroom = INT(name='id-UE-transmission-power-headroom', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_transmission_power_headroom._val = 1225
    
    #-----< id-MIMO-withfourtransmitantennas-ActivationIndicator >-----#
    id_MIMO_withfourtransmitantennas_ActivationIndicator = INT(name='id-MIMO-withfourtransmitantennas-ActivationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_withfourtransmitantennas_ActivationIndicator._val = 1226
    
    #-----< id-MIMO-withfourtransmitantennas-Mode-Indicator >-----#
    id_MIMO_withfourtransmitantennas_Mode_Indicator = INT(name='id-MIMO-withfourtransmitantennas-Mode-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_withfourtransmitantennas_Mode_Indicator._val = 1227
    
    #-----< id-MIMO-withfourtransmitantennas-PilotConfiguration >-----#
    id_MIMO_withfourtransmitantennas_PilotConfiguration = INT(name='id-MIMO-withfourtransmitantennas-PilotConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_withfourtransmitantennas_PilotConfiguration._val = 1228
    
    #-----< id-DualStream-MIMO-withfourtransmitantennas-ActivationIndicator >-----#
    id_DualStream_MIMO_withfourtransmitantennas_ActivationIndicator = INT(name='id-DualStream-MIMO-withfourtransmitantennas-ActivationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DualStream_MIMO_withfourtransmitantennas_ActivationIndicator._val = 1229
    
    #-----< id-DualStream-MIMO-withfourtransmitantennas-Mode-Indicator >-----#
    id_DualStream_MIMO_withfourtransmitantennas_Mode_Indicator = INT(name='id-DualStream-MIMO-withfourtransmitantennas-Mode-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DualStream_MIMO_withfourtransmitantennas_Mode_Indicator._val = 1230
    
    #-----< id-UL-MIMO-Information >-----#
    id_UL_MIMO_Information = INT(name='id-UL-MIMO-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_MIMO_Information._val = 1231
    
    #-----< id-UL-MIMO-Reconfiguration >-----#
    id_UL_MIMO_Reconfiguration = INT(name='id-UL-MIMO-Reconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_MIMO_Reconfiguration._val = 1232
    
    #-----< id-UL-MIMO-DL-Control-Channel-Information >-----#
    id_UL_MIMO_DL_Control_Channel_Information = INT(name='id-UL-MIMO-DL-Control-Channel-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_MIMO_DL_Control_Channel_Information._val = 1233
    
    #-----< id-SixtyfourQAM-UL-Operation-Indicator >-----#
    id_SixtyfourQAM_UL_Operation_Indicator = INT(name='id-SixtyfourQAM-UL-Operation-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixtyfourQAM_UL_Operation_Indicator._val = 1234
    
    #-----< id-Common-E-DCH-Implicit-Release-Timer >-----#
    id_Common_E_DCH_Implicit_Release_Timer = INT(name='id-Common-E-DCH-Implicit-Release-Timer', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_E_DCH_Implicit_Release_Timer._val = 1236
    
    #-----< id-Multiflow-Information >-----#
    id_Multiflow_Information = INT(name='id-Multiflow-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multiflow_Information._val = 1237
    
    #-----< id-Multiflow-Reconfiguration >-----#
    id_Multiflow_Reconfiguration = INT(name='id-Multiflow-Reconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multiflow_Reconfiguration._val = 1238
    
    #-----< id-Multiflow-OrdinalNumberOfFrequency >-----#
    id_Multiflow_OrdinalNumberOfFrequency = INT(name='id-Multiflow-OrdinalNumberOfFrequency', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multiflow_OrdinalNumberOfFrequency._val = 1239
    
    #-----< id-Concurrent-Deployment-of-2msand10ms-TTI >-----#
    id_Concurrent_Deployment_of_2msand10ms_TTI = INT(name='id-Concurrent-Deployment-of-2msand10ms-TTI', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Concurrent_Deployment_of_2msand10ms_TTI._val = 1240
    
    #-----< id-Common-EDH-Preamble-Control-Information-extension-Type1 >-----#
    id_Common_EDH_Preamble_Control_Information_extension_Type1 = INT(name='id-Common-EDH-Preamble-Control-Information-extension-Type1', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDH_Preamble_Control_Information_extension_Type1._val = 1241
    
    #-----< id-Common-EDH-Preamble-Control-Information-extension-Type2 >-----#
    id_Common_EDH_Preamble_Control_Information_extension_Type2 = INT(name='id-Common-EDH-Preamble-Control-Information-extension-Type2', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDH_Preamble_Control_Information_extension_Type2._val = 1242
    
    #-----< id-Common-EDH-Preamble-Control-Information-extension-Type3 >-----#
    id_Common_EDH_Preamble_Control_Information_extension_Type3 = INT(name='id-Common-EDH-Preamble-Control-Information-extension-Type3', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDH_Preamble_Control_Information_extension_Type3._val = 1243
    
    #-----< id-NodeB-Triggered-HSDPCCH-Transmission-Information >-----#
    id_NodeB_Triggered_HSDPCCH_Transmission_Information = INT(name='id-NodeB-Triggered-HSDPCCH-Transmission-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NodeB_Triggered_HSDPCCH_Transmission_Information._val = 1244
    
    #-----< id-Per-HARQ-Activiation-and-Deactiviation >-----#
    id_Per_HARQ_Activiation_and_Deactiviation = INT(name='id-Per-HARQ-Activiation-and-Deactiviation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Per_HARQ_Activiation_and_Deactiviation._val = 1245
    
    #-----< id-Coffset >-----#
    id_Coffset = INT(name='id-Coffset', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Coffset._val = 1246
    
    #-----< id-Common-E-DCH-MAC-d-flow-info-Concurrent-TTI >-----#
    id_Common_E_DCH_MAC_d_flow_info_Concurrent_TTI = INT(name='id-Common-E-DCH-MAC-d-flow-info-Concurrent-TTI', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_E_DCH_MAC_d_flow_info_Concurrent_TTI._val = 1247
    
    #-----< id-Serving-Grant-Value-for-Concurrent-Deployment-of-2msand10ms-TTI >-----#
    id_Serving_Grant_Value_for_Concurrent_Deployment_of_2msand10ms_TTI = INT(name='id-Serving-Grant-Value-for-Concurrent-Deployment-of-2msand10ms-TTI', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Serving_Grant_Value_for_Concurrent_Deployment_of_2msand10ms_TTI._val = 1248
    
    #-----< id-Two-ms-Grant-E-DCH-RACH-Resources >-----#
    id_Two_ms_Grant_E_DCH_RACH_Resources = INT(name='id-Two-ms-Grant-E-DCH-RACH-Resources', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Two_ms_Grant_E_DCH_RACH_Resources._val = 1249
    
    #-----< id-Two-ms-Overridden-E-DCH-RACH-Resources >-----#
    id_Two_ms_Overridden_E_DCH_RACH_Resources = INT(name='id-Two-ms-Overridden-E-DCH-RACH-Resources', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Two_ms_Overridden_E_DCH_RACH_Resources._val = 1250
    
    #-----< id-Two-ms-Denied-E-DCH-RACH-Resources >-----#
    id_Two_ms_Denied_E_DCH_RACH_Resources = INT(name='id-Two-ms-Denied-E-DCH-RACH-Resources', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Two_ms_Denied_E_DCH_RACH_Resources._val = 1251
    
    #-----< id-Further-Enhanced-UE-DRX-InformationFDD >-----#
    id_Further_Enhanced_UE_DRX_InformationFDD = INT(name='id-Further-Enhanced-UE-DRX-InformationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Further_Enhanced_UE_DRX_InformationFDD._val = 1252
    
    #-----< id-Common-E-RGCH-Operation-Indicator >-----#
    id_Common_E_RGCH_Operation_Indicator = INT(name='id-Common-E-RGCH-Operation-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_E_RGCH_Operation_Indicator._val = 1253
    
    #-----< id-Common-E-RGCH-InfoFDD >-----#
    id_Common_E_RGCH_InfoFDD = INT(name='id-Common-E-RGCH-InfoFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_E_RGCH_InfoFDD._val = 1254
    
    #-----< id-PrecoderWeightSetRestriction >-----#
    id_PrecoderWeightSetRestriction = INT(name='id-PrecoderWeightSetRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrecoderWeightSetRestriction._val = 1255
    
    #-----< id-Non-rectangular-resource-allocation-indicator >-----#
    id_Non_rectangular_resource_allocation_indicator = INT(name='id-Non-rectangular-resource-allocation-indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Non_rectangular_resource_allocation_indicator._val = 1256
    
    #-----< id-Non-rectangular-resource-timeslot-set >-----#
    id_Non_rectangular_resource_timeslot_set = INT(name='id-Non-rectangular-resource-timeslot-set', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Non_rectangular_resource_timeslot_set._val = 1257
    
    #-----< id-UE-Support-of-non-rectangular-resource-allocation >-----#
    id_UE_Support_of_non_rectangular_resource_allocation = INT(name='id-UE-Support-of-non-rectangular-resource-allocation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Support_of_non_rectangular_resource_allocation._val = 1258
    
    #-----< id-DBDS-CorrectionsReq >-----#
    id_DBDS_CorrectionsReq = INT(name='id-DBDS-CorrectionsReq', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DBDS_CorrectionsReq._val = 1267
    
    #-----< id-DBDS-Corrections >-----#
    id_DBDS_Corrections = INT(name='id-DBDS-Corrections', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DBDS_Corrections._val = 1268
    
    #-----< id-BDS-IonosphericGridModelReq >-----#
    id_BDS_IonosphericGridModelReq = INT(name='id-BDS-IonosphericGridModelReq', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BDS_IonosphericGridModelReq._val = 1269
    
    #-----< id-BDS-Ionospheric-Grid-Model >-----#
    id_BDS_Ionospheric_Grid_Model = INT(name='id-BDS-Ionospheric-Grid-Model', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BDS_Ionospheric_Grid_Model._val = 1270
    
    #-----< id-GANSS-alm-keplerianBDSAlmanac >-----#
    id_GANSS_alm_keplerianBDSAlmanac = INT(name='id-GANSS-alm-keplerianBDSAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianBDSAlmanac._val = 1271
    
    #-----< id-Assisting-RepetitionFactors >-----#
    id_Assisting_RepetitionFactors = INT(name='id-Assisting-RepetitionFactors', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Assisting_RepetitionFactors._val = 1276
    
    #-----< id-UE-Measurement-Forwarding >-----#
    id_UE_Measurement_Forwarding = INT(name='id-UE-Measurement-Forwarding', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Measurement_Forwarding._val = 1277
    
    #-----< id-UPH-Filtering-Measurement-Forwarding-Request >-----#
    id_UPH_Filtering_Measurement_Forwarding_Request = INT(name='id-UPH-Filtering-Measurement-Forwarding-Request', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UPH_Filtering_Measurement_Forwarding_Request._val = 1278
    
    #-----< id-TTI-Update-Indicator >-----#
    id_TTI_Update_Indicator = INT(name='id-TTI-Update-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TTI_Update_Indicator._val = 1279
    
    #-----< id-CQI-Feedback-Cycle2 >-----#
    id_CQI_Feedback_Cycle2 = INT(name='id-CQI-Feedback-Cycle2', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CQI_Feedback_Cycle2._val = 1280
    
    #-----< id-CQI-Cycle-Switch-Timer >-----#
    id_CQI_Cycle_Switch_Timer = INT(name='id-CQI-Cycle-Switch-Timer', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CQI_Cycle_Switch_Timer._val = 1281
    
    #-----< id-UE-DRX-Cycle2 >-----#
    id_UE_DRX_Cycle2 = INT(name='id-UE-DRX-Cycle2', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_DRX_Cycle2._val = 1282
    
    #-----< id-Inactivity-Threshold-for-UE-DRX-Cycle2 >-----#
    id_Inactivity_Threshold_for_UE_DRX_Cycle2 = INT(name='id-Inactivity-Threshold-for-UE-DRX-Cycle2', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Inactivity_Threshold_for_UE_DRX_Cycle2._val = 1283
    
    #-----< id-DTX-Information2 >-----#
    id_DTX_Information2 = INT(name='id-DTX-Information2', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DTX_Information2._val = 1284
    
    #-----< id-BCH-Parameters >-----#
    id_BCH_Parameters = INT(name='id-BCH-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCH_Parameters._val = 1286
    
    #-----< id-BCH-Parameters-CTCH-SetupRsp >-----#
    id_BCH_Parameters_CTCH_SetupRsp = INT(name='id-BCH-Parameters-CTCH-SetupRsp', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCH_Parameters_CTCH_SetupRsp._val = 1287
    
    #-----< id-BCH-Parameters-CTCH-ReconfRqstFDD >-----#
    id_BCH_Parameters_CTCH_ReconfRqstFDD = INT(name='id-BCH-Parameters-CTCH-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCH_Parameters_CTCH_ReconfRqstFDD._val = 1288
    
    #-----< id-BCH-mappedOnSCCPCH-Indication >-----#
    id_BCH_mappedOnSCCPCH_Indication = INT(name='id-BCH-mappedOnSCCPCH-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BCH_mappedOnSCCPCH_Indication._val = 1291
    
    #-----< id-DCH-ENH-Information >-----#
    id_DCH_ENH_Information = INT(name='id-DCH-ENH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_ENH_Information._val = 1292
    
    #-----< id-DCH-ENH-Information-Reconf >-----#
    id_DCH_ENH_Information_Reconf = INT(name='id-DCH-ENH-Information-Reconf', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_ENH_Information_Reconf._val = 1293
    
    #-----< id-Gainfactors-10ms-mode >-----#
    id_Gainfactors_10ms_mode = INT(name='id-Gainfactors-10ms-mode', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Gainfactors_10ms_mode._val = 1294
    
    #-----< id-E-DCH-Decoupling-Indication >-----#
    id_E_DCH_Decoupling_Indication = INT(name='id-E-DCH-Decoupling-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Decoupling_Indication._val = 1295
    
    #-----< id-Radio-Links-without-DPCH-FDPCH-Indication >-----#
    id_Radio_Links_without_DPCH_FDPCH_Indication = INT(name='id-Radio-Links-without-DPCH-FDPCH-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Radio_Links_without_DPCH_FDPCH_Indication._val = 1296
    
    #-----< id-UL-DPCCH2-Information >-----#
    id_UL_DPCCH2_Information = INT(name='id-UL-DPCCH2-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCCH2_Information._val = 1297
    
    #-----< id-UL-DPCCH2-Information-Reconf >-----#
    id_UL_DPCCH2_Information_Reconf = INT(name='id-UL-DPCCH2-Information-Reconf', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCCH2_Information_Reconf._val = 1298
    
    #-----< id-ImplicitGrantHandling >-----#
    id_ImplicitGrantHandling = INT(name='id-ImplicitGrantHandling', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ImplicitGrantHandling._val = 1299
    
    #-----< id-MinimumTEBSthreshold >-----#
    id_MinimumTEBSthreshold = INT(name='id-MinimumTEBSthreshold', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MinimumTEBSthreshold._val = 1300
    
    #-----< id-ActivationDelay >-----#
    id_ActivationDelay = INT(name='id-ActivationDelay', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivationDelay._val = 1301
    
    #-----< id-Fast-TTI-switching-Mode-synchronized >-----#
    id_Fast_TTI_switching_Mode_synchronized = INT(name='id-Fast-TTI-switching-Mode-synchronized', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Fast_TTI_switching_Mode_synchronized._val = 1302
    
    #-----< id-Fast-TTI-switching-Mode-unsynchronized >-----#
    id_Fast_TTI_switching_Mode_unsynchronized = INT(name='id-Fast-TTI-switching-Mode-unsynchronized', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Fast_TTI_switching_Mode_unsynchronized._val = 1303
    
    #-----< id-Fast-TTI-switching-Mode-Supported >-----#
    id_Fast_TTI_switching_Mode_Supported = INT(name='id-Fast-TTI-switching-Mode-Supported', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Fast_TTI_switching_Mode_Supported._val = 1304
    
    #-----< id-Dual-Band-EDCH-Capability >-----#
    id_Dual_Band_EDCH_Capability = INT(name='id-Dual-Band-EDCH-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Dual_Band_EDCH_Capability._val = 1305
    
    #-----< id-Improved-Synchronized-Indicator >-----#
    id_Improved_Synchronized_Indicator = INT(name='id-Improved-Synchronized-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Improved_Synchronized_Indicator._val = 1306
    
    #-----< id-Downlink-TPC-enhancements-Information >-----#
    id_Downlink_TPC_enhancements_Information = INT(name='id-Downlink-TPC-enhancements-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Downlink_TPC_enhancements_Information._val = 1307
    
    #-----< id-Downlink-TPC-enhancements-Reconf >-----#
    id_Downlink_TPC_enhancements_Reconf = INT(name='id-Downlink-TPC-enhancements-Reconf', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Downlink_TPC_enhancements_Reconf._val = 1308
    
    #-----< id-TPC-slot-position >-----#
    id_TPC_slot_position = INT(name='id-TPC-slot-position', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TPC_slot_position._val = 1309
    
    #-----< id-E-RNTI-Set >-----#
    id_E_RNTI_Set = INT(name='id-E-RNTI-Set', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RNTI_Set._val = 1310
    
    #-----< id-DL-TBS >-----#
    id_DL_TBS = INT(name='id-DL-TBS', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_TBS._val = 1311
    
    #-----< id-Dual-Cell-EDCH-Enhancements-Information >-----#
    id_Dual_Cell_EDCH_Enhancements_Information = INT(name='id-Dual-Cell-EDCH-Enhancements-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Dual_Cell_EDCH_Enhancements_Information._val = 1313
    
    #-----< id-HS-SCCH-DRX-InformationFDD >-----#
    id_HS_SCCH_DRX_InformationFDD = INT(name='id-HS-SCCH-DRX-InformationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_SCCH_DRX_InformationFDD._val = 1312
    
    _all_ = [
        id_audit,
        id_auditRequired,
        id_blockResource,
        id_cellDeletion,
        id_cellReconfiguration,
        id_cellSetup,
        id_cellSynchronisationInitiation,
        id_cellSynchronisationReconfiguration,
        id_cellSynchronisationReporting,
        id_cellSynchronisationTermination,
        id_cellSynchronisationFailure,
        id_commonMeasurementFailure,
        id_commonMeasurementInitiation,
        id_commonMeasurementReport,
        id_commonMeasurementTermination,
        id_commonTransportChannelDelete,
        id_commonTransportChannelReconfigure,
        id_commonTransportChannelSetup,
        id_compressedModeCommand,
        id_dedicatedMeasurementFailure,
        id_dedicatedMeasurementInitiation,
        id_dedicatedMeasurementReport,
        id_dedicatedMeasurementTermination,
        id_downlinkPowerControl,
        id_downlinkPowerTimeslotControl,
        id_errorIndicationForCommon,
        id_errorIndicationForDedicated,
        id_informationExchangeFailure,
        id_informationExchangeInitiation,
        id_informationExchangeTermination,
        id_informationReporting,
        id_BearerRearrangement,
        id_mBMSNotificationUpdate,
        id_physicalSharedChannelReconfiguration,
        id_privateMessageForCommon,
        id_privateMessageForDedicated,
        id_radioLinkAddition,
        id_radioLinkDeletion,
        id_radioLinkFailure,
        id_radioLinkPreemption,
        id_radioLinkRestoration,
        id_radioLinkSetup,
        id_reset,
        id_resourceStatusIndication,
        id_cellSynchronisationAdjustment,
        id_synchronisedRadioLinkReconfigurationCancellation,
        id_synchronisedRadioLinkReconfigurationCommit,
        id_synchronisedRadioLinkReconfigurationPreparation,
        id_systemInformationUpdate,
        id_unblockResource,
        id_unSynchronisedRadioLinkReconfiguration,
        id_radioLinkActivation,
        id_radioLinkParameterUpdate,
        id_uEStatusUpdate,
        id_secondaryULFrequencyReporting,
        id_secondaryULFrequencyUpdate,
        id_uEStatusUpdateConfirmation,
        maxNrOfCodes,
        maxNrOfDLTSs,
        maxNrOfDLTSLCRs,
        maxNrOfErrors,
        maxNrOfTFs,
        maxNrOfTFCs,
        maxNrOfRLs,
        maxNrOfRLs_1,
        maxNrOfRLs_2,
        maxNrOfRLSets,
        maxNrOfDPCHs,
        maxNrOfDPCHsPerRL_1,
        maxNrOfDPCHLCRs,
        maxNrOfDPCHsLCRPerRL_1,
        maxNrOfDPCHs768,
        maxNrOfDPCHs768PerRL_1,
        maxNrOfSCCPCHs,
        maxNrOfSCCPCHsinExt,
        maxNrOfSCCPCHs768,
        maxNrOfDCHs,
        maxNrOfDSCHs,
        maxNrOfFACHs,
        maxNrOfCCTrCHs,
        maxNrOfPDSCHs,
        maxNrOfHSPDSCHs,
        maxNrOfHSPDSCHs768,
        maxNrOfPUSCHs,
        maxNrOfPUSCHs_1,
        maxNrOfPDSCHSets,
        maxNrOfPRACHLCRs,
        maxNrOfPUSCHSets,
        maxNrOfSCCPCHLCRs,
        maxNrOfSCCPCHsLCRinExt,
        maxNrOfULTSs,
        maxNrOfULTSLCRs,
        maxNrOfUSCHs,
        maxNrOfSlotFormatsPRACH,
        maxCellinNodeB,
        maxCCPinNodeB,
        maxCTFC,
        maxLocalCellinNodeB,
        maxFPACHCell,
        maxRACHCell,
        maxPLCCHCell,
        maxPRACHCell,
        maxSCCPCHCell,
        maxSCCPCHCellinExt,
        maxSCCPCHCellinExtLCR,
        maxSCCPCHCell768,
        maxSCPICHCell,
        maxTTI_count,
        maxIBSEG,
        maxIB,
        maxFACHCell,
        maxRateMatching,
        maxHS_PDSCHCodeNrComp_1,
        maxHS_SCCHCodeNrComp_1,
        maxNrOfCellSyncBursts,
        maxNrOfReceptsPerSyncFrame,
        maxNrOfMeasNCell,
        maxNrOfMeasNCell_1,
        maxNrOfSF,
        maxTGPS,
        maxCommunicationContext,
        maxNrOfLevels,
        maxNoSat,
        maxNoGPSItems,
        maxNrOfHSSCCHs,
        maxNrOfHSSICHs,
        maxNrOfHSSICHs_1,
        maxNrOfSyncFramesLCR,
        maxNrOfReceptionsperSyncFrameLCR,
        maxNrOfSyncDLCodesLCR,
        maxNrOfHSSCCHCodes,
        maxNrOfMACdFlows,
        maxNrOfMACdFlows_1,
        maxNrOfMACdPDUIndexes,
        maxNrOfMACdPDUIndexes_1,
        maxNrOfMACdPDUSize,
        maxNrOfNIs,
        maxNrOfPriorityQueues,
        maxNrOfPriorityQueues_1,
        maxNrOfHARQProcesses,
        maxNrOfContextsOnUeList,
        maxNrOfCellPortionsPerCell,
        maxNrOfCellPortionsPerCell_1,
        maxNrOfPriorityClasses,
        maxNrOfSatAlmanac_maxNoSat,
        maxNrOfE_AGCHs,
        maxNrOfEDCHMACdFlows,
        maxNrOfEDCHMACdFlows_1,
        maxNrOfE_RGCHs_E_HICHs,
        maxNrOfEDCH_HARQ_PO_QUANTSTEPs,
        maxNrOfEDCHHARQProcesses2msEDCH,
        maxNrOfEDPCCH_PO_QUANTSTEPs,
        maxNrOfBits_MACe_PDU_non_scheduled,
        maxNrOfRefETFCIs,
        maxNrOfRefETFCI_PO_QUANTSTEPs,
        maxNrofSigSeqRGHI_1,
        maxNoOfLogicalChannels,
        maxNrOfCombEDPDCH,
        maxE_RUCCHCell,
        maxNrOfEAGCHCodes,
        maxNrOfRefBetas,
        maxNrOfE_PUCHSlots,
        maxNrOfEAGCHs,
        maxNrOfHS_DSCH_TBSs_HS_SCCHless,
        maxNrOfHS_DSCH_TBSs,
        maxNrOfEHICHCodes,
        maxNrOfE_PUCHSlotsLCR,
        maxNrOfEPUCHcodes,
        maxNrOfEHICHs,
        maxNrOfCommonMACFlows,
        maxNrOfCommonMACFlows_1,
        maxNrOfPagingMACFlow,
        maxNrOfPagingMACFlow_1,
        maxNrOfcommonMACQueues,
        maxNrOfpagingMACQueues,
        maxNrOfHS_DSCHTBSsE_PCH,
        maxGANSSSat,
        maxNoGANSS,
        maxSgnType,
        maxFrequencyinCell,
        maxFrequencyinCell_1,
        maxHSDPAFrequency,
        maxHSDPAFrequency_1,
        maxNrOfHSSCCHsinExt,
        maxGANSSSatAlmanac,
        maxGANSSClockMod,
        maxNrOfEDCHRLs,
        maxERNTItoRelease,
        maxNrOfCommonEDCH,
        maxNrOfCommonHRNTI,
        maxNrOfCommonMACFlowsLCR,
        maxNrOfCommonMACFlowsLCR_1,
        maxNrOfHSSCCHsLCR,
        maxNrOfEDCHMACdFlowsLCR,
        maxNrOfEDCHMACdFlowsLCR_1,
        maxNrOfEAGCHsLCR,
        maxNrOfEHICHsLCR,
        maxnrofERUCCHsLCR,
        maxNrOfHSDSCH_1,
        maxNrOfHSDSCH,
        maxGANSS_1,
        maxNoOfTBSs_Mapping_HS_DSCH_SPS,
        maxNoOfTBSs_Mapping_HS_DSCH_SPS_1,
        maxNoOfHS_DSCH_TBSsLCR,
        maxNoOfRepetition_Period_LCR,
        maxNoOfRepetitionPeriod_SPS_LCR_1,
        maxNoOf_HS_SICH_SPS,
        maxNoOf_HS_SICH_SPS_1,
        maxNoOfNon_HS_SCCH_Assosiated_HS_SICH,
        maxNoOfNon_HS_SCCH_Assosiated_HS_SICH_Ext,
        maxMBMSServiceSelect,
        maxNrOfCellPortionsPerCellLCR,
        maxNrOfCellPortionsPerCellLCR_1,
        maxNrOfEDCH_1,
        maxNoOfCommonH_RNTI,
        maxNrOfCommonMACFlowsLCRExt,
        maxofERNTI,
        maxNrOfDCHMeasurementOccasionPatternSequence,
        maxNrOfULCarriersLCR_1,
        maxFreqBandsTDD,
        maxnoofPRACHEUL,
        maxIGPInfo,
        maxNrofConcatenatedDCH,
        id_AICH_Information,
        id_AICH_InformationItem_ResourceStatusInd,
        id_BCH_Information,
        id_BCH_InformationItem_ResourceStatusInd,
        id_BCCH_ModificationTime,
        id_BlockingPriorityIndicator,
        id_Cause,
        id_CCP_InformationItem_AuditRsp,
        id_CCP_InformationList_AuditRsp,
        id_CCP_InformationItem_ResourceStatusInd,
        id_Cell_InformationItem_AuditRsp,
        id_Cell_InformationItem_ResourceStatusInd,
        id_Cell_InformationList_AuditRsp,
        id_CellParameterID,
        id_CFN,
        id_C_ID,
        id_CommonMeasurementAccuracy,
        id_CommonMeasurementObjectType_CM_Rprt,
        id_CommonMeasurementObjectType_CM_Rqst,
        id_CommonMeasurementObjectType_CM_Rsp,
        id_CommonMeasurementType,
        id_CommonPhysicalChannelID,
        id_CommonPhysicalChannelType_CTCH_SetupRqstFDD,
        id_CommonPhysicalChannelType_CTCH_SetupRqstTDD,
        id_CommunicationControlPortID,
        id_ConfigurationGenerationID,
        id_CRNC_CommunicationContextID,
        id_CriticalityDiagnostics,
        id_DCHs_to_Add_FDD,
        id_DCH_AddList_RL_ReconfPrepTDD,
        id_DCHs_to_Add_TDD,
        id_DCH_DeleteList_RL_ReconfPrepFDD,
        id_DCH_DeleteList_RL_ReconfPrepTDD,
        id_DCH_DeleteList_RL_ReconfRqstFDD,
        id_DCH_DeleteList_RL_ReconfRqstTDD,
        id_DCH_FDD_Information,
        id_DCH_TDD_Information,
        id_DCH_InformationResponse,
        id_FDD_DCHs_to_Modify,
        id_TDD_DCHs_to_Modify,
        id_DCH_ModifyList_RL_ReconfRqstTDD,
        id_DCH_RearrangeList_Bearer_RearrangeInd,
        id_DedicatedMeasurementObjectType_DM_Rprt,
        id_DedicatedMeasurementObjectType_DM_Rqst,
        id_DedicatedMeasurementObjectType_DM_Rsp,
        id_DedicatedMeasurementType,
        id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD,
        id_DL_CCTrCH_InformationList_RL_AdditionRqstTDD,
        id_DL_CCTrCH_InformationList_RL_SetupRqstTDD,
        id_DL_DPCH_InformationItem_RL_AdditionRqstTDD,
        id_DL_DPCH_InformationList_RL_SetupRqstTDD,
        id_DL_DPCH_Information_RL_ReconfPrepFDD,
        id_DL_DPCH_Information_RL_ReconfRqstFDD,
        id_DL_DPCH_Information_RL_SetupRqstFDD,
        id_DL_DPCH_TimingAdjustment,
        id_DL_ReferencePowerInformationItem_DL_PC_Rqst,
        id_DLReferencePower,
        id_DLReferencePowerList_DL_PC_Rqst,
        id_Unused_ProtocolIE_ID_87,
        id_Unused_ProtocolIE_ID_89,
        id_Unused_ProtocolIE_ID_91,
        id_Unused_ProtocolIE_ID_93,
        id_DSCHs_to_Add_TDD,
        id_DSCH_Information_DeleteList_RL_ReconfPrepTDD,
        id_DSCH_Information_ModifyList_RL_ReconfPrepTDD,
        id_DSCH_InformationResponse,
        id_Unused_ProtocolIE_ID_106,
        id_DSCH_TDD_Information,
        id_Unused_ProtocolIE_ID_108,
        id_Unused_ProtocolIE_ID_112,
        id_DSCH_RearrangeList_Bearer_RearrangeInd,
        id_End_Of_Audit_Sequence_Indicator,
        id_FACH_Information,
        id_FACH_InformationItem_ResourceStatusInd,
        id_FACH_ParametersList_CTCH_ReconfRqstTDD,
        id_FACH_ParametersListIE_CTCH_SetupRqstFDD,
        id_FACH_ParametersListIE_CTCH_SetupRqstTDD,
        id_IndicationType_ResourceStatusInd,
        id_Local_Cell_ID,
        id_Local_Cell_Group_InformationItem_AuditRsp,
        id_Local_Cell_Group_InformationItem_ResourceStatusInd,
        id_Local_Cell_Group_InformationItem2_ResourceStatusInd,
        id_Local_Cell_Group_InformationList_AuditRsp,
        id_Local_Cell_InformationItem_AuditRsp,
        id_Local_Cell_InformationItem_ResourceStatusInd,
        id_Local_Cell_InformationItem2_ResourceStatusInd,
        id_Local_Cell_InformationList_AuditRsp,
        id_AdjustmentPeriod,
        id_MaxAdjustmentStep,
        id_MaximumTransmissionPower,
        id_MeasurementFilterCoefficient,
        id_MeasurementID,
        id_MessageStructure,
        id_MIB_SB_SIB_InformationList_SystemInfoUpdateRqst,
        id_NodeB_CommunicationContextID,
        id_NeighbouringCellMeasurementInformation,
        id_P_CCPCH_Information,
        id_P_CCPCH_InformationItem_ResourceStatusInd,
        id_P_CPICH_Information,
        id_P_CPICH_InformationItem_ResourceStatusInd,
        id_P_SCH_Information,
        id_PCCPCH_Information_Cell_ReconfRqstTDD,
        id_PCCPCH_Information_Cell_SetupRqstTDD,
        id_PCH_Parameters_CTCH_ReconfRqstTDD,
        id_PCH_ParametersItem_CTCH_SetupRqstFDD,
        id_PCH_ParametersItem_CTCH_SetupRqstTDD,
        id_PCH_Information,
        id_PDSCH_Information_AddListIE_PSCH_ReconfRqst,
        id_PDSCH_Information_ModifyListIE_PSCH_ReconfRqst,
        id_PDSCHSets_AddList_PSCH_ReconfRqst,
        id_PDSCHSets_DeleteList_PSCH_ReconfRqst,
        id_PDSCHSets_ModifyList_PSCH_ReconfRqst,
        id_PICH_Information,
        id_PICH_Parameters_CTCH_ReconfRqstTDD,
        id_PowerAdjustmentType,
        id_PRACH_Information,
        id_PrimaryCCPCH_Information_Cell_ReconfRqstFDD,
        id_PrimaryCCPCH_Information_Cell_SetupRqstFDD,
        id_PrimaryCPICH_Information_Cell_ReconfRqstFDD,
        id_PrimaryCPICH_Information_Cell_SetupRqstFDD,
        id_PrimarySCH_Information_Cell_ReconfRqstFDD,
        id_PrimarySCH_Information_Cell_SetupRqstFDD,
        id_PrimaryScramblingCode,
        id_SCH_Information_Cell_ReconfRqstTDD,
        id_SCH_Information_Cell_SetupRqstTDD,
        id_PUSCH_Information_AddListIE_PSCH_ReconfRqst,
        id_PUSCH_Information_ModifyListIE_PSCH_ReconfRqst,
        id_PUSCHSets_AddList_PSCH_ReconfRqst,
        id_PUSCHSets_DeleteList_PSCH_ReconfRqst,
        id_PUSCHSets_ModifyList_PSCH_ReconfRqst,
        id_RACH_Information,
        id_RACH_ParametersItem_CTCH_SetupRqstFDD,
        id_RACH_ParameterItem_CTCH_SetupRqstTDD,
        id_ReportCharacteristics,
        id_Reporting_Object_RL_FailureInd,
        id_Reporting_Object_RL_RestoreInd,
        id_RL_InformationItem_DM_Rprt,
        id_RL_InformationItem_DM_Rqst,
        id_RL_InformationItem_DM_Rsp,
        id_RL_InformationItem_RL_AdditionRqstFDD,
        id_RL_informationItem_RL_DeletionRqst,
        id_RL_InformationItem_RL_FailureInd,
        id_RL_InformationItem_RL_PreemptRequiredInd,
        id_RL_InformationItem_RL_ReconfPrepFDD,
        id_RL_InformationItem_RL_ReconfRqstFDD,
        id_RL_InformationItem_RL_RestoreInd,
        id_RL_InformationItem_RL_SetupRqstFDD,
        id_RL_InformationList_RL_AdditionRqstFDD,
        id_RL_informationList_RL_DeletionRqst,
        id_RL_InformationList_RL_PreemptRequiredInd,
        id_RL_InformationList_RL_ReconfPrepFDD,
        id_RL_InformationList_RL_ReconfRqstFDD,
        id_RL_InformationList_RL_SetupRqstFDD,
        id_RL_InformationResponseItem_RL_AdditionRspFDD,
        id_RL_InformationResponseItem_RL_ReconfReady,
        id_RL_InformationResponseItem_RL_ReconfRsp,
        id_RL_InformationResponseItem_RL_SetupRspFDD,
        id_RL_InformationResponseList_RL_AdditionRspFDD,
        id_RL_InformationResponseList_RL_ReconfReady,
        id_RL_InformationResponseList_RL_ReconfRsp,
        id_RL_InformationResponseList_RL_SetupRspFDD,
        id_RL_InformationResponse_RL_AdditionRspTDD,
        id_RL_InformationResponse_RL_SetupRspTDD,
        id_RL_Information_RL_AdditionRqstTDD,
        id_RL_Information_RL_ReconfRqstTDD,
        id_RL_Information_RL_ReconfPrepTDD,
        id_RL_Information_RL_SetupRqstTDD,
        id_RL_ReconfigurationFailureItem_RL_ReconfFailure,
        id_RL_Set_InformationItem_DM_Rprt,
        id_RL_Set_InformationItem_DM_Rsp,
        id_RL_Set_InformationItem_RL_FailureInd,
        id_RL_Set_InformationItem_RL_RestoreInd,
        id_S_CCPCH_Information,
        id_S_CPICH_Information,
        id_SCH_Information,
        id_S_SCH_Information,
        id_Secondary_CCPCHListIE_CTCH_ReconfRqstTDD,
        id_Secondary_CCPCH_parameterListIE_CTCH_SetupRqstTDD,
        id_Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD,
        id_SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD,
        id_SecondaryCPICH_InformationItem_Cell_SetupRqstFDD,
        id_SecondaryCPICH_InformationList_Cell_ReconfRqstFDD,
        id_SecondaryCPICH_InformationList_Cell_SetupRqstFDD,
        id_SecondarySCH_Information_Cell_ReconfRqstFDD,
        id_SecondarySCH_Information_Cell_SetupRqstFDD,
        id_SegmentInformationListIE_SystemInfoUpdate,
        id_SFN,
        id_SignallingBearerRequestIndicator,
        id_ShutdownTimer,
        id_Start_Of_Audit_Sequence_Indicator,
        id_Successful_RL_InformationRespItem_RL_AdditionFailureFDD,
        id_Successful_RL_InformationRespItem_RL_SetupFailureFDD,
        id_SyncCase,
        id_SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH,
        id_T_Cell,
        id_TargetCommunicationControlPortID,
        id_TimeSlotConfigurationList_Cell_ReconfRqstTDD,
        id_TimeSlotConfigurationList_Cell_SetupRqstTDD,
        id_TransmissionDiversityApplied,
        id_TypeOfError,
        id_UARFCNforNt,
        id_UARFCNforNd,
        id_UARFCNforNu,
        id_UL_CCTrCH_InformationItem_RL_SetupRqstTDD,
        id_UL_CCTrCH_InformationList_RL_AdditionRqstTDD,
        id_UL_CCTrCH_InformationList_RL_SetupRqstTDD,
        id_UL_DPCH_InformationItem_RL_AdditionRqstTDD,
        id_UL_DPCH_InformationList_RL_SetupRqstTDD,
        id_UL_DPCH_Information_RL_ReconfPrepFDD,
        id_UL_DPCH_Information_RL_ReconfRqstFDD,
        id_UL_DPCH_Information_RL_SetupRqstFDD,
        id_Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD,
        id_Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD,
        id_Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD,
        id_Unsuccessful_RL_InformationResp_RL_SetupFailureTDD,
        id_USCH_Information_Add,
        id_USCH_Information_DeleteList_RL_ReconfPrepTDD,
        id_USCH_Information_ModifyList_RL_ReconfPrepTDD,
        id_USCH_InformationResponse,
        id_USCH_Information,
        id_USCH_RearrangeList_Bearer_RearrangeInd,
        id_Active_Pattern_Sequence_Information,
        id_AICH_ParametersListIE_CTCH_ReconfRqstFDD,
        id_AdjustmentRatio,
        id_Not_Used_320,
        id_Not_Used_322,
        id_FACH_ParametersListIE_CTCH_ReconfRqstFDD,
        id_CauseLevel_PSCH_ReconfFailure,
        id_CauseLevel_RL_AdditionFailureFDD,
        id_CauseLevel_RL_AdditionFailureTDD,
        id_CauseLevel_RL_ReconfFailure,
        id_CauseLevel_RL_SetupFailureFDD,
        id_CauseLevel_RL_SetupFailureTDD,
        id_Not_Used_330,
        id_Not_Used_332,
        id_Closed_Loop_Timing_Adjustment_Mode,
        id_CommonPhysicalChannelType_CTCH_ReconfRqstFDD,
        id_Compressed_Mode_Deactivation_Flag,
        id_Not_Used_336,
        id_Not_Used_342,
        id_Not_Used_343,
        id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD,
        id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD,
        id_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD,
        id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD,
        id_DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD,
        id_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD,
        id_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
        id_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD,
        id_DL_DPCH_InformationModify_AddListIE_RL_ReconfPrepTDD,
        id_DL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD,
        id_DL_DPCH_InformationModify_ModifyListIE_RL_ReconfPrepTDD,
        id_DL_TPC_Pattern01Count,
        id_DPC_Mode,
        id_DPCHConstant,
        id_Unused_ProtocolIE_ID_94,
        id_Unused_ProtocolIE_ID_110,
        id_Unused_ProtocolIE_ID_111,
        id_FACH_ParametersList_CTCH_SetupRsp,
        id_Limited_power_increase_information_Cell_SetupRqstFDD,
        id_PCH_Parameters_CTCH_SetupRsp,
        id_PCH_ParametersItem_CTCH_ReconfRqstFDD,
        id_Not_Used_376,
        id_PICH_ParametersItem_CTCH_ReconfRqstFDD,
        id_PRACHConstant,
        id_PRACH_ParametersListIE_CTCH_ReconfRqstFDD,
        id_PUSCHConstant,
        id_RACH_Parameters_CTCH_SetupRsp,
        id_Unused_ProtocolIE_ID_443,
        id_Synchronisation_Configuration_Cell_ReconfRqst,
        id_Synchronisation_Configuration_Cell_SetupRqst,
        id_Transmission_Gap_Pattern_Sequence_Information,
        id_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD,
        id_UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD,
        id_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD,
        id_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD,
        id_UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD,
        id_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD,
        id_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
        id_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD,
        id_UL_DPCH_InformationModify_AddListIE_RL_ReconfPrepTDD,
        id_UL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD,
        id_UL_DPCH_InformationModify_ModifyListIE_RL_ReconfPrepTDD,
        id_Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD,
        id_Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD,
        id_CommunicationContextInfoItem_Reset,
        id_CommunicationControlPortInfoItem_Reset,
        id_ResetIndicator,
        id_Unused_ProtocolIE_ID_417,
        id_Unused_ProtocolIE_ID_418,
        id_Unused_ProtocolIE_ID_419,
        id_Unused_ProtocolIE_ID_142,
        id_TimingAdvanceApplied,
        id_CFNReportingIndicator,
        id_SFNReportingIndicator,
        id_InnerLoopDLPCStatus,
        id_TimeslotISCPInfo,
        id_PICH_ParametersItem_CTCH_SetupRqstTDD,
        id_PRACH_ParametersItem_CTCH_SetupRqstTDD,
        id_CCTrCH_InformationItem_RL_FailureInd,
        id_CCTrCH_InformationItem_RL_RestoreInd,
        id_CauseLevel_SyncAdjustmntFailureTDD,
        id_CellAdjustmentInfo_SyncAdjustmntRqstTDD,
        id_CellAdjustmentInfoItem_SyncAdjustmentRqstTDD,
        id_CellSyncBurstInfoList_CellSyncReconfRqstTDD,
        id_CellSyncBurstTransInit_CellSyncInitiationRqstTDD,
        id_CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD,
        id_CellSyncBurstTransReconfiguration_CellSyncReconfRqstTDD,
        id_CellSyncBurstMeasReconfiguration_CellSyncReconfRqstTDD,
        id_CellSyncBurstTransInfoList_CellSyncReconfRqstTDD,
        id_CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD,
        id_CellSyncBurstTransReconfInfo_CellSyncReconfRqstTDD,
        id_CellSyncInfo_CellSyncReprtTDD,
        id_CSBTransmissionID,
        id_CSBMeasurementID,
        id_IntStdPhCellSyncInfoItem_CellSyncReprtTDD,
        id_NCyclesPerSFNperiod,
        id_NRepetitionsPerCyclePeriod,
        id_SyncFrameNumber,
        id_SynchronisationReportType,
        id_SynchronisationReportCharacteristics,
        id_Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD,
        id_LateEntranceCellSyncInfoItem_CellSyncReprtTDD,
        id_ReferenceClockAvailability,
        id_ReferenceSFNoffset,
        id_InformationExchangeID,
        id_InformationExchangeObjectType_InfEx_Rqst,
        id_InformationType,
        id_InformationReportCharacteristics,
        id_InformationExchangeObjectType_InfEx_Rsp,
        id_InformationExchangeObjectType_InfEx_Rprt,
        id_IPDLParameter_Information_Cell_ReconfRqstFDD,
        id_IPDLParameter_Information_Cell_SetupRqstFDD,
        id_IPDLParameter_Information_Cell_ReconfRqstTDD,
        id_IPDLParameter_Information_Cell_SetupRqstTDD,
        id_DL_DPCH_LCR_Information_RL_SetupRqstTDD,
        id_DwPCH_LCR_Information,
        id_DwPCH_LCR_InformationList_AuditRsp,
        id_DwPCH_LCR_Information_Cell_SetupRqstTDD,
        id_DwPCH_LCR_Information_Cell_ReconfRqstTDD,
        id_DwPCH_LCR_Information_ResourceStatusInd,
        id_maxFACH_Power_LCR_CTCH_SetupRqstTDD,
        id_maxFACH_Power_LCR_CTCH_ReconfRqstTDD,
        id_FPACH_LCR_Information,
        id_FPACH_LCR_Information_AuditRsp,
        id_FPACH_LCR_InformationList_AuditRsp,
        id_FPACH_LCR_InformationList_ResourceStatusInd,
        id_FPACH_LCR_Parameters_CTCH_SetupRqstTDD,
        id_FPACH_LCR_Parameters_CTCH_ReconfRqstTDD,
        id_PCCPCH_LCR_Information_Cell_SetupRqstTDD,
        id_PCH_Power_LCR_CTCH_SetupRqstTDD,
        id_PCH_Power_LCR_CTCH_ReconfRqstTDD,
        id_PICH_LCR_Parameters_CTCH_SetupRqstTDD,
        id_PRACH_LCR_ParametersList_CTCH_SetupRqstTDD,
        id_RL_InformationResponse_LCR_RL_SetupRspTDD,
        id_Secondary_CCPCH_LCR_parameterList_CTCH_SetupRqstTDD,
        id_TimeSlot,
        id_TimeSlotConfigurationList_LCR_Cell_ReconfRqstTDD,
        id_TimeSlotConfigurationList_LCR_Cell_SetupRqstTDD,
        id_TimeslotISCP_LCR_InfoList_RL_SetupRqstTDD,
        id_TimeSlotLCR_CM_Rqst,
        id_UL_DPCH_LCR_Information_RL_SetupRqstTDD,
        id_DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD,
        id_UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD,
        id_TimeslotISCP_InformationList_LCR_RL_AdditionRqstTDD,
        id_DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD,
        id_DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD,
        id_DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD,
        id_TimeslotISCPInfoList_LCR_DL_PC_RqstTDD,
        id_UL_DPCH_LCR_InformationAddListIE_RL_ReconfPrepTDD,
        id_UL_DPCH_LCR_InformationModify_AddList,
        id_UL_TimeslotLCR_Information_RL_ReconfPrepTDD,
        id_UL_SIRTarget,
        id_PDSCH_AddInformation_LCR_PSCH_ReconfRqst,
        id_PDSCH_AddInformation_LCR_AddListIE_PSCH_ReconfRqst,
        id_Unused_ProtocolIE_ID_26,
        id_Unused_ProtocolIE_ID_27,
        id_PDSCH_ModifyInformation_LCR_PSCH_ReconfRqst,
        id_PDSCH_ModifyInformation_LCR_ModifyListIE_PSCH_ReconfRqst,
        id_PUSCH_AddInformation_LCR_PSCH_ReconfRqst,
        id_PUSCH_AddInformation_LCR_AddListIE_PSCH_ReconfRqst,
        id_PUSCH_ModifyInformation_LCR_PSCH_ReconfRqst,
        id_PUSCH_ModifyInformation_LCR_ModifyListIE_PSCH_ReconfRqst,
        id_timeslotInfo_CellSyncInitiationRqstTDD,
        id_SyncReportType_CellSyncReprtTDD,
        id_Power_Local_Cell_Group_InformationItem_AuditRsp,
        id_Power_Local_Cell_Group_InformationItem_ResourceStatusInd,
        id_Power_Local_Cell_Group_InformationItem2_ResourceStatusInd,
        id_Power_Local_Cell_Group_InformationList_AuditRsp,
        id_Power_Local_Cell_Group_InformationList_ResourceStatusInd,
        id_Power_Local_Cell_Group_InformationList2_ResourceStatusInd,
        id_Power_Local_Cell_Group_ID,
        id_PUSCH_Info_DM_Rqst,
        id_PUSCH_Info_DM_Rsp,
        id_PUSCH_Info_DM_Rprt,
        id_InitDL_Power,
        id_cellSyncBurstRepetitionPeriod,
        id_ReportCharacteristicsType_OnModification,
        id_SFNSFNMeasurementValueInformation,
        id_SFNSFNMeasurementThresholdInformation,
        id_TUTRANGPSMeasurementValueInformation,
        id_TUTRANGPSMeasurementThresholdInformation,
        id_Rx_Timing_Deviation_Value_LCR,
        id_RL_InformationResponse_LCR_RL_AdditionRspTDD,
        id_DL_PowerBalancing_Information,
        id_DL_PowerBalancing_ActivationIndicator,
        id_DL_PowerBalancing_UpdatedIndicator,
        id_CCTrCH_Initial_DL_Power_RL_SetupRqstTDD,
        id_CCTrCH_Initial_DL_Power_RL_AdditionRqstTDD,
        id_CCTrCH_Initial_DL_Power_RL_ReconfPrepTDD,
        id_IPDLParameter_Information_LCR_Cell_SetupRqstTDD,
        id_IPDLParameter_Information_LCR_Cell_ReconfRqstTDD,
        id_HS_PDSCH_HS_SCCH_E_AGCH_E_RGCH_E_HICH_MaxPower_PSCH_ReconfRqst,
        id_HS_PDSCH_HS_SCCH_ScramblingCode_PSCH_ReconfRqst,
        id_HS_PDSCH_FDD_Code_Information_PSCH_ReconfRqst,
        id_HS_SCCH_FDD_Code_Information_PSCH_ReconfRqst,
        id_HS_PDSCH_TDD_Information_PSCH_ReconfRqst,
        id_Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst,
        id_Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst,
        id_Delete_From_HS_SCCH_Resource_Pool_PSCH_ReconfRqst,
        id_bindingID,
        id_RL_Specific_DCH_Info,
        id_transportlayeraddress,
        id_DelayedActivation,
        id_DelayedActivationList_RL_ActivationCmdFDD,
        id_DelayedActivationInformation_RL_ActivationCmdFDD,
        id_DelayedActivationList_RL_ActivationCmdTDD,
        id_DelayedActivationInformation_RL_ActivationCmdTDD,
        id_neighbouringTDDCellMeasurementInformationLCR,
        id_SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD,
        id_SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD,
        id_SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD,
        id_SYNCDlCodeIdMeasReconfigurationLCR_CellSyncReconfRqstTDD,
        id_SYNCDlCodeIdMeasInfoList_CellSyncReconfRqstTDD,
        id_SyncDLCodeIdsMeasInfoList_CellSyncReprtTDD,
        id_SyncDLCodeIdThreInfoLCR,
        id_NSubCyclesPerCyclePeriod_CellSyncReconfRqstTDD,
        id_DwPCH_Power,
        id_AccumulatedClockupdate_CellSyncReprtTDD,
        id_Angle_Of_Arrival_Value_LCR,
        id_HSDSCH_FDD_Information,
        id_HSDSCH_FDD_Information_Response,
        id_HSDSCH_Information_to_Modify,
        id_HSDSCH_RNTI,
        id_HSDSCH_TDD_Information,
        id_HSDSCH_TDD_Information_Response,
        id_HSPDSCH_RL_ID,
        id_PrimCCPCH_RSCP_DL_PC_RqstTDD,
        id_Unused_ProtocolIE_ID_64,
        id_PDSCH_RL_ID,
        id_HSDSCH_RearrangeList_Bearer_RearrangeInd,
        id_UL_Synchronisation_Parameters_LCR,
        id_HSDSCH_FDD_Update_Information,
        id_HSDSCH_TDD_Update_Information,
        id_DL_DPCH_TimeSlotFormat_LCR_ModifyItem_RL_ReconfPrepTDD,
        id_UL_DPCH_TimeSlotFormat_LCR_ModifyItem_RL_ReconfPrepTDD,
        id_TDD_TPC_UplinkStepSize_LCR_RL_SetupRqstTDD,
        id_TDD_TPC_UplinkStepSize_LCR_RL_AdditionRqstTDD,
        id_TDD_TPC_DownlinkStepSize_RL_AdditionRqstTDD,
        id_TDD_TPC_UplinkStepSize_InformationAdd_LCR_RL_ReconfPrepTDD,
        id_TDD_TPC_UplinkStepSize_InformationModify_LCR_RL_ReconfPrepTDD,
        id_TDD_TPC_DownlinkStepSize_InformationModify_RL_ReconfPrepTDD,
        id_TDD_TPC_DownlinkStepSize_InformationAdd_RL_ReconfPrepTDD,
        id_CCTrCH_Maximum_DL_Power_RL_SetupRqstTDD,
        id_CCTrCH_Minimum_DL_Power_RL_SetupRqstTDD,
        id_CCTrCH_Maximum_DL_Power_RL_AdditionRqstTDD,
        id_CCTrCH_Minimum_DL_Power_RL_AdditionRqstTDD,
        id_CCTrCH_Maximum_DL_Power_InformationAdd_RL_ReconfPrepTDD,
        id_CCTrCH_Minimum_DL_Power_InformationAdd_RL_ReconfPrepTDD,
        id_CCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfPrepTDD,
        id_CCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfPrepTDD,
        id_Maximum_DL_Power_Modify_LCR_InformationModify_RL_ReconfPrepTDD,
        id_Minimum_DL_Power_Modify_LCR_InformationModify_RL_ReconfPrepTDD,
        id_DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD,
        id_CCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfRqstTDD,
        id_CCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfRqstTDD,
        id_Initial_DL_Power_TimeslotLCR_InformationItem,
        id_Maximum_DL_Power_TimeslotLCR_InformationItem,
        id_Minimum_DL_Power_TimeslotLCR_InformationItem,
        id_HS_DSCHProvidedBitRateValueInformation,
        id_HS_DSCHRequiredPowerValueInformation,
        id_HS_DSCHRequiredPowerValue,
        id_TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmission,
        id_HS_SICH_Reception_Quality,
        id_HS_SICH_Reception_Quality_Measurement_Value,
        id_HSSICH_Info_DM_Rprt,
        id_HSSICH_Info_DM_Rqst,
        id_HSSICH_Info_DM_Rsp,
        id_Best_Cell_Portions_Value,
        id_Primary_CPICH_Usage_for_Channel_Estimation,
        id_Secondary_CPICH_Information_Change,
        id_NumberOfReportedCellPortions,
        id_CellPortion_InformationItem_Cell_SetupRqstFDD,
        id_CellPortion_InformationList_Cell_SetupRqstFDD,
        id_TimeslotISCP_LCR_InfoList_RL_ReconfPrepTDD,
        id_Secondary_CPICH_Information,
        id_Received_total_wide_band_power_For_CellPortion,
        id_Unidirectional_DCH_Indicator,
        id_TimingAdjustmentValueLCR,
        id_multipleRL_dl_DPCH_InformationList,
        id_multipleRL_dl_DPCH_InformationModifyList,
        id_multipleRL_ul_DPCH_InformationList,
        id_multipleRL_ul_DPCH_InformationModifyList,
        id_RL_ID,
        id_SAT_Info_Almanac_ExtItem,
        id_HSDPA_Capability,
        id_HSDSCH_Resources_Information_AuditRsp,
        id_HSDSCH_Resources_Information_ResourceStatusInd,
        id_HSDSCH_MACdFlows_to_Add,
        id_HSDSCH_MACdFlows_to_Delete,
        id_HSDSCH_Information_to_Modify_Unsynchronised,
        id_TnlQos,
        id_Received_total_wide_band_power_For_CellPortion_Value,
        id_Transmitted_Carrier_Power_For_CellPortion,
        id_Transmitted_Carrier_Power_For_CellPortion_Value,
        id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortion,
        id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue,
        id_UpPTSInterferenceValue,
        id_PrimaryCCPCH_RSCP_Delta,
        id_MeasurementRecoveryBehavior,
        id_MeasurementRecoveryReportingIndicator,
        id_MeasurementRecoverySupportIndicator,
        id_Tstd_indicator,
        id_multiple_RL_Information_RL_ReconfPrepTDD,
        id_multiple_RL_Information_RL_ReconfRqstTDD,
        id_DL_DPCH_Power_Information_RL_ReconfPrepFDD,
        id_F_DPCH_Information_RL_ReconfPrepFDD,
        id_F_DPCH_Information_RL_SetupRqstFDD,
        id_Additional_S_CCPCH_Parameters_CTCH_ReconfRqstTDD,
        id_Additional_S_CCPCH_Parameters_CTCH_SetupRqstTDD,
        id_Additional_S_CCPCH_LCR_Parameters_CTCH_ReconfRqstTDD,
        id_Additional_S_CCPCH_LCR_Parameters_CTCH_SetupRqstTDD,
        id_MICH_CFN,
        id_MICH_Information_AuditRsp,
        id_MICH_Information_ResourceStatusInd,
        id_MICH_Parameters_CTCH_ReconfRqstFDD,
        id_MICH_Parameters_CTCH_ReconfRqstTDD,
        id_MICH_Parameters_CTCH_SetupRqstFDD,
        id_MICH_Parameters_CTCH_SetupRqstTDD,
        id_Modification_Period,
        id_NI_Information_NotifUpdateCmd,
        id_S_CCPCH_InformationListExt_AuditRsp,
        id_S_CCPCH_InformationListExt_ResourceStatusInd,
        id_S_CCPCH_LCR_InformationListExt_AuditRsp,
        id_S_CCPCH_LCR_InformationListExt_ResourceStatusInd,
        id_HARQ_Preamble_Mode,
        id_Initial_DL_DPCH_TimingAdjustment,
        id_Initial_DL_DPCH_TimingAdjustment_Allowed,
        id_DLTransmissionBranchLoadValue,
        id_Power_Local_Cell_Group_choice_CM_Rqst,
        id_Power_Local_Cell_Group_choice_CM_Rsp,
        id_Power_Local_Cell_Group_choice_CM_Rprt,
        id_SynchronisationIndicator,
        id_HSDPA_And_EDCH_CellPortion_Information_PSCH_ReconfRqst,
        id_Unused_ProtocolIE_ID_659,
        id_HS_DSCHRequiredPowerValue_For_Cell_Portion,
        id_HS_DSCHRequiredPowerValueInformation_For_CellPortion,
        id_HS_DSCHProvidedBitRateValueInformation_For_CellPortion,
        id_E_AGCH_And_E_RGCH_E_HICH_FDD_Scrambling_Code,
        id_E_AGCH_FDD_Code_Information,
        id_E_DCH_Capability,
        id_E_DCH_FDD_DL_Control_Channel_Information,
        id_E_DCH_FDD_Information,
        id_E_DCH_FDD_Information_Response,
        id_E_DCH_FDD_Information_to_Modify,
        id_E_DCH_MACdFlows_to_Add,
        id_E_DCH_MACdFlows_to_Delete,
        id_E_DCH_Resources_Information_AuditRsp,
        id_E_DCH_Resources_Information_ResourceStatusInd,
        id_E_DCH_RL_Indication,
        id_E_DCH_RL_Set_ID,
        id_E_DPCH_Information_RL_ReconfPrepFDD,
        id_E_DPCH_Information_RL_SetupRqstFDD,
        id_E_RGCH_E_HICH_FDD_Code_Information,
        id_Serving_E_DCH_RL_ID,
        id_UL_DPDCH_Indicator_For_E_DCH_Operation,
        id_FDD_S_CCPCH_FrameOffset_CTCH_SetupRqstFDD,
        id_E_DPCH_Information_RL_ReconfRqstFDD,
        id_Maximum_Target_ReceivedTotalWideBandPower,
        id_E_DCHProvidedBitRateValueInformation,
        id_HARQ_Preamble_Mode_Activation_Indicator,
        id_RL_Specific_E_DCH_Info,
        id_E_DCH_CapacityConsumptionLaw,
        id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp,
        id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp,
        id_E_DCH_RearrangeList_Bearer_RearrangeInd,
        id_Unused_ProtocolIE_ID_691,
        id_multipleRL_dl_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
        id_Target_NonServing_EDCH_To_Total_EDCH_Power_Ratio,
        id_CellPortion_InformationItem_Cell_ReconfRqstFDD,
        id_CellPortion_InformationList_Cell_ReconfRqstFDD,
        id_multiple_PUSCH_InfoList_DM_Rsp,
        id_multiple_PUSCH_InfoList_DM_Rprt,
        id_Reference_ReceivedTotalWideBandPower,
        id_E_DCH_Serving_Cell_Change_Info_Response,
        id_HS_DSCH_Serving_Cell_Change_Info,
        id_HS_DSCH_Serving_Cell_Change_Info_Response,
        id_Serving_Cell_Change_CFN,
        id_E_DCH_HARQ_Combining_Capability,
        id_E_DCH_TTI2ms_Capability,
        id_E_DCH_SF_Capability,
        id_E_DCH_FDD_Update_Information,
        id_F_DPCH_Capability,
        id_E_DCH_Non_serving_Relative_Grant_Down_CommandsValue,
        id_HSSICH_SIRTarget,
        id_multiple_HSSICHMeasurementValueList_TDD_DM_Rsp,
        id_PLCCH_Information_AuditRsp,
        id_PLCCH_Information_ResourceStatusInd,
        id_PLCCH_Information_RL_ReconfPrepTDDLCR,
        id_PLCCH_Information_UL_TimeslotLCR_Info,
        id_PLCCH_InformationList_AuditRsp,
        id_PLCCH_InformationList_ResourceStatusInd,
        id_PLCCH_Parameters_CTCH_ReconfRqstTDD,
        id_S_CCPCH_768_Parameters_CTCH_SetupRqstTDD,
        id_PICH_768_Parameters_CTCH_SetupRqstTDD,
        id_PRACH_768_Parameters_CTCH_SetupRqstTDD,
        id_S_CCPCH_768_Parameters_CTCH_ReconfRqstTDD,
        id_PICH_768_Parameters_CTCH_ReconfRqstTDD,
        id_MICH_768_Parameters_CTCH_ReconfRqstTDD,
        id_CommonPhysicalChannelID768_CommonTrChDeletionReq,
        id_S_CCPCH_768_InformationList_AuditRsp,
        id_S_CCPCH_768_Information_AuditRsp,
        id_neighbouringTDDCellMeasurementInformation768,
        id_PCCPCH_768_Information_Cell_SetupRqstTDD,
        id_SCH_768_Information_Cell_SetupRqstTDD,
        id_SCH_768_Information_Cell_ReconfRqstTDD,
        id_PCCPCH_768_Information_Cell_ReconfRqstTDD,
        id_P_CCPCH_768_Information_AuditRsp,
        id_PICH_768_Information_AuditRsp,
        id_PRACH_768_InformationList_AuditRsp,
        id_SCH_768_Information_AuditRsp,
        id_MICH_768_Information_AuditRsp,
        id_PRACH_768_Information,
        id_S_CCPCH_768_Information_ResourceStatusInd,
        id_P_CCPCH_768_Information_ResourceStatusInd,
        id_PICH_768_Information_ResourceStatusInd,
        id_PRACH_768_InformationList_ResourceStatusInd,
        id_SCH_768_Information_ResourceStatusInd,
        id_MICH_768_Information_ResourceStatusInd,
        id_S_CCPCH_768_InformationList_ResourceStatusInd,
        id_UL_DPCH_768_Information_RL_SetupRqstTDD,
        id_DL_DPCH_768_Information_RL_SetupRqstTDD,
        id_DL_DPCH_InformationItem_768_RL_AdditionRqstTDD,
        id_UL_DPCH_InformationItem_768_RL_AdditionRqstTDD,
        id_UL_DPCH_768_InformationAddItemIE_RL_ReconfPrepTDD,
        id_UL_DPCH_768_InformationAddListIE_RL_ReconfPrepTDD,
        id_UL_DPCH_768_InformationModify_AddItem,
        id_UL_DPCH_768_InformationModify_AddList,
        id_UL_Timeslot768_Information_RL_ReconfPrepTDD,
        id_DL_DPCH_768_InformationAddItem_RL_ReconfPrepTDD,
        id_DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD,
        id_DL_DPCH_768_InformationModify_AddItem_RL_ReconfPrepTDD,
        id_DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD,
        id_DL_Timeslot_768_InformationModify_ModifyList_RL_ReconfPrepTDD,
        id_DPCH_ID768_DM_Rqst,
        id_multiple_DedicatedMeasurementValueList_768_TDD_DM_Rsp,
        id_DPCH_ID768_DM_Rsp,
        id_Rx_Timing_Deviation_Value_768,
        id_DPCH_ID768_DM_Rprt,
        id_PDSCH_AddInformation_768_PSCH_ReconfRqst,
        id_PDSCH_ModifyInformation_768_PSCH_ReconfRqst,
        id_PUSCH_AddInformation_768_PSCH_ReconfRqst,
        id_PUSCH_ModifyInformation_768_PSCH_ReconfRqst,
        id_dL_HS_PDSCH_Timeslot_Information_768_PSCH_ReconfRqst,
        id_hS_SCCH_Information_768_PSCH_ReconfRqst,
        id_hS_SCCH_InformationModify_768_PSCH_ReconfRqst,
        id_hsSCCH_Specific_Information_ResponseTDD768,
        id_E_DPCH_Information_RL_AdditionReqFDD,
        id_PDSCH_Timeslot_Format_PSCH_ReconfRqst_LCR,
        id_PUSCH_Timeslot_Format_PSCH_ReconfRqst_LCR,
        id_E_DCH_PowerOffset_for_SchedulingInfo,
        id_HSDSCH_Configured_Indicator,
        id_Rx_Timing_Deviation_Value_384_ext,
        id_RTWP_ReportingIndicator,
        id_RTWP_CellPortion_ReportingIndicator,
        id_Received_Scheduled_EDCH_Power_Share_Value,
        id_Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value,
        id_Received_Scheduled_EDCH_Power_Share,
        id_Received_Scheduled_EDCH_Power_Share_For_CellPortion,
        id_tFCI_Presence,
        id_HSSICH_TPC_StepSize,
        id_E_RUCCH_InformationList_AuditRsp,
        id_E_RUCCH_InformationList_ResourceStatusInd,
        id_E_DCH_TDD_CapacityConsumptionLaw,
        id_E_RUCCH_Information,
        id_E_DCH_Information,
        id_E_DCH_Information_Response,
        id_E_DCH_Information_Reconfig,
        id_E_PUCH_Information_PSCH_ReconfRqst,
        id_Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst,
        id_Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst,
        id_Delete_From_E_AGCH_Resource_Pool_PSCH_ReconfRqst,
        id_E_HICH_Information_PSCH_ReconfRqst,
        id_E_HICH_TimeOffset,
        id_Maximum_Generated_ReceivedTotalWideBandPowerInOtherCells,
        id_E_DCH_Serving_RL_ID,
        id_E_RUCCH_768_InformationList_AuditRsp,
        id_E_RUCCH_768_InformationList_ResourceStatusInd,
        id_E_RUCCH_768_Information,
        id_E_DCH_768_Information,
        id_E_DCH_768_Information_Reconfig,
        id_E_PUCH_Information_768_PSCH_ReconfRqst,
        id_Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst,
        id_Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst,
        id_E_HICH_Information_768_PSCH_ReconfRqst,
        id_ExtendedPropagationDelay,
        id_Extended_Round_Trip_Time_Value,
        id_AlternativeFormatReportingIndicator,
        id_DCH_Indicator_For_E_DCH_HSDPA_Operation,
        id_Reference_ReceivedTotalWideBandPowerReporting,
        id_Reference_ReceivedTotalWideBandPowerSupportIndicator,
        id_ueCapability_Info,
        id_MAChs_ResetIndicator,
        id_Fast_Reconfiguration_Mode,
        id_Fast_Reconfiguration_Permission,
        id_BroadcastReference,
        id_BroadcastCommonTransportBearerIndication,
        id_ContinuousPacketConnectivityDTX_DRX_Capability,
        id_ContinuousPacketConnectivityDTX_DRX_Information,
        id_ContinuousPacketConnectivityHS_SCCH_less_Capability,
        id_ContinuousPacketConnectivityHS_SCCH_less_Information,
        id_ContinuousPacketConnectivityHS_SCCH_less_Information_Response,
        id_CPC_Information,
        id_MIMO_Capability,
        id_MIMO_PilotConfiguration,
        id_MBSFN_Cell_ParameterID_Cell_SetupRqstTDD,
        id_MBSFN_Cell_ParameterID_Cell_ReconfRqstTDD,
        id_S_CCPCH_Modulation,
        id_HS_PDSCH_Code_Change_Grant,
        id_HS_PDSCH_Code_Change_Indicator,
        id_SYNC_UL_Partition_LCR,
        id_E_DCH_LCR_Information,
        id_E_DCH_LCR_Information_Reconfig,
        id_E_PUCH_Information_LCR_PSCH_ReconfRqst,
        id_Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst,
        id_Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst,
        id_Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst,
        id_Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst,
        id_Delete_From_E_HICH_Resource_Pool_PSCH_ReconfRqst,
        id_E_HICH_TimeOffsetLCR,
        id_SixtyfourQAM_DL_Capability,
        id_SixteenQAM_UL_Capability,
        id_HSDSCH_MACdPDU_SizeCapability,
        id_HSDSCH_MACdPDUSizeFormat,
        id_MaximumMACdPDU_SizeExtended,
        id_F_DPCH_SlotFormat,
        id_F_DPCH_SlotFormatCapability,
        id_LCRTDD_uplink_Physical_Channel_Capability,
        id_Extended_RNC_ID,
        id_Max_UE_DTX_Cycle,
        id_Secondary_CCPCH_SlotFormat_Extended,
        id_MBSFN_Only_Mode_Indicator_Cell_SetupRqstTDD_LCR,
        id_MBSFN_Only_Mode_Capability,
        id_Time_Slot_Parameter_ID,
        id_Additional_failed_HS_SICH,
        id_Additional_missed_HS_SICH,
        id_Additional_total_HS_SICH,
        id_Additional_HS_SICH_Reception_Quality_Measurement_Value,
        id_GANSS_Common_Data,
        id_GANSS_Information,
        id_GANSS_Generic_Data,
        id_TUTRANGANSSMeasurementThresholdInformation,
        id_TUTRANGANSSMeasurementValueInformation,
        id_ModulationPO_MBSFN,
        id_Enhanced_FACH_Capability,
        id_Enhanced_PCH_Capability,
        id_HSDSCH_Common_System_InformationFDD,
        id_HSDSCH_Common_System_Information_ResponseFDD,
        id_HSDSCH_Paging_System_InformationFDD,
        id_HSDSCH_Paging_System_Information_ResponseFDD,
        id_MBMS_Capability,
        id_Ext_Reference_E_TFCI_PO,
        id_Ext_Max_Bits_MACe_PDU_non_scheduled,
        id_HARQ_MemoryPartitioningInfoExtForMIMO,
        id_MIMO_ActivationIndicator,
        id_MIMO_Mode_Indicator,
        id_MIMO_N_M_Ratio,
        id_IPMulticastIndication,
        id_IPMulticastDataBearerIndication,
        id_TransportBearerNotSetupIndicator,
        id_TransportBearerNotRequestedIndicator,
        id_TimeSlotConfigurationList_LCR_CTCH_SetupRqstTDD,
        id_Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp,
        id_Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp,
        id_Cell_Frequency_List_LCR_MulFreq_Cell_SetupRqstTDD,
        id_UARFCN_Adjustment,
        id_Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd,
        id_Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd,
        id_UPPCHPositionLCR,
        id_UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD,
        id_UPPCH_LCR_InformationList_AuditRsp,
        id_UPPCH_LCR_InformationItem_AuditRsp,
        id_UPPCH_LCR_InformationList_ResourceStatusInd,
        id_UPPCH_LCR_InformationItem_ResourceStatusInd,
        id_multipleFreq_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst,
        id_number_Of_Supported_Carriers,
        id_multipleFreq_HSPDSCH_InformationList_ResponseTDDLCR,
        id_Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD,
        id_multipleFreq_HS_DSCH_Resources_InformationList_AuditRsp,
        id_multipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd,
        id_UARFCNSpecificCauseList,
        id_tSN_Length,
        id_MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst,
        id_multicarrier_number,
        id_Extended_HS_SCCH_ID,
        id_Extended_HS_SICH_ID,
        id_HSSICH_InfoExt_DM_Rqst,
        id_Delete_From_HS_SCCH_Resource_PoolExt_PSCH_ReconfRqst,
        id_HS_SCCH_InformationExt_LCR_PSCH_ReconfRqst,
        id_HS_SCCH_InformationModifyExt_LCR_PSCH_ReconfRqst,
        id_PowerControlGAP,
        id_MBSFN_SpecialTimeSlot_LCR,
        id_Common_MACFlows_to_DeleteFDD,
        id_Paging_MACFlows_to_DeleteFDD,
        id_E_TFCI_Boost_Information,
        id_SixteenQAM_UL_Operation_Indicator,
        id_SixtyfourQAM_UsageAllowedIndicator,
        id_SixtyfourQAM_DL_UsageIndicator,
        id_Default_Serving_Grant_in_DTX_Cycle2,
        id_Maximum_Target_ReceivedTotalWideBandPower_LCR,
        id_E_DPDCH_PowerInterpolation,
        id_Extended_E_DCH_LCRTDD_PhysicalLayerCategory,
        id_MultipleFreq_E_DCH_Resources_InformationList_AuditRsp,
        id_MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd,
        id_MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst,
        id_MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst,
        id_Extended_E_HICH_ID_TDD,
        id_ContinuousPacketConnectivityHS_SCCH_less_Deactivate_Indicator,
        id_E_DCH_MACdPDU_SizeCapability,
        id_E_DCH_MACdPDUSizeFormat,
        id_MaximumNumber_Of_Retransmission_for_Scheduling_Info_LCRTDD,
        id_E_DCH_RetransmissionTimer_for_SchedulingInfo_LCRTDD,
        id_E_HICH_TimeOffset_Extension,
        id_MultipleFreq_E_HICH_TimeOffsetLCR,
        id_E_PUCH_PowerControlGAP,
        id_HSDSCH_TBSizeTableIndicator,
        id_E_DCH_DL_Control_Channel_Change_Information,
        id_E_DCH_DL_Control_Channel_Grant_Information,
        id_DGANSS_Corrections_Req,
        id_UE_with_enhanced_HS_SCCH_support_indicator,
        id_AdditionalTimeSlotListLCR,
        id_AdditionalMeasurementValueList,
        id_E_AGCH_Table_Choice,
        id_PLCCH_parameters,
        id_E_RUCCH_parameters,
        id_E_RUCCH_768_parameters,
        id_HS_Cause,
        id_E_Cause,
        id_Common_EDCH_Capability,
        id_E_AI_Capability,
        id_Common_EDCH_System_InformationFDD,
        id_Common_UL_MACFlows_to_DeleteFDD,
        id_Common_EDCH_MACdFlows_to_DeleteFDD,
        id_Common_EDCH_System_Information_ResponseFDD,
        id_Cell_ERNTI_Status_Information,
        id_Enhanced_UE_DRX_Capability,
        id_Enhanced_UE_DRX_InformationFDD,
        id_TransportBearerRequestIndicator,
        id_SixtyfourQAM_DL_MIMO_Combined_Capability,
        id_E_RNTI,
        id_MinimumReducedE_DPDCH_GainFactor,
        id_GANSS_Time_ID,
        id_GANSS_AddIonoModelReq,
        id_GANSS_EarthOrientParaReq,
        id_GANSS_AddNavigationModelsReq,
        id_GANSS_AddUTCModelsReq,
        id_GANSS_AuxInfoReq,
        id_GANSS_SBAS_ID,
        id_GANSS_ID,
        id_GANSS_Additional_Ionospheric_Model,
        id_GANSS_Earth_Orientation_Parameters,
        id_GANSS_Additional_Time_Models,
        id_GANSS_Additional_Navigation_Models,
        id_GANSS_Additional_UTC_Models,
        id_GANSS_Auxiliary_Information,
        id_ERACH_CM_Rqst,
        id_ERACH_CM_Rsp,
        id_ERACH_CM_Rprt,
        id_EDCH_RACH_Report_Value,
        id_EDCH_RACH_Report_IncrDecrThres,
        id_EDCH_RACH_Report_ThresholdInformation,
        id_E_DPCCH_Power_Boosting_Capability,
        id_HSDSCH_Common_System_InformationLCR,
        id_HSDSCH_Common_System_Information_ResponseLCR,
        id_HSDSCH_Paging_System_InformationLCR,
        id_HSDSCH_Paging_System_Information_ResponseLCR,
        id_Common_MACFlows_to_DeleteLCR,
        id_Paging_MACFlows_to_DeleteLCR,
        id_Common_EDCH_System_InformationLCR,
        id_Common_UL_MACFlows_to_DeleteLCR,
        id_Common_EDCH_MACdFlows_to_DeleteLCR,
        id_Common_EDCH_System_Information_ResponseLCR,
        id_Enhanced_UE_DRX_CapabilityLCR,
        id_Enhanced_UE_DRX_InformationLCR,
        id_HSDSCH_PreconfigurationSetup,
        id_HSDSCH_PreconfigurationInfo,
        id_NoOfTargetCellHS_SCCH_Order,
        id_EnhancedHSServingCC_Abort,
        id_Additional_HS_Cell_Information_RL_Setup,
        id_Additional_HS_Cell_Information_Response,
        id_Additional_HS_Cell_Information_RL_Addition,
        id_Additional_HS_Cell_Change_Information_Response,
        id_Additional_HS_Cell_Information_RL_Reconf_Prep,
        id_Additional_HS_Cell_Information_RL_Reconf_Req,
        id_Additional_HS_Cell_Information_RL_Param_Upd,
        id_Multi_Cell_Capability_Info,
        id_IMB_Parameters,
        id_MACes_Maximum_Bitrate_LCR,
        id_Semi_PersistentScheduling_CapabilityLCR,
        id_E_DCH_Semi_PersistentScheduling_Information_LCR,
        id_HS_DSCH_Semi_PersistentScheduling_Information_LCR,
        id_Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst,
        id_Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst,
        id_Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst,
        id_ContinuousPacketConnectivity_DRX_CapabilityLCR,
        id_ContinuousPacketConnectivity_DRX_InformationLCR,
        id_ContinuousPacketConnectivity_DRX_Information_ResponseLCR,
        id_CPC_InformationLCR,
        id_HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR,
        id_E_DCH_Semi_PersistentScheduling_Information_ResponseLCR,
        id_E_AGCH_UE_Inactivity_Monitor_Threshold,
        id_IdleIntervalInformation,
        id_GANSS_alm_keplerianNAVAlmanac,
        id_GANSS_alm_keplerianReducedAlmanac,
        id_GANSS_alm_keplerianMidiAlmanac,
        id_GANSS_alm_keplerianGLONASS,
        id_GANSS_alm_ecefSBASAlmanac,
        id_HSSICH_ReferenceSignal_InformationLCR,
        id_MIMO_ReferenceSignal_InformationListLCR,
        id_MIMO_SFMode_For_HSPDSCHDualStream,
        id_MIMO_SFMode_Supported_For_HSPDSCHDualStream,
        id_UE_Selected_MBMS_Service_Information,
        id_MultiCarrier_HSDSCH_Physical_Layer_Category,
        id_Common_E_DCH_HSDPCCH_Capability,
        id_DL_RLC_PDU_Size_Format,
        id_HSSICH_ReferenceSignal_InformationModifyLCR,
        id_schedulingPriorityIndicator,
        id_TimeSlotMeasurementValueListLCR,
        id_UE_SupportIndicatorExtension,
        id_Single_Stream_MIMO_ActivationIndicator,
        id_Single_Stream_MIMO_Capability,
        id_Single_Stream_MIMO_Mode_Indicator,
        id_Dual_Band_Capability_Info,
        id_UE_AggregateMaximumBitRate,
        id_UE_AggregateMaximumBitRate_Enforcement_Indicator,
        id_MIMO_Power_Offset_For_S_CPICH_Capability,
        id_MIMO_PilotConfigurationExtension,
        id_TxDiversityOnDLControlChannelsByMIMOUECapability,
        id_ULTimeslotISCPValue_For_CellPortion,
        id_UpPTSInterferenceValue_For_CellPortion,
        id_Best_Cell_Portions_ValueLCR,
        id_Transmitted_Carrier_Power_For_CellPortion_ValueLCR,
        id_Received_total_wide_band_power_For_CellPortion_ValueLCR,
        id_UL_TimeslotISCP_For_CellPortion_Value,
        id_HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR,
        id_HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR,
        id_E_DCHProvidedBitRateValueInformation_For_CellPortion,
        id_UpPTSInterference_For_CellPortion_Value,
        id_NumberOfReportedCellPortionsLCR,
        id_CellPortion_CapabilityLCR,
        id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue,
        id_TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortion,
        id_ActivationInformation,
        id_Additional_EDCH_Cell_Information_RL_Setup_Req,
        id_Additional_EDCH_Cell_Information_Response,
        id_Additional_EDCH_Cell_Information_RL_Add_Req,
        id_Additional_EDCH_Cell_Information_Response_RL_Add,
        id_Additional_EDCH_Cell_Information_RL_Reconf_Prep,
        id_Additional_EDCH_Cell_Information_RL_Reconf_Req,
        id_Additional_EDCH_Cell_Information_Bearer_Rearrangement,
        id_Additional_EDCH_Cell_Information_RL_Param_Upd,
        id_Additional_EDCH_Preconfiguration_Information,
        id_EDCH_Indicator,
        id_HS_DSCH_SPS_Reservation_Indicator,
        id_E_DCH_SPS_Reservation_Indicator,
        id_MultipleFreq_HARQ_MemoryPartitioning_InformationList,
        id_Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR_Ext,
        id_RepetitionPeriodIndex,
        id_MidambleShiftLCR,
        id_MaxHSDSCH_HSSCCH_Power_per_CELLPORTION,
        id_DormantModeIndicator,
        id_DiversityMode,
        id_TransmitDiversityIndicator,
        id_NonCellSpecificTxDiversity,
        id_Cell_Capability_Container,
        id_E_RNTI_List_Request,
        id_E_RNTI_List,
        id_PowerControlGAP_For_CellFACHLCR,
        id_UL_Synchronisation_Parameters_For_FACHLCR,
        id_HS_DSCH_SPS_Operation_Indicator,
        id_HSDSCH_RNTI_For_FACH,
        id_E_RNTI_For_FACH,
        id_Out_of_Sychronization_Window,
        id_Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst,
        id_E_HICH_TimeOffset_ReconfFailureTDD,
        id_HSSCCH_TPC_StepSize,
        id_TS0_CapabilityLCR,
        id_UE_TS0_CapabilityLCR,
        id_Common_System_Information_ResponseLCR,
        id_Additional_EDCH_Cell_Information_ResponseRLReconf,
        id_Multicell_EDCH_InformationItemIEs,
        id_Multicell_EDCH_RL_Specific_InformationItemIEs,
        id_Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext,
        id_Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext,
        id_Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext,
        id_Initial_DL_Transmission_Power,
        id_Maximum_DL_Power,
        id_Minimum_DL_Power,
        id_DCH_MeasurementOccasion_Information,
        id_AssociatedPhsicalChannelID,
        id_DGNSS_ValidityPeriod,
        id_PhysicalChannelID_for_CommonERNTI_RequestedIndicator,
        id_PrecodingWeightSetRestriction,
        id_Treset_Usage_Indicator,
        id_Non_Serving_RL_Preconfig_Info,
        id_Non_Serving_RL_Preconfig_Setup,
        id_Non_Serving_RL_Preconfig_Removal,
        id_Additional_E_DCH_Non_Serving_RL_Preconfiguration_Setup,
        id_Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList,
        id_Ul_common_E_DCH_MACflow_Specific_InfoListLCR_Ext,
        id_CommonMACFlow_Specific_InfoList_ResponseLCR_Ext,
        id_Enabling_Delay_Ext_LCR,
        id_OrdinalNumberOfFrequency,
        id_Multicell_EDCH_Restriction,
        id_completeAlmanacProvided,
        id_ganss_Delta_T,
        id_Cell_Capability_Container_TDD_LCR,
        id_Multi_Carrier_EDCH_Setup,
        id_Multi_Carrier_EDCH_Reconfigure,
        id_Multi_Carrier_EDCH_Response,
        id_SNPL_Carrier_Group_Indicator,
        id_MU_MIMO_Capability_ContainerLCR,
        id_MU_MIMO_InformationLCR,
        id_MU_MIMO_Information_Response,
        id_MU_MIMO_Information_To_ReconfigureLCR,
        id_HS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext,
        id_Adaptive_Special_Burst_Power_CapabilityLCR,
        id_Usefulness_Of_Battery_Optimization,
        id_Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory,
        id_Common_HSDSCH_RNTI_List,
        id_CommonEDCH_AdditionalTransmissionBackOff,
        id_In_Sync_Information_LCR,
        id_Puncturing_Handling_in_First_Rate_Matching_Stage,
        id_ERNTI_Release_Status,
        id_UE_Status_Update_Confirm_Indicator,
        id_Max_RTWP_perCellPortion_InformationList_LCR_PSCH_ReconfRqst,
        id_AOA_per_CELL_Portion_LCR,
        id_UL_CLTD_Information,
        id_UL_CLTD_Information_Reconf,
        id_UL_CLTD_State_Update_Information,
        id_Affected_HSDSCH_Serving_Cell_List,
        id_Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order,
        id_CPC_RecoveryReport,
        id_FTPICH_Information,
        id_FTPICH_Information_Reconf,
        id_UE_RF_Band_CapabilityLCR,
        id_E_AGCH_PowerOffset,
        id_E_RGCH_PowerOffset,
        id_E_HICH_PowerOffset,
        id_UE_transmission_power_headroom,
        id_MIMO_withfourtransmitantennas_ActivationIndicator,
        id_MIMO_withfourtransmitantennas_Mode_Indicator,
        id_MIMO_withfourtransmitantennas_PilotConfiguration,
        id_DualStream_MIMO_withfourtransmitantennas_ActivationIndicator,
        id_DualStream_MIMO_withfourtransmitantennas_Mode_Indicator,
        id_UL_MIMO_Information,
        id_UL_MIMO_Reconfiguration,
        id_UL_MIMO_DL_Control_Channel_Information,
        id_SixtyfourQAM_UL_Operation_Indicator,
        id_Common_E_DCH_Implicit_Release_Timer,
        id_Multiflow_Information,
        id_Multiflow_Reconfiguration,
        id_Multiflow_OrdinalNumberOfFrequency,
        id_Concurrent_Deployment_of_2msand10ms_TTI,
        id_Common_EDH_Preamble_Control_Information_extension_Type1,
        id_Common_EDH_Preamble_Control_Information_extension_Type2,
        id_Common_EDH_Preamble_Control_Information_extension_Type3,
        id_NodeB_Triggered_HSDPCCH_Transmission_Information,
        id_Per_HARQ_Activiation_and_Deactiviation,
        id_Coffset,
        id_Common_E_DCH_MAC_d_flow_info_Concurrent_TTI,
        id_Serving_Grant_Value_for_Concurrent_Deployment_of_2msand10ms_TTI,
        id_Two_ms_Grant_E_DCH_RACH_Resources,
        id_Two_ms_Overridden_E_DCH_RACH_Resources,
        id_Two_ms_Denied_E_DCH_RACH_Resources,
        id_Further_Enhanced_UE_DRX_InformationFDD,
        id_Common_E_RGCH_Operation_Indicator,
        id_Common_E_RGCH_InfoFDD,
        id_PrecoderWeightSetRestriction,
        id_Non_rectangular_resource_allocation_indicator,
        id_Non_rectangular_resource_timeslot_set,
        id_UE_Support_of_non_rectangular_resource_allocation,
        id_DBDS_CorrectionsReq,
        id_DBDS_Corrections,
        id_BDS_IonosphericGridModelReq,
        id_BDS_Ionospheric_Grid_Model,
        id_GANSS_alm_keplerianBDSAlmanac,
        id_Assisting_RepetitionFactors,
        id_UE_Measurement_Forwarding,
        id_UPH_Filtering_Measurement_Forwarding_Request,
        id_TTI_Update_Indicator,
        id_CQI_Feedback_Cycle2,
        id_CQI_Cycle_Switch_Timer,
        id_UE_DRX_Cycle2,
        id_Inactivity_Threshold_for_UE_DRX_Cycle2,
        id_DTX_Information2,
        id_BCH_Parameters,
        id_BCH_Parameters_CTCH_SetupRsp,
        id_BCH_Parameters_CTCH_ReconfRqstFDD,
        id_BCH_mappedOnSCCPCH_Indication,
        id_DCH_ENH_Information,
        id_DCH_ENH_Information_Reconf,
        id_Gainfactors_10ms_mode,
        id_E_DCH_Decoupling_Indication,
        id_Radio_Links_without_DPCH_FDPCH_Indication,
        id_UL_DPCCH2_Information,
        id_UL_DPCCH2_Information_Reconf,
        id_ImplicitGrantHandling,
        id_MinimumTEBSthreshold,
        id_ActivationDelay,
        id_Fast_TTI_switching_Mode_synchronized,
        id_Fast_TTI_switching_Mode_unsynchronized,
        id_Fast_TTI_switching_Mode_Supported,
        id_Dual_Band_EDCH_Capability,
        id_Improved_Synchronized_Indicator,
        id_Downlink_TPC_enhancements_Information,
        id_Downlink_TPC_enhancements_Reconf,
        id_TPC_slot_position,
        id_E_RNTI_Set,
        id_DL_TBS,
        id_Dual_Cell_EDCH_Enhancements_Information,
        id_HS_SCCH_DRX_InformationFDD,
    ]

class NBAP_Containers:

    _name_  = 'NBAP-Containers'
    _oid_   = [0, 4, 0, 0, 20, 3, 2, 1, 5]
    
    _obj_ = [
        'NBAP-PROTOCOL-IES',
        'NBAP-PROTOCOL-IES-PAIR',
        'NBAP-PROTOCOL-EXTENSION',
        'NBAP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'NBAP-PROTOCOL-IES',
        'NBAP-PROTOCOL-IES-PAIR',
        'NBAP-PROTOCOL-EXTENSION',
        'NBAP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'NBAP-PROTOCOL-IES',
        'NBAP-PROTOCOL-IES-PAIR',
        'NBAP-PROTOCOL-EXTENSION',
        'NBAP-PRIVATE-IES',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< NBAP-PROTOCOL-IES >-----#
    NBAP_PROTOCOL_IES = CLASS(name='NBAP-PROTOCOL-IES', mode=MODE_TYPE)
    _NBAP_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _NBAP_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Criticality')))
    _NBAP_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _NBAP_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Presence')))
    NBAP_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _NBAP_PROTOCOL_IES_id),
        ('criticality', _NBAP_PROTOCOL_IES_criticality),
        ('Value', _NBAP_PROTOCOL_IES_Value),
        ('presence', _NBAP_PROTOCOL_IES_presence),
        ])
    
    #-----< NBAP-PROTOCOL-IES-PAIR >-----#
    NBAP_PROTOCOL_IES_PAIR = CLASS(name='NBAP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _NBAP_PROTOCOL_IES_PAIR_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _NBAP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name='firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Criticality')))
    _NBAP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name='FirstValue', mode=MODE_TYPE)
    _NBAP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name='secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Criticality')))
    _NBAP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name='SecondValue', mode=MODE_TYPE)
    _NBAP_PROTOCOL_IES_PAIR_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Presence')))
    NBAP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        ('id', _NBAP_PROTOCOL_IES_PAIR_id),
        ('firstCriticality', _NBAP_PROTOCOL_IES_PAIR_firstCriticality),
        ('FirstValue', _NBAP_PROTOCOL_IES_PAIR_FirstValue),
        ('secondCriticality', _NBAP_PROTOCOL_IES_PAIR_secondCriticality),
        ('SecondValue', _NBAP_PROTOCOL_IES_PAIR_SecondValue),
        ('presence', _NBAP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< NBAP-PROTOCOL-EXTENSION >-----#
    NBAP_PROTOCOL_EXTENSION = CLASS(name='NBAP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _NBAP_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _NBAP_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Criticality')))
    _NBAP_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _NBAP_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Presence')))
    NBAP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _NBAP_PROTOCOL_EXTENSION_id),
        ('criticality', _NBAP_PROTOCOL_EXTENSION_criticality),
        ('Extension', _NBAP_PROTOCOL_EXTENSION_Extension),
        ('presence', _NBAP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< NBAP-PRIVATE-IES >-----#
    NBAP_PRIVATE_IES = CLASS(name='NBAP-PRIVATE-IES', mode=MODE_TYPE)
    _NBAP_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'PrivateIE-ID')))
    _NBAP_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Criticality')))
    _NBAP_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _NBAP_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Presence')))
    NBAP_PRIVATE_IES._cont = ASN1Dict([
        ('id', _NBAP_PRIVATE_IES_id),
        ('criticality', _NBAP_PRIVATE_IES_criticality),
        ('Value', _NBAP_PRIVATE_IES_Value),
        ('presence', _NBAP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Single-Container >-----#
    ProtocolIE_Single_Container = SEQ(name='ProtocolIE-Single-Container', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name='ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name='ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name='ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _NBAP_PROTOCOL_IES_id,
        _NBAP_PROTOCOL_IES_criticality,
        _NBAP_PROTOCOL_IES_Value,
        _NBAP_PROTOCOL_IES_presence,
        NBAP_PROTOCOL_IES,
        _NBAP_PROTOCOL_IES_PAIR_id,
        _NBAP_PROTOCOL_IES_PAIR_firstCriticality,
        _NBAP_PROTOCOL_IES_PAIR_FirstValue,
        _NBAP_PROTOCOL_IES_PAIR_secondCriticality,
        _NBAP_PROTOCOL_IES_PAIR_SecondValue,
        _NBAP_PROTOCOL_IES_PAIR_presence,
        NBAP_PROTOCOL_IES_PAIR,
        _NBAP_PROTOCOL_EXTENSION_id,
        _NBAP_PROTOCOL_EXTENSION_criticality,
        _NBAP_PROTOCOL_EXTENSION_Extension,
        _NBAP_PROTOCOL_EXTENSION_presence,
        NBAP_PROTOCOL_EXTENSION,
        _NBAP_PRIVATE_IES_id,
        _NBAP_PRIVATE_IES_criticality,
        _NBAP_PRIVATE_IES_Value,
        _NBAP_PRIVATE_IES_presence,
        NBAP_PRIVATE_IES,
    ]

class NBAP_IEs:

    _name_  = 'NBAP-IEs'
    _oid_   = [0, 4, 0, 0, 20, 3, 2, 1, 2]
    
    _obj_ = [
        'AckNack-RepetitionFactor',
        'Ack-Power-Offset',
        'Acknowledged-PRACH-preambles-Value',
        'ActivationDelay',
        'ActivationInformation',
        'ActivationInformationItem',
        'ActivationInformationItem-ExtIEs',
        'Adaptive-Special-Burst-Power-CapabilityLCR',
        'EDCH-Reference-E-TFCI-Information',
        'EDCH-Reference-E-TFCI-Information-Item',
        'EDCH-Reference-E-TFCI-Information-Item-ExtIEs',
        'EDCH-Reference-E-TFCI-PO',
        'Additional-EDCH-Setup-Info',
        'Additional-EDCH-Setup-Info-ExtIEs',
        'Multicell-EDCH-Transport-Bearer-Mode',
        'Additional-EDCH-Cell-Information-Setup',
        'Additional-EDCH-FDD-Setup-Cell-Information',
        'Additional-EDCH-FDD-Setup-Cell-Information-ExtIEs',
        'Additional-EDCH-UL-DPCH-Information-Setup',
        'Additional-EDCH-UL-DPCH-Information-Setup-ExtIEs',
        'Additional-EDCH-F-DPCH-Information',
        'Additional-EDCH-F-DPCH-Information-ExtIEs',
        'Additional-EDCH-RL-Specific-Information-To-Setup-List',
        'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs',
        'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs-ExtIEs',
        'Additional-EDCH-Cell-Information-To-Add-List',
        'Additional-EDCH-Cell-Information-To-Add-ItemIEs',
        'Additional-EDCH-Cell-Information-To-Add-ItemIEs-ExtIEs',
        'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs',
        'EDCH-Additional-RL-Specific-Information-To-Add-List',
        'EDCH-Additional-RL-Specific-Information-To-Add-List-ExtIEs',
        'Additional-EDCH-RL-Specific-Information-To-Modify-List',
        'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs',
        'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs-ExtIEs',
        'Additional-EDCH-FDD-Information',
        'Additional-EDCH-FDD-Information-ExtIEs',
        'DTX-Information2',
        'DTX-Information2-ExtIEs',
        'Implicit-Grant-Handling',
        'Minimum-TEBS-threshold',
        'Additional-EDCH-MAC-d-Flows-Specific-Info-List',
        'Additional-EDCH-MAC-d-Flows-Specific-Info',
        'Additional-EDCH-MAC-d-Flows-Specific-Info-ExtIEs',
        'Additional-EDCH-Cell-Information-Response-List',
        'Additional-EDCH-FDD-Information-Response-ItemIEs',
        'Additional-EDCH-FDD-Information-Response-ItemIEs-ExtIEs',
        'EDCH-Additional-RL-Specific-Information-Response-List',
        'EDCH-Additional-RL-Specific-Information-Response-ItemIEs',
        'EDCH-Additional-RL-Specific-Information-Response-ItemIEs-ExtIEs',
        'Additional-EDCH-Cell-Information-Response-RLReconf-List',
        'Additional-EDCH-FDD-Information-Response-RLReconf-Items',
        'Additional-EDCH-FDD-Information-Response-RLReconf-Items-ExtIEs',
        'Additional-Modififed-EDCH-FDD-Information-Response-ItemIEs',
        'Additional-Modififed-EDCH-FDD-Information-Response-ItemIEs-ExtIEs',
        'EDCH-Additional-Modified-RL-Specific-Information-Response-List',
        'EDCH-Additional-Modified-RL-Specific-Information-Response-List-Items',
        'EDCH-Additional-Modified-RL-Specific-Information-Response-List-Items-ExtIEs',
        'Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List',
        'Additional-EDCH-MAC-d-Flows-Specific-Info-Response',
        'Additional-EDCH-MAC-d-Flows-Specific-Info-Response-ExtIEs',
        'Additional-EDCH-Cell-Information-Response-RL-Add-List',
        'Additional-EDCH-Cell-Information-Response-RL-Add-ItemIEs',
        'Additional-EDCH-Cell-Information-Response-RL-Add-ItemIEs-ExtIEs',
        'Additional-EDCH-Cell-Information-ConfigurationChange-List',
        'Additional-EDCH-ConfigurationChange-Info-ItemIEs',
        'Additional-EDCH-ConfigurationChange-Info-ItemIEs-ExtIEs',
        'Additional-EDCH-UL-DPCH-Information-Modify',
        'Additional-EDCH-UL-DPCH-Information-Modify-ExtIEs',
        'Additional-EDCH-Cell-Information-Removal-List',
        'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs',
        'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs-ExtIEs',
        'RL-on-Secondary-UL-Frequency',
        'Additional-EDCH-FDD-Update-Information',
        'Additional-EDCH-FDD-Update-Information-ExtIEs',
        'Additional-EDCH-DL-Control-Channel-Change-Information-List',
        'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs',
        'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs-ExtIEs',
        'AdditionalMeasurementValueList',
        'AdditionalMeasurementValue',
        'AdditionalMeasurementValueList-ExtIEs',
        'AdditionalTimeSlotListLCR',
        'AdditionalTimeSlotLCR',
        'AdditionalTimeSlotLCR-ExtIEs',
        'AddorDeleteIndicator',
        'Active-Pattern-Sequence-Information',
        'Active-Pattern-Sequence-Information-ExtIEs',
        'Transmission-Gap-Pattern-Sequence-Status-List',
        'Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs',
        'Affected-HSDSCH-Serving-Cell-List',
        'AICH-Power',
        'AICH-TransmissionTiming',
        'AllocationRetentionPriority',
        'AllocationRetentionPriority-ExtIEs',
        'AlternativeFormatReportingIndicator',
        'Angle-Of-Arrival-Value-LCR',
        'Angle-Of-Arrival-Value-LCR-ExtIEs',
        'AOA-LCR',
        'AOA-LCR-Accuracy-Class',
        'AOA-per-CELL-Portion-LCR',
        'AOA-per-CELL-Portion-LCR-Item',
        'AOA-per-CELL-Portion-LCR-Item-ExtIEs',
        'AvailabilityStatus',
        'BCCH-Specific-HSDSCH-RNTI-Information',
        'BCCH-Specific-HSDSCH-RNTI-Information-ExtIEs',
        'BCCH-Specific-HSDSCH-RNTI-InformationLCR',
        'BCCH-Specific-HSDSCH-RNTI-InformationLCR-ExtIEs',
        'BCCH-ModificationTime',
        'BDS-IGPInfoList',
        'BDS-IGPInfo',
        'BDS-IGPInfo-ExtIEs',
        'BDS-IonosphericGridModelReq',
        'BDS-Ionospheric-Grid-Model',
        'BDS-Ionospheric-Grid-Model-ExtIEs',
        'Best-Cell-Portions-Value',
        'Best-Cell-Portions-Item',
        'Best-Cell-Portions-Item-ExtIEs',
        'Best-Cell-Portions-ValueLCR',
        'Best-Cell-Portions-ItemLCR',
        'Best-Cell-Portions-ItemLCR-ExtIEs',
        'BindingID',
        'BetaCD',
        'BlockingPriorityIndicator',
        'SCTD-Indicator',
        'BundlingModeIndicator',
        'BroadcastCommonTransportBearerIndication',
        'BroadcastCommonTransportBearerIndication-ExtIEs',
        'BroadcastReference',
        'Cause',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'CCTrCH-ID',
        'Cell-Capability-Container',
        'Cell-ERNTI-Status-Information',
        'Cell-ERNTI-Status-Information-Item',
        'Vacant-ERNTI',
        'CellParameterID',
        'CellPortionID',
        'CellPortionLCRID',
        'CellPortion-CapabilityLCR',
        'CellSyncBurstCode',
        'CellSyncBurstCodeShift',
        'CellSyncBurstRepetitionPeriod',
        'CellSyncBurstSIR',
        'CellSyncBurstTiming',
        'CellSyncBurstTimingLCR',
        'CellSyncBurstTimingThreshold',
        'CFN',
        'ChipOffset',
        'C-ID',
        'Closedlooptimingadjustmentmode',
        'CodeRate',
        'CodeRate-short',
        'CommonChannelsCapacityConsumptionLaw',
        'CommonChannelsCapacityConsumptionLaw-ExtIEs',
        'Common-EDCH-Capability',
        'Common-E-DCH-HSDPCCH-Capability',
        'Common-EDCH-System-InformationFDD',
        'Common-EDCH-System-InformationFDD-ExtIEs',
        'E-RNTI-Set',
        'E-RNTI-Set-ExtIEs',
        'Common-E-DCH-UL-DPCH-InfoItem',
        'Common-E-DCH-UL-DPCH-InfoItem-ExtIEs',
        'Common-E-DCH-EDPCH-InfoItem',
        'Common-E-DCH-EDPCH-InfoItem-ExtIEs',
        'Common-E-DCH-InfoItem',
        'Common-E-DCH-InfoItem-ExtIEs',
        'CommonEDCH-AdditionalTransmissionBackOff',
        'Common-E-DCH-HSDPCCH-InfoItem',
        'Common-E-DCH-HSDPCCH-InfoItem-ExtIEs',
        'Common-E-DCH-CQI-Info',
        'Common-E-DCH-CQI-Info-ExtIEs',
        'Common-E-DCH-Preamble-Control-InfoItem',
        'Common-E-DCH-Preamble-Control-InfoItem-ExtIEs',
        'Common-E-DCH-AICH-Information',
        'Common-E-DCH-AICH-Information-ExtIEs',
        'Common-E-DCH-FDPCH-InfoItem',
        'Common-E-DCH-FDPCH-InfoItem-ExtIEs',
        'Common-E-DCH-Resource-Combination-InfoList',
        'Common-E-DCH-Resource-Combination-InfoList-Item',
        'Common-E-DCH-Resource-Combination-InfoList-Item-ExtIEs',
        'Common-E-DCH-MAC-d-flow-info-Concurrent-TTI',
        'Common-E-DCH-MAC-d-flow-info-Concurrent-TTI-ExtIEs',
        'Ul-common-E-DCH-MACflow-Specific-InfoList',
        'Ul-common-E-DCH-MACflow-Specific-InfoList-Item',
        'Ul-common-E-DCH-MACflow-Specific-InfoList-Item-ExtIEs',
        'Common-E-DCH-MACdFlow-Specific-InfoList',
        'Common-E-DCH-MACdFlow-Specific-InfoList-Item',
        'Common-E-DCH-MACdFlow-Specific-InfoList-Item-ExtIEs',
        'Common-E-DCH-LogicalChannel-InfoList',
        'Common-E-DCH-LogicalChannel-InfoList-Item',
        'Common-E-DCH-LogicalChannel-InfoList-Item-ExtIEs',
        'Common-EDCH-System-Information-ResponseFDD',
        'Common-EDCH-System-Information-ResponseFDD-ExtIEs',
        'E-RNTI-List',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-Item',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-Item-ExtIEs',
        'Common-HSDSCH-RNTI-List',
        'Common-MACFlows-to-DeleteFDD',
        'Common-MACFlows-to-DeleteFDD-Item',
        'Common-MACFlows-to-DeleteFDD-Item-ExtIEs',
        'Common-MACFlow-ID',
        'CommonMACFlow-Specific-InfoList',
        'CommonMACFlow-Specific-InfoItem',
        'CommonMACFlow-Specific-InfoItem-ExtIEs',
        'CommonMACFlow-Specific-InfoList-Response',
        'CommonMACFlow-Specific-InfoItem-Response',
        'CommonMACFlow-Specific-InfoItem-Response-ExtIEs',
        'Common-MACFlow-PriorityQueue-Information',
        'Common-MACFlow-PriorityQueue-Item',
        'Common-MACFlow-PriorityQueue-Item-ExtIEs',
        'CommonMeasurementAccuracy',
        'CommonMeasurementType',
        'CommonMeasurementValue',
        'Extension-CommonMeasurementValue',
        'Extension-CommonMeasurementValueIE',
        'CommonMeasurementValueInformation',
        'CommonMeasurementAvailable',
        'CommonMeasurementAvailableItem-ExtIEs',
        'CommonMeasurementnotAvailable',
        'CommonPhysicalChannelID',
        'CommonPhysicalChannelID768',
        'Common-PhysicalChannel-Status-Information',
        'Common-PhysicalChannel-Status-Information-ExtIEs',
        'Common-PhysicalChannel-Status-Information768',
        'Common-PhysicalChannel-Status-Information768-ExtIEs',
        'CommonTransportChannelID',
        'CommonTransportChannel-InformationResponse',
        'CommonTransportChannel-InformationResponse-ExtIEs',
        'Common-TransportChannel-Status-Information',
        'Common-TransportChannel-Status-Information-ExtIEs',
        'CommunicationControlPortID',
        'CompleteAlmanacProvided',
        'Compressed-Mode-Deactivation-Flag',
        'ConfigurationGenerationID',
        'ConstantValue',
        'ContinuousPacketConnectivityDTX-DRX-Capability',
        'ContinuousPacketConnectivityDTX-DRX-Information',
        'ContinuousPacketConnectivityDTX-DRX-Information-ExtIEs',
        'ContinuousPacketConnectivityDTX-DRX-Information-to-Modify',
        'ContinuousPacketConnectivityDTX-DRX-Information-to-Modify-ExtIEs',
        'ContinuousPacketConnectivityHS-SCCH-less-Capability',
        'ContinuousPacketConnectivityHS-SCCH-less-Information',
        'ContinuousPacketConnectivityHS-SCCH-less-InformationItem',
        'ContinuousPacketConnectivityHS-SCCH-less-Information-ExtIEs',
        'ContinuousPacketConnectivityHS-SCCH-less-Information-Response',
        'ContinuousPacketConnectivityHS-SCCH-less-Information-Response-ExtIEs',
        'ControlGAP',
        'CPC-Information',
        'CPC-Information-ExtIEs',
        'CPC-RecoveryReport',
        'ContinuousPacketConnectivityHS-SCCH-less-Deactivate-Indicator',
        'CQI-DTX-Timer',
        'CQI-Cycle-Switch-Timer',
        'CQI-Feedback-Cycle',
        'CQI-Feedback-Cycle2',
        'CQI-Power-Offset',
        'CQI-RepetitionFactor',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CRNC-CommunicationContextID',
        'CSBMeasurementID',
        'CSBTransmissionID',
        'Common-EDCH-System-InformationLCR',
        'Common-EDCH-System-InformationLCR-ExtIEs',
        'Common-E-PUCH-InformationLCR',
        'Common-E-PUCH-InformationLCR-ExtIEs',
        'PRXdes-base-perURAFCN',
        'PRXdes-base-Item',
        'PRXdes-base-Item-ExtIEs',
        'Ul-common-E-DCH-MACflow-Specific-InfoListLCR',
        'Ul-common-E-DCH-MACflow-Specific-InfoListLCR-Ext',
        'Ul-common-E-DCH-MACflow-Specific-InfoList-ItemLCR',
        'Ul-common-E-DCH-MACflow-Specific-InfoList-ItemLCR-ExtIEs',
        'Common-E-DCH-MACdFlow-Specific-InfoListLCR',
        'Common-E-DCH-MACdFlow-Specific-InfoList-ItemLCR',
        'Common-E-DCH-MACdFlow-Specific-InfoList-ItemLCR-ExtIEs',
        'Common-EDCH-System-Information-ResponseLCR',
        'Common-EDCH-System-Information-ResponseLCR-ExtIEs',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR-Ext',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-ItemLCR',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-ItemLCR-ExtIEs',
        'Common-E-AGCH-ListLCR',
        'Common-E-AGCH-ItemLCR',
        'Common-E-AGCH-ItemLCR-ExtIEs',
        'Common-E-HICH-ListLCR',
        'Common-E-HICH-ItemLCR',
        'Common-E-HICH-ItemLCR-ExtIEs',
        'Common-E-RNTI-Info-LCR',
        'Common-E-RNTI-Info-ItemLCR',
        'Common-E-RNTI-Info-ItemLCR-ExtIEs',
        'Common-MACFlows-to-DeleteLCR',
        'Common-MACFlows-to-DeleteLCR-Item',
        'Common-MACFlows-to-DeleteLCR-Item-ExtIEs',
        'Common-MACFlow-ID-LCR',
        'CommonMACFlow-Specific-InfoListLCR',
        'CommonMACFlow-Specific-InfoItemLCR',
        'CommonMACFlow-Specific-InfoItemLCR-ExtIEs',
        'Common-H-RNTI-InformationLCR',
        'Common-H-RNTI-InfoItemLCR',
        'Common-H-RNTI-InfoItemLCR-ExtIEs',
        'Sync-InformationLCR',
        'Sync-InformationLCR-ExtIEs',
        'CommonMACFlow-Specific-InfoList-ResponseLCR',
        'CommonMACFlow-Specific-InfoList-ResponseLCR-Ext',
        'CommonMACFlow-Specific-InfoItem-ResponseLCR',
        'CommonMACFlow-Specific-InfoItem-ResponseLCR-ExtIEs',
        'CPC-InformationLCR',
        'CPC-InformationLCR-ExtIEs',
        'ContinuousPacketConnectivity-DRX-CapabilityLCR',
        'ContinuousPacketConnectivity-DRX-InformationLCR',
        'ContinuousPacketConnectivity-DRX-InformationLCR-ExtIEs',
        'HS-SCCH-DRX-Information-LCR',
        'HS-SCCH-DRX-Information-LCR-ExtIEs',
        'E-AGCH-DRX-Information-LCR',
        'E-AGCH-DRX-Parameters',
        'E-AGCH-DRX-Parameters-ExtIEs',
        'UE-DRX-Cycle-LCR',
        'UE-DRX-Offset-LCR',
        'Inactivity-Threshold-for-UE-DRX-Cycle-LCR',
        'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext',
        'E-AGCH-UE-Inactivity-Monitor-Threshold',
        'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR',
        'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR-ExtIEs',
        'DRX-Information-to-Modify-LCR',
        'DRX-Information-to-Modify-Items-LCR',
        'DRX-Information-to-Modify-Items-LCR-ExtIEs',
        'ContinuousPacketConnectivity-DRX-Information-ResponseLCR',
        'ContinuousPacketConnectivity-DRX-Information-ResponseLCR-ExtIEs',
        'HS-SCCH-DRX-Information-ResponseLCR',
        'HS-SCCH-DRX-Information-ResponseLCR-ExtIEs',
        'E-AGCH-DRX-Information-ResponseLCR',
        'E-AGCH-DRX-Parameters-Response',
        'E-AGCH-DRX-Parameters-Response-ExtIEs',
        'Cell-Capability-Container-TDD-LCR',
        'Common-E-RGCH-Operation-Indicator',
        'Common-E-RGCH-InfoFDD',
        'Common-E-RGCH-InfoFDD-ExtIEs',
        'Concurrent-Deployment-of-2msand10ms-TTI',
        'Concurrent-Deployment-of-2msand10ms-TTI-ExtIEs',
        'Concurrent-TTI-Partition-Index',
        'Common-E-DCH-System-Info-Parameters-for-Concurrent-TTI',
        'Common-E-DCH-System-Info-Parameters-for-Concurrent-TTI-ExtIEs',
        'Common-E-DCH-HS-DPCCH-Information-forConcurrentTTI',
        'Common-E-DCH-HS-DPCCH-Information-forConcurrentTTI-ExtIEs',
        'Common-E-DCH-Preamble-Control-Information-extensionList',
        'Common-E-DCH-Preamble-Control-Information-extensionList-Item',
        'Common-E-DCH-Preamble-Control-Information-extensionList-Item-ExtIEs',
        'Common-E-DCH-Preamble-Control-Information-extension',
        'Common-E-DCH-Preamble-Control-Information-extension-Item-ExtIEs',
        'Configuration-for-2msTTI-Common-E-DCH-ResourcesList',
        'Configuration-for-2msTTI-Common-E-DCH-ResourcesList-Item',
        'Configuration-for-2msTTI-Common-E-DCH-ResourcesList-Item-ExtIEs',
        'Coffset',
        'CHOICE-DRX-level',
        'DATA-ID',
        'DBDS-CorrectionsReq',
        'DBDS-CorrectionsReq-ExtIEs',
        'DBDS-Corrections',
        'DBDS-Corrections-ExtIEs',
        'DBDS-Info',
        'DBDS-Info-ExtIEs',
        'DBDS-SignalInfoList',
        'DBDS-SignalInfo',
        'DBDS-SignalInfo-ExtIEs',
        'DBDS-InfoList',
        'DCH-ENH-Information',
        'DCH-ENH-Information-ExtIEs',
        'DCH-ENH-Information-to-Modify',
        'DCH-ENH-Information-to-Modify-ExtIEs',
        'DL-FET-Mode',
        'DCH-ENH-Concat',
        'DCH-ENH-Information-Reconf',
        'DCH-ENH-Information-Reconf-ExtIEs',
        'DCH-ENH-Information-Removal',
        'DCH-ID',
        'DCH-FDD-Information',
        'DCH-FDD-InformationItem',
        'DCH-FDD-InformationItem-ExtIEs',
        'DCH-Specific-FDD-InformationList',
        'DCH-Specific-FDD-Item',
        'DCH-Specific-FDD-Item-ExtIEs',
        'DCH-Indicator-For-E-DCH-HSDPA-Operation',
        'DCH-InformationResponse',
        'DCH-InformationResponseItem',
        'DCH-InformationResponseItem-ExtIEs',
        'DCH-MeasurementOccasion-Information',
        'DchMeasurementOccasionInformation-Item',
        'DCH-MeasurementOccasion-Information-ExtIEs',
        'Measurement-Occasion-Pattern-Sequence-parameters',
        'Measurement-Occasion-Pattern-Sequence-parameters-ExtIEs',
        'DCH-TDD-Information',
        'DCH-TDD-InformationItem',
        'DCH-TDD-InformationItem-ExtIEs',
        'DCH-Specific-TDD-InformationList',
        'DCH-Specific-TDD-Item',
        'DCH-Specific-TDD-Item-ExtIEs',
        'FDD-DCHs-to-Modify',
        'FDD-DCHs-to-ModifyItem',
        'FDD-DCHs-to-ModifyItem-ExtIEs',
        'DCH-ModifySpecificInformation-FDD',
        'DCH-ModifySpecificItem-FDD',
        'DCH-ModifySpecificItem-FDD-ExtIEs',
        'TDD-DCHs-to-Modify',
        'DCH-ModifyItem-TDD',
        'TDD-DCHs-to-ModifyItem-ExtIEs',
        'DCH-ModifySpecificInformation-TDD',
        'DCH-ModifySpecificItem-TDD',
        'DCH-ModifySpecificItem-TDD-ExtIEs',
        'DecimationFactor',
        'DedicatedChannelsCapacityConsumptionLaw',
        'DedicatedChannelsCapacityConsumptionLaw-ExtIEs',
        'DedicatedMeasurementType',
        'DedicatedMeasurementValue',
        'Extension-DedicatedMeasurementValue',
        'Extension-DedicatedMeasurementValueIE',
        'DedicatedMeasurementValueInformation',
        'DedicatedMeasurementAvailable',
        'DedicatedMeasurementAvailableItem-ExtIEs',
        'DedicatedMeasurementnotAvailable',
        'DelayedActivation',
        'DelayedActivationUpdate',
        'Activate-Info',
        'Activate-Info-ExtIEs',
        'Deactivate-Info',
        'Deactivate-Info-ExtIEs',
        'Execution-Type',
        'DeltaSIR',
        'DGANSSCorrections',
        'DGANSSCorrections-ExtIEs',
        'DGANSS-Corrections-Req',
        'DGANSS-Corrections-Req-ExtIEs',
        'DGANSS-Information',
        'DGANSS-InformationItem',
        'DGANSS-InformationItem-ExtIEs',
        'DGANSS-SignalInformation',
        'DGANSS-SignalInformationItem',
        'DGANSS-SignalInformationItem-ExtIEs',
        'DGANSSThreshold',
        'DGANSSThreshold-ExtIEs',
        'DGNSS-ValidityPeriod',
        'DGNSS-ValidityPeriod-ExtIEs',
        'DGPSCorrections',
        'DGPSCorrections-ExtIEs',
        'DGPSThresholds',
        'DGPSThresholds-ExtIEs',
        'DiscardTimer',
        'DiversityControlField',
        'DiversityMode',
        'DL-TBS',
        'DL-TBS-ExtIEs',
        'HS-DSCH-Cell-List',
        'HS-DSCH-Cell',
        'HS-DSCH-Cell-ExtIEs',
        'DL-TBS-Value',
        'DL-DPCH-SlotFormat',
        'DL-DPCH-TimingAdjustment',
        'DL-Timeslot-Information',
        'DL-Timeslot-InformationItem',
        'DL-Timeslot-InformationItem-ExtIEs',
        'DL-TimeslotLCR-Information',
        'DL-TimeslotLCR-InformationItem',
        'DL-TimeslotLCR-InformationItem-ExtIEs',
        'DL-Timeslot768-Information',
        'DL-Timeslot768-InformationItem',
        'DL-Timeslot768-InformationItem-ExtIEs',
        'DL-FrameType',
        'DL-or-Global-CapacityCredit',
        'DL-Power',
        'DLPowerAveragingWindowSize',
        'DL-PowerBalancing-Information',
        'DL-PowerBalancing-Information-ExtIEs',
        'DL-ReferencePowerInformationList',
        'DL-ReferencePowerInformationItem',
        'DL-ReferencePowerInformationItem-ExtIEs',
        'DL-PowerBalancing-ActivationIndicator',
        'DL-PowerBalancing-UpdatedIndicator',
        'DL-ScramblingCode',
        'DL-TimeslotISCP',
        'DL-TimeslotISCPInfo',
        'DL-TimeslotISCPInfoItem',
        'DL-TimeslotISCPInfoItem-ExtIEs',
        'DL-TimeslotISCPInfoLCR',
        'DL-TimeslotISCPInfoItemLCR',
        'DL-TimeslotISCPInfoItemLCR-ExtIEs',
        'DL-TPC-Pattern01Count',
        'DLTransmissionBranchLoadValue',
        'Downlink-Compressed-Mode-Method',
        'DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-InformationItem-LCR-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'MaxHSDSCH-HSSCCH-Power-per-CELLPORTION',
        'MaxHSDSCH-HSSCCH-Power-per-CELLPORTION-Item',
        'MaxHSDSCH-HSSCCH-Power-per-CELLPORTION-Item-ExtIEs',
        'DL-HS-PDSCH-Codelist-LCR-PSCH-ReconfRqst',
        'Downlink-TPC-enhancements-Information',
        'Downlink-TPC-enhancements-Information-ExtIEs',
        'Downlink-TPC-enhancements-Reconf',
        'Downlink-TPC-enhancements-Reconf-ExtIEs',
        'Downlink-TPC-enhancements-Information-Removal',
        'DPC-Mode',
        'DPCH-ID',
        'DPCH-ID768',
        'DRX-Information',
        'DRX-Information-ExtIEs',
        'DRX-Information-to-Modify',
        'DRX-Information-to-Modify-Items',
        'DRX-Information-to-Modify-Items-ExtIEs',
        'DRX-Interruption-by-HS-DSCH',
        'DSCH-ID',
        'DSCH-InformationResponse',
        'DSCH-InformationResponseItem',
        'DSCH-InformationResponseItem-ExtIEs',
        'DSCH-TDD-Information',
        'DSCH-TDD-InformationItem',
        'DSCH-TDD-InformationItem-ExtIEs',
        'DsField',
        'DTX-Cycle-2ms-Items',
        'DTX-Cycle-2ms-Items-ExtIEs',
        'DTX-Cycle-2ms-to-Modify-Items',
        'DTX-Cycle-2ms-to-Modify-Items-ExtIEs',
        'DTX-Cycle-10ms-Items',
        'DTX-Cycle-10ms-Items-ExtIEs',
        'DTX-Cycle-10ms-to-Modify-Items',
        'DTX-Cycle-10ms-to-Modify-Items-ExtIEs',
        'DTX-Information',
        'DTX-Information-ExtIEs',
        'DTX-Information-to-Modify',
        'DTX-Information-to-Modify-Items',
        'DTX-Information-to-Modify-Items-ExtIEs',
        'Dual-Band-Capability',
        'Dual-Band-Capability-Info',
        'Dual-Band-Capability-Info-ExtIEs',
        'DwPCH-Power',
        'Improved-Synchronized-Indicator',
        'E-AGCH-Table-Choice',
        'E-AGCH-FDD-Code-Information',
        'E-AGCH-FDD-Code-List',
        'E-AI-Capability',
        'E-AI-Indicator',
        'E-DCH-Capability',
        'E-DCHCapacityConsumptionLaw',
        'E-DCHCapacityConsumptionLaw-ExtIEs',
        'E-DCH-Decoupling-Indication',
        'E-DCH-TDD-CapacityConsumptionLaw',
        'E-DCH-TDD-CapacityConsumptionLaw-ExtIEs',
        'E-DCH-SF-allocation',
        'E-DCH-SF-allocation-ExtIEs',
        'E-DCH-TTI2ms-Capability',
        'E-DCH-SF-Capability',
        'E-DCH-HARQ-Combining-Capability',
        'E-DCH-DDI-Value',
        'E-DCH-FDD-DL-Control-Channel-Information',
        'E-DCH-FDD-DL-Control-Channel-Information-ExtIEs',
        'E-DCH-FDD-Information',
        'E-DCH-FDD-Information-ExtIEs',
        'UPH-Filtering-Measurement-Forwarding-Request',
        'E-DCH-FDD-Information-Response',
        'E-DCH-FDD-Information-Response-ExtIEs',
        'E-DCH-FDD-Information-to-Modify',
        'E-DCH-FDD-Information-to-Modify-ExtIEs',
        'E-DCH-FDD-Update-Information',
        'E-DCH-FDD-Update-Information-ExtIEs',
        'TTI-Update-Indicator',
        'TTI-Update-Ind',
        'E-DCH-MACdFlow-Specific-UpdateInformation',
        'E-DCH-MACdFlow-Specific-UpdateInformation-Item',
        'E-DCH-MACdFlow-Specific-UpdateInformation-Item-ExtIEs',
        'E-DCH-DL-Control-Channel-Change-Information',
        'E-DCH-DL-Control-Channel-Change-Information-Item',
        'E-DCH-DL-Control-Channel-Change-Information-Item-ExtIEs',
        'E-DCH-DL-Control-Channel-Grant-Information',
        'E-DCH-DL-Control-Channel-Grant-Information-Item',
        'E-DCH-DL-Control-Channel-Grant-Information-Item-ExtIEs',
        'E-DCH-Grant-Type-Information',
        'E-DCH-LogicalChannelInformation',
        'E-DCH-LogicalChannelInformationItem',
        'E-DCH-LogicalChannelInformationItem-ExtIEs',
        'E-DCH-Maximum-Bitrate',
        'E-DCH-PowerOffset-for-SchedulingInfo',
        'E-DCH-Processing-Overload-Level',
        'E-DCH-Reference-Power-Offset',
        'E-DCH-MACdPDU-SizeList',
        'E-DCH-MACdPDU-SizeListItem',
        'E-DCH-MACdPDU-SizeListItem-ExtIEs',
        'E-DCH-MACdPDU-SizeCapability',
        'E-DCH-MACdPDUSizeFormat',
        'E-DCH-LogicalChannelToModify',
        'E-DCH-LogicalChannelToModifyItem',
        'E-DCH-LogicalChannelToModifyItem-ExtIEs',
        'E-DCH-MACdPDU-SizeToModifyList',
        'E-DCH-LogicalChannelToDelete',
        'E-DCH-LogicalChannelToDeleteItem',
        'E-DCH-LogicalChannelToDeleteItem-ExtIEs',
        'LogicalChannelID',
        'E-DCH-HARQ-PO-FDD',
        'E-DCH-MACdFlow-ID',
        'E-DCH-MACdFlows-Information',
        'E-DCH-MACdFlows-Information-ExtIEs',
        'E-DCH-MACdFlow-Multiplexing-List',
        'E-DCH-MACdFlow-Specific-InfoList',
        'E-DCH-MACdFlow-Specific-InfoItem',
        'E-DCH-MACdFlow-Specific-InfoItem-ExtIEs',
        'E-DCH-MACdFlow-Specific-InformationResp',
        'E-DCH-MACdFlow-Specific-InformationResp-Item',
        'E-DCH-MACdFlow-Specific-InformationResp-Item-ExtIEs',
        'E-DCH-MACdFlow-Specific-InfoList-to-Modify',
        'E-DCH-MACdFlow-Specific-InfoItem-to-Modify',
        'E-DCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs',
        'E-DCH-MACdFlows-to-Delete',
        'E-DCH-MACdFlow-to-Delete-Item',
        'E-DCH-MACdFlow-to-Delete-Item-ExtIEs',
        'E-DCH-Non-Scheduled-Transmission-Grant-Items',
        'E-DCH-Non-Scheduled-Transmission-Grant-Items-ExtIEs',
        'E-DCH-Non-serving-Relative-Grant-Down-Commands',
        'E-DCHProvidedBitRateValue',
        'Maximum-Target-ReceivedTotalWideBandPower',
        'Target-NonServing-EDCH-To-Total-EDCH-Power-Ratio',
        'E-DCH-RL-Indication',
        'E-DCH-Serving-Cell-Change-Info-Response',
        'E-DCH-serving-cell-informationResponse-ExtIEs',
        'E-DCH-serving-cell-choice',
        'E-DCH-serving-cell-change-successful',
        'E-DCH-RL-InformationList-Rsp',
        'E-DCH-RL-InformationList-Rsp-Item',
        'E-DCH-serving-cell-change-successful-ExtIEs',
        'E-DCH-RL-InformationList-Rsp-Item-ExtIEs',
        'E-DCH-serving-cell-change-unsuccessful',
        'E-DCH-serving-cell-change-unsuccessful-ExtIEs',
        'EDCH-RACH-Report-Value',
        'EDCH-RACH-Report-Value-ExtIEs',
        'E-DCH-TFCI-Table-Index',
        'E-DCH-TTI-Length',
        'E-DCH-TTI-Length-to-Modify',
        'E-DPCCH-PO',
        'Extended-E-DPCCH-PO',
        'E-DPDCH-PowerInterpolation',
        'E-Primary-Secondary-Grant-Selector',
        'E-DCH-MACdFlow-ID-LCR',
        'E-DCH-MACdFlows-to-DeleteLCR',
        'E-DCH-MACdFlow-to-Delete-ItemLCR',
        'E-DCH-MACdFlow-to-Delete-ItemLCR-ExtIEs',
        'Enhanced-UE-DRX-InformationLCR',
        'Enhanced-UE-DRX-InformationLCR-ExtIEs',
        'E-HICH-ID-LCR',
        'E-HICH-Signature-Sequence',
        'End-Of-Audit-Sequence-Indicator',
        'E-Serving-Grant-Value',
        'E-RGCH-2-IndexStepThreshold',
        'E-RGCH-3-IndexStepThreshold',
        'E-RGCH-E-HICH-FDD-Code-Information',
        'E-RGCH-E-HICH-FDD-Code-List',
        'E-RGCH-Release-Indicator',
        'E-RGCH-Signature-Sequence',
        'E-RNTI',
        'E-TFCI',
        'E-TFCI-BetaEC-Boost',
        'E-TFCI-Boost-Information',
        'E-TFCI-Boost-Information-ExtIEs',
        'E-TFCS-Information',
        'E-TFCS-Information-ExtIEs',
        'E-TTI',
        'E-DCHProvidedBitRate',
        'E-DCHProvidedBitRate-Item',
        'E-DCHProvidedBitRate-Item-ExtIEs',
        'E-DCHProvidedBitRateValueInformation-For-CellPortion',
        'E-DCHProvidedBitRateValueInformation-For-CellPortion-Item',
        'E-DCHProvidedBitRateValueInformation-For-CellPortion-Item-ExtIEs',
        'E-AGCH-PowerOffset',
        'E-RGCH-PowerOffset',
        'E-HICH-PowerOffset',
        'E-HICH-TimeOffset',
        'E-HICH-TimeOffsetLCR',
        'E-DCH-Information',
        'E-DCH-Information-ExtIEs',
        'E-PUCH-Information',
        'E-PUCH-Information-ExtIEs',
        'E-TFCS-Information-TDD',
        'E-TFCS-Information-TDD-ExtIEs',
        'E-DCH-QPSK-RefBetaInfo',
        'E-DCH-sixteenQAM-RefBetaInfo',
        'E-DCH-RefBeta-Item',
        'E-DCH-MACdFlows-Information-TDD',
        'E-DCH-MACdFlow-InfoTDDItem',
        'E-DCH-MACdFlow-InfoTDDItem-ExtIEs',
        'E-DCH-MACdFlow-Retransmission-Timer',
        'E-DCH-HARQ-PO-TDD',
        'E-DCH-Grant-TypeTDD',
        'E-DCH-Non-Scheduled-Grant-Info',
        'E-DCH-Non-Scheduled-Grant-Info-ExtIEs',
        'E-DCH-TimeslotResource',
        'E-DCH-TimeslotResourceLCR',
        'E-DCH-PowerResource',
        'TddE-PUCH-Offset',
        'E-DCH-TDD-Information',
        'E-DCH-TDD-Information-ExtIEs',
        'E-DCH-TDD-Maximum-Bitrate',
        'E-DCH-Information-Response',
        'E-DCH-Information-Response-ExtIEs',
        'Scheduled-E-HICH-Specific-Information-ResponseLCRTDD',
        'Scheduled-E-HICH-Specific-InformationItem-ResponseLCRTDD',
        'Scheduled-E-HICH-Specific-InformationItem-ResponseLCRTDD-ExtIEs',
        'EI',
        'E-HICH-ID-TDD',
        'E-HICH-Type',
        'E-DCH-TDD-MACdFlow-Specific-InformationResp',
        'E-DCH-TDD-MACdFlow-Specific-InformationResp-Item',
        'E-DCH-TDD-MACdFlow-Specific-InformationRespItem-ExtIEs',
        'E-AGCH-Specific-InformationRespListTDD',
        'E-AGCH-Specific-InformationResp-ItemTDD',
        'E-AGCH-Specific-InformationResp-ItemTDD-ExtIEs',
        'E-AGCH-Id',
        'E-DCH-Information-Reconfig',
        'E-DCH-Information-Reconfig-ExtIEs',
        'E-DCH-TDD-Information-to-Modify',
        'E-DCH-TDD-Information-to-Modify-ExtIEs',
        'E-DCH-TDD-Information-to-Modify-List',
        'E-DCH-MACdFlow-ModifyTDDItem',
        'E-DCH-MACdFlow-ModifyTDDItem-ExtIEs',
        'Maximum-Generated-ReceivedTotalWideBandPowerInOtherCells',
        'E-DCH-768-Information',
        'E-DCH-768-Information-ExtIEs',
        'E-DCH-Non-Scheduled-Grant-Info768',
        'E-DCH-Non-Scheduled-Grant-Info768-ExtIEs',
        'E-DCH-TDD-Information768',
        'E-DCH-TDD-Information768-ExtIEs',
        'E-DCH-TDD-Maximum-Bitrate768',
        'E-DCH-768-Information-Reconfig',
        'E-DCH-768-Information-Reconfig-ExtIEs',
        'E-DCH-LCR-Information',
        'E-DCH-LCR-Information-ExtIEs',
        'E-PUCH-LCR-Information',
        'E-PUCH-LCR-Information-ExtIEs',
        'E-DCH-Non-Scheduled-Grant-LCR-Info',
        'E-DCH-Non-Scheduled-Grant-LCR-Info-ExtIEs',
        'E-HICH-LCR-Information',
        'E-HICH-LCR-Information-ExtIEs',
        'E-DCH-LCRTDD-Information',
        'E-DCH-LCRTDD-Information-ExtIEs',
        'E-DCH-LCRTDD-PhysicalLayerCategory',
        'E-DCH-LCR-Information-Reconfig',
        'E-DCH-LCR-Information-Reconfig-ExtIEs',
        'Enabling-Delay',
        'Enabling-Delay-Ext-LCR',
        'DormantModeIndicator',
        'Enhanced-FACH-Capability',
        'EnhancedHSServingCC-Abort',
        'Enhanced-PCH-Capability',
        'Enhanced-UE-DRX-Capability',
        'Enhanced-UE-DRX-InformationFDD',
        'Enhanced-UE-DRX-InformationFDD-ExtIEs',
        'Extended-E-DCH-LCRTDD-PhysicalLayerCategory',
        'Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory',
        'Ext-Max-Bits-MACe-PDU-non-scheduled',
        'Ext-Reference-E-TFCI-PO',
        'ExtendedPropagationDelay',
        'Extended-RNC-ID',
        'Extended-Round-Trip-Time-Value',
        'Extended-HS-SCCH-ID',
        'Extended-HS-SICH-ID',
        'Extended-E-HICH-ID-TDD',
        'Radio-Links-without-DPCH-FDPCH-Indication',
        'Radio-Links-without-DPCH-FDPCH-Information',
        'Radio-Links-without-DPCH-FDPCH-Information-ExtIEs',
        'E-DCH-Semi-PersistentScheduling-Information-LCR',
        'E-DCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        'E-DCH-SPS-Indicator',
        'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR',
        'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR',
        'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        'ERNTI-Release-Status',
        'Common-E-DCH-Implicit-Release-Timer',
        'FACH-Measurement-Occasion-Cycle-Length-Coefficient',
        'Fast-Reconfiguration-Mode',
        'Fast-Reconfiguration-Permission',
        'Fast-TTI-switching-Mode-synchronized',
        'Mode1-Ind',
        'Fast-TTI-switching-Mode-unsynchronized',
        'Fast-TTI-switching-Mode-Supported',
        'FDD-DL-ChannelisationCodeNumber',
        'FDD-DL-CodeInformation',
        'FDD-DL-CodeInformationItem',
        'FDD-DL-CodeInformationItem-ExtIEs',
        'FDD-S-CCPCH-FrameOffset',
        'FDD-S-CCPCH-Offset',
        'FDD-TPC-DownlinkStepSize',
        'F-DPCH-Capability',
        'F-DPCH-Info',
        'F-DPCH-Info-ExtIEs',
        'F-DPCH-Info-To-Modify',
        'F-DPCH-Info-To-Modify-ExtIEs',
        'F-DPCH-SlotFormat',
        'F-DPCH-SlotFormatCapability',
        'FirstRLS-Indicator',
        'FNReportingIndicator',
        'FrameHandlingPriority',
        'FrameAdjustmentValue',
        'FrameOffset',
        'FPACH-Power',
        'FTPICH-Information',
        'FTPICH-Information-ExtIEs',
        'FTPICH-SlotFormat',
        'FTPICH-Offset',
        'FTPICH-Information-Removal',
        'FTPICH-Information-To-Modify',
        'FTPICH-Information-To-Modify-ExtIEs',
        'FTPICH-Information-Reconf',
        'FTPICH-Information-Reconf-ExtIEs',
        'Further-Enhanced-UE-DRX-InformationFDD',
        'Further-Enhanced-UE-DRX-InformationFDD-ExtIEs',
        'Gainfactors-10ms-mode',
        'SignalledGainFactors10ms-ExtIEs',
        'GANSS-AddClockModels',
        'GANSS-AddIonoModelReq',
        'GANSS-AddNavigationModelsReq',
        'GANSS-AddOrbitModels',
        'GANSS-AddUTCModelsReq',
        'GANSS-Additional-Ionospheric-Model',
        'GANSS-Additional-Ionospheric-Model-ExtIEs',
        'GANSS-Additional-Navigation-Models',
        'GANSS-Additional-Navigation-Models-ExtIEs',
        'GANSS-Additional-Time-Models',
        'GANSS-Additional-UTC-Models',
        'GANSS-Almanac',
        'GANSS-Almanac-ExtIEs',
        'GANSS-AlmanacModel',
        'Extension-GANSS-AlmanacModel',
        'Extension-GANSS-AlmanacModel-IE',
        'GANSS-ALM-ECEFsbasAlmanacSet',
        'GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs',
        'GANSS-ALM-GlonassAlmanacSet',
        'GANSS-ALM-GlonassAlmanacSet-ExtIEs',
        'GANSS-ALM-MidiAlmanacSet',
        'GANSS-ALM-MidiAlmanacSet-ExtIEs',
        'GANSS-ALM-NAVKeplerianSet',
        'GANSS-ALM-NAVKeplerianSet-ExtIEs',
        'GANSS-ALM-KEPLERIANBDSALMANAC',
        'GANSS-ALM-KEPLERIANBDSALMANAC-ExtIEs',
        'GANSS-ALM-ReducedKeplerianSet',
        'GANSS-ALM-ReducedKeplerianSet-ExtIEs',
        'GANSS-Auxiliary-Information',
        'GANSS-AuxInfoGANSS-ID1',
        'GANSS-AuxInfoGANSS-ID1-element',
        'GANSS-AuxInfoGANSS-ID1-element-ExtIEs',
        'GANSS-AuxInfoGANSS-ID3',
        'GANSS-AuxInfoGANSS-ID3-element',
        'GANSS-AuxInfoGANSS-ID3-element-ExtIEs',
        'GANSS-AuxInfoReq',
        'GANSS-BDSclockModel',
        'GANSS-BDSclockModel-ExtIEs',
        'GANSS-Clock-Model',
        'GANSS-CNAVclockModel',
        'GANSS-CNAVclockModel-ExtIEs',
        'GANSS-Common-Data',
        'GANSS-Common-Data-ExtIEs',
        'GANSS-CommonDataInfoReq',
        'GANSS-CommonDataInfoReq-ExtIEs',
        'GANSS-Data-Bit-Assistance',
        'GANSS-Data-Bit-Assistance-ExtIEs',
        'GANSS-DataBitAssistanceList',
        'GANSS-DataBitAssistanceItem',
        'GANSS-DataBitAssistanceItem-ExtIEs',
        'GANSS-DataBitAssistanceSgnList',
        'GANSS-DataBitAssistanceSgnItem',
        'GANSS-DataBitAssistanceSgnItem-ExtIEs',
        'GANSS-Data-Bit-Assistance-ReqItem',
        'GANSS-Data-Bit-Assistance-ReqItem-ExtIEs',
        'GANSS-Data-Bit-Assistance-ReqList',
        'GANSS-Data-Bit-Assistance-ReqList-ExtIEs',
        'GANSS-Delta-T',
        'GANSS-DeltaUT1',
        'GANSS-DeltaUT1-ExtIEs',
        'GANSS-Earth-Orientation-Parameters',
        'GANSS-Earth-Orientation-Parameters-ExtIEs',
        'GANSS-EarthOrientParaReq',
        'GANSS-GenericDataInfoReqList',
        'GANSS-GenericDataInfoReqItem',
        'GANSS-GenericDataInfoReqItem-ExtIEs',
        'GANSS-Generic-Data',
        'GANSS-Generic-DataItem',
        'GANSS-Generic-DataItem-ExtIEs',
        'GANSS-GLONASSclockModel',
        'GANSS-GLONASSclockModel-ExtIEs',
        'GANSS-ID',
        'GANSS-Information',
        'GANSS-Information-ExtIEs',
        'GANSS-Ionospheric-Model',
        'GANSS-Ionospheric-Model-ExtIEs',
        'GANSS-IonosphereRegionalStormFlags',
        'GANSS-IonosphereRegionalStormFlags-ExtIEs',
        'GANSS-KeplerianParametersAlm',
        'GANSS-KeplerianParametersAlm-ExtIEs',
        'GANSS-KeplerianParametersOrb',
        'GANSS-KeplerianParametersOrb-ExtIEs',
        'GANSS-NAVclockModel',
        'GANSS-NAVclockModel-ExtIEs',
        'GANSS-Navigation-Model-And-Time-Recovery',
        'GANSS-Navigation-Model-And-Time-Recovery-ExtIEs',
        'GANSS-NavModel-BDSKeplerianSet',
        'GANSS-NavModel-BDSKeplerianSet-ExtIEs',
        'GANSS-NavModel-CNAVKeplerianSet',
        'GANSS-NavModel-CNAVKeplerianSet-ExtIEs',
        'GANSS-NavModel-GLONASSecef',
        'GANSS-NavModel-GLONASSecef-ExtIEs',
        'GANSS-NavModel-NAVKeplerianSet',
        'GANSS-NavModel-NAVKeplerianSet-ExtIEs',
        'GANSS-NavModel-SBASecef',
        'GANSS-NavModel-SBASecef-ExtIEs',
        'GANSS-Orbit-Model',
        'GANSS-Real-Time-Integrity',
        'GANSS-RealTimeInformationItem',
        'GANSS-RealTimeInformationItem-ExtIEs',
        'GANSS-RX-Pos',
        'GANSS-RX-Pos-ExtIEs',
        'GANSS-SatelliteClockModelItem',
        'GANSS-SatelliteClockModelItem-ExtIEs',
        'GANSS-SatelliteInformationKP',
        'GANSS-SatelliteInformationKPItem',
        'GANSS-SatelliteInformationKPItem-ExtIEs',
        'Ganss-Sat-Info-AddNavList',
        'Ganss-Sat-Info-AddNavList-ExtIEs',
        'GANSS-SAT-Info-Almanac-BDSkpList',
        'GANSS-SAT-Info-Almanac-BDS',
        'GANSS-SAT-Info-Almanac-BDS-ExtIEs',
        'GANSS-SAT-Info-Almanac-GLOkpList',
        'GANSS-SAT-Info-Almanac-GLOkp',
        'GANSS-SAT-Info-Almanac-GLOkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-MIDIkpList',
        'GANSS-SAT-Info-Almanac-MIDIkp',
        'GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-NAVkpList',
        'GANSS-SAT-Info-Almanac-NAVkp',
        'GANSS-SAT-Info-Almanac-NAVkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-REDkpList',
        'GANSS-SAT-Info-Almanac-REDkp',
        'GANSS-SAT-Info-Almanac-REDkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-SBASecefList',
        'GANSS-SAT-Info-Almanac-SBASecef',
        'GANSS-SAT-Info-Almanac-SBASecef-ExtIEs',
        'GANSS-Sat-Info-Nav',
        'GANSS-Sat-Info-Nav-ExtIEs',
        'GANSS-SBAS-ID',
        'GANSS-SBASclockModel',
        'GANSS-SBASclockModel-ExtIEs',
        'GANSS-Signal-ID',
        'GANSS-StatusHealth',
        'GANSS-Time-ID',
        'GANSS-Time-Model',
        'GANSS-Time-Model-ExtIEs',
        'GANSS-Transmission-Time',
        'GANSS-Transmission-Time-ExtIEs',
        'GANSS-UTC-Model',
        'GANSS-UTC-Model-ExtIEs',
        'GANSS-UTCmodelSet1',
        'GANSS-UTCmodelSet1-ExtIEs',
        'GANSS-UTCmodelSet2',
        'GANSS-UTCmodelSet2-ExtIEs',
        'GANSS-UTCmodelSet3',
        'GANSS-UTCmodelSet3-ExtIEs',
        'GANSS-UTCmodelSet4',
        'GANSS-UTCmodelSet4-ExtIEs',
        'GapLength',
        'GapDuration',
        'GenericTrafficCategory',
        'GPS-Almanac',
        'GPS-Almanac-ExtIEs',
        'GPS-Ionospheric-Model',
        'GPS-Ionospheric-Model-ExtIEs',
        'GPS-Information',
        'GPS-Information-Item',
        'GPS-RealTime-Integrity',
        'GPSBadSat-Info-RealTime-Integrity',
        'GPSBadSat-Info-RealTime-Integrity-ExtIEs',
        'GPS-NavigationModel-and-TimeRecovery',
        'GPS-NavandRecovery-Item',
        'GPS-NavandRecovery-Item-ExtIEs',
        'GPS-RX-POS',
        'GPS-RX-POS-ExtIEs',
        'GPS-Status-Health',
        'GPSTOW',
        'GPS-UTC-Model',
        'GPS-UTC-Model-ExtIEs',
        'HARQ-Info-for-E-DCH',
        'HARQ-MemoryPartitioning',
        'HARQ-MemoryPartitioning-Implicit',
        'HARQ-MemoryPartitioning-Implicit-ExtIEs',
        'HARQ-MemoryPartitioning-Explicit',
        'HARQ-MemoryPartitioning-Explicit-ExtIEs',
        'HARQ-MemoryPartitioningList',
        'HARQ-MemoryPartitioningInfoExtForMIMO',
        'HARQ-MemoryPartitioningItem',
        'HARQ-MemoryPartitioningItem-ExtIEs',
        'HARQ-Preamble-Mode',
        'HARQ-Process-Allocation-2ms-EDCH',
        'HARQ-Preamble-Mode-Activation-Indicator',
        'HSDPA-Capability',
        'HS-DSCHProvidedBitRate',
        'HS-DSCHProvidedBitRate-Item',
        'HS-DSCHProvidedBitRate-Item-ExtIEs',
        'HS-DSCHProvidedBitRateValue',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortion',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortion-Item',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortion-Item-ExtIEs',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR-Item',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR-Item-ExtIEs',
        'HS-DSCHRequiredPower',
        'HS-DSCHRequiredPower-Item',
        'HS-DSCHRequiredPower-Item-ExtIEs',
        'HS-DSCHRequiredPowerValue',
        'HS-DSCHRequiredPowerPerUEInformation',
        'HS-DSCHRequiredPowerPerUEInformation-Item',
        'HS-DSCHRequiredPowerPerUEInformation-Item-ExtIEs',
        'HS-DSCHRequiredPowerPerUEWeight',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortion',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortion-Item',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortion-Item-ExtIEs',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR-Item',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR-Item-ExtIEs',
        'HSDPA-Associated-PICH-Information',
        'HSDPA-PICH-Shared-with-PCH',
        'HSDPA-PICH-notShared-with-PCH',
        'HSDSCH-Common-System-InformationFDD',
        'HSDSCH-Common-System-InformationFDD-ExtIEs',
        'HSDSCH-Common-System-Information-ResponseFDD',
        'HSDSCH-Common-System-Information-ResponseFDD-ExtIEs',
        'HSDSCH-Common-Information',
        'HSDSCH-Common-Information-ExtIEs',
        'HSDSCH-FDD-Information',
        'HSDSCH-FDD-Information-ExtIEs',
        'HSDSCH-TDD-Information',
        'HSDSCH-TDD-Information-ExtIEs',
        'HSDSCH-Information-to-Modify',
        'HSDSCH-Information-to-Modify-ExtIEs',
        'HSDSCH-MACdFlow-Specific-InfoList-to-Modify',
        'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify',
        'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs',
        'HSDSCH-MACdPDUSizeFormat',
        'HSDSCH-MACdPDU-SizeCapability',
        'HSDSCH-Information-to-Modify-Unsynchronised',
        'HSDSCH-Information-to-Modify-Unsynchronised-ExtIEs',
        'HSDSCH-FDD-Information-Response',
        'HSDSCH-FDD-Information-Response-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Information',
        'HS-DSCH-FDD-Secondary-Serving-Information-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Information-Response',
        'HS-DSCH-first-DRX-ycle-FACH',
        'HS-DSCH-first-Rx-burst-FACH',
        'HS-DSCH-FDD-Secondary-Serving-Information-Respons-ExtIEs',
        'HS-DSCH-Second-DRX-Cycle-FACH',
        'HS-DSCH-second-Rx-burst-FACH',
        'HS-DSCH-Secondary-Serving-Information-To-Modify',
        'HS-DSCH-Secondary-Serving-Information-To-Modify-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised',
        'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Update-Information',
        'HS-DSCH-FDD-Secondary-Serving-Update-Information-ExtIEs',
        'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response',
        'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response-ExtIEs',
        'HS-DSCH-Secondary-Serving-cell-change-choice',
        'HS-Secondary-Serving-cell-change-successful',
        'HS-Secondary-Serving-cell-change-successful-ExtIEs',
        'HS-Secondary-Serving-cell-change-unsuccessful',
        'HS-Secondary-Serving-cell-change-unsuccessful-ExtIEs',
        'HS-DSCH-Secondary-Serving-Remove',
        'HSDSCH-Paging-System-InformationFDD',
        'HSDSCH-Paging-System-InformationFDD-ExtIEs',
        'HSDSCH-Paging-System-Information-ResponseFDD',
        'HSDSCH-Paging-System-Information-ResponseList',
        'HSDSCH-Paging-System-Information-ResponseList-ExtIEs',
        'HSDSCH-TDD-Information-Response',
        'HSDSCH-TDD-Information-Response-ExtIEs',
        'HSDSCH-MACdFlow-Specific-InformationResp',
        'HSDSCH-MACdFlow-Specific-InformationResp-Item',
        'HSDSCH-MACdFlow-Specific-InformationRespItem-ExtIEs',
        'HSDSCH-MACdFlows-Information',
        'HSDSCH-MACdFlows-Information-ExtIEs',
        'HSDSCH-MACdFlow-Specific-InfoList',
        'HSDSCH-MACdFlow-Specific-InfoItem',
        'HSDSCH-MACdFlow-Specific-InfoItem-ExtIEs',
        'HSDSCH-MACdFlows-to-Delete',
        'HSDSCH-MACdFlows-to-Delete-Item',
        'HSDSCH-MACdFlows-to-Delete-Item-ExtIEs',
        'HSDSCH-TBSizeTableIndicator',
        'HSSCCH-PowerOffset',
        'HSDSCH-Initial-Capacity-Allocation',
        'HSDSCH-Initial-Capacity-AllocationItem',
        'HSDSCH-Initial-Capacity-AllocationItem-ExtIEs',
        'HSDSCH-InitialWindowSize',
        'HSDSCH-PreconfigurationInfo',
        'HSDSCH-PreconfigurationInfo-ExtIEs',
        'Additional-EDCH-Preconfiguration-Information',
        'Additional-EDCH-Preconfiguration-Information-ItemIEs',
        'Additional-EDCH-Preconfiguration-Information-ItemIEs-ExtIEs',
        'HSDSCH-PreconfigurationSetup',
        'HSDSCHPreconfigurationSetup-ExtIEs',
        'HS-SCCH-PreconfiguredCodes',
        'HS-SCCH-PreconfiguredCodesItem',
        'HS-SCCH-PreconfiguredCodesItem-ExtIEs',
        'HS-SCCH-CodeNumber',
        'HSSCCH-Specific-InformationRespListFDD',
        'HSSCCH-Codes',
        'HSSCCH-Specific-InformationRespItemFDD-ExtIEs',
        'HSSCCH-Specific-InformationRespListTDD',
        'HSSCCH-Specific-InformationRespItemTDD',
        'HSSCCH-Specific-InformationRespItemTDD-ExtIEs',
        'HSSCCH-Specific-InformationRespListTDDLCR',
        'HSSCCH-Specific-InformationRespItemTDDLCR',
        'HSSCCH-Specific-InformationRespItemTDDLCR-ExtIEs',
        'HSSCCH-Specific-InformationRespListTDD768',
        'HSSCCH-Specific-InformationRespItemTDD768',
        'HSSCCH-Specific-InformationRespItemTDD768-ExtIEs',
        'HSSICH-Info',
        'HSSICH-Info-ExtIEs',
        'HSSICH-InfoLCR',
        'HSSICH-Info-LCR-ExtIEs',
        'HSSICH-Info768',
        'HSSICH-Info-768-ExtIEs',
        'HS-SICH-Reception-Quality-Value',
        'HS-SICH-Reception-Quality-Value-ExtIEs',
        'HS-SICH-failed',
        'HS-SICH-missed',
        'HS-SICH-total',
        'HS-SICH-Reception-Quality-Measurement-Value',
        'HSDSCH-MACdFlow-ID',
        'HSDSCH-RNTI',
        'HS-PDSCH-FDD-Code-Information',
        'HS-PDSCH-FDD-Code-Information-ExtIEs',
        'HS-PDSCH-Start-code-number',
        'HS-SCCH-ID',
        'HS-SICH-ID',
        'HS-SCCH-FDD-Code-Information',
        'HS-SCCH-FDD-Code-List',
        'HS-SCCH-FDD-Code-Information-Item',
        'HSSCCH-CodeChangeIndicator',
        'HSSCCH-Code-Change-Grant',
        'HS-PDSCH-Code-Change-Indicator',
        'HS-PDSCH-Code-Change-Grant',
        'HSDSCH-Configured-Indicator',
        'HS-DSCH-Serving-Cell-Change-Info',
        'HS-DSCH-Serving-Cell-Change-Info-ExtIEs',
        'HS-DSCH-Serving-Cell-Change-Info-Response',
        'HS-DSCH-serving-cell-informationResponse-ExtIEs',
        'HS-DSCH-serving-cell-choice',
        'HS-serving-cell-change-successful',
        'HS-serving-cell-change-successful-ExtIEs',
        'HS-serving-cell-change-unsuccessful',
        'HS-serving-cell-change-unsuccessful-ExtIEs',
        'HS-DSCH-DRX-Cycle-FACH',
        'HS-DSCH-RX-Burst-FACH',
        'HS-SCCH-DRX-Cycle-FACH',
        'HS-SCCH-RX-Burst-FACH',
        'HSDSCH-FDD-Update-Information',
        'HSDSCH-FDD-Update-Information-ExtIEs',
        'HSDSCH-TDD-Update-Information',
        'HSDSCH-TDD-Update-Information-ExtIEs',
        'HSPDSCH-Code-Index',
        'HSPDSCH-First-Code-Index',
        'HSPDSCH-Second-Code-Index',
        'HSPDSCH-Second-Code-Support',
        'HSDPA-Associated-PICH-InformationLCR',
        'HSDPA-PICH-notShared-with-PCHLCR',
        'HSDPA-PICH-notShared-with-PCHLCR-ExtIEs',
        'HSDSCH-Common-System-InformationLCR',
        'HSDSCH-Common-System-InformationLCR-ExtIEs',
        'HSDSCH-Common-System-Information-ResponseLCR',
        'HSDSCH-Common-System-Information-ResponseLCR-ExtIEs',
        'HSDSCH-Common-InformationLCR',
        'HSDSCH-Common-InformationLCR-ExtIEs',
        'HSDSCH-Paging-System-InformationLCR',
        'HSDSCH-Paging-System-InformationLCR-ExtIEs',
        'HSDSCH-Paging-System-Information-ResponseLCR',
        'HSDSCH-Paging-System-Information-ResponseListLCR',
        'HSDSCH-Paging-System-Information-ResponseListLCR-ExtIEs',
        'HS-SCCH-ID-LCR',
        'HSSCCH-Specific-InformationRespListLCR',
        'HSSCCH-Specific-InformationRespItemLCR',
        'HSSCCH-Specific-InformationRespItemLCR-ExtIEs',
        'HS-DSCH-Semi-PersistentScheduling-Information-LCR',
        'HS-DSCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        'Transport-Block-Size-List-LCR',
        'Transport-Block-Size-Item-LCR',
        'Transport-Block-Size-Item-LCR-ExtIEs',
        'Transport-Block-Size-maping-Index-LCR',
        'Transport-Block-Size-Index-LCR',
        'Repetition-Period-List-LCR',
        'Repetition-Period-Item-LCR',
        'Repetition-Period-Item-LCR-ExtIEs',
        'RepetitionPeriodIndex',
        'SPS-Reservation-Indicator',
        'HS-DSCH-SPS-Operation-Indicator',
        'LogicalChannellevel',
        'PriorityQueuelevel',
        'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR',
        'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR',
        'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        'HS-SICH-InformationList-for-HS-DSCH-SPS',
        'HS-SICH-InformationItem-for-HS-DSCH-SPS',
        'HS-SICH-InformationItem-for-HS-DSCH-SPS-ExtIEs',
        'HS-SICH-Mapping-Index',
        'HS-SICH-Type',
        'HS-SCCH-Associated-HS-SICH',
        'Non-HS-SCCH-Associated-HS-SICH',
        'Non-HS-SCCH-Aassociated-HS-SICH-ID',
        'Initial-HS-PDSCH-SPS-Resource',
        'Initial-HS-PDSCH-SPS-Resource-ExtIEs',
        'HS-DSCH-TimeslotResourceLCR',
        'ModulationSPS-LCR',
        'Number-of-Processes-for-HS-DSCH-SPS',
        'Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'Non-HS-SCCH-Associated-HS-SICH-InformationList',
        'Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext',
        'Non-HS-SCCH-Associated-HS-SICH-InformationItem',
        'Non-HS-SCCH-Associated-HS-SICH-InformationItem-ExtIEs',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationList',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationItem',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationItem-ExtIEs',
        'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext',
        'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqstItem',
        'MIMO-ReferenceSignal-InformationListLCR',
        'HSSICH-ReferenceSignal-InformationLCR',
        'HSSICH-ReferenceSignal-InformationLCR-ExtIEs',
        'HSSICH-ReferenceSignal-InformationModifyLCR',
        'HSSICH-ReferenceSignal-InformationModifyLCR-ExtIEs',
        'HS-DPCCH-transmission-continuation-backoff',
        'IB-OC-ID',
        'IB-SG-DATA',
        'IB-SG-POS',
        'IB-SG-REP',
        'IB-Type',
        'IMB-Parameters',
        'IMB-Parameters-ExtIEs',
        'BCH-Parameters',
        'BCH-ParametersItem-ExtIEs',
        'Inactivity-Threshold-for-UE-DRX-Cycle',
        'Inactivity-Threshold-for-UE-DTX-Cycle2',
        'Inactivity-Threshold-for-UE-Grant-Monitoring',
        'InformationReportCharacteristics',
        'InformationReportCharacteristicsType-ReportPeriodicity',
        'InformationReportCharacteristicsType-OnModification',
        'InformationReportCharacteristicsType-OnModification-ExtIEs',
        'InformationThresholds',
        'InformationExchangeID',
        'InformationType',
        'Information-Type-ExtIEs',
        'Information-Type-Item',
        'Initial-DL-DPCH-TimingAdjustment-Allowed',
        'InnerLoopDLPCStatus',
        'IPDL-Indicator',
        'IPDL-FDD-Parameters',
        'IPDLFDDParameter-ExtIEs',
        'IPDL-TDD-Parameters',
        'IPDL-TDD-Parameters-LCR',
        'IPMulticastIndication',
        'IPMulticastIndication-ExtIEs',
        'IPMulticastDataBearerIndication',
        'BurstModeParams',
        'IPDLTDDParameter-ExtIEs',
        'IPDLTDDParameterLCR-ExtIEs',
        'IdleIntervalInformation',
        'In-Sync-Information-LCR',
        'LimitedPowerIncrease',
        'Local-Cell-ID',
        'LTGI-Presence',
        'LCRTDD-Uplink-Physical-Channel-Capability',
        'LCRTDD-Uplink-Physical-Channel-Capability-ExtIEs',
        'MAC-DTX-Cycle-2ms',
        'MAC-DTX-Cycle-10ms',
        'MAC-ehs-Reset-Timer',
        'MACdPDU-Size',
        'MAC-PDU-SizeExtended',
        'MAC-Inactivity-Threshold',
        'MACdPDU-Size-Indexlist',
        'MACdPDU-Size-IndexItem',
        'MACdPDU-Size-IndexItem-ExtIEs',
        'MACdPDU-Size-Indexlist-to-Modify',
        'MACdPDU-Size-IndexItem-to-Modify',
        'MACdPDU-Size-IndexItem-to-Modify-ExtIEs',
        'MACesGuaranteedBitRate',
        'MACes-Maximum-Bitrate-LCR',
        'MACeReset-Indicator',
        'MAChsGuaranteedBitRate',
        'MAChsReorderingBufferSize-for-RLC-UM',
        'MAC-hsWindowSize',
        'MAChsResetScheme',
        'MaximumDL-PowerCapability',
        'Max-Bits-MACe-PDU-non-scheduled',
        'Max-EDCH-Resource-Allocation-for-CCCH',
        'Max-EDCH-Resource-Allocation-for-CCCH-Extension',
        'Max-Period-for-Collision-Resolution',
        'Max-TB-Sizes',
        'Max-TB-Sizes-ExtIEs',
        'Maximum-Number-of-Retransmissions-For-E-DCH',
        'Maximum-Target-ReceivedTotalWideBandPower-LCR',
        'MaximumTransmissionPower',
        'MaxNrOfUL-DPDCHs',
        'MaxPRACH-MidambleShifts',
        'Max-Set-E-DPDCHs',
        'Max-UE-DTX-Cycle',
        'MBMS-Capability',
        'MeasurementFilterCoefficient',
        'MeasurementID',
        'Measurement-Power-Offset',
        'MeasurementRecoveryBehavior',
        'MeasurementRecoveryReportingIndicator',
        'MeasurementRecoverySupportIndicator',
        'MessageStructure',
        'MessageStructure-ExtIEs',
        'MICH-CFN',
        'MICH-Mode',
        'MidambleConfigurationLCR',
        'MidambleConfigurationBurstType1And3',
        'MidambleConfigurationBurstType2',
        'MidambleShiftAndBurstType',
        'MidambleShiftLong',
        'MidambleShiftShort',
        'MidambleShiftLCR',
        'MidambleAllocationMode',
        'MidambleShiftLCR-ExtIEs',
        'MidambleShiftAndBurstType768',
        'MidambleConfigurationBurstType2-768',
        'MidambleShiftShort768',
        'MIMO-ActivationIndicator',
        'MIMO-Capability',
        'MIMO-Mode-Indicator',
        'MIMO-N-M-Ratio',
        'MIMO-PilotConfiguration',
        'MIMO-PilotConfigurationExtension',
        'MIMO-PowerOffsetForS-CPICHCapability',
        'MIMO-withfourtransmitantennas-ActivationIndicator',
        'MIMO-withfourtransmitantennas-Mode-Indicator',
        'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator',
        'DualStream-MIMO-withfourtransmitantennas-Mode-Indicator',
        'MIMO-withfourtransmitantennas-PilotConfiguration',
        'MIMO-withfourtransmitantennas-SCPICH',
        'MIMO-withfourtransmitantennas-SCPICH-Configuration',
        'MIMO-withfourtransmitantennas-SCPICH-Configuration-Item-ExtIEs',
        'PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas',
        'MinimumDL-PowerCapability',
        'MinimumReducedE-DPDCH-GainFactor',
        'MinSpreadingFactor',
        'Modification-Period',
        'ModifyPriorityQueue',
        'Modulation',
        'MinUL-ChannelisationCodeLength',
        'MultiplexingPosition',
        'MAChs-ResetIndicator',
        'ModulationMBSFN',
        'MBSFN-CPICH-secondary-CCPCH-power-offset',
        'ModulationPO-MBSFN',
        'MBSFN-Only-Mode-Indicator',
        'MBSFN-Only-Mode-Capability',
        'Multicarrier-Number',
        'MultipleFreq-HARQ-MemoryPartitioning-InformationList',
        'MultipleFreq-HARQ-MemoryPartitioning-InformationItem',
        'MultipleFreq-HARQ-MemoryPartitioning-InformationItem-ExtIEs',
        'MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR',
        'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR',
        'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR-ExtIEs',
        'Multi-Cell-Capability',
        'Multi-Cell-Capability-Info',
        'Multi-Cell-Capability-Info-ExtIEs',
        'Multicell-EDCH-Information',
        'Multicell-EDCH-InformationItem',
        'Multicell-EDCH-InformationItemIEs',
        'Multicell-EDCH-InformationItemIEs-ExtIEs',
        'Multicell-EDCH-RL-Specific-Information',
        'Multicell-EDCH-RL-Specific-InformationItem',
        'Multicell-EDCH-RL-Specific-InformationItemIEs',
        'Multicell-EDCH-RL-Specific-InformationItemIEs-ExtIEs',
        'Multicell-EDCH-Restriction',
        'MIMO-SFMode-For-HSPDSCHDualStream',
        'Multi-Carrier-EDCH-Info',
        'Multi-Carrier-EDCH-Info-ExtIEs',
        'Multicarrier-EDCH-Transport-Bearer-Mode',
        'Dual-Cell-EDCH-Enhancements-Information',
        'Dual-Cell-EDCH-Enhancements-Information-ExtIEs',
        'HS-SCCH-DRX-InformationFDD',
        'HS-SCCH-DRX-InformationFDD-ExtIEs',
        'Multi-Carrier-EDCH-Information',
        'Multi-Carrier-EDCH-LCR-InformationItem',
        'Multi-Carrier-EDCH-LCR-InformationItem-ExtIEs',
        'SNPL-Carrier-Group-Indicator',
        'Multi-Carrier-EDCH-MACdFlows-Information-TDD',
        'Multi-Carrier-EDCH-MACdFlows-Specific-Info',
        'Multi-Carrier-EDCH-MACdFlows-Specific-Info-ExtIEs',
        'Multi-Carrier-EDCH-Reconfigure',
        'Multi-Carrier-EDCH-Reconfigure-ExtIEs',
        'Continue-Setup-Change-Multi-Carrier-EDCH',
        'Multi-Carrier-EDCH-Change-Info',
        'Multi-Carrier-EDCH-Change-Info-ExtIEs',
        'Multi-Carrier-EDCH-Information-Removal-List',
        'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs',
        'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs-ExtIEs',
        'Multi-Carrier-EDCH-Information-Response',
        'Multi-Carrier-EDCH-LCR-Information-ResponseItem',
        'Multi-Carrier-EDCH-LCR-Information-ResponseItem-ExtIEs',
        'Multiflow-Reconfiguration',
        'Multiflow-Information',
        'Multiflow-Information-To-Modify',
        'Multiflow-Information-ExtIEs',
        'Multiflow-Information-To-Modify-ExtIEs',
        'Multiflow-RepetitionFactors',
        'Multiflow-RepetitionFactors-ExtIEs',
        'Multiflow-Stop',
        'Multiflow-Role',
        'Multiflow-MIMO',
        'Multiflow-Timing',
        'Multiflow-OrdinalNumberOfFrequency',
        'MU-MIMO-Capability-ContainerLCR',
        'MU-MIMO-InformationLCR',
        'Standalone-Midamble-Channel-Information-RequestLCR',
        'Standalone-Midamble-Channel-Information',
        'Standalone-Midamble-Configuratnion',
        'Standalone-MidambleShift',
        'Standalone-Midamble-RepetitionPeriod',
        'Standalone-Midamble-Offset',
        'ReferenceBeta',
        'Standalone-Midamble-Channel-Information-ExtIEs',
        'MU-MIMO-InformationLCR-ExtIEs',
        'MU-MIMO-Information-Response',
        'MU-MIMO-Information-Response-ExtIEs',
        'MU-MIMO-Information-To-ReconfigureLCR',
        'MU-MIMO-Information-To-Modify',
        'MU-MIMO-Information-To-Modify-ExtIEs',
        'MU-MIMO-IndicatorLCR',
        'MU-MIMO-Usage-IndicatorLCR',
        'Nack-Power-Offset',
        'NCyclesPerSFNperiod',
        'NRepetitionsPerCyclePeriod',
        'N-INSYNC-IND',
        'N-OUTSYNC-IND',
        'N-PROTECT',
        'NeighbouringCellMeasurementInformation',
        'NodeB-Triggered-HSDPCCH-Transmission-Information',
        'NodeB-Triggered-HSDPCCH-Transmission-Information-ExtIEs',
        'Extension-neighbouringCellMeasurementInformation',
        'Extension-neighbouringCellMeasurementInformationIE',
        'NeighbouringFDDCellMeasurementInformation',
        'NeighbouringFDDCellMeasurementInformationItem-ExtIEs',
        'NeighbouringTDDCellMeasurementInformation',
        'NeighbouringTDDCellMeasurementInformationItem-ExtIEs',
        'NeighbouringTDDCellMeasurementInformationLCR',
        'NeighbouringTDDCellMeasurementInformationLCRItem-ExtIEs',
        'NeighbouringTDDCellMeasurementInformation768',
        'NeighbouringTDDCellMeasurementInformation768Item-ExtIEs',
        'Non-rectangular-resource-allocation-indicator',
        'Non-rectangular-resource-timeslot-set',
        'NonCellSpecificTxDiversity',
        'Non-Serving-RL-Preconfig-Setup',
        'Non-Serving-RL-Preconfig-Setup-ExtIEs',
        'Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup',
        'New-non-serving-RL-setup-selection',
        'Non-Serving-RL-Preconfig-Info',
        'Non-Serving-RL-Preconfig-Info-ExtIEs',
        'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList',
        'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList-ExtIEs',
        'NI-Information',
        'Notification-Indicator',
        'NodeB-CommunicationContextID',
        'NormalAndDiversityPrimaryCPICHContainer',
        'NormalAndDiversityPrimaryCPICHContainer-ExtIEs',
        'NotificationIndicatorLength',
        'NumberOfReportedCellPortions',
        'NumberOfReportedCellPortionsLCR',
        'Number-of-PCCH-transmission',
        'NSubCyclesPerCyclePeriod',
        'N-E-UCCH',
        'N-E-UCCHLCR',
        'Number-Of-Supported-Carriers',
        'NumHS-SCCH-Codes',
        'NoOfTargetCellHS-SCCH-Order',
        'OrdinalNumberOfFrequency',
        'Out-of-Sychronization-Window',
        'One-level-DRX',
        'One-level-DRX-ExtIEs',
        'PagingIndicatorLength',
        'Paging-MACFlow-ID',
        'PayloadCRC-PresenceIndicator',
        'PCCPCH-Power',
        'PDSCH-ID',
        'PDSCH-ID768',
        'PDSCHSet-ID',
        'PICH-Mode',
        'PICH-Power',
        'Paging-MACFlows-to-DeleteFDD',
        'Paging-MACFlows-to-DeleteFDD-Item',
        'Paging-MACFlows-to-DeleteFDD-Item-ExtIEs',
        'Paging-MACFlow-Specific-Information',
        'Paging-MAC-Flow-Specific-Information-Item',
        'Paging-MAC-Flow-Specific-Information-Item-ExtIEs',
        'Paging-MACFlow-PriorityQueue-Information',
        'Paging-MACFlow-PriorityQueue-Item',
        'Paging-MACFlow-PriorityQueue-Item-ExtIEs',
        'Pattern-Sequence-Identifier',
        'PhysicalChannelID-for-CommonERNTI-RequestedIndicator',
        'PLCCHsequenceNumber',
        'PLCCHinformation',
        'PLCCHinformation-ExtIEs',
        'Possible-Secondary-Serving-Cell-List',
        'Possible-Secondary-Serving-Cell',
        'Possible-Secondary-Serving-Cell-ExtIEs',
        'PowerAdjustmentType',
        'PowerOffset',
        'PowerOffsetForSecondaryCPICHforMIMO',
        'PowerRaiseLimit',
        'PRACH-Midamble',
        'PRC',
        'PRCDeviation',
        'PrecodingWeightSetRestriction',
        'Precoder-Weight-Set-Restriction',
        'PreambleSignatures',
        'PreambleThreshold',
        'PredictedSFNSFNDeviationLimit',
        'PredictedTUTRANGPSDeviationLimit',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PrimaryAndSecondaryCPICHContainer',
        'PrimaryAndSecondaryCPICHContainer-ExtIEs',
        'PrimaryCPICH-Power',
        'Primary-CPICH-Usage-for-Channel-Estimation',
        'PrimaryScramblingCode',
        'PriorityLevel',
        'Priority-Queue-Information-for-Enhanced-FACH-PCH',
        'Priority-Queue-Information-for-Enhanced-FACH-PCH-ExtIEs',
        'PriorityQueue-Id',
        'PriorityQueue-InfoList',
        'PriorityQueue-InfoItem',
        'PriorityQueue-InfoItem-ExtIEs',
        'PriorityQueue-InfoList-to-Modify',
        'PriorityQueue-InfoItem-to-Add',
        'PriorityQueue-InfoItem-to-Add-ExtIEs',
        'PriorityQueue-InfoItem-to-Modify',
        'PriorityQueue-InfoItem-to-Modify-ExtIEs',
        'PriorityQueue-InfoList-to-Modify-Unsynchronised',
        'PriorityQueue-InfoItem-to-Modify-Unsynchronised',
        'PriorityQueue-InfoItem-to-Modify-Unsynchronised-ExtIEs',
        'PrimaryCCPCH-RSCP',
        'PrimaryCCPCH-RSCP-Delta',
        'PropagationDelay',
        'PRXdes-base',
        'SCH-TimeSlot',
        'PunctureLimit',
        'PUSCH-ID',
        'UE-Selected-MBMS-Service-Information',
        'Selected-MBMS-Service',
        'Selected-MBMS-Service-ExtIEs',
        'Selected-MBMS-Service-List',
        'Selected-MBMS-Service-Item',
        'Selected-MBMS-Service-Item-ExtIEs',
        'Selected-MBMS-Service-TimeSlot-Information-LCR',
        'MBMS-Service-TDM-Information',
        'MBMS-Service-TDM-Information-ExtIEs',
        'PUSCHSet-ID',
        'Paging-MACFlow-Specific-InformationLCR',
        'Paging-MAC-Flow-Specific-Information-ItemLCR',
        'Paging-MAC-Flow-Specific-Information-ItemLCR-ExtIEs',
        'Paging-MACFlows-to-DeleteLCR',
        'Paging-MACFlows-to-DeleteLCR-Item',
        'Paging-MACFlows-to-DeleteLCR-Item-ExtIEs',
        'Process-Memory-Size',
        'Per-HARQ-Activiation-and-Deactiviation',
        'Per-HARQ-Activiation-and-Deactiviation-ExtIEs',
        'QE-Selector',
        'RACH-Measurement-Result',
        'RACH-SlotFormat',
        'RACH-SubChannelNumbers',
        'RL-Specific-DCH-Info',
        'RL-Specific-DCH-Info-Item',
        'RL-Specific-DCH-Info-Item-ExtIEs',
        'RL-Specific-E-DCH-Info',
        'RL-Specific-E-DCH-Info-Item-ExtIEs',
        'RL-Specific-E-DCH-Information',
        'RL-Specific-E-DCH-Information-Item',
        'RL-Specific-E-DCH-Information-Item-ExtIEs',
        'Range-Correction-Rate',
        'Reference-ReceivedTotalWideBandPower',
        'Reference-ReceivedTotalWideBandPowerReporting',
        'Reference-ReceivedTotalWideBandPowerSupportIndicator',
        'ReferenceClockAvailability',
        'ReferenceSFNoffset',
        'Reference-E-TFCI-Information',
        'Reference-E-TFCI-Information-Item',
        'Reference-E-TFCI-Information-Item-ExtIEs',
        'Reference-E-TFCI-PO',
        'RepetitionLength',
        'RepetitionPeriod',
        'RepetitionNumber0',
        'RepetitionNumber1',
        'RefTFCNumber',
        'ReportCharacteristics',
        'Extension-ReportCharacteristics',
        'Extension-ReportCharacteristicsIE',
        'ReportCharacteristicsType-EventA',
        'ReportCharacteristicsType-EventA-ExtIEs',
        'ReportCharacteristicsType-EventB',
        'ReportCharacteristicsType-EventB-ExtIEs',
        'ReportCharacteristicsType-EventC',
        'ReportCharacteristicsType-EventC-ExtIEs',
        'ReportCharacteristicsType-EventD',
        'ReportCharacteristicsType-EventD-ExtIEs',
        'ReportCharacteristicsType-EventE',
        'ReportCharacteristicsType-EventE-ExtIEs',
        'ReportCharacteristicsType-EventF',
        'ReportCharacteristicsType-EventF-ExtIEs',
        'ReportCharacteristicsType-OnModification',
        'ReportCharacteristicsType-OnModification-ExtIEs',
        'ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold',
        'Extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold',
        'Extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThresholdIE',
        'EDCH-RACH-Report-IncrDecrThres',
        'EDCH-RACH-Report-IncrDecrThres-ExtIEs',
        'Granted-EDCH-RACH-Resources-Value',
        'Denied-EDCH-RACH-Resources-Value',
        'ReportCharacteristicsType-MeasurementThreshold',
        'Extension-ReportCharacteristicsType-MeasurementThreshold',
        'Extension-ReportCharacteristicsType-MeasurementThresholdIE',
        'EDCH-RACH-Report-ThresholdInformation',
        'EDCH-RACH-Report-ThresholdInformation-ExtIEs',
        'ReportCharacteristicsType-ScaledMeasurementChangeTime',
        'MeasurementChangeTime-Scaledmsec',
        'ReportCharacteristicsType-ScaledMeasurementHysteresisTime',
        'MeasurementHysteresisTime-Scaledmsec',
        'ReportCharacteristicsType-ReportPeriodicity',
        'ReportPeriodicity-Scaledmsec',
        'ReportPeriodicity-Scaledmin',
        'ReportPeriodicity-Scaledhour',
        'ResourceOperationalState',
        'RL-ID',
        'RL-Set-ID',
        'RLC-Mode',
        'DL-RLC-PDU-Size-Format',
        'Round-Trip-Time-IncrDecrThres',
        'RNC-ID',
        'Round-Trip-Time-Value',
        'RSCP-Value',
        'RSCP-Value-IncrDecrThres',
        'Received-total-wide-band-power-For-CellPortion-Value',
        'Received-total-wide-band-power-For-CellPortion-Value-Item',
        'Received-total-wide-band-power-For-CellPortion-Value-Item-ExtIEs',
        'Received-total-wide-band-power-For-CellPortion-ValueLCR',
        'Received-total-wide-band-power-For-CellPortion-ValueLCR-Item',
        'Received-total-wide-band-power-For-CellPortion-ValueLCR-Item-ExtIEs',
        'Received-total-wide-band-power-Value',
        'Received-total-wide-band-power-Value-IncrDecrThres',
        'Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value',
        'Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value-Item',
        'Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value-Item-ExtIEs',
        'Received-Scheduled-EDCH-Power-Share-Value',
        'RSEPS-Value-IncrDecrThres',
        'RSEPS-Value',
        'RequestedDataValueInformation',
        'InformationAvailable',
        'InformationAvailableItem-ExtIEs',
        'InformationnotAvailable',
        'RequestedDataValue',
        'RequestedDataValue-ExtIEs',
        'Rx-Timing-Deviation-Value',
        'Rx-Timing-Deviation-Value-LCR',
        'Rx-Timing-Deviation-Value-768',
        'Rx-Timing-Deviation-Value-384-ext',
        'RefBeta',
        'RTWP-ReportingIndicator',
        'RTWP-CellPortion-ReportingIndicator',
        'AdjustmentPeriod',
        'E-DPCCH-Power-Boosting-Capability',
        'SAT-ID',
        'SAT-Info-Almanac',
        'SAT-Info-Almanac-Item',
        'SAT-Info-Almanac-Item-ExtIEs',
        'SAT-Info-Almanac-ExtList',
        'SAT-Info-Almanac-ExtItem',
        'SAT-Info-Almanac-ExtItemIEs',
        'SAT-Info-DGPSCorrections',
        'SAT-Info-DGPSCorrections-Item',
        'SAT-Info-DGPSCorrections-Item-ExtIEs',
        'SATInfo-RealTime-Integrity',
        'SAT-Info-RealTime-Integrity-Item',
        'SAT-Info-RealTime-Integrity-Item-ExtIEs',
        'ScaledAdjustmentRatio',
        'MaxAdjustmentStep',
        'SchedulingInformation',
        'SecondaryServingCells',
        'SecondaryServingCellsItem',
        'SecondaryServingCellsItem-ExtIEs',
        'Secondary-UL-Frequency-Activation-State',
        'SchedulingPriorityIndicator',
        'SID',
        'ScramblingCodeNumber',
        'Secondary-CPICH-Information-Change',
        'SecondaryCCPCH-SlotFormat',
        'Secondary-CCPCH-SlotFormat-Extended',
        'Segment-Type',
        'Serving-E-DCH-RL-ID',
        'Serving-E-DCH-RL-in-this-NodeB',
        'Serving-E-DCH-RL-in-this-NodeB-ExtIEs',
        'SetsOfHS-SCCH-Codes',
        'SetsOfHS-SCCH-CodesItem',
        'SetsOfHS-SCCH-CodesItem-ExtIEs',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH',
        'SFN',
        'SFNSFN-FDD',
        'SFNSFN-TDD',
        'SFNSFN-TDD768',
        'SFNSFNChangeLimit',
        'SFNSFNDriftRate',
        'SFNSFNDriftRateQuality',
        'SFNSFNMeasurementThresholdInformation',
        'SFNSFNMeasurementThresholdInformation-ExtIEs',
        'SFNSFNMeasurementValueInformation',
        'SFNSFNMeasurementValueInformationItem-ExtIEs',
        'SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        'UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        'SFNSFNQuality',
        'ShutdownTimer',
        'SIB-Originator',
        'SIR-Error-Value',
        'SFNSFNTimeStampInformation',
        'SFNSFNTimeStamp-TDD',
        'SFNSFNTimeStamp-ExtIEs',
        'SFNSFNValue',
        'Single-Stream-MIMO-ActivationIndicator',
        'Single-Stream-MIMO-Capability',
        'Single-Stream-MIMO-Mode-Indicator',
        'SIR-Error-Value-IncrDecrThres',
        'SIR-Value',
        'SIR-Value-IncrDecrThres',
        'SignallingBearerRequestIndicator',
        'SixtyfourQAM-UsageAllowedIndicator',
        'SixtyfourQAM-DL-UsageIndicator',
        'SixtyfourQAM-DL-Capability',
        'SixtyfourQAM-DL-MIMO-Combined-Capability',
        'SignatureSequenceGroupIndex',
        'SixteenQAM-UL-Capability',
        'SixteenQAM-UL-Operation-Indicator',
        'SixtyfourQAM-UL-Operation-Indicator',
        'SNPL-Reporting-Type',
        'Soffset',
        'SpecialBurstScheduling',
        'Start-Of-Audit-Sequence-Indicator',
        'Status-Flag',
        'STTD-Indicator',
        'SSDT-SupportIndicator',
        'Sub-Frame-Number',
        'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order',
        'SyncCase',
        'SYNCDlCodeId',
        'SyncFrameNumber',
        'SynchronisationReportCharacteristics',
        'SynchronisationReportCharacteristics-ExtIEs',
        'SynchronisationReportCharactThreExc',
        'SynchronisationReportCharactThreInfoItem',
        'SynchronisationReportCharactThreInfoItem-ExtIEs',
        'SynchronisationReportCharactCellSyncBurstInfoItem',
        'SynchronisationReportCharactCellSyncBurstInfoItem-ExtIEs',
        'SyncDLCodeIdThreInfoLCR',
        'SyncDLCodeIdThreInfoList',
        'SyncDLCodeIdThreInfoList-ExtIEs',
        'SyncDLCodeInfoListLCR',
        'SyncDLCodeInfoItemLCR',
        'SyncDLCodeInfoItem-LCR-ExtIEs',
        'SDPCCH-PowerOffsetInformation',
        'SynchronisationReportCharacteristicsType',
        'SynchronisationReportType',
        'Semi-PersistentScheduling-CapabilityLCR',
        'T1',
        'T321',
        'T333',
        'T-Cell',
        'T-RLFAILURE',
        'T-PROTECT',
        'T-SYNC',
        'TDD-AckNack-Power-Offset',
        'TDD-ChannelisationCode',
        'Puncturing-Handling-in-First-Rate-Matching-Stage',
        'TDD-ChannelisationCodeLCR',
        'TDD-ChannelisationCodeLCR-ExtIEs',
        'TDD-ChannelisationCode768',
        'TDD-DL-Code-Information',
        'TDD-DL-Code-InformationItem',
        'TDD-DL-Code-InformationItem-ExtIEs',
        'TDD-DL-Code-LCR-Information',
        'TDD-DL-Code-LCR-InformationItem',
        'TDD-DL-Code-LCR-InformationItem-ExtIEs',
        'TDD-DL-Code-768-Information',
        'TDD-DL-Code-768-InformationItem',
        'TDD-DL-Code-768-InformationItem-ExtIEs',
        'TDD-DL-DPCH-TimeSlotFormat-LCR',
        'QPSK-DL-DPCH-TimeSlotFormatTDD-LCR',
        'EightPSK-DL-DPCH-TimeSlotFormatTDD-LCR',
        'TDD-DPCHOffset',
        'TDD-PhysicalChannelOffset',
        'TDD-TPC-DownlinkStepSize',
        'TDD-TPC-UplinkStepSize-LCR',
        'TransportFormatCombination-Beta',
        'GainFactorFDD-ExtIEs',
        'SignalledGainFactors-ExtIEs',
        'TDD-UL-Code-Information',
        'TDD-UL-Code-InformationItem',
        'TDD-UL-Code-InformationItem-ExtIEs',
        'TDD-UL-Code-LCR-Information',
        'TDD-UL-Code-LCR-InformationItem',
        'TDD-UL-Code-LCR-InformationItem-ExtIEs',
        'TDD-UL-Code-768-Information',
        'TDD-UL-Code-768-InformationItem',
        'TDD-UL-Code-768-InformationItem-ExtIEs',
        'TDD-UL-DPCH-TimeSlotFormat-LCR',
        'QPSK-UL-DPCH-TimeSlotFormatTDD-LCR',
        'EightPSK-UL-DPCH-TimeSlotFormatTDD-LCR',
        'TFCI-Coding',
        'TFCI-Presence',
        'TFCI-SignallingMode',
        'TFCI-SignallingMode-ExtIEs',
        'TFCI-SignallingMode-TFCI-SignallingOption',
        'TGD',
        'TGPRC',
        'TGPSID',
        'TGSN',
        'TimeSlot',
        'TimeSlotDirection',
        'TimeSlot-InitiatedListLCR',
        'TimeSlotLCR',
        'TimeslotLCR-Extension',
        'TimeSlotMeasurementValueListLCR',
        'TimeSlotMeasurementValueLCR',
        'TimeSlotMeasurementValueListLCR-ExtIEs',
        'TimeSlotStatus',
        'TimingAdjustmentValue',
        'TimingAdjustmentValueLCR',
        'TimingAdvanceApplied',
        'SynchronisationIndicator',
        'TnlQos',
        'ToAWE',
        'ToAWS',
        'Transmission-Gap-Pattern-Sequence-Information',
        'Transmission-Gap-Pattern-Sequence-Information-ExtIEs',
        'TransmissionGapPatternSequenceCodeInformation',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue-Item',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue-Item-ExtIEs',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue-Item',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue-Item-ExtIEs',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue',
        'Transmitted-Carrier-Power-For-CellPortion-Value',
        'Transmitted-Carrier-Power-For-CellPortion-Value-Item',
        'Transmitted-Carrier-Power-For-CellPortion-Value-Item-ExtIEs',
        'Transmitted-Carrier-Power-For-CellPortion-ValueLCR',
        'Transmitted-Carrier-Power-For-CellPortion-ValueLCR-Item',
        'Transmitted-Carrier-Power-For-CellPortion-ValueLCR-Item-ExtIEs',
        'Transmitted-Carrier-Power-Value',
        'Transmitted-Code-Power-Value',
        'Transmitted-Code-Power-Value-IncrDecrThres',
        'TransmissionDiversityApplied',
        'TransmitDiversityIndicator',
        'TFCS',
        'TFCS-ExtIEs',
        'TFCS-TFCSList',
        'TFCS-TFCSList-ExtIEs',
        'TFCS-CTFC',
        'TPC-slot-position',
        'TPC-slot-position-ExtIEs',
        'Transport-Block-Size-Index',
        'Transport-Block-Size-Index-for-Enhanced-PCH',
        'Transport-Block-Size-List',
        'Transport-Block-Size-List-ExtIEs',
        'TransportBearerRequestIndicator',
        'TransportBearerNotRequestedIndicator',
        'TransportBearerNotSetupIndicator',
        'TransportFormatSet',
        'TransportFormatSet-ExtIEs',
        'TransportFormatSet-DynamicPartList',
        'TransportFormatSet-DynamicPartList-ExtIEs',
        'TDD-TransportFormatSet-ModeDP',
        'TDD-TransportFormatSet-ModeDP-ExtIEs',
        'TransmissionTimeIntervalInformation',
        'TransmissionTimeIntervalInformation-ExtIEs',
        'TransportFormatSet-Semi-staticPart',
        'TransportFormatSet-Semi-staticPart-ExtIEs',
        'TransportFormatSet-ChannelCodingType',
        'TransportFormatSet-CodingRate',
        'TransportFormatSet-CRC-Size',
        'TransportFormatSet-ModeDP',
        'TransportFormatSet-ModeSSP',
        'TransportFormatSet-NrOfTransportBlocks',
        'TransportFormatSet-RateMatchingAttribute',
        'TransportFormatSet-SecondInterleavingMode',
        'TransportFormatSet-TransmissionTimeIntervalDynamic',
        'TransportFormatSet-TransmissionTimeIntervalSemiStatic',
        'TransportFormatSet-TransportBlockSize',
        'TransportLayerAddress',
        'TS0-CapabilityLCR',
        'TSTD-Indicator',
        'TSN-Length',
        'TUTRANGANSS',
        'TUTRANGANSSAccuracyClass',
        'TUTRANGANSSMeasurementThresholdInformation',
        'TUTRANGANSSMeasurementThresholdInformation-ExtIEs',
        'TUTRANGANSSMeasurementValueInformation',
        'TUTRANGANSSMeasurementValueInformation-ExtIEs',
        'TUTRANGPS',
        'TUTRANGPSChangeLimit',
        'TUTRANGPSDriftRate',
        'TUTRANGPSDriftRateQuality',
        'TUTRANGPSAccuracyClass',
        'TUTRANGPSMeasurementThresholdInformation',
        'TUTRANGPSMeasurementThresholdInformation-ExtIEs',
        'TUTRANGPSMeasurementValueInformation',
        'TUTRANGPSMeasurementValueInformationItem-ExtIEs',
        'TUTRANGPSQuality',
        'TxDiversityOnDLControlChannelsByMIMOUECapability',
        'TypeOfError',
        'Two-ms-Overridden-E-DCH-RACH-Resources',
        'Two-ms-Grant-E-DCH-RACH-Resources',
        'Two-ms-Denied-E-DCH-RACH-Resources',
        'Two-msand10msTTI-Concurrent-Deployment-Capability',
        'Two-level-DRX',
        'Two-level-DRX-ExtIEs',
        'T32x',
        'T32y',
        'UARFCN',
        'UC-Id',
        'UC-Id-ExtIEs',
        'UDRE',
        'UDREGrowthRate',
        'UDREValidityTime',
        'UE-AggregateMaximumBitRate',
        'UE-AggregateMaximumBitRateDownlink',
        'UE-AggregateMaximumBitRateUplink',
        'UE-AggregateMaximumBitRate-Enforcement-Indicator',
        'UE-Capability-Information',
        'UE-Capability-Information-ExtIEs',
        'UE-RF-Band-CapabilityLCR',
        'Radio-Frequency-BandItem',
        'UE-TS0-CapabilityLCR',
        'Radio-Frequency-Band',
        'Radio-Frequency-BandItem-ExtIEs',
        'UE-Support-of-non-rectangular-resource-allocation',
        'UE-SupportIndicatorExtension',
        'LCRTDD-HSDSCH-Physical-Layer-Category',
        'UE-DPCCH-burst1',
        'UE-DPCCH-burst2',
        'UE-DRX-Cycle',
        'UE-DRX-Grant-Monitoring',
        'UE-DTX-Cycle1-2ms',
        'UE-DTX-Cycle1-10ms',
        'UE-DTX-Cycle2-2ms',
        'UE-DTX-Cycle2-ext-2ms',
        'UE-DTX-Cycle2-10ms',
        'UE-DTX-DRX-Offset',
        'UE-DTX-Long-Preamble',
        'UE-transmission-power-headroom-Value',
        'UE-Measurement-Value',
        'Extension-UE-Measurement-Value',
        'Extension-UE-Measurement-ValueIE',
        'UPHFiltering-Value',
        'UL-CapacityCredit',
        'UL-Delta-T2TP',
        'UL-DL-mode',
        'UL-DPDCH-Indicator-For-E-DCH-Operation',
        'Uplink-Compressed-Mode-Method',
        'UL-Timeslot-Information',
        'UL-Timeslot-InformationItem',
        'UL-Timeslot-InformationItem-ExtIEs',
        'UL-TimeslotLCR-Information',
        'UL-TimeslotLCR-InformationItem',
        'UL-TimeslotLCR-InformationItem-ExtIEs',
        'UL-Timeslot768-Information',
        'UL-Timeslot768-InformationItem',
        'UL-Timeslot768-InformationItem-ExtIEs',
        'UL-DPCCH-SlotFormat',
        'UL-SIR',
        'UL-FP-Mode',
        'UL-PhysCH-SF-Variation',
        'UL-ScramblingCode',
        'UL-ScramblingCode-ExtIEs',
        'UL-ScramblingCodeNumber',
        'UL-ScramblingCodeLength',
        'UL-Synchronisation-Parameters-LCR',
        'UL-Synchronisation-Parameters-LCR-ExtIEs',
        'UL-Synchronisation-StepSize',
        'UL-Synchronisation-Frequency',
        'UPPCHPositionLCR',
        'UL-TimeSlot-ISCP-Info',
        'UL-TimeSlot-ISCP-InfoItem',
        'UL-TimeSlot-ISCP-InfoItem-ExtIEs',
        'UL-TimeSlot-ISCP-LCR-Info',
        'UL-TimeSlot-ISCP-LCR-InfoItem',
        'UL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs',
        'UpPTSInterference-For-CellPortion-Value',
        'UpPTSInterference-For-CellPortion-Value-Item',
        'UpPTSInterference-For-CellPortion-Value-Item-ExtIEs',
        'UpPTSInterferenceValue',
        'Unidirectional-DCH-Indicator',
        'USCH-Information',
        'USCH-InformationItem',
        'USCH-InformationItem-ExtIEs',
        'USCH-InformationResponse',
        'USCH-InformationResponseItem',
        'USCH-InformationResponseItem-ExtIEs',
        'UL-CLTD-Information',
        'UL-CLTD-Information-ExtIEs',
        'UL-CLTD-Information-Reconf',
        'UL-CLTD-Information-Reconf-ExtIEs',
        'UL-CLTD-Information-To-Modify',
        'UL-CLTD-Information-To-Modify-ExtIEs',
        'UL-CLTD-Information-Removal',
        'UL-CLTD-State-Update-Information',
        'UL-CLTD-Activation-Information',
        'UL-DPCCH2-Information',
        'UL-DPCCH2-Information-ExtIEs',
        'UL-DPCCH2-Information-Reconf',
        'UL-DPCCH2-Information-Reconf-ExtIEs',
        'UL-DPCCH2-Information-Removal',
        'UL-DPCCH2-Information-To-Modify',
        'UL-DPCCH2-Information-To-Modify-ExtIEs',
        'UL-MIMO-Information',
        'UL-MIMO-Information-To-Modify',
        'UL-MIMO-Reconfiguration',
        'UL-MIMO-Removal',
        'UL-MIMO-DL-Control-Channel-Information',
        'UL-MIMO-Information-ExtIEs',
        'UL-MIMO-Information-To-Modify-ExtIEs',
        'UL-MIMO-DL-Control-Channel-Information-ExtIEs',
        'E-ROCH-PowerOffset',
        'S-E-DPCCH-PowerOffset',
        'InterStream-Interference-Compensation',
        'S-E-ROCH-Release-Indicator',
        'UL-TimeslotISCP-For-CellPortion-Value',
        'UL-TimeslotISCP-For-CellPortion-Value-Item',
        'UL-TimeslotISCP-For-CellPortion-Value-Item-ExtIEs',
        'UL-TimeslotISCP-Value',
        'UL-TimeslotISCP-Value-IncrDecrThres',
        'USCH-ID',
        'Usefulness-Of-Battery-Optimization',
        'Uu-ActivationState',
        ]
    _type_ = [
        'AckNack-RepetitionFactor',
        'Ack-Power-Offset',
        'Acknowledged-PRACH-preambles-Value',
        'ActivationDelay',
        'ActivationInformation',
        'ActivationInformationItem',
        'Adaptive-Special-Burst-Power-CapabilityLCR',
        'EDCH-Reference-E-TFCI-Information',
        'EDCH-Reference-E-TFCI-Information-Item',
        'EDCH-Reference-E-TFCI-PO',
        'Additional-EDCH-Setup-Info',
        'Multicell-EDCH-Transport-Bearer-Mode',
        'Additional-EDCH-Cell-Information-Setup',
        'Additional-EDCH-FDD-Setup-Cell-Information',
        'Additional-EDCH-UL-DPCH-Information-Setup',
        'Additional-EDCH-F-DPCH-Information',
        'Additional-EDCH-RL-Specific-Information-To-Setup-List',
        'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs',
        'Additional-EDCH-Cell-Information-To-Add-List',
        'Additional-EDCH-Cell-Information-To-Add-ItemIEs',
        'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs',
        'EDCH-Additional-RL-Specific-Information-To-Add-List',
        'Additional-EDCH-RL-Specific-Information-To-Modify-List',
        'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs',
        'Additional-EDCH-FDD-Information',
        'DTX-Information2',
        'Implicit-Grant-Handling',
        'Minimum-TEBS-threshold',
        'Additional-EDCH-MAC-d-Flows-Specific-Info-List',
        'Additional-EDCH-MAC-d-Flows-Specific-Info',
        'Additional-EDCH-Cell-Information-Response-List',
        'Additional-EDCH-FDD-Information-Response-ItemIEs',
        'EDCH-Additional-RL-Specific-Information-Response-List',
        'EDCH-Additional-RL-Specific-Information-Response-ItemIEs',
        'Additional-EDCH-Cell-Information-Response-RLReconf-List',
        'Additional-EDCH-FDD-Information-Response-RLReconf-Items',
        'Additional-Modififed-EDCH-FDD-Information-Response-ItemIEs',
        'EDCH-Additional-Modified-RL-Specific-Information-Response-List',
        'EDCH-Additional-Modified-RL-Specific-Information-Response-List-Items',
        'Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List',
        'Additional-EDCH-MAC-d-Flows-Specific-Info-Response',
        'Additional-EDCH-Cell-Information-Response-RL-Add-List',
        'Additional-EDCH-Cell-Information-Response-RL-Add-ItemIEs',
        'Additional-EDCH-Cell-Information-ConfigurationChange-List',
        'Additional-EDCH-ConfigurationChange-Info-ItemIEs',
        'Additional-EDCH-UL-DPCH-Information-Modify',
        'Additional-EDCH-Cell-Information-Removal-List',
        'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs',
        'RL-on-Secondary-UL-Frequency',
        'Additional-EDCH-FDD-Update-Information',
        'Additional-EDCH-DL-Control-Channel-Change-Information-List',
        'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs',
        'AdditionalMeasurementValueList',
        'AdditionalMeasurementValue',
        'AdditionalTimeSlotListLCR',
        'AdditionalTimeSlotLCR',
        'AddorDeleteIndicator',
        'Active-Pattern-Sequence-Information',
        'Transmission-Gap-Pattern-Sequence-Status-List',
        'Affected-HSDSCH-Serving-Cell-List',
        'AICH-Power',
        'AICH-TransmissionTiming',
        'AllocationRetentionPriority',
        'AlternativeFormatReportingIndicator',
        'Angle-Of-Arrival-Value-LCR',
        'AOA-LCR',
        'AOA-LCR-Accuracy-Class',
        'AOA-per-CELL-Portion-LCR',
        'AOA-per-CELL-Portion-LCR-Item',
        'AvailabilityStatus',
        'BCCH-Specific-HSDSCH-RNTI-Information',
        'BCCH-Specific-HSDSCH-RNTI-InformationLCR',
        'BCCH-ModificationTime',
        'BDS-IGPInfoList',
        'BDS-IGPInfo',
        'BDS-IonosphericGridModelReq',
        'BDS-Ionospheric-Grid-Model',
        'Best-Cell-Portions-Value',
        'Best-Cell-Portions-Item',
        'Best-Cell-Portions-ValueLCR',
        'Best-Cell-Portions-ItemLCR',
        'BindingID',
        'BetaCD',
        'BlockingPriorityIndicator',
        'SCTD-Indicator',
        'BundlingModeIndicator',
        'BroadcastCommonTransportBearerIndication',
        'BroadcastReference',
        'Cause',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'CCTrCH-ID',
        'Cell-Capability-Container',
        'Cell-ERNTI-Status-Information',
        'Cell-ERNTI-Status-Information-Item',
        'Vacant-ERNTI',
        'CellParameterID',
        'CellPortionID',
        'CellPortionLCRID',
        'CellPortion-CapabilityLCR',
        'CellSyncBurstCode',
        'CellSyncBurstCodeShift',
        'CellSyncBurstRepetitionPeriod',
        'CellSyncBurstSIR',
        'CellSyncBurstTiming',
        'CellSyncBurstTimingLCR',
        'CellSyncBurstTimingThreshold',
        'CFN',
        'ChipOffset',
        'C-ID',
        'Closedlooptimingadjustmentmode',
        'CodeRate',
        'CodeRate-short',
        'CommonChannelsCapacityConsumptionLaw',
        'Common-EDCH-Capability',
        'Common-E-DCH-HSDPCCH-Capability',
        'Common-EDCH-System-InformationFDD',
        'E-RNTI-Set',
        'Common-E-DCH-UL-DPCH-InfoItem',
        'Common-E-DCH-EDPCH-InfoItem',
        'Common-E-DCH-InfoItem',
        'CommonEDCH-AdditionalTransmissionBackOff',
        'Common-E-DCH-HSDPCCH-InfoItem',
        'Common-E-DCH-CQI-Info',
        'Common-E-DCH-Preamble-Control-InfoItem',
        'Common-E-DCH-AICH-Information',
        'Common-E-DCH-FDPCH-InfoItem',
        'Common-E-DCH-Resource-Combination-InfoList',
        'Common-E-DCH-Resource-Combination-InfoList-Item',
        'Common-E-DCH-MAC-d-flow-info-Concurrent-TTI',
        'Ul-common-E-DCH-MACflow-Specific-InfoList',
        'Ul-common-E-DCH-MACflow-Specific-InfoList-Item',
        'Common-E-DCH-MACdFlow-Specific-InfoList',
        'Common-E-DCH-MACdFlow-Specific-InfoList-Item',
        'Common-E-DCH-LogicalChannel-InfoList',
        'Common-E-DCH-LogicalChannel-InfoList-Item',
        'Common-EDCH-System-Information-ResponseFDD',
        'E-RNTI-List',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-Item',
        'Common-HSDSCH-RNTI-List',
        'Common-MACFlows-to-DeleteFDD',
        'Common-MACFlows-to-DeleteFDD-Item',
        'Common-MACFlow-ID',
        'CommonMACFlow-Specific-InfoList',
        'CommonMACFlow-Specific-InfoItem',
        'CommonMACFlow-Specific-InfoList-Response',
        'CommonMACFlow-Specific-InfoItem-Response',
        'Common-MACFlow-PriorityQueue-Information',
        'Common-MACFlow-PriorityQueue-Item',
        'CommonMeasurementAccuracy',
        'CommonMeasurementType',
        'CommonMeasurementValue',
        'Extension-CommonMeasurementValue',
        'CommonMeasurementValueInformation',
        'CommonMeasurementAvailable',
        'CommonMeasurementnotAvailable',
        'CommonPhysicalChannelID',
        'CommonPhysicalChannelID768',
        'Common-PhysicalChannel-Status-Information',
        'Common-PhysicalChannel-Status-Information768',
        'CommonTransportChannelID',
        'CommonTransportChannel-InformationResponse',
        'Common-TransportChannel-Status-Information',
        'CommunicationControlPortID',
        'CompleteAlmanacProvided',
        'Compressed-Mode-Deactivation-Flag',
        'ConfigurationGenerationID',
        'ConstantValue',
        'ContinuousPacketConnectivityDTX-DRX-Capability',
        'ContinuousPacketConnectivityDTX-DRX-Information',
        'ContinuousPacketConnectivityDTX-DRX-Information-to-Modify',
        'ContinuousPacketConnectivityHS-SCCH-less-Capability',
        'ContinuousPacketConnectivityHS-SCCH-less-Information',
        'ContinuousPacketConnectivityHS-SCCH-less-InformationItem',
        'ContinuousPacketConnectivityHS-SCCH-less-Information-Response',
        'ControlGAP',
        'CPC-Information',
        'CPC-RecoveryReport',
        'ContinuousPacketConnectivityHS-SCCH-less-Deactivate-Indicator',
        'CQI-DTX-Timer',
        'CQI-Cycle-Switch-Timer',
        'CQI-Feedback-Cycle',
        'CQI-Feedback-Cycle2',
        'CQI-Power-Offset',
        'CQI-RepetitionFactor',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CRNC-CommunicationContextID',
        'CSBMeasurementID',
        'CSBTransmissionID',
        'Common-EDCH-System-InformationLCR',
        'Common-E-PUCH-InformationLCR',
        'PRXdes-base-perURAFCN',
        'PRXdes-base-Item',
        'Ul-common-E-DCH-MACflow-Specific-InfoListLCR',
        'Ul-common-E-DCH-MACflow-Specific-InfoListLCR-Ext',
        'Ul-common-E-DCH-MACflow-Specific-InfoList-ItemLCR',
        'Common-E-DCH-MACdFlow-Specific-InfoListLCR',
        'Common-E-DCH-MACdFlow-Specific-InfoList-ItemLCR',
        'Common-EDCH-System-Information-ResponseLCR',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR-Ext',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-ItemLCR',
        'Common-E-AGCH-ListLCR',
        'Common-E-AGCH-ItemLCR',
        'Common-E-HICH-ListLCR',
        'Common-E-HICH-ItemLCR',
        'Common-E-RNTI-Info-LCR',
        'Common-E-RNTI-Info-ItemLCR',
        'Common-MACFlows-to-DeleteLCR',
        'Common-MACFlows-to-DeleteLCR-Item',
        'Common-MACFlow-ID-LCR',
        'CommonMACFlow-Specific-InfoListLCR',
        'CommonMACFlow-Specific-InfoItemLCR',
        'Common-H-RNTI-InformationLCR',
        'Common-H-RNTI-InfoItemLCR',
        'Sync-InformationLCR',
        'CommonMACFlow-Specific-InfoList-ResponseLCR',
        'CommonMACFlow-Specific-InfoList-ResponseLCR-Ext',
        'CommonMACFlow-Specific-InfoItem-ResponseLCR',
        'CPC-InformationLCR',
        'ContinuousPacketConnectivity-DRX-CapabilityLCR',
        'ContinuousPacketConnectivity-DRX-InformationLCR',
        'HS-SCCH-DRX-Information-LCR',
        'E-AGCH-DRX-Information-LCR',
        'E-AGCH-DRX-Parameters',
        'UE-DRX-Cycle-LCR',
        'UE-DRX-Offset-LCR',
        'Inactivity-Threshold-for-UE-DRX-Cycle-LCR',
        'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext',
        'E-AGCH-UE-Inactivity-Monitor-Threshold',
        'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR',
        'DRX-Information-to-Modify-LCR',
        'DRX-Information-to-Modify-Items-LCR',
        'ContinuousPacketConnectivity-DRX-Information-ResponseLCR',
        'HS-SCCH-DRX-Information-ResponseLCR',
        'E-AGCH-DRX-Information-ResponseLCR',
        'E-AGCH-DRX-Parameters-Response',
        'Cell-Capability-Container-TDD-LCR',
        'Common-E-RGCH-Operation-Indicator',
        'Common-E-RGCH-InfoFDD',
        'Concurrent-Deployment-of-2msand10ms-TTI',
        'Concurrent-TTI-Partition-Index',
        'Common-E-DCH-System-Info-Parameters-for-Concurrent-TTI',
        'Common-E-DCH-HS-DPCCH-Information-forConcurrentTTI',
        'Common-E-DCH-Preamble-Control-Information-extensionList',
        'Common-E-DCH-Preamble-Control-Information-extensionList-Item',
        'Common-E-DCH-Preamble-Control-Information-extension',
        'Configuration-for-2msTTI-Common-E-DCH-ResourcesList',
        'Configuration-for-2msTTI-Common-E-DCH-ResourcesList-Item',
        'Coffset',
        'CHOICE-DRX-level',
        'DATA-ID',
        'DBDS-CorrectionsReq',
        'DBDS-Corrections',
        'DBDS-Info',
        'DBDS-SignalInfoList',
        'DBDS-SignalInfo',
        'DBDS-InfoList',
        'DCH-ENH-Information',
        'DCH-ENH-Information-to-Modify',
        'DL-FET-Mode',
        'DCH-ENH-Concat',
        'DCH-ENH-Information-Reconf',
        'DCH-ENH-Information-Removal',
        'DCH-ID',
        'DCH-FDD-Information',
        'DCH-FDD-InformationItem',
        'DCH-Specific-FDD-InformationList',
        'DCH-Specific-FDD-Item',
        'DCH-Indicator-For-E-DCH-HSDPA-Operation',
        'DCH-InformationResponse',
        'DCH-InformationResponseItem',
        'DCH-MeasurementOccasion-Information',
        'DchMeasurementOccasionInformation-Item',
        'Measurement-Occasion-Pattern-Sequence-parameters',
        'DCH-TDD-Information',
        'DCH-TDD-InformationItem',
        'DCH-Specific-TDD-InformationList',
        'DCH-Specific-TDD-Item',
        'FDD-DCHs-to-Modify',
        'FDD-DCHs-to-ModifyItem',
        'DCH-ModifySpecificInformation-FDD',
        'DCH-ModifySpecificItem-FDD',
        'TDD-DCHs-to-Modify',
        'DCH-ModifyItem-TDD',
        'DCH-ModifySpecificInformation-TDD',
        'DCH-ModifySpecificItem-TDD',
        'DecimationFactor',
        'DedicatedChannelsCapacityConsumptionLaw',
        'DedicatedMeasurementType',
        'DedicatedMeasurementValue',
        'Extension-DedicatedMeasurementValue',
        'DedicatedMeasurementValueInformation',
        'DedicatedMeasurementAvailable',
        'DedicatedMeasurementnotAvailable',
        'DelayedActivation',
        'DelayedActivationUpdate',
        'Activate-Info',
        'Deactivate-Info',
        'Execution-Type',
        'DeltaSIR',
        'DGANSSCorrections',
        'DGANSS-Corrections-Req',
        'DGANSS-Information',
        'DGANSS-InformationItem',
        'DGANSS-SignalInformation',
        'DGANSS-SignalInformationItem',
        'DGANSSThreshold',
        'DGNSS-ValidityPeriod',
        'DGPSCorrections',
        'DGPSThresholds',
        'DiscardTimer',
        'DiversityControlField',
        'DiversityMode',
        'DL-TBS',
        'HS-DSCH-Cell-List',
        'HS-DSCH-Cell',
        'DL-TBS-Value',
        'DL-DPCH-SlotFormat',
        'DL-DPCH-TimingAdjustment',
        'DL-Timeslot-Information',
        'DL-Timeslot-InformationItem',
        'DL-TimeslotLCR-Information',
        'DL-TimeslotLCR-InformationItem',
        'DL-Timeslot768-Information',
        'DL-Timeslot768-InformationItem',
        'DL-FrameType',
        'DL-or-Global-CapacityCredit',
        'DL-Power',
        'DLPowerAveragingWindowSize',
        'DL-PowerBalancing-Information',
        'DL-ReferencePowerInformationList',
        'DL-ReferencePowerInformationItem',
        'DL-PowerBalancing-ActivationIndicator',
        'DL-PowerBalancing-UpdatedIndicator',
        'DL-ScramblingCode',
        'DL-TimeslotISCP',
        'DL-TimeslotISCPInfo',
        'DL-TimeslotISCPInfoItem',
        'DL-TimeslotISCPInfoLCR',
        'DL-TimeslotISCPInfoItemLCR',
        'DL-TPC-Pattern01Count',
        'DLTransmissionBranchLoadValue',
        'Downlink-Compressed-Mode-Method',
        'DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-InformationItem-LCR-PSCH-ReconfRqst',
        'MaxHSDSCH-HSSCCH-Power-per-CELLPORTION',
        'MaxHSDSCH-HSSCCH-Power-per-CELLPORTION-Item',
        'DL-HS-PDSCH-Codelist-LCR-PSCH-ReconfRqst',
        'Downlink-TPC-enhancements-Information',
        'Downlink-TPC-enhancements-Reconf',
        'Downlink-TPC-enhancements-Information-Removal',
        'DPC-Mode',
        'DPCH-ID',
        'DPCH-ID768',
        'DRX-Information',
        'DRX-Information-to-Modify',
        'DRX-Information-to-Modify-Items',
        'DRX-Interruption-by-HS-DSCH',
        'DSCH-ID',
        'DSCH-InformationResponse',
        'DSCH-InformationResponseItem',
        'DSCH-TDD-Information',
        'DSCH-TDD-InformationItem',
        'DsField',
        'DTX-Cycle-2ms-Items',
        'DTX-Cycle-2ms-to-Modify-Items',
        'DTX-Cycle-10ms-Items',
        'DTX-Cycle-10ms-to-Modify-Items',
        'DTX-Information',
        'DTX-Information-to-Modify',
        'DTX-Information-to-Modify-Items',
        'Dual-Band-Capability',
        'Dual-Band-Capability-Info',
        'DwPCH-Power',
        'Improved-Synchronized-Indicator',
        'E-AGCH-Table-Choice',
        'E-AGCH-FDD-Code-Information',
        'E-AGCH-FDD-Code-List',
        'E-AI-Capability',
        'E-AI-Indicator',
        'E-DCH-Capability',
        'E-DCHCapacityConsumptionLaw',
        'E-DCH-Decoupling-Indication',
        'E-DCH-TDD-CapacityConsumptionLaw',
        'E-DCH-SF-allocation',
        'E-DCH-TTI2ms-Capability',
        'E-DCH-SF-Capability',
        'E-DCH-HARQ-Combining-Capability',
        'E-DCH-DDI-Value',
        'E-DCH-FDD-DL-Control-Channel-Information',
        'E-DCH-FDD-Information',
        'UPH-Filtering-Measurement-Forwarding-Request',
        'E-DCH-FDD-Information-Response',
        'E-DCH-FDD-Information-to-Modify',
        'E-DCH-FDD-Update-Information',
        'TTI-Update-Indicator',
        'TTI-Update-Ind',
        'E-DCH-MACdFlow-Specific-UpdateInformation',
        'E-DCH-MACdFlow-Specific-UpdateInformation-Item',
        'E-DCH-DL-Control-Channel-Change-Information',
        'E-DCH-DL-Control-Channel-Change-Information-Item',
        'E-DCH-DL-Control-Channel-Grant-Information',
        'E-DCH-DL-Control-Channel-Grant-Information-Item',
        'E-DCH-Grant-Type-Information',
        'E-DCH-LogicalChannelInformation',
        'E-DCH-LogicalChannelInformationItem',
        'E-DCH-Maximum-Bitrate',
        'E-DCH-PowerOffset-for-SchedulingInfo',
        'E-DCH-Processing-Overload-Level',
        'E-DCH-Reference-Power-Offset',
        'E-DCH-MACdPDU-SizeList',
        'E-DCH-MACdPDU-SizeListItem',
        'E-DCH-MACdPDU-SizeCapability',
        'E-DCH-MACdPDUSizeFormat',
        'E-DCH-LogicalChannelToModify',
        'E-DCH-LogicalChannelToModifyItem',
        'E-DCH-MACdPDU-SizeToModifyList',
        'E-DCH-LogicalChannelToDelete',
        'E-DCH-LogicalChannelToDeleteItem',
        'LogicalChannelID',
        'E-DCH-HARQ-PO-FDD',
        'E-DCH-MACdFlow-ID',
        'E-DCH-MACdFlows-Information',
        'E-DCH-MACdFlow-Multiplexing-List',
        'E-DCH-MACdFlow-Specific-InfoList',
        'E-DCH-MACdFlow-Specific-InfoItem',
        'E-DCH-MACdFlow-Specific-InformationResp',
        'E-DCH-MACdFlow-Specific-InformationResp-Item',
        'E-DCH-MACdFlow-Specific-InfoList-to-Modify',
        'E-DCH-MACdFlow-Specific-InfoItem-to-Modify',
        'E-DCH-MACdFlows-to-Delete',
        'E-DCH-MACdFlow-to-Delete-Item',
        'E-DCH-Non-Scheduled-Transmission-Grant-Items',
        'E-DCH-Non-serving-Relative-Grant-Down-Commands',
        'E-DCHProvidedBitRateValue',
        'Maximum-Target-ReceivedTotalWideBandPower',
        'Target-NonServing-EDCH-To-Total-EDCH-Power-Ratio',
        'E-DCH-RL-Indication',
        'E-DCH-Serving-Cell-Change-Info-Response',
        'E-DCH-serving-cell-choice',
        'E-DCH-serving-cell-change-successful',
        'E-DCH-RL-InformationList-Rsp',
        'E-DCH-RL-InformationList-Rsp-Item',
        'E-DCH-serving-cell-change-unsuccessful',
        'EDCH-RACH-Report-Value',
        'E-DCH-TFCI-Table-Index',
        'E-DCH-TTI-Length',
        'E-DCH-TTI-Length-to-Modify',
        'E-DPCCH-PO',
        'Extended-E-DPCCH-PO',
        'E-DPDCH-PowerInterpolation',
        'E-Primary-Secondary-Grant-Selector',
        'E-DCH-MACdFlow-ID-LCR',
        'E-DCH-MACdFlows-to-DeleteLCR',
        'E-DCH-MACdFlow-to-Delete-ItemLCR',
        'Enhanced-UE-DRX-InformationLCR',
        'E-HICH-ID-LCR',
        'E-HICH-Signature-Sequence',
        'End-Of-Audit-Sequence-Indicator',
        'E-Serving-Grant-Value',
        'E-RGCH-2-IndexStepThreshold',
        'E-RGCH-3-IndexStepThreshold',
        'E-RGCH-E-HICH-FDD-Code-Information',
        'E-RGCH-E-HICH-FDD-Code-List',
        'E-RGCH-Release-Indicator',
        'E-RGCH-Signature-Sequence',
        'E-RNTI',
        'E-TFCI',
        'E-TFCI-BetaEC-Boost',
        'E-TFCI-Boost-Information',
        'E-TFCS-Information',
        'E-TTI',
        'E-DCHProvidedBitRate',
        'E-DCHProvidedBitRate-Item',
        'E-DCHProvidedBitRateValueInformation-For-CellPortion',
        'E-DCHProvidedBitRateValueInformation-For-CellPortion-Item',
        'E-AGCH-PowerOffset',
        'E-RGCH-PowerOffset',
        'E-HICH-PowerOffset',
        'E-HICH-TimeOffset',
        'E-HICH-TimeOffsetLCR',
        'E-DCH-Information',
        'E-PUCH-Information',
        'E-TFCS-Information-TDD',
        'E-DCH-QPSK-RefBetaInfo',
        'E-DCH-sixteenQAM-RefBetaInfo',
        'E-DCH-RefBeta-Item',
        'E-DCH-MACdFlows-Information-TDD',
        'E-DCH-MACdFlow-InfoTDDItem',
        'E-DCH-MACdFlow-Retransmission-Timer',
        'E-DCH-HARQ-PO-TDD',
        'E-DCH-Grant-TypeTDD',
        'E-DCH-Non-Scheduled-Grant-Info',
        'E-DCH-TimeslotResource',
        'E-DCH-TimeslotResourceLCR',
        'E-DCH-PowerResource',
        'TddE-PUCH-Offset',
        'E-DCH-TDD-Information',
        'E-DCH-TDD-Maximum-Bitrate',
        'E-DCH-Information-Response',
        'Scheduled-E-HICH-Specific-Information-ResponseLCRTDD',
        'Scheduled-E-HICH-Specific-InformationItem-ResponseLCRTDD',
        'EI',
        'E-HICH-ID-TDD',
        'E-HICH-Type',
        'E-DCH-TDD-MACdFlow-Specific-InformationResp',
        'E-DCH-TDD-MACdFlow-Specific-InformationResp-Item',
        'E-AGCH-Specific-InformationRespListTDD',
        'E-AGCH-Specific-InformationResp-ItemTDD',
        'E-AGCH-Id',
        'E-DCH-Information-Reconfig',
        'E-DCH-TDD-Information-to-Modify',
        'E-DCH-TDD-Information-to-Modify-List',
        'E-DCH-MACdFlow-ModifyTDDItem',
        'Maximum-Generated-ReceivedTotalWideBandPowerInOtherCells',
        'E-DCH-768-Information',
        'E-DCH-Non-Scheduled-Grant-Info768',
        'E-DCH-TDD-Information768',
        'E-DCH-TDD-Maximum-Bitrate768',
        'E-DCH-768-Information-Reconfig',
        'E-DCH-LCR-Information',
        'E-PUCH-LCR-Information',
        'E-DCH-Non-Scheduled-Grant-LCR-Info',
        'E-HICH-LCR-Information',
        'E-DCH-LCRTDD-Information',
        'E-DCH-LCRTDD-PhysicalLayerCategory',
        'E-DCH-LCR-Information-Reconfig',
        'Enabling-Delay',
        'Enabling-Delay-Ext-LCR',
        'DormantModeIndicator',
        'Enhanced-FACH-Capability',
        'EnhancedHSServingCC-Abort',
        'Enhanced-PCH-Capability',
        'Enhanced-UE-DRX-Capability',
        'Enhanced-UE-DRX-InformationFDD',
        'Extended-E-DCH-LCRTDD-PhysicalLayerCategory',
        'Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory',
        'Ext-Max-Bits-MACe-PDU-non-scheduled',
        'Ext-Reference-E-TFCI-PO',
        'ExtendedPropagationDelay',
        'Extended-RNC-ID',
        'Extended-Round-Trip-Time-Value',
        'Extended-HS-SCCH-ID',
        'Extended-HS-SICH-ID',
        'Extended-E-HICH-ID-TDD',
        'Radio-Links-without-DPCH-FDPCH-Indication',
        'Radio-Links-without-DPCH-FDPCH-Information',
        'E-DCH-Semi-PersistentScheduling-Information-LCR',
        'E-DCH-SPS-Indicator',
        'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR',
        'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR',
        'ERNTI-Release-Status',
        'Common-E-DCH-Implicit-Release-Timer',
        'FACH-Measurement-Occasion-Cycle-Length-Coefficient',
        'Fast-Reconfiguration-Mode',
        'Fast-Reconfiguration-Permission',
        'Fast-TTI-switching-Mode-synchronized',
        'Mode1-Ind',
        'Fast-TTI-switching-Mode-unsynchronized',
        'Fast-TTI-switching-Mode-Supported',
        'FDD-DL-ChannelisationCodeNumber',
        'FDD-DL-CodeInformation',
        'FDD-DL-CodeInformationItem',
        'FDD-S-CCPCH-FrameOffset',
        'FDD-S-CCPCH-Offset',
        'FDD-TPC-DownlinkStepSize',
        'F-DPCH-Capability',
        'F-DPCH-Info',
        'F-DPCH-Info-To-Modify',
        'F-DPCH-SlotFormat',
        'F-DPCH-SlotFormatCapability',
        'FirstRLS-Indicator',
        'FNReportingIndicator',
        'FrameHandlingPriority',
        'FrameAdjustmentValue',
        'FrameOffset',
        'FPACH-Power',
        'FTPICH-Information',
        'FTPICH-SlotFormat',
        'FTPICH-Offset',
        'FTPICH-Information-Removal',
        'FTPICH-Information-To-Modify',
        'FTPICH-Information-Reconf',
        'Further-Enhanced-UE-DRX-InformationFDD',
        'Gainfactors-10ms-mode',
        'GANSS-AddClockModels',
        'GANSS-AddIonoModelReq',
        'GANSS-AddNavigationModelsReq',
        'GANSS-AddOrbitModels',
        'GANSS-AddUTCModelsReq',
        'GANSS-Additional-Ionospheric-Model',
        'GANSS-Additional-Navigation-Models',
        'GANSS-Additional-Time-Models',
        'GANSS-Additional-UTC-Models',
        'GANSS-Almanac',
        'GANSS-AlmanacModel',
        'Extension-GANSS-AlmanacModel',
        'GANSS-ALM-ECEFsbasAlmanacSet',
        'GANSS-ALM-GlonassAlmanacSet',
        'GANSS-ALM-MidiAlmanacSet',
        'GANSS-ALM-NAVKeplerianSet',
        'GANSS-ALM-KEPLERIANBDSALMANAC',
        'GANSS-ALM-ReducedKeplerianSet',
        'GANSS-Auxiliary-Information',
        'GANSS-AuxInfoGANSS-ID1',
        'GANSS-AuxInfoGANSS-ID1-element',
        'GANSS-AuxInfoGANSS-ID3',
        'GANSS-AuxInfoGANSS-ID3-element',
        'GANSS-AuxInfoReq',
        'GANSS-BDSclockModel',
        'GANSS-Clock-Model',
        'GANSS-CNAVclockModel',
        'GANSS-Common-Data',
        'GANSS-CommonDataInfoReq',
        'GANSS-Data-Bit-Assistance',
        'GANSS-DataBitAssistanceList',
        'GANSS-DataBitAssistanceItem',
        'GANSS-DataBitAssistanceSgnList',
        'GANSS-DataBitAssistanceSgnItem',
        'GANSS-Data-Bit-Assistance-ReqItem',
        'GANSS-Data-Bit-Assistance-ReqList',
        'GANSS-Delta-T',
        'GANSS-DeltaUT1',
        'GANSS-Earth-Orientation-Parameters',
        'GANSS-EarthOrientParaReq',
        'GANSS-GenericDataInfoReqList',
        'GANSS-GenericDataInfoReqItem',
        'GANSS-Generic-Data',
        'GANSS-Generic-DataItem',
        'GANSS-GLONASSclockModel',
        'GANSS-ID',
        'GANSS-Information',
        'GANSS-Ionospheric-Model',
        'GANSS-IonosphereRegionalStormFlags',
        'GANSS-KeplerianParametersAlm',
        'GANSS-KeplerianParametersOrb',
        'GANSS-NAVclockModel',
        'GANSS-Navigation-Model-And-Time-Recovery',
        'GANSS-NavModel-BDSKeplerianSet',
        'GANSS-NavModel-CNAVKeplerianSet',
        'GANSS-NavModel-GLONASSecef',
        'GANSS-NavModel-NAVKeplerianSet',
        'GANSS-NavModel-SBASecef',
        'GANSS-Orbit-Model',
        'GANSS-Real-Time-Integrity',
        'GANSS-RealTimeInformationItem',
        'GANSS-RX-Pos',
        'GANSS-SatelliteClockModelItem',
        'GANSS-SatelliteInformationKP',
        'GANSS-SatelliteInformationKPItem',
        'Ganss-Sat-Info-AddNavList',
        'GANSS-SAT-Info-Almanac-BDSkpList',
        'GANSS-SAT-Info-Almanac-BDS',
        'GANSS-SAT-Info-Almanac-GLOkpList',
        'GANSS-SAT-Info-Almanac-GLOkp',
        'GANSS-SAT-Info-Almanac-MIDIkpList',
        'GANSS-SAT-Info-Almanac-MIDIkp',
        'GANSS-SAT-Info-Almanac-NAVkpList',
        'GANSS-SAT-Info-Almanac-NAVkp',
        'GANSS-SAT-Info-Almanac-REDkpList',
        'GANSS-SAT-Info-Almanac-REDkp',
        'GANSS-SAT-Info-Almanac-SBASecefList',
        'GANSS-SAT-Info-Almanac-SBASecef',
        'GANSS-Sat-Info-Nav',
        'GANSS-SBAS-ID',
        'GANSS-SBASclockModel',
        'GANSS-Signal-ID',
        'GANSS-StatusHealth',
        'GANSS-Time-ID',
        'GANSS-Time-Model',
        'GANSS-Transmission-Time',
        'GANSS-UTC-Model',
        'GANSS-UTCmodelSet1',
        'GANSS-UTCmodelSet2',
        'GANSS-UTCmodelSet3',
        'GANSS-UTCmodelSet4',
        'GapLength',
        'GapDuration',
        'GenericTrafficCategory',
        'GPS-Almanac',
        'GPS-Ionospheric-Model',
        'GPS-Information',
        'GPS-Information-Item',
        'GPS-RealTime-Integrity',
        'GPSBadSat-Info-RealTime-Integrity',
        'GPS-NavigationModel-and-TimeRecovery',
        'GPS-NavandRecovery-Item',
        'GPS-RX-POS',
        'GPS-Status-Health',
        'GPSTOW',
        'GPS-UTC-Model',
        'HARQ-Info-for-E-DCH',
        'HARQ-MemoryPartitioning',
        'HARQ-MemoryPartitioning-Implicit',
        'HARQ-MemoryPartitioning-Explicit',
        'HARQ-MemoryPartitioningList',
        'HARQ-MemoryPartitioningInfoExtForMIMO',
        'HARQ-MemoryPartitioningItem',
        'HARQ-Preamble-Mode',
        'HARQ-Process-Allocation-2ms-EDCH',
        'HARQ-Preamble-Mode-Activation-Indicator',
        'HSDPA-Capability',
        'HS-DSCHProvidedBitRate',
        'HS-DSCHProvidedBitRate-Item',
        'HS-DSCHProvidedBitRateValue',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortion',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortion-Item',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR-Item',
        'HS-DSCHRequiredPower',
        'HS-DSCHRequiredPower-Item',
        'HS-DSCHRequiredPowerValue',
        'HS-DSCHRequiredPowerPerUEInformation',
        'HS-DSCHRequiredPowerPerUEInformation-Item',
        'HS-DSCHRequiredPowerPerUEWeight',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortion',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortion-Item',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR-Item',
        'HSDPA-Associated-PICH-Information',
        'HSDPA-PICH-Shared-with-PCH',
        'HSDPA-PICH-notShared-with-PCH',
        'HSDSCH-Common-System-InformationFDD',
        'HSDSCH-Common-System-Information-ResponseFDD',
        'HSDSCH-Common-Information',
        'HSDSCH-FDD-Information',
        'HSDSCH-TDD-Information',
        'HSDSCH-Information-to-Modify',
        'HSDSCH-MACdFlow-Specific-InfoList-to-Modify',
        'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify',
        'HSDSCH-MACdPDUSizeFormat',
        'HSDSCH-MACdPDU-SizeCapability',
        'HSDSCH-Information-to-Modify-Unsynchronised',
        'HSDSCH-FDD-Information-Response',
        'HS-DSCH-FDD-Secondary-Serving-Information',
        'HS-DSCH-FDD-Secondary-Serving-Information-Response',
        'HS-DSCH-first-DRX-ycle-FACH',
        'HS-DSCH-first-Rx-burst-FACH',
        'HS-DSCH-Second-DRX-Cycle-FACH',
        'HS-DSCH-second-Rx-burst-FACH',
        'HS-DSCH-Secondary-Serving-Information-To-Modify',
        'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised',
        'HS-DSCH-FDD-Secondary-Serving-Update-Information',
        'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response',
        'HS-DSCH-Secondary-Serving-cell-change-choice',
        'HS-Secondary-Serving-cell-change-successful',
        'HS-Secondary-Serving-cell-change-unsuccessful',
        'HS-DSCH-Secondary-Serving-Remove',
        'HSDSCH-Paging-System-InformationFDD',
        'HSDSCH-Paging-System-Information-ResponseFDD',
        'HSDSCH-Paging-System-Information-ResponseList',
        'HSDSCH-TDD-Information-Response',
        'HSDSCH-MACdFlow-Specific-InformationResp',
        'HSDSCH-MACdFlow-Specific-InformationResp-Item',
        'HSDSCH-MACdFlows-Information',
        'HSDSCH-MACdFlow-Specific-InfoList',
        'HSDSCH-MACdFlow-Specific-InfoItem',
        'HSDSCH-MACdFlows-to-Delete',
        'HSDSCH-MACdFlows-to-Delete-Item',
        'HSDSCH-TBSizeTableIndicator',
        'HSSCCH-PowerOffset',
        'HSDSCH-Initial-Capacity-Allocation',
        'HSDSCH-Initial-Capacity-AllocationItem',
        'HSDSCH-InitialWindowSize',
        'HSDSCH-PreconfigurationInfo',
        'Additional-EDCH-Preconfiguration-Information',
        'Additional-EDCH-Preconfiguration-Information-ItemIEs',
        'HSDSCH-PreconfigurationSetup',
        'HS-SCCH-PreconfiguredCodes',
        'HS-SCCH-PreconfiguredCodesItem',
        'HS-SCCH-CodeNumber',
        'HSSCCH-Specific-InformationRespListFDD',
        'HSSCCH-Codes',
        'HSSCCH-Specific-InformationRespListTDD',
        'HSSCCH-Specific-InformationRespItemTDD',
        'HSSCCH-Specific-InformationRespListTDDLCR',
        'HSSCCH-Specific-InformationRespItemTDDLCR',
        'HSSCCH-Specific-InformationRespListTDD768',
        'HSSCCH-Specific-InformationRespItemTDD768',
        'HSSICH-Info',
        'HSSICH-InfoLCR',
        'HSSICH-Info768',
        'HS-SICH-Reception-Quality-Value',
        'HS-SICH-failed',
        'HS-SICH-missed',
        'HS-SICH-total',
        'HS-SICH-Reception-Quality-Measurement-Value',
        'HSDSCH-MACdFlow-ID',
        'HSDSCH-RNTI',
        'HS-PDSCH-FDD-Code-Information',
        'HS-PDSCH-Start-code-number',
        'HS-SCCH-ID',
        'HS-SICH-ID',
        'HS-SCCH-FDD-Code-Information',
        'HS-SCCH-FDD-Code-List',
        'HS-SCCH-FDD-Code-Information-Item',
        'HSSCCH-CodeChangeIndicator',
        'HSSCCH-Code-Change-Grant',
        'HS-PDSCH-Code-Change-Indicator',
        'HS-PDSCH-Code-Change-Grant',
        'HSDSCH-Configured-Indicator',
        'HS-DSCH-Serving-Cell-Change-Info',
        'HS-DSCH-Serving-Cell-Change-Info-Response',
        'HS-DSCH-serving-cell-choice',
        'HS-serving-cell-change-successful',
        'HS-serving-cell-change-unsuccessful',
        'HS-DSCH-DRX-Cycle-FACH',
        'HS-DSCH-RX-Burst-FACH',
        'HS-SCCH-DRX-Cycle-FACH',
        'HS-SCCH-RX-Burst-FACH',
        'HSDSCH-FDD-Update-Information',
        'HSDSCH-TDD-Update-Information',
        'HSPDSCH-Code-Index',
        'HSPDSCH-First-Code-Index',
        'HSPDSCH-Second-Code-Index',
        'HSPDSCH-Second-Code-Support',
        'HSDPA-Associated-PICH-InformationLCR',
        'HSDPA-PICH-notShared-with-PCHLCR',
        'HSDSCH-Common-System-InformationLCR',
        'HSDSCH-Common-System-Information-ResponseLCR',
        'HSDSCH-Common-InformationLCR',
        'HSDSCH-Paging-System-InformationLCR',
        'HSDSCH-Paging-System-Information-ResponseLCR',
        'HSDSCH-Paging-System-Information-ResponseListLCR',
        'HS-SCCH-ID-LCR',
        'HSSCCH-Specific-InformationRespListLCR',
        'HSSCCH-Specific-InformationRespItemLCR',
        'HS-DSCH-Semi-PersistentScheduling-Information-LCR',
        'Transport-Block-Size-List-LCR',
        'Transport-Block-Size-Item-LCR',
        'Transport-Block-Size-maping-Index-LCR',
        'Transport-Block-Size-Index-LCR',
        'Repetition-Period-List-LCR',
        'Repetition-Period-Item-LCR',
        'RepetitionPeriodIndex',
        'SPS-Reservation-Indicator',
        'HS-DSCH-SPS-Operation-Indicator',
        'LogicalChannellevel',
        'PriorityQueuelevel',
        'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR',
        'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR',
        'HS-SICH-InformationList-for-HS-DSCH-SPS',
        'HS-SICH-InformationItem-for-HS-DSCH-SPS',
        'HS-SICH-Mapping-Index',
        'HS-SICH-Type',
        'HS-SCCH-Associated-HS-SICH',
        'Non-HS-SCCH-Associated-HS-SICH',
        'Non-HS-SCCH-Aassociated-HS-SICH-ID',
        'Initial-HS-PDSCH-SPS-Resource',
        'HS-DSCH-TimeslotResourceLCR',
        'ModulationSPS-LCR',
        'Number-of-Processes-for-HS-DSCH-SPS',
        'Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'Non-HS-SCCH-Associated-HS-SICH-InformationList',
        'Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext',
        'Non-HS-SCCH-Associated-HS-SICH-InformationItem',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationList',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationItem',
        'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext',
        'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqstItem',
        'MIMO-ReferenceSignal-InformationListLCR',
        'HSSICH-ReferenceSignal-InformationLCR',
        'HSSICH-ReferenceSignal-InformationModifyLCR',
        'HS-DPCCH-transmission-continuation-backoff',
        'IB-OC-ID',
        'IB-SG-DATA',
        'IB-SG-POS',
        'IB-SG-REP',
        'IB-Type',
        'IMB-Parameters',
        'BCH-Parameters',
        'Inactivity-Threshold-for-UE-DRX-Cycle',
        'Inactivity-Threshold-for-UE-DTX-Cycle2',
        'Inactivity-Threshold-for-UE-Grant-Monitoring',
        'InformationReportCharacteristics',
        'InformationReportCharacteristicsType-ReportPeriodicity',
        'InformationReportCharacteristicsType-OnModification',
        'InformationThresholds',
        'InformationExchangeID',
        'InformationType',
        'Information-Type-Item',
        'Initial-DL-DPCH-TimingAdjustment-Allowed',
        'InnerLoopDLPCStatus',
        'IPDL-Indicator',
        'IPDL-FDD-Parameters',
        'IPDL-TDD-Parameters',
        'IPDL-TDD-Parameters-LCR',
        'IPMulticastIndication',
        'IPMulticastDataBearerIndication',
        'BurstModeParams',
        'IdleIntervalInformation',
        'In-Sync-Information-LCR',
        'LimitedPowerIncrease',
        'Local-Cell-ID',
        'LTGI-Presence',
        'LCRTDD-Uplink-Physical-Channel-Capability',
        'MAC-DTX-Cycle-2ms',
        'MAC-DTX-Cycle-10ms',
        'MAC-ehs-Reset-Timer',
        'MACdPDU-Size',
        'MAC-PDU-SizeExtended',
        'MAC-Inactivity-Threshold',
        'MACdPDU-Size-Indexlist',
        'MACdPDU-Size-IndexItem',
        'MACdPDU-Size-Indexlist-to-Modify',
        'MACdPDU-Size-IndexItem-to-Modify',
        'MACesGuaranteedBitRate',
        'MACes-Maximum-Bitrate-LCR',
        'MACeReset-Indicator',
        'MAChsGuaranteedBitRate',
        'MAChsReorderingBufferSize-for-RLC-UM',
        'MAC-hsWindowSize',
        'MAChsResetScheme',
        'MaximumDL-PowerCapability',
        'Max-Bits-MACe-PDU-non-scheduled',
        'Max-EDCH-Resource-Allocation-for-CCCH',
        'Max-EDCH-Resource-Allocation-for-CCCH-Extension',
        'Max-Period-for-Collision-Resolution',
        'Max-TB-Sizes',
        'Maximum-Number-of-Retransmissions-For-E-DCH',
        'Maximum-Target-ReceivedTotalWideBandPower-LCR',
        'MaximumTransmissionPower',
        'MaxNrOfUL-DPDCHs',
        'MaxPRACH-MidambleShifts',
        'Max-Set-E-DPDCHs',
        'Max-UE-DTX-Cycle',
        'MBMS-Capability',
        'MeasurementFilterCoefficient',
        'MeasurementID',
        'Measurement-Power-Offset',
        'MeasurementRecoveryBehavior',
        'MeasurementRecoveryReportingIndicator',
        'MeasurementRecoverySupportIndicator',
        'MessageStructure',
        'MICH-CFN',
        'MICH-Mode',
        'MidambleConfigurationLCR',
        'MidambleConfigurationBurstType1And3',
        'MidambleConfigurationBurstType2',
        'MidambleShiftAndBurstType',
        'MidambleShiftLong',
        'MidambleShiftShort',
        'MidambleShiftLCR',
        'MidambleAllocationMode',
        'MidambleShiftAndBurstType768',
        'MidambleConfigurationBurstType2-768',
        'MidambleShiftShort768',
        'MIMO-ActivationIndicator',
        'MIMO-Capability',
        'MIMO-Mode-Indicator',
        'MIMO-N-M-Ratio',
        'MIMO-PilotConfiguration',
        'MIMO-PilotConfigurationExtension',
        'MIMO-PowerOffsetForS-CPICHCapability',
        'MIMO-withfourtransmitantennas-ActivationIndicator',
        'MIMO-withfourtransmitantennas-Mode-Indicator',
        'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator',
        'DualStream-MIMO-withfourtransmitantennas-Mode-Indicator',
        'MIMO-withfourtransmitantennas-PilotConfiguration',
        'MIMO-withfourtransmitantennas-SCPICH',
        'MIMO-withfourtransmitantennas-SCPICH-Configuration',
        'PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas',
        'MinimumDL-PowerCapability',
        'MinimumReducedE-DPDCH-GainFactor',
        'MinSpreadingFactor',
        'Modification-Period',
        'ModifyPriorityQueue',
        'Modulation',
        'MinUL-ChannelisationCodeLength',
        'MultiplexingPosition',
        'MAChs-ResetIndicator',
        'ModulationMBSFN',
        'MBSFN-CPICH-secondary-CCPCH-power-offset',
        'ModulationPO-MBSFN',
        'MBSFN-Only-Mode-Indicator',
        'MBSFN-Only-Mode-Capability',
        'Multicarrier-Number',
        'MultipleFreq-HARQ-MemoryPartitioning-InformationList',
        'MultipleFreq-HARQ-MemoryPartitioning-InformationItem',
        'MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR',
        'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR',
        'Multi-Cell-Capability',
        'Multi-Cell-Capability-Info',
        'Multicell-EDCH-Information',
        'Multicell-EDCH-InformationItemIEs',
        'Multicell-EDCH-RL-Specific-Information',
        'Multicell-EDCH-RL-Specific-InformationItemIEs',
        'Multicell-EDCH-Restriction',
        'MIMO-SFMode-For-HSPDSCHDualStream',
        'Multi-Carrier-EDCH-Info',
        'Multicarrier-EDCH-Transport-Bearer-Mode',
        'Dual-Cell-EDCH-Enhancements-Information',
        'HS-SCCH-DRX-InformationFDD',
        'Multi-Carrier-EDCH-Information',
        'Multi-Carrier-EDCH-LCR-InformationItem',
        'SNPL-Carrier-Group-Indicator',
        'Multi-Carrier-EDCH-MACdFlows-Information-TDD',
        'Multi-Carrier-EDCH-MACdFlows-Specific-Info',
        'Multi-Carrier-EDCH-Reconfigure',
        'Continue-Setup-Change-Multi-Carrier-EDCH',
        'Multi-Carrier-EDCH-Change-Info',
        'Multi-Carrier-EDCH-Information-Removal-List',
        'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs',
        'Multi-Carrier-EDCH-Information-Response',
        'Multi-Carrier-EDCH-LCR-Information-ResponseItem',
        'Multiflow-Reconfiguration',
        'Multiflow-Information',
        'Multiflow-Information-To-Modify',
        'Multiflow-RepetitionFactors',
        'Multiflow-Stop',
        'Multiflow-Role',
        'Multiflow-MIMO',
        'Multiflow-Timing',
        'Multiflow-OrdinalNumberOfFrequency',
        'MU-MIMO-Capability-ContainerLCR',
        'MU-MIMO-InformationLCR',
        'Standalone-Midamble-Channel-Information-RequestLCR',
        'Standalone-Midamble-Channel-Information',
        'Standalone-Midamble-Configuratnion',
        'Standalone-MidambleShift',
        'Standalone-Midamble-RepetitionPeriod',
        'Standalone-Midamble-Offset',
        'ReferenceBeta',
        'MU-MIMO-Information-Response',
        'MU-MIMO-Information-To-ReconfigureLCR',
        'MU-MIMO-Information-To-Modify',
        'MU-MIMO-IndicatorLCR',
        'MU-MIMO-Usage-IndicatorLCR',
        'Nack-Power-Offset',
        'NCyclesPerSFNperiod',
        'NRepetitionsPerCyclePeriod',
        'N-INSYNC-IND',
        'N-OUTSYNC-IND',
        'N-PROTECT',
        'NeighbouringCellMeasurementInformation',
        'NodeB-Triggered-HSDPCCH-Transmission-Information',
        'Extension-neighbouringCellMeasurementInformation',
        'NeighbouringFDDCellMeasurementInformation',
        'NeighbouringTDDCellMeasurementInformation',
        'NeighbouringTDDCellMeasurementInformationLCR',
        'NeighbouringTDDCellMeasurementInformation768',
        'Non-rectangular-resource-allocation-indicator',
        'Non-rectangular-resource-timeslot-set',
        'NonCellSpecificTxDiversity',
        'Non-Serving-RL-Preconfig-Setup',
        'Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup',
        'New-non-serving-RL-setup-selection',
        'Non-Serving-RL-Preconfig-Info',
        'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList',
        'NI-Information',
        'Notification-Indicator',
        'NodeB-CommunicationContextID',
        'NormalAndDiversityPrimaryCPICHContainer',
        'NotificationIndicatorLength',
        'NumberOfReportedCellPortions',
        'NumberOfReportedCellPortionsLCR',
        'Number-of-PCCH-transmission',
        'NSubCyclesPerCyclePeriod',
        'N-E-UCCH',
        'N-E-UCCHLCR',
        'Number-Of-Supported-Carriers',
        'NumHS-SCCH-Codes',
        'NoOfTargetCellHS-SCCH-Order',
        'OrdinalNumberOfFrequency',
        'Out-of-Sychronization-Window',
        'One-level-DRX',
        'PagingIndicatorLength',
        'Paging-MACFlow-ID',
        'PayloadCRC-PresenceIndicator',
        'PCCPCH-Power',
        'PDSCH-ID',
        'PDSCH-ID768',
        'PDSCHSet-ID',
        'PICH-Mode',
        'PICH-Power',
        'Paging-MACFlows-to-DeleteFDD',
        'Paging-MACFlows-to-DeleteFDD-Item',
        'Paging-MACFlow-Specific-Information',
        'Paging-MAC-Flow-Specific-Information-Item',
        'Paging-MACFlow-PriorityQueue-Information',
        'Paging-MACFlow-PriorityQueue-Item',
        'Pattern-Sequence-Identifier',
        'PhysicalChannelID-for-CommonERNTI-RequestedIndicator',
        'PLCCHsequenceNumber',
        'PLCCHinformation',
        'Possible-Secondary-Serving-Cell-List',
        'Possible-Secondary-Serving-Cell',
        'PowerAdjustmentType',
        'PowerOffset',
        'PowerOffsetForSecondaryCPICHforMIMO',
        'PowerRaiseLimit',
        'PRACH-Midamble',
        'PRC',
        'PRCDeviation',
        'PrecodingWeightSetRestriction',
        'Precoder-Weight-Set-Restriction',
        'PreambleSignatures',
        'PreambleThreshold',
        'PredictedSFNSFNDeviationLimit',
        'PredictedTUTRANGPSDeviationLimit',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PrimaryAndSecondaryCPICHContainer',
        'PrimaryCPICH-Power',
        'Primary-CPICH-Usage-for-Channel-Estimation',
        'PrimaryScramblingCode',
        'PriorityLevel',
        'Priority-Queue-Information-for-Enhanced-FACH-PCH',
        'PriorityQueue-Id',
        'PriorityQueue-InfoList',
        'PriorityQueue-InfoItem',
        'PriorityQueue-InfoList-to-Modify',
        'PriorityQueue-InfoItem-to-Add',
        'PriorityQueue-InfoItem-to-Modify',
        'PriorityQueue-InfoList-to-Modify-Unsynchronised',
        'PriorityQueue-InfoItem-to-Modify-Unsynchronised',
        'PrimaryCCPCH-RSCP',
        'PrimaryCCPCH-RSCP-Delta',
        'PropagationDelay',
        'PRXdes-base',
        'SCH-TimeSlot',
        'PunctureLimit',
        'PUSCH-ID',
        'UE-Selected-MBMS-Service-Information',
        'Selected-MBMS-Service',
        'Selected-MBMS-Service-List',
        'Selected-MBMS-Service-Item',
        'Selected-MBMS-Service-TimeSlot-Information-LCR',
        'MBMS-Service-TDM-Information',
        'PUSCHSet-ID',
        'Paging-MACFlow-Specific-InformationLCR',
        'Paging-MAC-Flow-Specific-Information-ItemLCR',
        'Paging-MACFlows-to-DeleteLCR',
        'Paging-MACFlows-to-DeleteLCR-Item',
        'Process-Memory-Size',
        'Per-HARQ-Activiation-and-Deactiviation',
        'QE-Selector',
        'RACH-Measurement-Result',
        'RACH-SlotFormat',
        'RACH-SubChannelNumbers',
        'RL-Specific-DCH-Info',
        'RL-Specific-DCH-Info-Item',
        'RL-Specific-E-DCH-Info',
        'RL-Specific-E-DCH-Information',
        'RL-Specific-E-DCH-Information-Item',
        'Range-Correction-Rate',
        'Reference-ReceivedTotalWideBandPower',
        'Reference-ReceivedTotalWideBandPowerReporting',
        'Reference-ReceivedTotalWideBandPowerSupportIndicator',
        'ReferenceClockAvailability',
        'ReferenceSFNoffset',
        'Reference-E-TFCI-Information',
        'Reference-E-TFCI-Information-Item',
        'Reference-E-TFCI-PO',
        'RepetitionLength',
        'RepetitionPeriod',
        'RepetitionNumber0',
        'RepetitionNumber1',
        'RefTFCNumber',
        'ReportCharacteristics',
        'Extension-ReportCharacteristics',
        'ReportCharacteristicsType-EventA',
        'ReportCharacteristicsType-EventB',
        'ReportCharacteristicsType-EventC',
        'ReportCharacteristicsType-EventD',
        'ReportCharacteristicsType-EventE',
        'ReportCharacteristicsType-EventF',
        'ReportCharacteristicsType-OnModification',
        'ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold',
        'Extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold',
        'EDCH-RACH-Report-IncrDecrThres',
        'Granted-EDCH-RACH-Resources-Value',
        'Denied-EDCH-RACH-Resources-Value',
        'ReportCharacteristicsType-MeasurementThreshold',
        'Extension-ReportCharacteristicsType-MeasurementThreshold',
        'EDCH-RACH-Report-ThresholdInformation',
        'ReportCharacteristicsType-ScaledMeasurementChangeTime',
        'MeasurementChangeTime-Scaledmsec',
        'ReportCharacteristicsType-ScaledMeasurementHysteresisTime',
        'MeasurementHysteresisTime-Scaledmsec',
        'ReportCharacteristicsType-ReportPeriodicity',
        'ReportPeriodicity-Scaledmsec',
        'ReportPeriodicity-Scaledmin',
        'ReportPeriodicity-Scaledhour',
        'ResourceOperationalState',
        'RL-ID',
        'RL-Set-ID',
        'RLC-Mode',
        'DL-RLC-PDU-Size-Format',
        'Round-Trip-Time-IncrDecrThres',
        'RNC-ID',
        'Round-Trip-Time-Value',
        'RSCP-Value',
        'RSCP-Value-IncrDecrThres',
        'Received-total-wide-band-power-For-CellPortion-Value',
        'Received-total-wide-band-power-For-CellPortion-Value-Item',
        'Received-total-wide-band-power-For-CellPortion-ValueLCR',
        'Received-total-wide-band-power-For-CellPortion-ValueLCR-Item',
        'Received-total-wide-band-power-Value',
        'Received-total-wide-band-power-Value-IncrDecrThres',
        'Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value',
        'Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value-Item',
        'Received-Scheduled-EDCH-Power-Share-Value',
        'RSEPS-Value-IncrDecrThres',
        'RSEPS-Value',
        'RequestedDataValueInformation',
        'InformationAvailable',
        'InformationnotAvailable',
        'RequestedDataValue',
        'Rx-Timing-Deviation-Value',
        'Rx-Timing-Deviation-Value-LCR',
        'Rx-Timing-Deviation-Value-768',
        'Rx-Timing-Deviation-Value-384-ext',
        'RefBeta',
        'RTWP-ReportingIndicator',
        'RTWP-CellPortion-ReportingIndicator',
        'AdjustmentPeriod',
        'E-DPCCH-Power-Boosting-Capability',
        'SAT-ID',
        'SAT-Info-Almanac',
        'SAT-Info-Almanac-Item',
        'SAT-Info-Almanac-ExtList',
        'SAT-Info-Almanac-ExtItem',
        'SAT-Info-DGPSCorrections',
        'SAT-Info-DGPSCorrections-Item',
        'SATInfo-RealTime-Integrity',
        'SAT-Info-RealTime-Integrity-Item',
        'ScaledAdjustmentRatio',
        'MaxAdjustmentStep',
        'SchedulingInformation',
        'SecondaryServingCells',
        'SecondaryServingCellsItem',
        'Secondary-UL-Frequency-Activation-State',
        'SchedulingPriorityIndicator',
        'SID',
        'ScramblingCodeNumber',
        'Secondary-CPICH-Information-Change',
        'SecondaryCCPCH-SlotFormat',
        'Secondary-CCPCH-SlotFormat-Extended',
        'Segment-Type',
        'Serving-E-DCH-RL-ID',
        'Serving-E-DCH-RL-in-this-NodeB',
        'SetsOfHS-SCCH-Codes',
        'SetsOfHS-SCCH-CodesItem',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information',
        'Setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH',
        'SFN',
        'SFNSFN-FDD',
        'SFNSFN-TDD',
        'SFNSFN-TDD768',
        'SFNSFNChangeLimit',
        'SFNSFNDriftRate',
        'SFNSFNDriftRateQuality',
        'SFNSFNMeasurementThresholdInformation',
        'SFNSFNMeasurementValueInformation',
        'SFNSFNQuality',
        'ShutdownTimer',
        'SIB-Originator',
        'SIR-Error-Value',
        'SFNSFNTimeStampInformation',
        'SFNSFNTimeStamp-TDD',
        'SFNSFNValue',
        'Single-Stream-MIMO-ActivationIndicator',
        'Single-Stream-MIMO-Capability',
        'Single-Stream-MIMO-Mode-Indicator',
        'SIR-Error-Value-IncrDecrThres',
        'SIR-Value',
        'SIR-Value-IncrDecrThres',
        'SignallingBearerRequestIndicator',
        'SixtyfourQAM-UsageAllowedIndicator',
        'SixtyfourQAM-DL-UsageIndicator',
        'SixtyfourQAM-DL-Capability',
        'SixtyfourQAM-DL-MIMO-Combined-Capability',
        'SignatureSequenceGroupIndex',
        'SixteenQAM-UL-Capability',
        'SixteenQAM-UL-Operation-Indicator',
        'SixtyfourQAM-UL-Operation-Indicator',
        'SNPL-Reporting-Type',
        'Soffset',
        'SpecialBurstScheduling',
        'Start-Of-Audit-Sequence-Indicator',
        'Status-Flag',
        'STTD-Indicator',
        'SSDT-SupportIndicator',
        'Sub-Frame-Number',
        'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order',
        'SyncCase',
        'SYNCDlCodeId',
        'SyncFrameNumber',
        'SynchronisationReportCharacteristics',
        'SynchronisationReportCharactThreExc',
        'SynchronisationReportCharactThreInfoItem',
        'SynchronisationReportCharactCellSyncBurstInfoItem',
        'SyncDLCodeIdThreInfoLCR',
        'SyncDLCodeIdThreInfoList',
        'SyncDLCodeInfoListLCR',
        'SyncDLCodeInfoItemLCR',
        'SDPCCH-PowerOffsetInformation',
        'SynchronisationReportCharacteristicsType',
        'SynchronisationReportType',
        'Semi-PersistentScheduling-CapabilityLCR',
        'T1',
        'T321',
        'T333',
        'T-Cell',
        'T-RLFAILURE',
        'T-PROTECT',
        'T-SYNC',
        'TDD-AckNack-Power-Offset',
        'TDD-ChannelisationCode',
        'Puncturing-Handling-in-First-Rate-Matching-Stage',
        'TDD-ChannelisationCodeLCR',
        'TDD-ChannelisationCode768',
        'TDD-DL-Code-Information',
        'TDD-DL-Code-InformationItem',
        'TDD-DL-Code-LCR-Information',
        'TDD-DL-Code-LCR-InformationItem',
        'TDD-DL-Code-768-Information',
        'TDD-DL-Code-768-InformationItem',
        'TDD-DL-DPCH-TimeSlotFormat-LCR',
        'QPSK-DL-DPCH-TimeSlotFormatTDD-LCR',
        'EightPSK-DL-DPCH-TimeSlotFormatTDD-LCR',
        'TDD-DPCHOffset',
        'TDD-PhysicalChannelOffset',
        'TDD-TPC-DownlinkStepSize',
        'TDD-TPC-UplinkStepSize-LCR',
        'TransportFormatCombination-Beta',
        'TDD-UL-Code-Information',
        'TDD-UL-Code-InformationItem',
        'TDD-UL-Code-LCR-Information',
        'TDD-UL-Code-LCR-InformationItem',
        'TDD-UL-Code-768-Information',
        'TDD-UL-Code-768-InformationItem',
        'TDD-UL-DPCH-TimeSlotFormat-LCR',
        'QPSK-UL-DPCH-TimeSlotFormatTDD-LCR',
        'EightPSK-UL-DPCH-TimeSlotFormatTDD-LCR',
        'TFCI-Coding',
        'TFCI-Presence',
        'TFCI-SignallingMode',
        'TFCI-SignallingMode-TFCI-SignallingOption',
        'TGD',
        'TGPRC',
        'TGPSID',
        'TGSN',
        'TimeSlot',
        'TimeSlotDirection',
        'TimeSlot-InitiatedListLCR',
        'TimeSlotLCR',
        'TimeslotLCR-Extension',
        'TimeSlotMeasurementValueListLCR',
        'TimeSlotMeasurementValueLCR',
        'TimeSlotStatus',
        'TimingAdjustmentValue',
        'TimingAdjustmentValueLCR',
        'TimingAdvanceApplied',
        'SynchronisationIndicator',
        'TnlQos',
        'ToAWE',
        'ToAWS',
        'Transmission-Gap-Pattern-Sequence-Information',
        'TransmissionGapPatternSequenceCodeInformation',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue-Item',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue-Item',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue',
        'Transmitted-Carrier-Power-For-CellPortion-Value',
        'Transmitted-Carrier-Power-For-CellPortion-Value-Item',
        'Transmitted-Carrier-Power-For-CellPortion-ValueLCR',
        'Transmitted-Carrier-Power-For-CellPortion-ValueLCR-Item',
        'Transmitted-Carrier-Power-Value',
        'Transmitted-Code-Power-Value',
        'Transmitted-Code-Power-Value-IncrDecrThres',
        'TransmissionDiversityApplied',
        'TransmitDiversityIndicator',
        'TFCS',
        'TFCS-TFCSList',
        'TFCS-CTFC',
        'TPC-slot-position',
        'Transport-Block-Size-Index',
        'Transport-Block-Size-Index-for-Enhanced-PCH',
        'Transport-Block-Size-List',
        'TransportBearerRequestIndicator',
        'TransportBearerNotRequestedIndicator',
        'TransportBearerNotSetupIndicator',
        'TransportFormatSet',
        'TransportFormatSet-DynamicPartList',
        'TDD-TransportFormatSet-ModeDP',
        'TransmissionTimeIntervalInformation',
        'TransportFormatSet-Semi-staticPart',
        'TransportFormatSet-ChannelCodingType',
        'TransportFormatSet-CodingRate',
        'TransportFormatSet-CRC-Size',
        'TransportFormatSet-ModeDP',
        'TransportFormatSet-ModeSSP',
        'TransportFormatSet-NrOfTransportBlocks',
        'TransportFormatSet-RateMatchingAttribute',
        'TransportFormatSet-SecondInterleavingMode',
        'TransportFormatSet-TransmissionTimeIntervalDynamic',
        'TransportFormatSet-TransmissionTimeIntervalSemiStatic',
        'TransportFormatSet-TransportBlockSize',
        'TransportLayerAddress',
        'TS0-CapabilityLCR',
        'TSTD-Indicator',
        'TSN-Length',
        'TUTRANGANSS',
        'TUTRANGANSSAccuracyClass',
        'TUTRANGANSSMeasurementThresholdInformation',
        'TUTRANGANSSMeasurementValueInformation',
        'TUTRANGPS',
        'TUTRANGPSChangeLimit',
        'TUTRANGPSDriftRate',
        'TUTRANGPSDriftRateQuality',
        'TUTRANGPSAccuracyClass',
        'TUTRANGPSMeasurementThresholdInformation',
        'TUTRANGPSMeasurementValueInformation',
        'TUTRANGPSQuality',
        'TxDiversityOnDLControlChannelsByMIMOUECapability',
        'TypeOfError',
        'Two-ms-Overridden-E-DCH-RACH-Resources',
        'Two-ms-Grant-E-DCH-RACH-Resources',
        'Two-ms-Denied-E-DCH-RACH-Resources',
        'Two-msand10msTTI-Concurrent-Deployment-Capability',
        'Two-level-DRX',
        'T32x',
        'T32y',
        'UARFCN',
        'UC-Id',
        'UDRE',
        'UDREGrowthRate',
        'UDREValidityTime',
        'UE-AggregateMaximumBitRate',
        'UE-AggregateMaximumBitRateDownlink',
        'UE-AggregateMaximumBitRateUplink',
        'UE-AggregateMaximumBitRate-Enforcement-Indicator',
        'UE-Capability-Information',
        'UE-RF-Band-CapabilityLCR',
        'Radio-Frequency-BandItem',
        'UE-TS0-CapabilityLCR',
        'Radio-Frequency-Band',
        'UE-Support-of-non-rectangular-resource-allocation',
        'UE-SupportIndicatorExtension',
        'LCRTDD-HSDSCH-Physical-Layer-Category',
        'UE-DPCCH-burst1',
        'UE-DPCCH-burst2',
        'UE-DRX-Cycle',
        'UE-DRX-Grant-Monitoring',
        'UE-DTX-Cycle1-2ms',
        'UE-DTX-Cycle1-10ms',
        'UE-DTX-Cycle2-2ms',
        'UE-DTX-Cycle2-ext-2ms',
        'UE-DTX-Cycle2-10ms',
        'UE-DTX-DRX-Offset',
        'UE-DTX-Long-Preamble',
        'UE-transmission-power-headroom-Value',
        'UE-Measurement-Value',
        'Extension-UE-Measurement-Value',
        'UPHFiltering-Value',
        'UL-CapacityCredit',
        'UL-Delta-T2TP',
        'UL-DL-mode',
        'UL-DPDCH-Indicator-For-E-DCH-Operation',
        'Uplink-Compressed-Mode-Method',
        'UL-Timeslot-Information',
        'UL-Timeslot-InformationItem',
        'UL-TimeslotLCR-Information',
        'UL-TimeslotLCR-InformationItem',
        'UL-Timeslot768-Information',
        'UL-Timeslot768-InformationItem',
        'UL-DPCCH-SlotFormat',
        'UL-SIR',
        'UL-FP-Mode',
        'UL-PhysCH-SF-Variation',
        'UL-ScramblingCode',
        'UL-ScramblingCodeNumber',
        'UL-ScramblingCodeLength',
        'UL-Synchronisation-Parameters-LCR',
        'UL-Synchronisation-StepSize',
        'UL-Synchronisation-Frequency',
        'UPPCHPositionLCR',
        'UL-TimeSlot-ISCP-Info',
        'UL-TimeSlot-ISCP-InfoItem',
        'UL-TimeSlot-ISCP-LCR-Info',
        'UL-TimeSlot-ISCP-LCR-InfoItem',
        'UpPTSInterference-For-CellPortion-Value',
        'UpPTSInterference-For-CellPortion-Value-Item',
        'UpPTSInterferenceValue',
        'Unidirectional-DCH-Indicator',
        'USCH-Information',
        'USCH-InformationItem',
        'USCH-InformationResponse',
        'USCH-InformationResponseItem',
        'UL-CLTD-Information',
        'UL-CLTD-Information-Reconf',
        'UL-CLTD-Information-To-Modify',
        'UL-CLTD-Information-Removal',
        'UL-CLTD-State-Update-Information',
        'UL-CLTD-Activation-Information',
        'UL-DPCCH2-Information',
        'UL-DPCCH2-Information-Reconf',
        'UL-DPCCH2-Information-Removal',
        'UL-DPCCH2-Information-To-Modify',
        'UL-MIMO-Information',
        'UL-MIMO-Information-To-Modify',
        'UL-MIMO-Reconfiguration',
        'UL-MIMO-Removal',
        'UL-MIMO-DL-Control-Channel-Information',
        'E-ROCH-PowerOffset',
        'S-E-DPCCH-PowerOffset',
        'InterStream-Interference-Compensation',
        'S-E-ROCH-Release-Indicator',
        'UL-TimeslotISCP-For-CellPortion-Value',
        'UL-TimeslotISCP-For-CellPortion-Value-Item',
        'UL-TimeslotISCP-Value',
        'UL-TimeslotISCP-Value-IncrDecrThres',
        'USCH-ID',
        'Usefulness-Of-Battery-Optimization',
        'Uu-ActivationState',
        ]
    _set_ = [
        'ActivationInformationItem-ExtIEs',
        'EDCH-Reference-E-TFCI-Information-Item-ExtIEs',
        'Additional-EDCH-Setup-Info-ExtIEs',
        'Additional-EDCH-FDD-Setup-Cell-Information-ExtIEs',
        'Additional-EDCH-UL-DPCH-Information-Setup-ExtIEs',
        'Additional-EDCH-F-DPCH-Information-ExtIEs',
        'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs-ExtIEs',
        'Additional-EDCH-Cell-Information-To-Add-ItemIEs-ExtIEs',
        'EDCH-Additional-RL-Specific-Information-To-Add-List-ExtIEs',
        'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs-ExtIEs',
        'Additional-EDCH-FDD-Information-ExtIEs',
        'DTX-Information2-ExtIEs',
        'Additional-EDCH-MAC-d-Flows-Specific-Info-ExtIEs',
        'Additional-EDCH-FDD-Information-Response-ItemIEs-ExtIEs',
        'EDCH-Additional-RL-Specific-Information-Response-ItemIEs-ExtIEs',
        'Additional-EDCH-FDD-Information-Response-RLReconf-Items-ExtIEs',
        'Additional-Modififed-EDCH-FDD-Information-Response-ItemIEs-ExtIEs',
        'EDCH-Additional-Modified-RL-Specific-Information-Response-List-Items-ExtIEs',
        'Additional-EDCH-MAC-d-Flows-Specific-Info-Response-ExtIEs',
        'Additional-EDCH-Cell-Information-Response-RL-Add-ItemIEs-ExtIEs',
        'Additional-EDCH-ConfigurationChange-Info-ItemIEs-ExtIEs',
        'Additional-EDCH-UL-DPCH-Information-Modify-ExtIEs',
        'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs-ExtIEs',
        'Additional-EDCH-FDD-Update-Information-ExtIEs',
        'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs-ExtIEs',
        'AdditionalMeasurementValueList-ExtIEs',
        'AdditionalTimeSlotLCR-ExtIEs',
        'Active-Pattern-Sequence-Information-ExtIEs',
        'Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs',
        'AllocationRetentionPriority-ExtIEs',
        'Angle-Of-Arrival-Value-LCR-ExtIEs',
        'AOA-per-CELL-Portion-LCR-Item-ExtIEs',
        'BCCH-Specific-HSDSCH-RNTI-Information-ExtIEs',
        'BCCH-Specific-HSDSCH-RNTI-InformationLCR-ExtIEs',
        'BDS-IGPInfo-ExtIEs',
        'BDS-Ionospheric-Grid-Model-ExtIEs',
        'Best-Cell-Portions-Item-ExtIEs',
        'Best-Cell-Portions-ItemLCR-ExtIEs',
        'BroadcastCommonTransportBearerIndication-ExtIEs',
        'CommonChannelsCapacityConsumptionLaw-ExtIEs',
        'Common-EDCH-System-InformationFDD-ExtIEs',
        'E-RNTI-Set-ExtIEs',
        'Common-E-DCH-UL-DPCH-InfoItem-ExtIEs',
        'Common-E-DCH-EDPCH-InfoItem-ExtIEs',
        'Common-E-DCH-InfoItem-ExtIEs',
        'Common-E-DCH-HSDPCCH-InfoItem-ExtIEs',
        'Common-E-DCH-CQI-Info-ExtIEs',
        'Common-E-DCH-Preamble-Control-InfoItem-ExtIEs',
        'Common-E-DCH-AICH-Information-ExtIEs',
        'Common-E-DCH-FDPCH-InfoItem-ExtIEs',
        'Common-E-DCH-Resource-Combination-InfoList-Item-ExtIEs',
        'Common-E-DCH-MAC-d-flow-info-Concurrent-TTI-ExtIEs',
        'Ul-common-E-DCH-MACflow-Specific-InfoList-Item-ExtIEs',
        'Common-E-DCH-MACdFlow-Specific-InfoList-Item-ExtIEs',
        'Common-E-DCH-LogicalChannel-InfoList-Item-ExtIEs',
        'Common-EDCH-System-Information-ResponseFDD-ExtIEs',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-Item-ExtIEs',
        'Common-MACFlows-to-DeleteFDD-Item-ExtIEs',
        'CommonMACFlow-Specific-InfoItem-ExtIEs',
        'CommonMACFlow-Specific-InfoItem-Response-ExtIEs',
        'Common-MACFlow-PriorityQueue-Item-ExtIEs',
        'Extension-CommonMeasurementValueIE',
        'CommonMeasurementAvailableItem-ExtIEs',
        'Common-PhysicalChannel-Status-Information-ExtIEs',
        'Common-PhysicalChannel-Status-Information768-ExtIEs',
        'CommonTransportChannel-InformationResponse-ExtIEs',
        'Common-TransportChannel-Status-Information-ExtIEs',
        'ContinuousPacketConnectivityDTX-DRX-Information-ExtIEs',
        'ContinuousPacketConnectivityDTX-DRX-Information-to-Modify-ExtIEs',
        'ContinuousPacketConnectivityHS-SCCH-less-Information-ExtIEs',
        'ContinuousPacketConnectivityHS-SCCH-less-Information-Response-ExtIEs',
        'CPC-Information-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'Common-EDCH-System-InformationLCR-ExtIEs',
        'Common-E-PUCH-InformationLCR-ExtIEs',
        'PRXdes-base-Item-ExtIEs',
        'Ul-common-E-DCH-MACflow-Specific-InfoList-ItemLCR-ExtIEs',
        'Common-E-DCH-MACdFlow-Specific-InfoList-ItemLCR-ExtIEs',
        'Common-EDCH-System-Information-ResponseLCR-ExtIEs',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-ItemLCR-ExtIEs',
        'Common-E-AGCH-ItemLCR-ExtIEs',
        'Common-E-HICH-ItemLCR-ExtIEs',
        'Common-E-RNTI-Info-ItemLCR-ExtIEs',
        'Common-MACFlows-to-DeleteLCR-Item-ExtIEs',
        'CommonMACFlow-Specific-InfoItemLCR-ExtIEs',
        'Common-H-RNTI-InfoItemLCR-ExtIEs',
        'Sync-InformationLCR-ExtIEs',
        'CommonMACFlow-Specific-InfoItem-ResponseLCR-ExtIEs',
        'CPC-InformationLCR-ExtIEs',
        'ContinuousPacketConnectivity-DRX-InformationLCR-ExtIEs',
        'HS-SCCH-DRX-Information-LCR-ExtIEs',
        'E-AGCH-DRX-Parameters-ExtIEs',
        'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR-ExtIEs',
        'DRX-Information-to-Modify-Items-LCR-ExtIEs',
        'ContinuousPacketConnectivity-DRX-Information-ResponseLCR-ExtIEs',
        'HS-SCCH-DRX-Information-ResponseLCR-ExtIEs',
        'E-AGCH-DRX-Parameters-Response-ExtIEs',
        'Common-E-RGCH-InfoFDD-ExtIEs',
        'Concurrent-Deployment-of-2msand10ms-TTI-ExtIEs',
        'Common-E-DCH-System-Info-Parameters-for-Concurrent-TTI-ExtIEs',
        'Common-E-DCH-HS-DPCCH-Information-forConcurrentTTI-ExtIEs',
        'Common-E-DCH-Preamble-Control-Information-extensionList-Item-ExtIEs',
        'Common-E-DCH-Preamble-Control-Information-extension-Item-ExtIEs',
        'Configuration-for-2msTTI-Common-E-DCH-ResourcesList-Item-ExtIEs',
        'DBDS-CorrectionsReq-ExtIEs',
        'DBDS-Corrections-ExtIEs',
        'DBDS-Info-ExtIEs',
        'DBDS-SignalInfo-ExtIEs',
        'DCH-ENH-Information-ExtIEs',
        'DCH-ENH-Information-to-Modify-ExtIEs',
        'DCH-ENH-Information-Reconf-ExtIEs',
        'DCH-FDD-InformationItem-ExtIEs',
        'DCH-Specific-FDD-Item-ExtIEs',
        'DCH-InformationResponseItem-ExtIEs',
        'DCH-MeasurementOccasion-Information-ExtIEs',
        'Measurement-Occasion-Pattern-Sequence-parameters-ExtIEs',
        'DCH-TDD-InformationItem-ExtIEs',
        'DCH-Specific-TDD-Item-ExtIEs',
        'FDD-DCHs-to-ModifyItem-ExtIEs',
        'DCH-ModifySpecificItem-FDD-ExtIEs',
        'TDD-DCHs-to-ModifyItem-ExtIEs',
        'DCH-ModifySpecificItem-TDD-ExtIEs',
        'DedicatedChannelsCapacityConsumptionLaw-ExtIEs',
        'Extension-DedicatedMeasurementValueIE',
        'DedicatedMeasurementAvailableItem-ExtIEs',
        'Activate-Info-ExtIEs',
        'Deactivate-Info-ExtIEs',
        'DGANSSCorrections-ExtIEs',
        'DGANSS-Corrections-Req-ExtIEs',
        'DGANSS-InformationItem-ExtIEs',
        'DGANSS-SignalInformationItem-ExtIEs',
        'DGANSSThreshold-ExtIEs',
        'DGNSS-ValidityPeriod-ExtIEs',
        'DGPSCorrections-ExtIEs',
        'DGPSThresholds-ExtIEs',
        'DL-TBS-ExtIEs',
        'HS-DSCH-Cell-ExtIEs',
        'DL-Timeslot-InformationItem-ExtIEs',
        'DL-TimeslotLCR-InformationItem-ExtIEs',
        'DL-Timeslot768-InformationItem-ExtIEs',
        'DL-PowerBalancing-Information-ExtIEs',
        'DL-ReferencePowerInformationItem-ExtIEs',
        'DL-TimeslotISCPInfoItem-ExtIEs',
        'DL-TimeslotISCPInfoItemLCR-ExtIEs',
        'DL-HS-PDSCH-Timeslot-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'MaxHSDSCH-HSSCCH-Power-per-CELLPORTION-Item-ExtIEs',
        'Downlink-TPC-enhancements-Information-ExtIEs',
        'Downlink-TPC-enhancements-Reconf-ExtIEs',
        'DRX-Information-ExtIEs',
        'DRX-Information-to-Modify-Items-ExtIEs',
        'DSCH-InformationResponseItem-ExtIEs',
        'DSCH-TDD-InformationItem-ExtIEs',
        'DTX-Cycle-2ms-Items-ExtIEs',
        'DTX-Cycle-2ms-to-Modify-Items-ExtIEs',
        'DTX-Cycle-10ms-Items-ExtIEs',
        'DTX-Cycle-10ms-to-Modify-Items-ExtIEs',
        'DTX-Information-ExtIEs',
        'DTX-Information-to-Modify-Items-ExtIEs',
        'Dual-Band-Capability-Info-ExtIEs',
        'E-DCHCapacityConsumptionLaw-ExtIEs',
        'E-DCH-TDD-CapacityConsumptionLaw-ExtIEs',
        'E-DCH-SF-allocation-ExtIEs',
        'E-DCH-FDD-DL-Control-Channel-Information-ExtIEs',
        'E-DCH-FDD-Information-ExtIEs',
        'E-DCH-FDD-Information-Response-ExtIEs',
        'E-DCH-FDD-Information-to-Modify-ExtIEs',
        'E-DCH-FDD-Update-Information-ExtIEs',
        'E-DCH-MACdFlow-Specific-UpdateInformation-Item-ExtIEs',
        'E-DCH-DL-Control-Channel-Change-Information-Item-ExtIEs',
        'E-DCH-DL-Control-Channel-Grant-Information-Item-ExtIEs',
        'E-DCH-LogicalChannelInformationItem-ExtIEs',
        'E-DCH-MACdPDU-SizeListItem-ExtIEs',
        'E-DCH-LogicalChannelToModifyItem-ExtIEs',
        'E-DCH-LogicalChannelToDeleteItem-ExtIEs',
        'E-DCH-MACdFlows-Information-ExtIEs',
        'E-DCH-MACdFlow-Specific-InfoItem-ExtIEs',
        'E-DCH-MACdFlow-Specific-InformationResp-Item-ExtIEs',
        'E-DCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs',
        'E-DCH-MACdFlow-to-Delete-Item-ExtIEs',
        'E-DCH-Non-Scheduled-Transmission-Grant-Items-ExtIEs',
        'E-DCH-serving-cell-informationResponse-ExtIEs',
        'E-DCH-serving-cell-change-successful-ExtIEs',
        'E-DCH-RL-InformationList-Rsp-Item-ExtIEs',
        'E-DCH-serving-cell-change-unsuccessful-ExtIEs',
        'EDCH-RACH-Report-Value-ExtIEs',
        'E-DCH-MACdFlow-to-Delete-ItemLCR-ExtIEs',
        'Enhanced-UE-DRX-InformationLCR-ExtIEs',
        'E-TFCI-Boost-Information-ExtIEs',
        'E-TFCS-Information-ExtIEs',
        'E-DCHProvidedBitRate-Item-ExtIEs',
        'E-DCHProvidedBitRateValueInformation-For-CellPortion-Item-ExtIEs',
        'E-DCH-Information-ExtIEs',
        'E-PUCH-Information-ExtIEs',
        'E-TFCS-Information-TDD-ExtIEs',
        'E-DCH-MACdFlow-InfoTDDItem-ExtIEs',
        'E-DCH-Non-Scheduled-Grant-Info-ExtIEs',
        'E-DCH-TDD-Information-ExtIEs',
        'E-DCH-Information-Response-ExtIEs',
        'Scheduled-E-HICH-Specific-InformationItem-ResponseLCRTDD-ExtIEs',
        'E-DCH-TDD-MACdFlow-Specific-InformationRespItem-ExtIEs',
        'E-AGCH-Specific-InformationResp-ItemTDD-ExtIEs',
        'E-DCH-Information-Reconfig-ExtIEs',
        'E-DCH-TDD-Information-to-Modify-ExtIEs',
        'E-DCH-MACdFlow-ModifyTDDItem-ExtIEs',
        'E-DCH-768-Information-ExtIEs',
        'E-DCH-Non-Scheduled-Grant-Info768-ExtIEs',
        'E-DCH-TDD-Information768-ExtIEs',
        'E-DCH-768-Information-Reconfig-ExtIEs',
        'E-DCH-LCR-Information-ExtIEs',
        'E-PUCH-LCR-Information-ExtIEs',
        'E-DCH-Non-Scheduled-Grant-LCR-Info-ExtIEs',
        'E-HICH-LCR-Information-ExtIEs',
        'E-DCH-LCRTDD-Information-ExtIEs',
        'E-DCH-LCR-Information-Reconfig-ExtIEs',
        'Enhanced-UE-DRX-InformationFDD-ExtIEs',
        'Radio-Links-without-DPCH-FDPCH-Information-ExtIEs',
        'E-DCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        'FDD-DL-CodeInformationItem-ExtIEs',
        'F-DPCH-Info-ExtIEs',
        'F-DPCH-Info-To-Modify-ExtIEs',
        'FTPICH-Information-ExtIEs',
        'FTPICH-Information-To-Modify-ExtIEs',
        'FTPICH-Information-Reconf-ExtIEs',
        'Further-Enhanced-UE-DRX-InformationFDD-ExtIEs',
        'SignalledGainFactors10ms-ExtIEs',
        'GANSS-Additional-Ionospheric-Model-ExtIEs',
        'GANSS-Additional-Navigation-Models-ExtIEs',
        'GANSS-Almanac-ExtIEs',
        'Extension-GANSS-AlmanacModel-IE',
        'GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs',
        'GANSS-ALM-GlonassAlmanacSet-ExtIEs',
        'GANSS-ALM-MidiAlmanacSet-ExtIEs',
        'GANSS-ALM-NAVKeplerianSet-ExtIEs',
        'GANSS-ALM-KEPLERIANBDSALMANAC-ExtIEs',
        'GANSS-ALM-ReducedKeplerianSet-ExtIEs',
        'GANSS-AuxInfoGANSS-ID1-element-ExtIEs',
        'GANSS-AuxInfoGANSS-ID3-element-ExtIEs',
        'GANSS-BDSclockModel-ExtIEs',
        'GANSS-CNAVclockModel-ExtIEs',
        'GANSS-Common-Data-ExtIEs',
        'GANSS-CommonDataInfoReq-ExtIEs',
        'GANSS-Data-Bit-Assistance-ExtIEs',
        'GANSS-DataBitAssistanceItem-ExtIEs',
        'GANSS-DataBitAssistanceSgnItem-ExtIEs',
        'GANSS-Data-Bit-Assistance-ReqItem-ExtIEs',
        'GANSS-Data-Bit-Assistance-ReqList-ExtIEs',
        'GANSS-DeltaUT1-ExtIEs',
        'GANSS-Earth-Orientation-Parameters-ExtIEs',
        'GANSS-GenericDataInfoReqItem-ExtIEs',
        'GANSS-Generic-DataItem-ExtIEs',
        'GANSS-GLONASSclockModel-ExtIEs',
        'GANSS-Information-ExtIEs',
        'GANSS-Ionospheric-Model-ExtIEs',
        'GANSS-IonosphereRegionalStormFlags-ExtIEs',
        'GANSS-KeplerianParametersAlm-ExtIEs',
        'GANSS-KeplerianParametersOrb-ExtIEs',
        'GANSS-NAVclockModel-ExtIEs',
        'GANSS-Navigation-Model-And-Time-Recovery-ExtIEs',
        'GANSS-NavModel-BDSKeplerianSet-ExtIEs',
        'GANSS-NavModel-CNAVKeplerianSet-ExtIEs',
        'GANSS-NavModel-GLONASSecef-ExtIEs',
        'GANSS-NavModel-NAVKeplerianSet-ExtIEs',
        'GANSS-NavModel-SBASecef-ExtIEs',
        'GANSS-RealTimeInformationItem-ExtIEs',
        'GANSS-RX-Pos-ExtIEs',
        'GANSS-SatelliteClockModelItem-ExtIEs',
        'GANSS-SatelliteInformationKPItem-ExtIEs',
        'Ganss-Sat-Info-AddNavList-ExtIEs',
        'GANSS-SAT-Info-Almanac-BDS-ExtIEs',
        'GANSS-SAT-Info-Almanac-GLOkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-NAVkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-REDkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-SBASecef-ExtIEs',
        'GANSS-Sat-Info-Nav-ExtIEs',
        'GANSS-SBASclockModel-ExtIEs',
        'GANSS-Time-Model-ExtIEs',
        'GANSS-Transmission-Time-ExtIEs',
        'GANSS-UTC-Model-ExtIEs',
        'GANSS-UTCmodelSet1-ExtIEs',
        'GANSS-UTCmodelSet2-ExtIEs',
        'GANSS-UTCmodelSet3-ExtIEs',
        'GANSS-UTCmodelSet4-ExtIEs',
        'GPS-Almanac-ExtIEs',
        'GPS-Ionospheric-Model-ExtIEs',
        'GPSBadSat-Info-RealTime-Integrity-ExtIEs',
        'GPS-NavandRecovery-Item-ExtIEs',
        'GPS-RX-POS-ExtIEs',
        'GPS-UTC-Model-ExtIEs',
        'HARQ-MemoryPartitioning-Implicit-ExtIEs',
        'HARQ-MemoryPartitioning-Explicit-ExtIEs',
        'HARQ-MemoryPartitioningItem-ExtIEs',
        'HS-DSCHProvidedBitRate-Item-ExtIEs',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortion-Item-ExtIEs',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR-Item-ExtIEs',
        'HS-DSCHRequiredPower-Item-ExtIEs',
        'HS-DSCHRequiredPowerPerUEInformation-Item-ExtIEs',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortion-Item-ExtIEs',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR-Item-ExtIEs',
        'HSDSCH-Common-System-InformationFDD-ExtIEs',
        'HSDSCH-Common-System-Information-ResponseFDD-ExtIEs',
        'HSDSCH-Common-Information-ExtIEs',
        'HSDSCH-FDD-Information-ExtIEs',
        'HSDSCH-TDD-Information-ExtIEs',
        'HSDSCH-Information-to-Modify-ExtIEs',
        'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs',
        'HSDSCH-Information-to-Modify-Unsynchronised-ExtIEs',
        'HSDSCH-FDD-Information-Response-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Information-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Information-Respons-ExtIEs',
        'HS-DSCH-Secondary-Serving-Information-To-Modify-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Update-Information-ExtIEs',
        'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response-ExtIEs',
        'HS-Secondary-Serving-cell-change-successful-ExtIEs',
        'HS-Secondary-Serving-cell-change-unsuccessful-ExtIEs',
        'HSDSCH-Paging-System-InformationFDD-ExtIEs',
        'HSDSCH-Paging-System-Information-ResponseList-ExtIEs',
        'HSDSCH-TDD-Information-Response-ExtIEs',
        'HSDSCH-MACdFlow-Specific-InformationRespItem-ExtIEs',
        'HSDSCH-MACdFlows-Information-ExtIEs',
        'HSDSCH-MACdFlow-Specific-InfoItem-ExtIEs',
        'HSDSCH-MACdFlows-to-Delete-Item-ExtIEs',
        'HSDSCH-Initial-Capacity-AllocationItem-ExtIEs',
        'HSDSCH-PreconfigurationInfo-ExtIEs',
        'Additional-EDCH-Preconfiguration-Information-ItemIEs-ExtIEs',
        'HSDSCHPreconfigurationSetup-ExtIEs',
        'HS-SCCH-PreconfiguredCodesItem-ExtIEs',
        'HSSCCH-Specific-InformationRespItemFDD-ExtIEs',
        'HSSCCH-Specific-InformationRespItemTDD-ExtIEs',
        'HSSCCH-Specific-InformationRespItemTDDLCR-ExtIEs',
        'HSSCCH-Specific-InformationRespItemTDD768-ExtIEs',
        'HSSICH-Info-ExtIEs',
        'HSSICH-Info-LCR-ExtIEs',
        'HSSICH-Info-768-ExtIEs',
        'HS-SICH-Reception-Quality-Value-ExtIEs',
        'HS-PDSCH-FDD-Code-Information-ExtIEs',
        'HS-DSCH-Serving-Cell-Change-Info-ExtIEs',
        'HS-DSCH-serving-cell-informationResponse-ExtIEs',
        'HS-serving-cell-change-successful-ExtIEs',
        'HS-serving-cell-change-unsuccessful-ExtIEs',
        'HSDSCH-FDD-Update-Information-ExtIEs',
        'HSDSCH-TDD-Update-Information-ExtIEs',
        'HSDPA-PICH-notShared-with-PCHLCR-ExtIEs',
        'HSDSCH-Common-System-InformationLCR-ExtIEs',
        'HSDSCH-Common-System-Information-ResponseLCR-ExtIEs',
        'HSDSCH-Common-InformationLCR-ExtIEs',
        'HSDSCH-Paging-System-InformationLCR-ExtIEs',
        'HSDSCH-Paging-System-Information-ResponseListLCR-ExtIEs',
        'HSSCCH-Specific-InformationRespItemLCR-ExtIEs',
        'HS-DSCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        'Transport-Block-Size-Item-LCR-ExtIEs',
        'Repetition-Period-Item-LCR-ExtIEs',
        'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        'HS-SICH-InformationItem-for-HS-DSCH-SPS-ExtIEs',
        'Initial-HS-PDSCH-SPS-Resource-ExtIEs',
        'Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'Non-HS-SCCH-Associated-HS-SICH-InformationItem-ExtIEs',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationItem-ExtIEs',
        'HSSICH-ReferenceSignal-InformationLCR-ExtIEs',
        'HSSICH-ReferenceSignal-InformationModifyLCR-ExtIEs',
        'IMB-Parameters-ExtIEs',
        'BCH-ParametersItem-ExtIEs',
        'InformationReportCharacteristicsType-OnModification-ExtIEs',
        'Information-Type-ExtIEs',
        'IPDLFDDParameter-ExtIEs',
        'IPMulticastIndication-ExtIEs',
        'IPDLTDDParameter-ExtIEs',
        'IPDLTDDParameterLCR-ExtIEs',
        'LCRTDD-Uplink-Physical-Channel-Capability-ExtIEs',
        'MACdPDU-Size-IndexItem-ExtIEs',
        'MACdPDU-Size-IndexItem-to-Modify-ExtIEs',
        'Max-TB-Sizes-ExtIEs',
        'MessageStructure-ExtIEs',
        'MidambleShiftLCR-ExtIEs',
        'MIMO-withfourtransmitantennas-SCPICH-Configuration-Item-ExtIEs',
        'MultipleFreq-HARQ-MemoryPartitioning-InformationItem-ExtIEs',
        'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR-ExtIEs',
        'Multi-Cell-Capability-Info-ExtIEs',
        'Multicell-EDCH-InformationItem',
        'Multicell-EDCH-InformationItemIEs-ExtIEs',
        'Multicell-EDCH-RL-Specific-InformationItem',
        'Multicell-EDCH-RL-Specific-InformationItemIEs-ExtIEs',
        'Multi-Carrier-EDCH-Info-ExtIEs',
        'Dual-Cell-EDCH-Enhancements-Information-ExtIEs',
        'HS-SCCH-DRX-InformationFDD-ExtIEs',
        'Multi-Carrier-EDCH-LCR-InformationItem-ExtIEs',
        'Multi-Carrier-EDCH-MACdFlows-Specific-Info-ExtIEs',
        'Multi-Carrier-EDCH-Reconfigure-ExtIEs',
        'Multi-Carrier-EDCH-Change-Info-ExtIEs',
        'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs-ExtIEs',
        'Multi-Carrier-EDCH-LCR-Information-ResponseItem-ExtIEs',
        'Multiflow-Information-ExtIEs',
        'Multiflow-Information-To-Modify-ExtIEs',
        'Multiflow-RepetitionFactors-ExtIEs',
        'Standalone-Midamble-Channel-Information-ExtIEs',
        'MU-MIMO-InformationLCR-ExtIEs',
        'MU-MIMO-Information-Response-ExtIEs',
        'MU-MIMO-Information-To-Modify-ExtIEs',
        'NodeB-Triggered-HSDPCCH-Transmission-Information-ExtIEs',
        'Extension-neighbouringCellMeasurementInformationIE',
        'NeighbouringFDDCellMeasurementInformationItem-ExtIEs',
        'NeighbouringTDDCellMeasurementInformationItem-ExtIEs',
        'NeighbouringTDDCellMeasurementInformationLCRItem-ExtIEs',
        'NeighbouringTDDCellMeasurementInformation768Item-ExtIEs',
        'Non-Serving-RL-Preconfig-Setup-ExtIEs',
        'Non-Serving-RL-Preconfig-Info-ExtIEs',
        'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList-ExtIEs',
        'NormalAndDiversityPrimaryCPICHContainer-ExtIEs',
        'One-level-DRX-ExtIEs',
        'Paging-MACFlows-to-DeleteFDD-Item-ExtIEs',
        'Paging-MAC-Flow-Specific-Information-Item-ExtIEs',
        'Paging-MACFlow-PriorityQueue-Item-ExtIEs',
        'PLCCHinformation-ExtIEs',
        'Possible-Secondary-Serving-Cell-ExtIEs',
        'PrimaryAndSecondaryCPICHContainer-ExtIEs',
        'Priority-Queue-Information-for-Enhanced-FACH-PCH-ExtIEs',
        'PriorityQueue-InfoItem-ExtIEs',
        'PriorityQueue-InfoItem-to-Add-ExtIEs',
        'PriorityQueue-InfoItem-to-Modify-ExtIEs',
        'PriorityQueue-InfoItem-to-Modify-Unsynchronised-ExtIEs',
        'Selected-MBMS-Service-ExtIEs',
        'Selected-MBMS-Service-Item-ExtIEs',
        'MBMS-Service-TDM-Information-ExtIEs',
        'Paging-MAC-Flow-Specific-Information-ItemLCR-ExtIEs',
        'Paging-MACFlows-to-DeleteLCR-Item-ExtIEs',
        'Per-HARQ-Activiation-and-Deactiviation-ExtIEs',
        'RL-Specific-DCH-Info-Item-ExtIEs',
        'RL-Specific-E-DCH-Info-Item-ExtIEs',
        'RL-Specific-E-DCH-Information-Item-ExtIEs',
        'Reference-E-TFCI-Information-Item-ExtIEs',
        'Extension-ReportCharacteristicsIE',
        'ReportCharacteristicsType-EventA-ExtIEs',
        'ReportCharacteristicsType-EventB-ExtIEs',
        'ReportCharacteristicsType-EventC-ExtIEs',
        'ReportCharacteristicsType-EventD-ExtIEs',
        'ReportCharacteristicsType-EventE-ExtIEs',
        'ReportCharacteristicsType-EventF-ExtIEs',
        'ReportCharacteristicsType-OnModification-ExtIEs',
        'Extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThresholdIE',
        'EDCH-RACH-Report-IncrDecrThres-ExtIEs',
        'Extension-ReportCharacteristicsType-MeasurementThresholdIE',
        'EDCH-RACH-Report-ThresholdInformation-ExtIEs',
        'Received-total-wide-band-power-For-CellPortion-Value-Item-ExtIEs',
        'Received-total-wide-band-power-For-CellPortion-ValueLCR-Item-ExtIEs',
        'Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value-Item-ExtIEs',
        'InformationAvailableItem-ExtIEs',
        'RequestedDataValue-ExtIEs',
        'SAT-Info-Almanac-Item-ExtIEs',
        'SAT-Info-Almanac-ExtItemIEs',
        'SAT-Info-DGPSCorrections-Item-ExtIEs',
        'SAT-Info-RealTime-Integrity-Item-ExtIEs',
        'SecondaryServingCellsItem-ExtIEs',
        'Serving-E-DCH-RL-in-this-NodeB-ExtIEs',
        'SetsOfHS-SCCH-CodesItem-ExtIEs',
        'SFNSFNMeasurementThresholdInformation-ExtIEs',
        'SFNSFNMeasurementValueInformationItem-ExtIEs',
        'SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        'UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        'SFNSFNTimeStamp-ExtIEs',
        'SynchronisationReportCharacteristics-ExtIEs',
        'SynchronisationReportCharactThreInfoItem-ExtIEs',
        'SynchronisationReportCharactCellSyncBurstInfoItem-ExtIEs',
        'SyncDLCodeIdThreInfoList-ExtIEs',
        'SyncDLCodeInfoItem-LCR-ExtIEs',
        'TDD-ChannelisationCodeLCR-ExtIEs',
        'TDD-DL-Code-InformationItem-ExtIEs',
        'TDD-DL-Code-LCR-InformationItem-ExtIEs',
        'TDD-DL-Code-768-InformationItem-ExtIEs',
        'GainFactorFDD-ExtIEs',
        'SignalledGainFactors-ExtIEs',
        'TDD-UL-Code-InformationItem-ExtIEs',
        'TDD-UL-Code-LCR-InformationItem-ExtIEs',
        'TDD-UL-Code-768-InformationItem-ExtIEs',
        'TFCI-SignallingMode-ExtIEs',
        'TimeSlotMeasurementValueListLCR-ExtIEs',
        'Transmission-Gap-Pattern-Sequence-Information-ExtIEs',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue-Item-ExtIEs',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue-Item-ExtIEs',
        'Transmitted-Carrier-Power-For-CellPortion-Value-Item-ExtIEs',
        'Transmitted-Carrier-Power-For-CellPortion-ValueLCR-Item-ExtIEs',
        'TFCS-ExtIEs',
        'TFCS-TFCSList-ExtIEs',
        'TPC-slot-position-ExtIEs',
        'Transport-Block-Size-List-ExtIEs',
        'TransportFormatSet-ExtIEs',
        'TransportFormatSet-DynamicPartList-ExtIEs',
        'TDD-TransportFormatSet-ModeDP-ExtIEs',
        'TransmissionTimeIntervalInformation-ExtIEs',
        'TransportFormatSet-Semi-staticPart-ExtIEs',
        'TUTRANGANSSMeasurementThresholdInformation-ExtIEs',
        'TUTRANGANSSMeasurementValueInformation-ExtIEs',
        'TUTRANGPSMeasurementThresholdInformation-ExtIEs',
        'TUTRANGPSMeasurementValueInformationItem-ExtIEs',
        'Two-level-DRX-ExtIEs',
        'UC-Id-ExtIEs',
        'UE-Capability-Information-ExtIEs',
        'Radio-Frequency-BandItem-ExtIEs',
        'Extension-UE-Measurement-ValueIE',
        'UL-Timeslot-InformationItem-ExtIEs',
        'UL-TimeslotLCR-InformationItem-ExtIEs',
        'UL-Timeslot768-InformationItem-ExtIEs',
        'UL-ScramblingCode-ExtIEs',
        'UL-Synchronisation-Parameters-LCR-ExtIEs',
        'UL-TimeSlot-ISCP-InfoItem-ExtIEs',
        'UL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs',
        'UpPTSInterference-For-CellPortion-Value-Item-ExtIEs',
        'USCH-InformationItem-ExtIEs',
        'USCH-InformationResponseItem-ExtIEs',
        'UL-CLTD-Information-ExtIEs',
        'UL-CLTD-Information-Reconf-ExtIEs',
        'UL-CLTD-Information-To-Modify-ExtIEs',
        'UL-DPCCH2-Information-ExtIEs',
        'UL-DPCCH2-Information-Reconf-ExtIEs',
        'UL-DPCCH2-Information-To-Modify-ExtIEs',
        'UL-MIMO-Information-ExtIEs',
        'UL-MIMO-Information-To-Modify-ExtIEs',
        'UL-MIMO-DL-Control-Channel-Information-ExtIEs',
        'UL-TimeslotISCP-For-CellPortion-Value-Item-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'ActivationInformationItem-ExtIEs',
        'EDCH-Reference-E-TFCI-Information-Item-ExtIEs',
        'Additional-EDCH-Setup-Info-ExtIEs',
        'Additional-EDCH-FDD-Setup-Cell-Information-ExtIEs',
        'Additional-EDCH-UL-DPCH-Information-Setup-ExtIEs',
        'Additional-EDCH-F-DPCH-Information-ExtIEs',
        'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs-ExtIEs',
        'Additional-EDCH-Cell-Information-To-Add-ItemIEs-ExtIEs',
        'EDCH-Additional-RL-Specific-Information-To-Add-List-ExtIEs',
        'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs-ExtIEs',
        'Additional-EDCH-FDD-Information-ExtIEs',
        'DTX-Information2-ExtIEs',
        'Additional-EDCH-MAC-d-Flows-Specific-Info-ExtIEs',
        'Additional-EDCH-FDD-Information-Response-ItemIEs-ExtIEs',
        'EDCH-Additional-RL-Specific-Information-Response-ItemIEs-ExtIEs',
        'Additional-EDCH-FDD-Information-Response-RLReconf-Items-ExtIEs',
        'Additional-Modififed-EDCH-FDD-Information-Response-ItemIEs-ExtIEs',
        'EDCH-Additional-Modified-RL-Specific-Information-Response-List-Items-ExtIEs',
        'Additional-EDCH-MAC-d-Flows-Specific-Info-Response-ExtIEs',
        'Additional-EDCH-Cell-Information-Response-RL-Add-ItemIEs-ExtIEs',
        'Additional-EDCH-ConfigurationChange-Info-ItemIEs-ExtIEs',
        'Additional-EDCH-UL-DPCH-Information-Modify-ExtIEs',
        'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs-ExtIEs',
        'Additional-EDCH-FDD-Update-Information-ExtIEs',
        'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs-ExtIEs',
        'AdditionalMeasurementValueList-ExtIEs',
        'AdditionalTimeSlotLCR-ExtIEs',
        'Active-Pattern-Sequence-Information-ExtIEs',
        'Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs',
        'AllocationRetentionPriority-ExtIEs',
        'Angle-Of-Arrival-Value-LCR-ExtIEs',
        'AOA-per-CELL-Portion-LCR-Item-ExtIEs',
        'BCCH-Specific-HSDSCH-RNTI-Information-ExtIEs',
        'BCCH-Specific-HSDSCH-RNTI-InformationLCR-ExtIEs',
        'BDS-IGPInfo-ExtIEs',
        'BDS-Ionospheric-Grid-Model-ExtIEs',
        'Best-Cell-Portions-Item-ExtIEs',
        'Best-Cell-Portions-ItemLCR-ExtIEs',
        'BroadcastCommonTransportBearerIndication-ExtIEs',
        'CommonChannelsCapacityConsumptionLaw-ExtIEs',
        'Common-EDCH-System-InformationFDD-ExtIEs',
        'E-RNTI-Set-ExtIEs',
        'Common-E-DCH-UL-DPCH-InfoItem-ExtIEs',
        'Common-E-DCH-EDPCH-InfoItem-ExtIEs',
        'Common-E-DCH-InfoItem-ExtIEs',
        'Common-E-DCH-HSDPCCH-InfoItem-ExtIEs',
        'Common-E-DCH-CQI-Info-ExtIEs',
        'Common-E-DCH-Preamble-Control-InfoItem-ExtIEs',
        'Common-E-DCH-AICH-Information-ExtIEs',
        'Common-E-DCH-FDPCH-InfoItem-ExtIEs',
        'Common-E-DCH-Resource-Combination-InfoList-Item-ExtIEs',
        'Common-E-DCH-MAC-d-flow-info-Concurrent-TTI-ExtIEs',
        'Ul-common-E-DCH-MACflow-Specific-InfoList-Item-ExtIEs',
        'Common-E-DCH-MACdFlow-Specific-InfoList-Item-ExtIEs',
        'Common-E-DCH-LogicalChannel-InfoList-Item-ExtIEs',
        'Common-EDCH-System-Information-ResponseFDD-ExtIEs',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-Item-ExtIEs',
        'Common-MACFlows-to-DeleteFDD-Item-ExtIEs',
        'CommonMACFlow-Specific-InfoItem-ExtIEs',
        'CommonMACFlow-Specific-InfoItem-Response-ExtIEs',
        'Common-MACFlow-PriorityQueue-Item-ExtIEs',
        'Extension-CommonMeasurementValueIE',
        'CommonMeasurementAvailableItem-ExtIEs',
        'Common-PhysicalChannel-Status-Information-ExtIEs',
        'Common-PhysicalChannel-Status-Information768-ExtIEs',
        'CommonTransportChannel-InformationResponse-ExtIEs',
        'Common-TransportChannel-Status-Information-ExtIEs',
        'ContinuousPacketConnectivityDTX-DRX-Information-ExtIEs',
        'ContinuousPacketConnectivityDTX-DRX-Information-to-Modify-ExtIEs',
        'ContinuousPacketConnectivityHS-SCCH-less-Information-ExtIEs',
        'ContinuousPacketConnectivityHS-SCCH-less-Information-Response-ExtIEs',
        'CPC-Information-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'Common-EDCH-System-InformationLCR-ExtIEs',
        'Common-E-PUCH-InformationLCR-ExtIEs',
        'PRXdes-base-Item-ExtIEs',
        'Ul-common-E-DCH-MACflow-Specific-InfoList-ItemLCR-ExtIEs',
        'Common-E-DCH-MACdFlow-Specific-InfoList-ItemLCR-ExtIEs',
        'Common-EDCH-System-Information-ResponseLCR-ExtIEs',
        'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-ItemLCR-ExtIEs',
        'Common-E-AGCH-ItemLCR-ExtIEs',
        'Common-E-HICH-ItemLCR-ExtIEs',
        'Common-E-RNTI-Info-ItemLCR-ExtIEs',
        'Common-MACFlows-to-DeleteLCR-Item-ExtIEs',
        'CommonMACFlow-Specific-InfoItemLCR-ExtIEs',
        'Common-H-RNTI-InfoItemLCR-ExtIEs',
        'Sync-InformationLCR-ExtIEs',
        'CommonMACFlow-Specific-InfoItem-ResponseLCR-ExtIEs',
        'CPC-InformationLCR-ExtIEs',
        'ContinuousPacketConnectivity-DRX-InformationLCR-ExtIEs',
        'HS-SCCH-DRX-Information-LCR-ExtIEs',
        'E-AGCH-DRX-Parameters-ExtIEs',
        'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR-ExtIEs',
        'DRX-Information-to-Modify-Items-LCR-ExtIEs',
        'ContinuousPacketConnectivity-DRX-Information-ResponseLCR-ExtIEs',
        'HS-SCCH-DRX-Information-ResponseLCR-ExtIEs',
        'E-AGCH-DRX-Parameters-Response-ExtIEs',
        'Common-E-RGCH-InfoFDD-ExtIEs',
        'Concurrent-Deployment-of-2msand10ms-TTI-ExtIEs',
        'Common-E-DCH-System-Info-Parameters-for-Concurrent-TTI-ExtIEs',
        'Common-E-DCH-HS-DPCCH-Information-forConcurrentTTI-ExtIEs',
        'Common-E-DCH-Preamble-Control-Information-extensionList-Item-ExtIEs',
        'Common-E-DCH-Preamble-Control-Information-extension-Item-ExtIEs',
        'Configuration-for-2msTTI-Common-E-DCH-ResourcesList-Item-ExtIEs',
        'DBDS-CorrectionsReq-ExtIEs',
        'DBDS-Corrections-ExtIEs',
        'DBDS-Info-ExtIEs',
        'DBDS-SignalInfo-ExtIEs',
        'DCH-ENH-Information-ExtIEs',
        'DCH-ENH-Information-to-Modify-ExtIEs',
        'DCH-ENH-Information-Reconf-ExtIEs',
        'DCH-FDD-InformationItem-ExtIEs',
        'DCH-Specific-FDD-Item-ExtIEs',
        'DCH-InformationResponseItem-ExtIEs',
        'DCH-MeasurementOccasion-Information-ExtIEs',
        'Measurement-Occasion-Pattern-Sequence-parameters-ExtIEs',
        'DCH-TDD-InformationItem-ExtIEs',
        'DCH-Specific-TDD-Item-ExtIEs',
        'FDD-DCHs-to-ModifyItem-ExtIEs',
        'DCH-ModifySpecificItem-FDD-ExtIEs',
        'TDD-DCHs-to-ModifyItem-ExtIEs',
        'DCH-ModifySpecificItem-TDD-ExtIEs',
        'DedicatedChannelsCapacityConsumptionLaw-ExtIEs',
        'Extension-DedicatedMeasurementValueIE',
        'DedicatedMeasurementAvailableItem-ExtIEs',
        'Activate-Info-ExtIEs',
        'Deactivate-Info-ExtIEs',
        'DGANSSCorrections-ExtIEs',
        'DGANSS-Corrections-Req-ExtIEs',
        'DGANSS-InformationItem-ExtIEs',
        'DGANSS-SignalInformationItem-ExtIEs',
        'DGANSSThreshold-ExtIEs',
        'DGNSS-ValidityPeriod-ExtIEs',
        'DGPSCorrections-ExtIEs',
        'DGPSThresholds-ExtIEs',
        'DL-TBS-ExtIEs',
        'HS-DSCH-Cell-ExtIEs',
        'DL-Timeslot-InformationItem-ExtIEs',
        'DL-TimeslotLCR-InformationItem-ExtIEs',
        'DL-Timeslot768-InformationItem-ExtIEs',
        'DL-PowerBalancing-Information-ExtIEs',
        'DL-ReferencePowerInformationItem-ExtIEs',
        'DL-TimeslotISCPInfoItem-ExtIEs',
        'DL-TimeslotISCPInfoItemLCR-ExtIEs',
        'DL-HS-PDSCH-Timeslot-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'MaxHSDSCH-HSSCCH-Power-per-CELLPORTION-Item-ExtIEs',
        'Downlink-TPC-enhancements-Information-ExtIEs',
        'Downlink-TPC-enhancements-Reconf-ExtIEs',
        'DRX-Information-ExtIEs',
        'DRX-Information-to-Modify-Items-ExtIEs',
        'DSCH-InformationResponseItem-ExtIEs',
        'DSCH-TDD-InformationItem-ExtIEs',
        'DTX-Cycle-2ms-Items-ExtIEs',
        'DTX-Cycle-2ms-to-Modify-Items-ExtIEs',
        'DTX-Cycle-10ms-Items-ExtIEs',
        'DTX-Cycle-10ms-to-Modify-Items-ExtIEs',
        'DTX-Information-ExtIEs',
        'DTX-Information-to-Modify-Items-ExtIEs',
        'Dual-Band-Capability-Info-ExtIEs',
        'E-DCHCapacityConsumptionLaw-ExtIEs',
        'E-DCH-TDD-CapacityConsumptionLaw-ExtIEs',
        'E-DCH-SF-allocation-ExtIEs',
        'E-DCH-FDD-DL-Control-Channel-Information-ExtIEs',
        'E-DCH-FDD-Information-ExtIEs',
        'E-DCH-FDD-Information-Response-ExtIEs',
        'E-DCH-FDD-Information-to-Modify-ExtIEs',
        'E-DCH-FDD-Update-Information-ExtIEs',
        'E-DCH-MACdFlow-Specific-UpdateInformation-Item-ExtIEs',
        'E-DCH-DL-Control-Channel-Change-Information-Item-ExtIEs',
        'E-DCH-DL-Control-Channel-Grant-Information-Item-ExtIEs',
        'E-DCH-LogicalChannelInformationItem-ExtIEs',
        'E-DCH-MACdPDU-SizeListItem-ExtIEs',
        'E-DCH-LogicalChannelToModifyItem-ExtIEs',
        'E-DCH-LogicalChannelToDeleteItem-ExtIEs',
        'E-DCH-MACdFlows-Information-ExtIEs',
        'E-DCH-MACdFlow-Specific-InfoItem-ExtIEs',
        'E-DCH-MACdFlow-Specific-InformationResp-Item-ExtIEs',
        'E-DCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs',
        'E-DCH-MACdFlow-to-Delete-Item-ExtIEs',
        'E-DCH-Non-Scheduled-Transmission-Grant-Items-ExtIEs',
        'E-DCH-serving-cell-informationResponse-ExtIEs',
        'E-DCH-serving-cell-change-successful-ExtIEs',
        'E-DCH-RL-InformationList-Rsp-Item-ExtIEs',
        'E-DCH-serving-cell-change-unsuccessful-ExtIEs',
        'EDCH-RACH-Report-Value-ExtIEs',
        'E-DCH-MACdFlow-to-Delete-ItemLCR-ExtIEs',
        'Enhanced-UE-DRX-InformationLCR-ExtIEs',
        'E-TFCI-Boost-Information-ExtIEs',
        'E-TFCS-Information-ExtIEs',
        'E-DCHProvidedBitRate-Item-ExtIEs',
        'E-DCHProvidedBitRateValueInformation-For-CellPortion-Item-ExtIEs',
        'E-DCH-Information-ExtIEs',
        'E-PUCH-Information-ExtIEs',
        'E-TFCS-Information-TDD-ExtIEs',
        'E-DCH-MACdFlow-InfoTDDItem-ExtIEs',
        'E-DCH-Non-Scheduled-Grant-Info-ExtIEs',
        'E-DCH-TDD-Information-ExtIEs',
        'E-DCH-Information-Response-ExtIEs',
        'Scheduled-E-HICH-Specific-InformationItem-ResponseLCRTDD-ExtIEs',
        'E-DCH-TDD-MACdFlow-Specific-InformationRespItem-ExtIEs',
        'E-AGCH-Specific-InformationResp-ItemTDD-ExtIEs',
        'E-DCH-Information-Reconfig-ExtIEs',
        'E-DCH-TDD-Information-to-Modify-ExtIEs',
        'E-DCH-MACdFlow-ModifyTDDItem-ExtIEs',
        'E-DCH-768-Information-ExtIEs',
        'E-DCH-Non-Scheduled-Grant-Info768-ExtIEs',
        'E-DCH-TDD-Information768-ExtIEs',
        'E-DCH-768-Information-Reconfig-ExtIEs',
        'E-DCH-LCR-Information-ExtIEs',
        'E-PUCH-LCR-Information-ExtIEs',
        'E-DCH-Non-Scheduled-Grant-LCR-Info-ExtIEs',
        'E-HICH-LCR-Information-ExtIEs',
        'E-DCH-LCRTDD-Information-ExtIEs',
        'E-DCH-LCR-Information-Reconfig-ExtIEs',
        'Enhanced-UE-DRX-InformationFDD-ExtIEs',
        'Radio-Links-without-DPCH-FDPCH-Information-ExtIEs',
        'E-DCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        'FDD-DL-CodeInformationItem-ExtIEs',
        'F-DPCH-Info-ExtIEs',
        'F-DPCH-Info-To-Modify-ExtIEs',
        'FTPICH-Information-ExtIEs',
        'FTPICH-Information-To-Modify-ExtIEs',
        'FTPICH-Information-Reconf-ExtIEs',
        'Further-Enhanced-UE-DRX-InformationFDD-ExtIEs',
        'SignalledGainFactors10ms-ExtIEs',
        'GANSS-Additional-Ionospheric-Model-ExtIEs',
        'GANSS-Additional-Navigation-Models-ExtIEs',
        'GANSS-Almanac-ExtIEs',
        'Extension-GANSS-AlmanacModel-IE',
        'GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs',
        'GANSS-ALM-GlonassAlmanacSet-ExtIEs',
        'GANSS-ALM-MidiAlmanacSet-ExtIEs',
        'GANSS-ALM-NAVKeplerianSet-ExtIEs',
        'GANSS-ALM-KEPLERIANBDSALMANAC-ExtIEs',
        'GANSS-ALM-ReducedKeplerianSet-ExtIEs',
        'GANSS-AuxInfoGANSS-ID1-element-ExtIEs',
        'GANSS-AuxInfoGANSS-ID3-element-ExtIEs',
        'GANSS-BDSclockModel-ExtIEs',
        'GANSS-CNAVclockModel-ExtIEs',
        'GANSS-Common-Data-ExtIEs',
        'GANSS-CommonDataInfoReq-ExtIEs',
        'GANSS-Data-Bit-Assistance-ExtIEs',
        'GANSS-DataBitAssistanceItem-ExtIEs',
        'GANSS-DataBitAssistanceSgnItem-ExtIEs',
        'GANSS-Data-Bit-Assistance-ReqItem-ExtIEs',
        'GANSS-Data-Bit-Assistance-ReqList-ExtIEs',
        'GANSS-DeltaUT1-ExtIEs',
        'GANSS-Earth-Orientation-Parameters-ExtIEs',
        'GANSS-GenericDataInfoReqItem-ExtIEs',
        'GANSS-Generic-DataItem-ExtIEs',
        'GANSS-GLONASSclockModel-ExtIEs',
        'GANSS-Information-ExtIEs',
        'GANSS-Ionospheric-Model-ExtIEs',
        'GANSS-IonosphereRegionalStormFlags-ExtIEs',
        'GANSS-KeplerianParametersAlm-ExtIEs',
        'GANSS-KeplerianParametersOrb-ExtIEs',
        'GANSS-NAVclockModel-ExtIEs',
        'GANSS-Navigation-Model-And-Time-Recovery-ExtIEs',
        'GANSS-NavModel-BDSKeplerianSet-ExtIEs',
        'GANSS-NavModel-CNAVKeplerianSet-ExtIEs',
        'GANSS-NavModel-GLONASSecef-ExtIEs',
        'GANSS-NavModel-NAVKeplerianSet-ExtIEs',
        'GANSS-NavModel-SBASecef-ExtIEs',
        'GANSS-RealTimeInformationItem-ExtIEs',
        'GANSS-RX-Pos-ExtIEs',
        'GANSS-SatelliteClockModelItem-ExtIEs',
        'GANSS-SatelliteInformationKPItem-ExtIEs',
        'Ganss-Sat-Info-AddNavList-ExtIEs',
        'GANSS-SAT-Info-Almanac-BDS-ExtIEs',
        'GANSS-SAT-Info-Almanac-GLOkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-NAVkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-REDkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-SBASecef-ExtIEs',
        'GANSS-Sat-Info-Nav-ExtIEs',
        'GANSS-SBASclockModel-ExtIEs',
        'GANSS-Time-Model-ExtIEs',
        'GANSS-Transmission-Time-ExtIEs',
        'GANSS-UTC-Model-ExtIEs',
        'GANSS-UTCmodelSet1-ExtIEs',
        'GANSS-UTCmodelSet2-ExtIEs',
        'GANSS-UTCmodelSet3-ExtIEs',
        'GANSS-UTCmodelSet4-ExtIEs',
        'GPS-Almanac-ExtIEs',
        'GPS-Ionospheric-Model-ExtIEs',
        'GPSBadSat-Info-RealTime-Integrity-ExtIEs',
        'GPS-NavandRecovery-Item-ExtIEs',
        'GPS-RX-POS-ExtIEs',
        'GPS-UTC-Model-ExtIEs',
        'HARQ-MemoryPartitioning-Implicit-ExtIEs',
        'HARQ-MemoryPartitioning-Explicit-ExtIEs',
        'HARQ-MemoryPartitioningItem-ExtIEs',
        'HS-DSCHProvidedBitRate-Item-ExtIEs',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortion-Item-ExtIEs',
        'HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR-Item-ExtIEs',
        'HS-DSCHRequiredPower-Item-ExtIEs',
        'HS-DSCHRequiredPowerPerUEInformation-Item-ExtIEs',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortion-Item-ExtIEs',
        'HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR-Item-ExtIEs',
        'HSDSCH-Common-System-InformationFDD-ExtIEs',
        'HSDSCH-Common-System-Information-ResponseFDD-ExtIEs',
        'HSDSCH-Common-Information-ExtIEs',
        'HSDSCH-FDD-Information-ExtIEs',
        'HSDSCH-TDD-Information-ExtIEs',
        'HSDSCH-Information-to-Modify-ExtIEs',
        'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs',
        'HSDSCH-Information-to-Modify-Unsynchronised-ExtIEs',
        'HSDSCH-FDD-Information-Response-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Information-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Information-Respons-ExtIEs',
        'HS-DSCH-Secondary-Serving-Information-To-Modify-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised-ExtIEs',
        'HS-DSCH-FDD-Secondary-Serving-Update-Information-ExtIEs',
        'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response-ExtIEs',
        'HS-Secondary-Serving-cell-change-successful-ExtIEs',
        'HS-Secondary-Serving-cell-change-unsuccessful-ExtIEs',
        'HSDSCH-Paging-System-InformationFDD-ExtIEs',
        'HSDSCH-Paging-System-Information-ResponseList-ExtIEs',
        'HSDSCH-TDD-Information-Response-ExtIEs',
        'HSDSCH-MACdFlow-Specific-InformationRespItem-ExtIEs',
        'HSDSCH-MACdFlows-Information-ExtIEs',
        'HSDSCH-MACdFlow-Specific-InfoItem-ExtIEs',
        'HSDSCH-MACdFlows-to-Delete-Item-ExtIEs',
        'HSDSCH-Initial-Capacity-AllocationItem-ExtIEs',
        'HSDSCH-PreconfigurationInfo-ExtIEs',
        'Additional-EDCH-Preconfiguration-Information-ItemIEs-ExtIEs',
        'HSDSCHPreconfigurationSetup-ExtIEs',
        'HS-SCCH-PreconfiguredCodesItem-ExtIEs',
        'HSSCCH-Specific-InformationRespItemFDD-ExtIEs',
        'HSSCCH-Specific-InformationRespItemTDD-ExtIEs',
        'HSSCCH-Specific-InformationRespItemTDDLCR-ExtIEs',
        'HSSCCH-Specific-InformationRespItemTDD768-ExtIEs',
        'HSSICH-Info-ExtIEs',
        'HSSICH-Info-LCR-ExtIEs',
        'HSSICH-Info-768-ExtIEs',
        'HS-SICH-Reception-Quality-Value-ExtIEs',
        'HS-PDSCH-FDD-Code-Information-ExtIEs',
        'HS-DSCH-Serving-Cell-Change-Info-ExtIEs',
        'HS-DSCH-serving-cell-informationResponse-ExtIEs',
        'HS-serving-cell-change-successful-ExtIEs',
        'HS-serving-cell-change-unsuccessful-ExtIEs',
        'HSDSCH-FDD-Update-Information-ExtIEs',
        'HSDSCH-TDD-Update-Information-ExtIEs',
        'HSDPA-PICH-notShared-with-PCHLCR-ExtIEs',
        'HSDSCH-Common-System-InformationLCR-ExtIEs',
        'HSDSCH-Common-System-Information-ResponseLCR-ExtIEs',
        'HSDSCH-Common-InformationLCR-ExtIEs',
        'HSDSCH-Paging-System-InformationLCR-ExtIEs',
        'HSDSCH-Paging-System-Information-ResponseListLCR-ExtIEs',
        'HSSCCH-Specific-InformationRespItemLCR-ExtIEs',
        'HS-DSCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        'Transport-Block-Size-Item-LCR-ExtIEs',
        'Repetition-Period-Item-LCR-ExtIEs',
        'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        'HS-SICH-InformationItem-for-HS-DSCH-SPS-ExtIEs',
        'Initial-HS-PDSCH-SPS-Resource-ExtIEs',
        'Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'Non-HS-SCCH-Associated-HS-SICH-InformationItem-ExtIEs',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationItem-ExtIEs',
        'HSSICH-ReferenceSignal-InformationLCR-ExtIEs',
        'HSSICH-ReferenceSignal-InformationModifyLCR-ExtIEs',
        'IMB-Parameters-ExtIEs',
        'BCH-ParametersItem-ExtIEs',
        'InformationReportCharacteristicsType-OnModification-ExtIEs',
        'Information-Type-ExtIEs',
        'IPDLFDDParameter-ExtIEs',
        'IPMulticastIndication-ExtIEs',
        'IPDLTDDParameter-ExtIEs',
        'IPDLTDDParameterLCR-ExtIEs',
        'LCRTDD-Uplink-Physical-Channel-Capability-ExtIEs',
        'MACdPDU-Size-IndexItem-ExtIEs',
        'MACdPDU-Size-IndexItem-to-Modify-ExtIEs',
        'Max-TB-Sizes-ExtIEs',
        'MessageStructure-ExtIEs',
        'MidambleShiftLCR-ExtIEs',
        'MIMO-withfourtransmitantennas-SCPICH-Configuration-Item-ExtIEs',
        'MultipleFreq-HARQ-MemoryPartitioning-InformationItem-ExtIEs',
        'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR-ExtIEs',
        'Multi-Cell-Capability-Info-ExtIEs',
        'Multicell-EDCH-InformationItem',
        'Multicell-EDCH-InformationItemIEs-ExtIEs',
        'Multicell-EDCH-RL-Specific-InformationItem',
        'Multicell-EDCH-RL-Specific-InformationItemIEs-ExtIEs',
        'Multi-Carrier-EDCH-Info-ExtIEs',
        'Dual-Cell-EDCH-Enhancements-Information-ExtIEs',
        'HS-SCCH-DRX-InformationFDD-ExtIEs',
        'Multi-Carrier-EDCH-LCR-InformationItem-ExtIEs',
        'Multi-Carrier-EDCH-MACdFlows-Specific-Info-ExtIEs',
        'Multi-Carrier-EDCH-Reconfigure-ExtIEs',
        'Multi-Carrier-EDCH-Change-Info-ExtIEs',
        'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs-ExtIEs',
        'Multi-Carrier-EDCH-LCR-Information-ResponseItem-ExtIEs',
        'Multiflow-Information-ExtIEs',
        'Multiflow-Information-To-Modify-ExtIEs',
        'Multiflow-RepetitionFactors-ExtIEs',
        'Standalone-Midamble-Channel-Information-ExtIEs',
        'MU-MIMO-InformationLCR-ExtIEs',
        'MU-MIMO-Information-Response-ExtIEs',
        'MU-MIMO-Information-To-Modify-ExtIEs',
        'NodeB-Triggered-HSDPCCH-Transmission-Information-ExtIEs',
        'Extension-neighbouringCellMeasurementInformationIE',
        'NeighbouringFDDCellMeasurementInformationItem-ExtIEs',
        'NeighbouringTDDCellMeasurementInformationItem-ExtIEs',
        'NeighbouringTDDCellMeasurementInformationLCRItem-ExtIEs',
        'NeighbouringTDDCellMeasurementInformation768Item-ExtIEs',
        'Non-Serving-RL-Preconfig-Setup-ExtIEs',
        'Non-Serving-RL-Preconfig-Info-ExtIEs',
        'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList-ExtIEs',
        'NormalAndDiversityPrimaryCPICHContainer-ExtIEs',
        'One-level-DRX-ExtIEs',
        'Paging-MACFlows-to-DeleteFDD-Item-ExtIEs',
        'Paging-MAC-Flow-Specific-Information-Item-ExtIEs',
        'Paging-MACFlow-PriorityQueue-Item-ExtIEs',
        'PLCCHinformation-ExtIEs',
        'Possible-Secondary-Serving-Cell-ExtIEs',
        'PrimaryAndSecondaryCPICHContainer-ExtIEs',
        'Priority-Queue-Information-for-Enhanced-FACH-PCH-ExtIEs',
        'PriorityQueue-InfoItem-ExtIEs',
        'PriorityQueue-InfoItem-to-Add-ExtIEs',
        'PriorityQueue-InfoItem-to-Modify-ExtIEs',
        'PriorityQueue-InfoItem-to-Modify-Unsynchronised-ExtIEs',
        'Selected-MBMS-Service-ExtIEs',
        'Selected-MBMS-Service-Item-ExtIEs',
        'MBMS-Service-TDM-Information-ExtIEs',
        'Paging-MAC-Flow-Specific-Information-ItemLCR-ExtIEs',
        'Paging-MACFlows-to-DeleteLCR-Item-ExtIEs',
        'Per-HARQ-Activiation-and-Deactiviation-ExtIEs',
        'RL-Specific-DCH-Info-Item-ExtIEs',
        'RL-Specific-E-DCH-Info-Item-ExtIEs',
        'RL-Specific-E-DCH-Information-Item-ExtIEs',
        'Reference-E-TFCI-Information-Item-ExtIEs',
        'Extension-ReportCharacteristicsIE',
        'ReportCharacteristicsType-EventA-ExtIEs',
        'ReportCharacteristicsType-EventB-ExtIEs',
        'ReportCharacteristicsType-EventC-ExtIEs',
        'ReportCharacteristicsType-EventD-ExtIEs',
        'ReportCharacteristicsType-EventE-ExtIEs',
        'ReportCharacteristicsType-EventF-ExtIEs',
        'ReportCharacteristicsType-OnModification-ExtIEs',
        'Extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThresholdIE',
        'EDCH-RACH-Report-IncrDecrThres-ExtIEs',
        'Extension-ReportCharacteristicsType-MeasurementThresholdIE',
        'EDCH-RACH-Report-ThresholdInformation-ExtIEs',
        'Received-total-wide-band-power-For-CellPortion-Value-Item-ExtIEs',
        'Received-total-wide-band-power-For-CellPortion-ValueLCR-Item-ExtIEs',
        'Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value-Item-ExtIEs',
        'InformationAvailableItem-ExtIEs',
        'RequestedDataValue-ExtIEs',
        'SAT-Info-Almanac-Item-ExtIEs',
        'SAT-Info-Almanac-ExtItemIEs',
        'SAT-Info-DGPSCorrections-Item-ExtIEs',
        'SAT-Info-RealTime-Integrity-Item-ExtIEs',
        'SecondaryServingCellsItem-ExtIEs',
        'Serving-E-DCH-RL-in-this-NodeB-ExtIEs',
        'SetsOfHS-SCCH-CodesItem-ExtIEs',
        'SFNSFNMeasurementThresholdInformation-ExtIEs',
        'SFNSFNMeasurementValueInformationItem-ExtIEs',
        'SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        'UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        'SFNSFNTimeStamp-ExtIEs',
        'SynchronisationReportCharacteristics-ExtIEs',
        'SynchronisationReportCharactThreInfoItem-ExtIEs',
        'SynchronisationReportCharactCellSyncBurstInfoItem-ExtIEs',
        'SyncDLCodeIdThreInfoList-ExtIEs',
        'SyncDLCodeInfoItem-LCR-ExtIEs',
        'TDD-ChannelisationCodeLCR-ExtIEs',
        'TDD-DL-Code-InformationItem-ExtIEs',
        'TDD-DL-Code-LCR-InformationItem-ExtIEs',
        'TDD-DL-Code-768-InformationItem-ExtIEs',
        'GainFactorFDD-ExtIEs',
        'SignalledGainFactors-ExtIEs',
        'TDD-UL-Code-InformationItem-ExtIEs',
        'TDD-UL-Code-LCR-InformationItem-ExtIEs',
        'TDD-UL-Code-768-InformationItem-ExtIEs',
        'TFCI-SignallingMode-ExtIEs',
        'TimeSlotMeasurementValueListLCR-ExtIEs',
        'Transmission-Gap-Pattern-Sequence-Information-ExtIEs',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue-Item-ExtIEs',
        'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue-Item-ExtIEs',
        'Transmitted-Carrier-Power-For-CellPortion-Value-Item-ExtIEs',
        'Transmitted-Carrier-Power-For-CellPortion-ValueLCR-Item-ExtIEs',
        'TFCS-ExtIEs',
        'TFCS-TFCSList-ExtIEs',
        'TPC-slot-position-ExtIEs',
        'Transport-Block-Size-List-ExtIEs',
        'TransportFormatSet-ExtIEs',
        'TransportFormatSet-DynamicPartList-ExtIEs',
        'TDD-TransportFormatSet-ModeDP-ExtIEs',
        'TransmissionTimeIntervalInformation-ExtIEs',
        'TransportFormatSet-Semi-staticPart-ExtIEs',
        'TUTRANGANSSMeasurementThresholdInformation-ExtIEs',
        'TUTRANGANSSMeasurementValueInformation-ExtIEs',
        'TUTRANGPSMeasurementThresholdInformation-ExtIEs',
        'TUTRANGPSMeasurementValueInformationItem-ExtIEs',
        'Two-level-DRX-ExtIEs',
        'UC-Id-ExtIEs',
        'UE-Capability-Information-ExtIEs',
        'Radio-Frequency-BandItem-ExtIEs',
        'Extension-UE-Measurement-ValueIE',
        'UL-Timeslot-InformationItem-ExtIEs',
        'UL-TimeslotLCR-InformationItem-ExtIEs',
        'UL-Timeslot768-InformationItem-ExtIEs',
        'UL-ScramblingCode-ExtIEs',
        'UL-Synchronisation-Parameters-LCR-ExtIEs',
        'UL-TimeSlot-ISCP-InfoItem-ExtIEs',
        'UL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs',
        'UpPTSInterference-For-CellPortion-Value-Item-ExtIEs',
        'USCH-InformationItem-ExtIEs',
        'USCH-InformationResponseItem-ExtIEs',
        'UL-CLTD-Information-ExtIEs',
        'UL-CLTD-Information-Reconf-ExtIEs',
        'UL-CLTD-Information-To-Modify-ExtIEs',
        'UL-DPCCH2-Information-ExtIEs',
        'UL-DPCCH2-Information-Reconf-ExtIEs',
        'UL-DPCCH2-Information-To-Modify-ExtIEs',
        'UL-MIMO-Information-ExtIEs',
        'UL-MIMO-Information-To-Modify-ExtIEs',
        'UL-MIMO-DL-Control-Channel-Information-ExtIEs',
        'UL-TimeslotISCP-For-CellPortion-Value-Item-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AckNack-RepetitionFactor >-----#
    AckNack_RepetitionFactor = INT(name='AckNack-RepetitionFactor', mode=MODE_TYPE)
    AckNack_RepetitionFactor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[])
    
    #-----< Ack-Power-Offset >-----#
    Ack_Power_Offset = INT(name='Ack-Power-Offset', mode=MODE_TYPE)
    Ack_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=[], er=[ASN1RangeInt(lb=9, ub=10)])
    
    #-----< Acknowledged-PRACH-preambles-Value >-----#
    Acknowledged_PRACH_preambles_Value = INT(name='Acknowledged-PRACH-preambles-Value', mode=MODE_TYPE)
    Acknowledged_PRACH_preambles_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=240)], ev=[], er=[])
    
    #-----< ActivationDelay >-----#
    ActivationDelay = ENUM(name='ActivationDelay', mode=MODE_TYPE)
    ActivationDelay._cont = ASN1Dict([('v0', 0), ('v1', 1), ('v2', 2), ('v3', 3), ('v4', 4), ('v5', 5)])
    ActivationDelay._ext = []
    
    #-----< ActivationInformation >-----#
    ActivationInformation = SEQ_OF(name='ActivationInformation', mode=MODE_TYPE)
    _ActivationInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ActivationInformationItem')))
    ActivationInformation._cont = _ActivationInformation__item_
    ActivationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< ActivationInformationItem >-----#
    ActivationInformationItem = SEQ(name='ActivationInformationItem', mode=MODE_TYPE)
    _ActivationInformationItem_uU_ActivationState = ENUM(name='uU-ActivationState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Uu-ActivationState')))
    _ActivationInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ActivationInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ActivationInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ActivationInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ActivationInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivationInformationItem_iE_Extensions__item__id._const_tab = ____ActivationInformationItem_iE_Extensions__item__id_tab
    ___ActivationInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___ActivationInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ActivationInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ActivationInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ActivationInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivationInformationItem_iE_Extensions__item__criticality._const_tab = ____ActivationInformationItem_iE_Extensions__item__criticality_tab
    ___ActivationInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ActivationInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ActivationInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ActivationInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ActivationInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivationInformationItem_iE_Extensions__item__extensionValue._const_tab = ____ActivationInformationItem_iE_Extensions__item__extensionValue_tab
    ___ActivationInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ActivationInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ActivationInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ActivationInformationItem_iE_Extensions__item__id),
        ('criticality', ___ActivationInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ActivationInformationItem_iE_Extensions__item__extensionValue),
        ])
    __ActivationInformationItem_iE_Extensions__item_._ext = None
    _ActivationInformationItem_iE_Extensions._cont = __ActivationInformationItem_iE_Extensions__item_
    _ActivationInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ActivationInformationItem._cont = ASN1Dict([
        ('uU-ActivationState', _ActivationInformationItem_uU_ActivationState),
        ('iE-Extensions', _ActivationInformationItem_iE_Extensions),
        ])
    ActivationInformationItem._ext = []
    
    #-----< ActivationInformationItem-ExtIEs >-----#
    ActivationInformationItem_ExtIEs = CLASS(name='ActivationInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ActivationInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Adaptive-Special-Burst-Power-CapabilityLCR >-----#
    Adaptive_Special_Burst_Power_CapabilityLCR = ENUM(name='Adaptive-Special-Burst-Power-CapabilityLCR', mode=MODE_TYPE)
    Adaptive_Special_Burst_Power_CapabilityLCR._cont = ASN1Dict([('adaptive-Special-Burst-Power-Capable', 0), ('adaptive-Special-Burst-Power-Not-Capable', 1)])
    Adaptive_Special_Burst_Power_CapabilityLCR._ext = None
    
    #-----< EDCH-Reference-E-TFCI-Information >-----#
    EDCH_Reference_E_TFCI_Information = SEQ_OF(name='EDCH-Reference-E-TFCI-Information', mode=MODE_TYPE)
    _EDCH_Reference_E_TFCI_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EDCH-Reference-E-TFCI-Information-Item')))
    EDCH_Reference_E_TFCI_Information._cont = _EDCH_Reference_E_TFCI_Information__item_
    EDCH_Reference_E_TFCI_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< EDCH-Reference-E-TFCI-Information-Item >-----#
    EDCH_Reference_E_TFCI_Information_Item = SEQ(name='EDCH-Reference-E-TFCI-Information-Item', mode=MODE_TYPE)
    _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI = INT(name='eDCH-reference-E-TFCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCI')))
    _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI_PO = INT(name='eDCH-reference-E-TFCI-PO', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'EDCH-Reference-E-TFCI-PO')))
    _EDCH_Reference_E_TFCI_Information_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab = ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab = ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id),
        ('criticality', ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item_._ext = None
    _EDCH_Reference_E_TFCI_Information_Item_iE_Extensions._cont = __EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item_
    _EDCH_Reference_E_TFCI_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_Reference_E_TFCI_Information_Item._cont = ASN1Dict([
        ('eDCH-reference-E-TFCI', _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI),
        ('eDCH-reference-E-TFCI-PO', _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI_PO),
        ('iE-Extensions', _EDCH_Reference_E_TFCI_Information_Item_iE_Extensions),
        ])
    EDCH_Reference_E_TFCI_Information_Item._ext = []
    
    #-----< EDCH-Reference-E-TFCI-Information-Item-ExtIEs >-----#
    EDCH_Reference_E_TFCI_Information_Item_ExtIEs = CLASS(name='EDCH-Reference-E-TFCI-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    EDCH_Reference_E_TFCI_Information_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-Reference-E-TFCI-PO >-----#
    EDCH_Reference_E_TFCI_PO = INT(name='EDCH-Reference-E-TFCI-PO', mode=MODE_TYPE)
    EDCH_Reference_E_TFCI_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< Additional-EDCH-Setup-Info >-----#
    Additional_EDCH_Setup_Info = SEQ(name='Additional-EDCH-Setup-Info', mode=MODE_TYPE)
    _Additional_EDCH_Setup_Info_multicell_EDCH_Transport_Bearer_Mode = ENUM(name='multicell-EDCH-Transport-Bearer-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-Transport-Bearer-Mode')))
    _Additional_EDCH_Setup_Info_additional_EDCH_Cell_Information_Setup = SEQ_OF(name='additional-EDCH-Cell-Information-Setup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Setup')))
    _Additional_EDCH_Setup_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Setup_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Setup_Info_iE_Extensions__item__id_tab
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Setup_Info_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_Setup_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_Setup_Info_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Setup_Info_iE_Extensions__item_._ext = None
    _Additional_EDCH_Setup_Info_iE_Extensions._cont = __Additional_EDCH_Setup_Info_iE_Extensions__item_
    _Additional_EDCH_Setup_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Setup_Info._cont = ASN1Dict([
        ('multicell-EDCH-Transport-Bearer-Mode', _Additional_EDCH_Setup_Info_multicell_EDCH_Transport_Bearer_Mode),
        ('additional-EDCH-Cell-Information-Setup', _Additional_EDCH_Setup_Info_additional_EDCH_Cell_Information_Setup),
        ('iE-Extensions', _Additional_EDCH_Setup_Info_iE_Extensions),
        ])
    Additional_EDCH_Setup_Info._ext = []
    
    #-----< Additional-EDCH-Setup-Info-ExtIEs >-----#
    Additional_EDCH_Setup_Info_ExtIEs = CLASS(name='Additional-EDCH-Setup-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Setup_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multicell-EDCH-Transport-Bearer-Mode >-----#
    Multicell_EDCH_Transport_Bearer_Mode = ENUM(name='Multicell-EDCH-Transport-Bearer-Mode', mode=MODE_TYPE)
    Multicell_EDCH_Transport_Bearer_Mode._cont = ASN1Dict([('separate-Iub-Transport-Bearer-Mode', 0), ('uL-Flow-Multiplexing-Mode', 1)])
    Multicell_EDCH_Transport_Bearer_Mode._ext = None
    
    #-----< Additional-EDCH-Cell-Information-Setup >-----#
    Additional_EDCH_Cell_Information_Setup = SEQ_OF(name='Additional-EDCH-Cell-Information-Setup', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Setup__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-FDD-Setup-Cell-Information')))
    Additional_EDCH_Cell_Information_Setup._cont = _Additional_EDCH_Cell_Information_Setup__item_
    Additional_EDCH_Cell_Information_Setup._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-FDD-Setup-Cell-Information >-----#
    Additional_EDCH_FDD_Setup_Cell_Information = SEQ(name='Additional-EDCH-FDD-Setup-Cell-Information', mode=MODE_TYPE)
    _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_UL_DPCH_Information_Setup = SEQ(name='additional-EDCH-UL-DPCH-Information-Setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-UL-DPCH-Information-Setup')))
    _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_RL_Specific_Information_To_Setup = SEQ_OF(name='additional-EDCH-RL-Specific-Information-To-Setup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Setup-List')))
    _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_FDD_Information = SEQ(name='additional-EDCH-FDD-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-FDD-Information')), opt=True)
    _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_F_DPCH_Information_Setup = SEQ(name='additional-EDCH-F-DPCH-Information-Setup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-F-DPCH-Information')))
    _Additional_EDCH_FDD_Setup_Cell_Information_multicell_EDCH_Information = SEQ(name='multicell-EDCH-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-Information')), opt=True)
    _Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id._const_tab = ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item_._ext = None
    _Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions._cont = __Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item_
    _Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_FDD_Setup_Cell_Information._cont = ASN1Dict([
        ('additional-EDCH-UL-DPCH-Information-Setup', _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_UL_DPCH_Information_Setup),
        ('additional-EDCH-RL-Specific-Information-To-Setup', _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_RL_Specific_Information_To_Setup),
        ('additional-EDCH-FDD-Information', _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_FDD_Information),
        ('additional-EDCH-F-DPCH-Information-Setup', _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_F_DPCH_Information_Setup),
        ('multicell-EDCH-Information', _Additional_EDCH_FDD_Setup_Cell_Information_multicell_EDCH_Information),
        ('iE-Extensions', _Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions),
        ])
    Additional_EDCH_FDD_Setup_Cell_Information._ext = []
    
    #-----< Additional-EDCH-FDD-Setup-Cell-Information-ExtIEs >-----#
    Additional_EDCH_FDD_Setup_Cell_Information_ExtIEs = CLASS(name='Additional-EDCH-FDD-Setup-Cell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_FDD_Setup_Cell_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-UL-DPCH-Information-Setup >-----#
    Additional_EDCH_UL_DPCH_Information_Setup = SEQ(name='Additional-EDCH-UL-DPCH-Information-Setup', mode=MODE_TYPE)
    _Additional_EDCH_UL_DPCH_Information_Setup_ul_ScramblingCode = SEQ(name='ul-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-ScramblingCode')))
    _Additional_EDCH_UL_DPCH_Information_Setup_ul_SIR_Target = INT(name='ul-SIR-Target', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id._const_tab = ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id_tab
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item_._ext = None
    _Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions._cont = __Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item_
    _Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_UL_DPCH_Information_Setup._cont = ASN1Dict([
        ('ul-ScramblingCode', _Additional_EDCH_UL_DPCH_Information_Setup_ul_ScramblingCode),
        ('ul-SIR-Target', _Additional_EDCH_UL_DPCH_Information_Setup_ul_SIR_Target),
        ('iE-Extensions', _Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions),
        ])
    Additional_EDCH_UL_DPCH_Information_Setup._ext = []
    
    #-----< Additional-EDCH-UL-DPCH-Information-Setup-ExtIEs >-----#
    Additional_EDCH_UL_DPCH_Information_Setup_ExtIEs = CLASS(name='Additional-EDCH-UL-DPCH-Information-Setup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_UL_DPCH_Information_Setup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-F-DPCH-Information >-----#
    Additional_EDCH_F_DPCH_Information = SEQ(name='Additional-EDCH-F-DPCH-Information', mode=MODE_TYPE)
    _Additional_EDCH_F_DPCH_Information_fdd_TPC_DownlinkStepSize = ENUM(name='fdd-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-TPC-DownlinkStepSize')))
    _Additional_EDCH_F_DPCH_Information_limitedPowerIncrease = ENUM(name='limitedPowerIncrease', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LimitedPowerIncrease')))
    _Additional_EDCH_F_DPCH_Information_innerLoopDLPCStatus = ENUM(name='innerLoopDLPCStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InnerLoopDLPCStatus')))
    _Additional_EDCH_F_DPCH_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_F_DPCH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id._const_tab = ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_F_DPCH_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_F_DPCH_Information_iE_Extensions__item_._ext = None
    _Additional_EDCH_F_DPCH_Information_iE_Extensions._cont = __Additional_EDCH_F_DPCH_Information_iE_Extensions__item_
    _Additional_EDCH_F_DPCH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_F_DPCH_Information._cont = ASN1Dict([
        ('fdd-TPC-DownlinkStepSize', _Additional_EDCH_F_DPCH_Information_fdd_TPC_DownlinkStepSize),
        ('limitedPowerIncrease', _Additional_EDCH_F_DPCH_Information_limitedPowerIncrease),
        ('innerLoopDLPCStatus', _Additional_EDCH_F_DPCH_Information_innerLoopDLPCStatus),
        ('iE-Extensions', _Additional_EDCH_F_DPCH_Information_iE_Extensions),
        ])
    Additional_EDCH_F_DPCH_Information._ext = []
    
    #-----< Additional-EDCH-F-DPCH-Information-ExtIEs >-----#
    Additional_EDCH_F_DPCH_Information_ExtIEs = CLASS(name='Additional-EDCH-F-DPCH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_F_DPCH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Setup-List >-----#
    Additional_EDCH_RL_Specific_Information_To_Setup_List = SEQ_OF(name='Additional-EDCH-RL-Specific-Information-To-Setup-List', mode=MODE_TYPE)
    _Additional_EDCH_RL_Specific_Information_To_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs')))
    Additional_EDCH_RL_Specific_Information_To_Setup_List._cont = _Additional_EDCH_RL_Specific_Information_To_Setup_List__item_
    Additional_EDCH_RL_Specific_Information_To_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs >-----#
    Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs = SEQ(name='Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_eDCH_Additional_RL_ID = INT(name='eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_firstRLS_indicator = ENUM(name='firstRLS-indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FirstRLS-Indicator')))
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_propagationDelay = INT(name='propagationDelay', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PropagationDelay')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_dl_CodeInformation = SEQ_OF(name='dl-CodeInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-CodeInformation')))
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_initialDL_transmissionPower = INT(name='initialDL-transmissionPower', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_maximumDL_power = INT(name='maximumDL-power', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_minimumDL_power = INT(name='minimumDL-power', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_f_DPCH_SlotFormat = INT(name='f-DPCH-SlotFormat', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_RNTI = INT(name='e-RNTI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_multicell_EDCH_RL_Specific_Information = SEQ(name='multicell-EDCH-RL-Specific-Information', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-RL-Specific-Information')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions._cont = __Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs._cont = ASN1Dict([
        ('eDCH-Additional-RL-ID', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_eDCH_Additional_RL_ID),
        ('c-ID', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_c_ID),
        ('firstRLS-indicator', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_firstRLS_indicator),
        ('propagationDelay', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_propagationDelay),
        ('dl-CodeInformation', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_dl_CodeInformation),
        ('initialDL-transmissionPower', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_initialDL_transmissionPower),
        ('maximumDL-power', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_maximumDL_power),
        ('minimumDL-power', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_minimumDL_power),
        ('f-DPCH-SlotFormat', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_f_DPCH_SlotFormat),
        ('e-RNTI', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_RNTI),
        ('multicell-EDCH-RL-Specific-Information', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_multicell_EDCH_RL_Specific_Information),
        ('iE-Extensions', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs._ext = []
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs-ExtIEs >-----#
    Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs = CLASS(name='Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs._val = ASN1Set(rv=[dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-To-Add-List >-----#
    Additional_EDCH_Cell_Information_To_Add_List = SEQ_OF(name='Additional-EDCH-Cell-Information-To-Add-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-To-Add-ItemIEs')))
    Additional_EDCH_Cell_Information_To_Add_List._cont = _Additional_EDCH_Cell_Information_To_Add_List__item_
    Additional_EDCH_Cell_Information_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Cell-Information-To-Add-ItemIEs >-----#
    Additional_EDCH_Cell_Information_To_Add_ItemIEs = SEQ(name='Additional-EDCH-Cell-Information-To-Add-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add_ItemIEs = SEQ_OF(name='additional-EDCH-RL-Specific-Information-To-Add-ItemIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs')))
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_FDD_Information = SEQ(name='additional-EDCH-FDD-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-FDD-Information')), opt=True)
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_multicell_EDCH_Information = SEQ(name='multicell-EDCH-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-Information')), opt=True)
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions._cont = __Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_To_Add_ItemIEs._cont = ASN1Dict([
        ('additional-EDCH-RL-Specific-Information-To-Add-ItemIEs', _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add_ItemIEs),
        ('additional-EDCH-FDD-Information', _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_FDD_Information),
        ('multicell-EDCH-Information', _Additional_EDCH_Cell_Information_To_Add_ItemIEs_multicell_EDCH_Information),
        ('iE-Extensions', _Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_To_Add_ItemIEs._ext = []
    
    #-----< Additional-EDCH-Cell-Information-To-Add-ItemIEs-ExtIEs >-----#
    Additional_EDCH_Cell_Information_To_Add_ItemIEs_ExtIEs = CLASS(name='Additional-EDCH-Cell-Information-To-Add-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_To_Add_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs >-----#
    Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs = SEQ_OF(name='Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EDCH-Additional-RL-Specific-Information-To-Add-List')))
    Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs._cont = _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs__item_
    Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< EDCH-Additional-RL-Specific-Information-To-Add-List >-----#
    EDCH_Additional_RL_Specific_Information_To_Add_List = SEQ(name='EDCH-Additional-RL-Specific-Information-To-Add-List', mode=MODE_TYPE)
    _EDCH_Additional_RL_Specific_Information_To_Add_List_eDCH_Additional_RL_ID = INT(name='eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _EDCH_Additional_RL_Specific_Information_To_Add_List_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _EDCH_Additional_RL_Specific_Information_To_Add_List_dl_CodeInformation = SEQ_OF(name='dl-CodeInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-CodeInformation')))
    _EDCH_Additional_RL_Specific_Information_To_Add_List_initialDL_transmissionPower = INT(name='initialDL-transmissionPower', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _EDCH_Additional_RL_Specific_Information_To_Add_List_maximumDL_power = INT(name='maximumDL-power', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _EDCH_Additional_RL_Specific_Information_To_Add_List_minimumDL_power = INT(name='minimumDL-power', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _EDCH_Additional_RL_Specific_Information_To_Add_List_f_DPCH_SlotFormat = INT(name='f-DPCH-SlotFormat', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')), opt=True)
    _EDCH_Additional_RL_Specific_Information_To_Add_List_multicell_EDCH_RL_Specific_Information = SEQ(name='multicell-EDCH-RL-Specific-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-RL-Specific-Information')), opt=True)
    _EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    ____EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _____EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id._const_tab = ____EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id_tab
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id._const_tab_id = 'id'
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__criticality._const_tab = ____EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id_tab
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__extensionValue._const_tab = ____EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id_tab
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id),
        ('criticality', ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__criticality),
        ('extensionValue', ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__extensionValue),
        ])
    __EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item_._ext = None
    _EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions._cont = __EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item_
    _EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_Additional_RL_Specific_Information_To_Add_List._cont = ASN1Dict([
        ('eDCH-Additional-RL-ID', _EDCH_Additional_RL_Specific_Information_To_Add_List_eDCH_Additional_RL_ID),
        ('c-ID', _EDCH_Additional_RL_Specific_Information_To_Add_List_c_ID),
        ('dl-CodeInformation', _EDCH_Additional_RL_Specific_Information_To_Add_List_dl_CodeInformation),
        ('initialDL-transmissionPower', _EDCH_Additional_RL_Specific_Information_To_Add_List_initialDL_transmissionPower),
        ('maximumDL-power', _EDCH_Additional_RL_Specific_Information_To_Add_List_maximumDL_power),
        ('minimumDL-power', _EDCH_Additional_RL_Specific_Information_To_Add_List_minimumDL_power),
        ('f-DPCH-SlotFormat', _EDCH_Additional_RL_Specific_Information_To_Add_List_f_DPCH_SlotFormat),
        ('multicell-EDCH-RL-Specific-Information', _EDCH_Additional_RL_Specific_Information_To_Add_List_multicell_EDCH_RL_Specific_Information),
        ('iE-Extensions', _EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions),
        ])
    EDCH_Additional_RL_Specific_Information_To_Add_List._ext = []
    
    #-----< EDCH-Additional-RL-Specific-Information-To-Add-List-ExtIEs >-----#
    EDCH_Additional_RL_Specific_Information_To_Add_List_ExtIEs = CLASS(name='EDCH-Additional-RL-Specific-Information-To-Add-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _EDCH_Additional_RL_Specific_Information_To_Add_List_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    EDCH_Additional_RL_Specific_Information_To_Add_List_ExtIEs._val = ASN1Set(rv=[dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _EDCH_Additional_RL_Specific_Information_To_Add_List_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Modify-List >-----#
    Additional_EDCH_RL_Specific_Information_To_Modify_List = SEQ_OF(name='Additional-EDCH-RL-Specific-Information-To-Modify-List', mode=MODE_TYPE)
    _Additional_EDCH_RL_Specific_Information_To_Modify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs')))
    Additional_EDCH_RL_Specific_Information_To_Modify_List._cont = _Additional_EDCH_RL_Specific_Information_To_Modify_List__item_
    Additional_EDCH_RL_Specific_Information_To_Modify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs >-----#
    Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs = SEQ(name='Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_eDCH_Additional_RL_ID = INT(name='eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_dl_CodeInformation = SEQ_OF(name='dl-CodeInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-CodeInformation')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_maximumDL_power = INT(name='maximumDL-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_minimumDL_power = INT(name='minimumDL-power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_f_DPCH_SlotFormat = INT(name='f-DPCH-SlotFormat', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_multicell_EDCH_RL_Specific_Information = SEQ(name='multicell-EDCH-RL-Specific-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-RL-Specific-Information')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions._cont = __Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs._cont = ASN1Dict([
        ('eDCH-Additional-RL-ID', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_eDCH_Additional_RL_ID),
        ('dl-CodeInformation', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_dl_CodeInformation),
        ('maximumDL-power', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_maximumDL_power),
        ('minimumDL-power', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_minimumDL_power),
        ('f-DPCH-SlotFormat', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_f_DPCH_SlotFormat),
        ('multicell-EDCH-RL-Specific-Information', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_multicell_EDCH_RL_Specific_Information),
        ('iE-Extensions', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs._ext = []
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs-ExtIEs >-----#
    Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs = CLASS(name='Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs._val = ASN1Set(rv=[dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-FDD-Information >-----#
    Additional_EDCH_FDD_Information = SEQ(name='Additional-EDCH-FDD-Information', mode=MODE_TYPE)
    _Additional_EDCH_FDD_Information_additional_EDCH_MAC_d_Flows_Specific_Information = SEQ_OF(name='additional-EDCH-MAC-d-Flows-Specific-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-MAC-d-Flows-Specific-Info-List')), opt=True)
    _Additional_EDCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name='hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _Additional_EDCH_FDD_Information_e_DCH_Maximum_Bitrate = INT(name='e-DCH-Maximum-Bitrate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Maximum-Bitrate')), opt=True)
    _Additional_EDCH_FDD_Information_e_DCH_Processing_Overload_Level = INT(name='e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _Additional_EDCH_FDD_Information_e_DCH_Min_Set_E_TFCI = INT(name='e-DCH-Min-Set-E-TFCI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCI')), opt=True)
    _Additional_EDCH_FDD_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_FDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DTX-Information2')))
    _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Implicit-Grant-Handling')))
    _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Minimum-TEBS-threshold')))
    _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Dual-Cell-EDCH-Enhancements-Information')))
    ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1284), ('criticality', 'ignore'), ('Extension', _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1299), ('criticality', 'ignore'), ('Extension', _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1300), ('criticality', 'ignore'), ('Extension', _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1313), ('criticality', 'reject'), ('Extension', _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__id._const_tab = ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_FDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_FDD_Information_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_FDD_Information_iE_Extensions__item_._ext = None
    _Additional_EDCH_FDD_Information_iE_Extensions._cont = __Additional_EDCH_FDD_Information_iE_Extensions__item_
    _Additional_EDCH_FDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_FDD_Information._cont = ASN1Dict([
        ('additional-EDCH-MAC-d-Flows-Specific-Information', _Additional_EDCH_FDD_Information_additional_EDCH_MAC_d_Flows_Specific_Information),
        ('hARQ-Process-Allocation-Scheduled-2ms-EDCH', _Additional_EDCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        ('e-DCH-Maximum-Bitrate', _Additional_EDCH_FDD_Information_e_DCH_Maximum_Bitrate),
        ('e-DCH-Processing-Overload-Level', _Additional_EDCH_FDD_Information_e_DCH_Processing_Overload_Level),
        ('e-DCH-Min-Set-E-TFCI', _Additional_EDCH_FDD_Information_e_DCH_Min_Set_E_TFCI),
        ('iE-Extensions', _Additional_EDCH_FDD_Information_iE_Extensions),
        ])
    Additional_EDCH_FDD_Information._ext = []
    
    #-----< Additional-EDCH-FDD-Information-ExtIEs >-----#
    Additional_EDCH_FDD_Information_ExtIEs = CLASS(name='Additional-EDCH-FDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DTX-Information2')))
    _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Implicit-Grant-Handling')))
    _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Minimum-TEBS-threshold')))
    _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Dual-Cell-EDCH-Enhancements-Information')))
    Additional_EDCH_FDD_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 1284), ('criticality', 'ignore'), ('Extension', _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1299), ('criticality', 'ignore'), ('Extension', _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1300), ('criticality', 'ignore'), ('Extension', _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1313), ('criticality', 'reject'), ('Extension', _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DTX-Information2 >-----#
    DTX_Information2 = SEQ(name='DTX-Information2', mode=MODE_TYPE)
    _DTX_Information2_uE_DTX_Cycle1 = ENUM(name='uE-DTX-Cycle1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Cycle1-2ms')))
    _DTX_Information2_uE_DTX_Cycle2 = ENUM(name='uE-DTX-Cycle2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Cycle2-ext-2ms')))
    _DTX_Information2_inactivity_Threshold_for_UE_DTX_Cycle2 = ENUM(name='inactivity-Threshold-for-UE-DTX-Cycle2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DTX-Cycle2')))
    _DTX_Information2_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Information2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Information2_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DTX_Information2_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Information2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information2_iE_Extensions__item__id._const_tab = ____DTX_Information2_iE_Extensions__item__id_tab
    ___DTX_Information2_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Information2_iE_Extensions__item__id._const_tab_id = 'id'
    ___DTX_Information2_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DTX_Information2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Information2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information2_iE_Extensions__item__criticality._const_tab = ____DTX_Information2_iE_Extensions__item__criticality_tab
    ___DTX_Information2_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DTX_Information2_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DTX_Information2_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DTX_Information2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Information2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information2_iE_Extensions__item__extensionValue._const_tab = ____DTX_Information2_iE_Extensions__item__extensionValue_tab
    ___DTX_Information2_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DTX_Information2_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DTX_Information2_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DTX_Information2_iE_Extensions__item__id),
        ('criticality', ___DTX_Information2_iE_Extensions__item__criticality),
        ('extensionValue', ___DTX_Information2_iE_Extensions__item__extensionValue),
        ])
    __DTX_Information2_iE_Extensions__item_._ext = None
    _DTX_Information2_iE_Extensions._cont = __DTX_Information2_iE_Extensions__item_
    _DTX_Information2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Information2._cont = ASN1Dict([
        ('uE-DTX-Cycle1', _DTX_Information2_uE_DTX_Cycle1),
        ('uE-DTX-Cycle2', _DTX_Information2_uE_DTX_Cycle2),
        ('inactivity-Threshold-for-UE-DTX-Cycle2', _DTX_Information2_inactivity_Threshold_for_UE_DTX_Cycle2),
        ('iE-Extensions', _DTX_Information2_iE_Extensions),
        ])
    DTX_Information2._ext = []
    
    #-----< DTX-Information2-ExtIEs >-----#
    DTX_Information2_ExtIEs = CLASS(name='DTX-Information2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DTX_Information2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Implicit-Grant-Handling >-----#
    Implicit_Grant_Handling = ENUM(name='Implicit-Grant-Handling', mode=MODE_TYPE)
    Implicit_Grant_Handling._cont = ASN1Dict([('true', 0)])
    Implicit_Grant_Handling._ext = None
    
    #-----< Minimum-TEBS-threshold >-----#
    Minimum_TEBS_threshold = ENUM(name='Minimum-TEBS-threshold', mode=MODE_TYPE)
    Minimum_TEBS_threshold._cont = ASN1Dict([('v2', 0), ('v4', 1), ('v8', 2), ('v16', 3), ('v32', 4), ('v64', 5), ('v128', 6), ('v256', 7), ('v512', 8), ('v1024', 9), ('v2048', 10), ('v4096', 11), ('v8192', 12), ('v16384', 13), ('v32768', 14), ('v65536', 15), ('v131072', 16), ('v262144', 17), ('v524288', 18), ('v1048576', 19)])
    Minimum_TEBS_threshold._ext = []
    
    #-----< Additional-EDCH-MAC-d-Flows-Specific-Info-List >-----#
    Additional_EDCH_MAC_d_Flows_Specific_Info_List = SEQ_OF(name='Additional-EDCH-MAC-d-Flows-Specific-Info-List', mode=MODE_TYPE)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-MAC-d-Flows-Specific-Info')))
    Additional_EDCH_MAC_d_Flows_Specific_Info_List._cont = _Additional_EDCH_MAC_d_Flows_Specific_Info_List__item_
    Additional_EDCH_MAC_d_Flows_Specific_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Additional-EDCH-MAC-d-Flows-Specific-Info >-----#
    Additional_EDCH_MAC_d_Flows_Specific_Info = SEQ(name='Additional-EDCH-MAC-d-Flows-Specific-Info', mode=MODE_TYPE)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _Additional_EDCH_MAC_d_Flows_Specific_Info_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item_._ext = None
    _Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions._cont = __Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item_
    _Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_MAC_d_Flows_Specific_Info._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _Additional_EDCH_MAC_d_Flows_Specific_Info_e_DCH_MACdFlow_ID),
        ('bindingID', _Additional_EDCH_MAC_d_Flows_Specific_Info_bindingID),
        ('transportLayerAddress', _Additional_EDCH_MAC_d_Flows_Specific_Info_transportLayerAddress),
        ('iE-Extensions', _Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions),
        ])
    Additional_EDCH_MAC_d_Flows_Specific_Info._ext = []
    
    #-----< Additional-EDCH-MAC-d-Flows-Specific-Info-ExtIEs >-----#
    Additional_EDCH_MAC_d_Flows_Specific_Info_ExtIEs = CLASS(name='Additional-EDCH-MAC-d-Flows-Specific-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_MAC_d_Flows_Specific_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-Response-List >-----#
    Additional_EDCH_Cell_Information_Response_List = SEQ_OF(name='Additional-EDCH-Cell-Information-Response-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-FDD-Information-Response-ItemIEs')))
    Additional_EDCH_Cell_Information_Response_List._cont = _Additional_EDCH_Cell_Information_Response_List__item_
    Additional_EDCH_Cell_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-FDD-Information-Response-ItemIEs >-----#
    Additional_EDCH_FDD_Information_Response_ItemIEs = SEQ(name='Additional-EDCH-FDD-Information-Response-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_FDD_Information_Response_ItemIEs_eDCH_Additional_RL_Specific_Information_Response = SEQ_OF(name='eDCH-Additional-RL-Specific-Information-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'EDCH-Additional-RL-Specific-Information-Response-List')), opt=True)
    _Additional_EDCH_FDD_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response = SEQ_OF(name='additional-EDCH-MAC-d-Flow-Specific-Information-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List')), opt=True)
    _Additional_EDCH_FDD_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name='hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions._cont = __Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_FDD_Information_Response_ItemIEs._cont = ASN1Dict([
        ('eDCH-Additional-RL-Specific-Information-Response', _Additional_EDCH_FDD_Information_Response_ItemIEs_eDCH_Additional_RL_Specific_Information_Response),
        ('additional-EDCH-MAC-d-Flow-Specific-Information-Response', _Additional_EDCH_FDD_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response),
        ('hARQ-Process-Allocation-Scheduled-2ms-EDCH', _Additional_EDCH_FDD_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        ('iE-Extensions', _Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_FDD_Information_Response_ItemIEs._ext = []
    
    #-----< Additional-EDCH-FDD-Information-Response-ItemIEs-ExtIEs >-----#
    Additional_EDCH_FDD_Information_Response_ItemIEs_ExtIEs = CLASS(name='Additional-EDCH-FDD-Information-Response-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_FDD_Information_Response_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-Additional-RL-Specific-Information-Response-List >-----#
    EDCH_Additional_RL_Specific_Information_Response_List = SEQ_OF(name='EDCH-Additional-RL-Specific-Information-Response-List', mode=MODE_TYPE)
    _EDCH_Additional_RL_Specific_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EDCH-Additional-RL-Specific-Information-Response-ItemIEs')))
    EDCH_Additional_RL_Specific_Information_Response_List._cont = _EDCH_Additional_RL_Specific_Information_Response_List__item_
    EDCH_Additional_RL_Specific_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< EDCH-Additional-RL-Specific-Information-Response-ItemIEs >-----#
    EDCH_Additional_RL_Specific_Information_Response_ItemIEs = SEQ(name='EDCH-Additional-RL-Specific-Information-Response-ItemIEs', mode=MODE_TYPE)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_eDCH_Additional_RL_ID = INT(name='eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_received_total_wide_band_power = INT(name='received-total-wide-band-power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dL_PowerBalancing_ActivationIndicator = ENUM(name='dL-PowerBalancing-ActivationIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-ActivationIndicator')), opt=True)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_rL_Set_ID = INT(name='rL-Set-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_e_DCH_RL_Set_ID = INT(name='e-DCH-RL-Set-ID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_e_DCH_FDD_DL_Control_Channel_Information = SEQ(name='e-DCH-FDD-DL-Control-Channel-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab = ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id_tab
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab = ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item_._ext = None
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions._cont = __EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item_
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_Additional_RL_Specific_Information_Response_ItemIEs._cont = ASN1Dict([
        ('eDCH-Additional-RL-ID', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_eDCH_Additional_RL_ID),
        ('received-total-wide-band-power', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_received_total_wide_band_power),
        ('dL-PowerBalancing-ActivationIndicator', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dL_PowerBalancing_ActivationIndicator),
        ('rL-Set-ID', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_rL_Set_ID),
        ('e-DCH-RL-Set-ID', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_e_DCH_RL_Set_ID),
        ('e-DCH-FDD-DL-Control-Channel-Information', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_e_DCH_FDD_DL_Control_Channel_Information),
        ('iE-Extensions', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions),
        ])
    EDCH_Additional_RL_Specific_Information_Response_ItemIEs._ext = []
    
    #-----< EDCH-Additional-RL-Specific-Information-Response-ItemIEs-ExtIEs >-----#
    EDCH_Additional_RL_Specific_Information_Response_ItemIEs_ExtIEs = CLASS(name='EDCH-Additional-RL-Specific-Information-Response-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    EDCH_Additional_RL_Specific_Information_Response_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-Response-RLReconf-List >-----#
    Additional_EDCH_Cell_Information_Response_RLReconf_List = SEQ_OF(name='Additional-EDCH-Cell-Information-Response-RLReconf-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Response_RLReconf_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-FDD-Information-Response-RLReconf-Items')))
    Additional_EDCH_Cell_Information_Response_RLReconf_List._cont = _Additional_EDCH_Cell_Information_Response_RLReconf_List__item_
    Additional_EDCH_Cell_Information_Response_RLReconf_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-FDD-Information-Response-RLReconf-Items >-----#
    Additional_EDCH_FDD_Information_Response_RLReconf_Items = SEQ(name='Additional-EDCH-FDD-Information-Response-RLReconf-Items', mode=MODE_TYPE)
    _Additional_EDCH_FDD_Information_Response_RLReconf_Items_additional_EDCH_FDD_Information_Response_ItemIEs = SEQ(name='additional-EDCH-FDD-Information-Response-ItemIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-FDD-Information-Response-ItemIEs')), opt=True)
    _Additional_EDCH_FDD_Information_Response_RLReconf_Items_additional_Modififed_EDCH_FDD_Information_Response_ItemIEs = SEQ(name='additional-Modififed-EDCH-FDD-Information-Response-ItemIEs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-Modififed-EDCH-FDD-Information-Response-ItemIEs')), opt=True)
    _Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id._const_tab = ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item_._ext = None
    _Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions._cont = __Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item_
    _Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_FDD_Information_Response_RLReconf_Items._cont = ASN1Dict([
        ('additional-EDCH-FDD-Information-Response-ItemIEs', _Additional_EDCH_FDD_Information_Response_RLReconf_Items_additional_EDCH_FDD_Information_Response_ItemIEs),
        ('additional-Modififed-EDCH-FDD-Information-Response-ItemIEs', _Additional_EDCH_FDD_Information_Response_RLReconf_Items_additional_Modififed_EDCH_FDD_Information_Response_ItemIEs),
        ('iE-Extensions', _Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions),
        ])
    Additional_EDCH_FDD_Information_Response_RLReconf_Items._ext = []
    
    #-----< Additional-EDCH-FDD-Information-Response-RLReconf-Items-ExtIEs >-----#
    Additional_EDCH_FDD_Information_Response_RLReconf_Items_ExtIEs = CLASS(name='Additional-EDCH-FDD-Information-Response-RLReconf-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_FDD_Information_Response_RLReconf_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-Modififed-EDCH-FDD-Information-Response-ItemIEs >-----#
    Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs = SEQ(name='Additional-Modififed-EDCH-FDD-Information-Response-ItemIEs', mode=MODE_TYPE)
    _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_eDCH_Additional_Modified_RL_Specific_Information_Response = SEQ_OF(name='eDCH-Additional-Modified-RL-Specific-Information-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'EDCH-Additional-Modified-RL-Specific-Information-Response-List')), opt=True)
    _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response = SEQ_OF(name='additional-EDCH-MAC-d-Flow-Specific-Information-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List')), opt=True)
    _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name='hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions._cont = __Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_
    _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs._cont = ASN1Dict([
        ('eDCH-Additional-Modified-RL-Specific-Information-Response', _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_eDCH_Additional_Modified_RL_Specific_Information_Response),
        ('additional-EDCH-MAC-d-Flow-Specific-Information-Response', _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response),
        ('hARQ-Process-Allocation-Scheduled-2ms-EDCH', _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        ('iE-Extensions', _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions),
        ])
    Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs._ext = []
    
    #-----< Additional-Modififed-EDCH-FDD-Information-Response-ItemIEs-ExtIEs >-----#
    Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_ExtIEs = CLASS(name='Additional-Modififed-EDCH-FDD-Information-Response-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-Additional-Modified-RL-Specific-Information-Response-List >-----#
    EDCH_Additional_Modified_RL_Specific_Information_Response_List = SEQ_OF(name='EDCH-Additional-Modified-RL-Specific-Information-Response-List', mode=MODE_TYPE)
    _EDCH_Additional_Modified_RL_Specific_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EDCH-Additional-Modified-RL-Specific-Information-Response-List-Items')))
    EDCH_Additional_Modified_RL_Specific_Information_Response_List._cont = _EDCH_Additional_Modified_RL_Specific_Information_Response_List__item_
    EDCH_Additional_Modified_RL_Specific_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< EDCH-Additional-Modified-RL-Specific-Information-Response-List-Items >-----#
    EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items = SEQ(name='EDCH-Additional-Modified-RL-Specific-Information-Response-List-Items', mode=MODE_TYPE)
    _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_eDCH_Additional_RL_ID = INT(name='eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_dL_PowerBalancing_UpdatedIndicator = ENUM(name='dL-PowerBalancing-UpdatedIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-UpdatedIndicator')), opt=True)
    _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_e_DCH_FDD_DL_Control_Channel_Information = SEQ(name='e-DCH-FDD-DL-Control-Channel-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')), opt=True)
    _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__id._const_tab = ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__id_tab
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__id._const_tab_id = 'id'
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__criticality._const_tab = ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__criticality_tab
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__extensionValue._const_tab = ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__extensionValue_tab
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__id),
        ('criticality', ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__criticality),
        ('extensionValue', ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__extensionValue),
        ])
    __EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item_._ext = None
    _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions._cont = __EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item_
    _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items._cont = ASN1Dict([
        ('eDCH-Additional-RL-ID', _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_eDCH_Additional_RL_ID),
        ('dL-PowerBalancing-UpdatedIndicator', _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_dL_PowerBalancing_UpdatedIndicator),
        ('e-DCH-FDD-DL-Control-Channel-Information', _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_e_DCH_FDD_DL_Control_Channel_Information),
        ('iE-Extensions', _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions),
        ])
    EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items._ext = []
    
    #-----< EDCH-Additional-Modified-RL-Specific-Information-Response-List-Items-ExtIEs >-----#
    EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_ExtIEs = CLASS(name='EDCH-Additional-Modified-RL-Specific-Information-Response-List-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List >-----#
    Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List = SEQ_OF(name='Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List', mode=MODE_TYPE)
    _Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-MAC-d-Flows-Specific-Info-Response')))
    Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List._cont = _Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List__item_
    Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Additional-EDCH-MAC-d-Flows-Specific-Info-Response >-----#
    Additional_EDCH_MAC_d_Flows_Specific_Info_Response = SEQ(name='Additional-EDCH-MAC-d-Flows-Specific-Info-Response', mode=MODE_TYPE)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item_._ext = None
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions._cont = __Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item_
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_MAC_d_Flows_Specific_Info_Response._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_e_DCH_MACdFlow_ID),
        ('bindingID', _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_bindingID),
        ('transportLayerAddress', _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_transportLayerAddress),
        ('iE-Extensions', _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions),
        ])
    Additional_EDCH_MAC_d_Flows_Specific_Info_Response._ext = []
    
    #-----< Additional-EDCH-MAC-d-Flows-Specific-Info-Response-ExtIEs >-----#
    Additional_EDCH_MAC_d_Flows_Specific_Info_Response_ExtIEs = CLASS(name='Additional-EDCH-MAC-d-Flows-Specific-Info-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_MAC_d_Flows_Specific_Info_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-Response-RL-Add-List >-----#
    Additional_EDCH_Cell_Information_Response_RL_Add_List = SEQ_OF(name='Additional-EDCH-Cell-Information-Response-RL-Add-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Response_RL_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-RL-Add-ItemIEs')))
    Additional_EDCH_Cell_Information_Response_RL_Add_List._cont = _Additional_EDCH_Cell_Information_Response_RL_Add_List__item_
    Additional_EDCH_Cell_Information_Response_RL_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Cell-Information-Response-RL-Add-ItemIEs >-----#
    Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs = SEQ(name='Additional-EDCH-Cell-Information-Response-RL-Add-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_additional_EDCH_FDD_Information_Response = SEQ(name='additional-EDCH-FDD-Information-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-FDD-Information-Response-ItemIEs')), opt=True)
    _Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_additional_EDCH_Serving_Cell_Change_Information_Response = SEQ(name='additional-EDCH-Serving-Cell-Change-Information-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Serving-Cell-Change-Info-Response')), opt=True)
    _Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions._cont = __Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs._cont = ASN1Dict([
        ('additional-EDCH-FDD-Information-Response', _Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_additional_EDCH_FDD_Information_Response),
        ('additional-EDCH-Serving-Cell-Change-Information-Response', _Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_additional_EDCH_Serving_Cell_Change_Information_Response),
        ('iE-Extensions', _Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs._ext = []
    
    #-----< Additional-EDCH-Cell-Information-Response-RL-Add-ItemIEs-ExtIEs >-----#
    Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_ExtIEs = CLASS(name='Additional-EDCH-Cell-Information-Response-RL-Add-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-ConfigurationChange-List >-----#
    Additional_EDCH_Cell_Information_ConfigurationChange_List = SEQ_OF(name='Additional-EDCH-Cell-Information-ConfigurationChange-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_ConfigurationChange_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-ConfigurationChange-Info-ItemIEs')))
    Additional_EDCH_Cell_Information_ConfigurationChange_List._cont = _Additional_EDCH_Cell_Information_ConfigurationChange_List__item_
    Additional_EDCH_Cell_Information_ConfigurationChange_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-ConfigurationChange-Info-ItemIEs >-----#
    Additional_EDCH_ConfigurationChange_Info_ItemIEs = SEQ(name='Additional-EDCH-ConfigurationChange-Info-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_UL_DPCH_Information_Modify = SEQ(name='additional-EDCH-UL-DPCH-Information-Modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-UL-DPCH-Information-Modify')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add = SEQ_OF(name='additional-EDCH-RL-Specific-Information-To-Add', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Modify = SEQ_OF(name='additional-EDCH-RL-Specific-Information-To-Modify', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Modify-List')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_FDD_Information_To_Modify = SEQ(name='additional-EDCH-FDD-Information-To-Modify', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-FDD-Information')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_F_DPCH_Information_Modify = SEQ(name='additional-EDCH-F-DPCH-Information-Modify', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-F-DPCH-Information')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_multicell_EDCH_Information = SEQ(name='multicell-EDCH-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-Information')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions._cont = __Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_ConfigurationChange_Info_ItemIEs._cont = ASN1Dict([
        ('additional-EDCH-UL-DPCH-Information-Modify', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_UL_DPCH_Information_Modify),
        ('additional-EDCH-RL-Specific-Information-To-Add', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add),
        ('additional-EDCH-RL-Specific-Information-To-Modify', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Modify),
        ('additional-EDCH-FDD-Information-To-Modify', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_FDD_Information_To_Modify),
        ('additional-EDCH-F-DPCH-Information-Modify', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_F_DPCH_Information_Modify),
        ('multicell-EDCH-Information', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_multicell_EDCH_Information),
        ('iE-Extensions', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_ConfigurationChange_Info_ItemIEs._ext = []
    
    #-----< Additional-EDCH-ConfigurationChange-Info-ItemIEs-ExtIEs >-----#
    Additional_EDCH_ConfigurationChange_Info_ItemIEs_ExtIEs = CLASS(name='Additional-EDCH-ConfigurationChange-Info-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_ConfigurationChange_Info_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-UL-DPCH-Information-Modify >-----#
    Additional_EDCH_UL_DPCH_Information_Modify = SEQ(name='Additional-EDCH-UL-DPCH-Information-Modify', mode=MODE_TYPE)
    _Additional_EDCH_UL_DPCH_Information_Modify_ul_ScramblingCode = SEQ(name='ul-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-ScramblingCode')), opt=True)
    _Additional_EDCH_UL_DPCH_Information_Modify_ul_SIR_Target = INT(name='ul-SIR-Target', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')), opt=True)
    _Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id._const_tab = ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id_tab
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item_._ext = None
    _Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions._cont = __Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item_
    _Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_UL_DPCH_Information_Modify._cont = ASN1Dict([
        ('ul-ScramblingCode', _Additional_EDCH_UL_DPCH_Information_Modify_ul_ScramblingCode),
        ('ul-SIR-Target', _Additional_EDCH_UL_DPCH_Information_Modify_ul_SIR_Target),
        ('iE-Extensions', _Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions),
        ])
    Additional_EDCH_UL_DPCH_Information_Modify._ext = []
    
    #-----< Additional-EDCH-UL-DPCH-Information-Modify-ExtIEs >-----#
    Additional_EDCH_UL_DPCH_Information_Modify_ExtIEs = CLASS(name='Additional-EDCH-UL-DPCH-Information-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_UL_DPCH_Information_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-Removal-List >-----#
    Additional_EDCH_Cell_Information_Removal_List = SEQ_OF(name='Additional-EDCH-Cell-Information-Removal-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Removal_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs')))
    Additional_EDCH_Cell_Information_Removal_List._cont = _Additional_EDCH_Cell_Information_Removal_List__item_
    Additional_EDCH_Cell_Information_Removal_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Cell-Information-Removal-Info-ItemIEs >-----#
    Additional_EDCH_Cell_Information_Removal_Info_ItemIEs = SEQ(name='Additional-EDCH-Cell-Information-Removal-Info-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_rL_on_Secondary_UL_Frequency = ENUM(name='rL-on-Secondary-UL-Frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-on-Secondary-UL-Frequency')))
    _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions._cont = __Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_Removal_Info_ItemIEs._cont = ASN1Dict([
        ('rL-on-Secondary-UL-Frequency', _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_rL_on_Secondary_UL_Frequency),
        ('iE-Extensions', _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_Removal_Info_ItemIEs._ext = []
    
    #-----< Additional-EDCH-Cell-Information-Removal-Info-ItemIEs-ExtIEs >-----#
    Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_ExtIEs = CLASS(name='Additional-EDCH-Cell-Information-Removal-Info-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-on-Secondary-UL-Frequency >-----#
    RL_on_Secondary_UL_Frequency = ENUM(name='RL-on-Secondary-UL-Frequency', mode=MODE_TYPE)
    RL_on_Secondary_UL_Frequency._cont = ASN1Dict([('remove', 0)])
    RL_on_Secondary_UL_Frequency._ext = []
    
    #-----< Additional-EDCH-FDD-Update-Information >-----#
    Additional_EDCH_FDD_Update_Information = SEQ(name='Additional-EDCH-FDD-Update-Information', mode=MODE_TYPE)
    _Additional_EDCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name='hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _Additional_EDCH_FDD_Update_Information_additional_EDCH_DL_Control_Channel_Change_Information = SEQ_OF(name='additional-EDCH-DL-Control-Channel-Change-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-DL-Control-Channel-Change-Information-List')), opt=True)
    _Additional_EDCH_FDD_Update_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_FDD_Update_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id._const_tab = ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_FDD_Update_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_FDD_Update_Information_iE_Extensions__item_._ext = None
    _Additional_EDCH_FDD_Update_Information_iE_Extensions._cont = __Additional_EDCH_FDD_Update_Information_iE_Extensions__item_
    _Additional_EDCH_FDD_Update_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_FDD_Update_Information._cont = ASN1Dict([
        ('hARQ-Process-Allocation-Scheduled-2ms-EDCH', _Additional_EDCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        ('additional-EDCH-DL-Control-Channel-Change-Information', _Additional_EDCH_FDD_Update_Information_additional_EDCH_DL_Control_Channel_Change_Information),
        ('iE-Extensions', _Additional_EDCH_FDD_Update_Information_iE_Extensions),
        ])
    Additional_EDCH_FDD_Update_Information._ext = []
    
    #-----< Additional-EDCH-FDD-Update-Information-ExtIEs >-----#
    Additional_EDCH_FDD_Update_Information_ExtIEs = CLASS(name='Additional-EDCH-FDD-Update-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_FDD_Update_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-DL-Control-Channel-Change-Information-List >-----#
    Additional_EDCH_DL_Control_Channel_Change_Information_List = SEQ_OF(name='Additional-EDCH-DL-Control-Channel-Change-Information-List', mode=MODE_TYPE)
    _Additional_EDCH_DL_Control_Channel_Change_Information_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs')))
    Additional_EDCH_DL_Control_Channel_Change_Information_List._cont = _Additional_EDCH_DL_Control_Channel_Change_Information_List__item_
    Additional_EDCH_DL_Control_Channel_Change_Information_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs >-----#
    Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs = SEQ(name='Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_eDCH_Additional_RL_ID = INT(name='eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions._cont = __Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs._cont = ASN1Dict([
        ('eDCH-Additional-RL-ID', _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_eDCH_Additional_RL_ID),
        ('iE-Extensions', _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs._ext = []
    
    #-----< Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs-ExtIEs >-----#
    Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_ExtIEs = CLASS(name='Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalMeasurementValueList >-----#
    AdditionalMeasurementValueList = SEQ_OF(name='AdditionalMeasurementValueList', mode=MODE_TYPE)
    _AdditionalMeasurementValueList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AdditionalMeasurementValue')))
    AdditionalMeasurementValueList._cont = _AdditionalMeasurementValueList__item_
    AdditionalMeasurementValueList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< AdditionalMeasurementValue >-----#
    AdditionalMeasurementValue = SEQ(name='AdditionalMeasurementValue', mode=MODE_TYPE)
    _AdditionalMeasurementValue_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _AdditionalMeasurementValue_timeSlotMeasurementValueListLCR = SEQ_OF(name='timeSlotMeasurementValueListLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotMeasurementValueListLCR')))
    _AdditionalMeasurementValue_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalMeasurementValue_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AdditionalMeasurementValue_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalMeasurementValue_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AdditionalMeasurementValue_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalMeasurementValue_iE_Extensions__item__id._const_tab = ____AdditionalMeasurementValue_iE_Extensions__item__id_tab
    ___AdditionalMeasurementValue_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalMeasurementValue_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalMeasurementValue_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AdditionalMeasurementValue_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AdditionalMeasurementValue_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalMeasurementValue_iE_Extensions__item__criticality._const_tab = ____AdditionalMeasurementValue_iE_Extensions__item__criticality_tab
    ___AdditionalMeasurementValue_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalMeasurementValue_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalMeasurementValue_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AdditionalMeasurementValue_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AdditionalMeasurementValue_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalMeasurementValue_iE_Extensions__item__extensionValue._const_tab = ____AdditionalMeasurementValue_iE_Extensions__item__extensionValue_tab
    ___AdditionalMeasurementValue_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalMeasurementValue_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalMeasurementValue_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalMeasurementValue_iE_Extensions__item__id),
        ('criticality', ___AdditionalMeasurementValue_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalMeasurementValue_iE_Extensions__item__extensionValue),
        ])
    __AdditionalMeasurementValue_iE_Extensions__item_._ext = None
    _AdditionalMeasurementValue_iE_Extensions._cont = __AdditionalMeasurementValue_iE_Extensions__item_
    _AdditionalMeasurementValue_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalMeasurementValue._cont = ASN1Dict([
        ('uARFCN', _AdditionalMeasurementValue_uARFCN),
        ('timeSlotMeasurementValueListLCR', _AdditionalMeasurementValue_timeSlotMeasurementValueListLCR),
        ('iE-Extensions', _AdditionalMeasurementValue_iE_Extensions),
        ])
    AdditionalMeasurementValue._ext = []
    
    #-----< AdditionalMeasurementValueList-ExtIEs >-----#
    AdditionalMeasurementValueList_ExtIEs = CLASS(name='AdditionalMeasurementValueList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    AdditionalMeasurementValueList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalTimeSlotListLCR >-----#
    AdditionalTimeSlotListLCR = SEQ_OF(name='AdditionalTimeSlotListLCR', mode=MODE_TYPE)
    _AdditionalTimeSlotListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AdditionalTimeSlotLCR')))
    AdditionalTimeSlotListLCR._cont = _AdditionalTimeSlotListLCR__item_
    AdditionalTimeSlotListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=None, er=[])
    
    #-----< AdditionalTimeSlotLCR >-----#
    AdditionalTimeSlotLCR = SEQ(name='AdditionalTimeSlotLCR', mode=MODE_TYPE)
    _AdditionalTimeSlotLCR_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _AdditionalTimeSlotLCR_timeslot_InitiatedListLCR = SEQ_OF(name='timeslot-InitiatedListLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot-InitiatedListLCR')), opt=True)
    _AdditionalTimeSlotLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalTimeSlotLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AdditionalTimeSlotLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalTimeSlotLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AdditionalTimeSlotLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalTimeSlotLCR_iE_Extensions__item__id._const_tab = ____AdditionalTimeSlotLCR_iE_Extensions__item__id_tab
    ___AdditionalTimeSlotLCR_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalTimeSlotLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalTimeSlotLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AdditionalTimeSlotLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AdditionalTimeSlotLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalTimeSlotLCR_iE_Extensions__item__criticality._const_tab = ____AdditionalTimeSlotLCR_iE_Extensions__item__criticality_tab
    ___AdditionalTimeSlotLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalTimeSlotLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalTimeSlotLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AdditionalTimeSlotLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AdditionalTimeSlotLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalTimeSlotLCR_iE_Extensions__item__extensionValue._const_tab = ____AdditionalTimeSlotLCR_iE_Extensions__item__extensionValue_tab
    ___AdditionalTimeSlotLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalTimeSlotLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalTimeSlotLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalTimeSlotLCR_iE_Extensions__item__id),
        ('criticality', ___AdditionalTimeSlotLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalTimeSlotLCR_iE_Extensions__item__extensionValue),
        ])
    __AdditionalTimeSlotLCR_iE_Extensions__item_._ext = None
    _AdditionalTimeSlotLCR_iE_Extensions._cont = __AdditionalTimeSlotLCR_iE_Extensions__item_
    _AdditionalTimeSlotLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalTimeSlotLCR._cont = ASN1Dict([
        ('uARFCN', _AdditionalTimeSlotLCR_uARFCN),
        ('timeslot-InitiatedListLCR', _AdditionalTimeSlotLCR_timeslot_InitiatedListLCR),
        ('iE-Extensions', _AdditionalTimeSlotLCR_iE_Extensions),
        ])
    AdditionalTimeSlotLCR._ext = []
    
    #-----< AdditionalTimeSlotLCR-ExtIEs >-----#
    AdditionalTimeSlotLCR_ExtIEs = CLASS(name='AdditionalTimeSlotLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    AdditionalTimeSlotLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AddorDeleteIndicator >-----#
    AddorDeleteIndicator = ENUM(name='AddorDeleteIndicator', mode=MODE_TYPE)
    AddorDeleteIndicator._cont = ASN1Dict([('add', 0), ('delete', 1)])
    AddorDeleteIndicator._ext = None
    
    #-----< Active-Pattern-Sequence-Information >-----#
    Active_Pattern_Sequence_Information = SEQ(name='Active-Pattern-Sequence-Information', mode=MODE_TYPE)
    _Active_Pattern_Sequence_Information_cMConfigurationChangeCFN = INT(name='cMConfigurationChangeCFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    _Active_Pattern_Sequence_Information_transmission_Gap_Pattern_Sequence_Status = SEQ_OF(name='transmission-Gap-Pattern-Sequence-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transmission-Gap-Pattern-Sequence-Status-List')), opt=True)
    _Active_Pattern_Sequence_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Active_Pattern_Sequence_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id._const_tab = ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id._const_tab_at = None
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality._const_tab = ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue._const_tab = ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Active_Pattern_Sequence_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Active_Pattern_Sequence_Information_iE_Extensions__item__id),
        ('criticality', ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue),
        ])
    __Active_Pattern_Sequence_Information_iE_Extensions__item_._ext = None
    _Active_Pattern_Sequence_Information_iE_Extensions._cont = __Active_Pattern_Sequence_Information_iE_Extensions__item_
    _Active_Pattern_Sequence_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Active_Pattern_Sequence_Information._cont = ASN1Dict([
        ('cMConfigurationChangeCFN', _Active_Pattern_Sequence_Information_cMConfigurationChangeCFN),
        ('transmission-Gap-Pattern-Sequence-Status', _Active_Pattern_Sequence_Information_transmission_Gap_Pattern_Sequence_Status),
        ('iE-Extensions', _Active_Pattern_Sequence_Information_iE_Extensions),
        ])
    Active_Pattern_Sequence_Information._ext = []
    
    #-----< Active-Pattern-Sequence-Information-ExtIEs >-----#
    Active_Pattern_Sequence_Information_ExtIEs = CLASS(name='Active-Pattern-Sequence-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Active_Pattern_Sequence_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transmission-Gap-Pattern-Sequence-Status-List >-----#
    Transmission_Gap_Pattern_Sequence_Status_List = SEQ_OF(name='Transmission-Gap-Pattern-Sequence-Status-List', mode=MODE_TYPE)
    _Transmission_Gap_Pattern_Sequence_Status_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPSID = INT(name='tGPSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TGPSID')))
    __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPRC = INT(name='tGPRC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TGPRC')))
    __Transmission_Gap_Pattern_Sequence_Status_List__item__tGCFN = INT(name='tGCFN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ______Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Affected-HSDSCH-Serving-Cell-List')))
    _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1212), ('criticality', 'reject'), ('Extension', ______Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id._const_tab = _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id._const_tab_at = None
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality._const_tab = _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue._const_tab = _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id),
        ('criticality', ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue),
        ])
    ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_._ext = None
    __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions._cont = ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_
    __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Transmission_Gap_Pattern_Sequence_Status_List__item_._cont = ASN1Dict([
        ('tGPSID', __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPSID),
        ('tGPRC', __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPRC),
        ('tGCFN', __Transmission_Gap_Pattern_Sequence_Status_List__item__tGCFN),
        ('iE-Extensions', __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions),
        ])
    _Transmission_Gap_Pattern_Sequence_Status_List__item_._ext = []
    Transmission_Gap_Pattern_Sequence_Status_List._cont = _Transmission_Gap_Pattern_Sequence_Status_List__item_
    Transmission_Gap_Pattern_Sequence_Status_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs >-----#
    Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs = CLASS(name='Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Affected-HSDSCH-Serving-Cell-List')))
    Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs._val = ASN1Set(rv=[dict([('id', 1212), ('criticality', 'reject'), ('Extension', _Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Affected-HSDSCH-Serving-Cell-List >-----#
    Affected_HSDSCH_Serving_Cell_List = SEQ_OF(name='Affected-HSDSCH-Serving-Cell-List', mode=MODE_TYPE)
    _Affected_HSDSCH_Serving_Cell_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    Affected_HSDSCH_Serving_Cell_List._cont = _Affected_HSDSCH_Serving_Cell_List__item_
    Affected_HSDSCH_Serving_Cell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=33)], ev=None, er=[])
    
    #-----< AICH-Power >-----#
    AICH_Power = INT(name='AICH-Power', mode=MODE_TYPE)
    AICH_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-22, ub=5)], ev=None, er=[])
    
    #-----< AICH-TransmissionTiming >-----#
    AICH_TransmissionTiming = ENUM(name='AICH-TransmissionTiming', mode=MODE_TYPE)
    AICH_TransmissionTiming._cont = ASN1Dict([('v0', 0), ('v1', 1)])
    AICH_TransmissionTiming._ext = None
    
    #-----< AllocationRetentionPriority >-----#
    AllocationRetentionPriority = SEQ(name='AllocationRetentionPriority', mode=MODE_TYPE)
    _AllocationRetentionPriority_priorityLevel = INT(name='priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityLevel')))
    _AllocationRetentionPriority_pre_emptionCapability = ENUM(name='pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Pre-emptionCapability')))
    _AllocationRetentionPriority_pre_emptionVulnerability = ENUM(name='pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Pre-emptionVulnerability')))
    _AllocationRetentionPriority_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AllocationRetentionPriority_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AllocationRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AllocationRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationRetentionPriority_iE_Extensions__item__id._const_tab_id = 'id'
    ___AllocationRetentionPriority_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AllocationRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AllocationRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AllocationRetentionPriority_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AllocationRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AllocationRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AllocationRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AllocationRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AllocationRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AllocationRetentionPriority_iE_Extensions__item__id),
        ('criticality', ___AllocationRetentionPriority_iE_Extensions__item__criticality),
        ('extensionValue', ___AllocationRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationRetentionPriority_iE_Extensions._cont = __AllocationRetentionPriority_iE_Extensions__item_
    _AllocationRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationRetentionPriority._cont = ASN1Dict([
        ('priorityLevel', _AllocationRetentionPriority_priorityLevel),
        ('pre-emptionCapability', _AllocationRetentionPriority_pre_emptionCapability),
        ('pre-emptionVulnerability', _AllocationRetentionPriority_pre_emptionVulnerability),
        ('iE-Extensions', _AllocationRetentionPriority_iE_Extensions),
        ])
    AllocationRetentionPriority._ext = []
    
    #-----< AllocationRetentionPriority-ExtIEs >-----#
    AllocationRetentionPriority_ExtIEs = CLASS(name='AllocationRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    AllocationRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AlternativeFormatReportingIndicator >-----#
    AlternativeFormatReportingIndicator = ENUM(name='AlternativeFormatReportingIndicator', mode=MODE_TYPE)
    AlternativeFormatReportingIndicator._cont = ASN1Dict([('alternativeFormatAllowed', 0)])
    AlternativeFormatReportingIndicator._ext = []
    
    #-----< Angle-Of-Arrival-Value-LCR >-----#
    Angle_Of_Arrival_Value_LCR = SEQ(name='Angle-Of-Arrival-Value-LCR', mode=MODE_TYPE)
    _Angle_Of_Arrival_Value_LCR_aOA_LCR = INT(name='aOA-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AOA-LCR')))
    _Angle_Of_Arrival_Value_LCR_aOA_LCR_Accuracy_Class = ENUM(name='aOA-LCR-Accuracy-Class', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AOA-LCR-Accuracy-Class')))
    _Angle_Of_Arrival_Value_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Angle_Of_Arrival_Value_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id._const_tab = ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id_tab
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id._const_tab_at = None
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality._const_tab = ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality_tab
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue._const_tab = ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue_tab
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Angle_Of_Arrival_Value_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id),
        ('criticality', ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue),
        ])
    __Angle_Of_Arrival_Value_LCR_iE_Extensions__item_._ext = None
    _Angle_Of_Arrival_Value_LCR_iE_Extensions._cont = __Angle_Of_Arrival_Value_LCR_iE_Extensions__item_
    _Angle_Of_Arrival_Value_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Angle_Of_Arrival_Value_LCR._cont = ASN1Dict([
        ('aOA-LCR', _Angle_Of_Arrival_Value_LCR_aOA_LCR),
        ('aOA-LCR-Accuracy-Class', _Angle_Of_Arrival_Value_LCR_aOA_LCR_Accuracy_Class),
        ('iE-Extensions', _Angle_Of_Arrival_Value_LCR_iE_Extensions),
        ])
    Angle_Of_Arrival_Value_LCR._ext = []
    
    #-----< Angle-Of-Arrival-Value-LCR-ExtIEs >-----#
    Angle_Of_Arrival_Value_LCR_ExtIEs = CLASS(name='Angle-Of-Arrival-Value-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Angle_Of_Arrival_Value_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AOA-LCR >-----#
    AOA_LCR = INT(name='AOA-LCR', mode=MODE_TYPE)
    AOA_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=719)], ev=None, er=[])
    
    #-----< AOA-LCR-Accuracy-Class >-----#
    AOA_LCR_Accuracy_Class = ENUM(name='AOA-LCR-Accuracy-Class', mode=MODE_TYPE)
    AOA_LCR_Accuracy_Class._cont = ASN1Dict([('a', 0), ('b', 1), ('c', 2), ('d', 3), ('e', 4), ('f', 5), ('g', 6), ('h', 7)])
    AOA_LCR_Accuracy_Class._ext = []
    
    #-----< AOA-per-CELL-Portion-LCR >-----#
    AOA_per_CELL_Portion_LCR = SEQ_OF(name='AOA-per-CELL-Portion-LCR', mode=MODE_TYPE)
    _AOA_per_CELL_Portion_LCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AOA-per-CELL-Portion-LCR-Item')))
    AOA_per_CELL_Portion_LCR._cont = _AOA_per_CELL_Portion_LCR__item_
    AOA_per_CELL_Portion_LCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< AOA-per-CELL-Portion-LCR-Item >-----#
    AOA_per_CELL_Portion_LCR_Item = SEQ(name='AOA-per-CELL-Portion-LCR-Item', mode=MODE_TYPE)
    _AOA_per_CELL_Portion_LCR_Item_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _AOA_per_CELL_Portion_LCR_Item_aOA_LCR = INT(name='aOA-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AOA-LCR')))
    _AOA_per_CELL_Portion_LCR_Item_aOA_LCR_Accuracy_Class = ENUM(name='aOA-LCR-Accuracy-Class', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AOA-LCR-Accuracy-Class')))
    _AOA_per_CELL_Portion_LCR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__id._const_tab = ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__id_tab
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__id._const_tab_at = None
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__criticality._const_tab = ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__criticality_tab
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__extensionValue._const_tab = ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__extensionValue_tab
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__id),
        ('criticality', ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__extensionValue),
        ])
    __AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item_._ext = None
    _AOA_per_CELL_Portion_LCR_Item_iE_Extensions._cont = __AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item_
    _AOA_per_CELL_Portion_LCR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AOA_per_CELL_Portion_LCR_Item._cont = ASN1Dict([
        ('cellPortionLCRID', _AOA_per_CELL_Portion_LCR_Item_cellPortionLCRID),
        ('aOA-LCR', _AOA_per_CELL_Portion_LCR_Item_aOA_LCR),
        ('aOA-LCR-Accuracy-Class', _AOA_per_CELL_Portion_LCR_Item_aOA_LCR_Accuracy_Class),
        ('iE-Extensions', _AOA_per_CELL_Portion_LCR_Item_iE_Extensions),
        ])
    AOA_per_CELL_Portion_LCR_Item._ext = []
    
    #-----< AOA-per-CELL-Portion-LCR-Item-ExtIEs >-----#
    AOA_per_CELL_Portion_LCR_Item_ExtIEs = CLASS(name='AOA-per-CELL-Portion-LCR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    AOA_per_CELL_Portion_LCR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AvailabilityStatus >-----#
    AvailabilityStatus = ENUM(name='AvailabilityStatus', mode=MODE_TYPE)
    AvailabilityStatus._cont = ASN1Dict([('empty', 0), ('in-test', 1), ('failed', 2), ('power-off', 3), ('off-line', 4), ('off-duty', 5), ('dependency', 6), ('degraded', 7), ('not-installed', 8), ('log-full', 9)])
    AvailabilityStatus._ext = []
    
    #-----< BCCH-Specific-HSDSCH-RNTI-Information >-----#
    BCCH_Specific_HSDSCH_RNTI_Information = SEQ(name='BCCH-Specific-HSDSCH-RNTI-Information', mode=MODE_TYPE)
    _BCCH_Specific_HSDSCH_RNTI_Information_bCCH_Specific_HSDSCH_RNTI = INT(name='bCCH-Specific-HSDSCH-RNTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _BCCH_Specific_HSDSCH_RNTI_Information_hSSCCH_Power = INT(name='hSSCCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _BCCH_Specific_HSDSCH_RNTI_Information_hSPDSCH_Power = INT(name='hSPDSCH-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__id._const_tab = ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__id_tab
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__id._const_tab_at = None
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__criticality._const_tab = ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__criticality_tab
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__extensionValue._const_tab = ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__extensionValue_tab
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__id),
        ('criticality', ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__extensionValue),
        ])
    __BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item_._ext = None
    _BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions._cont = __BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item_
    _BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCCH_Specific_HSDSCH_RNTI_Information._cont = ASN1Dict([
        ('bCCH-Specific-HSDSCH-RNTI', _BCCH_Specific_HSDSCH_RNTI_Information_bCCH_Specific_HSDSCH_RNTI),
        ('hSSCCH-Power', _BCCH_Specific_HSDSCH_RNTI_Information_hSSCCH_Power),
        ('hSPDSCH-Power', _BCCH_Specific_HSDSCH_RNTI_Information_hSPDSCH_Power),
        ('iE-Extensions', _BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions),
        ])
    BCCH_Specific_HSDSCH_RNTI_Information._ext = []
    
    #-----< BCCH-Specific-HSDSCH-RNTI-Information-ExtIEs >-----#
    BCCH_Specific_HSDSCH_RNTI_Information_ExtIEs = CLASS(name='BCCH-Specific-HSDSCH-RNTI-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BCCH_Specific_HSDSCH_RNTI_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCCH-Specific-HSDSCH-RNTI-InformationLCR >-----#
    BCCH_Specific_HSDSCH_RNTI_InformationLCR = SEQ(name='BCCH-Specific-HSDSCH-RNTI-InformationLCR', mode=MODE_TYPE)
    _BCCH_Specific_HSDSCH_RNTI_InformationLCR_bCCH_Specific_HSDSCH_RNTI = INT(name='bCCH-Specific-HSDSCH-RNTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _BCCH_Specific_HSDSCH_RNTI_InformationLCR_hSSCCH_Power = INT(name='hSSCCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _BCCH_Specific_HSDSCH_RNTI_InformationLCR_hSPDSCH_Power = INT(name='hSPDSCH-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__id._const_tab = ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__id_tab
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__criticality._const_tab = ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__criticality_tab
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item_._ext = None
    _BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions._cont = __BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item_
    _BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCCH_Specific_HSDSCH_RNTI_InformationLCR._cont = ASN1Dict([
        ('bCCH-Specific-HSDSCH-RNTI', _BCCH_Specific_HSDSCH_RNTI_InformationLCR_bCCH_Specific_HSDSCH_RNTI),
        ('hSSCCH-Power', _BCCH_Specific_HSDSCH_RNTI_InformationLCR_hSSCCH_Power),
        ('hSPDSCH-Power', _BCCH_Specific_HSDSCH_RNTI_InformationLCR_hSPDSCH_Power),
        ('iE-Extensions', _BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions),
        ])
    BCCH_Specific_HSDSCH_RNTI_InformationLCR._ext = []
    
    #-----< BCCH-Specific-HSDSCH-RNTI-InformationLCR-ExtIEs >-----#
    BCCH_Specific_HSDSCH_RNTI_InformationLCR_ExtIEs = CLASS(name='BCCH-Specific-HSDSCH-RNTI-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BCCH_Specific_HSDSCH_RNTI_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCCH-ModificationTime >-----#
    BCCH_ModificationTime = INT(name='BCCH-ModificationTime', mode=MODE_TYPE)
    BCCH_ModificationTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< BDS-IGPInfoList >-----#
    BDS_IGPInfoList = SEQ_OF(name='BDS-IGPInfoList', mode=MODE_TYPE)
    _BDS_IGPInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BDS-IGPInfo')))
    BDS_IGPInfoList._cont = _BDS_IGPInfoList__item_
    BDS_IGPInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=320)], ev=None, er=[])
    
    #-----< BDS-IGPInfo >-----#
    BDS_IGPInfo = SEQ(name='BDS-IGPInfo', mode=MODE_TYPE)
    _BDS_IGPInfo_bds_IGPNumber = INT(name='bds-IGPNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_IGPInfo_bds_IGPNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=320)], ev=None, er=[])
    _BDS_IGPInfo_bds_VerticalDelay = BIT_STR(name='bds-VerticalDelay', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_IGPInfo_bds_VerticalDelay._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _BDS_IGPInfo_bds_GIVEI = BIT_STR(name='bds-GIVEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_IGPInfo_bds_GIVEI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _BDS_IGPInfo_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BDS_IGPInfo_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BDS_IGPInfo_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BDS_IGPInfo_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BDS_IGPInfo_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_IGPInfo_ie_Extensions__item__id._const_tab = ____BDS_IGPInfo_ie_Extensions__item__id_tab
    ___BDS_IGPInfo_ie_Extensions__item__id._const_tab_at = None
    ___BDS_IGPInfo_ie_Extensions__item__id._const_tab_id = 'id'
    ___BDS_IGPInfo_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BDS_IGPInfo_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BDS_IGPInfo_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_IGPInfo_ie_Extensions__item__criticality._const_tab = ____BDS_IGPInfo_ie_Extensions__item__criticality_tab
    ___BDS_IGPInfo_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BDS_IGPInfo_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BDS_IGPInfo_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BDS_IGPInfo_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BDS_IGPInfo_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_IGPInfo_ie_Extensions__item__extensionValue._const_tab = ____BDS_IGPInfo_ie_Extensions__item__extensionValue_tab
    ___BDS_IGPInfo_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BDS_IGPInfo_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BDS_IGPInfo_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___BDS_IGPInfo_ie_Extensions__item__id),
        ('criticality', ___BDS_IGPInfo_ie_Extensions__item__criticality),
        ('extensionValue', ___BDS_IGPInfo_ie_Extensions__item__extensionValue),
        ])
    __BDS_IGPInfo_ie_Extensions__item_._ext = None
    _BDS_IGPInfo_ie_Extensions._cont = __BDS_IGPInfo_ie_Extensions__item_
    _BDS_IGPInfo_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BDS_IGPInfo._cont = ASN1Dict([
        ('bds-IGPNumber', _BDS_IGPInfo_bds_IGPNumber),
        ('bds-VerticalDelay', _BDS_IGPInfo_bds_VerticalDelay),
        ('bds-GIVEI', _BDS_IGPInfo_bds_GIVEI),
        ('ie-Extensions', _BDS_IGPInfo_ie_Extensions),
        ])
    BDS_IGPInfo._ext = []
    
    #-----< BDS-IGPInfo-ExtIEs >-----#
    BDS_IGPInfo_ExtIEs = CLASS(name='BDS-IGPInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BDS_IGPInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BDS-IonosphericGridModelReq >-----#
    BDS_IonosphericGridModelReq = ENUM(name='BDS-IonosphericGridModelReq', mode=MODE_TYPE)
    BDS_IonosphericGridModelReq._cont = ASN1Dict([('requested', 0)])
    BDS_IonosphericGridModelReq._ext = []
    
    #-----< BDS-Ionospheric-Grid-Model >-----#
    BDS_Ionospheric_Grid_Model = SEQ(name='BDS-Ionospheric-Grid-Model', mode=MODE_TYPE)
    _BDS_Ionospheric_Grid_Model_bDS_RefTime = INT(name='bDS-RefTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_Ionospheric_Grid_Model_bDS_RefTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=119)], ev=None, er=[])
    _BDS_Ionospheric_Grid_Model_bds_IGPInfoList = SEQ_OF(name='bds-IGPInfoList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BDS-IGPInfoList')))
    _BDS_Ionospheric_Grid_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BDS_Ionospheric_Grid_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id._const_tab = ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__id_tab
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id._const_tab_at = None
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality._const_tab = ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality_tab
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue._const_tab = ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue_tab
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BDS_Ionospheric_Grid_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id),
        ('criticality', ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue),
        ])
    __BDS_Ionospheric_Grid_Model_ie_Extensions__item_._ext = None
    _BDS_Ionospheric_Grid_Model_ie_Extensions._cont = __BDS_Ionospheric_Grid_Model_ie_Extensions__item_
    _BDS_Ionospheric_Grid_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BDS_Ionospheric_Grid_Model._cont = ASN1Dict([
        ('bDS-RefTime', _BDS_Ionospheric_Grid_Model_bDS_RefTime),
        ('bds-IGPInfoList', _BDS_Ionospheric_Grid_Model_bds_IGPInfoList),
        ('ie-Extensions', _BDS_Ionospheric_Grid_Model_ie_Extensions),
        ])
    BDS_Ionospheric_Grid_Model._ext = []
    
    #-----< BDS-Ionospheric-Grid-Model-ExtIEs >-----#
    BDS_Ionospheric_Grid_Model_ExtIEs = CLASS(name='BDS-Ionospheric-Grid-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BDS_Ionospheric_Grid_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Best-Cell-Portions-Value >-----#
    Best_Cell_Portions_Value = SEQ_OF(name='Best-Cell-Portions-Value', mode=MODE_TYPE)
    _Best_Cell_Portions_Value__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Best-Cell-Portions-Item')))
    Best_Cell_Portions_Value._cont = _Best_Cell_Portions_Value__item_
    Best_Cell_Portions_Value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Best-Cell-Portions-Item >-----#
    Best_Cell_Portions_Item = SEQ(name='Best-Cell-Portions-Item', mode=MODE_TYPE)
    _Best_Cell_Portions_Item_cellPortionID = INT(name='cellPortionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionID')))
    _Best_Cell_Portions_Item_sIRValue = INT(name='sIRValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SIR-Value')))
    _Best_Cell_Portions_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Best_Cell_Portions_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Best_Cell_Portions_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Best_Cell_Portions_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Best_Cell_Portions_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Best_Cell_Portions_Item_iE_Extensions__item__id._const_tab = ____Best_Cell_Portions_Item_iE_Extensions__item__id_tab
    ___Best_Cell_Portions_Item_iE_Extensions__item__id._const_tab_at = None
    ___Best_Cell_Portions_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Best_Cell_Portions_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Best_Cell_Portions_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Best_Cell_Portions_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Best_Cell_Portions_Item_iE_Extensions__item__criticality._const_tab = ____Best_Cell_Portions_Item_iE_Extensions__item__criticality_tab
    ___Best_Cell_Portions_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Best_Cell_Portions_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Best_Cell_Portions_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Best_Cell_Portions_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Best_Cell_Portions_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Best_Cell_Portions_Item_iE_Extensions__item__extensionValue._const_tab = ____Best_Cell_Portions_Item_iE_Extensions__item__extensionValue_tab
    ___Best_Cell_Portions_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Best_Cell_Portions_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Best_Cell_Portions_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Best_Cell_Portions_Item_iE_Extensions__item__id),
        ('criticality', ___Best_Cell_Portions_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Best_Cell_Portions_Item_iE_Extensions__item__extensionValue),
        ])
    __Best_Cell_Portions_Item_iE_Extensions__item_._ext = None
    _Best_Cell_Portions_Item_iE_Extensions._cont = __Best_Cell_Portions_Item_iE_Extensions__item_
    _Best_Cell_Portions_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Best_Cell_Portions_Item._cont = ASN1Dict([
        ('cellPortionID', _Best_Cell_Portions_Item_cellPortionID),
        ('sIRValue', _Best_Cell_Portions_Item_sIRValue),
        ('iE-Extensions', _Best_Cell_Portions_Item_iE_Extensions),
        ])
    Best_Cell_Portions_Item._ext = []
    
    #-----< Best-Cell-Portions-Item-ExtIEs >-----#
    Best_Cell_Portions_Item_ExtIEs = CLASS(name='Best-Cell-Portions-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Best_Cell_Portions_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Best-Cell-Portions-ValueLCR >-----#
    Best_Cell_Portions_ValueLCR = SEQ_OF(name='Best-Cell-Portions-ValueLCR', mode=MODE_TYPE)
    _Best_Cell_Portions_ValueLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Best-Cell-Portions-ItemLCR')))
    Best_Cell_Portions_ValueLCR._cont = _Best_Cell_Portions_ValueLCR__item_
    Best_Cell_Portions_ValueLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Best-Cell-Portions-ItemLCR >-----#
    Best_Cell_Portions_ItemLCR = SEQ(name='Best-Cell-Portions-ItemLCR', mode=MODE_TYPE)
    _Best_Cell_Portions_ItemLCR_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _Best_Cell_Portions_ItemLCR_rSCPValue = INT(name='rSCPValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RSCP-Value')))
    _Best_Cell_Portions_ItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Best_Cell_Portions_ItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__id._const_tab = ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__id_tab
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__criticality._const_tab = ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__criticality_tab
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__extensionValue._const_tab = ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__extensionValue_tab
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Best_Cell_Portions_ItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__id),
        ('criticality', ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__extensionValue),
        ])
    __Best_Cell_Portions_ItemLCR_iE_Extensions__item_._ext = None
    _Best_Cell_Portions_ItemLCR_iE_Extensions._cont = __Best_Cell_Portions_ItemLCR_iE_Extensions__item_
    _Best_Cell_Portions_ItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Best_Cell_Portions_ItemLCR._cont = ASN1Dict([
        ('cellPortionLCRID', _Best_Cell_Portions_ItemLCR_cellPortionLCRID),
        ('rSCPValue', _Best_Cell_Portions_ItemLCR_rSCPValue),
        ('iE-Extensions', _Best_Cell_Portions_ItemLCR_iE_Extensions),
        ])
    Best_Cell_Portions_ItemLCR._ext = []
    
    #-----< Best-Cell-Portions-ItemLCR-ExtIEs >-----#
    Best_Cell_Portions_ItemLCR_ExtIEs = CLASS(name='Best-Cell-Portions-ItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Best_Cell_Portions_ItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BindingID >-----#
    BindingID = OCT_STR(name='BindingID', mode=MODE_TYPE)
    BindingID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[])
    
    #-----< BetaCD >-----#
    BetaCD = INT(name='BetaCD', mode=MODE_TYPE)
    BetaCD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< BlockingPriorityIndicator >-----#
    BlockingPriorityIndicator = ENUM(name='BlockingPriorityIndicator', mode=MODE_TYPE)
    BlockingPriorityIndicator._cont = ASN1Dict([('high', 0), ('normal', 1), ('low', 2)])
    BlockingPriorityIndicator._ext = []
    
    #-----< SCTD-Indicator >-----#
    SCTD_Indicator = ENUM(name='SCTD-Indicator', mode=MODE_TYPE)
    SCTD_Indicator._cont = ASN1Dict([('active', 0), ('inactive', 1)])
    SCTD_Indicator._ext = None
    
    #-----< BundlingModeIndicator >-----#
    BundlingModeIndicator = ENUM(name='BundlingModeIndicator', mode=MODE_TYPE)
    BundlingModeIndicator._cont = ASN1Dict([('bundling', 0), ('no-bundling', 1)])
    BundlingModeIndicator._ext = None
    
    #-----< BroadcastCommonTransportBearerIndication >-----#
    BroadcastCommonTransportBearerIndication = SEQ(name='BroadcastCommonTransportBearerIndication', mode=MODE_TYPE)
    _BroadcastCommonTransportBearerIndication_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _BroadcastCommonTransportBearerIndication_cid = INT(name='cid', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _BroadcastCommonTransportBearerIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastCommonTransportBearerIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__id._const_tab = ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__id_tab
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__criticality._const_tab = ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__criticality_tab
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__extensionValue._const_tab = ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__extensionValue_tab
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastCommonTransportBearerIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__id),
        ('criticality', ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__extensionValue),
        ])
    __BroadcastCommonTransportBearerIndication_iE_Extensions__item_._ext = None
    _BroadcastCommonTransportBearerIndication_iE_Extensions._cont = __BroadcastCommonTransportBearerIndication_iE_Extensions__item_
    _BroadcastCommonTransportBearerIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastCommonTransportBearerIndication._cont = ASN1Dict([
        ('commonTransportChannelID', _BroadcastCommonTransportBearerIndication_commonTransportChannelID),
        ('cid', _BroadcastCommonTransportBearerIndication_cid),
        ('iE-Extensions', _BroadcastCommonTransportBearerIndication_iE_Extensions),
        ])
    BroadcastCommonTransportBearerIndication._ext = []
    
    #-----< BroadcastCommonTransportBearerIndication-ExtIEs >-----#
    BroadcastCommonTransportBearerIndication_ExtIEs = CLASS(name='BroadcastCommonTransportBearerIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BroadcastCommonTransportBearerIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastReference >-----#
    BroadcastReference = BIT_STR(name='BroadcastReference', mode=MODE_TYPE)
    BroadcastReference._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name='transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('transport', _Cause_transport),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('control-processing-overload', 0), ('hardware-failure', 1), ('oam-intervention', 2), ('not-enough-user-plane-processing-resources', 3), ('unspecified', 4)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('unspecified', 5), ('abstract-syntax-error-falsely-constructed-message', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('unknown-C-ID', 0), ('cell-not-available', 1), ('power-level-not-supported', 2), ('dl-radio-resources-not-available', 3), ('ul-radio-resources-not-available', 4), ('rl-already-ActivatedOrAllocated', 5), ('nodeB-Resources-unavailable', 6), ('measurement-not-supported-for-the-object', 7), ('combining-resources-not-available', 8), ('requested-configuration-not-supported', 9), ('synchronisation-failure', 10), ('priority-transport-channel-established', 11), ('sIB-Origination-in-Node-B-not-Supported', 12), ('requested-tx-diversity-mode-not-supported', 13), ('unspecified', 14), ('bCCH-scheduling-error', 15), ('measurement-temporarily-not-available', 16), ('invalid-CM-settings', 17), ('reconfiguration-CFN-not-elapsed', 18), ('number-of-DL-codes-not-supported', 19), ('s-cpich-not-supported', 20), ('combining-not-supported', 21), ('ul-sf-not-supported', 22), ('dl-SF-not-supported', 23), ('common-transport-channel-type-not-supported', 24), ('dedicated-transport-channel-type-not-supported', 25), ('downlink-shared-channel-type-not-supported', 26), ('uplink-shared-channel-type-not-supported', 27), ('cm-not-supported', 28), ('tx-diversity-no-longer-supported', 29), ('unknown-Local-Cell-ID', 30), ('number-of-UL-codes-not-supported', 31), ('information-temporarily-not-available', 32), ('information-provision-not-supported-for-the-object', 33), ('cell-synchronisation-not-supported', 34), ('cell-synchronisation-adjustment-not-supported', 35), ('dpc-mode-change-not-supported', 36), ('iPDL-already-activated', 37), ('iPDL-not-supported', 38), ('iPDL-parameters-not-available', 39), ('frequency-acquisition-not-supported', 40), ('power-balancing-status-not-compatible', 41), ('requested-typeofbearer-re-arrangement-not-supported', 42), ('signalling-Bearer-Re-arrangement-not-supported', 43), ('bearer-Re-arrangement-needed', 44), ('delayed-activation-not-supported', 45), ('rl-timing-adjustment-not-supported', 46), ('mich-not-supported', 47), ('f-DPCH-not-supported', 48), ('modification-period-not-available', 49), ('pLCCH-not-supported', 50), ('continuous-packet-connectivity-DTX-DRX-operation-not-available', 51), ('continuous-packet-connectivity-UE-DTX-Cycle-not-available', 52), ('mIMO-not-available', 53), ('e-DCH-MACdPDU-SizeFormat-not-available', 54), ('multi-Cell-operation-not-available', 55), ('semi-Persistent-scheduling-not-supported', 56), ('continuous-Packet-Connectivity-DRX-not-supported', 57), ('continuous-Packet-Connectivity-DRX-not-available', 58), ('sixtyfourQAM-DL-and-MIMO-Combined-not-available', 59), ('s-cpich-power-offset-not-available', 60), ('tx-diversity-for-mimo-on-DL-control-channels-not-available', 61), ('single-Stream-MIMO-not-available', 62), ('multi-Cell-operation-with-MIMO-not-available', 63), ('multi-Cell-operation-with-Single-Stream-MIMO-not-available', 64), ('cellSpecificTxDiversityHandlingForMultiCellOperationNotAvailable', 65), ('multi-Cell-EDCH-operation-not-available', 66), ('frequency-Specific-Compressed-Mode-operation-not-available', 67), ('uL-CLTD-Operation-not-available', 68), ('mimo-withfourtransmitantennas-not-available', 69), ('dualstream-mimo-withfourtransmitantennas-not-available', 70), ('multiflow-operation-not-available', 71), ('ul-SixtyfourQAM-Operation-not-available', 72), ('ul-MIMO-Operation-not-available', 73), ('ul-MIMO-SixteenQAM-Operation-not-available', 74), ('ul-MIMO-SixtyfourQAM-Operation-not-available', 75), ('nodeB-Triggered-HS-DPCCH-Transmission-operation-not-available', 76), ('two-msand10ms-TTI-Concurrent-Deployment-operation-not-available', 77), ('further-Enhanced-UE-DRX-operation-not-available', 78), ('per-HARQ-Activation-and-Deactivation-operation-not-available', 79), ('tTI-alignment-operation-not-available', 80), ('common-E-RGCH-operation-not-available', 81), ('e-DCH-decoupling-operation-not-available', 82), ('basic-dch-enh-not-available', 83), ('full-dch-enh-not-available', 84), ('bCH-mappedOnSCCPCH-scheduling-error', 85), ('radio-Links-without-DPCH-FDPCH-Indication-operation-not-available', 86), ('uL-DPCCH2-operation-not-available', 87), ('downlink-TPC-enhancements-operation-not-available', 88), ('dual-Cell-EDCH-enhancements-with-10ms-and-10ms-TTI-operation-not-available', 89), ('dual-Cell-EDCH-enhancements-with-different-TTI-operation-not-available', 90)])
    CauseRadioNetwork._ext = ['number-of-UL-codes-not-supported', 'information-temporarily-not-available', 'information-provision-not-supported-for-the-object', 'cell-synchronisation-not-supported', 'cell-synchronisation-adjustment-not-supported', 'dpc-mode-change-not-supported', 'iPDL-already-activated', 'iPDL-not-supported', 'iPDL-parameters-not-available', 'frequency-acquisition-not-supported', 'power-balancing-status-not-compatible', 'requested-typeofbearer-re-arrangement-not-supported', 'signalling-Bearer-Re-arrangement-not-supported', 'bearer-Re-arrangement-needed', 'delayed-activation-not-supported', 'rl-timing-adjustment-not-supported', 'mich-not-supported', 'f-DPCH-not-supported', 'modification-period-not-available', 'pLCCH-not-supported', 'continuous-packet-connectivity-DTX-DRX-operation-not-available', 'continuous-packet-connectivity-UE-DTX-Cycle-not-available', 'mIMO-not-available', 'e-DCH-MACdPDU-SizeFormat-not-available', 'multi-Cell-operation-not-available', 'semi-Persistent-scheduling-not-supported', 'continuous-Packet-Connectivity-DRX-not-supported', 'continuous-Packet-Connectivity-DRX-not-available', 'sixtyfourQAM-DL-and-MIMO-Combined-not-available', 's-cpich-power-offset-not-available', 'tx-diversity-for-mimo-on-DL-control-channels-not-available', 'single-Stream-MIMO-not-available', 'multi-Cell-operation-with-MIMO-not-available', 'multi-Cell-operation-with-Single-Stream-MIMO-not-available', 'cellSpecificTxDiversityHandlingForMultiCellOperationNotAvailable', 'multi-Cell-EDCH-operation-not-available', 'frequency-Specific-Compressed-Mode-operation-not-available', 'uL-CLTD-Operation-not-available', 'mimo-withfourtransmitantennas-not-available', 'dualstream-mimo-withfourtransmitantennas-not-available', 'multiflow-operation-not-available', 'ul-SixtyfourQAM-Operation-not-available', 'ul-MIMO-Operation-not-available', 'ul-MIMO-SixteenQAM-Operation-not-available', 'ul-MIMO-SixtyfourQAM-Operation-not-available', 'nodeB-Triggered-HS-DPCCH-Transmission-operation-not-available', 'two-msand10ms-TTI-Concurrent-Deployment-operation-not-available', 'further-Enhanced-UE-DRX-operation-not-available', 'per-HARQ-Activation-and-Deactivation-operation-not-available', 'tTI-alignment-operation-not-available', 'common-E-RGCH-operation-not-available', 'e-DCH-decoupling-operation-not-available', 'basic-dch-enh-not-available', 'full-dch-enh-not-available', 'bCH-mappedOnSCCPCH-scheduling-error', 'radio-Links-without-DPCH-FDPCH-Indication-operation-not-available', 'uL-DPCCH2-operation-not-available', 'downlink-TPC-enhancements-operation-not-available', 'dual-Cell-EDCH-enhancements-with-10ms-and-10ms-TTI-operation-not-available', 'dual-Cell-EDCH-enhancements-with-different-TTI-operation-not-available']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name='CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([('transport-resource-unavailable', 0), ('unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< CCTrCH-ID >-----#
    CCTrCH_ID = INT(name='CCTrCH-ID', mode=MODE_TYPE)
    CCTrCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< Cell-Capability-Container >-----#
    Cell_Capability_Container = BIT_STR(name='Cell-Capability-Container', mode=MODE_TYPE)
    Cell_Capability_Container._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    
    #-----< Cell-ERNTI-Status-Information >-----#
    Cell_ERNTI_Status_Information = SEQ_OF(name='Cell-ERNTI-Status-Information', mode=MODE_TYPE)
    _Cell_ERNTI_Status_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-ERNTI-Status-Information-Item')))
    Cell_ERNTI_Status_Information._cont = _Cell_ERNTI_Status_Information__item_
    Cell_ERNTI_Status_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Cell-ERNTI-Status-Information-Item >-----#
    Cell_ERNTI_Status_Information_Item = SEQ(name='Cell-ERNTI-Status-Information-Item', mode=MODE_TYPE)
    _Cell_ERNTI_Status_Information_Item_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _Cell_ERNTI_Status_Information_Item_vacant_ERNTI = SEQ_OF(name='vacant-ERNTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Vacant-ERNTI')))
    Cell_ERNTI_Status_Information_Item._cont = ASN1Dict([
        ('c-ID', _Cell_ERNTI_Status_Information_Item_c_ID),
        ('vacant-ERNTI', _Cell_ERNTI_Status_Information_Item_vacant_ERNTI),
        ])
    Cell_ERNTI_Status_Information_Item._ext = []
    
    #-----< Vacant-ERNTI >-----#
    Vacant_ERNTI = SEQ_OF(name='Vacant-ERNTI', mode=MODE_TYPE)
    _Vacant_ERNTI__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    Vacant_ERNTI._cont = _Vacant_ERNTI__item_
    Vacant_ERNTI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellParameterID >-----#
    CellParameterID = INT(name='CellParameterID', mode=MODE_TYPE)
    CellParameterID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< CellPortionID >-----#
    CellPortionID = INT(name='CellPortionID', mode=MODE_TYPE)
    CellPortionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=[], er=[])
    
    #-----< CellPortionLCRID >-----#
    CellPortionLCRID = INT(name='CellPortionLCRID', mode=MODE_TYPE)
    CellPortionLCRID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< CellPortion-CapabilityLCR >-----#
    CellPortion_CapabilityLCR = ENUM(name='CellPortion-CapabilityLCR', mode=MODE_TYPE)
    CellPortion_CapabilityLCR._cont = ASN1Dict([('cell-portion-capable', 0), ('cell-portion-non-capable', 1)])
    CellPortion_CapabilityLCR._ext = None
    
    #-----< CellSyncBurstCode >-----#
    CellSyncBurstCode = INT(name='CellSyncBurstCode', mode=MODE_TYPE)
    CellSyncBurstCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< CellSyncBurstCodeShift >-----#
    CellSyncBurstCodeShift = INT(name='CellSyncBurstCodeShift', mode=MODE_TYPE)
    CellSyncBurstCodeShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< CellSyncBurstRepetitionPeriod >-----#
    CellSyncBurstRepetitionPeriod = INT(name='CellSyncBurstRepetitionPeriod', mode=MODE_TYPE)
    CellSyncBurstRepetitionPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< CellSyncBurstSIR >-----#
    CellSyncBurstSIR = INT(name='CellSyncBurstSIR', mode=MODE_TYPE)
    CellSyncBurstSIR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< CellSyncBurstTiming >-----#
    CellSyncBurstTiming = CHOICE(name='CellSyncBurstTiming', mode=MODE_TYPE)
    _CellSyncBurstTiming_initialPhase = INT(name='initialPhase', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CellSyncBurstTiming_initialPhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=[], er=[])
    _CellSyncBurstTiming_steadyStatePhase = INT(name='steadyStatePhase', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CellSyncBurstTiming_steadyStatePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    CellSyncBurstTiming._cont = ASN1Dict([
        ('initialPhase', _CellSyncBurstTiming_initialPhase),
        ('steadyStatePhase', _CellSyncBurstTiming_steadyStatePhase),
        ])
    CellSyncBurstTiming._ext = None
    
    #-----< CellSyncBurstTimingLCR >-----#
    CellSyncBurstTimingLCR = CHOICE(name='CellSyncBurstTimingLCR', mode=MODE_TYPE)
    _CellSyncBurstTimingLCR_initialPhase = INT(name='initialPhase', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CellSyncBurstTimingLCR_initialPhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=524287)], ev=[], er=[])
    _CellSyncBurstTimingLCR_steadyStatePhase = INT(name='steadyStatePhase', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CellSyncBurstTimingLCR_steadyStatePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    CellSyncBurstTimingLCR._cont = ASN1Dict([
        ('initialPhase', _CellSyncBurstTimingLCR_initialPhase),
        ('steadyStatePhase', _CellSyncBurstTimingLCR_steadyStatePhase),
        ])
    CellSyncBurstTimingLCR._ext = None
    
    #-----< CellSyncBurstTimingThreshold >-----#
    CellSyncBurstTimingThreshold = INT(name='CellSyncBurstTimingThreshold', mode=MODE_TYPE)
    CellSyncBurstTimingThreshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=254)], ev=None, er=[])
    
    #-----< CFN >-----#
    CFN = INT(name='CFN', mode=MODE_TYPE)
    CFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ChipOffset >-----#
    ChipOffset = INT(name='ChipOffset', mode=MODE_TYPE)
    ChipOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=38399)], ev=None, er=[])
    
    #-----< C-ID >-----#
    C_ID = INT(name='C-ID', mode=MODE_TYPE)
    C_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< Closedlooptimingadjustmentmode >-----#
    Closedlooptimingadjustmentmode = ENUM(name='Closedlooptimingadjustmentmode', mode=MODE_TYPE)
    Closedlooptimingadjustmentmode._cont = ASN1Dict([('adj-1-slot', 0), ('adj-2-slot', 1)])
    Closedlooptimingadjustmentmode._ext = []
    
    #-----< CodeRate >-----#
    CodeRate = INT(name='CodeRate', mode=MODE_TYPE)
    CodeRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< CodeRate-short >-----#
    CodeRate_short = INT(name='CodeRate-short', mode=MODE_TYPE)
    CodeRate_short._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< CommonChannelsCapacityConsumptionLaw >-----#
    CommonChannelsCapacityConsumptionLaw = SEQ_OF(name='CommonChannelsCapacityConsumptionLaw', mode=MODE_TYPE)
    _CommonChannelsCapacityConsumptionLaw__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CommonChannelsCapacityConsumptionLaw__item__dl_Cost = INT(name='dl-Cost', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CommonChannelsCapacityConsumptionLaw__item__dl_Cost._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __CommonChannelsCapacityConsumptionLaw__item__ul_Cost = INT(name='ul-Cost', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CommonChannelsCapacityConsumptionLaw__item__ul_Cost._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __CommonChannelsCapacityConsumptionLaw__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id._const_tab = _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id_tab
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id._const_tab_at = None
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality._const_tab = _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality_tab
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue._const_tab = _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue_tab
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id),
        ('criticality', ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue),
        ])
    ___CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item_._ext = None
    __CommonChannelsCapacityConsumptionLaw__item__iE_Extensions._cont = ___CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item_
    __CommonChannelsCapacityConsumptionLaw__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CommonChannelsCapacityConsumptionLaw__item_._cont = ASN1Dict([
        ('dl-Cost', __CommonChannelsCapacityConsumptionLaw__item__dl_Cost),
        ('ul-Cost', __CommonChannelsCapacityConsumptionLaw__item__ul_Cost),
        ('iE-Extensions', __CommonChannelsCapacityConsumptionLaw__item__iE_Extensions),
        ])
    _CommonChannelsCapacityConsumptionLaw__item_._ext = []
    CommonChannelsCapacityConsumptionLaw._cont = _CommonChannelsCapacityConsumptionLaw__item_
    CommonChannelsCapacityConsumptionLaw._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CommonChannelsCapacityConsumptionLaw-ExtIEs >-----#
    CommonChannelsCapacityConsumptionLaw_ExtIEs = CLASS(name='CommonChannelsCapacityConsumptionLaw-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonChannelsCapacityConsumptionLaw_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-EDCH-Capability >-----#
    Common_EDCH_Capability = ENUM(name='Common-EDCH-Capability', mode=MODE_TYPE)
    Common_EDCH_Capability._cont = ASN1Dict([('common-EDCH-capable', 0), ('common-EDCH-non-capable', 1)])
    Common_EDCH_Capability._ext = None
    
    #-----< Common-E-DCH-HSDPCCH-Capability >-----#
    Common_E_DCH_HSDPCCH_Capability = ENUM(name='Common-E-DCH-HSDPCCH-Capability', mode=MODE_TYPE)
    Common_E_DCH_HSDPCCH_Capability._cont = ASN1Dict([('hSDPCCH-non-capable', 0), ('aCK-NACK-capable', 1), ('aCK-NACK-CQI-capable', 2)])
    Common_E_DCH_HSDPCCH_Capability._ext = None
    
    #-----< Common-EDCH-System-InformationFDD >-----#
    Common_EDCH_System_InformationFDD = SEQ(name='Common-EDCH-System-InformationFDD', mode=MODE_TYPE)
    _Common_EDCH_System_InformationFDD_common_E_DCH_UL_DPCH_Information = SEQ(name='common-E-DCH-UL-DPCH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-UL-DPCH-InfoItem')), opt=True)
    _Common_EDCH_System_InformationFDD_common_E_DCH_EDPCH_Information = SEQ(name='common-E-DCH-EDPCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-EDPCH-InfoItem')), opt=True)
    _Common_EDCH_System_InformationFDD_common_E_DCH_Information = SEQ(name='common-E-DCH-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-InfoItem')), opt=True)
    _Common_EDCH_System_InformationFDD_common_E_DCH_HSDPCCH_Information = SEQ(name='common-E-DCH-HSDPCCH-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-HSDPCCH-InfoItem')), opt=True)
    _Common_EDCH_System_InformationFDD_common_E_DCH_Preamble_Control_Information = SEQ(name='common-E-DCH-Preamble-Control-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Preamble-Control-InfoItem')), opt=True)
    _Common_EDCH_System_InformationFDD_common_E_DCH_FDPCH_Information = SEQ(name='common-E-DCH-FDPCH-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-FDPCH-InfoItem')), opt=True)
    _Common_EDCH_System_InformationFDD_common_E_DCH_E_AGCH_ChannelisationCodeNumber = INT(name='common-E-DCH-E-AGCH-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')), opt=True)
    _Common_EDCH_System_InformationFDD_common_E_DCH_Resource_Combination_Information = SEQ_OF(name='common-E-DCH-Resource-Combination-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Resource-Combination-InfoList')), opt=True)
    _Common_EDCH_System_InformationFDD_ul_common_E_DCH_MACflow_Specific_Information = SEQ_OF(name='ul-common-E-DCH-MACflow-Specific-Information', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoList')), opt=True)
    _Common_EDCH_System_InformationFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_EDCH_System_InformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE)
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-PowerOffset')))
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-PowerOffset')))
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-PowerOffset')))
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Concurrent-Deployment-of-2msand10ms-TTI')))
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Preamble-Control-Information-extensionList')))
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Preamble-Control-Information-extensionList')))
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Preamble-Control-Information-extensionList')))
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-Triggered-HSDPCCH-Transmission-Information')))
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Per-HARQ-Activiation-and-Deactiviation')))
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_10 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Coffset')))
    _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI-Set')))
    ____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1143), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1218), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1219), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1220), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1240), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1241), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1242), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1243), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1244), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1245), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1246), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 1310), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__id._const_tab = ____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__criticality._const_tab = ____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__extensionValue._const_tab = ____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_EDCH_System_InformationFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_EDCH_System_InformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_EDCH_System_InformationFDD_iE_Extensions__item__id),
        ('criticality', ___Common_EDCH_System_InformationFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_EDCH_System_InformationFDD_iE_Extensions__item__extensionValue),
        ])
    __Common_EDCH_System_InformationFDD_iE_Extensions__item_._ext = None
    _Common_EDCH_System_InformationFDD_iE_Extensions._cont = __Common_EDCH_System_InformationFDD_iE_Extensions__item_
    _Common_EDCH_System_InformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_EDCH_System_InformationFDD._cont = ASN1Dict([
        ('common-E-DCH-UL-DPCH-Information', _Common_EDCH_System_InformationFDD_common_E_DCH_UL_DPCH_Information),
        ('common-E-DCH-EDPCH-Information', _Common_EDCH_System_InformationFDD_common_E_DCH_EDPCH_Information),
        ('common-E-DCH-Information', _Common_EDCH_System_InformationFDD_common_E_DCH_Information),
        ('common-E-DCH-HSDPCCH-Information', _Common_EDCH_System_InformationFDD_common_E_DCH_HSDPCCH_Information),
        ('common-E-DCH-Preamble-Control-Information', _Common_EDCH_System_InformationFDD_common_E_DCH_Preamble_Control_Information),
        ('common-E-DCH-FDPCH-Information', _Common_EDCH_System_InformationFDD_common_E_DCH_FDPCH_Information),
        ('common-E-DCH-E-AGCH-ChannelisationCodeNumber', _Common_EDCH_System_InformationFDD_common_E_DCH_E_AGCH_ChannelisationCodeNumber),
        ('common-E-DCH-Resource-Combination-Information', _Common_EDCH_System_InformationFDD_common_E_DCH_Resource_Combination_Information),
        ('ul-common-E-DCH-MACflow-Specific-Information', _Common_EDCH_System_InformationFDD_ul_common_E_DCH_MACflow_Specific_Information),
        ('iE-Extensions', _Common_EDCH_System_InformationFDD_iE_Extensions),
        ])
    Common_EDCH_System_InformationFDD._ext = []
    
    #-----< Common-EDCH-System-InformationFDD-ExtIEs >-----#
    Common_EDCH_System_InformationFDD_ExtIEs = CLASS(name='Common-EDCH-System-InformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE)
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-PowerOffset')))
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-PowerOffset')))
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-PowerOffset')))
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Concurrent-Deployment-of-2msand10ms-TTI')))
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Preamble-Control-Information-extensionList')))
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Preamble-Control-Information-extensionList')))
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Preamble-Control-Information-extensionList')))
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-Triggered-HSDPCCH-Transmission-Information')))
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Per-HARQ-Activiation-and-Deactiviation')))
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_10 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Coffset')))
    _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI-Set')))
    Common_EDCH_System_InformationFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 1143), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1218), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1219), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1220), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1240), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1241), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 1242), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 1243), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 1244), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 1245), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 1246), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 1310), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_11), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RNTI-Set >-----#
    E_RNTI_Set = SEQ(name='E-RNTI-Set', mode=MODE_TYPE)
    _E_RNTI_Set_starting_e_rnti = INT(name='starting-e-rnti', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _E_RNTI_Set_ending_e_rnti = INT(name='ending-e-rnti', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _E_RNTI_Set_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RNTI_Set_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_RNTI_Set_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RNTI_Set_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_RNTI_Set_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RNTI_Set_iE_Extensions__item__id._const_tab = ____E_RNTI_Set_iE_Extensions__item__id_tab
    ___E_RNTI_Set_iE_Extensions__item__id._const_tab_at = None
    ___E_RNTI_Set_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RNTI_Set_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RNTI_Set_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_RNTI_Set_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RNTI_Set_iE_Extensions__item__criticality._const_tab = ____E_RNTI_Set_iE_Extensions__item__criticality_tab
    ___E_RNTI_Set_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RNTI_Set_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RNTI_Set_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RNTI_Set_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_RNTI_Set_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RNTI_Set_iE_Extensions__item__extensionValue._const_tab = ____E_RNTI_Set_iE_Extensions__item__extensionValue_tab
    ___E_RNTI_Set_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RNTI_Set_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RNTI_Set_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RNTI_Set_iE_Extensions__item__id),
        ('criticality', ___E_RNTI_Set_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RNTI_Set_iE_Extensions__item__extensionValue),
        ])
    __E_RNTI_Set_iE_Extensions__item_._ext = None
    _E_RNTI_Set_iE_Extensions._cont = __E_RNTI_Set_iE_Extensions__item_
    _E_RNTI_Set_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RNTI_Set._cont = ASN1Dict([
        ('starting-e-rnti', _E_RNTI_Set_starting_e_rnti),
        ('ending-e-rnti', _E_RNTI_Set_ending_e_rnti),
        ('iE-Extensions', _E_RNTI_Set_iE_Extensions),
        ])
    E_RNTI_Set._ext = []
    
    #-----< E-RNTI-Set-ExtIEs >-----#
    E_RNTI_Set_ExtIEs = CLASS(name='E-RNTI-Set-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_RNTI_Set_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-UL-DPCH-InfoItem >-----#
    Common_E_DCH_UL_DPCH_InfoItem = SEQ(name='Common-E-DCH-UL-DPCH-InfoItem', mode=MODE_TYPE)
    _Common_E_DCH_UL_DPCH_InfoItem_uL_SIR_Target = INT(name='uL-SIR-Target', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _Common_E_DCH_UL_DPCH_InfoItem_dPC_Mode = ENUM(name='dPC-Mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPC-Mode')), opt=True)
    _Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__id._const_tab = ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__id_tab
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item_._ext = None
    _Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions._cont = __Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item_
    _Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_UL_DPCH_InfoItem._cont = ASN1Dict([
        ('uL-SIR-Target', _Common_E_DCH_UL_DPCH_InfoItem_uL_SIR_Target),
        ('dPC-Mode', _Common_E_DCH_UL_DPCH_InfoItem_dPC_Mode),
        ('iE-Extensions', _Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions),
        ])
    Common_E_DCH_UL_DPCH_InfoItem._ext = []
    
    #-----< Common-E-DCH-UL-DPCH-InfoItem-ExtIEs >-----#
    Common_E_DCH_UL_DPCH_InfoItem_ExtIEs = CLASS(name='Common-E-DCH-UL-DPCH-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_UL_DPCH_InfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-EDPCH-InfoItem >-----#
    Common_E_DCH_EDPCH_InfoItem = SEQ(name='Common-E-DCH-EDPCH-InfoItem', mode=MODE_TYPE)
    _Common_E_DCH_EDPCH_InfoItem_maxSet_E_DPDCHs = ENUM(name='maxSet-E-DPDCHs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-Set-E-DPDCHs')))
    _Common_E_DCH_EDPCH_InfoItem_ul_PunctureLimit = INT(name='ul-PunctureLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')))
    _Common_E_DCH_EDPCH_InfoItem_e_TFCS_Information = SEQ(name='e-TFCS-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information')))
    _Common_E_DCH_EDPCH_InfoItem_e_TTI = ENUM(name='e-TTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TTI')))
    _Common_E_DCH_EDPCH_InfoItem_e_DPCCH_PO = INT(name='e-DPCCH-PO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-PO')))
    _Common_E_DCH_EDPCH_InfoItem_e_RGCH_2_IndexStepThreshold = INT(name='e-RGCH-2-IndexStepThreshold', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-2-IndexStepThreshold')), opt=True)
    _Common_E_DCH_EDPCH_InfoItem_e_RGCH_3_IndexStepThreshold = INT(name='e-RGCH-3-IndexStepThreshold', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-3-IndexStepThreshold')), opt=True)
    _Common_E_DCH_EDPCH_InfoItem_hARQ_Info_for_E_DCH = ENUM(name='hARQ-Info-for-E-DCH', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Info-for-E-DCH')))
    _Common_E_DCH_EDPCH_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__id._const_tab = ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__id_tab
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item_._ext = None
    _Common_E_DCH_EDPCH_InfoItem_iE_Extensions._cont = __Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item_
    _Common_E_DCH_EDPCH_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_EDPCH_InfoItem._cont = ASN1Dict([
        ('maxSet-E-DPDCHs', _Common_E_DCH_EDPCH_InfoItem_maxSet_E_DPDCHs),
        ('ul-PunctureLimit', _Common_E_DCH_EDPCH_InfoItem_ul_PunctureLimit),
        ('e-TFCS-Information', _Common_E_DCH_EDPCH_InfoItem_e_TFCS_Information),
        ('e-TTI', _Common_E_DCH_EDPCH_InfoItem_e_TTI),
        ('e-DPCCH-PO', _Common_E_DCH_EDPCH_InfoItem_e_DPCCH_PO),
        ('e-RGCH-2-IndexStepThreshold', _Common_E_DCH_EDPCH_InfoItem_e_RGCH_2_IndexStepThreshold),
        ('e-RGCH-3-IndexStepThreshold', _Common_E_DCH_EDPCH_InfoItem_e_RGCH_3_IndexStepThreshold),
        ('hARQ-Info-for-E-DCH', _Common_E_DCH_EDPCH_InfoItem_hARQ_Info_for_E_DCH),
        ('iE-Extensions', _Common_E_DCH_EDPCH_InfoItem_iE_Extensions),
        ])
    Common_E_DCH_EDPCH_InfoItem._ext = []
    
    #-----< Common-E-DCH-EDPCH-InfoItem-ExtIEs >-----#
    Common_E_DCH_EDPCH_InfoItem_ExtIEs = CLASS(name='Common-E-DCH-EDPCH-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_EDPCH_InfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-InfoItem >-----#
    Common_E_DCH_InfoItem = SEQ(name='Common-E-DCH-InfoItem', mode=MODE_TYPE)
    _Common_E_DCH_InfoItem_e_DCH_Reference_Power_Offset = INT(name='e-DCH-Reference-Power-Offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Reference-Power-Offset')), opt=True)
    _Common_E_DCH_InfoItem_e_DCH_PowerOffset_for_SchedulingInfo = INT(name='e-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')), opt=True)
    _Common_E_DCH_InfoItem_max_EDCH_Resource_Allocation_for_CCCH = ENUM(name='max-EDCH-Resource-Allocation-for-CCCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-EDCH-Resource-Allocation-for-CCCH')))
    _Common_E_DCH_InfoItem_max_Period_for_Collision_Resolution = INT(name='max-Period-for-Collision-Resolution', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-Period-for-Collision-Resolution')))
    _Common_E_DCH_InfoItem_max_TB_Sizes = SEQ(name='max-TB-Sizes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-TB-Sizes')), opt=True)
    _Common_E_DCH_InfoItem_common_E_DCH_ImplicitRelease_Indicator = BOOL(name='common-E-DCH-ImplicitRelease-Indicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Common_E_DCH_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonEDCH-AdditionalTransmissionBackOff')))
    _____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Implicit-Release-Timer')))
    ____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1200), ('criticality', 'ignore'), ('Extension', _____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1236), ('criticality', 'ignore'), ('Extension', _____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Common_E_DCH_InfoItem_iE_Extensions__item__id._const_tab = ____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab
    ___Common_E_DCH_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Common_E_DCH_InfoItem_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab
    ___Common_E_DCH_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Common_E_DCH_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab
    ___Common_E_DCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_InfoItem_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_InfoItem_iE_Extensions__item_._ext = None
    _Common_E_DCH_InfoItem_iE_Extensions._cont = __Common_E_DCH_InfoItem_iE_Extensions__item_
    _Common_E_DCH_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_InfoItem._cont = ASN1Dict([
        ('e-DCH-Reference-Power-Offset', _Common_E_DCH_InfoItem_e_DCH_Reference_Power_Offset),
        ('e-DCH-PowerOffset-for-SchedulingInfo', _Common_E_DCH_InfoItem_e_DCH_PowerOffset_for_SchedulingInfo),
        ('max-EDCH-Resource-Allocation-for-CCCH', _Common_E_DCH_InfoItem_max_EDCH_Resource_Allocation_for_CCCH),
        ('max-Period-for-Collision-Resolution', _Common_E_DCH_InfoItem_max_Period_for_Collision_Resolution),
        ('max-TB-Sizes', _Common_E_DCH_InfoItem_max_TB_Sizes),
        ('common-E-DCH-ImplicitRelease-Indicator', _Common_E_DCH_InfoItem_common_E_DCH_ImplicitRelease_Indicator),
        ('iE-Extensions', _Common_E_DCH_InfoItem_iE_Extensions),
        ])
    Common_E_DCH_InfoItem._ext = []
    
    #-----< Common-E-DCH-InfoItem-ExtIEs >-----#
    Common_E_DCH_InfoItem_ExtIEs = CLASS(name='Common-E-DCH-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Common_E_DCH_InfoItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonEDCH-AdditionalTransmissionBackOff')))
    _Common_E_DCH_InfoItem_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Implicit-Release-Timer')))
    Common_E_DCH_InfoItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 1200), ('criticality', 'ignore'), ('Extension', _Common_E_DCH_InfoItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1236), ('criticality', 'ignore'), ('Extension', _Common_E_DCH_InfoItem_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonEDCH-AdditionalTransmissionBackOff >-----#
    CommonEDCH_AdditionalTransmissionBackOff = INT(name='CommonEDCH-AdditionalTransmissionBackOff', mode=MODE_TYPE)
    CommonEDCH_AdditionalTransmissionBackOff._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< Common-E-DCH-HSDPCCH-InfoItem >-----#
    Common_E_DCH_HSDPCCH_InfoItem = SEQ(name='Common-E-DCH-HSDPCCH-InfoItem', mode=MODE_TYPE)
    _Common_E_DCH_HSDPCCH_InfoItem_ackNackRepetitionFactor = INT(name='ackNackRepetitionFactor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AckNack-RepetitionFactor')))
    _Common_E_DCH_HSDPCCH_InfoItem_ackPowerOffset = INT(name='ackPowerOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Ack-Power-Offset')))
    _Common_E_DCH_HSDPCCH_InfoItem_nackPowerOffset = INT(name='nackPowerOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Nack-Power-Offset')))
    _Common_E_DCH_HSDPCCH_InfoItem_common_E_DCH_CQI_Info = SEQ(name='common-E-DCH-CQI-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-CQI-Info')), opt=True)
    _Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__id._const_tab = ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__id_tab
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item_._ext = None
    _Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions._cont = __Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item_
    _Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_HSDPCCH_InfoItem._cont = ASN1Dict([
        ('ackNackRepetitionFactor', _Common_E_DCH_HSDPCCH_InfoItem_ackNackRepetitionFactor),
        ('ackPowerOffset', _Common_E_DCH_HSDPCCH_InfoItem_ackPowerOffset),
        ('nackPowerOffset', _Common_E_DCH_HSDPCCH_InfoItem_nackPowerOffset),
        ('common-E-DCH-CQI-Info', _Common_E_DCH_HSDPCCH_InfoItem_common_E_DCH_CQI_Info),
        ('iE-Extensions', _Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions),
        ])
    Common_E_DCH_HSDPCCH_InfoItem._ext = []
    
    #-----< Common-E-DCH-HSDPCCH-InfoItem-ExtIEs >-----#
    Common_E_DCH_HSDPCCH_InfoItem_ExtIEs = CLASS(name='Common-E-DCH-HSDPCCH-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_HSDPCCH_InfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-CQI-Info >-----#
    Common_E_DCH_CQI_Info = SEQ(name='Common-E-DCH-CQI-Info', mode=MODE_TYPE)
    _Common_E_DCH_CQI_Info_cqiFeedback_CycleK = ENUM(name='cqiFeedback-CycleK', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-Feedback-Cycle')))
    _Common_E_DCH_CQI_Info_cqiRepetitionFactor = INT(name='cqiRepetitionFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-RepetitionFactor')), opt=True)
    _Common_E_DCH_CQI_Info_cqiPowerOffset = INT(name='cqiPowerOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-Power-Offset')))
    _Common_E_DCH_CQI_Info_measurement_Power_Offset = INT(name='measurement-Power-Offset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Measurement-Power-Offset')))
    _Common_E_DCH_CQI_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_CQI_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_CQI_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_CQI_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__id._const_tab = ____Common_E_DCH_CQI_Info_iE_Extensions__item__id_tab
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_CQI_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_CQI_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_CQI_Info_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_CQI_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_CQI_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_CQI_Info_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_CQI_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_CQI_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_CQI_Info_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_CQI_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_CQI_Info_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_CQI_Info_iE_Extensions__item_._ext = None
    _Common_E_DCH_CQI_Info_iE_Extensions._cont = __Common_E_DCH_CQI_Info_iE_Extensions__item_
    _Common_E_DCH_CQI_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_CQI_Info._cont = ASN1Dict([
        ('cqiFeedback-CycleK', _Common_E_DCH_CQI_Info_cqiFeedback_CycleK),
        ('cqiRepetitionFactor', _Common_E_DCH_CQI_Info_cqiRepetitionFactor),
        ('cqiPowerOffset', _Common_E_DCH_CQI_Info_cqiPowerOffset),
        ('measurement-Power-Offset', _Common_E_DCH_CQI_Info_measurement_Power_Offset),
        ('iE-Extensions', _Common_E_DCH_CQI_Info_iE_Extensions),
        ])
    Common_E_DCH_CQI_Info._ext = []
    
    #-----< Common-E-DCH-CQI-Info-ExtIEs >-----#
    Common_E_DCH_CQI_Info_ExtIEs = CLASS(name='Common-E-DCH-CQI-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_CQI_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-Preamble-Control-InfoItem >-----#
    Common_E_DCH_Preamble_Control_InfoItem = SEQ(name='Common-E-DCH-Preamble-Control-InfoItem', mode=MODE_TYPE)
    _Common_E_DCH_Preamble_Control_InfoItem_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _Common_E_DCH_Preamble_Control_InfoItem_common_E_DCH_PreambleSignatures = BIT_STR(name='common-E-DCH-PreambleSignatures', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PreambleSignatures')))
    _Common_E_DCH_Preamble_Control_InfoItem_scramblingCodeNumber = INT(name='scramblingCodeNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ScramblingCodeNumber')))
    _Common_E_DCH_Preamble_Control_InfoItem_preambleThreshold = INT(name='preambleThreshold', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PreambleThreshold')))
    _Common_E_DCH_Preamble_Control_InfoItem_e_AI_Indicator = BOOL(name='e-AI-Indicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AI-Indicator')), opt=True)
    _Common_E_DCH_Preamble_Control_InfoItem_common_E_DCH_AICH_Information = SEQ(name='common-E-DCH-AICH-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-AICH-Information')), opt=True)
    _Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__id._const_tab = ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__id_tab
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item_._ext = None
    _Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions._cont = __Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item_
    _Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_Preamble_Control_InfoItem._cont = ASN1Dict([
        ('commonPhysicalChannelID', _Common_E_DCH_Preamble_Control_InfoItem_commonPhysicalChannelID),
        ('common-E-DCH-PreambleSignatures', _Common_E_DCH_Preamble_Control_InfoItem_common_E_DCH_PreambleSignatures),
        ('scramblingCodeNumber', _Common_E_DCH_Preamble_Control_InfoItem_scramblingCodeNumber),
        ('preambleThreshold', _Common_E_DCH_Preamble_Control_InfoItem_preambleThreshold),
        ('e-AI-Indicator', _Common_E_DCH_Preamble_Control_InfoItem_e_AI_Indicator),
        ('common-E-DCH-AICH-Information', _Common_E_DCH_Preamble_Control_InfoItem_common_E_DCH_AICH_Information),
        ('iE-Extensions', _Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions),
        ])
    Common_E_DCH_Preamble_Control_InfoItem._ext = []
    
    #-----< Common-E-DCH-Preamble-Control-InfoItem-ExtIEs >-----#
    Common_E_DCH_Preamble_Control_InfoItem_ExtIEs = CLASS(name='Common-E-DCH-Preamble-Control-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_Preamble_Control_InfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-AICH-Information >-----#
    Common_E_DCH_AICH_Information = SEQ(name='Common-E-DCH-AICH-Information', mode=MODE_TYPE)
    _Common_E_DCH_AICH_Information_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _Common_E_DCH_AICH_Information_aICH_TransmissionTiming = ENUM(name='aICH-TransmissionTiming', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AICH-TransmissionTiming')))
    _Common_E_DCH_AICH_Information_fdd_dl_ChannelisationCodeNumber = INT(name='fdd-dl-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _Common_E_DCH_AICH_Information_aICH_Power = INT(name='aICH-Power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AICH-Power')))
    _Common_E_DCH_AICH_Information_sTTD_Indicator = ENUM(name='sTTD-Indicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'STTD-Indicator')))
    _Common_E_DCH_AICH_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_AICH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_AICH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_AICH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__id._const_tab = ____Common_E_DCH_AICH_Information_iE_Extensions__item__id_tab
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_AICH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_AICH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_AICH_Information_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_AICH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_AICH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_AICH_Information_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_AICH_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_AICH_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_AICH_Information_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_AICH_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_AICH_Information_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_AICH_Information_iE_Extensions__item_._ext = None
    _Common_E_DCH_AICH_Information_iE_Extensions._cont = __Common_E_DCH_AICH_Information_iE_Extensions__item_
    _Common_E_DCH_AICH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_AICH_Information._cont = ASN1Dict([
        ('commonPhysicalChannelID', _Common_E_DCH_AICH_Information_commonPhysicalChannelID),
        ('aICH-TransmissionTiming', _Common_E_DCH_AICH_Information_aICH_TransmissionTiming),
        ('fdd-dl-ChannelisationCodeNumber', _Common_E_DCH_AICH_Information_fdd_dl_ChannelisationCodeNumber),
        ('aICH-Power', _Common_E_DCH_AICH_Information_aICH_Power),
        ('sTTD-Indicator', _Common_E_DCH_AICH_Information_sTTD_Indicator),
        ('iE-Extensions', _Common_E_DCH_AICH_Information_iE_Extensions),
        ])
    Common_E_DCH_AICH_Information._ext = []
    
    #-----< Common-E-DCH-AICH-Information-ExtIEs >-----#
    Common_E_DCH_AICH_Information_ExtIEs = CLASS(name='Common-E-DCH-AICH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_AICH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-FDPCH-InfoItem >-----#
    Common_E_DCH_FDPCH_InfoItem = SEQ(name='Common-E-DCH-FDPCH-InfoItem', mode=MODE_TYPE)
    _Common_E_DCH_FDPCH_InfoItem_f_DPCH_SlotFormat = INT(name='f-DPCH-SlotFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')))
    _Common_E_DCH_FDPCH_InfoItem_fdd_TPC_DownlinkStepSize = ENUM(name='fdd-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-TPC-DownlinkStepSize')))
    _Common_E_DCH_FDPCH_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    ____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1164), ('criticality', 'ignore'), ('Extension', _____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1165), ('criticality', 'ignore'), ('Extension', _____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1166), ('criticality', 'ignore'), ('Extension', _____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id._const_tab = ____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item_._ext = None
    _Common_E_DCH_FDPCH_InfoItem_iE_Extensions._cont = __Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item_
    _Common_E_DCH_FDPCH_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_FDPCH_InfoItem._cont = ASN1Dict([
        ('f-DPCH-SlotFormat', _Common_E_DCH_FDPCH_InfoItem_f_DPCH_SlotFormat),
        ('fdd-TPC-DownlinkStepSize', _Common_E_DCH_FDPCH_InfoItem_fdd_TPC_DownlinkStepSize),
        ('iE-Extensions', _Common_E_DCH_FDPCH_InfoItem_iE_Extensions),
        ])
    Common_E_DCH_FDPCH_InfoItem._ext = []
    
    #-----< Common-E-DCH-FDPCH-InfoItem-ExtIEs >-----#
    Common_E_DCH_FDPCH_InfoItem_ExtIEs = CLASS(name='Common-E-DCH-FDPCH-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Common_E_DCH_FDPCH_InfoItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _Common_E_DCH_FDPCH_InfoItem_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _Common_E_DCH_FDPCH_InfoItem_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    Common_E_DCH_FDPCH_InfoItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 1164), ('criticality', 'ignore'), ('Extension', _Common_E_DCH_FDPCH_InfoItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1165), ('criticality', 'ignore'), ('Extension', _Common_E_DCH_FDPCH_InfoItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1166), ('criticality', 'ignore'), ('Extension', _Common_E_DCH_FDPCH_InfoItem_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-Resource-Combination-InfoList >-----#
    Common_E_DCH_Resource_Combination_InfoList = SEQ_OF(name='Common-E-DCH-Resource-Combination-InfoList', mode=MODE_TYPE)
    _Common_E_DCH_Resource_Combination_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Resource-Combination-InfoList-Item')))
    Common_E_DCH_Resource_Combination_InfoList._cont = _Common_E_DCH_Resource_Combination_InfoList__item_
    Common_E_DCH_Resource_Combination_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Common-E-DCH-Resource-Combination-InfoList-Item >-----#
    Common_E_DCH_Resource_Combination_InfoList_Item = SEQ(name='Common-E-DCH-Resource-Combination-InfoList-Item', mode=MODE_TYPE)
    _Common_E_DCH_Resource_Combination_InfoList_Item_soffset = INT(name='soffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Soffset')))
    _Common_E_DCH_Resource_Combination_InfoList_Item_f_DPCH_DL_Code_Number = INT(name='f-DPCH-DL-Code-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _Common_E_DCH_Resource_Combination_InfoList_Item_ul_DPCH_ScramblingCode = SEQ(name='ul-DPCH-ScramblingCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-ScramblingCode')))
    _Common_E_DCH_Resource_Combination_InfoList_Item_e_RGCH_E_HICH_Channelisation_Code = INT(name='e-RGCH-E-HICH-Channelisation-Code', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _Common_E_DCH_Resource_Combination_InfoList_Item_e_RGCH_Signature_Sequence = INT(name='e-RGCH-Signature-Sequence', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-Signature-Sequence')), opt=True)
    _Common_E_DCH_Resource_Combination_InfoList_Item_e_HICH_Signature_Sequence = INT(name='e-HICH-Signature-Sequence', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-Signature-Sequence')))
    _Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__id._const_tab = ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__id_tab
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item_._ext = None
    _Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions._cont = __Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item_
    _Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_Resource_Combination_InfoList_Item._cont = ASN1Dict([
        ('soffset', _Common_E_DCH_Resource_Combination_InfoList_Item_soffset),
        ('f-DPCH-DL-Code-Number', _Common_E_DCH_Resource_Combination_InfoList_Item_f_DPCH_DL_Code_Number),
        ('ul-DPCH-ScramblingCode', _Common_E_DCH_Resource_Combination_InfoList_Item_ul_DPCH_ScramblingCode),
        ('e-RGCH-E-HICH-Channelisation-Code', _Common_E_DCH_Resource_Combination_InfoList_Item_e_RGCH_E_HICH_Channelisation_Code),
        ('e-RGCH-Signature-Sequence', _Common_E_DCH_Resource_Combination_InfoList_Item_e_RGCH_Signature_Sequence),
        ('e-HICH-Signature-Sequence', _Common_E_DCH_Resource_Combination_InfoList_Item_e_HICH_Signature_Sequence),
        ('iE-Extensions', _Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions),
        ])
    Common_E_DCH_Resource_Combination_InfoList_Item._ext = []
    
    #-----< Common-E-DCH-Resource-Combination-InfoList-Item-ExtIEs >-----#
    Common_E_DCH_Resource_Combination_InfoList_Item_ExtIEs = CLASS(name='Common-E-DCH-Resource-Combination-InfoList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_Resource_Combination_InfoList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-MAC-d-flow-info-Concurrent-TTI >-----#
    Common_E_DCH_MAC_d_flow_info_Concurrent_TTI = SEQ(name='Common-E-DCH-MAC-d-flow-info-Concurrent-TTI', mode=MODE_TYPE)
    _Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_maximum_Number_of_Retransmissions_For_E_DCH = INT(name='maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Number-of-Retransmissions-For-E-DCH')), opt=True)
    _Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_eDCH_HARQ_PO_FDD = INT(name='eDCH-HARQ-PO-FDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-PO-FDD')), opt=True)
    _Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__id._const_tab = ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__id_tab
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item_._ext = None
    _Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions._cont = __Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item_
    _Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_MAC_d_flow_info_Concurrent_TTI._cont = ASN1Dict([
        ('maximum-Number-of-Retransmissions-For-E-DCH', _Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_maximum_Number_of_Retransmissions_For_E_DCH),
        ('eDCH-HARQ-PO-FDD', _Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_eDCH_HARQ_PO_FDD),
        ('iE-Extensions', _Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions),
        ])
    Common_E_DCH_MAC_d_flow_info_Concurrent_TTI._ext = []
    
    #-----< Common-E-DCH-MAC-d-flow-info-Concurrent-TTI-ExtIEs >-----#
    Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_ExtIEs = CLASS(name='Common-E-DCH-MAC-d-flow-info-Concurrent-TTI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoList >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoList = SEQ_OF(name='Ul-common-E-DCH-MACflow-Specific-InfoList', mode=MODE_TYPE)
    _Ul_common_E_DCH_MACflow_Specific_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoList-Item')))
    Ul_common_E_DCH_MACflow_Specific_InfoList._cont = _Ul_common_E_DCH_MACflow_Specific_InfoList__item_
    Ul_common_E_DCH_MACflow_Specific_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoList-Item >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoList_Item = SEQ(name='Ul-common-E-DCH-MACflow-Specific-InfoList-Item', mode=MODE_TYPE)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_ul_Common_MACFlowID = INT(name='ul-Common-MACFlowID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID')))
    _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_transportBearerRequestIndicator = ENUM(name='transportBearerRequestIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_tnlQos = CHOICE(name='tnlQos', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_payloadCRC_PresenceIndicator = ENUM(name='payloadCRC-PresenceIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PayloadCRC-PresenceIndicator')))
    _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_bundlingModeIndicator = ENUM(name='bundlingModeIndicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BundlingModeIndicator')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_common_E_DCH_MACdFlow_Specific_Information = SEQ_OF(name='common-E-DCH-MACdFlow-Specific-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-MACdFlow-Specific-InfoList')))
    _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__id._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__id_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__id._const_tab_at = None
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__criticality._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__criticality_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__extensionValue._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__extensionValue_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__id),
        ('criticality', ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__extensionValue),
        ])
    __Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item_._ext = None
    _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions._cont = __Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item_
    _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ul_common_E_DCH_MACflow_Specific_InfoList_Item._cont = ASN1Dict([
        ('ul-Common-MACFlowID', _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_ul_Common_MACFlowID),
        ('transportBearerRequestIndicator', _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_transportBearerRequestIndicator),
        ('bindingID', _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_bindingID),
        ('transportLayerAddress', _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_transportLayerAddress),
        ('tnlQos', _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_tnlQos),
        ('payloadCRC-PresenceIndicator', _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_payloadCRC_PresenceIndicator),
        ('bundlingModeIndicator', _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_bundlingModeIndicator),
        ('common-E-DCH-MACdFlow-Specific-Information', _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_common_E_DCH_MACdFlow_Specific_Information),
        ('iE-Extensions', _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions),
        ])
    Ul_common_E_DCH_MACflow_Specific_InfoList_Item._ext = []
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoList-Item-ExtIEs >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoList_Item_ExtIEs = CLASS(name='Ul-common-E-DCH-MACflow-Specific-InfoList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Ul_common_E_DCH_MACflow_Specific_InfoList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-MACdFlow-Specific-InfoList >-----#
    Common_E_DCH_MACdFlow_Specific_InfoList = SEQ_OF(name='Common-E-DCH-MACdFlow-Specific-InfoList', mode=MODE_TYPE)
    _Common_E_DCH_MACdFlow_Specific_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-MACdFlow-Specific-InfoList-Item')))
    Common_E_DCH_MACdFlow_Specific_InfoList._cont = _Common_E_DCH_MACdFlow_Specific_InfoList__item_
    Common_E_DCH_MACdFlow_Specific_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Common-E-DCH-MACdFlow-Specific-InfoList-Item >-----#
    Common_E_DCH_MACdFlow_Specific_InfoList_Item = SEQ(name='Common-E-DCH-MACdFlow-Specific-InfoList-Item', mode=MODE_TYPE)
    _Common_E_DCH_MACdFlow_Specific_InfoList_Item_common_e_DCH_MACdFlow_ID = INT(name='common-e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _Common_E_DCH_MACdFlow_Specific_InfoList_Item_maximum_Number_of_Retransmissions_For_E_DCH = INT(name='maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Number-of-Retransmissions-For-E-DCH')))
    _Common_E_DCH_MACdFlow_Specific_InfoList_Item_eDCH_HARQ_PO_FDD = INT(name='eDCH-HARQ-PO-FDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-PO-FDD')))
    _Common_E_DCH_MACdFlow_Specific_InfoList_Item_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name='eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _Common_E_DCH_MACdFlow_Specific_InfoList_Item_common_E_DCHLogicalChannelInformation = SEQ_OF(name='common-E-DCHLogicalChannelInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-LogicalChannel-InfoList')))
    _Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-MAC-d-flow-info-Concurrent-TTI')))
    ____Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1247), ('criticality', 'ignore'), ('Extension', _____Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id._const_tab = ____Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id_tab
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id_tab
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id_tab
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item_._ext = None
    _Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions._cont = __Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item_
    _Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_MACdFlow_Specific_InfoList_Item._cont = ASN1Dict([
        ('common-e-DCH-MACdFlow-ID', _Common_E_DCH_MACdFlow_Specific_InfoList_Item_common_e_DCH_MACdFlow_ID),
        ('maximum-Number-of-Retransmissions-For-E-DCH', _Common_E_DCH_MACdFlow_Specific_InfoList_Item_maximum_Number_of_Retransmissions_For_E_DCH),
        ('eDCH-HARQ-PO-FDD', _Common_E_DCH_MACdFlow_Specific_InfoList_Item_eDCH_HARQ_PO_FDD),
        ('eDCH-MACdFlow-Multiplexing-List', _Common_E_DCH_MACdFlow_Specific_InfoList_Item_eDCH_MACdFlow_Multiplexing_List),
        ('common-E-DCHLogicalChannelInformation', _Common_E_DCH_MACdFlow_Specific_InfoList_Item_common_E_DCHLogicalChannelInformation),
        ('iE-Extensions', _Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions),
        ])
    Common_E_DCH_MACdFlow_Specific_InfoList_Item._ext = []
    
    #-----< Common-E-DCH-MACdFlow-Specific-InfoList-Item-ExtIEs >-----#
    Common_E_DCH_MACdFlow_Specific_InfoList_Item_ExtIEs = CLASS(name='Common-E-DCH-MACdFlow-Specific-InfoList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Common_E_DCH_MACdFlow_Specific_InfoList_Item_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-MAC-d-flow-info-Concurrent-TTI')))
    Common_E_DCH_MACdFlow_Specific_InfoList_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 1247), ('criticality', 'ignore'), ('Extension', _Common_E_DCH_MACdFlow_Specific_InfoList_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-LogicalChannel-InfoList >-----#
    Common_E_DCH_LogicalChannel_InfoList = SEQ_OF(name='Common-E-DCH-LogicalChannel-InfoList', mode=MODE_TYPE)
    _Common_E_DCH_LogicalChannel_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-LogicalChannel-InfoList-Item')))
    Common_E_DCH_LogicalChannel_InfoList._cont = _Common_E_DCH_LogicalChannel_InfoList__item_
    Common_E_DCH_LogicalChannel_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Common-E-DCH-LogicalChannel-InfoList-Item >-----#
    Common_E_DCH_LogicalChannel_InfoList_Item = SEQ(name='Common-E-DCH-LogicalChannel-InfoList-Item', mode=MODE_TYPE)
    _Common_E_DCH_LogicalChannel_InfoList_Item_logicalChannelId = INT(name='logicalChannelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LogicalChannelID')))
    _Common_E_DCH_LogicalChannel_InfoList_Item_maximumMACcPDU_SizeExtended = INT(name='maximumMACcPDU-SizeExtended', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')))
    ____Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1081), ('criticality', 'ignore'), ('Extension', _____Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id._const_tab = ____Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id_tab
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id_tab
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id_tab
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item_._ext = None
    _Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions._cont = __Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item_
    _Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_LogicalChannel_InfoList_Item._cont = ASN1Dict([
        ('logicalChannelId', _Common_E_DCH_LogicalChannel_InfoList_Item_logicalChannelId),
        ('maximumMACcPDU-SizeExtended', _Common_E_DCH_LogicalChannel_InfoList_Item_maximumMACcPDU_SizeExtended),
        ('iE-Extensions', _Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions),
        ])
    Common_E_DCH_LogicalChannel_InfoList_Item._ext = []
    
    #-----< Common-E-DCH-LogicalChannel-InfoList-Item-ExtIEs >-----#
    Common_E_DCH_LogicalChannel_InfoList_Item_ExtIEs = CLASS(name='Common-E-DCH-LogicalChannel-InfoList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Common_E_DCH_LogicalChannel_InfoList_Item_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')))
    Common_E_DCH_LogicalChannel_InfoList_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 1081), ('criticality', 'ignore'), ('Extension', _Common_E_DCH_LogicalChannel_InfoList_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Common-EDCH-System-Information-ResponseFDD >-----#
    Common_EDCH_System_Information_ResponseFDD = SEQ(name='Common-EDCH-System-Information-ResponseFDD', mode=MODE_TYPE)
    _Common_EDCH_System_Information_ResponseFDD_ul_common_E_DCH_MACflow_Specific_InfoResponse = SEQ_OF(name='ul-common-E-DCH-MACflow-Specific-InfoResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoResponseList')))
    _Common_EDCH_System_Information_ResponseFDD_serving_Grant_Value = INT(name='serving-Grant-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-Serving-Grant-Value')))
    _Common_EDCH_System_Information_ResponseFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI-List')))
    _____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE)
    _____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-Serving-Grant-Value')))
    ____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1144), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1204), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1248), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id._const_tab = ____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id._const_tab_at = None
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__criticality._const_tab = ____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__extensionValue._const_tab = ____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id),
        ('criticality', ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__extensionValue),
        ])
    __Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item_._ext = None
    _Common_EDCH_System_Information_ResponseFDD_iE_Extensions._cont = __Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item_
    _Common_EDCH_System_Information_ResponseFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_EDCH_System_Information_ResponseFDD._cont = ASN1Dict([
        ('ul-common-E-DCH-MACflow-Specific-InfoResponse', _Common_EDCH_System_Information_ResponseFDD_ul_common_E_DCH_MACflow_Specific_InfoResponse),
        ('serving-Grant-Value', _Common_EDCH_System_Information_ResponseFDD_serving_Grant_Value),
        ('iE-Extensions', _Common_EDCH_System_Information_ResponseFDD_iE_Extensions),
        ])
    Common_EDCH_System_Information_ResponseFDD._ext = []
    
    #-----< Common-EDCH-System-Information-ResponseFDD-ExtIEs >-----#
    Common_EDCH_System_Information_ResponseFDD_ExtIEs = CLASS(name='Common-EDCH-System-Information-ResponseFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Common_EDCH_System_Information_ResponseFDD_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI-List')))
    _Common_EDCH_System_Information_ResponseFDD_ExtIEs_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE)
    _Common_EDCH_System_Information_ResponseFDD_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-Serving-Grant-Value')))
    Common_EDCH_System_Information_ResponseFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 1144), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_Information_ResponseFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1204), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_Information_ResponseFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1248), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_Information_ResponseFDD_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RNTI-List >-----#
    E_RNTI_List = SEQ_OF(name='E-RNTI-List', mode=MODE_TYPE)
    _E_RNTI_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    E_RNTI_List._cont = _E_RNTI_List__item_
    E_RNTI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoResponseList >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList = SEQ_OF(name='Ul-common-E-DCH-MACflow-Specific-InfoResponseList', mode=MODE_TYPE)
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-Item')))
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList._cont = _Ul_common_E_DCH_MACflow_Specific_InfoResponseList__item_
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoResponseList-Item >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item = SEQ(name='Ul-common-E-DCH-MACflow-Specific-InfoResponseList-Item', mode=MODE_TYPE)
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_ul_Common_MACFlowID = INT(name='ul-Common-MACFlowID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID')))
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__id._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__id_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__id._const_tab_at = None
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__criticality._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__criticality_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__extensionValue._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__extensionValue_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__id),
        ('criticality', ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__extensionValue),
        ])
    __Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item_._ext = None
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions._cont = __Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item_
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item._cont = ASN1Dict([
        ('ul-Common-MACFlowID', _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_ul_Common_MACFlowID),
        ('bindingID', _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_bindingID),
        ('transportLayerAddress', _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_transportLayerAddress),
        ('iE-Extensions', _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions),
        ])
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item._ext = []
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoResponseList-Item-ExtIEs >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_ExtIEs = CLASS(name='Ul-common-E-DCH-MACflow-Specific-InfoResponseList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-HSDSCH-RNTI-List >-----#
    Common_HSDSCH_RNTI_List = SEQ_OF(name='Common-HSDSCH-RNTI-List', mode=MODE_TYPE)
    _Common_HSDSCH_RNTI_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    Common_HSDSCH_RNTI_List._cont = _Common_HSDSCH_RNTI_List__item_
    Common_HSDSCH_RNTI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Common-MACFlows-to-DeleteFDD >-----#
    Common_MACFlows_to_DeleteFDD = SEQ_OF(name='Common-MACFlows-to-DeleteFDD', mode=MODE_TYPE)
    _Common_MACFlows_to_DeleteFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlows-to-DeleteFDD-Item')))
    Common_MACFlows_to_DeleteFDD._cont = _Common_MACFlows_to_DeleteFDD__item_
    Common_MACFlows_to_DeleteFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Common-MACFlows-to-DeleteFDD-Item >-----#
    Common_MACFlows_to_DeleteFDD_Item = SEQ(name='Common-MACFlows-to-DeleteFDD-Item', mode=MODE_TYPE)
    _Common_MACFlows_to_DeleteFDD_Item_common_MACFlow_ID = INT(name='common-MACFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID')))
    _Common_MACFlows_to_DeleteFDD_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id._const_tab = ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id_tab
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id._const_tab_at = None
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality._const_tab = ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality_tab
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue._const_tab = ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue_tab
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id),
        ('criticality', ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue),
        ])
    __Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item_._ext = None
    _Common_MACFlows_to_DeleteFDD_Item_iE_Extensions._cont = __Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item_
    _Common_MACFlows_to_DeleteFDD_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_MACFlows_to_DeleteFDD_Item._cont = ASN1Dict([
        ('common-MACFlow-ID', _Common_MACFlows_to_DeleteFDD_Item_common_MACFlow_ID),
        ('iE-Extensions', _Common_MACFlows_to_DeleteFDD_Item_iE_Extensions),
        ])
    Common_MACFlows_to_DeleteFDD_Item._ext = []
    
    #-----< Common-MACFlows-to-DeleteFDD-Item-ExtIEs >-----#
    Common_MACFlows_to_DeleteFDD_Item_ExtIEs = CLASS(name='Common-MACFlows-to-DeleteFDD-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_MACFlows_to_DeleteFDD_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-MACFlow-ID >-----#
    Common_MACFlow_ID = INT(name='Common-MACFlow-ID', mode=MODE_TYPE)
    Common_MACFlow_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< CommonMACFlow-Specific-InfoList >-----#
    CommonMACFlow_Specific_InfoList = SEQ_OF(name='CommonMACFlow-Specific-InfoList', mode=MODE_TYPE)
    _CommonMACFlow_Specific_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMACFlow-Specific-InfoItem')))
    CommonMACFlow_Specific_InfoList._cont = _CommonMACFlow_Specific_InfoList__item_
    CommonMACFlow_Specific_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CommonMACFlow-Specific-InfoItem >-----#
    CommonMACFlow_Specific_InfoItem = SEQ(name='CommonMACFlow-Specific-InfoItem', mode=MODE_TYPE)
    _CommonMACFlow_Specific_InfoItem_common_MACFlow_Id = INT(name='common-MACFlow-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID')))
    _CommonMACFlow_Specific_InfoItem_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _CommonMACFlow_Specific_InfoItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _CommonMACFlow_Specific_InfoItem_tnl_qos = CHOICE(name='tnl-qos', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')), opt=True)
    _CommonMACFlow_Specific_InfoItem_common_MACFlow_PriorityQueue_Information = SEQ_OF(name='common-MACFlow-PriorityQueue-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-PriorityQueue-Information')), opt=True)
    _CommonMACFlow_Specific_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMACFlow_Specific_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    ____CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 996), ('criticality', 'ignore'), ('Extension', _____CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab = ____CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab = ____CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonMACFlow_Specific_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id),
        ('criticality', ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __CommonMACFlow_Specific_InfoItem_iE_Extensions__item_._ext = None
    _CommonMACFlow_Specific_InfoItem_iE_Extensions._cont = __CommonMACFlow_Specific_InfoItem_iE_Extensions__item_
    _CommonMACFlow_Specific_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMACFlow_Specific_InfoItem._cont = ASN1Dict([
        ('common-MACFlow-Id', _CommonMACFlow_Specific_InfoItem_common_MACFlow_Id),
        ('bindingID', _CommonMACFlow_Specific_InfoItem_bindingID),
        ('transportLayerAddress', _CommonMACFlow_Specific_InfoItem_transportLayerAddress),
        ('tnl-qos', _CommonMACFlow_Specific_InfoItem_tnl_qos),
        ('common-MACFlow-PriorityQueue-Information', _CommonMACFlow_Specific_InfoItem_common_MACFlow_PriorityQueue_Information),
        ('iE-Extensions', _CommonMACFlow_Specific_InfoItem_iE_Extensions),
        ])
    CommonMACFlow_Specific_InfoItem._ext = []
    
    #-----< CommonMACFlow-Specific-InfoItem-ExtIEs >-----#
    CommonMACFlow_Specific_InfoItem_ExtIEs = CLASS(name='CommonMACFlow-Specific-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CommonMACFlow_Specific_InfoItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    CommonMACFlow_Specific_InfoItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 996), ('criticality', 'ignore'), ('Extension', _CommonMACFlow_Specific_InfoItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMACFlow-Specific-InfoList-Response >-----#
    CommonMACFlow_Specific_InfoList_Response = SEQ_OF(name='CommonMACFlow-Specific-InfoList-Response', mode=MODE_TYPE)
    _CommonMACFlow_Specific_InfoList_Response__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMACFlow-Specific-InfoItem-Response')))
    CommonMACFlow_Specific_InfoList_Response._cont = _CommonMACFlow_Specific_InfoList_Response__item_
    CommonMACFlow_Specific_InfoList_Response._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CommonMACFlow-Specific-InfoItem-Response >-----#
    CommonMACFlow_Specific_InfoItem_Response = SEQ(name='CommonMACFlow-Specific-InfoItem-Response', mode=MODE_TYPE)
    _CommonMACFlow_Specific_InfoItem_Response_commonMACFlow_ID = INT(name='commonMACFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID')))
    _CommonMACFlow_Specific_InfoItem_Response_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _CommonMACFlow_Specific_InfoItem_Response_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _CommonMACFlow_Specific_InfoItem_Response_hSDSCH_Initial_Capacity_Allocation = SEQ_OF(name='hSDSCH-Initial-Capacity-Allocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Initial-Capacity-Allocation')), opt=True)
    _CommonMACFlow_Specific_InfoItem_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab = ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__id_tab
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab_at = None
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab = ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab = ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__id),
        ('criticality', ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue),
        ])
    __CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item_._ext = None
    _CommonMACFlow_Specific_InfoItem_Response_iE_Extensions._cont = __CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item_
    _CommonMACFlow_Specific_InfoItem_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMACFlow_Specific_InfoItem_Response._cont = ASN1Dict([
        ('commonMACFlow-ID', _CommonMACFlow_Specific_InfoItem_Response_commonMACFlow_ID),
        ('bindingID', _CommonMACFlow_Specific_InfoItem_Response_bindingID),
        ('transportLayerAddress', _CommonMACFlow_Specific_InfoItem_Response_transportLayerAddress),
        ('hSDSCH-Initial-Capacity-Allocation', _CommonMACFlow_Specific_InfoItem_Response_hSDSCH_Initial_Capacity_Allocation),
        ('iE-Extensions', _CommonMACFlow_Specific_InfoItem_Response_iE_Extensions),
        ])
    CommonMACFlow_Specific_InfoItem_Response._ext = []
    
    #-----< CommonMACFlow-Specific-InfoItem-Response-ExtIEs >-----#
    CommonMACFlow_Specific_InfoItem_Response_ExtIEs = CLASS(name='CommonMACFlow-Specific-InfoItem-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonMACFlow_Specific_InfoItem_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-MACFlow-PriorityQueue-Information >-----#
    Common_MACFlow_PriorityQueue_Information = SEQ_OF(name='Common-MACFlow-PriorityQueue-Information', mode=MODE_TYPE)
    _Common_MACFlow_PriorityQueue_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-PriorityQueue-Item')))
    Common_MACFlow_PriorityQueue_Information._cont = _Common_MACFlow_PriorityQueue_Information__item_
    Common_MACFlow_PriorityQueue_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Common-MACFlow-PriorityQueue-Item >-----#
    Common_MACFlow_PriorityQueue_Item = SEQ(name='Common-MACFlow-PriorityQueue-Item', mode=MODE_TYPE)
    _Common_MACFlow_PriorityQueue_Item_priority_Queue_Information_for_Enhanced_FACH = SEQ(name='priority-Queue-Information-for-Enhanced-FACH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Priority-Queue-Information-for-Enhanced-FACH-PCH')))
    _Common_MACFlow_PriorityQueue_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_MACFlow_PriorityQueue_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__id._const_tab = ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__id_tab
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__id._const_tab_at = None
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality._const_tab = ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality_tab
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue._const_tab = ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue_tab
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_MACFlow_PriorityQueue_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__id),
        ('criticality', ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue),
        ])
    __Common_MACFlow_PriorityQueue_Item_iE_Extensions__item_._ext = None
    _Common_MACFlow_PriorityQueue_Item_iE_Extensions._cont = __Common_MACFlow_PriorityQueue_Item_iE_Extensions__item_
    _Common_MACFlow_PriorityQueue_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_MACFlow_PriorityQueue_Item._cont = ASN1Dict([
        ('priority-Queue-Information-for-Enhanced-FACH', _Common_MACFlow_PriorityQueue_Item_priority_Queue_Information_for_Enhanced_FACH),
        ('iE-Extensions', _Common_MACFlow_PriorityQueue_Item_iE_Extensions),
        ])
    Common_MACFlow_PriorityQueue_Item._ext = []
    
    #-----< Common-MACFlow-PriorityQueue-Item-ExtIEs >-----#
    Common_MACFlow_PriorityQueue_Item_ExtIEs = CLASS(name='Common-MACFlow-PriorityQueue-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_MACFlow_PriorityQueue_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementAccuracy >-----#
    CommonMeasurementAccuracy = CHOICE(name='CommonMeasurementAccuracy', mode=MODE_TYPE)
    _CommonMeasurementAccuracy_tUTRANGPSMeasurementAccuracyClass = ENUM(name='tUTRANGPSMeasurementAccuracyClass', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGPSAccuracyClass')))
    _CommonMeasurementAccuracy_tUTRANGANSSMeasurementAccuracyClass = ENUM(name='tUTRANGANSSMeasurementAccuracyClass', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGANSSAccuracyClass')))
    CommonMeasurementAccuracy._cont = ASN1Dict([
        ('tUTRANGPSMeasurementAccuracyClass', _CommonMeasurementAccuracy_tUTRANGPSMeasurementAccuracyClass),
        ('tUTRANGANSSMeasurementAccuracyClass', _CommonMeasurementAccuracy_tUTRANGANSSMeasurementAccuracyClass),
        ])
    CommonMeasurementAccuracy._ext = ['tUTRANGANSSMeasurementAccuracyClass']
    
    #-----< CommonMeasurementType >-----#
    CommonMeasurementType = ENUM(name='CommonMeasurementType', mode=MODE_TYPE)
    CommonMeasurementType._cont = ASN1Dict([('received-total-wide-band-power', 0), ('transmitted-carrier-power', 1), ('acknowledged-prach-preambles', 2), ('ul-timeslot-iscp', 3), ('notUsed-1-acknowledged-PCPCH-access-preambles', 4), ('notUsed-2-detected-PCPCH-access-preambles', 5), ('uTRAN-GPS-Timing-of-Cell-Frames-for-UE-Positioning', 6), ('sFN-SFN-Observed-Time-Difference', 7), ('transmittedCarrierPowerOfAllCodesNotUsedForHSTransmission', 8), ('hS-DSCH-Required-Power', 9), ('hS-DSCH-Provided-Bit-Rate', 10), ('received-total-wide-band-power-for-cellPortion', 11), ('transmitted-carrier-power-for-cellPortion', 12), ('transmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmission-for-cellPortion', 13), ('upPTS-Interference', 14), ('dLTransmissionBranchLoad', 15), ('hS-DSCH-Required-Power-for-cell-portion', 16), ('hS-DSCH-Provided-Bit-Rate-for-cell-portion', 17), ('e-DCH-Provided-Bit-Rate', 18), ('e-DCH-Non-serving-Relative-Grant-Down-Commands', 19), ('received-Scheduled-EDCH-Power-Share', 20), ('received-Scheduled-EDCH-Power-Share-for-cellPortion', 21), ('uTRAN-GANSS-timing-of-cell-frames-for-UE-Positioning', 22), ('eDCH-RACH-report', 23), ('transmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmission-for-cellPortion', 24), ('ul-timeslot-iscp-for-cellPortion', 25), ('upPTS-Interference-for-cellPortion', 26), ('e-DCH-Provided-Bit-Rate-for-cellPortion', 27)])
    CommonMeasurementType._ext = ['uTRAN-GPS-Timing-of-Cell-Frames-for-UE-Positioning', 'sFN-SFN-Observed-Time-Difference', 'transmittedCarrierPowerOfAllCodesNotUsedForHSTransmission', 'hS-DSCH-Required-Power', 'hS-DSCH-Provided-Bit-Rate', 'received-total-wide-band-power-for-cellPortion', 'transmitted-carrier-power-for-cellPortion', 'transmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmission-for-cellPortion', 'upPTS-Interference', 'dLTransmissionBranchLoad', 'hS-DSCH-Required-Power-for-cell-portion', 'hS-DSCH-Provided-Bit-Rate-for-cell-portion', 'e-DCH-Provided-Bit-Rate', 'e-DCH-Non-serving-Relative-Grant-Down-Commands', 'received-Scheduled-EDCH-Power-Share', 'received-Scheduled-EDCH-Power-Share-for-cellPortion', 'uTRAN-GANSS-timing-of-cell-frames-for-UE-Positioning', 'eDCH-RACH-report', 'transmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmission-for-cellPortion', 'ul-timeslot-iscp-for-cellPortion', 'upPTS-Interference-for-cellPortion', 'e-DCH-Provided-Bit-Rate-for-cellPortion']
    
    #-----< CommonMeasurementValue >-----#
    CommonMeasurementValue = CHOICE(name='CommonMeasurementValue', mode=MODE_TYPE)
    _CommonMeasurementValue_transmitted_carrier_power = INT(name='transmitted-carrier-power', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-Value')))
    _CommonMeasurementValue_received_total_wide_band_power = INT(name='received-total-wide-band-power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')))
    _CommonMeasurementValue_acknowledged_prach_preambles = INT(name='acknowledged-prach-preambles', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Acknowledged-PRACH-preambles-Value')))
    _CommonMeasurementValue_uL_TimeslotISCP = INT(name='uL-TimeslotISCP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-Value')))
    _CommonMeasurementValue_notUsed_1_acknowledged_PCPCH_access_preambles = NULL(name='notUsed-1-acknowledged-PCPCH-access-preambles', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CommonMeasurementValue_notUsed_2_detected_PCPCH_access_preambles = NULL(name='notUsed-2-detected-PCPCH-access-preambles', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CommonMeasurementValue_extension_CommonMeasurementValue = SEQ(name='extension-CommonMeasurementValue', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Extension-CommonMeasurementValue')))
    CommonMeasurementValue._cont = ASN1Dict([
        ('transmitted-carrier-power', _CommonMeasurementValue_transmitted_carrier_power),
        ('received-total-wide-band-power', _CommonMeasurementValue_received_total_wide_band_power),
        ('acknowledged-prach-preambles', _CommonMeasurementValue_acknowledged_prach_preambles),
        ('uL-TimeslotISCP', _CommonMeasurementValue_uL_TimeslotISCP),
        ('notUsed-1-acknowledged-PCPCH-access-preambles', _CommonMeasurementValue_notUsed_1_acknowledged_PCPCH_access_preambles),
        ('notUsed-2-detected-PCPCH-access-preambles', _CommonMeasurementValue_notUsed_2_detected_PCPCH_access_preambles),
        ('extension-CommonMeasurementValue', _CommonMeasurementValue_extension_CommonMeasurementValue),
        ])
    CommonMeasurementValue._ext = ['extension-CommonMeasurementValue']
    
    #-----< Extension-CommonMeasurementValue >-----#
    Extension_CommonMeasurementValue = SEQ(name='Extension-CommonMeasurementValue', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_CommonMeasurementValue_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_CommonMeasurementValue_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGPSMeasurementValueInformation')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFNSFNMeasurementValueInformation')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPower')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRate')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-For-CellPortion-Value')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-For-CellPortion-Value')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterferenceValue')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DLTransmissionBranchLoadValue')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerValueInformation-For-CellPortion')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRateValueInformation-For-CellPortion')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHProvidedBitRate')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_13 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Non-serving-Relative-Grant-Down-Commands')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-Scheduled-EDCH-Power-Share-Value')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGANSSMeasurementValueInformation')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EDCH-RACH-Report-Value')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_18 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-For-CellPortion-ValueLCR')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_19 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-For-CellPortion-ValueLCR')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_20 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_21 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-For-CellPortion-Value')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_22 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_23 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_24 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHProvidedBitRateValueInformation-For-CellPortion')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_25 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterference-For-CellPortion-Value')))
    __Extension_CommonMeasurementValue_id_tab._val = ASN1Set(rv=[dict([('id', 515), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 513), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 587), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 585), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 583), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 619), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 617), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 621), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 622), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_8), ('presence', 'mandatory')]), dict([('id', 653), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_9), ('presence', 'mandatory')]), dict([('id', 661), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_10), ('presence', 'mandatory')]), dict([('id', 662), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_11), ('presence', 'mandatory')]), dict([('id', 684), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_12), ('presence', 'mandatory')]), dict([('id', 708), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_13), ('presence', 'mandatory')]), dict([('id', 789), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_14), ('presence', 'mandatory')]), dict([('id', 790), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_15), ('presence', 'mandatory')]), dict([('id', 891), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_16), ('presence', 'mandatory')]), dict([('id', 1017), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_17), ('presence', 'mandatory')]), dict([('id', 1107), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_18), ('presence', 'mandatory')]), dict([('id', 1108), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_19), ('presence', 'mandatory')]), dict([('id', 1116), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_20), ('presence', 'mandatory')]), dict([('id', 1109), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_21), ('presence', 'mandatory')]), dict([('id', 1110), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_22), ('presence', 'mandatory')]), dict([('id', 1111), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_23), ('presence', 'mandatory')]), dict([('id', 1112), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_24), ('presence', 'mandatory')]), dict([('id', 1113), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_25), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_CommonMeasurementValue_id._const_tab = __Extension_CommonMeasurementValue_id_tab
    _Extension_CommonMeasurementValue_id._const_tab_at = None
    _Extension_CommonMeasurementValue_id._const_tab_id = 'id'
    _Extension_CommonMeasurementValue_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_CommonMeasurementValue_criticality._const_tab = __Extension_CommonMeasurementValue_id_tab
    _Extension_CommonMeasurementValue_criticality._const_tab_at = ('..', 'id')
    _Extension_CommonMeasurementValue_criticality._const_tab_id = 'criticality'
    _Extension_CommonMeasurementValue_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_CommonMeasurementValue_value._const_tab = __Extension_CommonMeasurementValue_id_tab
    _Extension_CommonMeasurementValue_value._const_tab_at = ('..', 'id')
    _Extension_CommonMeasurementValue_value._const_tab_id = 'Value'
    Extension_CommonMeasurementValue._cont = ASN1Dict([
        ('id', _Extension_CommonMeasurementValue_id),
        ('criticality', _Extension_CommonMeasurementValue_criticality),
        ('value', _Extension_CommonMeasurementValue_value),
        ])
    Extension_CommonMeasurementValue._ext = None
    
    #-----< Extension-CommonMeasurementValueIE >-----#
    Extension_CommonMeasurementValueIE = CLASS(name='Extension-CommonMeasurementValueIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_CommonMeasurementValueIE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGPSMeasurementValueInformation')))
    _Extension_CommonMeasurementValueIE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFNSFNMeasurementValueInformation')))
    _Extension_CommonMeasurementValueIE_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    _Extension_CommonMeasurementValueIE_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPower')))
    _Extension_CommonMeasurementValueIE_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRate')))
    _Extension_CommonMeasurementValueIE_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-For-CellPortion-Value')))
    _Extension_CommonMeasurementValueIE_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-For-CellPortion-Value')))
    _Extension_CommonMeasurementValueIE_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue')))
    _Extension_CommonMeasurementValueIE_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterferenceValue')))
    _Extension_CommonMeasurementValueIE_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DLTransmissionBranchLoadValue')))
    _Extension_CommonMeasurementValueIE_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerValueInformation-For-CellPortion')))
    _Extension_CommonMeasurementValueIE_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRateValueInformation-For-CellPortion')))
    _Extension_CommonMeasurementValueIE_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHProvidedBitRate')))
    _Extension_CommonMeasurementValueIE_val_Value_13 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Non-serving-Relative-Grant-Down-Commands')))
    _Extension_CommonMeasurementValueIE_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-Scheduled-EDCH-Power-Share-Value')))
    _Extension_CommonMeasurementValueIE_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value')))
    _Extension_CommonMeasurementValueIE_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGANSSMeasurementValueInformation')))
    _Extension_CommonMeasurementValueIE_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EDCH-RACH-Report-Value')))
    _Extension_CommonMeasurementValueIE_val_Value_18 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-For-CellPortion-ValueLCR')))
    _Extension_CommonMeasurementValueIE_val_Value_19 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-For-CellPortion-ValueLCR')))
    _Extension_CommonMeasurementValueIE_val_Value_20 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue')))
    _Extension_CommonMeasurementValueIE_val_Value_21 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-For-CellPortion-Value')))
    _Extension_CommonMeasurementValueIE_val_Value_22 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR')))
    _Extension_CommonMeasurementValueIE_val_Value_23 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR')))
    _Extension_CommonMeasurementValueIE_val_Value_24 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHProvidedBitRateValueInformation-For-CellPortion')))
    _Extension_CommonMeasurementValueIE_val_Value_25 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterference-For-CellPortion-Value')))
    Extension_CommonMeasurementValueIE._val = ASN1Set(rv=[dict([('id', 515), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 513), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_1), ('presence', 'mandatory')]), dict([('id', 587), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_2), ('presence', 'mandatory')]), dict([('id', 585), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_3), ('presence', 'mandatory')]), dict([('id', 583), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_4), ('presence', 'mandatory')]), dict([('id', 619), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_5), ('presence', 'mandatory')]), dict([('id', 617), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_6), ('presence', 'mandatory')]), dict([('id', 621), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_7), ('presence', 'mandatory')]), dict([('id', 622), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_8), ('presence', 'mandatory')]), dict([('id', 653), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_9), ('presence', 'mandatory')]), dict([('id', 661), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_10), ('presence', 'mandatory')]), dict([('id', 662), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_11), ('presence', 'mandatory')]), dict([('id', 684), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_12), ('presence', 'mandatory')]), dict([('id', 708), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_13), ('presence', 'mandatory')]), dict([('id', 789), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_14), ('presence', 'mandatory')]), dict([('id', 790), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_15), ('presence', 'mandatory')]), dict([('id', 891), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_16), ('presence', 'mandatory')]), dict([('id', 1017), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_17), ('presence', 'mandatory')]), dict([('id', 1107), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_18), ('presence', 'mandatory')]), dict([('id', 1108), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_19), ('presence', 'mandatory')]), dict([('id', 1116), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_20), ('presence', 'mandatory')]), dict([('id', 1109), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_21), ('presence', 'mandatory')]), dict([('id', 1110), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_22), ('presence', 'mandatory')]), dict([('id', 1111), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_23), ('presence', 'mandatory')]), dict([('id', 1112), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_24), ('presence', 'mandatory')]), dict([('id', 1113), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementValueIE_val_Value_25), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CommonMeasurementValueInformation >-----#
    CommonMeasurementValueInformation = CHOICE(name='CommonMeasurementValueInformation', mode=MODE_TYPE)
    _CommonMeasurementValueInformation_measurementAvailable = SEQ(name='measurementAvailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementAvailable')))
    _CommonMeasurementValueInformation_measurementnotAvailable = NULL(name='measurementnotAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementnotAvailable')))
    CommonMeasurementValueInformation._cont = ASN1Dict([
        ('measurementAvailable', _CommonMeasurementValueInformation_measurementAvailable),
        ('measurementnotAvailable', _CommonMeasurementValueInformation_measurementnotAvailable),
        ])
    CommonMeasurementValueInformation._ext = None
    
    #-----< CommonMeasurementAvailable >-----#
    CommonMeasurementAvailable = SEQ(name='CommonMeasurementAvailable', mode=MODE_TYPE)
    _CommonMeasurementAvailable_commonmeasurementValue = CHOICE(name='commonmeasurementValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementValue')))
    _CommonMeasurementAvailable_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementAvailable_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementAvailable_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonMeasurementAvailable_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementAvailable_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementAvailable_ie_Extensions__item__id._const_tab = ____CommonMeasurementAvailable_ie_Extensions__item__id_tab
    ___CommonMeasurementAvailable_ie_Extensions__item__id._const_tab_at = None
    ___CommonMeasurementAvailable_ie_Extensions__item__id._const_tab_id = 'id'
    ___CommonMeasurementAvailable_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonMeasurementAvailable_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementAvailable_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementAvailable_ie_Extensions__item__criticality._const_tab = ____CommonMeasurementAvailable_ie_Extensions__item__criticality_tab
    ___CommonMeasurementAvailable_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementAvailable_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementAvailable_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonMeasurementAvailable_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementAvailable_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementAvailable_ie_Extensions__item__extensionValue._const_tab = ____CommonMeasurementAvailable_ie_Extensions__item__extensionValue_tab
    ___CommonMeasurementAvailable_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonMeasurementAvailable_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonMeasurementAvailable_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementAvailable_ie_Extensions__item__id),
        ('criticality', ___CommonMeasurementAvailable_ie_Extensions__item__criticality),
        ('extensionValue', ___CommonMeasurementAvailable_ie_Extensions__item__extensionValue),
        ])
    __CommonMeasurementAvailable_ie_Extensions__item_._ext = None
    _CommonMeasurementAvailable_ie_Extensions._cont = __CommonMeasurementAvailable_ie_Extensions__item_
    _CommonMeasurementAvailable_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementAvailable._cont = ASN1Dict([
        ('commonmeasurementValue', _CommonMeasurementAvailable_commonmeasurementValue),
        ('ie-Extensions', _CommonMeasurementAvailable_ie_Extensions),
        ])
    CommonMeasurementAvailable._ext = []
    
    #-----< CommonMeasurementAvailableItem-ExtIEs >-----#
    CommonMeasurementAvailableItem_ExtIEs = CLASS(name='CommonMeasurementAvailableItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonMeasurementAvailableItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementnotAvailable >-----#
    CommonMeasurementnotAvailable = NULL(name='CommonMeasurementnotAvailable', mode=MODE_TYPE)
    
    #-----< CommonPhysicalChannelID >-----#
    CommonPhysicalChannelID = INT(name='CommonPhysicalChannelID', mode=MODE_TYPE)
    CommonPhysicalChannelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< CommonPhysicalChannelID768 >-----#
    CommonPhysicalChannelID768 = INT(name='CommonPhysicalChannelID768', mode=MODE_TYPE)
    CommonPhysicalChannelID768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< Common-PhysicalChannel-Status-Information >-----#
    Common_PhysicalChannel_Status_Information = SEQ(name='Common-PhysicalChannel-Status-Information', mode=MODE_TYPE)
    _Common_PhysicalChannel_Status_Information_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _Common_PhysicalChannel_Status_Information_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _Common_PhysicalChannel_Status_Information_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _Common_PhysicalChannel_Status_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_PhysicalChannel_Status_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__id._const_tab = ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__id_tab
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__id._const_tab_at = None
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__criticality._const_tab = ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__criticality_tab
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__extensionValue._const_tab = ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__extensionValue_tab
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_PhysicalChannel_Status_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__id),
        ('criticality', ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__extensionValue),
        ])
    __Common_PhysicalChannel_Status_Information_iE_Extensions__item_._ext = None
    _Common_PhysicalChannel_Status_Information_iE_Extensions._cont = __Common_PhysicalChannel_Status_Information_iE_Extensions__item_
    _Common_PhysicalChannel_Status_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_PhysicalChannel_Status_Information._cont = ASN1Dict([
        ('commonPhysicalChannelID', _Common_PhysicalChannel_Status_Information_commonPhysicalChannelID),
        ('resourceOperationalState', _Common_PhysicalChannel_Status_Information_resourceOperationalState),
        ('availabilityStatus', _Common_PhysicalChannel_Status_Information_availabilityStatus),
        ('iE-Extensions', _Common_PhysicalChannel_Status_Information_iE_Extensions),
        ])
    Common_PhysicalChannel_Status_Information._ext = []
    
    #-----< Common-PhysicalChannel-Status-Information-ExtIEs >-----#
    Common_PhysicalChannel_Status_Information_ExtIEs = CLASS(name='Common-PhysicalChannel-Status-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_PhysicalChannel_Status_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-PhysicalChannel-Status-Information768 >-----#
    Common_PhysicalChannel_Status_Information768 = SEQ(name='Common-PhysicalChannel-Status-Information768', mode=MODE_TYPE)
    _Common_PhysicalChannel_Status_Information768_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _Common_PhysicalChannel_Status_Information768_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _Common_PhysicalChannel_Status_Information768_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _Common_PhysicalChannel_Status_Information768_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_PhysicalChannel_Status_Information768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__id._const_tab = ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__id_tab
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__id._const_tab_at = None
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__criticality._const_tab = ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__criticality_tab
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__extensionValue._const_tab = ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__extensionValue_tab
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_PhysicalChannel_Status_Information768_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__id),
        ('criticality', ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__extensionValue),
        ])
    __Common_PhysicalChannel_Status_Information768_iE_Extensions__item_._ext = None
    _Common_PhysicalChannel_Status_Information768_iE_Extensions._cont = __Common_PhysicalChannel_Status_Information768_iE_Extensions__item_
    _Common_PhysicalChannel_Status_Information768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_PhysicalChannel_Status_Information768._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _Common_PhysicalChannel_Status_Information768_commonPhysicalChannelID768),
        ('resourceOperationalState', _Common_PhysicalChannel_Status_Information768_resourceOperationalState),
        ('availabilityStatus', _Common_PhysicalChannel_Status_Information768_availabilityStatus),
        ('iE-Extensions', _Common_PhysicalChannel_Status_Information768_iE_Extensions),
        ])
    Common_PhysicalChannel_Status_Information768._ext = []
    
    #-----< Common-PhysicalChannel-Status-Information768-ExtIEs >-----#
    Common_PhysicalChannel_Status_Information768_ExtIEs = CLASS(name='Common-PhysicalChannel-Status-Information768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_PhysicalChannel_Status_Information768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelID >-----#
    CommonTransportChannelID = INT(name='CommonTransportChannelID', mode=MODE_TYPE)
    CommonTransportChannelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< CommonTransportChannel-InformationResponse >-----#
    CommonTransportChannel_InformationResponse = SEQ(name='CommonTransportChannel-InformationResponse', mode=MODE_TYPE)
    _CommonTransportChannel_InformationResponse_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _CommonTransportChannel_InformationResponse_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _CommonTransportChannel_InformationResponse_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _CommonTransportChannel_InformationResponse_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannel_InformationResponse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BroadcastCommonTransportBearerIndication')))
    _____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IPMulticastDataBearerIndication')))
    ____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 830), ('criticality', 'ignore'), ('Extension', _____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 909), ('criticality', 'ignore'), ('Extension', _____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__id._const_tab = ____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__id._const_tab_at = None
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__id._const_tab_id = 'id'
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__criticality._const_tab = ____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__extensionValue._const_tab = ____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonTransportChannel_InformationResponse_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonTransportChannel_InformationResponse_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannel_InformationResponse_iE_Extensions__item__id),
        ('criticality', ___CommonTransportChannel_InformationResponse_iE_Extensions__item__criticality),
        ('extensionValue', ___CommonTransportChannel_InformationResponse_iE_Extensions__item__extensionValue),
        ])
    __CommonTransportChannel_InformationResponse_iE_Extensions__item_._ext = None
    _CommonTransportChannel_InformationResponse_iE_Extensions._cont = __CommonTransportChannel_InformationResponse_iE_Extensions__item_
    _CommonTransportChannel_InformationResponse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannel_InformationResponse._cont = ASN1Dict([
        ('commonTransportChannelID', _CommonTransportChannel_InformationResponse_commonTransportChannelID),
        ('bindingID', _CommonTransportChannel_InformationResponse_bindingID),
        ('transportLayerAddress', _CommonTransportChannel_InformationResponse_transportLayerAddress),
        ('iE-Extensions', _CommonTransportChannel_InformationResponse_iE_Extensions),
        ])
    CommonTransportChannel_InformationResponse._ext = []
    
    #-----< CommonTransportChannel-InformationResponse-ExtIEs >-----#
    CommonTransportChannel_InformationResponse_ExtIEs = CLASS(name='CommonTransportChannel-InformationResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CommonTransportChannel_InformationResponse_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BroadcastCommonTransportBearerIndication')))
    _CommonTransportChannel_InformationResponse_ExtIEs_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IPMulticastDataBearerIndication')))
    CommonTransportChannel_InformationResponse_ExtIEs._val = ASN1Set(rv=[dict([('id', 830), ('criticality', 'ignore'), ('Extension', _CommonTransportChannel_InformationResponse_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 909), ('criticality', 'ignore'), ('Extension', _CommonTransportChannel_InformationResponse_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Common-TransportChannel-Status-Information >-----#
    Common_TransportChannel_Status_Information = SEQ(name='Common-TransportChannel-Status-Information', mode=MODE_TYPE)
    _Common_TransportChannel_Status_Information_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _Common_TransportChannel_Status_Information_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _Common_TransportChannel_Status_Information_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _Common_TransportChannel_Status_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_TransportChannel_Status_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_TransportChannel_Status_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_TransportChannel_Status_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__id._const_tab = ____Common_TransportChannel_Status_Information_iE_Extensions__item__id_tab
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__id._const_tab_at = None
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_TransportChannel_Status_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_TransportChannel_Status_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__criticality._const_tab = ____Common_TransportChannel_Status_Information_iE_Extensions__item__criticality_tab
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_TransportChannel_Status_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_TransportChannel_Status_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__extensionValue._const_tab = ____Common_TransportChannel_Status_Information_iE_Extensions__item__extensionValue_tab
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_TransportChannel_Status_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_TransportChannel_Status_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_TransportChannel_Status_Information_iE_Extensions__item__id),
        ('criticality', ___Common_TransportChannel_Status_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_TransportChannel_Status_Information_iE_Extensions__item__extensionValue),
        ])
    __Common_TransportChannel_Status_Information_iE_Extensions__item_._ext = None
    _Common_TransportChannel_Status_Information_iE_Extensions._cont = __Common_TransportChannel_Status_Information_iE_Extensions__item_
    _Common_TransportChannel_Status_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_TransportChannel_Status_Information._cont = ASN1Dict([
        ('commonTransportChannelID', _Common_TransportChannel_Status_Information_commonTransportChannelID),
        ('resourceOperationalState', _Common_TransportChannel_Status_Information_resourceOperationalState),
        ('availabilityStatus', _Common_TransportChannel_Status_Information_availabilityStatus),
        ('iE-Extensions', _Common_TransportChannel_Status_Information_iE_Extensions),
        ])
    Common_TransportChannel_Status_Information._ext = []
    
    #-----< Common-TransportChannel-Status-Information-ExtIEs >-----#
    Common_TransportChannel_Status_Information_ExtIEs = CLASS(name='Common-TransportChannel-Status-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_TransportChannel_Status_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommunicationControlPortID >-----#
    CommunicationControlPortID = INT(name='CommunicationControlPortID', mode=MODE_TYPE)
    CommunicationControlPortID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< CompleteAlmanacProvided >-----#
    CompleteAlmanacProvided = BOOL(name='CompleteAlmanacProvided', mode=MODE_TYPE)
    
    #-----< Compressed-Mode-Deactivation-Flag >-----#
    Compressed_Mode_Deactivation_Flag = ENUM(name='Compressed-Mode-Deactivation-Flag', mode=MODE_TYPE)
    Compressed_Mode_Deactivation_Flag._cont = ASN1Dict([('deactivate', 0), ('maintain-Active', 1)])
    Compressed_Mode_Deactivation_Flag._ext = None
    
    #-----< ConfigurationGenerationID >-----#
    ConfigurationGenerationID = INT(name='ConfigurationGenerationID', mode=MODE_TYPE)
    ConfigurationGenerationID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ConstantValue >-----#
    ConstantValue = INT(name='ConstantValue', mode=MODE_TYPE)
    ConstantValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-10, ub=10)], ev=[], er=[])
    
    #-----< ContinuousPacketConnectivityDTX-DRX-Capability >-----#
    ContinuousPacketConnectivityDTX_DRX_Capability = ENUM(name='ContinuousPacketConnectivityDTX-DRX-Capability', mode=MODE_TYPE)
    ContinuousPacketConnectivityDTX_DRX_Capability._cont = ASN1Dict([('continuous-Packet-Connectivity-DTX-DRX-capable', 0), ('continuous-Packet-Connectivity-DTX-DRX-non-capable', 1)])
    ContinuousPacketConnectivityDTX_DRX_Capability._ext = None
    
    #-----< ContinuousPacketConnectivityDTX-DRX-Information >-----#
    ContinuousPacketConnectivityDTX_DRX_Information = SEQ(name='ContinuousPacketConnectivityDTX-DRX-Information', mode=MODE_TYPE)
    _ContinuousPacketConnectivityDTX_DRX_Information_uE_DTX_DRX_Offset = INT(name='uE-DTX-DRX-Offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-DRX-Offset')))
    _ContinuousPacketConnectivityDTX_DRX_Information_enabling_Delay = ENUM(name='enabling-Delay', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Enabling-Delay')))
    _ContinuousPacketConnectivityDTX_DRX_Information_dTX_Information = SEQ(name='dTX-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DTX-Information')))
    _ContinuousPacketConnectivityDTX_DRX_Information_dRX_Information = SEQ(name='dRX-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DRX-Information')), opt=True)
    _ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__id._const_tab = ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__id._const_tab_at = None
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__criticality._const_tab = ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__criticality_tab
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__extensionValue._const_tab = ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__extensionValue_tab
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__id),
        ('criticality', ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__extensionValue),
        ])
    __ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item_._ext = None
    _ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions._cont = __ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item_
    _ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContinuousPacketConnectivityDTX_DRX_Information._cont = ASN1Dict([
        ('uE-DTX-DRX-Offset', _ContinuousPacketConnectivityDTX_DRX_Information_uE_DTX_DRX_Offset),
        ('enabling-Delay', _ContinuousPacketConnectivityDTX_DRX_Information_enabling_Delay),
        ('dTX-Information', _ContinuousPacketConnectivityDTX_DRX_Information_dTX_Information),
        ('dRX-Information', _ContinuousPacketConnectivityDTX_DRX_Information_dRX_Information),
        ('iE-Extensions', _ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions),
        ])
    ContinuousPacketConnectivityDTX_DRX_Information._ext = []
    
    #-----< ContinuousPacketConnectivityDTX-DRX-Information-ExtIEs >-----#
    ContinuousPacketConnectivityDTX_DRX_Information_ExtIEs = CLASS(name='ContinuousPacketConnectivityDTX-DRX-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ContinuousPacketConnectivityDTX_DRX_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContinuousPacketConnectivityDTX-DRX-Information-to-Modify >-----#
    ContinuousPacketConnectivityDTX_DRX_Information_to_Modify = SEQ(name='ContinuousPacketConnectivityDTX-DRX-Information-to-Modify', mode=MODE_TYPE)
    _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_uE_DTX_DRX_Offset = INT(name='uE-DTX-DRX-Offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-DRX-Offset')), opt=True)
    _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_enabling_Delay = ENUM(name='enabling-Delay', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Enabling-Delay')), opt=True)
    _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_dTX_Information_to_Modify = CHOICE(name='dTX-Information-to-Modify', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DTX-Information-to-Modify')), opt=True)
    _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_dRX_Information_to_Modify = CHOICE(name='dRX-Information-to-Modify', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DRX-Information-to-Modify')), opt=True)
    _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__id._const_tab = ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__criticality._const_tab = ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__criticality_tab
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue_tab
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__id),
        ('criticality', ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item_._ext = None
    _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions._cont = __ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item_
    _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContinuousPacketConnectivityDTX_DRX_Information_to_Modify._cont = ASN1Dict([
        ('uE-DTX-DRX-Offset', _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_uE_DTX_DRX_Offset),
        ('enabling-Delay', _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_enabling_Delay),
        ('dTX-Information-to-Modify', _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_dTX_Information_to_Modify),
        ('dRX-Information-to-Modify', _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_dRX_Information_to_Modify),
        ('iE-Extensions', _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions),
        ])
    ContinuousPacketConnectivityDTX_DRX_Information_to_Modify._ext = []
    
    #-----< ContinuousPacketConnectivityDTX-DRX-Information-to-Modify-ExtIEs >-----#
    ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_ExtIEs = CLASS(name='ContinuousPacketConnectivityDTX-DRX-Information-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContinuousPacketConnectivityHS-SCCH-less-Capability >-----#
    ContinuousPacketConnectivityHS_SCCH_less_Capability = ENUM(name='ContinuousPacketConnectivityHS-SCCH-less-Capability', mode=MODE_TYPE)
    ContinuousPacketConnectivityHS_SCCH_less_Capability._cont = ASN1Dict([('continuous-Packet-Connectivity-HS-SCCH-less-capable', 0), ('continuous-Packet-Connectivity-HS-SCCH-less-capable-non-capable', 1)])
    ContinuousPacketConnectivityHS_SCCH_less_Capability._ext = None
    
    #-----< ContinuousPacketConnectivityHS-SCCH-less-Information >-----#
    ContinuousPacketConnectivityHS_SCCH_less_Information = SEQ_OF(name='ContinuousPacketConnectivityHS-SCCH-less-Information', mode=MODE_TYPE)
    _ContinuousPacketConnectivityHS_SCCH_less_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-InformationItem')))
    ContinuousPacketConnectivityHS_SCCH_less_Information._cont = _ContinuousPacketConnectivityHS_SCCH_less_Information__item_
    ContinuousPacketConnectivityHS_SCCH_less_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< ContinuousPacketConnectivityHS-SCCH-less-InformationItem >-----#
    ContinuousPacketConnectivityHS_SCCH_less_InformationItem = SEQ(name='ContinuousPacketConnectivityHS-SCCH-less-InformationItem', mode=MODE_TYPE)
    _ContinuousPacketConnectivityHS_SCCH_less_InformationItem_transport_Block_Size_Index = INT(name='transport-Block-Size-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transport-Block-Size-Index')))
    _ContinuousPacketConnectivityHS_SCCH_less_InformationItem_hSPDSCH_Second_Code_Support = BOOL(name='hSPDSCH-Second-Code-Support', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSPDSCH-Second-Code-Support')))
    _ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__id._const_tab = ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__criticality._const_tab = ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__criticality_tab
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__extensionValue_tab
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__id),
        ('criticality', ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item_._ext = None
    _ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions._cont = __ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item_
    _ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContinuousPacketConnectivityHS_SCCH_less_InformationItem._cont = ASN1Dict([
        ('transport-Block-Size-Index', _ContinuousPacketConnectivityHS_SCCH_less_InformationItem_transport_Block_Size_Index),
        ('hSPDSCH-Second-Code-Support', _ContinuousPacketConnectivityHS_SCCH_less_InformationItem_hSPDSCH_Second_Code_Support),
        ('iE-Extensions', _ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions),
        ])
    ContinuousPacketConnectivityHS_SCCH_less_InformationItem._ext = []
    
    #-----< ContinuousPacketConnectivityHS-SCCH-less-Information-ExtIEs >-----#
    ContinuousPacketConnectivityHS_SCCH_less_Information_ExtIEs = CLASS(name='ContinuousPacketConnectivityHS-SCCH-less-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ContinuousPacketConnectivityHS_SCCH_less_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContinuousPacketConnectivityHS-SCCH-less-Information-Response >-----#
    ContinuousPacketConnectivityHS_SCCH_less_Information_Response = SEQ(name='ContinuousPacketConnectivityHS-SCCH-less-Information-Response', mode=MODE_TYPE)
    _ContinuousPacketConnectivityHS_SCCH_less_Information_Response_hSPDSCH_First_Code_Index = INT(name='hSPDSCH-First-Code-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSPDSCH-First-Code-Index')))
    _ContinuousPacketConnectivityHS_SCCH_less_Information_Response_hSPDSCH_Second_Code_Index = INT(name='hSPDSCH-Second-Code-Index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSPDSCH-Second-Code-Index')), opt=True)
    _ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__id._const_tab = ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__criticality._const_tab = ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__criticality_tab
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__extensionValue_tab
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__id),
        ('criticality', ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item_._ext = None
    _ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions._cont = __ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item_
    _ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContinuousPacketConnectivityHS_SCCH_less_Information_Response._cont = ASN1Dict([
        ('hSPDSCH-First-Code-Index', _ContinuousPacketConnectivityHS_SCCH_less_Information_Response_hSPDSCH_First_Code_Index),
        ('hSPDSCH-Second-Code-Index', _ContinuousPacketConnectivityHS_SCCH_less_Information_Response_hSPDSCH_Second_Code_Index),
        ('iE-Extensions', _ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions),
        ])
    ContinuousPacketConnectivityHS_SCCH_less_Information_Response._ext = []
    
    #-----< ContinuousPacketConnectivityHS-SCCH-less-Information-Response-ExtIEs >-----#
    ContinuousPacketConnectivityHS_SCCH_less_Information_Response_ExtIEs = CLASS(name='ContinuousPacketConnectivityHS-SCCH-less-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ContinuousPacketConnectivityHS_SCCH_less_Information_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ControlGAP >-----#
    ControlGAP = INT(name='ControlGAP', mode=MODE_TYPE)
    ControlGAP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< CPC-Information >-----#
    CPC_Information = SEQ(name='CPC-Information', mode=MODE_TYPE)
    _CPC_Information_continuousPacketConnectivityDTX_DRX_Information = SEQ(name='continuousPacketConnectivityDTX-DRX-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Information')), opt=True)
    _CPC_Information_continuousPacketConnectivityDTX_DRX_Information_to_Modify = SEQ(name='continuousPacketConnectivityDTX-DRX-Information-to-Modify', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Information-to-Modify')), opt=True)
    _CPC_Information_continuousPacketConnectivityHS_SCCH_less_Information = SEQ_OF(name='continuousPacketConnectivityHS-SCCH-less-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information')), opt=True)
    _CPC_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPC_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CPC_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CPC_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CPC_Information_iE_Extensions__item__id_tab_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Deactivate-Indicator')))
    ____CPC_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 958), ('criticality', 'reject'), ('Extension', _____CPC_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CPC_Information_iE_Extensions__item__id._const_tab = ____CPC_Information_iE_Extensions__item__id_tab
    ___CPC_Information_iE_Extensions__item__id._const_tab_at = None
    ___CPC_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPC_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CPC_Information_iE_Extensions__item__criticality._const_tab = ____CPC_Information_iE_Extensions__item__id_tab
    ___CPC_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPC_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPC_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CPC_Information_iE_Extensions__item__extensionValue._const_tab = ____CPC_Information_iE_Extensions__item__id_tab
    ___CPC_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPC_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPC_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPC_Information_iE_Extensions__item__id),
        ('criticality', ___CPC_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___CPC_Information_iE_Extensions__item__extensionValue),
        ])
    __CPC_Information_iE_Extensions__item_._ext = None
    _CPC_Information_iE_Extensions._cont = __CPC_Information_iE_Extensions__item_
    _CPC_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPC_Information._cont = ASN1Dict([
        ('continuousPacketConnectivityDTX-DRX-Information', _CPC_Information_continuousPacketConnectivityDTX_DRX_Information),
        ('continuousPacketConnectivityDTX-DRX-Information-to-Modify', _CPC_Information_continuousPacketConnectivityDTX_DRX_Information_to_Modify),
        ('continuousPacketConnectivityHS-SCCH-less-Information', _CPC_Information_continuousPacketConnectivityHS_SCCH_less_Information),
        ('iE-Extensions', _CPC_Information_iE_Extensions),
        ])
    CPC_Information._ext = []
    
    #-----< CPC-Information-ExtIEs >-----#
    CPC_Information_ExtIEs = CLASS(name='CPC-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CPC_Information_ExtIEs_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Deactivate-Indicator')))
    CPC_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 958), ('criticality', 'reject'), ('Extension', _CPC_Information_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CPC-RecoveryReport >-----#
    CPC_RecoveryReport = ENUM(name='CPC-RecoveryReport', mode=MODE_TYPE)
    CPC_RecoveryReport._cont = ASN1Dict([('initiated', 0)])
    CPC_RecoveryReport._ext = []
    
    #-----< ContinuousPacketConnectivityHS-SCCH-less-Deactivate-Indicator >-----#
    ContinuousPacketConnectivityHS_SCCH_less_Deactivate_Indicator = NULL(name='ContinuousPacketConnectivityHS-SCCH-less-Deactivate-Indicator', mode=MODE_TYPE)
    
    #-----< CQI-DTX-Timer >-----#
    CQI_DTX_Timer = ENUM(name='CQI-DTX-Timer', mode=MODE_TYPE)
    CQI_DTX_Timer._cont = ASN1Dict([('v0', 0), ('v1', 1), ('v2', 2), ('v4', 3), ('v8', 4), ('v16', 5), ('v32', 6), ('v64', 7), ('v128', 8), ('v256', 9), ('v512', 10), ('infinity', 11)])
    CQI_DTX_Timer._ext = None
    
    #-----< CQI-Cycle-Switch-Timer >-----#
    CQI_Cycle_Switch_Timer = ENUM(name='CQI-Cycle-Switch-Timer', mode=MODE_TYPE)
    CQI_Cycle_Switch_Timer._cont = ASN1Dict([('v4', 0), ('v8', 1), ('v16', 2), ('v32', 3), ('v64', 4), ('v128', 5), ('v256', 6), ('v512', 7), ('infinity', 8)])
    CQI_Cycle_Switch_Timer._ext = None
    
    #-----< CQI-Feedback-Cycle >-----#
    CQI_Feedback_Cycle = ENUM(name='CQI-Feedback-Cycle', mode=MODE_TYPE)
    CQI_Feedback_Cycle._cont = ASN1Dict([('v0', 0), ('v2', 1), ('v4', 2), ('v8', 3), ('v10', 4), ('v20', 5), ('v40', 6), ('v80', 7), ('v160', 8), ('v16', 9), ('v32', 10), ('v64', 11)])
    CQI_Feedback_Cycle._ext = ['v16', 'v32', 'v64']
    
    #-----< CQI-Feedback-Cycle2 >-----#
    CQI_Feedback_Cycle2 = ENUM(name='CQI-Feedback-Cycle2', mode=MODE_TYPE)
    CQI_Feedback_Cycle2._cont = ASN1Dict([('v0', 0), ('v8', 1), ('v10', 2), ('v16', 3), ('v20', 4), ('v32', 5), ('v40', 6), ('v64', 7), ('v80', 8), ('v160', 9)])
    CQI_Feedback_Cycle2._ext = []
    
    #-----< CQI-Power-Offset >-----#
    CQI_Power_Offset = INT(name='CQI-Power-Offset', mode=MODE_TYPE)
    CQI_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=[], er=[ASN1RangeInt(lb=9, ub=10)])
    
    #-----< CQI-RepetitionFactor >-----#
    CQI_RepetitionFactor = INT(name='CQI-RepetitionFactor', mode=MODE_TYPE)
    CQI_RepetitionFactor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[])
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureID = SEQ(name='procedureID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureID')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_transactionID = CHOICE(name='transactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'TransactionID')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureID', _CriticalityDiagnostics_procedureID),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('transactionID', _CriticalityDiagnostics_transactionID),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__repetitionNumber = INT(name='repetitionNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionNumber0')), opt=True)
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MessageStructure')))
    ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TypeOfError')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 115), ('criticality', 'ignore'), ('Extension', ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 508), ('criticality', 'ignore'), ('Extension', ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        ('criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        ('iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        ('iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        ('repetitionNumber', __CriticalityDiagnostics_IE_List__item__repetitionNumber),
        ('iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MessageStructure')))
    _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TypeOfError')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[dict([('id', 115), ('criticality', 'ignore'), ('Extension', _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 508), ('criticality', 'ignore'), ('Extension', _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CRNC-CommunicationContextID >-----#
    CRNC_CommunicationContextID = INT(name='CRNC-CommunicationContextID', mode=MODE_TYPE)
    CRNC_CommunicationContextID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< CSBMeasurementID >-----#
    CSBMeasurementID = INT(name='CSBMeasurementID', mode=MODE_TYPE)
    CSBMeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< CSBTransmissionID >-----#
    CSBTransmissionID = INT(name='CSBTransmissionID', mode=MODE_TYPE)
    CSBTransmissionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< Common-EDCH-System-InformationLCR >-----#
    Common_EDCH_System_InformationLCR = SEQ(name='Common-EDCH-System-InformationLCR', mode=MODE_TYPE)
    _Common_EDCH_System_InformationLCR_ul_common_E_DCH_MACflow_Specific_InformationLCR = SEQ_OF(name='ul-common-E-DCH-MACflow-Specific-InformationLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoListLCR')), opt=True)
    _Common_EDCH_System_InformationLCR_common_E_PUCH_InformationLCR = SEQ(name='common-E-PUCH-InformationLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-PUCH-InformationLCR')), opt=True)
    _Common_EDCH_System_InformationLCR_e_TFCS_Information_TDD = SEQ(name='e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information-TDD')), opt=True)
    _Common_EDCH_System_InformationLCR_maximum_Number_of_Retransmissions_For_SchedulingInfo = INT(name='maximum-Number-of-Retransmissions-For-SchedulingInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Number-of-Retransmissions-For-E-DCH')), opt=True)
    _Common_EDCH_System_InformationLCR_eDCH_Retransmission_Timer_SchedulingInfo = ENUM(name='eDCH-Retransmission-Timer-SchedulingInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer')), opt=True)
    _Common_EDCH_System_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_EDCH_System_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PhysicalChannelID-for-CommonERNTI-RequestedIndicator')))
    _____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoListLCR-Ext')))
    ____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1147), ('criticality', 'reject'), ('Extension', _____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1170), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1178), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__id._const_tab = ____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__criticality._const_tab = ____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_EDCH_System_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_EDCH_System_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_EDCH_System_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___Common_EDCH_System_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_EDCH_System_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __Common_EDCH_System_InformationLCR_iE_Extensions__item_._ext = None
    _Common_EDCH_System_InformationLCR_iE_Extensions._cont = __Common_EDCH_System_InformationLCR_iE_Extensions__item_
    _Common_EDCH_System_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_EDCH_System_InformationLCR._cont = ASN1Dict([
        ('ul-common-E-DCH-MACflow-Specific-InformationLCR', _Common_EDCH_System_InformationLCR_ul_common_E_DCH_MACflow_Specific_InformationLCR),
        ('common-E-PUCH-InformationLCR', _Common_EDCH_System_InformationLCR_common_E_PUCH_InformationLCR),
        ('e-TFCS-Information-TDD', _Common_EDCH_System_InformationLCR_e_TFCS_Information_TDD),
        ('maximum-Number-of-Retransmissions-For-SchedulingInfo', _Common_EDCH_System_InformationLCR_maximum_Number_of_Retransmissions_For_SchedulingInfo),
        ('eDCH-Retransmission-Timer-SchedulingInfo', _Common_EDCH_System_InformationLCR_eDCH_Retransmission_Timer_SchedulingInfo),
        ('iE-Extensions', _Common_EDCH_System_InformationLCR_iE_Extensions),
        ])
    Common_EDCH_System_InformationLCR._ext = []
    
    #-----< Common-EDCH-System-InformationLCR-ExtIEs >-----#
    Common_EDCH_System_InformationLCR_ExtIEs = CLASS(name='Common-EDCH-System-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Common_EDCH_System_InformationLCR_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _Common_EDCH_System_InformationLCR_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PhysicalChannelID-for-CommonERNTI-RequestedIndicator')))
    _Common_EDCH_System_InformationLCR_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoListLCR-Ext')))
    Common_EDCH_System_InformationLCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1147), ('criticality', 'reject'), ('Extension', _Common_EDCH_System_InformationLCR_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1170), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationLCR_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1178), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_InformationLCR_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Common-E-PUCH-InformationLCR >-----#
    Common_E_PUCH_InformationLCR = SEQ(name='Common-E-PUCH-InformationLCR', mode=MODE_TYPE)
    _Common_E_PUCH_InformationLCR_minCR = INT(name='minCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CodeRate')))
    _Common_E_PUCH_InformationLCR_maxCR = INT(name='maxCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CodeRate')))
    _Common_E_PUCH_InformationLCR_harqInfo = ENUM(name='harqInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Info-for-E-DCH')))
    _Common_E_PUCH_InformationLCR_pRXdes_base_perURAFCN = SEQ_OF(name='pRXdes-base-perURAFCN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PRXdes-base-perURAFCN')), opt=True)
    _Common_E_PUCH_InformationLCR_e_PUCH_TPC_StepSize = ENUM(name='e-PUCH-TPC-StepSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')), opt=True)
    _Common_E_PUCH_InformationLCR_e_AGCH_TPC_StepSize = ENUM(name='e-AGCH-TPC-StepSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')), opt=True)
    _Common_E_PUCH_InformationLCR_e_PUCH_PowerControlGAP = INT(name='e-PUCH-PowerControlGAP', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')), opt=True)
    _Common_E_PUCH_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_PUCH_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_PUCH_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_PUCH_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__id._const_tab = ____Common_E_PUCH_InformationLCR_iE_Extensions__item__id_tab
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_PUCH_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_PUCH_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__criticality._const_tab = ____Common_E_PUCH_InformationLCR_iE_Extensions__item__criticality_tab
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_PUCH_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_PUCH_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____Common_E_PUCH_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_PUCH_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_PUCH_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_PUCH_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___Common_E_PUCH_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_PUCH_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __Common_E_PUCH_InformationLCR_iE_Extensions__item_._ext = None
    _Common_E_PUCH_InformationLCR_iE_Extensions._cont = __Common_E_PUCH_InformationLCR_iE_Extensions__item_
    _Common_E_PUCH_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_PUCH_InformationLCR._cont = ASN1Dict([
        ('minCR', _Common_E_PUCH_InformationLCR_minCR),
        ('maxCR', _Common_E_PUCH_InformationLCR_maxCR),
        ('harqInfo', _Common_E_PUCH_InformationLCR_harqInfo),
        ('pRXdes-base-perURAFCN', _Common_E_PUCH_InformationLCR_pRXdes_base_perURAFCN),
        ('e-PUCH-TPC-StepSize', _Common_E_PUCH_InformationLCR_e_PUCH_TPC_StepSize),
        ('e-AGCH-TPC-StepSize', _Common_E_PUCH_InformationLCR_e_AGCH_TPC_StepSize),
        ('e-PUCH-PowerControlGAP', _Common_E_PUCH_InformationLCR_e_PUCH_PowerControlGAP),
        ('iE-Extensions', _Common_E_PUCH_InformationLCR_iE_Extensions),
        ])
    Common_E_PUCH_InformationLCR._ext = []
    
    #-----< Common-E-PUCH-InformationLCR-ExtIEs >-----#
    Common_E_PUCH_InformationLCR_ExtIEs = CLASS(name='Common-E-PUCH-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_PUCH_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRXdes-base-perURAFCN >-----#
    PRXdes_base_perURAFCN = SEQ_OF(name='PRXdes-base-perURAFCN', mode=MODE_TYPE)
    _PRXdes_base_perURAFCN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PRXdes-base-Item')))
    PRXdes_base_perURAFCN._cont = _PRXdes_base_perURAFCN__item_
    PRXdes_base_perURAFCN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< PRXdes-base-Item >-----#
    PRXdes_base_Item = SEQ(name='PRXdes-base-Item', mode=MODE_TYPE)
    _PRXdes_base_Item_pRXdes_base = INT(name='pRXdes-base', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PRXdes-base')))
    _PRXdes_base_Item_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')), opt=True)
    _PRXdes_base_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRXdes_base_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PRXdes_base_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PRXdes_base_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRXdes_base_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRXdes_base_Item_iE_Extensions__item__id._const_tab = ____PRXdes_base_Item_iE_Extensions__item__id_tab
    ___PRXdes_base_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRXdes_base_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRXdes_base_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRXdes_base_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRXdes_base_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRXdes_base_Item_iE_Extensions__item__criticality._const_tab = ____PRXdes_base_Item_iE_Extensions__item__criticality_tab
    ___PRXdes_base_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRXdes_base_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRXdes_base_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRXdes_base_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRXdes_base_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRXdes_base_Item_iE_Extensions__item__extensionValue._const_tab = ____PRXdes_base_Item_iE_Extensions__item__extensionValue_tab
    ___PRXdes_base_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRXdes_base_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRXdes_base_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRXdes_base_Item_iE_Extensions__item__id),
        ('criticality', ___PRXdes_base_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRXdes_base_Item_iE_Extensions__item__extensionValue),
        ])
    __PRXdes_base_Item_iE_Extensions__item_._ext = None
    _PRXdes_base_Item_iE_Extensions._cont = __PRXdes_base_Item_iE_Extensions__item_
    _PRXdes_base_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRXdes_base_Item._cont = ASN1Dict([
        ('pRXdes-base', _PRXdes_base_Item_pRXdes_base),
        ('uARFCN', _PRXdes_base_Item_uARFCN),
        ('iE-Extensions', _PRXdes_base_Item_iE_Extensions),
        ])
    PRXdes_base_Item._ext = []
    
    #-----< PRXdes-base-Item-ExtIEs >-----#
    PRXdes_base_Item_ExtIEs = CLASS(name='PRXdes-base-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PRXdes_base_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoListLCR >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoListLCR = SEQ_OF(name='Ul-common-E-DCH-MACflow-Specific-InfoListLCR', mode=MODE_TYPE)
    _Ul_common_E_DCH_MACflow_Specific_InfoListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoList-ItemLCR')))
    Ul_common_E_DCH_MACflow_Specific_InfoListLCR._cont = _Ul_common_E_DCH_MACflow_Specific_InfoListLCR__item_
    Ul_common_E_DCH_MACflow_Specific_InfoListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoListLCR-Ext >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoListLCR_Ext = SEQ_OF(name='Ul-common-E-DCH-MACflow-Specific-InfoListLCR-Ext', mode=MODE_TYPE)
    _Ul_common_E_DCH_MACflow_Specific_InfoListLCR_Ext__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoList-ItemLCR')))
    Ul_common_E_DCH_MACflow_Specific_InfoListLCR_Ext._cont = _Ul_common_E_DCH_MACflow_Specific_InfoListLCR_Ext__item_
    Ul_common_E_DCH_MACflow_Specific_InfoListLCR_Ext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=248)], ev=None, er=[])
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoList-ItemLCR >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR = SEQ(name='Ul-common-E-DCH-MACflow-Specific-InfoList-ItemLCR', mode=MODE_TYPE)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_ul_Common_MACFlowIDLCR = INT(name='ul-Common-MACFlowIDLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID-LCR')))
    _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_transportBearerRequestIndicator = ENUM(name='transportBearerRequestIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_tnlQos = CHOICE(name='tnlQos', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_payloadCRC_PresenceIndicator = ENUM(name='payloadCRC-PresenceIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PayloadCRC-PresenceIndicator')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_common_E_DCH_MACdFlow_Specific_InformationLCR = SEQ_OF(name='common-E-DCH-MACdFlow-Specific-InformationLCR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-MACdFlow-Specific-InfoListLCR')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__id._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__id_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__id),
        ('criticality', ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue),
        ])
    __Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item_._ext = None
    _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions._cont = __Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item_
    _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR._cont = ASN1Dict([
        ('ul-Common-MACFlowIDLCR', _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_ul_Common_MACFlowIDLCR),
        ('transportBearerRequestIndicator', _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_transportBearerRequestIndicator),
        ('bindingID', _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_bindingID),
        ('transportLayerAddress', _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_transportLayerAddress),
        ('tnlQos', _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_tnlQos),
        ('payloadCRC-PresenceIndicator', _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_payloadCRC_PresenceIndicator),
        ('common-E-DCH-MACdFlow-Specific-InformationLCR', _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_common_E_DCH_MACdFlow_Specific_InformationLCR),
        ('uARFCN', _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_uARFCN),
        ('iE-Extensions', _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions),
        ])
    Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR._ext = []
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoList-ItemLCR-ExtIEs >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_ExtIEs = CLASS(name='Ul-common-E-DCH-MACflow-Specific-InfoList-ItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-MACdFlow-Specific-InfoListLCR >-----#
    Common_E_DCH_MACdFlow_Specific_InfoListLCR = SEQ_OF(name='Common-E-DCH-MACdFlow-Specific-InfoListLCR', mode=MODE_TYPE)
    _Common_E_DCH_MACdFlow_Specific_InfoListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-MACdFlow-Specific-InfoList-ItemLCR')))
    Common_E_DCH_MACdFlow_Specific_InfoListLCR._cont = _Common_E_DCH_MACdFlow_Specific_InfoListLCR__item_
    Common_E_DCH_MACdFlow_Specific_InfoListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Common-E-DCH-MACdFlow-Specific-InfoList-ItemLCR >-----#
    Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR = SEQ(name='Common-E-DCH-MACdFlow-Specific-InfoList-ItemLCR', mode=MODE_TYPE)
    _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_common_e_DCH_MACdFlow_ID = INT(name='common-e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID-LCR')))
    _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_maximum_Number_of_Retransmissions_For_E_DCH = INT(name='maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Number-of-Retransmissions-For-E-DCH')), opt=True)
    _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name='eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_common_E_DCHLogicalChannelInformation = SEQ_OF(name='common-E-DCHLogicalChannelInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-LogicalChannel-InfoList')), opt=True)
    _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_eDCH_HARQ_PO_TDD = INT(name='eDCH-HARQ-PO-TDD', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-PO-TDD')), opt=True)
    _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_eDCH_MACdFlow_Retransmission_Timer = ENUM(name='eDCH-MACdFlow-Retransmission-Timer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer')), opt=True)
    _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__id._const_tab = ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__id_tab
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item_._ext = None
    _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions._cont = __Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item_
    _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR._cont = ASN1Dict([
        ('common-e-DCH-MACdFlow-ID', _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_common_e_DCH_MACdFlow_ID),
        ('maximum-Number-of-Retransmissions-For-E-DCH', _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_maximum_Number_of_Retransmissions_For_E_DCH),
        ('eDCH-MACdFlow-Multiplexing-List', _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_eDCH_MACdFlow_Multiplexing_List),
        ('common-E-DCHLogicalChannelInformation', _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_common_E_DCHLogicalChannelInformation),
        ('eDCH-HARQ-PO-TDD', _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_eDCH_HARQ_PO_TDD),
        ('eDCH-MACdFlow-Retransmission-Timer', _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_eDCH_MACdFlow_Retransmission_Timer),
        ('iE-Extensions', _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions),
        ])
    Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR._ext = []
    
    #-----< Common-E-DCH-MACdFlow-Specific-InfoList-ItemLCR-ExtIEs >-----#
    Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_ExtIEs = CLASS(name='Common-E-DCH-MACdFlow-Specific-InfoList-ItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-EDCH-System-Information-ResponseLCR >-----#
    Common_EDCH_System_Information_ResponseLCR = SEQ(name='Common-EDCH-System-Information-ResponseLCR', mode=MODE_TYPE)
    _Common_EDCH_System_Information_ResponseLCR_ul_common_E_DCH_MACflow_Specific_InfoResponseLCR = SEQ_OF(name='ul-common-E-DCH-MACflow-Specific-InfoResponseLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR')), opt=True)
    _Common_EDCH_System_Information_ResponseLCR_common_E_AGCH_ListLCR = SEQ_OF(name='common-E-AGCH-ListLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-AGCH-ListLCR')), opt=True)
    _Common_EDCH_System_Information_ResponseLCR_common_E_HICH_ListLCR = SEQ_OF(name='common-E-HICH-ListLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-HICH-ListLCR')), opt=True)
    _Common_EDCH_System_Information_ResponseLCR_common_E_RNTI_Info_LCR = SEQ_OF(name='common-E-RNTI-Info-LCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-RNTI-Info-LCR')), opt=True)
    _Common_EDCH_System_Information_ResponseLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR-Ext')))
    _____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE)
    ____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1134), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1204), ('criticality', 'ignore'), ('Extension', _____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id),
        ('criticality', ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _Common_EDCH_System_Information_ResponseLCR_iE_Extensions._cont = __Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item_
    _Common_EDCH_System_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_EDCH_System_Information_ResponseLCR._cont = ASN1Dict([
        ('ul-common-E-DCH-MACflow-Specific-InfoResponseLCR', _Common_EDCH_System_Information_ResponseLCR_ul_common_E_DCH_MACflow_Specific_InfoResponseLCR),
        ('common-E-AGCH-ListLCR', _Common_EDCH_System_Information_ResponseLCR_common_E_AGCH_ListLCR),
        ('common-E-HICH-ListLCR', _Common_EDCH_System_Information_ResponseLCR_common_E_HICH_ListLCR),
        ('common-E-RNTI-Info-LCR', _Common_EDCH_System_Information_ResponseLCR_common_E_RNTI_Info_LCR),
        ('iE-Extensions', _Common_EDCH_System_Information_ResponseLCR_iE_Extensions),
        ])
    Common_EDCH_System_Information_ResponseLCR._ext = []
    
    #-----< Common-EDCH-System-Information-ResponseLCR-ExtIEs >-----#
    Common_EDCH_System_Information_ResponseLCR_ExtIEs = CLASS(name='Common-EDCH-System-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Common_EDCH_System_Information_ResponseLCR_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR-Ext')))
    _Common_EDCH_System_Information_ResponseLCR_ExtIEs_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE)
    Common_EDCH_System_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1134), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_Information_ResponseLCR_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1204), ('criticality', 'ignore'), ('Extension', _Common_EDCH_System_Information_ResponseLCR_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR = SEQ_OF(name='Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR', mode=MODE_TYPE)
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-ItemLCR')))
    Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR._cont = _Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR__item_
    Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR-Ext >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR_Ext = SEQ_OF(name='Ul-common-E-DCH-MACflow-Specific-InfoResponseListLCR-Ext', mode=MODE_TYPE)
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR_Ext__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ul-common-E-DCH-MACflow-Specific-InfoResponseList-ItemLCR')))
    Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR_Ext._cont = _Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR_Ext__item_
    Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR_Ext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=248)], ev=None, er=[])
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoResponseList-ItemLCR >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR = SEQ(name='Ul-common-E-DCH-MACflow-Specific-InfoResponseList-ItemLCR', mode=MODE_TYPE)
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_ul_Common_MACFlowID_LCR = INT(name='ul-Common-MACFlowID-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID-LCR')))
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')), opt=True)
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__id._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__id_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__criticality._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__criticality_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__extensionValue._const_tab = ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__extensionValue_tab
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__id),
        ('criticality', ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__extensionValue),
        ])
    __Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item_._ext = None
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions._cont = __Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item_
    _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR._cont = ASN1Dict([
        ('ul-Common-MACFlowID-LCR', _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_ul_Common_MACFlowID_LCR),
        ('bindingID', _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_bindingID),
        ('transportLayerAddress', _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_transportLayerAddress),
        ('uARFCN', _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_uARFCN),
        ('iE-Extensions', _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions),
        ])
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR._ext = []
    
    #-----< Ul-common-E-DCH-MACflow-Specific-InfoResponseList-ItemLCR-ExtIEs >-----#
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_ExtIEs = CLASS(name='Ul-common-E-DCH-MACflow-Specific-InfoResponseList-ItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-AGCH-ListLCR >-----#
    Common_E_AGCH_ListLCR = SEQ_OF(name='Common-E-AGCH-ListLCR', mode=MODE_TYPE)
    _Common_E_AGCH_ListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-AGCH-ItemLCR')))
    Common_E_AGCH_ListLCR._cont = _Common_E_AGCH_ListLCR__item_
    Common_E_AGCH_ListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Common-E-AGCH-ItemLCR >-----#
    Common_E_AGCH_ItemLCR = SEQ(name='Common-E-AGCH-ItemLCR', mode=MODE_TYPE)
    _Common_E_AGCH_ItemLCR_e_AGCH_ID = INT(name='e-AGCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Id')))
    _Common_E_AGCH_ItemLCR_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')), opt=True)
    _Common_E_AGCH_ItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_AGCH_ItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_AGCH_ItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_AGCH_ItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__id._const_tab = ____Common_E_AGCH_ItemLCR_iE_Extensions__item__id_tab
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_AGCH_ItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_AGCH_ItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__criticality._const_tab = ____Common_E_AGCH_ItemLCR_iE_Extensions__item__criticality_tab
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_AGCH_ItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_AGCH_ItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__extensionValue._const_tab = ____Common_E_AGCH_ItemLCR_iE_Extensions__item__extensionValue_tab
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_AGCH_ItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_AGCH_ItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_AGCH_ItemLCR_iE_Extensions__item__id),
        ('criticality', ___Common_E_AGCH_ItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_AGCH_ItemLCR_iE_Extensions__item__extensionValue),
        ])
    __Common_E_AGCH_ItemLCR_iE_Extensions__item_._ext = None
    _Common_E_AGCH_ItemLCR_iE_Extensions._cont = __Common_E_AGCH_ItemLCR_iE_Extensions__item_
    _Common_E_AGCH_ItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_AGCH_ItemLCR._cont = ASN1Dict([
        ('e-AGCH-ID', _Common_E_AGCH_ItemLCR_e_AGCH_ID),
        ('uARFCN', _Common_E_AGCH_ItemLCR_uARFCN),
        ('iE-Extensions', _Common_E_AGCH_ItemLCR_iE_Extensions),
        ])
    Common_E_AGCH_ItemLCR._ext = []
    
    #-----< Common-E-AGCH-ItemLCR-ExtIEs >-----#
    Common_E_AGCH_ItemLCR_ExtIEs = CLASS(name='Common-E-AGCH-ItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_AGCH_ItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-HICH-ListLCR >-----#
    Common_E_HICH_ListLCR = SEQ_OF(name='Common-E-HICH-ListLCR', mode=MODE_TYPE)
    _Common_E_HICH_ListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-HICH-ItemLCR')))
    Common_E_HICH_ListLCR._cont = _Common_E_HICH_ListLCR__item_
    Common_E_HICH_ListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Common-E-HICH-ItemLCR >-----#
    Common_E_HICH_ItemLCR = SEQ(name='Common-E-HICH-ItemLCR', mode=MODE_TYPE)
    _Common_E_HICH_ItemLCR_eI = INT(name='eI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'EI')))
    _Common_E_HICH_ItemLCR_e_HICH_ID = INT(name='e-HICH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-ID-LCR')))
    _Common_E_HICH_ItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_HICH_ItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_HICH_ItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_HICH_ItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__id._const_tab = ____Common_E_HICH_ItemLCR_iE_Extensions__item__id_tab
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_HICH_ItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_HICH_ItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__criticality._const_tab = ____Common_E_HICH_ItemLCR_iE_Extensions__item__criticality_tab
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_HICH_ItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_HICH_ItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__extensionValue._const_tab = ____Common_E_HICH_ItemLCR_iE_Extensions__item__extensionValue_tab
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_HICH_ItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_HICH_ItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_HICH_ItemLCR_iE_Extensions__item__id),
        ('criticality', ___Common_E_HICH_ItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_HICH_ItemLCR_iE_Extensions__item__extensionValue),
        ])
    __Common_E_HICH_ItemLCR_iE_Extensions__item_._ext = None
    _Common_E_HICH_ItemLCR_iE_Extensions._cont = __Common_E_HICH_ItemLCR_iE_Extensions__item_
    _Common_E_HICH_ItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_HICH_ItemLCR._cont = ASN1Dict([
        ('eI', _Common_E_HICH_ItemLCR_eI),
        ('e-HICH-ID', _Common_E_HICH_ItemLCR_e_HICH_ID),
        ('iE-Extensions', _Common_E_HICH_ItemLCR_iE_Extensions),
        ])
    Common_E_HICH_ItemLCR._ext = []
    
    #-----< Common-E-HICH-ItemLCR-ExtIEs >-----#
    Common_E_HICH_ItemLCR_ExtIEs = CLASS(name='Common-E-HICH-ItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_HICH_ItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-RNTI-Info-LCR >-----#
    Common_E_RNTI_Info_LCR = SEQ_OF(name='Common-E-RNTI-Info-LCR', mode=MODE_TYPE)
    _Common_E_RNTI_Info_LCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-RNTI-Info-ItemLCR')))
    Common_E_RNTI_Info_LCR._cont = _Common_E_RNTI_Info_LCR__item_
    Common_E_RNTI_Info_LCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Common-E-RNTI-Info-ItemLCR >-----#
    Common_E_RNTI_Info_ItemLCR = SEQ(name='Common-E-RNTI-Info-ItemLCR', mode=MODE_TYPE)
    _Common_E_RNTI_Info_ItemLCR_starting_E_RNTI = INT(name='starting-E-RNTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _Common_E_RNTI_Info_ItemLCR_number_of_Group = INT(name='number-of-Group', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Common_E_RNTI_Info_ItemLCR_number_of_Group._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _Common_E_RNTI_Info_ItemLCR_number_of_e_E_RNTI_perGroup = INT(name='number-of-e-E-RNTI-perGroup', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Common_E_RNTI_Info_ItemLCR_number_of_e_E_RNTI_perGroup._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    _Common_E_RNTI_Info_ItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_RNTI_Info_ItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    ____Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1168), ('criticality', 'reject'), ('Extension', _____Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id._const_tab = ____Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id_tab
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__criticality._const_tab = ____Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id_tab
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__extensionValue._const_tab = ____Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id_tab
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_RNTI_Info_ItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id),
        ('criticality', ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__extensionValue),
        ])
    __Common_E_RNTI_Info_ItemLCR_iE_Extensions__item_._ext = None
    _Common_E_RNTI_Info_ItemLCR_iE_Extensions._cont = __Common_E_RNTI_Info_ItemLCR_iE_Extensions__item_
    _Common_E_RNTI_Info_ItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_RNTI_Info_ItemLCR._cont = ASN1Dict([
        ('starting-E-RNTI', _Common_E_RNTI_Info_ItemLCR_starting_E_RNTI),
        ('number-of-Group', _Common_E_RNTI_Info_ItemLCR_number_of_Group),
        ('number-of-e-E-RNTI-perGroup', _Common_E_RNTI_Info_ItemLCR_number_of_e_E_RNTI_perGroup),
        ('iE-Extensions', _Common_E_RNTI_Info_ItemLCR_iE_Extensions),
        ])
    Common_E_RNTI_Info_ItemLCR._ext = []
    
    #-----< Common-E-RNTI-Info-ItemLCR-ExtIEs >-----#
    Common_E_RNTI_Info_ItemLCR_ExtIEs = CLASS(name='Common-E-RNTI-Info-ItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Common_E_RNTI_Info_ItemLCR_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    Common_E_RNTI_Info_ItemLCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1168), ('criticality', 'reject'), ('Extension', _Common_E_RNTI_Info_ItemLCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Common-MACFlows-to-DeleteLCR >-----#
    Common_MACFlows_to_DeleteLCR = SEQ_OF(name='Common-MACFlows-to-DeleteLCR', mode=MODE_TYPE)
    _Common_MACFlows_to_DeleteLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlows-to-DeleteLCR-Item')))
    Common_MACFlows_to_DeleteLCR._cont = _Common_MACFlows_to_DeleteLCR__item_
    Common_MACFlows_to_DeleteLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Common-MACFlows-to-DeleteLCR-Item >-----#
    Common_MACFlows_to_DeleteLCR_Item = SEQ(name='Common-MACFlows-to-DeleteLCR-Item', mode=MODE_TYPE)
    _Common_MACFlows_to_DeleteLCR_Item_common_MACFlow_ID_LCR = INT(name='common-MACFlow-ID-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID-LCR')))
    _Common_MACFlows_to_DeleteLCR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id._const_tab = ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id_tab
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id._const_tab_at = None
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality._const_tab = ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality_tab
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue._const_tab = ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue_tab
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id),
        ('criticality', ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue),
        ])
    __Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item_._ext = None
    _Common_MACFlows_to_DeleteLCR_Item_iE_Extensions._cont = __Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item_
    _Common_MACFlows_to_DeleteLCR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_MACFlows_to_DeleteLCR_Item._cont = ASN1Dict([
        ('common-MACFlow-ID-LCR', _Common_MACFlows_to_DeleteLCR_Item_common_MACFlow_ID_LCR),
        ('iE-Extensions', _Common_MACFlows_to_DeleteLCR_Item_iE_Extensions),
        ])
    Common_MACFlows_to_DeleteLCR_Item._ext = []
    
    #-----< Common-MACFlows-to-DeleteLCR-Item-ExtIEs >-----#
    Common_MACFlows_to_DeleteLCR_Item_ExtIEs = CLASS(name='Common-MACFlows-to-DeleteLCR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_MACFlows_to_DeleteLCR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-MACFlow-ID-LCR >-----#
    Common_MACFlow_ID_LCR = INT(name='Common-MACFlow-ID-LCR', mode=MODE_TYPE)
    Common_MACFlow_ID_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< CommonMACFlow-Specific-InfoListLCR >-----#
    CommonMACFlow_Specific_InfoListLCR = SEQ_OF(name='CommonMACFlow-Specific-InfoListLCR', mode=MODE_TYPE)
    _CommonMACFlow_Specific_InfoListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMACFlow-Specific-InfoItemLCR')))
    CommonMACFlow_Specific_InfoListLCR._cont = _CommonMACFlow_Specific_InfoListLCR__item_
    CommonMACFlow_Specific_InfoListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CommonMACFlow-Specific-InfoItemLCR >-----#
    CommonMACFlow_Specific_InfoItemLCR = SEQ(name='CommonMACFlow-Specific-InfoItemLCR', mode=MODE_TYPE)
    _CommonMACFlow_Specific_InfoItemLCR_common_MACFlow_ID_LCR = INT(name='common-MACFlow-ID-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID-LCR')))
    _CommonMACFlow_Specific_InfoItemLCR_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _CommonMACFlow_Specific_InfoItemLCR_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _CommonMACFlow_Specific_InfoItemLCR_tnl_qos = CHOICE(name='tnl-qos', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')), opt=True)
    _CommonMACFlow_Specific_InfoItemLCR_common_MACFlow_PriorityQueue_InformationLCR = SEQ_OF(name='common-MACFlow-PriorityQueue-InformationLCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-PriorityQueue-Information')), opt=True)
    _CommonMACFlow_Specific_InfoItemLCR_transportBearerRequestIndicator = ENUM(name='transportBearerRequestIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')), opt=True)
    _CommonMACFlow_Specific_InfoItemLCR_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')), opt=True)
    _CommonMACFlow_Specific_InfoItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__id._const_tab = ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__id_tab
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__criticality._const_tab = ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__criticality_tab
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__extensionValue._const_tab = ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__extensionValue_tab
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__id),
        ('criticality', ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__extensionValue),
        ])
    __CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item_._ext = None
    _CommonMACFlow_Specific_InfoItemLCR_iE_Extensions._cont = __CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item_
    _CommonMACFlow_Specific_InfoItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMACFlow_Specific_InfoItemLCR._cont = ASN1Dict([
        ('common-MACFlow-ID-LCR', _CommonMACFlow_Specific_InfoItemLCR_common_MACFlow_ID_LCR),
        ('bindingID', _CommonMACFlow_Specific_InfoItemLCR_bindingID),
        ('transportLayerAddress', _CommonMACFlow_Specific_InfoItemLCR_transportLayerAddress),
        ('tnl-qos', _CommonMACFlow_Specific_InfoItemLCR_tnl_qos),
        ('common-MACFlow-PriorityQueue-InformationLCR', _CommonMACFlow_Specific_InfoItemLCR_common_MACFlow_PriorityQueue_InformationLCR),
        ('transportBearerRequestIndicator', _CommonMACFlow_Specific_InfoItemLCR_transportBearerRequestIndicator),
        ('uARFCN', _CommonMACFlow_Specific_InfoItemLCR_uARFCN),
        ('iE-Extensions', _CommonMACFlow_Specific_InfoItemLCR_iE_Extensions),
        ])
    CommonMACFlow_Specific_InfoItemLCR._ext = []
    
    #-----< CommonMACFlow-Specific-InfoItemLCR-ExtIEs >-----#
    CommonMACFlow_Specific_InfoItemLCR_ExtIEs = CLASS(name='CommonMACFlow-Specific-InfoItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonMACFlow_Specific_InfoItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-H-RNTI-InformationLCR >-----#
    Common_H_RNTI_InformationLCR = SEQ_OF(name='Common-H-RNTI-InformationLCR', mode=MODE_TYPE)
    _Common_H_RNTI_InformationLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-H-RNTI-InfoItemLCR')))
    Common_H_RNTI_InformationLCR._cont = _Common_H_RNTI_InformationLCR__item_
    Common_H_RNTI_InformationLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Common-H-RNTI-InfoItemLCR >-----#
    Common_H_RNTI_InfoItemLCR = SEQ(name='Common-H-RNTI-InfoItemLCR', mode=MODE_TYPE)
    _Common_H_RNTI_InfoItemLCR_common_H_RNTI = INT(name='common-H-RNTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _Common_H_RNTI_InfoItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_H_RNTI_InfoItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__id._const_tab = ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__id_tab
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__criticality._const_tab = ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__criticality_tab
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__extensionValue._const_tab = ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__extensionValue_tab
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_H_RNTI_InfoItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__id),
        ('criticality', ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__extensionValue),
        ])
    __Common_H_RNTI_InfoItemLCR_iE_Extensions__item_._ext = None
    _Common_H_RNTI_InfoItemLCR_iE_Extensions._cont = __Common_H_RNTI_InfoItemLCR_iE_Extensions__item_
    _Common_H_RNTI_InfoItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_H_RNTI_InfoItemLCR._cont = ASN1Dict([
        ('common-H-RNTI', _Common_H_RNTI_InfoItemLCR_common_H_RNTI),
        ('iE-Extensions', _Common_H_RNTI_InfoItemLCR_iE_Extensions),
        ])
    Common_H_RNTI_InfoItemLCR._ext = []
    
    #-----< Common-H-RNTI-InfoItemLCR-ExtIEs >-----#
    Common_H_RNTI_InfoItemLCR_ExtIEs = CLASS(name='Common-H-RNTI-InfoItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_H_RNTI_InfoItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Sync-InformationLCR >-----#
    Sync_InformationLCR = SEQ(name='Sync-InformationLCR', mode=MODE_TYPE)
    _Sync_InformationLCR_t_SYNC = ENUM(name='t-SYNC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T-SYNC')))
    _Sync_InformationLCR_t_PROTECT = ENUM(name='t-PROTECT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T-PROTECT')))
    _Sync_InformationLCR_n_PROTECT = INT(name='n-PROTECT', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'N-PROTECT')))
    _Sync_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Sync_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Sync_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Sync_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Sync_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Sync_InformationLCR_iE_Extensions__item__id._const_tab = ____Sync_InformationLCR_iE_Extensions__item__id_tab
    ___Sync_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___Sync_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Sync_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Sync_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Sync_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Sync_InformationLCR_iE_Extensions__item__criticality._const_tab = ____Sync_InformationLCR_iE_Extensions__item__criticality_tab
    ___Sync_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Sync_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Sync_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Sync_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Sync_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Sync_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____Sync_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___Sync_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Sync_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Sync_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Sync_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___Sync_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Sync_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __Sync_InformationLCR_iE_Extensions__item_._ext = None
    _Sync_InformationLCR_iE_Extensions._cont = __Sync_InformationLCR_iE_Extensions__item_
    _Sync_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Sync_InformationLCR._cont = ASN1Dict([
        ('t-SYNC', _Sync_InformationLCR_t_SYNC),
        ('t-PROTECT', _Sync_InformationLCR_t_PROTECT),
        ('n-PROTECT', _Sync_InformationLCR_n_PROTECT),
        ('iE-Extensions', _Sync_InformationLCR_iE_Extensions),
        ])
    Sync_InformationLCR._ext = []
    
    #-----< Sync-InformationLCR-ExtIEs >-----#
    Sync_InformationLCR_ExtIEs = CLASS(name='Sync-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Sync_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMACFlow-Specific-InfoList-ResponseLCR >-----#
    CommonMACFlow_Specific_InfoList_ResponseLCR = SEQ_OF(name='CommonMACFlow-Specific-InfoList-ResponseLCR', mode=MODE_TYPE)
    _CommonMACFlow_Specific_InfoList_ResponseLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMACFlow-Specific-InfoItem-ResponseLCR')))
    CommonMACFlow_Specific_InfoList_ResponseLCR._cont = _CommonMACFlow_Specific_InfoList_ResponseLCR__item_
    CommonMACFlow_Specific_InfoList_ResponseLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CommonMACFlow-Specific-InfoList-ResponseLCR-Ext >-----#
    CommonMACFlow_Specific_InfoList_ResponseLCR_Ext = SEQ_OF(name='CommonMACFlow-Specific-InfoList-ResponseLCR-Ext', mode=MODE_TYPE)
    _CommonMACFlow_Specific_InfoList_ResponseLCR_Ext__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMACFlow-Specific-InfoItem-ResponseLCR')))
    CommonMACFlow_Specific_InfoList_ResponseLCR_Ext._cont = _CommonMACFlow_Specific_InfoList_ResponseLCR_Ext__item_
    CommonMACFlow_Specific_InfoList_ResponseLCR_Ext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=248)], ev=None, er=[])
    
    #-----< CommonMACFlow-Specific-InfoItem-ResponseLCR >-----#
    CommonMACFlow_Specific_InfoItem_ResponseLCR = SEQ(name='CommonMACFlow-Specific-InfoItem-ResponseLCR', mode=MODE_TYPE)
    _CommonMACFlow_Specific_InfoItem_ResponseLCR_common_MACFlow_ID_LCR = INT(name='common-MACFlow-ID-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID-LCR')))
    _CommonMACFlow_Specific_InfoItem_ResponseLCR_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _CommonMACFlow_Specific_InfoItem_ResponseLCR_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _CommonMACFlow_Specific_InfoItem_ResponseLCR_hSDSCH_Initial_Capacity_Allocation = SEQ_OF(name='hSDSCH-Initial-Capacity-Allocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Initial-Capacity-Allocation')), opt=True)
    _CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__id._const_tab = ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__id_tab
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__criticality_tab
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__extensionValue_tab
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__id),
        ('criticality', ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item_._ext = None
    _CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions._cont = __CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item_
    _CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMACFlow_Specific_InfoItem_ResponseLCR._cont = ASN1Dict([
        ('common-MACFlow-ID-LCR', _CommonMACFlow_Specific_InfoItem_ResponseLCR_common_MACFlow_ID_LCR),
        ('bindingID', _CommonMACFlow_Specific_InfoItem_ResponseLCR_bindingID),
        ('transportLayerAddress', _CommonMACFlow_Specific_InfoItem_ResponseLCR_transportLayerAddress),
        ('hSDSCH-Initial-Capacity-Allocation', _CommonMACFlow_Specific_InfoItem_ResponseLCR_hSDSCH_Initial_Capacity_Allocation),
        ('iE-Extensions', _CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions),
        ])
    CommonMACFlow_Specific_InfoItem_ResponseLCR._ext = []
    
    #-----< CommonMACFlow-Specific-InfoItem-ResponseLCR-ExtIEs >-----#
    CommonMACFlow_Specific_InfoItem_ResponseLCR_ExtIEs = CLASS(name='CommonMACFlow-Specific-InfoItem-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonMACFlow_Specific_InfoItem_ResponseLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPC-InformationLCR >-----#
    CPC_InformationLCR = SEQ(name='CPC-InformationLCR', mode=MODE_TYPE)
    _CPC_InformationLCR_continuousPacketConnectivity_DRX_InformationLCR = SEQ(name='continuousPacketConnectivity-DRX-InformationLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-InformationLCR')), opt=True)
    _CPC_InformationLCR_continuousPacketConnectivity_DRX_Information_to_Modify_LCR = SEQ(name='continuousPacketConnectivity-DRX-Information-to-Modify-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR')), opt=True)
    _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_LCR = SEQ(name='hS-DSCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-LCR')), opt=True)
    _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR = SEQ(name='hS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR')), opt=True)
    _CPC_InformationLCR_hS_DSCH_SPS_Deactivate_Indicator_LCR = NULL(name='hS-DSCH-SPS-Deactivate-Indicator-LCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_LCR = SEQ(name='e-DCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-LCR')), opt=True)
    _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR = SEQ(name='e-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR')), opt=True)
    _CPC_InformationLCR_e_DCH_SPS_Deactivate_Indicator_LCR = NULL(name='e-DCH-SPS-Deactivate-Indicator-LCR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPC_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPC_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CPC_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CPC_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CPC_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_InformationLCR_iE_Extensions__item__id._const_tab = ____CPC_InformationLCR_iE_Extensions__item__id_tab
    ___CPC_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___CPC_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPC_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPC_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CPC_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_InformationLCR_iE_Extensions__item__criticality._const_tab = ____CPC_InformationLCR_iE_Extensions__item__criticality_tab
    ___CPC_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPC_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPC_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPC_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CPC_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____CPC_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___CPC_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPC_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPC_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPC_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___CPC_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___CPC_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __CPC_InformationLCR_iE_Extensions__item_._ext = None
    _CPC_InformationLCR_iE_Extensions._cont = __CPC_InformationLCR_iE_Extensions__item_
    _CPC_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPC_InformationLCR._cont = ASN1Dict([
        ('continuousPacketConnectivity-DRX-InformationLCR', _CPC_InformationLCR_continuousPacketConnectivity_DRX_InformationLCR),
        ('continuousPacketConnectivity-DRX-Information-to-Modify-LCR', _CPC_InformationLCR_continuousPacketConnectivity_DRX_Information_to_Modify_LCR),
        ('hS-DSCH-Semi-PersistentScheduling-Information-LCR', _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_LCR),
        ('hS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR', _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR),
        ('hS-DSCH-SPS-Deactivate-Indicator-LCR', _CPC_InformationLCR_hS_DSCH_SPS_Deactivate_Indicator_LCR),
        ('e-DCH-Semi-PersistentScheduling-Information-LCR', _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_LCR),
        ('e-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR', _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR),
        ('e-DCH-SPS-Deactivate-Indicator-LCR', _CPC_InformationLCR_e_DCH_SPS_Deactivate_Indicator_LCR),
        ('iE-Extensions', _CPC_InformationLCR_iE_Extensions),
        ])
    CPC_InformationLCR._ext = []
    
    #-----< CPC-InformationLCR-ExtIEs >-----#
    CPC_InformationLCR_ExtIEs = CLASS(name='CPC-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CPC_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContinuousPacketConnectivity-DRX-CapabilityLCR >-----#
    ContinuousPacketConnectivity_DRX_CapabilityLCR = ENUM(name='ContinuousPacketConnectivity-DRX-CapabilityLCR', mode=MODE_TYPE)
    ContinuousPacketConnectivity_DRX_CapabilityLCR._cont = ASN1Dict([('continuous-Packet-Connectivity-DRX-Capable', 0), ('continuous-Packet-Connectivity-DRX-Non-Capable', 1)])
    ContinuousPacketConnectivity_DRX_CapabilityLCR._ext = None
    
    #-----< ContinuousPacketConnectivity-DRX-InformationLCR >-----#
    ContinuousPacketConnectivity_DRX_InformationLCR = SEQ(name='ContinuousPacketConnectivity-DRX-InformationLCR', mode=MODE_TYPE)
    _ContinuousPacketConnectivity_DRX_InformationLCR_enabling_Delay = ENUM(name='enabling-Delay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Enabling-Delay')))
    _ContinuousPacketConnectivity_DRX_InformationLCR_hS_SCCH_DRX_Information_LCR = SEQ(name='hS-SCCH-DRX-Information-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-DRX-Information-LCR')))
    _ContinuousPacketConnectivity_DRX_InformationLCR_e_AGCH_DRX_Information_LCR = CHOICE(name='e-AGCH-DRX-Information-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-DRX-Information-LCR')), opt=True)
    _ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enabling-Delay-Ext-LCR')))
    ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1180), ('criticality', 'ignore'), ('Extension', _____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id._const_tab = ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality._const_tab = ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item_._ext = None
    _ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions._cont = __ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item_
    _ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContinuousPacketConnectivity_DRX_InformationLCR._cont = ASN1Dict([
        ('enabling-Delay', _ContinuousPacketConnectivity_DRX_InformationLCR_enabling_Delay),
        ('hS-SCCH-DRX-Information-LCR', _ContinuousPacketConnectivity_DRX_InformationLCR_hS_SCCH_DRX_Information_LCR),
        ('e-AGCH-DRX-Information-LCR', _ContinuousPacketConnectivity_DRX_InformationLCR_e_AGCH_DRX_Information_LCR),
        ('iE-Extensions', _ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions),
        ])
    ContinuousPacketConnectivity_DRX_InformationLCR._ext = []
    
    #-----< ContinuousPacketConnectivity-DRX-InformationLCR-ExtIEs >-----#
    ContinuousPacketConnectivity_DRX_InformationLCR_ExtIEs = CLASS(name='ContinuousPacketConnectivity-DRX-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _ContinuousPacketConnectivity_DRX_InformationLCR_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enabling-Delay-Ext-LCR')))
    ContinuousPacketConnectivity_DRX_InformationLCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1180), ('criticality', 'ignore'), ('Extension', _ContinuousPacketConnectivity_DRX_InformationLCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-DRX-Information-LCR >-----#
    HS_SCCH_DRX_Information_LCR = SEQ(name='HS-SCCH-DRX-Information-LCR', mode=MODE_TYPE)
    _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Cycle_LCR = ENUM(name='hS-SCCH-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Cycle-LCR')))
    _HS_SCCH_DRX_Information_LCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR = ENUM(name='hS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR')), opt=True)
    _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Offset_LCR = INT(name='hS-SCCH-UE-DRX-Offset-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Offset-LCR')))
    _HS_SCCH_DRX_Information_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_DRX_Information_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext')))
    ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1195), ('criticality', 'ignore'), ('Extension', _____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id._const_tab = ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SCCH_DRX_Information_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id),
        ('criticality', ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_DRX_Information_LCR_iE_Extensions__item_._ext = None
    _HS_SCCH_DRX_Information_LCR_iE_Extensions._cont = __HS_SCCH_DRX_Information_LCR_iE_Extensions__item_
    _HS_SCCH_DRX_Information_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_DRX_Information_LCR._cont = ASN1Dict([
        ('hS-SCCH-UE-DRX-Cycle-LCR', _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Cycle_LCR),
        ('hS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR', _HS_SCCH_DRX_Information_LCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR),
        ('hS-SCCH-UE-DRX-Offset-LCR', _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Offset_LCR),
        ('iE-Extensions', _HS_SCCH_DRX_Information_LCR_iE_Extensions),
        ])
    HS_SCCH_DRX_Information_LCR._ext = []
    
    #-----< HS-SCCH-DRX-Information-LCR-ExtIEs >-----#
    HS_SCCH_DRX_Information_LCR_ExtIEs = CLASS(name='HS-SCCH-DRX-Information-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_SCCH_DRX_Information_LCR_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext')))
    HS_SCCH_DRX_Information_LCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1195), ('criticality', 'ignore'), ('Extension', _HS_SCCH_DRX_Information_LCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-DRX-Information-LCR >-----#
    E_AGCH_DRX_Information_LCR = CHOICE(name='E-AGCH-DRX-Information-LCR', mode=MODE_TYPE)
    _E_AGCH_DRX_Information_LCR_sameAsHS_SCCH = NULL(name='sameAsHS-SCCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_AGCH_DRX_Information_LCR_e_AGCH_DRX_Parameters = SEQ(name='e-AGCH-DRX-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-DRX-Parameters')))
    E_AGCH_DRX_Information_LCR._cont = ASN1Dict([
        ('sameAsHS-SCCH', _E_AGCH_DRX_Information_LCR_sameAsHS_SCCH),
        ('e-AGCH-DRX-Parameters', _E_AGCH_DRX_Information_LCR_e_AGCH_DRX_Parameters),
        ])
    E_AGCH_DRX_Information_LCR._ext = []
    
    #-----< E-AGCH-DRX-Parameters >-----#
    E_AGCH_DRX_Parameters = SEQ(name='E-AGCH-DRX-Parameters', mode=MODE_TYPE)
    _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Cycle_LCR = ENUM(name='e-AGCH-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Cycle-LCR')))
    _E_AGCH_DRX_Parameters_e_AGCH_UE_Inactivity_Monitor_Threshold = ENUM(name='e-AGCH-UE-Inactivity-Monitor-Threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-UE-Inactivity-Monitor-Threshold')), opt=True)
    _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Offset_LCR = INT(name='e-AGCH-UE-DRX-Offset-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Offset-LCR')))
    _E_AGCH_DRX_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_DRX_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__id._const_tab = ____E_AGCH_DRX_Parameters_iE_Extensions__item__id_tab
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality._const_tab = ____E_AGCH_DRX_Parameters_iE_Extensions__item__criticality_tab
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_AGCH_DRX_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_AGCH_DRX_Parameters_iE_Extensions__item__id),
        ('criticality', ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_DRX_Parameters_iE_Extensions__item_._ext = None
    _E_AGCH_DRX_Parameters_iE_Extensions._cont = __E_AGCH_DRX_Parameters_iE_Extensions__item_
    _E_AGCH_DRX_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_DRX_Parameters._cont = ASN1Dict([
        ('e-AGCH-UE-DRX-Cycle-LCR', _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Cycle_LCR),
        ('e-AGCH-UE-Inactivity-Monitor-Threshold', _E_AGCH_DRX_Parameters_e_AGCH_UE_Inactivity_Monitor_Threshold),
        ('e-AGCH-UE-DRX-Offset-LCR', _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Offset_LCR),
        ('iE-Extensions', _E_AGCH_DRX_Parameters_iE_Extensions),
        ])
    E_AGCH_DRX_Parameters._ext = []
    
    #-----< E-AGCH-DRX-Parameters-ExtIEs >-----#
    E_AGCH_DRX_Parameters_ExtIEs = CLASS(name='E-AGCH-DRX-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_AGCH_DRX_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-DRX-Cycle-LCR >-----#
    UE_DRX_Cycle_LCR = ENUM(name='UE-DRX-Cycle-LCR', mode=MODE_TYPE)
    UE_DRX_Cycle_LCR._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v4', 2), ('v8', 3), ('v16', 4), ('v32', 5), ('v64', 6)])
    UE_DRX_Cycle_LCR._ext = []
    
    #-----< UE-DRX-Offset-LCR >-----#
    UE_DRX_Offset_LCR = INT(name='UE-DRX-Offset-LCR', mode=MODE_TYPE)
    UE_DRX_Offset_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< Inactivity-Threshold-for-UE-DRX-Cycle-LCR >-----#
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR = ENUM(name='Inactivity-Threshold-for-UE-DRX-Cycle-LCR', mode=MODE_TYPE)
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v4', 2), ('v8', 3), ('v16', 4), ('v32', 5), ('v64', 6)])
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR._ext = []
    
    #-----< Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext >-----#
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext = ENUM(name='Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext', mode=MODE_TYPE)
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext._cont = ASN1Dict([('v128', 0), ('v256', 1), ('v512', 2)])
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext._ext = []
    
    #-----< E-AGCH-UE-Inactivity-Monitor-Threshold >-----#
    E_AGCH_UE_Inactivity_Monitor_Threshold = ENUM(name='E-AGCH-UE-Inactivity-Monitor-Threshold', mode=MODE_TYPE)
    E_AGCH_UE_Inactivity_Monitor_Threshold._cont = ASN1Dict([('v0', 0), ('v1', 1), ('v2', 2), ('v4', 3), ('v8', 4), ('v16', 5), ('v32', 6), ('v64', 7), ('v128', 8), ('v256', 9), ('v512', 10), ('infinity', 11)])
    E_AGCH_UE_Inactivity_Monitor_Threshold._ext = []
    
    #-----< ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR >-----#
    ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR = SEQ(name='ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR', mode=MODE_TYPE)
    _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_enabling_Delay = ENUM(name='enabling-Delay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Enabling-Delay')), opt=True)
    _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_dRX_Information_to_Modify_LCR = CHOICE(name='dRX-Information-to-Modify-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DRX-Information-to-Modify-LCR')), opt=True)
    _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enabling-Delay-Ext-LCR')))
    ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1180), ('criticality', 'ignore'), ('Extension', _____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab = ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_at = None
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab = ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab = ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id),
        ('criticality', ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue),
        ])
    __ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item_._ext = None
    _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions._cont = __ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item_
    _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR._cont = ASN1Dict([
        ('enabling-Delay', _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_enabling_Delay),
        ('dRX-Information-to-Modify-LCR', _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_dRX_Information_to_Modify_LCR),
        ('iE-Extensions', _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions),
        ])
    ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR._ext = []
    
    #-----< ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR-ExtIEs >-----#
    ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_ExtIEs = CLASS(name='ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enabling-Delay-Ext-LCR')))
    ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1180), ('criticality', 'ignore'), ('Extension', _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRX-Information-to-Modify-LCR >-----#
    DRX_Information_to_Modify_LCR = CHOICE(name='DRX-Information-to-Modify-LCR', mode=MODE_TYPE)
    _DRX_Information_to_Modify_LCR_modify = SEQ(name='modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DRX-Information-to-Modify-Items-LCR')))
    _DRX_Information_to_Modify_LCR_deactivate = NULL(name='deactivate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DRX_Information_to_Modify_LCR._cont = ASN1Dict([
        ('modify', _DRX_Information_to_Modify_LCR_modify),
        ('deactivate', _DRX_Information_to_Modify_LCR_deactivate),
        ])
    DRX_Information_to_Modify_LCR._ext = []
    
    #-----< DRX-Information-to-Modify-Items-LCR >-----#
    DRX_Information_to_Modify_Items_LCR = SEQ(name='DRX-Information-to-Modify-Items-LCR', mode=MODE_TYPE)
    _DRX_Information_to_Modify_Items_LCR_hS_SCCH_DRX_Information_LCR = SEQ(name='hS-SCCH-DRX-Information-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-DRX-Information-LCR')), opt=True)
    _DRX_Information_to_Modify_Items_LCR_e_AGCH_DRX_Information_LCR = CHOICE(name='e-AGCH-DRX-Information-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-DRX-Information-LCR')), opt=True)
    _DRX_Information_to_Modify_Items_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRX_Information_to_Modify_Items_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id._const_tab = ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id_tab
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id._const_tab_at = None
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality._const_tab = ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality_tab
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue._const_tab = ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue_tab
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRX_Information_to_Modify_Items_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id),
        ('criticality', ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue),
        ])
    __DRX_Information_to_Modify_Items_LCR_iE_Extensions__item_._ext = None
    _DRX_Information_to_Modify_Items_LCR_iE_Extensions._cont = __DRX_Information_to_Modify_Items_LCR_iE_Extensions__item_
    _DRX_Information_to_Modify_Items_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRX_Information_to_Modify_Items_LCR._cont = ASN1Dict([
        ('hS-SCCH-DRX-Information-LCR', _DRX_Information_to_Modify_Items_LCR_hS_SCCH_DRX_Information_LCR),
        ('e-AGCH-DRX-Information-LCR', _DRX_Information_to_Modify_Items_LCR_e_AGCH_DRX_Information_LCR),
        ('iE-Extensions', _DRX_Information_to_Modify_Items_LCR_iE_Extensions),
        ])
    DRX_Information_to_Modify_Items_LCR._ext = []
    
    #-----< DRX-Information-to-Modify-Items-LCR-ExtIEs >-----#
    DRX_Information_to_Modify_Items_LCR_ExtIEs = CLASS(name='DRX-Information-to-Modify-Items-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DRX_Information_to_Modify_Items_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContinuousPacketConnectivity-DRX-Information-ResponseLCR >-----#
    ContinuousPacketConnectivity_DRX_Information_ResponseLCR = SEQ(name='ContinuousPacketConnectivity-DRX-Information-ResponseLCR', mode=MODE_TYPE)
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_enabling_Delay = ENUM(name='enabling-Delay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Enabling-Delay')), opt=True)
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_hS_SCCH_DRX_Information_ResponseLCR = SEQ(name='hS-SCCH-DRX-Information-ResponseLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-DRX-Information-ResponseLCR')), opt=True)
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_e_AGCH_DRX_Information_ResponseLCR = CHOICE(name='e-AGCH-DRX-Information-ResponseLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-DRX-Information-ResponseLCR')), opt=True)
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enabling-Delay-Ext-LCR')))
    ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1180), ('criticality', 'ignore'), ('Extension', _____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id),
        ('criticality', ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions._cont = __ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item_
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContinuousPacketConnectivity_DRX_Information_ResponseLCR._cont = ASN1Dict([
        ('enabling-Delay', _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_enabling_Delay),
        ('hS-SCCH-DRX-Information-ResponseLCR', _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_hS_SCCH_DRX_Information_ResponseLCR),
        ('e-AGCH-DRX-Information-ResponseLCR', _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_e_AGCH_DRX_Information_ResponseLCR),
        ('iE-Extensions', _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions),
        ])
    ContinuousPacketConnectivity_DRX_Information_ResponseLCR._ext = []
    
    #-----< ContinuousPacketConnectivity-DRX-Information-ResponseLCR-ExtIEs >-----#
    ContinuousPacketConnectivity_DRX_Information_ResponseLCR_ExtIEs = CLASS(name='ContinuousPacketConnectivity-DRX-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enabling-Delay-Ext-LCR')))
    ContinuousPacketConnectivity_DRX_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1180), ('criticality', 'ignore'), ('Extension', _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-DRX-Information-ResponseLCR >-----#
    HS_SCCH_DRX_Information_ResponseLCR = SEQ(name='HS-SCCH-DRX-Information-ResponseLCR', mode=MODE_TYPE)
    _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Cycle_LCR = ENUM(name='hS-SCCH-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Cycle-LCR')), opt=True)
    _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR = ENUM(name='hS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR')), opt=True)
    _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Offset_LCR = INT(name='hS-SCCH-UE-DRX-Offset-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Offset-LCR')), opt=True)
    _HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext')))
    ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1195), ('criticality', 'ignore'), ('Extension', _____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id),
        ('criticality', ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions._cont = __HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item_
    _HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_DRX_Information_ResponseLCR._cont = ASN1Dict([
        ('hS-SCCH-UE-DRX-Cycle-LCR', _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Cycle_LCR),
        ('hS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR', _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR),
        ('hS-SCCH-UE-DRX-Offset-LCR', _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Offset_LCR),
        ('iE-Extensions', _HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions),
        ])
    HS_SCCH_DRX_Information_ResponseLCR._ext = []
    
    #-----< HS-SCCH-DRX-Information-ResponseLCR-ExtIEs >-----#
    HS_SCCH_DRX_Information_ResponseLCR_ExtIEs = CLASS(name='HS-SCCH-DRX-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_SCCH_DRX_Information_ResponseLCR_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext')))
    HS_SCCH_DRX_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1195), ('criticality', 'ignore'), ('Extension', _HS_SCCH_DRX_Information_ResponseLCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-DRX-Information-ResponseLCR >-----#
    E_AGCH_DRX_Information_ResponseLCR = CHOICE(name='E-AGCH-DRX-Information-ResponseLCR', mode=MODE_TYPE)
    _E_AGCH_DRX_Information_ResponseLCR_sameAsHS_SCCH = NULL(name='sameAsHS-SCCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_AGCH_DRX_Information_ResponseLCR_e_AGCH_DRX_Parameters_Response = SEQ(name='e-AGCH-DRX-Parameters-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-DRX-Parameters-Response')))
    E_AGCH_DRX_Information_ResponseLCR._cont = ASN1Dict([
        ('sameAsHS-SCCH', _E_AGCH_DRX_Information_ResponseLCR_sameAsHS_SCCH),
        ('e-AGCH-DRX-Parameters-Response', _E_AGCH_DRX_Information_ResponseLCR_e_AGCH_DRX_Parameters_Response),
        ])
    E_AGCH_DRX_Information_ResponseLCR._ext = []
    
    #-----< E-AGCH-DRX-Parameters-Response >-----#
    E_AGCH_DRX_Parameters_Response = SEQ(name='E-AGCH-DRX-Parameters-Response', mode=MODE_TYPE)
    _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Cycle_LCR = ENUM(name='e-AGCH-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Cycle-LCR')), opt=True)
    _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_Inactivity_Monitor_Threshold = ENUM(name='e-AGCH-UE-Inactivity-Monitor-Threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-UE-Inactivity-Monitor-Threshold')), opt=True)
    _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Offset_LCR = INT(name='e-AGCH-UE-DRX-Offset-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Offset-LCR')), opt=True)
    _E_AGCH_DRX_Parameters_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_DRX_Parameters_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id._const_tab = ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id_tab
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality._const_tab = ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality_tab
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_AGCH_DRX_Parameters_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id),
        ('criticality', ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_DRX_Parameters_Response_iE_Extensions__item_._ext = None
    _E_AGCH_DRX_Parameters_Response_iE_Extensions._cont = __E_AGCH_DRX_Parameters_Response_iE_Extensions__item_
    _E_AGCH_DRX_Parameters_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_DRX_Parameters_Response._cont = ASN1Dict([
        ('e-AGCH-UE-DRX-Cycle-LCR', _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Cycle_LCR),
        ('e-AGCH-UE-Inactivity-Monitor-Threshold', _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_Inactivity_Monitor_Threshold),
        ('e-AGCH-UE-DRX-Offset-LCR', _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Offset_LCR),
        ('iE-Extensions', _E_AGCH_DRX_Parameters_Response_iE_Extensions),
        ])
    E_AGCH_DRX_Parameters_Response._ext = []
    
    #-----< E-AGCH-DRX-Parameters-Response-ExtIEs >-----#
    E_AGCH_DRX_Parameters_Response_ExtIEs = CLASS(name='E-AGCH-DRX-Parameters-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_AGCH_DRX_Parameters_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cell-Capability-Container-TDD-LCR >-----#
    Cell_Capability_Container_TDD_LCR = BIT_STR(name='Cell-Capability-Container-TDD-LCR', mode=MODE_TYPE)
    Cell_Capability_Container_TDD_LCR._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< Common-E-RGCH-Operation-Indicator >-----#
    Common_E_RGCH_Operation_Indicator = ENUM(name='Common-E-RGCH-Operation-Indicator', mode=MODE_TYPE)
    Common_E_RGCH_Operation_Indicator._cont = ASN1Dict([('true', 0)])
    Common_E_RGCH_Operation_Indicator._ext = None
    
    #-----< Common-E-RGCH-InfoFDD >-----#
    Common_E_RGCH_InfoFDD = SEQ(name='Common-E-RGCH-InfoFDD', mode=MODE_TYPE)
    _Common_E_RGCH_InfoFDD_e_RGCH_Channelisation_Code = INT(name='e-RGCH-Channelisation-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _Common_E_RGCH_InfoFDD_e_RGCH_Signature_Sequence = INT(name='e-RGCH-Signature-Sequence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-Signature-Sequence')))
    _Common_E_RGCH_InfoFDD_minimum_Serving_Grant = INT(name='minimum-Serving-Grant', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-Serving-Grant-Value')), opt=True)
    _Common_E_RGCH_InfoFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_RGCH_InfoFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_RGCH_InfoFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_RGCH_InfoFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__id._const_tab = ____Common_E_RGCH_InfoFDD_iE_Extensions__item__id_tab
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_RGCH_InfoFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_RGCH_InfoFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__criticality._const_tab = ____Common_E_RGCH_InfoFDD_iE_Extensions__item__criticality_tab
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_RGCH_InfoFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_RGCH_InfoFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__extensionValue._const_tab = ____Common_E_RGCH_InfoFDD_iE_Extensions__item__extensionValue_tab
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_RGCH_InfoFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_RGCH_InfoFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_RGCH_InfoFDD_iE_Extensions__item__id),
        ('criticality', ___Common_E_RGCH_InfoFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_RGCH_InfoFDD_iE_Extensions__item__extensionValue),
        ])
    __Common_E_RGCH_InfoFDD_iE_Extensions__item_._ext = None
    _Common_E_RGCH_InfoFDD_iE_Extensions._cont = __Common_E_RGCH_InfoFDD_iE_Extensions__item_
    _Common_E_RGCH_InfoFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_RGCH_InfoFDD._cont = ASN1Dict([
        ('e-RGCH-Channelisation-Code', _Common_E_RGCH_InfoFDD_e_RGCH_Channelisation_Code),
        ('e-RGCH-Signature-Sequence', _Common_E_RGCH_InfoFDD_e_RGCH_Signature_Sequence),
        ('minimum-Serving-Grant', _Common_E_RGCH_InfoFDD_minimum_Serving_Grant),
        ('iE-Extensions', _Common_E_RGCH_InfoFDD_iE_Extensions),
        ])
    Common_E_RGCH_InfoFDD._ext = []
    
    #-----< Common-E-RGCH-InfoFDD-ExtIEs >-----#
    Common_E_RGCH_InfoFDD_ExtIEs = CLASS(name='Common-E-RGCH-InfoFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_RGCH_InfoFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Concurrent-Deployment-of-2msand10ms-TTI >-----#
    Concurrent_Deployment_of_2msand10ms_TTI = SEQ(name='Concurrent-Deployment-of-2msand10ms-TTI', mode=MODE_TYPE)
    _Concurrent_Deployment_of_2msand10ms_TTI_concurrent_TTI_Partition_Index = INT(name='concurrent-TTI-Partition-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Concurrent-TTI-Partition-Index')))
    _Concurrent_Deployment_of_2msand10ms_TTI_common_E_DCH_System_Info_Parameters_for_Concurrent_TTI = SEQ(name='common-E-DCH-System-Info-Parameters-for-Concurrent-TTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-System-Info-Parameters-for-Concurrent-TTI')))
    _Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__id._const_tab = ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__id_tab
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__id._const_tab_at = None
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__id._const_tab_id = 'id'
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__criticality._const_tab = ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__criticality_tab
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__extensionValue._const_tab = ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__extensionValue_tab
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__id),
        ('criticality', ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__criticality),
        ('extensionValue', ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__extensionValue),
        ])
    __Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item_._ext = None
    _Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions._cont = __Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item_
    _Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Concurrent_Deployment_of_2msand10ms_TTI._cont = ASN1Dict([
        ('concurrent-TTI-Partition-Index', _Concurrent_Deployment_of_2msand10ms_TTI_concurrent_TTI_Partition_Index),
        ('common-E-DCH-System-Info-Parameters-for-Concurrent-TTI', _Concurrent_Deployment_of_2msand10ms_TTI_common_E_DCH_System_Info_Parameters_for_Concurrent_TTI),
        ('iE-Extensions', _Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions),
        ])
    Concurrent_Deployment_of_2msand10ms_TTI._ext = []
    
    #-----< Concurrent-Deployment-of-2msand10ms-TTI-ExtIEs >-----#
    Concurrent_Deployment_of_2msand10ms_TTI_ExtIEs = CLASS(name='Concurrent-Deployment-of-2msand10ms-TTI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Concurrent_Deployment_of_2msand10ms_TTI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Concurrent-TTI-Partition-Index >-----#
    Concurrent_TTI_Partition_Index = INT(name='Concurrent-TTI-Partition-Index', mode=MODE_TYPE)
    Concurrent_TTI_Partition_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    
    #-----< Common-E-DCH-System-Info-Parameters-for-Concurrent-TTI >-----#
    Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI = SEQ(name='Common-E-DCH-System-Info-Parameters-for-Concurrent-TTI', mode=MODE_TYPE)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_maxSet_E_DPDCHs = ENUM(name='maxSet-E-DPDCHs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-Set-E-DPDCHs')))
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_ul_PunctureLimit = INT(name='ul-PunctureLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')))
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_TFCS_Information = SEQ(name='e-TFCS-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information')))
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_DPCCH_PO = INT(name='e-DPCCH-PO', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-PO')), opt=True)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_RGCH_2_IndexStepThreshold = INT(name='e-RGCH-2-IndexStepThreshold', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-2-IndexStepThreshold')), opt=True)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_RGCH_3_IndexStepThreshold = INT(name='e-RGCH-3-IndexStepThreshold', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-3-IndexStepThreshold')), opt=True)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_DCH_Reference_Power_Offset = INT(name='e-DCH-Reference-Power-Offset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Reference-Power-Offset')), opt=True)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_DCH_PowerOffset_for_SchedulingInfo = INT(name='e-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')), opt=True)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_max_EDCH_Resource_Allocation_for_CCCH_extension = ENUM(name='max-EDCH-Resource-Allocation-for-CCCH-extension', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-EDCH-Resource-Allocation-for-CCCH-Extension')), opt=True)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_max_Period_for_Collision_Resolution = INT(name='max-Period-for-Collision-Resolution', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-Period-for-Collision-Resolution')), opt=True)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_max_TB_Sizes = SEQ(name='max-TB-Sizes', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-TB-Sizes')), opt=True)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_commonEDCH_AdditionalTransmissionBackOff = INT(name='commonEDCH-AdditionalTransmissionBackOff', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonEDCH-AdditionalTransmissionBackOff')), opt=True)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_common_E_DCH_E_AGCH_ChannelisationCodeNumber = INT(name='common-E-DCH-E-AGCH-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')), opt=True)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_common_E_DCH_HS_DPCCH_Information_forConcurrentTTI = SEQ(name='common-E-DCH-HS-DPCCH-Information-forConcurrentTTI', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-HS-DPCCH-Information-forConcurrentTTI')), opt=True)
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__id._const_tab = ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__id_tab
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item_._ext = None
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions._cont = __Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item_
    _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI._cont = ASN1Dict([
        ('maxSet-E-DPDCHs', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_maxSet_E_DPDCHs),
        ('ul-PunctureLimit', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_ul_PunctureLimit),
        ('e-TFCS-Information', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_TFCS_Information),
        ('e-DPCCH-PO', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_DPCCH_PO),
        ('e-RGCH-2-IndexStepThreshold', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_RGCH_2_IndexStepThreshold),
        ('e-RGCH-3-IndexStepThreshold', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_RGCH_3_IndexStepThreshold),
        ('e-DCH-Reference-Power-Offset', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_DCH_Reference_Power_Offset),
        ('e-DCH-PowerOffset-for-SchedulingInfo', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_DCH_PowerOffset_for_SchedulingInfo),
        ('max-EDCH-Resource-Allocation-for-CCCH-extension', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_max_EDCH_Resource_Allocation_for_CCCH_extension),
        ('max-Period-for-Collision-Resolution', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_max_Period_for_Collision_Resolution),
        ('max-TB-Sizes', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_max_TB_Sizes),
        ('commonEDCH-AdditionalTransmissionBackOff', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_commonEDCH_AdditionalTransmissionBackOff),
        ('common-E-DCH-E-AGCH-ChannelisationCodeNumber', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_common_E_DCH_E_AGCH_ChannelisationCodeNumber),
        ('common-E-DCH-HS-DPCCH-Information-forConcurrentTTI', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_common_E_DCH_HS_DPCCH_Information_forConcurrentTTI),
        ('iE-Extensions', _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions),
        ])
    Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI._ext = []
    
    #-----< Common-E-DCH-System-Info-Parameters-for-Concurrent-TTI-ExtIEs >-----#
    Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_ExtIEs = CLASS(name='Common-E-DCH-System-Info-Parameters-for-Concurrent-TTI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-HS-DPCCH-Information-forConcurrentTTI >-----#
    Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI = SEQ(name='Common-E-DCH-HS-DPCCH-Information-forConcurrentTTI', mode=MODE_TYPE)
    _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_ackNackRepetitionFactor = INT(name='ackNackRepetitionFactor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AckNack-RepetitionFactor')))
    _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_ackPowerOffset = INT(name='ackPowerOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Ack-Power-Offset')))
    _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_nackPowerOffset = INT(name='nackPowerOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Nack-Power-Offset')))
    _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_common_E_DCH_CQI_Info = SEQ(name='common-E-DCH-CQI-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-CQI-Info')), opt=True)
    _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__id._const_tab = ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__id_tab
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item_._ext = None
    _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions._cont = __Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item_
    _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI._cont = ASN1Dict([
        ('ackNackRepetitionFactor', _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_ackNackRepetitionFactor),
        ('ackPowerOffset', _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_ackPowerOffset),
        ('nackPowerOffset', _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_nackPowerOffset),
        ('common-E-DCH-CQI-Info', _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_common_E_DCH_CQI_Info),
        ('iE-Extensions', _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions),
        ])
    Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI._ext = []
    
    #-----< Common-E-DCH-HS-DPCCH-Information-forConcurrentTTI-ExtIEs >-----#
    Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_ExtIEs = CLASS(name='Common-E-DCH-HS-DPCCH-Information-forConcurrentTTI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-Preamble-Control-Information-extensionList >-----#
    Common_E_DCH_Preamble_Control_Information_extensionList = SEQ_OF(name='Common-E-DCH-Preamble-Control-Information-extensionList', mode=MODE_TYPE)
    _Common_E_DCH_Preamble_Control_Information_extensionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Preamble-Control-Information-extensionList-Item')))
    Common_E_DCH_Preamble_Control_Information_extensionList._cont = _Common_E_DCH_Preamble_Control_Information_extensionList__item_
    Common_E_DCH_Preamble_Control_Information_extensionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Common-E-DCH-Preamble-Control-Information-extensionList-Item >-----#
    Common_E_DCH_Preamble_Control_Information_extensionList_Item = SEQ(name='Common-E-DCH-Preamble-Control-Information-extensionList-Item', mode=MODE_TYPE)
    _Common_E_DCH_Preamble_Control_Information_extensionList_Item_common_E_DCH_Preamble_Control_Information_extension = SEQ(name='common-E-DCH-Preamble-Control-Information-extension', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-Preamble-Control-Information-extension')))
    _Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__id._const_tab = ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__id_tab
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item_._ext = None
    _Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions._cont = __Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item_
    _Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_Preamble_Control_Information_extensionList_Item._cont = ASN1Dict([
        ('common-E-DCH-Preamble-Control-Information-extension', _Common_E_DCH_Preamble_Control_Information_extensionList_Item_common_E_DCH_Preamble_Control_Information_extension),
        ('iE-Extensions', _Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions),
        ])
    Common_E_DCH_Preamble_Control_Information_extensionList_Item._ext = []
    
    #-----< Common-E-DCH-Preamble-Control-Information-extensionList-Item-ExtIEs >-----#
    Common_E_DCH_Preamble_Control_Information_extensionList_Item_ExtIEs = CLASS(name='Common-E-DCH-Preamble-Control-Information-extensionList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_Preamble_Control_Information_extensionList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-Preamble-Control-Information-extension >-----#
    Common_E_DCH_Preamble_Control_Information_extension = SEQ(name='Common-E-DCH-Preamble-Control-Information-extension', mode=MODE_TYPE)
    _Common_E_DCH_Preamble_Control_Information_extension_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _Common_E_DCH_Preamble_Control_Information_extension_scramblingCodeNumber = INT(name='scramblingCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ScramblingCodeNumber')))
    _Common_E_DCH_Preamble_Control_Information_extension_common_E_DCH_PreambleSignatures = BIT_STR(name='common-E-DCH-PreambleSignatures', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PreambleSignatures')))
    _Common_E_DCH_Preamble_Control_Information_extension_preambleThreshold = INT(name='preambleThreshold', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PreambleThreshold')))
    _Common_E_DCH_Preamble_Control_Information_extension_common_E_DCH_AICH_Information = SEQ(name='common-E-DCH-AICH-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-AICH-Information')), opt=True)
    _Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__id._const_tab = ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__id_tab
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__id),
        ('criticality', ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item_._ext = None
    _Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions._cont = __Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item_
    _Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_Preamble_Control_Information_extension._cont = ASN1Dict([
        ('commonPhysicalChannelID', _Common_E_DCH_Preamble_Control_Information_extension_commonPhysicalChannelID),
        ('scramblingCodeNumber', _Common_E_DCH_Preamble_Control_Information_extension_scramblingCodeNumber),
        ('common-E-DCH-PreambleSignatures', _Common_E_DCH_Preamble_Control_Information_extension_common_E_DCH_PreambleSignatures),
        ('preambleThreshold', _Common_E_DCH_Preamble_Control_Information_extension_preambleThreshold),
        ('common-E-DCH-AICH-Information', _Common_E_DCH_Preamble_Control_Information_extension_common_E_DCH_AICH_Information),
        ('iE-Extensions', _Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions),
        ])
    Common_E_DCH_Preamble_Control_Information_extension._ext = []
    
    #-----< Common-E-DCH-Preamble-Control-Information-extension-Item-ExtIEs >-----#
    Common_E_DCH_Preamble_Control_Information_extension_Item_ExtIEs = CLASS(name='Common-E-DCH-Preamble-Control-Information-extension-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_Preamble_Control_Information_extension_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Configuration-for-2msTTI-Common-E-DCH-ResourcesList >-----#
    Configuration_for_2msTTI_Common_E_DCH_ResourcesList = SEQ_OF(name='Configuration-for-2msTTI-Common-E-DCH-ResourcesList', mode=MODE_TYPE)
    _Configuration_for_2msTTI_Common_E_DCH_ResourcesList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Configuration-for-2msTTI-Common-E-DCH-ResourcesList-Item')))
    Configuration_for_2msTTI_Common_E_DCH_ResourcesList._cont = _Configuration_for_2msTTI_Common_E_DCH_ResourcesList__item_
    Configuration_for_2msTTI_Common_E_DCH_ResourcesList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Configuration-for-2msTTI-Common-E-DCH-ResourcesList-Item >-----#
    Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item = SEQ(name='Configuration-for-2msTTI-Common-E-DCH-ResourcesList-Item', mode=MODE_TYPE)
    _Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_two_ms_HARQ_Process_Allocation = BIT_STR(name='two-ms-HARQ-Process-Allocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')))
    _Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__id._const_tab = ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__id_tab
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__id._const_tab_at = None
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__criticality._const_tab = ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__criticality_tab
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__extensionValue._const_tab = ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__extensionValue_tab
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__id),
        ('criticality', ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__extensionValue),
        ])
    __Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item_._ext = None
    _Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions._cont = __Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item_
    _Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item._cont = ASN1Dict([
        ('two-ms-HARQ-Process-Allocation', _Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_two_ms_HARQ_Process_Allocation),
        ('iE-Extensions', _Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions),
        ])
    Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item._ext = []
    
    #-----< Configuration-for-2msTTI-Common-E-DCH-ResourcesList-Item-ExtIEs >-----#
    Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_ExtIEs = CLASS(name='Configuration-for-2msTTI-Common-E-DCH-ResourcesList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Coffset >-----#
    Coffset = INT(name='Coffset', mode=MODE_TYPE)
    Coffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=29)], ev=None, er=[])
    
    #-----< CHOICE-DRX-level >-----#
    CHOICE_DRX_level = CHOICE(name='CHOICE-DRX-level', mode=MODE_TYPE)
    _CHOICE_DRX_level_one_level_DRX = SEQ(name='one-level-DRX', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'One-level-DRX')))
    _CHOICE_DRX_level_two_level_DRX = SEQ(name='two-level-DRX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Two-level-DRX')))
    CHOICE_DRX_level._cont = ASN1Dict([
        ('one-level-DRX', _CHOICE_DRX_level_one_level_DRX),
        ('two-level-DRX', _CHOICE_DRX_level_two_level_DRX),
        ])
    CHOICE_DRX_level._ext = []
    
    #-----< DATA-ID >-----#
    DATA_ID = INT(name='DATA-ID', mode=MODE_TYPE)
    DATA_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< DBDS-CorrectionsReq >-----#
    DBDS_CorrectionsReq = SEQ(name='DBDS-CorrectionsReq', mode=MODE_TYPE)
    _DBDS_CorrectionsReq_dGANSS_Signal_ID = BIT_STR(name='dGANSS-Signal-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_CorrectionsReq_dGANSS_Signal_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DBDS_CorrectionsReq_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DBDS_CorrectionsReq_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DBDS_CorrectionsReq_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DBDS_CorrectionsReq_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_CorrectionsReq_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_CorrectionsReq_ie_Extensions__item__id._const_tab = ____DBDS_CorrectionsReq_ie_Extensions__item__id_tab
    ___DBDS_CorrectionsReq_ie_Extensions__item__id._const_tab_at = None
    ___DBDS_CorrectionsReq_ie_Extensions__item__id._const_tab_id = 'id'
    ___DBDS_CorrectionsReq_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DBDS_CorrectionsReq_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_CorrectionsReq_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_CorrectionsReq_ie_Extensions__item__criticality._const_tab = ____DBDS_CorrectionsReq_ie_Extensions__item__criticality_tab
    ___DBDS_CorrectionsReq_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DBDS_CorrectionsReq_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DBDS_CorrectionsReq_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_CorrectionsReq_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue._const_tab = ____DBDS_CorrectionsReq_ie_Extensions__item__extensionValue_tab
    ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DBDS_CorrectionsReq_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DBDS_CorrectionsReq_ie_Extensions__item__id),
        ('criticality', ___DBDS_CorrectionsReq_ie_Extensions__item__criticality),
        ('extensionValue', ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue),
        ])
    __DBDS_CorrectionsReq_ie_Extensions__item_._ext = None
    _DBDS_CorrectionsReq_ie_Extensions._cont = __DBDS_CorrectionsReq_ie_Extensions__item_
    _DBDS_CorrectionsReq_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DBDS_CorrectionsReq._cont = ASN1Dict([
        ('dGANSS-Signal-ID', _DBDS_CorrectionsReq_dGANSS_Signal_ID),
        ('ie-Extensions', _DBDS_CorrectionsReq_ie_Extensions),
        ])
    DBDS_CorrectionsReq._ext = []
    
    #-----< DBDS-CorrectionsReq-ExtIEs >-----#
    DBDS_CorrectionsReq_ExtIEs = CLASS(name='DBDS-CorrectionsReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DBDS_CorrectionsReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DBDS-Corrections >-----#
    DBDS_Corrections = SEQ(name='DBDS-Corrections', mode=MODE_TYPE)
    _DBDS_Corrections_bDS_RefTime = INT(name='bDS-RefTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_Corrections_bDS_RefTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=119)], ev=None, er=[])
    _DBDS_Corrections_dBDS_InfoList = SEQ_OF(name='dBDS-InfoList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DBDS-InfoList')))
    _DBDS_Corrections_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DBDS_Corrections_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DBDS_Corrections_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DBDS_Corrections_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_Corrections_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Corrections_ie_Extensions__item__id._const_tab = ____DBDS_Corrections_ie_Extensions__item__id_tab
    ___DBDS_Corrections_ie_Extensions__item__id._const_tab_at = None
    ___DBDS_Corrections_ie_Extensions__item__id._const_tab_id = 'id'
    ___DBDS_Corrections_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DBDS_Corrections_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_Corrections_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Corrections_ie_Extensions__item__criticality._const_tab = ____DBDS_Corrections_ie_Extensions__item__criticality_tab
    ___DBDS_Corrections_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DBDS_Corrections_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DBDS_Corrections_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DBDS_Corrections_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_Corrections_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Corrections_ie_Extensions__item__extensionValue._const_tab = ____DBDS_Corrections_ie_Extensions__item__extensionValue_tab
    ___DBDS_Corrections_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DBDS_Corrections_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DBDS_Corrections_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DBDS_Corrections_ie_Extensions__item__id),
        ('criticality', ___DBDS_Corrections_ie_Extensions__item__criticality),
        ('extensionValue', ___DBDS_Corrections_ie_Extensions__item__extensionValue),
        ])
    __DBDS_Corrections_ie_Extensions__item_._ext = None
    _DBDS_Corrections_ie_Extensions._cont = __DBDS_Corrections_ie_Extensions__item_
    _DBDS_Corrections_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DBDS_Corrections._cont = ASN1Dict([
        ('bDS-RefTime', _DBDS_Corrections_bDS_RefTime),
        ('dBDS-InfoList', _DBDS_Corrections_dBDS_InfoList),
        ('ie-Extensions', _DBDS_Corrections_ie_Extensions),
        ])
    DBDS_Corrections._ext = []
    
    #-----< DBDS-Corrections-ExtIEs >-----#
    DBDS_Corrections_ExtIEs = CLASS(name='DBDS-Corrections-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DBDS_Corrections_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DBDS-Info >-----#
    DBDS_Info = SEQ(name='DBDS-Info', mode=MODE_TYPE)
    _DBDS_Info_dBDS_SignalID = INT(name='dBDS-SignalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Signal-ID')), opt=True)
    _DBDS_Info_dBDS_SignalInfoList = SEQ_OF(name='dBDS-SignalInfoList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DBDS-SignalInfoList')))
    _DBDS_Info_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DBDS_Info_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DBDS_Info_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DBDS_Info_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_Info_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Info_ie_Extensions__item__id._const_tab = ____DBDS_Info_ie_Extensions__item__id_tab
    ___DBDS_Info_ie_Extensions__item__id._const_tab_at = None
    ___DBDS_Info_ie_Extensions__item__id._const_tab_id = 'id'
    ___DBDS_Info_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DBDS_Info_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_Info_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Info_ie_Extensions__item__criticality._const_tab = ____DBDS_Info_ie_Extensions__item__criticality_tab
    ___DBDS_Info_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DBDS_Info_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DBDS_Info_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DBDS_Info_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_Info_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Info_ie_Extensions__item__extensionValue._const_tab = ____DBDS_Info_ie_Extensions__item__extensionValue_tab
    ___DBDS_Info_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DBDS_Info_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DBDS_Info_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DBDS_Info_ie_Extensions__item__id),
        ('criticality', ___DBDS_Info_ie_Extensions__item__criticality),
        ('extensionValue', ___DBDS_Info_ie_Extensions__item__extensionValue),
        ])
    __DBDS_Info_ie_Extensions__item_._ext = None
    _DBDS_Info_ie_Extensions._cont = __DBDS_Info_ie_Extensions__item_
    _DBDS_Info_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DBDS_Info._cont = ASN1Dict([
        ('dBDS-SignalID', _DBDS_Info_dBDS_SignalID),
        ('dBDS-SignalInfoList', _DBDS_Info_dBDS_SignalInfoList),
        ('ie-Extensions', _DBDS_Info_ie_Extensions),
        ])
    DBDS_Info._ext = []
    
    #-----< DBDS-Info-ExtIEs >-----#
    DBDS_Info_ExtIEs = CLASS(name='DBDS-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DBDS_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DBDS-SignalInfoList >-----#
    DBDS_SignalInfoList = SEQ_OF(name='DBDS-SignalInfoList', mode=MODE_TYPE)
    _DBDS_SignalInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DBDS-SignalInfo')))
    DBDS_SignalInfoList._cont = _DBDS_SignalInfoList__item_
    DBDS_SignalInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DBDS-SignalInfo >-----#
    DBDS_SignalInfo = SEQ(name='DBDS-SignalInfo', mode=MODE_TYPE)
    _DBDS_SignalInfo_svID = INT(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_SignalInfo_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _DBDS_SignalInfo_bds_UDREI = INT(name='bds-UDREI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_SignalInfo_bds_UDREI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _DBDS_SignalInfo_bds_RURAI = INT(name='bds-RURAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_SignalInfo_bds_RURAI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _DBDS_SignalInfo_bds_ECC_DeltaT = BIT_STR(name='bds-ECC-DeltaT', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_SignalInfo_bds_ECC_DeltaT._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _DBDS_SignalInfo_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DBDS_SignalInfo_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DBDS_SignalInfo_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DBDS_SignalInfo_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_SignalInfo_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_SignalInfo_ie_Extensions__item__id._const_tab = ____DBDS_SignalInfo_ie_Extensions__item__id_tab
    ___DBDS_SignalInfo_ie_Extensions__item__id._const_tab_at = None
    ___DBDS_SignalInfo_ie_Extensions__item__id._const_tab_id = 'id'
    ___DBDS_SignalInfo_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DBDS_SignalInfo_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_SignalInfo_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_SignalInfo_ie_Extensions__item__criticality._const_tab = ____DBDS_SignalInfo_ie_Extensions__item__criticality_tab
    ___DBDS_SignalInfo_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DBDS_SignalInfo_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DBDS_SignalInfo_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DBDS_SignalInfo_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DBDS_SignalInfo_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_SignalInfo_ie_Extensions__item__extensionValue._const_tab = ____DBDS_SignalInfo_ie_Extensions__item__extensionValue_tab
    ___DBDS_SignalInfo_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DBDS_SignalInfo_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DBDS_SignalInfo_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DBDS_SignalInfo_ie_Extensions__item__id),
        ('criticality', ___DBDS_SignalInfo_ie_Extensions__item__criticality),
        ('extensionValue', ___DBDS_SignalInfo_ie_Extensions__item__extensionValue),
        ])
    __DBDS_SignalInfo_ie_Extensions__item_._ext = None
    _DBDS_SignalInfo_ie_Extensions._cont = __DBDS_SignalInfo_ie_Extensions__item_
    _DBDS_SignalInfo_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DBDS_SignalInfo._cont = ASN1Dict([
        ('svID', _DBDS_SignalInfo_svID),
        ('bds-UDREI', _DBDS_SignalInfo_bds_UDREI),
        ('bds-RURAI', _DBDS_SignalInfo_bds_RURAI),
        ('bds-ECC-DeltaT', _DBDS_SignalInfo_bds_ECC_DeltaT),
        ('ie-Extensions', _DBDS_SignalInfo_ie_Extensions),
        ])
    DBDS_SignalInfo._ext = []
    
    #-----< DBDS-SignalInfo-ExtIEs >-----#
    DBDS_SignalInfo_ExtIEs = CLASS(name='DBDS-SignalInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DBDS_SignalInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DBDS-InfoList >-----#
    DBDS_InfoList = SEQ_OF(name='DBDS-InfoList', mode=MODE_TYPE)
    _DBDS_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DBDS-Info')))
    DBDS_InfoList._cont = _DBDS_InfoList__item_
    DBDS_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DCH-ENH-Information >-----#
    DCH_ENH_Information = SEQ(name='DCH-ENH-Information', mode=MODE_TYPE)
    _DCH_ENH_Information_pO_SRB = INT(name='pO-SRB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')))
    _DCH_ENH_Information_dl_FET_Mode = ENUM(name='dl-FET-Mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-FET-Mode')))
    _DCH_ENH_Information_dCH_ENH_Concat = SEQ_OF(name='dCH-ENH-Concat', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ENH-Concat')), opt=True)
    _DCH_ENH_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_ENH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_ENH_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_ENH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_iE_Extensions__item__id._const_tab = ____DCH_ENH_Information_iE_Extensions__item__id_tab
    ___DCH_ENH_Information_iE_Extensions__item__id._const_tab_at = None
    ___DCH_ENH_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_ENH_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DCH_ENH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_iE_Extensions__item__criticality._const_tab = ____DCH_ENH_Information_iE_Extensions__item__criticality_tab
    ___DCH_ENH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_ENH_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_ENH_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DCH_ENH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_iE_Extensions__item__extensionValue._const_tab = ____DCH_ENH_Information_iE_Extensions__item__extensionValue_tab
    ___DCH_ENH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_ENH_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_ENH_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_ENH_Information_iE_Extensions__item__id),
        ('criticality', ___DCH_ENH_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_ENH_Information_iE_Extensions__item__extensionValue),
        ])
    __DCH_ENH_Information_iE_Extensions__item_._ext = None
    _DCH_ENH_Information_iE_Extensions._cont = __DCH_ENH_Information_iE_Extensions__item_
    _DCH_ENH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_ENH_Information._cont = ASN1Dict([
        ('pO-SRB', _DCH_ENH_Information_pO_SRB),
        ('dl-FET-Mode', _DCH_ENH_Information_dl_FET_Mode),
        ('dCH-ENH-Concat', _DCH_ENH_Information_dCH_ENH_Concat),
        ('iE-Extensions', _DCH_ENH_Information_iE_Extensions),
        ])
    DCH_ENH_Information._ext = []
    
    #-----< DCH-ENH-Information-ExtIEs >-----#
    DCH_ENH_Information_ExtIEs = CLASS(name='DCH-ENH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DCH_ENH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-ENH-Information-to-Modify >-----#
    DCH_ENH_Information_to_Modify = SEQ(name='DCH-ENH-Information-to-Modify', mode=MODE_TYPE)
    _DCH_ENH_Information_to_Modify_pO_SRB = INT(name='pO-SRB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')), opt=True)
    _DCH_ENH_Information_to_Modify_dl_FET_Mode = ENUM(name='dl-FET-Mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-FET-Mode')), opt=True)
    _DCH_ENH_Information_to_Modify_dCH_ENH_Concat = SEQ_OF(name='dCH-ENH-Concat', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ENH-Concat')), opt=True)
    _DCH_ENH_Information_to_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_ENH_Information_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id._const_tab = ____DCH_ENH_Information_to_Modify_iE_Extensions__item__id_tab
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality._const_tab = ____DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality_tab
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue_tab
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_ENH_Information_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id),
        ('criticality', ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __DCH_ENH_Information_to_Modify_iE_Extensions__item_._ext = None
    _DCH_ENH_Information_to_Modify_iE_Extensions._cont = __DCH_ENH_Information_to_Modify_iE_Extensions__item_
    _DCH_ENH_Information_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_ENH_Information_to_Modify._cont = ASN1Dict([
        ('pO-SRB', _DCH_ENH_Information_to_Modify_pO_SRB),
        ('dl-FET-Mode', _DCH_ENH_Information_to_Modify_dl_FET_Mode),
        ('dCH-ENH-Concat', _DCH_ENH_Information_to_Modify_dCH_ENH_Concat),
        ('iE-Extensions', _DCH_ENH_Information_to_Modify_iE_Extensions),
        ])
    DCH_ENH_Information_to_Modify._ext = []
    
    #-----< DCH-ENH-Information-to-Modify-ExtIEs >-----#
    DCH_ENH_Information_to_Modify_ExtIEs = CLASS(name='DCH-ENH-Information-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DCH_ENH_Information_to_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-FET-Mode >-----#
    DL_FET_Mode = ENUM(name='DL-FET-Mode', mode=MODE_TYPE)
    DL_FET_Mode._cont = ASN1Dict([('basic', 0), ('full', 1)])
    DL_FET_Mode._ext = []
    
    #-----< DCH-ENH-Concat >-----#
    DCH_ENH_Concat = SEQ_OF(name='DCH-ENH-Concat', mode=MODE_TYPE)
    _DCH_ENH_Concat__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    DCH_ENH_Concat._cont = _DCH_ENH_Concat__item_
    DCH_ENH_Concat._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< DCH-ENH-Information-Reconf >-----#
    DCH_ENH_Information_Reconf = SEQ(name='DCH-ENH-Information-Reconf', mode=MODE_TYPE)
    _DCH_ENH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH = CHOICE(name='setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH')))
    _DCH_ENH_Information_Reconf_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_ENH_Information_Reconf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__id._const_tab = ____DCH_ENH_Information_Reconf_iE_Extensions__item__id_tab
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__id._const_tab_at = None
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality._const_tab = ____DCH_ENH_Information_Reconf_iE_Extensions__item__criticality_tab
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab = ____DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue_tab
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_ENH_Information_Reconf_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_ENH_Information_Reconf_iE_Extensions__item__id),
        ('criticality', ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue),
        ])
    __DCH_ENH_Information_Reconf_iE_Extensions__item_._ext = None
    _DCH_ENH_Information_Reconf_iE_Extensions._cont = __DCH_ENH_Information_Reconf_iE_Extensions__item_
    _DCH_ENH_Information_Reconf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_ENH_Information_Reconf._cont = ASN1Dict([
        ('setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH', _DCH_ENH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH),
        ('iE-Extensions', _DCH_ENH_Information_Reconf_iE_Extensions),
        ])
    DCH_ENH_Information_Reconf._ext = []
    
    #-----< DCH-ENH-Information-Reconf-ExtIEs >-----#
    DCH_ENH_Information_Reconf_ExtIEs = CLASS(name='DCH-ENH-Information-Reconf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DCH_ENH_Information_Reconf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-ENH-Information-Removal >-----#
    DCH_ENH_Information_Removal = ENUM(name='DCH-ENH-Information-Removal', mode=MODE_TYPE)
    DCH_ENH_Information_Removal._cont = ASN1Dict([('remove', 0)])
    DCH_ENH_Information_Removal._ext = []
    
    #-----< DCH-ID >-----#
    DCH_ID = INT(name='DCH-ID', mode=MODE_TYPE)
    DCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< DCH-FDD-Information >-----#
    DCH_FDD_Information = SEQ_OF(name='DCH-FDD-Information', mode=MODE_TYPE)
    _DCH_FDD_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-FDD-InformationItem')))
    DCH_FDD_Information._cont = _DCH_FDD_Information__item_
    DCH_FDD_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-FDD-InformationItem >-----#
    DCH_FDD_InformationItem = SEQ(name='DCH-FDD-InformationItem', mode=MODE_TYPE)
    _DCH_FDD_InformationItem_payloadCRC_PresenceIndicator = ENUM(name='payloadCRC-PresenceIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PayloadCRC-PresenceIndicator')))
    _DCH_FDD_InformationItem_ul_FP_Mode = ENUM(name='ul-FP-Mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-FP-Mode')))
    _DCH_FDD_InformationItem_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')))
    _DCH_FDD_InformationItem_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')))
    _DCH_FDD_InformationItem_dCH_SpecificInformationList = SEQ_OF(name='dCH-SpecificInformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-Specific-FDD-InformationList')))
    _DCH_FDD_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_FDD_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_FDD_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DCH_FDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____DCH_FDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DCH_FDD_InformationItem_iE_Extensions__item__id._const_tab = ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_FDD_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DCH_FDD_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_FDD_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DCH_FDD_InformationItem_iE_Extensions__item__criticality._const_tab = ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_FDD_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_FDD_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_FDD_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_FDD_InformationItem_iE_Extensions__item__id),
        ('criticality', ___DCH_FDD_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __DCH_FDD_InformationItem_iE_Extensions__item_._ext = None
    _DCH_FDD_InformationItem_iE_Extensions._cont = __DCH_FDD_InformationItem_iE_Extensions__item_
    _DCH_FDD_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_FDD_InformationItem._cont = ASN1Dict([
        ('payloadCRC-PresenceIndicator', _DCH_FDD_InformationItem_payloadCRC_PresenceIndicator),
        ('ul-FP-Mode', _DCH_FDD_InformationItem_ul_FP_Mode),
        ('toAWS', _DCH_FDD_InformationItem_toAWS),
        ('toAWE', _DCH_FDD_InformationItem_toAWE),
        ('dCH-SpecificInformationList', _DCH_FDD_InformationItem_dCH_SpecificInformationList),
        ('iE-Extensions', _DCH_FDD_InformationItem_iE_Extensions),
        ])
    DCH_FDD_InformationItem._ext = []
    
    #-----< DCH-FDD-InformationItem-ExtIEs >-----#
    DCH_FDD_InformationItem_ExtIEs = CLASS(name='DCH-FDD-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DCH_FDD_InformationItem_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    DCH_FDD_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _DCH_FDD_InformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-Specific-FDD-InformationList >-----#
    DCH_Specific_FDD_InformationList = SEQ_OF(name='DCH-Specific-FDD-InformationList', mode=MODE_TYPE)
    _DCH_Specific_FDD_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-Specific-FDD-Item')))
    DCH_Specific_FDD_InformationList._cont = _DCH_Specific_FDD_InformationList__item_
    DCH_Specific_FDD_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-Specific-FDD-Item >-----#
    DCH_Specific_FDD_Item = SEQ(name='DCH-Specific-FDD-Item', mode=MODE_TYPE)
    _DCH_Specific_FDD_Item_dCH_ID = INT(name='dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    _DCH_Specific_FDD_Item_ul_TransportFormatSet = SEQ(name='ul-TransportFormatSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _DCH_Specific_FDD_Item_dl_TransportFormatSet = SEQ(name='dl-TransportFormatSet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _DCH_Specific_FDD_Item_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')))
    _DCH_Specific_FDD_Item_frameHandlingPriority = INT(name='frameHandlingPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FrameHandlingPriority')))
    _DCH_Specific_FDD_Item_qE_Selector = ENUM(name='qE-Selector', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'QE-Selector')))
    _DCH_Specific_FDD_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_Specific_FDD_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_Specific_FDD_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Unidirectional-DCH-Indicator')))
    ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 602), ('criticality', 'reject'), ('Extension', _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DCH_Specific_FDD_Item_iE_Extensions__item__id._const_tab = ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_FDD_Item_iE_Extensions__item__id._const_tab_at = None
    ___DCH_Specific_FDD_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality._const_tab = ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue._const_tab = ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_Specific_FDD_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_Specific_FDD_Item_iE_Extensions__item__id),
        ('criticality', ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue),
        ])
    __DCH_Specific_FDD_Item_iE_Extensions__item_._ext = None
    _DCH_Specific_FDD_Item_iE_Extensions._cont = __DCH_Specific_FDD_Item_iE_Extensions__item_
    _DCH_Specific_FDD_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_Specific_FDD_Item._cont = ASN1Dict([
        ('dCH-ID', _DCH_Specific_FDD_Item_dCH_ID),
        ('ul-TransportFormatSet', _DCH_Specific_FDD_Item_ul_TransportFormatSet),
        ('dl-TransportFormatSet', _DCH_Specific_FDD_Item_dl_TransportFormatSet),
        ('allocationRetentionPriority', _DCH_Specific_FDD_Item_allocationRetentionPriority),
        ('frameHandlingPriority', _DCH_Specific_FDD_Item_frameHandlingPriority),
        ('qE-Selector', _DCH_Specific_FDD_Item_qE_Selector),
        ('iE-Extensions', _DCH_Specific_FDD_Item_iE_Extensions),
        ])
    DCH_Specific_FDD_Item._ext = []
    
    #-----< DCH-Specific-FDD-Item-ExtIEs >-----#
    DCH_Specific_FDD_Item_ExtIEs = CLASS(name='DCH-Specific-FDD-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DCH_Specific_FDD_Item_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Unidirectional-DCH-Indicator')))
    DCH_Specific_FDD_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 602), ('criticality', 'reject'), ('Extension', _DCH_Specific_FDD_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-Indicator-For-E-DCH-HSDPA-Operation >-----#
    DCH_Indicator_For_E_DCH_HSDPA_Operation = ENUM(name='DCH-Indicator-For-E-DCH-HSDPA-Operation', mode=MODE_TYPE)
    DCH_Indicator_For_E_DCH_HSDPA_Operation._cont = ASN1Dict([('dch-not-present', 0)])
    DCH_Indicator_For_E_DCH_HSDPA_Operation._ext = None
    
    #-----< DCH-InformationResponse >-----#
    DCH_InformationResponse = SEQ_OF(name='DCH-InformationResponse', mode=MODE_TYPE)
    _DCH_InformationResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponseItem')))
    DCH_InformationResponse._cont = _DCH_InformationResponse__item_
    DCH_InformationResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-InformationResponseItem >-----#
    DCH_InformationResponseItem = SEQ(name='DCH-InformationResponseItem', mode=MODE_TYPE)
    _DCH_InformationResponseItem_dCH_ID = INT(name='dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    _DCH_InformationResponseItem_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _DCH_InformationResponseItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _DCH_InformationResponseItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_InformationResponseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_InformationResponseItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_InformationResponseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DCH_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerNotSetupIndicator')))
    ____DCH_InformationResponseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 910), ('criticality', 'ignore'), ('Extension', _____DCH_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DCH_InformationResponseItem_iE_Extensions__item__id._const_tab = ____DCH_InformationResponseItem_iE_Extensions__item__id_tab
    ___DCH_InformationResponseItem_iE_Extensions__item__id._const_tab_at = None
    ___DCH_InformationResponseItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_InformationResponseItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab = ____DCH_InformationResponseItem_iE_Extensions__item__id_tab
    ___DCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab = ____DCH_InformationResponseItem_iE_Extensions__item__id_tab
    ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_InformationResponseItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_InformationResponseItem_iE_Extensions__item__id),
        ('criticality', ___DCH_InformationResponseItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue),
        ])
    __DCH_InformationResponseItem_iE_Extensions__item_._ext = None
    _DCH_InformationResponseItem_iE_Extensions._cont = __DCH_InformationResponseItem_iE_Extensions__item_
    _DCH_InformationResponseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_InformationResponseItem._cont = ASN1Dict([
        ('dCH-ID', _DCH_InformationResponseItem_dCH_ID),
        ('bindingID', _DCH_InformationResponseItem_bindingID),
        ('transportLayerAddress', _DCH_InformationResponseItem_transportLayerAddress),
        ('iE-Extensions', _DCH_InformationResponseItem_iE_Extensions),
        ])
    DCH_InformationResponseItem._ext = []
    
    #-----< DCH-InformationResponseItem-ExtIEs >-----#
    DCH_InformationResponseItem_ExtIEs = CLASS(name='DCH-InformationResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DCH_InformationResponseItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerNotSetupIndicator')))
    DCH_InformationResponseItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 910), ('criticality', 'ignore'), ('Extension', _DCH_InformationResponseItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-MeasurementOccasion-Information >-----#
    DCH_MeasurementOccasion_Information = SEQ_OF(name='DCH-MeasurementOccasion-Information', mode=MODE_TYPE)
    _DCH_MeasurementOccasion_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DchMeasurementOccasionInformation-Item')))
    DCH_MeasurementOccasion_Information._cont = _DCH_MeasurementOccasion_Information__item_
    DCH_MeasurementOccasion_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DchMeasurementOccasionInformation-Item >-----#
    DchMeasurementOccasionInformation_Item = SEQ(name='DchMeasurementOccasionInformation-Item', mode=MODE_TYPE)
    _DchMeasurementOccasionInformation_Item_pattern_Sequence_Identifier = INT(name='pattern-Sequence-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Pattern-Sequence-Identifier')))
    _DchMeasurementOccasionInformation_Item_status_Flag = ENUM(name='status-Flag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Status-Flag')))
    _DchMeasurementOccasionInformation_Item_measurement_Occasion_Pattern_Sequence_parameters = SEQ(name='measurement-Occasion-Pattern-Sequence-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Measurement-Occasion-Pattern-Sequence-parameters')), opt=True)
    _DchMeasurementOccasionInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DchMeasurementOccasionInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id._const_tab = ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__id_tab
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality._const_tab = ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality_tab
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue_tab
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DchMeasurementOccasionInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id),
        ('criticality', ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __DchMeasurementOccasionInformation_Item_iE_Extensions__item_._ext = None
    _DchMeasurementOccasionInformation_Item_iE_Extensions._cont = __DchMeasurementOccasionInformation_Item_iE_Extensions__item_
    _DchMeasurementOccasionInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DchMeasurementOccasionInformation_Item._cont = ASN1Dict([
        ('pattern-Sequence-Identifier', _DchMeasurementOccasionInformation_Item_pattern_Sequence_Identifier),
        ('status-Flag', _DchMeasurementOccasionInformation_Item_status_Flag),
        ('measurement-Occasion-Pattern-Sequence-parameters', _DchMeasurementOccasionInformation_Item_measurement_Occasion_Pattern_Sequence_parameters),
        ('iE-Extensions', _DchMeasurementOccasionInformation_Item_iE_Extensions),
        ])
    DchMeasurementOccasionInformation_Item._ext = []
    
    #-----< DCH-MeasurementOccasion-Information-ExtIEs >-----#
    DCH_MeasurementOccasion_Information_ExtIEs = CLASS(name='DCH-MeasurementOccasion-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DCH_MeasurementOccasion_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Measurement-Occasion-Pattern-Sequence-parameters >-----#
    Measurement_Occasion_Pattern_Sequence_parameters = SEQ(name='Measurement-Occasion-Pattern-Sequence-parameters', mode=MODE_TYPE)
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_k = INT(name='measurement-Occasion-Pattern-Sequence-parameters-k', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_k._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_offset = INT(name='measurement-Occasion-Pattern-Sequence-parameters-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_M_Length = INT(name='measurement-Occasion-Pattern-Sequence-parameters-M-Length', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_M_Length._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_Timeslot_Bitmap = BIT_STR(name='measurement-Occasion-Pattern-Sequence-parameters-Timeslot-Bitmap', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_Timeslot_Bitmap._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id._const_tab = ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id_tab
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id._const_tab_at = None
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality._const_tab = ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality_tab
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue._const_tab = ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue_tab
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id),
        ('criticality', ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue),
        ])
    __Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item_._ext = None
    _Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions._cont = __Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item_
    _Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Measurement_Occasion_Pattern_Sequence_parameters._cont = ASN1Dict([
        ('measurement-Occasion-Pattern-Sequence-parameters-k', _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_k),
        ('measurement-Occasion-Pattern-Sequence-parameters-offset', _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_offset),
        ('measurement-Occasion-Pattern-Sequence-parameters-M-Length', _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_M_Length),
        ('measurement-Occasion-Pattern-Sequence-parameters-Timeslot-Bitmap', _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_Timeslot_Bitmap),
        ('iE-Extensions', _Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions),
        ])
    Measurement_Occasion_Pattern_Sequence_parameters._ext = []
    
    #-----< Measurement-Occasion-Pattern-Sequence-parameters-ExtIEs >-----#
    Measurement_Occasion_Pattern_Sequence_parameters_ExtIEs = CLASS(name='Measurement-Occasion-Pattern-Sequence-parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Measurement_Occasion_Pattern_Sequence_parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-TDD-Information >-----#
    DCH_TDD_Information = SEQ_OF(name='DCH-TDD-Information', mode=MODE_TYPE)
    _DCH_TDD_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-TDD-InformationItem')))
    DCH_TDD_Information._cont = _DCH_TDD_Information__item_
    DCH_TDD_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-TDD-InformationItem >-----#
    DCH_TDD_InformationItem = SEQ(name='DCH-TDD-InformationItem', mode=MODE_TYPE)
    _DCH_TDD_InformationItem_payloadCRC_PresenceIndicator = ENUM(name='payloadCRC-PresenceIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PayloadCRC-PresenceIndicator')))
    _DCH_TDD_InformationItem_ul_FP_Mode = ENUM(name='ul-FP-Mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-FP-Mode')))
    _DCH_TDD_InformationItem_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')))
    _DCH_TDD_InformationItem_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')))
    _DCH_TDD_InformationItem_dCH_SpecificInformationList = SEQ_OF(name='dCH-SpecificInformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-Specific-TDD-InformationList')))
    _DCH_TDD_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_TDD_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_TDD_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____DCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DCH_TDD_InformationItem_iE_Extensions__item__id._const_tab = ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_TDD_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab = ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_TDD_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_TDD_InformationItem_iE_Extensions__item__id),
        ('criticality', ___DCH_TDD_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __DCH_TDD_InformationItem_iE_Extensions__item_._ext = None
    _DCH_TDD_InformationItem_iE_Extensions._cont = __DCH_TDD_InformationItem_iE_Extensions__item_
    _DCH_TDD_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_TDD_InformationItem._cont = ASN1Dict([
        ('payloadCRC-PresenceIndicator', _DCH_TDD_InformationItem_payloadCRC_PresenceIndicator),
        ('ul-FP-Mode', _DCH_TDD_InformationItem_ul_FP_Mode),
        ('toAWS', _DCH_TDD_InformationItem_toAWS),
        ('toAWE', _DCH_TDD_InformationItem_toAWE),
        ('dCH-SpecificInformationList', _DCH_TDD_InformationItem_dCH_SpecificInformationList),
        ('iE-Extensions', _DCH_TDD_InformationItem_iE_Extensions),
        ])
    DCH_TDD_InformationItem._ext = []
    
    #-----< DCH-TDD-InformationItem-ExtIEs >-----#
    DCH_TDD_InformationItem_ExtIEs = CLASS(name='DCH-TDD-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DCH_TDD_InformationItem_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    DCH_TDD_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _DCH_TDD_InformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-Specific-TDD-InformationList >-----#
    DCH_Specific_TDD_InformationList = SEQ_OF(name='DCH-Specific-TDD-InformationList', mode=MODE_TYPE)
    _DCH_Specific_TDD_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-Specific-TDD-Item')))
    DCH_Specific_TDD_InformationList._cont = _DCH_Specific_TDD_InformationList__item_
    DCH_Specific_TDD_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-Specific-TDD-Item >-----#
    DCH_Specific_TDD_Item = SEQ(name='DCH-Specific-TDD-Item', mode=MODE_TYPE)
    _DCH_Specific_TDD_Item_dCH_ID = INT(name='dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    _DCH_Specific_TDD_Item_ul_CCTrCH_ID = INT(name='ul-CCTrCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _DCH_Specific_TDD_Item_dl_CCTrCH_ID = INT(name='dl-CCTrCH-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _DCH_Specific_TDD_Item_ul_TransportFormatSet = SEQ(name='ul-TransportFormatSet', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _DCH_Specific_TDD_Item_dl_TransportFormatSet = SEQ(name='dl-TransportFormatSet', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _DCH_Specific_TDD_Item_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')))
    _DCH_Specific_TDD_Item_frameHandlingPriority = INT(name='frameHandlingPriority', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FrameHandlingPriority')))
    _DCH_Specific_TDD_Item_qE_Selector = ENUM(name='qE-Selector', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'QE-Selector')), opt=True)
    _DCH_Specific_TDD_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_Specific_TDD_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_Specific_TDD_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Unidirectional-DCH-Indicator')))
    ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 602), ('criticality', 'reject'), ('Extension', _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DCH_Specific_TDD_Item_iE_Extensions__item__id._const_tab = ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_TDD_Item_iE_Extensions__item__id._const_tab_at = None
    ___DCH_Specific_TDD_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality._const_tab = ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue._const_tab = ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_Specific_TDD_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_Specific_TDD_Item_iE_Extensions__item__id),
        ('criticality', ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue),
        ])
    __DCH_Specific_TDD_Item_iE_Extensions__item_._ext = None
    _DCH_Specific_TDD_Item_iE_Extensions._cont = __DCH_Specific_TDD_Item_iE_Extensions__item_
    _DCH_Specific_TDD_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_Specific_TDD_Item._cont = ASN1Dict([
        ('dCH-ID', _DCH_Specific_TDD_Item_dCH_ID),
        ('ul-CCTrCH-ID', _DCH_Specific_TDD_Item_ul_CCTrCH_ID),
        ('dl-CCTrCH-ID', _DCH_Specific_TDD_Item_dl_CCTrCH_ID),
        ('ul-TransportFormatSet', _DCH_Specific_TDD_Item_ul_TransportFormatSet),
        ('dl-TransportFormatSet', _DCH_Specific_TDD_Item_dl_TransportFormatSet),
        ('allocationRetentionPriority', _DCH_Specific_TDD_Item_allocationRetentionPriority),
        ('frameHandlingPriority', _DCH_Specific_TDD_Item_frameHandlingPriority),
        ('qE-Selector', _DCH_Specific_TDD_Item_qE_Selector),
        ('iE-Extensions', _DCH_Specific_TDD_Item_iE_Extensions),
        ])
    DCH_Specific_TDD_Item._ext = []
    
    #-----< DCH-Specific-TDD-Item-ExtIEs >-----#
    DCH_Specific_TDD_Item_ExtIEs = CLASS(name='DCH-Specific-TDD-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DCH_Specific_TDD_Item_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Unidirectional-DCH-Indicator')))
    DCH_Specific_TDD_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 602), ('criticality', 'reject'), ('Extension', _DCH_Specific_TDD_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< FDD-DCHs-to-Modify >-----#
    FDD_DCHs_to_Modify = SEQ_OF(name='FDD-DCHs-to-Modify', mode=MODE_TYPE)
    _FDD_DCHs_to_Modify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FDD-DCHs-to-ModifyItem')))
    FDD_DCHs_to_Modify._cont = _FDD_DCHs_to_Modify__item_
    FDD_DCHs_to_Modify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< FDD-DCHs-to-ModifyItem >-----#
    FDD_DCHs_to_ModifyItem = SEQ(name='FDD-DCHs-to-ModifyItem', mode=MODE_TYPE)
    _FDD_DCHs_to_ModifyItem_ul_FP_Mode = ENUM(name='ul-FP-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-FP-Mode')), opt=True)
    _FDD_DCHs_to_ModifyItem_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')), opt=True)
    _FDD_DCHs_to_ModifyItem_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')), opt=True)
    _FDD_DCHs_to_ModifyItem_transportBearerRequestIndicator = ENUM(name='transportBearerRequestIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    _FDD_DCHs_to_ModifyItem_dCH_SpecificInformationList = SEQ_OF(name='dCH-SpecificInformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ModifySpecificInformation-FDD')))
    _FDD_DCHs_to_ModifyItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_DCHs_to_ModifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id._const_tab = ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id._const_tab_at = None
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality._const_tab = ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue._const_tab = ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FDD_DCHs_to_ModifyItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id),
        ('criticality', ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality),
        ('extensionValue', ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue),
        ])
    __FDD_DCHs_to_ModifyItem_iE_Extensions__item_._ext = None
    _FDD_DCHs_to_ModifyItem_iE_Extensions._cont = __FDD_DCHs_to_ModifyItem_iE_Extensions__item_
    _FDD_DCHs_to_ModifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_DCHs_to_ModifyItem._cont = ASN1Dict([
        ('ul-FP-Mode', _FDD_DCHs_to_ModifyItem_ul_FP_Mode),
        ('toAWS', _FDD_DCHs_to_ModifyItem_toAWS),
        ('toAWE', _FDD_DCHs_to_ModifyItem_toAWE),
        ('transportBearerRequestIndicator', _FDD_DCHs_to_ModifyItem_transportBearerRequestIndicator),
        ('dCH-SpecificInformationList', _FDD_DCHs_to_ModifyItem_dCH_SpecificInformationList),
        ('iE-Extensions', _FDD_DCHs_to_ModifyItem_iE_Extensions),
        ])
    FDD_DCHs_to_ModifyItem._ext = []
    
    #-----< FDD-DCHs-to-ModifyItem-ExtIEs >-----#
    FDD_DCHs_to_ModifyItem_ExtIEs = CLASS(name='FDD-DCHs-to-ModifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _FDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    FDD_DCHs_to_ModifyItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _FDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-ModifySpecificInformation-FDD >-----#
    DCH_ModifySpecificInformation_FDD = SEQ_OF(name='DCH-ModifySpecificInformation-FDD', mode=MODE_TYPE)
    _DCH_ModifySpecificInformation_FDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-ModifySpecificItem-FDD')))
    DCH_ModifySpecificInformation_FDD._cont = _DCH_ModifySpecificInformation_FDD__item_
    DCH_ModifySpecificInformation_FDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-ModifySpecificItem-FDD >-----#
    DCH_ModifySpecificItem_FDD = SEQ(name='DCH-ModifySpecificItem-FDD', mode=MODE_TYPE)
    _DCH_ModifySpecificItem_FDD_dCH_ID = INT(name='dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    _DCH_ModifySpecificItem_FDD_ul_TransportFormatSet = SEQ(name='ul-TransportFormatSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')), opt=True)
    _DCH_ModifySpecificItem_FDD_dl_TransportFormatSet = SEQ(name='dl-TransportFormatSet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')), opt=True)
    _DCH_ModifySpecificItem_FDD_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _DCH_ModifySpecificItem_FDD_frameHandlingPriority = INT(name='frameHandlingPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FrameHandlingPriority')), opt=True)
    _DCH_ModifySpecificItem_FDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_ModifySpecificItem_FDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_ModifySpecificItem_FDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DCH_ModifySpecificItem_FDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Unidirectional-DCH-Indicator')))
    ____DCH_ModifySpecificItem_FDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 602), ('criticality', 'reject'), ('Extension', _____DCH_ModifySpecificItem_FDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__id._const_tab = ____DCH_ModifySpecificItem_FDD_iE_Extensions__item__id_tab
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__criticality._const_tab = ____DCH_ModifySpecificItem_FDD_iE_Extensions__item__id_tab
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_ModifySpecificItem_FDD_iE_Extensions__item__id_tab
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_ModifySpecificItem_FDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__id),
        ('criticality', ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_ModifySpecificItem_FDD_iE_Extensions__item_._ext = None
    _DCH_ModifySpecificItem_FDD_iE_Extensions._cont = __DCH_ModifySpecificItem_FDD_iE_Extensions__item_
    _DCH_ModifySpecificItem_FDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_ModifySpecificItem_FDD._cont = ASN1Dict([
        ('dCH-ID', _DCH_ModifySpecificItem_FDD_dCH_ID),
        ('ul-TransportFormatSet', _DCH_ModifySpecificItem_FDD_ul_TransportFormatSet),
        ('dl-TransportFormatSet', _DCH_ModifySpecificItem_FDD_dl_TransportFormatSet),
        ('allocationRetentionPriority', _DCH_ModifySpecificItem_FDD_allocationRetentionPriority),
        ('frameHandlingPriority', _DCH_ModifySpecificItem_FDD_frameHandlingPriority),
        ('iE-Extensions', _DCH_ModifySpecificItem_FDD_iE_Extensions),
        ])
    DCH_ModifySpecificItem_FDD._ext = []
    
    #-----< DCH-ModifySpecificItem-FDD-ExtIEs >-----#
    DCH_ModifySpecificItem_FDD_ExtIEs = CLASS(name='DCH-ModifySpecificItem-FDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DCH_ModifySpecificItem_FDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Unidirectional-DCH-Indicator')))
    DCH_ModifySpecificItem_FDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 602), ('criticality', 'reject'), ('Extension', _DCH_ModifySpecificItem_FDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TDD-DCHs-to-Modify >-----#
    TDD_DCHs_to_Modify = SEQ_OF(name='TDD-DCHs-to-Modify', mode=MODE_TYPE)
    _TDD_DCHs_to_Modify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-ModifyItem-TDD')))
    TDD_DCHs_to_Modify._cont = _TDD_DCHs_to_Modify__item_
    TDD_DCHs_to_Modify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-ModifyItem-TDD >-----#
    DCH_ModifyItem_TDD = SEQ(name='DCH-ModifyItem-TDD', mode=MODE_TYPE)
    _DCH_ModifyItem_TDD_ul_FP_Mode = ENUM(name='ul-FP-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-FP-Mode')), opt=True)
    _DCH_ModifyItem_TDD_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')), opt=True)
    _DCH_ModifyItem_TDD_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')), opt=True)
    _DCH_ModifyItem_TDD_transportBearerRequestIndicator = ENUM(name='transportBearerRequestIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    _DCH_ModifyItem_TDD_dCH_SpecificInformationList = SEQ_OF(name='dCH-SpecificInformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ModifySpecificInformation-TDD')))
    _DCH_ModifyItem_TDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_ModifyItem_TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_ModifyItem_TDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_ModifyItem_TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DCH_ModifyItem_TDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____DCH_ModifyItem_TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____DCH_ModifyItem_TDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DCH_ModifyItem_TDD_iE_Extensions__item__id._const_tab = ____DCH_ModifyItem_TDD_iE_Extensions__item__id_tab
    ___DCH_ModifyItem_TDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_ModifyItem_TDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_ModifyItem_TDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DCH_ModifyItem_TDD_iE_Extensions__item__criticality._const_tab = ____DCH_ModifyItem_TDD_iE_Extensions__item__id_tab
    ___DCH_ModifyItem_TDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_ModifyItem_TDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_ModifyItem_TDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DCH_ModifyItem_TDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_ModifyItem_TDD_iE_Extensions__item__id_tab
    ___DCH_ModifyItem_TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_ModifyItem_TDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_ModifyItem_TDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_ModifyItem_TDD_iE_Extensions__item__id),
        ('criticality', ___DCH_ModifyItem_TDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_ModifyItem_TDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_ModifyItem_TDD_iE_Extensions__item_._ext = None
    _DCH_ModifyItem_TDD_iE_Extensions._cont = __DCH_ModifyItem_TDD_iE_Extensions__item_
    _DCH_ModifyItem_TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_ModifyItem_TDD._cont = ASN1Dict([
        ('ul-FP-Mode', _DCH_ModifyItem_TDD_ul_FP_Mode),
        ('toAWS', _DCH_ModifyItem_TDD_toAWS),
        ('toAWE', _DCH_ModifyItem_TDD_toAWE),
        ('transportBearerRequestIndicator', _DCH_ModifyItem_TDD_transportBearerRequestIndicator),
        ('dCH-SpecificInformationList', _DCH_ModifyItem_TDD_dCH_SpecificInformationList),
        ('iE-Extensions', _DCH_ModifyItem_TDD_iE_Extensions),
        ])
    DCH_ModifyItem_TDD._ext = []
    
    #-----< TDD-DCHs-to-ModifyItem-ExtIEs >-----#
    TDD_DCHs_to_ModifyItem_ExtIEs = CLASS(name='TDD-DCHs-to-ModifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _TDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    TDD_DCHs_to_ModifyItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _TDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-ModifySpecificInformation-TDD >-----#
    DCH_ModifySpecificInformation_TDD = SEQ_OF(name='DCH-ModifySpecificInformation-TDD', mode=MODE_TYPE)
    _DCH_ModifySpecificInformation_TDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-ModifySpecificItem-TDD')))
    DCH_ModifySpecificInformation_TDD._cont = _DCH_ModifySpecificInformation_TDD__item_
    DCH_ModifySpecificInformation_TDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-ModifySpecificItem-TDD >-----#
    DCH_ModifySpecificItem_TDD = SEQ(name='DCH-ModifySpecificItem-TDD', mode=MODE_TYPE)
    _DCH_ModifySpecificItem_TDD_dCH_ID = INT(name='dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    _DCH_ModifySpecificItem_TDD_ul_CCTrCH_ID = INT(name='ul-CCTrCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')), opt=True)
    _DCH_ModifySpecificItem_TDD_dl_CCTrCH_ID = INT(name='dl-CCTrCH-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')), opt=True)
    _DCH_ModifySpecificItem_TDD_ul_TransportFormatSet = SEQ(name='ul-TransportFormatSet', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')), opt=True)
    _DCH_ModifySpecificItem_TDD_dl_TransportFormatSet = SEQ(name='dl-TransportFormatSet', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')), opt=True)
    _DCH_ModifySpecificItem_TDD_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _DCH_ModifySpecificItem_TDD_frameHandlingPriority = INT(name='frameHandlingPriority', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FrameHandlingPriority')), opt=True)
    _DCH_ModifySpecificItem_TDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_ModifySpecificItem_TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__id._const_tab = ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__id_tab
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__criticality._const_tab = ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__criticality_tab
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__extensionValue_tab
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_ModifySpecificItem_TDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__id),
        ('criticality', ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_ModifySpecificItem_TDD_iE_Extensions__item_._ext = None
    _DCH_ModifySpecificItem_TDD_iE_Extensions._cont = __DCH_ModifySpecificItem_TDD_iE_Extensions__item_
    _DCH_ModifySpecificItem_TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_ModifySpecificItem_TDD._cont = ASN1Dict([
        ('dCH-ID', _DCH_ModifySpecificItem_TDD_dCH_ID),
        ('ul-CCTrCH-ID', _DCH_ModifySpecificItem_TDD_ul_CCTrCH_ID),
        ('dl-CCTrCH-ID', _DCH_ModifySpecificItem_TDD_dl_CCTrCH_ID),
        ('ul-TransportFormatSet', _DCH_ModifySpecificItem_TDD_ul_TransportFormatSet),
        ('dl-TransportFormatSet', _DCH_ModifySpecificItem_TDD_dl_TransportFormatSet),
        ('allocationRetentionPriority', _DCH_ModifySpecificItem_TDD_allocationRetentionPriority),
        ('frameHandlingPriority', _DCH_ModifySpecificItem_TDD_frameHandlingPriority),
        ('iE-Extensions', _DCH_ModifySpecificItem_TDD_iE_Extensions),
        ])
    DCH_ModifySpecificItem_TDD._ext = []
    
    #-----< DCH-ModifySpecificItem-TDD-ExtIEs >-----#
    DCH_ModifySpecificItem_TDD_ExtIEs = CLASS(name='DCH-ModifySpecificItem-TDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DCH_ModifySpecificItem_TDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DecimationFactor >-----#
    DecimationFactor = ENUM(name='DecimationFactor', mode=MODE_TYPE)
    DecimationFactor._cont = ASN1Dict([('slots3', 0), ('slots5', 1)])
    DecimationFactor._ext = None
    
    #-----< DedicatedChannelsCapacityConsumptionLaw >-----#
    DedicatedChannelsCapacityConsumptionLaw = SEQ_OF(name='DedicatedChannelsCapacityConsumptionLaw', mode=MODE_TYPE)
    _DedicatedChannelsCapacityConsumptionLaw__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __DedicatedChannelsCapacityConsumptionLaw__item__dl_Cost_1 = INT(name='dl-Cost-1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DedicatedChannelsCapacityConsumptionLaw__item__dl_Cost_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __DedicatedChannelsCapacityConsumptionLaw__item__dl_Cost_2 = INT(name='dl-Cost-2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DedicatedChannelsCapacityConsumptionLaw__item__dl_Cost_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __DedicatedChannelsCapacityConsumptionLaw__item__ul_Cost_1 = INT(name='ul-Cost-1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DedicatedChannelsCapacityConsumptionLaw__item__ul_Cost_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __DedicatedChannelsCapacityConsumptionLaw__item__ul_Cost_2 = INT(name='ul-Cost-2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DedicatedChannelsCapacityConsumptionLaw__item__ul_Cost_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id._const_tab = _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id_tab
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id._const_tab_at = None
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality._const_tab = _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality_tab
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue._const_tab = _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue_tab
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id),
        ('criticality', ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality),
        ('extensionValue', ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue),
        ])
    ___DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item_._ext = None
    __DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions._cont = ___DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item_
    __DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _DedicatedChannelsCapacityConsumptionLaw__item_._cont = ASN1Dict([
        ('dl-Cost-1', __DedicatedChannelsCapacityConsumptionLaw__item__dl_Cost_1),
        ('dl-Cost-2', __DedicatedChannelsCapacityConsumptionLaw__item__dl_Cost_2),
        ('ul-Cost-1', __DedicatedChannelsCapacityConsumptionLaw__item__ul_Cost_1),
        ('ul-Cost-2', __DedicatedChannelsCapacityConsumptionLaw__item__ul_Cost_2),
        ('iE-Extensions', __DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions),
        ])
    _DedicatedChannelsCapacityConsumptionLaw__item_._ext = []
    DedicatedChannelsCapacityConsumptionLaw._cont = _DedicatedChannelsCapacityConsumptionLaw__item_
    DedicatedChannelsCapacityConsumptionLaw._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DedicatedChannelsCapacityConsumptionLaw-ExtIEs >-----#
    DedicatedChannelsCapacityConsumptionLaw_ExtIEs = CLASS(name='DedicatedChannelsCapacityConsumptionLaw-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DedicatedChannelsCapacityConsumptionLaw_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementType >-----#
    DedicatedMeasurementType = ENUM(name='DedicatedMeasurementType', mode=MODE_TYPE)
    DedicatedMeasurementType._cont = ASN1Dict([('sir', 0), ('sir-error', 1), ('transmitted-code-power', 2), ('rscp', 3), ('rx-timing-deviation', 4), ('round-trip-time', 5), ('rx-timing-deviation-LCR', 6), ('angle-Of-Arrival-LCR', 7), ('hs-sich-quality', 8), ('best-Cell-Portions', 9), ('rx-timing-deviation-768', 10), ('rx-timing-deviation-384-extended', 11), ('best-Cell-PortionsLCR', 12), ('aOA-per-CELL-Portion-LCR', 13), ('uE-transmission-power-headroom', 14), ('dl-TBS', 15)])
    DedicatedMeasurementType._ext = ['rx-timing-deviation-LCR', 'angle-Of-Arrival-LCR', 'hs-sich-quality', 'best-Cell-Portions', 'rx-timing-deviation-768', 'rx-timing-deviation-384-extended', 'best-Cell-PortionsLCR', 'aOA-per-CELL-Portion-LCR', 'uE-transmission-power-headroom', 'dl-TBS']
    
    #-----< DedicatedMeasurementValue >-----#
    DedicatedMeasurementValue = CHOICE(name='DedicatedMeasurementValue', mode=MODE_TYPE)
    _DedicatedMeasurementValue_sIR_Value = INT(name='sIR-Value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SIR-Value')))
    _DedicatedMeasurementValue_sIR_ErrorValue = INT(name='sIR-ErrorValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SIR-Error-Value')))
    _DedicatedMeasurementValue_transmittedCodePowerValue = INT(name='transmittedCodePowerValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Code-Power-Value')))
    _DedicatedMeasurementValue_rSCP = INT(name='rSCP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RSCP-Value')))
    _DedicatedMeasurementValue_rxTimingDeviationValue = INT(name='rxTimingDeviationValue', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value')))
    _DedicatedMeasurementValue_roundTripTime = INT(name='roundTripTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Round-Trip-Time-Value')))
    _DedicatedMeasurementValue_extension_DedicatedMeasurementValue = SEQ(name='extension-DedicatedMeasurementValue', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Extension-DedicatedMeasurementValue')))
    DedicatedMeasurementValue._cont = ASN1Dict([
        ('sIR-Value', _DedicatedMeasurementValue_sIR_Value),
        ('sIR-ErrorValue', _DedicatedMeasurementValue_sIR_ErrorValue),
        ('transmittedCodePowerValue', _DedicatedMeasurementValue_transmittedCodePowerValue),
        ('rSCP', _DedicatedMeasurementValue_rSCP),
        ('rxTimingDeviationValue', _DedicatedMeasurementValue_rxTimingDeviationValue),
        ('roundTripTime', _DedicatedMeasurementValue_roundTripTime),
        ('extension-DedicatedMeasurementValue', _DedicatedMeasurementValue_extension_DedicatedMeasurementValue),
        ])
    DedicatedMeasurementValue._ext = ['extension-DedicatedMeasurementValue']
    
    #-----< Extension-DedicatedMeasurementValue >-----#
    Extension_DedicatedMeasurementValue = SEQ(name='Extension-DedicatedMeasurementValue', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_DedicatedMeasurementValue_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_DedicatedMeasurementValue_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-LCR')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Angle-Of-Arrival-Value-LCR')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-Reception-Quality-Value')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Best-Cell-Portions-Value')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-768')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-384-ext')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-Round-Trip-Time-Value')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Best-Cell-Portions-ValueLCR')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AOA-per-CELL-Portion-LCR')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-transmission-power-headroom-Value')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TBS')))
    __Extension_DedicatedMeasurementValue_id_tab._val = ASN1Set(rv=[dict([('id', 520), ('criticality', 'reject'), ('Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 521), ('criticality', 'reject'), ('Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 588), ('criticality', 'reject'), ('Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 593), ('criticality', 'reject'), ('Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 762), ('criticality', 'reject'), ('Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 786), ('criticality', 'reject'), ('Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 820), ('criticality', 'reject'), ('Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 1106), ('criticality', 'reject'), ('Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 1206), ('criticality', 'reject'), ('Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_8), ('presence', 'mandatory')]), dict([('id', 1225), ('criticality', 'reject'), ('Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_9), ('presence', 'mandatory')]), dict([('id', 1311), ('criticality', 'reject'), ('Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_10), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_DedicatedMeasurementValue_id._const_tab = __Extension_DedicatedMeasurementValue_id_tab
    _Extension_DedicatedMeasurementValue_id._const_tab_at = None
    _Extension_DedicatedMeasurementValue_id._const_tab_id = 'id'
    _Extension_DedicatedMeasurementValue_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_DedicatedMeasurementValue_criticality._const_tab = __Extension_DedicatedMeasurementValue_id_tab
    _Extension_DedicatedMeasurementValue_criticality._const_tab_at = ('..', 'id')
    _Extension_DedicatedMeasurementValue_criticality._const_tab_id = 'criticality'
    _Extension_DedicatedMeasurementValue_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_DedicatedMeasurementValue_value._const_tab = __Extension_DedicatedMeasurementValue_id_tab
    _Extension_DedicatedMeasurementValue_value._const_tab_at = ('..', 'id')
    _Extension_DedicatedMeasurementValue_value._const_tab_id = 'Value'
    Extension_DedicatedMeasurementValue._cont = ASN1Dict([
        ('id', _Extension_DedicatedMeasurementValue_id),
        ('criticality', _Extension_DedicatedMeasurementValue_criticality),
        ('value', _Extension_DedicatedMeasurementValue_value),
        ])
    Extension_DedicatedMeasurementValue._ext = None
    
    #-----< Extension-DedicatedMeasurementValueIE >-----#
    Extension_DedicatedMeasurementValueIE = CLASS(name='Extension-DedicatedMeasurementValueIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_DedicatedMeasurementValueIE_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-LCR')))
    _Extension_DedicatedMeasurementValueIE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Angle-Of-Arrival-Value-LCR')))
    _Extension_DedicatedMeasurementValueIE_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-Reception-Quality-Value')))
    _Extension_DedicatedMeasurementValueIE_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Best-Cell-Portions-Value')))
    _Extension_DedicatedMeasurementValueIE_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-768')))
    _Extension_DedicatedMeasurementValueIE_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-384-ext')))
    _Extension_DedicatedMeasurementValueIE_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-Round-Trip-Time-Value')))
    _Extension_DedicatedMeasurementValueIE_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Best-Cell-Portions-ValueLCR')))
    _Extension_DedicatedMeasurementValueIE_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AOA-per-CELL-Portion-LCR')))
    _Extension_DedicatedMeasurementValueIE_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-transmission-power-headroom-Value')))
    _Extension_DedicatedMeasurementValueIE_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TBS')))
    Extension_DedicatedMeasurementValueIE._val = ASN1Set(rv=[dict([('id', 520), ('criticality', 'reject'), ('Value', _Extension_DedicatedMeasurementValueIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 521), ('criticality', 'reject'), ('Value', _Extension_DedicatedMeasurementValueIE_val_Value_1), ('presence', 'mandatory')]), dict([('id', 588), ('criticality', 'reject'), ('Value', _Extension_DedicatedMeasurementValueIE_val_Value_2), ('presence', 'mandatory')]), dict([('id', 593), ('criticality', 'reject'), ('Value', _Extension_DedicatedMeasurementValueIE_val_Value_3), ('presence', 'mandatory')]), dict([('id', 762), ('criticality', 'reject'), ('Value', _Extension_DedicatedMeasurementValueIE_val_Value_4), ('presence', 'mandatory')]), dict([('id', 786), ('criticality', 'reject'), ('Value', _Extension_DedicatedMeasurementValueIE_val_Value_5), ('presence', 'mandatory')]), dict([('id', 820), ('criticality', 'reject'), ('Value', _Extension_DedicatedMeasurementValueIE_val_Value_6), ('presence', 'mandatory')]), dict([('id', 1106), ('criticality', 'reject'), ('Value', _Extension_DedicatedMeasurementValueIE_val_Value_7), ('presence', 'mandatory')]), dict([('id', 1206), ('criticality', 'reject'), ('Value', _Extension_DedicatedMeasurementValueIE_val_Value_8), ('presence', 'mandatory')]), dict([('id', 1225), ('criticality', 'reject'), ('Value', _Extension_DedicatedMeasurementValueIE_val_Value_9), ('presence', 'mandatory')]), dict([('id', 1311), ('criticality', 'reject'), ('Value', _Extension_DedicatedMeasurementValueIE_val_Value_10), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementValueInformation >-----#
    DedicatedMeasurementValueInformation = CHOICE(name='DedicatedMeasurementValueInformation', mode=MODE_TYPE)
    _DedicatedMeasurementValueInformation_measurementAvailable = SEQ(name='measurementAvailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementAvailable')))
    _DedicatedMeasurementValueInformation_measurementnotAvailable = NULL(name='measurementnotAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementnotAvailable')))
    DedicatedMeasurementValueInformation._cont = ASN1Dict([
        ('measurementAvailable', _DedicatedMeasurementValueInformation_measurementAvailable),
        ('measurementnotAvailable', _DedicatedMeasurementValueInformation_measurementnotAvailable),
        ])
    DedicatedMeasurementValueInformation._ext = None
    
    #-----< DedicatedMeasurementAvailable >-----#
    DedicatedMeasurementAvailable = SEQ(name='DedicatedMeasurementAvailable', mode=MODE_TYPE)
    _DedicatedMeasurementAvailable_dedicatedmeasurementValue = CHOICE(name='dedicatedmeasurementValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementValue')))
    _DedicatedMeasurementAvailable_cFN = INT(name='cFN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CFN')), opt=True)
    _DedicatedMeasurementAvailable_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementAvailable_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementAvailable_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementAvailable_ie_Extensions__item__id._const_tab = ____DedicatedMeasurementAvailable_ie_Extensions__item__id_tab
    ___DedicatedMeasurementAvailable_ie_Extensions__item__id._const_tab_at = None
    ___DedicatedMeasurementAvailable_ie_Extensions__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality._const_tab = ____DedicatedMeasurementAvailable_ie_Extensions__item__criticality_tab
    ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue._const_tab = ____DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue_tab
    ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DedicatedMeasurementAvailable_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementAvailable_ie_Extensions__item__id),
        ('criticality', ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality),
        ('extensionValue', ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue),
        ])
    __DedicatedMeasurementAvailable_ie_Extensions__item_._ext = None
    _DedicatedMeasurementAvailable_ie_Extensions._cont = __DedicatedMeasurementAvailable_ie_Extensions__item_
    _DedicatedMeasurementAvailable_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementAvailable._cont = ASN1Dict([
        ('dedicatedmeasurementValue', _DedicatedMeasurementAvailable_dedicatedmeasurementValue),
        ('cFN', _DedicatedMeasurementAvailable_cFN),
        ('ie-Extensions', _DedicatedMeasurementAvailable_ie_Extensions),
        ])
    DedicatedMeasurementAvailable._ext = []
    
    #-----< DedicatedMeasurementAvailableItem-ExtIEs >-----#
    DedicatedMeasurementAvailableItem_ExtIEs = CLASS(name='DedicatedMeasurementAvailableItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DedicatedMeasurementAvailableItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementnotAvailable >-----#
    DedicatedMeasurementnotAvailable = NULL(name='DedicatedMeasurementnotAvailable', mode=MODE_TYPE)
    
    #-----< DelayedActivation >-----#
    DelayedActivation = CHOICE(name='DelayedActivation', mode=MODE_TYPE)
    _DelayedActivation_cfn = INT(name='cfn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    _DelayedActivation_separate_indication = NULL(name='separate-indication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DelayedActivation._cont = ASN1Dict([
        ('cfn', _DelayedActivation_cfn),
        ('separate-indication', _DelayedActivation_separate_indication),
        ])
    DelayedActivation._ext = None
    
    #-----< DelayedActivationUpdate >-----#
    DelayedActivationUpdate = CHOICE(name='DelayedActivationUpdate', mode=MODE_TYPE)
    _DelayedActivationUpdate_activate = SEQ(name='activate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Activate-Info')))
    _DelayedActivationUpdate_deactivate = SEQ(name='deactivate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Deactivate-Info')))
    DelayedActivationUpdate._cont = ASN1Dict([
        ('activate', _DelayedActivationUpdate_activate),
        ('deactivate', _DelayedActivationUpdate_deactivate),
        ])
    DelayedActivationUpdate._ext = None
    
    #-----< Activate-Info >-----#
    Activate_Info = SEQ(name='Activate-Info', mode=MODE_TYPE)
    _Activate_Info_activation_type = CHOICE(name='activation-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Execution-Type')))
    _Activate_Info_initial_dl_tx_power = INT(name='initial-dl-tx-power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _Activate_Info_firstRLS_Indicator = ENUM(name='firstRLS-Indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FirstRLS-Indicator')), opt=True)
    _Activate_Info_propagation_delay = INT(name='propagation-delay', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PropagationDelay')), opt=True)
    _Activate_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Activate_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Activate_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Activate_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Activate_Info_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ExtendedPropagationDelay')))
    ____Activate_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 819), ('criticality', 'reject'), ('Extension', _____Activate_Info_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___Activate_Info_iE_Extensions__item__id._const_tab = ____Activate_Info_iE_Extensions__item__id_tab
    ___Activate_Info_iE_Extensions__item__id._const_tab_at = None
    ___Activate_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Activate_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Activate_Info_iE_Extensions__item__criticality._const_tab = ____Activate_Info_iE_Extensions__item__id_tab
    ___Activate_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Activate_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Activate_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Activate_Info_iE_Extensions__item__extensionValue._const_tab = ____Activate_Info_iE_Extensions__item__id_tab
    ___Activate_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Activate_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Activate_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Activate_Info_iE_Extensions__item__id),
        ('criticality', ___Activate_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Activate_Info_iE_Extensions__item__extensionValue),
        ])
    __Activate_Info_iE_Extensions__item_._ext = None
    _Activate_Info_iE_Extensions._cont = __Activate_Info_iE_Extensions__item_
    _Activate_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Activate_Info._cont = ASN1Dict([
        ('activation-type', _Activate_Info_activation_type),
        ('initial-dl-tx-power', _Activate_Info_initial_dl_tx_power),
        ('firstRLS-Indicator', _Activate_Info_firstRLS_Indicator),
        ('propagation-delay', _Activate_Info_propagation_delay),
        ('iE-Extensions', _Activate_Info_iE_Extensions),
        ])
    Activate_Info._ext = []
    
    #-----< Activate-Info-ExtIEs >-----#
    Activate_Info_ExtIEs = CLASS(name='Activate-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Activate_Info_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ExtendedPropagationDelay')))
    Activate_Info_ExtIEs._val = ASN1Set(rv=[dict([('id', 819), ('criticality', 'reject'), ('Extension', _Activate_Info_ExtIEs_val_Extension_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Deactivate-Info >-----#
    Deactivate_Info = SEQ(name='Deactivate-Info', mode=MODE_TYPE)
    _Deactivate_Info_deactivation_type = CHOICE(name='deactivation-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Execution-Type')))
    _Deactivate_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Deactivate_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Deactivate_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Deactivate_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Deactivate_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Deactivate_Info_iE_Extensions__item__id._const_tab = ____Deactivate_Info_iE_Extensions__item__id_tab
    ___Deactivate_Info_iE_Extensions__item__id._const_tab_at = None
    ___Deactivate_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Deactivate_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Deactivate_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Deactivate_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Deactivate_Info_iE_Extensions__item__criticality._const_tab = ____Deactivate_Info_iE_Extensions__item__criticality_tab
    ___Deactivate_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Deactivate_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Deactivate_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Deactivate_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Deactivate_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Deactivate_Info_iE_Extensions__item__extensionValue._const_tab = ____Deactivate_Info_iE_Extensions__item__extensionValue_tab
    ___Deactivate_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Deactivate_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Deactivate_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Deactivate_Info_iE_Extensions__item__id),
        ('criticality', ___Deactivate_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Deactivate_Info_iE_Extensions__item__extensionValue),
        ])
    __Deactivate_Info_iE_Extensions__item_._ext = None
    _Deactivate_Info_iE_Extensions._cont = __Deactivate_Info_iE_Extensions__item_
    _Deactivate_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Deactivate_Info._cont = ASN1Dict([
        ('deactivation-type', _Deactivate_Info_deactivation_type),
        ('iE-Extensions', _Deactivate_Info_iE_Extensions),
        ])
    Deactivate_Info._ext = []
    
    #-----< Deactivate-Info-ExtIEs >-----#
    Deactivate_Info_ExtIEs = CLASS(name='Deactivate-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Deactivate_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Execution-Type >-----#
    Execution_Type = CHOICE(name='Execution-Type', mode=MODE_TYPE)
    _Execution_Type_synchronised = INT(name='synchronised', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    _Execution_Type_unsynchronised = NULL(name='unsynchronised', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Execution_Type._cont = ASN1Dict([
        ('synchronised', _Execution_Type_synchronised),
        ('unsynchronised', _Execution_Type_unsynchronised),
        ])
    Execution_Type._ext = None
    
    #-----< DeltaSIR >-----#
    DeltaSIR = INT(name='DeltaSIR', mode=MODE_TYPE)
    DeltaSIR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=30)], ev=None, er=[])
    
    #-----< DGANSSCorrections >-----#
    DGANSSCorrections = SEQ(name='DGANSSCorrections', mode=MODE_TYPE)
    _DGANSSCorrections_dGANSS_ReferenceTime = INT(name='dGANSS-ReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSSCorrections_dGANSS_ReferenceTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=119)], ev=None, er=[])
    _DGANSSCorrections_dGANSS_Information = SEQ_OF(name='dGANSS-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DGANSS-Information')))
    _DGANSSCorrections_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGANSSCorrections_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DGANSSCorrections_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGANSSCorrections_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGANSSCorrections_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSSCorrections_ie_Extensions__item__id._const_tab = ____DGANSSCorrections_ie_Extensions__item__id_tab
    ___DGANSSCorrections_ie_Extensions__item__id._const_tab_at = None
    ___DGANSSCorrections_ie_Extensions__item__id._const_tab_id = 'id'
    ___DGANSSCorrections_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DGANSSCorrections_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGANSSCorrections_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSSCorrections_ie_Extensions__item__criticality._const_tab = ____DGANSSCorrections_ie_Extensions__item__criticality_tab
    ___DGANSSCorrections_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGANSSCorrections_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGANSSCorrections_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DGANSSCorrections_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGANSSCorrections_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSSCorrections_ie_Extensions__item__extensionValue._const_tab = ____DGANSSCorrections_ie_Extensions__item__extensionValue_tab
    ___DGANSSCorrections_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGANSSCorrections_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGANSSCorrections_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGANSSCorrections_ie_Extensions__item__id),
        ('criticality', ___DGANSSCorrections_ie_Extensions__item__criticality),
        ('extensionValue', ___DGANSSCorrections_ie_Extensions__item__extensionValue),
        ])
    __DGANSSCorrections_ie_Extensions__item_._ext = None
    _DGANSSCorrections_ie_Extensions._cont = __DGANSSCorrections_ie_Extensions__item_
    _DGANSSCorrections_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGANSSCorrections._cont = ASN1Dict([
        ('dGANSS-ReferenceTime', _DGANSSCorrections_dGANSS_ReferenceTime),
        ('dGANSS-Information', _DGANSSCorrections_dGANSS_Information),
        ('ie-Extensions', _DGANSSCorrections_ie_Extensions),
        ])
    DGANSSCorrections._ext = []
    
    #-----< DGANSSCorrections-ExtIEs >-----#
    DGANSSCorrections_ExtIEs = CLASS(name='DGANSSCorrections-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DGANSSCorrections_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGANSS-Corrections-Req >-----#
    DGANSS_Corrections_Req = SEQ(name='DGANSS-Corrections-Req', mode=MODE_TYPE)
    _DGANSS_Corrections_Req_dGANSS_Signal_ID = BIT_STR(name='dGANSS-Signal-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSS_Corrections_Req_dGANSS_Signal_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DGANSS_Corrections_Req_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGANSS_Corrections_Req_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DGANSS_Corrections_Req_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DGANSS_Corrections_Req_ie_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ID')))
    ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1007), ('criticality', 'ignore'), ('Extension', _____DGANSS_Corrections_Req_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DGANSS_Corrections_Req_ie_Extensions__item__id._const_tab = ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab
    ___DGANSS_Corrections_Req_ie_Extensions__item__id._const_tab_at = None
    ___DGANSS_Corrections_Req_ie_Extensions__item__id._const_tab_id = 'id'
    ___DGANSS_Corrections_Req_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DGANSS_Corrections_Req_ie_Extensions__item__criticality._const_tab = ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab
    ___DGANSS_Corrections_Req_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGANSS_Corrections_Req_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue._const_tab = ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab
    ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGANSS_Corrections_Req_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGANSS_Corrections_Req_ie_Extensions__item__id),
        ('criticality', ___DGANSS_Corrections_Req_ie_Extensions__item__criticality),
        ('extensionValue', ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue),
        ])
    __DGANSS_Corrections_Req_ie_Extensions__item_._ext = None
    _DGANSS_Corrections_Req_ie_Extensions._cont = __DGANSS_Corrections_Req_ie_Extensions__item_
    _DGANSS_Corrections_Req_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGANSS_Corrections_Req._cont = ASN1Dict([
        ('dGANSS-Signal-ID', _DGANSS_Corrections_Req_dGANSS_Signal_ID),
        ('ie-Extensions', _DGANSS_Corrections_Req_ie_Extensions),
        ])
    DGANSS_Corrections_Req._ext = []
    
    #-----< DGANSS-Corrections-Req-ExtIEs >-----#
    DGANSS_Corrections_Req_ExtIEs = CLASS(name='DGANSS-Corrections-Req-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DGANSS_Corrections_Req_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ID')))
    DGANSS_Corrections_Req_ExtIEs._val = ASN1Set(rv=[dict([('id', 1007), ('criticality', 'ignore'), ('Extension', _DGANSS_Corrections_Req_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DGANSS-Information >-----#
    DGANSS_Information = SEQ_OF(name='DGANSS-Information', mode=MODE_TYPE)
    _DGANSS_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DGANSS-InformationItem')))
    DGANSS_Information._cont = _DGANSS_Information__item_
    DGANSS_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DGANSS-InformationItem >-----#
    DGANSS_InformationItem = SEQ(name='DGANSS-InformationItem', mode=MODE_TYPE)
    _DGANSS_InformationItem_gANSS_SignalId = INT(name='gANSS-SignalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Signal-ID')), opt=True)
    _DGANSS_InformationItem_gANSS_StatusHealth = ENUM(name='gANSS-StatusHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-StatusHealth')))
    _DGANSS_InformationItem_dGANSS_SignalInformation = SEQ_OF(name='dGANSS-SignalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DGANSS-SignalInformation')), opt=True)
    _DGANSS_InformationItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGANSS_InformationItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DGANSS_InformationItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGANSS_InformationItem_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGANSS_InformationItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSS_InformationItem_ie_Extensions__item__id._const_tab = ____DGANSS_InformationItem_ie_Extensions__item__id_tab
    ___DGANSS_InformationItem_ie_Extensions__item__id._const_tab_at = None
    ___DGANSS_InformationItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___DGANSS_InformationItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DGANSS_InformationItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGANSS_InformationItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSS_InformationItem_ie_Extensions__item__criticality._const_tab = ____DGANSS_InformationItem_ie_Extensions__item__criticality_tab
    ___DGANSS_InformationItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGANSS_InformationItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGANSS_InformationItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DGANSS_InformationItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGANSS_InformationItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSS_InformationItem_ie_Extensions__item__extensionValue._const_tab = ____DGANSS_InformationItem_ie_Extensions__item__extensionValue_tab
    ___DGANSS_InformationItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGANSS_InformationItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGANSS_InformationItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGANSS_InformationItem_ie_Extensions__item__id),
        ('criticality', ___DGANSS_InformationItem_ie_Extensions__item__criticality),
        ('extensionValue', ___DGANSS_InformationItem_ie_Extensions__item__extensionValue),
        ])
    __DGANSS_InformationItem_ie_Extensions__item_._ext = None
    _DGANSS_InformationItem_ie_Extensions._cont = __DGANSS_InformationItem_ie_Extensions__item_
    _DGANSS_InformationItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGANSS_InformationItem._cont = ASN1Dict([
        ('gANSS-SignalId', _DGANSS_InformationItem_gANSS_SignalId),
        ('gANSS-StatusHealth', _DGANSS_InformationItem_gANSS_StatusHealth),
        ('dGANSS-SignalInformation', _DGANSS_InformationItem_dGANSS_SignalInformation),
        ('ie-Extensions', _DGANSS_InformationItem_ie_Extensions),
        ])
    DGANSS_InformationItem._ext = []
    
    #-----< DGANSS-InformationItem-ExtIEs >-----#
    DGANSS_InformationItem_ExtIEs = CLASS(name='DGANSS-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DGANSS_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGANSS-SignalInformation >-----#
    DGANSS_SignalInformation = SEQ_OF(name='DGANSS-SignalInformation', mode=MODE_TYPE)
    _DGANSS_SignalInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DGANSS-SignalInformationItem')))
    DGANSS_SignalInformation._cont = _DGANSS_SignalInformation__item_
    DGANSS_SignalInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DGANSS-SignalInformationItem >-----#
    DGANSS_SignalInformationItem = SEQ(name='DGANSS-SignalInformationItem', mode=MODE_TYPE)
    _DGANSS_SignalInformationItem_satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSS_SignalInformationItem_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _DGANSS_SignalInformationItem_gANSS_iod = BIT_STR(name='gANSS-iod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSS_SignalInformationItem_gANSS_iod._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _DGANSS_SignalInformationItem_udre = ENUM(name='udre', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UDRE')))
    _DGANSS_SignalInformationItem_ganss_prc = INT(name='ganss-prc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSS_SignalInformationItem_ganss_prc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2047, ub=2047)], ev=None, er=[])
    _DGANSS_SignalInformationItem_ganss_rrc = INT(name='ganss-rrc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSS_SignalInformationItem_ganss_rrc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=127)], ev=None, er=[])
    _DGANSS_SignalInformationItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGANSS_SignalInformationItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DGANSS_SignalInformationItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DGNSS-ValidityPeriod')))
    ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1169), ('criticality', 'ignore'), ('Extension', _____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DGANSS_SignalInformationItem_ie_Extensions__item__id._const_tab = ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab
    ___DGANSS_SignalInformationItem_ie_Extensions__item__id._const_tab_at = None
    ___DGANSS_SignalInformationItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality._const_tab = ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab
    ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue._const_tab = ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab
    ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGANSS_SignalInformationItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGANSS_SignalInformationItem_ie_Extensions__item__id),
        ('criticality', ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality),
        ('extensionValue', ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue),
        ])
    __DGANSS_SignalInformationItem_ie_Extensions__item_._ext = None
    _DGANSS_SignalInformationItem_ie_Extensions._cont = __DGANSS_SignalInformationItem_ie_Extensions__item_
    _DGANSS_SignalInformationItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGANSS_SignalInformationItem._cont = ASN1Dict([
        ('satId', _DGANSS_SignalInformationItem_satId),
        ('gANSS-iod', _DGANSS_SignalInformationItem_gANSS_iod),
        ('udre', _DGANSS_SignalInformationItem_udre),
        ('ganss-prc', _DGANSS_SignalInformationItem_ganss_prc),
        ('ganss-rrc', _DGANSS_SignalInformationItem_ganss_rrc),
        ('ie-Extensions', _DGANSS_SignalInformationItem_ie_Extensions),
        ])
    DGANSS_SignalInformationItem._ext = []
    
    #-----< DGANSS-SignalInformationItem-ExtIEs >-----#
    DGANSS_SignalInformationItem_ExtIEs = CLASS(name='DGANSS-SignalInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DGANSS_SignalInformationItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DGNSS-ValidityPeriod')))
    DGANSS_SignalInformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 1169), ('criticality', 'ignore'), ('Extension', _DGANSS_SignalInformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DGANSSThreshold >-----#
    DGANSSThreshold = SEQ(name='DGANSSThreshold', mode=MODE_TYPE)
    _DGANSSThreshold_pRCDeviation = ENUM(name='pRCDeviation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PRCDeviation')))
    _DGANSSThreshold_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGANSSThreshold_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DGANSSThreshold_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGANSSThreshold_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGANSSThreshold_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSSThreshold_ie_Extensions__item__id._const_tab = ____DGANSSThreshold_ie_Extensions__item__id_tab
    ___DGANSSThreshold_ie_Extensions__item__id._const_tab_at = None
    ___DGANSSThreshold_ie_Extensions__item__id._const_tab_id = 'id'
    ___DGANSSThreshold_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DGANSSThreshold_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGANSSThreshold_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSSThreshold_ie_Extensions__item__criticality._const_tab = ____DGANSSThreshold_ie_Extensions__item__criticality_tab
    ___DGANSSThreshold_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGANSSThreshold_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGANSSThreshold_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DGANSSThreshold_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGANSSThreshold_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSSThreshold_ie_Extensions__item__extensionValue._const_tab = ____DGANSSThreshold_ie_Extensions__item__extensionValue_tab
    ___DGANSSThreshold_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGANSSThreshold_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGANSSThreshold_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGANSSThreshold_ie_Extensions__item__id),
        ('criticality', ___DGANSSThreshold_ie_Extensions__item__criticality),
        ('extensionValue', ___DGANSSThreshold_ie_Extensions__item__extensionValue),
        ])
    __DGANSSThreshold_ie_Extensions__item_._ext = None
    _DGANSSThreshold_ie_Extensions._cont = __DGANSSThreshold_ie_Extensions__item_
    _DGANSSThreshold_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGANSSThreshold._cont = ASN1Dict([
        ('pRCDeviation', _DGANSSThreshold_pRCDeviation),
        ('ie-Extensions', _DGANSSThreshold_ie_Extensions),
        ])
    DGANSSThreshold._ext = []
    
    #-----< DGANSSThreshold-ExtIEs >-----#
    DGANSSThreshold_ExtIEs = CLASS(name='DGANSSThreshold-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DGANSSThreshold_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGNSS-ValidityPeriod >-----#
    DGNSS_ValidityPeriod = SEQ(name='DGNSS-ValidityPeriod', mode=MODE_TYPE)
    _DGNSS_ValidityPeriod_udreGrowthRate = ENUM(name='udreGrowthRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UDREGrowthRate')))
    _DGNSS_ValidityPeriod_udreValidityTime = ENUM(name='udreValidityTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UDREValidityTime')))
    _DGNSS_ValidityPeriod_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGNSS_ValidityPeriod_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id._const_tab = ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id._const_tab_at = None
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id._const_tab_id = 'id'
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality._const_tab = ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue._const_tab = ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGNSS_ValidityPeriod_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGNSS_ValidityPeriod_iE_Extensions__item__id),
        ('criticality', ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality),
        ('extensionValue', ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue),
        ])
    __DGNSS_ValidityPeriod_iE_Extensions__item_._ext = None
    _DGNSS_ValidityPeriod_iE_Extensions._cont = __DGNSS_ValidityPeriod_iE_Extensions__item_
    _DGNSS_ValidityPeriod_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGNSS_ValidityPeriod._cont = ASN1Dict([
        ('udreGrowthRate', _DGNSS_ValidityPeriod_udreGrowthRate),
        ('udreValidityTime', _DGNSS_ValidityPeriod_udreValidityTime),
        ('iE-Extensions', _DGNSS_ValidityPeriod_iE_Extensions),
        ])
    DGNSS_ValidityPeriod._ext = []
    
    #-----< DGNSS-ValidityPeriod-ExtIEs >-----#
    DGNSS_ValidityPeriod_ExtIEs = CLASS(name='DGNSS-ValidityPeriod-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DGNSS_ValidityPeriod_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGPSCorrections >-----#
    DGPSCorrections = SEQ(name='DGPSCorrections', mode=MODE_TYPE)
    _DGPSCorrections_gpstow = INT(name='gpstow', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GPSTOW')))
    _DGPSCorrections_status_health = ENUM(name='status-health', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GPS-Status-Health')))
    _DGPSCorrections_satelliteinfo = SEQ_OF(name='satelliteinfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SAT-Info-DGPSCorrections')))
    _DGPSCorrections_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGPSCorrections_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DGPSCorrections_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGPSCorrections_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGPSCorrections_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSCorrections_ie_Extensions__item__id._const_tab = ____DGPSCorrections_ie_Extensions__item__id_tab
    ___DGPSCorrections_ie_Extensions__item__id._const_tab_at = None
    ___DGPSCorrections_ie_Extensions__item__id._const_tab_id = 'id'
    ___DGPSCorrections_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DGPSCorrections_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGPSCorrections_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSCorrections_ie_Extensions__item__criticality._const_tab = ____DGPSCorrections_ie_Extensions__item__criticality_tab
    ___DGPSCorrections_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGPSCorrections_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGPSCorrections_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DGPSCorrections_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGPSCorrections_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSCorrections_ie_Extensions__item__extensionValue._const_tab = ____DGPSCorrections_ie_Extensions__item__extensionValue_tab
    ___DGPSCorrections_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGPSCorrections_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGPSCorrections_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGPSCorrections_ie_Extensions__item__id),
        ('criticality', ___DGPSCorrections_ie_Extensions__item__criticality),
        ('extensionValue', ___DGPSCorrections_ie_Extensions__item__extensionValue),
        ])
    __DGPSCorrections_ie_Extensions__item_._ext = None
    _DGPSCorrections_ie_Extensions._cont = __DGPSCorrections_ie_Extensions__item_
    _DGPSCorrections_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGPSCorrections._cont = ASN1Dict([
        ('gpstow', _DGPSCorrections_gpstow),
        ('status-health', _DGPSCorrections_status_health),
        ('satelliteinfo', _DGPSCorrections_satelliteinfo),
        ('ie-Extensions', _DGPSCorrections_ie_Extensions),
        ])
    DGPSCorrections._ext = []
    
    #-----< DGPSCorrections-ExtIEs >-----#
    DGPSCorrections_ExtIEs = CLASS(name='DGPSCorrections-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DGPSCorrections_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGPSThresholds >-----#
    DGPSThresholds = SEQ(name='DGPSThresholds', mode=MODE_TYPE)
    _DGPSThresholds_prcdeviation = ENUM(name='prcdeviation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PRCDeviation')))
    _DGPSThresholds_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGPSThresholds_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DGPSThresholds_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGPSThresholds_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGPSThresholds_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSThresholds_ie_Extensions__item__id._const_tab = ____DGPSThresholds_ie_Extensions__item__id_tab
    ___DGPSThresholds_ie_Extensions__item__id._const_tab_at = None
    ___DGPSThresholds_ie_Extensions__item__id._const_tab_id = 'id'
    ___DGPSThresholds_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DGPSThresholds_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGPSThresholds_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSThresholds_ie_Extensions__item__criticality._const_tab = ____DGPSThresholds_ie_Extensions__item__criticality_tab
    ___DGPSThresholds_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGPSThresholds_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGPSThresholds_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DGPSThresholds_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DGPSThresholds_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSThresholds_ie_Extensions__item__extensionValue._const_tab = ____DGPSThresholds_ie_Extensions__item__extensionValue_tab
    ___DGPSThresholds_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGPSThresholds_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGPSThresholds_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGPSThresholds_ie_Extensions__item__id),
        ('criticality', ___DGPSThresholds_ie_Extensions__item__criticality),
        ('extensionValue', ___DGPSThresholds_ie_Extensions__item__extensionValue),
        ])
    __DGPSThresholds_ie_Extensions__item_._ext = None
    _DGPSThresholds_ie_Extensions._cont = __DGPSThresholds_ie_Extensions__item_
    _DGPSThresholds_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGPSThresholds._cont = ASN1Dict([
        ('prcdeviation', _DGPSThresholds_prcdeviation),
        ('ie-Extensions', _DGPSThresholds_ie_Extensions),
        ])
    DGPSThresholds._ext = []
    
    #-----< DGPSThresholds-ExtIEs >-----#
    DGPSThresholds_ExtIEs = CLASS(name='DGPSThresholds-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DGPSThresholds_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DiscardTimer >-----#
    DiscardTimer = ENUM(name='DiscardTimer', mode=MODE_TYPE)
    DiscardTimer._cont = ASN1Dict([('v20', 0), ('v40', 1), ('v60', 2), ('v80', 3), ('v100', 4), ('v120', 5), ('v140', 6), ('v160', 7), ('v180', 8), ('v200', 9), ('v250', 10), ('v300', 11), ('v400', 12), ('v500', 13), ('v750', 14), ('v1000', 15), ('v1250', 16), ('v1500', 17), ('v1750', 18), ('v2000', 19), ('v2500', 20), ('v3000', 21), ('v3500', 22), ('v4000', 23), ('v4500', 24), ('v5000', 25), ('v7500', 26)])
    DiscardTimer._ext = []
    
    #-----< DiversityControlField >-----#
    DiversityControlField = ENUM(name='DiversityControlField', mode=MODE_TYPE)
    DiversityControlField._cont = ASN1Dict([('may', 0), ('must', 1), ('must-not', 2)])
    DiversityControlField._ext = []
    
    #-----< DiversityMode >-----#
    DiversityMode = ENUM(name='DiversityMode', mode=MODE_TYPE)
    DiversityMode._cont = ASN1Dict([('none', 0), ('sTTD', 1), ('closed-loop-mode1', 2), ('not-used-closed-loop-mode2', 3)])
    DiversityMode._ext = []
    
    #-----< DL-TBS >-----#
    DL_TBS = SEQ(name='DL-TBS', mode=MODE_TYPE)
    _DL_TBS_hs_DSCH_Cell_List = SEQ_OF(name='hs-DSCH-Cell-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Cell-List')))
    _DL_TBS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_TBS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_TBS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_TBS_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_TBS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TBS_iE_Extensions__item__id._const_tab = ____DL_TBS_iE_Extensions__item__id_tab
    ___DL_TBS_iE_Extensions__item__id._const_tab_at = None
    ___DL_TBS_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_TBS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_TBS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_TBS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TBS_iE_Extensions__item__criticality._const_tab = ____DL_TBS_iE_Extensions__item__criticality_tab
    ___DL_TBS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_TBS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_TBS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_TBS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_TBS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TBS_iE_Extensions__item__extensionValue._const_tab = ____DL_TBS_iE_Extensions__item__extensionValue_tab
    ___DL_TBS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_TBS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_TBS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_TBS_iE_Extensions__item__id),
        ('criticality', ___DL_TBS_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_TBS_iE_Extensions__item__extensionValue),
        ])
    __DL_TBS_iE_Extensions__item_._ext = None
    _DL_TBS_iE_Extensions._cont = __DL_TBS_iE_Extensions__item_
    _DL_TBS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_TBS._cont = ASN1Dict([
        ('hs-DSCH-Cell-List', _DL_TBS_hs_DSCH_Cell_List),
        ('iE-Extensions', _DL_TBS_iE_Extensions),
        ])
    DL_TBS._ext = []
    
    #-----< DL-TBS-ExtIEs >-----#
    DL_TBS_ExtIEs = CLASS(name='DL-TBS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_TBS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Cell-List >-----#
    HS_DSCH_Cell_List = SEQ_OF(name='HS-DSCH-Cell-List', mode=MODE_TYPE)
    _HS_DSCH_Cell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Cell')))
    HS_DSCH_Cell_List._cont = _HS_DSCH_Cell_List__item_
    HS_DSCH_Cell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< HS-DSCH-Cell >-----#
    HS_DSCH_Cell = SEQ(name='HS-DSCH-Cell', mode=MODE_TYPE)
    _HS_DSCH_Cell_hs_DSCH_Cell_TBS = INT(name='hs-DSCH-Cell-TBS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-TBS-Value')))
    _HS_DSCH_Cell_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Cell_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Cell_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_Cell_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Cell_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Cell_iE_Extensions__item__id._const_tab = ____HS_DSCH_Cell_iE_Extensions__item__id_tab
    ___HS_DSCH_Cell_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Cell_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_Cell_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCH_Cell_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Cell_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Cell_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Cell_iE_Extensions__item__criticality_tab
    ___HS_DSCH_Cell_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_Cell_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_Cell_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCH_Cell_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Cell_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Cell_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Cell_iE_Extensions__item__extensionValue_tab
    ___HS_DSCH_Cell_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_Cell_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_Cell_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_Cell_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_Cell_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_Cell_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Cell_iE_Extensions__item_._ext = None
    _HS_DSCH_Cell_iE_Extensions._cont = __HS_DSCH_Cell_iE_Extensions__item_
    _HS_DSCH_Cell_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Cell._cont = ASN1Dict([
        ('hs-DSCH-Cell-TBS', _HS_DSCH_Cell_hs_DSCH_Cell_TBS),
        ('iE-Extensions', _HS_DSCH_Cell_iE_Extensions),
        ])
    HS_DSCH_Cell._ext = []
    
    #-----< HS-DSCH-Cell-ExtIEs >-----#
    HS_DSCH_Cell_ExtIEs = CLASS(name='HS-DSCH-Cell-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCH_Cell_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-TBS-Value >-----#
    DL_TBS_Value = INT(name='DL-TBS-Value', mode=MODE_TYPE)
    DL_TBS_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=160000)], ev=None, er=[])
    
    #-----< DL-DPCH-SlotFormat >-----#
    DL_DPCH_SlotFormat = INT(name='DL-DPCH-SlotFormat', mode=MODE_TYPE)
    DL_DPCH_SlotFormat._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=[], er=[ASN1RangeInt(lb=17, ub=18)])
    
    #-----< DL-DPCH-TimingAdjustment >-----#
    DL_DPCH_TimingAdjustment = ENUM(name='DL-DPCH-TimingAdjustment', mode=MODE_TYPE)
    DL_DPCH_TimingAdjustment._cont = ASN1Dict([('timing-advance', 0), ('timing-delay', 1)])
    DL_DPCH_TimingAdjustment._ext = None
    
    #-----< DL-Timeslot-Information >-----#
    DL_Timeslot_Information = SEQ_OF(name='DL-Timeslot-Information', mode=MODE_TYPE)
    _DL_Timeslot_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Timeslot-InformationItem')))
    DL_Timeslot_Information._cont = _DL_Timeslot_Information__item_
    DL_Timeslot_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationItem >-----#
    DL_Timeslot_InformationItem = SEQ(name='DL-Timeslot-InformationItem', mode=MODE_TYPE)
    _DL_Timeslot_InformationItem_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _DL_Timeslot_InformationItem_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _DL_Timeslot_InformationItem_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _DL_Timeslot_InformationItem_dL_Code_Information = SEQ_OF(name='dL-Code-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-Code-Information')))
    _DL_Timeslot_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationItem_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot_InformationItem_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationItem_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationItem_iE_Extensions._cont = __DL_Timeslot_InformationItem_iE_Extensions__item_
    _DL_Timeslot_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationItem._cont = ASN1Dict([
        ('timeSlot', _DL_Timeslot_InformationItem_timeSlot),
        ('midambleShiftAndBurstType', _DL_Timeslot_InformationItem_midambleShiftAndBurstType),
        ('tFCI-Presence', _DL_Timeslot_InformationItem_tFCI_Presence),
        ('dL-Code-Information', _DL_Timeslot_InformationItem_dL_Code_Information),
        ('iE-Extensions', _DL_Timeslot_InformationItem_iE_Extensions),
        ])
    DL_Timeslot_InformationItem._ext = []
    
    #-----< DL-Timeslot-InformationItem-ExtIEs >-----#
    DL_Timeslot_InformationItem_ExtIEs = CLASS(name='DL-Timeslot-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-TimeslotLCR-Information >-----#
    DL_TimeslotLCR_Information = SEQ_OF(name='DL-TimeslotLCR-Information', mode=MODE_TYPE)
    _DL_TimeslotLCR_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotLCR-InformationItem')))
    DL_TimeslotLCR_Information._cont = _DL_TimeslotLCR_Information__item_
    DL_TimeslotLCR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-TimeslotLCR-InformationItem >-----#
    DL_TimeslotLCR_InformationItem = SEQ(name='DL-TimeslotLCR-InformationItem', mode=MODE_TYPE)
    _DL_TimeslotLCR_InformationItem_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _DL_TimeslotLCR_InformationItem_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _DL_TimeslotLCR_InformationItem_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _DL_TimeslotLCR_InformationItem_dL_Code_LCR_Information = SEQ_OF(name='dL-Code-LCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-Code-LCR-Information')))
    _DL_TimeslotLCR_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_TimeslotLCR_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 580), ('criticality', 'ignore'), ('Extension', _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 581), ('criticality', 'ignore'), ('Extension', _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 582), ('criticality', 'ignore'), ('Extension', _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab = ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab = ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_TimeslotLCR_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id),
        ('criticality', ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __DL_TimeslotLCR_InformationItem_iE_Extensions__item_._ext = None
    _DL_TimeslotLCR_InformationItem_iE_Extensions._cont = __DL_TimeslotLCR_InformationItem_iE_Extensions__item_
    _DL_TimeslotLCR_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_TimeslotLCR_InformationItem._cont = ASN1Dict([
        ('timeSlotLCR', _DL_TimeslotLCR_InformationItem_timeSlotLCR),
        ('midambleShiftLCR', _DL_TimeslotLCR_InformationItem_midambleShiftLCR),
        ('tFCI-Presence', _DL_TimeslotLCR_InformationItem_tFCI_Presence),
        ('dL-Code-LCR-Information', _DL_TimeslotLCR_InformationItem_dL_Code_LCR_Information),
        ('iE-Extensions', _DL_TimeslotLCR_InformationItem_iE_Extensions),
        ])
    DL_TimeslotLCR_InformationItem._ext = []
    
    #-----< DL-TimeslotLCR-InformationItem-ExtIEs >-----#
    DL_TimeslotLCR_InformationItem_ExtIEs = CLASS(name='DL-TimeslotLCR-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    DL_TimeslotLCR_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 580), ('criticality', 'ignore'), ('Extension', _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 581), ('criticality', 'ignore'), ('Extension', _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 582), ('criticality', 'ignore'), ('Extension', _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot768-Information >-----#
    DL_Timeslot768_Information = SEQ_OF(name='DL-Timeslot768-Information', mode=MODE_TYPE)
    _DL_Timeslot768_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Timeslot768-InformationItem')))
    DL_Timeslot768_Information._cont = _DL_Timeslot768_Information__item_
    DL_Timeslot768_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot768-InformationItem >-----#
    DL_Timeslot768_InformationItem = SEQ(name='DL-Timeslot768-InformationItem', mode=MODE_TYPE)
    _DL_Timeslot768_InformationItem_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _DL_Timeslot768_InformationItem_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _DL_Timeslot768_InformationItem_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _DL_Timeslot768_InformationItem_dL_Code_768_Information = SEQ_OF(name='dL-Code-768-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-Code-768-Information')))
    _DL_Timeslot768_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot768_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot768_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot768_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__id._const_tab = ____DL_Timeslot768_InformationItem_iE_Extensions__item__id_tab
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Timeslot768_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot768_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot768_InformationItem_iE_Extensions__item__criticality_tab
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot768_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot768_InformationItem_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot768_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot768_InformationItem_iE_Extensions__item_._ext = None
    _DL_Timeslot768_InformationItem_iE_Extensions._cont = __DL_Timeslot768_InformationItem_iE_Extensions__item_
    _DL_Timeslot768_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot768_InformationItem._cont = ASN1Dict([
        ('timeSlot', _DL_Timeslot768_InformationItem_timeSlot),
        ('midambleShiftAndBurstType768', _DL_Timeslot768_InformationItem_midambleShiftAndBurstType768),
        ('tFCI-Presence', _DL_Timeslot768_InformationItem_tFCI_Presence),
        ('dL-Code-768-Information', _DL_Timeslot768_InformationItem_dL_Code_768_Information),
        ('iE-Extensions', _DL_Timeslot768_InformationItem_iE_Extensions),
        ])
    DL_Timeslot768_InformationItem._ext = []
    
    #-----< DL-Timeslot768-InformationItem-ExtIEs >-----#
    DL_Timeslot768_InformationItem_ExtIEs = CLASS(name='DL-Timeslot768-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Timeslot768_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-FrameType >-----#
    DL_FrameType = ENUM(name='DL-FrameType', mode=MODE_TYPE)
    DL_FrameType._cont = ASN1Dict([('typeA', 0), ('typeB', 1)])
    DL_FrameType._ext = []
    
    #-----< DL-or-Global-CapacityCredit >-----#
    DL_or_Global_CapacityCredit = INT(name='DL-or-Global-CapacityCredit', mode=MODE_TYPE)
    DL_or_Global_CapacityCredit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< DL-Power >-----#
    DL_Power = INT(name='DL-Power', mode=MODE_TYPE)
    DL_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-350, ub=150)], ev=None, er=[])
    
    #-----< DLPowerAveragingWindowSize >-----#
    DLPowerAveragingWindowSize = INT(name='DLPowerAveragingWindowSize', mode=MODE_TYPE)
    DLPowerAveragingWindowSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=None, er=[])
    
    #-----< DL-PowerBalancing-Information >-----#
    DL_PowerBalancing_Information = SEQ(name='DL-PowerBalancing-Information', mode=MODE_TYPE)
    _DL_PowerBalancing_Information_powerAdjustmentType = ENUM(name='powerAdjustmentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerAdjustmentType')))
    _DL_PowerBalancing_Information_dLReferencePower = INT(name='dLReferencePower', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _DL_PowerBalancing_Information_dLReferencePowerList_DL_PC_Rqst = SEQ_OF(name='dLReferencePowerList-DL-PC-Rqst', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-ReferencePowerInformationList')), opt=True)
    _DL_PowerBalancing_Information_maxAdjustmentStep = INT(name='maxAdjustmentStep', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaxAdjustmentStep')), opt=True)
    _DL_PowerBalancing_Information_adjustmentPeriod = INT(name='adjustmentPeriod', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AdjustmentPeriod')), opt=True)
    _DL_PowerBalancing_Information_adjustmentRatio = INT(name='adjustmentRatio', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ScaledAdjustmentRatio')), opt=True)
    _DL_PowerBalancing_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_PowerBalancing_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_PowerBalancing_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_PowerBalancing_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_PowerBalancing_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerBalancing_Information_iE_Extensions__item__id._const_tab = ____DL_PowerBalancing_Information_iE_Extensions__item__id_tab
    ___DL_PowerBalancing_Information_iE_Extensions__item__id._const_tab_at = None
    ___DL_PowerBalancing_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_PowerBalancing_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_PowerBalancing_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_PowerBalancing_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerBalancing_Information_iE_Extensions__item__criticality._const_tab = ____DL_PowerBalancing_Information_iE_Extensions__item__criticality_tab
    ___DL_PowerBalancing_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_PowerBalancing_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_PowerBalancing_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_PowerBalancing_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue._const_tab = ____DL_PowerBalancing_Information_iE_Extensions__item__extensionValue_tab
    ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_PowerBalancing_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_PowerBalancing_Information_iE_Extensions__item__id),
        ('criticality', ___DL_PowerBalancing_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue),
        ])
    __DL_PowerBalancing_Information_iE_Extensions__item_._ext = None
    _DL_PowerBalancing_Information_iE_Extensions._cont = __DL_PowerBalancing_Information_iE_Extensions__item_
    _DL_PowerBalancing_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_PowerBalancing_Information._cont = ASN1Dict([
        ('powerAdjustmentType', _DL_PowerBalancing_Information_powerAdjustmentType),
        ('dLReferencePower', _DL_PowerBalancing_Information_dLReferencePower),
        ('dLReferencePowerList-DL-PC-Rqst', _DL_PowerBalancing_Information_dLReferencePowerList_DL_PC_Rqst),
        ('maxAdjustmentStep', _DL_PowerBalancing_Information_maxAdjustmentStep),
        ('adjustmentPeriod', _DL_PowerBalancing_Information_adjustmentPeriod),
        ('adjustmentRatio', _DL_PowerBalancing_Information_adjustmentRatio),
        ('iE-Extensions', _DL_PowerBalancing_Information_iE_Extensions),
        ])
    DL_PowerBalancing_Information._ext = []
    
    #-----< DL-PowerBalancing-Information-ExtIEs >-----#
    DL_PowerBalancing_Information_ExtIEs = CLASS(name='DL-PowerBalancing-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_PowerBalancing_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-ReferencePowerInformationList >-----#
    DL_ReferencePowerInformationList = SEQ_OF(name='DL-ReferencePowerInformationList', mode=MODE_TYPE)
    _DL_ReferencePowerInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-ReferencePowerInformationItem')))
    DL_ReferencePowerInformationList._cont = _DL_ReferencePowerInformationList__item_
    DL_ReferencePowerInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-ReferencePowerInformationItem >-----#
    DL_ReferencePowerInformationItem = SEQ(name='DL-ReferencePowerInformationItem', mode=MODE_TYPE)
    _DL_ReferencePowerInformationItem_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _DL_ReferencePowerInformationItem_dl_Reference_Power = INT(name='dl-Reference-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_ReferencePowerInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_ReferencePowerInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__id._const_tab = ____DL_ReferencePowerInformationItem_iE_Extensions__item__id_tab
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality._const_tab = ____DL_ReferencePowerInformationItem_iE_Extensions__item__criticality_tab
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue._const_tab = ____DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue_tab
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_ReferencePowerInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_ReferencePowerInformationItem_iE_Extensions__item__id),
        ('criticality', ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue),
        ])
    __DL_ReferencePowerInformationItem_iE_Extensions__item_._ext = None
    _DL_ReferencePowerInformationItem_iE_Extensions._cont = __DL_ReferencePowerInformationItem_iE_Extensions__item_
    _DL_ReferencePowerInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_ReferencePowerInformationItem._cont = ASN1Dict([
        ('rL-ID', _DL_ReferencePowerInformationItem_rL_ID),
        ('dl-Reference-Power', _DL_ReferencePowerInformationItem_dl_Reference_Power),
        ('iE-Extensions', _DL_ReferencePowerInformationItem_iE_Extensions),
        ])
    DL_ReferencePowerInformationItem._ext = []
    
    #-----< DL-ReferencePowerInformationItem-ExtIEs >-----#
    DL_ReferencePowerInformationItem_ExtIEs = CLASS(name='DL-ReferencePowerInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_ReferencePowerInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PowerBalancing-ActivationIndicator >-----#
    DL_PowerBalancing_ActivationIndicator = ENUM(name='DL-PowerBalancing-ActivationIndicator', mode=MODE_TYPE)
    DL_PowerBalancing_ActivationIndicator._cont = ASN1Dict([('dL-PowerBalancing-Activated', 0)])
    DL_PowerBalancing_ActivationIndicator._ext = None
    
    #-----< DL-PowerBalancing-UpdatedIndicator >-----#
    DL_PowerBalancing_UpdatedIndicator = ENUM(name='DL-PowerBalancing-UpdatedIndicator', mode=MODE_TYPE)
    DL_PowerBalancing_UpdatedIndicator._cont = ASN1Dict([('dL-PowerBalancing-Updated', 0)])
    DL_PowerBalancing_UpdatedIndicator._ext = None
    
    #-----< DL-ScramblingCode >-----#
    DL_ScramblingCode = INT(name='DL-ScramblingCode', mode=MODE_TYPE)
    DL_ScramblingCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< DL-TimeslotISCP >-----#
    DL_TimeslotISCP = INT(name='DL-TimeslotISCP', mode=MODE_TYPE)
    DL_TimeslotISCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=91)], ev=None, er=[])
    
    #-----< DL-TimeslotISCPInfo >-----#
    DL_TimeslotISCPInfo = SEQ_OF(name='DL-TimeslotISCPInfo', mode=MODE_TYPE)
    _DL_TimeslotISCPInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfoItem')))
    DL_TimeslotISCPInfo._cont = _DL_TimeslotISCPInfo__item_
    DL_TimeslotISCPInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-TimeslotISCPInfoItem >-----#
    DL_TimeslotISCPInfoItem = SEQ(name='DL-TimeslotISCPInfoItem', mode=MODE_TYPE)
    _DL_TimeslotISCPInfoItem_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _DL_TimeslotISCPInfoItem_dL_TimeslotISCP = INT(name='dL-TimeslotISCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCP')))
    _DL_TimeslotISCPInfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_TimeslotISCPInfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_TimeslotISCPInfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_TimeslotISCPInfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__id._const_tab = ____DL_TimeslotISCPInfoItem_iE_Extensions__item__id_tab
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__id._const_tab_at = None
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_TimeslotISCPInfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_TimeslotISCPInfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__criticality._const_tab = ____DL_TimeslotISCPInfoItem_iE_Extensions__item__criticality_tab
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_TimeslotISCPInfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_TimeslotISCPInfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__extensionValue._const_tab = ____DL_TimeslotISCPInfoItem_iE_Extensions__item__extensionValue_tab
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_TimeslotISCPInfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_TimeslotISCPInfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_TimeslotISCPInfoItem_iE_Extensions__item__id),
        ('criticality', ___DL_TimeslotISCPInfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_TimeslotISCPInfoItem_iE_Extensions__item__extensionValue),
        ])
    __DL_TimeslotISCPInfoItem_iE_Extensions__item_._ext = None
    _DL_TimeslotISCPInfoItem_iE_Extensions._cont = __DL_TimeslotISCPInfoItem_iE_Extensions__item_
    _DL_TimeslotISCPInfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_TimeslotISCPInfoItem._cont = ASN1Dict([
        ('timeSlot', _DL_TimeslotISCPInfoItem_timeSlot),
        ('dL-TimeslotISCP', _DL_TimeslotISCPInfoItem_dL_TimeslotISCP),
        ('iE-Extensions', _DL_TimeslotISCPInfoItem_iE_Extensions),
        ])
    DL_TimeslotISCPInfoItem._ext = []
    
    #-----< DL-TimeslotISCPInfoItem-ExtIEs >-----#
    DL_TimeslotISCPInfoItem_ExtIEs = CLASS(name='DL-TimeslotISCPInfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_TimeslotISCPInfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-TimeslotISCPInfoLCR >-----#
    DL_TimeslotISCPInfoLCR = SEQ_OF(name='DL-TimeslotISCPInfoLCR', mode=MODE_TYPE)
    _DL_TimeslotISCPInfoLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfoItemLCR')))
    DL_TimeslotISCPInfoLCR._cont = _DL_TimeslotISCPInfoLCR__item_
    DL_TimeslotISCPInfoLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-TimeslotISCPInfoItemLCR >-----#
    DL_TimeslotISCPInfoItemLCR = SEQ(name='DL-TimeslotISCPInfoItemLCR', mode=MODE_TYPE)
    _DL_TimeslotISCPInfoItemLCR_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _DL_TimeslotISCPInfoItemLCR_dL_TimeslotISCP = INT(name='dL-TimeslotISCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCP')))
    _DL_TimeslotISCPInfoItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_TimeslotISCPInfoItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__id._const_tab = ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__id_tab
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__criticality._const_tab = ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__criticality_tab
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__extensionValue._const_tab = ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__extensionValue_tab
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_TimeslotISCPInfoItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__id),
        ('criticality', ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__extensionValue),
        ])
    __DL_TimeslotISCPInfoItemLCR_iE_Extensions__item_._ext = None
    _DL_TimeslotISCPInfoItemLCR_iE_Extensions._cont = __DL_TimeslotISCPInfoItemLCR_iE_Extensions__item_
    _DL_TimeslotISCPInfoItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_TimeslotISCPInfoItemLCR._cont = ASN1Dict([
        ('timeSlotLCR', _DL_TimeslotISCPInfoItemLCR_timeSlotLCR),
        ('dL-TimeslotISCP', _DL_TimeslotISCPInfoItemLCR_dL_TimeslotISCP),
        ('iE-Extensions', _DL_TimeslotISCPInfoItemLCR_iE_Extensions),
        ])
    DL_TimeslotISCPInfoItemLCR._ext = []
    
    #-----< DL-TimeslotISCPInfoItemLCR-ExtIEs >-----#
    DL_TimeslotISCPInfoItemLCR_ExtIEs = CLASS(name='DL-TimeslotISCPInfoItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_TimeslotISCPInfoItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-TPC-Pattern01Count >-----#
    DL_TPC_Pattern01Count = INT(name='DL-TPC-Pattern01Count', mode=MODE_TYPE)
    DL_TPC_Pattern01Count._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=30)], ev=[], er=[])
    
    #-----< DLTransmissionBranchLoadValue >-----#
    DLTransmissionBranchLoadValue = INT(name='DLTransmissionBranchLoadValue', mode=MODE_TYPE)
    DLTransmissionBranchLoadValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=101)], ev=[], er=[])
    
    #-----< Downlink-Compressed-Mode-Method >-----#
    Downlink_Compressed_Mode_Method = ENUM(name='Downlink-Compressed-Mode-Method', mode=MODE_TYPE)
    Downlink_Compressed_Mode_Method._cont = ASN1Dict([('not-Used-puncturing', 0), ('sFdiv2', 1), ('higher-layer-scheduling', 2)])
    Downlink_Compressed_Mode_Method._ext = []
    
    #-----< DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst >-----#
    DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-HS-PDSCH-Timeslot-InformationItem-LCR-PSCH-ReconfRqst')))
    DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst._cont = _DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item_
    DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-HS-PDSCH-Timeslot-InformationItem-LCR-PSCH-ReconfRqst >-----#
    DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst = SEQ(name='DL-HS-PDSCH-Timeslot-InformationItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftAndBurstType = SEQ(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_dl_HS_PDSCH_Codelist_LCR_PSCH_ReconfRqst = SEQ_OF(name='dl-HS-PDSCH-Codelist-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-HS-PDSCH-Codelist-LCR-PSCH-ReconfRqst')))
    _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_maxHSDSCH_HSSCCH_Power = INT(name='maxHSDSCH-HSSCCH-Power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')), opt=True)
    _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaxHSDSCH-HSSCCH-Power-per-CELLPORTION')))
    ____DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1137), ('criticality', 'ignore'), ('Extension', _____DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlot', _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('dl-HS-PDSCH-Codelist-LCR-PSCH-ReconfRqst', _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_dl_HS_PDSCH_Codelist_LCR_PSCH_ReconfRqst),
        ('maxHSDSCH-HSSCCH-Power', _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_maxHSDSCH_HSSCCH_Power),
        ('iE-Extensions', _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< DL-HS-PDSCH-Timeslot-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-HS-PDSCH-Timeslot-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaxHSDSCH-HSSCCH-Power-per-CELLPORTION')))
    DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 1137), ('criticality', 'ignore'), ('Extension', _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MaxHSDSCH-HSSCCH-Power-per-CELLPORTION >-----#
    MaxHSDSCH_HSSCCH_Power_per_CELLPORTION = SEQ_OF(name='MaxHSDSCH-HSSCCH-Power-per-CELLPORTION', mode=MODE_TYPE)
    _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaxHSDSCH-HSSCCH-Power-per-CELLPORTION-Item')))
    MaxHSDSCH_HSSCCH_Power_per_CELLPORTION._cont = _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION__item_
    MaxHSDSCH_HSSCCH_Power_per_CELLPORTION._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MaxHSDSCH-HSSCCH-Power-per-CELLPORTION-Item >-----#
    MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item = SEQ(name='MaxHSDSCH-HSSCCH-Power-per-CELLPORTION-Item', mode=MODE_TYPE)
    _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_maxHSDSCH_HSSCCH_Power = INT(name='maxHSDSCH-HSSCCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__id._const_tab = ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__id_tab
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__id._const_tab_at = None
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__criticality._const_tab = ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__criticality_tab
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__extensionValue._const_tab = ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__extensionValue_tab
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__id),
        ('criticality', ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__extensionValue),
        ])
    __MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item_._ext = None
    _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions._cont = __MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item_
    _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item._cont = ASN1Dict([
        ('cellPortionLCRID', _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_cellPortionLCRID),
        ('maxHSDSCH-HSSCCH-Power', _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_maxHSDSCH_HSSCCH_Power),
        ('iE-Extensions', _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions),
        ])
    MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item._ext = []
    
    #-----< MaxHSDSCH-HSSCCH-Power-per-CELLPORTION-Item-ExtIEs >-----#
    MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_ExtIEs = CLASS(name='MaxHSDSCH-HSSCCH-Power-per-CELLPORTION-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-HS-PDSCH-Codelist-LCR-PSCH-ReconfRqst >-----#
    DL_HS_PDSCH_Codelist_LCR_PSCH_ReconfRqst = SEQ_OF(name='DL-HS-PDSCH-Codelist-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_HS_PDSCH_Codelist_LCR_PSCH_ReconfRqst__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    DL_HS_PDSCH_Codelist_LCR_PSCH_ReconfRqst._cont = _DL_HS_PDSCH_Codelist_LCR_PSCH_ReconfRqst__item_
    DL_HS_PDSCH_Codelist_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Downlink-TPC-enhancements-Information >-----#
    Downlink_TPC_enhancements_Information = SEQ(name='Downlink-TPC-enhancements-Information', mode=MODE_TYPE)
    _Downlink_TPC_enhancements_Information_decimationFactorforPrimaryFrequency = ENUM(name='decimationFactorforPrimaryFrequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DecimationFactor')), opt=True)
    _Downlink_TPC_enhancements_Information_decimationFactorforSecFrequency = ENUM(name='decimationFactorforSecFrequency', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DecimationFactor')), opt=True)
    _Downlink_TPC_enhancements_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Downlink_TPC_enhancements_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id._const_tab = ____Downlink_TPC_enhancements_Information_iE_Extensions__item__id_tab
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id._const_tab_at = None
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality._const_tab = ____Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality_tab
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue._const_tab = ____Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue_tab
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Downlink_TPC_enhancements_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id),
        ('criticality', ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue),
        ])
    __Downlink_TPC_enhancements_Information_iE_Extensions__item_._ext = None
    _Downlink_TPC_enhancements_Information_iE_Extensions._cont = __Downlink_TPC_enhancements_Information_iE_Extensions__item_
    _Downlink_TPC_enhancements_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Downlink_TPC_enhancements_Information._cont = ASN1Dict([
        ('decimationFactorforPrimaryFrequency', _Downlink_TPC_enhancements_Information_decimationFactorforPrimaryFrequency),
        ('decimationFactorforSecFrequency', _Downlink_TPC_enhancements_Information_decimationFactorforSecFrequency),
        ('iE-Extensions', _Downlink_TPC_enhancements_Information_iE_Extensions),
        ])
    Downlink_TPC_enhancements_Information._ext = []
    
    #-----< Downlink-TPC-enhancements-Information-ExtIEs >-----#
    Downlink_TPC_enhancements_Information_ExtIEs = CLASS(name='Downlink-TPC-enhancements-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Downlink_TPC_enhancements_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Downlink-TPC-enhancements-Reconf >-----#
    Downlink_TPC_enhancements_Reconf = SEQ(name='Downlink-TPC-enhancements-Reconf', mode=MODE_TYPE)
    _Downlink_TPC_enhancements_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements = CHOICE(name='setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements')))
    _Downlink_TPC_enhancements_Reconf_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Downlink_TPC_enhancements_Reconf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id._const_tab = ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id_tab
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id._const_tab_at = None
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id._const_tab_id = 'id'
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality._const_tab = ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality_tab
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue._const_tab = ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue_tab
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Downlink_TPC_enhancements_Reconf_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id),
        ('criticality', ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality),
        ('extensionValue', ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue),
        ])
    __Downlink_TPC_enhancements_Reconf_iE_Extensions__item_._ext = None
    _Downlink_TPC_enhancements_Reconf_iE_Extensions._cont = __Downlink_TPC_enhancements_Reconf_iE_Extensions__item_
    _Downlink_TPC_enhancements_Reconf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Downlink_TPC_enhancements_Reconf._cont = ASN1Dict([
        ('setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements', _Downlink_TPC_enhancements_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements),
        ('iE-Extensions', _Downlink_TPC_enhancements_Reconf_iE_Extensions),
        ])
    Downlink_TPC_enhancements_Reconf._ext = []
    
    #-----< Downlink-TPC-enhancements-Reconf-ExtIEs >-----#
    Downlink_TPC_enhancements_Reconf_ExtIEs = CLASS(name='Downlink-TPC-enhancements-Reconf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Downlink_TPC_enhancements_Reconf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Downlink-TPC-enhancements-Information-Removal >-----#
    Downlink_TPC_enhancements_Information_Removal = ENUM(name='Downlink-TPC-enhancements-Information-Removal', mode=MODE_TYPE)
    Downlink_TPC_enhancements_Information_Removal._cont = ASN1Dict([('remove', 0)])
    Downlink_TPC_enhancements_Information_Removal._ext = []
    
    #-----< DPC-Mode >-----#
    DPC_Mode = ENUM(name='DPC-Mode', mode=MODE_TYPE)
    DPC_Mode._cont = ASN1Dict([('mode0', 0), ('mode1', 1)])
    DPC_Mode._ext = []
    
    #-----< DPCH-ID >-----#
    DPCH_ID = INT(name='DPCH-ID', mode=MODE_TYPE)
    DPCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=239)], ev=None, er=[])
    
    #-----< DPCH-ID768 >-----#
    DPCH_ID768 = INT(name='DPCH-ID768', mode=MODE_TYPE)
    DPCH_ID768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=479)], ev=None, er=[])
    
    #-----< DRX-Information >-----#
    DRX_Information = SEQ(name='DRX-Information', mode=MODE_TYPE)
    _DRX_Information_uE_DRX_Cycle = ENUM(name='uE-DRX-Cycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Cycle')))
    _DRX_Information_inactivity_Threshold_for_UE_DRX_Cycle = ENUM(name='inactivity-Threshold-for-UE-DRX-Cycle', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')))
    _DRX_Information_inactivity_Threshold_for_UE_Grant_Monitoring = ENUM(name='inactivity-Threshold-for-UE-Grant-Monitoring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-Grant-Monitoring')))
    _DRX_Information_uE_DRX_Grant_Monitoring = BOOL(name='uE-DRX-Grant-Monitoring', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Grant-Monitoring')))
    _DRX_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRX_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DRX_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DRX_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Cycle')))
    _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')))
    ____DRX_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1282), ('criticality', 'ignore'), ('Extension', _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1283), ('criticality', 'ignore'), ('Extension', _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRX_Information_iE_Extensions__item__id._const_tab = ____DRX_Information_iE_Extensions__item__id_tab
    ___DRX_Information_iE_Extensions__item__id._const_tab_at = None
    ___DRX_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRX_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRX_Information_iE_Extensions__item__criticality._const_tab = ____DRX_Information_iE_Extensions__item__id_tab
    ___DRX_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRX_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRX_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRX_Information_iE_Extensions__item__extensionValue._const_tab = ____DRX_Information_iE_Extensions__item__id_tab
    ___DRX_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRX_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRX_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRX_Information_iE_Extensions__item__id),
        ('criticality', ___DRX_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___DRX_Information_iE_Extensions__item__extensionValue),
        ])
    __DRX_Information_iE_Extensions__item_._ext = None
    _DRX_Information_iE_Extensions._cont = __DRX_Information_iE_Extensions__item_
    _DRX_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRX_Information._cont = ASN1Dict([
        ('uE-DRX-Cycle', _DRX_Information_uE_DRX_Cycle),
        ('inactivity-Threshold-for-UE-DRX-Cycle', _DRX_Information_inactivity_Threshold_for_UE_DRX_Cycle),
        ('inactivity-Threshold-for-UE-Grant-Monitoring', _DRX_Information_inactivity_Threshold_for_UE_Grant_Monitoring),
        ('uE-DRX-Grant-Monitoring', _DRX_Information_uE_DRX_Grant_Monitoring),
        ('iE-Extensions', _DRX_Information_iE_Extensions),
        ])
    DRX_Information._ext = []
    
    #-----< DRX-Information-ExtIEs >-----#
    DRX_Information_ExtIEs = CLASS(name='DRX-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DRX_Information_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Cycle')))
    _DRX_Information_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')))
    DRX_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 1282), ('criticality', 'ignore'), ('Extension', _DRX_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1283), ('criticality', 'ignore'), ('Extension', _DRX_Information_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRX-Information-to-Modify >-----#
    DRX_Information_to_Modify = CHOICE(name='DRX-Information-to-Modify', mode=MODE_TYPE)
    _DRX_Information_to_Modify_modify = SEQ(name='modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DRX-Information-to-Modify-Items')))
    _DRX_Information_to_Modify_deactivate = NULL(name='deactivate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DRX_Information_to_Modify._cont = ASN1Dict([
        ('modify', _DRX_Information_to_Modify_modify),
        ('deactivate', _DRX_Information_to_Modify_deactivate),
        ])
    DRX_Information_to_Modify._ext = []
    
    #-----< DRX-Information-to-Modify-Items >-----#
    DRX_Information_to_Modify_Items = SEQ(name='DRX-Information-to-Modify-Items', mode=MODE_TYPE)
    _DRX_Information_to_Modify_Items_uE_DRX_Cycle = ENUM(name='uE-DRX-Cycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Cycle')), opt=True)
    _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DRX_Cycle = ENUM(name='inactivity-Threshold-for-UE-DRX-Cycle', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')), opt=True)
    _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_Grant_Monitoring = ENUM(name='inactivity-Threshold-for-UE-Grant-Monitoring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-Grant-Monitoring')), opt=True)
    _DRX_Information_to_Modify_Items_uE_DRX_Grant_Monitoring = BOOL(name='uE-DRX-Grant-Monitoring', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Grant-Monitoring')), opt=True)
    _DRX_Information_to_Modify_Items_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRX_Information_to_Modify_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Cycle')))
    _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')))
    ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1282), ('criticality', 'ignore'), ('Extension', _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1283), ('criticality', 'ignore'), ('Extension', _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab = ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab_at = None
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab = ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab = ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRX_Information_to_Modify_Items_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRX_Information_to_Modify_Items_iE_Extensions__item__id),
        ('criticality', ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality),
        ('extensionValue', ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue),
        ])
    __DRX_Information_to_Modify_Items_iE_Extensions__item_._ext = None
    _DRX_Information_to_Modify_Items_iE_Extensions._cont = __DRX_Information_to_Modify_Items_iE_Extensions__item_
    _DRX_Information_to_Modify_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRX_Information_to_Modify_Items._cont = ASN1Dict([
        ('uE-DRX-Cycle', _DRX_Information_to_Modify_Items_uE_DRX_Cycle),
        ('inactivity-Threshold-for-UE-DRX-Cycle', _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DRX_Cycle),
        ('inactivity-Threshold-for-UE-Grant-Monitoring', _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_Grant_Monitoring),
        ('uE-DRX-Grant-Monitoring', _DRX_Information_to_Modify_Items_uE_DRX_Grant_Monitoring),
        ('iE-Extensions', _DRX_Information_to_Modify_Items_iE_Extensions),
        ])
    DRX_Information_to_Modify_Items._ext = []
    
    #-----< DRX-Information-to-Modify-Items-ExtIEs >-----#
    DRX_Information_to_Modify_Items_ExtIEs = CLASS(name='DRX-Information-to-Modify-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-DRX-Cycle')))
    _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')))
    DRX_Information_to_Modify_Items_ExtIEs._val = ASN1Set(rv=[dict([('id', 1282), ('criticality', 'ignore'), ('Extension', _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1283), ('criticality', 'ignore'), ('Extension', _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRX-Interruption-by-HS-DSCH >-----#
    DRX_Interruption_by_HS_DSCH = ENUM(name='DRX-Interruption-by-HS-DSCH', mode=MODE_TYPE)
    DRX_Interruption_by_HS_DSCH._cont = ASN1Dict([('drx-Interruption-Configured', 0), ('drx-Interruption-Not-Configured', 1)])
    DRX_Interruption_by_HS_DSCH._ext = []
    
    #-----< DSCH-ID >-----#
    DSCH_ID = INT(name='DSCH-ID', mode=MODE_TYPE)
    DSCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< DSCH-InformationResponse >-----#
    DSCH_InformationResponse = SEQ_OF(name='DSCH-InformationResponse', mode=MODE_TYPE)
    _DSCH_InformationResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-InformationResponseItem')))
    DSCH_InformationResponse._cont = _DSCH_InformationResponse__item_
    DSCH_InformationResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DSCH-InformationResponseItem >-----#
    DSCH_InformationResponseItem = SEQ(name='DSCH-InformationResponseItem', mode=MODE_TYPE)
    _DSCH_InformationResponseItem_dSCH_ID = INT(name='dSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DSCH-ID')))
    _DSCH_InformationResponseItem_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _DSCH_InformationResponseItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _DSCH_InformationResponseItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCH_InformationResponseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DSCH_InformationResponseItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DSCH_InformationResponseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DSCH_InformationResponseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_InformationResponseItem_iE_Extensions__item__id._const_tab = ____DSCH_InformationResponseItem_iE_Extensions__item__id_tab
    ___DSCH_InformationResponseItem_iE_Extensions__item__id._const_tab_at = None
    ___DSCH_InformationResponseItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DSCH_InformationResponseItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DSCH_InformationResponseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DSCH_InformationResponseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab = ____DSCH_InformationResponseItem_iE_Extensions__item__criticality_tab
    ___DSCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DSCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DSCH_InformationResponseItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DSCH_InformationResponseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DSCH_InformationResponseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab = ____DSCH_InformationResponseItem_iE_Extensions__item__extensionValue_tab
    ___DSCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DSCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DSCH_InformationResponseItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DSCH_InformationResponseItem_iE_Extensions__item__id),
        ('criticality', ___DSCH_InformationResponseItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DSCH_InformationResponseItem_iE_Extensions__item__extensionValue),
        ])
    __DSCH_InformationResponseItem_iE_Extensions__item_._ext = None
    _DSCH_InformationResponseItem_iE_Extensions._cont = __DSCH_InformationResponseItem_iE_Extensions__item_
    _DSCH_InformationResponseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCH_InformationResponseItem._cont = ASN1Dict([
        ('dSCH-ID', _DSCH_InformationResponseItem_dSCH_ID),
        ('bindingID', _DSCH_InformationResponseItem_bindingID),
        ('transportLayerAddress', _DSCH_InformationResponseItem_transportLayerAddress),
        ('iE-Extensions', _DSCH_InformationResponseItem_iE_Extensions),
        ])
    DSCH_InformationResponseItem._ext = []
    
    #-----< DSCH-InformationResponseItem-ExtIEs >-----#
    DSCH_InformationResponseItem_ExtIEs = CLASS(name='DSCH-InformationResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DSCH_InformationResponseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DSCH-TDD-Information >-----#
    DSCH_TDD_Information = SEQ_OF(name='DSCH-TDD-Information', mode=MODE_TYPE)
    _DSCH_TDD_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-TDD-InformationItem')))
    DSCH_TDD_Information._cont = _DSCH_TDD_Information__item_
    DSCH_TDD_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DSCH-TDD-InformationItem >-----#
    DSCH_TDD_InformationItem = SEQ(name='DSCH-TDD-InformationItem', mode=MODE_TYPE)
    _DSCH_TDD_InformationItem_dSCH_ID = INT(name='dSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DSCH-ID')))
    _DSCH_TDD_InformationItem_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _DSCH_TDD_InformationItem_transportFormatSet = SEQ(name='transportFormatSet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _DSCH_TDD_InformationItem_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')))
    _DSCH_TDD_InformationItem_frameHandlingPriority = INT(name='frameHandlingPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FrameHandlingPriority')))
    _DSCH_TDD_InformationItem_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')))
    _DSCH_TDD_InformationItem_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')))
    _DSCH_TDD_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCH_TDD_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DSCH_TDD_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DSCH_TDD_InformationItem_iE_Extensions__item__id._const_tab = ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DSCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DSCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab = ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DSCH_TDD_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DSCH_TDD_InformationItem_iE_Extensions__item__id),
        ('criticality', ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __DSCH_TDD_InformationItem_iE_Extensions__item_._ext = None
    _DSCH_TDD_InformationItem_iE_Extensions._cont = __DSCH_TDD_InformationItem_iE_Extensions__item_
    _DSCH_TDD_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCH_TDD_InformationItem._cont = ASN1Dict([
        ('dSCH-ID', _DSCH_TDD_InformationItem_dSCH_ID),
        ('cCTrCH-ID', _DSCH_TDD_InformationItem_cCTrCH_ID),
        ('transportFormatSet', _DSCH_TDD_InformationItem_transportFormatSet),
        ('allocationRetentionPriority', _DSCH_TDD_InformationItem_allocationRetentionPriority),
        ('frameHandlingPriority', _DSCH_TDD_InformationItem_frameHandlingPriority),
        ('toAWS', _DSCH_TDD_InformationItem_toAWS),
        ('toAWE', _DSCH_TDD_InformationItem_toAWE),
        ('iE-Extensions', _DSCH_TDD_InformationItem_iE_Extensions),
        ])
    DSCH_TDD_InformationItem._ext = []
    
    #-----< DSCH-TDD-InformationItem-ExtIEs >-----#
    DSCH_TDD_InformationItem_ExtIEs = CLASS(name='DSCH-TDD-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DSCH_TDD_InformationItem_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _DSCH_TDD_InformationItem_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _DSCH_TDD_InformationItem_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    DSCH_TDD_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _DSCH_TDD_InformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _DSCH_TDD_InformationItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _DSCH_TDD_InformationItem_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DsField >-----#
    DsField = BIT_STR(name='DsField', mode=MODE_TYPE)
    DsField._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< DTX-Cycle-2ms-Items >-----#
    DTX_Cycle_2ms_Items = SEQ(name='DTX-Cycle-2ms-Items', mode=MODE_TYPE)
    _DTX_Cycle_2ms_Items_uE_DTX_Cycle1_2ms = ENUM(name='uE-DTX-Cycle1-2ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Cycle1-2ms')))
    _DTX_Cycle_2ms_Items_uE_DTX_Cycle2_2ms = ENUM(name='uE-DTX-Cycle2-2ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Cycle2-2ms')))
    _DTX_Cycle_2ms_Items_mAC_DTX_Cycle_2ms = ENUM(name='mAC-DTX-Cycle-2ms', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-DTX-Cycle-2ms')))
    _DTX_Cycle_2ms_Items_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Cycle_2ms_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__id._const_tab = ____DTX_Cycle_2ms_Items_iE_Extensions__item__id_tab
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__id._const_tab_id = 'id'
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality._const_tab = ____DTX_Cycle_2ms_Items_iE_Extensions__item__criticality_tab
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue._const_tab = ____DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue_tab
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DTX_Cycle_2ms_Items_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DTX_Cycle_2ms_Items_iE_Extensions__item__id),
        ('criticality', ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality),
        ('extensionValue', ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue),
        ])
    __DTX_Cycle_2ms_Items_iE_Extensions__item_._ext = None
    _DTX_Cycle_2ms_Items_iE_Extensions._cont = __DTX_Cycle_2ms_Items_iE_Extensions__item_
    _DTX_Cycle_2ms_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Cycle_2ms_Items._cont = ASN1Dict([
        ('uE-DTX-Cycle1-2ms', _DTX_Cycle_2ms_Items_uE_DTX_Cycle1_2ms),
        ('uE-DTX-Cycle2-2ms', _DTX_Cycle_2ms_Items_uE_DTX_Cycle2_2ms),
        ('mAC-DTX-Cycle-2ms', _DTX_Cycle_2ms_Items_mAC_DTX_Cycle_2ms),
        ('iE-Extensions', _DTX_Cycle_2ms_Items_iE_Extensions),
        ])
    DTX_Cycle_2ms_Items._ext = []
    
    #-----< DTX-Cycle-2ms-Items-ExtIEs >-----#
    DTX_Cycle_2ms_Items_ExtIEs = CLASS(name='DTX-Cycle-2ms-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DTX_Cycle_2ms_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DTX-Cycle-2ms-to-Modify-Items >-----#
    DTX_Cycle_2ms_to_Modify_Items = SEQ(name='DTX-Cycle-2ms-to-Modify-Items', mode=MODE_TYPE)
    _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle1_2ms = ENUM(name='uE-DTX-Cycle1-2ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Cycle1-2ms')))
    _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle2_2ms = ENUM(name='uE-DTX-Cycle2-2ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Cycle2-2ms')))
    _DTX_Cycle_2ms_to_Modify_Items_mAC_DTX_Cycle_2ms = ENUM(name='mAC-DTX-Cycle-2ms', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-DTX-Cycle-2ms')))
    _DTX_Cycle_2ms_to_Modify_Items_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id._const_tab = ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id_tab
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id._const_tab_id = 'id'
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab = ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality_tab
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab = ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id),
        ('criticality', ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality),
        ('extensionValue', ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue),
        ])
    __DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item_._ext = None
    _DTX_Cycle_2ms_to_Modify_Items_iE_Extensions._cont = __DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item_
    _DTX_Cycle_2ms_to_Modify_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Cycle_2ms_to_Modify_Items._cont = ASN1Dict([
        ('uE-DTX-Cycle1-2ms', _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle1_2ms),
        ('uE-DTX-Cycle2-2ms', _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle2_2ms),
        ('mAC-DTX-Cycle-2ms', _DTX_Cycle_2ms_to_Modify_Items_mAC_DTX_Cycle_2ms),
        ('iE-Extensions', _DTX_Cycle_2ms_to_Modify_Items_iE_Extensions),
        ])
    DTX_Cycle_2ms_to_Modify_Items._ext = []
    
    #-----< DTX-Cycle-2ms-to-Modify-Items-ExtIEs >-----#
    DTX_Cycle_2ms_to_Modify_Items_ExtIEs = CLASS(name='DTX-Cycle-2ms-to-Modify-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DTX_Cycle_2ms_to_Modify_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DTX-Cycle-10ms-Items >-----#
    DTX_Cycle_10ms_Items = SEQ(name='DTX-Cycle-10ms-Items', mode=MODE_TYPE)
    _DTX_Cycle_10ms_Items_uE_DTX_Cycle1_10ms = ENUM(name='uE-DTX-Cycle1-10ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Cycle1-10ms')))
    _DTX_Cycle_10ms_Items_uE_DTX_Cycle2_10ms = ENUM(name='uE-DTX-Cycle2-10ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Cycle2-10ms')))
    _DTX_Cycle_10ms_Items_mAC_DTX_Cycle_10ms = ENUM(name='mAC-DTX-Cycle-10ms', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-DTX-Cycle-10ms')))
    _DTX_Cycle_10ms_Items_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Cycle_10ms_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__id._const_tab = ____DTX_Cycle_10ms_Items_iE_Extensions__item__id_tab
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__id._const_tab_id = 'id'
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality._const_tab = ____DTX_Cycle_10ms_Items_iE_Extensions__item__criticality_tab
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue._const_tab = ____DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue_tab
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DTX_Cycle_10ms_Items_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DTX_Cycle_10ms_Items_iE_Extensions__item__id),
        ('criticality', ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality),
        ('extensionValue', ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue),
        ])
    __DTX_Cycle_10ms_Items_iE_Extensions__item_._ext = None
    _DTX_Cycle_10ms_Items_iE_Extensions._cont = __DTX_Cycle_10ms_Items_iE_Extensions__item_
    _DTX_Cycle_10ms_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Cycle_10ms_Items._cont = ASN1Dict([
        ('uE-DTX-Cycle1-10ms', _DTX_Cycle_10ms_Items_uE_DTX_Cycle1_10ms),
        ('uE-DTX-Cycle2-10ms', _DTX_Cycle_10ms_Items_uE_DTX_Cycle2_10ms),
        ('mAC-DTX-Cycle-10ms', _DTX_Cycle_10ms_Items_mAC_DTX_Cycle_10ms),
        ('iE-Extensions', _DTX_Cycle_10ms_Items_iE_Extensions),
        ])
    DTX_Cycle_10ms_Items._ext = []
    
    #-----< DTX-Cycle-10ms-Items-ExtIEs >-----#
    DTX_Cycle_10ms_Items_ExtIEs = CLASS(name='DTX-Cycle-10ms-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DTX_Cycle_10ms_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DTX-Cycle-10ms-to-Modify-Items >-----#
    DTX_Cycle_10ms_to_Modify_Items = SEQ(name='DTX-Cycle-10ms-to-Modify-Items', mode=MODE_TYPE)
    _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle1_10ms = ENUM(name='uE-DTX-Cycle1-10ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Cycle1-10ms')))
    _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle2_10ms = ENUM(name='uE-DTX-Cycle2-10ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Cycle2-10ms')))
    _DTX_Cycle_10ms_to_Modify_Items_mAC_DTX_Cycle_10ms = ENUM(name='mAC-DTX-Cycle-10ms', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-DTX-Cycle-10ms')))
    _DTX_Cycle_10ms_to_Modify_Items_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id._const_tab = ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id_tab
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id._const_tab_id = 'id'
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab = ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality_tab
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab = ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id),
        ('criticality', ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality),
        ('extensionValue', ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue),
        ])
    __DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item_._ext = None
    _DTX_Cycle_10ms_to_Modify_Items_iE_Extensions._cont = __DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item_
    _DTX_Cycle_10ms_to_Modify_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Cycle_10ms_to_Modify_Items._cont = ASN1Dict([
        ('uE-DTX-Cycle1-10ms', _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle1_10ms),
        ('uE-DTX-Cycle2-10ms', _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle2_10ms),
        ('mAC-DTX-Cycle-10ms', _DTX_Cycle_10ms_to_Modify_Items_mAC_DTX_Cycle_10ms),
        ('iE-Extensions', _DTX_Cycle_10ms_to_Modify_Items_iE_Extensions),
        ])
    DTX_Cycle_10ms_to_Modify_Items._ext = []
    
    #-----< DTX-Cycle-10ms-to-Modify-Items-ExtIEs >-----#
    DTX_Cycle_10ms_to_Modify_Items_ExtIEs = CLASS(name='DTX-Cycle-10ms-to-Modify-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DTX_Cycle_10ms_to_Modify_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DTX-Information >-----#
    DTX_Information = SEQ(name='DTX-Information', mode=MODE_TYPE)
    _DTX_Information_e_DCH_TTI_Length = CHOICE(name='e-DCH-TTI-Length', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TTI-Length')))
    _DTX_Information_inactivity_Threshold_for_UE_DTX_Cycle2 = ENUM(name='inactivity-Threshold-for-UE-DTX-Cycle2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DTX-Cycle2')))
    _DTX_Information_uE_DTX_Long_Preamble = ENUM(name='uE-DTX-Long-Preamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Long-Preamble')))
    _DTX_Information_mAC_Inactivity_Threshold = ENUM(name='mAC-Inactivity-Threshold', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-Inactivity-Threshold')))
    _DTX_Information_cQI_DTX_Timer = ENUM(name='cQI-DTX-Timer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-DTX-Timer')))
    _DTX_Information_uE_DPCCH_burst1 = ENUM(name='uE-DPCCH-burst1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DPCCH-burst1')))
    _DTX_Information_uE_DPCCH_burst2 = ENUM(name='uE-DPCCH-burst2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DPCCH-burst2')))
    _DTX_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DTX_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_iE_Extensions__item__id._const_tab = ____DTX_Information_iE_Extensions__item__id_tab
    ___DTX_Information_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___DTX_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DTX_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_iE_Extensions__item__criticality._const_tab = ____DTX_Information_iE_Extensions__item__criticality_tab
    ___DTX_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DTX_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DTX_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DTX_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_iE_Extensions__item__extensionValue._const_tab = ____DTX_Information_iE_Extensions__item__extensionValue_tab
    ___DTX_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DTX_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DTX_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DTX_Information_iE_Extensions__item__id),
        ('criticality', ___DTX_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___DTX_Information_iE_Extensions__item__extensionValue),
        ])
    __DTX_Information_iE_Extensions__item_._ext = None
    _DTX_Information_iE_Extensions._cont = __DTX_Information_iE_Extensions__item_
    _DTX_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Information._cont = ASN1Dict([
        ('e-DCH-TTI-Length', _DTX_Information_e_DCH_TTI_Length),
        ('inactivity-Threshold-for-UE-DTX-Cycle2', _DTX_Information_inactivity_Threshold_for_UE_DTX_Cycle2),
        ('uE-DTX-Long-Preamble', _DTX_Information_uE_DTX_Long_Preamble),
        ('mAC-Inactivity-Threshold', _DTX_Information_mAC_Inactivity_Threshold),
        ('cQI-DTX-Timer', _DTX_Information_cQI_DTX_Timer),
        ('uE-DPCCH-burst1', _DTX_Information_uE_DPCCH_burst1),
        ('uE-DPCCH-burst2', _DTX_Information_uE_DPCCH_burst2),
        ('iE-Extensions', _DTX_Information_iE_Extensions),
        ])
    DTX_Information._ext = []
    
    #-----< DTX-Information-ExtIEs >-----#
    DTX_Information_ExtIEs = CLASS(name='DTX-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DTX_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DTX-Information-to-Modify >-----#
    DTX_Information_to_Modify = CHOICE(name='DTX-Information-to-Modify', mode=MODE_TYPE)
    _DTX_Information_to_Modify_modify = SEQ(name='modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DTX-Information-to-Modify-Items')))
    _DTX_Information_to_Modify_deactivate = NULL(name='deactivate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DTX_Information_to_Modify._cont = ASN1Dict([
        ('modify', _DTX_Information_to_Modify_modify),
        ('deactivate', _DTX_Information_to_Modify_deactivate),
        ])
    DTX_Information_to_Modify._ext = []
    
    #-----< DTX-Information-to-Modify-Items >-----#
    DTX_Information_to_Modify_Items = SEQ(name='DTX-Information-to-Modify-Items', mode=MODE_TYPE)
    _DTX_Information_to_Modify_Items_e_DCH_TTI_Length_to_Modify = CHOICE(name='e-DCH-TTI-Length-to-Modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TTI-Length-to-Modify')), opt=True)
    _DTX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DTX_Cycle2 = ENUM(name='inactivity-Threshold-for-UE-DTX-Cycle2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Inactivity-Threshold-for-UE-DTX-Cycle2')), opt=True)
    _DTX_Information_to_Modify_Items_uE_DTX_Long_Preamble = ENUM(name='uE-DTX-Long-Preamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DTX-Long-Preamble')), opt=True)
    _DTX_Information_to_Modify_Items_mAC_Inactivity_Threshold = ENUM(name='mAC-Inactivity-Threshold', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-Inactivity-Threshold')), opt=True)
    _DTX_Information_to_Modify_Items_cQI_DTX_Timer = ENUM(name='cQI-DTX-Timer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-DTX-Timer')), opt=True)
    _DTX_Information_to_Modify_Items_uE_DPCCH_burst1 = ENUM(name='uE-DPCCH-burst1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DPCCH-burst1')), opt=True)
    _DTX_Information_to_Modify_Items_uE_DPCCH_burst2 = ENUM(name='uE-DPCCH-burst2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-DPCCH-burst2')), opt=True)
    _DTX_Information_to_Modify_Items_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Information_to_Modify_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab = ____DTX_Information_to_Modify_Items_iE_Extensions__item__id_tab
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab_id = 'id'
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab = ____DTX_Information_to_Modify_Items_iE_Extensions__item__criticality_tab
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab = ____DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue_tab
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DTX_Information_to_Modify_Items_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DTX_Information_to_Modify_Items_iE_Extensions__item__id),
        ('criticality', ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality),
        ('extensionValue', ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue),
        ])
    __DTX_Information_to_Modify_Items_iE_Extensions__item_._ext = None
    _DTX_Information_to_Modify_Items_iE_Extensions._cont = __DTX_Information_to_Modify_Items_iE_Extensions__item_
    _DTX_Information_to_Modify_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Information_to_Modify_Items._cont = ASN1Dict([
        ('e-DCH-TTI-Length-to-Modify', _DTX_Information_to_Modify_Items_e_DCH_TTI_Length_to_Modify),
        ('inactivity-Threshold-for-UE-DTX-Cycle2', _DTX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DTX_Cycle2),
        ('uE-DTX-Long-Preamble', _DTX_Information_to_Modify_Items_uE_DTX_Long_Preamble),
        ('mAC-Inactivity-Threshold', _DTX_Information_to_Modify_Items_mAC_Inactivity_Threshold),
        ('cQI-DTX-Timer', _DTX_Information_to_Modify_Items_cQI_DTX_Timer),
        ('uE-DPCCH-burst1', _DTX_Information_to_Modify_Items_uE_DPCCH_burst1),
        ('uE-DPCCH-burst2', _DTX_Information_to_Modify_Items_uE_DPCCH_burst2),
        ('iE-Extensions', _DTX_Information_to_Modify_Items_iE_Extensions),
        ])
    DTX_Information_to_Modify_Items._ext = []
    
    #-----< DTX-Information-to-Modify-Items-ExtIEs >-----#
    DTX_Information_to_Modify_Items_ExtIEs = CLASS(name='DTX-Information-to-Modify-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DTX_Information_to_Modify_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Dual-Band-Capability >-----#
    Dual_Band_Capability = ENUM(name='Dual-Band-Capability', mode=MODE_TYPE)
    Dual_Band_Capability._cont = ASN1Dict([('dual-Band-Capable', 0), ('dual-Band-non-Capable', 1)])
    Dual_Band_Capability._ext = None
    
    #-----< Dual-Band-Capability-Info >-----#
    Dual_Band_Capability_Info = SEQ(name='Dual-Band-Capability-Info', mode=MODE_TYPE)
    _Dual_Band_Capability_Info_dual_Band_Capability = ENUM(name='dual-Band-Capability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Dual-Band-Capability')))
    _Dual_Band_Capability_Info_possible_Secondary_Serving_Cell_List = SEQ_OF(name='possible-Secondary-Serving-Cell-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Possible-Secondary-Serving-Cell-List')), opt=True)
    _Dual_Band_Capability_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Dual_Band_Capability_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Dual_Band_Capability_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Dual_Band_Capability_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Dual_Band_Capability_Info_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Dual-Band-Capability')))
    ____Dual_Band_Capability_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1305), ('criticality', 'ignore'), ('Extension', _____Dual_Band_Capability_Info_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Dual_Band_Capability_Info_iE_Extensions__item__id._const_tab = ____Dual_Band_Capability_Info_iE_Extensions__item__id_tab
    ___Dual_Band_Capability_Info_iE_Extensions__item__id._const_tab_at = None
    ___Dual_Band_Capability_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Dual_Band_Capability_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Dual_Band_Capability_Info_iE_Extensions__item__criticality._const_tab = ____Dual_Band_Capability_Info_iE_Extensions__item__id_tab
    ___Dual_Band_Capability_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Dual_Band_Capability_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Dual_Band_Capability_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Dual_Band_Capability_Info_iE_Extensions__item__extensionValue._const_tab = ____Dual_Band_Capability_Info_iE_Extensions__item__id_tab
    ___Dual_Band_Capability_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Dual_Band_Capability_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Dual_Band_Capability_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Dual_Band_Capability_Info_iE_Extensions__item__id),
        ('criticality', ___Dual_Band_Capability_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Dual_Band_Capability_Info_iE_Extensions__item__extensionValue),
        ])
    __Dual_Band_Capability_Info_iE_Extensions__item_._ext = None
    _Dual_Band_Capability_Info_iE_Extensions._cont = __Dual_Band_Capability_Info_iE_Extensions__item_
    _Dual_Band_Capability_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Dual_Band_Capability_Info._cont = ASN1Dict([
        ('dual-Band-Capability', _Dual_Band_Capability_Info_dual_Band_Capability),
        ('possible-Secondary-Serving-Cell-List', _Dual_Band_Capability_Info_possible_Secondary_Serving_Cell_List),
        ('iE-Extensions', _Dual_Band_Capability_Info_iE_Extensions),
        ])
    Dual_Band_Capability_Info._ext = []
    
    #-----< Dual-Band-Capability-Info-ExtIEs >-----#
    Dual_Band_Capability_Info_ExtIEs = CLASS(name='Dual-Band-Capability-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Dual_Band_Capability_Info_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Dual-Band-Capability')))
    Dual_Band_Capability_Info_ExtIEs._val = ASN1Set(rv=[dict([('id', 1305), ('criticality', 'ignore'), ('Extension', _Dual_Band_Capability_Info_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DwPCH-Power >-----#
    DwPCH_Power = INT(name='DwPCH-Power', mode=MODE_TYPE)
    DwPCH_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-150, ub=400)], ev=[], er=[])
    
    #-----< Improved-Synchronized-Indicator >-----#
    Improved_Synchronized_Indicator = ENUM(name='Improved-Synchronized-Indicator', mode=MODE_TYPE)
    Improved_Synchronized_Indicator._cont = ASN1Dict([('true', 0)])
    Improved_Synchronized_Indicator._ext = None
    
    #-----< E-AGCH-Table-Choice >-----#
    E_AGCH_Table_Choice = ENUM(name='E-AGCH-Table-Choice', mode=MODE_TYPE)
    E_AGCH_Table_Choice._cont = ASN1Dict([('table16B', 0), ('table16B-1', 1)])
    E_AGCH_Table_Choice._ext = []
    
    #-----< E-AGCH-FDD-Code-Information >-----#
    E_AGCH_FDD_Code_Information = CHOICE(name='E-AGCH-FDD-Code-Information', mode=MODE_TYPE)
    _E_AGCH_FDD_Code_Information_replace = SEQ_OF(name='replace', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-FDD-Code-List')))
    _E_AGCH_FDD_Code_Information_remove = NULL(name='remove', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    E_AGCH_FDD_Code_Information._cont = ASN1Dict([
        ('replace', _E_AGCH_FDD_Code_Information_replace),
        ('remove', _E_AGCH_FDD_Code_Information_remove),
        ])
    E_AGCH_FDD_Code_Information._ext = []
    
    #-----< E-AGCH-FDD-Code-List >-----#
    E_AGCH_FDD_Code_List = SEQ_OF(name='E-AGCH-FDD-Code-List', mode=MODE_TYPE)
    _E_AGCH_FDD_Code_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    E_AGCH_FDD_Code_List._cont = _E_AGCH_FDD_Code_List__item_
    E_AGCH_FDD_Code_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-AI-Capability >-----#
    E_AI_Capability = ENUM(name='E-AI-Capability', mode=MODE_TYPE)
    E_AI_Capability._cont = ASN1Dict([('e-AI-capable', 0), ('e-AI-non-capable', 1)])
    E_AI_Capability._ext = None
    
    #-----< E-AI-Indicator >-----#
    E_AI_Indicator = BOOL(name='E-AI-Indicator', mode=MODE_TYPE)
    
    #-----< E-DCH-Capability >-----#
    E_DCH_Capability = ENUM(name='E-DCH-Capability', mode=MODE_TYPE)
    E_DCH_Capability._cont = ASN1Dict([('e-DCH-capable', 0), ('e-DCH-non-capable', 1)])
    E_DCH_Capability._ext = None
    
    #-----< E-DCHCapacityConsumptionLaw >-----#
    E_DCHCapacityConsumptionLaw = SEQ(name='E-DCHCapacityConsumptionLaw', mode=MODE_TYPE)
    _E_DCHCapacityConsumptionLaw_e_DCH_SF_allocation = SEQ_OF(name='e-DCH-SF-allocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-SF-allocation')))
    _E_DCHCapacityConsumptionLaw_dl_Cost_1 = INT(name='dl-Cost-1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _E_DCHCapacityConsumptionLaw_dl_Cost_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _E_DCHCapacityConsumptionLaw_dl_Cost_2 = INT(name='dl-Cost-2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _E_DCHCapacityConsumptionLaw_dl_Cost_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _E_DCHCapacityConsumptionLaw_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCHCapacityConsumptionLaw_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__id._const_tab = ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__id_tab
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__id._const_tab_at = None
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__criticality._const_tab = ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__criticality_tab
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__extensionValue._const_tab = ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__extensionValue_tab
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCHCapacityConsumptionLaw_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__id),
        ('criticality', ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__extensionValue),
        ])
    __E_DCHCapacityConsumptionLaw_iE_Extensions__item_._ext = None
    _E_DCHCapacityConsumptionLaw_iE_Extensions._cont = __E_DCHCapacityConsumptionLaw_iE_Extensions__item_
    _E_DCHCapacityConsumptionLaw_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCHCapacityConsumptionLaw._cont = ASN1Dict([
        ('e-DCH-SF-allocation', _E_DCHCapacityConsumptionLaw_e_DCH_SF_allocation),
        ('dl-Cost-1', _E_DCHCapacityConsumptionLaw_dl_Cost_1),
        ('dl-Cost-2', _E_DCHCapacityConsumptionLaw_dl_Cost_2),
        ('iE-Extensions', _E_DCHCapacityConsumptionLaw_iE_Extensions),
        ])
    E_DCHCapacityConsumptionLaw._ext = []
    
    #-----< E-DCHCapacityConsumptionLaw-ExtIEs >-----#
    E_DCHCapacityConsumptionLaw_ExtIEs = CLASS(name='E-DCHCapacityConsumptionLaw-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCHCapacityConsumptionLaw_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Decoupling-Indication >-----#
    E_DCH_Decoupling_Indication = ENUM(name='E-DCH-Decoupling-Indication', mode=MODE_TYPE)
    E_DCH_Decoupling_Indication._cont = ASN1Dict([('serving-E-DCH-cell-only', 0), ('serving-HS-DSCH-cell-only', 1)])
    E_DCH_Decoupling_Indication._ext = []
    
    #-----< E-DCH-TDD-CapacityConsumptionLaw >-----#
    E_DCH_TDD_CapacityConsumptionLaw = SEQ(name='E-DCH-TDD-CapacityConsumptionLaw', mode=MODE_TYPE)
    _E_DCH_TDD_CapacityConsumptionLaw_ul_Cost = INT(name='ul-Cost', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_DCH_TDD_CapacityConsumptionLaw_ul_Cost._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _E_DCH_TDD_CapacityConsumptionLaw_dl_Cost = INT(name='dl-Cost', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _E_DCH_TDD_CapacityConsumptionLaw_dl_Cost._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__id._const_tab = ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__id_tab
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__criticality._const_tab = ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__criticality_tab
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__extensionValue_tab
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__id),
        ('criticality', ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item_._ext = None
    _E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions._cont = __E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item_
    _E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_TDD_CapacityConsumptionLaw._cont = ASN1Dict([
        ('ul-Cost', _E_DCH_TDD_CapacityConsumptionLaw_ul_Cost),
        ('dl-Cost', _E_DCH_TDD_CapacityConsumptionLaw_dl_Cost),
        ('iE-Extensions', _E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions),
        ])
    E_DCH_TDD_CapacityConsumptionLaw._ext = []
    
    #-----< E-DCH-TDD-CapacityConsumptionLaw-ExtIEs >-----#
    E_DCH_TDD_CapacityConsumptionLaw_ExtIEs = CLASS(name='E-DCH-TDD-CapacityConsumptionLaw-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_TDD_CapacityConsumptionLaw_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-SF-allocation >-----#
    E_DCH_SF_allocation = SEQ_OF(name='E-DCH-SF-allocation', mode=MODE_TYPE)
    _E_DCH_SF_allocation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __E_DCH_SF_allocation__item__ul_Cost_1 = INT(name='ul-Cost-1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __E_DCH_SF_allocation__item__ul_Cost_1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __E_DCH_SF_allocation__item__ul_Cost_2 = INT(name='ul-Cost-2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __E_DCH_SF_allocation__item__ul_Cost_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __E_DCH_SF_allocation__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___E_DCH_SF_allocation__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____E_DCH_SF_allocation__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____E_DCH_SF_allocation__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_SF_allocation__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____E_DCH_SF_allocation__item__iE_Extensions__item__id._const_tab = _____E_DCH_SF_allocation__item__iE_Extensions__item__id_tab
    ____E_DCH_SF_allocation__item__iE_Extensions__item__id._const_tab_at = None
    ____E_DCH_SF_allocation__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____E_DCH_SF_allocation__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____E_DCH_SF_allocation__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_SF_allocation__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____E_DCH_SF_allocation__item__iE_Extensions__item__criticality._const_tab = _____E_DCH_SF_allocation__item__iE_Extensions__item__criticality_tab
    ____E_DCH_SF_allocation__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____E_DCH_SF_allocation__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____E_DCH_SF_allocation__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____E_DCH_SF_allocation__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_SF_allocation__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____E_DCH_SF_allocation__item__iE_Extensions__item__extensionValue._const_tab = _____E_DCH_SF_allocation__item__iE_Extensions__item__extensionValue_tab
    ____E_DCH_SF_allocation__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____E_DCH_SF_allocation__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___E_DCH_SF_allocation__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____E_DCH_SF_allocation__item__iE_Extensions__item__id),
        ('criticality', ____E_DCH_SF_allocation__item__iE_Extensions__item__criticality),
        ('extensionValue', ____E_DCH_SF_allocation__item__iE_Extensions__item__extensionValue),
        ])
    ___E_DCH_SF_allocation__item__iE_Extensions__item_._ext = None
    __E_DCH_SF_allocation__item__iE_Extensions._cont = ___E_DCH_SF_allocation__item__iE_Extensions__item_
    __E_DCH_SF_allocation__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _E_DCH_SF_allocation__item_._cont = ASN1Dict([
        ('ul-Cost-1', __E_DCH_SF_allocation__item__ul_Cost_1),
        ('ul-Cost-2', __E_DCH_SF_allocation__item__ul_Cost_2),
        ('iE-Extensions', __E_DCH_SF_allocation__item__iE_Extensions),
        ])
    _E_DCH_SF_allocation__item_._ext = []
    E_DCH_SF_allocation._cont = _E_DCH_SF_allocation__item_
    E_DCH_SF_allocation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< E-DCH-SF-allocation-ExtIEs >-----#
    E_DCH_SF_allocation_ExtIEs = CLASS(name='E-DCH-SF-allocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_SF_allocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TTI2ms-Capability >-----#
    E_DCH_TTI2ms_Capability = BOOL(name='E-DCH-TTI2ms-Capability', mode=MODE_TYPE)
    
    #-----< E-DCH-SF-Capability >-----#
    E_DCH_SF_Capability = ENUM(name='E-DCH-SF-Capability', mode=MODE_TYPE)
    E_DCH_SF_Capability._cont = ASN1Dict([('sf64', 0), ('sf32', 1), ('sf16', 2), ('sf8', 3), ('sf4', 4), ('sf4x2', 5), ('sf2x2', 6), ('sf4x2-and-sf2x2', 7)])
    E_DCH_SF_Capability._ext = []
    
    #-----< E-DCH-HARQ-Combining-Capability >-----#
    E_DCH_HARQ_Combining_Capability = ENUM(name='E-DCH-HARQ-Combining-Capability', mode=MODE_TYPE)
    E_DCH_HARQ_Combining_Capability._cont = ASN1Dict([('iR-Combining-capable', 0), ('chase-Combining-capable', 1), ('iR-and-Chase-Combining-capable', 2)])
    E_DCH_HARQ_Combining_Capability._ext = None
    
    #-----< E-DCH-DDI-Value >-----#
    E_DCH_DDI_Value = INT(name='E-DCH-DDI-Value', mode=MODE_TYPE)
    E_DCH_DDI_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=62)], ev=None, er=[])
    
    #-----< E-DCH-FDD-DL-Control-Channel-Information >-----#
    E_DCH_FDD_DL_Control_Channel_Information = SEQ(name='E-DCH-FDD-DL-Control-Channel-Information', mode=MODE_TYPE)
    _E_DCH_FDD_DL_Control_Channel_Information_e_AGCH_And_E_RGCH_E_HICH_FDD_Scrambling_Code = INT(name='e-AGCH-And-E-RGCH-E-HICH-FDD-Scrambling-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-ScramblingCode')), opt=True)
    _E_DCH_FDD_DL_Control_Channel_Information_e_AGCH_Channelisation_Code = INT(name='e-AGCH-Channelisation-Code', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')), opt=True)
    _E_DCH_FDD_DL_Control_Channel_Information_primary_e_RNTI = INT(name='primary-e-RNTI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')), opt=True)
    _E_DCH_FDD_DL_Control_Channel_Information_secondary_e_RNTI = INT(name='secondary-e-RNTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')), opt=True)
    _E_DCH_FDD_DL_Control_Channel_Information_e_RGCH_E_HICH_Channelisation_Code = INT(name='e-RGCH-E-HICH-Channelisation-Code', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')), opt=True)
    _E_DCH_FDD_DL_Control_Channel_Information_e_RGCH_Signature_Sequence = INT(name='e-RGCH-Signature-Sequence', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-Signature-Sequence')), opt=True)
    _E_DCH_FDD_DL_Control_Channel_Information_e_HICH_Signature_Sequence = INT(name='e-HICH-Signature-Sequence', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-Signature-Sequence')), opt=True)
    _E_DCH_FDD_DL_Control_Channel_Information_serving_Grant_Value = INT(name='serving-Grant-Value', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-Serving-Grant-Value')), opt=True)
    _E_DCH_FDD_DL_Control_Channel_Information_primary_Secondary_Grant_Selector = ENUM(name='primary-Secondary-Grant-Selector', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-Primary-Secondary-Grant-Selector')), opt=True)
    _E_DCH_FDD_DL_Control_Channel_Information_e_RGCH_Release_Indicator = ENUM(name='e-RGCH-Release-Indicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-Release-Indicator')), opt=True)
    _E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-Serving-Grant-Value')))
    _____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-MIMO-DL-Control-Channel-Information')))
    ____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 949), ('criticality', 'ignore'), ('Extension', _____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1233), ('criticality', 'ignore'), ('Extension', _____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id._const_tab = ____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id),
        ('criticality', ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item_._ext = None
    _E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions._cont = __E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item_
    _E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_FDD_DL_Control_Channel_Information._cont = ASN1Dict([
        ('e-AGCH-And-E-RGCH-E-HICH-FDD-Scrambling-Code', _E_DCH_FDD_DL_Control_Channel_Information_e_AGCH_And_E_RGCH_E_HICH_FDD_Scrambling_Code),
        ('e-AGCH-Channelisation-Code', _E_DCH_FDD_DL_Control_Channel_Information_e_AGCH_Channelisation_Code),
        ('primary-e-RNTI', _E_DCH_FDD_DL_Control_Channel_Information_primary_e_RNTI),
        ('secondary-e-RNTI', _E_DCH_FDD_DL_Control_Channel_Information_secondary_e_RNTI),
        ('e-RGCH-E-HICH-Channelisation-Code', _E_DCH_FDD_DL_Control_Channel_Information_e_RGCH_E_HICH_Channelisation_Code),
        ('e-RGCH-Signature-Sequence', _E_DCH_FDD_DL_Control_Channel_Information_e_RGCH_Signature_Sequence),
        ('e-HICH-Signature-Sequence', _E_DCH_FDD_DL_Control_Channel_Information_e_HICH_Signature_Sequence),
        ('serving-Grant-Value', _E_DCH_FDD_DL_Control_Channel_Information_serving_Grant_Value),
        ('primary-Secondary-Grant-Selector', _E_DCH_FDD_DL_Control_Channel_Information_primary_Secondary_Grant_Selector),
        ('e-RGCH-Release-Indicator', _E_DCH_FDD_DL_Control_Channel_Information_e_RGCH_Release_Indicator),
        ('iE-Extensions', _E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions),
        ])
    E_DCH_FDD_DL_Control_Channel_Information._ext = []
    
    #-----< E-DCH-FDD-DL-Control-Channel-Information-ExtIEs >-----#
    E_DCH_FDD_DL_Control_Channel_Information_ExtIEs = CLASS(name='E-DCH-FDD-DL-Control-Channel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_FDD_DL_Control_Channel_Information_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-Serving-Grant-Value')))
    _E_DCH_FDD_DL_Control_Channel_Information_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-MIMO-DL-Control-Channel-Information')))
    E_DCH_FDD_DL_Control_Channel_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 949), ('criticality', 'ignore'), ('Extension', _E_DCH_FDD_DL_Control_Channel_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1233), ('criticality', 'ignore'), ('Extension', _E_DCH_FDD_DL_Control_Channel_Information_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-FDD-Information >-----#
    E_DCH_FDD_Information = SEQ(name='E-DCH-FDD-Information', mode=MODE_TYPE)
    _E_DCH_FDD_Information_e_DCH_MACdFlows_Information = SEQ(name='e-DCH-MACdFlows-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-Information')))
    _E_DCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name='hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _E_DCH_FDD_Information_e_DCH_Maximum_Bitrate = INT(name='e-DCH-Maximum-Bitrate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Maximum-Bitrate')), opt=True)
    _E_DCH_FDD_Information_e_DCH_Processing_Overload_Level = INT(name='e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _E_DCH_FDD_Information_e_DCH_Reference_Power_Offset = INT(name='e-DCH-Reference-Power-Offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Reference-Power-Offset')), opt=True)
    _E_DCH_FDD_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_FDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_FDD_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_FDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')))
    _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Table-Choice')))
    _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-MIMO-Information')))
    _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UPH-Filtering-Measurement-Forwarding-Request')))
    ____E_DCH_FDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 782), ('criticality', 'ignore'), ('Extension', _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 946), ('criticality', 'reject'), ('Extension', _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 978), ('criticality', 'ignore'), ('Extension', _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'conditional')]), dict([('id', 1234), ('criticality', 'reject'), ('Extension', _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1231), ('criticality', 'reject'), ('Extension', _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1278), ('criticality', 'reject'), ('Extension', _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_FDD_Information_iE_Extensions__item__id._const_tab = ____E_DCH_FDD_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_FDD_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_FDD_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_FDD_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_FDD_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_FDD_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_FDD_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_FDD_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_FDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_FDD_Information_iE_Extensions__item__id),
        ('criticality', ___E_DCH_FDD_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_FDD_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_FDD_Information_iE_Extensions__item_._ext = None
    _E_DCH_FDD_Information_iE_Extensions._cont = __E_DCH_FDD_Information_iE_Extensions__item_
    _E_DCH_FDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_FDD_Information._cont = ASN1Dict([
        ('e-DCH-MACdFlows-Information', _E_DCH_FDD_Information_e_DCH_MACdFlows_Information),
        ('hARQ-Process-Allocation-Scheduled-2ms-EDCH', _E_DCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        ('e-DCH-Maximum-Bitrate', _E_DCH_FDD_Information_e_DCH_Maximum_Bitrate),
        ('e-DCH-Processing-Overload-Level', _E_DCH_FDD_Information_e_DCH_Processing_Overload_Level),
        ('e-DCH-Reference-Power-Offset', _E_DCH_FDD_Information_e_DCH_Reference_Power_Offset),
        ('iE-Extensions', _E_DCH_FDD_Information_iE_Extensions),
        ])
    E_DCH_FDD_Information._ext = []
    
    #-----< E-DCH-FDD-Information-ExtIEs >-----#
    E_DCH_FDD_Information_ExtIEs = CLASS(name='E-DCH-FDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_FDD_Information_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')))
    _E_DCH_FDD_Information_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _E_DCH_FDD_Information_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Table-Choice')))
    _E_DCH_FDD_Information_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    _E_DCH_FDD_Information_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-MIMO-Information')))
    _E_DCH_FDD_Information_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UPH-Filtering-Measurement-Forwarding-Request')))
    E_DCH_FDD_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 782), ('criticality', 'ignore'), ('Extension', _E_DCH_FDD_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 946), ('criticality', 'reject'), ('Extension', _E_DCH_FDD_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 978), ('criticality', 'ignore'), ('Extension', _E_DCH_FDD_Information_ExtIEs_val_Extension_2), ('presence', 'conditional')]), dict([('id', 1234), ('criticality', 'reject'), ('Extension', _E_DCH_FDD_Information_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1231), ('criticality', 'reject'), ('Extension', _E_DCH_FDD_Information_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1278), ('criticality', 'reject'), ('Extension', _E_DCH_FDD_Information_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UPH-Filtering-Measurement-Forwarding-Request >-----#
    UPH_Filtering_Measurement_Forwarding_Request = ENUM(name='UPH-Filtering-Measurement-Forwarding-Request', mode=MODE_TYPE)
    UPH_Filtering_Measurement_Forwarding_Request._cont = ASN1Dict([('requested', 0), ('notRequested', 1)])
    UPH_Filtering_Measurement_Forwarding_Request._ext = None
    
    #-----< E-DCH-FDD-Information-Response >-----#
    E_DCH_FDD_Information_Response = SEQ(name='E-DCH-FDD-Information-Response', mode=MODE_TYPE)
    _E_DCH_FDD_Information_Response_e_DCH_MACdFlow_Specific_InformationResp = SEQ_OF(name='e-DCH-MACdFlow-Specific-InformationResp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Specific-InformationResp')), opt=True)
    _E_DCH_FDD_Information_Response_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name='hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _E_DCH_FDD_Information_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_FDD_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_FDD_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-TTI-switching-Mode-Supported')))
    ____E_DCH_FDD_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1304), ('criticality', 'ignore'), ('Extension', _____E_DCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__id._const_tab = ____E_DCH_FDD_Information_Response_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__criticality._const_tab = ____E_DCH_FDD_Information_Response_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_FDD_Information_Response_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_FDD_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_FDD_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_FDD_Information_Response_iE_Extensions__item__id),
        ('criticality', ___E_DCH_FDD_Information_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_FDD_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_FDD_Information_Response_iE_Extensions__item_._ext = None
    _E_DCH_FDD_Information_Response_iE_Extensions._cont = __E_DCH_FDD_Information_Response_iE_Extensions__item_
    _E_DCH_FDD_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_FDD_Information_Response._cont = ASN1Dict([
        ('e-DCH-MACdFlow-Specific-InformationResp', _E_DCH_FDD_Information_Response_e_DCH_MACdFlow_Specific_InformationResp),
        ('hARQ-Process-Allocation-Scheduled-2ms-EDCH', _E_DCH_FDD_Information_Response_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        ('iE-Extensions', _E_DCH_FDD_Information_Response_iE_Extensions),
        ])
    E_DCH_FDD_Information_Response._ext = []
    
    #-----< E-DCH-FDD-Information-Response-ExtIEs >-----#
    E_DCH_FDD_Information_Response_ExtIEs = CLASS(name='E-DCH-FDD-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_FDD_Information_Response_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-TTI-switching-Mode-Supported')))
    E_DCH_FDD_Information_Response_ExtIEs._val = ASN1Set(rv=[dict([('id', 1304), ('criticality', 'ignore'), ('Extension', _E_DCH_FDD_Information_Response_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-FDD-Information-to-Modify >-----#
    E_DCH_FDD_Information_to_Modify = SEQ(name='E-DCH-FDD-Information-to-Modify', mode=MODE_TYPE)
    _E_DCH_FDD_Information_to_Modify_e_DCH_MACdFlow_Specific_Info_to_Modify = SEQ_OF(name='e-DCH-MACdFlow-Specific-Info-to-Modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Specific-InfoList-to-Modify')), opt=True)
    _E_DCH_FDD_Information_to_Modify_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name='hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _E_DCH_FDD_Information_to_Modify_e_DCH_Maximum_Bitrate = INT(name='e-DCH-Maximum-Bitrate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Maximum-Bitrate')), opt=True)
    _E_DCH_FDD_Information_to_Modify_e_DCH_Processing_Overload_Level = INT(name='e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _E_DCH_FDD_Information_to_Modify_e_DCH_Reference_Power_Offset = INT(name='e-DCH-Reference-Power-Offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Reference-Power-Offset')), opt=True)
    _E_DCH_FDD_Information_to_Modify_mACeReset_Indicator = ENUM(name='mACeReset-Indicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MACeReset-Indicator')), opt=True)
    _E_DCH_FDD_Information_to_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_FDD_Information_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')))
    _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDUSizeFormat')))
    _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-DL-Control-Channel-Grant-Information')))
    _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Table-Choice')))
    _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_6 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-MIMO-Reconfiguration')))
    _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_7 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-TTI-switching-Mode-synchronized')))
    _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_8 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-TTI-switching-Mode-unsynchronized')))
    ____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 782), ('criticality', 'ignore'), ('Extension', _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 946), ('criticality', 'reject'), ('Extension', _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 960), ('criticality', 'reject'), ('Extension', _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 968), ('criticality', 'ignore'), ('Extension', _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 978), ('criticality', 'ignore'), ('Extension', _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'conditional')]), dict([('id', 1234), ('criticality', 'reject'), ('Extension', _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1232), ('criticality', 'reject'), ('Extension', _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1302), ('criticality', 'reject'), ('Extension', _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1303), ('criticality', 'reject'), ('Extension', _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id._const_tab = ____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__criticality._const_tab = ____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_FDD_Information_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id),
        ('criticality', ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_FDD_Information_to_Modify_iE_Extensions__item_._ext = None
    _E_DCH_FDD_Information_to_Modify_iE_Extensions._cont = __E_DCH_FDD_Information_to_Modify_iE_Extensions__item_
    _E_DCH_FDD_Information_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_FDD_Information_to_Modify._cont = ASN1Dict([
        ('e-DCH-MACdFlow-Specific-Info-to-Modify', _E_DCH_FDD_Information_to_Modify_e_DCH_MACdFlow_Specific_Info_to_Modify),
        ('hARQ-Process-Allocation-Scheduled-2ms-EDCH', _E_DCH_FDD_Information_to_Modify_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        ('e-DCH-Maximum-Bitrate', _E_DCH_FDD_Information_to_Modify_e_DCH_Maximum_Bitrate),
        ('e-DCH-Processing-Overload-Level', _E_DCH_FDD_Information_to_Modify_e_DCH_Processing_Overload_Level),
        ('e-DCH-Reference-Power-Offset', _E_DCH_FDD_Information_to_Modify_e_DCH_Reference_Power_Offset),
        ('mACeReset-Indicator', _E_DCH_FDD_Information_to_Modify_mACeReset_Indicator),
        ('iE-Extensions', _E_DCH_FDD_Information_to_Modify_iE_Extensions),
        ])
    E_DCH_FDD_Information_to_Modify._ext = []
    
    #-----< E-DCH-FDD-Information-to-Modify-ExtIEs >-----#
    E_DCH_FDD_Information_to_Modify_ExtIEs = CLASS(name='E-DCH-FDD-Information-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')))
    _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDUSizeFormat')))
    _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-DL-Control-Channel-Grant-Information')))
    _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Table-Choice')))
    _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_6 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-MIMO-Reconfiguration')))
    _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_7 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-TTI-switching-Mode-synchronized')))
    _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_8 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-TTI-switching-Mode-unsynchronized')))
    E_DCH_FDD_Information_to_Modify_ExtIEs._val = ASN1Set(rv=[dict([('id', 782), ('criticality', 'ignore'), ('Extension', _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 946), ('criticality', 'reject'), ('Extension', _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 960), ('criticality', 'reject'), ('Extension', _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 968), ('criticality', 'ignore'), ('Extension', _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 978), ('criticality', 'ignore'), ('Extension', _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_4), ('presence', 'conditional')]), dict([('id', 1234), ('criticality', 'reject'), ('Extension', _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 1232), ('criticality', 'reject'), ('Extension', _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 1302), ('criticality', 'reject'), ('Extension', _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 1303), ('criticality', 'reject'), ('Extension', _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-FDD-Update-Information >-----#
    E_DCH_FDD_Update_Information = SEQ(name='E-DCH-FDD-Update-Information', mode=MODE_TYPE)
    _E_DCH_FDD_Update_Information_e_DCH_MACdFlow_Specific_UpdateInformation = SEQ_OF(name='e-DCH-MACdFlow-Specific-UpdateInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Specific-UpdateInformation')), opt=True)
    _E_DCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name='hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _E_DCH_FDD_Update_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_FDD_Update_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-DL-Control-Channel-Change-Information')))
    _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TTI-Update-Indicator')))
    ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 967), ('criticality', 'ignore'), ('Extension', _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1279), ('criticality', 'ignore'), ('Extension', _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__id._const_tab = ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_FDD_Update_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_FDD_Update_Information_iE_Extensions__item__id),
        ('criticality', ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_FDD_Update_Information_iE_Extensions__item_._ext = None
    _E_DCH_FDD_Update_Information_iE_Extensions._cont = __E_DCH_FDD_Update_Information_iE_Extensions__item_
    _E_DCH_FDD_Update_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_FDD_Update_Information._cont = ASN1Dict([
        ('e-DCH-MACdFlow-Specific-UpdateInformation', _E_DCH_FDD_Update_Information_e_DCH_MACdFlow_Specific_UpdateInformation),
        ('hARQ-Process-Allocation-Scheduled-2ms-EDCH', _E_DCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        ('iE-Extensions', _E_DCH_FDD_Update_Information_iE_Extensions),
        ])
    E_DCH_FDD_Update_Information._ext = []
    
    #-----< E-DCH-FDD-Update-Information-ExtIEs >-----#
    E_DCH_FDD_Update_Information_ExtIEs = CLASS(name='E-DCH-FDD-Update-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-DL-Control-Channel-Change-Information')))
    _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TTI-Update-Indicator')))
    E_DCH_FDD_Update_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 967), ('criticality', 'ignore'), ('Extension', _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1279), ('criticality', 'ignore'), ('Extension', _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TTI-Update-Indicator >-----#
    TTI_Update_Indicator = CHOICE(name='TTI-Update-Indicator', mode=MODE_TYPE)
    _TTI_Update_Indicator_tTI_Update_CFN = INT(name='tTI-Update-CFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    _TTI_Update_Indicator_tTI_Update_Ind = NULL(name='tTI-Update-Ind', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TTI-Update-Ind')))
    TTI_Update_Indicator._cont = ASN1Dict([
        ('tTI-Update-CFN', _TTI_Update_Indicator_tTI_Update_CFN),
        ('tTI-Update-Ind', _TTI_Update_Indicator_tTI_Update_Ind),
        ])
    TTI_Update_Indicator._ext = None
    
    #-----< TTI-Update-Ind >-----#
    TTI_Update_Ind = NULL(name='TTI-Update-Ind', mode=MODE_TYPE)
    
    #-----< E-DCH-MACdFlow-Specific-UpdateInformation >-----#
    E_DCH_MACdFlow_Specific_UpdateInformation = SEQ_OF(name='E-DCH-MACdFlow-Specific-UpdateInformation', mode=MODE_TYPE)
    _E_DCH_MACdFlow_Specific_UpdateInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Specific-UpdateInformation-Item')))
    E_DCH_MACdFlow_Specific_UpdateInformation._cont = _E_DCH_MACdFlow_Specific_UpdateInformation__item_
    E_DCH_MACdFlow_Specific_UpdateInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-Specific-UpdateInformation-Item >-----#
    E_DCH_MACdFlow_Specific_UpdateInformation_Item = SEQ(name='E-DCH-MACdFlow-Specific-UpdateInformation-Item', mode=MODE_TYPE)
    _E_DCH_MACdFlow_Specific_UpdateInformation_Item_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _E_DCH_MACdFlow_Specific_UpdateInformation_Item_hARQ_Process_Allocation_NonSched_2ms_EDCH = BIT_STR(name='hARQ-Process-Allocation-NonSched-2ms-EDCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality_tab
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id),
        ('criticality', ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions._cont = __E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item_
    _E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlow_Specific_UpdateInformation_Item._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _E_DCH_MACdFlow_Specific_UpdateInformation_Item_e_DCH_MACdFlow_ID),
        ('hARQ-Process-Allocation-NonSched-2ms-EDCH', _E_DCH_MACdFlow_Specific_UpdateInformation_Item_hARQ_Process_Allocation_NonSched_2ms_EDCH),
        ('iE-Extensions', _E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions),
        ])
    E_DCH_MACdFlow_Specific_UpdateInformation_Item._ext = []
    
    #-----< E-DCH-MACdFlow-Specific-UpdateInformation-Item-ExtIEs >-----#
    E_DCH_MACdFlow_Specific_UpdateInformation_Item_ExtIEs = CLASS(name='E-DCH-MACdFlow-Specific-UpdateInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_MACdFlow_Specific_UpdateInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-DL-Control-Channel-Change-Information >-----#
    E_DCH_DL_Control_Channel_Change_Information = SEQ_OF(name='E-DCH-DL-Control-Channel-Change-Information', mode=MODE_TYPE)
    _E_DCH_DL_Control_Channel_Change_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-DL-Control-Channel-Change-Information-Item')))
    E_DCH_DL_Control_Channel_Change_Information._cont = _E_DCH_DL_Control_Channel_Change_Information__item_
    E_DCH_DL_Control_Channel_Change_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< E-DCH-DL-Control-Channel-Change-Information-Item >-----#
    E_DCH_DL_Control_Channel_Change_Information_Item = SEQ(name='E-DCH-DL-Control-Channel-Change-Information-Item', mode=MODE_TYPE)
    _E_DCH_DL_Control_Channel_Change_Information_Item_e_DCH_RL_ID = INT(name='e-DCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id._const_tab = ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id_tab
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality_tab
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id),
        ('criticality', ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item_._ext = None
    _E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions._cont = __E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item_
    _E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_DL_Control_Channel_Change_Information_Item._cont = ASN1Dict([
        ('e-DCH-RL-ID', _E_DCH_DL_Control_Channel_Change_Information_Item_e_DCH_RL_ID),
        ('iE-Extensions', _E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions),
        ])
    E_DCH_DL_Control_Channel_Change_Information_Item._ext = []
    
    #-----< E-DCH-DL-Control-Channel-Change-Information-Item-ExtIEs >-----#
    E_DCH_DL_Control_Channel_Change_Information_Item_ExtIEs = CLASS(name='E-DCH-DL-Control-Channel-Change-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_DL_Control_Channel_Change_Information_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-DL-Control-Channel-Grant-Information >-----#
    E_DCH_DL_Control_Channel_Grant_Information = SEQ_OF(name='E-DCH-DL-Control-Channel-Grant-Information', mode=MODE_TYPE)
    _E_DCH_DL_Control_Channel_Grant_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-DL-Control-Channel-Grant-Information-Item')))
    E_DCH_DL_Control_Channel_Grant_Information._cont = _E_DCH_DL_Control_Channel_Grant_Information__item_
    E_DCH_DL_Control_Channel_Grant_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< E-DCH-DL-Control-Channel-Grant-Information-Item >-----#
    E_DCH_DL_Control_Channel_Grant_Information_Item = SEQ(name='E-DCH-DL-Control-Channel-Grant-Information-Item', mode=MODE_TYPE)
    _E_DCH_DL_Control_Channel_Grant_Information_Item_e_DCH_RL_ID = INT(name='e-DCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id._const_tab = ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id_tab
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality_tab
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id),
        ('criticality', ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item_._ext = None
    _E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions._cont = __E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item_
    _E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_DL_Control_Channel_Grant_Information_Item._cont = ASN1Dict([
        ('e-DCH-RL-ID', _E_DCH_DL_Control_Channel_Grant_Information_Item_e_DCH_RL_ID),
        ('iE-Extensions', _E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions),
        ])
    E_DCH_DL_Control_Channel_Grant_Information_Item._ext = []
    
    #-----< E-DCH-DL-Control-Channel-Grant-Information-Item-ExtIEs >-----#
    E_DCH_DL_Control_Channel_Grant_Information_Item_ExtIEs = CLASS(name='E-DCH-DL-Control-Channel-Grant-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_DL_Control_Channel_Grant_Information_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Grant-Type-Information >-----#
    E_DCH_Grant_Type_Information = CHOICE(name='E-DCH-Grant-Type-Information', mode=MODE_TYPE)
    _E_DCH_Grant_Type_Information_e_DCH_Non_Scheduled_Transmission_Grant = SEQ(name='e-DCH-Non-Scheduled-Transmission-Grant', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Non-Scheduled-Transmission-Grant-Items')))
    _E_DCH_Grant_Type_Information_e_DCH_Scheduled_Transmission_Grant = NULL(name='e-DCH-Scheduled-Transmission-Grant', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    E_DCH_Grant_Type_Information._cont = ASN1Dict([
        ('e-DCH-Non-Scheduled-Transmission-Grant', _E_DCH_Grant_Type_Information_e_DCH_Non_Scheduled_Transmission_Grant),
        ('e-DCH-Scheduled-Transmission-Grant', _E_DCH_Grant_Type_Information_e_DCH_Scheduled_Transmission_Grant),
        ])
    E_DCH_Grant_Type_Information._ext = []
    
    #-----< E-DCH-LogicalChannelInformation >-----#
    E_DCH_LogicalChannelInformation = SEQ_OF(name='E-DCH-LogicalChannelInformation', mode=MODE_TYPE)
    _E_DCH_LogicalChannelInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LogicalChannelInformationItem')))
    E_DCH_LogicalChannelInformation._cont = _E_DCH_LogicalChannelInformation__item_
    E_DCH_LogicalChannelInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< E-DCH-LogicalChannelInformationItem >-----#
    E_DCH_LogicalChannelInformationItem = SEQ(name='E-DCH-LogicalChannelInformationItem', mode=MODE_TYPE)
    _E_DCH_LogicalChannelInformationItem_logicalChannelId = INT(name='logicalChannelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LogicalChannelID')))
    _E_DCH_LogicalChannelInformationItem_schedulingPriorityIndicator = INT(name='schedulingPriorityIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')))
    _E_DCH_LogicalChannelInformationItem_schedulingInformation = ENUM(name='schedulingInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingInformation')))
    _E_DCH_LogicalChannelInformationItem_mACesGuaranteedBitRate = INT(name='mACesGuaranteedBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MACesGuaranteedBitRate')), opt=True)
    _E_DCH_LogicalChannelInformationItem_e_DCH_DDI_Value = INT(name='e-DCH-DDI-Value', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-DDI-Value')))
    _E_DCH_LogicalChannelInformationItem_mACd_PDU_Size_List = SEQ_OF(name='mACd-PDU-Size-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDU-SizeList')))
    _E_DCH_LogicalChannelInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LogicalChannelInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MACes-Maximum-Bitrate-LCR')))
    _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_2 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate-Enforcement-Indicator')))
    ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'reject'), ('Extension', _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1046), ('criticality', 'ignore'), ('Extension', _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1093), ('criticality', 'ignore'), ('Extension', _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id._const_tab = ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_LogicalChannelInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id),
        ('criticality', ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LogicalChannelInformationItem_iE_Extensions__item_._ext = None
    _E_DCH_LogicalChannelInformationItem_iE_Extensions._cont = __E_DCH_LogicalChannelInformationItem_iE_Extensions__item_
    _E_DCH_LogicalChannelInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LogicalChannelInformationItem._cont = ASN1Dict([
        ('logicalChannelId', _E_DCH_LogicalChannelInformationItem_logicalChannelId),
        ('schedulingPriorityIndicator', _E_DCH_LogicalChannelInformationItem_schedulingPriorityIndicator),
        ('schedulingInformation', _E_DCH_LogicalChannelInformationItem_schedulingInformation),
        ('mACesGuaranteedBitRate', _E_DCH_LogicalChannelInformationItem_mACesGuaranteedBitRate),
        ('e-DCH-DDI-Value', _E_DCH_LogicalChannelInformationItem_e_DCH_DDI_Value),
        ('mACd-PDU-Size-List', _E_DCH_LogicalChannelInformationItem_mACd_PDU_Size_List),
        ('iE-Extensions', _E_DCH_LogicalChannelInformationItem_iE_Extensions),
        ])
    E_DCH_LogicalChannelInformationItem._ext = []
    
    #-----< E-DCH-LogicalChannelInformationItem-ExtIEs >-----#
    E_DCH_LogicalChannelInformationItem_ExtIEs = CLASS(name='E-DCH-LogicalChannelInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MACes-Maximum-Bitrate-LCR')))
    _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_2 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate-Enforcement-Indicator')))
    E_DCH_LogicalChannelInformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'reject'), ('Extension', _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1046), ('criticality', 'ignore'), ('Extension', _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1093), ('criticality', 'ignore'), ('Extension', _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Maximum-Bitrate >-----#
    E_DCH_Maximum_Bitrate = INT(name='E-DCH-Maximum-Bitrate', mode=MODE_TYPE)
    E_DCH_Maximum_Bitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5742)], ev=[], er=[ASN1RangeInt(lb=5743, ub=11498), ASN1RangeInt(lb=11499, ub=34507)])
    
    #-----< E-DCH-PowerOffset-for-SchedulingInfo >-----#
    E_DCH_PowerOffset_for_SchedulingInfo = INT(name='E-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_TYPE)
    E_DCH_PowerOffset_for_SchedulingInfo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< E-DCH-Processing-Overload-Level >-----#
    E_DCH_Processing_Overload_Level = INT(name='E-DCH-Processing-Overload-Level', mode=MODE_TYPE)
    E_DCH_Processing_Overload_Level._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=[], er=[])
    
    #-----< E-DCH-Reference-Power-Offset >-----#
    E_DCH_Reference_Power_Offset = INT(name='E-DCH-Reference-Power-Offset', mode=MODE_TYPE)
    E_DCH_Reference_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< E-DCH-MACdPDU-SizeList >-----#
    E_DCH_MACdPDU_SizeList = SEQ_OF(name='E-DCH-MACdPDU-SizeList', mode=MODE_TYPE)
    _E_DCH_MACdPDU_SizeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDU-SizeListItem')))
    E_DCH_MACdPDU_SizeList._cont = _E_DCH_MACdPDU_SizeList__item_
    E_DCH_MACdPDU_SizeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-DCH-MACdPDU-SizeListItem >-----#
    E_DCH_MACdPDU_SizeListItem = SEQ(name='E-DCH-MACdPDU-SizeListItem', mode=MODE_TYPE)
    _E_DCH_MACdPDU_SizeListItem_mACdPDU_Size = INT(name='mACdPDU-Size', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MACdPDU-Size')))
    _E_DCH_MACdPDU_SizeListItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdPDU_SizeListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id._const_tab = ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality_tab
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue_tab
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_MACdPDU_SizeListItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id),
        ('criticality', ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdPDU_SizeListItem_iE_Extensions__item_._ext = None
    _E_DCH_MACdPDU_SizeListItem_iE_Extensions._cont = __E_DCH_MACdPDU_SizeListItem_iE_Extensions__item_
    _E_DCH_MACdPDU_SizeListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdPDU_SizeListItem._cont = ASN1Dict([
        ('mACdPDU-Size', _E_DCH_MACdPDU_SizeListItem_mACdPDU_Size),
        ('iE-Extensions', _E_DCH_MACdPDU_SizeListItem_iE_Extensions),
        ])
    E_DCH_MACdPDU_SizeListItem._ext = []
    
    #-----< E-DCH-MACdPDU-SizeListItem-ExtIEs >-----#
    E_DCH_MACdPDU_SizeListItem_ExtIEs = CLASS(name='E-DCH-MACdPDU-SizeListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_MACdPDU_SizeListItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-MACdPDU-SizeCapability >-----#
    E_DCH_MACdPDU_SizeCapability = ENUM(name='E-DCH-MACdPDU-SizeCapability', mode=MODE_TYPE)
    E_DCH_MACdPDU_SizeCapability._cont = ASN1Dict([('fixedSizeCapable', 0), ('flexibleSizeCapable', 1)])
    E_DCH_MACdPDU_SizeCapability._ext = None
    
    #-----< E-DCH-MACdPDUSizeFormat >-----#
    E_DCH_MACdPDUSizeFormat = ENUM(name='E-DCH-MACdPDUSizeFormat', mode=MODE_TYPE)
    E_DCH_MACdPDUSizeFormat._cont = ASN1Dict([('fixedMACdPDU-Size', 0), ('flexibleMACdPDU-Size', 1)])
    E_DCH_MACdPDUSizeFormat._ext = None
    
    #-----< E-DCH-LogicalChannelToModify >-----#
    E_DCH_LogicalChannelToModify = SEQ_OF(name='E-DCH-LogicalChannelToModify', mode=MODE_TYPE)
    _E_DCH_LogicalChannelToModify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LogicalChannelToModifyItem')))
    E_DCH_LogicalChannelToModify._cont = _E_DCH_LogicalChannelToModify__item_
    E_DCH_LogicalChannelToModify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< E-DCH-LogicalChannelToModifyItem >-----#
    E_DCH_LogicalChannelToModifyItem = SEQ(name='E-DCH-LogicalChannelToModifyItem', mode=MODE_TYPE)
    _E_DCH_LogicalChannelToModifyItem_logicalChannelId = INT(name='logicalChannelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LogicalChannelID')))
    _E_DCH_LogicalChannelToModifyItem_schedulingPriorityIndicator = INT(name='schedulingPriorityIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')), opt=True)
    _E_DCH_LogicalChannelToModifyItem_schedulingInformation = ENUM(name='schedulingInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingInformation')), opt=True)
    _E_DCH_LogicalChannelToModifyItem_mACesGuaranteedBitRate = INT(name='mACesGuaranteedBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MACesGuaranteedBitRate')), opt=True)
    _E_DCH_LogicalChannelToModifyItem_e_DCH_DDI_Value = INT(name='e-DCH-DDI-Value', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-DDI-Value')), opt=True)
    _E_DCH_LogicalChannelToModifyItem_mACd_PDU_Size_List = SEQ_OF(name='mACd-PDU-Size-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDU-SizeToModifyList')))
    _E_DCH_LogicalChannelToModifyItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LogicalChannelToModifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MACes-Maximum-Bitrate-LCR')))
    ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'reject'), ('Extension', _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1046), ('criticality', 'ignore'), ('Extension', _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id._const_tab = ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_LogicalChannelToModifyItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id),
        ('criticality', ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LogicalChannelToModifyItem_iE_Extensions__item_._ext = None
    _E_DCH_LogicalChannelToModifyItem_iE_Extensions._cont = __E_DCH_LogicalChannelToModifyItem_iE_Extensions__item_
    _E_DCH_LogicalChannelToModifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LogicalChannelToModifyItem._cont = ASN1Dict([
        ('logicalChannelId', _E_DCH_LogicalChannelToModifyItem_logicalChannelId),
        ('schedulingPriorityIndicator', _E_DCH_LogicalChannelToModifyItem_schedulingPriorityIndicator),
        ('schedulingInformation', _E_DCH_LogicalChannelToModifyItem_schedulingInformation),
        ('mACesGuaranteedBitRate', _E_DCH_LogicalChannelToModifyItem_mACesGuaranteedBitRate),
        ('e-DCH-DDI-Value', _E_DCH_LogicalChannelToModifyItem_e_DCH_DDI_Value),
        ('mACd-PDU-Size-List', _E_DCH_LogicalChannelToModifyItem_mACd_PDU_Size_List),
        ('iE-Extensions', _E_DCH_LogicalChannelToModifyItem_iE_Extensions),
        ])
    E_DCH_LogicalChannelToModifyItem._ext = []
    
    #-----< E-DCH-LogicalChannelToModifyItem-ExtIEs >-----#
    E_DCH_LogicalChannelToModifyItem_ExtIEs = CLASS(name='E-DCH-LogicalChannelToModifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MACes-Maximum-Bitrate-LCR')))
    E_DCH_LogicalChannelToModifyItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'reject'), ('Extension', _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1046), ('criticality', 'ignore'), ('Extension', _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-MACdPDU-SizeToModifyList >-----#
    E_DCH_MACdPDU_SizeToModifyList = SEQ_OF(name='E-DCH-MACdPDU-SizeToModifyList', mode=MODE_TYPE)
    _E_DCH_MACdPDU_SizeToModifyList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDU-SizeListItem')))
    E_DCH_MACdPDU_SizeToModifyList._cont = _E_DCH_MACdPDU_SizeToModifyList__item_
    E_DCH_MACdPDU_SizeToModifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    
    #-----< E-DCH-LogicalChannelToDelete >-----#
    E_DCH_LogicalChannelToDelete = SEQ_OF(name='E-DCH-LogicalChannelToDelete', mode=MODE_TYPE)
    _E_DCH_LogicalChannelToDelete__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LogicalChannelToDeleteItem')))
    E_DCH_LogicalChannelToDelete._cont = _E_DCH_LogicalChannelToDelete__item_
    E_DCH_LogicalChannelToDelete._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< E-DCH-LogicalChannelToDeleteItem >-----#
    E_DCH_LogicalChannelToDeleteItem = SEQ(name='E-DCH-LogicalChannelToDeleteItem', mode=MODE_TYPE)
    _E_DCH_LogicalChannelToDeleteItem_logicalChannelId = INT(name='logicalChannelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LogicalChannelID')))
    _E_DCH_LogicalChannelToDeleteItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id._const_tab = ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality_tab
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue_tab
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id),
        ('criticality', ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item_._ext = None
    _E_DCH_LogicalChannelToDeleteItem_iE_Extensions._cont = __E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item_
    _E_DCH_LogicalChannelToDeleteItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LogicalChannelToDeleteItem._cont = ASN1Dict([
        ('logicalChannelId', _E_DCH_LogicalChannelToDeleteItem_logicalChannelId),
        ('iE-Extensions', _E_DCH_LogicalChannelToDeleteItem_iE_Extensions),
        ])
    E_DCH_LogicalChannelToDeleteItem._ext = []
    
    #-----< E-DCH-LogicalChannelToDeleteItem-ExtIEs >-----#
    E_DCH_LogicalChannelToDeleteItem_ExtIEs = CLASS(name='E-DCH-LogicalChannelToDeleteItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_LogicalChannelToDeleteItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LogicalChannelID >-----#
    LogicalChannelID = INT(name='LogicalChannelID', mode=MODE_TYPE)
    LogicalChannelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< E-DCH-HARQ-PO-FDD >-----#
    E_DCH_HARQ_PO_FDD = INT(name='E-DCH-HARQ-PO-FDD', mode=MODE_TYPE)
    E_DCH_HARQ_PO_FDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-ID >-----#
    E_DCH_MACdFlow_ID = INT(name='E-DCH-MACdFlow-ID', mode=MODE_TYPE)
    E_DCH_MACdFlow_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlows-Information >-----#
    E_DCH_MACdFlows_Information = SEQ(name='E-DCH-MACdFlows-Information', mode=MODE_TYPE)
    _E_DCH_MACdFlows_Information_e_DCH_MACdFlow_Specific_Info = SEQ_OF(name='e-DCH-MACdFlow-Specific-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Specific-InfoList')))
    _E_DCH_MACdFlows_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlows_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_MACdFlows_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlows_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlows_Information_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_MACdFlows_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlows_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlows_Information_iE_Extensions__item__criticality_tab
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_MACdFlows_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_MACdFlows_Information_iE_Extensions__item__id),
        ('criticality', ___E_DCH_MACdFlows_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_MACdFlows_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlows_Information_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlows_Information_iE_Extensions._cont = __E_DCH_MACdFlows_Information_iE_Extensions__item_
    _E_DCH_MACdFlows_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlows_Information._cont = ASN1Dict([
        ('e-DCH-MACdFlow-Specific-Info', _E_DCH_MACdFlows_Information_e_DCH_MACdFlow_Specific_Info),
        ('iE-Extensions', _E_DCH_MACdFlows_Information_iE_Extensions),
        ])
    E_DCH_MACdFlows_Information._ext = []
    
    #-----< E-DCH-MACdFlows-Information-ExtIEs >-----#
    E_DCH_MACdFlows_Information_ExtIEs = CLASS(name='E-DCH-MACdFlows-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_MACdFlows_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-MACdFlow-Multiplexing-List >-----#
    E_DCH_MACdFlow_Multiplexing_List = BIT_STR(name='E-DCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE)
    E_DCH_MACdFlow_Multiplexing_List._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-Specific-InfoList >-----#
    E_DCH_MACdFlow_Specific_InfoList = SEQ_OF(name='E-DCH-MACdFlow-Specific-InfoList', mode=MODE_TYPE)
    _E_DCH_MACdFlow_Specific_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Specific-InfoItem')))
    E_DCH_MACdFlow_Specific_InfoList._cont = _E_DCH_MACdFlow_Specific_InfoList__item_
    E_DCH_MACdFlow_Specific_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-Specific-InfoItem >-----#
    E_DCH_MACdFlow_Specific_InfoItem = SEQ(name='E-DCH-MACdFlow-Specific-InfoItem', mode=MODE_TYPE)
    _E_DCH_MACdFlow_Specific_InfoItem_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _E_DCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')))
    _E_DCH_MACdFlow_Specific_InfoItem_tnlQos = CHOICE(name='tnlQos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_payloadCRC_PresenceIndicator = ENUM(name='payloadCRC-PresenceIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PayloadCRC-PresenceIndicator')))
    _E_DCH_MACdFlow_Specific_InfoItem_maximum_Number_of_Retransmissions_For_E_DCH = INT(name='maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Number-of-Retransmissions-For-E-DCH')))
    _E_DCH_MACdFlow_Specific_InfoItem_eDCH_HARQ_PO_FDD = INT(name='eDCH-HARQ-PO-FDD', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-PO-FDD')))
    _E_DCH_MACdFlow_Specific_InfoItem_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name='eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_eDCH_Grant_Type_Information = CHOICE(name='eDCH-Grant-Type-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Grant-Type-Information')))
    _E_DCH_MACdFlow_Specific_InfoItem_bundlingModeIndicator = ENUM(name='bundlingModeIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BundlingModeIndicator')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_eDCHLogicalChannelInformation = SEQ_OF(name='eDCHLogicalChannelInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LogicalChannelInformation')))
    _E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerNotRequestedIndicator')))
    ____E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 911), ('criticality', 'ignore'), ('Extension', _____E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id),
        ('criticality', ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions._cont = __E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_
    _E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlow_Specific_InfoItem._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _E_DCH_MACdFlow_Specific_InfoItem_e_DCH_MACdFlow_ID),
        ('allocationRetentionPriority', _E_DCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority),
        ('tnlQos', _E_DCH_MACdFlow_Specific_InfoItem_tnlQos),
        ('payloadCRC-PresenceIndicator', _E_DCH_MACdFlow_Specific_InfoItem_payloadCRC_PresenceIndicator),
        ('maximum-Number-of-Retransmissions-For-E-DCH', _E_DCH_MACdFlow_Specific_InfoItem_maximum_Number_of_Retransmissions_For_E_DCH),
        ('eDCH-HARQ-PO-FDD', _E_DCH_MACdFlow_Specific_InfoItem_eDCH_HARQ_PO_FDD),
        ('eDCH-MACdFlow-Multiplexing-List', _E_DCH_MACdFlow_Specific_InfoItem_eDCH_MACdFlow_Multiplexing_List),
        ('eDCH-Grant-Type-Information', _E_DCH_MACdFlow_Specific_InfoItem_eDCH_Grant_Type_Information),
        ('bundlingModeIndicator', _E_DCH_MACdFlow_Specific_InfoItem_bundlingModeIndicator),
        ('eDCHLogicalChannelInformation', _E_DCH_MACdFlow_Specific_InfoItem_eDCHLogicalChannelInformation),
        ('iE-Extensions', _E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions),
        ])
    E_DCH_MACdFlow_Specific_InfoItem._ext = []
    
    #-----< E-DCH-MACdFlow-Specific-InfoItem-ExtIEs >-----#
    E_DCH_MACdFlow_Specific_InfoItem_ExtIEs = CLASS(name='E-DCH-MACdFlow-Specific-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerNotRequestedIndicator')))
    E_DCH_MACdFlow_Specific_InfoItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 911), ('criticality', 'ignore'), ('Extension', _E_DCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-MACdFlow-Specific-InformationResp >-----#
    E_DCH_MACdFlow_Specific_InformationResp = SEQ_OF(name='E-DCH-MACdFlow-Specific-InformationResp', mode=MODE_TYPE)
    _E_DCH_MACdFlow_Specific_InformationResp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Specific-InformationResp-Item')))
    E_DCH_MACdFlow_Specific_InformationResp._cont = _E_DCH_MACdFlow_Specific_InformationResp__item_
    E_DCH_MACdFlow_Specific_InformationResp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-Specific-InformationResp-Item >-----#
    E_DCH_MACdFlow_Specific_InformationResp_Item = SEQ(name='E-DCH-MACdFlow-Specific-InformationResp-Item', mode=MODE_TYPE)
    _E_DCH_MACdFlow_Specific_InformationResp_Item_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _E_DCH_MACdFlow_Specific_InformationResp_Item_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _E_DCH_MACdFlow_Specific_InformationResp_Item_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _E_DCH_MACdFlow_Specific_InformationResp_Item_hARQ_Process_Allocation_NonSched_2ms_EDCH = BIT_STR(name='hARQ-Process-Allocation-NonSched-2ms-EDCH', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerNotSetupIndicator')))
    ____E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 910), ('criticality', 'ignore'), ('Extension', _____E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id),
        ('criticality', ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions._cont = __E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_
    _E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlow_Specific_InformationResp_Item._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _E_DCH_MACdFlow_Specific_InformationResp_Item_e_DCH_MACdFlow_ID),
        ('bindingID', _E_DCH_MACdFlow_Specific_InformationResp_Item_bindingID),
        ('transportLayerAddress', _E_DCH_MACdFlow_Specific_InformationResp_Item_transportLayerAddress),
        ('hARQ-Process-Allocation-NonSched-2ms-EDCH', _E_DCH_MACdFlow_Specific_InformationResp_Item_hARQ_Process_Allocation_NonSched_2ms_EDCH),
        ('iE-Extensions', _E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions),
        ])
    E_DCH_MACdFlow_Specific_InformationResp_Item._ext = []
    
    #-----< E-DCH-MACdFlow-Specific-InformationResp-Item-ExtIEs >-----#
    E_DCH_MACdFlow_Specific_InformationResp_Item_ExtIEs = CLASS(name='E-DCH-MACdFlow-Specific-InformationResp-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_MACdFlow_Specific_InformationResp_Item_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerNotSetupIndicator')))
    E_DCH_MACdFlow_Specific_InformationResp_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 910), ('criticality', 'ignore'), ('Extension', _E_DCH_MACdFlow_Specific_InformationResp_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-MACdFlow-Specific-InfoList-to-Modify >-----#
    E_DCH_MACdFlow_Specific_InfoList_to_Modify = SEQ_OF(name='E-DCH-MACdFlow-Specific-InfoList-to-Modify', mode=MODE_TYPE)
    _E_DCH_MACdFlow_Specific_InfoList_to_Modify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Specific-InfoItem-to-Modify')))
    E_DCH_MACdFlow_Specific_InfoList_to_Modify._cont = _E_DCH_MACdFlow_Specific_InfoList_to_Modify__item_
    E_DCH_MACdFlow_Specific_InfoList_to_Modify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-Specific-InfoItem-to-Modify >-----#
    E_DCH_MACdFlow_Specific_InfoItem_to_Modify = SEQ(name='E-DCH-MACdFlow-Specific-InfoItem-to-Modify', mode=MODE_TYPE)
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_transportBearerRequestIndicator = ENUM(name='transportBearerRequestIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_tnlQos = CHOICE(name='tnlQos', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_maximum_Number_of_Retransmissions_For_E_DCH = INT(name='maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Number-of-Retransmissions-For-E-DCH')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_HARQ_PO_FDD = INT(name='eDCH-HARQ-PO-FDD', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-PO-FDD')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name='eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_Grant_Type_Information = CHOICE(name='eDCH-Grant-Type-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Grant-Type-Information')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_bundlingModeIndicator = ENUM(name='bundlingModeIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BundlingModeIndicator')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_LogicalChannelToAdd = SEQ_OF(name='eDCH-LogicalChannelToAdd', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LogicalChannelInformation')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_LogicalChannelToModify = SEQ_OF(name='eDCH-LogicalChannelToModify', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LogicalChannelToModify')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_LogicalChannelToDelete = SEQ_OF(name='eDCH-LogicalChannelToDelete', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LogicalChannelToDelete')), opt=True)
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality_tab
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue_tab
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id),
        ('criticality', ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions._cont = __E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_
    _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlow_Specific_InfoItem_to_Modify._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_e_DCH_MACdFlow_ID),
        ('allocationRetentionPriority', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_allocationRetentionPriority),
        ('transportBearerRequestIndicator', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_transportBearerRequestIndicator),
        ('tnlQos', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_tnlQos),
        ('maximum-Number-of-Retransmissions-For-E-DCH', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_maximum_Number_of_Retransmissions_For_E_DCH),
        ('eDCH-HARQ-PO-FDD', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_HARQ_PO_FDD),
        ('eDCH-MACdFlow-Multiplexing-List', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_MACdFlow_Multiplexing_List),
        ('eDCH-Grant-Type-Information', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_Grant_Type_Information),
        ('bundlingModeIndicator', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_bundlingModeIndicator),
        ('eDCH-LogicalChannelToAdd', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_LogicalChannelToAdd),
        ('eDCH-LogicalChannelToModify', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_LogicalChannelToModify),
        ('eDCH-LogicalChannelToDelete', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_LogicalChannelToDelete),
        ('iE-Extensions', _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions),
        ])
    E_DCH_MACdFlow_Specific_InfoItem_to_Modify._ext = []
    
    #-----< E-DCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs >-----#
    E_DCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs = CLASS(name='E-DCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-MACdFlows-to-Delete >-----#
    E_DCH_MACdFlows_to_Delete = SEQ_OF(name='E-DCH-MACdFlows-to-Delete', mode=MODE_TYPE)
    _E_DCH_MACdFlows_to_Delete__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-to-Delete-Item')))
    E_DCH_MACdFlows_to_Delete._cont = _E_DCH_MACdFlows_to_Delete__item_
    E_DCH_MACdFlows_to_Delete._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-to-Delete-Item >-----#
    E_DCH_MACdFlow_to_Delete_Item = SEQ(name='E-DCH-MACdFlow-to-Delete-Item', mode=MODE_TYPE)
    _E_DCH_MACdFlow_to_Delete_Item_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _E_DCH_MACdFlow_to_Delete_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__criticality_tab
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__id),
        ('criticality', ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlow_to_Delete_Item_iE_Extensions._cont = __E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item_
    _E_DCH_MACdFlow_to_Delete_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlow_to_Delete_Item._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _E_DCH_MACdFlow_to_Delete_Item_e_DCH_MACdFlow_ID),
        ('iE-Extensions', _E_DCH_MACdFlow_to_Delete_Item_iE_Extensions),
        ])
    E_DCH_MACdFlow_to_Delete_Item._ext = []
    
    #-----< E-DCH-MACdFlow-to-Delete-Item-ExtIEs >-----#
    E_DCH_MACdFlow_to_Delete_Item_ExtIEs = CLASS(name='E-DCH-MACdFlow-to-Delete-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_MACdFlow_to_Delete_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Non-Scheduled-Transmission-Grant-Items >-----#
    E_DCH_Non_Scheduled_Transmission_Grant_Items = SEQ(name='E-DCH-Non-Scheduled-Transmission-Grant-Items', mode=MODE_TYPE)
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_maxBits_MACe_PDU_non_scheduled = INT(name='maxBits-MACe-PDU-non-scheduled', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-Bits-MACe-PDU-non-scheduled')))
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_hARQ_Process_Allocation_NonSched_2ms = BIT_STR(name='hARQ-Process-Allocation-NonSched-2ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ext-Max-Bits-MACe-PDU-non-scheduled')))
    ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 903), ('criticality', 'reject'), ('Extension', _____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id._const_tab = ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality._const_tab = ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item_._ext = None
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions._cont = __E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item_
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Non_Scheduled_Transmission_Grant_Items._cont = ASN1Dict([
        ('maxBits-MACe-PDU-non-scheduled', _E_DCH_Non_Scheduled_Transmission_Grant_Items_maxBits_MACe_PDU_non_scheduled),
        ('hARQ-Process-Allocation-NonSched-2ms', _E_DCH_Non_Scheduled_Transmission_Grant_Items_hARQ_Process_Allocation_NonSched_2ms),
        ('iE-Extensions', _E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions),
        ])
    E_DCH_Non_Scheduled_Transmission_Grant_Items._ext = []
    
    #-----< E-DCH-Non-Scheduled-Transmission-Grant-Items-ExtIEs >-----#
    E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs = CLASS(name='E-DCH-Non-Scheduled-Transmission-Grant-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ext-Max-Bits-MACe-PDU-non-scheduled')))
    E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs._val = ASN1Set(rv=[dict([('id', 903), ('criticality', 'reject'), ('Extension', _E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Non-serving-Relative-Grant-Down-Commands >-----#
    E_DCH_Non_serving_Relative_Grant_Down_Commands = INT(name='E-DCH-Non-serving-Relative-Grant-Down-Commands', mode=MODE_TYPE)
    E_DCH_Non_serving_Relative_Grant_Down_Commands._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    
    #-----< E-DCHProvidedBitRateValue >-----#
    E_DCHProvidedBitRateValue = INT(name='E-DCHProvidedBitRateValue', mode=MODE_TYPE)
    E_DCHProvidedBitRateValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=[], er=[ASN1RangeInt(lb=16777216, ub=256000000)])
    
    #-----< Maximum-Target-ReceivedTotalWideBandPower >-----#
    Maximum_Target_ReceivedTotalWideBandPower = INT(name='Maximum-Target-ReceivedTotalWideBandPower', mode=MODE_TYPE)
    Maximum_Target_ReceivedTotalWideBandPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=621)], ev=None, er=[])
    
    #-----< Target-NonServing-EDCH-To-Total-EDCH-Power-Ratio >-----#
    Target_NonServing_EDCH_To_Total_EDCH_Power_Ratio = INT(name='Target-NonServing-EDCH-To-Total-EDCH-Power-Ratio', mode=MODE_TYPE)
    Target_NonServing_EDCH_To_Total_EDCH_Power_Ratio._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< E-DCH-RL-Indication >-----#
    E_DCH_RL_Indication = ENUM(name='E-DCH-RL-Indication', mode=MODE_TYPE)
    E_DCH_RL_Indication._cont = ASN1Dict([('e-DCH', 0), ('non-e-DCH', 1)])
    E_DCH_RL_Indication._ext = None
    
    #-----< E-DCH-Serving-Cell-Change-Info-Response >-----#
    E_DCH_Serving_Cell_Change_Info_Response = SEQ(name='E-DCH-Serving-Cell-Change-Info-Response', mode=MODE_TYPE)
    _E_DCH_Serving_Cell_Change_Info_Response_e_DCH_serving_cell_choice = CHOICE(name='e-DCH-serving-cell-choice', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-serving-cell-choice')))
    _E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id._const_tab = ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id_tab
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality._const_tab = ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality_tab
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item_._ext = None
    _E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions._cont = __E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item_
    _E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Serving_Cell_Change_Info_Response._cont = ASN1Dict([
        ('e-DCH-serving-cell-choice', _E_DCH_Serving_Cell_Change_Info_Response_e_DCH_serving_cell_choice),
        ('iE-Extensions', _E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions),
        ])
    E_DCH_Serving_Cell_Change_Info_Response._ext = []
    
    #-----< E-DCH-serving-cell-informationResponse-ExtIEs >-----#
    E_DCH_serving_cell_informationResponse_ExtIEs = CLASS(name='E-DCH-serving-cell-informationResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_serving_cell_informationResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-serving-cell-choice >-----#
    E_DCH_serving_cell_choice = CHOICE(name='E-DCH-serving-cell-choice', mode=MODE_TYPE)
    _E_DCH_serving_cell_choice_e_DCH_serving_cell_change_successful = SEQ(name='e-DCH-serving-cell-change-successful', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-serving-cell-change-successful')))
    _E_DCH_serving_cell_choice_e_DCH_serving_cell_change_unsuccessful = SEQ(name='e-DCH-serving-cell-change-unsuccessful', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-serving-cell-change-unsuccessful')))
    E_DCH_serving_cell_choice._cont = ASN1Dict([
        ('e-DCH-serving-cell-change-successful', _E_DCH_serving_cell_choice_e_DCH_serving_cell_change_successful),
        ('e-DCH-serving-cell-change-unsuccessful', _E_DCH_serving_cell_choice_e_DCH_serving_cell_change_unsuccessful),
        ])
    E_DCH_serving_cell_choice._ext = []
    
    #-----< E-DCH-serving-cell-change-successful >-----#
    E_DCH_serving_cell_change_successful = SEQ(name='E-DCH-serving-cell-change-successful', mode=MODE_TYPE)
    _E_DCH_serving_cell_change_successful_e_DCH_RL_InformationList_Rsp = SEQ_OF(name='e-DCH-RL-InformationList-Rsp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RL-InformationList-Rsp')))
    _E_DCH_serving_cell_change_successful_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_serving_cell_change_successful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id._const_tab = ____E_DCH_serving_cell_change_successful_iE_Extensions__item__id_tab
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab = ____E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality_tab
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue_tab
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_serving_cell_change_successful_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id),
        ('criticality', ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_serving_cell_change_successful_iE_Extensions__item_._ext = None
    _E_DCH_serving_cell_change_successful_iE_Extensions._cont = __E_DCH_serving_cell_change_successful_iE_Extensions__item_
    _E_DCH_serving_cell_change_successful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_serving_cell_change_successful._cont = ASN1Dict([
        ('e-DCH-RL-InformationList-Rsp', _E_DCH_serving_cell_change_successful_e_DCH_RL_InformationList_Rsp),
        ('iE-Extensions', _E_DCH_serving_cell_change_successful_iE_Extensions),
        ])
    E_DCH_serving_cell_change_successful._ext = []
    
    #-----< E-DCH-RL-InformationList-Rsp >-----#
    E_DCH_RL_InformationList_Rsp = SEQ_OF(name='E-DCH-RL-InformationList-Rsp', mode=MODE_TYPE)
    _E_DCH_RL_InformationList_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RL-InformationList-Rsp-Item')))
    E_DCH_RL_InformationList_Rsp._cont = _E_DCH_RL_InformationList_Rsp__item_
    E_DCH_RL_InformationList_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< E-DCH-RL-InformationList-Rsp-Item >-----#
    E_DCH_RL_InformationList_Rsp_Item = SEQ(name='E-DCH-RL-InformationList-Rsp-Item', mode=MODE_TYPE)
    _E_DCH_RL_InformationList_Rsp_Item_rl_ID = INT(name='rl-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _E_DCH_RL_InformationList_Rsp_Item_e_DCH_FDD_DL_Control_Channel_Info = SEQ(name='e-DCH-FDD-DL-Control-Channel-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _E_DCH_RL_InformationList_Rsp_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id._const_tab = ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id_tab
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality_tab
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id),
        ('criticality', ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item_._ext = None
    _E_DCH_RL_InformationList_Rsp_Item_iE_Extensions._cont = __E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item_
    _E_DCH_RL_InformationList_Rsp_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_RL_InformationList_Rsp_Item._cont = ASN1Dict([
        ('rl-ID', _E_DCH_RL_InformationList_Rsp_Item_rl_ID),
        ('e-DCH-FDD-DL-Control-Channel-Info', _E_DCH_RL_InformationList_Rsp_Item_e_DCH_FDD_DL_Control_Channel_Info),
        ('iE-Extensions', _E_DCH_RL_InformationList_Rsp_Item_iE_Extensions),
        ])
    E_DCH_RL_InformationList_Rsp_Item._ext = []
    
    #-----< E-DCH-serving-cell-change-successful-ExtIEs >-----#
    E_DCH_serving_cell_change_successful_ExtIEs = CLASS(name='E-DCH-serving-cell-change-successful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_serving_cell_change_successful_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-RL-InformationList-Rsp-Item-ExtIEs >-----#
    E_DCH_RL_InformationList_Rsp_Item_ExtIEs = CLASS(name='E-DCH-RL-InformationList-Rsp-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_RL_InformationList_Rsp_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-serving-cell-change-unsuccessful >-----#
    E_DCH_serving_cell_change_unsuccessful = SEQ(name='E-DCH-serving-cell-change-unsuccessful', mode=MODE_TYPE)
    _E_DCH_serving_cell_change_unsuccessful_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _E_DCH_serving_cell_change_unsuccessful_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab = ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab = ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id),
        ('criticality', ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item_._ext = None
    _E_DCH_serving_cell_change_unsuccessful_iE_Extensions._cont = __E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item_
    _E_DCH_serving_cell_change_unsuccessful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_serving_cell_change_unsuccessful._cont = ASN1Dict([
        ('cause', _E_DCH_serving_cell_change_unsuccessful_cause),
        ('iE-Extensions', _E_DCH_serving_cell_change_unsuccessful_iE_Extensions),
        ])
    E_DCH_serving_cell_change_unsuccessful._ext = []
    
    #-----< E-DCH-serving-cell-change-unsuccessful-ExtIEs >-----#
    E_DCH_serving_cell_change_unsuccessful_ExtIEs = CLASS(name='E-DCH-serving-cell-change-unsuccessful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_serving_cell_change_unsuccessful_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-RACH-Report-Value >-----#
    EDCH_RACH_Report_Value = SEQ_OF(name='EDCH-RACH-Report-Value', mode=MODE_TYPE)
    _EDCH_RACH_Report_Value__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __EDCH_RACH_Report_Value__item__granted_EDCH_RACH_resources = INT(name='granted-EDCH-RACH-resources', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Granted-EDCH-RACH-Resources-Value')))
    __EDCH_RACH_Report_Value__item__denied_EDCH_RACH_resources = INT(name='denied-EDCH-RACH-resources', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Denied-EDCH-RACH-Resources-Value')))
    __EDCH_RACH_Report_Value__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___EDCH_RACH_Report_Value__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ______EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Grant-E-DCH-RACH-Resources')))
    ______EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Overridden-E-DCH-RACH-Resources')))
    ______EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Denied-E-DCH-RACH-Resources')))
    _____EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1249), ('criticality', 'ignore'), ('Extension', ______EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1250), ('criticality', 'ignore'), ('Extension', ______EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1251), ('criticality', 'ignore'), ('Extension', ______EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__id._const_tab = _____EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__id._const_tab_at = None
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__criticality._const_tab = _____EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__extensionValue._const_tab = _____EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____EDCH_RACH_Report_Value__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___EDCH_RACH_Report_Value__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____EDCH_RACH_Report_Value__item__iE_Extensions__item__id),
        ('criticality', ____EDCH_RACH_Report_Value__item__iE_Extensions__item__criticality),
        ('extensionValue', ____EDCH_RACH_Report_Value__item__iE_Extensions__item__extensionValue),
        ])
    ___EDCH_RACH_Report_Value__item__iE_Extensions__item_._ext = None
    __EDCH_RACH_Report_Value__item__iE_Extensions._cont = ___EDCH_RACH_Report_Value__item__iE_Extensions__item_
    __EDCH_RACH_Report_Value__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _EDCH_RACH_Report_Value__item_._cont = ASN1Dict([
        ('granted-EDCH-RACH-resources', __EDCH_RACH_Report_Value__item__granted_EDCH_RACH_resources),
        ('denied-EDCH-RACH-resources', __EDCH_RACH_Report_Value__item__denied_EDCH_RACH_resources),
        ('iE-Extensions', __EDCH_RACH_Report_Value__item__iE_Extensions),
        ])
    _EDCH_RACH_Report_Value__item_._ext = []
    EDCH_RACH_Report_Value._cont = _EDCH_RACH_Report_Value__item_
    EDCH_RACH_Report_Value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< EDCH-RACH-Report-Value-ExtIEs >-----#
    EDCH_RACH_Report_Value_ExtIEs = CLASS(name='EDCH-RACH-Report-Value-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _EDCH_RACH_Report_Value_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Grant-E-DCH-RACH-Resources')))
    _EDCH_RACH_Report_Value_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Overridden-E-DCH-RACH-Resources')))
    _EDCH_RACH_Report_Value_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Denied-E-DCH-RACH-Resources')))
    EDCH_RACH_Report_Value_ExtIEs._val = ASN1Set(rv=[dict([('id', 1249), ('criticality', 'ignore'), ('Extension', _EDCH_RACH_Report_Value_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1250), ('criticality', 'ignore'), ('Extension', _EDCH_RACH_Report_Value_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1251), ('criticality', 'ignore'), ('Extension', _EDCH_RACH_Report_Value_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TFCI-Table-Index >-----#
    E_DCH_TFCI_Table_Index = INT(name='E-DCH-TFCI-Table-Index', mode=MODE_TYPE)
    E_DCH_TFCI_Table_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=[], er=[ASN1RangeInt(lb=2, ub=7)])
    
    #-----< E-DCH-TTI-Length >-----#
    E_DCH_TTI_Length = CHOICE(name='E-DCH-TTI-Length', mode=MODE_TYPE)
    _E_DCH_TTI_Length_two_ms = SEQ(name='two-ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DTX-Cycle-2ms-Items')))
    _E_DCH_TTI_Length_ten_ms = SEQ(name='ten-ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DTX-Cycle-10ms-Items')))
    E_DCH_TTI_Length._cont = ASN1Dict([
        ('two-ms', _E_DCH_TTI_Length_two_ms),
        ('ten-ms', _E_DCH_TTI_Length_ten_ms),
        ])
    E_DCH_TTI_Length._ext = []
    
    #-----< E-DCH-TTI-Length-to-Modify >-----#
    E_DCH_TTI_Length_to_Modify = CHOICE(name='E-DCH-TTI-Length-to-Modify', mode=MODE_TYPE)
    _E_DCH_TTI_Length_to_Modify_two_ms = SEQ(name='two-ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DTX-Cycle-2ms-to-Modify-Items')))
    _E_DCH_TTI_Length_to_Modify_ten_ms = SEQ(name='ten-ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DTX-Cycle-10ms-to-Modify-Items')))
    E_DCH_TTI_Length_to_Modify._cont = ASN1Dict([
        ('two-ms', _E_DCH_TTI_Length_to_Modify_two_ms),
        ('ten-ms', _E_DCH_TTI_Length_to_Modify_ten_ms),
        ])
    E_DCH_TTI_Length_to_Modify._ext = []
    
    #-----< E-DPCCH-PO >-----#
    E_DPCCH_PO = INT(name='E-DPCCH-PO', mode=MODE_TYPE)
    E_DPCCH_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< Extended-E-DPCCH-PO >-----#
    Extended_E_DPCCH_PO = INT(name='Extended-E-DPCCH-PO', mode=MODE_TYPE)
    Extended_E_DPCCH_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=15)], ev=None, er=[])
    
    #-----< E-DPDCH-PowerInterpolation >-----#
    E_DPDCH_PowerInterpolation = BOOL(name='E-DPDCH-PowerInterpolation', mode=MODE_TYPE)
    
    #-----< E-Primary-Secondary-Grant-Selector >-----#
    E_Primary_Secondary_Grant_Selector = ENUM(name='E-Primary-Secondary-Grant-Selector', mode=MODE_TYPE)
    E_Primary_Secondary_Grant_Selector._cont = ASN1Dict([('primary', 0), ('secondary', 1)])
    E_Primary_Secondary_Grant_Selector._ext = None
    
    #-----< E-DCH-MACdFlow-ID-LCR >-----#
    E_DCH_MACdFlow_ID_LCR = INT(name='E-DCH-MACdFlow-ID-LCR', mode=MODE_TYPE)
    E_DCH_MACdFlow_ID_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlows-to-DeleteLCR >-----#
    E_DCH_MACdFlows_to_DeleteLCR = SEQ_OF(name='E-DCH-MACdFlows-to-DeleteLCR', mode=MODE_TYPE)
    _E_DCH_MACdFlows_to_DeleteLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-to-Delete-ItemLCR')))
    E_DCH_MACdFlows_to_DeleteLCR._cont = _E_DCH_MACdFlows_to_DeleteLCR__item_
    E_DCH_MACdFlows_to_DeleteLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-to-Delete-ItemLCR >-----#
    E_DCH_MACdFlow_to_Delete_ItemLCR = SEQ(name='E-DCH-MACdFlow-to-Delete-ItemLCR', mode=MODE_TYPE)
    _E_DCH_MACdFlow_to_Delete_ItemLCR_e_DCH_MACdFlow_ID_LCR = INT(name='e-DCH-MACdFlow-ID-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID-LCR')))
    _E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__criticality_tab
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__extensionValue_tab
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__id),
        ('criticality', ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions._cont = __E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item_
    _E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlow_to_Delete_ItemLCR._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID-LCR', _E_DCH_MACdFlow_to_Delete_ItemLCR_e_DCH_MACdFlow_ID_LCR),
        ('iE-Extensions', _E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions),
        ])
    E_DCH_MACdFlow_to_Delete_ItemLCR._ext = []
    
    #-----< E-DCH-MACdFlow-to-Delete-ItemLCR-ExtIEs >-----#
    E_DCH_MACdFlow_to_Delete_ItemLCR_ExtIEs = CLASS(name='E-DCH-MACdFlow-to-Delete-ItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_MACdFlow_to_Delete_ItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Enhanced-UE-DRX-InformationLCR >-----#
    Enhanced_UE_DRX_InformationLCR = SEQ(name='Enhanced-UE-DRX-InformationLCR', mode=MODE_TYPE)
    _Enhanced_UE_DRX_InformationLCR_t321 = ENUM(name='t321', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T321')))
    _Enhanced_UE_DRX_InformationLCR_hS_DSCH_DRX_Cycle_FACH = ENUM(name='hS-DSCH-DRX-Cycle-FACH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-DRX-Cycle-FACH')))
    _Enhanced_UE_DRX_InformationLCR_hS_DSCH_RX_Burst_FACH = ENUM(name='hS-DSCH-RX-Burst-FACH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-RX-Burst-FACH')))
    _Enhanced_UE_DRX_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Enhanced_UE_DRX_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__id._const_tab = ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__id_tab
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__criticality._const_tab = ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__criticality_tab
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Enhanced_UE_DRX_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __Enhanced_UE_DRX_InformationLCR_iE_Extensions__item_._ext = None
    _Enhanced_UE_DRX_InformationLCR_iE_Extensions._cont = __Enhanced_UE_DRX_InformationLCR_iE_Extensions__item_
    _Enhanced_UE_DRX_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Enhanced_UE_DRX_InformationLCR._cont = ASN1Dict([
        ('t321', _Enhanced_UE_DRX_InformationLCR_t321),
        ('hS-DSCH-DRX-Cycle-FACH', _Enhanced_UE_DRX_InformationLCR_hS_DSCH_DRX_Cycle_FACH),
        ('hS-DSCH-RX-Burst-FACH', _Enhanced_UE_DRX_InformationLCR_hS_DSCH_RX_Burst_FACH),
        ('iE-Extensions', _Enhanced_UE_DRX_InformationLCR_iE_Extensions),
        ])
    Enhanced_UE_DRX_InformationLCR._ext = []
    
    #-----< Enhanced-UE-DRX-InformationLCR-ExtIEs >-----#
    Enhanced_UE_DRX_InformationLCR_ExtIEs = CLASS(name='Enhanced-UE-DRX-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Enhanced_UE_DRX_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-ID-LCR >-----#
    E_HICH_ID_LCR = INT(name='E-HICH-ID-LCR', mode=MODE_TYPE)
    E_HICH_ID_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< E-HICH-Signature-Sequence >-----#
    E_HICH_Signature_Sequence = INT(name='E-HICH-Signature-Sequence', mode=MODE_TYPE)
    E_HICH_Signature_Sequence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=39)], ev=None, er=[])
    
    #-----< End-Of-Audit-Sequence-Indicator >-----#
    End_Of_Audit_Sequence_Indicator = ENUM(name='End-Of-Audit-Sequence-Indicator', mode=MODE_TYPE)
    End_Of_Audit_Sequence_Indicator._cont = ASN1Dict([('end-of-audit-sequence', 0), ('not-end-of-audit-sequence', 1)])
    End_Of_Audit_Sequence_Indicator._ext = None
    
    #-----< E-Serving-Grant-Value >-----#
    E_Serving_Grant_Value = INT(name='E-Serving-Grant-Value', mode=MODE_TYPE)
    E_Serving_Grant_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=38)], ev=None, er=[])
    
    #-----< E-RGCH-2-IndexStepThreshold >-----#
    E_RGCH_2_IndexStepThreshold = INT(name='E-RGCH-2-IndexStepThreshold', mode=MODE_TYPE)
    E_RGCH_2_IndexStepThreshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37)], ev=None, er=[])
    
    #-----< E-RGCH-3-IndexStepThreshold >-----#
    E_RGCH_3_IndexStepThreshold = INT(name='E-RGCH-3-IndexStepThreshold', mode=MODE_TYPE)
    E_RGCH_3_IndexStepThreshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37)], ev=None, er=[])
    
    #-----< E-RGCH-E-HICH-FDD-Code-Information >-----#
    E_RGCH_E_HICH_FDD_Code_Information = CHOICE(name='E-RGCH-E-HICH-FDD-Code-Information', mode=MODE_TYPE)
    _E_RGCH_E_HICH_FDD_Code_Information_replace = SEQ_OF(name='replace', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-E-HICH-FDD-Code-List')))
    _E_RGCH_E_HICH_FDD_Code_Information_remove = NULL(name='remove', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    E_RGCH_E_HICH_FDD_Code_Information._cont = ASN1Dict([
        ('replace', _E_RGCH_E_HICH_FDD_Code_Information_replace),
        ('remove', _E_RGCH_E_HICH_FDD_Code_Information_remove),
        ])
    E_RGCH_E_HICH_FDD_Code_Information._ext = []
    
    #-----< E-RGCH-E-HICH-FDD-Code-List >-----#
    E_RGCH_E_HICH_FDD_Code_List = SEQ_OF(name='E-RGCH-E-HICH-FDD-Code-List', mode=MODE_TYPE)
    _E_RGCH_E_HICH_FDD_Code_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    E_RGCH_E_HICH_FDD_Code_List._cont = _E_RGCH_E_HICH_FDD_Code_List__item_
    E_RGCH_E_HICH_FDD_Code_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-RGCH-Release-Indicator >-----#
    E_RGCH_Release_Indicator = ENUM(name='E-RGCH-Release-Indicator', mode=MODE_TYPE)
    E_RGCH_Release_Indicator._cont = ASN1Dict([('e-RGCHreleased', 0)])
    E_RGCH_Release_Indicator._ext = None
    
    #-----< E-RGCH-Signature-Sequence >-----#
    E_RGCH_Signature_Sequence = INT(name='E-RGCH-Signature-Sequence', mode=MODE_TYPE)
    E_RGCH_Signature_Sequence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=39)], ev=None, er=[])
    
    #-----< E-RNTI >-----#
    E_RNTI = INT(name='E-RNTI', mode=MODE_TYPE)
    E_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< E-TFCI >-----#
    E_TFCI = INT(name='E-TFCI', mode=MODE_TYPE)
    E_TFCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< E-TFCI-BetaEC-Boost >-----#
    E_TFCI_BetaEC_Boost = INT(name='E-TFCI-BetaEC-Boost', mode=MODE_TYPE)
    E_TFCI_BetaEC_Boost._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< E-TFCI-Boost-Information >-----#
    E_TFCI_Boost_Information = SEQ(name='E-TFCI-Boost-Information', mode=MODE_TYPE)
    _E_TFCI_Boost_Information_e_TFCI_BetaEC_Boost = INT(name='e-TFCI-BetaEC-Boost', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCI-BetaEC-Boost')))
    _E_TFCI_Boost_Information_uL_Delta_T2TP = INT(name='uL-Delta-T2TP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-Delta-T2TP')), opt=True)
    _E_TFCI_Boost_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_TFCI_Boost_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_TFCI_Boost_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_TFCI_Boost_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_TFCI_Boost_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCI_Boost_Information_iE_Extensions__item__id._const_tab = ____E_TFCI_Boost_Information_iE_Extensions__item__id_tab
    ___E_TFCI_Boost_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_TFCI_Boost_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_TFCI_Boost_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_TFCI_Boost_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_TFCI_Boost_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCI_Boost_Information_iE_Extensions__item__criticality._const_tab = ____E_TFCI_Boost_Information_iE_Extensions__item__criticality_tab
    ___E_TFCI_Boost_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_TFCI_Boost_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_TFCI_Boost_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_TFCI_Boost_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue._const_tab = ____E_TFCI_Boost_Information_iE_Extensions__item__extensionValue_tab
    ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_TFCI_Boost_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_TFCI_Boost_Information_iE_Extensions__item__id),
        ('criticality', ___E_TFCI_Boost_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue),
        ])
    __E_TFCI_Boost_Information_iE_Extensions__item_._ext = None
    _E_TFCI_Boost_Information_iE_Extensions._cont = __E_TFCI_Boost_Information_iE_Extensions__item_
    _E_TFCI_Boost_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_TFCI_Boost_Information._cont = ASN1Dict([
        ('e-TFCI-BetaEC-Boost', _E_TFCI_Boost_Information_e_TFCI_BetaEC_Boost),
        ('uL-Delta-T2TP', _E_TFCI_Boost_Information_uL_Delta_T2TP),
        ('iE-Extensions', _E_TFCI_Boost_Information_iE_Extensions),
        ])
    E_TFCI_Boost_Information._ext = []
    
    #-----< E-TFCI-Boost-Information-ExtIEs >-----#
    E_TFCI_Boost_Information_ExtIEs = CLASS(name='E-TFCI-Boost-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_TFCI_Boost_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-TFCS-Information >-----#
    E_TFCS_Information = SEQ(name='E-TFCS-Information', mode=MODE_TYPE)
    _E_TFCS_Information_e_DCH_TFCI_Table_Index = INT(name='e-DCH-TFCI-Table-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TFCI-Table-Index')))
    _E_TFCS_Information_e_DCH_Min_Set_E_TFCI = INT(name='e-DCH-Min-Set-E-TFCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCI')), opt=True)
    _E_TFCS_Information_reference_E_TFCI_Information = SEQ_OF(name='reference-E-TFCI-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Reference-E-TFCI-Information')))
    _E_TFCS_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_TFCS_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_TFCS_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_TFCS_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-TFCI-Boost-Information')))
    _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DPDCH-PowerInterpolation')))
    ____E_TFCS_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 945), ('criticality', 'reject'), ('Extension', _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 951), ('criticality', 'reject'), ('Extension', _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_TFCS_Information_iE_Extensions__item__id._const_tab = ____E_TFCS_Information_iE_Extensions__item__id_tab
    ___E_TFCS_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_TFCS_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_TFCS_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_TFCS_Information_iE_Extensions__item__criticality._const_tab = ____E_TFCS_Information_iE_Extensions__item__id_tab
    ___E_TFCS_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_TFCS_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_TFCS_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_TFCS_Information_iE_Extensions__item__extensionValue._const_tab = ____E_TFCS_Information_iE_Extensions__item__id_tab
    ___E_TFCS_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_TFCS_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_TFCS_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_TFCS_Information_iE_Extensions__item__id),
        ('criticality', ___E_TFCS_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_TFCS_Information_iE_Extensions__item__extensionValue),
        ])
    __E_TFCS_Information_iE_Extensions__item_._ext = None
    _E_TFCS_Information_iE_Extensions._cont = __E_TFCS_Information_iE_Extensions__item_
    _E_TFCS_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_TFCS_Information._cont = ASN1Dict([
        ('e-DCH-TFCI-Table-Index', _E_TFCS_Information_e_DCH_TFCI_Table_Index),
        ('e-DCH-Min-Set-E-TFCI', _E_TFCS_Information_e_DCH_Min_Set_E_TFCI),
        ('reference-E-TFCI-Information', _E_TFCS_Information_reference_E_TFCI_Information),
        ('iE-Extensions', _E_TFCS_Information_iE_Extensions),
        ])
    E_TFCS_Information._ext = []
    
    #-----< E-TFCS-Information-ExtIEs >-----#
    E_TFCS_Information_ExtIEs = CLASS(name='E-TFCS-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_TFCS_Information_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-TFCI-Boost-Information')))
    _E_TFCS_Information_ExtIEs_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DPDCH-PowerInterpolation')))
    E_TFCS_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 945), ('criticality', 'reject'), ('Extension', _E_TFCS_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 951), ('criticality', 'reject'), ('Extension', _E_TFCS_Information_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-TTI >-----#
    E_TTI = ENUM(name='E-TTI', mode=MODE_TYPE)
    E_TTI._cont = ASN1Dict([('e-TTI-2ms', 0), ('e-TTI-10ms', 1)])
    E_TTI._ext = None
    
    #-----< E-DCHProvidedBitRate >-----#
    E_DCHProvidedBitRate = SEQ_OF(name='E-DCHProvidedBitRate', mode=MODE_TYPE)
    _E_DCHProvidedBitRate__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHProvidedBitRate-Item')))
    E_DCHProvidedBitRate._cont = _E_DCHProvidedBitRate__item_
    E_DCHProvidedBitRate._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< E-DCHProvidedBitRate-Item >-----#
    E_DCHProvidedBitRate_Item = SEQ(name='E-DCHProvidedBitRate-Item', mode=MODE_TYPE)
    _E_DCHProvidedBitRate_Item_schedulingPriorityIndicator = INT(name='schedulingPriorityIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')))
    _E_DCHProvidedBitRate_Item_e_DCHProvidedBitRateValue = INT(name='e-DCHProvidedBitRateValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCHProvidedBitRateValue')))
    _E_DCHProvidedBitRate_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCHProvidedBitRate_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCHProvidedBitRate_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCHProvidedBitRate_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__id._const_tab = ____E_DCHProvidedBitRate_Item_iE_Extensions__item__id_tab
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCHProvidedBitRate_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCHProvidedBitRate_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__criticality._const_tab = ____E_DCHProvidedBitRate_Item_iE_Extensions__item__criticality_tab
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCHProvidedBitRate_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCHProvidedBitRate_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCHProvidedBitRate_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCHProvidedBitRate_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCHProvidedBitRate_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCHProvidedBitRate_Item_iE_Extensions__item__id),
        ('criticality', ___E_DCHProvidedBitRate_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCHProvidedBitRate_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCHProvidedBitRate_Item_iE_Extensions__item_._ext = None
    _E_DCHProvidedBitRate_Item_iE_Extensions._cont = __E_DCHProvidedBitRate_Item_iE_Extensions__item_
    _E_DCHProvidedBitRate_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCHProvidedBitRate_Item._cont = ASN1Dict([
        ('schedulingPriorityIndicator', _E_DCHProvidedBitRate_Item_schedulingPriorityIndicator),
        ('e-DCHProvidedBitRateValue', _E_DCHProvidedBitRate_Item_e_DCHProvidedBitRateValue),
        ('iE-Extensions', _E_DCHProvidedBitRate_Item_iE_Extensions),
        ])
    E_DCHProvidedBitRate_Item._ext = []
    
    #-----< E-DCHProvidedBitRate-Item-ExtIEs >-----#
    E_DCHProvidedBitRate_Item_ExtIEs = CLASS(name='E-DCHProvidedBitRate-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCHProvidedBitRate_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCHProvidedBitRateValueInformation-For-CellPortion >-----#
    E_DCHProvidedBitRateValueInformation_For_CellPortion = SEQ_OF(name='E-DCHProvidedBitRateValueInformation-For-CellPortion', mode=MODE_TYPE)
    _E_DCHProvidedBitRateValueInformation_For_CellPortion__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHProvidedBitRateValueInformation-For-CellPortion-Item')))
    E_DCHProvidedBitRateValueInformation_For_CellPortion._cont = _E_DCHProvidedBitRateValueInformation_For_CellPortion__item_
    E_DCHProvidedBitRateValueInformation_For_CellPortion._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-DCHProvidedBitRateValueInformation-For-CellPortion-Item >-----#
    E_DCHProvidedBitRateValueInformation_For_CellPortion_Item = SEQ(name='E-DCHProvidedBitRateValueInformation-For-CellPortion-Item', mode=MODE_TYPE)
    _E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_e_DCHProvidedBitRateValue = SEQ_OF(name='e-DCHProvidedBitRateValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCHProvidedBitRate')))
    _E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id._const_tab = ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality._const_tab = ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id),
        ('criticality', ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item_._ext = None
    _E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions._cont = __E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item_
    _E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCHProvidedBitRateValueInformation_For_CellPortion_Item._cont = ASN1Dict([
        ('cellPortionLCRID', _E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_cellPortionLCRID),
        ('e-DCHProvidedBitRateValue', _E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_e_DCHProvidedBitRateValue),
        ('iE-Extensions', _E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions),
        ])
    E_DCHProvidedBitRateValueInformation_For_CellPortion_Item._ext = []
    
    #-----< E-DCHProvidedBitRateValueInformation-For-CellPortion-Item-ExtIEs >-----#
    E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_ExtIEs = CLASS(name='E-DCHProvidedBitRateValueInformation-For-CellPortion-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-PowerOffset >-----#
    E_AGCH_PowerOffset = INT(name='E-AGCH-PowerOffset', mode=MODE_TYPE)
    E_AGCH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< E-RGCH-PowerOffset >-----#
    E_RGCH_PowerOffset = INT(name='E-RGCH-PowerOffset', mode=MODE_TYPE)
    E_RGCH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< E-HICH-PowerOffset >-----#
    E_HICH_PowerOffset = INT(name='E-HICH-PowerOffset', mode=MODE_TYPE)
    E_HICH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< E-HICH-TimeOffset >-----#
    E_HICH_TimeOffset = INT(name='E-HICH-TimeOffset', mode=MODE_TYPE)
    E_HICH_TimeOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=44)], ev=None, er=[])
    
    #-----< E-HICH-TimeOffsetLCR >-----#
    E_HICH_TimeOffsetLCR = INT(name='E-HICH-TimeOffsetLCR', mode=MODE_TYPE)
    E_HICH_TimeOffsetLCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=15)], ev=None, er=[])
    
    #-----< E-DCH-Information >-----#
    E_DCH_Information = SEQ(name='E-DCH-Information', mode=MODE_TYPE)
    _E_DCH_Information_e_PUCH_Information = SEQ(name='e-PUCH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-PUCH-Information')))
    _E_DCH_Information_e_TFCS_Information_TDD = SEQ(name='e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information-TDD')))
    _E_DCH_Information_e_DCH_MACdFlows_Information_TDD = SEQ_OF(name='e-DCH-MACdFlows-Information-TDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-Information-TDD')))
    _E_DCH_Information_e_DCH_Non_Scheduled_Grant_Info = SEQ(name='e-DCH-Non-Scheduled-Grant-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Non-Scheduled-Grant-Info')), opt=True)
    _E_DCH_Information_e_DCH_TDD_Information = SEQ(name='e-DCH-TDD-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-Information')))
    _E_DCH_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_iE_Extensions__item__id._const_tab = ____E_DCH_Information_iE_Extensions__item__id_tab
    ___E_DCH_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_Information_iE_Extensions__item__criticality_tab
    ___E_DCH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Information_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Information_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Information_iE_Extensions__item_._ext = None
    _E_DCH_Information_iE_Extensions._cont = __E_DCH_Information_iE_Extensions__item_
    _E_DCH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Information._cont = ASN1Dict([
        ('e-PUCH-Information', _E_DCH_Information_e_PUCH_Information),
        ('e-TFCS-Information-TDD', _E_DCH_Information_e_TFCS_Information_TDD),
        ('e-DCH-MACdFlows-Information-TDD', _E_DCH_Information_e_DCH_MACdFlows_Information_TDD),
        ('e-DCH-Non-Scheduled-Grant-Info', _E_DCH_Information_e_DCH_Non_Scheduled_Grant_Info),
        ('e-DCH-TDD-Information', _E_DCH_Information_e_DCH_TDD_Information),
        ('iE-Extensions', _E_DCH_Information_iE_Extensions),
        ])
    E_DCH_Information._ext = []
    
    #-----< E-DCH-Information-ExtIEs >-----#
    E_DCH_Information_ExtIEs = CLASS(name='E-DCH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-PUCH-Information >-----#
    E_PUCH_Information = SEQ(name='E-PUCH-Information', mode=MODE_TYPE)
    _E_PUCH_Information_minCR = INT(name='minCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CodeRate')))
    _E_PUCH_Information_maxCR = INT(name='maxCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CodeRate')))
    _E_PUCH_Information_harqInfo = ENUM(name='harqInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Info-for-E-DCH')))
    _E_PUCH_Information_n_E_UCCH = INT(name='n-E-UCCH', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'N-E-UCCH')))
    _E_PUCH_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_PUCH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_PUCH_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_PUCH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_iE_Extensions__item__id._const_tab = ____E_PUCH_Information_iE_Extensions__item__id_tab
    ___E_PUCH_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_PUCH_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_PUCH_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_PUCH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_iE_Extensions__item__criticality._const_tab = ____E_PUCH_Information_iE_Extensions__item__criticality_tab
    ___E_PUCH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_PUCH_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_PUCH_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_PUCH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_iE_Extensions__item__extensionValue._const_tab = ____E_PUCH_Information_iE_Extensions__item__extensionValue_tab
    ___E_PUCH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_PUCH_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_PUCH_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_PUCH_Information_iE_Extensions__item__id),
        ('criticality', ___E_PUCH_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_PUCH_Information_iE_Extensions__item__extensionValue),
        ])
    __E_PUCH_Information_iE_Extensions__item_._ext = None
    _E_PUCH_Information_iE_Extensions._cont = __E_PUCH_Information_iE_Extensions__item_
    _E_PUCH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_PUCH_Information._cont = ASN1Dict([
        ('minCR', _E_PUCH_Information_minCR),
        ('maxCR', _E_PUCH_Information_maxCR),
        ('harqInfo', _E_PUCH_Information_harqInfo),
        ('n-E-UCCH', _E_PUCH_Information_n_E_UCCH),
        ('iE-Extensions', _E_PUCH_Information_iE_Extensions),
        ])
    E_PUCH_Information._ext = []
    
    #-----< E-PUCH-Information-ExtIEs >-----#
    E_PUCH_Information_ExtIEs = CLASS(name='E-PUCH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_PUCH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-TFCS-Information-TDD >-----#
    E_TFCS_Information_TDD = SEQ(name='E-TFCS-Information-TDD', mode=MODE_TYPE)
    _E_TFCS_Information_TDD_e_DCH_QPSK_RefBetaInfo = SEQ_OF(name='e-DCH-QPSK-RefBetaInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-QPSK-RefBetaInfo')))
    _E_TFCS_Information_TDD_e_DCH_sixteenQAM_RefBetaInfo = SEQ_OF(name='e-DCH-sixteenQAM-RefBetaInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-sixteenQAM-RefBetaInfo')))
    _E_TFCS_Information_TDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_TFCS_Information_TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_TFCS_Information_TDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_TFCS_Information_TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_TFCS_Information_TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCS_Information_TDD_iE_Extensions__item__id._const_tab = ____E_TFCS_Information_TDD_iE_Extensions__item__id_tab
    ___E_TFCS_Information_TDD_iE_Extensions__item__id._const_tab_at = None
    ___E_TFCS_Information_TDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_TFCS_Information_TDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_TFCS_Information_TDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_TFCS_Information_TDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCS_Information_TDD_iE_Extensions__item__criticality._const_tab = ____E_TFCS_Information_TDD_iE_Extensions__item__criticality_tab
    ___E_TFCS_Information_TDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_TFCS_Information_TDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_TFCS_Information_TDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_TFCS_Information_TDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue._const_tab = ____E_TFCS_Information_TDD_iE_Extensions__item__extensionValue_tab
    ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_TFCS_Information_TDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_TFCS_Information_TDD_iE_Extensions__item__id),
        ('criticality', ___E_TFCS_Information_TDD_iE_Extensions__item__criticality),
        ('extensionValue', ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue),
        ])
    __E_TFCS_Information_TDD_iE_Extensions__item_._ext = None
    _E_TFCS_Information_TDD_iE_Extensions._cont = __E_TFCS_Information_TDD_iE_Extensions__item_
    _E_TFCS_Information_TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_TFCS_Information_TDD._cont = ASN1Dict([
        ('e-DCH-QPSK-RefBetaInfo', _E_TFCS_Information_TDD_e_DCH_QPSK_RefBetaInfo),
        ('e-DCH-sixteenQAM-RefBetaInfo', _E_TFCS_Information_TDD_e_DCH_sixteenQAM_RefBetaInfo),
        ('iE-Extensions', _E_TFCS_Information_TDD_iE_Extensions),
        ])
    E_TFCS_Information_TDD._ext = []
    
    #-----< E-TFCS-Information-TDD-ExtIEs >-----#
    E_TFCS_Information_TDD_ExtIEs = CLASS(name='E-TFCS-Information-TDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_TFCS_Information_TDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-QPSK-RefBetaInfo >-----#
    E_DCH_QPSK_RefBetaInfo = SEQ_OF(name='E-DCH-QPSK-RefBetaInfo', mode=MODE_TYPE)
    _E_DCH_QPSK_RefBetaInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RefBeta-Item')))
    E_DCH_QPSK_RefBetaInfo._cont = _E_DCH_QPSK_RefBetaInfo__item_
    E_DCH_QPSK_RefBetaInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-sixteenQAM-RefBetaInfo >-----#
    E_DCH_sixteenQAM_RefBetaInfo = SEQ_OF(name='E-DCH-sixteenQAM-RefBetaInfo', mode=MODE_TYPE)
    _E_DCH_sixteenQAM_RefBetaInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RefBeta-Item')))
    E_DCH_sixteenQAM_RefBetaInfo._cont = _E_DCH_sixteenQAM_RefBetaInfo__item_
    E_DCH_sixteenQAM_RefBetaInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-RefBeta-Item >-----#
    E_DCH_RefBeta_Item = SEQ(name='E-DCH-RefBeta-Item', mode=MODE_TYPE)
    _E_DCH_RefBeta_Item_refCodeRate = INT(name='refCodeRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CodeRate-short')))
    _E_DCH_RefBeta_Item_refBeta = INT(name='refBeta', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RefBeta')))
    E_DCH_RefBeta_Item._cont = ASN1Dict([
        ('refCodeRate', _E_DCH_RefBeta_Item_refCodeRate),
        ('refBeta', _E_DCH_RefBeta_Item_refBeta),
        ])
    E_DCH_RefBeta_Item._ext = None
    
    #-----< E-DCH-MACdFlows-Information-TDD >-----#
    E_DCH_MACdFlows_Information_TDD = SEQ_OF(name='E-DCH-MACdFlows-Information-TDD', mode=MODE_TYPE)
    _E_DCH_MACdFlows_Information_TDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-InfoTDDItem')))
    E_DCH_MACdFlows_Information_TDD._cont = _E_DCH_MACdFlows_Information_TDD__item_
    E_DCH_MACdFlows_Information_TDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-InfoTDDItem >-----#
    E_DCH_MACdFlow_InfoTDDItem = SEQ(name='E-DCH-MACdFlow-InfoTDDItem', mode=MODE_TYPE)
    _E_DCH_MACdFlow_InfoTDDItem_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _E_DCH_MACdFlow_InfoTDDItem_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')))
    _E_DCH_MACdFlow_InfoTDDItem_tnlQos = CHOICE(name='tnlQos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')), opt=True)
    _E_DCH_MACdFlow_InfoTDDItem_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _E_DCH_MACdFlow_InfoTDDItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _E_DCH_MACdFlow_InfoTDDItem_payloadCRC_PresenceIndicator = ENUM(name='payloadCRC-PresenceIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PayloadCRC-PresenceIndicator')))
    _E_DCH_MACdFlow_InfoTDDItem_maximum_Number_of_Retransmissions_For_E_DCH = INT(name='maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Number-of-Retransmissions-For-E-DCH')))
    _E_DCH_MACdFlow_InfoTDDItem_eDCH_HARQ_PO_TDD = INT(name='eDCH-HARQ-PO-TDD', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-PO-TDD')))
    _E_DCH_MACdFlow_InfoTDDItem_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name='eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _E_DCH_MACdFlow_InfoTDDItem_eDCH_Grant_TypeTDD = ENUM(name='eDCH-Grant-TypeTDD', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Grant-TypeTDD')))
    _E_DCH_MACdFlow_InfoTDDItem_eDCHLogicalChannelInformation = SEQ_OF(name='eDCHLogicalChannelInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LogicalChannelInformation')))
    _E_DCH_MACdFlow_InfoTDDItem_eDCH_MACdFlow_Retransmission_Timer = ENUM(name='eDCH-MACdFlow-Retransmission-Timer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer')), opt=True)
    _E_DCH_MACdFlow_InfoTDDItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality_tab
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue_tab
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id),
        ('criticality', ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlow_InfoTDDItem_iE_Extensions._cont = __E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item_
    _E_DCH_MACdFlow_InfoTDDItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlow_InfoTDDItem._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _E_DCH_MACdFlow_InfoTDDItem_e_DCH_MACdFlow_ID),
        ('allocationRetentionPriority', _E_DCH_MACdFlow_InfoTDDItem_allocationRetentionPriority),
        ('tnlQos', _E_DCH_MACdFlow_InfoTDDItem_tnlQos),
        ('bindingID', _E_DCH_MACdFlow_InfoTDDItem_bindingID),
        ('transportLayerAddress', _E_DCH_MACdFlow_InfoTDDItem_transportLayerAddress),
        ('payloadCRC-PresenceIndicator', _E_DCH_MACdFlow_InfoTDDItem_payloadCRC_PresenceIndicator),
        ('maximum-Number-of-Retransmissions-For-E-DCH', _E_DCH_MACdFlow_InfoTDDItem_maximum_Number_of_Retransmissions_For_E_DCH),
        ('eDCH-HARQ-PO-TDD', _E_DCH_MACdFlow_InfoTDDItem_eDCH_HARQ_PO_TDD),
        ('eDCH-MACdFlow-Multiplexing-List', _E_DCH_MACdFlow_InfoTDDItem_eDCH_MACdFlow_Multiplexing_List),
        ('eDCH-Grant-TypeTDD', _E_DCH_MACdFlow_InfoTDDItem_eDCH_Grant_TypeTDD),
        ('eDCHLogicalChannelInformation', _E_DCH_MACdFlow_InfoTDDItem_eDCHLogicalChannelInformation),
        ('eDCH-MACdFlow-Retransmission-Timer', _E_DCH_MACdFlow_InfoTDDItem_eDCH_MACdFlow_Retransmission_Timer),
        ('iE-Extensions', _E_DCH_MACdFlow_InfoTDDItem_iE_Extensions),
        ])
    E_DCH_MACdFlow_InfoTDDItem._ext = []
    
    #-----< E-DCH-MACdFlow-InfoTDDItem-ExtIEs >-----#
    E_DCH_MACdFlow_InfoTDDItem_ExtIEs = CLASS(name='E-DCH-MACdFlow-InfoTDDItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_MACdFlow_InfoTDDItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-MACdFlow-Retransmission-Timer >-----#
    E_DCH_MACdFlow_Retransmission_Timer = ENUM(name='E-DCH-MACdFlow-Retransmission-Timer', mode=MODE_TYPE)
    E_DCH_MACdFlow_Retransmission_Timer._cont = ASN1Dict([('ms10', 0), ('ms15', 1), ('ms20', 2), ('ms25', 3), ('ms30', 4), ('ms35', 5), ('ms40', 6), ('ms45', 7), ('ms50', 8), ('ms55', 9), ('ms60', 10), ('ms65', 11), ('ms70', 12), ('ms75', 13), ('ms80', 14), ('ms85', 15), ('ms90', 16), ('ms95', 17), ('ms100', 18), ('ms110', 19), ('ms120', 20), ('ms140', 21), ('ms160', 22), ('ms200', 23), ('ms240', 24), ('ms280', 25), ('ms320', 26), ('ms400', 27), ('ms480', 28), ('ms560', 29)])
    E_DCH_MACdFlow_Retransmission_Timer._ext = []
    
    #-----< E-DCH-HARQ-PO-TDD >-----#
    E_DCH_HARQ_PO_TDD = INT(name='E-DCH-HARQ-PO-TDD', mode=MODE_TYPE)
    E_DCH_HARQ_PO_TDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< E-DCH-Grant-TypeTDD >-----#
    E_DCH_Grant_TypeTDD = ENUM(name='E-DCH-Grant-TypeTDD', mode=MODE_TYPE)
    E_DCH_Grant_TypeTDD._cont = ASN1Dict([('scheduled', 0), ('non-scheduled', 1)])
    E_DCH_Grant_TypeTDD._ext = None
    
    #-----< E-DCH-Non-Scheduled-Grant-Info >-----#
    E_DCH_Non_Scheduled_Grant_Info = SEQ(name='E-DCH-Non-Scheduled-Grant-Info', mode=MODE_TYPE)
    _E_DCH_Non_Scheduled_Grant_Info_timeslotResource = BIT_STR(name='timeslotResource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TimeslotResource')))
    _E_DCH_Non_Scheduled_Grant_Info_powerResource = INT(name='powerResource', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerResource')))
    _E_DCH_Non_Scheduled_Grant_Info_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _E_DCH_Non_Scheduled_Grant_Info_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _E_DCH_Non_Scheduled_Grant_Info_tddE_PUCH_Offset = INT(name='tddE-PUCH-Offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TddE-PUCH-Offset')))
    _E_DCH_Non_Scheduled_Grant_Info_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _E_DCH_Non_Scheduled_Grant_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id._const_tab = ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality._const_tab = ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality_tab
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item_._ext = None
    _E_DCH_Non_Scheduled_Grant_Info_iE_Extensions._cont = __E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item_
    _E_DCH_Non_Scheduled_Grant_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Non_Scheduled_Grant_Info._cont = ASN1Dict([
        ('timeslotResource', _E_DCH_Non_Scheduled_Grant_Info_timeslotResource),
        ('powerResource', _E_DCH_Non_Scheduled_Grant_Info_powerResource),
        ('repetitionPeriod', _E_DCH_Non_Scheduled_Grant_Info_repetitionPeriod),
        ('repetitionLength', _E_DCH_Non_Scheduled_Grant_Info_repetitionLength),
        ('tddE-PUCH-Offset', _E_DCH_Non_Scheduled_Grant_Info_tddE_PUCH_Offset),
        ('tdd-ChannelisationCode', _E_DCH_Non_Scheduled_Grant_Info_tdd_ChannelisationCode),
        ('iE-Extensions', _E_DCH_Non_Scheduled_Grant_Info_iE_Extensions),
        ])
    E_DCH_Non_Scheduled_Grant_Info._ext = []
    
    #-----< E-DCH-Non-Scheduled-Grant-Info-ExtIEs >-----#
    E_DCH_Non_Scheduled_Grant_Info_ExtIEs = CLASS(name='E-DCH-Non-Scheduled-Grant-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_Non_Scheduled_Grant_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TimeslotResource >-----#
    E_DCH_TimeslotResource = BIT_STR(name='E-DCH-TimeslotResource', mode=MODE_TYPE)
    E_DCH_TimeslotResource._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    
    #-----< E-DCH-TimeslotResourceLCR >-----#
    E_DCH_TimeslotResourceLCR = BIT_STR(name='E-DCH-TimeslotResourceLCR', mode=MODE_TYPE)
    E_DCH_TimeslotResourceLCR._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< E-DCH-PowerResource >-----#
    E_DCH_PowerResource = INT(name='E-DCH-PowerResource', mode=MODE_TYPE)
    E_DCH_PowerResource._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TddE-PUCH-Offset >-----#
    TddE_PUCH_Offset = INT(name='TddE-PUCH-Offset', mode=MODE_TYPE)
    TddE_PUCH_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< E-DCH-TDD-Information >-----#
    E_DCH_TDD_Information = SEQ(name='E-DCH-TDD-Information', mode=MODE_TYPE)
    _E_DCH_TDD_Information_e_DCH_TDD_Maximum_Bitrate = INT(name='e-DCH-TDD-Maximum-Bitrate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-Maximum-Bitrate')), opt=True)
    _E_DCH_TDD_Information_e_DCH_Processing_Overload_Level = INT(name='e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _E_DCH_TDD_Information_e_DCH_PowerOffset_for_SchedulingInfo = INT(name='e-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')), opt=True)
    _E_DCH_TDD_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_TDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_TDD_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_TDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information_iE_Extensions__item__id._const_tab = ____E_DCH_TDD_Information_iE_Extensions__item__id_tab
    ___E_DCH_TDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_TDD_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_TDD_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_TDD_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_TDD_Information_iE_Extensions__item__criticality_tab
    ___E_DCH_TDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_TDD_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_TDD_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_TDD_Information_iE_Extensions__item__extensionValue_tab
    ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_TDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_TDD_Information_iE_Extensions__item__id),
        ('criticality', ___E_DCH_TDD_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_TDD_Information_iE_Extensions__item_._ext = None
    _E_DCH_TDD_Information_iE_Extensions._cont = __E_DCH_TDD_Information_iE_Extensions__item_
    _E_DCH_TDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_TDD_Information._cont = ASN1Dict([
        ('e-DCH-TDD-Maximum-Bitrate', _E_DCH_TDD_Information_e_DCH_TDD_Maximum_Bitrate),
        ('e-DCH-Processing-Overload-Level', _E_DCH_TDD_Information_e_DCH_Processing_Overload_Level),
        ('e-DCH-PowerOffset-for-SchedulingInfo', _E_DCH_TDD_Information_e_DCH_PowerOffset_for_SchedulingInfo),
        ('iE-Extensions', _E_DCH_TDD_Information_iE_Extensions),
        ])
    E_DCH_TDD_Information._ext = []
    
    #-----< E-DCH-TDD-Information-ExtIEs >-----#
    E_DCH_TDD_Information_ExtIEs = CLASS(name='E-DCH-TDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_TDD_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TDD-Maximum-Bitrate >-----#
    E_DCH_TDD_Maximum_Bitrate = INT(name='E-DCH-TDD-Maximum-Bitrate', mode=MODE_TYPE)
    E_DCH_TDD_Maximum_Bitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9201)], ev=[], er=[])
    
    #-----< E-DCH-Information-Response >-----#
    E_DCH_Information_Response = SEQ(name='E-DCH-Information-Response', mode=MODE_TYPE)
    _E_DCH_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp = SEQ_OF(name='e-DCH-TDD-MACdFlow-Specific-InformationResp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-MACdFlow-Specific-InformationResp')), opt=True)
    _E_DCH_Information_Response_e_AGCH_Specific_Information_ResponseTDD = SEQ_OF(name='e-AGCH-Specific-Information-ResponseTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Specific-InformationRespListTDD')), opt=True)
    _E_DCH_Information_Response_e_RNTI = INT(name='e-RNTI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _E_DCH_Information_Response_scheduled_E_HICH_Specific_InformationResp = SEQ_OF(name='scheduled-E-HICH-Specific-InformationResp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Scheduled-E-HICH-Specific-Information-ResponseLCRTDD')), opt=True)
    _E_DCH_Information_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Information_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Response_iE_Extensions__item__id._const_tab = ____E_DCH_Information_Response_iE_Extensions__item__id_tab
    ___E_DCH_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Information_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Information_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_Information_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Response_iE_Extensions__item__criticality._const_tab = ____E_DCH_Information_Response_iE_Extensions__item__criticality_tab
    ___E_DCH_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Information_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Information_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_Information_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Information_Response_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Information_Response_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Information_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Information_Response_iE_Extensions__item_._ext = None
    _E_DCH_Information_Response_iE_Extensions._cont = __E_DCH_Information_Response_iE_Extensions__item_
    _E_DCH_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Information_Response._cont = ASN1Dict([
        ('e-DCH-TDD-MACdFlow-Specific-InformationResp', _E_DCH_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp),
        ('e-AGCH-Specific-Information-ResponseTDD', _E_DCH_Information_Response_e_AGCH_Specific_Information_ResponseTDD),
        ('e-RNTI', _E_DCH_Information_Response_e_RNTI),
        ('scheduled-E-HICH-Specific-InformationResp', _E_DCH_Information_Response_scheduled_E_HICH_Specific_InformationResp),
        ('iE-Extensions', _E_DCH_Information_Response_iE_Extensions),
        ])
    E_DCH_Information_Response._ext = []
    
    #-----< E-DCH-Information-Response-ExtIEs >-----#
    E_DCH_Information_Response_ExtIEs = CLASS(name='E-DCH-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_Information_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Scheduled-E-HICH-Specific-Information-ResponseLCRTDD >-----#
    Scheduled_E_HICH_Specific_Information_ResponseLCRTDD = SEQ_OF(name='Scheduled-E-HICH-Specific-Information-ResponseLCRTDD', mode=MODE_TYPE)
    _Scheduled_E_HICH_Specific_Information_ResponseLCRTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Scheduled-E-HICH-Specific-InformationItem-ResponseLCRTDD')))
    Scheduled_E_HICH_Specific_Information_ResponseLCRTDD._cont = _Scheduled_E_HICH_Specific_Information_ResponseLCRTDD__item_
    Scheduled_E_HICH_Specific_Information_ResponseLCRTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Scheduled-E-HICH-Specific-InformationItem-ResponseLCRTDD >-----#
    Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD = SEQ(name='Scheduled-E-HICH-Specific-InformationItem-ResponseLCRTDD', mode=MODE_TYPE)
    _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_eI = INT(name='eI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'EI')))
    _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_e_HICH_ID_TDD = INT(name='e-HICH-ID-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-ID-TDD')))
    _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-HICH-ID-TDD')))
    ____Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 957), ('criticality', 'ignore'), ('Extension', _____Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id._const_tab = ____Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id_tab
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id._const_tab_at = None
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__criticality._const_tab = ____Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id_tab
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__extensionValue._const_tab = ____Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id_tab
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id),
        ('criticality', ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__extensionValue),
        ])
    __Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item_._ext = None
    _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions._cont = __Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item_
    _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD._cont = ASN1Dict([
        ('eI', _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_eI),
        ('e-HICH-ID-TDD', _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_e_HICH_ID_TDD),
        ('iE-Extensions', _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions),
        ])
    Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD._ext = []
    
    #-----< Scheduled-E-HICH-Specific-InformationItem-ResponseLCRTDD-ExtIEs >-----#
    Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_ExtIEs = CLASS(name='Scheduled-E-HICH-Specific-InformationItem-ResponseLCRTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-HICH-ID-TDD')))
    Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 957), ('criticality', 'ignore'), ('Extension', _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EI >-----#
    EI = INT(name='EI', mode=MODE_TYPE)
    EI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< E-HICH-ID-TDD >-----#
    E_HICH_ID_TDD = INT(name='E-HICH-ID-TDD', mode=MODE_TYPE)
    E_HICH_ID_TDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< E-HICH-Type >-----#
    E_HICH_Type = ENUM(name='E-HICH-Type', mode=MODE_TYPE)
    E_HICH_Type._cont = ASN1Dict([('scheduled', 0), ('non-scheduled', 1)])
    E_HICH_Type._ext = None
    
    #-----< E-DCH-TDD-MACdFlow-Specific-InformationResp >-----#
    E_DCH_TDD_MACdFlow_Specific_InformationResp = SEQ_OF(name='E-DCH-TDD-MACdFlow-Specific-InformationResp', mode=MODE_TYPE)
    _E_DCH_TDD_MACdFlow_Specific_InformationResp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-MACdFlow-Specific-InformationResp-Item')))
    E_DCH_TDD_MACdFlow_Specific_InformationResp._cont = _E_DCH_TDD_MACdFlow_Specific_InformationResp__item_
    E_DCH_TDD_MACdFlow_Specific_InformationResp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-TDD-MACdFlow-Specific-InformationResp-Item >-----#
    E_DCH_TDD_MACdFlow_Specific_InformationResp_Item = SEQ(name='E-DCH-TDD-MACdFlow-Specific-InformationResp-Item', mode=MODE_TYPE)
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_e_DCH_MacdFlow_Id = INT(name='e-DCH-MacdFlow-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab = ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id),
        ('criticality', ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_._ext = None
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions._cont = __E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_TDD_MACdFlow_Specific_InformationResp_Item._cont = ASN1Dict([
        ('e-DCH-MacdFlow-Id', _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_e_DCH_MacdFlow_Id),
        ('bindingID', _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_bindingID),
        ('transportLayerAddress', _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_transportLayerAddress),
        ('iE-Extensions', _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions),
        ])
    E_DCH_TDD_MACdFlow_Specific_InformationResp_Item._ext = []
    
    #-----< E-DCH-TDD-MACdFlow-Specific-InformationRespItem-ExtIEs >-----#
    E_DCH_TDD_MACdFlow_Specific_InformationRespItem_ExtIEs = CLASS(name='E-DCH-TDD-MACdFlow-Specific-InformationRespItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_TDD_MACdFlow_Specific_InformationRespItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-Specific-InformationRespListTDD >-----#
    E_AGCH_Specific_InformationRespListTDD = SEQ_OF(name='E-AGCH-Specific-InformationRespListTDD', mode=MODE_TYPE)
    _E_AGCH_Specific_InformationRespListTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Specific-InformationResp-ItemTDD')))
    E_AGCH_Specific_InformationRespListTDD._cont = _E_AGCH_Specific_InformationRespListTDD__item_
    E_AGCH_Specific_InformationRespListTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< E-AGCH-Specific-InformationResp-ItemTDD >-----#
    E_AGCH_Specific_InformationResp_ItemTDD = SEQ(name='E-AGCH-Specific-InformationResp-ItemTDD', mode=MODE_TYPE)
    _E_AGCH_Specific_InformationResp_ItemTDD_e_AGCH_Id = INT(name='e-AGCH-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Id')))
    _E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id._const_tab = ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id_tab
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality._const_tab = ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality_tab
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id),
        ('criticality', ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item_._ext = None
    _E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions._cont = __E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item_
    _E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_Specific_InformationResp_ItemTDD._cont = ASN1Dict([
        ('e-AGCH-Id', _E_AGCH_Specific_InformationResp_ItemTDD_e_AGCH_Id),
        ('iE-Extensions', _E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions),
        ])
    E_AGCH_Specific_InformationResp_ItemTDD._ext = []
    
    #-----< E-AGCH-Specific-InformationResp-ItemTDD-ExtIEs >-----#
    E_AGCH_Specific_InformationResp_ItemTDD_ExtIEs = CLASS(name='E-AGCH-Specific-InformationResp-ItemTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_AGCH_Specific_InformationResp_ItemTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-Id >-----#
    E_AGCH_Id = INT(name='E-AGCH-Id', mode=MODE_TYPE)
    E_AGCH_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=[], er=[ASN1RangeInt(lb=32, ub=255)])
    
    #-----< E-DCH-Information-Reconfig >-----#
    E_DCH_Information_Reconfig = SEQ(name='E-DCH-Information-Reconfig', mode=MODE_TYPE)
    _E_DCH_Information_Reconfig_e_PUCH_Information = SEQ(name='e-PUCH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-PUCH-Information')), opt=True)
    _E_DCH_Information_Reconfig_e_TFCS_Information_TDD = SEQ(name='e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information-TDD')), opt=True)
    _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Add = SEQ_OF(name='e-DCH-MACdFlows-to-Add', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-Information-TDD')), opt=True)
    _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Delete = SEQ_OF(name='e-DCH-MACdFlows-to-Delete', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-to-Delete')), opt=True)
    _E_DCH_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info = SEQ(name='e-DCH-Non-Scheduled-Grant-Info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Non-Scheduled-Grant-Info')), opt=True)
    _E_DCH_Information_Reconfig_e_DCH_TDD_Information = SEQ(name='e-DCH-TDD-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-Information')), opt=True)
    _E_DCH_Information_Reconfig_e_DCH_TDD_Information_to_Modify = SEQ(name='e-DCH-TDD-Information-to-Modify', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-Information-to-Modify')), opt=True)
    _E_DCH_Information_Reconfig_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Information_Reconfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Information_Reconfig_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Reconfig_iE_Extensions__item__id._const_tab = ____E_DCH_Information_Reconfig_iE_Extensions__item__id_tab
    ___E_DCH_Information_Reconfig_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Information_Reconfig_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality._const_tab = ____E_DCH_Information_Reconfig_iE_Extensions__item__criticality_tab
    ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Information_Reconfig_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Information_Reconfig_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Information_Reconfig_iE_Extensions__item_._ext = None
    _E_DCH_Information_Reconfig_iE_Extensions._cont = __E_DCH_Information_Reconfig_iE_Extensions__item_
    _E_DCH_Information_Reconfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Information_Reconfig._cont = ASN1Dict([
        ('e-PUCH-Information', _E_DCH_Information_Reconfig_e_PUCH_Information),
        ('e-TFCS-Information-TDD', _E_DCH_Information_Reconfig_e_TFCS_Information_TDD),
        ('e-DCH-MACdFlows-to-Add', _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Add),
        ('e-DCH-MACdFlows-to-Delete', _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Delete),
        ('e-DCH-Non-Scheduled-Grant-Info', _E_DCH_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info),
        ('e-DCH-TDD-Information', _E_DCH_Information_Reconfig_e_DCH_TDD_Information),
        ('e-DCH-TDD-Information-to-Modify', _E_DCH_Information_Reconfig_e_DCH_TDD_Information_to_Modify),
        ('iE-Extensions', _E_DCH_Information_Reconfig_iE_Extensions),
        ])
    E_DCH_Information_Reconfig._ext = []
    
    #-----< E-DCH-Information-Reconfig-ExtIEs >-----#
    E_DCH_Information_Reconfig_ExtIEs = CLASS(name='E-DCH-Information-Reconfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_Information_Reconfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TDD-Information-to-Modify >-----#
    E_DCH_TDD_Information_to_Modify = SEQ(name='E-DCH-TDD-Information-to-Modify', mode=MODE_TYPE)
    _E_DCH_TDD_Information_to_Modify_e_DCH_TDD_Information_to_Modify_List = SEQ_OF(name='e-DCH-TDD-Information-to-Modify-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-Information-to-Modify-List')), opt=True)
    _E_DCH_TDD_Information_to_Modify_mACeReset_Indicator = ENUM(name='mACeReset-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MACeReset-Indicator')), opt=True)
    _E_DCH_TDD_Information_to_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_TDD_Information_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDUSizeFormat')))
    _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-TS0-CapabilityLCR')))
    ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 960), ('criticality', 'reject'), ('Extension', _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1156), ('criticality', 'ignore'), ('Extension', _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id._const_tab = ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality._const_tab = ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_TDD_Information_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id),
        ('criticality', ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_TDD_Information_to_Modify_iE_Extensions__item_._ext = None
    _E_DCH_TDD_Information_to_Modify_iE_Extensions._cont = __E_DCH_TDD_Information_to_Modify_iE_Extensions__item_
    _E_DCH_TDD_Information_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_TDD_Information_to_Modify._cont = ASN1Dict([
        ('e-DCH-TDD-Information-to-Modify-List', _E_DCH_TDD_Information_to_Modify_e_DCH_TDD_Information_to_Modify_List),
        ('mACeReset-Indicator', _E_DCH_TDD_Information_to_Modify_mACeReset_Indicator),
        ('iE-Extensions', _E_DCH_TDD_Information_to_Modify_iE_Extensions),
        ])
    E_DCH_TDD_Information_to_Modify._ext = []
    
    #-----< E-DCH-TDD-Information-to-Modify-ExtIEs >-----#
    E_DCH_TDD_Information_to_Modify_ExtIEs = CLASS(name='E-DCH-TDD-Information-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDUSizeFormat')))
    _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-TS0-CapabilityLCR')))
    E_DCH_TDD_Information_to_Modify_ExtIEs._val = ASN1Set(rv=[dict([('id', 960), ('criticality', 'reject'), ('Extension', _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1156), ('criticality', 'ignore'), ('Extension', _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TDD-Information-to-Modify-List >-----#
    E_DCH_TDD_Information_to_Modify_List = SEQ_OF(name='E-DCH-TDD-Information-to-Modify-List', mode=MODE_TYPE)
    _E_DCH_TDD_Information_to_Modify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ModifyTDDItem')))
    E_DCH_TDD_Information_to_Modify_List._cont = _E_DCH_TDD_Information_to_Modify_List__item_
    E_DCH_TDD_Information_to_Modify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-ModifyTDDItem >-----#
    E_DCH_MACdFlow_ModifyTDDItem = SEQ(name='E-DCH-MACdFlow-ModifyTDDItem', mode=MODE_TYPE)
    _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _E_DCH_MACdFlow_ModifyTDDItem_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_transportBearerRequestIndicator = ENUM(name='transportBearerRequestIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    _E_DCH_MACdFlow_ModifyTDDItem_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_tnlQos = CHOICE(name='tnlQos', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_maximum_Number_of_Retransmissions_For_E_DCH = INT(name='maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Number-of-Retransmissions-For-E-DCH')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_eDCH_HARQ_PO_TDD = INT(name='eDCH-HARQ-PO-TDD', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-PO-TDD')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name='eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_eDCH_Grant_TypeTDD = ENUM(name='eDCH-Grant-TypeTDD', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Grant-TypeTDD')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToAdd = SEQ_OF(name='e-DCH-LogicalChannelToAdd', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LogicalChannelInformation')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToModify = SEQ_OF(name='e-DCH-LogicalChannelToModify', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LogicalChannelToModify')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToDelete = SEQ_OF(name='e-DCH-LogicalChannelToDelete', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LogicalChannelToDelete')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_eDCH_MACdFlow_Retransmission_Timer = ENUM(name='eDCH-MACdFlow-Retransmission-Timer', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality_tab
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue_tab
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id),
        ('criticality', ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions._cont = __E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item_
    _E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlow_ModifyTDDItem._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_MACdFlow_ID),
        ('allocationRetentionPriority', _E_DCH_MACdFlow_ModifyTDDItem_allocationRetentionPriority),
        ('transportBearerRequestIndicator', _E_DCH_MACdFlow_ModifyTDDItem_transportBearerRequestIndicator),
        ('bindingID', _E_DCH_MACdFlow_ModifyTDDItem_bindingID),
        ('transportLayerAddress', _E_DCH_MACdFlow_ModifyTDDItem_transportLayerAddress),
        ('tnlQos', _E_DCH_MACdFlow_ModifyTDDItem_tnlQos),
        ('maximum-Number-of-Retransmissions-For-E-DCH', _E_DCH_MACdFlow_ModifyTDDItem_maximum_Number_of_Retransmissions_For_E_DCH),
        ('eDCH-HARQ-PO-TDD', _E_DCH_MACdFlow_ModifyTDDItem_eDCH_HARQ_PO_TDD),
        ('eDCH-MACdFlow-Multiplexing-List', _E_DCH_MACdFlow_ModifyTDDItem_eDCH_MACdFlow_Multiplexing_List),
        ('eDCH-Grant-TypeTDD', _E_DCH_MACdFlow_ModifyTDDItem_eDCH_Grant_TypeTDD),
        ('e-DCH-LogicalChannelToAdd', _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToAdd),
        ('e-DCH-LogicalChannelToModify', _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToModify),
        ('e-DCH-LogicalChannelToDelete', _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToDelete),
        ('eDCH-MACdFlow-Retransmission-Timer', _E_DCH_MACdFlow_ModifyTDDItem_eDCH_MACdFlow_Retransmission_Timer),
        ('iE-Extensions', _E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions),
        ])
    E_DCH_MACdFlow_ModifyTDDItem._ext = []
    
    #-----< E-DCH-MACdFlow-ModifyTDDItem-ExtIEs >-----#
    E_DCH_MACdFlow_ModifyTDDItem_ExtIEs = CLASS(name='E-DCH-MACdFlow-ModifyTDDItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_MACdFlow_ModifyTDDItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Maximum-Generated-ReceivedTotalWideBandPowerInOtherCells >-----#
    Maximum_Generated_ReceivedTotalWideBandPowerInOtherCells = INT(name='Maximum-Generated-ReceivedTotalWideBandPowerInOtherCells', mode=MODE_TYPE)
    Maximum_Generated_ReceivedTotalWideBandPowerInOtherCells._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=621)], ev=None, er=[])
    
    #-----< E-DCH-768-Information >-----#
    E_DCH_768_Information = SEQ(name='E-DCH-768-Information', mode=MODE_TYPE)
    _E_DCH_768_Information_e_PUCH_Information = SEQ(name='e-PUCH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-PUCH-Information')))
    _E_DCH_768_Information_e_TFCS_Information_TDD = SEQ(name='e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information-TDD')))
    _E_DCH_768_Information_e_DCH_MACdFlows_Information_TDD = SEQ_OF(name='e-DCH-MACdFlows-Information-TDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-Information-TDD')))
    _E_DCH_768_Information_e_DCH_Non_Scheduled_Grant_Info768 = SEQ(name='e-DCH-Non-Scheduled-Grant-Info768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Non-Scheduled-Grant-Info768')), opt=True)
    _E_DCH_768_Information_e_DCH_TDD_Information768 = SEQ(name='e-DCH-TDD-Information768', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-Information768')))
    _E_DCH_768_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_768_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_768_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_768_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_iE_Extensions__item__id._const_tab = ____E_DCH_768_Information_iE_Extensions__item__id_tab
    ___E_DCH_768_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_768_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_768_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_768_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_768_Information_iE_Extensions__item__criticality_tab
    ___E_DCH_768_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_768_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_768_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_768_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_768_Information_iE_Extensions__item__extensionValue_tab
    ___E_DCH_768_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_768_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_768_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_768_Information_iE_Extensions__item__id),
        ('criticality', ___E_DCH_768_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_768_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_768_Information_iE_Extensions__item_._ext = None
    _E_DCH_768_Information_iE_Extensions._cont = __E_DCH_768_Information_iE_Extensions__item_
    _E_DCH_768_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_768_Information._cont = ASN1Dict([
        ('e-PUCH-Information', _E_DCH_768_Information_e_PUCH_Information),
        ('e-TFCS-Information-TDD', _E_DCH_768_Information_e_TFCS_Information_TDD),
        ('e-DCH-MACdFlows-Information-TDD', _E_DCH_768_Information_e_DCH_MACdFlows_Information_TDD),
        ('e-DCH-Non-Scheduled-Grant-Info768', _E_DCH_768_Information_e_DCH_Non_Scheduled_Grant_Info768),
        ('e-DCH-TDD-Information768', _E_DCH_768_Information_e_DCH_TDD_Information768),
        ('iE-Extensions', _E_DCH_768_Information_iE_Extensions),
        ])
    E_DCH_768_Information._ext = []
    
    #-----< E-DCH-768-Information-ExtIEs >-----#
    E_DCH_768_Information_ExtIEs = CLASS(name='E-DCH-768-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_768_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Non-Scheduled-Grant-Info768 >-----#
    E_DCH_Non_Scheduled_Grant_Info768 = SEQ(name='E-DCH-Non-Scheduled-Grant-Info768', mode=MODE_TYPE)
    _E_DCH_Non_Scheduled_Grant_Info768_timeslotResource = BIT_STR(name='timeslotResource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TimeslotResource')))
    _E_DCH_Non_Scheduled_Grant_Info768_powerResource = INT(name='powerResource', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerResource')))
    _E_DCH_Non_Scheduled_Grant_Info768_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _E_DCH_Non_Scheduled_Grant_Info768_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _E_DCH_Non_Scheduled_Grant_Info768_tddE_PUCH_Offset = INT(name='tddE-PUCH-Offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TddE-PUCH-Offset')))
    _E_DCH_Non_Scheduled_Grant_Info768_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id._const_tab = ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality._const_tab = ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality_tab
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item_._ext = None
    _E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions._cont = __E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item_
    _E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Non_Scheduled_Grant_Info768._cont = ASN1Dict([
        ('timeslotResource', _E_DCH_Non_Scheduled_Grant_Info768_timeslotResource),
        ('powerResource', _E_DCH_Non_Scheduled_Grant_Info768_powerResource),
        ('repetitionPeriod', _E_DCH_Non_Scheduled_Grant_Info768_repetitionPeriod),
        ('repetitionLength', _E_DCH_Non_Scheduled_Grant_Info768_repetitionLength),
        ('tddE-PUCH-Offset', _E_DCH_Non_Scheduled_Grant_Info768_tddE_PUCH_Offset),
        ('tdd-ChannelisationCode768', _E_DCH_Non_Scheduled_Grant_Info768_tdd_ChannelisationCode768),
        ('iE-Extensions', _E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions),
        ])
    E_DCH_Non_Scheduled_Grant_Info768._ext = []
    
    #-----< E-DCH-Non-Scheduled-Grant-Info768-ExtIEs >-----#
    E_DCH_Non_Scheduled_Grant_Info768_ExtIEs = CLASS(name='E-DCH-Non-Scheduled-Grant-Info768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_Non_Scheduled_Grant_Info768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TDD-Information768 >-----#
    E_DCH_TDD_Information768 = SEQ(name='E-DCH-TDD-Information768', mode=MODE_TYPE)
    _E_DCH_TDD_Information768_e_DCH_TDD_Maximum_Bitrate768 = INT(name='e-DCH-TDD-Maximum-Bitrate768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-Maximum-Bitrate768')), opt=True)
    _E_DCH_TDD_Information768_e_DCH_Processing_Overload_Level = INT(name='e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _E_DCH_TDD_Information768_e_DCH_PowerOffset_for_SchedulingInfo = INT(name='e-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')), opt=True)
    _E_DCH_TDD_Information768_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_TDD_Information768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_TDD_Information768_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_TDD_Information768_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information768_iE_Extensions__item__id._const_tab = ____E_DCH_TDD_Information768_iE_Extensions__item__id_tab
    ___E_DCH_TDD_Information768_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_TDD_Information768_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_TDD_Information768_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_TDD_Information768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information768_iE_Extensions__item__criticality._const_tab = ____E_DCH_TDD_Information768_iE_Extensions__item__criticality_tab
    ___E_DCH_TDD_Information768_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_TDD_Information768_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_TDD_Information768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_TDD_Information768_iE_Extensions__item__extensionValue_tab
    ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_TDD_Information768_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_TDD_Information768_iE_Extensions__item__id),
        ('criticality', ___E_DCH_TDD_Information768_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_TDD_Information768_iE_Extensions__item_._ext = None
    _E_DCH_TDD_Information768_iE_Extensions._cont = __E_DCH_TDD_Information768_iE_Extensions__item_
    _E_DCH_TDD_Information768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_TDD_Information768._cont = ASN1Dict([
        ('e-DCH-TDD-Maximum-Bitrate768', _E_DCH_TDD_Information768_e_DCH_TDD_Maximum_Bitrate768),
        ('e-DCH-Processing-Overload-Level', _E_DCH_TDD_Information768_e_DCH_Processing_Overload_Level),
        ('e-DCH-PowerOffset-for-SchedulingInfo', _E_DCH_TDD_Information768_e_DCH_PowerOffset_for_SchedulingInfo),
        ('iE-Extensions', _E_DCH_TDD_Information768_iE_Extensions),
        ])
    E_DCH_TDD_Information768._ext = []
    
    #-----< E-DCH-TDD-Information768-ExtIEs >-----#
    E_DCH_TDD_Information768_ExtIEs = CLASS(name='E-DCH-TDD-Information768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_TDD_Information768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TDD-Maximum-Bitrate768 >-----#
    E_DCH_TDD_Maximum_Bitrate768 = INT(name='E-DCH-TDD-Maximum-Bitrate768', mode=MODE_TYPE)
    E_DCH_TDD_Maximum_Bitrate768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=17713)], ev=[], er=[])
    
    #-----< E-DCH-768-Information-Reconfig >-----#
    E_DCH_768_Information_Reconfig = SEQ(name='E-DCH-768-Information-Reconfig', mode=MODE_TYPE)
    _E_DCH_768_Information_Reconfig_e_PUCH_Information = SEQ(name='e-PUCH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-PUCH-Information')), opt=True)
    _E_DCH_768_Information_Reconfig_e_TFCS_Information_TDD = SEQ(name='e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information-TDD')), opt=True)
    _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Add = SEQ_OF(name='e-DCH-MACdFlows-to-Add', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-Information-TDD')), opt=True)
    _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Delete = SEQ_OF(name='e-DCH-MACdFlows-to-Delete', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-to-Delete')), opt=True)
    _E_DCH_768_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info768 = SEQ(name='e-DCH-Non-Scheduled-Grant-Info768', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Non-Scheduled-Grant-Info768')), opt=True)
    _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information768 = SEQ(name='e-DCH-TDD-Information768', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-Information768')), opt=True)
    _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information_to_Modify = SEQ(name='e-DCH-TDD-Information-to-Modify', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-Information-to-Modify')), opt=True)
    _E_DCH_768_Information_Reconfig_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_768_Information_Reconfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id._const_tab = ____E_DCH_768_Information_Reconfig_iE_Extensions__item__id_tab
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality._const_tab = ____E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality_tab
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue_tab
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_768_Information_Reconfig_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id),
        ('criticality', ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_768_Information_Reconfig_iE_Extensions__item_._ext = None
    _E_DCH_768_Information_Reconfig_iE_Extensions._cont = __E_DCH_768_Information_Reconfig_iE_Extensions__item_
    _E_DCH_768_Information_Reconfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_768_Information_Reconfig._cont = ASN1Dict([
        ('e-PUCH-Information', _E_DCH_768_Information_Reconfig_e_PUCH_Information),
        ('e-TFCS-Information-TDD', _E_DCH_768_Information_Reconfig_e_TFCS_Information_TDD),
        ('e-DCH-MACdFlows-to-Add', _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Add),
        ('e-DCH-MACdFlows-to-Delete', _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Delete),
        ('e-DCH-Non-Scheduled-Grant-Info768', _E_DCH_768_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info768),
        ('e-DCH-TDD-Information768', _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information768),
        ('e-DCH-TDD-Information-to-Modify', _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information_to_Modify),
        ('iE-Extensions', _E_DCH_768_Information_Reconfig_iE_Extensions),
        ])
    E_DCH_768_Information_Reconfig._ext = []
    
    #-----< E-DCH-768-Information-Reconfig-ExtIEs >-----#
    E_DCH_768_Information_Reconfig_ExtIEs = CLASS(name='E-DCH-768-Information-Reconfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_768_Information_Reconfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-LCR-Information >-----#
    E_DCH_LCR_Information = SEQ(name='E-DCH-LCR-Information', mode=MODE_TYPE)
    _E_DCH_LCR_Information_e_PUCH_LCR_Information = SEQ(name='e-PUCH-LCR-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-PUCH-LCR-Information')))
    _E_DCH_LCR_Information_e_TFCS_Information_TDD = SEQ(name='e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information-TDD')))
    _E_DCH_LCR_Information_e_DCH_MACdFlows_Information_TDD = SEQ_OF(name='e-DCH-MACdFlows-Information-TDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-Information-TDD')))
    _E_DCH_LCR_Information_e_DCH_Non_Scheduled_Grant_LCR_Info = SEQ(name='e-DCH-Non-Scheduled-Grant-LCR-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Non-Scheduled-Grant-LCR-Info')), opt=True)
    _E_DCH_LCR_Information_e_DCH_LCRTDD_Information = SEQ(name='e-DCH-LCRTDD-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LCRTDD-Information')))
    _E_DCH_LCR_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LCR_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LCR_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_LCR_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_iE_Extensions__item__id._const_tab = ____E_DCH_LCR_Information_iE_Extensions__item__id_tab
    ___E_DCH_LCR_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LCR_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_LCR_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_LCR_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_LCR_Information_iE_Extensions__item__criticality_tab
    ___E_DCH_LCR_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_LCR_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_LCR_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LCR_Information_iE_Extensions__item__extensionValue_tab
    ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_LCR_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_LCR_Information_iE_Extensions__item__id),
        ('criticality', ___E_DCH_LCR_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LCR_Information_iE_Extensions__item_._ext = None
    _E_DCH_LCR_Information_iE_Extensions._cont = __E_DCH_LCR_Information_iE_Extensions__item_
    _E_DCH_LCR_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LCR_Information._cont = ASN1Dict([
        ('e-PUCH-LCR-Information', _E_DCH_LCR_Information_e_PUCH_LCR_Information),
        ('e-TFCS-Information-TDD', _E_DCH_LCR_Information_e_TFCS_Information_TDD),
        ('e-DCH-MACdFlows-Information-TDD', _E_DCH_LCR_Information_e_DCH_MACdFlows_Information_TDD),
        ('e-DCH-Non-Scheduled-Grant-LCR-Info', _E_DCH_LCR_Information_e_DCH_Non_Scheduled_Grant_LCR_Info),
        ('e-DCH-LCRTDD-Information', _E_DCH_LCR_Information_e_DCH_LCRTDD_Information),
        ('iE-Extensions', _E_DCH_LCR_Information_iE_Extensions),
        ])
    E_DCH_LCR_Information._ext = []
    
    #-----< E-DCH-LCR-Information-ExtIEs >-----#
    E_DCH_LCR_Information_ExtIEs = CLASS(name='E-DCH-LCR-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_LCR_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-PUCH-LCR-Information >-----#
    E_PUCH_LCR_Information = SEQ(name='E-PUCH-LCR-Information', mode=MODE_TYPE)
    _E_PUCH_LCR_Information_minCR = INT(name='minCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CodeRate')))
    _E_PUCH_LCR_Information_maxCR = INT(name='maxCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CodeRate')))
    _E_PUCH_LCR_Information_harqInfo = ENUM(name='harqInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Info-for-E-DCH')))
    _E_PUCH_LCR_Information_pRXdes_base = INT(name='pRXdes-base', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PRXdes-base')))
    _E_PUCH_LCR_Information_e_PUCH_TPC_StepSize = ENUM(name='e-PUCH-TPC-StepSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _E_PUCH_LCR_Information_e_AGCH_TPC_StepSize = ENUM(name='e-AGCH-TPC-StepSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _E_PUCH_LCR_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_PUCH_LCR_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_PUCH_LCR_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_PUCH_LCR_Information_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 965), ('criticality', 'ignore'), ('Extension', _____E_PUCH_LCR_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_PUCH_LCR_Information_iE_Extensions__item__id._const_tab = ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab
    ___E_PUCH_LCR_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_PUCH_LCR_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_PUCH_LCR_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_PUCH_LCR_Information_iE_Extensions__item__criticality._const_tab = ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab
    ___E_PUCH_LCR_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_PUCH_LCR_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab = ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab
    ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_PUCH_LCR_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_PUCH_LCR_Information_iE_Extensions__item__id),
        ('criticality', ___E_PUCH_LCR_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue),
        ])
    __E_PUCH_LCR_Information_iE_Extensions__item_._ext = None
    _E_PUCH_LCR_Information_iE_Extensions._cont = __E_PUCH_LCR_Information_iE_Extensions__item_
    _E_PUCH_LCR_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_PUCH_LCR_Information._cont = ASN1Dict([
        ('minCR', _E_PUCH_LCR_Information_minCR),
        ('maxCR', _E_PUCH_LCR_Information_maxCR),
        ('harqInfo', _E_PUCH_LCR_Information_harqInfo),
        ('pRXdes-base', _E_PUCH_LCR_Information_pRXdes_base),
        ('e-PUCH-TPC-StepSize', _E_PUCH_LCR_Information_e_PUCH_TPC_StepSize),
        ('e-AGCH-TPC-StepSize', _E_PUCH_LCR_Information_e_AGCH_TPC_StepSize),
        ('iE-Extensions', _E_PUCH_LCR_Information_iE_Extensions),
        ])
    E_PUCH_LCR_Information._ext = []
    
    #-----< E-PUCH-LCR-Information-ExtIEs >-----#
    E_PUCH_LCR_Information_ExtIEs = CLASS(name='E-PUCH-LCR-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_PUCH_LCR_Information_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    E_PUCH_LCR_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 965), ('criticality', 'ignore'), ('Extension', _E_PUCH_LCR_Information_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Non-Scheduled-Grant-LCR-Info >-----#
    E_DCH_Non_Scheduled_Grant_LCR_Info = SEQ(name='E-DCH-Non-Scheduled-Grant-LCR-Info', mode=MODE_TYPE)
    _E_DCH_Non_Scheduled_Grant_LCR_Info_timeslotResourceLCR = BIT_STR(name='timeslotResourceLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TimeslotResourceLCR')))
    _E_DCH_Non_Scheduled_Grant_LCR_Info_powerResource = INT(name='powerResource', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerResource')))
    _E_DCH_Non_Scheduled_Grant_LCR_Info_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _E_DCH_Non_Scheduled_Grant_LCR_Info_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _E_DCH_Non_Scheduled_Grant_LCR_Info_subframeNumber = ENUM(name='subframeNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_DCH_Non_Scheduled_Grant_LCR_Info_subframeNumber._cont = ASN1Dict([('v0', 0), ('v1', 1)])
    _E_DCH_Non_Scheduled_Grant_LCR_Info_subframeNumber._ext = None
    _E_DCH_Non_Scheduled_Grant_LCR_Info_tddE_PUCH_Offset = INT(name='tddE-PUCH-Offset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TddE-PUCH-Offset')))
    _E_DCH_Non_Scheduled_Grant_LCR_Info_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _E_DCH_Non_Scheduled_Grant_LCR_Info_n_E_UCCHLCR = INT(name='n-E-UCCHLCR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'N-E-UCCHLCR')))
    _E_DCH_Non_Scheduled_Grant_LCR_Info_e_HICH_LCR_Information = SEQ(name='e-HICH-LCR-Information', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-LCR-Information')))
    _E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__id._const_tab = ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__criticality._const_tab = ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__criticality_tab
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item_._ext = None
    _E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions._cont = __E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item_
    _E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Non_Scheduled_Grant_LCR_Info._cont = ASN1Dict([
        ('timeslotResourceLCR', _E_DCH_Non_Scheduled_Grant_LCR_Info_timeslotResourceLCR),
        ('powerResource', _E_DCH_Non_Scheduled_Grant_LCR_Info_powerResource),
        ('repetitionPeriod', _E_DCH_Non_Scheduled_Grant_LCR_Info_repetitionPeriod),
        ('repetitionLength', _E_DCH_Non_Scheduled_Grant_LCR_Info_repetitionLength),
        ('subframeNumber', _E_DCH_Non_Scheduled_Grant_LCR_Info_subframeNumber),
        ('tddE-PUCH-Offset', _E_DCH_Non_Scheduled_Grant_LCR_Info_tddE_PUCH_Offset),
        ('tdd-ChannelisationCode', _E_DCH_Non_Scheduled_Grant_LCR_Info_tdd_ChannelisationCode),
        ('n-E-UCCHLCR', _E_DCH_Non_Scheduled_Grant_LCR_Info_n_E_UCCHLCR),
        ('e-HICH-LCR-Information', _E_DCH_Non_Scheduled_Grant_LCR_Info_e_HICH_LCR_Information),
        ('iE-Extensions', _E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions),
        ])
    E_DCH_Non_Scheduled_Grant_LCR_Info._ext = []
    
    #-----< E-DCH-Non-Scheduled-Grant-LCR-Info-ExtIEs >-----#
    E_DCH_Non_Scheduled_Grant_LCR_Info_ExtIEs = CLASS(name='E-DCH-Non-Scheduled-Grant-LCR-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_Non_Scheduled_Grant_LCR_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-LCR-Information >-----#
    E_HICH_LCR_Information = SEQ(name='E-HICH-LCR-Information', mode=MODE_TYPE)
    _E_HICH_LCR_Information_e_HICH_ID_TDD = INT(name='e-HICH-ID-TDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-ID-TDD')))
    _E_HICH_LCR_Information_signatureSequenceGroupIndex = INT(name='signatureSequenceGroupIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SignatureSequenceGroupIndex')))
    _E_HICH_LCR_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_HICH_LCR_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_HICH_LCR_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_HICH_LCR_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_HICH_LCR_Information_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-HICH-ID-TDD')))
    ____E_HICH_LCR_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 957), ('criticality', 'ignore'), ('Extension', _____E_HICH_LCR_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_HICH_LCR_Information_iE_Extensions__item__id._const_tab = ____E_HICH_LCR_Information_iE_Extensions__item__id_tab
    ___E_HICH_LCR_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_HICH_LCR_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_HICH_LCR_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_HICH_LCR_Information_iE_Extensions__item__criticality._const_tab = ____E_HICH_LCR_Information_iE_Extensions__item__id_tab
    ___E_HICH_LCR_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_HICH_LCR_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_HICH_LCR_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_HICH_LCR_Information_iE_Extensions__item__extensionValue._const_tab = ____E_HICH_LCR_Information_iE_Extensions__item__id_tab
    ___E_HICH_LCR_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_HICH_LCR_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_HICH_LCR_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_HICH_LCR_Information_iE_Extensions__item__id),
        ('criticality', ___E_HICH_LCR_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_HICH_LCR_Information_iE_Extensions__item__extensionValue),
        ])
    __E_HICH_LCR_Information_iE_Extensions__item_._ext = None
    _E_HICH_LCR_Information_iE_Extensions._cont = __E_HICH_LCR_Information_iE_Extensions__item_
    _E_HICH_LCR_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_HICH_LCR_Information._cont = ASN1Dict([
        ('e-HICH-ID-TDD', _E_HICH_LCR_Information_e_HICH_ID_TDD),
        ('signatureSequenceGroupIndex', _E_HICH_LCR_Information_signatureSequenceGroupIndex),
        ('iE-Extensions', _E_HICH_LCR_Information_iE_Extensions),
        ])
    E_HICH_LCR_Information._ext = []
    
    #-----< E-HICH-LCR-Information-ExtIEs >-----#
    E_HICH_LCR_Information_ExtIEs = CLASS(name='E-HICH-LCR-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_HICH_LCR_Information_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-HICH-ID-TDD')))
    E_HICH_LCR_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 957), ('criticality', 'ignore'), ('Extension', _E_HICH_LCR_Information_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-LCRTDD-Information >-----#
    E_DCH_LCRTDD_Information = SEQ(name='E-DCH-LCRTDD-Information', mode=MODE_TYPE)
    _E_DCH_LCRTDD_Information_e_DCH_LCRTDD_PhysicalLayerCategory = INT(name='e-DCH-LCRTDD-PhysicalLayerCategory', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LCRTDD-PhysicalLayerCategory')), opt=True)
    _E_DCH_LCRTDD_Information_e_DCH_Processing_Overload_Level = INT(name='e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _E_DCH_LCRTDD_Information_e_DCH_PowerOffset_for_SchedulingInfo = INT(name='e-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')), opt=True)
    _E_DCH_LCRTDD_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LCRTDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-DCH-LCRTDD-PhysicalLayerCategory')))
    _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Number-of-Retransmissions-For-E-DCH')))
    _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer')))
    _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-UE-Inactivity-Monitor-Threshold')))
    _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SNPL-Carrier-Group-Indicator')))
    _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory')))
    _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-TS0-CapabilityLCR')))
    ____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 952), ('criticality', 'reject'), ('Extension', _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 961), ('criticality', 'ignore'), ('Extension', _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 962), ('criticality', 'ignore'), ('Extension', _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1059), ('criticality', 'ignore'), ('Extension', _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1190), ('criticality', 'ignore'), ('Extension', _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1198), ('criticality', 'reject'), ('Extension', _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1156), ('criticality', 'ignore'), ('Extension', _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__id._const_tab = ____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_LCRTDD_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_LCRTDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_LCRTDD_Information_iE_Extensions__item__id),
        ('criticality', ___E_DCH_LCRTDD_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_LCRTDD_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LCRTDD_Information_iE_Extensions__item_._ext = None
    _E_DCH_LCRTDD_Information_iE_Extensions._cont = __E_DCH_LCRTDD_Information_iE_Extensions__item_
    _E_DCH_LCRTDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LCRTDD_Information._cont = ASN1Dict([
        ('e-DCH-LCRTDD-PhysicalLayerCategory', _E_DCH_LCRTDD_Information_e_DCH_LCRTDD_PhysicalLayerCategory),
        ('e-DCH-Processing-Overload-Level', _E_DCH_LCRTDD_Information_e_DCH_Processing_Overload_Level),
        ('e-DCH-PowerOffset-for-SchedulingInfo', _E_DCH_LCRTDD_Information_e_DCH_PowerOffset_for_SchedulingInfo),
        ('iE-Extensions', _E_DCH_LCRTDD_Information_iE_Extensions),
        ])
    E_DCH_LCRTDD_Information._ext = []
    
    #-----< E-DCH-LCRTDD-Information-ExtIEs >-----#
    E_DCH_LCRTDD_Information_ExtIEs = CLASS(name='E-DCH-LCRTDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-DCH-LCRTDD-PhysicalLayerCategory')))
    _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Number-of-Retransmissions-For-E-DCH')))
    _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer')))
    _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-UE-Inactivity-Monitor-Threshold')))
    _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SNPL-Carrier-Group-Indicator')))
    _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory')))
    _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-TS0-CapabilityLCR')))
    E_DCH_LCRTDD_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 952), ('criticality', 'reject'), ('Extension', _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 961), ('criticality', 'ignore'), ('Extension', _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 962), ('criticality', 'ignore'), ('Extension', _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1059), ('criticality', 'ignore'), ('Extension', _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1190), ('criticality', 'ignore'), ('Extension', _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1198), ('criticality', 'reject'), ('Extension', _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 1156), ('criticality', 'ignore'), ('Extension', _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-LCRTDD-PhysicalLayerCategory >-----#
    E_DCH_LCRTDD_PhysicalLayerCategory = INT(name='E-DCH-LCRTDD-PhysicalLayerCategory', mode=MODE_TYPE)
    E_DCH_LCRTDD_PhysicalLayerCategory._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< E-DCH-LCR-Information-Reconfig >-----#
    E_DCH_LCR_Information_Reconfig = SEQ(name='E-DCH-LCR-Information-Reconfig', mode=MODE_TYPE)
    _E_DCH_LCR_Information_Reconfig_e_PUCH_LCR_Information = SEQ(name='e-PUCH-LCR-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-PUCH-LCR-Information')), opt=True)
    _E_DCH_LCR_Information_Reconfig_e_TFCS_Information_TDD = SEQ(name='e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information-TDD')), opt=True)
    _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Add = SEQ_OF(name='e-DCH-MACdFlows-to-Add', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-Information-TDD')), opt=True)
    _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Delete = SEQ_OF(name='e-DCH-MACdFlows-to-Delete', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-to-Delete')), opt=True)
    _E_DCH_LCR_Information_Reconfig_e_DCH_Non_Scheduled_Grant_LCR_Info = SEQ(name='e-DCH-Non-Scheduled-Grant-LCR-Info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Non-Scheduled-Grant-LCR-Info')), opt=True)
    _E_DCH_LCR_Information_Reconfig_e_DCH_LCRTDD_Information = SEQ(name='e-DCH-LCRTDD-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LCRTDD-Information')), opt=True)
    _E_DCH_LCR_Information_Reconfig_e_DCH_TDD_Information_to_Modify = SEQ(name='e-DCH-TDD-Information-to-Modify', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-Information-to-Modify')), opt=True)
    _E_DCH_LCR_Information_Reconfig_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LCR_Information_Reconfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id._const_tab = ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id_tab
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality._const_tab = ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality_tab
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue_tab
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_LCR_Information_Reconfig_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id),
        ('criticality', ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LCR_Information_Reconfig_iE_Extensions__item_._ext = None
    _E_DCH_LCR_Information_Reconfig_iE_Extensions._cont = __E_DCH_LCR_Information_Reconfig_iE_Extensions__item_
    _E_DCH_LCR_Information_Reconfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LCR_Information_Reconfig._cont = ASN1Dict([
        ('e-PUCH-LCR-Information', _E_DCH_LCR_Information_Reconfig_e_PUCH_LCR_Information),
        ('e-TFCS-Information-TDD', _E_DCH_LCR_Information_Reconfig_e_TFCS_Information_TDD),
        ('e-DCH-MACdFlows-to-Add', _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Add),
        ('e-DCH-MACdFlows-to-Delete', _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Delete),
        ('e-DCH-Non-Scheduled-Grant-LCR-Info', _E_DCH_LCR_Information_Reconfig_e_DCH_Non_Scheduled_Grant_LCR_Info),
        ('e-DCH-LCRTDD-Information', _E_DCH_LCR_Information_Reconfig_e_DCH_LCRTDD_Information),
        ('e-DCH-TDD-Information-to-Modify', _E_DCH_LCR_Information_Reconfig_e_DCH_TDD_Information_to_Modify),
        ('iE-Extensions', _E_DCH_LCR_Information_Reconfig_iE_Extensions),
        ])
    E_DCH_LCR_Information_Reconfig._ext = []
    
    #-----< E-DCH-LCR-Information-Reconfig-ExtIEs >-----#
    E_DCH_LCR_Information_Reconfig_ExtIEs = CLASS(name='E-DCH-LCR-Information-Reconfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_DCH_LCR_Information_Reconfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Enabling-Delay >-----#
    Enabling_Delay = ENUM(name='Enabling-Delay', mode=MODE_TYPE)
    Enabling_Delay._cont = ASN1Dict([('v0', 0), ('v1', 1), ('v2', 2), ('v4', 3), ('v8', 4), ('v16', 5), ('v32', 6), ('v64', 7), ('v128', 8)])
    Enabling_Delay._ext = None
    
    #-----< Enabling-Delay-Ext-LCR >-----#
    Enabling_Delay_Ext_LCR = ENUM(name='Enabling-Delay-Ext-LCR', mode=MODE_TYPE)
    Enabling_Delay_Ext_LCR._cont = ASN1Dict([('infinity', 0)])
    Enabling_Delay_Ext_LCR._ext = []
    
    #-----< DormantModeIndicator >-----#
    DormantModeIndicator = ENUM(name='DormantModeIndicator', mode=MODE_TYPE)
    DormantModeIndicator._cont = ASN1Dict([('enterDormantMode', 0), ('leaveDormantMode', 1)])
    DormantModeIndicator._ext = []
    
    #-----< Enhanced-FACH-Capability >-----#
    Enhanced_FACH_Capability = ENUM(name='Enhanced-FACH-Capability', mode=MODE_TYPE)
    Enhanced_FACH_Capability._cont = ASN1Dict([('enhanced-FACH-capable', 0), ('enhanced-FACH-non-capable', 1)])
    Enhanced_FACH_Capability._ext = None
    
    #-----< EnhancedHSServingCC-Abort >-----#
    EnhancedHSServingCC_Abort = ENUM(name='EnhancedHSServingCC-Abort', mode=MODE_TYPE)
    EnhancedHSServingCC_Abort._cont = ASN1Dict([('abortEnhancedHSServingCC', 0)])
    EnhancedHSServingCC_Abort._ext = []
    
    #-----< Enhanced-PCH-Capability >-----#
    Enhanced_PCH_Capability = ENUM(name='Enhanced-PCH-Capability', mode=MODE_TYPE)
    Enhanced_PCH_Capability._cont = ASN1Dict([('enhanced-PCH-capable', 0), ('enhanced-PCH-non-capable', 1)])
    Enhanced_PCH_Capability._ext = None
    
    #-----< Enhanced-UE-DRX-Capability >-----#
    Enhanced_UE_DRX_Capability = ENUM(name='Enhanced-UE-DRX-Capability', mode=MODE_TYPE)
    Enhanced_UE_DRX_Capability._cont = ASN1Dict([('enhanced-UE-DRX-capable', 0), ('enhanced-UE-DRX-non-capable', 1)])
    Enhanced_UE_DRX_Capability._ext = None
    
    #-----< Enhanced-UE-DRX-InformationFDD >-----#
    Enhanced_UE_DRX_InformationFDD = SEQ(name='Enhanced-UE-DRX-InformationFDD', mode=MODE_TYPE)
    _Enhanced_UE_DRX_InformationFDD_t321 = ENUM(name='t321', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T321')))
    _Enhanced_UE_DRX_InformationFDD_hS_DSCH_DRX_Cycle_FACH = ENUM(name='hS-DSCH-DRX-Cycle-FACH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-DRX-Cycle-FACH')))
    _Enhanced_UE_DRX_InformationFDD_hS_DSCH_RX_Burst_FACH = ENUM(name='hS-DSCH-RX-Burst-FACH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-RX-Burst-FACH')))
    _Enhanced_UE_DRX_InformationFDD_dRX_Interruption_by_HS_DSCH = ENUM(name='dRX-Interruption-by-HS-DSCH', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DRX-Interruption-by-HS-DSCH')))
    _Enhanced_UE_DRX_InformationFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Enhanced_UE_DRX_InformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id._const_tab = ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id_tab
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality._const_tab = ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality_tab
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue._const_tab = ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Enhanced_UE_DRX_InformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id),
        ('criticality', ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue),
        ])
    __Enhanced_UE_DRX_InformationFDD_iE_Extensions__item_._ext = None
    _Enhanced_UE_DRX_InformationFDD_iE_Extensions._cont = __Enhanced_UE_DRX_InformationFDD_iE_Extensions__item_
    _Enhanced_UE_DRX_InformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Enhanced_UE_DRX_InformationFDD._cont = ASN1Dict([
        ('t321', _Enhanced_UE_DRX_InformationFDD_t321),
        ('hS-DSCH-DRX-Cycle-FACH', _Enhanced_UE_DRX_InformationFDD_hS_DSCH_DRX_Cycle_FACH),
        ('hS-DSCH-RX-Burst-FACH', _Enhanced_UE_DRX_InformationFDD_hS_DSCH_RX_Burst_FACH),
        ('dRX-Interruption-by-HS-DSCH', _Enhanced_UE_DRX_InformationFDD_dRX_Interruption_by_HS_DSCH),
        ('iE-Extensions', _Enhanced_UE_DRX_InformationFDD_iE_Extensions),
        ])
    Enhanced_UE_DRX_InformationFDD._ext = []
    
    #-----< Enhanced-UE-DRX-InformationFDD-ExtIEs >-----#
    Enhanced_UE_DRX_InformationFDD_ExtIEs = CLASS(name='Enhanced-UE-DRX-InformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Enhanced_UE_DRX_InformationFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extended-E-DCH-LCRTDD-PhysicalLayerCategory >-----#
    Extended_E_DCH_LCRTDD_PhysicalLayerCategory = INT(name='Extended-E-DCH-LCRTDD-PhysicalLayerCategory', mode=MODE_TYPE)
    Extended_E_DCH_LCRTDD_PhysicalLayerCategory._const_val = ASN1Set(rv=[6], rr=[], ev=[], er=[])
    
    #-----< Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory >-----#
    Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory = INT(name='Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory', mode=MODE_TYPE)
    Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    
    #-----< Ext-Max-Bits-MACe-PDU-non-scheduled >-----#
    Ext_Max_Bits_MACe_PDU_non_scheduled = INT(name='Ext-Max-Bits-MACe-PDU-non-scheduled', mode=MODE_TYPE)
    Ext_Max_Bits_MACe_PDU_non_scheduled._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=19983, ub=22978)], ev=[], er=[ASN1RangeInt(lb=22979, ub=34507)])
    
    #-----< Ext-Reference-E-TFCI-PO >-----#
    Ext_Reference_E_TFCI_PO = INT(name='Ext-Reference-E-TFCI-PO', mode=MODE_TYPE)
    Ext_Reference_E_TFCI_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=30, ub=31)], ev=[], er=[])
    
    #-----< ExtendedPropagationDelay >-----#
    ExtendedPropagationDelay = INT(name='ExtendedPropagationDelay', mode=MODE_TYPE)
    ExtendedPropagationDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=255, ub=1023)], ev=None, er=[])
    
    #-----< Extended-RNC-ID >-----#
    Extended_RNC_ID = INT(name='Extended-RNC-ID', mode=MODE_TYPE)
    Extended_RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4096, ub=65535)], ev=None, er=[])
    
    #-----< Extended-Round-Trip-Time-Value >-----#
    Extended_Round_Trip_Time_Value = INT(name='Extended-Round-Trip-Time-Value', mode=MODE_TYPE)
    Extended_Round_Trip_Time_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32767, ub=103041)], ev=None, er=[])
    
    #-----< Extended-HS-SCCH-ID >-----#
    Extended_HS_SCCH_ID = INT(name='Extended-HS-SCCH-ID', mode=MODE_TYPE)
    Extended_HS_SCCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=255)], ev=None, er=[])
    
    #-----< Extended-HS-SICH-ID >-----#
    Extended_HS_SICH_ID = INT(name='Extended-HS-SICH-ID', mode=MODE_TYPE)
    Extended_HS_SICH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=255)], ev=None, er=[])
    
    #-----< Extended-E-HICH-ID-TDD >-----#
    Extended_E_HICH_ID_TDD = INT(name='Extended-E-HICH-ID-TDD', mode=MODE_TYPE)
    Extended_E_HICH_ID_TDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=255)], ev=None, er=[])
    
    #-----< Radio-Links-without-DPCH-FDPCH-Indication >-----#
    Radio_Links_without_DPCH_FDPCH_Indication = SEQ_OF(name='Radio-Links-without-DPCH-FDPCH-Indication', mode=MODE_TYPE)
    _Radio_Links_without_DPCH_FDPCH_Indication__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Information')))
    Radio_Links_without_DPCH_FDPCH_Indication._cont = _Radio_Links_without_DPCH_FDPCH_Indication__item_
    Radio_Links_without_DPCH_FDPCH_Indication._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Radio-Links-without-DPCH-FDPCH-Information >-----#
    Radio_Links_without_DPCH_FDPCH_Information = SEQ(name='Radio-Links-without-DPCH-FDPCH-Information', mode=MODE_TYPE)
    _Radio_Links_without_DPCH_FDPCH_Information_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Radio_Links_without_DPCH_FDPCH_Information_radio_Links_without_DPCH_FDPCH_Operation_Indicator = ENUM(name='radio-Links-without-DPCH-FDPCH-Operation-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Radio_Links_without_DPCH_FDPCH_Information_radio_Links_without_DPCH_FDPCH_Operation_Indicator._cont = ASN1Dict([('true', 0)])
    _Radio_Links_without_DPCH_FDPCH_Information_radio_Links_without_DPCH_FDPCH_Operation_Indicator._ext = None
    _Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id._const_tab = ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id_tab
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id._const_tab_at = None
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality._const_tab = ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality_tab
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue._const_tab = ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue_tab
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id),
        ('criticality', ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue),
        ])
    __Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item_._ext = None
    _Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions._cont = __Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item_
    _Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Radio_Links_without_DPCH_FDPCH_Information._cont = ASN1Dict([
        ('rL-ID', _Radio_Links_without_DPCH_FDPCH_Information_rL_ID),
        ('radio-Links-without-DPCH-FDPCH-Operation-Indicator', _Radio_Links_without_DPCH_FDPCH_Information_radio_Links_without_DPCH_FDPCH_Operation_Indicator),
        ('iE-Extensions', _Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions),
        ])
    Radio_Links_without_DPCH_FDPCH_Information._ext = []
    
    #-----< Radio-Links-without-DPCH-FDPCH-Information-ExtIEs >-----#
    Radio_Links_without_DPCH_FDPCH_Information_ExtIEs = CLASS(name='Radio-Links-without-DPCH-FDPCH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Radio_Links_without_DPCH_FDPCH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-LCR >-----#
    E_DCH_Semi_PersistentScheduling_Information_LCR = SEQ(name='E-DCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_TYPE)
    _E_DCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR = SEQ_OF(name='repetition-Period-List-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Repetition-Period-List-LCR')))
    _E_DCH_Semi_PersistentScheduling_Information_LCR_e_DCH_SPS_Indicator = BIT_STR(name='e-DCH-SPS-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-SPS-Indicator')))
    _E_DCH_Semi_PersistentScheduling_Information_LCR_sPS_E_DCH_releted_E_HICH_Information = SEQ(name='sPS-E-DCH-releted-E-HICH-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-LCR-Information')))
    _E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SPS-Reservation-Indicator')))
    ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1132), ('criticality', 'ignore'), ('Extension', _____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_._ext = None
    _E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions._cont = __E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_
    _E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Semi_PersistentScheduling_Information_LCR._cont = ASN1Dict([
        ('repetition-Period-List-LCR', _E_DCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR),
        ('e-DCH-SPS-Indicator', _E_DCH_Semi_PersistentScheduling_Information_LCR_e_DCH_SPS_Indicator),
        ('sPS-E-DCH-releted-E-HICH-Information', _E_DCH_Semi_PersistentScheduling_Information_LCR_sPS_E_DCH_releted_E_HICH_Information),
        ('iE-Extensions', _E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions),
        ])
    E_DCH_Semi_PersistentScheduling_Information_LCR._ext = []
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-LCR-ExtIEs >-----#
    E_DCH_Semi_PersistentScheduling_Information_LCR_ExtIEs = CLASS(name='E-DCH-Semi-PersistentScheduling-Information-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_Semi_PersistentScheduling_Information_LCR_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SPS-Reservation-Indicator')))
    E_DCH_Semi_PersistentScheduling_Information_LCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1132), ('criticality', 'ignore'), ('Extension', _E_DCH_Semi_PersistentScheduling_Information_LCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-SPS-Indicator >-----#
    E_DCH_SPS_Indicator = BIT_STR(name='E-DCH-SPS-Indicator', mode=MODE_TYPE)
    E_DCH_SPS_Indicator._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR >-----#
    E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR = SEQ(name='E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR', mode=MODE_TYPE)
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR = SEQ_OF(name='repetition-Period-List-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Repetition-Period-List-LCR')), opt=True)
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_e_DCH_SPS_Indicator = BIT_STR(name='e-DCH-SPS-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-SPS-Indicator')), opt=True)
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_sPS_E_DCH_releted_E_HICH_Information = SEQ(name='sPS-E-DCH-releted-E-HICH-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-LCR-Information')), opt=True)
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SPS-Reservation-Indicator')))
    ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1132), ('criticality', 'ignore'), ('Extension', _____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_._ext = None
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions._cont = __E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR._cont = ASN1Dict([
        ('repetition-Period-List-LCR', _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR),
        ('e-DCH-SPS-Indicator', _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_e_DCH_SPS_Indicator),
        ('sPS-E-DCH-releted-E-HICH-Information', _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_sPS_E_DCH_releted_E_HICH_Information),
        ('iE-Extensions', _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions),
        ])
    E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR._ext = []
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs >-----#
    E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs = CLASS(name='E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SPS-Reservation-Indicator')))
    E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1132), ('criticality', 'ignore'), ('Extension', _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-ResponseLCR >-----#
    E_DCH_Semi_PersistentScheduling_Information_ResponseLCR = SEQ(name='E-DCH-Semi-PersistentScheduling-Information-ResponseLCR', mode=MODE_TYPE)
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_timeslot_Resource_Related_Information = BIT_STR(name='timeslot-Resource-Related-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TimeslotResourceLCR')))
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_powerResource = INT(name='powerResource', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerResource')))
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_repetition_Period_List_LCR = SEQ_OF(name='repetition-Period-List-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Repetition-Period-List-LCR')))
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_subframeNumber = ENUM(name='subframeNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_subframeNumber._cont = ASN1Dict([('v0', 0), ('v1', 1)])
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_subframeNumber._ext = None
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_tddE_PUCH_Offset = INT(name='tddE-PUCH-Offset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TddE-PUCH-Offset')))
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_n_E_UCCHLCR = INT(name='n-E-UCCHLCR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'N-E-UCCHLCR')))
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriodIndex')))
    ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1135), ('criticality', 'reject'), ('Extension', _____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions._cont = __E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Semi_PersistentScheduling_Information_ResponseLCR._cont = ASN1Dict([
        ('timeslot-Resource-Related-Information', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_timeslot_Resource_Related_Information),
        ('powerResource', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_powerResource),
        ('repetition-Period-List-LCR', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_repetition_Period_List_LCR),
        ('repetitionLength', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_repetitionLength),
        ('subframeNumber', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_subframeNumber),
        ('tddE-PUCH-Offset', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_tddE_PUCH_Offset),
        ('tdd-ChannelisationCode', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_tdd_ChannelisationCode),
        ('n-E-UCCHLCR', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_n_E_UCCHLCR),
        ('iE-Extensions', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions),
        ])
    E_DCH_Semi_PersistentScheduling_Information_ResponseLCR._ext = []
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs >-----#
    E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs = CLASS(name='E-DCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriodIndex')))
    E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1135), ('criticality', 'reject'), ('Extension', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ERNTI-Release-Status >-----#
    ERNTI_Release_Status = ENUM(name='ERNTI-Release-Status', mode=MODE_TYPE)
    ERNTI_Release_Status._cont = ASN1Dict([('released', 0), ('not-released', 1)])
    ERNTI_Release_Status._ext = None
    
    #-----< Common-E-DCH-Implicit-Release-Timer >-----#
    Common_E_DCH_Implicit_Release_Timer = ENUM(name='Common-E-DCH-Implicit-Release-Timer', mode=MODE_TYPE)
    Common_E_DCH_Implicit_Release_Timer._cont = ASN1Dict([('zero', 0), ('more-than-zero', 1)])
    Common_E_DCH_Implicit_Release_Timer._ext = None
    
    #-----< FACH-Measurement-Occasion-Cycle-Length-Coefficient >-----#
    FACH_Measurement_Occasion_Cycle_Length_Coefficient = INT(name='FACH-Measurement-Occasion-Cycle-Length-Coefficient', mode=MODE_TYPE)
    FACH_Measurement_Occasion_Cycle_Length_Coefficient._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< Fast-Reconfiguration-Mode >-----#
    Fast_Reconfiguration_Mode = ENUM(name='Fast-Reconfiguration-Mode', mode=MODE_TYPE)
    Fast_Reconfiguration_Mode._cont = ASN1Dict([('fast', 0)])
    Fast_Reconfiguration_Mode._ext = []
    
    #-----< Fast-Reconfiguration-Permission >-----#
    Fast_Reconfiguration_Permission = ENUM(name='Fast-Reconfiguration-Permission', mode=MODE_TYPE)
    Fast_Reconfiguration_Permission._cont = ASN1Dict([('allowed', 0)])
    Fast_Reconfiguration_Permission._ext = []
    
    #-----< Fast-TTI-switching-Mode-synchronized >-----#
    Fast_TTI_switching_Mode_synchronized = CHOICE(name='Fast-TTI-switching-Mode-synchronized', mode=MODE_TYPE)
    _Fast_TTI_switching_Mode_synchronized_mode1 = NULL(name='mode1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Mode1-Ind')))
    _Fast_TTI_switching_Mode_synchronized_mode2 = INT(name='mode2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    Fast_TTI_switching_Mode_synchronized._cont = ASN1Dict([
        ('mode1', _Fast_TTI_switching_Mode_synchronized_mode1),
        ('mode2', _Fast_TTI_switching_Mode_synchronized_mode2),
        ])
    Fast_TTI_switching_Mode_synchronized._ext = None
    
    #-----< Mode1-Ind >-----#
    Mode1_Ind = NULL(name='Mode1-Ind', mode=MODE_TYPE)
    
    #-----< Fast-TTI-switching-Mode-unsynchronized >-----#
    Fast_TTI_switching_Mode_unsynchronized = CHOICE(name='Fast-TTI-switching-Mode-unsynchronized', mode=MODE_TYPE)
    _Fast_TTI_switching_Mode_unsynchronized_mode1 = ENUM(name='mode1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ActivationDelay')))
    _Fast_TTI_switching_Mode_unsynchronized_mode2 = INT(name='mode2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    Fast_TTI_switching_Mode_unsynchronized._cont = ASN1Dict([
        ('mode1', _Fast_TTI_switching_Mode_unsynchronized_mode1),
        ('mode2', _Fast_TTI_switching_Mode_unsynchronized_mode2),
        ])
    Fast_TTI_switching_Mode_unsynchronized._ext = None
    
    #-----< Fast-TTI-switching-Mode-Supported >-----#
    Fast_TTI_switching_Mode_Supported = ENUM(name='Fast-TTI-switching-Mode-Supported', mode=MODE_TYPE)
    Fast_TTI_switching_Mode_Supported._cont = ASN1Dict([('mode1', 0), ('mode2', 1)])
    Fast_TTI_switching_Mode_Supported._ext = None
    
    #-----< FDD-DL-ChannelisationCodeNumber >-----#
    FDD_DL_ChannelisationCodeNumber = INT(name='FDD-DL-ChannelisationCodeNumber', mode=MODE_TYPE)
    FDD_DL_ChannelisationCodeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< FDD-DL-CodeInformation >-----#
    FDD_DL_CodeInformation = SEQ_OF(name='FDD-DL-CodeInformation', mode=MODE_TYPE)
    _FDD_DL_CodeInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-CodeInformationItem')))
    FDD_DL_CodeInformation._cont = _FDD_DL_CodeInformation__item_
    FDD_DL_CodeInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< FDD-DL-CodeInformationItem >-----#
    FDD_DL_CodeInformationItem = SEQ(name='FDD-DL-CodeInformationItem', mode=MODE_TYPE)
    _FDD_DL_CodeInformationItem_dl_ScramblingCode = INT(name='dl-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-ScramblingCode')))
    _FDD_DL_CodeInformationItem_fdd_DL_ChannelisationCodeNumber = INT(name='fdd-DL-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _FDD_DL_CodeInformationItem_transmissionGapPatternSequenceCodeInformation = ENUM(name='transmissionGapPatternSequenceCodeInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransmissionGapPatternSequenceCodeInformation')), opt=True)
    _FDD_DL_CodeInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_DL_CodeInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__id._const_tab = ____FDD_DL_CodeInformationItem_iE_Extensions__item__id_tab
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality._const_tab = ____FDD_DL_CodeInformationItem_iE_Extensions__item__criticality_tab
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue._const_tab = ____FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue_tab
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FDD_DL_CodeInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FDD_DL_CodeInformationItem_iE_Extensions__item__id),
        ('criticality', ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue),
        ])
    __FDD_DL_CodeInformationItem_iE_Extensions__item_._ext = None
    _FDD_DL_CodeInformationItem_iE_Extensions._cont = __FDD_DL_CodeInformationItem_iE_Extensions__item_
    _FDD_DL_CodeInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_DL_CodeInformationItem._cont = ASN1Dict([
        ('dl-ScramblingCode', _FDD_DL_CodeInformationItem_dl_ScramblingCode),
        ('fdd-DL-ChannelisationCodeNumber', _FDD_DL_CodeInformationItem_fdd_DL_ChannelisationCodeNumber),
        ('transmissionGapPatternSequenceCodeInformation', _FDD_DL_CodeInformationItem_transmissionGapPatternSequenceCodeInformation),
        ('iE-Extensions', _FDD_DL_CodeInformationItem_iE_Extensions),
        ])
    FDD_DL_CodeInformationItem._ext = []
    
    #-----< FDD-DL-CodeInformationItem-ExtIEs >-----#
    FDD_DL_CodeInformationItem_ExtIEs = CLASS(name='FDD-DL-CodeInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    FDD_DL_CodeInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FDD-S-CCPCH-FrameOffset >-----#
    FDD_S_CCPCH_FrameOffset = ENUM(name='FDD-S-CCPCH-FrameOffset', mode=MODE_TYPE)
    FDD_S_CCPCH_FrameOffset._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v4', 2)])
    FDD_S_CCPCH_FrameOffset._ext = []
    
    #-----< FDD-S-CCPCH-Offset >-----#
    FDD_S_CCPCH_Offset = INT(name='FDD-S-CCPCH-Offset', mode=MODE_TYPE)
    FDD_S_CCPCH_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=149)], ev=None, er=[])
    
    #-----< FDD-TPC-DownlinkStepSize >-----#
    FDD_TPC_DownlinkStepSize = ENUM(name='FDD-TPC-DownlinkStepSize', mode=MODE_TYPE)
    FDD_TPC_DownlinkStepSize._cont = ASN1Dict([('step-size0-5', 0), ('step-size1', 1), ('step-size1-5', 2), ('step-size2', 3)])
    FDD_TPC_DownlinkStepSize._ext = []
    
    #-----< F-DPCH-Capability >-----#
    F_DPCH_Capability = ENUM(name='F-DPCH-Capability', mode=MODE_TYPE)
    F_DPCH_Capability._cont = ASN1Dict([('f-DPCH-capable', 0), ('f-DPCH-non-capable', 1)])
    F_DPCH_Capability._ext = None
    
    #-----< F-DPCH-Info >-----#
    F_DPCH_Info = SEQ(name='F-DPCH-Info', mode=MODE_TYPE)
    _F_DPCH_Info_f_DPCH_SlotFormat = INT(name='f-DPCH-SlotFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')))
    _F_DPCH_Info_fdd_dl_ChannelisationCodeNumber = INT(name='fdd-dl-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _F_DPCH_Info_extended_E_DPCCH_PO = INT(name='extended-E-DPCCH-PO', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-DPCCH-PO')), opt=True)
    _F_DPCH_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __F_DPCH_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___F_DPCH_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____F_DPCH_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_iE_Extensions__item__id._const_tab = ____F_DPCH_Info_iE_Extensions__item__id_tab
    ___F_DPCH_Info_iE_Extensions__item__id._const_tab_at = None
    ___F_DPCH_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___F_DPCH_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____F_DPCH_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_iE_Extensions__item__criticality._const_tab = ____F_DPCH_Info_iE_Extensions__item__criticality_tab
    ___F_DPCH_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___F_DPCH_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___F_DPCH_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____F_DPCH_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_iE_Extensions__item__extensionValue._const_tab = ____F_DPCH_Info_iE_Extensions__item__extensionValue_tab
    ___F_DPCH_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___F_DPCH_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __F_DPCH_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___F_DPCH_Info_iE_Extensions__item__id),
        ('criticality', ___F_DPCH_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___F_DPCH_Info_iE_Extensions__item__extensionValue),
        ])
    __F_DPCH_Info_iE_Extensions__item_._ext = None
    _F_DPCH_Info_iE_Extensions._cont = __F_DPCH_Info_iE_Extensions__item_
    _F_DPCH_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    F_DPCH_Info._cont = ASN1Dict([
        ('f-DPCH-SlotFormat', _F_DPCH_Info_f_DPCH_SlotFormat),
        ('fdd-dl-ChannelisationCodeNumber', _F_DPCH_Info_fdd_dl_ChannelisationCodeNumber),
        ('extended-E-DPCCH-PO', _F_DPCH_Info_extended_E_DPCCH_PO),
        ('iE-Extensions', _F_DPCH_Info_iE_Extensions),
        ])
    F_DPCH_Info._ext = []
    
    #-----< F-DPCH-Info-ExtIEs >-----#
    F_DPCH_Info_ExtIEs = CLASS(name='F-DPCH-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    F_DPCH_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< F-DPCH-Info-To-Modify >-----#
    F_DPCH_Info_To_Modify = SEQ(name='F-DPCH-Info-To-Modify', mode=MODE_TYPE)
    _F_DPCH_Info_To_Modify_f_DPCH_SlotFormat = INT(name='f-DPCH-SlotFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')), opt=True)
    _F_DPCH_Info_To_Modify_fdd_dl_ChannelisationCodeNumber = INT(name='fdd-dl-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')), opt=True)
    _F_DPCH_Info_To_Modify_extended_E_DPCCH_PO = INT(name='extended-E-DPCCH-PO', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-DPCCH-PO')), opt=True)
    _F_DPCH_Info_To_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __F_DPCH_Info_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__id._const_tab = ____F_DPCH_Info_To_Modify_iE_Extensions__item__id_tab
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality._const_tab = ____F_DPCH_Info_To_Modify_iE_Extensions__item__criticality_tab
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue_tab
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __F_DPCH_Info_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___F_DPCH_Info_To_Modify_iE_Extensions__item__id),
        ('criticality', ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __F_DPCH_Info_To_Modify_iE_Extensions__item_._ext = None
    _F_DPCH_Info_To_Modify_iE_Extensions._cont = __F_DPCH_Info_To_Modify_iE_Extensions__item_
    _F_DPCH_Info_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    F_DPCH_Info_To_Modify._cont = ASN1Dict([
        ('f-DPCH-SlotFormat', _F_DPCH_Info_To_Modify_f_DPCH_SlotFormat),
        ('fdd-dl-ChannelisationCodeNumber', _F_DPCH_Info_To_Modify_fdd_dl_ChannelisationCodeNumber),
        ('extended-E-DPCCH-PO', _F_DPCH_Info_To_Modify_extended_E_DPCCH_PO),
        ('iE-Extensions', _F_DPCH_Info_To_Modify_iE_Extensions),
        ])
    F_DPCH_Info_To_Modify._ext = []
    
    #-----< F-DPCH-Info-To-Modify-ExtIEs >-----#
    F_DPCH_Info_To_Modify_ExtIEs = CLASS(name='F-DPCH-Info-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    F_DPCH_Info_To_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< F-DPCH-SlotFormat >-----#
    F_DPCH_SlotFormat = INT(name='F-DPCH-SlotFormat', mode=MODE_TYPE)
    F_DPCH_SlotFormat._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    
    #-----< F-DPCH-SlotFormatCapability >-----#
    F_DPCH_SlotFormatCapability = ENUM(name='F-DPCH-SlotFormatCapability', mode=MODE_TYPE)
    F_DPCH_SlotFormatCapability._cont = ASN1Dict([('f-DPCH-slot-format-capable', 0), ('f-DPCH-slot-format-non-capable', 1)])
    F_DPCH_SlotFormatCapability._ext = None
    
    #-----< FirstRLS-Indicator >-----#
    FirstRLS_Indicator = ENUM(name='FirstRLS-Indicator', mode=MODE_TYPE)
    FirstRLS_Indicator._cont = ASN1Dict([('first-RLS', 0), ('not-first-RLS', 1)])
    FirstRLS_Indicator._ext = []
    
    #-----< FNReportingIndicator >-----#
    FNReportingIndicator = ENUM(name='FNReportingIndicator', mode=MODE_TYPE)
    FNReportingIndicator._cont = ASN1Dict([('fN-reporting-required', 0), ('fN-reporting-not-required', 1)])
    FNReportingIndicator._ext = None
    
    #-----< FrameHandlingPriority >-----#
    FrameHandlingPriority = INT(name='FrameHandlingPriority', mode=MODE_TYPE)
    FrameHandlingPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< FrameAdjustmentValue >-----#
    FrameAdjustmentValue = INT(name='FrameAdjustmentValue', mode=MODE_TYPE)
    FrameAdjustmentValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< FrameOffset >-----#
    FrameOffset = INT(name='FrameOffset', mode=MODE_TYPE)
    FrameOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< FPACH-Power >-----#
    FPACH_Power = INT(name='FPACH-Power', mode=MODE_TYPE)
    FPACH_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-150, ub=400)], ev=[], er=[])
    
    #-----< FTPICH-Information >-----#
    FTPICH_Information = SEQ(name='FTPICH-Information', mode=MODE_TYPE)
    _FTPICH_Information_fTPICH_SlotFormat = INT(name='fTPICH-SlotFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-SlotFormat')))
    _FTPICH_Information_fTPICH_Offset = INT(name='fTPICH-Offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Offset')))
    _FTPICH_Information_fTPICH_ChannelisationCodeNumber = INT(name='fTPICH-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _FTPICH_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FTPICH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___FTPICH_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____FTPICH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_iE_Extensions__item__id._const_tab = ____FTPICH_Information_iE_Extensions__item__id_tab
    ___FTPICH_Information_iE_Extensions__item__id._const_tab_at = None
    ___FTPICH_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___FTPICH_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FTPICH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_iE_Extensions__item__criticality._const_tab = ____FTPICH_Information_iE_Extensions__item__criticality_tab
    ___FTPICH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FTPICH_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FTPICH_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FTPICH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_iE_Extensions__item__extensionValue._const_tab = ____FTPICH_Information_iE_Extensions__item__extensionValue_tab
    ___FTPICH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FTPICH_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FTPICH_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FTPICH_Information_iE_Extensions__item__id),
        ('criticality', ___FTPICH_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___FTPICH_Information_iE_Extensions__item__extensionValue),
        ])
    __FTPICH_Information_iE_Extensions__item_._ext = None
    _FTPICH_Information_iE_Extensions._cont = __FTPICH_Information_iE_Extensions__item_
    _FTPICH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FTPICH_Information._cont = ASN1Dict([
        ('fTPICH-SlotFormat', _FTPICH_Information_fTPICH_SlotFormat),
        ('fTPICH-Offset', _FTPICH_Information_fTPICH_Offset),
        ('fTPICH-ChannelisationCodeNumber', _FTPICH_Information_fTPICH_ChannelisationCodeNumber),
        ('iE-Extensions', _FTPICH_Information_iE_Extensions),
        ])
    FTPICH_Information._ext = []
    
    #-----< FTPICH-Information-ExtIEs >-----#
    FTPICH_Information_ExtIEs = CLASS(name='FTPICH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    FTPICH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FTPICH-SlotFormat >-----#
    FTPICH_SlotFormat = INT(name='FTPICH-SlotFormat', mode=MODE_TYPE)
    FTPICH_SlotFormat._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    
    #-----< FTPICH-Offset >-----#
    FTPICH_Offset = INT(name='FTPICH-Offset', mode=MODE_TYPE)
    FTPICH_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=149)], ev=[], er=[])
    
    #-----< FTPICH-Information-Removal >-----#
    FTPICH_Information_Removal = ENUM(name='FTPICH-Information-Removal', mode=MODE_TYPE)
    FTPICH_Information_Removal._cont = ASN1Dict([('remove', 0)])
    FTPICH_Information_Removal._ext = []
    
    #-----< FTPICH-Information-To-Modify >-----#
    FTPICH_Information_To_Modify = SEQ(name='FTPICH-Information-To-Modify', mode=MODE_TYPE)
    _FTPICH_Information_To_Modify_fTPICH_SlotFormat = INT(name='fTPICH-SlotFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-SlotFormat')), opt=True)
    _FTPICH_Information_To_Modify_fTPICH_Offset = INT(name='fTPICH-Offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Offset')), opt=True)
    _FTPICH_Information_To_Modify_fTPICH_ChannelisationCodeNumber = INT(name='fTPICH-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')), opt=True)
    _FTPICH_Information_To_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FTPICH_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___FTPICH_Information_To_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_To_Modify_iE_Extensions__item__id._const_tab = ____FTPICH_Information_To_Modify_iE_Extensions__item__id_tab
    ___FTPICH_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___FTPICH_Information_To_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____FTPICH_Information_To_Modify_iE_Extensions__item__criticality_tab
    ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue_tab
    ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FTPICH_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FTPICH_Information_To_Modify_iE_Extensions__item__id),
        ('criticality', ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __FTPICH_Information_To_Modify_iE_Extensions__item_._ext = None
    _FTPICH_Information_To_Modify_iE_Extensions._cont = __FTPICH_Information_To_Modify_iE_Extensions__item_
    _FTPICH_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FTPICH_Information_To_Modify._cont = ASN1Dict([
        ('fTPICH-SlotFormat', _FTPICH_Information_To_Modify_fTPICH_SlotFormat),
        ('fTPICH-Offset', _FTPICH_Information_To_Modify_fTPICH_Offset),
        ('fTPICH-ChannelisationCodeNumber', _FTPICH_Information_To_Modify_fTPICH_ChannelisationCodeNumber),
        ('iE-Extensions', _FTPICH_Information_To_Modify_iE_Extensions),
        ])
    FTPICH_Information_To_Modify._ext = []
    
    #-----< FTPICH-Information-To-Modify-ExtIEs >-----#
    FTPICH_Information_To_Modify_ExtIEs = CLASS(name='FTPICH-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    FTPICH_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FTPICH-Information-Reconf >-----#
    FTPICH_Information_Reconf = SEQ(name='FTPICH-Information-Reconf', mode=MODE_TYPE)
    _FTPICH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information = CHOICE(name='setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information')))
    _FTPICH_Information_Reconf_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FTPICH_Information_Reconf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___FTPICH_Information_Reconf_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____FTPICH_Information_Reconf_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_Reconf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_Reconf_iE_Extensions__item__id._const_tab = ____FTPICH_Information_Reconf_iE_Extensions__item__id_tab
    ___FTPICH_Information_Reconf_iE_Extensions__item__id._const_tab_at = None
    ___FTPICH_Information_Reconf_iE_Extensions__item__id._const_tab_id = 'id'
    ___FTPICH_Information_Reconf_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FTPICH_Information_Reconf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_Reconf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_Reconf_iE_Extensions__item__criticality._const_tab = ____FTPICH_Information_Reconf_iE_Extensions__item__criticality_tab
    ___FTPICH_Information_Reconf_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FTPICH_Information_Reconf_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FTPICH_Information_Reconf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_Reconf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab = ____FTPICH_Information_Reconf_iE_Extensions__item__extensionValue_tab
    ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FTPICH_Information_Reconf_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FTPICH_Information_Reconf_iE_Extensions__item__id),
        ('criticality', ___FTPICH_Information_Reconf_iE_Extensions__item__criticality),
        ('extensionValue', ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue),
        ])
    __FTPICH_Information_Reconf_iE_Extensions__item_._ext = None
    _FTPICH_Information_Reconf_iE_Extensions._cont = __FTPICH_Information_Reconf_iE_Extensions__item_
    _FTPICH_Information_Reconf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FTPICH_Information_Reconf._cont = ASN1Dict([
        ('setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information', _FTPICH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information),
        ('iE-Extensions', _FTPICH_Information_Reconf_iE_Extensions),
        ])
    FTPICH_Information_Reconf._ext = []
    
    #-----< FTPICH-Information-Reconf-ExtIEs >-----#
    FTPICH_Information_Reconf_ExtIEs = CLASS(name='FTPICH-Information-Reconf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    FTPICH_Information_Reconf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Further-Enhanced-UE-DRX-InformationFDD >-----#
    Further_Enhanced_UE_DRX_InformationFDD = SEQ(name='Further-Enhanced-UE-DRX-InformationFDD', mode=MODE_TYPE)
    _Further_Enhanced_UE_DRX_InformationFDD_hS_DSCH_second_DRX_Cycle_FACH = ENUM(name='hS-DSCH-second-DRX-Cycle-FACH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Second-DRX-Cycle-FACH')))
    _Further_Enhanced_UE_DRX_InformationFDD_cHOICE_DRX_level = CHOICE(name='cHOICE-DRX-level', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CHOICE-DRX-level')))
    _Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id._const_tab = ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id_tab
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality._const_tab = ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality_tab
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue._const_tab = ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id),
        ('criticality', ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue),
        ])
    __Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item_._ext = None
    _Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions._cont = __Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item_
    _Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Further_Enhanced_UE_DRX_InformationFDD._cont = ASN1Dict([
        ('hS-DSCH-second-DRX-Cycle-FACH', _Further_Enhanced_UE_DRX_InformationFDD_hS_DSCH_second_DRX_Cycle_FACH),
        ('cHOICE-DRX-level', _Further_Enhanced_UE_DRX_InformationFDD_cHOICE_DRX_level),
        ('iE-Extensions', _Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions),
        ])
    Further_Enhanced_UE_DRX_InformationFDD._ext = []
    
    #-----< Further-Enhanced-UE-DRX-InformationFDD-ExtIEs >-----#
    Further_Enhanced_UE_DRX_InformationFDD_ExtIEs = CLASS(name='Further-Enhanced-UE-DRX-InformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Further_Enhanced_UE_DRX_InformationFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Gainfactors-10ms-mode >-----#
    Gainfactors_10ms_mode = CHOICE(name='Gainfactors-10ms-mode', mode=MODE_TYPE)
    _Gainfactors_10ms_mode_signalledGainFactors10ms = SEQ(name='signalledGainFactors10ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaC = INT(name='gain10ms-betaC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BetaCD')))
    __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaD = INT(name='gain10ms-betaD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BetaCD')))
    __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_refTFCNumber = INT(name='gain10ms-refTFCNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RefTFCNumber')), opt=True)
    __Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id._const_tab = _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id_tab
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id._const_tab_at = None
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id._const_tab_id = 'id'
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality._const_tab = _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality_tab
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue._const_tab = _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue_tab
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id),
        ('criticality', ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality),
        ('extensionValue', ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue),
        ])
    ___Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item_._ext = None
    __Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions._cont = ___Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item_
    __Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Gainfactors_10ms_mode_signalledGainFactors10ms._cont = ASN1Dict([
        ('gain10ms-betaC', __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaC),
        ('gain10ms-betaD', __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaD),
        ('gain10ms-refTFCNumber', __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_refTFCNumber),
        ('iE-Extensions', __Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions),
        ])
    _Gainfactors_10ms_mode_signalledGainFactors10ms._ext = []
    _Gainfactors_10ms_mode_computedGainFactors10ms = INT(name='computedGainFactors10ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RefTFCNumber')))
    Gainfactors_10ms_mode._cont = ASN1Dict([
        ('signalledGainFactors10ms', _Gainfactors_10ms_mode_signalledGainFactors10ms),
        ('computedGainFactors10ms', _Gainfactors_10ms_mode_computedGainFactors10ms),
        ])
    Gainfactors_10ms_mode._ext = []
    
    #-----< SignalledGainFactors10ms-ExtIEs >-----#
    SignalledGainFactors10ms_ExtIEs = CLASS(name='SignalledGainFactors10ms-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SignalledGainFactors10ms_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-AddClockModels >-----#
    GANSS_AddClockModels = CHOICE(name='GANSS-AddClockModels', mode=MODE_TYPE)
    _GANSS_AddClockModels_navClockModel = SEQ(name='navClockModel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-NAVclockModel')))
    _GANSS_AddClockModels_cnavClockModel = SEQ(name='cnavClockModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-CNAVclockModel')))
    _GANSS_AddClockModels_glonassClockModel = SEQ(name='glonassClockModel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-GLONASSclockModel')))
    _GANSS_AddClockModels_sbasClockModel = SEQ(name='sbasClockModel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SBASclockModel')))
    _GANSS_AddClockModels_bdsClockModel = SEQ(name='bdsClockModel', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-BDSclockModel')))
    GANSS_AddClockModels._cont = ASN1Dict([
        ('navClockModel', _GANSS_AddClockModels_navClockModel),
        ('cnavClockModel', _GANSS_AddClockModels_cnavClockModel),
        ('glonassClockModel', _GANSS_AddClockModels_glonassClockModel),
        ('sbasClockModel', _GANSS_AddClockModels_sbasClockModel),
        ('bdsClockModel', _GANSS_AddClockModels_bdsClockModel),
        ])
    GANSS_AddClockModels._ext = ['bdsClockModel']
    
    #-----< GANSS-AddIonoModelReq >-----#
    GANSS_AddIonoModelReq = BIT_STR(name='GANSS-AddIonoModelReq', mode=MODE_TYPE)
    GANSS_AddIonoModelReq._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< GANSS-AddNavigationModelsReq >-----#
    GANSS_AddNavigationModelsReq = BOOL(name='GANSS-AddNavigationModelsReq', mode=MODE_TYPE)
    
    #-----< GANSS-AddOrbitModels >-----#
    GANSS_AddOrbitModels = CHOICE(name='GANSS-AddOrbitModels', mode=MODE_TYPE)
    _GANSS_AddOrbitModels_navKeplerianSet = SEQ(name='navKeplerianSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-NavModel-NAVKeplerianSet')))
    _GANSS_AddOrbitModels_cnavKeplerianSet = SEQ(name='cnavKeplerianSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-NavModel-CNAVKeplerianSet')))
    _GANSS_AddOrbitModels_glonassECEF = SEQ(name='glonassECEF', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-NavModel-GLONASSecef')))
    _GANSS_AddOrbitModels_sbasECEF = SEQ(name='sbasECEF', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-NavModel-SBASecef')))
    _GANSS_AddOrbitModels_bdsKeplerianSet = SEQ(name='bdsKeplerianSet', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-NavModel-BDSKeplerianSet')))
    GANSS_AddOrbitModels._cont = ASN1Dict([
        ('navKeplerianSet', _GANSS_AddOrbitModels_navKeplerianSet),
        ('cnavKeplerianSet', _GANSS_AddOrbitModels_cnavKeplerianSet),
        ('glonassECEF', _GANSS_AddOrbitModels_glonassECEF),
        ('sbasECEF', _GANSS_AddOrbitModels_sbasECEF),
        ('bdsKeplerianSet', _GANSS_AddOrbitModels_bdsKeplerianSet),
        ])
    GANSS_AddOrbitModels._ext = ['bdsKeplerianSet']
    
    #-----< GANSS-AddUTCModelsReq >-----#
    GANSS_AddUTCModelsReq = BOOL(name='GANSS-AddUTCModelsReq', mode=MODE_TYPE)
    
    #-----< GANSS-Additional-Ionospheric-Model >-----#
    GANSS_Additional_Ionospheric_Model = SEQ(name='GANSS-Additional-Ionospheric-Model', mode=MODE_TYPE)
    _GANSS_Additional_Ionospheric_Model_dataID = BIT_STR(name='dataID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Additional_Ionospheric_Model_dataID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_Additional_Ionospheric_Model_alpha_beta_parameters = SEQ(name='alpha-beta-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GPS-Ionospheric-Model')))
    _GANSS_Additional_Ionospheric_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id._const_tab = ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id),
        ('criticality', ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_._ext = None
    _GANSS_Additional_Ionospheric_Model_ie_Extensions._cont = __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_
    _GANSS_Additional_Ionospheric_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Additional_Ionospheric_Model._cont = ASN1Dict([
        ('dataID', _GANSS_Additional_Ionospheric_Model_dataID),
        ('alpha-beta-parameters', _GANSS_Additional_Ionospheric_Model_alpha_beta_parameters),
        ('ie-Extensions', _GANSS_Additional_Ionospheric_Model_ie_Extensions),
        ])
    GANSS_Additional_Ionospheric_Model._ext = []
    
    #-----< GANSS-Additional-Ionospheric-Model-ExtIEs >-----#
    GANSS_Additional_Ionospheric_Model_ExtIEs = CLASS(name='GANSS-Additional-Ionospheric-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_Additional_Ionospheric_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Additional-Navigation-Models >-----#
    GANSS_Additional_Navigation_Models = SEQ(name='GANSS-Additional-Navigation-Models', mode=MODE_TYPE)
    _GANSS_Additional_Navigation_Models_ganss_Transmission_Time = SEQ(name='ganss-Transmission-Time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Transmission-Time')))
    _GANSS_Additional_Navigation_Models_non_broadcastIndication = ENUM(name='non-broadcastIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Additional_Navigation_Models_non_broadcastIndication._cont = ASN1Dict([('true', 0)])
    _GANSS_Additional_Navigation_Models_non_broadcastIndication._ext = None
    _GANSS_Additional_Navigation_Models_ganssSatInfoNavList = SEQ_OF(name='ganssSatInfoNavList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Ganss-Sat-Info-AddNavList')))
    _GANSS_Additional_Navigation_Models_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Additional_Navigation_Models_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id._const_tab = ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality._const_tab = ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Additional_Navigation_Models_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id),
        ('criticality', ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Additional_Navigation_Models_ie_Extensions__item_._ext = None
    _GANSS_Additional_Navigation_Models_ie_Extensions._cont = __GANSS_Additional_Navigation_Models_ie_Extensions__item_
    _GANSS_Additional_Navigation_Models_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Additional_Navigation_Models._cont = ASN1Dict([
        ('ganss-Transmission-Time', _GANSS_Additional_Navigation_Models_ganss_Transmission_Time),
        ('non-broadcastIndication', _GANSS_Additional_Navigation_Models_non_broadcastIndication),
        ('ganssSatInfoNavList', _GANSS_Additional_Navigation_Models_ganssSatInfoNavList),
        ('ie-Extensions', _GANSS_Additional_Navigation_Models_ie_Extensions),
        ])
    GANSS_Additional_Navigation_Models._ext = []
    
    #-----< GANSS-Additional-Navigation-Models-ExtIEs >-----#
    GANSS_Additional_Navigation_Models_ExtIEs = CLASS(name='GANSS-Additional-Navigation-Models-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_Additional_Navigation_Models_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Additional-Time-Models >-----#
    GANSS_Additional_Time_Models = SEQ_OF(name='GANSS-Additional-Time-Models', mode=MODE_TYPE)
    _GANSS_Additional_Time_Models__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Time-Model')))
    GANSS_Additional_Time_Models._cont = _GANSS_Additional_Time_Models__item_
    GANSS_Additional_Time_Models._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< GANSS-Additional-UTC-Models >-----#
    GANSS_Additional_UTC_Models = CHOICE(name='GANSS-Additional-UTC-Models', mode=MODE_TYPE)
    _GANSS_Additional_UTC_Models_utcModel1 = SEQ(name='utcModel1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-UTCmodelSet1')))
    _GANSS_Additional_UTC_Models_utcModel2 = SEQ(name='utcModel2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-UTCmodelSet2')))
    _GANSS_Additional_UTC_Models_utcModel3 = SEQ(name='utcModel3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-UTCmodelSet3')))
    _GANSS_Additional_UTC_Models_utcModel4 = SEQ(name='utcModel4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-UTCmodelSet4')))
    GANSS_Additional_UTC_Models._cont = ASN1Dict([
        ('utcModel1', _GANSS_Additional_UTC_Models_utcModel1),
        ('utcModel2', _GANSS_Additional_UTC_Models_utcModel2),
        ('utcModel3', _GANSS_Additional_UTC_Models_utcModel3),
        ('utcModel4', _GANSS_Additional_UTC_Models_utcModel4),
        ])
    GANSS_Additional_UTC_Models._ext = ['utcModel4']
    
    #-----< GANSS-Almanac >-----#
    GANSS_Almanac = SEQ(name='GANSS-Almanac', mode=MODE_TYPE)
    _GANSS_Almanac_ganss_wk_number = INT(name='ganss-wk-number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Almanac_ganss_wk_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_Almanac_gANSS_AlmanacModel = CHOICE(name='gANSS-AlmanacModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AlmanacModel')))
    _GANSS_Almanac_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Almanac_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Almanac_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Almanac_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____GANSS_Almanac_ie_Extensions__item__id_tab_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CompleteAlmanacProvided')))
    ____GANSS_Almanac_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1184), ('criticality', 'ignore'), ('Extension', _____GANSS_Almanac_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_Almanac_ie_Extensions__item__id._const_tab = ____GANSS_Almanac_ie_Extensions__item__id_tab
    ___GANSS_Almanac_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Almanac_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Almanac_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_Almanac_ie_Extensions__item__criticality._const_tab = ____GANSS_Almanac_ie_Extensions__item__id_tab
    ___GANSS_Almanac_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Almanac_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Almanac_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_Almanac_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Almanac_ie_Extensions__item__id_tab
    ___GANSS_Almanac_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Almanac_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Almanac_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Almanac_ie_Extensions__item__id),
        ('criticality', ___GANSS_Almanac_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Almanac_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Almanac_ie_Extensions__item_._ext = None
    _GANSS_Almanac_ie_Extensions._cont = __GANSS_Almanac_ie_Extensions__item_
    _GANSS_Almanac_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Almanac._cont = ASN1Dict([
        ('ganss-wk-number', _GANSS_Almanac_ganss_wk_number),
        ('gANSS-AlmanacModel', _GANSS_Almanac_gANSS_AlmanacModel),
        ('ie-Extensions', _GANSS_Almanac_ie_Extensions),
        ])
    GANSS_Almanac._ext = []
    
    #-----< GANSS-Almanac-ExtIEs >-----#
    GANSS_Almanac_ExtIEs = CLASS(name='GANSS-Almanac-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _GANSS_Almanac_ExtIEs_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CompleteAlmanacProvided')))
    GANSS_Almanac_ExtIEs._val = ASN1Set(rv=[dict([('id', 1184), ('criticality', 'ignore'), ('Extension', _GANSS_Almanac_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-AlmanacModel >-----#
    GANSS_AlmanacModel = CHOICE(name='GANSS-AlmanacModel', mode=MODE_TYPE)
    _GANSS_AlmanacModel_gANSS_keplerianParameters = SEQ(name='gANSS-keplerianParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-KeplerianParametersAlm')))
    _GANSS_AlmanacModel_extension_GANSS_AlmanacModel = SEQ(name='extension-GANSS-AlmanacModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Extension-GANSS-AlmanacModel')))
    GANSS_AlmanacModel._cont = ASN1Dict([
        ('gANSS-keplerianParameters', _GANSS_AlmanacModel_gANSS_keplerianParameters),
        ('extension-GANSS-AlmanacModel', _GANSS_AlmanacModel_extension_GANSS_AlmanacModel),
        ])
    GANSS_AlmanacModel._ext = ['extension-GANSS-AlmanacModel']
    
    #-----< Extension-GANSS-AlmanacModel >-----#
    Extension_GANSS_AlmanacModel = SEQ(name='Extension-GANSS-AlmanacModel', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_GANSS_AlmanacModel_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_GANSS_AlmanacModel_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-NAVKeplerianSet')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-ReducedKeplerianSet')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-MidiAlmanacSet')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-GlonassAlmanacSet')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-ECEFsbasAlmanacSet')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-KEPLERIANBDSALMANAC')))
    __Extension_GANSS_AlmanacModel_id_tab._val = ASN1Set(rv=[dict([('id', 1064), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1065), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1066), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1067), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 1068), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 1271), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_GANSS_AlmanacModel_id._const_tab = __Extension_GANSS_AlmanacModel_id_tab
    _Extension_GANSS_AlmanacModel_id._const_tab_at = None
    _Extension_GANSS_AlmanacModel_id._const_tab_id = 'id'
    _Extension_GANSS_AlmanacModel_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_GANSS_AlmanacModel_criticality._const_tab = __Extension_GANSS_AlmanacModel_id_tab
    _Extension_GANSS_AlmanacModel_criticality._const_tab_at = ('..', 'id')
    _Extension_GANSS_AlmanacModel_criticality._const_tab_id = 'criticality'
    _Extension_GANSS_AlmanacModel_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_GANSS_AlmanacModel_value._const_tab = __Extension_GANSS_AlmanacModel_id_tab
    _Extension_GANSS_AlmanacModel_value._const_tab_at = ('..', 'id')
    _Extension_GANSS_AlmanacModel_value._const_tab_id = 'Value'
    Extension_GANSS_AlmanacModel._cont = ASN1Dict([
        ('id', _Extension_GANSS_AlmanacModel_id),
        ('criticality', _Extension_GANSS_AlmanacModel_criticality),
        ('value', _Extension_GANSS_AlmanacModel_value),
        ])
    Extension_GANSS_AlmanacModel._ext = None
    
    #-----< Extension-GANSS-AlmanacModel-IE >-----#
    Extension_GANSS_AlmanacModel_IE = CLASS(name='Extension-GANSS-AlmanacModel-IE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-NAVKeplerianSet')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-ReducedKeplerianSet')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-MidiAlmanacSet')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-GlonassAlmanacSet')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-ECEFsbasAlmanacSet')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ALM-KEPLERIANBDSALMANAC')))
    Extension_GANSS_AlmanacModel_IE._val = ASN1Set(rv=[dict([('id', 1064), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1065), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1066), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_2), ('presence', 'mandatory')]), dict([('id', 1067), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_3), ('presence', 'mandatory')]), dict([('id', 1068), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_4), ('presence', 'mandatory')]), dict([('id', 1271), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< GANSS-ALM-ECEFsbasAlmanacSet >-----#
    GANSS_ALM_ECEFsbasAlmanacSet = SEQ(name='GANSS-ALM-ECEFsbasAlmanacSet', mode=MODE_TYPE)
    _GANSS_ALM_ECEFsbasAlmanacSet_sat_info_SBASecefList = SEQ_OF(name='sat-info-SBASecefList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-SBASecefList')))
    _GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id._const_tab = ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id_tab
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item_._ext = None
    _GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions._cont = __GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item_
    _GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_ECEFsbasAlmanacSet._cont = ASN1Dict([
        ('sat-info-SBASecefList', _GANSS_ALM_ECEFsbasAlmanacSet_sat_info_SBASecefList),
        ('ie-Extensions', _GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions),
        ])
    GANSS_ALM_ECEFsbasAlmanacSet._ext = []
    
    #-----< GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs >-----#
    GANSS_ALM_ECEFsbasAlmanacSet_ExtIEs = CLASS(name='GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_ECEFsbasAlmanacSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ALM-GlonassAlmanacSet >-----#
    GANSS_ALM_GlonassAlmanacSet = SEQ(name='GANSS-ALM-GlonassAlmanacSet', mode=MODE_TYPE)
    _GANSS_ALM_GlonassAlmanacSet_sat_info_GLOkpList = SEQ_OF(name='sat-info-GLOkpList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-GLOkpList')))
    _GANSS_ALM_GlonassAlmanacSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id._const_tab = ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id_tab
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item_._ext = None
    _GANSS_ALM_GlonassAlmanacSet_ie_Extensions._cont = __GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item_
    _GANSS_ALM_GlonassAlmanacSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_GlonassAlmanacSet._cont = ASN1Dict([
        ('sat-info-GLOkpList', _GANSS_ALM_GlonassAlmanacSet_sat_info_GLOkpList),
        ('ie-Extensions', _GANSS_ALM_GlonassAlmanacSet_ie_Extensions),
        ])
    GANSS_ALM_GlonassAlmanacSet._ext = []
    
    #-----< GANSS-ALM-GlonassAlmanacSet-ExtIEs >-----#
    GANSS_ALM_GlonassAlmanacSet_ExtIEs = CLASS(name='GANSS-ALM-GlonassAlmanacSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_GlonassAlmanacSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ALM-MidiAlmanacSet >-----#
    GANSS_ALM_MidiAlmanacSet = SEQ(name='GANSS-ALM-MidiAlmanacSet', mode=MODE_TYPE)
    _GANSS_ALM_MidiAlmanacSet_t_oa = INT(name='t-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_ALM_MidiAlmanacSet_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_ALM_MidiAlmanacSet_sat_info_MIDIkpList = SEQ_OF(name='sat-info-MIDIkpList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-MIDIkpList')))
    _GANSS_ALM_MidiAlmanacSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_MidiAlmanacSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id._const_tab = ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id_tab
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_MidiAlmanacSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_MidiAlmanacSet_ie_Extensions__item_._ext = None
    _GANSS_ALM_MidiAlmanacSet_ie_Extensions._cont = __GANSS_ALM_MidiAlmanacSet_ie_Extensions__item_
    _GANSS_ALM_MidiAlmanacSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_MidiAlmanacSet._cont = ASN1Dict([
        ('t-oa', _GANSS_ALM_MidiAlmanacSet_t_oa),
        ('sat-info-MIDIkpList', _GANSS_ALM_MidiAlmanacSet_sat_info_MIDIkpList),
        ('ie-Extensions', _GANSS_ALM_MidiAlmanacSet_ie_Extensions),
        ])
    GANSS_ALM_MidiAlmanacSet._ext = []
    
    #-----< GANSS-ALM-MidiAlmanacSet-ExtIEs >-----#
    GANSS_ALM_MidiAlmanacSet_ExtIEs = CLASS(name='GANSS-ALM-MidiAlmanacSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_MidiAlmanacSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ALM-NAVKeplerianSet >-----#
    GANSS_ALM_NAVKeplerianSet = SEQ(name='GANSS-ALM-NAVKeplerianSet', mode=MODE_TYPE)
    _GANSS_ALM_NAVKeplerianSet_t_oa = INT(name='t-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_ALM_NAVKeplerianSet_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_ALM_NAVKeplerianSet_sat_info_NAVkpList = SEQ_OF(name='sat-info-NAVkpList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-NAVkpList')))
    _GANSS_ALM_NAVKeplerianSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_NAVKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id._const_tab = ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id_tab
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_NAVKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_NAVKeplerianSet_ie_Extensions__item_._ext = None
    _GANSS_ALM_NAVKeplerianSet_ie_Extensions._cont = __GANSS_ALM_NAVKeplerianSet_ie_Extensions__item_
    _GANSS_ALM_NAVKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_NAVKeplerianSet._cont = ASN1Dict([
        ('t-oa', _GANSS_ALM_NAVKeplerianSet_t_oa),
        ('sat-info-NAVkpList', _GANSS_ALM_NAVKeplerianSet_sat_info_NAVkpList),
        ('ie-Extensions', _GANSS_ALM_NAVKeplerianSet_ie_Extensions),
        ])
    GANSS_ALM_NAVKeplerianSet._ext = []
    
    #-----< GANSS-ALM-NAVKeplerianSet-ExtIEs >-----#
    GANSS_ALM_NAVKeplerianSet_ExtIEs = CLASS(name='GANSS-ALM-NAVKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_NAVKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ALM-KEPLERIANBDSALMANAC >-----#
    GANSS_ALM_KEPLERIANBDSALMANAC = SEQ(name='GANSS-ALM-KEPLERIANBDSALMANAC', mode=MODE_TYPE)
    _GANSS_ALM_KEPLERIANBDSALMANAC_sat_info_BDSkpList = SEQ_OF(name='sat-info-BDSkpList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-BDSkpList')))
    _GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__id._const_tab = ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__id_tab
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item_._ext = None
    _GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions._cont = __GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item_
    _GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_KEPLERIANBDSALMANAC._cont = ASN1Dict([
        ('sat-info-BDSkpList', _GANSS_ALM_KEPLERIANBDSALMANAC_sat_info_BDSkpList),
        ('ie-Extensions', _GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions),
        ])
    GANSS_ALM_KEPLERIANBDSALMANAC._ext = []
    
    #-----< GANSS-ALM-KEPLERIANBDSALMANAC-ExtIEs >-----#
    GANSS_ALM_KEPLERIANBDSALMANAC_ExtIEs = CLASS(name='GANSS-ALM-KEPLERIANBDSALMANAC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_KEPLERIANBDSALMANAC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ALM-ReducedKeplerianSet >-----#
    GANSS_ALM_ReducedKeplerianSet = SEQ(name='GANSS-ALM-ReducedKeplerianSet', mode=MODE_TYPE)
    _GANSS_ALM_ReducedKeplerianSet_t_oa = INT(name='t-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_ALM_ReducedKeplerianSet_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_ALM_ReducedKeplerianSet_sat_info_REDkpList = SEQ_OF(name='sat-info-REDkpList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-REDkpList')))
    _GANSS_ALM_ReducedKeplerianSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id._const_tab = ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id_tab
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item_._ext = None
    _GANSS_ALM_ReducedKeplerianSet_ie_Extensions._cont = __GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item_
    _GANSS_ALM_ReducedKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_ReducedKeplerianSet._cont = ASN1Dict([
        ('t-oa', _GANSS_ALM_ReducedKeplerianSet_t_oa),
        ('sat-info-REDkpList', _GANSS_ALM_ReducedKeplerianSet_sat_info_REDkpList),
        ('ie-Extensions', _GANSS_ALM_ReducedKeplerianSet_ie_Extensions),
        ])
    GANSS_ALM_ReducedKeplerianSet._ext = []
    
    #-----< GANSS-ALM-ReducedKeplerianSet-ExtIEs >-----#
    GANSS_ALM_ReducedKeplerianSet_ExtIEs = CLASS(name='GANSS-ALM-ReducedKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_ReducedKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Auxiliary-Information >-----#
    GANSS_Auxiliary_Information = CHOICE(name='GANSS-Auxiliary-Information', mode=MODE_TYPE)
    _GANSS_Auxiliary_Information_ganssID1 = SEQ_OF(name='ganssID1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AuxInfoGANSS-ID1')))
    _GANSS_Auxiliary_Information_ganssID3 = SEQ_OF(name='ganssID3', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AuxInfoGANSS-ID3')))
    GANSS_Auxiliary_Information._cont = ASN1Dict([
        ('ganssID1', _GANSS_Auxiliary_Information_ganssID1),
        ('ganssID3', _GANSS_Auxiliary_Information_ganssID3),
        ])
    GANSS_Auxiliary_Information._ext = []
    
    #-----< GANSS-AuxInfoGANSS-ID1 >-----#
    GANSS_AuxInfoGANSS_ID1 = SEQ_OF(name='GANSS-AuxInfoGANSS-ID1', mode=MODE_TYPE)
    _GANSS_AuxInfoGANSS_ID1__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AuxInfoGANSS-ID1-element')))
    GANSS_AuxInfoGANSS_ID1._cont = _GANSS_AuxInfoGANSS_ID1__item_
    GANSS_AuxInfoGANSS_ID1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-AuxInfoGANSS-ID1-element >-----#
    GANSS_AuxInfoGANSS_ID1_element = SEQ(name='GANSS-AuxInfoGANSS-ID1-element', mode=MODE_TYPE)
    _GANSS_AuxInfoGANSS_ID1_element_svID = INT(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_AuxInfoGANSS_ID1_element_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_AuxInfoGANSS_ID1_element_signalsAvailable = BIT_STR(name='signalsAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_AuxInfoGANSS_ID1_element_signalsAvailable._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_AuxInfoGANSS_ID1_element_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__id._const_tab = ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__id_tab
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality._const_tab = ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality_tab
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue._const_tab = ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue_tab
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__id),
        ('criticality', ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue),
        ])
    __GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item_._ext = None
    _GANSS_AuxInfoGANSS_ID1_element_ie_Extensions._cont = __GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item_
    _GANSS_AuxInfoGANSS_ID1_element_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_AuxInfoGANSS_ID1_element._cont = ASN1Dict([
        ('svID', _GANSS_AuxInfoGANSS_ID1_element_svID),
        ('signalsAvailable', _GANSS_AuxInfoGANSS_ID1_element_signalsAvailable),
        ('ie-Extensions', _GANSS_AuxInfoGANSS_ID1_element_ie_Extensions),
        ])
    GANSS_AuxInfoGANSS_ID1_element._ext = []
    
    #-----< GANSS-AuxInfoGANSS-ID1-element-ExtIEs >-----#
    GANSS_AuxInfoGANSS_ID1_element_ExtIEs = CLASS(name='GANSS-AuxInfoGANSS-ID1-element-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_AuxInfoGANSS_ID1_element_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-AuxInfoGANSS-ID3 >-----#
    GANSS_AuxInfoGANSS_ID3 = SEQ_OF(name='GANSS-AuxInfoGANSS-ID3', mode=MODE_TYPE)
    _GANSS_AuxInfoGANSS_ID3__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AuxInfoGANSS-ID3-element')))
    GANSS_AuxInfoGANSS_ID3._cont = _GANSS_AuxInfoGANSS_ID3__item_
    GANSS_AuxInfoGANSS_ID3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-AuxInfoGANSS-ID3-element >-----#
    GANSS_AuxInfoGANSS_ID3_element = SEQ(name='GANSS-AuxInfoGANSS-ID3-element', mode=MODE_TYPE)
    _GANSS_AuxInfoGANSS_ID3_element_svID = INT(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_AuxInfoGANSS_ID3_element_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_AuxInfoGANSS_ID3_element_signalsAvailable = BIT_STR(name='signalsAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_AuxInfoGANSS_ID3_element_signalsAvailable._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_AuxInfoGANSS_ID3_element_channelNumber = INT(name='channelNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_AuxInfoGANSS_ID3_element_channelNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-7, ub=13)], ev=None, er=[])
    _GANSS_AuxInfoGANSS_ID3_element_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__id._const_tab = ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__id_tab
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality._const_tab = ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality_tab
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue._const_tab = ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue_tab
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__id),
        ('criticality', ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue),
        ])
    __GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item_._ext = None
    _GANSS_AuxInfoGANSS_ID3_element_ie_Extensions._cont = __GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item_
    _GANSS_AuxInfoGANSS_ID3_element_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_AuxInfoGANSS_ID3_element._cont = ASN1Dict([
        ('svID', _GANSS_AuxInfoGANSS_ID3_element_svID),
        ('signalsAvailable', _GANSS_AuxInfoGANSS_ID3_element_signalsAvailable),
        ('channelNumber', _GANSS_AuxInfoGANSS_ID3_element_channelNumber),
        ('ie-Extensions', _GANSS_AuxInfoGANSS_ID3_element_ie_Extensions),
        ])
    GANSS_AuxInfoGANSS_ID3_element._ext = []
    
    #-----< GANSS-AuxInfoGANSS-ID3-element-ExtIEs >-----#
    GANSS_AuxInfoGANSS_ID3_element_ExtIEs = CLASS(name='GANSS-AuxInfoGANSS-ID3-element-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_AuxInfoGANSS_ID3_element_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-AuxInfoReq >-----#
    GANSS_AuxInfoReq = BOOL(name='GANSS-AuxInfoReq', mode=MODE_TYPE)
    
    #-----< GANSS-BDSclockModel >-----#
    GANSS_BDSclockModel = SEQ(name='GANSS-BDSclockModel', mode=MODE_TYPE)
    _GANSS_BDSclockModel_bdsToc = BIT_STR(name='bdsToc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsToc._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_bdsa0 = BIT_STR(name='bdsa0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsa0._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_bdsa1 = BIT_STR(name='bdsa1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsa1._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_bdsa2 = BIT_STR(name='bdsa2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsa2._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_bdsTgd1 = BIT_STR(name='bdsTgd1', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsTgd1._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_bdsAODC = BIT_STR(name='bdsAODC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsAODC._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_BDSclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_BDSclockModel_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_BDSclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_BDSclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_BDSclockModel_ie_Extensions__item__id._const_tab = ____GANSS_BDSclockModel_ie_Extensions__item__id_tab
    ___GANSS_BDSclockModel_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_BDSclockModel_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_BDSclockModel_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_BDSclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_BDSclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_BDSclockModel_ie_Extensions__item__criticality._const_tab = ____GANSS_BDSclockModel_ie_Extensions__item__criticality_tab
    ___GANSS_BDSclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_BDSclockModel_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_BDSclockModel_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_BDSclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_BDSclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_BDSclockModel_ie_Extensions__item__extensionValue._const_tab = ____GANSS_BDSclockModel_ie_Extensions__item__extensionValue_tab
    ___GANSS_BDSclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_BDSclockModel_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_BDSclockModel_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_BDSclockModel_ie_Extensions__item__id),
        ('criticality', ___GANSS_BDSclockModel_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_BDSclockModel_ie_Extensions__item__extensionValue),
        ])
    __GANSS_BDSclockModel_ie_Extensions__item_._ext = None
    _GANSS_BDSclockModel_ie_Extensions._cont = __GANSS_BDSclockModel_ie_Extensions__item_
    _GANSS_BDSclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_BDSclockModel._cont = ASN1Dict([
        ('bdsToc', _GANSS_BDSclockModel_bdsToc),
        ('bdsa0', _GANSS_BDSclockModel_bdsa0),
        ('bdsa1', _GANSS_BDSclockModel_bdsa1),
        ('bdsa2', _GANSS_BDSclockModel_bdsa2),
        ('bdsTgd1', _GANSS_BDSclockModel_bdsTgd1),
        ('bdsAODC', _GANSS_BDSclockModel_bdsAODC),
        ('ie-Extensions', _GANSS_BDSclockModel_ie_Extensions),
        ])
    GANSS_BDSclockModel._ext = []
    
    #-----< GANSS-BDSclockModel-ExtIEs >-----#
    GANSS_BDSclockModel_ExtIEs = CLASS(name='GANSS-BDSclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_BDSclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Clock-Model >-----#
    GANSS_Clock_Model = SEQ_OF(name='GANSS-Clock-Model', mode=MODE_TYPE)
    _GANSS_Clock_Model__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SatelliteClockModelItem')))
    GANSS_Clock_Model._cont = _GANSS_Clock_Model__item_
    GANSS_Clock_Model._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< GANSS-CNAVclockModel >-----#
    GANSS_CNAVclockModel = SEQ(name='GANSS-CNAVclockModel', mode=MODE_TYPE)
    _GANSS_CNAVclockModel_cnavToc = BIT_STR(name='cnavToc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavToc._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavTop = BIT_STR(name='cnavTop', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavTop._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavURA0 = BIT_STR(name='cnavURA0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavURA0._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavURA1 = BIT_STR(name='cnavURA1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavURA1._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavURA2 = BIT_STR(name='cnavURA2', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavURA2._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavAf2 = BIT_STR(name='cnavAf2', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavAf2._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavAf1 = BIT_STR(name='cnavAf1', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavAf1._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavAf0 = BIT_STR(name='cnavAf0', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavAf0._const_sz = ASN1Set(rv=[26], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavTgd = BIT_STR(name='cnavTgd', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavTgd._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl1cp = BIT_STR(name='cnavISCl1cp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl1cp._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl1cd = BIT_STR(name='cnavISCl1cd', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl1cd._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl1ca = BIT_STR(name='cnavISCl1ca', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl1ca._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl2c = BIT_STR(name='cnavISCl2c', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl2c._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl5i5 = BIT_STR(name='cnavISCl5i5', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl5i5._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl5q5 = BIT_STR(name='cnavISCl5q5', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl5q5._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_CNAVclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_CNAVclockModel_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_CNAVclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_CNAVclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_CNAVclockModel_ie_Extensions__item__id._const_tab = ____GANSS_CNAVclockModel_ie_Extensions__item__id_tab
    ___GANSS_CNAVclockModel_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_CNAVclockModel_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_CNAVclockModel_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_CNAVclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_CNAVclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_CNAVclockModel_ie_Extensions__item__criticality._const_tab = ____GANSS_CNAVclockModel_ie_Extensions__item__criticality_tab
    ___GANSS_CNAVclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_CNAVclockModel_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_CNAVclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_CNAVclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue._const_tab = ____GANSS_CNAVclockModel_ie_Extensions__item__extensionValue_tab
    ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_CNAVclockModel_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_CNAVclockModel_ie_Extensions__item__id),
        ('criticality', ___GANSS_CNAVclockModel_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue),
        ])
    __GANSS_CNAVclockModel_ie_Extensions__item_._ext = None
    _GANSS_CNAVclockModel_ie_Extensions._cont = __GANSS_CNAVclockModel_ie_Extensions__item_
    _GANSS_CNAVclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_CNAVclockModel._cont = ASN1Dict([
        ('cnavToc', _GANSS_CNAVclockModel_cnavToc),
        ('cnavTop', _GANSS_CNAVclockModel_cnavTop),
        ('cnavURA0', _GANSS_CNAVclockModel_cnavURA0),
        ('cnavURA1', _GANSS_CNAVclockModel_cnavURA1),
        ('cnavURA2', _GANSS_CNAVclockModel_cnavURA2),
        ('cnavAf2', _GANSS_CNAVclockModel_cnavAf2),
        ('cnavAf1', _GANSS_CNAVclockModel_cnavAf1),
        ('cnavAf0', _GANSS_CNAVclockModel_cnavAf0),
        ('cnavTgd', _GANSS_CNAVclockModel_cnavTgd),
        ('cnavISCl1cp', _GANSS_CNAVclockModel_cnavISCl1cp),
        ('cnavISCl1cd', _GANSS_CNAVclockModel_cnavISCl1cd),
        ('cnavISCl1ca', _GANSS_CNAVclockModel_cnavISCl1ca),
        ('cnavISCl2c', _GANSS_CNAVclockModel_cnavISCl2c),
        ('cnavISCl5i5', _GANSS_CNAVclockModel_cnavISCl5i5),
        ('cnavISCl5q5', _GANSS_CNAVclockModel_cnavISCl5q5),
        ('ie-Extensions', _GANSS_CNAVclockModel_ie_Extensions),
        ])
    GANSS_CNAVclockModel._ext = []
    
    #-----< GANSS-CNAVclockModel-ExtIEs >-----#
    GANSS_CNAVclockModel_ExtIEs = CLASS(name='GANSS-CNAVclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_CNAVclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Common-Data >-----#
    GANSS_Common_Data = SEQ(name='GANSS-Common-Data', mode=MODE_TYPE)
    _GANSS_Common_Data_ganss_Ionospheric_Model = SEQ(name='ganss-Ionospheric-Model', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Ionospheric-Model')), opt=True)
    _GANSS_Common_Data_ganss_Rx_Pos = SEQ(name='ganss-Rx-Pos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-RX-Pos')), opt=True)
    _GANSS_Common_Data_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Common_Data_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Common_Data_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Common_Data_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Additional-Ionospheric-Model')))
    _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Earth-Orientation-Parameters')))
    ____GANSS_Common_Data_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1008), ('criticality', 'ignore'), ('Extension', _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1009), ('criticality', 'ignore'), ('Extension', _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_Common_Data_ie_Extensions__item__id._const_tab = ____GANSS_Common_Data_ie_Extensions__item__id_tab
    ___GANSS_Common_Data_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Common_Data_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Common_Data_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_Common_Data_ie_Extensions__item__criticality._const_tab = ____GANSS_Common_Data_ie_Extensions__item__id_tab
    ___GANSS_Common_Data_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Common_Data_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Common_Data_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_Common_Data_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Common_Data_ie_Extensions__item__id_tab
    ___GANSS_Common_Data_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Common_Data_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Common_Data_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Common_Data_ie_Extensions__item__id),
        ('criticality', ___GANSS_Common_Data_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Common_Data_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Common_Data_ie_Extensions__item_._ext = None
    _GANSS_Common_Data_ie_Extensions._cont = __GANSS_Common_Data_ie_Extensions__item_
    _GANSS_Common_Data_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Common_Data._cont = ASN1Dict([
        ('ganss-Ionospheric-Model', _GANSS_Common_Data_ganss_Ionospheric_Model),
        ('ganss-Rx-Pos', _GANSS_Common_Data_ganss_Rx_Pos),
        ('ie-Extensions', _GANSS_Common_Data_ie_Extensions),
        ])
    GANSS_Common_Data._ext = []
    
    #-----< GANSS-Common-Data-ExtIEs >-----#
    GANSS_Common_Data_ExtIEs = CLASS(name='GANSS-Common-Data-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _GANSS_Common_Data_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Additional-Ionospheric-Model')))
    _GANSS_Common_Data_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Earth-Orientation-Parameters')))
    GANSS_Common_Data_ExtIEs._val = ASN1Set(rv=[dict([('id', 1008), ('criticality', 'ignore'), ('Extension', _GANSS_Common_Data_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1009), ('criticality', 'ignore'), ('Extension', _GANSS_Common_Data_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-CommonDataInfoReq >-----#
    GANSS_CommonDataInfoReq = SEQ(name='GANSS-CommonDataInfoReq', mode=MODE_TYPE)
    _GANSS_CommonDataInfoReq_ionospheric_Model = BOOL(name='ionospheric-Model', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CommonDataInfoReq_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_CommonDataInfoReq_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AddIonoModelReq')))
    _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-EarthOrientParaReq')))
    ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1001), ('criticality', 'ignore'), ('Extension', _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1002), ('criticality', 'ignore'), ('Extension', _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__id._const_tab = ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality._const_tab = ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue._const_tab = ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_CommonDataInfoReq_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_CommonDataInfoReq_ie_Extensions__item__id),
        ('criticality', ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue),
        ])
    __GANSS_CommonDataInfoReq_ie_Extensions__item_._ext = None
    _GANSS_CommonDataInfoReq_ie_Extensions._cont = __GANSS_CommonDataInfoReq_ie_Extensions__item_
    _GANSS_CommonDataInfoReq_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_CommonDataInfoReq._cont = ASN1Dict([
        ('ionospheric-Model', _GANSS_CommonDataInfoReq_ionospheric_Model),
        ('ie-Extensions', _GANSS_CommonDataInfoReq_ie_Extensions),
        ])
    GANSS_CommonDataInfoReq._ext = []
    
    #-----< GANSS-CommonDataInfoReq-ExtIEs >-----#
    GANSS_CommonDataInfoReq_ExtIEs = CLASS(name='GANSS-CommonDataInfoReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AddIonoModelReq')))
    _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-EarthOrientParaReq')))
    GANSS_CommonDataInfoReq_ExtIEs._val = ASN1Set(rv=[dict([('id', 1001), ('criticality', 'ignore'), ('Extension', _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1002), ('criticality', 'ignore'), ('Extension', _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Data-Bit-Assistance >-----#
    GANSS_Data_Bit_Assistance = SEQ(name='GANSS-Data-Bit-Assistance', mode=MODE_TYPE)
    _GANSS_Data_Bit_Assistance_ganssTod = INT(name='ganssTod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Data_Bit_Assistance_ganssTod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=[], er=[])
    _GANSS_Data_Bit_Assistance_dataBitAssistancelist = SEQ_OF(name='dataBitAssistancelist', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-DataBitAssistanceList')))
    _GANSS_Data_Bit_Assistance_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Data_Bit_Assistance_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id._const_tab = ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality._const_tab = ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Data_Bit_Assistance_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id),
        ('criticality', ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Data_Bit_Assistance_ie_Extensions__item_._ext = None
    _GANSS_Data_Bit_Assistance_ie_Extensions._cont = __GANSS_Data_Bit_Assistance_ie_Extensions__item_
    _GANSS_Data_Bit_Assistance_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Data_Bit_Assistance._cont = ASN1Dict([
        ('ganssTod', _GANSS_Data_Bit_Assistance_ganssTod),
        ('dataBitAssistancelist', _GANSS_Data_Bit_Assistance_dataBitAssistancelist),
        ('ie-Extensions', _GANSS_Data_Bit_Assistance_ie_Extensions),
        ])
    GANSS_Data_Bit_Assistance._ext = []
    
    #-----< GANSS-Data-Bit-Assistance-ExtIEs >-----#
    GANSS_Data_Bit_Assistance_ExtIEs = CLASS(name='GANSS-Data-Bit-Assistance-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_Data_Bit_Assistance_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-DataBitAssistanceList >-----#
    GANSS_DataBitAssistanceList = SEQ_OF(name='GANSS-DataBitAssistanceList', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-DataBitAssistanceItem')))
    GANSS_DataBitAssistanceList._cont = _GANSS_DataBitAssistanceList__item_
    GANSS_DataBitAssistanceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-DataBitAssistanceItem >-----#
    GANSS_DataBitAssistanceItem = SEQ(name='GANSS-DataBitAssistanceItem', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceItem_satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_DataBitAssistanceItem_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_DataBitAssistanceItem_dataBitAssistanceSgnList = SEQ_OF(name='dataBitAssistanceSgnList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-DataBitAssistanceSgnList')))
    _GANSS_DataBitAssistanceItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_DataBitAssistanceItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id._const_tab = ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality._const_tab = ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_DataBitAssistanceItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_DataBitAssistanceItem_ie_Extensions__item_._ext = None
    _GANSS_DataBitAssistanceItem_ie_Extensions._cont = __GANSS_DataBitAssistanceItem_ie_Extensions__item_
    _GANSS_DataBitAssistanceItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_DataBitAssistanceItem._cont = ASN1Dict([
        ('satId', _GANSS_DataBitAssistanceItem_satId),
        ('dataBitAssistanceSgnList', _GANSS_DataBitAssistanceItem_dataBitAssistanceSgnList),
        ('ie-Extensions', _GANSS_DataBitAssistanceItem_ie_Extensions),
        ])
    GANSS_DataBitAssistanceItem._ext = []
    
    #-----< GANSS-DataBitAssistanceItem-ExtIEs >-----#
    GANSS_DataBitAssistanceItem_ExtIEs = CLASS(name='GANSS-DataBitAssistanceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_DataBitAssistanceItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-DataBitAssistanceSgnList >-----#
    GANSS_DataBitAssistanceSgnList = SEQ_OF(name='GANSS-DataBitAssistanceSgnList', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceSgnList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-DataBitAssistanceSgnItem')))
    GANSS_DataBitAssistanceSgnList._cont = _GANSS_DataBitAssistanceSgnList__item_
    GANSS_DataBitAssistanceSgnList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GANSS-DataBitAssistanceSgnItem >-----#
    GANSS_DataBitAssistanceSgnItem = SEQ(name='GANSS-DataBitAssistanceSgnItem', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceSgnItem_ganss_SignalId = INT(name='ganss-SignalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Signal-ID')))
    _GANSS_DataBitAssistanceSgnItem_ganssDataBits = BIT_STR(name='ganssDataBits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_DataBitAssistanceSgnItem_ganssDataBits._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _GANSS_DataBitAssistanceSgnItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id._const_tab = ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality._const_tab = ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_._ext = None
    _GANSS_DataBitAssistanceSgnItem_ie_Extensions._cont = __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_
    _GANSS_DataBitAssistanceSgnItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_DataBitAssistanceSgnItem._cont = ASN1Dict([
        ('ganss-SignalId', _GANSS_DataBitAssistanceSgnItem_ganss_SignalId),
        ('ganssDataBits', _GANSS_DataBitAssistanceSgnItem_ganssDataBits),
        ('ie-Extensions', _GANSS_DataBitAssistanceSgnItem_ie_Extensions),
        ])
    GANSS_DataBitAssistanceSgnItem._ext = []
    
    #-----< GANSS-DataBitAssistanceSgnItem-ExtIEs >-----#
    GANSS_DataBitAssistanceSgnItem_ExtIEs = CLASS(name='GANSS-DataBitAssistanceSgnItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_DataBitAssistanceSgnItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Data-Bit-Assistance-ReqItem >-----#
    GANSS_Data_Bit_Assistance_ReqItem = SEQ(name='GANSS-Data-Bit-Assistance-ReqItem', mode=MODE_TYPE)
    _GANSS_Data_Bit_Assistance_ReqItem_ganssTod = INT(name='ganssTod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Data_Bit_Assistance_ReqItem_ganssTod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=None, er=[])
    _GANSS_Data_Bit_Assistance_ReqItem_ganss_Data_Bit_Assistance_ReqList = SEQ(name='ganss-Data-Bit-Assistance-ReqList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Data-Bit-Assistance-ReqList')))
    _GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id._const_tab = ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id_tab
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality._const_tab = ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality_tab
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue._const_tab = ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue_tab
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id),
        ('criticality', ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue),
        ])
    __GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item_._ext = None
    _GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions._cont = __GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item_
    _GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Data_Bit_Assistance_ReqItem._cont = ASN1Dict([
        ('ganssTod', _GANSS_Data_Bit_Assistance_ReqItem_ganssTod),
        ('ganss-Data-Bit-Assistance-ReqList', _GANSS_Data_Bit_Assistance_ReqItem_ganss_Data_Bit_Assistance_ReqList),
        ('iE-Extensions', _GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions),
        ])
    GANSS_Data_Bit_Assistance_ReqItem._ext = []
    
    #-----< GANSS-Data-Bit-Assistance-ReqItem-ExtIEs >-----#
    GANSS_Data_Bit_Assistance_ReqItem_ExtIEs = CLASS(name='GANSS-Data-Bit-Assistance-ReqItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_Data_Bit_Assistance_ReqItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Data-Bit-Assistance-ReqList >-----#
    GANSS_Data_Bit_Assistance_ReqList = SEQ(name='GANSS-Data-Bit-Assistance-ReqList', mode=MODE_TYPE)
    _GANSS_Data_Bit_Assistance_ReqList_dGANSS_Signal_ID = BIT_STR(name='dGANSS-Signal-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Data_Bit_Assistance_ReqList_dGANSS_Signal_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_Data_Bit_Assistance_ReqList_ganss_DataBitInterval = INT(name='ganss-DataBitInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Data_Bit_Assistance_ReqList_ganss_DataBitInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo = SEQ_OF(name='ganss-SatelliteInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo__item_ = INT(name='_item_', mode=MODE_TYPE)
    __GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo._cont = __GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo__item_
    _GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _GANSS_Data_Bit_Assistance_ReqList_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id._const_tab = ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id_tab
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality._const_tab = ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality_tab
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue._const_tab = ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue_tab
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id),
        ('criticality', ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue),
        ])
    __GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item_._ext = None
    _GANSS_Data_Bit_Assistance_ReqList_iE_Extensions._cont = __GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item_
    _GANSS_Data_Bit_Assistance_ReqList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Data_Bit_Assistance_ReqList._cont = ASN1Dict([
        ('dGANSS-Signal-ID', _GANSS_Data_Bit_Assistance_ReqList_dGANSS_Signal_ID),
        ('ganss-DataBitInterval', _GANSS_Data_Bit_Assistance_ReqList_ganss_DataBitInterval),
        ('ganss-SatelliteInfo', _GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo),
        ('iE-Extensions', _GANSS_Data_Bit_Assistance_ReqList_iE_Extensions),
        ])
    GANSS_Data_Bit_Assistance_ReqList._ext = []
    
    #-----< GANSS-Data-Bit-Assistance-ReqList-ExtIEs >-----#
    GANSS_Data_Bit_Assistance_ReqList_ExtIEs = CLASS(name='GANSS-Data-Bit-Assistance-ReqList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_Data_Bit_Assistance_ReqList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Delta-T >-----#
    GANSS_Delta_T = INT(name='GANSS-Delta-T', mode=MODE_TYPE)
    GANSS_Delta_T._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    
    #-----< GANSS-DeltaUT1 >-----#
    GANSS_DeltaUT1 = SEQ(name='GANSS-DeltaUT1', mode=MODE_TYPE)
    _GANSS_DeltaUT1_b1 = BIT_STR(name='b1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_DeltaUT1_b1._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_DeltaUT1_b2 = BIT_STR(name='b2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_DeltaUT1_b2._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_DeltaUT1_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_DeltaUT1_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_DeltaUT1_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_DeltaUT1_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_DeltaUT1_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DeltaUT1_ie_Extensions__item__id._const_tab = ____GANSS_DeltaUT1_ie_Extensions__item__id_tab
    ___GANSS_DeltaUT1_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_DeltaUT1_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_DeltaUT1_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_DeltaUT1_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_DeltaUT1_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DeltaUT1_ie_Extensions__item__criticality._const_tab = ____GANSS_DeltaUT1_ie_Extensions__item__criticality_tab
    ___GANSS_DeltaUT1_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_DeltaUT1_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_DeltaUT1_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_DeltaUT1_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue._const_tab = ____GANSS_DeltaUT1_ie_Extensions__item__extensionValue_tab
    ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_DeltaUT1_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_DeltaUT1_ie_Extensions__item__id),
        ('criticality', ___GANSS_DeltaUT1_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue),
        ])
    __GANSS_DeltaUT1_ie_Extensions__item_._ext = None
    _GANSS_DeltaUT1_ie_Extensions._cont = __GANSS_DeltaUT1_ie_Extensions__item_
    _GANSS_DeltaUT1_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_DeltaUT1._cont = ASN1Dict([
        ('b1', _GANSS_DeltaUT1_b1),
        ('b2', _GANSS_DeltaUT1_b2),
        ('ie-Extensions', _GANSS_DeltaUT1_ie_Extensions),
        ])
    GANSS_DeltaUT1._ext = []
    
    #-----< GANSS-DeltaUT1-ExtIEs >-----#
    GANSS_DeltaUT1_ExtIEs = CLASS(name='GANSS-DeltaUT1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_DeltaUT1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Earth-Orientation-Parameters >-----#
    GANSS_Earth_Orientation_Parameters = SEQ(name='GANSS-Earth-Orientation-Parameters', mode=MODE_TYPE)
    _GANSS_Earth_Orientation_Parameters_teop = BIT_STR(name='teop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_teop._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmX = BIT_STR(name='pmX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmX._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmXdot = BIT_STR(name='pmXdot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmXdot._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmY = BIT_STR(name='pmY', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmY._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmYdot = BIT_STR(name='pmYdot', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmYdot._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_deltaUT1 = BIT_STR(name='deltaUT1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_deltaUT1._const_sz = ASN1Set(rv=[31], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_deltaUT1dot = BIT_STR(name='deltaUT1dot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_deltaUT1dot._const_sz = ASN1Set(rv=[19], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id._const_tab = ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality._const_tab = ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id),
        ('criticality', ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_._ext = None
    _GANSS_Earth_Orientation_Parameters_ie_Extensions._cont = __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_
    _GANSS_Earth_Orientation_Parameters_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Earth_Orientation_Parameters._cont = ASN1Dict([
        ('teop', _GANSS_Earth_Orientation_Parameters_teop),
        ('pmX', _GANSS_Earth_Orientation_Parameters_pmX),
        ('pmXdot', _GANSS_Earth_Orientation_Parameters_pmXdot),
        ('pmY', _GANSS_Earth_Orientation_Parameters_pmY),
        ('pmYdot', _GANSS_Earth_Orientation_Parameters_pmYdot),
        ('deltaUT1', _GANSS_Earth_Orientation_Parameters_deltaUT1),
        ('deltaUT1dot', _GANSS_Earth_Orientation_Parameters_deltaUT1dot),
        ('ie-Extensions', _GANSS_Earth_Orientation_Parameters_ie_Extensions),
        ])
    GANSS_Earth_Orientation_Parameters._ext = []
    
    #-----< GANSS-Earth-Orientation-Parameters-ExtIEs >-----#
    GANSS_Earth_Orientation_Parameters_ExtIEs = CLASS(name='GANSS-Earth-Orientation-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_Earth_Orientation_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-EarthOrientParaReq >-----#
    GANSS_EarthOrientParaReq = BOOL(name='GANSS-EarthOrientParaReq', mode=MODE_TYPE)
    
    #-----< GANSS-GenericDataInfoReqList >-----#
    GANSS_GenericDataInfoReqList = SEQ_OF(name='GANSS-GenericDataInfoReqList', mode=MODE_TYPE)
    _GANSS_GenericDataInfoReqList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-GenericDataInfoReqItem')))
    GANSS_GenericDataInfoReqList._cont = _GANSS_GenericDataInfoReqList__item_
    GANSS_GenericDataInfoReqList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GANSS-GenericDataInfoReqItem >-----#
    GANSS_GenericDataInfoReqItem = SEQ(name='GANSS-GenericDataInfoReqItem', mode=MODE_TYPE)
    _GANSS_GenericDataInfoReqItem_ganss_Id = INT(name='ganss-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ID')), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Navigation_Model_And_Time_Recovery = BOOL(name='ganss-Navigation-Model-And-Time-Recovery', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Time_Model_GNSS_GNSS = BIT_STR(name='ganss-Time-Model-GNSS-GNSS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Time_Model_GNSS_GNSS._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _GANSS_GenericDataInfoReqItem_ganss_UTC_Model = BOOL(name='ganss-UTC-Model', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Almanac = BOOL(name='ganss-Almanac', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Real_Time_Integrity = BOOL(name='ganss-Real-Time-Integrity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Data_Bit_Assistance_Req = SEQ(name='ganss-Data-Bit-Assistance-Req', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Data-Bit-Assistance-ReqItem')), opt=True)
    _GANSS_GenericDataInfoReqItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_GenericDataInfoReqItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AddNavigationModelsReq')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AddUTCModelsReq')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_2 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AuxInfoReq')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SBAS-ID')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DBDS-CorrectionsReq')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BDS-IonosphericGridModelReq')))
    ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1003), ('criticality', 'ignore'), ('Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1004), ('criticality', 'ignore'), ('Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1005), ('criticality', 'ignore'), ('Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1006), ('criticality', 'ignore'), ('Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1267), ('criticality', 'ignore'), ('Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1269), ('criticality', 'ignore'), ('Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id._const_tab = ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality._const_tab = ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_GenericDataInfoReqItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_GenericDataInfoReqItem_ie_Extensions__item_._ext = None
    _GANSS_GenericDataInfoReqItem_ie_Extensions._cont = __GANSS_GenericDataInfoReqItem_ie_Extensions__item_
    _GANSS_GenericDataInfoReqItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_GenericDataInfoReqItem._cont = ASN1Dict([
        ('ganss-Id', _GANSS_GenericDataInfoReqItem_ganss_Id),
        ('ganss-Navigation-Model-And-Time-Recovery', _GANSS_GenericDataInfoReqItem_ganss_Navigation_Model_And_Time_Recovery),
        ('ganss-Time-Model-GNSS-GNSS', _GANSS_GenericDataInfoReqItem_ganss_Time_Model_GNSS_GNSS),
        ('ganss-UTC-Model', _GANSS_GenericDataInfoReqItem_ganss_UTC_Model),
        ('ganss-Almanac', _GANSS_GenericDataInfoReqItem_ganss_Almanac),
        ('ganss-Real-Time-Integrity', _GANSS_GenericDataInfoReqItem_ganss_Real_Time_Integrity),
        ('ganss-Data-Bit-Assistance-Req', _GANSS_GenericDataInfoReqItem_ganss_Data_Bit_Assistance_Req),
        ('ie-Extensions', _GANSS_GenericDataInfoReqItem_ie_Extensions),
        ])
    GANSS_GenericDataInfoReqItem._ext = []
    
    #-----< GANSS-GenericDataInfoReqItem-ExtIEs >-----#
    GANSS_GenericDataInfoReqItem_ExtIEs = CLASS(name='GANSS-GenericDataInfoReqItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AddNavigationModelsReq')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AddUTCModelsReq')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_2 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AuxInfoReq')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SBAS-ID')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DBDS-CorrectionsReq')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BDS-IonosphericGridModelReq')))
    GANSS_GenericDataInfoReqItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 1003), ('criticality', 'ignore'), ('Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1004), ('criticality', 'ignore'), ('Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1005), ('criticality', 'ignore'), ('Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1006), ('criticality', 'ignore'), ('Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1267), ('criticality', 'ignore'), ('Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1269), ('criticality', 'ignore'), ('Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Generic-Data >-----#
    GANSS_Generic_Data = SEQ_OF(name='GANSS-Generic-Data', mode=MODE_TYPE)
    _GANSS_Generic_Data__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Generic-DataItem')))
    GANSS_Generic_Data._cont = _GANSS_Generic_Data__item_
    GANSS_Generic_Data._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GANSS-Generic-DataItem >-----#
    GANSS_Generic_DataItem = SEQ(name='GANSS-Generic-DataItem', mode=MODE_TYPE)
    _GANSS_Generic_DataItem_ganss_Id = INT(name='ganss-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-ID')), opt=True)
    _GANSS_Generic_DataItem_dganss_Correction = SEQ(name='dganss-Correction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DGANSSCorrections')), opt=True)
    _GANSS_Generic_DataItem_ganss_Navigation_Model_And_Time_Recovery = SEQ(name='ganss-Navigation-Model-And-Time-Recovery', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Navigation-Model-And-Time-Recovery')), opt=True)
    _GANSS_Generic_DataItem_ganss_Time_Model = SEQ(name='ganss-Time-Model', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Time-Model')), opt=True)
    _GANSS_Generic_DataItem_ganss_UTC_TIME = SEQ(name='ganss-UTC-TIME', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-UTC-Model')), opt=True)
    _GANSS_Generic_DataItem_ganss_Almanac = SEQ(name='ganss-Almanac', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Almanac')), opt=True)
    _GANSS_Generic_DataItem_ganss_Real_Time_Integrity = SEQ_OF(name='ganss-Real-Time-Integrity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Real-Time-Integrity')), opt=True)
    _GANSS_Generic_DataItem_ganss_Data_Bit_Assistance = SEQ(name='ganss-Data-Bit-Assistance', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Data-Bit-Assistance')), opt=True)
    _GANSS_Generic_DataItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Generic_DataItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Generic_DataItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Additional-Time-Models')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Additional-Navigation-Models')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Additional-UTC-Models')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Auxiliary-Information')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SBAS-ID')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DBDS-Corrections')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BDS-Ionospheric-Grid-Model')))
    ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1010), ('criticality', 'ignore'), ('Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1011), ('criticality', 'ignore'), ('Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1012), ('criticality', 'ignore'), ('Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1013), ('criticality', 'ignore'), ('Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1006), ('criticality', 'ignore'), ('Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1268), ('criticality', 'ignore'), ('Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1270), ('criticality', 'ignore'), ('Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_Generic_DataItem_ie_Extensions__item__id._const_tab = ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab
    ___GANSS_Generic_DataItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Generic_DataItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Generic_DataItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_Generic_DataItem_ie_Extensions__item__criticality._const_tab = ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab
    ___GANSS_Generic_DataItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Generic_DataItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab
    ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Generic_DataItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Generic_DataItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_Generic_DataItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Generic_DataItem_ie_Extensions__item_._ext = None
    _GANSS_Generic_DataItem_ie_Extensions._cont = __GANSS_Generic_DataItem_ie_Extensions__item_
    _GANSS_Generic_DataItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Generic_DataItem._cont = ASN1Dict([
        ('ganss-Id', _GANSS_Generic_DataItem_ganss_Id),
        ('dganss-Correction', _GANSS_Generic_DataItem_dganss_Correction),
        ('ganss-Navigation-Model-And-Time-Recovery', _GANSS_Generic_DataItem_ganss_Navigation_Model_And_Time_Recovery),
        ('ganss-Time-Model', _GANSS_Generic_DataItem_ganss_Time_Model),
        ('ganss-UTC-TIME', _GANSS_Generic_DataItem_ganss_UTC_TIME),
        ('ganss-Almanac', _GANSS_Generic_DataItem_ganss_Almanac),
        ('ganss-Real-Time-Integrity', _GANSS_Generic_DataItem_ganss_Real_Time_Integrity),
        ('ganss-Data-Bit-Assistance', _GANSS_Generic_DataItem_ganss_Data_Bit_Assistance),
        ('ie-Extensions', _GANSS_Generic_DataItem_ie_Extensions),
        ])
    GANSS_Generic_DataItem._ext = []
    
    #-----< GANSS-Generic-DataItem-ExtIEs >-----#
    GANSS_Generic_DataItem_ExtIEs = CLASS(name='GANSS-Generic-DataItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Additional-Time-Models')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Additional-Navigation-Models')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Additional-UTC-Models')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Auxiliary-Information')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SBAS-ID')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DBDS-Corrections')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BDS-Ionospheric-Grid-Model')))
    GANSS_Generic_DataItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 1010), ('criticality', 'ignore'), ('Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1011), ('criticality', 'ignore'), ('Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1012), ('criticality', 'ignore'), ('Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1013), ('criticality', 'ignore'), ('Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1006), ('criticality', 'ignore'), ('Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1268), ('criticality', 'ignore'), ('Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 1270), ('criticality', 'ignore'), ('Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-GLONASSclockModel >-----#
    GANSS_GLONASSclockModel = SEQ(name='GANSS-GLONASSclockModel', mode=MODE_TYPE)
    _GANSS_GLONASSclockModel_gloTau = BIT_STR(name='gloTau', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_GLONASSclockModel_gloTau._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GANSS_GLONASSclockModel_gloGamma = BIT_STR(name='gloGamma', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_GLONASSclockModel_gloGamma._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_GLONASSclockModel_gloDeltaTau = BIT_STR(name='gloDeltaTau', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GLONASSclockModel_gloDeltaTau._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_GLONASSclockModel_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_GLONASSclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_GLONASSclockModel_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_GLONASSclockModel_ie_Extensions__item__id._const_tab = ____GANSS_GLONASSclockModel_ie_Extensions__item__id_tab
    ___GANSS_GLONASSclockModel_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_GLONASSclockModel_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality._const_tab = ____GANSS_GLONASSclockModel_ie_Extensions__item__criticality_tab
    ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue._const_tab = ____GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue_tab
    ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_GLONASSclockModel_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_GLONASSclockModel_ie_Extensions__item__id),
        ('criticality', ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue),
        ])
    __GANSS_GLONASSclockModel_ie_Extensions__item_._ext = None
    _GANSS_GLONASSclockModel_ie_Extensions._cont = __GANSS_GLONASSclockModel_ie_Extensions__item_
    _GANSS_GLONASSclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_GLONASSclockModel._cont = ASN1Dict([
        ('gloTau', _GANSS_GLONASSclockModel_gloTau),
        ('gloGamma', _GANSS_GLONASSclockModel_gloGamma),
        ('gloDeltaTau', _GANSS_GLONASSclockModel_gloDeltaTau),
        ('ie-Extensions', _GANSS_GLONASSclockModel_ie_Extensions),
        ])
    GANSS_GLONASSclockModel._ext = []
    
    #-----< GANSS-GLONASSclockModel-ExtIEs >-----#
    GANSS_GLONASSclockModel_ExtIEs = CLASS(name='GANSS-GLONASSclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_GLONASSclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ID >-----#
    GANSS_ID = INT(name='GANSS-ID', mode=MODE_TYPE)
    GANSS_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< GANSS-Information >-----#
    GANSS_Information = SEQ(name='GANSS-Information', mode=MODE_TYPE)
    _GANSS_Information_gANSS_CommonDataInfoReq = SEQ(name='gANSS-CommonDataInfoReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-CommonDataInfoReq')), opt=True)
    _GANSS_Information_gANSS_GenericDataInfoReqList = SEQ_OF(name='gANSS-GenericDataInfoReqList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-GenericDataInfoReqList')), opt=True)
    _GANSS_Information_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Information_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Information_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Information_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Information_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Information_ie_Extensions__item__id._const_tab = ____GANSS_Information_ie_Extensions__item__id_tab
    ___GANSS_Information_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Information_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Information_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Information_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Information_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Information_ie_Extensions__item__criticality._const_tab = ____GANSS_Information_ie_Extensions__item__criticality_tab
    ___GANSS_Information_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Information_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Information_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Information_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Information_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Information_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Information_ie_Extensions__item__extensionValue_tab
    ___GANSS_Information_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Information_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Information_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Information_ie_Extensions__item__id),
        ('criticality', ___GANSS_Information_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Information_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Information_ie_Extensions__item_._ext = None
    _GANSS_Information_ie_Extensions._cont = __GANSS_Information_ie_Extensions__item_
    _GANSS_Information_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Information._cont = ASN1Dict([
        ('gANSS-CommonDataInfoReq', _GANSS_Information_gANSS_CommonDataInfoReq),
        ('gANSS-GenericDataInfoReqList', _GANSS_Information_gANSS_GenericDataInfoReqList),
        ('ie-Extensions', _GANSS_Information_ie_Extensions),
        ])
    GANSS_Information._ext = []
    
    #-----< GANSS-Information-ExtIEs >-----#
    GANSS_Information_ExtIEs = CLASS(name='GANSS-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Ionospheric-Model >-----#
    GANSS_Ionospheric_Model = SEQ(name='GANSS-Ionospheric-Model', mode=MODE_TYPE)
    _GANSS_Ionospheric_Model_alpha_zero_ionos = BIT_STR(name='alpha-zero-ionos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Ionospheric_Model_alpha_zero_ionos._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_Ionospheric_Model_alpha_one_ionos = BIT_STR(name='alpha-one-ionos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Ionospheric_Model_alpha_one_ionos._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_Ionospheric_Model_alpha_two_ionos = BIT_STR(name='alpha-two-ionos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Ionospheric_Model_alpha_two_ionos._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_Ionospheric_Model_gANSS_IonosphereRegionalStormFlags = SEQ(name='gANSS-IonosphereRegionalStormFlags', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-IonosphereRegionalStormFlags')), opt=True)
    _GANSS_Ionospheric_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Ionospheric_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id._const_tab = ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Ionospheric_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Ionospheric_Model_ie_Extensions__item__id),
        ('criticality', ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Ionospheric_Model_ie_Extensions__item_._ext = None
    _GANSS_Ionospheric_Model_ie_Extensions._cont = __GANSS_Ionospheric_Model_ie_Extensions__item_
    _GANSS_Ionospheric_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Ionospheric_Model._cont = ASN1Dict([
        ('alpha-zero-ionos', _GANSS_Ionospheric_Model_alpha_zero_ionos),
        ('alpha-one-ionos', _GANSS_Ionospheric_Model_alpha_one_ionos),
        ('alpha-two-ionos', _GANSS_Ionospheric_Model_alpha_two_ionos),
        ('gANSS-IonosphereRegionalStormFlags', _GANSS_Ionospheric_Model_gANSS_IonosphereRegionalStormFlags),
        ('ie-Extensions', _GANSS_Ionospheric_Model_ie_Extensions),
        ])
    GANSS_Ionospheric_Model._ext = []
    
    #-----< GANSS-Ionospheric-Model-ExtIEs >-----#
    GANSS_Ionospheric_Model_ExtIEs = CLASS(name='GANSS-Ionospheric-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_Ionospheric_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-IonosphereRegionalStormFlags >-----#
    GANSS_IonosphereRegionalStormFlags = SEQ(name='GANSS-IonosphereRegionalStormFlags', mode=MODE_TYPE)
    _GANSS_IonosphereRegionalStormFlags_storm_flag_one = BOOL(name='storm-flag-one', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_two = BOOL(name='storm-flag-two', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_three = BOOL(name='storm-flag-three', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_four = BOOL(name='storm-flag-four', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_five = BOOL(name='storm-flag-five', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id._const_tab = ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality._const_tab = ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue._const_tab = ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id),
        ('criticality', ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue),
        ])
    __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_._ext = None
    _GANSS_IonosphereRegionalStormFlags_ie_Extensions._cont = __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_
    _GANSS_IonosphereRegionalStormFlags_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_IonosphereRegionalStormFlags._cont = ASN1Dict([
        ('storm-flag-one', _GANSS_IonosphereRegionalStormFlags_storm_flag_one),
        ('storm-flag-two', _GANSS_IonosphereRegionalStormFlags_storm_flag_two),
        ('storm-flag-three', _GANSS_IonosphereRegionalStormFlags_storm_flag_three),
        ('storm-flag-four', _GANSS_IonosphereRegionalStormFlags_storm_flag_four),
        ('storm-flag-five', _GANSS_IonosphereRegionalStormFlags_storm_flag_five),
        ('ie-Extensions', _GANSS_IonosphereRegionalStormFlags_ie_Extensions),
        ])
    GANSS_IonosphereRegionalStormFlags._ext = []
    
    #-----< GANSS-IonosphereRegionalStormFlags-ExtIEs >-----#
    GANSS_IonosphereRegionalStormFlags_ExtIEs = CLASS(name='GANSS-IonosphereRegionalStormFlags-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_IonosphereRegionalStormFlags_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-KeplerianParametersAlm >-----#
    GANSS_KeplerianParametersAlm = SEQ(name='GANSS-KeplerianParametersAlm', mode=MODE_TYPE)
    _GANSS_KeplerianParametersAlm_t_oa = INT(name='t-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersAlm_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _GANSS_KeplerianParametersAlm_iod_a = INT(name='iod-a', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersAlm_iod_a._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _GANSS_KeplerianParametersAlm_gANSS_SatelliteInformationKP = SEQ_OF(name='gANSS-SatelliteInformationKP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SatelliteInformationKP')))
    _GANSS_KeplerianParametersAlm_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_KeplerianParametersAlm_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id._const_tab = ____GANSS_KeplerianParametersAlm_ie_Extensions__item__id_tab
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality._const_tab = ____GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality_tab
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue._const_tab = ____GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue_tab
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_KeplerianParametersAlm_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id),
        ('criticality', ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue),
        ])
    __GANSS_KeplerianParametersAlm_ie_Extensions__item_._ext = None
    _GANSS_KeplerianParametersAlm_ie_Extensions._cont = __GANSS_KeplerianParametersAlm_ie_Extensions__item_
    _GANSS_KeplerianParametersAlm_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_KeplerianParametersAlm._cont = ASN1Dict([
        ('t-oa', _GANSS_KeplerianParametersAlm_t_oa),
        ('iod-a', _GANSS_KeplerianParametersAlm_iod_a),
        ('gANSS-SatelliteInformationKP', _GANSS_KeplerianParametersAlm_gANSS_SatelliteInformationKP),
        ('ie-Extensions', _GANSS_KeplerianParametersAlm_ie_Extensions),
        ])
    GANSS_KeplerianParametersAlm._ext = []
    
    #-----< GANSS-KeplerianParametersAlm-ExtIEs >-----#
    GANSS_KeplerianParametersAlm_ExtIEs = CLASS(name='GANSS-KeplerianParametersAlm-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_KeplerianParametersAlm_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-KeplerianParametersOrb >-----#
    GANSS_KeplerianParametersOrb = SEQ(name='GANSS-KeplerianParametersOrb', mode=MODE_TYPE)
    _GANSS_KeplerianParametersOrb_toe_nav = BIT_STR(name='toe-nav', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_toe_nav._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_ganss_omega_nav = BIT_STR(name='ganss-omega-nav', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_ganss_omega_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_delta_n_nav = BIT_STR(name='delta-n-nav', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_delta_n_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_m_zero_nav = BIT_STR(name='m-zero-nav', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_m_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_omegadot_nav = BIT_STR(name='omegadot-nav', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_omegadot_nav._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_ganss_e_nav = BIT_STR(name='ganss-e-nav', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_ganss_e_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_idot_nav = BIT_STR(name='idot-nav', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_idot_nav._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_a_sqrt_nav = BIT_STR(name='a-sqrt-nav', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_a_sqrt_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_i_zero_nav = BIT_STR(name='i-zero-nav', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_i_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_omega_zero_nav = BIT_STR(name='omega-zero-nav', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_omega_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_rs_nav = BIT_STR(name='c-rs-nav', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_rs_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_is_nav = BIT_STR(name='c-is-nav', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_is_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_us_nav = BIT_STR(name='c-us-nav', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_us_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_rc_nav = BIT_STR(name='c-rc-nav', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_rc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_ic_nav = BIT_STR(name='c-ic-nav', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_ic_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_uc_nav = BIT_STR(name='c-uc-nav', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_uc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_KeplerianParametersOrb_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id._const_tab = ____GANSS_KeplerianParametersOrb_ie_Extensions__item__id_tab
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality._const_tab = ____GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality_tab
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue._const_tab = ____GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue_tab
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_KeplerianParametersOrb_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id),
        ('criticality', ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue),
        ])
    __GANSS_KeplerianParametersOrb_ie_Extensions__item_._ext = None
    _GANSS_KeplerianParametersOrb_ie_Extensions._cont = __GANSS_KeplerianParametersOrb_ie_Extensions__item_
    _GANSS_KeplerianParametersOrb_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_KeplerianParametersOrb._cont = ASN1Dict([
        ('toe-nav', _GANSS_KeplerianParametersOrb_toe_nav),
        ('ganss-omega-nav', _GANSS_KeplerianParametersOrb_ganss_omega_nav),
        ('delta-n-nav', _GANSS_KeplerianParametersOrb_delta_n_nav),
        ('m-zero-nav', _GANSS_KeplerianParametersOrb_m_zero_nav),
        ('omegadot-nav', _GANSS_KeplerianParametersOrb_omegadot_nav),
        ('ganss-e-nav', _GANSS_KeplerianParametersOrb_ganss_e_nav),
        ('idot-nav', _GANSS_KeplerianParametersOrb_idot_nav),
        ('a-sqrt-nav', _GANSS_KeplerianParametersOrb_a_sqrt_nav),
        ('i-zero-nav', _GANSS_KeplerianParametersOrb_i_zero_nav),
        ('omega-zero-nav', _GANSS_KeplerianParametersOrb_omega_zero_nav),
        ('c-rs-nav', _GANSS_KeplerianParametersOrb_c_rs_nav),
        ('c-is-nav', _GANSS_KeplerianParametersOrb_c_is_nav),
        ('c-us-nav', _GANSS_KeplerianParametersOrb_c_us_nav),
        ('c-rc-nav', _GANSS_KeplerianParametersOrb_c_rc_nav),
        ('c-ic-nav', _GANSS_KeplerianParametersOrb_c_ic_nav),
        ('c-uc-nav', _GANSS_KeplerianParametersOrb_c_uc_nav),
        ('ie-Extensions', _GANSS_KeplerianParametersOrb_ie_Extensions),
        ])
    GANSS_KeplerianParametersOrb._ext = []
    
    #-----< GANSS-KeplerianParametersOrb-ExtIEs >-----#
    GANSS_KeplerianParametersOrb_ExtIEs = CLASS(name='GANSS-KeplerianParametersOrb-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_KeplerianParametersOrb_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NAVclockModel >-----#
    GANSS_NAVclockModel = SEQ(name='GANSS-NAVclockModel', mode=MODE_TYPE)
    _GANSS_NAVclockModel_navToc = BIT_STR(name='navToc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NAVclockModel_navToc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NAVclockModel_navaf2 = BIT_STR(name='navaf2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NAVclockModel_navaf2._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_NAVclockModel_navaf1 = BIT_STR(name='navaf1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NAVclockModel_navaf1._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NAVclockModel_navaf0 = BIT_STR(name='navaf0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NAVclockModel_navaf0._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GANSS_NAVclockModel_navTgd = BIT_STR(name='navTgd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NAVclockModel_navTgd._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_NAVclockModel_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NAVclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NAVclockModel_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_NAVclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NAVclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NAVclockModel_ie_Extensions__item__id._const_tab = ____GANSS_NAVclockModel_ie_Extensions__item__id_tab
    ___GANSS_NAVclockModel_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_NAVclockModel_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_NAVclockModel_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_NAVclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NAVclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NAVclockModel_ie_Extensions__item__criticality._const_tab = ____GANSS_NAVclockModel_ie_Extensions__item__criticality_tab
    ___GANSS_NAVclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_NAVclockModel_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_NAVclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NAVclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue._const_tab = ____GANSS_NAVclockModel_ie_Extensions__item__extensionValue_tab
    ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_NAVclockModel_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_NAVclockModel_ie_Extensions__item__id),
        ('criticality', ___GANSS_NAVclockModel_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue),
        ])
    __GANSS_NAVclockModel_ie_Extensions__item_._ext = None
    _GANSS_NAVclockModel_ie_Extensions._cont = __GANSS_NAVclockModel_ie_Extensions__item_
    _GANSS_NAVclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NAVclockModel._cont = ASN1Dict([
        ('navToc', _GANSS_NAVclockModel_navToc),
        ('navaf2', _GANSS_NAVclockModel_navaf2),
        ('navaf1', _GANSS_NAVclockModel_navaf1),
        ('navaf0', _GANSS_NAVclockModel_navaf0),
        ('navTgd', _GANSS_NAVclockModel_navTgd),
        ('ie-Extensions', _GANSS_NAVclockModel_ie_Extensions),
        ])
    GANSS_NAVclockModel._ext = []
    
    #-----< GANSS-NAVclockModel-ExtIEs >-----#
    GANSS_NAVclockModel_ExtIEs = CLASS(name='GANSS-NAVclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_NAVclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Navigation-Model-And-Time-Recovery >-----#
    GANSS_Navigation_Model_And_Time_Recovery = SEQ(name='GANSS-Navigation-Model-And-Time-Recovery', mode=MODE_TYPE)
    _GANSS_Navigation_Model_And_Time_Recovery_ganss_Transmission_Time = SEQ(name='ganss-Transmission-Time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Transmission-Time')))
    _GANSS_Navigation_Model_And_Time_Recovery_non_broadcastIndication = ENUM(name='non-broadcastIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Navigation_Model_And_Time_Recovery_non_broadcastIndication._cont = ASN1Dict([('true', 0)])
    _GANSS_Navigation_Model_And_Time_Recovery_non_broadcastIndication._ext = None
    _GANSS_Navigation_Model_And_Time_Recovery_ganssSatInfoNav = SEQ_OF(name='ganssSatInfoNav', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Sat-Info-Nav')))
    _GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id._const_tab = ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id_tab
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality._const_tab = ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality_tab
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue_tab
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id),
        ('criticality', ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item_._ext = None
    _GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions._cont = __GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item_
    _GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Navigation_Model_And_Time_Recovery._cont = ASN1Dict([
        ('ganss-Transmission-Time', _GANSS_Navigation_Model_And_Time_Recovery_ganss_Transmission_Time),
        ('non-broadcastIndication', _GANSS_Navigation_Model_And_Time_Recovery_non_broadcastIndication),
        ('ganssSatInfoNav', _GANSS_Navigation_Model_And_Time_Recovery_ganssSatInfoNav),
        ('ie-Extensions', _GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions),
        ])
    GANSS_Navigation_Model_And_Time_Recovery._ext = []
    
    #-----< GANSS-Navigation-Model-And-Time-Recovery-ExtIEs >-----#
    GANSS_Navigation_Model_And_Time_Recovery_ExtIEs = CLASS(name='GANSS-Navigation-Model-And-Time-Recovery-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_Navigation_Model_And_Time_Recovery_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NavModel-BDSKeplerianSet >-----#
    GANSS_NavModel_BDSKeplerianSet = SEQ(name='GANSS-NavModel-BDSKeplerianSet', mode=MODE_TYPE)
    _GANSS_NavModel_BDSKeplerianSet_bdsURAI = BIT_STR(name='bdsURAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsURAI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsToe = BIT_STR(name='bdsToe', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsToe._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsAPowerHalf = BIT_STR(name='bdsAPowerHalf', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsAPowerHalf._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsE = BIT_STR(name='bdsE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsE._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsW = BIT_STR(name='bdsW', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsW._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsDeltaN = BIT_STR(name='bdsDeltaN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsDeltaN._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsM0 = BIT_STR(name='bdsM0', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsM0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsOmega0 = BIT_STR(name='bdsOmega0', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsOmega0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsOmegaDot = BIT_STR(name='bdsOmegaDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsOmegaDot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsI0 = BIT_STR(name='bdsI0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsI0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsIDot = BIT_STR(name='bdsIDot', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsIDot._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCuc = BIT_STR(name='bdsCuc', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCuc._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCus = BIT_STR(name='bdsCus', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCus._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCrc = BIT_STR(name='bdsCrc', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCrc._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCrs = BIT_STR(name='bdsCrs', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCrs._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCic = BIT_STR(name='bdsCic', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCic._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCis = BIT_STR(name='bdsCis', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCis._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsAODE = BIT_STR(name='bdsAODE', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsAODE._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__id._const_tab = ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__id_tab
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__criticality._const_tab = ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__criticality_tab
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item_._ext = None
    _GANSS_NavModel_BDSKeplerianSet_ie_Extensions._cont = __GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item_
    _GANSS_NavModel_BDSKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NavModel_BDSKeplerianSet._cont = ASN1Dict([
        ('bdsURAI', _GANSS_NavModel_BDSKeplerianSet_bdsURAI),
        ('bdsToe', _GANSS_NavModel_BDSKeplerianSet_bdsToe),
        ('bdsAPowerHalf', _GANSS_NavModel_BDSKeplerianSet_bdsAPowerHalf),
        ('bdsE', _GANSS_NavModel_BDSKeplerianSet_bdsE),
        ('bdsW', _GANSS_NavModel_BDSKeplerianSet_bdsW),
        ('bdsDeltaN', _GANSS_NavModel_BDSKeplerianSet_bdsDeltaN),
        ('bdsM0', _GANSS_NavModel_BDSKeplerianSet_bdsM0),
        ('bdsOmega0', _GANSS_NavModel_BDSKeplerianSet_bdsOmega0),
        ('bdsOmegaDot', _GANSS_NavModel_BDSKeplerianSet_bdsOmegaDot),
        ('bdsI0', _GANSS_NavModel_BDSKeplerianSet_bdsI0),
        ('bdsIDot', _GANSS_NavModel_BDSKeplerianSet_bdsIDot),
        ('bdsCuc', _GANSS_NavModel_BDSKeplerianSet_bdsCuc),
        ('bdsCus', _GANSS_NavModel_BDSKeplerianSet_bdsCus),
        ('bdsCrc', _GANSS_NavModel_BDSKeplerianSet_bdsCrc),
        ('bdsCrs', _GANSS_NavModel_BDSKeplerianSet_bdsCrs),
        ('bdsCic', _GANSS_NavModel_BDSKeplerianSet_bdsCic),
        ('bdsCis', _GANSS_NavModel_BDSKeplerianSet_bdsCis),
        ('bdsAODE', _GANSS_NavModel_BDSKeplerianSet_bdsAODE),
        ('ie-Extensions', _GANSS_NavModel_BDSKeplerianSet_ie_Extensions),
        ])
    GANSS_NavModel_BDSKeplerianSet._ext = []
    
    #-----< GANSS-NavModel-BDSKeplerianSet-ExtIEs >-----#
    GANSS_NavModel_BDSKeplerianSet_ExtIEs = CLASS(name='GANSS-NavModel-BDSKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_NavModel_BDSKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NavModel-CNAVKeplerianSet >-----#
    GANSS_NavModel_CNAVKeplerianSet = SEQ(name='GANSS-NavModel-CNAVKeplerianSet', mode=MODE_TYPE)
    _GANSS_NavModel_CNAVKeplerianSet_cnavTop = BIT_STR(name='cnavTop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavTop._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavURAindex = BIT_STR(name='cnavURAindex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavURAindex._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaA = BIT_STR(name='cnavDeltaA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaA._const_sz = ASN1Set(rv=[26], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavAdot = BIT_STR(name='cnavAdot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavAdot._const_sz = ASN1Set(rv=[25], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNo = BIT_STR(name='cnavDeltaNo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNo._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNoDot = BIT_STR(name='cnavDeltaNoDot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNoDot._const_sz = ASN1Set(rv=[23], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavMo = BIT_STR(name='cnavMo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavMo._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavE = BIT_STR(name='cnavE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavE._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavOmega = BIT_STR(name='cnavOmega', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavOmega._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavOMEGA0 = BIT_STR(name='cnavOMEGA0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavOMEGA0._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot = BIT_STR(name='cnavDeltaOmegaDot', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavIo = BIT_STR(name='cnavIo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavIo._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavIoDot = BIT_STR(name='cnavIoDot', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavIoDot._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCis = BIT_STR(name='cnavCis', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCis._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCic = BIT_STR(name='cnavCic', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCic._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCrs = BIT_STR(name='cnavCrs', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCrs._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCrc = BIT_STR(name='cnavCrc', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCrc._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCus = BIT_STR(name='cnavCus', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCus._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCuc = BIT_STR(name='cnavCuc', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCuc._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id._const_tab = ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality._const_tab = ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item_._ext = None
    _GANSS_NavModel_CNAVKeplerianSet_ie_Extensions._cont = __GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item_
    _GANSS_NavModel_CNAVKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NavModel_CNAVKeplerianSet._cont = ASN1Dict([
        ('cnavTop', _GANSS_NavModel_CNAVKeplerianSet_cnavTop),
        ('cnavURAindex', _GANSS_NavModel_CNAVKeplerianSet_cnavURAindex),
        ('cnavDeltaA', _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaA),
        ('cnavAdot', _GANSS_NavModel_CNAVKeplerianSet_cnavAdot),
        ('cnavDeltaNo', _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNo),
        ('cnavDeltaNoDot', _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNoDot),
        ('cnavMo', _GANSS_NavModel_CNAVKeplerianSet_cnavMo),
        ('cnavE', _GANSS_NavModel_CNAVKeplerianSet_cnavE),
        ('cnavOmega', _GANSS_NavModel_CNAVKeplerianSet_cnavOmega),
        ('cnavOMEGA0', _GANSS_NavModel_CNAVKeplerianSet_cnavOMEGA0),
        ('cnavDeltaOmegaDot', _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot),
        ('cnavIo', _GANSS_NavModel_CNAVKeplerianSet_cnavIo),
        ('cnavIoDot', _GANSS_NavModel_CNAVKeplerianSet_cnavIoDot),
        ('cnavCis', _GANSS_NavModel_CNAVKeplerianSet_cnavCis),
        ('cnavCic', _GANSS_NavModel_CNAVKeplerianSet_cnavCic),
        ('cnavCrs', _GANSS_NavModel_CNAVKeplerianSet_cnavCrs),
        ('cnavCrc', _GANSS_NavModel_CNAVKeplerianSet_cnavCrc),
        ('cnavCus', _GANSS_NavModel_CNAVKeplerianSet_cnavCus),
        ('cnavCuc', _GANSS_NavModel_CNAVKeplerianSet_cnavCuc),
        ('ie-Extensions', _GANSS_NavModel_CNAVKeplerianSet_ie_Extensions),
        ])
    GANSS_NavModel_CNAVKeplerianSet._ext = []
    
    #-----< GANSS-NavModel-CNAVKeplerianSet-ExtIEs >-----#
    GANSS_NavModel_CNAVKeplerianSet_ExtIEs = CLASS(name='GANSS-NavModel-CNAVKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_NavModel_CNAVKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NavModel-GLONASSecef >-----#
    GANSS_NavModel_GLONASSecef = SEQ(name='GANSS-NavModel-GLONASSecef', mode=MODE_TYPE)
    _GANSS_NavModel_GLONASSecef_gloEn = BIT_STR(name='gloEn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloEn._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloP1 = BIT_STR(name='gloP1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloP1._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloP2 = BIT_STR(name='gloP2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloP2._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloM = BIT_STR(name='gloM', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_NavModel_GLONASSecef_gloM._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloX = BIT_STR(name='gloX', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloX._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloXdot = BIT_STR(name='gloXdot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloXdot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloXdotdot = BIT_STR(name='gloXdotdot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloXdotdot._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloY = BIT_STR(name='gloY', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloY._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloYdot = BIT_STR(name='gloYdot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloYdot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloYdotdot = BIT_STR(name='gloYdotdot', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloYdotdot._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloZ = BIT_STR(name='gloZ', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloZ._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloZdot = BIT_STR(name='gloZdot', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloZdot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloZdotdot = BIT_STR(name='gloZdotdot', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloZdotdot._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NavModel_GLONASSecef_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id._const_tab = ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__id_tab
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality._const_tab = ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality_tab
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue._const_tab = ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_NavModel_GLONASSecef_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id),
        ('criticality', ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue),
        ])
    __GANSS_NavModel_GLONASSecef_ie_Extensions__item_._ext = None
    _GANSS_NavModel_GLONASSecef_ie_Extensions._cont = __GANSS_NavModel_GLONASSecef_ie_Extensions__item_
    _GANSS_NavModel_GLONASSecef_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NavModel_GLONASSecef._cont = ASN1Dict([
        ('gloEn', _GANSS_NavModel_GLONASSecef_gloEn),
        ('gloP1', _GANSS_NavModel_GLONASSecef_gloP1),
        ('gloP2', _GANSS_NavModel_GLONASSecef_gloP2),
        ('gloM', _GANSS_NavModel_GLONASSecef_gloM),
        ('gloX', _GANSS_NavModel_GLONASSecef_gloX),
        ('gloXdot', _GANSS_NavModel_GLONASSecef_gloXdot),
        ('gloXdotdot', _GANSS_NavModel_GLONASSecef_gloXdotdot),
        ('gloY', _GANSS_NavModel_GLONASSecef_gloY),
        ('gloYdot', _GANSS_NavModel_GLONASSecef_gloYdot),
        ('gloYdotdot', _GANSS_NavModel_GLONASSecef_gloYdotdot),
        ('gloZ', _GANSS_NavModel_GLONASSecef_gloZ),
        ('gloZdot', _GANSS_NavModel_GLONASSecef_gloZdot),
        ('gloZdotdot', _GANSS_NavModel_GLONASSecef_gloZdotdot),
        ('ie-Extensions', _GANSS_NavModel_GLONASSecef_ie_Extensions),
        ])
    GANSS_NavModel_GLONASSecef._ext = []
    
    #-----< GANSS-NavModel-GLONASSecef-ExtIEs >-----#
    GANSS_NavModel_GLONASSecef_ExtIEs = CLASS(name='GANSS-NavModel-GLONASSecef-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_NavModel_GLONASSecef_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NavModel-NAVKeplerianSet >-----#
    GANSS_NavModel_NAVKeplerianSet = SEQ(name='GANSS-NavModel-NAVKeplerianSet', mode=MODE_TYPE)
    _GANSS_NavModel_NAVKeplerianSet_navURA = BIT_STR(name='navURA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navURA._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navFitFlag = BIT_STR(name='navFitFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navFitFlag._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navToe = BIT_STR(name='navToe', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navToe._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navOmega = BIT_STR(name='navOmega', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navOmega._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navDeltaN = BIT_STR(name='navDeltaN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navDeltaN._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navM0 = BIT_STR(name='navM0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navM0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navOmegaADot = BIT_STR(name='navOmegaADot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navOmegaADot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navE = BIT_STR(name='navE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navE._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navIDot = BIT_STR(name='navIDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navIDot._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navAPowerHalf = BIT_STR(name='navAPowerHalf', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navAPowerHalf._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navI0 = BIT_STR(name='navI0', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navI0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navOmegaA0 = BIT_STR(name='navOmegaA0', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navOmegaA0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCrs = BIT_STR(name='navCrs', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCrs._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCis = BIT_STR(name='navCis', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCis._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCus = BIT_STR(name='navCus', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCus._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCrc = BIT_STR(name='navCrc', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCrc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCic = BIT_STR(name='navCic', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCic._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCuc = BIT_STR(name='navCuc', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCuc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id._const_tab = ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab = ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item_._ext = None
    _GANSS_NavModel_NAVKeplerianSet_ie_Extensions._cont = __GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item_
    _GANSS_NavModel_NAVKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NavModel_NAVKeplerianSet._cont = ASN1Dict([
        ('navURA', _GANSS_NavModel_NAVKeplerianSet_navURA),
        ('navFitFlag', _GANSS_NavModel_NAVKeplerianSet_navFitFlag),
        ('navToe', _GANSS_NavModel_NAVKeplerianSet_navToe),
        ('navOmega', _GANSS_NavModel_NAVKeplerianSet_navOmega),
        ('navDeltaN', _GANSS_NavModel_NAVKeplerianSet_navDeltaN),
        ('navM0', _GANSS_NavModel_NAVKeplerianSet_navM0),
        ('navOmegaADot', _GANSS_NavModel_NAVKeplerianSet_navOmegaADot),
        ('navE', _GANSS_NavModel_NAVKeplerianSet_navE),
        ('navIDot', _GANSS_NavModel_NAVKeplerianSet_navIDot),
        ('navAPowerHalf', _GANSS_NavModel_NAVKeplerianSet_navAPowerHalf),
        ('navI0', _GANSS_NavModel_NAVKeplerianSet_navI0),
        ('navOmegaA0', _GANSS_NavModel_NAVKeplerianSet_navOmegaA0),
        ('navCrs', _GANSS_NavModel_NAVKeplerianSet_navCrs),
        ('navCis', _GANSS_NavModel_NAVKeplerianSet_navCis),
        ('navCus', _GANSS_NavModel_NAVKeplerianSet_navCus),
        ('navCrc', _GANSS_NavModel_NAVKeplerianSet_navCrc),
        ('navCic', _GANSS_NavModel_NAVKeplerianSet_navCic),
        ('navCuc', _GANSS_NavModel_NAVKeplerianSet_navCuc),
        ('ie-Extensions', _GANSS_NavModel_NAVKeplerianSet_ie_Extensions),
        ])
    GANSS_NavModel_NAVKeplerianSet._ext = []
    
    #-----< GANSS-NavModel-NAVKeplerianSet-ExtIEs >-----#
    GANSS_NavModel_NAVKeplerianSet_ExtIEs = CLASS(name='GANSS-NavModel-NAVKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_NavModel_NAVKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NavModel-SBASecef >-----#
    GANSS_NavModel_SBASecef = SEQ(name='GANSS-NavModel-SBASecef', mode=MODE_TYPE)
    _GANSS_NavModel_SBASecef_sbasTo = BIT_STR(name='sbasTo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_NavModel_SBASecef_sbasTo._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasAccuracy = BIT_STR(name='sbasAccuracy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasAccuracy._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasXg = BIT_STR(name='sbasXg', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasXg._const_sz = ASN1Set(rv=[30], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasYg = BIT_STR(name='sbasYg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasYg._const_sz = ASN1Set(rv=[30], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasZg = BIT_STR(name='sbasZg', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasZg._const_sz = ASN1Set(rv=[25], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasXgDot = BIT_STR(name='sbasXgDot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasXgDot._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasYgDot = BIT_STR(name='sbasYgDot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasYgDot._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasZgDot = BIT_STR(name='sbasZgDot', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasZgDot._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasXgDotDot = BIT_STR(name='sbasXgDotDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasXgDotDot._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbagYgDotDot = BIT_STR(name='sbagYgDotDot', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbagYgDotDot._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasZgDotDot = BIT_STR(name='sbasZgDotDot', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasZgDotDot._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NavModel_SBASecef_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__id._const_tab = ____GANSS_NavModel_SBASecef_ie_Extensions__item__id_tab
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality._const_tab = ____GANSS_NavModel_SBASecef_ie_Extensions__item__criticality_tab
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue._const_tab = ____GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue_tab
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_NavModel_SBASecef_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_NavModel_SBASecef_ie_Extensions__item__id),
        ('criticality', ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue),
        ])
    __GANSS_NavModel_SBASecef_ie_Extensions__item_._ext = None
    _GANSS_NavModel_SBASecef_ie_Extensions._cont = __GANSS_NavModel_SBASecef_ie_Extensions__item_
    _GANSS_NavModel_SBASecef_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NavModel_SBASecef._cont = ASN1Dict([
        ('sbasTo', _GANSS_NavModel_SBASecef_sbasTo),
        ('sbasAccuracy', _GANSS_NavModel_SBASecef_sbasAccuracy),
        ('sbasXg', _GANSS_NavModel_SBASecef_sbasXg),
        ('sbasYg', _GANSS_NavModel_SBASecef_sbasYg),
        ('sbasZg', _GANSS_NavModel_SBASecef_sbasZg),
        ('sbasXgDot', _GANSS_NavModel_SBASecef_sbasXgDot),
        ('sbasYgDot', _GANSS_NavModel_SBASecef_sbasYgDot),
        ('sbasZgDot', _GANSS_NavModel_SBASecef_sbasZgDot),
        ('sbasXgDotDot', _GANSS_NavModel_SBASecef_sbasXgDotDot),
        ('sbagYgDotDot', _GANSS_NavModel_SBASecef_sbagYgDotDot),
        ('sbasZgDotDot', _GANSS_NavModel_SBASecef_sbasZgDotDot),
        ('ie-Extensions', _GANSS_NavModel_SBASecef_ie_Extensions),
        ])
    GANSS_NavModel_SBASecef._ext = []
    
    #-----< GANSS-NavModel-SBASecef-ExtIEs >-----#
    GANSS_NavModel_SBASecef_ExtIEs = CLASS(name='GANSS-NavModel-SBASecef-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_NavModel_SBASecef_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Orbit-Model >-----#
    GANSS_Orbit_Model = CHOICE(name='GANSS-Orbit-Model', mode=MODE_TYPE)
    _GANSS_Orbit_Model_gANSS_keplerianParameters = SEQ(name='gANSS-keplerianParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-KeplerianParametersOrb')))
    GANSS_Orbit_Model._cont = ASN1Dict([
        ('gANSS-keplerianParameters', _GANSS_Orbit_Model_gANSS_keplerianParameters),
        ])
    GANSS_Orbit_Model._ext = []
    
    #-----< GANSS-Real-Time-Integrity >-----#
    GANSS_Real_Time_Integrity = SEQ_OF(name='GANSS-Real-Time-Integrity', mode=MODE_TYPE)
    _GANSS_Real_Time_Integrity__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-RealTimeInformationItem')))
    GANSS_Real_Time_Integrity._cont = _GANSS_Real_Time_Integrity__item_
    GANSS_Real_Time_Integrity._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-RealTimeInformationItem >-----#
    GANSS_RealTimeInformationItem = SEQ(name='GANSS-RealTimeInformationItem', mode=MODE_TYPE)
    _GANSS_RealTimeInformationItem_bad_ganss_satId = INT(name='bad-ganss-satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RealTimeInformationItem_bad_ganss_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_RealTimeInformationItem_bad_ganss_signalId = BIT_STR(name='bad-ganss-signalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_RealTimeInformationItem_bad_ganss_signalId._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_RealTimeInformationItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_RealTimeInformationItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__id._const_tab = ____GANSS_RealTimeInformationItem_ie_Extensions__item__id_tab
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality._const_tab = ____GANSS_RealTimeInformationItem_ie_Extensions__item__criticality_tab
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_RealTimeInformationItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_RealTimeInformationItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_RealTimeInformationItem_ie_Extensions__item_._ext = None
    _GANSS_RealTimeInformationItem_ie_Extensions._cont = __GANSS_RealTimeInformationItem_ie_Extensions__item_
    _GANSS_RealTimeInformationItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_RealTimeInformationItem._cont = ASN1Dict([
        ('bad-ganss-satId', _GANSS_RealTimeInformationItem_bad_ganss_satId),
        ('bad-ganss-signalId', _GANSS_RealTimeInformationItem_bad_ganss_signalId),
        ('ie-Extensions', _GANSS_RealTimeInformationItem_ie_Extensions),
        ])
    GANSS_RealTimeInformationItem._ext = []
    
    #-----< GANSS-RealTimeInformationItem-ExtIEs >-----#
    GANSS_RealTimeInformationItem_ExtIEs = CLASS(name='GANSS-RealTimeInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_RealTimeInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-RX-Pos >-----#
    GANSS_RX_Pos = SEQ(name='GANSS-RX-Pos', mode=MODE_TYPE)
    _GANSS_RX_Pos_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RX_Pos_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _GANSS_RX_Pos_latitudeSign._ext = None
    _GANSS_RX_Pos_degreesOfLatitude = INT(name='degreesOfLatitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RX_Pos_degreesOfLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    _GANSS_RX_Pos_degreesOfLongitude = INT(name='degreesOfLongitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RX_Pos_degreesOfLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _GANSS_RX_Pos_directionOfAltitude = ENUM(name='directionOfAltitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RX_Pos_directionOfAltitude._cont = ASN1Dict([('height', 0), ('depth', 1)])
    _GANSS_RX_Pos_directionOfAltitude._ext = None
    _GANSS_RX_Pos_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RX_Pos_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _GANSS_RX_Pos_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_RX_Pos_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_RX_Pos_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_RX_Pos_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_RX_Pos_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RX_Pos_ie_Extensions__item__id._const_tab = ____GANSS_RX_Pos_ie_Extensions__item__id_tab
    ___GANSS_RX_Pos_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_RX_Pos_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_RX_Pos_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_RX_Pos_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_RX_Pos_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RX_Pos_ie_Extensions__item__criticality._const_tab = ____GANSS_RX_Pos_ie_Extensions__item__criticality_tab
    ___GANSS_RX_Pos_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_RX_Pos_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_RX_Pos_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_RX_Pos_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_RX_Pos_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RX_Pos_ie_Extensions__item__extensionValue._const_tab = ____GANSS_RX_Pos_ie_Extensions__item__extensionValue_tab
    ___GANSS_RX_Pos_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_RX_Pos_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_RX_Pos_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_RX_Pos_ie_Extensions__item__id),
        ('criticality', ___GANSS_RX_Pos_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_RX_Pos_ie_Extensions__item__extensionValue),
        ])
    __GANSS_RX_Pos_ie_Extensions__item_._ext = None
    _GANSS_RX_Pos_ie_Extensions._cont = __GANSS_RX_Pos_ie_Extensions__item_
    _GANSS_RX_Pos_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_RX_Pos._cont = ASN1Dict([
        ('latitudeSign', _GANSS_RX_Pos_latitudeSign),
        ('degreesOfLatitude', _GANSS_RX_Pos_degreesOfLatitude),
        ('degreesOfLongitude', _GANSS_RX_Pos_degreesOfLongitude),
        ('directionOfAltitude', _GANSS_RX_Pos_directionOfAltitude),
        ('altitude', _GANSS_RX_Pos_altitude),
        ('ie-Extensions', _GANSS_RX_Pos_ie_Extensions),
        ])
    GANSS_RX_Pos._ext = []
    
    #-----< GANSS-RX-Pos-ExtIEs >-----#
    GANSS_RX_Pos_ExtIEs = CLASS(name='GANSS-RX-Pos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_RX_Pos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SatelliteClockModelItem >-----#
    GANSS_SatelliteClockModelItem = SEQ(name='GANSS-SatelliteClockModelItem', mode=MODE_TYPE)
    _GANSS_SatelliteClockModelItem_t_oc = BIT_STR(name='t-oc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteClockModelItem_t_oc._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_a_i2 = BIT_STR(name='a-i2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteClockModelItem_a_i2._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_a_i1 = BIT_STR(name='a-i1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteClockModelItem_a_i1._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_a_i0 = BIT_STR(name='a-i0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteClockModelItem_a_i0._const_sz = ASN1Set(rv=[31], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_t_gd = BIT_STR(name='t-gd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_SatelliteClockModelItem_t_gd._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_sisa = BIT_STR(name='sisa', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteClockModelItem_sisa._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_model_id = INT(name='model-id', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_SatelliteClockModelItem_model_id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=[], er=[])
    _GANSS_SatelliteClockModelItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SatelliteClockModelItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id._const_tab = ____GANSS_SatelliteClockModelItem_ie_Extensions__item__id_tab
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality._const_tab = ____GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality_tab
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SatelliteClockModelItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SatelliteClockModelItem_ie_Extensions__item_._ext = None
    _GANSS_SatelliteClockModelItem_ie_Extensions._cont = __GANSS_SatelliteClockModelItem_ie_Extensions__item_
    _GANSS_SatelliteClockModelItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SatelliteClockModelItem._cont = ASN1Dict([
        ('t-oc', _GANSS_SatelliteClockModelItem_t_oc),
        ('a-i2', _GANSS_SatelliteClockModelItem_a_i2),
        ('a-i1', _GANSS_SatelliteClockModelItem_a_i1),
        ('a-i0', _GANSS_SatelliteClockModelItem_a_i0),
        ('t-gd', _GANSS_SatelliteClockModelItem_t_gd),
        ('sisa', _GANSS_SatelliteClockModelItem_sisa),
        ('model-id', _GANSS_SatelliteClockModelItem_model_id),
        ('ie-Extensions', _GANSS_SatelliteClockModelItem_ie_Extensions),
        ])
    GANSS_SatelliteClockModelItem._ext = []
    
    #-----< GANSS-SatelliteClockModelItem-ExtIEs >-----#
    GANSS_SatelliteClockModelItem_ExtIEs = CLASS(name='GANSS-SatelliteClockModelItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_SatelliteClockModelItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SatelliteInformationKP >-----#
    GANSS_SatelliteInformationKP = SEQ_OF(name='GANSS-SatelliteInformationKP', mode=MODE_TYPE)
    _GANSS_SatelliteInformationKP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SatelliteInformationKPItem')))
    GANSS_SatelliteInformationKP._cont = _GANSS_SatelliteInformationKP__item_
    GANSS_SatelliteInformationKP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SatelliteInformationKPItem >-----#
    GANSS_SatelliteInformationKPItem = SEQ(name='GANSS-SatelliteInformationKPItem', mode=MODE_TYPE)
    _GANSS_SatelliteInformationKPItem_satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_e_alm = BIT_STR(name='ganss-e-alm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_e_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_delta_I_alm = BIT_STR(name='ganss-delta-I-alm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_delta_I_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_omegadot_alm = BIT_STR(name='ganss-omegadot-alm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_omegadot_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_svStatusINAV_alm = BIT_STR(name='ganss-svStatusINAV-alm', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_svStatusINAV_alm._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_svStatusFNAV_alm = BIT_STR(name='ganss-svStatusFNAV-alm', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_SatelliteInformationKPItem_ganss_svStatusFNAV_alm._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_delta_a_sqrt_alm = BIT_STR(name='ganss-delta-a-sqrt-alm', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_delta_a_sqrt_alm._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_omegazero_alm = BIT_STR(name='ganss-omegazero-alm', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_omegazero_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_m_zero_alm = BIT_STR(name='ganss-m-zero-alm', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_m_zero_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_omega_alm = BIT_STR(name='ganss-omega-alm', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_omega_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_af_zero_alm = BIT_STR(name='ganss-af-zero-alm', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_af_zero_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_af_one_alm = BIT_STR(name='ganss-af-one-alm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_af_one_alm._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SatelliteInformationKPItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id._const_tab = ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__id_tab
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality._const_tab = ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality_tab
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SatelliteInformationKPItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SatelliteInformationKPItem_ie_Extensions__item_._ext = None
    _GANSS_SatelliteInformationKPItem_ie_Extensions._cont = __GANSS_SatelliteInformationKPItem_ie_Extensions__item_
    _GANSS_SatelliteInformationKPItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SatelliteInformationKPItem._cont = ASN1Dict([
        ('satId', _GANSS_SatelliteInformationKPItem_satId),
        ('ganss-e-alm', _GANSS_SatelliteInformationKPItem_ganss_e_alm),
        ('ganss-delta-I-alm', _GANSS_SatelliteInformationKPItem_ganss_delta_I_alm),
        ('ganss-omegadot-alm', _GANSS_SatelliteInformationKPItem_ganss_omegadot_alm),
        ('ganss-svStatusINAV-alm', _GANSS_SatelliteInformationKPItem_ganss_svStatusINAV_alm),
        ('ganss-svStatusFNAV-alm', _GANSS_SatelliteInformationKPItem_ganss_svStatusFNAV_alm),
        ('ganss-delta-a-sqrt-alm', _GANSS_SatelliteInformationKPItem_ganss_delta_a_sqrt_alm),
        ('ganss-omegazero-alm', _GANSS_SatelliteInformationKPItem_ganss_omegazero_alm),
        ('ganss-m-zero-alm', _GANSS_SatelliteInformationKPItem_ganss_m_zero_alm),
        ('ganss-omega-alm', _GANSS_SatelliteInformationKPItem_ganss_omega_alm),
        ('ganss-af-zero-alm', _GANSS_SatelliteInformationKPItem_ganss_af_zero_alm),
        ('ganss-af-one-alm', _GANSS_SatelliteInformationKPItem_ganss_af_one_alm),
        ('ie-Extensions', _GANSS_SatelliteInformationKPItem_ie_Extensions),
        ])
    GANSS_SatelliteInformationKPItem._ext = []
    
    #-----< GANSS-SatelliteInformationKPItem-ExtIEs >-----#
    GANSS_SatelliteInformationKPItem_ExtIEs = CLASS(name='GANSS-SatelliteInformationKPItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_SatelliteInformationKPItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ganss-Sat-Info-AddNavList >-----#
    Ganss_Sat_Info_AddNavList = SEQ_OF(name='Ganss-Sat-Info-AddNavList', mode=MODE_TYPE)
    _Ganss_Sat_Info_AddNavList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Ganss_Sat_Info_AddNavList__item__satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Ganss_Sat_Info_AddNavList__item__satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __Ganss_Sat_Info_AddNavList__item__svHealth = BIT_STR(name='svHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Ganss_Sat_Info_AddNavList__item__svHealth._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    __Ganss_Sat_Info_AddNavList__item__iod = BIT_STR(name='iod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Ganss_Sat_Info_AddNavList__item__iod._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __Ganss_Sat_Info_AddNavList__item__ganssAddClockModels = CHOICE(name='ganssAddClockModels', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AddClockModels')))
    __Ganss_Sat_Info_AddNavList__item__ganssAddOrbitModels = CHOICE(name='ganssAddOrbitModels', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-AddOrbitModels')))
    __Ganss_Sat_Info_AddNavList__item__ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id._const_tab = _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id._const_tab_at = None
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id._const_tab_id = 'id'
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality._const_tab = _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue._const_tab = _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_._cont = ASN1Dict([
        ('id', ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id),
        ('criticality', ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality),
        ('extensionValue', ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue),
        ])
    ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_._ext = None
    __Ganss_Sat_Info_AddNavList__item__ie_Extensions._cont = ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_
    __Ganss_Sat_Info_AddNavList__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Ganss_Sat_Info_AddNavList__item_._cont = ASN1Dict([
        ('satId', __Ganss_Sat_Info_AddNavList__item__satId),
        ('svHealth', __Ganss_Sat_Info_AddNavList__item__svHealth),
        ('iod', __Ganss_Sat_Info_AddNavList__item__iod),
        ('ganssAddClockModels', __Ganss_Sat_Info_AddNavList__item__ganssAddClockModels),
        ('ganssAddOrbitModels', __Ganss_Sat_Info_AddNavList__item__ganssAddOrbitModels),
        ('ie-Extensions', __Ganss_Sat_Info_AddNavList__item__ie_Extensions),
        ])
    _Ganss_Sat_Info_AddNavList__item_._ext = []
    Ganss_Sat_Info_AddNavList._cont = _Ganss_Sat_Info_AddNavList__item_
    Ganss_Sat_Info_AddNavList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Ganss-Sat-Info-AddNavList-ExtIEs >-----#
    Ganss_Sat_Info_AddNavList_ExtIEs = CLASS(name='Ganss-Sat-Info-AddNavList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Ganss_Sat_Info_AddNavList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-BDSkpList >-----#
    GANSS_SAT_Info_Almanac_BDSkpList = SEQ_OF(name='GANSS-SAT-Info-Almanac-BDSkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_BDSkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-BDS')))
    GANSS_SAT_Info_Almanac_BDSkpList._cont = _GANSS_SAT_Info_Almanac_BDSkpList__item_
    GANSS_SAT_Info_Almanac_BDSkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-BDS >-----#
    GANSS_SAT_Info_Almanac_BDS = SEQ(name='GANSS-SAT-Info-Almanac-BDS', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_BDS_satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmToa = BIT_STR(name='bdsAlmToa', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmToa._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmSqrtA = BIT_STR(name='bdsAlmSqrtA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmSqrtA._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmE = BIT_STR(name='bdsAlmE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmE._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmW = BIT_STR(name='bdsAlmW', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmW._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmM0 = BIT_STR(name='bdsAlmM0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmM0._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmega0 = BIT_STR(name='bdsAlmOmega0', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmega0._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmegaDot = BIT_STR(name='bdsAlmOmegaDot', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmegaDot._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmDeltaI = BIT_STR(name='bdsAlmDeltaI', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmDeltaI._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmA0 = BIT_STR(name='bdsAlmA0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmA0._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmA1 = BIT_STR(name='bdsAlmA1', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmA1._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsSvHealth = BIT_STR(name='bdsSvHealth', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_SAT_Info_Almanac_BDS_bdsSvHealth._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__id),
        ('criticality', ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_BDS_ie_Extensions._cont = __GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item_
    _GANSS_SAT_Info_Almanac_BDS_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_BDS._cont = ASN1Dict([
        ('satId', _GANSS_SAT_Info_Almanac_BDS_satId),
        ('bdsAlmToa', _GANSS_SAT_Info_Almanac_BDS_bdsAlmToa),
        ('bdsAlmSqrtA', _GANSS_SAT_Info_Almanac_BDS_bdsAlmSqrtA),
        ('bdsAlmE', _GANSS_SAT_Info_Almanac_BDS_bdsAlmE),
        ('bdsAlmW', _GANSS_SAT_Info_Almanac_BDS_bdsAlmW),
        ('bdsAlmM0', _GANSS_SAT_Info_Almanac_BDS_bdsAlmM0),
        ('bdsAlmOmega0', _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmega0),
        ('bdsAlmOmegaDot', _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmegaDot),
        ('bdsAlmDeltaI', _GANSS_SAT_Info_Almanac_BDS_bdsAlmDeltaI),
        ('bdsAlmA0', _GANSS_SAT_Info_Almanac_BDS_bdsAlmA0),
        ('bdsAlmA1', _GANSS_SAT_Info_Almanac_BDS_bdsAlmA1),
        ('bdsSvHealth', _GANSS_SAT_Info_Almanac_BDS_bdsSvHealth),
        ('ie-Extensions', _GANSS_SAT_Info_Almanac_BDS_ie_Extensions),
        ])
    GANSS_SAT_Info_Almanac_BDS._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-BDS-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_BDS_ExtIEs = CLASS(name='GANSS-SAT-Info-Almanac-BDS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_BDS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-GLOkpList >-----#
    GANSS_SAT_Info_Almanac_GLOkpList = SEQ_OF(name='GANSS-SAT-Info-Almanac-GLOkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_GLOkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-GLOkp')))
    GANSS_SAT_Info_Almanac_GLOkpList._cont = _GANSS_SAT_Info_Almanac_GLOkpList__item_
    GANSS_SAT_Info_Almanac_GLOkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-GLOkp >-----#
    GANSS_SAT_Info_Almanac_GLOkp = SEQ(name='GANSS-SAT-Info-Almanac-GLOkp', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmNA = BIT_STR(name='gloAlmNA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmNA._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmnA = BIT_STR(name='gloAlmnA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmnA._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmHA = BIT_STR(name='gloAlmHA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmHA._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmLambdaA = BIT_STR(name='gloAlmLambdaA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmLambdaA._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTlambdaA = BIT_STR(name='gloAlmTlambdaA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTlambdaA._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaIA = BIT_STR(name='gloAlmDeltaIA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaIA._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAkmDeltaTA = BIT_STR(name='gloAkmDeltaTA', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAkmDeltaTA._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaTdotA = BIT_STR(name='gloAlmDeltaTdotA', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaTdotA._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmEpsilonA = BIT_STR(name='gloAlmEpsilonA', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmEpsilonA._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmOmegaA = BIT_STR(name='gloAlmOmegaA', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmOmegaA._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTauA = BIT_STR(name='gloAlmTauA', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTauA._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmCA = BIT_STR(name='gloAlmCA', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmCA._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmMA = BIT_STR(name='gloAlmMA', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmMA._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id),
        ('criticality', ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions._cont = __GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item_
    _GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_GLOkp._cont = ASN1Dict([
        ('gloAlmNA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmNA),
        ('gloAlmnA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmnA),
        ('gloAlmHA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmHA),
        ('gloAlmLambdaA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmLambdaA),
        ('gloAlmTlambdaA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTlambdaA),
        ('gloAlmDeltaIA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaIA),
        ('gloAkmDeltaTA', _GANSS_SAT_Info_Almanac_GLOkp_gloAkmDeltaTA),
        ('gloAlmDeltaTdotA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaTdotA),
        ('gloAlmEpsilonA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmEpsilonA),
        ('gloAlmOmegaA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmOmegaA),
        ('gloAlmTauA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTauA),
        ('gloAlmCA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmCA),
        ('gloAlmMA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmMA),
        ('ie-Extensions', _GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions),
        ])
    GANSS_SAT_Info_Almanac_GLOkp._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-GLOkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_GLOkp_ExtIEs = CLASS(name='GANSS-SAT-Info-Almanac-GLOkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_GLOkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-MIDIkpList >-----#
    GANSS_SAT_Info_Almanac_MIDIkpList = SEQ_OF(name='GANSS-SAT-Info-Almanac-MIDIkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_MIDIkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-MIDIkp')))
    GANSS_SAT_Info_Almanac_MIDIkpList._cont = _GANSS_SAT_Info_Almanac_MIDIkpList__item_
    GANSS_SAT_Info_Almanac_MIDIkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-MIDIkp >-----#
    GANSS_SAT_Info_Almanac_MIDIkp = SEQ(name='GANSS-SAT-Info-Almanac-MIDIkp', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_MIDIkp_svID = INT(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmE = BIT_STR(name='midiAlmE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmE._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmDeltaI = BIT_STR(name='midiAlmDeltaI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmDeltaI._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmegaDot = BIT_STR(name='midiAlmOmegaDot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmegaDot._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmSqrtA = BIT_STR(name='midiAlmSqrtA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmSqrtA._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega0 = BIT_STR(name='midiAlmOmega0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega0._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega = BIT_STR(name='midiAlmOmega', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmMo = BIT_STR(name='midiAlmMo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmMo._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf0 = BIT_STR(name='midiAlmaf0', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf0._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf1 = BIT_STR(name='midiAlmaf1', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf1._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL1Health = BIT_STR(name='midiAlmL1Health', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL1Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL2Health = BIT_STR(name='midiAlmL2Health', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL2Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL5Health = BIT_STR(name='midiAlmL5Health', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL5Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id),
        ('criticality', ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions._cont = __GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item_
    _GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_MIDIkp._cont = ASN1Dict([
        ('svID', _GANSS_SAT_Info_Almanac_MIDIkp_svID),
        ('midiAlmE', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmE),
        ('midiAlmDeltaI', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmDeltaI),
        ('midiAlmOmegaDot', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmegaDot),
        ('midiAlmSqrtA', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmSqrtA),
        ('midiAlmOmega0', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega0),
        ('midiAlmOmega', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega),
        ('midiAlmMo', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmMo),
        ('midiAlmaf0', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf0),
        ('midiAlmaf1', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf1),
        ('midiAlmL1Health', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL1Health),
        ('midiAlmL2Health', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL2Health),
        ('midiAlmL5Health', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL5Health),
        ('ie-Extensions', _GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions),
        ])
    GANSS_SAT_Info_Almanac_MIDIkp._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_MIDIkp_ExtIEs = CLASS(name='GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_MIDIkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-NAVkpList >-----#
    GANSS_SAT_Info_Almanac_NAVkpList = SEQ_OF(name='GANSS-SAT-Info-Almanac-NAVkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_NAVkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-NAVkp')))
    GANSS_SAT_Info_Almanac_NAVkpList._cont = _GANSS_SAT_Info_Almanac_NAVkpList__item_
    GANSS_SAT_Info_Almanac_NAVkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-NAVkp >-----#
    GANSS_SAT_Info_Almanac_NAVkp = SEQ(name='GANSS-SAT-Info-Almanac-NAVkp', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_NAVkp_svID = INT(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmE = BIT_STR(name='navAlmE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmE._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmDeltaI = BIT_STR(name='navAlmDeltaI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmDeltaI._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGADOT = BIT_STR(name='navAlmOMEGADOT', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGADOT._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmSVHealth = BIT_STR(name='navAlmSVHealth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmSVHealth._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmSqrtA = BIT_STR(name='navAlmSqrtA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmSqrtA._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGAo = BIT_STR(name='navAlmOMEGAo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGAo._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOmega = BIT_STR(name='navAlmOmega', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOmega._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmMo = BIT_STR(name='navAlmMo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmMo._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf0 = BIT_STR(name='navAlmaf0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf0._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf1 = BIT_STR(name='navAlmaf1', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf1._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id),
        ('criticality', ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions._cont = __GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item_
    _GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_NAVkp._cont = ASN1Dict([
        ('svID', _GANSS_SAT_Info_Almanac_NAVkp_svID),
        ('navAlmE', _GANSS_SAT_Info_Almanac_NAVkp_navAlmE),
        ('navAlmDeltaI', _GANSS_SAT_Info_Almanac_NAVkp_navAlmDeltaI),
        ('navAlmOMEGADOT', _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGADOT),
        ('navAlmSVHealth', _GANSS_SAT_Info_Almanac_NAVkp_navAlmSVHealth),
        ('navAlmSqrtA', _GANSS_SAT_Info_Almanac_NAVkp_navAlmSqrtA),
        ('navAlmOMEGAo', _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGAo),
        ('navAlmOmega', _GANSS_SAT_Info_Almanac_NAVkp_navAlmOmega),
        ('navAlmMo', _GANSS_SAT_Info_Almanac_NAVkp_navAlmMo),
        ('navAlmaf0', _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf0),
        ('navAlmaf1', _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf1),
        ('ie-Extensions', _GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions),
        ])
    GANSS_SAT_Info_Almanac_NAVkp._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-NAVkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_NAVkp_ExtIEs = CLASS(name='GANSS-SAT-Info-Almanac-NAVkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_NAVkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-REDkpList >-----#
    GANSS_SAT_Info_Almanac_REDkpList = SEQ_OF(name='GANSS-SAT-Info-Almanac-REDkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_REDkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-REDkp')))
    GANSS_SAT_Info_Almanac_REDkpList._cont = _GANSS_SAT_Info_Almanac_REDkpList__item_
    GANSS_SAT_Info_Almanac_REDkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-REDkp >-----#
    GANSS_SAT_Info_Almanac_REDkp = SEQ(name='GANSS-SAT-Info-Almanac-REDkp', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_REDkp_svID = INT(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmDeltaA = BIT_STR(name='redAlmDeltaA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmDeltaA._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmOmega0 = BIT_STR(name='redAlmOmega0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmOmega0._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmPhi0 = BIT_STR(name='redAlmPhi0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmPhi0._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL1Health = BIT_STR(name='redAlmL1Health', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL1Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL2Health = BIT_STR(name='redAlmL2Health', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL2Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL5Health = BIT_STR(name='redAlmL5Health', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL5Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id),
        ('criticality', ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_REDkp_ie_Extensions._cont = __GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item_
    _GANSS_SAT_Info_Almanac_REDkp_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_REDkp._cont = ASN1Dict([
        ('svID', _GANSS_SAT_Info_Almanac_REDkp_svID),
        ('redAlmDeltaA', _GANSS_SAT_Info_Almanac_REDkp_redAlmDeltaA),
        ('redAlmOmega0', _GANSS_SAT_Info_Almanac_REDkp_redAlmOmega0),
        ('redAlmPhi0', _GANSS_SAT_Info_Almanac_REDkp_redAlmPhi0),
        ('redAlmL1Health', _GANSS_SAT_Info_Almanac_REDkp_redAlmL1Health),
        ('redAlmL2Health', _GANSS_SAT_Info_Almanac_REDkp_redAlmL2Health),
        ('redAlmL5Health', _GANSS_SAT_Info_Almanac_REDkp_redAlmL5Health),
        ('ie-Extensions', _GANSS_SAT_Info_Almanac_REDkp_ie_Extensions),
        ])
    GANSS_SAT_Info_Almanac_REDkp._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-REDkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_REDkp_ExtIEs = CLASS(name='GANSS-SAT-Info-Almanac-REDkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_REDkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-SBASecefList >-----#
    GANSS_SAT_Info_Almanac_SBASecefList = SEQ_OF(name='GANSS-SAT-Info-Almanac-SBASecefList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_SBASecefList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-SAT-Info-Almanac-SBASecef')))
    GANSS_SAT_Info_Almanac_SBASecefList._cont = _GANSS_SAT_Info_Almanac_SBASecefList__item_
    GANSS_SAT_Info_Almanac_SBASecefList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-SBASecef >-----#
    GANSS_SAT_Info_Almanac_SBASecef = SEQ(name='GANSS-SAT-Info-Almanac-SBASecef', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmDataID = BIT_STR(name='sbasAlmDataID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmDataID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_svID = INT(name='svID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmHealth = BIT_STR(name='sbasAlmHealth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmHealth._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXg = BIT_STR(name='sbasAlmXg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXg._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYg = BIT_STR(name='sbasAlmYg', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYg._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZg = BIT_STR(name='sbasAlmZg', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZg._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXgdot = BIT_STR(name='sbasAlmXgdot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXgdot._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYgDot = BIT_STR(name='sbasAlmYgDot', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYgDot._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZgDot = BIT_STR(name='sbasAlmZgDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZgDot._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmTo = BIT_STR(name='sbasAlmTo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmTo._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id),
        ('criticality', ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions._cont = __GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item_
    _GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_SBASecef._cont = ASN1Dict([
        ('sbasAlmDataID', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmDataID),
        ('svID', _GANSS_SAT_Info_Almanac_SBASecef_svID),
        ('sbasAlmHealth', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmHealth),
        ('sbasAlmXg', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXg),
        ('sbasAlmYg', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYg),
        ('sbasAlmZg', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZg),
        ('sbasAlmXgdot', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXgdot),
        ('sbasAlmYgDot', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYgDot),
        ('sbasAlmZgDot', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZgDot),
        ('sbasAlmTo', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmTo),
        ('ie-Extensions', _GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions),
        ])
    GANSS_SAT_Info_Almanac_SBASecef._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-SBASecef-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_SBASecef_ExtIEs = CLASS(name='GANSS-SAT-Info-Almanac-SBASecef-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_SBASecef_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Sat-Info-Nav >-----#
    GANSS_Sat_Info_Nav = SEQ_OF(name='GANSS-Sat-Info-Nav', mode=MODE_TYPE)
    _GANSS_Sat_Info_Nav__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_Sat_Info_Nav__item__satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Sat_Info_Nav__item__satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __GANSS_Sat_Info_Nav__item__svHealth = BIT_STR(name='svHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Sat_Info_Nav__item__svHealth._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    __GANSS_Sat_Info_Nav__item__iod = BIT_STR(name='iod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Sat_Info_Nav__item__iod._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __GANSS_Sat_Info_Nav__item__ganssClockModel = SEQ_OF(name='ganssClockModel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Clock-Model')))
    __GANSS_Sat_Info_Nav__item__ganssOrbitModel = CHOICE(name='ganssOrbitModel', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Orbit-Model')))
    __GANSS_Sat_Info_Nav__item__ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id._const_tab = _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id._const_tab_id = 'id'
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality._const_tab = _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_._cont = ASN1Dict([
        ('id', ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id),
        ('criticality', ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality),
        ('extensionValue', ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_._ext = None
    __GANSS_Sat_Info_Nav__item__ie_Extensions._cont = ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_
    __GANSS_Sat_Info_Nav__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_Sat_Info_Nav__item_._cont = ASN1Dict([
        ('satId', __GANSS_Sat_Info_Nav__item__satId),
        ('svHealth', __GANSS_Sat_Info_Nav__item__svHealth),
        ('iod', __GANSS_Sat_Info_Nav__item__iod),
        ('ganssClockModel', __GANSS_Sat_Info_Nav__item__ganssClockModel),
        ('ganssOrbitModel', __GANSS_Sat_Info_Nav__item__ganssOrbitModel),
        ('ie-Extensions', __GANSS_Sat_Info_Nav__item__ie_Extensions),
        ])
    _GANSS_Sat_Info_Nav__item_._ext = []
    GANSS_Sat_Info_Nav._cont = _GANSS_Sat_Info_Nav__item_
    GANSS_Sat_Info_Nav._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-Sat-Info-Nav-ExtIEs >-----#
    GANSS_Sat_Info_Nav_ExtIEs = CLASS(name='GANSS-Sat-Info-Nav-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_Sat_Info_Nav_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SBAS-ID >-----#
    GANSS_SBAS_ID = ENUM(name='GANSS-SBAS-ID', mode=MODE_TYPE)
    GANSS_SBAS_ID._cont = ASN1Dict([('waas', 0), ('egnos', 1), ('msas', 2), ('gagan', 3)])
    GANSS_SBAS_ID._ext = []
    
    #-----< GANSS-SBASclockModel >-----#
    GANSS_SBASclockModel = SEQ(name='GANSS-SBASclockModel', mode=MODE_TYPE)
    _GANSS_SBASclockModel_sbasTo = BIT_STR(name='sbasTo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SBASclockModel_sbasTo._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_SBASclockModel_sbasAgfo = BIT_STR(name='sbasAgfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SBASclockModel_sbasAgfo._const_sz = ASN1Set(rv=[12], rr=[], ev=None, er=[])
    _GANSS_SBASclockModel_sbasAgf1 = BIT_STR(name='sbasAgf1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SBASclockModel_sbasAgf1._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SBASclockModel_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SBASclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SBASclockModel_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SBASclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SBASclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SBASclockModel_ie_Extensions__item__id._const_tab = ____GANSS_SBASclockModel_ie_Extensions__item__id_tab
    ___GANSS_SBASclockModel_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SBASclockModel_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SBASclockModel_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SBASclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SBASclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SBASclockModel_ie_Extensions__item__criticality._const_tab = ____GANSS_SBASclockModel_ie_Extensions__item__criticality_tab
    ___GANSS_SBASclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SBASclockModel_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SBASclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_SBASclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SBASclockModel_ie_Extensions__item__extensionValue_tab
    ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SBASclockModel_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SBASclockModel_ie_Extensions__item__id),
        ('criticality', ___GANSS_SBASclockModel_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SBASclockModel_ie_Extensions__item_._ext = None
    _GANSS_SBASclockModel_ie_Extensions._cont = __GANSS_SBASclockModel_ie_Extensions__item_
    _GANSS_SBASclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SBASclockModel._cont = ASN1Dict([
        ('sbasTo', _GANSS_SBASclockModel_sbasTo),
        ('sbasAgfo', _GANSS_SBASclockModel_sbasAgfo),
        ('sbasAgf1', _GANSS_SBASclockModel_sbasAgf1),
        ('ie-Extensions', _GANSS_SBASclockModel_ie_Extensions),
        ])
    GANSS_SBASclockModel._ext = []
    
    #-----< GANSS-SBASclockModel-ExtIEs >-----#
    GANSS_SBASclockModel_ExtIEs = CLASS(name='GANSS-SBASclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_SBASclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Signal-ID >-----#
    GANSS_Signal_ID = INT(name='GANSS-Signal-ID', mode=MODE_TYPE)
    GANSS_Signal_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< GANSS-StatusHealth >-----#
    GANSS_StatusHealth = ENUM(name='GANSS-StatusHealth', mode=MODE_TYPE)
    GANSS_StatusHealth._cont = ASN1Dict([('udre-scale-1dot0', 0), ('udre-scale-0dot75', 1), ('udre-scale-0dot5', 2), ('udre-scale-0dot3', 3), ('udre-scale-0dot2', 4), ('udre-scale-0dot1', 5), ('no-data', 6), ('invalid-data', 7)])
    GANSS_StatusHealth._ext = None
    
    #-----< GANSS-Time-ID >-----#
    GANSS_Time_ID = INT(name='GANSS-Time-ID', mode=MODE_TYPE)
    GANSS_Time_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< GANSS-Time-Model >-----#
    GANSS_Time_Model = SEQ(name='GANSS-Time-Model', mode=MODE_TYPE)
    _GANSS_Time_Model_ganss_time_model_Ref_Time = INT(name='ganss-time-model-Ref-Time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Time_Model_ganss_time_model_Ref_Time._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37799)], ev=None, er=[])
    _GANSS_Time_Model_ganss_t_a0 = INT(name='ganss-t-a0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Time_Model_ganss_t_a0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _GANSS_Time_Model_ganss_t_a1 = INT(name='ganss-t-a1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Time_Model_ganss_t_a1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _GANSS_Time_Model_ganss_t_a2 = INT(name='ganss-t-a2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Time_Model_ganss_t_a2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64, ub=63)], ev=None, er=[])
    _GANSS_Time_Model_gnss_to_id = ENUM(name='gnss-to-id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Time_Model_gnss_to_id._cont = ASN1Dict([('gps', 0), ('galileo', 1), ('qzss', 2), ('glonass', 3), ('bds', 4)])
    _GANSS_Time_Model_gnss_to_id._ext = ['galileo', 'qzss', 'glonass', 'bds']
    _GANSS_Time_Model_ganss_wk_number = INT(name='ganss-wk-number', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Time_Model_ganss_wk_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _GANSS_Time_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Time_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Time_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Time_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____GANSS_Time_Model_ie_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Delta-T')))
    ____GANSS_Time_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1185), ('criticality', 'ignore'), ('Extension', _____GANSS_Time_Model_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_Time_Model_ie_Extensions__item__id._const_tab = ____GANSS_Time_Model_ie_Extensions__item__id_tab
    ___GANSS_Time_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Time_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Time_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_Time_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_Time_Model_ie_Extensions__item__id_tab
    ___GANSS_Time_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Time_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Time_Model_ie_Extensions__item__id_tab
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Time_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Time_Model_ie_Extensions__item__id),
        ('criticality', ___GANSS_Time_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Time_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Time_Model_ie_Extensions__item_._ext = None
    _GANSS_Time_Model_ie_Extensions._cont = __GANSS_Time_Model_ie_Extensions__item_
    _GANSS_Time_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Time_Model._cont = ASN1Dict([
        ('ganss-time-model-Ref-Time', _GANSS_Time_Model_ganss_time_model_Ref_Time),
        ('ganss-t-a0', _GANSS_Time_Model_ganss_t_a0),
        ('ganss-t-a1', _GANSS_Time_Model_ganss_t_a1),
        ('ganss-t-a2', _GANSS_Time_Model_ganss_t_a2),
        ('gnss-to-id', _GANSS_Time_Model_gnss_to_id),
        ('ganss-wk-number', _GANSS_Time_Model_ganss_wk_number),
        ('ie-Extensions', _GANSS_Time_Model_ie_Extensions),
        ])
    GANSS_Time_Model._ext = []
    
    #-----< GANSS-Time-Model-ExtIEs >-----#
    GANSS_Time_Model_ExtIEs = CLASS(name='GANSS-Time-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _GANSS_Time_Model_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Delta-T')))
    GANSS_Time_Model_ExtIEs._val = ASN1Set(rv=[dict([('id', 1185), ('criticality', 'ignore'), ('Extension', _GANSS_Time_Model_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Transmission-Time >-----#
    GANSS_Transmission_Time = SEQ(name='GANSS-Transmission-Time', mode=MODE_TYPE)
    _GANSS_Transmission_Time_ganssDay = INT(name='ganssDay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Transmission_Time_ganssDay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _GANSS_Transmission_Time_ganssTod = INT(name='ganssTod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Transmission_Time_ganssTod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=None, er=[])
    _GANSS_Transmission_Time_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Transmission_Time_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Transmission_Time_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Transmission_Time_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Transmission_Time_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Transmission_Time_ie_Extensions__item__id._const_tab = ____GANSS_Transmission_Time_ie_Extensions__item__id_tab
    ___GANSS_Transmission_Time_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Transmission_Time_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Transmission_Time_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Transmission_Time_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Transmission_Time_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Transmission_Time_ie_Extensions__item__criticality._const_tab = ____GANSS_Transmission_Time_ie_Extensions__item__criticality_tab
    ___GANSS_Transmission_Time_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Transmission_Time_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Transmission_Time_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_Transmission_Time_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Transmission_Time_ie_Extensions__item__extensionValue_tab
    ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Transmission_Time_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Transmission_Time_ie_Extensions__item__id),
        ('criticality', ___GANSS_Transmission_Time_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Transmission_Time_ie_Extensions__item_._ext = None
    _GANSS_Transmission_Time_ie_Extensions._cont = __GANSS_Transmission_Time_ie_Extensions__item_
    _GANSS_Transmission_Time_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Transmission_Time._cont = ASN1Dict([
        ('ganssDay', _GANSS_Transmission_Time_ganssDay),
        ('ganssTod', _GANSS_Transmission_Time_ganssTod),
        ('ie-Extensions', _GANSS_Transmission_Time_ie_Extensions),
        ])
    GANSS_Transmission_Time._ext = []
    
    #-----< GANSS-Transmission-Time-ExtIEs >-----#
    GANSS_Transmission_Time_ExtIEs = CLASS(name='GANSS-Transmission-Time-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_Transmission_Time_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-UTC-Model >-----#
    GANSS_UTC_Model = SEQ(name='GANSS-UTC-Model', mode=MODE_TYPE)
    _GANSS_UTC_Model_a_one_utc = BIT_STR(name='a-one-utc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_a_one_utc._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_a_zero_utc = BIT_STR(name='a-zero-utc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_a_zero_utc._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_t_ot_utc = BIT_STR(name='t-ot-utc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_t_ot_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_w_n_t_utc = BIT_STR(name='w-n-t-utc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_w_n_t_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_delta_t_ls_utc = BIT_STR(name='delta-t-ls-utc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_delta_t_ls_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_w_n_lsf_utc = BIT_STR(name='w-n-lsf-utc', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_w_n_lsf_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_dn_utc = BIT_STR(name='dn-utc', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_dn_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_delta_t_lsf_utc = BIT_STR(name='delta-t-lsf-utc', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_delta_t_lsf_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTC_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTC_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_UTC_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTC_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTC_Model_ie_Extensions__item__id._const_tab = ____GANSS_UTC_Model_ie_Extensions__item__id_tab
    ___GANSS_UTC_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_UTC_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_UTC_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTC_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab
    ___GANSS_UTC_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_UTC_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_UTC_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_UTC_Model_ie_Extensions__item__id),
        ('criticality', ___GANSS_UTC_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_UTC_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_UTC_Model_ie_Extensions__item_._ext = None
    _GANSS_UTC_Model_ie_Extensions._cont = __GANSS_UTC_Model_ie_Extensions__item_
    _GANSS_UTC_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTC_Model._cont = ASN1Dict([
        ('a-one-utc', _GANSS_UTC_Model_a_one_utc),
        ('a-zero-utc', _GANSS_UTC_Model_a_zero_utc),
        ('t-ot-utc', _GANSS_UTC_Model_t_ot_utc),
        ('w-n-t-utc', _GANSS_UTC_Model_w_n_t_utc),
        ('delta-t-ls-utc', _GANSS_UTC_Model_delta_t_ls_utc),
        ('w-n-lsf-utc', _GANSS_UTC_Model_w_n_lsf_utc),
        ('dn-utc', _GANSS_UTC_Model_dn_utc),
        ('delta-t-lsf-utc', _GANSS_UTC_Model_delta_t_lsf_utc),
        ('ie-Extensions', _GANSS_UTC_Model_ie_Extensions),
        ])
    GANSS_UTC_Model._ext = []
    
    #-----< GANSS-UTC-Model-ExtIEs >-----#
    GANSS_UTC_Model_ExtIEs = CLASS(name='GANSS-UTC-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_UTC_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-UTCmodelSet1 >-----#
    GANSS_UTCmodelSet1 = SEQ(name='GANSS-UTCmodelSet1', mode=MODE_TYPE)
    _GANSS_UTCmodelSet1_utcA0 = BIT_STR(name='utcA0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcA0._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcA1 = BIT_STR(name='utcA1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcA1._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcA2 = BIT_STR(name='utcA2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcA2._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcDeltaTls = BIT_STR(name='utcDeltaTls', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcDeltaTls._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcTot = BIT_STR(name='utcTot', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcTot._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcWNot = BIT_STR(name='utcWNot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcWNot._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcWNlsf = BIT_STR(name='utcWNlsf', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcWNlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcDN = BIT_STR(name='utcDN', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcDN._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcDeltaTlsf = BIT_STR(name='utcDeltaTlsf', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcDeltaTlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTCmodelSet1_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTCmodelSet1_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet1_ie_Extensions__item__id._const_tab = ____GANSS_UTCmodelSet1_ie_Extensions__item__id_tab
    ___GANSS_UTCmodelSet1_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_UTCmodelSet1_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality._const_tab = ____GANSS_UTCmodelSet1_ie_Extensions__item__criticality_tab
    ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue._const_tab = ____GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue_tab
    ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_UTCmodelSet1_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_UTCmodelSet1_ie_Extensions__item__id),
        ('criticality', ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue),
        ])
    __GANSS_UTCmodelSet1_ie_Extensions__item_._ext = None
    _GANSS_UTCmodelSet1_ie_Extensions._cont = __GANSS_UTCmodelSet1_ie_Extensions__item_
    _GANSS_UTCmodelSet1_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTCmodelSet1._cont = ASN1Dict([
        ('utcA0', _GANSS_UTCmodelSet1_utcA0),
        ('utcA1', _GANSS_UTCmodelSet1_utcA1),
        ('utcA2', _GANSS_UTCmodelSet1_utcA2),
        ('utcDeltaTls', _GANSS_UTCmodelSet1_utcDeltaTls),
        ('utcTot', _GANSS_UTCmodelSet1_utcTot),
        ('utcWNot', _GANSS_UTCmodelSet1_utcWNot),
        ('utcWNlsf', _GANSS_UTCmodelSet1_utcWNlsf),
        ('utcDN', _GANSS_UTCmodelSet1_utcDN),
        ('utcDeltaTlsf', _GANSS_UTCmodelSet1_utcDeltaTlsf),
        ('ie-Extensions', _GANSS_UTCmodelSet1_ie_Extensions),
        ])
    GANSS_UTCmodelSet1._ext = []
    
    #-----< GANSS-UTCmodelSet1-ExtIEs >-----#
    GANSS_UTCmodelSet1_ExtIEs = CLASS(name='GANSS-UTCmodelSet1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_UTCmodelSet1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-UTCmodelSet2 >-----#
    GANSS_UTCmodelSet2 = SEQ(name='GANSS-UTCmodelSet2', mode=MODE_TYPE)
    _GANSS_UTCmodelSet2_nA = BIT_STR(name='nA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet2_nA._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet2_tauC = BIT_STR(name='tauC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet2_tauC._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet2_deltaUT1 = SEQ(name='deltaUT1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GANSS-DeltaUT1')), opt=True)
    _GANSS_UTCmodelSet2_kp = BIT_STR(name='kp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_UTCmodelSet2_kp._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet2_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTCmodelSet2_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTCmodelSet2_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet2_ie_Extensions__item__id._const_tab = ____GANSS_UTCmodelSet2_ie_Extensions__item__id_tab
    ___GANSS_UTCmodelSet2_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_UTCmodelSet2_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality._const_tab = ____GANSS_UTCmodelSet2_ie_Extensions__item__criticality_tab
    ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue._const_tab = ____GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue_tab
    ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_UTCmodelSet2_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_UTCmodelSet2_ie_Extensions__item__id),
        ('criticality', ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue),
        ])
    __GANSS_UTCmodelSet2_ie_Extensions__item_._ext = None
    _GANSS_UTCmodelSet2_ie_Extensions._cont = __GANSS_UTCmodelSet2_ie_Extensions__item_
    _GANSS_UTCmodelSet2_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTCmodelSet2._cont = ASN1Dict([
        ('nA', _GANSS_UTCmodelSet2_nA),
        ('tauC', _GANSS_UTCmodelSet2_tauC),
        ('deltaUT1', _GANSS_UTCmodelSet2_deltaUT1),
        ('kp', _GANSS_UTCmodelSet2_kp),
        ('ie-Extensions', _GANSS_UTCmodelSet2_ie_Extensions),
        ])
    GANSS_UTCmodelSet2._ext = []
    
    #-----< GANSS-UTCmodelSet2-ExtIEs >-----#
    GANSS_UTCmodelSet2_ExtIEs = CLASS(name='GANSS-UTCmodelSet2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_UTCmodelSet2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-UTCmodelSet3 >-----#
    GANSS_UTCmodelSet3 = SEQ(name='GANSS-UTCmodelSet3', mode=MODE_TYPE)
    _GANSS_UTCmodelSet3_utcA1wnt = BIT_STR(name='utcA1wnt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcA1wnt._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcA0wnt = BIT_STR(name='utcA0wnt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcA0wnt._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcTot = BIT_STR(name='utcTot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcTot._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcWNt = BIT_STR(name='utcWNt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcWNt._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcDeltaTls = BIT_STR(name='utcDeltaTls', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcDeltaTls._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcWNlsf = BIT_STR(name='utcWNlsf', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcWNlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcDN = BIT_STR(name='utcDN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcDN._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcDeltaTlsf = BIT_STR(name='utcDeltaTlsf', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcDeltaTlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcStandardID = BIT_STR(name='utcStandardID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcStandardID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTCmodelSet3_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTCmodelSet3_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet3_ie_Extensions__item__id._const_tab = ____GANSS_UTCmodelSet3_ie_Extensions__item__id_tab
    ___GANSS_UTCmodelSet3_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_UTCmodelSet3_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality._const_tab = ____GANSS_UTCmodelSet3_ie_Extensions__item__criticality_tab
    ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue._const_tab = ____GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue_tab
    ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_UTCmodelSet3_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_UTCmodelSet3_ie_Extensions__item__id),
        ('criticality', ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue),
        ])
    __GANSS_UTCmodelSet3_ie_Extensions__item_._ext = None
    _GANSS_UTCmodelSet3_ie_Extensions._cont = __GANSS_UTCmodelSet3_ie_Extensions__item_
    _GANSS_UTCmodelSet3_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTCmodelSet3._cont = ASN1Dict([
        ('utcA1wnt', _GANSS_UTCmodelSet3_utcA1wnt),
        ('utcA0wnt', _GANSS_UTCmodelSet3_utcA0wnt),
        ('utcTot', _GANSS_UTCmodelSet3_utcTot),
        ('utcWNt', _GANSS_UTCmodelSet3_utcWNt),
        ('utcDeltaTls', _GANSS_UTCmodelSet3_utcDeltaTls),
        ('utcWNlsf', _GANSS_UTCmodelSet3_utcWNlsf),
        ('utcDN', _GANSS_UTCmodelSet3_utcDN),
        ('utcDeltaTlsf', _GANSS_UTCmodelSet3_utcDeltaTlsf),
        ('utcStandardID', _GANSS_UTCmodelSet3_utcStandardID),
        ('ie-Extensions', _GANSS_UTCmodelSet3_ie_Extensions),
        ])
    GANSS_UTCmodelSet3._ext = []
    
    #-----< GANSS-UTCmodelSet3-ExtIEs >-----#
    GANSS_UTCmodelSet3_ExtIEs = CLASS(name='GANSS-UTCmodelSet3-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_UTCmodelSet3_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-UTCmodelSet4 >-----#
    GANSS_UTCmodelSet4 = SEQ(name='GANSS-UTCmodelSet4', mode=MODE_TYPE)
    _GANSS_UTCmodelSet4_utcA0 = BIT_STR(name='utcA0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcA0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_utcA1 = BIT_STR(name='utcA1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcA1._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_utcDeltaTls = BIT_STR(name='utcDeltaTls', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcDeltaTls._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_utcWNlsf = BIT_STR(name='utcWNlsf', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcWNlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_utcDN = BIT_STR(name='utcDN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcDN._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_utcDeltaTlsf = BIT_STR(name='utcDeltaTlsf', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcDeltaTlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTCmodelSet4_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTCmodelSet4_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_UTCmodelSet4_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet4_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet4_ie_Extensions__item__id._const_tab = ____GANSS_UTCmodelSet4_ie_Extensions__item__id_tab
    ___GANSS_UTCmodelSet4_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_UTCmodelSet4_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_UTCmodelSet4_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_UTCmodelSet4_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet4_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet4_ie_Extensions__item__criticality._const_tab = ____GANSS_UTCmodelSet4_ie_Extensions__item__criticality_tab
    ___GANSS_UTCmodelSet4_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_UTCmodelSet4_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_UTCmodelSet4_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_UTCmodelSet4_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet4_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet4_ie_Extensions__item__extensionValue._const_tab = ____GANSS_UTCmodelSet4_ie_Extensions__item__extensionValue_tab
    ___GANSS_UTCmodelSet4_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_UTCmodelSet4_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_UTCmodelSet4_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_UTCmodelSet4_ie_Extensions__item__id),
        ('criticality', ___GANSS_UTCmodelSet4_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_UTCmodelSet4_ie_Extensions__item__extensionValue),
        ])
    __GANSS_UTCmodelSet4_ie_Extensions__item_._ext = None
    _GANSS_UTCmodelSet4_ie_Extensions._cont = __GANSS_UTCmodelSet4_ie_Extensions__item_
    _GANSS_UTCmodelSet4_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTCmodelSet4._cont = ASN1Dict([
        ('utcA0', _GANSS_UTCmodelSet4_utcA0),
        ('utcA1', _GANSS_UTCmodelSet4_utcA1),
        ('utcDeltaTls', _GANSS_UTCmodelSet4_utcDeltaTls),
        ('utcWNlsf', _GANSS_UTCmodelSet4_utcWNlsf),
        ('utcDN', _GANSS_UTCmodelSet4_utcDN),
        ('utcDeltaTlsf', _GANSS_UTCmodelSet4_utcDeltaTlsf),
        ('ie-Extensions', _GANSS_UTCmodelSet4_ie_Extensions),
        ])
    GANSS_UTCmodelSet4._ext = []
    
    #-----< GANSS-UTCmodelSet4-ExtIEs >-----#
    GANSS_UTCmodelSet4_ExtIEs = CLASS(name='GANSS-UTCmodelSet4-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GANSS_UTCmodelSet4_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GapLength >-----#
    GapLength = INT(name='GapLength', mode=MODE_TYPE)
    GapLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    
    #-----< GapDuration >-----#
    GapDuration = INT(name='GapDuration', mode=MODE_TYPE)
    GapDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=144)], ev=[], er=[])
    
    #-----< GenericTrafficCategory >-----#
    GenericTrafficCategory = BIT_STR(name='GenericTrafficCategory', mode=MODE_TYPE)
    GenericTrafficCategory._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< GPS-Almanac >-----#
    GPS_Almanac = SEQ(name='GPS-Almanac', mode=MODE_TYPE)
    _GPS_Almanac_wna_alm = BIT_STR(name='wna-alm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Almanac_wna_alm._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Almanac_sat_info_almanac = SEQ_OF(name='sat-info-almanac', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SAT-Info-Almanac')))
    _GPS_Almanac_sVGlobalHealth_alm = BIT_STR(name='sVGlobalHealth-alm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPS_Almanac_sVGlobalHealth_alm._const_sz = ASN1Set(rv=[364], rr=[], ev=None, er=[])
    _GPS_Almanac_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_Almanac_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GPS_Almanac_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_Almanac_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____GPS_Almanac_ie_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SAT-Info-Almanac-ExtList')))
    _____GPS_Almanac_ie_Extensions__item__id_tab_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CompleteAlmanacProvided')))
    ____GPS_Almanac_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 609), ('criticality', 'ignore'), ('Extension', _____GPS_Almanac_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1184), ('criticality', 'ignore'), ('Extension', _____GPS_Almanac_ie_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GPS_Almanac_ie_Extensions__item__id._const_tab = ____GPS_Almanac_ie_Extensions__item__id_tab
    ___GPS_Almanac_ie_Extensions__item__id._const_tab_at = None
    ___GPS_Almanac_ie_Extensions__item__id._const_tab_id = 'id'
    ___GPS_Almanac_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GPS_Almanac_ie_Extensions__item__criticality._const_tab = ____GPS_Almanac_ie_Extensions__item__id_tab
    ___GPS_Almanac_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_Almanac_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_Almanac_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GPS_Almanac_ie_Extensions__item__extensionValue._const_tab = ____GPS_Almanac_ie_Extensions__item__id_tab
    ___GPS_Almanac_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_Almanac_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_Almanac_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_Almanac_ie_Extensions__item__id),
        ('criticality', ___GPS_Almanac_ie_Extensions__item__criticality),
        ('extensionValue', ___GPS_Almanac_ie_Extensions__item__extensionValue),
        ])
    __GPS_Almanac_ie_Extensions__item_._ext = None
    _GPS_Almanac_ie_Extensions._cont = __GPS_Almanac_ie_Extensions__item_
    _GPS_Almanac_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_Almanac._cont = ASN1Dict([
        ('wna-alm', _GPS_Almanac_wna_alm),
        ('sat-info-almanac', _GPS_Almanac_sat_info_almanac),
        ('sVGlobalHealth-alm', _GPS_Almanac_sVGlobalHealth_alm),
        ('ie-Extensions', _GPS_Almanac_ie_Extensions),
        ])
    GPS_Almanac._ext = []
    
    #-----< GPS-Almanac-ExtIEs >-----#
    GPS_Almanac_ExtIEs = CLASS(name='GPS-Almanac-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _GPS_Almanac_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SAT-Info-Almanac-ExtList')))
    _GPS_Almanac_ExtIEs_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CompleteAlmanacProvided')))
    GPS_Almanac_ExtIEs._val = ASN1Set(rv=[dict([('id', 609), ('criticality', 'ignore'), ('Extension', _GPS_Almanac_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1184), ('criticality', 'ignore'), ('Extension', _GPS_Almanac_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GPS-Ionospheric-Model >-----#
    GPS_Ionospheric_Model = SEQ(name='GPS-Ionospheric-Model', mode=MODE_TYPE)
    _GPS_Ionospheric_Model_alpha_zero_ionos = BIT_STR(name='alpha-zero-ionos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alpha_zero_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_alpha_one_ionos = BIT_STR(name='alpha-one-ionos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alpha_one_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_alpha_two_ionos = BIT_STR(name='alpha-two-ionos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alpha_two_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_alpha_three_ionos = BIT_STR(name='alpha-three-ionos', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alpha_three_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta_zero_ionos = BIT_STR(name='beta-zero-ionos', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta_zero_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta_one_ionos = BIT_STR(name='beta-one-ionos', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta_one_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta_two_ionos = BIT_STR(name='beta-two-ionos', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta_two_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta_three_ionos = BIT_STR(name='beta-three-ionos', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta_three_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_Ionospheric_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GPS_Ionospheric_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_Ionospheric_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_Ionospheric_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_Ionospheric_Model_ie_Extensions__item__id._const_tab = ____GPS_Ionospheric_Model_ie_Extensions__item__id_tab
    ___GPS_Ionospheric_Model_ie_Extensions__item__id._const_tab_at = None
    ___GPS_Ionospheric_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___GPS_Ionospheric_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPS_Ionospheric_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_Ionospheric_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab = ____GPS_Ionospheric_Model_ie_Extensions__item__criticality_tab
    ___GPS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_Ionospheric_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab = ____GPS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab
    ___GPS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_Ionospheric_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_Ionospheric_Model_ie_Extensions__item__id),
        ('criticality', ___GPS_Ionospheric_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___GPS_Ionospheric_Model_ie_Extensions__item__extensionValue),
        ])
    __GPS_Ionospheric_Model_ie_Extensions__item_._ext = None
    _GPS_Ionospheric_Model_ie_Extensions._cont = __GPS_Ionospheric_Model_ie_Extensions__item_
    _GPS_Ionospheric_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_Ionospheric_Model._cont = ASN1Dict([
        ('alpha-zero-ionos', _GPS_Ionospheric_Model_alpha_zero_ionos),
        ('alpha-one-ionos', _GPS_Ionospheric_Model_alpha_one_ionos),
        ('alpha-two-ionos', _GPS_Ionospheric_Model_alpha_two_ionos),
        ('alpha-three-ionos', _GPS_Ionospheric_Model_alpha_three_ionos),
        ('beta-zero-ionos', _GPS_Ionospheric_Model_beta_zero_ionos),
        ('beta-one-ionos', _GPS_Ionospheric_Model_beta_one_ionos),
        ('beta-two-ionos', _GPS_Ionospheric_Model_beta_two_ionos),
        ('beta-three-ionos', _GPS_Ionospheric_Model_beta_three_ionos),
        ('ie-Extensions', _GPS_Ionospheric_Model_ie_Extensions),
        ])
    GPS_Ionospheric_Model._ext = []
    
    #-----< GPS-Ionospheric-Model-ExtIEs >-----#
    GPS_Ionospheric_Model_ExtIEs = CLASS(name='GPS-Ionospheric-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GPS_Ionospheric_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-Information >-----#
    GPS_Information = SEQ_OF(name='GPS-Information', mode=MODE_TYPE)
    _GPS_Information__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GPS-Information-Item')))
    GPS_Information._cont = _GPS_Information__item_
    GPS_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< GPS-Information-Item >-----#
    GPS_Information_Item = ENUM(name='GPS-Information-Item', mode=MODE_TYPE)
    GPS_Information_Item._cont = ASN1Dict([('gps-navigation-model-and-time-recovery', 0), ('gps-ionospheric-model', 1), ('gps-utc-model', 2), ('gps-almanac', 3), ('gps-rt-integrity', 4)])
    GPS_Information_Item._ext = []
    
    #-----< GPS-RealTime-Integrity >-----#
    GPS_RealTime_Integrity = CHOICE(name='GPS-RealTime-Integrity', mode=MODE_TYPE)
    _GPS_RealTime_Integrity_bad_satellites = SEQ(name='bad-satellites', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GPSBadSat-Info-RealTime-Integrity')))
    _GPS_RealTime_Integrity_no_bad_satellites = NULL(name='no-bad-satellites', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GPS_RealTime_Integrity._cont = ASN1Dict([
        ('bad-satellites', _GPS_RealTime_Integrity_bad_satellites),
        ('no-bad-satellites', _GPS_RealTime_Integrity_no_bad_satellites),
        ])
    GPS_RealTime_Integrity._ext = None
    
    #-----< GPSBadSat-Info-RealTime-Integrity >-----#
    GPSBadSat_Info_RealTime_Integrity = SEQ(name='GPSBadSat-Info-RealTime-Integrity', mode=MODE_TYPE)
    _GPSBadSat_Info_RealTime_Integrity_sat_info = SEQ_OF(name='sat-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SATInfo-RealTime-Integrity')))
    _GPSBadSat_Info_RealTime_Integrity_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__id._const_tab = ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__id_tab
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__id._const_tab_at = None
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__id._const_tab_id = 'id'
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__criticality._const_tab = ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__criticality_tab
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__extensionValue._const_tab = ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__extensionValue_tab
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__id),
        ('criticality', ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__criticality),
        ('extensionValue', ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__extensionValue),
        ])
    __GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item_._ext = None
    _GPSBadSat_Info_RealTime_Integrity_ie_Extensions._cont = __GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item_
    _GPSBadSat_Info_RealTime_Integrity_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPSBadSat_Info_RealTime_Integrity._cont = ASN1Dict([
        ('sat-info', _GPSBadSat_Info_RealTime_Integrity_sat_info),
        ('ie-Extensions', _GPSBadSat_Info_RealTime_Integrity_ie_Extensions),
        ])
    GPSBadSat_Info_RealTime_Integrity._ext = []
    
    #-----< GPSBadSat-Info-RealTime-Integrity-ExtIEs >-----#
    GPSBadSat_Info_RealTime_Integrity_ExtIEs = CLASS(name='GPSBadSat-Info-RealTime-Integrity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GPSBadSat_Info_RealTime_Integrity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-NavigationModel-and-TimeRecovery >-----#
    GPS_NavigationModel_and_TimeRecovery = SEQ_OF(name='GPS-NavigationModel-and-TimeRecovery', mode=MODE_TYPE)
    _GPS_NavigationModel_and_TimeRecovery__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GPS-NavandRecovery-Item')))
    GPS_NavigationModel_and_TimeRecovery._cont = _GPS_NavigationModel_and_TimeRecovery__item_
    GPS_NavigationModel_and_TimeRecovery._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GPS-NavandRecovery-Item >-----#
    GPS_NavandRecovery_Item = SEQ(name='GPS-NavandRecovery-Item', mode=MODE_TYPE)
    _GPS_NavandRecovery_Item_tx_tow_nav = INT(name='tx-tow-nav', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_tx_tow_nav._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    _GPS_NavandRecovery_Item_sat_id_nav = INT(name='sat-id-nav', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SAT-ID')))
    _GPS_NavandRecovery_Item_tlm_message_nav = BIT_STR(name='tlm-message-nav', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_tlm_message_nav._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_tlm_revd_c_nav = BIT_STR(name='tlm-revd-c-nav', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_tlm_revd_c_nav._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_ho_word_nav = BIT_STR(name='ho-word-nav', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_ho_word_nav._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_w_n_nav = BIT_STR(name='w-n-nav', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_w_n_nav._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_ca_or_p_on_l2_nav = BIT_STR(name='ca-or-p-on-l2-nav', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_ca_or_p_on_l2_nav._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_user_range_accuracy_index_nav = BIT_STR(name='user-range-accuracy-index-nav', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_user_range_accuracy_index_nav._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_sv_health_nav = BIT_STR(name='sv-health-nav', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_sv_health_nav._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_iodc_nav = BIT_STR(name='iodc-nav', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_iodc_nav._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_l2_p_dataflag_nav = BIT_STR(name='l2-p-dataflag-nav', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_l2_p_dataflag_nav._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_sf1_reserved_nav = BIT_STR(name='sf1-reserved-nav', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_sf1_reserved_nav._const_sz = ASN1Set(rv=[87], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_t_gd_nav = BIT_STR(name='t-gd-nav', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_t_gd_nav._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_t_oc_nav = BIT_STR(name='t-oc-nav', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_t_oc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_a_f_2_nav = BIT_STR(name='a-f-2-nav', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_a_f_2_nav._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_a_f_1_nav = BIT_STR(name='a-f-1-nav', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_a_f_1_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_a_f_zero_nav = BIT_STR(name='a-f-zero-nav', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_a_f_zero_nav._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_c_rs_nav = BIT_STR(name='c-rs-nav', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_c_rs_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_delta_n_nav = BIT_STR(name='delta-n-nav', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_delta_n_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_m_zero_nav = BIT_STR(name='m-zero-nav', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_m_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_c_uc_nav = BIT_STR(name='c-uc-nav', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_c_uc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_gps_e_nav = BIT_STR(name='gps-e-nav', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_gps_e_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_c_us_nav = BIT_STR(name='c-us-nav', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_c_us_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_a_sqrt_nav = BIT_STR(name='a-sqrt-nav', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_a_sqrt_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_t_oe_nav = BIT_STR(name='t-oe-nav', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_t_oe_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_fit_interval_flag_nav = BIT_STR(name='fit-interval-flag-nav', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_fit_interval_flag_nav._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_aodo_nav = BIT_STR(name='aodo-nav', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_aodo_nav._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_c_ic_nav = BIT_STR(name='c-ic-nav', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_c_ic_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_omega_zero_nav = BIT_STR(name='omega-zero-nav', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_omega_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_c_is_nav = BIT_STR(name='c-is-nav', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_c_is_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_i_zero_nav = BIT_STR(name='i-zero-nav', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_i_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_c_rc_nav = BIT_STR(name='c-rc-nav', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_c_rc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_gps_omega_nav = BIT_STR(name='gps-omega-nav', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_gps_omega_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_omegadot_nav = BIT_STR(name='omegadot-nav', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_omegadot_nav._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_idot_nav = BIT_STR(name='idot-nav', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_idot_nav._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_spare_zero_fill = BIT_STR(name='spare-zero-fill', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_NavandRecovery_Item_spare_zero_fill._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _GPS_NavandRecovery_Item_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_NavandRecovery_Item_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GPS_NavandRecovery_Item_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_NavandRecovery_Item_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_NavandRecovery_Item_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_NavandRecovery_Item_ie_Extensions__item__id._const_tab = ____GPS_NavandRecovery_Item_ie_Extensions__item__id_tab
    ___GPS_NavandRecovery_Item_ie_Extensions__item__id._const_tab_at = None
    ___GPS_NavandRecovery_Item_ie_Extensions__item__id._const_tab_id = 'id'
    ___GPS_NavandRecovery_Item_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPS_NavandRecovery_Item_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_NavandRecovery_Item_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_NavandRecovery_Item_ie_Extensions__item__criticality._const_tab = ____GPS_NavandRecovery_Item_ie_Extensions__item__criticality_tab
    ___GPS_NavandRecovery_Item_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_NavandRecovery_Item_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_NavandRecovery_Item_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPS_NavandRecovery_Item_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_NavandRecovery_Item_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_NavandRecovery_Item_ie_Extensions__item__extensionValue._const_tab = ____GPS_NavandRecovery_Item_ie_Extensions__item__extensionValue_tab
    ___GPS_NavandRecovery_Item_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_NavandRecovery_Item_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_NavandRecovery_Item_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_NavandRecovery_Item_ie_Extensions__item__id),
        ('criticality', ___GPS_NavandRecovery_Item_ie_Extensions__item__criticality),
        ('extensionValue', ___GPS_NavandRecovery_Item_ie_Extensions__item__extensionValue),
        ])
    __GPS_NavandRecovery_Item_ie_Extensions__item_._ext = None
    _GPS_NavandRecovery_Item_ie_Extensions._cont = __GPS_NavandRecovery_Item_ie_Extensions__item_
    _GPS_NavandRecovery_Item_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_NavandRecovery_Item._cont = ASN1Dict([
        ('tx-tow-nav', _GPS_NavandRecovery_Item_tx_tow_nav),
        ('sat-id-nav', _GPS_NavandRecovery_Item_sat_id_nav),
        ('tlm-message-nav', _GPS_NavandRecovery_Item_tlm_message_nav),
        ('tlm-revd-c-nav', _GPS_NavandRecovery_Item_tlm_revd_c_nav),
        ('ho-word-nav', _GPS_NavandRecovery_Item_ho_word_nav),
        ('w-n-nav', _GPS_NavandRecovery_Item_w_n_nav),
        ('ca-or-p-on-l2-nav', _GPS_NavandRecovery_Item_ca_or_p_on_l2_nav),
        ('user-range-accuracy-index-nav', _GPS_NavandRecovery_Item_user_range_accuracy_index_nav),
        ('sv-health-nav', _GPS_NavandRecovery_Item_sv_health_nav),
        ('iodc-nav', _GPS_NavandRecovery_Item_iodc_nav),
        ('l2-p-dataflag-nav', _GPS_NavandRecovery_Item_l2_p_dataflag_nav),
        ('sf1-reserved-nav', _GPS_NavandRecovery_Item_sf1_reserved_nav),
        ('t-gd-nav', _GPS_NavandRecovery_Item_t_gd_nav),
        ('t-oc-nav', _GPS_NavandRecovery_Item_t_oc_nav),
        ('a-f-2-nav', _GPS_NavandRecovery_Item_a_f_2_nav),
        ('a-f-1-nav', _GPS_NavandRecovery_Item_a_f_1_nav),
        ('a-f-zero-nav', _GPS_NavandRecovery_Item_a_f_zero_nav),
        ('c-rs-nav', _GPS_NavandRecovery_Item_c_rs_nav),
        ('delta-n-nav', _GPS_NavandRecovery_Item_delta_n_nav),
        ('m-zero-nav', _GPS_NavandRecovery_Item_m_zero_nav),
        ('c-uc-nav', _GPS_NavandRecovery_Item_c_uc_nav),
        ('gps-e-nav', _GPS_NavandRecovery_Item_gps_e_nav),
        ('c-us-nav', _GPS_NavandRecovery_Item_c_us_nav),
        ('a-sqrt-nav', _GPS_NavandRecovery_Item_a_sqrt_nav),
        ('t-oe-nav', _GPS_NavandRecovery_Item_t_oe_nav),
        ('fit-interval-flag-nav', _GPS_NavandRecovery_Item_fit_interval_flag_nav),
        ('aodo-nav', _GPS_NavandRecovery_Item_aodo_nav),
        ('c-ic-nav', _GPS_NavandRecovery_Item_c_ic_nav),
        ('omega-zero-nav', _GPS_NavandRecovery_Item_omega_zero_nav),
        ('c-is-nav', _GPS_NavandRecovery_Item_c_is_nav),
        ('i-zero-nav', _GPS_NavandRecovery_Item_i_zero_nav),
        ('c-rc-nav', _GPS_NavandRecovery_Item_c_rc_nav),
        ('gps-omega-nav', _GPS_NavandRecovery_Item_gps_omega_nav),
        ('omegadot-nav', _GPS_NavandRecovery_Item_omegadot_nav),
        ('idot-nav', _GPS_NavandRecovery_Item_idot_nav),
        ('spare-zero-fill', _GPS_NavandRecovery_Item_spare_zero_fill),
        ('ie-Extensions', _GPS_NavandRecovery_Item_ie_Extensions),
        ])
    GPS_NavandRecovery_Item._ext = []
    
    #-----< GPS-NavandRecovery-Item-ExtIEs >-----#
    GPS_NavandRecovery_Item_ExtIEs = CLASS(name='GPS-NavandRecovery-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GPS_NavandRecovery_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-RX-POS >-----#
    GPS_RX_POS = SEQ(name='GPS-RX-POS', mode=MODE_TYPE)
    _GPS_RX_POS_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_RX_POS_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _GPS_RX_POS_latitudeSign._ext = None
    _GPS_RX_POS_latitude = INT(name='latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_RX_POS_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _GPS_RX_POS_longitude = INT(name='longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_RX_POS_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _GPS_RX_POS_directionOfAltitude = ENUM(name='directionOfAltitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_RX_POS_directionOfAltitude._cont = ASN1Dict([('height', 0), ('depth', 1)])
    _GPS_RX_POS_directionOfAltitude._ext = None
    _GPS_RX_POS_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_RX_POS_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _GPS_RX_POS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_RX_POS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GPS_RX_POS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_RX_POS_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_RX_POS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_RX_POS_iE_Extensions__item__id._const_tab = ____GPS_RX_POS_iE_Extensions__item__id_tab
    ___GPS_RX_POS_iE_Extensions__item__id._const_tab_at = None
    ___GPS_RX_POS_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPS_RX_POS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPS_RX_POS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_RX_POS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_RX_POS_iE_Extensions__item__criticality._const_tab = ____GPS_RX_POS_iE_Extensions__item__criticality_tab
    ___GPS_RX_POS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_RX_POS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_RX_POS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPS_RX_POS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_RX_POS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_RX_POS_iE_Extensions__item__extensionValue._const_tab = ____GPS_RX_POS_iE_Extensions__item__extensionValue_tab
    ___GPS_RX_POS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_RX_POS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_RX_POS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_RX_POS_iE_Extensions__item__id),
        ('criticality', ___GPS_RX_POS_iE_Extensions__item__criticality),
        ('extensionValue', ___GPS_RX_POS_iE_Extensions__item__extensionValue),
        ])
    __GPS_RX_POS_iE_Extensions__item_._ext = None
    _GPS_RX_POS_iE_Extensions._cont = __GPS_RX_POS_iE_Extensions__item_
    _GPS_RX_POS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_RX_POS._cont = ASN1Dict([
        ('latitudeSign', _GPS_RX_POS_latitudeSign),
        ('latitude', _GPS_RX_POS_latitude),
        ('longitude', _GPS_RX_POS_longitude),
        ('directionOfAltitude', _GPS_RX_POS_directionOfAltitude),
        ('altitude', _GPS_RX_POS_altitude),
        ('iE-Extensions', _GPS_RX_POS_iE_Extensions),
        ])
    GPS_RX_POS._ext = []
    
    #-----< GPS-RX-POS-ExtIEs >-----#
    GPS_RX_POS_ExtIEs = CLASS(name='GPS-RX-POS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GPS_RX_POS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-Status-Health >-----#
    GPS_Status_Health = ENUM(name='GPS-Status-Health', mode=MODE_TYPE)
    GPS_Status_Health._cont = ASN1Dict([('udre-scale-1dot0', 0), ('udre-scale-0dot75', 1), ('udre-scale-0dot5', 2), ('udre-scale-0dot3', 3), ('udre-scale-0dot1', 4), ('no-data', 5), ('invalid-data', 6)])
    GPS_Status_Health._ext = None
    
    #-----< GPSTOW >-----#
    GPSTOW = INT(name='GPSTOW', mode=MODE_TYPE)
    GPSTOW._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=604799)], ev=None, er=[])
    
    #-----< GPS-UTC-Model >-----#
    GPS_UTC_Model = SEQ(name='GPS-UTC-Model', mode=MODE_TYPE)
    _GPS_UTC_Model_a_one_utc = BIT_STR(name='a-one-utc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_a_one_utc._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GPS_UTC_Model_a_zero_utc = BIT_STR(name='a-zero-utc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_a_zero_utc._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_UTC_Model_t_ot_utc = BIT_STR(name='t-ot-utc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_t_ot_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_delta_t_ls_utc = BIT_STR(name='delta-t-ls-utc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_delta_t_ls_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_w_n_t_utc = BIT_STR(name='w-n-t-utc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_w_n_t_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_w_n_lsf_utc = BIT_STR(name='w-n-lsf-utc', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_w_n_lsf_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_dn_utc = BIT_STR(name='dn-utc', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_dn_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_delta_t_lsf_utc = BIT_STR(name='delta-t-lsf-utc', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_delta_t_lsf_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_UTC_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GPS_UTC_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_UTC_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_UTC_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_UTC_Model_ie_Extensions__item__id._const_tab = ____GPS_UTC_Model_ie_Extensions__item__id_tab
    ___GPS_UTC_Model_ie_Extensions__item__id._const_tab_at = None
    ___GPS_UTC_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___GPS_UTC_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPS_UTC_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_UTC_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_UTC_Model_ie_Extensions__item__criticality._const_tab = ____GPS_UTC_Model_ie_Extensions__item__criticality_tab
    ___GPS_UTC_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_UTC_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_UTC_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPS_UTC_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GPS_UTC_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_UTC_Model_ie_Extensions__item__extensionValue._const_tab = ____GPS_UTC_Model_ie_Extensions__item__extensionValue_tab
    ___GPS_UTC_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_UTC_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_UTC_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_UTC_Model_ie_Extensions__item__id),
        ('criticality', ___GPS_UTC_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___GPS_UTC_Model_ie_Extensions__item__extensionValue),
        ])
    __GPS_UTC_Model_ie_Extensions__item_._ext = None
    _GPS_UTC_Model_ie_Extensions._cont = __GPS_UTC_Model_ie_Extensions__item_
    _GPS_UTC_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_UTC_Model._cont = ASN1Dict([
        ('a-one-utc', _GPS_UTC_Model_a_one_utc),
        ('a-zero-utc', _GPS_UTC_Model_a_zero_utc),
        ('t-ot-utc', _GPS_UTC_Model_t_ot_utc),
        ('delta-t-ls-utc', _GPS_UTC_Model_delta_t_ls_utc),
        ('w-n-t-utc', _GPS_UTC_Model_w_n_t_utc),
        ('w-n-lsf-utc', _GPS_UTC_Model_w_n_lsf_utc),
        ('dn-utc', _GPS_UTC_Model_dn_utc),
        ('delta-t-lsf-utc', _GPS_UTC_Model_delta_t_lsf_utc),
        ('ie-Extensions', _GPS_UTC_Model_ie_Extensions),
        ])
    GPS_UTC_Model._ext = []
    
    #-----< GPS-UTC-Model-ExtIEs >-----#
    GPS_UTC_Model_ExtIEs = CLASS(name='GPS-UTC-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GPS_UTC_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HARQ-Info-for-E-DCH >-----#
    HARQ_Info_for_E_DCH = ENUM(name='HARQ-Info-for-E-DCH', mode=MODE_TYPE)
    HARQ_Info_for_E_DCH._cont = ASN1Dict([('rv0', 0), ('rvtable', 1)])
    HARQ_Info_for_E_DCH._ext = None
    
    #-----< HARQ-MemoryPartitioning >-----#
    HARQ_MemoryPartitioning = CHOICE(name='HARQ-MemoryPartitioning', mode=MODE_TYPE)
    _HARQ_MemoryPartitioning_implicit = SEQ(name='implicit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioning-Implicit')))
    _HARQ_MemoryPartitioning_explicit = SEQ(name='explicit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioning-Explicit')))
    HARQ_MemoryPartitioning._cont = ASN1Dict([
        ('implicit', _HARQ_MemoryPartitioning_implicit),
        ('explicit', _HARQ_MemoryPartitioning_explicit),
        ])
    HARQ_MemoryPartitioning._ext = []
    
    #-----< HARQ-MemoryPartitioning-Implicit >-----#
    HARQ_MemoryPartitioning_Implicit = SEQ(name='HARQ-MemoryPartitioning-Implicit', mode=MODE_TYPE)
    _HARQ_MemoryPartitioning_Implicit_number_of_Processes = INT(name='number-of-Processes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HARQ_MemoryPartitioning_Implicit_number_of_Processes._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[12, 14, 16], er=[])
    _HARQ_MemoryPartitioning_Implicit_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HARQ_MemoryPartitioning_Implicit_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id._const_tab = ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id_tab
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id._const_tab_at = None
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id._const_tab_id = 'id'
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality._const_tab = ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality_tab
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue._const_tab = ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue_tab
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HARQ_MemoryPartitioning_Implicit_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id),
        ('criticality', ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality),
        ('extensionValue', ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue),
        ])
    __HARQ_MemoryPartitioning_Implicit_iE_Extensions__item_._ext = None
    _HARQ_MemoryPartitioning_Implicit_iE_Extensions._cont = __HARQ_MemoryPartitioning_Implicit_iE_Extensions__item_
    _HARQ_MemoryPartitioning_Implicit_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HARQ_MemoryPartitioning_Implicit._cont = ASN1Dict([
        ('number-of-Processes', _HARQ_MemoryPartitioning_Implicit_number_of_Processes),
        ('iE-Extensions', _HARQ_MemoryPartitioning_Implicit_iE_Extensions),
        ])
    HARQ_MemoryPartitioning_Implicit._ext = []
    
    #-----< HARQ-MemoryPartitioning-Implicit-ExtIEs >-----#
    HARQ_MemoryPartitioning_Implicit_ExtIEs = CLASS(name='HARQ-MemoryPartitioning-Implicit-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HARQ_MemoryPartitioning_Implicit_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HARQ-MemoryPartitioning-Explicit >-----#
    HARQ_MemoryPartitioning_Explicit = SEQ(name='HARQ-MemoryPartitioning-Explicit', mode=MODE_TYPE)
    _HARQ_MemoryPartitioning_Explicit_hARQ_MemoryPartitioningList = SEQ_OF(name='hARQ-MemoryPartitioningList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioningList')))
    _HARQ_MemoryPartitioning_Explicit_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HARQ_MemoryPartitioning_Explicit_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioningInfoExtForMIMO')))
    ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 904), ('criticality', 'ignore'), ('Extension', _____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id._const_tab = ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id._const_tab_at = None
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id._const_tab_id = 'id'
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality._const_tab = ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue._const_tab = ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HARQ_MemoryPartitioning_Explicit_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id),
        ('criticality', ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality),
        ('extensionValue', ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue),
        ])
    __HARQ_MemoryPartitioning_Explicit_iE_Extensions__item_._ext = None
    _HARQ_MemoryPartitioning_Explicit_iE_Extensions._cont = __HARQ_MemoryPartitioning_Explicit_iE_Extensions__item_
    _HARQ_MemoryPartitioning_Explicit_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HARQ_MemoryPartitioning_Explicit._cont = ASN1Dict([
        ('hARQ-MemoryPartitioningList', _HARQ_MemoryPartitioning_Explicit_hARQ_MemoryPartitioningList),
        ('iE-Extensions', _HARQ_MemoryPartitioning_Explicit_iE_Extensions),
        ])
    HARQ_MemoryPartitioning_Explicit._ext = []
    
    #-----< HARQ-MemoryPartitioning-Explicit-ExtIEs >-----#
    HARQ_MemoryPartitioning_Explicit_ExtIEs = CLASS(name='HARQ-MemoryPartitioning-Explicit-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HARQ_MemoryPartitioning_Explicit_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioningInfoExtForMIMO')))
    HARQ_MemoryPartitioning_Explicit_ExtIEs._val = ASN1Set(rv=[dict([('id', 904), ('criticality', 'ignore'), ('Extension', _HARQ_MemoryPartitioning_Explicit_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HARQ-MemoryPartitioningList >-----#
    HARQ_MemoryPartitioningList = SEQ_OF(name='HARQ-MemoryPartitioningList', mode=MODE_TYPE)
    _HARQ_MemoryPartitioningList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioningItem')))
    HARQ_MemoryPartitioningList._cont = _HARQ_MemoryPartitioningList__item_
    HARQ_MemoryPartitioningList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HARQ-MemoryPartitioningInfoExtForMIMO >-----#
    HARQ_MemoryPartitioningInfoExtForMIMO = SEQ_OF(name='HARQ-MemoryPartitioningInfoExtForMIMO', mode=MODE_TYPE)
    _HARQ_MemoryPartitioningInfoExtForMIMO__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioningItem')))
    HARQ_MemoryPartitioningInfoExtForMIMO._cont = _HARQ_MemoryPartitioningInfoExtForMIMO__item_
    HARQ_MemoryPartitioningInfoExtForMIMO._const_sz = ASN1Set(rv=[4, 6, 8], rr=[], ev=None, er=[])
    
    #-----< HARQ-MemoryPartitioningItem >-----#
    HARQ_MemoryPartitioningItem = SEQ(name='HARQ-MemoryPartitioningItem', mode=MODE_TYPE)
    _HARQ_MemoryPartitioningItem_process_Memory_Size = ENUM(name='process-Memory-Size', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HARQ_MemoryPartitioningItem_process_Memory_Size._cont = ASN1Dict([('hms800', 0), ('hms1600', 1), ('hms2400', 2), ('hms3200', 3), ('hms4000', 4), ('hms4800', 5), ('hms5600', 6), ('hms6400', 7), ('hms7200', 8), ('hms8000', 9), ('hms8800', 10), ('hms9600', 11), ('hms10400', 12), ('hms11200', 13), ('hms12000', 14), ('hms12800', 15), ('hms13600', 16), ('hms14400', 17), ('hms15200', 18), ('hms16000', 19), ('hms17600', 20), ('hms19200', 21), ('hms20800', 22), ('hms22400', 23), ('hms24000', 24), ('hms25600', 25), ('hms27200', 26), ('hms28800', 27), ('hms30400', 28), ('hms32000', 29), ('hms36000', 30), ('hms40000', 31), ('hms44000', 32), ('hms48000', 33), ('hms52000', 34), ('hms56000', 35), ('hms60000', 36), ('hms64000', 37), ('hms68000', 38), ('hms72000', 39), ('hms76000', 40), ('hms80000', 41), ('hms88000', 42), ('hms96000', 43), ('hms104000', 44), ('hms112000', 45), ('hms120000', 46), ('hms128000', 47), ('hms136000', 48), ('hms144000', 49), ('hms152000', 50), ('hms160000', 51), ('hms176000', 52), ('hms192000', 53), ('hms208000', 54), ('hms224000', 55), ('hms240000', 56), ('hms256000', 57), ('hms272000', 58), ('hms288000', 59), ('hms304000', 60)])
    _HARQ_MemoryPartitioningItem_process_Memory_Size._ext = []
    _HARQ_MemoryPartitioningItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HARQ_MemoryPartitioningItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id._const_tab = ____HARQ_MemoryPartitioningItem_iE_Extensions__item__id_tab
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id._const_tab_at = None
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality._const_tab = ____HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality_tab
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue._const_tab = ____HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue_tab
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HARQ_MemoryPartitioningItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id),
        ('criticality', ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality),
        ('extensionValue', ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue),
        ])
    __HARQ_MemoryPartitioningItem_iE_Extensions__item_._ext = None
    _HARQ_MemoryPartitioningItem_iE_Extensions._cont = __HARQ_MemoryPartitioningItem_iE_Extensions__item_
    _HARQ_MemoryPartitioningItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HARQ_MemoryPartitioningItem._cont = ASN1Dict([
        ('process-Memory-Size', _HARQ_MemoryPartitioningItem_process_Memory_Size),
        ('iE-Extensions', _HARQ_MemoryPartitioningItem_iE_Extensions),
        ])
    HARQ_MemoryPartitioningItem._ext = []
    
    #-----< HARQ-MemoryPartitioningItem-ExtIEs >-----#
    HARQ_MemoryPartitioningItem_ExtIEs = CLASS(name='HARQ-MemoryPartitioningItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HARQ_MemoryPartitioningItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HARQ-Preamble-Mode >-----#
    HARQ_Preamble_Mode = ENUM(name='HARQ-Preamble-Mode', mode=MODE_TYPE)
    HARQ_Preamble_Mode._cont = ASN1Dict([('mode0', 0), ('mode1', 1)])
    HARQ_Preamble_Mode._ext = None
    
    #-----< HARQ-Process-Allocation-2ms-EDCH >-----#
    HARQ_Process_Allocation_2ms_EDCH = BIT_STR(name='HARQ-Process-Allocation-2ms-EDCH', mode=MODE_TYPE)
    HARQ_Process_Allocation_2ms_EDCH._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< HARQ-Preamble-Mode-Activation-Indicator >-----#
    HARQ_Preamble_Mode_Activation_Indicator = ENUM(name='HARQ-Preamble-Mode-Activation-Indicator', mode=MODE_TYPE)
    HARQ_Preamble_Mode_Activation_Indicator._cont = ASN1Dict([('harqPreambleModeActivated', 0)])
    HARQ_Preamble_Mode_Activation_Indicator._ext = None
    
    #-----< HSDPA-Capability >-----#
    HSDPA_Capability = ENUM(name='HSDPA-Capability', mode=MODE_TYPE)
    HSDPA_Capability._cont = ASN1Dict([('hsdpa-capable', 0), ('hsdpa-non-capable', 1)])
    HSDPA_Capability._ext = None
    
    #-----< HS-DSCHProvidedBitRate >-----#
    HS_DSCHProvidedBitRate = SEQ_OF(name='HS-DSCHProvidedBitRate', mode=MODE_TYPE)
    _HS_DSCHProvidedBitRate__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRate-Item')))
    HS_DSCHProvidedBitRate._cont = _HS_DSCHProvidedBitRate__item_
    HS_DSCHProvidedBitRate._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< HS-DSCHProvidedBitRate-Item >-----#
    HS_DSCHProvidedBitRate_Item = SEQ(name='HS-DSCHProvidedBitRate-Item', mode=MODE_TYPE)
    _HS_DSCHProvidedBitRate_Item_schedulingPriorityIndicator = INT(name='schedulingPriorityIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')))
    _HS_DSCHProvidedBitRate_Item_hS_DSCHProvidedBitRateValue = INT(name='hS-DSCHProvidedBitRateValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRateValue')))
    _HS_DSCHProvidedBitRate_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCHProvidedBitRate_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__id._const_tab = ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__id_tab
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__criticality._const_tab = ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__criticality_tab
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__extensionValue_tab
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCHProvidedBitRate_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__id),
        ('criticality', ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCHProvidedBitRate_Item_iE_Extensions__item_._ext = None
    _HS_DSCHProvidedBitRate_Item_iE_Extensions._cont = __HS_DSCHProvidedBitRate_Item_iE_Extensions__item_
    _HS_DSCHProvidedBitRate_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCHProvidedBitRate_Item._cont = ASN1Dict([
        ('schedulingPriorityIndicator', _HS_DSCHProvidedBitRate_Item_schedulingPriorityIndicator),
        ('hS-DSCHProvidedBitRateValue', _HS_DSCHProvidedBitRate_Item_hS_DSCHProvidedBitRateValue),
        ('iE-Extensions', _HS_DSCHProvidedBitRate_Item_iE_Extensions),
        ])
    HS_DSCHProvidedBitRate_Item._ext = []
    
    #-----< HS-DSCHProvidedBitRate-Item-ExtIEs >-----#
    HS_DSCHProvidedBitRate_Item_ExtIEs = CLASS(name='HS-DSCHProvidedBitRate-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCHProvidedBitRate_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCHProvidedBitRateValue >-----#
    HS_DSCHProvidedBitRateValue = INT(name='HS-DSCHProvidedBitRateValue', mode=MODE_TYPE)
    HS_DSCHProvidedBitRateValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=[], er=[ASN1RangeInt(lb=16777216, ub=256000000)])
    
    #-----< HS-DSCHProvidedBitRateValueInformation-For-CellPortion >-----#
    HS_DSCHProvidedBitRateValueInformation_For_CellPortion = SEQ_OF(name='HS-DSCHProvidedBitRateValueInformation-For-CellPortion', mode=MODE_TYPE)
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortion__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRateValueInformation-For-CellPortion-Item')))
    HS_DSCHProvidedBitRateValueInformation_For_CellPortion._cont = _HS_DSCHProvidedBitRateValueInformation_For_CellPortion__item_
    HS_DSCHProvidedBitRateValueInformation_For_CellPortion._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< HS-DSCHProvidedBitRateValueInformation-For-CellPortion-Item >-----#
    HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item = SEQ(name='HS-DSCHProvidedBitRateValueInformation-For-CellPortion-Item', mode=MODE_TYPE)
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_cellPortionID = INT(name='cellPortionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionID')))
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_hS_DSCHProvidedBitRateValue = SEQ_OF(name='hS-DSCHProvidedBitRateValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRate')))
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id._const_tab = ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality._const_tab = ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id),
        ('criticality', ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item_._ext = None
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions._cont = __HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item_
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item._cont = ASN1Dict([
        ('cellPortionID', _HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_cellPortionID),
        ('hS-DSCHProvidedBitRateValue', _HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_hS_DSCHProvidedBitRateValue),
        ('iE-Extensions', _HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions),
        ])
    HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item._ext = []
    
    #-----< HS-DSCHProvidedBitRateValueInformation-For-CellPortion-Item-ExtIEs >-----#
    HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_ExtIEs = CLASS(name='HS-DSCHProvidedBitRateValueInformation-For-CellPortion-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR >-----#
    HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR = SEQ_OF(name='HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR', mode=MODE_TYPE)
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR-Item')))
    HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR._cont = _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR__item_
    HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR-Item >-----#
    HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item = SEQ(name='HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR-Item', mode=MODE_TYPE)
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_hS_DSCHProvidedBitRateValue = SEQ_OF(name='hS-DSCHProvidedBitRateValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHProvidedBitRate')))
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id._const_tab = ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id_tab
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality._const_tab = ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality_tab
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue_tab
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id),
        ('criticality', ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item_._ext = None
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions._cont = __HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item_
    _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item._cont = ASN1Dict([
        ('cellPortionLCRID', _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_cellPortionLCRID),
        ('hS-DSCHProvidedBitRateValue', _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_hS_DSCHProvidedBitRateValue),
        ('iE-Extensions', _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions),
        ])
    HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item._ext = []
    
    #-----< HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR-Item-ExtIEs >-----#
    HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_ExtIEs = CLASS(name='HS-DSCHProvidedBitRateValueInformation-For-CellPortionLCR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCHRequiredPower >-----#
    HS_DSCHRequiredPower = SEQ_OF(name='HS-DSCHRequiredPower', mode=MODE_TYPE)
    _HS_DSCHRequiredPower__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPower-Item')))
    HS_DSCHRequiredPower._cont = _HS_DSCHRequiredPower__item_
    HS_DSCHRequiredPower._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< HS-DSCHRequiredPower-Item >-----#
    HS_DSCHRequiredPower_Item = SEQ(name='HS-DSCHRequiredPower-Item', mode=MODE_TYPE)
    _HS_DSCHRequiredPower_Item_schedulingPriorityIndicator = INT(name='schedulingPriorityIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')))
    _HS_DSCHRequiredPower_Item_hS_DSCHRequiredPowerValue = INT(name='hS-DSCHRequiredPowerValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerValue')))
    _HS_DSCHRequiredPower_Item_hS_DSCHRequiredPowerPerUEInformation = SEQ_OF(name='hS-DSCHRequiredPowerPerUEInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerPerUEInformation')), opt=True)
    _HS_DSCHRequiredPower_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCHRequiredPower_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCHRequiredPower_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPower_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__id._const_tab = ____HS_DSCHRequiredPower_Item_iE_Extensions__item__id_tab
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCHRequiredPower_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPower_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__criticality._const_tab = ____HS_DSCHRequiredPower_Item_iE_Extensions__item__criticality_tab
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCHRequiredPower_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPower_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCHRequiredPower_Item_iE_Extensions__item__extensionValue_tab
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCHRequiredPower_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCHRequiredPower_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCHRequiredPower_Item_iE_Extensions__item__id),
        ('criticality', ___HS_DSCHRequiredPower_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCHRequiredPower_Item_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCHRequiredPower_Item_iE_Extensions__item_._ext = None
    _HS_DSCHRequiredPower_Item_iE_Extensions._cont = __HS_DSCHRequiredPower_Item_iE_Extensions__item_
    _HS_DSCHRequiredPower_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCHRequiredPower_Item._cont = ASN1Dict([
        ('schedulingPriorityIndicator', _HS_DSCHRequiredPower_Item_schedulingPriorityIndicator),
        ('hS-DSCHRequiredPowerValue', _HS_DSCHRequiredPower_Item_hS_DSCHRequiredPowerValue),
        ('hS-DSCHRequiredPowerPerUEInformation', _HS_DSCHRequiredPower_Item_hS_DSCHRequiredPowerPerUEInformation),
        ('iE-Extensions', _HS_DSCHRequiredPower_Item_iE_Extensions),
        ])
    HS_DSCHRequiredPower_Item._ext = []
    
    #-----< HS-DSCHRequiredPower-Item-ExtIEs >-----#
    HS_DSCHRequiredPower_Item_ExtIEs = CLASS(name='HS-DSCHRequiredPower-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCHRequiredPower_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCHRequiredPowerValue >-----#
    HS_DSCHRequiredPowerValue = INT(name='HS-DSCHRequiredPowerValue', mode=MODE_TYPE)
    HS_DSCHRequiredPowerValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    
    #-----< HS-DSCHRequiredPowerPerUEInformation >-----#
    HS_DSCHRequiredPowerPerUEInformation = SEQ_OF(name='HS-DSCHRequiredPowerPerUEInformation', mode=MODE_TYPE)
    _HS_DSCHRequiredPowerPerUEInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerPerUEInformation-Item')))
    HS_DSCHRequiredPowerPerUEInformation._cont = _HS_DSCHRequiredPowerPerUEInformation__item_
    HS_DSCHRequiredPowerPerUEInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< HS-DSCHRequiredPowerPerUEInformation-Item >-----#
    HS_DSCHRequiredPowerPerUEInformation_Item = SEQ(name='HS-DSCHRequiredPowerPerUEInformation-Item', mode=MODE_TYPE)
    _HS_DSCHRequiredPowerPerUEInformation_Item_cRNC_CommunicationContextID = INT(name='cRNC-CommunicationContextID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _HS_DSCHRequiredPowerPerUEInformation_Item_hS_DSCHRequiredPowerPerUEWeight = INT(name='hS-DSCHRequiredPowerPerUEWeight', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerPerUEWeight')), opt=True)
    _HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__id._const_tab = ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__id_tab
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__criticality._const_tab = ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__criticality_tab
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__extensionValue_tab
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__id),
        ('criticality', ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item_._ext = None
    _HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions._cont = __HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item_
    _HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCHRequiredPowerPerUEInformation_Item._cont = ASN1Dict([
        ('cRNC-CommunicationContextID', _HS_DSCHRequiredPowerPerUEInformation_Item_cRNC_CommunicationContextID),
        ('hS-DSCHRequiredPowerPerUEWeight', _HS_DSCHRequiredPowerPerUEInformation_Item_hS_DSCHRequiredPowerPerUEWeight),
        ('iE-Extensions', _HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions),
        ])
    HS_DSCHRequiredPowerPerUEInformation_Item._ext = []
    
    #-----< HS-DSCHRequiredPowerPerUEInformation-Item-ExtIEs >-----#
    HS_DSCHRequiredPowerPerUEInformation_Item_ExtIEs = CLASS(name='HS-DSCHRequiredPowerPerUEInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCHRequiredPowerPerUEInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCHRequiredPowerPerUEWeight >-----#
    HS_DSCHRequiredPowerPerUEWeight = INT(name='HS-DSCHRequiredPowerPerUEWeight', mode=MODE_TYPE)
    HS_DSCHRequiredPowerPerUEWeight._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< HS-DSCHRequiredPowerValueInformation-For-CellPortion >-----#
    HS_DSCHRequiredPowerValueInformation_For_CellPortion = SEQ_OF(name='HS-DSCHRequiredPowerValueInformation-For-CellPortion', mode=MODE_TYPE)
    _HS_DSCHRequiredPowerValueInformation_For_CellPortion__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerValueInformation-For-CellPortion-Item')))
    HS_DSCHRequiredPowerValueInformation_For_CellPortion._cont = _HS_DSCHRequiredPowerValueInformation_For_CellPortion__item_
    HS_DSCHRequiredPowerValueInformation_For_CellPortion._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< HS-DSCHRequiredPowerValueInformation-For-CellPortion-Item >-----#
    HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item = SEQ(name='HS-DSCHRequiredPowerValueInformation-For-CellPortion-Item', mode=MODE_TYPE)
    _HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_cellPortionID = INT(name='cellPortionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionID')))
    _HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_hS_DSCHRequiredPowerValue = SEQ_OF(name='hS-DSCHRequiredPowerValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPower')))
    _HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__id._const_tab = ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality._const_tab = ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__id),
        ('criticality', ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item_._ext = None
    _HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions._cont = __HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item_
    _HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item._cont = ASN1Dict([
        ('cellPortionID', _HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_cellPortionID),
        ('hS-DSCHRequiredPowerValue', _HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_hS_DSCHRequiredPowerValue),
        ('iE-Extensions', _HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions),
        ])
    HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item._ext = []
    
    #-----< HS-DSCHRequiredPowerValueInformation-For-CellPortion-Item-ExtIEs >-----#
    HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_ExtIEs = CLASS(name='HS-DSCHRequiredPowerValueInformation-For-CellPortion-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR >-----#
    HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR = SEQ_OF(name='HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR', mode=MODE_TYPE)
    _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR-Item')))
    HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR._cont = _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR__item_
    HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR-Item >-----#
    HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item = SEQ(name='HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR-Item', mode=MODE_TYPE)
    _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_hS_DSCHRequiredPowerValue = SEQ_OF(name='hS-DSCHRequiredPowerValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPower')))
    _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id._const_tab = ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id_tab
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality._const_tab = ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality_tab
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue_tab
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id),
        ('criticality', ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item_._ext = None
    _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions._cont = __HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item_
    _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item._cont = ASN1Dict([
        ('cellPortionLCRID', _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_cellPortionLCRID),
        ('hS-DSCHRequiredPowerValue', _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_hS_DSCHRequiredPowerValue),
        ('iE-Extensions', _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions),
        ])
    HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item._ext = []
    
    #-----< HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR-Item-ExtIEs >-----#
    HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_ExtIEs = CLASS(name='HS-DSCHRequiredPowerValueInformation-For-CellPortionLCR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDPA-Associated-PICH-Information >-----#
    HSDPA_Associated_PICH_Information = CHOICE(name='HSDPA-Associated-PICH-Information', mode=MODE_TYPE)
    _HSDPA_Associated_PICH_Information_hsdpa_PICH_Shared_with_PCH = SEQ(name='hsdpa-PICH-Shared-with-PCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-PICH-Shared-with-PCH')))
    _HSDPA_Associated_PICH_Information_hsdpa_PICH_notShared_with_PCH = SEQ(name='hsdpa-PICH-notShared-with-PCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-PICH-notShared-with-PCH')))
    HSDPA_Associated_PICH_Information._cont = ASN1Dict([
        ('hsdpa-PICH-Shared-with-PCH', _HSDPA_Associated_PICH_Information_hsdpa_PICH_Shared_with_PCH),
        ('hsdpa-PICH-notShared-with-PCH', _HSDPA_Associated_PICH_Information_hsdpa_PICH_notShared_with_PCH),
        ])
    HSDPA_Associated_PICH_Information._ext = []
    
    #-----< HSDPA-PICH-Shared-with-PCH >-----#
    HSDPA_PICH_Shared_with_PCH = SEQ(name='HSDPA-PICH-Shared-with-PCH', mode=MODE_TYPE)
    _HSDPA_PICH_Shared_with_PCH_hsdpa_PICH_SharedPCH_ID = INT(name='hsdpa-PICH-SharedPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    HSDPA_PICH_Shared_with_PCH._cont = ASN1Dict([
        ('hsdpa-PICH-SharedPCH-ID', _HSDPA_PICH_Shared_with_PCH_hsdpa_PICH_SharedPCH_ID),
        ])
    HSDPA_PICH_Shared_with_PCH._ext = []
    
    #-----< HSDPA-PICH-notShared-with-PCH >-----#
    HSDPA_PICH_notShared_with_PCH = SEQ(name='HSDPA-PICH-notShared-with-PCH', mode=MODE_TYPE)
    _HSDPA_PICH_notShared_with_PCH_hSDPA_PICH_notShared_ID = INT(name='hSDPA-PICH-notShared-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _HSDPA_PICH_notShared_with_PCH_fdd_DL_Channelisation_CodeNumber = INT(name='fdd-DL-Channelisation-CodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _HSDPA_PICH_notShared_with_PCH_pich_Power = INT(name='pich-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')))
    _HSDPA_PICH_notShared_with_PCH_pich_Mode = ENUM(name='pich-Mode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Mode')))
    _HSDPA_PICH_notShared_with_PCH_sttd_Indicator = ENUM(name='sttd-Indicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'STTD-Indicator')))
    HSDPA_PICH_notShared_with_PCH._cont = ASN1Dict([
        ('hSDPA-PICH-notShared-ID', _HSDPA_PICH_notShared_with_PCH_hSDPA_PICH_notShared_ID),
        ('fdd-DL-Channelisation-CodeNumber', _HSDPA_PICH_notShared_with_PCH_fdd_DL_Channelisation_CodeNumber),
        ('pich-Power', _HSDPA_PICH_notShared_with_PCH_pich_Power),
        ('pich-Mode', _HSDPA_PICH_notShared_with_PCH_pich_Mode),
        ('sttd-Indicator', _HSDPA_PICH_notShared_with_PCH_sttd_Indicator),
        ])
    HSDPA_PICH_notShared_with_PCH._ext = []
    
    #-----< HSDSCH-Common-System-InformationFDD >-----#
    HSDSCH_Common_System_InformationFDD = SEQ(name='HSDSCH-Common-System-InformationFDD', mode=MODE_TYPE)
    _HSDSCH_Common_System_InformationFDD_hsdsch_Common_Information = SEQ(name='hsdsch-Common-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Common-Information')), opt=True)
    _HSDSCH_Common_System_InformationFDD_commonMACFlow_Specific_Information = SEQ_OF(name='commonMACFlow-Specific-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMACFlow-Specific-InfoList')), opt=True)
    _HSDSCH_Common_System_InformationFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Common_System_InformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-HSDSCH-RNTI-List')))
    ____HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1199), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id._const_tab = ____HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id_tab
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id_tab
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id_tab
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Common_System_InformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Common_System_InformationFDD_iE_Extensions__item_._ext = None
    _HSDSCH_Common_System_InformationFDD_iE_Extensions._cont = __HSDSCH_Common_System_InformationFDD_iE_Extensions__item_
    _HSDSCH_Common_System_InformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Common_System_InformationFDD._cont = ASN1Dict([
        ('hsdsch-Common-Information', _HSDSCH_Common_System_InformationFDD_hsdsch_Common_Information),
        ('commonMACFlow-Specific-Information', _HSDSCH_Common_System_InformationFDD_commonMACFlow_Specific_Information),
        ('iE-Extensions', _HSDSCH_Common_System_InformationFDD_iE_Extensions),
        ])
    HSDSCH_Common_System_InformationFDD._ext = []
    
    #-----< HSDSCH-Common-System-InformationFDD-ExtIEs >-----#
    HSDSCH_Common_System_InformationFDD_ExtIEs = CLASS(name='HSDSCH-Common-System-InformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_Common_System_InformationFDD_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-HSDSCH-RNTI-List')))
    HSDSCH_Common_System_InformationFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 1199), ('criticality', 'ignore'), ('Extension', _HSDSCH_Common_System_InformationFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Common-System-Information-ResponseFDD >-----#
    HSDSCH_Common_System_Information_ResponseFDD = SEQ(name='HSDSCH-Common-System-Information-ResponseFDD', mode=MODE_TYPE)
    _HSDSCH_Common_System_Information_ResponseFDD_hsSCCH_Specific_Information_ResponseFDD = SEQ_OF(name='hsSCCH-Specific-Information-ResponseFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespListFDD')), opt=True)
    _HSDSCH_Common_System_Information_ResponseFDD_hARQ_MemoryPartitioning = CHOICE(name='hARQ-MemoryPartitioning', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioning')), opt=True)
    _HSDSCH_Common_System_Information_ResponseFDD_commonMACFlow_Specific_Info_Response = SEQ_OF(name='commonMACFlow-Specific-Info-Response', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMACFlow-Specific-InfoList-Response')), opt=True)
    _HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__id._const_tab = ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__id_tab
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__criticality_tab
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item_._ext = None
    _HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions._cont = __HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item_
    _HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Common_System_Information_ResponseFDD._cont = ASN1Dict([
        ('hsSCCH-Specific-Information-ResponseFDD', _HSDSCH_Common_System_Information_ResponseFDD_hsSCCH_Specific_Information_ResponseFDD),
        ('hARQ-MemoryPartitioning', _HSDSCH_Common_System_Information_ResponseFDD_hARQ_MemoryPartitioning),
        ('commonMACFlow-Specific-Info-Response', _HSDSCH_Common_System_Information_ResponseFDD_commonMACFlow_Specific_Info_Response),
        ('iE-Extensions', _HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions),
        ])
    HSDSCH_Common_System_Information_ResponseFDD._ext = []
    
    #-----< HSDSCH-Common-System-Information-ResponseFDD-ExtIEs >-----#
    HSDSCH_Common_System_Information_ResponseFDD_ExtIEs = CLASS(name='HSDSCH-Common-System-Information-ResponseFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_Common_System_Information_ResponseFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Common-Information >-----#
    HSDSCH_Common_Information = SEQ(name='HSDSCH-Common-Information', mode=MODE_TYPE)
    _HSDSCH_Common_Information_cCCH_PriorityQueue_Id = INT(name='cCCH-PriorityQueue-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-Id')))
    _HSDSCH_Common_Information_sRB1_PriorityQueue_Id = INT(name='sRB1-PriorityQueue-Id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-Id')))
    _HSDSCH_Common_Information_associatedCommon_MACFlow = INT(name='associatedCommon-MACFlow', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID')))
    _HSDSCH_Common_Information_fACH_Measurement_Occasion_Cycle_Length_Coefficient = INT(name='fACH-Measurement-Occasion-Cycle-Length-Coefficient', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FACH-Measurement-Occasion-Cycle-Length-Coefficient')), opt=True)
    _HSDSCH_Common_Information_rACH_Measurement_Result = ENUM(name='rACH-Measurement-Result', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RACH-Measurement-Result')))
    _HSDSCH_Common_Information_bCCH_Specific_HSDSCH_RNTI_Information = SEQ(name='bCCH-Specific-HSDSCH-RNTI-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BCCH-Specific-HSDSCH-RNTI-Information')))
    _HSDSCH_Common_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Common_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Common_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Common_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_Information_iE_Extensions__item__id._const_tab = ____HSDSCH_Common_Information_iE_Extensions__item__id_tab
    ___HSDSCH_Common_Information_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Common_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Common_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_Common_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_Information_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Common_Information_iE_Extensions__item__criticality_tab
    ___HSDSCH_Common_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Common_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_Common_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_Information_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Common_Information_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_Common_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Common_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Common_Information_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Common_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Common_Information_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Common_Information_iE_Extensions__item_._ext = None
    _HSDSCH_Common_Information_iE_Extensions._cont = __HSDSCH_Common_Information_iE_Extensions__item_
    _HSDSCH_Common_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Common_Information._cont = ASN1Dict([
        ('cCCH-PriorityQueue-Id', _HSDSCH_Common_Information_cCCH_PriorityQueue_Id),
        ('sRB1-PriorityQueue-Id', _HSDSCH_Common_Information_sRB1_PriorityQueue_Id),
        ('associatedCommon-MACFlow', _HSDSCH_Common_Information_associatedCommon_MACFlow),
        ('fACH-Measurement-Occasion-Cycle-Length-Coefficient', _HSDSCH_Common_Information_fACH_Measurement_Occasion_Cycle_Length_Coefficient),
        ('rACH-Measurement-Result', _HSDSCH_Common_Information_rACH_Measurement_Result),
        ('bCCH-Specific-HSDSCH-RNTI-Information', _HSDSCH_Common_Information_bCCH_Specific_HSDSCH_RNTI_Information),
        ('iE-Extensions', _HSDSCH_Common_Information_iE_Extensions),
        ])
    HSDSCH_Common_Information._ext = []
    
    #-----< HSDSCH-Common-Information-ExtIEs >-----#
    HSDSCH_Common_Information_ExtIEs = CLASS(name='HSDSCH-Common-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_Common_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-FDD-Information >-----#
    HSDSCH_FDD_Information = SEQ(name='HSDSCH-FDD-Information', mode=MODE_TYPE)
    _HSDSCH_FDD_Information_hSDSCH_MACdFlows_Information = SEQ(name='hSDSCH-MACdFlows-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _HSDSCH_FDD_Information_ueCapability_Info = SEQ(name='ueCapability-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-Capability-Information')))
    _HSDSCH_FDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM = INT(name='mAChs-Reordering-Buffer-Size-for-RLC-UM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAChsReorderingBufferSize-for-RLC-UM')))
    _HSDSCH_FDD_Information_cqiFeedback_CycleK = ENUM(name='cqiFeedback-CycleK', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-Feedback-Cycle')))
    _HSDSCH_FDD_Information_cqiRepetitionFactor = INT(name='cqiRepetitionFactor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-RepetitionFactor')), opt=True)
    _HSDSCH_FDD_Information_ackNackRepetitionFactor = INT(name='ackNackRepetitionFactor', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AckNack-RepetitionFactor')))
    _HSDSCH_FDD_Information_cqiPowerOffset = INT(name='cqiPowerOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-Power-Offset')))
    _HSDSCH_FDD_Information_ackPowerOffset = INT(name='ackPowerOffset', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Ack-Power-Offset')))
    _HSDSCH_FDD_Information_nackPowerOffset = INT(name='nackPowerOffset', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Nack-Power-Offset')))
    _HSDSCH_FDD_Information_hsscch_PowerOffset = INT(name='hsscch-PowerOffset', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HSDSCH_FDD_Information_measurement_Power_Offset = INT(name='measurement-Power-Offset', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Measurement-Power-Offset')), opt=True)
    _HSDSCH_FDD_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_FDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_FDD_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Preamble-Mode')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-ActivationIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4 = NULL(name='Extension', mode=MODE_TYPE)
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EnhancedHSServingCC-Abort')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_6 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-SupportIndicatorExtension')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_7 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-ActivationIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_8 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Puncturing-Handling-in-First-Rate-Matching-Stage')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_9 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_10 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Information')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_12 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Feedback-Cycle2')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Cycle-Switch-Timer')))
    ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 650), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 905), ('criticality', 'reject'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 865), ('criticality', 'reject'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 947), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 970), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1036), ('criticality', 'reject'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1085), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1088), ('criticality', 'reject'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1202), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1226), ('criticality', 'reject'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1229), ('criticality', 'reject'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 1237), ('criticality', 'reject'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 1280), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 1281), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_FDD_Information_iE_Extensions__item__id._const_tab = ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_FDD_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_FDD_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_FDD_Information_iE_Extensions__item__criticality._const_tab = ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_FDD_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_FDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_FDD_Information_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_FDD_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_FDD_Information_iE_Extensions__item_._ext = None
    _HSDSCH_FDD_Information_iE_Extensions._cont = __HSDSCH_FDD_Information_iE_Extensions__item_
    _HSDSCH_FDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_FDD_Information._cont = ASN1Dict([
        ('hSDSCH-MACdFlows-Information', _HSDSCH_FDD_Information_hSDSCH_MACdFlows_Information),
        ('ueCapability-Info', _HSDSCH_FDD_Information_ueCapability_Info),
        ('mAChs-Reordering-Buffer-Size-for-RLC-UM', _HSDSCH_FDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM),
        ('cqiFeedback-CycleK', _HSDSCH_FDD_Information_cqiFeedback_CycleK),
        ('cqiRepetitionFactor', _HSDSCH_FDD_Information_cqiRepetitionFactor),
        ('ackNackRepetitionFactor', _HSDSCH_FDD_Information_ackNackRepetitionFactor),
        ('cqiPowerOffset', _HSDSCH_FDD_Information_cqiPowerOffset),
        ('ackPowerOffset', _HSDSCH_FDD_Information_ackPowerOffset),
        ('nackPowerOffset', _HSDSCH_FDD_Information_nackPowerOffset),
        ('hsscch-PowerOffset', _HSDSCH_FDD_Information_hsscch_PowerOffset),
        ('measurement-Power-Offset', _HSDSCH_FDD_Information_measurement_Power_Offset),
        ('iE-Extensions', _HSDSCH_FDD_Information_iE_Extensions),
        ])
    HSDSCH_FDD_Information._ext = []
    
    #-----< HSDSCH-FDD-Information-ExtIEs >-----#
    HSDSCH_FDD_Information_ExtIEs = CLASS(name='HSDSCH-FDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Preamble-Mode')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-ActivationIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_4 = NULL(name='Extension', mode=MODE_TYPE)
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EnhancedHSServingCC-Abort')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_6 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-SupportIndicatorExtension')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_7 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-ActivationIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_8 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Puncturing-Handling-in-First-Rate-Matching-Stage')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_9 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_10 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Information')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_12 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Feedback-Cycle2')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Cycle-Switch-Timer')))
    HSDSCH_FDD_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 650), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 905), ('criticality', 'reject'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 865), ('criticality', 'reject'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 947), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 970), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1036), ('criticality', 'reject'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 1085), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 1088), ('criticality', 'reject'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 1202), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 1226), ('criticality', 'reject'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 1229), ('criticality', 'reject'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 1237), ('criticality', 'reject'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 1280), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 1281), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_13), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-TDD-Information >-----#
    HSDSCH_TDD_Information = SEQ(name='HSDSCH-TDD-Information', mode=MODE_TYPE)
    _HSDSCH_TDD_Information_hSDSCH_MACdFlows_Information = SEQ(name='hSDSCH-MACdFlows-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _HSDSCH_TDD_Information_ueCapability_Info = SEQ(name='ueCapability-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-Capability-Information')))
    _HSDSCH_TDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM = INT(name='mAChs-Reordering-Buffer-Size-for-RLC-UM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAChsReorderingBufferSize-for-RLC-UM')))
    _HSDSCH_TDD_Information_tDD_AckNack_Power_Offset = INT(name='tDD-AckNack-Power-Offset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-AckNack-Power-Offset')))
    _HSDSCH_TDD_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_TDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_TDD_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TSN-Length')))
    _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_4 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-ActivationIndicator')))
    ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 709), ('criticality', 'ignore'), ('Extension', _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 794), ('criticality', 'ignore'), ('Extension', _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 865), ('criticality', 'reject'), ('Extension', _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 932), ('criticality', 'reject'), ('Extension', _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 905), ('criticality', 'reject'), ('Extension', _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_TDD_Information_iE_Extensions__item__id._const_tab = ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_TDD_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_TDD_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_TDD_Information_iE_Extensions__item__criticality._const_tab = ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_TDD_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_TDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_TDD_Information_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_TDD_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_TDD_Information_iE_Extensions__item_._ext = None
    _HSDSCH_TDD_Information_iE_Extensions._cont = __HSDSCH_TDD_Information_iE_Extensions__item_
    _HSDSCH_TDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_TDD_Information._cont = ASN1Dict([
        ('hSDSCH-MACdFlows-Information', _HSDSCH_TDD_Information_hSDSCH_MACdFlows_Information),
        ('ueCapability-Info', _HSDSCH_TDD_Information_ueCapability_Info),
        ('mAChs-Reordering-Buffer-Size-for-RLC-UM', _HSDSCH_TDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM),
        ('tDD-AckNack-Power-Offset', _HSDSCH_TDD_Information_tDD_AckNack_Power_Offset),
        ('iE-Extensions', _HSDSCH_TDD_Information_iE_Extensions),
        ])
    HSDSCH_TDD_Information._ext = []
    
    #-----< HSDSCH-TDD-Information-ExtIEs >-----#
    HSDSCH_TDD_Information_ExtIEs = CLASS(name='HSDSCH-TDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_TDD_Information_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _HSDSCH_TDD_Information_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _HSDSCH_TDD_Information_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _HSDSCH_TDD_Information_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TSN-Length')))
    _HSDSCH_TDD_Information_ExtIEs_val_Extension_4 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-ActivationIndicator')))
    HSDSCH_TDD_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 709), ('criticality', 'ignore'), ('Extension', _HSDSCH_TDD_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 794), ('criticality', 'ignore'), ('Extension', _HSDSCH_TDD_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 865), ('criticality', 'reject'), ('Extension', _HSDSCH_TDD_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 932), ('criticality', 'reject'), ('Extension', _HSDSCH_TDD_Information_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 905), ('criticality', 'reject'), ('Extension', _HSDSCH_TDD_Information_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Information-to-Modify >-----#
    HSDSCH_Information_to_Modify = SEQ(name='HSDSCH-Information-to-Modify', mode=MODE_TYPE)
    _HSDSCH_Information_to_Modify_hsDSCH_MACdFlow_Specific_Info_to_Modify = SEQ_OF(name='hsDSCH-MACdFlow-Specific-Info-to-Modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoList-to-Modify')), opt=True)
    _HSDSCH_Information_to_Modify_priorityQueueInfotoModify = SEQ_OF(name='priorityQueueInfotoModify', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-InfoList-to-Modify')), opt=True)
    _HSDSCH_Information_to_Modify_mAChs_Reordering_Buffer_Size_for_RLC_UM = INT(name='mAChs-Reordering-Buffer-Size-for-RLC-UM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAChsReorderingBufferSize-for-RLC-UM')), opt=True)
    _HSDSCH_Information_to_Modify_cqiFeedback_CycleK = ENUM(name='cqiFeedback-CycleK', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-Feedback-Cycle')), opt=True)
    _HSDSCH_Information_to_Modify_cqiRepetitionFactor = INT(name='cqiRepetitionFactor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-RepetitionFactor')), opt=True)
    _HSDSCH_Information_to_Modify_ackNackRepetitionFactor = INT(name='ackNackRepetitionFactor', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AckNack-RepetitionFactor')), opt=True)
    _HSDSCH_Information_to_Modify_cqiPowerOffset = INT(name='cqiPowerOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_ackPowerOffset = INT(name='ackPowerOffset', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Ack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_nackPowerOffset = INT(name='nackPowerOffset', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Nack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_hsscch_PowerOffset = INT(name='hsscch-PowerOffset', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HSDSCH_Information_to_Modify_measurement_Power_Offset = INT(name='measurement-Power-Offset', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Measurement-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_hSSCCHCodeChangeGrant = ENUM(name='hSSCCHCodeChangeGrant', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Code-Change-Grant')), opt=True)
    _HSDSCH_Information_to_Modify_tDDAckNackPowerOffset = INT(name='tDDAckNackPowerOffset', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-AckNack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Information_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Preamble-Mode')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Capability-Information')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-PDSCH-Code-Change-Grant')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EnhancedHSServingCC-Abort')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_9 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-SupportIndicatorExtension')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_11 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Puncturing-Handling-in-First-Rate-Matching-Stage')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_12 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_14 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Reconfiguration')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_15 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Feedback-Cycle2')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Cycle-Switch-Timer')))
    ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 650), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 709), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 825), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 794), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 844), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 906), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 865), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 947), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1036), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1085), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1090), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 1202), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 1227), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 1230), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 1238), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 1280), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 1281), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_16), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__id._const_tab = ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Information_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Information_to_Modify_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Information_to_Modify_iE_Extensions__item_._ext = None
    _HSDSCH_Information_to_Modify_iE_Extensions._cont = __HSDSCH_Information_to_Modify_iE_Extensions__item_
    _HSDSCH_Information_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Information_to_Modify._cont = ASN1Dict([
        ('hsDSCH-MACdFlow-Specific-Info-to-Modify', _HSDSCH_Information_to_Modify_hsDSCH_MACdFlow_Specific_Info_to_Modify),
        ('priorityQueueInfotoModify', _HSDSCH_Information_to_Modify_priorityQueueInfotoModify),
        ('mAChs-Reordering-Buffer-Size-for-RLC-UM', _HSDSCH_Information_to_Modify_mAChs_Reordering_Buffer_Size_for_RLC_UM),
        ('cqiFeedback-CycleK', _HSDSCH_Information_to_Modify_cqiFeedback_CycleK),
        ('cqiRepetitionFactor', _HSDSCH_Information_to_Modify_cqiRepetitionFactor),
        ('ackNackRepetitionFactor', _HSDSCH_Information_to_Modify_ackNackRepetitionFactor),
        ('cqiPowerOffset', _HSDSCH_Information_to_Modify_cqiPowerOffset),
        ('ackPowerOffset', _HSDSCH_Information_to_Modify_ackPowerOffset),
        ('nackPowerOffset', _HSDSCH_Information_to_Modify_nackPowerOffset),
        ('hsscch-PowerOffset', _HSDSCH_Information_to_Modify_hsscch_PowerOffset),
        ('measurement-Power-Offset', _HSDSCH_Information_to_Modify_measurement_Power_Offset),
        ('hSSCCHCodeChangeGrant', _HSDSCH_Information_to_Modify_hSSCCHCodeChangeGrant),
        ('tDDAckNackPowerOffset', _HSDSCH_Information_to_Modify_tDDAckNackPowerOffset),
        ('iE-Extensions', _HSDSCH_Information_to_Modify_iE_Extensions),
        ])
    HSDSCH_Information_to_Modify._ext = []
    
    #-----< HSDSCH-Information-to-Modify-ExtIEs >-----#
    HSDSCH_Information_to_Modify_ExtIEs = CLASS(name='HSDSCH-Information-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Preamble-Mode')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Capability-Information')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-PDSCH-Code-Change-Grant')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EnhancedHSServingCC-Abort')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_9 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-SupportIndicatorExtension')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_11 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Puncturing-Handling-in-First-Rate-Matching-Stage')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_12 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_14 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Reconfiguration')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_15 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Feedback-Cycle2')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Cycle-Switch-Timer')))
    HSDSCH_Information_to_Modify_ExtIEs._val = ASN1Set(rv=[dict([('id', 650), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 709), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 825), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 794), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 844), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 906), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 865), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 947), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 1036), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 1085), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 1090), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 1202), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 1227), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 1230), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_13), ('presence', 'optional')]), dict([('id', 1238), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_14), ('presence', 'optional')]), dict([('id', 1280), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_15), ('presence', 'optional')]), dict([('id', 1281), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_16), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-MACdFlow-Specific-InfoList-to-Modify >-----#
    HSDSCH_MACdFlow_Specific_InfoList_to_Modify = SEQ_OF(name='HSDSCH-MACdFlow-Specific-InfoList-to-Modify', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InfoList_to_Modify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify')))
    HSDSCH_MACdFlow_Specific_InfoList_to_Modify._cont = _HSDSCH_MACdFlow_Specific_InfoList_to_Modify__item_
    HSDSCH_MACdFlow_Specific_InfoList_to_Modify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSDSCH-MACdFlow-Specific-InfoItem-to-Modify >-----#
    HSDSCH_MACdFlow_Specific_InfoItem_to_Modify = SEQ(name='HSDSCH-MACdFlow-Specific-InfoItem-to-Modify', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_hsDSCH_MACdFlow_ID = INT(name='hsDSCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportBearerRequestIndicator = ENUM(name='transportBearerRequestIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_._ext = None
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions._cont = __HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_MACdFlow_Specific_InfoItem_to_Modify._cont = ASN1Dict([
        ('hsDSCH-MACdFlow-ID', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_hsDSCH_MACdFlow_ID),
        ('allocationRetentionPriority', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_allocationRetentionPriority),
        ('transportBearerRequestIndicator', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportBearerRequestIndicator),
        ('bindingID', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_bindingID),
        ('transportLayerAddress', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportLayerAddress),
        ('iE-Extensions', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions),
        ])
    HSDSCH_MACdFlow_Specific_InfoItem_to_Modify._ext = []
    
    #-----< HSDSCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs >-----#
    HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs = CLASS(name='HSDSCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-MACdPDUSizeFormat >-----#
    HSDSCH_MACdPDUSizeFormat = ENUM(name='HSDSCH-MACdPDUSizeFormat', mode=MODE_TYPE)
    HSDSCH_MACdPDUSizeFormat._cont = ASN1Dict([('indexedMACdPDU-Size', 0), ('flexibleMACdPDU-Size', 1)])
    HSDSCH_MACdPDUSizeFormat._ext = None
    
    #-----< HSDSCH-MACdPDU-SizeCapability >-----#
    HSDSCH_MACdPDU_SizeCapability = ENUM(name='HSDSCH-MACdPDU-SizeCapability', mode=MODE_TYPE)
    HSDSCH_MACdPDU_SizeCapability._cont = ASN1Dict([('indexedSizeCapable', 0), ('flexibleSizeCapable', 1)])
    HSDSCH_MACdPDU_SizeCapability._ext = None
    
    #-----< HSDSCH-Information-to-Modify-Unsynchronised >-----#
    HSDSCH_Information_to_Modify_Unsynchronised = SEQ(name='HSDSCH-Information-to-Modify-Unsynchronised', mode=MODE_TYPE)
    _HSDSCH_Information_to_Modify_Unsynchronised_hsDSCH_MACdFlow_Specific_Info_to_Modify = SEQ_OF(name='hsDSCH-MACdFlow-Specific-Info-to-Modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoList-to-Modify')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_priorityQueueInfotoModifyUnsynchronised = SEQ_OF(name='priorityQueueInfotoModifyUnsynchronised', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-InfoList-to-Modify-Unsynchronised')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_cqiPowerOffset = INT(name='cqiPowerOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_ackPowerOffset = INT(name='ackPowerOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Ack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_nackPowerOffset = INT(name='nackPowerOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Nack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_hsscch_PowerOffset = INT(name='hsscch-PowerOffset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_tDDAckNackPowerOffset = INT(name='tDDAckNackPowerOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-AckNack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Preamble-Mode')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Capability-Information')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EnhancedHSServingCC-Abort')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_7 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-SupportIndicatorExtension')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_9 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Puncturing-Handling-in-First-Rate-Matching-Stage')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_12 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Reconfiguration')))
    ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 650), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 709), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 825), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 794), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 906), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 947), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1036), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1085), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1090), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1202), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1227), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 1230), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 1238), ('criticality', 'reject'), ('Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab = ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item_._ext = None
    _HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions._cont = __HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item_
    _HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Information_to_Modify_Unsynchronised._cont = ASN1Dict([
        ('hsDSCH-MACdFlow-Specific-Info-to-Modify', _HSDSCH_Information_to_Modify_Unsynchronised_hsDSCH_MACdFlow_Specific_Info_to_Modify),
        ('priorityQueueInfotoModifyUnsynchronised', _HSDSCH_Information_to_Modify_Unsynchronised_priorityQueueInfotoModifyUnsynchronised),
        ('cqiPowerOffset', _HSDSCH_Information_to_Modify_Unsynchronised_cqiPowerOffset),
        ('ackPowerOffset', _HSDSCH_Information_to_Modify_Unsynchronised_ackPowerOffset),
        ('nackPowerOffset', _HSDSCH_Information_to_Modify_Unsynchronised_nackPowerOffset),
        ('hsscch-PowerOffset', _HSDSCH_Information_to_Modify_Unsynchronised_hsscch_PowerOffset),
        ('tDDAckNackPowerOffset', _HSDSCH_Information_to_Modify_Unsynchronised_tDDAckNackPowerOffset),
        ('iE-Extensions', _HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions),
        ])
    HSDSCH_Information_to_Modify_Unsynchronised._ext = []
    
    #-----< HSDSCH-Information-to-Modify-Unsynchronised-ExtIEs >-----#
    HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs = CLASS(name='HSDSCH-Information-to-Modify-Unsynchronised-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Preamble-Mode')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Capability-Information')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EnhancedHSServingCC-Abort')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_7 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-SupportIndicatorExtension')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_9 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Puncturing-Handling-in-First-Rate-Matching-Stage')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_12 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Reconfiguration')))
    HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs._val = ASN1Set(rv=[dict([('id', 650), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 709), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 825), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 794), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 906), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 947), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 1036), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 1085), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 1090), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 1202), ('criticality', 'ignore'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 1227), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 1230), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 1238), ('criticality', 'reject'), ('Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_12), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-FDD-Information-Response >-----#
    HSDSCH_FDD_Information_Response = SEQ(name='HSDSCH-FDD-Information-Response', mode=MODE_TYPE)
    _HSDSCH_FDD_Information_Response_hsDSCH_MACdFlow_Specific_InformationResp = SEQ_OF(name='hsDSCH-MACdFlow-Specific-InformationResp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-Specific-InformationResp')), opt=True)
    _HSDSCH_FDD_Information_Response_hsSCCH_Specific_Information_ResponseFDD = SEQ_OF(name='hsSCCH-Specific-Information-ResponseFDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespListFDD')), opt=True)
    _HSDSCH_FDD_Information_Response_hARQ_MemoryPartitioning = CHOICE(name='hARQ-MemoryPartitioning', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioning')), opt=True)
    _HSDSCH_FDD_Information_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_FDD_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Preamble-Mode-Activation-Indicator')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-N-M-Ratio')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-UsageIndicator')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TBSizeTableIndicator')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Precoder-Weight-Set-Restriction')))
    ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 685), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 907), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 948), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 966), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1213), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1255), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id._const_tab = ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality._const_tab = ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_FDD_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_FDD_Information_Response_iE_Extensions__item_._ext = None
    _HSDSCH_FDD_Information_Response_iE_Extensions._cont = __HSDSCH_FDD_Information_Response_iE_Extensions__item_
    _HSDSCH_FDD_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_FDD_Information_Response._cont = ASN1Dict([
        ('hsDSCH-MACdFlow-Specific-InformationResp', _HSDSCH_FDD_Information_Response_hsDSCH_MACdFlow_Specific_InformationResp),
        ('hsSCCH-Specific-Information-ResponseFDD', _HSDSCH_FDD_Information_Response_hsSCCH_Specific_Information_ResponseFDD),
        ('hARQ-MemoryPartitioning', _HSDSCH_FDD_Information_Response_hARQ_MemoryPartitioning),
        ('iE-Extensions', _HSDSCH_FDD_Information_Response_iE_Extensions),
        ])
    HSDSCH_FDD_Information_Response._ext = []
    
    #-----< HSDSCH-FDD-Information-Response-ExtIEs >-----#
    HSDSCH_FDD_Information_Response_ExtIEs = CLASS(name='HSDSCH-FDD-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Preamble-Mode-Activation-Indicator')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-N-M-Ratio')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-UsageIndicator')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TBSizeTableIndicator')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_5 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Precoder-Weight-Set-Restriction')))
    HSDSCH_FDD_Information_Response_ExtIEs._val = ASN1Set(rv=[dict([('id', 685), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 907), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 948), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 966), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1213), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1255), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information >-----#
    HS_DSCH_FDD_Secondary_Serving_Information = SEQ(name='HS-DSCH-FDD-Secondary-Serving-Information', mode=MODE_TYPE)
    _HS_DSCH_FDD_Secondary_Serving_Information_hsscch_PowerOffset = INT(name='hsscch-PowerOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_measurement_Power_Offset = INT(name='measurement-Power-Offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Measurement-Power-Offset')))
    _HS_DSCH_FDD_Secondary_Serving_Information_sixtyfourQAM_UsageAllowedIndicator = ENUM(name='sixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_hSDSCH_RNTI = INT(name='hSDSCH-RNTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-ActivationIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-ActivationIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DiversityMode')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmitDiversityIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'OrdinalNumberOfFrequency')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_5 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_6 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 905), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1088), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1139), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1140), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1181), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1226), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1229), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1239), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item_._ext = None
    _HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions._cont = __HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item_
    _HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_FDD_Secondary_Serving_Information._cont = ASN1Dict([
        ('hsscch-PowerOffset', _HS_DSCH_FDD_Secondary_Serving_Information_hsscch_PowerOffset),
        ('measurement-Power-Offset', _HS_DSCH_FDD_Secondary_Serving_Information_measurement_Power_Offset),
        ('sixtyfourQAM-UsageAllowedIndicator', _HS_DSCH_FDD_Secondary_Serving_Information_sixtyfourQAM_UsageAllowedIndicator),
        ('hSDSCH-RNTI', _HS_DSCH_FDD_Secondary_Serving_Information_hSDSCH_RNTI),
        ('iE-Extensions', _HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions),
        ])
    HS_DSCH_FDD_Secondary_Serving_Information._ext = []
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information-ExtIEs >-----#
    HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs = CLASS(name='HS-DSCH-FDD-Secondary-Serving-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-ActivationIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-ActivationIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DiversityMode')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmitDiversityIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'OrdinalNumberOfFrequency')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_5 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_6 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 905), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1088), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1139), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1140), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1181), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1226), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 1229), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 1239), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information-Response >-----#
    HS_DSCH_FDD_Secondary_Serving_Information_Response = SEQ(name='HS-DSCH-FDD-Secondary-Serving-Information-Response', mode=MODE_TYPE)
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_hsSCCH_Specific_Information_ResponseFDD = SEQ_OF(name='hsSCCH-Specific-Information-ResponseFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespListFDD')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_sixtyfourQAM_DL_UsageIndicator = ENUM(name='sixtyfourQAM-DL-UsageIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-UsageIndicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSDSCH_TBSizeTableIndicator = ENUM(name='hSDSCH-TBSizeTableIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TBSizeTableIndicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-N-M-Ratio')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Precoder-Weight-Set-Restriction')))
    ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 907), ('criticality', 'ignore'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1255), ('criticality', 'ignore'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item_._ext = None
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions._cont = __HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item_
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_FDD_Secondary_Serving_Information_Response._cont = ASN1Dict([
        ('hsSCCH-Specific-Information-ResponseFDD', _HS_DSCH_FDD_Secondary_Serving_Information_Response_hsSCCH_Specific_Information_ResponseFDD),
        ('sixtyfourQAM-DL-UsageIndicator', _HS_DSCH_FDD_Secondary_Serving_Information_Response_sixtyfourQAM_DL_UsageIndicator),
        ('hSDSCH-TBSizeTableIndicator', _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSDSCH_TBSizeTableIndicator),
        ('iE-Extensions', _HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions),
        ])
    HS_DSCH_FDD_Secondary_Serving_Information_Response._ext = []
    
    #-----< HS-DSCH-first-DRX-ycle-FACH >-----#
    HS_DSCH_first_DRX_ycle_FACH = ENUM(name='HS-DSCH-first-DRX-ycle-FACH', mode=MODE_TYPE)
    HS_DSCH_first_DRX_ycle_FACH._cont = ASN1Dict([('v2', 0), ('v4', 1), ('v8', 2), ('v16', 3), ('v32', 4), ('v64', 5)])
    HS_DSCH_first_DRX_ycle_FACH._ext = None
    
    #-----< HS-DSCH-first-Rx-burst-FACH >-----#
    HS_DSCH_first_Rx_burst_FACH = ENUM(name='HS-DSCH-first-Rx-burst-FACH', mode=MODE_TYPE)
    HS_DSCH_first_Rx_burst_FACH._cont = ASN1Dict([('v0dot4', 0), ('v0dot8', 1)])
    HS_DSCH_first_Rx_burst_FACH._ext = None
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information-Respons-ExtIEs >-----#
    HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs = CLASS(name='HS-DSCH-FDD-Secondary-Serving-Information-Respons-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-N-M-Ratio')))
    _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Precoder-Weight-Set-Restriction')))
    HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs._val = ASN1Set(rv=[dict([('id', 907), ('criticality', 'ignore'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1255), ('criticality', 'ignore'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Second-DRX-Cycle-FACH >-----#
    HS_DSCH_Second_DRX_Cycle_FACH = ENUM(name='HS-DSCH-Second-DRX-Cycle-FACH', mode=MODE_TYPE)
    HS_DSCH_Second_DRX_Cycle_FACH._cont = ASN1Dict([('v4', 0), ('v8', 1), ('v16', 2), ('v32', 3), ('v64', 4), ('v128', 5), ('v256', 6), ('v512', 7)])
    HS_DSCH_Second_DRX_Cycle_FACH._ext = None
    
    #-----< HS-DSCH-second-Rx-burst-FACH >-----#
    HS_DSCH_second_Rx_burst_FACH = ENUM(name='HS-DSCH-second-Rx-burst-FACH', mode=MODE_TYPE)
    HS_DSCH_second_Rx_burst_FACH._cont = ASN1Dict([('v1', 0), ('v2', 1)])
    HS_DSCH_second_Rx_burst_FACH._ext = None
    
    #-----< HS-DSCH-Secondary-Serving-Information-To-Modify >-----#
    HS_DSCH_Secondary_Serving_Information_To_Modify = SEQ(name='HS-DSCH-Secondary-Serving-Information-To-Modify', mode=MODE_TYPE)
    _HS_DSCH_Secondary_Serving_Information_To_Modify_hsscch_PowerOffset = INT(name='hsscch-PowerOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HS_DSCH_Secondary_Serving_Information_To_Modify_measurement_Power_Offset = INT(name='measurement-Power-Offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Measurement-Power-Offset')), opt=True)
    _HS_DSCH_Secondary_Serving_Information_To_Modify_hSSCCH_CodeChangeGrant = ENUM(name='hSSCCH-CodeChangeGrant', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Code-Change-Grant')), opt=True)
    _HS_DSCH_Secondary_Serving_Information_To_Modify_sixtyfourQAM_UsageAllowedIndicator = ENUM(name='sixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')), opt=True)
    _HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Mode-Indicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DiversityMode')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmitDiversityIndicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NonCellSpecificTxDiversity')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'OrdinalNumberOfFrequency')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-Mode-Indicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-Mode-Indicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 906), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1090), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1139), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1140), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1141), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1181), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1227), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1230), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1239), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id._const_tab = ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item_._ext = None
    _HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions._cont = __HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item_
    _HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Secondary_Serving_Information_To_Modify._cont = ASN1Dict([
        ('hsscch-PowerOffset', _HS_DSCH_Secondary_Serving_Information_To_Modify_hsscch_PowerOffset),
        ('measurement-Power-Offset', _HS_DSCH_Secondary_Serving_Information_To_Modify_measurement_Power_Offset),
        ('hSSCCH-CodeChangeGrant', _HS_DSCH_Secondary_Serving_Information_To_Modify_hSSCCH_CodeChangeGrant),
        ('sixtyfourQAM-UsageAllowedIndicator', _HS_DSCH_Secondary_Serving_Information_To_Modify_sixtyfourQAM_UsageAllowedIndicator),
        ('iE-Extensions', _HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions),
        ])
    HS_DSCH_Secondary_Serving_Information_To_Modify._ext = []
    
    #-----< HS-DSCH-Secondary-Serving-Information-To-Modify-ExtIEs >-----#
    HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs = CLASS(name='HS-DSCH-Secondary-Serving-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Mode-Indicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DiversityMode')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmitDiversityIndicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NonCellSpecificTxDiversity')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'OrdinalNumberOfFrequency')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-Mode-Indicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-Mode-Indicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[dict([('id', 906), ('criticality', 'reject'), ('Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1090), ('criticality', 'reject'), ('Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1139), ('criticality', 'reject'), ('Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1140), ('criticality', 'reject'), ('Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1141), ('criticality', 'reject'), ('Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1181), ('criticality', 'reject'), ('Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 1227), ('criticality', 'reject'), ('Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 1230), ('criticality', 'reject'), ('Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 1239), ('criticality', 'reject'), ('Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised >-----#
    HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised = SEQ(name='HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised', mode=MODE_TYPE)
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_hsscch_PowerOffset = INT(name='hsscch-PowerOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_sixtyfourQAM_UsageAllowedIndicator = ENUM(name='sixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Mode-Indicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'OrdinalNumberOfFrequency')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-Mode-Indicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-Mode-Indicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 906), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1090), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1181), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1227), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1230), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1239), ('criticality', 'reject'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item_._ext = None
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions._cont = __HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item_
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised._cont = ASN1Dict([
        ('hsscch-PowerOffset', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_hsscch_PowerOffset),
        ('sixtyfourQAM-UsageAllowedIndicator', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_sixtyfourQAM_UsageAllowedIndicator),
        ('iE-Extensions', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions),
        ])
    HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised._ext = []
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised-ExtIEs >-----#
    HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs = CLASS(name='HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Mode-Indicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'OrdinalNumberOfFrequency')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-Mode-Indicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-Mode-Indicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs._val = ASN1Set(rv=[dict([('id', 906), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1090), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1181), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1227), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1230), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1239), ('criticality', 'reject'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Update-Information >-----#
    HS_DSCH_FDD_Secondary_Serving_Update_Information = SEQ(name='HS-DSCH-FDD-Secondary-Serving-Update-Information', mode=MODE_TYPE)
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_hsSCCHCodeChangeIndicator = ENUM(name='hsSCCHCodeChangeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-CodeChangeIndicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_hS_PDSCH_Code_Change_Indicator = ENUM(name='hS-PDSCH-Code-Change-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-PDSCH-Code-Change-Indicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Precoder-Weight-Set-Restriction')))
    ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1255), ('criticality', 'ignore'), ('Extension', _____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item_._ext = None
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions._cont = __HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item_
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_FDD_Secondary_Serving_Update_Information._cont = ASN1Dict([
        ('hsSCCHCodeChangeIndicator', _HS_DSCH_FDD_Secondary_Serving_Update_Information_hsSCCHCodeChangeIndicator),
        ('hS-PDSCH-Code-Change-Indicator', _HS_DSCH_FDD_Secondary_Serving_Update_Information_hS_PDSCH_Code_Change_Indicator),
        ('iE-Extensions', _HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions),
        ])
    HS_DSCH_FDD_Secondary_Serving_Update_Information._ext = []
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Update-Information-ExtIEs >-----#
    HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs = CLASS(name='HS-DSCH-FDD-Secondary-Serving-Update-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Precoder-Weight-Set-Restriction')))
    HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 1255), ('criticality', 'ignore'), ('Extension', _HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Secondary-Serving-Cell-Change-Information-Response >-----#
    HS_DSCH_Secondary_Serving_Cell_Change_Information_Response = SEQ(name='HS-DSCH-Secondary-Serving-Cell-Change-Information-Response', mode=MODE_TYPE)
    _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_hS_DSCH_Secondary_Serving_cell_choice = CHOICE(name='hS-DSCH-Secondary-Serving-cell-choice', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Secondary-Serving-cell-change-choice')))
    _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id._const_tab = ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id_tab
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality_tab
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue_tab
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item_._ext = None
    _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions._cont = __HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item_
    _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Secondary_Serving_Cell_Change_Information_Response._cont = ASN1Dict([
        ('hS-DSCH-Secondary-Serving-cell-choice', _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_hS_DSCH_Secondary_Serving_cell_choice),
        ('iE-Extensions', _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions),
        ])
    HS_DSCH_Secondary_Serving_Cell_Change_Information_Response._ext = []
    
    #-----< HS-DSCH-Secondary-Serving-Cell-Change-Information-Response-ExtIEs >-----#
    HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_ExtIEs = CLASS(name='HS-DSCH-Secondary-Serving-Cell-Change-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Secondary-Serving-cell-change-choice >-----#
    HS_DSCH_Secondary_Serving_cell_change_choice = CHOICE(name='HS-DSCH-Secondary-Serving-cell-change-choice', mode=MODE_TYPE)
    _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_successful = SEQ(name='hS-Secondary-Serving-cell-change-successful', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-Secondary-Serving-cell-change-successful')))
    _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_unsuccessful = SEQ(name='hS-Secondary-Serving-cell-change-unsuccessful', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-Secondary-Serving-cell-change-unsuccessful')))
    HS_DSCH_Secondary_Serving_cell_change_choice._cont = ASN1Dict([
        ('hS-Secondary-Serving-cell-change-successful', _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_successful),
        ('hS-Secondary-Serving-cell-change-unsuccessful', _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_unsuccessful),
        ])
    HS_DSCH_Secondary_Serving_cell_change_choice._ext = []
    
    #-----< HS-Secondary-Serving-cell-change-successful >-----#
    HS_Secondary_Serving_cell_change_successful = SEQ(name='HS-Secondary-Serving-cell-change-successful', mode=MODE_TYPE)
    _HS_Secondary_Serving_cell_change_successful_hS_DSCH_FDD_Secondary_Serving_Information_Response = SEQ(name='hS-DSCH-FDD-Secondary-Serving-Information-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information-Response')))
    _HS_Secondary_Serving_cell_change_successful_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_Secondary_Serving_cell_change_successful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id._const_tab = ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id_tab
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id._const_tab_at = None
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality._const_tab = ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality_tab
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab = ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue_tab
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_Secondary_Serving_cell_change_successful_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id),
        ('criticality', ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue),
        ])
    __HS_Secondary_Serving_cell_change_successful_iE_Extensions__item_._ext = None
    _HS_Secondary_Serving_cell_change_successful_iE_Extensions._cont = __HS_Secondary_Serving_cell_change_successful_iE_Extensions__item_
    _HS_Secondary_Serving_cell_change_successful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_Secondary_Serving_cell_change_successful._cont = ASN1Dict([
        ('hS-DSCH-FDD-Secondary-Serving-Information-Response', _HS_Secondary_Serving_cell_change_successful_hS_DSCH_FDD_Secondary_Serving_Information_Response),
        ('iE-Extensions', _HS_Secondary_Serving_cell_change_successful_iE_Extensions),
        ])
    HS_Secondary_Serving_cell_change_successful._ext = []
    
    #-----< HS-Secondary-Serving-cell-change-successful-ExtIEs >-----#
    HS_Secondary_Serving_cell_change_successful_ExtIEs = CLASS(name='HS-Secondary-Serving-cell-change-successful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_Secondary_Serving_cell_change_successful_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-Secondary-Serving-cell-change-unsuccessful >-----#
    HS_Secondary_Serving_cell_change_unsuccessful = SEQ(name='HS-Secondary-Serving-cell-change-unsuccessful', mode=MODE_TYPE)
    _HS_Secondary_Serving_cell_change_unsuccessful_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab = ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id_tab
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_at = None
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab = ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab = ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id),
        ('criticality', ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue),
        ])
    __HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item_._ext = None
    _HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions._cont = __HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item_
    _HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_Secondary_Serving_cell_change_unsuccessful._cont = ASN1Dict([
        ('cause', _HS_Secondary_Serving_cell_change_unsuccessful_cause),
        ('iE-Extensions', _HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions),
        ])
    HS_Secondary_Serving_cell_change_unsuccessful._ext = []
    
    #-----< HS-Secondary-Serving-cell-change-unsuccessful-ExtIEs >-----#
    HS_Secondary_Serving_cell_change_unsuccessful_ExtIEs = CLASS(name='HS-Secondary-Serving-cell-change-unsuccessful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_Secondary_Serving_cell_change_unsuccessful_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Secondary-Serving-Remove >-----#
    HS_DSCH_Secondary_Serving_Remove = NULL(name='HS-DSCH-Secondary-Serving-Remove', mode=MODE_TYPE)
    
    #-----< HSDSCH-Paging-System-InformationFDD >-----#
    HSDSCH_Paging_System_InformationFDD = SEQ(name='HSDSCH-Paging-System-InformationFDD', mode=MODE_TYPE)
    _HSDSCH_Paging_System_InformationFDD_paging_MACFlow_Specific_Information = SEQ_OF(name='paging-MACFlow-Specific-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlow-Specific-Information')))
    _HSDSCH_Paging_System_InformationFDD_hSSCCH_Power = INT(name='hSSCCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _HSDSCH_Paging_System_InformationFDD_hSPDSCH_Power = INT(name='hSPDSCH-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _HSDSCH_Paging_System_InformationFDD_number_of_PCCH_transmission = INT(name='number-of-PCCH-transmission', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Number-of-PCCH-transmission')))
    _HSDSCH_Paging_System_InformationFDD_transport_Block_Size_List = SEQ_OF(name='transport-Block-Size-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transport-Block-Size-List')))
    _HSDSCH_Paging_System_InformationFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Paging_System_InformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__id._const_tab = ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__id_tab
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__criticality_tab
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Paging_System_InformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Paging_System_InformationFDD_iE_Extensions__item_._ext = None
    _HSDSCH_Paging_System_InformationFDD_iE_Extensions._cont = __HSDSCH_Paging_System_InformationFDD_iE_Extensions__item_
    _HSDSCH_Paging_System_InformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Paging_System_InformationFDD._cont = ASN1Dict([
        ('paging-MACFlow-Specific-Information', _HSDSCH_Paging_System_InformationFDD_paging_MACFlow_Specific_Information),
        ('hSSCCH-Power', _HSDSCH_Paging_System_InformationFDD_hSSCCH_Power),
        ('hSPDSCH-Power', _HSDSCH_Paging_System_InformationFDD_hSPDSCH_Power),
        ('number-of-PCCH-transmission', _HSDSCH_Paging_System_InformationFDD_number_of_PCCH_transmission),
        ('transport-Block-Size-List', _HSDSCH_Paging_System_InformationFDD_transport_Block_Size_List),
        ('iE-Extensions', _HSDSCH_Paging_System_InformationFDD_iE_Extensions),
        ])
    HSDSCH_Paging_System_InformationFDD._ext = []
    
    #-----< HSDSCH-Paging-System-InformationFDD-ExtIEs >-----#
    HSDSCH_Paging_System_InformationFDD_ExtIEs = CLASS(name='HSDSCH-Paging-System-InformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_Paging_System_InformationFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Paging-System-Information-ResponseFDD >-----#
    HSDSCH_Paging_System_Information_ResponseFDD = SEQ_OF(name='HSDSCH-Paging-System-Information-ResponseFDD', mode=MODE_TYPE)
    _HSDSCH_Paging_System_Information_ResponseFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Paging-System-Information-ResponseList')))
    HSDSCH_Paging_System_Information_ResponseFDD._cont = _HSDSCH_Paging_System_Information_ResponseFDD__item_
    HSDSCH_Paging_System_Information_ResponseFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HSDSCH-Paging-System-Information-ResponseList >-----#
    HSDSCH_Paging_System_Information_ResponseList = SEQ(name='HSDSCH-Paging-System-Information-ResponseList', mode=MODE_TYPE)
    _HSDSCH_Paging_System_Information_ResponseList_pagingMACFlow_ID = INT(name='pagingMACFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlow-ID')))
    _HSDSCH_Paging_System_Information_ResponseList_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _HSDSCH_Paging_System_Information_ResponseList_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _HSDSCH_Paging_System_Information_ResponseList_hSPDSCH_Code_Index = INT(name='hSPDSCH-Code-Index', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSPDSCH-Code-Index')))
    _HSDSCH_Paging_System_Information_ResponseList_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__id._const_tab = ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__id_tab
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__criticality_tab
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item_._ext = None
    _HSDSCH_Paging_System_Information_ResponseList_iE_Extensions._cont = __HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item_
    _HSDSCH_Paging_System_Information_ResponseList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Paging_System_Information_ResponseList._cont = ASN1Dict([
        ('pagingMACFlow-ID', _HSDSCH_Paging_System_Information_ResponseList_pagingMACFlow_ID),
        ('bindingID', _HSDSCH_Paging_System_Information_ResponseList_bindingID),
        ('transportLayerAddress', _HSDSCH_Paging_System_Information_ResponseList_transportLayerAddress),
        ('hSPDSCH-Code-Index', _HSDSCH_Paging_System_Information_ResponseList_hSPDSCH_Code_Index),
        ('iE-Extensions', _HSDSCH_Paging_System_Information_ResponseList_iE_Extensions),
        ])
    HSDSCH_Paging_System_Information_ResponseList._ext = []
    
    #-----< HSDSCH-Paging-System-Information-ResponseList-ExtIEs >-----#
    HSDSCH_Paging_System_Information_ResponseList_ExtIEs = CLASS(name='HSDSCH-Paging-System-Information-ResponseList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_Paging_System_Information_ResponseList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-TDD-Information-Response >-----#
    HSDSCH_TDD_Information_Response = SEQ(name='HSDSCH-TDD-Information-Response', mode=MODE_TYPE)
    _HSDSCH_TDD_Information_Response_hsDSCH_MACdFlow_Specific_InformationResp = SEQ_OF(name='hsDSCH-MACdFlow-Specific-InformationResp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-Specific-InformationResp')), opt=True)
    _HSDSCH_TDD_Information_Response_hsSCCH_Specific_Information_ResponseTDD = SEQ_OF(name='hsSCCH-Specific-Information-ResponseTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespListTDD')), opt=True)
    _HSDSCH_TDD_Information_Response_hsSCCH_Specific_Information_ResponseTDDLCR = SEQ_OF(name='hsSCCH-Specific-Information-ResponseTDDLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespListTDDLCR')), opt=True)
    _HSDSCH_TDD_Information_Response_hARQ_MemoryPartitioning = CHOICE(name='hARQ-MemoryPartitioning', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioning')), opt=True)
    _HSDSCH_TDD_Information_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_TDD_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespListTDD768')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multicarrier-Number')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-SFMode-For-HSPDSCHDualStream')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-ReferenceSignal-InformationListLCR')))
    ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 771), ('criticality', 'ignore'), ('Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 927), ('criticality', 'ignore'), ('Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 934), ('criticality', 'ignore'), ('Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1072), ('criticality', 'reject'), ('Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1071), ('criticality', 'reject'), ('Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id._const_tab = ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality._const_tab = ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_TDD_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_TDD_Information_Response_iE_Extensions__item_._ext = None
    _HSDSCH_TDD_Information_Response_iE_Extensions._cont = __HSDSCH_TDD_Information_Response_iE_Extensions__item_
    _HSDSCH_TDD_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_TDD_Information_Response._cont = ASN1Dict([
        ('hsDSCH-MACdFlow-Specific-InformationResp', _HSDSCH_TDD_Information_Response_hsDSCH_MACdFlow_Specific_InformationResp),
        ('hsSCCH-Specific-Information-ResponseTDD', _HSDSCH_TDD_Information_Response_hsSCCH_Specific_Information_ResponseTDD),
        ('hsSCCH-Specific-Information-ResponseTDDLCR', _HSDSCH_TDD_Information_Response_hsSCCH_Specific_Information_ResponseTDDLCR),
        ('hARQ-MemoryPartitioning', _HSDSCH_TDD_Information_Response_hARQ_MemoryPartitioning),
        ('iE-Extensions', _HSDSCH_TDD_Information_Response_iE_Extensions),
        ])
    HSDSCH_TDD_Information_Response._ext = []
    
    #-----< HSDSCH-TDD-Information-Response-ExtIEs >-----#
    HSDSCH_TDD_Information_Response_ExtIEs = CLASS(name='HSDSCH-TDD-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespListTDD768')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multicarrier-Number')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-SFMode-For-HSPDSCHDualStream')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-ReferenceSignal-InformationListLCR')))
    HSDSCH_TDD_Information_Response_ExtIEs._val = ASN1Set(rv=[dict([('id', 771), ('criticality', 'ignore'), ('Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 927), ('criticality', 'ignore'), ('Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 934), ('criticality', 'ignore'), ('Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1072), ('criticality', 'reject'), ('Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1071), ('criticality', 'reject'), ('Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-MACdFlow-Specific-InformationResp >-----#
    HSDSCH_MACdFlow_Specific_InformationResp = SEQ_OF(name='HSDSCH-MACdFlow-Specific-InformationResp', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InformationResp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-Specific-InformationResp-Item')))
    HSDSCH_MACdFlow_Specific_InformationResp._cont = _HSDSCH_MACdFlow_Specific_InformationResp__item_
    HSDSCH_MACdFlow_Specific_InformationResp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSDSCH-MACdFlow-Specific-InformationResp-Item >-----#
    HSDSCH_MACdFlow_Specific_InformationResp_Item = SEQ(name='HSDSCH-MACdFlow-Specific-InformationResp-Item', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InformationResp_Item_hsDSCHMacdFlow_Id = INT(name='hsDSCHMacdFlow-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _HSDSCH_MACdFlow_Specific_InformationResp_Item_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _HSDSCH_MACdFlow_Specific_InformationResp_Item_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _HSDSCH_MACdFlow_Specific_InformationResp_Item_hSDSCH_Initial_Capacity_Allocation = SEQ_OF(name='hSDSCH-Initial-Capacity-Allocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Initial-Capacity-Allocation')), opt=True)
    _HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab = ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab = ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_._ext = None
    _HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions._cont = __HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_
    _HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_MACdFlow_Specific_InformationResp_Item._cont = ASN1Dict([
        ('hsDSCHMacdFlow-Id', _HSDSCH_MACdFlow_Specific_InformationResp_Item_hsDSCHMacdFlow_Id),
        ('bindingID', _HSDSCH_MACdFlow_Specific_InformationResp_Item_bindingID),
        ('transportLayerAddress', _HSDSCH_MACdFlow_Specific_InformationResp_Item_transportLayerAddress),
        ('hSDSCH-Initial-Capacity-Allocation', _HSDSCH_MACdFlow_Specific_InformationResp_Item_hSDSCH_Initial_Capacity_Allocation),
        ('iE-Extensions', _HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions),
        ])
    HSDSCH_MACdFlow_Specific_InformationResp_Item._ext = []
    
    #-----< HSDSCH-MACdFlow-Specific-InformationRespItem-ExtIEs >-----#
    HSDSCH_MACdFlow_Specific_InformationRespItem_ExtIEs = CLASS(name='HSDSCH-MACdFlow-Specific-InformationRespItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_MACdFlow_Specific_InformationRespItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-MACdFlows-Information >-----#
    HSDSCH_MACdFlows_Information = SEQ(name='HSDSCH-MACdFlows-Information', mode=MODE_TYPE)
    _HSDSCH_MACdFlows_Information_hSDSCH_MACdFlow_Specific_Info = SEQ_OF(name='hSDSCH-MACdFlow-Specific-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoList')))
    _HSDSCH_MACdFlows_Information_priorityQueue_Info = SEQ_OF(name='priorityQueue-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-InfoList')))
    _HSDSCH_MACdFlows_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_MACdFlows_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id._const_tab = ____HSDSCH_MACdFlows_Information_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab = ____HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality_tab
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_MACdFlows_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_MACdFlows_Information_iE_Extensions__item_._ext = None
    _HSDSCH_MACdFlows_Information_iE_Extensions._cont = __HSDSCH_MACdFlows_Information_iE_Extensions__item_
    _HSDSCH_MACdFlows_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_MACdFlows_Information._cont = ASN1Dict([
        ('hSDSCH-MACdFlow-Specific-Info', _HSDSCH_MACdFlows_Information_hSDSCH_MACdFlow_Specific_Info),
        ('priorityQueue-Info', _HSDSCH_MACdFlows_Information_priorityQueue_Info),
        ('iE-Extensions', _HSDSCH_MACdFlows_Information_iE_Extensions),
        ])
    HSDSCH_MACdFlows_Information._ext = []
    
    #-----< HSDSCH-MACdFlows-Information-ExtIEs >-----#
    HSDSCH_MACdFlows_Information_ExtIEs = CLASS(name='HSDSCH-MACdFlows-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_MACdFlows_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-MACdFlow-Specific-InfoList >-----#
    HSDSCH_MACdFlow_Specific_InfoList = SEQ_OF(name='HSDSCH-MACdFlow-Specific-InfoList', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoItem')))
    HSDSCH_MACdFlow_Specific_InfoList._cont = _HSDSCH_MACdFlow_Specific_InfoList__item_
    HSDSCH_MACdFlow_Specific_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSDSCH-MACdFlow-Specific-InfoItem >-----#
    HSDSCH_MACdFlow_Specific_InfoItem = SEQ(name='HSDSCH-MACdFlow-Specific-InfoItem', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InfoItem_hsDSCH_MACdFlow_ID = INT(name='hsDSCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _HSDSCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')))
    _HSDSCH_MACdFlow_Specific_InfoItem_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_._ext = None
    _HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions._cont = __HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_
    _HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_MACdFlow_Specific_InfoItem._cont = ASN1Dict([
        ('hsDSCH-MACdFlow-ID', _HSDSCH_MACdFlow_Specific_InfoItem_hsDSCH_MACdFlow_ID),
        ('allocationRetentionPriority', _HSDSCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority),
        ('bindingID', _HSDSCH_MACdFlow_Specific_InfoItem_bindingID),
        ('transportLayerAddress', _HSDSCH_MACdFlow_Specific_InfoItem_transportLayerAddress),
        ('iE-Extensions', _HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions),
        ])
    HSDSCH_MACdFlow_Specific_InfoItem._ext = []
    
    #-----< HSDSCH-MACdFlow-Specific-InfoItem-ExtIEs >-----#
    HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs = CLASS(name='HSDSCH-MACdFlow-Specific-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-MACdFlows-to-Delete >-----#
    HSDSCH_MACdFlows_to_Delete = SEQ_OF(name='HSDSCH-MACdFlows-to-Delete', mode=MODE_TYPE)
    _HSDSCH_MACdFlows_to_Delete__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-to-Delete-Item')))
    HSDSCH_MACdFlows_to_Delete._cont = _HSDSCH_MACdFlows_to_Delete__item_
    HSDSCH_MACdFlows_to_Delete._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSDSCH-MACdFlows-to-Delete-Item >-----#
    HSDSCH_MACdFlows_to_Delete_Item = SEQ(name='HSDSCH-MACdFlows-to-Delete-Item', mode=MODE_TYPE)
    _HSDSCH_MACdFlows_to_Delete_Item_hsDSCH_MACdFlow_ID = INT(name='hsDSCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id._const_tab = ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality._const_tab = ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality_tab
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item_._ext = None
    _HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions._cont = __HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item_
    _HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_MACdFlows_to_Delete_Item._cont = ASN1Dict([
        ('hsDSCH-MACdFlow-ID', _HSDSCH_MACdFlows_to_Delete_Item_hsDSCH_MACdFlow_ID),
        ('iE-Extensions', _HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions),
        ])
    HSDSCH_MACdFlows_to_Delete_Item._ext = []
    
    #-----< HSDSCH-MACdFlows-to-Delete-Item-ExtIEs >-----#
    HSDSCH_MACdFlows_to_Delete_Item_ExtIEs = CLASS(name='HSDSCH-MACdFlows-to-Delete-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_MACdFlows_to_Delete_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-TBSizeTableIndicator >-----#
    HSDSCH_TBSizeTableIndicator = ENUM(name='HSDSCH-TBSizeTableIndicator', mode=MODE_TYPE)
    HSDSCH_TBSizeTableIndicator._cont = ASN1Dict([('octet-aligned', 0)])
    HSDSCH_TBSizeTableIndicator._ext = None
    
    #-----< HSSCCH-PowerOffset >-----#
    HSSCCH_PowerOffset = INT(name='HSSCCH-PowerOffset', mode=MODE_TYPE)
    HSSCCH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< HSDSCH-Initial-Capacity-Allocation >-----#
    HSDSCH_Initial_Capacity_Allocation = SEQ_OF(name='HSDSCH-Initial-Capacity-Allocation', mode=MODE_TYPE)
    _HSDSCH_Initial_Capacity_Allocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Initial-Capacity-AllocationItem')))
    HSDSCH_Initial_Capacity_Allocation._cont = _HSDSCH_Initial_Capacity_Allocation__item_
    HSDSCH_Initial_Capacity_Allocation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSDSCH-Initial-Capacity-AllocationItem >-----#
    HSDSCH_Initial_Capacity_AllocationItem = SEQ(name='HSDSCH-Initial-Capacity-AllocationItem', mode=MODE_TYPE)
    _HSDSCH_Initial_Capacity_AllocationItem_schedulingPriorityIndicator = INT(name='schedulingPriorityIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')))
    _HSDSCH_Initial_Capacity_AllocationItem_maximum_MACdPDU_Size = INT(name='maximum-MACdPDU-Size', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MACdPDU-Size')))
    _HSDSCH_Initial_Capacity_AllocationItem_hSDSCH_InitialWindowSize = INT(name='hSDSCH-InitialWindowSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-InitialWindowSize')))
    _HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id._const_tab = ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item_._ext = None
    _HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions._cont = __HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item_
    _HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Initial_Capacity_AllocationItem._cont = ASN1Dict([
        ('schedulingPriorityIndicator', _HSDSCH_Initial_Capacity_AllocationItem_schedulingPriorityIndicator),
        ('maximum-MACdPDU-Size', _HSDSCH_Initial_Capacity_AllocationItem_maximum_MACdPDU_Size),
        ('hSDSCH-InitialWindowSize', _HSDSCH_Initial_Capacity_AllocationItem_hSDSCH_InitialWindowSize),
        ('iE-Extensions', _HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions),
        ])
    HSDSCH_Initial_Capacity_AllocationItem._ext = []
    
    #-----< HSDSCH-Initial-Capacity-AllocationItem-ExtIEs >-----#
    HSDSCH_Initial_Capacity_AllocationItem_ExtIEs = CLASS(name='HSDSCH-Initial-Capacity-AllocationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_Initial_Capacity_AllocationItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    HSDSCH_Initial_Capacity_AllocationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'ignore'), ('Extension', _HSDSCH_Initial_Capacity_AllocationItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-InitialWindowSize >-----#
    HSDSCH_InitialWindowSize = INT(name='HSDSCH-InitialWindowSize', mode=MODE_TYPE)
    HSDSCH_InitialWindowSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< HSDSCH-PreconfigurationInfo >-----#
    HSDSCH_PreconfigurationInfo = SEQ(name='HSDSCH-PreconfigurationInfo', mode=MODE_TYPE)
    _HSDSCH_PreconfigurationInfo_setsOfHS_SCCH_Codes = SEQ_OF(name='setsOfHS-SCCH-Codes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SetsOfHS-SCCH-Codes')))
    _HSDSCH_PreconfigurationInfo_hARQ_MemoryPartitioning = CHOICE(name='hARQ-MemoryPartitioning', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioning')))
    _HSDSCH_PreconfigurationInfo_e_DCH_FDD_DL_Control_Channel_Information = SEQ(name='e-DCH-FDD-DL-Control-Channel-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')), opt=True)
    _HSDSCH_PreconfigurationInfo_hARQ_Preamble_Mode_Activation_Indicator = ENUM(name='hARQ-Preamble-Mode-Activation-Indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Preamble-Mode-Activation-Indicator')), opt=True)
    _HSDSCH_PreconfigurationInfo_mIMO_N_M_Ratio = ENUM(name='mIMO-N-M-Ratio', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MIMO-N-M-Ratio')), opt=True)
    _HSDSCH_PreconfigurationInfo_continuousPacketConnectivityHS_SCCH_less_Information_Response = SEQ(name='continuousPacketConnectivityHS-SCCH-less-Information-Response', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information-Response')), opt=True)
    _HSDSCH_PreconfigurationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_PreconfigurationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Preconfiguration-Information')))
    _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order')))
    ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1128), ('criticality', 'ignore'), ('Extension', _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1213), ('criticality', 'ignore'), ('Extension', _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id._const_tab = ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality._const_tab = ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_PreconfigurationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_PreconfigurationInfo_iE_Extensions__item_._ext = None
    _HSDSCH_PreconfigurationInfo_iE_Extensions._cont = __HSDSCH_PreconfigurationInfo_iE_Extensions__item_
    _HSDSCH_PreconfigurationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_PreconfigurationInfo._cont = ASN1Dict([
        ('setsOfHS-SCCH-Codes', _HSDSCH_PreconfigurationInfo_setsOfHS_SCCH_Codes),
        ('hARQ-MemoryPartitioning', _HSDSCH_PreconfigurationInfo_hARQ_MemoryPartitioning),
        ('e-DCH-FDD-DL-Control-Channel-Information', _HSDSCH_PreconfigurationInfo_e_DCH_FDD_DL_Control_Channel_Information),
        ('hARQ-Preamble-Mode-Activation-Indicator', _HSDSCH_PreconfigurationInfo_hARQ_Preamble_Mode_Activation_Indicator),
        ('mIMO-N-M-Ratio', _HSDSCH_PreconfigurationInfo_mIMO_N_M_Ratio),
        ('continuousPacketConnectivityHS-SCCH-less-Information-Response', _HSDSCH_PreconfigurationInfo_continuousPacketConnectivityHS_SCCH_less_Information_Response),
        ('iE-Extensions', _HSDSCH_PreconfigurationInfo_iE_Extensions),
        ])
    HSDSCH_PreconfigurationInfo._ext = []
    
    #-----< HSDSCH-PreconfigurationInfo-ExtIEs >-----#
    HSDSCH_PreconfigurationInfo_ExtIEs = CLASS(name='HSDSCH-PreconfigurationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Preconfiguration-Information')))
    _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order')))
    HSDSCH_PreconfigurationInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 1128), ('criticality', 'ignore'), ('Extension', _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1213), ('criticality', 'ignore'), ('Extension', _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Preconfiguration-Information >-----#
    Additional_EDCH_Preconfiguration_Information = SEQ_OF(name='Additional-EDCH-Preconfiguration-Information', mode=MODE_TYPE)
    _Additional_EDCH_Preconfiguration_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Preconfiguration-Information-ItemIEs')))
    Additional_EDCH_Preconfiguration_Information._cont = _Additional_EDCH_Preconfiguration_Information__item_
    Additional_EDCH_Preconfiguration_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Preconfiguration-Information-ItemIEs >-----#
    Additional_EDCH_Preconfiguration_Information_ItemIEs = SEQ(name='Additional-EDCH-Preconfiguration-Information-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_Preconfiguration_Information_ItemIEs_e_DCH_FDD_DL_Control_Channel_Information = SEQ(name='e-DCH-FDD-DL-Control-Channel-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions._cont = __Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Preconfiguration_Information_ItemIEs._cont = ASN1Dict([
        ('e-DCH-FDD-DL-Control-Channel-Information', _Additional_EDCH_Preconfiguration_Information_ItemIEs_e_DCH_FDD_DL_Control_Channel_Information),
        ('iE-Extensions', _Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_Preconfiguration_Information_ItemIEs._ext = []
    
    #-----< Additional-EDCH-Preconfiguration-Information-ItemIEs-ExtIEs >-----#
    Additional_EDCH_Preconfiguration_Information_ItemIEs_ExtIEs = CLASS(name='Additional-EDCH-Preconfiguration-Information-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Preconfiguration_Information_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-PreconfigurationSetup >-----#
    HSDSCH_PreconfigurationSetup = SEQ(name='HSDSCH-PreconfigurationSetup', mode=MODE_TYPE)
    _HSDSCH_PreconfigurationSetup_mAChsResetScheme = ENUM(name='mAChsResetScheme', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAChsResetScheme')))
    _HSDSCH_PreconfigurationSetup_hSDSCH_Physical_Layer_Category = INT(name='hSDSCH-Physical-Layer-Category', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HSDSCH_PreconfigurationSetup_hSDSCH_Physical_Layer_Category._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=[], er=[])
    _HSDSCH_PreconfigurationSetup_mAChs_Reordering_Buffer_Size_for_RLC_UM = INT(name='mAChs-Reordering-Buffer-Size-for-RLC-UM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAChsReorderingBufferSize-for-RLC-UM')))
    _HSDSCH_PreconfigurationSetup_secondaryServingCells = SEQ_OF(name='secondaryServingCells', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SecondaryServingCells')), opt=True)
    _HSDSCH_PreconfigurationSetup_numPrimaryHS_SCCH_Codes = INT(name='numPrimaryHS-SCCH-Codes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'NumHS-SCCH-Codes')), opt=True)
    _HSDSCH_PreconfigurationSetup_hARQ_Preamble_Mode = ENUM(name='hARQ-Preamble-Mode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Preamble-Mode')), opt=True)
    _HSDSCH_PreconfigurationSetup_mIMO_ActivationIndicator = NULL(name='mIMO-ActivationIndicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MIMO-ActivationIndicator')), opt=True)
    _HSDSCH_PreconfigurationSetup_hSDSCH_MACdPDUSizeFormat = ENUM(name='hSDSCH-MACdPDUSizeFormat', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDUSizeFormat')), opt=True)
    _HSDSCH_PreconfigurationSetup_sixtyfourQAM_UsageAllowedIndicator = ENUM(name='sixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')), opt=True)
    _HSDSCH_PreconfigurationSetup_uE_with_enhanced_HS_SCCH_support_indicator = NULL(name='uE-with-enhanced-HS-SCCH-support-indicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _HSDSCH_PreconfigurationSetup_continuousPacketConnectivityHS_SCCH_less_Information = SEQ_OF(name='continuousPacketConnectivityHS-SCCH-less-Information', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information')), opt=True)
    _HSDSCH_PreconfigurationSetup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_PreconfigurationSetup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-SupportIndicatorExtension')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_2 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Information')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-MIMO-Information')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1085), ('criticality', 'ignore'), ('Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1226), ('criticality', 'ignore'), ('Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1229), ('criticality', 'ignore'), ('Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1237), ('criticality', 'ignore'), ('Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1215), ('criticality', 'ignore'), ('Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1208), ('criticality', 'ignore'), ('Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1231), ('criticality', 'ignore'), ('Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 946), ('criticality', 'ignore'), ('Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1234), ('criticality', 'ignore'), ('Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id._const_tab = ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality._const_tab = ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_PreconfigurationSetup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_PreconfigurationSetup_iE_Extensions__item_._ext = None
    _HSDSCH_PreconfigurationSetup_iE_Extensions._cont = __HSDSCH_PreconfigurationSetup_iE_Extensions__item_
    _HSDSCH_PreconfigurationSetup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_PreconfigurationSetup._cont = ASN1Dict([
        ('mAChsResetScheme', _HSDSCH_PreconfigurationSetup_mAChsResetScheme),
        ('hSDSCH-Physical-Layer-Category', _HSDSCH_PreconfigurationSetup_hSDSCH_Physical_Layer_Category),
        ('mAChs-Reordering-Buffer-Size-for-RLC-UM', _HSDSCH_PreconfigurationSetup_mAChs_Reordering_Buffer_Size_for_RLC_UM),
        ('secondaryServingCells', _HSDSCH_PreconfigurationSetup_secondaryServingCells),
        ('numPrimaryHS-SCCH-Codes', _HSDSCH_PreconfigurationSetup_numPrimaryHS_SCCH_Codes),
        ('hARQ-Preamble-Mode', _HSDSCH_PreconfigurationSetup_hARQ_Preamble_Mode),
        ('mIMO-ActivationIndicator', _HSDSCH_PreconfigurationSetup_mIMO_ActivationIndicator),
        ('hSDSCH-MACdPDUSizeFormat', _HSDSCH_PreconfigurationSetup_hSDSCH_MACdPDUSizeFormat),
        ('sixtyfourQAM-UsageAllowedIndicator', _HSDSCH_PreconfigurationSetup_sixtyfourQAM_UsageAllowedIndicator),
        ('uE-with-enhanced-HS-SCCH-support-indicator', _HSDSCH_PreconfigurationSetup_uE_with_enhanced_HS_SCCH_support_indicator),
        ('continuousPacketConnectivityHS-SCCH-less-Information', _HSDSCH_PreconfigurationSetup_continuousPacketConnectivityHS_SCCH_less_Information),
        ('iE-Extensions', _HSDSCH_PreconfigurationSetup_iE_Extensions),
        ])
    HSDSCH_PreconfigurationSetup._ext = []
    
    #-----< HSDSCHPreconfigurationSetup-ExtIEs >-----#
    HSDSCHPreconfigurationSetup_ExtIEs = CLASS(name='HSDSCHPreconfigurationSetup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-SupportIndicatorExtension')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_2 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Information')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-MIMO-Information')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    HSDSCHPreconfigurationSetup_ExtIEs._val = ASN1Set(rv=[dict([('id', 1085), ('criticality', 'ignore'), ('Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1226), ('criticality', 'ignore'), ('Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1229), ('criticality', 'ignore'), ('Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1237), ('criticality', 'ignore'), ('Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1215), ('criticality', 'ignore'), ('Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1208), ('criticality', 'ignore'), ('Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 1231), ('criticality', 'ignore'), ('Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 946), ('criticality', 'ignore'), ('Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 1234), ('criticality', 'ignore'), ('Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-PreconfiguredCodes >-----#
    HS_SCCH_PreconfiguredCodes = SEQ_OF(name='HS-SCCH-PreconfiguredCodes', mode=MODE_TYPE)
    _HS_SCCH_PreconfiguredCodes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-PreconfiguredCodesItem')))
    HS_SCCH_PreconfiguredCodes._cont = _HS_SCCH_PreconfiguredCodes__item_
    HS_SCCH_PreconfiguredCodes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HS-SCCH-PreconfiguredCodesItem >-----#
    HS_SCCH_PreconfiguredCodesItem = SEQ(name='HS-SCCH-PreconfiguredCodesItem', mode=MODE_TYPE)
    _HS_SCCH_PreconfiguredCodesItem_hS_SCCH_CodeNumber = INT(name='hS-SCCH-CodeNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-CodeNumber')))
    _HS_SCCH_PreconfiguredCodesItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id._const_tab = ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id_tab
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality_tab
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue_tab
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id),
        ('criticality', ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item_._ext = None
    _HS_SCCH_PreconfiguredCodesItem_iE_Extensions._cont = __HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item_
    _HS_SCCH_PreconfiguredCodesItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_PreconfiguredCodesItem._cont = ASN1Dict([
        ('hS-SCCH-CodeNumber', _HS_SCCH_PreconfiguredCodesItem_hS_SCCH_CodeNumber),
        ('iE-Extensions', _HS_SCCH_PreconfiguredCodesItem_iE_Extensions),
        ])
    HS_SCCH_PreconfiguredCodesItem._ext = []
    
    #-----< HS-SCCH-PreconfiguredCodesItem-ExtIEs >-----#
    HS_SCCH_PreconfiguredCodesItem_ExtIEs = CLASS(name='HS-SCCH-PreconfiguredCodesItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_SCCH_PreconfiguredCodesItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-CodeNumber >-----#
    HS_SCCH_CodeNumber = INT(name='HS-SCCH-CodeNumber', mode=MODE_TYPE)
    HS_SCCH_CodeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< HSSCCH-Specific-InformationRespListFDD >-----#
    HSSCCH_Specific_InformationRespListFDD = SEQ_OF(name='HSSCCH-Specific-InformationRespListFDD', mode=MODE_TYPE)
    _HSSCCH_Specific_InformationRespListFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Codes')))
    HSSCCH_Specific_InformationRespListFDD._cont = _HSSCCH_Specific_InformationRespListFDD__item_
    HSSCCH_Specific_InformationRespListFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HSSCCH-Codes >-----#
    HSSCCH_Codes = SEQ(name='HSSCCH-Codes', mode=MODE_TYPE)
    _HSSCCH_Codes_codeNumber = INT(name='codeNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HSSCCH_Codes_codeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _HSSCCH_Codes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSCCH_Codes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSSCCH_Codes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSSCCH_Codes_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Codes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Codes_iE_Extensions__item__id._const_tab = ____HSSCCH_Codes_iE_Extensions__item__id_tab
    ___HSSCCH_Codes_iE_Extensions__item__id._const_tab_at = None
    ___HSSCCH_Codes_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSSCCH_Codes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSSCCH_Codes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Codes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Codes_iE_Extensions__item__criticality._const_tab = ____HSSCCH_Codes_iE_Extensions__item__criticality_tab
    ___HSSCCH_Codes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSSCCH_Codes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSSCCH_Codes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSSCCH_Codes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Codes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Codes_iE_Extensions__item__extensionValue._const_tab = ____HSSCCH_Codes_iE_Extensions__item__extensionValue_tab
    ___HSSCCH_Codes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSSCCH_Codes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSSCCH_Codes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSSCCH_Codes_iE_Extensions__item__id),
        ('criticality', ___HSSCCH_Codes_iE_Extensions__item__criticality),
        ('extensionValue', ___HSSCCH_Codes_iE_Extensions__item__extensionValue),
        ])
    __HSSCCH_Codes_iE_Extensions__item_._ext = None
    _HSSCCH_Codes_iE_Extensions._cont = __HSSCCH_Codes_iE_Extensions__item_
    _HSSCCH_Codes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSCCH_Codes._cont = ASN1Dict([
        ('codeNumber', _HSSCCH_Codes_codeNumber),
        ('iE-Extensions', _HSSCCH_Codes_iE_Extensions),
        ])
    HSSCCH_Codes._ext = []
    
    #-----< HSSCCH-Specific-InformationRespItemFDD-ExtIEs >-----#
    HSSCCH_Specific_InformationRespItemFDD_ExtIEs = CLASS(name='HSSCCH-Specific-InformationRespItemFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSSCCH_Specific_InformationRespItemFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSSCCH-Specific-InformationRespListTDD >-----#
    HSSCCH_Specific_InformationRespListTDD = SEQ_OF(name='HSSCCH-Specific-InformationRespListTDD', mode=MODE_TYPE)
    _HSSCCH_Specific_InformationRespListTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespItemTDD')))
    HSSCCH_Specific_InformationRespListTDD._cont = _HSSCCH_Specific_InformationRespListTDD__item_
    HSSCCH_Specific_InformationRespListTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HSSCCH-Specific-InformationRespItemTDD >-----#
    HSSCCH_Specific_InformationRespItemTDD = SEQ(name='HSSCCH-Specific-InformationRespItemTDD', mode=MODE_TYPE)
    _HSSCCH_Specific_InformationRespItemTDD_timeslot = INT(name='timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _HSSCCH_Specific_InformationRespItemTDD_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _HSSCCH_Specific_InformationRespItemTDD_tDD_ChannelisationCode = ENUM(name='tDD-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _HSSCCH_Specific_InformationRespItemTDD_hSSICH_Info = SEQ(name='hSSICH-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSICH-Info')))
    _HSSCCH_Specific_InformationRespItemTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__id._const_tab = ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__id_tab
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__id._const_tab_at = None
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__criticality._const_tab = ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__criticality_tab
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__extensionValue._const_tab = ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__extensionValue_tab
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__id),
        ('criticality', ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__extensionValue),
        ])
    __HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item_._ext = None
    _HSSCCH_Specific_InformationRespItemTDD_iE_Extensions._cont = __HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item_
    _HSSCCH_Specific_InformationRespItemTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSCCH_Specific_InformationRespItemTDD._cont = ASN1Dict([
        ('timeslot', _HSSCCH_Specific_InformationRespItemTDD_timeslot),
        ('midambleShiftAndBurstType', _HSSCCH_Specific_InformationRespItemTDD_midambleShiftAndBurstType),
        ('tDD-ChannelisationCode', _HSSCCH_Specific_InformationRespItemTDD_tDD_ChannelisationCode),
        ('hSSICH-Info', _HSSCCH_Specific_InformationRespItemTDD_hSSICH_Info),
        ('iE-Extensions', _HSSCCH_Specific_InformationRespItemTDD_iE_Extensions),
        ])
    HSSCCH_Specific_InformationRespItemTDD._ext = []
    
    #-----< HSSCCH-Specific-InformationRespItemTDD-ExtIEs >-----#
    HSSCCH_Specific_InformationRespItemTDD_ExtIEs = CLASS(name='HSSCCH-Specific-InformationRespItemTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSSCCH_Specific_InformationRespItemTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSSCCH-Specific-InformationRespListTDDLCR >-----#
    HSSCCH_Specific_InformationRespListTDDLCR = SEQ_OF(name='HSSCCH-Specific-InformationRespListTDDLCR', mode=MODE_TYPE)
    _HSSCCH_Specific_InformationRespListTDDLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespItemTDDLCR')))
    HSSCCH_Specific_InformationRespListTDDLCR._cont = _HSSCCH_Specific_InformationRespListTDDLCR__item_
    HSSCCH_Specific_InformationRespListTDDLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HSSCCH-Specific-InformationRespItemTDDLCR >-----#
    HSSCCH_Specific_InformationRespItemTDDLCR = SEQ(name='HSSCCH-Specific-InformationRespItemTDDLCR', mode=MODE_TYPE)
    _HSSCCH_Specific_InformationRespItemTDDLCR_timeslotLCR = INT(name='timeslotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _HSSCCH_Specific_InformationRespItemTDDLCR_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _HSSCCH_Specific_InformationRespItemTDDLCR_first_TDD_ChannelisationCode = ENUM(name='first-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _HSSCCH_Specific_InformationRespItemTDDLCR_second_TDD_ChannelisationCode = ENUM(name='second-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _HSSCCH_Specific_InformationRespItemTDDLCR_hSSICH_InfoLCR = SEQ(name='hSSICH-InfoLCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSICH-InfoLCR')))
    _HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'reject'), ('Extension', _____HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id._const_tab = ____HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id_tab
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__criticality._const_tab = ____HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id_tab
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__extensionValue._const_tab = ____HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id_tab
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id),
        ('criticality', ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__extensionValue),
        ])
    __HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item_._ext = None
    _HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions._cont = __HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item_
    _HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSCCH_Specific_InformationRespItemTDDLCR._cont = ASN1Dict([
        ('timeslotLCR', _HSSCCH_Specific_InformationRespItemTDDLCR_timeslotLCR),
        ('midambleShiftLCR', _HSSCCH_Specific_InformationRespItemTDDLCR_midambleShiftLCR),
        ('first-TDD-ChannelisationCode', _HSSCCH_Specific_InformationRespItemTDDLCR_first_TDD_ChannelisationCode),
        ('second-TDD-ChannelisationCode', _HSSCCH_Specific_InformationRespItemTDDLCR_second_TDD_ChannelisationCode),
        ('hSSICH-InfoLCR', _HSSCCH_Specific_InformationRespItemTDDLCR_hSSICH_InfoLCR),
        ('iE-Extensions', _HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions),
        ])
    HSSCCH_Specific_InformationRespItemTDDLCR._ext = []
    
    #-----< HSSCCH-Specific-InformationRespItemTDDLCR-ExtIEs >-----#
    HSSCCH_Specific_InformationRespItemTDDLCR_ExtIEs = CLASS(name='HSSCCH-Specific-InformationRespItemTDDLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSSCCH_Specific_InformationRespItemTDDLCR_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    HSSCCH_Specific_InformationRespItemTDDLCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'reject'), ('Extension', _HSSCCH_Specific_InformationRespItemTDDLCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSSCCH-Specific-InformationRespListTDD768 >-----#
    HSSCCH_Specific_InformationRespListTDD768 = SEQ_OF(name='HSSCCH-Specific-InformationRespListTDD768', mode=MODE_TYPE)
    _HSSCCH_Specific_InformationRespListTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespItemTDD768')))
    HSSCCH_Specific_InformationRespListTDD768._cont = _HSSCCH_Specific_InformationRespListTDD768__item_
    HSSCCH_Specific_InformationRespListTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HSSCCH-Specific-InformationRespItemTDD768 >-----#
    HSSCCH_Specific_InformationRespItemTDD768 = SEQ(name='HSSCCH-Specific-InformationRespItemTDD768', mode=MODE_TYPE)
    _HSSCCH_Specific_InformationRespItemTDD768_timeslot = INT(name='timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _HSSCCH_Specific_InformationRespItemTDD768_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _HSSCCH_Specific_InformationRespItemTDD768_tDD_ChannelisationCode768 = ENUM(name='tDD-ChannelisationCode768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _HSSCCH_Specific_InformationRespItemTDD768_hSSICH_Info768 = SEQ(name='hSSICH-Info768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSICH-Info768')))
    _HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__id._const_tab = ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__id_tab
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__id._const_tab_at = None
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__criticality._const_tab = ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__criticality_tab
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__extensionValue._const_tab = ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__extensionValue_tab
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__id),
        ('criticality', ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__criticality),
        ('extensionValue', ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__extensionValue),
        ])
    __HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item_._ext = None
    _HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions._cont = __HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item_
    _HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSCCH_Specific_InformationRespItemTDD768._cont = ASN1Dict([
        ('timeslot', _HSSCCH_Specific_InformationRespItemTDD768_timeslot),
        ('midambleShiftAndBurstType768', _HSSCCH_Specific_InformationRespItemTDD768_midambleShiftAndBurstType768),
        ('tDD-ChannelisationCode768', _HSSCCH_Specific_InformationRespItemTDD768_tDD_ChannelisationCode768),
        ('hSSICH-Info768', _HSSCCH_Specific_InformationRespItemTDD768_hSSICH_Info768),
        ('iE-Extensions', _HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions),
        ])
    HSSCCH_Specific_InformationRespItemTDD768._ext = []
    
    #-----< HSSCCH-Specific-InformationRespItemTDD768-ExtIEs >-----#
    HSSCCH_Specific_InformationRespItemTDD768_ExtIEs = CLASS(name='HSSCCH-Specific-InformationRespItemTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSSCCH_Specific_InformationRespItemTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSSICH-Info >-----#
    HSSICH_Info = SEQ(name='HSSICH-Info', mode=MODE_TYPE)
    _HSSICH_Info_hsSICH_ID = INT(name='hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _HSSICH_Info_timeslot = INT(name='timeslot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _HSSICH_Info_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _HSSICH_Info_tDD_ChannelisationCode = ENUM(name='tDD-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _HSSICH_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSICH_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSSICH_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSSICH_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info_iE_Extensions__item__id._const_tab = ____HSSICH_Info_iE_Extensions__item__id_tab
    ___HSSICH_Info_iE_Extensions__item__id._const_tab_at = None
    ___HSSICH_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSSICH_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSSICH_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info_iE_Extensions__item__criticality._const_tab = ____HSSICH_Info_iE_Extensions__item__criticality_tab
    ___HSSICH_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSSICH_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSSICH_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSSICH_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info_iE_Extensions__item__extensionValue._const_tab = ____HSSICH_Info_iE_Extensions__item__extensionValue_tab
    ___HSSICH_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSSICH_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSSICH_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSSICH_Info_iE_Extensions__item__id),
        ('criticality', ___HSSICH_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___HSSICH_Info_iE_Extensions__item__extensionValue),
        ])
    __HSSICH_Info_iE_Extensions__item_._ext = None
    _HSSICH_Info_iE_Extensions._cont = __HSSICH_Info_iE_Extensions__item_
    _HSSICH_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSICH_Info._cont = ASN1Dict([
        ('hsSICH-ID', _HSSICH_Info_hsSICH_ID),
        ('timeslot', _HSSICH_Info_timeslot),
        ('midambleShiftAndBurstType', _HSSICH_Info_midambleShiftAndBurstType),
        ('tDD-ChannelisationCode', _HSSICH_Info_tDD_ChannelisationCode),
        ('iE-Extensions', _HSSICH_Info_iE_Extensions),
        ])
    HSSICH_Info._ext = []
    
    #-----< HSSICH-Info-ExtIEs >-----#
    HSSICH_Info_ExtIEs = CLASS(name='HSSICH-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSSICH_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSSICH-InfoLCR >-----#
    HSSICH_InfoLCR = SEQ(name='HSSICH-InfoLCR', mode=MODE_TYPE)
    _HSSICH_InfoLCR_hsSICH_ID = INT(name='hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _HSSICH_InfoLCR_timeslotLCR = INT(name='timeslotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _HSSICH_InfoLCR_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _HSSICH_InfoLCR_tDD_ChannelisationCode = ENUM(name='tDD-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _HSSICH_InfoLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSICH_InfoLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSSICH_InfoLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSSICH_InfoLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSSICH_InfoLCR_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    ____HSSICH_InfoLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 936), ('criticality', 'ignore'), ('Extension', _____HSSICH_InfoLCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSSICH_InfoLCR_iE_Extensions__item__id._const_tab = ____HSSICH_InfoLCR_iE_Extensions__item__id_tab
    ___HSSICH_InfoLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSSICH_InfoLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSSICH_InfoLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSSICH_InfoLCR_iE_Extensions__item__criticality._const_tab = ____HSSICH_InfoLCR_iE_Extensions__item__id_tab
    ___HSSICH_InfoLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSSICH_InfoLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue._const_tab = ____HSSICH_InfoLCR_iE_Extensions__item__id_tab
    ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSSICH_InfoLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSSICH_InfoLCR_iE_Extensions__item__id),
        ('criticality', ___HSSICH_InfoLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue),
        ])
    __HSSICH_InfoLCR_iE_Extensions__item_._ext = None
    _HSSICH_InfoLCR_iE_Extensions._cont = __HSSICH_InfoLCR_iE_Extensions__item_
    _HSSICH_InfoLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSICH_InfoLCR._cont = ASN1Dict([
        ('hsSICH-ID', _HSSICH_InfoLCR_hsSICH_ID),
        ('timeslotLCR', _HSSICH_InfoLCR_timeslotLCR),
        ('midambleShiftLCR', _HSSICH_InfoLCR_midambleShiftLCR),
        ('tDD-ChannelisationCode', _HSSICH_InfoLCR_tDD_ChannelisationCode),
        ('iE-Extensions', _HSSICH_InfoLCR_iE_Extensions),
        ])
    HSSICH_InfoLCR._ext = []
    
    #-----< HSSICH-Info-LCR-ExtIEs >-----#
    HSSICH_Info_LCR_ExtIEs = CLASS(name='HSSICH-Info-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSSICH_Info_LCR_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    HSSICH_Info_LCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 936), ('criticality', 'ignore'), ('Extension', _HSSICH_Info_LCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSSICH-Info768 >-----#
    HSSICH_Info768 = SEQ(name='HSSICH-Info768', mode=MODE_TYPE)
    _HSSICH_Info768_hsSICH_ID = INT(name='hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _HSSICH_Info768_timeslot = INT(name='timeslot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _HSSICH_Info768_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _HSSICH_Info768_tDD_ChannelisationCode768 = ENUM(name='tDD-ChannelisationCode768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _HSSICH_Info768_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSICH_Info768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSSICH_Info768_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSSICH_Info768_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info768_iE_Extensions__item__id._const_tab = ____HSSICH_Info768_iE_Extensions__item__id_tab
    ___HSSICH_Info768_iE_Extensions__item__id._const_tab_at = None
    ___HSSICH_Info768_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSSICH_Info768_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSSICH_Info768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info768_iE_Extensions__item__criticality._const_tab = ____HSSICH_Info768_iE_Extensions__item__criticality_tab
    ___HSSICH_Info768_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSSICH_Info768_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSSICH_Info768_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSSICH_Info768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info768_iE_Extensions__item__extensionValue._const_tab = ____HSSICH_Info768_iE_Extensions__item__extensionValue_tab
    ___HSSICH_Info768_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSSICH_Info768_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSSICH_Info768_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSSICH_Info768_iE_Extensions__item__id),
        ('criticality', ___HSSICH_Info768_iE_Extensions__item__criticality),
        ('extensionValue', ___HSSICH_Info768_iE_Extensions__item__extensionValue),
        ])
    __HSSICH_Info768_iE_Extensions__item_._ext = None
    _HSSICH_Info768_iE_Extensions._cont = __HSSICH_Info768_iE_Extensions__item_
    _HSSICH_Info768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSICH_Info768._cont = ASN1Dict([
        ('hsSICH-ID', _HSSICH_Info768_hsSICH_ID),
        ('timeslot', _HSSICH_Info768_timeslot),
        ('midambleShiftAndBurstType768', _HSSICH_Info768_midambleShiftAndBurstType768),
        ('tDD-ChannelisationCode768', _HSSICH_Info768_tDD_ChannelisationCode768),
        ('iE-Extensions', _HSSICH_Info768_iE_Extensions),
        ])
    HSSICH_Info768._ext = []
    
    #-----< HSSICH-Info-768-ExtIEs >-----#
    HSSICH_Info_768_ExtIEs = CLASS(name='HSSICH-Info-768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSSICH_Info_768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-Reception-Quality-Value >-----#
    HS_SICH_Reception_Quality_Value = SEQ(name='HS-SICH-Reception-Quality-Value', mode=MODE_TYPE)
    _HS_SICH_Reception_Quality_Value_failed_HS_SICH = INT(name='failed-HS-SICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-failed')))
    _HS_SICH_Reception_Quality_Value_missed_HS_SICH = INT(name='missed-HS-SICH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-missed')))
    _HS_SICH_Reception_Quality_Value_total_HS_SICH = INT(name='total-HS-SICH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-total')))
    _HS_SICH_Reception_Quality_Value_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SICH_Reception_Quality_Value_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-failed')))
    _____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-missed')))
    _____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-total')))
    ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 881), ('criticality', 'reject'), ('Extension', _____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 882), ('criticality', 'reject'), ('Extension', _____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 883), ('criticality', 'reject'), ('Extension', _____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id._const_tab = ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id._const_tab_at = None
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality._const_tab = ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue._const_tab = ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SICH_Reception_Quality_Value_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id),
        ('criticality', ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue),
        ])
    __HS_SICH_Reception_Quality_Value_iE_Extensions__item_._ext = None
    _HS_SICH_Reception_Quality_Value_iE_Extensions._cont = __HS_SICH_Reception_Quality_Value_iE_Extensions__item_
    _HS_SICH_Reception_Quality_Value_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SICH_Reception_Quality_Value._cont = ASN1Dict([
        ('failed-HS-SICH', _HS_SICH_Reception_Quality_Value_failed_HS_SICH),
        ('missed-HS-SICH', _HS_SICH_Reception_Quality_Value_missed_HS_SICH),
        ('total-HS-SICH', _HS_SICH_Reception_Quality_Value_total_HS_SICH),
        ('iE-Extensions', _HS_SICH_Reception_Quality_Value_iE_Extensions),
        ])
    HS_SICH_Reception_Quality_Value._ext = []
    
    #-----< HS-SICH-Reception-Quality-Value-ExtIEs >-----#
    HS_SICH_Reception_Quality_Value_ExtIEs = CLASS(name='HS-SICH-Reception-Quality-Value-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_SICH_Reception_Quality_Value_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-failed')))
    _HS_SICH_Reception_Quality_Value_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-missed')))
    _HS_SICH_Reception_Quality_Value_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-total')))
    HS_SICH_Reception_Quality_Value_ExtIEs._val = ASN1Set(rv=[dict([('id', 881), ('criticality', 'reject'), ('Extension', _HS_SICH_Reception_Quality_Value_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 882), ('criticality', 'reject'), ('Extension', _HS_SICH_Reception_Quality_Value_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 883), ('criticality', 'reject'), ('Extension', _HS_SICH_Reception_Quality_Value_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-failed >-----#
    HS_SICH_failed = INT(name='HS-SICH-failed', mode=MODE_TYPE)
    HS_SICH_failed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=20)], ev=None, er=[])
    
    #-----< HS-SICH-missed >-----#
    HS_SICH_missed = INT(name='HS-SICH-missed', mode=MODE_TYPE)
    HS_SICH_missed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=20)], ev=None, er=[])
    
    #-----< HS-SICH-total >-----#
    HS_SICH_total = INT(name='HS-SICH-total', mode=MODE_TYPE)
    HS_SICH_total._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=20)], ev=None, er=[])
    
    #-----< HS-SICH-Reception-Quality-Measurement-Value >-----#
    HS_SICH_Reception_Quality_Measurement_Value = INT(name='HS-SICH-Reception-Quality-Measurement-Value', mode=MODE_TYPE)
    HS_SICH_Reception_Quality_Measurement_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=20)], ev=None, er=[])
    
    #-----< HSDSCH-MACdFlow-ID >-----#
    HSDSCH_MACdFlow_ID = INT(name='HSDSCH-MACdFlow-ID', mode=MODE_TYPE)
    HSDSCH_MACdFlow_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< HSDSCH-RNTI >-----#
    HSDSCH_RNTI = INT(name='HSDSCH-RNTI', mode=MODE_TYPE)
    HSDSCH_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< HS-PDSCH-FDD-Code-Information >-----#
    HS_PDSCH_FDD_Code_Information = SEQ(name='HS-PDSCH-FDD-Code-Information', mode=MODE_TYPE)
    _HS_PDSCH_FDD_Code_Information_number_of_HS_PDSCH_codes = INT(name='number-of-HS-PDSCH-codes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HS_PDSCH_FDD_Code_Information_number_of_HS_PDSCH_codes._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _HS_PDSCH_FDD_Code_Information_hS_PDSCH_Start_code_number = INT(name='hS-PDSCH-Start-code-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-PDSCH-Start-code-number')), opt=True)
    _HS_PDSCH_FDD_Code_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_PDSCH_FDD_Code_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__id._const_tab = ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__id_tab
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__id._const_tab_at = None
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__criticality._const_tab = ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__criticality_tab
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__extensionValue._const_tab = ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__extensionValue_tab
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_PDSCH_FDD_Code_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__id),
        ('criticality', ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__extensionValue),
        ])
    __HS_PDSCH_FDD_Code_Information_iE_Extensions__item_._ext = None
    _HS_PDSCH_FDD_Code_Information_iE_Extensions._cont = __HS_PDSCH_FDD_Code_Information_iE_Extensions__item_
    _HS_PDSCH_FDD_Code_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_PDSCH_FDD_Code_Information._cont = ASN1Dict([
        ('number-of-HS-PDSCH-codes', _HS_PDSCH_FDD_Code_Information_number_of_HS_PDSCH_codes),
        ('hS-PDSCH-Start-code-number', _HS_PDSCH_FDD_Code_Information_hS_PDSCH_Start_code_number),
        ('iE-Extensions', _HS_PDSCH_FDD_Code_Information_iE_Extensions),
        ])
    HS_PDSCH_FDD_Code_Information._ext = []
    
    #-----< HS-PDSCH-FDD-Code-Information-ExtIEs >-----#
    HS_PDSCH_FDD_Code_Information_ExtIEs = CLASS(name='HS-PDSCH-FDD-Code-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_PDSCH_FDD_Code_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-PDSCH-Start-code-number >-----#
    HS_PDSCH_Start_code_number = INT(name='HS-PDSCH-Start-code-number', mode=MODE_TYPE)
    HS_PDSCH_Start_code_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< HS-SCCH-ID >-----#
    HS_SCCH_ID = INT(name='HS-SCCH-ID', mode=MODE_TYPE)
    HS_SCCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< HS-SICH-ID >-----#
    HS_SICH_ID = INT(name='HS-SICH-ID', mode=MODE_TYPE)
    HS_SICH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< HS-SCCH-FDD-Code-Information >-----#
    HS_SCCH_FDD_Code_Information = CHOICE(name='HS-SCCH-FDD-Code-Information', mode=MODE_TYPE)
    _HS_SCCH_FDD_Code_Information_replace = SEQ_OF(name='replace', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-FDD-Code-List')))
    _HS_SCCH_FDD_Code_Information_remove = NULL(name='remove', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    HS_SCCH_FDD_Code_Information._cont = ASN1Dict([
        ('replace', _HS_SCCH_FDD_Code_Information_replace),
        ('remove', _HS_SCCH_FDD_Code_Information_remove),
        ])
    HS_SCCH_FDD_Code_Information._ext = []
    
    #-----< HS-SCCH-FDD-Code-List >-----#
    HS_SCCH_FDD_Code_List = SEQ_OF(name='HS-SCCH-FDD-Code-List', mode=MODE_TYPE)
    _HS_SCCH_FDD_Code_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-FDD-Code-Information-Item')))
    HS_SCCH_FDD_Code_List._cont = _HS_SCCH_FDD_Code_List__item_
    HS_SCCH_FDD_Code_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< HS-SCCH-FDD-Code-Information-Item >-----#
    HS_SCCH_FDD_Code_Information_Item = INT(name='HS-SCCH-FDD-Code-Information-Item', mode=MODE_TYPE)
    HS_SCCH_FDD_Code_Information_Item._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< HSSCCH-CodeChangeIndicator >-----#
    HSSCCH_CodeChangeIndicator = ENUM(name='HSSCCH-CodeChangeIndicator', mode=MODE_TYPE)
    HSSCCH_CodeChangeIndicator._cont = ASN1Dict([('hsSCCHCodeChangeNeeded', 0)])
    HSSCCH_CodeChangeIndicator._ext = None
    
    #-----< HSSCCH-Code-Change-Grant >-----#
    HSSCCH_Code_Change_Grant = ENUM(name='HSSCCH-Code-Change-Grant', mode=MODE_TYPE)
    HSSCCH_Code_Change_Grant._cont = ASN1Dict([('changeGranted', 0)])
    HSSCCH_Code_Change_Grant._ext = None
    
    #-----< HS-PDSCH-Code-Change-Indicator >-----#
    HS_PDSCH_Code_Change_Indicator = ENUM(name='HS-PDSCH-Code-Change-Indicator', mode=MODE_TYPE)
    HS_PDSCH_Code_Change_Indicator._cont = ASN1Dict([('hsPDSCHCodeChangeNeeded', 0)])
    HS_PDSCH_Code_Change_Indicator._ext = None
    
    #-----< HS-PDSCH-Code-Change-Grant >-----#
    HS_PDSCH_Code_Change_Grant = ENUM(name='HS-PDSCH-Code-Change-Grant', mode=MODE_TYPE)
    HS_PDSCH_Code_Change_Grant._cont = ASN1Dict([('changeGranted', 0)])
    HS_PDSCH_Code_Change_Grant._ext = None
    
    #-----< HSDSCH-Configured-Indicator >-----#
    HSDSCH_Configured_Indicator = ENUM(name='HSDSCH-Configured-Indicator', mode=MODE_TYPE)
    HSDSCH_Configured_Indicator._cont = ASN1Dict([('configured-HS-DSCH', 0), ('no-configured-HS-DSCH', 1)])
    HSDSCH_Configured_Indicator._ext = None
    
    #-----< HS-DSCH-Serving-Cell-Change-Info >-----#
    HS_DSCH_Serving_Cell_Change_Info = SEQ(name='HS-DSCH-Serving-Cell-Change-Info', mode=MODE_TYPE)
    _HS_DSCH_Serving_Cell_Change_Info_hspdsch_RL_ID = INT(name='hspdsch-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _HS_DSCH_Serving_Cell_Change_Info_hSDSCH_FDD_Information = SEQ(name='hSDSCH-FDD-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information')), opt=True)
    _HS_DSCH_Serving_Cell_Change_Info_hsdsch_RNTI = INT(name='hsdsch-RNTI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _HS_DSCH_Serving_Cell_Change_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information')))
    _____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Information')))
    ____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 834), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 832), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id._const_tab = ____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item_._ext = None
    _HS_DSCH_Serving_Cell_Change_Info_iE_Extensions._cont = __HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item_
    _HS_DSCH_Serving_Cell_Change_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Serving_Cell_Change_Info._cont = ASN1Dict([
        ('hspdsch-RL-ID', _HS_DSCH_Serving_Cell_Change_Info_hspdsch_RL_ID),
        ('hSDSCH-FDD-Information', _HS_DSCH_Serving_Cell_Change_Info_hSDSCH_FDD_Information),
        ('hsdsch-RNTI', _HS_DSCH_Serving_Cell_Change_Info_hsdsch_RNTI),
        ('iE-Extensions', _HS_DSCH_Serving_Cell_Change_Info_iE_Extensions),
        ])
    HS_DSCH_Serving_Cell_Change_Info._ext = []
    
    #-----< HS-DSCH-Serving-Cell-Change-Info-ExtIEs >-----#
    HS_DSCH_Serving_Cell_Change_Info_ExtIEs = CLASS(name='HS-DSCH-Serving-Cell-Change-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_Serving_Cell_Change_Info_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information')))
    _HS_DSCH_Serving_Cell_Change_Info_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Information')))
    HS_DSCH_Serving_Cell_Change_Info_ExtIEs._val = ASN1Set(rv=[dict([('id', 834), ('criticality', 'reject'), ('Extension', _HS_DSCH_Serving_Cell_Change_Info_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 832), ('criticality', 'reject'), ('Extension', _HS_DSCH_Serving_Cell_Change_Info_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Serving-Cell-Change-Info-Response >-----#
    HS_DSCH_Serving_Cell_Change_Info_Response = SEQ(name='HS-DSCH-Serving-Cell-Change-Info-Response', mode=MODE_TYPE)
    _HS_DSCH_Serving_Cell_Change_Info_Response_hS_DSCH_serving_cell_choice = CHOICE(name='hS-DSCH-serving-cell-choice', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-serving-cell-choice')))
    _HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id._const_tab = ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id_tab
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality_tab
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue_tab
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item_._ext = None
    _HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions._cont = __HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item_
    _HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Serving_Cell_Change_Info_Response._cont = ASN1Dict([
        ('hS-DSCH-serving-cell-choice', _HS_DSCH_Serving_Cell_Change_Info_Response_hS_DSCH_serving_cell_choice),
        ('iE-Extensions', _HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions),
        ])
    HS_DSCH_Serving_Cell_Change_Info_Response._ext = []
    
    #-----< HS-DSCH-serving-cell-informationResponse-ExtIEs >-----#
    HS_DSCH_serving_cell_informationResponse_ExtIEs = CLASS(name='HS-DSCH-serving-cell-informationResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCH_serving_cell_informationResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-serving-cell-choice >-----#
    HS_DSCH_serving_cell_choice = CHOICE(name='HS-DSCH-serving-cell-choice', mode=MODE_TYPE)
    _HS_DSCH_serving_cell_choice_hS_serving_cell_change_successful = SEQ(name='hS-serving-cell-change-successful', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-serving-cell-change-successful')))
    _HS_DSCH_serving_cell_choice_hS_serving_cell_change_unsuccessful = SEQ(name='hS-serving-cell-change-unsuccessful', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-serving-cell-change-unsuccessful')))
    HS_DSCH_serving_cell_choice._cont = ASN1Dict([
        ('hS-serving-cell-change-successful', _HS_DSCH_serving_cell_choice_hS_serving_cell_change_successful),
        ('hS-serving-cell-change-unsuccessful', _HS_DSCH_serving_cell_choice_hS_serving_cell_change_unsuccessful),
        ])
    HS_DSCH_serving_cell_choice._ext = []
    
    #-----< HS-serving-cell-change-successful >-----#
    HS_serving_cell_change_successful = SEQ(name='HS-serving-cell-change-successful', mode=MODE_TYPE)
    _HS_serving_cell_change_successful_hSDSCH_FDD_Information_Response = SEQ(name='hSDSCH-FDD-Information-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _HS_serving_cell_change_successful_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_serving_cell_change_successful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_serving_cell_change_successful_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_serving_cell_change_successful_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information-Response')))
    ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 835), ('criticality', 'ignore'), ('Extension', _____HS_serving_cell_change_successful_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_serving_cell_change_successful_iE_Extensions__item__id._const_tab = ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab
    ___HS_serving_cell_change_successful_iE_Extensions__item__id._const_tab_at = None
    ___HS_serving_cell_change_successful_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_serving_cell_change_successful_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab = ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab
    ___HS_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab = ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab
    ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_serving_cell_change_successful_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_serving_cell_change_successful_iE_Extensions__item__id),
        ('criticality', ___HS_serving_cell_change_successful_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue),
        ])
    __HS_serving_cell_change_successful_iE_Extensions__item_._ext = None
    _HS_serving_cell_change_successful_iE_Extensions._cont = __HS_serving_cell_change_successful_iE_Extensions__item_
    _HS_serving_cell_change_successful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_serving_cell_change_successful._cont = ASN1Dict([
        ('hSDSCH-FDD-Information-Response', _HS_serving_cell_change_successful_hSDSCH_FDD_Information_Response),
        ('iE-Extensions', _HS_serving_cell_change_successful_iE_Extensions),
        ])
    HS_serving_cell_change_successful._ext = []
    
    #-----< HS-serving-cell-change-successful-ExtIEs >-----#
    HS_serving_cell_change_successful_ExtIEs = CLASS(name='HS-serving-cell-change-successful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_serving_cell_change_successful_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information-Response')))
    HS_serving_cell_change_successful_ExtIEs._val = ASN1Set(rv=[dict([('id', 835), ('criticality', 'ignore'), ('Extension', _HS_serving_cell_change_successful_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-serving-cell-change-unsuccessful >-----#
    HS_serving_cell_change_unsuccessful = SEQ(name='HS-serving-cell-change-unsuccessful', mode=MODE_TYPE)
    _HS_serving_cell_change_unsuccessful_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _HS_serving_cell_change_unsuccessful_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_serving_cell_change_unsuccessful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab = ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_at = None
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab = ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab = ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_serving_cell_change_unsuccessful_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id),
        ('criticality', ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue),
        ])
    __HS_serving_cell_change_unsuccessful_iE_Extensions__item_._ext = None
    _HS_serving_cell_change_unsuccessful_iE_Extensions._cont = __HS_serving_cell_change_unsuccessful_iE_Extensions__item_
    _HS_serving_cell_change_unsuccessful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_serving_cell_change_unsuccessful._cont = ASN1Dict([
        ('cause', _HS_serving_cell_change_unsuccessful_cause),
        ('iE-Extensions', _HS_serving_cell_change_unsuccessful_iE_Extensions),
        ])
    HS_serving_cell_change_unsuccessful._ext = []
    
    #-----< HS-serving-cell-change-unsuccessful-ExtIEs >-----#
    HS_serving_cell_change_unsuccessful_ExtIEs = CLASS(name='HS-serving-cell-change-unsuccessful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_serving_cell_change_unsuccessful_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-DRX-Cycle-FACH >-----#
    HS_DSCH_DRX_Cycle_FACH = ENUM(name='HS-DSCH-DRX-Cycle-FACH', mode=MODE_TYPE)
    HS_DSCH_DRX_Cycle_FACH._cont = ASN1Dict([('v4', 0), ('v8', 1), ('v16', 2), ('v32', 3)])
    HS_DSCH_DRX_Cycle_FACH._ext = []
    
    #-----< HS-DSCH-RX-Burst-FACH >-----#
    HS_DSCH_RX_Burst_FACH = ENUM(name='HS-DSCH-RX-Burst-FACH', mode=MODE_TYPE)
    HS_DSCH_RX_Burst_FACH._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v4', 2), ('v8', 3), ('v16', 4)])
    HS_DSCH_RX_Burst_FACH._ext = []
    
    #-----< HS-SCCH-DRX-Cycle-FACH >-----#
    HS_SCCH_DRX_Cycle_FACH = ENUM(name='HS-SCCH-DRX-Cycle-FACH', mode=MODE_TYPE)
    HS_SCCH_DRX_Cycle_FACH._cont = ASN1Dict([('v4', 0), ('v8', 1), ('v16', 2), ('v32', 3), ('v64', 4)])
    HS_SCCH_DRX_Cycle_FACH._ext = []
    
    #-----< HS-SCCH-RX-Burst-FACH >-----#
    HS_SCCH_RX_Burst_FACH = ENUM(name='HS-SCCH-RX-Burst-FACH', mode=MODE_TYPE)
    HS_SCCH_RX_Burst_FACH._cont = ASN1Dict([('v0dot4', 0), ('v0dot8', 1)])
    HS_SCCH_RX_Burst_FACH._ext = []
    
    #-----< HSDSCH-FDD-Update-Information >-----#
    HSDSCH_FDD_Update_Information = SEQ(name='HSDSCH-FDD-Update-Information', mode=MODE_TYPE)
    _HSDSCH_FDD_Update_Information_hsSCCHCodeChangeIndicator = ENUM(name='hsSCCHCodeChangeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-CodeChangeIndicator')), opt=True)
    _HSDSCH_FDD_Update_Information_cqiFeedback_CycleK = ENUM(name='cqiFeedback-CycleK', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-Feedback-Cycle')), opt=True)
    _HSDSCH_FDD_Update_Information_cqiRepetitionFactor = INT(name='cqiRepetitionFactor', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-RepetitionFactor')), opt=True)
    _HSDSCH_FDD_Update_Information_ackNackRepetitionFactor = INT(name='ackNackRepetitionFactor', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AckNack-RepetitionFactor')), opt=True)
    _HSDSCH_FDD_Update_Information_cqiPowerOffset = INT(name='cqiPowerOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-Power-Offset')), opt=True)
    _HSDSCH_FDD_Update_Information_ackPowerOffset = INT(name='ackPowerOffset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Ack-Power-Offset')), opt=True)
    _HSDSCH_FDD_Update_Information_nackPowerOffset = INT(name='nackPowerOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Nack-Power-Offset')), opt=True)
    _HSDSCH_FDD_Update_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_FDD_Update_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-PDSCH-Code-Change-Indicator')))
    _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Precoder-Weight-Set-Restriction')))
    _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Feedback-Cycle2')))
    _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Cycle-Switch-Timer')))
    ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 845), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1255), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1280), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1281), ('criticality', 'ignore'), ('Extension', _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id._const_tab = ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab = ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_FDD_Update_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_FDD_Update_Information_iE_Extensions__item_._ext = None
    _HSDSCH_FDD_Update_Information_iE_Extensions._cont = __HSDSCH_FDD_Update_Information_iE_Extensions__item_
    _HSDSCH_FDD_Update_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_FDD_Update_Information._cont = ASN1Dict([
        ('hsSCCHCodeChangeIndicator', _HSDSCH_FDD_Update_Information_hsSCCHCodeChangeIndicator),
        ('cqiFeedback-CycleK', _HSDSCH_FDD_Update_Information_cqiFeedback_CycleK),
        ('cqiRepetitionFactor', _HSDSCH_FDD_Update_Information_cqiRepetitionFactor),
        ('ackNackRepetitionFactor', _HSDSCH_FDD_Update_Information_ackNackRepetitionFactor),
        ('cqiPowerOffset', _HSDSCH_FDD_Update_Information_cqiPowerOffset),
        ('ackPowerOffset', _HSDSCH_FDD_Update_Information_ackPowerOffset),
        ('nackPowerOffset', _HSDSCH_FDD_Update_Information_nackPowerOffset),
        ('iE-Extensions', _HSDSCH_FDD_Update_Information_iE_Extensions),
        ])
    HSDSCH_FDD_Update_Information._ext = []
    
    #-----< HSDSCH-FDD-Update-Information-ExtIEs >-----#
    HSDSCH_FDD_Update_Information_ExtIEs = CLASS(name='HSDSCH-FDD-Update-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-PDSCH-Code-Change-Indicator')))
    _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Precoder-Weight-Set-Restriction')))
    _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Feedback-Cycle2')))
    _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CQI-Cycle-Switch-Timer')))
    HSDSCH_FDD_Update_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 845), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1255), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1280), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1281), ('criticality', 'ignore'), ('Extension', _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-TDD-Update-Information >-----#
    HSDSCH_TDD_Update_Information = SEQ(name='HSDSCH-TDD-Update-Information', mode=MODE_TYPE)
    _HSDSCH_TDD_Update_Information_hsSCCHCodeChangeIndicator = ENUM(name='hsSCCHCodeChangeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-CodeChangeIndicator')), opt=True)
    _HSDSCH_TDD_Update_Information_tDDAckNackPowerOffset = INT(name='tDDAckNackPowerOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-AckNack-Power-Offset')), opt=True)
    _HSDSCH_TDD_Update_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_TDD_Update_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id._const_tab = ____HSDSCH_TDD_Update_Information_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality._const_tab = ____HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality_tab
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_TDD_Update_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_TDD_Update_Information_iE_Extensions__item_._ext = None
    _HSDSCH_TDD_Update_Information_iE_Extensions._cont = __HSDSCH_TDD_Update_Information_iE_Extensions__item_
    _HSDSCH_TDD_Update_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_TDD_Update_Information._cont = ASN1Dict([
        ('hsSCCHCodeChangeIndicator', _HSDSCH_TDD_Update_Information_hsSCCHCodeChangeIndicator),
        ('tDDAckNackPowerOffset', _HSDSCH_TDD_Update_Information_tDDAckNackPowerOffset),
        ('iE-Extensions', _HSDSCH_TDD_Update_Information_iE_Extensions),
        ])
    HSDSCH_TDD_Update_Information._ext = []
    
    #-----< HSDSCH-TDD-Update-Information-ExtIEs >-----#
    HSDSCH_TDD_Update_Information_ExtIEs = CLASS(name='HSDSCH-TDD-Update-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_TDD_Update_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSPDSCH-Code-Index >-----#
    HSPDSCH_Code_Index = INT(name='HSPDSCH-Code-Index', mode=MODE_TYPE)
    HSPDSCH_Code_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< HSPDSCH-First-Code-Index >-----#
    HSPDSCH_First_Code_Index = INT(name='HSPDSCH-First-Code-Index', mode=MODE_TYPE)
    HSPDSCH_First_Code_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< HSPDSCH-Second-Code-Index >-----#
    HSPDSCH_Second_Code_Index = INT(name='HSPDSCH-Second-Code-Index', mode=MODE_TYPE)
    HSPDSCH_Second_Code_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< HSPDSCH-Second-Code-Support >-----#
    HSPDSCH_Second_Code_Support = BOOL(name='HSPDSCH-Second-Code-Support', mode=MODE_TYPE)
    
    #-----< HSDPA-Associated-PICH-InformationLCR >-----#
    HSDPA_Associated_PICH_InformationLCR = CHOICE(name='HSDPA-Associated-PICH-InformationLCR', mode=MODE_TYPE)
    _HSDPA_Associated_PICH_InformationLCR_hsdpa_PICH_Shared_with_PCH = SEQ(name='hsdpa-PICH-Shared-with-PCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-PICH-Shared-with-PCH')))
    _HSDPA_Associated_PICH_InformationLCR_hsdpa_PICH_notShared_with_PCHLCR = SEQ(name='hsdpa-PICH-notShared-with-PCHLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-PICH-notShared-with-PCHLCR')))
    HSDPA_Associated_PICH_InformationLCR._cont = ASN1Dict([
        ('hsdpa-PICH-Shared-with-PCH', _HSDPA_Associated_PICH_InformationLCR_hsdpa_PICH_Shared_with_PCH),
        ('hsdpa-PICH-notShared-with-PCHLCR', _HSDPA_Associated_PICH_InformationLCR_hsdpa_PICH_notShared_with_PCHLCR),
        ])
    HSDPA_Associated_PICH_InformationLCR._ext = []
    
    #-----< HSDPA-PICH-notShared-with-PCHLCR >-----#
    HSDPA_PICH_notShared_with_PCHLCR = SEQ(name='HSDPA-PICH-notShared-with-PCHLCR', mode=MODE_TYPE)
    _HSDPA_PICH_notShared_with_PCHLCR_hSDPA_PICH_notShared_ID = INT(name='hSDPA-PICH-notShared-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _HSDPA_PICH_notShared_with_PCHLCR_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _HSDPA_PICH_notShared_with_PCHLCR_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _HSDPA_PICH_notShared_with_PCHLCR_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _HSDPA_PICH_notShared_with_PCHLCR_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _HSDPA_PICH_notShared_with_PCHLCR_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _HSDPA_PICH_notShared_with_PCHLCR_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _HSDPA_PICH_notShared_with_PCHLCR_pagingIndicatorLength = ENUM(name='pagingIndicatorLength', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PagingIndicatorLength')))
    _HSDPA_PICH_notShared_with_PCHLCR_pICH_Power = INT(name='pICH-Power', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')))
    _HSDPA_PICH_notShared_with_PCHLCR_second_TDD_ChannelisationCodeLCR = SEQ(name='second-TDD-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _HSDPA_PICH_notShared_with_PCHLCR_sttd_Indicator = ENUM(name='sttd-Indicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'STTD-Indicator')))
    _HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__id._const_tab = ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__id_tab
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__criticality._const_tab = ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__criticality_tab
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__extensionValue._const_tab = ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__extensionValue_tab
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__id),
        ('criticality', ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__extensionValue),
        ])
    __HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item_._ext = None
    _HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions._cont = __HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item_
    _HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDPA_PICH_notShared_with_PCHLCR._cont = ASN1Dict([
        ('hSDPA-PICH-notShared-ID', _HSDPA_PICH_notShared_with_PCHLCR_hSDPA_PICH_notShared_ID),
        ('tdd-ChannelisationCodeLCR', _HSDPA_PICH_notShared_with_PCHLCR_tdd_ChannelisationCodeLCR),
        ('timeSlotLCR', _HSDPA_PICH_notShared_with_PCHLCR_timeSlotLCR),
        ('midambleShiftLCR', _HSDPA_PICH_notShared_with_PCHLCR_midambleShiftLCR),
        ('tdd-PhysicalChannelOffset', _HSDPA_PICH_notShared_with_PCHLCR_tdd_PhysicalChannelOffset),
        ('repetitionPeriod', _HSDPA_PICH_notShared_with_PCHLCR_repetitionPeriod),
        ('repetitionLength', _HSDPA_PICH_notShared_with_PCHLCR_repetitionLength),
        ('pagingIndicatorLength', _HSDPA_PICH_notShared_with_PCHLCR_pagingIndicatorLength),
        ('pICH-Power', _HSDPA_PICH_notShared_with_PCHLCR_pICH_Power),
        ('second-TDD-ChannelisationCodeLCR', _HSDPA_PICH_notShared_with_PCHLCR_second_TDD_ChannelisationCodeLCR),
        ('sttd-Indicator', _HSDPA_PICH_notShared_with_PCHLCR_sttd_Indicator),
        ('iE-Extensions', _HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions),
        ])
    HSDPA_PICH_notShared_with_PCHLCR._ext = []
    
    #-----< HSDPA-PICH-notShared-with-PCHLCR-ExtIEs >-----#
    HSDPA_PICH_notShared_with_PCHLCR_ExtIEs = CLASS(name='HSDPA-PICH-notShared-with-PCHLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDPA_PICH_notShared_with_PCHLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Common-System-InformationLCR >-----#
    HSDSCH_Common_System_InformationLCR = SEQ(name='HSDSCH-Common-System-InformationLCR', mode=MODE_TYPE)
    _HSDSCH_Common_System_InformationLCR_hsdsch_Common_InformationLCR = SEQ(name='hsdsch-Common-InformationLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Common-InformationLCR')), opt=True)
    _HSDSCH_Common_System_InformationLCR_commonMACFlow_Specific_InformationLCR = SEQ_OF(name='commonMACFlow-Specific-InformationLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMACFlow-Specific-InfoListLCR')), opt=True)
    _HSDSCH_Common_System_InformationLCR_common_H_RNTI_InformationLCR = SEQ_OF(name='common-H-RNTI-InformationLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-H-RNTI-InformationLCR')), opt=True)
    _HSDSCH_Common_System_InformationLCR_sync_InformationLCR = SEQ(name='sync-InformationLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Sync-InformationLCR')), opt=True)
    _HSDSCH_Common_System_InformationLCR_tDD_AckNack_Power_Offset = INT(name='tDD-AckNack-Power-Offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-AckNack-Power-Offset')), opt=True)
    _HSDSCH_Common_System_InformationLCR_hSSICH_SIRTarget = INT(name='hSSICH-SIRTarget', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')), opt=True)
    _HSDSCH_Common_System_InformationLCR_hSSICH_TPC_StepSize = ENUM(name='hSSICH-TPC-StepSize', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')), opt=True)
    _HSDSCH_Common_System_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Common_System_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__id._const_tab = ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__id_tab
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__criticality_tab
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Common_System_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Common_System_InformationLCR_iE_Extensions__item_._ext = None
    _HSDSCH_Common_System_InformationLCR_iE_Extensions._cont = __HSDSCH_Common_System_InformationLCR_iE_Extensions__item_
    _HSDSCH_Common_System_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Common_System_InformationLCR._cont = ASN1Dict([
        ('hsdsch-Common-InformationLCR', _HSDSCH_Common_System_InformationLCR_hsdsch_Common_InformationLCR),
        ('commonMACFlow-Specific-InformationLCR', _HSDSCH_Common_System_InformationLCR_commonMACFlow_Specific_InformationLCR),
        ('common-H-RNTI-InformationLCR', _HSDSCH_Common_System_InformationLCR_common_H_RNTI_InformationLCR),
        ('sync-InformationLCR', _HSDSCH_Common_System_InformationLCR_sync_InformationLCR),
        ('tDD-AckNack-Power-Offset', _HSDSCH_Common_System_InformationLCR_tDD_AckNack_Power_Offset),
        ('hSSICH-SIRTarget', _HSDSCH_Common_System_InformationLCR_hSSICH_SIRTarget),
        ('hSSICH-TPC-StepSize', _HSDSCH_Common_System_InformationLCR_hSSICH_TPC_StepSize),
        ('iE-Extensions', _HSDSCH_Common_System_InformationLCR_iE_Extensions),
        ])
    HSDSCH_Common_System_InformationLCR._ext = []
    
    #-----< HSDSCH-Common-System-InformationLCR-ExtIEs >-----#
    HSDSCH_Common_System_InformationLCR_ExtIEs = CLASS(name='HSDSCH-Common-System-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_Common_System_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Common-System-Information-ResponseLCR >-----#
    HSDSCH_Common_System_Information_ResponseLCR = SEQ(name='HSDSCH-Common-System-Information-ResponseLCR', mode=MODE_TYPE)
    _HSDSCH_Common_System_Information_ResponseLCR_hsSCCH_Specific_Information_ResponseLCR = SEQ_OF(name='hsSCCH-Specific-Information-ResponseLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespListLCR')), opt=True)
    _HSDSCH_Common_System_Information_ResponseLCR_hARQ_MemoryPartitioning = CHOICE(name='hARQ-MemoryPartitioning', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioning')), opt=True)
    _HSDSCH_Common_System_Information_ResponseLCR_commonMACFlow_Specific_Info_ResponseLCR = SEQ_OF(name='commonMACFlow-Specific-Info-ResponseLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMACFlow-Specific-InfoList-ResponseLCR')), opt=True)
    _HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MultipleFreq-HARQ-MemoryPartitioning-InformationList')))
    _____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMACFlow-Specific-InfoList-ResponseLCR-Ext')))
    ____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1133), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1179), ('criticality', 'ignore'), ('Extension', _____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions._cont = __HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item_
    _HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Common_System_Information_ResponseLCR._cont = ASN1Dict([
        ('hsSCCH-Specific-Information-ResponseLCR', _HSDSCH_Common_System_Information_ResponseLCR_hsSCCH_Specific_Information_ResponseLCR),
        ('hARQ-MemoryPartitioning', _HSDSCH_Common_System_Information_ResponseLCR_hARQ_MemoryPartitioning),
        ('commonMACFlow-Specific-Info-ResponseLCR', _HSDSCH_Common_System_Information_ResponseLCR_commonMACFlow_Specific_Info_ResponseLCR),
        ('iE-Extensions', _HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions),
        ])
    HSDSCH_Common_System_Information_ResponseLCR._ext = []
    
    #-----< HSDSCH-Common-System-Information-ResponseLCR-ExtIEs >-----#
    HSDSCH_Common_System_Information_ResponseLCR_ExtIEs = CLASS(name='HSDSCH-Common-System-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDSCH_Common_System_Information_ResponseLCR_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _HSDSCH_Common_System_Information_ResponseLCR_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MultipleFreq-HARQ-MemoryPartitioning-InformationList')))
    _HSDSCH_Common_System_Information_ResponseLCR_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMACFlow-Specific-InfoList-ResponseLCR-Ext')))
    HSDSCH_Common_System_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _HSDSCH_Common_System_Information_ResponseLCR_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1133), ('criticality', 'ignore'), ('Extension', _HSDSCH_Common_System_Information_ResponseLCR_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1179), ('criticality', 'ignore'), ('Extension', _HSDSCH_Common_System_Information_ResponseLCR_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Common-InformationLCR >-----#
    HSDSCH_Common_InformationLCR = SEQ(name='HSDSCH-Common-InformationLCR', mode=MODE_TYPE)
    _HSDSCH_Common_InformationLCR_cCCH_PriorityQueue_Id = INT(name='cCCH-PriorityQueue-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-Id')))
    _HSDSCH_Common_InformationLCR_sRB1_PriorityQueue_Id = INT(name='sRB1-PriorityQueue-Id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-Id')))
    _HSDSCH_Common_InformationLCR_associatedCommon_MACFlowLCR = INT(name='associatedCommon-MACFlowLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlow-ID-LCR')))
    _HSDSCH_Common_InformationLCR_fACH_Measurement_Occasion_Cycle_Length_Coefficient = INT(name='fACH-Measurement-Occasion-Cycle-Length-Coefficient', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FACH-Measurement-Occasion-Cycle-Length-Coefficient')), opt=True)
    _HSDSCH_Common_InformationLCR_bCCH_Specific_HSDSCH_RNTI_InformationLCR = SEQ(name='bCCH-Specific-HSDSCH-RNTI-InformationLCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BCCH-Specific-HSDSCH-RNTI-InformationLCR')), opt=True)
    _HSDSCH_Common_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Common_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Common_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__id._const_tab = ____HSDSCH_Common_InformationLCR_iE_Extensions__item__id_tab
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_Common_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Common_InformationLCR_iE_Extensions__item__criticality_tab
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_Common_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Common_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Common_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Common_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Common_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Common_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Common_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Common_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Common_InformationLCR_iE_Extensions__item_._ext = None
    _HSDSCH_Common_InformationLCR_iE_Extensions._cont = __HSDSCH_Common_InformationLCR_iE_Extensions__item_
    _HSDSCH_Common_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Common_InformationLCR._cont = ASN1Dict([
        ('cCCH-PriorityQueue-Id', _HSDSCH_Common_InformationLCR_cCCH_PriorityQueue_Id),
        ('sRB1-PriorityQueue-Id', _HSDSCH_Common_InformationLCR_sRB1_PriorityQueue_Id),
        ('associatedCommon-MACFlowLCR', _HSDSCH_Common_InformationLCR_associatedCommon_MACFlowLCR),
        ('fACH-Measurement-Occasion-Cycle-Length-Coefficient', _HSDSCH_Common_InformationLCR_fACH_Measurement_Occasion_Cycle_Length_Coefficient),
        ('bCCH-Specific-HSDSCH-RNTI-InformationLCR', _HSDSCH_Common_InformationLCR_bCCH_Specific_HSDSCH_RNTI_InformationLCR),
        ('iE-Extensions', _HSDSCH_Common_InformationLCR_iE_Extensions),
        ])
    HSDSCH_Common_InformationLCR._ext = []
    
    #-----< HSDSCH-Common-InformationLCR-ExtIEs >-----#
    HSDSCH_Common_InformationLCR_ExtIEs = CLASS(name='HSDSCH-Common-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_Common_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Paging-System-InformationLCR >-----#
    HSDSCH_Paging_System_InformationLCR = SEQ(name='HSDSCH-Paging-System-InformationLCR', mode=MODE_TYPE)
    _HSDSCH_Paging_System_InformationLCR_paging_MACFlow_Specific_InformationLCR = SEQ_OF(name='paging-MACFlow-Specific-InformationLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlow-Specific-InformationLCR')))
    _HSDSCH_Paging_System_InformationLCR_hSSCCH_Power = INT(name='hSSCCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _HSDSCH_Paging_System_InformationLCR_hSPDSCH_Power = INT(name='hSPDSCH-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _HSDSCH_Paging_System_InformationLCR_reception_Window_Size = INT(name='reception-Window-Size', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _HSDSCH_Paging_System_InformationLCR_reception_Window_Size._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _HSDSCH_Paging_System_InformationLCR_n_PCH = INT(name='n-PCH', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _HSDSCH_Paging_System_InformationLCR_n_PCH._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _HSDSCH_Paging_System_InformationLCR_paging_Subchannel_Size = INT(name='paging-Subchannel-Size', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _HSDSCH_Paging_System_InformationLCR_paging_Subchannel_Size._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _HSDSCH_Paging_System_InformationLCR_transport_Block_Size_List = SEQ_OF(name='transport-Block-Size-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transport-Block-Size-List')), opt=True)
    _HSDSCH_Paging_System_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Paging_System_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__id._const_tab = ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__id_tab
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__criticality_tab
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Paging_System_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Paging_System_InformationLCR_iE_Extensions__item_._ext = None
    _HSDSCH_Paging_System_InformationLCR_iE_Extensions._cont = __HSDSCH_Paging_System_InformationLCR_iE_Extensions__item_
    _HSDSCH_Paging_System_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Paging_System_InformationLCR._cont = ASN1Dict([
        ('paging-MACFlow-Specific-InformationLCR', _HSDSCH_Paging_System_InformationLCR_paging_MACFlow_Specific_InformationLCR),
        ('hSSCCH-Power', _HSDSCH_Paging_System_InformationLCR_hSSCCH_Power),
        ('hSPDSCH-Power', _HSDSCH_Paging_System_InformationLCR_hSPDSCH_Power),
        ('reception-Window-Size', _HSDSCH_Paging_System_InformationLCR_reception_Window_Size),
        ('n-PCH', _HSDSCH_Paging_System_InformationLCR_n_PCH),
        ('paging-Subchannel-Size', _HSDSCH_Paging_System_InformationLCR_paging_Subchannel_Size),
        ('transport-Block-Size-List', _HSDSCH_Paging_System_InformationLCR_transport_Block_Size_List),
        ('iE-Extensions', _HSDSCH_Paging_System_InformationLCR_iE_Extensions),
        ])
    HSDSCH_Paging_System_InformationLCR._ext = []
    
    #-----< HSDSCH-Paging-System-InformationLCR-ExtIEs >-----#
    HSDSCH_Paging_System_InformationLCR_ExtIEs = CLASS(name='HSDSCH-Paging-System-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_Paging_System_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Paging-System-Information-ResponseLCR >-----#
    HSDSCH_Paging_System_Information_ResponseLCR = SEQ_OF(name='HSDSCH-Paging-System-Information-ResponseLCR', mode=MODE_TYPE)
    _HSDSCH_Paging_System_Information_ResponseLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Paging-System-Information-ResponseListLCR')))
    HSDSCH_Paging_System_Information_ResponseLCR._cont = _HSDSCH_Paging_System_Information_ResponseLCR__item_
    HSDSCH_Paging_System_Information_ResponseLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HSDSCH-Paging-System-Information-ResponseListLCR >-----#
    HSDSCH_Paging_System_Information_ResponseListLCR = SEQ(name='HSDSCH-Paging-System-Information-ResponseListLCR', mode=MODE_TYPE)
    _HSDSCH_Paging_System_Information_ResponseListLCR_pagingMACFlow_ID = INT(name='pagingMACFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlow-ID')))
    _HSDSCH_Paging_System_Information_ResponseListLCR_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _HSDSCH_Paging_System_Information_ResponseListLCR_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _HSDSCH_Paging_System_Information_ResponseListLCR_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='dL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst')))
    _HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__id._const_tab = ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__id_tab
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__criticality_tab
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item_._ext = None
    _HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions._cont = __HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item_
    _HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Paging_System_Information_ResponseListLCR._cont = ASN1Dict([
        ('pagingMACFlow-ID', _HSDSCH_Paging_System_Information_ResponseListLCR_pagingMACFlow_ID),
        ('bindingID', _HSDSCH_Paging_System_Information_ResponseListLCR_bindingID),
        ('transportLayerAddress', _HSDSCH_Paging_System_Information_ResponseListLCR_transportLayerAddress),
        ('dL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst', _HSDSCH_Paging_System_Information_ResponseListLCR_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions),
        ])
    HSDSCH_Paging_System_Information_ResponseListLCR._ext = []
    
    #-----< HSDSCH-Paging-System-Information-ResponseListLCR-ExtIEs >-----#
    HSDSCH_Paging_System_Information_ResponseListLCR_ExtIEs = CLASS(name='HSDSCH-Paging-System-Information-ResponseListLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_Paging_System_Information_ResponseListLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-ID-LCR >-----#
    HS_SCCH_ID_LCR = INT(name='HS-SCCH-ID-LCR', mode=MODE_TYPE)
    HS_SCCH_ID_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< HSSCCH-Specific-InformationRespListLCR >-----#
    HSSCCH_Specific_InformationRespListLCR = SEQ_OF(name='HSSCCH-Specific-InformationRespListLCR', mode=MODE_TYPE)
    _HSSCCH_Specific_InformationRespListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespItemLCR')))
    HSSCCH_Specific_InformationRespListLCR._cont = _HSSCCH_Specific_InformationRespListLCR__item_
    HSSCCH_Specific_InformationRespListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< HSSCCH-Specific-InformationRespItemLCR >-----#
    HSSCCH_Specific_InformationRespItemLCR = SEQ(name='HSSCCH-Specific-InformationRespItemLCR', mode=MODE_TYPE)
    _HSSCCH_Specific_InformationRespItemLCR_hS_SCCH_ID_LCR = INT(name='hS-SCCH-ID-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-ID-LCR')))
    _HSSCCH_Specific_InformationRespItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__id._const_tab = ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__id_tab
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__criticality._const_tab = ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__criticality_tab
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__extensionValue._const_tab = ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__extensionValue_tab
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__id),
        ('criticality', ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__extensionValue),
        ])
    __HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item_._ext = None
    _HSSCCH_Specific_InformationRespItemLCR_iE_Extensions._cont = __HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item_
    _HSSCCH_Specific_InformationRespItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSCCH_Specific_InformationRespItemLCR._cont = ASN1Dict([
        ('hS-SCCH-ID-LCR', _HSSCCH_Specific_InformationRespItemLCR_hS_SCCH_ID_LCR),
        ('iE-Extensions', _HSSCCH_Specific_InformationRespItemLCR_iE_Extensions),
        ])
    HSSCCH_Specific_InformationRespItemLCR._ext = []
    
    #-----< HSSCCH-Specific-InformationRespItemLCR-ExtIEs >-----#
    HSSCCH_Specific_InformationRespItemLCR_ExtIEs = CLASS(name='HSSCCH-Specific-InformationRespItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSSCCH_Specific_InformationRespItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-LCR >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_LCR = SEQ(name='HS-DSCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_TYPE)
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_transport_Block_Size_List = SEQ_OF(name='transport-Block-Size-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transport-Block-Size-List-LCR')))
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR = SEQ_OF(name='repetition-Period-List-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Repetition-Period-List-LCR')))
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Reservation_Indicator = ENUM(name='hS-DSCH-SPS-Reservation-Indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SPS-Reservation-Indicator')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Operation_Indicator = CHOICE(name='hS-DSCH-SPS-Operation-Indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-SPS-Operation-Indicator')))
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_._ext = None
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions._cont = __HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Semi_PersistentScheduling_Information_LCR._cont = ASN1Dict([
        ('transport-Block-Size-List', _HS_DSCH_Semi_PersistentScheduling_Information_LCR_transport_Block_Size_List),
        ('repetition-Period-List-LCR', _HS_DSCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR),
        ('hS-DSCH-SPS-Reservation-Indicator', _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Reservation_Indicator),
        ('hS-DSCH-SPS-Operation-Indicator', _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Operation_Indicator),
        ('iE-Extensions', _HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions),
        ])
    HS_DSCH_Semi_PersistentScheduling_Information_LCR._ext = []
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-LCR-ExtIEs >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_LCR_ExtIEs = CLASS(name='HS-DSCH-Semi-PersistentScheduling-Information-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCH_Semi_PersistentScheduling_Information_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transport-Block-Size-List-LCR >-----#
    Transport_Block_Size_List_LCR = SEQ_OF(name='Transport-Block-Size-List-LCR', mode=MODE_TYPE)
    _Transport_Block_Size_List_LCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transport-Block-Size-Item-LCR')))
    Transport_Block_Size_List_LCR._cont = _Transport_Block_Size_List_LCR__item_
    Transport_Block_Size_List_LCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Transport-Block-Size-Item-LCR >-----#
    Transport_Block_Size_Item_LCR = SEQ(name='Transport-Block-Size-Item-LCR', mode=MODE_TYPE)
    _Transport_Block_Size_Item_LCR_transport_Block_Size_maping_Index_LCR = INT(name='transport-Block-Size-maping-Index-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transport-Block-Size-maping-Index-LCR')))
    _Transport_Block_Size_Item_LCR_transport_Block_Size_Index_LCR = INT(name='transport-Block-Size-Index-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transport-Block-Size-Index-LCR')))
    _Transport_Block_Size_Item_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_Block_Size_Item_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id._const_tab = ____Transport_Block_Size_Item_LCR_iE_Extensions__item__id_tab
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id._const_tab_at = None
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality._const_tab = ____Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality_tab
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue._const_tab = ____Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue_tab
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transport_Block_Size_Item_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id),
        ('criticality', ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue),
        ])
    __Transport_Block_Size_Item_LCR_iE_Extensions__item_._ext = None
    _Transport_Block_Size_Item_LCR_iE_Extensions._cont = __Transport_Block_Size_Item_LCR_iE_Extensions__item_
    _Transport_Block_Size_Item_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_Block_Size_Item_LCR._cont = ASN1Dict([
        ('transport-Block-Size-maping-Index-LCR', _Transport_Block_Size_Item_LCR_transport_Block_Size_maping_Index_LCR),
        ('transport-Block-Size-Index-LCR', _Transport_Block_Size_Item_LCR_transport_Block_Size_Index_LCR),
        ('iE-Extensions', _Transport_Block_Size_Item_LCR_iE_Extensions),
        ])
    Transport_Block_Size_Item_LCR._ext = []
    
    #-----< Transport-Block-Size-Item-LCR-ExtIEs >-----#
    Transport_Block_Size_Item_LCR_ExtIEs = CLASS(name='Transport-Block-Size-Item-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Transport_Block_Size_Item_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transport-Block-Size-maping-Index-LCR >-----#
    Transport_Block_Size_maping_Index_LCR = INT(name='Transport-Block-Size-maping-Index-LCR', mode=MODE_TYPE)
    Transport_Block_Size_maping_Index_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< Transport-Block-Size-Index-LCR >-----#
    Transport_Block_Size_Index_LCR = INT(name='Transport-Block-Size-Index-LCR', mode=MODE_TYPE)
    Transport_Block_Size_Index_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Repetition-Period-List-LCR >-----#
    Repetition_Period_List_LCR = SEQ_OF(name='Repetition-Period-List-LCR', mode=MODE_TYPE)
    _Repetition_Period_List_LCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Repetition-Period-Item-LCR')))
    Repetition_Period_List_LCR._cont = _Repetition_Period_List_LCR__item_
    Repetition_Period_List_LCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Repetition-Period-Item-LCR >-----#
    Repetition_Period_Item_LCR = SEQ(name='Repetition-Period-Item-LCR', mode=MODE_TYPE)
    _Repetition_Period_Item_LCR_repetitionPeriodIndex = INT(name='repetitionPeriodIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriodIndex')))
    _Repetition_Period_Item_LCR_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _Repetition_Period_Item_LCR_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')), opt=True)
    _Repetition_Period_Item_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Repetition_Period_Item_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Repetition_Period_Item_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Repetition_Period_Item_LCR_iE_Extensions__item__id._const_tab = ____Repetition_Period_Item_LCR_iE_Extensions__item__id_tab
    ___Repetition_Period_Item_LCR_iE_Extensions__item__id._const_tab_at = None
    ___Repetition_Period_Item_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality._const_tab = ____Repetition_Period_Item_LCR_iE_Extensions__item__criticality_tab
    ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue._const_tab = ____Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue_tab
    ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Repetition_Period_Item_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Repetition_Period_Item_LCR_iE_Extensions__item__id),
        ('criticality', ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue),
        ])
    __Repetition_Period_Item_LCR_iE_Extensions__item_._ext = None
    _Repetition_Period_Item_LCR_iE_Extensions._cont = __Repetition_Period_Item_LCR_iE_Extensions__item_
    _Repetition_Period_Item_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Repetition_Period_Item_LCR._cont = ASN1Dict([
        ('repetitionPeriodIndex', _Repetition_Period_Item_LCR_repetitionPeriodIndex),
        ('repetitionPeriod', _Repetition_Period_Item_LCR_repetitionPeriod),
        ('repetitionLength', _Repetition_Period_Item_LCR_repetitionLength),
        ('iE-Extensions', _Repetition_Period_Item_LCR_iE_Extensions),
        ])
    Repetition_Period_Item_LCR._ext = []
    
    #-----< Repetition-Period-Item-LCR-ExtIEs >-----#
    Repetition_Period_Item_LCR_ExtIEs = CLASS(name='Repetition-Period-Item-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Repetition_Period_Item_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RepetitionPeriodIndex >-----#
    RepetitionPeriodIndex = INT(name='RepetitionPeriodIndex', mode=MODE_TYPE)
    RepetitionPeriodIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< SPS-Reservation-Indicator >-----#
    SPS_Reservation_Indicator = ENUM(name='SPS-Reservation-Indicator', mode=MODE_TYPE)
    SPS_Reservation_Indicator._cont = ASN1Dict([('reserve', 0)])
    SPS_Reservation_Indicator._ext = None
    
    #-----< HS-DSCH-SPS-Operation-Indicator >-----#
    HS_DSCH_SPS_Operation_Indicator = CHOICE(name='HS-DSCH-SPS-Operation-Indicator', mode=MODE_TYPE)
    _HS_DSCH_SPS_Operation_Indicator_logicalChannellevel = BIT_STR(name='logicalChannellevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LogicalChannellevel')))
    _HS_DSCH_SPS_Operation_Indicator_priorityQueuelevel = BIT_STR(name='priorityQueuelevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueuelevel')))
    HS_DSCH_SPS_Operation_Indicator._cont = ASN1Dict([
        ('logicalChannellevel', _HS_DSCH_SPS_Operation_Indicator_logicalChannellevel),
        ('priorityQueuelevel', _HS_DSCH_SPS_Operation_Indicator_priorityQueuelevel),
        ])
    HS_DSCH_SPS_Operation_Indicator._ext = []
    
    #-----< LogicalChannellevel >-----#
    LogicalChannellevel = BIT_STR(name='LogicalChannellevel', mode=MODE_TYPE)
    LogicalChannellevel._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< PriorityQueuelevel >-----#
    PriorityQueuelevel = BIT_STR(name='PriorityQueuelevel', mode=MODE_TYPE)
    PriorityQueuelevel._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR = SEQ(name='HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR', mode=MODE_TYPE)
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_transport_Block_Size_List = SEQ_OF(name='transport-Block-Size-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transport-Block-Size-List-LCR')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR = SEQ_OF(name='repetition-Period-List-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Repetition-Period-List-LCR')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SPS-Reservation-Indicator')))
    _____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-SPS-Operation-Indicator')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1131), ('criticality', 'ignore'), ('Extension', _____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1148), ('criticality', 'reject'), ('Extension', _____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_._ext = None
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions._cont = __HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR._cont = ASN1Dict([
        ('transport-Block-Size-List', _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_transport_Block_Size_List),
        ('repetition-Period-List-LCR', _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR),
        ('iE-Extensions', _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions),
        ])
    HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR._ext = []
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs = CLASS(name='HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SPS-Reservation-Indicator')))
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-SPS-Operation-Indicator')))
    HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 1131), ('criticality', 'ignore'), ('Extension', _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1148), ('criticality', 'reject'), ('Extension', _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR = SEQ(name='HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR', mode=MODE_TYPE)
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_hS_SICH_InformationList_for_HS_DSCH_SPS = SEQ_OF(name='hS-SICH-InformationList-for-HS-DSCH-SPS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-InformationList-for-HS-DSCH-SPS')))
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_initial_HS_PDSCH_SPS_Resource = SEQ(name='initial-HS-PDSCH-SPS-Resource', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Initial-HS-PDSCH-SPS-Resource')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_buffer_Size_for_HS_DSCH_SPS = ENUM(name='buffer-Size-for-HS-DSCH-SPS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Process-Memory-Size')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_number_of_Processes_for_HS_DSCH_SPS = INT(name='number-of-Processes-for-HS-DSCH-SPS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Number-of-Processes-for-HS-DSCH-SPS')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions._cont = __HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR._cont = ASN1Dict([
        ('hS-SICH-InformationList-for-HS-DSCH-SPS', _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_hS_SICH_InformationList_for_HS_DSCH_SPS),
        ('initial-HS-PDSCH-SPS-Resource', _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_initial_HS_PDSCH_SPS_Resource),
        ('buffer-Size-for-HS-DSCH-SPS', _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_buffer_Size_for_HS_DSCH_SPS),
        ('number-of-Processes-for-HS-DSCH-SPS', _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_number_of_Processes_for_HS_DSCH_SPS),
        ('iE-Extensions', _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions),
        ])
    HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR._ext = []
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs = CLASS(name='HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-InformationList-for-HS-DSCH-SPS >-----#
    HS_SICH_InformationList_for_HS_DSCH_SPS = SEQ_OF(name='HS-SICH-InformationList-for-HS-DSCH-SPS', mode=MODE_TYPE)
    _HS_SICH_InformationList_for_HS_DSCH_SPS__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-InformationItem-for-HS-DSCH-SPS')))
    HS_SICH_InformationList_for_HS_DSCH_SPS._cont = _HS_SICH_InformationList_for_HS_DSCH_SPS__item_
    HS_SICH_InformationList_for_HS_DSCH_SPS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HS-SICH-InformationItem-for-HS-DSCH-SPS >-----#
    HS_SICH_InformationItem_for_HS_DSCH_SPS = SEQ(name='HS-SICH-InformationItem-for-HS-DSCH-SPS', mode=MODE_TYPE)
    _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Mapping_Index = INT(name='hS-SICH-Mapping-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-Mapping-Index')), opt=True)
    _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Type = CHOICE(name='hS-SICH-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-Type')))
    _HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id._const_tab = ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id_tab
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id._const_tab_at = None
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality._const_tab = ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality_tab
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue._const_tab = ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue_tab
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id),
        ('criticality', ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue),
        ])
    __HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item_._ext = None
    _HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions._cont = __HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item_
    _HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SICH_InformationItem_for_HS_DSCH_SPS._cont = ASN1Dict([
        ('hS-SICH-Mapping-Index', _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Mapping_Index),
        ('hS-SICH-Type', _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Type),
        ('iE-Extensions', _HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions),
        ])
    HS_SICH_InformationItem_for_HS_DSCH_SPS._ext = []
    
    #-----< HS-SICH-InformationItem-for-HS-DSCH-SPS-ExtIEs >-----#
    HS_SICH_InformationItem_for_HS_DSCH_SPS_ExtIEs = CLASS(name='HS-SICH-InformationItem-for-HS-DSCH-SPS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_SICH_InformationItem_for_HS_DSCH_SPS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-Mapping-Index >-----#
    HS_SICH_Mapping_Index = INT(name='HS-SICH-Mapping-Index', mode=MODE_TYPE)
    HS_SICH_Mapping_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< HS-SICH-Type >-----#
    HS_SICH_Type = CHOICE(name='HS-SICH-Type', mode=MODE_TYPE)
    _HS_SICH_Type_hS_SCCH_Associated_HS_SICH = SEQ(name='hS-SCCH-Associated-HS-SICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-Associated-HS-SICH')))
    _HS_SICH_Type_non_HS_SCCH_Associated_HS_SICH = SEQ(name='non-HS-SCCH-Associated-HS-SICH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Non-HS-SCCH-Associated-HS-SICH')))
    HS_SICH_Type._cont = ASN1Dict([
        ('hS-SCCH-Associated-HS-SICH', _HS_SICH_Type_hS_SCCH_Associated_HS_SICH),
        ('non-HS-SCCH-Associated-HS-SICH', _HS_SICH_Type_non_HS_SCCH_Associated_HS_SICH),
        ])
    HS_SICH_Type._ext = []
    
    #-----< HS-SCCH-Associated-HS-SICH >-----#
    HS_SCCH_Associated_HS_SICH = SEQ(name='HS-SCCH-Associated-HS-SICH', mode=MODE_TYPE)
    _HS_SCCH_Associated_HS_SICH_hsSICH_ID = INT(name='hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _HS_SCCH_Associated_HS_SICH_extended_HS_SICH_ID = INT(name='extended-HS-SICH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')), opt=True)
    HS_SCCH_Associated_HS_SICH._cont = ASN1Dict([
        ('hsSICH-ID', _HS_SCCH_Associated_HS_SICH_hsSICH_ID),
        ('extended-HS-SICH-ID', _HS_SCCH_Associated_HS_SICH_extended_HS_SICH_ID),
        ])
    HS_SCCH_Associated_HS_SICH._ext = []
    
    #-----< Non-HS-SCCH-Associated-HS-SICH >-----#
    Non_HS_SCCH_Associated_HS_SICH = SEQ(name='Non-HS-SCCH-Associated-HS-SICH', mode=MODE_TYPE)
    _Non_HS_SCCH_Associated_HS_SICH_non_HS_SCCH_Aassociated_HS_SICH_ID = INT(name='non-HS-SCCH-Aassociated-HS-SICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Non-HS-SCCH-Aassociated-HS-SICH-ID')))
    Non_HS_SCCH_Associated_HS_SICH._cont = ASN1Dict([
        ('non-HS-SCCH-Aassociated-HS-SICH-ID', _Non_HS_SCCH_Associated_HS_SICH_non_HS_SCCH_Aassociated_HS_SICH_ID),
        ])
    Non_HS_SCCH_Associated_HS_SICH._ext = []
    
    #-----< Non-HS-SCCH-Aassociated-HS-SICH-ID >-----#
    Non_HS_SCCH_Aassociated_HS_SICH_ID = INT(name='Non-HS-SCCH-Aassociated-HS-SICH-ID', mode=MODE_TYPE)
    Non_HS_SCCH_Aassociated_HS_SICH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< Initial-HS-PDSCH-SPS-Resource >-----#
    Initial_HS_PDSCH_SPS_Resource = SEQ(name='Initial-HS-PDSCH-SPS-Resource', mode=MODE_TYPE)
    _Initial_HS_PDSCH_SPS_Resource_repetitionPeriodIndex = INT(name='repetitionPeriodIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriodIndex')))
    _Initial_HS_PDSCH_SPS_Resource_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')), opt=True)
    _Initial_HS_PDSCH_SPS_Resource_hS_PDSCH_Offset = INT(name='hS-PDSCH-Offset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _Initial_HS_PDSCH_SPS_Resource_timeslot_Resource_Related_Information = BIT_STR(name='timeslot-Resource-Related-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-TimeslotResourceLCR')))
    _Initial_HS_PDSCH_SPS_Resource_startCode = ENUM(name='startCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _Initial_HS_PDSCH_SPS_Resource_endCode = ENUM(name='endCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _Initial_HS_PDSCH_SPS_Resource_transport_Block_Size_Index = INT(name='transport-Block-Size-Index', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transport-Block-Size-Index-LCR')))
    _Initial_HS_PDSCH_SPS_Resource_modulationType = ENUM(name='modulationType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ModulationSPS-LCR')))
    _Initial_HS_PDSCH_SPS_Resource_hS_SICH_Mapping_Index = INT(name='hS-SICH-Mapping-Index', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-Mapping-Index')))
    _Initial_HS_PDSCH_SPS_Resource_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1136), ('criticality', 'reject'), ('Extension', _____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id._const_tab = ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id._const_tab_at = None
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id._const_tab_id = 'id'
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality._const_tab = ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue._const_tab = ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id),
        ('criticality', ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality),
        ('extensionValue', ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue),
        ])
    __Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item_._ext = None
    _Initial_HS_PDSCH_SPS_Resource_iE_Extensions._cont = __Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item_
    _Initial_HS_PDSCH_SPS_Resource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Initial_HS_PDSCH_SPS_Resource._cont = ASN1Dict([
        ('repetitionPeriodIndex', _Initial_HS_PDSCH_SPS_Resource_repetitionPeriodIndex),
        ('repetitionLength', _Initial_HS_PDSCH_SPS_Resource_repetitionLength),
        ('hS-PDSCH-Offset', _Initial_HS_PDSCH_SPS_Resource_hS_PDSCH_Offset),
        ('timeslot-Resource-Related-Information', _Initial_HS_PDSCH_SPS_Resource_timeslot_Resource_Related_Information),
        ('startCode', _Initial_HS_PDSCH_SPS_Resource_startCode),
        ('endCode', _Initial_HS_PDSCH_SPS_Resource_endCode),
        ('transport-Block-Size-Index', _Initial_HS_PDSCH_SPS_Resource_transport_Block_Size_Index),
        ('modulationType', _Initial_HS_PDSCH_SPS_Resource_modulationType),
        ('hS-SICH-Mapping-Index', _Initial_HS_PDSCH_SPS_Resource_hS_SICH_Mapping_Index),
        ('iE-Extensions', _Initial_HS_PDSCH_SPS_Resource_iE_Extensions),
        ])
    Initial_HS_PDSCH_SPS_Resource._ext = []
    
    #-----< Initial-HS-PDSCH-SPS-Resource-ExtIEs >-----#
    Initial_HS_PDSCH_SPS_Resource_ExtIEs = CLASS(name='Initial-HS-PDSCH-SPS-Resource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Initial_HS_PDSCH_SPS_Resource_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    Initial_HS_PDSCH_SPS_Resource_ExtIEs._val = ASN1Set(rv=[dict([('id', 1136), ('criticality', 'reject'), ('Extension', _Initial_HS_PDSCH_SPS_Resource_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-TimeslotResourceLCR >-----#
    HS_DSCH_TimeslotResourceLCR = BIT_STR(name='HS-DSCH-TimeslotResourceLCR', mode=MODE_TYPE)
    HS_DSCH_TimeslotResourceLCR._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< ModulationSPS-LCR >-----#
    ModulationSPS_LCR = ENUM(name='ModulationSPS-LCR', mode=MODE_TYPE)
    ModulationSPS_LCR._cont = ASN1Dict([('qPSK', 0), ('sixteenQAM', 1)])
    ModulationSPS_LCR._ext = []
    
    #-----< Number-of-Processes-for-HS-DSCH-SPS >-----#
    Number_of_Processes_for_HS_DSCH_SPS = INT(name='Number-of-Processes-for-HS-DSCH-SPS', mode=MODE_TYPE)
    Number_of_Processes_for_HS_DSCH_SPS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst = SEQ(name='Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_non_HS_SCCH_Associated_HS_SICH_InformationList = SEQ_OF(name='non-HS-SCCH-Associated-HS-SICH-InformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Non-HS-SCCH-Associated-HS-SICH-InformationList')))
    _Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext')))
    ____Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1161), ('criticality', 'reject'), ('Extension', _____Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('non-HS-SCCH-Associated-HS-SICH-InformationList', _Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_non_HS_SCCH_Associated_HS_SICH_InformationList),
        ('iE-Extensions', _Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext')))
    Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 1161), ('criticality', 'reject'), ('Extension', _Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Non-HS-SCCH-Associated-HS-SICH-InformationList >-----#
    Non_HS_SCCH_Associated_HS_SICH_InformationList = SEQ_OF(name='Non-HS-SCCH-Associated-HS-SICH-InformationList', mode=MODE_TYPE)
    _Non_HS_SCCH_Associated_HS_SICH_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-HS-SCCH-Associated-HS-SICH-InformationItem')))
    Non_HS_SCCH_Associated_HS_SICH_InformationList._cont = _Non_HS_SCCH_Associated_HS_SICH_InformationList__item_
    Non_HS_SCCH_Associated_HS_SICH_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    
    #-----< Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext >-----#
    Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext = SEQ_OF(name='Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext', mode=MODE_TYPE)
    _Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-HS-SCCH-Associated-HS-SICH-InformationItem')))
    Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext._cont = _Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext__item_
    Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=44)], ev=None, er=[])
    
    #-----< Non-HS-SCCH-Associated-HS-SICH-InformationItem >-----#
    Non_HS_SCCH_Associated_HS_SICH_InformationItem = SEQ(name='Non-HS-SCCH-Associated-HS-SICH-InformationItem', mode=MODE_TYPE)
    _Non_HS_SCCH_Associated_HS_SICH_InformationItem_non_HS_SCCH_Aassociated_HS_SICH_ID = INT(name='non-HS-SCCH-Aassociated-HS-SICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Non-HS-SCCH-Aassociated-HS-SICH-ID')))
    _Non_HS_SCCH_Associated_HS_SICH_InformationItem_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _Non_HS_SCCH_Associated_HS_SICH_InformationItem_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _Non_HS_SCCH_Associated_HS_SICH_InformationItem_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _Non_HS_SCCH_Associated_HS_SICH_InformationItem_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')), opt=True)
    _Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id._const_tab = ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id_tab
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality._const_tab = ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality_tab
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue_tab
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id),
        ('criticality', ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item_._ext = None
    _Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions._cont = __Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item_
    _Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Non_HS_SCCH_Associated_HS_SICH_InformationItem._cont = ASN1Dict([
        ('non-HS-SCCH-Aassociated-HS-SICH-ID', _Non_HS_SCCH_Associated_HS_SICH_InformationItem_non_HS_SCCH_Aassociated_HS_SICH_ID),
        ('timeSlotLCR', _Non_HS_SCCH_Associated_HS_SICH_InformationItem_timeSlotLCR),
        ('midambleShiftLCR', _Non_HS_SCCH_Associated_HS_SICH_InformationItem_midambleShiftLCR),
        ('tdd-ChannelisationCode', _Non_HS_SCCH_Associated_HS_SICH_InformationItem_tdd_ChannelisationCode),
        ('uARFCN', _Non_HS_SCCH_Associated_HS_SICH_InformationItem_uARFCN),
        ('iE-Extensions', _Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions),
        ])
    Non_HS_SCCH_Associated_HS_SICH_InformationItem._ext = []
    
    #-----< Non-HS-SCCH-Associated-HS-SICH-InformationItem-ExtIEs >-----#
    Non_HS_SCCH_Associated_HS_SICH_InformationItem_ExtIEs = CLASS(name='Non-HS-SCCH-Associated-HS-SICH-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Non_HS_SCCH_Associated_HS_SICH_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst = SEQ(name='Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_modify_non_HS_SCCH_Associated_HS_SICH_InformationList = SEQ_OF(name='modify-non-HS-SCCH-Associated-HS-SICH-InformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationList')))
    _Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext')))
    ____Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1162), ('criticality', 'reject'), ('Extension', _____Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('modify-non-HS-SCCH-Associated-HS-SICH-InformationList', _Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_modify_non_HS_SCCH_Associated_HS_SICH_InformationList),
        ('iE-Extensions', _Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext')))
    Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 1162), ('criticality', 'reject'), ('Extension', _Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Modify-Non-HS-SCCH-Associated-HS-SICH-InformationList >-----#
    Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList = SEQ_OF(name='Modify-Non-HS-SCCH-Associated-HS-SICH-InformationList', mode=MODE_TYPE)
    _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationItem')))
    Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList._cont = _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList__item_
    Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    
    #-----< Modify-Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext >-----#
    Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext = SEQ_OF(name='Modify-Non-HS-SCCH-Associated-HS-SICH-InformationList-Ext', mode=MODE_TYPE)
    _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Modify-Non-HS-SCCH-Associated-HS-SICH-InformationItem')))
    Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext._cont = _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext__item_
    Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=44)], ev=None, er=[])
    
    #-----< Modify-Non-HS-SCCH-Associated-HS-SICH-InformationItem >-----#
    Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem = SEQ(name='Modify-Non-HS-SCCH-Associated-HS-SICH-InformationItem', mode=MODE_TYPE)
    _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_non_HS_SCCH_Aassociated_HS_SICH_ID = INT(name='non-HS-SCCH-Aassociated-HS-SICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Non-HS-SCCH-Aassociated-HS-SICH-ID')))
    _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')), opt=True)
    _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')), opt=True)
    _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')), opt=True)
    _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id._const_tab = ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id_tab
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality._const_tab = ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality_tab
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue_tab
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id),
        ('criticality', ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item_._ext = None
    _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions._cont = __Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item_
    _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem._cont = ASN1Dict([
        ('non-HS-SCCH-Aassociated-HS-SICH-ID', _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_non_HS_SCCH_Aassociated_HS_SICH_ID),
        ('timeSlotLCR', _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_timeSlotLCR),
        ('midambleShiftLCR', _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_midambleShiftLCR),
        ('tdd-ChannelisationCode', _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_tdd_ChannelisationCode),
        ('uARFCN', _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_uARFCN),
        ('iE-Extensions', _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions),
        ])
    Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem._ext = []
    
    #-----< Modify-Non-HS-SCCH-Associated-HS-SICH-InformationItem-ExtIEs >-----#
    Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_ExtIEs = CLASS(name='Modify-Non-HS-SCCH-Associated-HS-SICH-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst = SEQ_OF(name='Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqstItem')))
    Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst._cont = _Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst__item_
    Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    
    #-----< Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext >-----#
    Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext = SEQ_OF(name='Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext', mode=MODE_TYPE)
    _Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqstItem')))
    Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext._cont = _Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext__item_
    Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=44)], ev=None, er=[])
    
    #-----< Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqstItem >-----#
    Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqstItem = SEQ(name='Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqstItem', mode=MODE_TYPE)
    _Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqstItem_non_HS_SCCH_Aassociated_HS_SICH_ID = INT(name='non-HS-SCCH-Aassociated-HS-SICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Non-HS-SCCH-Aassociated-HS-SICH-ID')))
    Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqstItem._cont = ASN1Dict([
        ('non-HS-SCCH-Aassociated-HS-SICH-ID', _Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqstItem_non_HS_SCCH_Aassociated_HS_SICH_ID),
        ])
    Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqstItem._ext = []
    
    #-----< MIMO-ReferenceSignal-InformationListLCR >-----#
    MIMO_ReferenceSignal_InformationListLCR = SEQ_OF(name='MIMO-ReferenceSignal-InformationListLCR', mode=MODE_TYPE)
    _MIMO_ReferenceSignal_InformationListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSICH-ReferenceSignal-InformationLCR')))
    MIMO_ReferenceSignal_InformationListLCR._cont = _MIMO_ReferenceSignal_InformationListLCR__item_
    MIMO_ReferenceSignal_InformationListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HSSICH-ReferenceSignal-InformationLCR >-----#
    HSSICH_ReferenceSignal_InformationLCR = SEQ(name='HSSICH-ReferenceSignal-InformationLCR', mode=MODE_TYPE)
    _HSSICH_ReferenceSignal_InformationLCR_midambleConfigurationLCR = ENUM(name='midambleConfigurationLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleConfigurationLCR')))
    _HSSICH_ReferenceSignal_InformationLCR_midambleShift = INT(name='midambleShift', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HSSICH_ReferenceSignal_InformationLCR_midambleShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _HSSICH_ReferenceSignal_InformationLCR_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _HSSICH_ReferenceSignal_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id._const_tab = ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id_tab
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality._const_tab = ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality_tab
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item_._ext = None
    _HSSICH_ReferenceSignal_InformationLCR_iE_Extensions._cont = __HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item_
    _HSSICH_ReferenceSignal_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSICH_ReferenceSignal_InformationLCR._cont = ASN1Dict([
        ('midambleConfigurationLCR', _HSSICH_ReferenceSignal_InformationLCR_midambleConfigurationLCR),
        ('midambleShift', _HSSICH_ReferenceSignal_InformationLCR_midambleShift),
        ('timeSlotLCR', _HSSICH_ReferenceSignal_InformationLCR_timeSlotLCR),
        ('iE-Extensions', _HSSICH_ReferenceSignal_InformationLCR_iE_Extensions),
        ])
    HSSICH_ReferenceSignal_InformationLCR._ext = []
    
    #-----< HSSICH-ReferenceSignal-InformationLCR-ExtIEs >-----#
    HSSICH_ReferenceSignal_InformationLCR_ExtIEs = CLASS(name='HSSICH-ReferenceSignal-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSSICH_ReferenceSignal_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSSICH-ReferenceSignal-InformationModifyLCR >-----#
    HSSICH_ReferenceSignal_InformationModifyLCR = SEQ(name='HSSICH-ReferenceSignal-InformationModifyLCR', mode=MODE_TYPE)
    _HSSICH_ReferenceSignal_InformationModifyLCR_hSSICH_ReferenceSignal_InformationLCR = SEQ(name='hSSICH-ReferenceSignal-InformationLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSICH-ReferenceSignal-InformationLCR')), opt=True)
    _HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__id._const_tab = ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__id_tab
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__criticality._const_tab = ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__criticality_tab
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__extensionValue._const_tab = ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__extensionValue_tab
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__id),
        ('criticality', ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__extensionValue),
        ])
    __HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item_._ext = None
    _HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions._cont = __HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item_
    _HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSICH_ReferenceSignal_InformationModifyLCR._cont = ASN1Dict([
        ('hSSICH-ReferenceSignal-InformationLCR', _HSSICH_ReferenceSignal_InformationModifyLCR_hSSICH_ReferenceSignal_InformationLCR),
        ('iE-Extensions', _HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions),
        ])
    HSSICH_ReferenceSignal_InformationModifyLCR._ext = []
    
    #-----< HSSICH-ReferenceSignal-InformationModifyLCR-ExtIEs >-----#
    HSSICH_ReferenceSignal_InformationModifyLCR_ExtIEs = CLASS(name='HSSICH-ReferenceSignal-InformationModifyLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSSICH_ReferenceSignal_InformationModifyLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DPCCH-transmission-continuation-backoff >-----#
    HS_DPCCH_transmission_continuation_backoff = ENUM(name='HS-DPCCH-transmission-continuation-backoff', mode=MODE_TYPE)
    HS_DPCCH_transmission_continuation_backoff._cont = ASN1Dict([('v10', 0), ('v20', 1), ('v30', 2), ('v40', 3), ('v80', 4), ('v160', 5), ('v320', 6), ('v800', 7), ('infinity', 8)])
    HS_DPCCH_transmission_continuation_backoff._ext = []
    
    #-----< IB-OC-ID >-----#
    IB_OC_ID = INT(name='IB-OC-ID', mode=MODE_TYPE)
    IB_OC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< IB-SG-DATA >-----#
    IB_SG_DATA = BIT_STR(name='IB-SG-DATA', mode=MODE_TYPE)
    
    #-----< IB-SG-POS >-----#
    IB_SG_POS = INT(name='IB-SG-POS', mode=MODE_TYPE)
    IB_SG_POS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4094)], ev=None, er=[])
    
    #-----< IB-SG-REP >-----#
    IB_SG_REP = ENUM(name='IB-SG-REP', mode=MODE_TYPE)
    IB_SG_REP._cont = ASN1Dict([('rep4', 0), ('rep8', 1), ('rep16', 2), ('rep32', 3), ('rep64', 4), ('rep128', 5), ('rep256', 6), ('rep512', 7), ('rep1024', 8), ('rep2048', 9), ('rep4096', 10)])
    IB_SG_REP._ext = None
    
    #-----< IB-Type >-----#
    IB_Type = ENUM(name='IB-Type', mode=MODE_TYPE)
    IB_Type._cont = ASN1Dict([('mIB', 0), ('sB1', 1), ('sB2', 2), ('sIB1', 3), ('sIB2', 4), ('sIB3', 5), ('sIB4', 6), ('sIB5', 7), ('sIB6', 8), ('sIB7', 9), ('not-Used-sIB8', 10), ('not-Used-sIB9', 11), ('not-Used-sIB10', 12), ('sIB11', 13), ('sIB12', 14), ('sIB13', 15), ('sIB13dot1', 16), ('sIB13dot2', 17), ('sIB13dot3', 18), ('sIB13dot4', 19), ('sIB14', 20), ('sIB15', 21), ('sIB15dot1', 22), ('sIB15dot2', 23), ('sIB15dot3', 24), ('sIB16', 25), ('sIB17', 26), ('sIB15dot4', 27), ('sIB18', 28), ('sIB15dot5', 29), ('sIB5bis', 30), ('sIB11bis', 31), ('sIB15bis', 32), ('sIB15dot1bis', 33), ('sIB15dot2bis', 34), ('sIB15dot3bis', 35), ('sIB15dot6', 36), ('sIB15dot7', 37), ('sIB15dot8', 38), ('sIB15dot2ter', 39), ('sIB19', 40), ('not-Applicable-SIB20', 41), ('sIB21', 42), ('sIB22', 43), ('sIB15dot1ter', 44), ('sB3', 45), ('sIB23', 46), ('sIB24', 47), ('sIB11ter', 48), ('sIB25', 49)])
    IB_Type._ext = ['sIB17', 'sIB15dot4', 'sIB18', 'sIB15dot5', 'sIB5bis', 'sIB11bis', 'sIB15bis', 'sIB15dot1bis', 'sIB15dot2bis', 'sIB15dot3bis', 'sIB15dot6', 'sIB15dot7', 'sIB15dot8', 'sIB15dot2ter', 'sIB19', 'not-Applicable-SIB20', 'sIB21', 'sIB22', 'sIB15dot1ter', 'sB3', 'sIB23', 'sIB24', 'sIB11ter', 'sIB25']
    
    #-----< IMB-Parameters >-----#
    IMB_Parameters = SEQ(name='IMB-Parameters', mode=MODE_TYPE)
    _IMB_Parameters_sub_Frame_Number = INT(name='sub-Frame-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Sub-Frame-Number')))
    _IMB_Parameters_fdd_dl_ChannelisationCodeNumber = INT(name='fdd-dl-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')), opt=True)
    _IMB_Parameters_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IMB_Parameters_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IMB_Parameters_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IMB_Parameters_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IMB_Parameters_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMB_Parameters_ie_Extensions__item__id._const_tab = ____IMB_Parameters_ie_Extensions__item__id_tab
    ___IMB_Parameters_ie_Extensions__item__id._const_tab_at = None
    ___IMB_Parameters_ie_Extensions__item__id._const_tab_id = 'id'
    ___IMB_Parameters_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IMB_Parameters_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IMB_Parameters_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMB_Parameters_ie_Extensions__item__criticality._const_tab = ____IMB_Parameters_ie_Extensions__item__criticality_tab
    ___IMB_Parameters_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IMB_Parameters_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IMB_Parameters_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IMB_Parameters_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IMB_Parameters_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMB_Parameters_ie_Extensions__item__extensionValue._const_tab = ____IMB_Parameters_ie_Extensions__item__extensionValue_tab
    ___IMB_Parameters_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IMB_Parameters_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IMB_Parameters_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___IMB_Parameters_ie_Extensions__item__id),
        ('criticality', ___IMB_Parameters_ie_Extensions__item__criticality),
        ('extensionValue', ___IMB_Parameters_ie_Extensions__item__extensionValue),
        ])
    __IMB_Parameters_ie_Extensions__item_._ext = None
    _IMB_Parameters_ie_Extensions._cont = __IMB_Parameters_ie_Extensions__item_
    _IMB_Parameters_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IMB_Parameters._cont = ASN1Dict([
        ('sub-Frame-Number', _IMB_Parameters_sub_Frame_Number),
        ('fdd-dl-ChannelisationCodeNumber', _IMB_Parameters_fdd_dl_ChannelisationCodeNumber),
        ('ie-Extensions', _IMB_Parameters_ie_Extensions),
        ])
    IMB_Parameters._ext = []
    
    #-----< IMB-Parameters-ExtIEs >-----#
    IMB_Parameters_ExtIEs = CLASS(name='IMB-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    IMB_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCH-Parameters >-----#
    BCH_Parameters = SEQ(name='BCH-Parameters', mode=MODE_TYPE)
    _BCH_Parameters_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _BCH_Parameters_bCH_Power = INT(name='bCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _BCH_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCH_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BCH_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BCH_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_Parameters_iE_Extensions__item__id._const_tab = ____BCH_Parameters_iE_Extensions__item__id_tab
    ___BCH_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___BCH_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCH_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCH_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_Parameters_iE_Extensions__item__criticality._const_tab = ____BCH_Parameters_iE_Extensions__item__criticality_tab
    ___BCH_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCH_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCH_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCH_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_Parameters_iE_Extensions__item__extensionValue._const_tab = ____BCH_Parameters_iE_Extensions__item__extensionValue_tab
    ___BCH_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCH_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCH_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCH_Parameters_iE_Extensions__item__id),
        ('criticality', ___BCH_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___BCH_Parameters_iE_Extensions__item__extensionValue),
        ])
    __BCH_Parameters_iE_Extensions__item_._ext = None
    _BCH_Parameters_iE_Extensions._cont = __BCH_Parameters_iE_Extensions__item_
    _BCH_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCH_Parameters._cont = ASN1Dict([
        ('commonTransportChannelID', _BCH_Parameters_commonTransportChannelID),
        ('bCH-Power', _BCH_Parameters_bCH_Power),
        ('iE-Extensions', _BCH_Parameters_iE_Extensions),
        ])
    BCH_Parameters._ext = []
    
    #-----< BCH-ParametersItem-ExtIEs >-----#
    BCH_ParametersItem_ExtIEs = CLASS(name='BCH-ParametersItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BCH_ParametersItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Inactivity-Threshold-for-UE-DRX-Cycle >-----#
    Inactivity_Threshold_for_UE_DRX_Cycle = ENUM(name='Inactivity-Threshold-for-UE-DRX-Cycle', mode=MODE_TYPE)
    Inactivity_Threshold_for_UE_DRX_Cycle._cont = ASN1Dict([('v0', 0), ('v1', 1), ('v2', 2), ('v4', 3), ('v8', 4), ('v16', 5), ('v32', 6), ('v64', 7), ('v128', 8), ('v256', 9), ('v512', 10)])
    Inactivity_Threshold_for_UE_DRX_Cycle._ext = None
    
    #-----< Inactivity-Threshold-for-UE-DTX-Cycle2 >-----#
    Inactivity_Threshold_for_UE_DTX_Cycle2 = ENUM(name='Inactivity-Threshold-for-UE-DTX-Cycle2', mode=MODE_TYPE)
    Inactivity_Threshold_for_UE_DTX_Cycle2._cont = ASN1Dict([('v1', 0), ('v4', 1), ('v8', 2), ('v16', 3), ('v32', 4), ('v64', 5), ('v128', 6), ('v256', 7)])
    Inactivity_Threshold_for_UE_DTX_Cycle2._ext = None
    
    #-----< Inactivity-Threshold-for-UE-Grant-Monitoring >-----#
    Inactivity_Threshold_for_UE_Grant_Monitoring = ENUM(name='Inactivity-Threshold-for-UE-Grant-Monitoring', mode=MODE_TYPE)
    Inactivity_Threshold_for_UE_Grant_Monitoring._cont = ASN1Dict([('v0', 0), ('v1', 1), ('v2', 2), ('v4', 3), ('v8', 4), ('v16', 5), ('v32', 6), ('v64', 7), ('v128', 8), ('v256', 9)])
    Inactivity_Threshold_for_UE_Grant_Monitoring._ext = None
    
    #-----< InformationReportCharacteristics >-----#
    InformationReportCharacteristics = CHOICE(name='InformationReportCharacteristics', mode=MODE_TYPE)
    _InformationReportCharacteristics_onDemand = NULL(name='onDemand', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InformationReportCharacteristics_periodic = CHOICE(name='periodic', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InformationReportCharacteristicsType-ReportPeriodicity')))
    _InformationReportCharacteristics_onModification = SEQ(name='onModification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InformationReportCharacteristicsType-OnModification')))
    InformationReportCharacteristics._cont = ASN1Dict([
        ('onDemand', _InformationReportCharacteristics_onDemand),
        ('periodic', _InformationReportCharacteristics_periodic),
        ('onModification', _InformationReportCharacteristics_onModification),
        ])
    InformationReportCharacteristics._ext = []
    
    #-----< InformationReportCharacteristicsType-ReportPeriodicity >-----#
    InformationReportCharacteristicsType_ReportPeriodicity = CHOICE(name='InformationReportCharacteristicsType-ReportPeriodicity', mode=MODE_TYPE)
    _InformationReportCharacteristicsType_ReportPeriodicity_min = INT(name='min', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportPeriodicity-Scaledmin')))
    _InformationReportCharacteristicsType_ReportPeriodicity_hours = INT(name='hours', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportPeriodicity-Scaledhour')))
    InformationReportCharacteristicsType_ReportPeriodicity._cont = ASN1Dict([
        ('min', _InformationReportCharacteristicsType_ReportPeriodicity_min),
        ('hours', _InformationReportCharacteristicsType_ReportPeriodicity_hours),
        ])
    InformationReportCharacteristicsType_ReportPeriodicity._ext = []
    
    #-----< InformationReportCharacteristicsType-OnModification >-----#
    InformationReportCharacteristicsType_OnModification = SEQ(name='InformationReportCharacteristicsType-OnModification', mode=MODE_TYPE)
    _InformationReportCharacteristicsType_OnModification_information_thresholds = CHOICE(name='information-thresholds', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InformationThresholds')), opt=True)
    _InformationReportCharacteristicsType_OnModification_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationReportCharacteristicsType_OnModification_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__id._const_tab = ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__id_tab
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__id._const_tab_at = None
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__id._const_tab_id = 'id'
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__criticality._const_tab = ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__criticality_tab
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__extensionValue._const_tab = ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__extensionValue_tab
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationReportCharacteristicsType_OnModification_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__id),
        ('criticality', ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__criticality),
        ('extensionValue', ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__extensionValue),
        ])
    __InformationReportCharacteristicsType_OnModification_ie_Extensions__item_._ext = None
    _InformationReportCharacteristicsType_OnModification_ie_Extensions._cont = __InformationReportCharacteristicsType_OnModification_ie_Extensions__item_
    _InformationReportCharacteristicsType_OnModification_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationReportCharacteristicsType_OnModification._cont = ASN1Dict([
        ('information-thresholds', _InformationReportCharacteristicsType_OnModification_information_thresholds),
        ('ie-Extensions', _InformationReportCharacteristicsType_OnModification_ie_Extensions),
        ])
    InformationReportCharacteristicsType_OnModification._ext = []
    
    #-----< InformationReportCharacteristicsType-OnModification-ExtIEs >-----#
    InformationReportCharacteristicsType_OnModification_ExtIEs = CLASS(name='InformationReportCharacteristicsType-OnModification-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    InformationReportCharacteristicsType_OnModification_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationThresholds >-----#
    InformationThresholds = CHOICE(name='InformationThresholds', mode=MODE_TYPE)
    _InformationThresholds_dgps = SEQ(name='dgps', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DGPSThresholds')))
    _InformationThresholds_dGANSSThreshold = SEQ(name='dGANSSThreshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DGANSSThreshold')))
    InformationThresholds._cont = ASN1Dict([
        ('dgps', _InformationThresholds_dgps),
        ('dGANSSThreshold', _InformationThresholds_dGANSSThreshold),
        ])
    InformationThresholds._ext = ['dGANSSThreshold']
    
    #-----< InformationExchangeID >-----#
    InformationExchangeID = INT(name='InformationExchangeID', mode=MODE_TYPE)
    InformationExchangeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< InformationType >-----#
    InformationType = SEQ(name='InformationType', mode=MODE_TYPE)
    _InformationType_information_Type_Item = ENUM(name='information-Type-Item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Information-Type-Item')))
    _InformationType_gPSInformation = SEQ_OF(name='gPSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GPS-Information')), opt=True)
    _InformationType_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___InformationType_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationType_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____InformationType_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Information')))
    _____InformationType_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DGANSS-Corrections-Req')))
    ____InformationType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 888), ('criticality', 'ignore'), ('Extension', _____InformationType_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'conditional')]), dict([('id', 969), ('criticality', 'ignore'), ('Extension', _____InformationType_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___InformationType_iE_Extensions__item__id._const_tab = ____InformationType_iE_Extensions__item__id_tab
    ___InformationType_iE_Extensions__item__id._const_tab_at = None
    ___InformationType_iE_Extensions__item__id._const_tab_id = 'id'
    ___InformationType_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___InformationType_iE_Extensions__item__criticality._const_tab = ____InformationType_iE_Extensions__item__id_tab
    ___InformationType_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationType_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InformationType_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___InformationType_iE_Extensions__item__extensionValue._const_tab = ____InformationType_iE_Extensions__item__id_tab
    ___InformationType_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationType_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationType_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___InformationType_iE_Extensions__item__id),
        ('criticality', ___InformationType_iE_Extensions__item__criticality),
        ('extensionValue', ___InformationType_iE_Extensions__item__extensionValue),
        ])
    __InformationType_iE_Extensions__item_._ext = None
    _InformationType_iE_Extensions._cont = __InformationType_iE_Extensions__item_
    _InformationType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationType._cont = ASN1Dict([
        ('information-Type-Item', _InformationType_information_Type_Item),
        ('gPSInformation', _InformationType_gPSInformation),
        ('iE-Extensions', _InformationType_iE_Extensions),
        ])
    InformationType._ext = []
    
    #-----< Information-Type-ExtIEs >-----#
    Information_Type_ExtIEs = CLASS(name='Information-Type-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Information_Type_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Information')))
    _Information_Type_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DGANSS-Corrections-Req')))
    Information_Type_ExtIEs._val = ASN1Set(rv=[dict([('id', 888), ('criticality', 'ignore'), ('Extension', _Information_Type_ExtIEs_val_Extension_0), ('presence', 'conditional')]), dict([('id', 969), ('criticality', 'ignore'), ('Extension', _Information_Type_ExtIEs_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< Information-Type-Item >-----#
    Information_Type_Item = ENUM(name='Information-Type-Item', mode=MODE_TYPE)
    Information_Type_Item._cont = ASN1Dict([('gpsinformation', 0), ('dgpscorrections', 1), ('gpsrxpos', 2), ('gANSSInformation', 3), ('dGANSSCorrections', 4), ('gANSS-RX-Pos', 5)])
    Information_Type_Item._ext = ['gANSSInformation', 'dGANSSCorrections', 'gANSS-RX-Pos']
    
    #-----< Initial-DL-DPCH-TimingAdjustment-Allowed >-----#
    Initial_DL_DPCH_TimingAdjustment_Allowed = ENUM(name='Initial-DL-DPCH-TimingAdjustment-Allowed', mode=MODE_TYPE)
    Initial_DL_DPCH_TimingAdjustment_Allowed._cont = ASN1Dict([('initial-DL-DPCH-TimingAdjustment-Allowed', 0)])
    Initial_DL_DPCH_TimingAdjustment_Allowed._ext = None
    
    #-----< InnerLoopDLPCStatus >-----#
    InnerLoopDLPCStatus = ENUM(name='InnerLoopDLPCStatus', mode=MODE_TYPE)
    InnerLoopDLPCStatus._cont = ASN1Dict([('active', 0), ('inactive', 1)])
    InnerLoopDLPCStatus._ext = None
    
    #-----< IPDL-Indicator >-----#
    IPDL_Indicator = ENUM(name='IPDL-Indicator', mode=MODE_TYPE)
    IPDL_Indicator._cont = ASN1Dict([('active', 0), ('inactive', 1)])
    IPDL_Indicator._ext = None
    
    #-----< IPDL-FDD-Parameters >-----#
    IPDL_FDD_Parameters = SEQ(name='IPDL-FDD-Parameters', mode=MODE_TYPE)
    _IPDL_FDD_Parameters_iP_SpacingFDD = ENUM(name='iP-SpacingFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPDL_FDD_Parameters_iP_SpacingFDD._cont = ASN1Dict([('sp5', 0), ('sp7', 1), ('sp10', 2), ('sp15', 3), ('sp20', 4), ('sp30', 5), ('sp40', 6), ('sp50', 7)])
    _IPDL_FDD_Parameters_iP_SpacingFDD._ext = []
    _IPDL_FDD_Parameters_iP_Length = ENUM(name='iP-Length', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPDL_FDD_Parameters_iP_Length._cont = ASN1Dict([('len5', 0), ('len10', 1)])
    _IPDL_FDD_Parameters_iP_Length._ext = None
    _IPDL_FDD_Parameters_seed = INT(name='seed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPDL_FDD_Parameters_seed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _IPDL_FDD_Parameters_burstModeParams = SEQ(name='burstModeParams', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BurstModeParams')), opt=True)
    _IPDL_FDD_Parameters_iP_Offset = INT(name='iP-Offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPDL_FDD_Parameters_iP_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _IPDL_FDD_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDL_FDD_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IPDL_FDD_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IPDL_FDD_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDL_FDD_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_FDD_Parameters_iE_Extensions__item__id._const_tab = ____IPDL_FDD_Parameters_iE_Extensions__item__id_tab
    ___IPDL_FDD_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___IPDL_FDD_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPDL_FDD_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPDL_FDD_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDL_FDD_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_FDD_Parameters_iE_Extensions__item__criticality._const_tab = ____IPDL_FDD_Parameters_iE_Extensions__item__criticality_tab
    ___IPDL_FDD_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPDL_FDD_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPDL_FDD_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDL_FDD_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue._const_tab = ____IPDL_FDD_Parameters_iE_Extensions__item__extensionValue_tab
    ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPDL_FDD_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPDL_FDD_Parameters_iE_Extensions__item__id),
        ('criticality', ___IPDL_FDD_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue),
        ])
    __IPDL_FDD_Parameters_iE_Extensions__item_._ext = None
    _IPDL_FDD_Parameters_iE_Extensions._cont = __IPDL_FDD_Parameters_iE_Extensions__item_
    _IPDL_FDD_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDL_FDD_Parameters._cont = ASN1Dict([
        ('iP-SpacingFDD', _IPDL_FDD_Parameters_iP_SpacingFDD),
        ('iP-Length', _IPDL_FDD_Parameters_iP_Length),
        ('seed', _IPDL_FDD_Parameters_seed),
        ('burstModeParams', _IPDL_FDD_Parameters_burstModeParams),
        ('iP-Offset', _IPDL_FDD_Parameters_iP_Offset),
        ('iE-Extensions', _IPDL_FDD_Parameters_iE_Extensions),
        ])
    IPDL_FDD_Parameters._ext = []
    
    #-----< IPDLFDDParameter-ExtIEs >-----#
    IPDLFDDParameter_ExtIEs = CLASS(name='IPDLFDDParameter-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    IPDLFDDParameter_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPDL-TDD-Parameters >-----#
    IPDL_TDD_Parameters = SEQ(name='IPDL-TDD-Parameters', mode=MODE_TYPE)
    _IPDL_TDD_Parameters_iP_SpacingTDD = ENUM(name='iP-SpacingTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPDL_TDD_Parameters_iP_SpacingTDD._cont = ASN1Dict([('sp30', 0), ('sp40', 1), ('sp50', 2), ('sp70', 3), ('sp100', 4)])
    _IPDL_TDD_Parameters_iP_SpacingTDD._ext = []
    _IPDL_TDD_Parameters_iP_Start = INT(name='iP-Start', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPDL_TDD_Parameters_iP_Start._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _IPDL_TDD_Parameters_iP_Slot = INT(name='iP-Slot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPDL_TDD_Parameters_iP_Slot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    _IPDL_TDD_Parameters_iP_PCCPCH = ENUM(name='iP-PCCPCH', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPDL_TDD_Parameters_iP_PCCPCH._cont = ASN1Dict([('switchOff-1-Frame', 0), ('switchOff-2-Frames', 1)])
    _IPDL_TDD_Parameters_iP_PCCPCH._ext = None
    _IPDL_TDD_Parameters_burstModeParams = SEQ(name='burstModeParams', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BurstModeParams')), opt=True)
    _IPDL_TDD_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDL_TDD_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IPDL_TDD_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IPDL_TDD_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_Parameters_iE_Extensions__item__id._const_tab = ____IPDL_TDD_Parameters_iE_Extensions__item__id_tab
    ___IPDL_TDD_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___IPDL_TDD_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPDL_TDD_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPDL_TDD_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_Parameters_iE_Extensions__item__criticality._const_tab = ____IPDL_TDD_Parameters_iE_Extensions__item__criticality_tab
    ___IPDL_TDD_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPDL_TDD_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPDL_TDD_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue._const_tab = ____IPDL_TDD_Parameters_iE_Extensions__item__extensionValue_tab
    ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPDL_TDD_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPDL_TDD_Parameters_iE_Extensions__item__id),
        ('criticality', ___IPDL_TDD_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue),
        ])
    __IPDL_TDD_Parameters_iE_Extensions__item_._ext = None
    _IPDL_TDD_Parameters_iE_Extensions._cont = __IPDL_TDD_Parameters_iE_Extensions__item_
    _IPDL_TDD_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDL_TDD_Parameters._cont = ASN1Dict([
        ('iP-SpacingTDD', _IPDL_TDD_Parameters_iP_SpacingTDD),
        ('iP-Start', _IPDL_TDD_Parameters_iP_Start),
        ('iP-Slot', _IPDL_TDD_Parameters_iP_Slot),
        ('iP-PCCPCH', _IPDL_TDD_Parameters_iP_PCCPCH),
        ('burstModeParams', _IPDL_TDD_Parameters_burstModeParams),
        ('iE-Extensions', _IPDL_TDD_Parameters_iE_Extensions),
        ])
    IPDL_TDD_Parameters._ext = []
    
    #-----< IPDL-TDD-Parameters-LCR >-----#
    IPDL_TDD_Parameters_LCR = SEQ(name='IPDL-TDD-Parameters-LCR', mode=MODE_TYPE)
    _IPDL_TDD_Parameters_LCR_iP_SpacingTDD = ENUM(name='iP-SpacingTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPDL_TDD_Parameters_LCR_iP_SpacingTDD._cont = ASN1Dict([('sp30', 0), ('sp40', 1), ('sp50', 2), ('sp70', 3), ('sp100', 4)])
    _IPDL_TDD_Parameters_LCR_iP_SpacingTDD._ext = []
    _IPDL_TDD_Parameters_LCR_iP_Start = INT(name='iP-Start', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPDL_TDD_Parameters_LCR_iP_Start._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _IPDL_TDD_Parameters_LCR_iP_Sub = ENUM(name='iP-Sub', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPDL_TDD_Parameters_LCR_iP_Sub._cont = ASN1Dict([('first', 0), ('second', 1), ('both', 2)])
    _IPDL_TDD_Parameters_LCR_iP_Sub._ext = None
    _IPDL_TDD_Parameters_LCR_burstModeParams = SEQ(name='burstModeParams', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BurstModeParams')), opt=True)
    _IPDL_TDD_Parameters_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDL_TDD_Parameters_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__id._const_tab = ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__id_tab
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__id._const_tab_at = None
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__criticality._const_tab = ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__criticality_tab
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__extensionValue._const_tab = ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__extensionValue_tab
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPDL_TDD_Parameters_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__id),
        ('criticality', ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__extensionValue),
        ])
    __IPDL_TDD_Parameters_LCR_iE_Extensions__item_._ext = None
    _IPDL_TDD_Parameters_LCR_iE_Extensions._cont = __IPDL_TDD_Parameters_LCR_iE_Extensions__item_
    _IPDL_TDD_Parameters_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDL_TDD_Parameters_LCR._cont = ASN1Dict([
        ('iP-SpacingTDD', _IPDL_TDD_Parameters_LCR_iP_SpacingTDD),
        ('iP-Start', _IPDL_TDD_Parameters_LCR_iP_Start),
        ('iP-Sub', _IPDL_TDD_Parameters_LCR_iP_Sub),
        ('burstModeParams', _IPDL_TDD_Parameters_LCR_burstModeParams),
        ('iE-Extensions', _IPDL_TDD_Parameters_LCR_iE_Extensions),
        ])
    IPDL_TDD_Parameters_LCR._ext = []
    
    #-----< IPMulticastIndication >-----#
    IPMulticastIndication = SEQ(name='IPMulticastIndication', mode=MODE_TYPE)
    _IPMulticastIndication_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _IPMulticastIndication_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _IPMulticastIndication_cFNOffset = INT(name='cFNOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPMulticastIndication_cFNOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _IPMulticastIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPMulticastIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IPMulticastIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IPMulticastIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPMulticastIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPMulticastIndication_iE_Extensions__item__id._const_tab = ____IPMulticastIndication_iE_Extensions__item__id_tab
    ___IPMulticastIndication_iE_Extensions__item__id._const_tab_at = None
    ___IPMulticastIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPMulticastIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPMulticastIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPMulticastIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPMulticastIndication_iE_Extensions__item__criticality._const_tab = ____IPMulticastIndication_iE_Extensions__item__criticality_tab
    ___IPMulticastIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPMulticastIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPMulticastIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPMulticastIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPMulticastIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPMulticastIndication_iE_Extensions__item__extensionValue._const_tab = ____IPMulticastIndication_iE_Extensions__item__extensionValue_tab
    ___IPMulticastIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPMulticastIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPMulticastIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPMulticastIndication_iE_Extensions__item__id),
        ('criticality', ___IPMulticastIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___IPMulticastIndication_iE_Extensions__item__extensionValue),
        ])
    __IPMulticastIndication_iE_Extensions__item_._ext = None
    _IPMulticastIndication_iE_Extensions._cont = __IPMulticastIndication_iE_Extensions__item_
    _IPMulticastIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPMulticastIndication._cont = ASN1Dict([
        ('transportLayerAddress', _IPMulticastIndication_transportLayerAddress),
        ('bindingID', _IPMulticastIndication_bindingID),
        ('cFNOffset', _IPMulticastIndication_cFNOffset),
        ('iE-Extensions', _IPMulticastIndication_iE_Extensions),
        ])
    IPMulticastIndication._ext = []
    
    #-----< IPMulticastIndication-ExtIEs >-----#
    IPMulticastIndication_ExtIEs = CLASS(name='IPMulticastIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    IPMulticastIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPMulticastDataBearerIndication >-----#
    IPMulticastDataBearerIndication = BOOL(name='IPMulticastDataBearerIndication', mode=MODE_TYPE)
    
    #-----< BurstModeParams >-----#
    BurstModeParams = SEQ(name='BurstModeParams', mode=MODE_TYPE)
    _BurstModeParams_burstStart = INT(name='burstStart', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BurstModeParams_burstStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _BurstModeParams_burstLength = INT(name='burstLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BurstModeParams_burstLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10, ub=25)], ev=None, er=[])
    _BurstModeParams_burstFreq = INT(name='burstFreq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BurstModeParams_burstFreq._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    BurstModeParams._cont = ASN1Dict([
        ('burstStart', _BurstModeParams_burstStart),
        ('burstLength', _BurstModeParams_burstLength),
        ('burstFreq', _BurstModeParams_burstFreq),
        ])
    BurstModeParams._ext = []
    
    #-----< IPDLTDDParameter-ExtIEs >-----#
    IPDLTDDParameter_ExtIEs = CLASS(name='IPDLTDDParameter-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    IPDLTDDParameter_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPDLTDDParameterLCR-ExtIEs >-----#
    IPDLTDDParameterLCR_ExtIEs = CLASS(name='IPDLTDDParameterLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    IPDLTDDParameterLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IdleIntervalInformation >-----#
    IdleIntervalInformation = SEQ(name='IdleIntervalInformation', mode=MODE_TYPE)
    _IdleIntervalInformation_idleIntervalInfo_k = INT(name='idleIntervalInfo-k', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IdleIntervalInformation_idleIntervalInfo_k._cont = ASN1Dict([('none', 0), ('two', 2), ('three', 3)])
    _IdleIntervalInformation_idleIntervalInfo_k._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _IdleIntervalInformation_idleIntervalInfo_offset = INT(name='idleIntervalInfo-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IdleIntervalInformation_idleIntervalInfo_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    IdleIntervalInformation._cont = ASN1Dict([
        ('idleIntervalInfo-k', _IdleIntervalInformation_idleIntervalInfo_k),
        ('idleIntervalInfo-offset', _IdleIntervalInformation_idleIntervalInfo_offset),
        ])
    IdleIntervalInformation._ext = []
    
    #-----< In-Sync-Information-LCR >-----#
    In_Sync_Information_LCR = SEQ(name='In-Sync-Information-LCR', mode=MODE_TYPE)
    _In_Sync_Information_LCR_t312 = INT(name='t312', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _In_Sync_Information_LCR_t312._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _In_Sync_Information_LCR_n312 = ENUM(name='n312', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _In_Sync_Information_LCR_n312._cont = ASN1Dict([('s1', 0), ('s2', 1), ('s4', 2), ('s10', 3), ('s20', 4), ('s50', 5), ('s100', 6), ('s200', 7), ('s400', 8), ('s600', 9), ('s800', 10), ('s1000', 11)])
    _In_Sync_Information_LCR_n312._ext = None
    In_Sync_Information_LCR._cont = ASN1Dict([
        ('t312', _In_Sync_Information_LCR_t312),
        ('n312', _In_Sync_Information_LCR_n312),
        ])
    In_Sync_Information_LCR._ext = []
    
    #-----< LimitedPowerIncrease >-----#
    LimitedPowerIncrease = ENUM(name='LimitedPowerIncrease', mode=MODE_TYPE)
    LimitedPowerIncrease._cont = ASN1Dict([('used', 0), ('not-used', 1)])
    LimitedPowerIncrease._ext = None
    
    #-----< Local-Cell-ID >-----#
    Local_Cell_ID = INT(name='Local-Cell-ID', mode=MODE_TYPE)
    Local_Cell_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268435455)], ev=None, er=[])
    
    #-----< LTGI-Presence >-----#
    LTGI_Presence = BOOL(name='LTGI-Presence', mode=MODE_TYPE)
    
    #-----< LCRTDD-Uplink-Physical-Channel-Capability >-----#
    LCRTDD_Uplink_Physical_Channel_Capability = SEQ(name='LCRTDD-Uplink-Physical-Channel-Capability', mode=MODE_TYPE)
    _LCRTDD_Uplink_Physical_Channel_Capability_maxTimeslotsPerSubFrame = INT(name='maxTimeslotsPerSubFrame', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCRTDD_Uplink_Physical_Channel_Capability_maxTimeslotsPerSubFrame._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    _LCRTDD_Uplink_Physical_Channel_Capability_maxPhysChPerTimeslot = ENUM(name='maxPhysChPerTimeslot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCRTDD_Uplink_Physical_Channel_Capability_maxPhysChPerTimeslot._cont = ASN1Dict([('one', 0), ('two', 1), ('three', 2), ('four', 3)])
    _LCRTDD_Uplink_Physical_Channel_Capability_maxPhysChPerTimeslot._ext = ['three', 'four']
    _LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id._const_tab = ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id_tab
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id._const_tab_at = None
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id._const_tab_id = 'id'
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality._const_tab = ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality_tab
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue._const_tab = ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue_tab
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id),
        ('criticality', ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality),
        ('extensionValue', ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue),
        ])
    __LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item_._ext = None
    _LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions._cont = __LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item_
    _LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LCRTDD_Uplink_Physical_Channel_Capability._cont = ASN1Dict([
        ('maxTimeslotsPerSubFrame', _LCRTDD_Uplink_Physical_Channel_Capability_maxTimeslotsPerSubFrame),
        ('maxPhysChPerTimeslot', _LCRTDD_Uplink_Physical_Channel_Capability_maxPhysChPerTimeslot),
        ('iE-Extensions', _LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions),
        ])
    LCRTDD_Uplink_Physical_Channel_Capability._ext = []
    
    #-----< LCRTDD-Uplink-Physical-Channel-Capability-ExtIEs >-----#
    LCRTDD_Uplink_Physical_Channel_Capability_ExtIEs = CLASS(name='LCRTDD-Uplink-Physical-Channel-Capability-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    LCRTDD_Uplink_Physical_Channel_Capability_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MAC-DTX-Cycle-2ms >-----#
    MAC_DTX_Cycle_2ms = ENUM(name='MAC-DTX-Cycle-2ms', mode=MODE_TYPE)
    MAC_DTX_Cycle_2ms._cont = ASN1Dict([('v1', 0), ('v4', 1), ('v5', 2), ('v8', 3), ('v10', 4), ('v16', 5), ('v20', 6)])
    MAC_DTX_Cycle_2ms._ext = None
    
    #-----< MAC-DTX-Cycle-10ms >-----#
    MAC_DTX_Cycle_10ms = ENUM(name='MAC-DTX-Cycle-10ms', mode=MODE_TYPE)
    MAC_DTX_Cycle_10ms._cont = ASN1Dict([('v5', 0), ('v10', 1), ('v20', 2)])
    MAC_DTX_Cycle_10ms._ext = None
    
    #-----< MAC-ehs-Reset-Timer >-----#
    MAC_ehs_Reset_Timer = ENUM(name='MAC-ehs-Reset-Timer', mode=MODE_TYPE)
    MAC_ehs_Reset_Timer._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v3', 2), ('v4', 3)])
    MAC_ehs_Reset_Timer._ext = []
    
    #-----< MACdPDU-Size >-----#
    MACdPDU_Size = INT(name='MACdPDU-Size', mode=MODE_TYPE)
    MACdPDU_Size._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5000)], ev=[], er=[])
    
    #-----< MAC-PDU-SizeExtended >-----#
    MAC_PDU_SizeExtended = INT(name='MAC-PDU-SizeExtended', mode=MODE_TYPE)
    MAC_PDU_SizeExtended._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1504)], ev=[1505], er=[])
    
    #-----< MAC-Inactivity-Threshold >-----#
    MAC_Inactivity_Threshold = ENUM(name='MAC-Inactivity-Threshold', mode=MODE_TYPE)
    MAC_Inactivity_Threshold._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v4', 2), ('v8', 3), ('v16', 4), ('v32', 5), ('v64', 6), ('v128', 7), ('v256', 8), ('v512', 9), ('infinity', 10)])
    MAC_Inactivity_Threshold._ext = None
    
    #-----< MACdPDU-Size-Indexlist >-----#
    MACdPDU_Size_Indexlist = SEQ_OF(name='MACdPDU-Size-Indexlist', mode=MODE_TYPE)
    _MACdPDU_Size_Indexlist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MACdPDU-Size-IndexItem')))
    MACdPDU_Size_Indexlist._cont = _MACdPDU_Size_Indexlist__item_
    MACdPDU_Size_Indexlist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MACdPDU-Size-IndexItem >-----#
    MACdPDU_Size_IndexItem = SEQ(name='MACdPDU-Size-IndexItem', mode=MODE_TYPE)
    _MACdPDU_Size_IndexItem_sID = INT(name='sID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SID')))
    _MACdPDU_Size_IndexItem_macdPDU_Size = INT(name='macdPDU-Size', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MACdPDU-Size')))
    _MACdPDU_Size_IndexItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MACdPDU_Size_IndexItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__id._const_tab = ____MACdPDU_Size_IndexItem_iE_Extensions__item__id_tab
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__id._const_tab_at = None
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality._const_tab = ____MACdPDU_Size_IndexItem_iE_Extensions__item__criticality_tab
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue._const_tab = ____MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue_tab
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MACdPDU_Size_IndexItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MACdPDU_Size_IndexItem_iE_Extensions__item__id),
        ('criticality', ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue),
        ])
    __MACdPDU_Size_IndexItem_iE_Extensions__item_._ext = None
    _MACdPDU_Size_IndexItem_iE_Extensions._cont = __MACdPDU_Size_IndexItem_iE_Extensions__item_
    _MACdPDU_Size_IndexItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MACdPDU_Size_IndexItem._cont = ASN1Dict([
        ('sID', _MACdPDU_Size_IndexItem_sID),
        ('macdPDU-Size', _MACdPDU_Size_IndexItem_macdPDU_Size),
        ('iE-Extensions', _MACdPDU_Size_IndexItem_iE_Extensions),
        ])
    MACdPDU_Size_IndexItem._ext = []
    
    #-----< MACdPDU-Size-IndexItem-ExtIEs >-----#
    MACdPDU_Size_IndexItem_ExtIEs = CLASS(name='MACdPDU-Size-IndexItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MACdPDU_Size_IndexItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MACdPDU-Size-Indexlist-to-Modify >-----#
    MACdPDU_Size_Indexlist_to_Modify = SEQ_OF(name='MACdPDU-Size-Indexlist-to-Modify', mode=MODE_TYPE)
    _MACdPDU_Size_Indexlist_to_Modify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MACdPDU-Size-IndexItem-to-Modify')))
    MACdPDU_Size_Indexlist_to_Modify._cont = _MACdPDU_Size_Indexlist_to_Modify__item_
    MACdPDU_Size_Indexlist_to_Modify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MACdPDU-Size-IndexItem-to-Modify >-----#
    MACdPDU_Size_IndexItem_to_Modify = SEQ(name='MACdPDU-Size-IndexItem-to-Modify', mode=MODE_TYPE)
    _MACdPDU_Size_IndexItem_to_Modify_sID = INT(name='sID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SID')))
    _MACdPDU_Size_IndexItem_to_Modify_macdPDU_Size = INT(name='macdPDU-Size', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MACdPDU-Size')))
    _MACdPDU_Size_IndexItem_to_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id._const_tab = ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id_tab
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality._const_tab = ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality_tab
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue_tab
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id),
        ('criticality', ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item_._ext = None
    _MACdPDU_Size_IndexItem_to_Modify_iE_Extensions._cont = __MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item_
    _MACdPDU_Size_IndexItem_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MACdPDU_Size_IndexItem_to_Modify._cont = ASN1Dict([
        ('sID', _MACdPDU_Size_IndexItem_to_Modify_sID),
        ('macdPDU-Size', _MACdPDU_Size_IndexItem_to_Modify_macdPDU_Size),
        ('iE-Extensions', _MACdPDU_Size_IndexItem_to_Modify_iE_Extensions),
        ])
    MACdPDU_Size_IndexItem_to_Modify._ext = []
    
    #-----< MACdPDU-Size-IndexItem-to-Modify-ExtIEs >-----#
    MACdPDU_Size_IndexItem_to_Modify_ExtIEs = CLASS(name='MACdPDU-Size-IndexItem-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MACdPDU_Size_IndexItem_to_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MACesGuaranteedBitRate >-----#
    MACesGuaranteedBitRate = INT(name='MACesGuaranteedBitRate', mode=MODE_TYPE)
    MACesGuaranteedBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=[], er=[ASN1RangeInt(lb=16777216, ub=256000000)])
    
    #-----< MACes-Maximum-Bitrate-LCR >-----#
    MACes_Maximum_Bitrate_LCR = INT(name='MACes-Maximum-Bitrate-LCR', mode=MODE_TYPE)
    MACes_Maximum_Bitrate_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256000000)], ev=[], er=[])
    
    #-----< MACeReset-Indicator >-----#
    MACeReset_Indicator = ENUM(name='MACeReset-Indicator', mode=MODE_TYPE)
    MACeReset_Indicator._cont = ASN1Dict([('mACeReset', 0)])
    MACeReset_Indicator._ext = None
    
    #-----< MAChsGuaranteedBitRate >-----#
    MAChsGuaranteedBitRate = INT(name='MAChsGuaranteedBitRate', mode=MODE_TYPE)
    MAChsGuaranteedBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=[], er=[ASN1RangeInt(lb=16777216, ub=1000000000)])
    
    #-----< MAChsReorderingBufferSize-for-RLC-UM >-----#
    MAChsReorderingBufferSize_for_RLC_UM = INT(name='MAChsReorderingBufferSize-for-RLC-UM', mode=MODE_TYPE)
    MAChsReorderingBufferSize_for_RLC_UM._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=300)], ev=[], er=[])
    
    #-----< MAC-hsWindowSize >-----#
    MAC_hsWindowSize = ENUM(name='MAC-hsWindowSize', mode=MODE_TYPE)
    MAC_hsWindowSize._cont = ASN1Dict([('v4', 0), ('v6', 1), ('v8', 2), ('v12', 3), ('v16', 4), ('v24', 5), ('v32', 6), ('v64', 7), ('v128', 8), ('v256', 9)])
    MAC_hsWindowSize._ext = ['v64', 'v128', 'v256']
    
    #-----< MAChsResetScheme >-----#
    MAChsResetScheme = ENUM(name='MAChsResetScheme', mode=MODE_TYPE)
    MAChsResetScheme._cont = ASN1Dict([('always', 0), ('interNodeB-change', 1)])
    MAChsResetScheme._ext = None
    
    #-----< MaximumDL-PowerCapability >-----#
    MaximumDL_PowerCapability = INT(name='MaximumDL-PowerCapability', mode=MODE_TYPE)
    MaximumDL_PowerCapability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=500)], ev=None, er=[])
    
    #-----< Max-Bits-MACe-PDU-non-scheduled >-----#
    Max_Bits_MACe_PDU_non_scheduled = INT(name='Max-Bits-MACe-PDU-non-scheduled', mode=MODE_TYPE)
    Max_Bits_MACe_PDU_non_scheduled._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=19982)], ev=None, er=[])
    
    #-----< Max-EDCH-Resource-Allocation-for-CCCH >-----#
    Max_EDCH_Resource_Allocation_for_CCCH = ENUM(name='Max-EDCH-Resource-Allocation-for-CCCH', mode=MODE_TYPE)
    Max_EDCH_Resource_Allocation_for_CCCH._cont = ASN1Dict([('v8', 0), ('v12', 1), ('v16', 2), ('v24', 3), ('v32', 4), ('v40', 5), ('v80', 6), ('v120', 7), ('v20', 8)])
    Max_EDCH_Resource_Allocation_for_CCCH._ext = ['v20']
    
    #-----< Max-EDCH-Resource-Allocation-for-CCCH-Extension >-----#
    Max_EDCH_Resource_Allocation_for_CCCH_Extension = ENUM(name='Max-EDCH-Resource-Allocation-for-CCCH-Extension', mode=MODE_TYPE)
    Max_EDCH_Resource_Allocation_for_CCCH_Extension._cont = ASN1Dict([('v8', 0), ('v12', 1), ('v16', 2), ('v20', 3), ('v24', 4), ('v32', 5), ('v40', 6), ('v80', 7)])
    Max_EDCH_Resource_Allocation_for_CCCH_Extension._ext = []
    
    #-----< Max-Period-for-Collision-Resolution >-----#
    Max_Period_for_Collision_Resolution = INT(name='Max-Period-for-Collision-Resolution', mode=MODE_TYPE)
    Max_Period_for_Collision_Resolution._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=24)], ev=[], er=[])
    
    #-----< Max-TB-Sizes >-----#
    Max_TB_Sizes = SEQ(name='Max-TB-Sizes', mode=MODE_TYPE)
    _Max_TB_Sizes_maximum_TB_Size_cell_edge_users = INT(name='maximum-TB-Size-cell-edge-users', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Max_TB_Sizes_maximum_TB_Size_cell_edge_users._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5000)], ev=[], er=[])
    _Max_TB_Sizes_maximum_TB_Size_other_users = INT(name='maximum-TB-Size-other-users', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Max_TB_Sizes_maximum_TB_Size_other_users._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5000)], ev=[], er=[])
    _Max_TB_Sizes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Max_TB_Sizes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Max_TB_Sizes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Max_TB_Sizes_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Max_TB_Sizes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Max_TB_Sizes_iE_Extensions__item__id._const_tab = ____Max_TB_Sizes_iE_Extensions__item__id_tab
    ___Max_TB_Sizes_iE_Extensions__item__id._const_tab_at = None
    ___Max_TB_Sizes_iE_Extensions__item__id._const_tab_id = 'id'
    ___Max_TB_Sizes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Max_TB_Sizes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Max_TB_Sizes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Max_TB_Sizes_iE_Extensions__item__criticality._const_tab = ____Max_TB_Sizes_iE_Extensions__item__criticality_tab
    ___Max_TB_Sizes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Max_TB_Sizes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Max_TB_Sizes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Max_TB_Sizes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Max_TB_Sizes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Max_TB_Sizes_iE_Extensions__item__extensionValue._const_tab = ____Max_TB_Sizes_iE_Extensions__item__extensionValue_tab
    ___Max_TB_Sizes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Max_TB_Sizes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Max_TB_Sizes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Max_TB_Sizes_iE_Extensions__item__id),
        ('criticality', ___Max_TB_Sizes_iE_Extensions__item__criticality),
        ('extensionValue', ___Max_TB_Sizes_iE_Extensions__item__extensionValue),
        ])
    __Max_TB_Sizes_iE_Extensions__item_._ext = None
    _Max_TB_Sizes_iE_Extensions._cont = __Max_TB_Sizes_iE_Extensions__item_
    _Max_TB_Sizes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Max_TB_Sizes._cont = ASN1Dict([
        ('maximum-TB-Size-cell-edge-users', _Max_TB_Sizes_maximum_TB_Size_cell_edge_users),
        ('maximum-TB-Size-other-users', _Max_TB_Sizes_maximum_TB_Size_other_users),
        ('iE-Extensions', _Max_TB_Sizes_iE_Extensions),
        ])
    Max_TB_Sizes._ext = []
    
    #-----< Max-TB-Sizes-ExtIEs >-----#
    Max_TB_Sizes_ExtIEs = CLASS(name='Max-TB-Sizes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Max_TB_Sizes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Maximum-Number-of-Retransmissions-For-E-DCH >-----#
    Maximum_Number_of_Retransmissions_For_E_DCH = INT(name='Maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE)
    Maximum_Number_of_Retransmissions_For_E_DCH._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< Maximum-Target-ReceivedTotalWideBandPower-LCR >-----#
    Maximum_Target_ReceivedTotalWideBandPower_LCR = INT(name='Maximum-Target-ReceivedTotalWideBandPower-LCR', mode=MODE_TYPE)
    Maximum_Target_ReceivedTotalWideBandPower_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=621)], ev=None, er=[])
    
    #-----< MaximumTransmissionPower >-----#
    MaximumTransmissionPower = INT(name='MaximumTransmissionPower', mode=MODE_TYPE)
    MaximumTransmissionPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=500)], ev=None, er=[])
    
    #-----< MaxNrOfUL-DPDCHs >-----#
    MaxNrOfUL_DPDCHs = INT(name='MaxNrOfUL-DPDCHs', mode=MODE_TYPE)
    MaxNrOfUL_DPDCHs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< MaxPRACH-MidambleShifts >-----#
    MaxPRACH_MidambleShifts = ENUM(name='MaxPRACH-MidambleShifts', mode=MODE_TYPE)
    MaxPRACH_MidambleShifts._cont = ASN1Dict([('shift4', 0), ('shift8', 1), ('shift16', 2)])
    MaxPRACH_MidambleShifts._ext = ['shift16']
    
    #-----< Max-Set-E-DPDCHs >-----#
    Max_Set_E_DPDCHs = ENUM(name='Max-Set-E-DPDCHs', mode=MODE_TYPE)
    Max_Set_E_DPDCHs._cont = ASN1Dict([('vN256', 0), ('vN128', 1), ('vN64', 2), ('vN32', 3), ('vN16', 4), ('vN8', 5), ('vN4', 6), ('v2xN4', 7), ('v2xN2', 8), ('v2xN2plus2xN4', 9), ('v2xM2plus2xM4', 10)])
    Max_Set_E_DPDCHs._ext = ['v2xM2plus2xM4']
    
    #-----< Max-UE-DTX-Cycle >-----#
    Max_UE_DTX_Cycle = ENUM(name='Max-UE-DTX-Cycle', mode=MODE_TYPE)
    Max_UE_DTX_Cycle._cont = ASN1Dict([('v5', 0), ('v10', 1), ('v20', 2), ('v40', 3), ('v64', 4), ('v80', 5), ('v128', 6), ('v160', 7), ('v256', 8), ('v320', 9), ('v512', 10), ('v640', 11), ('v1024', 12), ('v1280', 13)])
    Max_UE_DTX_Cycle._ext = ['v256', 'v320', 'v512', 'v640', 'v1024', 'v1280']
    
    #-----< MBMS-Capability >-----#
    MBMS_Capability = ENUM(name='MBMS-Capability', mode=MODE_TYPE)
    MBMS_Capability._cont = ASN1Dict([('mbms-capable', 0), ('mbms-non-capable', 1)])
    MBMS_Capability._ext = None
    
    #-----< MeasurementFilterCoefficient >-----#
    MeasurementFilterCoefficient = ENUM(name='MeasurementFilterCoefficient', mode=MODE_TYPE)
    MeasurementFilterCoefficient._cont = ASN1Dict([('k0', 0), ('k1', 1), ('k2', 2), ('k3', 3), ('k4', 4), ('k5', 5), ('k6', 6), ('k7', 7), ('k8', 8), ('k9', 9), ('k11', 10), ('k13', 11), ('k15', 12), ('k17', 13), ('k19', 14)])
    MeasurementFilterCoefficient._ext = []
    
    #-----< MeasurementID >-----#
    MeasurementID = INT(name='MeasurementID', mode=MODE_TYPE)
    MeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< Measurement-Power-Offset >-----#
    Measurement_Power_Offset = INT(name='Measurement-Power-Offset', mode=MODE_TYPE)
    Measurement_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-12, ub=26)], ev=None, er=[])
    
    #-----< MeasurementRecoveryBehavior >-----#
    MeasurementRecoveryBehavior = NULL(name='MeasurementRecoveryBehavior', mode=MODE_TYPE)
    
    #-----< MeasurementRecoveryReportingIndicator >-----#
    MeasurementRecoveryReportingIndicator = NULL(name='MeasurementRecoveryReportingIndicator', mode=MODE_TYPE)
    
    #-----< MeasurementRecoverySupportIndicator >-----#
    MeasurementRecoverySupportIndicator = NULL(name='MeasurementRecoverySupportIndicator', mode=MODE_TYPE)
    
    #-----< MessageStructure >-----#
    MessageStructure = SEQ_OF(name='MessageStructure', mode=MODE_TYPE)
    _MessageStructure__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __MessageStructure__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProtocolIE-ID')))
    __MessageStructure__item__repetitionNumber = INT(name='repetitionNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionNumber1')), opt=True)
    __MessageStructure__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___MessageStructure__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____MessageStructure__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____MessageStructure__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__id._const_tab = _____MessageStructure__item__iE_Extensions__item__id_tab
    ____MessageStructure__item__iE_Extensions__item__id._const_tab_at = None
    ____MessageStructure__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____MessageStructure__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____MessageStructure__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab = _____MessageStructure__item__iE_Extensions__item__criticality_tab
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____MessageStructure__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____MessageStructure__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab = _____MessageStructure__item__iE_Extensions__item__extensionValue_tab
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___MessageStructure__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____MessageStructure__item__iE_Extensions__item__id),
        ('criticality', ____MessageStructure__item__iE_Extensions__item__criticality),
        ('extensionValue', ____MessageStructure__item__iE_Extensions__item__extensionValue),
        ])
    ___MessageStructure__item__iE_Extensions__item_._ext = None
    __MessageStructure__item__iE_Extensions._cont = ___MessageStructure__item__iE_Extensions__item_
    __MessageStructure__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _MessageStructure__item_._cont = ASN1Dict([
        ('iE-ID', __MessageStructure__item__iE_ID),
        ('repetitionNumber', __MessageStructure__item__repetitionNumber),
        ('iE-Extensions', __MessageStructure__item__iE_Extensions),
        ])
    _MessageStructure__item_._ext = []
    MessageStructure._cont = _MessageStructure__item_
    MessageStructure._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MessageStructure-ExtIEs >-----#
    MessageStructure_ExtIEs = CLASS(name='MessageStructure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MessageStructure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MICH-CFN >-----#
    MICH_CFN = INT(name='MICH-CFN', mode=MODE_TYPE)
    MICH_CFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< MICH-Mode >-----#
    MICH_Mode = ENUM(name='MICH-Mode', mode=MODE_TYPE)
    MICH_Mode._cont = ASN1Dict([('v18', 0), ('v36', 1), ('v72', 2), ('v144', 3), ('v16', 4), ('v32', 5), ('v64', 6), ('v128', 7)])
    MICH_Mode._ext = ['v16', 'v32', 'v64', 'v128']
    
    #-----< MidambleConfigurationLCR >-----#
    MidambleConfigurationLCR = ENUM(name='MidambleConfigurationLCR', mode=MODE_TYPE)
    MidambleConfigurationLCR._cont = ASN1Dict([('v2', 0), ('v4', 1), ('v6', 2), ('v8', 3), ('v10', 4), ('v12', 5), ('v14', 6), ('v16', 7)])
    MidambleConfigurationLCR._ext = []
    
    #-----< MidambleConfigurationBurstType1And3 >-----#
    MidambleConfigurationBurstType1And3 = ENUM(name='MidambleConfigurationBurstType1And3', mode=MODE_TYPE)
    MidambleConfigurationBurstType1And3._cont = ASN1Dict([('v4', 0), ('v8', 1), ('v16', 2)])
    MidambleConfigurationBurstType1And3._ext = None
    
    #-----< MidambleConfigurationBurstType2 >-----#
    MidambleConfigurationBurstType2 = ENUM(name='MidambleConfigurationBurstType2', mode=MODE_TYPE)
    MidambleConfigurationBurstType2._cont = ASN1Dict([('v3', 0), ('v6', 1)])
    MidambleConfigurationBurstType2._ext = None
    
    #-----< MidambleShiftAndBurstType >-----#
    MidambleShiftAndBurstType = CHOICE(name='MidambleShiftAndBurstType', mode=MODE_TYPE)
    _MidambleShiftAndBurstType_type1 = SEQ(name='type1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType_type1_midambleConfigurationBurstType1And3 = ENUM(name='midambleConfigurationBurstType1And3', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleConfigurationBurstType1And3')))
    __MidambleShiftAndBurstType_type1_midambleAllocationMode = CHOICE(name='midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType_type1_midambleAllocationMode_defaultMidamble = NULL(name='defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type1_midambleAllocationMode_commonMidamble = NULL(name='commonMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type1_midambleAllocationMode_ueSpecificMidamble = INT(name='ueSpecificMidamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLong')))
    __MidambleShiftAndBurstType_type1_midambleAllocationMode._cont = ASN1Dict([
        ('defaultMidamble', ___MidambleShiftAndBurstType_type1_midambleAllocationMode_defaultMidamble),
        ('commonMidamble', ___MidambleShiftAndBurstType_type1_midambleAllocationMode_commonMidamble),
        ('ueSpecificMidamble', ___MidambleShiftAndBurstType_type1_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType_type1_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType_type1._cont = ASN1Dict([
        ('midambleConfigurationBurstType1And3', __MidambleShiftAndBurstType_type1_midambleConfigurationBurstType1And3),
        ('midambleAllocationMode', __MidambleShiftAndBurstType_type1_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType_type1._ext = []
    _MidambleShiftAndBurstType_type2 = SEQ(name='type2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType_type2_midambleConfigurationBurstType2 = ENUM(name='midambleConfigurationBurstType2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleConfigurationBurstType2')))
    __MidambleShiftAndBurstType_type2_midambleAllocationMode = CHOICE(name='midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType_type2_midambleAllocationMode_defaultMidamble = NULL(name='defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type2_midambleAllocationMode_commonMidamble = NULL(name='commonMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type2_midambleAllocationMode_ueSpecificMidamble = INT(name='ueSpecificMidamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftShort')))
    __MidambleShiftAndBurstType_type2_midambleAllocationMode._cont = ASN1Dict([
        ('defaultMidamble', ___MidambleShiftAndBurstType_type2_midambleAllocationMode_defaultMidamble),
        ('commonMidamble', ___MidambleShiftAndBurstType_type2_midambleAllocationMode_commonMidamble),
        ('ueSpecificMidamble', ___MidambleShiftAndBurstType_type2_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType_type2_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType_type2._cont = ASN1Dict([
        ('midambleConfigurationBurstType2', __MidambleShiftAndBurstType_type2_midambleConfigurationBurstType2),
        ('midambleAllocationMode', __MidambleShiftAndBurstType_type2_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType_type2._ext = []
    _MidambleShiftAndBurstType_type3 = SEQ(name='type3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType_type3_midambleConfigurationBurstType1And3 = ENUM(name='midambleConfigurationBurstType1And3', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleConfigurationBurstType1And3')))
    __MidambleShiftAndBurstType_type3_midambleAllocationMode = CHOICE(name='midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType_type3_midambleAllocationMode_defaultMidamble = NULL(name='defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type3_midambleAllocationMode_ueSpecificMidamble = INT(name='ueSpecificMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLong')))
    __MidambleShiftAndBurstType_type3_midambleAllocationMode._cont = ASN1Dict([
        ('defaultMidamble', ___MidambleShiftAndBurstType_type3_midambleAllocationMode_defaultMidamble),
        ('ueSpecificMidamble', ___MidambleShiftAndBurstType_type3_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType_type3_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType_type3._cont = ASN1Dict([
        ('midambleConfigurationBurstType1And3', __MidambleShiftAndBurstType_type3_midambleConfigurationBurstType1And3),
        ('midambleAllocationMode', __MidambleShiftAndBurstType_type3_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType_type3._ext = []
    MidambleShiftAndBurstType._cont = ASN1Dict([
        ('type1', _MidambleShiftAndBurstType_type1),
        ('type2', _MidambleShiftAndBurstType_type2),
        ('type3', _MidambleShiftAndBurstType_type3),
        ])
    MidambleShiftAndBurstType._ext = []
    
    #-----< MidambleShiftLong >-----#
    MidambleShiftLong = INT(name='MidambleShiftLong', mode=MODE_TYPE)
    MidambleShiftLong._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< MidambleShiftShort >-----#
    MidambleShiftShort = INT(name='MidambleShiftShort', mode=MODE_TYPE)
    MidambleShiftShort._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    
    #-----< MidambleShiftLCR >-----#
    MidambleShiftLCR = SEQ(name='MidambleShiftLCR', mode=MODE_TYPE)
    _MidambleShiftLCR_midambleAllocationMode = ENUM(name='midambleAllocationMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleAllocationMode')))
    _MidambleShiftLCR_midambleShift = INT(name='midambleShift', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLong')), opt=True)
    _MidambleShiftLCR_midambleConfigurationLCR = ENUM(name='midambleConfigurationLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleConfigurationLCR')))
    _MidambleShiftLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MidambleShiftLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MidambleShiftLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MidambleShiftLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MidambleShiftLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MidambleShiftLCR_iE_Extensions__item__id._const_tab = ____MidambleShiftLCR_iE_Extensions__item__id_tab
    ___MidambleShiftLCR_iE_Extensions__item__id._const_tab_at = None
    ___MidambleShiftLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___MidambleShiftLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MidambleShiftLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MidambleShiftLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MidambleShiftLCR_iE_Extensions__item__criticality._const_tab = ____MidambleShiftLCR_iE_Extensions__item__criticality_tab
    ___MidambleShiftLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MidambleShiftLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MidambleShiftLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MidambleShiftLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MidambleShiftLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MidambleShiftLCR_iE_Extensions__item__extensionValue._const_tab = ____MidambleShiftLCR_iE_Extensions__item__extensionValue_tab
    ___MidambleShiftLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MidambleShiftLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MidambleShiftLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MidambleShiftLCR_iE_Extensions__item__id),
        ('criticality', ___MidambleShiftLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___MidambleShiftLCR_iE_Extensions__item__extensionValue),
        ])
    __MidambleShiftLCR_iE_Extensions__item_._ext = None
    _MidambleShiftLCR_iE_Extensions._cont = __MidambleShiftLCR_iE_Extensions__item_
    _MidambleShiftLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MidambleShiftLCR._cont = ASN1Dict([
        ('midambleAllocationMode', _MidambleShiftLCR_midambleAllocationMode),
        ('midambleShift', _MidambleShiftLCR_midambleShift),
        ('midambleConfigurationLCR', _MidambleShiftLCR_midambleConfigurationLCR),
        ('iE-Extensions', _MidambleShiftLCR_iE_Extensions),
        ])
    MidambleShiftLCR._ext = []
    
    #-----< MidambleAllocationMode >-----#
    MidambleAllocationMode = ENUM(name='MidambleAllocationMode', mode=MODE_TYPE)
    MidambleAllocationMode._cont = ASN1Dict([('defaultMidamble', 0), ('commonMidamble', 1), ('uESpecificMidamble', 2)])
    MidambleAllocationMode._ext = []
    
    #-----< MidambleShiftLCR-ExtIEs >-----#
    MidambleShiftLCR_ExtIEs = CLASS(name='MidambleShiftLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MidambleShiftLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MidambleShiftAndBurstType768 >-----#
    MidambleShiftAndBurstType768 = CHOICE(name='MidambleShiftAndBurstType768', mode=MODE_TYPE)
    _MidambleShiftAndBurstType768_type1 = SEQ(name='type1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType768_type1_midambleConfigurationBurstType1And3 = ENUM(name='midambleConfigurationBurstType1And3', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleConfigurationBurstType1And3')))
    __MidambleShiftAndBurstType768_type1_midambleAllocationMode = CHOICE(name='midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_defaultMidamble = NULL(name='defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_commonMidamble = NULL(name='commonMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_ueSpecificMidamble = INT(name='ueSpecificMidamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLong')))
    __MidambleShiftAndBurstType768_type1_midambleAllocationMode._cont = ASN1Dict([
        ('defaultMidamble', ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_defaultMidamble),
        ('commonMidamble', ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_commonMidamble),
        ('ueSpecificMidamble', ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType768_type1_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType768_type1._cont = ASN1Dict([
        ('midambleConfigurationBurstType1And3', __MidambleShiftAndBurstType768_type1_midambleConfigurationBurstType1And3),
        ('midambleAllocationMode', __MidambleShiftAndBurstType768_type1_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType768_type1._ext = []
    _MidambleShiftAndBurstType768_type2 = SEQ(name='type2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType768_type2_midambleConfigurationBurstType2_768 = ENUM(name='midambleConfigurationBurstType2-768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleConfigurationBurstType2-768')))
    __MidambleShiftAndBurstType768_type2_midambleAllocationMode = CHOICE(name='midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_defaultMidamble = NULL(name='defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_commonMidamble = NULL(name='commonMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_ueSpecificMidamble = INT(name='ueSpecificMidamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftShort768')))
    __MidambleShiftAndBurstType768_type2_midambleAllocationMode._cont = ASN1Dict([
        ('defaultMidamble', ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_defaultMidamble),
        ('commonMidamble', ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_commonMidamble),
        ('ueSpecificMidamble', ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType768_type2_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType768_type2._cont = ASN1Dict([
        ('midambleConfigurationBurstType2-768', __MidambleShiftAndBurstType768_type2_midambleConfigurationBurstType2_768),
        ('midambleAllocationMode', __MidambleShiftAndBurstType768_type2_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType768_type2._ext = []
    _MidambleShiftAndBurstType768_type3 = SEQ(name='type3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType768_type3_midambleConfigurationBurstType1And3 = ENUM(name='midambleConfigurationBurstType1And3', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleConfigurationBurstType1And3')))
    __MidambleShiftAndBurstType768_type3_midambleAllocationMode = CHOICE(name='midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_defaultMidamble = NULL(name='defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_ueSpecificMidamble = INT(name='ueSpecificMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLong')))
    __MidambleShiftAndBurstType768_type3_midambleAllocationMode._cont = ASN1Dict([
        ('defaultMidamble', ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_defaultMidamble),
        ('ueSpecificMidamble', ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType768_type3_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType768_type3._cont = ASN1Dict([
        ('midambleConfigurationBurstType1And3', __MidambleShiftAndBurstType768_type3_midambleConfigurationBurstType1And3),
        ('midambleAllocationMode', __MidambleShiftAndBurstType768_type3_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType768_type3._ext = []
    MidambleShiftAndBurstType768._cont = ASN1Dict([
        ('type1', _MidambleShiftAndBurstType768_type1),
        ('type2', _MidambleShiftAndBurstType768_type2),
        ('type3', _MidambleShiftAndBurstType768_type3),
        ])
    MidambleShiftAndBurstType768._ext = []
    
    #-----< MidambleConfigurationBurstType2-768 >-----#
    MidambleConfigurationBurstType2_768 = ENUM(name='MidambleConfigurationBurstType2-768', mode=MODE_TYPE)
    MidambleConfigurationBurstType2_768._cont = ASN1Dict([('v4', 0), ('v8', 1)])
    MidambleConfigurationBurstType2_768._ext = None
    
    #-----< MidambleShiftShort768 >-----#
    MidambleShiftShort768 = INT(name='MidambleShiftShort768', mode=MODE_TYPE)
    MidambleShiftShort768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< MIMO-ActivationIndicator >-----#
    MIMO_ActivationIndicator = NULL(name='MIMO-ActivationIndicator', mode=MODE_TYPE)
    
    #-----< MIMO-Capability >-----#
    MIMO_Capability = ENUM(name='MIMO-Capability', mode=MODE_TYPE)
    MIMO_Capability._cont = ASN1Dict([('mimo-capable', 0), ('mimo-non-capable', 1)])
    MIMO_Capability._ext = None
    
    #-----< MIMO-Mode-Indicator >-----#
    MIMO_Mode_Indicator = ENUM(name='MIMO-Mode-Indicator', mode=MODE_TYPE)
    MIMO_Mode_Indicator._cont = ASN1Dict([('activate', 0), ('deactivate', 1)])
    MIMO_Mode_Indicator._ext = None
    
    #-----< MIMO-N-M-Ratio >-----#
    MIMO_N_M_Ratio = ENUM(name='MIMO-N-M-Ratio', mode=MODE_TYPE)
    MIMO_N_M_Ratio._cont = ASN1Dict([('v1-2', 0), ('v2-3', 1), ('v3-4', 2), ('v4-5', 3), ('v5-6', 4), ('v6-7', 5), ('v7-8', 6), ('v8-9', 7), ('v9-10', 8), ('v1-1', 9)])
    MIMO_N_M_Ratio._ext = []
    
    #-----< MIMO-PilotConfiguration >-----#
    MIMO_PilotConfiguration = CHOICE(name='MIMO-PilotConfiguration', mode=MODE_TYPE)
    _MIMO_PilotConfiguration_primary_and_secondary_CPICH = INT(name='primary-and-secondary-CPICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _MIMO_PilotConfiguration_normal_and_diversity_primary_CPICH = NULL(name='normal-and-diversity-primary-CPICH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MIMO_PilotConfiguration._cont = ASN1Dict([
        ('primary-and-secondary-CPICH', _MIMO_PilotConfiguration_primary_and_secondary_CPICH),
        ('normal-and-diversity-primary-CPICH', _MIMO_PilotConfiguration_normal_and_diversity_primary_CPICH),
        ])
    MIMO_PilotConfiguration._ext = []
    
    #-----< MIMO-PilotConfigurationExtension >-----#
    MIMO_PilotConfigurationExtension = CHOICE(name='MIMO-PilotConfigurationExtension', mode=MODE_TYPE)
    _MIMO_PilotConfigurationExtension_primary_and_secondary_CPICH = SEQ(name='primary-and-secondary-CPICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PrimaryAndSecondaryCPICHContainer')))
    _MIMO_PilotConfigurationExtension_normal_and_diversity_primary_CPICH = SEQ(name='normal-and-diversity-primary-CPICH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'NormalAndDiversityPrimaryCPICHContainer')))
    MIMO_PilotConfigurationExtension._cont = ASN1Dict([
        ('primary-and-secondary-CPICH', _MIMO_PilotConfigurationExtension_primary_and_secondary_CPICH),
        ('normal-and-diversity-primary-CPICH', _MIMO_PilotConfigurationExtension_normal_and_diversity_primary_CPICH),
        ])
    MIMO_PilotConfigurationExtension._ext = []
    
    #-----< MIMO-PowerOffsetForS-CPICHCapability >-----#
    MIMO_PowerOffsetForS_CPICHCapability = ENUM(name='MIMO-PowerOffsetForS-CPICHCapability', mode=MODE_TYPE)
    MIMO_PowerOffsetForS_CPICHCapability._cont = ASN1Dict([('s-CPICH-Power-Offset-Capable', 0), ('s-CPICH-Power-Offset-Not-Capable', 1)])
    MIMO_PowerOffsetForS_CPICHCapability._ext = None
    
    #-----< MIMO-withfourtransmitantennas-ActivationIndicator >-----#
    MIMO_withfourtransmitantennas_ActivationIndicator = NULL(name='MIMO-withfourtransmitantennas-ActivationIndicator', mode=MODE_TYPE)
    
    #-----< MIMO-withfourtransmitantennas-Mode-Indicator >-----#
    MIMO_withfourtransmitantennas_Mode_Indicator = ENUM(name='MIMO-withfourtransmitantennas-Mode-Indicator', mode=MODE_TYPE)
    MIMO_withfourtransmitantennas_Mode_Indicator._cont = ASN1Dict([('activate', 0), ('deactivate', 1)])
    MIMO_withfourtransmitantennas_Mode_Indicator._ext = None
    
    #-----< DualStream-MIMO-withfourtransmitantennas-ActivationIndicator >-----#
    DualStream_MIMO_withfourtransmitantennas_ActivationIndicator = NULL(name='DualStream-MIMO-withfourtransmitantennas-ActivationIndicator', mode=MODE_TYPE)
    
    #-----< DualStream-MIMO-withfourtransmitantennas-Mode-Indicator >-----#
    DualStream_MIMO_withfourtransmitantennas_Mode_Indicator = ENUM(name='DualStream-MIMO-withfourtransmitantennas-Mode-Indicator', mode=MODE_TYPE)
    DualStream_MIMO_withfourtransmitantennas_Mode_Indicator._cont = ASN1Dict([('activate', 0), ('deactivate', 1)])
    DualStream_MIMO_withfourtransmitantennas_Mode_Indicator._ext = None
    
    #-----< MIMO-withfourtransmitantennas-PilotConfiguration >-----#
    MIMO_withfourtransmitantennas_PilotConfiguration = CHOICE(name='MIMO-withfourtransmitantennas-PilotConfiguration', mode=MODE_TYPE)
    _MIMO_withfourtransmitantennas_PilotConfiguration_primary_and_secondary_CPICH = SEQ_OF(name='primary-and-secondary-CPICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-SCPICH')))
    _MIMO_withfourtransmitantennas_PilotConfiguration_normal_and_diversity_primary_CPICH = SEQ(name='normal-and-diversity-primary-CPICH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'NormalAndDiversityPrimaryCPICHContainer')))
    MIMO_withfourtransmitantennas_PilotConfiguration._cont = ASN1Dict([
        ('primary-and-secondary-CPICH', _MIMO_withfourtransmitantennas_PilotConfiguration_primary_and_secondary_CPICH),
        ('normal-and-diversity-primary-CPICH', _MIMO_withfourtransmitantennas_PilotConfiguration_normal_and_diversity_primary_CPICH),
        ])
    MIMO_withfourtransmitantennas_PilotConfiguration._ext = []
    
    #-----< MIMO-withfourtransmitantennas-SCPICH >-----#
    MIMO_withfourtransmitantennas_SCPICH = SEQ_OF(name='MIMO-withfourtransmitantennas-SCPICH', mode=MODE_TYPE)
    _MIMO_withfourtransmitantennas_SCPICH__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-SCPICH-Configuration')))
    MIMO_withfourtransmitantennas_SCPICH._cont = _MIMO_withfourtransmitantennas_SCPICH__item_
    MIMO_withfourtransmitantennas_SCPICH._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MIMO-withfourtransmitantennas-SCPICH-Configuration >-----#
    MIMO_withfourtransmitantennas_SCPICH_Configuration = SEQ(name='MIMO-withfourtransmitantennas-SCPICH-Configuration', mode=MODE_TYPE)
    _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_S_CPICH = INT(name='associated-S-CPICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_S_CPICH_poweroffset = INT(name='associated-S-CPICH-poweroffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas')), opt=True)
    _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_D_CPICH = INT(name='associated-D-CPICH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')), opt=True)
    _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_D_CPICH_poweroffset = INT(name='associated-D-CPICH-poweroffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas')), opt=True)
    _MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__id._const_tab = ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__id_tab
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__criticality._const_tab = ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__criticality_tab
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__extensionValue._const_tab = ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__extensionValue_tab
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__id),
        ('criticality', ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__extensionValue),
        ])
    __MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item_._ext = None
    _MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions._cont = __MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item_
    _MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MIMO_withfourtransmitantennas_SCPICH_Configuration._cont = ASN1Dict([
        ('associated-S-CPICH', _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_S_CPICH),
        ('associated-S-CPICH-poweroffset', _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_S_CPICH_poweroffset),
        ('associated-D-CPICH', _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_D_CPICH),
        ('associated-D-CPICH-poweroffset', _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_D_CPICH_poweroffset),
        ('iE-Extensions', _MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions),
        ])
    MIMO_withfourtransmitantennas_SCPICH_Configuration._ext = []
    
    #-----< MIMO-withfourtransmitantennas-SCPICH-Configuration-Item-ExtIEs >-----#
    MIMO_withfourtransmitantennas_SCPICH_Configuration_Item_ExtIEs = CLASS(name='MIMO-withfourtransmitantennas-SCPICH-Configuration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MIMO_withfourtransmitantennas_SCPICH_Configuration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas >-----#
    PowerOffsetForSCPICH_DCPICHforMIMOwithfourtransmitantennas = INT(name='PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas', mode=MODE_TYPE)
    PowerOffsetForSCPICH_DCPICHforMIMOwithfourtransmitantennas._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-12, ub=0)], ev=None, er=[])
    
    #-----< MinimumDL-PowerCapability >-----#
    MinimumDL_PowerCapability = INT(name='MinimumDL-PowerCapability', mode=MODE_TYPE)
    MinimumDL_PowerCapability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=800)], ev=None, er=[])
    
    #-----< MinimumReducedE-DPDCH-GainFactor >-----#
    MinimumReducedE_DPDCH_GainFactor = ENUM(name='MinimumReducedE-DPDCH-GainFactor', mode=MODE_TYPE)
    MinimumReducedE_DPDCH_GainFactor._cont = ASN1Dict([('m8-15', 0), ('m11-15', 1), ('m15-15', 2), ('m21-15', 3), ('m30-15', 4), ('m42-15', 5), ('m60-15', 6), ('m84-15', 7)])
    MinimumReducedE_DPDCH_GainFactor._ext = []
    
    #-----< MinSpreadingFactor >-----#
    MinSpreadingFactor = ENUM(name='MinSpreadingFactor', mode=MODE_TYPE)
    MinSpreadingFactor._cont = ASN1Dict([('v4', 0), ('v8', 1), ('v16', 2), ('v32', 3), ('v64', 4), ('v128', 5), ('v256', 6), ('v512', 7)])
    MinSpreadingFactor._ext = None
    
    #-----< Modification-Period >-----#
    Modification_Period = ENUM(name='Modification-Period', mode=MODE_TYPE)
    Modification_Period._cont = ASN1Dict([('v1280', 0), ('v2560', 1), ('v5120', 2), ('v10240', 3)])
    Modification_Period._ext = []
    
    #-----< ModifyPriorityQueue >-----#
    ModifyPriorityQueue = CHOICE(name='ModifyPriorityQueue', mode=MODE_TYPE)
    _ModifyPriorityQueue_addPriorityQueue = SEQ(name='addPriorityQueue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-InfoItem-to-Add')))
    _ModifyPriorityQueue_modifyPriorityQueue = SEQ(name='modifyPriorityQueue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-InfoItem-to-Modify')))
    _ModifyPriorityQueue_deletePriorityQueue = INT(name='deletePriorityQueue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-Id')))
    ModifyPriorityQueue._cont = ASN1Dict([
        ('addPriorityQueue', _ModifyPriorityQueue_addPriorityQueue),
        ('modifyPriorityQueue', _ModifyPriorityQueue_modifyPriorityQueue),
        ('deletePriorityQueue', _ModifyPriorityQueue_deletePriorityQueue),
        ])
    ModifyPriorityQueue._ext = []
    
    #-----< Modulation >-----#
    Modulation = ENUM(name='Modulation', mode=MODE_TYPE)
    Modulation._cont = ASN1Dict([('qPSK', 0), ('eightPSK', 1)])
    Modulation._ext = []
    
    #-----< MinUL-ChannelisationCodeLength >-----#
    MinUL_ChannelisationCodeLength = ENUM(name='MinUL-ChannelisationCodeLength', mode=MODE_TYPE)
    MinUL_ChannelisationCodeLength._cont = ASN1Dict([('v4', 0), ('v8', 1), ('v16', 2), ('v32', 3), ('v64', 4), ('v128', 5), ('v256', 6)])
    MinUL_ChannelisationCodeLength._ext = []
    
    #-----< MultiplexingPosition >-----#
    MultiplexingPosition = ENUM(name='MultiplexingPosition', mode=MODE_TYPE)
    MultiplexingPosition._cont = ASN1Dict([('fixed', 0), ('flexible', 1)])
    MultiplexingPosition._ext = None
    
    #-----< MAChs-ResetIndicator >-----#
    MAChs_ResetIndicator = ENUM(name='MAChs-ResetIndicator', mode=MODE_TYPE)
    MAChs_ResetIndicator._cont = ASN1Dict([('mAChs-NotReset', 0)])
    MAChs_ResetIndicator._ext = None
    
    #-----< ModulationMBSFN >-----#
    ModulationMBSFN = ENUM(name='ModulationMBSFN', mode=MODE_TYPE)
    ModulationMBSFN._cont = ASN1Dict([('qPSK', 0), ('sixteenQAM', 1)])
    ModulationMBSFN._ext = []
    
    #-----< MBSFN-CPICH-secondary-CCPCH-power-offset >-----#
    MBSFN_CPICH_secondary_CCPCH_power_offset = INT(name='MBSFN-CPICH-secondary-CCPCH-power-offset', mode=MODE_TYPE)
    MBSFN_CPICH_secondary_CCPCH_power_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-11, ub=4)], ev=[], er=[])
    
    #-----< ModulationPO-MBSFN >-----#
    ModulationPO_MBSFN = CHOICE(name='ModulationPO-MBSFN', mode=MODE_TYPE)
    _ModulationPO_MBSFN_qPSK = NULL(name='qPSK', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ModulationPO_MBSFN_sixteenQAM = INT(name='sixteenQAM', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MBSFN-CPICH-secondary-CCPCH-power-offset')))
    ModulationPO_MBSFN._cont = ASN1Dict([
        ('qPSK', _ModulationPO_MBSFN_qPSK),
        ('sixteenQAM', _ModulationPO_MBSFN_sixteenQAM),
        ])
    ModulationPO_MBSFN._ext = []
    
    #-----< MBSFN-Only-Mode-Indicator >-----#
    MBSFN_Only_Mode_Indicator = ENUM(name='MBSFN-Only-Mode-Indicator', mode=MODE_TYPE)
    MBSFN_Only_Mode_Indicator._cont = ASN1Dict([('mBSFN-Only-Mode', 0)])
    MBSFN_Only_Mode_Indicator._ext = None
    
    #-----< MBSFN-Only-Mode-Capability >-----#
    MBSFN_Only_Mode_Capability = ENUM(name='MBSFN-Only-Mode-Capability', mode=MODE_TYPE)
    MBSFN_Only_Mode_Capability._cont = ASN1Dict([('mBSFN-Only-Mode-capable', 0), ('mBSFN-Only-Mode-non-capable', 1)])
    MBSFN_Only_Mode_Capability._ext = None
    
    #-----< Multicarrier-Number >-----#
    Multicarrier_Number = INT(name='Multicarrier-Number', mode=MODE_TYPE)
    Multicarrier_Number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MultipleFreq-HARQ-MemoryPartitioning-InformationList >-----#
    MultipleFreq_HARQ_MemoryPartitioning_InformationList = SEQ_OF(name='MultipleFreq-HARQ-MemoryPartitioning-InformationList', mode=MODE_TYPE)
    _MultipleFreq_HARQ_MemoryPartitioning_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MultipleFreq-HARQ-MemoryPartitioning-InformationItem')))
    MultipleFreq_HARQ_MemoryPartitioning_InformationList._cont = _MultipleFreq_HARQ_MemoryPartitioning_InformationList__item_
    MultipleFreq_HARQ_MemoryPartitioning_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< MultipleFreq-HARQ-MemoryPartitioning-InformationItem >-----#
    MultipleFreq_HARQ_MemoryPartitioning_InformationItem = SEQ(name='MultipleFreq-HARQ-MemoryPartitioning-InformationItem', mode=MODE_TYPE)
    _MultipleFreq_HARQ_MemoryPartitioning_InformationItem_hARQ_MemoryPartitioning = CHOICE(name='hARQ-MemoryPartitioning', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioning')))
    _MultipleFreq_HARQ_MemoryPartitioning_InformationItem_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__id._const_tab = ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__id_tab
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__criticality._const_tab = ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__criticality_tab
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__extensionValue_tab
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__id),
        ('criticality', ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item_._ext = None
    _MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions._cont = __MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item_
    _MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleFreq_HARQ_MemoryPartitioning_InformationItem._cont = ASN1Dict([
        ('hARQ-MemoryPartitioning', _MultipleFreq_HARQ_MemoryPartitioning_InformationItem_hARQ_MemoryPartitioning),
        ('uARFCN', _MultipleFreq_HARQ_MemoryPartitioning_InformationItem_uARFCN),
        ('iE-Extensions', _MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions),
        ])
    MultipleFreq_HARQ_MemoryPartitioning_InformationItem._ext = []
    
    #-----< MultipleFreq-HARQ-MemoryPartitioning-InformationItem-ExtIEs >-----#
    MultipleFreq_HARQ_MemoryPartitioning_InformationItem_ExtIEs = CLASS(name='MultipleFreq-HARQ-MemoryPartitioning-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MultipleFreq_HARQ_MemoryPartitioning_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR >-----#
    MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR = SEQ_OF(name='MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR', mode=MODE_TYPE)
    _MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR')))
    MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR._cont = _MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR__item_
    MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR >-----#
    MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR = SEQ(name='MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR', mode=MODE_TYPE)
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hsSCCH_Specific_Information_ResponseTDDLCR = SEQ_OF(name='hsSCCH-Specific-Information-ResponseTDDLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSSCCH-Specific-InformationRespListTDDLCR')), opt=True)
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hARQ_MemoryPartitioning = CHOICE(name='hARQ-MemoryPartitioning', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-MemoryPartitioning')), opt=True)
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id._const_tab = ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id_tab
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id._const_tab_at = None
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality._const_tab = ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality_tab
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue._const_tab = ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue_tab
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id),
        ('criticality', ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue),
        ])
    __MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item_._ext = None
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions._cont = __MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item_
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR._cont = ASN1Dict([
        ('hsSCCH-Specific-Information-ResponseTDDLCR', _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hsSCCH_Specific_Information_ResponseTDDLCR),
        ('hARQ-MemoryPartitioning', _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hARQ_MemoryPartitioning),
        ('uARFCN', _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_uARFCN),
        ('iE-Extensions', _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions),
        ])
    MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR._ext = []
    
    #-----< MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR-ExtIEs >-----#
    MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_ExtIEs = CLASS(name='MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multi-Cell-Capability >-----#
    Multi_Cell_Capability = ENUM(name='Multi-Cell-Capability', mode=MODE_TYPE)
    Multi_Cell_Capability._cont = ASN1Dict([('multi-Cell-Capable', 0), ('multi-Cell-non-Capable', 1)])
    Multi_Cell_Capability._ext = None
    
    #-----< Multi-Cell-Capability-Info >-----#
    Multi_Cell_Capability_Info = SEQ(name='Multi-Cell-Capability-Info', mode=MODE_TYPE)
    _Multi_Cell_Capability_Info_multi_Cell_Capability = ENUM(name='multi-Cell-Capability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multi-Cell-Capability')))
    _Multi_Cell_Capability_Info_possible_Secondary_Serving_Cell_List = SEQ_OF(name='possible-Secondary-Serving-Cell-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Possible-Secondary-Serving-Cell-List')), opt=True)
    _Multi_Cell_Capability_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Cell_Capability_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Cell_Capability_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multi_Cell_Capability_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Cell_Capability_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Cell_Capability_Info_iE_Extensions__item__id._const_tab = ____Multi_Cell_Capability_Info_iE_Extensions__item__id_tab
    ___Multi_Cell_Capability_Info_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Cell_Capability_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multi_Cell_Capability_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multi_Cell_Capability_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Cell_Capability_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Cell_Capability_Info_iE_Extensions__item__criticality._const_tab = ____Multi_Cell_Capability_Info_iE_Extensions__item__criticality_tab
    ___Multi_Cell_Capability_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multi_Cell_Capability_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multi_Cell_Capability_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multi_Cell_Capability_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Cell_Capability_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Cell_Capability_Info_iE_Extensions__item__extensionValue._const_tab = ____Multi_Cell_Capability_Info_iE_Extensions__item__extensionValue_tab
    ___Multi_Cell_Capability_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multi_Cell_Capability_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multi_Cell_Capability_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multi_Cell_Capability_Info_iE_Extensions__item__id),
        ('criticality', ___Multi_Cell_Capability_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Multi_Cell_Capability_Info_iE_Extensions__item__extensionValue),
        ])
    __Multi_Cell_Capability_Info_iE_Extensions__item_._ext = None
    _Multi_Cell_Capability_Info_iE_Extensions._cont = __Multi_Cell_Capability_Info_iE_Extensions__item_
    _Multi_Cell_Capability_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Cell_Capability_Info._cont = ASN1Dict([
        ('multi-Cell-Capability', _Multi_Cell_Capability_Info_multi_Cell_Capability),
        ('possible-Secondary-Serving-Cell-List', _Multi_Cell_Capability_Info_possible_Secondary_Serving_Cell_List),
        ('iE-Extensions', _Multi_Cell_Capability_Info_iE_Extensions),
        ])
    Multi_Cell_Capability_Info._ext = []
    
    #-----< Multi-Cell-Capability-Info-ExtIEs >-----#
    Multi_Cell_Capability_Info_ExtIEs = CLASS(name='Multi-Cell-Capability-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multi_Cell_Capability_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multicell-EDCH-Information >-----#
    Multicell_EDCH_Information = SEQ(name='Multicell-EDCH-Information', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Multicell_EDCH_Information_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Multicell_EDCH_Information_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Multicell_EDCH_Information_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-InformationItemIEs')))
    __Multicell_EDCH_Information_id_tab._val = ASN1Set(rv=[dict([('id', 1159), ('criticality', 'ignore'), ('Value', ___Multicell_EDCH_Information_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Multicell_EDCH_Information_id._const_tab = __Multicell_EDCH_Information_id_tab
    _Multicell_EDCH_Information_id._const_tab_at = None
    _Multicell_EDCH_Information_id._const_tab_id = 'id'
    _Multicell_EDCH_Information_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Multicell_EDCH_Information_criticality._const_tab = __Multicell_EDCH_Information_id_tab
    _Multicell_EDCH_Information_criticality._const_tab_at = ('..', 'id')
    _Multicell_EDCH_Information_criticality._const_tab_id = 'criticality'
    _Multicell_EDCH_Information_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Multicell_EDCH_Information_value._const_tab = __Multicell_EDCH_Information_id_tab
    _Multicell_EDCH_Information_value._const_tab_at = ('..', 'id')
    _Multicell_EDCH_Information_value._const_tab_id = 'Value'
    Multicell_EDCH_Information._cont = ASN1Dict([
        ('id', _Multicell_EDCH_Information_id),
        ('criticality', _Multicell_EDCH_Information_criticality),
        ('value', _Multicell_EDCH_Information_value),
        ])
    Multicell_EDCH_Information._ext = None
    
    #-----< Multicell-EDCH-InformationItem >-----#
    Multicell_EDCH_InformationItem = CLASS(name='Multicell-EDCH-InformationItem', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Multicell_EDCH_InformationItem_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-InformationItemIEs')))
    Multicell_EDCH_InformationItem._val = ASN1Set(rv=[dict([('id', 1159), ('criticality', 'ignore'), ('Value', _Multicell_EDCH_InformationItem_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Multicell-EDCH-InformationItemIEs >-----#
    Multicell_EDCH_InformationItemIEs = SEQ(name='Multicell-EDCH-InformationItemIEs', mode=MODE_TYPE)
    _Multicell_EDCH_InformationItemIEs_dL_PowerBalancing_Information = SEQ(name='dL-PowerBalancing-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-Information')), opt=True)
    _Multicell_EDCH_InformationItemIEs_minimumReducedE_DPDCH_GainFactor = ENUM(name='minimumReducedE-DPDCH-GainFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')), opt=True)
    _Multicell_EDCH_InformationItemIEs_secondary_UL_Frequency_Activation_State = ENUM(name='secondary-UL-Frequency-Activation-State', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Secondary-UL-Frequency-Activation-State')), opt=True)
    _Multicell_EDCH_InformationItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multicell_EDCH_InformationItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__id._const_tab = ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__id_tab
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__criticality._const_tab = ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__criticality_tab
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__extensionValue_tab
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multicell_EDCH_InformationItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__id),
        ('criticality', ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Multicell_EDCH_InformationItemIEs_iE_Extensions__item_._ext = None
    _Multicell_EDCH_InformationItemIEs_iE_Extensions._cont = __Multicell_EDCH_InformationItemIEs_iE_Extensions__item_
    _Multicell_EDCH_InformationItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multicell_EDCH_InformationItemIEs._cont = ASN1Dict([
        ('dL-PowerBalancing-Information', _Multicell_EDCH_InformationItemIEs_dL_PowerBalancing_Information),
        ('minimumReducedE-DPDCH-GainFactor', _Multicell_EDCH_InformationItemIEs_minimumReducedE_DPDCH_GainFactor),
        ('secondary-UL-Frequency-Activation-State', _Multicell_EDCH_InformationItemIEs_secondary_UL_Frequency_Activation_State),
        ('iE-Extensions', _Multicell_EDCH_InformationItemIEs_iE_Extensions),
        ])
    Multicell_EDCH_InformationItemIEs._ext = []
    
    #-----< Multicell-EDCH-InformationItemIEs-ExtIEs >-----#
    Multicell_EDCH_InformationItemIEs_ExtIEs = CLASS(name='Multicell-EDCH-InformationItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multicell_EDCH_InformationItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multicell-EDCH-RL-Specific-Information >-----#
    Multicell_EDCH_RL_Specific_Information = SEQ(name='Multicell-EDCH-RL-Specific-Information', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Multicell_EDCH_RL_Specific_Information_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Multicell_EDCH_RL_Specific_Information_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Multicell_EDCH_RL_Specific_Information_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-RL-Specific-InformationItemIEs')))
    __Multicell_EDCH_RL_Specific_Information_id_tab._val = ASN1Set(rv=[dict([('id', 1160), ('criticality', 'ignore'), ('Value', ___Multicell_EDCH_RL_Specific_Information_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Multicell_EDCH_RL_Specific_Information_id._const_tab = __Multicell_EDCH_RL_Specific_Information_id_tab
    _Multicell_EDCH_RL_Specific_Information_id._const_tab_at = None
    _Multicell_EDCH_RL_Specific_Information_id._const_tab_id = 'id'
    _Multicell_EDCH_RL_Specific_Information_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Multicell_EDCH_RL_Specific_Information_criticality._const_tab = __Multicell_EDCH_RL_Specific_Information_id_tab
    _Multicell_EDCH_RL_Specific_Information_criticality._const_tab_at = ('..', 'id')
    _Multicell_EDCH_RL_Specific_Information_criticality._const_tab_id = 'criticality'
    _Multicell_EDCH_RL_Specific_Information_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Multicell_EDCH_RL_Specific_Information_value._const_tab = __Multicell_EDCH_RL_Specific_Information_id_tab
    _Multicell_EDCH_RL_Specific_Information_value._const_tab_at = ('..', 'id')
    _Multicell_EDCH_RL_Specific_Information_value._const_tab_id = 'Value'
    Multicell_EDCH_RL_Specific_Information._cont = ASN1Dict([
        ('id', _Multicell_EDCH_RL_Specific_Information_id),
        ('criticality', _Multicell_EDCH_RL_Specific_Information_criticality),
        ('value', _Multicell_EDCH_RL_Specific_Information_value),
        ])
    Multicell_EDCH_RL_Specific_Information._ext = None
    
    #-----< Multicell-EDCH-RL-Specific-InformationItem >-----#
    Multicell_EDCH_RL_Specific_InformationItem = CLASS(name='Multicell-EDCH-RL-Specific-InformationItem', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Multicell_EDCH_RL_Specific_InformationItem_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-RL-Specific-InformationItemIEs')))
    Multicell_EDCH_RL_Specific_InformationItem._val = ASN1Set(rv=[dict([('id', 1160), ('criticality', 'ignore'), ('Value', _Multicell_EDCH_RL_Specific_InformationItem_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Multicell-EDCH-RL-Specific-InformationItemIEs >-----#
    Multicell_EDCH_RL_Specific_InformationItemIEs = SEQ(name='Multicell-EDCH-RL-Specific-InformationItemIEs', mode=MODE_TYPE)
    _Multicell_EDCH_RL_Specific_InformationItemIEs_extendedPropagationDelay = INT(name='extendedPropagationDelay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ExtendedPropagationDelay')), opt=True)
    _Multicell_EDCH_RL_Specific_InformationItemIEs_primary_CPICH_Usage_for_Channel_Estimation = ENUM(name='primary-CPICH-Usage-for-Channel-Estimation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Primary-CPICH-Usage-for-Channel-Estimation')), opt=True)
    _Multicell_EDCH_RL_Specific_InformationItemIEs_secondary_CPICH_Information = INT(name='secondary-CPICH-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')), opt=True)
    _Multicell_EDCH_RL_Specific_InformationItemIEs_secondary_CPICH_Information_Change = CHOICE(name='secondary-CPICH-Information-Change', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Secondary-CPICH-Information-Change')), opt=True)
    _Multicell_EDCH_RL_Specific_InformationItemIEs_e_AGCH_PowerOffset = INT(name='e-AGCH-PowerOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-PowerOffset')), opt=True)
    _Multicell_EDCH_RL_Specific_InformationItemIEs_e_RGCH_PowerOffset = INT(name='e-RGCH-PowerOffset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-PowerOffset')), opt=True)
    _Multicell_EDCH_RL_Specific_InformationItemIEs_e_HICH_PowerOffset = INT(name='e-HICH-PowerOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-PowerOffset')), opt=True)
    _Multicell_EDCH_RL_Specific_InformationItemIEs_dLReferencePower = INT(name='dLReferencePower', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _Multicell_EDCH_RL_Specific_InformationItemIEs_e_DCH_DL_Control_Channel_Grant = NULL(name='e-DCH-DL-Control-Channel-Grant', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__id._const_tab = ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__id_tab
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__criticality._const_tab = ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__criticality_tab
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__extensionValue_tab
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__id),
        ('criticality', ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item_._ext = None
    _Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions._cont = __Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item_
    _Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multicell_EDCH_RL_Specific_InformationItemIEs._cont = ASN1Dict([
        ('extendedPropagationDelay', _Multicell_EDCH_RL_Specific_InformationItemIEs_extendedPropagationDelay),
        ('primary-CPICH-Usage-for-Channel-Estimation', _Multicell_EDCH_RL_Specific_InformationItemIEs_primary_CPICH_Usage_for_Channel_Estimation),
        ('secondary-CPICH-Information', _Multicell_EDCH_RL_Specific_InformationItemIEs_secondary_CPICH_Information),
        ('secondary-CPICH-Information-Change', _Multicell_EDCH_RL_Specific_InformationItemIEs_secondary_CPICH_Information_Change),
        ('e-AGCH-PowerOffset', _Multicell_EDCH_RL_Specific_InformationItemIEs_e_AGCH_PowerOffset),
        ('e-RGCH-PowerOffset', _Multicell_EDCH_RL_Specific_InformationItemIEs_e_RGCH_PowerOffset),
        ('e-HICH-PowerOffset', _Multicell_EDCH_RL_Specific_InformationItemIEs_e_HICH_PowerOffset),
        ('dLReferencePower', _Multicell_EDCH_RL_Specific_InformationItemIEs_dLReferencePower),
        ('e-DCH-DL-Control-Channel-Grant', _Multicell_EDCH_RL_Specific_InformationItemIEs_e_DCH_DL_Control_Channel_Grant),
        ('iE-Extensions', _Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions),
        ])
    Multicell_EDCH_RL_Specific_InformationItemIEs._ext = []
    
    #-----< Multicell-EDCH-RL-Specific-InformationItemIEs-ExtIEs >-----#
    Multicell_EDCH_RL_Specific_InformationItemIEs_ExtIEs = CLASS(name='Multicell-EDCH-RL-Specific-InformationItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multicell_EDCH_RL_Specific_InformationItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multicell-EDCH-Restriction >-----#
    Multicell_EDCH_Restriction = BOOL(name='Multicell-EDCH-Restriction', mode=MODE_TYPE)
    
    #-----< MIMO-SFMode-For-HSPDSCHDualStream >-----#
    MIMO_SFMode_For_HSPDSCHDualStream = ENUM(name='MIMO-SFMode-For-HSPDSCHDualStream', mode=MODE_TYPE)
    MIMO_SFMode_For_HSPDSCHDualStream._cont = ASN1Dict([('sF1', 0), ('sF1SF16', 1)])
    MIMO_SFMode_For_HSPDSCHDualStream._ext = None
    
    #-----< Multi-Carrier-EDCH-Info >-----#
    Multi_Carrier_EDCH_Info = SEQ(name='Multi-Carrier-EDCH-Info', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Info_multicarrier_EDCH_Transport_Bearer_Mode = ENUM(name='multicarrier-EDCH-Transport-Bearer-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multicarrier-EDCH-Transport-Bearer-Mode')))
    _Multi_Carrier_EDCH_Info_multi_carrier_EDCH_Information = SEQ_OF(name='multi-carrier-EDCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information')))
    _Multi_Carrier_EDCH_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_Info_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multi_Carrier_EDCH_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id),
        ('criticality', ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_Info_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_Info_iE_Extensions._cont = __Multi_Carrier_EDCH_Info_iE_Extensions__item_
    _Multi_Carrier_EDCH_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_Info._cont = ASN1Dict([
        ('multicarrier-EDCH-Transport-Bearer-Mode', _Multi_Carrier_EDCH_Info_multicarrier_EDCH_Transport_Bearer_Mode),
        ('multi-carrier-EDCH-Information', _Multi_Carrier_EDCH_Info_multi_carrier_EDCH_Information),
        ('iE-Extensions', _Multi_Carrier_EDCH_Info_iE_Extensions),
        ])
    Multi_Carrier_EDCH_Info._ext = []
    
    #-----< Multi-Carrier-EDCH-Info-ExtIEs >-----#
    Multi_Carrier_EDCH_Info_ExtIEs = CLASS(name='Multi-Carrier-EDCH-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multicarrier-EDCH-Transport-Bearer-Mode >-----#
    Multicarrier_EDCH_Transport_Bearer_Mode = ENUM(name='Multicarrier-EDCH-Transport-Bearer-Mode', mode=MODE_TYPE)
    Multicarrier_EDCH_Transport_Bearer_Mode._cont = ASN1Dict([('separate-Iub-Transport-Bearer-Mode', 0), ('eDCH-UL-Flow-Multiplexing-Mode', 1)])
    Multicarrier_EDCH_Transport_Bearer_Mode._ext = []
    
    #-----< Dual-Cell-EDCH-Enhancements-Information >-----#
    Dual_Cell_EDCH_Enhancements_Information = SEQ(name='Dual-Cell-EDCH-Enhancements-Information', mode=MODE_TYPE)
    _Dual_Cell_EDCH_Enhancements_Information_e_TTI = ENUM(name='e-TTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TTI')))
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_Reference_E_TFCI_Information = SEQ_OF(name='eDCH-Reference-E-TFCI-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'EDCH-Reference-E-TFCI-Information')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Boost_Information = SEQ(name='eDCH-E-TFCI-Boost-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCI-Boost-Information')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_DPCCH_Power_Offset = INT(name='eDCH-E-DPCCH-Power-Offset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-PO')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Table_Index = INT(name='eDCH-E-TFCI-Table-Index', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TFCI-Table-Index')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_Power_Offset_for_SchedulingInfo = INT(name='eDCH-Power-Offset-for-SchedulingInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_Max_Set_E_DPDCHs = ENUM(name='eDCH-Max-Set-E-DPDCHs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-Set-E-DPDCHs')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id._const_tab = ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id_tab
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id._const_tab_at = None
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality._const_tab = ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality_tab
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue._const_tab = ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue_tab
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id),
        ('criticality', ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue),
        ])
    __Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item_._ext = None
    _Dual_Cell_EDCH_Enhancements_Information_iE_Extensions._cont = __Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item_
    _Dual_Cell_EDCH_Enhancements_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Dual_Cell_EDCH_Enhancements_Information._cont = ASN1Dict([
        ('e-TTI', _Dual_Cell_EDCH_Enhancements_Information_e_TTI),
        ('eDCH-Reference-E-TFCI-Information', _Dual_Cell_EDCH_Enhancements_Information_eDCH_Reference_E_TFCI_Information),
        ('eDCH-E-TFCI-Boost-Information', _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Boost_Information),
        ('eDCH-E-DPCCH-Power-Offset', _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_DPCCH_Power_Offset),
        ('eDCH-E-TFCI-Table-Index', _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Table_Index),
        ('eDCH-Power-Offset-for-SchedulingInfo', _Dual_Cell_EDCH_Enhancements_Information_eDCH_Power_Offset_for_SchedulingInfo),
        ('eDCH-Max-Set-E-DPDCHs', _Dual_Cell_EDCH_Enhancements_Information_eDCH_Max_Set_E_DPDCHs),
        ('iE-Extensions', _Dual_Cell_EDCH_Enhancements_Information_iE_Extensions),
        ])
    Dual_Cell_EDCH_Enhancements_Information._ext = []
    
    #-----< Dual-Cell-EDCH-Enhancements-Information-ExtIEs >-----#
    Dual_Cell_EDCH_Enhancements_Information_ExtIEs = CLASS(name='Dual-Cell-EDCH-Enhancements-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Dual_Cell_EDCH_Enhancements_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-DRX-InformationFDD >-----#
    HS_SCCH_DRX_InformationFDD = SEQ(name='HS-SCCH-DRX-InformationFDD', mode=MODE_TYPE)
    _HS_SCCH_DRX_InformationFDD_t333 = ENUM(name='t333', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T333')))
    _HS_SCCH_DRX_InformationFDD_hS_SCCH_DRX_Cycle_FACH = ENUM(name='hS-SCCH-DRX-Cycle-FACH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-DRX-Cycle-FACH')))
    _HS_SCCH_DRX_InformationFDD_hS_SCCH_RX_Burst_FACH = ENUM(name='hS-SCCH-RX-Burst-FACH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-RX-Burst-FACH')))
    _HS_SCCH_DRX_InformationFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_DRX_InformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__id._const_tab = ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__criticality_tab
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SCCH_DRX_InformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__id),
        ('criticality', ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_DRX_InformationFDD_iE_Extensions__item_._ext = None
    _HS_SCCH_DRX_InformationFDD_iE_Extensions._cont = __HS_SCCH_DRX_InformationFDD_iE_Extensions__item_
    _HS_SCCH_DRX_InformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_DRX_InformationFDD._cont = ASN1Dict([
        ('t333', _HS_SCCH_DRX_InformationFDD_t333),
        ('hS-SCCH-DRX-Cycle-FACH', _HS_SCCH_DRX_InformationFDD_hS_SCCH_DRX_Cycle_FACH),
        ('hS-SCCH-RX-Burst-FACH', _HS_SCCH_DRX_InformationFDD_hS_SCCH_RX_Burst_FACH),
        ('iE-Extensions', _HS_SCCH_DRX_InformationFDD_iE_Extensions),
        ])
    HS_SCCH_DRX_InformationFDD._ext = []
    
    #-----< HS-SCCH-DRX-InformationFDD-ExtIEs >-----#
    HS_SCCH_DRX_InformationFDD_ExtIEs = CLASS(name='HS-SCCH-DRX-InformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_SCCH_DRX_InformationFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multi-Carrier-EDCH-Information >-----#
    Multi_Carrier_EDCH_Information = SEQ_OF(name='Multi-Carrier-EDCH-Information', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-LCR-InformationItem')))
    Multi_Carrier_EDCH_Information._cont = _Multi_Carrier_EDCH_Information__item_
    Multi_Carrier_EDCH_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Multi-Carrier-EDCH-LCR-InformationItem >-----#
    Multi_Carrier_EDCH_LCR_InformationItem = SEQ(name='Multi-Carrier-EDCH-LCR-InformationItem', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_LCR_InformationItem_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _Multi_Carrier_EDCH_LCR_InformationItem_sNPL_carrier_group_indicator = INT(name='sNPL-carrier-group-indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SNPL-Carrier-Group-Indicator')), opt=True)
    _Multi_Carrier_EDCH_LCR_InformationItem_pRXdes_base = INT(name='pRXdes-base', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PRXdes-base')))
    _Multi_Carrier_EDCH_LCR_InformationItem_multi_Carrier_EDCH_MACdFlows_Information_TDD = SEQ_OF(name='multi-Carrier-EDCH-MACdFlows-Information-TDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-MACdFlows-Information-TDD')), opt=True)
    _Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id),
        ('criticality', ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions._cont = __Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item_
    _Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_LCR_InformationItem._cont = ASN1Dict([
        ('uARFCN', _Multi_Carrier_EDCH_LCR_InformationItem_uARFCN),
        ('sNPL-carrier-group-indicator', _Multi_Carrier_EDCH_LCR_InformationItem_sNPL_carrier_group_indicator),
        ('pRXdes-base', _Multi_Carrier_EDCH_LCR_InformationItem_pRXdes_base),
        ('multi-Carrier-EDCH-MACdFlows-Information-TDD', _Multi_Carrier_EDCH_LCR_InformationItem_multi_Carrier_EDCH_MACdFlows_Information_TDD),
        ('iE-Extensions', _Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions),
        ])
    Multi_Carrier_EDCH_LCR_InformationItem._ext = []
    
    #-----< Multi-Carrier-EDCH-LCR-InformationItem-ExtIEs >-----#
    Multi_Carrier_EDCH_LCR_InformationItem_ExtIEs = CLASS(name='Multi-Carrier-EDCH-LCR-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_LCR_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNPL-Carrier-Group-Indicator >-----#
    SNPL_Carrier_Group_Indicator = INT(name='SNPL-Carrier-Group-Indicator', mode=MODE_TYPE)
    SNPL_Carrier_Group_Indicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< Multi-Carrier-EDCH-MACdFlows-Information-TDD >-----#
    Multi_Carrier_EDCH_MACdFlows_Information_TDD = SEQ_OF(name='Multi-Carrier-EDCH-MACdFlows-Information-TDD', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_MACdFlows_Information_TDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-MACdFlows-Specific-Info')))
    Multi_Carrier_EDCH_MACdFlows_Information_TDD._cont = _Multi_Carrier_EDCH_MACdFlows_Information_TDD__item_
    Multi_Carrier_EDCH_MACdFlows_Information_TDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Multi-Carrier-EDCH-MACdFlows-Specific-Info >-----#
    Multi_Carrier_EDCH_MACdFlows_Specific_Info = SEQ(name='Multi-Carrier-EDCH-MACdFlows-Specific-Info', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id),
        ('criticality', ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions._cont = __Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item_
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_MACdFlows_Specific_Info._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _Multi_Carrier_EDCH_MACdFlows_Specific_Info_e_DCH_MACdFlow_ID),
        ('bindingID', _Multi_Carrier_EDCH_MACdFlows_Specific_Info_bindingID),
        ('transportLayerAddress', _Multi_Carrier_EDCH_MACdFlows_Specific_Info_transportLayerAddress),
        ('iE-Extensions', _Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions),
        ])
    Multi_Carrier_EDCH_MACdFlows_Specific_Info._ext = []
    
    #-----< Multi-Carrier-EDCH-MACdFlows-Specific-Info-ExtIEs >-----#
    Multi_Carrier_EDCH_MACdFlows_Specific_Info_ExtIEs = CLASS(name='Multi-Carrier-EDCH-MACdFlows-Specific-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_MACdFlows_Specific_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multi-Carrier-EDCH-Reconfigure >-----#
    Multi_Carrier_EDCH_Reconfigure = SEQ(name='Multi-Carrier-EDCH-Reconfigure', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Reconfigure_continue_setup_change_Of_Multi_Carrier_EDCH = CHOICE(name='continue-setup-change-Of-Multi-Carrier-EDCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Continue-Setup-Change-Multi-Carrier-EDCH')))
    _Multi_Carrier_EDCH_Reconfigure_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id),
        ('criticality', ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality),
        ('extensionValue', ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_Reconfigure_iE_Extensions._cont = __Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item_
    _Multi_Carrier_EDCH_Reconfigure_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_Reconfigure._cont = ASN1Dict([
        ('continue-setup-change-Of-Multi-Carrier-EDCH', _Multi_Carrier_EDCH_Reconfigure_continue_setup_change_Of_Multi_Carrier_EDCH),
        ('iE-Extensions', _Multi_Carrier_EDCH_Reconfigure_iE_Extensions),
        ])
    Multi_Carrier_EDCH_Reconfigure._ext = []
    
    #-----< Multi-Carrier-EDCH-Reconfigure-ExtIEs >-----#
    Multi_Carrier_EDCH_Reconfigure_ExtIEs = CLASS(name='Multi-Carrier-EDCH-Reconfigure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_Reconfigure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Continue-Setup-Change-Multi-Carrier-EDCH >-----#
    Continue_Setup_Change_Multi_Carrier_EDCH = CHOICE(name='Continue-Setup-Change-Multi-Carrier-EDCH', mode=MODE_TYPE)
    _Continue_Setup_Change_Multi_Carrier_EDCH_continue_ = NULL(name='continue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Continue_Setup_Change_Multi_Carrier_EDCH_setup = SEQ(name='setup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Info')))
    _Continue_Setup_Change_Multi_Carrier_EDCH_change = SEQ(name='change', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Change-Info')))
    Continue_Setup_Change_Multi_Carrier_EDCH._cont = ASN1Dict([
        ('continue', _Continue_Setup_Change_Multi_Carrier_EDCH_continue_),
        ('setup', _Continue_Setup_Change_Multi_Carrier_EDCH_setup),
        ('change', _Continue_Setup_Change_Multi_Carrier_EDCH_change),
        ])
    Continue_Setup_Change_Multi_Carrier_EDCH._ext = []
    
    #-----< Multi-Carrier-EDCH-Change-Info >-----#
    Multi_Carrier_EDCH_Change_Info = SEQ(name='Multi-Carrier-EDCH-Change-Info', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Change_Info_multicarrier_EDCH_Transport_Bearer_Mode = ENUM(name='multicarrier-EDCH-Transport-Bearer-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multicarrier-EDCH-Transport-Bearer-Mode')), opt=True)
    _Multi_Carrier_EDCH_Change_Info_multi_carrier_EDCH_Information = SEQ_OF(name='multi-carrier-EDCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information')), opt=True)
    _Multi_Carrier_EDCH_Change_Info_multi_Carrier_EDCH_Information_Removal_List = SEQ_OF(name='multi-Carrier-EDCH-Information-Removal-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information-Removal-List')), opt=True)
    _Multi_Carrier_EDCH_Change_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_Change_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multi_Carrier_EDCH_Change_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id),
        ('criticality', ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_Change_Info_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_Change_Info_iE_Extensions._cont = __Multi_Carrier_EDCH_Change_Info_iE_Extensions__item_
    _Multi_Carrier_EDCH_Change_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_Change_Info._cont = ASN1Dict([
        ('multicarrier-EDCH-Transport-Bearer-Mode', _Multi_Carrier_EDCH_Change_Info_multicarrier_EDCH_Transport_Bearer_Mode),
        ('multi-carrier-EDCH-Information', _Multi_Carrier_EDCH_Change_Info_multi_carrier_EDCH_Information),
        ('multi-Carrier-EDCH-Information-Removal-List', _Multi_Carrier_EDCH_Change_Info_multi_Carrier_EDCH_Information_Removal_List),
        ('iE-Extensions', _Multi_Carrier_EDCH_Change_Info_iE_Extensions),
        ])
    Multi_Carrier_EDCH_Change_Info._ext = []
    
    #-----< Multi-Carrier-EDCH-Change-Info-ExtIEs >-----#
    Multi_Carrier_EDCH_Change_Info_ExtIEs = CLASS(name='Multi-Carrier-EDCH-Change-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_Change_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multi-Carrier-EDCH-Information-Removal-List >-----#
    Multi_Carrier_EDCH_Information_Removal_List = SEQ_OF(name='Multi-Carrier-EDCH-Information-Removal-List', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Information_Removal_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs')))
    Multi_Carrier_EDCH_Information_Removal_List._cont = _Multi_Carrier_EDCH_Information_Removal_List__item_
    Multi_Carrier_EDCH_Information_Removal_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs >-----#
    Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs = SEQ(name='Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions._cont = __Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item_
    _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs._cont = ASN1Dict([
        ('uARFCN', _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_uARFCN),
        ('iE-Extensions', _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions),
        ])
    Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs._ext = []
    
    #-----< Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs-ExtIEs >-----#
    Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_ExtIEs = CLASS(name='Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multi-Carrier-EDCH-Information-Response >-----#
    Multi_Carrier_EDCH_Information_Response = SEQ_OF(name='Multi-Carrier-EDCH-Information-Response', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Information_Response__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-LCR-Information-ResponseItem')))
    Multi_Carrier_EDCH_Information_Response._cont = _Multi_Carrier_EDCH_Information_Response__item_
    Multi_Carrier_EDCH_Information_Response._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Multi-Carrier-EDCH-LCR-Information-ResponseItem >-----#
    Multi_Carrier_EDCH_LCR_Information_ResponseItem = SEQ(name='Multi-Carrier-EDCH-LCR-Information-ResponseItem', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_DCH_TDD_MACdFlow_Specific_InformationResp = SEQ_OF(name='e-DCH-TDD-MACdFlow-Specific-InformationResp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-MACdFlow-Specific-InformationResp')), opt=True)
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_AGCH_Specific_Information_ResponseTDD = SEQ_OF(name='e-AGCH-Specific-Information-ResponseTDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Specific-InformationRespListTDD')), opt=True)
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_scheduled_E_HICH_Specific_InformationResp = SEQ_OF(name='scheduled-E-HICH-Specific-InformationResp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Scheduled-E-HICH-Specific-Information-ResponseLCRTDD')), opt=True)
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id),
        ('criticality', ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality),
        ('extensionValue', ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions._cont = __Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item_
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_LCR_Information_ResponseItem._cont = ASN1Dict([
        ('uARFCN', _Multi_Carrier_EDCH_LCR_Information_ResponseItem_uARFCN),
        ('e-DCH-TDD-MACdFlow-Specific-InformationResp', _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_DCH_TDD_MACdFlow_Specific_InformationResp),
        ('e-AGCH-Specific-Information-ResponseTDD', _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_AGCH_Specific_Information_ResponseTDD),
        ('scheduled-E-HICH-Specific-InformationResp', _Multi_Carrier_EDCH_LCR_Information_ResponseItem_scheduled_E_HICH_Specific_InformationResp),
        ('iE-Extensions', _Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions),
        ])
    Multi_Carrier_EDCH_LCR_Information_ResponseItem._ext = []
    
    #-----< Multi-Carrier-EDCH-LCR-Information-ResponseItem-ExtIEs >-----#
    Multi_Carrier_EDCH_LCR_Information_ResponseItem_ExtIEs = CLASS(name='Multi-Carrier-EDCH-LCR-Information-ResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_LCR_Information_ResponseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multiflow-Reconfiguration >-----#
    Multiflow_Reconfiguration = CHOICE(name='Multiflow-Reconfiguration', mode=MODE_TYPE)
    _Multiflow_Reconfiguration_setup = SEQ(name='setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Information')))
    _Multiflow_Reconfiguration_change = SEQ(name='change', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Information-To-Modify')))
    _Multiflow_Reconfiguration_stop = ENUM(name='stop', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Stop')))
    Multiflow_Reconfiguration._cont = ASN1Dict([
        ('setup', _Multiflow_Reconfiguration_setup),
        ('change', _Multiflow_Reconfiguration_change),
        ('stop', _Multiflow_Reconfiguration_stop),
        ])
    Multiflow_Reconfiguration._ext = []
    
    #-----< Multiflow-Information >-----#
    Multiflow_Information = SEQ(name='Multiflow-Information', mode=MODE_TYPE)
    _Multiflow_Information_total_Number_of_HS_DSCH_Cells = INT(name='total-Number-of-HS-DSCH-Cells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Multiflow_Information_total_Number_of_HS_DSCH_Cells._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=[], er=[])
    _Multiflow_Information_role = ENUM(name='role', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Role')))
    _Multiflow_Information_mimo = ENUM(name='mimo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-MIMO')))
    _Multiflow_Information_timing = CHOICE(name='timing', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Timing')), opt=True)
    _Multiflow_Information_max_Number_of_HS_SCCH_Sets_per_NodeB = INT(name='max-Number-of-HS-SCCH-Sets-per-NodeB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Multiflow_Information_max_Number_of_HS_SCCH_Sets_per_NodeB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    _Multiflow_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiflow_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multiflow_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multiflow_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Multiflow_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-RepetitionFactors')))
    ____Multiflow_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1276), ('criticality', 'ignore'), ('Extension', _____Multiflow_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Multiflow_Information_iE_Extensions__item__id._const_tab = ____Multiflow_Information_iE_Extensions__item__id_tab
    ___Multiflow_Information_iE_Extensions__item__id._const_tab_at = None
    ___Multiflow_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multiflow_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Multiflow_Information_iE_Extensions__item__criticality._const_tab = ____Multiflow_Information_iE_Extensions__item__id_tab
    ___Multiflow_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multiflow_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multiflow_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Multiflow_Information_iE_Extensions__item__extensionValue._const_tab = ____Multiflow_Information_iE_Extensions__item__id_tab
    ___Multiflow_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multiflow_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multiflow_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multiflow_Information_iE_Extensions__item__id),
        ('criticality', ___Multiflow_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Multiflow_Information_iE_Extensions__item__extensionValue),
        ])
    __Multiflow_Information_iE_Extensions__item_._ext = None
    _Multiflow_Information_iE_Extensions._cont = __Multiflow_Information_iE_Extensions__item_
    _Multiflow_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiflow_Information._cont = ASN1Dict([
        ('total-Number-of-HS-DSCH-Cells', _Multiflow_Information_total_Number_of_HS_DSCH_Cells),
        ('role', _Multiflow_Information_role),
        ('mimo', _Multiflow_Information_mimo),
        ('timing', _Multiflow_Information_timing),
        ('max-Number-of-HS-SCCH-Sets-per-NodeB', _Multiflow_Information_max_Number_of_HS_SCCH_Sets_per_NodeB),
        ('iE-Extensions', _Multiflow_Information_iE_Extensions),
        ])
    Multiflow_Information._ext = []
    
    #-----< Multiflow-Information-To-Modify >-----#
    Multiflow_Information_To_Modify = SEQ(name='Multiflow-Information-To-Modify', mode=MODE_TYPE)
    _Multiflow_Information_To_Modify_total_Number_of_HS_DSCH_Cells = INT(name='total-Number-of-HS-DSCH-Cells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Multiflow_Information_To_Modify_total_Number_of_HS_DSCH_Cells._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=[], er=[])
    _Multiflow_Information_To_Modify_role = ENUM(name='role', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Role')), opt=True)
    _Multiflow_Information_To_Modify_mimo = ENUM(name='mimo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-MIMO')), opt=True)
    _Multiflow_Information_To_Modify_timing = CHOICE(name='timing', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-Timing')), opt=True)
    _Multiflow_Information_To_Modify_max_Number_of_HS_SCCH_Sets_per_NodeB = INT(name='max-Number-of-HS-SCCH-Sets-per-NodeB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Multiflow_Information_To_Modify_max_Number_of_HS_SCCH_Sets_per_NodeB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    _Multiflow_Information_To_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiflow_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multiflow_Information_To_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-RepetitionFactors')))
    ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1276), ('criticality', 'ignore'), ('Extension', _____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Multiflow_Information_To_Modify_iE_Extensions__item__id._const_tab = ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab
    ___Multiflow_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___Multiflow_Information_To_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab
    ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab
    ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multiflow_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multiflow_Information_To_Modify_iE_Extensions__item__id),
        ('criticality', ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __Multiflow_Information_To_Modify_iE_Extensions__item_._ext = None
    _Multiflow_Information_To_Modify_iE_Extensions._cont = __Multiflow_Information_To_Modify_iE_Extensions__item_
    _Multiflow_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiflow_Information_To_Modify._cont = ASN1Dict([
        ('total-Number-of-HS-DSCH-Cells', _Multiflow_Information_To_Modify_total_Number_of_HS_DSCH_Cells),
        ('role', _Multiflow_Information_To_Modify_role),
        ('mimo', _Multiflow_Information_To_Modify_mimo),
        ('timing', _Multiflow_Information_To_Modify_timing),
        ('max-Number-of-HS-SCCH-Sets-per-NodeB', _Multiflow_Information_To_Modify_max_Number_of_HS_SCCH_Sets_per_NodeB),
        ('iE-Extensions', _Multiflow_Information_To_Modify_iE_Extensions),
        ])
    Multiflow_Information_To_Modify._ext = []
    
    #-----< Multiflow-Information-ExtIEs >-----#
    Multiflow_Information_ExtIEs = CLASS(name='Multiflow-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Multiflow_Information_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-RepetitionFactors')))
    Multiflow_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 1276), ('criticality', 'ignore'), ('Extension', _Multiflow_Information_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Multiflow-Information-To-Modify-ExtIEs >-----#
    Multiflow_Information_To_Modify_ExtIEs = CLASS(name='Multiflow-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Multiflow_Information_To_Modify_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-RepetitionFactors')))
    Multiflow_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[dict([('id', 1276), ('criticality', 'ignore'), ('Extension', _Multiflow_Information_To_Modify_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Multiflow-RepetitionFactors >-----#
    Multiflow_RepetitionFactors = SEQ(name='Multiflow-RepetitionFactors', mode=MODE_TYPE)
    _Multiflow_RepetitionFactors_assisting_CQI_RepetitionFactor = INT(name='assisting-CQI-RepetitionFactor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CQI-RepetitionFactor')), opt=True)
    _Multiflow_RepetitionFactors_assisting_AckNack_RepetitionFactor = INT(name='assisting-AckNack-RepetitionFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AckNack-RepetitionFactor')), opt=True)
    _Multiflow_RepetitionFactors_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiflow_RepetitionFactors_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multiflow_RepetitionFactors_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiflow_RepetitionFactors_iE_Extensions__item__id._const_tab = ____Multiflow_RepetitionFactors_iE_Extensions__item__id_tab
    ___Multiflow_RepetitionFactors_iE_Extensions__item__id._const_tab_at = None
    ___Multiflow_RepetitionFactors_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality._const_tab = ____Multiflow_RepetitionFactors_iE_Extensions__item__criticality_tab
    ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue._const_tab = ____Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue_tab
    ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multiflow_RepetitionFactors_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multiflow_RepetitionFactors_iE_Extensions__item__id),
        ('criticality', ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality),
        ('extensionValue', ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue),
        ])
    __Multiflow_RepetitionFactors_iE_Extensions__item_._ext = None
    _Multiflow_RepetitionFactors_iE_Extensions._cont = __Multiflow_RepetitionFactors_iE_Extensions__item_
    _Multiflow_RepetitionFactors_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiflow_RepetitionFactors._cont = ASN1Dict([
        ('assisting-CQI-RepetitionFactor', _Multiflow_RepetitionFactors_assisting_CQI_RepetitionFactor),
        ('assisting-AckNack-RepetitionFactor', _Multiflow_RepetitionFactors_assisting_AckNack_RepetitionFactor),
        ('iE-Extensions', _Multiflow_RepetitionFactors_iE_Extensions),
        ])
    Multiflow_RepetitionFactors._ext = []
    
    #-----< Multiflow-RepetitionFactors-ExtIEs >-----#
    Multiflow_RepetitionFactors_ExtIEs = CLASS(name='Multiflow-RepetitionFactors-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multiflow_RepetitionFactors_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multiflow-Stop >-----#
    Multiflow_Stop = ENUM(name='Multiflow-Stop', mode=MODE_TYPE)
    Multiflow_Stop._cont = ASN1Dict([('stop', 0)])
    Multiflow_Stop._ext = []
    
    #-----< Multiflow-Role >-----#
    Multiflow_Role = ENUM(name='Multiflow-Role', mode=MODE_TYPE)
    Multiflow_Role._cont = ASN1Dict([('primary', 0), ('assisting', 1)])
    Multiflow_Role._ext = []
    
    #-----< Multiflow-MIMO >-----#
    Multiflow_MIMO = ENUM(name='Multiflow-MIMO', mode=MODE_TYPE)
    Multiflow_MIMO._cont = ASN1Dict([('on', 0), ('off', 1)])
    Multiflow_MIMO._ext = []
    
    #-----< Multiflow-Timing >-----#
    Multiflow_Timing = CHOICE(name='Multiflow-Timing', mode=MODE_TYPE)
    _Multiflow_Timing_time_Reference = NULL(name='time-Reference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Multiflow_Timing_non_Time_Reference = INT(name='non-Time-Reference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Multiflow_Timing_non_Time_Reference._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=30)], ev=[], er=[])
    Multiflow_Timing._cont = ASN1Dict([
        ('time-Reference', _Multiflow_Timing_time_Reference),
        ('non-Time-Reference', _Multiflow_Timing_non_Time_Reference),
        ])
    Multiflow_Timing._ext = []
    
    #-----< Multiflow-OrdinalNumberOfFrequency >-----#
    Multiflow_OrdinalNumberOfFrequency = INT(name='Multiflow-OrdinalNumberOfFrequency', mode=MODE_TYPE)
    Multiflow_OrdinalNumberOfFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< MU-MIMO-Capability-ContainerLCR >-----#
    MU_MIMO_Capability_ContainerLCR = BIT_STR(name='MU-MIMO-Capability-ContainerLCR', mode=MODE_TYPE)
    MU_MIMO_Capability_ContainerLCR._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MU-MIMO-InformationLCR >-----#
    MU_MIMO_InformationLCR = SEQ(name='MU-MIMO-InformationLCR', mode=MODE_TYPE)
    _MU_MIMO_InformationLCR_mU_MIMO_IndicatorLCR = ENUM(name='mU-MIMO-IndicatorLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-IndicatorLCR')))
    _MU_MIMO_InformationLCR_standalone_Midamble_Channel_Information_RequestLCR = ENUM(name='standalone-Midamble-Channel-Information-RequestLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Standalone-Midamble-Channel-Information-RequestLCR')), opt=True)
    _MU_MIMO_InformationLCR_standalone_Midamble_Channel_Information = SEQ(name='standalone-Midamble-Channel-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Standalone-Midamble-Channel-Information')), opt=True)
    _MU_MIMO_InformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MU_MIMO_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MU_MIMO_InformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_InformationLCR_iE_Extensions__item__id._const_tab = ____MU_MIMO_InformationLCR_iE_Extensions__item__id_tab
    ___MU_MIMO_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___MU_MIMO_InformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality._const_tab = ____MU_MIMO_InformationLCR_iE_Extensions__item__criticality_tab
    ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MU_MIMO_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MU_MIMO_InformationLCR_iE_Extensions__item__id),
        ('criticality', ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __MU_MIMO_InformationLCR_iE_Extensions__item_._ext = None
    _MU_MIMO_InformationLCR_iE_Extensions._cont = __MU_MIMO_InformationLCR_iE_Extensions__item_
    _MU_MIMO_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MU_MIMO_InformationLCR._cont = ASN1Dict([
        ('mU-MIMO-IndicatorLCR', _MU_MIMO_InformationLCR_mU_MIMO_IndicatorLCR),
        ('standalone-Midamble-Channel-Information-RequestLCR', _MU_MIMO_InformationLCR_standalone_Midamble_Channel_Information_RequestLCR),
        ('standalone-Midamble-Channel-Information', _MU_MIMO_InformationLCR_standalone_Midamble_Channel_Information),
        ('iE-Extensions', _MU_MIMO_InformationLCR_iE_Extensions),
        ])
    MU_MIMO_InformationLCR._ext = []
    
    #-----< Standalone-Midamble-Channel-Information-RequestLCR >-----#
    Standalone_Midamble_Channel_Information_RequestLCR = ENUM(name='Standalone-Midamble-Channel-Information-RequestLCR', mode=MODE_TYPE)
    Standalone_Midamble_Channel_Information_RequestLCR._cont = ASN1Dict([('stand-alone-Midamble-Resource-Requested', 0), ('stand-alone-Midamble-Resource-not-Requested', 1)])
    Standalone_Midamble_Channel_Information_RequestLCR._ext = None
    
    #-----< Standalone-Midamble-Channel-Information >-----#
    Standalone_Midamble_Channel_Information = SEQ(name='Standalone-Midamble-Channel-Information', mode=MODE_TYPE)
    _Standalone_Midamble_Channel_Information_standalone_Midamble_Configuratnion = ENUM(name='standalone-Midamble-Configuratnion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Standalone-Midamble-Configuratnion')))
    _Standalone_Midamble_Channel_Information_standalone_MidambleShift = INT(name='standalone-MidambleShift', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Standalone-MidambleShift')))
    _Standalone_Midamble_Channel_Information_timeslotLCR = INT(name='timeslotLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _Standalone_Midamble_Channel_Information_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Standalone-Midamble-RepetitionPeriod')))
    _Standalone_Midamble_Channel_Information_offset = INT(name='offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Standalone-Midamble-Offset')))
    _Standalone_Midamble_Channel_Information_referenceBeta = INT(name='referenceBeta', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReferenceBeta')), opt=True)
    _Standalone_Midamble_Channel_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Standalone_Midamble_Channel_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id._const_tab = ____Standalone_Midamble_Channel_Information_iE_Extensions__item__id_tab
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id._const_tab_at = None
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality._const_tab = ____Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality_tab
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue._const_tab = ____Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue_tab
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Standalone_Midamble_Channel_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id),
        ('criticality', ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue),
        ])
    __Standalone_Midamble_Channel_Information_iE_Extensions__item_._ext = None
    _Standalone_Midamble_Channel_Information_iE_Extensions._cont = __Standalone_Midamble_Channel_Information_iE_Extensions__item_
    _Standalone_Midamble_Channel_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Standalone_Midamble_Channel_Information._cont = ASN1Dict([
        ('standalone-Midamble-Configuratnion', _Standalone_Midamble_Channel_Information_standalone_Midamble_Configuratnion),
        ('standalone-MidambleShift', _Standalone_Midamble_Channel_Information_standalone_MidambleShift),
        ('timeslotLCR', _Standalone_Midamble_Channel_Information_timeslotLCR),
        ('repetitionPeriod', _Standalone_Midamble_Channel_Information_repetitionPeriod),
        ('offset', _Standalone_Midamble_Channel_Information_offset),
        ('referenceBeta', _Standalone_Midamble_Channel_Information_referenceBeta),
        ('iE-Extensions', _Standalone_Midamble_Channel_Information_iE_Extensions),
        ])
    Standalone_Midamble_Channel_Information._ext = []
    
    #-----< Standalone-Midamble-Configuratnion >-----#
    Standalone_Midamble_Configuratnion = ENUM(name='Standalone-Midamble-Configuratnion', mode=MODE_TYPE)
    Standalone_Midamble_Configuratnion._cont = ASN1Dict([('v2', 0), ('v4', 1), ('v6', 2), ('v8', 3), ('v10', 4), ('v12', 5), ('v14', 6), ('v16', 7)])
    Standalone_Midamble_Configuratnion._ext = []
    
    #-----< Standalone-MidambleShift >-----#
    Standalone_MidambleShift = INT(name='Standalone-MidambleShift', mode=MODE_TYPE)
    Standalone_MidambleShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< Standalone-Midamble-RepetitionPeriod >-----#
    Standalone_Midamble_RepetitionPeriod = ENUM(name='Standalone-Midamble-RepetitionPeriod', mode=MODE_TYPE)
    Standalone_Midamble_RepetitionPeriod._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v4', 2), ('v8', 3), ('v16', 4), ('v32', 5), ('v64', 6)])
    Standalone_Midamble_RepetitionPeriod._ext = []
    
    #-----< Standalone-Midamble-Offset >-----#
    Standalone_Midamble_Offset = INT(name='Standalone-Midamble-Offset', mode=MODE_TYPE)
    Standalone_Midamble_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< ReferenceBeta >-----#
    ReferenceBeta = INT(name='ReferenceBeta', mode=MODE_TYPE)
    ReferenceBeta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-15, ub=16)], ev=None, er=[])
    
    #-----< Standalone-Midamble-Channel-Information-ExtIEs >-----#
    Standalone_Midamble_Channel_Information_ExtIEs = CLASS(name='Standalone-Midamble-Channel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Standalone_Midamble_Channel_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MU-MIMO-InformationLCR-ExtIEs >-----#
    MU_MIMO_InformationLCR_ExtIEs = CLASS(name='MU-MIMO-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MU_MIMO_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MU-MIMO-Information-Response >-----#
    MU_MIMO_Information_Response = SEQ(name='MU-MIMO-Information-Response', mode=MODE_TYPE)
    _MU_MIMO_Information_Response_mU_MIMO_Usage_IndicatorLCR = ENUM(name='mU-MIMO-Usage-IndicatorLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Usage-IndicatorLCR')))
    _MU_MIMO_Information_Response_standalone_Midamble_Channel_Information = SEQ(name='standalone-Midamble-Channel-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Standalone-Midamble-Channel-Information')), opt=True)
    _MU_MIMO_Information_Response_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MU_MIMO_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MU_MIMO_Information_Response_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MU_MIMO_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_Information_Response_iE_Extensions__item__id._const_tab = ____MU_MIMO_Information_Response_iE_Extensions__item__id_tab
    ___MU_MIMO_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___MU_MIMO_Information_Response_iE_Extensions__item__id._const_tab_id = 'id'
    ___MU_MIMO_Information_Response_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MU_MIMO_Information_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_Information_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_Information_Response_iE_Extensions__item__criticality._const_tab = ____MU_MIMO_Information_Response_iE_Extensions__item__criticality_tab
    ___MU_MIMO_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MU_MIMO_Information_Response_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MU_MIMO_Information_Response_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MU_MIMO_Information_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_Information_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____MU_MIMO_Information_Response_iE_Extensions__item__extensionValue_tab
    ___MU_MIMO_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MU_MIMO_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MU_MIMO_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MU_MIMO_Information_Response_iE_Extensions__item__id),
        ('criticality', ___MU_MIMO_Information_Response_iE_Extensions__item__criticality),
        ('extensionValue', ___MU_MIMO_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __MU_MIMO_Information_Response_iE_Extensions__item_._ext = None
    _MU_MIMO_Information_Response_iE_Extensions._cont = __MU_MIMO_Information_Response_iE_Extensions__item_
    _MU_MIMO_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MU_MIMO_Information_Response._cont = ASN1Dict([
        ('mU-MIMO-Usage-IndicatorLCR', _MU_MIMO_Information_Response_mU_MIMO_Usage_IndicatorLCR),
        ('standalone-Midamble-Channel-Information', _MU_MIMO_Information_Response_standalone_Midamble_Channel_Information),
        ('iE-Extensions', _MU_MIMO_Information_Response_iE_Extensions),
        ])
    MU_MIMO_Information_Response._ext = []
    
    #-----< MU-MIMO-Information-Response-ExtIEs >-----#
    MU_MIMO_Information_Response_ExtIEs = CLASS(name='MU-MIMO-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MU_MIMO_Information_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MU-MIMO-Information-To-ReconfigureLCR >-----#
    MU_MIMO_Information_To_ReconfigureLCR = CHOICE(name='MU-MIMO-Information-To-ReconfigureLCR', mode=MODE_TYPE)
    _MU_MIMO_Information_To_ReconfigureLCR_mU_MIMO_Information_To_Modify = SEQ(name='mU-MIMO-Information-To-Modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-To-Modify')))
    _MU_MIMO_Information_To_ReconfigureLCR_mU_MIMO_Information_To_Continue = NULL(name='mU-MIMO-Information-To-Continue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MU_MIMO_Information_To_ReconfigureLCR._cont = ASN1Dict([
        ('mU-MIMO-Information-To-Modify', _MU_MIMO_Information_To_ReconfigureLCR_mU_MIMO_Information_To_Modify),
        ('mU-MIMO-Information-To-Continue', _MU_MIMO_Information_To_ReconfigureLCR_mU_MIMO_Information_To_Continue),
        ])
    MU_MIMO_Information_To_ReconfigureLCR._ext = []
    
    #-----< MU-MIMO-Information-To-Modify >-----#
    MU_MIMO_Information_To_Modify = SEQ(name='MU-MIMO-Information-To-Modify', mode=MODE_TYPE)
    _MU_MIMO_Information_To_Modify_mU_MIMO_IndicatorLCR = ENUM(name='mU-MIMO-IndicatorLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-IndicatorLCR')), opt=True)
    _MU_MIMO_Information_To_Modify_standalone_Midamble_Configuratnion = ENUM(name='standalone-Midamble-Configuratnion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Standalone-Midamble-Configuratnion')), opt=True)
    _MU_MIMO_Information_To_Modify_standalone_MidambleShift = INT(name='standalone-MidambleShift', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Standalone-MidambleShift')), opt=True)
    _MU_MIMO_Information_To_Modify_timeslotLCR = INT(name='timeslotLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')), opt=True)
    _MU_MIMO_Information_To_Modify_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Standalone-Midamble-RepetitionPeriod')), opt=True)
    _MU_MIMO_Information_To_Modify_offset = INT(name='offset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Standalone-Midamble-Offset')), opt=True)
    _MU_MIMO_Information_To_Modify_referenceBeta = INT(name='referenceBeta', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReferenceBeta')), opt=True)
    _MU_MIMO_Information_To_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MU_MIMO_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MU_MIMO_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__id._const_tab = ____MU_MIMO_Information_To_Modify_iE_Extensions__item__id_tab
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MU_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____MU_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MU_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____MU_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MU_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MU_MIMO_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MU_MIMO_Information_To_Modify_iE_Extensions__item__id),
        ('criticality', ___MU_MIMO_Information_To_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___MU_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __MU_MIMO_Information_To_Modify_iE_Extensions__item_._ext = None
    _MU_MIMO_Information_To_Modify_iE_Extensions._cont = __MU_MIMO_Information_To_Modify_iE_Extensions__item_
    _MU_MIMO_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MU_MIMO_Information_To_Modify._cont = ASN1Dict([
        ('mU-MIMO-IndicatorLCR', _MU_MIMO_Information_To_Modify_mU_MIMO_IndicatorLCR),
        ('standalone-Midamble-Configuratnion', _MU_MIMO_Information_To_Modify_standalone_Midamble_Configuratnion),
        ('standalone-MidambleShift', _MU_MIMO_Information_To_Modify_standalone_MidambleShift),
        ('timeslotLCR', _MU_MIMO_Information_To_Modify_timeslotLCR),
        ('repetitionPeriod', _MU_MIMO_Information_To_Modify_repetitionPeriod),
        ('offset', _MU_MIMO_Information_To_Modify_offset),
        ('referenceBeta', _MU_MIMO_Information_To_Modify_referenceBeta),
        ('iE-Extensions', _MU_MIMO_Information_To_Modify_iE_Extensions),
        ])
    MU_MIMO_Information_To_Modify._ext = []
    
    #-----< MU-MIMO-Information-To-Modify-ExtIEs >-----#
    MU_MIMO_Information_To_Modify_ExtIEs = CLASS(name='MU-MIMO-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MU_MIMO_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MU-MIMO-IndicatorLCR >-----#
    MU_MIMO_IndicatorLCR = ENUM(name='MU-MIMO-IndicatorLCR', mode=MODE_TYPE)
    MU_MIMO_IndicatorLCR._cont = ASN1Dict([('uL-Only', 0), ('dL-Only', 1), ('uL-and-DL', 2)])
    MU_MIMO_IndicatorLCR._ext = []
    
    #-----< MU-MIMO-Usage-IndicatorLCR >-----#
    MU_MIMO_Usage_IndicatorLCR = ENUM(name='MU-MIMO-Usage-IndicatorLCR', mode=MODE_TYPE)
    MU_MIMO_Usage_IndicatorLCR._cont = ASN1Dict([('mU-MIMO-Used', 0), ('mU-MIMO-Not-Used', 1)])
    MU_MIMO_Usage_IndicatorLCR._ext = []
    
    #-----< Nack-Power-Offset >-----#
    Nack_Power_Offset = INT(name='Nack-Power-Offset', mode=MODE_TYPE)
    Nack_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=[], er=[ASN1RangeInt(lb=9, ub=10)])
    
    #-----< NCyclesPerSFNperiod >-----#
    NCyclesPerSFNperiod = ENUM(name='NCyclesPerSFNperiod', mode=MODE_TYPE)
    NCyclesPerSFNperiod._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v4', 2), ('v8', 3), ('v16', 4), ('v32', 5), ('v64', 6)])
    NCyclesPerSFNperiod._ext = ['v16', 'v32', 'v64']
    
    #-----< NRepetitionsPerCyclePeriod >-----#
    NRepetitionsPerCyclePeriod = INT(name='NRepetitionsPerCyclePeriod', mode=MODE_TYPE)
    NRepetitionsPerCyclePeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    
    #-----< N-INSYNC-IND >-----#
    N_INSYNC_IND = INT(name='N-INSYNC-IND', mode=MODE_TYPE)
    N_INSYNC_IND._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< N-OUTSYNC-IND >-----#
    N_OUTSYNC_IND = INT(name='N-OUTSYNC-IND', mode=MODE_TYPE)
    N_OUTSYNC_IND._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< N-PROTECT >-----#
    N_PROTECT = INT(name='N-PROTECT', mode=MODE_TYPE)
    N_PROTECT._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< NeighbouringCellMeasurementInformation >-----#
    NeighbouringCellMeasurementInformation = SEQ_OF(name='NeighbouringCellMeasurementInformation', mode=MODE_TYPE)
    _NeighbouringCellMeasurementInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __NeighbouringCellMeasurementInformation__item__neighbouringFDDCellMeasurementInformation = SEQ(name='neighbouringFDDCellMeasurementInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'NeighbouringFDDCellMeasurementInformation')))
    __NeighbouringCellMeasurementInformation__item__neighbouringTDDCellMeasurementInformation = SEQ(name='neighbouringTDDCellMeasurementInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'NeighbouringTDDCellMeasurementInformation')))
    __NeighbouringCellMeasurementInformation__item__extension_neighbouringCellMeasurementInformation = SEQ(name='extension-neighbouringCellMeasurementInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Extension-neighbouringCellMeasurementInformation')))
    _NeighbouringCellMeasurementInformation__item_._cont = ASN1Dict([
        ('neighbouringFDDCellMeasurementInformation', __NeighbouringCellMeasurementInformation__item__neighbouringFDDCellMeasurementInformation),
        ('neighbouringTDDCellMeasurementInformation', __NeighbouringCellMeasurementInformation__item__neighbouringTDDCellMeasurementInformation),
        ('extension-neighbouringCellMeasurementInformation', __NeighbouringCellMeasurementInformation__item__extension_neighbouringCellMeasurementInformation),
        ])
    _NeighbouringCellMeasurementInformation__item_._ext = ['extension-neighbouringCellMeasurementInformation']
    NeighbouringCellMeasurementInformation._cont = _NeighbouringCellMeasurementInformation__item_
    NeighbouringCellMeasurementInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=96)], ev=None, er=[])
    
    #-----< NodeB-Triggered-HSDPCCH-Transmission-Information >-----#
    NodeB_Triggered_HSDPCCH_Transmission_Information = SEQ(name='NodeB-Triggered-HSDPCCH-Transmission-Information', mode=MODE_TYPE)
    _NodeB_Triggered_HSDPCCH_Transmission_Information_hS_DPCCH_transmission_continuation_backoff = ENUM(name='hS-DPCCH-transmission-continuation-backoff', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DPCCH-transmission-continuation-backoff')))
    _NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__id._const_tab = ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__id_tab
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__id._const_tab_at = None
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__criticality._const_tab = ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__criticality_tab
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__extensionValue._const_tab = ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__extensionValue_tab
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__id),
        ('criticality', ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__extensionValue),
        ])
    __NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item_._ext = None
    _NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions._cont = __NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item_
    _NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NodeB_Triggered_HSDPCCH_Transmission_Information._cont = ASN1Dict([
        ('hS-DPCCH-transmission-continuation-backoff', _NodeB_Triggered_HSDPCCH_Transmission_Information_hS_DPCCH_transmission_continuation_backoff),
        ('iE-Extensions', _NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions),
        ])
    NodeB_Triggered_HSDPCCH_Transmission_Information._ext = []
    
    #-----< NodeB-Triggered-HSDPCCH-Transmission-Information-ExtIEs >-----#
    NodeB_Triggered_HSDPCCH_Transmission_Information_ExtIEs = CLASS(name='NodeB-Triggered-HSDPCCH-Transmission-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    NodeB_Triggered_HSDPCCH_Transmission_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extension-neighbouringCellMeasurementInformation >-----#
    Extension_neighbouringCellMeasurementInformation = SEQ(name='Extension-neighbouringCellMeasurementInformation', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_neighbouringCellMeasurementInformation_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_neighbouringCellMeasurementInformation_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_neighbouringCellMeasurementInformation_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NeighbouringTDDCellMeasurementInformationLCR')))
    ___Extension_neighbouringCellMeasurementInformation_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NeighbouringTDDCellMeasurementInformation768')))
    __Extension_neighbouringCellMeasurementInformation_id_tab._val = ASN1Set(rv=[dict([('id', 58), ('criticality', 'reject'), ('Value', ___Extension_neighbouringCellMeasurementInformation_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 727), ('criticality', 'reject'), ('Value', ___Extension_neighbouringCellMeasurementInformation_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_neighbouringCellMeasurementInformation_id._const_tab = __Extension_neighbouringCellMeasurementInformation_id_tab
    _Extension_neighbouringCellMeasurementInformation_id._const_tab_at = None
    _Extension_neighbouringCellMeasurementInformation_id._const_tab_id = 'id'
    _Extension_neighbouringCellMeasurementInformation_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_neighbouringCellMeasurementInformation_criticality._const_tab = __Extension_neighbouringCellMeasurementInformation_id_tab
    _Extension_neighbouringCellMeasurementInformation_criticality._const_tab_at = ('..', 'id')
    _Extension_neighbouringCellMeasurementInformation_criticality._const_tab_id = 'criticality'
    _Extension_neighbouringCellMeasurementInformation_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_neighbouringCellMeasurementInformation_value._const_tab = __Extension_neighbouringCellMeasurementInformation_id_tab
    _Extension_neighbouringCellMeasurementInformation_value._const_tab_at = ('..', 'id')
    _Extension_neighbouringCellMeasurementInformation_value._const_tab_id = 'Value'
    Extension_neighbouringCellMeasurementInformation._cont = ASN1Dict([
        ('id', _Extension_neighbouringCellMeasurementInformation_id),
        ('criticality', _Extension_neighbouringCellMeasurementInformation_criticality),
        ('value', _Extension_neighbouringCellMeasurementInformation_value),
        ])
    Extension_neighbouringCellMeasurementInformation._ext = None
    
    #-----< Extension-neighbouringCellMeasurementInformationIE >-----#
    Extension_neighbouringCellMeasurementInformationIE = CLASS(name='Extension-neighbouringCellMeasurementInformationIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_neighbouringCellMeasurementInformationIE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NeighbouringTDDCellMeasurementInformationLCR')))
    _Extension_neighbouringCellMeasurementInformationIE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NeighbouringTDDCellMeasurementInformation768')))
    Extension_neighbouringCellMeasurementInformationIE._val = ASN1Set(rv=[dict([('id', 58), ('criticality', 'reject'), ('Value', _Extension_neighbouringCellMeasurementInformationIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 727), ('criticality', 'reject'), ('Value', _Extension_neighbouringCellMeasurementInformationIE_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< NeighbouringFDDCellMeasurementInformation >-----#
    NeighbouringFDDCellMeasurementInformation = SEQ(name='NeighbouringFDDCellMeasurementInformation', mode=MODE_TYPE)
    _NeighbouringFDDCellMeasurementInformation_uC_Id = SEQ(name='uC-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UC-Id')))
    _NeighbouringFDDCellMeasurementInformation_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _NeighbouringFDDCellMeasurementInformation_primaryScramblingCode = INT(name='primaryScramblingCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PrimaryScramblingCode')))
    _NeighbouringFDDCellMeasurementInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NeighbouringFDDCellMeasurementInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id._const_tab = ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id_tab
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id._const_tab_at = None
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab = ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality_tab
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab = ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NeighbouringFDDCellMeasurementInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id),
        ('criticality', ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue),
        ])
    __NeighbouringFDDCellMeasurementInformation_iE_Extensions__item_._ext = None
    _NeighbouringFDDCellMeasurementInformation_iE_Extensions._cont = __NeighbouringFDDCellMeasurementInformation_iE_Extensions__item_
    _NeighbouringFDDCellMeasurementInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NeighbouringFDDCellMeasurementInformation._cont = ASN1Dict([
        ('uC-Id', _NeighbouringFDDCellMeasurementInformation_uC_Id),
        ('uARFCN', _NeighbouringFDDCellMeasurementInformation_uARFCN),
        ('primaryScramblingCode', _NeighbouringFDDCellMeasurementInformation_primaryScramblingCode),
        ('iE-Extensions', _NeighbouringFDDCellMeasurementInformation_iE_Extensions),
        ])
    NeighbouringFDDCellMeasurementInformation._ext = []
    
    #-----< NeighbouringFDDCellMeasurementInformationItem-ExtIEs >-----#
    NeighbouringFDDCellMeasurementInformationItem_ExtIEs = CLASS(name='NeighbouringFDDCellMeasurementInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    NeighbouringFDDCellMeasurementInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NeighbouringTDDCellMeasurementInformation >-----#
    NeighbouringTDDCellMeasurementInformation = SEQ(name='NeighbouringTDDCellMeasurementInformation', mode=MODE_TYPE)
    _NeighbouringTDDCellMeasurementInformation_uC_Id = SEQ(name='uC-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UC-Id')))
    _NeighbouringTDDCellMeasurementInformation_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _NeighbouringTDDCellMeasurementInformation_cellParameterID = INT(name='cellParameterID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    _NeighbouringTDDCellMeasurementInformation_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')), opt=True)
    _NeighbouringTDDCellMeasurementInformation_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _NeighbouringTDDCellMeasurementInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NeighbouringTDDCellMeasurementInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id._const_tab = ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id_tab
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id._const_tab_at = None
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab = ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality_tab
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab = ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NeighbouringTDDCellMeasurementInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id),
        ('criticality', ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue),
        ])
    __NeighbouringTDDCellMeasurementInformation_iE_Extensions__item_._ext = None
    _NeighbouringTDDCellMeasurementInformation_iE_Extensions._cont = __NeighbouringTDDCellMeasurementInformation_iE_Extensions__item_
    _NeighbouringTDDCellMeasurementInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NeighbouringTDDCellMeasurementInformation._cont = ASN1Dict([
        ('uC-Id', _NeighbouringTDDCellMeasurementInformation_uC_Id),
        ('uARFCN', _NeighbouringTDDCellMeasurementInformation_uARFCN),
        ('cellParameterID', _NeighbouringTDDCellMeasurementInformation_cellParameterID),
        ('timeSlot', _NeighbouringTDDCellMeasurementInformation_timeSlot),
        ('midambleShiftAndBurstType', _NeighbouringTDDCellMeasurementInformation_midambleShiftAndBurstType),
        ('iE-Extensions', _NeighbouringTDDCellMeasurementInformation_iE_Extensions),
        ])
    NeighbouringTDDCellMeasurementInformation._ext = []
    
    #-----< NeighbouringTDDCellMeasurementInformationItem-ExtIEs >-----#
    NeighbouringTDDCellMeasurementInformationItem_ExtIEs = CLASS(name='NeighbouringTDDCellMeasurementInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    NeighbouringTDDCellMeasurementInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NeighbouringTDDCellMeasurementInformationLCR >-----#
    NeighbouringTDDCellMeasurementInformationLCR = SEQ(name='NeighbouringTDDCellMeasurementInformationLCR', mode=MODE_TYPE)
    _NeighbouringTDDCellMeasurementInformationLCR_uC_Id = SEQ(name='uC-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UC-Id')))
    _NeighbouringTDDCellMeasurementInformationLCR_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _NeighbouringTDDCellMeasurementInformationLCR_cellParameterID = INT(name='cellParameterID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    _NeighbouringTDDCellMeasurementInformationLCR_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')), opt=True)
    _NeighbouringTDDCellMeasurementInformationLCR_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')), opt=True)
    _NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id._const_tab = ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id_tab
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality._const_tab = ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality_tab
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue._const_tab = ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue_tab
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id),
        ('criticality', ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue),
        ])
    __NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item_._ext = None
    _NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions._cont = __NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item_
    _NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NeighbouringTDDCellMeasurementInformationLCR._cont = ASN1Dict([
        ('uC-Id', _NeighbouringTDDCellMeasurementInformationLCR_uC_Id),
        ('uARFCN', _NeighbouringTDDCellMeasurementInformationLCR_uARFCN),
        ('cellParameterID', _NeighbouringTDDCellMeasurementInformationLCR_cellParameterID),
        ('timeSlotLCR', _NeighbouringTDDCellMeasurementInformationLCR_timeSlotLCR),
        ('midambleShiftLCR', _NeighbouringTDDCellMeasurementInformationLCR_midambleShiftLCR),
        ('iE-Extensions', _NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions),
        ])
    NeighbouringTDDCellMeasurementInformationLCR._ext = []
    
    #-----< NeighbouringTDDCellMeasurementInformationLCRItem-ExtIEs >-----#
    NeighbouringTDDCellMeasurementInformationLCRItem_ExtIEs = CLASS(name='NeighbouringTDDCellMeasurementInformationLCRItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    NeighbouringTDDCellMeasurementInformationLCRItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NeighbouringTDDCellMeasurementInformation768 >-----#
    NeighbouringTDDCellMeasurementInformation768 = SEQ(name='NeighbouringTDDCellMeasurementInformation768', mode=MODE_TYPE)
    _NeighbouringTDDCellMeasurementInformation768_uC_Id = SEQ(name='uC-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UC-Id')))
    _NeighbouringTDDCellMeasurementInformation768_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _NeighbouringTDDCellMeasurementInformation768_cellParameterID = INT(name='cellParameterID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    _NeighbouringTDDCellMeasurementInformation768_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')), opt=True)
    _NeighbouringTDDCellMeasurementInformation768_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')), opt=True)
    _NeighbouringTDDCellMeasurementInformation768_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id._const_tab = ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id_tab
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id._const_tab_at = None
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id._const_tab_id = 'id'
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality._const_tab = ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality_tab
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue._const_tab = ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue_tab
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id),
        ('criticality', ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality),
        ('extensionValue', ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue),
        ])
    __NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item_._ext = None
    _NeighbouringTDDCellMeasurementInformation768_iE_Extensions._cont = __NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item_
    _NeighbouringTDDCellMeasurementInformation768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NeighbouringTDDCellMeasurementInformation768._cont = ASN1Dict([
        ('uC-Id', _NeighbouringTDDCellMeasurementInformation768_uC_Id),
        ('uARFCN', _NeighbouringTDDCellMeasurementInformation768_uARFCN),
        ('cellParameterID', _NeighbouringTDDCellMeasurementInformation768_cellParameterID),
        ('timeSlot', _NeighbouringTDDCellMeasurementInformation768_timeSlot),
        ('midambleShiftAndBurstType768', _NeighbouringTDDCellMeasurementInformation768_midambleShiftAndBurstType768),
        ('iE-Extensions', _NeighbouringTDDCellMeasurementInformation768_iE_Extensions),
        ])
    NeighbouringTDDCellMeasurementInformation768._ext = []
    
    #-----< NeighbouringTDDCellMeasurementInformation768Item-ExtIEs >-----#
    NeighbouringTDDCellMeasurementInformation768Item_ExtIEs = CLASS(name='NeighbouringTDDCellMeasurementInformation768Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    NeighbouringTDDCellMeasurementInformation768Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Non-rectangular-resource-allocation-indicator >-----#
    Non_rectangular_resource_allocation_indicator = ENUM(name='Non-rectangular-resource-allocation-indicator', mode=MODE_TYPE)
    Non_rectangular_resource_allocation_indicator._cont = ASN1Dict([('activate', 0)])
    Non_rectangular_resource_allocation_indicator._ext = None
    
    #-----< Non-rectangular-resource-timeslot-set >-----#
    Non_rectangular_resource_timeslot_set = BIT_STR(name='Non-rectangular-resource-timeslot-set', mode=MODE_TYPE)
    Non_rectangular_resource_timeslot_set._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< NonCellSpecificTxDiversity >-----#
    NonCellSpecificTxDiversity = ENUM(name='NonCellSpecificTxDiversity', mode=MODE_TYPE)
    NonCellSpecificTxDiversity._cont = ASN1Dict([('txDiversity', 0)])
    NonCellSpecificTxDiversity._ext = []
    
    #-----< Non-Serving-RL-Preconfig-Setup >-----#
    Non_Serving_RL_Preconfig_Setup = SEQ(name='Non-Serving-RL-Preconfig-Setup', mode=MODE_TYPE)
    _Non_Serving_RL_Preconfig_Setup_new_non_serving_RL_selection = CHOICE(name='new-non-serving-RL-selection', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'New-non-serving-RL-setup-selection')))
    _Non_Serving_RL_Preconfig_Setup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Non_Serving_RL_Preconfig_Setup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup')))
    ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1176), ('criticality', 'ignore'), ('Extension', _____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id._const_tab = ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id._const_tab_at = None
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id._const_tab_id = 'id'
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality._const_tab = ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue._const_tab = ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Non_Serving_RL_Preconfig_Setup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id),
        ('criticality', ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality),
        ('extensionValue', ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue),
        ])
    __Non_Serving_RL_Preconfig_Setup_iE_Extensions__item_._ext = None
    _Non_Serving_RL_Preconfig_Setup_iE_Extensions._cont = __Non_Serving_RL_Preconfig_Setup_iE_Extensions__item_
    _Non_Serving_RL_Preconfig_Setup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Non_Serving_RL_Preconfig_Setup._cont = ASN1Dict([
        ('new-non-serving-RL-selection', _Non_Serving_RL_Preconfig_Setup_new_non_serving_RL_selection),
        ('iE-Extensions', _Non_Serving_RL_Preconfig_Setup_iE_Extensions),
        ])
    Non_Serving_RL_Preconfig_Setup._ext = []
    
    #-----< Non-Serving-RL-Preconfig-Setup-ExtIEs >-----#
    Non_Serving_RL_Preconfig_Setup_ExtIEs = CLASS(name='Non-Serving-RL-Preconfig-Setup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Non_Serving_RL_Preconfig_Setup_ExtIEs_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup')))
    Non_Serving_RL_Preconfig_Setup_ExtIEs._val = ASN1Set(rv=[dict([('id', 1176), ('criticality', 'ignore'), ('Extension', _Non_Serving_RL_Preconfig_Setup_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup >-----#
    Additional_E_DCH_Non_Serving_RL_Preconfiguration_Setup = NULL(name='Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup', mode=MODE_TYPE)
    
    #-----< New-non-serving-RL-setup-selection >-----#
    New_non_serving_RL_setup_selection = CHOICE(name='New-non-serving-RL-setup-selection', mode=MODE_TYPE)
    _New_non_serving_RL_setup_selection_new_Serving_RL_in_NodeB = NULL(name='new-Serving-RL-in-NodeB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _New_non_serving_RL_setup_selection_new_Serving_RL_Not_in_NodeB = NULL(name='new-Serving-RL-Not-in-NodeB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _New_non_serving_RL_setup_selection_new_Serving_RL_in_or_Not_in_NodeB = NULL(name='new-Serving-RL-in-or-Not-in-NodeB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    New_non_serving_RL_setup_selection._cont = ASN1Dict([
        ('new-Serving-RL-in-NodeB', _New_non_serving_RL_setup_selection_new_Serving_RL_in_NodeB),
        ('new-Serving-RL-Not-in-NodeB', _New_non_serving_RL_setup_selection_new_Serving_RL_Not_in_NodeB),
        ('new-Serving-RL-in-or-Not-in-NodeB', _New_non_serving_RL_setup_selection_new_Serving_RL_in_or_Not_in_NodeB),
        ])
    New_non_serving_RL_setup_selection._ext = []
    
    #-----< Non-Serving-RL-Preconfig-Info >-----#
    Non_Serving_RL_Preconfig_Info = SEQ(name='Non-Serving-RL-Preconfig-Info', mode=MODE_TYPE)
    _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_A = SEQ(name='new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-A', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')), opt=True)
    _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_B = SEQ(name='new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-B', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')), opt=True)
    _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_C = SEQ(name='new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-C', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')), opt=True)
    _Non_Serving_RL_Preconfig_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Non_Serving_RL_Preconfig_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList')))
    _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information')))
    ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1177), ('criticality', 'ignore'), ('Extension', _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1215), ('criticality', 'ignore'), ('Extension', _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id._const_tab = ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id._const_tab_at = None
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality._const_tab = ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue._const_tab = ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Non_Serving_RL_Preconfig_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id),
        ('criticality', ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue),
        ])
    __Non_Serving_RL_Preconfig_Info_iE_Extensions__item_._ext = None
    _Non_Serving_RL_Preconfig_Info_iE_Extensions._cont = __Non_Serving_RL_Preconfig_Info_iE_Extensions__item_
    _Non_Serving_RL_Preconfig_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Non_Serving_RL_Preconfig_Info._cont = ASN1Dict([
        ('new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-A', _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_A),
        ('new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-B', _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_B),
        ('new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-C', _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_C),
        ('iE-Extensions', _Non_Serving_RL_Preconfig_Info_iE_Extensions),
        ])
    Non_Serving_RL_Preconfig_Info._ext = []
    
    #-----< Non-Serving-RL-Preconfig-Info-ExtIEs >-----#
    Non_Serving_RL_Preconfig_Info_ExtIEs = CLASS(name='Non-Serving-RL-Preconfig-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList')))
    _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information')))
    Non_Serving_RL_Preconfig_Info_ExtIEs._val = ASN1Set(rv=[dict([('id', 1177), ('criticality', 'ignore'), ('Extension', _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1215), ('criticality', 'ignore'), ('Extension', _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList >-----#
    Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList = SEQ_OF(name='Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList', mode=MODE_TYPE)
    _Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_A = SEQ(name='new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-A', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')), opt=True)
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_B = SEQ(name='new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-B', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')), opt=True)
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_C = SEQ(name='new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-C', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')), opt=True)
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id._const_tab = _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id_tab
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id._const_tab_at = None
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality._const_tab = _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality_tab
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue._const_tab = _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue_tab
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id),
        ('criticality', ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality),
        ('extensionValue', ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue),
        ])
    ___Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item_._ext = None
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions._cont = ___Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item_
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item_._cont = ASN1Dict([
        ('new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-A', __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_A),
        ('new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-B', __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_B),
        ('new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-C', __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_C),
        ('iE-Extensions', __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions),
        ])
    _Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item_._ext = []
    Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList._cont = _Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item_
    Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList-ExtIEs >-----#
    Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList_ExtIEs = CLASS(name='Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NI-Information >-----#
    NI_Information = SEQ_OF(name='NI-Information', mode=MODE_TYPE)
    _NI_Information__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Notification-Indicator')))
    NI_Information._cont = _NI_Information__item_
    NI_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Notification-Indicator >-----#
    Notification_Indicator = INT(name='Notification-Indicator', mode=MODE_TYPE)
    Notification_Indicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NodeB-CommunicationContextID >-----#
    NodeB_CommunicationContextID = INT(name='NodeB-CommunicationContextID', mode=MODE_TYPE)
    NodeB_CommunicationContextID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< NormalAndDiversityPrimaryCPICHContainer >-----#
    NormalAndDiversityPrimaryCPICHContainer = SEQ(name='NormalAndDiversityPrimaryCPICHContainer', mode=MODE_TYPE)
    _NormalAndDiversityPrimaryCPICHContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__id._const_tab = ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__id_tab
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__id._const_tab_at = None
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__criticality._const_tab = ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__criticality_tab
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__extensionValue._const_tab = ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__extensionValue_tab
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__id),
        ('criticality', ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__extensionValue),
        ])
    __NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item_._ext = None
    _NormalAndDiversityPrimaryCPICHContainer_iE_Extensions._cont = __NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item_
    _NormalAndDiversityPrimaryCPICHContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NormalAndDiversityPrimaryCPICHContainer._cont = ASN1Dict([
        ('iE-Extensions', _NormalAndDiversityPrimaryCPICHContainer_iE_Extensions),
        ])
    NormalAndDiversityPrimaryCPICHContainer._ext = []
    
    #-----< NormalAndDiversityPrimaryCPICHContainer-ExtIEs >-----#
    NormalAndDiversityPrimaryCPICHContainer_ExtIEs = CLASS(name='NormalAndDiversityPrimaryCPICHContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    NormalAndDiversityPrimaryCPICHContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NotificationIndicatorLength >-----#
    NotificationIndicatorLength = ENUM(name='NotificationIndicatorLength', mode=MODE_TYPE)
    NotificationIndicatorLength._cont = ASN1Dict([('v2', 0), ('v4', 1), ('v8', 2)])
    NotificationIndicatorLength._ext = []
    
    #-----< NumberOfReportedCellPortions >-----#
    NumberOfReportedCellPortions = INT(name='NumberOfReportedCellPortions', mode=MODE_TYPE)
    NumberOfReportedCellPortions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=[], er=[])
    
    #-----< NumberOfReportedCellPortionsLCR >-----#
    NumberOfReportedCellPortionsLCR = INT(name='NumberOfReportedCellPortionsLCR', mode=MODE_TYPE)
    NumberOfReportedCellPortionsLCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< Number-of-PCCH-transmission >-----#
    Number_of_PCCH_transmission = INT(name='Number-of-PCCH-transmission', mode=MODE_TYPE)
    Number_of_PCCH_transmission._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< NSubCyclesPerCyclePeriod >-----#
    NSubCyclesPerCyclePeriod = INT(name='NSubCyclesPerCyclePeriod', mode=MODE_TYPE)
    NSubCyclesPerCyclePeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< N-E-UCCH >-----#
    N_E_UCCH = INT(name='N-E-UCCH', mode=MODE_TYPE)
    N_E_UCCH._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< N-E-UCCHLCR >-----#
    N_E_UCCHLCR = INT(name='N-E-UCCHLCR', mode=MODE_TYPE)
    N_E_UCCHLCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Number-Of-Supported-Carriers >-----#
    Number_Of_Supported_Carriers = ENUM(name='Number-Of-Supported-Carriers', mode=MODE_TYPE)
    Number_Of_Supported_Carriers._cont = ASN1Dict([('one-one-carrier', 0), ('one-three-carrier', 1), ('three-three-carrier', 2), ('one-six-carrier', 3), ('three-six-carrier', 4), ('six-six-carrier', 5), ('one-two-carrier-discontiguous', 6), ('two-two-carrier-discontiguous', 7), ('one-two-carrier-contiguous', 8), ('two-two-carrier-contiguous', 9)])
    Number_Of_Supported_Carriers._ext = ['one-two-carrier-discontiguous', 'two-two-carrier-discontiguous', 'one-two-carrier-contiguous', 'two-two-carrier-contiguous']
    
    #-----< NumHS-SCCH-Codes >-----#
    NumHS_SCCH_Codes = INT(name='NumHS-SCCH-Codes', mode=MODE_TYPE)
    NumHS_SCCH_Codes._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< NoOfTargetCellHS-SCCH-Order >-----#
    NoOfTargetCellHS_SCCH_Order = INT(name='NoOfTargetCellHS-SCCH-Order', mode=MODE_TYPE)
    NoOfTargetCellHS_SCCH_Order._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< OrdinalNumberOfFrequency >-----#
    OrdinalNumberOfFrequency = INT(name='OrdinalNumberOfFrequency', mode=MODE_TYPE)
    OrdinalNumberOfFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< Out-of-Sychronization-Window >-----#
    Out_of_Sychronization_Window = ENUM(name='Out-of-Sychronization-Window', mode=MODE_TYPE)
    Out_of_Sychronization_Window._cont = ASN1Dict([('ms40', 0), ('ms80', 1), ('ms160', 2), ('ms320', 3), ('ms640', 4)])
    Out_of_Sychronization_Window._ext = []
    
    #-----< One-level-DRX >-----#
    One_level_DRX = SEQ(name='One-level-DRX', mode=MODE_TYPE)
    _One_level_DRX_hS_DSCH_second_Rx_burst_FACH = ENUM(name='hS-DSCH-second-Rx-burst-FACH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-second-Rx-burst-FACH')), opt=True)
    _One_level_DRX_t32y = ENUM(name='t32y', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T32y')), opt=True)
    _One_level_DRX_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __One_level_DRX_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___One_level_DRX_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____One_level_DRX_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____One_level_DRX_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___One_level_DRX_iE_Extensions__item__id._const_tab = ____One_level_DRX_iE_Extensions__item__id_tab
    ___One_level_DRX_iE_Extensions__item__id._const_tab_at = None
    ___One_level_DRX_iE_Extensions__item__id._const_tab_id = 'id'
    ___One_level_DRX_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____One_level_DRX_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____One_level_DRX_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___One_level_DRX_iE_Extensions__item__criticality._const_tab = ____One_level_DRX_iE_Extensions__item__criticality_tab
    ___One_level_DRX_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___One_level_DRX_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___One_level_DRX_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____One_level_DRX_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____One_level_DRX_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___One_level_DRX_iE_Extensions__item__extensionValue._const_tab = ____One_level_DRX_iE_Extensions__item__extensionValue_tab
    ___One_level_DRX_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___One_level_DRX_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __One_level_DRX_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___One_level_DRX_iE_Extensions__item__id),
        ('criticality', ___One_level_DRX_iE_Extensions__item__criticality),
        ('extensionValue', ___One_level_DRX_iE_Extensions__item__extensionValue),
        ])
    __One_level_DRX_iE_Extensions__item_._ext = None
    _One_level_DRX_iE_Extensions._cont = __One_level_DRX_iE_Extensions__item_
    _One_level_DRX_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    One_level_DRX._cont = ASN1Dict([
        ('hS-DSCH-second-Rx-burst-FACH', _One_level_DRX_hS_DSCH_second_Rx_burst_FACH),
        ('t32y', _One_level_DRX_t32y),
        ('iE-Extensions', _One_level_DRX_iE_Extensions),
        ])
    One_level_DRX._ext = []
    
    #-----< One-level-DRX-ExtIEs >-----#
    One_level_DRX_ExtIEs = CLASS(name='One-level-DRX-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    One_level_DRX_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingIndicatorLength >-----#
    PagingIndicatorLength = ENUM(name='PagingIndicatorLength', mode=MODE_TYPE)
    PagingIndicatorLength._cont = ASN1Dict([('v2', 0), ('v4', 1), ('v8', 2)])
    PagingIndicatorLength._ext = []
    
    #-----< Paging-MACFlow-ID >-----#
    Paging_MACFlow_ID = INT(name='Paging-MACFlow-ID', mode=MODE_TYPE)
    Paging_MACFlow_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< PayloadCRC-PresenceIndicator >-----#
    PayloadCRC_PresenceIndicator = ENUM(name='PayloadCRC-PresenceIndicator', mode=MODE_TYPE)
    PayloadCRC_PresenceIndicator._cont = ASN1Dict([('cRC-Included', 0), ('cRC-NotIncluded', 1)])
    PayloadCRC_PresenceIndicator._ext = []
    
    #-----< PCCPCH-Power >-----#
    PCCPCH_Power = INT(name='PCCPCH-Power', mode=MODE_TYPE)
    PCCPCH_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-150, ub=400)], ev=[], er=[])
    
    #-----< PDSCH-ID >-----#
    PDSCH_ID = INT(name='PDSCH-ID', mode=MODE_TYPE)
    PDSCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PDSCH-ID768 >-----#
    PDSCH_ID768 = INT(name='PDSCH-ID768', mode=MODE_TYPE)
    PDSCH_ID768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< PDSCHSet-ID >-----#
    PDSCHSet_ID = INT(name='PDSCHSet-ID', mode=MODE_TYPE)
    PDSCHSet_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PICH-Mode >-----#
    PICH_Mode = ENUM(name='PICH-Mode', mode=MODE_TYPE)
    PICH_Mode._cont = ASN1Dict([('v18', 0), ('v36', 1), ('v72', 2), ('v144', 3)])
    PICH_Mode._ext = []
    
    #-----< PICH-Power >-----#
    PICH_Power = INT(name='PICH-Power', mode=MODE_TYPE)
    PICH_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-10, ub=5)], ev=None, er=[])
    
    #-----< Paging-MACFlows-to-DeleteFDD >-----#
    Paging_MACFlows_to_DeleteFDD = SEQ_OF(name='Paging-MACFlows-to-DeleteFDD', mode=MODE_TYPE)
    _Paging_MACFlows_to_DeleteFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlows-to-DeleteFDD-Item')))
    Paging_MACFlows_to_DeleteFDD._cont = _Paging_MACFlows_to_DeleteFDD__item_
    Paging_MACFlows_to_DeleteFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Paging-MACFlows-to-DeleteFDD-Item >-----#
    Paging_MACFlows_to_DeleteFDD_Item = SEQ(name='Paging-MACFlows-to-DeleteFDD-Item', mode=MODE_TYPE)
    _Paging_MACFlows_to_DeleteFDD_Item_paging_MACFlow_ID = INT(name='paging-MACFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlow-ID')))
    _Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id._const_tab = ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id_tab
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id._const_tab_at = None
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality._const_tab = ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality_tab
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue._const_tab = ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue_tab
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id),
        ('criticality', ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue),
        ])
    __Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item_._ext = None
    _Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions._cont = __Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item_
    _Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Paging_MACFlows_to_DeleteFDD_Item._cont = ASN1Dict([
        ('paging-MACFlow-ID', _Paging_MACFlows_to_DeleteFDD_Item_paging_MACFlow_ID),
        ('iE-Extensions', _Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions),
        ])
    Paging_MACFlows_to_DeleteFDD_Item._ext = []
    
    #-----< Paging-MACFlows-to-DeleteFDD-Item-ExtIEs >-----#
    Paging_MACFlows_to_DeleteFDD_Item_ExtIEs = CLASS(name='Paging-MACFlows-to-DeleteFDD-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Paging_MACFlows_to_DeleteFDD_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Paging-MACFlow-Specific-Information >-----#
    Paging_MACFlow_Specific_Information = SEQ_OF(name='Paging-MACFlow-Specific-Information', mode=MODE_TYPE)
    _Paging_MACFlow_Specific_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Paging-MAC-Flow-Specific-Information-Item')))
    Paging_MACFlow_Specific_Information._cont = _Paging_MACFlow_Specific_Information__item_
    Paging_MACFlow_Specific_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Paging-MAC-Flow-Specific-Information-Item >-----#
    Paging_MAC_Flow_Specific_Information_Item = SEQ(name='Paging-MAC-Flow-Specific-Information-Item', mode=MODE_TYPE)
    _Paging_MAC_Flow_Specific_Information_Item_paging_MACFlow_Id = INT(name='paging-MACFlow-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlow-ID')))
    _Paging_MAC_Flow_Specific_Information_Item_hSDPA_associated_PICH_Info = CHOICE(name='hSDPA-associated-PICH-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-Associated-PICH-Information')))
    _Paging_MAC_Flow_Specific_Information_Item_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _Paging_MAC_Flow_Specific_Information_Item_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _Paging_MAC_Flow_Specific_Information_Item_tnl_qos = CHOICE(name='tnl-qos', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')), opt=True)
    _Paging_MAC_Flow_Specific_Information_Item_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')))
    _Paging_MAC_Flow_Specific_Information_Item_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')))
    _Paging_MAC_Flow_Specific_Information_Item_paging_MACFlow_PriorityQueue_Information = SEQ_OF(name='paging-MACFlow-PriorityQueue-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlow-PriorityQueue-Information')), opt=True)
    _Paging_MAC_Flow_Specific_Information_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    ____Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 996), ('criticality', 'ignore'), ('Extension', _____Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id._const_tab = ____Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id_tab
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__criticality._const_tab = ____Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id_tab
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id_tab
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id),
        ('criticality', ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item_._ext = None
    _Paging_MAC_Flow_Specific_Information_Item_iE_Extensions._cont = __Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item_
    _Paging_MAC_Flow_Specific_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Paging_MAC_Flow_Specific_Information_Item._cont = ASN1Dict([
        ('paging-MACFlow-Id', _Paging_MAC_Flow_Specific_Information_Item_paging_MACFlow_Id),
        ('hSDPA-associated-PICH-Info', _Paging_MAC_Flow_Specific_Information_Item_hSDPA_associated_PICH_Info),
        ('bindingID', _Paging_MAC_Flow_Specific_Information_Item_bindingID),
        ('transportLayerAddress', _Paging_MAC_Flow_Specific_Information_Item_transportLayerAddress),
        ('tnl-qos', _Paging_MAC_Flow_Specific_Information_Item_tnl_qos),
        ('toAWS', _Paging_MAC_Flow_Specific_Information_Item_toAWS),
        ('toAWE', _Paging_MAC_Flow_Specific_Information_Item_toAWE),
        ('paging-MACFlow-PriorityQueue-Information', _Paging_MAC_Flow_Specific_Information_Item_paging_MACFlow_PriorityQueue_Information),
        ('iE-Extensions', _Paging_MAC_Flow_Specific_Information_Item_iE_Extensions),
        ])
    Paging_MAC_Flow_Specific_Information_Item._ext = []
    
    #-----< Paging-MAC-Flow-Specific-Information-Item-ExtIEs >-----#
    Paging_MAC_Flow_Specific_Information_Item_ExtIEs = CLASS(name='Paging-MAC-Flow-Specific-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Paging_MAC_Flow_Specific_Information_Item_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    Paging_MAC_Flow_Specific_Information_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 996), ('criticality', 'ignore'), ('Extension', _Paging_MAC_Flow_Specific_Information_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Paging-MACFlow-PriorityQueue-Information >-----#
    Paging_MACFlow_PriorityQueue_Information = SEQ_OF(name='Paging-MACFlow-PriorityQueue-Information', mode=MODE_TYPE)
    _Paging_MACFlow_PriorityQueue_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlow-PriorityQueue-Item')))
    Paging_MACFlow_PriorityQueue_Information._cont = _Paging_MACFlow_PriorityQueue_Information__item_
    Paging_MACFlow_PriorityQueue_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Paging-MACFlow-PriorityQueue-Item >-----#
    Paging_MACFlow_PriorityQueue_Item = SEQ(name='Paging-MACFlow-PriorityQueue-Item', mode=MODE_TYPE)
    _Paging_MACFlow_PriorityQueue_Item_priority_Queue_Information_for_Enhanced_PCH = SEQ(name='priority-Queue-Information-for-Enhanced-PCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Priority-Queue-Information-for-Enhanced-FACH-PCH')))
    _Paging_MACFlow_PriorityQueue_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__id._const_tab = ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__id_tab
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__id._const_tab_at = None
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality._const_tab = ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality_tab
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue._const_tab = ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue_tab
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__id),
        ('criticality', ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue),
        ])
    __Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item_._ext = None
    _Paging_MACFlow_PriorityQueue_Item_iE_Extensions._cont = __Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item_
    _Paging_MACFlow_PriorityQueue_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Paging_MACFlow_PriorityQueue_Item._cont = ASN1Dict([
        ('priority-Queue-Information-for-Enhanced-PCH', _Paging_MACFlow_PriorityQueue_Item_priority_Queue_Information_for_Enhanced_PCH),
        ('iE-Extensions', _Paging_MACFlow_PriorityQueue_Item_iE_Extensions),
        ])
    Paging_MACFlow_PriorityQueue_Item._ext = []
    
    #-----< Paging-MACFlow-PriorityQueue-Item-ExtIEs >-----#
    Paging_MACFlow_PriorityQueue_Item_ExtIEs = CLASS(name='Paging-MACFlow-PriorityQueue-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Paging_MACFlow_PriorityQueue_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Pattern-Sequence-Identifier >-----#
    Pattern_Sequence_Identifier = INT(name='Pattern-Sequence-Identifier', mode=MODE_TYPE)
    Pattern_Sequence_Identifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< PhysicalChannelID-for-CommonERNTI-RequestedIndicator >-----#
    PhysicalChannelID_for_CommonERNTI_RequestedIndicator = ENUM(name='PhysicalChannelID-for-CommonERNTI-RequestedIndicator', mode=MODE_TYPE)
    PhysicalChannelID_for_CommonERNTI_RequestedIndicator._cont = ASN1Dict([('requested', 0)])
    PhysicalChannelID_for_CommonERNTI_RequestedIndicator._ext = None
    
    #-----< PLCCHsequenceNumber >-----#
    PLCCHsequenceNumber = INT(name='PLCCHsequenceNumber', mode=MODE_TYPE)
    PLCCHsequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< PLCCHinformation >-----#
    PLCCHinformation = SEQ(name='PLCCHinformation', mode=MODE_TYPE)
    _PLCCHinformation_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PLCCHinformation_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PLCCHsequenceNumber')))
    _PLCCHinformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLCCHinformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PLCCHinformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PLCCHinformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PLCCHinformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCHinformation_iE_Extensions__item__id._const_tab = ____PLCCHinformation_iE_Extensions__item__id_tab
    ___PLCCHinformation_iE_Extensions__item__id._const_tab_at = None
    ___PLCCHinformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___PLCCHinformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PLCCHinformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PLCCHinformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCHinformation_iE_Extensions__item__criticality._const_tab = ____PLCCHinformation_iE_Extensions__item__criticality_tab
    ___PLCCHinformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PLCCHinformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PLCCHinformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PLCCHinformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PLCCHinformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCHinformation_iE_Extensions__item__extensionValue._const_tab = ____PLCCHinformation_iE_Extensions__item__extensionValue_tab
    ___PLCCHinformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PLCCHinformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PLCCHinformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PLCCHinformation_iE_Extensions__item__id),
        ('criticality', ___PLCCHinformation_iE_Extensions__item__criticality),
        ('extensionValue', ___PLCCHinformation_iE_Extensions__item__extensionValue),
        ])
    __PLCCHinformation_iE_Extensions__item_._ext = None
    _PLCCHinformation_iE_Extensions._cont = __PLCCHinformation_iE_Extensions__item_
    _PLCCHinformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLCCHinformation._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PLCCHinformation_commonPhysicalChannelID),
        ('sequenceNumber', _PLCCHinformation_sequenceNumber),
        ('iE-Extensions', _PLCCHinformation_iE_Extensions),
        ])
    PLCCHinformation._ext = []
    
    #-----< PLCCHinformation-ExtIEs >-----#
    PLCCHinformation_ExtIEs = CLASS(name='PLCCHinformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PLCCHinformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Possible-Secondary-Serving-Cell-List >-----#
    Possible_Secondary_Serving_Cell_List = SEQ_OF(name='Possible-Secondary-Serving-Cell-List', mode=MODE_TYPE)
    _Possible_Secondary_Serving_Cell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Possible-Secondary-Serving-Cell')))
    Possible_Secondary_Serving_Cell_List._cont = _Possible_Secondary_Serving_Cell_List__item_
    Possible_Secondary_Serving_Cell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Possible-Secondary-Serving-Cell >-----#
    Possible_Secondary_Serving_Cell = SEQ(name='Possible-Secondary-Serving-Cell', mode=MODE_TYPE)
    _Possible_Secondary_Serving_Cell_local_Cell_ID = INT(name='local-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Possible_Secondary_Serving_Cell_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Possible_Secondary_Serving_Cell_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-Restriction')))
    ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1183), ('criticality', 'ignore'), ('Extension', _____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id._const_tab = ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id._const_tab_at = None
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id._const_tab_id = 'id'
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality._const_tab = ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue._const_tab = ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Possible_Secondary_Serving_Cell_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id),
        ('criticality', ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality),
        ('extensionValue', ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue),
        ])
    __Possible_Secondary_Serving_Cell_iE_Extensions__item_._ext = None
    _Possible_Secondary_Serving_Cell_iE_Extensions._cont = __Possible_Secondary_Serving_Cell_iE_Extensions__item_
    _Possible_Secondary_Serving_Cell_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Possible_Secondary_Serving_Cell._cont = ASN1Dict([
        ('local-Cell-ID', _Possible_Secondary_Serving_Cell_local_Cell_ID),
        ('iE-Extensions', _Possible_Secondary_Serving_Cell_iE_Extensions),
        ])
    Possible_Secondary_Serving_Cell._ext = []
    
    #-----< Possible-Secondary-Serving-Cell-ExtIEs >-----#
    Possible_Secondary_Serving_Cell_ExtIEs = CLASS(name='Possible-Secondary-Serving-Cell-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Possible_Secondary_Serving_Cell_ExtIEs_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multicell-EDCH-Restriction')))
    Possible_Secondary_Serving_Cell_ExtIEs._val = ASN1Set(rv=[dict([('id', 1183), ('criticality', 'ignore'), ('Extension', _Possible_Secondary_Serving_Cell_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PowerAdjustmentType >-----#
    PowerAdjustmentType = ENUM(name='PowerAdjustmentType', mode=MODE_TYPE)
    PowerAdjustmentType._cont = ASN1Dict([('none', 0), ('common', 1), ('individual', 2)])
    PowerAdjustmentType._ext = None
    
    #-----< PowerOffset >-----#
    PowerOffset = INT(name='PowerOffset', mode=MODE_TYPE)
    PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=24)], ev=None, er=[])
    
    #-----< PowerOffsetForSecondaryCPICHforMIMO >-----#
    PowerOffsetForSecondaryCPICHforMIMO = INT(name='PowerOffsetForSecondaryCPICHforMIMO', mode=MODE_TYPE)
    PowerOffsetForSecondaryCPICHforMIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-6, ub=0)], ev=None, er=[])
    
    #-----< PowerRaiseLimit >-----#
    PowerRaiseLimit = INT(name='PowerRaiseLimit', mode=MODE_TYPE)
    PowerRaiseLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< PRACH-Midamble >-----#
    PRACH_Midamble = ENUM(name='PRACH-Midamble', mode=MODE_TYPE)
    PRACH_Midamble._cont = ASN1Dict([('inverted', 0), ('direct', 1)])
    PRACH_Midamble._ext = []
    
    #-----< PRC >-----#
    PRC = INT(name='PRC', mode=MODE_TYPE)
    PRC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2047, ub=2047)], ev=None, er=[])
    
    #-----< PRCDeviation >-----#
    PRCDeviation = ENUM(name='PRCDeviation', mode=MODE_TYPE)
    PRCDeviation._cont = ASN1Dict([('one', 0), ('two', 1), ('five', 2), ('ten', 3)])
    PRCDeviation._ext = []
    
    #-----< PrecodingWeightSetRestriction >-----#
    PrecodingWeightSetRestriction = ENUM(name='PrecodingWeightSetRestriction', mode=MODE_TYPE)
    PrecodingWeightSetRestriction._cont = ASN1Dict([('preferred', 0), ('not-preferred', 1)])
    PrecodingWeightSetRestriction._ext = None
    
    #-----< Precoder-Weight-Set-Restriction >-----#
    Precoder_Weight_Set_Restriction = BIT_STR(name='Precoder-Weight-Set-Restriction', mode=MODE_TYPE)
    Precoder_Weight_Set_Restriction._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< PreambleSignatures >-----#
    PreambleSignatures = BIT_STR(name='PreambleSignatures', mode=MODE_TYPE)
    PreambleSignatures._cont = ASN1Dict([('signature15', 0), ('signature14', 1), ('signature13', 2), ('signature12', 3), ('signature11', 4), ('signature10', 5), ('signature9', 6), ('signature8', 7), ('signature7', 8), ('signature6', 9), ('signature5', 10), ('signature4', 11), ('signature3', 12), ('signature2', 13), ('signature1', 14), ('signature0', 15)])
    PreambleSignatures._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< PreambleThreshold >-----#
    PreambleThreshold = INT(name='PreambleThreshold', mode=MODE_TYPE)
    PreambleThreshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=72)], ev=None, er=[])
    
    #-----< PredictedSFNSFNDeviationLimit >-----#
    PredictedSFNSFNDeviationLimit = INT(name='PredictedSFNSFNDeviationLimit', mode=MODE_TYPE)
    PredictedSFNSFNDeviationLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PredictedTUTRANGPSDeviationLimit >-----#
    PredictedTUTRANGPSDeviationLimit = INT(name='PredictedTUTRANGPSDeviationLimit', mode=MODE_TYPE)
    PredictedTUTRANGPSDeviationLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name='Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([('shall-not-trigger-pre-emption', 0), ('may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name='Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([('not-pre-emptable', 0), ('pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< PrimaryAndSecondaryCPICHContainer >-----#
    PrimaryAndSecondaryCPICHContainer = SEQ(name='PrimaryAndSecondaryCPICHContainer', mode=MODE_TYPE)
    _PrimaryAndSecondaryCPICHContainer_power_Offset_For_Secondary_CPICH_for_MIMO = INT(name='power-Offset-For-Secondary-CPICH-for-MIMO', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMO')))
    _PrimaryAndSecondaryCPICHContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PrimaryAndSecondaryCPICHContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__id._const_tab = ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__id_tab
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__id._const_tab_at = None
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__criticality._const_tab = ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__criticality_tab
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__extensionValue._const_tab = ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__extensionValue_tab
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PrimaryAndSecondaryCPICHContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__id),
        ('criticality', ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__extensionValue),
        ])
    __PrimaryAndSecondaryCPICHContainer_iE_Extensions__item_._ext = None
    _PrimaryAndSecondaryCPICHContainer_iE_Extensions._cont = __PrimaryAndSecondaryCPICHContainer_iE_Extensions__item_
    _PrimaryAndSecondaryCPICHContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrimaryAndSecondaryCPICHContainer._cont = ASN1Dict([
        ('power-Offset-For-Secondary-CPICH-for-MIMO', _PrimaryAndSecondaryCPICHContainer_power_Offset_For_Secondary_CPICH_for_MIMO),
        ('iE-Extensions', _PrimaryAndSecondaryCPICHContainer_iE_Extensions),
        ])
    PrimaryAndSecondaryCPICHContainer._ext = []
    
    #-----< PrimaryAndSecondaryCPICHContainer-ExtIEs >-----#
    PrimaryAndSecondaryCPICHContainer_ExtIEs = CLASS(name='PrimaryAndSecondaryCPICHContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PrimaryAndSecondaryCPICHContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrimaryCPICH-Power >-----#
    PrimaryCPICH_Power = INT(name='PrimaryCPICH-Power', mode=MODE_TYPE)
    PrimaryCPICH_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-100, ub=500)], ev=None, er=[])
    
    #-----< Primary-CPICH-Usage-for-Channel-Estimation >-----#
    Primary_CPICH_Usage_for_Channel_Estimation = ENUM(name='Primary-CPICH-Usage-for-Channel-Estimation', mode=MODE_TYPE)
    Primary_CPICH_Usage_for_Channel_Estimation._cont = ASN1Dict([('primary-CPICH-may-be-used', 0), ('primary-CPICH-shall-not-be-used', 1)])
    Primary_CPICH_Usage_for_Channel_Estimation._ext = None
    
    #-----< PrimaryScramblingCode >-----#
    PrimaryScramblingCode = INT(name='PrimaryScramblingCode', mode=MODE_TYPE)
    PrimaryScramblingCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name='PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< Priority-Queue-Information-for-Enhanced-FACH-PCH >-----#
    Priority_Queue_Information_for_Enhanced_FACH_PCH = SEQ(name='Priority-Queue-Information-for-Enhanced-FACH-PCH', mode=MODE_TYPE)
    _Priority_Queue_Information_for_Enhanced_FACH_PCH_priorityQueue_Id = INT(name='priorityQueue-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-Id')))
    _Priority_Queue_Information_for_Enhanced_FACH_PCH_schedulingPriorityIndicator = INT(name='schedulingPriorityIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')))
    _Priority_Queue_Information_for_Enhanced_FACH_PCH_t1 = ENUM(name='t1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T1')))
    _Priority_Queue_Information_for_Enhanced_FACH_PCH_mAC_ehs_Reset_Timer = ENUM(name='mAC-ehs-Reset-Timer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-ehs-Reset-Timer')))
    _Priority_Queue_Information_for_Enhanced_FACH_PCH_discardTimer = ENUM(name='discardTimer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DiscardTimer')), opt=True)
    _Priority_Queue_Information_for_Enhanced_FACH_PCH_mAC_hsWindowSize = ENUM(name='mAC-hsWindowSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-hsWindowSize')))
    _Priority_Queue_Information_for_Enhanced_FACH_PCH_maximum_MACcPDU_Size = INT(name='maximum-MACcPDU-Size', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__id._const_tab = ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__id_tab
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__id._const_tab_at = None
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__id._const_tab_id = 'id'
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__criticality._const_tab = ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__criticality_tab
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__extensionValue._const_tab = ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__extensionValue_tab
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__id),
        ('criticality', ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__criticality),
        ('extensionValue', ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__extensionValue),
        ])
    __Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item_._ext = None
    _Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions._cont = __Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item_
    _Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Priority_Queue_Information_for_Enhanced_FACH_PCH._cont = ASN1Dict([
        ('priorityQueue-Id', _Priority_Queue_Information_for_Enhanced_FACH_PCH_priorityQueue_Id),
        ('schedulingPriorityIndicator', _Priority_Queue_Information_for_Enhanced_FACH_PCH_schedulingPriorityIndicator),
        ('t1', _Priority_Queue_Information_for_Enhanced_FACH_PCH_t1),
        ('mAC-ehs-Reset-Timer', _Priority_Queue_Information_for_Enhanced_FACH_PCH_mAC_ehs_Reset_Timer),
        ('discardTimer', _Priority_Queue_Information_for_Enhanced_FACH_PCH_discardTimer),
        ('mAC-hsWindowSize', _Priority_Queue_Information_for_Enhanced_FACH_PCH_mAC_hsWindowSize),
        ('maximum-MACcPDU-Size', _Priority_Queue_Information_for_Enhanced_FACH_PCH_maximum_MACcPDU_Size),
        ('iE-Extensions', _Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions),
        ])
    Priority_Queue_Information_for_Enhanced_FACH_PCH._ext = []
    
    #-----< Priority-Queue-Information-for-Enhanced-FACH-PCH-ExtIEs >-----#
    Priority_Queue_Information_for_Enhanced_FACH_PCH_ExtIEs = CLASS(name='Priority-Queue-Information-for-Enhanced-FACH-PCH-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Priority_Queue_Information_for_Enhanced_FACH_PCH_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PriorityQueue-Id >-----#
    PriorityQueue_Id = INT(name='PriorityQueue-Id', mode=MODE_TYPE)
    PriorityQueue_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< PriorityQueue-InfoList >-----#
    PriorityQueue_InfoList = SEQ_OF(name='PriorityQueue-InfoList', mode=MODE_TYPE)
    _PriorityQueue_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-InfoItem')))
    PriorityQueue_InfoList._cont = _PriorityQueue_InfoList__item_
    PriorityQueue_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PriorityQueue-InfoItem >-----#
    PriorityQueue_InfoItem = SEQ(name='PriorityQueue-InfoItem', mode=MODE_TYPE)
    _PriorityQueue_InfoItem_priorityQueueId = INT(name='priorityQueueId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-Id')))
    _PriorityQueue_InfoItem_associatedHSDSCH_MACdFlow = INT(name='associatedHSDSCH-MACdFlow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _PriorityQueue_InfoItem_schedulingPriorityIndicator = INT(name='schedulingPriorityIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')))
    _PriorityQueue_InfoItem_t1 = ENUM(name='t1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T1')))
    _PriorityQueue_InfoItem_discardTimer = ENUM(name='discardTimer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DiscardTimer')), opt=True)
    _PriorityQueue_InfoItem_mAC_hsWindowSize = ENUM(name='mAC-hsWindowSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-hsWindowSize')))
    _PriorityQueue_InfoItem_mAChsGuaranteedBitRate = INT(name='mAChsGuaranteedBitRate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAChsGuaranteedBitRate')), opt=True)
    _PriorityQueue_InfoItem_macdPDU_Size_Index = SEQ_OF(name='macdPDU-Size-Index', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MACdPDU-Size-Indexlist')))
    _PriorityQueue_InfoItem_rLC_Mode = ENUM(name='rLC-Mode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RLC-Mode')))
    _PriorityQueue_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PriorityQueue_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PriorityQueue_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-RLC-PDU-Size-Format')))
    _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_2 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate-Enforcement-Indicator')))
    ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'reject'), ('Extension', _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1079), ('criticality', 'ignore'), ('Extension', _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1093), ('criticality', 'ignore'), ('Extension', _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_iE_Extensions__item__id._const_tab = ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___PriorityQueue_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PriorityQueue_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PriorityQueue_InfoItem_iE_Extensions__item__criticality._const_tab = ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PriorityQueue_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PriorityQueue_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PriorityQueue_InfoItem_iE_Extensions__item__id),
        ('criticality', ___PriorityQueue_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __PriorityQueue_InfoItem_iE_Extensions__item_._ext = None
    _PriorityQueue_InfoItem_iE_Extensions._cont = __PriorityQueue_InfoItem_iE_Extensions__item_
    _PriorityQueue_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PriorityQueue_InfoItem._cont = ASN1Dict([
        ('priorityQueueId', _PriorityQueue_InfoItem_priorityQueueId),
        ('associatedHSDSCH-MACdFlow', _PriorityQueue_InfoItem_associatedHSDSCH_MACdFlow),
        ('schedulingPriorityIndicator', _PriorityQueue_InfoItem_schedulingPriorityIndicator),
        ('t1', _PriorityQueue_InfoItem_t1),
        ('discardTimer', _PriorityQueue_InfoItem_discardTimer),
        ('mAC-hsWindowSize', _PriorityQueue_InfoItem_mAC_hsWindowSize),
        ('mAChsGuaranteedBitRate', _PriorityQueue_InfoItem_mAChsGuaranteedBitRate),
        ('macdPDU-Size-Index', _PriorityQueue_InfoItem_macdPDU_Size_Index),
        ('rLC-Mode', _PriorityQueue_InfoItem_rLC_Mode),
        ('iE-Extensions', _PriorityQueue_InfoItem_iE_Extensions),
        ])
    PriorityQueue_InfoItem._ext = []
    
    #-----< PriorityQueue-InfoItem-ExtIEs >-----#
    PriorityQueue_InfoItem_ExtIEs = CLASS(name='PriorityQueue-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PriorityQueue_InfoItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _PriorityQueue_InfoItem_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-RLC-PDU-Size-Format')))
    _PriorityQueue_InfoItem_ExtIEs_val_Extension_2 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate-Enforcement-Indicator')))
    PriorityQueue_InfoItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'reject'), ('Extension', _PriorityQueue_InfoItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1079), ('criticality', 'ignore'), ('Extension', _PriorityQueue_InfoItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1093), ('criticality', 'ignore'), ('Extension', _PriorityQueue_InfoItem_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PriorityQueue-InfoList-to-Modify >-----#
    PriorityQueue_InfoList_to_Modify = SEQ_OF(name='PriorityQueue-InfoList-to-Modify', mode=MODE_TYPE)
    _PriorityQueue_InfoList_to_Modify__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ModifyPriorityQueue')))
    PriorityQueue_InfoList_to_Modify._cont = _PriorityQueue_InfoList_to_Modify__item_
    PriorityQueue_InfoList_to_Modify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PriorityQueue-InfoItem-to-Add >-----#
    PriorityQueue_InfoItem_to_Add = SEQ(name='PriorityQueue-InfoItem-to-Add', mode=MODE_TYPE)
    _PriorityQueue_InfoItem_to_Add_priorityQueueId = INT(name='priorityQueueId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-Id')))
    _PriorityQueue_InfoItem_to_Add_associatedHSDSCH_MACdFlow = INT(name='associatedHSDSCH-MACdFlow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _PriorityQueue_InfoItem_to_Add_schedulingPriorityIndicator = INT(name='schedulingPriorityIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')))
    _PriorityQueue_InfoItem_to_Add_t1 = ENUM(name='t1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T1')))
    _PriorityQueue_InfoItem_to_Add_discardTimer = ENUM(name='discardTimer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DiscardTimer')), opt=True)
    _PriorityQueue_InfoItem_to_Add_mAC_hsWindowSize = ENUM(name='mAC-hsWindowSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-hsWindowSize')))
    _PriorityQueue_InfoItem_to_Add_mAChsGuaranteedBitRate = INT(name='mAChsGuaranteedBitRate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAChsGuaranteedBitRate')), opt=True)
    _PriorityQueue_InfoItem_to_Add_macdPDU_Size_Index = SEQ_OF(name='macdPDU-Size-Index', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MACdPDU-Size-Indexlist')))
    _PriorityQueue_InfoItem_to_Add_rLC_Mode = ENUM(name='rLC-Mode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RLC-Mode')))
    _PriorityQueue_InfoItem_to_Add_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PriorityQueue_InfoItem_to_Add_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-RLC-PDU-Size-Format')))
    ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'reject'), ('Extension', _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1079), ('criticality', 'ignore'), ('Extension', _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id._const_tab = ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id._const_tab_at = None
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id._const_tab_id = 'id'
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality._const_tab = ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue._const_tab = ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PriorityQueue_InfoItem_to_Add_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id),
        ('criticality', ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality),
        ('extensionValue', ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue),
        ])
    __PriorityQueue_InfoItem_to_Add_iE_Extensions__item_._ext = None
    _PriorityQueue_InfoItem_to_Add_iE_Extensions._cont = __PriorityQueue_InfoItem_to_Add_iE_Extensions__item_
    _PriorityQueue_InfoItem_to_Add_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PriorityQueue_InfoItem_to_Add._cont = ASN1Dict([
        ('priorityQueueId', _PriorityQueue_InfoItem_to_Add_priorityQueueId),
        ('associatedHSDSCH-MACdFlow', _PriorityQueue_InfoItem_to_Add_associatedHSDSCH_MACdFlow),
        ('schedulingPriorityIndicator', _PriorityQueue_InfoItem_to_Add_schedulingPriorityIndicator),
        ('t1', _PriorityQueue_InfoItem_to_Add_t1),
        ('discardTimer', _PriorityQueue_InfoItem_to_Add_discardTimer),
        ('mAC-hsWindowSize', _PriorityQueue_InfoItem_to_Add_mAC_hsWindowSize),
        ('mAChsGuaranteedBitRate', _PriorityQueue_InfoItem_to_Add_mAChsGuaranteedBitRate),
        ('macdPDU-Size-Index', _PriorityQueue_InfoItem_to_Add_macdPDU_Size_Index),
        ('rLC-Mode', _PriorityQueue_InfoItem_to_Add_rLC_Mode),
        ('iE-Extensions', _PriorityQueue_InfoItem_to_Add_iE_Extensions),
        ])
    PriorityQueue_InfoItem_to_Add._ext = []
    
    #-----< PriorityQueue-InfoItem-to-Add-ExtIEs >-----#
    PriorityQueue_InfoItem_to_Add_ExtIEs = CLASS(name='PriorityQueue-InfoItem-to-Add-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-RLC-PDU-Size-Format')))
    PriorityQueue_InfoItem_to_Add_ExtIEs._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'reject'), ('Extension', _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1079), ('criticality', 'ignore'), ('Extension', _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PriorityQueue-InfoItem-to-Modify >-----#
    PriorityQueue_InfoItem_to_Modify = SEQ(name='PriorityQueue-InfoItem-to-Modify', mode=MODE_TYPE)
    _PriorityQueue_InfoItem_to_Modify_priorityQueueId = INT(name='priorityQueueId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-Id')))
    _PriorityQueue_InfoItem_to_Modify_schedulingPriorityIndicator = INT(name='schedulingPriorityIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_t1 = ENUM(name='t1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T1')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_discardTimer = ENUM(name='discardTimer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DiscardTimer')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_mAC_hsWindowSize = ENUM(name='mAC-hsWindowSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAC-hsWindowSize')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_mAChsGuaranteedBitRate = INT(name='mAChsGuaranteedBitRate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAChsGuaranteedBitRate')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_macdPDU_Size_Index_to_Modify = SEQ_OF(name='macdPDU-Size-Index-to-Modify', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MACdPDU-Size-Indexlist-to-Modify')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PriorityQueue_InfoItem_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-RLC-PDU-Size-Format')))
    ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'reject'), ('Extension', _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1079), ('criticality', 'ignore'), ('Extension', _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id._const_tab = ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab = ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PriorityQueue_InfoItem_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id),
        ('criticality', ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __PriorityQueue_InfoItem_to_Modify_iE_Extensions__item_._ext = None
    _PriorityQueue_InfoItem_to_Modify_iE_Extensions._cont = __PriorityQueue_InfoItem_to_Modify_iE_Extensions__item_
    _PriorityQueue_InfoItem_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PriorityQueue_InfoItem_to_Modify._cont = ASN1Dict([
        ('priorityQueueId', _PriorityQueue_InfoItem_to_Modify_priorityQueueId),
        ('schedulingPriorityIndicator', _PriorityQueue_InfoItem_to_Modify_schedulingPriorityIndicator),
        ('t1', _PriorityQueue_InfoItem_to_Modify_t1),
        ('discardTimer', _PriorityQueue_InfoItem_to_Modify_discardTimer),
        ('mAC-hsWindowSize', _PriorityQueue_InfoItem_to_Modify_mAC_hsWindowSize),
        ('mAChsGuaranteedBitRate', _PriorityQueue_InfoItem_to_Modify_mAChsGuaranteedBitRate),
        ('macdPDU-Size-Index-to-Modify', _PriorityQueue_InfoItem_to_Modify_macdPDU_Size_Index_to_Modify),
        ('iE-Extensions', _PriorityQueue_InfoItem_to_Modify_iE_Extensions),
        ])
    PriorityQueue_InfoItem_to_Modify._ext = []
    
    #-----< PriorityQueue-InfoItem-to-Modify-ExtIEs >-----#
    PriorityQueue_InfoItem_to_Modify_ExtIEs = CLASS(name='PriorityQueue-InfoItem-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAC-PDU-SizeExtended')))
    _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-RLC-PDU-Size-Format')))
    PriorityQueue_InfoItem_to_Modify_ExtIEs._val = ASN1Set(rv=[dict([('id', 866), ('criticality', 'reject'), ('Extension', _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1079), ('criticality', 'ignore'), ('Extension', _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PriorityQueue-InfoList-to-Modify-Unsynchronised >-----#
    PriorityQueue_InfoList_to_Modify_Unsynchronised = SEQ_OF(name='PriorityQueue-InfoList-to-Modify-Unsynchronised', mode=MODE_TYPE)
    _PriorityQueue_InfoList_to_Modify_Unsynchronised__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-InfoItem-to-Modify-Unsynchronised')))
    PriorityQueue_InfoList_to_Modify_Unsynchronised._cont = _PriorityQueue_InfoList_to_Modify_Unsynchronised__item_
    PriorityQueue_InfoList_to_Modify_Unsynchronised._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PriorityQueue-InfoItem-to-Modify-Unsynchronised >-----#
    PriorityQueue_InfoItem_to_Modify_Unsynchronised = SEQ(name='PriorityQueue-InfoItem-to-Modify-Unsynchronised', mode=MODE_TYPE)
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_priorityQueueId = INT(name='priorityQueueId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PriorityQueue-Id')))
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_schedulingPriorityIndicator = INT(name='schedulingPriorityIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SchedulingPriorityIndicator')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_discardTimer = ENUM(name='discardTimer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DiscardTimer')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_mAChsGuaranteedBitRate = INT(name='mAChsGuaranteedBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MAChsGuaranteedBitRate')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab = ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_at = None
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_id = 'id'
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab = ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality_tab
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab = ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue_tab
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id),
        ('criticality', ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality),
        ('extensionValue', ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue),
        ])
    __PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item_._ext = None
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions._cont = __PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item_
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PriorityQueue_InfoItem_to_Modify_Unsynchronised._cont = ASN1Dict([
        ('priorityQueueId', _PriorityQueue_InfoItem_to_Modify_Unsynchronised_priorityQueueId),
        ('schedulingPriorityIndicator', _PriorityQueue_InfoItem_to_Modify_Unsynchronised_schedulingPriorityIndicator),
        ('discardTimer', _PriorityQueue_InfoItem_to_Modify_Unsynchronised_discardTimer),
        ('mAChsGuaranteedBitRate', _PriorityQueue_InfoItem_to_Modify_Unsynchronised_mAChsGuaranteedBitRate),
        ('iE-Extensions', _PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions),
        ])
    PriorityQueue_InfoItem_to_Modify_Unsynchronised._ext = []
    
    #-----< PriorityQueue-InfoItem-to-Modify-Unsynchronised-ExtIEs >-----#
    PriorityQueue_InfoItem_to_Modify_Unsynchronised_ExtIEs = CLASS(name='PriorityQueue-InfoItem-to-Modify-Unsynchronised-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PriorityQueue_InfoItem_to_Modify_Unsynchronised_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrimaryCCPCH-RSCP >-----#
    PrimaryCCPCH_RSCP = INT(name='PrimaryCCPCH-RSCP', mode=MODE_TYPE)
    PrimaryCCPCH_RSCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=91)], ev=None, er=[])
    
    #-----< PrimaryCCPCH-RSCP-Delta >-----#
    PrimaryCCPCH_RSCP_Delta = INT(name='PrimaryCCPCH-RSCP-Delta', mode=MODE_TYPE)
    PrimaryCCPCH_RSCP_Delta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-5, ub=-1)], ev=[], er=[])
    
    #-----< PropagationDelay >-----#
    PropagationDelay = INT(name='PropagationDelay', mode=MODE_TYPE)
    PropagationDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PRXdes-base >-----#
    PRXdes_base = INT(name='PRXdes-base', mode=MODE_TYPE)
    PRXdes_base._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-112, ub=-50)], ev=None, er=[])
    
    #-----< SCH-TimeSlot >-----#
    SCH_TimeSlot = INT(name='SCH-TimeSlot', mode=MODE_TYPE)
    SCH_TimeSlot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< PunctureLimit >-----#
    PunctureLimit = INT(name='PunctureLimit', mode=MODE_TYPE)
    PunctureLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< PUSCH-ID >-----#
    PUSCH_ID = INT(name='PUSCH-ID', mode=MODE_TYPE)
    PUSCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< UE-Selected-MBMS-Service-Information >-----#
    UE_Selected_MBMS_Service_Information = CHOICE(name='UE-Selected-MBMS-Service-Information', mode=MODE_TYPE)
    _UE_Selected_MBMS_Service_Information_none = NULL(name='none', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_Selected_MBMS_Service_Information_selected_MBMS_Service = SEQ(name='selected-MBMS-Service', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Selected-MBMS-Service')))
    UE_Selected_MBMS_Service_Information._cont = ASN1Dict([
        ('none', _UE_Selected_MBMS_Service_Information_none),
        ('selected-MBMS-Service', _UE_Selected_MBMS_Service_Information_selected_MBMS_Service),
        ])
    UE_Selected_MBMS_Service_Information._ext = []
    
    #-----< Selected-MBMS-Service >-----#
    Selected_MBMS_Service = SEQ(name='Selected-MBMS-Service', mode=MODE_TYPE)
    _Selected_MBMS_Service_selected_MBMS_Service_List = SEQ_OF(name='selected-MBMS-Service-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Selected-MBMS-Service-List')))
    _Selected_MBMS_Service_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Selected_MBMS_Service_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Selected_MBMS_Service_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Selected_MBMS_Service_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Selected_MBMS_Service_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Selected_MBMS_Service_iE_Extensions__item__id._const_tab = ____Selected_MBMS_Service_iE_Extensions__item__id_tab
    ___Selected_MBMS_Service_iE_Extensions__item__id._const_tab_at = None
    ___Selected_MBMS_Service_iE_Extensions__item__id._const_tab_id = 'id'
    ___Selected_MBMS_Service_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Selected_MBMS_Service_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Selected_MBMS_Service_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Selected_MBMS_Service_iE_Extensions__item__criticality._const_tab = ____Selected_MBMS_Service_iE_Extensions__item__criticality_tab
    ___Selected_MBMS_Service_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Selected_MBMS_Service_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Selected_MBMS_Service_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Selected_MBMS_Service_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Selected_MBMS_Service_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Selected_MBMS_Service_iE_Extensions__item__extensionValue._const_tab = ____Selected_MBMS_Service_iE_Extensions__item__extensionValue_tab
    ___Selected_MBMS_Service_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Selected_MBMS_Service_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Selected_MBMS_Service_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Selected_MBMS_Service_iE_Extensions__item__id),
        ('criticality', ___Selected_MBMS_Service_iE_Extensions__item__criticality),
        ('extensionValue', ___Selected_MBMS_Service_iE_Extensions__item__extensionValue),
        ])
    __Selected_MBMS_Service_iE_Extensions__item_._ext = None
    _Selected_MBMS_Service_iE_Extensions._cont = __Selected_MBMS_Service_iE_Extensions__item_
    _Selected_MBMS_Service_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Selected_MBMS_Service._cont = ASN1Dict([
        ('selected-MBMS-Service-List', _Selected_MBMS_Service_selected_MBMS_Service_List),
        ('iE-Extensions', _Selected_MBMS_Service_iE_Extensions),
        ])
    Selected_MBMS_Service._ext = []
    
    #-----< Selected-MBMS-Service-ExtIEs >-----#
    Selected_MBMS_Service_ExtIEs = CLASS(name='Selected-MBMS-Service-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Selected_MBMS_Service_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Selected-MBMS-Service-List >-----#
    Selected_MBMS_Service_List = SEQ_OF(name='Selected-MBMS-Service-List', mode=MODE_TYPE)
    _Selected_MBMS_Service_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Selected-MBMS-Service-Item')))
    Selected_MBMS_Service_List._cont = _Selected_MBMS_Service_List__item_
    Selected_MBMS_Service_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Selected-MBMS-Service-Item >-----#
    Selected_MBMS_Service_Item = SEQ(name='Selected-MBMS-Service-Item', mode=MODE_TYPE)
    _Selected_MBMS_Service_Item_selected_MBMS_Service_TimeSlot_Information_LCR = SEQ_OF(name='selected-MBMS-Service-TimeSlot-Information-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Selected-MBMS-Service-TimeSlot-Information-LCR')), opt=True)
    _Selected_MBMS_Service_Item_mBMS_Service_TDM_Information = SEQ(name='mBMS-Service-TDM-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MBMS-Service-TDM-Information')), opt=True)
    _Selected_MBMS_Service_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Selected_MBMS_Service_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Selected_MBMS_Service_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Selected_MBMS_Service_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Selected_MBMS_Service_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Selected_MBMS_Service_Item_iE_Extensions__item__id._const_tab = ____Selected_MBMS_Service_Item_iE_Extensions__item__id_tab
    ___Selected_MBMS_Service_Item_iE_Extensions__item__id._const_tab_at = None
    ___Selected_MBMS_Service_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Selected_MBMS_Service_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Selected_MBMS_Service_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Selected_MBMS_Service_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Selected_MBMS_Service_Item_iE_Extensions__item__criticality._const_tab = ____Selected_MBMS_Service_Item_iE_Extensions__item__criticality_tab
    ___Selected_MBMS_Service_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Selected_MBMS_Service_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Selected_MBMS_Service_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Selected_MBMS_Service_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Selected_MBMS_Service_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Selected_MBMS_Service_Item_iE_Extensions__item__extensionValue._const_tab = ____Selected_MBMS_Service_Item_iE_Extensions__item__extensionValue_tab
    ___Selected_MBMS_Service_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Selected_MBMS_Service_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Selected_MBMS_Service_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Selected_MBMS_Service_Item_iE_Extensions__item__id),
        ('criticality', ___Selected_MBMS_Service_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Selected_MBMS_Service_Item_iE_Extensions__item__extensionValue),
        ])
    __Selected_MBMS_Service_Item_iE_Extensions__item_._ext = None
    _Selected_MBMS_Service_Item_iE_Extensions._cont = __Selected_MBMS_Service_Item_iE_Extensions__item_
    _Selected_MBMS_Service_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Selected_MBMS_Service_Item._cont = ASN1Dict([
        ('selected-MBMS-Service-TimeSlot-Information-LCR', _Selected_MBMS_Service_Item_selected_MBMS_Service_TimeSlot_Information_LCR),
        ('mBMS-Service-TDM-Information', _Selected_MBMS_Service_Item_mBMS_Service_TDM_Information),
        ('iE-Extensions', _Selected_MBMS_Service_Item_iE_Extensions),
        ])
    Selected_MBMS_Service_Item._ext = []
    
    #-----< Selected-MBMS-Service-Item-ExtIEs >-----#
    Selected_MBMS_Service_Item_ExtIEs = CLASS(name='Selected-MBMS-Service-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Selected_MBMS_Service_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Selected-MBMS-Service-TimeSlot-Information-LCR >-----#
    Selected_MBMS_Service_TimeSlot_Information_LCR = SEQ_OF(name='Selected-MBMS-Service-TimeSlot-Information-LCR', mode=MODE_TYPE)
    _Selected_MBMS_Service_TimeSlot_Information_LCR__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    Selected_MBMS_Service_TimeSlot_Information_LCR._cont = _Selected_MBMS_Service_TimeSlot_Information_LCR__item_
    Selected_MBMS_Service_TimeSlot_Information_LCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< MBMS-Service-TDM-Information >-----#
    MBMS_Service_TDM_Information = SEQ(name='MBMS-Service-TDM-Information', mode=MODE_TYPE)
    _MBMS_Service_TDM_Information_transmission_Time_Interval = ENUM(name='transmission-Time-Interval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBMS_Service_TDM_Information_transmission_Time_Interval._cont = ASN1Dict([('v10', 0), ('v20', 1), ('v40', 2), ('v80', 3)])
    _MBMS_Service_TDM_Information_transmission_Time_Interval._ext = []
    _MBMS_Service_TDM_Information_tDM_Rep = INT(name='tDM-Rep', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBMS_Service_TDM_Information_tDM_Rep._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=9)], ev=None, er=[])
    _MBMS_Service_TDM_Information_tDM_Offset = INT(name='tDM-Offset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBMS_Service_TDM_Information_tDM_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    _MBMS_Service_TDM_Information_tDM_Length = INT(name='tDM-Length', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBMS_Service_TDM_Information_tDM_Length._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _MBMS_Service_TDM_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Service_TDM_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Service_TDM_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMS_Service_TDM_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MBMS_Service_TDM_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Service_TDM_Information_iE_Extensions__item__id._const_tab = ____MBMS_Service_TDM_Information_iE_Extensions__item__id_tab
    ___MBMS_Service_TDM_Information_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Service_TDM_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBMS_Service_TDM_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMS_Service_TDM_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MBMS_Service_TDM_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Service_TDM_Information_iE_Extensions__item__criticality._const_tab = ____MBMS_Service_TDM_Information_iE_Extensions__item__criticality_tab
    ___MBMS_Service_TDM_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMS_Service_TDM_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBMS_Service_TDM_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMS_Service_TDM_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MBMS_Service_TDM_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Service_TDM_Information_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Service_TDM_Information_iE_Extensions__item__extensionValue_tab
    ___MBMS_Service_TDM_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMS_Service_TDM_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMS_Service_TDM_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBMS_Service_TDM_Information_iE_Extensions__item__id),
        ('criticality', ___MBMS_Service_TDM_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___MBMS_Service_TDM_Information_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Service_TDM_Information_iE_Extensions__item_._ext = None
    _MBMS_Service_TDM_Information_iE_Extensions._cont = __MBMS_Service_TDM_Information_iE_Extensions__item_
    _MBMS_Service_TDM_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Service_TDM_Information._cont = ASN1Dict([
        ('transmission-Time-Interval', _MBMS_Service_TDM_Information_transmission_Time_Interval),
        ('tDM-Rep', _MBMS_Service_TDM_Information_tDM_Rep),
        ('tDM-Offset', _MBMS_Service_TDM_Information_tDM_Offset),
        ('tDM-Length', _MBMS_Service_TDM_Information_tDM_Length),
        ('iE-Extensions', _MBMS_Service_TDM_Information_iE_Extensions),
        ])
    MBMS_Service_TDM_Information._ext = []
    
    #-----< MBMS-Service-TDM-Information-ExtIEs >-----#
    MBMS_Service_TDM_Information_ExtIEs = CLASS(name='MBMS-Service-TDM-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MBMS_Service_TDM_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PUSCHSet-ID >-----#
    PUSCHSet_ID = INT(name='PUSCHSet-ID', mode=MODE_TYPE)
    PUSCHSet_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< Paging-MACFlow-Specific-InformationLCR >-----#
    Paging_MACFlow_Specific_InformationLCR = SEQ_OF(name='Paging-MACFlow-Specific-InformationLCR', mode=MODE_TYPE)
    _Paging_MACFlow_Specific_InformationLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Paging-MAC-Flow-Specific-Information-ItemLCR')))
    Paging_MACFlow_Specific_InformationLCR._cont = _Paging_MACFlow_Specific_InformationLCR__item_
    Paging_MACFlow_Specific_InformationLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Paging-MAC-Flow-Specific-Information-ItemLCR >-----#
    Paging_MAC_Flow_Specific_Information_ItemLCR = SEQ(name='Paging-MAC-Flow-Specific-Information-ItemLCR', mode=MODE_TYPE)
    _Paging_MAC_Flow_Specific_Information_ItemLCR_paging_MACFlow_Id = INT(name='paging-MACFlow-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlow-ID')))
    _Paging_MAC_Flow_Specific_Information_ItemLCR_hSDPA_associated_PICH_InfoLCR = CHOICE(name='hSDPA-associated-PICH-InfoLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-Associated-PICH-InformationLCR')), opt=True)
    _Paging_MAC_Flow_Specific_Information_ItemLCR_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _Paging_MAC_Flow_Specific_Information_ItemLCR_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _Paging_MAC_Flow_Specific_Information_ItemLCR_tnl_qos = CHOICE(name='tnl-qos', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')), opt=True)
    _Paging_MAC_Flow_Specific_Information_ItemLCR_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')), opt=True)
    _Paging_MAC_Flow_Specific_Information_ItemLCR_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')), opt=True)
    _Paging_MAC_Flow_Specific_Information_ItemLCR_paging_MACFlow_PriorityQueue_InformationLCR = SEQ_OF(name='paging-MACFlow-PriorityQueue-InformationLCR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlow-PriorityQueue-Information')), opt=True)
    _Paging_MAC_Flow_Specific_Information_ItemLCR_transportBearerRequestIndicator = ENUM(name='transportBearerRequestIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')), opt=True)
    _Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__id._const_tab = ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__id_tab
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__criticality._const_tab = ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__criticality_tab
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__extensionValue._const_tab = ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__extensionValue_tab
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__id),
        ('criticality', ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__extensionValue),
        ])
    __Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item_._ext = None
    _Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions._cont = __Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item_
    _Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Paging_MAC_Flow_Specific_Information_ItemLCR._cont = ASN1Dict([
        ('paging-MACFlow-Id', _Paging_MAC_Flow_Specific_Information_ItemLCR_paging_MACFlow_Id),
        ('hSDPA-associated-PICH-InfoLCR', _Paging_MAC_Flow_Specific_Information_ItemLCR_hSDPA_associated_PICH_InfoLCR),
        ('bindingID', _Paging_MAC_Flow_Specific_Information_ItemLCR_bindingID),
        ('transportLayerAddress', _Paging_MAC_Flow_Specific_Information_ItemLCR_transportLayerAddress),
        ('tnl-qos', _Paging_MAC_Flow_Specific_Information_ItemLCR_tnl_qos),
        ('toAWS', _Paging_MAC_Flow_Specific_Information_ItemLCR_toAWS),
        ('toAWE', _Paging_MAC_Flow_Specific_Information_ItemLCR_toAWE),
        ('paging-MACFlow-PriorityQueue-InformationLCR', _Paging_MAC_Flow_Specific_Information_ItemLCR_paging_MACFlow_PriorityQueue_InformationLCR),
        ('transportBearerRequestIndicator', _Paging_MAC_Flow_Specific_Information_ItemLCR_transportBearerRequestIndicator),
        ('iE-Extensions', _Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions),
        ])
    Paging_MAC_Flow_Specific_Information_ItemLCR._ext = []
    
    #-----< Paging-MAC-Flow-Specific-Information-ItemLCR-ExtIEs >-----#
    Paging_MAC_Flow_Specific_Information_ItemLCR_ExtIEs = CLASS(name='Paging-MAC-Flow-Specific-Information-ItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Paging_MAC_Flow_Specific_Information_ItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Paging-MACFlows-to-DeleteLCR >-----#
    Paging_MACFlows_to_DeleteLCR = SEQ_OF(name='Paging-MACFlows-to-DeleteLCR', mode=MODE_TYPE)
    _Paging_MACFlows_to_DeleteLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlows-to-DeleteLCR-Item')))
    Paging_MACFlows_to_DeleteLCR._cont = _Paging_MACFlows_to_DeleteLCR__item_
    Paging_MACFlows_to_DeleteLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Paging-MACFlows-to-DeleteLCR-Item >-----#
    Paging_MACFlows_to_DeleteLCR_Item = SEQ(name='Paging-MACFlows-to-DeleteLCR-Item', mode=MODE_TYPE)
    _Paging_MACFlows_to_DeleteLCR_Item_paging_MACFlow_ID = INT(name='paging-MACFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlow-ID')))
    _Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id._const_tab = ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id_tab
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id._const_tab_at = None
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality._const_tab = ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality_tab
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue._const_tab = ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue_tab
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id),
        ('criticality', ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue),
        ])
    __Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item_._ext = None
    _Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions._cont = __Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item_
    _Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Paging_MACFlows_to_DeleteLCR_Item._cont = ASN1Dict([
        ('paging-MACFlow-ID', _Paging_MACFlows_to_DeleteLCR_Item_paging_MACFlow_ID),
        ('iE-Extensions', _Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions),
        ])
    Paging_MACFlows_to_DeleteLCR_Item._ext = []
    
    #-----< Paging-MACFlows-to-DeleteLCR-Item-ExtIEs >-----#
    Paging_MACFlows_to_DeleteLCR_Item_ExtIEs = CLASS(name='Paging-MACFlows-to-DeleteLCR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Paging_MACFlows_to_DeleteLCR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Process-Memory-Size >-----#
    Process_Memory_Size = ENUM(name='Process-Memory-Size', mode=MODE_TYPE)
    Process_Memory_Size._cont = ASN1Dict([('hms800', 0), ('hms1600', 1), ('hms2400', 2), ('hms3200', 3), ('hms4000', 4), ('hms4800', 5), ('hms5600', 6), ('hms6400', 7), ('hms7200', 8), ('hms8000', 9), ('hms8800', 10), ('hms9600', 11), ('hms10400', 12), ('hms11200', 13), ('hms12000', 14), ('hms12800', 15), ('hms13600', 16), ('hms14400', 17), ('hms15200', 18), ('hms16000', 19), ('hms17600', 20), ('hms19200', 21), ('hms20800', 22), ('hms22400', 23), ('hms24000', 24), ('hms25600', 25), ('hms27200', 26), ('hms28800', 27), ('hms30400', 28), ('hms32000', 29), ('hms36000', 30), ('hms40000', 31), ('hms44000', 32), ('hms48000', 33), ('hms52000', 34), ('hms56000', 35), ('hms60000', 36), ('hms64000', 37), ('hms68000', 38), ('hms72000', 39), ('hms76000', 40), ('hms80000', 41), ('hms88000', 42), ('hms96000', 43), ('hms104000', 44), ('hms112000', 45), ('hms120000', 46), ('hms128000', 47), ('hms136000', 48), ('hms144000', 49), ('hms152000', 50), ('hms160000', 51), ('hms176000', 52), ('hms192000', 53), ('hms208000', 54), ('hms224000', 55), ('hms240000', 56), ('hms256000', 57), ('hms272000', 58), ('hms288000', 59), ('hms304000', 60)])
    Process_Memory_Size._ext = []
    
    #-----< Per-HARQ-Activiation-and-Deactiviation >-----#
    Per_HARQ_Activiation_and_Deactiviation = SEQ(name='Per-HARQ-Activiation-and-Deactiviation', mode=MODE_TYPE)
    _Per_HARQ_Activiation_and_Deactiviation_configuration_for_2msTTI_Common_E_DCH_ResourcesList = SEQ_OF(name='configuration-for-2msTTI-Common-E-DCH-ResourcesList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Configuration-for-2msTTI-Common-E-DCH-ResourcesList')))
    _Per_HARQ_Activiation_and_Deactiviation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__id._const_tab = ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__id_tab
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__id._const_tab_at = None
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__id._const_tab_id = 'id'
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__criticality._const_tab = ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__criticality_tab
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__extensionValue._const_tab = ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__extensionValue_tab
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__id),
        ('criticality', ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__criticality),
        ('extensionValue', ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__extensionValue),
        ])
    __Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item_._ext = None
    _Per_HARQ_Activiation_and_Deactiviation_iE_Extensions._cont = __Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item_
    _Per_HARQ_Activiation_and_Deactiviation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Per_HARQ_Activiation_and_Deactiviation._cont = ASN1Dict([
        ('configuration-for-2msTTI-Common-E-DCH-ResourcesList', _Per_HARQ_Activiation_and_Deactiviation_configuration_for_2msTTI_Common_E_DCH_ResourcesList),
        ('iE-Extensions', _Per_HARQ_Activiation_and_Deactiviation_iE_Extensions),
        ])
    Per_HARQ_Activiation_and_Deactiviation._ext = []
    
    #-----< Per-HARQ-Activiation-and-Deactiviation-ExtIEs >-----#
    Per_HARQ_Activiation_and_Deactiviation_ExtIEs = CLASS(name='Per-HARQ-Activiation-and-Deactiviation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Per_HARQ_Activiation_and_Deactiviation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QE-Selector >-----#
    QE_Selector = ENUM(name='QE-Selector', mode=MODE_TYPE)
    QE_Selector._cont = ASN1Dict([('selected', 0), ('non-selected', 1)])
    QE_Selector._ext = None
    
    #-----< RACH-Measurement-Result >-----#
    RACH_Measurement_Result = ENUM(name='RACH-Measurement-Result', mode=MODE_TYPE)
    RACH_Measurement_Result._cont = ASN1Dict([('cpich-EcNo', 0), ('cpich-RSCP', 1), ('pathloss', 2)])
    RACH_Measurement_Result._ext = []
    
    #-----< RACH-SlotFormat >-----#
    RACH_SlotFormat = ENUM(name='RACH-SlotFormat', mode=MODE_TYPE)
    RACH_SlotFormat._cont = ASN1Dict([('v0', 0), ('v1', 1), ('v2', 2), ('v3', 3)])
    RACH_SlotFormat._ext = []
    
    #-----< RACH-SubChannelNumbers >-----#
    RACH_SubChannelNumbers = BIT_STR(name='RACH-SubChannelNumbers', mode=MODE_TYPE)
    RACH_SubChannelNumbers._cont = ASN1Dict([('subCh11', 0), ('subCh10', 1), ('subCh9', 2), ('subCh8', 3), ('subCh7', 4), ('subCh6', 5), ('subCh5', 6), ('subCh4', 7), ('subCh3', 8), ('subCh2', 9), ('subCh1', 10), ('subCh0', 11)])
    RACH_SubChannelNumbers._const_sz = ASN1Set(rv=[12], rr=[], ev=None, er=[])
    
    #-----< RL-Specific-DCH-Info >-----#
    RL_Specific_DCH_Info = SEQ_OF(name='RL-Specific-DCH-Info', mode=MODE_TYPE)
    _RL_Specific_DCH_Info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info-Item')))
    RL_Specific_DCH_Info._cont = _RL_Specific_DCH_Info__item_
    RL_Specific_DCH_Info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< RL-Specific-DCH-Info-Item >-----#
    RL_Specific_DCH_Info_Item = SEQ(name='RL-Specific-DCH-Info-Item', mode=MODE_TYPE)
    _RL_Specific_DCH_Info_Item_dCH_id = INT(name='dCH-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    _RL_Specific_DCH_Info_Item_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _RL_Specific_DCH_Info_Item_transportlayeraddress = BIT_STR(name='transportlayeraddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _RL_Specific_DCH_Info_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Specific_DCH_Info_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerNotRequestedIndicator')))
    ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 911), ('criticality', 'ignore'), ('Extension', _____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id._const_tab = ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id._const_tab_at = None
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality._const_tab = ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue._const_tab = ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Specific_DCH_Info_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id),
        ('criticality', ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue),
        ])
    __RL_Specific_DCH_Info_Item_iE_Extensions__item_._ext = None
    _RL_Specific_DCH_Info_Item_iE_Extensions._cont = __RL_Specific_DCH_Info_Item_iE_Extensions__item_
    _RL_Specific_DCH_Info_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Specific_DCH_Info_Item._cont = ASN1Dict([
        ('dCH-id', _RL_Specific_DCH_Info_Item_dCH_id),
        ('bindingID', _RL_Specific_DCH_Info_Item_bindingID),
        ('transportlayeraddress', _RL_Specific_DCH_Info_Item_transportlayeraddress),
        ('iE-Extensions', _RL_Specific_DCH_Info_Item_iE_Extensions),
        ])
    RL_Specific_DCH_Info_Item._ext = []
    
    #-----< RL-Specific-DCH-Info-Item-ExtIEs >-----#
    RL_Specific_DCH_Info_Item_ExtIEs = CLASS(name='RL-Specific-DCH-Info-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_Specific_DCH_Info_Item_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerNotRequestedIndicator')))
    RL_Specific_DCH_Info_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 911), ('criticality', 'ignore'), ('Extension', _RL_Specific_DCH_Info_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-Specific-E-DCH-Info >-----#
    RL_Specific_E_DCH_Info = SEQ(name='RL-Specific-E-DCH-Info', mode=MODE_TYPE)
    _RL_Specific_E_DCH_Info_rL_Specific_E_DCH_Information = SEQ_OF(name='rL-Specific-E-DCH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-E-DCH-Information')))
    _RL_Specific_E_DCH_Info_e_AGCH_PowerOffset = INT(name='e-AGCH-PowerOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-PowerOffset')), opt=True)
    _RL_Specific_E_DCH_Info_e_RGCH_PowerOffset = INT(name='e-RGCH-PowerOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-PowerOffset')), opt=True)
    _RL_Specific_E_DCH_Info_e_HICH_PowerOffset = INT(name='e-HICH-PowerOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-PowerOffset')), opt=True)
    _RL_Specific_E_DCH_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Specific_E_DCH_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Specific_E_DCH_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Specific_E_DCH_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__id._const_tab = ____RL_Specific_E_DCH_Info_iE_Extensions__item__id_tab
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__id._const_tab_at = None
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Specific_E_DCH_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Specific_E_DCH_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__criticality._const_tab = ____RL_Specific_E_DCH_Info_iE_Extensions__item__criticality_tab
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Specific_E_DCH_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Specific_E_DCH_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__extensionValue._const_tab = ____RL_Specific_E_DCH_Info_iE_Extensions__item__extensionValue_tab
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Specific_E_DCH_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Specific_E_DCH_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Specific_E_DCH_Info_iE_Extensions__item__id),
        ('criticality', ___RL_Specific_E_DCH_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Specific_E_DCH_Info_iE_Extensions__item__extensionValue),
        ])
    __RL_Specific_E_DCH_Info_iE_Extensions__item_._ext = None
    _RL_Specific_E_DCH_Info_iE_Extensions._cont = __RL_Specific_E_DCH_Info_iE_Extensions__item_
    _RL_Specific_E_DCH_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Specific_E_DCH_Info._cont = ASN1Dict([
        ('rL-Specific-E-DCH-Information', _RL_Specific_E_DCH_Info_rL_Specific_E_DCH_Information),
        ('e-AGCH-PowerOffset', _RL_Specific_E_DCH_Info_e_AGCH_PowerOffset),
        ('e-RGCH-PowerOffset', _RL_Specific_E_DCH_Info_e_RGCH_PowerOffset),
        ('e-HICH-PowerOffset', _RL_Specific_E_DCH_Info_e_HICH_PowerOffset),
        ('iE-Extensions', _RL_Specific_E_DCH_Info_iE_Extensions),
        ])
    RL_Specific_E_DCH_Info._ext = []
    
    #-----< RL-Specific-E-DCH-Info-Item-ExtIEs >-----#
    RL_Specific_E_DCH_Info_Item_ExtIEs = CLASS(name='RL-Specific-E-DCH-Info-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_Specific_E_DCH_Info_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Specific-E-DCH-Information >-----#
    RL_Specific_E_DCH_Information = SEQ_OF(name='RL-Specific-E-DCH-Information', mode=MODE_TYPE)
    _RL_Specific_E_DCH_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-E-DCH-Information-Item')))
    RL_Specific_E_DCH_Information._cont = _RL_Specific_E_DCH_Information__item_
    RL_Specific_E_DCH_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< RL-Specific-E-DCH-Information-Item >-----#
    RL_Specific_E_DCH_Information_Item = SEQ(name='RL-Specific-E-DCH-Information-Item', mode=MODE_TYPE)
    _RL_Specific_E_DCH_Information_Item_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _RL_Specific_E_DCH_Information_Item_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _RL_Specific_E_DCH_Information_Item_transportlayeraddress = BIT_STR(name='transportlayeraddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _RL_Specific_E_DCH_Information_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Specific_E_DCH_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__id._const_tab = ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__id_tab
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__criticality._const_tab = ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__criticality_tab
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__extensionValue_tab
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Specific_E_DCH_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__id),
        ('criticality', ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __RL_Specific_E_DCH_Information_Item_iE_Extensions__item_._ext = None
    _RL_Specific_E_DCH_Information_Item_iE_Extensions._cont = __RL_Specific_E_DCH_Information_Item_iE_Extensions__item_
    _RL_Specific_E_DCH_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Specific_E_DCH_Information_Item._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _RL_Specific_E_DCH_Information_Item_e_DCH_MACdFlow_ID),
        ('bindingID', _RL_Specific_E_DCH_Information_Item_bindingID),
        ('transportlayeraddress', _RL_Specific_E_DCH_Information_Item_transportlayeraddress),
        ('iE-Extensions', _RL_Specific_E_DCH_Information_Item_iE_Extensions),
        ])
    RL_Specific_E_DCH_Information_Item._ext = []
    
    #-----< RL-Specific-E-DCH-Information-Item-ExtIEs >-----#
    RL_Specific_E_DCH_Information_Item_ExtIEs = CLASS(name='RL-Specific-E-DCH-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_Specific_E_DCH_Information_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Range-Correction-Rate >-----#
    Range_Correction_Rate = INT(name='Range-Correction-Rate', mode=MODE_TYPE)
    Range_Correction_Rate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=127)], ev=None, er=[])
    
    #-----< Reference-ReceivedTotalWideBandPower >-----#
    Reference_ReceivedTotalWideBandPower = INT(name='Reference-ReceivedTotalWideBandPower', mode=MODE_TYPE)
    Reference_ReceivedTotalWideBandPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=621)], ev=None, er=[])
    
    #-----< Reference-ReceivedTotalWideBandPowerReporting >-----#
    Reference_ReceivedTotalWideBandPowerReporting = ENUM(name='Reference-ReceivedTotalWideBandPowerReporting', mode=MODE_TYPE)
    Reference_ReceivedTotalWideBandPowerReporting._cont = ASN1Dict([('reference-ReceivedTotalWideBandPower-Requested', 0)])
    Reference_ReceivedTotalWideBandPowerReporting._ext = None
    
    #-----< Reference-ReceivedTotalWideBandPowerSupportIndicator >-----#
    Reference_ReceivedTotalWideBandPowerSupportIndicator = ENUM(name='Reference-ReceivedTotalWideBandPowerSupportIndicator', mode=MODE_TYPE)
    Reference_ReceivedTotalWideBandPowerSupportIndicator._cont = ASN1Dict([('indication-of-Reference-ReceivedTotalWideBandPower-supported', 0)])
    Reference_ReceivedTotalWideBandPowerSupportIndicator._ext = None
    
    #-----< ReferenceClockAvailability >-----#
    ReferenceClockAvailability = ENUM(name='ReferenceClockAvailability', mode=MODE_TYPE)
    ReferenceClockAvailability._cont = ASN1Dict([('available', 0), ('notAvailable', 1)])
    ReferenceClockAvailability._ext = None
    
    #-----< ReferenceSFNoffset >-----#
    ReferenceSFNoffset = INT(name='ReferenceSFNoffset', mode=MODE_TYPE)
    ReferenceSFNoffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< Reference-E-TFCI-Information >-----#
    Reference_E_TFCI_Information = SEQ_OF(name='Reference-E-TFCI-Information', mode=MODE_TYPE)
    _Reference_E_TFCI_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-E-TFCI-Information-Item')))
    Reference_E_TFCI_Information._cont = _Reference_E_TFCI_Information__item_
    Reference_E_TFCI_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Reference-E-TFCI-Information-Item >-----#
    Reference_E_TFCI_Information_Item = SEQ(name='Reference-E-TFCI-Information-Item', mode=MODE_TYPE)
    _Reference_E_TFCI_Information_Item_reference_E_TFCI = INT(name='reference-E-TFCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCI')))
    _Reference_E_TFCI_Information_Item_reference_E_TFCI_PO = INT(name='reference-E-TFCI-PO', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Reference-E-TFCI-PO')))
    _Reference_E_TFCI_Information_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Reference_E_TFCI_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ext-Reference-E-TFCI-PO')))
    ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 902), ('criticality', 'reject'), ('Extension', _____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab = ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab = ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Reference_E_TFCI_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id),
        ('criticality', ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __Reference_E_TFCI_Information_Item_iE_Extensions__item_._ext = None
    _Reference_E_TFCI_Information_Item_iE_Extensions._cont = __Reference_E_TFCI_Information_Item_iE_Extensions__item_
    _Reference_E_TFCI_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Reference_E_TFCI_Information_Item._cont = ASN1Dict([
        ('reference-E-TFCI', _Reference_E_TFCI_Information_Item_reference_E_TFCI),
        ('reference-E-TFCI-PO', _Reference_E_TFCI_Information_Item_reference_E_TFCI_PO),
        ('iE-Extensions', _Reference_E_TFCI_Information_Item_iE_Extensions),
        ])
    Reference_E_TFCI_Information_Item._ext = []
    
    #-----< Reference-E-TFCI-Information-Item-ExtIEs >-----#
    Reference_E_TFCI_Information_Item_ExtIEs = CLASS(name='Reference-E-TFCI-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Reference_E_TFCI_Information_Item_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Ext-Reference-E-TFCI-PO')))
    Reference_E_TFCI_Information_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 902), ('criticality', 'reject'), ('Extension', _Reference_E_TFCI_Information_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Reference-E-TFCI-PO >-----#
    Reference_E_TFCI_PO = INT(name='Reference-E-TFCI-PO', mode=MODE_TYPE)
    Reference_E_TFCI_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=29)], ev=None, er=[])
    
    #-----< RepetitionLength >-----#
    RepetitionLength = INT(name='RepetitionLength', mode=MODE_TYPE)
    RepetitionLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< RepetitionPeriod >-----#
    RepetitionPeriod = ENUM(name='RepetitionPeriod', mode=MODE_TYPE)
    RepetitionPeriod._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v4', 2), ('v8', 3), ('v16', 4), ('v32', 5), ('v64', 6)])
    RepetitionPeriod._ext = []
    
    #-----< RepetitionNumber0 >-----#
    RepetitionNumber0 = INT(name='RepetitionNumber0', mode=MODE_TYPE)
    RepetitionNumber0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RepetitionNumber1 >-----#
    RepetitionNumber1 = INT(name='RepetitionNumber1', mode=MODE_TYPE)
    RepetitionNumber1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RefTFCNumber >-----#
    RefTFCNumber = INT(name='RefTFCNumber', mode=MODE_TYPE)
    RefTFCNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< ReportCharacteristics >-----#
    ReportCharacteristics = CHOICE(name='ReportCharacteristics', mode=MODE_TYPE)
    _ReportCharacteristics_onDemand = NULL(name='onDemand', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReportCharacteristics_periodic = CHOICE(name='periodic', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-ReportPeriodicity')))
    _ReportCharacteristics_event_a = SEQ(name='event-a', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-EventA')))
    _ReportCharacteristics_event_b = SEQ(name='event-b', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-EventB')))
    _ReportCharacteristics_event_c = SEQ(name='event-c', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-EventC')))
    _ReportCharacteristics_event_d = SEQ(name='event-d', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-EventD')))
    _ReportCharacteristics_event_e = SEQ(name='event-e', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-EventE')))
    _ReportCharacteristics_event_f = SEQ(name='event-f', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-EventF')))
    _ReportCharacteristics_extension_ReportCharacteristics = SEQ(name='extension-ReportCharacteristics', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Extension-ReportCharacteristics')))
    ReportCharacteristics._cont = ASN1Dict([
        ('onDemand', _ReportCharacteristics_onDemand),
        ('periodic', _ReportCharacteristics_periodic),
        ('event-a', _ReportCharacteristics_event_a),
        ('event-b', _ReportCharacteristics_event_b),
        ('event-c', _ReportCharacteristics_event_c),
        ('event-d', _ReportCharacteristics_event_d),
        ('event-e', _ReportCharacteristics_event_e),
        ('event-f', _ReportCharacteristics_event_f),
        ('extension-ReportCharacteristics', _ReportCharacteristics_extension_ReportCharacteristics),
        ])
    ReportCharacteristics._ext = ['extension-ReportCharacteristics']
    
    #-----< Extension-ReportCharacteristics >-----#
    Extension_ReportCharacteristics = SEQ(name='Extension-ReportCharacteristics', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_ReportCharacteristics_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_ReportCharacteristics_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_ReportCharacteristics_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-OnModification')))
    __Extension_ReportCharacteristics_id_tab._val = ASN1Set(rv=[dict([('id', 512), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristics_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_ReportCharacteristics_id._const_tab = __Extension_ReportCharacteristics_id_tab
    _Extension_ReportCharacteristics_id._const_tab_at = None
    _Extension_ReportCharacteristics_id._const_tab_id = 'id'
    _Extension_ReportCharacteristics_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_ReportCharacteristics_criticality._const_tab = __Extension_ReportCharacteristics_id_tab
    _Extension_ReportCharacteristics_criticality._const_tab_at = ('..', 'id')
    _Extension_ReportCharacteristics_criticality._const_tab_id = 'criticality'
    _Extension_ReportCharacteristics_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_ReportCharacteristics_value._const_tab = __Extension_ReportCharacteristics_id_tab
    _Extension_ReportCharacteristics_value._const_tab_at = ('..', 'id')
    _Extension_ReportCharacteristics_value._const_tab_id = 'Value'
    Extension_ReportCharacteristics._cont = ASN1Dict([
        ('id', _Extension_ReportCharacteristics_id),
        ('criticality', _Extension_ReportCharacteristics_criticality),
        ('value', _Extension_ReportCharacteristics_value),
        ])
    Extension_ReportCharacteristics._ext = None
    
    #-----< Extension-ReportCharacteristicsIE >-----#
    Extension_ReportCharacteristicsIE = CLASS(name='Extension-ReportCharacteristicsIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_ReportCharacteristicsIE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-OnModification')))
    Extension_ReportCharacteristicsIE._val = ASN1Set(rv=[dict([('id', 512), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsIE_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< ReportCharacteristicsType-EventA >-----#
    ReportCharacteristicsType_EventA = SEQ(name='ReportCharacteristicsType-EventA', mode=MODE_TYPE)
    _ReportCharacteristicsType_EventA_measurementThreshold = CHOICE(name='measurementThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-MeasurementThreshold')))
    _ReportCharacteristicsType_EventA_measurementHysteresisTime = CHOICE(name='measurementHysteresisTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-ScaledMeasurementHysteresisTime')), opt=True)
    _ReportCharacteristicsType_EventA_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ReportCharacteristicsType_EventA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ReportCharacteristicsType_EventA_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__id._const_tab = ____ReportCharacteristicsType_EventA_iE_Extensions__item__id_tab
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__id._const_tab_at = None
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__id._const_tab_id = 'id'
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ReportCharacteristicsType_EventA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__criticality._const_tab = ____ReportCharacteristicsType_EventA_iE_Extensions__item__criticality_tab
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ReportCharacteristicsType_EventA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__extensionValue._const_tab = ____ReportCharacteristicsType_EventA_iE_Extensions__item__extensionValue_tab
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventA_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ReportCharacteristicsType_EventA_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ReportCharacteristicsType_EventA_iE_Extensions__item__id),
        ('criticality', ___ReportCharacteristicsType_EventA_iE_Extensions__item__criticality),
        ('extensionValue', ___ReportCharacteristicsType_EventA_iE_Extensions__item__extensionValue),
        ])
    __ReportCharacteristicsType_EventA_iE_Extensions__item_._ext = None
    _ReportCharacteristicsType_EventA_iE_Extensions._cont = __ReportCharacteristicsType_EventA_iE_Extensions__item_
    _ReportCharacteristicsType_EventA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ReportCharacteristicsType_EventA._cont = ASN1Dict([
        ('measurementThreshold', _ReportCharacteristicsType_EventA_measurementThreshold),
        ('measurementHysteresisTime', _ReportCharacteristicsType_EventA_measurementHysteresisTime),
        ('iE-Extensions', _ReportCharacteristicsType_EventA_iE_Extensions),
        ])
    ReportCharacteristicsType_EventA._ext = []
    
    #-----< ReportCharacteristicsType-EventA-ExtIEs >-----#
    ReportCharacteristicsType_EventA_ExtIEs = CLASS(name='ReportCharacteristicsType-EventA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ReportCharacteristicsType_EventA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportCharacteristicsType-EventB >-----#
    ReportCharacteristicsType_EventB = SEQ(name='ReportCharacteristicsType-EventB', mode=MODE_TYPE)
    _ReportCharacteristicsType_EventB_measurementThreshold = CHOICE(name='measurementThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-MeasurementThreshold')))
    _ReportCharacteristicsType_EventB_measurementHysteresisTime = CHOICE(name='measurementHysteresisTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-ScaledMeasurementHysteresisTime')), opt=True)
    _ReportCharacteristicsType_EventB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ReportCharacteristicsType_EventB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ReportCharacteristicsType_EventB_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__id._const_tab = ____ReportCharacteristicsType_EventB_iE_Extensions__item__id_tab
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__id._const_tab_at = None
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__id._const_tab_id = 'id'
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ReportCharacteristicsType_EventB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__criticality._const_tab = ____ReportCharacteristicsType_EventB_iE_Extensions__item__criticality_tab
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ReportCharacteristicsType_EventB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__extensionValue._const_tab = ____ReportCharacteristicsType_EventB_iE_Extensions__item__extensionValue_tab
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ReportCharacteristicsType_EventB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ReportCharacteristicsType_EventB_iE_Extensions__item__id),
        ('criticality', ___ReportCharacteristicsType_EventB_iE_Extensions__item__criticality),
        ('extensionValue', ___ReportCharacteristicsType_EventB_iE_Extensions__item__extensionValue),
        ])
    __ReportCharacteristicsType_EventB_iE_Extensions__item_._ext = None
    _ReportCharacteristicsType_EventB_iE_Extensions._cont = __ReportCharacteristicsType_EventB_iE_Extensions__item_
    _ReportCharacteristicsType_EventB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ReportCharacteristicsType_EventB._cont = ASN1Dict([
        ('measurementThreshold', _ReportCharacteristicsType_EventB_measurementThreshold),
        ('measurementHysteresisTime', _ReportCharacteristicsType_EventB_measurementHysteresisTime),
        ('iE-Extensions', _ReportCharacteristicsType_EventB_iE_Extensions),
        ])
    ReportCharacteristicsType_EventB._ext = []
    
    #-----< ReportCharacteristicsType-EventB-ExtIEs >-----#
    ReportCharacteristicsType_EventB_ExtIEs = CLASS(name='ReportCharacteristicsType-EventB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ReportCharacteristicsType_EventB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportCharacteristicsType-EventC >-----#
    ReportCharacteristicsType_EventC = SEQ(name='ReportCharacteristicsType-EventC', mode=MODE_TYPE)
    _ReportCharacteristicsType_EventC_measurementIncreaseThreshold = CHOICE(name='measurementIncreaseThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold')))
    _ReportCharacteristicsType_EventC_measurementChangeTime = CHOICE(name='measurementChangeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-ScaledMeasurementChangeTime')))
    _ReportCharacteristicsType_EventC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ReportCharacteristicsType_EventC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ReportCharacteristicsType_EventC_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__id._const_tab = ____ReportCharacteristicsType_EventC_iE_Extensions__item__id_tab
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__id._const_tab_at = None
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__id._const_tab_id = 'id'
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ReportCharacteristicsType_EventC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__criticality._const_tab = ____ReportCharacteristicsType_EventC_iE_Extensions__item__criticality_tab
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ReportCharacteristicsType_EventC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__extensionValue._const_tab = ____ReportCharacteristicsType_EventC_iE_Extensions__item__extensionValue_tab
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ReportCharacteristicsType_EventC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ReportCharacteristicsType_EventC_iE_Extensions__item__id),
        ('criticality', ___ReportCharacteristicsType_EventC_iE_Extensions__item__criticality),
        ('extensionValue', ___ReportCharacteristicsType_EventC_iE_Extensions__item__extensionValue),
        ])
    __ReportCharacteristicsType_EventC_iE_Extensions__item_._ext = None
    _ReportCharacteristicsType_EventC_iE_Extensions._cont = __ReportCharacteristicsType_EventC_iE_Extensions__item_
    _ReportCharacteristicsType_EventC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ReportCharacteristicsType_EventC._cont = ASN1Dict([
        ('measurementIncreaseThreshold', _ReportCharacteristicsType_EventC_measurementIncreaseThreshold),
        ('measurementChangeTime', _ReportCharacteristicsType_EventC_measurementChangeTime),
        ('iE-Extensions', _ReportCharacteristicsType_EventC_iE_Extensions),
        ])
    ReportCharacteristicsType_EventC._ext = []
    
    #-----< ReportCharacteristicsType-EventC-ExtIEs >-----#
    ReportCharacteristicsType_EventC_ExtIEs = CLASS(name='ReportCharacteristicsType-EventC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ReportCharacteristicsType_EventC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportCharacteristicsType-EventD >-----#
    ReportCharacteristicsType_EventD = SEQ(name='ReportCharacteristicsType-EventD', mode=MODE_TYPE)
    _ReportCharacteristicsType_EventD_measurementDecreaseThreshold = CHOICE(name='measurementDecreaseThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold')))
    _ReportCharacteristicsType_EventD_measurementChangeTime = CHOICE(name='measurementChangeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-ScaledMeasurementChangeTime')))
    _ReportCharacteristicsType_EventD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ReportCharacteristicsType_EventD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ReportCharacteristicsType_EventD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__id._const_tab = ____ReportCharacteristicsType_EventD_iE_Extensions__item__id_tab
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__id._const_tab_at = None
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__id._const_tab_id = 'id'
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ReportCharacteristicsType_EventD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__criticality._const_tab = ____ReportCharacteristicsType_EventD_iE_Extensions__item__criticality_tab
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ReportCharacteristicsType_EventD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__extensionValue._const_tab = ____ReportCharacteristicsType_EventD_iE_Extensions__item__extensionValue_tab
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ReportCharacteristicsType_EventD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ReportCharacteristicsType_EventD_iE_Extensions__item__id),
        ('criticality', ___ReportCharacteristicsType_EventD_iE_Extensions__item__criticality),
        ('extensionValue', ___ReportCharacteristicsType_EventD_iE_Extensions__item__extensionValue),
        ])
    __ReportCharacteristicsType_EventD_iE_Extensions__item_._ext = None
    _ReportCharacteristicsType_EventD_iE_Extensions._cont = __ReportCharacteristicsType_EventD_iE_Extensions__item_
    _ReportCharacteristicsType_EventD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ReportCharacteristicsType_EventD._cont = ASN1Dict([
        ('measurementDecreaseThreshold', _ReportCharacteristicsType_EventD_measurementDecreaseThreshold),
        ('measurementChangeTime', _ReportCharacteristicsType_EventD_measurementChangeTime),
        ('iE-Extensions', _ReportCharacteristicsType_EventD_iE_Extensions),
        ])
    ReportCharacteristicsType_EventD._ext = []
    
    #-----< ReportCharacteristicsType-EventD-ExtIEs >-----#
    ReportCharacteristicsType_EventD_ExtIEs = CLASS(name='ReportCharacteristicsType-EventD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ReportCharacteristicsType_EventD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportCharacteristicsType-EventE >-----#
    ReportCharacteristicsType_EventE = SEQ(name='ReportCharacteristicsType-EventE', mode=MODE_TYPE)
    _ReportCharacteristicsType_EventE_measurementThreshold1 = CHOICE(name='measurementThreshold1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-MeasurementThreshold')))
    _ReportCharacteristicsType_EventE_measurementThreshold2 = CHOICE(name='measurementThreshold2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-MeasurementThreshold')), opt=True)
    _ReportCharacteristicsType_EventE_measurementHysteresisTime = CHOICE(name='measurementHysteresisTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-ScaledMeasurementHysteresisTime')), opt=True)
    _ReportCharacteristicsType_EventE_reportPeriodicity = CHOICE(name='reportPeriodicity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-ReportPeriodicity')), opt=True)
    _ReportCharacteristicsType_EventE_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ReportCharacteristicsType_EventE_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ReportCharacteristicsType_EventE_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventE_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__id._const_tab = ____ReportCharacteristicsType_EventE_iE_Extensions__item__id_tab
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__id._const_tab_at = None
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__id._const_tab_id = 'id'
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ReportCharacteristicsType_EventE_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventE_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__criticality._const_tab = ____ReportCharacteristicsType_EventE_iE_Extensions__item__criticality_tab
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ReportCharacteristicsType_EventE_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventE_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__extensionValue._const_tab = ____ReportCharacteristicsType_EventE_iE_Extensions__item__extensionValue_tab
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventE_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ReportCharacteristicsType_EventE_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ReportCharacteristicsType_EventE_iE_Extensions__item__id),
        ('criticality', ___ReportCharacteristicsType_EventE_iE_Extensions__item__criticality),
        ('extensionValue', ___ReportCharacteristicsType_EventE_iE_Extensions__item__extensionValue),
        ])
    __ReportCharacteristicsType_EventE_iE_Extensions__item_._ext = None
    _ReportCharacteristicsType_EventE_iE_Extensions._cont = __ReportCharacteristicsType_EventE_iE_Extensions__item_
    _ReportCharacteristicsType_EventE_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ReportCharacteristicsType_EventE._cont = ASN1Dict([
        ('measurementThreshold1', _ReportCharacteristicsType_EventE_measurementThreshold1),
        ('measurementThreshold2', _ReportCharacteristicsType_EventE_measurementThreshold2),
        ('measurementHysteresisTime', _ReportCharacteristicsType_EventE_measurementHysteresisTime),
        ('reportPeriodicity', _ReportCharacteristicsType_EventE_reportPeriodicity),
        ('iE-Extensions', _ReportCharacteristicsType_EventE_iE_Extensions),
        ])
    ReportCharacteristicsType_EventE._ext = []
    
    #-----< ReportCharacteristicsType-EventE-ExtIEs >-----#
    ReportCharacteristicsType_EventE_ExtIEs = CLASS(name='ReportCharacteristicsType-EventE-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ReportCharacteristicsType_EventE_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportCharacteristicsType-EventF >-----#
    ReportCharacteristicsType_EventF = SEQ(name='ReportCharacteristicsType-EventF', mode=MODE_TYPE)
    _ReportCharacteristicsType_EventF_measurementThreshold1 = CHOICE(name='measurementThreshold1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-MeasurementThreshold')))
    _ReportCharacteristicsType_EventF_measurementThreshold2 = CHOICE(name='measurementThreshold2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-MeasurementThreshold')), opt=True)
    _ReportCharacteristicsType_EventF_measurementHysteresisTime = CHOICE(name='measurementHysteresisTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-ScaledMeasurementHysteresisTime')), opt=True)
    _ReportCharacteristicsType_EventF_reportPeriodicity = CHOICE(name='reportPeriodicity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-ReportPeriodicity')), opt=True)
    _ReportCharacteristicsType_EventF_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ReportCharacteristicsType_EventF_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ReportCharacteristicsType_EventF_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventF_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__id._const_tab = ____ReportCharacteristicsType_EventF_iE_Extensions__item__id_tab
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__id._const_tab_at = None
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__id._const_tab_id = 'id'
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ReportCharacteristicsType_EventF_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventF_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__criticality._const_tab = ____ReportCharacteristicsType_EventF_iE_Extensions__item__criticality_tab
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ReportCharacteristicsType_EventF_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_EventF_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__extensionValue._const_tab = ____ReportCharacteristicsType_EventF_iE_Extensions__item__extensionValue_tab
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_EventF_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ReportCharacteristicsType_EventF_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ReportCharacteristicsType_EventF_iE_Extensions__item__id),
        ('criticality', ___ReportCharacteristicsType_EventF_iE_Extensions__item__criticality),
        ('extensionValue', ___ReportCharacteristicsType_EventF_iE_Extensions__item__extensionValue),
        ])
    __ReportCharacteristicsType_EventF_iE_Extensions__item_._ext = None
    _ReportCharacteristicsType_EventF_iE_Extensions._cont = __ReportCharacteristicsType_EventF_iE_Extensions__item_
    _ReportCharacteristicsType_EventF_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ReportCharacteristicsType_EventF._cont = ASN1Dict([
        ('measurementThreshold1', _ReportCharacteristicsType_EventF_measurementThreshold1),
        ('measurementThreshold2', _ReportCharacteristicsType_EventF_measurementThreshold2),
        ('measurementHysteresisTime', _ReportCharacteristicsType_EventF_measurementHysteresisTime),
        ('reportPeriodicity', _ReportCharacteristicsType_EventF_reportPeriodicity),
        ('iE-Extensions', _ReportCharacteristicsType_EventF_iE_Extensions),
        ])
    ReportCharacteristicsType_EventF._ext = []
    
    #-----< ReportCharacteristicsType-EventF-ExtIEs >-----#
    ReportCharacteristicsType_EventF_ExtIEs = CLASS(name='ReportCharacteristicsType-EventF-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ReportCharacteristicsType_EventF_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportCharacteristicsType-OnModification >-----#
    ReportCharacteristicsType_OnModification = SEQ(name='ReportCharacteristicsType-OnModification', mode=MODE_TYPE)
    _ReportCharacteristicsType_OnModification_measurementThreshold = CHOICE(name='measurementThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristicsType-MeasurementThreshold')))
    _ReportCharacteristicsType_OnModification_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ReportCharacteristicsType_OnModification_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ReportCharacteristicsType_OnModification_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_OnModification_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__id._const_tab = ____ReportCharacteristicsType_OnModification_iE_Extensions__item__id_tab
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__id._const_tab_at = None
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__id._const_tab_id = 'id'
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ReportCharacteristicsType_OnModification_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_OnModification_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__criticality._const_tab = ____ReportCharacteristicsType_OnModification_iE_Extensions__item__criticality_tab
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ReportCharacteristicsType_OnModification_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ReportCharacteristicsType_OnModification_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__extensionValue._const_tab = ____ReportCharacteristicsType_OnModification_iE_Extensions__item__extensionValue_tab
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ReportCharacteristicsType_OnModification_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ReportCharacteristicsType_OnModification_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ReportCharacteristicsType_OnModification_iE_Extensions__item__id),
        ('criticality', ___ReportCharacteristicsType_OnModification_iE_Extensions__item__criticality),
        ('extensionValue', ___ReportCharacteristicsType_OnModification_iE_Extensions__item__extensionValue),
        ])
    __ReportCharacteristicsType_OnModification_iE_Extensions__item_._ext = None
    _ReportCharacteristicsType_OnModification_iE_Extensions._cont = __ReportCharacteristicsType_OnModification_iE_Extensions__item_
    _ReportCharacteristicsType_OnModification_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ReportCharacteristicsType_OnModification._cont = ASN1Dict([
        ('measurementThreshold', _ReportCharacteristicsType_OnModification_measurementThreshold),
        ('iE-Extensions', _ReportCharacteristicsType_OnModification_iE_Extensions),
        ])
    ReportCharacteristicsType_OnModification._ext = []
    
    #-----< ReportCharacteristicsType-OnModification-ExtIEs >-----#
    ReportCharacteristicsType_OnModification_ExtIEs = CLASS(name='ReportCharacteristicsType-OnModification-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ReportCharacteristicsType_OnModification_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold >-----#
    ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold = CHOICE(name='ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold', mode=MODE_TYPE)
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_received_total_wide_band_power = INT(name='received-total-wide-band-power', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value-IncrDecrThres')))
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_transmitted_carrier_power = INT(name='transmitted-carrier-power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-Value')))
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_acknowledged_prach_preambles = INT(name='acknowledged-prach-preambles', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Acknowledged-PRACH-preambles-Value')))
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_uL_TimeslotISCP = INT(name='uL-TimeslotISCP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-Value-IncrDecrThres')))
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_sir = INT(name='sir', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SIR-Value-IncrDecrThres')))
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_sir_error = INT(name='sir-error', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SIR-Error-Value-IncrDecrThres')))
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_transmitted_code_power = INT(name='transmitted-code-power', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Code-Power-Value-IncrDecrThres')))
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_rscp = INT(name='rscp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RSCP-Value-IncrDecrThres')))
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_round_trip_time = INT(name='round-trip-time', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Round-Trip-Time-IncrDecrThres')))
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_notUsed_1_acknowledged_PCPCH_access_preambles = NULL(name='notUsed-1-acknowledged-PCPCH-access-preambles', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_notUsed_2_detected_PCPCH_access_preambles = NULL(name='notUsed-2-detected-PCPCH-access-preambles', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold = SEQ(name='extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold')))
    ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold._cont = ASN1Dict([
        ('received-total-wide-band-power', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_received_total_wide_band_power),
        ('transmitted-carrier-power', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_transmitted_carrier_power),
        ('acknowledged-prach-preambles', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_acknowledged_prach_preambles),
        ('uL-TimeslotISCP', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_uL_TimeslotISCP),
        ('sir', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_sir),
        ('sir-error', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_sir_error),
        ('transmitted-code-power', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_transmitted_code_power),
        ('rscp', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_rscp),
        ('round-trip-time', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_round_trip_time),
        ('notUsed-1-acknowledged-PCPCH-access-preambles', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_notUsed_1_acknowledged_PCPCH_access_preambles),
        ('notUsed-2-detected-PCPCH-access-preambles', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_notUsed_2_detected_PCPCH_access_preambles),
        ('extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold', _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold),
        ])
    ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold._ext = ['extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold']
    
    #-----< Extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold >-----#
    Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold = SEQ(name='Extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThreshold', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-Value')))
    ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value-IncrDecrThres')))
    ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterferenceValue')))
    ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RSEPS-Value-IncrDecrThres')))
    ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RSEPS-Value-IncrDecrThres')))
    ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EDCH-RACH-Report-IncrDecrThres')))
    ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-Value-IncrDecrThres')))
    ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterferenceValue')))
    __Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab._val = ASN1Set(rv=[dict([('id', 587), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 618), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 601), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 620), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 622), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 791), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 792), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 1018), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 1117), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_8), ('presence', 'mandatory')]), dict([('id', 1104), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_9), ('presence', 'mandatory')]), dict([('id', 1105), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_10), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id._const_tab = __Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id._const_tab_at = None
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id._const_tab_id = 'id'
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_criticality._const_tab = __Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_criticality._const_tab_at = ('..', 'id')
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_criticality._const_tab_id = 'criticality'
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_value._const_tab = __Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_value._const_tab_at = ('..', 'id')
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_value._const_tab_id = 'Value'
    Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold._cont = ASN1Dict([
        ('id', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id),
        ('criticality', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_criticality),
        ('value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_value),
        ])
    Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold._ext = None
    
    #-----< Extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThresholdIE >-----#
    Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE = CLASS(name='Extension-ReportCharacteristicsType-MeasurementIncreaseDecreaseThresholdIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-Value')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value-IncrDecrThres')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterferenceValue')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RSEPS-Value-IncrDecrThres')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RSEPS-Value-IncrDecrThres')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EDCH-RACH-Report-IncrDecrThres')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-Value-IncrDecrThres')))
    _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterferenceValue')))
    Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE._val = ASN1Set(rv=[dict([('id', 587), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 618), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_1), ('presence', 'mandatory')]), dict([('id', 601), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_2), ('presence', 'mandatory')]), dict([('id', 620), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_3), ('presence', 'mandatory')]), dict([('id', 622), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_4), ('presence', 'mandatory')]), dict([('id', 791), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_5), ('presence', 'mandatory')]), dict([('id', 792), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_6), ('presence', 'mandatory')]), dict([('id', 1018), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_7), ('presence', 'mandatory')]), dict([('id', 1117), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_8), ('presence', 'mandatory')]), dict([('id', 1104), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_9), ('presence', 'mandatory')]), dict([('id', 1105), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_10), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< EDCH-RACH-Report-IncrDecrThres >-----#
    EDCH_RACH_Report_IncrDecrThres = SEQ(name='EDCH-RACH-Report-IncrDecrThres', mode=MODE_TYPE)
    _EDCH_RACH_Report_IncrDecrThres_denied_EDCH_RACH_resources = INT(name='denied-EDCH-RACH-resources', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Denied-EDCH-RACH-Resources-Value')))
    _EDCH_RACH_Report_IncrDecrThres_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Overridden-E-DCH-RACH-Resources')))
    _____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Denied-E-DCH-RACH-Resources')))
    ____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1250), ('criticality', 'ignore'), ('Extension', _____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1251), ('criticality', 'ignore'), ('Extension', _____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id._const_tab = ____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id._const_tab_id = 'id'
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__criticality._const_tab = ____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__extensionValue._const_tab = ____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id),
        ('criticality', ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__criticality),
        ('extensionValue', ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__extensionValue),
        ])
    __EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item_._ext = None
    _EDCH_RACH_Report_IncrDecrThres_iE_Extensions._cont = __EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item_
    _EDCH_RACH_Report_IncrDecrThres_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_RACH_Report_IncrDecrThres._cont = ASN1Dict([
        ('denied-EDCH-RACH-resources', _EDCH_RACH_Report_IncrDecrThres_denied_EDCH_RACH_resources),
        ('iE-Extensions', _EDCH_RACH_Report_IncrDecrThres_iE_Extensions),
        ])
    EDCH_RACH_Report_IncrDecrThres._ext = []
    
    #-----< EDCH-RACH-Report-IncrDecrThres-ExtIEs >-----#
    EDCH_RACH_Report_IncrDecrThres_ExtIEs = CLASS(name='EDCH-RACH-Report-IncrDecrThres-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _EDCH_RACH_Report_IncrDecrThres_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Overridden-E-DCH-RACH-Resources')))
    _EDCH_RACH_Report_IncrDecrThres_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Denied-E-DCH-RACH-Resources')))
    EDCH_RACH_Report_IncrDecrThres_ExtIEs._val = ASN1Set(rv=[dict([('id', 1250), ('criticality', 'ignore'), ('Extension', _EDCH_RACH_Report_IncrDecrThres_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1251), ('criticality', 'ignore'), ('Extension', _EDCH_RACH_Report_IncrDecrThres_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Granted-EDCH-RACH-Resources-Value >-----#
    Granted_EDCH_RACH_Resources_Value = INT(name='Granted-EDCH-RACH-Resources-Value', mode=MODE_TYPE)
    Granted_EDCH_RACH_Resources_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=240)], ev=[], er=[])
    
    #-----< Denied-EDCH-RACH-Resources-Value >-----#
    Denied_EDCH_RACH_Resources_Value = INT(name='Denied-EDCH-RACH-Resources-Value', mode=MODE_TYPE)
    Denied_EDCH_RACH_Resources_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=240)], ev=[], er=[])
    
    #-----< ReportCharacteristicsType-MeasurementThreshold >-----#
    ReportCharacteristicsType_MeasurementThreshold = CHOICE(name='ReportCharacteristicsType-MeasurementThreshold', mode=MODE_TYPE)
    _ReportCharacteristicsType_MeasurementThreshold_received_total_wide_band_power = INT(name='received-total-wide-band-power', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')))
    _ReportCharacteristicsType_MeasurementThreshold_transmitted_carrier_power = INT(name='transmitted-carrier-power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-Value')))
    _ReportCharacteristicsType_MeasurementThreshold_acknowledged_prach_preambles = INT(name='acknowledged-prach-preambles', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Acknowledged-PRACH-preambles-Value')))
    _ReportCharacteristicsType_MeasurementThreshold_uL_TimeslotISCP = INT(name='uL-TimeslotISCP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-Value')))
    _ReportCharacteristicsType_MeasurementThreshold_sir = INT(name='sir', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SIR-Value')))
    _ReportCharacteristicsType_MeasurementThreshold_sir_error = INT(name='sir-error', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SIR-Error-Value')))
    _ReportCharacteristicsType_MeasurementThreshold_transmitted_code_power = INT(name='transmitted-code-power', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Code-Power-Value')))
    _ReportCharacteristicsType_MeasurementThreshold_rscp = INT(name='rscp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RSCP-Value')))
    _ReportCharacteristicsType_MeasurementThreshold_rx_timing_deviation = INT(name='rx-timing-deviation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value')))
    _ReportCharacteristicsType_MeasurementThreshold_round_trip_time = INT(name='round-trip-time', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Round-Trip-Time-Value')))
    _ReportCharacteristicsType_MeasurementThreshold_notUsed_1_acknowledged_PCPCH_access_preambles = NULL(name='notUsed-1-acknowledged-PCPCH-access-preambles', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReportCharacteristicsType_MeasurementThreshold_notUsed_2_detected_PCPCH_access_preambles = NULL(name='notUsed-2-detected-PCPCH-access-preambles', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReportCharacteristicsType_MeasurementThreshold_extension_ReportCharacteristicsType_MeasurementThreshold = SEQ(name='extension-ReportCharacteristicsType-MeasurementThreshold', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Extension-ReportCharacteristicsType-MeasurementThreshold')))
    ReportCharacteristicsType_MeasurementThreshold._cont = ASN1Dict([
        ('received-total-wide-band-power', _ReportCharacteristicsType_MeasurementThreshold_received_total_wide_band_power),
        ('transmitted-carrier-power', _ReportCharacteristicsType_MeasurementThreshold_transmitted_carrier_power),
        ('acknowledged-prach-preambles', _ReportCharacteristicsType_MeasurementThreshold_acknowledged_prach_preambles),
        ('uL-TimeslotISCP', _ReportCharacteristicsType_MeasurementThreshold_uL_TimeslotISCP),
        ('sir', _ReportCharacteristicsType_MeasurementThreshold_sir),
        ('sir-error', _ReportCharacteristicsType_MeasurementThreshold_sir_error),
        ('transmitted-code-power', _ReportCharacteristicsType_MeasurementThreshold_transmitted_code_power),
        ('rscp', _ReportCharacteristicsType_MeasurementThreshold_rscp),
        ('rx-timing-deviation', _ReportCharacteristicsType_MeasurementThreshold_rx_timing_deviation),
        ('round-trip-time', _ReportCharacteristicsType_MeasurementThreshold_round_trip_time),
        ('notUsed-1-acknowledged-PCPCH-access-preambles', _ReportCharacteristicsType_MeasurementThreshold_notUsed_1_acknowledged_PCPCH_access_preambles),
        ('notUsed-2-detected-PCPCH-access-preambles', _ReportCharacteristicsType_MeasurementThreshold_notUsed_2_detected_PCPCH_access_preambles),
        ('extension-ReportCharacteristicsType-MeasurementThreshold', _ReportCharacteristicsType_MeasurementThreshold_extension_ReportCharacteristicsType_MeasurementThreshold),
        ])
    ReportCharacteristicsType_MeasurementThreshold._ext = ['extension-ReportCharacteristicsType-MeasurementThreshold']
    
    #-----< Extension-ReportCharacteristicsType-MeasurementThreshold >-----#
    Extension_ReportCharacteristicsType_MeasurementThreshold = SEQ(name='Extension-ReportCharacteristicsType-MeasurementThreshold', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_ReportCharacteristicsType_MeasurementThreshold_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGPSMeasurementThresholdInformation')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFNSFNMeasurementThresholdInformation')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-LCR')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-Reception-Quality-Measurement-Value')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerValue')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-Value')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterferenceValue')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DLTransmissionBranchLoadValue')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerValue')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_12 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Non-serving-Relative-Grant-Down-Commands')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_13 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-768')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_14 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-384-ext')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_15 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-Round-Trip-Time-Value')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_16 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RSEPS-Value-IncrDecrThres')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_17 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RSEPS-Value-IncrDecrThres')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_18 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-Reception-Quality-Measurement-Value')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGANSSMeasurementThresholdInformation')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EDCH-RACH-Report-ThresholdInformation')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_21 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_22 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-Value')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_23 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterferenceValue')))
    ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_24 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-transmission-power-headroom-Value')))
    __Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab._val = ASN1Set(rv=[dict([('id', 516), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 514), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 520), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 589), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 587), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 586), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 618), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 601), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 620), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_8), ('presence', 'mandatory')]), dict([('id', 622), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_9), ('presence', 'mandatory')]), dict([('id', 653), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_10), ('presence', 'mandatory')]), dict([('id', 660), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_11), ('presence', 'mandatory')]), dict([('id', 708), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_12), ('presence', 'mandatory')]), dict([('id', 762), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_13), ('presence', 'mandatory')]), dict([('id', 786), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_14), ('presence', 'mandatory')]), dict([('id', 820), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_15), ('presence', 'mandatory')]), dict([('id', 791), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_16), ('presence', 'mandatory')]), dict([('id', 792), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_17), ('presence', 'mandatory')]), dict([('id', 884), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_18), ('presence', 'mandatory')]), dict([('id', 890), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_19), ('presence', 'mandatory')]), dict([('id', 1019), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_20), ('presence', 'mandatory')]), dict([('id', 1117), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_21), ('presence', 'mandatory')]), dict([('id', 1104), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_22), ('presence', 'mandatory')]), dict([('id', 1105), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_23), ('presence', 'mandatory')]), dict([('id', 1225), ('criticality', 'reject'), ('Value', ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_24), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_ReportCharacteristicsType_MeasurementThreshold_id._const_tab = __Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab
    _Extension_ReportCharacteristicsType_MeasurementThreshold_id._const_tab_at = None
    _Extension_ReportCharacteristicsType_MeasurementThreshold_id._const_tab_id = 'id'
    _Extension_ReportCharacteristicsType_MeasurementThreshold_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_ReportCharacteristicsType_MeasurementThreshold_criticality._const_tab = __Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab
    _Extension_ReportCharacteristicsType_MeasurementThreshold_criticality._const_tab_at = ('..', 'id')
    _Extension_ReportCharacteristicsType_MeasurementThreshold_criticality._const_tab_id = 'criticality'
    _Extension_ReportCharacteristicsType_MeasurementThreshold_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_ReportCharacteristicsType_MeasurementThreshold_value._const_tab = __Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab
    _Extension_ReportCharacteristicsType_MeasurementThreshold_value._const_tab_at = ('..', 'id')
    _Extension_ReportCharacteristicsType_MeasurementThreshold_value._const_tab_id = 'Value'
    Extension_ReportCharacteristicsType_MeasurementThreshold._cont = ASN1Dict([
        ('id', _Extension_ReportCharacteristicsType_MeasurementThreshold_id),
        ('criticality', _Extension_ReportCharacteristicsType_MeasurementThreshold_criticality),
        ('value', _Extension_ReportCharacteristicsType_MeasurementThreshold_value),
        ])
    Extension_ReportCharacteristicsType_MeasurementThreshold._ext = None
    
    #-----< Extension-ReportCharacteristicsType-MeasurementThresholdIE >-----#
    Extension_ReportCharacteristicsType_MeasurementThresholdIE = CLASS(name='Extension-ReportCharacteristicsType-MeasurementThresholdIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGPSMeasurementThresholdInformation')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFNSFNMeasurementThresholdInformation')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-LCR')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-Reception-Quality-Measurement-Value')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerValue')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-Value')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterferenceValue')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DLTransmissionBranchLoadValue')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCHRequiredPowerValue')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_12 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Non-serving-Relative-Grant-Down-Commands')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_13 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-768')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_14 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Rx-Timing-Deviation-Value-384-ext')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_15 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-Round-Trip-Time-Value')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_16 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RSEPS-Value-IncrDecrThres')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_17 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RSEPS-Value-IncrDecrThres')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_18 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-Reception-Quality-Measurement-Value')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGANSSMeasurementThresholdInformation')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'EDCH-RACH-Report-ThresholdInformation')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_21 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_22 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-Value')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_23 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterferenceValue')))
    _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_24 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-transmission-power-headroom-Value')))
    Extension_ReportCharacteristicsType_MeasurementThresholdIE._val = ASN1Set(rv=[dict([('id', 516), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 514), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_1), ('presence', 'mandatory')]), dict([('id', 520), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_2), ('presence', 'mandatory')]), dict([('id', 589), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_3), ('presence', 'mandatory')]), dict([('id', 587), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_4), ('presence', 'mandatory')]), dict([('id', 586), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_5), ('presence', 'mandatory')]), dict([('id', 618), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_6), ('presence', 'mandatory')]), dict([('id', 601), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_7), ('presence', 'mandatory')]), dict([('id', 620), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_8), ('presence', 'mandatory')]), dict([('id', 622), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_9), ('presence', 'mandatory')]), dict([('id', 653), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_10), ('presence', 'mandatory')]), dict([('id', 660), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_11), ('presence', 'mandatory')]), dict([('id', 708), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_12), ('presence', 'mandatory')]), dict([('id', 762), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_13), ('presence', 'mandatory')]), dict([('id', 786), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_14), ('presence', 'mandatory')]), dict([('id', 820), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_15), ('presence', 'mandatory')]), dict([('id', 791), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_16), ('presence', 'mandatory')]), dict([('id', 792), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_17), ('presence', 'mandatory')]), dict([('id', 884), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_18), ('presence', 'mandatory')]), dict([('id', 890), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_19), ('presence', 'mandatory')]), dict([('id', 1019), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_20), ('presence', 'mandatory')]), dict([('id', 1117), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_21), ('presence', 'mandatory')]), dict([('id', 1104), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_22), ('presence', 'mandatory')]), dict([('id', 1105), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_23), ('presence', 'mandatory')]), dict([('id', 1225), ('criticality', 'reject'), ('Value', _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_24), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< EDCH-RACH-Report-ThresholdInformation >-----#
    EDCH_RACH_Report_ThresholdInformation = SEQ(name='EDCH-RACH-Report-ThresholdInformation', mode=MODE_TYPE)
    _EDCH_RACH_Report_ThresholdInformation_denied_EDCH_RACH_resources = INT(name='denied-EDCH-RACH-resources', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Denied-EDCH-RACH-Resources-Value')))
    _EDCH_RACH_Report_ThresholdInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Overridden-E-DCH-RACH-Resources')))
    _____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Denied-E-DCH-RACH-Resources')))
    ____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1250), ('criticality', 'ignore'), ('Extension', _____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1251), ('criticality', 'ignore'), ('Extension', _____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id._const_tab = ____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__criticality._const_tab = ____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__extensionValue._const_tab = ____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id),
        ('criticality', ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__extensionValue),
        ])
    __EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item_._ext = None
    _EDCH_RACH_Report_ThresholdInformation_iE_Extensions._cont = __EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item_
    _EDCH_RACH_Report_ThresholdInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_RACH_Report_ThresholdInformation._cont = ASN1Dict([
        ('denied-EDCH-RACH-resources', _EDCH_RACH_Report_ThresholdInformation_denied_EDCH_RACH_resources),
        ('iE-Extensions', _EDCH_RACH_Report_ThresholdInformation_iE_Extensions),
        ])
    EDCH_RACH_Report_ThresholdInformation._ext = []
    
    #-----< EDCH-RACH-Report-ThresholdInformation-ExtIEs >-----#
    EDCH_RACH_Report_ThresholdInformation_ExtIEs = CLASS(name='EDCH-RACH-Report-ThresholdInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _EDCH_RACH_Report_ThresholdInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Overridden-E-DCH-RACH-Resources')))
    _EDCH_RACH_Report_ThresholdInformation_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Two-ms-Denied-E-DCH-RACH-Resources')))
    EDCH_RACH_Report_ThresholdInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 1250), ('criticality', 'ignore'), ('Extension', _EDCH_RACH_Report_ThresholdInformation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1251), ('criticality', 'ignore'), ('Extension', _EDCH_RACH_Report_ThresholdInformation_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ReportCharacteristicsType-ScaledMeasurementChangeTime >-----#
    ReportCharacteristicsType_ScaledMeasurementChangeTime = CHOICE(name='ReportCharacteristicsType-ScaledMeasurementChangeTime', mode=MODE_TYPE)
    _ReportCharacteristicsType_ScaledMeasurementChangeTime_msec = INT(name='msec', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MeasurementChangeTime-Scaledmsec')))
    ReportCharacteristicsType_ScaledMeasurementChangeTime._cont = ASN1Dict([
        ('msec', _ReportCharacteristicsType_ScaledMeasurementChangeTime_msec),
        ])
    ReportCharacteristicsType_ScaledMeasurementChangeTime._ext = []
    
    #-----< MeasurementChangeTime-Scaledmsec >-----#
    MeasurementChangeTime_Scaledmsec = INT(name='MeasurementChangeTime-Scaledmsec', mode=MODE_TYPE)
    MeasurementChangeTime_Scaledmsec._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6000)], ev=[], er=[])
    
    #-----< ReportCharacteristicsType-ScaledMeasurementHysteresisTime >-----#
    ReportCharacteristicsType_ScaledMeasurementHysteresisTime = CHOICE(name='ReportCharacteristicsType-ScaledMeasurementHysteresisTime', mode=MODE_TYPE)
    _ReportCharacteristicsType_ScaledMeasurementHysteresisTime_msec = INT(name='msec', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MeasurementHysteresisTime-Scaledmsec')))
    ReportCharacteristicsType_ScaledMeasurementHysteresisTime._cont = ASN1Dict([
        ('msec', _ReportCharacteristicsType_ScaledMeasurementHysteresisTime_msec),
        ])
    ReportCharacteristicsType_ScaledMeasurementHysteresisTime._ext = []
    
    #-----< MeasurementHysteresisTime-Scaledmsec >-----#
    MeasurementHysteresisTime_Scaledmsec = INT(name='MeasurementHysteresisTime-Scaledmsec', mode=MODE_TYPE)
    MeasurementHysteresisTime_Scaledmsec._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6000)], ev=[], er=[])
    
    #-----< ReportCharacteristicsType-ReportPeriodicity >-----#
    ReportCharacteristicsType_ReportPeriodicity = CHOICE(name='ReportCharacteristicsType-ReportPeriodicity', mode=MODE_TYPE)
    _ReportCharacteristicsType_ReportPeriodicity_msec = INT(name='msec', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportPeriodicity-Scaledmsec')))
    _ReportCharacteristicsType_ReportPeriodicity_min = INT(name='min', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ReportPeriodicity-Scaledmin')))
    ReportCharacteristicsType_ReportPeriodicity._cont = ASN1Dict([
        ('msec', _ReportCharacteristicsType_ReportPeriodicity_msec),
        ('min', _ReportCharacteristicsType_ReportPeriodicity_min),
        ])
    ReportCharacteristicsType_ReportPeriodicity._ext = []
    
    #-----< ReportPeriodicity-Scaledmsec >-----#
    ReportPeriodicity_Scaledmsec = INT(name='ReportPeriodicity-Scaledmsec', mode=MODE_TYPE)
    ReportPeriodicity_Scaledmsec._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6000)], ev=[], er=[])
    
    #-----< ReportPeriodicity-Scaledmin >-----#
    ReportPeriodicity_Scaledmin = INT(name='ReportPeriodicity-Scaledmin', mode=MODE_TYPE)
    ReportPeriodicity_Scaledmin._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    
    #-----< ReportPeriodicity-Scaledhour >-----#
    ReportPeriodicity_Scaledhour = INT(name='ReportPeriodicity-Scaledhour', mode=MODE_TYPE)
    ReportPeriodicity_Scaledhour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=[], er=[])
    
    #-----< ResourceOperationalState >-----#
    ResourceOperationalState = ENUM(name='ResourceOperationalState', mode=MODE_TYPE)
    ResourceOperationalState._cont = ASN1Dict([('enabled', 0), ('disabled', 1)])
    ResourceOperationalState._ext = None
    
    #-----< RL-ID >-----#
    RL_ID = INT(name='RL-ID', mode=MODE_TYPE)
    RL_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< RL-Set-ID >-----#
    RL_Set_ID = INT(name='RL-Set-ID', mode=MODE_TYPE)
    RL_Set_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< RLC-Mode >-----#
    RLC_Mode = ENUM(name='RLC-Mode', mode=MODE_TYPE)
    RLC_Mode._cont = ASN1Dict([('rLC-AM', 0), ('rLC-UM', 1)])
    RLC_Mode._ext = []
    
    #-----< DL-RLC-PDU-Size-Format >-----#
    DL_RLC_PDU_Size_Format = ENUM(name='DL-RLC-PDU-Size-Format', mode=MODE_TYPE)
    DL_RLC_PDU_Size_Format._cont = ASN1Dict([('fixed-RLC-PDU-Size', 0), ('flexible-RLC-PDU-Size', 1)])
    DL_RLC_PDU_Size_Format._ext = []
    
    #-----< Round-Trip-Time-IncrDecrThres >-----#
    Round_Trip_Time_IncrDecrThres = INT(name='Round-Trip-Time-IncrDecrThres', mode=MODE_TYPE)
    Round_Trip_Time_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32766)], ev=None, er=[])
    
    #-----< RNC-ID >-----#
    RNC_ID = INT(name='RNC-ID', mode=MODE_TYPE)
    RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< Round-Trip-Time-Value >-----#
    Round_Trip_Time_Value = INT(name='Round-Trip-Time-Value', mode=MODE_TYPE)
    Round_Trip_Time_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< RSCP-Value >-----#
    RSCP_Value = INT(name='RSCP-Value', mode=MODE_TYPE)
    RSCP_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< RSCP-Value-IncrDecrThres >-----#
    RSCP_Value_IncrDecrThres = INT(name='RSCP-Value-IncrDecrThres', mode=MODE_TYPE)
    RSCP_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=126)], ev=None, er=[])
    
    #-----< Received-total-wide-band-power-For-CellPortion-Value >-----#
    Received_total_wide_band_power_For_CellPortion_Value = SEQ_OF(name='Received-total-wide-band-power-For-CellPortion-Value', mode=MODE_TYPE)
    _Received_total_wide_band_power_For_CellPortion_Value__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-For-CellPortion-Value-Item')))
    Received_total_wide_band_power_For_CellPortion_Value._cont = _Received_total_wide_band_power_For_CellPortion_Value__item_
    Received_total_wide_band_power_For_CellPortion_Value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Received-total-wide-band-power-For-CellPortion-Value-Item >-----#
    Received_total_wide_band_power_For_CellPortion_Value_Item = SEQ(name='Received-total-wide-band-power-For-CellPortion-Value-Item', mode=MODE_TYPE)
    _Received_total_wide_band_power_For_CellPortion_Value_Item_cellPortionID = INT(name='cellPortionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionID')))
    _Received_total_wide_band_power_For_CellPortion_Value_Item_received_total_wide_band_power_value = INT(name='received-total-wide-band-power-value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')))
    _Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab = ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__id_tab
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab_at = None
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab = ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab = ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__id),
        ('criticality', ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue),
        ])
    __Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item_._ext = None
    _Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions._cont = __Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item_
    _Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Received_total_wide_band_power_For_CellPortion_Value_Item._cont = ASN1Dict([
        ('cellPortionID', _Received_total_wide_band_power_For_CellPortion_Value_Item_cellPortionID),
        ('received-total-wide-band-power-value', _Received_total_wide_band_power_For_CellPortion_Value_Item_received_total_wide_band_power_value),
        ('iE-Extensions', _Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions),
        ])
    Received_total_wide_band_power_For_CellPortion_Value_Item._ext = []
    
    #-----< Received-total-wide-band-power-For-CellPortion-Value-Item-ExtIEs >-----#
    Received_total_wide_band_power_For_CellPortion_Value_Item_ExtIEs = CLASS(name='Received-total-wide-band-power-For-CellPortion-Value-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Received_total_wide_band_power_For_CellPortion_Value_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Received-total-wide-band-power-For-CellPortion-ValueLCR >-----#
    Received_total_wide_band_power_For_CellPortion_ValueLCR = SEQ_OF(name='Received-total-wide-band-power-For-CellPortion-ValueLCR', mode=MODE_TYPE)
    _Received_total_wide_band_power_For_CellPortion_ValueLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-For-CellPortion-ValueLCR-Item')))
    Received_total_wide_band_power_For_CellPortion_ValueLCR._cont = _Received_total_wide_band_power_For_CellPortion_ValueLCR__item_
    Received_total_wide_band_power_For_CellPortion_ValueLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Received-total-wide-band-power-For-CellPortion-ValueLCR-Item >-----#
    Received_total_wide_band_power_For_CellPortion_ValueLCR_Item = SEQ(name='Received-total-wide-band-power-For-CellPortion-ValueLCR-Item', mode=MODE_TYPE)
    _Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_received_total_wide_band_power_value = INT(name='received-total-wide-band-power-value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')))
    _Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id._const_tab = ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id_tab
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id._const_tab_at = None
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality._const_tab = ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality_tab
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue._const_tab = ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue_tab
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id),
        ('criticality', ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue),
        ])
    __Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item_._ext = None
    _Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions._cont = __Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item_
    _Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Received_total_wide_band_power_For_CellPortion_ValueLCR_Item._cont = ASN1Dict([
        ('cellPortionLCRID', _Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_cellPortionLCRID),
        ('received-total-wide-band-power-value', _Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_received_total_wide_band_power_value),
        ('iE-Extensions', _Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions),
        ])
    Received_total_wide_band_power_For_CellPortion_ValueLCR_Item._ext = []
    
    #-----< Received-total-wide-band-power-For-CellPortion-ValueLCR-Item-ExtIEs >-----#
    Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_ExtIEs = CLASS(name='Received-total-wide-band-power-For-CellPortion-ValueLCR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Received-total-wide-band-power-Value >-----#
    Received_total_wide_band_power_Value = INT(name='Received-total-wide-band-power-Value', mode=MODE_TYPE)
    Received_total_wide_band_power_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=621)], ev=None, er=[])
    
    #-----< Received-total-wide-band-power-Value-IncrDecrThres >-----#
    Received_total_wide_band_power_Value_IncrDecrThres = INT(name='Received-total-wide-band-power-Value-IncrDecrThres', mode=MODE_TYPE)
    Received_total_wide_band_power_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=620)], ev=None, er=[])
    
    #-----< Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value >-----#
    Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value = SEQ_OF(name='Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value', mode=MODE_TYPE)
    _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value-Item')))
    Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value._cont = _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value__item_
    Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value-Item >-----#
    Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item = SEQ(name='Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value-Item', mode=MODE_TYPE)
    _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_cellPortionID = INT(name='cellPortionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionID')))
    _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_received_Scheduled_power_share_value = INT(name='received-Scheduled-power-share-value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RSEPS-Value')))
    _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_received_total_wide_band_power_value = INT(name='received-total-wide-band-power-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')), opt=True)
    _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab = ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__id_tab
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab_at = None
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab = ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab = ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__id),
        ('criticality', ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue),
        ])
    __Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item_._ext = None
    _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions._cont = __Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item_
    _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item._cont = ASN1Dict([
        ('cellPortionID', _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_cellPortionID),
        ('received-Scheduled-power-share-value', _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_received_Scheduled_power_share_value),
        ('received-total-wide-band-power-value', _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_received_total_wide_band_power_value),
        ('iE-Extensions', _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions),
        ])
    Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item._ext = []
    
    #-----< Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value-Item-ExtIEs >-----#
    Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_ExtIEs = CLASS(name='Received-Scheduled-EDCH-Power-Share-For-CellPortion-Value-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Received-Scheduled-EDCH-Power-Share-Value >-----#
    Received_Scheduled_EDCH_Power_Share_Value = SEQ(name='Received-Scheduled-EDCH-Power-Share-Value', mode=MODE_TYPE)
    _Received_Scheduled_EDCH_Power_Share_Value_received_Scheduled_power_share_value = INT(name='received-Scheduled-power-share-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RSEPS-Value')))
    _Received_Scheduled_EDCH_Power_Share_Value_received_total_wide_band_power_value = INT(name='received-total-wide-band-power-value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')), opt=True)
    Received_Scheduled_EDCH_Power_Share_Value._cont = ASN1Dict([
        ('received-Scheduled-power-share-value', _Received_Scheduled_EDCH_Power_Share_Value_received_Scheduled_power_share_value),
        ('received-total-wide-band-power-value', _Received_Scheduled_EDCH_Power_Share_Value_received_total_wide_band_power_value),
        ])
    Received_Scheduled_EDCH_Power_Share_Value._ext = []
    
    #-----< RSEPS-Value-IncrDecrThres >-----#
    RSEPS_Value_IncrDecrThres = INT(name='RSEPS-Value-IncrDecrThres', mode=MODE_TYPE)
    RSEPS_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=151)], ev=None, er=[])
    
    #-----< RSEPS-Value >-----#
    RSEPS_Value = INT(name='RSEPS-Value', mode=MODE_TYPE)
    RSEPS_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=151)], ev=None, er=[])
    
    #-----< RequestedDataValueInformation >-----#
    RequestedDataValueInformation = CHOICE(name='RequestedDataValueInformation', mode=MODE_TYPE)
    _RequestedDataValueInformation_informationAvailable = SEQ(name='informationAvailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InformationAvailable')))
    _RequestedDataValueInformation_informationnotAvailable = NULL(name='informationnotAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InformationnotAvailable')))
    RequestedDataValueInformation._cont = ASN1Dict([
        ('informationAvailable', _RequestedDataValueInformation_informationAvailable),
        ('informationnotAvailable', _RequestedDataValueInformation_informationnotAvailable),
        ])
    RequestedDataValueInformation._ext = None
    
    #-----< InformationAvailable >-----#
    InformationAvailable = SEQ(name='InformationAvailable', mode=MODE_TYPE)
    _InformationAvailable_requesteddataValue = SEQ(name='requesteddataValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RequestedDataValue')))
    _InformationAvailable_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationAvailable_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___InformationAvailable_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationAvailable_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationAvailable_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationAvailable_ie_Extensions__item__id._const_tab = ____InformationAvailable_ie_Extensions__item__id_tab
    ___InformationAvailable_ie_Extensions__item__id._const_tab_at = None
    ___InformationAvailable_ie_Extensions__item__id._const_tab_id = 'id'
    ___InformationAvailable_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationAvailable_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationAvailable_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationAvailable_ie_Extensions__item__criticality._const_tab = ____InformationAvailable_ie_Extensions__item__criticality_tab
    ___InformationAvailable_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationAvailable_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InformationAvailable_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationAvailable_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationAvailable_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationAvailable_ie_Extensions__item__extensionValue._const_tab = ____InformationAvailable_ie_Extensions__item__extensionValue_tab
    ___InformationAvailable_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationAvailable_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationAvailable_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___InformationAvailable_ie_Extensions__item__id),
        ('criticality', ___InformationAvailable_ie_Extensions__item__criticality),
        ('extensionValue', ___InformationAvailable_ie_Extensions__item__extensionValue),
        ])
    __InformationAvailable_ie_Extensions__item_._ext = None
    _InformationAvailable_ie_Extensions._cont = __InformationAvailable_ie_Extensions__item_
    _InformationAvailable_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationAvailable._cont = ASN1Dict([
        ('requesteddataValue', _InformationAvailable_requesteddataValue),
        ('ie-Extensions', _InformationAvailable_ie_Extensions),
        ])
    InformationAvailable._ext = []
    
    #-----< InformationAvailableItem-ExtIEs >-----#
    InformationAvailableItem_ExtIEs = CLASS(name='InformationAvailableItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    InformationAvailableItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationnotAvailable >-----#
    InformationnotAvailable = NULL(name='InformationnotAvailable', mode=MODE_TYPE)
    
    #-----< RequestedDataValue >-----#
    RequestedDataValue = SEQ(name='RequestedDataValue', mode=MODE_TYPE)
    _RequestedDataValue_dgps_corrections = SEQ(name='dgps-corrections', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DGPSCorrections')), opt=True)
    _RequestedDataValue_gps_navandrecovery = SEQ_OF(name='gps-navandrecovery', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GPS-NavigationModel-and-TimeRecovery')), opt=True)
    _RequestedDataValue_gps_ionos_model = SEQ(name='gps-ionos-model', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GPS-Ionospheric-Model')), opt=True)
    _RequestedDataValue_gps_utc_model = SEQ(name='gps-utc-model', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GPS-UTC-Model')), opt=True)
    _RequestedDataValue_gps_almanac = SEQ(name='gps-almanac', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GPS-Almanac')), opt=True)
    _RequestedDataValue_gps_rt_integrity = CHOICE(name='gps-rt-integrity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GPS-RealTime-Integrity')), opt=True)
    _RequestedDataValue_gpsrxpos = SEQ(name='gpsrxpos', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GPS-RX-POS')), opt=True)
    _RequestedDataValue_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedDataValue_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RequestedDataValue_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RequestedDataValue_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Common-Data')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Generic-Data')))
    ____RequestedDataValue_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 887), ('criticality', 'ignore'), ('Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 889), ('criticality', 'ignore'), ('Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RequestedDataValue_iE_Extensions__item__id._const_tab = ____RequestedDataValue_iE_Extensions__item__id_tab
    ___RequestedDataValue_iE_Extensions__item__id._const_tab_at = None
    ___RequestedDataValue_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestedDataValue_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RequestedDataValue_iE_Extensions__item__criticality._const_tab = ____RequestedDataValue_iE_Extensions__item__id_tab
    ___RequestedDataValue_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestedDataValue_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestedDataValue_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RequestedDataValue_iE_Extensions__item__extensionValue._const_tab = ____RequestedDataValue_iE_Extensions__item__id_tab
    ___RequestedDataValue_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestedDataValue_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestedDataValue_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestedDataValue_iE_Extensions__item__id),
        ('criticality', ___RequestedDataValue_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestedDataValue_iE_Extensions__item__extensionValue),
        ])
    __RequestedDataValue_iE_Extensions__item_._ext = None
    _RequestedDataValue_iE_Extensions._cont = __RequestedDataValue_iE_Extensions__item_
    _RequestedDataValue_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedDataValue._cont = ASN1Dict([
        ('dgps-corrections', _RequestedDataValue_dgps_corrections),
        ('gps-navandrecovery', _RequestedDataValue_gps_navandrecovery),
        ('gps-ionos-model', _RequestedDataValue_gps_ionos_model),
        ('gps-utc-model', _RequestedDataValue_gps_utc_model),
        ('gps-almanac', _RequestedDataValue_gps_almanac),
        ('gps-rt-integrity', _RequestedDataValue_gps_rt_integrity),
        ('gpsrxpos', _RequestedDataValue_gpsrxpos),
        ('iE-Extensions', _RequestedDataValue_iE_Extensions),
        ])
    RequestedDataValue._ext = []
    
    #-----< RequestedDataValue-ExtIEs >-----#
    RequestedDataValue_ExtIEs = CLASS(name='RequestedDataValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RequestedDataValue_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Common-Data')))
    _RequestedDataValue_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Generic-Data')))
    RequestedDataValue_ExtIEs._val = ASN1Set(rv=[dict([('id', 887), ('criticality', 'ignore'), ('Extension', _RequestedDataValue_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 889), ('criticality', 'ignore'), ('Extension', _RequestedDataValue_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Rx-Timing-Deviation-Value >-----#
    Rx_Timing_Deviation_Value = INT(name='Rx-Timing-Deviation-Value', mode=MODE_TYPE)
    Rx_Timing_Deviation_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< Rx-Timing-Deviation-Value-LCR >-----#
    Rx_Timing_Deviation_Value_LCR = INT(name='Rx-Timing-Deviation-Value-LCR', mode=MODE_TYPE)
    Rx_Timing_Deviation_Value_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< Rx-Timing-Deviation-Value-768 >-----#
    Rx_Timing_Deviation_Value_768 = INT(name='Rx-Timing-Deviation-Value-768', mode=MODE_TYPE)
    Rx_Timing_Deviation_Value_768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< Rx-Timing-Deviation-Value-384-ext >-----#
    Rx_Timing_Deviation_Value_384_ext = INT(name='Rx-Timing-Deviation-Value-384-ext', mode=MODE_TYPE)
    Rx_Timing_Deviation_Value_384_ext._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< RefBeta >-----#
    RefBeta = INT(name='RefBeta', mode=MODE_TYPE)
    RefBeta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-15, ub=16)], ev=None, er=[])
    
    #-----< RTWP-ReportingIndicator >-----#
    RTWP_ReportingIndicator = ENUM(name='RTWP-ReportingIndicator', mode=MODE_TYPE)
    RTWP_ReportingIndicator._cont = ASN1Dict([('rTWP-reporting-required', 0)])
    RTWP_ReportingIndicator._ext = None
    
    #-----< RTWP-CellPortion-ReportingIndicator >-----#
    RTWP_CellPortion_ReportingIndicator = ENUM(name='RTWP-CellPortion-ReportingIndicator', mode=MODE_TYPE)
    RTWP_CellPortion_ReportingIndicator._cont = ASN1Dict([('rTWP-CellPortion-reporting-required', 0)])
    RTWP_CellPortion_ReportingIndicator._ext = None
    
    #-----< AdjustmentPeriod >-----#
    AdjustmentPeriod = INT(name='AdjustmentPeriod', mode=MODE_TYPE)
    AdjustmentPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-DPCCH-Power-Boosting-Capability >-----#
    E_DPCCH_Power_Boosting_Capability = ENUM(name='E-DPCCH-Power-Boosting-Capability', mode=MODE_TYPE)
    E_DPCCH_Power_Boosting_Capability._cont = ASN1Dict([('e-DPCCH-Power-Boosting-capable', 0), ('e-DPCCH-Power-Boosting-non-capable', 1)])
    E_DPCCH_Power_Boosting_Capability._ext = None
    
    #-----< SAT-ID >-----#
    SAT_ID = INT(name='SAT-ID', mode=MODE_TYPE)
    SAT_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SAT-Info-Almanac >-----#
    SAT_Info_Almanac = SEQ_OF(name='SAT-Info-Almanac', mode=MODE_TYPE)
    _SAT_Info_Almanac__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SAT-Info-Almanac-Item')))
    SAT_Info_Almanac._cont = _SAT_Info_Almanac__item_
    SAT_Info_Almanac._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SAT-Info-Almanac-Item >-----#
    SAT_Info_Almanac_Item = SEQ(name='SAT-Info-Almanac-Item', mode=MODE_TYPE)
    _SAT_Info_Almanac_Item_data_id = INT(name='data-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DATA-ID')))
    _SAT_Info_Almanac_Item_sat_id = INT(name='sat-id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SAT-ID')))
    _SAT_Info_Almanac_Item_gps_e_alm = BIT_STR(name='gps-e-alm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_Item_gps_e_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_Item_gps_toa_alm = BIT_STR(name='gps-toa-alm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_Item_gps_toa_alm._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_Item_gps_delta_I_alm = BIT_STR(name='gps-delta-I-alm', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_Item_gps_delta_I_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_Item_omegadot_alm = BIT_STR(name='omegadot-alm', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_Item_omegadot_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_Item_svhealth_alm = BIT_STR(name='svhealth-alm', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_Item_svhealth_alm._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_Item_gps_a_sqrt_alm = BIT_STR(name='gps-a-sqrt-alm', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_Item_gps_a_sqrt_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_Item_omegazero_alm = BIT_STR(name='omegazero-alm', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_Item_omegazero_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_Item_m_zero_alm = BIT_STR(name='m-zero-alm', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_Item_m_zero_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_Item_gps_omega_alm = BIT_STR(name='gps-omega-alm', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_Item_gps_omega_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_Item_gps_af_zero_alm = BIT_STR(name='gps-af-zero-alm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_Item_gps_af_zero_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_Item_gps_af_one_alm = BIT_STR(name='gps-af-one-alm', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_Item_gps_af_one_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_Item_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SAT_Info_Almanac_Item_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SAT_Info_Almanac_Item_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SAT_Info_Almanac_Item_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SAT_Info_Almanac_Item_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAT_Info_Almanac_Item_ie_Extensions__item__id._const_tab = ____SAT_Info_Almanac_Item_ie_Extensions__item__id_tab
    ___SAT_Info_Almanac_Item_ie_Extensions__item__id._const_tab_at = None
    ___SAT_Info_Almanac_Item_ie_Extensions__item__id._const_tab_id = 'id'
    ___SAT_Info_Almanac_Item_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SAT_Info_Almanac_Item_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SAT_Info_Almanac_Item_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAT_Info_Almanac_Item_ie_Extensions__item__criticality._const_tab = ____SAT_Info_Almanac_Item_ie_Extensions__item__criticality_tab
    ___SAT_Info_Almanac_Item_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SAT_Info_Almanac_Item_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SAT_Info_Almanac_Item_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SAT_Info_Almanac_Item_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SAT_Info_Almanac_Item_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAT_Info_Almanac_Item_ie_Extensions__item__extensionValue._const_tab = ____SAT_Info_Almanac_Item_ie_Extensions__item__extensionValue_tab
    ___SAT_Info_Almanac_Item_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SAT_Info_Almanac_Item_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SAT_Info_Almanac_Item_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___SAT_Info_Almanac_Item_ie_Extensions__item__id),
        ('criticality', ___SAT_Info_Almanac_Item_ie_Extensions__item__criticality),
        ('extensionValue', ___SAT_Info_Almanac_Item_ie_Extensions__item__extensionValue),
        ])
    __SAT_Info_Almanac_Item_ie_Extensions__item_._ext = None
    _SAT_Info_Almanac_Item_ie_Extensions._cont = __SAT_Info_Almanac_Item_ie_Extensions__item_
    _SAT_Info_Almanac_Item_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SAT_Info_Almanac_Item._cont = ASN1Dict([
        ('data-id', _SAT_Info_Almanac_Item_data_id),
        ('sat-id', _SAT_Info_Almanac_Item_sat_id),
        ('gps-e-alm', _SAT_Info_Almanac_Item_gps_e_alm),
        ('gps-toa-alm', _SAT_Info_Almanac_Item_gps_toa_alm),
        ('gps-delta-I-alm', _SAT_Info_Almanac_Item_gps_delta_I_alm),
        ('omegadot-alm', _SAT_Info_Almanac_Item_omegadot_alm),
        ('svhealth-alm', _SAT_Info_Almanac_Item_svhealth_alm),
        ('gps-a-sqrt-alm', _SAT_Info_Almanac_Item_gps_a_sqrt_alm),
        ('omegazero-alm', _SAT_Info_Almanac_Item_omegazero_alm),
        ('m-zero-alm', _SAT_Info_Almanac_Item_m_zero_alm),
        ('gps-omega-alm', _SAT_Info_Almanac_Item_gps_omega_alm),
        ('gps-af-zero-alm', _SAT_Info_Almanac_Item_gps_af_zero_alm),
        ('gps-af-one-alm', _SAT_Info_Almanac_Item_gps_af_one_alm),
        ('ie-Extensions', _SAT_Info_Almanac_Item_ie_Extensions),
        ])
    SAT_Info_Almanac_Item._ext = []
    
    #-----< SAT-Info-Almanac-Item-ExtIEs >-----#
    SAT_Info_Almanac_Item_ExtIEs = CLASS(name='SAT-Info-Almanac-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SAT_Info_Almanac_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SAT-Info-Almanac-ExtList >-----#
    SAT_Info_Almanac_ExtList = SEQ_OF(name='SAT-Info-Almanac-ExtList', mode=MODE_TYPE)
    _SAT_Info_Almanac_ExtList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SAT-Info-Almanac-ExtItem')))
    SAT_Info_Almanac_ExtList._cont = _SAT_Info_Almanac_ExtList__item_
    SAT_Info_Almanac_ExtList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SAT-Info-Almanac-ExtItem >-----#
    SAT_Info_Almanac_ExtItem = SEQ(name='SAT-Info-Almanac-ExtItem', mode=MODE_TYPE)
    _SAT_Info_Almanac_ExtItem_data_id = INT(name='data-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DATA-ID')))
    _SAT_Info_Almanac_ExtItem_sat_id = INT(name='sat-id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SAT-ID')))
    _SAT_Info_Almanac_ExtItem_gps_e_alm = BIT_STR(name='gps-e-alm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_ExtItem_gps_e_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_ExtItem_gps_toa_alm = BIT_STR(name='gps-toa-alm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_ExtItem_gps_toa_alm._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_ExtItem_gps_delta_I_alm = BIT_STR(name='gps-delta-I-alm', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_ExtItem_gps_delta_I_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_ExtItem_omegadot_alm = BIT_STR(name='omegadot-alm', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_ExtItem_omegadot_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_ExtItem_svhealth_alm = BIT_STR(name='svhealth-alm', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_ExtItem_svhealth_alm._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_ExtItem_gps_a_sqrt_alm = BIT_STR(name='gps-a-sqrt-alm', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_ExtItem_gps_a_sqrt_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_ExtItem_omegazero_alm = BIT_STR(name='omegazero-alm', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_ExtItem_omegazero_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_ExtItem_m_zero_alm = BIT_STR(name='m-zero-alm', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_ExtItem_m_zero_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_ExtItem_gps_omega_alm = BIT_STR(name='gps-omega-alm', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_ExtItem_gps_omega_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_ExtItem_gps_af_zero_alm = BIT_STR(name='gps-af-zero-alm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_ExtItem_gps_af_zero_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_ExtItem_gps_af_one_alm = BIT_STR(name='gps-af-one-alm', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_Almanac_ExtItem_gps_af_one_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _SAT_Info_Almanac_ExtItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SAT_Info_Almanac_ExtItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__id._const_tab = ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__id_tab
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__id._const_tab_at = None
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__criticality._const_tab = ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__criticality_tab
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__extensionValue._const_tab = ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__extensionValue_tab
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SAT_Info_Almanac_ExtItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__id),
        ('criticality', ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__criticality),
        ('extensionValue', ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__extensionValue),
        ])
    __SAT_Info_Almanac_ExtItem_ie_Extensions__item_._ext = None
    _SAT_Info_Almanac_ExtItem_ie_Extensions._cont = __SAT_Info_Almanac_ExtItem_ie_Extensions__item_
    _SAT_Info_Almanac_ExtItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SAT_Info_Almanac_ExtItem._cont = ASN1Dict([
        ('data-id', _SAT_Info_Almanac_ExtItem_data_id),
        ('sat-id', _SAT_Info_Almanac_ExtItem_sat_id),
        ('gps-e-alm', _SAT_Info_Almanac_ExtItem_gps_e_alm),
        ('gps-toa-alm', _SAT_Info_Almanac_ExtItem_gps_toa_alm),
        ('gps-delta-I-alm', _SAT_Info_Almanac_ExtItem_gps_delta_I_alm),
        ('omegadot-alm', _SAT_Info_Almanac_ExtItem_omegadot_alm),
        ('svhealth-alm', _SAT_Info_Almanac_ExtItem_svhealth_alm),
        ('gps-a-sqrt-alm', _SAT_Info_Almanac_ExtItem_gps_a_sqrt_alm),
        ('omegazero-alm', _SAT_Info_Almanac_ExtItem_omegazero_alm),
        ('m-zero-alm', _SAT_Info_Almanac_ExtItem_m_zero_alm),
        ('gps-omega-alm', _SAT_Info_Almanac_ExtItem_gps_omega_alm),
        ('gps-af-zero-alm', _SAT_Info_Almanac_ExtItem_gps_af_zero_alm),
        ('gps-af-one-alm', _SAT_Info_Almanac_ExtItem_gps_af_one_alm),
        ('ie-Extensions', _SAT_Info_Almanac_ExtItem_ie_Extensions),
        ])
    SAT_Info_Almanac_ExtItem._ext = []
    
    #-----< SAT-Info-Almanac-ExtItemIEs >-----#
    SAT_Info_Almanac_ExtItemIEs = CLASS(name='SAT-Info-Almanac-ExtItemIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SAT_Info_Almanac_ExtItemIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SAT-Info-DGPSCorrections >-----#
    SAT_Info_DGPSCorrections = SEQ_OF(name='SAT-Info-DGPSCorrections', mode=MODE_TYPE)
    _SAT_Info_DGPSCorrections__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SAT-Info-DGPSCorrections-Item')))
    SAT_Info_DGPSCorrections._cont = _SAT_Info_DGPSCorrections__item_
    SAT_Info_DGPSCorrections._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SAT-Info-DGPSCorrections-Item >-----#
    SAT_Info_DGPSCorrections_Item = SEQ(name='SAT-Info-DGPSCorrections-Item', mode=MODE_TYPE)
    _SAT_Info_DGPSCorrections_Item_sat_id = INT(name='sat-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SAT-ID')))
    _SAT_Info_DGPSCorrections_Item_iode_dgps = BIT_STR(name='iode-dgps', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SAT_Info_DGPSCorrections_Item_iode_dgps._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SAT_Info_DGPSCorrections_Item_udre = ENUM(name='udre', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UDRE')))
    _SAT_Info_DGPSCorrections_Item_prc = INT(name='prc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PRC')))
    _SAT_Info_DGPSCorrections_Item_range_correction_rate = INT(name='range-correction-rate', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Range-Correction-Rate')))
    _SAT_Info_DGPSCorrections_Item_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SAT_Info_DGPSCorrections_Item_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DGNSS-ValidityPeriod')))
    ____SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1169), ('criticality', 'ignore'), ('Extension', _____SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id._const_tab = ____SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id_tab
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id._const_tab_at = None
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id._const_tab_id = 'id'
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__criticality._const_tab = ____SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id_tab
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__extensionValue._const_tab = ____SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id_tab
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SAT_Info_DGPSCorrections_Item_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id),
        ('criticality', ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__criticality),
        ('extensionValue', ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__extensionValue),
        ])
    __SAT_Info_DGPSCorrections_Item_ie_Extensions__item_._ext = None
    _SAT_Info_DGPSCorrections_Item_ie_Extensions._cont = __SAT_Info_DGPSCorrections_Item_ie_Extensions__item_
    _SAT_Info_DGPSCorrections_Item_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SAT_Info_DGPSCorrections_Item._cont = ASN1Dict([
        ('sat-id', _SAT_Info_DGPSCorrections_Item_sat_id),
        ('iode-dgps', _SAT_Info_DGPSCorrections_Item_iode_dgps),
        ('udre', _SAT_Info_DGPSCorrections_Item_udre),
        ('prc', _SAT_Info_DGPSCorrections_Item_prc),
        ('range-correction-rate', _SAT_Info_DGPSCorrections_Item_range_correction_rate),
        ('ie-Extensions', _SAT_Info_DGPSCorrections_Item_ie_Extensions),
        ])
    SAT_Info_DGPSCorrections_Item._ext = []
    
    #-----< SAT-Info-DGPSCorrections-Item-ExtIEs >-----#
    SAT_Info_DGPSCorrections_Item_ExtIEs = CLASS(name='SAT-Info-DGPSCorrections-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _SAT_Info_DGPSCorrections_Item_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DGNSS-ValidityPeriod')))
    SAT_Info_DGPSCorrections_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 1169), ('criticality', 'ignore'), ('Extension', _SAT_Info_DGPSCorrections_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SATInfo-RealTime-Integrity >-----#
    SATInfo_RealTime_Integrity = SEQ_OF(name='SATInfo-RealTime-Integrity', mode=MODE_TYPE)
    _SATInfo_RealTime_Integrity__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SAT-Info-RealTime-Integrity-Item')))
    SATInfo_RealTime_Integrity._cont = _SATInfo_RealTime_Integrity__item_
    SATInfo_RealTime_Integrity._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SAT-Info-RealTime-Integrity-Item >-----#
    SAT_Info_RealTime_Integrity_Item = SEQ(name='SAT-Info-RealTime-Integrity-Item', mode=MODE_TYPE)
    _SAT_Info_RealTime_Integrity_Item_bad_sat_id = INT(name='bad-sat-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SAT-ID')))
    _SAT_Info_RealTime_Integrity_Item_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SAT_Info_RealTime_Integrity_Item_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__id._const_tab = ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__id_tab
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__id._const_tab_at = None
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__id._const_tab_id = 'id'
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__criticality._const_tab = ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__criticality_tab
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__extensionValue._const_tab = ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__extensionValue_tab
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SAT_Info_RealTime_Integrity_Item_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__id),
        ('criticality', ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__criticality),
        ('extensionValue', ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__extensionValue),
        ])
    __SAT_Info_RealTime_Integrity_Item_ie_Extensions__item_._ext = None
    _SAT_Info_RealTime_Integrity_Item_ie_Extensions._cont = __SAT_Info_RealTime_Integrity_Item_ie_Extensions__item_
    _SAT_Info_RealTime_Integrity_Item_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SAT_Info_RealTime_Integrity_Item._cont = ASN1Dict([
        ('bad-sat-id', _SAT_Info_RealTime_Integrity_Item_bad_sat_id),
        ('ie-Extensions', _SAT_Info_RealTime_Integrity_Item_ie_Extensions),
        ])
    SAT_Info_RealTime_Integrity_Item._ext = []
    
    #-----< SAT-Info-RealTime-Integrity-Item-ExtIEs >-----#
    SAT_Info_RealTime_Integrity_Item_ExtIEs = CLASS(name='SAT-Info-RealTime-Integrity-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SAT_Info_RealTime_Integrity_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ScaledAdjustmentRatio >-----#
    ScaledAdjustmentRatio = INT(name='ScaledAdjustmentRatio', mode=MODE_TYPE)
    ScaledAdjustmentRatio._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< MaxAdjustmentStep >-----#
    MaxAdjustmentStep = INT(name='MaxAdjustmentStep', mode=MODE_TYPE)
    MaxAdjustmentStep._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< SchedulingInformation >-----#
    SchedulingInformation = ENUM(name='SchedulingInformation', mode=MODE_TYPE)
    SchedulingInformation._cont = ASN1Dict([('included', 0), ('not-included', 1)])
    SchedulingInformation._ext = None
    
    #-----< SecondaryServingCells >-----#
    SecondaryServingCells = SEQ_OF(name='SecondaryServingCells', mode=MODE_TYPE)
    _SecondaryServingCells__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SecondaryServingCellsItem')))
    SecondaryServingCells._cont = _SecondaryServingCells__item_
    SecondaryServingCells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SecondaryServingCellsItem >-----#
    SecondaryServingCellsItem = SEQ(name='SecondaryServingCellsItem', mode=MODE_TYPE)
    _SecondaryServingCellsItem_secondaryC_ID = INT(name='secondaryC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _SecondaryServingCellsItem_numSecondaryHS_SCCH_Codes = INT(name='numSecondaryHS-SCCH-Codes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'NumHS-SCCH-Codes')), opt=True)
    _SecondaryServingCellsItem_sixtyfourQAM_UsageAllowedIndicator = ENUM(name='sixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')), opt=True)
    _SecondaryServingCellsItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryServingCellsItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryServingCellsItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecondaryServingCellsItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-ActivationIndicator')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE)
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'OrdinalNumberOfFrequency')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_3 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_4 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    ____SecondaryServingCellsItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 905), ('criticality', 'ignore'), ('Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1129), ('criticality', 'ignore'), ('Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1181), ('criticality', 'ignore'), ('Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1226), ('criticality', 'ignore'), ('Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1229), ('criticality', 'ignore'), ('Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1239), ('criticality', 'ignore'), ('Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SecondaryServingCellsItem_iE_Extensions__item__id._const_tab = ____SecondaryServingCellsItem_iE_Extensions__item__id_tab
    ___SecondaryServingCellsItem_iE_Extensions__item__id._const_tab_at = None
    ___SecondaryServingCellsItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecondaryServingCellsItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SecondaryServingCellsItem_iE_Extensions__item__criticality._const_tab = ____SecondaryServingCellsItem_iE_Extensions__item__id_tab
    ___SecondaryServingCellsItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryServingCellsItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue._const_tab = ____SecondaryServingCellsItem_iE_Extensions__item__id_tab
    ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecondaryServingCellsItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecondaryServingCellsItem_iE_Extensions__item__id),
        ('criticality', ___SecondaryServingCellsItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue),
        ])
    __SecondaryServingCellsItem_iE_Extensions__item_._ext = None
    _SecondaryServingCellsItem_iE_Extensions._cont = __SecondaryServingCellsItem_iE_Extensions__item_
    _SecondaryServingCellsItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryServingCellsItem._cont = ASN1Dict([
        ('secondaryC-ID', _SecondaryServingCellsItem_secondaryC_ID),
        ('numSecondaryHS-SCCH-Codes', _SecondaryServingCellsItem_numSecondaryHS_SCCH_Codes),
        ('sixtyfourQAM-UsageAllowedIndicator', _SecondaryServingCellsItem_sixtyfourQAM_UsageAllowedIndicator),
        ('iE-Extensions', _SecondaryServingCellsItem_iE_Extensions),
        ])
    SecondaryServingCellsItem._ext = []
    
    #-----< SecondaryServingCellsItem-ExtIEs >-----#
    SecondaryServingCellsItem_ExtIEs = CLASS(name='SecondaryServingCellsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-ActivationIndicator')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE)
    _SecondaryServingCellsItem_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'OrdinalNumberOfFrequency')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_3 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_4 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    SecondaryServingCellsItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 905), ('criticality', 'ignore'), ('Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1129), ('criticality', 'ignore'), ('Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1181), ('criticality', 'ignore'), ('Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1226), ('criticality', 'ignore'), ('Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1229), ('criticality', 'ignore'), ('Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1239), ('criticality', 'ignore'), ('Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Secondary-UL-Frequency-Activation-State >-----#
    Secondary_UL_Frequency_Activation_State = ENUM(name='Secondary-UL-Frequency-Activation-State', mode=MODE_TYPE)
    Secondary_UL_Frequency_Activation_State._cont = ASN1Dict([('activated', 0), ('deactivated', 1)])
    Secondary_UL_Frequency_Activation_State._ext = []
    
    #-----< SchedulingPriorityIndicator >-----#
    SchedulingPriorityIndicator = INT(name='SchedulingPriorityIndicator', mode=MODE_TYPE)
    SchedulingPriorityIndicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< SID >-----#
    SID = INT(name='SID', mode=MODE_TYPE)
    SID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< ScramblingCodeNumber >-----#
    ScramblingCodeNumber = INT(name='ScramblingCodeNumber', mode=MODE_TYPE)
    ScramblingCodeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< Secondary-CPICH-Information-Change >-----#
    Secondary_CPICH_Information_Change = CHOICE(name='Secondary-CPICH-Information-Change', mode=MODE_TYPE)
    _Secondary_CPICH_Information_Change_new_secondary_CPICH = INT(name='new-secondary-CPICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _Secondary_CPICH_Information_Change_secondary_CPICH_shall_not_be_used = NULL(name='secondary-CPICH-shall-not-be-used', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Secondary_CPICH_Information_Change._cont = ASN1Dict([
        ('new-secondary-CPICH', _Secondary_CPICH_Information_Change_new_secondary_CPICH),
        ('secondary-CPICH-shall-not-be-used', _Secondary_CPICH_Information_Change_secondary_CPICH_shall_not_be_used),
        ])
    Secondary_CPICH_Information_Change._ext = []
    
    #-----< SecondaryCCPCH-SlotFormat >-----#
    SecondaryCCPCH_SlotFormat = INT(name='SecondaryCCPCH-SlotFormat', mode=MODE_TYPE)
    SecondaryCCPCH_SlotFormat._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=17)], ev=[], er=[])
    
    #-----< Secondary-CCPCH-SlotFormat-Extended >-----#
    Secondary_CCPCH_SlotFormat_Extended = INT(name='Secondary-CCPCH-SlotFormat-Extended', mode=MODE_TYPE)
    Secondary_CCPCH_SlotFormat_Extended._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=18, ub=23)], ev=[], er=[])
    
    #-----< Segment-Type >-----#
    Segment_Type = ENUM(name='Segment-Type', mode=MODE_TYPE)
    Segment_Type._cont = ASN1Dict([('first-segment', 0), ('first-segment-short', 1), ('subsequent-segment', 2), ('last-segment', 3), ('last-segment-short', 4), ('complete-SIB', 5), ('complete-SIB-short', 6)])
    Segment_Type._ext = []
    
    #-----< Serving-E-DCH-RL-ID >-----#
    Serving_E_DCH_RL_ID = CHOICE(name='Serving-E-DCH-RL-ID', mode=MODE_TYPE)
    _Serving_E_DCH_RL_ID_serving_E_DCH_RL_in_this_NodeB = SEQ(name='serving-E-DCH-RL-in-this-NodeB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Serving-E-DCH-RL-in-this-NodeB')))
    _Serving_E_DCH_RL_ID_serving_E_DCH_RL_not_in_this_NodeB = NULL(name='serving-E-DCH-RL-not-in-this-NodeB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Serving_E_DCH_RL_ID._cont = ASN1Dict([
        ('serving-E-DCH-RL-in-this-NodeB', _Serving_E_DCH_RL_ID_serving_E_DCH_RL_in_this_NodeB),
        ('serving-E-DCH-RL-not-in-this-NodeB', _Serving_E_DCH_RL_ID_serving_E_DCH_RL_not_in_this_NodeB),
        ])
    Serving_E_DCH_RL_ID._ext = []
    
    #-----< Serving-E-DCH-RL-in-this-NodeB >-----#
    Serving_E_DCH_RL_in_this_NodeB = SEQ(name='Serving-E-DCH-RL-in-this-NodeB', mode=MODE_TYPE)
    _Serving_E_DCH_RL_in_this_NodeB_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Serving_E_DCH_RL_in_this_NodeB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__id._const_tab = ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__id_tab
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__id._const_tab_at = None
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__id._const_tab_id = 'id'
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__criticality._const_tab = ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__criticality_tab
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__extensionValue._const_tab = ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__extensionValue_tab
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__id),
        ('criticality', ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__criticality),
        ('extensionValue', ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__extensionValue),
        ])
    __Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item_._ext = None
    _Serving_E_DCH_RL_in_this_NodeB_iE_Extensions._cont = __Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item_
    _Serving_E_DCH_RL_in_this_NodeB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Serving_E_DCH_RL_in_this_NodeB._cont = ASN1Dict([
        ('rL-ID', _Serving_E_DCH_RL_in_this_NodeB_rL_ID),
        ('iE-Extensions', _Serving_E_DCH_RL_in_this_NodeB_iE_Extensions),
        ])
    Serving_E_DCH_RL_in_this_NodeB._ext = []
    
    #-----< Serving-E-DCH-RL-in-this-NodeB-ExtIEs >-----#
    Serving_E_DCH_RL_in_this_NodeB_ExtIEs = CLASS(name='Serving-E-DCH-RL-in-this-NodeB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Serving_E_DCH_RL_in_this_NodeB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SetsOfHS-SCCH-Codes >-----#
    SetsOfHS_SCCH_Codes = SEQ_OF(name='SetsOfHS-SCCH-Codes', mode=MODE_TYPE)
    _SetsOfHS_SCCH_Codes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SetsOfHS-SCCH-CodesItem')))
    SetsOfHS_SCCH_Codes._cont = _SetsOfHS_SCCH_Codes__item_
    SetsOfHS_SCCH_Codes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=33)], ev=None, er=[])
    
    #-----< SetsOfHS-SCCH-CodesItem >-----#
    SetsOfHS_SCCH_CodesItem = SEQ(name='SetsOfHS-SCCH-CodesItem', mode=MODE_TYPE)
    _SetsOfHS_SCCH_CodesItem_hS_SCCH_PreconfiguredCodes = SEQ_OF(name='hS-SCCH-PreconfiguredCodes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-PreconfiguredCodes')))
    _SetsOfHS_SCCH_CodesItem_sixtyfourQAM_DL_UsageIndicator = ENUM(name='sixtyfourQAM-DL-UsageIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-UsageIndicator')), opt=True)
    _SetsOfHS_SCCH_CodesItem_hSDSCH_TBSizeTableIndicator = ENUM(name='hSDSCH-TBSizeTableIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TBSizeTableIndicator')), opt=True)
    _SetsOfHS_SCCH_CodesItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SetsOfHS_SCCH_CodesItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-N-M-Ratio')))
    ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 907), ('criticality', 'ignore'), ('Extension', _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id._const_tab = ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id._const_tab_at = None
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality._const_tab = ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue._const_tab = ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SetsOfHS_SCCH_CodesItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id),
        ('criticality', ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue),
        ])
    __SetsOfHS_SCCH_CodesItem_iE_Extensions__item_._ext = None
    _SetsOfHS_SCCH_CodesItem_iE_Extensions._cont = __SetsOfHS_SCCH_CodesItem_iE_Extensions__item_
    _SetsOfHS_SCCH_CodesItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SetsOfHS_SCCH_CodesItem._cont = ASN1Dict([
        ('hS-SCCH-PreconfiguredCodes', _SetsOfHS_SCCH_CodesItem_hS_SCCH_PreconfiguredCodes),
        ('sixtyfourQAM-DL-UsageIndicator', _SetsOfHS_SCCH_CodesItem_sixtyfourQAM_DL_UsageIndicator),
        ('hSDSCH-TBSizeTableIndicator', _SetsOfHS_SCCH_CodesItem_hSDSCH_TBSizeTableIndicator),
        ('iE-Extensions', _SetsOfHS_SCCH_CodesItem_iE_Extensions),
        ])
    SetsOfHS_SCCH_CodesItem._ext = []
    
    #-----< SetsOfHS-SCCH-CodesItem-ExtIEs >-----#
    SetsOfHS_SCCH_CodesItem_ExtIEs = CLASS(name='SetsOfHS-SCCH-CodesItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-N-M-Ratio')))
    SetsOfHS_SCCH_CodesItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 907), ('criticality', 'ignore'), ('Extension', _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency = CHOICE(name='Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_setup = SEQ(name='setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Setup-Info')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_configurationChange = SEQ_OF(name='configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-ConfigurationChange-List')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_removal = SEQ_OF(name='removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Removal-List')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency._cont = ASN1Dict([
        ('setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_setup),
        ('configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_configurationChange),
        ('removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency._ext = []
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements = CHOICE(name='Setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_setup = SEQ(name='setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Downlink-TPC-enhancements-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_configurationChange = SEQ(name='configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Downlink-TPC-enhancements-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_removal = ENUM(name='removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Downlink-TPC-enhancements-Information-Removal')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements._cont = ASN1Dict([
        ('setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_setup),
        ('configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_configurationChange),
        ('removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements._ext = []
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD = CHOICE(name='Setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_setup = SEQ(name='setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_configurationChange = SEQ(name='configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information-To-Modify')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_removal = ENUM(name='removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information-Removal')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD._cont = ASN1Dict([
        ('setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_setup),
        ('configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_configurationChange),
        ('removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD._ext = []
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2 >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2 = CHOICE(name='Setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_setup = SEQ(name='setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH2-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_configurationChange = SEQ(name='configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH2-Information-To-Modify')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_removal = ENUM(name='removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH2-Information-Removal')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2._cont = ASN1Dict([
        ('setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_setup),
        ('configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_configurationChange),
        ('removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2._ext = []
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information = CHOICE(name='Setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_setup = SEQ(name='setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_configurationChange = SEQ(name='configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information-To-Modify')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_removal = ENUM(name='removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information-Removal')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information._cont = ASN1Dict([
        ('setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_setup),
        ('configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_configurationChange),
        ('removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information._ext = []
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH = CHOICE(name='Setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_setup = SEQ(name='setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ENH-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_configurationChange = SEQ(name='configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ENH-Information-to-Modify')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_removal = ENUM(name='removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ENH-Information-Removal')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH._cont = ASN1Dict([
        ('setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_setup),
        ('configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_configurationChange),
        ('removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH._ext = []
    
    #-----< SFN >-----#
    SFN = INT(name='SFN', mode=MODE_TYPE)
    SFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< SFNSFN-FDD >-----#
    SFNSFN_FDD = INT(name='SFNSFN-FDD', mode=MODE_TYPE)
    SFNSFN_FDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=614399)], ev=None, er=[])
    
    #-----< SFNSFN-TDD >-----#
    SFNSFN_TDD = INT(name='SFNSFN-TDD', mode=MODE_TYPE)
    SFNSFN_TDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40961)], ev=None, er=[])
    
    #-----< SFNSFN-TDD768 >-----#
    SFNSFN_TDD768 = INT(name='SFNSFN-TDD768', mode=MODE_TYPE)
    SFNSFN_TDD768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81923)], ev=None, er=[])
    
    #-----< SFNSFNChangeLimit >-----#
    SFNSFNChangeLimit = INT(name='SFNSFNChangeLimit', mode=MODE_TYPE)
    SFNSFNChangeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SFNSFNDriftRate >-----#
    SFNSFNDriftRate = INT(name='SFNSFNDriftRate', mode=MODE_TYPE)
    SFNSFNDriftRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-100, ub=100)], ev=None, er=[])
    
    #-----< SFNSFNDriftRateQuality >-----#
    SFNSFNDriftRateQuality = INT(name='SFNSFNDriftRateQuality', mode=MODE_TYPE)
    SFNSFNDriftRateQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< SFNSFNMeasurementThresholdInformation >-----#
    SFNSFNMeasurementThresholdInformation = SEQ(name='SFNSFNMeasurementThresholdInformation', mode=MODE_TYPE)
    _SFNSFNMeasurementThresholdInformation_sFNSFNChangeLimit = INT(name='sFNSFNChangeLimit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFNSFNChangeLimit')), opt=True)
    _SFNSFNMeasurementThresholdInformation_predictedSFNSFNDeviationLimit = INT(name='predictedSFNSFNDeviationLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PredictedSFNSFNDeviationLimit')), opt=True)
    _SFNSFNMeasurementThresholdInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SFNSFNMeasurementThresholdInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id._const_tab = ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id_tab
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id._const_tab_at = None
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab = ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality_tab
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab = ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SFNSFNMeasurementThresholdInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id),
        ('criticality', ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue),
        ])
    __SFNSFNMeasurementThresholdInformation_iE_Extensions__item_._ext = None
    _SFNSFNMeasurementThresholdInformation_iE_Extensions._cont = __SFNSFNMeasurementThresholdInformation_iE_Extensions__item_
    _SFNSFNMeasurementThresholdInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SFNSFNMeasurementThresholdInformation._cont = ASN1Dict([
        ('sFNSFNChangeLimit', _SFNSFNMeasurementThresholdInformation_sFNSFNChangeLimit),
        ('predictedSFNSFNDeviationLimit', _SFNSFNMeasurementThresholdInformation_predictedSFNSFNDeviationLimit),
        ('iE-Extensions', _SFNSFNMeasurementThresholdInformation_iE_Extensions),
        ])
    SFNSFNMeasurementThresholdInformation._ext = []
    
    #-----< SFNSFNMeasurementThresholdInformation-ExtIEs >-----#
    SFNSFNMeasurementThresholdInformation_ExtIEs = CLASS(name='SFNSFNMeasurementThresholdInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SFNSFNMeasurementThresholdInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SFNSFNMeasurementValueInformation >-----#
    SFNSFNMeasurementValueInformation = SEQ(name='SFNSFNMeasurementValueInformation', mode=MODE_TYPE)
    _SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation = SEQ_OF(name='successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_Id = SEQ(name='uC-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UC-Id')))
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNValue = CHOICE(name='sFNSFNValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFNSFNValue')))
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNQuality = INT(name='sFNSFNQuality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFNSFNQuality')), opt=True)
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRate = INT(name='sFNSFNDriftRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFNSFNDriftRate')))
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRateQuality = INT(name='sFNSFNDriftRateQuality', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFNSFNDriftRateQuality')), opt=True)
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNTimeStampInformation = CHOICE(name='sFNSFNTimeStampInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFNSFNTimeStampInformation')))
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab = ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab_at = None
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab_id = 'id'
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab = ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab = ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id),
        ('criticality', _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality),
        ('extensionValue', _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue),
        ])
    ____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_._ext = None
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions._cont = ____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_._cont = ASN1Dict([
        ('uC-Id', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_Id),
        ('sFNSFNValue', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNValue),
        ('sFNSFNQuality', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNQuality),
        ('sFNSFNDriftRate', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRate),
        ('sFNSFNDriftRateQuality', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRateQuality),
        ('sFNSFNTimeStampInformation', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNTimeStampInformation),
        ('iE-Extensions', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions),
        ])
    __SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_._ext = []
    _SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation._cont = __SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_
    _SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=96)], ev=None, er=[])
    _SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation = SEQ_OF(name='unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_Id = SEQ(name='uC-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UC-Id')))
    ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab = ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab_at = None
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab_id = 'id'
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab = ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab = ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id),
        ('criticality', _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality),
        ('extensionValue', _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue),
        ])
    ____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_._ext = None
    ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions._cont = ____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_
    ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_._cont = ASN1Dict([
        ('uC-Id', ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_Id),
        ('iE-Extensions', ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions),
        ])
    __SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_._ext = []
    _SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation._cont = __SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_
    _SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=95)], ev=None, er=[])
    _SFNSFNMeasurementValueInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SFNSFNMeasurementValueInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id._const_tab = ____SFNSFNMeasurementValueInformation_iE_Extensions__item__id_tab
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id._const_tab_at = None
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality._const_tab = ____SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality_tab
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue._const_tab = ____SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue_tab
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SFNSFNMeasurementValueInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id),
        ('criticality', ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue),
        ])
    __SFNSFNMeasurementValueInformation_iE_Extensions__item_._ext = None
    _SFNSFNMeasurementValueInformation_iE_Extensions._cont = __SFNSFNMeasurementValueInformation_iE_Extensions__item_
    _SFNSFNMeasurementValueInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SFNSFNMeasurementValueInformation._cont = ASN1Dict([
        ('successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation', _SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation),
        ('unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation', _SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation),
        ('iE-Extensions', _SFNSFNMeasurementValueInformation_iE_Extensions),
        ])
    SFNSFNMeasurementValueInformation._ext = []
    
    #-----< SFNSFNMeasurementValueInformationItem-ExtIEs >-----#
    SFNSFNMeasurementValueInformationItem_ExtIEs = CLASS(name='SFNSFNMeasurementValueInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SFNSFNMeasurementValueInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs >-----#
    SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs = CLASS(name='SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs >-----#
    UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs = CLASS(name='UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SFNSFNQuality >-----#
    SFNSFNQuality = INT(name='SFNSFNQuality', mode=MODE_TYPE)
    SFNSFNQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ShutdownTimer >-----#
    ShutdownTimer = INT(name='ShutdownTimer', mode=MODE_TYPE)
    ShutdownTimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    
    #-----< SIB-Originator >-----#
    SIB_Originator = ENUM(name='SIB-Originator', mode=MODE_TYPE)
    SIB_Originator._cont = ASN1Dict([('nodeB', 0), ('cRNC', 1)])
    SIB_Originator._ext = []
    
    #-----< SIR-Error-Value >-----#
    SIR_Error_Value = INT(name='SIR-Error-Value', mode=MODE_TYPE)
    SIR_Error_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=125)], ev=None, er=[])
    
    #-----< SFNSFNTimeStampInformation >-----#
    SFNSFNTimeStampInformation = CHOICE(name='SFNSFNTimeStampInformation', mode=MODE_TYPE)
    _SFNSFNTimeStampInformation_sFNSFNTimeStamp_FDD = INT(name='sFNSFNTimeStamp-FDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _SFNSFNTimeStampInformation_sFNSFNTimeStamp_TDD = SEQ(name='sFNSFNTimeStamp-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFNSFNTimeStamp-TDD')))
    SFNSFNTimeStampInformation._cont = ASN1Dict([
        ('sFNSFNTimeStamp-FDD', _SFNSFNTimeStampInformation_sFNSFNTimeStamp_FDD),
        ('sFNSFNTimeStamp-TDD', _SFNSFNTimeStampInformation_sFNSFNTimeStamp_TDD),
        ])
    SFNSFNTimeStampInformation._ext = []
    
    #-----< SFNSFNTimeStamp-TDD >-----#
    SFNSFNTimeStamp_TDD = SEQ(name='SFNSFNTimeStamp-TDD', mode=MODE_TYPE)
    _SFNSFNTimeStamp_TDD_sFN = INT(name='sFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _SFNSFNTimeStamp_TDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _SFNSFNTimeStamp_TDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SFNSFNTimeStamp_TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id._const_tab = ____SFNSFNTimeStamp_TDD_iE_Extensions__item__id_tab
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id._const_tab_at = None
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality._const_tab = ____SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality_tab
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue._const_tab = ____SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue_tab
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SFNSFNTimeStamp_TDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id),
        ('criticality', ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue),
        ])
    __SFNSFNTimeStamp_TDD_iE_Extensions__item_._ext = None
    _SFNSFNTimeStamp_TDD_iE_Extensions._cont = __SFNSFNTimeStamp_TDD_iE_Extensions__item_
    _SFNSFNTimeStamp_TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SFNSFNTimeStamp_TDD._cont = ASN1Dict([
        ('sFN', _SFNSFNTimeStamp_TDD_sFN),
        ('timeSlot', _SFNSFNTimeStamp_TDD_timeSlot),
        ('iE-Extensions', _SFNSFNTimeStamp_TDD_iE_Extensions),
        ])
    SFNSFNTimeStamp_TDD._ext = []
    
    #-----< SFNSFNTimeStamp-ExtIEs >-----#
    SFNSFNTimeStamp_ExtIEs = CLASS(name='SFNSFNTimeStamp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SFNSFNTimeStamp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SFNSFNValue >-----#
    SFNSFNValue = CHOICE(name='SFNSFNValue', mode=MODE_TYPE)
    _SFNSFNValue_sFNSFN_FDD = INT(name='sFNSFN-FDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFNSFN-FDD')))
    _SFNSFNValue_sFNSFN_TDD = INT(name='sFNSFN-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFNSFN-TDD')))
    _SFNSFNValue_sFNSFN_TDD768 = INT(name='sFNSFN-TDD768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFNSFN-TDD768')))
    SFNSFNValue._cont = ASN1Dict([
        ('sFNSFN-FDD', _SFNSFNValue_sFNSFN_FDD),
        ('sFNSFN-TDD', _SFNSFNValue_sFNSFN_TDD),
        ('sFNSFN-TDD768', _SFNSFNValue_sFNSFN_TDD768),
        ])
    SFNSFNValue._ext = ['sFNSFN-TDD768']
    
    #-----< Single-Stream-MIMO-ActivationIndicator >-----#
    Single_Stream_MIMO_ActivationIndicator = NULL(name='Single-Stream-MIMO-ActivationIndicator', mode=MODE_TYPE)
    
    #-----< Single-Stream-MIMO-Capability >-----#
    Single_Stream_MIMO_Capability = ENUM(name='Single-Stream-MIMO-Capability', mode=MODE_TYPE)
    Single_Stream_MIMO_Capability._cont = ASN1Dict([('single-stream-mimo-capable', 0), ('single-stream-mimo-non-capable', 1)])
    Single_Stream_MIMO_Capability._ext = None
    
    #-----< Single-Stream-MIMO-Mode-Indicator >-----#
    Single_Stream_MIMO_Mode_Indicator = ENUM(name='Single-Stream-MIMO-Mode-Indicator', mode=MODE_TYPE)
    Single_Stream_MIMO_Mode_Indicator._cont = ASN1Dict([('activate', 0), ('deactivate', 1)])
    Single_Stream_MIMO_Mode_Indicator._ext = None
    
    #-----< SIR-Error-Value-IncrDecrThres >-----#
    SIR_Error_Value_IncrDecrThres = INT(name='SIR-Error-Value-IncrDecrThres', mode=MODE_TYPE)
    SIR_Error_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=124)], ev=None, er=[])
    
    #-----< SIR-Value >-----#
    SIR_Value = INT(name='SIR-Value', mode=MODE_TYPE)
    SIR_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SIR-Value-IncrDecrThres >-----#
    SIR_Value_IncrDecrThres = INT(name='SIR-Value-IncrDecrThres', mode=MODE_TYPE)
    SIR_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=62)], ev=None, er=[])
    
    #-----< SignallingBearerRequestIndicator >-----#
    SignallingBearerRequestIndicator = ENUM(name='SignallingBearerRequestIndicator', mode=MODE_TYPE)
    SignallingBearerRequestIndicator._cont = ASN1Dict([('bearerRequested', 0)])
    SignallingBearerRequestIndicator._ext = None
    
    #-----< SixtyfourQAM-UsageAllowedIndicator >-----#
    SixtyfourQAM_UsageAllowedIndicator = ENUM(name='SixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE)
    SixtyfourQAM_UsageAllowedIndicator._cont = ASN1Dict([('allowed', 0), ('not-allowed', 1)])
    SixtyfourQAM_UsageAllowedIndicator._ext = None
    
    #-----< SixtyfourQAM-DL-UsageIndicator >-----#
    SixtyfourQAM_DL_UsageIndicator = ENUM(name='SixtyfourQAM-DL-UsageIndicator', mode=MODE_TYPE)
    SixtyfourQAM_DL_UsageIndicator._cont = ASN1Dict([('sixtyfourQAM-DL-used', 0), ('sixtyfourQAM-DL-not-used', 1)])
    SixtyfourQAM_DL_UsageIndicator._ext = None
    
    #-----< SixtyfourQAM-DL-Capability >-----#
    SixtyfourQAM_DL_Capability = ENUM(name='SixtyfourQAM-DL-Capability', mode=MODE_TYPE)
    SixtyfourQAM_DL_Capability._cont = ASN1Dict([('sixtyfourQAM-DL-supported', 0), ('sixtyfourQAM-DL-not-supported', 1)])
    SixtyfourQAM_DL_Capability._ext = None
    
    #-----< SixtyfourQAM-DL-MIMO-Combined-Capability >-----#
    SixtyfourQAM_DL_MIMO_Combined_Capability = ENUM(name='SixtyfourQAM-DL-MIMO-Combined-Capability', mode=MODE_TYPE)
    SixtyfourQAM_DL_MIMO_Combined_Capability._cont = ASN1Dict([('sixtyfourQAM-DL-MIMO-Combined-capable', 0), ('sixtyfourQAM-DL-MIMO-Combined-non-capable', 1)])
    SixtyfourQAM_DL_MIMO_Combined_Capability._ext = None
    
    #-----< SignatureSequenceGroupIndex >-----#
    SignatureSequenceGroupIndex = INT(name='SignatureSequenceGroupIndex', mode=MODE_TYPE)
    SignatureSequenceGroupIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=19)], ev=None, er=[])
    
    #-----< SixteenQAM-UL-Capability >-----#
    SixteenQAM_UL_Capability = ENUM(name='SixteenQAM-UL-Capability', mode=MODE_TYPE)
    SixteenQAM_UL_Capability._cont = ASN1Dict([('sixteenQAM-UL-capable', 0), ('sixteenQAM-UL-non-capable', 1)])
    SixteenQAM_UL_Capability._ext = None
    
    #-----< SixteenQAM-UL-Operation-Indicator >-----#
    SixteenQAM_UL_Operation_Indicator = ENUM(name='SixteenQAM-UL-Operation-Indicator', mode=MODE_TYPE)
    SixteenQAM_UL_Operation_Indicator._cont = ASN1Dict([('activate', 0), ('deactivate', 1)])
    SixteenQAM_UL_Operation_Indicator._ext = None
    
    #-----< SixtyfourQAM-UL-Operation-Indicator >-----#
    SixtyfourQAM_UL_Operation_Indicator = ENUM(name='SixtyfourQAM-UL-Operation-Indicator', mode=MODE_TYPE)
    SixtyfourQAM_UL_Operation_Indicator._cont = ASN1Dict([('activate', 0), ('deactivate', 1)])
    SixtyfourQAM_UL_Operation_Indicator._ext = None
    
    #-----< SNPL-Reporting-Type >-----#
    SNPL_Reporting_Type = ENUM(name='SNPL-Reporting-Type', mode=MODE_TYPE)
    SNPL_Reporting_Type._cont = ASN1Dict([('type1', 0), ('type2', 1)])
    SNPL_Reporting_Type._ext = None
    
    #-----< Soffset >-----#
    Soffset = INT(name='Soffset', mode=MODE_TYPE)
    Soffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    
    #-----< SpecialBurstScheduling >-----#
    SpecialBurstScheduling = INT(name='SpecialBurstScheduling', mode=MODE_TYPE)
    SpecialBurstScheduling._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Start-Of-Audit-Sequence-Indicator >-----#
    Start_Of_Audit_Sequence_Indicator = ENUM(name='Start-Of-Audit-Sequence-Indicator', mode=MODE_TYPE)
    Start_Of_Audit_Sequence_Indicator._cont = ASN1Dict([('start-of-audit-sequence', 0), ('not-start-of-audit-sequence', 1)])
    Start_Of_Audit_Sequence_Indicator._ext = None
    
    #-----< Status-Flag >-----#
    Status_Flag = ENUM(name='Status-Flag', mode=MODE_TYPE)
    Status_Flag._cont = ASN1Dict([('activate', 0), ('deactivate', 1)])
    Status_Flag._ext = None
    
    #-----< STTD-Indicator >-----#
    STTD_Indicator = ENUM(name='STTD-Indicator', mode=MODE_TYPE)
    STTD_Indicator._cont = ASN1Dict([('active', 0), ('inactive', 1)])
    STTD_Indicator._ext = []
    
    #-----< SSDT-SupportIndicator >-----#
    SSDT_SupportIndicator = ENUM(name='SSDT-SupportIndicator', mode=MODE_TYPE)
    SSDT_SupportIndicator._cont = ASN1Dict([('not-Used-sSDT-Supported', 0), ('sSDT-not-supported', 1)])
    SSDT_SupportIndicator._ext = None
    
    #-----< Sub-Frame-Number >-----#
    Sub_Frame_Number = INT(name='Sub-Frame-Number', mode=MODE_TYPE)
    Sub_Frame_Number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=[], er=[])
    
    #-----< Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order >-----#
    Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order = ENUM(name='Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order', mode=MODE_TYPE)
    Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order._cont = ASN1Dict([('supported', 0), ('not-supported', 1)])
    Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order._ext = None
    
    #-----< SyncCase >-----#
    SyncCase = INT(name='SyncCase', mode=MODE_TYPE)
    SyncCase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=[], er=[])
    
    #-----< SYNCDlCodeId >-----#
    SYNCDlCodeId = INT(name='SYNCDlCodeId', mode=MODE_TYPE)
    SYNCDlCodeId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< SyncFrameNumber >-----#
    SyncFrameNumber = INT(name='SyncFrameNumber', mode=MODE_TYPE)
    SyncFrameNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< SynchronisationReportCharacteristics >-----#
    SynchronisationReportCharacteristics = SEQ(name='SynchronisationReportCharacteristics', mode=MODE_TYPE)
    _SynchronisationReportCharacteristics_synchronisationReportCharacteristicsType = ENUM(name='synchronisationReportCharacteristicsType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportCharacteristicsType')))
    _SynchronisationReportCharacteristics_synchronisationReportCharactThreExc = SEQ_OF(name='synchronisationReportCharactThreExc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportCharactThreExc')), opt=True)
    _SynchronisationReportCharacteristics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SynchronisationReportCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SynchronisationReportCharacteristics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SynchronisationReportCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____SynchronisationReportCharacteristics_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SyncDLCodeIdThreInfoLCR')))
    ____SynchronisationReportCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 549), ('criticality', 'ignore'), ('Extension', _____SynchronisationReportCharacteristics_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SynchronisationReportCharacteristics_iE_Extensions__item__id._const_tab = ____SynchronisationReportCharacteristics_iE_Extensions__item__id_tab
    ___SynchronisationReportCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___SynchronisationReportCharacteristics_iE_Extensions__item__id._const_tab_id = 'id'
    ___SynchronisationReportCharacteristics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SynchronisationReportCharacteristics_iE_Extensions__item__criticality._const_tab = ____SynchronisationReportCharacteristics_iE_Extensions__item__id_tab
    ___SynchronisationReportCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SynchronisationReportCharacteristics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SynchronisationReportCharacteristics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SynchronisationReportCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____SynchronisationReportCharacteristics_iE_Extensions__item__id_tab
    ___SynchronisationReportCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SynchronisationReportCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SynchronisationReportCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SynchronisationReportCharacteristics_iE_Extensions__item__id),
        ('criticality', ___SynchronisationReportCharacteristics_iE_Extensions__item__criticality),
        ('extensionValue', ___SynchronisationReportCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __SynchronisationReportCharacteristics_iE_Extensions__item_._ext = None
    _SynchronisationReportCharacteristics_iE_Extensions._cont = __SynchronisationReportCharacteristics_iE_Extensions__item_
    _SynchronisationReportCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SynchronisationReportCharacteristics._cont = ASN1Dict([
        ('synchronisationReportCharacteristicsType', _SynchronisationReportCharacteristics_synchronisationReportCharacteristicsType),
        ('synchronisationReportCharactThreExc', _SynchronisationReportCharacteristics_synchronisationReportCharactThreExc),
        ('iE-Extensions', _SynchronisationReportCharacteristics_iE_Extensions),
        ])
    SynchronisationReportCharacteristics._ext = []
    
    #-----< SynchronisationReportCharacteristics-ExtIEs >-----#
    SynchronisationReportCharacteristics_ExtIEs = CLASS(name='SynchronisationReportCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _SynchronisationReportCharacteristics_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SyncDLCodeIdThreInfoLCR')))
    SynchronisationReportCharacteristics_ExtIEs._val = ASN1Set(rv=[dict([('id', 549), ('criticality', 'ignore'), ('Extension', _SynchronisationReportCharacteristics_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SynchronisationReportCharactThreExc >-----#
    SynchronisationReportCharactThreExc = SEQ_OF(name='SynchronisationReportCharactThreExc', mode=MODE_TYPE)
    _SynchronisationReportCharactThreExc__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportCharactThreInfoItem')))
    SynchronisationReportCharactThreExc._cont = _SynchronisationReportCharactThreExc__item_
    SynchronisationReportCharactThreExc._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< SynchronisationReportCharactThreInfoItem >-----#
    SynchronisationReportCharactThreInfoItem = SEQ(name='SynchronisationReportCharactThreInfoItem', mode=MODE_TYPE)
    _SynchronisationReportCharactThreInfoItem_syncFrameNumber = INT(name='syncFrameNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SyncFrameNumber')))
    _SynchronisationReportCharactThreInfoItem_cellSyncBurstInformation = SEQ_OF(name='cellSyncBurstInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SynchronisationReportCharactThreInfoItem_cellSyncBurstInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportCharactCellSyncBurstInfoItem')))
    _SynchronisationReportCharactThreInfoItem_cellSyncBurstInformation._cont = __SynchronisationReportCharactThreInfoItem_cellSyncBurstInformation__item_
    _SynchronisationReportCharactThreInfoItem_cellSyncBurstInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _SynchronisationReportCharactThreInfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SynchronisationReportCharactThreInfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__id._const_tab = ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__id_tab
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__id._const_tab_at = None
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__criticality._const_tab = ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__criticality_tab
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__extensionValue._const_tab = ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__extensionValue_tab
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SynchronisationReportCharactThreInfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__id),
        ('criticality', ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__extensionValue),
        ])
    __SynchronisationReportCharactThreInfoItem_iE_Extensions__item_._ext = None
    _SynchronisationReportCharactThreInfoItem_iE_Extensions._cont = __SynchronisationReportCharactThreInfoItem_iE_Extensions__item_
    _SynchronisationReportCharactThreInfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SynchronisationReportCharactThreInfoItem._cont = ASN1Dict([
        ('syncFrameNumber', _SynchronisationReportCharactThreInfoItem_syncFrameNumber),
        ('cellSyncBurstInformation', _SynchronisationReportCharactThreInfoItem_cellSyncBurstInformation),
        ('iE-Extensions', _SynchronisationReportCharactThreInfoItem_iE_Extensions),
        ])
    SynchronisationReportCharactThreInfoItem._ext = []
    
    #-----< SynchronisationReportCharactThreInfoItem-ExtIEs >-----#
    SynchronisationReportCharactThreInfoItem_ExtIEs = CLASS(name='SynchronisationReportCharactThreInfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SynchronisationReportCharactThreInfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SynchronisationReportCharactCellSyncBurstInfoItem >-----#
    SynchronisationReportCharactCellSyncBurstInfoItem = SEQ(name='SynchronisationReportCharactCellSyncBurstInfoItem', mode=MODE_TYPE)
    _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstCode = INT(name='cellSyncBurstCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstCode')))
    _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstCodeShift = INT(name='cellSyncBurstCodeShift', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstCodeShift')))
    _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstTiming = CHOICE(name='cellSyncBurstTiming', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstTiming')), opt=True)
    _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstTimingThreshold = INT(name='cellSyncBurstTimingThreshold', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstTimingThreshold')), opt=True)
    _SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__id._const_tab = ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__id_tab
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__id._const_tab_at = None
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__criticality._const_tab = ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__criticality_tab
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__extensionValue._const_tab = ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__extensionValue_tab
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__id),
        ('criticality', ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__extensionValue),
        ])
    __SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item_._ext = None
    _SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions._cont = __SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item_
    _SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SynchronisationReportCharactCellSyncBurstInfoItem._cont = ASN1Dict([
        ('cellSyncBurstCode', _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstCode),
        ('cellSyncBurstCodeShift', _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstCodeShift),
        ('cellSyncBurstTiming', _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstTiming),
        ('cellSyncBurstTimingThreshold', _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstTimingThreshold),
        ('iE-Extensions', _SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions),
        ])
    SynchronisationReportCharactCellSyncBurstInfoItem._ext = []
    
    #-----< SynchronisationReportCharactCellSyncBurstInfoItem-ExtIEs >-----#
    SynchronisationReportCharactCellSyncBurstInfoItem_ExtIEs = CLASS(name='SynchronisationReportCharactCellSyncBurstInfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SynchronisationReportCharactCellSyncBurstInfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SyncDLCodeIdThreInfoLCR >-----#
    SyncDLCodeIdThreInfoLCR = SEQ_OF(name='SyncDLCodeIdThreInfoLCR', mode=MODE_TYPE)
    _SyncDLCodeIdThreInfoLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SyncDLCodeIdThreInfoList')))
    SyncDLCodeIdThreInfoLCR._cont = _SyncDLCodeIdThreInfoLCR__item_
    SyncDLCodeIdThreInfoLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=512)], ev=None, er=[])
    
    #-----< SyncDLCodeIdThreInfoList >-----#
    SyncDLCodeIdThreInfoList = SEQ(name='SyncDLCodeIdThreInfoList', mode=MODE_TYPE)
    _SyncDLCodeIdThreInfoList_syncFrameNoToReceive = INT(name='syncFrameNoToReceive', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SyncFrameNumber')))
    _SyncDLCodeIdThreInfoList_syncDLCodeIdInfoLCR = SEQ_OF(name='syncDLCodeIdInfoLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SyncDLCodeInfoListLCR')))
    _SyncDLCodeIdThreInfoList_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SyncDLCodeIdThreInfoList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SyncDLCodeIdThreInfoList_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeIdThreInfoList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__id._const_tab = ____SyncDLCodeIdThreInfoList_iE_Extensions__item__id_tab
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__id._const_tab_at = None
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__id._const_tab_id = 'id'
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SyncDLCodeIdThreInfoList_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeIdThreInfoList_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__criticality._const_tab = ____SyncDLCodeIdThreInfoList_iE_Extensions__item__criticality_tab
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SyncDLCodeIdThreInfoList_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeIdThreInfoList_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__extensionValue._const_tab = ____SyncDLCodeIdThreInfoList_iE_Extensions__item__extensionValue_tab
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SyncDLCodeIdThreInfoList_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SyncDLCodeIdThreInfoList_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SyncDLCodeIdThreInfoList_iE_Extensions__item__id),
        ('criticality', ___SyncDLCodeIdThreInfoList_iE_Extensions__item__criticality),
        ('extensionValue', ___SyncDLCodeIdThreInfoList_iE_Extensions__item__extensionValue),
        ])
    __SyncDLCodeIdThreInfoList_iE_Extensions__item_._ext = None
    _SyncDLCodeIdThreInfoList_iE_Extensions._cont = __SyncDLCodeIdThreInfoList_iE_Extensions__item_
    _SyncDLCodeIdThreInfoList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SyncDLCodeIdThreInfoList._cont = ASN1Dict([
        ('syncFrameNoToReceive', _SyncDLCodeIdThreInfoList_syncFrameNoToReceive),
        ('syncDLCodeIdInfoLCR', _SyncDLCodeIdThreInfoList_syncDLCodeIdInfoLCR),
        ('iE-Extensions', _SyncDLCodeIdThreInfoList_iE_Extensions),
        ])
    SyncDLCodeIdThreInfoList._ext = []
    
    #-----< SyncDLCodeIdThreInfoList-ExtIEs >-----#
    SyncDLCodeIdThreInfoList_ExtIEs = CLASS(name='SyncDLCodeIdThreInfoList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SyncDLCodeIdThreInfoList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SyncDLCodeInfoListLCR >-----#
    SyncDLCodeInfoListLCR = SEQ_OF(name='SyncDLCodeInfoListLCR', mode=MODE_TYPE)
    _SyncDLCodeInfoListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SyncDLCodeInfoItemLCR')))
    SyncDLCodeInfoListLCR._cont = _SyncDLCodeInfoListLCR__item_
    SyncDLCodeInfoListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SyncDLCodeInfoItemLCR >-----#
    SyncDLCodeInfoItemLCR = SEQ(name='SyncDLCodeInfoItemLCR', mode=MODE_TYPE)
    _SyncDLCodeInfoItemLCR_syncDLCodeId = INT(name='syncDLCodeId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SYNCDlCodeId')))
    _SyncDLCodeInfoItemLCR_syncDLCodeIdArrivTime = CHOICE(name='syncDLCodeIdArrivTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstTimingLCR')), opt=True)
    _SyncDLCodeInfoItemLCR_syncDLCodeIdTimingThre = INT(name='syncDLCodeIdTimingThre', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstTimingThreshold')), opt=True)
    _SyncDLCodeInfoItemLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SyncDLCodeInfoItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SyncDLCodeInfoItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeInfoItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__id._const_tab = ____SyncDLCodeInfoItemLCR_iE_Extensions__item__id_tab
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SyncDLCodeInfoItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeInfoItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__criticality._const_tab = ____SyncDLCodeInfoItemLCR_iE_Extensions__item__criticality_tab
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SyncDLCodeInfoItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeInfoItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__extensionValue._const_tab = ____SyncDLCodeInfoItemLCR_iE_Extensions__item__extensionValue_tab
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SyncDLCodeInfoItemLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SyncDLCodeInfoItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SyncDLCodeInfoItemLCR_iE_Extensions__item__id),
        ('criticality', ___SyncDLCodeInfoItemLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___SyncDLCodeInfoItemLCR_iE_Extensions__item__extensionValue),
        ])
    __SyncDLCodeInfoItemLCR_iE_Extensions__item_._ext = None
    _SyncDLCodeInfoItemLCR_iE_Extensions._cont = __SyncDLCodeInfoItemLCR_iE_Extensions__item_
    _SyncDLCodeInfoItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SyncDLCodeInfoItemLCR._cont = ASN1Dict([
        ('syncDLCodeId', _SyncDLCodeInfoItemLCR_syncDLCodeId),
        ('syncDLCodeIdArrivTime', _SyncDLCodeInfoItemLCR_syncDLCodeIdArrivTime),
        ('syncDLCodeIdTimingThre', _SyncDLCodeInfoItemLCR_syncDLCodeIdTimingThre),
        ('iE-Extensions', _SyncDLCodeInfoItemLCR_iE_Extensions),
        ])
    SyncDLCodeInfoItemLCR._ext = []
    
    #-----< SyncDLCodeInfoItem-LCR-ExtIEs >-----#
    SyncDLCodeInfoItem_LCR_ExtIEs = CLASS(name='SyncDLCodeInfoItem-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SyncDLCodeInfoItem_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDPCCH-PowerOffsetInformation >-----#
    SDPCCH_PowerOffsetInformation = INT(name='SDPCCH-PowerOffsetInformation', mode=MODE_TYPE)
    SDPCCH_PowerOffsetInformation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=[], er=[])
    
    #-----< SynchronisationReportCharacteristicsType >-----#
    SynchronisationReportCharacteristicsType = ENUM(name='SynchronisationReportCharacteristicsType', mode=MODE_TYPE)
    SynchronisationReportCharacteristicsType._cont = ASN1Dict([('frameRelated', 0), ('sFNperiodRelated', 1), ('cycleLengthRelated', 2), ('thresholdExceeding', 3), ('frequencyAcquisitionCompleted', 4)])
    SynchronisationReportCharacteristicsType._ext = []
    
    #-----< SynchronisationReportType >-----#
    SynchronisationReportType = ENUM(name='SynchronisationReportType', mode=MODE_TYPE)
    SynchronisationReportType._cont = ASN1Dict([('initialPhase', 0), ('steadyStatePhase', 1), ('lateEntrantCell', 2), ('frequencyAcquisition', 3)])
    SynchronisationReportType._ext = []
    
    #-----< Semi-PersistentScheduling-CapabilityLCR >-----#
    Semi_PersistentScheduling_CapabilityLCR = ENUM(name='Semi-PersistentScheduling-CapabilityLCR', mode=MODE_TYPE)
    Semi_PersistentScheduling_CapabilityLCR._cont = ASN1Dict([('semi-Persistent-scheduling-Capable', 0), ('semi-Persistent-scheduling-Non-Capable', 1)])
    Semi_PersistentScheduling_CapabilityLCR._ext = None
    
    #-----< T1 >-----#
    T1 = ENUM(name='T1', mode=MODE_TYPE)
    T1._cont = ASN1Dict([('v10', 0), ('v20', 1), ('v30', 2), ('v40', 3), ('v50', 4), ('v60', 5), ('v70', 6), ('v80', 7), ('v90', 8), ('v100', 9), ('v120', 10), ('v140', 11), ('v160', 12), ('v200', 13), ('v300', 14), ('v400', 15)])
    T1._ext = []
    
    #-----< T321 >-----#
    T321 = ENUM(name='T321', mode=MODE_TYPE)
    T321._cont = ASN1Dict([('v100', 0), ('v200', 1), ('v400', 2), ('v800', 3)])
    T321._ext = []
    
    #-----< T333 >-----#
    T333 = ENUM(name='T333', mode=MODE_TYPE)
    T333._cont = ASN1Dict([('v100', 0), ('v200', 1), ('v400', 2), ('v800', 3)])
    T333._ext = []
    
    #-----< T-Cell >-----#
    T_Cell = ENUM(name='T-Cell', mode=MODE_TYPE)
    T_Cell._cont = ASN1Dict([('v0', 0), ('v1', 1), ('v2', 2), ('v3', 3), ('v4', 4), ('v5', 5), ('v6', 6), ('v7', 7), ('v8', 8), ('v9', 9)])
    T_Cell._ext = None
    
    #-----< T-RLFAILURE >-----#
    T_RLFAILURE = INT(name='T-RLFAILURE', mode=MODE_TYPE)
    T_RLFAILURE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< T-PROTECT >-----#
    T_PROTECT = ENUM(name='T-PROTECT', mode=MODE_TYPE)
    T_PROTECT._cont = ASN1Dict([('v40', 0), ('v60', 1), ('v80', 2), ('v100', 3), ('v120', 4), ('v200', 5), ('v400', 6)])
    T_PROTECT._ext = []
    
    #-----< T-SYNC >-----#
    T_SYNC = ENUM(name='T-SYNC', mode=MODE_TYPE)
    T_SYNC._cont = ASN1Dict([('v40', 0), ('v80', 1), ('v120', 2), ('v160', 3), ('v200', 4), ('v300', 5), ('v400', 6), ('v500', 7)])
    T_SYNC._ext = []
    
    #-----< TDD-AckNack-Power-Offset >-----#
    TDD_AckNack_Power_Offset = INT(name='TDD-AckNack-Power-Offset', mode=MODE_TYPE)
    TDD_AckNack_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-7, ub=8)], ev=[], er=[])
    
    #-----< TDD-ChannelisationCode >-----#
    TDD_ChannelisationCode = ENUM(name='TDD-ChannelisationCode', mode=MODE_TYPE)
    TDD_ChannelisationCode._cont = ASN1Dict([('chCode1div1', 0), ('chCode2div1', 1), ('chCode2div2', 2), ('chCode4div1', 3), ('chCode4div2', 4), ('chCode4div3', 5), ('chCode4div4', 6), ('chCode8div1', 7), ('chCode8div2', 8), ('chCode8div3', 9), ('chCode8div4', 10), ('chCode8div5', 11), ('chCode8div6', 12), ('chCode8div7', 13), ('chCode8div8', 14), ('chCode16div1', 15), ('chCode16div2', 16), ('chCode16div3', 17), ('chCode16div4', 18), ('chCode16div5', 19), ('chCode16div6', 20), ('chCode16div7', 21), ('chCode16div8', 22), ('chCode16div9', 23), ('chCode16div10', 24), ('chCode16div11', 25), ('chCode16div12', 26), ('chCode16div13', 27), ('chCode16div14', 28), ('chCode16div15', 29), ('chCode16div16', 30)])
    TDD_ChannelisationCode._ext = []
    
    #-----< Puncturing-Handling-in-First-Rate-Matching-Stage >-----#
    Puncturing_Handling_in_First_Rate_Matching_Stage = BOOL(name='Puncturing-Handling-in-First-Rate-Matching-Stage', mode=MODE_TYPE)
    
    #-----< TDD-ChannelisationCodeLCR >-----#
    TDD_ChannelisationCodeLCR = SEQ(name='TDD-ChannelisationCodeLCR', mode=MODE_TYPE)
    _TDD_ChannelisationCodeLCR_tDD_ChannelisationCode = ENUM(name='tDD-ChannelisationCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _TDD_ChannelisationCodeLCR_modulation = ENUM(name='modulation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Modulation')))
    _TDD_ChannelisationCodeLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_ChannelisationCodeLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_ChannelisationCodeLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_ChannelisationCodeLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__id._const_tab = ____TDD_ChannelisationCodeLCR_iE_Extensions__item__id_tab
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__id._const_tab_at = None
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TDD_ChannelisationCodeLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_ChannelisationCodeLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__criticality._const_tab = ____TDD_ChannelisationCodeLCR_iE_Extensions__item__criticality_tab
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TDD_ChannelisationCodeLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_ChannelisationCodeLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__extensionValue._const_tab = ____TDD_ChannelisationCodeLCR_iE_Extensions__item__extensionValue_tab
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_ChannelisationCodeLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_ChannelisationCodeLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_ChannelisationCodeLCR_iE_Extensions__item__id),
        ('criticality', ___TDD_ChannelisationCodeLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_ChannelisationCodeLCR_iE_Extensions__item__extensionValue),
        ])
    __TDD_ChannelisationCodeLCR_iE_Extensions__item_._ext = None
    _TDD_ChannelisationCodeLCR_iE_Extensions._cont = __TDD_ChannelisationCodeLCR_iE_Extensions__item_
    _TDD_ChannelisationCodeLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_ChannelisationCodeLCR._cont = ASN1Dict([
        ('tDD-ChannelisationCode', _TDD_ChannelisationCodeLCR_tDD_ChannelisationCode),
        ('modulation', _TDD_ChannelisationCodeLCR_modulation),
        ('iE-Extensions', _TDD_ChannelisationCodeLCR_iE_Extensions),
        ])
    TDD_ChannelisationCodeLCR._ext = []
    
    #-----< TDD-ChannelisationCodeLCR-ExtIEs >-----#
    TDD_ChannelisationCodeLCR_ExtIEs = CLASS(name='TDD-ChannelisationCodeLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TDD_ChannelisationCodeLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-ChannelisationCode768 >-----#
    TDD_ChannelisationCode768 = ENUM(name='TDD-ChannelisationCode768', mode=MODE_TYPE)
    TDD_ChannelisationCode768._cont = ASN1Dict([('chCode1div1', 0), ('chCode2div1', 1), ('chCode2div2', 2), ('chCode4div1', 3), ('chCode4div2', 4), ('chCode4div3', 5), ('chCode4div4', 6), ('chCode8div1', 7), ('chCode8div2', 8), ('chCode8div3', 9), ('chCode8div4', 10), ('chCode8div5', 11), ('chCode8div6', 12), ('chCode8div7', 13), ('chCode8div8', 14), ('chCode16div1', 15), ('chCode16div2', 16), ('chCode16div3', 17), ('chCode16div4', 18), ('chCode16div5', 19), ('chCode16div6', 20), ('chCode16div7', 21), ('chCode16div8', 22), ('chCode16div9', 23), ('chCode16div10', 24), ('chCode16div11', 25), ('chCode16div12', 26), ('chCode16div13', 27), ('chCode16div14', 28), ('chCode16div15', 29), ('chCode16div16', 30), ('chCode32div1', 31), ('chCode32div2', 32), ('chCode32div3', 33), ('chCode32div4', 34), ('chCode32div5', 35), ('chCode32div6', 36), ('chCode32div7', 37), ('chCode32div8', 38), ('chCode32div9', 39), ('chCode32div10', 40), ('chCode32div11', 41), ('chCode32div12', 42), ('chCode32div13', 43), ('chCode32div14', 44), ('chCode32div15', 45), ('chCode32div16', 46), ('chCode32div17', 47), ('chCode32div18', 48), ('chCode32div19', 49), ('chCode32div20', 50), ('chCode32div21', 51), ('chCode32div22', 52), ('chCode32div23', 53), ('chCode32div24', 54), ('chCode32div25', 55), ('chCode32div26', 56), ('chCode32div27', 57), ('chCode32div28', 58), ('chCode32div29', 59), ('chCode32div30', 60), ('chCode32div31', 61), ('chCode32div32', 62)])
    TDD_ChannelisationCode768._ext = []
    
    #-----< TDD-DL-Code-Information >-----#
    TDD_DL_Code_Information = SEQ_OF(name='TDD-DL-Code-Information', mode=MODE_TYPE)
    _TDD_DL_Code_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-Code-InformationItem')))
    TDD_DL_Code_Information._cont = _TDD_DL_Code_Information__item_
    TDD_DL_Code_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-DL-Code-InformationItem >-----#
    TDD_DL_Code_InformationItem = SEQ(name='TDD-DL-Code-InformationItem', mode=MODE_TYPE)
    _TDD_DL_Code_InformationItem_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _TDD_DL_Code_InformationItem_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _TDD_DL_Code_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_DL_Code_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__id._const_tab = ____TDD_DL_Code_InformationItem_iE_Extensions__item__id_tab
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality._const_tab = ____TDD_DL_Code_InformationItem_iE_Extensions__item__criticality_tab
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue_tab
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_DL_Code_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_DL_Code_InformationItem_iE_Extensions__item__id),
        ('criticality', ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_DL_Code_InformationItem_iE_Extensions__item_._ext = None
    _TDD_DL_Code_InformationItem_iE_Extensions._cont = __TDD_DL_Code_InformationItem_iE_Extensions__item_
    _TDD_DL_Code_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_DL_Code_InformationItem._cont = ASN1Dict([
        ('dPCH-ID', _TDD_DL_Code_InformationItem_dPCH_ID),
        ('tdd-ChannelisationCode', _TDD_DL_Code_InformationItem_tdd_ChannelisationCode),
        ('iE-Extensions', _TDD_DL_Code_InformationItem_iE_Extensions),
        ])
    TDD_DL_Code_InformationItem._ext = []
    
    #-----< TDD-DL-Code-InformationItem-ExtIEs >-----#
    TDD_DL_Code_InformationItem_ExtIEs = CLASS(name='TDD-DL-Code-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TDD_DL_Code_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-DL-Code-LCR-Information >-----#
    TDD_DL_Code_LCR_Information = SEQ_OF(name='TDD-DL-Code-LCR-Information', mode=MODE_TYPE)
    _TDD_DL_Code_LCR_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-Code-LCR-InformationItem')))
    TDD_DL_Code_LCR_Information._cont = _TDD_DL_Code_LCR_Information__item_
    TDD_DL_Code_LCR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-DL-Code-LCR-InformationItem >-----#
    TDD_DL_Code_LCR_InformationItem = SEQ(name='TDD-DL-Code-LCR-InformationItem', mode=MODE_TYPE)
    _TDD_DL_Code_LCR_InformationItem_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _TDD_DL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _TDD_DL_Code_LCR_InformationItem_tdd_DL_DPCH_TimeSlotFormat_LCR = CHOICE(name='tdd-DL-DPCH-TimeSlotFormat-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    _TDD_DL_Code_LCR_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_DL_Code_LCR_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab = ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id_tab
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab = ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_DL_Code_LCR_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id),
        ('criticality', ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_DL_Code_LCR_InformationItem_iE_Extensions__item_._ext = None
    _TDD_DL_Code_LCR_InformationItem_iE_Extensions._cont = __TDD_DL_Code_LCR_InformationItem_iE_Extensions__item_
    _TDD_DL_Code_LCR_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_DL_Code_LCR_InformationItem._cont = ASN1Dict([
        ('dPCH-ID', _TDD_DL_Code_LCR_InformationItem_dPCH_ID),
        ('tdd-ChannelisationCodeLCR', _TDD_DL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR),
        ('tdd-DL-DPCH-TimeSlotFormat-LCR', _TDD_DL_Code_LCR_InformationItem_tdd_DL_DPCH_TimeSlotFormat_LCR),
        ('iE-Extensions', _TDD_DL_Code_LCR_InformationItem_iE_Extensions),
        ])
    TDD_DL_Code_LCR_InformationItem._ext = []
    
    #-----< TDD-DL-Code-LCR-InformationItem-ExtIEs >-----#
    TDD_DL_Code_LCR_InformationItem_ExtIEs = CLASS(name='TDD-DL-Code-LCR-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TDD_DL_Code_LCR_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-DL-Code-768-Information >-----#
    TDD_DL_Code_768_Information = SEQ_OF(name='TDD-DL-Code-768-Information', mode=MODE_TYPE)
    _TDD_DL_Code_768_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-Code-768-InformationItem')))
    TDD_DL_Code_768_Information._cont = _TDD_DL_Code_768_Information__item_
    TDD_DL_Code_768_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=480)], ev=None, er=[])
    
    #-----< TDD-DL-Code-768-InformationItem >-----#
    TDD_DL_Code_768_InformationItem = SEQ(name='TDD-DL-Code-768-InformationItem', mode=MODE_TYPE)
    _TDD_DL_Code_768_InformationItem_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _TDD_DL_Code_768_InformationItem_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _TDD_DL_Code_768_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_DL_Code_768_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__id._const_tab = ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__id_tab
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__criticality._const_tab = ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__criticality_tab
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__extensionValue_tab
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_DL_Code_768_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__id),
        ('criticality', ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_DL_Code_768_InformationItem_iE_Extensions__item_._ext = None
    _TDD_DL_Code_768_InformationItem_iE_Extensions._cont = __TDD_DL_Code_768_InformationItem_iE_Extensions__item_
    _TDD_DL_Code_768_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_DL_Code_768_InformationItem._cont = ASN1Dict([
        ('dPCH-ID', _TDD_DL_Code_768_InformationItem_dPCH_ID),
        ('tdd-ChannelisationCode768', _TDD_DL_Code_768_InformationItem_tdd_ChannelisationCode768),
        ('iE-Extensions', _TDD_DL_Code_768_InformationItem_iE_Extensions),
        ])
    TDD_DL_Code_768_InformationItem._ext = []
    
    #-----< TDD-DL-Code-768-InformationItem-ExtIEs >-----#
    TDD_DL_Code_768_InformationItem_ExtIEs = CLASS(name='TDD-DL-Code-768-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TDD_DL_Code_768_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-DL-DPCH-TimeSlotFormat-LCR >-----#
    TDD_DL_DPCH_TimeSlotFormat_LCR = CHOICE(name='TDD-DL-DPCH-TimeSlotFormat-LCR', mode=MODE_TYPE)
    _TDD_DL_DPCH_TimeSlotFormat_LCR_qPSK = INT(name='qPSK', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'QPSK-DL-DPCH-TimeSlotFormatTDD-LCR')))
    _TDD_DL_DPCH_TimeSlotFormat_LCR_eightPSK = INT(name='eightPSK', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'EightPSK-DL-DPCH-TimeSlotFormatTDD-LCR')))
    TDD_DL_DPCH_TimeSlotFormat_LCR._cont = ASN1Dict([
        ('qPSK', _TDD_DL_DPCH_TimeSlotFormat_LCR_qPSK),
        ('eightPSK', _TDD_DL_DPCH_TimeSlotFormat_LCR_eightPSK),
        ])
    TDD_DL_DPCH_TimeSlotFormat_LCR._ext = []
    
    #-----< QPSK-DL-DPCH-TimeSlotFormatTDD-LCR >-----#
    QPSK_DL_DPCH_TimeSlotFormatTDD_LCR = INT(name='QPSK-DL-DPCH-TimeSlotFormatTDD-LCR', mode=MODE_TYPE)
    QPSK_DL_DPCH_TimeSlotFormatTDD_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=24)], ev=[], er=[])
    
    #-----< EightPSK-DL-DPCH-TimeSlotFormatTDD-LCR >-----#
    EightPSK_DL_DPCH_TimeSlotFormatTDD_LCR = INT(name='EightPSK-DL-DPCH-TimeSlotFormatTDD-LCR', mode=MODE_TYPE)
    EightPSK_DL_DPCH_TimeSlotFormatTDD_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=24)], ev=[], er=[])
    
    #-----< TDD-DPCHOffset >-----#
    TDD_DPCHOffset = CHOICE(name='TDD-DPCHOffset', mode=MODE_TYPE)
    _TDD_DPCHOffset_initialOffset = INT(name='initialOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TDD_DPCHOffset_initialOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TDD_DPCHOffset_noinitialOffset = INT(name='noinitialOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TDD_DPCHOffset_noinitialOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    TDD_DPCHOffset._cont = ASN1Dict([
        ('initialOffset', _TDD_DPCHOffset_initialOffset),
        ('noinitialOffset', _TDD_DPCHOffset_noinitialOffset),
        ])
    TDD_DPCHOffset._ext = None
    
    #-----< TDD-PhysicalChannelOffset >-----#
    TDD_PhysicalChannelOffset = INT(name='TDD-PhysicalChannelOffset', mode=MODE_TYPE)
    TDD_PhysicalChannelOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< TDD-TPC-DownlinkStepSize >-----#
    TDD_TPC_DownlinkStepSize = ENUM(name='TDD-TPC-DownlinkStepSize', mode=MODE_TYPE)
    TDD_TPC_DownlinkStepSize._cont = ASN1Dict([('step-size1', 0), ('step-size2', 1), ('step-size3', 2)])
    TDD_TPC_DownlinkStepSize._ext = []
    
    #-----< TDD-TPC-UplinkStepSize-LCR >-----#
    TDD_TPC_UplinkStepSize_LCR = ENUM(name='TDD-TPC-UplinkStepSize-LCR', mode=MODE_TYPE)
    TDD_TPC_UplinkStepSize_LCR._cont = ASN1Dict([('step-size1', 0), ('step-size2', 1), ('step-size3', 2)])
    TDD_TPC_UplinkStepSize_LCR._ext = []
    
    #-----< TransportFormatCombination-Beta >-----#
    TransportFormatCombination_Beta = CHOICE(name='TransportFormatCombination-Beta', mode=MODE_TYPE)
    _TransportFormatCombination_Beta_signalledGainFactors = SEQ(name='signalledGainFactors', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransportFormatCombination_Beta_signalledGainFactors_gainFactor = CHOICE(name='gainFactor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_betaC = INT(name='betaC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BetaCD')))
    ____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_betaD = INT(name='betaD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BetaCD')))
    ____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    _____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__id._const_tab = _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__id_tab
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__id._const_tab_at = None
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__id._const_tab_id = 'id'
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__criticality._const_tab = _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__criticality_tab
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__extensionValue._const_tab = _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__extensionValue_tab
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    _____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__id),
        ('criticality', ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__criticality),
        ('extensionValue', ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__extensionValue),
        ])
    _____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item_._ext = None
    ____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions._cont = _____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item_
    ____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ___TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd._cont = ASN1Dict([
        ('betaC', ____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_betaC),
        ('betaD', ____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_betaD),
        ('iE-Extensions', ____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions),
        ])
    ___TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd._ext = []
    ___TransportFormatCombination_Beta_signalledGainFactors_gainFactor_tdd = INT(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BetaCD')))
    __TransportFormatCombination_Beta_signalledGainFactors_gainFactor._cont = ASN1Dict([
        ('fdd', ___TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd),
        ('tdd', ___TransportFormatCombination_Beta_signalledGainFactors_gainFactor_tdd),
        ])
    __TransportFormatCombination_Beta_signalledGainFactors_gainFactor._ext = []
    __TransportFormatCombination_Beta_signalledGainFactors_refTFCNumber = INT(name='refTFCNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RefTFCNumber')), opt=True)
    __TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id._const_tab = _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id_tab
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id._const_tab_at = None
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id._const_tab_id = 'id'
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality._const_tab = _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality_tab
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue._const_tab = _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue_tab
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id),
        ('criticality', ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality),
        ('extensionValue', ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue),
        ])
    ___TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item_._ext = None
    __TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions._cont = ___TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item_
    __TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TransportFormatCombination_Beta_signalledGainFactors._cont = ASN1Dict([
        ('gainFactor', __TransportFormatCombination_Beta_signalledGainFactors_gainFactor),
        ('refTFCNumber', __TransportFormatCombination_Beta_signalledGainFactors_refTFCNumber),
        ('iE-Extensions', __TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions),
        ])
    _TransportFormatCombination_Beta_signalledGainFactors._ext = []
    _TransportFormatCombination_Beta_computedGainFactors = INT(name='computedGainFactors', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RefTFCNumber')))
    TransportFormatCombination_Beta._cont = ASN1Dict([
        ('signalledGainFactors', _TransportFormatCombination_Beta_signalledGainFactors),
        ('computedGainFactors', _TransportFormatCombination_Beta_computedGainFactors),
        ])
    TransportFormatCombination_Beta._ext = []
    
    #-----< GainFactorFDD-ExtIEs >-----#
    GainFactorFDD_ExtIEs = CLASS(name='GainFactorFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GainFactorFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SignalledGainFactors-ExtIEs >-----#
    SignalledGainFactors_ExtIEs = CLASS(name='SignalledGainFactors-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SignalledGainFactors_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-UL-Code-Information >-----#
    TDD_UL_Code_Information = SEQ_OF(name='TDD-UL-Code-Information', mode=MODE_TYPE)
    _TDD_UL_Code_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-Code-InformationItem')))
    TDD_UL_Code_Information._cont = _TDD_UL_Code_Information__item_
    TDD_UL_Code_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-UL-Code-InformationItem >-----#
    TDD_UL_Code_InformationItem = SEQ(name='TDD-UL-Code-InformationItem', mode=MODE_TYPE)
    _TDD_UL_Code_InformationItem_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _TDD_UL_Code_InformationItem_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _TDD_UL_Code_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_UL_Code_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id._const_tab = ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality._const_tab = ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_UL_Code_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_UL_Code_InformationItem_iE_Extensions__item__id),
        ('criticality', ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_UL_Code_InformationItem_iE_Extensions__item_._ext = None
    _TDD_UL_Code_InformationItem_iE_Extensions._cont = __TDD_UL_Code_InformationItem_iE_Extensions__item_
    _TDD_UL_Code_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_UL_Code_InformationItem._cont = ASN1Dict([
        ('dPCH-ID', _TDD_UL_Code_InformationItem_dPCH_ID),
        ('tdd-ChannelisationCode', _TDD_UL_Code_InformationItem_tdd_ChannelisationCode),
        ('iE-Extensions', _TDD_UL_Code_InformationItem_iE_Extensions),
        ])
    TDD_UL_Code_InformationItem._ext = []
    
    #-----< TDD-UL-Code-InformationItem-ExtIEs >-----#
    TDD_UL_Code_InformationItem_ExtIEs = CLASS(name='TDD-UL-Code-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TDD_UL_Code_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-UL-Code-LCR-Information >-----#
    TDD_UL_Code_LCR_Information = SEQ_OF(name='TDD-UL-Code-LCR-Information', mode=MODE_TYPE)
    _TDD_UL_Code_LCR_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-Code-LCR-InformationItem')))
    TDD_UL_Code_LCR_Information._cont = _TDD_UL_Code_LCR_Information__item_
    TDD_UL_Code_LCR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-UL-Code-LCR-InformationItem >-----#
    TDD_UL_Code_LCR_InformationItem = SEQ(name='TDD-UL-Code-LCR-InformationItem', mode=MODE_TYPE)
    _TDD_UL_Code_LCR_InformationItem_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _TDD_UL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _TDD_UL_Code_LCR_InformationItem_tdd_UL_DPCH_TimeSlotFormat_LCR = CHOICE(name='tdd-UL-DPCH-TimeSlotFormat-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-DPCH-TimeSlotFormat-LCR')))
    _TDD_UL_Code_LCR_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_UL_Code_LCR_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab = ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id_tab
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab = ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_UL_Code_LCR_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id),
        ('criticality', ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_UL_Code_LCR_InformationItem_iE_Extensions__item_._ext = None
    _TDD_UL_Code_LCR_InformationItem_iE_Extensions._cont = __TDD_UL_Code_LCR_InformationItem_iE_Extensions__item_
    _TDD_UL_Code_LCR_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_UL_Code_LCR_InformationItem._cont = ASN1Dict([
        ('dPCH-ID', _TDD_UL_Code_LCR_InformationItem_dPCH_ID),
        ('tdd-ChannelisationCodeLCR', _TDD_UL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR),
        ('tdd-UL-DPCH-TimeSlotFormat-LCR', _TDD_UL_Code_LCR_InformationItem_tdd_UL_DPCH_TimeSlotFormat_LCR),
        ('iE-Extensions', _TDD_UL_Code_LCR_InformationItem_iE_Extensions),
        ])
    TDD_UL_Code_LCR_InformationItem._ext = []
    
    #-----< TDD-UL-Code-LCR-InformationItem-ExtIEs >-----#
    TDD_UL_Code_LCR_InformationItem_ExtIEs = CLASS(name='TDD-UL-Code-LCR-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TDD_UL_Code_LCR_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-UL-Code-768-Information >-----#
    TDD_UL_Code_768_Information = SEQ_OF(name='TDD-UL-Code-768-Information', mode=MODE_TYPE)
    _TDD_UL_Code_768_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-Code-768-InformationItem')))
    TDD_UL_Code_768_Information._cont = _TDD_UL_Code_768_Information__item_
    TDD_UL_Code_768_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-UL-Code-768-InformationItem >-----#
    TDD_UL_Code_768_InformationItem = SEQ(name='TDD-UL-Code-768-InformationItem', mode=MODE_TYPE)
    _TDD_UL_Code_768_InformationItem_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _TDD_UL_Code_768_InformationItem_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _TDD_UL_Code_768_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_UL_Code_768_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__id._const_tab = ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__id_tab
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__criticality._const_tab = ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__criticality_tab
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__extensionValue_tab
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_UL_Code_768_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__id),
        ('criticality', ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_UL_Code_768_InformationItem_iE_Extensions__item_._ext = None
    _TDD_UL_Code_768_InformationItem_iE_Extensions._cont = __TDD_UL_Code_768_InformationItem_iE_Extensions__item_
    _TDD_UL_Code_768_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_UL_Code_768_InformationItem._cont = ASN1Dict([
        ('dPCH-ID', _TDD_UL_Code_768_InformationItem_dPCH_ID),
        ('tdd-ChannelisationCode768', _TDD_UL_Code_768_InformationItem_tdd_ChannelisationCode768),
        ('iE-Extensions', _TDD_UL_Code_768_InformationItem_iE_Extensions),
        ])
    TDD_UL_Code_768_InformationItem._ext = []
    
    #-----< TDD-UL-Code-768-InformationItem-ExtIEs >-----#
    TDD_UL_Code_768_InformationItem_ExtIEs = CLASS(name='TDD-UL-Code-768-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TDD_UL_Code_768_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-UL-DPCH-TimeSlotFormat-LCR >-----#
    TDD_UL_DPCH_TimeSlotFormat_LCR = CHOICE(name='TDD-UL-DPCH-TimeSlotFormat-LCR', mode=MODE_TYPE)
    _TDD_UL_DPCH_TimeSlotFormat_LCR_qPSK = INT(name='qPSK', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'QPSK-UL-DPCH-TimeSlotFormatTDD-LCR')))
    _TDD_UL_DPCH_TimeSlotFormat_LCR_eightPSK = INT(name='eightPSK', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'EightPSK-UL-DPCH-TimeSlotFormatTDD-LCR')))
    TDD_UL_DPCH_TimeSlotFormat_LCR._cont = ASN1Dict([
        ('qPSK', _TDD_UL_DPCH_TimeSlotFormat_LCR_qPSK),
        ('eightPSK', _TDD_UL_DPCH_TimeSlotFormat_LCR_eightPSK),
        ])
    TDD_UL_DPCH_TimeSlotFormat_LCR._ext = []
    
    #-----< QPSK-UL-DPCH-TimeSlotFormatTDD-LCR >-----#
    QPSK_UL_DPCH_TimeSlotFormatTDD_LCR = INT(name='QPSK-UL-DPCH-TimeSlotFormatTDD-LCR', mode=MODE_TYPE)
    QPSK_UL_DPCH_TimeSlotFormatTDD_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=69)], ev=[], er=[])
    
    #-----< EightPSK-UL-DPCH-TimeSlotFormatTDD-LCR >-----#
    EightPSK_UL_DPCH_TimeSlotFormatTDD_LCR = INT(name='EightPSK-UL-DPCH-TimeSlotFormatTDD-LCR', mode=MODE_TYPE)
    EightPSK_UL_DPCH_TimeSlotFormatTDD_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=24)], ev=[], er=[])
    
    #-----< TFCI-Coding >-----#
    TFCI_Coding = ENUM(name='TFCI-Coding', mode=MODE_TYPE)
    TFCI_Coding._cont = ASN1Dict([('v4', 0), ('v8', 1), ('v16', 2), ('v32', 3)])
    TFCI_Coding._ext = []
    
    #-----< TFCI-Presence >-----#
    TFCI_Presence = ENUM(name='TFCI-Presence', mode=MODE_TYPE)
    TFCI_Presence._cont = ASN1Dict([('present', 0), ('not-present', 1)])
    TFCI_Presence._ext = None
    
    #-----< TFCI-SignallingMode >-----#
    TFCI_SignallingMode = SEQ(name='TFCI-SignallingMode', mode=MODE_TYPE)
    _TFCI_SignallingMode_tFCI_SignallingOption = ENUM(name='tFCI-SignallingOption', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-SignallingMode-TFCI-SignallingOption')))
    _TFCI_SignallingMode_not_Used_splitType = NULL(name='not-Used-splitType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFCI_SignallingMode_not_Used_lengthOfTFCI2 = NULL(name='not-Used-lengthOfTFCI2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFCI_SignallingMode_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TFCI_SignallingMode_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TFCI_SignallingMode_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TFCI_SignallingMode_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TFCI_SignallingMode_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TFCI_SignallingMode_iE_Extensions__item__id._const_tab = ____TFCI_SignallingMode_iE_Extensions__item__id_tab
    ___TFCI_SignallingMode_iE_Extensions__item__id._const_tab_at = None
    ___TFCI_SignallingMode_iE_Extensions__item__id._const_tab_id = 'id'
    ___TFCI_SignallingMode_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TFCI_SignallingMode_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TFCI_SignallingMode_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TFCI_SignallingMode_iE_Extensions__item__criticality._const_tab = ____TFCI_SignallingMode_iE_Extensions__item__criticality_tab
    ___TFCI_SignallingMode_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TFCI_SignallingMode_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TFCI_SignallingMode_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TFCI_SignallingMode_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TFCI_SignallingMode_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TFCI_SignallingMode_iE_Extensions__item__extensionValue._const_tab = ____TFCI_SignallingMode_iE_Extensions__item__extensionValue_tab
    ___TFCI_SignallingMode_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TFCI_SignallingMode_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TFCI_SignallingMode_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TFCI_SignallingMode_iE_Extensions__item__id),
        ('criticality', ___TFCI_SignallingMode_iE_Extensions__item__criticality),
        ('extensionValue', ___TFCI_SignallingMode_iE_Extensions__item__extensionValue),
        ])
    __TFCI_SignallingMode_iE_Extensions__item_._ext = None
    _TFCI_SignallingMode_iE_Extensions._cont = __TFCI_SignallingMode_iE_Extensions__item_
    _TFCI_SignallingMode_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TFCI_SignallingMode._cont = ASN1Dict([
        ('tFCI-SignallingOption', _TFCI_SignallingMode_tFCI_SignallingOption),
        ('not-Used-splitType', _TFCI_SignallingMode_not_Used_splitType),
        ('not-Used-lengthOfTFCI2', _TFCI_SignallingMode_not_Used_lengthOfTFCI2),
        ('iE-Extensions', _TFCI_SignallingMode_iE_Extensions),
        ])
    TFCI_SignallingMode._ext = []
    
    #-----< TFCI-SignallingMode-ExtIEs >-----#
    TFCI_SignallingMode_ExtIEs = CLASS(name='TFCI-SignallingMode-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TFCI_SignallingMode_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TFCI-SignallingMode-TFCI-SignallingOption >-----#
    TFCI_SignallingMode_TFCI_SignallingOption = ENUM(name='TFCI-SignallingMode-TFCI-SignallingOption', mode=MODE_TYPE)
    TFCI_SignallingMode_TFCI_SignallingOption._cont = ASN1Dict([('normal', 0), ('not-Used-split', 1)])
    TFCI_SignallingMode_TFCI_SignallingOption._ext = None
    
    #-----< TGD >-----#
    TGD = INT(name='TGD', mode=MODE_TYPE)
    TGD._const_val = ASN1Set(rv=[0], rr=[ASN1RangeInt(lb=15, ub=269)], ev=None, er=[])
    
    #-----< TGPRC >-----#
    TGPRC = INT(name='TGPRC', mode=MODE_TYPE)
    TGPRC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< TGPSID >-----#
    TGPSID = INT(name='TGPSID', mode=MODE_TYPE)
    TGPSID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< TGSN >-----#
    TGSN = INT(name='TGSN', mode=MODE_TYPE)
    TGSN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< TimeSlot >-----#
    TimeSlot = INT(name='TimeSlot', mode=MODE_TYPE)
    TimeSlot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< TimeSlotDirection >-----#
    TimeSlotDirection = ENUM(name='TimeSlotDirection', mode=MODE_TYPE)
    TimeSlotDirection._cont = ASN1Dict([('ul', 0), ('dl', 1)])
    TimeSlotDirection._ext = []
    
    #-----< TimeSlot-InitiatedListLCR >-----#
    TimeSlot_InitiatedListLCR = SEQ_OF(name='TimeSlot-InitiatedListLCR', mode=MODE_TYPE)
    _TimeSlot_InitiatedListLCR__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    TimeSlot_InitiatedListLCR._cont = _TimeSlot_InitiatedListLCR__item_
    TimeSlot_InitiatedListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< TimeSlotLCR >-----#
    TimeSlotLCR = INT(name='TimeSlotLCR', mode=MODE_TYPE)
    TimeSlotLCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< TimeslotLCR-Extension >-----#
    TimeslotLCR_Extension = ENUM(name='TimeslotLCR-Extension', mode=MODE_TYPE)
    TimeslotLCR_Extension._cont = ASN1Dict([('ts7', 0)])
    TimeslotLCR_Extension._ext = []
    
    #-----< TimeSlotMeasurementValueListLCR >-----#
    TimeSlotMeasurementValueListLCR = SEQ_OF(name='TimeSlotMeasurementValueListLCR', mode=MODE_TYPE)
    _TimeSlotMeasurementValueListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotMeasurementValueLCR')))
    TimeSlotMeasurementValueListLCR._cont = _TimeSlotMeasurementValueListLCR__item_
    TimeSlotMeasurementValueListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< TimeSlotMeasurementValueLCR >-----#
    TimeSlotMeasurementValueLCR = SEQ(name='TimeSlotMeasurementValueLCR', mode=MODE_TYPE)
    _TimeSlotMeasurementValueLCR_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _TimeSlotMeasurementValueLCR_commonMeasurementValue = CHOICE(name='commonMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementValue')))
    _TimeSlotMeasurementValueLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeSlotMeasurementValueLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TimeSlotMeasurementValueLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TimeSlotMeasurementValueLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__id._const_tab = ____TimeSlotMeasurementValueLCR_iE_Extensions__item__id_tab
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__id._const_tab_at = None
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TimeSlotMeasurementValueLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TimeSlotMeasurementValueLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__criticality._const_tab = ____TimeSlotMeasurementValueLCR_iE_Extensions__item__criticality_tab
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TimeSlotMeasurementValueLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TimeSlotMeasurementValueLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__extensionValue._const_tab = ____TimeSlotMeasurementValueLCR_iE_Extensions__item__extensionValue_tab
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimeSlotMeasurementValueLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TimeSlotMeasurementValueLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TimeSlotMeasurementValueLCR_iE_Extensions__item__id),
        ('criticality', ___TimeSlotMeasurementValueLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___TimeSlotMeasurementValueLCR_iE_Extensions__item__extensionValue),
        ])
    __TimeSlotMeasurementValueLCR_iE_Extensions__item_._ext = None
    _TimeSlotMeasurementValueLCR_iE_Extensions._cont = __TimeSlotMeasurementValueLCR_iE_Extensions__item_
    _TimeSlotMeasurementValueLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeSlotMeasurementValueLCR._cont = ASN1Dict([
        ('timeSlotLCR', _TimeSlotMeasurementValueLCR_timeSlotLCR),
        ('commonMeasurementValue', _TimeSlotMeasurementValueLCR_commonMeasurementValue),
        ('iE-Extensions', _TimeSlotMeasurementValueLCR_iE_Extensions),
        ])
    TimeSlotMeasurementValueLCR._ext = []
    
    #-----< TimeSlotMeasurementValueListLCR-ExtIEs >-----#
    TimeSlotMeasurementValueListLCR_ExtIEs = CLASS(name='TimeSlotMeasurementValueListLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TimeSlotMeasurementValueListLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeSlotStatus >-----#
    TimeSlotStatus = ENUM(name='TimeSlotStatus', mode=MODE_TYPE)
    TimeSlotStatus._cont = ASN1Dict([('active', 0), ('not-active', 1)])
    TimeSlotStatus._ext = []
    
    #-----< TimingAdjustmentValue >-----#
    TimingAdjustmentValue = CHOICE(name='TimingAdjustmentValue', mode=MODE_TYPE)
    _TimingAdjustmentValue_initialPhase = INT(name='initialPhase', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimingAdjustmentValue_initialPhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=[], er=[])
    _TimingAdjustmentValue_steadyStatePhase = INT(name='steadyStatePhase', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimingAdjustmentValue_steadyStatePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    TimingAdjustmentValue._cont = ASN1Dict([
        ('initialPhase', _TimingAdjustmentValue_initialPhase),
        ('steadyStatePhase', _TimingAdjustmentValue_steadyStatePhase),
        ])
    TimingAdjustmentValue._ext = None
    
    #-----< TimingAdjustmentValueLCR >-----#
    TimingAdjustmentValueLCR = CHOICE(name='TimingAdjustmentValueLCR', mode=MODE_TYPE)
    _TimingAdjustmentValueLCR_initialPhase = INT(name='initialPhase', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimingAdjustmentValueLCR_initialPhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=524287)], ev=[], er=[])
    _TimingAdjustmentValueLCR_steadyStatePhase = INT(name='steadyStatePhase', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimingAdjustmentValueLCR_steadyStatePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    TimingAdjustmentValueLCR._cont = ASN1Dict([
        ('initialPhase', _TimingAdjustmentValueLCR_initialPhase),
        ('steadyStatePhase', _TimingAdjustmentValueLCR_steadyStatePhase),
        ])
    TimingAdjustmentValueLCR._ext = None
    
    #-----< TimingAdvanceApplied >-----#
    TimingAdvanceApplied = ENUM(name='TimingAdvanceApplied', mode=MODE_TYPE)
    TimingAdvanceApplied._cont = ASN1Dict([('yes', 0), ('no', 1)])
    TimingAdvanceApplied._ext = None
    
    #-----< SynchronisationIndicator >-----#
    SynchronisationIndicator = ENUM(name='SynchronisationIndicator', mode=MODE_TYPE)
    SynchronisationIndicator._cont = ASN1Dict([('timingMaintainedSynchronisation', 0)])
    SynchronisationIndicator._ext = []
    
    #-----< TnlQos >-----#
    TnlQos = CHOICE(name='TnlQos', mode=MODE_TYPE)
    _TnlQos_dsField = BIT_STR(name='dsField', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DsField')))
    _TnlQos_genericTrafficCategory = BIT_STR(name='genericTrafficCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GenericTrafficCategory')))
    TnlQos._cont = ASN1Dict([
        ('dsField', _TnlQos_dsField),
        ('genericTrafficCategory', _TnlQos_genericTrafficCategory),
        ])
    TnlQos._ext = []
    
    #-----< ToAWE >-----#
    ToAWE = INT(name='ToAWE', mode=MODE_TYPE)
    ToAWE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2559)], ev=None, er=[])
    
    #-----< ToAWS >-----#
    ToAWS = INT(name='ToAWS', mode=MODE_TYPE)
    ToAWS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1279)], ev=None, er=[])
    
    #-----< Transmission-Gap-Pattern-Sequence-Information >-----#
    Transmission_Gap_Pattern_Sequence_Information = SEQ_OF(name='Transmission-Gap-Pattern-Sequence-Information', mode=MODE_TYPE)
    _Transmission_Gap_Pattern_Sequence_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Transmission_Gap_Pattern_Sequence_Information__item__tGPSID = INT(name='tGPSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TGPSID')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGSN = INT(name='tGSN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TGSN')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGL1 = INT(name='tGL1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GapLength')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGL2 = INT(name='tGL2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GapLength')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__tGD = INT(name='tGD', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TGD')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGPL1 = INT(name='tGPL1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GapDuration')))
    __Transmission_Gap_Pattern_Sequence_Information__item__not_to_be_used_1 = INT(name='not-to-be-used-1', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'GapDuration')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__uL_DL_mode = ENUM(name='uL-DL-mode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-DL-mode')))
    __Transmission_Gap_Pattern_Sequence_Information__item__downlink_Compressed_Mode_Method = ENUM(name='downlink-Compressed-Mode-Method', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Downlink-Compressed-Mode-Method')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__uplink_Compressed_Mode_Method = ENUM(name='uplink-Compressed-Mode-Method', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Uplink-Compressed-Mode-Method')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__dL_FrameType = ENUM(name='dL-FrameType', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-FrameType')))
    __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR1 = INT(name='delta-SIR1', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DeltaSIR')))
    __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after1 = INT(name='delta-SIR-after1', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DeltaSIR')))
    __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR2 = INT(name='delta-SIR2', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DeltaSIR')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after2 = INT(name='delta-SIR-after2', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DeltaSIR')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id._const_tab = _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id._const_tab_at = None
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality._const_tab = _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue._const_tab = _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id),
        ('criticality', ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality),
        ('extensionValue', ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue),
        ])
    ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_._ext = None
    __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions._cont = ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_
    __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Transmission_Gap_Pattern_Sequence_Information__item_._cont = ASN1Dict([
        ('tGPSID', __Transmission_Gap_Pattern_Sequence_Information__item__tGPSID),
        ('tGSN', __Transmission_Gap_Pattern_Sequence_Information__item__tGSN),
        ('tGL1', __Transmission_Gap_Pattern_Sequence_Information__item__tGL1),
        ('tGL2', __Transmission_Gap_Pattern_Sequence_Information__item__tGL2),
        ('tGD', __Transmission_Gap_Pattern_Sequence_Information__item__tGD),
        ('tGPL1', __Transmission_Gap_Pattern_Sequence_Information__item__tGPL1),
        ('not-to-be-used-1', __Transmission_Gap_Pattern_Sequence_Information__item__not_to_be_used_1),
        ('uL-DL-mode', __Transmission_Gap_Pattern_Sequence_Information__item__uL_DL_mode),
        ('downlink-Compressed-Mode-Method', __Transmission_Gap_Pattern_Sequence_Information__item__downlink_Compressed_Mode_Method),
        ('uplink-Compressed-Mode-Method', __Transmission_Gap_Pattern_Sequence_Information__item__uplink_Compressed_Mode_Method),
        ('dL-FrameType', __Transmission_Gap_Pattern_Sequence_Information__item__dL_FrameType),
        ('delta-SIR1', __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR1),
        ('delta-SIR-after1', __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after1),
        ('delta-SIR2', __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR2),
        ('delta-SIR-after2', __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after2),
        ('iE-Extensions', __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions),
        ])
    _Transmission_Gap_Pattern_Sequence_Information__item_._ext = []
    Transmission_Gap_Pattern_Sequence_Information._cont = _Transmission_Gap_Pattern_Sequence_Information__item_
    Transmission_Gap_Pattern_Sequence_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< Transmission-Gap-Pattern-Sequence-Information-ExtIEs >-----#
    Transmission_Gap_Pattern_Sequence_Information_ExtIEs = CLASS(name='Transmission-Gap-Pattern-Sequence-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Transmission_Gap_Pattern_Sequence_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionGapPatternSequenceCodeInformation >-----#
    TransmissionGapPatternSequenceCodeInformation = ENUM(name='TransmissionGapPatternSequenceCodeInformation', mode=MODE_TYPE)
    TransmissionGapPatternSequenceCodeInformation._cont = ASN1Dict([('code-change', 0), ('nocode-change', 1)])
    TransmissionGapPatternSequenceCodeInformation._ext = None
    
    #-----< TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue >-----#
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue = SEQ_OF(name='TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue', mode=MODE_TYPE)
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue-Item')))
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue._cont = _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue__item_
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue-Item >-----#
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item = SEQ(name='TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue-Item', mode=MODE_TYPE)
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_cellPortionID = INT(name='cellPortionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionID')))
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_transmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue = INT(name='transmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id._const_tab = ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id_tab
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id._const_tab_at = None
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality._const_tab = ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality_tab
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue._const_tab = ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue_tab
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id),
        ('criticality', ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue),
        ])
    __TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item_._ext = None
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions._cont = __TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item_
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item._cont = ASN1Dict([
        ('cellPortionID', _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_cellPortionID),
        ('transmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue', _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_transmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue),
        ('iE-Extensions', _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions),
        ])
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item._ext = []
    
    #-----< TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue-Item-ExtIEs >-----#
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_ExtIEs = CLASS(name='TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCH-E-RGCHOrE-HICHTransmissionCellPortionValue-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue >-----#
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue = SEQ_OF(name='TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue', mode=MODE_TYPE)
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue-Item')))
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue._cont = _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue__item_
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue-Item >-----#
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item = SEQ(name='TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue-Item', mode=MODE_TYPE)
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_transmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue = INT(name='transmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue')))
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id._const_tab = ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id_tab
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id._const_tab_at = None
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality._const_tab = ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality_tab
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue._const_tab = ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue_tab
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id),
        ('criticality', ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue),
        ])
    __TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item_._ext = None
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions._cont = __TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item_
    _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item._cont = ASN1Dict([
        ('cellPortionLCRID', _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_cellPortionLCRID),
        ('transmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue', _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_transmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue),
        ('iE-Extensions', _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions),
        ])
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item._ext = []
    
    #-----< TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue-Item-ExtIEs >-----#
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_ExtIEs = CLASS(name='TransmittedCarrierPowerOfAllCodesNotUsedForHS-PDSCH-HS-SCCH-E-AGCHOrE-HICHTransmissionCellPortionValue-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue >-----#
    TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue = INT(name='TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue', mode=MODE_TYPE)
    TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< Transmitted-Carrier-Power-For-CellPortion-Value >-----#
    Transmitted_Carrier_Power_For_CellPortion_Value = SEQ_OF(name='Transmitted-Carrier-Power-For-CellPortion-Value', mode=MODE_TYPE)
    _Transmitted_Carrier_Power_For_CellPortion_Value__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-For-CellPortion-Value-Item')))
    Transmitted_Carrier_Power_For_CellPortion_Value._cont = _Transmitted_Carrier_Power_For_CellPortion_Value__item_
    Transmitted_Carrier_Power_For_CellPortion_Value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Transmitted-Carrier-Power-For-CellPortion-Value-Item >-----#
    Transmitted_Carrier_Power_For_CellPortion_Value_Item = SEQ(name='Transmitted-Carrier-Power-For-CellPortion-Value-Item', mode=MODE_TYPE)
    _Transmitted_Carrier_Power_For_CellPortion_Value_Item_cellPortionID = INT(name='cellPortionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionID')))
    _Transmitted_Carrier_Power_For_CellPortion_Value_Item_transmitted_Carrier_Power_Value = INT(name='transmitted-Carrier-Power-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-Value')))
    _Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab = ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__id_tab
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab_at = None
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab = ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab = ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__id),
        ('criticality', ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue),
        ])
    __Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item_._ext = None
    _Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions._cont = __Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item_
    _Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transmitted_Carrier_Power_For_CellPortion_Value_Item._cont = ASN1Dict([
        ('cellPortionID', _Transmitted_Carrier_Power_For_CellPortion_Value_Item_cellPortionID),
        ('transmitted-Carrier-Power-Value', _Transmitted_Carrier_Power_For_CellPortion_Value_Item_transmitted_Carrier_Power_Value),
        ('iE-Extensions', _Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions),
        ])
    Transmitted_Carrier_Power_For_CellPortion_Value_Item._ext = []
    
    #-----< Transmitted-Carrier-Power-For-CellPortion-Value-Item-ExtIEs >-----#
    Transmitted_Carrier_Power_For_CellPortion_Value_Item_ExtIEs = CLASS(name='Transmitted-Carrier-Power-For-CellPortion-Value-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Transmitted_Carrier_Power_For_CellPortion_Value_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transmitted-Carrier-Power-For-CellPortion-ValueLCR >-----#
    Transmitted_Carrier_Power_For_CellPortion_ValueLCR = SEQ_OF(name='Transmitted-Carrier-Power-For-CellPortion-ValueLCR', mode=MODE_TYPE)
    _Transmitted_Carrier_Power_For_CellPortion_ValueLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-For-CellPortion-ValueLCR-Item')))
    Transmitted_Carrier_Power_For_CellPortion_ValueLCR._cont = _Transmitted_Carrier_Power_For_CellPortion_ValueLCR__item_
    Transmitted_Carrier_Power_For_CellPortion_ValueLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Transmitted-Carrier-Power-For-CellPortion-ValueLCR-Item >-----#
    Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item = SEQ(name='Transmitted-Carrier-Power-For-CellPortion-ValueLCR-Item', mode=MODE_TYPE)
    _Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_transmitted_Carrier_Power_Value = INT(name='transmitted-Carrier-Power-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transmitted-Carrier-Power-Value')))
    _Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id._const_tab = ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id_tab
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id._const_tab_at = None
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality._const_tab = ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality_tab
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue._const_tab = ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue_tab
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id),
        ('criticality', ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue),
        ])
    __Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item_._ext = None
    _Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions._cont = __Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item_
    _Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item._cont = ASN1Dict([
        ('cellPortionLCRID', _Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_cellPortionLCRID),
        ('transmitted-Carrier-Power-Value', _Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_transmitted_Carrier_Power_Value),
        ('iE-Extensions', _Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions),
        ])
    Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item._ext = []
    
    #-----< Transmitted-Carrier-Power-For-CellPortion-ValueLCR-Item-ExtIEs >-----#
    Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_ExtIEs = CLASS(name='Transmitted-Carrier-Power-For-CellPortion-ValueLCR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transmitted-Carrier-Power-Value >-----#
    Transmitted_Carrier_Power_Value = INT(name='Transmitted-Carrier-Power-Value', mode=MODE_TYPE)
    Transmitted_Carrier_Power_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< Transmitted-Code-Power-Value >-----#
    Transmitted_Code_Power_Value = INT(name='Transmitted-Code-Power-Value', mode=MODE_TYPE)
    Transmitted_Code_Power_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< Transmitted-Code-Power-Value-IncrDecrThres >-----#
    Transmitted_Code_Power_Value_IncrDecrThres = INT(name='Transmitted-Code-Power-Value-IncrDecrThres', mode=MODE_TYPE)
    Transmitted_Code_Power_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=112)], ev=[], er=[])
    
    #-----< TransmissionDiversityApplied >-----#
    TransmissionDiversityApplied = BOOL(name='TransmissionDiversityApplied', mode=MODE_TYPE)
    
    #-----< TransmitDiversityIndicator >-----#
    TransmitDiversityIndicator = ENUM(name='TransmitDiversityIndicator', mode=MODE_TYPE)
    TransmitDiversityIndicator._cont = ASN1Dict([('active', 0), ('inactive', 1)])
    TransmitDiversityIndicator._ext = None
    
    #-----< TFCS >-----#
    TFCS = SEQ(name='TFCS', mode=MODE_TYPE)
    _TFCS_tFCSvalues = CHOICE(name='tFCSvalues', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __TFCS_tFCSvalues_no_Split_in_TFCI = SEQ_OF(name='no-Split-in-TFCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS-TFCSList')))
    __TFCS_tFCSvalues_not_Used_split_in_TFCI = NULL(name='not-Used-split-in-TFCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_tFCSvalues._cont = ASN1Dict([
        ('no-Split-in-TFCI', __TFCS_tFCSvalues_no_Split_in_TFCI),
        ('not-Used-split-in-TFCI', __TFCS_tFCSvalues_not_Used_split_in_TFCI),
        ])
    _TFCS_tFCSvalues._ext = []
    _TFCS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TFCS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TFCS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TFCS_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TFCS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TFCS_iE_Extensions__item__id._const_tab = ____TFCS_iE_Extensions__item__id_tab
    ___TFCS_iE_Extensions__item__id._const_tab_at = None
    ___TFCS_iE_Extensions__item__id._const_tab_id = 'id'
    ___TFCS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TFCS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TFCS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TFCS_iE_Extensions__item__criticality._const_tab = ____TFCS_iE_Extensions__item__criticality_tab
    ___TFCS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TFCS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TFCS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TFCS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TFCS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TFCS_iE_Extensions__item__extensionValue._const_tab = ____TFCS_iE_Extensions__item__extensionValue_tab
    ___TFCS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TFCS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TFCS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TFCS_iE_Extensions__item__id),
        ('criticality', ___TFCS_iE_Extensions__item__criticality),
        ('extensionValue', ___TFCS_iE_Extensions__item__extensionValue),
        ])
    __TFCS_iE_Extensions__item_._ext = None
    _TFCS_iE_Extensions._cont = __TFCS_iE_Extensions__item_
    _TFCS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TFCS._cont = ASN1Dict([
        ('tFCSvalues', _TFCS_tFCSvalues),
        ('iE-Extensions', _TFCS_iE_Extensions),
        ])
    TFCS._ext = []
    
    #-----< TFCS-ExtIEs >-----#
    TFCS_ExtIEs = CLASS(name='TFCS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TFCS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TFCS-TFCSList >-----#
    TFCS_TFCSList = SEQ_OF(name='TFCS-TFCSList', mode=MODE_TYPE)
    _TFCS_TFCSList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __TFCS_TFCSList__item__cTFC = CHOICE(name='cTFC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS-CTFC')))
    __TFCS_TFCSList__item__tFC_Beta = CHOICE(name='tFC-Beta', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatCombination-Beta')), opt=True)
    __TFCS_TFCSList__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___TFCS_TFCSList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____TFCS_TFCSList__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____TFCS_TFCSList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ______TFCS_TFCSList__item__iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Gainfactors-10ms-mode')))
    _____TFCS_TFCSList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1294), ('criticality', 'reject'), ('Extension', ______TFCS_TFCSList__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ____TFCS_TFCSList__item__iE_Extensions__item__id._const_tab = _____TFCS_TFCSList__item__iE_Extensions__item__id_tab
    ____TFCS_TFCSList__item__iE_Extensions__item__id._const_tab_at = None
    ____TFCS_TFCSList__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____TFCS_TFCSList__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TFCS_TFCSList__item__iE_Extensions__item__criticality._const_tab = _____TFCS_TFCSList__item__iE_Extensions__item__id_tab
    ____TFCS_TFCSList__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____TFCS_TFCSList__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue._const_tab = _____TFCS_TFCSList__item__iE_Extensions__item__id_tab
    ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___TFCS_TFCSList__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____TFCS_TFCSList__item__iE_Extensions__item__id),
        ('criticality', ____TFCS_TFCSList__item__iE_Extensions__item__criticality),
        ('extensionValue', ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue),
        ])
    ___TFCS_TFCSList__item__iE_Extensions__item_._ext = None
    __TFCS_TFCSList__item__iE_Extensions._cont = ___TFCS_TFCSList__item__iE_Extensions__item_
    __TFCS_TFCSList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TFCS_TFCSList__item_._cont = ASN1Dict([
        ('cTFC', __TFCS_TFCSList__item__cTFC),
        ('tFC-Beta', __TFCS_TFCSList__item__tFC_Beta),
        ('iE-Extensions', __TFCS_TFCSList__item__iE_Extensions),
        ])
    _TFCS_TFCSList__item_._ext = []
    TFCS_TFCSList._cont = _TFCS_TFCSList__item_
    TFCS_TFCSList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< TFCS-TFCSList-ExtIEs >-----#
    TFCS_TFCSList_ExtIEs = CLASS(name='TFCS-TFCSList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _TFCS_TFCSList_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Gainfactors-10ms-mode')))
    TFCS_TFCSList_ExtIEs._val = ASN1Set(rv=[dict([('id', 1294), ('criticality', 'reject'), ('Extension', _TFCS_TFCSList_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TFCS-CTFC >-----#
    TFCS_CTFC = CHOICE(name='TFCS-CTFC', mode=MODE_TYPE)
    _TFCS_CTFC_ctfc2bit = INT(name='ctfc2bit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc2bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _TFCS_CTFC_ctfc4bit = INT(name='ctfc4bit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc4bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _TFCS_CTFC_ctfc6bit = INT(name='ctfc6bit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc6bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _TFCS_CTFC_ctfc8bit = INT(name='ctfc8bit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc8bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TFCS_CTFC_ctfc12bit = INT(name='ctfc12bit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc12bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _TFCS_CTFC_ctfc16bit = INT(name='ctfc16bit', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc16bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _TFCS_CTFC_ctfcmaxbit = INT(name='ctfcmaxbit', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfcmaxbit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    TFCS_CTFC._cont = ASN1Dict([
        ('ctfc2bit', _TFCS_CTFC_ctfc2bit),
        ('ctfc4bit', _TFCS_CTFC_ctfc4bit),
        ('ctfc6bit', _TFCS_CTFC_ctfc6bit),
        ('ctfc8bit', _TFCS_CTFC_ctfc8bit),
        ('ctfc12bit', _TFCS_CTFC_ctfc12bit),
        ('ctfc16bit', _TFCS_CTFC_ctfc16bit),
        ('ctfcmaxbit', _TFCS_CTFC_ctfcmaxbit),
        ])
    TFCS_CTFC._ext = None
    
    #-----< TPC-slot-position >-----#
    TPC_slot_position = SEQ(name='TPC-slot-position', mode=MODE_TYPE)
    _TPC_slot_position_slot_position = INT(name='slot-position', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TPC_slot_position_slot_position._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    _TPC_slot_position_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TPC_slot_position_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TPC_slot_position_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TPC_slot_position_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TPC_slot_position_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TPC_slot_position_iE_Extensions__item__id._const_tab = ____TPC_slot_position_iE_Extensions__item__id_tab
    ___TPC_slot_position_iE_Extensions__item__id._const_tab_at = None
    ___TPC_slot_position_iE_Extensions__item__id._const_tab_id = 'id'
    ___TPC_slot_position_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TPC_slot_position_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TPC_slot_position_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TPC_slot_position_iE_Extensions__item__criticality._const_tab = ____TPC_slot_position_iE_Extensions__item__criticality_tab
    ___TPC_slot_position_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TPC_slot_position_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TPC_slot_position_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TPC_slot_position_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TPC_slot_position_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TPC_slot_position_iE_Extensions__item__extensionValue._const_tab = ____TPC_slot_position_iE_Extensions__item__extensionValue_tab
    ___TPC_slot_position_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TPC_slot_position_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TPC_slot_position_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TPC_slot_position_iE_Extensions__item__id),
        ('criticality', ___TPC_slot_position_iE_Extensions__item__criticality),
        ('extensionValue', ___TPC_slot_position_iE_Extensions__item__extensionValue),
        ])
    __TPC_slot_position_iE_Extensions__item_._ext = None
    _TPC_slot_position_iE_Extensions._cont = __TPC_slot_position_iE_Extensions__item_
    _TPC_slot_position_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TPC_slot_position._cont = ASN1Dict([
        ('slot-position', _TPC_slot_position_slot_position),
        ('iE-Extensions', _TPC_slot_position_iE_Extensions),
        ])
    TPC_slot_position._ext = []
    
    #-----< TPC-slot-position-ExtIEs >-----#
    TPC_slot_position_ExtIEs = CLASS(name='TPC-slot-position-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TPC_slot_position_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transport-Block-Size-Index >-----#
    Transport_Block_Size_Index = INT(name='Transport-Block-Size-Index', mode=MODE_TYPE)
    Transport_Block_Size_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=90)], ev=None, er=[])
    
    #-----< Transport-Block-Size-Index-for-Enhanced-PCH >-----#
    Transport_Block_Size_Index_for_Enhanced_PCH = INT(name='Transport-Block-Size-Index-for-Enhanced-PCH', mode=MODE_TYPE)
    Transport_Block_Size_Index_for_Enhanced_PCH._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Transport-Block-Size-List >-----#
    Transport_Block_Size_List = SEQ_OF(name='Transport-Block-Size-List', mode=MODE_TYPE)
    _Transport_Block_Size_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Transport_Block_Size_List__item__transport_Block_Size_Index_for_Enhanced_PCH = INT(name='transport-Block-Size-Index-for-Enhanced-PCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Transport-Block-Size-Index-for-Enhanced-PCH')))
    __Transport_Block_Size_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Transport_Block_Size_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____Transport_Block_Size_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____Transport_Block_Size_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Transport_Block_Size_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transport_Block_Size_List__item__iE_Extensions__item__id._const_tab = _____Transport_Block_Size_List__item__iE_Extensions__item__id_tab
    ____Transport_Block_Size_List__item__iE_Extensions__item__id._const_tab_at = None
    ____Transport_Block_Size_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____Transport_Block_Size_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____Transport_Block_Size_List__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Transport_Block_Size_List__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transport_Block_Size_List__item__iE_Extensions__item__criticality._const_tab = _____Transport_Block_Size_List__item__iE_Extensions__item__criticality_tab
    ____Transport_Block_Size_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Transport_Block_Size_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Transport_Block_Size_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____Transport_Block_Size_List__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Transport_Block_Size_List__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transport_Block_Size_List__item__iE_Extensions__item__extensionValue._const_tab = _____Transport_Block_Size_List__item__iE_Extensions__item__extensionValue_tab
    ____Transport_Block_Size_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Transport_Block_Size_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Transport_Block_Size_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____Transport_Block_Size_List__item__iE_Extensions__item__id),
        ('criticality', ____Transport_Block_Size_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____Transport_Block_Size_List__item__iE_Extensions__item__extensionValue),
        ])
    ___Transport_Block_Size_List__item__iE_Extensions__item_._ext = None
    __Transport_Block_Size_List__item__iE_Extensions._cont = ___Transport_Block_Size_List__item__iE_Extensions__item_
    __Transport_Block_Size_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Transport_Block_Size_List__item_._cont = ASN1Dict([
        ('transport-Block-Size-Index-for-Enhanced-PCH', __Transport_Block_Size_List__item__transport_Block_Size_Index_for_Enhanced_PCH),
        ('iE-Extensions', __Transport_Block_Size_List__item__iE_Extensions),
        ])
    _Transport_Block_Size_List__item_._ext = []
    Transport_Block_Size_List._cont = _Transport_Block_Size_List__item_
    Transport_Block_Size_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Transport-Block-Size-List-ExtIEs >-----#
    Transport_Block_Size_List_ExtIEs = CLASS(name='Transport-Block-Size-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Transport_Block_Size_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportBearerRequestIndicator >-----#
    TransportBearerRequestIndicator = ENUM(name='TransportBearerRequestIndicator', mode=MODE_TYPE)
    TransportBearerRequestIndicator._cont = ASN1Dict([('bearerRequested', 0), ('bearerNotRequested', 1)])
    TransportBearerRequestIndicator._ext = []
    
    #-----< TransportBearerNotRequestedIndicator >-----#
    TransportBearerNotRequestedIndicator = ENUM(name='TransportBearerNotRequestedIndicator', mode=MODE_TYPE)
    TransportBearerNotRequestedIndicator._cont = ASN1Dict([('transport-bearer-shall-not-be-established', 0), ('transport-bearer-may-not-be-established', 1)])
    TransportBearerNotRequestedIndicator._ext = None
    
    #-----< TransportBearerNotSetupIndicator >-----#
    TransportBearerNotSetupIndicator = ENUM(name='TransportBearerNotSetupIndicator', mode=MODE_TYPE)
    TransportBearerNotSetupIndicator._cont = ASN1Dict([('transport-bearer-not-setup', 0)])
    TransportBearerNotSetupIndicator._ext = None
    
    #-----< TransportFormatSet >-----#
    TransportFormatSet = SEQ(name='TransportFormatSet', mode=MODE_TYPE)
    _TransportFormatSet_dynamicParts = SEQ_OF(name='dynamicParts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-DynamicPartList')))
    _TransportFormatSet_semi_staticPart = SEQ(name='semi-staticPart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-Semi-staticPart')))
    _TransportFormatSet_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TransportFormatSet_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TransportFormatSet_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TransportFormatSet_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_iE_Extensions__item__id._const_tab = ____TransportFormatSet_iE_Extensions__item__id_tab
    ___TransportFormatSet_iE_Extensions__item__id._const_tab_at = None
    ___TransportFormatSet_iE_Extensions__item__id._const_tab_id = 'id'
    ___TransportFormatSet_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TransportFormatSet_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_iE_Extensions__item__criticality._const_tab = ____TransportFormatSet_iE_Extensions__item__criticality_tab
    ___TransportFormatSet_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TransportFormatSet_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TransportFormatSet_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TransportFormatSet_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_iE_Extensions__item__extensionValue._const_tab = ____TransportFormatSet_iE_Extensions__item__extensionValue_tab
    ___TransportFormatSet_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TransportFormatSet_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TransportFormatSet_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TransportFormatSet_iE_Extensions__item__id),
        ('criticality', ___TransportFormatSet_iE_Extensions__item__criticality),
        ('extensionValue', ___TransportFormatSet_iE_Extensions__item__extensionValue),
        ])
    __TransportFormatSet_iE_Extensions__item_._ext = None
    _TransportFormatSet_iE_Extensions._cont = __TransportFormatSet_iE_Extensions__item_
    _TransportFormatSet_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TransportFormatSet._cont = ASN1Dict([
        ('dynamicParts', _TransportFormatSet_dynamicParts),
        ('semi-staticPart', _TransportFormatSet_semi_staticPart),
        ('iE-Extensions', _TransportFormatSet_iE_Extensions),
        ])
    TransportFormatSet._ext = []
    
    #-----< TransportFormatSet-ExtIEs >-----#
    TransportFormatSet_ExtIEs = CLASS(name='TransportFormatSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TransportFormatSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportFormatSet-DynamicPartList >-----#
    TransportFormatSet_DynamicPartList = SEQ_OF(name='TransportFormatSet-DynamicPartList', mode=MODE_TYPE)
    _TransportFormatSet_DynamicPartList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __TransportFormatSet_DynamicPartList__item__nrOfTransportBlocks = INT(name='nrOfTransportBlocks', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-NrOfTransportBlocks')))
    __TransportFormatSet_DynamicPartList__item__transportBlockSize = INT(name='transportBlockSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-TransportBlockSize')), opt=True)
    __TransportFormatSet_DynamicPartList__item__mode = CHOICE(name='mode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-ModeDP')))
    __TransportFormatSet_DynamicPartList__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id._const_tab = _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id._const_tab_at = None
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality._const_tab = _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue._const_tab = _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id),
        ('criticality', ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality),
        ('extensionValue', ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue),
        ])
    ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_._ext = None
    __TransportFormatSet_DynamicPartList__item__iE_Extensions._cont = ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_
    __TransportFormatSet_DynamicPartList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TransportFormatSet_DynamicPartList__item_._cont = ASN1Dict([
        ('nrOfTransportBlocks', __TransportFormatSet_DynamicPartList__item__nrOfTransportBlocks),
        ('transportBlockSize', __TransportFormatSet_DynamicPartList__item__transportBlockSize),
        ('mode', __TransportFormatSet_DynamicPartList__item__mode),
        ('iE-Extensions', __TransportFormatSet_DynamicPartList__item__iE_Extensions),
        ])
    _TransportFormatSet_DynamicPartList__item_._ext = []
    TransportFormatSet_DynamicPartList._cont = _TransportFormatSet_DynamicPartList__item_
    TransportFormatSet_DynamicPartList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TransportFormatSet-DynamicPartList-ExtIEs >-----#
    TransportFormatSet_DynamicPartList_ExtIEs = CLASS(name='TransportFormatSet-DynamicPartList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TransportFormatSet_DynamicPartList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-TransportFormatSet-ModeDP >-----#
    TDD_TransportFormatSet_ModeDP = SEQ(name='TDD-TransportFormatSet-ModeDP', mode=MODE_TYPE)
    _TDD_TransportFormatSet_ModeDP_transmissionTimeIntervalInformation = SEQ_OF(name='transmissionTimeIntervalInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransmissionTimeIntervalInformation')), opt=True)
    _TDD_TransportFormatSet_ModeDP_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_TransportFormatSet_ModeDP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id._const_tab = ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id_tab
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id._const_tab_at = None
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality._const_tab = ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality_tab
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue._const_tab = ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue_tab
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_TransportFormatSet_ModeDP_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id),
        ('criticality', ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue),
        ])
    __TDD_TransportFormatSet_ModeDP_iE_Extensions__item_._ext = None
    _TDD_TransportFormatSet_ModeDP_iE_Extensions._cont = __TDD_TransportFormatSet_ModeDP_iE_Extensions__item_
    _TDD_TransportFormatSet_ModeDP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_TransportFormatSet_ModeDP._cont = ASN1Dict([
        ('transmissionTimeIntervalInformation', _TDD_TransportFormatSet_ModeDP_transmissionTimeIntervalInformation),
        ('iE-Extensions', _TDD_TransportFormatSet_ModeDP_iE_Extensions),
        ])
    TDD_TransportFormatSet_ModeDP._ext = []
    
    #-----< TDD-TransportFormatSet-ModeDP-ExtIEs >-----#
    TDD_TransportFormatSet_ModeDP_ExtIEs = CLASS(name='TDD-TransportFormatSet-ModeDP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TDD_TransportFormatSet_ModeDP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionTimeIntervalInformation >-----#
    TransmissionTimeIntervalInformation = SEQ_OF(name='TransmissionTimeIntervalInformation', mode=MODE_TYPE)
    _TransmissionTimeIntervalInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __TransmissionTimeIntervalInformation__item__transmissionTimeInterval = ENUM(name='transmissionTimeInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-TransmissionTimeIntervalDynamic')))
    __TransmissionTimeIntervalInformation__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___TransmissionTimeIntervalInformation__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id._const_tab = _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id_tab
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id._const_tab_at = None
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality._const_tab = _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality_tab
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue._const_tab = _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue_tab
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___TransmissionTimeIntervalInformation__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id),
        ('criticality', ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality),
        ('extensionValue', ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue),
        ])
    ___TransmissionTimeIntervalInformation__item__iE_Extensions__item_._ext = None
    __TransmissionTimeIntervalInformation__item__iE_Extensions._cont = ___TransmissionTimeIntervalInformation__item__iE_Extensions__item_
    __TransmissionTimeIntervalInformation__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TransmissionTimeIntervalInformation__item_._cont = ASN1Dict([
        ('transmissionTimeInterval', __TransmissionTimeIntervalInformation__item__transmissionTimeInterval),
        ('iE-Extensions', __TransmissionTimeIntervalInformation__item__iE_Extensions),
        ])
    _TransmissionTimeIntervalInformation__item_._ext = []
    TransmissionTimeIntervalInformation._cont = _TransmissionTimeIntervalInformation__item_
    TransmissionTimeIntervalInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< TransmissionTimeIntervalInformation-ExtIEs >-----#
    TransmissionTimeIntervalInformation_ExtIEs = CLASS(name='TransmissionTimeIntervalInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TransmissionTimeIntervalInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportFormatSet-Semi-staticPart >-----#
    TransportFormatSet_Semi_staticPart = SEQ(name='TransportFormatSet-Semi-staticPart', mode=MODE_TYPE)
    _TransportFormatSet_Semi_staticPart_transmissionTimeInterval = ENUM(name='transmissionTimeInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-TransmissionTimeIntervalSemiStatic')))
    _TransportFormatSet_Semi_staticPart_channelCoding = ENUM(name='channelCoding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-ChannelCodingType')))
    _TransportFormatSet_Semi_staticPart_codingRate = ENUM(name='codingRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-CodingRate')), opt=True)
    _TransportFormatSet_Semi_staticPart_rateMatchingAttribute = INT(name='rateMatchingAttribute', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-RateMatchingAttribute')))
    _TransportFormatSet_Semi_staticPart_cRC_Size = ENUM(name='cRC-Size', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-CRC-Size')))
    _TransportFormatSet_Semi_staticPart_mode = CHOICE(name='mode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-ModeSSP')))
    _TransportFormatSet_Semi_staticPart_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TransportFormatSet_Semi_staticPart_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id._const_tab = ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id._const_tab_at = None
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id._const_tab_id = 'id'
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality._const_tab = ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue._const_tab = ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TransportFormatSet_Semi_staticPart_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id),
        ('criticality', ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality),
        ('extensionValue', ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue),
        ])
    __TransportFormatSet_Semi_staticPart_iE_Extensions__item_._ext = None
    _TransportFormatSet_Semi_staticPart_iE_Extensions._cont = __TransportFormatSet_Semi_staticPart_iE_Extensions__item_
    _TransportFormatSet_Semi_staticPart_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TransportFormatSet_Semi_staticPart._cont = ASN1Dict([
        ('transmissionTimeInterval', _TransportFormatSet_Semi_staticPart_transmissionTimeInterval),
        ('channelCoding', _TransportFormatSet_Semi_staticPart_channelCoding),
        ('codingRate', _TransportFormatSet_Semi_staticPart_codingRate),
        ('rateMatchingAttribute', _TransportFormatSet_Semi_staticPart_rateMatchingAttribute),
        ('cRC-Size', _TransportFormatSet_Semi_staticPart_cRC_Size),
        ('mode', _TransportFormatSet_Semi_staticPart_mode),
        ('iE-Extensions', _TransportFormatSet_Semi_staticPart_iE_Extensions),
        ])
    TransportFormatSet_Semi_staticPart._ext = []
    
    #-----< TransportFormatSet-Semi-staticPart-ExtIEs >-----#
    TransportFormatSet_Semi_staticPart_ExtIEs = CLASS(name='TransportFormatSet-Semi-staticPart-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TransportFormatSet_Semi_staticPart_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportFormatSet-ChannelCodingType >-----#
    TransportFormatSet_ChannelCodingType = ENUM(name='TransportFormatSet-ChannelCodingType', mode=MODE_TYPE)
    TransportFormatSet_ChannelCodingType._cont = ASN1Dict([('no-codingTDD', 0), ('convolutional-coding', 1), ('turbo-coding', 2)])
    TransportFormatSet_ChannelCodingType._ext = []
    
    #-----< TransportFormatSet-CodingRate >-----#
    TransportFormatSet_CodingRate = ENUM(name='TransportFormatSet-CodingRate', mode=MODE_TYPE)
    TransportFormatSet_CodingRate._cont = ASN1Dict([('half', 0), ('third', 1)])
    TransportFormatSet_CodingRate._ext = []
    
    #-----< TransportFormatSet-CRC-Size >-----#
    TransportFormatSet_CRC_Size = ENUM(name='TransportFormatSet-CRC-Size', mode=MODE_TYPE)
    TransportFormatSet_CRC_Size._cont = ASN1Dict([('v0', 0), ('v8', 1), ('v12', 2), ('v16', 3), ('v24', 4)])
    TransportFormatSet_CRC_Size._ext = []
    
    #-----< TransportFormatSet-ModeDP >-----#
    TransportFormatSet_ModeDP = CHOICE(name='TransportFormatSet-ModeDP', mode=MODE_TYPE)
    _TransportFormatSet_ModeDP_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-TransportFormatSet-ModeDP')))
    _TransportFormatSet_ModeDP_notApplicable = NULL(name='notApplicable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TransportFormatSet_ModeDP._cont = ASN1Dict([
        ('tdd', _TransportFormatSet_ModeDP_tdd),
        ('notApplicable', _TransportFormatSet_ModeDP_notApplicable),
        ])
    TransportFormatSet_ModeDP._ext = []
    
    #-----< TransportFormatSet-ModeSSP >-----#
    TransportFormatSet_ModeSSP = CHOICE(name='TransportFormatSet-ModeSSP', mode=MODE_TYPE)
    _TransportFormatSet_ModeSSP_tdd = ENUM(name='tdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet-SecondInterleavingMode')))
    _TransportFormatSet_ModeSSP_notApplicable = NULL(name='notApplicable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TransportFormatSet_ModeSSP._cont = ASN1Dict([
        ('tdd', _TransportFormatSet_ModeSSP_tdd),
        ('notApplicable', _TransportFormatSet_ModeSSP_notApplicable),
        ])
    TransportFormatSet_ModeSSP._ext = []
    
    #-----< TransportFormatSet-NrOfTransportBlocks >-----#
    TransportFormatSet_NrOfTransportBlocks = INT(name='TransportFormatSet-NrOfTransportBlocks', mode=MODE_TYPE)
    TransportFormatSet_NrOfTransportBlocks._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=512)], ev=None, er=[])
    
    #-----< TransportFormatSet-RateMatchingAttribute >-----#
    TransportFormatSet_RateMatchingAttribute = INT(name='TransportFormatSet-RateMatchingAttribute', mode=MODE_TYPE)
    TransportFormatSet_RateMatchingAttribute._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< TransportFormatSet-SecondInterleavingMode >-----#
    TransportFormatSet_SecondInterleavingMode = ENUM(name='TransportFormatSet-SecondInterleavingMode', mode=MODE_TYPE)
    TransportFormatSet_SecondInterleavingMode._cont = ASN1Dict([('frame-related', 0), ('timeSlot-related', 1)])
    TransportFormatSet_SecondInterleavingMode._ext = []
    
    #-----< TransportFormatSet-TransmissionTimeIntervalDynamic >-----#
    TransportFormatSet_TransmissionTimeIntervalDynamic = ENUM(name='TransportFormatSet-TransmissionTimeIntervalDynamic', mode=MODE_TYPE)
    TransportFormatSet_TransmissionTimeIntervalDynamic._cont = ASN1Dict([('msec-10', 0), ('msec-20', 1), ('msec-40', 2), ('msec-80', 3)])
    TransportFormatSet_TransmissionTimeIntervalDynamic._ext = []
    
    #-----< TransportFormatSet-TransmissionTimeIntervalSemiStatic >-----#
    TransportFormatSet_TransmissionTimeIntervalSemiStatic = ENUM(name='TransportFormatSet-TransmissionTimeIntervalSemiStatic', mode=MODE_TYPE)
    TransportFormatSet_TransmissionTimeIntervalSemiStatic._cont = ASN1Dict([('msec-10', 0), ('msec-20', 1), ('msec-40', 2), ('msec-80', 3), ('dynamic', 4), ('msec-5', 5)])
    TransportFormatSet_TransmissionTimeIntervalSemiStatic._ext = ['msec-5']
    
    #-----< TransportFormatSet-TransportBlockSize >-----#
    TransportFormatSet_TransportBlockSize = INT(name='TransportFormatSet-TransportBlockSize', mode=MODE_TYPE)
    TransportFormatSet_TransportBlockSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5000)], ev=None, er=[])
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name='TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TS0-CapabilityLCR >-----#
    TS0_CapabilityLCR = ENUM(name='TS0-CapabilityLCR', mode=MODE_TYPE)
    TS0_CapabilityLCR._cont = ASN1Dict([('tS0-Capable', 0), ('tS0-Not-Capable', 1)])
    TS0_CapabilityLCR._ext = None
    
    #-----< TSTD-Indicator >-----#
    TSTD_Indicator = ENUM(name='TSTD-Indicator', mode=MODE_TYPE)
    TSTD_Indicator._cont = ASN1Dict([('active', 0), ('inactive', 1)])
    TSTD_Indicator._ext = None
    
    #-----< TSN-Length >-----#
    TSN_Length = ENUM(name='TSN-Length', mode=MODE_TYPE)
    TSN_Length._cont = ASN1Dict([('tsn-6bits', 0), ('tsn-9bits', 1)])
    TSN_Length._ext = None
    
    #-----< TUTRANGANSS >-----#
    TUTRANGANSS = SEQ(name='TUTRANGANSS', mode=MODE_TYPE)
    _TUTRANGANSS_mS = INT(name='mS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGANSS_mS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _TUTRANGANSS_lS = INT(name='lS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGANSS_lS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    TUTRANGANSS._cont = ASN1Dict([
        ('mS', _TUTRANGANSS_mS),
        ('lS', _TUTRANGANSS_lS),
        ])
    TUTRANGANSS._ext = None
    
    #-----< TUTRANGANSSAccuracyClass >-----#
    TUTRANGANSSAccuracyClass = ENUM(name='TUTRANGANSSAccuracyClass', mode=MODE_TYPE)
    TUTRANGANSSAccuracyClass._cont = ASN1Dict([('ganssAccuracy-class-A', 0), ('ganssAccuracy-class-B', 1), ('ganssAccuracy-class-C', 2)])
    TUTRANGANSSAccuracyClass._ext = []
    
    #-----< TUTRANGANSSMeasurementThresholdInformation >-----#
    TUTRANGANSSMeasurementThresholdInformation = SEQ(name='TUTRANGANSSMeasurementThresholdInformation', mode=MODE_TYPE)
    _TUTRANGANSSMeasurementThresholdInformation_tUTRANGANSSChangeLimit = INT(name='tUTRANGANSSChangeLimit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TUTRANGANSSMeasurementThresholdInformation_tUTRANGANSSChangeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _TUTRANGANSSMeasurementThresholdInformation_predictedTUTRANGANSSDeviationLimit = INT(name='predictedTUTRANGANSSDeviationLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TUTRANGANSSMeasurementThresholdInformation_predictedTUTRANGANSSDeviationLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _TUTRANGANSSMeasurementThresholdInformation_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id._const_tab = ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id_tab
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id._const_tab_at = None
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id._const_tab_id = 'id'
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality._const_tab = ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality_tab
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue._const_tab = ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue_tab
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id),
        ('criticality', ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality),
        ('extensionValue', ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue),
        ])
    __TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item_._ext = None
    _TUTRANGANSSMeasurementThresholdInformation_ie_Extensions._cont = __TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item_
    _TUTRANGANSSMeasurementThresholdInformation_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TUTRANGANSSMeasurementThresholdInformation._cont = ASN1Dict([
        ('tUTRANGANSSChangeLimit', _TUTRANGANSSMeasurementThresholdInformation_tUTRANGANSSChangeLimit),
        ('predictedTUTRANGANSSDeviationLimit', _TUTRANGANSSMeasurementThresholdInformation_predictedTUTRANGANSSDeviationLimit),
        ('ie-Extensions', _TUTRANGANSSMeasurementThresholdInformation_ie_Extensions),
        ])
    TUTRANGANSSMeasurementThresholdInformation._ext = []
    
    #-----< TUTRANGANSSMeasurementThresholdInformation-ExtIEs >-----#
    TUTRANGANSSMeasurementThresholdInformation_ExtIEs = CLASS(name='TUTRANGANSSMeasurementThresholdInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TUTRANGANSSMeasurementThresholdInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TUTRANGANSSMeasurementValueInformation >-----#
    TUTRANGANSSMeasurementValueInformation = SEQ(name='TUTRANGANSSMeasurementValueInformation', mode=MODE_TYPE)
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSS = SEQ(name='tUTRANGANSS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGANSS')))
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSQuality = INT(name='tUTRANGANSSQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRate = INT(name='tUTRANGANSSDriftRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-50, ub=50)], ev=None, er=[])
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRateQuality = INT(name='tUTRANGANSSDriftRateQuality', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRateQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=50)], ev=None, er=[])
    _TUTRANGANSSMeasurementValueInformation_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TUTRANGANSSMeasurementValueInformation_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Time-ID')))
    ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1000), ('criticality', 'ignore'), ('Extension', _____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id._const_tab = ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id._const_tab_at = None
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id._const_tab_id = 'id'
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality._const_tab = ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue._const_tab = ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TUTRANGANSSMeasurementValueInformation_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id),
        ('criticality', ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality),
        ('extensionValue', ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue),
        ])
    __TUTRANGANSSMeasurementValueInformation_ie_Extensions__item_._ext = None
    _TUTRANGANSSMeasurementValueInformation_ie_Extensions._cont = __TUTRANGANSSMeasurementValueInformation_ie_Extensions__item_
    _TUTRANGANSSMeasurementValueInformation_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TUTRANGANSSMeasurementValueInformation._cont = ASN1Dict([
        ('tUTRANGANSS', _TUTRANGANSSMeasurementValueInformation_tUTRANGANSS),
        ('tUTRANGANSSQuality', _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSQuality),
        ('tUTRANGANSSDriftRate', _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRate),
        ('tUTRANGANSSDriftRateQuality', _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRateQuality),
        ('ie-Extensions', _TUTRANGANSSMeasurementValueInformation_ie_Extensions),
        ])
    TUTRANGANSSMeasurementValueInformation._ext = []
    
    #-----< TUTRANGANSSMeasurementValueInformation-ExtIEs >-----#
    TUTRANGANSSMeasurementValueInformation_ExtIEs = CLASS(name='TUTRANGANSSMeasurementValueInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _TUTRANGANSSMeasurementValueInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Time-ID')))
    TUTRANGANSSMeasurementValueInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 1000), ('criticality', 'ignore'), ('Extension', _TUTRANGANSSMeasurementValueInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TUTRANGPS >-----#
    TUTRANGPS = SEQ(name='TUTRANGPS', mode=MODE_TYPE)
    _TUTRANGPS_ms_part = INT(name='ms-part', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGPS_ms_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _TUTRANGPS_ls_part = INT(name='ls-part', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGPS_ls_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    TUTRANGPS._cont = ASN1Dict([
        ('ms-part', _TUTRANGPS_ms_part),
        ('ls-part', _TUTRANGPS_ls_part),
        ])
    TUTRANGPS._ext = None
    
    #-----< TUTRANGPSChangeLimit >-----#
    TUTRANGPSChangeLimit = INT(name='TUTRANGPSChangeLimit', mode=MODE_TYPE)
    TUTRANGPSChangeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< TUTRANGPSDriftRate >-----#
    TUTRANGPSDriftRate = INT(name='TUTRANGPSDriftRate', mode=MODE_TYPE)
    TUTRANGPSDriftRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-50, ub=50)], ev=None, er=[])
    
    #-----< TUTRANGPSDriftRateQuality >-----#
    TUTRANGPSDriftRateQuality = INT(name='TUTRANGPSDriftRateQuality', mode=MODE_TYPE)
    TUTRANGPSDriftRateQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=50)], ev=None, er=[])
    
    #-----< TUTRANGPSAccuracyClass >-----#
    TUTRANGPSAccuracyClass = ENUM(name='TUTRANGPSAccuracyClass', mode=MODE_TYPE)
    TUTRANGPSAccuracyClass._cont = ASN1Dict([('accuracy-class-A', 0), ('accuracy-class-B', 1), ('accuracy-class-C', 2)])
    TUTRANGPSAccuracyClass._ext = []
    
    #-----< TUTRANGPSMeasurementThresholdInformation >-----#
    TUTRANGPSMeasurementThresholdInformation = SEQ(name='TUTRANGPSMeasurementThresholdInformation', mode=MODE_TYPE)
    _TUTRANGPSMeasurementThresholdInformation_tUTRANGPSChangeLimit = INT(name='tUTRANGPSChangeLimit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGPSChangeLimit')), opt=True)
    _TUTRANGPSMeasurementThresholdInformation_predictedTUTRANGPSDeviationLimit = INT(name='predictedTUTRANGPSDeviationLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PredictedTUTRANGPSDeviationLimit')), opt=True)
    _TUTRANGPSMeasurementThresholdInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id._const_tab = ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id_tab
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id._const_tab_at = None
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab = ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality_tab
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab = ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id),
        ('criticality', ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue),
        ])
    __TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item_._ext = None
    _TUTRANGPSMeasurementThresholdInformation_iE_Extensions._cont = __TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item_
    _TUTRANGPSMeasurementThresholdInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TUTRANGPSMeasurementThresholdInformation._cont = ASN1Dict([
        ('tUTRANGPSChangeLimit', _TUTRANGPSMeasurementThresholdInformation_tUTRANGPSChangeLimit),
        ('predictedTUTRANGPSDeviationLimit', _TUTRANGPSMeasurementThresholdInformation_predictedTUTRANGPSDeviationLimit),
        ('iE-Extensions', _TUTRANGPSMeasurementThresholdInformation_iE_Extensions),
        ])
    TUTRANGPSMeasurementThresholdInformation._ext = []
    
    #-----< TUTRANGPSMeasurementThresholdInformation-ExtIEs >-----#
    TUTRANGPSMeasurementThresholdInformation_ExtIEs = CLASS(name='TUTRANGPSMeasurementThresholdInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TUTRANGPSMeasurementThresholdInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TUTRANGPSMeasurementValueInformation >-----#
    TUTRANGPSMeasurementValueInformation = SEQ(name='TUTRANGPSMeasurementValueInformation', mode=MODE_TYPE)
    _TUTRANGPSMeasurementValueInformation_tUTRANGPS = SEQ(name='tUTRANGPS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGPS')))
    _TUTRANGPSMeasurementValueInformation_tUTRANGPSQuality = INT(name='tUTRANGPSQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGPSQuality')), opt=True)
    _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRate = INT(name='tUTRANGPSDriftRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGPSDriftRate')))
    _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRateQuality = INT(name='tUTRANGPSDriftRateQuality', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TUTRANGPSDriftRateQuality')), opt=True)
    _TUTRANGPSMeasurementValueInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TUTRANGPSMeasurementValueInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__id._const_tab = ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__id_tab
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__id._const_tab_at = None
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__criticality._const_tab = ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__criticality_tab
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__extensionValue._const_tab = ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__extensionValue_tab
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TUTRANGPSMeasurementValueInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__id),
        ('criticality', ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__extensionValue),
        ])
    __TUTRANGPSMeasurementValueInformation_iE_Extensions__item_._ext = None
    _TUTRANGPSMeasurementValueInformation_iE_Extensions._cont = __TUTRANGPSMeasurementValueInformation_iE_Extensions__item_
    _TUTRANGPSMeasurementValueInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TUTRANGPSMeasurementValueInformation._cont = ASN1Dict([
        ('tUTRANGPS', _TUTRANGPSMeasurementValueInformation_tUTRANGPS),
        ('tUTRANGPSQuality', _TUTRANGPSMeasurementValueInformation_tUTRANGPSQuality),
        ('tUTRANGPSDriftRate', _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRate),
        ('tUTRANGPSDriftRateQuality', _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRateQuality),
        ('iE-Extensions', _TUTRANGPSMeasurementValueInformation_iE_Extensions),
        ])
    TUTRANGPSMeasurementValueInformation._ext = []
    
    #-----< TUTRANGPSMeasurementValueInformationItem-ExtIEs >-----#
    TUTRANGPSMeasurementValueInformationItem_ExtIEs = CLASS(name='TUTRANGPSMeasurementValueInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TUTRANGPSMeasurementValueInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TUTRANGPSQuality >-----#
    TUTRANGPSQuality = INT(name='TUTRANGPSQuality', mode=MODE_TYPE)
    TUTRANGPSQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< TxDiversityOnDLControlChannelsByMIMOUECapability >-----#
    TxDiversityOnDLControlChannelsByMIMOUECapability = ENUM(name='TxDiversityOnDLControlChannelsByMIMOUECapability', mode=MODE_TYPE)
    TxDiversityOnDLControlChannelsByMIMOUECapability._cont = ASN1Dict([('dL-Control-Channel-Tx-Diversity-for-MIMO-UE-with-non-diverse-P-CPICH-Capable', 0), ('dL-Control-Channel-Tx-Diversity-for-MIMO-UE-with-non-diverse-P-CPICH-Not-Capable', 1)])
    TxDiversityOnDLControlChannelsByMIMOUECapability._ext = None
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    #-----< Two-ms-Overridden-E-DCH-RACH-Resources >-----#
    Two_ms_Overridden_E_DCH_RACH_Resources = INT(name='Two-ms-Overridden-E-DCH-RACH-Resources', mode=MODE_TYPE)
    Two_ms_Overridden_E_DCH_RACH_Resources._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=240)], ev=[], er=[])
    
    #-----< Two-ms-Grant-E-DCH-RACH-Resources >-----#
    Two_ms_Grant_E_DCH_RACH_Resources = INT(name='Two-ms-Grant-E-DCH-RACH-Resources', mode=MODE_TYPE)
    Two_ms_Grant_E_DCH_RACH_Resources._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=240)], ev=[], er=[])
    
    #-----< Two-ms-Denied-E-DCH-RACH-Resources >-----#
    Two_ms_Denied_E_DCH_RACH_Resources = INT(name='Two-ms-Denied-E-DCH-RACH-Resources', mode=MODE_TYPE)
    Two_ms_Denied_E_DCH_RACH_Resources._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=240)], ev=[], er=[])
    
    #-----< Two-msand10msTTI-Concurrent-Deployment-Capability >-----#
    Two_msand10msTTI_Concurrent_Deployment_Capability = ENUM(name='Two-msand10msTTI-Concurrent-Deployment-Capability', mode=MODE_TYPE)
    Two_msand10msTTI_Concurrent_Deployment_Capability._cont = ASN1Dict([('twomsand10msTTI-Concurrent-Deployment-capable', 0), ('twomsand10msTTI-Concurrent-Deployment-non-capable', 1)])
    Two_msand10msTTI_Concurrent_Deployment_Capability._ext = None
    
    #-----< Two-level-DRX >-----#
    Two_level_DRX = SEQ(name='Two-level-DRX', mode=MODE_TYPE)
    _Two_level_DRX_t32x = ENUM(name='t32x', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T32x')), opt=True)
    _Two_level_DRX_hS_DSCH_first_Rx_burst_FACH = ENUM(name='hS-DSCH-first-Rx-burst-FACH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-first-Rx-burst-FACH')), opt=True)
    _Two_level_DRX_hS_DSCH_first_DRX_ycle_FACH = ENUM(name='hS-DSCH-first-DRX-ycle-FACH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-first-DRX-ycle-FACH')), opt=True)
    _Two_level_DRX_hS_DSCH_second_Rx_burst_FACH = ENUM(name='hS-DSCH-second-Rx-burst-FACH', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-second-Rx-burst-FACH')), opt=True)
    _Two_level_DRX_t32y = ENUM(name='t32y', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T32y')), opt=True)
    _Two_level_DRX_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Two_level_DRX_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Two_level_DRX_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Two_level_DRX_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Two_level_DRX_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Two_level_DRX_iE_Extensions__item__id._const_tab = ____Two_level_DRX_iE_Extensions__item__id_tab
    ___Two_level_DRX_iE_Extensions__item__id._const_tab_at = None
    ___Two_level_DRX_iE_Extensions__item__id._const_tab_id = 'id'
    ___Two_level_DRX_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Two_level_DRX_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Two_level_DRX_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Two_level_DRX_iE_Extensions__item__criticality._const_tab = ____Two_level_DRX_iE_Extensions__item__criticality_tab
    ___Two_level_DRX_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Two_level_DRX_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Two_level_DRX_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Two_level_DRX_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Two_level_DRX_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Two_level_DRX_iE_Extensions__item__extensionValue._const_tab = ____Two_level_DRX_iE_Extensions__item__extensionValue_tab
    ___Two_level_DRX_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Two_level_DRX_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Two_level_DRX_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Two_level_DRX_iE_Extensions__item__id),
        ('criticality', ___Two_level_DRX_iE_Extensions__item__criticality),
        ('extensionValue', ___Two_level_DRX_iE_Extensions__item__extensionValue),
        ])
    __Two_level_DRX_iE_Extensions__item_._ext = None
    _Two_level_DRX_iE_Extensions._cont = __Two_level_DRX_iE_Extensions__item_
    _Two_level_DRX_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Two_level_DRX._cont = ASN1Dict([
        ('t32x', _Two_level_DRX_t32x),
        ('hS-DSCH-first-Rx-burst-FACH', _Two_level_DRX_hS_DSCH_first_Rx_burst_FACH),
        ('hS-DSCH-first-DRX-ycle-FACH', _Two_level_DRX_hS_DSCH_first_DRX_ycle_FACH),
        ('hS-DSCH-second-Rx-burst-FACH', _Two_level_DRX_hS_DSCH_second_Rx_burst_FACH),
        ('t32y', _Two_level_DRX_t32y),
        ('iE-Extensions', _Two_level_DRX_iE_Extensions),
        ])
    Two_level_DRX._ext = []
    
    #-----< Two-level-DRX-ExtIEs >-----#
    Two_level_DRX_ExtIEs = CLASS(name='Two-level-DRX-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Two_level_DRX_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< T32x >-----#
    T32x = ENUM(name='T32x', mode=MODE_TYPE)
    T32x._cont = ASN1Dict([('v20', 0), ('v40', 1), ('v60', 2), ('v80', 3)])
    T32x._ext = None
    
    #-----< T32y >-----#
    T32y = ENUM(name='T32y', mode=MODE_TYPE)
    T32y._cont = ASN1Dict([('v0dot5', 0), ('v1', 1), ('v2', 2), ('v4', 3)])
    T32y._ext = None
    
    #-----< UARFCN >-----#
    UARFCN = INT(name='UARFCN', mode=MODE_TYPE)
    UARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=[], er=[])
    
    #-----< UC-Id >-----#
    UC_Id = SEQ(name='UC-Id', mode=MODE_TYPE)
    _UC_Id_rNC_ID = INT(name='rNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RNC-ID')))
    _UC_Id_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _UC_Id_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UC_Id_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UC_Id_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UC_Id_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UC_Id_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-RNC-ID')))
    ____UC_Id_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 873), ('criticality', 'reject'), ('Extension', _____UC_Id_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UC_Id_iE_Extensions__item__id._const_tab = ____UC_Id_iE_Extensions__item__id_tab
    ___UC_Id_iE_Extensions__item__id._const_tab_at = None
    ___UC_Id_iE_Extensions__item__id._const_tab_id = 'id'
    ___UC_Id_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UC_Id_iE_Extensions__item__criticality._const_tab = ____UC_Id_iE_Extensions__item__id_tab
    ___UC_Id_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UC_Id_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UC_Id_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UC_Id_iE_Extensions__item__extensionValue._const_tab = ____UC_Id_iE_Extensions__item__id_tab
    ___UC_Id_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UC_Id_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UC_Id_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UC_Id_iE_Extensions__item__id),
        ('criticality', ___UC_Id_iE_Extensions__item__criticality),
        ('extensionValue', ___UC_Id_iE_Extensions__item__extensionValue),
        ])
    __UC_Id_iE_Extensions__item_._ext = None
    _UC_Id_iE_Extensions._cont = __UC_Id_iE_Extensions__item_
    _UC_Id_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UC_Id._cont = ASN1Dict([
        ('rNC-ID', _UC_Id_rNC_ID),
        ('c-ID', _UC_Id_c_ID),
        ('iE-Extensions', _UC_Id_iE_Extensions),
        ])
    UC_Id._ext = []
    
    #-----< UC-Id-ExtIEs >-----#
    UC_Id_ExtIEs = CLASS(name='UC-Id-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UC_Id_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-RNC-ID')))
    UC_Id_ExtIEs._val = ASN1Set(rv=[dict([('id', 873), ('criticality', 'reject'), ('Extension', _UC_Id_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UDRE >-----#
    UDRE = ENUM(name='UDRE', mode=MODE_TYPE)
    UDRE._cont = ASN1Dict([('udre-minusequal-one-m', 0), ('udre-betweenoneandfour-m', 1), ('udre-betweenfourandeight-m', 2), ('udre-greaterequaleight-m', 3)])
    UDRE._ext = None
    
    #-----< UDREGrowthRate >-----#
    UDREGrowthRate = ENUM(name='UDREGrowthRate', mode=MODE_TYPE)
    UDREGrowthRate._cont = ASN1Dict([('growth-1-point-5', 0), ('growth-2', 1), ('growth-4', 2), ('growth-6', 3), ('growth-8', 4), ('growth-10', 5), ('growth-12', 6), ('growth-16', 7)])
    UDREGrowthRate._ext = None
    
    #-----< UDREValidityTime >-----#
    UDREValidityTime = ENUM(name='UDREValidityTime', mode=MODE_TYPE)
    UDREValidityTime._cont = ASN1Dict([('val-20sec', 0), ('val-40sec', 1), ('val-80sec', 2), ('val-160sec', 3), ('val-320sec', 4), ('val-640sec', 5), ('val-1280sec', 6), ('val-2560sec', 7)])
    UDREValidityTime._ext = None
    
    #-----< UE-AggregateMaximumBitRate >-----#
    UE_AggregateMaximumBitRate = SEQ(name='UE-AggregateMaximumBitRate', mode=MODE_TYPE)
    _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink = INT(name='uE-AggregateMaximumBitRateDownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRateDownlink')), opt=True)
    _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink = INT(name='uE-AggregateMaximumBitRateUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRateUplink')), opt=True)
    UE_AggregateMaximumBitRate._cont = ASN1Dict([
        ('uE-AggregateMaximumBitRateDownlink', _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink),
        ('uE-AggregateMaximumBitRateUplink', _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink),
        ])
    UE_AggregateMaximumBitRate._ext = []
    
    #-----< UE-AggregateMaximumBitRateDownlink >-----#
    UE_AggregateMaximumBitRateDownlink = INT(name='UE-AggregateMaximumBitRateDownlink', mode=MODE_TYPE)
    UE_AggregateMaximumBitRateDownlink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000000)], ev=None, er=[])
    
    #-----< UE-AggregateMaximumBitRateUplink >-----#
    UE_AggregateMaximumBitRateUplink = INT(name='UE-AggregateMaximumBitRateUplink', mode=MODE_TYPE)
    UE_AggregateMaximumBitRateUplink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000000)], ev=None, er=[])
    
    #-----< UE-AggregateMaximumBitRate-Enforcement-Indicator >-----#
    UE_AggregateMaximumBitRate_Enforcement_Indicator = NULL(name='UE-AggregateMaximumBitRate-Enforcement-Indicator', mode=MODE_TYPE)
    
    #-----< UE-Capability-Information >-----#
    UE_Capability_Information = SEQ(name='UE-Capability-Information', mode=MODE_TYPE)
    _UE_Capability_Information_hSDSCH_Physical_Layer_Category = INT(name='hSDSCH-Physical-Layer-Category', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_Capability_Information_hSDSCH_Physical_Layer_Category._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=[], er=[])
    _UE_Capability_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_Capability_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UE_Capability_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_Capability_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'LCRTDD-Uplink-Physical-Channel-Capability')))
    _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Number-Of-Supported-Carriers')))
    _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'LCRTDD-HSDSCH-Physical-Layer-Category')))
    _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-SFMode-For-HSPDSCHDualStream')))
    _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-TS0-CapabilityLCR')))
    _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-RF-Band-CapabilityLCR')))
    ____UE_Capability_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 872), ('criticality', 'ignore'), ('Extension', _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 926), ('criticality', 'reject'), ('Extension', _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1077), ('criticality', 'ignore'), ('Extension', _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1073), ('criticality', 'ignore'), ('Extension', _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1156), ('criticality', 'ignore'), ('Extension', _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1217), ('criticality', 'ignore'), ('Extension', _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___UE_Capability_Information_iE_Extensions__item__id._const_tab = ____UE_Capability_Information_iE_Extensions__item__id_tab
    ___UE_Capability_Information_iE_Extensions__item__id._const_tab_at = None
    ___UE_Capability_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_Capability_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UE_Capability_Information_iE_Extensions__item__criticality._const_tab = ____UE_Capability_Information_iE_Extensions__item__id_tab
    ___UE_Capability_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_Capability_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_Capability_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UE_Capability_Information_iE_Extensions__item__extensionValue._const_tab = ____UE_Capability_Information_iE_Extensions__item__id_tab
    ___UE_Capability_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_Capability_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_Capability_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_Capability_Information_iE_Extensions__item__id),
        ('criticality', ___UE_Capability_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_Capability_Information_iE_Extensions__item__extensionValue),
        ])
    __UE_Capability_Information_iE_Extensions__item_._ext = None
    _UE_Capability_Information_iE_Extensions._cont = __UE_Capability_Information_iE_Extensions__item_
    _UE_Capability_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_Capability_Information._cont = ASN1Dict([
        ('hSDSCH-Physical-Layer-Category', _UE_Capability_Information_hSDSCH_Physical_Layer_Category),
        ('iE-Extensions', _UE_Capability_Information_iE_Extensions),
        ])
    UE_Capability_Information._ext = []
    
    #-----< UE-Capability-Information-ExtIEs >-----#
    UE_Capability_Information_ExtIEs = CLASS(name='UE-Capability-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UE_Capability_Information_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'LCRTDD-Uplink-Physical-Channel-Capability')))
    _UE_Capability_Information_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Number-Of-Supported-Carriers')))
    _UE_Capability_Information_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'LCRTDD-HSDSCH-Physical-Layer-Category')))
    _UE_Capability_Information_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-SFMode-For-HSPDSCHDualStream')))
    _UE_Capability_Information_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-TS0-CapabilityLCR')))
    _UE_Capability_Information_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-RF-Band-CapabilityLCR')))
    UE_Capability_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 872), ('criticality', 'ignore'), ('Extension', _UE_Capability_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 926), ('criticality', 'reject'), ('Extension', _UE_Capability_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1077), ('criticality', 'ignore'), ('Extension', _UE_Capability_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1073), ('criticality', 'ignore'), ('Extension', _UE_Capability_Information_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1156), ('criticality', 'ignore'), ('Extension', _UE_Capability_Information_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1217), ('criticality', 'ignore'), ('Extension', _UE_Capability_Information_ExtIEs_val_Extension_5), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< UE-RF-Band-CapabilityLCR >-----#
    UE_RF_Band_CapabilityLCR = SEQ_OF(name='UE-RF-Band-CapabilityLCR', mode=MODE_TYPE)
    _UE_RF_Band_CapabilityLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Radio-Frequency-BandItem')))
    UE_RF_Band_CapabilityLCR._cont = _UE_RF_Band_CapabilityLCR__item_
    UE_RF_Band_CapabilityLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Radio-Frequency-BandItem >-----#
    Radio_Frequency_BandItem = SEQ(name='Radio-Frequency-BandItem', mode=MODE_TYPE)
    _Radio_Frequency_BandItem_radio_Frequency_Band = ENUM(name='radio-Frequency-Band', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Radio-Frequency-Band')))
    _Radio_Frequency_BandItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Radio_Frequency_BandItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Radio_Frequency_BandItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Radio_Frequency_BandItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Radio_Frequency_BandItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Frequency_BandItem_iE_Extensions__item__id._const_tab = ____Radio_Frequency_BandItem_iE_Extensions__item__id_tab
    ___Radio_Frequency_BandItem_iE_Extensions__item__id._const_tab_at = None
    ___Radio_Frequency_BandItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___Radio_Frequency_BandItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Radio_Frequency_BandItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Radio_Frequency_BandItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Frequency_BandItem_iE_Extensions__item__criticality._const_tab = ____Radio_Frequency_BandItem_iE_Extensions__item__criticality_tab
    ___Radio_Frequency_BandItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Radio_Frequency_BandItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Radio_Frequency_BandItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Radio_Frequency_BandItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue._const_tab = ____Radio_Frequency_BandItem_iE_Extensions__item__extensionValue_tab
    ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Radio_Frequency_BandItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Radio_Frequency_BandItem_iE_Extensions__item__id),
        ('criticality', ___Radio_Frequency_BandItem_iE_Extensions__item__criticality),
        ('extensionValue', ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue),
        ])
    __Radio_Frequency_BandItem_iE_Extensions__item_._ext = None
    _Radio_Frequency_BandItem_iE_Extensions._cont = __Radio_Frequency_BandItem_iE_Extensions__item_
    _Radio_Frequency_BandItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Radio_Frequency_BandItem._cont = ASN1Dict([
        ('radio-Frequency-Band', _Radio_Frequency_BandItem_radio_Frequency_Band),
        ('iE-Extensions', _Radio_Frequency_BandItem_iE_Extensions),
        ])
    Radio_Frequency_BandItem._ext = []
    
    #-----< UE-TS0-CapabilityLCR >-----#
    UE_TS0_CapabilityLCR = ENUM(name='UE-TS0-CapabilityLCR', mode=MODE_TYPE)
    UE_TS0_CapabilityLCR._cont = ASN1Dict([('uE-TS0-Capable', 0), ('uE-TS0-Not-Capable', 1)])
    UE_TS0_CapabilityLCR._ext = None
    
    #-----< Radio-Frequency-Band >-----#
    Radio_Frequency_Band = ENUM(name='Radio-Frequency-Band', mode=MODE_TYPE)
    Radio_Frequency_Band._cont = ASN1Dict([('a', 0), ('b', 1), ('c', 2), ('d', 3), ('e', 4), ('f', 5), ('g', 6), ('h', 7), ('i', 8), ('j', 9), ('k', 10), ('l', 11), ('m', 12), ('n', 13), ('o', 14), ('p', 15)])
    Radio_Frequency_Band._ext = []
    
    #-----< Radio-Frequency-BandItem-ExtIEs >-----#
    Radio_Frequency_BandItem_ExtIEs = CLASS(name='Radio-Frequency-BandItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Radio_Frequency_BandItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-Support-of-non-rectangular-resource-allocation >-----#
    UE_Support_of_non_rectangular_resource_allocation = ENUM(name='UE-Support-of-non-rectangular-resource-allocation', mode=MODE_TYPE)
    UE_Support_of_non_rectangular_resource_allocation._cont = ASN1Dict([('support', 0)])
    UE_Support_of_non_rectangular_resource_allocation._ext = None
    
    #-----< UE-SupportIndicatorExtension >-----#
    UE_SupportIndicatorExtension = BIT_STR(name='UE-SupportIndicatorExtension', mode=MODE_TYPE)
    UE_SupportIndicatorExtension._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< LCRTDD-HSDSCH-Physical-Layer-Category >-----#
    LCRTDD_HSDSCH_Physical_Layer_Category = INT(name='LCRTDD-HSDSCH-Physical-Layer-Category', mode=MODE_TYPE)
    LCRTDD_HSDSCH_Physical_Layer_Category._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< UE-DPCCH-burst1 >-----#
    UE_DPCCH_burst1 = ENUM(name='UE-DPCCH-burst1', mode=MODE_TYPE)
    UE_DPCCH_burst1._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v5', 2)])
    UE_DPCCH_burst1._ext = None
    
    #-----< UE-DPCCH-burst2 >-----#
    UE_DPCCH_burst2 = ENUM(name='UE-DPCCH-burst2', mode=MODE_TYPE)
    UE_DPCCH_burst2._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v5', 2)])
    UE_DPCCH_burst2._ext = None
    
    #-----< UE-DRX-Cycle >-----#
    UE_DRX_Cycle = ENUM(name='UE-DRX-Cycle', mode=MODE_TYPE)
    UE_DRX_Cycle._cont = ASN1Dict([('v4', 0), ('v5', 1), ('v8', 2), ('v10', 3), ('v16', 4), ('v20', 5)])
    UE_DRX_Cycle._ext = None
    
    #-----< UE-DRX-Grant-Monitoring >-----#
    UE_DRX_Grant_Monitoring = BOOL(name='UE-DRX-Grant-Monitoring', mode=MODE_TYPE)
    
    #-----< UE-DTX-Cycle1-2ms >-----#
    UE_DTX_Cycle1_2ms = ENUM(name='UE-DTX-Cycle1-2ms', mode=MODE_TYPE)
    UE_DTX_Cycle1_2ms._cont = ASN1Dict([('v1', 0), ('v4', 1), ('v5', 2), ('v8', 3), ('v10', 4), ('v16', 5), ('v20', 6)])
    UE_DTX_Cycle1_2ms._ext = None
    
    #-----< UE-DTX-Cycle1-10ms >-----#
    UE_DTX_Cycle1_10ms = ENUM(name='UE-DTX-Cycle1-10ms', mode=MODE_TYPE)
    UE_DTX_Cycle1_10ms._cont = ASN1Dict([('v1', 0), ('v5', 1), ('v10', 2), ('v20', 3)])
    UE_DTX_Cycle1_10ms._ext = None
    
    #-----< UE-DTX-Cycle2-2ms >-----#
    UE_DTX_Cycle2_2ms = ENUM(name='UE-DTX-Cycle2-2ms', mode=MODE_TYPE)
    UE_DTX_Cycle2_2ms._cont = ASN1Dict([('v4', 0), ('v5', 1), ('v8', 2), ('v10', 3), ('v16', 4), ('v20', 5), ('v32', 6), ('v40', 7), ('v64', 8), ('v80', 9), ('v128', 10), ('v160', 11)])
    UE_DTX_Cycle2_2ms._ext = None
    
    #-----< UE-DTX-Cycle2-ext-2ms >-----#
    UE_DTX_Cycle2_ext_2ms = ENUM(name='UE-DTX-Cycle2-ext-2ms', mode=MODE_TYPE)
    UE_DTX_Cycle2_ext_2ms._cont = ASN1Dict([('v4', 0), ('v5', 1), ('v8', 2), ('v10', 3), ('v16', 4), ('v20', 5), ('v32', 6), ('v40', 7), ('v64', 8), ('v80', 9), ('v128', 10), ('v160', 11), ('v256', 12), ('v320', 13), ('v512', 14), ('v640', 15), ('v1024', 16), ('v1280', 17)])
    UE_DTX_Cycle2_ext_2ms._ext = None
    
    #-----< UE-DTX-Cycle2-10ms >-----#
    UE_DTX_Cycle2_10ms = ENUM(name='UE-DTX-Cycle2-10ms', mode=MODE_TYPE)
    UE_DTX_Cycle2_10ms._cont = ASN1Dict([('v5', 0), ('v10', 1), ('v20', 2), ('v40', 3), ('v80', 4), ('v160', 5)])
    UE_DTX_Cycle2_10ms._ext = None
    
    #-----< UE-DTX-DRX-Offset >-----#
    UE_DTX_DRX_Offset = INT(name='UE-DTX-DRX-Offset', mode=MODE_TYPE)
    UE_DTX_DRX_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=159)], ev=None, er=[])
    
    #-----< UE-DTX-Long-Preamble >-----#
    UE_DTX_Long_Preamble = ENUM(name='UE-DTX-Long-Preamble', mode=MODE_TYPE)
    UE_DTX_Long_Preamble._cont = ASN1Dict([('v2', 0), ('v4', 1), ('v15', 2)])
    UE_DTX_Long_Preamble._ext = None
    
    #-----< UE-transmission-power-headroom-Value >-----#
    UE_transmission_power_headroom_Value = INT(name='UE-transmission-power-headroom-Value', mode=MODE_TYPE)
    UE_transmission_power_headroom_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< UE-Measurement-Value >-----#
    UE_Measurement_Value = CHOICE(name='UE-Measurement-Value', mode=MODE_TYPE)
    _UE_Measurement_Value_uPHFiltering_Value = INT(name='uPHFiltering-Value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UPHFiltering-Value')))
    _UE_Measurement_Value_extension_UE_Measurement_Value = SEQ(name='extension-UE-Measurement-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Extension-UE-Measurement-Value')))
    UE_Measurement_Value._cont = ASN1Dict([
        ('uPHFiltering-Value', _UE_Measurement_Value_uPHFiltering_Value),
        ('extension-UE-Measurement-Value', _UE_Measurement_Value_extension_UE_Measurement_Value),
        ])
    UE_Measurement_Value._ext = None
    
    #-----< Extension-UE-Measurement-Value >-----#
    Extension_UE_Measurement_Value = SEQ(name='Extension-UE-Measurement-Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_UE_Measurement_Value_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_UE_Measurement_Value_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    __Extension_UE_Measurement_Value_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Extension_UE_Measurement_Value_id._const_tab = __Extension_UE_Measurement_Value_id_tab
    _Extension_UE_Measurement_Value_id._const_tab_at = None
    _Extension_UE_Measurement_Value_id._const_tab_id = 'id'
    _Extension_UE_Measurement_Value_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Extension_UE_Measurement_Value_criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    __Extension_UE_Measurement_Value_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Extension_UE_Measurement_Value_criticality._const_tab = __Extension_UE_Measurement_Value_criticality_tab
    _Extension_UE_Measurement_Value_criticality._const_tab_at = ('..', 'id')
    _Extension_UE_Measurement_Value_criticality._const_tab_id = 'criticality'
    _Extension_UE_Measurement_Value_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Extension_UE_Measurement_Value_value_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    __Extension_UE_Measurement_Value_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Extension_UE_Measurement_Value_value._const_tab = __Extension_UE_Measurement_Value_value_tab
    _Extension_UE_Measurement_Value_value._const_tab_at = ('..', 'id')
    _Extension_UE_Measurement_Value_value._const_tab_id = 'Value'
    Extension_UE_Measurement_Value._cont = ASN1Dict([
        ('id', _Extension_UE_Measurement_Value_id),
        ('criticality', _Extension_UE_Measurement_Value_criticality),
        ('value', _Extension_UE_Measurement_Value_value),
        ])
    Extension_UE_Measurement_Value._ext = None
    
    #-----< Extension-UE-Measurement-ValueIE >-----#
    Extension_UE_Measurement_ValueIE = CLASS(name='Extension-UE-Measurement-ValueIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    Extension_UE_Measurement_ValueIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UPHFiltering-Value >-----#
    UPHFiltering_Value = INT(name='UPHFiltering-Value', mode=MODE_TYPE)
    UPHFiltering_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    
    #-----< UL-CapacityCredit >-----#
    UL_CapacityCredit = INT(name='UL-CapacityCredit', mode=MODE_TYPE)
    UL_CapacityCredit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< UL-Delta-T2TP >-----#
    UL_Delta_T2TP = INT(name='UL-Delta-T2TP', mode=MODE_TYPE)
    UL_Delta_T2TP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=[], er=[])
    
    #-----< UL-DL-mode >-----#
    UL_DL_mode = ENUM(name='UL-DL-mode', mode=MODE_TYPE)
    UL_DL_mode._cont = ASN1Dict([('ul-only', 0), ('dl-only', 1), ('both-ul-and-dl', 2)])
    UL_DL_mode._ext = None
    
    #-----< UL-DPDCH-Indicator-For-E-DCH-Operation >-----#
    UL_DPDCH_Indicator_For_E_DCH_Operation = ENUM(name='UL-DPDCH-Indicator-For-E-DCH-Operation', mode=MODE_TYPE)
    UL_DPDCH_Indicator_For_E_DCH_Operation._cont = ASN1Dict([('ul-DPDCH-present', 0), ('ul-DPDCH-not-present', 1)])
    UL_DPDCH_Indicator_For_E_DCH_Operation._ext = None
    
    #-----< Uplink-Compressed-Mode-Method >-----#
    Uplink_Compressed_Mode_Method = ENUM(name='Uplink-Compressed-Mode-Method', mode=MODE_TYPE)
    Uplink_Compressed_Mode_Method._cont = ASN1Dict([('sFdiv2', 0), ('higher-layer-scheduling', 1)])
    Uplink_Compressed_Mode_Method._ext = []
    
    #-----< UL-Timeslot-Information >-----#
    UL_Timeslot_Information = SEQ_OF(name='UL-Timeslot-Information', mode=MODE_TYPE)
    _UL_Timeslot_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Timeslot-InformationItem')))
    UL_Timeslot_Information._cont = _UL_Timeslot_Information__item_
    UL_Timeslot_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationItem >-----#
    UL_Timeslot_InformationItem = SEQ(name='UL-Timeslot-InformationItem', mode=MODE_TYPE)
    _UL_Timeslot_InformationItem_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationItem_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _UL_Timeslot_InformationItem_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _UL_Timeslot_InformationItem_uL_Code_InformationList = SEQ_OF(name='uL-Code-InformationList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-Code-Information')))
    _UL_Timeslot_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot_InformationItem_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationItem_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationItem_iE_Extensions._cont = __UL_Timeslot_InformationItem_iE_Extensions__item_
    _UL_Timeslot_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationItem._cont = ASN1Dict([
        ('timeSlot', _UL_Timeslot_InformationItem_timeSlot),
        ('midambleShiftAndBurstType', _UL_Timeslot_InformationItem_midambleShiftAndBurstType),
        ('tFCI-Presence', _UL_Timeslot_InformationItem_tFCI_Presence),
        ('uL-Code-InformationList', _UL_Timeslot_InformationItem_uL_Code_InformationList),
        ('iE-Extensions', _UL_Timeslot_InformationItem_iE_Extensions),
        ])
    UL_Timeslot_InformationItem._ext = []
    
    #-----< UL-Timeslot-InformationItem-ExtIEs >-----#
    UL_Timeslot_InformationItem_ExtIEs = CLASS(name='UL-Timeslot-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-TimeslotLCR-Information >-----#
    UL_TimeslotLCR_Information = SEQ_OF(name='UL-TimeslotLCR-Information', mode=MODE_TYPE)
    _UL_TimeslotLCR_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotLCR-InformationItem')))
    UL_TimeslotLCR_Information._cont = _UL_TimeslotLCR_Information__item_
    UL_TimeslotLCR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UL-TimeslotLCR-InformationItem >-----#
    UL_TimeslotLCR_InformationItem = SEQ(name='UL-TimeslotLCR-InformationItem', mode=MODE_TYPE)
    _UL_TimeslotLCR_InformationItem_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _UL_TimeslotLCR_InformationItem_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _UL_TimeslotLCR_InformationItem_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _UL_TimeslotLCR_InformationItem_uL_Code_InformationList = SEQ_OF(name='uL-Code-InformationList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-Code-LCR-Information')))
    _UL_TimeslotLCR_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_TimeslotLCR_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PLCCHinformation')))
    ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 714), ('criticality', 'reject'), ('Extension', _____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab = ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab = ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_TimeslotLCR_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id),
        ('criticality', ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __UL_TimeslotLCR_InformationItem_iE_Extensions__item_._ext = None
    _UL_TimeslotLCR_InformationItem_iE_Extensions._cont = __UL_TimeslotLCR_InformationItem_iE_Extensions__item_
    _UL_TimeslotLCR_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_TimeslotLCR_InformationItem._cont = ASN1Dict([
        ('timeSlotLCR', _UL_TimeslotLCR_InformationItem_timeSlotLCR),
        ('midambleShiftLCR', _UL_TimeslotLCR_InformationItem_midambleShiftLCR),
        ('tFCI-Presence', _UL_TimeslotLCR_InformationItem_tFCI_Presence),
        ('uL-Code-InformationList', _UL_TimeslotLCR_InformationItem_uL_Code_InformationList),
        ('iE-Extensions', _UL_TimeslotLCR_InformationItem_iE_Extensions),
        ])
    UL_TimeslotLCR_InformationItem._ext = []
    
    #-----< UL-TimeslotLCR-InformationItem-ExtIEs >-----#
    UL_TimeslotLCR_InformationItem_ExtIEs = CLASS(name='UL-TimeslotLCR-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PLCCHinformation')))
    UL_TimeslotLCR_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 714), ('criticality', 'reject'), ('Extension', _UL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot768-Information >-----#
    UL_Timeslot768_Information = SEQ_OF(name='UL-Timeslot768-Information', mode=MODE_TYPE)
    _UL_Timeslot768_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Timeslot768-InformationItem')))
    UL_Timeslot768_Information._cont = _UL_Timeslot768_Information__item_
    UL_Timeslot768_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot768-InformationItem >-----#
    UL_Timeslot768_InformationItem = SEQ(name='UL-Timeslot768-InformationItem', mode=MODE_TYPE)
    _UL_Timeslot768_InformationItem_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _UL_Timeslot768_InformationItem_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _UL_Timeslot768_InformationItem_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _UL_Timeslot768_InformationItem_uL_Code_InformationList = SEQ_OF(name='uL-Code-InformationList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-Code-768-Information')))
    _UL_Timeslot768_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot768_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot768_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot768_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__id._const_tab = ____UL_Timeslot768_InformationItem_iE_Extensions__item__id_tab
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Timeslot768_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot768_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot768_InformationItem_iE_Extensions__item__criticality_tab
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot768_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot768_InformationItem_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot768_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot768_InformationItem_iE_Extensions__item_._ext = None
    _UL_Timeslot768_InformationItem_iE_Extensions._cont = __UL_Timeslot768_InformationItem_iE_Extensions__item_
    _UL_Timeslot768_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot768_InformationItem._cont = ASN1Dict([
        ('timeSlot', _UL_Timeslot768_InformationItem_timeSlot),
        ('midambleShiftAndBurstType768', _UL_Timeslot768_InformationItem_midambleShiftAndBurstType768),
        ('tFCI-Presence', _UL_Timeslot768_InformationItem_tFCI_Presence),
        ('uL-Code-InformationList', _UL_Timeslot768_InformationItem_uL_Code_InformationList),
        ('iE-Extensions', _UL_Timeslot768_InformationItem_iE_Extensions),
        ])
    UL_Timeslot768_InformationItem._ext = []
    
    #-----< UL-Timeslot768-InformationItem-ExtIEs >-----#
    UL_Timeslot768_InformationItem_ExtIEs = CLASS(name='UL-Timeslot768-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Timeslot768_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCCH-SlotFormat >-----#
    UL_DPCCH_SlotFormat = INT(name='UL-DPCCH-SlotFormat', mode=MODE_TYPE)
    UL_DPCCH_SlotFormat._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=[], er=[])
    
    #-----< UL-SIR >-----#
    UL_SIR = INT(name='UL-SIR', mode=MODE_TYPE)
    UL_SIR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-82, ub=173)], ev=None, er=[])
    
    #-----< UL-FP-Mode >-----#
    UL_FP_Mode = ENUM(name='UL-FP-Mode', mode=MODE_TYPE)
    UL_FP_Mode._cont = ASN1Dict([('normal', 0), ('silent', 1)])
    UL_FP_Mode._ext = []
    
    #-----< UL-PhysCH-SF-Variation >-----#
    UL_PhysCH_SF_Variation = ENUM(name='UL-PhysCH-SF-Variation', mode=MODE_TYPE)
    UL_PhysCH_SF_Variation._cont = ASN1Dict([('sf-variation-supported', 0), ('sf-variation-not-supported', 1)])
    UL_PhysCH_SF_Variation._ext = None
    
    #-----< UL-ScramblingCode >-----#
    UL_ScramblingCode = SEQ(name='UL-ScramblingCode', mode=MODE_TYPE)
    _UL_ScramblingCode_uL_ScramblingCodeNumber = INT(name='uL-ScramblingCodeNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-ScramblingCodeNumber')))
    _UL_ScramblingCode_uL_ScramblingCodeLength = ENUM(name='uL-ScramblingCodeLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-ScramblingCodeLength')))
    _UL_ScramblingCode_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_ScramblingCode_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_ScramblingCode_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_ScramblingCode_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_ScramblingCode_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_ScramblingCode_iE_Extensions__item__id._const_tab = ____UL_ScramblingCode_iE_Extensions__item__id_tab
    ___UL_ScramblingCode_iE_Extensions__item__id._const_tab_at = None
    ___UL_ScramblingCode_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_ScramblingCode_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_ScramblingCode_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_ScramblingCode_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_ScramblingCode_iE_Extensions__item__criticality._const_tab = ____UL_ScramblingCode_iE_Extensions__item__criticality_tab
    ___UL_ScramblingCode_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_ScramblingCode_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_ScramblingCode_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_ScramblingCode_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_ScramblingCode_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_ScramblingCode_iE_Extensions__item__extensionValue._const_tab = ____UL_ScramblingCode_iE_Extensions__item__extensionValue_tab
    ___UL_ScramblingCode_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_ScramblingCode_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_ScramblingCode_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_ScramblingCode_iE_Extensions__item__id),
        ('criticality', ___UL_ScramblingCode_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_ScramblingCode_iE_Extensions__item__extensionValue),
        ])
    __UL_ScramblingCode_iE_Extensions__item_._ext = None
    _UL_ScramblingCode_iE_Extensions._cont = __UL_ScramblingCode_iE_Extensions__item_
    _UL_ScramblingCode_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_ScramblingCode._cont = ASN1Dict([
        ('uL-ScramblingCodeNumber', _UL_ScramblingCode_uL_ScramblingCodeNumber),
        ('uL-ScramblingCodeLength', _UL_ScramblingCode_uL_ScramblingCodeLength),
        ('iE-Extensions', _UL_ScramblingCode_iE_Extensions),
        ])
    UL_ScramblingCode._ext = []
    
    #-----< UL-ScramblingCode-ExtIEs >-----#
    UL_ScramblingCode_ExtIEs = CLASS(name='UL-ScramblingCode-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_ScramblingCode_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-ScramblingCodeNumber >-----#
    UL_ScramblingCodeNumber = INT(name='UL-ScramblingCodeNumber', mode=MODE_TYPE)
    UL_ScramblingCodeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    
    #-----< UL-ScramblingCodeLength >-----#
    UL_ScramblingCodeLength = ENUM(name='UL-ScramblingCodeLength', mode=MODE_TYPE)
    UL_ScramblingCodeLength._cont = ASN1Dict([('short', 0), ('long', 1)])
    UL_ScramblingCodeLength._ext = None
    
    #-----< UL-Synchronisation-Parameters-LCR >-----#
    UL_Synchronisation_Parameters_LCR = SEQ(name='UL-Synchronisation-Parameters-LCR', mode=MODE_TYPE)
    _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_StepSize = INT(name='uL-Synchronisation-StepSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-StepSize')))
    _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_Frequency = INT(name='uL-Synchronisation-Frequency', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-Frequency')))
    _UL_Synchronisation_Parameters_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Synchronisation_Parameters_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id._const_tab = ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id_tab
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id._const_tab_at = None
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality._const_tab = ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality_tab
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue._const_tab = ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue_tab
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Synchronisation_Parameters_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id),
        ('criticality', ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue),
        ])
    __UL_Synchronisation_Parameters_LCR_iE_Extensions__item_._ext = None
    _UL_Synchronisation_Parameters_LCR_iE_Extensions._cont = __UL_Synchronisation_Parameters_LCR_iE_Extensions__item_
    _UL_Synchronisation_Parameters_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Synchronisation_Parameters_LCR._cont = ASN1Dict([
        ('uL-Synchronisation-StepSize', _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_StepSize),
        ('uL-Synchronisation-Frequency', _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_Frequency),
        ('iE-Extensions', _UL_Synchronisation_Parameters_LCR_iE_Extensions),
        ])
    UL_Synchronisation_Parameters_LCR._ext = []
    
    #-----< UL-Synchronisation-Parameters-LCR-ExtIEs >-----#
    UL_Synchronisation_Parameters_LCR_ExtIEs = CLASS(name='UL-Synchronisation-Parameters-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Synchronisation_Parameters_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Synchronisation-StepSize >-----#
    UL_Synchronisation_StepSize = INT(name='UL-Synchronisation-StepSize', mode=MODE_TYPE)
    UL_Synchronisation_StepSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< UL-Synchronisation-Frequency >-----#
    UL_Synchronisation_Frequency = INT(name='UL-Synchronisation-Frequency', mode=MODE_TYPE)
    UL_Synchronisation_Frequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< UPPCHPositionLCR >-----#
    UPPCHPositionLCR = INT(name='UPPCHPositionLCR', mode=MODE_TYPE)
    UPPCHPositionLCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< UL-TimeSlot-ISCP-Info >-----#
    UL_TimeSlot_ISCP_Info = SEQ_OF(name='UL-TimeSlot-ISCP-Info', mode=MODE_TYPE)
    _UL_TimeSlot_ISCP_Info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeSlot-ISCP-InfoItem')))
    UL_TimeSlot_ISCP_Info._cont = _UL_TimeSlot_ISCP_Info__item_
    UL_TimeSlot_ISCP_Info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-TimeSlot-ISCP-InfoItem >-----#
    UL_TimeSlot_ISCP_InfoItem = SEQ(name='UL-TimeSlot-ISCP-InfoItem', mode=MODE_TYPE)
    _UL_TimeSlot_ISCP_InfoItem_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _UL_TimeSlot_ISCP_InfoItem_iSCP = INT(name='iSCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-Value')))
    _UL_TimeSlot_ISCP_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id._const_tab = ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality._const_tab = ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id),
        ('criticality', ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_._ext = None
    _UL_TimeSlot_ISCP_InfoItem_iE_Extensions._cont = __UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_
    _UL_TimeSlot_ISCP_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_TimeSlot_ISCP_InfoItem._cont = ASN1Dict([
        ('timeSlot', _UL_TimeSlot_ISCP_InfoItem_timeSlot),
        ('iSCP', _UL_TimeSlot_ISCP_InfoItem_iSCP),
        ('iE-Extensions', _UL_TimeSlot_ISCP_InfoItem_iE_Extensions),
        ])
    UL_TimeSlot_ISCP_InfoItem._ext = []
    
    #-----< UL-TimeSlot-ISCP-InfoItem-ExtIEs >-----#
    UL_TimeSlot_ISCP_InfoItem_ExtIEs = CLASS(name='UL-TimeSlot-ISCP-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_TimeSlot_ISCP_InfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-TimeSlot-ISCP-LCR-Info >-----#
    UL_TimeSlot_ISCP_LCR_Info = SEQ_OF(name='UL-TimeSlot-ISCP-LCR-Info', mode=MODE_TYPE)
    _UL_TimeSlot_ISCP_LCR_Info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeSlot-ISCP-LCR-InfoItem')))
    UL_TimeSlot_ISCP_LCR_Info._cont = _UL_TimeSlot_ISCP_LCR_Info__item_
    UL_TimeSlot_ISCP_LCR_Info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UL-TimeSlot-ISCP-LCR-InfoItem >-----#
    UL_TimeSlot_ISCP_LCR_InfoItem = SEQ(name='UL-TimeSlot-ISCP-LCR-InfoItem', mode=MODE_TYPE)
    _UL_TimeSlot_ISCP_LCR_InfoItem_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _UL_TimeSlot_ISCP_LCR_InfoItem_iSCP = INT(name='iSCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-Value')))
    _UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id._const_tab = ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality._const_tab = ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id),
        ('criticality', ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_._ext = None
    _UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions._cont = __UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_
    _UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_TimeSlot_ISCP_LCR_InfoItem._cont = ASN1Dict([
        ('timeSlotLCR', _UL_TimeSlot_ISCP_LCR_InfoItem_timeSlotLCR),
        ('iSCP', _UL_TimeSlot_ISCP_LCR_InfoItem_iSCP),
        ('iE-Extensions', _UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions),
        ])
    UL_TimeSlot_ISCP_LCR_InfoItem._ext = []
    
    #-----< UL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs >-----#
    UL_TimeSlot_ISCP_LCR_InfoItem_ExtIEs = CLASS(name='UL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_TimeSlot_ISCP_LCR_InfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UpPTSInterference-For-CellPortion-Value >-----#
    UpPTSInterference_For_CellPortion_Value = SEQ_OF(name='UpPTSInterference-For-CellPortion-Value', mode=MODE_TYPE)
    _UpPTSInterference_For_CellPortion_Value__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterference-For-CellPortion-Value-Item')))
    UpPTSInterference_For_CellPortion_Value._cont = _UpPTSInterference_For_CellPortion_Value__item_
    UpPTSInterference_For_CellPortion_Value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UpPTSInterference-For-CellPortion-Value-Item >-----#
    UpPTSInterference_For_CellPortion_Value_Item = SEQ(name='UpPTSInterference-For-CellPortion-Value-Item', mode=MODE_TYPE)
    _UpPTSInterference_For_CellPortion_Value_Item_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _UpPTSInterference_For_CellPortion_Value_Item_upPTSInterferenceValue = INT(name='upPTSInterferenceValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UpPTSInterferenceValue')))
    _UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab = ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__id_tab
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab_at = None
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab = ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab = ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__id),
        ('criticality', ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue),
        ])
    __UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item_._ext = None
    _UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions._cont = __UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item_
    _UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UpPTSInterference_For_CellPortion_Value_Item._cont = ASN1Dict([
        ('cellPortionLCRID', _UpPTSInterference_For_CellPortion_Value_Item_cellPortionLCRID),
        ('upPTSInterferenceValue', _UpPTSInterference_For_CellPortion_Value_Item_upPTSInterferenceValue),
        ('iE-Extensions', _UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions),
        ])
    UpPTSInterference_For_CellPortion_Value_Item._ext = []
    
    #-----< UpPTSInterference-For-CellPortion-Value-Item-ExtIEs >-----#
    UpPTSInterference_For_CellPortion_Value_Item_ExtIEs = CLASS(name='UpPTSInterference-For-CellPortion-Value-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UpPTSInterference_For_CellPortion_Value_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UpPTSInterferenceValue >-----#
    UpPTSInterferenceValue = INT(name='UpPTSInterferenceValue', mode=MODE_TYPE)
    UpPTSInterferenceValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< Unidirectional-DCH-Indicator >-----#
    Unidirectional_DCH_Indicator = ENUM(name='Unidirectional-DCH-Indicator', mode=MODE_TYPE)
    Unidirectional_DCH_Indicator._cont = ASN1Dict([('downlink-DCH-only', 0), ('uplink-DCH-only', 1)])
    Unidirectional_DCH_Indicator._ext = None
    
    #-----< USCH-Information >-----#
    USCH_Information = SEQ_OF(name='USCH-Information', mode=MODE_TYPE)
    _USCH_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-InformationItem')))
    USCH_Information._cont = _USCH_Information__item_
    USCH_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< USCH-InformationItem >-----#
    USCH_InformationItem = SEQ(name='USCH-InformationItem', mode=MODE_TYPE)
    _USCH_InformationItem_uSCH_ID = INT(name='uSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'USCH-ID')))
    _USCH_InformationItem_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _USCH_InformationItem_transportFormatSet = SEQ(name='transportFormatSet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _USCH_InformationItem_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')))
    _USCH_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCH_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___USCH_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____USCH_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____USCH_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___USCH_InformationItem_iE_Extensions__item__id._const_tab = ____USCH_InformationItem_iE_Extensions__item__id_tab
    ___USCH_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___USCH_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___USCH_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___USCH_InformationItem_iE_Extensions__item__criticality._const_tab = ____USCH_InformationItem_iE_Extensions__item__id_tab
    ___USCH_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___USCH_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___USCH_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___USCH_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____USCH_InformationItem_iE_Extensions__item__id_tab
    ___USCH_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___USCH_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __USCH_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___USCH_InformationItem_iE_Extensions__item__id),
        ('criticality', ___USCH_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___USCH_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __USCH_InformationItem_iE_Extensions__item_._ext = None
    _USCH_InformationItem_iE_Extensions._cont = __USCH_InformationItem_iE_Extensions__item_
    _USCH_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCH_InformationItem._cont = ASN1Dict([
        ('uSCH-ID', _USCH_InformationItem_uSCH_ID),
        ('cCTrCH-ID', _USCH_InformationItem_cCTrCH_ID),
        ('transportFormatSet', _USCH_InformationItem_transportFormatSet),
        ('allocationRetentionPriority', _USCH_InformationItem_allocationRetentionPriority),
        ('iE-Extensions', _USCH_InformationItem_iE_Extensions),
        ])
    USCH_InformationItem._ext = []
    
    #-----< USCH-InformationItem-ExtIEs >-----#
    USCH_InformationItem_ExtIEs = CLASS(name='USCH-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _USCH_InformationItem_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _USCH_InformationItem_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _USCH_InformationItem_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    USCH_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _USCH_InformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _USCH_InformationItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _USCH_InformationItem_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< USCH-InformationResponse >-----#
    USCH_InformationResponse = SEQ_OF(name='USCH-InformationResponse', mode=MODE_TYPE)
    _USCH_InformationResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-InformationResponseItem')))
    USCH_InformationResponse._cont = _USCH_InformationResponse__item_
    USCH_InformationResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< USCH-InformationResponseItem >-----#
    USCH_InformationResponseItem = SEQ(name='USCH-InformationResponseItem', mode=MODE_TYPE)
    _USCH_InformationResponseItem_uSCH_ID = INT(name='uSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'USCH-ID')))
    _USCH_InformationResponseItem_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'BindingID')), opt=True)
    _USCH_InformationResponseItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')), opt=True)
    _USCH_InformationResponseItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCH_InformationResponseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___USCH_InformationResponseItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____USCH_InformationResponseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____USCH_InformationResponseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_InformationResponseItem_iE_Extensions__item__id._const_tab = ____USCH_InformationResponseItem_iE_Extensions__item__id_tab
    ___USCH_InformationResponseItem_iE_Extensions__item__id._const_tab_at = None
    ___USCH_InformationResponseItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___USCH_InformationResponseItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____USCH_InformationResponseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____USCH_InformationResponseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab = ____USCH_InformationResponseItem_iE_Extensions__item__criticality_tab
    ___USCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___USCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___USCH_InformationResponseItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____USCH_InformationResponseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____USCH_InformationResponseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab = ____USCH_InformationResponseItem_iE_Extensions__item__extensionValue_tab
    ___USCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___USCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __USCH_InformationResponseItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___USCH_InformationResponseItem_iE_Extensions__item__id),
        ('criticality', ___USCH_InformationResponseItem_iE_Extensions__item__criticality),
        ('extensionValue', ___USCH_InformationResponseItem_iE_Extensions__item__extensionValue),
        ])
    __USCH_InformationResponseItem_iE_Extensions__item_._ext = None
    _USCH_InformationResponseItem_iE_Extensions._cont = __USCH_InformationResponseItem_iE_Extensions__item_
    _USCH_InformationResponseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCH_InformationResponseItem._cont = ASN1Dict([
        ('uSCH-ID', _USCH_InformationResponseItem_uSCH_ID),
        ('bindingID', _USCH_InformationResponseItem_bindingID),
        ('transportLayerAddress', _USCH_InformationResponseItem_transportLayerAddress),
        ('iE-Extensions', _USCH_InformationResponseItem_iE_Extensions),
        ])
    USCH_InformationResponseItem._ext = []
    
    #-----< USCH-InformationResponseItem-ExtIEs >-----#
    USCH_InformationResponseItem_ExtIEs = CLASS(name='USCH-InformationResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    USCH_InformationResponseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-CLTD-Information >-----#
    UL_CLTD_Information = SEQ(name='UL-CLTD-Information', mode=MODE_TYPE)
    _UL_CLTD_Information_sDPCCH_PowerOffsetinformation = INT(name='sDPCCH-PowerOffsetinformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SDPCCH-PowerOffsetInformation')))
    _UL_CLTD_Information_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')), opt=True)
    _UL_CLTD_Information_uL_CLTD_Activation_Information = ENUM(name='uL-CLTD-Activation-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Activation-Information')), opt=True)
    _UL_CLTD_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CLTD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_CLTD_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CLTD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_iE_Extensions__item__id._const_tab = ____UL_CLTD_Information_iE_Extensions__item__id_tab
    ___UL_CLTD_Information_iE_Extensions__item__id._const_tab_at = None
    ___UL_CLTD_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CLTD_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_CLTD_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_iE_Extensions__item__criticality._const_tab = ____UL_CLTD_Information_iE_Extensions__item__criticality_tab
    ___UL_CLTD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CLTD_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CLTD_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_CLTD_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_iE_Extensions__item__extensionValue._const_tab = ____UL_CLTD_Information_iE_Extensions__item__extensionValue_tab
    ___UL_CLTD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CLTD_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CLTD_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CLTD_Information_iE_Extensions__item__id),
        ('criticality', ___UL_CLTD_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CLTD_Information_iE_Extensions__item__extensionValue),
        ])
    __UL_CLTD_Information_iE_Extensions__item_._ext = None
    _UL_CLTD_Information_iE_Extensions._cont = __UL_CLTD_Information_iE_Extensions__item_
    _UL_CLTD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CLTD_Information._cont = ASN1Dict([
        ('sDPCCH-PowerOffsetinformation', _UL_CLTD_Information_sDPCCH_PowerOffsetinformation),
        ('c-ID', _UL_CLTD_Information_c_ID),
        ('uL-CLTD-Activation-Information', _UL_CLTD_Information_uL_CLTD_Activation_Information),
        ('iE-Extensions', _UL_CLTD_Information_iE_Extensions),
        ])
    UL_CLTD_Information._ext = []
    
    #-----< UL-CLTD-Information-ExtIEs >-----#
    UL_CLTD_Information_ExtIEs = CLASS(name='UL-CLTD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_CLTD_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-CLTD-Information-Reconf >-----#
    UL_CLTD_Information_Reconf = SEQ(name='UL-CLTD-Information-Reconf', mode=MODE_TYPE)
    _UL_CLTD_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD = CHOICE(name='setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD')))
    _UL_CLTD_Information_Reconf_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CLTD_Information_Reconf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__id._const_tab = ____UL_CLTD_Information_Reconf_iE_Extensions__item__id_tab
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__id._const_tab_at = None
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality._const_tab = ____UL_CLTD_Information_Reconf_iE_Extensions__item__criticality_tab
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue._const_tab = ____UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue_tab
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CLTD_Information_Reconf_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CLTD_Information_Reconf_iE_Extensions__item__id),
        ('criticality', ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue),
        ])
    __UL_CLTD_Information_Reconf_iE_Extensions__item_._ext = None
    _UL_CLTD_Information_Reconf_iE_Extensions._cont = __UL_CLTD_Information_Reconf_iE_Extensions__item_
    _UL_CLTD_Information_Reconf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CLTD_Information_Reconf._cont = ASN1Dict([
        ('setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD', _UL_CLTD_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD),
        ('iE-Extensions', _UL_CLTD_Information_Reconf_iE_Extensions),
        ])
    UL_CLTD_Information_Reconf._ext = []
    
    #-----< UL-CLTD-Information-Reconf-ExtIEs >-----#
    UL_CLTD_Information_Reconf_ExtIEs = CLASS(name='UL-CLTD-Information-Reconf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_CLTD_Information_Reconf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-CLTD-Information-To-Modify >-----#
    UL_CLTD_Information_To_Modify = SEQ(name='UL-CLTD-Information-To-Modify', mode=MODE_TYPE)
    _UL_CLTD_Information_To_Modify_sDPCCH_PowerOffsetInformation = INT(name='sDPCCH-PowerOffsetInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SDPCCH-PowerOffsetInformation')), opt=True)
    _UL_CLTD_Information_To_Modify_uL_CLTD_Activation_Information = ENUM(name='uL-CLTD-Activation-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Activation-Information')), opt=True)
    _UL_CLTD_Information_To_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CLTD_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id._const_tab = ____UL_CLTD_Information_To_Modify_iE_Extensions__item__id_tab
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality_tab
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue_tab
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CLTD_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id),
        ('criticality', ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __UL_CLTD_Information_To_Modify_iE_Extensions__item_._ext = None
    _UL_CLTD_Information_To_Modify_iE_Extensions._cont = __UL_CLTD_Information_To_Modify_iE_Extensions__item_
    _UL_CLTD_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CLTD_Information_To_Modify._cont = ASN1Dict([
        ('sDPCCH-PowerOffsetInformation', _UL_CLTD_Information_To_Modify_sDPCCH_PowerOffsetInformation),
        ('uL-CLTD-Activation-Information', _UL_CLTD_Information_To_Modify_uL_CLTD_Activation_Information),
        ('iE-Extensions', _UL_CLTD_Information_To_Modify_iE_Extensions),
        ])
    UL_CLTD_Information_To_Modify._ext = []
    
    #-----< UL-CLTD-Information-To-Modify-ExtIEs >-----#
    UL_CLTD_Information_To_Modify_ExtIEs = CLASS(name='UL-CLTD-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_CLTD_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-CLTD-Information-Removal >-----#
    UL_CLTD_Information_Removal = ENUM(name='UL-CLTD-Information-Removal', mode=MODE_TYPE)
    UL_CLTD_Information_Removal._cont = ASN1Dict([('remove', 0)])
    UL_CLTD_Information_Removal._ext = []
    
    #-----< UL-CLTD-State-Update-Information >-----#
    UL_CLTD_State_Update_Information = ENUM(name='UL-CLTD-State-Update-Information', mode=MODE_TYPE)
    UL_CLTD_State_Update_Information._cont = ASN1Dict([('activate', 0), ('de-activate', 1)])
    UL_CLTD_State_Update_Information._ext = []
    
    #-----< UL-CLTD-Activation-Information >-----#
    UL_CLTD_Activation_Information = ENUM(name='UL-CLTD-Activation-Information', mode=MODE_TYPE)
    UL_CLTD_Activation_Information._cont = ASN1Dict([('activated', 0), ('de-activated', 1)])
    UL_CLTD_Activation_Information._ext = []
    
    #-----< UL-DPCCH2-Information >-----#
    UL_DPCCH2_Information = SEQ(name='UL-DPCCH2-Information', mode=MODE_TYPE)
    _UL_DPCCH2_Information_f_DPCH_Info = SEQ(name='f-DPCH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-Info')))
    _UL_DPCCH2_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCCH2_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCCH2_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCCH2_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_iE_Extensions__item__id._const_tab = ____UL_DPCCH2_Information_iE_Extensions__item__id_tab
    ___UL_DPCCH2_Information_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCCH2_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCCH2_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCCH2_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_iE_Extensions__item__criticality._const_tab = ____UL_DPCCH2_Information_iE_Extensions__item__criticality_tab
    ___UL_DPCCH2_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCCH2_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCCH2_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCCH2_Information_iE_Extensions__item__extensionValue_tab
    ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCCH2_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCCH2_Information_iE_Extensions__item__id),
        ('criticality', ___UL_DPCCH2_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCCH2_Information_iE_Extensions__item_._ext = None
    _UL_DPCCH2_Information_iE_Extensions._cont = __UL_DPCCH2_Information_iE_Extensions__item_
    _UL_DPCCH2_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCCH2_Information._cont = ASN1Dict([
        ('f-DPCH-Info', _UL_DPCCH2_Information_f_DPCH_Info),
        ('iE-Extensions', _UL_DPCCH2_Information_iE_Extensions),
        ])
    UL_DPCCH2_Information._ext = []
    
    #-----< UL-DPCCH2-Information-ExtIEs >-----#
    UL_DPCCH2_Information_ExtIEs = CLASS(name='UL-DPCCH2-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCCH2_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCCH2-Information-Reconf >-----#
    UL_DPCCH2_Information_Reconf = SEQ(name='UL-DPCCH2-Information-Reconf', mode=MODE_TYPE)
    _UL_DPCCH2_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2 = CHOICE(name='setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2')))
    _UL_DPCCH2_Information_Reconf_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCCH2_Information_Reconf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id._const_tab = ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__id_tab
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality._const_tab = ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality_tab
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue_tab
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCCH2_Information_Reconf_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id),
        ('criticality', ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCCH2_Information_Reconf_iE_Extensions__item_._ext = None
    _UL_DPCCH2_Information_Reconf_iE_Extensions._cont = __UL_DPCCH2_Information_Reconf_iE_Extensions__item_
    _UL_DPCCH2_Information_Reconf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCCH2_Information_Reconf._cont = ASN1Dict([
        ('setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2', _UL_DPCCH2_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2),
        ('iE-Extensions', _UL_DPCCH2_Information_Reconf_iE_Extensions),
        ])
    UL_DPCCH2_Information_Reconf._ext = []
    
    #-----< UL-DPCCH2-Information-Reconf-ExtIEs >-----#
    UL_DPCCH2_Information_Reconf_ExtIEs = CLASS(name='UL-DPCCH2-Information-Reconf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCCH2_Information_Reconf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCCH2-Information-Removal >-----#
    UL_DPCCH2_Information_Removal = ENUM(name='UL-DPCCH2-Information-Removal', mode=MODE_TYPE)
    UL_DPCCH2_Information_Removal._cont = ASN1Dict([('remove', 0)])
    UL_DPCCH2_Information_Removal._ext = []
    
    #-----< UL-DPCCH2-Information-To-Modify >-----#
    UL_DPCCH2_Information_To_Modify = SEQ(name='UL-DPCCH2-Information-To-Modify', mode=MODE_TYPE)
    _UL_DPCCH2_Information_To_Modify_f_DPCH_Info = SEQ(name='f-DPCH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-Info-To-Modify')), opt=True)
    _UL_DPCCH2_Information_To_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCCH2_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id._const_tab = ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id_tab
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality_tab
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue_tab
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCCH2_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id),
        ('criticality', ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCCH2_Information_To_Modify_iE_Extensions__item_._ext = None
    _UL_DPCCH2_Information_To_Modify_iE_Extensions._cont = __UL_DPCCH2_Information_To_Modify_iE_Extensions__item_
    _UL_DPCCH2_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCCH2_Information_To_Modify._cont = ASN1Dict([
        ('f-DPCH-Info', _UL_DPCCH2_Information_To_Modify_f_DPCH_Info),
        ('iE-Extensions', _UL_DPCCH2_Information_To_Modify_iE_Extensions),
        ])
    UL_DPCCH2_Information_To_Modify._ext = []
    
    #-----< UL-DPCCH2-Information-To-Modify-ExtIEs >-----#
    UL_DPCCH2_Information_To_Modify_ExtIEs = CLASS(name='UL-DPCCH2-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCCH2_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-MIMO-Information >-----#
    UL_MIMO_Information = SEQ(name='UL-MIMO-Information', mode=MODE_TYPE)
    _UL_MIMO_Information_e_roch_power_offset = INT(name='e-roch-power-offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-ROCH-PowerOffset')), opt=True)
    _UL_MIMO_Information_s_e_dpcch_power_offset = INT(name='s-e-dpcch-power-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'S-E-DPCCH-PowerOffset')))
    _UL_MIMO_Information_interstream_compensation = INT(name='interstream-compensation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InterStream-Interference-Compensation')))
    _UL_MIMO_Information_minimum_E_TFCI_rank2 = INT(name='minimum-E-TFCI-rank2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_MIMO_Information_minimum_E_TFCI_rank2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _UL_MIMO_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_MIMO_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_MIMO_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_MIMO_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_iE_Extensions__item__id._const_tab = ____UL_MIMO_Information_iE_Extensions__item__id_tab
    ___UL_MIMO_Information_iE_Extensions__item__id._const_tab_at = None
    ___UL_MIMO_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_MIMO_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_MIMO_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_iE_Extensions__item__criticality._const_tab = ____UL_MIMO_Information_iE_Extensions__item__criticality_tab
    ___UL_MIMO_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_MIMO_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_MIMO_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_MIMO_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_iE_Extensions__item__extensionValue._const_tab = ____UL_MIMO_Information_iE_Extensions__item__extensionValue_tab
    ___UL_MIMO_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_MIMO_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_MIMO_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_MIMO_Information_iE_Extensions__item__id),
        ('criticality', ___UL_MIMO_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_MIMO_Information_iE_Extensions__item__extensionValue),
        ])
    __UL_MIMO_Information_iE_Extensions__item_._ext = None
    _UL_MIMO_Information_iE_Extensions._cont = __UL_MIMO_Information_iE_Extensions__item_
    _UL_MIMO_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_MIMO_Information._cont = ASN1Dict([
        ('e-roch-power-offset', _UL_MIMO_Information_e_roch_power_offset),
        ('s-e-dpcch-power-offset', _UL_MIMO_Information_s_e_dpcch_power_offset),
        ('interstream-compensation', _UL_MIMO_Information_interstream_compensation),
        ('minimum-E-TFCI-rank2', _UL_MIMO_Information_minimum_E_TFCI_rank2),
        ('iE-Extensions', _UL_MIMO_Information_iE_Extensions),
        ])
    UL_MIMO_Information._ext = []
    
    #-----< UL-MIMO-Information-To-Modify >-----#
    UL_MIMO_Information_To_Modify = SEQ(name='UL-MIMO-Information-To-Modify', mode=MODE_TYPE)
    _UL_MIMO_Information_To_Modify_e_roch_power_offset = INT(name='e-roch-power-offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-ROCH-PowerOffset')), opt=True)
    _UL_MIMO_Information_To_Modify_s_e_dpcch_power_offset = INT(name='s-e-dpcch-power-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'S-E-DPCCH-PowerOffset')), opt=True)
    _UL_MIMO_Information_To_Modify_interstream_compensation = INT(name='interstream-compensation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InterStream-Interference-Compensation')), opt=True)
    _UL_MIMO_Information_To_Modify_minimum_E_TFCI_rank2 = INT(name='minimum-E-TFCI-rank2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_MIMO_Information_To_Modify_minimum_E_TFCI_rank2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _UL_MIMO_Information_To_Modify_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_MIMO_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id._const_tab = ____UL_MIMO_Information_To_Modify_iE_Extensions__item__id_tab
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_MIMO_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id),
        ('criticality', ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __UL_MIMO_Information_To_Modify_iE_Extensions__item_._ext = None
    _UL_MIMO_Information_To_Modify_iE_Extensions._cont = __UL_MIMO_Information_To_Modify_iE_Extensions__item_
    _UL_MIMO_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_MIMO_Information_To_Modify._cont = ASN1Dict([
        ('e-roch-power-offset', _UL_MIMO_Information_To_Modify_e_roch_power_offset),
        ('s-e-dpcch-power-offset', _UL_MIMO_Information_To_Modify_s_e_dpcch_power_offset),
        ('interstream-compensation', _UL_MIMO_Information_To_Modify_interstream_compensation),
        ('minimum-E-TFCI-rank2', _UL_MIMO_Information_To_Modify_minimum_E_TFCI_rank2),
        ('iE-Extensions', _UL_MIMO_Information_To_Modify_iE_Extensions),
        ])
    UL_MIMO_Information_To_Modify._ext = []
    
    #-----< UL-MIMO-Reconfiguration >-----#
    UL_MIMO_Reconfiguration = CHOICE(name='UL-MIMO-Reconfiguration', mode=MODE_TYPE)
    _UL_MIMO_Reconfiguration_setup = SEQ(name='setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-MIMO-Information')))
    _UL_MIMO_Reconfiguration_configurationChange = SEQ(name='configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-MIMO-Information-To-Modify')))
    _UL_MIMO_Reconfiguration_removal = ENUM(name='removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-MIMO-Removal')))
    UL_MIMO_Reconfiguration._cont = ASN1Dict([
        ('setup', _UL_MIMO_Reconfiguration_setup),
        ('configurationChange', _UL_MIMO_Reconfiguration_configurationChange),
        ('removal', _UL_MIMO_Reconfiguration_removal),
        ])
    UL_MIMO_Reconfiguration._ext = None
    
    #-----< UL-MIMO-Removal >-----#
    UL_MIMO_Removal = ENUM(name='UL-MIMO-Removal', mode=MODE_TYPE)
    UL_MIMO_Removal._cont = ASN1Dict([('remove', 0)])
    UL_MIMO_Removal._ext = []
    
    #-----< UL-MIMO-DL-Control-Channel-Information >-----#
    UL_MIMO_DL_Control_Channel_Information = SEQ(name='UL-MIMO-DL-Control-Channel-Information', mode=MODE_TYPE)
    _UL_MIMO_DL_Control_Channel_Information_e_roch_channelization_code = INT(name='e-roch-channelization-code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _UL_MIMO_DL_Control_Channel_Information_s_e_rnti = INT(name='s-e-rnti', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _UL_MIMO_DL_Control_Channel_Information_s_signature_sequence = INT(name='s-signature-sequence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-Signature-Sequence')))
    _UL_MIMO_DL_Control_Channel_Information_s_e_roch_release_indicator = ENUM(name='s-e-roch-release-indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'S-E-ROCH-Release-Indicator')), opt=True)
    _UL_MIMO_DL_Control_Channel_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id._const_tab = ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id_tab
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id._const_tab_at = None
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality._const_tab = ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality_tab
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue._const_tab = ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue_tab
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id),
        ('criticality', ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue),
        ])
    __UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item_._ext = None
    _UL_MIMO_DL_Control_Channel_Information_iE_Extensions._cont = __UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item_
    _UL_MIMO_DL_Control_Channel_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_MIMO_DL_Control_Channel_Information._cont = ASN1Dict([
        ('e-roch-channelization-code', _UL_MIMO_DL_Control_Channel_Information_e_roch_channelization_code),
        ('s-e-rnti', _UL_MIMO_DL_Control_Channel_Information_s_e_rnti),
        ('s-signature-sequence', _UL_MIMO_DL_Control_Channel_Information_s_signature_sequence),
        ('s-e-roch-release-indicator', _UL_MIMO_DL_Control_Channel_Information_s_e_roch_release_indicator),
        ('iE-Extensions', _UL_MIMO_DL_Control_Channel_Information_iE_Extensions),
        ])
    UL_MIMO_DL_Control_Channel_Information._ext = []
    
    #-----< UL-MIMO-Information-ExtIEs >-----#
    UL_MIMO_Information_ExtIEs = CLASS(name='UL-MIMO-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_MIMO_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-MIMO-Information-To-Modify-ExtIEs >-----#
    UL_MIMO_Information_To_Modify_ExtIEs = CLASS(name='UL-MIMO-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_MIMO_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-MIMO-DL-Control-Channel-Information-ExtIEs >-----#
    UL_MIMO_DL_Control_Channel_Information_ExtIEs = CLASS(name='UL-MIMO-DL-Control-Channel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_MIMO_DL_Control_Channel_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-ROCH-PowerOffset >-----#
    E_ROCH_PowerOffset = INT(name='E-ROCH-PowerOffset', mode=MODE_TYPE)
    E_ROCH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< S-E-DPCCH-PowerOffset >-----#
    S_E_DPCCH_PowerOffset = INT(name='S-E-DPCCH-PowerOffset', mode=MODE_TYPE)
    S_E_DPCCH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=17)], ev=[], er=[])
    
    #-----< InterStream-Interference-Compensation >-----#
    InterStream_Interference_Compensation = INT(name='InterStream-Interference-Compensation', mode=MODE_TYPE)
    InterStream_Interference_Compensation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< S-E-ROCH-Release-Indicator >-----#
    S_E_ROCH_Release_Indicator = ENUM(name='S-E-ROCH-Release-Indicator', mode=MODE_TYPE)
    S_E_ROCH_Release_Indicator._cont = ASN1Dict([('s-E-ROCHreleased', 0)])
    S_E_ROCH_Release_Indicator._ext = None
    
    #-----< UL-TimeslotISCP-For-CellPortion-Value >-----#
    UL_TimeslotISCP_For_CellPortion_Value = SEQ_OF(name='UL-TimeslotISCP-For-CellPortion-Value', mode=MODE_TYPE)
    _UL_TimeslotISCP_For_CellPortion_Value__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-For-CellPortion-Value-Item')))
    UL_TimeslotISCP_For_CellPortion_Value._cont = _UL_TimeslotISCP_For_CellPortion_Value__item_
    UL_TimeslotISCP_For_CellPortion_Value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UL-TimeslotISCP-For-CellPortion-Value-Item >-----#
    UL_TimeslotISCP_For_CellPortion_Value_Item = SEQ(name='UL-TimeslotISCP-For-CellPortion-Value-Item', mode=MODE_TYPE)
    _UL_TimeslotISCP_For_CellPortion_Value_Item_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _UL_TimeslotISCP_For_CellPortion_Value_Item_uL_TimeslotISCP_Value = INT(name='uL-TimeslotISCP-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotISCP-Value')))
    _UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab = ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__id_tab
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab_at = None
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab = ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab = ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__id),
        ('criticality', ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue),
        ])
    __UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item_._ext = None
    _UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions._cont = __UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item_
    _UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_TimeslotISCP_For_CellPortion_Value_Item._cont = ASN1Dict([
        ('cellPortionLCRID', _UL_TimeslotISCP_For_CellPortion_Value_Item_cellPortionLCRID),
        ('uL-TimeslotISCP-Value', _UL_TimeslotISCP_For_CellPortion_Value_Item_uL_TimeslotISCP_Value),
        ('iE-Extensions', _UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions),
        ])
    UL_TimeslotISCP_For_CellPortion_Value_Item._ext = []
    
    #-----< UL-TimeslotISCP-For-CellPortion-Value-Item-ExtIEs >-----#
    UL_TimeslotISCP_For_CellPortion_Value_Item_ExtIEs = CLASS(name='UL-TimeslotISCP-For-CellPortion-Value-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_TimeslotISCP_For_CellPortion_Value_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-TimeslotISCP-Value >-----#
    UL_TimeslotISCP_Value = INT(name='UL-TimeslotISCP-Value', mode=MODE_TYPE)
    UL_TimeslotISCP_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< UL-TimeslotISCP-Value-IncrDecrThres >-----#
    UL_TimeslotISCP_Value_IncrDecrThres = INT(name='UL-TimeslotISCP-Value-IncrDecrThres', mode=MODE_TYPE)
    UL_TimeslotISCP_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=126)], ev=None, er=[])
    
    #-----< USCH-ID >-----#
    USCH_ID = INT(name='USCH-ID', mode=MODE_TYPE)
    USCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< Usefulness-Of-Battery-Optimization >-----#
    Usefulness_Of_Battery_Optimization = ENUM(name='Usefulness-Of-Battery-Optimization', mode=MODE_TYPE)
    Usefulness_Of_Battery_Optimization._cont = ASN1Dict([('can-benefit', 0), ('cannot-benefit', 1)])
    Usefulness_Of_Battery_Optimization._ext = None
    
    #-----< Uu-ActivationState >-----#
    Uu_ActivationState = ENUM(name='Uu-ActivationState', mode=MODE_TYPE)
    Uu_ActivationState._cont = ASN1Dict([('activated', 0), ('de-activated', 1), ('changeRequest', 2)])
    Uu_ActivationState._ext = ['changeRequest']
    
    _all_ = [
        AckNack_RepetitionFactor,
        Ack_Power_Offset,
        Acknowledged_PRACH_preambles_Value,
        ActivationDelay,
        _ActivationInformation__item_,
        ActivationInformation,
        _ActivationInformationItem_uU_ActivationState,
        ____ActivationInformationItem_iE_Extensions__item__id_tab,
        ___ActivationInformationItem_iE_Extensions__item__id,
        ____ActivationInformationItem_iE_Extensions__item__criticality_tab,
        ___ActivationInformationItem_iE_Extensions__item__criticality,
        ____ActivationInformationItem_iE_Extensions__item__extensionValue_tab,
        ___ActivationInformationItem_iE_Extensions__item__extensionValue,
        __ActivationInformationItem_iE_Extensions__item_,
        _ActivationInformationItem_iE_Extensions,
        ActivationInformationItem,
        ActivationInformationItem_ExtIEs,
        Adaptive_Special_Burst_Power_CapabilityLCR,
        _EDCH_Reference_E_TFCI_Information__item_,
        EDCH_Reference_E_TFCI_Information,
        _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI,
        _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI_PO,
        ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab,
        ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id,
        ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab,
        ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality,
        ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue,
        __EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item_,
        _EDCH_Reference_E_TFCI_Information_Item_iE_Extensions,
        EDCH_Reference_E_TFCI_Information_Item,
        EDCH_Reference_E_TFCI_Information_Item_ExtIEs,
        EDCH_Reference_E_TFCI_PO,
        _Additional_EDCH_Setup_Info_multicell_EDCH_Transport_Bearer_Mode,
        _Additional_EDCH_Setup_Info_additional_EDCH_Cell_Information_Setup,
        ____Additional_EDCH_Setup_Info_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Setup_Info_iE_Extensions__item__id,
        ____Additional_EDCH_Setup_Info_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality,
        ____Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Setup_Info_iE_Extensions__item_,
        _Additional_EDCH_Setup_Info_iE_Extensions,
        Additional_EDCH_Setup_Info,
        Additional_EDCH_Setup_Info_ExtIEs,
        Multicell_EDCH_Transport_Bearer_Mode,
        _Additional_EDCH_Cell_Information_Setup__item_,
        Additional_EDCH_Cell_Information_Setup,
        _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_UL_DPCH_Information_Setup,
        _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_RL_Specific_Information_To_Setup,
        _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_FDD_Information,
        _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_F_DPCH_Information_Setup,
        _Additional_EDCH_FDD_Setup_Cell_Information_multicell_EDCH_Information,
        ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id_tab,
        ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id,
        ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality,
        ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue,
        __Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item_,
        _Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions,
        Additional_EDCH_FDD_Setup_Cell_Information,
        Additional_EDCH_FDD_Setup_Cell_Information_ExtIEs,
        _Additional_EDCH_UL_DPCH_Information_Setup_ul_ScramblingCode,
        _Additional_EDCH_UL_DPCH_Information_Setup_ul_SIR_Target,
        ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id_tab,
        ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id,
        ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality,
        ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue,
        __Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item_,
        _Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions,
        Additional_EDCH_UL_DPCH_Information_Setup,
        Additional_EDCH_UL_DPCH_Information_Setup_ExtIEs,
        _Additional_EDCH_F_DPCH_Information_fdd_TPC_DownlinkStepSize,
        _Additional_EDCH_F_DPCH_Information_limitedPowerIncrease,
        _Additional_EDCH_F_DPCH_Information_innerLoopDLPCStatus,
        ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id_tab,
        ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id,
        ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality,
        ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue,
        __Additional_EDCH_F_DPCH_Information_iE_Extensions__item_,
        _Additional_EDCH_F_DPCH_Information_iE_Extensions,
        Additional_EDCH_F_DPCH_Information,
        Additional_EDCH_F_DPCH_Information_ExtIEs,
        _Additional_EDCH_RL_Specific_Information_To_Setup_List__item_,
        Additional_EDCH_RL_Specific_Information_To_Setup_List,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_eDCH_Additional_RL_ID,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_c_ID,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_firstRLS_indicator,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_propagationDelay,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_dl_CodeInformation,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_initialDL_transmissionPower,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_maximumDL_power,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_minimumDL_power,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_f_DPCH_SlotFormat,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_RNTI,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_multicell_EDCH_RL_Specific_Information,
        ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab,
        _____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0,
        ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id,
        ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality,
        ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions,
        Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs,
        Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs_val_Extension_0,
        _Additional_EDCH_Cell_Information_To_Add_List__item_,
        Additional_EDCH_Cell_Information_To_Add_List,
        _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add_ItemIEs,
        _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_FDD_Information,
        _Additional_EDCH_Cell_Information_To_Add_ItemIEs_multicell_EDCH_Information,
        ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions,
        Additional_EDCH_Cell_Information_To_Add_ItemIEs,
        Additional_EDCH_Cell_Information_To_Add_ItemIEs_ExtIEs,
        _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs__item_,
        Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs,
        _EDCH_Additional_RL_Specific_Information_To_Add_List_eDCH_Additional_RL_ID,
        _EDCH_Additional_RL_Specific_Information_To_Add_List_c_ID,
        _EDCH_Additional_RL_Specific_Information_To_Add_List_dl_CodeInformation,
        _EDCH_Additional_RL_Specific_Information_To_Add_List_initialDL_transmissionPower,
        _EDCH_Additional_RL_Specific_Information_To_Add_List_maximumDL_power,
        _EDCH_Additional_RL_Specific_Information_To_Add_List_minimumDL_power,
        _EDCH_Additional_RL_Specific_Information_To_Add_List_f_DPCH_SlotFormat,
        _EDCH_Additional_RL_Specific_Information_To_Add_List_multicell_EDCH_RL_Specific_Information,
        ____EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id_tab,
        _____EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id_tab_val_Extension_0,
        ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__id,
        ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__criticality,
        ___EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item__extensionValue,
        __EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions__item_,
        _EDCH_Additional_RL_Specific_Information_To_Add_List_iE_Extensions,
        EDCH_Additional_RL_Specific_Information_To_Add_List,
        EDCH_Additional_RL_Specific_Information_To_Add_List_ExtIEs,
        _EDCH_Additional_RL_Specific_Information_To_Add_List_ExtIEs_val_Extension_0,
        _Additional_EDCH_RL_Specific_Information_To_Modify_List__item_,
        Additional_EDCH_RL_Specific_Information_To_Modify_List,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_eDCH_Additional_RL_ID,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_dl_CodeInformation,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_maximumDL_power,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_minimumDL_power,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_f_DPCH_SlotFormat,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_multicell_EDCH_RL_Specific_Information,
        ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab,
        _____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0,
        ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id,
        ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality,
        ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions,
        Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs,
        Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs_val_Extension_0,
        _Additional_EDCH_FDD_Information_additional_EDCH_MAC_d_Flows_Specific_Information,
        _Additional_EDCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        _Additional_EDCH_FDD_Information_e_DCH_Maximum_Bitrate,
        _Additional_EDCH_FDD_Information_e_DCH_Processing_Overload_Level,
        _Additional_EDCH_FDD_Information_e_DCH_Min_Set_E_TFCI,
        ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab,
        _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3,
        ___Additional_EDCH_FDD_Information_iE_Extensions__item__id,
        ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality,
        ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue,
        __Additional_EDCH_FDD_Information_iE_Extensions__item_,
        _Additional_EDCH_FDD_Information_iE_Extensions,
        Additional_EDCH_FDD_Information,
        Additional_EDCH_FDD_Information_ExtIEs,
        _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_0,
        _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_1,
        _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_2,
        _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_3,
        _DTX_Information2_uE_DTX_Cycle1,
        _DTX_Information2_uE_DTX_Cycle2,
        _DTX_Information2_inactivity_Threshold_for_UE_DTX_Cycle2,
        ____DTX_Information2_iE_Extensions__item__id_tab,
        ___DTX_Information2_iE_Extensions__item__id,
        ____DTX_Information2_iE_Extensions__item__criticality_tab,
        ___DTX_Information2_iE_Extensions__item__criticality,
        ____DTX_Information2_iE_Extensions__item__extensionValue_tab,
        ___DTX_Information2_iE_Extensions__item__extensionValue,
        __DTX_Information2_iE_Extensions__item_,
        _DTX_Information2_iE_Extensions,
        DTX_Information2,
        DTX_Information2_ExtIEs,
        Implicit_Grant_Handling,
        Minimum_TEBS_threshold,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_List__item_,
        Additional_EDCH_MAC_d_Flows_Specific_Info_List,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_e_DCH_MACdFlow_ID,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_bindingID,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_transportLayerAddress,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue,
        __Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item_,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions,
        Additional_EDCH_MAC_d_Flows_Specific_Info,
        Additional_EDCH_MAC_d_Flows_Specific_Info_ExtIEs,
        _Additional_EDCH_Cell_Information_Response_List__item_,
        Additional_EDCH_Cell_Information_Response_List,
        _Additional_EDCH_FDD_Information_Response_ItemIEs_eDCH_Additional_RL_Specific_Information_Response,
        _Additional_EDCH_FDD_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response,
        _Additional_EDCH_FDD_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions,
        Additional_EDCH_FDD_Information_Response_ItemIEs,
        Additional_EDCH_FDD_Information_Response_ItemIEs_ExtIEs,
        _EDCH_Additional_RL_Specific_Information_Response_List__item_,
        EDCH_Additional_RL_Specific_Information_Response_List,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_eDCH_Additional_RL_ID,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_received_total_wide_band_power,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dL_PowerBalancing_ActivationIndicator,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_rL_Set_ID,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_e_DCH_RL_Set_ID,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_e_DCH_FDD_DL_Control_Channel_Information,
        ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id_tab,
        ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id,
        ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab,
        ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality,
        ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue,
        __EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item_,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions,
        EDCH_Additional_RL_Specific_Information_Response_ItemIEs,
        EDCH_Additional_RL_Specific_Information_Response_ItemIEs_ExtIEs,
        _Additional_EDCH_Cell_Information_Response_RLReconf_List__item_,
        Additional_EDCH_Cell_Information_Response_RLReconf_List,
        _Additional_EDCH_FDD_Information_Response_RLReconf_Items_additional_EDCH_FDD_Information_Response_ItemIEs,
        _Additional_EDCH_FDD_Information_Response_RLReconf_Items_additional_Modififed_EDCH_FDD_Information_Response_ItemIEs,
        ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id_tab,
        ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id,
        ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality,
        ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue,
        __Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item_,
        _Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions,
        Additional_EDCH_FDD_Information_Response_RLReconf_Items,
        Additional_EDCH_FDD_Information_Response_RLReconf_Items_ExtIEs,
        _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_eDCH_Additional_Modified_RL_Specific_Information_Response,
        _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response,
        _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id,
        ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_,
        _Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions,
        Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs,
        Additional_Modififed_EDCH_FDD_Information_Response_ItemIEs_ExtIEs,
        _EDCH_Additional_Modified_RL_Specific_Information_Response_List__item_,
        EDCH_Additional_Modified_RL_Specific_Information_Response_List,
        _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_eDCH_Additional_RL_ID,
        _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_dL_PowerBalancing_UpdatedIndicator,
        _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_e_DCH_FDD_DL_Control_Channel_Information,
        ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__id_tab,
        ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__id,
        ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__criticality_tab,
        ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__criticality,
        ____EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__extensionValue_tab,
        ___EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item__extensionValue,
        __EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions__item_,
        _EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_iE_Extensions,
        EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items,
        EDCH_Additional_Modified_RL_Specific_Information_Response_List_Items_ExtIEs,
        _Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List__item_,
        Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_e_DCH_MACdFlow_ID,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_bindingID,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_transportLayerAddress,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue,
        __Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item_,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions,
        Additional_EDCH_MAC_d_Flows_Specific_Info_Response,
        Additional_EDCH_MAC_d_Flows_Specific_Info_Response_ExtIEs,
        _Additional_EDCH_Cell_Information_Response_RL_Add_List__item_,
        Additional_EDCH_Cell_Information_Response_RL_Add_List,
        _Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_additional_EDCH_FDD_Information_Response,
        _Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_additional_EDCH_Serving_Cell_Change_Information_Response,
        ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_iE_Extensions,
        Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs,
        Additional_EDCH_Cell_Information_Response_RL_Add_ItemIEs_ExtIEs,
        _Additional_EDCH_Cell_Information_ConfigurationChange_List__item_,
        Additional_EDCH_Cell_Information_ConfigurationChange_List,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_UL_DPCH_Information_Modify,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Modify,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_FDD_Information_To_Modify,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_F_DPCH_Information_Modify,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_multicell_EDCH_Information,
        ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions,
        Additional_EDCH_ConfigurationChange_Info_ItemIEs,
        Additional_EDCH_ConfigurationChange_Info_ItemIEs_ExtIEs,
        _Additional_EDCH_UL_DPCH_Information_Modify_ul_ScramblingCode,
        _Additional_EDCH_UL_DPCH_Information_Modify_ul_SIR_Target,
        ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id_tab,
        ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id,
        ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality,
        ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue,
        __Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item_,
        _Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions,
        Additional_EDCH_UL_DPCH_Information_Modify,
        Additional_EDCH_UL_DPCH_Information_Modify_ExtIEs,
        _Additional_EDCH_Cell_Information_Removal_List__item_,
        Additional_EDCH_Cell_Information_Removal_List,
        _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_rL_on_Secondary_UL_Frequency,
        ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions,
        Additional_EDCH_Cell_Information_Removal_Info_ItemIEs,
        Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_ExtIEs,
        RL_on_Secondary_UL_Frequency,
        _Additional_EDCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        _Additional_EDCH_FDD_Update_Information_additional_EDCH_DL_Control_Channel_Change_Information,
        ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id_tab,
        ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id,
        ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality,
        ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue,
        __Additional_EDCH_FDD_Update_Information_iE_Extensions__item_,
        _Additional_EDCH_FDD_Update_Information_iE_Extensions,
        Additional_EDCH_FDD_Update_Information,
        Additional_EDCH_FDD_Update_Information_ExtIEs,
        _Additional_EDCH_DL_Control_Channel_Change_Information_List__item_,
        Additional_EDCH_DL_Control_Channel_Change_Information_List,
        _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_eDCH_Additional_RL_ID,
        ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions,
        Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs,
        Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_ExtIEs,
        _AdditionalMeasurementValueList__item_,
        AdditionalMeasurementValueList,
        _AdditionalMeasurementValue_uARFCN,
        _AdditionalMeasurementValue_timeSlotMeasurementValueListLCR,
        ____AdditionalMeasurementValue_iE_Extensions__item__id_tab,
        ___AdditionalMeasurementValue_iE_Extensions__item__id,
        ____AdditionalMeasurementValue_iE_Extensions__item__criticality_tab,
        ___AdditionalMeasurementValue_iE_Extensions__item__criticality,
        ____AdditionalMeasurementValue_iE_Extensions__item__extensionValue_tab,
        ___AdditionalMeasurementValue_iE_Extensions__item__extensionValue,
        __AdditionalMeasurementValue_iE_Extensions__item_,
        _AdditionalMeasurementValue_iE_Extensions,
        AdditionalMeasurementValue,
        AdditionalMeasurementValueList_ExtIEs,
        _AdditionalTimeSlotListLCR__item_,
        AdditionalTimeSlotListLCR,
        _AdditionalTimeSlotLCR_uARFCN,
        _AdditionalTimeSlotLCR_timeslot_InitiatedListLCR,
        ____AdditionalTimeSlotLCR_iE_Extensions__item__id_tab,
        ___AdditionalTimeSlotLCR_iE_Extensions__item__id,
        ____AdditionalTimeSlotLCR_iE_Extensions__item__criticality_tab,
        ___AdditionalTimeSlotLCR_iE_Extensions__item__criticality,
        ____AdditionalTimeSlotLCR_iE_Extensions__item__extensionValue_tab,
        ___AdditionalTimeSlotLCR_iE_Extensions__item__extensionValue,
        __AdditionalTimeSlotLCR_iE_Extensions__item_,
        _AdditionalTimeSlotLCR_iE_Extensions,
        AdditionalTimeSlotLCR,
        AdditionalTimeSlotLCR_ExtIEs,
        AddorDeleteIndicator,
        _Active_Pattern_Sequence_Information_cMConfigurationChangeCFN,
        _Active_Pattern_Sequence_Information_transmission_Gap_Pattern_Sequence_Status,
        ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab,
        ___Active_Pattern_Sequence_Information_iE_Extensions__item__id,
        ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab,
        ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality,
        ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab,
        ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue,
        __Active_Pattern_Sequence_Information_iE_Extensions__item_,
        _Active_Pattern_Sequence_Information_iE_Extensions,
        Active_Pattern_Sequence_Information,
        Active_Pattern_Sequence_Information_ExtIEs,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPSID,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPRC,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__tGCFN,
        _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab,
        ______Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab_val_Extension_0,
        ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id,
        ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality,
        ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue,
        ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions,
        _Transmission_Gap_Pattern_Sequence_Status_List__item_,
        Transmission_Gap_Pattern_Sequence_Status_List,
        Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs,
        _Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs_val_Extension_0,
        _Affected_HSDSCH_Serving_Cell_List__item_,
        Affected_HSDSCH_Serving_Cell_List,
        AICH_Power,
        AICH_TransmissionTiming,
        _AllocationRetentionPriority_priorityLevel,
        _AllocationRetentionPriority_pre_emptionCapability,
        _AllocationRetentionPriority_pre_emptionVulnerability,
        ____AllocationRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationRetentionPriority_iE_Extensions__item__id,
        ____AllocationRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationRetentionPriority_iE_Extensions__item_,
        _AllocationRetentionPriority_iE_Extensions,
        AllocationRetentionPriority,
        AllocationRetentionPriority_ExtIEs,
        AlternativeFormatReportingIndicator,
        _Angle_Of_Arrival_Value_LCR_aOA_LCR,
        _Angle_Of_Arrival_Value_LCR_aOA_LCR_Accuracy_Class,
        ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id_tab,
        ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id,
        ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality_tab,
        ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality,
        ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue_tab,
        ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue,
        __Angle_Of_Arrival_Value_LCR_iE_Extensions__item_,
        _Angle_Of_Arrival_Value_LCR_iE_Extensions,
        Angle_Of_Arrival_Value_LCR,
        Angle_Of_Arrival_Value_LCR_ExtIEs,
        AOA_LCR,
        AOA_LCR_Accuracy_Class,
        _AOA_per_CELL_Portion_LCR__item_,
        AOA_per_CELL_Portion_LCR,
        _AOA_per_CELL_Portion_LCR_Item_cellPortionLCRID,
        _AOA_per_CELL_Portion_LCR_Item_aOA_LCR,
        _AOA_per_CELL_Portion_LCR_Item_aOA_LCR_Accuracy_Class,
        ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__id_tab,
        ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__id,
        ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__criticality_tab,
        ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__criticality,
        ____AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__extensionValue_tab,
        ___AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item__extensionValue,
        __AOA_per_CELL_Portion_LCR_Item_iE_Extensions__item_,
        _AOA_per_CELL_Portion_LCR_Item_iE_Extensions,
        AOA_per_CELL_Portion_LCR_Item,
        AOA_per_CELL_Portion_LCR_Item_ExtIEs,
        AvailabilityStatus,
        _BCCH_Specific_HSDSCH_RNTI_Information_bCCH_Specific_HSDSCH_RNTI,
        _BCCH_Specific_HSDSCH_RNTI_Information_hSSCCH_Power,
        _BCCH_Specific_HSDSCH_RNTI_Information_hSPDSCH_Power,
        ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__id_tab,
        ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__id,
        ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__criticality_tab,
        ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__criticality,
        ____BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__extensionValue_tab,
        ___BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item__extensionValue,
        __BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions__item_,
        _BCCH_Specific_HSDSCH_RNTI_Information_iE_Extensions,
        BCCH_Specific_HSDSCH_RNTI_Information,
        BCCH_Specific_HSDSCH_RNTI_Information_ExtIEs,
        _BCCH_Specific_HSDSCH_RNTI_InformationLCR_bCCH_Specific_HSDSCH_RNTI,
        _BCCH_Specific_HSDSCH_RNTI_InformationLCR_hSSCCH_Power,
        _BCCH_Specific_HSDSCH_RNTI_InformationLCR_hSPDSCH_Power,
        ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__id_tab,
        ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__id,
        ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__criticality_tab,
        ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__criticality,
        ____BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item__extensionValue,
        __BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions__item_,
        _BCCH_Specific_HSDSCH_RNTI_InformationLCR_iE_Extensions,
        BCCH_Specific_HSDSCH_RNTI_InformationLCR,
        BCCH_Specific_HSDSCH_RNTI_InformationLCR_ExtIEs,
        BCCH_ModificationTime,
        _BDS_IGPInfoList__item_,
        BDS_IGPInfoList,
        _BDS_IGPInfo_bds_IGPNumber,
        _BDS_IGPInfo_bds_VerticalDelay,
        _BDS_IGPInfo_bds_GIVEI,
        ____BDS_IGPInfo_ie_Extensions__item__id_tab,
        ___BDS_IGPInfo_ie_Extensions__item__id,
        ____BDS_IGPInfo_ie_Extensions__item__criticality_tab,
        ___BDS_IGPInfo_ie_Extensions__item__criticality,
        ____BDS_IGPInfo_ie_Extensions__item__extensionValue_tab,
        ___BDS_IGPInfo_ie_Extensions__item__extensionValue,
        __BDS_IGPInfo_ie_Extensions__item_,
        _BDS_IGPInfo_ie_Extensions,
        BDS_IGPInfo,
        BDS_IGPInfo_ExtIEs,
        BDS_IonosphericGridModelReq,
        _BDS_Ionospheric_Grid_Model_bDS_RefTime,
        _BDS_Ionospheric_Grid_Model_bds_IGPInfoList,
        ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__id_tab,
        ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id,
        ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality_tab,
        ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality,
        ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue_tab,
        ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue,
        __BDS_Ionospheric_Grid_Model_ie_Extensions__item_,
        _BDS_Ionospheric_Grid_Model_ie_Extensions,
        BDS_Ionospheric_Grid_Model,
        BDS_Ionospheric_Grid_Model_ExtIEs,
        _Best_Cell_Portions_Value__item_,
        Best_Cell_Portions_Value,
        _Best_Cell_Portions_Item_cellPortionID,
        _Best_Cell_Portions_Item_sIRValue,
        ____Best_Cell_Portions_Item_iE_Extensions__item__id_tab,
        ___Best_Cell_Portions_Item_iE_Extensions__item__id,
        ____Best_Cell_Portions_Item_iE_Extensions__item__criticality_tab,
        ___Best_Cell_Portions_Item_iE_Extensions__item__criticality,
        ____Best_Cell_Portions_Item_iE_Extensions__item__extensionValue_tab,
        ___Best_Cell_Portions_Item_iE_Extensions__item__extensionValue,
        __Best_Cell_Portions_Item_iE_Extensions__item_,
        _Best_Cell_Portions_Item_iE_Extensions,
        Best_Cell_Portions_Item,
        Best_Cell_Portions_Item_ExtIEs,
        _Best_Cell_Portions_ValueLCR__item_,
        Best_Cell_Portions_ValueLCR,
        _Best_Cell_Portions_ItemLCR_cellPortionLCRID,
        _Best_Cell_Portions_ItemLCR_rSCPValue,
        ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__id_tab,
        ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__id,
        ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__criticality_tab,
        ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__criticality,
        ____Best_Cell_Portions_ItemLCR_iE_Extensions__item__extensionValue_tab,
        ___Best_Cell_Portions_ItemLCR_iE_Extensions__item__extensionValue,
        __Best_Cell_Portions_ItemLCR_iE_Extensions__item_,
        _Best_Cell_Portions_ItemLCR_iE_Extensions,
        Best_Cell_Portions_ItemLCR,
        Best_Cell_Portions_ItemLCR_ExtIEs,
        BindingID,
        BetaCD,
        BlockingPriorityIndicator,
        SCTD_Indicator,
        BundlingModeIndicator,
        _BroadcastCommonTransportBearerIndication_commonTransportChannelID,
        _BroadcastCommonTransportBearerIndication_cid,
        ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__id_tab,
        ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__id,
        ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__criticality_tab,
        ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__criticality,
        ____BroadcastCommonTransportBearerIndication_iE_Extensions__item__extensionValue_tab,
        ___BroadcastCommonTransportBearerIndication_iE_Extensions__item__extensionValue,
        __BroadcastCommonTransportBearerIndication_iE_Extensions__item_,
        _BroadcastCommonTransportBearerIndication_iE_Extensions,
        BroadcastCommonTransportBearerIndication,
        BroadcastCommonTransportBearerIndication_ExtIEs,
        BroadcastReference,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        CCTrCH_ID,
        Cell_Capability_Container,
        _Cell_ERNTI_Status_Information__item_,
        Cell_ERNTI_Status_Information,
        _Cell_ERNTI_Status_Information_Item_c_ID,
        _Cell_ERNTI_Status_Information_Item_vacant_ERNTI,
        Cell_ERNTI_Status_Information_Item,
        _Vacant_ERNTI__item_,
        Vacant_ERNTI,
        CellParameterID,
        CellPortionID,
        CellPortionLCRID,
        CellPortion_CapabilityLCR,
        CellSyncBurstCode,
        CellSyncBurstCodeShift,
        CellSyncBurstRepetitionPeriod,
        CellSyncBurstSIR,
        _CellSyncBurstTiming_initialPhase,
        _CellSyncBurstTiming_steadyStatePhase,
        CellSyncBurstTiming,
        _CellSyncBurstTimingLCR_initialPhase,
        _CellSyncBurstTimingLCR_steadyStatePhase,
        CellSyncBurstTimingLCR,
        CellSyncBurstTimingThreshold,
        CFN,
        ChipOffset,
        C_ID,
        Closedlooptimingadjustmentmode,
        CodeRate,
        CodeRate_short,
        __CommonChannelsCapacityConsumptionLaw__item__dl_Cost,
        __CommonChannelsCapacityConsumptionLaw__item__ul_Cost,
        _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id_tab,
        ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id,
        _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality_tab,
        ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality,
        _____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue_tab,
        ____CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue,
        ___CommonChannelsCapacityConsumptionLaw__item__iE_Extensions__item_,
        __CommonChannelsCapacityConsumptionLaw__item__iE_Extensions,
        _CommonChannelsCapacityConsumptionLaw__item_,
        CommonChannelsCapacityConsumptionLaw,
        CommonChannelsCapacityConsumptionLaw_ExtIEs,
        Common_EDCH_Capability,
        Common_E_DCH_HSDPCCH_Capability,
        _Common_EDCH_System_InformationFDD_common_E_DCH_UL_DPCH_Information,
        _Common_EDCH_System_InformationFDD_common_E_DCH_EDPCH_Information,
        _Common_EDCH_System_InformationFDD_common_E_DCH_Information,
        _Common_EDCH_System_InformationFDD_common_E_DCH_HSDPCCH_Information,
        _Common_EDCH_System_InformationFDD_common_E_DCH_Preamble_Control_Information,
        _Common_EDCH_System_InformationFDD_common_E_DCH_FDPCH_Information,
        _Common_EDCH_System_InformationFDD_common_E_DCH_E_AGCH_ChannelisationCodeNumber,
        _Common_EDCH_System_InformationFDD_common_E_DCH_Resource_Combination_Information,
        _Common_EDCH_System_InformationFDD_ul_common_E_DCH_MACflow_Specific_Information,
        ____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_9,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_10,
        _____Common_EDCH_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_11,
        ___Common_EDCH_System_InformationFDD_iE_Extensions__item__id,
        ___Common_EDCH_System_InformationFDD_iE_Extensions__item__criticality,
        ___Common_EDCH_System_InformationFDD_iE_Extensions__item__extensionValue,
        __Common_EDCH_System_InformationFDD_iE_Extensions__item_,
        _Common_EDCH_System_InformationFDD_iE_Extensions,
        Common_EDCH_System_InformationFDD,
        Common_EDCH_System_InformationFDD_ExtIEs,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_0,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_1,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_2,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_3,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_4,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_5,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_6,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_7,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_8,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_9,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_10,
        _Common_EDCH_System_InformationFDD_ExtIEs_val_Extension_11,
        _E_RNTI_Set_starting_e_rnti,
        _E_RNTI_Set_ending_e_rnti,
        ____E_RNTI_Set_iE_Extensions__item__id_tab,
        ___E_RNTI_Set_iE_Extensions__item__id,
        ____E_RNTI_Set_iE_Extensions__item__criticality_tab,
        ___E_RNTI_Set_iE_Extensions__item__criticality,
        ____E_RNTI_Set_iE_Extensions__item__extensionValue_tab,
        ___E_RNTI_Set_iE_Extensions__item__extensionValue,
        __E_RNTI_Set_iE_Extensions__item_,
        _E_RNTI_Set_iE_Extensions,
        E_RNTI_Set,
        E_RNTI_Set_ExtIEs,
        _Common_E_DCH_UL_DPCH_InfoItem_uL_SIR_Target,
        _Common_E_DCH_UL_DPCH_InfoItem_dPC_Mode,
        ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__id_tab,
        ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__id,
        ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__criticality,
        ____Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item__extensionValue,
        __Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions__item_,
        _Common_E_DCH_UL_DPCH_InfoItem_iE_Extensions,
        Common_E_DCH_UL_DPCH_InfoItem,
        Common_E_DCH_UL_DPCH_InfoItem_ExtIEs,
        _Common_E_DCH_EDPCH_InfoItem_maxSet_E_DPDCHs,
        _Common_E_DCH_EDPCH_InfoItem_ul_PunctureLimit,
        _Common_E_DCH_EDPCH_InfoItem_e_TFCS_Information,
        _Common_E_DCH_EDPCH_InfoItem_e_TTI,
        _Common_E_DCH_EDPCH_InfoItem_e_DPCCH_PO,
        _Common_E_DCH_EDPCH_InfoItem_e_RGCH_2_IndexStepThreshold,
        _Common_E_DCH_EDPCH_InfoItem_e_RGCH_3_IndexStepThreshold,
        _Common_E_DCH_EDPCH_InfoItem_hARQ_Info_for_E_DCH,
        ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__id_tab,
        ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__id,
        ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__criticality,
        ____Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item__extensionValue,
        __Common_E_DCH_EDPCH_InfoItem_iE_Extensions__item_,
        _Common_E_DCH_EDPCH_InfoItem_iE_Extensions,
        Common_E_DCH_EDPCH_InfoItem,
        Common_E_DCH_EDPCH_InfoItem_ExtIEs,
        _Common_E_DCH_InfoItem_e_DCH_Reference_Power_Offset,
        _Common_E_DCH_InfoItem_e_DCH_PowerOffset_for_SchedulingInfo,
        _Common_E_DCH_InfoItem_max_EDCH_Resource_Allocation_for_CCCH,
        _Common_E_DCH_InfoItem_max_Period_for_Collision_Resolution,
        _Common_E_DCH_InfoItem_max_TB_Sizes,
        _Common_E_DCH_InfoItem_common_E_DCH_ImplicitRelease_Indicator,
        ____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab,
        _____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____Common_E_DCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___Common_E_DCH_InfoItem_iE_Extensions__item__id,
        ___Common_E_DCH_InfoItem_iE_Extensions__item__criticality,
        ___Common_E_DCH_InfoItem_iE_Extensions__item__extensionValue,
        __Common_E_DCH_InfoItem_iE_Extensions__item_,
        _Common_E_DCH_InfoItem_iE_Extensions,
        Common_E_DCH_InfoItem,
        Common_E_DCH_InfoItem_ExtIEs,
        _Common_E_DCH_InfoItem_ExtIEs_val_Extension_0,
        _Common_E_DCH_InfoItem_ExtIEs_val_Extension_1,
        CommonEDCH_AdditionalTransmissionBackOff,
        _Common_E_DCH_HSDPCCH_InfoItem_ackNackRepetitionFactor,
        _Common_E_DCH_HSDPCCH_InfoItem_ackPowerOffset,
        _Common_E_DCH_HSDPCCH_InfoItem_nackPowerOffset,
        _Common_E_DCH_HSDPCCH_InfoItem_common_E_DCH_CQI_Info,
        ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__id_tab,
        ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__id,
        ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__criticality,
        ____Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item__extensionValue,
        __Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions__item_,
        _Common_E_DCH_HSDPCCH_InfoItem_iE_Extensions,
        Common_E_DCH_HSDPCCH_InfoItem,
        Common_E_DCH_HSDPCCH_InfoItem_ExtIEs,
        _Common_E_DCH_CQI_Info_cqiFeedback_CycleK,
        _Common_E_DCH_CQI_Info_cqiRepetitionFactor,
        _Common_E_DCH_CQI_Info_cqiPowerOffset,
        _Common_E_DCH_CQI_Info_measurement_Power_Offset,
        ____Common_E_DCH_CQI_Info_iE_Extensions__item__id_tab,
        ___Common_E_DCH_CQI_Info_iE_Extensions__item__id,
        ____Common_E_DCH_CQI_Info_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_CQI_Info_iE_Extensions__item__criticality,
        ____Common_E_DCH_CQI_Info_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_CQI_Info_iE_Extensions__item__extensionValue,
        __Common_E_DCH_CQI_Info_iE_Extensions__item_,
        _Common_E_DCH_CQI_Info_iE_Extensions,
        Common_E_DCH_CQI_Info,
        Common_E_DCH_CQI_Info_ExtIEs,
        _Common_E_DCH_Preamble_Control_InfoItem_commonPhysicalChannelID,
        _Common_E_DCH_Preamble_Control_InfoItem_common_E_DCH_PreambleSignatures,
        _Common_E_DCH_Preamble_Control_InfoItem_scramblingCodeNumber,
        _Common_E_DCH_Preamble_Control_InfoItem_preambleThreshold,
        _Common_E_DCH_Preamble_Control_InfoItem_e_AI_Indicator,
        _Common_E_DCH_Preamble_Control_InfoItem_common_E_DCH_AICH_Information,
        ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__id_tab,
        ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__id,
        ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__criticality,
        ____Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item__extensionValue,
        __Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions__item_,
        _Common_E_DCH_Preamble_Control_InfoItem_iE_Extensions,
        Common_E_DCH_Preamble_Control_InfoItem,
        Common_E_DCH_Preamble_Control_InfoItem_ExtIEs,
        _Common_E_DCH_AICH_Information_commonPhysicalChannelID,
        _Common_E_DCH_AICH_Information_aICH_TransmissionTiming,
        _Common_E_DCH_AICH_Information_fdd_dl_ChannelisationCodeNumber,
        _Common_E_DCH_AICH_Information_aICH_Power,
        _Common_E_DCH_AICH_Information_sTTD_Indicator,
        ____Common_E_DCH_AICH_Information_iE_Extensions__item__id_tab,
        ___Common_E_DCH_AICH_Information_iE_Extensions__item__id,
        ____Common_E_DCH_AICH_Information_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_AICH_Information_iE_Extensions__item__criticality,
        ____Common_E_DCH_AICH_Information_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_AICH_Information_iE_Extensions__item__extensionValue,
        __Common_E_DCH_AICH_Information_iE_Extensions__item_,
        _Common_E_DCH_AICH_Information_iE_Extensions,
        Common_E_DCH_AICH_Information,
        Common_E_DCH_AICH_Information_ExtIEs,
        _Common_E_DCH_FDPCH_InfoItem_f_DPCH_SlotFormat,
        _Common_E_DCH_FDPCH_InfoItem_fdd_TPC_DownlinkStepSize,
        ____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab,
        _____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__id,
        ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__criticality,
        ___Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item__extensionValue,
        __Common_E_DCH_FDPCH_InfoItem_iE_Extensions__item_,
        _Common_E_DCH_FDPCH_InfoItem_iE_Extensions,
        Common_E_DCH_FDPCH_InfoItem,
        Common_E_DCH_FDPCH_InfoItem_ExtIEs,
        _Common_E_DCH_FDPCH_InfoItem_ExtIEs_val_Extension_0,
        _Common_E_DCH_FDPCH_InfoItem_ExtIEs_val_Extension_1,
        _Common_E_DCH_FDPCH_InfoItem_ExtIEs_val_Extension_2,
        _Common_E_DCH_Resource_Combination_InfoList__item_,
        Common_E_DCH_Resource_Combination_InfoList,
        _Common_E_DCH_Resource_Combination_InfoList_Item_soffset,
        _Common_E_DCH_Resource_Combination_InfoList_Item_f_DPCH_DL_Code_Number,
        _Common_E_DCH_Resource_Combination_InfoList_Item_ul_DPCH_ScramblingCode,
        _Common_E_DCH_Resource_Combination_InfoList_Item_e_RGCH_E_HICH_Channelisation_Code,
        _Common_E_DCH_Resource_Combination_InfoList_Item_e_RGCH_Signature_Sequence,
        _Common_E_DCH_Resource_Combination_InfoList_Item_e_HICH_Signature_Sequence,
        ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__id_tab,
        ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__id,
        ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__criticality,
        ____Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item__extensionValue,
        __Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions__item_,
        _Common_E_DCH_Resource_Combination_InfoList_Item_iE_Extensions,
        Common_E_DCH_Resource_Combination_InfoList_Item,
        Common_E_DCH_Resource_Combination_InfoList_Item_ExtIEs,
        _Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_maximum_Number_of_Retransmissions_For_E_DCH,
        _Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_eDCH_HARQ_PO_FDD,
        ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__id_tab,
        ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__id,
        ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__criticality,
        ____Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item__extensionValue,
        __Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions__item_,
        _Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_iE_Extensions,
        Common_E_DCH_MAC_d_flow_info_Concurrent_TTI,
        Common_E_DCH_MAC_d_flow_info_Concurrent_TTI_ExtIEs,
        _Ul_common_E_DCH_MACflow_Specific_InfoList__item_,
        Ul_common_E_DCH_MACflow_Specific_InfoList,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_ul_Common_MACFlowID,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_transportBearerRequestIndicator,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_bindingID,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_transportLayerAddress,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_tnlQos,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_payloadCRC_PresenceIndicator,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_bundlingModeIndicator,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_common_E_DCH_MACdFlow_Specific_Information,
        ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__id_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__id,
        ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__criticality_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__criticality,
        ____Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__extensionValue_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item__extensionValue,
        __Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions__item_,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_Item_iE_Extensions,
        Ul_common_E_DCH_MACflow_Specific_InfoList_Item,
        Ul_common_E_DCH_MACflow_Specific_InfoList_Item_ExtIEs,
        _Common_E_DCH_MACdFlow_Specific_InfoList__item_,
        Common_E_DCH_MACdFlow_Specific_InfoList,
        _Common_E_DCH_MACdFlow_Specific_InfoList_Item_common_e_DCH_MACdFlow_ID,
        _Common_E_DCH_MACdFlow_Specific_InfoList_Item_maximum_Number_of_Retransmissions_For_E_DCH,
        _Common_E_DCH_MACdFlow_Specific_InfoList_Item_eDCH_HARQ_PO_FDD,
        _Common_E_DCH_MACdFlow_Specific_InfoList_Item_eDCH_MACdFlow_Multiplexing_List,
        _Common_E_DCH_MACdFlow_Specific_InfoList_Item_common_E_DCHLogicalChannelInformation,
        ____Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id_tab,
        _____Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__id,
        ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__criticality,
        ___Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item__extensionValue,
        __Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions__item_,
        _Common_E_DCH_MACdFlow_Specific_InfoList_Item_iE_Extensions,
        Common_E_DCH_MACdFlow_Specific_InfoList_Item,
        Common_E_DCH_MACdFlow_Specific_InfoList_Item_ExtIEs,
        _Common_E_DCH_MACdFlow_Specific_InfoList_Item_ExtIEs_val_Extension_0,
        _Common_E_DCH_LogicalChannel_InfoList__item_,
        Common_E_DCH_LogicalChannel_InfoList,
        _Common_E_DCH_LogicalChannel_InfoList_Item_logicalChannelId,
        _Common_E_DCH_LogicalChannel_InfoList_Item_maximumMACcPDU_SizeExtended,
        ____Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id_tab,
        _____Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__id,
        ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__criticality,
        ___Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item__extensionValue,
        __Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions__item_,
        _Common_E_DCH_LogicalChannel_InfoList_Item_iE_Extensions,
        Common_E_DCH_LogicalChannel_InfoList_Item,
        Common_E_DCH_LogicalChannel_InfoList_Item_ExtIEs,
        _Common_E_DCH_LogicalChannel_InfoList_Item_ExtIEs_val_Extension_0,
        _Common_EDCH_System_Information_ResponseFDD_ul_common_E_DCH_MACflow_Specific_InfoResponse,
        _Common_EDCH_System_Information_ResponseFDD_serving_Grant_Value,
        ____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab,
        _____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id_tab_val_Extension_2,
        ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__id,
        ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__criticality,
        ___Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item__extensionValue,
        __Common_EDCH_System_Information_ResponseFDD_iE_Extensions__item_,
        _Common_EDCH_System_Information_ResponseFDD_iE_Extensions,
        Common_EDCH_System_Information_ResponseFDD,
        Common_EDCH_System_Information_ResponseFDD_ExtIEs,
        _Common_EDCH_System_Information_ResponseFDD_ExtIEs_val_Extension_0,
        _Common_EDCH_System_Information_ResponseFDD_ExtIEs_val_Extension_1,
        _Common_EDCH_System_Information_ResponseFDD_ExtIEs_val_Extension_2,
        _E_RNTI_List__item_,
        E_RNTI_List,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseList__item_,
        Ul_common_E_DCH_MACflow_Specific_InfoResponseList,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_ul_Common_MACFlowID,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_bindingID,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_transportLayerAddress,
        ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__id_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__id,
        ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__criticality_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__criticality,
        ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__extensionValue_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item__extensionValue,
        __Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions__item_,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_iE_Extensions,
        Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item,
        Ul_common_E_DCH_MACflow_Specific_InfoResponseList_Item_ExtIEs,
        _Common_HSDSCH_RNTI_List__item_,
        Common_HSDSCH_RNTI_List,
        _Common_MACFlows_to_DeleteFDD__item_,
        Common_MACFlows_to_DeleteFDD,
        _Common_MACFlows_to_DeleteFDD_Item_common_MACFlow_ID,
        ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id_tab,
        ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id,
        ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality_tab,
        ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality,
        ____Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue_tab,
        ___Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue,
        __Common_MACFlows_to_DeleteFDD_Item_iE_Extensions__item_,
        _Common_MACFlows_to_DeleteFDD_Item_iE_Extensions,
        Common_MACFlows_to_DeleteFDD_Item,
        Common_MACFlows_to_DeleteFDD_Item_ExtIEs,
        Common_MACFlow_ID,
        _CommonMACFlow_Specific_InfoList__item_,
        CommonMACFlow_Specific_InfoList,
        _CommonMACFlow_Specific_InfoItem_common_MACFlow_Id,
        _CommonMACFlow_Specific_InfoItem_bindingID,
        _CommonMACFlow_Specific_InfoItem_transportLayerAddress,
        _CommonMACFlow_Specific_InfoItem_tnl_qos,
        _CommonMACFlow_Specific_InfoItem_common_MACFlow_PriorityQueue_Information,
        ____CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id_tab,
        _____CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__id,
        ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__criticality,
        ___CommonMACFlow_Specific_InfoItem_iE_Extensions__item__extensionValue,
        __CommonMACFlow_Specific_InfoItem_iE_Extensions__item_,
        _CommonMACFlow_Specific_InfoItem_iE_Extensions,
        CommonMACFlow_Specific_InfoItem,
        CommonMACFlow_Specific_InfoItem_ExtIEs,
        _CommonMACFlow_Specific_InfoItem_ExtIEs_val_Extension_0,
        _CommonMACFlow_Specific_InfoList_Response__item_,
        CommonMACFlow_Specific_InfoList_Response,
        _CommonMACFlow_Specific_InfoItem_Response_commonMACFlow_ID,
        _CommonMACFlow_Specific_InfoItem_Response_bindingID,
        _CommonMACFlow_Specific_InfoItem_Response_transportLayerAddress,
        _CommonMACFlow_Specific_InfoItem_Response_hSDSCH_Initial_Capacity_Allocation,
        ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__id_tab,
        ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__id,
        ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab,
        ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality,
        ____CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab,
        ___CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue,
        __CommonMACFlow_Specific_InfoItem_Response_iE_Extensions__item_,
        _CommonMACFlow_Specific_InfoItem_Response_iE_Extensions,
        CommonMACFlow_Specific_InfoItem_Response,
        CommonMACFlow_Specific_InfoItem_Response_ExtIEs,
        _Common_MACFlow_PriorityQueue_Information__item_,
        Common_MACFlow_PriorityQueue_Information,
        _Common_MACFlow_PriorityQueue_Item_priority_Queue_Information_for_Enhanced_FACH,
        ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__id_tab,
        ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__id,
        ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality_tab,
        ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality,
        ____Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue_tab,
        ___Common_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue,
        __Common_MACFlow_PriorityQueue_Item_iE_Extensions__item_,
        _Common_MACFlow_PriorityQueue_Item_iE_Extensions,
        Common_MACFlow_PriorityQueue_Item,
        Common_MACFlow_PriorityQueue_Item_ExtIEs,
        _CommonMeasurementAccuracy_tUTRANGPSMeasurementAccuracyClass,
        _CommonMeasurementAccuracy_tUTRANGANSSMeasurementAccuracyClass,
        CommonMeasurementAccuracy,
        CommonMeasurementType,
        _CommonMeasurementValue_transmitted_carrier_power,
        _CommonMeasurementValue_received_total_wide_band_power,
        _CommonMeasurementValue_acknowledged_prach_preambles,
        _CommonMeasurementValue_uL_TimeslotISCP,
        _CommonMeasurementValue_notUsed_1_acknowledged_PCPCH_access_preambles,
        _CommonMeasurementValue_notUsed_2_detected_PCPCH_access_preambles,
        _CommonMeasurementValue_extension_CommonMeasurementValue,
        CommonMeasurementValue,
        __Extension_CommonMeasurementValue_id_tab,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_0,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_1,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_2,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_3,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_4,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_5,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_6,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_7,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_8,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_9,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_10,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_11,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_12,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_13,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_14,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_15,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_16,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_17,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_18,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_19,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_20,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_21,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_22,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_23,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_24,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_25,
        _Extension_CommonMeasurementValue_id,
        _Extension_CommonMeasurementValue_criticality,
        _Extension_CommonMeasurementValue_value,
        Extension_CommonMeasurementValue,
        Extension_CommonMeasurementValueIE,
        _Extension_CommonMeasurementValueIE_val_Value_0,
        _Extension_CommonMeasurementValueIE_val_Value_1,
        _Extension_CommonMeasurementValueIE_val_Value_2,
        _Extension_CommonMeasurementValueIE_val_Value_3,
        _Extension_CommonMeasurementValueIE_val_Value_4,
        _Extension_CommonMeasurementValueIE_val_Value_5,
        _Extension_CommonMeasurementValueIE_val_Value_6,
        _Extension_CommonMeasurementValueIE_val_Value_7,
        _Extension_CommonMeasurementValueIE_val_Value_8,
        _Extension_CommonMeasurementValueIE_val_Value_9,
        _Extension_CommonMeasurementValueIE_val_Value_10,
        _Extension_CommonMeasurementValueIE_val_Value_11,
        _Extension_CommonMeasurementValueIE_val_Value_12,
        _Extension_CommonMeasurementValueIE_val_Value_13,
        _Extension_CommonMeasurementValueIE_val_Value_14,
        _Extension_CommonMeasurementValueIE_val_Value_15,
        _Extension_CommonMeasurementValueIE_val_Value_16,
        _Extension_CommonMeasurementValueIE_val_Value_17,
        _Extension_CommonMeasurementValueIE_val_Value_18,
        _Extension_CommonMeasurementValueIE_val_Value_19,
        _Extension_CommonMeasurementValueIE_val_Value_20,
        _Extension_CommonMeasurementValueIE_val_Value_21,
        _Extension_CommonMeasurementValueIE_val_Value_22,
        _Extension_CommonMeasurementValueIE_val_Value_23,
        _Extension_CommonMeasurementValueIE_val_Value_24,
        _Extension_CommonMeasurementValueIE_val_Value_25,
        _CommonMeasurementValueInformation_measurementAvailable,
        _CommonMeasurementValueInformation_measurementnotAvailable,
        CommonMeasurementValueInformation,
        _CommonMeasurementAvailable_commonmeasurementValue,
        ____CommonMeasurementAvailable_ie_Extensions__item__id_tab,
        ___CommonMeasurementAvailable_ie_Extensions__item__id,
        ____CommonMeasurementAvailable_ie_Extensions__item__criticality_tab,
        ___CommonMeasurementAvailable_ie_Extensions__item__criticality,
        ____CommonMeasurementAvailable_ie_Extensions__item__extensionValue_tab,
        ___CommonMeasurementAvailable_ie_Extensions__item__extensionValue,
        __CommonMeasurementAvailable_ie_Extensions__item_,
        _CommonMeasurementAvailable_ie_Extensions,
        CommonMeasurementAvailable,
        CommonMeasurementAvailableItem_ExtIEs,
        CommonMeasurementnotAvailable,
        CommonPhysicalChannelID,
        CommonPhysicalChannelID768,
        _Common_PhysicalChannel_Status_Information_commonPhysicalChannelID,
        _Common_PhysicalChannel_Status_Information_resourceOperationalState,
        _Common_PhysicalChannel_Status_Information_availabilityStatus,
        ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__id_tab,
        ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__id,
        ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__criticality_tab,
        ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__criticality,
        ____Common_PhysicalChannel_Status_Information_iE_Extensions__item__extensionValue_tab,
        ___Common_PhysicalChannel_Status_Information_iE_Extensions__item__extensionValue,
        __Common_PhysicalChannel_Status_Information_iE_Extensions__item_,
        _Common_PhysicalChannel_Status_Information_iE_Extensions,
        Common_PhysicalChannel_Status_Information,
        Common_PhysicalChannel_Status_Information_ExtIEs,
        _Common_PhysicalChannel_Status_Information768_commonPhysicalChannelID768,
        _Common_PhysicalChannel_Status_Information768_resourceOperationalState,
        _Common_PhysicalChannel_Status_Information768_availabilityStatus,
        ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__id_tab,
        ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__id,
        ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__criticality_tab,
        ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__criticality,
        ____Common_PhysicalChannel_Status_Information768_iE_Extensions__item__extensionValue_tab,
        ___Common_PhysicalChannel_Status_Information768_iE_Extensions__item__extensionValue,
        __Common_PhysicalChannel_Status_Information768_iE_Extensions__item_,
        _Common_PhysicalChannel_Status_Information768_iE_Extensions,
        Common_PhysicalChannel_Status_Information768,
        Common_PhysicalChannel_Status_Information768_ExtIEs,
        CommonTransportChannelID,
        _CommonTransportChannel_InformationResponse_commonTransportChannelID,
        _CommonTransportChannel_InformationResponse_bindingID,
        _CommonTransportChannel_InformationResponse_transportLayerAddress,
        ____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab,
        _____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab_val_Extension_0,
        _____CommonTransportChannel_InformationResponse_iE_Extensions__item__id_tab_val_Extension_1,
        ___CommonTransportChannel_InformationResponse_iE_Extensions__item__id,
        ___CommonTransportChannel_InformationResponse_iE_Extensions__item__criticality,
        ___CommonTransportChannel_InformationResponse_iE_Extensions__item__extensionValue,
        __CommonTransportChannel_InformationResponse_iE_Extensions__item_,
        _CommonTransportChannel_InformationResponse_iE_Extensions,
        CommonTransportChannel_InformationResponse,
        CommonTransportChannel_InformationResponse_ExtIEs,
        _CommonTransportChannel_InformationResponse_ExtIEs_val_Extension_0,
        _CommonTransportChannel_InformationResponse_ExtIEs_val_Extension_1,
        _Common_TransportChannel_Status_Information_commonTransportChannelID,
        _Common_TransportChannel_Status_Information_resourceOperationalState,
        _Common_TransportChannel_Status_Information_availabilityStatus,
        ____Common_TransportChannel_Status_Information_iE_Extensions__item__id_tab,
        ___Common_TransportChannel_Status_Information_iE_Extensions__item__id,
        ____Common_TransportChannel_Status_Information_iE_Extensions__item__criticality_tab,
        ___Common_TransportChannel_Status_Information_iE_Extensions__item__criticality,
        ____Common_TransportChannel_Status_Information_iE_Extensions__item__extensionValue_tab,
        ___Common_TransportChannel_Status_Information_iE_Extensions__item__extensionValue,
        __Common_TransportChannel_Status_Information_iE_Extensions__item_,
        _Common_TransportChannel_Status_Information_iE_Extensions,
        Common_TransportChannel_Status_Information,
        Common_TransportChannel_Status_Information_ExtIEs,
        CommunicationControlPortID,
        CompleteAlmanacProvided,
        Compressed_Mode_Deactivation_Flag,
        ConfigurationGenerationID,
        ConstantValue,
        ContinuousPacketConnectivityDTX_DRX_Capability,
        _ContinuousPacketConnectivityDTX_DRX_Information_uE_DTX_DRX_Offset,
        _ContinuousPacketConnectivityDTX_DRX_Information_enabling_Delay,
        _ContinuousPacketConnectivityDTX_DRX_Information_dTX_Information,
        _ContinuousPacketConnectivityDTX_DRX_Information_dRX_Information,
        ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__id_tab,
        ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__id,
        ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__criticality_tab,
        ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__criticality,
        ____ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__extensionValue_tab,
        ___ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item__extensionValue,
        __ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions__item_,
        _ContinuousPacketConnectivityDTX_DRX_Information_iE_Extensions,
        ContinuousPacketConnectivityDTX_DRX_Information,
        ContinuousPacketConnectivityDTX_DRX_Information_ExtIEs,
        _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_uE_DTX_DRX_Offset,
        _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_enabling_Delay,
        _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_dTX_Information_to_Modify,
        _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_dRX_Information_to_Modify,
        ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__id_tab,
        ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__id,
        ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__criticality_tab,
        ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__criticality,
        ____ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue_tab,
        ___ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue,
        __ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions__item_,
        _ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_iE_Extensions,
        ContinuousPacketConnectivityDTX_DRX_Information_to_Modify,
        ContinuousPacketConnectivityDTX_DRX_Information_to_Modify_ExtIEs,
        ContinuousPacketConnectivityHS_SCCH_less_Capability,
        _ContinuousPacketConnectivityHS_SCCH_less_Information__item_,
        ContinuousPacketConnectivityHS_SCCH_less_Information,
        _ContinuousPacketConnectivityHS_SCCH_less_InformationItem_transport_Block_Size_Index,
        _ContinuousPacketConnectivityHS_SCCH_less_InformationItem_hSPDSCH_Second_Code_Support,
        ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__id_tab,
        ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__id,
        ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__criticality_tab,
        ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__criticality,
        ____ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item__extensionValue,
        __ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions__item_,
        _ContinuousPacketConnectivityHS_SCCH_less_InformationItem_iE_Extensions,
        ContinuousPacketConnectivityHS_SCCH_less_InformationItem,
        ContinuousPacketConnectivityHS_SCCH_less_Information_ExtIEs,
        _ContinuousPacketConnectivityHS_SCCH_less_Information_Response_hSPDSCH_First_Code_Index,
        _ContinuousPacketConnectivityHS_SCCH_less_Information_Response_hSPDSCH_Second_Code_Index,
        ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__id_tab,
        ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__id,
        ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__criticality_tab,
        ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__criticality,
        ____ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__extensionValue_tab,
        ___ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item__extensionValue,
        __ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions__item_,
        _ContinuousPacketConnectivityHS_SCCH_less_Information_Response_iE_Extensions,
        ContinuousPacketConnectivityHS_SCCH_less_Information_Response,
        ContinuousPacketConnectivityHS_SCCH_less_Information_Response_ExtIEs,
        ControlGAP,
        _CPC_Information_continuousPacketConnectivityDTX_DRX_Information,
        _CPC_Information_continuousPacketConnectivityDTX_DRX_Information_to_Modify,
        _CPC_Information_continuousPacketConnectivityHS_SCCH_less_Information,
        ____CPC_Information_iE_Extensions__item__id_tab,
        _____CPC_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___CPC_Information_iE_Extensions__item__id,
        ___CPC_Information_iE_Extensions__item__criticality,
        ___CPC_Information_iE_Extensions__item__extensionValue,
        __CPC_Information_iE_Extensions__item_,
        _CPC_Information_iE_Extensions,
        CPC_Information,
        CPC_Information_ExtIEs,
        _CPC_Information_ExtIEs_val_Extension_0,
        CPC_RecoveryReport,
        ContinuousPacketConnectivityHS_SCCH_less_Deactivate_Indicator,
        CQI_DTX_Timer,
        CQI_Cycle_Switch_Timer,
        CQI_Feedback_Cycle,
        CQI_Feedback_Cycle2,
        CQI_Power_Offset,
        CQI_RepetitionFactor,
        _CriticalityDiagnostics_procedureID,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_transactionID,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__repetitionNumber,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0,
        ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0,
        _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1,
        CRNC_CommunicationContextID,
        CSBMeasurementID,
        CSBTransmissionID,
        _Common_EDCH_System_InformationLCR_ul_common_E_DCH_MACflow_Specific_InformationLCR,
        _Common_EDCH_System_InformationLCR_common_E_PUCH_InformationLCR,
        _Common_EDCH_System_InformationLCR_e_TFCS_Information_TDD,
        _Common_EDCH_System_InformationLCR_maximum_Number_of_Retransmissions_For_SchedulingInfo,
        _Common_EDCH_System_InformationLCR_eDCH_Retransmission_Timer_SchedulingInfo,
        ____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab,
        _____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab_val_Extension_0,
        _____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab_val_Extension_1,
        _____Common_EDCH_System_InformationLCR_iE_Extensions__item__id_tab_val_Extension_2,
        ___Common_EDCH_System_InformationLCR_iE_Extensions__item__id,
        ___Common_EDCH_System_InformationLCR_iE_Extensions__item__criticality,
        ___Common_EDCH_System_InformationLCR_iE_Extensions__item__extensionValue,
        __Common_EDCH_System_InformationLCR_iE_Extensions__item_,
        _Common_EDCH_System_InformationLCR_iE_Extensions,
        Common_EDCH_System_InformationLCR,
        Common_EDCH_System_InformationLCR_ExtIEs,
        _Common_EDCH_System_InformationLCR_ExtIEs_val_Extension_0,
        _Common_EDCH_System_InformationLCR_ExtIEs_val_Extension_1,
        _Common_EDCH_System_InformationLCR_ExtIEs_val_Extension_2,
        _Common_E_PUCH_InformationLCR_minCR,
        _Common_E_PUCH_InformationLCR_maxCR,
        _Common_E_PUCH_InformationLCR_harqInfo,
        _Common_E_PUCH_InformationLCR_pRXdes_base_perURAFCN,
        _Common_E_PUCH_InformationLCR_e_PUCH_TPC_StepSize,
        _Common_E_PUCH_InformationLCR_e_AGCH_TPC_StepSize,
        _Common_E_PUCH_InformationLCR_e_PUCH_PowerControlGAP,
        ____Common_E_PUCH_InformationLCR_iE_Extensions__item__id_tab,
        ___Common_E_PUCH_InformationLCR_iE_Extensions__item__id,
        ____Common_E_PUCH_InformationLCR_iE_Extensions__item__criticality_tab,
        ___Common_E_PUCH_InformationLCR_iE_Extensions__item__criticality,
        ____Common_E_PUCH_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___Common_E_PUCH_InformationLCR_iE_Extensions__item__extensionValue,
        __Common_E_PUCH_InformationLCR_iE_Extensions__item_,
        _Common_E_PUCH_InformationLCR_iE_Extensions,
        Common_E_PUCH_InformationLCR,
        Common_E_PUCH_InformationLCR_ExtIEs,
        _PRXdes_base_perURAFCN__item_,
        PRXdes_base_perURAFCN,
        _PRXdes_base_Item_pRXdes_base,
        _PRXdes_base_Item_uARFCN,
        ____PRXdes_base_Item_iE_Extensions__item__id_tab,
        ___PRXdes_base_Item_iE_Extensions__item__id,
        ____PRXdes_base_Item_iE_Extensions__item__criticality_tab,
        ___PRXdes_base_Item_iE_Extensions__item__criticality,
        ____PRXdes_base_Item_iE_Extensions__item__extensionValue_tab,
        ___PRXdes_base_Item_iE_Extensions__item__extensionValue,
        __PRXdes_base_Item_iE_Extensions__item_,
        _PRXdes_base_Item_iE_Extensions,
        PRXdes_base_Item,
        PRXdes_base_Item_ExtIEs,
        _Ul_common_E_DCH_MACflow_Specific_InfoListLCR__item_,
        Ul_common_E_DCH_MACflow_Specific_InfoListLCR,
        _Ul_common_E_DCH_MACflow_Specific_InfoListLCR_Ext__item_,
        Ul_common_E_DCH_MACflow_Specific_InfoListLCR_Ext,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_ul_Common_MACFlowIDLCR,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_transportBearerRequestIndicator,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_bindingID,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_transportLayerAddress,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_tnlQos,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_payloadCRC_PresenceIndicator,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_common_E_DCH_MACdFlow_Specific_InformationLCR,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_uARFCN,
        ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__id_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__id,
        ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality,
        ____Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue,
        __Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions__item_,
        _Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_iE_Extensions,
        Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR,
        Ul_common_E_DCH_MACflow_Specific_InfoList_ItemLCR_ExtIEs,
        _Common_E_DCH_MACdFlow_Specific_InfoListLCR__item_,
        Common_E_DCH_MACdFlow_Specific_InfoListLCR,
        _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_common_e_DCH_MACdFlow_ID,
        _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_maximum_Number_of_Retransmissions_For_E_DCH,
        _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_eDCH_MACdFlow_Multiplexing_List,
        _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_common_E_DCHLogicalChannelInformation,
        _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_eDCH_HARQ_PO_TDD,
        _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_eDCH_MACdFlow_Retransmission_Timer,
        ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__id_tab,
        ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__id,
        ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__criticality,
        ____Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item__extensionValue,
        __Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions__item_,
        _Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_iE_Extensions,
        Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR,
        Common_E_DCH_MACdFlow_Specific_InfoList_ItemLCR_ExtIEs,
        _Common_EDCH_System_Information_ResponseLCR_ul_common_E_DCH_MACflow_Specific_InfoResponseLCR,
        _Common_EDCH_System_Information_ResponseLCR_common_E_AGCH_ListLCR,
        _Common_EDCH_System_Information_ResponseLCR_common_E_HICH_ListLCR,
        _Common_EDCH_System_Information_ResponseLCR_common_E_RNTI_Info_LCR,
        ____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab,
        _____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0,
        _____Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_1,
        ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__id,
        ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__criticality,
        ___Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __Common_EDCH_System_Information_ResponseLCR_iE_Extensions__item_,
        _Common_EDCH_System_Information_ResponseLCR_iE_Extensions,
        Common_EDCH_System_Information_ResponseLCR,
        Common_EDCH_System_Information_ResponseLCR_ExtIEs,
        _Common_EDCH_System_Information_ResponseLCR_ExtIEs_val_Extension_0,
        _Common_EDCH_System_Information_ResponseLCR_ExtIEs_val_Extension_1,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR__item_,
        Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR_Ext__item_,
        Ul_common_E_DCH_MACflow_Specific_InfoResponseListLCR_Ext,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_ul_Common_MACFlowID_LCR,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_bindingID,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_transportLayerAddress,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_uARFCN,
        ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__id_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__id,
        ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__criticality_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__criticality,
        ____Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__extensionValue_tab,
        ___Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item__extensionValue,
        __Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions__item_,
        _Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_iE_Extensions,
        Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR,
        Ul_common_E_DCH_MACflow_Specific_InfoResponseList_ItemLCR_ExtIEs,
        _Common_E_AGCH_ListLCR__item_,
        Common_E_AGCH_ListLCR,
        _Common_E_AGCH_ItemLCR_e_AGCH_ID,
        _Common_E_AGCH_ItemLCR_uARFCN,
        ____Common_E_AGCH_ItemLCR_iE_Extensions__item__id_tab,
        ___Common_E_AGCH_ItemLCR_iE_Extensions__item__id,
        ____Common_E_AGCH_ItemLCR_iE_Extensions__item__criticality_tab,
        ___Common_E_AGCH_ItemLCR_iE_Extensions__item__criticality,
        ____Common_E_AGCH_ItemLCR_iE_Extensions__item__extensionValue_tab,
        ___Common_E_AGCH_ItemLCR_iE_Extensions__item__extensionValue,
        __Common_E_AGCH_ItemLCR_iE_Extensions__item_,
        _Common_E_AGCH_ItemLCR_iE_Extensions,
        Common_E_AGCH_ItemLCR,
        Common_E_AGCH_ItemLCR_ExtIEs,
        _Common_E_HICH_ListLCR__item_,
        Common_E_HICH_ListLCR,
        _Common_E_HICH_ItemLCR_eI,
        _Common_E_HICH_ItemLCR_e_HICH_ID,
        ____Common_E_HICH_ItemLCR_iE_Extensions__item__id_tab,
        ___Common_E_HICH_ItemLCR_iE_Extensions__item__id,
        ____Common_E_HICH_ItemLCR_iE_Extensions__item__criticality_tab,
        ___Common_E_HICH_ItemLCR_iE_Extensions__item__criticality,
        ____Common_E_HICH_ItemLCR_iE_Extensions__item__extensionValue_tab,
        ___Common_E_HICH_ItemLCR_iE_Extensions__item__extensionValue,
        __Common_E_HICH_ItemLCR_iE_Extensions__item_,
        _Common_E_HICH_ItemLCR_iE_Extensions,
        Common_E_HICH_ItemLCR,
        Common_E_HICH_ItemLCR_ExtIEs,
        _Common_E_RNTI_Info_LCR__item_,
        Common_E_RNTI_Info_LCR,
        _Common_E_RNTI_Info_ItemLCR_starting_E_RNTI,
        _Common_E_RNTI_Info_ItemLCR_number_of_Group,
        _Common_E_RNTI_Info_ItemLCR_number_of_e_E_RNTI_perGroup,
        ____Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id_tab,
        _____Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__id,
        ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__criticality,
        ___Common_E_RNTI_Info_ItemLCR_iE_Extensions__item__extensionValue,
        __Common_E_RNTI_Info_ItemLCR_iE_Extensions__item_,
        _Common_E_RNTI_Info_ItemLCR_iE_Extensions,
        Common_E_RNTI_Info_ItemLCR,
        Common_E_RNTI_Info_ItemLCR_ExtIEs,
        _Common_E_RNTI_Info_ItemLCR_ExtIEs_val_Extension_0,
        _Common_MACFlows_to_DeleteLCR__item_,
        Common_MACFlows_to_DeleteLCR,
        _Common_MACFlows_to_DeleteLCR_Item_common_MACFlow_ID_LCR,
        ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id_tab,
        ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id,
        ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality_tab,
        ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality,
        ____Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue_tab,
        ___Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue,
        __Common_MACFlows_to_DeleteLCR_Item_iE_Extensions__item_,
        _Common_MACFlows_to_DeleteLCR_Item_iE_Extensions,
        Common_MACFlows_to_DeleteLCR_Item,
        Common_MACFlows_to_DeleteLCR_Item_ExtIEs,
        Common_MACFlow_ID_LCR,
        _CommonMACFlow_Specific_InfoListLCR__item_,
        CommonMACFlow_Specific_InfoListLCR,
        _CommonMACFlow_Specific_InfoItemLCR_common_MACFlow_ID_LCR,
        _CommonMACFlow_Specific_InfoItemLCR_bindingID,
        _CommonMACFlow_Specific_InfoItemLCR_transportLayerAddress,
        _CommonMACFlow_Specific_InfoItemLCR_tnl_qos,
        _CommonMACFlow_Specific_InfoItemLCR_common_MACFlow_PriorityQueue_InformationLCR,
        _CommonMACFlow_Specific_InfoItemLCR_transportBearerRequestIndicator,
        _CommonMACFlow_Specific_InfoItemLCR_uARFCN,
        ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__id_tab,
        ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__id,
        ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__criticality_tab,
        ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__criticality,
        ____CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__extensionValue_tab,
        ___CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item__extensionValue,
        __CommonMACFlow_Specific_InfoItemLCR_iE_Extensions__item_,
        _CommonMACFlow_Specific_InfoItemLCR_iE_Extensions,
        CommonMACFlow_Specific_InfoItemLCR,
        CommonMACFlow_Specific_InfoItemLCR_ExtIEs,
        _Common_H_RNTI_InformationLCR__item_,
        Common_H_RNTI_InformationLCR,
        _Common_H_RNTI_InfoItemLCR_common_H_RNTI,
        ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__id_tab,
        ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__id,
        ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__criticality_tab,
        ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__criticality,
        ____Common_H_RNTI_InfoItemLCR_iE_Extensions__item__extensionValue_tab,
        ___Common_H_RNTI_InfoItemLCR_iE_Extensions__item__extensionValue,
        __Common_H_RNTI_InfoItemLCR_iE_Extensions__item_,
        _Common_H_RNTI_InfoItemLCR_iE_Extensions,
        Common_H_RNTI_InfoItemLCR,
        Common_H_RNTI_InfoItemLCR_ExtIEs,
        _Sync_InformationLCR_t_SYNC,
        _Sync_InformationLCR_t_PROTECT,
        _Sync_InformationLCR_n_PROTECT,
        ____Sync_InformationLCR_iE_Extensions__item__id_tab,
        ___Sync_InformationLCR_iE_Extensions__item__id,
        ____Sync_InformationLCR_iE_Extensions__item__criticality_tab,
        ___Sync_InformationLCR_iE_Extensions__item__criticality,
        ____Sync_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___Sync_InformationLCR_iE_Extensions__item__extensionValue,
        __Sync_InformationLCR_iE_Extensions__item_,
        _Sync_InformationLCR_iE_Extensions,
        Sync_InformationLCR,
        Sync_InformationLCR_ExtIEs,
        _CommonMACFlow_Specific_InfoList_ResponseLCR__item_,
        CommonMACFlow_Specific_InfoList_ResponseLCR,
        _CommonMACFlow_Specific_InfoList_ResponseLCR_Ext__item_,
        CommonMACFlow_Specific_InfoList_ResponseLCR_Ext,
        _CommonMACFlow_Specific_InfoItem_ResponseLCR_common_MACFlow_ID_LCR,
        _CommonMACFlow_Specific_InfoItem_ResponseLCR_bindingID,
        _CommonMACFlow_Specific_InfoItem_ResponseLCR_transportLayerAddress,
        _CommonMACFlow_Specific_InfoItem_ResponseLCR_hSDSCH_Initial_Capacity_Allocation,
        ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__id_tab,
        ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__id,
        ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__criticality_tab,
        ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__criticality,
        ____CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__extensionValue_tab,
        ___CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item__extensionValue,
        __CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions__item_,
        _CommonMACFlow_Specific_InfoItem_ResponseLCR_iE_Extensions,
        CommonMACFlow_Specific_InfoItem_ResponseLCR,
        CommonMACFlow_Specific_InfoItem_ResponseLCR_ExtIEs,
        _CPC_InformationLCR_continuousPacketConnectivity_DRX_InformationLCR,
        _CPC_InformationLCR_continuousPacketConnectivity_DRX_Information_to_Modify_LCR,
        _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_LCR,
        _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR,
        _CPC_InformationLCR_hS_DSCH_SPS_Deactivate_Indicator_LCR,
        _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_LCR,
        _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR,
        _CPC_InformationLCR_e_DCH_SPS_Deactivate_Indicator_LCR,
        ____CPC_InformationLCR_iE_Extensions__item__id_tab,
        ___CPC_InformationLCR_iE_Extensions__item__id,
        ____CPC_InformationLCR_iE_Extensions__item__criticality_tab,
        ___CPC_InformationLCR_iE_Extensions__item__criticality,
        ____CPC_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___CPC_InformationLCR_iE_Extensions__item__extensionValue,
        __CPC_InformationLCR_iE_Extensions__item_,
        _CPC_InformationLCR_iE_Extensions,
        CPC_InformationLCR,
        CPC_InformationLCR_ExtIEs,
        ContinuousPacketConnectivity_DRX_CapabilityLCR,
        _ContinuousPacketConnectivity_DRX_InformationLCR_enabling_Delay,
        _ContinuousPacketConnectivity_DRX_InformationLCR_hS_SCCH_DRX_Information_LCR,
        _ContinuousPacketConnectivity_DRX_InformationLCR_e_AGCH_DRX_Information_LCR,
        ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab,
        _____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id,
        ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality,
        ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue,
        __ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item_,
        _ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions,
        ContinuousPacketConnectivity_DRX_InformationLCR,
        ContinuousPacketConnectivity_DRX_InformationLCR_ExtIEs,
        _ContinuousPacketConnectivity_DRX_InformationLCR_ExtIEs_val_Extension_0,
        _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Cycle_LCR,
        _HS_SCCH_DRX_Information_LCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR,
        _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Offset_LCR,
        ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab,
        _____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id,
        ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality,
        ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue,
        __HS_SCCH_DRX_Information_LCR_iE_Extensions__item_,
        _HS_SCCH_DRX_Information_LCR_iE_Extensions,
        HS_SCCH_DRX_Information_LCR,
        HS_SCCH_DRX_Information_LCR_ExtIEs,
        _HS_SCCH_DRX_Information_LCR_ExtIEs_val_Extension_0,
        _E_AGCH_DRX_Information_LCR_sameAsHS_SCCH,
        _E_AGCH_DRX_Information_LCR_e_AGCH_DRX_Parameters,
        E_AGCH_DRX_Information_LCR,
        _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Cycle_LCR,
        _E_AGCH_DRX_Parameters_e_AGCH_UE_Inactivity_Monitor_Threshold,
        _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Offset_LCR,
        ____E_AGCH_DRX_Parameters_iE_Extensions__item__id_tab,
        ___E_AGCH_DRX_Parameters_iE_Extensions__item__id,
        ____E_AGCH_DRX_Parameters_iE_Extensions__item__criticality_tab,
        ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality,
        ____E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue,
        __E_AGCH_DRX_Parameters_iE_Extensions__item_,
        _E_AGCH_DRX_Parameters_iE_Extensions,
        E_AGCH_DRX_Parameters,
        E_AGCH_DRX_Parameters_ExtIEs,
        UE_DRX_Cycle_LCR,
        UE_DRX_Offset_LCR,
        Inactivity_Threshold_for_UE_DRX_Cycle_LCR,
        Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext,
        E_AGCH_UE_Inactivity_Monitor_Threshold,
        _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_enabling_Delay,
        _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_dRX_Information_to_Modify_LCR,
        ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab,
        _____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id,
        ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality,
        ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue,
        __ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item_,
        _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions,
        ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR,
        ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_ExtIEs,
        _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_ExtIEs_val_Extension_0,
        _DRX_Information_to_Modify_LCR_modify,
        _DRX_Information_to_Modify_LCR_deactivate,
        DRX_Information_to_Modify_LCR,
        _DRX_Information_to_Modify_Items_LCR_hS_SCCH_DRX_Information_LCR,
        _DRX_Information_to_Modify_Items_LCR_e_AGCH_DRX_Information_LCR,
        ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id_tab,
        ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id,
        ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality_tab,
        ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality,
        ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue_tab,
        ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue,
        __DRX_Information_to_Modify_Items_LCR_iE_Extensions__item_,
        _DRX_Information_to_Modify_Items_LCR_iE_Extensions,
        DRX_Information_to_Modify_Items_LCR,
        DRX_Information_to_Modify_Items_LCR_ExtIEs,
        _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_enabling_Delay,
        _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_hS_SCCH_DRX_Information_ResponseLCR,
        _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_e_AGCH_DRX_Information_ResponseLCR,
        ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab,
        _____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id,
        ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality,
        ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item_,
        _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions,
        ContinuousPacketConnectivity_DRX_Information_ResponseLCR,
        ContinuousPacketConnectivity_DRX_Information_ResponseLCR_ExtIEs,
        _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_ExtIEs_val_Extension_0,
        _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Cycle_LCR,
        _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR,
        _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Offset_LCR,
        ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab,
        _____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id,
        ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality,
        ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item_,
        _HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions,
        HS_SCCH_DRX_Information_ResponseLCR,
        HS_SCCH_DRX_Information_ResponseLCR_ExtIEs,
        _HS_SCCH_DRX_Information_ResponseLCR_ExtIEs_val_Extension_0,
        _E_AGCH_DRX_Information_ResponseLCR_sameAsHS_SCCH,
        _E_AGCH_DRX_Information_ResponseLCR_e_AGCH_DRX_Parameters_Response,
        E_AGCH_DRX_Information_ResponseLCR,
        _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Cycle_LCR,
        _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_Inactivity_Monitor_Threshold,
        _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Offset_LCR,
        ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id_tab,
        ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id,
        ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality_tab,
        ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality,
        ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue,
        __E_AGCH_DRX_Parameters_Response_iE_Extensions__item_,
        _E_AGCH_DRX_Parameters_Response_iE_Extensions,
        E_AGCH_DRX_Parameters_Response,
        E_AGCH_DRX_Parameters_Response_ExtIEs,
        Cell_Capability_Container_TDD_LCR,
        Common_E_RGCH_Operation_Indicator,
        _Common_E_RGCH_InfoFDD_e_RGCH_Channelisation_Code,
        _Common_E_RGCH_InfoFDD_e_RGCH_Signature_Sequence,
        _Common_E_RGCH_InfoFDD_minimum_Serving_Grant,
        ____Common_E_RGCH_InfoFDD_iE_Extensions__item__id_tab,
        ___Common_E_RGCH_InfoFDD_iE_Extensions__item__id,
        ____Common_E_RGCH_InfoFDD_iE_Extensions__item__criticality_tab,
        ___Common_E_RGCH_InfoFDD_iE_Extensions__item__criticality,
        ____Common_E_RGCH_InfoFDD_iE_Extensions__item__extensionValue_tab,
        ___Common_E_RGCH_InfoFDD_iE_Extensions__item__extensionValue,
        __Common_E_RGCH_InfoFDD_iE_Extensions__item_,
        _Common_E_RGCH_InfoFDD_iE_Extensions,
        Common_E_RGCH_InfoFDD,
        Common_E_RGCH_InfoFDD_ExtIEs,
        _Concurrent_Deployment_of_2msand10ms_TTI_concurrent_TTI_Partition_Index,
        _Concurrent_Deployment_of_2msand10ms_TTI_common_E_DCH_System_Info_Parameters_for_Concurrent_TTI,
        ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__id_tab,
        ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__id,
        ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__criticality_tab,
        ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__criticality,
        ____Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__extensionValue_tab,
        ___Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item__extensionValue,
        __Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions__item_,
        _Concurrent_Deployment_of_2msand10ms_TTI_iE_Extensions,
        Concurrent_Deployment_of_2msand10ms_TTI,
        Concurrent_Deployment_of_2msand10ms_TTI_ExtIEs,
        Concurrent_TTI_Partition_Index,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_maxSet_E_DPDCHs,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_ul_PunctureLimit,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_TFCS_Information,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_DPCCH_PO,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_RGCH_2_IndexStepThreshold,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_RGCH_3_IndexStepThreshold,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_DCH_Reference_Power_Offset,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_e_DCH_PowerOffset_for_SchedulingInfo,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_max_EDCH_Resource_Allocation_for_CCCH_extension,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_max_Period_for_Collision_Resolution,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_max_TB_Sizes,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_commonEDCH_AdditionalTransmissionBackOff,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_common_E_DCH_E_AGCH_ChannelisationCodeNumber,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_common_E_DCH_HS_DPCCH_Information_forConcurrentTTI,
        ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__id_tab,
        ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__id,
        ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__criticality,
        ____Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item__extensionValue,
        __Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions__item_,
        _Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_iE_Extensions,
        Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI,
        Common_E_DCH_System_Info_Parameters_for_Concurrent_TTI_ExtIEs,
        _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_ackNackRepetitionFactor,
        _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_ackPowerOffset,
        _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_nackPowerOffset,
        _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_common_E_DCH_CQI_Info,
        ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__id_tab,
        ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__id,
        ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__criticality,
        ____Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item__extensionValue,
        __Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions__item_,
        _Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_iE_Extensions,
        Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI,
        Common_E_DCH_HS_DPCCH_Information_forConcurrentTTI_ExtIEs,
        _Common_E_DCH_Preamble_Control_Information_extensionList__item_,
        Common_E_DCH_Preamble_Control_Information_extensionList,
        _Common_E_DCH_Preamble_Control_Information_extensionList_Item_common_E_DCH_Preamble_Control_Information_extension,
        ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__id_tab,
        ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__id,
        ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__criticality,
        ____Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item__extensionValue,
        __Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions__item_,
        _Common_E_DCH_Preamble_Control_Information_extensionList_Item_iE_Extensions,
        Common_E_DCH_Preamble_Control_Information_extensionList_Item,
        Common_E_DCH_Preamble_Control_Information_extensionList_Item_ExtIEs,
        _Common_E_DCH_Preamble_Control_Information_extension_commonPhysicalChannelID,
        _Common_E_DCH_Preamble_Control_Information_extension_scramblingCodeNumber,
        _Common_E_DCH_Preamble_Control_Information_extension_common_E_DCH_PreambleSignatures,
        _Common_E_DCH_Preamble_Control_Information_extension_preambleThreshold,
        _Common_E_DCH_Preamble_Control_Information_extension_common_E_DCH_AICH_Information,
        ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__id_tab,
        ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__id,
        ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__criticality,
        ____Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item__extensionValue,
        __Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions__item_,
        _Common_E_DCH_Preamble_Control_Information_extension_iE_Extensions,
        Common_E_DCH_Preamble_Control_Information_extension,
        Common_E_DCH_Preamble_Control_Information_extension_Item_ExtIEs,
        _Configuration_for_2msTTI_Common_E_DCH_ResourcesList__item_,
        Configuration_for_2msTTI_Common_E_DCH_ResourcesList,
        _Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_two_ms_HARQ_Process_Allocation,
        ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__id_tab,
        ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__id,
        ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__criticality_tab,
        ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__criticality,
        ____Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__extensionValue_tab,
        ___Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item__extensionValue,
        __Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions__item_,
        _Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_iE_Extensions,
        Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item,
        Configuration_for_2msTTI_Common_E_DCH_ResourcesList_Item_ExtIEs,
        Coffset,
        _CHOICE_DRX_level_one_level_DRX,
        _CHOICE_DRX_level_two_level_DRX,
        CHOICE_DRX_level,
        DATA_ID,
        _DBDS_CorrectionsReq_dGANSS_Signal_ID,
        ____DBDS_CorrectionsReq_ie_Extensions__item__id_tab,
        ___DBDS_CorrectionsReq_ie_Extensions__item__id,
        ____DBDS_CorrectionsReq_ie_Extensions__item__criticality_tab,
        ___DBDS_CorrectionsReq_ie_Extensions__item__criticality,
        ____DBDS_CorrectionsReq_ie_Extensions__item__extensionValue_tab,
        ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue,
        __DBDS_CorrectionsReq_ie_Extensions__item_,
        _DBDS_CorrectionsReq_ie_Extensions,
        DBDS_CorrectionsReq,
        DBDS_CorrectionsReq_ExtIEs,
        _DBDS_Corrections_bDS_RefTime,
        _DBDS_Corrections_dBDS_InfoList,
        ____DBDS_Corrections_ie_Extensions__item__id_tab,
        ___DBDS_Corrections_ie_Extensions__item__id,
        ____DBDS_Corrections_ie_Extensions__item__criticality_tab,
        ___DBDS_Corrections_ie_Extensions__item__criticality,
        ____DBDS_Corrections_ie_Extensions__item__extensionValue_tab,
        ___DBDS_Corrections_ie_Extensions__item__extensionValue,
        __DBDS_Corrections_ie_Extensions__item_,
        _DBDS_Corrections_ie_Extensions,
        DBDS_Corrections,
        DBDS_Corrections_ExtIEs,
        _DBDS_Info_dBDS_SignalID,
        _DBDS_Info_dBDS_SignalInfoList,
        ____DBDS_Info_ie_Extensions__item__id_tab,
        ___DBDS_Info_ie_Extensions__item__id,
        ____DBDS_Info_ie_Extensions__item__criticality_tab,
        ___DBDS_Info_ie_Extensions__item__criticality,
        ____DBDS_Info_ie_Extensions__item__extensionValue_tab,
        ___DBDS_Info_ie_Extensions__item__extensionValue,
        __DBDS_Info_ie_Extensions__item_,
        _DBDS_Info_ie_Extensions,
        DBDS_Info,
        DBDS_Info_ExtIEs,
        _DBDS_SignalInfoList__item_,
        DBDS_SignalInfoList,
        _DBDS_SignalInfo_svID,
        _DBDS_SignalInfo_bds_UDREI,
        _DBDS_SignalInfo_bds_RURAI,
        _DBDS_SignalInfo_bds_ECC_DeltaT,
        ____DBDS_SignalInfo_ie_Extensions__item__id_tab,
        ___DBDS_SignalInfo_ie_Extensions__item__id,
        ____DBDS_SignalInfo_ie_Extensions__item__criticality_tab,
        ___DBDS_SignalInfo_ie_Extensions__item__criticality,
        ____DBDS_SignalInfo_ie_Extensions__item__extensionValue_tab,
        ___DBDS_SignalInfo_ie_Extensions__item__extensionValue,
        __DBDS_SignalInfo_ie_Extensions__item_,
        _DBDS_SignalInfo_ie_Extensions,
        DBDS_SignalInfo,
        DBDS_SignalInfo_ExtIEs,
        _DBDS_InfoList__item_,
        DBDS_InfoList,
        _DCH_ENH_Information_pO_SRB,
        _DCH_ENH_Information_dl_FET_Mode,
        _DCH_ENH_Information_dCH_ENH_Concat,
        ____DCH_ENH_Information_iE_Extensions__item__id_tab,
        ___DCH_ENH_Information_iE_Extensions__item__id,
        ____DCH_ENH_Information_iE_Extensions__item__criticality_tab,
        ___DCH_ENH_Information_iE_Extensions__item__criticality,
        ____DCH_ENH_Information_iE_Extensions__item__extensionValue_tab,
        ___DCH_ENH_Information_iE_Extensions__item__extensionValue,
        __DCH_ENH_Information_iE_Extensions__item_,
        _DCH_ENH_Information_iE_Extensions,
        DCH_ENH_Information,
        DCH_ENH_Information_ExtIEs,
        _DCH_ENH_Information_to_Modify_pO_SRB,
        _DCH_ENH_Information_to_Modify_dl_FET_Mode,
        _DCH_ENH_Information_to_Modify_dCH_ENH_Concat,
        ____DCH_ENH_Information_to_Modify_iE_Extensions__item__id_tab,
        ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id,
        ____DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality_tab,
        ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality,
        ____DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue_tab,
        ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue,
        __DCH_ENH_Information_to_Modify_iE_Extensions__item_,
        _DCH_ENH_Information_to_Modify_iE_Extensions,
        DCH_ENH_Information_to_Modify,
        DCH_ENH_Information_to_Modify_ExtIEs,
        DL_FET_Mode,
        _DCH_ENH_Concat__item_,
        DCH_ENH_Concat,
        _DCH_ENH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH,
        ____DCH_ENH_Information_Reconf_iE_Extensions__item__id_tab,
        ___DCH_ENH_Information_Reconf_iE_Extensions__item__id,
        ____DCH_ENH_Information_Reconf_iE_Extensions__item__criticality_tab,
        ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality,
        ____DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue_tab,
        ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue,
        __DCH_ENH_Information_Reconf_iE_Extensions__item_,
        _DCH_ENH_Information_Reconf_iE_Extensions,
        DCH_ENH_Information_Reconf,
        DCH_ENH_Information_Reconf_ExtIEs,
        DCH_ENH_Information_Removal,
        DCH_ID,
        _DCH_FDD_Information__item_,
        DCH_FDD_Information,
        _DCH_FDD_InformationItem_payloadCRC_PresenceIndicator,
        _DCH_FDD_InformationItem_ul_FP_Mode,
        _DCH_FDD_InformationItem_toAWS,
        _DCH_FDD_InformationItem_toAWE,
        _DCH_FDD_InformationItem_dCH_SpecificInformationList,
        ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab,
        _____DCH_FDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___DCH_FDD_InformationItem_iE_Extensions__item__id,
        ___DCH_FDD_InformationItem_iE_Extensions__item__criticality,
        ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue,
        __DCH_FDD_InformationItem_iE_Extensions__item_,
        _DCH_FDD_InformationItem_iE_Extensions,
        DCH_FDD_InformationItem,
        DCH_FDD_InformationItem_ExtIEs,
        _DCH_FDD_InformationItem_ExtIEs_val_Extension_0,
        _DCH_Specific_FDD_InformationList__item_,
        DCH_Specific_FDD_InformationList,
        _DCH_Specific_FDD_Item_dCH_ID,
        _DCH_Specific_FDD_Item_ul_TransportFormatSet,
        _DCH_Specific_FDD_Item_dl_TransportFormatSet,
        _DCH_Specific_FDD_Item_allocationRetentionPriority,
        _DCH_Specific_FDD_Item_frameHandlingPriority,
        _DCH_Specific_FDD_Item_qE_Selector,
        ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab,
        _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___DCH_Specific_FDD_Item_iE_Extensions__item__id,
        ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality,
        ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue,
        __DCH_Specific_FDD_Item_iE_Extensions__item_,
        _DCH_Specific_FDD_Item_iE_Extensions,
        DCH_Specific_FDD_Item,
        DCH_Specific_FDD_Item_ExtIEs,
        _DCH_Specific_FDD_Item_ExtIEs_val_Extension_0,
        DCH_Indicator_For_E_DCH_HSDPA_Operation,
        _DCH_InformationResponse__item_,
        DCH_InformationResponse,
        _DCH_InformationResponseItem_dCH_ID,
        _DCH_InformationResponseItem_bindingID,
        _DCH_InformationResponseItem_transportLayerAddress,
        ____DCH_InformationResponseItem_iE_Extensions__item__id_tab,
        _____DCH_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___DCH_InformationResponseItem_iE_Extensions__item__id,
        ___DCH_InformationResponseItem_iE_Extensions__item__criticality,
        ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue,
        __DCH_InformationResponseItem_iE_Extensions__item_,
        _DCH_InformationResponseItem_iE_Extensions,
        DCH_InformationResponseItem,
        DCH_InformationResponseItem_ExtIEs,
        _DCH_InformationResponseItem_ExtIEs_val_Extension_0,
        _DCH_MeasurementOccasion_Information__item_,
        DCH_MeasurementOccasion_Information,
        _DchMeasurementOccasionInformation_Item_pattern_Sequence_Identifier,
        _DchMeasurementOccasionInformation_Item_status_Flag,
        _DchMeasurementOccasionInformation_Item_measurement_Occasion_Pattern_Sequence_parameters,
        ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__id_tab,
        ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id,
        ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality_tab,
        ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality,
        ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue,
        __DchMeasurementOccasionInformation_Item_iE_Extensions__item_,
        _DchMeasurementOccasionInformation_Item_iE_Extensions,
        DchMeasurementOccasionInformation_Item,
        DCH_MeasurementOccasion_Information_ExtIEs,
        _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_k,
        _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_offset,
        _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_M_Length,
        _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_Timeslot_Bitmap,
        ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id_tab,
        ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id,
        ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality_tab,
        ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality,
        ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue_tab,
        ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue,
        __Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item_,
        _Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions,
        Measurement_Occasion_Pattern_Sequence_parameters,
        Measurement_Occasion_Pattern_Sequence_parameters_ExtIEs,
        _DCH_TDD_Information__item_,
        DCH_TDD_Information,
        _DCH_TDD_InformationItem_payloadCRC_PresenceIndicator,
        _DCH_TDD_InformationItem_ul_FP_Mode,
        _DCH_TDD_InformationItem_toAWS,
        _DCH_TDD_InformationItem_toAWE,
        _DCH_TDD_InformationItem_dCH_SpecificInformationList,
        ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab,
        _____DCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___DCH_TDD_InformationItem_iE_Extensions__item__id,
        ___DCH_TDD_InformationItem_iE_Extensions__item__criticality,
        ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue,
        __DCH_TDD_InformationItem_iE_Extensions__item_,
        _DCH_TDD_InformationItem_iE_Extensions,
        DCH_TDD_InformationItem,
        DCH_TDD_InformationItem_ExtIEs,
        _DCH_TDD_InformationItem_ExtIEs_val_Extension_0,
        _DCH_Specific_TDD_InformationList__item_,
        DCH_Specific_TDD_InformationList,
        _DCH_Specific_TDD_Item_dCH_ID,
        _DCH_Specific_TDD_Item_ul_CCTrCH_ID,
        _DCH_Specific_TDD_Item_dl_CCTrCH_ID,
        _DCH_Specific_TDD_Item_ul_TransportFormatSet,
        _DCH_Specific_TDD_Item_dl_TransportFormatSet,
        _DCH_Specific_TDD_Item_allocationRetentionPriority,
        _DCH_Specific_TDD_Item_frameHandlingPriority,
        _DCH_Specific_TDD_Item_qE_Selector,
        ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab,
        _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___DCH_Specific_TDD_Item_iE_Extensions__item__id,
        ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality,
        ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue,
        __DCH_Specific_TDD_Item_iE_Extensions__item_,
        _DCH_Specific_TDD_Item_iE_Extensions,
        DCH_Specific_TDD_Item,
        DCH_Specific_TDD_Item_ExtIEs,
        _DCH_Specific_TDD_Item_ExtIEs_val_Extension_0,
        _FDD_DCHs_to_Modify__item_,
        FDD_DCHs_to_Modify,
        _FDD_DCHs_to_ModifyItem_ul_FP_Mode,
        _FDD_DCHs_to_ModifyItem_toAWS,
        _FDD_DCHs_to_ModifyItem_toAWE,
        _FDD_DCHs_to_ModifyItem_transportBearerRequestIndicator,
        _FDD_DCHs_to_ModifyItem_dCH_SpecificInformationList,
        ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab,
        _____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id,
        ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality,
        ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue,
        __FDD_DCHs_to_ModifyItem_iE_Extensions__item_,
        _FDD_DCHs_to_ModifyItem_iE_Extensions,
        FDD_DCHs_to_ModifyItem,
        FDD_DCHs_to_ModifyItem_ExtIEs,
        _FDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0,
        _DCH_ModifySpecificInformation_FDD__item_,
        DCH_ModifySpecificInformation_FDD,
        _DCH_ModifySpecificItem_FDD_dCH_ID,
        _DCH_ModifySpecificItem_FDD_ul_TransportFormatSet,
        _DCH_ModifySpecificItem_FDD_dl_TransportFormatSet,
        _DCH_ModifySpecificItem_FDD_allocationRetentionPriority,
        _DCH_ModifySpecificItem_FDD_frameHandlingPriority,
        ____DCH_ModifySpecificItem_FDD_iE_Extensions__item__id_tab,
        _____DCH_ModifySpecificItem_FDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__id,
        ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__criticality,
        ___DCH_ModifySpecificItem_FDD_iE_Extensions__item__extensionValue,
        __DCH_ModifySpecificItem_FDD_iE_Extensions__item_,
        _DCH_ModifySpecificItem_FDD_iE_Extensions,
        DCH_ModifySpecificItem_FDD,
        DCH_ModifySpecificItem_FDD_ExtIEs,
        _DCH_ModifySpecificItem_FDD_ExtIEs_val_Extension_0,
        _TDD_DCHs_to_Modify__item_,
        TDD_DCHs_to_Modify,
        _DCH_ModifyItem_TDD_ul_FP_Mode,
        _DCH_ModifyItem_TDD_toAWS,
        _DCH_ModifyItem_TDD_toAWE,
        _DCH_ModifyItem_TDD_transportBearerRequestIndicator,
        _DCH_ModifyItem_TDD_dCH_SpecificInformationList,
        ____DCH_ModifyItem_TDD_iE_Extensions__item__id_tab,
        _____DCH_ModifyItem_TDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___DCH_ModifyItem_TDD_iE_Extensions__item__id,
        ___DCH_ModifyItem_TDD_iE_Extensions__item__criticality,
        ___DCH_ModifyItem_TDD_iE_Extensions__item__extensionValue,
        __DCH_ModifyItem_TDD_iE_Extensions__item_,
        _DCH_ModifyItem_TDD_iE_Extensions,
        DCH_ModifyItem_TDD,
        TDD_DCHs_to_ModifyItem_ExtIEs,
        _TDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0,
        _DCH_ModifySpecificInformation_TDD__item_,
        DCH_ModifySpecificInformation_TDD,
        _DCH_ModifySpecificItem_TDD_dCH_ID,
        _DCH_ModifySpecificItem_TDD_ul_CCTrCH_ID,
        _DCH_ModifySpecificItem_TDD_dl_CCTrCH_ID,
        _DCH_ModifySpecificItem_TDD_ul_TransportFormatSet,
        _DCH_ModifySpecificItem_TDD_dl_TransportFormatSet,
        _DCH_ModifySpecificItem_TDD_allocationRetentionPriority,
        _DCH_ModifySpecificItem_TDD_frameHandlingPriority,
        ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__id_tab,
        ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__id,
        ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__criticality_tab,
        ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__criticality,
        ____DCH_ModifySpecificItem_TDD_iE_Extensions__item__extensionValue_tab,
        ___DCH_ModifySpecificItem_TDD_iE_Extensions__item__extensionValue,
        __DCH_ModifySpecificItem_TDD_iE_Extensions__item_,
        _DCH_ModifySpecificItem_TDD_iE_Extensions,
        DCH_ModifySpecificItem_TDD,
        DCH_ModifySpecificItem_TDD_ExtIEs,
        DecimationFactor,
        __DedicatedChannelsCapacityConsumptionLaw__item__dl_Cost_1,
        __DedicatedChannelsCapacityConsumptionLaw__item__dl_Cost_2,
        __DedicatedChannelsCapacityConsumptionLaw__item__ul_Cost_1,
        __DedicatedChannelsCapacityConsumptionLaw__item__ul_Cost_2,
        _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id_tab,
        ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__id,
        _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality_tab,
        ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__criticality,
        _____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue_tab,
        ____DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item__extensionValue,
        ___DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions__item_,
        __DedicatedChannelsCapacityConsumptionLaw__item__iE_Extensions,
        _DedicatedChannelsCapacityConsumptionLaw__item_,
        DedicatedChannelsCapacityConsumptionLaw,
        DedicatedChannelsCapacityConsumptionLaw_ExtIEs,
        DedicatedMeasurementType,
        _DedicatedMeasurementValue_sIR_Value,
        _DedicatedMeasurementValue_sIR_ErrorValue,
        _DedicatedMeasurementValue_transmittedCodePowerValue,
        _DedicatedMeasurementValue_rSCP,
        _DedicatedMeasurementValue_rxTimingDeviationValue,
        _DedicatedMeasurementValue_roundTripTime,
        _DedicatedMeasurementValue_extension_DedicatedMeasurementValue,
        DedicatedMeasurementValue,
        __Extension_DedicatedMeasurementValue_id_tab,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_0,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_1,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_2,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_3,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_4,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_5,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_6,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_7,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_8,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_9,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_10,
        _Extension_DedicatedMeasurementValue_id,
        _Extension_DedicatedMeasurementValue_criticality,
        _Extension_DedicatedMeasurementValue_value,
        Extension_DedicatedMeasurementValue,
        Extension_DedicatedMeasurementValueIE,
        _Extension_DedicatedMeasurementValueIE_val_Value_0,
        _Extension_DedicatedMeasurementValueIE_val_Value_1,
        _Extension_DedicatedMeasurementValueIE_val_Value_2,
        _Extension_DedicatedMeasurementValueIE_val_Value_3,
        _Extension_DedicatedMeasurementValueIE_val_Value_4,
        _Extension_DedicatedMeasurementValueIE_val_Value_5,
        _Extension_DedicatedMeasurementValueIE_val_Value_6,
        _Extension_DedicatedMeasurementValueIE_val_Value_7,
        _Extension_DedicatedMeasurementValueIE_val_Value_8,
        _Extension_DedicatedMeasurementValueIE_val_Value_9,
        _Extension_DedicatedMeasurementValueIE_val_Value_10,
        _DedicatedMeasurementValueInformation_measurementAvailable,
        _DedicatedMeasurementValueInformation_measurementnotAvailable,
        DedicatedMeasurementValueInformation,
        _DedicatedMeasurementAvailable_dedicatedmeasurementValue,
        _DedicatedMeasurementAvailable_cFN,
        ____DedicatedMeasurementAvailable_ie_Extensions__item__id_tab,
        ___DedicatedMeasurementAvailable_ie_Extensions__item__id,
        ____DedicatedMeasurementAvailable_ie_Extensions__item__criticality_tab,
        ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality,
        ____DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue_tab,
        ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue,
        __DedicatedMeasurementAvailable_ie_Extensions__item_,
        _DedicatedMeasurementAvailable_ie_Extensions,
        DedicatedMeasurementAvailable,
        DedicatedMeasurementAvailableItem_ExtIEs,
        DedicatedMeasurementnotAvailable,
        _DelayedActivation_cfn,
        _DelayedActivation_separate_indication,
        DelayedActivation,
        _DelayedActivationUpdate_activate,
        _DelayedActivationUpdate_deactivate,
        DelayedActivationUpdate,
        _Activate_Info_activation_type,
        _Activate_Info_initial_dl_tx_power,
        _Activate_Info_firstRLS_Indicator,
        _Activate_Info_propagation_delay,
        ____Activate_Info_iE_Extensions__item__id_tab,
        _____Activate_Info_iE_Extensions__item__id_tab_val_Extension_0,
        ___Activate_Info_iE_Extensions__item__id,
        ___Activate_Info_iE_Extensions__item__criticality,
        ___Activate_Info_iE_Extensions__item__extensionValue,
        __Activate_Info_iE_Extensions__item_,
        _Activate_Info_iE_Extensions,
        Activate_Info,
        Activate_Info_ExtIEs,
        _Activate_Info_ExtIEs_val_Extension_0,
        _Deactivate_Info_deactivation_type,
        ____Deactivate_Info_iE_Extensions__item__id_tab,
        ___Deactivate_Info_iE_Extensions__item__id,
        ____Deactivate_Info_iE_Extensions__item__criticality_tab,
        ___Deactivate_Info_iE_Extensions__item__criticality,
        ____Deactivate_Info_iE_Extensions__item__extensionValue_tab,
        ___Deactivate_Info_iE_Extensions__item__extensionValue,
        __Deactivate_Info_iE_Extensions__item_,
        _Deactivate_Info_iE_Extensions,
        Deactivate_Info,
        Deactivate_Info_ExtIEs,
        _Execution_Type_synchronised,
        _Execution_Type_unsynchronised,
        Execution_Type,
        DeltaSIR,
        _DGANSSCorrections_dGANSS_ReferenceTime,
        _DGANSSCorrections_dGANSS_Information,
        ____DGANSSCorrections_ie_Extensions__item__id_tab,
        ___DGANSSCorrections_ie_Extensions__item__id,
        ____DGANSSCorrections_ie_Extensions__item__criticality_tab,
        ___DGANSSCorrections_ie_Extensions__item__criticality,
        ____DGANSSCorrections_ie_Extensions__item__extensionValue_tab,
        ___DGANSSCorrections_ie_Extensions__item__extensionValue,
        __DGANSSCorrections_ie_Extensions__item_,
        _DGANSSCorrections_ie_Extensions,
        DGANSSCorrections,
        DGANSSCorrections_ExtIEs,
        _DGANSS_Corrections_Req_dGANSS_Signal_ID,
        ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab,
        _____DGANSS_Corrections_Req_ie_Extensions__item__id_tab_val_Extension_0,
        ___DGANSS_Corrections_Req_ie_Extensions__item__id,
        ___DGANSS_Corrections_Req_ie_Extensions__item__criticality,
        ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue,
        __DGANSS_Corrections_Req_ie_Extensions__item_,
        _DGANSS_Corrections_Req_ie_Extensions,
        DGANSS_Corrections_Req,
        DGANSS_Corrections_Req_ExtIEs,
        _DGANSS_Corrections_Req_ExtIEs_val_Extension_0,
        _DGANSS_Information__item_,
        DGANSS_Information,
        _DGANSS_InformationItem_gANSS_SignalId,
        _DGANSS_InformationItem_gANSS_StatusHealth,
        _DGANSS_InformationItem_dGANSS_SignalInformation,
        ____DGANSS_InformationItem_ie_Extensions__item__id_tab,
        ___DGANSS_InformationItem_ie_Extensions__item__id,
        ____DGANSS_InformationItem_ie_Extensions__item__criticality_tab,
        ___DGANSS_InformationItem_ie_Extensions__item__criticality,
        ____DGANSS_InformationItem_ie_Extensions__item__extensionValue_tab,
        ___DGANSS_InformationItem_ie_Extensions__item__extensionValue,
        __DGANSS_InformationItem_ie_Extensions__item_,
        _DGANSS_InformationItem_ie_Extensions,
        DGANSS_InformationItem,
        DGANSS_InformationItem_ExtIEs,
        _DGANSS_SignalInformation__item_,
        DGANSS_SignalInformation,
        _DGANSS_SignalInformationItem_satId,
        _DGANSS_SignalInformationItem_gANSS_iod,
        _DGANSS_SignalInformationItem_udre,
        _DGANSS_SignalInformationItem_ganss_prc,
        _DGANSS_SignalInformationItem_ganss_rrc,
        ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab,
        _____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab_val_Extension_0,
        ___DGANSS_SignalInformationItem_ie_Extensions__item__id,
        ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality,
        ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue,
        __DGANSS_SignalInformationItem_ie_Extensions__item_,
        _DGANSS_SignalInformationItem_ie_Extensions,
        DGANSS_SignalInformationItem,
        DGANSS_SignalInformationItem_ExtIEs,
        _DGANSS_SignalInformationItem_ExtIEs_val_Extension_0,
        _DGANSSThreshold_pRCDeviation,
        ____DGANSSThreshold_ie_Extensions__item__id_tab,
        ___DGANSSThreshold_ie_Extensions__item__id,
        ____DGANSSThreshold_ie_Extensions__item__criticality_tab,
        ___DGANSSThreshold_ie_Extensions__item__criticality,
        ____DGANSSThreshold_ie_Extensions__item__extensionValue_tab,
        ___DGANSSThreshold_ie_Extensions__item__extensionValue,
        __DGANSSThreshold_ie_Extensions__item_,
        _DGANSSThreshold_ie_Extensions,
        DGANSSThreshold,
        DGANSSThreshold_ExtIEs,
        _DGNSS_ValidityPeriod_udreGrowthRate,
        _DGNSS_ValidityPeriod_udreValidityTime,
        ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab,
        ___DGNSS_ValidityPeriod_iE_Extensions__item__id,
        ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab,
        ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality,
        ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab,
        ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue,
        __DGNSS_ValidityPeriod_iE_Extensions__item_,
        _DGNSS_ValidityPeriod_iE_Extensions,
        DGNSS_ValidityPeriod,
        DGNSS_ValidityPeriod_ExtIEs,
        _DGPSCorrections_gpstow,
        _DGPSCorrections_status_health,
        _DGPSCorrections_satelliteinfo,
        ____DGPSCorrections_ie_Extensions__item__id_tab,
        ___DGPSCorrections_ie_Extensions__item__id,
        ____DGPSCorrections_ie_Extensions__item__criticality_tab,
        ___DGPSCorrections_ie_Extensions__item__criticality,
        ____DGPSCorrections_ie_Extensions__item__extensionValue_tab,
        ___DGPSCorrections_ie_Extensions__item__extensionValue,
        __DGPSCorrections_ie_Extensions__item_,
        _DGPSCorrections_ie_Extensions,
        DGPSCorrections,
        DGPSCorrections_ExtIEs,
        _DGPSThresholds_prcdeviation,
        ____DGPSThresholds_ie_Extensions__item__id_tab,
        ___DGPSThresholds_ie_Extensions__item__id,
        ____DGPSThresholds_ie_Extensions__item__criticality_tab,
        ___DGPSThresholds_ie_Extensions__item__criticality,
        ____DGPSThresholds_ie_Extensions__item__extensionValue_tab,
        ___DGPSThresholds_ie_Extensions__item__extensionValue,
        __DGPSThresholds_ie_Extensions__item_,
        _DGPSThresholds_ie_Extensions,
        DGPSThresholds,
        DGPSThresholds_ExtIEs,
        DiscardTimer,
        DiversityControlField,
        DiversityMode,
        _DL_TBS_hs_DSCH_Cell_List,
        ____DL_TBS_iE_Extensions__item__id_tab,
        ___DL_TBS_iE_Extensions__item__id,
        ____DL_TBS_iE_Extensions__item__criticality_tab,
        ___DL_TBS_iE_Extensions__item__criticality,
        ____DL_TBS_iE_Extensions__item__extensionValue_tab,
        ___DL_TBS_iE_Extensions__item__extensionValue,
        __DL_TBS_iE_Extensions__item_,
        _DL_TBS_iE_Extensions,
        DL_TBS,
        DL_TBS_ExtIEs,
        _HS_DSCH_Cell_List__item_,
        HS_DSCH_Cell_List,
        _HS_DSCH_Cell_hs_DSCH_Cell_TBS,
        ____HS_DSCH_Cell_iE_Extensions__item__id_tab,
        ___HS_DSCH_Cell_iE_Extensions__item__id,
        ____HS_DSCH_Cell_iE_Extensions__item__criticality_tab,
        ___HS_DSCH_Cell_iE_Extensions__item__criticality,
        ____HS_DSCH_Cell_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCH_Cell_iE_Extensions__item__extensionValue,
        __HS_DSCH_Cell_iE_Extensions__item_,
        _HS_DSCH_Cell_iE_Extensions,
        HS_DSCH_Cell,
        HS_DSCH_Cell_ExtIEs,
        DL_TBS_Value,
        DL_DPCH_SlotFormat,
        DL_DPCH_TimingAdjustment,
        _DL_Timeslot_Information__item_,
        DL_Timeslot_Information,
        _DL_Timeslot_InformationItem_timeSlot,
        _DL_Timeslot_InformationItem_midambleShiftAndBurstType,
        _DL_Timeslot_InformationItem_tFCI_Presence,
        _DL_Timeslot_InformationItem_dL_Code_Information,
        ____DL_Timeslot_InformationItem_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationItem_iE_Extensions__item__id,
        ____DL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationItem_iE_Extensions__item_,
        _DL_Timeslot_InformationItem_iE_Extensions,
        DL_Timeslot_InformationItem,
        DL_Timeslot_InformationItem_ExtIEs,
        _DL_TimeslotLCR_Information__item_,
        DL_TimeslotLCR_Information,
        _DL_TimeslotLCR_InformationItem_timeSlotLCR,
        _DL_TimeslotLCR_InformationItem_midambleShiftLCR,
        _DL_TimeslotLCR_InformationItem_tFCI_Presence,
        _DL_TimeslotLCR_InformationItem_dL_Code_LCR_Information,
        ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab,
        _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id,
        ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality,
        ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue,
        __DL_TimeslotLCR_InformationItem_iE_Extensions__item_,
        _DL_TimeslotLCR_InformationItem_iE_Extensions,
        DL_TimeslotLCR_InformationItem,
        DL_TimeslotLCR_InformationItem_ExtIEs,
        _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0,
        _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_1,
        _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_2,
        _DL_Timeslot768_Information__item_,
        DL_Timeslot768_Information,
        _DL_Timeslot768_InformationItem_timeSlot,
        _DL_Timeslot768_InformationItem_midambleShiftAndBurstType768,
        _DL_Timeslot768_InformationItem_tFCI_Presence,
        _DL_Timeslot768_InformationItem_dL_Code_768_Information,
        ____DL_Timeslot768_InformationItem_iE_Extensions__item__id_tab,
        ___DL_Timeslot768_InformationItem_iE_Extensions__item__id,
        ____DL_Timeslot768_InformationItem_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot768_InformationItem_iE_Extensions__item__criticality,
        ____DL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue,
        __DL_Timeslot768_InformationItem_iE_Extensions__item_,
        _DL_Timeslot768_InformationItem_iE_Extensions,
        DL_Timeslot768_InformationItem,
        DL_Timeslot768_InformationItem_ExtIEs,
        DL_FrameType,
        DL_or_Global_CapacityCredit,
        DL_Power,
        DLPowerAveragingWindowSize,
        _DL_PowerBalancing_Information_powerAdjustmentType,
        _DL_PowerBalancing_Information_dLReferencePower,
        _DL_PowerBalancing_Information_dLReferencePowerList_DL_PC_Rqst,
        _DL_PowerBalancing_Information_maxAdjustmentStep,
        _DL_PowerBalancing_Information_adjustmentPeriod,
        _DL_PowerBalancing_Information_adjustmentRatio,
        ____DL_PowerBalancing_Information_iE_Extensions__item__id_tab,
        ___DL_PowerBalancing_Information_iE_Extensions__item__id,
        ____DL_PowerBalancing_Information_iE_Extensions__item__criticality_tab,
        ___DL_PowerBalancing_Information_iE_Extensions__item__criticality,
        ____DL_PowerBalancing_Information_iE_Extensions__item__extensionValue_tab,
        ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue,
        __DL_PowerBalancing_Information_iE_Extensions__item_,
        _DL_PowerBalancing_Information_iE_Extensions,
        DL_PowerBalancing_Information,
        DL_PowerBalancing_Information_ExtIEs,
        _DL_ReferencePowerInformationList__item_,
        DL_ReferencePowerInformationList,
        _DL_ReferencePowerInformationItem_rL_ID,
        _DL_ReferencePowerInformationItem_dl_Reference_Power,
        ____DL_ReferencePowerInformationItem_iE_Extensions__item__id_tab,
        ___DL_ReferencePowerInformationItem_iE_Extensions__item__id,
        ____DL_ReferencePowerInformationItem_iE_Extensions__item__criticality_tab,
        ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality,
        ____DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue_tab,
        ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue,
        __DL_ReferencePowerInformationItem_iE_Extensions__item_,
        _DL_ReferencePowerInformationItem_iE_Extensions,
        DL_ReferencePowerInformationItem,
        DL_ReferencePowerInformationItem_ExtIEs,
        DL_PowerBalancing_ActivationIndicator,
        DL_PowerBalancing_UpdatedIndicator,
        DL_ScramblingCode,
        DL_TimeslotISCP,
        _DL_TimeslotISCPInfo__item_,
        DL_TimeslotISCPInfo,
        _DL_TimeslotISCPInfoItem_timeSlot,
        _DL_TimeslotISCPInfoItem_dL_TimeslotISCP,
        ____DL_TimeslotISCPInfoItem_iE_Extensions__item__id_tab,
        ___DL_TimeslotISCPInfoItem_iE_Extensions__item__id,
        ____DL_TimeslotISCPInfoItem_iE_Extensions__item__criticality_tab,
        ___DL_TimeslotISCPInfoItem_iE_Extensions__item__criticality,
        ____DL_TimeslotISCPInfoItem_iE_Extensions__item__extensionValue_tab,
        ___DL_TimeslotISCPInfoItem_iE_Extensions__item__extensionValue,
        __DL_TimeslotISCPInfoItem_iE_Extensions__item_,
        _DL_TimeslotISCPInfoItem_iE_Extensions,
        DL_TimeslotISCPInfoItem,
        DL_TimeslotISCPInfoItem_ExtIEs,
        _DL_TimeslotISCPInfoLCR__item_,
        DL_TimeslotISCPInfoLCR,
        _DL_TimeslotISCPInfoItemLCR_timeSlotLCR,
        _DL_TimeslotISCPInfoItemLCR_dL_TimeslotISCP,
        ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__id_tab,
        ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__id,
        ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__criticality_tab,
        ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__criticality,
        ____DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__extensionValue_tab,
        ___DL_TimeslotISCPInfoItemLCR_iE_Extensions__item__extensionValue,
        __DL_TimeslotISCPInfoItemLCR_iE_Extensions__item_,
        _DL_TimeslotISCPInfoItemLCR_iE_Extensions,
        DL_TimeslotISCPInfoItemLCR,
        DL_TimeslotISCPInfoItemLCR_ExtIEs,
        DL_TPC_Pattern01Count,
        DLTransmissionBranchLoadValue,
        Downlink_Compressed_Mode_Method,
        _DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item_,
        DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst,
        _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_timeSlot,
        _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_dl_HS_PDSCH_Codelist_LCR_PSCH_ReconfRqst,
        _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_maxHSDSCH_HSSCCH_Power,
        ____DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst,
        DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs,
        _DL_HS_PDSCH_Timeslot_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION__item_,
        MaxHSDSCH_HSSCCH_Power_per_CELLPORTION,
        _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_cellPortionLCRID,
        _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_maxHSDSCH_HSSCCH_Power,
        ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__id_tab,
        ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__id,
        ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__criticality_tab,
        ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__criticality,
        ____MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__extensionValue_tab,
        ___MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item__extensionValue,
        __MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions__item_,
        _MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_iE_Extensions,
        MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item,
        MaxHSDSCH_HSSCCH_Power_per_CELLPORTION_Item_ExtIEs,
        _DL_HS_PDSCH_Codelist_LCR_PSCH_ReconfRqst__item_,
        DL_HS_PDSCH_Codelist_LCR_PSCH_ReconfRqst,
        _Downlink_TPC_enhancements_Information_decimationFactorforPrimaryFrequency,
        _Downlink_TPC_enhancements_Information_decimationFactorforSecFrequency,
        ____Downlink_TPC_enhancements_Information_iE_Extensions__item__id_tab,
        ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id,
        ____Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality_tab,
        ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality,
        ____Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue_tab,
        ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue,
        __Downlink_TPC_enhancements_Information_iE_Extensions__item_,
        _Downlink_TPC_enhancements_Information_iE_Extensions,
        Downlink_TPC_enhancements_Information,
        Downlink_TPC_enhancements_Information_ExtIEs,
        _Downlink_TPC_enhancements_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements,
        ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id_tab,
        ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id,
        ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality_tab,
        ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality,
        ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue_tab,
        ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue,
        __Downlink_TPC_enhancements_Reconf_iE_Extensions__item_,
        _Downlink_TPC_enhancements_Reconf_iE_Extensions,
        Downlink_TPC_enhancements_Reconf,
        Downlink_TPC_enhancements_Reconf_ExtIEs,
        Downlink_TPC_enhancements_Information_Removal,
        DPC_Mode,
        DPCH_ID,
        DPCH_ID768,
        _DRX_Information_uE_DRX_Cycle,
        _DRX_Information_inactivity_Threshold_for_UE_DRX_Cycle,
        _DRX_Information_inactivity_Threshold_for_UE_Grant_Monitoring,
        _DRX_Information_uE_DRX_Grant_Monitoring,
        ____DRX_Information_iE_Extensions__item__id_tab,
        _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRX_Information_iE_Extensions__item__id,
        ___DRX_Information_iE_Extensions__item__criticality,
        ___DRX_Information_iE_Extensions__item__extensionValue,
        __DRX_Information_iE_Extensions__item_,
        _DRX_Information_iE_Extensions,
        DRX_Information,
        DRX_Information_ExtIEs,
        _DRX_Information_ExtIEs_val_Extension_0,
        _DRX_Information_ExtIEs_val_Extension_1,
        _DRX_Information_to_Modify_modify,
        _DRX_Information_to_Modify_deactivate,
        DRX_Information_to_Modify,
        _DRX_Information_to_Modify_Items_uE_DRX_Cycle,
        _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DRX_Cycle,
        _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_Grant_Monitoring,
        _DRX_Information_to_Modify_Items_uE_DRX_Grant_Monitoring,
        ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab,
        _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRX_Information_to_Modify_Items_iE_Extensions__item__id,
        ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality,
        ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue,
        __DRX_Information_to_Modify_Items_iE_Extensions__item_,
        _DRX_Information_to_Modify_Items_iE_Extensions,
        DRX_Information_to_Modify_Items,
        DRX_Information_to_Modify_Items_ExtIEs,
        _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_0,
        _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_1,
        DRX_Interruption_by_HS_DSCH,
        DSCH_ID,
        _DSCH_InformationResponse__item_,
        DSCH_InformationResponse,
        _DSCH_InformationResponseItem_dSCH_ID,
        _DSCH_InformationResponseItem_bindingID,
        _DSCH_InformationResponseItem_transportLayerAddress,
        ____DSCH_InformationResponseItem_iE_Extensions__item__id_tab,
        ___DSCH_InformationResponseItem_iE_Extensions__item__id,
        ____DSCH_InformationResponseItem_iE_Extensions__item__criticality_tab,
        ___DSCH_InformationResponseItem_iE_Extensions__item__criticality,
        ____DSCH_InformationResponseItem_iE_Extensions__item__extensionValue_tab,
        ___DSCH_InformationResponseItem_iE_Extensions__item__extensionValue,
        __DSCH_InformationResponseItem_iE_Extensions__item_,
        _DSCH_InformationResponseItem_iE_Extensions,
        DSCH_InformationResponseItem,
        DSCH_InformationResponseItem_ExtIEs,
        _DSCH_TDD_Information__item_,
        DSCH_TDD_Information,
        _DSCH_TDD_InformationItem_dSCH_ID,
        _DSCH_TDD_InformationItem_cCTrCH_ID,
        _DSCH_TDD_InformationItem_transportFormatSet,
        _DSCH_TDD_InformationItem_allocationRetentionPriority,
        _DSCH_TDD_InformationItem_frameHandlingPriority,
        _DSCH_TDD_InformationItem_toAWS,
        _DSCH_TDD_InformationItem_toAWE,
        ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab,
        _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___DSCH_TDD_InformationItem_iE_Extensions__item__id,
        ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality,
        ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue,
        __DSCH_TDD_InformationItem_iE_Extensions__item_,
        _DSCH_TDD_InformationItem_iE_Extensions,
        DSCH_TDD_InformationItem,
        DSCH_TDD_InformationItem_ExtIEs,
        _DSCH_TDD_InformationItem_ExtIEs_val_Extension_0,
        _DSCH_TDD_InformationItem_ExtIEs_val_Extension_1,
        _DSCH_TDD_InformationItem_ExtIEs_val_Extension_2,
        DsField,
        _DTX_Cycle_2ms_Items_uE_DTX_Cycle1_2ms,
        _DTX_Cycle_2ms_Items_uE_DTX_Cycle2_2ms,
        _DTX_Cycle_2ms_Items_mAC_DTX_Cycle_2ms,
        ____DTX_Cycle_2ms_Items_iE_Extensions__item__id_tab,
        ___DTX_Cycle_2ms_Items_iE_Extensions__item__id,
        ____DTX_Cycle_2ms_Items_iE_Extensions__item__criticality_tab,
        ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality,
        ____DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue_tab,
        ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue,
        __DTX_Cycle_2ms_Items_iE_Extensions__item_,
        _DTX_Cycle_2ms_Items_iE_Extensions,
        DTX_Cycle_2ms_Items,
        DTX_Cycle_2ms_Items_ExtIEs,
        _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle1_2ms,
        _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle2_2ms,
        _DTX_Cycle_2ms_to_Modify_Items_mAC_DTX_Cycle_2ms,
        ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id_tab,
        ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id,
        ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality_tab,
        ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality,
        ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab,
        ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue,
        __DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item_,
        _DTX_Cycle_2ms_to_Modify_Items_iE_Extensions,
        DTX_Cycle_2ms_to_Modify_Items,
        DTX_Cycle_2ms_to_Modify_Items_ExtIEs,
        _DTX_Cycle_10ms_Items_uE_DTX_Cycle1_10ms,
        _DTX_Cycle_10ms_Items_uE_DTX_Cycle2_10ms,
        _DTX_Cycle_10ms_Items_mAC_DTX_Cycle_10ms,
        ____DTX_Cycle_10ms_Items_iE_Extensions__item__id_tab,
        ___DTX_Cycle_10ms_Items_iE_Extensions__item__id,
        ____DTX_Cycle_10ms_Items_iE_Extensions__item__criticality_tab,
        ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality,
        ____DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue_tab,
        ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue,
        __DTX_Cycle_10ms_Items_iE_Extensions__item_,
        _DTX_Cycle_10ms_Items_iE_Extensions,
        DTX_Cycle_10ms_Items,
        DTX_Cycle_10ms_Items_ExtIEs,
        _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle1_10ms,
        _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle2_10ms,
        _DTX_Cycle_10ms_to_Modify_Items_mAC_DTX_Cycle_10ms,
        ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id_tab,
        ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id,
        ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality_tab,
        ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality,
        ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab,
        ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue,
        __DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item_,
        _DTX_Cycle_10ms_to_Modify_Items_iE_Extensions,
        DTX_Cycle_10ms_to_Modify_Items,
        DTX_Cycle_10ms_to_Modify_Items_ExtIEs,
        _DTX_Information_e_DCH_TTI_Length,
        _DTX_Information_inactivity_Threshold_for_UE_DTX_Cycle2,
        _DTX_Information_uE_DTX_Long_Preamble,
        _DTX_Information_mAC_Inactivity_Threshold,
        _DTX_Information_cQI_DTX_Timer,
        _DTX_Information_uE_DPCCH_burst1,
        _DTX_Information_uE_DPCCH_burst2,
        ____DTX_Information_iE_Extensions__item__id_tab,
        ___DTX_Information_iE_Extensions__item__id,
        ____DTX_Information_iE_Extensions__item__criticality_tab,
        ___DTX_Information_iE_Extensions__item__criticality,
        ____DTX_Information_iE_Extensions__item__extensionValue_tab,
        ___DTX_Information_iE_Extensions__item__extensionValue,
        __DTX_Information_iE_Extensions__item_,
        _DTX_Information_iE_Extensions,
        DTX_Information,
        DTX_Information_ExtIEs,
        _DTX_Information_to_Modify_modify,
        _DTX_Information_to_Modify_deactivate,
        DTX_Information_to_Modify,
        _DTX_Information_to_Modify_Items_e_DCH_TTI_Length_to_Modify,
        _DTX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DTX_Cycle2,
        _DTX_Information_to_Modify_Items_uE_DTX_Long_Preamble,
        _DTX_Information_to_Modify_Items_mAC_Inactivity_Threshold,
        _DTX_Information_to_Modify_Items_cQI_DTX_Timer,
        _DTX_Information_to_Modify_Items_uE_DPCCH_burst1,
        _DTX_Information_to_Modify_Items_uE_DPCCH_burst2,
        ____DTX_Information_to_Modify_Items_iE_Extensions__item__id_tab,
        ___DTX_Information_to_Modify_Items_iE_Extensions__item__id,
        ____DTX_Information_to_Modify_Items_iE_Extensions__item__criticality_tab,
        ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality,
        ____DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue_tab,
        ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue,
        __DTX_Information_to_Modify_Items_iE_Extensions__item_,
        _DTX_Information_to_Modify_Items_iE_Extensions,
        DTX_Information_to_Modify_Items,
        DTX_Information_to_Modify_Items_ExtIEs,
        Dual_Band_Capability,
        _Dual_Band_Capability_Info_dual_Band_Capability,
        _Dual_Band_Capability_Info_possible_Secondary_Serving_Cell_List,
        ____Dual_Band_Capability_Info_iE_Extensions__item__id_tab,
        _____Dual_Band_Capability_Info_iE_Extensions__item__id_tab_val_Extension_0,
        ___Dual_Band_Capability_Info_iE_Extensions__item__id,
        ___Dual_Band_Capability_Info_iE_Extensions__item__criticality,
        ___Dual_Band_Capability_Info_iE_Extensions__item__extensionValue,
        __Dual_Band_Capability_Info_iE_Extensions__item_,
        _Dual_Band_Capability_Info_iE_Extensions,
        Dual_Band_Capability_Info,
        Dual_Band_Capability_Info_ExtIEs,
        _Dual_Band_Capability_Info_ExtIEs_val_Extension_0,
        DwPCH_Power,
        Improved_Synchronized_Indicator,
        E_AGCH_Table_Choice,
        _E_AGCH_FDD_Code_Information_replace,
        _E_AGCH_FDD_Code_Information_remove,
        E_AGCH_FDD_Code_Information,
        _E_AGCH_FDD_Code_List__item_,
        E_AGCH_FDD_Code_List,
        E_AI_Capability,
        E_AI_Indicator,
        E_DCH_Capability,
        _E_DCHCapacityConsumptionLaw_e_DCH_SF_allocation,
        _E_DCHCapacityConsumptionLaw_dl_Cost_1,
        _E_DCHCapacityConsumptionLaw_dl_Cost_2,
        ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__id_tab,
        ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__id,
        ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__criticality_tab,
        ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__criticality,
        ____E_DCHCapacityConsumptionLaw_iE_Extensions__item__extensionValue_tab,
        ___E_DCHCapacityConsumptionLaw_iE_Extensions__item__extensionValue,
        __E_DCHCapacityConsumptionLaw_iE_Extensions__item_,
        _E_DCHCapacityConsumptionLaw_iE_Extensions,
        E_DCHCapacityConsumptionLaw,
        E_DCHCapacityConsumptionLaw_ExtIEs,
        E_DCH_Decoupling_Indication,
        _E_DCH_TDD_CapacityConsumptionLaw_ul_Cost,
        _E_DCH_TDD_CapacityConsumptionLaw_dl_Cost,
        ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__id_tab,
        ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__id,
        ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__criticality_tab,
        ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__criticality,
        ____E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item__extensionValue,
        __E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions__item_,
        _E_DCH_TDD_CapacityConsumptionLaw_iE_Extensions,
        E_DCH_TDD_CapacityConsumptionLaw,
        E_DCH_TDD_CapacityConsumptionLaw_ExtIEs,
        __E_DCH_SF_allocation__item__ul_Cost_1,
        __E_DCH_SF_allocation__item__ul_Cost_2,
        _____E_DCH_SF_allocation__item__iE_Extensions__item__id_tab,
        ____E_DCH_SF_allocation__item__iE_Extensions__item__id,
        _____E_DCH_SF_allocation__item__iE_Extensions__item__criticality_tab,
        ____E_DCH_SF_allocation__item__iE_Extensions__item__criticality,
        _____E_DCH_SF_allocation__item__iE_Extensions__item__extensionValue_tab,
        ____E_DCH_SF_allocation__item__iE_Extensions__item__extensionValue,
        ___E_DCH_SF_allocation__item__iE_Extensions__item_,
        __E_DCH_SF_allocation__item__iE_Extensions,
        _E_DCH_SF_allocation__item_,
        E_DCH_SF_allocation,
        E_DCH_SF_allocation_ExtIEs,
        E_DCH_TTI2ms_Capability,
        E_DCH_SF_Capability,
        E_DCH_HARQ_Combining_Capability,
        E_DCH_DDI_Value,
        _E_DCH_FDD_DL_Control_Channel_Information_e_AGCH_And_E_RGCH_E_HICH_FDD_Scrambling_Code,
        _E_DCH_FDD_DL_Control_Channel_Information_e_AGCH_Channelisation_Code,
        _E_DCH_FDD_DL_Control_Channel_Information_primary_e_RNTI,
        _E_DCH_FDD_DL_Control_Channel_Information_secondary_e_RNTI,
        _E_DCH_FDD_DL_Control_Channel_Information_e_RGCH_E_HICH_Channelisation_Code,
        _E_DCH_FDD_DL_Control_Channel_Information_e_RGCH_Signature_Sequence,
        _E_DCH_FDD_DL_Control_Channel_Information_e_HICH_Signature_Sequence,
        _E_DCH_FDD_DL_Control_Channel_Information_serving_Grant_Value,
        _E_DCH_FDD_DL_Control_Channel_Information_primary_Secondary_Grant_Selector,
        _E_DCH_FDD_DL_Control_Channel_Information_e_RGCH_Release_Indicator,
        ____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab,
        _____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__id,
        ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__criticality,
        ___E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item__extensionValue,
        __E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions__item_,
        _E_DCH_FDD_DL_Control_Channel_Information_iE_Extensions,
        E_DCH_FDD_DL_Control_Channel_Information,
        E_DCH_FDD_DL_Control_Channel_Information_ExtIEs,
        _E_DCH_FDD_DL_Control_Channel_Information_ExtIEs_val_Extension_0,
        _E_DCH_FDD_DL_Control_Channel_Information_ExtIEs_val_Extension_1,
        _E_DCH_FDD_Information_e_DCH_MACdFlows_Information,
        _E_DCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        _E_DCH_FDD_Information_e_DCH_Maximum_Bitrate,
        _E_DCH_FDD_Information_e_DCH_Processing_Overload_Level,
        _E_DCH_FDD_Information_e_DCH_Reference_Power_Offset,
        ____E_DCH_FDD_Information_iE_Extensions__item__id_tab,
        _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____E_DCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5,
        ___E_DCH_FDD_Information_iE_Extensions__item__id,
        ___E_DCH_FDD_Information_iE_Extensions__item__criticality,
        ___E_DCH_FDD_Information_iE_Extensions__item__extensionValue,
        __E_DCH_FDD_Information_iE_Extensions__item_,
        _E_DCH_FDD_Information_iE_Extensions,
        E_DCH_FDD_Information,
        E_DCH_FDD_Information_ExtIEs,
        _E_DCH_FDD_Information_ExtIEs_val_Extension_0,
        _E_DCH_FDD_Information_ExtIEs_val_Extension_1,
        _E_DCH_FDD_Information_ExtIEs_val_Extension_2,
        _E_DCH_FDD_Information_ExtIEs_val_Extension_3,
        _E_DCH_FDD_Information_ExtIEs_val_Extension_4,
        _E_DCH_FDD_Information_ExtIEs_val_Extension_5,
        UPH_Filtering_Measurement_Forwarding_Request,
        _E_DCH_FDD_Information_Response_e_DCH_MACdFlow_Specific_InformationResp,
        _E_DCH_FDD_Information_Response_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        ____E_DCH_FDD_Information_Response_iE_Extensions__item__id_tab,
        _____E_DCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DCH_FDD_Information_Response_iE_Extensions__item__id,
        ___E_DCH_FDD_Information_Response_iE_Extensions__item__criticality,
        ___E_DCH_FDD_Information_Response_iE_Extensions__item__extensionValue,
        __E_DCH_FDD_Information_Response_iE_Extensions__item_,
        _E_DCH_FDD_Information_Response_iE_Extensions,
        E_DCH_FDD_Information_Response,
        E_DCH_FDD_Information_Response_ExtIEs,
        _E_DCH_FDD_Information_Response_ExtIEs_val_Extension_0,
        _E_DCH_FDD_Information_to_Modify_e_DCH_MACdFlow_Specific_Info_to_Modify,
        _E_DCH_FDD_Information_to_Modify_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        _E_DCH_FDD_Information_to_Modify_e_DCH_Maximum_Bitrate,
        _E_DCH_FDD_Information_to_Modify_e_DCH_Processing_Overload_Level,
        _E_DCH_FDD_Information_to_Modify_e_DCH_Reference_Power_Offset,
        _E_DCH_FDD_Information_to_Modify_mACeReset_Indicator,
        ____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab,
        _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_4,
        _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_5,
        _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_6,
        _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_7,
        _____E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_8,
        ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__id,
        ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__criticality,
        ___E_DCH_FDD_Information_to_Modify_iE_Extensions__item__extensionValue,
        __E_DCH_FDD_Information_to_Modify_iE_Extensions__item_,
        _E_DCH_FDD_Information_to_Modify_iE_Extensions,
        E_DCH_FDD_Information_to_Modify,
        E_DCH_FDD_Information_to_Modify_ExtIEs,
        _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_0,
        _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_1,
        _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_2,
        _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_3,
        _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_4,
        _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_5,
        _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_6,
        _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_7,
        _E_DCH_FDD_Information_to_Modify_ExtIEs_val_Extension_8,
        _E_DCH_FDD_Update_Information_e_DCH_MACdFlow_Specific_UpdateInformation,
        _E_DCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab,
        _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_DCH_FDD_Update_Information_iE_Extensions__item__id,
        ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality,
        ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue,
        __E_DCH_FDD_Update_Information_iE_Extensions__item_,
        _E_DCH_FDD_Update_Information_iE_Extensions,
        E_DCH_FDD_Update_Information,
        E_DCH_FDD_Update_Information_ExtIEs,
        _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_0,
        _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_1,
        _TTI_Update_Indicator_tTI_Update_CFN,
        _TTI_Update_Indicator_tTI_Update_Ind,
        TTI_Update_Indicator,
        TTI_Update_Ind,
        _E_DCH_MACdFlow_Specific_UpdateInformation__item_,
        E_DCH_MACdFlow_Specific_UpdateInformation,
        _E_DCH_MACdFlow_Specific_UpdateInformation_Item_e_DCH_MACdFlow_ID,
        _E_DCH_MACdFlow_Specific_UpdateInformation_Item_hARQ_Process_Allocation_NonSched_2ms_EDCH,
        ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id_tab,
        ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id,
        ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality_tab,
        ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality,
        ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item_,
        _E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions,
        E_DCH_MACdFlow_Specific_UpdateInformation_Item,
        E_DCH_MACdFlow_Specific_UpdateInformation_Item_ExtIEs,
        _E_DCH_DL_Control_Channel_Change_Information__item_,
        E_DCH_DL_Control_Channel_Change_Information,
        _E_DCH_DL_Control_Channel_Change_Information_Item_e_DCH_RL_ID,
        ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id_tab,
        ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id,
        ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality_tab,
        ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality,
        ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue,
        __E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item_,
        _E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions,
        E_DCH_DL_Control_Channel_Change_Information_Item,
        E_DCH_DL_Control_Channel_Change_Information_Item_ExtIEs,
        _E_DCH_DL_Control_Channel_Grant_Information__item_,
        E_DCH_DL_Control_Channel_Grant_Information,
        _E_DCH_DL_Control_Channel_Grant_Information_Item_e_DCH_RL_ID,
        ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id_tab,
        ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id,
        ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality_tab,
        ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality,
        ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue,
        __E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item_,
        _E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions,
        E_DCH_DL_Control_Channel_Grant_Information_Item,
        E_DCH_DL_Control_Channel_Grant_Information_Item_ExtIEs,
        _E_DCH_Grant_Type_Information_e_DCH_Non_Scheduled_Transmission_Grant,
        _E_DCH_Grant_Type_Information_e_DCH_Scheduled_Transmission_Grant,
        E_DCH_Grant_Type_Information,
        _E_DCH_LogicalChannelInformation__item_,
        E_DCH_LogicalChannelInformation,
        _E_DCH_LogicalChannelInformationItem_logicalChannelId,
        _E_DCH_LogicalChannelInformationItem_schedulingPriorityIndicator,
        _E_DCH_LogicalChannelInformationItem_schedulingInformation,
        _E_DCH_LogicalChannelInformationItem_mACesGuaranteedBitRate,
        _E_DCH_LogicalChannelInformationItem_e_DCH_DDI_Value,
        _E_DCH_LogicalChannelInformationItem_mACd_PDU_Size_List,
        ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab,
        _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id,
        ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality,
        ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue,
        __E_DCH_LogicalChannelInformationItem_iE_Extensions__item_,
        _E_DCH_LogicalChannelInformationItem_iE_Extensions,
        E_DCH_LogicalChannelInformationItem,
        E_DCH_LogicalChannelInformationItem_ExtIEs,
        _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_0,
        _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_1,
        _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_2,
        E_DCH_Maximum_Bitrate,
        E_DCH_PowerOffset_for_SchedulingInfo,
        E_DCH_Processing_Overload_Level,
        E_DCH_Reference_Power_Offset,
        _E_DCH_MACdPDU_SizeList__item_,
        E_DCH_MACdPDU_SizeList,
        _E_DCH_MACdPDU_SizeListItem_mACdPDU_Size,
        ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id_tab,
        ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id,
        ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality_tab,
        ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality,
        ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue,
        __E_DCH_MACdPDU_SizeListItem_iE_Extensions__item_,
        _E_DCH_MACdPDU_SizeListItem_iE_Extensions,
        E_DCH_MACdPDU_SizeListItem,
        E_DCH_MACdPDU_SizeListItem_ExtIEs,
        E_DCH_MACdPDU_SizeCapability,
        E_DCH_MACdPDUSizeFormat,
        _E_DCH_LogicalChannelToModify__item_,
        E_DCH_LogicalChannelToModify,
        _E_DCH_LogicalChannelToModifyItem_logicalChannelId,
        _E_DCH_LogicalChannelToModifyItem_schedulingPriorityIndicator,
        _E_DCH_LogicalChannelToModifyItem_schedulingInformation,
        _E_DCH_LogicalChannelToModifyItem_mACesGuaranteedBitRate,
        _E_DCH_LogicalChannelToModifyItem_e_DCH_DDI_Value,
        _E_DCH_LogicalChannelToModifyItem_mACd_PDU_Size_List,
        ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab,
        _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id,
        ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality,
        ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue,
        __E_DCH_LogicalChannelToModifyItem_iE_Extensions__item_,
        _E_DCH_LogicalChannelToModifyItem_iE_Extensions,
        E_DCH_LogicalChannelToModifyItem,
        E_DCH_LogicalChannelToModifyItem_ExtIEs,
        _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_0,
        _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_1,
        _E_DCH_MACdPDU_SizeToModifyList__item_,
        E_DCH_MACdPDU_SizeToModifyList,
        _E_DCH_LogicalChannelToDelete__item_,
        E_DCH_LogicalChannelToDelete,
        _E_DCH_LogicalChannelToDeleteItem_logicalChannelId,
        ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id_tab,
        ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id,
        ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality_tab,
        ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality,
        ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue,
        __E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item_,
        _E_DCH_LogicalChannelToDeleteItem_iE_Extensions,
        E_DCH_LogicalChannelToDeleteItem,
        E_DCH_LogicalChannelToDeleteItem_ExtIEs,
        LogicalChannelID,
        E_DCH_HARQ_PO_FDD,
        E_DCH_MACdFlow_ID,
        _E_DCH_MACdFlows_Information_e_DCH_MACdFlow_Specific_Info,
        ____E_DCH_MACdFlows_Information_iE_Extensions__item__id_tab,
        ___E_DCH_MACdFlows_Information_iE_Extensions__item__id,
        ____E_DCH_MACdFlows_Information_iE_Extensions__item__criticality_tab,
        ___E_DCH_MACdFlows_Information_iE_Extensions__item__criticality,
        ____E_DCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_MACdFlows_Information_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlows_Information_iE_Extensions__item_,
        _E_DCH_MACdFlows_Information_iE_Extensions,
        E_DCH_MACdFlows_Information,
        E_DCH_MACdFlows_Information_ExtIEs,
        E_DCH_MACdFlow_Multiplexing_List,
        _E_DCH_MACdFlow_Specific_InfoList__item_,
        E_DCH_MACdFlow_Specific_InfoList,
        _E_DCH_MACdFlow_Specific_InfoItem_e_DCH_MACdFlow_ID,
        _E_DCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority,
        _E_DCH_MACdFlow_Specific_InfoItem_tnlQos,
        _E_DCH_MACdFlow_Specific_InfoItem_payloadCRC_PresenceIndicator,
        _E_DCH_MACdFlow_Specific_InfoItem_maximum_Number_of_Retransmissions_For_E_DCH,
        _E_DCH_MACdFlow_Specific_InfoItem_eDCH_HARQ_PO_FDD,
        _E_DCH_MACdFlow_Specific_InfoItem_eDCH_MACdFlow_Multiplexing_List,
        _E_DCH_MACdFlow_Specific_InfoItem_eDCH_Grant_Type_Information,
        _E_DCH_MACdFlow_Specific_InfoItem_bundlingModeIndicator,
        _E_DCH_MACdFlow_Specific_InfoItem_eDCHLogicalChannelInformation,
        ____E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab,
        _____E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id,
        ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality,
        ___E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_,
        _E_DCH_MACdFlow_Specific_InfoItem_iE_Extensions,
        E_DCH_MACdFlow_Specific_InfoItem,
        E_DCH_MACdFlow_Specific_InfoItem_ExtIEs,
        _E_DCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0,
        _E_DCH_MACdFlow_Specific_InformationResp__item_,
        E_DCH_MACdFlow_Specific_InformationResp,
        _E_DCH_MACdFlow_Specific_InformationResp_Item_e_DCH_MACdFlow_ID,
        _E_DCH_MACdFlow_Specific_InformationResp_Item_bindingID,
        _E_DCH_MACdFlow_Specific_InformationResp_Item_transportLayerAddress,
        _E_DCH_MACdFlow_Specific_InformationResp_Item_hARQ_Process_Allocation_NonSched_2ms_EDCH,
        ____E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab,
        _____E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id,
        ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality,
        ___E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_,
        _E_DCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions,
        E_DCH_MACdFlow_Specific_InformationResp_Item,
        E_DCH_MACdFlow_Specific_InformationResp_Item_ExtIEs,
        _E_DCH_MACdFlow_Specific_InformationResp_Item_ExtIEs_val_Extension_0,
        _E_DCH_MACdFlow_Specific_InfoList_to_Modify__item_,
        E_DCH_MACdFlow_Specific_InfoList_to_Modify,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_e_DCH_MACdFlow_ID,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_allocationRetentionPriority,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_transportBearerRequestIndicator,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_tnlQos,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_maximum_Number_of_Retransmissions_For_E_DCH,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_HARQ_PO_FDD,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_MACdFlow_Multiplexing_List,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_Grant_Type_Information,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_bundlingModeIndicator,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_LogicalChannelToAdd,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_LogicalChannelToModify,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_eDCH_LogicalChannelToDelete,
        ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab,
        ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id,
        ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality_tab,
        ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality,
        ____E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_,
        _E_DCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions,
        E_DCH_MACdFlow_Specific_InfoItem_to_Modify,
        E_DCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs,
        _E_DCH_MACdFlows_to_Delete__item_,
        E_DCH_MACdFlows_to_Delete,
        _E_DCH_MACdFlow_to_Delete_Item_e_DCH_MACdFlow_ID,
        ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__id_tab,
        ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__id,
        ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__criticality_tab,
        ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__criticality,
        ____E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlow_to_Delete_Item_iE_Extensions__item_,
        _E_DCH_MACdFlow_to_Delete_Item_iE_Extensions,
        E_DCH_MACdFlow_to_Delete_Item,
        E_DCH_MACdFlow_to_Delete_Item_ExtIEs,
        _E_DCH_Non_Scheduled_Transmission_Grant_Items_maxBits_MACe_PDU_non_scheduled,
        _E_DCH_Non_Scheduled_Transmission_Grant_Items_hARQ_Process_Allocation_NonSched_2ms,
        ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab,
        _____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id,
        ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality,
        ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue,
        __E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item_,
        _E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions,
        E_DCH_Non_Scheduled_Transmission_Grant_Items,
        E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs,
        _E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs_val_Extension_0,
        E_DCH_Non_serving_Relative_Grant_Down_Commands,
        E_DCHProvidedBitRateValue,
        Maximum_Target_ReceivedTotalWideBandPower,
        Target_NonServing_EDCH_To_Total_EDCH_Power_Ratio,
        E_DCH_RL_Indication,
        _E_DCH_Serving_Cell_Change_Info_Response_e_DCH_serving_cell_choice,
        ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id_tab,
        ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id,
        ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality_tab,
        ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality,
        ____E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue,
        __E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions__item_,
        _E_DCH_Serving_Cell_Change_Info_Response_iE_Extensions,
        E_DCH_Serving_Cell_Change_Info_Response,
        E_DCH_serving_cell_informationResponse_ExtIEs,
        _E_DCH_serving_cell_choice_e_DCH_serving_cell_change_successful,
        _E_DCH_serving_cell_choice_e_DCH_serving_cell_change_unsuccessful,
        E_DCH_serving_cell_choice,
        _E_DCH_serving_cell_change_successful_e_DCH_RL_InformationList_Rsp,
        ____E_DCH_serving_cell_change_successful_iE_Extensions__item__id_tab,
        ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id,
        ____E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality_tab,
        ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality,
        ____E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue,
        __E_DCH_serving_cell_change_successful_iE_Extensions__item_,
        _E_DCH_serving_cell_change_successful_iE_Extensions,
        E_DCH_serving_cell_change_successful,
        _E_DCH_RL_InformationList_Rsp__item_,
        E_DCH_RL_InformationList_Rsp,
        _E_DCH_RL_InformationList_Rsp_Item_rl_ID,
        _E_DCH_RL_InformationList_Rsp_Item_e_DCH_FDD_DL_Control_Channel_Info,
        ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id_tab,
        ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id,
        ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality_tab,
        ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality,
        ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue,
        __E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item_,
        _E_DCH_RL_InformationList_Rsp_Item_iE_Extensions,
        E_DCH_RL_InformationList_Rsp_Item,
        E_DCH_serving_cell_change_successful_ExtIEs,
        E_DCH_RL_InformationList_Rsp_Item_ExtIEs,
        _E_DCH_serving_cell_change_unsuccessful_cause,
        ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab,
        ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id,
        ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab,
        ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality,
        ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue,
        __E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item_,
        _E_DCH_serving_cell_change_unsuccessful_iE_Extensions,
        E_DCH_serving_cell_change_unsuccessful,
        E_DCH_serving_cell_change_unsuccessful_ExtIEs,
        __EDCH_RACH_Report_Value__item__granted_EDCH_RACH_resources,
        __EDCH_RACH_Report_Value__item__denied_EDCH_RACH_resources,
        _____EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab,
        ______EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab_val_Extension_0,
        ______EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab_val_Extension_1,
        ______EDCH_RACH_Report_Value__item__iE_Extensions__item__id_tab_val_Extension_2,
        ____EDCH_RACH_Report_Value__item__iE_Extensions__item__id,
        ____EDCH_RACH_Report_Value__item__iE_Extensions__item__criticality,
        ____EDCH_RACH_Report_Value__item__iE_Extensions__item__extensionValue,
        ___EDCH_RACH_Report_Value__item__iE_Extensions__item_,
        __EDCH_RACH_Report_Value__item__iE_Extensions,
        _EDCH_RACH_Report_Value__item_,
        EDCH_RACH_Report_Value,
        EDCH_RACH_Report_Value_ExtIEs,
        _EDCH_RACH_Report_Value_ExtIEs_val_Extension_0,
        _EDCH_RACH_Report_Value_ExtIEs_val_Extension_1,
        _EDCH_RACH_Report_Value_ExtIEs_val_Extension_2,
        E_DCH_TFCI_Table_Index,
        _E_DCH_TTI_Length_two_ms,
        _E_DCH_TTI_Length_ten_ms,
        E_DCH_TTI_Length,
        _E_DCH_TTI_Length_to_Modify_two_ms,
        _E_DCH_TTI_Length_to_Modify_ten_ms,
        E_DCH_TTI_Length_to_Modify,
        E_DPCCH_PO,
        Extended_E_DPCCH_PO,
        E_DPDCH_PowerInterpolation,
        E_Primary_Secondary_Grant_Selector,
        E_DCH_MACdFlow_ID_LCR,
        _E_DCH_MACdFlows_to_DeleteLCR__item_,
        E_DCH_MACdFlows_to_DeleteLCR,
        _E_DCH_MACdFlow_to_Delete_ItemLCR_e_DCH_MACdFlow_ID_LCR,
        ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__id_tab,
        ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__id,
        ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__criticality_tab,
        ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__criticality,
        ____E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions__item_,
        _E_DCH_MACdFlow_to_Delete_ItemLCR_iE_Extensions,
        E_DCH_MACdFlow_to_Delete_ItemLCR,
        E_DCH_MACdFlow_to_Delete_ItemLCR_ExtIEs,
        _Enhanced_UE_DRX_InformationLCR_t321,
        _Enhanced_UE_DRX_InformationLCR_hS_DSCH_DRX_Cycle_FACH,
        _Enhanced_UE_DRX_InformationLCR_hS_DSCH_RX_Burst_FACH,
        ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__id_tab,
        ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__id,
        ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__criticality_tab,
        ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__criticality,
        ____Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___Enhanced_UE_DRX_InformationLCR_iE_Extensions__item__extensionValue,
        __Enhanced_UE_DRX_InformationLCR_iE_Extensions__item_,
        _Enhanced_UE_DRX_InformationLCR_iE_Extensions,
        Enhanced_UE_DRX_InformationLCR,
        Enhanced_UE_DRX_InformationLCR_ExtIEs,
        E_HICH_ID_LCR,
        E_HICH_Signature_Sequence,
        End_Of_Audit_Sequence_Indicator,
        E_Serving_Grant_Value,
        E_RGCH_2_IndexStepThreshold,
        E_RGCH_3_IndexStepThreshold,
        _E_RGCH_E_HICH_FDD_Code_Information_replace,
        _E_RGCH_E_HICH_FDD_Code_Information_remove,
        E_RGCH_E_HICH_FDD_Code_Information,
        _E_RGCH_E_HICH_FDD_Code_List__item_,
        E_RGCH_E_HICH_FDD_Code_List,
        E_RGCH_Release_Indicator,
        E_RGCH_Signature_Sequence,
        E_RNTI,
        E_TFCI,
        E_TFCI_BetaEC_Boost,
        _E_TFCI_Boost_Information_e_TFCI_BetaEC_Boost,
        _E_TFCI_Boost_Information_uL_Delta_T2TP,
        ____E_TFCI_Boost_Information_iE_Extensions__item__id_tab,
        ___E_TFCI_Boost_Information_iE_Extensions__item__id,
        ____E_TFCI_Boost_Information_iE_Extensions__item__criticality_tab,
        ___E_TFCI_Boost_Information_iE_Extensions__item__criticality,
        ____E_TFCI_Boost_Information_iE_Extensions__item__extensionValue_tab,
        ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue,
        __E_TFCI_Boost_Information_iE_Extensions__item_,
        _E_TFCI_Boost_Information_iE_Extensions,
        E_TFCI_Boost_Information,
        E_TFCI_Boost_Information_ExtIEs,
        _E_TFCS_Information_e_DCH_TFCI_Table_Index,
        _E_TFCS_Information_e_DCH_Min_Set_E_TFCI,
        _E_TFCS_Information_reference_E_TFCI_Information,
        ____E_TFCS_Information_iE_Extensions__item__id_tab,
        _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_TFCS_Information_iE_Extensions__item__id,
        ___E_TFCS_Information_iE_Extensions__item__criticality,
        ___E_TFCS_Information_iE_Extensions__item__extensionValue,
        __E_TFCS_Information_iE_Extensions__item_,
        _E_TFCS_Information_iE_Extensions,
        E_TFCS_Information,
        E_TFCS_Information_ExtIEs,
        _E_TFCS_Information_ExtIEs_val_Extension_0,
        _E_TFCS_Information_ExtIEs_val_Extension_1,
        E_TTI,
        _E_DCHProvidedBitRate__item_,
        E_DCHProvidedBitRate,
        _E_DCHProvidedBitRate_Item_schedulingPriorityIndicator,
        _E_DCHProvidedBitRate_Item_e_DCHProvidedBitRateValue,
        ____E_DCHProvidedBitRate_Item_iE_Extensions__item__id_tab,
        ___E_DCHProvidedBitRate_Item_iE_Extensions__item__id,
        ____E_DCHProvidedBitRate_Item_iE_Extensions__item__criticality_tab,
        ___E_DCHProvidedBitRate_Item_iE_Extensions__item__criticality,
        ____E_DCHProvidedBitRate_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCHProvidedBitRate_Item_iE_Extensions__item__extensionValue,
        __E_DCHProvidedBitRate_Item_iE_Extensions__item_,
        _E_DCHProvidedBitRate_Item_iE_Extensions,
        E_DCHProvidedBitRate_Item,
        E_DCHProvidedBitRate_Item_ExtIEs,
        _E_DCHProvidedBitRateValueInformation_For_CellPortion__item_,
        E_DCHProvidedBitRateValueInformation_For_CellPortion,
        _E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_cellPortionLCRID,
        _E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_e_DCHProvidedBitRateValue,
        ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab,
        ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id,
        ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab,
        ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality,
        ____E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue,
        __E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item_,
        _E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions,
        E_DCHProvidedBitRateValueInformation_For_CellPortion_Item,
        E_DCHProvidedBitRateValueInformation_For_CellPortion_Item_ExtIEs,
        E_AGCH_PowerOffset,
        E_RGCH_PowerOffset,
        E_HICH_PowerOffset,
        E_HICH_TimeOffset,
        E_HICH_TimeOffsetLCR,
        _E_DCH_Information_e_PUCH_Information,
        _E_DCH_Information_e_TFCS_Information_TDD,
        _E_DCH_Information_e_DCH_MACdFlows_Information_TDD,
        _E_DCH_Information_e_DCH_Non_Scheduled_Grant_Info,
        _E_DCH_Information_e_DCH_TDD_Information,
        ____E_DCH_Information_iE_Extensions__item__id_tab,
        ___E_DCH_Information_iE_Extensions__item__id,
        ____E_DCH_Information_iE_Extensions__item__criticality_tab,
        ___E_DCH_Information_iE_Extensions__item__criticality,
        ____E_DCH_Information_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Information_iE_Extensions__item__extensionValue,
        __E_DCH_Information_iE_Extensions__item_,
        _E_DCH_Information_iE_Extensions,
        E_DCH_Information,
        E_DCH_Information_ExtIEs,
        _E_PUCH_Information_minCR,
        _E_PUCH_Information_maxCR,
        _E_PUCH_Information_harqInfo,
        _E_PUCH_Information_n_E_UCCH,
        ____E_PUCH_Information_iE_Extensions__item__id_tab,
        ___E_PUCH_Information_iE_Extensions__item__id,
        ____E_PUCH_Information_iE_Extensions__item__criticality_tab,
        ___E_PUCH_Information_iE_Extensions__item__criticality,
        ____E_PUCH_Information_iE_Extensions__item__extensionValue_tab,
        ___E_PUCH_Information_iE_Extensions__item__extensionValue,
        __E_PUCH_Information_iE_Extensions__item_,
        _E_PUCH_Information_iE_Extensions,
        E_PUCH_Information,
        E_PUCH_Information_ExtIEs,
        _E_TFCS_Information_TDD_e_DCH_QPSK_RefBetaInfo,
        _E_TFCS_Information_TDD_e_DCH_sixteenQAM_RefBetaInfo,
        ____E_TFCS_Information_TDD_iE_Extensions__item__id_tab,
        ___E_TFCS_Information_TDD_iE_Extensions__item__id,
        ____E_TFCS_Information_TDD_iE_Extensions__item__criticality_tab,
        ___E_TFCS_Information_TDD_iE_Extensions__item__criticality,
        ____E_TFCS_Information_TDD_iE_Extensions__item__extensionValue_tab,
        ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue,
        __E_TFCS_Information_TDD_iE_Extensions__item_,
        _E_TFCS_Information_TDD_iE_Extensions,
        E_TFCS_Information_TDD,
        E_TFCS_Information_TDD_ExtIEs,
        _E_DCH_QPSK_RefBetaInfo__item_,
        E_DCH_QPSK_RefBetaInfo,
        _E_DCH_sixteenQAM_RefBetaInfo__item_,
        E_DCH_sixteenQAM_RefBetaInfo,
        _E_DCH_RefBeta_Item_refCodeRate,
        _E_DCH_RefBeta_Item_refBeta,
        E_DCH_RefBeta_Item,
        _E_DCH_MACdFlows_Information_TDD__item_,
        E_DCH_MACdFlows_Information_TDD,
        _E_DCH_MACdFlow_InfoTDDItem_e_DCH_MACdFlow_ID,
        _E_DCH_MACdFlow_InfoTDDItem_allocationRetentionPriority,
        _E_DCH_MACdFlow_InfoTDDItem_tnlQos,
        _E_DCH_MACdFlow_InfoTDDItem_bindingID,
        _E_DCH_MACdFlow_InfoTDDItem_transportLayerAddress,
        _E_DCH_MACdFlow_InfoTDDItem_payloadCRC_PresenceIndicator,
        _E_DCH_MACdFlow_InfoTDDItem_maximum_Number_of_Retransmissions_For_E_DCH,
        _E_DCH_MACdFlow_InfoTDDItem_eDCH_HARQ_PO_TDD,
        _E_DCH_MACdFlow_InfoTDDItem_eDCH_MACdFlow_Multiplexing_List,
        _E_DCH_MACdFlow_InfoTDDItem_eDCH_Grant_TypeTDD,
        _E_DCH_MACdFlow_InfoTDDItem_eDCHLogicalChannelInformation,
        _E_DCH_MACdFlow_InfoTDDItem_eDCH_MACdFlow_Retransmission_Timer,
        ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab,
        ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id,
        ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality_tab,
        ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality,
        ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item_,
        _E_DCH_MACdFlow_InfoTDDItem_iE_Extensions,
        E_DCH_MACdFlow_InfoTDDItem,
        E_DCH_MACdFlow_InfoTDDItem_ExtIEs,
        E_DCH_MACdFlow_Retransmission_Timer,
        E_DCH_HARQ_PO_TDD,
        E_DCH_Grant_TypeTDD,
        _E_DCH_Non_Scheduled_Grant_Info_timeslotResource,
        _E_DCH_Non_Scheduled_Grant_Info_powerResource,
        _E_DCH_Non_Scheduled_Grant_Info_repetitionPeriod,
        _E_DCH_Non_Scheduled_Grant_Info_repetitionLength,
        _E_DCH_Non_Scheduled_Grant_Info_tddE_PUCH_Offset,
        _E_DCH_Non_Scheduled_Grant_Info_tdd_ChannelisationCode,
        ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id_tab,
        ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id,
        ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality_tab,
        ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality,
        ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue,
        __E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item_,
        _E_DCH_Non_Scheduled_Grant_Info_iE_Extensions,
        E_DCH_Non_Scheduled_Grant_Info,
        E_DCH_Non_Scheduled_Grant_Info_ExtIEs,
        E_DCH_TimeslotResource,
        E_DCH_TimeslotResourceLCR,
        E_DCH_PowerResource,
        TddE_PUCH_Offset,
        _E_DCH_TDD_Information_e_DCH_TDD_Maximum_Bitrate,
        _E_DCH_TDD_Information_e_DCH_Processing_Overload_Level,
        _E_DCH_TDD_Information_e_DCH_PowerOffset_for_SchedulingInfo,
        ____E_DCH_TDD_Information_iE_Extensions__item__id_tab,
        ___E_DCH_TDD_Information_iE_Extensions__item__id,
        ____E_DCH_TDD_Information_iE_Extensions__item__criticality_tab,
        ___E_DCH_TDD_Information_iE_Extensions__item__criticality,
        ____E_DCH_TDD_Information_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue,
        __E_DCH_TDD_Information_iE_Extensions__item_,
        _E_DCH_TDD_Information_iE_Extensions,
        E_DCH_TDD_Information,
        E_DCH_TDD_Information_ExtIEs,
        E_DCH_TDD_Maximum_Bitrate,
        _E_DCH_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp,
        _E_DCH_Information_Response_e_AGCH_Specific_Information_ResponseTDD,
        _E_DCH_Information_Response_e_RNTI,
        _E_DCH_Information_Response_scheduled_E_HICH_Specific_InformationResp,
        ____E_DCH_Information_Response_iE_Extensions__item__id_tab,
        ___E_DCH_Information_Response_iE_Extensions__item__id,
        ____E_DCH_Information_Response_iE_Extensions__item__criticality_tab,
        ___E_DCH_Information_Response_iE_Extensions__item__criticality,
        ____E_DCH_Information_Response_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Information_Response_iE_Extensions__item__extensionValue,
        __E_DCH_Information_Response_iE_Extensions__item_,
        _E_DCH_Information_Response_iE_Extensions,
        E_DCH_Information_Response,
        E_DCH_Information_Response_ExtIEs,
        _Scheduled_E_HICH_Specific_Information_ResponseLCRTDD__item_,
        Scheduled_E_HICH_Specific_Information_ResponseLCRTDD,
        _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_eI,
        _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_e_HICH_ID_TDD,
        ____Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id_tab,
        _____Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__id,
        ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__criticality,
        ___Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item__extensionValue,
        __Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions__item_,
        _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_iE_Extensions,
        Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD,
        Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_ExtIEs,
        _Scheduled_E_HICH_Specific_InformationItem_ResponseLCRTDD_ExtIEs_val_Extension_0,
        EI,
        E_HICH_ID_TDD,
        E_HICH_Type,
        _E_DCH_TDD_MACdFlow_Specific_InformationResp__item_,
        E_DCH_TDD_MACdFlow_Specific_InformationResp,
        _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_e_DCH_MacdFlow_Id,
        _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_bindingID,
        _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_transportLayerAddress,
        ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab,
        ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id,
        ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab,
        ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality,
        ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue,
        __E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_,
        _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions,
        E_DCH_TDD_MACdFlow_Specific_InformationResp_Item,
        E_DCH_TDD_MACdFlow_Specific_InformationRespItem_ExtIEs,
        _E_AGCH_Specific_InformationRespListTDD__item_,
        E_AGCH_Specific_InformationRespListTDD,
        _E_AGCH_Specific_InformationResp_ItemTDD_e_AGCH_Id,
        ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id_tab,
        ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id,
        ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality_tab,
        ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality,
        ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue,
        __E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item_,
        _E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions,
        E_AGCH_Specific_InformationResp_ItemTDD,
        E_AGCH_Specific_InformationResp_ItemTDD_ExtIEs,
        E_AGCH_Id,
        _E_DCH_Information_Reconfig_e_PUCH_Information,
        _E_DCH_Information_Reconfig_e_TFCS_Information_TDD,
        _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Add,
        _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Delete,
        _E_DCH_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info,
        _E_DCH_Information_Reconfig_e_DCH_TDD_Information,
        _E_DCH_Information_Reconfig_e_DCH_TDD_Information_to_Modify,
        ____E_DCH_Information_Reconfig_iE_Extensions__item__id_tab,
        ___E_DCH_Information_Reconfig_iE_Extensions__item__id,
        ____E_DCH_Information_Reconfig_iE_Extensions__item__criticality_tab,
        ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality,
        ____E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue,
        __E_DCH_Information_Reconfig_iE_Extensions__item_,
        _E_DCH_Information_Reconfig_iE_Extensions,
        E_DCH_Information_Reconfig,
        E_DCH_Information_Reconfig_ExtIEs,
        _E_DCH_TDD_Information_to_Modify_e_DCH_TDD_Information_to_Modify_List,
        _E_DCH_TDD_Information_to_Modify_mACeReset_Indicator,
        ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab,
        _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id,
        ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality,
        ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue,
        __E_DCH_TDD_Information_to_Modify_iE_Extensions__item_,
        _E_DCH_TDD_Information_to_Modify_iE_Extensions,
        E_DCH_TDD_Information_to_Modify,
        E_DCH_TDD_Information_to_Modify_ExtIEs,
        _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_0,
        _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_1,
        _E_DCH_TDD_Information_to_Modify_List__item_,
        E_DCH_TDD_Information_to_Modify_List,
        _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_MACdFlow_ID,
        _E_DCH_MACdFlow_ModifyTDDItem_allocationRetentionPriority,
        _E_DCH_MACdFlow_ModifyTDDItem_transportBearerRequestIndicator,
        _E_DCH_MACdFlow_ModifyTDDItem_bindingID,
        _E_DCH_MACdFlow_ModifyTDDItem_transportLayerAddress,
        _E_DCH_MACdFlow_ModifyTDDItem_tnlQos,
        _E_DCH_MACdFlow_ModifyTDDItem_maximum_Number_of_Retransmissions_For_E_DCH,
        _E_DCH_MACdFlow_ModifyTDDItem_eDCH_HARQ_PO_TDD,
        _E_DCH_MACdFlow_ModifyTDDItem_eDCH_MACdFlow_Multiplexing_List,
        _E_DCH_MACdFlow_ModifyTDDItem_eDCH_Grant_TypeTDD,
        _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToAdd,
        _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToModify,
        _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToDelete,
        _E_DCH_MACdFlow_ModifyTDDItem_eDCH_MACdFlow_Retransmission_Timer,
        ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab,
        ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id,
        ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality_tab,
        ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality,
        ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item_,
        _E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions,
        E_DCH_MACdFlow_ModifyTDDItem,
        E_DCH_MACdFlow_ModifyTDDItem_ExtIEs,
        Maximum_Generated_ReceivedTotalWideBandPowerInOtherCells,
        _E_DCH_768_Information_e_PUCH_Information,
        _E_DCH_768_Information_e_TFCS_Information_TDD,
        _E_DCH_768_Information_e_DCH_MACdFlows_Information_TDD,
        _E_DCH_768_Information_e_DCH_Non_Scheduled_Grant_Info768,
        _E_DCH_768_Information_e_DCH_TDD_Information768,
        ____E_DCH_768_Information_iE_Extensions__item__id_tab,
        ___E_DCH_768_Information_iE_Extensions__item__id,
        ____E_DCH_768_Information_iE_Extensions__item__criticality_tab,
        ___E_DCH_768_Information_iE_Extensions__item__criticality,
        ____E_DCH_768_Information_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_768_Information_iE_Extensions__item__extensionValue,
        __E_DCH_768_Information_iE_Extensions__item_,
        _E_DCH_768_Information_iE_Extensions,
        E_DCH_768_Information,
        E_DCH_768_Information_ExtIEs,
        _E_DCH_Non_Scheduled_Grant_Info768_timeslotResource,
        _E_DCH_Non_Scheduled_Grant_Info768_powerResource,
        _E_DCH_Non_Scheduled_Grant_Info768_repetitionPeriod,
        _E_DCH_Non_Scheduled_Grant_Info768_repetitionLength,
        _E_DCH_Non_Scheduled_Grant_Info768_tddE_PUCH_Offset,
        _E_DCH_Non_Scheduled_Grant_Info768_tdd_ChannelisationCode768,
        ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id_tab,
        ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id,
        ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality_tab,
        ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality,
        ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue,
        __E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item_,
        _E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions,
        E_DCH_Non_Scheduled_Grant_Info768,
        E_DCH_Non_Scheduled_Grant_Info768_ExtIEs,
        _E_DCH_TDD_Information768_e_DCH_TDD_Maximum_Bitrate768,
        _E_DCH_TDD_Information768_e_DCH_Processing_Overload_Level,
        _E_DCH_TDD_Information768_e_DCH_PowerOffset_for_SchedulingInfo,
        ____E_DCH_TDD_Information768_iE_Extensions__item__id_tab,
        ___E_DCH_TDD_Information768_iE_Extensions__item__id,
        ____E_DCH_TDD_Information768_iE_Extensions__item__criticality_tab,
        ___E_DCH_TDD_Information768_iE_Extensions__item__criticality,
        ____E_DCH_TDD_Information768_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue,
        __E_DCH_TDD_Information768_iE_Extensions__item_,
        _E_DCH_TDD_Information768_iE_Extensions,
        E_DCH_TDD_Information768,
        E_DCH_TDD_Information768_ExtIEs,
        E_DCH_TDD_Maximum_Bitrate768,
        _E_DCH_768_Information_Reconfig_e_PUCH_Information,
        _E_DCH_768_Information_Reconfig_e_TFCS_Information_TDD,
        _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Add,
        _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Delete,
        _E_DCH_768_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info768,
        _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information768,
        _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information_to_Modify,
        ____E_DCH_768_Information_Reconfig_iE_Extensions__item__id_tab,
        ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id,
        ____E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality_tab,
        ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality,
        ____E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue,
        __E_DCH_768_Information_Reconfig_iE_Extensions__item_,
        _E_DCH_768_Information_Reconfig_iE_Extensions,
        E_DCH_768_Information_Reconfig,
        E_DCH_768_Information_Reconfig_ExtIEs,
        _E_DCH_LCR_Information_e_PUCH_LCR_Information,
        _E_DCH_LCR_Information_e_TFCS_Information_TDD,
        _E_DCH_LCR_Information_e_DCH_MACdFlows_Information_TDD,
        _E_DCH_LCR_Information_e_DCH_Non_Scheduled_Grant_LCR_Info,
        _E_DCH_LCR_Information_e_DCH_LCRTDD_Information,
        ____E_DCH_LCR_Information_iE_Extensions__item__id_tab,
        ___E_DCH_LCR_Information_iE_Extensions__item__id,
        ____E_DCH_LCR_Information_iE_Extensions__item__criticality_tab,
        ___E_DCH_LCR_Information_iE_Extensions__item__criticality,
        ____E_DCH_LCR_Information_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue,
        __E_DCH_LCR_Information_iE_Extensions__item_,
        _E_DCH_LCR_Information_iE_Extensions,
        E_DCH_LCR_Information,
        E_DCH_LCR_Information_ExtIEs,
        _E_PUCH_LCR_Information_minCR,
        _E_PUCH_LCR_Information_maxCR,
        _E_PUCH_LCR_Information_harqInfo,
        _E_PUCH_LCR_Information_pRXdes_base,
        _E_PUCH_LCR_Information_e_PUCH_TPC_StepSize,
        _E_PUCH_LCR_Information_e_AGCH_TPC_StepSize,
        ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab,
        _____E_PUCH_LCR_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_PUCH_LCR_Information_iE_Extensions__item__id,
        ___E_PUCH_LCR_Information_iE_Extensions__item__criticality,
        ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue,
        __E_PUCH_LCR_Information_iE_Extensions__item_,
        _E_PUCH_LCR_Information_iE_Extensions,
        E_PUCH_LCR_Information,
        E_PUCH_LCR_Information_ExtIEs,
        _E_PUCH_LCR_Information_ExtIEs_val_Extension_0,
        _E_DCH_Non_Scheduled_Grant_LCR_Info_timeslotResourceLCR,
        _E_DCH_Non_Scheduled_Grant_LCR_Info_powerResource,
        _E_DCH_Non_Scheduled_Grant_LCR_Info_repetitionPeriod,
        _E_DCH_Non_Scheduled_Grant_LCR_Info_repetitionLength,
        _E_DCH_Non_Scheduled_Grant_LCR_Info_subframeNumber,
        _E_DCH_Non_Scheduled_Grant_LCR_Info_tddE_PUCH_Offset,
        _E_DCH_Non_Scheduled_Grant_LCR_Info_tdd_ChannelisationCode,
        _E_DCH_Non_Scheduled_Grant_LCR_Info_n_E_UCCHLCR,
        _E_DCH_Non_Scheduled_Grant_LCR_Info_e_HICH_LCR_Information,
        ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__id_tab,
        ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__id,
        ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__criticality_tab,
        ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__criticality,
        ____E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item__extensionValue,
        __E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions__item_,
        _E_DCH_Non_Scheduled_Grant_LCR_Info_iE_Extensions,
        E_DCH_Non_Scheduled_Grant_LCR_Info,
        E_DCH_Non_Scheduled_Grant_LCR_Info_ExtIEs,
        _E_HICH_LCR_Information_e_HICH_ID_TDD,
        _E_HICH_LCR_Information_signatureSequenceGroupIndex,
        ____E_HICH_LCR_Information_iE_Extensions__item__id_tab,
        _____E_HICH_LCR_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_HICH_LCR_Information_iE_Extensions__item__id,
        ___E_HICH_LCR_Information_iE_Extensions__item__criticality,
        ___E_HICH_LCR_Information_iE_Extensions__item__extensionValue,
        __E_HICH_LCR_Information_iE_Extensions__item_,
        _E_HICH_LCR_Information_iE_Extensions,
        E_HICH_LCR_Information,
        E_HICH_LCR_Information_ExtIEs,
        _E_HICH_LCR_Information_ExtIEs_val_Extension_0,
        _E_DCH_LCRTDD_Information_e_DCH_LCRTDD_PhysicalLayerCategory,
        _E_DCH_LCRTDD_Information_e_DCH_Processing_Overload_Level,
        _E_DCH_LCRTDD_Information_e_DCH_PowerOffset_for_SchedulingInfo,
        ____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab,
        _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____E_DCH_LCRTDD_Information_iE_Extensions__item__id_tab_val_Extension_6,
        ___E_DCH_LCRTDD_Information_iE_Extensions__item__id,
        ___E_DCH_LCRTDD_Information_iE_Extensions__item__criticality,
        ___E_DCH_LCRTDD_Information_iE_Extensions__item__extensionValue,
        __E_DCH_LCRTDD_Information_iE_Extensions__item_,
        _E_DCH_LCRTDD_Information_iE_Extensions,
        E_DCH_LCRTDD_Information,
        E_DCH_LCRTDD_Information_ExtIEs,
        _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_0,
        _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_1,
        _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_2,
        _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_3,
        _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_4,
        _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_5,
        _E_DCH_LCRTDD_Information_ExtIEs_val_Extension_6,
        E_DCH_LCRTDD_PhysicalLayerCategory,
        _E_DCH_LCR_Information_Reconfig_e_PUCH_LCR_Information,
        _E_DCH_LCR_Information_Reconfig_e_TFCS_Information_TDD,
        _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Add,
        _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Delete,
        _E_DCH_LCR_Information_Reconfig_e_DCH_Non_Scheduled_Grant_LCR_Info,
        _E_DCH_LCR_Information_Reconfig_e_DCH_LCRTDD_Information,
        _E_DCH_LCR_Information_Reconfig_e_DCH_TDD_Information_to_Modify,
        ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id_tab,
        ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id,
        ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality_tab,
        ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality,
        ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue,
        __E_DCH_LCR_Information_Reconfig_iE_Extensions__item_,
        _E_DCH_LCR_Information_Reconfig_iE_Extensions,
        E_DCH_LCR_Information_Reconfig,
        E_DCH_LCR_Information_Reconfig_ExtIEs,
        Enabling_Delay,
        Enabling_Delay_Ext_LCR,
        DormantModeIndicator,
        Enhanced_FACH_Capability,
        EnhancedHSServingCC_Abort,
        Enhanced_PCH_Capability,
        Enhanced_UE_DRX_Capability,
        _Enhanced_UE_DRX_InformationFDD_t321,
        _Enhanced_UE_DRX_InformationFDD_hS_DSCH_DRX_Cycle_FACH,
        _Enhanced_UE_DRX_InformationFDD_hS_DSCH_RX_Burst_FACH,
        _Enhanced_UE_DRX_InformationFDD_dRX_Interruption_by_HS_DSCH,
        ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id_tab,
        ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id,
        ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality_tab,
        ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality,
        ____Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab,
        ___Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue,
        __Enhanced_UE_DRX_InformationFDD_iE_Extensions__item_,
        _Enhanced_UE_DRX_InformationFDD_iE_Extensions,
        Enhanced_UE_DRX_InformationFDD,
        Enhanced_UE_DRX_InformationFDD_ExtIEs,
        Extended_E_DCH_LCRTDD_PhysicalLayerCategory,
        Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory,
        Ext_Max_Bits_MACe_PDU_non_scheduled,
        Ext_Reference_E_TFCI_PO,
        ExtendedPropagationDelay,
        Extended_RNC_ID,
        Extended_Round_Trip_Time_Value,
        Extended_HS_SCCH_ID,
        Extended_HS_SICH_ID,
        Extended_E_HICH_ID_TDD,
        _Radio_Links_without_DPCH_FDPCH_Indication__item_,
        Radio_Links_without_DPCH_FDPCH_Indication,
        _Radio_Links_without_DPCH_FDPCH_Information_rL_ID,
        _Radio_Links_without_DPCH_FDPCH_Information_radio_Links_without_DPCH_FDPCH_Operation_Indicator,
        ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id_tab,
        ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id,
        ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality_tab,
        ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality,
        ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue_tab,
        ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue,
        __Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item_,
        _Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions,
        Radio_Links_without_DPCH_FDPCH_Information,
        Radio_Links_without_DPCH_FDPCH_Information_ExtIEs,
        _E_DCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR,
        _E_DCH_Semi_PersistentScheduling_Information_LCR_e_DCH_SPS_Indicator,
        _E_DCH_Semi_PersistentScheduling_Information_LCR_sPS_E_DCH_releted_E_HICH_Information,
        ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab,
        _____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id,
        ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality,
        ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue,
        __E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_,
        _E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions,
        E_DCH_Semi_PersistentScheduling_Information_LCR,
        E_DCH_Semi_PersistentScheduling_Information_LCR_ExtIEs,
        _E_DCH_Semi_PersistentScheduling_Information_LCR_ExtIEs_val_Extension_0,
        E_DCH_SPS_Indicator,
        _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR,
        _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_e_DCH_SPS_Indicator,
        _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_sPS_E_DCH_releted_E_HICH_Information,
        ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab,
        _____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id,
        ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality,
        ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue,
        __E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_,
        _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions,
        E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR,
        E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs,
        _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs_val_Extension_0,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_timeslot_Resource_Related_Information,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_powerResource,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_repetition_Period_List_LCR,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_repetitionLength,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_subframeNumber,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_tddE_PUCH_Offset,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_tdd_ChannelisationCode,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_n_E_UCCHLCR,
        ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab,
        _____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id,
        ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality,
        ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions,
        E_DCH_Semi_PersistentScheduling_Information_ResponseLCR,
        E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs_val_Extension_0,
        ERNTI_Release_Status,
        Common_E_DCH_Implicit_Release_Timer,
        FACH_Measurement_Occasion_Cycle_Length_Coefficient,
        Fast_Reconfiguration_Mode,
        Fast_Reconfiguration_Permission,
        _Fast_TTI_switching_Mode_synchronized_mode1,
        _Fast_TTI_switching_Mode_synchronized_mode2,
        Fast_TTI_switching_Mode_synchronized,
        Mode1_Ind,
        _Fast_TTI_switching_Mode_unsynchronized_mode1,
        _Fast_TTI_switching_Mode_unsynchronized_mode2,
        Fast_TTI_switching_Mode_unsynchronized,
        Fast_TTI_switching_Mode_Supported,
        FDD_DL_ChannelisationCodeNumber,
        _FDD_DL_CodeInformation__item_,
        FDD_DL_CodeInformation,
        _FDD_DL_CodeInformationItem_dl_ScramblingCode,
        _FDD_DL_CodeInformationItem_fdd_DL_ChannelisationCodeNumber,
        _FDD_DL_CodeInformationItem_transmissionGapPatternSequenceCodeInformation,
        ____FDD_DL_CodeInformationItem_iE_Extensions__item__id_tab,
        ___FDD_DL_CodeInformationItem_iE_Extensions__item__id,
        ____FDD_DL_CodeInformationItem_iE_Extensions__item__criticality_tab,
        ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality,
        ____FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue_tab,
        ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue,
        __FDD_DL_CodeInformationItem_iE_Extensions__item_,
        _FDD_DL_CodeInformationItem_iE_Extensions,
        FDD_DL_CodeInformationItem,
        FDD_DL_CodeInformationItem_ExtIEs,
        FDD_S_CCPCH_FrameOffset,
        FDD_S_CCPCH_Offset,
        FDD_TPC_DownlinkStepSize,
        F_DPCH_Capability,
        _F_DPCH_Info_f_DPCH_SlotFormat,
        _F_DPCH_Info_fdd_dl_ChannelisationCodeNumber,
        _F_DPCH_Info_extended_E_DPCCH_PO,
        ____F_DPCH_Info_iE_Extensions__item__id_tab,
        ___F_DPCH_Info_iE_Extensions__item__id,
        ____F_DPCH_Info_iE_Extensions__item__criticality_tab,
        ___F_DPCH_Info_iE_Extensions__item__criticality,
        ____F_DPCH_Info_iE_Extensions__item__extensionValue_tab,
        ___F_DPCH_Info_iE_Extensions__item__extensionValue,
        __F_DPCH_Info_iE_Extensions__item_,
        _F_DPCH_Info_iE_Extensions,
        F_DPCH_Info,
        F_DPCH_Info_ExtIEs,
        _F_DPCH_Info_To_Modify_f_DPCH_SlotFormat,
        _F_DPCH_Info_To_Modify_fdd_dl_ChannelisationCodeNumber,
        _F_DPCH_Info_To_Modify_extended_E_DPCCH_PO,
        ____F_DPCH_Info_To_Modify_iE_Extensions__item__id_tab,
        ___F_DPCH_Info_To_Modify_iE_Extensions__item__id,
        ____F_DPCH_Info_To_Modify_iE_Extensions__item__criticality_tab,
        ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality,
        ____F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue_tab,
        ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue,
        __F_DPCH_Info_To_Modify_iE_Extensions__item_,
        _F_DPCH_Info_To_Modify_iE_Extensions,
        F_DPCH_Info_To_Modify,
        F_DPCH_Info_To_Modify_ExtIEs,
        F_DPCH_SlotFormat,
        F_DPCH_SlotFormatCapability,
        FirstRLS_Indicator,
        FNReportingIndicator,
        FrameHandlingPriority,
        FrameAdjustmentValue,
        FrameOffset,
        FPACH_Power,
        _FTPICH_Information_fTPICH_SlotFormat,
        _FTPICH_Information_fTPICH_Offset,
        _FTPICH_Information_fTPICH_ChannelisationCodeNumber,
        ____FTPICH_Information_iE_Extensions__item__id_tab,
        ___FTPICH_Information_iE_Extensions__item__id,
        ____FTPICH_Information_iE_Extensions__item__criticality_tab,
        ___FTPICH_Information_iE_Extensions__item__criticality,
        ____FTPICH_Information_iE_Extensions__item__extensionValue_tab,
        ___FTPICH_Information_iE_Extensions__item__extensionValue,
        __FTPICH_Information_iE_Extensions__item_,
        _FTPICH_Information_iE_Extensions,
        FTPICH_Information,
        FTPICH_Information_ExtIEs,
        FTPICH_SlotFormat,
        FTPICH_Offset,
        FTPICH_Information_Removal,
        _FTPICH_Information_To_Modify_fTPICH_SlotFormat,
        _FTPICH_Information_To_Modify_fTPICH_Offset,
        _FTPICH_Information_To_Modify_fTPICH_ChannelisationCodeNumber,
        ____FTPICH_Information_To_Modify_iE_Extensions__item__id_tab,
        ___FTPICH_Information_To_Modify_iE_Extensions__item__id,
        ____FTPICH_Information_To_Modify_iE_Extensions__item__criticality_tab,
        ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality,
        ____FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue_tab,
        ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue,
        __FTPICH_Information_To_Modify_iE_Extensions__item_,
        _FTPICH_Information_To_Modify_iE_Extensions,
        FTPICH_Information_To_Modify,
        FTPICH_Information_To_Modify_ExtIEs,
        _FTPICH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information,
        ____FTPICH_Information_Reconf_iE_Extensions__item__id_tab,
        ___FTPICH_Information_Reconf_iE_Extensions__item__id,
        ____FTPICH_Information_Reconf_iE_Extensions__item__criticality_tab,
        ___FTPICH_Information_Reconf_iE_Extensions__item__criticality,
        ____FTPICH_Information_Reconf_iE_Extensions__item__extensionValue_tab,
        ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue,
        __FTPICH_Information_Reconf_iE_Extensions__item_,
        _FTPICH_Information_Reconf_iE_Extensions,
        FTPICH_Information_Reconf,
        FTPICH_Information_Reconf_ExtIEs,
        _Further_Enhanced_UE_DRX_InformationFDD_hS_DSCH_second_DRX_Cycle_FACH,
        _Further_Enhanced_UE_DRX_InformationFDD_cHOICE_DRX_level,
        ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id_tab,
        ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__id,
        ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality_tab,
        ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__criticality,
        ____Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab,
        ___Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item__extensionValue,
        __Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions__item_,
        _Further_Enhanced_UE_DRX_InformationFDD_iE_Extensions,
        Further_Enhanced_UE_DRX_InformationFDD,
        Further_Enhanced_UE_DRX_InformationFDD_ExtIEs,
        __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaC,
        __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaD,
        __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_refTFCNumber,
        _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id_tab,
        ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id,
        _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality_tab,
        ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality,
        _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue_tab,
        ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue,
        ___Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item_,
        __Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions,
        _Gainfactors_10ms_mode_signalledGainFactors10ms,
        _Gainfactors_10ms_mode_computedGainFactors10ms,
        Gainfactors_10ms_mode,
        SignalledGainFactors10ms_ExtIEs,
        _GANSS_AddClockModels_navClockModel,
        _GANSS_AddClockModels_cnavClockModel,
        _GANSS_AddClockModels_glonassClockModel,
        _GANSS_AddClockModels_sbasClockModel,
        _GANSS_AddClockModels_bdsClockModel,
        GANSS_AddClockModels,
        GANSS_AddIonoModelReq,
        GANSS_AddNavigationModelsReq,
        _GANSS_AddOrbitModels_navKeplerianSet,
        _GANSS_AddOrbitModels_cnavKeplerianSet,
        _GANSS_AddOrbitModels_glonassECEF,
        _GANSS_AddOrbitModels_sbasECEF,
        _GANSS_AddOrbitModels_bdsKeplerianSet,
        GANSS_AddOrbitModels,
        GANSS_AddUTCModelsReq,
        _GANSS_Additional_Ionospheric_Model_dataID,
        _GANSS_Additional_Ionospheric_Model_alpha_beta_parameters,
        ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab,
        ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id,
        ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab,
        ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality,
        ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue,
        __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_,
        _GANSS_Additional_Ionospheric_Model_ie_Extensions,
        GANSS_Additional_Ionospheric_Model,
        GANSS_Additional_Ionospheric_Model_ExtIEs,
        _GANSS_Additional_Navigation_Models_ganss_Transmission_Time,
        _GANSS_Additional_Navigation_Models_non_broadcastIndication,
        _GANSS_Additional_Navigation_Models_ganssSatInfoNavList,
        ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab,
        ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id,
        ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab,
        ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality,
        ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue,
        __GANSS_Additional_Navigation_Models_ie_Extensions__item_,
        _GANSS_Additional_Navigation_Models_ie_Extensions,
        GANSS_Additional_Navigation_Models,
        GANSS_Additional_Navigation_Models_ExtIEs,
        _GANSS_Additional_Time_Models__item_,
        GANSS_Additional_Time_Models,
        _GANSS_Additional_UTC_Models_utcModel1,
        _GANSS_Additional_UTC_Models_utcModel2,
        _GANSS_Additional_UTC_Models_utcModel3,
        _GANSS_Additional_UTC_Models_utcModel4,
        GANSS_Additional_UTC_Models,
        _GANSS_Almanac_ganss_wk_number,
        _GANSS_Almanac_gANSS_AlmanacModel,
        ____GANSS_Almanac_ie_Extensions__item__id_tab,
        _____GANSS_Almanac_ie_Extensions__item__id_tab_val_Extension_0,
        ___GANSS_Almanac_ie_Extensions__item__id,
        ___GANSS_Almanac_ie_Extensions__item__criticality,
        ___GANSS_Almanac_ie_Extensions__item__extensionValue,
        __GANSS_Almanac_ie_Extensions__item_,
        _GANSS_Almanac_ie_Extensions,
        GANSS_Almanac,
        GANSS_Almanac_ExtIEs,
        _GANSS_Almanac_ExtIEs_val_Extension_0,
        _GANSS_AlmanacModel_gANSS_keplerianParameters,
        _GANSS_AlmanacModel_extension_GANSS_AlmanacModel,
        GANSS_AlmanacModel,
        __Extension_GANSS_AlmanacModel_id_tab,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_0,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_1,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_2,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_3,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_4,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_5,
        _Extension_GANSS_AlmanacModel_id,
        _Extension_GANSS_AlmanacModel_criticality,
        _Extension_GANSS_AlmanacModel_value,
        Extension_GANSS_AlmanacModel,
        Extension_GANSS_AlmanacModel_IE,
        _Extension_GANSS_AlmanacModel_IE_val_Value_0,
        _Extension_GANSS_AlmanacModel_IE_val_Value_1,
        _Extension_GANSS_AlmanacModel_IE_val_Value_2,
        _Extension_GANSS_AlmanacModel_IE_val_Value_3,
        _Extension_GANSS_AlmanacModel_IE_val_Value_4,
        _Extension_GANSS_AlmanacModel_IE_val_Value_5,
        _GANSS_ALM_ECEFsbasAlmanacSet_sat_info_SBASecefList,
        ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id_tab,
        ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id,
        ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality,
        ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue,
        __GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item_,
        _GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions,
        GANSS_ALM_ECEFsbasAlmanacSet,
        GANSS_ALM_ECEFsbasAlmanacSet_ExtIEs,
        _GANSS_ALM_GlonassAlmanacSet_sat_info_GLOkpList,
        ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id_tab,
        ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id,
        ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality,
        ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue,
        __GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item_,
        _GANSS_ALM_GlonassAlmanacSet_ie_Extensions,
        GANSS_ALM_GlonassAlmanacSet,
        GANSS_ALM_GlonassAlmanacSet_ExtIEs,
        _GANSS_ALM_MidiAlmanacSet_t_oa,
        _GANSS_ALM_MidiAlmanacSet_sat_info_MIDIkpList,
        ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id_tab,
        ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id,
        ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality,
        ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue,
        __GANSS_ALM_MidiAlmanacSet_ie_Extensions__item_,
        _GANSS_ALM_MidiAlmanacSet_ie_Extensions,
        GANSS_ALM_MidiAlmanacSet,
        GANSS_ALM_MidiAlmanacSet_ExtIEs,
        _GANSS_ALM_NAVKeplerianSet_t_oa,
        _GANSS_ALM_NAVKeplerianSet_sat_info_NAVkpList,
        ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id_tab,
        ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id,
        ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality,
        ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue,
        __GANSS_ALM_NAVKeplerianSet_ie_Extensions__item_,
        _GANSS_ALM_NAVKeplerianSet_ie_Extensions,
        GANSS_ALM_NAVKeplerianSet,
        GANSS_ALM_NAVKeplerianSet_ExtIEs,
        _GANSS_ALM_KEPLERIANBDSALMANAC_sat_info_BDSkpList,
        ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__id_tab,
        ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__id,
        ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__criticality,
        ____GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item__extensionValue,
        __GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions__item_,
        _GANSS_ALM_KEPLERIANBDSALMANAC_ie_Extensions,
        GANSS_ALM_KEPLERIANBDSALMANAC,
        GANSS_ALM_KEPLERIANBDSALMANAC_ExtIEs,
        _GANSS_ALM_ReducedKeplerianSet_t_oa,
        _GANSS_ALM_ReducedKeplerianSet_sat_info_REDkpList,
        ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id_tab,
        ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id,
        ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality,
        ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue,
        __GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item_,
        _GANSS_ALM_ReducedKeplerianSet_ie_Extensions,
        GANSS_ALM_ReducedKeplerianSet,
        GANSS_ALM_ReducedKeplerianSet_ExtIEs,
        _GANSS_Auxiliary_Information_ganssID1,
        _GANSS_Auxiliary_Information_ganssID3,
        GANSS_Auxiliary_Information,
        _GANSS_AuxInfoGANSS_ID1__item_,
        GANSS_AuxInfoGANSS_ID1,
        _GANSS_AuxInfoGANSS_ID1_element_svID,
        _GANSS_AuxInfoGANSS_ID1_element_signalsAvailable,
        ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__id_tab,
        ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__id,
        ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality_tab,
        ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality,
        ____GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue_tab,
        ___GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue,
        __GANSS_AuxInfoGANSS_ID1_element_ie_Extensions__item_,
        _GANSS_AuxInfoGANSS_ID1_element_ie_Extensions,
        GANSS_AuxInfoGANSS_ID1_element,
        GANSS_AuxInfoGANSS_ID1_element_ExtIEs,
        _GANSS_AuxInfoGANSS_ID3__item_,
        GANSS_AuxInfoGANSS_ID3,
        _GANSS_AuxInfoGANSS_ID3_element_svID,
        _GANSS_AuxInfoGANSS_ID3_element_signalsAvailable,
        _GANSS_AuxInfoGANSS_ID3_element_channelNumber,
        ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__id_tab,
        ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__id,
        ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality_tab,
        ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality,
        ____GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue_tab,
        ___GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue,
        __GANSS_AuxInfoGANSS_ID3_element_ie_Extensions__item_,
        _GANSS_AuxInfoGANSS_ID3_element_ie_Extensions,
        GANSS_AuxInfoGANSS_ID3_element,
        GANSS_AuxInfoGANSS_ID3_element_ExtIEs,
        GANSS_AuxInfoReq,
        _GANSS_BDSclockModel_bdsToc,
        _GANSS_BDSclockModel_bdsa0,
        _GANSS_BDSclockModel_bdsa1,
        _GANSS_BDSclockModel_bdsa2,
        _GANSS_BDSclockModel_bdsTgd1,
        _GANSS_BDSclockModel_bdsAODC,
        ____GANSS_BDSclockModel_ie_Extensions__item__id_tab,
        ___GANSS_BDSclockModel_ie_Extensions__item__id,
        ____GANSS_BDSclockModel_ie_Extensions__item__criticality_tab,
        ___GANSS_BDSclockModel_ie_Extensions__item__criticality,
        ____GANSS_BDSclockModel_ie_Extensions__item__extensionValue_tab,
        ___GANSS_BDSclockModel_ie_Extensions__item__extensionValue,
        __GANSS_BDSclockModel_ie_Extensions__item_,
        _GANSS_BDSclockModel_ie_Extensions,
        GANSS_BDSclockModel,
        GANSS_BDSclockModel_ExtIEs,
        _GANSS_Clock_Model__item_,
        GANSS_Clock_Model,
        _GANSS_CNAVclockModel_cnavToc,
        _GANSS_CNAVclockModel_cnavTop,
        _GANSS_CNAVclockModel_cnavURA0,
        _GANSS_CNAVclockModel_cnavURA1,
        _GANSS_CNAVclockModel_cnavURA2,
        _GANSS_CNAVclockModel_cnavAf2,
        _GANSS_CNAVclockModel_cnavAf1,
        _GANSS_CNAVclockModel_cnavAf0,
        _GANSS_CNAVclockModel_cnavTgd,
        _GANSS_CNAVclockModel_cnavISCl1cp,
        _GANSS_CNAVclockModel_cnavISCl1cd,
        _GANSS_CNAVclockModel_cnavISCl1ca,
        _GANSS_CNAVclockModel_cnavISCl2c,
        _GANSS_CNAVclockModel_cnavISCl5i5,
        _GANSS_CNAVclockModel_cnavISCl5q5,
        ____GANSS_CNAVclockModel_ie_Extensions__item__id_tab,
        ___GANSS_CNAVclockModel_ie_Extensions__item__id,
        ____GANSS_CNAVclockModel_ie_Extensions__item__criticality_tab,
        ___GANSS_CNAVclockModel_ie_Extensions__item__criticality,
        ____GANSS_CNAVclockModel_ie_Extensions__item__extensionValue_tab,
        ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue,
        __GANSS_CNAVclockModel_ie_Extensions__item_,
        _GANSS_CNAVclockModel_ie_Extensions,
        GANSS_CNAVclockModel,
        GANSS_CNAVclockModel_ExtIEs,
        _GANSS_Common_Data_ganss_Ionospheric_Model,
        _GANSS_Common_Data_ganss_Rx_Pos,
        ____GANSS_Common_Data_ie_Extensions__item__id_tab,
        _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_0,
        _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_1,
        ___GANSS_Common_Data_ie_Extensions__item__id,
        ___GANSS_Common_Data_ie_Extensions__item__criticality,
        ___GANSS_Common_Data_ie_Extensions__item__extensionValue,
        __GANSS_Common_Data_ie_Extensions__item_,
        _GANSS_Common_Data_ie_Extensions,
        GANSS_Common_Data,
        GANSS_Common_Data_ExtIEs,
        _GANSS_Common_Data_ExtIEs_val_Extension_0,
        _GANSS_Common_Data_ExtIEs_val_Extension_1,
        _GANSS_CommonDataInfoReq_ionospheric_Model,
        ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab,
        _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_0,
        _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_1,
        ___GANSS_CommonDataInfoReq_ie_Extensions__item__id,
        ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality,
        ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue,
        __GANSS_CommonDataInfoReq_ie_Extensions__item_,
        _GANSS_CommonDataInfoReq_ie_Extensions,
        GANSS_CommonDataInfoReq,
        GANSS_CommonDataInfoReq_ExtIEs,
        _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_0,
        _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_1,
        _GANSS_Data_Bit_Assistance_ganssTod,
        _GANSS_Data_Bit_Assistance_dataBitAssistancelist,
        ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab,
        ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id,
        ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab,
        ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality,
        ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue,
        __GANSS_Data_Bit_Assistance_ie_Extensions__item_,
        _GANSS_Data_Bit_Assistance_ie_Extensions,
        GANSS_Data_Bit_Assistance,
        GANSS_Data_Bit_Assistance_ExtIEs,
        _GANSS_DataBitAssistanceList__item_,
        GANSS_DataBitAssistanceList,
        _GANSS_DataBitAssistanceItem_satId,
        _GANSS_DataBitAssistanceItem_dataBitAssistanceSgnList,
        ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab,
        ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id,
        ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab,
        ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality,
        ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue,
        __GANSS_DataBitAssistanceItem_ie_Extensions__item_,
        _GANSS_DataBitAssistanceItem_ie_Extensions,
        GANSS_DataBitAssistanceItem,
        GANSS_DataBitAssistanceItem_ExtIEs,
        _GANSS_DataBitAssistanceSgnList__item_,
        GANSS_DataBitAssistanceSgnList,
        _GANSS_DataBitAssistanceSgnItem_ganss_SignalId,
        _GANSS_DataBitAssistanceSgnItem_ganssDataBits,
        ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab,
        ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id,
        ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab,
        ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality,
        ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue,
        __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_,
        _GANSS_DataBitAssistanceSgnItem_ie_Extensions,
        GANSS_DataBitAssistanceSgnItem,
        GANSS_DataBitAssistanceSgnItem_ExtIEs,
        _GANSS_Data_Bit_Assistance_ReqItem_ganssTod,
        _GANSS_Data_Bit_Assistance_ReqItem_ganss_Data_Bit_Assistance_ReqList,
        ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id_tab,
        ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id,
        ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality_tab,
        ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality,
        ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue_tab,
        ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue,
        __GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item_,
        _GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions,
        GANSS_Data_Bit_Assistance_ReqItem,
        GANSS_Data_Bit_Assistance_ReqItem_ExtIEs,
        _GANSS_Data_Bit_Assistance_ReqList_dGANSS_Signal_ID,
        _GANSS_Data_Bit_Assistance_ReqList_ganss_DataBitInterval,
        __GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo__item_,
        _GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo,
        ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id_tab,
        ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id,
        ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality_tab,
        ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality,
        ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue_tab,
        ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue,
        __GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item_,
        _GANSS_Data_Bit_Assistance_ReqList_iE_Extensions,
        GANSS_Data_Bit_Assistance_ReqList,
        GANSS_Data_Bit_Assistance_ReqList_ExtIEs,
        GANSS_Delta_T,
        _GANSS_DeltaUT1_b1,
        _GANSS_DeltaUT1_b2,
        ____GANSS_DeltaUT1_ie_Extensions__item__id_tab,
        ___GANSS_DeltaUT1_ie_Extensions__item__id,
        ____GANSS_DeltaUT1_ie_Extensions__item__criticality_tab,
        ___GANSS_DeltaUT1_ie_Extensions__item__criticality,
        ____GANSS_DeltaUT1_ie_Extensions__item__extensionValue_tab,
        ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue,
        __GANSS_DeltaUT1_ie_Extensions__item_,
        _GANSS_DeltaUT1_ie_Extensions,
        GANSS_DeltaUT1,
        GANSS_DeltaUT1_ExtIEs,
        _GANSS_Earth_Orientation_Parameters_teop,
        _GANSS_Earth_Orientation_Parameters_pmX,
        _GANSS_Earth_Orientation_Parameters_pmXdot,
        _GANSS_Earth_Orientation_Parameters_pmY,
        _GANSS_Earth_Orientation_Parameters_pmYdot,
        _GANSS_Earth_Orientation_Parameters_deltaUT1,
        _GANSS_Earth_Orientation_Parameters_deltaUT1dot,
        ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab,
        ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id,
        ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab,
        ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality,
        ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue,
        __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_,
        _GANSS_Earth_Orientation_Parameters_ie_Extensions,
        GANSS_Earth_Orientation_Parameters,
        GANSS_Earth_Orientation_Parameters_ExtIEs,
        GANSS_EarthOrientParaReq,
        _GANSS_GenericDataInfoReqList__item_,
        GANSS_GenericDataInfoReqList,
        _GANSS_GenericDataInfoReqItem_ganss_Id,
        _GANSS_GenericDataInfoReqItem_ganss_Navigation_Model_And_Time_Recovery,
        _GANSS_GenericDataInfoReqItem_ganss_Time_Model_GNSS_GNSS,
        _GANSS_GenericDataInfoReqItem_ganss_UTC_Model,
        _GANSS_GenericDataInfoReqItem_ganss_Almanac,
        _GANSS_GenericDataInfoReqItem_ganss_Real_Time_Integrity,
        _GANSS_GenericDataInfoReqItem_ganss_Data_Bit_Assistance_Req,
        ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_0,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_1,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_2,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_3,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_4,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_5,
        ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id,
        ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality,
        ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue,
        __GANSS_GenericDataInfoReqItem_ie_Extensions__item_,
        _GANSS_GenericDataInfoReqItem_ie_Extensions,
        GANSS_GenericDataInfoReqItem,
        GANSS_GenericDataInfoReqItem_ExtIEs,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_0,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_1,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_2,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_3,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_4,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_5,
        _GANSS_Generic_Data__item_,
        GANSS_Generic_Data,
        _GANSS_Generic_DataItem_ganss_Id,
        _GANSS_Generic_DataItem_dganss_Correction,
        _GANSS_Generic_DataItem_ganss_Navigation_Model_And_Time_Recovery,
        _GANSS_Generic_DataItem_ganss_Time_Model,
        _GANSS_Generic_DataItem_ganss_UTC_TIME,
        _GANSS_Generic_DataItem_ganss_Almanac,
        _GANSS_Generic_DataItem_ganss_Real_Time_Integrity,
        _GANSS_Generic_DataItem_ganss_Data_Bit_Assistance,
        ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_0,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_1,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_2,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_3,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_4,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_5,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_6,
        ___GANSS_Generic_DataItem_ie_Extensions__item__id,
        ___GANSS_Generic_DataItem_ie_Extensions__item__criticality,
        ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue,
        __GANSS_Generic_DataItem_ie_Extensions__item_,
        _GANSS_Generic_DataItem_ie_Extensions,
        GANSS_Generic_DataItem,
        GANSS_Generic_DataItem_ExtIEs,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_0,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_1,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_2,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_3,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_4,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_5,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_6,
        _GANSS_GLONASSclockModel_gloTau,
        _GANSS_GLONASSclockModel_gloGamma,
        _GANSS_GLONASSclockModel_gloDeltaTau,
        ____GANSS_GLONASSclockModel_ie_Extensions__item__id_tab,
        ___GANSS_GLONASSclockModel_ie_Extensions__item__id,
        ____GANSS_GLONASSclockModel_ie_Extensions__item__criticality_tab,
        ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality,
        ____GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue_tab,
        ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue,
        __GANSS_GLONASSclockModel_ie_Extensions__item_,
        _GANSS_GLONASSclockModel_ie_Extensions,
        GANSS_GLONASSclockModel,
        GANSS_GLONASSclockModel_ExtIEs,
        GANSS_ID,
        _GANSS_Information_gANSS_CommonDataInfoReq,
        _GANSS_Information_gANSS_GenericDataInfoReqList,
        ____GANSS_Information_ie_Extensions__item__id_tab,
        ___GANSS_Information_ie_Extensions__item__id,
        ____GANSS_Information_ie_Extensions__item__criticality_tab,
        ___GANSS_Information_ie_Extensions__item__criticality,
        ____GANSS_Information_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Information_ie_Extensions__item__extensionValue,
        __GANSS_Information_ie_Extensions__item_,
        _GANSS_Information_ie_Extensions,
        GANSS_Information,
        GANSS_Information_ExtIEs,
        _GANSS_Ionospheric_Model_alpha_zero_ionos,
        _GANSS_Ionospheric_Model_alpha_one_ionos,
        _GANSS_Ionospheric_Model_alpha_two_ionos,
        _GANSS_Ionospheric_Model_gANSS_IonosphereRegionalStormFlags,
        ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab,
        ___GANSS_Ionospheric_Model_ie_Extensions__item__id,
        ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab,
        ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality,
        ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue,
        __GANSS_Ionospheric_Model_ie_Extensions__item_,
        _GANSS_Ionospheric_Model_ie_Extensions,
        GANSS_Ionospheric_Model,
        GANSS_Ionospheric_Model_ExtIEs,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_one,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_two,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_three,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_four,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_five,
        ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab,
        ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id,
        ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab,
        ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality,
        ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab,
        ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue,
        __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_,
        _GANSS_IonosphereRegionalStormFlags_ie_Extensions,
        GANSS_IonosphereRegionalStormFlags,
        GANSS_IonosphereRegionalStormFlags_ExtIEs,
        _GANSS_KeplerianParametersAlm_t_oa,
        _GANSS_KeplerianParametersAlm_iod_a,
        _GANSS_KeplerianParametersAlm_gANSS_SatelliteInformationKP,
        ____GANSS_KeplerianParametersAlm_ie_Extensions__item__id_tab,
        ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id,
        ____GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality_tab,
        ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality,
        ____GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue_tab,
        ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue,
        __GANSS_KeplerianParametersAlm_ie_Extensions__item_,
        _GANSS_KeplerianParametersAlm_ie_Extensions,
        GANSS_KeplerianParametersAlm,
        GANSS_KeplerianParametersAlm_ExtIEs,
        _GANSS_KeplerianParametersOrb_toe_nav,
        _GANSS_KeplerianParametersOrb_ganss_omega_nav,
        _GANSS_KeplerianParametersOrb_delta_n_nav,
        _GANSS_KeplerianParametersOrb_m_zero_nav,
        _GANSS_KeplerianParametersOrb_omegadot_nav,
        _GANSS_KeplerianParametersOrb_ganss_e_nav,
        _GANSS_KeplerianParametersOrb_idot_nav,
        _GANSS_KeplerianParametersOrb_a_sqrt_nav,
        _GANSS_KeplerianParametersOrb_i_zero_nav,
        _GANSS_KeplerianParametersOrb_omega_zero_nav,
        _GANSS_KeplerianParametersOrb_c_rs_nav,
        _GANSS_KeplerianParametersOrb_c_is_nav,
        _GANSS_KeplerianParametersOrb_c_us_nav,
        _GANSS_KeplerianParametersOrb_c_rc_nav,
        _GANSS_KeplerianParametersOrb_c_ic_nav,
        _GANSS_KeplerianParametersOrb_c_uc_nav,
        ____GANSS_KeplerianParametersOrb_ie_Extensions__item__id_tab,
        ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id,
        ____GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality_tab,
        ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality,
        ____GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue_tab,
        ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue,
        __GANSS_KeplerianParametersOrb_ie_Extensions__item_,
        _GANSS_KeplerianParametersOrb_ie_Extensions,
        GANSS_KeplerianParametersOrb,
        GANSS_KeplerianParametersOrb_ExtIEs,
        _GANSS_NAVclockModel_navToc,
        _GANSS_NAVclockModel_navaf2,
        _GANSS_NAVclockModel_navaf1,
        _GANSS_NAVclockModel_navaf0,
        _GANSS_NAVclockModel_navTgd,
        ____GANSS_NAVclockModel_ie_Extensions__item__id_tab,
        ___GANSS_NAVclockModel_ie_Extensions__item__id,
        ____GANSS_NAVclockModel_ie_Extensions__item__criticality_tab,
        ___GANSS_NAVclockModel_ie_Extensions__item__criticality,
        ____GANSS_NAVclockModel_ie_Extensions__item__extensionValue_tab,
        ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue,
        __GANSS_NAVclockModel_ie_Extensions__item_,
        _GANSS_NAVclockModel_ie_Extensions,
        GANSS_NAVclockModel,
        GANSS_NAVclockModel_ExtIEs,
        _GANSS_Navigation_Model_And_Time_Recovery_ganss_Transmission_Time,
        _GANSS_Navigation_Model_And_Time_Recovery_non_broadcastIndication,
        _GANSS_Navigation_Model_And_Time_Recovery_ganssSatInfoNav,
        ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id_tab,
        ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id,
        ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality_tab,
        ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality,
        ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue,
        __GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item_,
        _GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions,
        GANSS_Navigation_Model_And_Time_Recovery,
        GANSS_Navigation_Model_And_Time_Recovery_ExtIEs,
        _GANSS_NavModel_BDSKeplerianSet_bdsURAI,
        _GANSS_NavModel_BDSKeplerianSet_bdsToe,
        _GANSS_NavModel_BDSKeplerianSet_bdsAPowerHalf,
        _GANSS_NavModel_BDSKeplerianSet_bdsE,
        _GANSS_NavModel_BDSKeplerianSet_bdsW,
        _GANSS_NavModel_BDSKeplerianSet_bdsDeltaN,
        _GANSS_NavModel_BDSKeplerianSet_bdsM0,
        _GANSS_NavModel_BDSKeplerianSet_bdsOmega0,
        _GANSS_NavModel_BDSKeplerianSet_bdsOmegaDot,
        _GANSS_NavModel_BDSKeplerianSet_bdsI0,
        _GANSS_NavModel_BDSKeplerianSet_bdsIDot,
        _GANSS_NavModel_BDSKeplerianSet_bdsCuc,
        _GANSS_NavModel_BDSKeplerianSet_bdsCus,
        _GANSS_NavModel_BDSKeplerianSet_bdsCrc,
        _GANSS_NavModel_BDSKeplerianSet_bdsCrs,
        _GANSS_NavModel_BDSKeplerianSet_bdsCic,
        _GANSS_NavModel_BDSKeplerianSet_bdsCis,
        _GANSS_NavModel_BDSKeplerianSet_bdsAODE,
        ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__id_tab,
        ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__id,
        ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__criticality_tab,
        ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__criticality,
        ____GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue,
        __GANSS_NavModel_BDSKeplerianSet_ie_Extensions__item_,
        _GANSS_NavModel_BDSKeplerianSet_ie_Extensions,
        GANSS_NavModel_BDSKeplerianSet,
        GANSS_NavModel_BDSKeplerianSet_ExtIEs,
        _GANSS_NavModel_CNAVKeplerianSet_cnavTop,
        _GANSS_NavModel_CNAVKeplerianSet_cnavURAindex,
        _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaA,
        _GANSS_NavModel_CNAVKeplerianSet_cnavAdot,
        _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNo,
        _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNoDot,
        _GANSS_NavModel_CNAVKeplerianSet_cnavMo,
        _GANSS_NavModel_CNAVKeplerianSet_cnavE,
        _GANSS_NavModel_CNAVKeplerianSet_cnavOmega,
        _GANSS_NavModel_CNAVKeplerianSet_cnavOMEGA0,
        _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot,
        _GANSS_NavModel_CNAVKeplerianSet_cnavIo,
        _GANSS_NavModel_CNAVKeplerianSet_cnavIoDot,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCis,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCic,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCrs,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCrc,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCus,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCuc,
        ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab,
        ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id,
        ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab,
        ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality,
        ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue,
        __GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item_,
        _GANSS_NavModel_CNAVKeplerianSet_ie_Extensions,
        GANSS_NavModel_CNAVKeplerianSet,
        GANSS_NavModel_CNAVKeplerianSet_ExtIEs,
        _GANSS_NavModel_GLONASSecef_gloEn,
        _GANSS_NavModel_GLONASSecef_gloP1,
        _GANSS_NavModel_GLONASSecef_gloP2,
        _GANSS_NavModel_GLONASSecef_gloM,
        _GANSS_NavModel_GLONASSecef_gloX,
        _GANSS_NavModel_GLONASSecef_gloXdot,
        _GANSS_NavModel_GLONASSecef_gloXdotdot,
        _GANSS_NavModel_GLONASSecef_gloY,
        _GANSS_NavModel_GLONASSecef_gloYdot,
        _GANSS_NavModel_GLONASSecef_gloYdotdot,
        _GANSS_NavModel_GLONASSecef_gloZ,
        _GANSS_NavModel_GLONASSecef_gloZdot,
        _GANSS_NavModel_GLONASSecef_gloZdotdot,
        ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__id_tab,
        ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id,
        ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality_tab,
        ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality,
        ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab,
        ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue,
        __GANSS_NavModel_GLONASSecef_ie_Extensions__item_,
        _GANSS_NavModel_GLONASSecef_ie_Extensions,
        GANSS_NavModel_GLONASSecef,
        GANSS_NavModel_GLONASSecef_ExtIEs,
        _GANSS_NavModel_NAVKeplerianSet_navURA,
        _GANSS_NavModel_NAVKeplerianSet_navFitFlag,
        _GANSS_NavModel_NAVKeplerianSet_navToe,
        _GANSS_NavModel_NAVKeplerianSet_navOmega,
        _GANSS_NavModel_NAVKeplerianSet_navDeltaN,
        _GANSS_NavModel_NAVKeplerianSet_navM0,
        _GANSS_NavModel_NAVKeplerianSet_navOmegaADot,
        _GANSS_NavModel_NAVKeplerianSet_navE,
        _GANSS_NavModel_NAVKeplerianSet_navIDot,
        _GANSS_NavModel_NAVKeplerianSet_navAPowerHalf,
        _GANSS_NavModel_NAVKeplerianSet_navI0,
        _GANSS_NavModel_NAVKeplerianSet_navOmegaA0,
        _GANSS_NavModel_NAVKeplerianSet_navCrs,
        _GANSS_NavModel_NAVKeplerianSet_navCis,
        _GANSS_NavModel_NAVKeplerianSet_navCus,
        _GANSS_NavModel_NAVKeplerianSet_navCrc,
        _GANSS_NavModel_NAVKeplerianSet_navCic,
        _GANSS_NavModel_NAVKeplerianSet_navCuc,
        ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab,
        ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id,
        ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab,
        ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality,
        ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue,
        __GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item_,
        _GANSS_NavModel_NAVKeplerianSet_ie_Extensions,
        GANSS_NavModel_NAVKeplerianSet,
        GANSS_NavModel_NAVKeplerianSet_ExtIEs,
        _GANSS_NavModel_SBASecef_sbasTo,
        _GANSS_NavModel_SBASecef_sbasAccuracy,
        _GANSS_NavModel_SBASecef_sbasXg,
        _GANSS_NavModel_SBASecef_sbasYg,
        _GANSS_NavModel_SBASecef_sbasZg,
        _GANSS_NavModel_SBASecef_sbasXgDot,
        _GANSS_NavModel_SBASecef_sbasYgDot,
        _GANSS_NavModel_SBASecef_sbasZgDot,
        _GANSS_NavModel_SBASecef_sbasXgDotDot,
        _GANSS_NavModel_SBASecef_sbagYgDotDot,
        _GANSS_NavModel_SBASecef_sbasZgDotDot,
        ____GANSS_NavModel_SBASecef_ie_Extensions__item__id_tab,
        ___GANSS_NavModel_SBASecef_ie_Extensions__item__id,
        ____GANSS_NavModel_SBASecef_ie_Extensions__item__criticality_tab,
        ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality,
        ____GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue_tab,
        ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue,
        __GANSS_NavModel_SBASecef_ie_Extensions__item_,
        _GANSS_NavModel_SBASecef_ie_Extensions,
        GANSS_NavModel_SBASecef,
        GANSS_NavModel_SBASecef_ExtIEs,
        _GANSS_Orbit_Model_gANSS_keplerianParameters,
        GANSS_Orbit_Model,
        _GANSS_Real_Time_Integrity__item_,
        GANSS_Real_Time_Integrity,
        _GANSS_RealTimeInformationItem_bad_ganss_satId,
        _GANSS_RealTimeInformationItem_bad_ganss_signalId,
        ____GANSS_RealTimeInformationItem_ie_Extensions__item__id_tab,
        ___GANSS_RealTimeInformationItem_ie_Extensions__item__id,
        ____GANSS_RealTimeInformationItem_ie_Extensions__item__criticality_tab,
        ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality,
        ____GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue,
        __GANSS_RealTimeInformationItem_ie_Extensions__item_,
        _GANSS_RealTimeInformationItem_ie_Extensions,
        GANSS_RealTimeInformationItem,
        GANSS_RealTimeInformationItem_ExtIEs,
        _GANSS_RX_Pos_latitudeSign,
        _GANSS_RX_Pos_degreesOfLatitude,
        _GANSS_RX_Pos_degreesOfLongitude,
        _GANSS_RX_Pos_directionOfAltitude,
        _GANSS_RX_Pos_altitude,
        ____GANSS_RX_Pos_ie_Extensions__item__id_tab,
        ___GANSS_RX_Pos_ie_Extensions__item__id,
        ____GANSS_RX_Pos_ie_Extensions__item__criticality_tab,
        ___GANSS_RX_Pos_ie_Extensions__item__criticality,
        ____GANSS_RX_Pos_ie_Extensions__item__extensionValue_tab,
        ___GANSS_RX_Pos_ie_Extensions__item__extensionValue,
        __GANSS_RX_Pos_ie_Extensions__item_,
        _GANSS_RX_Pos_ie_Extensions,
        GANSS_RX_Pos,
        GANSS_RX_Pos_ExtIEs,
        _GANSS_SatelliteClockModelItem_t_oc,
        _GANSS_SatelliteClockModelItem_a_i2,
        _GANSS_SatelliteClockModelItem_a_i1,
        _GANSS_SatelliteClockModelItem_a_i0,
        _GANSS_SatelliteClockModelItem_t_gd,
        _GANSS_SatelliteClockModelItem_sisa,
        _GANSS_SatelliteClockModelItem_model_id,
        ____GANSS_SatelliteClockModelItem_ie_Extensions__item__id_tab,
        ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id,
        ____GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality_tab,
        ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality,
        ____GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue,
        __GANSS_SatelliteClockModelItem_ie_Extensions__item_,
        _GANSS_SatelliteClockModelItem_ie_Extensions,
        GANSS_SatelliteClockModelItem,
        GANSS_SatelliteClockModelItem_ExtIEs,
        _GANSS_SatelliteInformationKP__item_,
        GANSS_SatelliteInformationKP,
        _GANSS_SatelliteInformationKPItem_satId,
        _GANSS_SatelliteInformationKPItem_ganss_e_alm,
        _GANSS_SatelliteInformationKPItem_ganss_delta_I_alm,
        _GANSS_SatelliteInformationKPItem_ganss_omegadot_alm,
        _GANSS_SatelliteInformationKPItem_ganss_svStatusINAV_alm,
        _GANSS_SatelliteInformationKPItem_ganss_svStatusFNAV_alm,
        _GANSS_SatelliteInformationKPItem_ganss_delta_a_sqrt_alm,
        _GANSS_SatelliteInformationKPItem_ganss_omegazero_alm,
        _GANSS_SatelliteInformationKPItem_ganss_m_zero_alm,
        _GANSS_SatelliteInformationKPItem_ganss_omega_alm,
        _GANSS_SatelliteInformationKPItem_ganss_af_zero_alm,
        _GANSS_SatelliteInformationKPItem_ganss_af_one_alm,
        ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__id_tab,
        ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id,
        ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality_tab,
        ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality,
        ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue,
        __GANSS_SatelliteInformationKPItem_ie_Extensions__item_,
        _GANSS_SatelliteInformationKPItem_ie_Extensions,
        GANSS_SatelliteInformationKPItem,
        GANSS_SatelliteInformationKPItem_ExtIEs,
        __Ganss_Sat_Info_AddNavList__item__satId,
        __Ganss_Sat_Info_AddNavList__item__svHealth,
        __Ganss_Sat_Info_AddNavList__item__iod,
        __Ganss_Sat_Info_AddNavList__item__ganssAddClockModels,
        __Ganss_Sat_Info_AddNavList__item__ganssAddOrbitModels,
        _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab,
        ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id,
        _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab,
        ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality,
        _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab,
        ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue,
        ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_,
        __Ganss_Sat_Info_AddNavList__item__ie_Extensions,
        _Ganss_Sat_Info_AddNavList__item_,
        Ganss_Sat_Info_AddNavList,
        Ganss_Sat_Info_AddNavList_ExtIEs,
        _GANSS_SAT_Info_Almanac_BDSkpList__item_,
        GANSS_SAT_Info_Almanac_BDSkpList,
        _GANSS_SAT_Info_Almanac_BDS_satId,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmToa,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmSqrtA,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmE,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmW,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmM0,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmega0,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmegaDot,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmDeltaI,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmA0,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmA1,
        _GANSS_SAT_Info_Almanac_BDS_bdsSvHealth,
        ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_BDS_ie_Extensions__item_,
        _GANSS_SAT_Info_Almanac_BDS_ie_Extensions,
        GANSS_SAT_Info_Almanac_BDS,
        GANSS_SAT_Info_Almanac_BDS_ExtIEs,
        _GANSS_SAT_Info_Almanac_GLOkpList__item_,
        GANSS_SAT_Info_Almanac_GLOkpList,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmNA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmnA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmHA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmLambdaA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTlambdaA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaIA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAkmDeltaTA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaTdotA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmEpsilonA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmOmegaA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTauA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmCA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmMA,
        ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item_,
        _GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions,
        GANSS_SAT_Info_Almanac_GLOkp,
        GANSS_SAT_Info_Almanac_GLOkp_ExtIEs,
        _GANSS_SAT_Info_Almanac_MIDIkpList__item_,
        GANSS_SAT_Info_Almanac_MIDIkpList,
        _GANSS_SAT_Info_Almanac_MIDIkp_svID,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmE,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmDeltaI,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmegaDot,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmSqrtA,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega0,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmMo,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf0,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf1,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL1Health,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL2Health,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL5Health,
        ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item_,
        _GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions,
        GANSS_SAT_Info_Almanac_MIDIkp,
        GANSS_SAT_Info_Almanac_MIDIkp_ExtIEs,
        _GANSS_SAT_Info_Almanac_NAVkpList__item_,
        GANSS_SAT_Info_Almanac_NAVkpList,
        _GANSS_SAT_Info_Almanac_NAVkp_svID,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmE,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmDeltaI,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGADOT,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmSVHealth,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmSqrtA,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGAo,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmOmega,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmMo,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf0,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf1,
        ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item_,
        _GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions,
        GANSS_SAT_Info_Almanac_NAVkp,
        GANSS_SAT_Info_Almanac_NAVkp_ExtIEs,
        _GANSS_SAT_Info_Almanac_REDkpList__item_,
        GANSS_SAT_Info_Almanac_REDkpList,
        _GANSS_SAT_Info_Almanac_REDkp_svID,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmDeltaA,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmOmega0,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmPhi0,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmL1Health,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmL2Health,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmL5Health,
        ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item_,
        _GANSS_SAT_Info_Almanac_REDkp_ie_Extensions,
        GANSS_SAT_Info_Almanac_REDkp,
        GANSS_SAT_Info_Almanac_REDkp_ExtIEs,
        _GANSS_SAT_Info_Almanac_SBASecefList__item_,
        GANSS_SAT_Info_Almanac_SBASecefList,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmDataID,
        _GANSS_SAT_Info_Almanac_SBASecef_svID,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmHealth,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXg,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYg,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZg,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXgdot,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYgDot,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZgDot,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmTo,
        ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item_,
        _GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions,
        GANSS_SAT_Info_Almanac_SBASecef,
        GANSS_SAT_Info_Almanac_SBASecef_ExtIEs,
        __GANSS_Sat_Info_Nav__item__satId,
        __GANSS_Sat_Info_Nav__item__svHealth,
        __GANSS_Sat_Info_Nav__item__iod,
        __GANSS_Sat_Info_Nav__item__ganssClockModel,
        __GANSS_Sat_Info_Nav__item__ganssOrbitModel,
        _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab,
        ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id,
        _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab,
        ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality,
        _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue,
        ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_,
        __GANSS_Sat_Info_Nav__item__ie_Extensions,
        _GANSS_Sat_Info_Nav__item_,
        GANSS_Sat_Info_Nav,
        GANSS_Sat_Info_Nav_ExtIEs,
        GANSS_SBAS_ID,
        _GANSS_SBASclockModel_sbasTo,
        _GANSS_SBASclockModel_sbasAgfo,
        _GANSS_SBASclockModel_sbasAgf1,
        ____GANSS_SBASclockModel_ie_Extensions__item__id_tab,
        ___GANSS_SBASclockModel_ie_Extensions__item__id,
        ____GANSS_SBASclockModel_ie_Extensions__item__criticality_tab,
        ___GANSS_SBASclockModel_ie_Extensions__item__criticality,
        ____GANSS_SBASclockModel_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue,
        __GANSS_SBASclockModel_ie_Extensions__item_,
        _GANSS_SBASclockModel_ie_Extensions,
        GANSS_SBASclockModel,
        GANSS_SBASclockModel_ExtIEs,
        GANSS_Signal_ID,
        GANSS_StatusHealth,
        GANSS_Time_ID,
        _GANSS_Time_Model_ganss_time_model_Ref_Time,
        _GANSS_Time_Model_ganss_t_a0,
        _GANSS_Time_Model_ganss_t_a1,
        _GANSS_Time_Model_ganss_t_a2,
        _GANSS_Time_Model_gnss_to_id,
        _GANSS_Time_Model_ganss_wk_number,
        ____GANSS_Time_Model_ie_Extensions__item__id_tab,
        _____GANSS_Time_Model_ie_Extensions__item__id_tab_val_Extension_0,
        ___GANSS_Time_Model_ie_Extensions__item__id,
        ___GANSS_Time_Model_ie_Extensions__item__criticality,
        ___GANSS_Time_Model_ie_Extensions__item__extensionValue,
        __GANSS_Time_Model_ie_Extensions__item_,
        _GANSS_Time_Model_ie_Extensions,
        GANSS_Time_Model,
        GANSS_Time_Model_ExtIEs,
        _GANSS_Time_Model_ExtIEs_val_Extension_0,
        _GANSS_Transmission_Time_ganssDay,
        _GANSS_Transmission_Time_ganssTod,
        ____GANSS_Transmission_Time_ie_Extensions__item__id_tab,
        ___GANSS_Transmission_Time_ie_Extensions__item__id,
        ____GANSS_Transmission_Time_ie_Extensions__item__criticality_tab,
        ___GANSS_Transmission_Time_ie_Extensions__item__criticality,
        ____GANSS_Transmission_Time_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue,
        __GANSS_Transmission_Time_ie_Extensions__item_,
        _GANSS_Transmission_Time_ie_Extensions,
        GANSS_Transmission_Time,
        GANSS_Transmission_Time_ExtIEs,
        _GANSS_UTC_Model_a_one_utc,
        _GANSS_UTC_Model_a_zero_utc,
        _GANSS_UTC_Model_t_ot_utc,
        _GANSS_UTC_Model_w_n_t_utc,
        _GANSS_UTC_Model_delta_t_ls_utc,
        _GANSS_UTC_Model_w_n_lsf_utc,
        _GANSS_UTC_Model_dn_utc,
        _GANSS_UTC_Model_delta_t_lsf_utc,
        ____GANSS_UTC_Model_ie_Extensions__item__id_tab,
        ___GANSS_UTC_Model_ie_Extensions__item__id,
        ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab,
        ___GANSS_UTC_Model_ie_Extensions__item__criticality,
        ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab,
        ___GANSS_UTC_Model_ie_Extensions__item__extensionValue,
        __GANSS_UTC_Model_ie_Extensions__item_,
        _GANSS_UTC_Model_ie_Extensions,
        GANSS_UTC_Model,
        GANSS_UTC_Model_ExtIEs,
        _GANSS_UTCmodelSet1_utcA0,
        _GANSS_UTCmodelSet1_utcA1,
        _GANSS_UTCmodelSet1_utcA2,
        _GANSS_UTCmodelSet1_utcDeltaTls,
        _GANSS_UTCmodelSet1_utcTot,
        _GANSS_UTCmodelSet1_utcWNot,
        _GANSS_UTCmodelSet1_utcWNlsf,
        _GANSS_UTCmodelSet1_utcDN,
        _GANSS_UTCmodelSet1_utcDeltaTlsf,
        ____GANSS_UTCmodelSet1_ie_Extensions__item__id_tab,
        ___GANSS_UTCmodelSet1_ie_Extensions__item__id,
        ____GANSS_UTCmodelSet1_ie_Extensions__item__criticality_tab,
        ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality,
        ____GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue_tab,
        ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue,
        __GANSS_UTCmodelSet1_ie_Extensions__item_,
        _GANSS_UTCmodelSet1_ie_Extensions,
        GANSS_UTCmodelSet1,
        GANSS_UTCmodelSet1_ExtIEs,
        _GANSS_UTCmodelSet2_nA,
        _GANSS_UTCmodelSet2_tauC,
        _GANSS_UTCmodelSet2_deltaUT1,
        _GANSS_UTCmodelSet2_kp,
        ____GANSS_UTCmodelSet2_ie_Extensions__item__id_tab,
        ___GANSS_UTCmodelSet2_ie_Extensions__item__id,
        ____GANSS_UTCmodelSet2_ie_Extensions__item__criticality_tab,
        ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality,
        ____GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue_tab,
        ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue,
        __GANSS_UTCmodelSet2_ie_Extensions__item_,
        _GANSS_UTCmodelSet2_ie_Extensions,
        GANSS_UTCmodelSet2,
        GANSS_UTCmodelSet2_ExtIEs,
        _GANSS_UTCmodelSet3_utcA1wnt,
        _GANSS_UTCmodelSet3_utcA0wnt,
        _GANSS_UTCmodelSet3_utcTot,
        _GANSS_UTCmodelSet3_utcWNt,
        _GANSS_UTCmodelSet3_utcDeltaTls,
        _GANSS_UTCmodelSet3_utcWNlsf,
        _GANSS_UTCmodelSet3_utcDN,
        _GANSS_UTCmodelSet3_utcDeltaTlsf,
        _GANSS_UTCmodelSet3_utcStandardID,
        ____GANSS_UTCmodelSet3_ie_Extensions__item__id_tab,
        ___GANSS_UTCmodelSet3_ie_Extensions__item__id,
        ____GANSS_UTCmodelSet3_ie_Extensions__item__criticality_tab,
        ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality,
        ____GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue_tab,
        ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue,
        __GANSS_UTCmodelSet3_ie_Extensions__item_,
        _GANSS_UTCmodelSet3_ie_Extensions,
        GANSS_UTCmodelSet3,
        GANSS_UTCmodelSet3_ExtIEs,
        _GANSS_UTCmodelSet4_utcA0,
        _GANSS_UTCmodelSet4_utcA1,
        _GANSS_UTCmodelSet4_utcDeltaTls,
        _GANSS_UTCmodelSet4_utcWNlsf,
        _GANSS_UTCmodelSet4_utcDN,
        _GANSS_UTCmodelSet4_utcDeltaTlsf,
        ____GANSS_UTCmodelSet4_ie_Extensions__item__id_tab,
        ___GANSS_UTCmodelSet4_ie_Extensions__item__id,
        ____GANSS_UTCmodelSet4_ie_Extensions__item__criticality_tab,
        ___GANSS_UTCmodelSet4_ie_Extensions__item__criticality,
        ____GANSS_UTCmodelSet4_ie_Extensions__item__extensionValue_tab,
        ___GANSS_UTCmodelSet4_ie_Extensions__item__extensionValue,
        __GANSS_UTCmodelSet4_ie_Extensions__item_,
        _GANSS_UTCmodelSet4_ie_Extensions,
        GANSS_UTCmodelSet4,
        GANSS_UTCmodelSet4_ExtIEs,
        GapLength,
        GapDuration,
        GenericTrafficCategory,
        _GPS_Almanac_wna_alm,
        _GPS_Almanac_sat_info_almanac,
        _GPS_Almanac_sVGlobalHealth_alm,
        ____GPS_Almanac_ie_Extensions__item__id_tab,
        _____GPS_Almanac_ie_Extensions__item__id_tab_val_Extension_0,
        _____GPS_Almanac_ie_Extensions__item__id_tab_val_Extension_1,
        ___GPS_Almanac_ie_Extensions__item__id,
        ___GPS_Almanac_ie_Extensions__item__criticality,
        ___GPS_Almanac_ie_Extensions__item__extensionValue,
        __GPS_Almanac_ie_Extensions__item_,
        _GPS_Almanac_ie_Extensions,
        GPS_Almanac,
        GPS_Almanac_ExtIEs,
        _GPS_Almanac_ExtIEs_val_Extension_0,
        _GPS_Almanac_ExtIEs_val_Extension_1,
        _GPS_Ionospheric_Model_alpha_zero_ionos,
        _GPS_Ionospheric_Model_alpha_one_ionos,
        _GPS_Ionospheric_Model_alpha_two_ionos,
        _GPS_Ionospheric_Model_alpha_three_ionos,
        _GPS_Ionospheric_Model_beta_zero_ionos,
        _GPS_Ionospheric_Model_beta_one_ionos,
        _GPS_Ionospheric_Model_beta_two_ionos,
        _GPS_Ionospheric_Model_beta_three_ionos,
        ____GPS_Ionospheric_Model_ie_Extensions__item__id_tab,
        ___GPS_Ionospheric_Model_ie_Extensions__item__id,
        ____GPS_Ionospheric_Model_ie_Extensions__item__criticality_tab,
        ___GPS_Ionospheric_Model_ie_Extensions__item__criticality,
        ____GPS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab,
        ___GPS_Ionospheric_Model_ie_Extensions__item__extensionValue,
        __GPS_Ionospheric_Model_ie_Extensions__item_,
        _GPS_Ionospheric_Model_ie_Extensions,
        GPS_Ionospheric_Model,
        GPS_Ionospheric_Model_ExtIEs,
        _GPS_Information__item_,
        GPS_Information,
        GPS_Information_Item,
        _GPS_RealTime_Integrity_bad_satellites,
        _GPS_RealTime_Integrity_no_bad_satellites,
        GPS_RealTime_Integrity,
        _GPSBadSat_Info_RealTime_Integrity_sat_info,
        ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__id_tab,
        ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__id,
        ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__criticality_tab,
        ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__criticality,
        ____GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__extensionValue_tab,
        ___GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item__extensionValue,
        __GPSBadSat_Info_RealTime_Integrity_ie_Extensions__item_,
        _GPSBadSat_Info_RealTime_Integrity_ie_Extensions,
        GPSBadSat_Info_RealTime_Integrity,
        GPSBadSat_Info_RealTime_Integrity_ExtIEs,
        _GPS_NavigationModel_and_TimeRecovery__item_,
        GPS_NavigationModel_and_TimeRecovery,
        _GPS_NavandRecovery_Item_tx_tow_nav,
        _GPS_NavandRecovery_Item_sat_id_nav,
        _GPS_NavandRecovery_Item_tlm_message_nav,
        _GPS_NavandRecovery_Item_tlm_revd_c_nav,
        _GPS_NavandRecovery_Item_ho_word_nav,
        _GPS_NavandRecovery_Item_w_n_nav,
        _GPS_NavandRecovery_Item_ca_or_p_on_l2_nav,
        _GPS_NavandRecovery_Item_user_range_accuracy_index_nav,
        _GPS_NavandRecovery_Item_sv_health_nav,
        _GPS_NavandRecovery_Item_iodc_nav,
        _GPS_NavandRecovery_Item_l2_p_dataflag_nav,
        _GPS_NavandRecovery_Item_sf1_reserved_nav,
        _GPS_NavandRecovery_Item_t_gd_nav,
        _GPS_NavandRecovery_Item_t_oc_nav,
        _GPS_NavandRecovery_Item_a_f_2_nav,
        _GPS_NavandRecovery_Item_a_f_1_nav,
        _GPS_NavandRecovery_Item_a_f_zero_nav,
        _GPS_NavandRecovery_Item_c_rs_nav,
        _GPS_NavandRecovery_Item_delta_n_nav,
        _GPS_NavandRecovery_Item_m_zero_nav,
        _GPS_NavandRecovery_Item_c_uc_nav,
        _GPS_NavandRecovery_Item_gps_e_nav,
        _GPS_NavandRecovery_Item_c_us_nav,
        _GPS_NavandRecovery_Item_a_sqrt_nav,
        _GPS_NavandRecovery_Item_t_oe_nav,
        _GPS_NavandRecovery_Item_fit_interval_flag_nav,
        _GPS_NavandRecovery_Item_aodo_nav,
        _GPS_NavandRecovery_Item_c_ic_nav,
        _GPS_NavandRecovery_Item_omega_zero_nav,
        _GPS_NavandRecovery_Item_c_is_nav,
        _GPS_NavandRecovery_Item_i_zero_nav,
        _GPS_NavandRecovery_Item_c_rc_nav,
        _GPS_NavandRecovery_Item_gps_omega_nav,
        _GPS_NavandRecovery_Item_omegadot_nav,
        _GPS_NavandRecovery_Item_idot_nav,
        _GPS_NavandRecovery_Item_spare_zero_fill,
        ____GPS_NavandRecovery_Item_ie_Extensions__item__id_tab,
        ___GPS_NavandRecovery_Item_ie_Extensions__item__id,
        ____GPS_NavandRecovery_Item_ie_Extensions__item__criticality_tab,
        ___GPS_NavandRecovery_Item_ie_Extensions__item__criticality,
        ____GPS_NavandRecovery_Item_ie_Extensions__item__extensionValue_tab,
        ___GPS_NavandRecovery_Item_ie_Extensions__item__extensionValue,
        __GPS_NavandRecovery_Item_ie_Extensions__item_,
        _GPS_NavandRecovery_Item_ie_Extensions,
        GPS_NavandRecovery_Item,
        GPS_NavandRecovery_Item_ExtIEs,
        _GPS_RX_POS_latitudeSign,
        _GPS_RX_POS_latitude,
        _GPS_RX_POS_longitude,
        _GPS_RX_POS_directionOfAltitude,
        _GPS_RX_POS_altitude,
        ____GPS_RX_POS_iE_Extensions__item__id_tab,
        ___GPS_RX_POS_iE_Extensions__item__id,
        ____GPS_RX_POS_iE_Extensions__item__criticality_tab,
        ___GPS_RX_POS_iE_Extensions__item__criticality,
        ____GPS_RX_POS_iE_Extensions__item__extensionValue_tab,
        ___GPS_RX_POS_iE_Extensions__item__extensionValue,
        __GPS_RX_POS_iE_Extensions__item_,
        _GPS_RX_POS_iE_Extensions,
        GPS_RX_POS,
        GPS_RX_POS_ExtIEs,
        GPS_Status_Health,
        GPSTOW,
        _GPS_UTC_Model_a_one_utc,
        _GPS_UTC_Model_a_zero_utc,
        _GPS_UTC_Model_t_ot_utc,
        _GPS_UTC_Model_delta_t_ls_utc,
        _GPS_UTC_Model_w_n_t_utc,
        _GPS_UTC_Model_w_n_lsf_utc,
        _GPS_UTC_Model_dn_utc,
        _GPS_UTC_Model_delta_t_lsf_utc,
        ____GPS_UTC_Model_ie_Extensions__item__id_tab,
        ___GPS_UTC_Model_ie_Extensions__item__id,
        ____GPS_UTC_Model_ie_Extensions__item__criticality_tab,
        ___GPS_UTC_Model_ie_Extensions__item__criticality,
        ____GPS_UTC_Model_ie_Extensions__item__extensionValue_tab,
        ___GPS_UTC_Model_ie_Extensions__item__extensionValue,
        __GPS_UTC_Model_ie_Extensions__item_,
        _GPS_UTC_Model_ie_Extensions,
        GPS_UTC_Model,
        GPS_UTC_Model_ExtIEs,
        HARQ_Info_for_E_DCH,
        _HARQ_MemoryPartitioning_implicit,
        _HARQ_MemoryPartitioning_explicit,
        HARQ_MemoryPartitioning,
        _HARQ_MemoryPartitioning_Implicit_number_of_Processes,
        ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id_tab,
        ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id,
        ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality_tab,
        ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality,
        ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue_tab,
        ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue,
        __HARQ_MemoryPartitioning_Implicit_iE_Extensions__item_,
        _HARQ_MemoryPartitioning_Implicit_iE_Extensions,
        HARQ_MemoryPartitioning_Implicit,
        HARQ_MemoryPartitioning_Implicit_ExtIEs,
        _HARQ_MemoryPartitioning_Explicit_hARQ_MemoryPartitioningList,
        ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab,
        _____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab_val_Extension_0,
        ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id,
        ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality,
        ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue,
        __HARQ_MemoryPartitioning_Explicit_iE_Extensions__item_,
        _HARQ_MemoryPartitioning_Explicit_iE_Extensions,
        HARQ_MemoryPartitioning_Explicit,
        HARQ_MemoryPartitioning_Explicit_ExtIEs,
        _HARQ_MemoryPartitioning_Explicit_ExtIEs_val_Extension_0,
        _HARQ_MemoryPartitioningList__item_,
        HARQ_MemoryPartitioningList,
        _HARQ_MemoryPartitioningInfoExtForMIMO__item_,
        HARQ_MemoryPartitioningInfoExtForMIMO,
        _HARQ_MemoryPartitioningItem_process_Memory_Size,
        ____HARQ_MemoryPartitioningItem_iE_Extensions__item__id_tab,
        ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id,
        ____HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality_tab,
        ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality,
        ____HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue_tab,
        ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue,
        __HARQ_MemoryPartitioningItem_iE_Extensions__item_,
        _HARQ_MemoryPartitioningItem_iE_Extensions,
        HARQ_MemoryPartitioningItem,
        HARQ_MemoryPartitioningItem_ExtIEs,
        HARQ_Preamble_Mode,
        HARQ_Process_Allocation_2ms_EDCH,
        HARQ_Preamble_Mode_Activation_Indicator,
        HSDPA_Capability,
        _HS_DSCHProvidedBitRate__item_,
        HS_DSCHProvidedBitRate,
        _HS_DSCHProvidedBitRate_Item_schedulingPriorityIndicator,
        _HS_DSCHProvidedBitRate_Item_hS_DSCHProvidedBitRateValue,
        ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__id_tab,
        ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__id,
        ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__criticality_tab,
        ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__criticality,
        ____HS_DSCHProvidedBitRate_Item_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCHProvidedBitRate_Item_iE_Extensions__item__extensionValue,
        __HS_DSCHProvidedBitRate_Item_iE_Extensions__item_,
        _HS_DSCHProvidedBitRate_Item_iE_Extensions,
        HS_DSCHProvidedBitRate_Item,
        HS_DSCHProvidedBitRate_Item_ExtIEs,
        HS_DSCHProvidedBitRateValue,
        _HS_DSCHProvidedBitRateValueInformation_For_CellPortion__item_,
        HS_DSCHProvidedBitRateValueInformation_For_CellPortion,
        _HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_cellPortionID,
        _HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_hS_DSCHProvidedBitRateValue,
        ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab,
        ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__id,
        ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab,
        ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality,
        ____HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue,
        __HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions__item_,
        _HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_iE_Extensions,
        HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item,
        HS_DSCHProvidedBitRateValueInformation_For_CellPortion_Item_ExtIEs,
        _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR__item_,
        HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR,
        _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_cellPortionLCRID,
        _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_hS_DSCHProvidedBitRateValue,
        ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id_tab,
        ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id,
        ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality_tab,
        ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality,
        ____HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue,
        __HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions__item_,
        _HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_iE_Extensions,
        HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item,
        HS_DSCHProvidedBitRateValueInformation_For_CellPortionLCR_Item_ExtIEs,
        _HS_DSCHRequiredPower__item_,
        HS_DSCHRequiredPower,
        _HS_DSCHRequiredPower_Item_schedulingPriorityIndicator,
        _HS_DSCHRequiredPower_Item_hS_DSCHRequiredPowerValue,
        _HS_DSCHRequiredPower_Item_hS_DSCHRequiredPowerPerUEInformation,
        ____HS_DSCHRequiredPower_Item_iE_Extensions__item__id_tab,
        ___HS_DSCHRequiredPower_Item_iE_Extensions__item__id,
        ____HS_DSCHRequiredPower_Item_iE_Extensions__item__criticality_tab,
        ___HS_DSCHRequiredPower_Item_iE_Extensions__item__criticality,
        ____HS_DSCHRequiredPower_Item_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCHRequiredPower_Item_iE_Extensions__item__extensionValue,
        __HS_DSCHRequiredPower_Item_iE_Extensions__item_,
        _HS_DSCHRequiredPower_Item_iE_Extensions,
        HS_DSCHRequiredPower_Item,
        HS_DSCHRequiredPower_Item_ExtIEs,
        HS_DSCHRequiredPowerValue,
        _HS_DSCHRequiredPowerPerUEInformation__item_,
        HS_DSCHRequiredPowerPerUEInformation,
        _HS_DSCHRequiredPowerPerUEInformation_Item_cRNC_CommunicationContextID,
        _HS_DSCHRequiredPowerPerUEInformation_Item_hS_DSCHRequiredPowerPerUEWeight,
        ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__id_tab,
        ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__id,
        ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__criticality_tab,
        ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__criticality,
        ____HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item__extensionValue,
        __HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions__item_,
        _HS_DSCHRequiredPowerPerUEInformation_Item_iE_Extensions,
        HS_DSCHRequiredPowerPerUEInformation_Item,
        HS_DSCHRequiredPowerPerUEInformation_Item_ExtIEs,
        HS_DSCHRequiredPowerPerUEWeight,
        _HS_DSCHRequiredPowerValueInformation_For_CellPortion__item_,
        HS_DSCHRequiredPowerValueInformation_For_CellPortion,
        _HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_cellPortionID,
        _HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_hS_DSCHRequiredPowerValue,
        ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__id_tab,
        ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__id,
        ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality_tab,
        ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__criticality,
        ____HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item__extensionValue,
        __HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions__item_,
        _HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_iE_Extensions,
        HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item,
        HS_DSCHRequiredPowerValueInformation_For_CellPortion_Item_ExtIEs,
        _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR__item_,
        HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR,
        _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_cellPortionLCRID,
        _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_hS_DSCHRequiredPowerValue,
        ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id_tab,
        ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__id,
        ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality_tab,
        ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__criticality,
        ____HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item__extensionValue,
        __HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions__item_,
        _HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_iE_Extensions,
        HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item,
        HS_DSCHRequiredPowerValueInformation_For_CellPortionLCR_Item_ExtIEs,
        _HSDPA_Associated_PICH_Information_hsdpa_PICH_Shared_with_PCH,
        _HSDPA_Associated_PICH_Information_hsdpa_PICH_notShared_with_PCH,
        HSDPA_Associated_PICH_Information,
        _HSDPA_PICH_Shared_with_PCH_hsdpa_PICH_SharedPCH_ID,
        HSDPA_PICH_Shared_with_PCH,
        _HSDPA_PICH_notShared_with_PCH_hSDPA_PICH_notShared_ID,
        _HSDPA_PICH_notShared_with_PCH_fdd_DL_Channelisation_CodeNumber,
        _HSDPA_PICH_notShared_with_PCH_pich_Power,
        _HSDPA_PICH_notShared_with_PCH_pich_Mode,
        _HSDPA_PICH_notShared_with_PCH_sttd_Indicator,
        HSDPA_PICH_notShared_with_PCH,
        _HSDSCH_Common_System_InformationFDD_hsdsch_Common_Information,
        _HSDSCH_Common_System_InformationFDD_commonMACFlow_Specific_Information,
        ____HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id_tab,
        _____HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__id,
        ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__criticality,
        ___HSDSCH_Common_System_InformationFDD_iE_Extensions__item__extensionValue,
        __HSDSCH_Common_System_InformationFDD_iE_Extensions__item_,
        _HSDSCH_Common_System_InformationFDD_iE_Extensions,
        HSDSCH_Common_System_InformationFDD,
        HSDSCH_Common_System_InformationFDD_ExtIEs,
        _HSDSCH_Common_System_InformationFDD_ExtIEs_val_Extension_0,
        _HSDSCH_Common_System_Information_ResponseFDD_hsSCCH_Specific_Information_ResponseFDD,
        _HSDSCH_Common_System_Information_ResponseFDD_hARQ_MemoryPartitioning,
        _HSDSCH_Common_System_Information_ResponseFDD_commonMACFlow_Specific_Info_Response,
        ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__id_tab,
        ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__id,
        ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__criticality_tab,
        ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__criticality,
        ____HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item__extensionValue,
        __HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions__item_,
        _HSDSCH_Common_System_Information_ResponseFDD_iE_Extensions,
        HSDSCH_Common_System_Information_ResponseFDD,
        HSDSCH_Common_System_Information_ResponseFDD_ExtIEs,
        _HSDSCH_Common_Information_cCCH_PriorityQueue_Id,
        _HSDSCH_Common_Information_sRB1_PriorityQueue_Id,
        _HSDSCH_Common_Information_associatedCommon_MACFlow,
        _HSDSCH_Common_Information_fACH_Measurement_Occasion_Cycle_Length_Coefficient,
        _HSDSCH_Common_Information_rACH_Measurement_Result,
        _HSDSCH_Common_Information_bCCH_Specific_HSDSCH_RNTI_Information,
        ____HSDSCH_Common_Information_iE_Extensions__item__id_tab,
        ___HSDSCH_Common_Information_iE_Extensions__item__id,
        ____HSDSCH_Common_Information_iE_Extensions__item__criticality_tab,
        ___HSDSCH_Common_Information_iE_Extensions__item__criticality,
        ____HSDSCH_Common_Information_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_Common_Information_iE_Extensions__item__extensionValue,
        __HSDSCH_Common_Information_iE_Extensions__item_,
        _HSDSCH_Common_Information_iE_Extensions,
        HSDSCH_Common_Information,
        HSDSCH_Common_Information_ExtIEs,
        _HSDSCH_FDD_Information_hSDSCH_MACdFlows_Information,
        _HSDSCH_FDD_Information_ueCapability_Info,
        _HSDSCH_FDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM,
        _HSDSCH_FDD_Information_cqiFeedback_CycleK,
        _HSDSCH_FDD_Information_cqiRepetitionFactor,
        _HSDSCH_FDD_Information_ackNackRepetitionFactor,
        _HSDSCH_FDD_Information_cqiPowerOffset,
        _HSDSCH_FDD_Information_ackPowerOffset,
        _HSDSCH_FDD_Information_nackPowerOffset,
        _HSDSCH_FDD_Information_hsscch_PowerOffset,
        _HSDSCH_FDD_Information_measurement_Power_Offset,
        ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_6,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_7,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_8,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_9,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_10,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_11,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_12,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_13,
        ___HSDSCH_FDD_Information_iE_Extensions__item__id,
        ___HSDSCH_FDD_Information_iE_Extensions__item__criticality,
        ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue,
        __HSDSCH_FDD_Information_iE_Extensions__item_,
        _HSDSCH_FDD_Information_iE_Extensions,
        HSDSCH_FDD_Information,
        HSDSCH_FDD_Information_ExtIEs,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_0,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_1,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_2,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_3,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_4,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_5,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_6,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_7,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_8,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_9,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_10,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_11,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_12,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_13,
        _HSDSCH_TDD_Information_hSDSCH_MACdFlows_Information,
        _HSDSCH_TDD_Information_ueCapability_Info,
        _HSDSCH_TDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM,
        _HSDSCH_TDD_Information_tDD_AckNack_Power_Offset,
        ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab,
        _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_4,
        ___HSDSCH_TDD_Information_iE_Extensions__item__id,
        ___HSDSCH_TDD_Information_iE_Extensions__item__criticality,
        ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue,
        __HSDSCH_TDD_Information_iE_Extensions__item_,
        _HSDSCH_TDD_Information_iE_Extensions,
        HSDSCH_TDD_Information,
        HSDSCH_TDD_Information_ExtIEs,
        _HSDSCH_TDD_Information_ExtIEs_val_Extension_0,
        _HSDSCH_TDD_Information_ExtIEs_val_Extension_1,
        _HSDSCH_TDD_Information_ExtIEs_val_Extension_2,
        _HSDSCH_TDD_Information_ExtIEs_val_Extension_3,
        _HSDSCH_TDD_Information_ExtIEs_val_Extension_4,
        _HSDSCH_Information_to_Modify_hsDSCH_MACdFlow_Specific_Info_to_Modify,
        _HSDSCH_Information_to_Modify_priorityQueueInfotoModify,
        _HSDSCH_Information_to_Modify_mAChs_Reordering_Buffer_Size_for_RLC_UM,
        _HSDSCH_Information_to_Modify_cqiFeedback_CycleK,
        _HSDSCH_Information_to_Modify_cqiRepetitionFactor,
        _HSDSCH_Information_to_Modify_ackNackRepetitionFactor,
        _HSDSCH_Information_to_Modify_cqiPowerOffset,
        _HSDSCH_Information_to_Modify_ackPowerOffset,
        _HSDSCH_Information_to_Modify_nackPowerOffset,
        _HSDSCH_Information_to_Modify_hsscch_PowerOffset,
        _HSDSCH_Information_to_Modify_measurement_Power_Offset,
        _HSDSCH_Information_to_Modify_hSSCCHCodeChangeGrant,
        _HSDSCH_Information_to_Modify_tDDAckNackPowerOffset,
        ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_5,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_6,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_7,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_8,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_9,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_10,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_11,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_12,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_13,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_14,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_15,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_16,
        ___HSDSCH_Information_to_Modify_iE_Extensions__item__id,
        ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality,
        ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue,
        __HSDSCH_Information_to_Modify_iE_Extensions__item_,
        _HSDSCH_Information_to_Modify_iE_Extensions,
        HSDSCH_Information_to_Modify,
        HSDSCH_Information_to_Modify_ExtIEs,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_0,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_1,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_2,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_3,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_4,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_5,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_6,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_7,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_8,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_9,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_10,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_11,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_12,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_13,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_14,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_15,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_16,
        _HSDSCH_MACdFlow_Specific_InfoList_to_Modify__item_,
        HSDSCH_MACdFlow_Specific_InfoList_to_Modify,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_hsDSCH_MACdFlow_ID,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_allocationRetentionPriority,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportBearerRequestIndicator,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_bindingID,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportLayerAddress,
        ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab,
        _____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id,
        ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality,
        ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue,
        __HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions,
        HSDSCH_MACdFlow_Specific_InfoItem_to_Modify,
        HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs_val_Extension_0,
        HSDSCH_MACdPDUSizeFormat,
        HSDSCH_MACdPDU_SizeCapability,
        _HSDSCH_Information_to_Modify_Unsynchronised_hsDSCH_MACdFlow_Specific_Info_to_Modify,
        _HSDSCH_Information_to_Modify_Unsynchronised_priorityQueueInfotoModifyUnsynchronised,
        _HSDSCH_Information_to_Modify_Unsynchronised_cqiPowerOffset,
        _HSDSCH_Information_to_Modify_Unsynchronised_ackPowerOffset,
        _HSDSCH_Information_to_Modify_Unsynchronised_nackPowerOffset,
        _HSDSCH_Information_to_Modify_Unsynchronised_hsscch_PowerOffset,
        _HSDSCH_Information_to_Modify_Unsynchronised_tDDAckNackPowerOffset,
        ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_6,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_7,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_8,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_9,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_10,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_11,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_12,
        ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id,
        ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality,
        ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue,
        __HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item_,
        _HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions,
        HSDSCH_Information_to_Modify_Unsynchronised,
        HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_0,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_1,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_2,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_3,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_4,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_5,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_6,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_7,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_8,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_9,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_10,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_11,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_12,
        _HSDSCH_FDD_Information_Response_hsDSCH_MACdFlow_Specific_InformationResp,
        _HSDSCH_FDD_Information_Response_hsSCCH_Specific_Information_ResponseFDD,
        _HSDSCH_FDD_Information_Response_hARQ_MemoryPartitioning,
        ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5,
        ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id,
        ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality,
        ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue,
        __HSDSCH_FDD_Information_Response_iE_Extensions__item_,
        _HSDSCH_FDD_Information_Response_iE_Extensions,
        HSDSCH_FDD_Information_Response,
        HSDSCH_FDD_Information_Response_ExtIEs,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_0,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_1,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_2,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_3,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_4,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_5,
        _HS_DSCH_FDD_Secondary_Serving_Information_hsscch_PowerOffset,
        _HS_DSCH_FDD_Secondary_Serving_Information_measurement_Power_Offset,
        _HS_DSCH_FDD_Secondary_Serving_Information_sixtyfourQAM_UsageAllowedIndicator,
        _HS_DSCH_FDD_Secondary_Serving_Information_hSDSCH_RNTI,
        ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_6,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_7,
        ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id,
        ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality,
        ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue,
        __HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item_,
        _HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions,
        HS_DSCH_FDD_Secondary_Serving_Information,
        HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_0,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_1,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_2,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_3,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_4,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_5,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_6,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_7,
        _HS_DSCH_FDD_Secondary_Serving_Information_Response_hsSCCH_Specific_Information_ResponseFDD,
        _HS_DSCH_FDD_Secondary_Serving_Information_Response_sixtyfourQAM_DL_UsageIndicator,
        _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSDSCH_TBSizeTableIndicator,
        ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab,
        _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_1,
        ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id,
        ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality,
        ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue,
        __HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item_,
        _HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions,
        HS_DSCH_FDD_Secondary_Serving_Information_Response,
        HS_DSCH_first_DRX_ycle_FACH,
        HS_DSCH_first_Rx_burst_FACH,
        HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs,
        _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_0,
        _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_1,
        HS_DSCH_Second_DRX_Cycle_FACH,
        HS_DSCH_second_Rx_burst_FACH,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_hsscch_PowerOffset,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_measurement_Power_Offset,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_hSSCCH_CodeChangeGrant,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_sixtyfourQAM_UsageAllowedIndicator,
        ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_1,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_2,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_3,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_4,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_5,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_6,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_7,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_8,
        ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id,
        ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality,
        ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue,
        __HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item_,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions,
        HS_DSCH_Secondary_Serving_Information_To_Modify,
        HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_0,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_1,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_2,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_3,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_4,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_5,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_6,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_7,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_8,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_hsscch_PowerOffset,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_sixtyfourQAM_UsageAllowedIndicator,
        ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5,
        ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id,
        ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality,
        ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue,
        __HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item_,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions,
        HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised,
        HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_0,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_1,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_2,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_3,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_4,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_5,
        _HS_DSCH_FDD_Secondary_Serving_Update_Information_hsSCCHCodeChangeIndicator,
        _HS_DSCH_FDD_Secondary_Serving_Update_Information_hS_PDSCH_Code_Change_Indicator,
        ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab,
        _____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id,
        ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality,
        ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue,
        __HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item_,
        _HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions,
        HS_DSCH_FDD_Secondary_Serving_Update_Information,
        HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs,
        _HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs_val_Extension_0,
        _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_hS_DSCH_Secondary_Serving_cell_choice,
        ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id_tab,
        ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id,
        ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality_tab,
        ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality,
        ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue,
        __HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item_,
        _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions,
        HS_DSCH_Secondary_Serving_Cell_Change_Information_Response,
        HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_ExtIEs,
        _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_successful,
        _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_unsuccessful,
        HS_DSCH_Secondary_Serving_cell_change_choice,
        _HS_Secondary_Serving_cell_change_successful_hS_DSCH_FDD_Secondary_Serving_Information_Response,
        ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id_tab,
        ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id,
        ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality_tab,
        ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality,
        ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue_tab,
        ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue,
        __HS_Secondary_Serving_cell_change_successful_iE_Extensions__item_,
        _HS_Secondary_Serving_cell_change_successful_iE_Extensions,
        HS_Secondary_Serving_cell_change_successful,
        HS_Secondary_Serving_cell_change_successful_ExtIEs,
        _HS_Secondary_Serving_cell_change_unsuccessful_cause,
        ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id_tab,
        ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id,
        ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab,
        ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality,
        ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab,
        ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue,
        __HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item_,
        _HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions,
        HS_Secondary_Serving_cell_change_unsuccessful,
        HS_Secondary_Serving_cell_change_unsuccessful_ExtIEs,
        HS_DSCH_Secondary_Serving_Remove,
        _HSDSCH_Paging_System_InformationFDD_paging_MACFlow_Specific_Information,
        _HSDSCH_Paging_System_InformationFDD_hSSCCH_Power,
        _HSDSCH_Paging_System_InformationFDD_hSPDSCH_Power,
        _HSDSCH_Paging_System_InformationFDD_number_of_PCCH_transmission,
        _HSDSCH_Paging_System_InformationFDD_transport_Block_Size_List,
        ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__id_tab,
        ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__id,
        ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__criticality_tab,
        ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__criticality,
        ____HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_Paging_System_InformationFDD_iE_Extensions__item__extensionValue,
        __HSDSCH_Paging_System_InformationFDD_iE_Extensions__item_,
        _HSDSCH_Paging_System_InformationFDD_iE_Extensions,
        HSDSCH_Paging_System_InformationFDD,
        HSDSCH_Paging_System_InformationFDD_ExtIEs,
        _HSDSCH_Paging_System_Information_ResponseFDD__item_,
        HSDSCH_Paging_System_Information_ResponseFDD,
        _HSDSCH_Paging_System_Information_ResponseList_pagingMACFlow_ID,
        _HSDSCH_Paging_System_Information_ResponseList_bindingID,
        _HSDSCH_Paging_System_Information_ResponseList_transportLayerAddress,
        _HSDSCH_Paging_System_Information_ResponseList_hSPDSCH_Code_Index,
        ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__id_tab,
        ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__id,
        ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__criticality_tab,
        ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__criticality,
        ____HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item__extensionValue,
        __HSDSCH_Paging_System_Information_ResponseList_iE_Extensions__item_,
        _HSDSCH_Paging_System_Information_ResponseList_iE_Extensions,
        HSDSCH_Paging_System_Information_ResponseList,
        HSDSCH_Paging_System_Information_ResponseList_ExtIEs,
        _HSDSCH_TDD_Information_Response_hsDSCH_MACdFlow_Specific_InformationResp,
        _HSDSCH_TDD_Information_Response_hsSCCH_Specific_Information_ResponseTDD,
        _HSDSCH_TDD_Information_Response_hsSCCH_Specific_Information_ResponseTDDLCR,
        _HSDSCH_TDD_Information_Response_hARQ_MemoryPartitioning,
        ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5,
        ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id,
        ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality,
        ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue,
        __HSDSCH_TDD_Information_Response_iE_Extensions__item_,
        _HSDSCH_TDD_Information_Response_iE_Extensions,
        HSDSCH_TDD_Information_Response,
        HSDSCH_TDD_Information_Response_ExtIEs,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_0,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_1,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_2,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_3,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_4,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_5,
        _HSDSCH_MACdFlow_Specific_InformationResp__item_,
        HSDSCH_MACdFlow_Specific_InformationResp,
        _HSDSCH_MACdFlow_Specific_InformationResp_Item_hsDSCHMacdFlow_Id,
        _HSDSCH_MACdFlow_Specific_InformationResp_Item_bindingID,
        _HSDSCH_MACdFlow_Specific_InformationResp_Item_transportLayerAddress,
        _HSDSCH_MACdFlow_Specific_InformationResp_Item_hSDSCH_Initial_Capacity_Allocation,
        ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab,
        ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id,
        ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab,
        ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality,
        ____HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue,
        __HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_,
        _HSDSCH_MACdFlow_Specific_InformationResp_Item_iE_Extensions,
        HSDSCH_MACdFlow_Specific_InformationResp_Item,
        HSDSCH_MACdFlow_Specific_InformationRespItem_ExtIEs,
        _HSDSCH_MACdFlows_Information_hSDSCH_MACdFlow_Specific_Info,
        _HSDSCH_MACdFlows_Information_priorityQueue_Info,
        ____HSDSCH_MACdFlows_Information_iE_Extensions__item__id_tab,
        ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id,
        ____HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality_tab,
        ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality,
        ____HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue,
        __HSDSCH_MACdFlows_Information_iE_Extensions__item_,
        _HSDSCH_MACdFlows_Information_iE_Extensions,
        HSDSCH_MACdFlows_Information,
        HSDSCH_MACdFlows_Information_ExtIEs,
        _HSDSCH_MACdFlow_Specific_InfoList__item_,
        HSDSCH_MACdFlow_Specific_InfoList,
        _HSDSCH_MACdFlow_Specific_InfoItem_hsDSCH_MACdFlow_ID,
        _HSDSCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority,
        _HSDSCH_MACdFlow_Specific_InfoItem_bindingID,
        _HSDSCH_MACdFlow_Specific_InfoItem_transportLayerAddress,
        ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab,
        _____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id,
        ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality,
        ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue,
        __HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_,
        _HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions,
        HSDSCH_MACdFlow_Specific_InfoItem,
        HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs,
        _HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0,
        _HSDSCH_MACdFlows_to_Delete__item_,
        HSDSCH_MACdFlows_to_Delete,
        _HSDSCH_MACdFlows_to_Delete_Item_hsDSCH_MACdFlow_ID,
        ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id_tab,
        ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id,
        ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality_tab,
        ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality,
        ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue,
        __HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item_,
        _HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions,
        HSDSCH_MACdFlows_to_Delete_Item,
        HSDSCH_MACdFlows_to_Delete_Item_ExtIEs,
        HSDSCH_TBSizeTableIndicator,
        HSSCCH_PowerOffset,
        _HSDSCH_Initial_Capacity_Allocation__item_,
        HSDSCH_Initial_Capacity_Allocation,
        _HSDSCH_Initial_Capacity_AllocationItem_schedulingPriorityIndicator,
        _HSDSCH_Initial_Capacity_AllocationItem_maximum_MACdPDU_Size,
        _HSDSCH_Initial_Capacity_AllocationItem_hSDSCH_InitialWindowSize,
        ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab,
        _____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id,
        ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality,
        ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue,
        __HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item_,
        _HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions,
        HSDSCH_Initial_Capacity_AllocationItem,
        HSDSCH_Initial_Capacity_AllocationItem_ExtIEs,
        _HSDSCH_Initial_Capacity_AllocationItem_ExtIEs_val_Extension_0,
        HSDSCH_InitialWindowSize,
        _HSDSCH_PreconfigurationInfo_setsOfHS_SCCH_Codes,
        _HSDSCH_PreconfigurationInfo_hARQ_MemoryPartitioning,
        _HSDSCH_PreconfigurationInfo_e_DCH_FDD_DL_Control_Channel_Information,
        _HSDSCH_PreconfigurationInfo_hARQ_Preamble_Mode_Activation_Indicator,
        _HSDSCH_PreconfigurationInfo_mIMO_N_M_Ratio,
        _HSDSCH_PreconfigurationInfo_continuousPacketConnectivityHS_SCCH_less_Information_Response,
        ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab,
        _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1,
        ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id,
        ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality,
        ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue,
        __HSDSCH_PreconfigurationInfo_iE_Extensions__item_,
        _HSDSCH_PreconfigurationInfo_iE_Extensions,
        HSDSCH_PreconfigurationInfo,
        HSDSCH_PreconfigurationInfo_ExtIEs,
        _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_0,
        _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_1,
        _Additional_EDCH_Preconfiguration_Information__item_,
        Additional_EDCH_Preconfiguration_Information,
        _Additional_EDCH_Preconfiguration_Information_ItemIEs_e_DCH_FDD_DL_Control_Channel_Information,
        ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions,
        Additional_EDCH_Preconfiguration_Information_ItemIEs,
        Additional_EDCH_Preconfiguration_Information_ItemIEs_ExtIEs,
        _HSDSCH_PreconfigurationSetup_mAChsResetScheme,
        _HSDSCH_PreconfigurationSetup_hSDSCH_Physical_Layer_Category,
        _HSDSCH_PreconfigurationSetup_mAChs_Reordering_Buffer_Size_for_RLC_UM,
        _HSDSCH_PreconfigurationSetup_secondaryServingCells,
        _HSDSCH_PreconfigurationSetup_numPrimaryHS_SCCH_Codes,
        _HSDSCH_PreconfigurationSetup_hARQ_Preamble_Mode,
        _HSDSCH_PreconfigurationSetup_mIMO_ActivationIndicator,
        _HSDSCH_PreconfigurationSetup_hSDSCH_MACdPDUSizeFormat,
        _HSDSCH_PreconfigurationSetup_sixtyfourQAM_UsageAllowedIndicator,
        _HSDSCH_PreconfigurationSetup_uE_with_enhanced_HS_SCCH_support_indicator,
        _HSDSCH_PreconfigurationSetup_continuousPacketConnectivityHS_SCCH_less_Information,
        ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_5,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_6,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_7,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_8,
        ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id,
        ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality,
        ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue,
        __HSDSCH_PreconfigurationSetup_iE_Extensions__item_,
        _HSDSCH_PreconfigurationSetup_iE_Extensions,
        HSDSCH_PreconfigurationSetup,
        HSDSCHPreconfigurationSetup_ExtIEs,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_0,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_1,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_2,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_3,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_4,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_5,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_6,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_7,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_8,
        _HS_SCCH_PreconfiguredCodes__item_,
        HS_SCCH_PreconfiguredCodes,
        _HS_SCCH_PreconfiguredCodesItem_hS_SCCH_CodeNumber,
        ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id_tab,
        ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id,
        ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality_tab,
        ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality,
        ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue_tab,
        ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue,
        __HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item_,
        _HS_SCCH_PreconfiguredCodesItem_iE_Extensions,
        HS_SCCH_PreconfiguredCodesItem,
        HS_SCCH_PreconfiguredCodesItem_ExtIEs,
        HS_SCCH_CodeNumber,
        _HSSCCH_Specific_InformationRespListFDD__item_,
        HSSCCH_Specific_InformationRespListFDD,
        _HSSCCH_Codes_codeNumber,
        ____HSSCCH_Codes_iE_Extensions__item__id_tab,
        ___HSSCCH_Codes_iE_Extensions__item__id,
        ____HSSCCH_Codes_iE_Extensions__item__criticality_tab,
        ___HSSCCH_Codes_iE_Extensions__item__criticality,
        ____HSSCCH_Codes_iE_Extensions__item__extensionValue_tab,
        ___HSSCCH_Codes_iE_Extensions__item__extensionValue,
        __HSSCCH_Codes_iE_Extensions__item_,
        _HSSCCH_Codes_iE_Extensions,
        HSSCCH_Codes,
        HSSCCH_Specific_InformationRespItemFDD_ExtIEs,
        _HSSCCH_Specific_InformationRespListTDD__item_,
        HSSCCH_Specific_InformationRespListTDD,
        _HSSCCH_Specific_InformationRespItemTDD_timeslot,
        _HSSCCH_Specific_InformationRespItemTDD_midambleShiftAndBurstType,
        _HSSCCH_Specific_InformationRespItemTDD_tDD_ChannelisationCode,
        _HSSCCH_Specific_InformationRespItemTDD_hSSICH_Info,
        ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__id_tab,
        ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__id,
        ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__criticality_tab,
        ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__criticality,
        ____HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__extensionValue_tab,
        ___HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item__extensionValue,
        __HSSCCH_Specific_InformationRespItemTDD_iE_Extensions__item_,
        _HSSCCH_Specific_InformationRespItemTDD_iE_Extensions,
        HSSCCH_Specific_InformationRespItemTDD,
        HSSCCH_Specific_InformationRespItemTDD_ExtIEs,
        _HSSCCH_Specific_InformationRespListTDDLCR__item_,
        HSSCCH_Specific_InformationRespListTDDLCR,
        _HSSCCH_Specific_InformationRespItemTDDLCR_timeslotLCR,
        _HSSCCH_Specific_InformationRespItemTDDLCR_midambleShiftLCR,
        _HSSCCH_Specific_InformationRespItemTDDLCR_first_TDD_ChannelisationCode,
        _HSSCCH_Specific_InformationRespItemTDDLCR_second_TDD_ChannelisationCode,
        _HSSCCH_Specific_InformationRespItemTDDLCR_hSSICH_InfoLCR,
        ____HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id_tab,
        _____HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__id,
        ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__criticality,
        ___HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item__extensionValue,
        __HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions__item_,
        _HSSCCH_Specific_InformationRespItemTDDLCR_iE_Extensions,
        HSSCCH_Specific_InformationRespItemTDDLCR,
        HSSCCH_Specific_InformationRespItemTDDLCR_ExtIEs,
        _HSSCCH_Specific_InformationRespItemTDDLCR_ExtIEs_val_Extension_0,
        _HSSCCH_Specific_InformationRespListTDD768__item_,
        HSSCCH_Specific_InformationRespListTDD768,
        _HSSCCH_Specific_InformationRespItemTDD768_timeslot,
        _HSSCCH_Specific_InformationRespItemTDD768_midambleShiftAndBurstType768,
        _HSSCCH_Specific_InformationRespItemTDD768_tDD_ChannelisationCode768,
        _HSSCCH_Specific_InformationRespItemTDD768_hSSICH_Info768,
        ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__id_tab,
        ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__id,
        ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__criticality_tab,
        ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__criticality,
        ____HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__extensionValue_tab,
        ___HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item__extensionValue,
        __HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions__item_,
        _HSSCCH_Specific_InformationRespItemTDD768_iE_Extensions,
        HSSCCH_Specific_InformationRespItemTDD768,
        HSSCCH_Specific_InformationRespItemTDD768_ExtIEs,
        _HSSICH_Info_hsSICH_ID,
        _HSSICH_Info_timeslot,
        _HSSICH_Info_midambleShiftAndBurstType,
        _HSSICH_Info_tDD_ChannelisationCode,
        ____HSSICH_Info_iE_Extensions__item__id_tab,
        ___HSSICH_Info_iE_Extensions__item__id,
        ____HSSICH_Info_iE_Extensions__item__criticality_tab,
        ___HSSICH_Info_iE_Extensions__item__criticality,
        ____HSSICH_Info_iE_Extensions__item__extensionValue_tab,
        ___HSSICH_Info_iE_Extensions__item__extensionValue,
        __HSSICH_Info_iE_Extensions__item_,
        _HSSICH_Info_iE_Extensions,
        HSSICH_Info,
        HSSICH_Info_ExtIEs,
        _HSSICH_InfoLCR_hsSICH_ID,
        _HSSICH_InfoLCR_timeslotLCR,
        _HSSICH_InfoLCR_midambleShiftLCR,
        _HSSICH_InfoLCR_tDD_ChannelisationCode,
        ____HSSICH_InfoLCR_iE_Extensions__item__id_tab,
        _____HSSICH_InfoLCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___HSSICH_InfoLCR_iE_Extensions__item__id,
        ___HSSICH_InfoLCR_iE_Extensions__item__criticality,
        ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue,
        __HSSICH_InfoLCR_iE_Extensions__item_,
        _HSSICH_InfoLCR_iE_Extensions,
        HSSICH_InfoLCR,
        HSSICH_Info_LCR_ExtIEs,
        _HSSICH_Info_LCR_ExtIEs_val_Extension_0,
        _HSSICH_Info768_hsSICH_ID,
        _HSSICH_Info768_timeslot,
        _HSSICH_Info768_midambleShiftAndBurstType768,
        _HSSICH_Info768_tDD_ChannelisationCode768,
        ____HSSICH_Info768_iE_Extensions__item__id_tab,
        ___HSSICH_Info768_iE_Extensions__item__id,
        ____HSSICH_Info768_iE_Extensions__item__criticality_tab,
        ___HSSICH_Info768_iE_Extensions__item__criticality,
        ____HSSICH_Info768_iE_Extensions__item__extensionValue_tab,
        ___HSSICH_Info768_iE_Extensions__item__extensionValue,
        __HSSICH_Info768_iE_Extensions__item_,
        _HSSICH_Info768_iE_Extensions,
        HSSICH_Info768,
        HSSICH_Info_768_ExtIEs,
        _HS_SICH_Reception_Quality_Value_failed_HS_SICH,
        _HS_SICH_Reception_Quality_Value_missed_HS_SICH,
        _HS_SICH_Reception_Quality_Value_total_HS_SICH,
        ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab,
        _____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab_val_Extension_1,
        _____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab_val_Extension_2,
        ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id,
        ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality,
        ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue,
        __HS_SICH_Reception_Quality_Value_iE_Extensions__item_,
        _HS_SICH_Reception_Quality_Value_iE_Extensions,
        HS_SICH_Reception_Quality_Value,
        HS_SICH_Reception_Quality_Value_ExtIEs,
        _HS_SICH_Reception_Quality_Value_ExtIEs_val_Extension_0,
        _HS_SICH_Reception_Quality_Value_ExtIEs_val_Extension_1,
        _HS_SICH_Reception_Quality_Value_ExtIEs_val_Extension_2,
        HS_SICH_failed,
        HS_SICH_missed,
        HS_SICH_total,
        HS_SICH_Reception_Quality_Measurement_Value,
        HSDSCH_MACdFlow_ID,
        HSDSCH_RNTI,
        _HS_PDSCH_FDD_Code_Information_number_of_HS_PDSCH_codes,
        _HS_PDSCH_FDD_Code_Information_hS_PDSCH_Start_code_number,
        ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__id_tab,
        ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__id,
        ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__criticality_tab,
        ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__criticality,
        ____HS_PDSCH_FDD_Code_Information_iE_Extensions__item__extensionValue_tab,
        ___HS_PDSCH_FDD_Code_Information_iE_Extensions__item__extensionValue,
        __HS_PDSCH_FDD_Code_Information_iE_Extensions__item_,
        _HS_PDSCH_FDD_Code_Information_iE_Extensions,
        HS_PDSCH_FDD_Code_Information,
        HS_PDSCH_FDD_Code_Information_ExtIEs,
        HS_PDSCH_Start_code_number,
        HS_SCCH_ID,
        HS_SICH_ID,
        _HS_SCCH_FDD_Code_Information_replace,
        _HS_SCCH_FDD_Code_Information_remove,
        HS_SCCH_FDD_Code_Information,
        _HS_SCCH_FDD_Code_List__item_,
        HS_SCCH_FDD_Code_List,
        HS_SCCH_FDD_Code_Information_Item,
        HSSCCH_CodeChangeIndicator,
        HSSCCH_Code_Change_Grant,
        HS_PDSCH_Code_Change_Indicator,
        HS_PDSCH_Code_Change_Grant,
        HSDSCH_Configured_Indicator,
        _HS_DSCH_Serving_Cell_Change_Info_hspdsch_RL_ID,
        _HS_DSCH_Serving_Cell_Change_Info_hSDSCH_FDD_Information,
        _HS_DSCH_Serving_Cell_Change_Info_hsdsch_RNTI,
        ____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab,
        _____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id_tab_val_Extension_1,
        ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__id,
        ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__criticality,
        ___HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item__extensionValue,
        __HS_DSCH_Serving_Cell_Change_Info_iE_Extensions__item_,
        _HS_DSCH_Serving_Cell_Change_Info_iE_Extensions,
        HS_DSCH_Serving_Cell_Change_Info,
        HS_DSCH_Serving_Cell_Change_Info_ExtIEs,
        _HS_DSCH_Serving_Cell_Change_Info_ExtIEs_val_Extension_0,
        _HS_DSCH_Serving_Cell_Change_Info_ExtIEs_val_Extension_1,
        _HS_DSCH_Serving_Cell_Change_Info_Response_hS_DSCH_serving_cell_choice,
        ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id_tab,
        ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__id,
        ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality_tab,
        ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__criticality,
        ____HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item__extensionValue,
        __HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions__item_,
        _HS_DSCH_Serving_Cell_Change_Info_Response_iE_Extensions,
        HS_DSCH_Serving_Cell_Change_Info_Response,
        HS_DSCH_serving_cell_informationResponse_ExtIEs,
        _HS_DSCH_serving_cell_choice_hS_serving_cell_change_successful,
        _HS_DSCH_serving_cell_choice_hS_serving_cell_change_unsuccessful,
        HS_DSCH_serving_cell_choice,
        _HS_serving_cell_change_successful_hSDSCH_FDD_Information_Response,
        ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab,
        _____HS_serving_cell_change_successful_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_serving_cell_change_successful_iE_Extensions__item__id,
        ___HS_serving_cell_change_successful_iE_Extensions__item__criticality,
        ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue,
        __HS_serving_cell_change_successful_iE_Extensions__item_,
        _HS_serving_cell_change_successful_iE_Extensions,
        HS_serving_cell_change_successful,
        HS_serving_cell_change_successful_ExtIEs,
        _HS_serving_cell_change_successful_ExtIEs_val_Extension_0,
        _HS_serving_cell_change_unsuccessful_cause,
        ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab,
        ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id,
        ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab,
        ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality,
        ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab,
        ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue,
        __HS_serving_cell_change_unsuccessful_iE_Extensions__item_,
        _HS_serving_cell_change_unsuccessful_iE_Extensions,
        HS_serving_cell_change_unsuccessful,
        HS_serving_cell_change_unsuccessful_ExtIEs,
        HS_DSCH_DRX_Cycle_FACH,
        HS_DSCH_RX_Burst_FACH,
        HS_SCCH_DRX_Cycle_FACH,
        HS_SCCH_RX_Burst_FACH,
        _HSDSCH_FDD_Update_Information_hsSCCHCodeChangeIndicator,
        _HSDSCH_FDD_Update_Information_cqiFeedback_CycleK,
        _HSDSCH_FDD_Update_Information_cqiRepetitionFactor,
        _HSDSCH_FDD_Update_Information_ackNackRepetitionFactor,
        _HSDSCH_FDD_Update_Information_cqiPowerOffset,
        _HSDSCH_FDD_Update_Information_ackPowerOffset,
        _HSDSCH_FDD_Update_Information_nackPowerOffset,
        ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab,
        _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_3,
        ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id,
        ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality,
        ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue,
        __HSDSCH_FDD_Update_Information_iE_Extensions__item_,
        _HSDSCH_FDD_Update_Information_iE_Extensions,
        HSDSCH_FDD_Update_Information,
        HSDSCH_FDD_Update_Information_ExtIEs,
        _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_0,
        _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_1,
        _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_2,
        _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_3,
        _HSDSCH_TDD_Update_Information_hsSCCHCodeChangeIndicator,
        _HSDSCH_TDD_Update_Information_tDDAckNackPowerOffset,
        ____HSDSCH_TDD_Update_Information_iE_Extensions__item__id_tab,
        ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id,
        ____HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality_tab,
        ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality,
        ____HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue,
        __HSDSCH_TDD_Update_Information_iE_Extensions__item_,
        _HSDSCH_TDD_Update_Information_iE_Extensions,
        HSDSCH_TDD_Update_Information,
        HSDSCH_TDD_Update_Information_ExtIEs,
        HSPDSCH_Code_Index,
        HSPDSCH_First_Code_Index,
        HSPDSCH_Second_Code_Index,
        HSPDSCH_Second_Code_Support,
        _HSDPA_Associated_PICH_InformationLCR_hsdpa_PICH_Shared_with_PCH,
        _HSDPA_Associated_PICH_InformationLCR_hsdpa_PICH_notShared_with_PCHLCR,
        HSDPA_Associated_PICH_InformationLCR,
        _HSDPA_PICH_notShared_with_PCHLCR_hSDPA_PICH_notShared_ID,
        _HSDPA_PICH_notShared_with_PCHLCR_tdd_ChannelisationCodeLCR,
        _HSDPA_PICH_notShared_with_PCHLCR_timeSlotLCR,
        _HSDPA_PICH_notShared_with_PCHLCR_midambleShiftLCR,
        _HSDPA_PICH_notShared_with_PCHLCR_tdd_PhysicalChannelOffset,
        _HSDPA_PICH_notShared_with_PCHLCR_repetitionPeriod,
        _HSDPA_PICH_notShared_with_PCHLCR_repetitionLength,
        _HSDPA_PICH_notShared_with_PCHLCR_pagingIndicatorLength,
        _HSDPA_PICH_notShared_with_PCHLCR_pICH_Power,
        _HSDPA_PICH_notShared_with_PCHLCR_second_TDD_ChannelisationCodeLCR,
        _HSDPA_PICH_notShared_with_PCHLCR_sttd_Indicator,
        ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__id_tab,
        ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__id,
        ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__criticality_tab,
        ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__criticality,
        ____HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__extensionValue_tab,
        ___HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item__extensionValue,
        __HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions__item_,
        _HSDPA_PICH_notShared_with_PCHLCR_iE_Extensions,
        HSDPA_PICH_notShared_with_PCHLCR,
        HSDPA_PICH_notShared_with_PCHLCR_ExtIEs,
        _HSDSCH_Common_System_InformationLCR_hsdsch_Common_InformationLCR,
        _HSDSCH_Common_System_InformationLCR_commonMACFlow_Specific_InformationLCR,
        _HSDSCH_Common_System_InformationLCR_common_H_RNTI_InformationLCR,
        _HSDSCH_Common_System_InformationLCR_sync_InformationLCR,
        _HSDSCH_Common_System_InformationLCR_tDD_AckNack_Power_Offset,
        _HSDSCH_Common_System_InformationLCR_hSSICH_SIRTarget,
        _HSDSCH_Common_System_InformationLCR_hSSICH_TPC_StepSize,
        ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__id_tab,
        ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__id,
        ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__criticality_tab,
        ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__criticality,
        ____HSDSCH_Common_System_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_Common_System_InformationLCR_iE_Extensions__item__extensionValue,
        __HSDSCH_Common_System_InformationLCR_iE_Extensions__item_,
        _HSDSCH_Common_System_InformationLCR_iE_Extensions,
        HSDSCH_Common_System_InformationLCR,
        HSDSCH_Common_System_InformationLCR_ExtIEs,
        _HSDSCH_Common_System_Information_ResponseLCR_hsSCCH_Specific_Information_ResponseLCR,
        _HSDSCH_Common_System_Information_ResponseLCR_hARQ_MemoryPartitioning,
        _HSDSCH_Common_System_Information_ResponseLCR_commonMACFlow_Specific_Info_ResponseLCR,
        ____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab,
        _____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_2,
        ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__id,
        ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__criticality,
        ___HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions__item_,
        _HSDSCH_Common_System_Information_ResponseLCR_iE_Extensions,
        HSDSCH_Common_System_Information_ResponseLCR,
        HSDSCH_Common_System_Information_ResponseLCR_ExtIEs,
        _HSDSCH_Common_System_Information_ResponseLCR_ExtIEs_val_Extension_0,
        _HSDSCH_Common_System_Information_ResponseLCR_ExtIEs_val_Extension_1,
        _HSDSCH_Common_System_Information_ResponseLCR_ExtIEs_val_Extension_2,
        _HSDSCH_Common_InformationLCR_cCCH_PriorityQueue_Id,
        _HSDSCH_Common_InformationLCR_sRB1_PriorityQueue_Id,
        _HSDSCH_Common_InformationLCR_associatedCommon_MACFlowLCR,
        _HSDSCH_Common_InformationLCR_fACH_Measurement_Occasion_Cycle_Length_Coefficient,
        _HSDSCH_Common_InformationLCR_bCCH_Specific_HSDSCH_RNTI_InformationLCR,
        ____HSDSCH_Common_InformationLCR_iE_Extensions__item__id_tab,
        ___HSDSCH_Common_InformationLCR_iE_Extensions__item__id,
        ____HSDSCH_Common_InformationLCR_iE_Extensions__item__criticality_tab,
        ___HSDSCH_Common_InformationLCR_iE_Extensions__item__criticality,
        ____HSDSCH_Common_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_Common_InformationLCR_iE_Extensions__item__extensionValue,
        __HSDSCH_Common_InformationLCR_iE_Extensions__item_,
        _HSDSCH_Common_InformationLCR_iE_Extensions,
        HSDSCH_Common_InformationLCR,
        HSDSCH_Common_InformationLCR_ExtIEs,
        _HSDSCH_Paging_System_InformationLCR_paging_MACFlow_Specific_InformationLCR,
        _HSDSCH_Paging_System_InformationLCR_hSSCCH_Power,
        _HSDSCH_Paging_System_InformationLCR_hSPDSCH_Power,
        _HSDSCH_Paging_System_InformationLCR_reception_Window_Size,
        _HSDSCH_Paging_System_InformationLCR_n_PCH,
        _HSDSCH_Paging_System_InformationLCR_paging_Subchannel_Size,
        _HSDSCH_Paging_System_InformationLCR_transport_Block_Size_List,
        ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__id_tab,
        ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__id,
        ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__criticality_tab,
        ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__criticality,
        ____HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_Paging_System_InformationLCR_iE_Extensions__item__extensionValue,
        __HSDSCH_Paging_System_InformationLCR_iE_Extensions__item_,
        _HSDSCH_Paging_System_InformationLCR_iE_Extensions,
        HSDSCH_Paging_System_InformationLCR,
        HSDSCH_Paging_System_InformationLCR_ExtIEs,
        _HSDSCH_Paging_System_Information_ResponseLCR__item_,
        HSDSCH_Paging_System_Information_ResponseLCR,
        _HSDSCH_Paging_System_Information_ResponseListLCR_pagingMACFlow_ID,
        _HSDSCH_Paging_System_Information_ResponseListLCR_bindingID,
        _HSDSCH_Paging_System_Information_ResponseListLCR_transportLayerAddress,
        _HSDSCH_Paging_System_Information_ResponseListLCR_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst,
        ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__id_tab,
        ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__id,
        ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__criticality_tab,
        ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__criticality,
        ____HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item__extensionValue,
        __HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions__item_,
        _HSDSCH_Paging_System_Information_ResponseListLCR_iE_Extensions,
        HSDSCH_Paging_System_Information_ResponseListLCR,
        HSDSCH_Paging_System_Information_ResponseListLCR_ExtIEs,
        HS_SCCH_ID_LCR,
        _HSSCCH_Specific_InformationRespListLCR__item_,
        HSSCCH_Specific_InformationRespListLCR,
        _HSSCCH_Specific_InformationRespItemLCR_hS_SCCH_ID_LCR,
        ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__id_tab,
        ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__id,
        ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__criticality_tab,
        ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__criticality,
        ____HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__extensionValue_tab,
        ___HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item__extensionValue,
        __HSSCCH_Specific_InformationRespItemLCR_iE_Extensions__item_,
        _HSSCCH_Specific_InformationRespItemLCR_iE_Extensions,
        HSSCCH_Specific_InformationRespItemLCR,
        HSSCCH_Specific_InformationRespItemLCR_ExtIEs,
        _HS_DSCH_Semi_PersistentScheduling_Information_LCR_transport_Block_Size_List,
        _HS_DSCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR,
        _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Reservation_Indicator,
        _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Operation_Indicator,
        ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id,
        ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality,
        ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue,
        __HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_,
        _HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions,
        HS_DSCH_Semi_PersistentScheduling_Information_LCR,
        HS_DSCH_Semi_PersistentScheduling_Information_LCR_ExtIEs,
        _Transport_Block_Size_List_LCR__item_,
        Transport_Block_Size_List_LCR,
        _Transport_Block_Size_Item_LCR_transport_Block_Size_maping_Index_LCR,
        _Transport_Block_Size_Item_LCR_transport_Block_Size_Index_LCR,
        ____Transport_Block_Size_Item_LCR_iE_Extensions__item__id_tab,
        ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id,
        ____Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality_tab,
        ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality,
        ____Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue_tab,
        ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue,
        __Transport_Block_Size_Item_LCR_iE_Extensions__item_,
        _Transport_Block_Size_Item_LCR_iE_Extensions,
        Transport_Block_Size_Item_LCR,
        Transport_Block_Size_Item_LCR_ExtIEs,
        Transport_Block_Size_maping_Index_LCR,
        Transport_Block_Size_Index_LCR,
        _Repetition_Period_List_LCR__item_,
        Repetition_Period_List_LCR,
        _Repetition_Period_Item_LCR_repetitionPeriodIndex,
        _Repetition_Period_Item_LCR_repetitionPeriod,
        _Repetition_Period_Item_LCR_repetitionLength,
        ____Repetition_Period_Item_LCR_iE_Extensions__item__id_tab,
        ___Repetition_Period_Item_LCR_iE_Extensions__item__id,
        ____Repetition_Period_Item_LCR_iE_Extensions__item__criticality_tab,
        ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality,
        ____Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue_tab,
        ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue,
        __Repetition_Period_Item_LCR_iE_Extensions__item_,
        _Repetition_Period_Item_LCR_iE_Extensions,
        Repetition_Period_Item_LCR,
        Repetition_Period_Item_LCR_ExtIEs,
        RepetitionPeriodIndex,
        SPS_Reservation_Indicator,
        _HS_DSCH_SPS_Operation_Indicator_logicalChannellevel,
        _HS_DSCH_SPS_Operation_Indicator_priorityQueuelevel,
        HS_DSCH_SPS_Operation_Indicator,
        LogicalChannellevel,
        PriorityQueuelevel,
        _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_transport_Block_Size_List,
        _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR,
        ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab,
        _____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab_val_Extension_1,
        ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id,
        ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality,
        ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue,
        __HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_,
        _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions,
        HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR,
        HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs,
        _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs_val_Extension_0,
        _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs_val_Extension_1,
        _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_hS_SICH_InformationList_for_HS_DSCH_SPS,
        _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_initial_HS_PDSCH_SPS_Resource,
        _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_buffer_Size_for_HS_DSCH_SPS,
        _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_number_of_Processes_for_HS_DSCH_SPS,
        ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id,
        ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality,
        ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_,
        _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions,
        HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR,
        HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs,
        _HS_SICH_InformationList_for_HS_DSCH_SPS__item_,
        HS_SICH_InformationList_for_HS_DSCH_SPS,
        _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Mapping_Index,
        _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Type,
        ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id_tab,
        ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id,
        ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality_tab,
        ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality,
        ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue_tab,
        ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue,
        __HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item_,
        _HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions,
        HS_SICH_InformationItem_for_HS_DSCH_SPS,
        HS_SICH_InformationItem_for_HS_DSCH_SPS_ExtIEs,
        HS_SICH_Mapping_Index,
        _HS_SICH_Type_hS_SCCH_Associated_HS_SICH,
        _HS_SICH_Type_non_HS_SCCH_Associated_HS_SICH,
        HS_SICH_Type,
        _HS_SCCH_Associated_HS_SICH_hsSICH_ID,
        _HS_SCCH_Associated_HS_SICH_extended_HS_SICH_ID,
        HS_SCCH_Associated_HS_SICH,
        _Non_HS_SCCH_Associated_HS_SICH_non_HS_SCCH_Aassociated_HS_SICH_ID,
        Non_HS_SCCH_Associated_HS_SICH,
        Non_HS_SCCH_Aassociated_HS_SICH_ID,
        _Initial_HS_PDSCH_SPS_Resource_repetitionPeriodIndex,
        _Initial_HS_PDSCH_SPS_Resource_repetitionLength,
        _Initial_HS_PDSCH_SPS_Resource_hS_PDSCH_Offset,
        _Initial_HS_PDSCH_SPS_Resource_timeslot_Resource_Related_Information,
        _Initial_HS_PDSCH_SPS_Resource_startCode,
        _Initial_HS_PDSCH_SPS_Resource_endCode,
        _Initial_HS_PDSCH_SPS_Resource_transport_Block_Size_Index,
        _Initial_HS_PDSCH_SPS_Resource_modulationType,
        _Initial_HS_PDSCH_SPS_Resource_hS_SICH_Mapping_Index,
        ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab,
        _____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab_val_Extension_0,
        ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id,
        ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality,
        ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue,
        __Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item_,
        _Initial_HS_PDSCH_SPS_Resource_iE_Extensions,
        Initial_HS_PDSCH_SPS_Resource,
        Initial_HS_PDSCH_SPS_Resource_ExtIEs,
        _Initial_HS_PDSCH_SPS_Resource_ExtIEs_val_Extension_0,
        HS_DSCH_TimeslotResourceLCR,
        ModulationSPS_LCR,
        Number_of_Processes_for_HS_DSCH_SPS,
        _Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_non_HS_SCCH_Associated_HS_SICH_InformationList,
        ____Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions,
        Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst,
        Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs,
        _Add_To_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _Non_HS_SCCH_Associated_HS_SICH_InformationList__item_,
        Non_HS_SCCH_Associated_HS_SICH_InformationList,
        _Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext__item_,
        Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext,
        _Non_HS_SCCH_Associated_HS_SICH_InformationItem_non_HS_SCCH_Aassociated_HS_SICH_ID,
        _Non_HS_SCCH_Associated_HS_SICH_InformationItem_timeSlotLCR,
        _Non_HS_SCCH_Associated_HS_SICH_InformationItem_midambleShiftLCR,
        _Non_HS_SCCH_Associated_HS_SICH_InformationItem_tdd_ChannelisationCode,
        _Non_HS_SCCH_Associated_HS_SICH_InformationItem_uARFCN,
        ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id_tab,
        ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id,
        ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality_tab,
        ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality,
        ____Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue,
        __Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item_,
        _Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions,
        Non_HS_SCCH_Associated_HS_SICH_InformationItem,
        Non_HS_SCCH_Associated_HS_SICH_InformationItem_ExtIEs,
        _Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_modify_non_HS_SCCH_Associated_HS_SICH_InformationList,
        ____Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions,
        Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst,
        Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs,
        _Modify_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList__item_,
        Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList,
        _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext__item_,
        Modify_Non_HS_SCCH_Associated_HS_SICH_InformationList_Ext,
        _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_non_HS_SCCH_Aassociated_HS_SICH_ID,
        _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_timeSlotLCR,
        _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_midambleShiftLCR,
        _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_tdd_ChannelisationCode,
        _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_uARFCN,
        ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id_tab,
        ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__id,
        ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality_tab,
        ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__criticality,
        ____Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item__extensionValue,
        __Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions__item_,
        _Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_iE_Extensions,
        Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem,
        Modify_Non_HS_SCCH_Associated_HS_SICH_InformationItem_ExtIEs,
        _Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst__item_,
        Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst,
        _Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext__item_,
        Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqst_Ext,
        _Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqstItem_non_HS_SCCH_Aassociated_HS_SICH_ID,
        Delete_From_Non_HS_SCCH_Associated_HS_SICH_Resource_Pool_LCR_PSCH_ReconfRqstItem,
        _MIMO_ReferenceSignal_InformationListLCR__item_,
        MIMO_ReferenceSignal_InformationListLCR,
        _HSSICH_ReferenceSignal_InformationLCR_midambleConfigurationLCR,
        _HSSICH_ReferenceSignal_InformationLCR_midambleShift,
        _HSSICH_ReferenceSignal_InformationLCR_timeSlotLCR,
        ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id_tab,
        ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id,
        ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality_tab,
        ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality,
        ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue,
        __HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item_,
        _HSSICH_ReferenceSignal_InformationLCR_iE_Extensions,
        HSSICH_ReferenceSignal_InformationLCR,
        HSSICH_ReferenceSignal_InformationLCR_ExtIEs,
        _HSSICH_ReferenceSignal_InformationModifyLCR_hSSICH_ReferenceSignal_InformationLCR,
        ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__id_tab,
        ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__id,
        ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__criticality_tab,
        ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__criticality,
        ____HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__extensionValue_tab,
        ___HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item__extensionValue,
        __HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions__item_,
        _HSSICH_ReferenceSignal_InformationModifyLCR_iE_Extensions,
        HSSICH_ReferenceSignal_InformationModifyLCR,
        HSSICH_ReferenceSignal_InformationModifyLCR_ExtIEs,
        HS_DPCCH_transmission_continuation_backoff,
        IB_OC_ID,
        IB_SG_DATA,
        IB_SG_POS,
        IB_SG_REP,
        IB_Type,
        _IMB_Parameters_sub_Frame_Number,
        _IMB_Parameters_fdd_dl_ChannelisationCodeNumber,
        ____IMB_Parameters_ie_Extensions__item__id_tab,
        ___IMB_Parameters_ie_Extensions__item__id,
        ____IMB_Parameters_ie_Extensions__item__criticality_tab,
        ___IMB_Parameters_ie_Extensions__item__criticality,
        ____IMB_Parameters_ie_Extensions__item__extensionValue_tab,
        ___IMB_Parameters_ie_Extensions__item__extensionValue,
        __IMB_Parameters_ie_Extensions__item_,
        _IMB_Parameters_ie_Extensions,
        IMB_Parameters,
        IMB_Parameters_ExtIEs,
        _BCH_Parameters_commonTransportChannelID,
        _BCH_Parameters_bCH_Power,
        ____BCH_Parameters_iE_Extensions__item__id_tab,
        ___BCH_Parameters_iE_Extensions__item__id,
        ____BCH_Parameters_iE_Extensions__item__criticality_tab,
        ___BCH_Parameters_iE_Extensions__item__criticality,
        ____BCH_Parameters_iE_Extensions__item__extensionValue_tab,
        ___BCH_Parameters_iE_Extensions__item__extensionValue,
        __BCH_Parameters_iE_Extensions__item_,
        _BCH_Parameters_iE_Extensions,
        BCH_Parameters,
        BCH_ParametersItem_ExtIEs,
        Inactivity_Threshold_for_UE_DRX_Cycle,
        Inactivity_Threshold_for_UE_DTX_Cycle2,
        Inactivity_Threshold_for_UE_Grant_Monitoring,
        _InformationReportCharacteristics_onDemand,
        _InformationReportCharacteristics_periodic,
        _InformationReportCharacteristics_onModification,
        InformationReportCharacteristics,
        _InformationReportCharacteristicsType_ReportPeriodicity_min,
        _InformationReportCharacteristicsType_ReportPeriodicity_hours,
        InformationReportCharacteristicsType_ReportPeriodicity,
        _InformationReportCharacteristicsType_OnModification_information_thresholds,
        ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__id_tab,
        ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__id,
        ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__criticality_tab,
        ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__criticality,
        ____InformationReportCharacteristicsType_OnModification_ie_Extensions__item__extensionValue_tab,
        ___InformationReportCharacteristicsType_OnModification_ie_Extensions__item__extensionValue,
        __InformationReportCharacteristicsType_OnModification_ie_Extensions__item_,
        _InformationReportCharacteristicsType_OnModification_ie_Extensions,
        InformationReportCharacteristicsType_OnModification,
        InformationReportCharacteristicsType_OnModification_ExtIEs,
        _InformationThresholds_dgps,
        _InformationThresholds_dGANSSThreshold,
        InformationThresholds,
        InformationExchangeID,
        _InformationType_information_Type_Item,
        _InformationType_gPSInformation,
        ____InformationType_iE_Extensions__item__id_tab,
        _____InformationType_iE_Extensions__item__id_tab_val_Extension_0,
        _____InformationType_iE_Extensions__item__id_tab_val_Extension_1,
        ___InformationType_iE_Extensions__item__id,
        ___InformationType_iE_Extensions__item__criticality,
        ___InformationType_iE_Extensions__item__extensionValue,
        __InformationType_iE_Extensions__item_,
        _InformationType_iE_Extensions,
        InformationType,
        Information_Type_ExtIEs,
        _Information_Type_ExtIEs_val_Extension_0,
        _Information_Type_ExtIEs_val_Extension_1,
        Information_Type_Item,
        Initial_DL_DPCH_TimingAdjustment_Allowed,
        InnerLoopDLPCStatus,
        IPDL_Indicator,
        _IPDL_FDD_Parameters_iP_SpacingFDD,
        _IPDL_FDD_Parameters_iP_Length,
        _IPDL_FDD_Parameters_seed,
        _IPDL_FDD_Parameters_burstModeParams,
        _IPDL_FDD_Parameters_iP_Offset,
        ____IPDL_FDD_Parameters_iE_Extensions__item__id_tab,
        ___IPDL_FDD_Parameters_iE_Extensions__item__id,
        ____IPDL_FDD_Parameters_iE_Extensions__item__criticality_tab,
        ___IPDL_FDD_Parameters_iE_Extensions__item__criticality,
        ____IPDL_FDD_Parameters_iE_Extensions__item__extensionValue_tab,
        ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue,
        __IPDL_FDD_Parameters_iE_Extensions__item_,
        _IPDL_FDD_Parameters_iE_Extensions,
        IPDL_FDD_Parameters,
        IPDLFDDParameter_ExtIEs,
        _IPDL_TDD_Parameters_iP_SpacingTDD,
        _IPDL_TDD_Parameters_iP_Start,
        _IPDL_TDD_Parameters_iP_Slot,
        _IPDL_TDD_Parameters_iP_PCCPCH,
        _IPDL_TDD_Parameters_burstModeParams,
        ____IPDL_TDD_Parameters_iE_Extensions__item__id_tab,
        ___IPDL_TDD_Parameters_iE_Extensions__item__id,
        ____IPDL_TDD_Parameters_iE_Extensions__item__criticality_tab,
        ___IPDL_TDD_Parameters_iE_Extensions__item__criticality,
        ____IPDL_TDD_Parameters_iE_Extensions__item__extensionValue_tab,
        ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue,
        __IPDL_TDD_Parameters_iE_Extensions__item_,
        _IPDL_TDD_Parameters_iE_Extensions,
        IPDL_TDD_Parameters,
        _IPDL_TDD_Parameters_LCR_iP_SpacingTDD,
        _IPDL_TDD_Parameters_LCR_iP_Start,
        _IPDL_TDD_Parameters_LCR_iP_Sub,
        _IPDL_TDD_Parameters_LCR_burstModeParams,
        ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__id_tab,
        ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__id,
        ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__criticality_tab,
        ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__criticality,
        ____IPDL_TDD_Parameters_LCR_iE_Extensions__item__extensionValue_tab,
        ___IPDL_TDD_Parameters_LCR_iE_Extensions__item__extensionValue,
        __IPDL_TDD_Parameters_LCR_iE_Extensions__item_,
        _IPDL_TDD_Parameters_LCR_iE_Extensions,
        IPDL_TDD_Parameters_LCR,
        _IPMulticastIndication_transportLayerAddress,
        _IPMulticastIndication_bindingID,
        _IPMulticastIndication_cFNOffset,
        ____IPMulticastIndication_iE_Extensions__item__id_tab,
        ___IPMulticastIndication_iE_Extensions__item__id,
        ____IPMulticastIndication_iE_Extensions__item__criticality_tab,
        ___IPMulticastIndication_iE_Extensions__item__criticality,
        ____IPMulticastIndication_iE_Extensions__item__extensionValue_tab,
        ___IPMulticastIndication_iE_Extensions__item__extensionValue,
        __IPMulticastIndication_iE_Extensions__item_,
        _IPMulticastIndication_iE_Extensions,
        IPMulticastIndication,
        IPMulticastIndication_ExtIEs,
        IPMulticastDataBearerIndication,
        _BurstModeParams_burstStart,
        _BurstModeParams_burstLength,
        _BurstModeParams_burstFreq,
        BurstModeParams,
        IPDLTDDParameter_ExtIEs,
        IPDLTDDParameterLCR_ExtIEs,
        _IdleIntervalInformation_idleIntervalInfo_k,
        _IdleIntervalInformation_idleIntervalInfo_offset,
        IdleIntervalInformation,
        _In_Sync_Information_LCR_t312,
        _In_Sync_Information_LCR_n312,
        In_Sync_Information_LCR,
        LimitedPowerIncrease,
        Local_Cell_ID,
        LTGI_Presence,
        _LCRTDD_Uplink_Physical_Channel_Capability_maxTimeslotsPerSubFrame,
        _LCRTDD_Uplink_Physical_Channel_Capability_maxPhysChPerTimeslot,
        ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id_tab,
        ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id,
        ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality_tab,
        ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality,
        ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue_tab,
        ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue,
        __LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item_,
        _LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions,
        LCRTDD_Uplink_Physical_Channel_Capability,
        LCRTDD_Uplink_Physical_Channel_Capability_ExtIEs,
        MAC_DTX_Cycle_2ms,
        MAC_DTX_Cycle_10ms,
        MAC_ehs_Reset_Timer,
        MACdPDU_Size,
        MAC_PDU_SizeExtended,
        MAC_Inactivity_Threshold,
        _MACdPDU_Size_Indexlist__item_,
        MACdPDU_Size_Indexlist,
        _MACdPDU_Size_IndexItem_sID,
        _MACdPDU_Size_IndexItem_macdPDU_Size,
        ____MACdPDU_Size_IndexItem_iE_Extensions__item__id_tab,
        ___MACdPDU_Size_IndexItem_iE_Extensions__item__id,
        ____MACdPDU_Size_IndexItem_iE_Extensions__item__criticality_tab,
        ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality,
        ____MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue_tab,
        ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue,
        __MACdPDU_Size_IndexItem_iE_Extensions__item_,
        _MACdPDU_Size_IndexItem_iE_Extensions,
        MACdPDU_Size_IndexItem,
        MACdPDU_Size_IndexItem_ExtIEs,
        _MACdPDU_Size_Indexlist_to_Modify__item_,
        MACdPDU_Size_Indexlist_to_Modify,
        _MACdPDU_Size_IndexItem_to_Modify_sID,
        _MACdPDU_Size_IndexItem_to_Modify_macdPDU_Size,
        ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id_tab,
        ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id,
        ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality_tab,
        ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality,
        ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue_tab,
        ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue,
        __MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item_,
        _MACdPDU_Size_IndexItem_to_Modify_iE_Extensions,
        MACdPDU_Size_IndexItem_to_Modify,
        MACdPDU_Size_IndexItem_to_Modify_ExtIEs,
        MACesGuaranteedBitRate,
        MACes_Maximum_Bitrate_LCR,
        MACeReset_Indicator,
        MAChsGuaranteedBitRate,
        MAChsReorderingBufferSize_for_RLC_UM,
        MAC_hsWindowSize,
        MAChsResetScheme,
        MaximumDL_PowerCapability,
        Max_Bits_MACe_PDU_non_scheduled,
        Max_EDCH_Resource_Allocation_for_CCCH,
        Max_EDCH_Resource_Allocation_for_CCCH_Extension,
        Max_Period_for_Collision_Resolution,
        _Max_TB_Sizes_maximum_TB_Size_cell_edge_users,
        _Max_TB_Sizes_maximum_TB_Size_other_users,
        ____Max_TB_Sizes_iE_Extensions__item__id_tab,
        ___Max_TB_Sizes_iE_Extensions__item__id,
        ____Max_TB_Sizes_iE_Extensions__item__criticality_tab,
        ___Max_TB_Sizes_iE_Extensions__item__criticality,
        ____Max_TB_Sizes_iE_Extensions__item__extensionValue_tab,
        ___Max_TB_Sizes_iE_Extensions__item__extensionValue,
        __Max_TB_Sizes_iE_Extensions__item_,
        _Max_TB_Sizes_iE_Extensions,
        Max_TB_Sizes,
        Max_TB_Sizes_ExtIEs,
        Maximum_Number_of_Retransmissions_For_E_DCH,
        Maximum_Target_ReceivedTotalWideBandPower_LCR,
        MaximumTransmissionPower,
        MaxNrOfUL_DPDCHs,
        MaxPRACH_MidambleShifts,
        Max_Set_E_DPDCHs,
        Max_UE_DTX_Cycle,
        MBMS_Capability,
        MeasurementFilterCoefficient,
        MeasurementID,
        Measurement_Power_Offset,
        MeasurementRecoveryBehavior,
        MeasurementRecoveryReportingIndicator,
        MeasurementRecoverySupportIndicator,
        __MessageStructure__item__iE_ID,
        __MessageStructure__item__repetitionNumber,
        _____MessageStructure__item__iE_Extensions__item__id_tab,
        ____MessageStructure__item__iE_Extensions__item__id,
        _____MessageStructure__item__iE_Extensions__item__criticality_tab,
        ____MessageStructure__item__iE_Extensions__item__criticality,
        _____MessageStructure__item__iE_Extensions__item__extensionValue_tab,
        ____MessageStructure__item__iE_Extensions__item__extensionValue,
        ___MessageStructure__item__iE_Extensions__item_,
        __MessageStructure__item__iE_Extensions,
        _MessageStructure__item_,
        MessageStructure,
        MessageStructure_ExtIEs,
        MICH_CFN,
        MICH_Mode,
        MidambleConfigurationLCR,
        MidambleConfigurationBurstType1And3,
        MidambleConfigurationBurstType2,
        __MidambleShiftAndBurstType_type1_midambleConfigurationBurstType1And3,
        ___MidambleShiftAndBurstType_type1_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType_type1_midambleAllocationMode_commonMidamble,
        ___MidambleShiftAndBurstType_type1_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType_type1_midambleAllocationMode,
        _MidambleShiftAndBurstType_type1,
        __MidambleShiftAndBurstType_type2_midambleConfigurationBurstType2,
        ___MidambleShiftAndBurstType_type2_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType_type2_midambleAllocationMode_commonMidamble,
        ___MidambleShiftAndBurstType_type2_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType_type2_midambleAllocationMode,
        _MidambleShiftAndBurstType_type2,
        __MidambleShiftAndBurstType_type3_midambleConfigurationBurstType1And3,
        ___MidambleShiftAndBurstType_type3_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType_type3_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType_type3_midambleAllocationMode,
        _MidambleShiftAndBurstType_type3,
        MidambleShiftAndBurstType,
        MidambleShiftLong,
        MidambleShiftShort,
        _MidambleShiftLCR_midambleAllocationMode,
        _MidambleShiftLCR_midambleShift,
        _MidambleShiftLCR_midambleConfigurationLCR,
        ____MidambleShiftLCR_iE_Extensions__item__id_tab,
        ___MidambleShiftLCR_iE_Extensions__item__id,
        ____MidambleShiftLCR_iE_Extensions__item__criticality_tab,
        ___MidambleShiftLCR_iE_Extensions__item__criticality,
        ____MidambleShiftLCR_iE_Extensions__item__extensionValue_tab,
        ___MidambleShiftLCR_iE_Extensions__item__extensionValue,
        __MidambleShiftLCR_iE_Extensions__item_,
        _MidambleShiftLCR_iE_Extensions,
        MidambleShiftLCR,
        MidambleAllocationMode,
        MidambleShiftLCR_ExtIEs,
        __MidambleShiftAndBurstType768_type1_midambleConfigurationBurstType1And3,
        ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_commonMidamble,
        ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType768_type1_midambleAllocationMode,
        _MidambleShiftAndBurstType768_type1,
        __MidambleShiftAndBurstType768_type2_midambleConfigurationBurstType2_768,
        ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_commonMidamble,
        ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType768_type2_midambleAllocationMode,
        _MidambleShiftAndBurstType768_type2,
        __MidambleShiftAndBurstType768_type3_midambleConfigurationBurstType1And3,
        ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType768_type3_midambleAllocationMode,
        _MidambleShiftAndBurstType768_type3,
        MidambleShiftAndBurstType768,
        MidambleConfigurationBurstType2_768,
        MidambleShiftShort768,
        MIMO_ActivationIndicator,
        MIMO_Capability,
        MIMO_Mode_Indicator,
        MIMO_N_M_Ratio,
        _MIMO_PilotConfiguration_primary_and_secondary_CPICH,
        _MIMO_PilotConfiguration_normal_and_diversity_primary_CPICH,
        MIMO_PilotConfiguration,
        _MIMO_PilotConfigurationExtension_primary_and_secondary_CPICH,
        _MIMO_PilotConfigurationExtension_normal_and_diversity_primary_CPICH,
        MIMO_PilotConfigurationExtension,
        MIMO_PowerOffsetForS_CPICHCapability,
        MIMO_withfourtransmitantennas_ActivationIndicator,
        MIMO_withfourtransmitantennas_Mode_Indicator,
        DualStream_MIMO_withfourtransmitantennas_ActivationIndicator,
        DualStream_MIMO_withfourtransmitantennas_Mode_Indicator,
        _MIMO_withfourtransmitantennas_PilotConfiguration_primary_and_secondary_CPICH,
        _MIMO_withfourtransmitantennas_PilotConfiguration_normal_and_diversity_primary_CPICH,
        MIMO_withfourtransmitantennas_PilotConfiguration,
        _MIMO_withfourtransmitantennas_SCPICH__item_,
        MIMO_withfourtransmitantennas_SCPICH,
        _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_S_CPICH,
        _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_S_CPICH_poweroffset,
        _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_D_CPICH,
        _MIMO_withfourtransmitantennas_SCPICH_Configuration_associated_D_CPICH_poweroffset,
        ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__id_tab,
        ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__id,
        ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__criticality_tab,
        ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__criticality,
        ____MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__extensionValue_tab,
        ___MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item__extensionValue,
        __MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions__item_,
        _MIMO_withfourtransmitantennas_SCPICH_Configuration_iE_Extensions,
        MIMO_withfourtransmitantennas_SCPICH_Configuration,
        MIMO_withfourtransmitantennas_SCPICH_Configuration_Item_ExtIEs,
        PowerOffsetForSCPICH_DCPICHforMIMOwithfourtransmitantennas,
        MinimumDL_PowerCapability,
        MinimumReducedE_DPDCH_GainFactor,
        MinSpreadingFactor,
        Modification_Period,
        _ModifyPriorityQueue_addPriorityQueue,
        _ModifyPriorityQueue_modifyPriorityQueue,
        _ModifyPriorityQueue_deletePriorityQueue,
        ModifyPriorityQueue,
        Modulation,
        MinUL_ChannelisationCodeLength,
        MultiplexingPosition,
        MAChs_ResetIndicator,
        ModulationMBSFN,
        MBSFN_CPICH_secondary_CCPCH_power_offset,
        _ModulationPO_MBSFN_qPSK,
        _ModulationPO_MBSFN_sixteenQAM,
        ModulationPO_MBSFN,
        MBSFN_Only_Mode_Indicator,
        MBSFN_Only_Mode_Capability,
        Multicarrier_Number,
        _MultipleFreq_HARQ_MemoryPartitioning_InformationList__item_,
        MultipleFreq_HARQ_MemoryPartitioning_InformationList,
        _MultipleFreq_HARQ_MemoryPartitioning_InformationItem_hARQ_MemoryPartitioning,
        _MultipleFreq_HARQ_MemoryPartitioning_InformationItem_uARFCN,
        ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__id_tab,
        ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__id,
        ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__criticality_tab,
        ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__criticality,
        ____MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item__extensionValue,
        __MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions__item_,
        _MultipleFreq_HARQ_MemoryPartitioning_InformationItem_iE_Extensions,
        MultipleFreq_HARQ_MemoryPartitioning_InformationItem,
        MultipleFreq_HARQ_MemoryPartitioning_InformationItem_ExtIEs,
        _MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR__item_,
        MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR,
        _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hsSCCH_Specific_Information_ResponseTDDLCR,
        _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hARQ_MemoryPartitioning,
        _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_uARFCN,
        ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id_tab,
        ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id,
        ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality_tab,
        ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality,
        ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue_tab,
        ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue,
        __MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item_,
        _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions,
        MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR,
        MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_ExtIEs,
        Multi_Cell_Capability,
        _Multi_Cell_Capability_Info_multi_Cell_Capability,
        _Multi_Cell_Capability_Info_possible_Secondary_Serving_Cell_List,
        ____Multi_Cell_Capability_Info_iE_Extensions__item__id_tab,
        ___Multi_Cell_Capability_Info_iE_Extensions__item__id,
        ____Multi_Cell_Capability_Info_iE_Extensions__item__criticality_tab,
        ___Multi_Cell_Capability_Info_iE_Extensions__item__criticality,
        ____Multi_Cell_Capability_Info_iE_Extensions__item__extensionValue_tab,
        ___Multi_Cell_Capability_Info_iE_Extensions__item__extensionValue,
        __Multi_Cell_Capability_Info_iE_Extensions__item_,
        _Multi_Cell_Capability_Info_iE_Extensions,
        Multi_Cell_Capability_Info,
        Multi_Cell_Capability_Info_ExtIEs,
        __Multicell_EDCH_Information_id_tab,
        ___Multicell_EDCH_Information_id_tab_val_Value_0,
        _Multicell_EDCH_Information_id,
        _Multicell_EDCH_Information_criticality,
        _Multicell_EDCH_Information_value,
        Multicell_EDCH_Information,
        Multicell_EDCH_InformationItem,
        _Multicell_EDCH_InformationItem_val_Value_0,
        _Multicell_EDCH_InformationItemIEs_dL_PowerBalancing_Information,
        _Multicell_EDCH_InformationItemIEs_minimumReducedE_DPDCH_GainFactor,
        _Multicell_EDCH_InformationItemIEs_secondary_UL_Frequency_Activation_State,
        ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__id_tab,
        ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__id,
        ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__criticality_tab,
        ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__criticality,
        ____Multicell_EDCH_InformationItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Multicell_EDCH_InformationItemIEs_iE_Extensions__item__extensionValue,
        __Multicell_EDCH_InformationItemIEs_iE_Extensions__item_,
        _Multicell_EDCH_InformationItemIEs_iE_Extensions,
        Multicell_EDCH_InformationItemIEs,
        Multicell_EDCH_InformationItemIEs_ExtIEs,
        __Multicell_EDCH_RL_Specific_Information_id_tab,
        ___Multicell_EDCH_RL_Specific_Information_id_tab_val_Value_0,
        _Multicell_EDCH_RL_Specific_Information_id,
        _Multicell_EDCH_RL_Specific_Information_criticality,
        _Multicell_EDCH_RL_Specific_Information_value,
        Multicell_EDCH_RL_Specific_Information,
        Multicell_EDCH_RL_Specific_InformationItem,
        _Multicell_EDCH_RL_Specific_InformationItem_val_Value_0,
        _Multicell_EDCH_RL_Specific_InformationItemIEs_extendedPropagationDelay,
        _Multicell_EDCH_RL_Specific_InformationItemIEs_primary_CPICH_Usage_for_Channel_Estimation,
        _Multicell_EDCH_RL_Specific_InformationItemIEs_secondary_CPICH_Information,
        _Multicell_EDCH_RL_Specific_InformationItemIEs_secondary_CPICH_Information_Change,
        _Multicell_EDCH_RL_Specific_InformationItemIEs_e_AGCH_PowerOffset,
        _Multicell_EDCH_RL_Specific_InformationItemIEs_e_RGCH_PowerOffset,
        _Multicell_EDCH_RL_Specific_InformationItemIEs_e_HICH_PowerOffset,
        _Multicell_EDCH_RL_Specific_InformationItemIEs_dLReferencePower,
        _Multicell_EDCH_RL_Specific_InformationItemIEs_e_DCH_DL_Control_Channel_Grant,
        ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__id_tab,
        ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__id,
        ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__criticality_tab,
        ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__criticality,
        ____Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item__extensionValue,
        __Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions__item_,
        _Multicell_EDCH_RL_Specific_InformationItemIEs_iE_Extensions,
        Multicell_EDCH_RL_Specific_InformationItemIEs,
        Multicell_EDCH_RL_Specific_InformationItemIEs_ExtIEs,
        Multicell_EDCH_Restriction,
        MIMO_SFMode_For_HSPDSCHDualStream,
        _Multi_Carrier_EDCH_Info_multicarrier_EDCH_Transport_Bearer_Mode,
        _Multi_Carrier_EDCH_Info_multi_carrier_EDCH_Information,
        ____Multi_Carrier_EDCH_Info_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_Info_iE_Extensions__item_,
        _Multi_Carrier_EDCH_Info_iE_Extensions,
        Multi_Carrier_EDCH_Info,
        Multi_Carrier_EDCH_Info_ExtIEs,
        Multicarrier_EDCH_Transport_Bearer_Mode,
        _Dual_Cell_EDCH_Enhancements_Information_e_TTI,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_Reference_E_TFCI_Information,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Boost_Information,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_DPCCH_Power_Offset,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Table_Index,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_Power_Offset_for_SchedulingInfo,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_Max_Set_E_DPDCHs,
        ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id_tab,
        ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id,
        ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality_tab,
        ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality,
        ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue_tab,
        ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue,
        __Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item_,
        _Dual_Cell_EDCH_Enhancements_Information_iE_Extensions,
        Dual_Cell_EDCH_Enhancements_Information,
        Dual_Cell_EDCH_Enhancements_Information_ExtIEs,
        _HS_SCCH_DRX_InformationFDD_t333,
        _HS_SCCH_DRX_InformationFDD_hS_SCCH_DRX_Cycle_FACH,
        _HS_SCCH_DRX_InformationFDD_hS_SCCH_RX_Burst_FACH,
        ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__id_tab,
        ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__id,
        ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__criticality_tab,
        ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__criticality,
        ____HS_SCCH_DRX_InformationFDD_iE_Extensions__item__extensionValue_tab,
        ___HS_SCCH_DRX_InformationFDD_iE_Extensions__item__extensionValue,
        __HS_SCCH_DRX_InformationFDD_iE_Extensions__item_,
        _HS_SCCH_DRX_InformationFDD_iE_Extensions,
        HS_SCCH_DRX_InformationFDD,
        HS_SCCH_DRX_InformationFDD_ExtIEs,
        _Multi_Carrier_EDCH_Information__item_,
        Multi_Carrier_EDCH_Information,
        _Multi_Carrier_EDCH_LCR_InformationItem_uARFCN,
        _Multi_Carrier_EDCH_LCR_InformationItem_sNPL_carrier_group_indicator,
        _Multi_Carrier_EDCH_LCR_InformationItem_pRXdes_base,
        _Multi_Carrier_EDCH_LCR_InformationItem_multi_Carrier_EDCH_MACdFlows_Information_TDD,
        ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item_,
        _Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions,
        Multi_Carrier_EDCH_LCR_InformationItem,
        Multi_Carrier_EDCH_LCR_InformationItem_ExtIEs,
        SNPL_Carrier_Group_Indicator,
        _Multi_Carrier_EDCH_MACdFlows_Information_TDD__item_,
        Multi_Carrier_EDCH_MACdFlows_Information_TDD,
        _Multi_Carrier_EDCH_MACdFlows_Specific_Info_e_DCH_MACdFlow_ID,
        _Multi_Carrier_EDCH_MACdFlows_Specific_Info_bindingID,
        _Multi_Carrier_EDCH_MACdFlows_Specific_Info_transportLayerAddress,
        ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item_,
        _Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions,
        Multi_Carrier_EDCH_MACdFlows_Specific_Info,
        Multi_Carrier_EDCH_MACdFlows_Specific_Info_ExtIEs,
        _Multi_Carrier_EDCH_Reconfigure_continue_setup_change_Of_Multi_Carrier_EDCH,
        ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item_,
        _Multi_Carrier_EDCH_Reconfigure_iE_Extensions,
        Multi_Carrier_EDCH_Reconfigure,
        Multi_Carrier_EDCH_Reconfigure_ExtIEs,
        _Continue_Setup_Change_Multi_Carrier_EDCH_continue_,
        _Continue_Setup_Change_Multi_Carrier_EDCH_setup,
        _Continue_Setup_Change_Multi_Carrier_EDCH_change,
        Continue_Setup_Change_Multi_Carrier_EDCH,
        _Multi_Carrier_EDCH_Change_Info_multicarrier_EDCH_Transport_Bearer_Mode,
        _Multi_Carrier_EDCH_Change_Info_multi_carrier_EDCH_Information,
        _Multi_Carrier_EDCH_Change_Info_multi_Carrier_EDCH_Information_Removal_List,
        ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_Change_Info_iE_Extensions__item_,
        _Multi_Carrier_EDCH_Change_Info_iE_Extensions,
        Multi_Carrier_EDCH_Change_Info,
        Multi_Carrier_EDCH_Change_Info_ExtIEs,
        _Multi_Carrier_EDCH_Information_Removal_List__item_,
        Multi_Carrier_EDCH_Information_Removal_List,
        _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_uARFCN,
        ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item_,
        _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions,
        Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs,
        Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_ExtIEs,
        _Multi_Carrier_EDCH_Information_Response__item_,
        Multi_Carrier_EDCH_Information_Response,
        _Multi_Carrier_EDCH_LCR_Information_ResponseItem_uARFCN,
        _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_DCH_TDD_MACdFlow_Specific_InformationResp,
        _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_AGCH_Specific_Information_ResponseTDD,
        _Multi_Carrier_EDCH_LCR_Information_ResponseItem_scheduled_E_HICH_Specific_InformationResp,
        ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item_,
        _Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions,
        Multi_Carrier_EDCH_LCR_Information_ResponseItem,
        Multi_Carrier_EDCH_LCR_Information_ResponseItem_ExtIEs,
        _Multiflow_Reconfiguration_setup,
        _Multiflow_Reconfiguration_change,
        _Multiflow_Reconfiguration_stop,
        Multiflow_Reconfiguration,
        _Multiflow_Information_total_Number_of_HS_DSCH_Cells,
        _Multiflow_Information_role,
        _Multiflow_Information_mimo,
        _Multiflow_Information_timing,
        _Multiflow_Information_max_Number_of_HS_SCCH_Sets_per_NodeB,
        ____Multiflow_Information_iE_Extensions__item__id_tab,
        _____Multiflow_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___Multiflow_Information_iE_Extensions__item__id,
        ___Multiflow_Information_iE_Extensions__item__criticality,
        ___Multiflow_Information_iE_Extensions__item__extensionValue,
        __Multiflow_Information_iE_Extensions__item_,
        _Multiflow_Information_iE_Extensions,
        Multiflow_Information,
        _Multiflow_Information_To_Modify_total_Number_of_HS_DSCH_Cells,
        _Multiflow_Information_To_Modify_role,
        _Multiflow_Information_To_Modify_mimo,
        _Multiflow_Information_To_Modify_timing,
        _Multiflow_Information_To_Modify_max_Number_of_HS_SCCH_Sets_per_NodeB,
        ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab,
        _____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        ___Multiflow_Information_To_Modify_iE_Extensions__item__id,
        ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality,
        ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue,
        __Multiflow_Information_To_Modify_iE_Extensions__item_,
        _Multiflow_Information_To_Modify_iE_Extensions,
        Multiflow_Information_To_Modify,
        Multiflow_Information_ExtIEs,
        _Multiflow_Information_ExtIEs_val_Extension_0,
        Multiflow_Information_To_Modify_ExtIEs,
        _Multiflow_Information_To_Modify_ExtIEs_val_Extension_0,
        _Multiflow_RepetitionFactors_assisting_CQI_RepetitionFactor,
        _Multiflow_RepetitionFactors_assisting_AckNack_RepetitionFactor,
        ____Multiflow_RepetitionFactors_iE_Extensions__item__id_tab,
        ___Multiflow_RepetitionFactors_iE_Extensions__item__id,
        ____Multiflow_RepetitionFactors_iE_Extensions__item__criticality_tab,
        ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality,
        ____Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue_tab,
        ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue,
        __Multiflow_RepetitionFactors_iE_Extensions__item_,
        _Multiflow_RepetitionFactors_iE_Extensions,
        Multiflow_RepetitionFactors,
        Multiflow_RepetitionFactors_ExtIEs,
        Multiflow_Stop,
        Multiflow_Role,
        Multiflow_MIMO,
        _Multiflow_Timing_time_Reference,
        _Multiflow_Timing_non_Time_Reference,
        Multiflow_Timing,
        Multiflow_OrdinalNumberOfFrequency,
        MU_MIMO_Capability_ContainerLCR,
        _MU_MIMO_InformationLCR_mU_MIMO_IndicatorLCR,
        _MU_MIMO_InformationLCR_standalone_Midamble_Channel_Information_RequestLCR,
        _MU_MIMO_InformationLCR_standalone_Midamble_Channel_Information,
        ____MU_MIMO_InformationLCR_iE_Extensions__item__id_tab,
        ___MU_MIMO_InformationLCR_iE_Extensions__item__id,
        ____MU_MIMO_InformationLCR_iE_Extensions__item__criticality_tab,
        ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality,
        ____MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue,
        __MU_MIMO_InformationLCR_iE_Extensions__item_,
        _MU_MIMO_InformationLCR_iE_Extensions,
        MU_MIMO_InformationLCR,
        Standalone_Midamble_Channel_Information_RequestLCR,
        _Standalone_Midamble_Channel_Information_standalone_Midamble_Configuratnion,
        _Standalone_Midamble_Channel_Information_standalone_MidambleShift,
        _Standalone_Midamble_Channel_Information_timeslotLCR,
        _Standalone_Midamble_Channel_Information_repetitionPeriod,
        _Standalone_Midamble_Channel_Information_offset,
        _Standalone_Midamble_Channel_Information_referenceBeta,
        ____Standalone_Midamble_Channel_Information_iE_Extensions__item__id_tab,
        ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id,
        ____Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality_tab,
        ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality,
        ____Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue_tab,
        ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue,
        __Standalone_Midamble_Channel_Information_iE_Extensions__item_,
        _Standalone_Midamble_Channel_Information_iE_Extensions,
        Standalone_Midamble_Channel_Information,
        Standalone_Midamble_Configuratnion,
        Standalone_MidambleShift,
        Standalone_Midamble_RepetitionPeriod,
        Standalone_Midamble_Offset,
        ReferenceBeta,
        Standalone_Midamble_Channel_Information_ExtIEs,
        MU_MIMO_InformationLCR_ExtIEs,
        _MU_MIMO_Information_Response_mU_MIMO_Usage_IndicatorLCR,
        _MU_MIMO_Information_Response_standalone_Midamble_Channel_Information,
        ____MU_MIMO_Information_Response_iE_Extensions__item__id_tab,
        ___MU_MIMO_Information_Response_iE_Extensions__item__id,
        ____MU_MIMO_Information_Response_iE_Extensions__item__criticality_tab,
        ___MU_MIMO_Information_Response_iE_Extensions__item__criticality,
        ____MU_MIMO_Information_Response_iE_Extensions__item__extensionValue_tab,
        ___MU_MIMO_Information_Response_iE_Extensions__item__extensionValue,
        __MU_MIMO_Information_Response_iE_Extensions__item_,
        _MU_MIMO_Information_Response_iE_Extensions,
        MU_MIMO_Information_Response,
        MU_MIMO_Information_Response_ExtIEs,
        _MU_MIMO_Information_To_ReconfigureLCR_mU_MIMO_Information_To_Modify,
        _MU_MIMO_Information_To_ReconfigureLCR_mU_MIMO_Information_To_Continue,
        MU_MIMO_Information_To_ReconfigureLCR,
        _MU_MIMO_Information_To_Modify_mU_MIMO_IndicatorLCR,
        _MU_MIMO_Information_To_Modify_standalone_Midamble_Configuratnion,
        _MU_MIMO_Information_To_Modify_standalone_MidambleShift,
        _MU_MIMO_Information_To_Modify_timeslotLCR,
        _MU_MIMO_Information_To_Modify_repetitionPeriod,
        _MU_MIMO_Information_To_Modify_offset,
        _MU_MIMO_Information_To_Modify_referenceBeta,
        ____MU_MIMO_Information_To_Modify_iE_Extensions__item__id_tab,
        ___MU_MIMO_Information_To_Modify_iE_Extensions__item__id,
        ____MU_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab,
        ___MU_MIMO_Information_To_Modify_iE_Extensions__item__criticality,
        ____MU_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab,
        ___MU_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue,
        __MU_MIMO_Information_To_Modify_iE_Extensions__item_,
        _MU_MIMO_Information_To_Modify_iE_Extensions,
        MU_MIMO_Information_To_Modify,
        MU_MIMO_Information_To_Modify_ExtIEs,
        MU_MIMO_IndicatorLCR,
        MU_MIMO_Usage_IndicatorLCR,
        Nack_Power_Offset,
        NCyclesPerSFNperiod,
        NRepetitionsPerCyclePeriod,
        N_INSYNC_IND,
        N_OUTSYNC_IND,
        N_PROTECT,
        __NeighbouringCellMeasurementInformation__item__neighbouringFDDCellMeasurementInformation,
        __NeighbouringCellMeasurementInformation__item__neighbouringTDDCellMeasurementInformation,
        __NeighbouringCellMeasurementInformation__item__extension_neighbouringCellMeasurementInformation,
        _NeighbouringCellMeasurementInformation__item_,
        NeighbouringCellMeasurementInformation,
        _NodeB_Triggered_HSDPCCH_Transmission_Information_hS_DPCCH_transmission_continuation_backoff,
        ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__id_tab,
        ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__id,
        ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__criticality_tab,
        ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__criticality,
        ____NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__extensionValue_tab,
        ___NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item__extensionValue,
        __NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions__item_,
        _NodeB_Triggered_HSDPCCH_Transmission_Information_iE_Extensions,
        NodeB_Triggered_HSDPCCH_Transmission_Information,
        NodeB_Triggered_HSDPCCH_Transmission_Information_ExtIEs,
        __Extension_neighbouringCellMeasurementInformation_id_tab,
        ___Extension_neighbouringCellMeasurementInformation_id_tab_val_Value_0,
        ___Extension_neighbouringCellMeasurementInformation_id_tab_val_Value_1,
        _Extension_neighbouringCellMeasurementInformation_id,
        _Extension_neighbouringCellMeasurementInformation_criticality,
        _Extension_neighbouringCellMeasurementInformation_value,
        Extension_neighbouringCellMeasurementInformation,
        Extension_neighbouringCellMeasurementInformationIE,
        _Extension_neighbouringCellMeasurementInformationIE_val_Value_0,
        _Extension_neighbouringCellMeasurementInformationIE_val_Value_1,
        _NeighbouringFDDCellMeasurementInformation_uC_Id,
        _NeighbouringFDDCellMeasurementInformation_uARFCN,
        _NeighbouringFDDCellMeasurementInformation_primaryScramblingCode,
        ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id_tab,
        ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id,
        ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality_tab,
        ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality,
        ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab,
        ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue,
        __NeighbouringFDDCellMeasurementInformation_iE_Extensions__item_,
        _NeighbouringFDDCellMeasurementInformation_iE_Extensions,
        NeighbouringFDDCellMeasurementInformation,
        NeighbouringFDDCellMeasurementInformationItem_ExtIEs,
        _NeighbouringTDDCellMeasurementInformation_uC_Id,
        _NeighbouringTDDCellMeasurementInformation_uARFCN,
        _NeighbouringTDDCellMeasurementInformation_cellParameterID,
        _NeighbouringTDDCellMeasurementInformation_timeSlot,
        _NeighbouringTDDCellMeasurementInformation_midambleShiftAndBurstType,
        ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id_tab,
        ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id,
        ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality_tab,
        ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality,
        ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab,
        ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue,
        __NeighbouringTDDCellMeasurementInformation_iE_Extensions__item_,
        _NeighbouringTDDCellMeasurementInformation_iE_Extensions,
        NeighbouringTDDCellMeasurementInformation,
        NeighbouringTDDCellMeasurementInformationItem_ExtIEs,
        _NeighbouringTDDCellMeasurementInformationLCR_uC_Id,
        _NeighbouringTDDCellMeasurementInformationLCR_uARFCN,
        _NeighbouringTDDCellMeasurementInformationLCR_cellParameterID,
        _NeighbouringTDDCellMeasurementInformationLCR_timeSlotLCR,
        _NeighbouringTDDCellMeasurementInformationLCR_midambleShiftLCR,
        ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id_tab,
        ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id,
        ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality_tab,
        ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality,
        ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue_tab,
        ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue,
        __NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item_,
        _NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions,
        NeighbouringTDDCellMeasurementInformationLCR,
        NeighbouringTDDCellMeasurementInformationLCRItem_ExtIEs,
        _NeighbouringTDDCellMeasurementInformation768_uC_Id,
        _NeighbouringTDDCellMeasurementInformation768_uARFCN,
        _NeighbouringTDDCellMeasurementInformation768_cellParameterID,
        _NeighbouringTDDCellMeasurementInformation768_timeSlot,
        _NeighbouringTDDCellMeasurementInformation768_midambleShiftAndBurstType768,
        ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id_tab,
        ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id,
        ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality_tab,
        ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality,
        ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue_tab,
        ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue,
        __NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item_,
        _NeighbouringTDDCellMeasurementInformation768_iE_Extensions,
        NeighbouringTDDCellMeasurementInformation768,
        NeighbouringTDDCellMeasurementInformation768Item_ExtIEs,
        Non_rectangular_resource_allocation_indicator,
        Non_rectangular_resource_timeslot_set,
        NonCellSpecificTxDiversity,
        _Non_Serving_RL_Preconfig_Setup_new_non_serving_RL_selection,
        ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab,
        _____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab_val_Extension_0,
        ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id,
        ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality,
        ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue,
        __Non_Serving_RL_Preconfig_Setup_iE_Extensions__item_,
        _Non_Serving_RL_Preconfig_Setup_iE_Extensions,
        Non_Serving_RL_Preconfig_Setup,
        Non_Serving_RL_Preconfig_Setup_ExtIEs,
        _Non_Serving_RL_Preconfig_Setup_ExtIEs_val_Extension_0,
        Additional_E_DCH_Non_Serving_RL_Preconfiguration_Setup,
        _New_non_serving_RL_setup_selection_new_Serving_RL_in_NodeB,
        _New_non_serving_RL_setup_selection_new_Serving_RL_Not_in_NodeB,
        _New_non_serving_RL_setup_selection_new_Serving_RL_in_or_Not_in_NodeB,
        New_non_serving_RL_setup_selection,
        _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_A,
        _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_B,
        _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_C,
        ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab,
        _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_1,
        ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id,
        ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality,
        ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue,
        __Non_Serving_RL_Preconfig_Info_iE_Extensions__item_,
        _Non_Serving_RL_Preconfig_Info_iE_Extensions,
        Non_Serving_RL_Preconfig_Info,
        Non_Serving_RL_Preconfig_Info_ExtIEs,
        _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_0,
        _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_1,
        __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_A,
        __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_B,
        __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_C,
        _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id_tab,
        ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id,
        _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality_tab,
        ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality,
        _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue_tab,
        ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue,
        ___Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item_,
        __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions,
        _Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item_,
        Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList,
        Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList_ExtIEs,
        _NI_Information__item_,
        NI_Information,
        Notification_Indicator,
        NodeB_CommunicationContextID,
        ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__id_tab,
        ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__id,
        ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__criticality_tab,
        ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__criticality,
        ____NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__extensionValue_tab,
        ___NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item__extensionValue,
        __NormalAndDiversityPrimaryCPICHContainer_iE_Extensions__item_,
        _NormalAndDiversityPrimaryCPICHContainer_iE_Extensions,
        NormalAndDiversityPrimaryCPICHContainer,
        NormalAndDiversityPrimaryCPICHContainer_ExtIEs,
        NotificationIndicatorLength,
        NumberOfReportedCellPortions,
        NumberOfReportedCellPortionsLCR,
        Number_of_PCCH_transmission,
        NSubCyclesPerCyclePeriod,
        N_E_UCCH,
        N_E_UCCHLCR,
        Number_Of_Supported_Carriers,
        NumHS_SCCH_Codes,
        NoOfTargetCellHS_SCCH_Order,
        OrdinalNumberOfFrequency,
        Out_of_Sychronization_Window,
        _One_level_DRX_hS_DSCH_second_Rx_burst_FACH,
        _One_level_DRX_t32y,
        ____One_level_DRX_iE_Extensions__item__id_tab,
        ___One_level_DRX_iE_Extensions__item__id,
        ____One_level_DRX_iE_Extensions__item__criticality_tab,
        ___One_level_DRX_iE_Extensions__item__criticality,
        ____One_level_DRX_iE_Extensions__item__extensionValue_tab,
        ___One_level_DRX_iE_Extensions__item__extensionValue,
        __One_level_DRX_iE_Extensions__item_,
        _One_level_DRX_iE_Extensions,
        One_level_DRX,
        One_level_DRX_ExtIEs,
        PagingIndicatorLength,
        Paging_MACFlow_ID,
        PayloadCRC_PresenceIndicator,
        PCCPCH_Power,
        PDSCH_ID,
        PDSCH_ID768,
        PDSCHSet_ID,
        PICH_Mode,
        PICH_Power,
        _Paging_MACFlows_to_DeleteFDD__item_,
        Paging_MACFlows_to_DeleteFDD,
        _Paging_MACFlows_to_DeleteFDD_Item_paging_MACFlow_ID,
        ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id_tab,
        ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__id,
        ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality_tab,
        ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__criticality,
        ____Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue_tab,
        ___Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item__extensionValue,
        __Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions__item_,
        _Paging_MACFlows_to_DeleteFDD_Item_iE_Extensions,
        Paging_MACFlows_to_DeleteFDD_Item,
        Paging_MACFlows_to_DeleteFDD_Item_ExtIEs,
        _Paging_MACFlow_Specific_Information__item_,
        Paging_MACFlow_Specific_Information,
        _Paging_MAC_Flow_Specific_Information_Item_paging_MACFlow_Id,
        _Paging_MAC_Flow_Specific_Information_Item_hSDPA_associated_PICH_Info,
        _Paging_MAC_Flow_Specific_Information_Item_bindingID,
        _Paging_MAC_Flow_Specific_Information_Item_transportLayerAddress,
        _Paging_MAC_Flow_Specific_Information_Item_tnl_qos,
        _Paging_MAC_Flow_Specific_Information_Item_toAWS,
        _Paging_MAC_Flow_Specific_Information_Item_toAWE,
        _Paging_MAC_Flow_Specific_Information_Item_paging_MACFlow_PriorityQueue_Information,
        ____Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id_tab,
        _____Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__id,
        ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__criticality,
        ___Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item__extensionValue,
        __Paging_MAC_Flow_Specific_Information_Item_iE_Extensions__item_,
        _Paging_MAC_Flow_Specific_Information_Item_iE_Extensions,
        Paging_MAC_Flow_Specific_Information_Item,
        Paging_MAC_Flow_Specific_Information_Item_ExtIEs,
        _Paging_MAC_Flow_Specific_Information_Item_ExtIEs_val_Extension_0,
        _Paging_MACFlow_PriorityQueue_Information__item_,
        Paging_MACFlow_PriorityQueue_Information,
        _Paging_MACFlow_PriorityQueue_Item_priority_Queue_Information_for_Enhanced_PCH,
        ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__id_tab,
        ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__id,
        ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality_tab,
        ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__criticality,
        ____Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue_tab,
        ___Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item__extensionValue,
        __Paging_MACFlow_PriorityQueue_Item_iE_Extensions__item_,
        _Paging_MACFlow_PriorityQueue_Item_iE_Extensions,
        Paging_MACFlow_PriorityQueue_Item,
        Paging_MACFlow_PriorityQueue_Item_ExtIEs,
        Pattern_Sequence_Identifier,
        PhysicalChannelID_for_CommonERNTI_RequestedIndicator,
        PLCCHsequenceNumber,
        _PLCCHinformation_commonPhysicalChannelID,
        _PLCCHinformation_sequenceNumber,
        ____PLCCHinformation_iE_Extensions__item__id_tab,
        ___PLCCHinformation_iE_Extensions__item__id,
        ____PLCCHinformation_iE_Extensions__item__criticality_tab,
        ___PLCCHinformation_iE_Extensions__item__criticality,
        ____PLCCHinformation_iE_Extensions__item__extensionValue_tab,
        ___PLCCHinformation_iE_Extensions__item__extensionValue,
        __PLCCHinformation_iE_Extensions__item_,
        _PLCCHinformation_iE_Extensions,
        PLCCHinformation,
        PLCCHinformation_ExtIEs,
        _Possible_Secondary_Serving_Cell_List__item_,
        Possible_Secondary_Serving_Cell_List,
        _Possible_Secondary_Serving_Cell_local_Cell_ID,
        ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab,
        _____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab_val_Extension_0,
        ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id,
        ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality,
        ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue,
        __Possible_Secondary_Serving_Cell_iE_Extensions__item_,
        _Possible_Secondary_Serving_Cell_iE_Extensions,
        Possible_Secondary_Serving_Cell,
        Possible_Secondary_Serving_Cell_ExtIEs,
        _Possible_Secondary_Serving_Cell_ExtIEs_val_Extension_0,
        PowerAdjustmentType,
        PowerOffset,
        PowerOffsetForSecondaryCPICHforMIMO,
        PowerRaiseLimit,
        PRACH_Midamble,
        PRC,
        PRCDeviation,
        PrecodingWeightSetRestriction,
        Precoder_Weight_Set_Restriction,
        PreambleSignatures,
        PreambleThreshold,
        PredictedSFNSFNDeviationLimit,
        PredictedTUTRANGPSDeviationLimit,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        _PrimaryAndSecondaryCPICHContainer_power_Offset_For_Secondary_CPICH_for_MIMO,
        ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__id_tab,
        ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__id,
        ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__criticality_tab,
        ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__criticality,
        ____PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__extensionValue_tab,
        ___PrimaryAndSecondaryCPICHContainer_iE_Extensions__item__extensionValue,
        __PrimaryAndSecondaryCPICHContainer_iE_Extensions__item_,
        _PrimaryAndSecondaryCPICHContainer_iE_Extensions,
        PrimaryAndSecondaryCPICHContainer,
        PrimaryAndSecondaryCPICHContainer_ExtIEs,
        PrimaryCPICH_Power,
        Primary_CPICH_Usage_for_Channel_Estimation,
        PrimaryScramblingCode,
        PriorityLevel,
        _Priority_Queue_Information_for_Enhanced_FACH_PCH_priorityQueue_Id,
        _Priority_Queue_Information_for_Enhanced_FACH_PCH_schedulingPriorityIndicator,
        _Priority_Queue_Information_for_Enhanced_FACH_PCH_t1,
        _Priority_Queue_Information_for_Enhanced_FACH_PCH_mAC_ehs_Reset_Timer,
        _Priority_Queue_Information_for_Enhanced_FACH_PCH_discardTimer,
        _Priority_Queue_Information_for_Enhanced_FACH_PCH_mAC_hsWindowSize,
        _Priority_Queue_Information_for_Enhanced_FACH_PCH_maximum_MACcPDU_Size,
        ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__id_tab,
        ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__id,
        ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__criticality_tab,
        ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__criticality,
        ____Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__extensionValue_tab,
        ___Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item__extensionValue,
        __Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions__item_,
        _Priority_Queue_Information_for_Enhanced_FACH_PCH_iE_Extensions,
        Priority_Queue_Information_for_Enhanced_FACH_PCH,
        Priority_Queue_Information_for_Enhanced_FACH_PCH_ExtIEs,
        PriorityQueue_Id,
        _PriorityQueue_InfoList__item_,
        PriorityQueue_InfoList,
        _PriorityQueue_InfoItem_priorityQueueId,
        _PriorityQueue_InfoItem_associatedHSDSCH_MACdFlow,
        _PriorityQueue_InfoItem_schedulingPriorityIndicator,
        _PriorityQueue_InfoItem_t1,
        _PriorityQueue_InfoItem_discardTimer,
        _PriorityQueue_InfoItem_mAC_hsWindowSize,
        _PriorityQueue_InfoItem_mAChsGuaranteedBitRate,
        _PriorityQueue_InfoItem_macdPDU_Size_Index,
        _PriorityQueue_InfoItem_rLC_Mode,
        ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab,
        _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___PriorityQueue_InfoItem_iE_Extensions__item__id,
        ___PriorityQueue_InfoItem_iE_Extensions__item__criticality,
        ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue,
        __PriorityQueue_InfoItem_iE_Extensions__item_,
        _PriorityQueue_InfoItem_iE_Extensions,
        PriorityQueue_InfoItem,
        PriorityQueue_InfoItem_ExtIEs,
        _PriorityQueue_InfoItem_ExtIEs_val_Extension_0,
        _PriorityQueue_InfoItem_ExtIEs_val_Extension_1,
        _PriorityQueue_InfoItem_ExtIEs_val_Extension_2,
        _PriorityQueue_InfoList_to_Modify__item_,
        PriorityQueue_InfoList_to_Modify,
        _PriorityQueue_InfoItem_to_Add_priorityQueueId,
        _PriorityQueue_InfoItem_to_Add_associatedHSDSCH_MACdFlow,
        _PriorityQueue_InfoItem_to_Add_schedulingPriorityIndicator,
        _PriorityQueue_InfoItem_to_Add_t1,
        _PriorityQueue_InfoItem_to_Add_discardTimer,
        _PriorityQueue_InfoItem_to_Add_mAC_hsWindowSize,
        _PriorityQueue_InfoItem_to_Add_mAChsGuaranteedBitRate,
        _PriorityQueue_InfoItem_to_Add_macdPDU_Size_Index,
        _PriorityQueue_InfoItem_to_Add_rLC_Mode,
        ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab,
        _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_0,
        _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_1,
        ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id,
        ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality,
        ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue,
        __PriorityQueue_InfoItem_to_Add_iE_Extensions__item_,
        _PriorityQueue_InfoItem_to_Add_iE_Extensions,
        PriorityQueue_InfoItem_to_Add,
        PriorityQueue_InfoItem_to_Add_ExtIEs,
        _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_0,
        _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_1,
        _PriorityQueue_InfoItem_to_Modify_priorityQueueId,
        _PriorityQueue_InfoItem_to_Modify_schedulingPriorityIndicator,
        _PriorityQueue_InfoItem_to_Modify_t1,
        _PriorityQueue_InfoItem_to_Modify_discardTimer,
        _PriorityQueue_InfoItem_to_Modify_mAC_hsWindowSize,
        _PriorityQueue_InfoItem_to_Modify_mAChsGuaranteedBitRate,
        _PriorityQueue_InfoItem_to_Modify_macdPDU_Size_Index_to_Modify,
        ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab,
        _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_1,
        ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id,
        ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality,
        ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue,
        __PriorityQueue_InfoItem_to_Modify_iE_Extensions__item_,
        _PriorityQueue_InfoItem_to_Modify_iE_Extensions,
        PriorityQueue_InfoItem_to_Modify,
        PriorityQueue_InfoItem_to_Modify_ExtIEs,
        _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_0,
        _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_1,
        _PriorityQueue_InfoList_to_Modify_Unsynchronised__item_,
        PriorityQueue_InfoList_to_Modify_Unsynchronised,
        _PriorityQueue_InfoItem_to_Modify_Unsynchronised_priorityQueueId,
        _PriorityQueue_InfoItem_to_Modify_Unsynchronised_schedulingPriorityIndicator,
        _PriorityQueue_InfoItem_to_Modify_Unsynchronised_discardTimer,
        _PriorityQueue_InfoItem_to_Modify_Unsynchronised_mAChsGuaranteedBitRate,
        ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id_tab,
        ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id,
        ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality_tab,
        ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality,
        ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue_tab,
        ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue,
        __PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item_,
        _PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions,
        PriorityQueue_InfoItem_to_Modify_Unsynchronised,
        PriorityQueue_InfoItem_to_Modify_Unsynchronised_ExtIEs,
        PrimaryCCPCH_RSCP,
        PrimaryCCPCH_RSCP_Delta,
        PropagationDelay,
        PRXdes_base,
        SCH_TimeSlot,
        PunctureLimit,
        PUSCH_ID,
        _UE_Selected_MBMS_Service_Information_none,
        _UE_Selected_MBMS_Service_Information_selected_MBMS_Service,
        UE_Selected_MBMS_Service_Information,
        _Selected_MBMS_Service_selected_MBMS_Service_List,
        ____Selected_MBMS_Service_iE_Extensions__item__id_tab,
        ___Selected_MBMS_Service_iE_Extensions__item__id,
        ____Selected_MBMS_Service_iE_Extensions__item__criticality_tab,
        ___Selected_MBMS_Service_iE_Extensions__item__criticality,
        ____Selected_MBMS_Service_iE_Extensions__item__extensionValue_tab,
        ___Selected_MBMS_Service_iE_Extensions__item__extensionValue,
        __Selected_MBMS_Service_iE_Extensions__item_,
        _Selected_MBMS_Service_iE_Extensions,
        Selected_MBMS_Service,
        Selected_MBMS_Service_ExtIEs,
        _Selected_MBMS_Service_List__item_,
        Selected_MBMS_Service_List,
        _Selected_MBMS_Service_Item_selected_MBMS_Service_TimeSlot_Information_LCR,
        _Selected_MBMS_Service_Item_mBMS_Service_TDM_Information,
        ____Selected_MBMS_Service_Item_iE_Extensions__item__id_tab,
        ___Selected_MBMS_Service_Item_iE_Extensions__item__id,
        ____Selected_MBMS_Service_Item_iE_Extensions__item__criticality_tab,
        ___Selected_MBMS_Service_Item_iE_Extensions__item__criticality,
        ____Selected_MBMS_Service_Item_iE_Extensions__item__extensionValue_tab,
        ___Selected_MBMS_Service_Item_iE_Extensions__item__extensionValue,
        __Selected_MBMS_Service_Item_iE_Extensions__item_,
        _Selected_MBMS_Service_Item_iE_Extensions,
        Selected_MBMS_Service_Item,
        Selected_MBMS_Service_Item_ExtIEs,
        _Selected_MBMS_Service_TimeSlot_Information_LCR__item_,
        Selected_MBMS_Service_TimeSlot_Information_LCR,
        _MBMS_Service_TDM_Information_transmission_Time_Interval,
        _MBMS_Service_TDM_Information_tDM_Rep,
        _MBMS_Service_TDM_Information_tDM_Offset,
        _MBMS_Service_TDM_Information_tDM_Length,
        ____MBMS_Service_TDM_Information_iE_Extensions__item__id_tab,
        ___MBMS_Service_TDM_Information_iE_Extensions__item__id,
        ____MBMS_Service_TDM_Information_iE_Extensions__item__criticality_tab,
        ___MBMS_Service_TDM_Information_iE_Extensions__item__criticality,
        ____MBMS_Service_TDM_Information_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Service_TDM_Information_iE_Extensions__item__extensionValue,
        __MBMS_Service_TDM_Information_iE_Extensions__item_,
        _MBMS_Service_TDM_Information_iE_Extensions,
        MBMS_Service_TDM_Information,
        MBMS_Service_TDM_Information_ExtIEs,
        PUSCHSet_ID,
        _Paging_MACFlow_Specific_InformationLCR__item_,
        Paging_MACFlow_Specific_InformationLCR,
        _Paging_MAC_Flow_Specific_Information_ItemLCR_paging_MACFlow_Id,
        _Paging_MAC_Flow_Specific_Information_ItemLCR_hSDPA_associated_PICH_InfoLCR,
        _Paging_MAC_Flow_Specific_Information_ItemLCR_bindingID,
        _Paging_MAC_Flow_Specific_Information_ItemLCR_transportLayerAddress,
        _Paging_MAC_Flow_Specific_Information_ItemLCR_tnl_qos,
        _Paging_MAC_Flow_Specific_Information_ItemLCR_toAWS,
        _Paging_MAC_Flow_Specific_Information_ItemLCR_toAWE,
        _Paging_MAC_Flow_Specific_Information_ItemLCR_paging_MACFlow_PriorityQueue_InformationLCR,
        _Paging_MAC_Flow_Specific_Information_ItemLCR_transportBearerRequestIndicator,
        ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__id_tab,
        ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__id,
        ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__criticality_tab,
        ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__criticality,
        ____Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__extensionValue_tab,
        ___Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item__extensionValue,
        __Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions__item_,
        _Paging_MAC_Flow_Specific_Information_ItemLCR_iE_Extensions,
        Paging_MAC_Flow_Specific_Information_ItemLCR,
        Paging_MAC_Flow_Specific_Information_ItemLCR_ExtIEs,
        _Paging_MACFlows_to_DeleteLCR__item_,
        Paging_MACFlows_to_DeleteLCR,
        _Paging_MACFlows_to_DeleteLCR_Item_paging_MACFlow_ID,
        ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id_tab,
        ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__id,
        ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality_tab,
        ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__criticality,
        ____Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue_tab,
        ___Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item__extensionValue,
        __Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions__item_,
        _Paging_MACFlows_to_DeleteLCR_Item_iE_Extensions,
        Paging_MACFlows_to_DeleteLCR_Item,
        Paging_MACFlows_to_DeleteLCR_Item_ExtIEs,
        Process_Memory_Size,
        _Per_HARQ_Activiation_and_Deactiviation_configuration_for_2msTTI_Common_E_DCH_ResourcesList,
        ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__id_tab,
        ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__id,
        ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__criticality_tab,
        ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__criticality,
        ____Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__extensionValue_tab,
        ___Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item__extensionValue,
        __Per_HARQ_Activiation_and_Deactiviation_iE_Extensions__item_,
        _Per_HARQ_Activiation_and_Deactiviation_iE_Extensions,
        Per_HARQ_Activiation_and_Deactiviation,
        Per_HARQ_Activiation_and_Deactiviation_ExtIEs,
        QE_Selector,
        RACH_Measurement_Result,
        RACH_SlotFormat,
        RACH_SubChannelNumbers,
        _RL_Specific_DCH_Info__item_,
        RL_Specific_DCH_Info,
        _RL_Specific_DCH_Info_Item_dCH_id,
        _RL_Specific_DCH_Info_Item_bindingID,
        _RL_Specific_DCH_Info_Item_transportlayeraddress,
        ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab,
        _____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id,
        ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality,
        ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue,
        __RL_Specific_DCH_Info_Item_iE_Extensions__item_,
        _RL_Specific_DCH_Info_Item_iE_Extensions,
        RL_Specific_DCH_Info_Item,
        RL_Specific_DCH_Info_Item_ExtIEs,
        _RL_Specific_DCH_Info_Item_ExtIEs_val_Extension_0,
        _RL_Specific_E_DCH_Info_rL_Specific_E_DCH_Information,
        _RL_Specific_E_DCH_Info_e_AGCH_PowerOffset,
        _RL_Specific_E_DCH_Info_e_RGCH_PowerOffset,
        _RL_Specific_E_DCH_Info_e_HICH_PowerOffset,
        ____RL_Specific_E_DCH_Info_iE_Extensions__item__id_tab,
        ___RL_Specific_E_DCH_Info_iE_Extensions__item__id,
        ____RL_Specific_E_DCH_Info_iE_Extensions__item__criticality_tab,
        ___RL_Specific_E_DCH_Info_iE_Extensions__item__criticality,
        ____RL_Specific_E_DCH_Info_iE_Extensions__item__extensionValue_tab,
        ___RL_Specific_E_DCH_Info_iE_Extensions__item__extensionValue,
        __RL_Specific_E_DCH_Info_iE_Extensions__item_,
        _RL_Specific_E_DCH_Info_iE_Extensions,
        RL_Specific_E_DCH_Info,
        RL_Specific_E_DCH_Info_Item_ExtIEs,
        _RL_Specific_E_DCH_Information__item_,
        RL_Specific_E_DCH_Information,
        _RL_Specific_E_DCH_Information_Item_e_DCH_MACdFlow_ID,
        _RL_Specific_E_DCH_Information_Item_bindingID,
        _RL_Specific_E_DCH_Information_Item_transportlayeraddress,
        ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__id_tab,
        ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__id,
        ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__criticality_tab,
        ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__criticality,
        ____RL_Specific_E_DCH_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___RL_Specific_E_DCH_Information_Item_iE_Extensions__item__extensionValue,
        __RL_Specific_E_DCH_Information_Item_iE_Extensions__item_,
        _RL_Specific_E_DCH_Information_Item_iE_Extensions,
        RL_Specific_E_DCH_Information_Item,
        RL_Specific_E_DCH_Information_Item_ExtIEs,
        Range_Correction_Rate,
        Reference_ReceivedTotalWideBandPower,
        Reference_ReceivedTotalWideBandPowerReporting,
        Reference_ReceivedTotalWideBandPowerSupportIndicator,
        ReferenceClockAvailability,
        ReferenceSFNoffset,
        _Reference_E_TFCI_Information__item_,
        Reference_E_TFCI_Information,
        _Reference_E_TFCI_Information_Item_reference_E_TFCI,
        _Reference_E_TFCI_Information_Item_reference_E_TFCI_PO,
        ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab,
        _____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id,
        ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality,
        ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue,
        __Reference_E_TFCI_Information_Item_iE_Extensions__item_,
        _Reference_E_TFCI_Information_Item_iE_Extensions,
        Reference_E_TFCI_Information_Item,
        Reference_E_TFCI_Information_Item_ExtIEs,
        _Reference_E_TFCI_Information_Item_ExtIEs_val_Extension_0,
        Reference_E_TFCI_PO,
        RepetitionLength,
        RepetitionPeriod,
        RepetitionNumber0,
        RepetitionNumber1,
        RefTFCNumber,
        _ReportCharacteristics_onDemand,
        _ReportCharacteristics_periodic,
        _ReportCharacteristics_event_a,
        _ReportCharacteristics_event_b,
        _ReportCharacteristics_event_c,
        _ReportCharacteristics_event_d,
        _ReportCharacteristics_event_e,
        _ReportCharacteristics_event_f,
        _ReportCharacteristics_extension_ReportCharacteristics,
        ReportCharacteristics,
        __Extension_ReportCharacteristics_id_tab,
        ___Extension_ReportCharacteristics_id_tab_val_Value_0,
        _Extension_ReportCharacteristics_id,
        _Extension_ReportCharacteristics_criticality,
        _Extension_ReportCharacteristics_value,
        Extension_ReportCharacteristics,
        Extension_ReportCharacteristicsIE,
        _Extension_ReportCharacteristicsIE_val_Value_0,
        _ReportCharacteristicsType_EventA_measurementThreshold,
        _ReportCharacteristicsType_EventA_measurementHysteresisTime,
        ____ReportCharacteristicsType_EventA_iE_Extensions__item__id_tab,
        ___ReportCharacteristicsType_EventA_iE_Extensions__item__id,
        ____ReportCharacteristicsType_EventA_iE_Extensions__item__criticality_tab,
        ___ReportCharacteristicsType_EventA_iE_Extensions__item__criticality,
        ____ReportCharacteristicsType_EventA_iE_Extensions__item__extensionValue_tab,
        ___ReportCharacteristicsType_EventA_iE_Extensions__item__extensionValue,
        __ReportCharacteristicsType_EventA_iE_Extensions__item_,
        _ReportCharacteristicsType_EventA_iE_Extensions,
        ReportCharacteristicsType_EventA,
        ReportCharacteristicsType_EventA_ExtIEs,
        _ReportCharacteristicsType_EventB_measurementThreshold,
        _ReportCharacteristicsType_EventB_measurementHysteresisTime,
        ____ReportCharacteristicsType_EventB_iE_Extensions__item__id_tab,
        ___ReportCharacteristicsType_EventB_iE_Extensions__item__id,
        ____ReportCharacteristicsType_EventB_iE_Extensions__item__criticality_tab,
        ___ReportCharacteristicsType_EventB_iE_Extensions__item__criticality,
        ____ReportCharacteristicsType_EventB_iE_Extensions__item__extensionValue_tab,
        ___ReportCharacteristicsType_EventB_iE_Extensions__item__extensionValue,
        __ReportCharacteristicsType_EventB_iE_Extensions__item_,
        _ReportCharacteristicsType_EventB_iE_Extensions,
        ReportCharacteristicsType_EventB,
        ReportCharacteristicsType_EventB_ExtIEs,
        _ReportCharacteristicsType_EventC_measurementIncreaseThreshold,
        _ReportCharacteristicsType_EventC_measurementChangeTime,
        ____ReportCharacteristicsType_EventC_iE_Extensions__item__id_tab,
        ___ReportCharacteristicsType_EventC_iE_Extensions__item__id,
        ____ReportCharacteristicsType_EventC_iE_Extensions__item__criticality_tab,
        ___ReportCharacteristicsType_EventC_iE_Extensions__item__criticality,
        ____ReportCharacteristicsType_EventC_iE_Extensions__item__extensionValue_tab,
        ___ReportCharacteristicsType_EventC_iE_Extensions__item__extensionValue,
        __ReportCharacteristicsType_EventC_iE_Extensions__item_,
        _ReportCharacteristicsType_EventC_iE_Extensions,
        ReportCharacteristicsType_EventC,
        ReportCharacteristicsType_EventC_ExtIEs,
        _ReportCharacteristicsType_EventD_measurementDecreaseThreshold,
        _ReportCharacteristicsType_EventD_measurementChangeTime,
        ____ReportCharacteristicsType_EventD_iE_Extensions__item__id_tab,
        ___ReportCharacteristicsType_EventD_iE_Extensions__item__id,
        ____ReportCharacteristicsType_EventD_iE_Extensions__item__criticality_tab,
        ___ReportCharacteristicsType_EventD_iE_Extensions__item__criticality,
        ____ReportCharacteristicsType_EventD_iE_Extensions__item__extensionValue_tab,
        ___ReportCharacteristicsType_EventD_iE_Extensions__item__extensionValue,
        __ReportCharacteristicsType_EventD_iE_Extensions__item_,
        _ReportCharacteristicsType_EventD_iE_Extensions,
        ReportCharacteristicsType_EventD,
        ReportCharacteristicsType_EventD_ExtIEs,
        _ReportCharacteristicsType_EventE_measurementThreshold1,
        _ReportCharacteristicsType_EventE_measurementThreshold2,
        _ReportCharacteristicsType_EventE_measurementHysteresisTime,
        _ReportCharacteristicsType_EventE_reportPeriodicity,
        ____ReportCharacteristicsType_EventE_iE_Extensions__item__id_tab,
        ___ReportCharacteristicsType_EventE_iE_Extensions__item__id,
        ____ReportCharacteristicsType_EventE_iE_Extensions__item__criticality_tab,
        ___ReportCharacteristicsType_EventE_iE_Extensions__item__criticality,
        ____ReportCharacteristicsType_EventE_iE_Extensions__item__extensionValue_tab,
        ___ReportCharacteristicsType_EventE_iE_Extensions__item__extensionValue,
        __ReportCharacteristicsType_EventE_iE_Extensions__item_,
        _ReportCharacteristicsType_EventE_iE_Extensions,
        ReportCharacteristicsType_EventE,
        ReportCharacteristicsType_EventE_ExtIEs,
        _ReportCharacteristicsType_EventF_measurementThreshold1,
        _ReportCharacteristicsType_EventF_measurementThreshold2,
        _ReportCharacteristicsType_EventF_measurementHysteresisTime,
        _ReportCharacteristicsType_EventF_reportPeriodicity,
        ____ReportCharacteristicsType_EventF_iE_Extensions__item__id_tab,
        ___ReportCharacteristicsType_EventF_iE_Extensions__item__id,
        ____ReportCharacteristicsType_EventF_iE_Extensions__item__criticality_tab,
        ___ReportCharacteristicsType_EventF_iE_Extensions__item__criticality,
        ____ReportCharacteristicsType_EventF_iE_Extensions__item__extensionValue_tab,
        ___ReportCharacteristicsType_EventF_iE_Extensions__item__extensionValue,
        __ReportCharacteristicsType_EventF_iE_Extensions__item_,
        _ReportCharacteristicsType_EventF_iE_Extensions,
        ReportCharacteristicsType_EventF,
        ReportCharacteristicsType_EventF_ExtIEs,
        _ReportCharacteristicsType_OnModification_measurementThreshold,
        ____ReportCharacteristicsType_OnModification_iE_Extensions__item__id_tab,
        ___ReportCharacteristicsType_OnModification_iE_Extensions__item__id,
        ____ReportCharacteristicsType_OnModification_iE_Extensions__item__criticality_tab,
        ___ReportCharacteristicsType_OnModification_iE_Extensions__item__criticality,
        ____ReportCharacteristicsType_OnModification_iE_Extensions__item__extensionValue_tab,
        ___ReportCharacteristicsType_OnModification_iE_Extensions__item__extensionValue,
        __ReportCharacteristicsType_OnModification_iE_Extensions__item_,
        _ReportCharacteristicsType_OnModification_iE_Extensions,
        ReportCharacteristicsType_OnModification,
        ReportCharacteristicsType_OnModification_ExtIEs,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_received_total_wide_band_power,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_transmitted_carrier_power,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_acknowledged_prach_preambles,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_uL_TimeslotISCP,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_sir,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_sir_error,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_transmitted_code_power,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_rscp,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_round_trip_time,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_notUsed_1_acknowledged_PCPCH_access_preambles,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_notUsed_2_detected_PCPCH_access_preambles,
        _ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold,
        ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold,
        __Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab,
        ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_0,
        ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_1,
        ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_2,
        ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_3,
        ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_4,
        ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_5,
        ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_6,
        ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_7,
        ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_8,
        ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_9,
        ___Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_10,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_id,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_criticality,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold_value,
        Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThreshold,
        Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_0,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_1,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_2,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_3,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_4,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_5,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_6,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_7,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_8,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_9,
        _Extension_ReportCharacteristicsType_MeasurementIncreaseDecreaseThresholdIE_val_Value_10,
        _EDCH_RACH_Report_IncrDecrThres_denied_EDCH_RACH_resources,
        ____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab,
        _____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab_val_Extension_0,
        _____EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id_tab_val_Extension_1,
        ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__id,
        ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__criticality,
        ___EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item__extensionValue,
        __EDCH_RACH_Report_IncrDecrThres_iE_Extensions__item_,
        _EDCH_RACH_Report_IncrDecrThres_iE_Extensions,
        EDCH_RACH_Report_IncrDecrThres,
        EDCH_RACH_Report_IncrDecrThres_ExtIEs,
        _EDCH_RACH_Report_IncrDecrThres_ExtIEs_val_Extension_0,
        _EDCH_RACH_Report_IncrDecrThres_ExtIEs_val_Extension_1,
        Granted_EDCH_RACH_Resources_Value,
        Denied_EDCH_RACH_Resources_Value,
        _ReportCharacteristicsType_MeasurementThreshold_received_total_wide_band_power,
        _ReportCharacteristicsType_MeasurementThreshold_transmitted_carrier_power,
        _ReportCharacteristicsType_MeasurementThreshold_acknowledged_prach_preambles,
        _ReportCharacteristicsType_MeasurementThreshold_uL_TimeslotISCP,
        _ReportCharacteristicsType_MeasurementThreshold_sir,
        _ReportCharacteristicsType_MeasurementThreshold_sir_error,
        _ReportCharacteristicsType_MeasurementThreshold_transmitted_code_power,
        _ReportCharacteristicsType_MeasurementThreshold_rscp,
        _ReportCharacteristicsType_MeasurementThreshold_rx_timing_deviation,
        _ReportCharacteristicsType_MeasurementThreshold_round_trip_time,
        _ReportCharacteristicsType_MeasurementThreshold_notUsed_1_acknowledged_PCPCH_access_preambles,
        _ReportCharacteristicsType_MeasurementThreshold_notUsed_2_detected_PCPCH_access_preambles,
        _ReportCharacteristicsType_MeasurementThreshold_extension_ReportCharacteristicsType_MeasurementThreshold,
        ReportCharacteristicsType_MeasurementThreshold,
        __Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_0,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_1,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_2,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_3,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_4,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_5,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_6,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_7,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_8,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_9,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_10,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_11,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_12,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_13,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_14,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_15,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_16,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_17,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_18,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_19,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_20,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_21,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_22,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_23,
        ___Extension_ReportCharacteristicsType_MeasurementThreshold_id_tab_val_Value_24,
        _Extension_ReportCharacteristicsType_MeasurementThreshold_id,
        _Extension_ReportCharacteristicsType_MeasurementThreshold_criticality,
        _Extension_ReportCharacteristicsType_MeasurementThreshold_value,
        Extension_ReportCharacteristicsType_MeasurementThreshold,
        Extension_ReportCharacteristicsType_MeasurementThresholdIE,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_0,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_1,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_2,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_3,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_4,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_5,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_6,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_7,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_8,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_9,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_10,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_11,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_12,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_13,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_14,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_15,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_16,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_17,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_18,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_19,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_20,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_21,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_22,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_23,
        _Extension_ReportCharacteristicsType_MeasurementThresholdIE_val_Value_24,
        _EDCH_RACH_Report_ThresholdInformation_denied_EDCH_RACH_resources,
        ____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab,
        _____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id_tab_val_Extension_1,
        ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__id,
        ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__criticality,
        ___EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item__extensionValue,
        __EDCH_RACH_Report_ThresholdInformation_iE_Extensions__item_,
        _EDCH_RACH_Report_ThresholdInformation_iE_Extensions,
        EDCH_RACH_Report_ThresholdInformation,
        EDCH_RACH_Report_ThresholdInformation_ExtIEs,
        _EDCH_RACH_Report_ThresholdInformation_ExtIEs_val_Extension_0,
        _EDCH_RACH_Report_ThresholdInformation_ExtIEs_val_Extension_1,
        _ReportCharacteristicsType_ScaledMeasurementChangeTime_msec,
        ReportCharacteristicsType_ScaledMeasurementChangeTime,
        MeasurementChangeTime_Scaledmsec,
        _ReportCharacteristicsType_ScaledMeasurementHysteresisTime_msec,
        ReportCharacteristicsType_ScaledMeasurementHysteresisTime,
        MeasurementHysteresisTime_Scaledmsec,
        _ReportCharacteristicsType_ReportPeriodicity_msec,
        _ReportCharacteristicsType_ReportPeriodicity_min,
        ReportCharacteristicsType_ReportPeriodicity,
        ReportPeriodicity_Scaledmsec,
        ReportPeriodicity_Scaledmin,
        ReportPeriodicity_Scaledhour,
        ResourceOperationalState,
        RL_ID,
        RL_Set_ID,
        RLC_Mode,
        DL_RLC_PDU_Size_Format,
        Round_Trip_Time_IncrDecrThres,
        RNC_ID,
        Round_Trip_Time_Value,
        RSCP_Value,
        RSCP_Value_IncrDecrThres,
        _Received_total_wide_band_power_For_CellPortion_Value__item_,
        Received_total_wide_band_power_For_CellPortion_Value,
        _Received_total_wide_band_power_For_CellPortion_Value_Item_cellPortionID,
        _Received_total_wide_band_power_For_CellPortion_Value_Item_received_total_wide_band_power_value,
        ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__id_tab,
        ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__id,
        ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab,
        ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__criticality,
        ____Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab,
        ___Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue,
        __Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions__item_,
        _Received_total_wide_band_power_For_CellPortion_Value_Item_iE_Extensions,
        Received_total_wide_band_power_For_CellPortion_Value_Item,
        Received_total_wide_band_power_For_CellPortion_Value_Item_ExtIEs,
        _Received_total_wide_band_power_For_CellPortion_ValueLCR__item_,
        Received_total_wide_band_power_For_CellPortion_ValueLCR,
        _Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_cellPortionLCRID,
        _Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_received_total_wide_band_power_value,
        ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id_tab,
        ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id,
        ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality_tab,
        ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality,
        ____Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue_tab,
        ___Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue,
        __Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions__item_,
        _Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_iE_Extensions,
        Received_total_wide_band_power_For_CellPortion_ValueLCR_Item,
        Received_total_wide_band_power_For_CellPortion_ValueLCR_Item_ExtIEs,
        Received_total_wide_band_power_Value,
        Received_total_wide_band_power_Value_IncrDecrThres,
        _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value__item_,
        Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value,
        _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_cellPortionID,
        _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_received_Scheduled_power_share_value,
        _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_received_total_wide_band_power_value,
        ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__id_tab,
        ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__id,
        ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab,
        ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__criticality,
        ____Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab,
        ___Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue,
        __Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions__item_,
        _Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_iE_Extensions,
        Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item,
        Received_Scheduled_EDCH_Power_Share_For_CellPortion_Value_Item_ExtIEs,
        _Received_Scheduled_EDCH_Power_Share_Value_received_Scheduled_power_share_value,
        _Received_Scheduled_EDCH_Power_Share_Value_received_total_wide_band_power_value,
        Received_Scheduled_EDCH_Power_Share_Value,
        RSEPS_Value_IncrDecrThres,
        RSEPS_Value,
        _RequestedDataValueInformation_informationAvailable,
        _RequestedDataValueInformation_informationnotAvailable,
        RequestedDataValueInformation,
        _InformationAvailable_requesteddataValue,
        ____InformationAvailable_ie_Extensions__item__id_tab,
        ___InformationAvailable_ie_Extensions__item__id,
        ____InformationAvailable_ie_Extensions__item__criticality_tab,
        ___InformationAvailable_ie_Extensions__item__criticality,
        ____InformationAvailable_ie_Extensions__item__extensionValue_tab,
        ___InformationAvailable_ie_Extensions__item__extensionValue,
        __InformationAvailable_ie_Extensions__item_,
        _InformationAvailable_ie_Extensions,
        InformationAvailable,
        InformationAvailableItem_ExtIEs,
        InformationnotAvailable,
        _RequestedDataValue_dgps_corrections,
        _RequestedDataValue_gps_navandrecovery,
        _RequestedDataValue_gps_ionos_model,
        _RequestedDataValue_gps_utc_model,
        _RequestedDataValue_gps_almanac,
        _RequestedDataValue_gps_rt_integrity,
        _RequestedDataValue_gpsrxpos,
        ____RequestedDataValue_iE_Extensions__item__id_tab,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_0,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_1,
        ___RequestedDataValue_iE_Extensions__item__id,
        ___RequestedDataValue_iE_Extensions__item__criticality,
        ___RequestedDataValue_iE_Extensions__item__extensionValue,
        __RequestedDataValue_iE_Extensions__item_,
        _RequestedDataValue_iE_Extensions,
        RequestedDataValue,
        RequestedDataValue_ExtIEs,
        _RequestedDataValue_ExtIEs_val_Extension_0,
        _RequestedDataValue_ExtIEs_val_Extension_1,
        Rx_Timing_Deviation_Value,
        Rx_Timing_Deviation_Value_LCR,
        Rx_Timing_Deviation_Value_768,
        Rx_Timing_Deviation_Value_384_ext,
        RefBeta,
        RTWP_ReportingIndicator,
        RTWP_CellPortion_ReportingIndicator,
        AdjustmentPeriod,
        E_DPCCH_Power_Boosting_Capability,
        SAT_ID,
        _SAT_Info_Almanac__item_,
        SAT_Info_Almanac,
        _SAT_Info_Almanac_Item_data_id,
        _SAT_Info_Almanac_Item_sat_id,
        _SAT_Info_Almanac_Item_gps_e_alm,
        _SAT_Info_Almanac_Item_gps_toa_alm,
        _SAT_Info_Almanac_Item_gps_delta_I_alm,
        _SAT_Info_Almanac_Item_omegadot_alm,
        _SAT_Info_Almanac_Item_svhealth_alm,
        _SAT_Info_Almanac_Item_gps_a_sqrt_alm,
        _SAT_Info_Almanac_Item_omegazero_alm,
        _SAT_Info_Almanac_Item_m_zero_alm,
        _SAT_Info_Almanac_Item_gps_omega_alm,
        _SAT_Info_Almanac_Item_gps_af_zero_alm,
        _SAT_Info_Almanac_Item_gps_af_one_alm,
        ____SAT_Info_Almanac_Item_ie_Extensions__item__id_tab,
        ___SAT_Info_Almanac_Item_ie_Extensions__item__id,
        ____SAT_Info_Almanac_Item_ie_Extensions__item__criticality_tab,
        ___SAT_Info_Almanac_Item_ie_Extensions__item__criticality,
        ____SAT_Info_Almanac_Item_ie_Extensions__item__extensionValue_tab,
        ___SAT_Info_Almanac_Item_ie_Extensions__item__extensionValue,
        __SAT_Info_Almanac_Item_ie_Extensions__item_,
        _SAT_Info_Almanac_Item_ie_Extensions,
        SAT_Info_Almanac_Item,
        SAT_Info_Almanac_Item_ExtIEs,
        _SAT_Info_Almanac_ExtList__item_,
        SAT_Info_Almanac_ExtList,
        _SAT_Info_Almanac_ExtItem_data_id,
        _SAT_Info_Almanac_ExtItem_sat_id,
        _SAT_Info_Almanac_ExtItem_gps_e_alm,
        _SAT_Info_Almanac_ExtItem_gps_toa_alm,
        _SAT_Info_Almanac_ExtItem_gps_delta_I_alm,
        _SAT_Info_Almanac_ExtItem_omegadot_alm,
        _SAT_Info_Almanac_ExtItem_svhealth_alm,
        _SAT_Info_Almanac_ExtItem_gps_a_sqrt_alm,
        _SAT_Info_Almanac_ExtItem_omegazero_alm,
        _SAT_Info_Almanac_ExtItem_m_zero_alm,
        _SAT_Info_Almanac_ExtItem_gps_omega_alm,
        _SAT_Info_Almanac_ExtItem_gps_af_zero_alm,
        _SAT_Info_Almanac_ExtItem_gps_af_one_alm,
        ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__id_tab,
        ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__id,
        ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__criticality_tab,
        ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__criticality,
        ____SAT_Info_Almanac_ExtItem_ie_Extensions__item__extensionValue_tab,
        ___SAT_Info_Almanac_ExtItem_ie_Extensions__item__extensionValue,
        __SAT_Info_Almanac_ExtItem_ie_Extensions__item_,
        _SAT_Info_Almanac_ExtItem_ie_Extensions,
        SAT_Info_Almanac_ExtItem,
        SAT_Info_Almanac_ExtItemIEs,
        _SAT_Info_DGPSCorrections__item_,
        SAT_Info_DGPSCorrections,
        _SAT_Info_DGPSCorrections_Item_sat_id,
        _SAT_Info_DGPSCorrections_Item_iode_dgps,
        _SAT_Info_DGPSCorrections_Item_udre,
        _SAT_Info_DGPSCorrections_Item_prc,
        _SAT_Info_DGPSCorrections_Item_range_correction_rate,
        ____SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id_tab,
        _____SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id_tab_val_Extension_0,
        ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__id,
        ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__criticality,
        ___SAT_Info_DGPSCorrections_Item_ie_Extensions__item__extensionValue,
        __SAT_Info_DGPSCorrections_Item_ie_Extensions__item_,
        _SAT_Info_DGPSCorrections_Item_ie_Extensions,
        SAT_Info_DGPSCorrections_Item,
        SAT_Info_DGPSCorrections_Item_ExtIEs,
        _SAT_Info_DGPSCorrections_Item_ExtIEs_val_Extension_0,
        _SATInfo_RealTime_Integrity__item_,
        SATInfo_RealTime_Integrity,
        _SAT_Info_RealTime_Integrity_Item_bad_sat_id,
        ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__id_tab,
        ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__id,
        ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__criticality_tab,
        ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__criticality,
        ____SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__extensionValue_tab,
        ___SAT_Info_RealTime_Integrity_Item_ie_Extensions__item__extensionValue,
        __SAT_Info_RealTime_Integrity_Item_ie_Extensions__item_,
        _SAT_Info_RealTime_Integrity_Item_ie_Extensions,
        SAT_Info_RealTime_Integrity_Item,
        SAT_Info_RealTime_Integrity_Item_ExtIEs,
        ScaledAdjustmentRatio,
        MaxAdjustmentStep,
        SchedulingInformation,
        _SecondaryServingCells__item_,
        SecondaryServingCells,
        _SecondaryServingCellsItem_secondaryC_ID,
        _SecondaryServingCellsItem_numSecondaryHS_SCCH_Codes,
        _SecondaryServingCellsItem_sixtyfourQAM_UsageAllowedIndicator,
        ____SecondaryServingCellsItem_iE_Extensions__item__id_tab,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_2,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_3,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_4,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_5,
        ___SecondaryServingCellsItem_iE_Extensions__item__id,
        ___SecondaryServingCellsItem_iE_Extensions__item__criticality,
        ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue,
        __SecondaryServingCellsItem_iE_Extensions__item_,
        _SecondaryServingCellsItem_iE_Extensions,
        SecondaryServingCellsItem,
        SecondaryServingCellsItem_ExtIEs,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_0,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_1,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_2,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_3,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_4,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_5,
        Secondary_UL_Frequency_Activation_State,
        SchedulingPriorityIndicator,
        SID,
        ScramblingCodeNumber,
        _Secondary_CPICH_Information_Change_new_secondary_CPICH,
        _Secondary_CPICH_Information_Change_secondary_CPICH_shall_not_be_used,
        Secondary_CPICH_Information_Change,
        SecondaryCCPCH_SlotFormat,
        Secondary_CCPCH_SlotFormat_Extended,
        Segment_Type,
        _Serving_E_DCH_RL_ID_serving_E_DCH_RL_in_this_NodeB,
        _Serving_E_DCH_RL_ID_serving_E_DCH_RL_not_in_this_NodeB,
        Serving_E_DCH_RL_ID,
        _Serving_E_DCH_RL_in_this_NodeB_rL_ID,
        ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__id_tab,
        ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__id,
        ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__criticality_tab,
        ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__criticality,
        ____Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__extensionValue_tab,
        ___Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item__extensionValue,
        __Serving_E_DCH_RL_in_this_NodeB_iE_Extensions__item_,
        _Serving_E_DCH_RL_in_this_NodeB_iE_Extensions,
        Serving_E_DCH_RL_in_this_NodeB,
        Serving_E_DCH_RL_in_this_NodeB_ExtIEs,
        _SetsOfHS_SCCH_Codes__item_,
        SetsOfHS_SCCH_Codes,
        _SetsOfHS_SCCH_CodesItem_hS_SCCH_PreconfiguredCodes,
        _SetsOfHS_SCCH_CodesItem_sixtyfourQAM_DL_UsageIndicator,
        _SetsOfHS_SCCH_CodesItem_hSDSCH_TBSizeTableIndicator,
        ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab,
        _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id,
        ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality,
        ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue,
        __SetsOfHS_SCCH_CodesItem_iE_Extensions__item_,
        _SetsOfHS_SCCH_CodesItem_iE_Extensions,
        SetsOfHS_SCCH_CodesItem,
        SetsOfHS_SCCH_CodesItem_ExtIEs,
        _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_0,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH,
        SFN,
        SFNSFN_FDD,
        SFNSFN_TDD,
        SFNSFN_TDD768,
        SFNSFNChangeLimit,
        SFNSFNDriftRate,
        SFNSFNDriftRateQuality,
        _SFNSFNMeasurementThresholdInformation_sFNSFNChangeLimit,
        _SFNSFNMeasurementThresholdInformation_predictedSFNSFNDeviationLimit,
        ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id_tab,
        ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id,
        ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality_tab,
        ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality,
        ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab,
        ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue,
        __SFNSFNMeasurementThresholdInformation_iE_Extensions__item_,
        _SFNSFNMeasurementThresholdInformation_iE_Extensions,
        SFNSFNMeasurementThresholdInformation,
        SFNSFNMeasurementThresholdInformation_ExtIEs,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_Id,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNValue,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNQuality,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRate,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRateQuality,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNTimeStampInformation,
        ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab,
        _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id,
        ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab,
        _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality,
        ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab,
        _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue,
        ____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions,
        __SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_,
        _SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation,
        ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_Id,
        ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab,
        _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id,
        ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab,
        _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality,
        ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab,
        _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue,
        ____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_,
        ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions,
        __SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_,
        _SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation,
        ____SFNSFNMeasurementValueInformation_iE_Extensions__item__id_tab,
        ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id,
        ____SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality_tab,
        ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality,
        ____SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue_tab,
        ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue,
        __SFNSFNMeasurementValueInformation_iE_Extensions__item_,
        _SFNSFNMeasurementValueInformation_iE_Extensions,
        SFNSFNMeasurementValueInformation,
        SFNSFNMeasurementValueInformationItem_ExtIEs,
        SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs,
        UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs,
        SFNSFNQuality,
        ShutdownTimer,
        SIB_Originator,
        SIR_Error_Value,
        _SFNSFNTimeStampInformation_sFNSFNTimeStamp_FDD,
        _SFNSFNTimeStampInformation_sFNSFNTimeStamp_TDD,
        SFNSFNTimeStampInformation,
        _SFNSFNTimeStamp_TDD_sFN,
        _SFNSFNTimeStamp_TDD_timeSlot,
        ____SFNSFNTimeStamp_TDD_iE_Extensions__item__id_tab,
        ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id,
        ____SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality_tab,
        ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality,
        ____SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue_tab,
        ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue,
        __SFNSFNTimeStamp_TDD_iE_Extensions__item_,
        _SFNSFNTimeStamp_TDD_iE_Extensions,
        SFNSFNTimeStamp_TDD,
        SFNSFNTimeStamp_ExtIEs,
        _SFNSFNValue_sFNSFN_FDD,
        _SFNSFNValue_sFNSFN_TDD,
        _SFNSFNValue_sFNSFN_TDD768,
        SFNSFNValue,
        Single_Stream_MIMO_ActivationIndicator,
        Single_Stream_MIMO_Capability,
        Single_Stream_MIMO_Mode_Indicator,
        SIR_Error_Value_IncrDecrThres,
        SIR_Value,
        SIR_Value_IncrDecrThres,
        SignallingBearerRequestIndicator,
        SixtyfourQAM_UsageAllowedIndicator,
        SixtyfourQAM_DL_UsageIndicator,
        SixtyfourQAM_DL_Capability,
        SixtyfourQAM_DL_MIMO_Combined_Capability,
        SignatureSequenceGroupIndex,
        SixteenQAM_UL_Capability,
        SixteenQAM_UL_Operation_Indicator,
        SixtyfourQAM_UL_Operation_Indicator,
        SNPL_Reporting_Type,
        Soffset,
        SpecialBurstScheduling,
        Start_Of_Audit_Sequence_Indicator,
        Status_Flag,
        STTD_Indicator,
        SSDT_SupportIndicator,
        Sub_Frame_Number,
        Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order,
        SyncCase,
        SYNCDlCodeId,
        SyncFrameNumber,
        _SynchronisationReportCharacteristics_synchronisationReportCharacteristicsType,
        _SynchronisationReportCharacteristics_synchronisationReportCharactThreExc,
        ____SynchronisationReportCharacteristics_iE_Extensions__item__id_tab,
        _____SynchronisationReportCharacteristics_iE_Extensions__item__id_tab_val_Extension_0,
        ___SynchronisationReportCharacteristics_iE_Extensions__item__id,
        ___SynchronisationReportCharacteristics_iE_Extensions__item__criticality,
        ___SynchronisationReportCharacteristics_iE_Extensions__item__extensionValue,
        __SynchronisationReportCharacteristics_iE_Extensions__item_,
        _SynchronisationReportCharacteristics_iE_Extensions,
        SynchronisationReportCharacteristics,
        SynchronisationReportCharacteristics_ExtIEs,
        _SynchronisationReportCharacteristics_ExtIEs_val_Extension_0,
        _SynchronisationReportCharactThreExc__item_,
        SynchronisationReportCharactThreExc,
        _SynchronisationReportCharactThreInfoItem_syncFrameNumber,
        __SynchronisationReportCharactThreInfoItem_cellSyncBurstInformation__item_,
        _SynchronisationReportCharactThreInfoItem_cellSyncBurstInformation,
        ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__id_tab,
        ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__id,
        ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__criticality_tab,
        ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__criticality,
        ____SynchronisationReportCharactThreInfoItem_iE_Extensions__item__extensionValue_tab,
        ___SynchronisationReportCharactThreInfoItem_iE_Extensions__item__extensionValue,
        __SynchronisationReportCharactThreInfoItem_iE_Extensions__item_,
        _SynchronisationReportCharactThreInfoItem_iE_Extensions,
        SynchronisationReportCharactThreInfoItem,
        SynchronisationReportCharactThreInfoItem_ExtIEs,
        _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstCode,
        _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstCodeShift,
        _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstTiming,
        _SynchronisationReportCharactCellSyncBurstInfoItem_cellSyncBurstTimingThreshold,
        ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__id_tab,
        ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__id,
        ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__criticality_tab,
        ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__criticality,
        ____SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__extensionValue_tab,
        ___SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item__extensionValue,
        __SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions__item_,
        _SynchronisationReportCharactCellSyncBurstInfoItem_iE_Extensions,
        SynchronisationReportCharactCellSyncBurstInfoItem,
        SynchronisationReportCharactCellSyncBurstInfoItem_ExtIEs,
        _SyncDLCodeIdThreInfoLCR__item_,
        SyncDLCodeIdThreInfoLCR,
        _SyncDLCodeIdThreInfoList_syncFrameNoToReceive,
        _SyncDLCodeIdThreInfoList_syncDLCodeIdInfoLCR,
        ____SyncDLCodeIdThreInfoList_iE_Extensions__item__id_tab,
        ___SyncDLCodeIdThreInfoList_iE_Extensions__item__id,
        ____SyncDLCodeIdThreInfoList_iE_Extensions__item__criticality_tab,
        ___SyncDLCodeIdThreInfoList_iE_Extensions__item__criticality,
        ____SyncDLCodeIdThreInfoList_iE_Extensions__item__extensionValue_tab,
        ___SyncDLCodeIdThreInfoList_iE_Extensions__item__extensionValue,
        __SyncDLCodeIdThreInfoList_iE_Extensions__item_,
        _SyncDLCodeIdThreInfoList_iE_Extensions,
        SyncDLCodeIdThreInfoList,
        SyncDLCodeIdThreInfoList_ExtIEs,
        _SyncDLCodeInfoListLCR__item_,
        SyncDLCodeInfoListLCR,
        _SyncDLCodeInfoItemLCR_syncDLCodeId,
        _SyncDLCodeInfoItemLCR_syncDLCodeIdArrivTime,
        _SyncDLCodeInfoItemLCR_syncDLCodeIdTimingThre,
        ____SyncDLCodeInfoItemLCR_iE_Extensions__item__id_tab,
        ___SyncDLCodeInfoItemLCR_iE_Extensions__item__id,
        ____SyncDLCodeInfoItemLCR_iE_Extensions__item__criticality_tab,
        ___SyncDLCodeInfoItemLCR_iE_Extensions__item__criticality,
        ____SyncDLCodeInfoItemLCR_iE_Extensions__item__extensionValue_tab,
        ___SyncDLCodeInfoItemLCR_iE_Extensions__item__extensionValue,
        __SyncDLCodeInfoItemLCR_iE_Extensions__item_,
        _SyncDLCodeInfoItemLCR_iE_Extensions,
        SyncDLCodeInfoItemLCR,
        SyncDLCodeInfoItem_LCR_ExtIEs,
        SDPCCH_PowerOffsetInformation,
        SynchronisationReportCharacteristicsType,
        SynchronisationReportType,
        Semi_PersistentScheduling_CapabilityLCR,
        T1,
        T321,
        T333,
        T_Cell,
        T_RLFAILURE,
        T_PROTECT,
        T_SYNC,
        TDD_AckNack_Power_Offset,
        TDD_ChannelisationCode,
        Puncturing_Handling_in_First_Rate_Matching_Stage,
        _TDD_ChannelisationCodeLCR_tDD_ChannelisationCode,
        _TDD_ChannelisationCodeLCR_modulation,
        ____TDD_ChannelisationCodeLCR_iE_Extensions__item__id_tab,
        ___TDD_ChannelisationCodeLCR_iE_Extensions__item__id,
        ____TDD_ChannelisationCodeLCR_iE_Extensions__item__criticality_tab,
        ___TDD_ChannelisationCodeLCR_iE_Extensions__item__criticality,
        ____TDD_ChannelisationCodeLCR_iE_Extensions__item__extensionValue_tab,
        ___TDD_ChannelisationCodeLCR_iE_Extensions__item__extensionValue,
        __TDD_ChannelisationCodeLCR_iE_Extensions__item_,
        _TDD_ChannelisationCodeLCR_iE_Extensions,
        TDD_ChannelisationCodeLCR,
        TDD_ChannelisationCodeLCR_ExtIEs,
        TDD_ChannelisationCode768,
        _TDD_DL_Code_Information__item_,
        TDD_DL_Code_Information,
        _TDD_DL_Code_InformationItem_dPCH_ID,
        _TDD_DL_Code_InformationItem_tdd_ChannelisationCode,
        ____TDD_DL_Code_InformationItem_iE_Extensions__item__id_tab,
        ___TDD_DL_Code_InformationItem_iE_Extensions__item__id,
        ____TDD_DL_Code_InformationItem_iE_Extensions__item__criticality_tab,
        ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality,
        ____TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue,
        __TDD_DL_Code_InformationItem_iE_Extensions__item_,
        _TDD_DL_Code_InformationItem_iE_Extensions,
        TDD_DL_Code_InformationItem,
        TDD_DL_Code_InformationItem_ExtIEs,
        _TDD_DL_Code_LCR_Information__item_,
        TDD_DL_Code_LCR_Information,
        _TDD_DL_Code_LCR_InformationItem_dPCH_ID,
        _TDD_DL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR,
        _TDD_DL_Code_LCR_InformationItem_tdd_DL_DPCH_TimeSlotFormat_LCR,
        ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id_tab,
        ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id,
        ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab,
        ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality,
        ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue,
        __TDD_DL_Code_LCR_InformationItem_iE_Extensions__item_,
        _TDD_DL_Code_LCR_InformationItem_iE_Extensions,
        TDD_DL_Code_LCR_InformationItem,
        TDD_DL_Code_LCR_InformationItem_ExtIEs,
        _TDD_DL_Code_768_Information__item_,
        TDD_DL_Code_768_Information,
        _TDD_DL_Code_768_InformationItem_dPCH_ID,
        _TDD_DL_Code_768_InformationItem_tdd_ChannelisationCode768,
        ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__id_tab,
        ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__id,
        ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__criticality_tab,
        ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__criticality,
        ____TDD_DL_Code_768_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___TDD_DL_Code_768_InformationItem_iE_Extensions__item__extensionValue,
        __TDD_DL_Code_768_InformationItem_iE_Extensions__item_,
        _TDD_DL_Code_768_InformationItem_iE_Extensions,
        TDD_DL_Code_768_InformationItem,
        TDD_DL_Code_768_InformationItem_ExtIEs,
        _TDD_DL_DPCH_TimeSlotFormat_LCR_qPSK,
        _TDD_DL_DPCH_TimeSlotFormat_LCR_eightPSK,
        TDD_DL_DPCH_TimeSlotFormat_LCR,
        QPSK_DL_DPCH_TimeSlotFormatTDD_LCR,
        EightPSK_DL_DPCH_TimeSlotFormatTDD_LCR,
        _TDD_DPCHOffset_initialOffset,
        _TDD_DPCHOffset_noinitialOffset,
        TDD_DPCHOffset,
        TDD_PhysicalChannelOffset,
        TDD_TPC_DownlinkStepSize,
        TDD_TPC_UplinkStepSize_LCR,
        ____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_betaC,
        ____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_betaD,
        _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__id_tab,
        ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__id,
        _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__criticality_tab,
        ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__criticality,
        _______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__extensionValue_tab,
        ______TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item__extensionValue,
        _____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions__item_,
        ____TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd_iE_Extensions,
        ___TransportFormatCombination_Beta_signalledGainFactors_gainFactor_fdd,
        ___TransportFormatCombination_Beta_signalledGainFactors_gainFactor_tdd,
        __TransportFormatCombination_Beta_signalledGainFactors_gainFactor,
        __TransportFormatCombination_Beta_signalledGainFactors_refTFCNumber,
        _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id_tab,
        ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id,
        _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality_tab,
        ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality,
        _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue_tab,
        ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue,
        ___TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item_,
        __TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions,
        _TransportFormatCombination_Beta_signalledGainFactors,
        _TransportFormatCombination_Beta_computedGainFactors,
        TransportFormatCombination_Beta,
        GainFactorFDD_ExtIEs,
        SignalledGainFactors_ExtIEs,
        _TDD_UL_Code_Information__item_,
        TDD_UL_Code_Information,
        _TDD_UL_Code_InformationItem_dPCH_ID,
        _TDD_UL_Code_InformationItem_tdd_ChannelisationCode,
        ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab,
        ___TDD_UL_Code_InformationItem_iE_Extensions__item__id,
        ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab,
        ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality,
        ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue,
        __TDD_UL_Code_InformationItem_iE_Extensions__item_,
        _TDD_UL_Code_InformationItem_iE_Extensions,
        TDD_UL_Code_InformationItem,
        TDD_UL_Code_InformationItem_ExtIEs,
        _TDD_UL_Code_LCR_Information__item_,
        TDD_UL_Code_LCR_Information,
        _TDD_UL_Code_LCR_InformationItem_dPCH_ID,
        _TDD_UL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR,
        _TDD_UL_Code_LCR_InformationItem_tdd_UL_DPCH_TimeSlotFormat_LCR,
        ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id_tab,
        ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id,
        ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab,
        ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality,
        ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue,
        __TDD_UL_Code_LCR_InformationItem_iE_Extensions__item_,
        _TDD_UL_Code_LCR_InformationItem_iE_Extensions,
        TDD_UL_Code_LCR_InformationItem,
        TDD_UL_Code_LCR_InformationItem_ExtIEs,
        _TDD_UL_Code_768_Information__item_,
        TDD_UL_Code_768_Information,
        _TDD_UL_Code_768_InformationItem_dPCH_ID,
        _TDD_UL_Code_768_InformationItem_tdd_ChannelisationCode768,
        ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__id_tab,
        ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__id,
        ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__criticality_tab,
        ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__criticality,
        ____TDD_UL_Code_768_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___TDD_UL_Code_768_InformationItem_iE_Extensions__item__extensionValue,
        __TDD_UL_Code_768_InformationItem_iE_Extensions__item_,
        _TDD_UL_Code_768_InformationItem_iE_Extensions,
        TDD_UL_Code_768_InformationItem,
        TDD_UL_Code_768_InformationItem_ExtIEs,
        _TDD_UL_DPCH_TimeSlotFormat_LCR_qPSK,
        _TDD_UL_DPCH_TimeSlotFormat_LCR_eightPSK,
        TDD_UL_DPCH_TimeSlotFormat_LCR,
        QPSK_UL_DPCH_TimeSlotFormatTDD_LCR,
        EightPSK_UL_DPCH_TimeSlotFormatTDD_LCR,
        TFCI_Coding,
        TFCI_Presence,
        _TFCI_SignallingMode_tFCI_SignallingOption,
        _TFCI_SignallingMode_not_Used_splitType,
        _TFCI_SignallingMode_not_Used_lengthOfTFCI2,
        ____TFCI_SignallingMode_iE_Extensions__item__id_tab,
        ___TFCI_SignallingMode_iE_Extensions__item__id,
        ____TFCI_SignallingMode_iE_Extensions__item__criticality_tab,
        ___TFCI_SignallingMode_iE_Extensions__item__criticality,
        ____TFCI_SignallingMode_iE_Extensions__item__extensionValue_tab,
        ___TFCI_SignallingMode_iE_Extensions__item__extensionValue,
        __TFCI_SignallingMode_iE_Extensions__item_,
        _TFCI_SignallingMode_iE_Extensions,
        TFCI_SignallingMode,
        TFCI_SignallingMode_ExtIEs,
        TFCI_SignallingMode_TFCI_SignallingOption,
        TGD,
        TGPRC,
        TGPSID,
        TGSN,
        TimeSlot,
        TimeSlotDirection,
        _TimeSlot_InitiatedListLCR__item_,
        TimeSlot_InitiatedListLCR,
        TimeSlotLCR,
        TimeslotLCR_Extension,
        _TimeSlotMeasurementValueListLCR__item_,
        TimeSlotMeasurementValueListLCR,
        _TimeSlotMeasurementValueLCR_timeSlotLCR,
        _TimeSlotMeasurementValueLCR_commonMeasurementValue,
        ____TimeSlotMeasurementValueLCR_iE_Extensions__item__id_tab,
        ___TimeSlotMeasurementValueLCR_iE_Extensions__item__id,
        ____TimeSlotMeasurementValueLCR_iE_Extensions__item__criticality_tab,
        ___TimeSlotMeasurementValueLCR_iE_Extensions__item__criticality,
        ____TimeSlotMeasurementValueLCR_iE_Extensions__item__extensionValue_tab,
        ___TimeSlotMeasurementValueLCR_iE_Extensions__item__extensionValue,
        __TimeSlotMeasurementValueLCR_iE_Extensions__item_,
        _TimeSlotMeasurementValueLCR_iE_Extensions,
        TimeSlotMeasurementValueLCR,
        TimeSlotMeasurementValueListLCR_ExtIEs,
        TimeSlotStatus,
        _TimingAdjustmentValue_initialPhase,
        _TimingAdjustmentValue_steadyStatePhase,
        TimingAdjustmentValue,
        _TimingAdjustmentValueLCR_initialPhase,
        _TimingAdjustmentValueLCR_steadyStatePhase,
        TimingAdjustmentValueLCR,
        TimingAdvanceApplied,
        SynchronisationIndicator,
        _TnlQos_dsField,
        _TnlQos_genericTrafficCategory,
        TnlQos,
        ToAWE,
        ToAWS,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGPSID,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGSN,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGL1,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGL2,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGD,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGPL1,
        __Transmission_Gap_Pattern_Sequence_Information__item__not_to_be_used_1,
        __Transmission_Gap_Pattern_Sequence_Information__item__uL_DL_mode,
        __Transmission_Gap_Pattern_Sequence_Information__item__downlink_Compressed_Mode_Method,
        __Transmission_Gap_Pattern_Sequence_Information__item__uplink_Compressed_Mode_Method,
        __Transmission_Gap_Pattern_Sequence_Information__item__dL_FrameType,
        __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR1,
        __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after1,
        __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR2,
        __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after2,
        _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab,
        ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id,
        _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab,
        ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality,
        _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab,
        ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue,
        ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_,
        __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions,
        _Transmission_Gap_Pattern_Sequence_Information__item_,
        Transmission_Gap_Pattern_Sequence_Information,
        Transmission_Gap_Pattern_Sequence_Information_ExtIEs,
        TransmissionGapPatternSequenceCodeInformation,
        _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue__item_,
        TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue,
        _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_cellPortionID,
        _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_transmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue,
        ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id_tab,
        ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id,
        ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality_tab,
        ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality,
        ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue_tab,
        ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue,
        __TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item_,
        _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions,
        TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item,
        TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCH_E_RGCHOrE_HICHTransmissionCellPortionValue_Item_ExtIEs,
        _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue__item_,
        TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue,
        _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_cellPortionLCRID,
        _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_transmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue,
        ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id_tab,
        ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__id,
        ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality_tab,
        ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__criticality,
        ____TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue_tab,
        ___TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item__extensionValue,
        __TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions__item_,
        _TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_iE_Extensions,
        TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item,
        TransmittedCarrierPowerOfAllCodesNotUsedForHS_PDSCH_HS_SCCH_E_AGCHOrE_HICHTransmissionCellPortionValue_Item_ExtIEs,
        TransmittedCarrierPowerOfAllCodesNotUsedForHSTransmissionValue,
        _Transmitted_Carrier_Power_For_CellPortion_Value__item_,
        Transmitted_Carrier_Power_For_CellPortion_Value,
        _Transmitted_Carrier_Power_For_CellPortion_Value_Item_cellPortionID,
        _Transmitted_Carrier_Power_For_CellPortion_Value_Item_transmitted_Carrier_Power_Value,
        ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__id_tab,
        ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__id,
        ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab,
        ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__criticality,
        ____Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab,
        ___Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue,
        __Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions__item_,
        _Transmitted_Carrier_Power_For_CellPortion_Value_Item_iE_Extensions,
        Transmitted_Carrier_Power_For_CellPortion_Value_Item,
        Transmitted_Carrier_Power_For_CellPortion_Value_Item_ExtIEs,
        _Transmitted_Carrier_Power_For_CellPortion_ValueLCR__item_,
        Transmitted_Carrier_Power_For_CellPortion_ValueLCR,
        _Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_cellPortionLCRID,
        _Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_transmitted_Carrier_Power_Value,
        ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id_tab,
        ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__id,
        ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality_tab,
        ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__criticality,
        ____Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue_tab,
        ___Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item__extensionValue,
        __Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions__item_,
        _Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_iE_Extensions,
        Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item,
        Transmitted_Carrier_Power_For_CellPortion_ValueLCR_Item_ExtIEs,
        Transmitted_Carrier_Power_Value,
        Transmitted_Code_Power_Value,
        Transmitted_Code_Power_Value_IncrDecrThres,
        TransmissionDiversityApplied,
        TransmitDiversityIndicator,
        __TFCS_tFCSvalues_no_Split_in_TFCI,
        __TFCS_tFCSvalues_not_Used_split_in_TFCI,
        _TFCS_tFCSvalues,
        ____TFCS_iE_Extensions__item__id_tab,
        ___TFCS_iE_Extensions__item__id,
        ____TFCS_iE_Extensions__item__criticality_tab,
        ___TFCS_iE_Extensions__item__criticality,
        ____TFCS_iE_Extensions__item__extensionValue_tab,
        ___TFCS_iE_Extensions__item__extensionValue,
        __TFCS_iE_Extensions__item_,
        _TFCS_iE_Extensions,
        TFCS,
        TFCS_ExtIEs,
        __TFCS_TFCSList__item__cTFC,
        __TFCS_TFCSList__item__tFC_Beta,
        _____TFCS_TFCSList__item__iE_Extensions__item__id_tab,
        ______TFCS_TFCSList__item__iE_Extensions__item__id_tab_val_Extension_0,
        ____TFCS_TFCSList__item__iE_Extensions__item__id,
        ____TFCS_TFCSList__item__iE_Extensions__item__criticality,
        ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue,
        ___TFCS_TFCSList__item__iE_Extensions__item_,
        __TFCS_TFCSList__item__iE_Extensions,
        _TFCS_TFCSList__item_,
        TFCS_TFCSList,
        TFCS_TFCSList_ExtIEs,
        _TFCS_TFCSList_ExtIEs_val_Extension_0,
        _TFCS_CTFC_ctfc2bit,
        _TFCS_CTFC_ctfc4bit,
        _TFCS_CTFC_ctfc6bit,
        _TFCS_CTFC_ctfc8bit,
        _TFCS_CTFC_ctfc12bit,
        _TFCS_CTFC_ctfc16bit,
        _TFCS_CTFC_ctfcmaxbit,
        TFCS_CTFC,
        _TPC_slot_position_slot_position,
        ____TPC_slot_position_iE_Extensions__item__id_tab,
        ___TPC_slot_position_iE_Extensions__item__id,
        ____TPC_slot_position_iE_Extensions__item__criticality_tab,
        ___TPC_slot_position_iE_Extensions__item__criticality,
        ____TPC_slot_position_iE_Extensions__item__extensionValue_tab,
        ___TPC_slot_position_iE_Extensions__item__extensionValue,
        __TPC_slot_position_iE_Extensions__item_,
        _TPC_slot_position_iE_Extensions,
        TPC_slot_position,
        TPC_slot_position_ExtIEs,
        Transport_Block_Size_Index,
        Transport_Block_Size_Index_for_Enhanced_PCH,
        __Transport_Block_Size_List__item__transport_Block_Size_Index_for_Enhanced_PCH,
        _____Transport_Block_Size_List__item__iE_Extensions__item__id_tab,
        ____Transport_Block_Size_List__item__iE_Extensions__item__id,
        _____Transport_Block_Size_List__item__iE_Extensions__item__criticality_tab,
        ____Transport_Block_Size_List__item__iE_Extensions__item__criticality,
        _____Transport_Block_Size_List__item__iE_Extensions__item__extensionValue_tab,
        ____Transport_Block_Size_List__item__iE_Extensions__item__extensionValue,
        ___Transport_Block_Size_List__item__iE_Extensions__item_,
        __Transport_Block_Size_List__item__iE_Extensions,
        _Transport_Block_Size_List__item_,
        Transport_Block_Size_List,
        Transport_Block_Size_List_ExtIEs,
        TransportBearerRequestIndicator,
        TransportBearerNotRequestedIndicator,
        TransportBearerNotSetupIndicator,
        _TransportFormatSet_dynamicParts,
        _TransportFormatSet_semi_staticPart,
        ____TransportFormatSet_iE_Extensions__item__id_tab,
        ___TransportFormatSet_iE_Extensions__item__id,
        ____TransportFormatSet_iE_Extensions__item__criticality_tab,
        ___TransportFormatSet_iE_Extensions__item__criticality,
        ____TransportFormatSet_iE_Extensions__item__extensionValue_tab,
        ___TransportFormatSet_iE_Extensions__item__extensionValue,
        __TransportFormatSet_iE_Extensions__item_,
        _TransportFormatSet_iE_Extensions,
        TransportFormatSet,
        TransportFormatSet_ExtIEs,
        __TransportFormatSet_DynamicPartList__item__nrOfTransportBlocks,
        __TransportFormatSet_DynamicPartList__item__transportBlockSize,
        __TransportFormatSet_DynamicPartList__item__mode,
        _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab,
        ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id,
        _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab,
        ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality,
        _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab,
        ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue,
        ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_,
        __TransportFormatSet_DynamicPartList__item__iE_Extensions,
        _TransportFormatSet_DynamicPartList__item_,
        TransportFormatSet_DynamicPartList,
        TransportFormatSet_DynamicPartList_ExtIEs,
        _TDD_TransportFormatSet_ModeDP_transmissionTimeIntervalInformation,
        ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id_tab,
        ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id,
        ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality_tab,
        ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality,
        ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue_tab,
        ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue,
        __TDD_TransportFormatSet_ModeDP_iE_Extensions__item_,
        _TDD_TransportFormatSet_ModeDP_iE_Extensions,
        TDD_TransportFormatSet_ModeDP,
        TDD_TransportFormatSet_ModeDP_ExtIEs,
        __TransmissionTimeIntervalInformation__item__transmissionTimeInterval,
        _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id_tab,
        ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id,
        _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality_tab,
        ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality,
        _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue_tab,
        ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue,
        ___TransmissionTimeIntervalInformation__item__iE_Extensions__item_,
        __TransmissionTimeIntervalInformation__item__iE_Extensions,
        _TransmissionTimeIntervalInformation__item_,
        TransmissionTimeIntervalInformation,
        TransmissionTimeIntervalInformation_ExtIEs,
        _TransportFormatSet_Semi_staticPart_transmissionTimeInterval,
        _TransportFormatSet_Semi_staticPart_channelCoding,
        _TransportFormatSet_Semi_staticPart_codingRate,
        _TransportFormatSet_Semi_staticPart_rateMatchingAttribute,
        _TransportFormatSet_Semi_staticPart_cRC_Size,
        _TransportFormatSet_Semi_staticPart_mode,
        ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab,
        ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id,
        ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab,
        ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality,
        ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab,
        ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue,
        __TransportFormatSet_Semi_staticPart_iE_Extensions__item_,
        _TransportFormatSet_Semi_staticPart_iE_Extensions,
        TransportFormatSet_Semi_staticPart,
        TransportFormatSet_Semi_staticPart_ExtIEs,
        TransportFormatSet_ChannelCodingType,
        TransportFormatSet_CodingRate,
        TransportFormatSet_CRC_Size,
        _TransportFormatSet_ModeDP_tdd,
        _TransportFormatSet_ModeDP_notApplicable,
        TransportFormatSet_ModeDP,
        _TransportFormatSet_ModeSSP_tdd,
        _TransportFormatSet_ModeSSP_notApplicable,
        TransportFormatSet_ModeSSP,
        TransportFormatSet_NrOfTransportBlocks,
        TransportFormatSet_RateMatchingAttribute,
        TransportFormatSet_SecondInterleavingMode,
        TransportFormatSet_TransmissionTimeIntervalDynamic,
        TransportFormatSet_TransmissionTimeIntervalSemiStatic,
        TransportFormatSet_TransportBlockSize,
        TransportLayerAddress,
        TS0_CapabilityLCR,
        TSTD_Indicator,
        TSN_Length,
        _TUTRANGANSS_mS,
        _TUTRANGANSS_lS,
        TUTRANGANSS,
        TUTRANGANSSAccuracyClass,
        _TUTRANGANSSMeasurementThresholdInformation_tUTRANGANSSChangeLimit,
        _TUTRANGANSSMeasurementThresholdInformation_predictedTUTRANGANSSDeviationLimit,
        ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id_tab,
        ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id,
        ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality_tab,
        ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality,
        ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue_tab,
        ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue,
        __TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item_,
        _TUTRANGANSSMeasurementThresholdInformation_ie_Extensions,
        TUTRANGANSSMeasurementThresholdInformation,
        TUTRANGANSSMeasurementThresholdInformation_ExtIEs,
        _TUTRANGANSSMeasurementValueInformation_tUTRANGANSS,
        _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSQuality,
        _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRate,
        _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRateQuality,
        ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab,
        _____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab_val_Extension_0,
        ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id,
        ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality,
        ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue,
        __TUTRANGANSSMeasurementValueInformation_ie_Extensions__item_,
        _TUTRANGANSSMeasurementValueInformation_ie_Extensions,
        TUTRANGANSSMeasurementValueInformation,
        TUTRANGANSSMeasurementValueInformation_ExtIEs,
        _TUTRANGANSSMeasurementValueInformation_ExtIEs_val_Extension_0,
        _TUTRANGPS_ms_part,
        _TUTRANGPS_ls_part,
        TUTRANGPS,
        TUTRANGPSChangeLimit,
        TUTRANGPSDriftRate,
        TUTRANGPSDriftRateQuality,
        TUTRANGPSAccuracyClass,
        _TUTRANGPSMeasurementThresholdInformation_tUTRANGPSChangeLimit,
        _TUTRANGPSMeasurementThresholdInformation_predictedTUTRANGPSDeviationLimit,
        ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id_tab,
        ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id,
        ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality_tab,
        ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality,
        ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab,
        ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue,
        __TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item_,
        _TUTRANGPSMeasurementThresholdInformation_iE_Extensions,
        TUTRANGPSMeasurementThresholdInformation,
        TUTRANGPSMeasurementThresholdInformation_ExtIEs,
        _TUTRANGPSMeasurementValueInformation_tUTRANGPS,
        _TUTRANGPSMeasurementValueInformation_tUTRANGPSQuality,
        _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRate,
        _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRateQuality,
        ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__id_tab,
        ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__id,
        ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__criticality_tab,
        ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__criticality,
        ____TUTRANGPSMeasurementValueInformation_iE_Extensions__item__extensionValue_tab,
        ___TUTRANGPSMeasurementValueInformation_iE_Extensions__item__extensionValue,
        __TUTRANGPSMeasurementValueInformation_iE_Extensions__item_,
        _TUTRANGPSMeasurementValueInformation_iE_Extensions,
        TUTRANGPSMeasurementValueInformation,
        TUTRANGPSMeasurementValueInformationItem_ExtIEs,
        TUTRANGPSQuality,
        TxDiversityOnDLControlChannelsByMIMOUECapability,
        TypeOfError,
        Two_ms_Overridden_E_DCH_RACH_Resources,
        Two_ms_Grant_E_DCH_RACH_Resources,
        Two_ms_Denied_E_DCH_RACH_Resources,
        Two_msand10msTTI_Concurrent_Deployment_Capability,
        _Two_level_DRX_t32x,
        _Two_level_DRX_hS_DSCH_first_Rx_burst_FACH,
        _Two_level_DRX_hS_DSCH_first_DRX_ycle_FACH,
        _Two_level_DRX_hS_DSCH_second_Rx_burst_FACH,
        _Two_level_DRX_t32y,
        ____Two_level_DRX_iE_Extensions__item__id_tab,
        ___Two_level_DRX_iE_Extensions__item__id,
        ____Two_level_DRX_iE_Extensions__item__criticality_tab,
        ___Two_level_DRX_iE_Extensions__item__criticality,
        ____Two_level_DRX_iE_Extensions__item__extensionValue_tab,
        ___Two_level_DRX_iE_Extensions__item__extensionValue,
        __Two_level_DRX_iE_Extensions__item_,
        _Two_level_DRX_iE_Extensions,
        Two_level_DRX,
        Two_level_DRX_ExtIEs,
        T32x,
        T32y,
        UARFCN,
        _UC_Id_rNC_ID,
        _UC_Id_c_ID,
        ____UC_Id_iE_Extensions__item__id_tab,
        _____UC_Id_iE_Extensions__item__id_tab_val_Extension_0,
        ___UC_Id_iE_Extensions__item__id,
        ___UC_Id_iE_Extensions__item__criticality,
        ___UC_Id_iE_Extensions__item__extensionValue,
        __UC_Id_iE_Extensions__item_,
        _UC_Id_iE_Extensions,
        UC_Id,
        UC_Id_ExtIEs,
        _UC_Id_ExtIEs_val_Extension_0,
        UDRE,
        UDREGrowthRate,
        UDREValidityTime,
        _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink,
        _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink,
        UE_AggregateMaximumBitRate,
        UE_AggregateMaximumBitRateDownlink,
        UE_AggregateMaximumBitRateUplink,
        UE_AggregateMaximumBitRate_Enforcement_Indicator,
        _UE_Capability_Information_hSDSCH_Physical_Layer_Category,
        ____UE_Capability_Information_iE_Extensions__item__id_tab,
        _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____UE_Capability_Information_iE_Extensions__item__id_tab_val_Extension_5,
        ___UE_Capability_Information_iE_Extensions__item__id,
        ___UE_Capability_Information_iE_Extensions__item__criticality,
        ___UE_Capability_Information_iE_Extensions__item__extensionValue,
        __UE_Capability_Information_iE_Extensions__item_,
        _UE_Capability_Information_iE_Extensions,
        UE_Capability_Information,
        UE_Capability_Information_ExtIEs,
        _UE_Capability_Information_ExtIEs_val_Extension_0,
        _UE_Capability_Information_ExtIEs_val_Extension_1,
        _UE_Capability_Information_ExtIEs_val_Extension_2,
        _UE_Capability_Information_ExtIEs_val_Extension_3,
        _UE_Capability_Information_ExtIEs_val_Extension_4,
        _UE_Capability_Information_ExtIEs_val_Extension_5,
        _UE_RF_Band_CapabilityLCR__item_,
        UE_RF_Band_CapabilityLCR,
        _Radio_Frequency_BandItem_radio_Frequency_Band,
        ____Radio_Frequency_BandItem_iE_Extensions__item__id_tab,
        ___Radio_Frequency_BandItem_iE_Extensions__item__id,
        ____Radio_Frequency_BandItem_iE_Extensions__item__criticality_tab,
        ___Radio_Frequency_BandItem_iE_Extensions__item__criticality,
        ____Radio_Frequency_BandItem_iE_Extensions__item__extensionValue_tab,
        ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue,
        __Radio_Frequency_BandItem_iE_Extensions__item_,
        _Radio_Frequency_BandItem_iE_Extensions,
        Radio_Frequency_BandItem,
        UE_TS0_CapabilityLCR,
        Radio_Frequency_Band,
        Radio_Frequency_BandItem_ExtIEs,
        UE_Support_of_non_rectangular_resource_allocation,
        UE_SupportIndicatorExtension,
        LCRTDD_HSDSCH_Physical_Layer_Category,
        UE_DPCCH_burst1,
        UE_DPCCH_burst2,
        UE_DRX_Cycle,
        UE_DRX_Grant_Monitoring,
        UE_DTX_Cycle1_2ms,
        UE_DTX_Cycle1_10ms,
        UE_DTX_Cycle2_2ms,
        UE_DTX_Cycle2_ext_2ms,
        UE_DTX_Cycle2_10ms,
        UE_DTX_DRX_Offset,
        UE_DTX_Long_Preamble,
        UE_transmission_power_headroom_Value,
        _UE_Measurement_Value_uPHFiltering_Value,
        _UE_Measurement_Value_extension_UE_Measurement_Value,
        UE_Measurement_Value,
        __Extension_UE_Measurement_Value_id_tab,
        _Extension_UE_Measurement_Value_id,
        __Extension_UE_Measurement_Value_criticality_tab,
        _Extension_UE_Measurement_Value_criticality,
        __Extension_UE_Measurement_Value_value_tab,
        _Extension_UE_Measurement_Value_value,
        Extension_UE_Measurement_Value,
        Extension_UE_Measurement_ValueIE,
        UPHFiltering_Value,
        UL_CapacityCredit,
        UL_Delta_T2TP,
        UL_DL_mode,
        UL_DPDCH_Indicator_For_E_DCH_Operation,
        Uplink_Compressed_Mode_Method,
        _UL_Timeslot_Information__item_,
        UL_Timeslot_Information,
        _UL_Timeslot_InformationItem_timeSlot,
        _UL_Timeslot_InformationItem_midambleShiftAndBurstType,
        _UL_Timeslot_InformationItem_tFCI_Presence,
        _UL_Timeslot_InformationItem_uL_Code_InformationList,
        ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationItem_iE_Extensions__item__id,
        ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationItem_iE_Extensions__item_,
        _UL_Timeslot_InformationItem_iE_Extensions,
        UL_Timeslot_InformationItem,
        UL_Timeslot_InformationItem_ExtIEs,
        _UL_TimeslotLCR_Information__item_,
        UL_TimeslotLCR_Information,
        _UL_TimeslotLCR_InformationItem_timeSlotLCR,
        _UL_TimeslotLCR_InformationItem_midambleShiftLCR,
        _UL_TimeslotLCR_InformationItem_tFCI_Presence,
        _UL_TimeslotLCR_InformationItem_uL_Code_InformationList,
        ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab,
        _____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id,
        ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality,
        ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue,
        __UL_TimeslotLCR_InformationItem_iE_Extensions__item_,
        _UL_TimeslotLCR_InformationItem_iE_Extensions,
        UL_TimeslotLCR_InformationItem,
        UL_TimeslotLCR_InformationItem_ExtIEs,
        _UL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0,
        _UL_Timeslot768_Information__item_,
        UL_Timeslot768_Information,
        _UL_Timeslot768_InformationItem_timeSlot,
        _UL_Timeslot768_InformationItem_midambleShiftAndBurstType768,
        _UL_Timeslot768_InformationItem_tFCI_Presence,
        _UL_Timeslot768_InformationItem_uL_Code_InformationList,
        ____UL_Timeslot768_InformationItem_iE_Extensions__item__id_tab,
        ___UL_Timeslot768_InformationItem_iE_Extensions__item__id,
        ____UL_Timeslot768_InformationItem_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot768_InformationItem_iE_Extensions__item__criticality,
        ____UL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot768_InformationItem_iE_Extensions__item__extensionValue,
        __UL_Timeslot768_InformationItem_iE_Extensions__item_,
        _UL_Timeslot768_InformationItem_iE_Extensions,
        UL_Timeslot768_InformationItem,
        UL_Timeslot768_InformationItem_ExtIEs,
        UL_DPCCH_SlotFormat,
        UL_SIR,
        UL_FP_Mode,
        UL_PhysCH_SF_Variation,
        _UL_ScramblingCode_uL_ScramblingCodeNumber,
        _UL_ScramblingCode_uL_ScramblingCodeLength,
        ____UL_ScramblingCode_iE_Extensions__item__id_tab,
        ___UL_ScramblingCode_iE_Extensions__item__id,
        ____UL_ScramblingCode_iE_Extensions__item__criticality_tab,
        ___UL_ScramblingCode_iE_Extensions__item__criticality,
        ____UL_ScramblingCode_iE_Extensions__item__extensionValue_tab,
        ___UL_ScramblingCode_iE_Extensions__item__extensionValue,
        __UL_ScramblingCode_iE_Extensions__item_,
        _UL_ScramblingCode_iE_Extensions,
        UL_ScramblingCode,
        UL_ScramblingCode_ExtIEs,
        UL_ScramblingCodeNumber,
        UL_ScramblingCodeLength,
        _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_StepSize,
        _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_Frequency,
        ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id_tab,
        ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id,
        ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality_tab,
        ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality,
        ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue_tab,
        ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue,
        __UL_Synchronisation_Parameters_LCR_iE_Extensions__item_,
        _UL_Synchronisation_Parameters_LCR_iE_Extensions,
        UL_Synchronisation_Parameters_LCR,
        UL_Synchronisation_Parameters_LCR_ExtIEs,
        UL_Synchronisation_StepSize,
        UL_Synchronisation_Frequency,
        UPPCHPositionLCR,
        _UL_TimeSlot_ISCP_Info__item_,
        UL_TimeSlot_ISCP_Info,
        _UL_TimeSlot_ISCP_InfoItem_timeSlot,
        _UL_TimeSlot_ISCP_InfoItem_iSCP,
        ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab,
        ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id,
        ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab,
        ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality,
        ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab,
        ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue,
        __UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_,
        _UL_TimeSlot_ISCP_InfoItem_iE_Extensions,
        UL_TimeSlot_ISCP_InfoItem,
        UL_TimeSlot_ISCP_InfoItem_ExtIEs,
        _UL_TimeSlot_ISCP_LCR_Info__item_,
        UL_TimeSlot_ISCP_LCR_Info,
        _UL_TimeSlot_ISCP_LCR_InfoItem_timeSlotLCR,
        _UL_TimeSlot_ISCP_LCR_InfoItem_iSCP,
        ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab,
        ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id,
        ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab,
        ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality,
        ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab,
        ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue,
        __UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_,
        _UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions,
        UL_TimeSlot_ISCP_LCR_InfoItem,
        UL_TimeSlot_ISCP_LCR_InfoItem_ExtIEs,
        _UpPTSInterference_For_CellPortion_Value__item_,
        UpPTSInterference_For_CellPortion_Value,
        _UpPTSInterference_For_CellPortion_Value_Item_cellPortionLCRID,
        _UpPTSInterference_For_CellPortion_Value_Item_upPTSInterferenceValue,
        ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__id_tab,
        ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__id,
        ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab,
        ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__criticality,
        ____UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab,
        ___UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue,
        __UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions__item_,
        _UpPTSInterference_For_CellPortion_Value_Item_iE_Extensions,
        UpPTSInterference_For_CellPortion_Value_Item,
        UpPTSInterference_For_CellPortion_Value_Item_ExtIEs,
        UpPTSInterferenceValue,
        Unidirectional_DCH_Indicator,
        _USCH_Information__item_,
        USCH_Information,
        _USCH_InformationItem_uSCH_ID,
        _USCH_InformationItem_cCTrCH_ID,
        _USCH_InformationItem_transportFormatSet,
        _USCH_InformationItem_allocationRetentionPriority,
        ____USCH_InformationItem_iE_Extensions__item__id_tab,
        _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___USCH_InformationItem_iE_Extensions__item__id,
        ___USCH_InformationItem_iE_Extensions__item__criticality,
        ___USCH_InformationItem_iE_Extensions__item__extensionValue,
        __USCH_InformationItem_iE_Extensions__item_,
        _USCH_InformationItem_iE_Extensions,
        USCH_InformationItem,
        USCH_InformationItem_ExtIEs,
        _USCH_InformationItem_ExtIEs_val_Extension_0,
        _USCH_InformationItem_ExtIEs_val_Extension_1,
        _USCH_InformationItem_ExtIEs_val_Extension_2,
        _USCH_InformationResponse__item_,
        USCH_InformationResponse,
        _USCH_InformationResponseItem_uSCH_ID,
        _USCH_InformationResponseItem_bindingID,
        _USCH_InformationResponseItem_transportLayerAddress,
        ____USCH_InformationResponseItem_iE_Extensions__item__id_tab,
        ___USCH_InformationResponseItem_iE_Extensions__item__id,
        ____USCH_InformationResponseItem_iE_Extensions__item__criticality_tab,
        ___USCH_InformationResponseItem_iE_Extensions__item__criticality,
        ____USCH_InformationResponseItem_iE_Extensions__item__extensionValue_tab,
        ___USCH_InformationResponseItem_iE_Extensions__item__extensionValue,
        __USCH_InformationResponseItem_iE_Extensions__item_,
        _USCH_InformationResponseItem_iE_Extensions,
        USCH_InformationResponseItem,
        USCH_InformationResponseItem_ExtIEs,
        _UL_CLTD_Information_sDPCCH_PowerOffsetinformation,
        _UL_CLTD_Information_c_ID,
        _UL_CLTD_Information_uL_CLTD_Activation_Information,
        ____UL_CLTD_Information_iE_Extensions__item__id_tab,
        ___UL_CLTD_Information_iE_Extensions__item__id,
        ____UL_CLTD_Information_iE_Extensions__item__criticality_tab,
        ___UL_CLTD_Information_iE_Extensions__item__criticality,
        ____UL_CLTD_Information_iE_Extensions__item__extensionValue_tab,
        ___UL_CLTD_Information_iE_Extensions__item__extensionValue,
        __UL_CLTD_Information_iE_Extensions__item_,
        _UL_CLTD_Information_iE_Extensions,
        UL_CLTD_Information,
        UL_CLTD_Information_ExtIEs,
        _UL_CLTD_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD,
        ____UL_CLTD_Information_Reconf_iE_Extensions__item__id_tab,
        ___UL_CLTD_Information_Reconf_iE_Extensions__item__id,
        ____UL_CLTD_Information_Reconf_iE_Extensions__item__criticality_tab,
        ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality,
        ____UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue_tab,
        ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue,
        __UL_CLTD_Information_Reconf_iE_Extensions__item_,
        _UL_CLTD_Information_Reconf_iE_Extensions,
        UL_CLTD_Information_Reconf,
        UL_CLTD_Information_Reconf_ExtIEs,
        _UL_CLTD_Information_To_Modify_sDPCCH_PowerOffsetInformation,
        _UL_CLTD_Information_To_Modify_uL_CLTD_Activation_Information,
        ____UL_CLTD_Information_To_Modify_iE_Extensions__item__id_tab,
        ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id,
        ____UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality_tab,
        ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality,
        ____UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue_tab,
        ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue,
        __UL_CLTD_Information_To_Modify_iE_Extensions__item_,
        _UL_CLTD_Information_To_Modify_iE_Extensions,
        UL_CLTD_Information_To_Modify,
        UL_CLTD_Information_To_Modify_ExtIEs,
        UL_CLTD_Information_Removal,
        UL_CLTD_State_Update_Information,
        UL_CLTD_Activation_Information,
        _UL_DPCCH2_Information_f_DPCH_Info,
        ____UL_DPCCH2_Information_iE_Extensions__item__id_tab,
        ___UL_DPCCH2_Information_iE_Extensions__item__id,
        ____UL_DPCCH2_Information_iE_Extensions__item__criticality_tab,
        ___UL_DPCCH2_Information_iE_Extensions__item__criticality,
        ____UL_DPCCH2_Information_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue,
        __UL_DPCCH2_Information_iE_Extensions__item_,
        _UL_DPCCH2_Information_iE_Extensions,
        UL_DPCCH2_Information,
        UL_DPCCH2_Information_ExtIEs,
        _UL_DPCCH2_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2,
        ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__id_tab,
        ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id,
        ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality_tab,
        ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality,
        ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue,
        __UL_DPCCH2_Information_Reconf_iE_Extensions__item_,
        _UL_DPCCH2_Information_Reconf_iE_Extensions,
        UL_DPCCH2_Information_Reconf,
        UL_DPCCH2_Information_Reconf_ExtIEs,
        UL_DPCCH2_Information_Removal,
        _UL_DPCCH2_Information_To_Modify_f_DPCH_Info,
        ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id_tab,
        ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id,
        ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality_tab,
        ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality,
        ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue,
        __UL_DPCCH2_Information_To_Modify_iE_Extensions__item_,
        _UL_DPCCH2_Information_To_Modify_iE_Extensions,
        UL_DPCCH2_Information_To_Modify,
        UL_DPCCH2_Information_To_Modify_ExtIEs,
        _UL_MIMO_Information_e_roch_power_offset,
        _UL_MIMO_Information_s_e_dpcch_power_offset,
        _UL_MIMO_Information_interstream_compensation,
        _UL_MIMO_Information_minimum_E_TFCI_rank2,
        ____UL_MIMO_Information_iE_Extensions__item__id_tab,
        ___UL_MIMO_Information_iE_Extensions__item__id,
        ____UL_MIMO_Information_iE_Extensions__item__criticality_tab,
        ___UL_MIMO_Information_iE_Extensions__item__criticality,
        ____UL_MIMO_Information_iE_Extensions__item__extensionValue_tab,
        ___UL_MIMO_Information_iE_Extensions__item__extensionValue,
        __UL_MIMO_Information_iE_Extensions__item_,
        _UL_MIMO_Information_iE_Extensions,
        UL_MIMO_Information,
        _UL_MIMO_Information_To_Modify_e_roch_power_offset,
        _UL_MIMO_Information_To_Modify_s_e_dpcch_power_offset,
        _UL_MIMO_Information_To_Modify_interstream_compensation,
        _UL_MIMO_Information_To_Modify_minimum_E_TFCI_rank2,
        ____UL_MIMO_Information_To_Modify_iE_Extensions__item__id_tab,
        ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id,
        ____UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab,
        ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality,
        ____UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab,
        ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue,
        __UL_MIMO_Information_To_Modify_iE_Extensions__item_,
        _UL_MIMO_Information_To_Modify_iE_Extensions,
        UL_MIMO_Information_To_Modify,
        _UL_MIMO_Reconfiguration_setup,
        _UL_MIMO_Reconfiguration_configurationChange,
        _UL_MIMO_Reconfiguration_removal,
        UL_MIMO_Reconfiguration,
        UL_MIMO_Removal,
        _UL_MIMO_DL_Control_Channel_Information_e_roch_channelization_code,
        _UL_MIMO_DL_Control_Channel_Information_s_e_rnti,
        _UL_MIMO_DL_Control_Channel_Information_s_signature_sequence,
        _UL_MIMO_DL_Control_Channel_Information_s_e_roch_release_indicator,
        ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id_tab,
        ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id,
        ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality_tab,
        ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality,
        ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue_tab,
        ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue,
        __UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item_,
        _UL_MIMO_DL_Control_Channel_Information_iE_Extensions,
        UL_MIMO_DL_Control_Channel_Information,
        UL_MIMO_Information_ExtIEs,
        UL_MIMO_Information_To_Modify_ExtIEs,
        UL_MIMO_DL_Control_Channel_Information_ExtIEs,
        E_ROCH_PowerOffset,
        S_E_DPCCH_PowerOffset,
        InterStream_Interference_Compensation,
        S_E_ROCH_Release_Indicator,
        _UL_TimeslotISCP_For_CellPortion_Value__item_,
        UL_TimeslotISCP_For_CellPortion_Value,
        _UL_TimeslotISCP_For_CellPortion_Value_Item_cellPortionLCRID,
        _UL_TimeslotISCP_For_CellPortion_Value_Item_uL_TimeslotISCP_Value,
        ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__id_tab,
        ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__id,
        ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__criticality_tab,
        ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__criticality,
        ____UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue_tab,
        ___UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item__extensionValue,
        __UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions__item_,
        _UL_TimeslotISCP_For_CellPortion_Value_Item_iE_Extensions,
        UL_TimeslotISCP_For_CellPortion_Value_Item,
        UL_TimeslotISCP_For_CellPortion_Value_Item_ExtIEs,
        UL_TimeslotISCP_Value,
        UL_TimeslotISCP_Value_IncrDecrThres,
        USCH_ID,
        Usefulness_Of_Battery_Optimization,
        Uu_ActivationState,
    ]

class NBAP_PDU_Contents:

    _name_  = 'NBAP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 20, 3, 2, 1, 1]
    
    _obj_ = [
        'CommonTransportChannelSetupRequestFDD',
        'CommonTransportChannelSetupRequestFDD-Extensions',
        'CommonTransportChannelSetupRequestFDD-IEs',
        'CommonPhysicalChannelType-CTCH-SetupRqstFDD',
        'Secondary-CCPCH-CTCH-SetupRqstFDD',
        'Secondary-CCPCHItem-CTCH-SetupRqstFDD-ExtIEs',
        'PowerOffsetInformation-CTCH-SetupRqstFDD',
        'PowerOffsetInformation-CTCH-SetupRqstFDD-ExtIEs',
        'FACH-ParametersList-CTCH-SetupRqstFDD',
        'FACH-ParametersListIEs-CTCH-SetupRqstFDD',
        'FACH-ParametersListIE-CTCH-SetupRqstFDD',
        'FACH-ParametersItem-CTCH-SetupRqstFDD',
        'FACH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs',
        'PCH-Parameters-CTCH-SetupRqstFDD',
        'PCH-ParametersIE-CTCH-SetupRqstFDD',
        'PCH-ParametersItem-CTCH-SetupRqstFDD',
        'PCH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs',
        'PICH-Parameters-CTCH-SetupRqstFDD',
        'PICH-Parameters-CTCH-SetupRqstFDD-ExtIEs',
        'MICH-Parameters-CTCH-SetupRqstFDD',
        'MICH-Parameters-CTCH-SetupRqstFDD-ExtIEs',
        'PRACH-CTCH-SetupRqstFDD',
        'PRACHItem-CTCH-SetupRqstFDD-ExtIEs',
        'AllowedSlotFormatInformationList-CTCH-SetupRqstFDD',
        'AllowedSlotFormatInformationItem-CTCH-SetupRqstFDD',
        'AllowedSlotFormatInformationItem-CTCH-SetupRqstFDD-ExtIEs',
        'RACH-Parameters-CTCH-SetupRqstFDD',
        'RACH-ParametersIE-CTCH-SetupRqstFDD',
        'RACH-ParametersItem-CTCH-SetupRqstFDD',
        'RACH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs',
        'AICH-Parameters-CTCH-SetupRqstFDD',
        'AICH-Parameters-CTCH-SetupRqstFDD-ExtIEs',
        'CommonTransportChannelSetupRequestTDD',
        'CommonTransportChannelSetupRequestTDD-IEs',
        'CommonTransportChannelSetupRequestTDD-Extensions',
        'CommonPhysicalChannelType-CTCH-SetupRqstTDD',
        'Extension-CommonPhysicalChannelType-CTCH-SetupRqstTDD',
        'Extension-CommonPhysicalChannelType-CTCH-SetupRqstTDDIE',
        'Secondary-CCPCH-CTCH-SetupRqstTDD',
        'Secondary-CCPCHItem-CTCH-SetupRqstTDD-ExtIEs',
        'Secondary-CCPCH-parameterList-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-parameterListIEs-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-parameterListIE-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-parameterItem-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-parameterItem-CTCH-SetupRqstTDD-ExtIEs',
        'Secondary-CCPCH-LCR-parameterList-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-LCR-parameterItem-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-LCR-parameterItem-CTCH-SetupRqstTDD-ExtIEs',
        'Secondary-CCPCH-768-parameterList-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-768-parameterItem-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-parameterItem-768-CTCH-SetupRqstTDD-ExtIEs',
        'FACH-ParametersList-CTCH-SetupRqstTDD',
        'FACH-ParametersListIEs-CTCH-SetupRqstTDD',
        'FACH-ParametersListIE-CTCH-SetupRqstTDD',
        'FACH-ParametersItem-CTCH-SetupRqstTDD',
        'FACH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PCH-Parameters-CTCH-SetupRqstTDD',
        'PCH-ParametersIE-CTCH-SetupRqstTDD',
        'PCH-ParametersItem-CTCH-SetupRqstTDD',
        'PCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PICH-Parameters-CTCH-SetupRqstTDD',
        'PICH-ParametersIE-CTCH-SetupRqstTDD',
        'PICH-ParametersItem-CTCH-SetupRqstTDD',
        'PICH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PICH-LCR-Parameters-CTCH-SetupRqstTDD',
        'PICH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PICH-768-ParametersItem-CTCH-SetupRqstTDD',
        'PICH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-Parameters-CTCH-SetupRqstTDD',
        'MICH-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-TDDOption-Specific-Parameters-CTCH-SetupRqstTDD',
        'MICH-HCR-Parameters-CTCH-SetupRqstTDD',
        'MICH-HCR-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-LCR-Parameters-CTCH-SetupRqstTDD',
        'MICH-LCR-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-768-Parameters-CTCH-SetupRqstTDD',
        'MICH-768-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'TimeSlotConfigurationList-LCR-CTCH-SetupRqstTDD',
        'TimeSlotConfigurationItem-LCR-CTCH-SetupRqstTDD',
        'TimeSlotConfigurationItem-LCR-CTCH-SetupRqstTDD-ExtIEs',
        'Secondary-CCPCH-parameterExtendedList-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-LCR-parameterExtendedList-CTCH-SetupRqstTDD',
        'PRACH-CTCH-SetupRqstTDD',
        'PRACH-CTCH-SetupRqstTDD-ExtIEs',
        'PRACH-Parameters-CTCH-SetupRqstTDD',
        'PRACH-ParametersIE-CTCH-SetupRqstTDD',
        'PRACH-ParametersItem-CTCH-SetupRqstTDD',
        'PRACH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'RACH-Parameter-CTCH-SetupRqstTDD',
        'RACH-ParameterIE-CTCH-SetupRqstTDD',
        'RACH-ParameterItem-CTCH-SetupRqstTDD',
        'RACH-ParameterItem-CTCH-SetupRqstTDD-ExtIEs',
        'PRACH-LCR-ParametersList-CTCH-SetupRqstTDD',
        'PRACH-LCR-ParametersItem-CTCH-SetupRqstTDD',
        'PRACH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PRACH-768-ParametersItem-CTCH-SetupRqstTDD',
        'PRACH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'FPACH-LCR-Parameters-CTCH-SetupRqstTDD',
        'FPACH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PLCCH-parameters',
        'PLCCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'E-RUCCH-parameters',
        'E-RUCCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'E-RUCCH-768-parameters',
        'E-RUCCH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'CommonTransportChannelSetupResponse',
        'CommonTransportChannelSetupResponse-IEs',
        'CommonTransportChannelSetupResponse-Extensions',
        'FACH-CommonTransportChannel-InformationResponse',
        'CommonTransportChannelSetupFailure',
        'CommonTransportChannelSetupFailure-IEs',
        'CommonTransportChannelSetupFailure-Extensions',
        'CommonTransportChannelReconfigurationRequestFDD',
        'CommonTransportChannelReconfigurationRequestFDD-IEs',
        'CommonTransportChannelReconfigurationRequestFDD-Extensions',
        'CommonPhysicalChannelType-CTCH-ReconfRqstFDD',
        'Secondary-CCPCHList-CTCH-ReconfRqstFDD',
        'Secondary-CCPCH-CTCH-ReconfRqstFDD-ExtIEs',
        'FACH-ParametersList-CTCH-ReconfRqstFDD',
        'FACH-ParametersListIEs-CTCH-ReconfRqstFDD',
        'FACH-ParametersListIE-CTCH-ReconfRqstFDD',
        'FACH-ParametersItem-CTCH-ReconfRqstFDD',
        'FACH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'PCH-Parameters-CTCH-ReconfRqstFDD',
        'PCH-ParametersIE-CTCH-ReconfRqstFDD',
        'PCH-ParametersItem-CTCH-ReconfRqstFDD',
        'PCH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'PICH-Parameters-CTCH-ReconfRqstFDD',
        'PICH-ParametersIE-CTCH-ReconfRqstFDD',
        'PICH-ParametersItem-CTCH-ReconfRqstFDD',
        'PICH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'MICH-Parameters-CTCH-ReconfRqstFDD',
        'MICH-Parameters-CTCH-ReconfRqstFDD-ExtIEs',
        'BCH-Parameters-CTCH-ReconfRqstFDD',
        'BCH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'PRACHList-CTCH-ReconfRqstFDD',
        'PRACH-CTCH-ReconfRqstFDD-ExtIEs',
        'PRACH-ParametersList-CTCH-ReconfRqstFDD',
        'PRACH-ParametersListIEs-CTCH-ReconfRqstFDD',
        'PRACH-ParametersListIE-CTCH-ReconfRqstFDD',
        'PRACH-ParametersItem-CTCH-ReconfRqstFDD',
        'PRACH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'AllowedSlotFormatInformationList-CTCH-ReconfRqstFDD',
        'AllowedSlotFormatInformationItem-CTCH-ReconfRqstFDD',
        'AllowedSlotFormatInformationItem-CTCH-ReconfRqstFDD-ExtIEs',
        'AICH-ParametersList-CTCH-ReconfRqstFDD',
        'AICH-ParametersListIEs-CTCH-ReconfRqstFDD',
        'AICH-ParametersListIE-CTCH-ReconfRqstFDD',
        'AICH-ParametersItem-CTCH-ReconfRqstFDD',
        'AICH-ParametersItemIE-CTCH-ReconfRqstFDD-ExtIEs',
        'CommonTransportChannelReconfigurationRequestTDD',
        'CommonTransportChannelReconfigurationRequestTDD-IEs',
        'CommonTransportChannelReconfigurationRequestTDD-Extensions',
        'Secondary-CCPCH-Parameters-CTCH-ReconfRqstTDD',
        'Secondary-CCPCH-CTCH-ReconfRqstTDD-ExtIEs',
        'Secondary-CCPCHList-CTCH-ReconfRqstTDD',
        'Secondary-CCPCHListIEs-CTCH-ReconfRqstTDD',
        'Secondary-CCPCHListIE-CTCH-ReconfRqstTDD',
        'Secondary-CCPCHItem-CTCH-ReconfRqstTDD',
        'Secondary-CCPCHItem-CTCH-ReconfRqstTDD-ExtIEs',
        'Secondary-CCPCH-parameterExtendedList-CTCH-ReconfRqstTDD',
        'Secondary-CCPCH-LCR-parameterExtendedList-CTCH-ReconfRqstTDD',
        'PICH-Parameters-CTCH-ReconfRqstTDD',
        'PICH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'FACH-ParametersList-CTCH-ReconfRqstTDD',
        'FACH-ParametersItem-CTCH-ReconfRqstTDD',
        'FACH-ParametersItem-CTCH-ReconfRqstTDD-ExtIEs',
        'PCH-Parameters-CTCH-ReconfRqstTDD',
        'PCH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'FPACH-LCR-Parameters-CTCH-ReconfRqstTDD',
        'FPACH-LCR-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'MICH-Parameters-CTCH-ReconfRqstTDD',
        'MICH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'PLCCH-Parameters-CTCH-ReconfRqstTDD',
        'PLCCH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'Secondary-CCPCH-768-Parameters-CTCH-ReconfRqstTDD',
        'Secondary-CCPCH-768-CTCH-ReconfRqstTDD-ExtIEs',
        'Secondary-CCPCH-768-List-CTCH-ReconfRqstTDD',
        'Secondary-CCPCH-768-Item-CTCH-ReconfRqstTDD',
        'Secondary-CCPCH-768-Item-CTCH-ReconfRqstTDD-ExtIEs',
        'PICH-768-Parameters-CTCH-ReconfRqstTDD',
        'PICH-768-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'MICH-768-Parameters-CTCH-ReconfRqstTDD',
        'MICH-768-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD',
        'UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'CommonTransportChannelReconfigurationResponse',
        'CommonTransportChannelReconfigurationResponse-IEs',
        'CommonTransportChannelReconfigurationResponse-Extensions',
        'CommonTransportChannelReconfigurationFailure',
        'CommonTransportChannelReconfigurationFailure-IEs',
        'CommonTransportChannelReconfigurationFailure-Extensions',
        'CommonTransportChannelDeletionRequest',
        'CommonTransportChannelDeletionRequest-IEs',
        'CommonTransportChannelDeletionRequest-Extensions',
        'CommonTransportChannelDeletionResponse',
        'CommonTransportChannelDeletionResponse-IEs',
        'CommonTransportChannelDeletionResponse-Extensions',
        'BlockResourceRequest',
        'BlockResourceRequest-IEs',
        'BlockResourceRequest-Extensions',
        'BlockResourceResponse',
        'BlockResourceResponse-IEs',
        'BlockResourceResponse-Extensions',
        'BlockResourceFailure',
        'BlockResourceFailure-IEs',
        'BlockResourceFailure-Extensions',
        'UnblockResourceIndication',
        'UnblockResourceIndication-IEs',
        'UnblockResourceIndication-Extensions',
        'AuditRequiredIndication',
        'AuditRequiredIndication-IEs',
        'AuditRequiredIndication-Extensions',
        'AuditRequest',
        'AuditRequest-IEs',
        'AuditRequest-Extensions',
        'AuditResponse',
        'AuditResponse-IEs',
        'AuditResponse-Extensions',
        'Cell-InformationList-AuditRsp',
        'Cell-InformationItemIE-AuditRsp',
        'Cell-InformationItem-AuditRsp',
        'Cell-InformationItem-AuditRsp-ExtIEs',
        'P-SCH-Information-AuditRsp',
        'P-SCH-InformationIE-AuditRsp',
        'S-SCH-Information-AuditRsp',
        'S-SCH-InformationIE-AuditRsp',
        'P-CPICH-Information-AuditRsp',
        'P-CPICH-InformationIE-AuditRsp',
        'S-CPICH-InformationList-AuditRsp',
        'S-CPICH-InformationItemIE-AuditRsp',
        'P-CCPCH-Information-AuditRsp',
        'P-CCPCH-InformationIE-AuditRsp',
        'BCH-Information-AuditRsp',
        'BCH-InformationIE-AuditRsp',
        'S-CCPCH-InformationList-AuditRsp',
        'S-CCPCH-InformationItemIE-AuditRsp',
        'PCH-Information-AuditRsp',
        'PCH-InformationIE-AuditRsp',
        'PICH-Information-AuditRsp',
        'PICH-InformationIE-AuditRsp',
        'FACH-InformationList-AuditRsp',
        'FACH-InformationItemIE-AuditRsp',
        'PRACH-InformationList-AuditRsp',
        'PRACH-InformationItemIE-AuditRsp',
        'RACH-InformationList-AuditRsp',
        'RACH-InformationItemIE-AuditRsp',
        'AICH-InformationList-AuditRsp',
        'AICH-InformationItemIE-AuditRsp',
        'SCH-Information-AuditRsp',
        'SCH-InformationIE-AuditRsp',
        'FPACH-LCR-InformationList-AuditRsp',
        'FPACH-LCR-InformationItemIE-AuditRsp',
        'HS-DSCH-Resources-Information-AuditRsp',
        'HS-DSCH-Resources-Information-AuditRsp-ExtIEs',
        'S-CCPCH-InformationListExt-AuditRsp',
        'S-CCPCH-LCR-InformationListExt-AuditRsp',
        'E-DCH-Resources-Information-AuditRsp',
        'E-DCH-Resources-Information-AuditRsp-ExtIEs',
        'PLCCH-InformationList-AuditRsp',
        'PLCCH-InformationItemIE-AuditRsp',
        'S-CCPCH-768-InformationList-AuditRsp',
        'S-CCPCH-768-InformationItemIE-AuditRsp',
        'PRACH-768-InformationList-AuditRsp',
        'PRACH-768-InformationItemIE-AuditRsp',
        'E-RUCCH-InformationList-AuditRsp',
        'E-RUCCH-InformationItemIE-AuditRsp',
        'E-RUCCH-768-InformationList-AuditRsp',
        'E-RUCCH-768-InformationItemIE-AuditRsp',
        'Cell-Frequency-List-Information-LCR-MulFreq-AuditRsp',
        'Cell-Frequency-List-InformationIE-LCR-MulFreq-AuditRsp',
        'Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp',
        'Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp-ExtIEs',
        'UPPCH-LCR-InformationList-AuditRsp',
        'UPPCH-LCR-InformationIE-AuditRsp',
        'UPPCH-LCR-InformationItem-AuditRsp',
        'UPPCH-LCR-InformationItem-AuditRsp-ExtIEs',
        'MultipleFreq-HS-DSCH-Resources-InformationList-AuditRsp',
        'MultipleFreq-HS-DSCH-Resources-InformationItem-AuditRsp',
        'MultipleFreq-E-DCH-Resources-InformationList-AuditRsp',
        'MultipleFreq-E-DCH-Resources-InformationItem-AuditRsp',
        'CCP-InformationList-AuditRsp',
        'CCP-InformationItemIE-AuditRsp',
        'CCP-InformationItem-AuditRsp',
        'CCP-InformationItem-AuditRsp-ExtIEs',
        'Local-Cell-InformationList-AuditRsp',
        'Local-Cell-InformationItemIE-AuditRsp',
        'Local-Cell-InformationItem-AuditRsp',
        'Local-Cell-InformationItem-AuditRsp-ExtIEs',
        'Local-Cell-Group-InformationList-AuditRsp',
        'Local-Cell-Group-InformationItemIE-AuditRsp',
        'Local-Cell-Group-InformationItem-AuditRsp',
        'Local-Cell-Group-InformationItem-AuditRsp-ExtIEs',
        'Power-Local-Cell-Group-InformationList-AuditRsp',
        'Power-Local-Cell-Group-InformationItemIE-AuditRsp',
        'Power-Local-Cell-Group-InformationItem-AuditRsp',
        'Power-Local-Cell-Group-InformationItem-AuditRsp-ExtIEs',
        'AuditFailure',
        'AuditFailure-IEs',
        'AuditFailure-Extensions',
        'CommonMeasurementInitiationRequest',
        'CommonMeasurementInitiationRequest-IEs',
        'CommonMeasurementInitiationRequest-Extensions',
        'CommonMeasurementObjectType-CM-Rqst',
        'Extension-CommonMeasurementObjectType-CM-Rqst',
        'Extension-CommonMeasurementObjectType-CM-RqstIE',
        'ERACH-CM-Rqst',
        'ERACHItem-CM-Rqst-ExtIEs',
        'Cell-CM-Rqst',
        'CellItem-CM-Rqst-ExtIEs',
        'RACH-CM-Rqst',
        'RACHItem-CM-Rqst-ExtIEs',
        'PowerLocalCellGroup-CM-Rqst',
        'PowerLocalCellGroup-CM-Rqst-ExtIEs',
        'CommonMeasurementInitiationResponse',
        'CommonMeasurementInitiationResponse-IEs',
        'CommonMeasurementInitiationResponse-Extensions',
        'CommonMeasurementObjectType-CM-Rsp',
        'Extension-CommonMeasurementObjectType-CM-Rsp',
        'Extension-CommonMeasurementObjectType-CM-RspIE',
        'ERACH-CM-Rsp',
        'ERACHItem-CM-Rsp-ExtIEs',
        'Cell-CM-Rsp',
        'CellItem-CM-Rsp-ExtIEs',
        'RACH-CM-Rsp',
        'RACHItem-CM-Rsp-ExtIEs',
        'PowerLocalCellGroup-CM-Rsp',
        'PowerLocalCellGroup-CM-Rsp-ExtIEs',
        'CommonMeasurementInitiationFailure',
        'CommonMeasurementInitiationFailure-IEs',
        'CommonMeasurementInitiationFailure-Extensions',
        'CommonMeasurementReport',
        'CommonMeasurementReport-IEs',
        'CommonMeasurementReport-Extensions',
        'CommonMeasurementObjectType-CM-Rprt',
        'Extension-CommonMeasurementObjectType-CM-Rprt',
        'Extension-CommonMeasurementObjectType-CM-RprtIE',
        'ERACH-CM-Rprt',
        'ERACHItem-CM-Rprt-ExtIEs',
        'Cell-CM-Rprt',
        'CellItem-CM-Rprt-ExtIEs',
        'RACH-CM-Rprt',
        'RACHItem-CM-Rprt-ExtIEs',
        'PowerLocalCellGroup-CM-Rprt',
        'PowerLocalCellGroup-CM-Rprt-ExtIEs',
        'CommonMeasurementTerminationRequest',
        'CommonMeasurementTerminationRequest-IEs',
        'CommonMeasurementTerminationRequest-Extensions',
        'CommonMeasurementFailureIndication',
        'CommonMeasurementFailureIndication-IEs',
        'CommonMeasurementFailureIndication-Extensions',
        'CellSetupRequestFDD',
        'CellSetupRequestFDD-IEs',
        'CellSetupRequestFDD-Extensions',
        'Synchronisation-Configuration-Cell-SetupRqst',
        'Synchronisation-Configuration-Cell-SetupRqst-ExtIEs',
        'PrimarySCH-Information-Cell-SetupRqstFDD',
        'PrimarySCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'SecondarySCH-Information-Cell-SetupRqstFDD',
        'SecondarySCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'PrimaryCPICH-Information-Cell-SetupRqstFDD',
        'PrimaryCPICH-Information-Cell-SetupRqstFDD-ExtIEs',
        'SecondaryCPICH-InformationList-Cell-SetupRqstFDD',
        'SecondaryCPICH-InformationItemIE-Cell-SetupRqstFDD',
        'SecondaryCPICH-InformationItem-Cell-SetupRqstFDD',
        'SecondaryCPICH-InformationItem-Cell-SetupRqstFDD-ExtIEs',
        'PrimaryCCPCH-Information-Cell-SetupRqstFDD',
        'PrimaryCCPCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'BCH-Information-Cell-SetupRqstFDD',
        'BCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'Limited-power-increase-information-Cell-SetupRqstFDD',
        'Limited-power-increase-information-Cell-SetupRqstFDD-ExtIEs',
        'IPDLParameter-Information-Cell-SetupRqstFDD',
        'IPDLParameter-Information-Cell-SetupRqstFDD-ExtIEs',
        'CellPortion-InformationList-Cell-SetupRqstFDD',
        'CellPortion-InformationItemIE-Cell-SetupRqstFDD',
        'CellPortion-InformationItem-Cell-SetupRqstFDD',
        'CellPortion-InformationItem-Cell-SetupRqstFDD-ExtIEs',
        'CellSetupRequestTDD',
        'CellSetupRequestTDD-IEs',
        'CellSetupRequestTDD-Extensions',
        'SCH-Information-Cell-SetupRqstTDD',
        'SCH-Information-Cell-SetupRqstTDD-ExtIEs',
        'SyncCaseIndicator-Cell-SetupRqstTDD-PSCH',
        'SyncCaseIndicatorIE-Cell-SetupRqstTDD-PSCH',
        'SyncCaseIndicatorItem-Cell-SetupRqstTDD-PSCH',
        'Case1-Cell-SetupRqstTDD',
        'Case1Item-Cell-SetupRqstTDD-ExtIEs',
        'Case2-Cell-SetupRqstTDD',
        'Case2Item-Cell-SetupRqstTDD-ExtIEs',
        'PCCPCH-Information-Cell-SetupRqstTDD',
        'PCCPCH-Information-Cell-SetupRqstTDD-ExtIEs',
        'TimeSlotConfigurationList-Cell-SetupRqstTDD',
        'TimeSlotConfigurationItem-Cell-SetupRqstTDD',
        'TimeSlotConfigurationItem-Cell-SetupRqstTDD-ExtIEs',
        'TimeSlotConfigurationList-LCR-Cell-SetupRqstTDD',
        'TimeSlotConfigurationItem-LCR-Cell-SetupRqstTDD',
        'TimeSlotConfigurationItem-LCR-Cell-SetupRqstTDD-ExtIEs',
        'PCCPCH-LCR-Information-Cell-SetupRqstTDD',
        'PCCPCH-LCR-Information-Cell-SetupRqstTDD-ExtIEs',
        'DwPCH-LCR-Information-Cell-SetupRqstTDD',
        'DwPCH-LCR-Information-Cell-SetupRqstTDD-ExtIEs',
        'IPDLParameter-Information-Cell-SetupRqstTDD',
        'IPDLParameter-Information-Cell-SetupRqstTDD-ExtIEs',
        'IPDLParameter-Information-LCR-Cell-SetupRqstTDD',
        'IPDLParameter-Information-LCR-Cell-SetupRqstTDD-ExtIEs',
        'PCCPCH-768-Information-Cell-SetupRqstTDD',
        'PCCPCH-768-Information-Cell-SetupRqstTDD-ExtIEs',
        'SCH-768-Information-Cell-SetupRqstTDD',
        'SCH-768-Information-Cell-SetupRqstTDD-ExtIEs',
        'Cell-Frequency-List-LCR-MulFreq-Cell-SetupRqstTDD',
        'Cell-Frequency-Item-LCR-MulFreq-Cell-SetupRqstTDD',
        'Cell-Frequency-Item-LCR-MulFreq-Cell-SetupRqstTDD-ExtIEs',
        'CellSetupResponse',
        'CellSetupResponse-IEs',
        'CellSetupResponse-Extensions',
        'CellSetupFailure',
        'CellSetupFailure-IEs',
        'CellSetupFailure-Extensions',
        'CellReconfigurationRequestFDD',
        'CellReconfigurationRequestFDD-IEs',
        'CellReconfigurationRequestFDD-Extensions',
        'Synchronisation-Configuration-Cell-ReconfRqst',
        'Synchronisation-Configuration-Cell-ReconfRqst-ExtIEs',
        'PrimarySCH-Information-Cell-ReconfRqstFDD',
        'PrimarySCH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'SecondarySCH-Information-Cell-ReconfRqstFDD',
        'SecondarySCH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'PrimaryCPICH-Information-Cell-ReconfRqstFDD',
        'PrimaryCPICH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'SecondaryCPICH-InformationList-Cell-ReconfRqstFDD',
        'SecondaryCPICH-InformationItemIE-Cell-ReconfRqstFDD',
        'SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD',
        'SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD-ExtIEs',
        'PrimaryCCPCH-Information-Cell-ReconfRqstFDD',
        'PrimaryCCPCH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'BCH-information-Cell-ReconfRqstFDD',
        'BCH-information-Cell-ReconfRqstFDD-ExtIEs',
        'IPDLParameter-Information-Cell-ReconfRqstFDD',
        'IPDLParameter-Information-Cell-ReconfRqstFDD-ExtIEs',
        'CellPortion-InformationList-Cell-ReconfRqstFDD',
        'CellPortion-InformationItemIE-Cell-ReconfRqstFDD',
        'CellPortion-InformationItem-Cell-ReconfRqstFDD',
        'CellPortion-InformationItem-Cell-ReconfRqstFDD-ExtIEs',
        'CellReconfigurationRequestTDD',
        'CellReconfigurationRequestTDD-IEs',
        'CellReconfigurationRequestTDD-Extensions',
        'SCH-Information-Cell-ReconfRqstTDD',
        'PSCH-Information-Cell-ReconfRqstTDD-ExtIEs',
        'PCCPCH-Information-Cell-ReconfRqstTDD',
        'PCCPCH-Information-Cell-ReconfRqstTDD-ExtIEs',
        'TimeSlotConfigurationList-Cell-ReconfRqstTDD',
        'TimeSlotConfigurationItem-Cell-ReconfRqstTDD',
        'TimeSlotConfigurationItem-Cell-ReconfRqstTDD-ExtIEs',
        'TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD',
        'TimeSlotConfigurationItem-LCR-Cell-ReconfRqstTDD',
        'TimeSlotConfigurationItem-LCR-Cell-ReconfRqstTDD-ExtIEs',
        'DwPCH-LCR-Information-Cell-ReconfRqstTDD',
        'DwPCH-LCR-Information-Cell-ReconfRqstTDD-ExtIEs',
        'IPDLParameter-Information-Cell-ReconfRqstTDD',
        'IPDLParameter-Information-Cell-ReconfRqstTDD-ExtIEs',
        'IPDLParameter-Information-LCR-Cell-ReconfRqstTDD',
        'IPDLParameter-Information-LCR-Cell-ReconfRqstTDD-ExtIEs',
        'SCH-768-Information-Cell-ReconfRqstTDD',
        'PSCH-768-Information-Cell-ReconfRqstTDD-ExtIEs',
        'PCCPCH-768-Information-Cell-ReconfRqstTDD',
        'PCCPCH-768-Information-Cell-ReconfRqstTDD-ExtIEs',
        'UARFCN-Adjustment',
        'Cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD',
        'Cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs',
        'Cell-Frequency-ModifyList-LCR-MulFreq-Cell-ReconfRqstTDD',
        'Cell-Frequency-ModifyItem-LCR-MulFreq-Cell-ReconfRqstTDD',
        'Cell-Frequency-ModifyItem-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs',
        'Cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD',
        'Cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs',
        'CellReconfigurationResponse',
        'CellReconfigurationResponse-IEs',
        'CellReconfigurationResponse-Extensions',
        'CellReconfigurationFailure',
        'CellReconfigurationFailure-IEs',
        'CellReconfigurationFailure-Extensions',
        'CellDeletionRequest',
        'CellDeletionRequest-IEs',
        'CellDeletionRequest-Extensions',
        'CellDeletionResponse',
        'CellDeletionResponse-IEs',
        'CellDeletionResponse-Extensions',
        'ResourceStatusIndication',
        'ResourceStatusIndication-IEs',
        'ResourceStatusIndication-Extensions',
        'IndicationType-ResourceStatusInd',
        'No-Failure-ResourceStatusInd',
        'No-FailureItem-ResourceStatusInd-ExtIEs',
        'Local-Cell-InformationList-ResourceStatusInd',
        'Local-Cell-InformationItemIE-ResourceStatusInd',
        'Local-Cell-InformationItem-ResourceStatusInd',
        'Local-Cell-InformationItem-ResourceStatusInd-ExtIEs',
        'Local-Cell-Group-InformationList-ResourceStatusInd',
        'Local-Cell-Group-InformationItemIE-ResourceStatusInd',
        'Local-Cell-Group-InformationItem-ResourceStatusInd',
        'Local-Cell-Group-InformationItem-ResourceStatusInd-ExtIEs',
        'Power-Local-Cell-Group-InformationList-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItemIE-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItem-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItem-ResourceStatusInd-ExtIEs',
        'ServiceImpacting-ResourceStatusInd',
        'ServiceImpactingItem-ResourceStatusInd-ExtIEs',
        'Local-Cell-InformationList2-ResourceStatusInd',
        'Local-Cell-InformationItemIE2-ResourceStatusInd',
        'Local-Cell-InformationItem2-ResourceStatusInd',
        'Local-Cell-InformationItem2-ResourceStatusInd-ExtIEs',
        'Local-Cell-Group-InformationList2-ResourceStatusInd',
        'Local-Cell-Group-InformationItemIE2-ResourceStatusInd',
        'Local-Cell-Group-InformationItem2-ResourceStatusInd',
        'Local-Cell-Group-InformationItem2-ResourceStatusInd-ExtIEs',
        'CCP-InformationList-ResourceStatusInd',
        'CCP-InformationItemIE-ResourceStatusInd',
        'CCP-InformationItem-ResourceStatusInd',
        'CCP-InformationItem-ResourceStatusInd-ExtIEs',
        'Cell-InformationList-ResourceStatusInd',
        'Cell-InformationItemIE-ResourceStatusInd',
        'Cell-InformationItem-ResourceStatusInd',
        'Cell-InformationItem-ResourceStatusInd-ExtIEs',
        'P-SCH-Information-ResourceStatusInd',
        'P-SCH-InformationIE-ResourceStatusInd',
        'S-SCH-Information-ResourceStatusInd',
        'S-SCH-InformationIE-ResourceStatusInd',
        'P-CPICH-Information-ResourceStatusInd',
        'P-CPICH-InformationIE-ResourceStatusInd',
        'S-CPICH-InformationList-ResourceStatusInd',
        'S-CPICH-InformationItemIE-ResourceStatusInd',
        'P-CCPCH-Information-ResourceStatusInd',
        'P-CCPCH-InformationIE-ResourceStatusInd',
        'BCH-Information-ResourceStatusInd',
        'BCH-InformationIE-ResourceStatusInd',
        'S-CCPCH-InformationList-ResourceStatusInd',
        'S-CCPCH-InformationItemIE-ResourceStatusInd',
        'PCH-Information-ResourceStatusInd',
        'PCH-InformationIE-ResourceStatusInd',
        'PICH-Information-ResourceStatusInd',
        'PICH-InformationIE-ResourceStatusInd',
        'FACH-InformationList-ResourceStatusInd',
        'FACH-InformationItemIE-ResourceStatusInd',
        'PRACH-InformationList-ResourceStatusInd',
        'PRACH-InformationItemIE-ResourceStatusInd',
        'RACH-InformationList-ResourceStatusInd',
        'RACH-InformationItemIE-ResourceStatusInd',
        'AICH-InformationList-ResourceStatusInd',
        'AICH-InformationItemIE-ResourceStatusInd',
        'SCH-Information-ResourceStatusInd',
        'SCH-InformationIE-ResourceStatusInd',
        'FPACH-LCR-InformationList-ResourceStatusInd',
        'FPACH-LCR-InformationItemIE-ResourceStatusInd',
        'DwPCH-LCR-Information-ResourceStatusInd',
        'DwPCH-LCR-InformationIE-ResourceStatusInd',
        'HS-DSCH-Resources-Information-ResourceStatusInd',
        'HS-DSCH-Resources-Information-ResourceStatusInd-ExtIEs',
        'S-CCPCH-InformationListExt-ResourceStatusInd',
        'S-CCPCH-LCR-InformationListExt-ResourceStatusInd',
        'E-DCH-Resources-Information-ResourceStatusInd',
        'E-DCH-Resources-Information-ResourceStatusInd-ExtIEs',
        'PLCCH-InformationList-ResourceStatusInd',
        'PLCCH-InformationItemIE-ResourceStatusInd',
        'S-CCPCH-768-InformationList-ResourceStatusInd',
        'S-CCPCH-768-InformationItemIE-ResourceStatusInd',
        'PRACH-768-InformationList-ResourceStatusInd',
        'PRACH-768-InformationItemIE-ResourceStatusInd',
        'E-RUCCH-InformationList-ResourceStatusInd',
        'E-RUCCH-InformationItemIE-ResourceStatusInd',
        'E-RUCCH-768-InformationList-ResourceStatusInd',
        'E-RUCCH-768-InformationItemIE-ResourceStatusInd',
        'Cell-Frequency-List-Information-LCR-MulFreq-ResourceStatusInd',
        'Cell-Frequency-List-InformationIE-LCR-MulFreq-ResourceStatusInd',
        'Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd',
        'Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd-ExtIEs',
        'UPPCH-LCR-InformationList-ResourceStatusInd',
        'UPPCH-LCR-InformationIE-ResourceStatusInd',
        'UPPCH-LCR-InformationItem-ResourceStatusInd',
        'UPPCH-LCR-InformationItem-ResourceStatusInd-ExtIEs',
        'MultipleFreq-HS-DSCH-Resources-InformationList-ResourceStatusInd',
        'MultipleFreq-HS-DSCH-Resources-InformationItem-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationList2-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItemIE2-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItem2-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItem2-ResourceStatusInd-ExtIEs',
        'MultipleFreq-E-DCH-Resources-InformationList-ResourceStatusInd',
        'MultipleFreq-E-DCH-Resources-InformationItem-ResourceStatusInd',
        'SystemInformationUpdateRequest',
        'SystemInformationUpdateRequest-IEs',
        'SystemInformationUpdateRequest-Extensions',
        'MIB-SB-SIB-InformationList-SystemInfoUpdateRqst',
        'MIB-SB-SIB-InformationItem-SystemInfoUpdateRqst',
        'MIB-SB-SIB-InformationItem-SystemInfoUpdateRqst-ExtIEs',
        'BCH-mappedOnSCCPCH-Indication',
        'DeletionIndicator-SystemInfoUpdate',
        'No-Deletion-SystemInfoUpdate',
        'No-DeletionItem-SystemInfoUpdate-ExtIEs',
        'SegmentInformationList-SystemInfoUpdate',
        'SegmentInformationListIEs-SystemInfoUpdate',
        'SegmentInformationListIE-SystemInfoUpdate',
        'SegmentInformationItem-SystemInfoUpdate',
        'SegmentInformationItem-SystemInfoUpdate-ExtIEs',
        'SystemInformationUpdateResponse',
        'SystemInformationUpdateResponse-IEs',
        'SystemInformationUpdateResponse-Extensions',
        'SystemInformationUpdateFailure',
        'SystemInformationUpdateFailure-IEs',
        'SystemInformationUpdateFailure-Extensions',
        'RadioLinkSetupRequestFDD',
        'RadioLinkSetupRequestFDD-IEs',
        'RadioLinkSetupRequestFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Setup-List',
        'Additional-HS-Cell-Information-RL-Setup-ItemIEs',
        'Additional-HS-Cell-Information-RL-Setup-ItemIEs-ExtIEs',
        'UL-DPCH-Information-RL-SetupRqstFDD',
        'UL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'DL-DPCH-Information-RL-SetupRqstFDD',
        'DL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'PowerOffsetInformation-RL-SetupRqstFDD',
        'PowerOffsetInformation-RL-SetupRqstFDD-ExtIEs',
        'RL-InformationList-RL-SetupRqstFDD',
        'RL-InformationItemIE-RL-SetupRqstFDD',
        'RL-InformationItem-RL-SetupRqstFDD',
        'RL-InformationItem-RL-SetupRqstFDD-ExtIEs',
        'E-DPCH-Information-RL-SetupRqstFDD',
        'E-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'F-DPCH-Information-RL-SetupRqstFDD',
        'F-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD',
        'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD-ExtIEs',
        'RadioLinkSetupRequestTDD',
        'RadioLinkSetupRequestTDD-IEs',
        'RadioLinkSetupRequestTDD-Extensions',
        'UL-CCTrCH-InformationList-RL-SetupRqstTDD',
        'UL-CCTrCH-InformationItemIE-RL-SetupRqstTDD',
        'UL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        'UL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'UL-DPCH-Information-RL-SetupRqstTDD',
        'UL-DPCH-InformationIE-RL-SetupRqstTDD',
        'UL-DPCH-InformationItem-RL-SetupRqstTDD',
        'UL-DPCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'UL-DPCH-LCR-Information-RL-SetupRqstTDD',
        'UL-DPCH-LCR-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'UL-DPCH-768-Information-RL-SetupRqstTDD',
        'UL-DPCH-768-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationList-RL-SetupRqstTDD',
        'DL-CCTrCH-InformationItemIE-RL-SetupRqstTDD',
        'DL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        'DL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'CCTrCH-TPCList-RL-SetupRqstTDD',
        'CCTrCH-TPCItem-RL-SetupRqstTDD',
        'CCTrCH-TPCItem-RL-SetupRqstTDD-ExtIEs',
        'DL-DPCH-Information-RL-SetupRqstTDD',
        'DL-DPCH-InformationIE-RL-SetupRqstTDD',
        'DL-DPCH-InformationItem-RL-SetupRqstTDD',
        'DL-DPCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'DL-DPCH-LCR-Information-RL-SetupRqstTDD',
        'DL-DPCH-LCR-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'DL-DPCH-768-Information-RL-SetupRqstTDD',
        'DL-DPCH-768-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'RL-Information-RL-SetupRqstTDD',
        'RL-Information-RL-SetupRqstTDD-ExtIEs',
        'RadioLinkSetupResponseFDD',
        'RadioLinkSetupResponseFDD-IEs',
        'RadioLinkSetupResponseFDD-Extensions',
        'Additional-HS-Cell-Information-Response-List',
        'Additional-HS-Cell-Information-Response-ItemIEs',
        'Additional-HS-Cell-Information-Response-ItemIEs-ExtIEs',
        'RL-InformationResponseList-RL-SetupRspFDD',
        'RL-InformationResponseItemIE-RL-SetupRspFDD',
        'RL-InformationResponseItem-RL-SetupRspFDD',
        'RL-InformationResponseItem-RL-SetupRspFDD-ExtIEs',
        'DiversityIndication-RL-SetupRspFDD',
        'Combining-RL-SetupRspFDD',
        'Combining-RL-SetupRspFDD-ExtIEs',
        'NonCombiningOrFirstRL-RL-SetupRspFDD',
        'NonCombiningOrFirstRLItem-RL-SetupRspFDD-ExtIEs',
        'RadioLinkSetupResponseTDD',
        'RadioLinkSetupResponseTDD-IEs',
        'RadioLinkSetupResponseTDD-Extensions',
        'RL-InformationResponse-RL-SetupRspTDD',
        'RL-InformationResponseList-RL-SetupRspTDD-ExtIEs',
        'DCH-InformationResponseList-RL-SetupRspTDD',
        'DCH-InformationResponseListIEs-RL-SetupRspTDD',
        'DSCH-InformationResponseList-RL-SetupRspTDD',
        'DSCH-InformationResponseListIEs-RL-SetupRspTDD',
        'USCH-InformationResponseList-RL-SetupRspTDD',
        'USCH-InformationResponseListIEs-RL-SetupRspTDD',
        'RL-InformationResponse-LCR-RL-SetupRspTDD',
        'RL-InformationResponseList-LCR-RL-SetupRspTDD-ExtIEs',
        'RadioLinkSetupFailureFDD',
        'RadioLinkSetupFailureFDD-IEs',
        'RadioLinkSetupFailureFDD-Extensions',
        'CauseLevel-RL-SetupFailureFDD',
        'GeneralCauseList-RL-SetupFailureFDD',
        'GeneralCauseItem-RL-SetupFailureFDD-ExtIEs',
        'RLSpecificCauseList-RL-SetupFailureFDD',
        'RLSpecificCauseItem-RL-SetupFailureFDD-ExtIEs',
        'Unsuccessful-RL-InformationRespList-RL-SetupFailureFDD',
        'Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureFDD',
        'Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD',
        'Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD-ExtIEs',
        'Successful-RL-InformationRespList-RL-SetupFailureFDD',
        'Successful-RL-InformationRespItemIE-RL-SetupFailureFDD',
        'Successful-RL-InformationRespItem-RL-SetupFailureFDD',
        'Successful-RL-InformationRespItem-RL-SetupFailureFDD-ExtIEs',
        'DiversityIndication-RL-SetupFailureFDD',
        'Combining-RL-SetupFailureFDD',
        'CombiningItem-RL-SetupFailureFDD-ExtIEs',
        'NonCombiningOrFirstRL-RL-SetupFailureFDD',
        'NonCombiningOrFirstRLItem-RL-SetupFailureFDD-ExtIEs',
        'RadioLinkSetupFailureTDD',
        'RadioLinkSetupFailureTDD-IEs',
        'RadioLinkSetupFailureTDD-Extensions',
        'CauseLevel-RL-SetupFailureTDD',
        'GeneralCauseList-RL-SetupFailureTDD',
        'GeneralCauseItem-RL-SetupFailureTDD-ExtIEs',
        'RLSpecificCauseList-RL-SetupFailureTDD',
        'RLSpecificCauseItem-RL-SetupFailureTDD-ExtIEs',
        'Unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD',
        'Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureTDD',
        'Unsuccessful-RL-InformationResp-RL-SetupFailureTDD',
        'Unsuccessful-RL-InformationResp-RL-SetupFailureTDD-ExtIEs',
        'RadioLinkAdditionRequestFDD',
        'RadioLinkAdditionRequestFDD-IEs',
        'RadioLinkAdditionRequestFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Addition-List',
        'Additional-EDCH-Cell-Information-RL-Add-Req',
        'Additional-EDCH-Cell-Information-RL-Add-Req-ExtIEs',
        'Setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency',
        'Additional-HS-Cell-Information-RL-Addition-ItemIEs',
        'Additional-HS-Cell-Information-RL-Addition-ItemIEs-ExtIEs',
        'RL-InformationList-RL-AdditionRqstFDD',
        'RL-InformationItemIE-RL-AdditionRqstFDD',
        'RL-InformationItem-RL-AdditionRqstFDD',
        'RL-InformationItem-RL-AdditionRqstFDD-ExtIEs',
        'E-DPCH-Information-RL-AdditionReqFDD',
        'E-DPCH-Information-RL-AdditionReqFDD-ExtIEs',
        'RadioLinkAdditionRequestTDD',
        'RadioLinkAdditionRequestTDD-IEs',
        'RadioLinkAdditionRequestTDD-Extensions',
        'UL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'UL-DPCH-InformationList-RL-AdditionRqstTDD',
        'UL-DPCH-InformationItemIE-RL-AdditionRqstTDD',
        'UL-DPCH-InformationItem-RL-AdditionRqstTDD',
        'UL-DPCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD',
        'UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD-ExtIEs',
        'UL-DPCH-InformationItem-768-RL-AdditionRqstTDD',
        'UL-DPCH-InformationItem-768-RL-AdditionRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'DL-DPCH-InformationList-RL-AdditionRqstTDD',
        'DL-DPCH-InformationItemIE-RL-AdditionRqstTDD',
        'DL-DPCH-InformationItem-RL-AdditionRqstTDD',
        'DL-DPCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD',
        'DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD-ExtIEs',
        'DL-DPCH-InformationItem-768-RL-AdditionRqstTDD',
        'DL-DPCH-InformationItem-768-RL-AdditionRqstTDD-ExtIEs',
        'RL-Information-RL-AdditionRqstTDD',
        'RL-information-RL-AdditionRqstTDD-ExtIEs',
        'RadioLinkAdditionResponseFDD',
        'RadioLinkAdditionResponseFDD-IEs',
        'RadioLinkAdditionResponseFDD-Extensions',
        'Additional-HS-Cell-Change-Information-Response-List',
        'Additional-HS-Cell-Change-Information-Response-ItemIEs',
        'Additional-HS-Cell-Change-Information-Response-ItemIEs-ExtIEs',
        'RL-InformationResponseList-RL-AdditionRspFDD',
        'RL-InformationResponseItemIE-RL-AdditionRspFDD',
        'RL-InformationResponseItem-RL-AdditionRspFDD',
        'RL-InformationResponseItem-RL-AdditionRspFDD-ExtIEs',
        'DiversityIndication-RL-AdditionRspFDD',
        'Combining-RL-AdditionRspFDD',
        'CombiningItem-RL-AdditionRspFDD-ExtIEs',
        'Non-Combining-RL-AdditionRspFDD',
        'Non-CombiningItem-RL-AdditionRspFDD-ExtIEs',
        'RadioLinkAdditionResponseTDD',
        'RadioLinkAdditionResponseTDD-IEs',
        'RadioLinkAdditionResponseTDD-Extensions',
        'RL-InformationResponse-RL-AdditionRspTDD',
        'RL-InformationResponse-RL-AdditionRspTDD-ExtIEs',
        'DCH-Information-RL-AdditionRspTDD',
        'DCH-Information-RL-AdditionRspTDD-ExtIEs',
        'DiversityIndication-RL-AdditionRspTDD',
        'Combining-RL-AdditionRspTDD',
        'CombiningItem-RL-AdditionRspTDD-ExtIEs',
        'Non-Combining-RL-AdditionRspTDD',
        'Non-CombiningItem-RL-AdditionRspTDD-ExtIEs',
        'DSCH-InformationResponseList-RL-AdditionRspTDD',
        'DSCH-InformationResponseListIEs-RL-AdditionRspTDD',
        'USCH-InformationResponseList-RL-AdditionRspTDD',
        'USCH-InformationResponseListIEs-RL-AdditionRspTDD',
        'RL-InformationResponse-LCR-RL-AdditionRspTDD',
        'RL-InformationResponse-LCR-RL-AdditionRspTDD-ExtIEs',
        'RadioLinkAdditionFailureFDD',
        'RadioLinkAdditionFailureFDD-IEs',
        'RadioLinkAdditionFailureFDD-Extensions',
        'CauseLevel-RL-AdditionFailureFDD',
        'GeneralCauseList-RL-AdditionFailureFDD',
        'GeneralCauseItem-RL-AdditionFailureFDD-ExtIEs',
        'RLSpecificCauseList-RL-AdditionFailureFDD',
        'RLSpecificCauseItem-RL-AdditionFailureFDD-ExtIEs',
        'Unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD',
        'Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureFDD',
        'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD',
        'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD-ExtIEs',
        'Successful-RL-InformationRespList-RL-AdditionFailureFDD',
        'Successful-RL-InformationRespItemIE-RL-AdditionFailureFDD',
        'Successful-RL-InformationRespItem-RL-AdditionFailureFDD',
        'Successful-RL-InformationRespItem-RL-AdditionFailureFDD-ExtIEs',
        'DiversityIndication-RL-AdditionFailureFDD',
        'Combining-RL-AdditionFailureFDD',
        'CombiningItem-RL-AdditionFailureFDD-ExtIEs',
        'Non-Combining-RL-AdditionFailureFDD',
        'Non-CombiningItem-RL-AdditionFailureFDD-ExtIEs',
        'RadioLinkAdditionFailureTDD',
        'RadioLinkAdditionFailureTDD-IEs',
        'RadioLinkAdditionFailureTDD-Extensions',
        'CauseLevel-RL-AdditionFailureTDD',
        'GeneralCauseList-RL-AdditionFailureTDD',
        'GeneralCauseItem-RL-AdditionFailureTDD-ExtIEs',
        'RLSpecificCauseList-RL-AdditionFailureTDD',
        'RLSpecificCauseItem-RL-AdditionFailureTDD-ExtIEs',
        'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD',
        'Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureTDD',
        'Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD',
        'Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD-ExtIEs',
        'RadioLinkReconfigurationPrepareFDD',
        'RadioLinkReconfigurationPrepareFDD-IEs',
        'RadioLinkReconfigurationPrepareFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Reconf-Prep',
        'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs',
        'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs-ExtIEs',
        'Additional-EDCH-Cell-Information-RL-Reconf-Prep',
        'Additional-EDCH-Cell-Information-RL-Reconf-Prep-ExtIEs',
        'UL-DPCH-Information-RL-ReconfPrepFDD',
        'UL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'DL-DPCH-Information-RL-ReconfPrepFDD',
        'DL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'DL-DPCH-Power-Information-RL-ReconfPrepFDD',
        'DL-DPCH-Power-Information-RL-ReconfPrepFDD-ExtIEs',
        'PowerOffsetInformation-RL-ReconfPrepFDD',
        'PowerOffsetInformation-RL-ReconfPrepFDD-ExtIEs',
        'DCH-DeleteList-RL-ReconfPrepFDD',
        'DCH-DeleteItem-RL-ReconfPrepFDD',
        'DCH-DeleteItem-RL-ReconfPrepFDD-ExtIEs',
        'RL-InformationList-RL-ReconfPrepFDD',
        'RL-InformationItemIE-RL-ReconfPrepFDD',
        'RL-InformationItem-RL-ReconfPrepFDD',
        'RL-InformationItem-RL-ReconfPrepFDD-ExtIEs',
        'E-DPCH-Information-RL-ReconfPrepFDD',
        'E-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'F-DPCH-Information-RL-ReconfPrepFDD',
        'F-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD',
        'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD-ExtIEs',
        'RadioLinkReconfigurationPrepareTDD',
        'RadioLinkReconfigurationPrepareTDD-IEs',
        'RadioLinkReconfigurationPrepareTDD-Extensions',
        'UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        'UL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD',
        'UL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-InformationAddList-RL-ReconfPrepTDD',
        'UL-DPCH-InformationAddListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationAddItem-RL-ReconfPrepTDD',
        'UL-DPCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD',
        'UL-DPCH-LCR-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-UL-DPCH-InformationAddList-RL-ReconfPrepTDD',
        'MultipleRL-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD',
        'MultipleRL-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-768-InformationAddList-RL-ReconfPrepTDD',
        'UL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        'UL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD',
        'UL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-AddListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-ModifyListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'UL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'UL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-TimeslotLCR-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'UL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'UL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDDLCR',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDDLCR',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDDLCR-ExtIEs',
        'UL-Timeslot768-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'UL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'UL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD768',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD768',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD768-ExtIEs',
        'UL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-DeleteListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD',
        'UL-DPCH-LCR-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-UL-DPCH-InformationModifyList-RL-ReconfPrepTDD',
        'MultipleRL-UL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD',
        'MultipleRL-UL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD',
        'UL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        'UL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD',
        'UL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'CCTrCH-TPCAddList-RL-ReconfPrepTDD',
        'CCTrCH-TPCAddItem-RL-ReconfPrepTDD',
        'CCTrCH-TPCAddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationAddList-RL-ReconfPrepTDD',
        'DL-DPCH-InformationAddListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationAddItem-RL-ReconfPrepTDD',
        'DL-DPCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD',
        'DL-DPCH-LCR-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-DL-DPCH-InformationAddList-RL-ReconfPrepTDD',
        'MultipleRL-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD',
        'MultipleRL-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD',
        'DL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'CCTrCH-TPCModifyList-RL-ReconfPrepTDD',
        'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD',
        'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-AddListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-ModifyListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Code-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Code-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Code-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Timeslot-768-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Code-768-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Code-768-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Code-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-DeleteListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD',
        'DL-DPCH-LCR-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-DL-DPCH-InformationModifyList-RL-ReconfPrepTDD',
        'MultipleRL-DL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD',
        'MultipleRL-DL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD',
        'DL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DCH-DeleteList-RL-ReconfPrepTDD',
        'DCH-DeleteItem-RL-ReconfPrepTDD',
        'DCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DSCH-Information-ModifyList-RL-ReconfPrepTDD',
        'DSCH-Information-ModifyItem-RL-ReconfPrepTDD',
        'DSCH-Information-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DSCH-Information-DeleteList-RL-ReconfPrepTDD',
        'DSCH-Information-DeleteItem-RL-ReconfPrepTDD',
        'DSCH-Information-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'USCH-Information-ModifyList-RL-ReconfPrepTDD',
        'USCH-Information-ModifyItem-RL-ReconfPrepTDD',
        'USCH-Information-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'USCH-Information-DeleteList-RL-ReconfPrepTDD',
        'USCH-Information-DeleteItem-RL-ReconfPrepTDD',
        'USCH-Information-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-Information-RL-ReconfPrepTDD',
        'RL-Information-RL-ReconfPrepTDD',
        'RL-Information-RL-ReconfPrepTDD-ExtIEs',
        'RadioLinkReconfigurationReady',
        'RadioLinkReconfigurationReady-IEs',
        'RadioLinkReconfigurationReady-Extensions',
        'RL-InformationResponseList-RL-ReconfReady',
        'RL-InformationResponseItemIE-RL-ReconfReady',
        'RL-InformationResponseItem-RL-ReconfReady',
        'RL-InformationResponseItem-RL-ReconfReady-ExtIEs',
        'DCH-InformationResponseList-RL-ReconfReady',
        'DCH-InformationResponseListIEs-RL-ReconfReady',
        'DSCH-InformationResponseList-RL-ReconfReady',
        'DSCH-InformationResponseListIEs-RL-ReconfReady',
        'USCH-InformationResponseList-RL-ReconfReady',
        'USCH-InformationResponseListIEs-RL-ReconfReady',
        'RadioLinkReconfigurationFailure',
        'RadioLinkReconfigurationFailure-IEs',
        'RadioLinkReconfigurationFailure-Extensions',
        'CauseLevel-RL-ReconfFailure',
        'GeneralCauseList-RL-ReconfFailure',
        'GeneralCauseItem-RL-ReconfFailure-ExtIEs',
        'RLSpecificCauseList-RL-ReconfFailure',
        'RLSpecificCauseItem-RL-ReconfFailure-ExtIEs',
        'RL-ReconfigurationFailureList-RL-ReconfFailure',
        'RL-ReconfigurationFailureItemIE-RL-ReconfFailure',
        'RL-ReconfigurationFailureItem-RL-ReconfFailure',
        'RL-ReconfigurationFailureItem-RL-ReconfFailure-ExtIEs',
        'RadioLinkReconfigurationCommit',
        'RadioLinkReconfigurationCommit-IEs',
        'RadioLinkReconfigurationCommit-Extensions',
        'RadioLinkReconfigurationCancel',
        'RadioLinkReconfigurationCancel-IEs',
        'RadioLinkReconfigurationCancel-Extensions',
        'RadioLinkReconfigurationRequestFDD',
        'RadioLinkReconfigurationRequestFDD-IEs',
        'RadioLinkReconfigurationRequestFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Reconf-Req',
        'Additional-HS-Cell-Information-RL-Reconf-Req-ItemIEs',
        'Additional-HS-Cell-Information-RL-Reconf-Req-ExtIEs',
        'Additional-EDCH-Cell-Information-RL-Reconf-Req',
        'Additional-EDCH-Cell-Information-RL-Reconf-Req-ExtIEs',
        'UL-DPCH-Information-RL-ReconfRqstFDD',
        'UL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        'DL-DPCH-Information-RL-ReconfRqstFDD',
        'DL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        'DCH-DeleteList-RL-ReconfRqstFDD',
        'DCH-DeleteItem-RL-ReconfRqstFDD',
        'DCH-DeleteItem-RL-ReconfRqstFDD-ExtIEs',
        'RL-InformationList-RL-ReconfRqstFDD',
        'RL-InformationItemIE-RL-ReconfRqstFDD',
        'RL-InformationItem-RL-ReconfRqstFDD',
        'RL-InformationItem-RL-ReconfRqstFDD-ExtIEs',
        'E-DPCH-Information-RL-ReconfRqstFDD',
        'E-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        'RadioLinkReconfigurationRequestTDD',
        'RadioLinkReconfigurationRequestTDD-IEs',
        'RadioLinkReconfigurationRequestTDD-Extensions',
        'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationModifyItemIE-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationDeleteItemIE-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationModifyItemIE-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        'MultipleRL-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'MultipleRL-DL-CCTrCH-InformationModifyListIE-RL-ReconfRqstTDD',
        'DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD',
        'DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD-ExtIEs',
        'DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD',
        'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfRqstTDD',
        'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationDeleteItemIE-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        'DCH-DeleteList-RL-ReconfRqstTDD',
        'DCH-DeleteItem-RL-ReconfRqstTDD',
        'DCH-DeleteItem-RL-ReconfRqstTDD-ExtIEs',
        'Multiple-RL-Information-RL-ReconfRqstTDD',
        'RL-Information-RL-ReconfRqstTDD',
        'RL-InformationItem-RL-ReconfRqstTDD-ExtIEs',
        'RadioLinkReconfigurationResponse',
        'RadioLinkReconfigurationResponse-IEs',
        'RadioLinkReconfigurationResponse-Extensions',
        'RL-InformationResponseList-RL-ReconfRsp',
        'RL-InformationResponseItemIE-RL-ReconfRsp',
        'RL-InformationResponseItem-RL-ReconfRsp',
        'RL-InformationResponseItem-RL-ReconfRsp-ExtIEs',
        'DCH-InformationResponseList-RL-ReconfRsp',
        'DCH-InformationResponseListIEs-RL-ReconfRsp',
        'RadioLinkDeletionRequest',
        'RadioLinkDeletionRequest-IEs',
        'RadioLinkDeletionRequest-Extensions',
        'RL-informationList-RL-DeletionRqst',
        'RL-informationItemIE-RL-DeletionRqst',
        'RL-informationItem-RL-DeletionRqst',
        'RL-informationItem-RL-DeletionRqst-ExtIEs',
        'RadioLinkDeletionResponse',
        'RadioLinkDeletionResponse-IEs',
        'RadioLinkDeletionResponse-Extensions',
        'DL-PowerControlRequest',
        'DL-PowerControlRequest-IEs',
        'DL-PowerControlRequest-Extensions',
        'DL-ReferencePowerInformationList-DL-PC-Rqst',
        'DL-ReferencePowerInformationItemIE-DL-PC-Rqst',
        'DL-ReferencePowerInformationItem-DL-PC-Rqst',
        'DL-ReferencePowerInformationItem-DL-PC-Rqst-ExtIEs',
        'DL-PowerTimeslotControlRequest',
        'DL-PowerTimeslotControlRequest-IEs',
        'DL-PowerTimeslotControlRequest-Extensions',
        'DedicatedMeasurementInitiationRequest',
        'DedicatedMeasurementInitiationRequest-IEs',
        'DedicatedMeasurementInitiationRequest-Extensions',
        'DedicatedMeasurementObjectType-DM-Rqst',
        'RL-DM-Rqst',
        'RLItem-DM-Rqst-ExtIEs',
        'RL-InformationList-DM-Rqst',
        'RL-InformationItemIE-DM-Rqst',
        'RL-InformationItem-DM-Rqst',
        'RL-InformationItem-DM-Rqst-ExtIEs',
        'PUSCH-Info-DM-Rqst',
        'HSSICH-Info-DM-Rqst',
        'HSSICH-InfoExt-DM-Rqst',
        'RL-Set-DM-Rqst',
        'RL-SetItem-DM-Rqst-ExtIEs',
        'RL-Set-InformationList-DM-Rqst',
        'RL-Set-InformationItem-DM-Rqst',
        'RL-Set-InformationItem-DM-Rqst-ExtIEs',
        'AllRL-DM-Rqst',
        'AllRL-Set-DM-Rqst',
        'DedicatedMeasurementInitiationResponse',
        'DedicatedMeasurementInitiationResponse-IEs',
        'DedicatedMeasurementInitiationResponse-Extensions',
        'DedicatedMeasurementObjectType-DM-Rsp',
        'RL-DM-Rsp',
        'RLItem-DM-Rsp-ExtIEs',
        'RL-InformationList-DM-Rsp',
        'RL-InformationItemIE-DM-Rsp',
        'RL-InformationItem-DM-Rsp',
        'RL-InformationItem-DM-Rsp-ExtIEs',
        'PUSCH-Info-DM-Rsp',
        'Multiple-PUSCH-InfoList-DM-Rsp',
        'Multiple-PUSCH-InfoListIE-DM-Rsp',
        'Multiple-PUSCH-InfoListIE-DM-Rsp-ExtIEs',
        'Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp',
        'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp',
        'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        'Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp',
        'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp',
        'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp-ExtIEs',
        'Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp',
        'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp',
        'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        'Multiple-DedicatedMeasurementValueList-768-TDD-DM-Rsp',
        'Multiple-DedicatedMeasurementValueItem-768-TDD-DM-Rsp',
        'Multiple-DedicatedMeasurementValueItem-768-TDD-DM-Rsp-ExtIEs',
        'RL-Set-DM-Rsp',
        'RL-SetItem-DM-Rsp-ExtIEs',
        'RL-Set-InformationList-DM-Rsp',
        'RL-Set-InformationItemIE-DM-Rsp',
        'RL-Set-InformationItem-DM-Rsp',
        'RL-Set-InformationItem-DM-Rsp-ExtIEs',
        'DedicatedMeasurementInitiationFailure',
        'DedicatedMeasurementInitiationFailure-IEs',
        'DedicatedMeasurementInitiationFailure-Extensions',
        'DedicatedMeasurementReport',
        'DedicatedMeasurementReport-IEs',
        'DedicatedMeasurementReport-Extensions',
        'DedicatedMeasurementObjectType-DM-Rprt',
        'RL-DM-Rprt',
        'RLItem-DM-Rprt-ExtIEs',
        'RL-InformationList-DM-Rprt',
        'RL-InformationItemIE-DM-Rprt',
        'RL-InformationItem-DM-Rprt',
        'RL-InformationItem-DM-Rprt-ExtIEs',
        'PUSCH-Info-DM-Rprt',
        'Multiple-PUSCH-InfoList-DM-Rprt',
        'Multiple-PUSCH-InfoListIE-DM-Rprt',
        'Multiple-PUSCH-InfoListIE-DM-Rprt-ExtIEs',
        'RL-Set-DM-Rprt',
        'RL-SetItem-DM-Rprt-ExtIEs',
        'RL-Set-InformationList-DM-Rprt',
        'RL-Set-InformationItemIE-DM-Rprt',
        'RL-Set-InformationItem-DM-Rprt',
        'RL-Set-InformationItem-DM-Rprt-ExtIEs',
        'DedicatedMeasurementTerminationRequest',
        'DedicatedMeasurementTerminationRequest-IEs',
        'DedicatedMeasurementTerminationRequest-Extensions',
        'DedicatedMeasurementFailureIndication',
        'DedicatedMeasurementFailureIndication-IEs',
        'DedicatedMeasurementFailureIndication-Extensions',
        'RadioLinkFailureIndication',
        'RadioLinkFailureIndication-IEs',
        'RadioLinkFailureIndication-Extensions',
        'Reporting-Object-RL-FailureInd',
        'RL-RL-FailureInd',
        'RLItem-RL-FailureInd-ExtIEs',
        'RL-InformationList-RL-FailureInd',
        'RL-InformationItemIE-RL-FailureInd',
        'RL-InformationItem-RL-FailureInd',
        'RL-InformationItem-RL-FailureInd-ExtIEs',
        'RL-Set-RL-FailureInd',
        'RL-SetItem-RL-FailureInd-ExtIEs',
        'RL-Set-InformationList-RL-FailureInd',
        'RL-Set-InformationItemIE-RL-FailureInd',
        'RL-Set-InformationItem-RL-FailureInd',
        'RL-Set-InformationItem-RL-FailureInd-ExtIEs',
        'CCTrCH-RL-FailureInd',
        'CCTrCHItem-RL-FailureInd-ExtIEs',
        'CCTrCH-InformationList-RL-FailureInd',
        'CCTrCH-InformationItemIE-RL-FailureInd',
        'CCTrCH-InformationItem-RL-FailureInd',
        'CCTrCH-InformationItem-RL-FailureInd-ExtIEs',
        'RadioLinkPreemptionRequiredIndication',
        'RadioLinkPreemptionRequiredIndication-IEs',
        'RadioLinkPreemptionRequiredIndication-Extensions',
        'RL-InformationList-RL-PreemptRequiredInd',
        'RL-InformationItemIE-RL-PreemptRequiredInd',
        'RL-InformationItem-RL-PreemptRequiredInd',
        'RL-InformationItem-RL-PreemptRequiredInd-ExtIEs',
        'RadioLinkRestoreIndication',
        'RadioLinkRestoreIndication-IEs',
        'RadioLinkRestoreIndication-Extensions',
        'Reporting-Object-RL-RestoreInd',
        'RL-RL-RestoreInd',
        'RLItem-RL-RestoreInd-ExtIEs',
        'RL-InformationList-RL-RestoreInd',
        'RL-InformationItemIE-RL-RestoreInd',
        'RL-InformationItem-RL-RestoreInd',
        'RL-InformationItem-RL-RestoreInd-ExtIEs',
        'RL-Set-RL-RestoreInd',
        'RL-SetItem-RL-RestoreInd-ExtIEs',
        'RL-Set-InformationList-RL-RestoreInd',
        'RL-Set-InformationItemIE-RL-RestoreInd',
        'RL-Set-InformationItem-RL-RestoreInd',
        'RL-Set-InformationItem-RL-RestoreInd-ExtIEs',
        'CCTrCH-RL-RestoreInd',
        'CCTrCHItem-RL-RestoreInd-ExtIEs',
        'CCTrCH-InformationList-RL-RestoreInd',
        'CCTrCH-InformationItemIE-RL-RestoreInd',
        'CCTrCH-InformationItem-RL-RestoreInd',
        'CCTrCH-InformationItem-RL-RestoreInd-ExtIEs',
        'CompressedModeCommand',
        'CompressedModeCommand-IEs',
        'CompressedModeCommand-Extensions',
        'ErrorIndication',
        'ErrorIndication-IEs',
        'ErrorIndication-Extensions',
        'PrivateMessage',
        'PrivateMessage-IEs',
        'PhysicalSharedChannelReconfigurationRequestFDD',
        'PhysicalSharedChannelReconfigurationRequestFDD-IEs',
        'PhysicalSharedChannelReconfigurationRequestFDD-Extensions',
        'HSDPA-And-EDCH-CellPortion-InformationList-PSCH-ReconfRqst',
        'HSDPA-And-EDCH-CellPortion-InformationItem-PSCH-ReconfRqst',
        'HSDPA-And-EDCH-CellPortion-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'PhysicalSharedChannelReconfigurationRequestTDD',
        'PhysicalSharedChannelReconfigurationRequestTDD-IEs',
        'PhysicalSharedChannelReconfigurationRequestTDD-Extensions',
        'PDSCHSets-AddList-PSCH-ReconfRqst',
        'PDSCHSets-AddItem-PSCH-ReconfRqst',
        'PDSCHSets-AddItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-Information-AddList-PSCH-ReconfRqst',
        'PDSCH-Information-AddListIEs-PSCH-ReconfRqst',
        'PDSCH-Information-AddItem-PSCH-ReconfRqst',
        'PDSCH-Information-AddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationAddList-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddItem-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationAddList-PSCH-ReconfRqst',
        'DL-Code-InformationAddItem-PSCH-ReconfRqst',
        'DL-Code-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst',
        'PDSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationAddList-LCR-PSCH-ReconfRqst',
        'DL-Code-InformationAddItem-LCR-PSCH-ReconfRqst',
        'DL-Code-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-AddInformation-768-AddItem-PSCH-ReconfRqst',
        'PDSCH-AddInformation-768-AddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationAddList-768-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationAddList-768-PSCH-ReconfRqst',
        'DL-Code-InformationAddItem-768-PSCH-ReconfRqst',
        'DL-Code-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'PDSCHSets-ModifyList-PSCH-ReconfRqst',
        'PDSCHSets-ModifyItem-PSCH-ReconfRqst',
        'PDSCHSets-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-Information-ModifyList-PSCH-ReconfRqst',
        'PDSCH-Information-ModifyListIEs-PSCH-ReconfRqst',
        'PDSCH-Information-ModifyItem-PSCH-ReconfRqst',
        'PDSCH-Information-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationModifyList-PSCH-ReconfRqst',
        'DL-Timeslot-InformationModifyItem-PSCH-ReconfRqst',
        'DL-Timeslot-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationModifyList-PSCH-ReconfRqst',
        'DL-Code-InformationModifyItem-PSCH-ReconfRqst',
        'DL-Code-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst',
        'PDSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst',
        'DL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst',
        'DL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-LCR-InformationModifyList-PSCH-ReconfRqst',
        'DL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst',
        'DL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst',
        'PDSCH-ModifyInformation-768-ModifyListIE-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst',
        'DL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst',
        'DL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-768-InformationModifyList-PSCH-ReconfRqst',
        'DL-Code-768-InformationModifyItem-PSCH-ReconfRqst',
        'DL-Code-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCHSets-DeleteList-PSCH-ReconfRqst',
        'PDSCHSets-DeleteItem-PSCH-ReconfRqst',
        'PDSCHSets-DeleteItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCHSets-AddList-PSCH-ReconfRqst',
        'PUSCHSets-AddItem-PSCH-ReconfRqst',
        'PUSCHSets-AddItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-Information-AddList-PSCH-ReconfRqst',
        'PUSCH-Information-AddListIEs-PSCH-ReconfRqst',
        'PUSCH-Information-AddItem-PSCH-ReconfRqst',
        'PUSCH-Information-AddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationAddList-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddItem-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationAddList-PSCH-ReconfRqst',
        'UL-Code-InformationAddItem-PSCH-ReconfRqst',
        'UL-Code-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst',
        'PUSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationAddList-LCR-PSCH-ReconfRqst',
        'UL-Code-InformationAddItem-LCR-PSCH-ReconfRqst',
        'UL-Code-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-AddInformation-768-AddItem-PSCH-ReconfRqst',
        'PUSCH-AddInformation-768-AddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationAddList-768-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationAddList-768-PSCH-ReconfRqst',
        'UL-Code-InformationAddItem-768-PSCH-ReconfRqst',
        'UL-Code-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'PUSCHSets-ModifyList-PSCH-ReconfRqst',
        'PUSCHSets-ModifyItem-PSCH-ReconfRqst',
        'PUSCHSets-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-Information-ModifyList-PSCH-ReconfRqst',
        'PUSCH-Information-ModifyListIEs-PSCH-ReconfRqst',
        'PUSCH-Information-ModifyItem-PSCH-ReconfRqst',
        'PUSCH-Information-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationModifyList-PSCH-ReconfRqst',
        'UL-Timeslot-InformationModifyItem-PSCH-ReconfRqst',
        'UL-Timeslot-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationModifyList-PSCH-ReconfRqst',
        'UL-Code-InformationModifyItem-PSCH-ReconfRqst',
        'UL-Code-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst',
        'PUSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst',
        'UL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst',
        'UL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-LCR-InformationModifyList-PSCH-ReconfRqst',
        'UL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst',
        'UL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst',
        'PUSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst',
        'UL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst',
        'UL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-768-InformationModifyList-PSCH-ReconfRqst',
        'UL-Code-768-InformationModifyItem-PSCH-ReconfRqst',
        'UL-Code-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCHSets-DeleteList-PSCH-ReconfRqst',
        'PUSCHSets-DeleteItem-PSCH-ReconfRqst',
        'PUSCHSets-DeleteItem-PSCH-ReconfRqst-ExtIEs',
        'HS-PDSCH-TDD-Information-PSCH-ReconfRqst',
        'HS-PDSCH-TDD-Information-PSCH-ReconfRqst-ExtIEs',
        'DL-HS-PDSCH-Timeslot-Information-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-InformationItem-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'DL-HS-PDSCH-Codelist-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-Information-768-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-InformationItem-768-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-InformationItem-768-PSCH-ReconfRqst-ExtIEs',
        'DL-HS-PDSCH-Codelist-768-PSCH-ReconfRqst',
        'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst',
        'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItemIE-PSCH-ReconfRqst',
        'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst',
        'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst-ExtIEs',
        'Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-Information-PSCH-ReconfRqst',
        'HS-SCCH-InformationItem-PSCH-ReconfRqst',
        'HS-SCCH-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-Information-PSCH-ReconfRqst',
        'HS-SICH-Information-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-Information-LCR-PSCH-ReconfRqst',
        'HS-SCCH-InformationItem-LCR-PSCH-ReconfRqst',
        'HS-SCCH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-Information-LCR-PSCH-ReconfRqst',
        'HS-SICH-Information-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-Information-768-PSCH-ReconfRqst',
        'HS-SCCH-InformationItem-768-PSCH-ReconfRqst',
        'HS-SCCH-InformationItem-768-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-Information-768-PSCH-ReconfRqst',
        'HS-SICH-Information-768-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationExt-LCR-PSCH-ReconfRqst',
        'Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationModifyItem-PSCH-ReconfRqst',
        'HS-SCCH-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-InformationModify-PSCH-ReconfRqst',
        'HS-SICH-InformationModify-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationModify-LCR-PSCH-ReconfRqst',
        'HS-SCCH-InformationModifyItem-LCR-PSCH-ReconfRqst',
        'HS-SCCH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationModifyExt-LCR-PSCH-ReconfRqst',
        'HS-SICH-InformationModify-LCR-PSCH-ReconfRqst',
        'HS-SICH-InformationModify-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationModify-768-PSCH-ReconfRqst',
        'HS-SCCH-InformationModifyItem-768-PSCH-ReconfRqst',
        'HS-SCCH-InformationModifyItem-768-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-InformationModify-768-PSCH-ReconfRqst',
        'HS-SICH-InformationModify-768-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationModify-PSCH-ReconfRqst',
        'Delete-From-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'Delete-From-HS-SCCH-Resource-PoolItem-PSCH-ReconfRqst',
        'Delete-From-HS-SCCH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Information-PSCH-ReconfRqst',
        'E-PUCH-Information-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Timeslot-Info',
        'Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-Information-PSCH-ReconfRqst',
        'E-AGCH-InformationItem-PSCH-ReconfRqst',
        'E-AGCH-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationModify-PSCH-ReconfRqst',
        'E-AGCH-InformationModifyItem-PSCH-ReconfRqst',
        'E-AGCH-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'Delete-From-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'Delete-From-E-AGCH-Resource-PoolItem-PSCH-ReconfRqst',
        'Delete-From-E-AGCH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-Information-PSCH-ReconfRqst',
        'E-HICH-Information-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Information-768-PSCH-ReconfRqst',
        'E-PUCH-Information-768-PSCH-ReconfRqst-ExtIEs',
        'Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst',
        'Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-Information-768-PSCH-ReconfRqst',
        'E-AGCH-InformationItem-768-PSCH-ReconfRqst',
        'E-AGCH-InformationItem-768-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst',
        'Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationModify-768-PSCH-ReconfRqst',
        'E-AGCH-InformationModifyItem-768-PSCH-ReconfRqst',
        'E-AGCH-InformationModifyItem-768-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-Information-768-PSCH-ReconfRqst',
        'E-HICH-Information-768-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Information-LCR-PSCH-ReconfRqst',
        'E-PUCH-Information-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Timeslot-InfoLCR',
        'E-PUCH-Timeslot-Item-InfoLCR',
        'E-PUCH-Timeslot-Item-InfoLCR-ExtIEs',
        'E-PUCH-Codelist-LCR',
        'Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-Information-LCR-PSCH-ReconfRqst',
        'E-AGCH-InformationItem-LCR-PSCH-ReconfRqst',
        'E-AGCH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationModify-LCR-PSCH-ReconfRqst',
        'E-AGCH-InformationModifyItem-LCR-PSCH-ReconfRqst',
        'E-AGCH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-Information-LCR-PSCH-ReconfRqst',
        'E-HICH-InformationItem-LCR-PSCH-ReconfRqst',
        'E-HICH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-InformationModify-LCR-PSCH-ReconfRqst',
        'E-HICH-InformationModifyItem-LCR-PSCH-ReconfRqst',
        'E-HICH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Delete-From-E-HICH-Resource-Pool-PSCH-ReconfRqst',
        'Delete-From-E-HICH-Resource-PoolItem-PSCH-ReconfRqst',
        'Delete-From-E-HICH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs',
        'SYNC-UL-Partition-LCR',
        'SYNC-UL-Partition-LCR-ExtIEs',
        'Delete-From-HS-SCCH-Resource-PoolExt-PSCH-ReconfRqst',
        'MultipleFreq-E-PUCH-Timeslot-InformationList-LCR-PSCH-ReconfRqst',
        'MultipleFreq-E-PUCH-Timeslot-InformationItemIE-LCR-PSCH-ReconfRqst',
        'MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst',
        'MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst-ExtIEs',
        'Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst',
        'Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst-Item',
        'Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst-Item-ExtIEs',
        'Max-RTWP-perCellPortion-InformationList-LCR-PSCH-ReconfRqst',
        'Max-RTWP-perCellPortion-InformationItem-LCR-PSCH-ReconfRqst',
        'Max-RTWP-perCellPortion-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'PhysicalSharedChannelReconfigurationResponse',
        'PhysicalSharedChannelReconfigurationResponse-IEs',
        'PhysicalSharedChannelReconfigurationResponse-Extensions',
        'E-HICH-TimeOffset-ExtensionLCR',
        'Multiple-E-HICH-TimeOffsetLCR',
        'MultipleFreq-E-HICH-TimeOffsetLCR',
        'MultipleFreq-E-HICH-TimeOffsetLCR-ExtIEs',
        'PhysicalSharedChannelReconfigurationFailure',
        'PhysicalSharedChannelReconfigurationFailure-IEs',
        'PhysicalSharedChannelReconfigurationFailure-Extensions',
        'CauseLevel-PSCH-ReconfFailure',
        'GeneralCauseList-PSCH-ReconfFailure',
        'GeneralCauseItem-PSCH-ReconfFailure-ExtIEs',
        'SetSpecificCauseList-PSCH-ReconfFailureTDD',
        'SetSpecificCauseItem-PSCH-ReconfFailureTDD-ExtIEs',
        'Unsuccessful-PDSCHSetList-PSCH-ReconfFailureTDD',
        'Unsuccessful-PDSCHSetItemIE-PSCH-ReconfFailureTDD',
        'Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD',
        'Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD-ExtIEs',
        'Unsuccessful-PUSCHSetList-PSCH-ReconfFailureTDD',
        'Unsuccessful-PUSCHSetItemIE-PSCH-ReconfFailureTDD',
        'Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD',
        'Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD-ExtIEs',
        'Extension-CauseLevel-PSCH-ReconfFailure',
        'Extension-CauseLevel-PSCH-ReconfFailureIE',
        'UARFCNSpecificCauseList-PSCH-ReconfFailureTDD',
        'Unsuccessful-UARFCNItemIE-PSCH-ReconfFailureTDD',
        'Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD',
        'Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD-ExtIEs',
        'E-HICH-TimeOffset-ReconfFailureTDD',
        'Common-System-Information-ResponseLCR',
        'Common-System-Information-ResponseLCR-ExtIEs',
        'ResetRequest',
        'ResetRequest-IEs',
        'ResetRequest-Extensions',
        'ResetIndicator',
        'CommunicationContextList-Reset',
        'CommunicationContextItem-Reset-ExtIEs',
        'CommunicationContextInfoList-Reset',
        'CommunicationContextInfoItemIE-Reset',
        'CommunicationContextInfoItem-Reset',
        'CommunicationContextInfoItem-Reset-ExtIEs',
        'CommunicationContextType-Reset',
        'CommunicationControlPortList-Reset',
        'CommunicationControlPortItem-Reset-ExtIEs',
        'CommunicationControlPortInfoList-Reset',
        'CommunicationControlPortInfoItemIE-Reset',
        'CommunicationControlPortInfoItem-Reset',
        'CommunicationControlPortInfoItem-Reset-ExtIEs',
        'ResetResponse',
        'ResetResponse-IEs',
        'ResetResponse-Extensions',
        'InformationExchangeInitiationRequest',
        'InformationExchangeInitiationRequest-IEs',
        'InformationExchangeInitiationRequest-Extensions',
        'InformationExchangeObjectType-InfEx-Rqst',
        'Cell-InfEx-Rqst',
        'CellItem-InfEx-Rqst-ExtIEs',
        'InformationExchangeInitiationResponse',
        'InformationExchangeInitiationResponse-IEs',
        'InformationExchangeInitiationResponse-Extensions',
        'InformationExchangeObjectType-InfEx-Rsp',
        'Cell-InfEx-Rsp',
        'CellItem-InfEx-Rsp-ExtIEs',
        'InformationExchangeInitiationFailure',
        'InformationExchangeInitiationFailure-IEs',
        'InformationExchangeInitiationFailure-Extensions',
        'InformationReport',
        'InformationReport-IEs',
        'InformationReport-Extensions',
        'InformationExchangeObjectType-InfEx-Rprt',
        'Cell-Inf-Rprt',
        'CellItem-Inf-Rprt-ExtIEs',
        'InformationExchangeTerminationRequest',
        'InformationExchangeTerminationRequest-IEs',
        'InformationExchangeTerminationRequest-Extensions',
        'InformationExchangeFailureIndication',
        'InformationExchangeFailureIndication-IEs',
        'InformationExchangeFailureIndication-Extensions',
        'CellSynchronisationInitiationRequestTDD',
        'CellSynchronisationInitiationRequestTDD-IEs',
        'CellSynchronisationInitiationRequestTDD-Extensions',
        'TimeslotInfo-CellSyncInitiationRqstTDD',
        'CellSyncBurstTransInit-CellSyncInitiationRqstTDD',
        'CellSyncBurstTransInit-CellSyncInitiationRqstTDD-ExtIEs',
        'CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD',
        'CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD-ExtIEs',
        'SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD',
        'SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD-ExtIEs',
        'SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD',
        'SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD-ExtIEs',
        'CellSynchronisationInitiationResponseTDD',
        'CellSynchronisationInitiationResponseTDD-Extensions',
        'CellSynchronisationInitiationResponseTDD-IEs',
        'CellSynchronisationInitiationFailureTDD',
        'CellSynchronisationInitiationFailureTDD-Extensions',
        'CellSynchronisationInitiationFailureTDD-IEs',
        'CellSynchronisationReconfigurationRequestTDD',
        'CellSynchronisationReconfigurationRequestTDD-IEs',
        'CellSynchronisationReconfigurationRequestTDD-Extensions',
        'CellSyncBurstTransReconfInfo-CellSyncReconfRqstTDD',
        'CellSyncBurstTransInfoItem-CellSyncReconfRqstTDD',
        'CellSyncBurstTransInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'CellSyncBurstMeasInfo-CellSyncReconfRqstTDD',
        'CellSyncBurstMeasInfo-CellSyncReconfRqstTDD-ExtIEs',
        'CellSyncBurstMeasInfoList-CellSyncReconfRqstTDD',
        'CellSyncBurstMeasInfoListIEs-CellSyncReconfRqstTDD',
        'SynchronisationReportTypeIE',
        'SynchronisationReportTypeIEs',
        'SynchronisationReportCharacteristicsIE',
        'SynchronisationReportCharacteristicsIEs',
        'CellSyncBurstMeasInfoListIE-CellSyncReconfRqstTDD',
        'CellSyncBurstMeasInfoItem-CellSyncReconfRqstTDD',
        'CellSyncBurstMeasInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'CellSyncBurstInfoList-CellSyncReconfRqstTDD',
        'CellSyncBurstInfoItem-CellSyncReconfRqstTDD',
        'CellSyncBurstInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdTransReconfItemLCR-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdMeasInfoLCR-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdMeasInfoLCR-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdMeasInfoList-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdMeasInfoItem-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdMeasInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdInfoListLCR-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdInfoItemLCR-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdInfoItemLCR-CellSyncReconfRqstTDD-ExtIEs',
        'CellSynchronisationReconfigurationResponseTDD',
        'CellSynchronisationReconfigurationResponseTDD-Extensions',
        'CellSynchronisationReconfigurationResponseTDD-IEs',
        'CellSynchronisationReconfigurationFailureTDD',
        'CellSynchronisationReconfigurationFailureTDD-Extensions',
        'CellSynchronisationReconfigurationFailureTDD-IEs',
        'CellSynchronisationAdjustmentRequestTDD',
        'CellSynchronisationAdjustmentRequestTDD-Extensions',
        'CellSynchronisationAdjustmentRequestTDD-IEs',
        'CellAdjustmentInfo-SyncAdjustmentRqstTDD',
        'CellAdjustmentInfoItemIE-SyncAdjustmntRqstTDD',
        'CellAdjustmentInfoItem-SyncAdjustmentRqstTDD',
        'CellAdjustmentInfoItem-SyncAdjustmntRqstTDD-ExtIEs',
        'CellSynchronisationAdjustmentResponseTDD',
        'CellSynchronisationAdjustmentResponseTDD-Extensions',
        'CellSynchronisationAdjustmentResponseTDD-IEs',
        'CellSynchronisationAdjustmentFailureTDD',
        'CellSynchronisationAdjustmentFailureTDD-Extensions',
        'CellSynchronisationAdjustmentFailureTDD-IEs',
        'CauseLevel-SyncAdjustmntFailureTDD',
        'GeneralCauseList-SyncAdjustmntFailureTDD',
        'GeneralCauseList-SyncAdjustmntFailureTDD-ExtIEs',
        'CellSpecificCauseList-SyncAdjustmntFailureTDD',
        'CellSpecificCauseList-SyncAdjustmntFailureTDD-ExtIEs',
        'Unsuccessful-cell-InformationRespList-SyncAdjustmntFailureTDD',
        'Unsuccessful-cell-InformationRespItemIE-SyncAdjustmntFailureTDD',
        'Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD',
        'Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD-ExtIEs',
        'CellSynchronisationTerminationRequestTDD',
        'CellSynchronisationTerminationRequestTDD-Extensions',
        'CellSynchronisationTerminationRequestTDD-IEs',
        'CellSynchronisationFailureIndicationTDD',
        'CellSynchronisationFailureIndicationTDD-Extensions',
        'CellSynchronisationFailureIndicationTDD-IEs',
        'CellSynchronisationReportTDD',
        'CellSynchronisationReportTDD-Extensions',
        'CellSynchronisationReportTDD-IEs',
        'CellSyncInfo-CellSyncReprtTDD',
        'CellSyncInfoItemIE-CellSyncReprtTDD',
        'C-ID-IE-CellSyncReprtTDD',
        'C-ID-IEs-CellSyncReprtTDD',
        'SyncReportTypeIE-CellSyncReprtTDD',
        'SyncReportTypeIEs-CellSyncReprtTDD',
        'SyncReportType-CellSyncReprtTDD',
        'IntStdPhCellSyncInfo-CellSyncReprtTDD',
        'IntStdPhCellSyncInfoList-CellSyncReprtTDD-ExtIEs',
        'CellSyncBurstMeasInfoList-CellSyncReprtTDD',
        'CellSyncBurstMeasInfoItem-CellSyncReprtTDD',
        'CellSyncBurstMeasInfoItem-CellSyncReprtTDD-ExtIEs',
        'CellSyncBurstInfo-CellSyncReprtTDD',
        'CellSyncBurstAvailable-CellSyncReprtTDD',
        'CellSyncBurstAvailable-CellSyncReprtTDD-ExtIEs',
        'SyncDLCodeIdsMeasInfoList-CellSyncReprtTDD',
        'SyncDLCodeIdsMeasInfoItem-CellSyncReprtTDD',
        'SyncDLCodeIdsMeasInfoItem-CellSyncReprtTDD-ExtIEs',
        'SyncDLCodeIdInfo-CellSyncReprtTDD',
        'SyncDLCodeIdItem-CellSyncReprtTDD',
        'SyncDLCodeIdAvailable-CellSyncReprtTDD',
        'SyncDLCodeIdAvailable-CellSyncReprtTDD-ExtIEs',
        'BearerRearrangementIndication',
        'BearerRearrangementIndication-IEs',
        'BearerRearrangementIndication-Extensions',
        'DCH-RearrangeList-Bearer-RearrangeInd',
        'DCH-RearrangeItem-Bearer-RearrangeInd',
        'DCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'DSCH-RearrangeList-Bearer-RearrangeInd',
        'DSCH-RearrangeItem-Bearer-RearrangeInd',
        'DSCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'USCH-RearrangeList-Bearer-RearrangeInd',
        'USCH-RearrangeItem-Bearer-RearrangeInd',
        'USCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'HSDSCH-RearrangeList-Bearer-RearrangeInd',
        'HSDSCH-RearrangeItem-Bearer-RearrangeInd',
        'HSDSCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'E-DCH-RearrangeList-Bearer-RearrangeInd',
        'E-DCH-RearrangeItem-Bearer-RearrangeInd',
        'E-DCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'Additional-EDCH-Cell-Information-Bearer-Rearrangement-List',
        'Additional-EDCH-Cell-Information-Bearer-Rearrangement-ItemIEs',
        'Additional-EDCH-Cell-Information-Bearer-Rearrangement-ItemIEs-ExtIEs',
        'Transport-Bearer-Rearrangement-Indicator-for-Additional-EDCH-Separate-Mode',
        'RadioLinkActivationCommandFDD',
        'RadioLinkActivationCommandFDD-IEs',
        'RadioLinkActivationCommandFDD-Extensions',
        'DelayedActivationInformationList-RL-ActivationCmdFDD',
        'DelayedActivationInformation-RL-ActivationCmdFDD-IEs',
        'DelayedActivationInformation-RL-ActivationCmdFDD',
        'DelayedActivationInformation-RL-ActivationCmdFDD-ExtIEs',
        'RadioLinkActivationCommandTDD',
        'RadioLinkActivationCommandTDD-IEs',
        'RadioLinkActivationCommandTDD-Extensions',
        'DelayedActivationInformationList-RL-ActivationCmdTDD',
        'DelayedActivationInformation-RL-ActivationCmdTDD-IEs',
        'DelayedActivationInformation-RL-ActivationCmdTDD',
        'DelayedActivationInformation-RL-ActivationCmdTDD-ExtIEs',
        'RadioLinkParameterUpdateIndicationFDD',
        'RadioLinkParameterUpdateIndicationFDD-IEs',
        'RadioLinkParameterUpdateIndicationFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Param-Upd',
        'Additional-HS-Cell-Information-RL-Param-Upd-ItemIEs',
        'Additional-HS-Cell-Information-RL-Setup-ExtIEs',
        'Additional-EDCH-Cell-Information-RL-Param-Upd',
        'Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs',
        'Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs-ExtIEs',
        'UE-Measurement-Forwarding',
        'UE-Measurement-Forwarding-ExtIEs',
        'RadioLinkParameterUpdateIndicationTDD',
        'RadioLinkParameterUpdateIndicationTDD-IEs',
        'RadioLinkParameterUpdateIndicationTDD-Extensions',
        'MBMSNotificationUpdateCommand',
        'MBMSNotificationUpdateCommand-IEs',
        'MBMSNotificationUpdateCommand-Extensions',
        'UEStatusUpdateCommand',
        'UEStatusUpdateCommand-IEs',
        'UEStatusUpdateCommand-Extensions',
        'SecondaryULFrequencyReport',
        'SecondaryULFrequencyReport-IEs',
        'SecondaryULFrequencyReport-Extensions',
        'SecondaryULFrequencyUpdateIndication',
        'SecondaryULFrequencyUpdateIndication-IEs',
        'SecondaryULFrequencyUpdateIndication-Extensions',
        'UEStatusUpdateConfirmRequest',
        'UEStatusUpdateConfirmRequest-IEs',
        'UEStatusUpdateConfirmRequest-Extensions',
        'UEStatusUpdateConfirmResponse',
        'UEStatusUpdateConfirmResponse-IEs',
        'UEStatusUpdateConfirmResponse-Extensions',
        ]
    _type_ = [
        'CommonTransportChannelSetupRequestFDD',
        'CommonPhysicalChannelType-CTCH-SetupRqstFDD',
        'Secondary-CCPCH-CTCH-SetupRqstFDD',
        'PowerOffsetInformation-CTCH-SetupRqstFDD',
        'FACH-ParametersList-CTCH-SetupRqstFDD',
        'FACH-ParametersListIE-CTCH-SetupRqstFDD',
        'FACH-ParametersItem-CTCH-SetupRqstFDD',
        'PCH-Parameters-CTCH-SetupRqstFDD',
        'PCH-ParametersItem-CTCH-SetupRqstFDD',
        'PICH-Parameters-CTCH-SetupRqstFDD',
        'MICH-Parameters-CTCH-SetupRqstFDD',
        'PRACH-CTCH-SetupRqstFDD',
        'AllowedSlotFormatInformationList-CTCH-SetupRqstFDD',
        'AllowedSlotFormatInformationItem-CTCH-SetupRqstFDD',
        'RACH-Parameters-CTCH-SetupRqstFDD',
        'RACH-ParametersItem-CTCH-SetupRqstFDD',
        'AICH-Parameters-CTCH-SetupRqstFDD',
        'CommonTransportChannelSetupRequestTDD',
        'CommonPhysicalChannelType-CTCH-SetupRqstTDD',
        'Extension-CommonPhysicalChannelType-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-parameterList-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-parameterListIE-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-parameterItem-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-LCR-parameterList-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-LCR-parameterItem-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-768-parameterList-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-768-parameterItem-CTCH-SetupRqstTDD',
        'FACH-ParametersList-CTCH-SetupRqstTDD',
        'FACH-ParametersListIE-CTCH-SetupRqstTDD',
        'FACH-ParametersItem-CTCH-SetupRqstTDD',
        'PCH-Parameters-CTCH-SetupRqstTDD',
        'PCH-ParametersItem-CTCH-SetupRqstTDD',
        'PICH-Parameters-CTCH-SetupRqstTDD',
        'PICH-ParametersItem-CTCH-SetupRqstTDD',
        'PICH-LCR-Parameters-CTCH-SetupRqstTDD',
        'PICH-768-ParametersItem-CTCH-SetupRqstTDD',
        'MICH-Parameters-CTCH-SetupRqstTDD',
        'MICH-TDDOption-Specific-Parameters-CTCH-SetupRqstTDD',
        'MICH-HCR-Parameters-CTCH-SetupRqstTDD',
        'MICH-LCR-Parameters-CTCH-SetupRqstTDD',
        'MICH-768-Parameters-CTCH-SetupRqstTDD',
        'TimeSlotConfigurationList-LCR-CTCH-SetupRqstTDD',
        'TimeSlotConfigurationItem-LCR-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-parameterExtendedList-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-LCR-parameterExtendedList-CTCH-SetupRqstTDD',
        'PRACH-CTCH-SetupRqstTDD',
        'PRACH-Parameters-CTCH-SetupRqstTDD',
        'PRACH-ParametersItem-CTCH-SetupRqstTDD',
        'RACH-Parameter-CTCH-SetupRqstTDD',
        'RACH-ParameterItem-CTCH-SetupRqstTDD',
        'PRACH-LCR-ParametersList-CTCH-SetupRqstTDD',
        'PRACH-LCR-ParametersItem-CTCH-SetupRqstTDD',
        'PRACH-768-ParametersItem-CTCH-SetupRqstTDD',
        'FPACH-LCR-Parameters-CTCH-SetupRqstTDD',
        'PLCCH-parameters',
        'E-RUCCH-parameters',
        'E-RUCCH-768-parameters',
        'CommonTransportChannelSetupResponse',
        'FACH-CommonTransportChannel-InformationResponse',
        'CommonTransportChannelSetupFailure',
        'CommonTransportChannelReconfigurationRequestFDD',
        'CommonPhysicalChannelType-CTCH-ReconfRqstFDD',
        'Secondary-CCPCHList-CTCH-ReconfRqstFDD',
        'FACH-ParametersList-CTCH-ReconfRqstFDD',
        'FACH-ParametersListIE-CTCH-ReconfRqstFDD',
        'FACH-ParametersItem-CTCH-ReconfRqstFDD',
        'PCH-Parameters-CTCH-ReconfRqstFDD',
        'PCH-ParametersItem-CTCH-ReconfRqstFDD',
        'PICH-Parameters-CTCH-ReconfRqstFDD',
        'PICH-ParametersItem-CTCH-ReconfRqstFDD',
        'MICH-Parameters-CTCH-ReconfRqstFDD',
        'BCH-Parameters-CTCH-ReconfRqstFDD',
        'PRACHList-CTCH-ReconfRqstFDD',
        'PRACH-ParametersList-CTCH-ReconfRqstFDD',
        'PRACH-ParametersListIE-CTCH-ReconfRqstFDD',
        'PRACH-ParametersItem-CTCH-ReconfRqstFDD',
        'AllowedSlotFormatInformationList-CTCH-ReconfRqstFDD',
        'AllowedSlotFormatInformationItem-CTCH-ReconfRqstFDD',
        'AICH-ParametersList-CTCH-ReconfRqstFDD',
        'AICH-ParametersListIE-CTCH-ReconfRqstFDD',
        'AICH-ParametersItem-CTCH-ReconfRqstFDD',
        'CommonTransportChannelReconfigurationRequestTDD',
        'Secondary-CCPCH-Parameters-CTCH-ReconfRqstTDD',
        'Secondary-CCPCHList-CTCH-ReconfRqstTDD',
        'Secondary-CCPCHListIE-CTCH-ReconfRqstTDD',
        'Secondary-CCPCHItem-CTCH-ReconfRqstTDD',
        'Secondary-CCPCH-parameterExtendedList-CTCH-ReconfRqstTDD',
        'Secondary-CCPCH-LCR-parameterExtendedList-CTCH-ReconfRqstTDD',
        'PICH-Parameters-CTCH-ReconfRqstTDD',
        'FACH-ParametersList-CTCH-ReconfRqstTDD',
        'FACH-ParametersItem-CTCH-ReconfRqstTDD',
        'PCH-Parameters-CTCH-ReconfRqstTDD',
        'FPACH-LCR-Parameters-CTCH-ReconfRqstTDD',
        'MICH-Parameters-CTCH-ReconfRqstTDD',
        'PLCCH-Parameters-CTCH-ReconfRqstTDD',
        'Secondary-CCPCH-768-Parameters-CTCH-ReconfRqstTDD',
        'Secondary-CCPCH-768-List-CTCH-ReconfRqstTDD',
        'Secondary-CCPCH-768-Item-CTCH-ReconfRqstTDD',
        'PICH-768-Parameters-CTCH-ReconfRqstTDD',
        'MICH-768-Parameters-CTCH-ReconfRqstTDD',
        'UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD',
        'CommonTransportChannelReconfigurationResponse',
        'CommonTransportChannelReconfigurationFailure',
        'CommonTransportChannelDeletionRequest',
        'CommonTransportChannelDeletionResponse',
        'BlockResourceRequest',
        'BlockResourceResponse',
        'BlockResourceFailure',
        'UnblockResourceIndication',
        'AuditRequiredIndication',
        'AuditRequest',
        'AuditResponse',
        'Cell-InformationList-AuditRsp',
        'Cell-InformationItem-AuditRsp',
        'P-SCH-Information-AuditRsp',
        'S-SCH-Information-AuditRsp',
        'P-CPICH-Information-AuditRsp',
        'S-CPICH-InformationList-AuditRsp',
        'P-CCPCH-Information-AuditRsp',
        'BCH-Information-AuditRsp',
        'S-CCPCH-InformationList-AuditRsp',
        'PCH-Information-AuditRsp',
        'PICH-Information-AuditRsp',
        'FACH-InformationList-AuditRsp',
        'PRACH-InformationList-AuditRsp',
        'RACH-InformationList-AuditRsp',
        'AICH-InformationList-AuditRsp',
        'SCH-Information-AuditRsp',
        'FPACH-LCR-InformationList-AuditRsp',
        'HS-DSCH-Resources-Information-AuditRsp',
        'S-CCPCH-InformationListExt-AuditRsp',
        'S-CCPCH-LCR-InformationListExt-AuditRsp',
        'E-DCH-Resources-Information-AuditRsp',
        'PLCCH-InformationList-AuditRsp',
        'S-CCPCH-768-InformationList-AuditRsp',
        'PRACH-768-InformationList-AuditRsp',
        'E-RUCCH-InformationList-AuditRsp',
        'E-RUCCH-768-InformationList-AuditRsp',
        'Cell-Frequency-List-Information-LCR-MulFreq-AuditRsp',
        'Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp',
        'UPPCH-LCR-InformationList-AuditRsp',
        'UPPCH-LCR-InformationItem-AuditRsp',
        'MultipleFreq-HS-DSCH-Resources-InformationList-AuditRsp',
        'MultipleFreq-E-DCH-Resources-InformationList-AuditRsp',
        'CCP-InformationList-AuditRsp',
        'CCP-InformationItem-AuditRsp',
        'Local-Cell-InformationList-AuditRsp',
        'Local-Cell-InformationItem-AuditRsp',
        'Local-Cell-Group-InformationList-AuditRsp',
        'Local-Cell-Group-InformationItem-AuditRsp',
        'Power-Local-Cell-Group-InformationList-AuditRsp',
        'Power-Local-Cell-Group-InformationItem-AuditRsp',
        'AuditFailure',
        'CommonMeasurementInitiationRequest',
        'CommonMeasurementObjectType-CM-Rqst',
        'Extension-CommonMeasurementObjectType-CM-Rqst',
        'ERACH-CM-Rqst',
        'Cell-CM-Rqst',
        'RACH-CM-Rqst',
        'PowerLocalCellGroup-CM-Rqst',
        'CommonMeasurementInitiationResponse',
        'CommonMeasurementObjectType-CM-Rsp',
        'Extension-CommonMeasurementObjectType-CM-Rsp',
        'ERACH-CM-Rsp',
        'Cell-CM-Rsp',
        'RACH-CM-Rsp',
        'PowerLocalCellGroup-CM-Rsp',
        'CommonMeasurementInitiationFailure',
        'CommonMeasurementReport',
        'CommonMeasurementObjectType-CM-Rprt',
        'Extension-CommonMeasurementObjectType-CM-Rprt',
        'ERACH-CM-Rprt',
        'Cell-CM-Rprt',
        'RACH-CM-Rprt',
        'PowerLocalCellGroup-CM-Rprt',
        'CommonMeasurementTerminationRequest',
        'CommonMeasurementFailureIndication',
        'CellSetupRequestFDD',
        'Synchronisation-Configuration-Cell-SetupRqst',
        'PrimarySCH-Information-Cell-SetupRqstFDD',
        'SecondarySCH-Information-Cell-SetupRqstFDD',
        'PrimaryCPICH-Information-Cell-SetupRqstFDD',
        'SecondaryCPICH-InformationList-Cell-SetupRqstFDD',
        'SecondaryCPICH-InformationItem-Cell-SetupRqstFDD',
        'PrimaryCCPCH-Information-Cell-SetupRqstFDD',
        'BCH-Information-Cell-SetupRqstFDD',
        'Limited-power-increase-information-Cell-SetupRqstFDD',
        'IPDLParameter-Information-Cell-SetupRqstFDD',
        'CellPortion-InformationList-Cell-SetupRqstFDD',
        'CellPortion-InformationItem-Cell-SetupRqstFDD',
        'CellSetupRequestTDD',
        'SCH-Information-Cell-SetupRqstTDD',
        'SyncCaseIndicator-Cell-SetupRqstTDD-PSCH',
        'SyncCaseIndicatorItem-Cell-SetupRqstTDD-PSCH',
        'Case1-Cell-SetupRqstTDD',
        'Case2-Cell-SetupRqstTDD',
        'PCCPCH-Information-Cell-SetupRqstTDD',
        'TimeSlotConfigurationList-Cell-SetupRqstTDD',
        'TimeSlotConfigurationItem-Cell-SetupRqstTDD',
        'TimeSlotConfigurationList-LCR-Cell-SetupRqstTDD',
        'TimeSlotConfigurationItem-LCR-Cell-SetupRqstTDD',
        'PCCPCH-LCR-Information-Cell-SetupRqstTDD',
        'DwPCH-LCR-Information-Cell-SetupRqstTDD',
        'IPDLParameter-Information-Cell-SetupRqstTDD',
        'IPDLParameter-Information-LCR-Cell-SetupRqstTDD',
        'PCCPCH-768-Information-Cell-SetupRqstTDD',
        'SCH-768-Information-Cell-SetupRqstTDD',
        'Cell-Frequency-List-LCR-MulFreq-Cell-SetupRqstTDD',
        'Cell-Frequency-Item-LCR-MulFreq-Cell-SetupRqstTDD',
        'CellSetupResponse',
        'CellSetupFailure',
        'CellReconfigurationRequestFDD',
        'Synchronisation-Configuration-Cell-ReconfRqst',
        'PrimarySCH-Information-Cell-ReconfRqstFDD',
        'SecondarySCH-Information-Cell-ReconfRqstFDD',
        'PrimaryCPICH-Information-Cell-ReconfRqstFDD',
        'SecondaryCPICH-InformationList-Cell-ReconfRqstFDD',
        'SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD',
        'PrimaryCCPCH-Information-Cell-ReconfRqstFDD',
        'BCH-information-Cell-ReconfRqstFDD',
        'IPDLParameter-Information-Cell-ReconfRqstFDD',
        'CellPortion-InformationList-Cell-ReconfRqstFDD',
        'CellPortion-InformationItem-Cell-ReconfRqstFDD',
        'CellReconfigurationRequestTDD',
        'SCH-Information-Cell-ReconfRqstTDD',
        'PCCPCH-Information-Cell-ReconfRqstTDD',
        'TimeSlotConfigurationList-Cell-ReconfRqstTDD',
        'TimeSlotConfigurationItem-Cell-ReconfRqstTDD',
        'TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD',
        'TimeSlotConfigurationItem-LCR-Cell-ReconfRqstTDD',
        'DwPCH-LCR-Information-Cell-ReconfRqstTDD',
        'IPDLParameter-Information-Cell-ReconfRqstTDD',
        'IPDLParameter-Information-LCR-Cell-ReconfRqstTDD',
        'SCH-768-Information-Cell-ReconfRqstTDD',
        'PCCPCH-768-Information-Cell-ReconfRqstTDD',
        'UARFCN-Adjustment',
        'Cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD',
        'Cell-Frequency-ModifyList-LCR-MulFreq-Cell-ReconfRqstTDD',
        'Cell-Frequency-ModifyItem-LCR-MulFreq-Cell-ReconfRqstTDD',
        'Cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD',
        'CellReconfigurationResponse',
        'CellReconfigurationFailure',
        'CellDeletionRequest',
        'CellDeletionResponse',
        'ResourceStatusIndication',
        'IndicationType-ResourceStatusInd',
        'No-Failure-ResourceStatusInd',
        'Local-Cell-InformationList-ResourceStatusInd',
        'Local-Cell-InformationItem-ResourceStatusInd',
        'Local-Cell-Group-InformationList-ResourceStatusInd',
        'Local-Cell-Group-InformationItem-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationList-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItem-ResourceStatusInd',
        'ServiceImpacting-ResourceStatusInd',
        'Local-Cell-InformationList2-ResourceStatusInd',
        'Local-Cell-InformationItem2-ResourceStatusInd',
        'Local-Cell-Group-InformationList2-ResourceStatusInd',
        'Local-Cell-Group-InformationItem2-ResourceStatusInd',
        'CCP-InformationList-ResourceStatusInd',
        'CCP-InformationItem-ResourceStatusInd',
        'Cell-InformationList-ResourceStatusInd',
        'Cell-InformationItem-ResourceStatusInd',
        'P-SCH-Information-ResourceStatusInd',
        'S-SCH-Information-ResourceStatusInd',
        'P-CPICH-Information-ResourceStatusInd',
        'S-CPICH-InformationList-ResourceStatusInd',
        'P-CCPCH-Information-ResourceStatusInd',
        'BCH-Information-ResourceStatusInd',
        'S-CCPCH-InformationList-ResourceStatusInd',
        'PCH-Information-ResourceStatusInd',
        'PICH-Information-ResourceStatusInd',
        'FACH-InformationList-ResourceStatusInd',
        'PRACH-InformationList-ResourceStatusInd',
        'RACH-InformationList-ResourceStatusInd',
        'AICH-InformationList-ResourceStatusInd',
        'SCH-Information-ResourceStatusInd',
        'FPACH-LCR-InformationList-ResourceStatusInd',
        'DwPCH-LCR-Information-ResourceStatusInd',
        'HS-DSCH-Resources-Information-ResourceStatusInd',
        'S-CCPCH-InformationListExt-ResourceStatusInd',
        'S-CCPCH-LCR-InformationListExt-ResourceStatusInd',
        'E-DCH-Resources-Information-ResourceStatusInd',
        'PLCCH-InformationList-ResourceStatusInd',
        'S-CCPCH-768-InformationList-ResourceStatusInd',
        'PRACH-768-InformationList-ResourceStatusInd',
        'E-RUCCH-InformationList-ResourceStatusInd',
        'E-RUCCH-768-InformationList-ResourceStatusInd',
        'Cell-Frequency-List-Information-LCR-MulFreq-ResourceStatusInd',
        'Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd',
        'UPPCH-LCR-InformationList-ResourceStatusInd',
        'UPPCH-LCR-InformationItem-ResourceStatusInd',
        'MultipleFreq-HS-DSCH-Resources-InformationList-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationList2-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItem2-ResourceStatusInd',
        'MultipleFreq-E-DCH-Resources-InformationList-ResourceStatusInd',
        'SystemInformationUpdateRequest',
        'MIB-SB-SIB-InformationList-SystemInfoUpdateRqst',
        'MIB-SB-SIB-InformationItem-SystemInfoUpdateRqst',
        'BCH-mappedOnSCCPCH-Indication',
        'DeletionIndicator-SystemInfoUpdate',
        'No-Deletion-SystemInfoUpdate',
        'SegmentInformationList-SystemInfoUpdate',
        'SegmentInformationListIE-SystemInfoUpdate',
        'SegmentInformationItem-SystemInfoUpdate',
        'SystemInformationUpdateResponse',
        'SystemInformationUpdateFailure',
        'RadioLinkSetupRequestFDD',
        'Additional-HS-Cell-Information-RL-Setup-List',
        'Additional-HS-Cell-Information-RL-Setup-ItemIEs',
        'UL-DPCH-Information-RL-SetupRqstFDD',
        'DL-DPCH-Information-RL-SetupRqstFDD',
        'PowerOffsetInformation-RL-SetupRqstFDD',
        'RL-InformationList-RL-SetupRqstFDD',
        'RL-InformationItem-RL-SetupRqstFDD',
        'E-DPCH-Information-RL-SetupRqstFDD',
        'F-DPCH-Information-RL-SetupRqstFDD',
        'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD',
        'RadioLinkSetupRequestTDD',
        'UL-CCTrCH-InformationList-RL-SetupRqstTDD',
        'UL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        'UL-DPCH-Information-RL-SetupRqstTDD',
        'UL-DPCH-InformationItem-RL-SetupRqstTDD',
        'UL-DPCH-LCR-Information-RL-SetupRqstTDD',
        'UL-DPCH-768-Information-RL-SetupRqstTDD',
        'DL-CCTrCH-InformationList-RL-SetupRqstTDD',
        'DL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        'CCTrCH-TPCList-RL-SetupRqstTDD',
        'CCTrCH-TPCItem-RL-SetupRqstTDD',
        'DL-DPCH-Information-RL-SetupRqstTDD',
        'DL-DPCH-InformationItem-RL-SetupRqstTDD',
        'DL-DPCH-LCR-Information-RL-SetupRqstTDD',
        'DL-DPCH-768-Information-RL-SetupRqstTDD',
        'RL-Information-RL-SetupRqstTDD',
        'RadioLinkSetupResponseFDD',
        'Additional-HS-Cell-Information-Response-List',
        'Additional-HS-Cell-Information-Response-ItemIEs',
        'RL-InformationResponseList-RL-SetupRspFDD',
        'RL-InformationResponseItem-RL-SetupRspFDD',
        'DiversityIndication-RL-SetupRspFDD',
        'Combining-RL-SetupRspFDD',
        'NonCombiningOrFirstRL-RL-SetupRspFDD',
        'RadioLinkSetupResponseTDD',
        'RL-InformationResponse-RL-SetupRspTDD',
        'DCH-InformationResponseList-RL-SetupRspTDD',
        'DSCH-InformationResponseList-RL-SetupRspTDD',
        'USCH-InformationResponseList-RL-SetupRspTDD',
        'RL-InformationResponse-LCR-RL-SetupRspTDD',
        'RadioLinkSetupFailureFDD',
        'CauseLevel-RL-SetupFailureFDD',
        'GeneralCauseList-RL-SetupFailureFDD',
        'RLSpecificCauseList-RL-SetupFailureFDD',
        'Unsuccessful-RL-InformationRespList-RL-SetupFailureFDD',
        'Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD',
        'Successful-RL-InformationRespList-RL-SetupFailureFDD',
        'Successful-RL-InformationRespItem-RL-SetupFailureFDD',
        'DiversityIndication-RL-SetupFailureFDD',
        'Combining-RL-SetupFailureFDD',
        'NonCombiningOrFirstRL-RL-SetupFailureFDD',
        'RadioLinkSetupFailureTDD',
        'CauseLevel-RL-SetupFailureTDD',
        'GeneralCauseList-RL-SetupFailureTDD',
        'RLSpecificCauseList-RL-SetupFailureTDD',
        'Unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD',
        'Unsuccessful-RL-InformationResp-RL-SetupFailureTDD',
        'RadioLinkAdditionRequestFDD',
        'Additional-HS-Cell-Information-RL-Addition-List',
        'Additional-EDCH-Cell-Information-RL-Add-Req',
        'Setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency',
        'Additional-HS-Cell-Information-RL-Addition-ItemIEs',
        'RL-InformationList-RL-AdditionRqstFDD',
        'RL-InformationItem-RL-AdditionRqstFDD',
        'E-DPCH-Information-RL-AdditionReqFDD',
        'RadioLinkAdditionRequestTDD',
        'UL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        'UL-DPCH-InformationList-RL-AdditionRqstTDD',
        'UL-DPCH-InformationItem-RL-AdditionRqstTDD',
        'UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD',
        'UL-DPCH-InformationItem-768-RL-AdditionRqstTDD',
        'DL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        'DL-DPCH-InformationList-RL-AdditionRqstTDD',
        'DL-DPCH-InformationItem-RL-AdditionRqstTDD',
        'DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD',
        'DL-DPCH-InformationItem-768-RL-AdditionRqstTDD',
        'RL-Information-RL-AdditionRqstTDD',
        'RadioLinkAdditionResponseFDD',
        'Additional-HS-Cell-Change-Information-Response-List',
        'Additional-HS-Cell-Change-Information-Response-ItemIEs',
        'RL-InformationResponseList-RL-AdditionRspFDD',
        'RL-InformationResponseItem-RL-AdditionRspFDD',
        'DiversityIndication-RL-AdditionRspFDD',
        'Combining-RL-AdditionRspFDD',
        'Non-Combining-RL-AdditionRspFDD',
        'RadioLinkAdditionResponseTDD',
        'RL-InformationResponse-RL-AdditionRspTDD',
        'DCH-Information-RL-AdditionRspTDD',
        'DiversityIndication-RL-AdditionRspTDD',
        'Combining-RL-AdditionRspTDD',
        'Non-Combining-RL-AdditionRspTDD',
        'DSCH-InformationResponseList-RL-AdditionRspTDD',
        'USCH-InformationResponseList-RL-AdditionRspTDD',
        'RL-InformationResponse-LCR-RL-AdditionRspTDD',
        'RadioLinkAdditionFailureFDD',
        'CauseLevel-RL-AdditionFailureFDD',
        'GeneralCauseList-RL-AdditionFailureFDD',
        'RLSpecificCauseList-RL-AdditionFailureFDD',
        'Unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD',
        'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD',
        'Successful-RL-InformationRespList-RL-AdditionFailureFDD',
        'Successful-RL-InformationRespItem-RL-AdditionFailureFDD',
        'DiversityIndication-RL-AdditionFailureFDD',
        'Combining-RL-AdditionFailureFDD',
        'Non-Combining-RL-AdditionFailureFDD',
        'RadioLinkAdditionFailureTDD',
        'CauseLevel-RL-AdditionFailureTDD',
        'GeneralCauseList-RL-AdditionFailureTDD',
        'RLSpecificCauseList-RL-AdditionFailureTDD',
        'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD',
        'Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD',
        'RadioLinkReconfigurationPrepareFDD',
        'Additional-HS-Cell-Information-RL-Reconf-Prep',
        'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs',
        'Additional-EDCH-Cell-Information-RL-Reconf-Prep',
        'UL-DPCH-Information-RL-ReconfPrepFDD',
        'DL-DPCH-Information-RL-ReconfPrepFDD',
        'DL-DPCH-Power-Information-RL-ReconfPrepFDD',
        'PowerOffsetInformation-RL-ReconfPrepFDD',
        'DCH-DeleteList-RL-ReconfPrepFDD',
        'DCH-DeleteItem-RL-ReconfPrepFDD',
        'RL-InformationList-RL-ReconfPrepFDD',
        'RL-InformationItem-RL-ReconfPrepFDD',
        'E-DPCH-Information-RL-ReconfPrepFDD',
        'F-DPCH-Information-RL-ReconfPrepFDD',
        'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD',
        'RadioLinkReconfigurationPrepareTDD',
        'UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        'UL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD',
        'UL-DPCH-InformationAddList-RL-ReconfPrepTDD',
        'UL-DPCH-InformationAddItem-RL-ReconfPrepTDD',
        'UL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD',
        'MultipleRL-UL-DPCH-InformationAddList-RL-ReconfPrepTDD',
        'MultipleRL-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD',
        'UL-DPCH-768-InformationAddList-RL-ReconfPrepTDD',
        'UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        'UL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'UL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'UL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'UL-TimeslotLCR-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'UL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDDLCR',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDDLCR',
        'UL-Timeslot768-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'UL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD768',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD768',
        'UL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD',
        'UL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD',
        'MultipleRL-UL-DPCH-InformationModifyList-RL-ReconfPrepTDD',
        'MultipleRL-UL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD',
        'UL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD',
        'UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        'UL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD',
        'CCTrCH-TPCAddList-RL-ReconfPrepTDD',
        'CCTrCH-TPCAddItem-RL-ReconfPrepTDD',
        'DL-DPCH-InformationAddList-RL-ReconfPrepTDD',
        'DL-DPCH-InformationAddItem-RL-ReconfPrepTDD',
        'DL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD',
        'MultipleRL-DL-DPCH-InformationAddList-RL-ReconfPrepTDD',
        'MultipleRL-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD',
        'DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD',
        'CCTrCH-TPCModifyList-RL-ReconfPrepTDD',
        'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Code-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Code-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Timeslot-768-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-Code-768-InformationModify-ModifyList-RL-ReconfPrepTDD',
        'DL-Code-768-InformationModify-ModifyItem-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD',
        'DL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD',
        'MultipleRL-DL-DPCH-InformationModifyList-RL-ReconfPrepTDD',
        'MultipleRL-DL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD',
        'DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD',
        'DCH-DeleteList-RL-ReconfPrepTDD',
        'DCH-DeleteItem-RL-ReconfPrepTDD',
        'DSCH-Information-ModifyList-RL-ReconfPrepTDD',
        'DSCH-Information-ModifyItem-RL-ReconfPrepTDD',
        'DSCH-Information-DeleteList-RL-ReconfPrepTDD',
        'DSCH-Information-DeleteItem-RL-ReconfPrepTDD',
        'USCH-Information-ModifyList-RL-ReconfPrepTDD',
        'USCH-Information-ModifyItem-RL-ReconfPrepTDD',
        'USCH-Information-DeleteList-RL-ReconfPrepTDD',
        'USCH-Information-DeleteItem-RL-ReconfPrepTDD',
        'MultipleRL-Information-RL-ReconfPrepTDD',
        'RL-Information-RL-ReconfPrepTDD',
        'RadioLinkReconfigurationReady',
        'RL-InformationResponseList-RL-ReconfReady',
        'RL-InformationResponseItem-RL-ReconfReady',
        'DCH-InformationResponseList-RL-ReconfReady',
        'DSCH-InformationResponseList-RL-ReconfReady',
        'USCH-InformationResponseList-RL-ReconfReady',
        'RadioLinkReconfigurationFailure',
        'CauseLevel-RL-ReconfFailure',
        'GeneralCauseList-RL-ReconfFailure',
        'RLSpecificCauseList-RL-ReconfFailure',
        'RL-ReconfigurationFailureList-RL-ReconfFailure',
        'RL-ReconfigurationFailureItem-RL-ReconfFailure',
        'RadioLinkReconfigurationCommit',
        'RadioLinkReconfigurationCancel',
        'RadioLinkReconfigurationRequestFDD',
        'Additional-HS-Cell-Information-RL-Reconf-Req',
        'Additional-HS-Cell-Information-RL-Reconf-Req-ItemIEs',
        'Additional-EDCH-Cell-Information-RL-Reconf-Req',
        'UL-DPCH-Information-RL-ReconfRqstFDD',
        'DL-DPCH-Information-RL-ReconfRqstFDD',
        'DCH-DeleteList-RL-ReconfRqstFDD',
        'DCH-DeleteItem-RL-ReconfRqstFDD',
        'RL-InformationList-RL-ReconfRqstFDD',
        'RL-InformationItem-RL-ReconfRqstFDD',
        'E-DPCH-Information-RL-ReconfRqstFDD',
        'RadioLinkReconfigurationRequestTDD',
        'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        'MultipleRL-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        'MultipleRL-DL-CCTrCH-InformationModifyListIE-RL-ReconfRqstTDD',
        'DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD',
        'DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD',
        'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        'DCH-DeleteList-RL-ReconfRqstTDD',
        'DCH-DeleteItem-RL-ReconfRqstTDD',
        'Multiple-RL-Information-RL-ReconfRqstTDD',
        'RL-Information-RL-ReconfRqstTDD',
        'RadioLinkReconfigurationResponse',
        'RL-InformationResponseList-RL-ReconfRsp',
        'RL-InformationResponseItem-RL-ReconfRsp',
        'DCH-InformationResponseList-RL-ReconfRsp',
        'RadioLinkDeletionRequest',
        'RL-informationList-RL-DeletionRqst',
        'RL-informationItem-RL-DeletionRqst',
        'RadioLinkDeletionResponse',
        'DL-PowerControlRequest',
        'DL-ReferencePowerInformationList-DL-PC-Rqst',
        'DL-ReferencePowerInformationItem-DL-PC-Rqst',
        'DL-PowerTimeslotControlRequest',
        'DedicatedMeasurementInitiationRequest',
        'DedicatedMeasurementObjectType-DM-Rqst',
        'RL-DM-Rqst',
        'RL-InformationList-DM-Rqst',
        'RL-InformationItem-DM-Rqst',
        'PUSCH-Info-DM-Rqst',
        'HSSICH-Info-DM-Rqst',
        'HSSICH-InfoExt-DM-Rqst',
        'RL-Set-DM-Rqst',
        'RL-Set-InformationList-DM-Rqst',
        'RL-Set-InformationItem-DM-Rqst',
        'AllRL-DM-Rqst',
        'AllRL-Set-DM-Rqst',
        'DedicatedMeasurementInitiationResponse',
        'DedicatedMeasurementObjectType-DM-Rsp',
        'RL-DM-Rsp',
        'RL-InformationList-DM-Rsp',
        'RL-InformationItem-DM-Rsp',
        'PUSCH-Info-DM-Rsp',
        'Multiple-PUSCH-InfoList-DM-Rsp',
        'Multiple-PUSCH-InfoListIE-DM-Rsp',
        'Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp',
        'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp',
        'Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp',
        'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp',
        'Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp',
        'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp',
        'Multiple-DedicatedMeasurementValueList-768-TDD-DM-Rsp',
        'Multiple-DedicatedMeasurementValueItem-768-TDD-DM-Rsp',
        'RL-Set-DM-Rsp',
        'RL-Set-InformationList-DM-Rsp',
        'RL-Set-InformationItem-DM-Rsp',
        'DedicatedMeasurementInitiationFailure',
        'DedicatedMeasurementReport',
        'DedicatedMeasurementObjectType-DM-Rprt',
        'RL-DM-Rprt',
        'RL-InformationList-DM-Rprt',
        'RL-InformationItem-DM-Rprt',
        'PUSCH-Info-DM-Rprt',
        'Multiple-PUSCH-InfoList-DM-Rprt',
        'Multiple-PUSCH-InfoListIE-DM-Rprt',
        'RL-Set-DM-Rprt',
        'RL-Set-InformationList-DM-Rprt',
        'RL-Set-InformationItem-DM-Rprt',
        'DedicatedMeasurementTerminationRequest',
        'DedicatedMeasurementFailureIndication',
        'RadioLinkFailureIndication',
        'Reporting-Object-RL-FailureInd',
        'RL-RL-FailureInd',
        'RL-InformationList-RL-FailureInd',
        'RL-InformationItem-RL-FailureInd',
        'RL-Set-RL-FailureInd',
        'RL-Set-InformationList-RL-FailureInd',
        'RL-Set-InformationItem-RL-FailureInd',
        'CCTrCH-RL-FailureInd',
        'CCTrCH-InformationList-RL-FailureInd',
        'CCTrCH-InformationItem-RL-FailureInd',
        'RadioLinkPreemptionRequiredIndication',
        'RL-InformationList-RL-PreemptRequiredInd',
        'RL-InformationItem-RL-PreemptRequiredInd',
        'RadioLinkRestoreIndication',
        'Reporting-Object-RL-RestoreInd',
        'RL-RL-RestoreInd',
        'RL-InformationList-RL-RestoreInd',
        'RL-InformationItem-RL-RestoreInd',
        'RL-Set-RL-RestoreInd',
        'RL-Set-InformationList-RL-RestoreInd',
        'RL-Set-InformationItem-RL-RestoreInd',
        'CCTrCH-RL-RestoreInd',
        'CCTrCH-InformationList-RL-RestoreInd',
        'CCTrCH-InformationItem-RL-RestoreInd',
        'CompressedModeCommand',
        'ErrorIndication',
        'PrivateMessage',
        'PhysicalSharedChannelReconfigurationRequestFDD',
        'HSDPA-And-EDCH-CellPortion-InformationList-PSCH-ReconfRqst',
        'HSDPA-And-EDCH-CellPortion-InformationItem-PSCH-ReconfRqst',
        'PhysicalSharedChannelReconfigurationRequestTDD',
        'PDSCHSets-AddList-PSCH-ReconfRqst',
        'PDSCHSets-AddItem-PSCH-ReconfRqst',
        'PDSCH-Information-AddList-PSCH-ReconfRqst',
        'PDSCH-Information-AddItem-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddList-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddItem-PSCH-ReconfRqst',
        'DL-Code-InformationAddList-PSCH-ReconfRqst',
        'DL-Code-InformationAddItem-PSCH-ReconfRqst',
        'PDSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst',
        'DL-Code-InformationAddList-LCR-PSCH-ReconfRqst',
        'DL-Code-InformationAddItem-LCR-PSCH-ReconfRqst',
        'PDSCH-AddInformation-768-AddItem-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddList-768-PSCH-ReconfRqst',
        'DL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst',
        'DL-Code-InformationAddList-768-PSCH-ReconfRqst',
        'DL-Code-InformationAddItem-768-PSCH-ReconfRqst',
        'PDSCHSets-ModifyList-PSCH-ReconfRqst',
        'PDSCHSets-ModifyItem-PSCH-ReconfRqst',
        'PDSCH-Information-ModifyList-PSCH-ReconfRqst',
        'PDSCH-Information-ModifyItem-PSCH-ReconfRqst',
        'DL-Timeslot-InformationModifyList-PSCH-ReconfRqst',
        'DL-Timeslot-InformationModifyItem-PSCH-ReconfRqst',
        'DL-Code-InformationModifyList-PSCH-ReconfRqst',
        'DL-Code-InformationModifyItem-PSCH-ReconfRqst',
        'PDSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst',
        'DL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst',
        'DL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst',
        'DL-Code-LCR-InformationModifyList-PSCH-ReconfRqst',
        'DL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst',
        'PDSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst',
        'DL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst',
        'DL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst',
        'DL-Code-768-InformationModifyList-PSCH-ReconfRqst',
        'DL-Code-768-InformationModifyItem-PSCH-ReconfRqst',
        'PDSCHSets-DeleteList-PSCH-ReconfRqst',
        'PDSCHSets-DeleteItem-PSCH-ReconfRqst',
        'PUSCHSets-AddList-PSCH-ReconfRqst',
        'PUSCHSets-AddItem-PSCH-ReconfRqst',
        'PUSCH-Information-AddList-PSCH-ReconfRqst',
        'PUSCH-Information-AddItem-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddList-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddItem-PSCH-ReconfRqst',
        'UL-Code-InformationAddList-PSCH-ReconfRqst',
        'UL-Code-InformationAddItem-PSCH-ReconfRqst',
        'PUSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst',
        'UL-Code-InformationAddList-LCR-PSCH-ReconfRqst',
        'UL-Code-InformationAddItem-LCR-PSCH-ReconfRqst',
        'PUSCH-AddInformation-768-AddItem-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddList-768-PSCH-ReconfRqst',
        'UL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst',
        'UL-Code-InformationAddList-768-PSCH-ReconfRqst',
        'UL-Code-InformationAddItem-768-PSCH-ReconfRqst',
        'PUSCHSets-ModifyList-PSCH-ReconfRqst',
        'PUSCHSets-ModifyItem-PSCH-ReconfRqst',
        'PUSCH-Information-ModifyList-PSCH-ReconfRqst',
        'PUSCH-Information-ModifyItem-PSCH-ReconfRqst',
        'UL-Timeslot-InformationModifyList-PSCH-ReconfRqst',
        'UL-Timeslot-InformationModifyItem-PSCH-ReconfRqst',
        'UL-Code-InformationModifyList-PSCH-ReconfRqst',
        'UL-Code-InformationModifyItem-PSCH-ReconfRqst',
        'PUSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst',
        'UL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst',
        'UL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst',
        'UL-Code-LCR-InformationModifyList-PSCH-ReconfRqst',
        'UL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst',
        'PUSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst',
        'UL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst',
        'UL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst',
        'UL-Code-768-InformationModifyList-PSCH-ReconfRqst',
        'UL-Code-768-InformationModifyItem-PSCH-ReconfRqst',
        'PUSCHSets-DeleteList-PSCH-ReconfRqst',
        'PUSCHSets-DeleteItem-PSCH-ReconfRqst',
        'HS-PDSCH-TDD-Information-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-Information-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-InformationItem-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Codelist-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-Information-768-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Timeslot-InformationItem-768-PSCH-ReconfRqst',
        'DL-HS-PDSCH-Codelist-768-PSCH-ReconfRqst',
        'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst',
        'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst',
        'Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'HS-SCCH-Information-PSCH-ReconfRqst',
        'HS-SCCH-InformationItem-PSCH-ReconfRqst',
        'HS-SICH-Information-PSCH-ReconfRqst',
        'HS-SCCH-Information-LCR-PSCH-ReconfRqst',
        'HS-SCCH-InformationItem-LCR-PSCH-ReconfRqst',
        'HS-SICH-Information-LCR-PSCH-ReconfRqst',
        'HS-SCCH-Information-768-PSCH-ReconfRqst',
        'HS-SCCH-InformationItem-768-PSCH-ReconfRqst',
        'HS-SICH-Information-768-PSCH-ReconfRqst',
        'HS-SCCH-InformationExt-LCR-PSCH-ReconfRqst',
        'Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'HS-SCCH-InformationModifyItem-PSCH-ReconfRqst',
        'HS-SICH-InformationModify-PSCH-ReconfRqst',
        'HS-SCCH-InformationModify-LCR-PSCH-ReconfRqst',
        'HS-SCCH-InformationModifyItem-LCR-PSCH-ReconfRqst',
        'HS-SCCH-InformationModifyExt-LCR-PSCH-ReconfRqst',
        'HS-SICH-InformationModify-LCR-PSCH-ReconfRqst',
        'HS-SCCH-InformationModify-768-PSCH-ReconfRqst',
        'HS-SCCH-InformationModifyItem-768-PSCH-ReconfRqst',
        'HS-SICH-InformationModify-768-PSCH-ReconfRqst',
        'HS-SCCH-InformationModify-PSCH-ReconfRqst',
        'Delete-From-HS-SCCH-Resource-Pool-PSCH-ReconfRqst',
        'Delete-From-HS-SCCH-Resource-PoolItem-PSCH-ReconfRqst',
        'E-PUCH-Information-PSCH-ReconfRqst',
        'E-PUCH-Timeslot-Info',
        'Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'E-AGCH-Information-PSCH-ReconfRqst',
        'E-AGCH-InformationItem-PSCH-ReconfRqst',
        'Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'E-AGCH-InformationModify-PSCH-ReconfRqst',
        'E-AGCH-InformationModifyItem-PSCH-ReconfRqst',
        'Delete-From-E-AGCH-Resource-Pool-PSCH-ReconfRqst',
        'Delete-From-E-AGCH-Resource-PoolItem-PSCH-ReconfRqst',
        'E-HICH-Information-PSCH-ReconfRqst',
        'E-PUCH-Information-768-PSCH-ReconfRqst',
        'Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst',
        'E-AGCH-Information-768-PSCH-ReconfRqst',
        'E-AGCH-InformationItem-768-PSCH-ReconfRqst',
        'Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst',
        'E-AGCH-InformationModify-768-PSCH-ReconfRqst',
        'E-AGCH-InformationModifyItem-768-PSCH-ReconfRqst',
        'E-HICH-Information-768-PSCH-ReconfRqst',
        'E-PUCH-Information-LCR-PSCH-ReconfRqst',
        'E-PUCH-Timeslot-InfoLCR',
        'E-PUCH-Timeslot-Item-InfoLCR',
        'E-PUCH-Codelist-LCR',
        'Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'E-AGCH-Information-LCR-PSCH-ReconfRqst',
        'E-AGCH-InformationItem-LCR-PSCH-ReconfRqst',
        'Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'E-AGCH-InformationModify-LCR-PSCH-ReconfRqst',
        'E-AGCH-InformationModifyItem-LCR-PSCH-ReconfRqst',
        'Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'E-HICH-Information-LCR-PSCH-ReconfRqst',
        'E-HICH-InformationItem-LCR-PSCH-ReconfRqst',
        'Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst',
        'E-HICH-InformationModify-LCR-PSCH-ReconfRqst',
        'E-HICH-InformationModifyItem-LCR-PSCH-ReconfRqst',
        'Delete-From-E-HICH-Resource-Pool-PSCH-ReconfRqst',
        'Delete-From-E-HICH-Resource-PoolItem-PSCH-ReconfRqst',
        'SYNC-UL-Partition-LCR',
        'Delete-From-HS-SCCH-Resource-PoolExt-PSCH-ReconfRqst',
        'MultipleFreq-E-PUCH-Timeslot-InformationList-LCR-PSCH-ReconfRqst',
        'MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst',
        'Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst',
        'Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst-Item',
        'Max-RTWP-perCellPortion-InformationList-LCR-PSCH-ReconfRqst',
        'Max-RTWP-perCellPortion-InformationItem-LCR-PSCH-ReconfRqst',
        'PhysicalSharedChannelReconfigurationResponse',
        'E-HICH-TimeOffset-ExtensionLCR',
        'MultipleFreq-E-HICH-TimeOffsetLCR',
        'PhysicalSharedChannelReconfigurationFailure',
        'CauseLevel-PSCH-ReconfFailure',
        'GeneralCauseList-PSCH-ReconfFailure',
        'SetSpecificCauseList-PSCH-ReconfFailureTDD',
        'Unsuccessful-PDSCHSetList-PSCH-ReconfFailureTDD',
        'Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD',
        'Unsuccessful-PUSCHSetList-PSCH-ReconfFailureTDD',
        'Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD',
        'Extension-CauseLevel-PSCH-ReconfFailure',
        'UARFCNSpecificCauseList-PSCH-ReconfFailureTDD',
        'Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD',
        'E-HICH-TimeOffset-ReconfFailureTDD',
        'Common-System-Information-ResponseLCR',
        'ResetRequest',
        'ResetIndicator',
        'CommunicationContextList-Reset',
        'CommunicationContextInfoList-Reset',
        'CommunicationContextInfoItem-Reset',
        'CommunicationContextType-Reset',
        'CommunicationControlPortList-Reset',
        'CommunicationControlPortInfoList-Reset',
        'CommunicationControlPortInfoItem-Reset',
        'ResetResponse',
        'InformationExchangeInitiationRequest',
        'InformationExchangeObjectType-InfEx-Rqst',
        'Cell-InfEx-Rqst',
        'InformationExchangeInitiationResponse',
        'InformationExchangeObjectType-InfEx-Rsp',
        'Cell-InfEx-Rsp',
        'InformationExchangeInitiationFailure',
        'InformationReport',
        'InformationExchangeObjectType-InfEx-Rprt',
        'Cell-Inf-Rprt',
        'InformationExchangeTerminationRequest',
        'InformationExchangeFailureIndication',
        'CellSynchronisationInitiationRequestTDD',
        'TimeslotInfo-CellSyncInitiationRqstTDD',
        'CellSyncBurstTransInit-CellSyncInitiationRqstTDD',
        'CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD',
        'SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD',
        'SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD',
        'CellSynchronisationInitiationResponseTDD',
        'CellSynchronisationInitiationFailureTDD',
        'CellSynchronisationReconfigurationRequestTDD',
        'CellSyncBurstTransReconfInfo-CellSyncReconfRqstTDD',
        'CellSyncBurstTransInfoItem-CellSyncReconfRqstTDD',
        'CellSyncBurstMeasInfo-CellSyncReconfRqstTDD',
        'CellSyncBurstMeasInfoList-CellSyncReconfRqstTDD',
        'SynchronisationReportTypeIE',
        'SynchronisationReportCharacteristicsIE',
        'CellSyncBurstMeasInfoListIE-CellSyncReconfRqstTDD',
        'CellSyncBurstMeasInfoItem-CellSyncReconfRqstTDD',
        'CellSyncBurstInfoList-CellSyncReconfRqstTDD',
        'CellSyncBurstInfoItem-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdTransReconfItemLCR-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdMeasInfoLCR-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdMeasInfoList-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdMeasInfoItem-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdInfoListLCR-CellSyncReconfRqstTDD',
        'SYNCDlCodeIdInfoItemLCR-CellSyncReconfRqstTDD',
        'CellSynchronisationReconfigurationResponseTDD',
        'CellSynchronisationReconfigurationFailureTDD',
        'CellSynchronisationAdjustmentRequestTDD',
        'CellAdjustmentInfo-SyncAdjustmentRqstTDD',
        'CellAdjustmentInfoItem-SyncAdjustmentRqstTDD',
        'CellSynchronisationAdjustmentResponseTDD',
        'CellSynchronisationAdjustmentFailureTDD',
        'CauseLevel-SyncAdjustmntFailureTDD',
        'GeneralCauseList-SyncAdjustmntFailureTDD',
        'CellSpecificCauseList-SyncAdjustmntFailureTDD',
        'Unsuccessful-cell-InformationRespList-SyncAdjustmntFailureTDD',
        'Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD',
        'CellSynchronisationTerminationRequestTDD',
        'CellSynchronisationFailureIndicationTDD',
        'CellSynchronisationReportTDD',
        'CellSyncInfo-CellSyncReprtTDD',
        'CellSyncInfoItemIE-CellSyncReprtTDD',
        'C-ID-IE-CellSyncReprtTDD',
        'SyncReportTypeIE-CellSyncReprtTDD',
        'SyncReportType-CellSyncReprtTDD',
        'IntStdPhCellSyncInfo-CellSyncReprtTDD',
        'CellSyncBurstMeasInfoList-CellSyncReprtTDD',
        'CellSyncBurstMeasInfoItem-CellSyncReprtTDD',
        'CellSyncBurstInfo-CellSyncReprtTDD',
        'CellSyncBurstAvailable-CellSyncReprtTDD',
        'SyncDLCodeIdsMeasInfoList-CellSyncReprtTDD',
        'SyncDLCodeIdsMeasInfoItem-CellSyncReprtTDD',
        'SyncDLCodeIdInfo-CellSyncReprtTDD',
        'SyncDLCodeIdItem-CellSyncReprtTDD',
        'SyncDLCodeIdAvailable-CellSyncReprtTDD',
        'BearerRearrangementIndication',
        'DCH-RearrangeList-Bearer-RearrangeInd',
        'DCH-RearrangeItem-Bearer-RearrangeInd',
        'DSCH-RearrangeList-Bearer-RearrangeInd',
        'DSCH-RearrangeItem-Bearer-RearrangeInd',
        'USCH-RearrangeList-Bearer-RearrangeInd',
        'USCH-RearrangeItem-Bearer-RearrangeInd',
        'HSDSCH-RearrangeList-Bearer-RearrangeInd',
        'HSDSCH-RearrangeItem-Bearer-RearrangeInd',
        'E-DCH-RearrangeList-Bearer-RearrangeInd',
        'E-DCH-RearrangeItem-Bearer-RearrangeInd',
        'Additional-EDCH-Cell-Information-Bearer-Rearrangement-List',
        'Additional-EDCH-Cell-Information-Bearer-Rearrangement-ItemIEs',
        'Transport-Bearer-Rearrangement-Indicator-for-Additional-EDCH-Separate-Mode',
        'RadioLinkActivationCommandFDD',
        'DelayedActivationInformationList-RL-ActivationCmdFDD',
        'DelayedActivationInformation-RL-ActivationCmdFDD',
        'RadioLinkActivationCommandTDD',
        'DelayedActivationInformationList-RL-ActivationCmdTDD',
        'DelayedActivationInformation-RL-ActivationCmdTDD',
        'RadioLinkParameterUpdateIndicationFDD',
        'Additional-HS-Cell-Information-RL-Param-Upd',
        'Additional-HS-Cell-Information-RL-Param-Upd-ItemIEs',
        'Additional-EDCH-Cell-Information-RL-Param-Upd',
        'Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs',
        'UE-Measurement-Forwarding',
        'RadioLinkParameterUpdateIndicationTDD',
        'MBMSNotificationUpdateCommand',
        'UEStatusUpdateCommand',
        'SecondaryULFrequencyReport',
        'SecondaryULFrequencyUpdateIndication',
        'UEStatusUpdateConfirmRequest',
        'UEStatusUpdateConfirmResponse',
        ]
    _set_ = [
        'CommonTransportChannelSetupRequestFDD-Extensions',
        'CommonTransportChannelSetupRequestFDD-IEs',
        'Secondary-CCPCHItem-CTCH-SetupRqstFDD-ExtIEs',
        'PowerOffsetInformation-CTCH-SetupRqstFDD-ExtIEs',
        'FACH-ParametersListIEs-CTCH-SetupRqstFDD',
        'FACH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs',
        'PCH-ParametersIE-CTCH-SetupRqstFDD',
        'PCH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs',
        'PICH-Parameters-CTCH-SetupRqstFDD-ExtIEs',
        'MICH-Parameters-CTCH-SetupRqstFDD-ExtIEs',
        'PRACHItem-CTCH-SetupRqstFDD-ExtIEs',
        'AllowedSlotFormatInformationItem-CTCH-SetupRqstFDD-ExtIEs',
        'RACH-ParametersIE-CTCH-SetupRqstFDD',
        'RACH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs',
        'AICH-Parameters-CTCH-SetupRqstFDD-ExtIEs',
        'CommonTransportChannelSetupRequestTDD-IEs',
        'CommonTransportChannelSetupRequestTDD-Extensions',
        'Extension-CommonPhysicalChannelType-CTCH-SetupRqstTDDIE',
        'Secondary-CCPCHItem-CTCH-SetupRqstTDD-ExtIEs',
        'Secondary-CCPCH-parameterListIEs-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-parameterItem-CTCH-SetupRqstTDD-ExtIEs',
        'Secondary-CCPCH-LCR-parameterItem-CTCH-SetupRqstTDD-ExtIEs',
        'Secondary-CCPCH-parameterItem-768-CTCH-SetupRqstTDD-ExtIEs',
        'FACH-ParametersListIEs-CTCH-SetupRqstTDD',
        'FACH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PCH-ParametersIE-CTCH-SetupRqstTDD',
        'PCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PICH-ParametersIE-CTCH-SetupRqstTDD',
        'PICH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PICH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PICH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-HCR-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-LCR-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-768-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'TimeSlotConfigurationItem-LCR-CTCH-SetupRqstTDD-ExtIEs',
        'PRACH-CTCH-SetupRqstTDD-ExtIEs',
        'PRACH-ParametersIE-CTCH-SetupRqstTDD',
        'PRACH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'RACH-ParameterIE-CTCH-SetupRqstTDD',
        'RACH-ParameterItem-CTCH-SetupRqstTDD-ExtIEs',
        'PRACH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PRACH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'FPACH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PLCCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'E-RUCCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'E-RUCCH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'CommonTransportChannelSetupResponse-IEs',
        'CommonTransportChannelSetupResponse-Extensions',
        'CommonTransportChannelSetupFailure-IEs',
        'CommonTransportChannelSetupFailure-Extensions',
        'CommonTransportChannelReconfigurationRequestFDD-IEs',
        'CommonTransportChannelReconfigurationRequestFDD-Extensions',
        'Secondary-CCPCH-CTCH-ReconfRqstFDD-ExtIEs',
        'FACH-ParametersListIEs-CTCH-ReconfRqstFDD',
        'FACH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'PCH-ParametersIE-CTCH-ReconfRqstFDD',
        'PCH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'PICH-ParametersIE-CTCH-ReconfRqstFDD',
        'PICH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'MICH-Parameters-CTCH-ReconfRqstFDD-ExtIEs',
        'BCH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'PRACH-CTCH-ReconfRqstFDD-ExtIEs',
        'PRACH-ParametersListIEs-CTCH-ReconfRqstFDD',
        'PRACH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'AllowedSlotFormatInformationItem-CTCH-ReconfRqstFDD-ExtIEs',
        'AICH-ParametersListIEs-CTCH-ReconfRqstFDD',
        'AICH-ParametersItemIE-CTCH-ReconfRqstFDD-ExtIEs',
        'CommonTransportChannelReconfigurationRequestTDD-IEs',
        'CommonTransportChannelReconfigurationRequestTDD-Extensions',
        'Secondary-CCPCH-CTCH-ReconfRqstTDD-ExtIEs',
        'Secondary-CCPCHListIEs-CTCH-ReconfRqstTDD',
        'Secondary-CCPCHItem-CTCH-ReconfRqstTDD-ExtIEs',
        'PICH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'FACH-ParametersItem-CTCH-ReconfRqstTDD-ExtIEs',
        'PCH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'FPACH-LCR-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'MICH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'PLCCH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'Secondary-CCPCH-768-CTCH-ReconfRqstTDD-ExtIEs',
        'Secondary-CCPCH-768-Item-CTCH-ReconfRqstTDD-ExtIEs',
        'PICH-768-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'MICH-768-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'CommonTransportChannelReconfigurationResponse-IEs',
        'CommonTransportChannelReconfigurationResponse-Extensions',
        'CommonTransportChannelReconfigurationFailure-IEs',
        'CommonTransportChannelReconfigurationFailure-Extensions',
        'CommonTransportChannelDeletionRequest-IEs',
        'CommonTransportChannelDeletionRequest-Extensions',
        'CommonTransportChannelDeletionResponse-IEs',
        'CommonTransportChannelDeletionResponse-Extensions',
        'BlockResourceRequest-IEs',
        'BlockResourceRequest-Extensions',
        'BlockResourceResponse-IEs',
        'BlockResourceResponse-Extensions',
        'BlockResourceFailure-IEs',
        'BlockResourceFailure-Extensions',
        'UnblockResourceIndication-IEs',
        'UnblockResourceIndication-Extensions',
        'AuditRequiredIndication-IEs',
        'AuditRequiredIndication-Extensions',
        'AuditRequest-IEs',
        'AuditRequest-Extensions',
        'AuditResponse-IEs',
        'AuditResponse-Extensions',
        'Cell-InformationItemIE-AuditRsp',
        'Cell-InformationItem-AuditRsp-ExtIEs',
        'P-SCH-InformationIE-AuditRsp',
        'S-SCH-InformationIE-AuditRsp',
        'P-CPICH-InformationIE-AuditRsp',
        'S-CPICH-InformationItemIE-AuditRsp',
        'P-CCPCH-InformationIE-AuditRsp',
        'BCH-InformationIE-AuditRsp',
        'S-CCPCH-InformationItemIE-AuditRsp',
        'PCH-InformationIE-AuditRsp',
        'PICH-InformationIE-AuditRsp',
        'FACH-InformationItemIE-AuditRsp',
        'PRACH-InformationItemIE-AuditRsp',
        'RACH-InformationItemIE-AuditRsp',
        'AICH-InformationItemIE-AuditRsp',
        'SCH-InformationIE-AuditRsp',
        'FPACH-LCR-InformationItemIE-AuditRsp',
        'HS-DSCH-Resources-Information-AuditRsp-ExtIEs',
        'E-DCH-Resources-Information-AuditRsp-ExtIEs',
        'PLCCH-InformationItemIE-AuditRsp',
        'S-CCPCH-768-InformationItemIE-AuditRsp',
        'PRACH-768-InformationItemIE-AuditRsp',
        'E-RUCCH-InformationItemIE-AuditRsp',
        'E-RUCCH-768-InformationItemIE-AuditRsp',
        'Cell-Frequency-List-InformationIE-LCR-MulFreq-AuditRsp',
        'Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp-ExtIEs',
        'UPPCH-LCR-InformationIE-AuditRsp',
        'UPPCH-LCR-InformationItem-AuditRsp-ExtIEs',
        'MultipleFreq-HS-DSCH-Resources-InformationItem-AuditRsp',
        'MultipleFreq-E-DCH-Resources-InformationItem-AuditRsp',
        'CCP-InformationItemIE-AuditRsp',
        'CCP-InformationItem-AuditRsp-ExtIEs',
        'Local-Cell-InformationItemIE-AuditRsp',
        'Local-Cell-InformationItem-AuditRsp-ExtIEs',
        'Local-Cell-Group-InformationItemIE-AuditRsp',
        'Local-Cell-Group-InformationItem-AuditRsp-ExtIEs',
        'Power-Local-Cell-Group-InformationItemIE-AuditRsp',
        'Power-Local-Cell-Group-InformationItem-AuditRsp-ExtIEs',
        'AuditFailure-IEs',
        'AuditFailure-Extensions',
        'CommonMeasurementInitiationRequest-IEs',
        'CommonMeasurementInitiationRequest-Extensions',
        'Extension-CommonMeasurementObjectType-CM-RqstIE',
        'ERACHItem-CM-Rqst-ExtIEs',
        'CellItem-CM-Rqst-ExtIEs',
        'RACHItem-CM-Rqst-ExtIEs',
        'PowerLocalCellGroup-CM-Rqst-ExtIEs',
        'CommonMeasurementInitiationResponse-IEs',
        'CommonMeasurementInitiationResponse-Extensions',
        'Extension-CommonMeasurementObjectType-CM-RspIE',
        'ERACHItem-CM-Rsp-ExtIEs',
        'CellItem-CM-Rsp-ExtIEs',
        'RACHItem-CM-Rsp-ExtIEs',
        'PowerLocalCellGroup-CM-Rsp-ExtIEs',
        'CommonMeasurementInitiationFailure-IEs',
        'CommonMeasurementInitiationFailure-Extensions',
        'CommonMeasurementReport-IEs',
        'CommonMeasurementReport-Extensions',
        'Extension-CommonMeasurementObjectType-CM-RprtIE',
        'ERACHItem-CM-Rprt-ExtIEs',
        'CellItem-CM-Rprt-ExtIEs',
        'RACHItem-CM-Rprt-ExtIEs',
        'PowerLocalCellGroup-CM-Rprt-ExtIEs',
        'CommonMeasurementTerminationRequest-IEs',
        'CommonMeasurementTerminationRequest-Extensions',
        'CommonMeasurementFailureIndication-IEs',
        'CommonMeasurementFailureIndication-Extensions',
        'CellSetupRequestFDD-IEs',
        'CellSetupRequestFDD-Extensions',
        'Synchronisation-Configuration-Cell-SetupRqst-ExtIEs',
        'PrimarySCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'SecondarySCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'PrimaryCPICH-Information-Cell-SetupRqstFDD-ExtIEs',
        'SecondaryCPICH-InformationItemIE-Cell-SetupRqstFDD',
        'SecondaryCPICH-InformationItem-Cell-SetupRqstFDD-ExtIEs',
        'PrimaryCCPCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'BCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'Limited-power-increase-information-Cell-SetupRqstFDD-ExtIEs',
        'IPDLParameter-Information-Cell-SetupRqstFDD-ExtIEs',
        'CellPortion-InformationItemIE-Cell-SetupRqstFDD',
        'CellPortion-InformationItem-Cell-SetupRqstFDD-ExtIEs',
        'CellSetupRequestTDD-IEs',
        'CellSetupRequestTDD-Extensions',
        'SCH-Information-Cell-SetupRqstTDD-ExtIEs',
        'SyncCaseIndicatorIE-Cell-SetupRqstTDD-PSCH',
        'Case1Item-Cell-SetupRqstTDD-ExtIEs',
        'Case2Item-Cell-SetupRqstTDD-ExtIEs',
        'PCCPCH-Information-Cell-SetupRqstTDD-ExtIEs',
        'TimeSlotConfigurationItem-Cell-SetupRqstTDD-ExtIEs',
        'TimeSlotConfigurationItem-LCR-Cell-SetupRqstTDD-ExtIEs',
        'PCCPCH-LCR-Information-Cell-SetupRqstTDD-ExtIEs',
        'DwPCH-LCR-Information-Cell-SetupRqstTDD-ExtIEs',
        'IPDLParameter-Information-Cell-SetupRqstTDD-ExtIEs',
        'IPDLParameter-Information-LCR-Cell-SetupRqstTDD-ExtIEs',
        'PCCPCH-768-Information-Cell-SetupRqstTDD-ExtIEs',
        'SCH-768-Information-Cell-SetupRqstTDD-ExtIEs',
        'Cell-Frequency-Item-LCR-MulFreq-Cell-SetupRqstTDD-ExtIEs',
        'CellSetupResponse-IEs',
        'CellSetupResponse-Extensions',
        'CellSetupFailure-IEs',
        'CellSetupFailure-Extensions',
        'CellReconfigurationRequestFDD-IEs',
        'CellReconfigurationRequestFDD-Extensions',
        'Synchronisation-Configuration-Cell-ReconfRqst-ExtIEs',
        'PrimarySCH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'SecondarySCH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'PrimaryCPICH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'SecondaryCPICH-InformationItemIE-Cell-ReconfRqstFDD',
        'SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD-ExtIEs',
        'PrimaryCCPCH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'BCH-information-Cell-ReconfRqstFDD-ExtIEs',
        'IPDLParameter-Information-Cell-ReconfRqstFDD-ExtIEs',
        'CellPortion-InformationItemIE-Cell-ReconfRqstFDD',
        'CellPortion-InformationItem-Cell-ReconfRqstFDD-ExtIEs',
        'CellReconfigurationRequestTDD-IEs',
        'CellReconfigurationRequestTDD-Extensions',
        'PSCH-Information-Cell-ReconfRqstTDD-ExtIEs',
        'PCCPCH-Information-Cell-ReconfRqstTDD-ExtIEs',
        'TimeSlotConfigurationItem-Cell-ReconfRqstTDD-ExtIEs',
        'TimeSlotConfigurationItem-LCR-Cell-ReconfRqstTDD-ExtIEs',
        'DwPCH-LCR-Information-Cell-ReconfRqstTDD-ExtIEs',
        'IPDLParameter-Information-Cell-ReconfRqstTDD-ExtIEs',
        'IPDLParameter-Information-LCR-Cell-ReconfRqstTDD-ExtIEs',
        'PSCH-768-Information-Cell-ReconfRqstTDD-ExtIEs',
        'PCCPCH-768-Information-Cell-ReconfRqstTDD-ExtIEs',
        'Cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs',
        'Cell-Frequency-ModifyItem-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs',
        'Cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs',
        'CellReconfigurationResponse-IEs',
        'CellReconfigurationResponse-Extensions',
        'CellReconfigurationFailure-IEs',
        'CellReconfigurationFailure-Extensions',
        'CellDeletionRequest-IEs',
        'CellDeletionRequest-Extensions',
        'CellDeletionResponse-IEs',
        'CellDeletionResponse-Extensions',
        'ResourceStatusIndication-IEs',
        'ResourceStatusIndication-Extensions',
        'No-FailureItem-ResourceStatusInd-ExtIEs',
        'Local-Cell-InformationItemIE-ResourceStatusInd',
        'Local-Cell-InformationItem-ResourceStatusInd-ExtIEs',
        'Local-Cell-Group-InformationItemIE-ResourceStatusInd',
        'Local-Cell-Group-InformationItem-ResourceStatusInd-ExtIEs',
        'Power-Local-Cell-Group-InformationItemIE-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItem-ResourceStatusInd-ExtIEs',
        'ServiceImpactingItem-ResourceStatusInd-ExtIEs',
        'Local-Cell-InformationItemIE2-ResourceStatusInd',
        'Local-Cell-InformationItem2-ResourceStatusInd-ExtIEs',
        'Local-Cell-Group-InformationItemIE2-ResourceStatusInd',
        'Local-Cell-Group-InformationItem2-ResourceStatusInd-ExtIEs',
        'CCP-InformationItemIE-ResourceStatusInd',
        'CCP-InformationItem-ResourceStatusInd-ExtIEs',
        'Cell-InformationItemIE-ResourceStatusInd',
        'Cell-InformationItem-ResourceStatusInd-ExtIEs',
        'P-SCH-InformationIE-ResourceStatusInd',
        'S-SCH-InformationIE-ResourceStatusInd',
        'P-CPICH-InformationIE-ResourceStatusInd',
        'S-CPICH-InformationItemIE-ResourceStatusInd',
        'P-CCPCH-InformationIE-ResourceStatusInd',
        'BCH-InformationIE-ResourceStatusInd',
        'S-CCPCH-InformationItemIE-ResourceStatusInd',
        'PCH-InformationIE-ResourceStatusInd',
        'PICH-InformationIE-ResourceStatusInd',
        'FACH-InformationItemIE-ResourceStatusInd',
        'PRACH-InformationItemIE-ResourceStatusInd',
        'RACH-InformationItemIE-ResourceStatusInd',
        'AICH-InformationItemIE-ResourceStatusInd',
        'SCH-InformationIE-ResourceStatusInd',
        'FPACH-LCR-InformationItemIE-ResourceStatusInd',
        'DwPCH-LCR-InformationIE-ResourceStatusInd',
        'HS-DSCH-Resources-Information-ResourceStatusInd-ExtIEs',
        'E-DCH-Resources-Information-ResourceStatusInd-ExtIEs',
        'PLCCH-InformationItemIE-ResourceStatusInd',
        'S-CCPCH-768-InformationItemIE-ResourceStatusInd',
        'PRACH-768-InformationItemIE-ResourceStatusInd',
        'E-RUCCH-InformationItemIE-ResourceStatusInd',
        'E-RUCCH-768-InformationItemIE-ResourceStatusInd',
        'Cell-Frequency-List-InformationIE-LCR-MulFreq-ResourceStatusInd',
        'Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd-ExtIEs',
        'UPPCH-LCR-InformationIE-ResourceStatusInd',
        'UPPCH-LCR-InformationItem-ResourceStatusInd-ExtIEs',
        'MultipleFreq-HS-DSCH-Resources-InformationItem-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItemIE2-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItem2-ResourceStatusInd-ExtIEs',
        'MultipleFreq-E-DCH-Resources-InformationItem-ResourceStatusInd',
        'SystemInformationUpdateRequest-IEs',
        'SystemInformationUpdateRequest-Extensions',
        'MIB-SB-SIB-InformationItem-SystemInfoUpdateRqst-ExtIEs',
        'No-DeletionItem-SystemInfoUpdate-ExtIEs',
        'SegmentInformationListIEs-SystemInfoUpdate',
        'SegmentInformationItem-SystemInfoUpdate-ExtIEs',
        'SystemInformationUpdateResponse-IEs',
        'SystemInformationUpdateResponse-Extensions',
        'SystemInformationUpdateFailure-IEs',
        'SystemInformationUpdateFailure-Extensions',
        'RadioLinkSetupRequestFDD-IEs',
        'RadioLinkSetupRequestFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Setup-ItemIEs-ExtIEs',
        'UL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'DL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'PowerOffsetInformation-RL-SetupRqstFDD-ExtIEs',
        'RL-InformationItemIE-RL-SetupRqstFDD',
        'RL-InformationItem-RL-SetupRqstFDD-ExtIEs',
        'E-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'F-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD-ExtIEs',
        'RadioLinkSetupRequestTDD-IEs',
        'RadioLinkSetupRequestTDD-Extensions',
        'UL-CCTrCH-InformationItemIE-RL-SetupRqstTDD',
        'UL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'UL-DPCH-InformationIE-RL-SetupRqstTDD',
        'UL-DPCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'UL-DPCH-LCR-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'UL-DPCH-768-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationItemIE-RL-SetupRqstTDD',
        'DL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'CCTrCH-TPCItem-RL-SetupRqstTDD-ExtIEs',
        'DL-DPCH-InformationIE-RL-SetupRqstTDD',
        'DL-DPCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'DL-DPCH-LCR-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'DL-DPCH-768-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'RL-Information-RL-SetupRqstTDD-ExtIEs',
        'RadioLinkSetupResponseFDD-IEs',
        'RadioLinkSetupResponseFDD-Extensions',
        'Additional-HS-Cell-Information-Response-ItemIEs-ExtIEs',
        'RL-InformationResponseItemIE-RL-SetupRspFDD',
        'RL-InformationResponseItem-RL-SetupRspFDD-ExtIEs',
        'Combining-RL-SetupRspFDD-ExtIEs',
        'NonCombiningOrFirstRLItem-RL-SetupRspFDD-ExtIEs',
        'RadioLinkSetupResponseTDD-IEs',
        'RadioLinkSetupResponseTDD-Extensions',
        'RL-InformationResponseList-RL-SetupRspTDD-ExtIEs',
        'DCH-InformationResponseListIEs-RL-SetupRspTDD',
        'DSCH-InformationResponseListIEs-RL-SetupRspTDD',
        'USCH-InformationResponseListIEs-RL-SetupRspTDD',
        'RL-InformationResponseList-LCR-RL-SetupRspTDD-ExtIEs',
        'RadioLinkSetupFailureFDD-IEs',
        'RadioLinkSetupFailureFDD-Extensions',
        'GeneralCauseItem-RL-SetupFailureFDD-ExtIEs',
        'RLSpecificCauseItem-RL-SetupFailureFDD-ExtIEs',
        'Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureFDD',
        'Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD-ExtIEs',
        'Successful-RL-InformationRespItemIE-RL-SetupFailureFDD',
        'Successful-RL-InformationRespItem-RL-SetupFailureFDD-ExtIEs',
        'CombiningItem-RL-SetupFailureFDD-ExtIEs',
        'NonCombiningOrFirstRLItem-RL-SetupFailureFDD-ExtIEs',
        'RadioLinkSetupFailureTDD-IEs',
        'RadioLinkSetupFailureTDD-Extensions',
        'GeneralCauseItem-RL-SetupFailureTDD-ExtIEs',
        'RLSpecificCauseItem-RL-SetupFailureTDD-ExtIEs',
        'Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureTDD',
        'Unsuccessful-RL-InformationResp-RL-SetupFailureTDD-ExtIEs',
        'RadioLinkAdditionRequestFDD-IEs',
        'RadioLinkAdditionRequestFDD-Extensions',
        'Additional-EDCH-Cell-Information-RL-Add-Req-ExtIEs',
        'Additional-HS-Cell-Information-RL-Addition-ItemIEs-ExtIEs',
        'RL-InformationItemIE-RL-AdditionRqstFDD',
        'RL-InformationItem-RL-AdditionRqstFDD-ExtIEs',
        'E-DPCH-Information-RL-AdditionReqFDD-ExtIEs',
        'RadioLinkAdditionRequestTDD-IEs',
        'RadioLinkAdditionRequestTDD-Extensions',
        'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'UL-DPCH-InformationItemIE-RL-AdditionRqstTDD',
        'UL-DPCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD-ExtIEs',
        'UL-DPCH-InformationItem-768-RL-AdditionRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'DL-DPCH-InformationItemIE-RL-AdditionRqstTDD',
        'DL-DPCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD-ExtIEs',
        'DL-DPCH-InformationItem-768-RL-AdditionRqstTDD-ExtIEs',
        'RL-information-RL-AdditionRqstTDD-ExtIEs',
        'RadioLinkAdditionResponseFDD-IEs',
        'RadioLinkAdditionResponseFDD-Extensions',
        'Additional-HS-Cell-Change-Information-Response-ItemIEs-ExtIEs',
        'RL-InformationResponseItemIE-RL-AdditionRspFDD',
        'RL-InformationResponseItem-RL-AdditionRspFDD-ExtIEs',
        'CombiningItem-RL-AdditionRspFDD-ExtIEs',
        'Non-CombiningItem-RL-AdditionRspFDD-ExtIEs',
        'RadioLinkAdditionResponseTDD-IEs',
        'RadioLinkAdditionResponseTDD-Extensions',
        'RL-InformationResponse-RL-AdditionRspTDD-ExtIEs',
        'DCH-Information-RL-AdditionRspTDD-ExtIEs',
        'CombiningItem-RL-AdditionRspTDD-ExtIEs',
        'Non-CombiningItem-RL-AdditionRspTDD-ExtIEs',
        'DSCH-InformationResponseListIEs-RL-AdditionRspTDD',
        'USCH-InformationResponseListIEs-RL-AdditionRspTDD',
        'RL-InformationResponse-LCR-RL-AdditionRspTDD-ExtIEs',
        'RadioLinkAdditionFailureFDD-IEs',
        'RadioLinkAdditionFailureFDD-Extensions',
        'GeneralCauseItem-RL-AdditionFailureFDD-ExtIEs',
        'RLSpecificCauseItem-RL-AdditionFailureFDD-ExtIEs',
        'Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureFDD',
        'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD-ExtIEs',
        'Successful-RL-InformationRespItemIE-RL-AdditionFailureFDD',
        'Successful-RL-InformationRespItem-RL-AdditionFailureFDD-ExtIEs',
        'CombiningItem-RL-AdditionFailureFDD-ExtIEs',
        'Non-CombiningItem-RL-AdditionFailureFDD-ExtIEs',
        'RadioLinkAdditionFailureTDD-IEs',
        'RadioLinkAdditionFailureTDD-Extensions',
        'GeneralCauseItem-RL-AdditionFailureTDD-ExtIEs',
        'RLSpecificCauseItem-RL-AdditionFailureTDD-ExtIEs',
        'Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureTDD',
        'Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD-ExtIEs',
        'RadioLinkReconfigurationPrepareFDD-IEs',
        'RadioLinkReconfigurationPrepareFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs-ExtIEs',
        'Additional-EDCH-Cell-Information-RL-Reconf-Prep-ExtIEs',
        'UL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'DL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'DL-DPCH-Power-Information-RL-ReconfPrepFDD-ExtIEs',
        'PowerOffsetInformation-RL-ReconfPrepFDD-ExtIEs',
        'DCH-DeleteItem-RL-ReconfPrepFDD-ExtIEs',
        'RL-InformationItemIE-RL-ReconfPrepFDD',
        'RL-InformationItem-RL-ReconfPrepFDD-ExtIEs',
        'E-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'F-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD-ExtIEs',
        'RadioLinkReconfigurationPrepareTDD-IEs',
        'RadioLinkReconfigurationPrepareTDD-Extensions',
        'UL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-InformationAddListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-LCR-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-InformationModify-AddListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-InformationModify-ModifyListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDDLCR-ExtIEs',
        'UL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD768-ExtIEs',
        'UL-DPCH-InformationModify-DeleteListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-LCR-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-UL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'CCTrCH-TPCAddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationAddListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-LCR-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationModify-AddListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationModify-ModifyListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Code-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Code-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationModify-DeleteListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-LCR-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-DL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DSCH-Information-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DSCH-Information-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'USCH-Information-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'USCH-Information-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'RL-Information-RL-ReconfPrepTDD-ExtIEs',
        'RadioLinkReconfigurationReady-IEs',
        'RadioLinkReconfigurationReady-Extensions',
        'RL-InformationResponseItemIE-RL-ReconfReady',
        'RL-InformationResponseItem-RL-ReconfReady-ExtIEs',
        'DCH-InformationResponseListIEs-RL-ReconfReady',
        'DSCH-InformationResponseListIEs-RL-ReconfReady',
        'USCH-InformationResponseListIEs-RL-ReconfReady',
        'RadioLinkReconfigurationFailure-IEs',
        'RadioLinkReconfigurationFailure-Extensions',
        'GeneralCauseItem-RL-ReconfFailure-ExtIEs',
        'RLSpecificCauseItem-RL-ReconfFailure-ExtIEs',
        'RL-ReconfigurationFailureItemIE-RL-ReconfFailure',
        'RL-ReconfigurationFailureItem-RL-ReconfFailure-ExtIEs',
        'RadioLinkReconfigurationCommit-IEs',
        'RadioLinkReconfigurationCommit-Extensions',
        'RadioLinkReconfigurationCancel-IEs',
        'RadioLinkReconfigurationCancel-Extensions',
        'RadioLinkReconfigurationRequestFDD-IEs',
        'RadioLinkReconfigurationRequestFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Reconf-Req-ExtIEs',
        'Additional-EDCH-Cell-Information-RL-Reconf-Req-ExtIEs',
        'UL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        'DL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        'DCH-DeleteItem-RL-ReconfRqstFDD-ExtIEs',
        'RL-InformationItemIE-RL-ReconfRqstFDD',
        'RL-InformationItem-RL-ReconfRqstFDD-ExtIEs',
        'E-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        'RadioLinkReconfigurationRequestTDD-IEs',
        'RadioLinkReconfigurationRequestTDD-Extensions',
        'UL-CCTrCH-InformationModifyItemIE-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        'UL-CCTrCH-InformationDeleteItemIE-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationModifyItemIE-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        'DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD-ExtIEs',
        'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationDeleteItemIE-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        'DCH-DeleteItem-RL-ReconfRqstTDD-ExtIEs',
        'RL-InformationItem-RL-ReconfRqstTDD-ExtIEs',
        'RadioLinkReconfigurationResponse-IEs',
        'RadioLinkReconfigurationResponse-Extensions',
        'RL-InformationResponseItemIE-RL-ReconfRsp',
        'RL-InformationResponseItem-RL-ReconfRsp-ExtIEs',
        'DCH-InformationResponseListIEs-RL-ReconfRsp',
        'RadioLinkDeletionRequest-IEs',
        'RadioLinkDeletionRequest-Extensions',
        'RL-informationItemIE-RL-DeletionRqst',
        'RL-informationItem-RL-DeletionRqst-ExtIEs',
        'RadioLinkDeletionResponse-IEs',
        'RadioLinkDeletionResponse-Extensions',
        'DL-PowerControlRequest-IEs',
        'DL-PowerControlRequest-Extensions',
        'DL-ReferencePowerInformationItemIE-DL-PC-Rqst',
        'DL-ReferencePowerInformationItem-DL-PC-Rqst-ExtIEs',
        'DL-PowerTimeslotControlRequest-IEs',
        'DL-PowerTimeslotControlRequest-Extensions',
        'DedicatedMeasurementInitiationRequest-IEs',
        'DedicatedMeasurementInitiationRequest-Extensions',
        'RLItem-DM-Rqst-ExtIEs',
        'RL-InformationItemIE-DM-Rqst',
        'RL-InformationItem-DM-Rqst-ExtIEs',
        'RL-SetItem-DM-Rqst-ExtIEs',
        'RL-Set-InformationItem-DM-Rqst-ExtIEs',
        'DedicatedMeasurementInitiationResponse-IEs',
        'DedicatedMeasurementInitiationResponse-Extensions',
        'RLItem-DM-Rsp-ExtIEs',
        'RL-InformationItemIE-DM-Rsp',
        'RL-InformationItem-DM-Rsp-ExtIEs',
        'Multiple-PUSCH-InfoListIE-DM-Rsp-ExtIEs',
        'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp-ExtIEs',
        'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        'Multiple-DedicatedMeasurementValueItem-768-TDD-DM-Rsp-ExtIEs',
        'RL-SetItem-DM-Rsp-ExtIEs',
        'RL-Set-InformationItemIE-DM-Rsp',
        'RL-Set-InformationItem-DM-Rsp-ExtIEs',
        'DedicatedMeasurementInitiationFailure-IEs',
        'DedicatedMeasurementInitiationFailure-Extensions',
        'DedicatedMeasurementReport-IEs',
        'DedicatedMeasurementReport-Extensions',
        'RLItem-DM-Rprt-ExtIEs',
        'RL-InformationItemIE-DM-Rprt',
        'RL-InformationItem-DM-Rprt-ExtIEs',
        'Multiple-PUSCH-InfoListIE-DM-Rprt-ExtIEs',
        'RL-SetItem-DM-Rprt-ExtIEs',
        'RL-Set-InformationItemIE-DM-Rprt',
        'RL-Set-InformationItem-DM-Rprt-ExtIEs',
        'DedicatedMeasurementTerminationRequest-IEs',
        'DedicatedMeasurementTerminationRequest-Extensions',
        'DedicatedMeasurementFailureIndication-IEs',
        'DedicatedMeasurementFailureIndication-Extensions',
        'RadioLinkFailureIndication-IEs',
        'RadioLinkFailureIndication-Extensions',
        'RLItem-RL-FailureInd-ExtIEs',
        'RL-InformationItemIE-RL-FailureInd',
        'RL-InformationItem-RL-FailureInd-ExtIEs',
        'RL-SetItem-RL-FailureInd-ExtIEs',
        'RL-Set-InformationItemIE-RL-FailureInd',
        'RL-Set-InformationItem-RL-FailureInd-ExtIEs',
        'CCTrCHItem-RL-FailureInd-ExtIEs',
        'CCTrCH-InformationItemIE-RL-FailureInd',
        'CCTrCH-InformationItem-RL-FailureInd-ExtIEs',
        'RadioLinkPreemptionRequiredIndication-IEs',
        'RadioLinkPreemptionRequiredIndication-Extensions',
        'RL-InformationItemIE-RL-PreemptRequiredInd',
        'RL-InformationItem-RL-PreemptRequiredInd-ExtIEs',
        'RadioLinkRestoreIndication-IEs',
        'RadioLinkRestoreIndication-Extensions',
        'RLItem-RL-RestoreInd-ExtIEs',
        'RL-InformationItemIE-RL-RestoreInd',
        'RL-InformationItem-RL-RestoreInd-ExtIEs',
        'RL-SetItem-RL-RestoreInd-ExtIEs',
        'RL-Set-InformationItemIE-RL-RestoreInd',
        'RL-Set-InformationItem-RL-RestoreInd-ExtIEs',
        'CCTrCHItem-RL-RestoreInd-ExtIEs',
        'CCTrCH-InformationItemIE-RL-RestoreInd',
        'CCTrCH-InformationItem-RL-RestoreInd-ExtIEs',
        'CompressedModeCommand-IEs',
        'CompressedModeCommand-Extensions',
        'ErrorIndication-IEs',
        'ErrorIndication-Extensions',
        'PrivateMessage-IEs',
        'PhysicalSharedChannelReconfigurationRequestFDD-IEs',
        'PhysicalSharedChannelReconfigurationRequestFDD-Extensions',
        'HSDPA-And-EDCH-CellPortion-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'PhysicalSharedChannelReconfigurationRequestTDD-IEs',
        'PhysicalSharedChannelReconfigurationRequestTDD-Extensions',
        'PDSCHSets-AddItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-Information-AddListIEs-PSCH-ReconfRqst',
        'PDSCH-Information-AddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-AddInformation-768-AddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'PDSCHSets-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-Information-ModifyListIEs-PSCH-ReconfRqst',
        'PDSCH-Information-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-ModifyInformation-768-ModifyListIE-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCHSets-DeleteItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCHSets-AddItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-Information-AddListIEs-PSCH-ReconfRqst',
        'PUSCH-Information-AddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-AddInformation-768-AddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'PUSCHSets-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-Information-ModifyListIEs-PSCH-ReconfRqst',
        'PUSCH-Information-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCHSets-DeleteItem-PSCH-ReconfRqst-ExtIEs',
        'HS-PDSCH-TDD-Information-PSCH-ReconfRqst-ExtIEs',
        'DL-HS-PDSCH-Timeslot-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'DL-HS-PDSCH-Timeslot-InformationItem-768-PSCH-ReconfRqst-ExtIEs',
        'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItemIE-PSCH-ReconfRqst',
        'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst-ExtIEs',
        'Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-Information-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-Information-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationItem-768-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-Information-768-PSCH-ReconfRqst-ExtIEs',
        'Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-InformationModify-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-InformationModify-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationModifyItem-768-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-InformationModify-768-PSCH-ReconfRqst-ExtIEs',
        'Delete-From-HS-SCCH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Information-PSCH-ReconfRqst-ExtIEs',
        'Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'Delete-From-E-AGCH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-Information-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Information-768-PSCH-ReconfRqst-ExtIEs',
        'Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationItem-768-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationModifyItem-768-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-Information-768-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Information-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Timeslot-Item-InfoLCR-ExtIEs',
        'Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Delete-From-E-HICH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs',
        'SYNC-UL-Partition-LCR-ExtIEs',
        'MultipleFreq-E-PUCH-Timeslot-InformationItemIE-LCR-PSCH-ReconfRqst',
        'MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst-ExtIEs',
        'Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst-Item-ExtIEs',
        'Max-RTWP-perCellPortion-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'PhysicalSharedChannelReconfigurationResponse-IEs',
        'PhysicalSharedChannelReconfigurationResponse-Extensions',
        'Multiple-E-HICH-TimeOffsetLCR',
        'MultipleFreq-E-HICH-TimeOffsetLCR-ExtIEs',
        'PhysicalSharedChannelReconfigurationFailure-IEs',
        'PhysicalSharedChannelReconfigurationFailure-Extensions',
        'GeneralCauseItem-PSCH-ReconfFailure-ExtIEs',
        'SetSpecificCauseItem-PSCH-ReconfFailureTDD-ExtIEs',
        'Unsuccessful-PDSCHSetItemIE-PSCH-ReconfFailureTDD',
        'Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD-ExtIEs',
        'Unsuccessful-PUSCHSetItemIE-PSCH-ReconfFailureTDD',
        'Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD-ExtIEs',
        'Extension-CauseLevel-PSCH-ReconfFailureIE',
        'Unsuccessful-UARFCNItemIE-PSCH-ReconfFailureTDD',
        'Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD-ExtIEs',
        'Common-System-Information-ResponseLCR-ExtIEs',
        'ResetRequest-IEs',
        'ResetRequest-Extensions',
        'CommunicationContextItem-Reset-ExtIEs',
        'CommunicationContextInfoItemIE-Reset',
        'CommunicationContextInfoItem-Reset-ExtIEs',
        'CommunicationControlPortItem-Reset-ExtIEs',
        'CommunicationControlPortInfoItemIE-Reset',
        'CommunicationControlPortInfoItem-Reset-ExtIEs',
        'ResetResponse-IEs',
        'ResetResponse-Extensions',
        'InformationExchangeInitiationRequest-IEs',
        'InformationExchangeInitiationRequest-Extensions',
        'CellItem-InfEx-Rqst-ExtIEs',
        'InformationExchangeInitiationResponse-IEs',
        'InformationExchangeInitiationResponse-Extensions',
        'CellItem-InfEx-Rsp-ExtIEs',
        'InformationExchangeInitiationFailure-IEs',
        'InformationExchangeInitiationFailure-Extensions',
        'InformationReport-IEs',
        'InformationReport-Extensions',
        'CellItem-Inf-Rprt-ExtIEs',
        'InformationExchangeTerminationRequest-IEs',
        'InformationExchangeTerminationRequest-Extensions',
        'InformationExchangeFailureIndication-IEs',
        'InformationExchangeFailureIndication-Extensions',
        'CellSynchronisationInitiationRequestTDD-IEs',
        'CellSynchronisationInitiationRequestTDD-Extensions',
        'CellSyncBurstTransInit-CellSyncInitiationRqstTDD-ExtIEs',
        'CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD-ExtIEs',
        'SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD-ExtIEs',
        'SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD-ExtIEs',
        'CellSynchronisationInitiationResponseTDD-Extensions',
        'CellSynchronisationInitiationResponseTDD-IEs',
        'CellSynchronisationInitiationFailureTDD-Extensions',
        'CellSynchronisationInitiationFailureTDD-IEs',
        'CellSynchronisationReconfigurationRequestTDD-IEs',
        'CellSynchronisationReconfigurationRequestTDD-Extensions',
        'CellSyncBurstTransInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'CellSyncBurstMeasInfo-CellSyncReconfRqstTDD-ExtIEs',
        'CellSyncBurstMeasInfoListIEs-CellSyncReconfRqstTDD',
        'SynchronisationReportTypeIEs',
        'SynchronisationReportCharacteristicsIEs',
        'CellSyncBurstMeasInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'CellSyncBurstInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdMeasInfoLCR-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdMeasInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdInfoItemLCR-CellSyncReconfRqstTDD-ExtIEs',
        'CellSynchronisationReconfigurationResponseTDD-Extensions',
        'CellSynchronisationReconfigurationResponseTDD-IEs',
        'CellSynchronisationReconfigurationFailureTDD-Extensions',
        'CellSynchronisationReconfigurationFailureTDD-IEs',
        'CellSynchronisationAdjustmentRequestTDD-Extensions',
        'CellSynchronisationAdjustmentRequestTDD-IEs',
        'CellAdjustmentInfoItemIE-SyncAdjustmntRqstTDD',
        'CellAdjustmentInfoItem-SyncAdjustmntRqstTDD-ExtIEs',
        'CellSynchronisationAdjustmentResponseTDD-Extensions',
        'CellSynchronisationAdjustmentResponseTDD-IEs',
        'CellSynchronisationAdjustmentFailureTDD-Extensions',
        'CellSynchronisationAdjustmentFailureTDD-IEs',
        'GeneralCauseList-SyncAdjustmntFailureTDD-ExtIEs',
        'CellSpecificCauseList-SyncAdjustmntFailureTDD-ExtIEs',
        'Unsuccessful-cell-InformationRespItemIE-SyncAdjustmntFailureTDD',
        'Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD-ExtIEs',
        'CellSynchronisationTerminationRequestTDD-Extensions',
        'CellSynchronisationTerminationRequestTDD-IEs',
        'CellSynchronisationFailureIndicationTDD-Extensions',
        'CellSynchronisationFailureIndicationTDD-IEs',
        'CellSynchronisationReportTDD-Extensions',
        'CellSynchronisationReportTDD-IEs',
        'C-ID-IEs-CellSyncReprtTDD',
        'SyncReportTypeIEs-CellSyncReprtTDD',
        'IntStdPhCellSyncInfoList-CellSyncReprtTDD-ExtIEs',
        'CellSyncBurstMeasInfoItem-CellSyncReprtTDD-ExtIEs',
        'CellSyncBurstAvailable-CellSyncReprtTDD-ExtIEs',
        'SyncDLCodeIdsMeasInfoItem-CellSyncReprtTDD-ExtIEs',
        'SyncDLCodeIdAvailable-CellSyncReprtTDD-ExtIEs',
        'BearerRearrangementIndication-IEs',
        'BearerRearrangementIndication-Extensions',
        'DCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'DSCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'USCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'HSDSCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'E-DCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'Additional-EDCH-Cell-Information-Bearer-Rearrangement-ItemIEs-ExtIEs',
        'RadioLinkActivationCommandFDD-IEs',
        'RadioLinkActivationCommandFDD-Extensions',
        'DelayedActivationInformation-RL-ActivationCmdFDD-IEs',
        'DelayedActivationInformation-RL-ActivationCmdFDD-ExtIEs',
        'RadioLinkActivationCommandTDD-IEs',
        'RadioLinkActivationCommandTDD-Extensions',
        'DelayedActivationInformation-RL-ActivationCmdTDD-IEs',
        'DelayedActivationInformation-RL-ActivationCmdTDD-ExtIEs',
        'RadioLinkParameterUpdateIndicationFDD-IEs',
        'RadioLinkParameterUpdateIndicationFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Setup-ExtIEs',
        'Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs-ExtIEs',
        'UE-Measurement-Forwarding-ExtIEs',
        'RadioLinkParameterUpdateIndicationTDD-IEs',
        'RadioLinkParameterUpdateIndicationTDD-Extensions',
        'MBMSNotificationUpdateCommand-IEs',
        'MBMSNotificationUpdateCommand-Extensions',
        'UEStatusUpdateCommand-IEs',
        'UEStatusUpdateCommand-Extensions',
        'SecondaryULFrequencyReport-IEs',
        'SecondaryULFrequencyReport-Extensions',
        'SecondaryULFrequencyUpdateIndication-IEs',
        'SecondaryULFrequencyUpdateIndication-Extensions',
        'UEStatusUpdateConfirmRequest-IEs',
        'UEStatusUpdateConfirmRequest-Extensions',
        'UEStatusUpdateConfirmResponse-IEs',
        'UEStatusUpdateConfirmResponse-Extensions',
        ]
    _val_ = [
        ]
    _class_ = [
        'CommonTransportChannelSetupRequestFDD-Extensions',
        'CommonTransportChannelSetupRequestFDD-IEs',
        'Secondary-CCPCHItem-CTCH-SetupRqstFDD-ExtIEs',
        'PowerOffsetInformation-CTCH-SetupRqstFDD-ExtIEs',
        'FACH-ParametersListIEs-CTCH-SetupRqstFDD',
        'FACH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs',
        'PCH-ParametersIE-CTCH-SetupRqstFDD',
        'PCH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs',
        'PICH-Parameters-CTCH-SetupRqstFDD-ExtIEs',
        'MICH-Parameters-CTCH-SetupRqstFDD-ExtIEs',
        'PRACHItem-CTCH-SetupRqstFDD-ExtIEs',
        'AllowedSlotFormatInformationItem-CTCH-SetupRqstFDD-ExtIEs',
        'RACH-ParametersIE-CTCH-SetupRqstFDD',
        'RACH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs',
        'AICH-Parameters-CTCH-SetupRqstFDD-ExtIEs',
        'CommonTransportChannelSetupRequestTDD-IEs',
        'CommonTransportChannelSetupRequestTDD-Extensions',
        'Extension-CommonPhysicalChannelType-CTCH-SetupRqstTDDIE',
        'Secondary-CCPCHItem-CTCH-SetupRqstTDD-ExtIEs',
        'Secondary-CCPCH-parameterListIEs-CTCH-SetupRqstTDD',
        'Secondary-CCPCH-parameterItem-CTCH-SetupRqstTDD-ExtIEs',
        'Secondary-CCPCH-LCR-parameterItem-CTCH-SetupRqstTDD-ExtIEs',
        'Secondary-CCPCH-parameterItem-768-CTCH-SetupRqstTDD-ExtIEs',
        'FACH-ParametersListIEs-CTCH-SetupRqstTDD',
        'FACH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PCH-ParametersIE-CTCH-SetupRqstTDD',
        'PCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PICH-ParametersIE-CTCH-SetupRqstTDD',
        'PICH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PICH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PICH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-HCR-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-LCR-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'MICH-768-Parameters-CTCH-SetupRqstTDD-ExtIEs',
        'TimeSlotConfigurationItem-LCR-CTCH-SetupRqstTDD-ExtIEs',
        'PRACH-CTCH-SetupRqstTDD-ExtIEs',
        'PRACH-ParametersIE-CTCH-SetupRqstTDD',
        'PRACH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'RACH-ParameterIE-CTCH-SetupRqstTDD',
        'RACH-ParameterItem-CTCH-SetupRqstTDD-ExtIEs',
        'PRACH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PRACH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'FPACH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'PLCCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'E-RUCCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'E-RUCCH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs',
        'CommonTransportChannelSetupResponse-IEs',
        'CommonTransportChannelSetupResponse-Extensions',
        'CommonTransportChannelSetupFailure-IEs',
        'CommonTransportChannelSetupFailure-Extensions',
        'CommonTransportChannelReconfigurationRequestFDD-IEs',
        'CommonTransportChannelReconfigurationRequestFDD-Extensions',
        'Secondary-CCPCH-CTCH-ReconfRqstFDD-ExtIEs',
        'FACH-ParametersListIEs-CTCH-ReconfRqstFDD',
        'FACH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'PCH-ParametersIE-CTCH-ReconfRqstFDD',
        'PCH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'PICH-ParametersIE-CTCH-ReconfRqstFDD',
        'PICH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'MICH-Parameters-CTCH-ReconfRqstFDD-ExtIEs',
        'BCH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'PRACH-CTCH-ReconfRqstFDD-ExtIEs',
        'PRACH-ParametersListIEs-CTCH-ReconfRqstFDD',
        'PRACH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs',
        'AllowedSlotFormatInformationItem-CTCH-ReconfRqstFDD-ExtIEs',
        'AICH-ParametersListIEs-CTCH-ReconfRqstFDD',
        'AICH-ParametersItemIE-CTCH-ReconfRqstFDD-ExtIEs',
        'CommonTransportChannelReconfigurationRequestTDD-IEs',
        'CommonTransportChannelReconfigurationRequestTDD-Extensions',
        'Secondary-CCPCH-CTCH-ReconfRqstTDD-ExtIEs',
        'Secondary-CCPCHListIEs-CTCH-ReconfRqstTDD',
        'Secondary-CCPCHItem-CTCH-ReconfRqstTDD-ExtIEs',
        'PICH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'FACH-ParametersItem-CTCH-ReconfRqstTDD-ExtIEs',
        'PCH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'FPACH-LCR-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'MICH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'PLCCH-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'Secondary-CCPCH-768-CTCH-ReconfRqstTDD-ExtIEs',
        'Secondary-CCPCH-768-Item-CTCH-ReconfRqstTDD-ExtIEs',
        'PICH-768-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'MICH-768-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD-ExtIEs',
        'CommonTransportChannelReconfigurationResponse-IEs',
        'CommonTransportChannelReconfigurationResponse-Extensions',
        'CommonTransportChannelReconfigurationFailure-IEs',
        'CommonTransportChannelReconfigurationFailure-Extensions',
        'CommonTransportChannelDeletionRequest-IEs',
        'CommonTransportChannelDeletionRequest-Extensions',
        'CommonTransportChannelDeletionResponse-IEs',
        'CommonTransportChannelDeletionResponse-Extensions',
        'BlockResourceRequest-IEs',
        'BlockResourceRequest-Extensions',
        'BlockResourceResponse-IEs',
        'BlockResourceResponse-Extensions',
        'BlockResourceFailure-IEs',
        'BlockResourceFailure-Extensions',
        'UnblockResourceIndication-IEs',
        'UnblockResourceIndication-Extensions',
        'AuditRequiredIndication-IEs',
        'AuditRequiredIndication-Extensions',
        'AuditRequest-IEs',
        'AuditRequest-Extensions',
        'AuditResponse-IEs',
        'AuditResponse-Extensions',
        'Cell-InformationItemIE-AuditRsp',
        'Cell-InformationItem-AuditRsp-ExtIEs',
        'P-SCH-InformationIE-AuditRsp',
        'S-SCH-InformationIE-AuditRsp',
        'P-CPICH-InformationIE-AuditRsp',
        'S-CPICH-InformationItemIE-AuditRsp',
        'P-CCPCH-InformationIE-AuditRsp',
        'BCH-InformationIE-AuditRsp',
        'S-CCPCH-InformationItemIE-AuditRsp',
        'PCH-InformationIE-AuditRsp',
        'PICH-InformationIE-AuditRsp',
        'FACH-InformationItemIE-AuditRsp',
        'PRACH-InformationItemIE-AuditRsp',
        'RACH-InformationItemIE-AuditRsp',
        'AICH-InformationItemIE-AuditRsp',
        'SCH-InformationIE-AuditRsp',
        'FPACH-LCR-InformationItemIE-AuditRsp',
        'HS-DSCH-Resources-Information-AuditRsp-ExtIEs',
        'E-DCH-Resources-Information-AuditRsp-ExtIEs',
        'PLCCH-InformationItemIE-AuditRsp',
        'S-CCPCH-768-InformationItemIE-AuditRsp',
        'PRACH-768-InformationItemIE-AuditRsp',
        'E-RUCCH-InformationItemIE-AuditRsp',
        'E-RUCCH-768-InformationItemIE-AuditRsp',
        'Cell-Frequency-List-InformationIE-LCR-MulFreq-AuditRsp',
        'Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp-ExtIEs',
        'UPPCH-LCR-InformationIE-AuditRsp',
        'UPPCH-LCR-InformationItem-AuditRsp-ExtIEs',
        'MultipleFreq-HS-DSCH-Resources-InformationItem-AuditRsp',
        'MultipleFreq-E-DCH-Resources-InformationItem-AuditRsp',
        'CCP-InformationItemIE-AuditRsp',
        'CCP-InformationItem-AuditRsp-ExtIEs',
        'Local-Cell-InformationItemIE-AuditRsp',
        'Local-Cell-InformationItem-AuditRsp-ExtIEs',
        'Local-Cell-Group-InformationItemIE-AuditRsp',
        'Local-Cell-Group-InformationItem-AuditRsp-ExtIEs',
        'Power-Local-Cell-Group-InformationItemIE-AuditRsp',
        'Power-Local-Cell-Group-InformationItem-AuditRsp-ExtIEs',
        'AuditFailure-IEs',
        'AuditFailure-Extensions',
        'CommonMeasurementInitiationRequest-IEs',
        'CommonMeasurementInitiationRequest-Extensions',
        'Extension-CommonMeasurementObjectType-CM-RqstIE',
        'ERACHItem-CM-Rqst-ExtIEs',
        'CellItem-CM-Rqst-ExtIEs',
        'RACHItem-CM-Rqst-ExtIEs',
        'PowerLocalCellGroup-CM-Rqst-ExtIEs',
        'CommonMeasurementInitiationResponse-IEs',
        'CommonMeasurementInitiationResponse-Extensions',
        'Extension-CommonMeasurementObjectType-CM-RspIE',
        'ERACHItem-CM-Rsp-ExtIEs',
        'CellItem-CM-Rsp-ExtIEs',
        'RACHItem-CM-Rsp-ExtIEs',
        'PowerLocalCellGroup-CM-Rsp-ExtIEs',
        'CommonMeasurementInitiationFailure-IEs',
        'CommonMeasurementInitiationFailure-Extensions',
        'CommonMeasurementReport-IEs',
        'CommonMeasurementReport-Extensions',
        'Extension-CommonMeasurementObjectType-CM-RprtIE',
        'ERACHItem-CM-Rprt-ExtIEs',
        'CellItem-CM-Rprt-ExtIEs',
        'RACHItem-CM-Rprt-ExtIEs',
        'PowerLocalCellGroup-CM-Rprt-ExtIEs',
        'CommonMeasurementTerminationRequest-IEs',
        'CommonMeasurementTerminationRequest-Extensions',
        'CommonMeasurementFailureIndication-IEs',
        'CommonMeasurementFailureIndication-Extensions',
        'CellSetupRequestFDD-IEs',
        'CellSetupRequestFDD-Extensions',
        'Synchronisation-Configuration-Cell-SetupRqst-ExtIEs',
        'PrimarySCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'SecondarySCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'PrimaryCPICH-Information-Cell-SetupRqstFDD-ExtIEs',
        'SecondaryCPICH-InformationItemIE-Cell-SetupRqstFDD',
        'SecondaryCPICH-InformationItem-Cell-SetupRqstFDD-ExtIEs',
        'PrimaryCCPCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'BCH-Information-Cell-SetupRqstFDD-ExtIEs',
        'Limited-power-increase-information-Cell-SetupRqstFDD-ExtIEs',
        'IPDLParameter-Information-Cell-SetupRqstFDD-ExtIEs',
        'CellPortion-InformationItemIE-Cell-SetupRqstFDD',
        'CellPortion-InformationItem-Cell-SetupRqstFDD-ExtIEs',
        'CellSetupRequestTDD-IEs',
        'CellSetupRequestTDD-Extensions',
        'SCH-Information-Cell-SetupRqstTDD-ExtIEs',
        'SyncCaseIndicatorIE-Cell-SetupRqstTDD-PSCH',
        'Case1Item-Cell-SetupRqstTDD-ExtIEs',
        'Case2Item-Cell-SetupRqstTDD-ExtIEs',
        'PCCPCH-Information-Cell-SetupRqstTDD-ExtIEs',
        'TimeSlotConfigurationItem-Cell-SetupRqstTDD-ExtIEs',
        'TimeSlotConfigurationItem-LCR-Cell-SetupRqstTDD-ExtIEs',
        'PCCPCH-LCR-Information-Cell-SetupRqstTDD-ExtIEs',
        'DwPCH-LCR-Information-Cell-SetupRqstTDD-ExtIEs',
        'IPDLParameter-Information-Cell-SetupRqstTDD-ExtIEs',
        'IPDLParameter-Information-LCR-Cell-SetupRqstTDD-ExtIEs',
        'PCCPCH-768-Information-Cell-SetupRqstTDD-ExtIEs',
        'SCH-768-Information-Cell-SetupRqstTDD-ExtIEs',
        'Cell-Frequency-Item-LCR-MulFreq-Cell-SetupRqstTDD-ExtIEs',
        'CellSetupResponse-IEs',
        'CellSetupResponse-Extensions',
        'CellSetupFailure-IEs',
        'CellSetupFailure-Extensions',
        'CellReconfigurationRequestFDD-IEs',
        'CellReconfigurationRequestFDD-Extensions',
        'Synchronisation-Configuration-Cell-ReconfRqst-ExtIEs',
        'PrimarySCH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'SecondarySCH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'PrimaryCPICH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'SecondaryCPICH-InformationItemIE-Cell-ReconfRqstFDD',
        'SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD-ExtIEs',
        'PrimaryCCPCH-Information-Cell-ReconfRqstFDD-ExtIEs',
        'BCH-information-Cell-ReconfRqstFDD-ExtIEs',
        'IPDLParameter-Information-Cell-ReconfRqstFDD-ExtIEs',
        'CellPortion-InformationItemIE-Cell-ReconfRqstFDD',
        'CellPortion-InformationItem-Cell-ReconfRqstFDD-ExtIEs',
        'CellReconfigurationRequestTDD-IEs',
        'CellReconfigurationRequestTDD-Extensions',
        'PSCH-Information-Cell-ReconfRqstTDD-ExtIEs',
        'PCCPCH-Information-Cell-ReconfRqstTDD-ExtIEs',
        'TimeSlotConfigurationItem-Cell-ReconfRqstTDD-ExtIEs',
        'TimeSlotConfigurationItem-LCR-Cell-ReconfRqstTDD-ExtIEs',
        'DwPCH-LCR-Information-Cell-ReconfRqstTDD-ExtIEs',
        'IPDLParameter-Information-Cell-ReconfRqstTDD-ExtIEs',
        'IPDLParameter-Information-LCR-Cell-ReconfRqstTDD-ExtIEs',
        'PSCH-768-Information-Cell-ReconfRqstTDD-ExtIEs',
        'PCCPCH-768-Information-Cell-ReconfRqstTDD-ExtIEs',
        'Cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs',
        'Cell-Frequency-ModifyItem-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs',
        'Cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs',
        'CellReconfigurationResponse-IEs',
        'CellReconfigurationResponse-Extensions',
        'CellReconfigurationFailure-IEs',
        'CellReconfigurationFailure-Extensions',
        'CellDeletionRequest-IEs',
        'CellDeletionRequest-Extensions',
        'CellDeletionResponse-IEs',
        'CellDeletionResponse-Extensions',
        'ResourceStatusIndication-IEs',
        'ResourceStatusIndication-Extensions',
        'No-FailureItem-ResourceStatusInd-ExtIEs',
        'Local-Cell-InformationItemIE-ResourceStatusInd',
        'Local-Cell-InformationItem-ResourceStatusInd-ExtIEs',
        'Local-Cell-Group-InformationItemIE-ResourceStatusInd',
        'Local-Cell-Group-InformationItem-ResourceStatusInd-ExtIEs',
        'Power-Local-Cell-Group-InformationItemIE-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItem-ResourceStatusInd-ExtIEs',
        'ServiceImpactingItem-ResourceStatusInd-ExtIEs',
        'Local-Cell-InformationItemIE2-ResourceStatusInd',
        'Local-Cell-InformationItem2-ResourceStatusInd-ExtIEs',
        'Local-Cell-Group-InformationItemIE2-ResourceStatusInd',
        'Local-Cell-Group-InformationItem2-ResourceStatusInd-ExtIEs',
        'CCP-InformationItemIE-ResourceStatusInd',
        'CCP-InformationItem-ResourceStatusInd-ExtIEs',
        'Cell-InformationItemIE-ResourceStatusInd',
        'Cell-InformationItem-ResourceStatusInd-ExtIEs',
        'P-SCH-InformationIE-ResourceStatusInd',
        'S-SCH-InformationIE-ResourceStatusInd',
        'P-CPICH-InformationIE-ResourceStatusInd',
        'S-CPICH-InformationItemIE-ResourceStatusInd',
        'P-CCPCH-InformationIE-ResourceStatusInd',
        'BCH-InformationIE-ResourceStatusInd',
        'S-CCPCH-InformationItemIE-ResourceStatusInd',
        'PCH-InformationIE-ResourceStatusInd',
        'PICH-InformationIE-ResourceStatusInd',
        'FACH-InformationItemIE-ResourceStatusInd',
        'PRACH-InformationItemIE-ResourceStatusInd',
        'RACH-InformationItemIE-ResourceStatusInd',
        'AICH-InformationItemIE-ResourceStatusInd',
        'SCH-InformationIE-ResourceStatusInd',
        'FPACH-LCR-InformationItemIE-ResourceStatusInd',
        'DwPCH-LCR-InformationIE-ResourceStatusInd',
        'HS-DSCH-Resources-Information-ResourceStatusInd-ExtIEs',
        'E-DCH-Resources-Information-ResourceStatusInd-ExtIEs',
        'PLCCH-InformationItemIE-ResourceStatusInd',
        'S-CCPCH-768-InformationItemIE-ResourceStatusInd',
        'PRACH-768-InformationItemIE-ResourceStatusInd',
        'E-RUCCH-InformationItemIE-ResourceStatusInd',
        'E-RUCCH-768-InformationItemIE-ResourceStatusInd',
        'Cell-Frequency-List-InformationIE-LCR-MulFreq-ResourceStatusInd',
        'Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd-ExtIEs',
        'UPPCH-LCR-InformationIE-ResourceStatusInd',
        'UPPCH-LCR-InformationItem-ResourceStatusInd-ExtIEs',
        'MultipleFreq-HS-DSCH-Resources-InformationItem-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItemIE2-ResourceStatusInd',
        'Power-Local-Cell-Group-InformationItem2-ResourceStatusInd-ExtIEs',
        'MultipleFreq-E-DCH-Resources-InformationItem-ResourceStatusInd',
        'SystemInformationUpdateRequest-IEs',
        'SystemInformationUpdateRequest-Extensions',
        'MIB-SB-SIB-InformationItem-SystemInfoUpdateRqst-ExtIEs',
        'No-DeletionItem-SystemInfoUpdate-ExtIEs',
        'SegmentInformationListIEs-SystemInfoUpdate',
        'SegmentInformationItem-SystemInfoUpdate-ExtIEs',
        'SystemInformationUpdateResponse-IEs',
        'SystemInformationUpdateResponse-Extensions',
        'SystemInformationUpdateFailure-IEs',
        'SystemInformationUpdateFailure-Extensions',
        'RadioLinkSetupRequestFDD-IEs',
        'RadioLinkSetupRequestFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Setup-ItemIEs-ExtIEs',
        'UL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'DL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'PowerOffsetInformation-RL-SetupRqstFDD-ExtIEs',
        'RL-InformationItemIE-RL-SetupRqstFDD',
        'RL-InformationItem-RL-SetupRqstFDD-ExtIEs',
        'E-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'F-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD-ExtIEs',
        'RadioLinkSetupRequestTDD-IEs',
        'RadioLinkSetupRequestTDD-Extensions',
        'UL-CCTrCH-InformationItemIE-RL-SetupRqstTDD',
        'UL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'UL-DPCH-InformationIE-RL-SetupRqstTDD',
        'UL-DPCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'UL-DPCH-LCR-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'UL-DPCH-768-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationItemIE-RL-SetupRqstTDD',
        'DL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'CCTrCH-TPCItem-RL-SetupRqstTDD-ExtIEs',
        'DL-DPCH-InformationIE-RL-SetupRqstTDD',
        'DL-DPCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'DL-DPCH-LCR-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'DL-DPCH-768-InformationItem-RL-SetupRqstTDD-ExtIEs',
        'RL-Information-RL-SetupRqstTDD-ExtIEs',
        'RadioLinkSetupResponseFDD-IEs',
        'RadioLinkSetupResponseFDD-Extensions',
        'Additional-HS-Cell-Information-Response-ItemIEs-ExtIEs',
        'RL-InformationResponseItemIE-RL-SetupRspFDD',
        'RL-InformationResponseItem-RL-SetupRspFDD-ExtIEs',
        'Combining-RL-SetupRspFDD-ExtIEs',
        'NonCombiningOrFirstRLItem-RL-SetupRspFDD-ExtIEs',
        'RadioLinkSetupResponseTDD-IEs',
        'RadioLinkSetupResponseTDD-Extensions',
        'RL-InformationResponseList-RL-SetupRspTDD-ExtIEs',
        'DCH-InformationResponseListIEs-RL-SetupRspTDD',
        'DSCH-InformationResponseListIEs-RL-SetupRspTDD',
        'USCH-InformationResponseListIEs-RL-SetupRspTDD',
        'RL-InformationResponseList-LCR-RL-SetupRspTDD-ExtIEs',
        'RadioLinkSetupFailureFDD-IEs',
        'RadioLinkSetupFailureFDD-Extensions',
        'GeneralCauseItem-RL-SetupFailureFDD-ExtIEs',
        'RLSpecificCauseItem-RL-SetupFailureFDD-ExtIEs',
        'Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureFDD',
        'Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD-ExtIEs',
        'Successful-RL-InformationRespItemIE-RL-SetupFailureFDD',
        'Successful-RL-InformationRespItem-RL-SetupFailureFDD-ExtIEs',
        'CombiningItem-RL-SetupFailureFDD-ExtIEs',
        'NonCombiningOrFirstRLItem-RL-SetupFailureFDD-ExtIEs',
        'RadioLinkSetupFailureTDD-IEs',
        'RadioLinkSetupFailureTDD-Extensions',
        'GeneralCauseItem-RL-SetupFailureTDD-ExtIEs',
        'RLSpecificCauseItem-RL-SetupFailureTDD-ExtIEs',
        'Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureTDD',
        'Unsuccessful-RL-InformationResp-RL-SetupFailureTDD-ExtIEs',
        'RadioLinkAdditionRequestFDD-IEs',
        'RadioLinkAdditionRequestFDD-Extensions',
        'Additional-EDCH-Cell-Information-RL-Add-Req-ExtIEs',
        'Additional-HS-Cell-Information-RL-Addition-ItemIEs-ExtIEs',
        'RL-InformationItemIE-RL-AdditionRqstFDD',
        'RL-InformationItem-RL-AdditionRqstFDD-ExtIEs',
        'E-DPCH-Information-RL-AdditionReqFDD-ExtIEs',
        'RadioLinkAdditionRequestTDD-IEs',
        'RadioLinkAdditionRequestTDD-Extensions',
        'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'UL-DPCH-InformationItemIE-RL-AdditionRqstTDD',
        'UL-DPCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD-ExtIEs',
        'UL-DPCH-InformationItem-768-RL-AdditionRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'DL-DPCH-InformationItemIE-RL-AdditionRqstTDD',
        'DL-DPCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        'DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD-ExtIEs',
        'DL-DPCH-InformationItem-768-RL-AdditionRqstTDD-ExtIEs',
        'RL-information-RL-AdditionRqstTDD-ExtIEs',
        'RadioLinkAdditionResponseFDD-IEs',
        'RadioLinkAdditionResponseFDD-Extensions',
        'Additional-HS-Cell-Change-Information-Response-ItemIEs-ExtIEs',
        'RL-InformationResponseItemIE-RL-AdditionRspFDD',
        'RL-InformationResponseItem-RL-AdditionRspFDD-ExtIEs',
        'CombiningItem-RL-AdditionRspFDD-ExtIEs',
        'Non-CombiningItem-RL-AdditionRspFDD-ExtIEs',
        'RadioLinkAdditionResponseTDD-IEs',
        'RadioLinkAdditionResponseTDD-Extensions',
        'RL-InformationResponse-RL-AdditionRspTDD-ExtIEs',
        'DCH-Information-RL-AdditionRspTDD-ExtIEs',
        'CombiningItem-RL-AdditionRspTDD-ExtIEs',
        'Non-CombiningItem-RL-AdditionRspTDD-ExtIEs',
        'DSCH-InformationResponseListIEs-RL-AdditionRspTDD',
        'USCH-InformationResponseListIEs-RL-AdditionRspTDD',
        'RL-InformationResponse-LCR-RL-AdditionRspTDD-ExtIEs',
        'RadioLinkAdditionFailureFDD-IEs',
        'RadioLinkAdditionFailureFDD-Extensions',
        'GeneralCauseItem-RL-AdditionFailureFDD-ExtIEs',
        'RLSpecificCauseItem-RL-AdditionFailureFDD-ExtIEs',
        'Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureFDD',
        'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD-ExtIEs',
        'Successful-RL-InformationRespItemIE-RL-AdditionFailureFDD',
        'Successful-RL-InformationRespItem-RL-AdditionFailureFDD-ExtIEs',
        'CombiningItem-RL-AdditionFailureFDD-ExtIEs',
        'Non-CombiningItem-RL-AdditionFailureFDD-ExtIEs',
        'RadioLinkAdditionFailureTDD-IEs',
        'RadioLinkAdditionFailureTDD-Extensions',
        'GeneralCauseItem-RL-AdditionFailureTDD-ExtIEs',
        'RLSpecificCauseItem-RL-AdditionFailureTDD-ExtIEs',
        'Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureTDD',
        'Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD-ExtIEs',
        'RadioLinkReconfigurationPrepareFDD-IEs',
        'RadioLinkReconfigurationPrepareFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs-ExtIEs',
        'Additional-EDCH-Cell-Information-RL-Reconf-Prep-ExtIEs',
        'UL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'DL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'DL-DPCH-Power-Information-RL-ReconfPrepFDD-ExtIEs',
        'PowerOffsetInformation-RL-ReconfPrepFDD-ExtIEs',
        'DCH-DeleteItem-RL-ReconfPrepFDD-ExtIEs',
        'RL-InformationItemIE-RL-ReconfPrepFDD',
        'RL-InformationItem-RL-ReconfPrepFDD-ExtIEs',
        'E-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'F-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD-ExtIEs',
        'RadioLinkReconfigurationPrepareTDD-IEs',
        'RadioLinkReconfigurationPrepareTDD-Extensions',
        'UL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-InformationAddListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-LCR-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-InformationModify-AddListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-InformationModify-ModifyListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDDLCR-ExtIEs',
        'UL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD768-ExtIEs',
        'UL-DPCH-InformationModify-DeleteListIEs-RL-ReconfPrepTDD',
        'UL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-LCR-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-UL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD-ExtIEs',
        'UL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'UL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'CCTrCH-TPCAddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationAddListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-LCR-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationModify-AddListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationModify-ModifyListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Code-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-Code-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-InformationModify-DeleteListIEs-RL-ReconfPrepTDD',
        'DL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-LCR-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'MultipleRL-DL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD-ExtIEs',
        'DL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs',
        'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'DSCH-Information-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'DSCH-Information-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'USCH-Information-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        'USCH-Information-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        'RL-Information-RL-ReconfPrepTDD-ExtIEs',
        'RadioLinkReconfigurationReady-IEs',
        'RadioLinkReconfigurationReady-Extensions',
        'RL-InformationResponseItemIE-RL-ReconfReady',
        'RL-InformationResponseItem-RL-ReconfReady-ExtIEs',
        'DCH-InformationResponseListIEs-RL-ReconfReady',
        'DSCH-InformationResponseListIEs-RL-ReconfReady',
        'USCH-InformationResponseListIEs-RL-ReconfReady',
        'RadioLinkReconfigurationFailure-IEs',
        'RadioLinkReconfigurationFailure-Extensions',
        'GeneralCauseItem-RL-ReconfFailure-ExtIEs',
        'RLSpecificCauseItem-RL-ReconfFailure-ExtIEs',
        'RL-ReconfigurationFailureItemIE-RL-ReconfFailure',
        'RL-ReconfigurationFailureItem-RL-ReconfFailure-ExtIEs',
        'RadioLinkReconfigurationCommit-IEs',
        'RadioLinkReconfigurationCommit-Extensions',
        'RadioLinkReconfigurationCancel-IEs',
        'RadioLinkReconfigurationCancel-Extensions',
        'RadioLinkReconfigurationRequestFDD-IEs',
        'RadioLinkReconfigurationRequestFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Reconf-Req-ExtIEs',
        'Additional-EDCH-Cell-Information-RL-Reconf-Req-ExtIEs',
        'UL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        'DL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        'DCH-DeleteItem-RL-ReconfRqstFDD-ExtIEs',
        'RL-InformationItemIE-RL-ReconfRqstFDD',
        'RL-InformationItem-RL-ReconfRqstFDD-ExtIEs',
        'E-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        'RadioLinkReconfigurationRequestTDD-IEs',
        'RadioLinkReconfigurationRequestTDD-Extensions',
        'UL-CCTrCH-InformationModifyItemIE-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        'UL-CCTrCH-InformationDeleteItemIE-RL-ReconfRqstTDD',
        'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationModifyItemIE-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        'DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD-ExtIEs',
        'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfRqstTDD-ExtIEs',
        'DL-CCTrCH-InformationDeleteItemIE-RL-ReconfRqstTDD',
        'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        'DCH-DeleteItem-RL-ReconfRqstTDD-ExtIEs',
        'RL-InformationItem-RL-ReconfRqstTDD-ExtIEs',
        'RadioLinkReconfigurationResponse-IEs',
        'RadioLinkReconfigurationResponse-Extensions',
        'RL-InformationResponseItemIE-RL-ReconfRsp',
        'RL-InformationResponseItem-RL-ReconfRsp-ExtIEs',
        'DCH-InformationResponseListIEs-RL-ReconfRsp',
        'RadioLinkDeletionRequest-IEs',
        'RadioLinkDeletionRequest-Extensions',
        'RL-informationItemIE-RL-DeletionRqst',
        'RL-informationItem-RL-DeletionRqst-ExtIEs',
        'RadioLinkDeletionResponse-IEs',
        'RadioLinkDeletionResponse-Extensions',
        'DL-PowerControlRequest-IEs',
        'DL-PowerControlRequest-Extensions',
        'DL-ReferencePowerInformationItemIE-DL-PC-Rqst',
        'DL-ReferencePowerInformationItem-DL-PC-Rqst-ExtIEs',
        'DL-PowerTimeslotControlRequest-IEs',
        'DL-PowerTimeslotControlRequest-Extensions',
        'DedicatedMeasurementInitiationRequest-IEs',
        'DedicatedMeasurementInitiationRequest-Extensions',
        'RLItem-DM-Rqst-ExtIEs',
        'RL-InformationItemIE-DM-Rqst',
        'RL-InformationItem-DM-Rqst-ExtIEs',
        'RL-SetItem-DM-Rqst-ExtIEs',
        'RL-Set-InformationItem-DM-Rqst-ExtIEs',
        'DedicatedMeasurementInitiationResponse-IEs',
        'DedicatedMeasurementInitiationResponse-Extensions',
        'RLItem-DM-Rsp-ExtIEs',
        'RL-InformationItemIE-DM-Rsp',
        'RL-InformationItem-DM-Rsp-ExtIEs',
        'Multiple-PUSCH-InfoListIE-DM-Rsp-ExtIEs',
        'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp-ExtIEs',
        'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        'Multiple-DedicatedMeasurementValueItem-768-TDD-DM-Rsp-ExtIEs',
        'RL-SetItem-DM-Rsp-ExtIEs',
        'RL-Set-InformationItemIE-DM-Rsp',
        'RL-Set-InformationItem-DM-Rsp-ExtIEs',
        'DedicatedMeasurementInitiationFailure-IEs',
        'DedicatedMeasurementInitiationFailure-Extensions',
        'DedicatedMeasurementReport-IEs',
        'DedicatedMeasurementReport-Extensions',
        'RLItem-DM-Rprt-ExtIEs',
        'RL-InformationItemIE-DM-Rprt',
        'RL-InformationItem-DM-Rprt-ExtIEs',
        'Multiple-PUSCH-InfoListIE-DM-Rprt-ExtIEs',
        'RL-SetItem-DM-Rprt-ExtIEs',
        'RL-Set-InformationItemIE-DM-Rprt',
        'RL-Set-InformationItem-DM-Rprt-ExtIEs',
        'DedicatedMeasurementTerminationRequest-IEs',
        'DedicatedMeasurementTerminationRequest-Extensions',
        'DedicatedMeasurementFailureIndication-IEs',
        'DedicatedMeasurementFailureIndication-Extensions',
        'RadioLinkFailureIndication-IEs',
        'RadioLinkFailureIndication-Extensions',
        'RLItem-RL-FailureInd-ExtIEs',
        'RL-InformationItemIE-RL-FailureInd',
        'RL-InformationItem-RL-FailureInd-ExtIEs',
        'RL-SetItem-RL-FailureInd-ExtIEs',
        'RL-Set-InformationItemIE-RL-FailureInd',
        'RL-Set-InformationItem-RL-FailureInd-ExtIEs',
        'CCTrCHItem-RL-FailureInd-ExtIEs',
        'CCTrCH-InformationItemIE-RL-FailureInd',
        'CCTrCH-InformationItem-RL-FailureInd-ExtIEs',
        'RadioLinkPreemptionRequiredIndication-IEs',
        'RadioLinkPreemptionRequiredIndication-Extensions',
        'RL-InformationItemIE-RL-PreemptRequiredInd',
        'RL-InformationItem-RL-PreemptRequiredInd-ExtIEs',
        'RadioLinkRestoreIndication-IEs',
        'RadioLinkRestoreIndication-Extensions',
        'RLItem-RL-RestoreInd-ExtIEs',
        'RL-InformationItemIE-RL-RestoreInd',
        'RL-InformationItem-RL-RestoreInd-ExtIEs',
        'RL-SetItem-RL-RestoreInd-ExtIEs',
        'RL-Set-InformationItemIE-RL-RestoreInd',
        'RL-Set-InformationItem-RL-RestoreInd-ExtIEs',
        'CCTrCHItem-RL-RestoreInd-ExtIEs',
        'CCTrCH-InformationItemIE-RL-RestoreInd',
        'CCTrCH-InformationItem-RL-RestoreInd-ExtIEs',
        'CompressedModeCommand-IEs',
        'CompressedModeCommand-Extensions',
        'ErrorIndication-IEs',
        'ErrorIndication-Extensions',
        'PrivateMessage-IEs',
        'PhysicalSharedChannelReconfigurationRequestFDD-IEs',
        'PhysicalSharedChannelReconfigurationRequestFDD-Extensions',
        'HSDPA-And-EDCH-CellPortion-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'PhysicalSharedChannelReconfigurationRequestTDD-IEs',
        'PhysicalSharedChannelReconfigurationRequestTDD-Extensions',
        'PDSCHSets-AddItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-Information-AddListIEs-PSCH-ReconfRqst',
        'PDSCH-Information-AddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-AddInformation-768-AddItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'PDSCHSets-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-Information-ModifyListIEs-PSCH-ReconfRqst',
        'PDSCH-Information-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCH-ModifyInformation-768-ModifyListIE-PSCH-ReconfRqst-ExtIEs',
        'DL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'DL-Code-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PDSCHSets-DeleteItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCHSets-AddItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-Information-AddListIEs-PSCH-ReconfRqst',
        'PUSCH-Information-AddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationAddItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-AddInformation-768-AddItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs',
        'PUSCHSets-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-Information-ModifyListIEs-PSCH-ReconfRqst',
        'PUSCH-Information-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'UL-Code-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'PUSCHSets-DeleteItem-PSCH-ReconfRqst-ExtIEs',
        'HS-PDSCH-TDD-Information-PSCH-ReconfRqst-ExtIEs',
        'DL-HS-PDSCH-Timeslot-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'DL-HS-PDSCH-Timeslot-InformationItem-768-PSCH-ReconfRqst-ExtIEs',
        'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItemIE-PSCH-ReconfRqst',
        'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst-ExtIEs',
        'Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-Information-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-Information-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationItem-768-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-Information-768-PSCH-ReconfRqst-ExtIEs',
        'Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-InformationModify-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-InformationModify-LCR-PSCH-ReconfRqst-ExtIEs',
        'HS-SCCH-InformationModifyItem-768-PSCH-ReconfRqst-ExtIEs',
        'HS-SICH-InformationModify-768-PSCH-ReconfRqst-ExtIEs',
        'Delete-From-HS-SCCH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Information-PSCH-ReconfRqst-ExtIEs',
        'Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationItem-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationModifyItem-PSCH-ReconfRqst-ExtIEs',
        'Delete-From-E-AGCH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-Information-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Information-768-PSCH-ReconfRqst-ExtIEs',
        'Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationItem-768-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationModifyItem-768-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-Information-768-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Information-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-PUCH-Timeslot-Item-InfoLCR-ExtIEs',
        'Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-AGCH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs',
        'E-HICH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'Delete-From-E-HICH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs',
        'SYNC-UL-Partition-LCR-ExtIEs',
        'MultipleFreq-E-PUCH-Timeslot-InformationItemIE-LCR-PSCH-ReconfRqst',
        'MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst-ExtIEs',
        'Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst-Item-ExtIEs',
        'Max-RTWP-perCellPortion-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs',
        'PhysicalSharedChannelReconfigurationResponse-IEs',
        'PhysicalSharedChannelReconfigurationResponse-Extensions',
        'Multiple-E-HICH-TimeOffsetLCR',
        'MultipleFreq-E-HICH-TimeOffsetLCR-ExtIEs',
        'PhysicalSharedChannelReconfigurationFailure-IEs',
        'PhysicalSharedChannelReconfigurationFailure-Extensions',
        'GeneralCauseItem-PSCH-ReconfFailure-ExtIEs',
        'SetSpecificCauseItem-PSCH-ReconfFailureTDD-ExtIEs',
        'Unsuccessful-PDSCHSetItemIE-PSCH-ReconfFailureTDD',
        'Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD-ExtIEs',
        'Unsuccessful-PUSCHSetItemIE-PSCH-ReconfFailureTDD',
        'Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD-ExtIEs',
        'Extension-CauseLevel-PSCH-ReconfFailureIE',
        'Unsuccessful-UARFCNItemIE-PSCH-ReconfFailureTDD',
        'Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD-ExtIEs',
        'Common-System-Information-ResponseLCR-ExtIEs',
        'ResetRequest-IEs',
        'ResetRequest-Extensions',
        'CommunicationContextItem-Reset-ExtIEs',
        'CommunicationContextInfoItemIE-Reset',
        'CommunicationContextInfoItem-Reset-ExtIEs',
        'CommunicationControlPortItem-Reset-ExtIEs',
        'CommunicationControlPortInfoItemIE-Reset',
        'CommunicationControlPortInfoItem-Reset-ExtIEs',
        'ResetResponse-IEs',
        'ResetResponse-Extensions',
        'InformationExchangeInitiationRequest-IEs',
        'InformationExchangeInitiationRequest-Extensions',
        'CellItem-InfEx-Rqst-ExtIEs',
        'InformationExchangeInitiationResponse-IEs',
        'InformationExchangeInitiationResponse-Extensions',
        'CellItem-InfEx-Rsp-ExtIEs',
        'InformationExchangeInitiationFailure-IEs',
        'InformationExchangeInitiationFailure-Extensions',
        'InformationReport-IEs',
        'InformationReport-Extensions',
        'CellItem-Inf-Rprt-ExtIEs',
        'InformationExchangeTerminationRequest-IEs',
        'InformationExchangeTerminationRequest-Extensions',
        'InformationExchangeFailureIndication-IEs',
        'InformationExchangeFailureIndication-Extensions',
        'CellSynchronisationInitiationRequestTDD-IEs',
        'CellSynchronisationInitiationRequestTDD-Extensions',
        'CellSyncBurstTransInit-CellSyncInitiationRqstTDD-ExtIEs',
        'CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD-ExtIEs',
        'SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD-ExtIEs',
        'SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD-ExtIEs',
        'CellSynchronisationInitiationResponseTDD-Extensions',
        'CellSynchronisationInitiationResponseTDD-IEs',
        'CellSynchronisationInitiationFailureTDD-Extensions',
        'CellSynchronisationInitiationFailureTDD-IEs',
        'CellSynchronisationReconfigurationRequestTDD-IEs',
        'CellSynchronisationReconfigurationRequestTDD-Extensions',
        'CellSyncBurstTransInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'CellSyncBurstMeasInfo-CellSyncReconfRqstTDD-ExtIEs',
        'CellSyncBurstMeasInfoListIEs-CellSyncReconfRqstTDD',
        'SynchronisationReportTypeIEs',
        'SynchronisationReportCharacteristicsIEs',
        'CellSyncBurstMeasInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'CellSyncBurstInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdMeasInfoLCR-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdMeasInfoItem-CellSyncReconfRqstTDD-ExtIEs',
        'SYNCDlCodeIdInfoItemLCR-CellSyncReconfRqstTDD-ExtIEs',
        'CellSynchronisationReconfigurationResponseTDD-Extensions',
        'CellSynchronisationReconfigurationResponseTDD-IEs',
        'CellSynchronisationReconfigurationFailureTDD-Extensions',
        'CellSynchronisationReconfigurationFailureTDD-IEs',
        'CellSynchronisationAdjustmentRequestTDD-Extensions',
        'CellSynchronisationAdjustmentRequestTDD-IEs',
        'CellAdjustmentInfoItemIE-SyncAdjustmntRqstTDD',
        'CellAdjustmentInfoItem-SyncAdjustmntRqstTDD-ExtIEs',
        'CellSynchronisationAdjustmentResponseTDD-Extensions',
        'CellSynchronisationAdjustmentResponseTDD-IEs',
        'CellSynchronisationAdjustmentFailureTDD-Extensions',
        'CellSynchronisationAdjustmentFailureTDD-IEs',
        'GeneralCauseList-SyncAdjustmntFailureTDD-ExtIEs',
        'CellSpecificCauseList-SyncAdjustmntFailureTDD-ExtIEs',
        'Unsuccessful-cell-InformationRespItemIE-SyncAdjustmntFailureTDD',
        'Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD-ExtIEs',
        'CellSynchronisationTerminationRequestTDD-Extensions',
        'CellSynchronisationTerminationRequestTDD-IEs',
        'CellSynchronisationFailureIndicationTDD-Extensions',
        'CellSynchronisationFailureIndicationTDD-IEs',
        'CellSynchronisationReportTDD-Extensions',
        'CellSynchronisationReportTDD-IEs',
        'C-ID-IEs-CellSyncReprtTDD',
        'SyncReportTypeIEs-CellSyncReprtTDD',
        'IntStdPhCellSyncInfoList-CellSyncReprtTDD-ExtIEs',
        'CellSyncBurstMeasInfoItem-CellSyncReprtTDD-ExtIEs',
        'CellSyncBurstAvailable-CellSyncReprtTDD-ExtIEs',
        'SyncDLCodeIdsMeasInfoItem-CellSyncReprtTDD-ExtIEs',
        'SyncDLCodeIdAvailable-CellSyncReprtTDD-ExtIEs',
        'BearerRearrangementIndication-IEs',
        'BearerRearrangementIndication-Extensions',
        'DCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'DSCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'USCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'HSDSCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'E-DCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs',
        'Additional-EDCH-Cell-Information-Bearer-Rearrangement-ItemIEs-ExtIEs',
        'RadioLinkActivationCommandFDD-IEs',
        'RadioLinkActivationCommandFDD-Extensions',
        'DelayedActivationInformation-RL-ActivationCmdFDD-IEs',
        'DelayedActivationInformation-RL-ActivationCmdFDD-ExtIEs',
        'RadioLinkActivationCommandTDD-IEs',
        'RadioLinkActivationCommandTDD-Extensions',
        'DelayedActivationInformation-RL-ActivationCmdTDD-IEs',
        'DelayedActivationInformation-RL-ActivationCmdTDD-ExtIEs',
        'RadioLinkParameterUpdateIndicationFDD-IEs',
        'RadioLinkParameterUpdateIndicationFDD-Extensions',
        'Additional-HS-Cell-Information-RL-Setup-ExtIEs',
        'Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs-ExtIEs',
        'UE-Measurement-Forwarding-ExtIEs',
        'RadioLinkParameterUpdateIndicationTDD-IEs',
        'RadioLinkParameterUpdateIndicationTDD-Extensions',
        'MBMSNotificationUpdateCommand-IEs',
        'MBMSNotificationUpdateCommand-Extensions',
        'UEStatusUpdateCommand-IEs',
        'UEStatusUpdateCommand-Extensions',
        'SecondaryULFrequencyReport-IEs',
        'SecondaryULFrequencyReport-Extensions',
        'SecondaryULFrequencyUpdateIndication-IEs',
        'SecondaryULFrequencyUpdateIndication-Extensions',
        'UEStatusUpdateConfirmRequest-IEs',
        'UEStatusUpdateConfirmRequest-Extensions',
        'UEStatusUpdateConfirmResponse-IEs',
        'UEStatusUpdateConfirmResponse-Extensions',
        ]
    _param_ = [
        ]
    
    #-----< CommonTransportChannelSetupRequestFDD >-----#
    CommonTransportChannelSetupRequestFDD = SEQ(name='CommonTransportChannelSetupRequestFDD', mode=MODE_TYPE)
    _CommonTransportChannelSetupRequestFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelSetupRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonPhysicalChannelType-CTCH-SetupRqstFDD')))
    ____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__id._const_tab = ____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__value._const_tab = ____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonTransportChannelSetupRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__id),
        ('criticality', ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__criticality),
        ('value', ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__value),
        ])
    __CommonTransportChannelSetupRequestFDD_protocolIEs__item_._ext = None
    _CommonTransportChannelSetupRequestFDD_protocolIEs._cont = __CommonTransportChannelSetupRequestFDD_protocolIEs__item_
    _CommonTransportChannelSetupRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelSetupRequestFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelSetupRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__id._const_tab = ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__criticality_tab
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__extensionValue_tab
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonTransportChannelSetupRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__id),
        ('criticality', ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelSetupRequestFDD_protocolExtensions__item_._ext = None
    _CommonTransportChannelSetupRequestFDD_protocolExtensions._cont = __CommonTransportChannelSetupRequestFDD_protocolExtensions__item_
    _CommonTransportChannelSetupRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelSetupRequestFDD._cont = ASN1Dict([
        ('protocolIEs', _CommonTransportChannelSetupRequestFDD_protocolIEs),
        ('protocolExtensions', _CommonTransportChannelSetupRequestFDD_protocolExtensions),
        ])
    CommonTransportChannelSetupRequestFDD._ext = []
    
    #-----< CommonTransportChannelSetupRequestFDD-Extensions >-----#
    CommonTransportChannelSetupRequestFDD_Extensions = CLASS(name='CommonTransportChannelSetupRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonTransportChannelSetupRequestFDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelSetupRequestFDD-IEs >-----#
    CommonTransportChannelSetupRequestFDD_IEs = CLASS(name='CommonTransportChannelSetupRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonTransportChannelSetupRequestFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CommonTransportChannelSetupRequestFDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _CommonTransportChannelSetupRequestFDD_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonPhysicalChannelType-CTCH-SetupRqstFDD')))
    CommonTransportChannelSetupRequestFDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _CommonTransportChannelSetupRequestFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _CommonTransportChannelSetupRequestFDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _CommonTransportChannelSetupRequestFDD_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonPhysicalChannelType-CTCH-SetupRqstFDD >-----#
    CommonPhysicalChannelType_CTCH_SetupRqstFDD = CHOICE(name='CommonPhysicalChannelType-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _CommonPhysicalChannelType_CTCH_SetupRqstFDD_secondary_CCPCH_parameters = SEQ(name='secondary-CCPCH-parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-CTCH-SetupRqstFDD')))
    _CommonPhysicalChannelType_CTCH_SetupRqstFDD_pRACH_parameters = SEQ(name='pRACH-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-CTCH-SetupRqstFDD')))
    _CommonPhysicalChannelType_CTCH_SetupRqstFDD_notUsed_pCPCHes_parameters = NULL(name='notUsed-pCPCHes-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CommonPhysicalChannelType_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('secondary-CCPCH-parameters', _CommonPhysicalChannelType_CTCH_SetupRqstFDD_secondary_CCPCH_parameters),
        ('pRACH-parameters', _CommonPhysicalChannelType_CTCH_SetupRqstFDD_pRACH_parameters),
        ('notUsed-pCPCHes-parameters', _CommonPhysicalChannelType_CTCH_SetupRqstFDD_notUsed_pCPCHes_parameters),
        ])
    CommonPhysicalChannelType_CTCH_SetupRqstFDD._ext = []
    
    #-----< Secondary-CCPCH-CTCH-SetupRqstFDD >-----#
    Secondary_CCPCH_CTCH_SetupRqstFDD = SEQ(name='Secondary-CCPCH-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _Secondary_CCPCH_CTCH_SetupRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _Secondary_CCPCH_CTCH_SetupRqstFDD_fdd_S_CCPCH_Offset = INT(name='fdd-S-CCPCH-Offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-S-CCPCH-Offset')))
    _Secondary_CCPCH_CTCH_SetupRqstFDD_dl_ScramblingCode = INT(name='dl-ScramblingCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-ScramblingCode')), opt=True)
    _Secondary_CCPCH_CTCH_SetupRqstFDD_fdd_DL_ChannelisationCodeNumber = INT(name='fdd-DL-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _Secondary_CCPCH_CTCH_SetupRqstFDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _Secondary_CCPCH_CTCH_SetupRqstFDD_secondary_CCPCH_SlotFormat = INT(name='secondary-CCPCH-SlotFormat', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SecondaryCCPCH-SlotFormat')))
    _Secondary_CCPCH_CTCH_SetupRqstFDD_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _Secondary_CCPCH_CTCH_SetupRqstFDD_multiplexingPosition = ENUM(name='multiplexingPosition', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MultiplexingPosition')))
    _Secondary_CCPCH_CTCH_SetupRqstFDD_powerOffsetInformation = SEQ(name='powerOffsetInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PowerOffsetInformation-CTCH-SetupRqstFDD')))
    _Secondary_CCPCH_CTCH_SetupRqstFDD_sTTD_Indicator = ENUM(name='sTTD-Indicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'STTD-Indicator')))
    _Secondary_CCPCH_CTCH_SetupRqstFDD_fACH_Parameters = SEQ(name='fACH-Parameters', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersList-CTCH-SetupRqstFDD')), opt=True)
    _Secondary_CCPCH_CTCH_SetupRqstFDD_pCH_Parameters = SEQ(name='pCH-Parameters', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-Parameters-CTCH-SetupRqstFDD')), opt=True)
    _Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-Parameters-CTCH-SetupRqstFDD')))
    _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FDD-S-CCPCH-FrameOffset')))
    _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ModulationPO-MBSFN')))
    _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Secondary-CCPCH-SlotFormat-Extended')))
    _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IMB-Parameters')))
    _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BCH-Parameters')))
    ____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 642), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 681), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 892), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 876), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1045), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1286), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions._cont = __Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item_
    _Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _Secondary_CCPCH_CTCH_SetupRqstFDD_commonPhysicalChannelID),
        ('fdd-S-CCPCH-Offset', _Secondary_CCPCH_CTCH_SetupRqstFDD_fdd_S_CCPCH_Offset),
        ('dl-ScramblingCode', _Secondary_CCPCH_CTCH_SetupRqstFDD_dl_ScramblingCode),
        ('fdd-DL-ChannelisationCodeNumber', _Secondary_CCPCH_CTCH_SetupRqstFDD_fdd_DL_ChannelisationCodeNumber),
        ('tFCS', _Secondary_CCPCH_CTCH_SetupRqstFDD_tFCS),
        ('secondary-CCPCH-SlotFormat', _Secondary_CCPCH_CTCH_SetupRqstFDD_secondary_CCPCH_SlotFormat),
        ('tFCI-Presence', _Secondary_CCPCH_CTCH_SetupRqstFDD_tFCI_Presence),
        ('multiplexingPosition', _Secondary_CCPCH_CTCH_SetupRqstFDD_multiplexingPosition),
        ('powerOffsetInformation', _Secondary_CCPCH_CTCH_SetupRqstFDD_powerOffsetInformation),
        ('sTTD-Indicator', _Secondary_CCPCH_CTCH_SetupRqstFDD_sTTD_Indicator),
        ('fACH-Parameters', _Secondary_CCPCH_CTCH_SetupRqstFDD_fACH_Parameters),
        ('pCH-Parameters', _Secondary_CCPCH_CTCH_SetupRqstFDD_pCH_Parameters),
        ('iE-Extensions', _Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions),
        ])
    Secondary_CCPCH_CTCH_SetupRqstFDD._ext = []
    
    #-----< Secondary-CCPCHItem-CTCH-SetupRqstFDD-ExtIEs >-----#
    Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs = CLASS(name='Secondary-CCPCHItem-CTCH-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-Parameters-CTCH-SetupRqstFDD')))
    _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FDD-S-CCPCH-FrameOffset')))
    _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ModulationPO-MBSFN')))
    _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Secondary-CCPCH-SlotFormat-Extended')))
    _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IMB-Parameters')))
    _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BCH-Parameters')))
    Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 642), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 681), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 892), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 876), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1045), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1286), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PowerOffsetInformation-CTCH-SetupRqstFDD >-----#
    PowerOffsetInformation_CTCH_SetupRqstFDD = SEQ(name='PowerOffsetInformation-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _PowerOffsetInformation_CTCH_SetupRqstFDD_pO1_ForTFCI_Bits = INT(name='pO1-ForTFCI-Bits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_CTCH_SetupRqstFDD_pO3_ForPilotBits = INT(name='pO3-ForPilotBits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item_._ext = None
    _PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions._cont = __PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item_
    _PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerOffsetInformation_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('pO1-ForTFCI-Bits', _PowerOffsetInformation_CTCH_SetupRqstFDD_pO1_ForTFCI_Bits),
        ('pO3-ForPilotBits', _PowerOffsetInformation_CTCH_SetupRqstFDD_pO3_ForPilotBits),
        ('iE-Extensions', _PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions),
        ])
    PowerOffsetInformation_CTCH_SetupRqstFDD._ext = []
    
    #-----< PowerOffsetInformation-CTCH-SetupRqstFDD-ExtIEs >-----#
    PowerOffsetInformation_CTCH_SetupRqstFDD_ExtIEs = CLASS(name='PowerOffsetInformation-CTCH-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PowerOffsetInformation_CTCH_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FACH-ParametersList-CTCH-SetupRqstFDD >-----#
    FACH_ParametersList_CTCH_SetupRqstFDD = SEQ(name='FACH-ParametersList-CTCH-SetupRqstFDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _FACH_ParametersList_CTCH_SetupRqstFDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __FACH_ParametersList_CTCH_SetupRqstFDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___FACH_ParametersList_CTCH_SetupRqstFDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersListIE-CTCH-SetupRqstFDD')))
    __FACH_ParametersList_CTCH_SetupRqstFDD_id_tab._val = ASN1Set(rv=[dict([('id', 121), ('criticality', 'reject'), ('Value', ___FACH_ParametersList_CTCH_SetupRqstFDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _FACH_ParametersList_CTCH_SetupRqstFDD_id._const_tab = __FACH_ParametersList_CTCH_SetupRqstFDD_id_tab
    _FACH_ParametersList_CTCH_SetupRqstFDD_id._const_tab_at = None
    _FACH_ParametersList_CTCH_SetupRqstFDD_id._const_tab_id = 'id'
    _FACH_ParametersList_CTCH_SetupRqstFDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _FACH_ParametersList_CTCH_SetupRqstFDD_criticality._const_tab = __FACH_ParametersList_CTCH_SetupRqstFDD_id_tab
    _FACH_ParametersList_CTCH_SetupRqstFDD_criticality._const_tab_at = ('..', 'id')
    _FACH_ParametersList_CTCH_SetupRqstFDD_criticality._const_tab_id = 'criticality'
    _FACH_ParametersList_CTCH_SetupRqstFDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _FACH_ParametersList_CTCH_SetupRqstFDD_value._const_tab = __FACH_ParametersList_CTCH_SetupRqstFDD_id_tab
    _FACH_ParametersList_CTCH_SetupRqstFDD_value._const_tab_at = ('..', 'id')
    _FACH_ParametersList_CTCH_SetupRqstFDD_value._const_tab_id = 'Value'
    FACH_ParametersList_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('id', _FACH_ParametersList_CTCH_SetupRqstFDD_id),
        ('criticality', _FACH_ParametersList_CTCH_SetupRqstFDD_criticality),
        ('value', _FACH_ParametersList_CTCH_SetupRqstFDD_value),
        ])
    FACH_ParametersList_CTCH_SetupRqstFDD._ext = None
    
    #-----< FACH-ParametersListIEs-CTCH-SetupRqstFDD >-----#
    FACH_ParametersListIEs_CTCH_SetupRqstFDD = CLASS(name='FACH-ParametersListIEs-CTCH-SetupRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _FACH_ParametersListIEs_CTCH_SetupRqstFDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersListIE-CTCH-SetupRqstFDD')))
    FACH_ParametersListIEs_CTCH_SetupRqstFDD._val = ASN1Set(rv=[dict([('id', 121), ('criticality', 'reject'), ('Value', _FACH_ParametersListIEs_CTCH_SetupRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< FACH-ParametersListIE-CTCH-SetupRqstFDD >-----#
    FACH_ParametersListIE_CTCH_SetupRqstFDD = SEQ_OF(name='FACH-ParametersListIE-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _FACH_ParametersListIE_CTCH_SetupRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersItem-CTCH-SetupRqstFDD')))
    FACH_ParametersListIE_CTCH_SetupRqstFDD._cont = _FACH_ParametersListIE_CTCH_SetupRqstFDD__item_
    FACH_ParametersListIE_CTCH_SetupRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< FACH-ParametersItem-CTCH-SetupRqstFDD >-----#
    FACH_ParametersItem_CTCH_SetupRqstFDD = SEQ(name='FACH-ParametersItem-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _FACH_ParametersItem_CTCH_SetupRqstFDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _FACH_ParametersItem_CTCH_SetupRqstFDD_transportFormatSet = SEQ(name='transportFormatSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _FACH_ParametersItem_CTCH_SetupRqstFDD_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')))
    _FACH_ParametersItem_CTCH_SetupRqstFDD_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')))
    _FACH_ParametersItem_CTCH_SetupRqstFDD_maxFACH_Power = INT(name='maxFACH-Power', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BroadcastReference')))
    _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IPMulticastIndication')))
    ____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 829), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 908), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_._ext = None
    _FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions._cont = __FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_
    _FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FACH_ParametersItem_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('commonTransportChannelID', _FACH_ParametersItem_CTCH_SetupRqstFDD_commonTransportChannelID),
        ('transportFormatSet', _FACH_ParametersItem_CTCH_SetupRqstFDD_transportFormatSet),
        ('toAWS', _FACH_ParametersItem_CTCH_SetupRqstFDD_toAWS),
        ('toAWE', _FACH_ParametersItem_CTCH_SetupRqstFDD_toAWE),
        ('maxFACH-Power', _FACH_ParametersItem_CTCH_SetupRqstFDD_maxFACH_Power),
        ('iE-Extensions', _FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions),
        ])
    FACH_ParametersItem_CTCH_SetupRqstFDD._ext = []
    
    #-----< FACH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs >-----#
    FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs = CLASS(name='FACH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BroadcastReference')))
    _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IPMulticastIndication')))
    FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 829), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 908), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PCH-Parameters-CTCH-SetupRqstFDD >-----#
    PCH_Parameters_CTCH_SetupRqstFDD = SEQ(name='PCH-Parameters-CTCH-SetupRqstFDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PCH_Parameters_CTCH_SetupRqstFDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PCH_Parameters_CTCH_SetupRqstFDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PCH_Parameters_CTCH_SetupRqstFDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-ParametersItem-CTCH-SetupRqstFDD')))
    __PCH_Parameters_CTCH_SetupRqstFDD_id_tab._val = ASN1Set(rv=[dict([('id', 156), ('criticality', 'reject'), ('Value', ___PCH_Parameters_CTCH_SetupRqstFDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _PCH_Parameters_CTCH_SetupRqstFDD_id._const_tab = __PCH_Parameters_CTCH_SetupRqstFDD_id_tab
    _PCH_Parameters_CTCH_SetupRqstFDD_id._const_tab_at = None
    _PCH_Parameters_CTCH_SetupRqstFDD_id._const_tab_id = 'id'
    _PCH_Parameters_CTCH_SetupRqstFDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PCH_Parameters_CTCH_SetupRqstFDD_criticality._const_tab = __PCH_Parameters_CTCH_SetupRqstFDD_id_tab
    _PCH_Parameters_CTCH_SetupRqstFDD_criticality._const_tab_at = ('..', 'id')
    _PCH_Parameters_CTCH_SetupRqstFDD_criticality._const_tab_id = 'criticality'
    _PCH_Parameters_CTCH_SetupRqstFDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PCH_Parameters_CTCH_SetupRqstFDD_value._const_tab = __PCH_Parameters_CTCH_SetupRqstFDD_id_tab
    _PCH_Parameters_CTCH_SetupRqstFDD_value._const_tab_at = ('..', 'id')
    _PCH_Parameters_CTCH_SetupRqstFDD_value._const_tab_id = 'Value'
    PCH_Parameters_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('id', _PCH_Parameters_CTCH_SetupRqstFDD_id),
        ('criticality', _PCH_Parameters_CTCH_SetupRqstFDD_criticality),
        ('value', _PCH_Parameters_CTCH_SetupRqstFDD_value),
        ])
    PCH_Parameters_CTCH_SetupRqstFDD._ext = None
    
    #-----< PCH-ParametersIE-CTCH-SetupRqstFDD >-----#
    PCH_ParametersIE_CTCH_SetupRqstFDD = CLASS(name='PCH-ParametersIE-CTCH-SetupRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PCH_ParametersIE_CTCH_SetupRqstFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-ParametersItem-CTCH-SetupRqstFDD')))
    PCH_ParametersIE_CTCH_SetupRqstFDD._val = ASN1Set(rv=[dict([('id', 156), ('criticality', 'reject'), ('Value', _PCH_ParametersIE_CTCH_SetupRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PCH-ParametersItem-CTCH-SetupRqstFDD >-----#
    PCH_ParametersItem_CTCH_SetupRqstFDD = SEQ(name='PCH-ParametersItem-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _PCH_ParametersItem_CTCH_SetupRqstFDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _PCH_ParametersItem_CTCH_SetupRqstFDD_transportFormatSet = SEQ(name='transportFormatSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _PCH_ParametersItem_CTCH_SetupRqstFDD_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')))
    _PCH_ParametersItem_CTCH_SetupRqstFDD_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')))
    _PCH_ParametersItem_CTCH_SetupRqstFDD_pCH_Power = INT(name='pCH-Power', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _PCH_ParametersItem_CTCH_SetupRqstFDD_pICH_Parameters = SEQ(name='pICH-Parameters', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-Parameters-CTCH-SetupRqstFDD')))
    _PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_._ext = None
    _PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions._cont = __PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_
    _PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PCH_ParametersItem_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('commonTransportChannelID', _PCH_ParametersItem_CTCH_SetupRqstFDD_commonTransportChannelID),
        ('transportFormatSet', _PCH_ParametersItem_CTCH_SetupRqstFDD_transportFormatSet),
        ('toAWS', _PCH_ParametersItem_CTCH_SetupRqstFDD_toAWS),
        ('toAWE', _PCH_ParametersItem_CTCH_SetupRqstFDD_toAWE),
        ('pCH-Power', _PCH_ParametersItem_CTCH_SetupRqstFDD_pCH_Power),
        ('pICH-Parameters', _PCH_ParametersItem_CTCH_SetupRqstFDD_pICH_Parameters),
        ('iE-Extensions', _PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions),
        ])
    PCH_ParametersItem_CTCH_SetupRqstFDD._ext = []
    
    #-----< PCH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs >-----#
    PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs = CLASS(name='PCH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PICH-Parameters-CTCH-SetupRqstFDD >-----#
    PICH_Parameters_CTCH_SetupRqstFDD = SEQ(name='PICH-Parameters-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _PICH_Parameters_CTCH_SetupRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PICH_Parameters_CTCH_SetupRqstFDD_fdd_dl_ChannelisationCodeNumber = INT(name='fdd-dl-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _PICH_Parameters_CTCH_SetupRqstFDD_pICH_Power = INT(name='pICH-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')))
    _PICH_Parameters_CTCH_SetupRqstFDD_pICH_Mode = ENUM(name='pICH-Mode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Mode')))
    _PICH_Parameters_CTCH_SetupRqstFDD_sTTD_Indicator = ENUM(name='sTTD-Indicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'STTD-Indicator')))
    _PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_._ext = None
    _PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions._cont = __PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_
    _PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PICH_Parameters_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PICH_Parameters_CTCH_SetupRqstFDD_commonPhysicalChannelID),
        ('fdd-dl-ChannelisationCodeNumber', _PICH_Parameters_CTCH_SetupRqstFDD_fdd_dl_ChannelisationCodeNumber),
        ('pICH-Power', _PICH_Parameters_CTCH_SetupRqstFDD_pICH_Power),
        ('pICH-Mode', _PICH_Parameters_CTCH_SetupRqstFDD_pICH_Mode),
        ('sTTD-Indicator', _PICH_Parameters_CTCH_SetupRqstFDD_sTTD_Indicator),
        ('iE-Extensions', _PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions),
        ])
    PICH_Parameters_CTCH_SetupRqstFDD._ext = []
    
    #-----< PICH-Parameters-CTCH-SetupRqstFDD-ExtIEs >-----#
    PICH_Parameters_CTCH_SetupRqstFDD_ExtIEs = CLASS(name='PICH-Parameters-CTCH-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PICH_Parameters_CTCH_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MICH-Parameters-CTCH-SetupRqstFDD >-----#
    MICH_Parameters_CTCH_SetupRqstFDD = SEQ(name='MICH-Parameters-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _MICH_Parameters_CTCH_SetupRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _MICH_Parameters_CTCH_SetupRqstFDD_fdd_dl_ChannelisationCodeNumber = INT(name='fdd-dl-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _MICH_Parameters_CTCH_SetupRqstFDD_mICH_Power = INT(name='mICH-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')))
    _MICH_Parameters_CTCH_SetupRqstFDD_mICH_Mode = ENUM(name='mICH-Mode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MICH-Mode')))
    _MICH_Parameters_CTCH_SetupRqstFDD_sTTD_Indicator = ENUM(name='sTTD-Indicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'STTD-Indicator')))
    _MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_._ext = None
    _MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions._cont = __MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_
    _MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MICH_Parameters_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _MICH_Parameters_CTCH_SetupRqstFDD_commonPhysicalChannelID),
        ('fdd-dl-ChannelisationCodeNumber', _MICH_Parameters_CTCH_SetupRqstFDD_fdd_dl_ChannelisationCodeNumber),
        ('mICH-Power', _MICH_Parameters_CTCH_SetupRqstFDD_mICH_Power),
        ('mICH-Mode', _MICH_Parameters_CTCH_SetupRqstFDD_mICH_Mode),
        ('sTTD-Indicator', _MICH_Parameters_CTCH_SetupRqstFDD_sTTD_Indicator),
        ('iE-Extensions', _MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions),
        ])
    MICH_Parameters_CTCH_SetupRqstFDD._ext = []
    
    #-----< MICH-Parameters-CTCH-SetupRqstFDD-ExtIEs >-----#
    MICH_Parameters_CTCH_SetupRqstFDD_ExtIEs = CLASS(name='MICH-Parameters-CTCH-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MICH_Parameters_CTCH_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRACH-CTCH-SetupRqstFDD >-----#
    PRACH_CTCH_SetupRqstFDD = SEQ(name='PRACH-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _PRACH_CTCH_SetupRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PRACH_CTCH_SetupRqstFDD_scramblingCodeNumber = INT(name='scramblingCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ScramblingCodeNumber')))
    _PRACH_CTCH_SetupRqstFDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _PRACH_CTCH_SetupRqstFDD_preambleSignatures = BIT_STR(name='preambleSignatures', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PreambleSignatures')))
    _PRACH_CTCH_SetupRqstFDD_allowedSlotFormatInformation = SEQ_OF(name='allowedSlotFormatInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'AllowedSlotFormatInformationList-CTCH-SetupRqstFDD')))
    _PRACH_CTCH_SetupRqstFDD_rACH_SubChannelNumbers = BIT_STR(name='rACH-SubChannelNumbers', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RACH-SubChannelNumbers')))
    _PRACH_CTCH_SetupRqstFDD_ul_punctureLimit = INT(name='ul-punctureLimit', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')))
    _PRACH_CTCH_SetupRqstFDD_preambleThreshold = INT(name='preambleThreshold', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PreambleThreshold')))
    _PRACH_CTCH_SetupRqstFDD_rACH_Parameters = SEQ(name='rACH-Parameters', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-Parameters-CTCH-SetupRqstFDD')))
    _PRACH_CTCH_SetupRqstFDD_aICH_Parameters = SEQ(name='aICH-Parameters', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'AICH-Parameters-CTCH-SetupRqstFDD')))
    _PRACH_CTCH_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRACH_CTCH_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRACH_CTCH_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PRACH_CTCH_SetupRqstFDD_iE_Extensions__item_._ext = None
    _PRACH_CTCH_SetupRqstFDD_iE_Extensions._cont = __PRACH_CTCH_SetupRqstFDD_iE_Extensions__item_
    _PRACH_CTCH_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRACH_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PRACH_CTCH_SetupRqstFDD_commonPhysicalChannelID),
        ('scramblingCodeNumber', _PRACH_CTCH_SetupRqstFDD_scramblingCodeNumber),
        ('tFCS', _PRACH_CTCH_SetupRqstFDD_tFCS),
        ('preambleSignatures', _PRACH_CTCH_SetupRqstFDD_preambleSignatures),
        ('allowedSlotFormatInformation', _PRACH_CTCH_SetupRqstFDD_allowedSlotFormatInformation),
        ('rACH-SubChannelNumbers', _PRACH_CTCH_SetupRqstFDD_rACH_SubChannelNumbers),
        ('ul-punctureLimit', _PRACH_CTCH_SetupRqstFDD_ul_punctureLimit),
        ('preambleThreshold', _PRACH_CTCH_SetupRqstFDD_preambleThreshold),
        ('rACH-Parameters', _PRACH_CTCH_SetupRqstFDD_rACH_Parameters),
        ('aICH-Parameters', _PRACH_CTCH_SetupRqstFDD_aICH_Parameters),
        ('iE-Extensions', _PRACH_CTCH_SetupRqstFDD_iE_Extensions),
        ])
    PRACH_CTCH_SetupRqstFDD._ext = []
    
    #-----< PRACHItem-CTCH-SetupRqstFDD-ExtIEs >-----#
    PRACHItem_CTCH_SetupRqstFDD_ExtIEs = CLASS(name='PRACHItem-CTCH-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PRACHItem_CTCH_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AllowedSlotFormatInformationList-CTCH-SetupRqstFDD >-----#
    AllowedSlotFormatInformationList_CTCH_SetupRqstFDD = SEQ_OF(name='AllowedSlotFormatInformationList-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _AllowedSlotFormatInformationList_CTCH_SetupRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AllowedSlotFormatInformationItem-CTCH-SetupRqstFDD')))
    AllowedSlotFormatInformationList_CTCH_SetupRqstFDD._cont = _AllowedSlotFormatInformationList_CTCH_SetupRqstFDD__item_
    AllowedSlotFormatInformationList_CTCH_SetupRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AllowedSlotFormatInformationItem-CTCH-SetupRqstFDD >-----#
    AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD = SEQ(name='AllowedSlotFormatInformationItem-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_rACHSlotFormat = ENUM(name='rACHSlotFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RACH-SlotFormat')))
    _AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item_._ext = None
    _AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions._cont = __AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item_
    _AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('rACHSlotFormat', _AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_rACHSlotFormat),
        ('iE-Extensions', _AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions),
        ])
    AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD._ext = []
    
    #-----< AllowedSlotFormatInformationItem-CTCH-SetupRqstFDD-ExtIEs >-----#
    AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_ExtIEs = CLASS(name='AllowedSlotFormatInformationItem-CTCH-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RACH-Parameters-CTCH-SetupRqstFDD >-----#
    RACH_Parameters_CTCH_SetupRqstFDD = SEQ(name='RACH-Parameters-CTCH-SetupRqstFDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _RACH_Parameters_CTCH_SetupRqstFDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __RACH_Parameters_CTCH_SetupRqstFDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___RACH_Parameters_CTCH_SetupRqstFDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-ParametersItem-CTCH-SetupRqstFDD')))
    __RACH_Parameters_CTCH_SetupRqstFDD_id_tab._val = ASN1Set(rv=[dict([('id', 196), ('criticality', 'reject'), ('Value', ___RACH_Parameters_CTCH_SetupRqstFDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _RACH_Parameters_CTCH_SetupRqstFDD_id._const_tab = __RACH_Parameters_CTCH_SetupRqstFDD_id_tab
    _RACH_Parameters_CTCH_SetupRqstFDD_id._const_tab_at = None
    _RACH_Parameters_CTCH_SetupRqstFDD_id._const_tab_id = 'id'
    _RACH_Parameters_CTCH_SetupRqstFDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _RACH_Parameters_CTCH_SetupRqstFDD_criticality._const_tab = __RACH_Parameters_CTCH_SetupRqstFDD_id_tab
    _RACH_Parameters_CTCH_SetupRqstFDD_criticality._const_tab_at = ('..', 'id')
    _RACH_Parameters_CTCH_SetupRqstFDD_criticality._const_tab_id = 'criticality'
    _RACH_Parameters_CTCH_SetupRqstFDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _RACH_Parameters_CTCH_SetupRqstFDD_value._const_tab = __RACH_Parameters_CTCH_SetupRqstFDD_id_tab
    _RACH_Parameters_CTCH_SetupRqstFDD_value._const_tab_at = ('..', 'id')
    _RACH_Parameters_CTCH_SetupRqstFDD_value._const_tab_id = 'Value'
    RACH_Parameters_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('id', _RACH_Parameters_CTCH_SetupRqstFDD_id),
        ('criticality', _RACH_Parameters_CTCH_SetupRqstFDD_criticality),
        ('value', _RACH_Parameters_CTCH_SetupRqstFDD_value),
        ])
    RACH_Parameters_CTCH_SetupRqstFDD._ext = None
    
    #-----< RACH-ParametersIE-CTCH-SetupRqstFDD >-----#
    RACH_ParametersIE_CTCH_SetupRqstFDD = CLASS(name='RACH-ParametersIE-CTCH-SetupRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RACH_ParametersIE_CTCH_SetupRqstFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-ParametersItem-CTCH-SetupRqstFDD')))
    RACH_ParametersIE_CTCH_SetupRqstFDD._val = ASN1Set(rv=[dict([('id', 196), ('criticality', 'reject'), ('Value', _RACH_ParametersIE_CTCH_SetupRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RACH-ParametersItem-CTCH-SetupRqstFDD >-----#
    RACH_ParametersItem_CTCH_SetupRqstFDD = SEQ(name='RACH-ParametersItem-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _RACH_ParametersItem_CTCH_SetupRqstFDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _RACH_ParametersItem_CTCH_SetupRqstFDD_transportFormatSet = SEQ(name='transportFormatSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_._ext = None
    _RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions._cont = __RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_
    _RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RACH_ParametersItem_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('commonTransportChannelID', _RACH_ParametersItem_CTCH_SetupRqstFDD_commonTransportChannelID),
        ('transportFormatSet', _RACH_ParametersItem_CTCH_SetupRqstFDD_transportFormatSet),
        ('iE-Extensions', _RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions),
        ])
    RACH_ParametersItem_CTCH_SetupRqstFDD._ext = []
    
    #-----< RACH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs >-----#
    RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs = CLASS(name='RACH-ParametersItem-CTCH-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AICH-Parameters-CTCH-SetupRqstFDD >-----#
    AICH_Parameters_CTCH_SetupRqstFDD = SEQ(name='AICH-Parameters-CTCH-SetupRqstFDD', mode=MODE_TYPE)
    _AICH_Parameters_CTCH_SetupRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _AICH_Parameters_CTCH_SetupRqstFDD_aICH_TransmissionTiming = ENUM(name='aICH-TransmissionTiming', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AICH-TransmissionTiming')))
    _AICH_Parameters_CTCH_SetupRqstFDD_fdd_dl_ChannelisationCodeNumber = INT(name='fdd-dl-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _AICH_Parameters_CTCH_SetupRqstFDD_aICH_Power = INT(name='aICH-Power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AICH-Power')))
    _AICH_Parameters_CTCH_SetupRqstFDD_sTTD_Indicator = ENUM(name='sTTD-Indicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'STTD-Indicator')))
    _AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_._ext = None
    _AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions._cont = __AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_
    _AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AICH_Parameters_CTCH_SetupRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _AICH_Parameters_CTCH_SetupRqstFDD_commonPhysicalChannelID),
        ('aICH-TransmissionTiming', _AICH_Parameters_CTCH_SetupRqstFDD_aICH_TransmissionTiming),
        ('fdd-dl-ChannelisationCodeNumber', _AICH_Parameters_CTCH_SetupRqstFDD_fdd_dl_ChannelisationCodeNumber),
        ('aICH-Power', _AICH_Parameters_CTCH_SetupRqstFDD_aICH_Power),
        ('sTTD-Indicator', _AICH_Parameters_CTCH_SetupRqstFDD_sTTD_Indicator),
        ('iE-Extensions', _AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions),
        ])
    AICH_Parameters_CTCH_SetupRqstFDD._ext = []
    
    #-----< AICH-Parameters-CTCH-SetupRqstFDD-ExtIEs >-----#
    AICH_Parameters_CTCH_SetupRqstFDD_ExtIEs = CLASS(name='AICH-Parameters-CTCH-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    AICH_Parameters_CTCH_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelSetupRequestTDD >-----#
    CommonTransportChannelSetupRequestTDD = SEQ(name='CommonTransportChannelSetupRequestTDD', mode=MODE_TYPE)
    _CommonTransportChannelSetupRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelSetupRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonPhysicalChannelType-CTCH-SetupRqstTDD')))
    ____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 37), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__id._const_tab = ____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__value._const_tab = ____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonTransportChannelSetupRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__id),
        ('criticality', ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__criticality),
        ('value', ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__value),
        ])
    __CommonTransportChannelSetupRequestTDD_protocolIEs__item_._ext = None
    _CommonTransportChannelSetupRequestTDD_protocolIEs._cont = __CommonTransportChannelSetupRequestTDD_protocolIEs__item_
    _CommonTransportChannelSetupRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelSetupRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelSetupRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__id._const_tab = ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__criticality_tab
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__extensionValue_tab
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonTransportChannelSetupRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__id),
        ('criticality', ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelSetupRequestTDD_protocolExtensions__item_._ext = None
    _CommonTransportChannelSetupRequestTDD_protocolExtensions._cont = __CommonTransportChannelSetupRequestTDD_protocolExtensions__item_
    _CommonTransportChannelSetupRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelSetupRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _CommonTransportChannelSetupRequestTDD_protocolIEs),
        ('protocolExtensions', _CommonTransportChannelSetupRequestTDD_protocolExtensions),
        ])
    CommonTransportChannelSetupRequestTDD._ext = []
    
    #-----< CommonTransportChannelSetupRequestTDD-IEs >-----#
    CommonTransportChannelSetupRequestTDD_IEs = CLASS(name='CommonTransportChannelSetupRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonTransportChannelSetupRequestTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CommonTransportChannelSetupRequestTDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _CommonTransportChannelSetupRequestTDD_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonPhysicalChannelType-CTCH-SetupRqstTDD')))
    CommonTransportChannelSetupRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _CommonTransportChannelSetupRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _CommonTransportChannelSetupRequestTDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 37), ('criticality', 'ignore'), ('Value', _CommonTransportChannelSetupRequestTDD_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelSetupRequestTDD-Extensions >-----#
    CommonTransportChannelSetupRequestTDD_Extensions = CLASS(name='CommonTransportChannelSetupRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonTransportChannelSetupRequestTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonPhysicalChannelType-CTCH-SetupRqstTDD >-----#
    CommonPhysicalChannelType_CTCH_SetupRqstTDD = CHOICE(name='CommonPhysicalChannelType-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _CommonPhysicalChannelType_CTCH_SetupRqstTDD_secondary_CCPCH_parameters = SEQ(name='secondary-CCPCH-parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-CTCH-SetupRqstTDD')))
    _CommonPhysicalChannelType_CTCH_SetupRqstTDD_pRACH_parameters = SEQ(name='pRACH-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-CTCH-SetupRqstTDD')))
    _CommonPhysicalChannelType_CTCH_SetupRqstTDD_extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD = SEQ(name='extension-CommonPhysicalChannelType-CTCH-SetupRqstTDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Extension-CommonPhysicalChannelType-CTCH-SetupRqstTDD')))
    CommonPhysicalChannelType_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('secondary-CCPCH-parameters', _CommonPhysicalChannelType_CTCH_SetupRqstTDD_secondary_CCPCH_parameters),
        ('pRACH-parameters', _CommonPhysicalChannelType_CTCH_SetupRqstTDD_pRACH_parameters),
        ('extension-CommonPhysicalChannelType-CTCH-SetupRqstTDD', _CommonPhysicalChannelType_CTCH_SetupRqstTDD_extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD),
        ])
    CommonPhysicalChannelType_CTCH_SetupRqstTDD._ext = ['extension-CommonPhysicalChannelType-CTCH-SetupRqstTDD']
    
    #-----< Extension-CommonPhysicalChannelType-CTCH-SetupRqstTDD >-----#
    Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD = SEQ(name='Extension-CommonPhysicalChannelType-CTCH-SetupRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PLCCH-parameters')))
    ___Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-parameters')))
    ___Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-768-parameters')))
    __Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 981), ('criticality', 'ignore'), ('Value', ___Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 982), ('criticality', 'ignore'), ('Value', ___Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 983), ('criticality', 'ignore'), ('Value', ___Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id._const_tab = __Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id._const_tab_at = None
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id._const_tab_id = 'id'
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_criticality._const_tab = __Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_criticality._const_tab_at = ('..', 'id')
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_criticality._const_tab_id = 'criticality'
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_value._const_tab = __Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_value._const_tab_at = ('..', 'id')
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_value._const_tab_id = 'Value'
    Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('id', _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id),
        ('criticality', _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_criticality),
        ('value', _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_value),
        ])
    Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD._ext = None
    
    #-----< Extension-CommonPhysicalChannelType-CTCH-SetupRqstTDDIE >-----#
    Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE = CLASS(name='Extension-CommonPhysicalChannelType-CTCH-SetupRqstTDDIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PLCCH-parameters')))
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-parameters')))
    _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-768-parameters')))
    Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE._val = ASN1Set(rv=[dict([('id', 981), ('criticality', 'ignore'), ('Value', _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 982), ('criticality', 'ignore'), ('Value', _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE_val_Value_1), ('presence', 'mandatory')]), dict([('id', 983), ('criticality', 'ignore'), ('Value', _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-CTCH-SetupRqstTDD >-----#
    Secondary_CCPCH_CTCH_SetupRqstTDD = SEQ(name='Secondary-CCPCH-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_CTCH_SetupRqstTDD_sCCPCH_CCTrCH_ID = INT(name='sCCPCH-CCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _Secondary_CCPCH_CTCH_SetupRqstTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _Secondary_CCPCH_CTCH_SetupRqstTDD_tFCI_Coding = ENUM(name='tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Coding')))
    _Secondary_CCPCH_CTCH_SetupRqstTDD_punctureLimit = INT(name='punctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')))
    _Secondary_CCPCH_CTCH_SetupRqstTDD_secondaryCCPCH_parameterList = SEQ(name='secondaryCCPCH-parameterList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-parameterList-CTCH-SetupRqstTDD')))
    _Secondary_CCPCH_CTCH_SetupRqstTDD_fACH_ParametersList = SEQ(name='fACH-ParametersList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersList-CTCH-SetupRqstTDD')), opt=True)
    _Secondary_CCPCH_CTCH_SetupRqstTDD_pCH_Parameters = SEQ(name='pCH-Parameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-Parameters-CTCH-SetupRqstTDD')), opt=True)
    _Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-Parameters-CTCH-SetupRqstTDD')))
    _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-parameterExtendedList-CTCH-SetupRqstTDD')))
    _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-LCR-parameterExtendedList-CTCH-SetupRqstTDD')))
    _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-768-parameterList-CTCH-SetupRqstTDD')))
    _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ModulationMBSFN')))
    _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-LCR-CTCH-SetupRqstTDD')))
    _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 627), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 643), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 634), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 636), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 718), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 843), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 912), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions._cont = __Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item_
    _Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('sCCPCH-CCTrCH-ID', _Secondary_CCPCH_CTCH_SetupRqstTDD_sCCPCH_CCTrCH_ID),
        ('tFCS', _Secondary_CCPCH_CTCH_SetupRqstTDD_tFCS),
        ('tFCI-Coding', _Secondary_CCPCH_CTCH_SetupRqstTDD_tFCI_Coding),
        ('punctureLimit', _Secondary_CCPCH_CTCH_SetupRqstTDD_punctureLimit),
        ('secondaryCCPCH-parameterList', _Secondary_CCPCH_CTCH_SetupRqstTDD_secondaryCCPCH_parameterList),
        ('fACH-ParametersList', _Secondary_CCPCH_CTCH_SetupRqstTDD_fACH_ParametersList),
        ('pCH-Parameters', _Secondary_CCPCH_CTCH_SetupRqstTDD_pCH_Parameters),
        ('iE-Extensions', _Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    Secondary_CCPCH_CTCH_SetupRqstTDD._ext = []
    
    #-----< Secondary-CCPCHItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='Secondary-CCPCHItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-Parameters-CTCH-SetupRqstTDD')))
    _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-parameterExtendedList-CTCH-SetupRqstTDD')))
    _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-LCR-parameterExtendedList-CTCH-SetupRqstTDD')))
    _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-768-parameterList-CTCH-SetupRqstTDD')))
    _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ModulationMBSFN')))
    _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-LCR-CTCH-SetupRqstTDD')))
    _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 627), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 643), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 634), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 636), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 718), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 843), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 912), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-parameterList-CTCH-SetupRqstTDD >-----#
    Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD = SEQ(name='Secondary-CCPCH-parameterList-CTCH-SetupRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-parameterListIE-CTCH-SetupRqstTDD')))
    ___Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-LCR-parameterList-CTCH-SetupRqstTDD')))
    __Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 258), ('criticality', 'reject'), ('Value', ___Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 465), ('criticality', 'reject'), ('Value', ___Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id._const_tab = __Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id._const_tab_at = None
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id._const_tab_id = 'id'
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_criticality._const_tab = __Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_criticality._const_tab_at = ('..', 'id')
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_criticality._const_tab_id = 'criticality'
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_value._const_tab = __Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_value._const_tab_at = ('..', 'id')
    _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_value._const_tab_id = 'Value'
    Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('id', _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id),
        ('criticality', _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_criticality),
        ('value', _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_value),
        ])
    Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD._ext = None
    
    #-----< Secondary-CCPCH-parameterListIEs-CTCH-SetupRqstTDD >-----#
    Secondary_CCPCH_parameterListIEs_CTCH_SetupRqstTDD = CLASS(name='Secondary-CCPCH-parameterListIEs-CTCH-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Secondary_CCPCH_parameterListIEs_CTCH_SetupRqstTDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-parameterListIE-CTCH-SetupRqstTDD')))
    _Secondary_CCPCH_parameterListIEs_CTCH_SetupRqstTDD_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-LCR-parameterList-CTCH-SetupRqstTDD')))
    Secondary_CCPCH_parameterListIEs_CTCH_SetupRqstTDD._val = ASN1Set(rv=[dict([('id', 258), ('criticality', 'reject'), ('Value', _Secondary_CCPCH_parameterListIEs_CTCH_SetupRqstTDD_val_Value_0), ('presence', 'optional')]), dict([('id', 465), ('criticality', 'reject'), ('Value', _Secondary_CCPCH_parameterListIEs_CTCH_SetupRqstTDD_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< Secondary-CCPCH-parameterListIE-CTCH-SetupRqstTDD >-----#
    Secondary_CCPCH_parameterListIE_CTCH_SetupRqstTDD = SEQ_OF(name='Secondary-CCPCH-parameterListIE-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_parameterListIE_CTCH_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-parameterItem-CTCH-SetupRqstTDD')))
    Secondary_CCPCH_parameterListIE_CTCH_SetupRqstTDD._cont = _Secondary_CCPCH_parameterListIE_CTCH_SetupRqstTDD__item_
    Secondary_CCPCH_parameterListIE_CTCH_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Secondary-CCPCH-parameterItem-CTCH-SetupRqstTDD >-----#
    Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD = SEQ(name='Secondary-CCPCH-parameterItem-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_timeslot = INT(name='timeslot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_midambleShiftandBurstType = CHOICE(name='midambleShiftandBurstType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_Power = INT(name='s-CCPCH-Power', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    ____Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 793), ('criticality', 'notify'), ('Extension', _____Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions._cont = __Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_commonPhysicalChannelID),
        ('tdd-ChannelisationCode', _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode),
        ('timeslot', _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_timeslot),
        ('midambleShiftandBurstType', _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_midambleShiftandBurstType),
        ('tdd-PhysicalChannelOffset', _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset),
        ('repetitionPeriod', _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_repetitionLength),
        ('s-CCPCH-Power', _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_Power),
        ('iE-Extensions', _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD._ext = []
    
    #-----< Secondary-CCPCH-parameterItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='Secondary-CCPCH-parameterItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 793), ('criticality', 'notify'), ('Extension', _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-LCR-parameterList-CTCH-SetupRqstTDD >-----#
    Secondary_CCPCH_LCR_parameterList_CTCH_SetupRqstTDD = SEQ_OF(name='Secondary-CCPCH-LCR-parameterList-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_LCR_parameterList_CTCH_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-LCR-parameterItem-CTCH-SetupRqstTDD')))
    Secondary_CCPCH_LCR_parameterList_CTCH_SetupRqstTDD._cont = _Secondary_CCPCH_LCR_parameterList_CTCH_SetupRqstTDD__item_
    Secondary_CCPCH_LCR_parameterList_CTCH_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Secondary-CCPCH-LCR-parameterItem-CTCH-SetupRqstTDD >-----#
    Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD = SEQ(name='Secondary-CCPCH-LCR-parameterItem-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_timeslotLCR = INT(name='timeslotLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_Power = INT(name='s-CCPCH-Power', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_TimeSlotFormat_LCR = CHOICE(name='s-CCPCH-TimeSlotFormat-LCR', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeslotLCR-Extension')))
    ____Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 942), ('criticality', 'ignore'), ('Extension', _____Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions._cont = __Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_commonPhysicalChannelID),
        ('tdd-ChannelisationCodeLCR', _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR),
        ('timeslotLCR', _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_timeslotLCR),
        ('midambleShiftLCR', _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_midambleShiftLCR),
        ('tdd-PhysicalChannelOffset', _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset),
        ('repetitionPeriod', _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_repetitionLength),
        ('s-CCPCH-Power', _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_Power),
        ('s-CCPCH-TimeSlotFormat-LCR', _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_TimeSlotFormat_LCR),
        ('iE-Extensions', _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD._ext = []
    
    #-----< Secondary-CCPCH-LCR-parameterItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='Secondary-CCPCH-LCR-parameterItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeslotLCR-Extension')))
    Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 942), ('criticality', 'ignore'), ('Extension', _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-768-parameterList-CTCH-SetupRqstTDD >-----#
    Secondary_CCPCH_768_parameterList_CTCH_SetupRqstTDD = SEQ_OF(name='Secondary-CCPCH-768-parameterList-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_768_parameterList_CTCH_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-768-parameterItem-CTCH-SetupRqstTDD')))
    Secondary_CCPCH_768_parameterList_CTCH_SetupRqstTDD._cont = _Secondary_CCPCH_768_parameterList_CTCH_SetupRqstTDD__item_
    Secondary_CCPCH_768_parameterList_CTCH_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=480)], ev=None, er=[])
    
    #-----< Secondary-CCPCH-768-parameterItem-CTCH-SetupRqstTDD >-----#
    Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD = SEQ(name='Secondary-CCPCH-768-parameterItem-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_timeslot = INT(name='timeslot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_tFCI_Presence768 = ENUM(name='tFCI-Presence768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_midambleShiftandBurstType768 = CHOICE(name='midambleShiftandBurstType768', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_Power = INT(name='s-CCPCH-Power', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions._cont = __Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_
    _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_commonPhysicalChannelID768),
        ('tdd-ChannelisationCode768', _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode768),
        ('timeslot', _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_timeslot),
        ('tFCI-Presence768', _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_tFCI_Presence768),
        ('midambleShiftandBurstType768', _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_midambleShiftandBurstType768),
        ('tdd-PhysicalChannelOffset', _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset),
        ('repetitionPeriod', _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_repetitionLength),
        ('s-CCPCH-Power', _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_Power),
        ('iE-Extensions', _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD._ext = []
    
    #-----< Secondary-CCPCH-parameterItem-768-CTCH-SetupRqstTDD-ExtIEs >-----#
    Secondary_CCPCH_parameterItem_768_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='Secondary-CCPCH-parameterItem-768-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Secondary_CCPCH_parameterItem_768_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FACH-ParametersList-CTCH-SetupRqstTDD >-----#
    FACH_ParametersList_CTCH_SetupRqstTDD = SEQ(name='FACH-ParametersList-CTCH-SetupRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _FACH_ParametersList_CTCH_SetupRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __FACH_ParametersList_CTCH_SetupRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___FACH_ParametersList_CTCH_SetupRqstTDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersListIE-CTCH-SetupRqstTDD')))
    __FACH_ParametersList_CTCH_SetupRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 122), ('criticality', 'reject'), ('Value', ___FACH_ParametersList_CTCH_SetupRqstTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _FACH_ParametersList_CTCH_SetupRqstTDD_id._const_tab = __FACH_ParametersList_CTCH_SetupRqstTDD_id_tab
    _FACH_ParametersList_CTCH_SetupRqstTDD_id._const_tab_at = None
    _FACH_ParametersList_CTCH_SetupRqstTDD_id._const_tab_id = 'id'
    _FACH_ParametersList_CTCH_SetupRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _FACH_ParametersList_CTCH_SetupRqstTDD_criticality._const_tab = __FACH_ParametersList_CTCH_SetupRqstTDD_id_tab
    _FACH_ParametersList_CTCH_SetupRqstTDD_criticality._const_tab_at = ('..', 'id')
    _FACH_ParametersList_CTCH_SetupRqstTDD_criticality._const_tab_id = 'criticality'
    _FACH_ParametersList_CTCH_SetupRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _FACH_ParametersList_CTCH_SetupRqstTDD_value._const_tab = __FACH_ParametersList_CTCH_SetupRqstTDD_id_tab
    _FACH_ParametersList_CTCH_SetupRqstTDD_value._const_tab_at = ('..', 'id')
    _FACH_ParametersList_CTCH_SetupRqstTDD_value._const_tab_id = 'Value'
    FACH_ParametersList_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('id', _FACH_ParametersList_CTCH_SetupRqstTDD_id),
        ('criticality', _FACH_ParametersList_CTCH_SetupRqstTDD_criticality),
        ('value', _FACH_ParametersList_CTCH_SetupRqstTDD_value),
        ])
    FACH_ParametersList_CTCH_SetupRqstTDD._ext = None
    
    #-----< FACH-ParametersListIEs-CTCH-SetupRqstTDD >-----#
    FACH_ParametersListIEs_CTCH_SetupRqstTDD = CLASS(name='FACH-ParametersListIEs-CTCH-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _FACH_ParametersListIEs_CTCH_SetupRqstTDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersListIE-CTCH-SetupRqstTDD')))
    FACH_ParametersListIEs_CTCH_SetupRqstTDD._val = ASN1Set(rv=[dict([('id', 122), ('criticality', 'reject'), ('Value', _FACH_ParametersListIEs_CTCH_SetupRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< FACH-ParametersListIE-CTCH-SetupRqstTDD >-----#
    FACH_ParametersListIE_CTCH_SetupRqstTDD = SEQ_OF(name='FACH-ParametersListIE-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _FACH_ParametersListIE_CTCH_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersItem-CTCH-SetupRqstTDD')))
    FACH_ParametersListIE_CTCH_SetupRqstTDD._cont = _FACH_ParametersListIE_CTCH_SetupRqstTDD__item_
    FACH_ParametersListIE_CTCH_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< FACH-ParametersItem-CTCH-SetupRqstTDD >-----#
    FACH_ParametersItem_CTCH_SetupRqstTDD = SEQ(name='FACH-ParametersItem-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _FACH_ParametersItem_CTCH_SetupRqstTDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _FACH_ParametersItem_CTCH_SetupRqstTDD_fACH_CCTrCH_ID = INT(name='fACH-CCTrCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _FACH_ParametersItem_CTCH_SetupRqstTDD_dl_TransportFormatSet = SEQ(name='dl-TransportFormatSet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _FACH_ParametersItem_CTCH_SetupRqstTDD_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')))
    _FACH_ParametersItem_CTCH_SetupRqstTDD_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')))
    _FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BroadcastReference')))
    _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IPMulticastIndication')))
    ____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'reject'), ('Extension', _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 829), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 908), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._cont = __FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_
    _FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FACH_ParametersItem_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonTransportChannelID', _FACH_ParametersItem_CTCH_SetupRqstTDD_commonTransportChannelID),
        ('fACH-CCTrCH-ID', _FACH_ParametersItem_CTCH_SetupRqstTDD_fACH_CCTrCH_ID),
        ('dl-TransportFormatSet', _FACH_ParametersItem_CTCH_SetupRqstTDD_dl_TransportFormatSet),
        ('toAWS', _FACH_ParametersItem_CTCH_SetupRqstTDD_toAWS),
        ('toAWE', _FACH_ParametersItem_CTCH_SetupRqstTDD_toAWE),
        ('iE-Extensions', _FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    FACH_ParametersItem_CTCH_SetupRqstTDD._ext = []
    
    #-----< FACH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='FACH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BroadcastReference')))
    _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IPMulticastIndication')))
    FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'reject'), ('Extension', _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 829), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 908), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PCH-Parameters-CTCH-SetupRqstTDD >-----#
    PCH_Parameters_CTCH_SetupRqstTDD = SEQ(name='PCH-Parameters-CTCH-SetupRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PCH_Parameters_CTCH_SetupRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PCH_Parameters_CTCH_SetupRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PCH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-ParametersItem-CTCH-SetupRqstTDD')))
    __PCH_Parameters_CTCH_SetupRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 157), ('criticality', 'reject'), ('Value', ___PCH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _PCH_Parameters_CTCH_SetupRqstTDD_id._const_tab = __PCH_Parameters_CTCH_SetupRqstTDD_id_tab
    _PCH_Parameters_CTCH_SetupRqstTDD_id._const_tab_at = None
    _PCH_Parameters_CTCH_SetupRqstTDD_id._const_tab_id = 'id'
    _PCH_Parameters_CTCH_SetupRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PCH_Parameters_CTCH_SetupRqstTDD_criticality._const_tab = __PCH_Parameters_CTCH_SetupRqstTDD_id_tab
    _PCH_Parameters_CTCH_SetupRqstTDD_criticality._const_tab_at = ('..', 'id')
    _PCH_Parameters_CTCH_SetupRqstTDD_criticality._const_tab_id = 'criticality'
    _PCH_Parameters_CTCH_SetupRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PCH_Parameters_CTCH_SetupRqstTDD_value._const_tab = __PCH_Parameters_CTCH_SetupRqstTDD_id_tab
    _PCH_Parameters_CTCH_SetupRqstTDD_value._const_tab_at = ('..', 'id')
    _PCH_Parameters_CTCH_SetupRqstTDD_value._const_tab_id = 'Value'
    PCH_Parameters_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('id', _PCH_Parameters_CTCH_SetupRqstTDD_id),
        ('criticality', _PCH_Parameters_CTCH_SetupRqstTDD_criticality),
        ('value', _PCH_Parameters_CTCH_SetupRqstTDD_value),
        ])
    PCH_Parameters_CTCH_SetupRqstTDD._ext = None
    
    #-----< PCH-ParametersIE-CTCH-SetupRqstTDD >-----#
    PCH_ParametersIE_CTCH_SetupRqstTDD = CLASS(name='PCH-ParametersIE-CTCH-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PCH_ParametersIE_CTCH_SetupRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-ParametersItem-CTCH-SetupRqstTDD')))
    PCH_ParametersIE_CTCH_SetupRqstTDD._val = ASN1Set(rv=[dict([('id', 157), ('criticality', 'reject'), ('Value', _PCH_ParametersIE_CTCH_SetupRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PCH-ParametersItem-CTCH-SetupRqstTDD >-----#
    PCH_ParametersItem_CTCH_SetupRqstTDD = SEQ(name='PCH-ParametersItem-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _PCH_ParametersItem_CTCH_SetupRqstTDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _PCH_ParametersItem_CTCH_SetupRqstTDD_pCH_CCTrCH_ID = INT(name='pCH-CCTrCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _PCH_ParametersItem_CTCH_SetupRqstTDD_dl_TransportFormatSet = SEQ(name='dl-TransportFormatSet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _PCH_ParametersItem_CTCH_SetupRqstTDD_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')))
    _PCH_ParametersItem_CTCH_SetupRqstTDD_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')))
    _PCH_ParametersItem_CTCH_SetupRqstTDD_pICH_Parameters = SEQ(name='pICH-Parameters', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-Parameters-CTCH-SetupRqstTDD')))
    _PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-768-ParametersItem-CTCH-SetupRqstTDD')))
    _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 457), ('criticality', 'reject'), ('Extension', _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 719), ('criticality', 'reject'), ('Extension', _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._cont = __PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_
    _PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PCH_ParametersItem_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonTransportChannelID', _PCH_ParametersItem_CTCH_SetupRqstTDD_commonTransportChannelID),
        ('pCH-CCTrCH-ID', _PCH_ParametersItem_CTCH_SetupRqstTDD_pCH_CCTrCH_ID),
        ('dl-TransportFormatSet', _PCH_ParametersItem_CTCH_SetupRqstTDD_dl_TransportFormatSet),
        ('toAWS', _PCH_ParametersItem_CTCH_SetupRqstTDD_toAWS),
        ('toAWE', _PCH_ParametersItem_CTCH_SetupRqstTDD_toAWE),
        ('pICH-Parameters', _PCH_ParametersItem_CTCH_SetupRqstTDD_pICH_Parameters),
        ('iE-Extensions', _PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    PCH_ParametersItem_CTCH_SetupRqstTDD._ext = []
    
    #-----< PCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='PCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-768-ParametersItem-CTCH-SetupRqstTDD')))
    _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 457), ('criticality', 'reject'), ('Extension', _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'ignore'), ('Extension', _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 719), ('criticality', 'reject'), ('Extension', _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PICH-Parameters-CTCH-SetupRqstTDD >-----#
    PICH_Parameters_CTCH_SetupRqstTDD = SEQ(name='PICH-Parameters-CTCH-SetupRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PICH_Parameters_CTCH_SetupRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PICH_Parameters_CTCH_SetupRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PICH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-ParametersItem-CTCH-SetupRqstTDD')))
    ___PICH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-LCR-Parameters-CTCH-SetupRqstTDD')))
    __PICH_Parameters_CTCH_SetupRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 167), ('criticality', 'reject'), ('Value', ___PICH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 459), ('criticality', 'reject'), ('Value', ___PICH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    _PICH_Parameters_CTCH_SetupRqstTDD_id._const_tab = __PICH_Parameters_CTCH_SetupRqstTDD_id_tab
    _PICH_Parameters_CTCH_SetupRqstTDD_id._const_tab_at = None
    _PICH_Parameters_CTCH_SetupRqstTDD_id._const_tab_id = 'id'
    _PICH_Parameters_CTCH_SetupRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PICH_Parameters_CTCH_SetupRqstTDD_criticality._const_tab = __PICH_Parameters_CTCH_SetupRqstTDD_id_tab
    _PICH_Parameters_CTCH_SetupRqstTDD_criticality._const_tab_at = ('..', 'id')
    _PICH_Parameters_CTCH_SetupRqstTDD_criticality._const_tab_id = 'criticality'
    _PICH_Parameters_CTCH_SetupRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PICH_Parameters_CTCH_SetupRqstTDD_value._const_tab = __PICH_Parameters_CTCH_SetupRqstTDD_id_tab
    _PICH_Parameters_CTCH_SetupRqstTDD_value._const_tab_at = ('..', 'id')
    _PICH_Parameters_CTCH_SetupRqstTDD_value._const_tab_id = 'Value'
    PICH_Parameters_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('id', _PICH_Parameters_CTCH_SetupRqstTDD_id),
        ('criticality', _PICH_Parameters_CTCH_SetupRqstTDD_criticality),
        ('value', _PICH_Parameters_CTCH_SetupRqstTDD_value),
        ])
    PICH_Parameters_CTCH_SetupRqstTDD._ext = None
    
    #-----< PICH-ParametersIE-CTCH-SetupRqstTDD >-----#
    PICH_ParametersIE_CTCH_SetupRqstTDD = CLASS(name='PICH-ParametersIE-CTCH-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PICH_ParametersIE_CTCH_SetupRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-ParametersItem-CTCH-SetupRqstTDD')))
    _PICH_ParametersIE_CTCH_SetupRqstTDD_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-LCR-Parameters-CTCH-SetupRqstTDD')))
    PICH_ParametersIE_CTCH_SetupRqstTDD._val = ASN1Set(rv=[dict([('id', 167), ('criticality', 'reject'), ('Value', _PICH_ParametersIE_CTCH_SetupRqstTDD_val_Value_0), ('presence', 'optional')]), dict([('id', 459), ('criticality', 'reject'), ('Value', _PICH_ParametersIE_CTCH_SetupRqstTDD_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< PICH-ParametersItem-CTCH-SetupRqstTDD >-----#
    PICH_ParametersItem_CTCH_SetupRqstTDD = SEQ(name='PICH-ParametersItem-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _PICH_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PICH_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _PICH_ParametersItem_CTCH_SetupRqstTDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _PICH_ParametersItem_CTCH_SetupRqstTDD_midambleshiftAndBurstType = CHOICE(name='midambleshiftAndBurstType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _PICH_ParametersItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PICH_ParametersItem_CTCH_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PICH_ParametersItem_CTCH_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PICH_ParametersItem_CTCH_SetupRqstTDD_pagingIndicatorLength = ENUM(name='pagingIndicatorLength', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PagingIndicatorLength')))
    _PICH_ParametersItem_CTCH_SetupRqstTDD_pICH_Power = INT(name='pICH-Power', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')))
    _PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._cont = __PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_
    _PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PICH_ParametersItem_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PICH_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID),
        ('tdd-ChannelisationCode', _PICH_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode),
        ('timeSlot', _PICH_ParametersItem_CTCH_SetupRqstTDD_timeSlot),
        ('midambleshiftAndBurstType', _PICH_ParametersItem_CTCH_SetupRqstTDD_midambleshiftAndBurstType),
        ('tdd-PhysicalChannelOffset', _PICH_ParametersItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset),
        ('repetitionPeriod', _PICH_ParametersItem_CTCH_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _PICH_ParametersItem_CTCH_SetupRqstTDD_repetitionLength),
        ('pagingIndicatorLength', _PICH_ParametersItem_CTCH_SetupRqstTDD_pagingIndicatorLength),
        ('pICH-Power', _PICH_ParametersItem_CTCH_SetupRqstTDD_pICH_Power),
        ('iE-Extensions', _PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    PICH_ParametersItem_CTCH_SetupRqstTDD._ext = []
    
    #-----< PICH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    PICH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='PICH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PICH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PICH-LCR-Parameters-CTCH-SetupRqstTDD >-----#
    PICH_LCR_Parameters_CTCH_SetupRqstTDD = SEQ(name='PICH-LCR-Parameters-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_pagingIndicatorLength = ENUM(name='pagingIndicatorLength', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PagingIndicatorLength')))
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_pICH_Power = INT(name='pICH-Power', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')))
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_second_TDD_ChannelisationCodeLCR = SEQ(name='second-TDD-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    ____PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 627), ('criticality', 'reject'), ('Extension', _____PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions._cont = __PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_
    _PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PICH_LCR_Parameters_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PICH_LCR_Parameters_CTCH_SetupRqstTDD_commonPhysicalChannelID),
        ('tdd-ChannelisationCodeLCR', _PICH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR),
        ('timeSlotLCR', _PICH_LCR_Parameters_CTCH_SetupRqstTDD_timeSlotLCR),
        ('midambleShiftLCR', _PICH_LCR_Parameters_CTCH_SetupRqstTDD_midambleShiftLCR),
        ('tdd-PhysicalChannelOffset', _PICH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset),
        ('repetitionPeriod', _PICH_LCR_Parameters_CTCH_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _PICH_LCR_Parameters_CTCH_SetupRqstTDD_repetitionLength),
        ('pagingIndicatorLength', _PICH_LCR_Parameters_CTCH_SetupRqstTDD_pagingIndicatorLength),
        ('pICH-Power', _PICH_LCR_Parameters_CTCH_SetupRqstTDD_pICH_Power),
        ('second-TDD-ChannelisationCodeLCR', _PICH_LCR_Parameters_CTCH_SetupRqstTDD_second_TDD_ChannelisationCodeLCR),
        ('iE-Extensions', _PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    PICH_LCR_Parameters_CTCH_SetupRqstTDD._ext = []
    
    #-----< PICH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    PICH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='PICH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PICH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    PICH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 627), ('criticality', 'reject'), ('Extension', _PICH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PICH-768-ParametersItem-CTCH-SetupRqstTDD >-----#
    PICH_768_ParametersItem_CTCH_SetupRqstTDD = SEQ(name='PICH-768-ParametersItem-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_midambleshiftAndBurstType78 = CHOICE(name='midambleshiftAndBurstType78', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_pagingIndicatorLength = ENUM(name='pagingIndicatorLength', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PagingIndicatorLength')))
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_pICH_Power = INT(name='pICH-Power', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')))
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._cont = __PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_
    _PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PICH_768_ParametersItem_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _PICH_768_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID768),
        ('tdd-ChannelisationCode768', _PICH_768_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode768),
        ('timeSlot', _PICH_768_ParametersItem_CTCH_SetupRqstTDD_timeSlot),
        ('midambleshiftAndBurstType78', _PICH_768_ParametersItem_CTCH_SetupRqstTDD_midambleshiftAndBurstType78),
        ('tdd-PhysicalChannelOffset', _PICH_768_ParametersItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset),
        ('repetitionPeriod', _PICH_768_ParametersItem_CTCH_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _PICH_768_ParametersItem_CTCH_SetupRqstTDD_repetitionLength),
        ('pagingIndicatorLength', _PICH_768_ParametersItem_CTCH_SetupRqstTDD_pagingIndicatorLength),
        ('pICH-Power', _PICH_768_ParametersItem_CTCH_SetupRqstTDD_pICH_Power),
        ('iE-Extensions', _PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    PICH_768_ParametersItem_CTCH_SetupRqstTDD._ext = []
    
    #-----< PICH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    PICH_768_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='PICH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PICH_768_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MICH-Parameters-CTCH-SetupRqstTDD >-----#
    MICH_Parameters_CTCH_SetupRqstTDD = SEQ(name='MICH-Parameters-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _MICH_Parameters_CTCH_SetupRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _MICH_Parameters_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _MICH_Parameters_CTCH_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _MICH_Parameters_CTCH_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _MICH_Parameters_CTCH_SetupRqstTDD_notificationIndicatorLength = ENUM(name='notificationIndicatorLength', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'NotificationIndicatorLength')))
    _MICH_Parameters_CTCH_SetupRqstTDD_mICH_Power = INT(name='mICH-Power', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')))
    _MICH_Parameters_CTCH_SetupRqstTDD_mICH_TDDOption_Specific_Parameters = CHOICE(name='mICH-TDDOption-Specific-Parameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-TDDOption-Specific-Parameters-CTCH-SetupRqstTDD')))
    _MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions._cont = __MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_
    _MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MICH_Parameters_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _MICH_Parameters_CTCH_SetupRqstTDD_commonPhysicalChannelID),
        ('tdd-PhysicalChannelOffset', _MICH_Parameters_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset),
        ('repetitionPeriod', _MICH_Parameters_CTCH_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _MICH_Parameters_CTCH_SetupRqstTDD_repetitionLength),
        ('notificationIndicatorLength', _MICH_Parameters_CTCH_SetupRqstTDD_notificationIndicatorLength),
        ('mICH-Power', _MICH_Parameters_CTCH_SetupRqstTDD_mICH_Power),
        ('mICH-TDDOption-Specific-Parameters', _MICH_Parameters_CTCH_SetupRqstTDD_mICH_TDDOption_Specific_Parameters),
        ('iE-Extensions', _MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    MICH_Parameters_CTCH_SetupRqstTDD._ext = []
    
    #-----< MICH-Parameters-CTCH-SetupRqstTDD-ExtIEs >-----#
    MICH_Parameters_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='MICH-Parameters-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MICH_Parameters_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MICH-TDDOption-Specific-Parameters-CTCH-SetupRqstTDD >-----#
    MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD = CHOICE(name='MICH-TDDOption-Specific-Parameters-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD_hCR_TDD = SEQ(name='hCR-TDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-HCR-Parameters-CTCH-SetupRqstTDD')))
    _MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD_lCR_TDD = SEQ(name='lCR-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-LCR-Parameters-CTCH-SetupRqstTDD')))
    _MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD_cHipRate768_TDD = SEQ(name='cHipRate768-TDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-768-Parameters-CTCH-SetupRqstTDD')))
    MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('hCR-TDD', _MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD_hCR_TDD),
        ('lCR-TDD', _MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD_lCR_TDD),
        ('cHipRate768-TDD', _MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD_cHipRate768_TDD),
        ])
    MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD._ext = ['cHipRate768-TDD']
    
    #-----< MICH-HCR-Parameters-CTCH-SetupRqstTDD >-----#
    MICH_HCR_Parameters_CTCH_SetupRqstTDD = SEQ(name='MICH-HCR-Parameters-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _MICH_HCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _MICH_HCR_Parameters_CTCH_SetupRqstTDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _MICH_HCR_Parameters_CTCH_SetupRqstTDD_midambleshiftAndBurstType = CHOICE(name='midambleshiftAndBurstType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions._cont = __MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_
    _MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MICH_HCR_Parameters_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('tdd-ChannelisationCode', _MICH_HCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCode),
        ('timeSlot', _MICH_HCR_Parameters_CTCH_SetupRqstTDD_timeSlot),
        ('midambleshiftAndBurstType', _MICH_HCR_Parameters_CTCH_SetupRqstTDD_midambleshiftAndBurstType),
        ('iE-Extensions', _MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    MICH_HCR_Parameters_CTCH_SetupRqstTDD._ext = []
    
    #-----< MICH-HCR-Parameters-CTCH-SetupRqstTDD-ExtIEs >-----#
    MICH_HCR_Parameters_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='MICH-HCR-Parameters-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MICH_HCR_Parameters_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MICH-LCR-Parameters-CTCH-SetupRqstTDD >-----#
    MICH_LCR_Parameters_CTCH_SetupRqstTDD = SEQ(name='MICH-LCR-Parameters-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _MICH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _MICH_LCR_Parameters_CTCH_SetupRqstTDD_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _MICH_LCR_Parameters_CTCH_SetupRqstTDD_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _MICH_LCR_Parameters_CTCH_SetupRqstTDD_second_TDD_ChannelisationCodeLCR = SEQ(name='second-TDD-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _MICH_LCR_Parameters_CTCH_SetupRqstTDD_tSTD_Indicator = ENUM(name='tSTD-Indicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    _MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeslotLCR-Extension')))
    ____MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 942), ('criticality', 'ignore'), ('Extension', _____MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions._cont = __MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_
    _MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MICH_LCR_Parameters_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('tdd-ChannelisationCodeLCR', _MICH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR),
        ('timeSlotLCR', _MICH_LCR_Parameters_CTCH_SetupRqstTDD_timeSlotLCR),
        ('midambleShiftLCR', _MICH_LCR_Parameters_CTCH_SetupRqstTDD_midambleShiftLCR),
        ('second-TDD-ChannelisationCodeLCR', _MICH_LCR_Parameters_CTCH_SetupRqstTDD_second_TDD_ChannelisationCodeLCR),
        ('tSTD-Indicator', _MICH_LCR_Parameters_CTCH_SetupRqstTDD_tSTD_Indicator),
        ('iE-Extensions', _MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    MICH_LCR_Parameters_CTCH_SetupRqstTDD._ext = []
    
    #-----< MICH-LCR-Parameters-CTCH-SetupRqstTDD-ExtIEs >-----#
    MICH_LCR_Parameters_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='MICH-LCR-Parameters-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _MICH_LCR_Parameters_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeslotLCR-Extension')))
    MICH_LCR_Parameters_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 942), ('criticality', 'ignore'), ('Extension', _MICH_LCR_Parameters_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MICH-768-Parameters-CTCH-SetupRqstTDD >-----#
    MICH_768_Parameters_CTCH_SetupRqstTDD = SEQ(name='MICH-768-Parameters-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _MICH_768_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _MICH_768_Parameters_CTCH_SetupRqstTDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _MICH_768_Parameters_CTCH_SetupRqstTDD_midambleshiftAndBurstType768 = CHOICE(name='midambleshiftAndBurstType768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions._cont = __MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_
    _MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MICH_768_Parameters_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('tdd-ChannelisationCode768', _MICH_768_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCode768),
        ('timeSlot', _MICH_768_Parameters_CTCH_SetupRqstTDD_timeSlot),
        ('midambleshiftAndBurstType768', _MICH_768_Parameters_CTCH_SetupRqstTDD_midambleshiftAndBurstType768),
        ('iE-Extensions', _MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    MICH_768_Parameters_CTCH_SetupRqstTDD._ext = []
    
    #-----< MICH-768-Parameters-CTCH-SetupRqstTDD-ExtIEs >-----#
    MICH_768_Parameters_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='MICH-768-Parameters-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MICH_768_Parameters_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeSlotConfigurationList-LCR-CTCH-SetupRqstTDD >-----#
    TimeSlotConfigurationList_LCR_CTCH_SetupRqstTDD = SEQ_OF(name='TimeSlotConfigurationList-LCR-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _TimeSlotConfigurationList_LCR_CTCH_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationItem-LCR-CTCH-SetupRqstTDD')))
    TimeSlotConfigurationList_LCR_CTCH_SetupRqstTDD._cont = _TimeSlotConfigurationList_LCR_CTCH_SetupRqstTDD__item_
    TimeSlotConfigurationList_LCR_CTCH_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< TimeSlotConfigurationItem-LCR-CTCH-SetupRqstTDD >-----#
    TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD = SEQ(name='TimeSlotConfigurationItem-LCR-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_timeslotLCR = INT(name='timeslotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_timeslotLCR_Parameter_ID = INT(name='timeslotLCR-Parameter-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    _TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions._cont = __TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item_
    _TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('timeslotLCR', _TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_timeslotLCR),
        ('timeslotLCR-Parameter-ID', _TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_timeslotLCR_Parameter_ID),
        ('iE-Extensions', _TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD._ext = []
    
    #-----< TimeSlotConfigurationItem-LCR-CTCH-SetupRqstTDD-ExtIEs >-----#
    TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='TimeSlotConfigurationItem-LCR-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-parameterExtendedList-CTCH-SetupRqstTDD >-----#
    Secondary_CCPCH_parameterExtendedList_CTCH_SetupRqstTDD = SEQ_OF(name='Secondary-CCPCH-parameterExtendedList-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_parameterExtendedList_CTCH_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-parameterItem-CTCH-SetupRqstTDD')))
    Secondary_CCPCH_parameterExtendedList_CTCH_SetupRqstTDD._cont = _Secondary_CCPCH_parameterExtendedList_CTCH_SetupRqstTDD__item_
    Secondary_CCPCH_parameterExtendedList_CTCH_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=232)], ev=None, er=[])
    
    #-----< Secondary-CCPCH-LCR-parameterExtendedList-CTCH-SetupRqstTDD >-----#
    Secondary_CCPCH_LCR_parameterExtendedList_CTCH_SetupRqstTDD = SEQ_OF(name='Secondary-CCPCH-LCR-parameterExtendedList-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_LCR_parameterExtendedList_CTCH_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-LCR-parameterItem-CTCH-SetupRqstTDD')))
    Secondary_CCPCH_LCR_parameterExtendedList_CTCH_SetupRqstTDD._cont = _Secondary_CCPCH_LCR_parameterExtendedList_CTCH_SetupRqstTDD__item_
    Secondary_CCPCH_LCR_parameterExtendedList_CTCH_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=88)], ev=None, er=[])
    
    #-----< PRACH-CTCH-SetupRqstTDD >-----#
    PRACH_CTCH_SetupRqstTDD = SEQ(name='PRACH-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _PRACH_CTCH_SetupRqstTDD_pRACH_Parameters_CTCH_SetupRqstTDD = SEQ(name='pRACH-Parameters-CTCH-SetupRqstTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-Parameters-CTCH-SetupRqstTDD')))
    _PRACH_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRACH_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FPACH-LCR-Parameters-CTCH-SetupRqstTDD')))
    _____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-768-ParametersItem-CTCH-SetupRqstTDD')))
    ____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 312), ('criticality', 'reject'), ('Extension', _____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 720), ('criticality', 'reject'), ('Extension', _____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRACH_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PRACH_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _PRACH_CTCH_SetupRqstTDD_iE_Extensions._cont = __PRACH_CTCH_SetupRqstTDD_iE_Extensions__item_
    _PRACH_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRACH_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('pRACH-Parameters-CTCH-SetupRqstTDD', _PRACH_CTCH_SetupRqstTDD_pRACH_Parameters_CTCH_SetupRqstTDD),
        ('iE-Extensions', _PRACH_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    PRACH_CTCH_SetupRqstTDD._ext = []
    
    #-----< PRACH-CTCH-SetupRqstTDD-ExtIEs >-----#
    PRACH_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='PRACH-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PRACH_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FPACH-LCR-Parameters-CTCH-SetupRqstTDD')))
    _PRACH_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-768-ParametersItem-CTCH-SetupRqstTDD')))
    PRACH_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 312), ('criticality', 'reject'), ('Extension', _PRACH_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 720), ('criticality', 'reject'), ('Extension', _PRACH_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PRACH-Parameters-CTCH-SetupRqstTDD >-----#
    PRACH_Parameters_CTCH_SetupRqstTDD = SEQ(name='PRACH-Parameters-CTCH-SetupRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PRACH_Parameters_CTCH_SetupRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PRACH_Parameters_CTCH_SetupRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PRACH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-ParametersItem-CTCH-SetupRqstTDD')))
    ___PRACH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-LCR-ParametersList-CTCH-SetupRqstTDD')))
    __PRACH_Parameters_CTCH_SetupRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'reject'), ('Value', ___PRACH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 461), ('criticality', 'reject'), ('Value', ___PRACH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    _PRACH_Parameters_CTCH_SetupRqstTDD_id._const_tab = __PRACH_Parameters_CTCH_SetupRqstTDD_id_tab
    _PRACH_Parameters_CTCH_SetupRqstTDD_id._const_tab_at = None
    _PRACH_Parameters_CTCH_SetupRqstTDD_id._const_tab_id = 'id'
    _PRACH_Parameters_CTCH_SetupRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PRACH_Parameters_CTCH_SetupRqstTDD_criticality._const_tab = __PRACH_Parameters_CTCH_SetupRqstTDD_id_tab
    _PRACH_Parameters_CTCH_SetupRqstTDD_criticality._const_tab_at = ('..', 'id')
    _PRACH_Parameters_CTCH_SetupRqstTDD_criticality._const_tab_id = 'criticality'
    _PRACH_Parameters_CTCH_SetupRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PRACH_Parameters_CTCH_SetupRqstTDD_value._const_tab = __PRACH_Parameters_CTCH_SetupRqstTDD_id_tab
    _PRACH_Parameters_CTCH_SetupRqstTDD_value._const_tab_at = ('..', 'id')
    _PRACH_Parameters_CTCH_SetupRqstTDD_value._const_tab_id = 'Value'
    PRACH_Parameters_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('id', _PRACH_Parameters_CTCH_SetupRqstTDD_id),
        ('criticality', _PRACH_Parameters_CTCH_SetupRqstTDD_criticality),
        ('value', _PRACH_Parameters_CTCH_SetupRqstTDD_value),
        ])
    PRACH_Parameters_CTCH_SetupRqstTDD._ext = None
    
    #-----< PRACH-ParametersIE-CTCH-SetupRqstTDD >-----#
    PRACH_ParametersIE_CTCH_SetupRqstTDD = CLASS(name='PRACH-ParametersIE-CTCH-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PRACH_ParametersIE_CTCH_SetupRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-ParametersItem-CTCH-SetupRqstTDD')))
    _PRACH_ParametersIE_CTCH_SetupRqstTDD_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-LCR-ParametersList-CTCH-SetupRqstTDD')))
    PRACH_ParametersIE_CTCH_SetupRqstTDD._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'reject'), ('Value', _PRACH_ParametersIE_CTCH_SetupRqstTDD_val_Value_0), ('presence', 'optional')]), dict([('id', 461), ('criticality', 'reject'), ('Value', _PRACH_ParametersIE_CTCH_SetupRqstTDD_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< PRACH-ParametersItem-CTCH-SetupRqstTDD >-----#
    PRACH_ParametersItem_CTCH_SetupRqstTDD = SEQ(name='PRACH-ParametersItem-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _PRACH_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PRACH_ParametersItem_CTCH_SetupRqstTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _PRACH_ParametersItem_CTCH_SetupRqstTDD_timeslot = INT(name='timeslot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _PRACH_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _PRACH_ParametersItem_CTCH_SetupRqstTDD_maxPRACH_MidambleShifts = ENUM(name='maxPRACH-MidambleShifts', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaxPRACH-MidambleShifts')))
    _PRACH_ParametersItem_CTCH_SetupRqstTDD_pRACH_Midamble = ENUM(name='pRACH-Midamble', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PRACH-Midamble')))
    _PRACH_ParametersItem_CTCH_SetupRqstTDD_rACH = SEQ(name='rACH', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-Parameter-CTCH-SetupRqstTDD')))
    _PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._cont = __PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_
    _PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRACH_ParametersItem_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PRACH_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID),
        ('tFCS', _PRACH_ParametersItem_CTCH_SetupRqstTDD_tFCS),
        ('timeslot', _PRACH_ParametersItem_CTCH_SetupRqstTDD_timeslot),
        ('tdd-ChannelisationCode', _PRACH_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode),
        ('maxPRACH-MidambleShifts', _PRACH_ParametersItem_CTCH_SetupRqstTDD_maxPRACH_MidambleShifts),
        ('pRACH-Midamble', _PRACH_ParametersItem_CTCH_SetupRqstTDD_pRACH_Midamble),
        ('rACH', _PRACH_ParametersItem_CTCH_SetupRqstTDD_rACH),
        ('iE-Extensions', _PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    PRACH_ParametersItem_CTCH_SetupRqstTDD._ext = []
    
    #-----< PRACH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    PRACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='PRACH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PRACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RACH-Parameter-CTCH-SetupRqstTDD >-----#
    RACH_Parameter_CTCH_SetupRqstTDD = SEQ(name='RACH-Parameter-CTCH-SetupRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _RACH_Parameter_CTCH_SetupRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __RACH_Parameter_CTCH_SetupRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___RACH_Parameter_CTCH_SetupRqstTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-ParameterItem-CTCH-SetupRqstTDD')))
    __RACH_Parameter_CTCH_SetupRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 197), ('criticality', 'reject'), ('Value', ___RACH_Parameter_CTCH_SetupRqstTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _RACH_Parameter_CTCH_SetupRqstTDD_id._const_tab = __RACH_Parameter_CTCH_SetupRqstTDD_id_tab
    _RACH_Parameter_CTCH_SetupRqstTDD_id._const_tab_at = None
    _RACH_Parameter_CTCH_SetupRqstTDD_id._const_tab_id = 'id'
    _RACH_Parameter_CTCH_SetupRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _RACH_Parameter_CTCH_SetupRqstTDD_criticality._const_tab = __RACH_Parameter_CTCH_SetupRqstTDD_id_tab
    _RACH_Parameter_CTCH_SetupRqstTDD_criticality._const_tab_at = ('..', 'id')
    _RACH_Parameter_CTCH_SetupRqstTDD_criticality._const_tab_id = 'criticality'
    _RACH_Parameter_CTCH_SetupRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _RACH_Parameter_CTCH_SetupRqstTDD_value._const_tab = __RACH_Parameter_CTCH_SetupRqstTDD_id_tab
    _RACH_Parameter_CTCH_SetupRqstTDD_value._const_tab_at = ('..', 'id')
    _RACH_Parameter_CTCH_SetupRqstTDD_value._const_tab_id = 'Value'
    RACH_Parameter_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('id', _RACH_Parameter_CTCH_SetupRqstTDD_id),
        ('criticality', _RACH_Parameter_CTCH_SetupRqstTDD_criticality),
        ('value', _RACH_Parameter_CTCH_SetupRqstTDD_value),
        ])
    RACH_Parameter_CTCH_SetupRqstTDD._ext = None
    
    #-----< RACH-ParameterIE-CTCH-SetupRqstTDD >-----#
    RACH_ParameterIE_CTCH_SetupRqstTDD = CLASS(name='RACH-ParameterIE-CTCH-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RACH_ParameterIE_CTCH_SetupRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-ParameterItem-CTCH-SetupRqstTDD')))
    RACH_ParameterIE_CTCH_SetupRqstTDD._val = ASN1Set(rv=[dict([('id', 197), ('criticality', 'reject'), ('Value', _RACH_ParameterIE_CTCH_SetupRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RACH-ParameterItem-CTCH-SetupRqstTDD >-----#
    RACH_ParameterItem_CTCH_SetupRqstTDD = SEQ(name='RACH-ParameterItem-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _RACH_ParameterItem_CTCH_SetupRqstTDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _RACH_ParameterItem_CTCH_SetupRqstTDD_uL_TransportFormatSet = SEQ(name='uL-TransportFormatSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')))
    _RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions._cont = __RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_
    _RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RACH_ParameterItem_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonTransportChannelID', _RACH_ParameterItem_CTCH_SetupRqstTDD_commonTransportChannelID),
        ('uL-TransportFormatSet', _RACH_ParameterItem_CTCH_SetupRqstTDD_uL_TransportFormatSet),
        ('iE-Extensions', _RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    RACH_ParameterItem_CTCH_SetupRqstTDD._ext = []
    
    #-----< RACH-ParameterItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='RACH-ParameterItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PRACH-LCR-ParametersList-CTCH-SetupRqstTDD >-----#
    PRACH_LCR_ParametersList_CTCH_SetupRqstTDD = SEQ_OF(name='PRACH-LCR-ParametersList-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _PRACH_LCR_ParametersList_CTCH_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-LCR-ParametersItem-CTCH-SetupRqstTDD')))
    PRACH_LCR_ParametersList_CTCH_SetupRqstTDD._cont = _PRACH_LCR_ParametersList_CTCH_SetupRqstTDD__item_
    PRACH_LCR_ParametersList_CTCH_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PRACH-LCR-ParametersItem-CTCH-SetupRqstTDD >-----#
    PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD = SEQ(name='PRACH-LCR-ParametersItem-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_timeslotLCR = INT(name='timeslotLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_rACH = SEQ(name='rACH', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-Parameter-CTCH-SetupRqstTDD')))
    _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'reject'), ('Extension', _____PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._cont = __PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_
    _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID),
        ('tFCS', _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_tFCS),
        ('timeslotLCR', _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_timeslotLCR),
        ('tdd-ChannelisationCodeLCR', _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR),
        ('midambleShiftLCR', _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_midambleShiftLCR),
        ('rACH', _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_rACH),
        ('iE-Extensions', _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD._ext = []
    
    #-----< PRACH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='PRACH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'reject'), ('Extension', _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PRACH-768-ParametersItem-CTCH-SetupRqstTDD >-----#
    PRACH_768_ParametersItem_CTCH_SetupRqstTDD = SEQ(name='PRACH-768-ParametersItem-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_timeslot = INT(name='timeslot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_maxPRACH_MidambleShifts = ENUM(name='maxPRACH-MidambleShifts', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaxPRACH-MidambleShifts')))
    _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_pRACH_Midamble = ENUM(name='pRACH-Midamble', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PRACH-Midamble')))
    _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_rACH = SEQ(name='rACH', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-Parameter-CTCH-SetupRqstTDD')))
    _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._cont = __PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_
    _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRACH_768_ParametersItem_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID768),
        ('tFCS', _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_tFCS),
        ('timeslot', _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_timeslot),
        ('tdd-ChannelisationCode768', _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode768),
        ('maxPRACH-MidambleShifts', _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_maxPRACH_MidambleShifts),
        ('pRACH-Midamble', _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_pRACH_Midamble),
        ('rACH', _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_rACH),
        ('iE-Extensions', _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    PRACH_768_ParametersItem_CTCH_SetupRqstTDD._ext = []
    
    #-----< PRACH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    PRACH_768_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='PRACH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PRACH_768_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FPACH-LCR-Parameters-CTCH-SetupRqstTDD >-----#
    FPACH_LCR_Parameters_CTCH_SetupRqstTDD = SEQ(name='FPACH-LCR-Parameters-CTCH-SetupRqstTDD', mode=MODE_TYPE)
    _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_timeslotLCR = INT(name='timeslotLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_fPACH_Power = INT(name='fPACH-Power', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FPACH-Power')))
    _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'reject'), ('Extension', _____FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_._ext = None
    _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions._cont = __FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_
    _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FPACH_LCR_Parameters_CTCH_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_commonPhysicalChannelID),
        ('tdd-ChannelisationCodeLCR', _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR),
        ('timeslotLCR', _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_timeslotLCR),
        ('midambleShiftLCR', _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_midambleShiftLCR),
        ('fPACH-Power', _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_fPACH_Power),
        ('iE-Extensions', _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions),
        ])
    FPACH_LCR_Parameters_CTCH_SetupRqstTDD._ext = []
    
    #-----< FPACH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    FPACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='FPACH-LCR-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _FPACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    FPACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'reject'), ('Extension', _FPACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PLCCH-parameters >-----#
    PLCCH_parameters = SEQ(name='PLCCH-parameters', mode=MODE_TYPE)
    _PLCCH_parameters_maxPowerPLCCH = INT(name='maxPowerPLCCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _PLCCH_parameters_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PLCCH_parameters_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _PLCCH_parameters_timeslotLCR = INT(name='timeslotLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _PLCCH_parameters_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _PLCCH_parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLCCH_parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PLCCH_parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PLCCH_parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PLCCH_parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCH_parameters_iE_Extensions__item__id._const_tab = ____PLCCH_parameters_iE_Extensions__item__id_tab
    ___PLCCH_parameters_iE_Extensions__item__id._const_tab_at = None
    ___PLCCH_parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___PLCCH_parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PLCCH_parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PLCCH_parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCH_parameters_iE_Extensions__item__criticality._const_tab = ____PLCCH_parameters_iE_Extensions__item__criticality_tab
    ___PLCCH_parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PLCCH_parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PLCCH_parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PLCCH_parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PLCCH_parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCH_parameters_iE_Extensions__item__extensionValue._const_tab = ____PLCCH_parameters_iE_Extensions__item__extensionValue_tab
    ___PLCCH_parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PLCCH_parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PLCCH_parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PLCCH_parameters_iE_Extensions__item__id),
        ('criticality', ___PLCCH_parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___PLCCH_parameters_iE_Extensions__item__extensionValue),
        ])
    __PLCCH_parameters_iE_Extensions__item_._ext = None
    _PLCCH_parameters_iE_Extensions._cont = __PLCCH_parameters_iE_Extensions__item_
    _PLCCH_parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLCCH_parameters._cont = ASN1Dict([
        ('maxPowerPLCCH', _PLCCH_parameters_maxPowerPLCCH),
        ('commonPhysicalChannelID', _PLCCH_parameters_commonPhysicalChannelID),
        ('tdd-ChannelisationCode', _PLCCH_parameters_tdd_ChannelisationCode),
        ('timeslotLCR', _PLCCH_parameters_timeslotLCR),
        ('midambleShiftLCR', _PLCCH_parameters_midambleShiftLCR),
        ('iE-Extensions', _PLCCH_parameters_iE_Extensions),
        ])
    PLCCH_parameters._ext = []
    
    #-----< PLCCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    PLCCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='PLCCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PLCCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RUCCH-parameters >-----#
    E_RUCCH_parameters = SEQ(name='E-RUCCH-parameters', mode=MODE_TYPE)
    _E_RUCCH_parameters_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _E_RUCCH_parameters_timeslot = INT(name='timeslot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _E_RUCCH_parameters_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _E_RUCCH_parameters_maxE_RUCCH_MidambleShifts = ENUM(name='maxE-RUCCH-MidambleShifts', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaxPRACH-MidambleShifts')))
    _E_RUCCH_parameters_e_RUCCH_Midamble = ENUM(name='e-RUCCH-Midamble', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PRACH-Midamble')))
    _E_RUCCH_parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RUCCH_parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_RUCCH_parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RUCCH_parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_RUCCH_parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RUCCH_parameters_iE_Extensions__item__id._const_tab = ____E_RUCCH_parameters_iE_Extensions__item__id_tab
    ___E_RUCCH_parameters_iE_Extensions__item__id._const_tab_at = None
    ___E_RUCCH_parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RUCCH_parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RUCCH_parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_RUCCH_parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RUCCH_parameters_iE_Extensions__item__criticality._const_tab = ____E_RUCCH_parameters_iE_Extensions__item__criticality_tab
    ___E_RUCCH_parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RUCCH_parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RUCCH_parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RUCCH_parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_RUCCH_parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RUCCH_parameters_iE_Extensions__item__extensionValue._const_tab = ____E_RUCCH_parameters_iE_Extensions__item__extensionValue_tab
    ___E_RUCCH_parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RUCCH_parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RUCCH_parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RUCCH_parameters_iE_Extensions__item__id),
        ('criticality', ___E_RUCCH_parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RUCCH_parameters_iE_Extensions__item__extensionValue),
        ])
    __E_RUCCH_parameters_iE_Extensions__item_._ext = None
    _E_RUCCH_parameters_iE_Extensions._cont = __E_RUCCH_parameters_iE_Extensions__item_
    _E_RUCCH_parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RUCCH_parameters._cont = ASN1Dict([
        ('commonPhysicalChannelID', _E_RUCCH_parameters_commonPhysicalChannelID),
        ('timeslot', _E_RUCCH_parameters_timeslot),
        ('tdd-ChannelisationCode', _E_RUCCH_parameters_tdd_ChannelisationCode),
        ('maxE-RUCCH-MidambleShifts', _E_RUCCH_parameters_maxE_RUCCH_MidambleShifts),
        ('e-RUCCH-Midamble', _E_RUCCH_parameters_e_RUCCH_Midamble),
        ('iE-Extensions', _E_RUCCH_parameters_iE_Extensions),
        ])
    E_RUCCH_parameters._ext = []
    
    #-----< E-RUCCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    E_RUCCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='E-RUCCH-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_RUCCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RUCCH-768-parameters >-----#
    E_RUCCH_768_parameters = SEQ(name='E-RUCCH-768-parameters', mode=MODE_TYPE)
    _E_RUCCH_768_parameters_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _E_RUCCH_768_parameters_timeslot = INT(name='timeslot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _E_RUCCH_768_parameters_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _E_RUCCH_768_parameters_maxE_RUCCH_MidambleShifts = ENUM(name='maxE-RUCCH-MidambleShifts', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaxPRACH-MidambleShifts')))
    _E_RUCCH_768_parameters_e_RUCCH_Midamble = ENUM(name='e-RUCCH-Midamble', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PRACH-Midamble')))
    _E_RUCCH_768_parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RUCCH_768_parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_RUCCH_768_parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RUCCH_768_parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_RUCCH_768_parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RUCCH_768_parameters_iE_Extensions__item__id._const_tab = ____E_RUCCH_768_parameters_iE_Extensions__item__id_tab
    ___E_RUCCH_768_parameters_iE_Extensions__item__id._const_tab_at = None
    ___E_RUCCH_768_parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RUCCH_768_parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RUCCH_768_parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_RUCCH_768_parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RUCCH_768_parameters_iE_Extensions__item__criticality._const_tab = ____E_RUCCH_768_parameters_iE_Extensions__item__criticality_tab
    ___E_RUCCH_768_parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RUCCH_768_parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RUCCH_768_parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RUCCH_768_parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_RUCCH_768_parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RUCCH_768_parameters_iE_Extensions__item__extensionValue._const_tab = ____E_RUCCH_768_parameters_iE_Extensions__item__extensionValue_tab
    ___E_RUCCH_768_parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RUCCH_768_parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RUCCH_768_parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RUCCH_768_parameters_iE_Extensions__item__id),
        ('criticality', ___E_RUCCH_768_parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RUCCH_768_parameters_iE_Extensions__item__extensionValue),
        ])
    __E_RUCCH_768_parameters_iE_Extensions__item_._ext = None
    _E_RUCCH_768_parameters_iE_Extensions._cont = __E_RUCCH_768_parameters_iE_Extensions__item_
    _E_RUCCH_768_parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RUCCH_768_parameters._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _E_RUCCH_768_parameters_commonPhysicalChannelID768),
        ('timeslot', _E_RUCCH_768_parameters_timeslot),
        ('tdd-ChannelisationCode768', _E_RUCCH_768_parameters_tdd_ChannelisationCode768),
        ('maxE-RUCCH-MidambleShifts', _E_RUCCH_768_parameters_maxE_RUCCH_MidambleShifts),
        ('e-RUCCH-Midamble', _E_RUCCH_768_parameters_e_RUCCH_Midamble),
        ('iE-Extensions', _E_RUCCH_768_parameters_iE_Extensions),
        ])
    E_RUCCH_768_parameters._ext = []
    
    #-----< E-RUCCH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs >-----#
    E_RUCCH_768_ParametersItem_CTCH_SetupRqstTDD_ExtIEs = CLASS(name='E-RUCCH-768-ParametersItem-CTCH-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_RUCCH_768_ParametersItem_CTCH_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelSetupResponse >-----#
    CommonTransportChannelSetupResponse = SEQ(name='CommonTransportChannelSetupResponse', mode=MODE_TYPE)
    _CommonTransportChannelSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-CommonTransportChannel-InformationResponse')))
    _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannel-InformationResponse')))
    _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannel-InformationResponse')))
    _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannel-InformationResponse')))
    ____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 362), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 374), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 385), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 1287), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupResponse_protocolIEs__item__id._const_tab = ____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonTransportChannelSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonTransportChannelSetupResponse_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonTransportChannelSetupResponse_protocolIEs__item__value._const_tab = ____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonTransportChannelSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelSetupResponse_protocolIEs__item__id),
        ('criticality', ___CommonTransportChannelSetupResponse_protocolIEs__item__criticality),
        ('value', ___CommonTransportChannelSetupResponse_protocolIEs__item__value),
        ])
    __CommonTransportChannelSetupResponse_protocolIEs__item_._ext = None
    _CommonTransportChannelSetupResponse_protocolIEs._cont = __CommonTransportChannelSetupResponse_protocolIEs__item_
    _CommonTransportChannelSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelSetupResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelSetupResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonTransportChannelSetupResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__id._const_tab = ____CommonTransportChannelSetupResponse_protocolExtensions__item__id_tab
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonTransportChannelSetupResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelSetupResponse_protocolExtensions__item__criticality_tab
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonTransportChannelSetupResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelSetupResponse_protocolExtensions__item__extensionValue_tab
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonTransportChannelSetupResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelSetupResponse_protocolExtensions__item__id),
        ('criticality', ___CommonTransportChannelSetupResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonTransportChannelSetupResponse_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelSetupResponse_protocolExtensions__item_._ext = None
    _CommonTransportChannelSetupResponse_protocolExtensions._cont = __CommonTransportChannelSetupResponse_protocolExtensions__item_
    _CommonTransportChannelSetupResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _CommonTransportChannelSetupResponse_protocolIEs),
        ('protocolExtensions', _CommonTransportChannelSetupResponse_protocolExtensions),
        ])
    CommonTransportChannelSetupResponse._ext = []
    
    #-----< CommonTransportChannelSetupResponse-IEs >-----#
    CommonTransportChannelSetupResponse_IEs = CLASS(name='CommonTransportChannelSetupResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonTransportChannelSetupResponse_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-CommonTransportChannel-InformationResponse')))
    _CommonTransportChannelSetupResponse_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannel-InformationResponse')))
    _CommonTransportChannelSetupResponse_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannel-InformationResponse')))
    _CommonTransportChannelSetupResponse_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    _CommonTransportChannelSetupResponse_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannel-InformationResponse')))
    CommonTransportChannelSetupResponse_IEs._val = ASN1Set(rv=[dict([('id', 362), ('criticality', 'ignore'), ('Value', _CommonTransportChannelSetupResponse_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 374), ('criticality', 'ignore'), ('Value', _CommonTransportChannelSetupResponse_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 385), ('criticality', 'ignore'), ('Value', _CommonTransportChannelSetupResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _CommonTransportChannelSetupResponse_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 1287), ('criticality', 'ignore'), ('Value', _CommonTransportChannelSetupResponse_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelSetupResponse-Extensions >-----#
    CommonTransportChannelSetupResponse_Extensions = CLASS(name='CommonTransportChannelSetupResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonTransportChannelSetupResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FACH-CommonTransportChannel-InformationResponse >-----#
    FACH_CommonTransportChannel_InformationResponse = SEQ_OF(name='FACH-CommonTransportChannel-InformationResponse', mode=MODE_TYPE)
    _FACH_CommonTransportChannel_InformationResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannel-InformationResponse')))
    FACH_CommonTransportChannel_InformationResponse._cont = _FACH_CommonTransportChannel_InformationResponse__item_
    FACH_CommonTransportChannel_InformationResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CommonTransportChannelSetupFailure >-----#
    CommonTransportChannelSetupFailure = SEQ(name='CommonTransportChannelSetupFailure', mode=MODE_TYPE)
    _CommonTransportChannelSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupFailure_protocolIEs__item__id._const_tab = ____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonTransportChannelSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonTransportChannelSetupFailure_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonTransportChannelSetupFailure_protocolIEs__item__value._const_tab = ____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab
    ___CommonTransportChannelSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonTransportChannelSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelSetupFailure_protocolIEs__item__id),
        ('criticality', ___CommonTransportChannelSetupFailure_protocolIEs__item__criticality),
        ('value', ___CommonTransportChannelSetupFailure_protocolIEs__item__value),
        ])
    __CommonTransportChannelSetupFailure_protocolIEs__item_._ext = None
    _CommonTransportChannelSetupFailure_protocolIEs._cont = __CommonTransportChannelSetupFailure_protocolIEs__item_
    _CommonTransportChannelSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelSetupFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelSetupFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonTransportChannelSetupFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__id._const_tab = ____CommonTransportChannelSetupFailure_protocolExtensions__item__id_tab
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonTransportChannelSetupFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelSetupFailure_protocolExtensions__item__criticality_tab
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonTransportChannelSetupFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelSetupFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelSetupFailure_protocolExtensions__item__extensionValue_tab
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonTransportChannelSetupFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonTransportChannelSetupFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelSetupFailure_protocolExtensions__item__id),
        ('criticality', ___CommonTransportChannelSetupFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonTransportChannelSetupFailure_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelSetupFailure_protocolExtensions__item_._ext = None
    _CommonTransportChannelSetupFailure_protocolExtensions._cont = __CommonTransportChannelSetupFailure_protocolExtensions__item_
    _CommonTransportChannelSetupFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _CommonTransportChannelSetupFailure_protocolIEs),
        ('protocolExtensions', _CommonTransportChannelSetupFailure_protocolExtensions),
        ])
    CommonTransportChannelSetupFailure._ext = []
    
    #-----< CommonTransportChannelSetupFailure-IEs >-----#
    CommonTransportChannelSetupFailure_IEs = CLASS(name='CommonTransportChannelSetupFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonTransportChannelSetupFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _CommonTransportChannelSetupFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CommonTransportChannelSetupFailure_IEs._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _CommonTransportChannelSetupFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _CommonTransportChannelSetupFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelSetupFailure-Extensions >-----#
    CommonTransportChannelSetupFailure_Extensions = CLASS(name='CommonTransportChannelSetupFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonTransportChannelSetupFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelReconfigurationRequestFDD >-----#
    CommonTransportChannelReconfigurationRequestFDD = SEQ(name='CommonTransportChannelReconfigurationRequestFDD', mode=MODE_TYPE)
    _CommonTransportChannelReconfigurationRequestFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonPhysicalChannelType-CTCH-ReconfRqstFDD')))
    ____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 334), ('criticality', 'reject'), ('Value', _____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id._const_tab = ____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__value._const_tab = ____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id),
        ('criticality', ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__criticality),
        ('value', ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__value),
        ])
    __CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item_._ext = None
    _CommonTransportChannelReconfigurationRequestFDD_protocolIEs._cont = __CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item_
    _CommonTransportChannelReconfigurationRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelReconfigurationRequestFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__id._const_tab = ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__criticality_tab
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue_tab
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__id),
        ('criticality', ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item_._ext = None
    _CommonTransportChannelReconfigurationRequestFDD_protocolExtensions._cont = __CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item_
    _CommonTransportChannelReconfigurationRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelReconfigurationRequestFDD._cont = ASN1Dict([
        ('protocolIEs', _CommonTransportChannelReconfigurationRequestFDD_protocolIEs),
        ('protocolExtensions', _CommonTransportChannelReconfigurationRequestFDD_protocolExtensions),
        ])
    CommonTransportChannelReconfigurationRequestFDD._ext = []
    
    #-----< CommonTransportChannelReconfigurationRequestFDD-IEs >-----#
    CommonTransportChannelReconfigurationRequestFDD_IEs = CLASS(name='CommonTransportChannelReconfigurationRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonTransportChannelReconfigurationRequestFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CommonTransportChannelReconfigurationRequestFDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _CommonTransportChannelReconfigurationRequestFDD_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonPhysicalChannelType-CTCH-ReconfRqstFDD')))
    CommonTransportChannelReconfigurationRequestFDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _CommonTransportChannelReconfigurationRequestFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _CommonTransportChannelReconfigurationRequestFDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 334), ('criticality', 'reject'), ('Value', _CommonTransportChannelReconfigurationRequestFDD_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelReconfigurationRequestFDD-Extensions >-----#
    CommonTransportChannelReconfigurationRequestFDD_Extensions = CLASS(name='CommonTransportChannelReconfigurationRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonTransportChannelReconfigurationRequestFDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonPhysicalChannelType-CTCH-ReconfRqstFDD >-----#
    CommonPhysicalChannelType_CTCH_ReconfRqstFDD = CHOICE(name='CommonPhysicalChannelType-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _CommonPhysicalChannelType_CTCH_ReconfRqstFDD_secondary_CCPCH_parameters = SEQ(name='secondary-CCPCH-parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCHList-CTCH-ReconfRqstFDD')))
    _CommonPhysicalChannelType_CTCH_ReconfRqstFDD_pRACH_parameters = SEQ(name='pRACH-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACHList-CTCH-ReconfRqstFDD')))
    _CommonPhysicalChannelType_CTCH_ReconfRqstFDD_notUsed_cPCH_parameters = NULL(name='notUsed-cPCH-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CommonPhysicalChannelType_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('secondary-CCPCH-parameters', _CommonPhysicalChannelType_CTCH_ReconfRqstFDD_secondary_CCPCH_parameters),
        ('pRACH-parameters', _CommonPhysicalChannelType_CTCH_ReconfRqstFDD_pRACH_parameters),
        ('notUsed-cPCH-parameters', _CommonPhysicalChannelType_CTCH_ReconfRqstFDD_notUsed_cPCH_parameters),
        ])
    CommonPhysicalChannelType_CTCH_ReconfRqstFDD._ext = []
    
    #-----< Secondary-CCPCHList-CTCH-ReconfRqstFDD >-----#
    Secondary_CCPCHList_CTCH_ReconfRqstFDD = SEQ(name='Secondary-CCPCHList-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _Secondary_CCPCHList_CTCH_ReconfRqstFDD_fACH_ParametersList_CTCH_ReconfRqstFDD = SEQ(name='fACH-ParametersList-CTCH-ReconfRqstFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersList-CTCH-ReconfRqstFDD')), opt=True)
    _Secondary_CCPCHList_CTCH_ReconfRqstFDD_pCH_Parameters_CTCH_ReconfRqstFDD = SEQ(name='pCH-Parameters-CTCH-ReconfRqstFDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-Parameters-CTCH-ReconfRqstFDD')), opt=True)
    _Secondary_CCPCHList_CTCH_ReconfRqstFDD_pICH_Parameters_CTCH_ReconfRqstFDD = SEQ(name='pICH-Parameters-CTCH-ReconfRqstFDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-Parameters-CTCH-ReconfRqstFDD')), opt=True)
    _Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-Parameters-CTCH-ReconfRqstFDD')))
    _____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BCH-Parameters-CTCH-ReconfRqstFDD')))
    ____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 640), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1288), ('criticality', 'ignore'), ('Extension', _____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions._cont = __Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item_
    _Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCHList_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('fACH-ParametersList-CTCH-ReconfRqstFDD', _Secondary_CCPCHList_CTCH_ReconfRqstFDD_fACH_ParametersList_CTCH_ReconfRqstFDD),
        ('pCH-Parameters-CTCH-ReconfRqstFDD', _Secondary_CCPCHList_CTCH_ReconfRqstFDD_pCH_Parameters_CTCH_ReconfRqstFDD),
        ('pICH-Parameters-CTCH-ReconfRqstFDD', _Secondary_CCPCHList_CTCH_ReconfRqstFDD_pICH_Parameters_CTCH_ReconfRqstFDD),
        ('iE-Extensions', _Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions),
        ])
    Secondary_CCPCHList_CTCH_ReconfRqstFDD._ext = []
    
    #-----< Secondary-CCPCH-CTCH-ReconfRqstFDD-ExtIEs >-----#
    Secondary_CCPCH_CTCH_ReconfRqstFDD_ExtIEs = CLASS(name='Secondary-CCPCH-CTCH-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Secondary_CCPCH_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-Parameters-CTCH-ReconfRqstFDD')))
    _Secondary_CCPCH_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BCH-Parameters-CTCH-ReconfRqstFDD')))
    Secondary_CCPCH_CTCH_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 640), ('criticality', 'reject'), ('Extension', _Secondary_CCPCH_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1288), ('criticality', 'ignore'), ('Extension', _Secondary_CCPCH_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< FACH-ParametersList-CTCH-ReconfRqstFDD >-----#
    FACH_ParametersList_CTCH_ReconfRqstFDD = SEQ(name='FACH-ParametersList-CTCH-ReconfRqstFDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _FACH_ParametersList_CTCH_ReconfRqstFDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __FACH_ParametersList_CTCH_ReconfRqstFDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___FACH_ParametersList_CTCH_ReconfRqstFDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersListIE-CTCH-ReconfRqstFDD')))
    __FACH_ParametersList_CTCH_ReconfRqstFDD_id_tab._val = ASN1Set(rv=[dict([('id', 323), ('criticality', 'reject'), ('Value', ___FACH_ParametersList_CTCH_ReconfRqstFDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _FACH_ParametersList_CTCH_ReconfRqstFDD_id._const_tab = __FACH_ParametersList_CTCH_ReconfRqstFDD_id_tab
    _FACH_ParametersList_CTCH_ReconfRqstFDD_id._const_tab_at = None
    _FACH_ParametersList_CTCH_ReconfRqstFDD_id._const_tab_id = 'id'
    _FACH_ParametersList_CTCH_ReconfRqstFDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _FACH_ParametersList_CTCH_ReconfRqstFDD_criticality._const_tab = __FACH_ParametersList_CTCH_ReconfRqstFDD_id_tab
    _FACH_ParametersList_CTCH_ReconfRqstFDD_criticality._const_tab_at = ('..', 'id')
    _FACH_ParametersList_CTCH_ReconfRqstFDD_criticality._const_tab_id = 'criticality'
    _FACH_ParametersList_CTCH_ReconfRqstFDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _FACH_ParametersList_CTCH_ReconfRqstFDD_value._const_tab = __FACH_ParametersList_CTCH_ReconfRqstFDD_id_tab
    _FACH_ParametersList_CTCH_ReconfRqstFDD_value._const_tab_at = ('..', 'id')
    _FACH_ParametersList_CTCH_ReconfRqstFDD_value._const_tab_id = 'Value'
    FACH_ParametersList_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('id', _FACH_ParametersList_CTCH_ReconfRqstFDD_id),
        ('criticality', _FACH_ParametersList_CTCH_ReconfRqstFDD_criticality),
        ('value', _FACH_ParametersList_CTCH_ReconfRqstFDD_value),
        ])
    FACH_ParametersList_CTCH_ReconfRqstFDD._ext = None
    
    #-----< FACH-ParametersListIEs-CTCH-ReconfRqstFDD >-----#
    FACH_ParametersListIEs_CTCH_ReconfRqstFDD = CLASS(name='FACH-ParametersListIEs-CTCH-ReconfRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _FACH_ParametersListIEs_CTCH_ReconfRqstFDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersListIE-CTCH-ReconfRqstFDD')))
    FACH_ParametersListIEs_CTCH_ReconfRqstFDD._val = ASN1Set(rv=[dict([('id', 323), ('criticality', 'reject'), ('Value', _FACH_ParametersListIEs_CTCH_ReconfRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< FACH-ParametersListIE-CTCH-ReconfRqstFDD >-----#
    FACH_ParametersListIE_CTCH_ReconfRqstFDD = SEQ_OF(name='FACH-ParametersListIE-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _FACH_ParametersListIE_CTCH_ReconfRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersItem-CTCH-ReconfRqstFDD')))
    FACH_ParametersListIE_CTCH_ReconfRqstFDD._cont = _FACH_ParametersListIE_CTCH_ReconfRqstFDD__item_
    FACH_ParametersListIE_CTCH_ReconfRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< FACH-ParametersItem-CTCH-ReconfRqstFDD >-----#
    FACH_ParametersItem_CTCH_ReconfRqstFDD = SEQ(name='FACH-ParametersItem-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _FACH_ParametersItem_CTCH_ReconfRqstFDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _FACH_ParametersItem_CTCH_ReconfRqstFDD_maxFACH_Power = INT(name='maxFACH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _FACH_ParametersItem_CTCH_ReconfRqstFDD_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')), opt=True)
    _FACH_ParametersItem_CTCH_ReconfRqstFDD_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')), opt=True)
    _FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions._cont = __FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_
    _FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FACH_ParametersItem_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('commonTransportChannelID', _FACH_ParametersItem_CTCH_ReconfRqstFDD_commonTransportChannelID),
        ('maxFACH-Power', _FACH_ParametersItem_CTCH_ReconfRqstFDD_maxFACH_Power),
        ('toAWS', _FACH_ParametersItem_CTCH_ReconfRqstFDD_toAWS),
        ('toAWE', _FACH_ParametersItem_CTCH_ReconfRqstFDD_toAWE),
        ('iE-Extensions', _FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions),
        ])
    FACH_ParametersItem_CTCH_ReconfRqstFDD._ext = []
    
    #-----< FACH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs >-----#
    FACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs = CLASS(name='FACH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _FACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    FACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PCH-Parameters-CTCH-ReconfRqstFDD >-----#
    PCH_Parameters_CTCH_ReconfRqstFDD = SEQ(name='PCH-Parameters-CTCH-ReconfRqstFDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PCH_Parameters_CTCH_ReconfRqstFDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PCH_Parameters_CTCH_ReconfRqstFDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PCH_Parameters_CTCH_ReconfRqstFDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-ParametersItem-CTCH-ReconfRqstFDD')))
    __PCH_Parameters_CTCH_ReconfRqstFDD_id_tab._val = ASN1Set(rv=[dict([('id', 375), ('criticality', 'reject'), ('Value', ___PCH_Parameters_CTCH_ReconfRqstFDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _PCH_Parameters_CTCH_ReconfRqstFDD_id._const_tab = __PCH_Parameters_CTCH_ReconfRqstFDD_id_tab
    _PCH_Parameters_CTCH_ReconfRqstFDD_id._const_tab_at = None
    _PCH_Parameters_CTCH_ReconfRqstFDD_id._const_tab_id = 'id'
    _PCH_Parameters_CTCH_ReconfRqstFDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PCH_Parameters_CTCH_ReconfRqstFDD_criticality._const_tab = __PCH_Parameters_CTCH_ReconfRqstFDD_id_tab
    _PCH_Parameters_CTCH_ReconfRqstFDD_criticality._const_tab_at = ('..', 'id')
    _PCH_Parameters_CTCH_ReconfRqstFDD_criticality._const_tab_id = 'criticality'
    _PCH_Parameters_CTCH_ReconfRqstFDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PCH_Parameters_CTCH_ReconfRqstFDD_value._const_tab = __PCH_Parameters_CTCH_ReconfRqstFDD_id_tab
    _PCH_Parameters_CTCH_ReconfRqstFDD_value._const_tab_at = ('..', 'id')
    _PCH_Parameters_CTCH_ReconfRqstFDD_value._const_tab_id = 'Value'
    PCH_Parameters_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('id', _PCH_Parameters_CTCH_ReconfRqstFDD_id),
        ('criticality', _PCH_Parameters_CTCH_ReconfRqstFDD_criticality),
        ('value', _PCH_Parameters_CTCH_ReconfRqstFDD_value),
        ])
    PCH_Parameters_CTCH_ReconfRqstFDD._ext = None
    
    #-----< PCH-ParametersIE-CTCH-ReconfRqstFDD >-----#
    PCH_ParametersIE_CTCH_ReconfRqstFDD = CLASS(name='PCH-ParametersIE-CTCH-ReconfRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PCH_ParametersIE_CTCH_ReconfRqstFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-ParametersItem-CTCH-ReconfRqstFDD')))
    PCH_ParametersIE_CTCH_ReconfRqstFDD._val = ASN1Set(rv=[dict([('id', 375), ('criticality', 'reject'), ('Value', _PCH_ParametersIE_CTCH_ReconfRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PCH-ParametersItem-CTCH-ReconfRqstFDD >-----#
    PCH_ParametersItem_CTCH_ReconfRqstFDD = SEQ(name='PCH-ParametersItem-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _PCH_ParametersItem_CTCH_ReconfRqstFDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _PCH_ParametersItem_CTCH_ReconfRqstFDD_pCH_Power = INT(name='pCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _PCH_ParametersItem_CTCH_ReconfRqstFDD_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')), opt=True)
    _PCH_ParametersItem_CTCH_ReconfRqstFDD_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')), opt=True)
    _PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions._cont = __PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_
    _PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PCH_ParametersItem_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('commonTransportChannelID', _PCH_ParametersItem_CTCH_ReconfRqstFDD_commonTransportChannelID),
        ('pCH-Power', _PCH_ParametersItem_CTCH_ReconfRqstFDD_pCH_Power),
        ('toAWS', _PCH_ParametersItem_CTCH_ReconfRqstFDD_toAWS),
        ('toAWE', _PCH_ParametersItem_CTCH_ReconfRqstFDD_toAWE),
        ('iE-Extensions', _PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions),
        ])
    PCH_ParametersItem_CTCH_ReconfRqstFDD._ext = []
    
    #-----< PCH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs >-----#
    PCH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs = CLASS(name='PCH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PCH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    PCH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _PCH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PICH-Parameters-CTCH-ReconfRqstFDD >-----#
    PICH_Parameters_CTCH_ReconfRqstFDD = SEQ(name='PICH-Parameters-CTCH-ReconfRqstFDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PICH_Parameters_CTCH_ReconfRqstFDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PICH_Parameters_CTCH_ReconfRqstFDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PICH_Parameters_CTCH_ReconfRqstFDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-ParametersItem-CTCH-ReconfRqstFDD')))
    __PICH_Parameters_CTCH_ReconfRqstFDD_id_tab._val = ASN1Set(rv=[dict([('id', 380), ('criticality', 'reject'), ('Value', ___PICH_Parameters_CTCH_ReconfRqstFDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _PICH_Parameters_CTCH_ReconfRqstFDD_id._const_tab = __PICH_Parameters_CTCH_ReconfRqstFDD_id_tab
    _PICH_Parameters_CTCH_ReconfRqstFDD_id._const_tab_at = None
    _PICH_Parameters_CTCH_ReconfRqstFDD_id._const_tab_id = 'id'
    _PICH_Parameters_CTCH_ReconfRqstFDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PICH_Parameters_CTCH_ReconfRqstFDD_criticality._const_tab = __PICH_Parameters_CTCH_ReconfRqstFDD_id_tab
    _PICH_Parameters_CTCH_ReconfRqstFDD_criticality._const_tab_at = ('..', 'id')
    _PICH_Parameters_CTCH_ReconfRqstFDD_criticality._const_tab_id = 'criticality'
    _PICH_Parameters_CTCH_ReconfRqstFDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PICH_Parameters_CTCH_ReconfRqstFDD_value._const_tab = __PICH_Parameters_CTCH_ReconfRqstFDD_id_tab
    _PICH_Parameters_CTCH_ReconfRqstFDD_value._const_tab_at = ('..', 'id')
    _PICH_Parameters_CTCH_ReconfRqstFDD_value._const_tab_id = 'Value'
    PICH_Parameters_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('id', _PICH_Parameters_CTCH_ReconfRqstFDD_id),
        ('criticality', _PICH_Parameters_CTCH_ReconfRqstFDD_criticality),
        ('value', _PICH_Parameters_CTCH_ReconfRqstFDD_value),
        ])
    PICH_Parameters_CTCH_ReconfRqstFDD._ext = None
    
    #-----< PICH-ParametersIE-CTCH-ReconfRqstFDD >-----#
    PICH_ParametersIE_CTCH_ReconfRqstFDD = CLASS(name='PICH-ParametersIE-CTCH-ReconfRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PICH_ParametersIE_CTCH_ReconfRqstFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-ParametersItem-CTCH-ReconfRqstFDD')))
    PICH_ParametersIE_CTCH_ReconfRqstFDD._val = ASN1Set(rv=[dict([('id', 380), ('criticality', 'reject'), ('Value', _PICH_ParametersIE_CTCH_ReconfRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PICH-ParametersItem-CTCH-ReconfRqstFDD >-----#
    PICH_ParametersItem_CTCH_ReconfRqstFDD = SEQ(name='PICH-ParametersItem-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _PICH_ParametersItem_CTCH_ReconfRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PICH_ParametersItem_CTCH_ReconfRqstFDD_pICH_Power = INT(name='pICH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')), opt=True)
    _PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions._cont = __PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_
    _PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PICH_ParametersItem_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PICH_ParametersItem_CTCH_ReconfRqstFDD_commonPhysicalChannelID),
        ('pICH-Power', _PICH_ParametersItem_CTCH_ReconfRqstFDD_pICH_Power),
        ('iE-Extensions', _PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions),
        ])
    PICH_ParametersItem_CTCH_ReconfRqstFDD._ext = []
    
    #-----< PICH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs >-----#
    PICH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs = CLASS(name='PICH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PICH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MICH-Parameters-CTCH-ReconfRqstFDD >-----#
    MICH_Parameters_CTCH_ReconfRqstFDD = SEQ(name='MICH-Parameters-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _MICH_Parameters_CTCH_ReconfRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _MICH_Parameters_CTCH_ReconfRqstFDD_mICH_Power = INT(name='mICH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')), opt=True)
    _MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions._cont = __MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item_
    _MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MICH_Parameters_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _MICH_Parameters_CTCH_ReconfRqstFDD_commonPhysicalChannelID),
        ('mICH-Power', _MICH_Parameters_CTCH_ReconfRqstFDD_mICH_Power),
        ('iE-Extensions', _MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions),
        ])
    MICH_Parameters_CTCH_ReconfRqstFDD._ext = []
    
    #-----< MICH-Parameters-CTCH-ReconfRqstFDD-ExtIEs >-----#
    MICH_Parameters_CTCH_ReconfRqstFDD_ExtIEs = CLASS(name='MICH-Parameters-CTCH-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MICH_Parameters_CTCH_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCH-Parameters-CTCH-ReconfRqstFDD >-----#
    BCH_Parameters_CTCH_ReconfRqstFDD = SEQ(name='BCH-Parameters-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _BCH_Parameters_CTCH_ReconfRqstFDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _BCH_Parameters_CTCH_ReconfRqstFDD_bCH_Power = INT(name='bCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions._cont = __BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item_
    _BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCH_Parameters_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('commonTransportChannelID', _BCH_Parameters_CTCH_ReconfRqstFDD_commonTransportChannelID),
        ('bCH-Power', _BCH_Parameters_CTCH_ReconfRqstFDD_bCH_Power),
        ('iE-Extensions', _BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions),
        ])
    BCH_Parameters_CTCH_ReconfRqstFDD._ext = []
    
    #-----< BCH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs >-----#
    BCH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs = CLASS(name='BCH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BCH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRACHList-CTCH-ReconfRqstFDD >-----#
    PRACHList_CTCH_ReconfRqstFDD = SEQ(name='PRACHList-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _PRACHList_CTCH_ReconfRqstFDD_pRACH_ParametersList_CTCH_ReconfRqstFDD = SEQ(name='pRACH-ParametersList-CTCH-ReconfRqstFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-ParametersList-CTCH-ReconfRqstFDD')), opt=True)
    _PRACHList_CTCH_ReconfRqstFDD_aICH_ParametersList_CTCH_ReconfRqstFDD = SEQ(name='aICH-ParametersList-CTCH-ReconfRqstFDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'AICH-ParametersList-CTCH-ReconfRqstFDD')), opt=True)
    _PRACHList_CTCH_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _PRACHList_CTCH_ReconfRqstFDD_iE_Extensions._cont = __PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item_
    _PRACHList_CTCH_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRACHList_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('pRACH-ParametersList-CTCH-ReconfRqstFDD', _PRACHList_CTCH_ReconfRqstFDD_pRACH_ParametersList_CTCH_ReconfRqstFDD),
        ('aICH-ParametersList-CTCH-ReconfRqstFDD', _PRACHList_CTCH_ReconfRqstFDD_aICH_ParametersList_CTCH_ReconfRqstFDD),
        ('iE-Extensions', _PRACHList_CTCH_ReconfRqstFDD_iE_Extensions),
        ])
    PRACHList_CTCH_ReconfRqstFDD._ext = []
    
    #-----< PRACH-CTCH-ReconfRqstFDD-ExtIEs >-----#
    PRACH_CTCH_ReconfRqstFDD_ExtIEs = CLASS(name='PRACH-CTCH-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PRACH_CTCH_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRACH-ParametersList-CTCH-ReconfRqstFDD >-----#
    PRACH_ParametersList_CTCH_ReconfRqstFDD = SEQ(name='PRACH-ParametersList-CTCH-ReconfRqstFDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PRACH_ParametersList_CTCH_ReconfRqstFDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PRACH_ParametersList_CTCH_ReconfRqstFDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-ParametersListIE-CTCH-ReconfRqstFDD')))
    __PRACH_ParametersList_CTCH_ReconfRqstFDD_id_tab._val = ASN1Set(rv=[dict([('id', 383), ('criticality', 'reject'), ('Value', ___PRACH_ParametersList_CTCH_ReconfRqstFDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_id._const_tab = __PRACH_ParametersList_CTCH_ReconfRqstFDD_id_tab
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_id._const_tab_at = None
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_id._const_tab_id = 'id'
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_criticality._const_tab = __PRACH_ParametersList_CTCH_ReconfRqstFDD_id_tab
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_criticality._const_tab_at = ('..', 'id')
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_criticality._const_tab_id = 'criticality'
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_value._const_tab = __PRACH_ParametersList_CTCH_ReconfRqstFDD_id_tab
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_value._const_tab_at = ('..', 'id')
    _PRACH_ParametersList_CTCH_ReconfRqstFDD_value._const_tab_id = 'Value'
    PRACH_ParametersList_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('id', _PRACH_ParametersList_CTCH_ReconfRqstFDD_id),
        ('criticality', _PRACH_ParametersList_CTCH_ReconfRqstFDD_criticality),
        ('value', _PRACH_ParametersList_CTCH_ReconfRqstFDD_value),
        ])
    PRACH_ParametersList_CTCH_ReconfRqstFDD._ext = None
    
    #-----< PRACH-ParametersListIEs-CTCH-ReconfRqstFDD >-----#
    PRACH_ParametersListIEs_CTCH_ReconfRqstFDD = CLASS(name='PRACH-ParametersListIEs-CTCH-ReconfRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PRACH_ParametersListIEs_CTCH_ReconfRqstFDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-ParametersListIE-CTCH-ReconfRqstFDD')))
    PRACH_ParametersListIEs_CTCH_ReconfRqstFDD._val = ASN1Set(rv=[dict([('id', 383), ('criticality', 'reject'), ('Value', _PRACH_ParametersListIEs_CTCH_ReconfRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PRACH-ParametersListIE-CTCH-ReconfRqstFDD >-----#
    PRACH_ParametersListIE_CTCH_ReconfRqstFDD = SEQ_OF(name='PRACH-ParametersListIE-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _PRACH_ParametersListIE_CTCH_ReconfRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-ParametersItem-CTCH-ReconfRqstFDD')))
    PRACH_ParametersListIE_CTCH_ReconfRqstFDD._cont = _PRACH_ParametersListIE_CTCH_ReconfRqstFDD__item_
    PRACH_ParametersListIE_CTCH_ReconfRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PRACH-ParametersItem-CTCH-ReconfRqstFDD >-----#
    PRACH_ParametersItem_CTCH_ReconfRqstFDD = SEQ(name='PRACH-ParametersItem-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _PRACH_ParametersItem_CTCH_ReconfRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PRACH_ParametersItem_CTCH_ReconfRqstFDD_preambleSignatures = BIT_STR(name='preambleSignatures', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PreambleSignatures')), opt=True)
    _PRACH_ParametersItem_CTCH_ReconfRqstFDD_allowedSlotFormatInformation = SEQ_OF(name='allowedSlotFormatInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'AllowedSlotFormatInformationList-CTCH-ReconfRqstFDD')), opt=True)
    _PRACH_ParametersItem_CTCH_ReconfRqstFDD_rACH_SubChannelNumbers = BIT_STR(name='rACH-SubChannelNumbers', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RACH-SubChannelNumbers')), opt=True)
    _PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions._cont = __PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_
    _PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRACH_ParametersItem_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PRACH_ParametersItem_CTCH_ReconfRqstFDD_commonPhysicalChannelID),
        ('preambleSignatures', _PRACH_ParametersItem_CTCH_ReconfRqstFDD_preambleSignatures),
        ('allowedSlotFormatInformation', _PRACH_ParametersItem_CTCH_ReconfRqstFDD_allowedSlotFormatInformation),
        ('rACH-SubChannelNumbers', _PRACH_ParametersItem_CTCH_ReconfRqstFDD_rACH_SubChannelNumbers),
        ('iE-Extensions', _PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions),
        ])
    PRACH_ParametersItem_CTCH_ReconfRqstFDD._ext = []
    
    #-----< PRACH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs >-----#
    PRACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs = CLASS(name='PRACH-ParametersItem-CTCH-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PRACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    PRACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 616), ('criticality', 'ignore'), ('Extension', _PRACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AllowedSlotFormatInformationList-CTCH-ReconfRqstFDD >-----#
    AllowedSlotFormatInformationList_CTCH_ReconfRqstFDD = SEQ_OF(name='AllowedSlotFormatInformationList-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _AllowedSlotFormatInformationList_CTCH_ReconfRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AllowedSlotFormatInformationItem-CTCH-ReconfRqstFDD')))
    AllowedSlotFormatInformationList_CTCH_ReconfRqstFDD._cont = _AllowedSlotFormatInformationList_CTCH_ReconfRqstFDD__item_
    AllowedSlotFormatInformationList_CTCH_ReconfRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AllowedSlotFormatInformationItem-CTCH-ReconfRqstFDD >-----#
    AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD = SEQ(name='AllowedSlotFormatInformationItem-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_rACH_SlotFormat = ENUM(name='rACH-SlotFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RACH-SlotFormat')))
    _AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions._cont = __AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item_
    _AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('rACH-SlotFormat', _AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_rACH_SlotFormat),
        ('iE-Extensions', _AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions),
        ])
    AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD._ext = []
    
    #-----< AllowedSlotFormatInformationItem-CTCH-ReconfRqstFDD-ExtIEs >-----#
    AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_ExtIEs = CLASS(name='AllowedSlotFormatInformationItem-CTCH-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AICH-ParametersList-CTCH-ReconfRqstFDD >-----#
    AICH_ParametersList_CTCH_ReconfRqstFDD = SEQ(name='AICH-ParametersList-CTCH-ReconfRqstFDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _AICH_ParametersList_CTCH_ReconfRqstFDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __AICH_ParametersList_CTCH_ReconfRqstFDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___AICH_ParametersList_CTCH_ReconfRqstFDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AICH-ParametersListIE-CTCH-ReconfRqstFDD')))
    __AICH_ParametersList_CTCH_ReconfRqstFDD_id_tab._val = ASN1Set(rv=[dict([('id', 316), ('criticality', 'reject'), ('Value', ___AICH_ParametersList_CTCH_ReconfRqstFDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _AICH_ParametersList_CTCH_ReconfRqstFDD_id._const_tab = __AICH_ParametersList_CTCH_ReconfRqstFDD_id_tab
    _AICH_ParametersList_CTCH_ReconfRqstFDD_id._const_tab_at = None
    _AICH_ParametersList_CTCH_ReconfRqstFDD_id._const_tab_id = 'id'
    _AICH_ParametersList_CTCH_ReconfRqstFDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _AICH_ParametersList_CTCH_ReconfRqstFDD_criticality._const_tab = __AICH_ParametersList_CTCH_ReconfRqstFDD_id_tab
    _AICH_ParametersList_CTCH_ReconfRqstFDD_criticality._const_tab_at = ('..', 'id')
    _AICH_ParametersList_CTCH_ReconfRqstFDD_criticality._const_tab_id = 'criticality'
    _AICH_ParametersList_CTCH_ReconfRqstFDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _AICH_ParametersList_CTCH_ReconfRqstFDD_value._const_tab = __AICH_ParametersList_CTCH_ReconfRqstFDD_id_tab
    _AICH_ParametersList_CTCH_ReconfRqstFDD_value._const_tab_at = ('..', 'id')
    _AICH_ParametersList_CTCH_ReconfRqstFDD_value._const_tab_id = 'Value'
    AICH_ParametersList_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('id', _AICH_ParametersList_CTCH_ReconfRqstFDD_id),
        ('criticality', _AICH_ParametersList_CTCH_ReconfRqstFDD_criticality),
        ('value', _AICH_ParametersList_CTCH_ReconfRqstFDD_value),
        ])
    AICH_ParametersList_CTCH_ReconfRqstFDD._ext = None
    
    #-----< AICH-ParametersListIEs-CTCH-ReconfRqstFDD >-----#
    AICH_ParametersListIEs_CTCH_ReconfRqstFDD = CLASS(name='AICH-ParametersListIEs-CTCH-ReconfRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _AICH_ParametersListIEs_CTCH_ReconfRqstFDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AICH-ParametersListIE-CTCH-ReconfRqstFDD')))
    AICH_ParametersListIEs_CTCH_ReconfRqstFDD._val = ASN1Set(rv=[dict([('id', 316), ('criticality', 'reject'), ('Value', _AICH_ParametersListIEs_CTCH_ReconfRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< AICH-ParametersListIE-CTCH-ReconfRqstFDD >-----#
    AICH_ParametersListIE_CTCH_ReconfRqstFDD = SEQ_OF(name='AICH-ParametersListIE-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _AICH_ParametersListIE_CTCH_ReconfRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AICH-ParametersItem-CTCH-ReconfRqstFDD')))
    AICH_ParametersListIE_CTCH_ReconfRqstFDD._cont = _AICH_ParametersListIE_CTCH_ReconfRqstFDD__item_
    AICH_ParametersListIE_CTCH_ReconfRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< AICH-ParametersItem-CTCH-ReconfRqstFDD >-----#
    AICH_ParametersItem_CTCH_ReconfRqstFDD = SEQ(name='AICH-ParametersItem-CTCH-ReconfRqstFDD', mode=MODE_TYPE)
    _AICH_ParametersItem_CTCH_ReconfRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _AICH_ParametersItem_CTCH_ReconfRqstFDD_aICH_Power = INT(name='aICH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AICH-Power')), opt=True)
    _AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions._cont = __AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_
    _AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AICH_ParametersItem_CTCH_ReconfRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _AICH_ParametersItem_CTCH_ReconfRqstFDD_commonPhysicalChannelID),
        ('aICH-Power', _AICH_ParametersItem_CTCH_ReconfRqstFDD_aICH_Power),
        ('iE-Extensions', _AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions),
        ])
    AICH_ParametersItem_CTCH_ReconfRqstFDD._ext = []
    
    #-----< AICH-ParametersItemIE-CTCH-ReconfRqstFDD-ExtIEs >-----#
    AICH_ParametersItemIE_CTCH_ReconfRqstFDD_ExtIEs = CLASS(name='AICH-ParametersItemIE-CTCH-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    AICH_ParametersItemIE_CTCH_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelReconfigurationRequestTDD >-----#
    CommonTransportChannelReconfigurationRequestTDD = SEQ(name='CommonTransportChannelReconfigurationRequestTDD', mode=MODE_TYPE)
    _CommonTransportChannelReconfigurationRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-Parameters-CTCH-ReconfRqstTDD')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-Parameters-CTCH-ReconfRqstTDD')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersList-CTCH-ReconfRqstTDD')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-Parameters-CTCH-ReconfRqstTDD')))
    ____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 259), ('criticality', 'reject'), ('Value', _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 168), ('criticality', 'reject'), ('Value', _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 120), ('criticality', 'reject'), ('Value', _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'reject'), ('Value', _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id._const_tab = ____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__value._const_tab = ____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id),
        ('criticality', ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__criticality),
        ('value', ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__value),
        ])
    __CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item_._ext = None
    _CommonTransportChannelReconfigurationRequestTDD_protocolIEs._cont = __CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item_
    _CommonTransportChannelReconfigurationRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelReconfigurationRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FPACH-LCR-Parameters-CTCH-ReconfRqstTDD')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-Parameters-CTCH-ReconfRqstTDD')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PLCCH-Parameters-CTCH-ReconfRqstTDD')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-768-Parameters-CTCH-ReconfRqstTDD')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-768-Parameters-CTCH-ReconfRqstTDD')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-768-Parameters-CTCH-ReconfRqstTDD')))
    _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD')))
    ____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 314), ('criticality', 'reject'), ('Extension', _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 641), ('criticality', 'reject'), ('Extension', _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 717), ('criticality', 'ignore'), ('Extension', _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 721), ('criticality', 'reject'), ('Extension', _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 722), ('criticality', 'reject'), ('Extension', _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 723), ('criticality', 'reject'), ('Extension', _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 920), ('criticality', 'reject'), ('Extension', _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id._const_tab = ____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id),
        ('criticality', ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item_._ext = None
    _CommonTransportChannelReconfigurationRequestTDD_protocolExtensions._cont = __CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item_
    _CommonTransportChannelReconfigurationRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelReconfigurationRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _CommonTransportChannelReconfigurationRequestTDD_protocolIEs),
        ('protocolExtensions', _CommonTransportChannelReconfigurationRequestTDD_protocolExtensions),
        ])
    CommonTransportChannelReconfigurationRequestTDD._ext = []
    
    #-----< CommonTransportChannelReconfigurationRequestTDD-IEs >-----#
    CommonTransportChannelReconfigurationRequestTDD_IEs = CLASS(name='CommonTransportChannelReconfigurationRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-Parameters-CTCH-ReconfRqstTDD')))
    _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-Parameters-CTCH-ReconfRqstTDD')))
    _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersList-CTCH-ReconfRqstTDD')))
    _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-Parameters-CTCH-ReconfRqstTDD')))
    CommonTransportChannelReconfigurationRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 259), ('criticality', 'reject'), ('Value', _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 168), ('criticality', 'reject'), ('Value', _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 120), ('criticality', 'reject'), ('Value', _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'reject'), ('Value', _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelReconfigurationRequestTDD-Extensions >-----#
    CommonTransportChannelReconfigurationRequestTDD_Extensions = CLASS(name='CommonTransportChannelReconfigurationRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FPACH-LCR-Parameters-CTCH-ReconfRqstTDD')))
    _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-Parameters-CTCH-ReconfRqstTDD')))
    _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PLCCH-Parameters-CTCH-ReconfRqstTDD')))
    _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-768-Parameters-CTCH-ReconfRqstTDD')))
    _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-768-Parameters-CTCH-ReconfRqstTDD')))
    _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MICH-768-Parameters-CTCH-ReconfRqstTDD')))
    _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD')))
    CommonTransportChannelReconfigurationRequestTDD_Extensions._val = ASN1Set(rv=[dict([('id', 314), ('criticality', 'reject'), ('Extension', _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 641), ('criticality', 'reject'), ('Extension', _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 717), ('criticality', 'ignore'), ('Extension', _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 721), ('criticality', 'reject'), ('Extension', _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 722), ('criticality', 'reject'), ('Extension', _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 723), ('criticality', 'reject'), ('Extension', _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 920), ('criticality', 'reject'), ('Extension', _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-Parameters-CTCH-ReconfRqstTDD >-----#
    Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD = SEQ(name='Secondary-CCPCH-Parameters-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_secondaryCCPCHList = SEQ(name='secondaryCCPCHList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCHList-CTCH-ReconfRqstTDD')), opt=True)
    _Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-parameterExtendedList-CTCH-ReconfRqstTDD')))
    _____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-LCR-parameterExtendedList-CTCH-ReconfRqstTDD')))
    ____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 633), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 635), ('criticality', 'reject'), ('Extension', _____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._cont = __Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_cCTrCH_ID),
        ('secondaryCCPCHList', _Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_secondaryCCPCHList),
        ('iE-Extensions', _Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD._ext = []
    
    #-----< Secondary-CCPCH-CTCH-ReconfRqstTDD-ExtIEs >-----#
    Secondary_CCPCH_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='Secondary-CCPCH-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Secondary_CCPCH_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-parameterExtendedList-CTCH-ReconfRqstTDD')))
    _Secondary_CCPCH_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-LCR-parameterExtendedList-CTCH-ReconfRqstTDD')))
    Secondary_CCPCH_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 633), ('criticality', 'reject'), ('Extension', _Secondary_CCPCH_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 635), ('criticality', 'reject'), ('Extension', _Secondary_CCPCH_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCHList-CTCH-ReconfRqstTDD >-----#
    Secondary_CCPCHList_CTCH_ReconfRqstTDD = SEQ(name='Secondary-CCPCHList-CTCH-ReconfRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Secondary_CCPCHList_CTCH_ReconfRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Secondary_CCPCHList_CTCH_ReconfRqstTDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCHListIE-CTCH-ReconfRqstTDD')))
    __Secondary_CCPCHList_CTCH_ReconfRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 257), ('criticality', 'reject'), ('Value', ___Secondary_CCPCHList_CTCH_ReconfRqstTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_id._const_tab = __Secondary_CCPCHList_CTCH_ReconfRqstTDD_id_tab
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_id._const_tab_at = None
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_id._const_tab_id = 'id'
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_criticality._const_tab = __Secondary_CCPCHList_CTCH_ReconfRqstTDD_id_tab
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_criticality._const_tab_at = ('..', 'id')
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_criticality._const_tab_id = 'criticality'
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_value._const_tab = __Secondary_CCPCHList_CTCH_ReconfRqstTDD_id_tab
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_value._const_tab_at = ('..', 'id')
    _Secondary_CCPCHList_CTCH_ReconfRqstTDD_value._const_tab_id = 'Value'
    Secondary_CCPCHList_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('id', _Secondary_CCPCHList_CTCH_ReconfRqstTDD_id),
        ('criticality', _Secondary_CCPCHList_CTCH_ReconfRqstTDD_criticality),
        ('value', _Secondary_CCPCHList_CTCH_ReconfRqstTDD_value),
        ])
    Secondary_CCPCHList_CTCH_ReconfRqstTDD._ext = None
    
    #-----< Secondary-CCPCHListIEs-CTCH-ReconfRqstTDD >-----#
    Secondary_CCPCHListIEs_CTCH_ReconfRqstTDD = CLASS(name='Secondary-CCPCHListIEs-CTCH-ReconfRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Secondary_CCPCHListIEs_CTCH_ReconfRqstTDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCHListIE-CTCH-ReconfRqstTDD')))
    Secondary_CCPCHListIEs_CTCH_ReconfRqstTDD._val = ASN1Set(rv=[dict([('id', 257), ('criticality', 'reject'), ('Value', _Secondary_CCPCHListIEs_CTCH_ReconfRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Secondary-CCPCHListIE-CTCH-ReconfRqstTDD >-----#
    Secondary_CCPCHListIE_CTCH_ReconfRqstTDD = SEQ_OF(name='Secondary-CCPCHListIE-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCHListIE_CTCH_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCHItem-CTCH-ReconfRqstTDD')))
    Secondary_CCPCHListIE_CTCH_ReconfRqstTDD._cont = _Secondary_CCPCHListIE_CTCH_ReconfRqstTDD__item_
    Secondary_CCPCHListIE_CTCH_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Secondary-CCPCHItem-CTCH-ReconfRqstTDD >-----#
    Secondary_CCPCHItem_CTCH_ReconfRqstTDD = SEQ(name='Secondary-CCPCHItem-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCHItem_CTCH_ReconfRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _Secondary_CCPCHItem_CTCH_ReconfRqstTDD_sCCPCH_Power = INT(name='sCCPCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions._cont = __Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCHItem_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _Secondary_CCPCHItem_CTCH_ReconfRqstTDD_commonPhysicalChannelID),
        ('sCCPCH-Power', _Secondary_CCPCHItem_CTCH_ReconfRqstTDD_sCCPCH_Power),
        ('iE-Extensions', _Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    Secondary_CCPCHItem_CTCH_ReconfRqstTDD._ext = []
    
    #-----< Secondary-CCPCHItem-CTCH-ReconfRqstTDD-ExtIEs >-----#
    Secondary_CCPCHItem_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='Secondary-CCPCHItem-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Secondary_CCPCHItem_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-parameterExtendedList-CTCH-ReconfRqstTDD >-----#
    Secondary_CCPCH_parameterExtendedList_CTCH_ReconfRqstTDD = SEQ_OF(name='Secondary-CCPCH-parameterExtendedList-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_parameterExtendedList_CTCH_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCHItem-CTCH-ReconfRqstTDD')))
    Secondary_CCPCH_parameterExtendedList_CTCH_ReconfRqstTDD._cont = _Secondary_CCPCH_parameterExtendedList_CTCH_ReconfRqstTDD__item_
    Secondary_CCPCH_parameterExtendedList_CTCH_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=232)], ev=None, er=[])
    
    #-----< Secondary-CCPCH-LCR-parameterExtendedList-CTCH-ReconfRqstTDD >-----#
    Secondary_CCPCH_LCR_parameterExtendedList_CTCH_ReconfRqstTDD = SEQ_OF(name='Secondary-CCPCH-LCR-parameterExtendedList-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_LCR_parameterExtendedList_CTCH_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCHItem-CTCH-ReconfRqstTDD')))
    Secondary_CCPCH_LCR_parameterExtendedList_CTCH_ReconfRqstTDD._cont = _Secondary_CCPCH_LCR_parameterExtendedList_CTCH_ReconfRqstTDD__item_
    Secondary_CCPCH_LCR_parameterExtendedList_CTCH_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=88)], ev=None, er=[])
    
    #-----< PICH-Parameters-CTCH-ReconfRqstTDD >-----#
    PICH_Parameters_CTCH_ReconfRqstTDD = SEQ(name='PICH-Parameters-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _PICH_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PICH_Parameters_CTCH_ReconfRqstTDD_pICH_Power = INT(name='pICH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')), opt=True)
    _PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._cont = __PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PICH_Parameters_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PICH_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID),
        ('pICH-Power', _PICH_Parameters_CTCH_ReconfRqstTDD_pICH_Power),
        ('iE-Extensions', _PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    PICH_Parameters_CTCH_ReconfRqstTDD._ext = []
    
    #-----< PICH-Parameters-CTCH-ReconfRqstTDD-ExtIEs >-----#
    PICH_Parameters_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='PICH-Parameters-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PICH_Parameters_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FACH-ParametersList-CTCH-ReconfRqstTDD >-----#
    FACH_ParametersList_CTCH_ReconfRqstTDD = SEQ_OF(name='FACH-ParametersList-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _FACH_ParametersList_CTCH_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-ParametersItem-CTCH-ReconfRqstTDD')))
    FACH_ParametersList_CTCH_ReconfRqstTDD._cont = _FACH_ParametersList_CTCH_ReconfRqstTDD__item_
    FACH_ParametersList_CTCH_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< FACH-ParametersItem-CTCH-ReconfRqstTDD >-----#
    FACH_ParametersItem_CTCH_ReconfRqstTDD = SEQ(name='FACH-ParametersItem-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _FACH_ParametersItem_CTCH_ReconfRqstTDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _FACH_ParametersItem_CTCH_ReconfRqstTDD_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')), opt=True)
    _FACH_ParametersItem_CTCH_ReconfRqstTDD_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')), opt=True)
    _FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 174), ('criticality', 'reject'), ('Extension', _____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions._cont = __FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FACH_ParametersItem_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('commonTransportChannelID', _FACH_ParametersItem_CTCH_ReconfRqstTDD_commonTransportChannelID),
        ('toAWS', _FACH_ParametersItem_CTCH_ReconfRqstTDD_toAWS),
        ('toAWE', _FACH_ParametersItem_CTCH_ReconfRqstTDD_toAWE),
        ('iE-Extensions', _FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    FACH_ParametersItem_CTCH_ReconfRqstTDD._ext = []
    
    #-----< FACH-ParametersItem-CTCH-ReconfRqstTDD-ExtIEs >-----#
    FACH_ParametersItem_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='FACH-ParametersItem-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _FACH_ParametersItem_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _FACH_ParametersItem_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    FACH_ParametersItem_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 174), ('criticality', 'reject'), ('Extension', _FACH_ParametersItem_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _FACH_ParametersItem_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PCH-Parameters-CTCH-ReconfRqstTDD >-----#
    PCH_Parameters_CTCH_ReconfRqstTDD = SEQ(name='PCH-Parameters-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _PCH_Parameters_CTCH_ReconfRqstTDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _PCH_Parameters_CTCH_ReconfRqstTDD_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')), opt=True)
    _PCH_Parameters_CTCH_ReconfRqstTDD_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')), opt=True)
    _PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 458), ('criticality', 'reject'), ('Extension', _____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._cont = __PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PCH_Parameters_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('commonTransportChannelID', _PCH_Parameters_CTCH_ReconfRqstTDD_commonTransportChannelID),
        ('toAWS', _PCH_Parameters_CTCH_ReconfRqstTDD_toAWS),
        ('toAWE', _PCH_Parameters_CTCH_ReconfRqstTDD_toAWE),
        ('iE-Extensions', _PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    PCH_Parameters_CTCH_ReconfRqstTDD._ext = []
    
    #-----< PCH-Parameters-CTCH-ReconfRqstTDD-ExtIEs >-----#
    PCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='PCH-Parameters-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _PCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    PCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 458), ('criticality', 'reject'), ('Extension', _PCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _PCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< FPACH-LCR-Parameters-CTCH-ReconfRqstTDD >-----#
    FPACH_LCR_Parameters_CTCH_ReconfRqstTDD = SEQ(name='FPACH-LCR-Parameters-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelId = INT(name='commonPhysicalChannelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_fPACHPower = INT(name='fPACHPower', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FPACH-Power')), opt=True)
    _FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._cont = __FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FPACH_LCR_Parameters_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelId', _FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelId),
        ('fPACHPower', _FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_fPACHPower),
        ('iE-Extensions', _FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    FPACH_LCR_Parameters_CTCH_ReconfRqstTDD._ext = []
    
    #-----< FPACH-LCR-Parameters-CTCH-ReconfRqstTDD-ExtIEs >-----#
    FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='FPACH-LCR-Parameters-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MICH-Parameters-CTCH-ReconfRqstTDD >-----#
    MICH_Parameters_CTCH_ReconfRqstTDD = SEQ(name='MICH-Parameters-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _MICH_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _MICH_Parameters_CTCH_ReconfRqstTDD_mICH_Power = INT(name='mICH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')), opt=True)
    _MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._cont = __MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MICH_Parameters_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _MICH_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID),
        ('mICH-Power', _MICH_Parameters_CTCH_ReconfRqstTDD_mICH_Power),
        ('iE-Extensions', _MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    MICH_Parameters_CTCH_ReconfRqstTDD._ext = []
    
    #-----< MICH-Parameters-CTCH-ReconfRqstTDD-ExtIEs >-----#
    MICH_Parameters_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='MICH-Parameters-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MICH_Parameters_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PLCCH-Parameters-CTCH-ReconfRqstTDD >-----#
    PLCCH_Parameters_CTCH_ReconfRqstTDD = SEQ(name='PLCCH-Parameters-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _PLCCH_Parameters_CTCH_ReconfRqstTDD_maxPowerPLCCH = INT(name='maxPowerPLCCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._cont = __PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLCCH_Parameters_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('maxPowerPLCCH', _PLCCH_Parameters_CTCH_ReconfRqstTDD_maxPowerPLCCH),
        ('iE-Extensions', _PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    PLCCH_Parameters_CTCH_ReconfRqstTDD._ext = []
    
    #-----< PLCCH-Parameters-CTCH-ReconfRqstTDD-ExtIEs >-----#
    PLCCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='PLCCH-Parameters-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PLCCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-768-Parameters-CTCH-ReconfRqstTDD >-----#
    Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD = SEQ(name='Secondary-CCPCH-768-Parameters-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_secondaryCCPCH768List = SEQ_OF(name='secondaryCCPCH768List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-768-List-CTCH-ReconfRqstTDD')), opt=True)
    _Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._cont = __Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_cCTrCH_ID),
        ('secondaryCCPCH768List', _Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_secondaryCCPCH768List),
        ('iE-Extensions', _Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD._ext = []
    
    #-----< Secondary-CCPCH-768-CTCH-ReconfRqstTDD-ExtIEs >-----#
    Secondary_CCPCH_768_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='Secondary-CCPCH-768-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Secondary_CCPCH_768_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-768-List-CTCH-ReconfRqstTDD >-----#
    Secondary_CCPCH_768_List_CTCH_ReconfRqstTDD = SEQ_OF(name='Secondary-CCPCH-768-List-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_768_List_CTCH_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Secondary-CCPCH-768-Item-CTCH-ReconfRqstTDD')))
    Secondary_CCPCH_768_List_CTCH_ReconfRqstTDD._cont = _Secondary_CCPCH_768_List_CTCH_ReconfRqstTDD__item_
    Secondary_CCPCH_768_List_CTCH_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=480)], ev=None, er=[])
    
    #-----< Secondary-CCPCH-768-Item-CTCH-ReconfRqstTDD >-----#
    Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD = SEQ(name='Secondary-CCPCH-768-Item-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_sCCPCH_Power = INT(name='sCCPCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions._cont = __Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_commonPhysicalChannelID768),
        ('sCCPCH-Power', _Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_sCCPCH_Power),
        ('iE-Extensions', _Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD._ext = []
    
    #-----< Secondary-CCPCH-768-Item-CTCH-ReconfRqstTDD-ExtIEs >-----#
    Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='Secondary-CCPCH-768-Item-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PICH-768-Parameters-CTCH-ReconfRqstTDD >-----#
    PICH_768_Parameters_CTCH_ReconfRqstTDD = SEQ(name='PICH-768-Parameters-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _PICH_768_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _PICH_768_Parameters_CTCH_ReconfRqstTDD_pICH_Power = INT(name='pICH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')), opt=True)
    _PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._cont = __PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PICH_768_Parameters_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _PICH_768_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID768),
        ('pICH-Power', _PICH_768_Parameters_CTCH_ReconfRqstTDD_pICH_Power),
        ('iE-Extensions', _PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    PICH_768_Parameters_CTCH_ReconfRqstTDD._ext = []
    
    #-----< PICH-768-Parameters-CTCH-ReconfRqstTDD-ExtIEs >-----#
    PICH_768_Parameters_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='PICH-768-Parameters-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PICH_768_Parameters_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MICH-768-Parameters-CTCH-ReconfRqstTDD >-----#
    MICH_768_Parameters_CTCH_ReconfRqstTDD = SEQ(name='MICH-768-Parameters-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _MICH_768_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _MICH_768_Parameters_CTCH_ReconfRqstTDD_mICH_Power = INT(name='mICH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PICH-Power')), opt=True)
    _MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._cont = __MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MICH_768_Parameters_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _MICH_768_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID768),
        ('mICH-Power', _MICH_768_Parameters_CTCH_ReconfRqstTDD_mICH_Power),
        ('iE-Extensions', _MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    MICH_768_Parameters_CTCH_ReconfRqstTDD._ext = []
    
    #-----< MICH-768-Parameters-CTCH-ReconfRqstTDD-ExtIEs >-----#
    MICH_768_Parameters_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='MICH-768-Parameters-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MICH_768_Parameters_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD >-----#
    UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD = SEQ(name='UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD', mode=MODE_TYPE)
    _UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_uPPCHPositionLCR = INT(name='uPPCHPositionLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UPPCHPositionLCR')), opt=True)
    _UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')), opt=True)
    _UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._cont = __UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_
    _UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD._cont = ASN1Dict([
        ('uPPCHPositionLCR', _UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_uPPCHPositionLCR),
        ('uARFCN', _UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_uARFCN),
        ('iE-Extensions', _UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions),
        ])
    UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD._ext = []
    
    #-----< UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD-ExtIEs >-----#
    UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_ExtIEs = CLASS(name='UPPCH-LCR-Parameters-CTCH-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelReconfigurationResponse >-----#
    CommonTransportChannelReconfigurationResponse = SEQ(name='CommonTransportChannelReconfigurationResponse', mode=MODE_TYPE)
    _CommonTransportChannelReconfigurationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelReconfigurationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonTransportChannelReconfigurationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonTransportChannelReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CommonTransportChannelReconfigurationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__id._const_tab = ____CommonTransportChannelReconfigurationResponse_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelReconfigurationResponse_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__value._const_tab = ____CommonTransportChannelReconfigurationResponse_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonTransportChannelReconfigurationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__id),
        ('criticality', ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__criticality),
        ('value', ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__value),
        ])
    __CommonTransportChannelReconfigurationResponse_protocolIEs__item_._ext = None
    _CommonTransportChannelReconfigurationResponse_protocolIEs._cont = __CommonTransportChannelReconfigurationResponse_protocolIEs__item_
    _CommonTransportChannelReconfigurationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelReconfigurationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelReconfigurationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__id._const_tab = ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__id_tab
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__criticality_tab
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__extensionValue_tab
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonTransportChannelReconfigurationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__id),
        ('criticality', ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelReconfigurationResponse_protocolExtensions__item_._ext = None
    _CommonTransportChannelReconfigurationResponse_protocolExtensions._cont = __CommonTransportChannelReconfigurationResponse_protocolExtensions__item_
    _CommonTransportChannelReconfigurationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelReconfigurationResponse._cont = ASN1Dict([
        ('protocolIEs', _CommonTransportChannelReconfigurationResponse_protocolIEs),
        ('protocolExtensions', _CommonTransportChannelReconfigurationResponse_protocolExtensions),
        ])
    CommonTransportChannelReconfigurationResponse._ext = []
    
    #-----< CommonTransportChannelReconfigurationResponse-IEs >-----#
    CommonTransportChannelReconfigurationResponse_IEs = CLASS(name='CommonTransportChannelReconfigurationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonTransportChannelReconfigurationResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CommonTransportChannelReconfigurationResponse_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _CommonTransportChannelReconfigurationResponse_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelReconfigurationResponse-Extensions >-----#
    CommonTransportChannelReconfigurationResponse_Extensions = CLASS(name='CommonTransportChannelReconfigurationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonTransportChannelReconfigurationResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelReconfigurationFailure >-----#
    CommonTransportChannelReconfigurationFailure = SEQ(name='CommonTransportChannelReconfigurationFailure', mode=MODE_TYPE)
    _CommonTransportChannelReconfigurationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelReconfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__id._const_tab = ____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__value._const_tab = ____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonTransportChannelReconfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__id),
        ('criticality', ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__criticality),
        ('value', ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__value),
        ])
    __CommonTransportChannelReconfigurationFailure_protocolIEs__item_._ext = None
    _CommonTransportChannelReconfigurationFailure_protocolIEs._cont = __CommonTransportChannelReconfigurationFailure_protocolIEs__item_
    _CommonTransportChannelReconfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelReconfigurationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelReconfigurationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__id._const_tab = ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__id_tab
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__criticality_tab
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__extensionValue_tab
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonTransportChannelReconfigurationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__id),
        ('criticality', ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelReconfigurationFailure_protocolExtensions__item_._ext = None
    _CommonTransportChannelReconfigurationFailure_protocolExtensions._cont = __CommonTransportChannelReconfigurationFailure_protocolExtensions__item_
    _CommonTransportChannelReconfigurationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelReconfigurationFailure._cont = ASN1Dict([
        ('protocolIEs', _CommonTransportChannelReconfigurationFailure_protocolIEs),
        ('protocolExtensions', _CommonTransportChannelReconfigurationFailure_protocolExtensions),
        ])
    CommonTransportChannelReconfigurationFailure._ext = []
    
    #-----< CommonTransportChannelReconfigurationFailure-IEs >-----#
    CommonTransportChannelReconfigurationFailure_IEs = CLASS(name='CommonTransportChannelReconfigurationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonTransportChannelReconfigurationFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _CommonTransportChannelReconfigurationFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CommonTransportChannelReconfigurationFailure_IEs._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _CommonTransportChannelReconfigurationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _CommonTransportChannelReconfigurationFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelReconfigurationFailure-Extensions >-----#
    CommonTransportChannelReconfigurationFailure_Extensions = CLASS(name='CommonTransportChannelReconfigurationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonTransportChannelReconfigurationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelDeletionRequest >-----#
    CommonTransportChannelDeletionRequest = SEQ(name='CommonTransportChannelDeletionRequest', mode=MODE_TYPE)
    _CommonTransportChannelDeletionRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelDeletionRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    ____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 35), ('criticality', 'reject'), ('Value', _____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__id._const_tab = ____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__value._const_tab = ____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonTransportChannelDeletionRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonTransportChannelDeletionRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelDeletionRequest_protocolIEs__item__id),
        ('criticality', ___CommonTransportChannelDeletionRequest_protocolIEs__item__criticality),
        ('value', ___CommonTransportChannelDeletionRequest_protocolIEs__item__value),
        ])
    __CommonTransportChannelDeletionRequest_protocolIEs__item_._ext = None
    _CommonTransportChannelDeletionRequest_protocolIEs._cont = __CommonTransportChannelDeletionRequest_protocolIEs__item_
    _CommonTransportChannelDeletionRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelDeletionRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelDeletionRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonTransportChannelDeletionRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CommonTransportChannelDeletionRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    ____CommonTransportChannelDeletionRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 724), ('criticality', 'reject'), ('Extension', _____CommonTransportChannelDeletionRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__id._const_tab = ____CommonTransportChannelDeletionRequest_protocolExtensions__item__id_tab
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelDeletionRequest_protocolExtensions__item__id_tab
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelDeletionRequest_protocolExtensions__item__id_tab
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonTransportChannelDeletionRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonTransportChannelDeletionRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelDeletionRequest_protocolExtensions__item__id),
        ('criticality', ___CommonTransportChannelDeletionRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonTransportChannelDeletionRequest_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelDeletionRequest_protocolExtensions__item_._ext = None
    _CommonTransportChannelDeletionRequest_protocolExtensions._cont = __CommonTransportChannelDeletionRequest_protocolExtensions__item_
    _CommonTransportChannelDeletionRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelDeletionRequest._cont = ASN1Dict([
        ('protocolIEs', _CommonTransportChannelDeletionRequest_protocolIEs),
        ('protocolExtensions', _CommonTransportChannelDeletionRequest_protocolExtensions),
        ])
    CommonTransportChannelDeletionRequest._ext = []
    
    #-----< CommonTransportChannelDeletionRequest-IEs >-----#
    CommonTransportChannelDeletionRequest_IEs = CLASS(name='CommonTransportChannelDeletionRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonTransportChannelDeletionRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CommonTransportChannelDeletionRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _CommonTransportChannelDeletionRequest_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    CommonTransportChannelDeletionRequest_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _CommonTransportChannelDeletionRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 35), ('criticality', 'reject'), ('Value', _CommonTransportChannelDeletionRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _CommonTransportChannelDeletionRequest_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelDeletionRequest-Extensions >-----#
    CommonTransportChannelDeletionRequest_Extensions = CLASS(name='CommonTransportChannelDeletionRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CommonTransportChannelDeletionRequest_Extensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    CommonTransportChannelDeletionRequest_Extensions._val = ASN1Set(rv=[dict([('id', 724), ('criticality', 'reject'), ('Extension', _CommonTransportChannelDeletionRequest_Extensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelDeletionResponse >-----#
    CommonTransportChannelDeletionResponse = SEQ(name='CommonTransportChannelDeletionResponse', mode=MODE_TYPE)
    _CommonTransportChannelDeletionResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelDeletionResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonTransportChannelDeletionResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonTransportChannelDeletionResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CommonTransportChannelDeletionResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CommonTransportChannelDeletionResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__id._const_tab = ____CommonTransportChannelDeletionResponse_protocolIEs__item__id_tab
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelDeletionResponse_protocolIEs__item__id_tab
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__value._const_tab = ____CommonTransportChannelDeletionResponse_protocolIEs__item__id_tab
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonTransportChannelDeletionResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonTransportChannelDeletionResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelDeletionResponse_protocolIEs__item__id),
        ('criticality', ___CommonTransportChannelDeletionResponse_protocolIEs__item__criticality),
        ('value', ___CommonTransportChannelDeletionResponse_protocolIEs__item__value),
        ])
    __CommonTransportChannelDeletionResponse_protocolIEs__item_._ext = None
    _CommonTransportChannelDeletionResponse_protocolIEs._cont = __CommonTransportChannelDeletionResponse_protocolIEs__item_
    _CommonTransportChannelDeletionResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelDeletionResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelDeletionResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonTransportChannelDeletionResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelDeletionResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__id._const_tab = ____CommonTransportChannelDeletionResponse_protocolExtensions__item__id_tab
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonTransportChannelDeletionResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelDeletionResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelDeletionResponse_protocolExtensions__item__criticality_tab
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonTransportChannelDeletionResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelDeletionResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelDeletionResponse_protocolExtensions__item__extensionValue_tab
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonTransportChannelDeletionResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonTransportChannelDeletionResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonTransportChannelDeletionResponse_protocolExtensions__item__id),
        ('criticality', ___CommonTransportChannelDeletionResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonTransportChannelDeletionResponse_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelDeletionResponse_protocolExtensions__item_._ext = None
    _CommonTransportChannelDeletionResponse_protocolExtensions._cont = __CommonTransportChannelDeletionResponse_protocolExtensions__item_
    _CommonTransportChannelDeletionResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelDeletionResponse._cont = ASN1Dict([
        ('protocolIEs', _CommonTransportChannelDeletionResponse_protocolIEs),
        ('protocolExtensions', _CommonTransportChannelDeletionResponse_protocolExtensions),
        ])
    CommonTransportChannelDeletionResponse._ext = []
    
    #-----< CommonTransportChannelDeletionResponse-IEs >-----#
    CommonTransportChannelDeletionResponse_IEs = CLASS(name='CommonTransportChannelDeletionResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonTransportChannelDeletionResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CommonTransportChannelDeletionResponse_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _CommonTransportChannelDeletionResponse_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelDeletionResponse-Extensions >-----#
    CommonTransportChannelDeletionResponse_Extensions = CLASS(name='CommonTransportChannelDeletionResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonTransportChannelDeletionResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BlockResourceRequest >-----#
    BlockResourceRequest = SEQ(name='BlockResourceRequest', mode=MODE_TYPE)
    _BlockResourceRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __BlockResourceRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___BlockResourceRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____BlockResourceRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____BlockResourceRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____BlockResourceRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BlockingPriorityIndicator')))
    _____BlockResourceRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ShutdownTimer')))
    ____BlockResourceRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____BlockResourceRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _____BlockResourceRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 269), ('criticality', 'reject'), ('Value', _____BlockResourceRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___BlockResourceRequest_protocolIEs__item__id._const_tab = ____BlockResourceRequest_protocolIEs__item__id_tab
    ___BlockResourceRequest_protocolIEs__item__id._const_tab_at = None
    ___BlockResourceRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BlockResourceRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___BlockResourceRequest_protocolIEs__item__criticality._const_tab = ____BlockResourceRequest_protocolIEs__item__id_tab
    ___BlockResourceRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BlockResourceRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BlockResourceRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___BlockResourceRequest_protocolIEs__item__value._const_tab = ____BlockResourceRequest_protocolIEs__item__id_tab
    ___BlockResourceRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BlockResourceRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BlockResourceRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BlockResourceRequest_protocolIEs__item__id),
        ('criticality', ___BlockResourceRequest_protocolIEs__item__criticality),
        ('value', ___BlockResourceRequest_protocolIEs__item__value),
        ])
    __BlockResourceRequest_protocolIEs__item_._ext = None
    _BlockResourceRequest_protocolIEs._cont = __BlockResourceRequest_protocolIEs__item_
    _BlockResourceRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _BlockResourceRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BlockResourceRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BlockResourceRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BlockResourceRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BlockResourceRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BlockResourceRequest_protocolExtensions__item__id._const_tab = ____BlockResourceRequest_protocolExtensions__item__id_tab
    ___BlockResourceRequest_protocolExtensions__item__id._const_tab_at = None
    ___BlockResourceRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___BlockResourceRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BlockResourceRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BlockResourceRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BlockResourceRequest_protocolExtensions__item__criticality._const_tab = ____BlockResourceRequest_protocolExtensions__item__criticality_tab
    ___BlockResourceRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___BlockResourceRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___BlockResourceRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BlockResourceRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BlockResourceRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BlockResourceRequest_protocolExtensions__item__extensionValue._const_tab = ____BlockResourceRequest_protocolExtensions__item__extensionValue_tab
    ___BlockResourceRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BlockResourceRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __BlockResourceRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___BlockResourceRequest_protocolExtensions__item__id),
        ('criticality', ___BlockResourceRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___BlockResourceRequest_protocolExtensions__item__extensionValue),
        ])
    __BlockResourceRequest_protocolExtensions__item_._ext = None
    _BlockResourceRequest_protocolExtensions._cont = __BlockResourceRequest_protocolExtensions__item_
    _BlockResourceRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BlockResourceRequest._cont = ASN1Dict([
        ('protocolIEs', _BlockResourceRequest_protocolIEs),
        ('protocolExtensions', _BlockResourceRequest_protocolExtensions),
        ])
    BlockResourceRequest._ext = []
    
    #-----< BlockResourceRequest-IEs >-----#
    BlockResourceRequest_IEs = CLASS(name='BlockResourceRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _BlockResourceRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _BlockResourceRequest_IEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BlockingPriorityIndicator')))
    _BlockResourceRequest_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ShutdownTimer')))
    BlockResourceRequest_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _BlockResourceRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _BlockResourceRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 269), ('criticality', 'reject'), ('Value', _BlockResourceRequest_IEs_val_Value_2), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< BlockResourceRequest-Extensions >-----#
    BlockResourceRequest_Extensions = CLASS(name='BlockResourceRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BlockResourceRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BlockResourceResponse >-----#
    BlockResourceResponse = SEQ(name='BlockResourceResponse', mode=MODE_TYPE)
    _BlockResourceResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __BlockResourceResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___BlockResourceResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____BlockResourceResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____BlockResourceResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____BlockResourceResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____BlockResourceResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BlockResourceResponse_protocolIEs__item__id._const_tab = ____BlockResourceResponse_protocolIEs__item__id_tab
    ___BlockResourceResponse_protocolIEs__item__id._const_tab_at = None
    ___BlockResourceResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___BlockResourceResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___BlockResourceResponse_protocolIEs__item__criticality._const_tab = ____BlockResourceResponse_protocolIEs__item__id_tab
    ___BlockResourceResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BlockResourceResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BlockResourceResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___BlockResourceResponse_protocolIEs__item__value._const_tab = ____BlockResourceResponse_protocolIEs__item__id_tab
    ___BlockResourceResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BlockResourceResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __BlockResourceResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BlockResourceResponse_protocolIEs__item__id),
        ('criticality', ___BlockResourceResponse_protocolIEs__item__criticality),
        ('value', ___BlockResourceResponse_protocolIEs__item__value),
        ])
    __BlockResourceResponse_protocolIEs__item_._ext = None
    _BlockResourceResponse_protocolIEs._cont = __BlockResourceResponse_protocolIEs__item_
    _BlockResourceResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _BlockResourceResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BlockResourceResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BlockResourceResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BlockResourceResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BlockResourceResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BlockResourceResponse_protocolExtensions__item__id._const_tab = ____BlockResourceResponse_protocolExtensions__item__id_tab
    ___BlockResourceResponse_protocolExtensions__item__id._const_tab_at = None
    ___BlockResourceResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___BlockResourceResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BlockResourceResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BlockResourceResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BlockResourceResponse_protocolExtensions__item__criticality._const_tab = ____BlockResourceResponse_protocolExtensions__item__criticality_tab
    ___BlockResourceResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___BlockResourceResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___BlockResourceResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BlockResourceResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BlockResourceResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BlockResourceResponse_protocolExtensions__item__extensionValue._const_tab = ____BlockResourceResponse_protocolExtensions__item__extensionValue_tab
    ___BlockResourceResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BlockResourceResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __BlockResourceResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___BlockResourceResponse_protocolExtensions__item__id),
        ('criticality', ___BlockResourceResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___BlockResourceResponse_protocolExtensions__item__extensionValue),
        ])
    __BlockResourceResponse_protocolExtensions__item_._ext = None
    _BlockResourceResponse_protocolExtensions._cont = __BlockResourceResponse_protocolExtensions__item_
    _BlockResourceResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BlockResourceResponse._cont = ASN1Dict([
        ('protocolIEs', _BlockResourceResponse_protocolIEs),
        ('protocolExtensions', _BlockResourceResponse_protocolExtensions),
        ])
    BlockResourceResponse._ext = []
    
    #-----< BlockResourceResponse-IEs >-----#
    BlockResourceResponse_IEs = CLASS(name='BlockResourceResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _BlockResourceResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    BlockResourceResponse_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _BlockResourceResponse_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BlockResourceResponse-Extensions >-----#
    BlockResourceResponse_Extensions = CLASS(name='BlockResourceResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BlockResourceResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BlockResourceFailure >-----#
    BlockResourceFailure = SEQ(name='BlockResourceFailure', mode=MODE_TYPE)
    _BlockResourceFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __BlockResourceFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___BlockResourceFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____BlockResourceFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____BlockResourceFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____BlockResourceFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____BlockResourceFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _____BlockResourceFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____BlockResourceFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BlockResourceFailure_protocolIEs__item__id._const_tab = ____BlockResourceFailure_protocolIEs__item__id_tab
    ___BlockResourceFailure_protocolIEs__item__id._const_tab_at = None
    ___BlockResourceFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___BlockResourceFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___BlockResourceFailure_protocolIEs__item__criticality._const_tab = ____BlockResourceFailure_protocolIEs__item__id_tab
    ___BlockResourceFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BlockResourceFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BlockResourceFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___BlockResourceFailure_protocolIEs__item__value._const_tab = ____BlockResourceFailure_protocolIEs__item__id_tab
    ___BlockResourceFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BlockResourceFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __BlockResourceFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BlockResourceFailure_protocolIEs__item__id),
        ('criticality', ___BlockResourceFailure_protocolIEs__item__criticality),
        ('value', ___BlockResourceFailure_protocolIEs__item__value),
        ])
    __BlockResourceFailure_protocolIEs__item_._ext = None
    _BlockResourceFailure_protocolIEs._cont = __BlockResourceFailure_protocolIEs__item_
    _BlockResourceFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _BlockResourceFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BlockResourceFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BlockResourceFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BlockResourceFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BlockResourceFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BlockResourceFailure_protocolExtensions__item__id._const_tab = ____BlockResourceFailure_protocolExtensions__item__id_tab
    ___BlockResourceFailure_protocolExtensions__item__id._const_tab_at = None
    ___BlockResourceFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___BlockResourceFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BlockResourceFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BlockResourceFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BlockResourceFailure_protocolExtensions__item__criticality._const_tab = ____BlockResourceFailure_protocolExtensions__item__criticality_tab
    ___BlockResourceFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___BlockResourceFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___BlockResourceFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BlockResourceFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BlockResourceFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BlockResourceFailure_protocolExtensions__item__extensionValue._const_tab = ____BlockResourceFailure_protocolExtensions__item__extensionValue_tab
    ___BlockResourceFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BlockResourceFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __BlockResourceFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___BlockResourceFailure_protocolExtensions__item__id),
        ('criticality', ___BlockResourceFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___BlockResourceFailure_protocolExtensions__item__extensionValue),
        ])
    __BlockResourceFailure_protocolExtensions__item_._ext = None
    _BlockResourceFailure_protocolExtensions._cont = __BlockResourceFailure_protocolExtensions__item_
    _BlockResourceFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BlockResourceFailure._cont = ASN1Dict([
        ('protocolIEs', _BlockResourceFailure_protocolIEs),
        ('protocolExtensions', _BlockResourceFailure_protocolExtensions),
        ])
    BlockResourceFailure._ext = []
    
    #-----< BlockResourceFailure-IEs >-----#
    BlockResourceFailure_IEs = CLASS(name='BlockResourceFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _BlockResourceFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _BlockResourceFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    BlockResourceFailure_IEs._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _BlockResourceFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _BlockResourceFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BlockResourceFailure-Extensions >-----#
    BlockResourceFailure_Extensions = CLASS(name='BlockResourceFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BlockResourceFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UnblockResourceIndication >-----#
    UnblockResourceIndication = SEQ(name='UnblockResourceIndication', mode=MODE_TYPE)
    _UnblockResourceIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __UnblockResourceIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___UnblockResourceIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____UnblockResourceIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____UnblockResourceIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    ____UnblockResourceIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _____UnblockResourceIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UnblockResourceIndication_protocolIEs__item__id._const_tab = ____UnblockResourceIndication_protocolIEs__item__id_tab
    ___UnblockResourceIndication_protocolIEs__item__id._const_tab_at = None
    ___UnblockResourceIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___UnblockResourceIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___UnblockResourceIndication_protocolIEs__item__criticality._const_tab = ____UnblockResourceIndication_protocolIEs__item__id_tab
    ___UnblockResourceIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UnblockResourceIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UnblockResourceIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___UnblockResourceIndication_protocolIEs__item__value._const_tab = ____UnblockResourceIndication_protocolIEs__item__id_tab
    ___UnblockResourceIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UnblockResourceIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __UnblockResourceIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UnblockResourceIndication_protocolIEs__item__id),
        ('criticality', ___UnblockResourceIndication_protocolIEs__item__criticality),
        ('value', ___UnblockResourceIndication_protocolIEs__item__value),
        ])
    __UnblockResourceIndication_protocolIEs__item_._ext = None
    _UnblockResourceIndication_protocolIEs._cont = __UnblockResourceIndication_protocolIEs__item_
    _UnblockResourceIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UnblockResourceIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UnblockResourceIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UnblockResourceIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UnblockResourceIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UnblockResourceIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnblockResourceIndication_protocolExtensions__item__id._const_tab = ____UnblockResourceIndication_protocolExtensions__item__id_tab
    ___UnblockResourceIndication_protocolExtensions__item__id._const_tab_at = None
    ___UnblockResourceIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___UnblockResourceIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UnblockResourceIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UnblockResourceIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnblockResourceIndication_protocolExtensions__item__criticality._const_tab = ____UnblockResourceIndication_protocolExtensions__item__criticality_tab
    ___UnblockResourceIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UnblockResourceIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UnblockResourceIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UnblockResourceIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UnblockResourceIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnblockResourceIndication_protocolExtensions__item__extensionValue._const_tab = ____UnblockResourceIndication_protocolExtensions__item__extensionValue_tab
    ___UnblockResourceIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UnblockResourceIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UnblockResourceIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UnblockResourceIndication_protocolExtensions__item__id),
        ('criticality', ___UnblockResourceIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___UnblockResourceIndication_protocolExtensions__item__extensionValue),
        ])
    __UnblockResourceIndication_protocolExtensions__item_._ext = None
    _UnblockResourceIndication_protocolExtensions._cont = __UnblockResourceIndication_protocolExtensions__item_
    _UnblockResourceIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UnblockResourceIndication._cont = ASN1Dict([
        ('protocolIEs', _UnblockResourceIndication_protocolIEs),
        ('protocolExtensions', _UnblockResourceIndication_protocolExtensions),
        ])
    UnblockResourceIndication._ext = []
    
    #-----< UnblockResourceIndication-IEs >-----#
    UnblockResourceIndication_IEs = CLASS(name='UnblockResourceIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UnblockResourceIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    UnblockResourceIndication_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _UnblockResourceIndication_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UnblockResourceIndication-Extensions >-----#
    UnblockResourceIndication_Extensions = CLASS(name='UnblockResourceIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UnblockResourceIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AuditRequiredIndication >-----#
    AuditRequiredIndication = SEQ(name='AuditRequiredIndication', mode=MODE_TYPE)
    _AuditRequiredIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __AuditRequiredIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___AuditRequiredIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____AuditRequiredIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____AuditRequiredIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditRequiredIndication_protocolIEs__item__id._const_tab = ____AuditRequiredIndication_protocolIEs__item__id_tab
    ___AuditRequiredIndication_protocolIEs__item__id._const_tab_at = None
    ___AuditRequiredIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___AuditRequiredIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ____AuditRequiredIndication_protocolIEs__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____AuditRequiredIndication_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditRequiredIndication_protocolIEs__item__criticality._const_tab = ____AuditRequiredIndication_protocolIEs__item__criticality_tab
    ___AuditRequiredIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AuditRequiredIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AuditRequiredIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ____AuditRequiredIndication_protocolIEs__item__value_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____AuditRequiredIndication_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditRequiredIndication_protocolIEs__item__value._const_tab = ____AuditRequiredIndication_protocolIEs__item__value_tab
    ___AuditRequiredIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AuditRequiredIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __AuditRequiredIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AuditRequiredIndication_protocolIEs__item__id),
        ('criticality', ___AuditRequiredIndication_protocolIEs__item__criticality),
        ('value', ___AuditRequiredIndication_protocolIEs__item__value),
        ])
    __AuditRequiredIndication_protocolIEs__item_._ext = None
    _AuditRequiredIndication_protocolIEs._cont = __AuditRequiredIndication_protocolIEs__item_
    _AuditRequiredIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _AuditRequiredIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AuditRequiredIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AuditRequiredIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AuditRequiredIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AuditRequiredIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditRequiredIndication_protocolExtensions__item__id._const_tab = ____AuditRequiredIndication_protocolExtensions__item__id_tab
    ___AuditRequiredIndication_protocolExtensions__item__id._const_tab_at = None
    ___AuditRequiredIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___AuditRequiredIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AuditRequiredIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AuditRequiredIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditRequiredIndication_protocolExtensions__item__criticality._const_tab = ____AuditRequiredIndication_protocolExtensions__item__criticality_tab
    ___AuditRequiredIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___AuditRequiredIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___AuditRequiredIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AuditRequiredIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AuditRequiredIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditRequiredIndication_protocolExtensions__item__extensionValue._const_tab = ____AuditRequiredIndication_protocolExtensions__item__extensionValue_tab
    ___AuditRequiredIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AuditRequiredIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __AuditRequiredIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___AuditRequiredIndication_protocolExtensions__item__id),
        ('criticality', ___AuditRequiredIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___AuditRequiredIndication_protocolExtensions__item__extensionValue),
        ])
    __AuditRequiredIndication_protocolExtensions__item_._ext = None
    _AuditRequiredIndication_protocolExtensions._cont = __AuditRequiredIndication_protocolExtensions__item_
    _AuditRequiredIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AuditRequiredIndication._cont = ASN1Dict([
        ('protocolIEs', _AuditRequiredIndication_protocolIEs),
        ('protocolExtensions', _AuditRequiredIndication_protocolExtensions),
        ])
    AuditRequiredIndication._ext = []
    
    #-----< AuditRequiredIndication-IEs >-----#
    AuditRequiredIndication_IEs = CLASS(name='AuditRequiredIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    AuditRequiredIndication_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AuditRequiredIndication-Extensions >-----#
    AuditRequiredIndication_Extensions = CLASS(name='AuditRequiredIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    AuditRequiredIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AuditRequest >-----#
    AuditRequest = SEQ(name='AuditRequest', mode=MODE_TYPE)
    _AuditRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __AuditRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___AuditRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____AuditRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____AuditRequest_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Start-Of-Audit-Sequence-Indicator')))
    ____AuditRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 114), ('criticality', 'reject'), ('Value', _____AuditRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___AuditRequest_protocolIEs__item__id._const_tab = ____AuditRequest_protocolIEs__item__id_tab
    ___AuditRequest_protocolIEs__item__id._const_tab_at = None
    ___AuditRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___AuditRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___AuditRequest_protocolIEs__item__criticality._const_tab = ____AuditRequest_protocolIEs__item__id_tab
    ___AuditRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AuditRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AuditRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___AuditRequest_protocolIEs__item__value._const_tab = ____AuditRequest_protocolIEs__item__id_tab
    ___AuditRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AuditRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __AuditRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AuditRequest_protocolIEs__item__id),
        ('criticality', ___AuditRequest_protocolIEs__item__criticality),
        ('value', ___AuditRequest_protocolIEs__item__value),
        ])
    __AuditRequest_protocolIEs__item_._ext = None
    _AuditRequest_protocolIEs._cont = __AuditRequest_protocolIEs__item_
    _AuditRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _AuditRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AuditRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AuditRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AuditRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AuditRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditRequest_protocolExtensions__item__id._const_tab = ____AuditRequest_protocolExtensions__item__id_tab
    ___AuditRequest_protocolExtensions__item__id._const_tab_at = None
    ___AuditRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___AuditRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AuditRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AuditRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditRequest_protocolExtensions__item__criticality._const_tab = ____AuditRequest_protocolExtensions__item__criticality_tab
    ___AuditRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___AuditRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___AuditRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AuditRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AuditRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditRequest_protocolExtensions__item__extensionValue._const_tab = ____AuditRequest_protocolExtensions__item__extensionValue_tab
    ___AuditRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AuditRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __AuditRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___AuditRequest_protocolExtensions__item__id),
        ('criticality', ___AuditRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___AuditRequest_protocolExtensions__item__extensionValue),
        ])
    __AuditRequest_protocolExtensions__item_._ext = None
    _AuditRequest_protocolExtensions._cont = __AuditRequest_protocolExtensions__item_
    _AuditRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AuditRequest._cont = ASN1Dict([
        ('protocolIEs', _AuditRequest_protocolIEs),
        ('protocolExtensions', _AuditRequest_protocolExtensions),
        ])
    AuditRequest._ext = []
    
    #-----< AuditRequest-IEs >-----#
    AuditRequest_IEs = CLASS(name='AuditRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _AuditRequest_IEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Start-Of-Audit-Sequence-Indicator')))
    AuditRequest_IEs._val = ASN1Set(rv=[dict([('id', 114), ('criticality', 'reject'), ('Value', _AuditRequest_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< AuditRequest-Extensions >-----#
    AuditRequest_Extensions = CLASS(name='AuditRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    AuditRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AuditResponse >-----#
    AuditResponse = SEQ(name='AuditResponse', mode=MODE_TYPE)
    _AuditResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __AuditResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___AuditResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____AuditResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____AuditResponse_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'End-Of-Audit-Sequence-Indicator')))
    _____AuditResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-InformationList-AuditRsp')))
    _____AuditResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCP-InformationList-AuditRsp')))
    _____AuditResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-InformationList-AuditRsp')))
    _____AuditResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-Group-InformationList-AuditRsp')))
    _____AuditResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____AuditResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 113), ('criticality', 'ignore'), ('Value', _____AuditResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____AuditResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____AuditResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 128), ('criticality', 'ignore'), ('Value', _____AuditResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____AuditResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____AuditResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AuditResponse_protocolIEs__item__id._const_tab = ____AuditResponse_protocolIEs__item__id_tab
    ___AuditResponse_protocolIEs__item__id._const_tab_at = None
    ___AuditResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___AuditResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___AuditResponse_protocolIEs__item__criticality._const_tab = ____AuditResponse_protocolIEs__item__id_tab
    ___AuditResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AuditResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AuditResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___AuditResponse_protocolIEs__item__value._const_tab = ____AuditResponse_protocolIEs__item__id_tab
    ___AuditResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AuditResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __AuditResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AuditResponse_protocolIEs__item__id),
        ('criticality', ___AuditResponse_protocolIEs__item__criticality),
        ('value', ___AuditResponse_protocolIEs__item__value),
        ])
    __AuditResponse_protocolIEs__item_._ext = None
    _AuditResponse_protocolIEs._cont = __AuditResponse_protocolIEs__item_
    _AuditResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _AuditResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AuditResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AuditResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AuditResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____AuditResponse_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationList-AuditRsp')))
    ____AuditResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 501), ('criticality', 'ignore'), ('Extension', _____AuditResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AuditResponse_protocolExtensions__item__id._const_tab = ____AuditResponse_protocolExtensions__item__id_tab
    ___AuditResponse_protocolExtensions__item__id._const_tab_at = None
    ___AuditResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___AuditResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___AuditResponse_protocolExtensions__item__criticality._const_tab = ____AuditResponse_protocolExtensions__item__id_tab
    ___AuditResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___AuditResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___AuditResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___AuditResponse_protocolExtensions__item__extensionValue._const_tab = ____AuditResponse_protocolExtensions__item__id_tab
    ___AuditResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AuditResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __AuditResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___AuditResponse_protocolExtensions__item__id),
        ('criticality', ___AuditResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___AuditResponse_protocolExtensions__item__extensionValue),
        ])
    __AuditResponse_protocolExtensions__item_._ext = None
    _AuditResponse_protocolExtensions._cont = __AuditResponse_protocolExtensions__item_
    _AuditResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AuditResponse._cont = ASN1Dict([
        ('protocolIEs', _AuditResponse_protocolIEs),
        ('protocolExtensions', _AuditResponse_protocolExtensions),
        ])
    AuditResponse._ext = []
    
    #-----< AuditResponse-IEs >-----#
    AuditResponse_IEs = CLASS(name='AuditResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _AuditResponse_IEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'End-Of-Audit-Sequence-Indicator')))
    _AuditResponse_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-InformationList-AuditRsp')))
    _AuditResponse_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCP-InformationList-AuditRsp')))
    _AuditResponse_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-InformationList-AuditRsp')))
    _AuditResponse_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-Group-InformationList-AuditRsp')))
    _AuditResponse_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    AuditResponse_IEs._val = ASN1Set(rv=[dict([('id', 113), ('criticality', 'ignore'), ('Value', _AuditResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _AuditResponse_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _AuditResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 128), ('criticality', 'ignore'), ('Value', _AuditResponse_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _AuditResponse_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _AuditResponse_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AuditResponse-Extensions >-----#
    AuditResponse_Extensions = CLASS(name='AuditResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _AuditResponse_Extensions_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationList-AuditRsp')))
    AuditResponse_Extensions._val = ASN1Set(rv=[dict([('id', 501), ('criticality', 'ignore'), ('Extension', _AuditResponse_Extensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Cell-InformationList-AuditRsp >-----#
    Cell_InformationList_AuditRsp = SEQ_OF(name='Cell-InformationList-AuditRsp', mode=MODE_TYPE)
    _Cell_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Cell_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Cell_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Cell_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-InformationItem-AuditRsp')))
    ___Cell_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 17), ('criticality', 'ignore'), ('Value', ____Cell_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __Cell_InformationList_AuditRsp__item__id._const_tab = ___Cell_InformationList_AuditRsp__item__id_tab
    __Cell_InformationList_AuditRsp__item__id._const_tab_at = None
    __Cell_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __Cell_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Cell_InformationList_AuditRsp__item__criticality._const_tab = ___Cell_InformationList_AuditRsp__item__id_tab
    __Cell_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __Cell_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __Cell_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Cell_InformationList_AuditRsp__item__value._const_tab = ___Cell_InformationList_AuditRsp__item__id_tab
    __Cell_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __Cell_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _Cell_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __Cell_InformationList_AuditRsp__item__id),
        ('criticality', __Cell_InformationList_AuditRsp__item__criticality),
        ('value', __Cell_InformationList_AuditRsp__item__value),
        ])
    _Cell_InformationList_AuditRsp__item_._ext = None
    Cell_InformationList_AuditRsp._cont = _Cell_InformationList_AuditRsp__item_
    Cell_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Cell-InformationItemIE-AuditRsp >-----#
    Cell_InformationItemIE_AuditRsp = CLASS(name='Cell-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Cell_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-InformationItem-AuditRsp')))
    Cell_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 17), ('criticality', 'ignore'), ('Value', _Cell_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< Cell-InformationItem-AuditRsp >-----#
    Cell_InformationItem_AuditRsp = SEQ(name='Cell-InformationItem-AuditRsp', mode=MODE_TYPE)
    _Cell_InformationItem_AuditRsp_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _Cell_InformationItem_AuditRsp_configurationGenerationID = INT(name='configurationGenerationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _Cell_InformationItem_AuditRsp_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _Cell_InformationItem_AuditRsp_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _Cell_InformationItem_AuditRsp_local_Cell_ID = INT(name='local-Cell-ID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Cell_InformationItem_AuditRsp_primary_SCH_Information = SEQ(name='primary-SCH-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'P-SCH-Information-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_secondary_SCH_Information = SEQ(name='secondary-SCH-Information', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-SCH-Information-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_primary_CPICH_Information = SEQ(name='primary-CPICH-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'P-CPICH-Information-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_secondary_CPICH_InformationList = SEQ_OF(name='secondary-CPICH-InformationList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CPICH-InformationList-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_primary_CCPCH_Information = SEQ(name='primary-CCPCH-Information', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'P-CCPCH-Information-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_bCH_Information = SEQ(name='bCH-Information', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'BCH-Information-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_secondary_CCPCH_InformationList = SEQ_OF(name='secondary-CCPCH-InformationList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-InformationList-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_pCH_Information = SEQ(name='pCH-Information', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-Information-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_pICH_Information = SEQ(name='pICH-Information', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-Information-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_fACH_InformationList = SEQ_OF(name='fACH-InformationList', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-InformationList-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_pRACH_InformationList = SEQ_OF(name='pRACH-InformationList', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-InformationList-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_rACH_InformationList = SEQ_OF(name='rACH-InformationList', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-InformationList-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_aICH_InformationList = SEQ_OF(name='aICH-InformationList', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'AICH-InformationList-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_notUsed_1_pCPCH_InformationList = NULL(name='notUsed-1-pCPCH-InformationList', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Cell_InformationItem_AuditRsp_notUsed_2_cPCH_InformationList = NULL(name='notUsed-2-cPCH-InformationList', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Cell_InformationItem_AuditRsp_notUsed_3_aP_AICH_InformationList = NULL(name='notUsed-3-aP-AICH-InformationList', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Cell_InformationItem_AuditRsp_notUsed_4_cDCA_ICH_InformationList = NULL(name='notUsed-4-cDCA-ICH-InformationList', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Cell_InformationItem_AuditRsp_sCH_Information = SEQ(name='sCH-Information', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SCH-Information-AuditRsp')), opt=True)
    _Cell_InformationItem_AuditRsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_InformationItem_AuditRsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FPACH-LCR-InformationList-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-DSCH-Resources-Information-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-InformationListExt-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-LCR-InformationListExt-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DCH-Resources-Information-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PLCCH-InformationList-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_9 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-768-InformationList-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_11 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-768-InformationList-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_14 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-InformationList-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_15 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-768-InformationList-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_16 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-List-Information-LCR-MulFreq-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_17 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UPPCH-LCR-InformationList-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_18 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-HS-DSCH-Resources-InformationList-AuditRsp')))
    _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_19 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-E-DCH-Resources-InformationList-AuditRsp')))
    ____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 22), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 90), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 611), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 638), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 646), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 648), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 672), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 715), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 732), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 725), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 733), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 734), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 735), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 736), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 795), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 810), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 913), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 921), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_17), ('presence', 'optional')]), dict([('id', 929), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 953), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_19), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab = ____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_at = None
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab = ____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab = ____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_InformationItem_AuditRsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_InformationItem_AuditRsp_iE_Extensions__item__id),
        ('criticality', ___Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue),
        ])
    __Cell_InformationItem_AuditRsp_iE_Extensions__item_._ext = None
    _Cell_InformationItem_AuditRsp_iE_Extensions._cont = __Cell_InformationItem_AuditRsp_iE_Extensions__item_
    _Cell_InformationItem_AuditRsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_InformationItem_AuditRsp._cont = ASN1Dict([
        ('c-ID', _Cell_InformationItem_AuditRsp_c_ID),
        ('configurationGenerationID', _Cell_InformationItem_AuditRsp_configurationGenerationID),
        ('resourceOperationalState', _Cell_InformationItem_AuditRsp_resourceOperationalState),
        ('availabilityStatus', _Cell_InformationItem_AuditRsp_availabilityStatus),
        ('local-Cell-ID', _Cell_InformationItem_AuditRsp_local_Cell_ID),
        ('primary-SCH-Information', _Cell_InformationItem_AuditRsp_primary_SCH_Information),
        ('secondary-SCH-Information', _Cell_InformationItem_AuditRsp_secondary_SCH_Information),
        ('primary-CPICH-Information', _Cell_InformationItem_AuditRsp_primary_CPICH_Information),
        ('secondary-CPICH-InformationList', _Cell_InformationItem_AuditRsp_secondary_CPICH_InformationList),
        ('primary-CCPCH-Information', _Cell_InformationItem_AuditRsp_primary_CCPCH_Information),
        ('bCH-Information', _Cell_InformationItem_AuditRsp_bCH_Information),
        ('secondary-CCPCH-InformationList', _Cell_InformationItem_AuditRsp_secondary_CCPCH_InformationList),
        ('pCH-Information', _Cell_InformationItem_AuditRsp_pCH_Information),
        ('pICH-Information', _Cell_InformationItem_AuditRsp_pICH_Information),
        ('fACH-InformationList', _Cell_InformationItem_AuditRsp_fACH_InformationList),
        ('pRACH-InformationList', _Cell_InformationItem_AuditRsp_pRACH_InformationList),
        ('rACH-InformationList', _Cell_InformationItem_AuditRsp_rACH_InformationList),
        ('aICH-InformationList', _Cell_InformationItem_AuditRsp_aICH_InformationList),
        ('notUsed-1-pCPCH-InformationList', _Cell_InformationItem_AuditRsp_notUsed_1_pCPCH_InformationList),
        ('notUsed-2-cPCH-InformationList', _Cell_InformationItem_AuditRsp_notUsed_2_cPCH_InformationList),
        ('notUsed-3-aP-AICH-InformationList', _Cell_InformationItem_AuditRsp_notUsed_3_aP_AICH_InformationList),
        ('notUsed-4-cDCA-ICH-InformationList', _Cell_InformationItem_AuditRsp_notUsed_4_cDCA_ICH_InformationList),
        ('sCH-Information', _Cell_InformationItem_AuditRsp_sCH_Information),
        ('iE-Extensions', _Cell_InformationItem_AuditRsp_iE_Extensions),
        ])
    Cell_InformationItem_AuditRsp._ext = []
    
    #-----< Cell-InformationItem-AuditRsp-ExtIEs >-----#
    Cell_InformationItem_AuditRsp_ExtIEs = CLASS(name='Cell-InformationItem-AuditRsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FPACH-LCR-InformationList-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-DSCH-Resources-Information-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-InformationListExt-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-LCR-InformationListExt-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DCH-Resources-Information-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PLCCH-InformationList-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_9 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-768-InformationList-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_11 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-768-InformationList-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_14 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-InformationList-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_15 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-768-InformationList-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_16 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-List-Information-LCR-MulFreq-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_17 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UPPCH-LCR-InformationList-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_18 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-HS-DSCH-Resources-InformationList-AuditRsp')))
    _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_19 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-E-DCH-Resources-InformationList-AuditRsp')))
    Cell_InformationItem_AuditRsp_ExtIEs._val = ASN1Set(rv=[dict([('id', 22), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 90), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 611), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 638), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 646), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 648), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 672), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 715), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 732), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 725), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 733), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 734), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 735), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 736), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_13), ('presence', 'optional')]), dict([('id', 795), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_14), ('presence', 'optional')]), dict([('id', 810), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_15), ('presence', 'optional')]), dict([('id', 913), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_16), ('presence', 'optional')]), dict([('id', 921), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_17), ('presence', 'optional')]), dict([('id', 929), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_18), ('presence', 'optional')]), dict([('id', 953), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_19), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< P-SCH-Information-AuditRsp >-----#
    P_SCH_Information_AuditRsp = SEQ(name='P-SCH-Information-AuditRsp', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _P_SCH_Information_AuditRsp_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __P_SCH_Information_AuditRsp_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___P_SCH_Information_AuditRsp_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __P_SCH_Information_AuditRsp_id_tab._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'ignore'), ('Value', ___P_SCH_Information_AuditRsp_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _P_SCH_Information_AuditRsp_id._const_tab = __P_SCH_Information_AuditRsp_id_tab
    _P_SCH_Information_AuditRsp_id._const_tab_at = None
    _P_SCH_Information_AuditRsp_id._const_tab_id = 'id'
    _P_SCH_Information_AuditRsp_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _P_SCH_Information_AuditRsp_criticality._const_tab = __P_SCH_Information_AuditRsp_id_tab
    _P_SCH_Information_AuditRsp_criticality._const_tab_at = ('..', 'id')
    _P_SCH_Information_AuditRsp_criticality._const_tab_id = 'criticality'
    _P_SCH_Information_AuditRsp_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _P_SCH_Information_AuditRsp_value._const_tab = __P_SCH_Information_AuditRsp_id_tab
    _P_SCH_Information_AuditRsp_value._const_tab_at = ('..', 'id')
    _P_SCH_Information_AuditRsp_value._const_tab_id = 'Value'
    P_SCH_Information_AuditRsp._cont = ASN1Dict([
        ('id', _P_SCH_Information_AuditRsp_id),
        ('criticality', _P_SCH_Information_AuditRsp_criticality),
        ('value', _P_SCH_Information_AuditRsp_value),
        ])
    P_SCH_Information_AuditRsp._ext = None
    
    #-----< P-SCH-InformationIE-AuditRsp >-----#
    P_SCH_InformationIE_AuditRsp = CLASS(name='P-SCH-InformationIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _P_SCH_InformationIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    P_SCH_InformationIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'ignore'), ('Value', _P_SCH_InformationIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< S-SCH-Information-AuditRsp >-----#
    S_SCH_Information_AuditRsp = SEQ(name='S-SCH-Information-AuditRsp', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _S_SCH_Information_AuditRsp_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __S_SCH_Information_AuditRsp_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___S_SCH_Information_AuditRsp_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __S_SCH_Information_AuditRsp_id_tab._val = ASN1Set(rv=[dict([('id', 253), ('criticality', 'ignore'), ('Value', ___S_SCH_Information_AuditRsp_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _S_SCH_Information_AuditRsp_id._const_tab = __S_SCH_Information_AuditRsp_id_tab
    _S_SCH_Information_AuditRsp_id._const_tab_at = None
    _S_SCH_Information_AuditRsp_id._const_tab_id = 'id'
    _S_SCH_Information_AuditRsp_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _S_SCH_Information_AuditRsp_criticality._const_tab = __S_SCH_Information_AuditRsp_id_tab
    _S_SCH_Information_AuditRsp_criticality._const_tab_at = ('..', 'id')
    _S_SCH_Information_AuditRsp_criticality._const_tab_id = 'criticality'
    _S_SCH_Information_AuditRsp_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _S_SCH_Information_AuditRsp_value._const_tab = __S_SCH_Information_AuditRsp_id_tab
    _S_SCH_Information_AuditRsp_value._const_tab_at = ('..', 'id')
    _S_SCH_Information_AuditRsp_value._const_tab_id = 'Value'
    S_SCH_Information_AuditRsp._cont = ASN1Dict([
        ('id', _S_SCH_Information_AuditRsp_id),
        ('criticality', _S_SCH_Information_AuditRsp_criticality),
        ('value', _S_SCH_Information_AuditRsp_value),
        ])
    S_SCH_Information_AuditRsp._ext = None
    
    #-----< S-SCH-InformationIE-AuditRsp >-----#
    S_SCH_InformationIE_AuditRsp = CLASS(name='S-SCH-InformationIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _S_SCH_InformationIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    S_SCH_InformationIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 253), ('criticality', 'ignore'), ('Value', _S_SCH_InformationIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< P-CPICH-Information-AuditRsp >-----#
    P_CPICH_Information_AuditRsp = SEQ(name='P-CPICH-Information-AuditRsp', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _P_CPICH_Information_AuditRsp_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __P_CPICH_Information_AuditRsp_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___P_CPICH_Information_AuditRsp_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __P_CPICH_Information_AuditRsp_id_tab._val = ASN1Set(rv=[dict([('id', 146), ('criticality', 'ignore'), ('Value', ___P_CPICH_Information_AuditRsp_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _P_CPICH_Information_AuditRsp_id._const_tab = __P_CPICH_Information_AuditRsp_id_tab
    _P_CPICH_Information_AuditRsp_id._const_tab_at = None
    _P_CPICH_Information_AuditRsp_id._const_tab_id = 'id'
    _P_CPICH_Information_AuditRsp_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _P_CPICH_Information_AuditRsp_criticality._const_tab = __P_CPICH_Information_AuditRsp_id_tab
    _P_CPICH_Information_AuditRsp_criticality._const_tab_at = ('..', 'id')
    _P_CPICH_Information_AuditRsp_criticality._const_tab_id = 'criticality'
    _P_CPICH_Information_AuditRsp_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _P_CPICH_Information_AuditRsp_value._const_tab = __P_CPICH_Information_AuditRsp_id_tab
    _P_CPICH_Information_AuditRsp_value._const_tab_at = ('..', 'id')
    _P_CPICH_Information_AuditRsp_value._const_tab_id = 'Value'
    P_CPICH_Information_AuditRsp._cont = ASN1Dict([
        ('id', _P_CPICH_Information_AuditRsp_id),
        ('criticality', _P_CPICH_Information_AuditRsp_criticality),
        ('value', _P_CPICH_Information_AuditRsp_value),
        ])
    P_CPICH_Information_AuditRsp._ext = None
    
    #-----< P-CPICH-InformationIE-AuditRsp >-----#
    P_CPICH_InformationIE_AuditRsp = CLASS(name='P-CPICH-InformationIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _P_CPICH_InformationIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    P_CPICH_InformationIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 146), ('criticality', 'ignore'), ('Value', _P_CPICH_InformationIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< S-CPICH-InformationList-AuditRsp >-----#
    S_CPICH_InformationList_AuditRsp = SEQ_OF(name='S-CPICH-InformationList-AuditRsp', mode=MODE_TYPE)
    _S_CPICH_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __S_CPICH_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___S_CPICH_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____S_CPICH_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___S_CPICH_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 249), ('criticality', 'ignore'), ('Value', ____S_CPICH_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __S_CPICH_InformationList_AuditRsp__item__id._const_tab = ___S_CPICH_InformationList_AuditRsp__item__id_tab
    __S_CPICH_InformationList_AuditRsp__item__id._const_tab_at = None
    __S_CPICH_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __S_CPICH_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __S_CPICH_InformationList_AuditRsp__item__criticality._const_tab = ___S_CPICH_InformationList_AuditRsp__item__id_tab
    __S_CPICH_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __S_CPICH_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __S_CPICH_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __S_CPICH_InformationList_AuditRsp__item__value._const_tab = ___S_CPICH_InformationList_AuditRsp__item__id_tab
    __S_CPICH_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __S_CPICH_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _S_CPICH_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __S_CPICH_InformationList_AuditRsp__item__id),
        ('criticality', __S_CPICH_InformationList_AuditRsp__item__criticality),
        ('value', __S_CPICH_InformationList_AuditRsp__item__value),
        ])
    _S_CPICH_InformationList_AuditRsp__item_._ext = None
    S_CPICH_InformationList_AuditRsp._cont = _S_CPICH_InformationList_AuditRsp__item_
    S_CPICH_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< S-CPICH-InformationItemIE-AuditRsp >-----#
    S_CPICH_InformationItemIE_AuditRsp = CLASS(name='S-CPICH-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _S_CPICH_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    S_CPICH_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 249), ('criticality', 'ignore'), ('Value', _S_CPICH_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< P-CCPCH-Information-AuditRsp >-----#
    P_CCPCH_Information_AuditRsp = SEQ(name='P-CCPCH-Information-AuditRsp', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _P_CCPCH_Information_AuditRsp_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __P_CCPCH_Information_AuditRsp_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___P_CCPCH_Information_AuditRsp_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __P_CCPCH_Information_AuditRsp_id_tab._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Value', ___P_CCPCH_Information_AuditRsp_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _P_CCPCH_Information_AuditRsp_id._const_tab = __P_CCPCH_Information_AuditRsp_id_tab
    _P_CCPCH_Information_AuditRsp_id._const_tab_at = None
    _P_CCPCH_Information_AuditRsp_id._const_tab_id = 'id'
    _P_CCPCH_Information_AuditRsp_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _P_CCPCH_Information_AuditRsp_criticality._const_tab = __P_CCPCH_Information_AuditRsp_id_tab
    _P_CCPCH_Information_AuditRsp_criticality._const_tab_at = ('..', 'id')
    _P_CCPCH_Information_AuditRsp_criticality._const_tab_id = 'criticality'
    _P_CCPCH_Information_AuditRsp_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _P_CCPCH_Information_AuditRsp_value._const_tab = __P_CCPCH_Information_AuditRsp_id_tab
    _P_CCPCH_Information_AuditRsp_value._const_tab_at = ('..', 'id')
    _P_CCPCH_Information_AuditRsp_value._const_tab_id = 'Value'
    P_CCPCH_Information_AuditRsp._cont = ASN1Dict([
        ('id', _P_CCPCH_Information_AuditRsp_id),
        ('criticality', _P_CCPCH_Information_AuditRsp_criticality),
        ('value', _P_CCPCH_Information_AuditRsp_value),
        ])
    P_CCPCH_Information_AuditRsp._ext = None
    
    #-----< P-CCPCH-InformationIE-AuditRsp >-----#
    P_CCPCH_InformationIE_AuditRsp = CLASS(name='P-CCPCH-InformationIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _P_CCPCH_InformationIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    P_CCPCH_InformationIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Value', _P_CCPCH_InformationIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< BCH-Information-AuditRsp >-----#
    BCH_Information_AuditRsp = SEQ(name='BCH-Information-AuditRsp', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _BCH_Information_AuditRsp_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __BCH_Information_AuditRsp_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___BCH_Information_AuditRsp_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    __BCH_Information_AuditRsp_id_tab._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'ignore'), ('Value', ___BCH_Information_AuditRsp_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _BCH_Information_AuditRsp_id._const_tab = __BCH_Information_AuditRsp_id_tab
    _BCH_Information_AuditRsp_id._const_tab_at = None
    _BCH_Information_AuditRsp_id._const_tab_id = 'id'
    _BCH_Information_AuditRsp_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _BCH_Information_AuditRsp_criticality._const_tab = __BCH_Information_AuditRsp_id_tab
    _BCH_Information_AuditRsp_criticality._const_tab_at = ('..', 'id')
    _BCH_Information_AuditRsp_criticality._const_tab_id = 'criticality'
    _BCH_Information_AuditRsp_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _BCH_Information_AuditRsp_value._const_tab = __BCH_Information_AuditRsp_id_tab
    _BCH_Information_AuditRsp_value._const_tab_at = ('..', 'id')
    _BCH_Information_AuditRsp_value._const_tab_id = 'Value'
    BCH_Information_AuditRsp._cont = ASN1Dict([
        ('id', _BCH_Information_AuditRsp_id),
        ('criticality', _BCH_Information_AuditRsp_criticality),
        ('value', _BCH_Information_AuditRsp_value),
        ])
    BCH_Information_AuditRsp._ext = None
    
    #-----< BCH-InformationIE-AuditRsp >-----#
    BCH_InformationIE_AuditRsp = CLASS(name='BCH-InformationIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _BCH_InformationIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    BCH_InformationIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'ignore'), ('Value', _BCH_InformationIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< S-CCPCH-InformationList-AuditRsp >-----#
    S_CCPCH_InformationList_AuditRsp = SEQ_OF(name='S-CCPCH-InformationList-AuditRsp', mode=MODE_TYPE)
    _S_CCPCH_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __S_CCPCH_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___S_CCPCH_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____S_CCPCH_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___S_CCPCH_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 247), ('criticality', 'ignore'), ('Value', ____S_CCPCH_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __S_CCPCH_InformationList_AuditRsp__item__id._const_tab = ___S_CCPCH_InformationList_AuditRsp__item__id_tab
    __S_CCPCH_InformationList_AuditRsp__item__id._const_tab_at = None
    __S_CCPCH_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __S_CCPCH_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __S_CCPCH_InformationList_AuditRsp__item__criticality._const_tab = ___S_CCPCH_InformationList_AuditRsp__item__id_tab
    __S_CCPCH_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __S_CCPCH_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __S_CCPCH_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __S_CCPCH_InformationList_AuditRsp__item__value._const_tab = ___S_CCPCH_InformationList_AuditRsp__item__id_tab
    __S_CCPCH_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __S_CCPCH_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _S_CCPCH_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __S_CCPCH_InformationList_AuditRsp__item__id),
        ('criticality', __S_CCPCH_InformationList_AuditRsp__item__criticality),
        ('value', __S_CCPCH_InformationList_AuditRsp__item__value),
        ])
    _S_CCPCH_InformationList_AuditRsp__item_._ext = None
    S_CCPCH_InformationList_AuditRsp._cont = _S_CCPCH_InformationList_AuditRsp__item_
    S_CCPCH_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< S-CCPCH-InformationItemIE-AuditRsp >-----#
    S_CCPCH_InformationItemIE_AuditRsp = CLASS(name='S-CCPCH-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _S_CCPCH_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    S_CCPCH_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 247), ('criticality', 'ignore'), ('Value', _S_CCPCH_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PCH-Information-AuditRsp >-----#
    PCH_Information_AuditRsp = SEQ(name='PCH-Information-AuditRsp', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PCH_Information_AuditRsp_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PCH_Information_AuditRsp_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PCH_Information_AuditRsp_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    __PCH_Information_AuditRsp_id_tab._val = ASN1Set(rv=[dict([('id', 158), ('criticality', 'ignore'), ('Value', ___PCH_Information_AuditRsp_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _PCH_Information_AuditRsp_id._const_tab = __PCH_Information_AuditRsp_id_tab
    _PCH_Information_AuditRsp_id._const_tab_at = None
    _PCH_Information_AuditRsp_id._const_tab_id = 'id'
    _PCH_Information_AuditRsp_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PCH_Information_AuditRsp_criticality._const_tab = __PCH_Information_AuditRsp_id_tab
    _PCH_Information_AuditRsp_criticality._const_tab_at = ('..', 'id')
    _PCH_Information_AuditRsp_criticality._const_tab_id = 'criticality'
    _PCH_Information_AuditRsp_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PCH_Information_AuditRsp_value._const_tab = __PCH_Information_AuditRsp_id_tab
    _PCH_Information_AuditRsp_value._const_tab_at = ('..', 'id')
    _PCH_Information_AuditRsp_value._const_tab_id = 'Value'
    PCH_Information_AuditRsp._cont = ASN1Dict([
        ('id', _PCH_Information_AuditRsp_id),
        ('criticality', _PCH_Information_AuditRsp_criticality),
        ('value', _PCH_Information_AuditRsp_value),
        ])
    PCH_Information_AuditRsp._ext = None
    
    #-----< PCH-InformationIE-AuditRsp >-----#
    PCH_InformationIE_AuditRsp = CLASS(name='PCH-InformationIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PCH_InformationIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    PCH_InformationIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 158), ('criticality', 'ignore'), ('Value', _PCH_InformationIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PICH-Information-AuditRsp >-----#
    PICH_Information_AuditRsp = SEQ(name='PICH-Information-AuditRsp', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PICH_Information_AuditRsp_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PICH_Information_AuditRsp_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PICH_Information_AuditRsp_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __PICH_Information_AuditRsp_id_tab._val = ASN1Set(rv=[dict([('id', 166), ('criticality', 'ignore'), ('Value', ___PICH_Information_AuditRsp_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _PICH_Information_AuditRsp_id._const_tab = __PICH_Information_AuditRsp_id_tab
    _PICH_Information_AuditRsp_id._const_tab_at = None
    _PICH_Information_AuditRsp_id._const_tab_id = 'id'
    _PICH_Information_AuditRsp_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PICH_Information_AuditRsp_criticality._const_tab = __PICH_Information_AuditRsp_id_tab
    _PICH_Information_AuditRsp_criticality._const_tab_at = ('..', 'id')
    _PICH_Information_AuditRsp_criticality._const_tab_id = 'criticality'
    _PICH_Information_AuditRsp_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PICH_Information_AuditRsp_value._const_tab = __PICH_Information_AuditRsp_id_tab
    _PICH_Information_AuditRsp_value._const_tab_at = ('..', 'id')
    _PICH_Information_AuditRsp_value._const_tab_id = 'Value'
    PICH_Information_AuditRsp._cont = ASN1Dict([
        ('id', _PICH_Information_AuditRsp_id),
        ('criticality', _PICH_Information_AuditRsp_criticality),
        ('value', _PICH_Information_AuditRsp_value),
        ])
    PICH_Information_AuditRsp._ext = None
    
    #-----< PICH-InformationIE-AuditRsp >-----#
    PICH_InformationIE_AuditRsp = CLASS(name='PICH-InformationIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PICH_InformationIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    PICH_InformationIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 166), ('criticality', 'ignore'), ('Value', _PICH_InformationIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< FACH-InformationList-AuditRsp >-----#
    FACH_InformationList_AuditRsp = SEQ_OF(name='FACH-InformationList-AuditRsp', mode=MODE_TYPE)
    _FACH_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __FACH_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___FACH_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____FACH_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    ___FACH_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 116), ('criticality', 'ignore'), ('Value', ____FACH_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __FACH_InformationList_AuditRsp__item__id._const_tab = ___FACH_InformationList_AuditRsp__item__id_tab
    __FACH_InformationList_AuditRsp__item__id._const_tab_at = None
    __FACH_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __FACH_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __FACH_InformationList_AuditRsp__item__criticality._const_tab = ___FACH_InformationList_AuditRsp__item__id_tab
    __FACH_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __FACH_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __FACH_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __FACH_InformationList_AuditRsp__item__value._const_tab = ___FACH_InformationList_AuditRsp__item__id_tab
    __FACH_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __FACH_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _FACH_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __FACH_InformationList_AuditRsp__item__id),
        ('criticality', __FACH_InformationList_AuditRsp__item__criticality),
        ('value', __FACH_InformationList_AuditRsp__item__value),
        ])
    _FACH_InformationList_AuditRsp__item_._ext = None
    FACH_InformationList_AuditRsp._cont = _FACH_InformationList_AuditRsp__item_
    FACH_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< FACH-InformationItemIE-AuditRsp >-----#
    FACH_InformationItemIE_AuditRsp = CLASS(name='FACH-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _FACH_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    FACH_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 116), ('criticality', 'ignore'), ('Value', _FACH_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PRACH-InformationList-AuditRsp >-----#
    PRACH_InformationList_AuditRsp = SEQ_OF(name='PRACH-InformationList-AuditRsp', mode=MODE_TYPE)
    _PRACH_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __PRACH_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___PRACH_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____PRACH_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___PRACH_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 170), ('criticality', 'ignore'), ('Value', ____PRACH_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __PRACH_InformationList_AuditRsp__item__id._const_tab = ___PRACH_InformationList_AuditRsp__item__id_tab
    __PRACH_InformationList_AuditRsp__item__id._const_tab_at = None
    __PRACH_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __PRACH_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __PRACH_InformationList_AuditRsp__item__criticality._const_tab = ___PRACH_InformationList_AuditRsp__item__id_tab
    __PRACH_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __PRACH_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __PRACH_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __PRACH_InformationList_AuditRsp__item__value._const_tab = ___PRACH_InformationList_AuditRsp__item__id_tab
    __PRACH_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __PRACH_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _PRACH_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __PRACH_InformationList_AuditRsp__item__id),
        ('criticality', __PRACH_InformationList_AuditRsp__item__criticality),
        ('value', __PRACH_InformationList_AuditRsp__item__value),
        ])
    _PRACH_InformationList_AuditRsp__item_._ext = None
    PRACH_InformationList_AuditRsp._cont = _PRACH_InformationList_AuditRsp__item_
    PRACH_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PRACH-InformationItemIE-AuditRsp >-----#
    PRACH_InformationItemIE_AuditRsp = CLASS(name='PRACH-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PRACH_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    PRACH_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 170), ('criticality', 'ignore'), ('Value', _PRACH_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RACH-InformationList-AuditRsp >-----#
    RACH_InformationList_AuditRsp = SEQ_OF(name='RACH-InformationList-AuditRsp', mode=MODE_TYPE)
    _RACH_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RACH_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RACH_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RACH_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    ___RACH_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 190), ('criticality', 'ignore'), ('Value', ____RACH_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RACH_InformationList_AuditRsp__item__id._const_tab = ___RACH_InformationList_AuditRsp__item__id_tab
    __RACH_InformationList_AuditRsp__item__id._const_tab_at = None
    __RACH_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __RACH_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RACH_InformationList_AuditRsp__item__criticality._const_tab = ___RACH_InformationList_AuditRsp__item__id_tab
    __RACH_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __RACH_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __RACH_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RACH_InformationList_AuditRsp__item__value._const_tab = ___RACH_InformationList_AuditRsp__item__id_tab
    __RACH_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __RACH_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _RACH_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __RACH_InformationList_AuditRsp__item__id),
        ('criticality', __RACH_InformationList_AuditRsp__item__criticality),
        ('value', __RACH_InformationList_AuditRsp__item__value),
        ])
    _RACH_InformationList_AuditRsp__item_._ext = None
    RACH_InformationList_AuditRsp._cont = _RACH_InformationList_AuditRsp__item_
    RACH_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RACH-InformationItemIE-AuditRsp >-----#
    RACH_InformationItemIE_AuditRsp = CLASS(name='RACH-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RACH_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    RACH_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 190), ('criticality', 'ignore'), ('Value', _RACH_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< AICH-InformationList-AuditRsp >-----#
    AICH_InformationList_AuditRsp = SEQ_OF(name='AICH-InformationList-AuditRsp', mode=MODE_TYPE)
    _AICH_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __AICH_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___AICH_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____AICH_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___AICH_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', ____AICH_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __AICH_InformationList_AuditRsp__item__id._const_tab = ___AICH_InformationList_AuditRsp__item__id_tab
    __AICH_InformationList_AuditRsp__item__id._const_tab_at = None
    __AICH_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __AICH_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __AICH_InformationList_AuditRsp__item__criticality._const_tab = ___AICH_InformationList_AuditRsp__item__id_tab
    __AICH_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __AICH_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __AICH_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __AICH_InformationList_AuditRsp__item__value._const_tab = ___AICH_InformationList_AuditRsp__item__id_tab
    __AICH_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __AICH_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _AICH_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __AICH_InformationList_AuditRsp__item__id),
        ('criticality', __AICH_InformationList_AuditRsp__item__criticality),
        ('value', __AICH_InformationList_AuditRsp__item__value),
        ])
    _AICH_InformationList_AuditRsp__item_._ext = None
    AICH_InformationList_AuditRsp._cont = _AICH_InformationList_AuditRsp__item_
    AICH_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< AICH-InformationItemIE-AuditRsp >-----#
    AICH_InformationItemIE_AuditRsp = CLASS(name='AICH-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _AICH_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    AICH_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _AICH_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SCH-Information-AuditRsp >-----#
    SCH_Information_AuditRsp = SEQ(name='SCH-Information-AuditRsp', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _SCH_Information_AuditRsp_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __SCH_Information_AuditRsp_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___SCH_Information_AuditRsp_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __SCH_Information_AuditRsp_id_tab._val = ASN1Set(rv=[dict([('id', 251), ('criticality', 'ignore'), ('Value', ___SCH_Information_AuditRsp_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _SCH_Information_AuditRsp_id._const_tab = __SCH_Information_AuditRsp_id_tab
    _SCH_Information_AuditRsp_id._const_tab_at = None
    _SCH_Information_AuditRsp_id._const_tab_id = 'id'
    _SCH_Information_AuditRsp_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _SCH_Information_AuditRsp_criticality._const_tab = __SCH_Information_AuditRsp_id_tab
    _SCH_Information_AuditRsp_criticality._const_tab_at = ('..', 'id')
    _SCH_Information_AuditRsp_criticality._const_tab_id = 'criticality'
    _SCH_Information_AuditRsp_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _SCH_Information_AuditRsp_value._const_tab = __SCH_Information_AuditRsp_id_tab
    _SCH_Information_AuditRsp_value._const_tab_at = ('..', 'id')
    _SCH_Information_AuditRsp_value._const_tab_id = 'Value'
    SCH_Information_AuditRsp._cont = ASN1Dict([
        ('id', _SCH_Information_AuditRsp_id),
        ('criticality', _SCH_Information_AuditRsp_criticality),
        ('value', _SCH_Information_AuditRsp_value),
        ])
    SCH_Information_AuditRsp._ext = None
    
    #-----< SCH-InformationIE-AuditRsp >-----#
    SCH_InformationIE_AuditRsp = CLASS(name='SCH-InformationIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SCH_InformationIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    SCH_InformationIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 251), ('criticality', 'ignore'), ('Value', _SCH_InformationIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< FPACH-LCR-InformationList-AuditRsp >-----#
    FPACH_LCR_InformationList_AuditRsp = SEQ_OF(name='FPACH-LCR-InformationList-AuditRsp', mode=MODE_TYPE)
    _FPACH_LCR_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __FPACH_LCR_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___FPACH_LCR_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____FPACH_LCR_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___FPACH_LCR_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 292), ('criticality', 'ignore'), ('Value', ____FPACH_LCR_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __FPACH_LCR_InformationList_AuditRsp__item__id._const_tab = ___FPACH_LCR_InformationList_AuditRsp__item__id_tab
    __FPACH_LCR_InformationList_AuditRsp__item__id._const_tab_at = None
    __FPACH_LCR_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __FPACH_LCR_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __FPACH_LCR_InformationList_AuditRsp__item__criticality._const_tab = ___FPACH_LCR_InformationList_AuditRsp__item__id_tab
    __FPACH_LCR_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __FPACH_LCR_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __FPACH_LCR_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __FPACH_LCR_InformationList_AuditRsp__item__value._const_tab = ___FPACH_LCR_InformationList_AuditRsp__item__id_tab
    __FPACH_LCR_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __FPACH_LCR_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _FPACH_LCR_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __FPACH_LCR_InformationList_AuditRsp__item__id),
        ('criticality', __FPACH_LCR_InformationList_AuditRsp__item__criticality),
        ('value', __FPACH_LCR_InformationList_AuditRsp__item__value),
        ])
    _FPACH_LCR_InformationList_AuditRsp__item_._ext = None
    FPACH_LCR_InformationList_AuditRsp._cont = _FPACH_LCR_InformationList_AuditRsp__item_
    FPACH_LCR_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< FPACH-LCR-InformationItemIE-AuditRsp >-----#
    FPACH_LCR_InformationItemIE_AuditRsp = CLASS(name='FPACH-LCR-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _FPACH_LCR_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    FPACH_LCR_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 292), ('criticality', 'ignore'), ('Value', _FPACH_LCR_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< HS-DSCH-Resources-Information-AuditRsp >-----#
    HS_DSCH_Resources_Information_AuditRsp = SEQ(name='HS-DSCH-Resources-Information-AuditRsp', mode=MODE_TYPE)
    _HS_DSCH_Resources_Information_AuditRsp_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _HS_DSCH_Resources_Information_AuditRsp_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _HS_DSCH_Resources_Information_AuditRsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id._const_tab = ____HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item_._ext = None
    _HS_DSCH_Resources_Information_AuditRsp_iE_Extensions._cont = __HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item_
    _HS_DSCH_Resources_Information_AuditRsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Resources_Information_AuditRsp._cont = ASN1Dict([
        ('resourceOperationalState', _HS_DSCH_Resources_Information_AuditRsp_resourceOperationalState),
        ('availabilityStatus', _HS_DSCH_Resources_Information_AuditRsp_availabilityStatus),
        ('iE-Extensions', _HS_DSCH_Resources_Information_AuditRsp_iE_Extensions),
        ])
    HS_DSCH_Resources_Information_AuditRsp._ext = []
    
    #-----< HS-DSCH-Resources-Information-AuditRsp-ExtIEs >-----#
    HS_DSCH_Resources_Information_AuditRsp_ExtIEs = CLASS(name='HS-DSCH-Resources-Information-AuditRsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_Resources_Information_AuditRsp_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    HS_DSCH_Resources_Information_AuditRsp_ExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _HS_DSCH_Resources_Information_AuditRsp_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< S-CCPCH-InformationListExt-AuditRsp >-----#
    S_CCPCH_InformationListExt_AuditRsp = SEQ_OF(name='S-CCPCH-InformationListExt-AuditRsp', mode=MODE_TYPE)
    _S_CCPCH_InformationListExt_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __S_CCPCH_InformationListExt_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___S_CCPCH_InformationListExt_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____S_CCPCH_InformationListExt_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___S_CCPCH_InformationListExt_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 247), ('criticality', 'ignore'), ('Value', ____S_CCPCH_InformationListExt_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __S_CCPCH_InformationListExt_AuditRsp__item__id._const_tab = ___S_CCPCH_InformationListExt_AuditRsp__item__id_tab
    __S_CCPCH_InformationListExt_AuditRsp__item__id._const_tab_at = None
    __S_CCPCH_InformationListExt_AuditRsp__item__id._const_tab_id = 'id'
    __S_CCPCH_InformationListExt_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __S_CCPCH_InformationListExt_AuditRsp__item__criticality._const_tab = ___S_CCPCH_InformationListExt_AuditRsp__item__id_tab
    __S_CCPCH_InformationListExt_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __S_CCPCH_InformationListExt_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __S_CCPCH_InformationListExt_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __S_CCPCH_InformationListExt_AuditRsp__item__value._const_tab = ___S_CCPCH_InformationListExt_AuditRsp__item__id_tab
    __S_CCPCH_InformationListExt_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __S_CCPCH_InformationListExt_AuditRsp__item__value._const_tab_id = 'Value'
    _S_CCPCH_InformationListExt_AuditRsp__item_._cont = ASN1Dict([
        ('id', __S_CCPCH_InformationListExt_AuditRsp__item__id),
        ('criticality', __S_CCPCH_InformationListExt_AuditRsp__item__criticality),
        ('value', __S_CCPCH_InformationListExt_AuditRsp__item__value),
        ])
    _S_CCPCH_InformationListExt_AuditRsp__item_._ext = None
    S_CCPCH_InformationListExt_AuditRsp._cont = _S_CCPCH_InformationListExt_AuditRsp__item_
    S_CCPCH_InformationListExt_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=208)], ev=None, er=[])
    
    #-----< S-CCPCH-LCR-InformationListExt-AuditRsp >-----#
    S_CCPCH_LCR_InformationListExt_AuditRsp = SEQ_OF(name='S-CCPCH-LCR-InformationListExt-AuditRsp', mode=MODE_TYPE)
    _S_CCPCH_LCR_InformationListExt_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___S_CCPCH_LCR_InformationListExt_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____S_CCPCH_LCR_InformationListExt_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___S_CCPCH_LCR_InformationListExt_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 247), ('criticality', 'ignore'), ('Value', ____S_CCPCH_LCR_InformationListExt_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__id._const_tab = ___S_CCPCH_LCR_InformationListExt_AuditRsp__item__id_tab
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__id._const_tab_at = None
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__id._const_tab_id = 'id'
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__criticality._const_tab = ___S_CCPCH_LCR_InformationListExt_AuditRsp__item__id_tab
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__value._const_tab = ___S_CCPCH_LCR_InformationListExt_AuditRsp__item__id_tab
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __S_CCPCH_LCR_InformationListExt_AuditRsp__item__value._const_tab_id = 'Value'
    _S_CCPCH_LCR_InformationListExt_AuditRsp__item_._cont = ASN1Dict([
        ('id', __S_CCPCH_LCR_InformationListExt_AuditRsp__item__id),
        ('criticality', __S_CCPCH_LCR_InformationListExt_AuditRsp__item__criticality),
        ('value', __S_CCPCH_LCR_InformationListExt_AuditRsp__item__value),
        ])
    _S_CCPCH_LCR_InformationListExt_AuditRsp__item_._ext = None
    S_CCPCH_LCR_InformationListExt_AuditRsp._cont = _S_CCPCH_LCR_InformationListExt_AuditRsp__item_
    S_CCPCH_LCR_InformationListExt_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< E-DCH-Resources-Information-AuditRsp >-----#
    E_DCH_Resources_Information_AuditRsp = SEQ(name='E-DCH-Resources-Information-AuditRsp', mode=MODE_TYPE)
    _E_DCH_Resources_Information_AuditRsp_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _E_DCH_Resources_Information_AuditRsp_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _E_DCH_Resources_Information_AuditRsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Resources_Information_AuditRsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id._const_tab = ____E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality._const_tab = ____E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Resources_Information_AuditRsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Resources_Information_AuditRsp_iE_Extensions__item_._ext = None
    _E_DCH_Resources_Information_AuditRsp_iE_Extensions._cont = __E_DCH_Resources_Information_AuditRsp_iE_Extensions__item_
    _E_DCH_Resources_Information_AuditRsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Resources_Information_AuditRsp._cont = ASN1Dict([
        ('resourceOperationalState', _E_DCH_Resources_Information_AuditRsp_resourceOperationalState),
        ('availabilityStatus', _E_DCH_Resources_Information_AuditRsp_availabilityStatus),
        ('iE-Extensions', _E_DCH_Resources_Information_AuditRsp_iE_Extensions),
        ])
    E_DCH_Resources_Information_AuditRsp._ext = []
    
    #-----< E-DCH-Resources-Information-AuditRsp-ExtIEs >-----#
    E_DCH_Resources_Information_AuditRsp_ExtIEs = CLASS(name='E-DCH-Resources-Information-AuditRsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_Resources_Information_AuditRsp_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    E_DCH_Resources_Information_AuditRsp_ExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _E_DCH_Resources_Information_AuditRsp_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PLCCH-InformationList-AuditRsp >-----#
    PLCCH_InformationList_AuditRsp = SEQ_OF(name='PLCCH-InformationList-AuditRsp', mode=MODE_TYPE)
    _PLCCH_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __PLCCH_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___PLCCH_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____PLCCH_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___PLCCH_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 711), ('criticality', 'ignore'), ('Value', ____PLCCH_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __PLCCH_InformationList_AuditRsp__item__id._const_tab = ___PLCCH_InformationList_AuditRsp__item__id_tab
    __PLCCH_InformationList_AuditRsp__item__id._const_tab_at = None
    __PLCCH_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __PLCCH_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __PLCCH_InformationList_AuditRsp__item__criticality._const_tab = ___PLCCH_InformationList_AuditRsp__item__id_tab
    __PLCCH_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __PLCCH_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __PLCCH_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __PLCCH_InformationList_AuditRsp__item__value._const_tab = ___PLCCH_InformationList_AuditRsp__item__id_tab
    __PLCCH_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __PLCCH_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _PLCCH_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __PLCCH_InformationList_AuditRsp__item__id),
        ('criticality', __PLCCH_InformationList_AuditRsp__item__criticality),
        ('value', __PLCCH_InformationList_AuditRsp__item__value),
        ])
    _PLCCH_InformationList_AuditRsp__item_._ext = None
    PLCCH_InformationList_AuditRsp._cont = _PLCCH_InformationList_AuditRsp__item_
    PLCCH_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PLCCH-InformationItemIE-AuditRsp >-----#
    PLCCH_InformationItemIE_AuditRsp = CLASS(name='PLCCH-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PLCCH_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    PLCCH_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 711), ('criticality', 'ignore'), ('Value', _PLCCH_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< S-CCPCH-768-InformationList-AuditRsp >-----#
    S_CCPCH_768_InformationList_AuditRsp = SEQ_OF(name='S-CCPCH-768-InformationList-AuditRsp', mode=MODE_TYPE)
    _S_CCPCH_768_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __S_CCPCH_768_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___S_CCPCH_768_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____S_CCPCH_768_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    ___S_CCPCH_768_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 726), ('criticality', 'ignore'), ('Value', ____S_CCPCH_768_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __S_CCPCH_768_InformationList_AuditRsp__item__id._const_tab = ___S_CCPCH_768_InformationList_AuditRsp__item__id_tab
    __S_CCPCH_768_InformationList_AuditRsp__item__id._const_tab_at = None
    __S_CCPCH_768_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __S_CCPCH_768_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __S_CCPCH_768_InformationList_AuditRsp__item__criticality._const_tab = ___S_CCPCH_768_InformationList_AuditRsp__item__id_tab
    __S_CCPCH_768_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __S_CCPCH_768_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __S_CCPCH_768_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __S_CCPCH_768_InformationList_AuditRsp__item__value._const_tab = ___S_CCPCH_768_InformationList_AuditRsp__item__id_tab
    __S_CCPCH_768_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __S_CCPCH_768_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _S_CCPCH_768_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __S_CCPCH_768_InformationList_AuditRsp__item__id),
        ('criticality', __S_CCPCH_768_InformationList_AuditRsp__item__criticality),
        ('value', __S_CCPCH_768_InformationList_AuditRsp__item__value),
        ])
    _S_CCPCH_768_InformationList_AuditRsp__item_._ext = None
    S_CCPCH_768_InformationList_AuditRsp._cont = _S_CCPCH_768_InformationList_AuditRsp__item_
    S_CCPCH_768_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=480)], ev=None, er=[])
    
    #-----< S-CCPCH-768-InformationItemIE-AuditRsp >-----#
    S_CCPCH_768_InformationItemIE_AuditRsp = CLASS(name='S-CCPCH-768-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _S_CCPCH_768_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    S_CCPCH_768_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 726), ('criticality', 'ignore'), ('Value', _S_CCPCH_768_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PRACH-768-InformationList-AuditRsp >-----#
    PRACH_768_InformationList_AuditRsp = SEQ_OF(name='PRACH-768-InformationList-AuditRsp', mode=MODE_TYPE)
    _PRACH_768_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __PRACH_768_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___PRACH_768_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____PRACH_768_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    ___PRACH_768_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 737), ('criticality', 'ignore'), ('Value', ____PRACH_768_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __PRACH_768_InformationList_AuditRsp__item__id._const_tab = ___PRACH_768_InformationList_AuditRsp__item__id_tab
    __PRACH_768_InformationList_AuditRsp__item__id._const_tab_at = None
    __PRACH_768_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __PRACH_768_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __PRACH_768_InformationList_AuditRsp__item__criticality._const_tab = ___PRACH_768_InformationList_AuditRsp__item__id_tab
    __PRACH_768_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __PRACH_768_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __PRACH_768_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __PRACH_768_InformationList_AuditRsp__item__value._const_tab = ___PRACH_768_InformationList_AuditRsp__item__id_tab
    __PRACH_768_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __PRACH_768_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _PRACH_768_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __PRACH_768_InformationList_AuditRsp__item__id),
        ('criticality', __PRACH_768_InformationList_AuditRsp__item__criticality),
        ('value', __PRACH_768_InformationList_AuditRsp__item__value),
        ])
    _PRACH_768_InformationList_AuditRsp__item_._ext = None
    PRACH_768_InformationList_AuditRsp._cont = _PRACH_768_InformationList_AuditRsp__item_
    PRACH_768_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PRACH-768-InformationItemIE-AuditRsp >-----#
    PRACH_768_InformationItemIE_AuditRsp = CLASS(name='PRACH-768-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PRACH_768_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    PRACH_768_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 737), ('criticality', 'ignore'), ('Value', _PRACH_768_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RUCCH-InformationList-AuditRsp >-----#
    E_RUCCH_InformationList_AuditRsp = SEQ_OF(name='E-RUCCH-InformationList-AuditRsp', mode=MODE_TYPE)
    _E_RUCCH_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __E_RUCCH_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___E_RUCCH_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____E_RUCCH_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___E_RUCCH_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 798), ('criticality', 'ignore'), ('Value', ____E_RUCCH_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RUCCH_InformationList_AuditRsp__item__id._const_tab = ___E_RUCCH_InformationList_AuditRsp__item__id_tab
    __E_RUCCH_InformationList_AuditRsp__item__id._const_tab_at = None
    __E_RUCCH_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __E_RUCCH_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __E_RUCCH_InformationList_AuditRsp__item__criticality._const_tab = ___E_RUCCH_InformationList_AuditRsp__item__id_tab
    __E_RUCCH_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __E_RUCCH_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __E_RUCCH_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __E_RUCCH_InformationList_AuditRsp__item__value._const_tab = ___E_RUCCH_InformationList_AuditRsp__item__id_tab
    __E_RUCCH_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __E_RUCCH_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _E_RUCCH_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __E_RUCCH_InformationList_AuditRsp__item__id),
        ('criticality', __E_RUCCH_InformationList_AuditRsp__item__criticality),
        ('value', __E_RUCCH_InformationList_AuditRsp__item__value),
        ])
    _E_RUCCH_InformationList_AuditRsp__item_._ext = None
    E_RUCCH_InformationList_AuditRsp._cont = _E_RUCCH_InformationList_AuditRsp__item_
    E_RUCCH_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< E-RUCCH-InformationItemIE-AuditRsp >-----#
    E_RUCCH_InformationItemIE_AuditRsp = CLASS(name='E-RUCCH-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _E_RUCCH_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    E_RUCCH_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 798), ('criticality', 'ignore'), ('Value', _E_RUCCH_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RUCCH-768-InformationList-AuditRsp >-----#
    E_RUCCH_768_InformationList_AuditRsp = SEQ_OF(name='E-RUCCH-768-InformationList-AuditRsp', mode=MODE_TYPE)
    _E_RUCCH_768_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __E_RUCCH_768_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___E_RUCCH_768_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____E_RUCCH_768_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    ___E_RUCCH_768_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 812), ('criticality', 'ignore'), ('Value', ____E_RUCCH_768_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RUCCH_768_InformationList_AuditRsp__item__id._const_tab = ___E_RUCCH_768_InformationList_AuditRsp__item__id_tab
    __E_RUCCH_768_InformationList_AuditRsp__item__id._const_tab_at = None
    __E_RUCCH_768_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __E_RUCCH_768_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __E_RUCCH_768_InformationList_AuditRsp__item__criticality._const_tab = ___E_RUCCH_768_InformationList_AuditRsp__item__id_tab
    __E_RUCCH_768_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __E_RUCCH_768_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __E_RUCCH_768_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __E_RUCCH_768_InformationList_AuditRsp__item__value._const_tab = ___E_RUCCH_768_InformationList_AuditRsp__item__id_tab
    __E_RUCCH_768_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __E_RUCCH_768_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _E_RUCCH_768_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __E_RUCCH_768_InformationList_AuditRsp__item__id),
        ('criticality', __E_RUCCH_768_InformationList_AuditRsp__item__criticality),
        ('value', __E_RUCCH_768_InformationList_AuditRsp__item__value),
        ])
    _E_RUCCH_768_InformationList_AuditRsp__item_._ext = None
    E_RUCCH_768_InformationList_AuditRsp._cont = _E_RUCCH_768_InformationList_AuditRsp__item_
    E_RUCCH_768_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< E-RUCCH-768-InformationItemIE-AuditRsp >-----#
    E_RUCCH_768_InformationItemIE_AuditRsp = CLASS(name='E-RUCCH-768-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _E_RUCCH_768_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    E_RUCCH_768_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 812), ('criticality', 'ignore'), ('Value', _E_RUCCH_768_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Cell-Frequency-List-Information-LCR-MulFreq-AuditRsp >-----#
    Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp = SEQ_OF(name='Cell-Frequency-List-Information-LCR-MulFreq-AuditRsp', mode=MODE_TYPE)
    _Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp')))
    ___Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 914), ('criticality', 'ignore'), ('Value', ____Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id._const_tab = ___Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id_tab
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id._const_tab_at = None
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id._const_tab_id = 'id'
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__criticality._const_tab = ___Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id_tab
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__value._const_tab = ___Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id_tab
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__value._const_tab_id = 'Value'
    _Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item_._cont = ASN1Dict([
        ('id', __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id),
        ('criticality', __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__criticality),
        ('value', __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__value),
        ])
    _Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item_._ext = None
    Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp._cont = _Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item_
    Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< Cell-Frequency-List-InformationIE-LCR-MulFreq-AuditRsp >-----#
    Cell_Frequency_List_InformationIE_LCR_MulFreq_AuditRsp = CLASS(name='Cell-Frequency-List-InformationIE-LCR-MulFreq-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Cell_Frequency_List_InformationIE_LCR_MulFreq_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp')))
    Cell_Frequency_List_InformationIE_LCR_MulFreq_AuditRsp._val = ASN1Set(rv=[dict([('id', 914), ('criticality', 'ignore'), ('Value', _Cell_Frequency_List_InformationIE_LCR_MulFreq_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp >-----#
    Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp = SEQ(name='Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp', mode=MODE_TYPE)
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__id._const_tab = ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__id_tab
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__id._const_tab_at = None
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__criticality._const_tab = ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__criticality_tab
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__extensionValue._const_tab = ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__extensionValue_tab
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__id),
        ('criticality', ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__extensionValue),
        ])
    __Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item_._ext = None
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions._cont = __Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item_
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp._cont = ASN1Dict([
        ('uARFCN', _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_uARFCN),
        ('resourceOperationalState', _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_resourceOperationalState),
        ('availabilityStatus', _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_availabilityStatus),
        ('iE-Extensions', _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions),
        ])
    Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp._ext = []
    
    #-----< Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp-ExtIEs >-----#
    Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_ExtIEs = CLASS(name='Cell-Frequency-List-InformationItem-LCR-MulFreq-AuditRsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UPPCH-LCR-InformationList-AuditRsp >-----#
    UPPCH_LCR_InformationList_AuditRsp = SEQ_OF(name='UPPCH-LCR-InformationList-AuditRsp', mode=MODE_TYPE)
    _UPPCH_LCR_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __UPPCH_LCR_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___UPPCH_LCR_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____UPPCH_LCR_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UPPCH-LCR-InformationItem-AuditRsp')))
    ___UPPCH_LCR_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 922), ('criticality', 'ignore'), ('Value', ____UPPCH_LCR_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UPPCH_LCR_InformationList_AuditRsp__item__id._const_tab = ___UPPCH_LCR_InformationList_AuditRsp__item__id_tab
    __UPPCH_LCR_InformationList_AuditRsp__item__id._const_tab_at = None
    __UPPCH_LCR_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __UPPCH_LCR_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __UPPCH_LCR_InformationList_AuditRsp__item__criticality._const_tab = ___UPPCH_LCR_InformationList_AuditRsp__item__id_tab
    __UPPCH_LCR_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __UPPCH_LCR_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __UPPCH_LCR_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __UPPCH_LCR_InformationList_AuditRsp__item__value._const_tab = ___UPPCH_LCR_InformationList_AuditRsp__item__id_tab
    __UPPCH_LCR_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __UPPCH_LCR_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _UPPCH_LCR_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __UPPCH_LCR_InformationList_AuditRsp__item__id),
        ('criticality', __UPPCH_LCR_InformationList_AuditRsp__item__criticality),
        ('value', __UPPCH_LCR_InformationList_AuditRsp__item__value),
        ])
    _UPPCH_LCR_InformationList_AuditRsp__item_._ext = None
    UPPCH_LCR_InformationList_AuditRsp._cont = _UPPCH_LCR_InformationList_AuditRsp__item_
    UPPCH_LCR_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< UPPCH-LCR-InformationIE-AuditRsp >-----#
    UPPCH_LCR_InformationIE_AuditRsp = CLASS(name='UPPCH-LCR-InformationIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UPPCH_LCR_InformationIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UPPCH-LCR-InformationItem-AuditRsp')))
    UPPCH_LCR_InformationIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 922), ('criticality', 'ignore'), ('Value', _UPPCH_LCR_InformationIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UPPCH-LCR-InformationItem-AuditRsp >-----#
    UPPCH_LCR_InformationItem_AuditRsp = SEQ(name='UPPCH-LCR-InformationItem-AuditRsp', mode=MODE_TYPE)
    _UPPCH_LCR_InformationItem_AuditRsp_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')), opt=True)
    _UPPCH_LCR_InformationItem_AuditRsp_uPPCHPositionLCR = INT(name='uPPCHPositionLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UPPCHPositionLCR')))
    _UPPCH_LCR_InformationItem_AuditRsp_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _UPPCH_LCR_InformationItem_AuditRsp_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab = ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_at = None
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab = ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab = ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__id),
        ('criticality', ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__criticality),
        ('extensionValue', ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__extensionValue),
        ])
    __UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item_._ext = None
    _UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions._cont = __UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item_
    _UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UPPCH_LCR_InformationItem_AuditRsp._cont = ASN1Dict([
        ('uARFCN', _UPPCH_LCR_InformationItem_AuditRsp_uARFCN),
        ('uPPCHPositionLCR', _UPPCH_LCR_InformationItem_AuditRsp_uPPCHPositionLCR),
        ('resourceOperationalState', _UPPCH_LCR_InformationItem_AuditRsp_resourceOperationalState),
        ('availabilityStatus', _UPPCH_LCR_InformationItem_AuditRsp_availabilityStatus),
        ('iE-Extensions', _UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions),
        ])
    UPPCH_LCR_InformationItem_AuditRsp._ext = []
    
    #-----< UPPCH-LCR-InformationItem-AuditRsp-ExtIEs >-----#
    UPPCH_LCR_InformationItem_AuditRsp_ExtIEs = CLASS(name='UPPCH-LCR-InformationItem-AuditRsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UPPCH_LCR_InformationItem_AuditRsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultipleFreq-HS-DSCH-Resources-InformationList-AuditRsp >-----#
    MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp = SEQ_OF(name='MultipleFreq-HS-DSCH-Resources-InformationList-AuditRsp', mode=MODE_TYPE)
    _MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-DSCH-Resources-Information-AuditRsp')))
    ___MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 611), ('criticality', 'ignore'), ('Value', ____MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id._const_tab = ___MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id_tab
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id._const_tab_at = None
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__criticality._const_tab = ___MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id_tab
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__value._const_tab = ___MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id_tab
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id),
        ('criticality', __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__criticality),
        ('value', __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__value),
        ])
    _MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item_._ext = None
    MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp._cont = _MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item_
    MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< MultipleFreq-HS-DSCH-Resources-InformationItem-AuditRsp >-----#
    MultipleFreq_HS_DSCH_Resources_InformationItem_AuditRsp = CLASS(name='MultipleFreq-HS-DSCH-Resources-InformationItem-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _MultipleFreq_HS_DSCH_Resources_InformationItem_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-DSCH-Resources-Information-AuditRsp')))
    MultipleFreq_HS_DSCH_Resources_InformationItem_AuditRsp._val = ASN1Set(rv=[dict([('id', 611), ('criticality', 'ignore'), ('Value', _MultipleFreq_HS_DSCH_Resources_InformationItem_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MultipleFreq-E-DCH-Resources-InformationList-AuditRsp >-----#
    MultipleFreq_E_DCH_Resources_InformationList_AuditRsp = SEQ_OF(name='MultipleFreq-E-DCH-Resources-InformationList-AuditRsp', mode=MODE_TYPE)
    _MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DCH-Resources-Information-AuditRsp')))
    ___MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 672), ('criticality', 'ignore'), ('Value', ____MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id._const_tab = ___MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id_tab
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id._const_tab_at = None
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__criticality._const_tab = ___MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id_tab
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__value._const_tab = ___MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id_tab
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id),
        ('criticality', __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__criticality),
        ('value', __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__value),
        ])
    _MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item_._ext = None
    MultipleFreq_E_DCH_Resources_InformationList_AuditRsp._cont = _MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item_
    MultipleFreq_E_DCH_Resources_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< MultipleFreq-E-DCH-Resources-InformationItem-AuditRsp >-----#
    MultipleFreq_E_DCH_Resources_InformationItem_AuditRsp = CLASS(name='MultipleFreq-E-DCH-Resources-InformationItem-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _MultipleFreq_E_DCH_Resources_InformationItem_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DCH-Resources-Information-AuditRsp')))
    MultipleFreq_E_DCH_Resources_InformationItem_AuditRsp._val = ASN1Set(rv=[dict([('id', 672), ('criticality', 'ignore'), ('Value', _MultipleFreq_E_DCH_Resources_InformationItem_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CCP-InformationList-AuditRsp >-----#
    CCP_InformationList_AuditRsp = SEQ_OF(name='CCP-InformationList-AuditRsp', mode=MODE_TYPE)
    _CCP_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __CCP_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___CCP_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____CCP_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCP-InformationItem-AuditRsp')))
    ___CCP_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 14), ('criticality', 'ignore'), ('Value', ____CCP_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CCP_InformationList_AuditRsp__item__id._const_tab = ___CCP_InformationList_AuditRsp__item__id_tab
    __CCP_InformationList_AuditRsp__item__id._const_tab_at = None
    __CCP_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __CCP_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __CCP_InformationList_AuditRsp__item__criticality._const_tab = ___CCP_InformationList_AuditRsp__item__id_tab
    __CCP_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __CCP_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __CCP_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __CCP_InformationList_AuditRsp__item__value._const_tab = ___CCP_InformationList_AuditRsp__item__id_tab
    __CCP_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __CCP_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _CCP_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __CCP_InformationList_AuditRsp__item__id),
        ('criticality', __CCP_InformationList_AuditRsp__item__criticality),
        ('value', __CCP_InformationList_AuditRsp__item__value),
        ])
    _CCP_InformationList_AuditRsp__item_._ext = None
    CCP_InformationList_AuditRsp._cont = _CCP_InformationList_AuditRsp__item_
    CCP_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CCP-InformationItemIE-AuditRsp >-----#
    CCP_InformationItemIE_AuditRsp = CLASS(name='CCP-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CCP_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCP-InformationItem-AuditRsp')))
    CCP_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 14), ('criticality', 'ignore'), ('Value', _CCP_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CCP-InformationItem-AuditRsp >-----#
    CCP_InformationItem_AuditRsp = SEQ(name='CCP-InformationItem-AuditRsp', mode=MODE_TYPE)
    _CCP_InformationItem_AuditRsp_communicationControlPortID = INT(name='communicationControlPortID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _CCP_InformationItem_AuditRsp_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _CCP_InformationItem_AuditRsp_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _CCP_InformationItem_AuditRsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCP_InformationItem_AuditRsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CCP_InformationItem_AuditRsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCP_InformationItem_AuditRsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab = ____CCP_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_at = None
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CCP_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCP_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab = ____CCP_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CCP_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCP_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab = ____CCP_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CCP_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CCP_InformationItem_AuditRsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CCP_InformationItem_AuditRsp_iE_Extensions__item__id),
        ('criticality', ___CCP_InformationItem_AuditRsp_iE_Extensions__item__criticality),
        ('extensionValue', ___CCP_InformationItem_AuditRsp_iE_Extensions__item__extensionValue),
        ])
    __CCP_InformationItem_AuditRsp_iE_Extensions__item_._ext = None
    _CCP_InformationItem_AuditRsp_iE_Extensions._cont = __CCP_InformationItem_AuditRsp_iE_Extensions__item_
    _CCP_InformationItem_AuditRsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCP_InformationItem_AuditRsp._cont = ASN1Dict([
        ('communicationControlPortID', _CCP_InformationItem_AuditRsp_communicationControlPortID),
        ('resourceOperationalState', _CCP_InformationItem_AuditRsp_resourceOperationalState),
        ('availabilityStatus', _CCP_InformationItem_AuditRsp_availabilityStatus),
        ('iE-Extensions', _CCP_InformationItem_AuditRsp_iE_Extensions),
        ])
    CCP_InformationItem_AuditRsp._ext = []
    
    #-----< CCP-InformationItem-AuditRsp-ExtIEs >-----#
    CCP_InformationItem_AuditRsp_ExtIEs = CLASS(name='CCP-InformationItem-AuditRsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CCP_InformationItem_AuditRsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Local-Cell-InformationList-AuditRsp >-----#
    Local_Cell_InformationList_AuditRsp = SEQ_OF(name='Local-Cell-InformationList-AuditRsp', mode=MODE_TYPE)
    _Local_Cell_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Local_Cell_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Local_Cell_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Local_Cell_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-InformationItem-AuditRsp')))
    ___Local_Cell_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 125), ('criticality', 'ignore'), ('Value', ____Local_Cell_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Local_Cell_InformationList_AuditRsp__item__id._const_tab = ___Local_Cell_InformationList_AuditRsp__item__id_tab
    __Local_Cell_InformationList_AuditRsp__item__id._const_tab_at = None
    __Local_Cell_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __Local_Cell_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Local_Cell_InformationList_AuditRsp__item__criticality._const_tab = ___Local_Cell_InformationList_AuditRsp__item__id_tab
    __Local_Cell_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __Local_Cell_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __Local_Cell_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Local_Cell_InformationList_AuditRsp__item__value._const_tab = ___Local_Cell_InformationList_AuditRsp__item__id_tab
    __Local_Cell_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __Local_Cell_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _Local_Cell_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __Local_Cell_InformationList_AuditRsp__item__id),
        ('criticality', __Local_Cell_InformationList_AuditRsp__item__criticality),
        ('value', __Local_Cell_InformationList_AuditRsp__item__value),
        ])
    _Local_Cell_InformationList_AuditRsp__item_._ext = None
    Local_Cell_InformationList_AuditRsp._cont = _Local_Cell_InformationList_AuditRsp__item_
    Local_Cell_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Local-Cell-InformationItemIE-AuditRsp >-----#
    Local_Cell_InformationItemIE_AuditRsp = CLASS(name='Local-Cell-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Local_Cell_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-InformationItem-AuditRsp')))
    Local_Cell_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 125), ('criticality', 'ignore'), ('Value', _Local_Cell_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Local-Cell-InformationItem-AuditRsp >-----#
    Local_Cell_InformationItem_AuditRsp = SEQ(name='Local-Cell-InformationItem-AuditRsp', mode=MODE_TYPE)
    _Local_Cell_InformationItem_AuditRsp_local_Cell_ID = INT(name='local-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Local_Cell_InformationItem_AuditRsp_dl_or_global_capacityCredit = INT(name='dl-or-global-capacityCredit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-or-Global-CapacityCredit')))
    _Local_Cell_InformationItem_AuditRsp_ul_capacityCredit = INT(name='ul-capacityCredit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-CapacityCredit')), opt=True)
    _Local_Cell_InformationItem_AuditRsp_commonChannelsCapacityConsumptionLaw = SEQ_OF(name='commonChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonChannelsCapacityConsumptionLaw')))
    _Local_Cell_InformationItem_AuditRsp_dedicatedChannelsCapacityConsumptionLaw = SEQ_OF(name='dedicatedChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedChannelsCapacityConsumptionLaw')))
    _Local_Cell_InformationItem_AuditRsp_maximumDL_PowerCapability = INT(name='maximumDL-PowerCapability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumDL-PowerCapability')), opt=True)
    _Local_Cell_InformationItem_AuditRsp_minSpreadingFactor = ENUM(name='minSpreadingFactor', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MinSpreadingFactor')), opt=True)
    _Local_Cell_InformationItem_AuditRsp_minimumDL_PowerCapability = INT(name='minimumDL-PowerCapability', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MinimumDL-PowerCapability')), opt=True)
    _Local_Cell_InformationItem_AuditRsp_local_Cell_Group_ID = INT(name='local-Cell-Group-ID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')), opt=True)
    _Local_Cell_InformationItem_AuditRsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Local_Cell_InformationItem_AuditRsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReferenceClockAvailability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_4 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TTI2ms-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-SF-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-Combining-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Max-UE-DTX-Cycle')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_12 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_15 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBMS-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-FACH-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-PCH-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_18 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDU-SizeCapability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_20 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBSFN-Only-Mode-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_21 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormatCapability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_22 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDU-SizeCapability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_23 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_24 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AI-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_25 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_26 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_27 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-Power-Boosting-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_28 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-MIMO-Combined-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_29 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Cell-Capability-Info')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_30 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Semi-PersistentScheduling-CapabilityLCR')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_31 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-CapabilityLCR')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_32 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-HSDPCCH-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_33 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PowerOffsetForS-CPICHCapability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_34 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TxDiversityOnDLControlChannelsByMIMOUECapability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_35 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Capability')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_36 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Dual-Band-Capability-Info')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_37 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellPortion-CapabilityLCR')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_38 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_39 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TS0-CapabilityLCR')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_40 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrecodingWeightSetRestriction')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_41 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container-TDD-LCR')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_42 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Capability-ContainerLCR')))
    _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_43 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Adaptive-Special-Burst-Power-CapabilityLCR')))
    ____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 435), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 504), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 610), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 665), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 704), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'conditional')]), dict([('id', 705), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'conditional')]), dict([('id', 703), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'conditional')]), dict([('id', 687), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 707), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 831), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 874), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'conditional')]), dict([('id', 833), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 837), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 860), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 901), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 895), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 896), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_17), ('presence', 'conditional')]), dict([('id', 861), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 864), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_19), ('presence', 'optional')]), dict([('id', 879), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_20), ('presence', 'optional')]), dict([('id', 871), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_21), ('presence', 'optional')]), dict([('id', 959), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_22), ('presence', 'optional')]), dict([('id', 987), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_23), ('presence', 'optional')]), dict([('id', 988), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_24), ('presence', 'optional')]), dict([('id', 994), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_25), ('presence', 'optional')]), dict([('id', 1031), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_26), ('presence', 'optional')]), dict([('id', 1020), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_27), ('presence', 'optional')]), dict([('id', 997), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_28), ('presence', 'optional')]), dict([('id', 1044), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_29), ('presence', 'optional')]), dict([('id', 1047), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_30), ('presence', 'optional')]), dict([('id', 1053), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_31), ('presence', 'optional')]), dict([('id', 1078), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_32), ('presence', 'optional')]), dict([('id', 1101), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_33), ('presence', 'optional')]), dict([('id', 1103), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_34), ('presence', 'optional')]), dict([('id', 1089), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_35), ('presence', 'optional')]), dict([('id', 1091), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_36), ('presence', 'optional')]), dict([('id', 1115), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_37), ('presence', 'optional')]), dict([('id', 1142), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_38), ('presence', 'optional')]), dict([('id', 1155), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_39), ('presence', 'optional')]), dict([('id', 1171), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_40), ('presence', 'optional')]), dict([('id', 1186), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_41), ('presence', 'optional')]), dict([('id', 1191), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_42), ('presence', 'optional')]), dict([('id', 1196), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_43), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab = ____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_at = None
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab = ____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab = ____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Local_Cell_InformationItem_AuditRsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id),
        ('criticality', ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue),
        ])
    __Local_Cell_InformationItem_AuditRsp_iE_Extensions__item_._ext = None
    _Local_Cell_InformationItem_AuditRsp_iE_Extensions._cont = __Local_Cell_InformationItem_AuditRsp_iE_Extensions__item_
    _Local_Cell_InformationItem_AuditRsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Local_Cell_InformationItem_AuditRsp._cont = ASN1Dict([
        ('local-Cell-ID', _Local_Cell_InformationItem_AuditRsp_local_Cell_ID),
        ('dl-or-global-capacityCredit', _Local_Cell_InformationItem_AuditRsp_dl_or_global_capacityCredit),
        ('ul-capacityCredit', _Local_Cell_InformationItem_AuditRsp_ul_capacityCredit),
        ('commonChannelsCapacityConsumptionLaw', _Local_Cell_InformationItem_AuditRsp_commonChannelsCapacityConsumptionLaw),
        ('dedicatedChannelsCapacityConsumptionLaw', _Local_Cell_InformationItem_AuditRsp_dedicatedChannelsCapacityConsumptionLaw),
        ('maximumDL-PowerCapability', _Local_Cell_InformationItem_AuditRsp_maximumDL_PowerCapability),
        ('minSpreadingFactor', _Local_Cell_InformationItem_AuditRsp_minSpreadingFactor),
        ('minimumDL-PowerCapability', _Local_Cell_InformationItem_AuditRsp_minimumDL_PowerCapability),
        ('local-Cell-Group-ID', _Local_Cell_InformationItem_AuditRsp_local_Cell_Group_ID),
        ('iE-Extensions', _Local_Cell_InformationItem_AuditRsp_iE_Extensions),
        ])
    Local_Cell_InformationItem_AuditRsp._ext = []
    
    #-----< Local-Cell-InformationItem-AuditRsp-ExtIEs >-----#
    Local_Cell_InformationItem_AuditRsp_ExtIEs = CLASS(name='Local-Cell-InformationItem-AuditRsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReferenceClockAvailability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_4 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TTI2ms-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-SF-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-Combining-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Max-UE-DTX-Cycle')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_12 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_15 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBMS-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-FACH-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-PCH-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_18 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDU-SizeCapability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_20 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBSFN-Only-Mode-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_21 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormatCapability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_22 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDU-SizeCapability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_23 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_24 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AI-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_25 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_26 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_27 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-Power-Boosting-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_28 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-MIMO-Combined-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_29 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Cell-Capability-Info')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_30 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Semi-PersistentScheduling-CapabilityLCR')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_31 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-CapabilityLCR')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_32 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-HSDPCCH-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_33 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PowerOffsetForS-CPICHCapability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_34 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TxDiversityOnDLControlChannelsByMIMOUECapability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_35 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Capability')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_36 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Dual-Band-Capability-Info')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_37 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellPortion-CapabilityLCR')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_38 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_39 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TS0-CapabilityLCR')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_40 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrecodingWeightSetRestriction')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_41 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container-TDD-LCR')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_42 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Capability-ContainerLCR')))
    _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_43 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Adaptive-Special-Burst-Power-CapabilityLCR')))
    Local_Cell_InformationItem_AuditRsp_ExtIEs._val = ASN1Set(rv=[dict([('id', 435), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 504), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 610), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 665), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 704), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_4), ('presence', 'conditional')]), dict([('id', 705), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_5), ('presence', 'conditional')]), dict([('id', 703), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_6), ('presence', 'conditional')]), dict([('id', 687), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 707), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 831), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 874), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_11), ('presence', 'conditional')]), dict([('id', 833), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 837), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_13), ('presence', 'optional')]), dict([('id', 860), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_14), ('presence', 'optional')]), dict([('id', 901), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_15), ('presence', 'optional')]), dict([('id', 895), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_16), ('presence', 'optional')]), dict([('id', 896), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_17), ('presence', 'conditional')]), dict([('id', 861), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_18), ('presence', 'optional')]), dict([('id', 864), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_19), ('presence', 'optional')]), dict([('id', 879), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_20), ('presence', 'optional')]), dict([('id', 871), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_21), ('presence', 'optional')]), dict([('id', 959), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_22), ('presence', 'optional')]), dict([('id', 987), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_23), ('presence', 'optional')]), dict([('id', 988), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_24), ('presence', 'optional')]), dict([('id', 994), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_25), ('presence', 'optional')]), dict([('id', 1031), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_26), ('presence', 'optional')]), dict([('id', 1020), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_27), ('presence', 'optional')]), dict([('id', 997), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_28), ('presence', 'optional')]), dict([('id', 1044), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_29), ('presence', 'optional')]), dict([('id', 1047), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_30), ('presence', 'optional')]), dict([('id', 1053), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_31), ('presence', 'optional')]), dict([('id', 1078), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_32), ('presence', 'optional')]), dict([('id', 1101), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_33), ('presence', 'optional')]), dict([('id', 1103), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_34), ('presence', 'optional')]), dict([('id', 1089), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_35), ('presence', 'optional')]), dict([('id', 1091), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_36), ('presence', 'optional')]), dict([('id', 1115), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_37), ('presence', 'optional')]), dict([('id', 1142), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_38), ('presence', 'optional')]), dict([('id', 1155), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_39), ('presence', 'optional')]), dict([('id', 1171), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_40), ('presence', 'optional')]), dict([('id', 1186), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_41), ('presence', 'optional')]), dict([('id', 1191), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_42), ('presence', 'optional')]), dict([('id', 1196), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_43), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Local-Cell-Group-InformationList-AuditRsp >-----#
    Local_Cell_Group_InformationList_AuditRsp = SEQ_OF(name='Local-Cell-Group-InformationList-AuditRsp', mode=MODE_TYPE)
    _Local_Cell_Group_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Local_Cell_Group_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Local_Cell_Group_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Local_Cell_Group_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-Group-InformationItem-AuditRsp')))
    ___Local_Cell_Group_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', ____Local_Cell_Group_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Local_Cell_Group_InformationList_AuditRsp__item__id._const_tab = ___Local_Cell_Group_InformationList_AuditRsp__item__id_tab
    __Local_Cell_Group_InformationList_AuditRsp__item__id._const_tab_at = None
    __Local_Cell_Group_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __Local_Cell_Group_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Local_Cell_Group_InformationList_AuditRsp__item__criticality._const_tab = ___Local_Cell_Group_InformationList_AuditRsp__item__id_tab
    __Local_Cell_Group_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __Local_Cell_Group_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __Local_Cell_Group_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Local_Cell_Group_InformationList_AuditRsp__item__value._const_tab = ___Local_Cell_Group_InformationList_AuditRsp__item__id_tab
    __Local_Cell_Group_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __Local_Cell_Group_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _Local_Cell_Group_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __Local_Cell_Group_InformationList_AuditRsp__item__id),
        ('criticality', __Local_Cell_Group_InformationList_AuditRsp__item__criticality),
        ('value', __Local_Cell_Group_InformationList_AuditRsp__item__value),
        ])
    _Local_Cell_Group_InformationList_AuditRsp__item_._ext = None
    Local_Cell_Group_InformationList_AuditRsp._cont = _Local_Cell_Group_InformationList_AuditRsp__item_
    Local_Cell_Group_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Local-Cell-Group-InformationItemIE-AuditRsp >-----#
    Local_Cell_Group_InformationItemIE_AuditRsp = CLASS(name='Local-Cell-Group-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Local_Cell_Group_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-Group-InformationItem-AuditRsp')))
    Local_Cell_Group_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _Local_Cell_Group_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Local-Cell-Group-InformationItem-AuditRsp >-----#
    Local_Cell_Group_InformationItem_AuditRsp = SEQ(name='Local-Cell-Group-InformationItem-AuditRsp', mode=MODE_TYPE)
    _Local_Cell_Group_InformationItem_AuditRsp_local_Cell_Group_ID = INT(name='local-Cell-Group-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Local_Cell_Group_InformationItem_AuditRsp_dl_or_global_capacityCredit = INT(name='dl-or-global-capacityCredit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-or-Global-CapacityCredit')))
    _Local_Cell_Group_InformationItem_AuditRsp_ul_capacityCredit = INT(name='ul-capacityCredit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-CapacityCredit')), opt=True)
    _Local_Cell_Group_InformationItem_AuditRsp_commonChannelsCapacityConsumptionLaw = SEQ_OF(name='commonChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonChannelsCapacityConsumptionLaw')))
    _Local_Cell_Group_InformationItem_AuditRsp_dedicatedChannelsCapacityConsumptionLaw = SEQ_OF(name='dedicatedChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedChannelsCapacityConsumptionLaw')))
    _Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    ____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 687), ('criticality', 'ignore'), ('Extension', _____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab = ____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_at = None
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab = ____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab = ____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id),
        ('criticality', ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue),
        ])
    __Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item_._ext = None
    _Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions._cont = __Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item_
    _Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Local_Cell_Group_InformationItem_AuditRsp._cont = ASN1Dict([
        ('local-Cell-Group-ID', _Local_Cell_Group_InformationItem_AuditRsp_local_Cell_Group_ID),
        ('dl-or-global-capacityCredit', _Local_Cell_Group_InformationItem_AuditRsp_dl_or_global_capacityCredit),
        ('ul-capacityCredit', _Local_Cell_Group_InformationItem_AuditRsp_ul_capacityCredit),
        ('commonChannelsCapacityConsumptionLaw', _Local_Cell_Group_InformationItem_AuditRsp_commonChannelsCapacityConsumptionLaw),
        ('dedicatedChannelsCapacityConsumptionLaw', _Local_Cell_Group_InformationItem_AuditRsp_dedicatedChannelsCapacityConsumptionLaw),
        ('iE-Extensions', _Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions),
        ])
    Local_Cell_Group_InformationItem_AuditRsp._ext = []
    
    #-----< Local-Cell-Group-InformationItem-AuditRsp-ExtIEs >-----#
    Local_Cell_Group_InformationItem_AuditRsp_ExtIEs = CLASS(name='Local-Cell-Group-InformationItem-AuditRsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Local_Cell_Group_InformationItem_AuditRsp_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _Local_Cell_Group_InformationItem_AuditRsp_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    Local_Cell_Group_InformationItem_AuditRsp_ExtIEs._val = ASN1Set(rv=[dict([('id', 687), ('criticality', 'ignore'), ('Extension', _Local_Cell_Group_InformationItem_AuditRsp_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _Local_Cell_Group_InformationItem_AuditRsp_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Power-Local-Cell-Group-InformationList-AuditRsp >-----#
    Power_Local_Cell_Group_InformationList_AuditRsp = SEQ_OF(name='Power-Local-Cell-Group-InformationList-AuditRsp', mode=MODE_TYPE)
    _Power_Local_Cell_Group_InformationList_AuditRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Power_Local_Cell_Group_InformationList_AuditRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Power_Local_Cell_Group_InformationList_AuditRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationItem-AuditRsp')))
    ___Power_Local_Cell_Group_InformationList_AuditRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 498), ('criticality', 'ignore'), ('Value', ____Power_Local_Cell_Group_InformationList_AuditRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__id._const_tab = ___Power_Local_Cell_Group_InformationList_AuditRsp__item__id_tab
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__id._const_tab_at = None
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__id._const_tab_id = 'id'
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__criticality._const_tab = ___Power_Local_Cell_Group_InformationList_AuditRsp__item__id_tab
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__criticality._const_tab_at = ('..', 'id')
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__criticality._const_tab_id = 'criticality'
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__value._const_tab = ___Power_Local_Cell_Group_InformationList_AuditRsp__item__id_tab
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__value._const_tab_at = ('..', 'id')
    __Power_Local_Cell_Group_InformationList_AuditRsp__item__value._const_tab_id = 'Value'
    _Power_Local_Cell_Group_InformationList_AuditRsp__item_._cont = ASN1Dict([
        ('id', __Power_Local_Cell_Group_InformationList_AuditRsp__item__id),
        ('criticality', __Power_Local_Cell_Group_InformationList_AuditRsp__item__criticality),
        ('value', __Power_Local_Cell_Group_InformationList_AuditRsp__item__value),
        ])
    _Power_Local_Cell_Group_InformationList_AuditRsp__item_._ext = None
    Power_Local_Cell_Group_InformationList_AuditRsp._cont = _Power_Local_Cell_Group_InformationList_AuditRsp__item_
    Power_Local_Cell_Group_InformationList_AuditRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Power-Local-Cell-Group-InformationItemIE-AuditRsp >-----#
    Power_Local_Cell_Group_InformationItemIE_AuditRsp = CLASS(name='Power-Local-Cell-Group-InformationItemIE-AuditRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Power_Local_Cell_Group_InformationItemIE_AuditRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationItem-AuditRsp')))
    Power_Local_Cell_Group_InformationItemIE_AuditRsp._val = ASN1Set(rv=[dict([('id', 498), ('criticality', 'ignore'), ('Value', _Power_Local_Cell_Group_InformationItemIE_AuditRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Power-Local-Cell-Group-InformationItem-AuditRsp >-----#
    Power_Local_Cell_Group_InformationItem_AuditRsp = SEQ(name='Power-Local-Cell-Group-InformationItem-AuditRsp', mode=MODE_TYPE)
    _Power_Local_Cell_Group_InformationItem_AuditRsp_power_Local_Cell_Group_ID = INT(name='power-Local-Cell-Group-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Power_Local_Cell_Group_InformationItem_AuditRsp_maximumDL_PowerCapability = INT(name='maximumDL-PowerCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumDL-PowerCapability')))
    _Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab = ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_at = None
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab = ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab = ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id),
        ('criticality', ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue),
        ])
    __Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item_._ext = None
    _Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions._cont = __Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item_
    _Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Power_Local_Cell_Group_InformationItem_AuditRsp._cont = ASN1Dict([
        ('power-Local-Cell-Group-ID', _Power_Local_Cell_Group_InformationItem_AuditRsp_power_Local_Cell_Group_ID),
        ('maximumDL-PowerCapability', _Power_Local_Cell_Group_InformationItem_AuditRsp_maximumDL_PowerCapability),
        ('iE-Extensions', _Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions),
        ])
    Power_Local_Cell_Group_InformationItem_AuditRsp._ext = []
    
    #-----< Power-Local-Cell-Group-InformationItem-AuditRsp-ExtIEs >-----#
    Power_Local_Cell_Group_InformationItem_AuditRsp_ExtIEs = CLASS(name='Power-Local-Cell-Group-InformationItem-AuditRsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Power_Local_Cell_Group_InformationItem_AuditRsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AuditFailure >-----#
    AuditFailure = SEQ(name='AuditFailure', mode=MODE_TYPE)
    _AuditFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __AuditFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___AuditFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____AuditFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____AuditFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____AuditFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____AuditFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _____AuditFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____AuditFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AuditFailure_protocolIEs__item__id._const_tab = ____AuditFailure_protocolIEs__item__id_tab
    ___AuditFailure_protocolIEs__item__id._const_tab_at = None
    ___AuditFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___AuditFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___AuditFailure_protocolIEs__item__criticality._const_tab = ____AuditFailure_protocolIEs__item__id_tab
    ___AuditFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AuditFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AuditFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___AuditFailure_protocolIEs__item__value._const_tab = ____AuditFailure_protocolIEs__item__id_tab
    ___AuditFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AuditFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __AuditFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AuditFailure_protocolIEs__item__id),
        ('criticality', ___AuditFailure_protocolIEs__item__criticality),
        ('value', ___AuditFailure_protocolIEs__item__value),
        ])
    __AuditFailure_protocolIEs__item_._ext = None
    _AuditFailure_protocolIEs._cont = __AuditFailure_protocolIEs__item_
    _AuditFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _AuditFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AuditFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___AuditFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____AuditFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AuditFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditFailure_protocolExtensions__item__id._const_tab = ____AuditFailure_protocolExtensions__item__id_tab
    ___AuditFailure_protocolExtensions__item__id._const_tab_at = None
    ___AuditFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___AuditFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AuditFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AuditFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditFailure_protocolExtensions__item__criticality._const_tab = ____AuditFailure_protocolExtensions__item__criticality_tab
    ___AuditFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___AuditFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___AuditFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AuditFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____AuditFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuditFailure_protocolExtensions__item__extensionValue._const_tab = ____AuditFailure_protocolExtensions__item__extensionValue_tab
    ___AuditFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AuditFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __AuditFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___AuditFailure_protocolExtensions__item__id),
        ('criticality', ___AuditFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___AuditFailure_protocolExtensions__item__extensionValue),
        ])
    __AuditFailure_protocolExtensions__item_._ext = None
    _AuditFailure_protocolExtensions._cont = __AuditFailure_protocolExtensions__item_
    _AuditFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AuditFailure._cont = ASN1Dict([
        ('protocolIEs', _AuditFailure_protocolIEs),
        ('protocolExtensions', _AuditFailure_protocolExtensions),
        ])
    AuditFailure._ext = []
    
    #-----< AuditFailure-IEs >-----#
    AuditFailure_IEs = CLASS(name='AuditFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _AuditFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _AuditFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    AuditFailure_IEs._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _AuditFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _AuditFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AuditFailure-Extensions >-----#
    AuditFailure_Extensions = CLASS(name='AuditFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    AuditFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationRequest >-----#
    CommonMeasurementInitiationRequest = SEQ(name='CommonMeasurementInitiationRequest', mode=MODE_TYPE)
    _CommonMeasurementInitiationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementInitiationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rqst')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementType')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementFilterCoefficient')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristics')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FNReportingIndicator')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'reject'), ('Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 32), ('criticality', 'reject'), ('Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 34), ('criticality', 'reject'), ('Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 132), ('criticality', 'reject'), ('Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'reject'), ('Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'reject'), ('Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationRequest_protocolIEs__item__id._const_tab = ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementInitiationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab = ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementInitiationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonMeasurementInitiationRequest_protocolIEs__item__value._const_tab = ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonMeasurementInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementInitiationRequest_protocolIEs__item__id),
        ('criticality', ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality),
        ('value', ___CommonMeasurementInitiationRequest_protocolIEs__item__value),
        ])
    __CommonMeasurementInitiationRequest_protocolIEs__item_._ext = None
    _CommonMeasurementInitiationRequest_protocolIEs._cont = __CommonMeasurementInitiationRequest_protocolIEs__item_
    _CommonMeasurementInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementInitiationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementInitiationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementAccuracy')))
    _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoveryBehavior')))
    _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RTWP-ReportingIndicator')))
    _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RTWP-CellPortion-ReportingIndicator')))
    _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPowerReporting')))
    _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Time-ID')))
    ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Extension', _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 624), ('criticality', 'ignore'), ('Extension', _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 787), ('criticality', 'reject'), ('Extension', _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 788), ('criticality', 'reject'), ('Extension', _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 823), ('criticality', 'ignore'), ('Extension', _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1000), ('criticality', 'ignore'), ('Extension', _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__id._const_tab = ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonMeasurementInitiationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementInitiationRequest_protocolExtensions__item__id),
        ('criticality', ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementInitiationRequest_protocolExtensions__item_._ext = None
    _CommonMeasurementInitiationRequest_protocolExtensions._cont = __CommonMeasurementInitiationRequest_protocolExtensions__item_
    _CommonMeasurementInitiationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementInitiationRequest._cont = ASN1Dict([
        ('protocolIEs', _CommonMeasurementInitiationRequest_protocolIEs),
        ('protocolExtensions', _CommonMeasurementInitiationRequest_protocolExtensions),
        ])
    CommonMeasurementInitiationRequest._ext = []
    
    #-----< CommonMeasurementInitiationRequest-IEs >-----#
    CommonMeasurementInitiationRequest_IEs = CLASS(name='CommonMeasurementInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rqst')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementType')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementFilterCoefficient')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristics')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FNReportingIndicator')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    CommonMeasurementInitiationRequest_IEs._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'reject'), ('Value', _CommonMeasurementInitiationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 32), ('criticality', 'reject'), ('Value', _CommonMeasurementInitiationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 34), ('criticality', 'reject'), ('Value', _CommonMeasurementInitiationRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 132), ('criticality', 'reject'), ('Value', _CommonMeasurementInitiationRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'reject'), ('Value', _CommonMeasurementInitiationRequest_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _CommonMeasurementInitiationRequest_IEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'reject'), ('Value', _CommonMeasurementInitiationRequest_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationRequest-Extensions >-----#
    CommonMeasurementInitiationRequest_Extensions = CLASS(name='CommonMeasurementInitiationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CommonMeasurementInitiationRequest_Extensions_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementAccuracy')))
    _CommonMeasurementInitiationRequest_Extensions_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoveryBehavior')))
    _CommonMeasurementInitiationRequest_Extensions_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RTWP-ReportingIndicator')))
    _CommonMeasurementInitiationRequest_Extensions_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RTWP-CellPortion-ReportingIndicator')))
    _CommonMeasurementInitiationRequest_Extensions_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPowerReporting')))
    _CommonMeasurementInitiationRequest_Extensions_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'GANSS-Time-ID')))
    CommonMeasurementInitiationRequest_Extensions._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Extension', _CommonMeasurementInitiationRequest_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 624), ('criticality', 'ignore'), ('Extension', _CommonMeasurementInitiationRequest_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 787), ('criticality', 'reject'), ('Extension', _CommonMeasurementInitiationRequest_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 788), ('criticality', 'reject'), ('Extension', _CommonMeasurementInitiationRequest_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 823), ('criticality', 'ignore'), ('Extension', _CommonMeasurementInitiationRequest_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 1000), ('criticality', 'ignore'), ('Extension', _CommonMeasurementInitiationRequest_Extensions_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementObjectType-CM-Rqst >-----#
    CommonMeasurementObjectType_CM_Rqst = CHOICE(name='CommonMeasurementObjectType-CM-Rqst', mode=MODE_TYPE)
    _CommonMeasurementObjectType_CM_Rqst_cell = SEQ(name='cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-CM-Rqst')))
    _CommonMeasurementObjectType_CM_Rqst_rACH = SEQ(name='rACH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-CM-Rqst')))
    _CommonMeasurementObjectType_CM_Rqst_notUsed_cPCH = NULL(name='notUsed-cPCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CommonMeasurementObjectType_CM_Rqst_extension_CommonMeasurementObjectType_CM_Rqst = SEQ(name='extension-CommonMeasurementObjectType-CM-Rqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Extension-CommonMeasurementObjectType-CM-Rqst')))
    CommonMeasurementObjectType_CM_Rqst._cont = ASN1Dict([
        ('cell', _CommonMeasurementObjectType_CM_Rqst_cell),
        ('rACH', _CommonMeasurementObjectType_CM_Rqst_rACH),
        ('notUsed-cPCH', _CommonMeasurementObjectType_CM_Rqst_notUsed_cPCH),
        ('extension-CommonMeasurementObjectType-CM-Rqst', _CommonMeasurementObjectType_CM_Rqst_extension_CommonMeasurementObjectType_CM_Rqst),
        ])
    CommonMeasurementObjectType_CM_Rqst._ext = ['extension-CommonMeasurementObjectType-CM-Rqst']
    
    #-----< Extension-CommonMeasurementObjectType-CM-Rqst >-----#
    Extension_CommonMeasurementObjectType_CM_Rqst = SEQ(name='Extension-CommonMeasurementObjectType-CM-Rqst', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_CommonMeasurementObjectType_CM_Rqst_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PowerLocalCellGroup-CM-Rqst')))
    ___Extension_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ERACH-CM-Rqst')))
    __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab._val = ASN1Set(rv=[dict([('id', 654), ('criticality', 'reject'), ('Value', ___Extension_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1014), ('criticality', 'reject'), ('Value', ___Extension_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_CommonMeasurementObjectType_CM_Rqst_id._const_tab = __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rqst_id._const_tab_at = None
    _Extension_CommonMeasurementObjectType_CM_Rqst_id._const_tab_id = 'id'
    _Extension_CommonMeasurementObjectType_CM_Rqst_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_CommonMeasurementObjectType_CM_Rqst_criticality._const_tab = __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rqst_criticality._const_tab_at = ('..', 'id')
    _Extension_CommonMeasurementObjectType_CM_Rqst_criticality._const_tab_id = 'criticality'
    _Extension_CommonMeasurementObjectType_CM_Rqst_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_CommonMeasurementObjectType_CM_Rqst_value._const_tab = __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rqst_value._const_tab_at = ('..', 'id')
    _Extension_CommonMeasurementObjectType_CM_Rqst_value._const_tab_id = 'Value'
    Extension_CommonMeasurementObjectType_CM_Rqst._cont = ASN1Dict([
        ('id', _Extension_CommonMeasurementObjectType_CM_Rqst_id),
        ('criticality', _Extension_CommonMeasurementObjectType_CM_Rqst_criticality),
        ('value', _Extension_CommonMeasurementObjectType_CM_Rqst_value),
        ])
    Extension_CommonMeasurementObjectType_CM_Rqst._ext = None
    
    #-----< Extension-CommonMeasurementObjectType-CM-RqstIE >-----#
    Extension_CommonMeasurementObjectType_CM_RqstIE = CLASS(name='Extension-CommonMeasurementObjectType-CM-RqstIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_CommonMeasurementObjectType_CM_RqstIE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PowerLocalCellGroup-CM-Rqst')))
    _Extension_CommonMeasurementObjectType_CM_RqstIE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ERACH-CM-Rqst')))
    Extension_CommonMeasurementObjectType_CM_RqstIE._val = ASN1Set(rv=[dict([('id', 654), ('criticality', 'reject'), ('Value', _Extension_CommonMeasurementObjectType_CM_RqstIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1014), ('criticality', 'reject'), ('Value', _Extension_CommonMeasurementObjectType_CM_RqstIE_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< ERACH-CM-Rqst >-----#
    ERACH_CM_Rqst = SEQ(name='ERACH-CM-Rqst', mode=MODE_TYPE)
    _ERACH_CM_Rqst_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _ERACH_CM_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ERACH_CM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ERACH_CM_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ERACH_CM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ERACH_CM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERACH_CM_Rqst_iE_Extensions__item__id._const_tab = ____ERACH_CM_Rqst_iE_Extensions__item__id_tab
    ___ERACH_CM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___ERACH_CM_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___ERACH_CM_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ERACH_CM_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ERACH_CM_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERACH_CM_Rqst_iE_Extensions__item__criticality._const_tab = ____ERACH_CM_Rqst_iE_Extensions__item__criticality_tab
    ___ERACH_CM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ERACH_CM_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ERACH_CM_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ERACH_CM_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ERACH_CM_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERACH_CM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____ERACH_CM_Rqst_iE_Extensions__item__extensionValue_tab
    ___ERACH_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ERACH_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ERACH_CM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ERACH_CM_Rqst_iE_Extensions__item__id),
        ('criticality', ___ERACH_CM_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___ERACH_CM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __ERACH_CM_Rqst_iE_Extensions__item_._ext = None
    _ERACH_CM_Rqst_iE_Extensions._cont = __ERACH_CM_Rqst_iE_Extensions__item_
    _ERACH_CM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ERACH_CM_Rqst._cont = ASN1Dict([
        ('c-ID', _ERACH_CM_Rqst_c_ID),
        ('iE-Extensions', _ERACH_CM_Rqst_iE_Extensions),
        ])
    ERACH_CM_Rqst._ext = []
    
    #-----< ERACHItem-CM-Rqst-ExtIEs >-----#
    ERACHItem_CM_Rqst_ExtIEs = CLASS(name='ERACHItem-CM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ERACHItem_CM_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cell-CM-Rqst >-----#
    Cell_CM_Rqst = SEQ(name='Cell-CM-Rqst', mode=MODE_TYPE)
    _Cell_CM_Rqst_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _Cell_CM_Rqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')), opt=True)
    _Cell_CM_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_CM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_CM_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_CM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NeighbouringCellMeasurementInformation')))
    _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UPPCHPositionLCR')))
    _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AdditionalTimeSlotListLCR')))
    ____Cell_CM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 469), ('criticality', 'reject'), ('Extension', _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 455), ('criticality', 'ignore'), ('Extension', _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 919), ('criticality', 'reject'), ('Extension', _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 971), ('criticality', 'ignore'), ('Extension', _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Cell_CM_Rqst_iE_Extensions__item__id._const_tab = ____Cell_CM_Rqst_iE_Extensions__item__id_tab
    ___Cell_CM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___Cell_CM_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_CM_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Cell_CM_Rqst_iE_Extensions__item__criticality._const_tab = ____Cell_CM_Rqst_iE_Extensions__item__id_tab
    ___Cell_CM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_CM_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_CM_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Cell_CM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____Cell_CM_Rqst_iE_Extensions__item__id_tab
    ___Cell_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_CM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_CM_Rqst_iE_Extensions__item__id),
        ('criticality', ___Cell_CM_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_CM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __Cell_CM_Rqst_iE_Extensions__item_._ext = None
    _Cell_CM_Rqst_iE_Extensions._cont = __Cell_CM_Rqst_iE_Extensions__item_
    _Cell_CM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_CM_Rqst._cont = ASN1Dict([
        ('c-ID', _Cell_CM_Rqst_c_ID),
        ('timeSlot', _Cell_CM_Rqst_timeSlot),
        ('iE-Extensions', _Cell_CM_Rqst_iE_Extensions),
        ])
    Cell_CM_Rqst._ext = []
    
    #-----< CellItem-CM-Rqst-ExtIEs >-----#
    CellItem_CM_Rqst_ExtIEs = CLASS(name='CellItem-CM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CellItem_CM_Rqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _CellItem_CM_Rqst_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NeighbouringCellMeasurementInformation')))
    _CellItem_CM_Rqst_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _CellItem_CM_Rqst_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UPPCHPositionLCR')))
    _CellItem_CM_Rqst_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AdditionalTimeSlotListLCR')))
    CellItem_CM_Rqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 469), ('criticality', 'reject'), ('Extension', _CellItem_CM_Rqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 455), ('criticality', 'ignore'), ('Extension', _CellItem_CM_Rqst_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _CellItem_CM_Rqst_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 919), ('criticality', 'reject'), ('Extension', _CellItem_CM_Rqst_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 971), ('criticality', 'ignore'), ('Extension', _CellItem_CM_Rqst_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RACH-CM-Rqst >-----#
    RACH_CM_Rqst = SEQ(name='RACH-CM-Rqst', mode=MODE_TYPE)
    _RACH_CM_Rqst_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _RACH_CM_Rqst_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _RACH_CM_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RACH_CM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RACH_CM_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RACH_CM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RACH_CM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACH_CM_Rqst_iE_Extensions__item__id._const_tab = ____RACH_CM_Rqst_iE_Extensions__item__id_tab
    ___RACH_CM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___RACH_CM_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___RACH_CM_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RACH_CM_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RACH_CM_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACH_CM_Rqst_iE_Extensions__item__criticality._const_tab = ____RACH_CM_Rqst_iE_Extensions__item__criticality_tab
    ___RACH_CM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RACH_CM_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RACH_CM_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RACH_CM_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RACH_CM_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACH_CM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____RACH_CM_Rqst_iE_Extensions__item__extensionValue_tab
    ___RACH_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RACH_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RACH_CM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RACH_CM_Rqst_iE_Extensions__item__id),
        ('criticality', ___RACH_CM_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___RACH_CM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __RACH_CM_Rqst_iE_Extensions__item_._ext = None
    _RACH_CM_Rqst_iE_Extensions._cont = __RACH_CM_Rqst_iE_Extensions__item_
    _RACH_CM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RACH_CM_Rqst._cont = ASN1Dict([
        ('c-ID', _RACH_CM_Rqst_c_ID),
        ('commonTransportChannelID', _RACH_CM_Rqst_commonTransportChannelID),
        ('iE-Extensions', _RACH_CM_Rqst_iE_Extensions),
        ])
    RACH_CM_Rqst._ext = []
    
    #-----< RACHItem-CM-Rqst-ExtIEs >-----#
    RACHItem_CM_Rqst_ExtIEs = CLASS(name='RACHItem-CM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RACHItem_CM_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PowerLocalCellGroup-CM-Rqst >-----#
    PowerLocalCellGroup_CM_Rqst = SEQ(name='PowerLocalCellGroup-CM-Rqst', mode=MODE_TYPE)
    _PowerLocalCellGroup_CM_Rqst_powerLocalCellGroupID = INT(name='powerLocalCellGroupID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _PowerLocalCellGroup_CM_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerLocalCellGroup_CM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__id._const_tab = ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__id_tab
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__criticality._const_tab = ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__criticality_tab
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__extensionValue_tab
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PowerLocalCellGroup_CM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__id),
        ('criticality', ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __PowerLocalCellGroup_CM_Rqst_iE_Extensions__item_._ext = None
    _PowerLocalCellGroup_CM_Rqst_iE_Extensions._cont = __PowerLocalCellGroup_CM_Rqst_iE_Extensions__item_
    _PowerLocalCellGroup_CM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerLocalCellGroup_CM_Rqst._cont = ASN1Dict([
        ('powerLocalCellGroupID', _PowerLocalCellGroup_CM_Rqst_powerLocalCellGroupID),
        ('iE-Extensions', _PowerLocalCellGroup_CM_Rqst_iE_Extensions),
        ])
    PowerLocalCellGroup_CM_Rqst._ext = []
    
    #-----< PowerLocalCellGroup-CM-Rqst-ExtIEs >-----#
    PowerLocalCellGroup_CM_Rqst_ExtIEs = CLASS(name='PowerLocalCellGroup-CM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PowerLocalCellGroup_CM_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationResponse >-----#
    CommonMeasurementInitiationResponse = SEQ(name='CommonMeasurementInitiationResponse', mode=MODE_TYPE)
    _CommonMeasurementInitiationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementInitiationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rsp')))
    _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 268), ('criticality', 'ignore'), ('Value', _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationResponse_protocolIEs__item__id._const_tab = ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementInitiationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab = ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementInitiationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonMeasurementInitiationResponse_protocolIEs__item__value._const_tab = ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonMeasurementInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementInitiationResponse_protocolIEs__item__id),
        ('criticality', ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality),
        ('value', ___CommonMeasurementInitiationResponse_protocolIEs__item__value),
        ])
    __CommonMeasurementInitiationResponse_protocolIEs__item_._ext = None
    _CommonMeasurementInitiationResponse_protocolIEs._cont = __CommonMeasurementInitiationResponse_protocolIEs__item_
    _CommonMeasurementInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementInitiationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementInitiationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementAccuracy')))
    _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoverySupportIndicator')))
    _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPowerSupportIndicator')))
    _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPower')))
    ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'ignore'), ('Extension', _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 626), ('criticality', 'ignore'), ('Extension', _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 824), ('criticality', 'ignore'), ('Extension', _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 698), ('criticality', 'ignore'), ('Extension', _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__id._const_tab = ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonMeasurementInitiationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementInitiationResponse_protocolExtensions__item__id),
        ('criticality', ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementInitiationResponse_protocolExtensions__item_._ext = None
    _CommonMeasurementInitiationResponse_protocolExtensions._cont = __CommonMeasurementInitiationResponse_protocolExtensions__item_
    _CommonMeasurementInitiationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementInitiationResponse._cont = ASN1Dict([
        ('protocolIEs', _CommonMeasurementInitiationResponse_protocolIEs),
        ('protocolExtensions', _CommonMeasurementInitiationResponse_protocolExtensions),
        ])
    CommonMeasurementInitiationResponse._ext = []
    
    #-----< CommonMeasurementInitiationResponse-IEs >-----#
    CommonMeasurementInitiationResponse_IEs = CLASS(name='CommonMeasurementInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonMeasurementInitiationResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _CommonMeasurementInitiationResponse_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rsp')))
    _CommonMeasurementInitiationResponse_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _CommonMeasurementInitiationResponse_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CommonMeasurementInitiationResponse_IEs._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _CommonMeasurementInitiationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _CommonMeasurementInitiationResponse_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 268), ('criticality', 'ignore'), ('Value', _CommonMeasurementInitiationResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _CommonMeasurementInitiationResponse_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationResponse-Extensions >-----#
    CommonMeasurementInitiationResponse_Extensions = CLASS(name='CommonMeasurementInitiationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CommonMeasurementInitiationResponse_Extensions_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementAccuracy')))
    _CommonMeasurementInitiationResponse_Extensions_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoverySupportIndicator')))
    _CommonMeasurementInitiationResponse_Extensions_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPowerSupportIndicator')))
    _CommonMeasurementInitiationResponse_Extensions_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPower')))
    CommonMeasurementInitiationResponse_Extensions._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'ignore'), ('Extension', _CommonMeasurementInitiationResponse_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 626), ('criticality', 'ignore'), ('Extension', _CommonMeasurementInitiationResponse_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 824), ('criticality', 'ignore'), ('Extension', _CommonMeasurementInitiationResponse_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 698), ('criticality', 'ignore'), ('Extension', _CommonMeasurementInitiationResponse_Extensions_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementObjectType-CM-Rsp >-----#
    CommonMeasurementObjectType_CM_Rsp = CHOICE(name='CommonMeasurementObjectType-CM-Rsp', mode=MODE_TYPE)
    _CommonMeasurementObjectType_CM_Rsp_cell = SEQ(name='cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-CM-Rsp')))
    _CommonMeasurementObjectType_CM_Rsp_rACH = SEQ(name='rACH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-CM-Rsp')))
    _CommonMeasurementObjectType_CM_Rsp_notUsed_cPCH = NULL(name='notUsed-cPCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CommonMeasurementObjectType_CM_Rsp_extension_CommonMeasurementObjectType_CM_Rsp = SEQ(name='extension-CommonMeasurementObjectType-CM-Rsp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Extension-CommonMeasurementObjectType-CM-Rsp')))
    CommonMeasurementObjectType_CM_Rsp._cont = ASN1Dict([
        ('cell', _CommonMeasurementObjectType_CM_Rsp_cell),
        ('rACH', _CommonMeasurementObjectType_CM_Rsp_rACH),
        ('notUsed-cPCH', _CommonMeasurementObjectType_CM_Rsp_notUsed_cPCH),
        ('extension-CommonMeasurementObjectType-CM-Rsp', _CommonMeasurementObjectType_CM_Rsp_extension_CommonMeasurementObjectType_CM_Rsp),
        ])
    CommonMeasurementObjectType_CM_Rsp._ext = ['extension-CommonMeasurementObjectType-CM-Rsp']
    
    #-----< Extension-CommonMeasurementObjectType-CM-Rsp >-----#
    Extension_CommonMeasurementObjectType_CM_Rsp = SEQ(name='Extension-CommonMeasurementObjectType-CM-Rsp', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_CommonMeasurementObjectType_CM_Rsp_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_CommonMeasurementObjectType_CM_Rsp_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PowerLocalCellGroup-CM-Rsp')))
    ___Extension_CommonMeasurementObjectType_CM_Rsp_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ERACH-CM-Rsp')))
    __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab._val = ASN1Set(rv=[dict([('id', 655), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementObjectType_CM_Rsp_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1015), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementObjectType_CM_Rsp_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_CommonMeasurementObjectType_CM_Rsp_id._const_tab = __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rsp_id._const_tab_at = None
    _Extension_CommonMeasurementObjectType_CM_Rsp_id._const_tab_id = 'id'
    _Extension_CommonMeasurementObjectType_CM_Rsp_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_CommonMeasurementObjectType_CM_Rsp_criticality._const_tab = __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rsp_criticality._const_tab_at = ('..', 'id')
    _Extension_CommonMeasurementObjectType_CM_Rsp_criticality._const_tab_id = 'criticality'
    _Extension_CommonMeasurementObjectType_CM_Rsp_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_CommonMeasurementObjectType_CM_Rsp_value._const_tab = __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rsp_value._const_tab_at = ('..', 'id')
    _Extension_CommonMeasurementObjectType_CM_Rsp_value._const_tab_id = 'Value'
    Extension_CommonMeasurementObjectType_CM_Rsp._cont = ASN1Dict([
        ('id', _Extension_CommonMeasurementObjectType_CM_Rsp_id),
        ('criticality', _Extension_CommonMeasurementObjectType_CM_Rsp_criticality),
        ('value', _Extension_CommonMeasurementObjectType_CM_Rsp_value),
        ])
    Extension_CommonMeasurementObjectType_CM_Rsp._ext = None
    
    #-----< Extension-CommonMeasurementObjectType-CM-RspIE >-----#
    Extension_CommonMeasurementObjectType_CM_RspIE = CLASS(name='Extension-CommonMeasurementObjectType-CM-RspIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_CommonMeasurementObjectType_CM_RspIE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PowerLocalCellGroup-CM-Rsp')))
    _Extension_CommonMeasurementObjectType_CM_RspIE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ERACH-CM-Rsp')))
    Extension_CommonMeasurementObjectType_CM_RspIE._val = ASN1Set(rv=[dict([('id', 655), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementObjectType_CM_RspIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1015), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementObjectType_CM_RspIE_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< ERACH-CM-Rsp >-----#
    ERACH_CM_Rsp = SEQ(name='ERACH-CM-Rsp', mode=MODE_TYPE)
    _ERACH_CM_Rsp_commonMeasurementValue = CHOICE(name='commonMeasurementValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementValue')))
    _ERACH_CM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ERACH_CM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ERACH_CM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ERACH_CM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ERACH_CM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERACH_CM_Rsp_iE_Extensions__item__id._const_tab = ____ERACH_CM_Rsp_iE_Extensions__item__id_tab
    ___ERACH_CM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___ERACH_CM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___ERACH_CM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ERACH_CM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ERACH_CM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERACH_CM_Rsp_iE_Extensions__item__criticality._const_tab = ____ERACH_CM_Rsp_iE_Extensions__item__criticality_tab
    ___ERACH_CM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ERACH_CM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ERACH_CM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ERACH_CM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ERACH_CM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERACH_CM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____ERACH_CM_Rsp_iE_Extensions__item__extensionValue_tab
    ___ERACH_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ERACH_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ERACH_CM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ERACH_CM_Rsp_iE_Extensions__item__id),
        ('criticality', ___ERACH_CM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___ERACH_CM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __ERACH_CM_Rsp_iE_Extensions__item_._ext = None
    _ERACH_CM_Rsp_iE_Extensions._cont = __ERACH_CM_Rsp_iE_Extensions__item_
    _ERACH_CM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ERACH_CM_Rsp._cont = ASN1Dict([
        ('commonMeasurementValue', _ERACH_CM_Rsp_commonMeasurementValue),
        ('iE-Extensions', _ERACH_CM_Rsp_iE_Extensions),
        ])
    ERACH_CM_Rsp._ext = []
    
    #-----< ERACHItem-CM-Rsp-ExtIEs >-----#
    ERACHItem_CM_Rsp_ExtIEs = CLASS(name='ERACHItem-CM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ERACHItem_CM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cell-CM-Rsp >-----#
    Cell_CM_Rsp = SEQ(name='Cell-CM-Rsp', mode=MODE_TYPE)
    _Cell_CM_Rsp_commonMeasurementValue = CHOICE(name='commonMeasurementValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementValue')))
    _Cell_CM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_CM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_CM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_CM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Cell_CM_Rsp_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AdditionalMeasurementValueList')))
    _____Cell_CM_Rsp_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotMeasurementValueListLCR')))
    ____Cell_CM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 972), ('criticality', 'ignore'), ('Extension', _____Cell_CM_Rsp_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1082), ('criticality', 'ignore'), ('Extension', _____Cell_CM_Rsp_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Cell_CM_Rsp_iE_Extensions__item__id._const_tab = ____Cell_CM_Rsp_iE_Extensions__item__id_tab
    ___Cell_CM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Cell_CM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_CM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Cell_CM_Rsp_iE_Extensions__item__criticality._const_tab = ____Cell_CM_Rsp_iE_Extensions__item__id_tab
    ___Cell_CM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_CM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_CM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Cell_CM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Cell_CM_Rsp_iE_Extensions__item__id_tab
    ___Cell_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_CM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_CM_Rsp_iE_Extensions__item__id),
        ('criticality', ___Cell_CM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_CM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Cell_CM_Rsp_iE_Extensions__item_._ext = None
    _Cell_CM_Rsp_iE_Extensions._cont = __Cell_CM_Rsp_iE_Extensions__item_
    _Cell_CM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_CM_Rsp._cont = ASN1Dict([
        ('commonMeasurementValue', _Cell_CM_Rsp_commonMeasurementValue),
        ('iE-Extensions', _Cell_CM_Rsp_iE_Extensions),
        ])
    Cell_CM_Rsp._ext = []
    
    #-----< CellItem-CM-Rsp-ExtIEs >-----#
    CellItem_CM_Rsp_ExtIEs = CLASS(name='CellItem-CM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CellItem_CM_Rsp_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AdditionalMeasurementValueList')))
    _CellItem_CM_Rsp_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotMeasurementValueListLCR')))
    CellItem_CM_Rsp_ExtIEs._val = ASN1Set(rv=[dict([('id', 972), ('criticality', 'ignore'), ('Extension', _CellItem_CM_Rsp_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 1082), ('criticality', 'ignore'), ('Extension', _CellItem_CM_Rsp_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RACH-CM-Rsp >-----#
    RACH_CM_Rsp = SEQ(name='RACH-CM-Rsp', mode=MODE_TYPE)
    _RACH_CM_Rsp_commonMeasurementValue = CHOICE(name='commonMeasurementValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementValue')))
    _RACH_CM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RACH_CM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RACH_CM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RACH_CM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RACH_CM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACH_CM_Rsp_iE_Extensions__item__id._const_tab = ____RACH_CM_Rsp_iE_Extensions__item__id_tab
    ___RACH_CM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___RACH_CM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___RACH_CM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RACH_CM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RACH_CM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACH_CM_Rsp_iE_Extensions__item__criticality._const_tab = ____RACH_CM_Rsp_iE_Extensions__item__criticality_tab
    ___RACH_CM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RACH_CM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RACH_CM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RACH_CM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RACH_CM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RACH_CM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____RACH_CM_Rsp_iE_Extensions__item__extensionValue_tab
    ___RACH_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RACH_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RACH_CM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RACH_CM_Rsp_iE_Extensions__item__id),
        ('criticality', ___RACH_CM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___RACH_CM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __RACH_CM_Rsp_iE_Extensions__item_._ext = None
    _RACH_CM_Rsp_iE_Extensions._cont = __RACH_CM_Rsp_iE_Extensions__item_
    _RACH_CM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RACH_CM_Rsp._cont = ASN1Dict([
        ('commonMeasurementValue', _RACH_CM_Rsp_commonMeasurementValue),
        ('iE-Extensions', _RACH_CM_Rsp_iE_Extensions),
        ])
    RACH_CM_Rsp._ext = []
    
    #-----< RACHItem-CM-Rsp-ExtIEs >-----#
    RACHItem_CM_Rsp_ExtIEs = CLASS(name='RACHItem-CM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RACHItem_CM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PowerLocalCellGroup-CM-Rsp >-----#
    PowerLocalCellGroup_CM_Rsp = SEQ(name='PowerLocalCellGroup-CM-Rsp', mode=MODE_TYPE)
    _PowerLocalCellGroup_CM_Rsp_commonMeasurementValue = CHOICE(name='commonMeasurementValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementValue')))
    _PowerLocalCellGroup_CM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerLocalCellGroup_CM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__id._const_tab = ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__id_tab
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__criticality._const_tab = ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__criticality_tab
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__extensionValue_tab
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PowerLocalCellGroup_CM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__id),
        ('criticality', ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __PowerLocalCellGroup_CM_Rsp_iE_Extensions__item_._ext = None
    _PowerLocalCellGroup_CM_Rsp_iE_Extensions._cont = __PowerLocalCellGroup_CM_Rsp_iE_Extensions__item_
    _PowerLocalCellGroup_CM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerLocalCellGroup_CM_Rsp._cont = ASN1Dict([
        ('commonMeasurementValue', _PowerLocalCellGroup_CM_Rsp_commonMeasurementValue),
        ('iE-Extensions', _PowerLocalCellGroup_CM_Rsp_iE_Extensions),
        ])
    PowerLocalCellGroup_CM_Rsp._ext = []
    
    #-----< PowerLocalCellGroup-CM-Rsp-ExtIEs >-----#
    PowerLocalCellGroup_CM_Rsp_ExtIEs = CLASS(name='PowerLocalCellGroup-CM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PowerLocalCellGroup_CM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationFailure >-----#
    CommonMeasurementInitiationFailure = SEQ(name='CommonMeasurementInitiationFailure', mode=MODE_TYPE)
    _CommonMeasurementInitiationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementInitiationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationFailure_protocolIEs__item__id._const_tab = ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementInitiationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab = ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementInitiationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonMeasurementInitiationFailure_protocolIEs__item__value._const_tab = ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonMeasurementInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementInitiationFailure_protocolIEs__item__id),
        ('criticality', ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality),
        ('value', ___CommonMeasurementInitiationFailure_protocolIEs__item__value),
        ])
    __CommonMeasurementInitiationFailure_protocolIEs__item_._ext = None
    _CommonMeasurementInitiationFailure_protocolIEs._cont = __CommonMeasurementInitiationFailure_protocolIEs__item_
    _CommonMeasurementInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementInitiationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementInitiationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__id._const_tab = ____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonMeasurementInitiationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementInitiationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementInitiationFailure_protocolExtensions__item__criticality_tab
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonMeasurementInitiationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementInitiationFailure_protocolExtensions__item__id),
        ('criticality', ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementInitiationFailure_protocolExtensions__item_._ext = None
    _CommonMeasurementInitiationFailure_protocolExtensions._cont = __CommonMeasurementInitiationFailure_protocolExtensions__item_
    _CommonMeasurementInitiationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementInitiationFailure._cont = ASN1Dict([
        ('protocolIEs', _CommonMeasurementInitiationFailure_protocolIEs),
        ('protocolExtensions', _CommonMeasurementInitiationFailure_protocolExtensions),
        ])
    CommonMeasurementInitiationFailure._ext = []
    
    #-----< CommonMeasurementInitiationFailure-IEs >-----#
    CommonMeasurementInitiationFailure_IEs = CLASS(name='CommonMeasurementInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonMeasurementInitiationFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _CommonMeasurementInitiationFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _CommonMeasurementInitiationFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CommonMeasurementInitiationFailure_IEs._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _CommonMeasurementInitiationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _CommonMeasurementInitiationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _CommonMeasurementInitiationFailure_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationFailure-Extensions >-----#
    CommonMeasurementInitiationFailure_Extensions = CLASS(name='CommonMeasurementInitiationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonMeasurementInitiationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementReport >-----#
    CommonMeasurementReport = SEQ(name='CommonMeasurementReport', mode=MODE_TYPE)
    _CommonMeasurementReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rprt')))
    _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    ____CommonMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'ignore'), ('Value', _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementReport_protocolIEs__item__id._const_tab = ____CommonMeasurementReport_protocolIEs__item__id_tab
    ___CommonMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementReport_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonMeasurementReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonMeasurementReport_protocolIEs__item__criticality._const_tab = ____CommonMeasurementReport_protocolIEs__item__id_tab
    ___CommonMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonMeasurementReport_protocolIEs__item__value._const_tab = ____CommonMeasurementReport_protocolIEs__item__id_tab
    ___CommonMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonMeasurementReport_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementReport_protocolIEs__item__id),
        ('criticality', ___CommonMeasurementReport_protocolIEs__item__criticality),
        ('value', ___CommonMeasurementReport_protocolIEs__item__value),
        ])
    __CommonMeasurementReport_protocolIEs__item_._ext = None
    _CommonMeasurementReport_protocolIEs._cont = __CommonMeasurementReport_protocolIEs__item_
    _CommonMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementReport_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementReport_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonMeasurementReport_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoveryReportingIndicator')))
    _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPower')))
    ____CommonMeasurementReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 625), ('criticality', 'ignore'), ('Extension', _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 698), ('criticality', 'ignore'), ('Extension', _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementReport_protocolExtensions__item__id._const_tab = ____CommonMeasurementReport_protocolExtensions__item__id_tab
    ___CommonMeasurementReport_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementReport_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonMeasurementReport_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CommonMeasurementReport_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementReport_protocolExtensions__item__id_tab
    ___CommonMeasurementReport_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementReport_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementReport_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CommonMeasurementReport_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementReport_protocolExtensions__item__id_tab
    ___CommonMeasurementReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonMeasurementReport_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonMeasurementReport_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementReport_protocolExtensions__item__id),
        ('criticality', ___CommonMeasurementReport_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonMeasurementReport_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementReport_protocolExtensions__item_._ext = None
    _CommonMeasurementReport_protocolExtensions._cont = __CommonMeasurementReport_protocolExtensions__item_
    _CommonMeasurementReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementReport._cont = ASN1Dict([
        ('protocolIEs', _CommonMeasurementReport_protocolIEs),
        ('protocolExtensions', _CommonMeasurementReport_protocolExtensions),
        ])
    CommonMeasurementReport._ext = []
    
    #-----< CommonMeasurementReport-IEs >-----#
    CommonMeasurementReport_IEs = CLASS(name='CommonMeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonMeasurementReport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _CommonMeasurementReport_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rprt')))
    _CommonMeasurementReport_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    CommonMeasurementReport_IEs._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _CommonMeasurementReport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _CommonMeasurementReport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'ignore'), ('Value', _CommonMeasurementReport_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementReport-Extensions >-----#
    CommonMeasurementReport_Extensions = CLASS(name='CommonMeasurementReport-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CommonMeasurementReport_Extensions_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoveryReportingIndicator')))
    _CommonMeasurementReport_Extensions_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPower')))
    CommonMeasurementReport_Extensions._val = ASN1Set(rv=[dict([('id', 625), ('criticality', 'ignore'), ('Extension', _CommonMeasurementReport_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 698), ('criticality', 'ignore'), ('Extension', _CommonMeasurementReport_Extensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementObjectType-CM-Rprt >-----#
    CommonMeasurementObjectType_CM_Rprt = CHOICE(name='CommonMeasurementObjectType-CM-Rprt', mode=MODE_TYPE)
    _CommonMeasurementObjectType_CM_Rprt_cell = SEQ(name='cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-CM-Rprt')))
    _CommonMeasurementObjectType_CM_Rprt_rACH = SEQ(name='rACH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-CM-Rprt')))
    _CommonMeasurementObjectType_CM_Rprt_notUsed_cPCH = NULL(name='notUsed-cPCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CommonMeasurementObjectType_CM_Rprt_extension_CommonMeasurementObjectType_CM_Rprt = SEQ(name='extension-CommonMeasurementObjectType-CM-Rprt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Extension-CommonMeasurementObjectType-CM-Rprt')))
    CommonMeasurementObjectType_CM_Rprt._cont = ASN1Dict([
        ('cell', _CommonMeasurementObjectType_CM_Rprt_cell),
        ('rACH', _CommonMeasurementObjectType_CM_Rprt_rACH),
        ('notUsed-cPCH', _CommonMeasurementObjectType_CM_Rprt_notUsed_cPCH),
        ('extension-CommonMeasurementObjectType-CM-Rprt', _CommonMeasurementObjectType_CM_Rprt_extension_CommonMeasurementObjectType_CM_Rprt),
        ])
    CommonMeasurementObjectType_CM_Rprt._ext = ['extension-CommonMeasurementObjectType-CM-Rprt']
    
    #-----< Extension-CommonMeasurementObjectType-CM-Rprt >-----#
    Extension_CommonMeasurementObjectType_CM_Rprt = SEQ(name='Extension-CommonMeasurementObjectType-CM-Rprt', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_CommonMeasurementObjectType_CM_Rprt_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_CommonMeasurementObjectType_CM_Rprt_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PowerLocalCellGroup-CM-Rprt')))
    ___Extension_CommonMeasurementObjectType_CM_Rprt_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ERACH-CM-Rprt')))
    __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab._val = ASN1Set(rv=[dict([('id', 656), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementObjectType_CM_Rprt_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1016), ('criticality', 'ignore'), ('Value', ___Extension_CommonMeasurementObjectType_CM_Rprt_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_CommonMeasurementObjectType_CM_Rprt_id._const_tab = __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rprt_id._const_tab_at = None
    _Extension_CommonMeasurementObjectType_CM_Rprt_id._const_tab_id = 'id'
    _Extension_CommonMeasurementObjectType_CM_Rprt_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_CommonMeasurementObjectType_CM_Rprt_criticality._const_tab = __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rprt_criticality._const_tab_at = ('..', 'id')
    _Extension_CommonMeasurementObjectType_CM_Rprt_criticality._const_tab_id = 'criticality'
    _Extension_CommonMeasurementObjectType_CM_Rprt_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_CommonMeasurementObjectType_CM_Rprt_value._const_tab = __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rprt_value._const_tab_at = ('..', 'id')
    _Extension_CommonMeasurementObjectType_CM_Rprt_value._const_tab_id = 'Value'
    Extension_CommonMeasurementObjectType_CM_Rprt._cont = ASN1Dict([
        ('id', _Extension_CommonMeasurementObjectType_CM_Rprt_id),
        ('criticality', _Extension_CommonMeasurementObjectType_CM_Rprt_criticality),
        ('value', _Extension_CommonMeasurementObjectType_CM_Rprt_value),
        ])
    Extension_CommonMeasurementObjectType_CM_Rprt._ext = None
    
    #-----< Extension-CommonMeasurementObjectType-CM-RprtIE >-----#
    Extension_CommonMeasurementObjectType_CM_RprtIE = CLASS(name='Extension-CommonMeasurementObjectType-CM-RprtIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_CommonMeasurementObjectType_CM_RprtIE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PowerLocalCellGroup-CM-Rprt')))
    _Extension_CommonMeasurementObjectType_CM_RprtIE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ERACH-CM-Rprt')))
    Extension_CommonMeasurementObjectType_CM_RprtIE._val = ASN1Set(rv=[dict([('id', 656), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementObjectType_CM_RprtIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1016), ('criticality', 'ignore'), ('Value', _Extension_CommonMeasurementObjectType_CM_RprtIE_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ERACH-CM-Rprt >-----#
    ERACH_CM_Rprt = SEQ(name='ERACH-CM-Rprt', mode=MODE_TYPE)
    _ERACH_CM_Rprt_commonMeasurementValueInformation = CHOICE(name='commonMeasurementValueInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementValueInformation')))
    _ERACH_CM_Rprt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ERACH_CM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ERACH_CM_Rprt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ERACH_CM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ERACH_CM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERACH_CM_Rprt_iE_Extensions__item__id._const_tab = ____ERACH_CM_Rprt_iE_Extensions__item__id_tab
    ___ERACH_CM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___ERACH_CM_Rprt_iE_Extensions__item__id._const_tab_id = 'id'
    ___ERACH_CM_Rprt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ERACH_CM_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ERACH_CM_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERACH_CM_Rprt_iE_Extensions__item__criticality._const_tab = ____ERACH_CM_Rprt_iE_Extensions__item__criticality_tab
    ___ERACH_CM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ERACH_CM_Rprt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ERACH_CM_Rprt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ERACH_CM_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ERACH_CM_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERACH_CM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____ERACH_CM_Rprt_iE_Extensions__item__extensionValue_tab
    ___ERACH_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ERACH_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ERACH_CM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ERACH_CM_Rprt_iE_Extensions__item__id),
        ('criticality', ___ERACH_CM_Rprt_iE_Extensions__item__criticality),
        ('extensionValue', ___ERACH_CM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __ERACH_CM_Rprt_iE_Extensions__item_._ext = None
    _ERACH_CM_Rprt_iE_Extensions._cont = __ERACH_CM_Rprt_iE_Extensions__item_
    _ERACH_CM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ERACH_CM_Rprt._cont = ASN1Dict([
        ('commonMeasurementValueInformation', _ERACH_CM_Rprt_commonMeasurementValueInformation),
        ('iE-Extensions', _ERACH_CM_Rprt_iE_Extensions),
        ])
    ERACH_CM_Rprt._ext = []
    
    #-----< ERACHItem-CM-Rprt-ExtIEs >-----#
    ERACHItem_CM_Rprt_ExtIEs = CLASS(name='ERACHItem-CM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ERACHItem_CM_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cell-CM-Rprt >-----#
    Cell_CM_Rprt = SEQ(name='Cell-CM-Rprt', mode=MODE_TYPE)
    _Cell_CM_Rprt_commonMeasurementValueInformation = CHOICE(name='commonMeasurementValueInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementValueInformation')))
    _Cell_CM_Rprt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_CM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_CM_Rprt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_CM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Cell_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____Cell_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AdditionalMeasurementValueList')))
    _____Cell_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotMeasurementValueListLCR')))
    ____Cell_CM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Extension', _____Cell_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 972), ('criticality', 'ignore'), ('Extension', _____Cell_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1082), ('criticality', 'ignore'), ('Extension', _____Cell_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Cell_CM_Rprt_iE_Extensions__item__id._const_tab = ____Cell_CM_Rprt_iE_Extensions__item__id_tab
    ___Cell_CM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___Cell_CM_Rprt_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_CM_Rprt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Cell_CM_Rprt_iE_Extensions__item__criticality._const_tab = ____Cell_CM_Rprt_iE_Extensions__item__id_tab
    ___Cell_CM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_CM_Rprt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_CM_Rprt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Cell_CM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____Cell_CM_Rprt_iE_Extensions__item__id_tab
    ___Cell_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_CM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_CM_Rprt_iE_Extensions__item__id),
        ('criticality', ___Cell_CM_Rprt_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_CM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __Cell_CM_Rprt_iE_Extensions__item_._ext = None
    _Cell_CM_Rprt_iE_Extensions._cont = __Cell_CM_Rprt_iE_Extensions__item_
    _Cell_CM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_CM_Rprt._cont = ASN1Dict([
        ('commonMeasurementValueInformation', _Cell_CM_Rprt_commonMeasurementValueInformation),
        ('iE-Extensions', _Cell_CM_Rprt_iE_Extensions),
        ])
    Cell_CM_Rprt._ext = []
    
    #-----< CellItem-CM-Rprt-ExtIEs >-----#
    CellItem_CM_Rprt_ExtIEs = CLASS(name='CellItem-CM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CellItem_CM_Rprt_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CellItem_CM_Rprt_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AdditionalMeasurementValueList')))
    _CellItem_CM_Rprt_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotMeasurementValueListLCR')))
    CellItem_CM_Rprt_ExtIEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Extension', _CellItem_CM_Rprt_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 972), ('criticality', 'ignore'), ('Extension', _CellItem_CM_Rprt_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1082), ('criticality', 'ignore'), ('Extension', _CellItem_CM_Rprt_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RACH-CM-Rprt >-----#
    RACH_CM_Rprt = SEQ(name='RACH-CM-Rprt', mode=MODE_TYPE)
    _RACH_CM_Rprt_commonMeasurementValueInformation = CHOICE(name='commonMeasurementValueInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementValueInformation')))
    _RACH_CM_Rprt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RACH_CM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RACH_CM_Rprt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RACH_CM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RACH_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    ____RACH_CM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Extension', _____RACH_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RACH_CM_Rprt_iE_Extensions__item__id._const_tab = ____RACH_CM_Rprt_iE_Extensions__item__id_tab
    ___RACH_CM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___RACH_CM_Rprt_iE_Extensions__item__id._const_tab_id = 'id'
    ___RACH_CM_Rprt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RACH_CM_Rprt_iE_Extensions__item__criticality._const_tab = ____RACH_CM_Rprt_iE_Extensions__item__id_tab
    ___RACH_CM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RACH_CM_Rprt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RACH_CM_Rprt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RACH_CM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____RACH_CM_Rprt_iE_Extensions__item__id_tab
    ___RACH_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RACH_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RACH_CM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RACH_CM_Rprt_iE_Extensions__item__id),
        ('criticality', ___RACH_CM_Rprt_iE_Extensions__item__criticality),
        ('extensionValue', ___RACH_CM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __RACH_CM_Rprt_iE_Extensions__item_._ext = None
    _RACH_CM_Rprt_iE_Extensions._cont = __RACH_CM_Rprt_iE_Extensions__item_
    _RACH_CM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RACH_CM_Rprt._cont = ASN1Dict([
        ('commonMeasurementValueInformation', _RACH_CM_Rprt_commonMeasurementValueInformation),
        ('iE-Extensions', _RACH_CM_Rprt_iE_Extensions),
        ])
    RACH_CM_Rprt._ext = []
    
    #-----< RACHItem-CM-Rprt-ExtIEs >-----#
    RACHItem_CM_Rprt_ExtIEs = CLASS(name='RACHItem-CM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RACHItem_CM_Rprt_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    RACHItem_CM_Rprt_ExtIEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Extension', _RACHItem_CM_Rprt_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PowerLocalCellGroup-CM-Rprt >-----#
    PowerLocalCellGroup_CM_Rprt = SEQ(name='PowerLocalCellGroup-CM-Rprt', mode=MODE_TYPE)
    _PowerLocalCellGroup_CM_Rprt_commonMeasurementValueInformation = CHOICE(name='commonMeasurementValueInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonMeasurementValueInformation')))
    _PowerLocalCellGroup_CM_Rprt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerLocalCellGroup_CM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__id._const_tab = ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__id_tab
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__id._const_tab_id = 'id'
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__criticality._const_tab = ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__criticality_tab
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__extensionValue_tab
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PowerLocalCellGroup_CM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__id),
        ('criticality', ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__criticality),
        ('extensionValue', ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __PowerLocalCellGroup_CM_Rprt_iE_Extensions__item_._ext = None
    _PowerLocalCellGroup_CM_Rprt_iE_Extensions._cont = __PowerLocalCellGroup_CM_Rprt_iE_Extensions__item_
    _PowerLocalCellGroup_CM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerLocalCellGroup_CM_Rprt._cont = ASN1Dict([
        ('commonMeasurementValueInformation', _PowerLocalCellGroup_CM_Rprt_commonMeasurementValueInformation),
        ('iE-Extensions', _PowerLocalCellGroup_CM_Rprt_iE_Extensions),
        ])
    PowerLocalCellGroup_CM_Rprt._ext = []
    
    #-----< PowerLocalCellGroup-CM-Rprt-ExtIEs >-----#
    PowerLocalCellGroup_CM_Rprt_ExtIEs = CLASS(name='PowerLocalCellGroup-CM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PowerLocalCellGroup_CM_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementTerminationRequest >-----#
    CommonMeasurementTerminationRequest = SEQ(name='CommonMeasurementTerminationRequest', mode=MODE_TYPE)
    _CommonMeasurementTerminationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementTerminationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementTerminationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CommonMeasurementTerminationRequest_protocolIEs__item__id._const_tab = ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementTerminationRequest_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementTerminationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab = ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementTerminationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonMeasurementTerminationRequest_protocolIEs__item__value._const_tab = ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementTerminationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonMeasurementTerminationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonMeasurementTerminationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementTerminationRequest_protocolIEs__item__id),
        ('criticality', ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality),
        ('value', ___CommonMeasurementTerminationRequest_protocolIEs__item__value),
        ])
    __CommonMeasurementTerminationRequest_protocolIEs__item_._ext = None
    _CommonMeasurementTerminationRequest_protocolIEs._cont = __CommonMeasurementTerminationRequest_protocolIEs__item_
    _CommonMeasurementTerminationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementTerminationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementTerminationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__id._const_tab = ____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonMeasurementTerminationRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementTerminationRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementTerminationRequest_protocolExtensions__item__criticality_tab
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonMeasurementTerminationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementTerminationRequest_protocolExtensions__item__id),
        ('criticality', ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementTerminationRequest_protocolExtensions__item_._ext = None
    _CommonMeasurementTerminationRequest_protocolExtensions._cont = __CommonMeasurementTerminationRequest_protocolExtensions__item_
    _CommonMeasurementTerminationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementTerminationRequest._cont = ASN1Dict([
        ('protocolIEs', _CommonMeasurementTerminationRequest_protocolIEs),
        ('protocolExtensions', _CommonMeasurementTerminationRequest_protocolExtensions),
        ])
    CommonMeasurementTerminationRequest._ext = []
    
    #-----< CommonMeasurementTerminationRequest-IEs >-----#
    CommonMeasurementTerminationRequest_IEs = CLASS(name='CommonMeasurementTerminationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonMeasurementTerminationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    CommonMeasurementTerminationRequest_IEs._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _CommonMeasurementTerminationRequest_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementTerminationRequest-Extensions >-----#
    CommonMeasurementTerminationRequest_Extensions = CLASS(name='CommonMeasurementTerminationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonMeasurementTerminationRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementFailureIndication >-----#
    CommonMeasurementFailureIndication = SEQ(name='CommonMeasurementFailureIndication', mode=MODE_TYPE)
    _CommonMeasurementFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CommonMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab
    ___CommonMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CommonMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab
    ___CommonMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CommonMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab
    ___CommonMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementFailureIndication_protocolIEs__item__id),
        ('criticality', ___CommonMeasurementFailureIndication_protocolIEs__item__criticality),
        ('value', ___CommonMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __CommonMeasurementFailureIndication_protocolIEs__item_._ext = None
    _CommonMeasurementFailureIndication_protocolIEs._cont = __CommonMeasurementFailureIndication_protocolIEs__item_
    _CommonMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementFailureIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementFailureIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementFailureIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementFailureIndication_protocolExtensions__item__id._const_tab = ____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab
    ___CommonMeasurementFailureIndication_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementFailureIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommonMeasurementFailureIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementFailureIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementFailureIndication_protocolExtensions__item__criticality_tab
    ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab
    ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonMeasurementFailureIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonMeasurementFailureIndication_protocolExtensions__item__id),
        ('criticality', ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementFailureIndication_protocolExtensions__item_._ext = None
    _CommonMeasurementFailureIndication_protocolExtensions._cont = __CommonMeasurementFailureIndication_protocolExtensions__item_
    _CommonMeasurementFailureIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _CommonMeasurementFailureIndication_protocolIEs),
        ('protocolExtensions', _CommonMeasurementFailureIndication_protocolExtensions),
        ])
    CommonMeasurementFailureIndication._ext = []
    
    #-----< CommonMeasurementFailureIndication-IEs >-----#
    CommonMeasurementFailureIndication_IEs = CLASS(name='CommonMeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommonMeasurementFailureIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _CommonMeasurementFailureIndication_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    CommonMeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _CommonMeasurementFailureIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _CommonMeasurementFailureIndication_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementFailureIndication-Extensions >-----#
    CommonMeasurementFailureIndication_Extensions = CLASS(name='CommonMeasurementFailureIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommonMeasurementFailureIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSetupRequestFDD >-----#
    CellSetupRequestFDD = SEQ(name='CellSetupRequestFDD', mode=MODE_TYPE)
    _CellSetupRequestFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSetupRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSetupRequestFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSetupRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'T-Cell')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Closedlooptimingadjustmentmode')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrimaryScramblingCode')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Synchronisation-Configuration-Cell-SetupRqst')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TPC-Pattern01Count')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimarySCH-Information-Cell-SetupRqstFDD')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondarySCH-Information-Cell-SetupRqstFDD')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimaryCPICH-Information-Cell-SetupRqstFDD')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryCPICH-InformationList-Cell-SetupRqstFDD')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimaryCCPCH-Information-Cell-SetupRqstFDD')))
    _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Limited-power-increase-information-Cell-SetupRqstFDD')))
    ____CellSetupRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 124), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 276), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 282), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 281), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 131), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 333), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 181), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_8), ('presence', 'mandatory')]), dict([('id', 394), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_9), ('presence', 'mandatory')]), dict([('id', 358), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_10), ('presence', 'mandatory')]), dict([('id', 180), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_11), ('presence', 'mandatory')]), dict([('id', 265), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_12), ('presence', 'mandatory')]), dict([('id', 178), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_13), ('presence', 'mandatory')]), dict([('id', 263), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_15), ('presence', 'mandatory')]), dict([('id', 369), ('criticality', 'reject'), ('Value', _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_16), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CellSetupRequestFDD_protocolIEs__item__id._const_tab = ____CellSetupRequestFDD_protocolIEs__item__id_tab
    ___CellSetupRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___CellSetupRequestFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSetupRequestFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSetupRequestFDD_protocolIEs__item__criticality._const_tab = ____CellSetupRequestFDD_protocolIEs__item__id_tab
    ___CellSetupRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSetupRequestFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSetupRequestFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSetupRequestFDD_protocolIEs__item__value._const_tab = ____CellSetupRequestFDD_protocolIEs__item__id_tab
    ___CellSetupRequestFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSetupRequestFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSetupRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSetupRequestFDD_protocolIEs__item__id),
        ('criticality', ___CellSetupRequestFDD_protocolIEs__item__criticality),
        ('value', ___CellSetupRequestFDD_protocolIEs__item__value),
        ])
    __CellSetupRequestFDD_protocolIEs__item_._ext = None
    _CellSetupRequestFDD_protocolIEs._cont = __CellSetupRequestFDD_protocolIEs__item_
    _CellSetupRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSetupRequestFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSetupRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSetupRequestFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSetupRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-Cell-SetupRqstFDD')))
    _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellPortion-InformationList-Cell-SetupRqstFDD')))
    _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PilotConfiguration')))
    _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PilotConfigurationExtension')))
    _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-PilotConfiguration')))
    ____CellSetupRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 452), ('criticality', 'reject'), ('Extension', _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 598), ('criticality', 'reject'), ('Extension', _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 838), ('criticality', 'reject'), ('Extension', _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1102), ('criticality', 'reject'), ('Extension', _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1228), ('criticality', 'reject'), ('Extension', _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSetupRequestFDD_protocolExtensions__item__id._const_tab = ____CellSetupRequestFDD_protocolExtensions__item__id_tab
    ___CellSetupRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSetupRequestFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSetupRequestFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellSetupRequestFDD_protocolExtensions__item__criticality._const_tab = ____CellSetupRequestFDD_protocolExtensions__item__id_tab
    ___CellSetupRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSetupRequestFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSetupRequestFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____CellSetupRequestFDD_protocolExtensions__item__id_tab
    ___CellSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSetupRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSetupRequestFDD_protocolExtensions__item__id),
        ('criticality', ___CellSetupRequestFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSetupRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __CellSetupRequestFDD_protocolExtensions__item_._ext = None
    _CellSetupRequestFDD_protocolExtensions._cont = __CellSetupRequestFDD_protocolExtensions__item_
    _CellSetupRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSetupRequestFDD._cont = ASN1Dict([
        ('protocolIEs', _CellSetupRequestFDD_protocolIEs),
        ('protocolExtensions', _CellSetupRequestFDD_protocolExtensions),
        ])
    CellSetupRequestFDD._ext = []
    
    #-----< CellSetupRequestFDD-IEs >-----#
    CellSetupRequestFDD_IEs = CLASS(name='CellSetupRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSetupRequestFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _CellSetupRequestFDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CellSetupRequestFDD_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _CellSetupRequestFDD_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'T-Cell')))
    _CellSetupRequestFDD_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _CellSetupRequestFDD_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _CellSetupRequestFDD_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _CellSetupRequestFDD_IEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Closedlooptimingadjustmentmode')))
    _CellSetupRequestFDD_IEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrimaryScramblingCode')))
    _CellSetupRequestFDD_IEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Synchronisation-Configuration-Cell-SetupRqst')))
    _CellSetupRequestFDD_IEs_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TPC-Pattern01Count')))
    _CellSetupRequestFDD_IEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimarySCH-Information-Cell-SetupRqstFDD')))
    _CellSetupRequestFDD_IEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondarySCH-Information-Cell-SetupRqstFDD')))
    _CellSetupRequestFDD_IEs_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimaryCPICH-Information-Cell-SetupRqstFDD')))
    _CellSetupRequestFDD_IEs_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryCPICH-InformationList-Cell-SetupRqstFDD')))
    _CellSetupRequestFDD_IEs_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimaryCCPCH-Information-Cell-SetupRqstFDD')))
    _CellSetupRequestFDD_IEs_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Limited-power-increase-information-Cell-SetupRqstFDD')))
    CellSetupRequestFDD_IEs._val = ASN1Set(rv=[dict([('id', 124), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 276), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 282), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 281), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 131), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 333), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 181), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_8), ('presence', 'mandatory')]), dict([('id', 394), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_9), ('presence', 'mandatory')]), dict([('id', 358), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_10), ('presence', 'mandatory')]), dict([('id', 180), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_11), ('presence', 'mandatory')]), dict([('id', 265), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_12), ('presence', 'mandatory')]), dict([('id', 178), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_13), ('presence', 'mandatory')]), dict([('id', 263), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_15), ('presence', 'mandatory')]), dict([('id', 369), ('criticality', 'reject'), ('Value', _CellSetupRequestFDD_IEs_val_Value_16), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellSetupRequestFDD-Extensions >-----#
    CellSetupRequestFDD_Extensions = CLASS(name='CellSetupRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CellSetupRequestFDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-Cell-SetupRqstFDD')))
    _CellSetupRequestFDD_Extensions_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellPortion-InformationList-Cell-SetupRqstFDD')))
    _CellSetupRequestFDD_Extensions_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PilotConfiguration')))
    _CellSetupRequestFDD_Extensions_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PilotConfigurationExtension')))
    _CellSetupRequestFDD_Extensions_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-PilotConfiguration')))
    CellSetupRequestFDD_Extensions._val = ASN1Set(rv=[dict([('id', 452), ('criticality', 'reject'), ('Extension', _CellSetupRequestFDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 598), ('criticality', 'reject'), ('Extension', _CellSetupRequestFDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 838), ('criticality', 'reject'), ('Extension', _CellSetupRequestFDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 1102), ('criticality', 'reject'), ('Extension', _CellSetupRequestFDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 1228), ('criticality', 'reject'), ('Extension', _CellSetupRequestFDD_Extensions_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Synchronisation-Configuration-Cell-SetupRqst >-----#
    Synchronisation_Configuration_Cell_SetupRqst = SEQ(name='Synchronisation-Configuration-Cell-SetupRqst', mode=MODE_TYPE)
    _Synchronisation_Configuration_Cell_SetupRqst_n_INSYNC_IND = INT(name='n-INSYNC-IND', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'N-INSYNC-IND')))
    _Synchronisation_Configuration_Cell_SetupRqst_n_OUTSYNC_IND = INT(name='n-OUTSYNC-IND', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'N-OUTSYNC-IND')))
    _Synchronisation_Configuration_Cell_SetupRqst_t_RLFAILURE = INT(name='t-RLFAILURE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T-RLFAILURE')))
    _Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__id._const_tab = ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__id_tab
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__id._const_tab_at = None
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__criticality._const_tab = ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__criticality_tab
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__extensionValue._const_tab = ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__extensionValue_tab
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__id),
        ('criticality', ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__extensionValue),
        ])
    __Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item_._ext = None
    _Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions._cont = __Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item_
    _Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Synchronisation_Configuration_Cell_SetupRqst._cont = ASN1Dict([
        ('n-INSYNC-IND', _Synchronisation_Configuration_Cell_SetupRqst_n_INSYNC_IND),
        ('n-OUTSYNC-IND', _Synchronisation_Configuration_Cell_SetupRqst_n_OUTSYNC_IND),
        ('t-RLFAILURE', _Synchronisation_Configuration_Cell_SetupRqst_t_RLFAILURE),
        ('iE-Extensions', _Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions),
        ])
    Synchronisation_Configuration_Cell_SetupRqst._ext = []
    
    #-----< Synchronisation-Configuration-Cell-SetupRqst-ExtIEs >-----#
    Synchronisation_Configuration_Cell_SetupRqst_ExtIEs = CLASS(name='Synchronisation-Configuration-Cell-SetupRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Synchronisation_Configuration_Cell_SetupRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrimarySCH-Information-Cell-SetupRqstFDD >-----#
    PrimarySCH_Information_Cell_SetupRqstFDD = SEQ(name='PrimarySCH-Information-Cell-SetupRqstFDD', mode=MODE_TYPE)
    _PrimarySCH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PrimarySCH_Information_Cell_SetupRqstFDD_primarySCH_Power = INT(name='primarySCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _PrimarySCH_Information_Cell_SetupRqstFDD_tSTD_Indicator = ENUM(name='tSTD-Indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    _PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_._ext = None
    _PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions._cont = __PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_
    _PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrimarySCH_Information_Cell_SetupRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PrimarySCH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID),
        ('primarySCH-Power', _PrimarySCH_Information_Cell_SetupRqstFDD_primarySCH_Power),
        ('tSTD-Indicator', _PrimarySCH_Information_Cell_SetupRqstFDD_tSTD_Indicator),
        ('iE-Extensions', _PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions),
        ])
    PrimarySCH_Information_Cell_SetupRqstFDD._ext = []
    
    #-----< PrimarySCH-Information-Cell-SetupRqstFDD-ExtIEs >-----#
    PrimarySCH_Information_Cell_SetupRqstFDD_ExtIEs = CLASS(name='PrimarySCH-Information-Cell-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PrimarySCH_Information_Cell_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondarySCH-Information-Cell-SetupRqstFDD >-----#
    SecondarySCH_Information_Cell_SetupRqstFDD = SEQ(name='SecondarySCH-Information-Cell-SetupRqstFDD', mode=MODE_TYPE)
    _SecondarySCH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _SecondarySCH_Information_Cell_SetupRqstFDD_secondarySCH_Power = INT(name='secondarySCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _SecondarySCH_Information_Cell_SetupRqstFDD_tSTD_Indicator = ENUM(name='tSTD-Indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    _SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_._ext = None
    _SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions._cont = __SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_
    _SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondarySCH_Information_Cell_SetupRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _SecondarySCH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID),
        ('secondarySCH-Power', _SecondarySCH_Information_Cell_SetupRqstFDD_secondarySCH_Power),
        ('tSTD-Indicator', _SecondarySCH_Information_Cell_SetupRqstFDD_tSTD_Indicator),
        ('iE-Extensions', _SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions),
        ])
    SecondarySCH_Information_Cell_SetupRqstFDD._ext = []
    
    #-----< SecondarySCH-Information-Cell-SetupRqstFDD-ExtIEs >-----#
    SecondarySCH_Information_Cell_SetupRqstFDD_ExtIEs = CLASS(name='SecondarySCH-Information-Cell-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SecondarySCH_Information_Cell_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrimaryCPICH-Information-Cell-SetupRqstFDD >-----#
    PrimaryCPICH_Information_Cell_SetupRqstFDD = SEQ(name='PrimaryCPICH-Information-Cell-SetupRqstFDD', mode=MODE_TYPE)
    _PrimaryCPICH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PrimaryCPICH_Information_Cell_SetupRqstFDD_primaryCPICH_Power = INT(name='primaryCPICH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PrimaryCPICH-Power')))
    _PrimaryCPICH_Information_Cell_SetupRqstFDD_transmitDiversityIndicator = ENUM(name='transmitDiversityIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransmitDiversityIndicator')))
    _PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item_._ext = None
    _PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions._cont = __PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item_
    _PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrimaryCPICH_Information_Cell_SetupRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PrimaryCPICH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID),
        ('primaryCPICH-Power', _PrimaryCPICH_Information_Cell_SetupRqstFDD_primaryCPICH_Power),
        ('transmitDiversityIndicator', _PrimaryCPICH_Information_Cell_SetupRqstFDD_transmitDiversityIndicator),
        ('iE-Extensions', _PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions),
        ])
    PrimaryCPICH_Information_Cell_SetupRqstFDD._ext = []
    
    #-----< PrimaryCPICH-Information-Cell-SetupRqstFDD-ExtIEs >-----#
    PrimaryCPICH_Information_Cell_SetupRqstFDD_ExtIEs = CLASS(name='PrimaryCPICH-Information-Cell-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PrimaryCPICH_Information_Cell_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryCPICH-InformationList-Cell-SetupRqstFDD >-----#
    SecondaryCPICH_InformationList_Cell_SetupRqstFDD = SEQ_OF(name='SecondaryCPICH-InformationList-Cell-SetupRqstFDD', mode=MODE_TYPE)
    _SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryCPICH-InformationItem-Cell-SetupRqstFDD')))
    ___SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 261), ('criticality', 'reject'), ('Value', ____SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id._const_tab = ___SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id_tab
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id._const_tab_at = None
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id._const_tab_id = 'id'
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__criticality._const_tab = ___SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id_tab
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__criticality._const_tab_at = ('..', 'id')
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__criticality._const_tab_id = 'criticality'
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__value._const_tab = ___SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id_tab
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__value._const_tab_at = ('..', 'id')
    __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__value._const_tab_id = 'Value'
    _SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item_._cont = ASN1Dict([
        ('id', __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id),
        ('criticality', __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__criticality),
        ('value', __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__value),
        ])
    _SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item_._ext = None
    SecondaryCPICH_InformationList_Cell_SetupRqstFDD._cont = _SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item_
    SecondaryCPICH_InformationList_Cell_SetupRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SecondaryCPICH-InformationItemIE-Cell-SetupRqstFDD >-----#
    SecondaryCPICH_InformationItemIE_Cell_SetupRqstFDD = CLASS(name='SecondaryCPICH-InformationItemIE-Cell-SetupRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SecondaryCPICH_InformationItemIE_Cell_SetupRqstFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryCPICH-InformationItem-Cell-SetupRqstFDD')))
    SecondaryCPICH_InformationItemIE_Cell_SetupRqstFDD._val = ASN1Set(rv=[dict([('id', 261), ('criticality', 'reject'), ('Value', _SecondaryCPICH_InformationItemIE_Cell_SetupRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SecondaryCPICH-InformationItem-Cell-SetupRqstFDD >-----#
    SecondaryCPICH_InformationItem_Cell_SetupRqstFDD = SEQ(name='SecondaryCPICH-InformationItem-Cell-SetupRqstFDD', mode=MODE_TYPE)
    _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_dl_ScramblingCode = INT(name='dl-ScramblingCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-ScramblingCode')))
    _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_fDD_DL_ChannelisationCodeNumber = INT(name='fDD-DL-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_secondaryCPICH_Power = INT(name='secondaryCPICH-Power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_transmitDiversityIndicator = ENUM(name='transmitDiversityIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransmitDiversityIndicator')))
    _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id_tab
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item_._ext = None
    _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions._cont = __SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item_
    _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryCPICH_InformationItem_Cell_SetupRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_commonPhysicalChannelID),
        ('dl-ScramblingCode', _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_dl_ScramblingCode),
        ('fDD-DL-ChannelisationCodeNumber', _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_fDD_DL_ChannelisationCodeNumber),
        ('secondaryCPICH-Power', _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_secondaryCPICH_Power),
        ('transmitDiversityIndicator', _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_transmitDiversityIndicator),
        ('iE-Extensions', _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions),
        ])
    SecondaryCPICH_InformationItem_Cell_SetupRqstFDD._ext = []
    
    #-----< SecondaryCPICH-InformationItem-Cell-SetupRqstFDD-ExtIEs >-----#
    SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_ExtIEs = CLASS(name='SecondaryCPICH-InformationItem-Cell-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrimaryCCPCH-Information-Cell-SetupRqstFDD >-----#
    PrimaryCCPCH_Information_Cell_SetupRqstFDD = SEQ(name='PrimaryCCPCH-Information-Cell-SetupRqstFDD', mode=MODE_TYPE)
    _PrimaryCCPCH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PrimaryCCPCH_Information_Cell_SetupRqstFDD_bCH_information = SEQ(name='bCH-information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'BCH-Information-Cell-SetupRqstFDD')))
    _PrimaryCCPCH_Information_Cell_SetupRqstFDD_sTTD_Indicator = ENUM(name='sTTD-Indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'STTD-Indicator')))
    _PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_._ext = None
    _PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions._cont = __PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_
    _PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrimaryCCPCH_Information_Cell_SetupRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PrimaryCCPCH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID),
        ('bCH-information', _PrimaryCCPCH_Information_Cell_SetupRqstFDD_bCH_information),
        ('sTTD-Indicator', _PrimaryCCPCH_Information_Cell_SetupRqstFDD_sTTD_Indicator),
        ('iE-Extensions', _PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions),
        ])
    PrimaryCCPCH_Information_Cell_SetupRqstFDD._ext = []
    
    #-----< PrimaryCCPCH-Information-Cell-SetupRqstFDD-ExtIEs >-----#
    PrimaryCCPCH_Information_Cell_SetupRqstFDD_ExtIEs = CLASS(name='PrimaryCCPCH-Information-Cell-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PrimaryCCPCH_Information_Cell_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCH-Information-Cell-SetupRqstFDD >-----#
    BCH_Information_Cell_SetupRqstFDD = SEQ(name='BCH-Information-Cell-SetupRqstFDD', mode=MODE_TYPE)
    _BCH_Information_Cell_SetupRqstFDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _BCH_Information_Cell_SetupRqstFDD_bCH_Power = INT(name='bCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _BCH_Information_Cell_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_._ext = None
    _BCH_Information_Cell_SetupRqstFDD_iE_Extensions._cont = __BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_
    _BCH_Information_Cell_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCH_Information_Cell_SetupRqstFDD._cont = ASN1Dict([
        ('commonTransportChannelID', _BCH_Information_Cell_SetupRqstFDD_commonTransportChannelID),
        ('bCH-Power', _BCH_Information_Cell_SetupRqstFDD_bCH_Power),
        ('iE-Extensions', _BCH_Information_Cell_SetupRqstFDD_iE_Extensions),
        ])
    BCH_Information_Cell_SetupRqstFDD._ext = []
    
    #-----< BCH-Information-Cell-SetupRqstFDD-ExtIEs >-----#
    BCH_Information_Cell_SetupRqstFDD_ExtIEs = CLASS(name='BCH-Information-Cell-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BCH_Information_Cell_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Limited-power-increase-information-Cell-SetupRqstFDD >-----#
    Limited_power_increase_information_Cell_SetupRqstFDD = SEQ(name='Limited-power-increase-information-Cell-SetupRqstFDD', mode=MODE_TYPE)
    _Limited_power_increase_information_Cell_SetupRqstFDD_powerRaiseLimit = INT(name='powerRaiseLimit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerRaiseLimit')))
    _Limited_power_increase_information_Cell_SetupRqstFDD_dLPowerAveragingWindowSize = INT(name='dLPowerAveragingWindowSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DLPowerAveragingWindowSize')))
    _Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item_._ext = None
    _Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions._cont = __Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item_
    _Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Limited_power_increase_information_Cell_SetupRqstFDD._cont = ASN1Dict([
        ('powerRaiseLimit', _Limited_power_increase_information_Cell_SetupRqstFDD_powerRaiseLimit),
        ('dLPowerAveragingWindowSize', _Limited_power_increase_information_Cell_SetupRqstFDD_dLPowerAveragingWindowSize),
        ('iE-Extensions', _Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions),
        ])
    Limited_power_increase_information_Cell_SetupRqstFDD._ext = []
    
    #-----< Limited-power-increase-information-Cell-SetupRqstFDD-ExtIEs >-----#
    Limited_power_increase_information_Cell_SetupRqstFDD_ExtIEs = CLASS(name='Limited-power-increase-information-Cell-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Limited_power_increase_information_Cell_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPDLParameter-Information-Cell-SetupRqstFDD >-----#
    IPDLParameter_Information_Cell_SetupRqstFDD = SEQ(name='IPDLParameter-Information-Cell-SetupRqstFDD', mode=MODE_TYPE)
    _IPDLParameter_Information_Cell_SetupRqstFDD_iPDL_FDD_Parameters = SEQ(name='iPDL-FDD-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-FDD-Parameters')))
    _IPDLParameter_Information_Cell_SetupRqstFDD_iPDL_Indicator = ENUM(name='iPDL-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-Indicator')))
    _IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item_._ext = None
    _IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions._cont = __IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item_
    _IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDLParameter_Information_Cell_SetupRqstFDD._cont = ASN1Dict([
        ('iPDL-FDD-Parameters', _IPDLParameter_Information_Cell_SetupRqstFDD_iPDL_FDD_Parameters),
        ('iPDL-Indicator', _IPDLParameter_Information_Cell_SetupRqstFDD_iPDL_Indicator),
        ('iE-Extensions', _IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions),
        ])
    IPDLParameter_Information_Cell_SetupRqstFDD._ext = []
    
    #-----< IPDLParameter-Information-Cell-SetupRqstFDD-ExtIEs >-----#
    IPDLParameter_Information_Cell_SetupRqstFDD_ExtIEs = CLASS(name='IPDLParameter-Information-Cell-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    IPDLParameter_Information_Cell_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellPortion-InformationList-Cell-SetupRqstFDD >-----#
    CellPortion_InformationList_Cell_SetupRqstFDD = SEQ_OF(name='CellPortion-InformationList-Cell-SetupRqstFDD', mode=MODE_TYPE)
    _CellPortion_InformationList_Cell_SetupRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___CellPortion_InformationList_Cell_SetupRqstFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____CellPortion_InformationList_Cell_SetupRqstFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellPortion-InformationItem-Cell-SetupRqstFDD')))
    ___CellPortion_InformationList_Cell_SetupRqstFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 597), ('criticality', 'reject'), ('Value', ____CellPortion_InformationList_Cell_SetupRqstFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__id._const_tab = ___CellPortion_InformationList_Cell_SetupRqstFDD__item__id_tab
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__id._const_tab_at = None
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__id._const_tab_id = 'id'
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__criticality._const_tab = ___CellPortion_InformationList_Cell_SetupRqstFDD__item__id_tab
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__criticality._const_tab_at = ('..', 'id')
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__criticality._const_tab_id = 'criticality'
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__value._const_tab = ___CellPortion_InformationList_Cell_SetupRqstFDD__item__id_tab
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__value._const_tab_at = ('..', 'id')
    __CellPortion_InformationList_Cell_SetupRqstFDD__item__value._const_tab_id = 'Value'
    _CellPortion_InformationList_Cell_SetupRqstFDD__item_._cont = ASN1Dict([
        ('id', __CellPortion_InformationList_Cell_SetupRqstFDD__item__id),
        ('criticality', __CellPortion_InformationList_Cell_SetupRqstFDD__item__criticality),
        ('value', __CellPortion_InformationList_Cell_SetupRqstFDD__item__value),
        ])
    _CellPortion_InformationList_Cell_SetupRqstFDD__item_._ext = None
    CellPortion_InformationList_Cell_SetupRqstFDD._cont = _CellPortion_InformationList_Cell_SetupRqstFDD__item_
    CellPortion_InformationList_Cell_SetupRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< CellPortion-InformationItemIE-Cell-SetupRqstFDD >-----#
    CellPortion_InformationItemIE_Cell_SetupRqstFDD = CLASS(name='CellPortion-InformationItemIE-Cell-SetupRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellPortion_InformationItemIE_Cell_SetupRqstFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellPortion-InformationItem-Cell-SetupRqstFDD')))
    CellPortion_InformationItemIE_Cell_SetupRqstFDD._val = ASN1Set(rv=[dict([('id', 597), ('criticality', 'reject'), ('Value', _CellPortion_InformationItemIE_Cell_SetupRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellPortion-InformationItem-Cell-SetupRqstFDD >-----#
    CellPortion_InformationItem_Cell_SetupRqstFDD = SEQ(name='CellPortion-InformationItem-Cell-SetupRqstFDD', mode=MODE_TYPE)
    _CellPortion_InformationItem_Cell_SetupRqstFDD_cellPortionID = INT(name='cellPortionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionID')))
    _CellPortion_InformationItem_Cell_SetupRqstFDD_associatedSecondaryCPICH = INT(name='associatedSecondaryCPICH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _CellPortion_InformationItem_Cell_SetupRqstFDD_maximumTransmissionPowerforCellPortion = INT(name='maximumTransmissionPowerforCellPortion', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id_tab
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item_._ext = None
    _CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions._cont = __CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item_
    _CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellPortion_InformationItem_Cell_SetupRqstFDD._cont = ASN1Dict([
        ('cellPortionID', _CellPortion_InformationItem_Cell_SetupRqstFDD_cellPortionID),
        ('associatedSecondaryCPICH', _CellPortion_InformationItem_Cell_SetupRqstFDD_associatedSecondaryCPICH),
        ('maximumTransmissionPowerforCellPortion', _CellPortion_InformationItem_Cell_SetupRqstFDD_maximumTransmissionPowerforCellPortion),
        ('iE-Extensions', _CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions),
        ])
    CellPortion_InformationItem_Cell_SetupRqstFDD._ext = []
    
    #-----< CellPortion-InformationItem-Cell-SetupRqstFDD-ExtIEs >-----#
    CellPortion_InformationItem_Cell_SetupRqstFDD_ExtIEs = CLASS(name='CellPortion-InformationItem-Cell-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellPortion_InformationItem_Cell_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSetupRequestTDD >-----#
    CellSetupRequestTDD = SEQ(name='CellSetupRequestTDD', mode=MODE_TYPE)
    _CellSetupRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSetupRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSetupRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSetupRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_6 = BOOL(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmissionDiversityApplied')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SyncCase')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Synchronisation-Configuration-Cell-SetupRqst')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimingAdvanceApplied')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SCH-Information-Cell-SetupRqstTDD')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCCPCH-Information-Cell-SetupRqstTDD')))
    _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-Cell-SetupRqstTDD')))
    ____CellSetupRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 124), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 280), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 131), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 279), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 274), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 394), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_8), ('presence', 'mandatory')]), dict([('id', 359), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_9), ('presence', 'mandatory')]), dict([('id', 384), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_10), ('presence', 'mandatory')]), dict([('id', 381), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_11), ('presence', 'mandatory')]), dict([('id', 287), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_12), ('presence', 'mandatory')]), dict([('id', 184), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 151), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'reject'), ('Value', _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSetupRequestTDD_protocolIEs__item__id._const_tab = ____CellSetupRequestTDD_protocolIEs__item__id_tab
    ___CellSetupRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSetupRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSetupRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSetupRequestTDD_protocolIEs__item__criticality._const_tab = ____CellSetupRequestTDD_protocolIEs__item__id_tab
    ___CellSetupRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSetupRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSetupRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSetupRequestTDD_protocolIEs__item__value._const_tab = ____CellSetupRequestTDD_protocolIEs__item__id_tab
    ___CellSetupRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSetupRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSetupRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSetupRequestTDD_protocolIEs__item__id),
        ('criticality', ___CellSetupRequestTDD_protocolIEs__item__criticality),
        ('value', ___CellSetupRequestTDD_protocolIEs__item__value),
        ])
    __CellSetupRequestTDD_protocolIEs__item_._ext = None
    _CellSetupRequestTDD_protocolIEs._cont = __CellSetupRequestTDD_protocolIEs__item_
    _CellSetupRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSetupRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSetupRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSetupRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSetupRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-LCR-Cell-SetupRqstTDD')))
    _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCCPCH-LCR-Information-Cell-SetupRqstTDD')))
    _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DwPCH-LCR-Information-Cell-SetupRqstTDD')))
    _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReferenceSFNoffset')))
    _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-Cell-SetupRqstTDD')))
    _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-LCR-Cell-SetupRqstTDD')))
    _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCCPCH-768-Information-Cell-SetupRqstTDD')))
    _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SCH-768-Information-Cell-SetupRqstTDD')))
    _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBSFN-Only-Mode-Indicator')))
    _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-List-LCR-MulFreq-Cell-SetupRqstTDD')))
    ____CellSetupRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 467), ('criticality', 'reject'), ('Extension', _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 456), ('criticality', 'reject'), ('Extension', _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'reject'), ('Extension', _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 436), ('criticality', 'ignore'), ('Extension', _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 454), ('criticality', 'reject'), ('Extension', _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'reject'), ('Extension', _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 728), ('criticality', 'reject'), ('Extension', _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 729), ('criticality', 'reject'), ('Extension', _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 878), ('criticality', 'reject'), ('Extension', _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 915), ('criticality', 'reject'), ('Extension', _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSetupRequestTDD_protocolExtensions__item__id._const_tab = ____CellSetupRequestTDD_protocolExtensions__item__id_tab
    ___CellSetupRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSetupRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSetupRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellSetupRequestTDD_protocolExtensions__item__criticality._const_tab = ____CellSetupRequestTDD_protocolExtensions__item__id_tab
    ___CellSetupRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSetupRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSetupRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSetupRequestTDD_protocolExtensions__item__id_tab
    ___CellSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSetupRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSetupRequestTDD_protocolExtensions__item__id),
        ('criticality', ___CellSetupRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSetupRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSetupRequestTDD_protocolExtensions__item_._ext = None
    _CellSetupRequestTDD_protocolExtensions._cont = __CellSetupRequestTDD_protocolExtensions__item_
    _CellSetupRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSetupRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSetupRequestTDD_protocolIEs),
        ('protocolExtensions', _CellSetupRequestTDD_protocolExtensions),
        ])
    CellSetupRequestTDD._ext = []
    
    #-----< CellSetupRequestTDD-IEs >-----#
    CellSetupRequestTDD_IEs = CLASS(name='CellSetupRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSetupRequestTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _CellSetupRequestTDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CellSetupRequestTDD_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _CellSetupRequestTDD_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _CellSetupRequestTDD_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    _CellSetupRequestTDD_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _CellSetupRequestTDD_IEs_val_Value_6 = BOOL(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransmissionDiversityApplied')))
    _CellSetupRequestTDD_IEs_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SyncCase')))
    _CellSetupRequestTDD_IEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Synchronisation-Configuration-Cell-SetupRqst')))
    _CellSetupRequestTDD_IEs_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _CellSetupRequestTDD_IEs_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _CellSetupRequestTDD_IEs_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _CellSetupRequestTDD_IEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimingAdvanceApplied')))
    _CellSetupRequestTDD_IEs_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SCH-Information-Cell-SetupRqstTDD')))
    _CellSetupRequestTDD_IEs_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCCPCH-Information-Cell-SetupRqstTDD')))
    _CellSetupRequestTDD_IEs_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-Cell-SetupRqstTDD')))
    CellSetupRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 124), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 280), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 131), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 279), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 274), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_7), ('presence', 'mandatory')]), dict([('id', 394), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_8), ('presence', 'mandatory')]), dict([('id', 359), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_9), ('presence', 'mandatory')]), dict([('id', 384), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_10), ('presence', 'mandatory')]), dict([('id', 381), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_11), ('presence', 'mandatory')]), dict([('id', 287), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_12), ('presence', 'mandatory')]), dict([('id', 184), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 151), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'reject'), ('Value', _CellSetupRequestTDD_IEs_val_Value_15), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSetupRequestTDD-Extensions >-----#
    CellSetupRequestTDD_Extensions = CLASS(name='CellSetupRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CellSetupRequestTDD_Extensions_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-LCR-Cell-SetupRqstTDD')))
    _CellSetupRequestTDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCCPCH-LCR-Information-Cell-SetupRqstTDD')))
    _CellSetupRequestTDD_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DwPCH-LCR-Information-Cell-SetupRqstTDD')))
    _CellSetupRequestTDD_Extensions_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReferenceSFNoffset')))
    _CellSetupRequestTDD_Extensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-Cell-SetupRqstTDD')))
    _CellSetupRequestTDD_Extensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-LCR-Cell-SetupRqstTDD')))
    _CellSetupRequestTDD_Extensions_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCCPCH-768-Information-Cell-SetupRqstTDD')))
    _CellSetupRequestTDD_Extensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SCH-768-Information-Cell-SetupRqstTDD')))
    _CellSetupRequestTDD_Extensions_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBSFN-Only-Mode-Indicator')))
    _CellSetupRequestTDD_Extensions_val_Extension_9 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-List-LCR-MulFreq-Cell-SetupRqstTDD')))
    CellSetupRequestTDD_Extensions._val = ASN1Set(rv=[dict([('id', 467), ('criticality', 'reject'), ('Extension', _CellSetupRequestTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 456), ('criticality', 'reject'), ('Extension', _CellSetupRequestTDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'reject'), ('Extension', _CellSetupRequestTDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 436), ('criticality', 'ignore'), ('Extension', _CellSetupRequestTDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 454), ('criticality', 'reject'), ('Extension', _CellSetupRequestTDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'reject'), ('Extension', _CellSetupRequestTDD_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 728), ('criticality', 'reject'), ('Extension', _CellSetupRequestTDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 729), ('criticality', 'reject'), ('Extension', _CellSetupRequestTDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 878), ('criticality', 'reject'), ('Extension', _CellSetupRequestTDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 915), ('criticality', 'reject'), ('Extension', _CellSetupRequestTDD_Extensions_val_Extension_9), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SCH-Information-Cell-SetupRqstTDD >-----#
    SCH_Information_Cell_SetupRqstTDD = SEQ(name='SCH-Information-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _SCH_Information_Cell_SetupRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _SCH_Information_Cell_SetupRqstTDD_syncCaseIndicator = SEQ(name='syncCaseIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncCaseIndicator-Cell-SetupRqstTDD-PSCH')))
    _SCH_Information_Cell_SetupRqstTDD_sCH_Power = INT(name='sCH-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _SCH_Information_Cell_SetupRqstTDD_tSTD_Indicator = ENUM(name='tSTD-Indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    _SCH_Information_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _SCH_Information_Cell_SetupRqstTDD_iE_Extensions._cont = __SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item_
    _SCH_Information_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCH_Information_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _SCH_Information_Cell_SetupRqstTDD_commonPhysicalChannelID),
        ('syncCaseIndicator', _SCH_Information_Cell_SetupRqstTDD_syncCaseIndicator),
        ('sCH-Power', _SCH_Information_Cell_SetupRqstTDD_sCH_Power),
        ('tSTD-Indicator', _SCH_Information_Cell_SetupRqstTDD_tSTD_Indicator),
        ('iE-Extensions', _SCH_Information_Cell_SetupRqstTDD_iE_Extensions),
        ])
    SCH_Information_Cell_SetupRqstTDD._ext = []
    
    #-----< SCH-Information-Cell-SetupRqstTDD-ExtIEs >-----#
    SCH_Information_Cell_SetupRqstTDD_ExtIEs = CLASS(name='SCH-Information-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SCH_Information_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SyncCaseIndicator-Cell-SetupRqstTDD-PSCH >-----#
    SyncCaseIndicator_Cell_SetupRqstTDD_PSCH = SEQ(name='SyncCaseIndicator-Cell-SetupRqstTDD-PSCH', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncCaseIndicatorItem-Cell-SetupRqstTDD-PSCH')))
    __SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id_tab._val = ASN1Set(rv=[dict([('id', 275), ('criticality', 'reject'), ('Value', ___SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id._const_tab = __SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id_tab
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id._const_tab_at = None
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id._const_tab_id = 'id'
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_criticality._const_tab = __SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id_tab
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_criticality._const_tab_at = ('..', 'id')
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_criticality._const_tab_id = 'criticality'
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_value._const_tab = __SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id_tab
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_value._const_tab_at = ('..', 'id')
    _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_value._const_tab_id = 'Value'
    SyncCaseIndicator_Cell_SetupRqstTDD_PSCH._cont = ASN1Dict([
        ('id', _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id),
        ('criticality', _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_criticality),
        ('value', _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_value),
        ])
    SyncCaseIndicator_Cell_SetupRqstTDD_PSCH._ext = None
    
    #-----< SyncCaseIndicatorIE-Cell-SetupRqstTDD-PSCH >-----#
    SyncCaseIndicatorIE_Cell_SetupRqstTDD_PSCH = CLASS(name='SyncCaseIndicatorIE-Cell-SetupRqstTDD-PSCH', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SyncCaseIndicatorIE_Cell_SetupRqstTDD_PSCH_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncCaseIndicatorItem-Cell-SetupRqstTDD-PSCH')))
    SyncCaseIndicatorIE_Cell_SetupRqstTDD_PSCH._val = ASN1Set(rv=[dict([('id', 275), ('criticality', 'reject'), ('Value', _SyncCaseIndicatorIE_Cell_SetupRqstTDD_PSCH_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SyncCaseIndicatorItem-Cell-SetupRqstTDD-PSCH >-----#
    SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH = CHOICE(name='SyncCaseIndicatorItem-Cell-SetupRqstTDD-PSCH', mode=MODE_TYPE)
    _SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH_case1 = SEQ(name='case1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Case1-Cell-SetupRqstTDD')))
    _SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH_case2 = SEQ(name='case2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Case2-Cell-SetupRqstTDD')))
    SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH._cont = ASN1Dict([
        ('case1', _SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH_case1),
        ('case2', _SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH_case2),
        ])
    SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH._ext = []
    
    #-----< Case1-Cell-SetupRqstTDD >-----#
    Case1_Cell_SetupRqstTDD = SEQ(name='Case1-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _Case1_Cell_SetupRqstTDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _Case1_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Case1_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Case1_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Case1_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _Case1_Cell_SetupRqstTDD_iE_Extensions._cont = __Case1_Cell_SetupRqstTDD_iE_Extensions__item_
    _Case1_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Case1_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('timeSlot', _Case1_Cell_SetupRqstTDD_timeSlot),
        ('iE-Extensions', _Case1_Cell_SetupRqstTDD_iE_Extensions),
        ])
    Case1_Cell_SetupRqstTDD._ext = []
    
    #-----< Case1Item-Cell-SetupRqstTDD-ExtIEs >-----#
    Case1Item_Cell_SetupRqstTDD_ExtIEs = CLASS(name='Case1Item-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Case1Item_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Case2-Cell-SetupRqstTDD >-----#
    Case2_Cell_SetupRqstTDD = SEQ(name='Case2-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _Case2_Cell_SetupRqstTDD_sCH_TimeSlot = INT(name='sCH-TimeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SCH-TimeSlot')))
    _Case2_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Case2_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Case2_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Case2_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _Case2_Cell_SetupRqstTDD_iE_Extensions._cont = __Case2_Cell_SetupRqstTDD_iE_Extensions__item_
    _Case2_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Case2_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('sCH-TimeSlot', _Case2_Cell_SetupRqstTDD_sCH_TimeSlot),
        ('iE-Extensions', _Case2_Cell_SetupRqstTDD_iE_Extensions),
        ])
    Case2_Cell_SetupRqstTDD._ext = []
    
    #-----< Case2Item-Cell-SetupRqstTDD-ExtIEs >-----#
    Case2Item_Cell_SetupRqstTDD_ExtIEs = CLASS(name='Case2Item-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Case2Item_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCCPCH-Information-Cell-SetupRqstTDD >-----#
    PCCPCH_Information_Cell_SetupRqstTDD = SEQ(name='PCCPCH-Information-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _PCCPCH_Information_Cell_SetupRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PCCPCH_Information_Cell_SetupRqstTDD_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PCCPCH_Information_Cell_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PCCPCH_Information_Cell_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PCCPCH_Information_Cell_SetupRqstTDD_pCCPCH_Power = INT(name='pCCPCH-Power', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PCCPCH-Power')))
    _PCCPCH_Information_Cell_SetupRqstTDD_sCTD_Indicator = ENUM(name='sCTD-Indicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SCTD-Indicator')))
    _PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions._cont = __PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item_
    _PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PCCPCH_Information_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PCCPCH_Information_Cell_SetupRqstTDD_commonPhysicalChannelID),
        ('tdd-PhysicalChannelOffset', _PCCPCH_Information_Cell_SetupRqstTDD_tdd_PhysicalChannelOffset),
        ('repetitionPeriod', _PCCPCH_Information_Cell_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _PCCPCH_Information_Cell_SetupRqstTDD_repetitionLength),
        ('pCCPCH-Power', _PCCPCH_Information_Cell_SetupRqstTDD_pCCPCH_Power),
        ('sCTD-Indicator', _PCCPCH_Information_Cell_SetupRqstTDD_sCTD_Indicator),
        ('iE-Extensions', _PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions),
        ])
    PCCPCH_Information_Cell_SetupRqstTDD._ext = []
    
    #-----< PCCPCH-Information-Cell-SetupRqstTDD-ExtIEs >-----#
    PCCPCH_Information_Cell_SetupRqstTDD_ExtIEs = CLASS(name='PCCPCH-Information-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PCCPCH_Information_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeSlotConfigurationList-Cell-SetupRqstTDD >-----#
    TimeSlotConfigurationList_Cell_SetupRqstTDD = SEQ_OF(name='TimeSlotConfigurationList-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _TimeSlotConfigurationList_Cell_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationItem-Cell-SetupRqstTDD')))
    TimeSlotConfigurationList_Cell_SetupRqstTDD._cont = _TimeSlotConfigurationList_Cell_SetupRqstTDD__item_
    TimeSlotConfigurationList_Cell_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< TimeSlotConfigurationItem-Cell-SetupRqstTDD >-----#
    TimeSlotConfigurationItem_Cell_SetupRqstTDD = SEQ(name='TimeSlotConfigurationItem-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _TimeSlotConfigurationItem_Cell_SetupRqstTDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _TimeSlotConfigurationItem_Cell_SetupRqstTDD_timeSlotStatus = ENUM(name='timeSlotStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotStatus')))
    _TimeSlotConfigurationItem_Cell_SetupRqstTDD_timeSlotDirection = ENUM(name='timeSlotDirection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotDirection')))
    _TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    ____TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 841), ('criticality', 'reject'), ('Extension', _____TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions._cont = __TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item_
    _TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeSlotConfigurationItem_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('timeSlot', _TimeSlotConfigurationItem_Cell_SetupRqstTDD_timeSlot),
        ('timeSlotStatus', _TimeSlotConfigurationItem_Cell_SetupRqstTDD_timeSlotStatus),
        ('timeSlotDirection', _TimeSlotConfigurationItem_Cell_SetupRqstTDD_timeSlotDirection),
        ('iE-Extensions', _TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions),
        ])
    TimeSlotConfigurationItem_Cell_SetupRqstTDD._ext = []
    
    #-----< TimeSlotConfigurationItem-Cell-SetupRqstTDD-ExtIEs >-----#
    TimeSlotConfigurationItem_Cell_SetupRqstTDD_ExtIEs = CLASS(name='TimeSlotConfigurationItem-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _TimeSlotConfigurationItem_Cell_SetupRqstTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    TimeSlotConfigurationItem_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 841), ('criticality', 'reject'), ('Extension', _TimeSlotConfigurationItem_Cell_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TimeSlotConfigurationList-LCR-Cell-SetupRqstTDD >-----#
    TimeSlotConfigurationList_LCR_Cell_SetupRqstTDD = SEQ_OF(name='TimeSlotConfigurationList-LCR-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _TimeSlotConfigurationList_LCR_Cell_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationItem-LCR-Cell-SetupRqstTDD')))
    TimeSlotConfigurationList_LCR_Cell_SetupRqstTDD._cont = _TimeSlotConfigurationList_LCR_Cell_SetupRqstTDD__item_
    TimeSlotConfigurationList_LCR_Cell_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< TimeSlotConfigurationItem-LCR-Cell-SetupRqstTDD >-----#
    TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD = SEQ(name='TimeSlotConfigurationItem-LCR-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_timeSlotStatus = ENUM(name='timeSlotStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotStatus')))
    _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_timeSlotDirection = ENUM(name='timeSlotDirection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotDirection')))
    _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    ____TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 880), ('criticality', 'reject'), ('Extension', _____TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions._cont = __TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item_
    _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('timeSlotLCR', _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_timeSlotLCR),
        ('timeSlotStatus', _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_timeSlotStatus),
        ('timeSlotDirection', _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_timeSlotDirection),
        ('iE-Extensions', _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions),
        ])
    TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD._ext = []
    
    #-----< TimeSlotConfigurationItem-LCR-Cell-SetupRqstTDD-ExtIEs >-----#
    TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_ExtIEs = CLASS(name='TimeSlotConfigurationItem-LCR-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 880), ('criticality', 'reject'), ('Extension', _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PCCPCH-LCR-Information-Cell-SetupRqstTDD >-----#
    PCCPCH_LCR_Information_Cell_SetupRqstTDD = SEQ(name='PCCPCH-LCR-Information-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _PCCPCH_LCR_Information_Cell_SetupRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PCCPCH_LCR_Information_Cell_SetupRqstTDD_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PCCPCH_LCR_Information_Cell_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PCCPCH_LCR_Information_Cell_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PCCPCH_LCR_Information_Cell_SetupRqstTDD_pCCPCH_Power = INT(name='pCCPCH-Power', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PCCPCH-Power')))
    _PCCPCH_LCR_Information_Cell_SetupRqstTDD_sCTD_Indicator = ENUM(name='sCTD-Indicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SCTD-Indicator')))
    _PCCPCH_LCR_Information_Cell_SetupRqstTDD_tSTD_Indicator = ENUM(name='tSTD-Indicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    _PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions._cont = __PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item_
    _PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PCCPCH_LCR_Information_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PCCPCH_LCR_Information_Cell_SetupRqstTDD_commonPhysicalChannelID),
        ('tdd-PhysicalChannelOffset', _PCCPCH_LCR_Information_Cell_SetupRqstTDD_tdd_PhysicalChannelOffset),
        ('repetitionPeriod', _PCCPCH_LCR_Information_Cell_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _PCCPCH_LCR_Information_Cell_SetupRqstTDD_repetitionLength),
        ('pCCPCH-Power', _PCCPCH_LCR_Information_Cell_SetupRqstTDD_pCCPCH_Power),
        ('sCTD-Indicator', _PCCPCH_LCR_Information_Cell_SetupRqstTDD_sCTD_Indicator),
        ('tSTD-Indicator', _PCCPCH_LCR_Information_Cell_SetupRqstTDD_tSTD_Indicator),
        ('iE-Extensions', _PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions),
        ])
    PCCPCH_LCR_Information_Cell_SetupRqstTDD._ext = []
    
    #-----< PCCPCH-LCR-Information-Cell-SetupRqstTDD-ExtIEs >-----#
    PCCPCH_LCR_Information_Cell_SetupRqstTDD_ExtIEs = CLASS(name='PCCPCH-LCR-Information-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PCCPCH_LCR_Information_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DwPCH-LCR-Information-Cell-SetupRqstTDD >-----#
    DwPCH_LCR_Information_Cell_SetupRqstTDD = SEQ(name='DwPCH-LCR-Information-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _DwPCH_LCR_Information_Cell_SetupRqstTDD_commonPhysicalChannelId = INT(name='commonPhysicalChannelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _DwPCH_LCR_Information_Cell_SetupRqstTDD_tSTD_Indicator = ENUM(name='tSTD-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    _DwPCH_LCR_Information_Cell_SetupRqstTDD_dwPCH_Power = INT(name='dwPCH-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DwPCH-Power')))
    _DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions._cont = __DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item_
    _DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DwPCH_LCR_Information_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelId', _DwPCH_LCR_Information_Cell_SetupRqstTDD_commonPhysicalChannelId),
        ('tSTD-Indicator', _DwPCH_LCR_Information_Cell_SetupRqstTDD_tSTD_Indicator),
        ('dwPCH-Power', _DwPCH_LCR_Information_Cell_SetupRqstTDD_dwPCH_Power),
        ('iE-Extensions', _DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions),
        ])
    DwPCH_LCR_Information_Cell_SetupRqstTDD._ext = []
    
    #-----< DwPCH-LCR-Information-Cell-SetupRqstTDD-ExtIEs >-----#
    DwPCH_LCR_Information_Cell_SetupRqstTDD_ExtIEs = CLASS(name='DwPCH-LCR-Information-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DwPCH_LCR_Information_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPDLParameter-Information-Cell-SetupRqstTDD >-----#
    IPDLParameter_Information_Cell_SetupRqstTDD = SEQ(name='IPDLParameter-Information-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _IPDLParameter_Information_Cell_SetupRqstTDD_iPDL_TDD_Parameters = SEQ(name='iPDL-TDD-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-TDD-Parameters')))
    _IPDLParameter_Information_Cell_SetupRqstTDD_iPDL_Indicator = ENUM(name='iPDL-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-Indicator')))
    _IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions._cont = __IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item_
    _IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDLParameter_Information_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('iPDL-TDD-Parameters', _IPDLParameter_Information_Cell_SetupRqstTDD_iPDL_TDD_Parameters),
        ('iPDL-Indicator', _IPDLParameter_Information_Cell_SetupRqstTDD_iPDL_Indicator),
        ('iE-Extensions', _IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions),
        ])
    IPDLParameter_Information_Cell_SetupRqstTDD._ext = []
    
    #-----< IPDLParameter-Information-Cell-SetupRqstTDD-ExtIEs >-----#
    IPDLParameter_Information_Cell_SetupRqstTDD_ExtIEs = CLASS(name='IPDLParameter-Information-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    IPDLParameter_Information_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPDLParameter-Information-LCR-Cell-SetupRqstTDD >-----#
    IPDLParameter_Information_LCR_Cell_SetupRqstTDD = SEQ(name='IPDLParameter-Information-LCR-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iPDL_TDD_Parameters_LCR = SEQ(name='iPDL-TDD-Parameters-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-TDD-Parameters-LCR')))
    _IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iPDL_Indicator = ENUM(name='iPDL-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-Indicator')))
    _IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions._cont = __IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item_
    _IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDLParameter_Information_LCR_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('iPDL-TDD-Parameters-LCR', _IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iPDL_TDD_Parameters_LCR),
        ('iPDL-Indicator', _IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iPDL_Indicator),
        ('iE-Extensions', _IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions),
        ])
    IPDLParameter_Information_LCR_Cell_SetupRqstTDD._ext = []
    
    #-----< IPDLParameter-Information-LCR-Cell-SetupRqstTDD-ExtIEs >-----#
    IPDLParameter_Information_LCR_Cell_SetupRqstTDD_ExtIEs = CLASS(name='IPDLParameter-Information-LCR-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    IPDLParameter_Information_LCR_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCCPCH-768-Information-Cell-SetupRqstTDD >-----#
    PCCPCH_768_Information_Cell_SetupRqstTDD = SEQ(name='PCCPCH-768-Information-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _PCCPCH_768_Information_Cell_SetupRqstTDD_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _PCCPCH_768_Information_Cell_SetupRqstTDD_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PCCPCH_768_Information_Cell_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PCCPCH_768_Information_Cell_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PCCPCH_768_Information_Cell_SetupRqstTDD_pCCPCH_Power = INT(name='pCCPCH-Power', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PCCPCH-Power')))
    _PCCPCH_768_Information_Cell_SetupRqstTDD_sCTD_Indicator = ENUM(name='sCTD-Indicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SCTD-Indicator')))
    _PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions._cont = __PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item_
    _PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PCCPCH_768_Information_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _PCCPCH_768_Information_Cell_SetupRqstTDD_commonPhysicalChannelID768),
        ('tdd-PhysicalChannelOffset', _PCCPCH_768_Information_Cell_SetupRqstTDD_tdd_PhysicalChannelOffset),
        ('repetitionPeriod', _PCCPCH_768_Information_Cell_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _PCCPCH_768_Information_Cell_SetupRqstTDD_repetitionLength),
        ('pCCPCH-Power', _PCCPCH_768_Information_Cell_SetupRqstTDD_pCCPCH_Power),
        ('sCTD-Indicator', _PCCPCH_768_Information_Cell_SetupRqstTDD_sCTD_Indicator),
        ('iE-Extensions', _PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions),
        ])
    PCCPCH_768_Information_Cell_SetupRqstTDD._ext = []
    
    #-----< PCCPCH-768-Information-Cell-SetupRqstTDD-ExtIEs >-----#
    PCCPCH_768_Information_Cell_SetupRqstTDD_ExtIEs = CLASS(name='PCCPCH-768-Information-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PCCPCH_768_Information_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCH-768-Information-Cell-SetupRqstTDD >-----#
    SCH_768_Information_Cell_SetupRqstTDD = SEQ(name='SCH-768-Information-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _SCH_768_Information_Cell_SetupRqstTDD_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _SCH_768_Information_Cell_SetupRqstTDD_syncCaseIndicator = SEQ(name='syncCaseIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncCaseIndicator-Cell-SetupRqstTDD-PSCH')))
    _SCH_768_Information_Cell_SetupRqstTDD_sCH_Power = INT(name='sCH-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _SCH_768_Information_Cell_SetupRqstTDD_tSTD_Indicator = ENUM(name='tSTD-Indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    _SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions._cont = __SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item_
    _SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCH_768_Information_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _SCH_768_Information_Cell_SetupRqstTDD_commonPhysicalChannelID768),
        ('syncCaseIndicator', _SCH_768_Information_Cell_SetupRqstTDD_syncCaseIndicator),
        ('sCH-Power', _SCH_768_Information_Cell_SetupRqstTDD_sCH_Power),
        ('tSTD-Indicator', _SCH_768_Information_Cell_SetupRqstTDD_tSTD_Indicator),
        ('iE-Extensions', _SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions),
        ])
    SCH_768_Information_Cell_SetupRqstTDD._ext = []
    
    #-----< SCH-768-Information-Cell-SetupRqstTDD-ExtIEs >-----#
    SCH_768_Information_Cell_SetupRqstTDD_ExtIEs = CLASS(name='SCH-768-Information-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SCH_768_Information_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cell-Frequency-List-LCR-MulFreq-Cell-SetupRqstTDD >-----#
    Cell_Frequency_List_LCR_MulFreq_Cell_SetupRqstTDD = SEQ_OF(name='Cell-Frequency-List-LCR-MulFreq-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _Cell_Frequency_List_LCR_MulFreq_Cell_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-Item-LCR-MulFreq-Cell-SetupRqstTDD')))
    Cell_Frequency_List_LCR_MulFreq_Cell_SetupRqstTDD._cont = _Cell_Frequency_List_LCR_MulFreq_Cell_SetupRqstTDD__item_
    Cell_Frequency_List_LCR_MulFreq_Cell_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< Cell-Frequency-Item-LCR-MulFreq-Cell-SetupRqstTDD >-----#
    Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD = SEQ(name='Cell-Frequency-Item-LCR-MulFreq-Cell-SetupRqstTDD', mode=MODE_TYPE)
    _Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_timeSlotConfigurationList_LCR_Cell_SetupRqstTDD = SEQ_OF(name='timeSlotConfigurationList-LCR-Cell-SetupRqstTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-LCR-Cell-SetupRqstTDD')))
    _Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__id_tab
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item_._ext = None
    _Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions._cont = __Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item_
    _Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD._cont = ASN1Dict([
        ('uARFCN', _Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_uARFCN),
        ('timeSlotConfigurationList-LCR-Cell-SetupRqstTDD', _Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_timeSlotConfigurationList_LCR_Cell_SetupRqstTDD),
        ('iE-Extensions', _Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions),
        ])
    Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD._ext = []
    
    #-----< Cell-Frequency-Item-LCR-MulFreq-Cell-SetupRqstTDD-ExtIEs >-----#
    Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_ExtIEs = CLASS(name='Cell-Frequency-Item-LCR-MulFreq-Cell-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSetupResponse >-----#
    CellSetupResponse = SEQ(name='CellSetupResponse', mode=MODE_TYPE)
    _CellSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSetupResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CellSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CellSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSetupResponse_protocolIEs__item__id._const_tab = ____CellSetupResponse_protocolIEs__item__id_tab
    ___CellSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___CellSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSetupResponse_protocolIEs__item__criticality._const_tab = ____CellSetupResponse_protocolIEs__item__id_tab
    ___CellSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSetupResponse_protocolIEs__item__value._const_tab = ____CellSetupResponse_protocolIEs__item__id_tab
    ___CellSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSetupResponse_protocolIEs__item__id),
        ('criticality', ___CellSetupResponse_protocolIEs__item__criticality),
        ('value', ___CellSetupResponse_protocolIEs__item__value),
        ])
    __CellSetupResponse_protocolIEs__item_._ext = None
    _CellSetupResponse_protocolIEs._cont = __CellSetupResponse_protocolIEs__item_
    _CellSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSetupResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSetupResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSetupResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSetupResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSetupResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSetupResponse_protocolExtensions__item__id._const_tab = ____CellSetupResponse_protocolExtensions__item__id_tab
    ___CellSetupResponse_protocolExtensions__item__id._const_tab_at = None
    ___CellSetupResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSetupResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSetupResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSetupResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSetupResponse_protocolExtensions__item__criticality._const_tab = ____CellSetupResponse_protocolExtensions__item__criticality_tab
    ___CellSetupResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSetupResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSetupResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSetupResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSetupResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSetupResponse_protocolExtensions__item__extensionValue._const_tab = ____CellSetupResponse_protocolExtensions__item__extensionValue_tab
    ___CellSetupResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSetupResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSetupResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSetupResponse_protocolExtensions__item__id),
        ('criticality', ___CellSetupResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSetupResponse_protocolExtensions__item__extensionValue),
        ])
    __CellSetupResponse_protocolExtensions__item_._ext = None
    _CellSetupResponse_protocolExtensions._cont = __CellSetupResponse_protocolExtensions__item_
    _CellSetupResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _CellSetupResponse_protocolIEs),
        ('protocolExtensions', _CellSetupResponse_protocolExtensions),
        ])
    CellSetupResponse._ext = []
    
    #-----< CellSetupResponse-IEs >-----#
    CellSetupResponse_IEs = CLASS(name='CellSetupResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSetupResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CellSetupResponse_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _CellSetupResponse_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSetupResponse-Extensions >-----#
    CellSetupResponse_Extensions = CLASS(name='CellSetupResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSetupResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSetupFailure >-----#
    CellSetupFailure = SEQ(name='CellSetupFailure', mode=MODE_TYPE)
    _CellSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSetupFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____CellSetupFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CellSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _____CellSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CellSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSetupFailure_protocolIEs__item__id._const_tab = ____CellSetupFailure_protocolIEs__item__id_tab
    ___CellSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___CellSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSetupFailure_protocolIEs__item__criticality._const_tab = ____CellSetupFailure_protocolIEs__item__id_tab
    ___CellSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSetupFailure_protocolIEs__item__value._const_tab = ____CellSetupFailure_protocolIEs__item__id_tab
    ___CellSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSetupFailure_protocolIEs__item__id),
        ('criticality', ___CellSetupFailure_protocolIEs__item__criticality),
        ('value', ___CellSetupFailure_protocolIEs__item__value),
        ])
    __CellSetupFailure_protocolIEs__item_._ext = None
    _CellSetupFailure_protocolIEs._cont = __CellSetupFailure_protocolIEs__item_
    _CellSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSetupFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSetupFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSetupFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSetupFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSetupFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSetupFailure_protocolExtensions__item__id._const_tab = ____CellSetupFailure_protocolExtensions__item__id_tab
    ___CellSetupFailure_protocolExtensions__item__id._const_tab_at = None
    ___CellSetupFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSetupFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSetupFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSetupFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSetupFailure_protocolExtensions__item__criticality._const_tab = ____CellSetupFailure_protocolExtensions__item__criticality_tab
    ___CellSetupFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSetupFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSetupFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSetupFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSetupFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSetupFailure_protocolExtensions__item__extensionValue._const_tab = ____CellSetupFailure_protocolExtensions__item__extensionValue_tab
    ___CellSetupFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSetupFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSetupFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSetupFailure_protocolExtensions__item__id),
        ('criticality', ___CellSetupFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSetupFailure_protocolExtensions__item__extensionValue),
        ])
    __CellSetupFailure_protocolExtensions__item_._ext = None
    _CellSetupFailure_protocolExtensions._cont = __CellSetupFailure_protocolExtensions__item_
    _CellSetupFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _CellSetupFailure_protocolIEs),
        ('protocolExtensions', _CellSetupFailure_protocolExtensions),
        ])
    CellSetupFailure._ext = []
    
    #-----< CellSetupFailure-IEs >-----#
    CellSetupFailure_IEs = CLASS(name='CellSetupFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSetupFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _CellSetupFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CellSetupFailure_IEs._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _CellSetupFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _CellSetupFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSetupFailure-Extensions >-----#
    CellSetupFailure_Extensions = CLASS(name='CellSetupFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSetupFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellReconfigurationRequestFDD >-----#
    CellReconfigurationRequestFDD = SEQ(name='CellReconfigurationRequestFDD', mode=MODE_TYPE)
    _CellReconfigurationRequestFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellReconfigurationRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellReconfigurationRequestFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellReconfigurationRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Synchronisation-Configuration-Cell-ReconfRqst')))
    _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimarySCH-Information-Cell-ReconfRqstFDD')))
    _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondarySCH-Information-Cell-ReconfRqstFDD')))
    _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimaryCPICH-Information-Cell-ReconfRqstFDD')))
    _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryCPICH-InformationList-Cell-ReconfRqstFDD')))
    _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimaryCCPCH-Information-Cell-ReconfRqstFDD')))
    ____CellReconfigurationRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 131), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 393), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 179), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 175), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellReconfigurationRequestFDD_protocolIEs__item__id._const_tab = ____CellReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___CellReconfigurationRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___CellReconfigurationRequestFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellReconfigurationRequestFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab = ____CellReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___CellReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellReconfigurationRequestFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellReconfigurationRequestFDD_protocolIEs__item__value._const_tab = ____CellReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___CellReconfigurationRequestFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellReconfigurationRequestFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellReconfigurationRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellReconfigurationRequestFDD_protocolIEs__item__id),
        ('criticality', ___CellReconfigurationRequestFDD_protocolIEs__item__criticality),
        ('value', ___CellReconfigurationRequestFDD_protocolIEs__item__value),
        ])
    __CellReconfigurationRequestFDD_protocolIEs__item_._ext = None
    _CellReconfigurationRequestFDD_protocolIEs._cont = __CellReconfigurationRequestFDD_protocolIEs__item_
    _CellReconfigurationRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellReconfigurationRequestFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellReconfigurationRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellReconfigurationRequestFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-Cell-ReconfRqstFDD')))
    _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellPortion-InformationList-Cell-ReconfRqstFDD')))
    _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PilotConfiguration')))
    _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PilotConfigurationExtension')))
    _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DormantModeIndicator')))
    _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-PilotConfiguration')))
    ____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 695), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 838), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1102), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1138), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1228), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellReconfigurationRequestFDD_protocolExtensions__item__id._const_tab = ____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___CellReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___CellReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellReconfigurationRequestFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab = ____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___CellReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellReconfigurationRequestFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___CellReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellReconfigurationRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellReconfigurationRequestFDD_protocolExtensions__item__id),
        ('criticality', ___CellReconfigurationRequestFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellReconfigurationRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __CellReconfigurationRequestFDD_protocolExtensions__item_._ext = None
    _CellReconfigurationRequestFDD_protocolExtensions._cont = __CellReconfigurationRequestFDD_protocolExtensions__item_
    _CellReconfigurationRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellReconfigurationRequestFDD._cont = ASN1Dict([
        ('protocolIEs', _CellReconfigurationRequestFDD_protocolIEs),
        ('protocolExtensions', _CellReconfigurationRequestFDD_protocolExtensions),
        ])
    CellReconfigurationRequestFDD._ext = []
    
    #-----< CellReconfigurationRequestFDD-IEs >-----#
    CellReconfigurationRequestFDD_IEs = CLASS(name='CellReconfigurationRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellReconfigurationRequestFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CellReconfigurationRequestFDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _CellReconfigurationRequestFDD_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _CellReconfigurationRequestFDD_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Synchronisation-Configuration-Cell-ReconfRqst')))
    _CellReconfigurationRequestFDD_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimarySCH-Information-Cell-ReconfRqstFDD')))
    _CellReconfigurationRequestFDD_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondarySCH-Information-Cell-ReconfRqstFDD')))
    _CellReconfigurationRequestFDD_IEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimaryCPICH-Information-Cell-ReconfRqstFDD')))
    _CellReconfigurationRequestFDD_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryCPICH-InformationList-Cell-ReconfRqstFDD')))
    _CellReconfigurationRequestFDD_IEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrimaryCCPCH-Information-Cell-ReconfRqstFDD')))
    CellReconfigurationRequestFDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestFDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 131), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestFDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 393), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestFDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 179), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestFDD_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestFDD_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestFDD_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestFDD_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 175), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestFDD_IEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellReconfigurationRequestFDD-Extensions >-----#
    CellReconfigurationRequestFDD_Extensions = CLASS(name='CellReconfigurationRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CellReconfigurationRequestFDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-Cell-ReconfRqstFDD')))
    _CellReconfigurationRequestFDD_Extensions_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellPortion-InformationList-Cell-ReconfRqstFDD')))
    _CellReconfigurationRequestFDD_Extensions_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PilotConfiguration')))
    _CellReconfigurationRequestFDD_Extensions_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PilotConfigurationExtension')))
    _CellReconfigurationRequestFDD_Extensions_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DormantModeIndicator')))
    _CellReconfigurationRequestFDD_Extensions_val_Extension_5 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-withfourtransmitantennas-PilotConfiguration')))
    CellReconfigurationRequestFDD_Extensions._val = ASN1Set(rv=[dict([('id', 451), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestFDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 695), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestFDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 838), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestFDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 1102), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestFDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 1138), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestFDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 1228), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestFDD_Extensions_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Synchronisation-Configuration-Cell-ReconfRqst >-----#
    Synchronisation_Configuration_Cell_ReconfRqst = SEQ(name='Synchronisation-Configuration-Cell-ReconfRqst', mode=MODE_TYPE)
    _Synchronisation_Configuration_Cell_ReconfRqst_n_INSYNC_IND = INT(name='n-INSYNC-IND', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'N-INSYNC-IND')))
    _Synchronisation_Configuration_Cell_ReconfRqst_n_OUTSYNC_IND = INT(name='n-OUTSYNC-IND', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'N-OUTSYNC-IND')))
    _Synchronisation_Configuration_Cell_ReconfRqst_t_RLFAILURE = INT(name='t-RLFAILURE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'T-RLFAILURE')))
    _Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__id._const_tab = ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__id_tab
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__criticality_tab
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item_._ext = None
    _Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions._cont = __Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item_
    _Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Synchronisation_Configuration_Cell_ReconfRqst._cont = ASN1Dict([
        ('n-INSYNC-IND', _Synchronisation_Configuration_Cell_ReconfRqst_n_INSYNC_IND),
        ('n-OUTSYNC-IND', _Synchronisation_Configuration_Cell_ReconfRqst_n_OUTSYNC_IND),
        ('t-RLFAILURE', _Synchronisation_Configuration_Cell_ReconfRqst_t_RLFAILURE),
        ('iE-Extensions', _Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions),
        ])
    Synchronisation_Configuration_Cell_ReconfRqst._ext = []
    
    #-----< Synchronisation-Configuration-Cell-ReconfRqst-ExtIEs >-----#
    Synchronisation_Configuration_Cell_ReconfRqst_ExtIEs = CLASS(name='Synchronisation-Configuration-Cell-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Synchronisation_Configuration_Cell_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrimarySCH-Information-Cell-ReconfRqstFDD >-----#
    PrimarySCH_Information_Cell_ReconfRqstFDD = SEQ(name='PrimarySCH-Information-Cell-ReconfRqstFDD', mode=MODE_TYPE)
    _PrimarySCH_Information_Cell_ReconfRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PrimarySCH_Information_Cell_ReconfRqstFDD_primarySCH_Power = INT(name='primarySCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions._cont = __PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_
    _PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrimarySCH_Information_Cell_ReconfRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PrimarySCH_Information_Cell_ReconfRqstFDD_commonPhysicalChannelID),
        ('primarySCH-Power', _PrimarySCH_Information_Cell_ReconfRqstFDD_primarySCH_Power),
        ('iE-Extensions', _PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions),
        ])
    PrimarySCH_Information_Cell_ReconfRqstFDD._ext = []
    
    #-----< PrimarySCH-Information-Cell-ReconfRqstFDD-ExtIEs >-----#
    PrimarySCH_Information_Cell_ReconfRqstFDD_ExtIEs = CLASS(name='PrimarySCH-Information-Cell-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PrimarySCH_Information_Cell_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondarySCH-Information-Cell-ReconfRqstFDD >-----#
    SecondarySCH_Information_Cell_ReconfRqstFDD = SEQ(name='SecondarySCH-Information-Cell-ReconfRqstFDD', mode=MODE_TYPE)
    _SecondarySCH_Information_Cell_ReconfRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _SecondarySCH_Information_Cell_ReconfRqstFDD_secondarySCH_Power = INT(name='secondarySCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions._cont = __SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_
    _SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondarySCH_Information_Cell_ReconfRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _SecondarySCH_Information_Cell_ReconfRqstFDD_commonPhysicalChannelID),
        ('secondarySCH-Power', _SecondarySCH_Information_Cell_ReconfRqstFDD_secondarySCH_Power),
        ('iE-Extensions', _SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions),
        ])
    SecondarySCH_Information_Cell_ReconfRqstFDD._ext = []
    
    #-----< SecondarySCH-Information-Cell-ReconfRqstFDD-ExtIEs >-----#
    SecondarySCH_Information_Cell_ReconfRqstFDD_ExtIEs = CLASS(name='SecondarySCH-Information-Cell-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SecondarySCH_Information_Cell_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrimaryCPICH-Information-Cell-ReconfRqstFDD >-----#
    PrimaryCPICH_Information_Cell_ReconfRqstFDD = SEQ(name='PrimaryCPICH-Information-Cell-ReconfRqstFDD', mode=MODE_TYPE)
    _PrimaryCPICH_Information_Cell_ReconfRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PrimaryCPICH_Information_Cell_ReconfRqstFDD_primaryCPICH_Power = INT(name='primaryCPICH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PrimaryCPICH-Power')))
    _PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions._cont = __PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_
    _PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrimaryCPICH_Information_Cell_ReconfRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PrimaryCPICH_Information_Cell_ReconfRqstFDD_commonPhysicalChannelID),
        ('primaryCPICH-Power', _PrimaryCPICH_Information_Cell_ReconfRqstFDD_primaryCPICH_Power),
        ('iE-Extensions', _PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions),
        ])
    PrimaryCPICH_Information_Cell_ReconfRqstFDD._ext = []
    
    #-----< PrimaryCPICH-Information-Cell-ReconfRqstFDD-ExtIEs >-----#
    PrimaryCPICH_Information_Cell_ReconfRqstFDD_ExtIEs = CLASS(name='PrimaryCPICH-Information-Cell-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PrimaryCPICH_Information_Cell_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryCPICH-InformationList-Cell-ReconfRqstFDD >-----#
    SecondaryCPICH_InformationList_Cell_ReconfRqstFDD = SEQ_OF(name='SecondaryCPICH-InformationList-Cell-ReconfRqstFDD', mode=MODE_TYPE)
    _SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD')))
    ___SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 260), ('criticality', 'reject'), ('Value', ____SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id._const_tab = ___SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id_tab
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id._const_tab_at = None
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id._const_tab_id = 'id'
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__criticality._const_tab = ___SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id_tab
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__criticality._const_tab_at = ('..', 'id')
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__criticality._const_tab_id = 'criticality'
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__value._const_tab = ___SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id_tab
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__value._const_tab_at = ('..', 'id')
    __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__value._const_tab_id = 'Value'
    _SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item_._cont = ASN1Dict([
        ('id', __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id),
        ('criticality', __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__criticality),
        ('value', __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__value),
        ])
    _SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item_._ext = None
    SecondaryCPICH_InformationList_Cell_ReconfRqstFDD._cont = _SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item_
    SecondaryCPICH_InformationList_Cell_ReconfRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SecondaryCPICH-InformationItemIE-Cell-ReconfRqstFDD >-----#
    SecondaryCPICH_InformationItemIE_Cell_ReconfRqstFDD = CLASS(name='SecondaryCPICH-InformationItemIE-Cell-ReconfRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SecondaryCPICH_InformationItemIE_Cell_ReconfRqstFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD')))
    SecondaryCPICH_InformationItemIE_Cell_ReconfRqstFDD._val = ASN1Set(rv=[dict([('id', 260), ('criticality', 'reject'), ('Value', _SecondaryCPICH_InformationItemIE_Cell_ReconfRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD >-----#
    SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD = SEQ(name='SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD', mode=MODE_TYPE)
    _SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_secondaryCPICH_Power = INT(name='secondaryCPICH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions._cont = __SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item_
    _SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_commonPhysicalChannelID),
        ('secondaryCPICH-Power', _SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_secondaryCPICH_Power),
        ('iE-Extensions', _SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions),
        ])
    SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD._ext = []
    
    #-----< SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD-ExtIEs >-----#
    SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_ExtIEs = CLASS(name='SecondaryCPICH-InformationItem-Cell-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrimaryCCPCH-Information-Cell-ReconfRqstFDD >-----#
    PrimaryCCPCH_Information_Cell_ReconfRqstFDD = SEQ(name='PrimaryCCPCH-Information-Cell-ReconfRqstFDD', mode=MODE_TYPE)
    _PrimaryCCPCH_Information_Cell_ReconfRqstFDD_bCH_information = SEQ(name='bCH-information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'BCH-information-Cell-ReconfRqstFDD')))
    _PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions._cont = __PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_
    _PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrimaryCCPCH_Information_Cell_ReconfRqstFDD._cont = ASN1Dict([
        ('bCH-information', _PrimaryCCPCH_Information_Cell_ReconfRqstFDD_bCH_information),
        ('iE-Extensions', _PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions),
        ])
    PrimaryCCPCH_Information_Cell_ReconfRqstFDD._ext = []
    
    #-----< PrimaryCCPCH-Information-Cell-ReconfRqstFDD-ExtIEs >-----#
    PrimaryCCPCH_Information_Cell_ReconfRqstFDD_ExtIEs = CLASS(name='PrimaryCCPCH-Information-Cell-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PrimaryCCPCH_Information_Cell_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCH-information-Cell-ReconfRqstFDD >-----#
    BCH_information_Cell_ReconfRqstFDD = SEQ(name='BCH-information-Cell-ReconfRqstFDD', mode=MODE_TYPE)
    _BCH_information_Cell_ReconfRqstFDD_commonTransportChannelID = INT(name='commonTransportChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonTransportChannelID')))
    _BCH_information_Cell_ReconfRqstFDD_bCH_Power = INT(name='bCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _BCH_information_Cell_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _BCH_information_Cell_ReconfRqstFDD_iE_Extensions._cont = __BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item_
    _BCH_information_Cell_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BCH_information_Cell_ReconfRqstFDD._cont = ASN1Dict([
        ('commonTransportChannelID', _BCH_information_Cell_ReconfRqstFDD_commonTransportChannelID),
        ('bCH-Power', _BCH_information_Cell_ReconfRqstFDD_bCH_Power),
        ('iE-Extensions', _BCH_information_Cell_ReconfRqstFDD_iE_Extensions),
        ])
    BCH_information_Cell_ReconfRqstFDD._ext = []
    
    #-----< BCH-information-Cell-ReconfRqstFDD-ExtIEs >-----#
    BCH_information_Cell_ReconfRqstFDD_ExtIEs = CLASS(name='BCH-information-Cell-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    BCH_information_Cell_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPDLParameter-Information-Cell-ReconfRqstFDD >-----#
    IPDLParameter_Information_Cell_ReconfRqstFDD = SEQ(name='IPDLParameter-Information-Cell-ReconfRqstFDD', mode=MODE_TYPE)
    _IPDLParameter_Information_Cell_ReconfRqstFDD_iPDL_FDD_Parameters = SEQ(name='iPDL-FDD-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-FDD-Parameters')), opt=True)
    _IPDLParameter_Information_Cell_ReconfRqstFDD_iPDL_Indicator = ENUM(name='iPDL-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-Indicator')))
    _IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions._cont = __IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item_
    _IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDLParameter_Information_Cell_ReconfRqstFDD._cont = ASN1Dict([
        ('iPDL-FDD-Parameters', _IPDLParameter_Information_Cell_ReconfRqstFDD_iPDL_FDD_Parameters),
        ('iPDL-Indicator', _IPDLParameter_Information_Cell_ReconfRqstFDD_iPDL_Indicator),
        ('iE-Extensions', _IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions),
        ])
    IPDLParameter_Information_Cell_ReconfRqstFDD._ext = []
    
    #-----< IPDLParameter-Information-Cell-ReconfRqstFDD-ExtIEs >-----#
    IPDLParameter_Information_Cell_ReconfRqstFDD_ExtIEs = CLASS(name='IPDLParameter-Information-Cell-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    IPDLParameter_Information_Cell_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellPortion-InformationList-Cell-ReconfRqstFDD >-----#
    CellPortion_InformationList_Cell_ReconfRqstFDD = SEQ_OF(name='CellPortion-InformationList-Cell-ReconfRqstFDD', mode=MODE_TYPE)
    _CellPortion_InformationList_Cell_ReconfRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___CellPortion_InformationList_Cell_ReconfRqstFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____CellPortion_InformationList_Cell_ReconfRqstFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellPortion-InformationItem-Cell-ReconfRqstFDD')))
    ___CellPortion_InformationList_Cell_ReconfRqstFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 694), ('criticality', 'reject'), ('Value', ____CellPortion_InformationList_Cell_ReconfRqstFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__id._const_tab = ___CellPortion_InformationList_Cell_ReconfRqstFDD__item__id_tab
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__id._const_tab_at = None
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__id._const_tab_id = 'id'
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__criticality._const_tab = ___CellPortion_InformationList_Cell_ReconfRqstFDD__item__id_tab
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__criticality._const_tab_at = ('..', 'id')
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__criticality._const_tab_id = 'criticality'
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__value._const_tab = ___CellPortion_InformationList_Cell_ReconfRqstFDD__item__id_tab
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__value._const_tab_at = ('..', 'id')
    __CellPortion_InformationList_Cell_ReconfRqstFDD__item__value._const_tab_id = 'Value'
    _CellPortion_InformationList_Cell_ReconfRqstFDD__item_._cont = ASN1Dict([
        ('id', __CellPortion_InformationList_Cell_ReconfRqstFDD__item__id),
        ('criticality', __CellPortion_InformationList_Cell_ReconfRqstFDD__item__criticality),
        ('value', __CellPortion_InformationList_Cell_ReconfRqstFDD__item__value),
        ])
    _CellPortion_InformationList_Cell_ReconfRqstFDD__item_._ext = None
    CellPortion_InformationList_Cell_ReconfRqstFDD._cont = _CellPortion_InformationList_Cell_ReconfRqstFDD__item_
    CellPortion_InformationList_Cell_ReconfRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< CellPortion-InformationItemIE-Cell-ReconfRqstFDD >-----#
    CellPortion_InformationItemIE_Cell_ReconfRqstFDD = CLASS(name='CellPortion-InformationItemIE-Cell-ReconfRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellPortion_InformationItemIE_Cell_ReconfRqstFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellPortion-InformationItem-Cell-ReconfRqstFDD')))
    CellPortion_InformationItemIE_Cell_ReconfRqstFDD._val = ASN1Set(rv=[dict([('id', 694), ('criticality', 'reject'), ('Value', _CellPortion_InformationItemIE_Cell_ReconfRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellPortion-InformationItem-Cell-ReconfRqstFDD >-----#
    CellPortion_InformationItem_Cell_ReconfRqstFDD = SEQ(name='CellPortion-InformationItem-Cell-ReconfRqstFDD', mode=MODE_TYPE)
    _CellPortion_InformationItem_Cell_ReconfRqstFDD_cellPortionID = INT(name='cellPortionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionID')))
    _CellPortion_InformationItem_Cell_ReconfRqstFDD_maximumTransmissionPowerforCellPortion = INT(name='maximumTransmissionPowerforCellPortion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions._cont = __CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item_
    _CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellPortion_InformationItem_Cell_ReconfRqstFDD._cont = ASN1Dict([
        ('cellPortionID', _CellPortion_InformationItem_Cell_ReconfRqstFDD_cellPortionID),
        ('maximumTransmissionPowerforCellPortion', _CellPortion_InformationItem_Cell_ReconfRqstFDD_maximumTransmissionPowerforCellPortion),
        ('iE-Extensions', _CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions),
        ])
    CellPortion_InformationItem_Cell_ReconfRqstFDD._ext = []
    
    #-----< CellPortion-InformationItem-Cell-ReconfRqstFDD-ExtIEs >-----#
    CellPortion_InformationItem_Cell_ReconfRqstFDD_ExtIEs = CLASS(name='CellPortion-InformationItem-Cell-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellPortion_InformationItem_Cell_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellReconfigurationRequestTDD >-----#
    CellReconfigurationRequestTDD = SEQ(name='CellReconfigurationRequestTDD', mode=MODE_TYPE)
    _CellReconfigurationRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellReconfigurationRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellReconfigurationRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellReconfigurationRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Synchronisation-Configuration-Cell-ReconfRqst')))
    _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimingAdvanceApplied')))
    _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SCH-Information-Cell-ReconfRqstTDD')))
    _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCCPCH-Information-Cell-ReconfRqstTDD')))
    _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-Cell-ReconfRqstTDD')))
    ____CellReconfigurationRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 393), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 183), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 131), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 359), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 384), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 381), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'reject'), ('Value', _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellReconfigurationRequestTDD_protocolIEs__item__id._const_tab = ____CellReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___CellReconfigurationRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___CellReconfigurationRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellReconfigurationRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab = ____CellReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___CellReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellReconfigurationRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellReconfigurationRequestTDD_protocolIEs__item__value._const_tab = ____CellReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___CellReconfigurationRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellReconfigurationRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellReconfigurationRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellReconfigurationRequestTDD_protocolIEs__item__id),
        ('criticality', ___CellReconfigurationRequestTDD_protocolIEs__item__criticality),
        ('value', ___CellReconfigurationRequestTDD_protocolIEs__item__value),
        ])
    __CellReconfigurationRequestTDD_protocolIEs__item_._ext = None
    _CellReconfigurationRequestTDD_protocolIEs._cont = __CellReconfigurationRequestTDD_protocolIEs__item_
    _CellReconfigurationRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellReconfigurationRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellReconfigurationRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellReconfigurationRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD')))
    _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DwPCH-LCR-Information-Cell-ReconfRqstTDD')))
    _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-Cell-ReconfRqstTDD')))
    _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-LCR-Cell-ReconfRqstTDD')))
    _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SCH-768-Information-Cell-ReconfRqstTDD')))
    _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCCPCH-768-Information-Cell-ReconfRqstTDD')))
    _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UARFCN-Adjustment')))
    _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DormantModeIndicator')))
    ____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 466), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 99), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 453), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 730), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 731), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 916), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1138), ('criticality', 'reject'), ('Extension', _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellReconfigurationRequestTDD_protocolExtensions__item__id._const_tab = ____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___CellReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellReconfigurationRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab = ____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___CellReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellReconfigurationRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___CellReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellReconfigurationRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellReconfigurationRequestTDD_protocolExtensions__item__id),
        ('criticality', ___CellReconfigurationRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellReconfigurationRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __CellReconfigurationRequestTDD_protocolExtensions__item_._ext = None
    _CellReconfigurationRequestTDD_protocolExtensions._cont = __CellReconfigurationRequestTDD_protocolExtensions__item_
    _CellReconfigurationRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellReconfigurationRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _CellReconfigurationRequestTDD_protocolIEs),
        ('protocolExtensions', _CellReconfigurationRequestTDD_protocolExtensions),
        ])
    CellReconfigurationRequestTDD._ext = []
    
    #-----< CellReconfigurationRequestTDD-IEs >-----#
    CellReconfigurationRequestTDD_IEs = CLASS(name='CellReconfigurationRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellReconfigurationRequestTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CellReconfigurationRequestTDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _CellReconfigurationRequestTDD_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Synchronisation-Configuration-Cell-ReconfRqst')))
    _CellReconfigurationRequestTDD_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimingAdvanceApplied')))
    _CellReconfigurationRequestTDD_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SCH-Information-Cell-ReconfRqstTDD')))
    _CellReconfigurationRequestTDD_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCCPCH-Information-Cell-ReconfRqstTDD')))
    _CellReconfigurationRequestTDD_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _CellReconfigurationRequestTDD_IEs_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _CellReconfigurationRequestTDD_IEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _CellReconfigurationRequestTDD_IEs_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConstantValue')))
    _CellReconfigurationRequestTDD_IEs_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-Cell-ReconfRqstTDD')))
    CellReconfigurationRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestTDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 393), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestTDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestTDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 183), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestTDD_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestTDD_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 131), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestTDD_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 359), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestTDD_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 384), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestTDD_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 381), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestTDD_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'reject'), ('Value', _CellReconfigurationRequestTDD_IEs_val_Value_10), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellReconfigurationRequestTDD-Extensions >-----#
    CellReconfigurationRequestTDD_Extensions = CLASS(name='CellReconfigurationRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CellReconfigurationRequestTDD_Extensions_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD')))
    _CellReconfigurationRequestTDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DwPCH-LCR-Information-Cell-ReconfRqstTDD')))
    _CellReconfigurationRequestTDD_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-Cell-ReconfRqstTDD')))
    _CellReconfigurationRequestTDD_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IPDLParameter-Information-LCR-Cell-ReconfRqstTDD')))
    _CellReconfigurationRequestTDD_Extensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SCH-768-Information-Cell-ReconfRqstTDD')))
    _CellReconfigurationRequestTDD_Extensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCCPCH-768-Information-Cell-ReconfRqstTDD')))
    _CellReconfigurationRequestTDD_Extensions_val_Extension_6 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UARFCN-Adjustment')))
    _CellReconfigurationRequestTDD_Extensions_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DormantModeIndicator')))
    CellReconfigurationRequestTDD_Extensions._val = ASN1Set(rv=[dict([('id', 466), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 99), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestTDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 453), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestTDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestTDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 730), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestTDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 731), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestTDD_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 916), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestTDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 1138), ('criticality', 'reject'), ('Extension', _CellReconfigurationRequestTDD_Extensions_val_Extension_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SCH-Information-Cell-ReconfRqstTDD >-----#
    SCH_Information_Cell_ReconfRqstTDD = SEQ(name='SCH-Information-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _SCH_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _SCH_Information_Cell_ReconfRqstTDD_sCH_Power = INT(name='sCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _SCH_Information_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _SCH_Information_Cell_ReconfRqstTDD_iE_Extensions._cont = __SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item_
    _SCH_Information_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCH_Information_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _SCH_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID),
        ('sCH-Power', _SCH_Information_Cell_ReconfRqstTDD_sCH_Power),
        ('iE-Extensions', _SCH_Information_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    SCH_Information_Cell_ReconfRqstTDD._ext = []
    
    #-----< PSCH-Information-Cell-ReconfRqstTDD-ExtIEs >-----#
    PSCH_Information_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='PSCH-Information-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PSCH_Information_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCCPCH-Information-Cell-ReconfRqstTDD >-----#
    PCCPCH_Information_Cell_ReconfRqstTDD = SEQ(name='PCCPCH-Information-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _PCCPCH_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID = INT(name='commonPhysicalChannelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _PCCPCH_Information_Cell_ReconfRqstTDD_pCCPCH_Power = INT(name='pCCPCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PCCPCH-Power')))
    _PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions._cont = __PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item_
    _PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PCCPCH_Information_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID', _PCCPCH_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID),
        ('pCCPCH-Power', _PCCPCH_Information_Cell_ReconfRqstTDD_pCCPCH_Power),
        ('iE-Extensions', _PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    PCCPCH_Information_Cell_ReconfRqstTDD._ext = []
    
    #-----< PCCPCH-Information-Cell-ReconfRqstTDD-ExtIEs >-----#
    PCCPCH_Information_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='PCCPCH-Information-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PCCPCH_Information_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeSlotConfigurationList-Cell-ReconfRqstTDD >-----#
    TimeSlotConfigurationList_Cell_ReconfRqstTDD = SEQ_OF(name='TimeSlotConfigurationList-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _TimeSlotConfigurationList_Cell_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationItem-Cell-ReconfRqstTDD')))
    TimeSlotConfigurationList_Cell_ReconfRqstTDD._cont = _TimeSlotConfigurationList_Cell_ReconfRqstTDD__item_
    TimeSlotConfigurationList_Cell_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< TimeSlotConfigurationItem-Cell-ReconfRqstTDD >-----#
    TimeSlotConfigurationItem_Cell_ReconfRqstTDD = SEQ(name='TimeSlotConfigurationItem-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_timeSlotStatus = ENUM(name='timeSlotStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotStatus')))
    _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_timeSlotDirection = ENUM(name='timeSlotDirection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotDirection')))
    _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    ____TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 842), ('criticality', 'reject'), ('Extension', _____TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions._cont = __TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item_
    _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeSlotConfigurationItem_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('timeSlot', _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_timeSlot),
        ('timeSlotStatus', _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_timeSlotStatus),
        ('timeSlotDirection', _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_timeSlotDirection),
        ('iE-Extensions', _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    TimeSlotConfigurationItem_Cell_ReconfRqstTDD._ext = []
    
    #-----< TimeSlotConfigurationItem-Cell-ReconfRqstTDD-ExtIEs >-----#
    TimeSlotConfigurationItem_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='TimeSlotConfigurationItem-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellParameterID')))
    TimeSlotConfigurationItem_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 842), ('criticality', 'reject'), ('Extension', _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD >-----#
    TimeSlotConfigurationList_LCR_Cell_ReconfRqstTDD = SEQ_OF(name='TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _TimeSlotConfigurationList_LCR_Cell_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationItem-LCR-Cell-ReconfRqstTDD')))
    TimeSlotConfigurationList_LCR_Cell_ReconfRqstTDD._cont = _TimeSlotConfigurationList_LCR_Cell_ReconfRqstTDD__item_
    TimeSlotConfigurationList_LCR_Cell_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< TimeSlotConfigurationItem-LCR-Cell-ReconfRqstTDD >-----#
    TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD = SEQ(name='TimeSlotConfigurationItem-LCR-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_timeSlotStatus = ENUM(name='timeSlotStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotStatus')))
    _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_timeSlotDirection = ENUM(name='timeSlotDirection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotDirection')))
    _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions._cont = __TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item_
    _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('timeSlotLCR', _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_timeSlotLCR),
        ('timeSlotStatus', _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_timeSlotStatus),
        ('timeSlotDirection', _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_timeSlotDirection),
        ('iE-Extensions', _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD._ext = []
    
    #-----< TimeSlotConfigurationItem-LCR-Cell-ReconfRqstTDD-ExtIEs >-----#
    TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='TimeSlotConfigurationItem-LCR-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DwPCH-LCR-Information-Cell-ReconfRqstTDD >-----#
    DwPCH_LCR_Information_Cell_ReconfRqstTDD = SEQ(name='DwPCH-LCR-Information-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _DwPCH_LCR_Information_Cell_ReconfRqstTDD_commonPhysicalChannelId = INT(name='commonPhysicalChannelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _DwPCH_LCR_Information_Cell_ReconfRqstTDD_dwPCH_Power = INT(name='dwPCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DwPCH-Power')))
    _DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions._cont = __DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item_
    _DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DwPCH_LCR_Information_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelId', _DwPCH_LCR_Information_Cell_ReconfRqstTDD_commonPhysicalChannelId),
        ('dwPCH-Power', _DwPCH_LCR_Information_Cell_ReconfRqstTDD_dwPCH_Power),
        ('iE-Extensions', _DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    DwPCH_LCR_Information_Cell_ReconfRqstTDD._ext = []
    
    #-----< DwPCH-LCR-Information-Cell-ReconfRqstTDD-ExtIEs >-----#
    DwPCH_LCR_Information_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='DwPCH-LCR-Information-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DwPCH_LCR_Information_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPDLParameter-Information-Cell-ReconfRqstTDD >-----#
    IPDLParameter_Information_Cell_ReconfRqstTDD = SEQ(name='IPDLParameter-Information-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _IPDLParameter_Information_Cell_ReconfRqstTDD_iPDL_TDD_Parameters = SEQ(name='iPDL-TDD-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-TDD-Parameters')), opt=True)
    _IPDLParameter_Information_Cell_ReconfRqstTDD_iPDL_Indicator = ENUM(name='iPDL-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-Indicator')))
    _IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions._cont = __IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item_
    _IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDLParameter_Information_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('iPDL-TDD-Parameters', _IPDLParameter_Information_Cell_ReconfRqstTDD_iPDL_TDD_Parameters),
        ('iPDL-Indicator', _IPDLParameter_Information_Cell_ReconfRqstTDD_iPDL_Indicator),
        ('iE-Extensions', _IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    IPDLParameter_Information_Cell_ReconfRqstTDD._ext = []
    
    #-----< IPDLParameter-Information-Cell-ReconfRqstTDD-ExtIEs >-----#
    IPDLParameter_Information_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='IPDLParameter-Information-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    IPDLParameter_Information_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPDLParameter-Information-LCR-Cell-ReconfRqstTDD >-----#
    IPDLParameter_Information_LCR_Cell_ReconfRqstTDD = SEQ(name='IPDLParameter-Information-LCR-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iPDL_TDD_Parameters_LCR = SEQ(name='iPDL-TDD-Parameters-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-TDD-Parameters-LCR')), opt=True)
    _IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iPDL_Indicator = ENUM(name='iPDL-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IPDL-Indicator')))
    _IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions._cont = __IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item_
    _IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDLParameter_Information_LCR_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('iPDL-TDD-Parameters-LCR', _IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iPDL_TDD_Parameters_LCR),
        ('iPDL-Indicator', _IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iPDL_Indicator),
        ('iE-Extensions', _IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    IPDLParameter_Information_LCR_Cell_ReconfRqstTDD._ext = []
    
    #-----< IPDLParameter-Information-LCR-Cell-ReconfRqstTDD-ExtIEs >-----#
    IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='IPDLParameter-Information-LCR-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCH-768-Information-Cell-ReconfRqstTDD >-----#
    SCH_768_Information_Cell_ReconfRqstTDD = SEQ(name='SCH-768-Information-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _SCH_768_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _SCH_768_Information_Cell_ReconfRqstTDD_sCH_Power = INT(name='sCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions._cont = __SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item_
    _SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCH_768_Information_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _SCH_768_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID768),
        ('sCH-Power', _SCH_768_Information_Cell_ReconfRqstTDD_sCH_Power),
        ('iE-Extensions', _SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    SCH_768_Information_Cell_ReconfRqstTDD._ext = []
    
    #-----< PSCH-768-Information-Cell-ReconfRqstTDD-ExtIEs >-----#
    PSCH_768_Information_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='PSCH-768-Information-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PSCH_768_Information_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCCPCH-768-Information-Cell-ReconfRqstTDD >-----#
    PCCPCH_768_Information_Cell_ReconfRqstTDD = SEQ(name='PCCPCH-768-Information-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _PCCPCH_768_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID768 = INT(name='commonPhysicalChannelID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID768')))
    _PCCPCH_768_Information_Cell_ReconfRqstTDD_pCCPCH_Power = INT(name='pCCPCH-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PCCPCH-Power')))
    _PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions._cont = __PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item_
    _PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PCCPCH_768_Information_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('commonPhysicalChannelID768', _PCCPCH_768_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID768),
        ('pCCPCH-Power', _PCCPCH_768_Information_Cell_ReconfRqstTDD_pCCPCH_Power),
        ('iE-Extensions', _PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    PCCPCH_768_Information_Cell_ReconfRqstTDD._ext = []
    
    #-----< PCCPCH-768-Information-Cell-ReconfRqstTDD-ExtIEs >-----#
    PCCPCH_768_Information_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='PCCPCH-768-Information-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PCCPCH_768_Information_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UARFCN-Adjustment >-----#
    UARFCN_Adjustment = CHOICE(name='UARFCN-Adjustment', mode=MODE_TYPE)
    _UARFCN_Adjustment_cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD = SEQ(name='cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD')))
    _UARFCN_Adjustment_cell_Frequency_ModifyList_LCR_MulFreq_Cell_ReconfRqstTDD = SEQ_OF(name='cell-Frequency-ModifyList-LCR-MulFreq-Cell-ReconfRqstTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-ModifyList-LCR-MulFreq-Cell-ReconfRqstTDD')))
    _UARFCN_Adjustment_cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD = SEQ(name='cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD')))
    UARFCN_Adjustment._cont = ASN1Dict([
        ('cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD', _UARFCN_Adjustment_cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD),
        ('cell-Frequency-ModifyList-LCR-MulFreq-Cell-ReconfRqstTDD', _UARFCN_Adjustment_cell_Frequency_ModifyList_LCR_MulFreq_Cell_ReconfRqstTDD),
        ('cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD', _UARFCN_Adjustment_cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD),
        ])
    UARFCN_Adjustment._ext = []
    
    #-----< Cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD >-----#
    Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD = SEQ(name='Cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_timeSlotConfigurationList_LCR_Cell_ReconfRqstTDD = SEQ_OF(name='timeSlotConfigurationList-LCR-Cell-ReconfRqstTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD')))
    _Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions._cont = __Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_
    _Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('uARFCN', _Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_uARFCN),
        ('timeSlotConfigurationList-LCR-Cell-ReconfRqstTDD', _Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_timeSlotConfigurationList_LCR_Cell_ReconfRqstTDD),
        ('iE-Extensions', _Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD._ext = []
    
    #-----< Cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs >-----#
    Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='Cell-Frequency-Add-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cell-Frequency-ModifyList-LCR-MulFreq-Cell-ReconfRqstTDD >-----#
    Cell_Frequency_ModifyList_LCR_MulFreq_Cell_ReconfRqstTDD = SEQ_OF(name='Cell-Frequency-ModifyList-LCR-MulFreq-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _Cell_Frequency_ModifyList_LCR_MulFreq_Cell_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-ModifyItem-LCR-MulFreq-Cell-ReconfRqstTDD')))
    Cell_Frequency_ModifyList_LCR_MulFreq_Cell_ReconfRqstTDD._cont = _Cell_Frequency_ModifyList_LCR_MulFreq_Cell_ReconfRqstTDD__item_
    Cell_Frequency_ModifyList_LCR_MulFreq_Cell_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< Cell-Frequency-ModifyItem-LCR-MulFreq-Cell-ReconfRqstTDD >-----#
    Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD = SEQ(name='Cell-Frequency-ModifyItem-LCR-MulFreq-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_timeSlotConfigurationList_LCR_Cell_ReconfRqstTDD = SEQ_OF(name='timeSlotConfigurationList-LCR-Cell-ReconfRqstTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeSlotConfigurationList-LCR-Cell-ReconfRqstTDD')))
    _Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions._cont = __Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_
    _Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('uARFCN', _Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_uARFCN),
        ('timeSlotConfigurationList-LCR-Cell-ReconfRqstTDD', _Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_timeSlotConfigurationList_LCR_Cell_ReconfRqstTDD),
        ('iE-Extensions', _Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD._ext = []
    
    #-----< Cell-Frequency-ModifyItem-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs >-----#
    Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='Cell-Frequency-ModifyItem-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD >-----#
    Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD = SEQ(name='Cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD', mode=MODE_TYPE)
    _Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions._cont = __Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_
    _Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD._cont = ASN1Dict([
        ('uARFCN', _Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_uARFCN),
        ('iE-Extensions', _Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions),
        ])
    Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD._ext = []
    
    #-----< Cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs >-----#
    Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_ExtIEs = CLASS(name='Cell-Frequency-Delete-LCR-MulFreq-Cell-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellReconfigurationResponse >-----#
    CellReconfigurationResponse = SEQ(name='CellReconfigurationResponse', mode=MODE_TYPE)
    _CellReconfigurationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellReconfigurationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellReconfigurationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellReconfigurationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CellReconfigurationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CellReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellReconfigurationResponse_protocolIEs__item__id._const_tab = ____CellReconfigurationResponse_protocolIEs__item__id_tab
    ___CellReconfigurationResponse_protocolIEs__item__id._const_tab_at = None
    ___CellReconfigurationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___CellReconfigurationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellReconfigurationResponse_protocolIEs__item__criticality._const_tab = ____CellReconfigurationResponse_protocolIEs__item__id_tab
    ___CellReconfigurationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellReconfigurationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellReconfigurationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellReconfigurationResponse_protocolIEs__item__value._const_tab = ____CellReconfigurationResponse_protocolIEs__item__id_tab
    ___CellReconfigurationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellReconfigurationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __CellReconfigurationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellReconfigurationResponse_protocolIEs__item__id),
        ('criticality', ___CellReconfigurationResponse_protocolIEs__item__criticality),
        ('value', ___CellReconfigurationResponse_protocolIEs__item__value),
        ])
    __CellReconfigurationResponse_protocolIEs__item_._ext = None
    _CellReconfigurationResponse_protocolIEs._cont = __CellReconfigurationResponse_protocolIEs__item_
    _CellReconfigurationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellReconfigurationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellReconfigurationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellReconfigurationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellReconfigurationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellReconfigurationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellReconfigurationResponse_protocolExtensions__item__id._const_tab = ____CellReconfigurationResponse_protocolExtensions__item__id_tab
    ___CellReconfigurationResponse_protocolExtensions__item__id._const_tab_at = None
    ___CellReconfigurationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellReconfigurationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellReconfigurationResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellReconfigurationResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellReconfigurationResponse_protocolExtensions__item__criticality._const_tab = ____CellReconfigurationResponse_protocolExtensions__item__criticality_tab
    ___CellReconfigurationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellReconfigurationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellReconfigurationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellReconfigurationResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellReconfigurationResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab = ____CellReconfigurationResponse_protocolExtensions__item__extensionValue_tab
    ___CellReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellReconfigurationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellReconfigurationResponse_protocolExtensions__item__id),
        ('criticality', ___CellReconfigurationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___CellReconfigurationResponse_protocolExtensions__item__extensionValue),
        ])
    __CellReconfigurationResponse_protocolExtensions__item_._ext = None
    _CellReconfigurationResponse_protocolExtensions._cont = __CellReconfigurationResponse_protocolExtensions__item_
    _CellReconfigurationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellReconfigurationResponse._cont = ASN1Dict([
        ('protocolIEs', _CellReconfigurationResponse_protocolIEs),
        ('protocolExtensions', _CellReconfigurationResponse_protocolExtensions),
        ])
    CellReconfigurationResponse._ext = []
    
    #-----< CellReconfigurationResponse-IEs >-----#
    CellReconfigurationResponse_IEs = CLASS(name='CellReconfigurationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellReconfigurationResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CellReconfigurationResponse_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _CellReconfigurationResponse_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellReconfigurationResponse-Extensions >-----#
    CellReconfigurationResponse_Extensions = CLASS(name='CellReconfigurationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellReconfigurationResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellReconfigurationFailure >-----#
    CellReconfigurationFailure = SEQ(name='CellReconfigurationFailure', mode=MODE_TYPE)
    _CellReconfigurationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellReconfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellReconfigurationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellReconfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____CellReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CellReconfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _____CellReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CellReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellReconfigurationFailure_protocolIEs__item__id._const_tab = ____CellReconfigurationFailure_protocolIEs__item__id_tab
    ___CellReconfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___CellReconfigurationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___CellReconfigurationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellReconfigurationFailure_protocolIEs__item__criticality._const_tab = ____CellReconfigurationFailure_protocolIEs__item__id_tab
    ___CellReconfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellReconfigurationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellReconfigurationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellReconfigurationFailure_protocolIEs__item__value._const_tab = ____CellReconfigurationFailure_protocolIEs__item__id_tab
    ___CellReconfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellReconfigurationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __CellReconfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellReconfigurationFailure_protocolIEs__item__id),
        ('criticality', ___CellReconfigurationFailure_protocolIEs__item__criticality),
        ('value', ___CellReconfigurationFailure_protocolIEs__item__value),
        ])
    __CellReconfigurationFailure_protocolIEs__item_._ext = None
    _CellReconfigurationFailure_protocolIEs._cont = __CellReconfigurationFailure_protocolIEs__item_
    _CellReconfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellReconfigurationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellReconfigurationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellReconfigurationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellReconfigurationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellReconfigurationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellReconfigurationFailure_protocolExtensions__item__id._const_tab = ____CellReconfigurationFailure_protocolExtensions__item__id_tab
    ___CellReconfigurationFailure_protocolExtensions__item__id._const_tab_at = None
    ___CellReconfigurationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellReconfigurationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellReconfigurationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellReconfigurationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellReconfigurationFailure_protocolExtensions__item__criticality._const_tab = ____CellReconfigurationFailure_protocolExtensions__item__criticality_tab
    ___CellReconfigurationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellReconfigurationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellReconfigurationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellReconfigurationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellReconfigurationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab = ____CellReconfigurationFailure_protocolExtensions__item__extensionValue_tab
    ___CellReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellReconfigurationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellReconfigurationFailure_protocolExtensions__item__id),
        ('criticality', ___CellReconfigurationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___CellReconfigurationFailure_protocolExtensions__item__extensionValue),
        ])
    __CellReconfigurationFailure_protocolExtensions__item_._ext = None
    _CellReconfigurationFailure_protocolExtensions._cont = __CellReconfigurationFailure_protocolExtensions__item_
    _CellReconfigurationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellReconfigurationFailure._cont = ASN1Dict([
        ('protocolIEs', _CellReconfigurationFailure_protocolIEs),
        ('protocolExtensions', _CellReconfigurationFailure_protocolExtensions),
        ])
    CellReconfigurationFailure._ext = []
    
    #-----< CellReconfigurationFailure-IEs >-----#
    CellReconfigurationFailure_IEs = CLASS(name='CellReconfigurationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellReconfigurationFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _CellReconfigurationFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CellReconfigurationFailure_IEs._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _CellReconfigurationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _CellReconfigurationFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellReconfigurationFailure-Extensions >-----#
    CellReconfigurationFailure_Extensions = CLASS(name='CellReconfigurationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellReconfigurationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellDeletionRequest >-----#
    CellDeletionRequest = SEQ(name='CellDeletionRequest', mode=MODE_TYPE)
    _CellDeletionRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellDeletionRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellDeletionRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellDeletionRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellDeletionRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    ____CellDeletionRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____CellDeletionRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CellDeletionRequest_protocolIEs__item__id._const_tab = ____CellDeletionRequest_protocolIEs__item__id_tab
    ___CellDeletionRequest_protocolIEs__item__id._const_tab_at = None
    ___CellDeletionRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___CellDeletionRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellDeletionRequest_protocolIEs__item__criticality._const_tab = ____CellDeletionRequest_protocolIEs__item__id_tab
    ___CellDeletionRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellDeletionRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellDeletionRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellDeletionRequest_protocolIEs__item__value._const_tab = ____CellDeletionRequest_protocolIEs__item__id_tab
    ___CellDeletionRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellDeletionRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __CellDeletionRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellDeletionRequest_protocolIEs__item__id),
        ('criticality', ___CellDeletionRequest_protocolIEs__item__criticality),
        ('value', ___CellDeletionRequest_protocolIEs__item__value),
        ])
    __CellDeletionRequest_protocolIEs__item_._ext = None
    _CellDeletionRequest_protocolIEs._cont = __CellDeletionRequest_protocolIEs__item_
    _CellDeletionRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellDeletionRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellDeletionRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellDeletionRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellDeletionRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellDeletionRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellDeletionRequest_protocolExtensions__item__id._const_tab = ____CellDeletionRequest_protocolExtensions__item__id_tab
    ___CellDeletionRequest_protocolExtensions__item__id._const_tab_at = None
    ___CellDeletionRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellDeletionRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellDeletionRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellDeletionRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellDeletionRequest_protocolExtensions__item__criticality._const_tab = ____CellDeletionRequest_protocolExtensions__item__criticality_tab
    ___CellDeletionRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellDeletionRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellDeletionRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellDeletionRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellDeletionRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellDeletionRequest_protocolExtensions__item__extensionValue._const_tab = ____CellDeletionRequest_protocolExtensions__item__extensionValue_tab
    ___CellDeletionRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellDeletionRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellDeletionRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellDeletionRequest_protocolExtensions__item__id),
        ('criticality', ___CellDeletionRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___CellDeletionRequest_protocolExtensions__item__extensionValue),
        ])
    __CellDeletionRequest_protocolExtensions__item_._ext = None
    _CellDeletionRequest_protocolExtensions._cont = __CellDeletionRequest_protocolExtensions__item_
    _CellDeletionRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellDeletionRequest._cont = ASN1Dict([
        ('protocolIEs', _CellDeletionRequest_protocolIEs),
        ('protocolExtensions', _CellDeletionRequest_protocolExtensions),
        ])
    CellDeletionRequest._ext = []
    
    #-----< CellDeletionRequest-IEs >-----#
    CellDeletionRequest_IEs = CLASS(name='CellDeletionRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellDeletionRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    CellDeletionRequest_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _CellDeletionRequest_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellDeletionRequest-Extensions >-----#
    CellDeletionRequest_Extensions = CLASS(name='CellDeletionRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellDeletionRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellDeletionResponse >-----#
    CellDeletionResponse = SEQ(name='CellDeletionResponse', mode=MODE_TYPE)
    _CellDeletionResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellDeletionResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellDeletionResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellDeletionResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellDeletionResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CellDeletionResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CellDeletionResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellDeletionResponse_protocolIEs__item__id._const_tab = ____CellDeletionResponse_protocolIEs__item__id_tab
    ___CellDeletionResponse_protocolIEs__item__id._const_tab_at = None
    ___CellDeletionResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___CellDeletionResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellDeletionResponse_protocolIEs__item__criticality._const_tab = ____CellDeletionResponse_protocolIEs__item__id_tab
    ___CellDeletionResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellDeletionResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellDeletionResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellDeletionResponse_protocolIEs__item__value._const_tab = ____CellDeletionResponse_protocolIEs__item__id_tab
    ___CellDeletionResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellDeletionResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __CellDeletionResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellDeletionResponse_protocolIEs__item__id),
        ('criticality', ___CellDeletionResponse_protocolIEs__item__criticality),
        ('value', ___CellDeletionResponse_protocolIEs__item__value),
        ])
    __CellDeletionResponse_protocolIEs__item_._ext = None
    _CellDeletionResponse_protocolIEs._cont = __CellDeletionResponse_protocolIEs__item_
    _CellDeletionResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellDeletionResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellDeletionResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellDeletionResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellDeletionResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellDeletionResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellDeletionResponse_protocolExtensions__item__id._const_tab = ____CellDeletionResponse_protocolExtensions__item__id_tab
    ___CellDeletionResponse_protocolExtensions__item__id._const_tab_at = None
    ___CellDeletionResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellDeletionResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellDeletionResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellDeletionResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellDeletionResponse_protocolExtensions__item__criticality._const_tab = ____CellDeletionResponse_protocolExtensions__item__criticality_tab
    ___CellDeletionResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellDeletionResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellDeletionResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellDeletionResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellDeletionResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellDeletionResponse_protocolExtensions__item__extensionValue._const_tab = ____CellDeletionResponse_protocolExtensions__item__extensionValue_tab
    ___CellDeletionResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellDeletionResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellDeletionResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellDeletionResponse_protocolExtensions__item__id),
        ('criticality', ___CellDeletionResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___CellDeletionResponse_protocolExtensions__item__extensionValue),
        ])
    __CellDeletionResponse_protocolExtensions__item_._ext = None
    _CellDeletionResponse_protocolExtensions._cont = __CellDeletionResponse_protocolExtensions__item_
    _CellDeletionResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellDeletionResponse._cont = ASN1Dict([
        ('protocolIEs', _CellDeletionResponse_protocolIEs),
        ('protocolExtensions', _CellDeletionResponse_protocolExtensions),
        ])
    CellDeletionResponse._ext = []
    
    #-----< CellDeletionResponse-IEs >-----#
    CellDeletionResponse_IEs = CLASS(name='CellDeletionResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellDeletionResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CellDeletionResponse_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _CellDeletionResponse_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellDeletionResponse-Extensions >-----#
    CellDeletionResponse_Extensions = CLASS(name='CellDeletionResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellDeletionResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusIndication >-----#
    ResourceStatusIndication = SEQ(name='ResourceStatusIndication', mode=MODE_TYPE)
    _ResourceStatusIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____ResourceStatusIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IndicationType-ResourceStatusInd')))
    _____ResourceStatusIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    ____ResourceStatusIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 123), ('criticality', 'ignore'), ('Value', _____ResourceStatusIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____ResourceStatusIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusIndication_protocolIEs__item__id._const_tab = ____ResourceStatusIndication_protocolIEs__item__id_tab
    ___ResourceStatusIndication_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusIndication_protocolIEs__item__criticality._const_tab = ____ResourceStatusIndication_protocolIEs__item__id_tab
    ___ResourceStatusIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusIndication_protocolIEs__item__value._const_tab = ____ResourceStatusIndication_protocolIEs__item__id_tab
    ___ResourceStatusIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusIndication_protocolIEs__item__id),
        ('criticality', ___ResourceStatusIndication_protocolIEs__item__criticality),
        ('value', ___ResourceStatusIndication_protocolIEs__item__value),
        ])
    __ResourceStatusIndication_protocolIEs__item_._ext = None
    _ResourceStatusIndication_protocolIEs._cont = __ResourceStatusIndication_protocolIEs__item_
    _ResourceStatusIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ResourceStatusIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceStatusIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ResourceStatusIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceStatusIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ResourceStatusIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceStatusIndication_protocolExtensions__item__id._const_tab = ____ResourceStatusIndication_protocolExtensions__item__id_tab
    ___ResourceStatusIndication_protocolExtensions__item__id._const_tab_at = None
    ___ResourceStatusIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___ResourceStatusIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceStatusIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ResourceStatusIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceStatusIndication_protocolExtensions__item__criticality._const_tab = ____ResourceStatusIndication_protocolExtensions__item__criticality_tab
    ___ResourceStatusIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceStatusIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ResourceStatusIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceStatusIndication_protocolExtensions__item__extensionValue._const_tab = ____ResourceStatusIndication_protocolExtensions__item__extensionValue_tab
    ___ResourceStatusIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceStatusIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceStatusIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusIndication_protocolExtensions__item__id),
        ('criticality', ___ResourceStatusIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___ResourceStatusIndication_protocolExtensions__item__extensionValue),
        ])
    __ResourceStatusIndication_protocolExtensions__item_._ext = None
    _ResourceStatusIndication_protocolExtensions._cont = __ResourceStatusIndication_protocolExtensions__item_
    _ResourceStatusIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceStatusIndication._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusIndication_protocolIEs),
        ('protocolExtensions', _ResourceStatusIndication_protocolExtensions),
        ])
    ResourceStatusIndication._ext = []
    
    #-----< ResourceStatusIndication-IEs >-----#
    ResourceStatusIndication_IEs = CLASS(name='ResourceStatusIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _ResourceStatusIndication_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'IndicationType-ResourceStatusInd')))
    _ResourceStatusIndication_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    ResourceStatusIndication_IEs._val = ASN1Set(rv=[dict([('id', 123), ('criticality', 'ignore'), ('Value', _ResourceStatusIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _ResourceStatusIndication_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusIndication-Extensions >-----#
    ResourceStatusIndication_Extensions = CLASS(name='ResourceStatusIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ResourceStatusIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IndicationType-ResourceStatusInd >-----#
    IndicationType_ResourceStatusInd = CHOICE(name='IndicationType-ResourceStatusInd', mode=MODE_TYPE)
    _IndicationType_ResourceStatusInd_no_Failure = SEQ(name='no-Failure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'No-Failure-ResourceStatusInd')))
    _IndicationType_ResourceStatusInd_serviceImpacting = SEQ(name='serviceImpacting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'ServiceImpacting-ResourceStatusInd')))
    IndicationType_ResourceStatusInd._cont = ASN1Dict([
        ('no-Failure', _IndicationType_ResourceStatusInd_no_Failure),
        ('serviceImpacting', _IndicationType_ResourceStatusInd_serviceImpacting),
        ])
    IndicationType_ResourceStatusInd._ext = []
    
    #-----< No-Failure-ResourceStatusInd >-----#
    No_Failure_ResourceStatusInd = SEQ(name='No-Failure-ResourceStatusInd', mode=MODE_TYPE)
    _No_Failure_ResourceStatusInd_local_Cell_InformationList = SEQ_OF(name='local-Cell-InformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-InformationList-ResourceStatusInd')))
    _No_Failure_ResourceStatusInd_local_Cell_Group_InformationList = SEQ_OF(name='local-Cell-Group-InformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-Group-InformationList-ResourceStatusInd')), opt=True)
    _No_Failure_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __No_Failure_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____No_Failure_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____No_Failure_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationList-ResourceStatusInd')))
    ____No_Failure_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 502), ('criticality', 'ignore'), ('Extension', _____No_Failure_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____No_Failure_ResourceStatusInd_iE_Extensions__item__id_tab
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____No_Failure_ResourceStatusInd_iE_Extensions__item__id_tab
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____No_Failure_ResourceStatusInd_iE_Extensions__item__id_tab
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___No_Failure_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __No_Failure_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___No_Failure_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___No_Failure_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___No_Failure_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __No_Failure_ResourceStatusInd_iE_Extensions__item_._ext = None
    _No_Failure_ResourceStatusInd_iE_Extensions._cont = __No_Failure_ResourceStatusInd_iE_Extensions__item_
    _No_Failure_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    No_Failure_ResourceStatusInd._cont = ASN1Dict([
        ('local-Cell-InformationList', _No_Failure_ResourceStatusInd_local_Cell_InformationList),
        ('local-Cell-Group-InformationList', _No_Failure_ResourceStatusInd_local_Cell_Group_InformationList),
        ('iE-Extensions', _No_Failure_ResourceStatusInd_iE_Extensions),
        ])
    No_Failure_ResourceStatusInd._ext = []
    
    #-----< No-FailureItem-ResourceStatusInd-ExtIEs >-----#
    No_FailureItem_ResourceStatusInd_ExtIEs = CLASS(name='No-FailureItem-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _No_FailureItem_ResourceStatusInd_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationList-ResourceStatusInd')))
    No_FailureItem_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[dict([('id', 502), ('criticality', 'ignore'), ('Extension', _No_FailureItem_ResourceStatusInd_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Local-Cell-InformationList-ResourceStatusInd >-----#
    Local_Cell_InformationList_ResourceStatusInd = SEQ_OF(name='Local-Cell-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _Local_Cell_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Local_Cell_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Local_Cell_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Local_Cell_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-InformationItem-ResourceStatusInd')))
    ___Local_Cell_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 126), ('criticality', 'ignore'), ('Value', ____Local_Cell_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Local_Cell_InformationList_ResourceStatusInd__item__id._const_tab = ___Local_Cell_InformationList_ResourceStatusInd__item__id_tab
    __Local_Cell_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __Local_Cell_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __Local_Cell_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Local_Cell_InformationList_ResourceStatusInd__item__criticality._const_tab = ___Local_Cell_InformationList_ResourceStatusInd__item__id_tab
    __Local_Cell_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __Local_Cell_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __Local_Cell_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Local_Cell_InformationList_ResourceStatusInd__item__value._const_tab = ___Local_Cell_InformationList_ResourceStatusInd__item__id_tab
    __Local_Cell_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __Local_Cell_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _Local_Cell_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __Local_Cell_InformationList_ResourceStatusInd__item__id),
        ('criticality', __Local_Cell_InformationList_ResourceStatusInd__item__criticality),
        ('value', __Local_Cell_InformationList_ResourceStatusInd__item__value),
        ])
    _Local_Cell_InformationList_ResourceStatusInd__item_._ext = None
    Local_Cell_InformationList_ResourceStatusInd._cont = _Local_Cell_InformationList_ResourceStatusInd__item_
    Local_Cell_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Local-Cell-InformationItemIE-ResourceStatusInd >-----#
    Local_Cell_InformationItemIE_ResourceStatusInd = CLASS(name='Local-Cell-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Local_Cell_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-InformationItem-ResourceStatusInd')))
    Local_Cell_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 126), ('criticality', 'ignore'), ('Value', _Local_Cell_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Local-Cell-InformationItem-ResourceStatusInd >-----#
    Local_Cell_InformationItem_ResourceStatusInd = SEQ(name='Local-Cell-InformationItem-ResourceStatusInd', mode=MODE_TYPE)
    _Local_Cell_InformationItem_ResourceStatusInd_local_CellID = INT(name='local-CellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Local_Cell_InformationItem_ResourceStatusInd_addorDeleteIndicator = ENUM(name='addorDeleteIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AddorDeleteIndicator')))
    _Local_Cell_InformationItem_ResourceStatusInd_dl_or_global_capacityCredit = INT(name='dl-or-global-capacityCredit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-or-Global-CapacityCredit')), opt=True)
    _Local_Cell_InformationItem_ResourceStatusInd_ul_capacityCredit = INT(name='ul-capacityCredit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-CapacityCredit')), opt=True)
    _Local_Cell_InformationItem_ResourceStatusInd_commonChannelsCapacityConsumptionLaw = SEQ_OF(name='commonChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonChannelsCapacityConsumptionLaw')), opt=True)
    _Local_Cell_InformationItem_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw = SEQ_OF(name='dedicatedChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedChannelsCapacityConsumptionLaw')), opt=True)
    _Local_Cell_InformationItem_ResourceStatusInd_maximumDL_PowerCapability = INT(name='maximumDL-PowerCapability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumDL-PowerCapability')), opt=True)
    _Local_Cell_InformationItem_ResourceStatusInd_minSpreadingFactor = ENUM(name='minSpreadingFactor', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MinSpreadingFactor')), opt=True)
    _Local_Cell_InformationItem_ResourceStatusInd_minimumDL_PowerCapability = INT(name='minimumDL-PowerCapability', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MinimumDL-PowerCapability')), opt=True)
    _Local_Cell_InformationItem_ResourceStatusInd_local_Cell_Group_ID = INT(name='local-Cell-Group-ID', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')), opt=True)
    _Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReferenceClockAvailability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_4 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TTI2ms-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-SF-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-Combining-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Max-UE-DTX-Cycle')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_12 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_15 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBMS-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-FACH-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-PCH-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_18 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDU-SizeCapability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_20 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBSFN-Only-Mode-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_21 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormatCapability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_22 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDU-SizeCapability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_23 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_24 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AI-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_25 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_26 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_27 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-Power-Boosting-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_28 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-MIMO-Combined-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_29 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Cell-Capability-Info')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_30 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Semi-PersistentScheduling-CapabilityLCR')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_31 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-CapabilityLCR')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_32 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-HSDPCCH-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_33 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PowerOffsetForS-CPICHCapability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_34 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TxDiversityOnDLControlChannelsByMIMOUECapability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_35 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Capability')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_36 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Dual-Band-Capability-Info')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_37 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellPortion-CapabilityLCR')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_38 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_39 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TS0-CapabilityLCR')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_40 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrecodingWeightSetRestriction')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_41 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container-TDD-LCR')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_42 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Capability-ContainerLCR')))
    _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_43 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Adaptive-Special-Burst-Power-CapabilityLCR')))
    ____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 435), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 504), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 610), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 665), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 704), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'conditional')]), dict([('id', 705), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'conditional')]), dict([('id', 703), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'conditional')]), dict([('id', 687), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 707), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 831), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 874), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'conditional')]), dict([('id', 833), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 837), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 860), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 901), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 895), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 896), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_17), ('presence', 'conditional')]), dict([('id', 861), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 864), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_19), ('presence', 'optional')]), dict([('id', 879), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_20), ('presence', 'optional')]), dict([('id', 871), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_21), ('presence', 'optional')]), dict([('id', 959), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_22), ('presence', 'optional')]), dict([('id', 987), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_23), ('presence', 'optional')]), dict([('id', 988), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_24), ('presence', 'optional')]), dict([('id', 994), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_25), ('presence', 'optional')]), dict([('id', 1031), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_26), ('presence', 'optional')]), dict([('id', 1020), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_27), ('presence', 'optional')]), dict([('id', 997), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_28), ('presence', 'optional')]), dict([('id', 1044), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_29), ('presence', 'optional')]), dict([('id', 1047), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_30), ('presence', 'optional')]), dict([('id', 1053), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_31), ('presence', 'optional')]), dict([('id', 1078), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_32), ('presence', 'optional')]), dict([('id', 1101), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_33), ('presence', 'optional')]), dict([('id', 1103), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_34), ('presence', 'optional')]), dict([('id', 1089), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_35), ('presence', 'optional')]), dict([('id', 1091), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_36), ('presence', 'optional')]), dict([('id', 1115), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_37), ('presence', 'optional')]), dict([('id', 1142), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_38), ('presence', 'optional')]), dict([('id', 1155), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_39), ('presence', 'optional')]), dict([('id', 1171), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_40), ('presence', 'optional')]), dict([('id', 1186), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_41), ('presence', 'optional')]), dict([('id', 1191), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_42), ('presence', 'optional')]), dict([('id', 1196), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_43), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item_._ext = None
    _Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions._cont = __Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item_
    _Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Local_Cell_InformationItem_ResourceStatusInd._cont = ASN1Dict([
        ('local-CellID', _Local_Cell_InformationItem_ResourceStatusInd_local_CellID),
        ('addorDeleteIndicator', _Local_Cell_InformationItem_ResourceStatusInd_addorDeleteIndicator),
        ('dl-or-global-capacityCredit', _Local_Cell_InformationItem_ResourceStatusInd_dl_or_global_capacityCredit),
        ('ul-capacityCredit', _Local_Cell_InformationItem_ResourceStatusInd_ul_capacityCredit),
        ('commonChannelsCapacityConsumptionLaw', _Local_Cell_InformationItem_ResourceStatusInd_commonChannelsCapacityConsumptionLaw),
        ('dedicatedChannelsCapacityConsumptionLaw', _Local_Cell_InformationItem_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw),
        ('maximumDL-PowerCapability', _Local_Cell_InformationItem_ResourceStatusInd_maximumDL_PowerCapability),
        ('minSpreadingFactor', _Local_Cell_InformationItem_ResourceStatusInd_minSpreadingFactor),
        ('minimumDL-PowerCapability', _Local_Cell_InformationItem_ResourceStatusInd_minimumDL_PowerCapability),
        ('local-Cell-Group-ID', _Local_Cell_InformationItem_ResourceStatusInd_local_Cell_Group_ID),
        ('iE-Extensions', _Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions),
        ])
    Local_Cell_InformationItem_ResourceStatusInd._ext = []
    
    #-----< Local-Cell-InformationItem-ResourceStatusInd-ExtIEs >-----#
    Local_Cell_InformationItem_ResourceStatusInd_ExtIEs = CLASS(name='Local-Cell-InformationItem-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReferenceClockAvailability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_4 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TTI2ms-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-SF-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-Combining-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Max-UE-DTX-Cycle')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_12 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_15 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBMS-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-FACH-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-PCH-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_18 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDU-SizeCapability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_20 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBSFN-Only-Mode-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_21 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormatCapability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_22 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDU-SizeCapability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_23 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_24 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AI-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_25 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_26 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_27 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-Power-Boosting-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_28 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-MIMO-Combined-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_29 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Cell-Capability-Info')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_30 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Semi-PersistentScheduling-CapabilityLCR')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_31 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-CapabilityLCR')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_32 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-HSDPCCH-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_33 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PowerOffsetForS-CPICHCapability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_34 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TxDiversityOnDLControlChannelsByMIMOUECapability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_35 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Capability')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_36 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Dual-Band-Capability-Info')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_37 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellPortion-CapabilityLCR')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_38 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_39 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TS0-CapabilityLCR')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_40 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrecodingWeightSetRestriction')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_41 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container-TDD-LCR')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_42 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Capability-ContainerLCR')))
    _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_43 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Adaptive-Special-Burst-Power-CapabilityLCR')))
    Local_Cell_InformationItem_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[dict([('id', 435), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 504), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 610), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 665), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 704), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_4), ('presence', 'conditional')]), dict([('id', 705), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_5), ('presence', 'conditional')]), dict([('id', 703), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_6), ('presence', 'conditional')]), dict([('id', 687), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 707), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 831), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 874), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_11), ('presence', 'conditional')]), dict([('id', 833), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 837), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_13), ('presence', 'optional')]), dict([('id', 860), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_14), ('presence', 'optional')]), dict([('id', 901), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_15), ('presence', 'optional')]), dict([('id', 895), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_16), ('presence', 'optional')]), dict([('id', 896), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_17), ('presence', 'conditional')]), dict([('id', 861), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_18), ('presence', 'optional')]), dict([('id', 864), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_19), ('presence', 'optional')]), dict([('id', 879), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_20), ('presence', 'optional')]), dict([('id', 871), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_21), ('presence', 'optional')]), dict([('id', 959), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_22), ('presence', 'optional')]), dict([('id', 987), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_23), ('presence', 'optional')]), dict([('id', 988), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_24), ('presence', 'optional')]), dict([('id', 994), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_25), ('presence', 'optional')]), dict([('id', 1031), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_26), ('presence', 'optional')]), dict([('id', 1020), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_27), ('presence', 'optional')]), dict([('id', 997), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_28), ('presence', 'optional')]), dict([('id', 1044), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_29), ('presence', 'optional')]), dict([('id', 1047), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_30), ('presence', 'optional')]), dict([('id', 1053), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_31), ('presence', 'optional')]), dict([('id', 1078), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_32), ('presence', 'optional')]), dict([('id', 1101), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_33), ('presence', 'optional')]), dict([('id', 1103), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_34), ('presence', 'optional')]), dict([('id', 1089), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_35), ('presence', 'optional')]), dict([('id', 1091), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_36), ('presence', 'optional')]), dict([('id', 1115), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_37), ('presence', 'optional')]), dict([('id', 1142), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_38), ('presence', 'optional')]), dict([('id', 1155), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_39), ('presence', 'optional')]), dict([('id', 1171), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_40), ('presence', 'optional')]), dict([('id', 1186), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_41), ('presence', 'optional')]), dict([('id', 1191), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_42), ('presence', 'optional')]), dict([('id', 1196), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_43), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Local-Cell-Group-InformationList-ResourceStatusInd >-----#
    Local_Cell_Group_InformationList_ResourceStatusInd = SEQ_OF(name='Local-Cell-Group-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _Local_Cell_Group_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-Group-InformationItem-ResourceStatusInd')))
    ___Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'ignore'), ('Value', ____Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__id._const_tab = ___Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality._const_tab = ___Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__value._const_tab = ___Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __Local_Cell_Group_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _Local_Cell_Group_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __Local_Cell_Group_InformationList_ResourceStatusInd__item__id),
        ('criticality', __Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality),
        ('value', __Local_Cell_Group_InformationList_ResourceStatusInd__item__value),
        ])
    _Local_Cell_Group_InformationList_ResourceStatusInd__item_._ext = None
    Local_Cell_Group_InformationList_ResourceStatusInd._cont = _Local_Cell_Group_InformationList_ResourceStatusInd__item_
    Local_Cell_Group_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Local-Cell-Group-InformationItemIE-ResourceStatusInd >-----#
    Local_Cell_Group_InformationItemIE_ResourceStatusInd = CLASS(name='Local-Cell-Group-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Local_Cell_Group_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-Group-InformationItem-ResourceStatusInd')))
    Local_Cell_Group_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'ignore'), ('Value', _Local_Cell_Group_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Local-Cell-Group-InformationItem-ResourceStatusInd >-----#
    Local_Cell_Group_InformationItem_ResourceStatusInd = SEQ(name='Local-Cell-Group-InformationItem-ResourceStatusInd', mode=MODE_TYPE)
    _Local_Cell_Group_InformationItem_ResourceStatusInd_local_Cell_Group_ID = INT(name='local-Cell-Group-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Local_Cell_Group_InformationItem_ResourceStatusInd_dl_or_global_capacityCredit = INT(name='dl-or-global-capacityCredit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-or-Global-CapacityCredit')))
    _Local_Cell_Group_InformationItem_ResourceStatusInd_ul_capacityCredit = INT(name='ul-capacityCredit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-CapacityCredit')), opt=True)
    _Local_Cell_Group_InformationItem_ResourceStatusInd_commonChannelsCapacityConsumptionLaw = SEQ_OF(name='commonChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonChannelsCapacityConsumptionLaw')))
    _Local_Cell_Group_InformationItem_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw = SEQ_OF(name='dedicatedChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedChannelsCapacityConsumptionLaw')))
    _Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    ____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 687), ('criticality', 'ignore'), ('Extension', _____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item_._ext = None
    _Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions._cont = __Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item_
    _Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Local_Cell_Group_InformationItem_ResourceStatusInd._cont = ASN1Dict([
        ('local-Cell-Group-ID', _Local_Cell_Group_InformationItem_ResourceStatusInd_local_Cell_Group_ID),
        ('dl-or-global-capacityCredit', _Local_Cell_Group_InformationItem_ResourceStatusInd_dl_or_global_capacityCredit),
        ('ul-capacityCredit', _Local_Cell_Group_InformationItem_ResourceStatusInd_ul_capacityCredit),
        ('commonChannelsCapacityConsumptionLaw', _Local_Cell_Group_InformationItem_ResourceStatusInd_commonChannelsCapacityConsumptionLaw),
        ('dedicatedChannelsCapacityConsumptionLaw', _Local_Cell_Group_InformationItem_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw),
        ('iE-Extensions', _Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions),
        ])
    Local_Cell_Group_InformationItem_ResourceStatusInd._ext = []
    
    #-----< Local-Cell-Group-InformationItem-ResourceStatusInd-ExtIEs >-----#
    Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs = CLASS(name='Local-Cell-Group-InformationItem-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[dict([('id', 687), ('criticality', 'ignore'), ('Extension', _Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Power-Local-Cell-Group-InformationList-ResourceStatusInd >-----#
    Power_Local_Cell_Group_InformationList_ResourceStatusInd = SEQ_OF(name='Power-Local-Cell-Group-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _Power_Local_Cell_Group_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationItem-ResourceStatusInd')))
    ___Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 499), ('criticality', 'ignore'), ('Value', ____Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id._const_tab = ___Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality._const_tab = ___Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__value._const_tab = ___Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _Power_Local_Cell_Group_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id),
        ('criticality', __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality),
        ('value', __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__value),
        ])
    _Power_Local_Cell_Group_InformationList_ResourceStatusInd__item_._ext = None
    Power_Local_Cell_Group_InformationList_ResourceStatusInd._cont = _Power_Local_Cell_Group_InformationList_ResourceStatusInd__item_
    Power_Local_Cell_Group_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Power-Local-Cell-Group-InformationItemIE-ResourceStatusInd >-----#
    Power_Local_Cell_Group_InformationItemIE_ResourceStatusInd = CLASS(name='Power-Local-Cell-Group-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Power_Local_Cell_Group_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationItem-ResourceStatusInd')))
    Power_Local_Cell_Group_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 499), ('criticality', 'ignore'), ('Value', _Power_Local_Cell_Group_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Power-Local-Cell-Group-InformationItem-ResourceStatusInd >-----#
    Power_Local_Cell_Group_InformationItem_ResourceStatusInd = SEQ(name='Power-Local-Cell-Group-InformationItem-ResourceStatusInd', mode=MODE_TYPE)
    _Power_Local_Cell_Group_InformationItem_ResourceStatusInd_power_Local_Cell_Group_ID = INT(name='power-Local-Cell-Group-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Power_Local_Cell_Group_InformationItem_ResourceStatusInd_maximumDL_PowerCapability = INT(name='maximumDL-PowerCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumDL-PowerCapability')))
    _Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item_._ext = None
    _Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions._cont = __Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item_
    _Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Power_Local_Cell_Group_InformationItem_ResourceStatusInd._cont = ASN1Dict([
        ('power-Local-Cell-Group-ID', _Power_Local_Cell_Group_InformationItem_ResourceStatusInd_power_Local_Cell_Group_ID),
        ('maximumDL-PowerCapability', _Power_Local_Cell_Group_InformationItem_ResourceStatusInd_maximumDL_PowerCapability),
        ('iE-Extensions', _Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions),
        ])
    Power_Local_Cell_Group_InformationItem_ResourceStatusInd._ext = []
    
    #-----< Power-Local-Cell-Group-InformationItem-ResourceStatusInd-ExtIEs >-----#
    Power_Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs = CLASS(name='Power-Local-Cell-Group-InformationItem-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Power_Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ServiceImpacting-ResourceStatusInd >-----#
    ServiceImpacting_ResourceStatusInd = SEQ(name='ServiceImpacting-ResourceStatusInd', mode=MODE_TYPE)
    _ServiceImpacting_ResourceStatusInd_local_Cell_InformationList = SEQ_OF(name='local-Cell-InformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-InformationList2-ResourceStatusInd')), opt=True)
    _ServiceImpacting_ResourceStatusInd_local_Cell_Group_InformationList = SEQ_OF(name='local-Cell-Group-InformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-Group-InformationList2-ResourceStatusInd')), opt=True)
    _ServiceImpacting_ResourceStatusInd_cCP_InformationList = SEQ_OF(name='cCP-InformationList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCP-InformationList-ResourceStatusInd')), opt=True)
    _ServiceImpacting_ResourceStatusInd_cell_InformationList = SEQ_OF(name='cell-InformationList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-InformationList-ResourceStatusInd')), opt=True)
    _ServiceImpacting_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServiceImpacting_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationList2-ResourceStatusInd')))
    ____ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 503), ('criticality', 'ignore'), ('Extension', _____ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id_tab
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id_tab
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id_tab
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServiceImpacting_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __ServiceImpacting_ResourceStatusInd_iE_Extensions__item_._ext = None
    _ServiceImpacting_ResourceStatusInd_iE_Extensions._cont = __ServiceImpacting_ResourceStatusInd_iE_Extensions__item_
    _ServiceImpacting_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServiceImpacting_ResourceStatusInd._cont = ASN1Dict([
        ('local-Cell-InformationList', _ServiceImpacting_ResourceStatusInd_local_Cell_InformationList),
        ('local-Cell-Group-InformationList', _ServiceImpacting_ResourceStatusInd_local_Cell_Group_InformationList),
        ('cCP-InformationList', _ServiceImpacting_ResourceStatusInd_cCP_InformationList),
        ('cell-InformationList', _ServiceImpacting_ResourceStatusInd_cell_InformationList),
        ('iE-Extensions', _ServiceImpacting_ResourceStatusInd_iE_Extensions),
        ])
    ServiceImpacting_ResourceStatusInd._ext = []
    
    #-----< ServiceImpactingItem-ResourceStatusInd-ExtIEs >-----#
    ServiceImpactingItem_ResourceStatusInd_ExtIEs = CLASS(name='ServiceImpactingItem-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _ServiceImpactingItem_ResourceStatusInd_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationList2-ResourceStatusInd')))
    ServiceImpactingItem_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[dict([('id', 503), ('criticality', 'ignore'), ('Extension', _ServiceImpactingItem_ResourceStatusInd_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Local-Cell-InformationList2-ResourceStatusInd >-----#
    Local_Cell_InformationList2_ResourceStatusInd = SEQ_OF(name='Local-Cell-InformationList2-ResourceStatusInd', mode=MODE_TYPE)
    _Local_Cell_InformationList2_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Local_Cell_InformationList2_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Local_Cell_InformationList2_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Local_Cell_InformationList2_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-InformationItem2-ResourceStatusInd')))
    ___Local_Cell_InformationList2_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 127), ('criticality', 'ignore'), ('Value', ____Local_Cell_InformationList2_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Local_Cell_InformationList2_ResourceStatusInd__item__id._const_tab = ___Local_Cell_InformationList2_ResourceStatusInd__item__id_tab
    __Local_Cell_InformationList2_ResourceStatusInd__item__id._const_tab_at = None
    __Local_Cell_InformationList2_ResourceStatusInd__item__id._const_tab_id = 'id'
    __Local_Cell_InformationList2_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Local_Cell_InformationList2_ResourceStatusInd__item__criticality._const_tab = ___Local_Cell_InformationList2_ResourceStatusInd__item__id_tab
    __Local_Cell_InformationList2_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __Local_Cell_InformationList2_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __Local_Cell_InformationList2_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Local_Cell_InformationList2_ResourceStatusInd__item__value._const_tab = ___Local_Cell_InformationList2_ResourceStatusInd__item__id_tab
    __Local_Cell_InformationList2_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __Local_Cell_InformationList2_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _Local_Cell_InformationList2_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __Local_Cell_InformationList2_ResourceStatusInd__item__id),
        ('criticality', __Local_Cell_InformationList2_ResourceStatusInd__item__criticality),
        ('value', __Local_Cell_InformationList2_ResourceStatusInd__item__value),
        ])
    _Local_Cell_InformationList2_ResourceStatusInd__item_._ext = None
    Local_Cell_InformationList2_ResourceStatusInd._cont = _Local_Cell_InformationList2_ResourceStatusInd__item_
    Local_Cell_InformationList2_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Local-Cell-InformationItemIE2-ResourceStatusInd >-----#
    Local_Cell_InformationItemIE2_ResourceStatusInd = CLASS(name='Local-Cell-InformationItemIE2-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Local_Cell_InformationItemIE2_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-InformationItem2-ResourceStatusInd')))
    Local_Cell_InformationItemIE2_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 127), ('criticality', 'ignore'), ('Value', _Local_Cell_InformationItemIE2_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Local-Cell-InformationItem2-ResourceStatusInd >-----#
    Local_Cell_InformationItem2_ResourceStatusInd = SEQ(name='Local-Cell-InformationItem2-ResourceStatusInd', mode=MODE_TYPE)
    _Local_Cell_InformationItem2_ResourceStatusInd_local_Cell_ID = INT(name='local-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Local_Cell_InformationItem2_ResourceStatusInd_dl_or_global_capacityCredit = INT(name='dl-or-global-capacityCredit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-or-Global-CapacityCredit')), opt=True)
    _Local_Cell_InformationItem2_ResourceStatusInd_ul_capacityCredit = INT(name='ul-capacityCredit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-CapacityCredit')), opt=True)
    _Local_Cell_InformationItem2_ResourceStatusInd_commonChannelsCapacityConsumptionLaw = SEQ_OF(name='commonChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonChannelsCapacityConsumptionLaw')), opt=True)
    _Local_Cell_InformationItem2_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw = SEQ_OF(name='dedicatedChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedChannelsCapacityConsumptionLaw')), opt=True)
    _Local_Cell_InformationItem2_ResourceStatusInd_maximum_DL_PowerCapability = INT(name='maximum-DL-PowerCapability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumDL-PowerCapability')), opt=True)
    _Local_Cell_InformationItem2_ResourceStatusInd_minSpreadingFactor = ENUM(name='minSpreadingFactor', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MinSpreadingFactor')), opt=True)
    _Local_Cell_InformationItem2_ResourceStatusInd_minimumDL_PowerCapability = INT(name='minimumDL-PowerCapability', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MinimumDL-PowerCapability')), opt=True)
    _Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReferenceClockAvailability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_3 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TTI2ms-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-SF-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-Combining-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Max-UE-DTX-Cycle')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_12 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBMS-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_15 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-FACH-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-PCH-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_18 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDU-SizeCapability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBSFN-Only-Mode-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_20 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormatCapability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_21 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDU-SizeCapability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_22 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_23 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AI-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_24 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_25 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_26 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-Power-Boosting-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_27 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-MIMO-Combined-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_28 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Cell-Capability-Info')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_29 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Semi-PersistentScheduling-CapabilityLCR')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_30 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-CapabilityLCR')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_31 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-HSDPCCH-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_32 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PowerOffsetForS-CPICHCapability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_33 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TxDiversityOnDLControlChannelsByMIMOUECapability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_34 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Capability')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_35 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Dual-Band-Capability-Info')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_36 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellPortion-CapabilityLCR')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_37 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_38 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TS0-CapabilityLCR')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_39 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrecodingWeightSetRestriction')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_40 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container-TDD-LCR')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_41 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Capability-ContainerLCR')))
    _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_42 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Adaptive-Special-Burst-Power-CapabilityLCR')))
    ____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 435), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 610), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 665), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 704), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'conditional')]), dict([('id', 705), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'conditional')]), dict([('id', 703), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'conditional')]), dict([('id', 687), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 707), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 831), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 874), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'conditional')]), dict([('id', 833), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 837), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 860), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 901), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 895), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 896), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_16), ('presence', 'conditional')]), dict([('id', 861), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_17), ('presence', 'optional')]), dict([('id', 864), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 879), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_19), ('presence', 'optional')]), dict([('id', 871), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_20), ('presence', 'optional')]), dict([('id', 959), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_21), ('presence', 'optional')]), dict([('id', 987), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_22), ('presence', 'optional')]), dict([('id', 988), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_23), ('presence', 'optional')]), dict([('id', 994), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_24), ('presence', 'optional')]), dict([('id', 1031), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_25), ('presence', 'optional')]), dict([('id', 1020), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_26), ('presence', 'optional')]), dict([('id', 997), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_27), ('presence', 'optional')]), dict([('id', 1044), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_28), ('presence', 'optional')]), dict([('id', 1047), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_29), ('presence', 'optional')]), dict([('id', 1053), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_30), ('presence', 'optional')]), dict([('id', 1078), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_31), ('presence', 'optional')]), dict([('id', 1101), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_32), ('presence', 'optional')]), dict([('id', 1103), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_33), ('presence', 'optional')]), dict([('id', 1089), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_34), ('presence', 'optional')]), dict([('id', 1091), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_35), ('presence', 'optional')]), dict([('id', 1115), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_36), ('presence', 'optional')]), dict([('id', 1142), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_37), ('presence', 'optional')]), dict([('id', 1155), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_38), ('presence', 'optional')]), dict([('id', 1171), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_39), ('presence', 'optional')]), dict([('id', 1186), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_40), ('presence', 'optional')]), dict([('id', 1191), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_41), ('presence', 'optional')]), dict([('id', 1196), ('criticality', 'ignore'), ('Extension', _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_42), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item_._ext = None
    _Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions._cont = __Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item_
    _Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Local_Cell_InformationItem2_ResourceStatusInd._cont = ASN1Dict([
        ('local-Cell-ID', _Local_Cell_InformationItem2_ResourceStatusInd_local_Cell_ID),
        ('dl-or-global-capacityCredit', _Local_Cell_InformationItem2_ResourceStatusInd_dl_or_global_capacityCredit),
        ('ul-capacityCredit', _Local_Cell_InformationItem2_ResourceStatusInd_ul_capacityCredit),
        ('commonChannelsCapacityConsumptionLaw', _Local_Cell_InformationItem2_ResourceStatusInd_commonChannelsCapacityConsumptionLaw),
        ('dedicatedChannelsCapacityConsumptionLaw', _Local_Cell_InformationItem2_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw),
        ('maximum-DL-PowerCapability', _Local_Cell_InformationItem2_ResourceStatusInd_maximum_DL_PowerCapability),
        ('minSpreadingFactor', _Local_Cell_InformationItem2_ResourceStatusInd_minSpreadingFactor),
        ('minimumDL-PowerCapability', _Local_Cell_InformationItem2_ResourceStatusInd_minimumDL_PowerCapability),
        ('iE-Extensions', _Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions),
        ])
    Local_Cell_InformationItem2_ResourceStatusInd._ext = []
    
    #-----< Local-Cell-InformationItem2-ResourceStatusInd-ExtIEs >-----#
    Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs = CLASS(name='Local-Cell-InformationItem2-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReferenceClockAvailability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDPA-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_3 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TTI2ms-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-SF-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-HARQ-Combining-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Max-UE-DTX-Cycle')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_12 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBMS-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_15 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-FACH-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-PCH-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixteenQAM-UL-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_18 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdPDU-SizeCapability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MBSFN-Only-Mode-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_20 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormatCapability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_21 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdPDU-SizeCapability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_22 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_23 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AI-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_24 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_25 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_26 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-Power-Boosting-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_27 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SixtyfourQAM-DL-MIMO-Combined-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_28 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Cell-Capability-Info')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_29 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Semi-PersistentScheduling-CapabilityLCR')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_30 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-CapabilityLCR')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_31 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-DCH-HSDPCCH-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_32 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MIMO-PowerOffsetForS-CPICHCapability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_33 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TxDiversityOnDLControlChannelsByMIMOUECapability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_34 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Single-Stream-MIMO-Capability')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_35 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Dual-Band-Capability-Info')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_36 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellPortion-CapabilityLCR')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_37 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_38 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TS0-CapabilityLCR')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_39 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrecodingWeightSetRestriction')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_40 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-Capability-Container-TDD-LCR')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_41 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Capability-ContainerLCR')))
    _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_42 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Adaptive-Special-Burst-Power-CapabilityLCR')))
    Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[dict([('id', 435), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 610), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 665), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 704), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_3), ('presence', 'conditional')]), dict([('id', 705), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_4), ('presence', 'conditional')]), dict([('id', 703), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_5), ('presence', 'conditional')]), dict([('id', 687), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 707), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 831), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 874), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_10), ('presence', 'conditional')]), dict([('id', 833), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 837), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 860), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_13), ('presence', 'optional')]), dict([('id', 901), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_14), ('presence', 'optional')]), dict([('id', 895), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_15), ('presence', 'optional')]), dict([('id', 896), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_16), ('presence', 'conditional')]), dict([('id', 861), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_17), ('presence', 'optional')]), dict([('id', 864), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_18), ('presence', 'optional')]), dict([('id', 879), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_19), ('presence', 'optional')]), dict([('id', 871), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_20), ('presence', 'optional')]), dict([('id', 959), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_21), ('presence', 'optional')]), dict([('id', 987), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_22), ('presence', 'optional')]), dict([('id', 988), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_23), ('presence', 'optional')]), dict([('id', 994), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_24), ('presence', 'optional')]), dict([('id', 1031), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_25), ('presence', 'optional')]), dict([('id', 1020), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_26), ('presence', 'optional')]), dict([('id', 997), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_27), ('presence', 'optional')]), dict([('id', 1044), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_28), ('presence', 'optional')]), dict([('id', 1047), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_29), ('presence', 'optional')]), dict([('id', 1053), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_30), ('presence', 'optional')]), dict([('id', 1078), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_31), ('presence', 'optional')]), dict([('id', 1101), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_32), ('presence', 'optional')]), dict([('id', 1103), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_33), ('presence', 'optional')]), dict([('id', 1089), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_34), ('presence', 'optional')]), dict([('id', 1091), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_35), ('presence', 'optional')]), dict([('id', 1115), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_36), ('presence', 'optional')]), dict([('id', 1142), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_37), ('presence', 'optional')]), dict([('id', 1155), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_38), ('presence', 'optional')]), dict([('id', 1171), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_39), ('presence', 'optional')]), dict([('id', 1186), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_40), ('presence', 'optional')]), dict([('id', 1191), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_41), ('presence', 'optional')]), dict([('id', 1196), ('criticality', 'ignore'), ('Extension', _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_42), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Local-Cell-Group-InformationList2-ResourceStatusInd >-----#
    Local_Cell_Group_InformationList2_ResourceStatusInd = SEQ_OF(name='Local-Cell-Group-InformationList2-ResourceStatusInd', mode=MODE_TYPE)
    _Local_Cell_Group_InformationList2_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-Group-InformationItem2-ResourceStatusInd')))
    ___Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', ____Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__id._const_tab = ___Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__id._const_tab_at = None
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__id._const_tab_id = 'id'
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality._const_tab = ___Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__value._const_tab = ___Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __Local_Cell_Group_InformationList2_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _Local_Cell_Group_InformationList2_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __Local_Cell_Group_InformationList2_ResourceStatusInd__item__id),
        ('criticality', __Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality),
        ('value', __Local_Cell_Group_InformationList2_ResourceStatusInd__item__value),
        ])
    _Local_Cell_Group_InformationList2_ResourceStatusInd__item_._ext = None
    Local_Cell_Group_InformationList2_ResourceStatusInd._cont = _Local_Cell_Group_InformationList2_ResourceStatusInd__item_
    Local_Cell_Group_InformationList2_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Local-Cell-Group-InformationItemIE2-ResourceStatusInd >-----#
    Local_Cell_Group_InformationItemIE2_ResourceStatusInd = CLASS(name='Local-Cell-Group-InformationItemIE2-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Local_Cell_Group_InformationItemIE2_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Local-Cell-Group-InformationItem2-ResourceStatusInd')))
    Local_Cell_Group_InformationItemIE2_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _Local_Cell_Group_InformationItemIE2_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Local-Cell-Group-InformationItem2-ResourceStatusInd >-----#
    Local_Cell_Group_InformationItem2_ResourceStatusInd = SEQ(name='Local-Cell-Group-InformationItem2-ResourceStatusInd', mode=MODE_TYPE)
    _Local_Cell_Group_InformationItem2_ResourceStatusInd_local_Cell_Group_ID = INT(name='local-Cell-Group-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Local_Cell_Group_InformationItem2_ResourceStatusInd_dl_or_global_capacityCredit = INT(name='dl-or-global-capacityCredit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-or-Global-CapacityCredit')), opt=True)
    _Local_Cell_Group_InformationItem2_ResourceStatusInd_ul_capacityCredit = INT(name='ul-capacityCredit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-CapacityCredit')), opt=True)
    _Local_Cell_Group_InformationItem2_ResourceStatusInd_commonChannelsCapacityConsumptionLaw = SEQ_OF(name='commonChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommonChannelsCapacityConsumptionLaw')), opt=True)
    _Local_Cell_Group_InformationItem2_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw = SEQ_OF(name='dedicatedChannelsCapacityConsumptionLaw', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedChannelsCapacityConsumptionLaw')), opt=True)
    _Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    ____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 687), ('criticality', 'ignore'), ('Extension', _____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item_._ext = None
    _Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions._cont = __Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item_
    _Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Local_Cell_Group_InformationItem2_ResourceStatusInd._cont = ASN1Dict([
        ('local-Cell-Group-ID', _Local_Cell_Group_InformationItem2_ResourceStatusInd_local_Cell_Group_ID),
        ('dl-or-global-capacityCredit', _Local_Cell_Group_InformationItem2_ResourceStatusInd_dl_or_global_capacityCredit),
        ('ul-capacityCredit', _Local_Cell_Group_InformationItem2_ResourceStatusInd_ul_capacityCredit),
        ('commonChannelsCapacityConsumptionLaw', _Local_Cell_Group_InformationItem2_ResourceStatusInd_commonChannelsCapacityConsumptionLaw),
        ('dedicatedChannelsCapacityConsumptionLaw', _Local_Cell_Group_InformationItem2_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw),
        ('iE-Extensions', _Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions),
        ])
    Local_Cell_Group_InformationItem2_ResourceStatusInd._ext = []
    
    #-----< Local-Cell-Group-InformationItem2-ResourceStatusInd-ExtIEs >-----#
    Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs = CLASS(name='Local-Cell-Group-InformationItem2-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCHCapacityConsumptionLaw')))
    _Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-TDD-CapacityConsumptionLaw')))
    Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[dict([('id', 687), ('criticality', 'ignore'), ('Extension', _Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 797), ('criticality', 'ignore'), ('Extension', _Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CCP-InformationList-ResourceStatusInd >-----#
    CCP_InformationList_ResourceStatusInd = SEQ_OF(name='CCP-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _CCP_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __CCP_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___CCP_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____CCP_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCP-InformationItem-ResourceStatusInd')))
    ___CCP_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'ignore'), ('Value', ____CCP_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CCP_InformationList_ResourceStatusInd__item__id._const_tab = ___CCP_InformationList_ResourceStatusInd__item__id_tab
    __CCP_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __CCP_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __CCP_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __CCP_InformationList_ResourceStatusInd__item__criticality._const_tab = ___CCP_InformationList_ResourceStatusInd__item__id_tab
    __CCP_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __CCP_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __CCP_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __CCP_InformationList_ResourceStatusInd__item__value._const_tab = ___CCP_InformationList_ResourceStatusInd__item__id_tab
    __CCP_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __CCP_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _CCP_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __CCP_InformationList_ResourceStatusInd__item__id),
        ('criticality', __CCP_InformationList_ResourceStatusInd__item__criticality),
        ('value', __CCP_InformationList_ResourceStatusInd__item__value),
        ])
    _CCP_InformationList_ResourceStatusInd__item_._ext = None
    CCP_InformationList_ResourceStatusInd._cont = _CCP_InformationList_ResourceStatusInd__item_
    CCP_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CCP-InformationItemIE-ResourceStatusInd >-----#
    CCP_InformationItemIE_ResourceStatusInd = CLASS(name='CCP-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CCP_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCP-InformationItem-ResourceStatusInd')))
    CCP_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'ignore'), ('Value', _CCP_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CCP-InformationItem-ResourceStatusInd >-----#
    CCP_InformationItem_ResourceStatusInd = SEQ(name='CCP-InformationItem-ResourceStatusInd', mode=MODE_TYPE)
    _CCP_InformationItem_ResourceStatusInd_communicationControlPortID = INT(name='communicationControlPortID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _CCP_InformationItem_ResourceStatusInd_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _CCP_InformationItem_ResourceStatusInd_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _CCP_InformationItem_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCP_InformationItem_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CCP_InformationItem_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __CCP_InformationItem_ResourceStatusInd_iE_Extensions__item_._ext = None
    _CCP_InformationItem_ResourceStatusInd_iE_Extensions._cont = __CCP_InformationItem_ResourceStatusInd_iE_Extensions__item_
    _CCP_InformationItem_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCP_InformationItem_ResourceStatusInd._cont = ASN1Dict([
        ('communicationControlPortID', _CCP_InformationItem_ResourceStatusInd_communicationControlPortID),
        ('resourceOperationalState', _CCP_InformationItem_ResourceStatusInd_resourceOperationalState),
        ('availabilityStatus', _CCP_InformationItem_ResourceStatusInd_availabilityStatus),
        ('iE-Extensions', _CCP_InformationItem_ResourceStatusInd_iE_Extensions),
        ])
    CCP_InformationItem_ResourceStatusInd._ext = []
    
    #-----< CCP-InformationItem-ResourceStatusInd-ExtIEs >-----#
    CCP_InformationItem_ResourceStatusInd_ExtIEs = CLASS(name='CCP-InformationItem-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CCP_InformationItem_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cell-InformationList-ResourceStatusInd >-----#
    Cell_InformationList_ResourceStatusInd = SEQ_OF(name='Cell-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _Cell_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Cell_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Cell_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Cell_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-InformationItem-ResourceStatusInd')))
    ___Cell_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'ignore'), ('Value', ____Cell_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Cell_InformationList_ResourceStatusInd__item__id._const_tab = ___Cell_InformationList_ResourceStatusInd__item__id_tab
    __Cell_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __Cell_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __Cell_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Cell_InformationList_ResourceStatusInd__item__criticality._const_tab = ___Cell_InformationList_ResourceStatusInd__item__id_tab
    __Cell_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __Cell_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __Cell_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Cell_InformationList_ResourceStatusInd__item__value._const_tab = ___Cell_InformationList_ResourceStatusInd__item__id_tab
    __Cell_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __Cell_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _Cell_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __Cell_InformationList_ResourceStatusInd__item__id),
        ('criticality', __Cell_InformationList_ResourceStatusInd__item__criticality),
        ('value', __Cell_InformationList_ResourceStatusInd__item__value),
        ])
    _Cell_InformationList_ResourceStatusInd__item_._ext = None
    Cell_InformationList_ResourceStatusInd._cont = _Cell_InformationList_ResourceStatusInd__item_
    Cell_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Cell-InformationItemIE-ResourceStatusInd >-----#
    Cell_InformationItemIE_ResourceStatusInd = CLASS(name='Cell-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Cell_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-InformationItem-ResourceStatusInd')))
    Cell_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'ignore'), ('Value', _Cell_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Cell-InformationItem-ResourceStatusInd >-----#
    Cell_InformationItem_ResourceStatusInd = SEQ(name='Cell-InformationItem-ResourceStatusInd', mode=MODE_TYPE)
    _Cell_InformationItem_ResourceStatusInd_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _Cell_InformationItem_ResourceStatusInd_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_primary_SCH_Information = SEQ(name='primary-SCH-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'P-SCH-Information-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_secondary_SCH_Information = SEQ(name='secondary-SCH-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-SCH-Information-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_primary_CPICH_Information = SEQ(name='primary-CPICH-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'P-CPICH-Information-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_secondary_CPICH_Information = SEQ_OF(name='secondary-CPICH-Information', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CPICH-InformationList-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_primary_CCPCH_Information = SEQ(name='primary-CCPCH-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'P-CCPCH-Information-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_bCH_Information = SEQ(name='bCH-Information', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'BCH-Information-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_secondary_CCPCH_InformationList = SEQ_OF(name='secondary-CCPCH-InformationList', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-InformationList-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_pCH_Information = SEQ(name='pCH-Information', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PCH-Information-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_pICH_Information = SEQ(name='pICH-Information', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PICH-Information-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_fACH_InformationList = SEQ_OF(name='fACH-InformationList', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'FACH-InformationList-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_pRACH_InformationList = SEQ_OF(name='pRACH-InformationList', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-InformationList-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_rACH_InformationList = SEQ_OF(name='rACH-InformationList', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RACH-InformationList-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_aICH_InformationList = SEQ_OF(name='aICH-InformationList', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'AICH-InformationList-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_notUsed_1_pCPCH_InformationList = NULL(name='notUsed-1-pCPCH-InformationList', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Cell_InformationItem_ResourceStatusInd_notUsed_2_cPCH_InformationList = NULL(name='notUsed-2-cPCH-InformationList', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Cell_InformationItem_ResourceStatusInd_notUsed_3_aP_AICH_InformationList = NULL(name='notUsed-3-aP-AICH-InformationList', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Cell_InformationItem_ResourceStatusInd_notUsed_4_cDCA_ICH_InformationList = NULL(name='notUsed-4-cDCA-ICH-InformationList', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Cell_InformationItem_ResourceStatusInd_sCH_Information = SEQ(name='sCH-Information', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SCH-Information-ResourceStatusInd')), opt=True)
    _Cell_InformationItem_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_InformationItem_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FPACH-LCR-InformationList-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DwPCH-LCR-Information-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-DSCH-Resources-Information-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-InformationListExt-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-LCR-InformationListExt-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DCH-Resources-Information-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PLCCH-InformationList-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_9 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-768-InformationList-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_11 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-768-InformationList-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_14 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-InformationList-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_15 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-768-InformationList-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_16 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-List-Information-LCR-MulFreq-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_17 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UPPCH-LCR-InformationList-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_18 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-HS-DSCH-Resources-InformationList-ResourceStatusInd')))
    _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_19 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-E-DCH-Resources-InformationList-ResourceStatusInd')))
    ____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 101), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 612), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 639), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 647), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 649), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 673), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 716), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 739), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 744), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 740), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 741), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 742), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 743), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 796), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 811), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 917), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 923), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_17), ('presence', 'optional')]), dict([('id', 930), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 954), ('criticality', 'ignore'), ('Extension', _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_19), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_InformationItem_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __Cell_InformationItem_ResourceStatusInd_iE_Extensions__item_._ext = None
    _Cell_InformationItem_ResourceStatusInd_iE_Extensions._cont = __Cell_InformationItem_ResourceStatusInd_iE_Extensions__item_
    _Cell_InformationItem_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_InformationItem_ResourceStatusInd._cont = ASN1Dict([
        ('c-ID', _Cell_InformationItem_ResourceStatusInd_c_ID),
        ('resourceOperationalState', _Cell_InformationItem_ResourceStatusInd_resourceOperationalState),
        ('availabilityStatus', _Cell_InformationItem_ResourceStatusInd_availabilityStatus),
        ('primary-SCH-Information', _Cell_InformationItem_ResourceStatusInd_primary_SCH_Information),
        ('secondary-SCH-Information', _Cell_InformationItem_ResourceStatusInd_secondary_SCH_Information),
        ('primary-CPICH-Information', _Cell_InformationItem_ResourceStatusInd_primary_CPICH_Information),
        ('secondary-CPICH-Information', _Cell_InformationItem_ResourceStatusInd_secondary_CPICH_Information),
        ('primary-CCPCH-Information', _Cell_InformationItem_ResourceStatusInd_primary_CCPCH_Information),
        ('bCH-Information', _Cell_InformationItem_ResourceStatusInd_bCH_Information),
        ('secondary-CCPCH-InformationList', _Cell_InformationItem_ResourceStatusInd_secondary_CCPCH_InformationList),
        ('pCH-Information', _Cell_InformationItem_ResourceStatusInd_pCH_Information),
        ('pICH-Information', _Cell_InformationItem_ResourceStatusInd_pICH_Information),
        ('fACH-InformationList', _Cell_InformationItem_ResourceStatusInd_fACH_InformationList),
        ('pRACH-InformationList', _Cell_InformationItem_ResourceStatusInd_pRACH_InformationList),
        ('rACH-InformationList', _Cell_InformationItem_ResourceStatusInd_rACH_InformationList),
        ('aICH-InformationList', _Cell_InformationItem_ResourceStatusInd_aICH_InformationList),
        ('notUsed-1-pCPCH-InformationList', _Cell_InformationItem_ResourceStatusInd_notUsed_1_pCPCH_InformationList),
        ('notUsed-2-cPCH-InformationList', _Cell_InformationItem_ResourceStatusInd_notUsed_2_cPCH_InformationList),
        ('notUsed-3-aP-AICH-InformationList', _Cell_InformationItem_ResourceStatusInd_notUsed_3_aP_AICH_InformationList),
        ('notUsed-4-cDCA-ICH-InformationList', _Cell_InformationItem_ResourceStatusInd_notUsed_4_cDCA_ICH_InformationList),
        ('sCH-Information', _Cell_InformationItem_ResourceStatusInd_sCH_Information),
        ('iE-Extensions', _Cell_InformationItem_ResourceStatusInd_iE_Extensions),
        ])
    Cell_InformationItem_ResourceStatusInd._ext = []
    
    #-----< Cell-InformationItem-ResourceStatusInd-ExtIEs >-----#
    Cell_InformationItem_ResourceStatusInd_ExtIEs = CLASS(name='Cell-InformationItem-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'FPACH-LCR-InformationList-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DwPCH-LCR-Information-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-DSCH-Resources-Information-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-InformationListExt-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-LCR-InformationListExt-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DCH-Resources-Information-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PLCCH-InformationList-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_9 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'S-CCPCH-768-InformationList-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_11 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PRACH-768-InformationList-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_14 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-InformationList-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_15 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-RUCCH-768-InformationList-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_16 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-List-Information-LCR-MulFreq-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_17 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UPPCH-LCR-InformationList-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_18 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-HS-DSCH-Resources-InformationList-ResourceStatusInd')))
    _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_19 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-E-DCH-Resources-InformationList-ResourceStatusInd')))
    Cell_InformationItem_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[dict([('id', 311), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 101), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 612), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 639), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 647), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 649), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 673), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 716), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 739), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 744), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 740), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 741), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 742), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 743), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_13), ('presence', 'optional')]), dict([('id', 796), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_14), ('presence', 'optional')]), dict([('id', 811), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_15), ('presence', 'optional')]), dict([('id', 917), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_16), ('presence', 'optional')]), dict([('id', 923), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_17), ('presence', 'optional')]), dict([('id', 930), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_18), ('presence', 'optional')]), dict([('id', 954), ('criticality', 'ignore'), ('Extension', _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_19), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< P-SCH-Information-ResourceStatusInd >-----#
    P_SCH_Information_ResourceStatusInd = SEQ(name='P-SCH-Information-ResourceStatusInd', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _P_SCH_Information_ResourceStatusInd_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __P_SCH_Information_ResourceStatusInd_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___P_SCH_Information_ResourceStatusInd_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __P_SCH_Information_ResourceStatusInd_id_tab._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'ignore'), ('Value', ___P_SCH_Information_ResourceStatusInd_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _P_SCH_Information_ResourceStatusInd_id._const_tab = __P_SCH_Information_ResourceStatusInd_id_tab
    _P_SCH_Information_ResourceStatusInd_id._const_tab_at = None
    _P_SCH_Information_ResourceStatusInd_id._const_tab_id = 'id'
    _P_SCH_Information_ResourceStatusInd_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _P_SCH_Information_ResourceStatusInd_criticality._const_tab = __P_SCH_Information_ResourceStatusInd_id_tab
    _P_SCH_Information_ResourceStatusInd_criticality._const_tab_at = ('..', 'id')
    _P_SCH_Information_ResourceStatusInd_criticality._const_tab_id = 'criticality'
    _P_SCH_Information_ResourceStatusInd_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _P_SCH_Information_ResourceStatusInd_value._const_tab = __P_SCH_Information_ResourceStatusInd_id_tab
    _P_SCH_Information_ResourceStatusInd_value._const_tab_at = ('..', 'id')
    _P_SCH_Information_ResourceStatusInd_value._const_tab_id = 'Value'
    P_SCH_Information_ResourceStatusInd._cont = ASN1Dict([
        ('id', _P_SCH_Information_ResourceStatusInd_id),
        ('criticality', _P_SCH_Information_ResourceStatusInd_criticality),
        ('value', _P_SCH_Information_ResourceStatusInd_value),
        ])
    P_SCH_Information_ResourceStatusInd._ext = None
    
    #-----< P-SCH-InformationIE-ResourceStatusInd >-----#
    P_SCH_InformationIE_ResourceStatusInd = CLASS(name='P-SCH-InformationIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _P_SCH_InformationIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    P_SCH_InformationIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'ignore'), ('Value', _P_SCH_InformationIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< S-SCH-Information-ResourceStatusInd >-----#
    S_SCH_Information_ResourceStatusInd = SEQ(name='S-SCH-Information-ResourceStatusInd', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _S_SCH_Information_ResourceStatusInd_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __S_SCH_Information_ResourceStatusInd_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___S_SCH_Information_ResourceStatusInd_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __S_SCH_Information_ResourceStatusInd_id_tab._val = ASN1Set(rv=[dict([('id', 253), ('criticality', 'ignore'), ('Value', ___S_SCH_Information_ResourceStatusInd_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _S_SCH_Information_ResourceStatusInd_id._const_tab = __S_SCH_Information_ResourceStatusInd_id_tab
    _S_SCH_Information_ResourceStatusInd_id._const_tab_at = None
    _S_SCH_Information_ResourceStatusInd_id._const_tab_id = 'id'
    _S_SCH_Information_ResourceStatusInd_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _S_SCH_Information_ResourceStatusInd_criticality._const_tab = __S_SCH_Information_ResourceStatusInd_id_tab
    _S_SCH_Information_ResourceStatusInd_criticality._const_tab_at = ('..', 'id')
    _S_SCH_Information_ResourceStatusInd_criticality._const_tab_id = 'criticality'
    _S_SCH_Information_ResourceStatusInd_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _S_SCH_Information_ResourceStatusInd_value._const_tab = __S_SCH_Information_ResourceStatusInd_id_tab
    _S_SCH_Information_ResourceStatusInd_value._const_tab_at = ('..', 'id')
    _S_SCH_Information_ResourceStatusInd_value._const_tab_id = 'Value'
    S_SCH_Information_ResourceStatusInd._cont = ASN1Dict([
        ('id', _S_SCH_Information_ResourceStatusInd_id),
        ('criticality', _S_SCH_Information_ResourceStatusInd_criticality),
        ('value', _S_SCH_Information_ResourceStatusInd_value),
        ])
    S_SCH_Information_ResourceStatusInd._ext = None
    
    #-----< S-SCH-InformationIE-ResourceStatusInd >-----#
    S_SCH_InformationIE_ResourceStatusInd = CLASS(name='S-SCH-InformationIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _S_SCH_InformationIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    S_SCH_InformationIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 253), ('criticality', 'ignore'), ('Value', _S_SCH_InformationIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< P-CPICH-Information-ResourceStatusInd >-----#
    P_CPICH_Information_ResourceStatusInd = SEQ(name='P-CPICH-Information-ResourceStatusInd', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _P_CPICH_Information_ResourceStatusInd_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __P_CPICH_Information_ResourceStatusInd_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___P_CPICH_Information_ResourceStatusInd_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __P_CPICH_Information_ResourceStatusInd_id_tab._val = ASN1Set(rv=[dict([('id', 146), ('criticality', 'ignore'), ('Value', ___P_CPICH_Information_ResourceStatusInd_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _P_CPICH_Information_ResourceStatusInd_id._const_tab = __P_CPICH_Information_ResourceStatusInd_id_tab
    _P_CPICH_Information_ResourceStatusInd_id._const_tab_at = None
    _P_CPICH_Information_ResourceStatusInd_id._const_tab_id = 'id'
    _P_CPICH_Information_ResourceStatusInd_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _P_CPICH_Information_ResourceStatusInd_criticality._const_tab = __P_CPICH_Information_ResourceStatusInd_id_tab
    _P_CPICH_Information_ResourceStatusInd_criticality._const_tab_at = ('..', 'id')
    _P_CPICH_Information_ResourceStatusInd_criticality._const_tab_id = 'criticality'
    _P_CPICH_Information_ResourceStatusInd_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _P_CPICH_Information_ResourceStatusInd_value._const_tab = __P_CPICH_Information_ResourceStatusInd_id_tab
    _P_CPICH_Information_ResourceStatusInd_value._const_tab_at = ('..', 'id')
    _P_CPICH_Information_ResourceStatusInd_value._const_tab_id = 'Value'
    P_CPICH_Information_ResourceStatusInd._cont = ASN1Dict([
        ('id', _P_CPICH_Information_ResourceStatusInd_id),
        ('criticality', _P_CPICH_Information_ResourceStatusInd_criticality),
        ('value', _P_CPICH_Information_ResourceStatusInd_value),
        ])
    P_CPICH_Information_ResourceStatusInd._ext = None
    
    #-----< P-CPICH-InformationIE-ResourceStatusInd >-----#
    P_CPICH_InformationIE_ResourceStatusInd = CLASS(name='P-CPICH-InformationIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _P_CPICH_InformationIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    P_CPICH_InformationIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 146), ('criticality', 'ignore'), ('Value', _P_CPICH_InformationIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< S-CPICH-InformationList-ResourceStatusInd >-----#
    S_CPICH_InformationList_ResourceStatusInd = SEQ_OF(name='S-CPICH-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _S_CPICH_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __S_CPICH_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___S_CPICH_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____S_CPICH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___S_CPICH_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 249), ('criticality', 'ignore'), ('Value', ____S_CPICH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __S_CPICH_InformationList_ResourceStatusInd__item__id._const_tab = ___S_CPICH_InformationList_ResourceStatusInd__item__id_tab
    __S_CPICH_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __S_CPICH_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __S_CPICH_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __S_CPICH_InformationList_ResourceStatusInd__item__criticality._const_tab = ___S_CPICH_InformationList_ResourceStatusInd__item__id_tab
    __S_CPICH_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __S_CPICH_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __S_CPICH_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __S_CPICH_InformationList_ResourceStatusInd__item__value._const_tab = ___S_CPICH_InformationList_ResourceStatusInd__item__id_tab
    __S_CPICH_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __S_CPICH_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _S_CPICH_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __S_CPICH_InformationList_ResourceStatusInd__item__id),
        ('criticality', __S_CPICH_InformationList_ResourceStatusInd__item__criticality),
        ('value', __S_CPICH_InformationList_ResourceStatusInd__item__value),
        ])
    _S_CPICH_InformationList_ResourceStatusInd__item_._ext = None
    S_CPICH_InformationList_ResourceStatusInd._cont = _S_CPICH_InformationList_ResourceStatusInd__item_
    S_CPICH_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< S-CPICH-InformationItemIE-ResourceStatusInd >-----#
    S_CPICH_InformationItemIE_ResourceStatusInd = CLASS(name='S-CPICH-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _S_CPICH_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    S_CPICH_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 249), ('criticality', 'ignore'), ('Value', _S_CPICH_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< P-CCPCH-Information-ResourceStatusInd >-----#
    P_CCPCH_Information_ResourceStatusInd = SEQ(name='P-CCPCH-Information-ResourceStatusInd', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _P_CCPCH_Information_ResourceStatusInd_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __P_CCPCH_Information_ResourceStatusInd_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___P_CCPCH_Information_ResourceStatusInd_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __P_CCPCH_Information_ResourceStatusInd_id_tab._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Value', ___P_CCPCH_Information_ResourceStatusInd_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _P_CCPCH_Information_ResourceStatusInd_id._const_tab = __P_CCPCH_Information_ResourceStatusInd_id_tab
    _P_CCPCH_Information_ResourceStatusInd_id._const_tab_at = None
    _P_CCPCH_Information_ResourceStatusInd_id._const_tab_id = 'id'
    _P_CCPCH_Information_ResourceStatusInd_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _P_CCPCH_Information_ResourceStatusInd_criticality._const_tab = __P_CCPCH_Information_ResourceStatusInd_id_tab
    _P_CCPCH_Information_ResourceStatusInd_criticality._const_tab_at = ('..', 'id')
    _P_CCPCH_Information_ResourceStatusInd_criticality._const_tab_id = 'criticality'
    _P_CCPCH_Information_ResourceStatusInd_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _P_CCPCH_Information_ResourceStatusInd_value._const_tab = __P_CCPCH_Information_ResourceStatusInd_id_tab
    _P_CCPCH_Information_ResourceStatusInd_value._const_tab_at = ('..', 'id')
    _P_CCPCH_Information_ResourceStatusInd_value._const_tab_id = 'Value'
    P_CCPCH_Information_ResourceStatusInd._cont = ASN1Dict([
        ('id', _P_CCPCH_Information_ResourceStatusInd_id),
        ('criticality', _P_CCPCH_Information_ResourceStatusInd_criticality),
        ('value', _P_CCPCH_Information_ResourceStatusInd_value),
        ])
    P_CCPCH_Information_ResourceStatusInd._ext = None
    
    #-----< P-CCPCH-InformationIE-ResourceStatusInd >-----#
    P_CCPCH_InformationIE_ResourceStatusInd = CLASS(name='P-CCPCH-InformationIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _P_CCPCH_InformationIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    P_CCPCH_InformationIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Value', _P_CCPCH_InformationIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< BCH-Information-ResourceStatusInd >-----#
    BCH_Information_ResourceStatusInd = SEQ(name='BCH-Information-ResourceStatusInd', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _BCH_Information_ResourceStatusInd_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __BCH_Information_ResourceStatusInd_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___BCH_Information_ResourceStatusInd_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    __BCH_Information_ResourceStatusInd_id_tab._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'ignore'), ('Value', ___BCH_Information_ResourceStatusInd_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _BCH_Information_ResourceStatusInd_id._const_tab = __BCH_Information_ResourceStatusInd_id_tab
    _BCH_Information_ResourceStatusInd_id._const_tab_at = None
    _BCH_Information_ResourceStatusInd_id._const_tab_id = 'id'
    _BCH_Information_ResourceStatusInd_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _BCH_Information_ResourceStatusInd_criticality._const_tab = __BCH_Information_ResourceStatusInd_id_tab
    _BCH_Information_ResourceStatusInd_criticality._const_tab_at = ('..', 'id')
    _BCH_Information_ResourceStatusInd_criticality._const_tab_id = 'criticality'
    _BCH_Information_ResourceStatusInd_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _BCH_Information_ResourceStatusInd_value._const_tab = __BCH_Information_ResourceStatusInd_id_tab
    _BCH_Information_ResourceStatusInd_value._const_tab_at = ('..', 'id')
    _BCH_Information_ResourceStatusInd_value._const_tab_id = 'Value'
    BCH_Information_ResourceStatusInd._cont = ASN1Dict([
        ('id', _BCH_Information_ResourceStatusInd_id),
        ('criticality', _BCH_Information_ResourceStatusInd_criticality),
        ('value', _BCH_Information_ResourceStatusInd_value),
        ])
    BCH_Information_ResourceStatusInd._ext = None
    
    #-----< BCH-InformationIE-ResourceStatusInd >-----#
    BCH_InformationIE_ResourceStatusInd = CLASS(name='BCH-InformationIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _BCH_InformationIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    BCH_InformationIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'ignore'), ('Value', _BCH_InformationIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< S-CCPCH-InformationList-ResourceStatusInd >-----#
    S_CCPCH_InformationList_ResourceStatusInd = SEQ_OF(name='S-CCPCH-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _S_CCPCH_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __S_CCPCH_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___S_CCPCH_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____S_CCPCH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___S_CCPCH_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 247), ('criticality', 'ignore'), ('Value', ____S_CCPCH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __S_CCPCH_InformationList_ResourceStatusInd__item__id._const_tab = ___S_CCPCH_InformationList_ResourceStatusInd__item__id_tab
    __S_CCPCH_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __S_CCPCH_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __S_CCPCH_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __S_CCPCH_InformationList_ResourceStatusInd__item__criticality._const_tab = ___S_CCPCH_InformationList_ResourceStatusInd__item__id_tab
    __S_CCPCH_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __S_CCPCH_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __S_CCPCH_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __S_CCPCH_InformationList_ResourceStatusInd__item__value._const_tab = ___S_CCPCH_InformationList_ResourceStatusInd__item__id_tab
    __S_CCPCH_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __S_CCPCH_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _S_CCPCH_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __S_CCPCH_InformationList_ResourceStatusInd__item__id),
        ('criticality', __S_CCPCH_InformationList_ResourceStatusInd__item__criticality),
        ('value', __S_CCPCH_InformationList_ResourceStatusInd__item__value),
        ])
    _S_CCPCH_InformationList_ResourceStatusInd__item_._ext = None
    S_CCPCH_InformationList_ResourceStatusInd._cont = _S_CCPCH_InformationList_ResourceStatusInd__item_
    S_CCPCH_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< S-CCPCH-InformationItemIE-ResourceStatusInd >-----#
    S_CCPCH_InformationItemIE_ResourceStatusInd = CLASS(name='S-CCPCH-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _S_CCPCH_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    S_CCPCH_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 247), ('criticality', 'ignore'), ('Value', _S_CCPCH_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PCH-Information-ResourceStatusInd >-----#
    PCH_Information_ResourceStatusInd = SEQ(name='PCH-Information-ResourceStatusInd', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PCH_Information_ResourceStatusInd_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PCH_Information_ResourceStatusInd_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PCH_Information_ResourceStatusInd_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    __PCH_Information_ResourceStatusInd_id_tab._val = ASN1Set(rv=[dict([('id', 158), ('criticality', 'ignore'), ('Value', ___PCH_Information_ResourceStatusInd_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _PCH_Information_ResourceStatusInd_id._const_tab = __PCH_Information_ResourceStatusInd_id_tab
    _PCH_Information_ResourceStatusInd_id._const_tab_at = None
    _PCH_Information_ResourceStatusInd_id._const_tab_id = 'id'
    _PCH_Information_ResourceStatusInd_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PCH_Information_ResourceStatusInd_criticality._const_tab = __PCH_Information_ResourceStatusInd_id_tab
    _PCH_Information_ResourceStatusInd_criticality._const_tab_at = ('..', 'id')
    _PCH_Information_ResourceStatusInd_criticality._const_tab_id = 'criticality'
    _PCH_Information_ResourceStatusInd_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PCH_Information_ResourceStatusInd_value._const_tab = __PCH_Information_ResourceStatusInd_id_tab
    _PCH_Information_ResourceStatusInd_value._const_tab_at = ('..', 'id')
    _PCH_Information_ResourceStatusInd_value._const_tab_id = 'Value'
    PCH_Information_ResourceStatusInd._cont = ASN1Dict([
        ('id', _PCH_Information_ResourceStatusInd_id),
        ('criticality', _PCH_Information_ResourceStatusInd_criticality),
        ('value', _PCH_Information_ResourceStatusInd_value),
        ])
    PCH_Information_ResourceStatusInd._ext = None
    
    #-----< PCH-InformationIE-ResourceStatusInd >-----#
    PCH_InformationIE_ResourceStatusInd = CLASS(name='PCH-InformationIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PCH_InformationIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    PCH_InformationIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 158), ('criticality', 'ignore'), ('Value', _PCH_InformationIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PICH-Information-ResourceStatusInd >-----#
    PICH_Information_ResourceStatusInd = SEQ(name='PICH-Information-ResourceStatusInd', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PICH_Information_ResourceStatusInd_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PICH_Information_ResourceStatusInd_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PICH_Information_ResourceStatusInd_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __PICH_Information_ResourceStatusInd_id_tab._val = ASN1Set(rv=[dict([('id', 166), ('criticality', 'ignore'), ('Value', ___PICH_Information_ResourceStatusInd_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _PICH_Information_ResourceStatusInd_id._const_tab = __PICH_Information_ResourceStatusInd_id_tab
    _PICH_Information_ResourceStatusInd_id._const_tab_at = None
    _PICH_Information_ResourceStatusInd_id._const_tab_id = 'id'
    _PICH_Information_ResourceStatusInd_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PICH_Information_ResourceStatusInd_criticality._const_tab = __PICH_Information_ResourceStatusInd_id_tab
    _PICH_Information_ResourceStatusInd_criticality._const_tab_at = ('..', 'id')
    _PICH_Information_ResourceStatusInd_criticality._const_tab_id = 'criticality'
    _PICH_Information_ResourceStatusInd_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PICH_Information_ResourceStatusInd_value._const_tab = __PICH_Information_ResourceStatusInd_id_tab
    _PICH_Information_ResourceStatusInd_value._const_tab_at = ('..', 'id')
    _PICH_Information_ResourceStatusInd_value._const_tab_id = 'Value'
    PICH_Information_ResourceStatusInd._cont = ASN1Dict([
        ('id', _PICH_Information_ResourceStatusInd_id),
        ('criticality', _PICH_Information_ResourceStatusInd_criticality),
        ('value', _PICH_Information_ResourceStatusInd_value),
        ])
    PICH_Information_ResourceStatusInd._ext = None
    
    #-----< PICH-InformationIE-ResourceStatusInd >-----#
    PICH_InformationIE_ResourceStatusInd = CLASS(name='PICH-InformationIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PICH_InformationIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    PICH_InformationIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 166), ('criticality', 'ignore'), ('Value', _PICH_InformationIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< FACH-InformationList-ResourceStatusInd >-----#
    FACH_InformationList_ResourceStatusInd = SEQ_OF(name='FACH-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _FACH_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __FACH_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___FACH_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____FACH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    ___FACH_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 116), ('criticality', 'ignore'), ('Value', ____FACH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __FACH_InformationList_ResourceStatusInd__item__id._const_tab = ___FACH_InformationList_ResourceStatusInd__item__id_tab
    __FACH_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __FACH_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __FACH_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __FACH_InformationList_ResourceStatusInd__item__criticality._const_tab = ___FACH_InformationList_ResourceStatusInd__item__id_tab
    __FACH_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __FACH_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __FACH_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __FACH_InformationList_ResourceStatusInd__item__value._const_tab = ___FACH_InformationList_ResourceStatusInd__item__id_tab
    __FACH_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __FACH_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _FACH_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __FACH_InformationList_ResourceStatusInd__item__id),
        ('criticality', __FACH_InformationList_ResourceStatusInd__item__criticality),
        ('value', __FACH_InformationList_ResourceStatusInd__item__value),
        ])
    _FACH_InformationList_ResourceStatusInd__item_._ext = None
    FACH_InformationList_ResourceStatusInd._cont = _FACH_InformationList_ResourceStatusInd__item_
    FACH_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< FACH-InformationItemIE-ResourceStatusInd >-----#
    FACH_InformationItemIE_ResourceStatusInd = CLASS(name='FACH-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _FACH_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    FACH_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 116), ('criticality', 'ignore'), ('Value', _FACH_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PRACH-InformationList-ResourceStatusInd >-----#
    PRACH_InformationList_ResourceStatusInd = SEQ_OF(name='PRACH-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _PRACH_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __PRACH_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___PRACH_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____PRACH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___PRACH_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 170), ('criticality', 'ignore'), ('Value', ____PRACH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __PRACH_InformationList_ResourceStatusInd__item__id._const_tab = ___PRACH_InformationList_ResourceStatusInd__item__id_tab
    __PRACH_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __PRACH_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __PRACH_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __PRACH_InformationList_ResourceStatusInd__item__criticality._const_tab = ___PRACH_InformationList_ResourceStatusInd__item__id_tab
    __PRACH_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __PRACH_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __PRACH_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __PRACH_InformationList_ResourceStatusInd__item__value._const_tab = ___PRACH_InformationList_ResourceStatusInd__item__id_tab
    __PRACH_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __PRACH_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _PRACH_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __PRACH_InformationList_ResourceStatusInd__item__id),
        ('criticality', __PRACH_InformationList_ResourceStatusInd__item__criticality),
        ('value', __PRACH_InformationList_ResourceStatusInd__item__value),
        ])
    _PRACH_InformationList_ResourceStatusInd__item_._ext = None
    PRACH_InformationList_ResourceStatusInd._cont = _PRACH_InformationList_ResourceStatusInd__item_
    PRACH_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PRACH-InformationItemIE-ResourceStatusInd >-----#
    PRACH_InformationItemIE_ResourceStatusInd = CLASS(name='PRACH-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PRACH_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    PRACH_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 170), ('criticality', 'ignore'), ('Value', _PRACH_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RACH-InformationList-ResourceStatusInd >-----#
    RACH_InformationList_ResourceStatusInd = SEQ_OF(name='RACH-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _RACH_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RACH_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RACH_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RACH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    ___RACH_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 190), ('criticality', 'ignore'), ('Value', ____RACH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RACH_InformationList_ResourceStatusInd__item__id._const_tab = ___RACH_InformationList_ResourceStatusInd__item__id_tab
    __RACH_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __RACH_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __RACH_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RACH_InformationList_ResourceStatusInd__item__criticality._const_tab = ___RACH_InformationList_ResourceStatusInd__item__id_tab
    __RACH_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __RACH_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __RACH_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RACH_InformationList_ResourceStatusInd__item__value._const_tab = ___RACH_InformationList_ResourceStatusInd__item__id_tab
    __RACH_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __RACH_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _RACH_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __RACH_InformationList_ResourceStatusInd__item__id),
        ('criticality', __RACH_InformationList_ResourceStatusInd__item__criticality),
        ('value', __RACH_InformationList_ResourceStatusInd__item__value),
        ])
    _RACH_InformationList_ResourceStatusInd__item_._ext = None
    RACH_InformationList_ResourceStatusInd._cont = _RACH_InformationList_ResourceStatusInd__item_
    RACH_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RACH-InformationItemIE-ResourceStatusInd >-----#
    RACH_InformationItemIE_ResourceStatusInd = CLASS(name='RACH-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RACH_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-TransportChannel-Status-Information')))
    RACH_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 190), ('criticality', 'ignore'), ('Value', _RACH_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< AICH-InformationList-ResourceStatusInd >-----#
    AICH_InformationList_ResourceStatusInd = SEQ_OF(name='AICH-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _AICH_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __AICH_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___AICH_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____AICH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___AICH_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', ____AICH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __AICH_InformationList_ResourceStatusInd__item__id._const_tab = ___AICH_InformationList_ResourceStatusInd__item__id_tab
    __AICH_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __AICH_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __AICH_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __AICH_InformationList_ResourceStatusInd__item__criticality._const_tab = ___AICH_InformationList_ResourceStatusInd__item__id_tab
    __AICH_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __AICH_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __AICH_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __AICH_InformationList_ResourceStatusInd__item__value._const_tab = ___AICH_InformationList_ResourceStatusInd__item__id_tab
    __AICH_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __AICH_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _AICH_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __AICH_InformationList_ResourceStatusInd__item__id),
        ('criticality', __AICH_InformationList_ResourceStatusInd__item__criticality),
        ('value', __AICH_InformationList_ResourceStatusInd__item__value),
        ])
    _AICH_InformationList_ResourceStatusInd__item_._ext = None
    AICH_InformationList_ResourceStatusInd._cont = _AICH_InformationList_ResourceStatusInd__item_
    AICH_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< AICH-InformationItemIE-ResourceStatusInd >-----#
    AICH_InformationItemIE_ResourceStatusInd = CLASS(name='AICH-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _AICH_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    AICH_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _AICH_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SCH-Information-ResourceStatusInd >-----#
    SCH_Information_ResourceStatusInd = SEQ(name='SCH-Information-ResourceStatusInd', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _SCH_Information_ResourceStatusInd_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __SCH_Information_ResourceStatusInd_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___SCH_Information_ResourceStatusInd_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __SCH_Information_ResourceStatusInd_id_tab._val = ASN1Set(rv=[dict([('id', 251), ('criticality', 'ignore'), ('Value', ___SCH_Information_ResourceStatusInd_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _SCH_Information_ResourceStatusInd_id._const_tab = __SCH_Information_ResourceStatusInd_id_tab
    _SCH_Information_ResourceStatusInd_id._const_tab_at = None
    _SCH_Information_ResourceStatusInd_id._const_tab_id = 'id'
    _SCH_Information_ResourceStatusInd_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _SCH_Information_ResourceStatusInd_criticality._const_tab = __SCH_Information_ResourceStatusInd_id_tab
    _SCH_Information_ResourceStatusInd_criticality._const_tab_at = ('..', 'id')
    _SCH_Information_ResourceStatusInd_criticality._const_tab_id = 'criticality'
    _SCH_Information_ResourceStatusInd_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _SCH_Information_ResourceStatusInd_value._const_tab = __SCH_Information_ResourceStatusInd_id_tab
    _SCH_Information_ResourceStatusInd_value._const_tab_at = ('..', 'id')
    _SCH_Information_ResourceStatusInd_value._const_tab_id = 'Value'
    SCH_Information_ResourceStatusInd._cont = ASN1Dict([
        ('id', _SCH_Information_ResourceStatusInd_id),
        ('criticality', _SCH_Information_ResourceStatusInd_criticality),
        ('value', _SCH_Information_ResourceStatusInd_value),
        ])
    SCH_Information_ResourceStatusInd._ext = None
    
    #-----< SCH-InformationIE-ResourceStatusInd >-----#
    SCH_InformationIE_ResourceStatusInd = CLASS(name='SCH-InformationIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SCH_InformationIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    SCH_InformationIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 251), ('criticality', 'ignore'), ('Value', _SCH_InformationIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< FPACH-LCR-InformationList-ResourceStatusInd >-----#
    FPACH_LCR_InformationList_ResourceStatusInd = SEQ_OF(name='FPACH-LCR-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _FPACH_LCR_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __FPACH_LCR_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___FPACH_LCR_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____FPACH_LCR_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___FPACH_LCR_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 290), ('criticality', 'ignore'), ('Value', ____FPACH_LCR_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __FPACH_LCR_InformationList_ResourceStatusInd__item__id._const_tab = ___FPACH_LCR_InformationList_ResourceStatusInd__item__id_tab
    __FPACH_LCR_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __FPACH_LCR_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __FPACH_LCR_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __FPACH_LCR_InformationList_ResourceStatusInd__item__criticality._const_tab = ___FPACH_LCR_InformationList_ResourceStatusInd__item__id_tab
    __FPACH_LCR_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __FPACH_LCR_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __FPACH_LCR_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __FPACH_LCR_InformationList_ResourceStatusInd__item__value._const_tab = ___FPACH_LCR_InformationList_ResourceStatusInd__item__id_tab
    __FPACH_LCR_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __FPACH_LCR_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _FPACH_LCR_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __FPACH_LCR_InformationList_ResourceStatusInd__item__id),
        ('criticality', __FPACH_LCR_InformationList_ResourceStatusInd__item__criticality),
        ('value', __FPACH_LCR_InformationList_ResourceStatusInd__item__value),
        ])
    _FPACH_LCR_InformationList_ResourceStatusInd__item_._ext = None
    FPACH_LCR_InformationList_ResourceStatusInd._cont = _FPACH_LCR_InformationList_ResourceStatusInd__item_
    FPACH_LCR_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< FPACH-LCR-InformationItemIE-ResourceStatusInd >-----#
    FPACH_LCR_InformationItemIE_ResourceStatusInd = CLASS(name='FPACH-LCR-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _FPACH_LCR_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    FPACH_LCR_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 290), ('criticality', 'ignore'), ('Value', _FPACH_LCR_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DwPCH-LCR-Information-ResourceStatusInd >-----#
    DwPCH_LCR_Information_ResourceStatusInd = SEQ(name='DwPCH-LCR-Information-ResourceStatusInd', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DwPCH_LCR_Information_ResourceStatusInd_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DwPCH_LCR_Information_ResourceStatusInd_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DwPCH_LCR_Information_ResourceStatusInd_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    __DwPCH_LCR_Information_ResourceStatusInd_id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Value', ___DwPCH_LCR_Information_ResourceStatusInd_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DwPCH_LCR_Information_ResourceStatusInd_id._const_tab = __DwPCH_LCR_Information_ResourceStatusInd_id_tab
    _DwPCH_LCR_Information_ResourceStatusInd_id._const_tab_at = None
    _DwPCH_LCR_Information_ResourceStatusInd_id._const_tab_id = 'id'
    _DwPCH_LCR_Information_ResourceStatusInd_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DwPCH_LCR_Information_ResourceStatusInd_criticality._const_tab = __DwPCH_LCR_Information_ResourceStatusInd_id_tab
    _DwPCH_LCR_Information_ResourceStatusInd_criticality._const_tab_at = ('..', 'id')
    _DwPCH_LCR_Information_ResourceStatusInd_criticality._const_tab_id = 'criticality'
    _DwPCH_LCR_Information_ResourceStatusInd_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DwPCH_LCR_Information_ResourceStatusInd_value._const_tab = __DwPCH_LCR_Information_ResourceStatusInd_id_tab
    _DwPCH_LCR_Information_ResourceStatusInd_value._const_tab_at = ('..', 'id')
    _DwPCH_LCR_Information_ResourceStatusInd_value._const_tab_id = 'Value'
    DwPCH_LCR_Information_ResourceStatusInd._cont = ASN1Dict([
        ('id', _DwPCH_LCR_Information_ResourceStatusInd_id),
        ('criticality', _DwPCH_LCR_Information_ResourceStatusInd_criticality),
        ('value', _DwPCH_LCR_Information_ResourceStatusInd_value),
        ])
    DwPCH_LCR_Information_ResourceStatusInd._ext = None
    
    #-----< DwPCH-LCR-InformationIE-ResourceStatusInd >-----#
    DwPCH_LCR_InformationIE_ResourceStatusInd = CLASS(name='DwPCH-LCR-InformationIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DwPCH_LCR_InformationIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    DwPCH_LCR_InformationIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Value', _DwPCH_LCR_InformationIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< HS-DSCH-Resources-Information-ResourceStatusInd >-----#
    HS_DSCH_Resources_Information_ResourceStatusInd = SEQ(name='HS-DSCH-Resources-Information-ResourceStatusInd', mode=MODE_TYPE)
    _HS_DSCH_Resources_Information_ResourceStatusInd_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _HS_DSCH_Resources_Information_ResourceStatusInd_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item_._ext = None
    _HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions._cont = __HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item_
    _HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Resources_Information_ResourceStatusInd._cont = ASN1Dict([
        ('resourceOperationalState', _HS_DSCH_Resources_Information_ResourceStatusInd_resourceOperationalState),
        ('availabilityStatus', _HS_DSCH_Resources_Information_ResourceStatusInd_availabilityStatus),
        ('iE-Extensions', _HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions),
        ])
    HS_DSCH_Resources_Information_ResourceStatusInd._ext = []
    
    #-----< HS-DSCH-Resources-Information-ResourceStatusInd-ExtIEs >-----#
    HS_DSCH_Resources_Information_ResourceStatusInd_ExtIEs = CLASS(name='HS-DSCH-Resources-Information-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_Resources_Information_ResourceStatusInd_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    HS_DSCH_Resources_Information_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _HS_DSCH_Resources_Information_ResourceStatusInd_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< S-CCPCH-InformationListExt-ResourceStatusInd >-----#
    S_CCPCH_InformationListExt_ResourceStatusInd = SEQ_OF(name='S-CCPCH-InformationListExt-ResourceStatusInd', mode=MODE_TYPE)
    _S_CCPCH_InformationListExt_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___S_CCPCH_InformationListExt_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____S_CCPCH_InformationListExt_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___S_CCPCH_InformationListExt_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 247), ('criticality', 'ignore'), ('Value', ____S_CCPCH_InformationListExt_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__id._const_tab = ___S_CCPCH_InformationListExt_ResourceStatusInd__item__id_tab
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__id._const_tab_at = None
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__id._const_tab_id = 'id'
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__criticality._const_tab = ___S_CCPCH_InformationListExt_ResourceStatusInd__item__id_tab
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__value._const_tab = ___S_CCPCH_InformationListExt_ResourceStatusInd__item__id_tab
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __S_CCPCH_InformationListExt_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _S_CCPCH_InformationListExt_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __S_CCPCH_InformationListExt_ResourceStatusInd__item__id),
        ('criticality', __S_CCPCH_InformationListExt_ResourceStatusInd__item__criticality),
        ('value', __S_CCPCH_InformationListExt_ResourceStatusInd__item__value),
        ])
    _S_CCPCH_InformationListExt_ResourceStatusInd__item_._ext = None
    S_CCPCH_InformationListExt_ResourceStatusInd._cont = _S_CCPCH_InformationListExt_ResourceStatusInd__item_
    S_CCPCH_InformationListExt_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=208)], ev=None, er=[])
    
    #-----< S-CCPCH-LCR-InformationListExt-ResourceStatusInd >-----#
    S_CCPCH_LCR_InformationListExt_ResourceStatusInd = SEQ_OF(name='S-CCPCH-LCR-InformationListExt-ResourceStatusInd', mode=MODE_TYPE)
    _S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 247), ('criticality', 'ignore'), ('Value', ____S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id._const_tab = ___S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id_tab
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id._const_tab_at = None
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id._const_tab_id = 'id'
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__criticality._const_tab = ___S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id_tab
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__value._const_tab = ___S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id_tab
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id),
        ('criticality', __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__criticality),
        ('value', __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__value),
        ])
    _S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item_._ext = None
    S_CCPCH_LCR_InformationListExt_ResourceStatusInd._cont = _S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item_
    S_CCPCH_LCR_InformationListExt_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< E-DCH-Resources-Information-ResourceStatusInd >-----#
    E_DCH_Resources_Information_ResourceStatusInd = SEQ(name='E-DCH-Resources-Information-ResourceStatusInd', mode=MODE_TYPE)
    _E_DCH_Resources_Information_ResourceStatusInd_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _E_DCH_Resources_Information_ResourceStatusInd_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item_._ext = None
    _E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions._cont = __E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item_
    _E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Resources_Information_ResourceStatusInd._cont = ASN1Dict([
        ('resourceOperationalState', _E_DCH_Resources_Information_ResourceStatusInd_resourceOperationalState),
        ('availabilityStatus', _E_DCH_Resources_Information_ResourceStatusInd_availabilityStatus),
        ('iE-Extensions', _E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions),
        ])
    E_DCH_Resources_Information_ResourceStatusInd._ext = []
    
    #-----< E-DCH-Resources-Information-ResourceStatusInd-ExtIEs >-----#
    E_DCH_Resources_Information_ResourceStatusInd_ExtIEs = CLASS(name='E-DCH-Resources-Information-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_Resources_Information_ResourceStatusInd_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    E_DCH_Resources_Information_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _E_DCH_Resources_Information_ResourceStatusInd_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PLCCH-InformationList-ResourceStatusInd >-----#
    PLCCH_InformationList_ResourceStatusInd = SEQ_OF(name='PLCCH-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _PLCCH_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __PLCCH_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___PLCCH_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____PLCCH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___PLCCH_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 712), ('criticality', 'ignore'), ('Value', ____PLCCH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __PLCCH_InformationList_ResourceStatusInd__item__id._const_tab = ___PLCCH_InformationList_ResourceStatusInd__item__id_tab
    __PLCCH_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __PLCCH_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __PLCCH_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __PLCCH_InformationList_ResourceStatusInd__item__criticality._const_tab = ___PLCCH_InformationList_ResourceStatusInd__item__id_tab
    __PLCCH_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __PLCCH_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __PLCCH_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __PLCCH_InformationList_ResourceStatusInd__item__value._const_tab = ___PLCCH_InformationList_ResourceStatusInd__item__id_tab
    __PLCCH_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __PLCCH_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _PLCCH_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __PLCCH_InformationList_ResourceStatusInd__item__id),
        ('criticality', __PLCCH_InformationList_ResourceStatusInd__item__criticality),
        ('value', __PLCCH_InformationList_ResourceStatusInd__item__value),
        ])
    _PLCCH_InformationList_ResourceStatusInd__item_._ext = None
    PLCCH_InformationList_ResourceStatusInd._cont = _PLCCH_InformationList_ResourceStatusInd__item_
    PLCCH_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PLCCH-InformationItemIE-ResourceStatusInd >-----#
    PLCCH_InformationItemIE_ResourceStatusInd = CLASS(name='PLCCH-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PLCCH_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    PLCCH_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 712), ('criticality', 'ignore'), ('Value', _PLCCH_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< S-CCPCH-768-InformationList-ResourceStatusInd >-----#
    S_CCPCH_768_InformationList_ResourceStatusInd = SEQ_OF(name='S-CCPCH-768-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _S_CCPCH_768_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___S_CCPCH_768_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____S_CCPCH_768_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    ___S_CCPCH_768_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 738), ('criticality', 'ignore'), ('Value', ____S_CCPCH_768_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__id._const_tab = ___S_CCPCH_768_InformationList_ResourceStatusInd__item__id_tab
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__criticality._const_tab = ___S_CCPCH_768_InformationList_ResourceStatusInd__item__id_tab
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__value._const_tab = ___S_CCPCH_768_InformationList_ResourceStatusInd__item__id_tab
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __S_CCPCH_768_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _S_CCPCH_768_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __S_CCPCH_768_InformationList_ResourceStatusInd__item__id),
        ('criticality', __S_CCPCH_768_InformationList_ResourceStatusInd__item__criticality),
        ('value', __S_CCPCH_768_InformationList_ResourceStatusInd__item__value),
        ])
    _S_CCPCH_768_InformationList_ResourceStatusInd__item_._ext = None
    S_CCPCH_768_InformationList_ResourceStatusInd._cont = _S_CCPCH_768_InformationList_ResourceStatusInd__item_
    S_CCPCH_768_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=480)], ev=None, er=[])
    
    #-----< S-CCPCH-768-InformationItemIE-ResourceStatusInd >-----#
    S_CCPCH_768_InformationItemIE_ResourceStatusInd = CLASS(name='S-CCPCH-768-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _S_CCPCH_768_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    S_CCPCH_768_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 738), ('criticality', 'ignore'), ('Value', _S_CCPCH_768_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PRACH-768-InformationList-ResourceStatusInd >-----#
    PRACH_768_InformationList_ResourceStatusInd = SEQ_OF(name='PRACH-768-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _PRACH_768_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __PRACH_768_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___PRACH_768_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____PRACH_768_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    ___PRACH_768_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 737), ('criticality', 'ignore'), ('Value', ____PRACH_768_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __PRACH_768_InformationList_ResourceStatusInd__item__id._const_tab = ___PRACH_768_InformationList_ResourceStatusInd__item__id_tab
    __PRACH_768_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __PRACH_768_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __PRACH_768_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __PRACH_768_InformationList_ResourceStatusInd__item__criticality._const_tab = ___PRACH_768_InformationList_ResourceStatusInd__item__id_tab
    __PRACH_768_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __PRACH_768_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __PRACH_768_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __PRACH_768_InformationList_ResourceStatusInd__item__value._const_tab = ___PRACH_768_InformationList_ResourceStatusInd__item__id_tab
    __PRACH_768_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __PRACH_768_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _PRACH_768_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __PRACH_768_InformationList_ResourceStatusInd__item__id),
        ('criticality', __PRACH_768_InformationList_ResourceStatusInd__item__criticality),
        ('value', __PRACH_768_InformationList_ResourceStatusInd__item__value),
        ])
    _PRACH_768_InformationList_ResourceStatusInd__item_._ext = None
    PRACH_768_InformationList_ResourceStatusInd._cont = _PRACH_768_InformationList_ResourceStatusInd__item_
    PRACH_768_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PRACH-768-InformationItemIE-ResourceStatusInd >-----#
    PRACH_768_InformationItemIE_ResourceStatusInd = CLASS(name='PRACH-768-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PRACH_768_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    PRACH_768_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 737), ('criticality', 'ignore'), ('Value', _PRACH_768_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RUCCH-InformationList-ResourceStatusInd >-----#
    E_RUCCH_InformationList_ResourceStatusInd = SEQ_OF(name='E-RUCCH-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _E_RUCCH_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __E_RUCCH_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___E_RUCCH_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____E_RUCCH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    ___E_RUCCH_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 798), ('criticality', 'ignore'), ('Value', ____E_RUCCH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RUCCH_InformationList_ResourceStatusInd__item__id._const_tab = ___E_RUCCH_InformationList_ResourceStatusInd__item__id_tab
    __E_RUCCH_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __E_RUCCH_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __E_RUCCH_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __E_RUCCH_InformationList_ResourceStatusInd__item__criticality._const_tab = ___E_RUCCH_InformationList_ResourceStatusInd__item__id_tab
    __E_RUCCH_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __E_RUCCH_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __E_RUCCH_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __E_RUCCH_InformationList_ResourceStatusInd__item__value._const_tab = ___E_RUCCH_InformationList_ResourceStatusInd__item__id_tab
    __E_RUCCH_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __E_RUCCH_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _E_RUCCH_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __E_RUCCH_InformationList_ResourceStatusInd__item__id),
        ('criticality', __E_RUCCH_InformationList_ResourceStatusInd__item__criticality),
        ('value', __E_RUCCH_InformationList_ResourceStatusInd__item__value),
        ])
    _E_RUCCH_InformationList_ResourceStatusInd__item_._ext = None
    E_RUCCH_InformationList_ResourceStatusInd._cont = _E_RUCCH_InformationList_ResourceStatusInd__item_
    E_RUCCH_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< E-RUCCH-InformationItemIE-ResourceStatusInd >-----#
    E_RUCCH_InformationItemIE_ResourceStatusInd = CLASS(name='E-RUCCH-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _E_RUCCH_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information')))
    E_RUCCH_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 798), ('criticality', 'ignore'), ('Value', _E_RUCCH_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RUCCH-768-InformationList-ResourceStatusInd >-----#
    E_RUCCH_768_InformationList_ResourceStatusInd = SEQ_OF(name='E-RUCCH-768-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _E_RUCCH_768_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___E_RUCCH_768_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____E_RUCCH_768_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    ___E_RUCCH_768_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 812), ('criticality', 'ignore'), ('Value', ____E_RUCCH_768_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__id._const_tab = ___E_RUCCH_768_InformationList_ResourceStatusInd__item__id_tab
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__criticality._const_tab = ___E_RUCCH_768_InformationList_ResourceStatusInd__item__id_tab
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__value._const_tab = ___E_RUCCH_768_InformationList_ResourceStatusInd__item__id_tab
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __E_RUCCH_768_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _E_RUCCH_768_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __E_RUCCH_768_InformationList_ResourceStatusInd__item__id),
        ('criticality', __E_RUCCH_768_InformationList_ResourceStatusInd__item__criticality),
        ('value', __E_RUCCH_768_InformationList_ResourceStatusInd__item__value),
        ])
    _E_RUCCH_768_InformationList_ResourceStatusInd__item_._ext = None
    E_RUCCH_768_InformationList_ResourceStatusInd._cont = _E_RUCCH_768_InformationList_ResourceStatusInd__item_
    E_RUCCH_768_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< E-RUCCH-768-InformationItemIE-ResourceStatusInd >-----#
    E_RUCCH_768_InformationItemIE_ResourceStatusInd = CLASS(name='E-RUCCH-768-InformationItemIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _E_RUCCH_768_InformationItemIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-PhysicalChannel-Status-Information768')))
    E_RUCCH_768_InformationItemIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 812), ('criticality', 'ignore'), ('Value', _E_RUCCH_768_InformationItemIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Cell-Frequency-List-Information-LCR-MulFreq-ResourceStatusInd >-----#
    Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd = SEQ_OF(name='Cell-Frequency-List-Information-LCR-MulFreq-ResourceStatusInd', mode=MODE_TYPE)
    _Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd')))
    ___Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 918), ('criticality', 'ignore'), ('Value', ____Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id._const_tab = ___Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id_tab
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id._const_tab_at = None
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id._const_tab_id = 'id'
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__criticality._const_tab = ___Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id_tab
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__value._const_tab = ___Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id_tab
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id),
        ('criticality', __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__criticality),
        ('value', __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__value),
        ])
    _Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item_._ext = None
    Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd._cont = _Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item_
    Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< Cell-Frequency-List-InformationIE-LCR-MulFreq-ResourceStatusInd >-----#
    Cell_Frequency_List_InformationIE_LCR_MulFreq_ResourceStatusInd = CLASS(name='Cell-Frequency-List-InformationIE-LCR-MulFreq-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Cell_Frequency_List_InformationIE_LCR_MulFreq_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd')))
    Cell_Frequency_List_InformationIE_LCR_MulFreq_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 918), ('criticality', 'ignore'), ('Value', _Cell_Frequency_List_InformationIE_LCR_MulFreq_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd >-----#
    Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd = SEQ(name='Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd', mode=MODE_TYPE)
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')), opt=True)
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__criticality_tab
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__extensionValue_tab
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item_._ext = None
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions._cont = __Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item_
    _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd._cont = ASN1Dict([
        ('uARFCN', _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_uARFCN),
        ('resourceOperationalState', _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_resourceOperationalState),
        ('availabilityStatus', _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_availabilityStatus),
        ('cause', _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_cause),
        ('iE-Extensions', _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions),
        ])
    Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd._ext = []
    
    #-----< Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd-ExtIEs >-----#
    Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_ExtIEs = CLASS(name='Cell-Frequency-List-InformationItem-LCR-MulFreq-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UPPCH-LCR-InformationList-ResourceStatusInd >-----#
    UPPCH_LCR_InformationList_ResourceStatusInd = SEQ_OF(name='UPPCH-LCR-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _UPPCH_LCR_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___UPPCH_LCR_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____UPPCH_LCR_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UPPCH-LCR-InformationItem-ResourceStatusInd')))
    ___UPPCH_LCR_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 924), ('criticality', 'ignore'), ('Value', ____UPPCH_LCR_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__id._const_tab = ___UPPCH_LCR_InformationList_ResourceStatusInd__item__id_tab
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__criticality._const_tab = ___UPPCH_LCR_InformationList_ResourceStatusInd__item__id_tab
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__value._const_tab = ___UPPCH_LCR_InformationList_ResourceStatusInd__item__id_tab
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __UPPCH_LCR_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _UPPCH_LCR_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __UPPCH_LCR_InformationList_ResourceStatusInd__item__id),
        ('criticality', __UPPCH_LCR_InformationList_ResourceStatusInd__item__criticality),
        ('value', __UPPCH_LCR_InformationList_ResourceStatusInd__item__value),
        ])
    _UPPCH_LCR_InformationList_ResourceStatusInd__item_._ext = None
    UPPCH_LCR_InformationList_ResourceStatusInd._cont = _UPPCH_LCR_InformationList_ResourceStatusInd__item_
    UPPCH_LCR_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< UPPCH-LCR-InformationIE-ResourceStatusInd >-----#
    UPPCH_LCR_InformationIE_ResourceStatusInd = CLASS(name='UPPCH-LCR-InformationIE-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UPPCH_LCR_InformationIE_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UPPCH-LCR-InformationItem-ResourceStatusInd')))
    UPPCH_LCR_InformationIE_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 924), ('criticality', 'ignore'), ('Value', _UPPCH_LCR_InformationIE_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UPPCH-LCR-InformationItem-ResourceStatusInd >-----#
    UPPCH_LCR_InformationItem_ResourceStatusInd = SEQ(name='UPPCH-LCR-InformationItem-ResourceStatusInd', mode=MODE_TYPE)
    _UPPCH_LCR_InformationItem_ResourceStatusInd_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')), opt=True)
    _UPPCH_LCR_InformationItem_ResourceStatusInd_uPPCHPositionLCR = INT(name='uPPCHPositionLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UPPCHPositionLCR')))
    _UPPCH_LCR_InformationItem_ResourceStatusInd_resourceOperationalState = ENUM(name='resourceOperationalState', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ResourceOperationalState')))
    _UPPCH_LCR_InformationItem_ResourceStatusInd_availabilityStatus = ENUM(name='availabilityStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AvailabilityStatus')))
    _UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item_._ext = None
    _UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions._cont = __UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item_
    _UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UPPCH_LCR_InformationItem_ResourceStatusInd._cont = ASN1Dict([
        ('uARFCN', _UPPCH_LCR_InformationItem_ResourceStatusInd_uARFCN),
        ('uPPCHPositionLCR', _UPPCH_LCR_InformationItem_ResourceStatusInd_uPPCHPositionLCR),
        ('resourceOperationalState', _UPPCH_LCR_InformationItem_ResourceStatusInd_resourceOperationalState),
        ('availabilityStatus', _UPPCH_LCR_InformationItem_ResourceStatusInd_availabilityStatus),
        ('iE-Extensions', _UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions),
        ])
    UPPCH_LCR_InformationItem_ResourceStatusInd._ext = []
    
    #-----< UPPCH-LCR-InformationItem-ResourceStatusInd-ExtIEs >-----#
    UPPCH_LCR_InformationItem_ResourceStatusInd_ExtIEs = CLASS(name='UPPCH-LCR-InformationItem-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UPPCH_LCR_InformationItem_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultipleFreq-HS-DSCH-Resources-InformationList-ResourceStatusInd >-----#
    MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd = SEQ_OF(name='MultipleFreq-HS-DSCH-Resources-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-DSCH-Resources-Information-ResourceStatusInd')))
    ___MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 612), ('criticality', 'ignore'), ('Value', ____MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id._const_tab = ___MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id_tab
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__criticality._const_tab = ___MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id_tab
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__value._const_tab = ___MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id_tab
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id),
        ('criticality', __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__criticality),
        ('value', __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__value),
        ])
    _MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item_._ext = None
    MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd._cont = _MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item_
    MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< MultipleFreq-HS-DSCH-Resources-InformationItem-ResourceStatusInd >-----#
    MultipleFreq_HS_DSCH_Resources_InformationItem_ResourceStatusInd = CLASS(name='MultipleFreq-HS-DSCH-Resources-InformationItem-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _MultipleFreq_HS_DSCH_Resources_InformationItem_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-DSCH-Resources-Information-ResourceStatusInd')))
    MultipleFreq_HS_DSCH_Resources_InformationItem_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 612), ('criticality', 'ignore'), ('Value', _MultipleFreq_HS_DSCH_Resources_InformationItem_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Power-Local-Cell-Group-InformationList2-ResourceStatusInd >-----#
    Power_Local_Cell_Group_InformationList2_ResourceStatusInd = SEQ_OF(name='Power-Local-Cell-Group-InformationList2-ResourceStatusInd', mode=MODE_TYPE)
    _Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationItem2-ResourceStatusInd')))
    ___Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 500), ('criticality', 'ignore'), ('Value', ____Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id._const_tab = ___Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id._const_tab_at = None
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id._const_tab_id = 'id'
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality._const_tab = ___Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__value._const_tab = ___Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id),
        ('criticality', __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality),
        ('value', __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__value),
        ])
    _Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item_._ext = None
    Power_Local_Cell_Group_InformationList2_ResourceStatusInd._cont = _Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item_
    Power_Local_Cell_Group_InformationList2_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Power-Local-Cell-Group-InformationItemIE2-ResourceStatusInd >-----#
    Power_Local_Cell_Group_InformationItemIE2_ResourceStatusInd = CLASS(name='Power-Local-Cell-Group-InformationItemIE2-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Power_Local_Cell_Group_InformationItemIE2_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Power-Local-Cell-Group-InformationItem2-ResourceStatusInd')))
    Power_Local_Cell_Group_InformationItemIE2_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 500), ('criticality', 'ignore'), ('Value', _Power_Local_Cell_Group_InformationItemIE2_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Power-Local-Cell-Group-InformationItem2-ResourceStatusInd >-----#
    Power_Local_Cell_Group_InformationItem2_ResourceStatusInd = SEQ(name='Power-Local-Cell-Group-InformationItem2-ResourceStatusInd', mode=MODE_TYPE)
    _Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_power_Local_Cell_Group_ID = INT(name='power-Local-Cell-Group-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Local-Cell-ID')))
    _Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_maximumDL_PowerCapability = INT(name='maximumDL-PowerCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumDL-PowerCapability')))
    _Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id._const_tab = ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id._const_tab_at = None
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality._const_tab = ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality_tab
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab = ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue_tab
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id),
        ('criticality', ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality),
        ('extensionValue', ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue),
        ])
    __Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item_._ext = None
    _Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions._cont = __Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item_
    _Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Power_Local_Cell_Group_InformationItem2_ResourceStatusInd._cont = ASN1Dict([
        ('power-Local-Cell-Group-ID', _Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_power_Local_Cell_Group_ID),
        ('maximumDL-PowerCapability', _Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_maximumDL_PowerCapability),
        ('iE-Extensions', _Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions),
        ])
    Power_Local_Cell_Group_InformationItem2_ResourceStatusInd._ext = []
    
    #-----< Power-Local-Cell-Group-InformationItem2-ResourceStatusInd-ExtIEs >-----#
    Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs = CLASS(name='Power-Local-Cell-Group-InformationItem2-ResourceStatusInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultipleFreq-E-DCH-Resources-InformationList-ResourceStatusInd >-----#
    MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd = SEQ_OF(name='MultipleFreq-E-DCH-Resources-InformationList-ResourceStatusInd', mode=MODE_TYPE)
    _MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DCH-Resources-Information-ResourceStatusInd')))
    ___MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 673), ('criticality', 'ignore'), ('Value', ____MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id._const_tab = ___MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id_tab
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id._const_tab_at = None
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id._const_tab_id = 'id'
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__criticality._const_tab = ___MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id_tab
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__criticality._const_tab_at = ('..', 'id')
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__criticality._const_tab_id = 'criticality'
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__value._const_tab = ___MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id_tab
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__value._const_tab_at = ('..', 'id')
    __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__value._const_tab_id = 'Value'
    _MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item_._cont = ASN1Dict([
        ('id', __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id),
        ('criticality', __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__criticality),
        ('value', __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__value),
        ])
    _MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item_._ext = None
    MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd._cont = _MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item_
    MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< MultipleFreq-E-DCH-Resources-InformationItem-ResourceStatusInd >-----#
    MultipleFreq_E_DCH_Resources_InformationItem_ResourceStatusInd = CLASS(name='MultipleFreq-E-DCH-Resources-InformationItem-ResourceStatusInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _MultipleFreq_E_DCH_Resources_InformationItem_ResourceStatusInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DCH-Resources-Information-ResourceStatusInd')))
    MultipleFreq_E_DCH_Resources_InformationItem_ResourceStatusInd._val = ASN1Set(rv=[dict([('id', 673), ('criticality', 'ignore'), ('Value', _MultipleFreq_E_DCH_Resources_InformationItem_ResourceStatusInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SystemInformationUpdateRequest >-----#
    SystemInformationUpdateRequest = SEQ(name='SystemInformationUpdateRequest', mode=MODE_TYPE)
    _SystemInformationUpdateRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __SystemInformationUpdateRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___SystemInformationUpdateRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____SystemInformationUpdateRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____SystemInformationUpdateRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____SystemInformationUpdateRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BCCH-ModificationTime')))
    _____SystemInformationUpdateRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MIB-SB-SIB-InformationList-SystemInfoUpdateRqst')))
    ____SystemInformationUpdateRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____SystemInformationUpdateRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____SystemInformationUpdateRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'reject'), ('Value', _____SystemInformationUpdateRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___SystemInformationUpdateRequest_protocolIEs__item__id._const_tab = ____SystemInformationUpdateRequest_protocolIEs__item__id_tab
    ___SystemInformationUpdateRequest_protocolIEs__item__id._const_tab_at = None
    ___SystemInformationUpdateRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___SystemInformationUpdateRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___SystemInformationUpdateRequest_protocolIEs__item__criticality._const_tab = ____SystemInformationUpdateRequest_protocolIEs__item__id_tab
    ___SystemInformationUpdateRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SystemInformationUpdateRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___SystemInformationUpdateRequest_protocolIEs__item__value._const_tab = ____SystemInformationUpdateRequest_protocolIEs__item__id_tab
    ___SystemInformationUpdateRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __SystemInformationUpdateRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SystemInformationUpdateRequest_protocolIEs__item__id),
        ('criticality', ___SystemInformationUpdateRequest_protocolIEs__item__criticality),
        ('value', ___SystemInformationUpdateRequest_protocolIEs__item__value),
        ])
    __SystemInformationUpdateRequest_protocolIEs__item_._ext = None
    _SystemInformationUpdateRequest_protocolIEs._cont = __SystemInformationUpdateRequest_protocolIEs__item_
    _SystemInformationUpdateRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SystemInformationUpdateRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SystemInformationUpdateRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SystemInformationUpdateRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SystemInformationUpdateRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____SystemInformationUpdateRequest_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BCH-mappedOnSCCPCH-Indication')))
    ____SystemInformationUpdateRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1291), ('criticality', 'reject'), ('Extension', _____SystemInformationUpdateRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SystemInformationUpdateRequest_protocolExtensions__item__id._const_tab = ____SystemInformationUpdateRequest_protocolExtensions__item__id_tab
    ___SystemInformationUpdateRequest_protocolExtensions__item__id._const_tab_at = None
    ___SystemInformationUpdateRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___SystemInformationUpdateRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SystemInformationUpdateRequest_protocolExtensions__item__criticality._const_tab = ____SystemInformationUpdateRequest_protocolExtensions__item__id_tab
    ___SystemInformationUpdateRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SystemInformationUpdateRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SystemInformationUpdateRequest_protocolExtensions__item__extensionValue._const_tab = ____SystemInformationUpdateRequest_protocolExtensions__item__id_tab
    ___SystemInformationUpdateRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SystemInformationUpdateRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SystemInformationUpdateRequest_protocolExtensions__item__id),
        ('criticality', ___SystemInformationUpdateRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___SystemInformationUpdateRequest_protocolExtensions__item__extensionValue),
        ])
    __SystemInformationUpdateRequest_protocolExtensions__item_._ext = None
    _SystemInformationUpdateRequest_protocolExtensions._cont = __SystemInformationUpdateRequest_protocolExtensions__item_
    _SystemInformationUpdateRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SystemInformationUpdateRequest._cont = ASN1Dict([
        ('protocolIEs', _SystemInformationUpdateRequest_protocolIEs),
        ('protocolExtensions', _SystemInformationUpdateRequest_protocolExtensions),
        ])
    SystemInformationUpdateRequest._ext = []
    
    #-----< SystemInformationUpdateRequest-IEs >-----#
    SystemInformationUpdateRequest_IEs = CLASS(name='SystemInformationUpdateRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SystemInformationUpdateRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _SystemInformationUpdateRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BCCH-ModificationTime')))
    _SystemInformationUpdateRequest_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MIB-SB-SIB-InformationList-SystemInfoUpdateRqst')))
    SystemInformationUpdateRequest_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _SystemInformationUpdateRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _SystemInformationUpdateRequest_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'reject'), ('Value', _SystemInformationUpdateRequest_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SystemInformationUpdateRequest-Extensions >-----#
    SystemInformationUpdateRequest_Extensions = CLASS(name='SystemInformationUpdateRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _SystemInformationUpdateRequest_Extensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BCH-mappedOnSCCPCH-Indication')))
    SystemInformationUpdateRequest_Extensions._val = ASN1Set(rv=[dict([('id', 1291), ('criticality', 'reject'), ('Extension', _SystemInformationUpdateRequest_Extensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MIB-SB-SIB-InformationList-SystemInfoUpdateRqst >-----#
    MIB_SB_SIB_InformationList_SystemInfoUpdateRqst = SEQ_OF(name='MIB-SB-SIB-InformationList-SystemInfoUpdateRqst', mode=MODE_TYPE)
    _MIB_SB_SIB_InformationList_SystemInfoUpdateRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MIB-SB-SIB-InformationItem-SystemInfoUpdateRqst')))
    MIB_SB_SIB_InformationList_SystemInfoUpdateRqst._cont = _MIB_SB_SIB_InformationList_SystemInfoUpdateRqst__item_
    MIB_SB_SIB_InformationList_SystemInfoUpdateRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MIB-SB-SIB-InformationItem-SystemInfoUpdateRqst >-----#
    MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst = SEQ(name='MIB-SB-SIB-InformationItem-SystemInfoUpdateRqst', mode=MODE_TYPE)
    _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iB_Type = ENUM(name='iB-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IB-Type')))
    _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iB_OC_ID = INT(name='iB-OC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IB-OC-ID')))
    _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_deletionIndicator = CHOICE(name='deletionIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DeletionIndicator-SystemInfoUpdate')))
    _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__id._const_tab = ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__id_tab
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__id._const_tab_at = None
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__criticality._const_tab = ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__criticality_tab
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__extensionValue._const_tab = ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__extensionValue_tab
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__id),
        ('criticality', ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__extensionValue),
        ])
    __MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item_._ext = None
    _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions._cont = __MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item_
    _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst._cont = ASN1Dict([
        ('iB-Type', _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iB_Type),
        ('iB-OC-ID', _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iB_OC_ID),
        ('deletionIndicator', _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_deletionIndicator),
        ('iE-Extensions', _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions),
        ])
    MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst._ext = []
    
    #-----< MIB-SB-SIB-InformationItem-SystemInfoUpdateRqst-ExtIEs >-----#
    MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_ExtIEs = CLASS(name='MIB-SB-SIB-InformationItem-SystemInfoUpdateRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCH-mappedOnSCCPCH-Indication >-----#
    BCH_mappedOnSCCPCH_Indication = ENUM(name='BCH-mappedOnSCCPCH-Indication', mode=MODE_TYPE)
    BCH_mappedOnSCCPCH_Indication._cont = ASN1Dict([('inUse', 0)])
    BCH_mappedOnSCCPCH_Indication._ext = []
    
    #-----< DeletionIndicator-SystemInfoUpdate >-----#
    DeletionIndicator_SystemInfoUpdate = CHOICE(name='DeletionIndicator-SystemInfoUpdate', mode=MODE_TYPE)
    _DeletionIndicator_SystemInfoUpdate_no_Deletion = SEQ(name='no-Deletion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'No-Deletion-SystemInfoUpdate')))
    _DeletionIndicator_SystemInfoUpdate_yes_Deletion = NULL(name='yes-Deletion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DeletionIndicator_SystemInfoUpdate._cont = ASN1Dict([
        ('no-Deletion', _DeletionIndicator_SystemInfoUpdate_no_Deletion),
        ('yes-Deletion', _DeletionIndicator_SystemInfoUpdate_yes_Deletion),
        ])
    DeletionIndicator_SystemInfoUpdate._ext = None
    
    #-----< No-Deletion-SystemInfoUpdate >-----#
    No_Deletion_SystemInfoUpdate = SEQ(name='No-Deletion-SystemInfoUpdate', mode=MODE_TYPE)
    _No_Deletion_SystemInfoUpdate_sIB_Originator = ENUM(name='sIB-Originator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SIB-Originator')), opt=True)
    _No_Deletion_SystemInfoUpdate_iB_SG_REP = ENUM(name='iB-SG-REP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IB-SG-REP')), opt=True)
    _No_Deletion_SystemInfoUpdate_segmentInformationList = SEQ(name='segmentInformationList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SegmentInformationList-SystemInfoUpdate')))
    _No_Deletion_SystemInfoUpdate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __No_Deletion_SystemInfoUpdate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__id._const_tab = ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__id_tab
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__id._const_tab_at = None
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__id._const_tab_id = 'id'
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__criticality._const_tab = ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__criticality_tab
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__extensionValue._const_tab = ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__extensionValue_tab
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __No_Deletion_SystemInfoUpdate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__id),
        ('criticality', ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__criticality),
        ('extensionValue', ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__extensionValue),
        ])
    __No_Deletion_SystemInfoUpdate_iE_Extensions__item_._ext = None
    _No_Deletion_SystemInfoUpdate_iE_Extensions._cont = __No_Deletion_SystemInfoUpdate_iE_Extensions__item_
    _No_Deletion_SystemInfoUpdate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    No_Deletion_SystemInfoUpdate._cont = ASN1Dict([
        ('sIB-Originator', _No_Deletion_SystemInfoUpdate_sIB_Originator),
        ('iB-SG-REP', _No_Deletion_SystemInfoUpdate_iB_SG_REP),
        ('segmentInformationList', _No_Deletion_SystemInfoUpdate_segmentInformationList),
        ('iE-Extensions', _No_Deletion_SystemInfoUpdate_iE_Extensions),
        ])
    No_Deletion_SystemInfoUpdate._ext = []
    
    #-----< No-DeletionItem-SystemInfoUpdate-ExtIEs >-----#
    No_DeletionItem_SystemInfoUpdate_ExtIEs = CLASS(name='No-DeletionItem-SystemInfoUpdate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    No_DeletionItem_SystemInfoUpdate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SegmentInformationList-SystemInfoUpdate >-----#
    SegmentInformationList_SystemInfoUpdate = SEQ(name='SegmentInformationList-SystemInfoUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _SegmentInformationList_SystemInfoUpdate_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __SegmentInformationList_SystemInfoUpdate_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___SegmentInformationList_SystemInfoUpdate_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SegmentInformationListIE-SystemInfoUpdate')))
    __SegmentInformationList_SystemInfoUpdate_id_tab._val = ASN1Set(rv=[dict([('id', 266), ('criticality', 'reject'), ('Value', ___SegmentInformationList_SystemInfoUpdate_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _SegmentInformationList_SystemInfoUpdate_id._const_tab = __SegmentInformationList_SystemInfoUpdate_id_tab
    _SegmentInformationList_SystemInfoUpdate_id._const_tab_at = None
    _SegmentInformationList_SystemInfoUpdate_id._const_tab_id = 'id'
    _SegmentInformationList_SystemInfoUpdate_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _SegmentInformationList_SystemInfoUpdate_criticality._const_tab = __SegmentInformationList_SystemInfoUpdate_id_tab
    _SegmentInformationList_SystemInfoUpdate_criticality._const_tab_at = ('..', 'id')
    _SegmentInformationList_SystemInfoUpdate_criticality._const_tab_id = 'criticality'
    _SegmentInformationList_SystemInfoUpdate_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _SegmentInformationList_SystemInfoUpdate_value._const_tab = __SegmentInformationList_SystemInfoUpdate_id_tab
    _SegmentInformationList_SystemInfoUpdate_value._const_tab_at = ('..', 'id')
    _SegmentInformationList_SystemInfoUpdate_value._const_tab_id = 'Value'
    SegmentInformationList_SystemInfoUpdate._cont = ASN1Dict([
        ('id', _SegmentInformationList_SystemInfoUpdate_id),
        ('criticality', _SegmentInformationList_SystemInfoUpdate_criticality),
        ('value', _SegmentInformationList_SystemInfoUpdate_value),
        ])
    SegmentInformationList_SystemInfoUpdate._ext = None
    
    #-----< SegmentInformationListIEs-SystemInfoUpdate >-----#
    SegmentInformationListIEs_SystemInfoUpdate = CLASS(name='SegmentInformationListIEs-SystemInfoUpdate', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SegmentInformationListIEs_SystemInfoUpdate_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SegmentInformationListIE-SystemInfoUpdate')))
    SegmentInformationListIEs_SystemInfoUpdate._val = ASN1Set(rv=[dict([('id', 266), ('criticality', 'reject'), ('Value', _SegmentInformationListIEs_SystemInfoUpdate_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SegmentInformationListIE-SystemInfoUpdate >-----#
    SegmentInformationListIE_SystemInfoUpdate = SEQ_OF(name='SegmentInformationListIE-SystemInfoUpdate', mode=MODE_TYPE)
    _SegmentInformationListIE_SystemInfoUpdate__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SegmentInformationItem-SystemInfoUpdate')))
    SegmentInformationListIE_SystemInfoUpdate._cont = _SegmentInformationListIE_SystemInfoUpdate__item_
    SegmentInformationListIE_SystemInfoUpdate._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SegmentInformationItem-SystemInfoUpdate >-----#
    SegmentInformationItem_SystemInfoUpdate = SEQ(name='SegmentInformationItem-SystemInfoUpdate', mode=MODE_TYPE)
    _SegmentInformationItem_SystemInfoUpdate_iB_SG_POS = INT(name='iB-SG-POS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IB-SG-POS')), opt=True)
    _SegmentInformationItem_SystemInfoUpdate_segment_Type = ENUM(name='segment-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Segment-Type')), opt=True)
    _SegmentInformationItem_SystemInfoUpdate_iB_SG_DATA = BIT_STR(name='iB-SG-DATA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'IB-SG-DATA')), opt=True)
    _SegmentInformationItem_SystemInfoUpdate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__id._const_tab = ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__id_tab
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__id._const_tab_at = None
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__id._const_tab_id = 'id'
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__criticality._const_tab = ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__criticality_tab
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__extensionValue._const_tab = ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__extensionValue_tab
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__id),
        ('criticality', ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__criticality),
        ('extensionValue', ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__extensionValue),
        ])
    __SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item_._ext = None
    _SegmentInformationItem_SystemInfoUpdate_iE_Extensions._cont = __SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item_
    _SegmentInformationItem_SystemInfoUpdate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SegmentInformationItem_SystemInfoUpdate._cont = ASN1Dict([
        ('iB-SG-POS', _SegmentInformationItem_SystemInfoUpdate_iB_SG_POS),
        ('segment-Type', _SegmentInformationItem_SystemInfoUpdate_segment_Type),
        ('iB-SG-DATA', _SegmentInformationItem_SystemInfoUpdate_iB_SG_DATA),
        ('iE-Extensions', _SegmentInformationItem_SystemInfoUpdate_iE_Extensions),
        ])
    SegmentInformationItem_SystemInfoUpdate._ext = []
    
    #-----< SegmentInformationItem-SystemInfoUpdate-ExtIEs >-----#
    SegmentInformationItem_SystemInfoUpdate_ExtIEs = CLASS(name='SegmentInformationItem-SystemInfoUpdate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SegmentInformationItem_SystemInfoUpdate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SystemInformationUpdateResponse >-----#
    SystemInformationUpdateResponse = SEQ(name='SystemInformationUpdateResponse', mode=MODE_TYPE)
    _SystemInformationUpdateResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __SystemInformationUpdateResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___SystemInformationUpdateResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____SystemInformationUpdateResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____SystemInformationUpdateResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____SystemInformationUpdateResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____SystemInformationUpdateResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SystemInformationUpdateResponse_protocolIEs__item__id._const_tab = ____SystemInformationUpdateResponse_protocolIEs__item__id_tab
    ___SystemInformationUpdateResponse_protocolIEs__item__id._const_tab_at = None
    ___SystemInformationUpdateResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___SystemInformationUpdateResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___SystemInformationUpdateResponse_protocolIEs__item__criticality._const_tab = ____SystemInformationUpdateResponse_protocolIEs__item__id_tab
    ___SystemInformationUpdateResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SystemInformationUpdateResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___SystemInformationUpdateResponse_protocolIEs__item__value._const_tab = ____SystemInformationUpdateResponse_protocolIEs__item__id_tab
    ___SystemInformationUpdateResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __SystemInformationUpdateResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SystemInformationUpdateResponse_protocolIEs__item__id),
        ('criticality', ___SystemInformationUpdateResponse_protocolIEs__item__criticality),
        ('value', ___SystemInformationUpdateResponse_protocolIEs__item__value),
        ])
    __SystemInformationUpdateResponse_protocolIEs__item_._ext = None
    _SystemInformationUpdateResponse_protocolIEs._cont = __SystemInformationUpdateResponse_protocolIEs__item_
    _SystemInformationUpdateResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SystemInformationUpdateResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SystemInformationUpdateResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SystemInformationUpdateResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SystemInformationUpdateResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SystemInformationUpdateResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SystemInformationUpdateResponse_protocolExtensions__item__id._const_tab = ____SystemInformationUpdateResponse_protocolExtensions__item__id_tab
    ___SystemInformationUpdateResponse_protocolExtensions__item__id._const_tab_at = None
    ___SystemInformationUpdateResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___SystemInformationUpdateResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SystemInformationUpdateResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SystemInformationUpdateResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SystemInformationUpdateResponse_protocolExtensions__item__criticality._const_tab = ____SystemInformationUpdateResponse_protocolExtensions__item__criticality_tab
    ___SystemInformationUpdateResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SystemInformationUpdateResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SystemInformationUpdateResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SystemInformationUpdateResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SystemInformationUpdateResponse_protocolExtensions__item__extensionValue._const_tab = ____SystemInformationUpdateResponse_protocolExtensions__item__extensionValue_tab
    ___SystemInformationUpdateResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SystemInformationUpdateResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SystemInformationUpdateResponse_protocolExtensions__item__id),
        ('criticality', ___SystemInformationUpdateResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___SystemInformationUpdateResponse_protocolExtensions__item__extensionValue),
        ])
    __SystemInformationUpdateResponse_protocolExtensions__item_._ext = None
    _SystemInformationUpdateResponse_protocolExtensions._cont = __SystemInformationUpdateResponse_protocolExtensions__item_
    _SystemInformationUpdateResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SystemInformationUpdateResponse._cont = ASN1Dict([
        ('protocolIEs', _SystemInformationUpdateResponse_protocolIEs),
        ('protocolExtensions', _SystemInformationUpdateResponse_protocolExtensions),
        ])
    SystemInformationUpdateResponse._ext = []
    
    #-----< SystemInformationUpdateResponse-IEs >-----#
    SystemInformationUpdateResponse_IEs = CLASS(name='SystemInformationUpdateResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SystemInformationUpdateResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    SystemInformationUpdateResponse_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _SystemInformationUpdateResponse_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SystemInformationUpdateResponse-Extensions >-----#
    SystemInformationUpdateResponse_Extensions = CLASS(name='SystemInformationUpdateResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SystemInformationUpdateResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SystemInformationUpdateFailure >-----#
    SystemInformationUpdateFailure = SEQ(name='SystemInformationUpdateFailure', mode=MODE_TYPE)
    _SystemInformationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __SystemInformationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___SystemInformationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____SystemInformationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____SystemInformationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____SystemInformationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____SystemInformationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _____SystemInformationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____SystemInformationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SystemInformationUpdateFailure_protocolIEs__item__id._const_tab = ____SystemInformationUpdateFailure_protocolIEs__item__id_tab
    ___SystemInformationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___SystemInformationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___SystemInformationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___SystemInformationUpdateFailure_protocolIEs__item__criticality._const_tab = ____SystemInformationUpdateFailure_protocolIEs__item__id_tab
    ___SystemInformationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SystemInformationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___SystemInformationUpdateFailure_protocolIEs__item__value._const_tab = ____SystemInformationUpdateFailure_protocolIEs__item__id_tab
    ___SystemInformationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __SystemInformationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SystemInformationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___SystemInformationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___SystemInformationUpdateFailure_protocolIEs__item__value),
        ])
    __SystemInformationUpdateFailure_protocolIEs__item_._ext = None
    _SystemInformationUpdateFailure_protocolIEs._cont = __SystemInformationUpdateFailure_protocolIEs__item_
    _SystemInformationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SystemInformationUpdateFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SystemInformationUpdateFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SystemInformationUpdateFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SystemInformationUpdateFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SystemInformationUpdateFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SystemInformationUpdateFailure_protocolExtensions__item__id._const_tab = ____SystemInformationUpdateFailure_protocolExtensions__item__id_tab
    ___SystemInformationUpdateFailure_protocolExtensions__item__id._const_tab_at = None
    ___SystemInformationUpdateFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___SystemInformationUpdateFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SystemInformationUpdateFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SystemInformationUpdateFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SystemInformationUpdateFailure_protocolExtensions__item__criticality._const_tab = ____SystemInformationUpdateFailure_protocolExtensions__item__criticality_tab
    ___SystemInformationUpdateFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SystemInformationUpdateFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SystemInformationUpdateFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SystemInformationUpdateFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SystemInformationUpdateFailure_protocolExtensions__item__extensionValue._const_tab = ____SystemInformationUpdateFailure_protocolExtensions__item__extensionValue_tab
    ___SystemInformationUpdateFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SystemInformationUpdateFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SystemInformationUpdateFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SystemInformationUpdateFailure_protocolExtensions__item__id),
        ('criticality', ___SystemInformationUpdateFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___SystemInformationUpdateFailure_protocolExtensions__item__extensionValue),
        ])
    __SystemInformationUpdateFailure_protocolExtensions__item_._ext = None
    _SystemInformationUpdateFailure_protocolExtensions._cont = __SystemInformationUpdateFailure_protocolExtensions__item_
    _SystemInformationUpdateFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SystemInformationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _SystemInformationUpdateFailure_protocolIEs),
        ('protocolExtensions', _SystemInformationUpdateFailure_protocolExtensions),
        ])
    SystemInformationUpdateFailure._ext = []
    
    #-----< SystemInformationUpdateFailure-IEs >-----#
    SystemInformationUpdateFailure_IEs = CLASS(name='SystemInformationUpdateFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SystemInformationUpdateFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _SystemInformationUpdateFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    SystemInformationUpdateFailure_IEs._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _SystemInformationUpdateFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _SystemInformationUpdateFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SystemInformationUpdateFailure-Extensions >-----#
    SystemInformationUpdateFailure_Extensions = CLASS(name='SystemInformationUpdateFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SystemInformationUpdateFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupRequestFDD >-----#
    RadioLinkSetupRequestFDD = SEQ(name='RadioLinkSetupRequestFDD', mode=MODE_TYPE)
    _RadioLinkSetupRequestFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupRequestFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-Information-RL-SetupRqstFDD')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-Information-RL-SetupRqstFDD')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-FDD-Information')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-SetupRqstFDD')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Active-Pattern-Sequence-Information')))
    ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'reject'), ('Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'reject'), ('Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 56), ('criticality', 'reject'), ('Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 216), ('criticality', 'notify'), ('Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 315), ('criticality', 'reject'), ('Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupRequestFDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupRequestFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupRequestFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkSetupRequestFDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkSetupRequestFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkSetupRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupRequestFDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkSetupRequestFDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupRequestFDD_protocolIEs__item_._ext = None
    _RadioLinkSetupRequestFDD_protocolIEs._cont = __RadioLinkSetupRequestFDD_protocolIEs__item_
    _RadioLinkSetupRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupRequestFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DPCH-Information-RL-SetupRqstFDD')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_6 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Serving-E-DCH-RL-ID')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'F-DPCH-Information-RL-SetupRqstFDD')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Initial-DL-DPCH-TimingAdjustment-Allowed')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-Indicator-For-E-DCH-HSDPA-Operation')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_10 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_12 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Setup-List')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Setup-Info')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Usefulness-Of-Battery-Optimization')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_18 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Decoupling-Indication')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_19 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-ENH-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_20 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_21 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH2-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_22 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Downlink-TPC-enhancements-Information')))
    ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 28), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 530), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'conditional')]), dict([('id', 677), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 667), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'conditional')]), dict([('id', 679), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 632), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 652), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 822), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 702), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 832), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 834), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 1037), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 1092), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 1120), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 1197), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 1208), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_17), ('presence', 'optional')]), dict([('id', 1295), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 1292), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_19), ('presence', 'optional')]), dict([('id', 1296), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_20), ('presence', 'optional')]), dict([('id', 1297), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_21), ('presence', 'optional')]), dict([('id', 1307), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_22), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkSetupRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupRequestFDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupRequestFDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupRequestFDD_protocolExtensions._cont = __RadioLinkSetupRequestFDD_protocolExtensions__item_
    _RadioLinkSetupRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupRequestFDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkSetupRequestFDD_protocolIEs),
        ('protocolExtensions', _RadioLinkSetupRequestFDD_protocolExtensions),
        ])
    RadioLinkSetupRequestFDD._ext = []
    
    #-----< RadioLinkSetupRequestFDD-IEs >-----#
    RadioLinkSetupRequestFDD_IEs = CLASS(name='RadioLinkSetupRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-Information-RL-SetupRqstFDD')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-Information-RL-SetupRqstFDD')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-FDD-Information')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-SetupRqstFDD')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Active-Pattern-Sequence-Information')))
    RadioLinkSetupRequestFDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'reject'), ('Value', _RadioLinkSetupRequestFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _RadioLinkSetupRequestFDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'reject'), ('Value', _RadioLinkSetupRequestFDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 56), ('criticality', 'reject'), ('Value', _RadioLinkSetupRequestFDD_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 216), ('criticality', 'notify'), ('Value', _RadioLinkSetupRequestFDD_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _RadioLinkSetupRequestFDD_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 315), ('criticality', 'reject'), ('Value', _RadioLinkSetupRequestFDD_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupRequestFDD-Extensions >-----#
    RadioLinkSetupRequestFDD_Extensions = CLASS(name='RadioLinkSetupRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DPCH-Information-RL-SetupRqstFDD')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_6 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Serving-E-DCH-RL-ID')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'F-DPCH-Information-RL-SetupRqstFDD')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Initial-DL-DPCH-TimingAdjustment-Allowed')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-Indicator-For-E-DCH-HSDPA-Operation')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_10 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityDTX-DRX-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_12 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_13 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Setup-List')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Setup-Info')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Usefulness-Of-Battery-Optimization')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_18 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Decoupling-Indication')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_19 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-ENH-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_20 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_21 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH2-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_22 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Downlink-TPC-enhancements-Information')))
    RadioLinkSetupRequestFDD_Extensions._val = ASN1Set(rv=[dict([('id', 28), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 530), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_2), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_3), ('presence', 'conditional')]), dict([('id', 677), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 667), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_5), ('presence', 'conditional')]), dict([('id', 679), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 632), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 652), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 822), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 702), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 832), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 834), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 1037), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 1092), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 1120), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_15), ('presence', 'optional')]), dict([('id', 1197), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_16), ('presence', 'optional')]), dict([('id', 1208), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_17), ('presence', 'optional')]), dict([('id', 1295), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_18), ('presence', 'optional')]), dict([('id', 1292), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_19), ('presence', 'optional')]), dict([('id', 1296), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_20), ('presence', 'optional')]), dict([('id', 1297), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_21), ('presence', 'optional')]), dict([('id', 1307), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_22), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Setup-List >-----#
    Additional_HS_Cell_Information_RL_Setup_List = SEQ_OF(name='Additional-HS-Cell-Information-RL-Setup-List', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Setup-ItemIEs')))
    Additional_HS_Cell_Information_RL_Setup_List._cont = _Additional_HS_Cell_Information_RL_Setup_List__item_
    Additional_HS_Cell_Information_RL_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Setup-ItemIEs >-----#
    Additional_HS_Cell_Information_RL_Setup_ItemIEs = SEQ(name='Additional-HS-Cell-Information-RL-Setup-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hSPDSCH_RL_ID = INT(name='hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information = SEQ(name='hS-DSCH-FDD-Secondary-Serving-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information')))
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_RL_Setup_ItemIEs._cont = ASN1Dict([
        ('hSPDSCH-RL-ID', _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hSPDSCH_RL_ID),
        ('c-ID', _Additional_HS_Cell_Information_RL_Setup_ItemIEs_c_ID),
        ('hS-DSCH-FDD-Secondary-Serving-Information', _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information),
        ('iE-Extensions', _Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_RL_Setup_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-RL-Setup-ItemIEs-ExtIEs >-----#
    Additional_HS_Cell_Information_RL_Setup_ItemIEs_ExtIEs = CLASS(name='Additional-HS-Cell-Information-RL-Setup-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_RL_Setup_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-Information-RL-SetupRqstFDD >-----#
    UL_DPCH_Information_RL_SetupRqstFDD = SEQ(name='UL-DPCH-Information-RL-SetupRqstFDD', mode=MODE_TYPE)
    _UL_DPCH_Information_RL_SetupRqstFDD_ul_ScramblingCode = SEQ(name='ul-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-ScramblingCode')))
    _UL_DPCH_Information_RL_SetupRqstFDD_minUL_ChannelisationCodeLength = ENUM(name='minUL-ChannelisationCodeLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MinUL-ChannelisationCodeLength')))
    _UL_DPCH_Information_RL_SetupRqstFDD_maxNrOfUL_DPDCHs = INT(name='maxNrOfUL-DPDCHs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaxNrOfUL-DPDCHs')), opt=True)
    _UL_DPCH_Information_RL_SetupRqstFDD_ul_PunctureLimit = INT(name='ul-PunctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')))
    _UL_DPCH_Information_RL_SetupRqstFDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _UL_DPCH_Information_RL_SetupRqstFDD_ul_DPCCH_SlotFormat = INT(name='ul-DPCCH-SlotFormat', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH-SlotFormat')))
    _UL_DPCH_Information_RL_SetupRqstFDD_ul_SIR_Target = INT(name='ul-SIR-Target', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _UL_DPCH_Information_RL_SetupRqstFDD_diversityMode = ENUM(name='diversityMode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DiversityMode')))
    _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_sSDT_CellID_Length = NULL(name='not-Used-sSDT-CellID-Length', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_s_FieldLength = NULL(name='not-Used-s-FieldLength', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DPC-Mode')))
    _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPDCH-Indicator-For-E-DCH-Operation')))
    ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 450), ('criticality', 'reject'), ('Extension', _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 680), ('criticality', 'reject'), ('Extension', _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._cont = __UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_
    _UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_Information_RL_SetupRqstFDD._cont = ASN1Dict([
        ('ul-ScramblingCode', _UL_DPCH_Information_RL_SetupRqstFDD_ul_ScramblingCode),
        ('minUL-ChannelisationCodeLength', _UL_DPCH_Information_RL_SetupRqstFDD_minUL_ChannelisationCodeLength),
        ('maxNrOfUL-DPDCHs', _UL_DPCH_Information_RL_SetupRqstFDD_maxNrOfUL_DPDCHs),
        ('ul-PunctureLimit', _UL_DPCH_Information_RL_SetupRqstFDD_ul_PunctureLimit),
        ('tFCS', _UL_DPCH_Information_RL_SetupRqstFDD_tFCS),
        ('ul-DPCCH-SlotFormat', _UL_DPCH_Information_RL_SetupRqstFDD_ul_DPCCH_SlotFormat),
        ('ul-SIR-Target', _UL_DPCH_Information_RL_SetupRqstFDD_ul_SIR_Target),
        ('diversityMode', _UL_DPCH_Information_RL_SetupRqstFDD_diversityMode),
        ('not-Used-sSDT-CellID-Length', _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_sSDT_CellID_Length),
        ('not-Used-s-FieldLength', _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_s_FieldLength),
        ('iE-Extensions', _UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions),
        ])
    UL_DPCH_Information_RL_SetupRqstFDD._ext = []
    
    #-----< UL-DPCH-Information-RL-SetupRqstFDD-ExtIEs >-----#
    UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs = CLASS(name='UL-DPCH-Information-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DPC-Mode')))
    _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPDCH-Indicator-For-E-DCH-Operation')))
    UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 450), ('criticality', 'reject'), ('Extension', _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 680), ('criticality', 'reject'), ('Extension', _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-Information-RL-SetupRqstFDD >-----#
    DL_DPCH_Information_RL_SetupRqstFDD = SEQ(name='DL-DPCH-Information-RL-SetupRqstFDD', mode=MODE_TYPE)
    _DL_DPCH_Information_RL_SetupRqstFDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _DL_DPCH_Information_RL_SetupRqstFDD_dl_DPCH_SlotFormat = INT(name='dl-DPCH-SlotFormat', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-SlotFormat')))
    _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_SignallingMode = SEQ(name='tFCI-SignallingMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-SignallingMode')))
    _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_DPCH_Information_RL_SetupRqstFDD_multiplexingPosition = ENUM(name='multiplexingPosition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MultiplexingPosition')))
    _DL_DPCH_Information_RL_SetupRqstFDD_not_Used_pDSCH_RL_ID = NULL(name='not-Used-pDSCH-RL-ID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DL_DPCH_Information_RL_SetupRqstFDD_not_Used_pDSCH_CodeMapping = NULL(name='not-Used-pDSCH-CodeMapping', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DL_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation = SEQ(name='powerOffsetInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PowerOffsetInformation-RL-SetupRqstFDD')))
    _DL_DPCH_Information_RL_SetupRqstFDD_fdd_TPC_DownlinkStepSize = ENUM(name='fdd-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-TPC-DownlinkStepSize')))
    _DL_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease = ENUM(name='limitedPowerIncrease', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LimitedPowerIncrease')))
    _DL_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus = ENUM(name='innerLoopDLPCStatus', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InnerLoopDLPCStatus')))
    _DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._cont = __DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_
    _DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_Information_RL_SetupRqstFDD._cont = ASN1Dict([
        ('tFCS', _DL_DPCH_Information_RL_SetupRqstFDD_tFCS),
        ('dl-DPCH-SlotFormat', _DL_DPCH_Information_RL_SetupRqstFDD_dl_DPCH_SlotFormat),
        ('tFCI-SignallingMode', _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_SignallingMode),
        ('tFCI-Presence', _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_Presence),
        ('multiplexingPosition', _DL_DPCH_Information_RL_SetupRqstFDD_multiplexingPosition),
        ('not-Used-pDSCH-RL-ID', _DL_DPCH_Information_RL_SetupRqstFDD_not_Used_pDSCH_RL_ID),
        ('not-Used-pDSCH-CodeMapping', _DL_DPCH_Information_RL_SetupRqstFDD_not_Used_pDSCH_CodeMapping),
        ('powerOffsetInformation', _DL_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation),
        ('fdd-TPC-DownlinkStepSize', _DL_DPCH_Information_RL_SetupRqstFDD_fdd_TPC_DownlinkStepSize),
        ('limitedPowerIncrease', _DL_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease),
        ('innerLoopDLPCStatus', _DL_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus),
        ('iE-Extensions', _DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions),
        ])
    DL_DPCH_Information_RL_SetupRqstFDD._ext = []
    
    #-----< DL-DPCH-Information-RL-SetupRqstFDD-ExtIEs >-----#
    DL_DPCH_Information_RL_SetupRqstFDD_ExtIEs = CLASS(name='DL-DPCH-Information-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_Information_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PowerOffsetInformation-RL-SetupRqstFDD >-----#
    PowerOffsetInformation_RL_SetupRqstFDD = SEQ(name='PowerOffsetInformation-RL-SetupRqstFDD', mode=MODE_TYPE)
    _PowerOffsetInformation_RL_SetupRqstFDD_pO1_ForTFCI_Bits = INT(name='pO1-ForTFCI-Bits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_SetupRqstFDD_pO2_ForTPC_Bits = INT(name='pO2-ForTPC-Bits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_SetupRqstFDD_pO3_ForPilotBits = INT(name='pO3-ForPilotBits', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions._cont = __PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item_
    _PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerOffsetInformation_RL_SetupRqstFDD._cont = ASN1Dict([
        ('pO1-ForTFCI-Bits', _PowerOffsetInformation_RL_SetupRqstFDD_pO1_ForTFCI_Bits),
        ('pO2-ForTPC-Bits', _PowerOffsetInformation_RL_SetupRqstFDD_pO2_ForTPC_Bits),
        ('pO3-ForPilotBits', _PowerOffsetInformation_RL_SetupRqstFDD_pO3_ForPilotBits),
        ('iE-Extensions', _PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions),
        ])
    PowerOffsetInformation_RL_SetupRqstFDD._ext = []
    
    #-----< PowerOffsetInformation-RL-SetupRqstFDD-ExtIEs >-----#
    PowerOffsetInformation_RL_SetupRqstFDD_ExtIEs = CLASS(name='PowerOffsetInformation-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PowerOffsetInformation_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-SetupRqstFDD >-----#
    RL_InformationList_RL_SetupRqstFDD = SEQ_OF(name='RL-InformationList-RL-SetupRqstFDD', mode=MODE_TYPE)
    _RL_InformationList_RL_SetupRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_SetupRqstFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationList_RL_SetupRqstFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_SetupRqstFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-SetupRqstFDD')))
    ___RL_InformationList_RL_SetupRqstFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 211), ('criticality', 'notify'), ('Value', ____RL_InformationList_RL_SetupRqstFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_SetupRqstFDD__item__id._const_tab = ___RL_InformationList_RL_SetupRqstFDD__item__id_tab
    __RL_InformationList_RL_SetupRqstFDD__item__id._const_tab_at = None
    __RL_InformationList_RL_SetupRqstFDD__item__id._const_tab_id = 'id'
    __RL_InformationList_RL_SetupRqstFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationList_RL_SetupRqstFDD__item__criticality._const_tab = ___RL_InformationList_RL_SetupRqstFDD__item__id_tab
    __RL_InformationList_RL_SetupRqstFDD__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_SetupRqstFDD__item__criticality._const_tab_id = 'criticality'
    __RL_InformationList_RL_SetupRqstFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationList_RL_SetupRqstFDD__item__value._const_tab = ___RL_InformationList_RL_SetupRqstFDD__item__id_tab
    __RL_InformationList_RL_SetupRqstFDD__item__value._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_SetupRqstFDD__item__value._const_tab_id = 'Value'
    _RL_InformationList_RL_SetupRqstFDD__item_._cont = ASN1Dict([
        ('id', __RL_InformationList_RL_SetupRqstFDD__item__id),
        ('criticality', __RL_InformationList_RL_SetupRqstFDD__item__criticality),
        ('value', __RL_InformationList_RL_SetupRqstFDD__item__value),
        ])
    _RL_InformationList_RL_SetupRqstFDD__item_._ext = None
    RL_InformationList_RL_SetupRqstFDD._cont = _RL_InformationList_RL_SetupRqstFDD__item_
    RL_InformationList_RL_SetupRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIE-RL-SetupRqstFDD >-----#
    RL_InformationItemIE_RL_SetupRqstFDD = CLASS(name='RL-InformationItemIE-RL-SetupRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationItemIE_RL_SetupRqstFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-SetupRqstFDD')))
    RL_InformationItemIE_RL_SetupRqstFDD._val = ASN1Set(rv=[dict([('id', 211), ('criticality', 'notify'), ('Value', _RL_InformationItemIE_RL_SetupRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-RL-SetupRqstFDD >-----#
    RL_InformationItem_RL_SetupRqstFDD = SEQ(name='RL-InformationItem-RL-SetupRqstFDD', mode=MODE_TYPE)
    _RL_InformationItem_RL_SetupRqstFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationItem_RL_SetupRqstFDD_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _RL_InformationItem_RL_SetupRqstFDD_firstRLS_indicator = ENUM(name='firstRLS-indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FirstRLS-Indicator')))
    _RL_InformationItem_RL_SetupRqstFDD_frameOffset = INT(name='frameOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FrameOffset')))
    _RL_InformationItem_RL_SetupRqstFDD_chipOffset = INT(name='chipOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ChipOffset')))
    _RL_InformationItem_RL_SetupRqstFDD_propagationDelay = INT(name='propagationDelay', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PropagationDelay')), opt=True)
    _RL_InformationItem_RL_SetupRqstFDD_diversityControlField = ENUM(name='diversityControlField', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DiversityControlField')), opt=True)
    _RL_InformationItem_RL_SetupRqstFDD_dl_CodeInformation = SEQ_OF(name='dl-CodeInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-CodeInformation')))
    _RL_InformationItem_RL_SetupRqstFDD_initialDL_transmissionPower = INT(name='initialDL-transmissionPower', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _RL_InformationItem_RL_SetupRqstFDD_maximumDL_power = INT(name='maximumDL-power', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _RL_InformationItem_RL_SetupRqstFDD_minimumDL_power = INT(name='minimumDL-power', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _RL_InformationItem_RL_SetupRqstFDD_not_Used_sSDT_Cell_Identity = NULL(name='not-Used-sSDT-Cell-Identity', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationItem_RL_SetupRqstFDD_transmitDiversityIndicator = ENUM(name='transmitDiversityIndicator', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransmitDiversityIndicator')), opt=True)
    _RL_InformationItem_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DelayedActivation')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Primary-CPICH-Usage-for-Channel-Estimation')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RL-Indication')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-E-DCH-Info')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationIndicator')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ExtendedPropagationDelay')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_10 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 594), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 600), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 674), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 686), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 657), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 819), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 870), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1033), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 998), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 1174), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 1215), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _RL_InformationItem_RL_SetupRqstFDD_iE_Extensions._cont = __RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item_
    _RL_InformationItem_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_RL_SetupRqstFDD._cont = ASN1Dict([
        ('rL-ID', _RL_InformationItem_RL_SetupRqstFDD_rL_ID),
        ('c-ID', _RL_InformationItem_RL_SetupRqstFDD_c_ID),
        ('firstRLS-indicator', _RL_InformationItem_RL_SetupRqstFDD_firstRLS_indicator),
        ('frameOffset', _RL_InformationItem_RL_SetupRqstFDD_frameOffset),
        ('chipOffset', _RL_InformationItem_RL_SetupRqstFDD_chipOffset),
        ('propagationDelay', _RL_InformationItem_RL_SetupRqstFDD_propagationDelay),
        ('diversityControlField', _RL_InformationItem_RL_SetupRqstFDD_diversityControlField),
        ('dl-CodeInformation', _RL_InformationItem_RL_SetupRqstFDD_dl_CodeInformation),
        ('initialDL-transmissionPower', _RL_InformationItem_RL_SetupRqstFDD_initialDL_transmissionPower),
        ('maximumDL-power', _RL_InformationItem_RL_SetupRqstFDD_maximumDL_power),
        ('minimumDL-power', _RL_InformationItem_RL_SetupRqstFDD_minimumDL_power),
        ('not-Used-sSDT-Cell-Identity', _RL_InformationItem_RL_SetupRqstFDD_not_Used_sSDT_Cell_Identity),
        ('transmitDiversityIndicator', _RL_InformationItem_RL_SetupRqstFDD_transmitDiversityIndicator),
        ('iE-Extensions', _RL_InformationItem_RL_SetupRqstFDD_iE_Extensions),
        ])
    RL_InformationItem_RL_SetupRqstFDD._ext = []
    
    #-----< RL-InformationItem-RL-SetupRqstFDD-ExtIEs >-----#
    RL_InformationItem_RL_SetupRqstFDD_ExtIEs = CLASS(name='RL-InformationItem-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DelayedActivation')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Primary-CPICH-Usage-for-Channel-Estimation')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RL-Indication')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-E-DCH-Info')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationIndicator')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ExtendedPropagationDelay')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_10 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    RL_InformationItem_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 594), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 600), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 674), ('criticality', 'reject'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 686), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 657), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 819), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 870), ('criticality', 'reject'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 1033), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 998), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 1174), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 1215), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_13), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DPCH-Information-RL-SetupRqstFDD >-----#
    E_DPCH_Information_RL_SetupRqstFDD = SEQ(name='E-DPCH-Information-RL-SetupRqstFDD', mode=MODE_TYPE)
    _E_DPCH_Information_RL_SetupRqstFDD_maxSet_E_DPDCHs = ENUM(name='maxSet-E-DPDCHs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-Set-E-DPDCHs')))
    _E_DPCH_Information_RL_SetupRqstFDD_ul_PunctureLimit = INT(name='ul-PunctureLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')))
    _E_DPCH_Information_RL_SetupRqstFDD_e_TFCS_Information = SEQ(name='e-TFCS-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information')))
    _E_DPCH_Information_RL_SetupRqstFDD_e_TTI = ENUM(name='e-TTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TTI')))
    _E_DPCH_Information_RL_SetupRqstFDD_e_DPCCH_PO = INT(name='e-DPCCH-PO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-PO')))
    _E_DPCH_Information_RL_SetupRqstFDD_e_RGCH_2_IndexStepThreshold = INT(name='e-RGCH-2-IndexStepThreshold', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-2-IndexStepThreshold')))
    _E_DPCH_Information_RL_SetupRqstFDD_e_RGCH_3_IndexStepThreshold = INT(name='e-RGCH-3-IndexStepThreshold', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-3-IndexStepThreshold')))
    _E_DPCH_Information_RL_SetupRqstFDD_hARQ_Info_for_E_DCH = ENUM(name='hARQ-Info-for-E-DCH', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Info-for-E-DCH')))
    _E_DPCH_Information_RL_SetupRqstFDD_hSDSCH_Configured_Indicator = ENUM(name='hSDSCH-Configured-Indicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Configured-Indicator')))
    _E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    ____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 998), ('criticality', 'reject'), ('Extension', _____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 999), ('criticality', 'ignore'), ('Extension', _____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._cont = __E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_
    _E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DPCH_Information_RL_SetupRqstFDD._cont = ASN1Dict([
        ('maxSet-E-DPDCHs', _E_DPCH_Information_RL_SetupRqstFDD_maxSet_E_DPDCHs),
        ('ul-PunctureLimit', _E_DPCH_Information_RL_SetupRqstFDD_ul_PunctureLimit),
        ('e-TFCS-Information', _E_DPCH_Information_RL_SetupRqstFDD_e_TFCS_Information),
        ('e-TTI', _E_DPCH_Information_RL_SetupRqstFDD_e_TTI),
        ('e-DPCCH-PO', _E_DPCH_Information_RL_SetupRqstFDD_e_DPCCH_PO),
        ('e-RGCH-2-IndexStepThreshold', _E_DPCH_Information_RL_SetupRqstFDD_e_RGCH_2_IndexStepThreshold),
        ('e-RGCH-3-IndexStepThreshold', _E_DPCH_Information_RL_SetupRqstFDD_e_RGCH_3_IndexStepThreshold),
        ('hARQ-Info-for-E-DCH', _E_DPCH_Information_RL_SetupRqstFDD_hARQ_Info_for_E_DCH),
        ('hSDSCH-Configured-Indicator', _E_DPCH_Information_RL_SetupRqstFDD_hSDSCH_Configured_Indicator),
        ('iE-Extensions', _E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions),
        ])
    E_DPCH_Information_RL_SetupRqstFDD._ext = []
    
    #-----< E-DPCH-Information-RL-SetupRqstFDD-ExtIEs >-----#
    E_DPCH_Information_RL_SetupRqstFDD_ExtIEs = CLASS(name='E-DPCH-Information-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _E_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    E_DPCH_Information_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 998), ('criticality', 'reject'), ('Extension', _E_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 999), ('criticality', 'ignore'), ('Extension', _E_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< F-DPCH-Information-RL-SetupRqstFDD >-----#
    F_DPCH_Information_RL_SetupRqstFDD = SEQ(name='F-DPCH-Information-RL-SetupRqstFDD', mode=MODE_TYPE)
    _F_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation = SEQ(name='powerOffsetInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD')))
    _F_DPCH_Information_RL_SetupRqstFDD_fdd_TPC_DownlinkStepSize = ENUM(name='fdd-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-TPC-DownlinkStepSize')))
    _F_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease = ENUM(name='limitedPowerIncrease', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LimitedPowerIncrease')))
    _F_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus = ENUM(name='innerLoopDLPCStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InnerLoopDLPCStatus')))
    _F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._cont = __F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_
    _F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    F_DPCH_Information_RL_SetupRqstFDD._cont = ASN1Dict([
        ('powerOffsetInformation', _F_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation),
        ('fdd-TPC-DownlinkStepSize', _F_DPCH_Information_RL_SetupRqstFDD_fdd_TPC_DownlinkStepSize),
        ('limitedPowerIncrease', _F_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease),
        ('innerLoopDLPCStatus', _F_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus),
        ('iE-Extensions', _F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions),
        ])
    F_DPCH_Information_RL_SetupRqstFDD._ext = []
    
    #-----< F-DPCH-Information-RL-SetupRqstFDD-ExtIEs >-----#
    F_DPCH_Information_RL_SetupRqstFDD_ExtIEs = CLASS(name='F-DPCH-Information-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    F_DPCH_Information_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD >-----#
    PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD = SEQ(name='PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD', mode=MODE_TYPE)
    _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_pO2_ForTPC_Bits = INT(name='pO2-ForTPC-Bits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id),
        ('criticality', ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions._cont = __PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item_
    _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD._cont = ASN1Dict([
        ('pO2-ForTPC-Bits', _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_pO2_ForTPC_Bits),
        ('iE-Extensions', _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions),
        ])
    PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD._ext = []
    
    #-----< PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD-ExtIEs >-----#
    PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_ExtIEs = CLASS(name='PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupRequestTDD >-----#
    RadioLinkSetupRequestTDD = SEQ(name='RadioLinkSetupRequestTDD', mode=MODE_TYPE)
    _RadioLinkSetupRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationList-RL-SetupRqstTDD')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationList-RL-SetupRqstTDD')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-TDD-Information')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-TDD-Information')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-Information')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Information-RL-SetupRqstTDD')))
    ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'reject'), ('Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'notify'), ('Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 76), ('criticality', 'notify'), ('Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 57), ('criticality', 'reject'), ('Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 310), ('criticality', 'reject'), ('Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 230), ('criticality', 'reject'), ('Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupRequestTDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkSetupRequestTDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkSetupRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkSetupRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupRequestTDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkSetupRequestTDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupRequestTDD_protocolIEs__item_._ext = None
    _RadioLinkSetupRequestTDD_protocolIEs._cont = __RadioLinkSetupRequestTDD_protocolIEs__item_
    _RadioLinkSetupRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-768-Information')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LCR-Information')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-InformationLCR')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-LCR')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-LCR')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IdleIntervalInformation')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_13 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Selected-MBMS-Service-Information')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_16 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Info')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_18 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-InformationLCR')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 536), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'conditional')]), dict([('id', 66), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 799), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 809), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 813), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 847), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 941), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1054), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1049), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 1048), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 1063), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 1074), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 1154), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 1167), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 1149), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 1187), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_17), ('presence', 'optional')]), dict([('id', 1192), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 1258), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_19), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkSetupRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupRequestTDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupRequestTDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupRequestTDD_protocolExtensions._cont = __RadioLinkSetupRequestTDD_protocolExtensions__item_
    _RadioLinkSetupRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkSetupRequestTDD_protocolIEs),
        ('protocolExtensions', _RadioLinkSetupRequestTDD_protocolExtensions),
        ])
    RadioLinkSetupRequestTDD._ext = []
    
    #-----< RadioLinkSetupRequestTDD-IEs >-----#
    RadioLinkSetupRequestTDD_IEs = CLASS(name='RadioLinkSetupRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationList-RL-SetupRqstTDD')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationList-RL-SetupRqstTDD')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-TDD-Information')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-TDD-Information')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-Information')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Information-RL-SetupRqstTDD')))
    RadioLinkSetupRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'reject'), ('Value', _RadioLinkSetupRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'notify'), ('Value', _RadioLinkSetupRequestTDD_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 76), ('criticality', 'notify'), ('Value', _RadioLinkSetupRequestTDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 57), ('criticality', 'reject'), ('Value', _RadioLinkSetupRequestTDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _RadioLinkSetupRequestTDD_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 310), ('criticality', 'reject'), ('Value', _RadioLinkSetupRequestTDD_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 230), ('criticality', 'reject'), ('Value', _RadioLinkSetupRequestTDD_IEs_val_Value_6), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupRequestTDD-Extensions >-----#
    RadioLinkSetupRequestTDD_Extensions = CLASS(name='RadioLinkSetupRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-768-Information')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LCR-Information')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-InformationLCR')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-LCR')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-LCR')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IdleIntervalInformation')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_13 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Selected-MBMS-Service-Information')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_15 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_16 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Info')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_18 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-InformationLCR')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    RadioLinkSetupRequestTDD_Extensions._val = ASN1Set(rv=[dict([('id', 536), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_1), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_2), ('presence', 'conditional')]), dict([('id', 66), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 799), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 809), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 813), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 847), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 941), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 1054), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 1049), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 1048), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 1063), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 1074), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 1154), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 1167), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_15), ('presence', 'optional')]), dict([('id', 1149), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_16), ('presence', 'optional')]), dict([('id', 1187), ('criticality', 'reject'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_17), ('presence', 'optional')]), dict([('id', 1192), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_18), ('presence', 'optional')]), dict([('id', 1258), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_19), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationList-RL-SetupRqstTDD >-----#
    UL_CCTrCH_InformationList_RL_SetupRqstTDD = SEQ_OF(name='UL-CCTrCH-InformationList-RL-SetupRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationList_RL_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationItem-RL-SetupRqstTDD')))
    ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 284), ('criticality', 'notify'), ('Value', ____UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab = ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab_at = None
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab_id = 'id'
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab = ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab_at = ('..', 'id')
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab_id = 'criticality'
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab = ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab_at = ('..', 'id')
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab_id = 'Value'
    _UL_CCTrCH_InformationList_RL_SetupRqstTDD__item_._cont = ASN1Dict([
        ('id', __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id),
        ('criticality', __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality),
        ('value', __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value),
        ])
    _UL_CCTrCH_InformationList_RL_SetupRqstTDD__item_._ext = None
    UL_CCTrCH_InformationList_RL_SetupRqstTDD._cont = _UL_CCTrCH_InformationList_RL_SetupRqstTDD__item_
    UL_CCTrCH_InformationList_RL_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationItemIE-RL-SetupRqstTDD >-----#
    UL_CCTrCH_InformationItemIE_RL_SetupRqstTDD = CLASS(name='UL-CCTrCH-InformationItemIE-RL-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UL_CCTrCH_InformationItemIE_RL_SetupRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationItem-RL-SetupRqstTDD')))
    UL_CCTrCH_InformationItemIE_RL_SetupRqstTDD._val = ASN1Set(rv=[dict([('id', 284), ('criticality', 'notify'), ('Value', _UL_CCTrCH_InformationItemIE_RL_SetupRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationItem-RL-SetupRqstTDD >-----#
    UL_CCTrCH_InformationItem_RL_SetupRqstTDD = SEQ(name='UL-CCTrCH-InformationItem-RL-SetupRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding = ENUM(name='tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Coding')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_punctureLimit = INT(name='punctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_uL_DPCH_Information = SEQ(name='uL-DPCH-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-Information-RL-SetupRqstTDD')), opt=True)
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-LCR-Information-RL-SetupRqstTDD')))
    _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-768-Information-RL-SetupRqstTDD')))
    ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 470), ('criticality', 'notify'), ('Extension', _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 510), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 560), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 745), ('criticality', 'notify'), ('Extension', _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._cont = __UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationItem_RL_SetupRqstTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID),
        ('tFCS', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCS),
        ('tFCI-Coding', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding),
        ('punctureLimit', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_punctureLimit),
        ('uL-DPCH-Information', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_uL_DPCH_Information),
        ('iE-Extensions', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationItem_RL_SetupRqstTDD._ext = []
    
    #-----< UL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name='UL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-LCR-Information-RL-SetupRqstTDD')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-768-Information-RL-SetupRqstTDD')))
    UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 470), ('criticality', 'notify'), ('Extension', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 510), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 560), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 745), ('criticality', 'notify'), ('Extension', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-Information-RL-SetupRqstTDD >-----#
    UL_DPCH_Information_RL_SetupRqstTDD = SEQ(name='UL-DPCH-Information-RL-SetupRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_Information_RL_SetupRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __UL_DPCH_Information_RL_SetupRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___UL_DPCH_Information_RL_SetupRqstTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-SetupRqstTDD')))
    __UL_DPCH_Information_RL_SetupRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 291), ('criticality', 'notify'), ('Value', ___UL_DPCH_Information_RL_SetupRqstTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_Information_RL_SetupRqstTDD_id._const_tab = __UL_DPCH_Information_RL_SetupRqstTDD_id_tab
    _UL_DPCH_Information_RL_SetupRqstTDD_id._const_tab_at = None
    _UL_DPCH_Information_RL_SetupRqstTDD_id._const_tab_id = 'id'
    _UL_DPCH_Information_RL_SetupRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _UL_DPCH_Information_RL_SetupRqstTDD_criticality._const_tab = __UL_DPCH_Information_RL_SetupRqstTDD_id_tab
    _UL_DPCH_Information_RL_SetupRqstTDD_criticality._const_tab_at = ('..', 'id')
    _UL_DPCH_Information_RL_SetupRqstTDD_criticality._const_tab_id = 'criticality'
    _UL_DPCH_Information_RL_SetupRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _UL_DPCH_Information_RL_SetupRqstTDD_value._const_tab = __UL_DPCH_Information_RL_SetupRqstTDD_id_tab
    _UL_DPCH_Information_RL_SetupRqstTDD_value._const_tab_at = ('..', 'id')
    _UL_DPCH_Information_RL_SetupRqstTDD_value._const_tab_id = 'Value'
    UL_DPCH_Information_RL_SetupRqstTDD._cont = ASN1Dict([
        ('id', _UL_DPCH_Information_RL_SetupRqstTDD_id),
        ('criticality', _UL_DPCH_Information_RL_SetupRqstTDD_criticality),
        ('value', _UL_DPCH_Information_RL_SetupRqstTDD_value),
        ])
    UL_DPCH_Information_RL_SetupRqstTDD._ext = None
    
    #-----< UL-DPCH-InformationIE-RL-SetupRqstTDD >-----#
    UL_DPCH_InformationIE_RL_SetupRqstTDD = CLASS(name='UL-DPCH-InformationIE-RL-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UL_DPCH_InformationIE_RL_SetupRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-SetupRqstTDD')))
    UL_DPCH_InformationIE_RL_SetupRqstTDD._val = ASN1Set(rv=[dict([('id', 291), ('criticality', 'notify'), ('Value', _UL_DPCH_InformationIE_RL_SetupRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationItem-RL-SetupRqstTDD >-----#
    UL_DPCH_InformationItem_RL_SetupRqstTDD = SEQ(name='UL-DPCH-InformationItem-RL-SetupRqstTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationItem_RL_SetupRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationItem_RL_SetupRqstTDD_uL_Timeslot_Information = SEQ_OF(name='uL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-Timeslot-Information')))
    _UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._cont = __UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_
    _UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationItem_RL_SetupRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_InformationItem_RL_SetupRqstTDD_tdd_DPCHOffset),
        ('uL-Timeslot-Information', _UL_DPCH_InformationItem_RL_SetupRqstTDD_uL_Timeslot_Information),
        ('iE-Extensions', _UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions),
        ])
    UL_DPCH_InformationItem_RL_SetupRqstTDD._ext = []
    
    #-----< UL-DPCH-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    UL_DPCH_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name='UL-DPCH-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-LCR-Information-RL-SetupRqstTDD >-----#
    UL_DPCH_LCR_Information_RL_SetupRqstTDD = SEQ(name='UL-DPCH-LCR-Information-RL-SetupRqstTDD', mode=MODE_TYPE)
    _UL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_LCR_Information_RL_SetupRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_LCR_Information_RL_SetupRqstTDD_uL_TimeslotLCR_Information = SEQ_OF(name='uL-TimeslotLCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotLCR-Information')))
    _UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions._cont = __UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item_
    _UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_LCR_Information_RL_SetupRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_LCR_Information_RL_SetupRqstTDD_tdd_DPCHOffset),
        ('uL-TimeslotLCR-Information', _UL_DPCH_LCR_Information_RL_SetupRqstTDD_uL_TimeslotLCR_Information),
        ('iE-Extensions', _UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions),
        ])
    UL_DPCH_LCR_Information_RL_SetupRqstTDD._ext = []
    
    #-----< UL-DPCH-LCR-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    UL_DPCH_LCR_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name='UL-DPCH-LCR-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_LCR_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-768-Information-RL-SetupRqstTDD >-----#
    UL_DPCH_768_Information_RL_SetupRqstTDD = SEQ(name='UL-DPCH-768-Information-RL-SetupRqstTDD', mode=MODE_TYPE)
    _UL_DPCH_768_Information_RL_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_768_Information_RL_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_768_Information_RL_SetupRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_768_Information_RL_SetupRqstTDD_uL_Timeslot768_Information = SEQ_OF(name='uL-Timeslot768-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-Timeslot768-Information')))
    _UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions._cont = __UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item_
    _UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_768_Information_RL_SetupRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_768_Information_RL_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_768_Information_RL_SetupRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_768_Information_RL_SetupRqstTDD_tdd_DPCHOffset),
        ('uL-Timeslot768-Information', _UL_DPCH_768_Information_RL_SetupRqstTDD_uL_Timeslot768_Information),
        ('iE-Extensions', _UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions),
        ])
    UL_DPCH_768_Information_RL_SetupRqstTDD._ext = []
    
    #-----< UL-DPCH-768-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    UL_DPCH_768_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name='UL-DPCH-768-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_768_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationList-RL-SetupRqstTDD >-----#
    DL_CCTrCH_InformationList_RL_SetupRqstTDD = SEQ_OF(name='DL-CCTrCH-InformationList-RL-SetupRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationList_RL_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationItem-RL-SetupRqstTDD')))
    ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'notify'), ('Value', ____DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab = ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab_at = None
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab_id = 'id'
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab = ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab_at = ('..', 'id')
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab_id = 'criticality'
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab = ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab_at = ('..', 'id')
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab_id = 'Value'
    _DL_CCTrCH_InformationList_RL_SetupRqstTDD__item_._cont = ASN1Dict([
        ('id', __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id),
        ('criticality', __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality),
        ('value', __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value),
        ])
    _DL_CCTrCH_InformationList_RL_SetupRqstTDD__item_._ext = None
    DL_CCTrCH_InformationList_RL_SetupRqstTDD._cont = _DL_CCTrCH_InformationList_RL_SetupRqstTDD__item_
    DL_CCTrCH_InformationList_RL_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationItemIE-RL-SetupRqstTDD >-----#
    DL_CCTrCH_InformationItemIE_RL_SetupRqstTDD = CLASS(name='DL-CCTrCH-InformationItemIE-RL-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_CCTrCH_InformationItemIE_RL_SetupRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationItem-RL-SetupRqstTDD')))
    DL_CCTrCH_InformationItemIE_RL_SetupRqstTDD._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'notify'), ('Value', _DL_CCTrCH_InformationItemIE_RL_SetupRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationItem-RL-SetupRqstTDD >-----#
    DL_CCTrCH_InformationItem_RL_SetupRqstTDD = SEQ(name='DL-CCTrCH-InformationItem-RL-SetupRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding = ENUM(name='tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Coding')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_punctureLimit = INT(name='punctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tdd_TPC_DownlinkStepSize = ENUM(name='tdd-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_TPCList = SEQ_OF(name='cCTrCH-TPCList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-TPCList-RL-SetupRqstTDD')), opt=True)
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_dL_DPCH_Information = SEQ(name='dL-DPCH-Information', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-Information-RL-SetupRqstTDD')), opt=True)
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-LCR-Information-RL-SetupRqstTDD')))
    _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-768-Information-RL-SetupRqstTDD')))
    ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'notify'), ('Extension', _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 517), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 567), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 568), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 746), ('criticality', 'notify'), ('Extension', _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._cont = __DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationItem_RL_SetupRqstTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID),
        ('tFCS', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCS),
        ('tFCI-Coding', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding),
        ('punctureLimit', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_punctureLimit),
        ('tdd-TPC-DownlinkStepSize', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tdd_TPC_DownlinkStepSize),
        ('cCTrCH-TPCList', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_TPCList),
        ('dL-DPCH-Information', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_dL_DPCH_Information),
        ('iE-Extensions', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationItem_RL_SetupRqstTDD._ext = []
    
    #-----< DL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name='DL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-LCR-Information-RL-SetupRqstTDD')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-768-Information-RL-SetupRqstTDD')))
    DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'notify'), ('Extension', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 517), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 567), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 568), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 746), ('criticality', 'notify'), ('Extension', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-TPCList-RL-SetupRqstTDD >-----#
    CCTrCH_TPCList_RL_SetupRqstTDD = SEQ_OF(name='CCTrCH-TPCList-RL-SetupRqstTDD', mode=MODE_TYPE)
    _CCTrCH_TPCList_RL_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-TPCItem-RL-SetupRqstTDD')))
    CCTrCH_TPCList_RL_SetupRqstTDD._cont = _CCTrCH_TPCList_RL_SetupRqstTDD__item_
    CCTrCH_TPCList_RL_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CCTrCH-TPCItem-RL-SetupRqstTDD >-----#
    CCTrCH_TPCItem_RL_SetupRqstTDD = SEQ(name='CCTrCH-TPCItem-RL-SetupRqstTDD', mode=MODE_TYPE)
    _CCTrCH_TPCItem_RL_SetupRqstTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions._cont = __CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item_
    _CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_TPCItem_RL_SetupRqstTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _CCTrCH_TPCItem_RL_SetupRqstTDD_cCTrCH_ID),
        ('iE-Extensions', _CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions),
        ])
    CCTrCH_TPCItem_RL_SetupRqstTDD._ext = []
    
    #-----< CCTrCH-TPCItem-RL-SetupRqstTDD-ExtIEs >-----#
    CCTrCH_TPCItem_RL_SetupRqstTDD_ExtIEs = CLASS(name='CCTrCH-TPCItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CCTrCH_TPCItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-Information-RL-SetupRqstTDD >-----#
    DL_DPCH_Information_RL_SetupRqstTDD = SEQ(name='DL-DPCH-Information-RL-SetupRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_Information_RL_SetupRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DL_DPCH_Information_RL_SetupRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DL_DPCH_Information_RL_SetupRqstTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-SetupRqstTDD')))
    __DL_DPCH_Information_RL_SetupRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 79), ('criticality', 'notify'), ('Value', ___DL_DPCH_Information_RL_SetupRqstTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_Information_RL_SetupRqstTDD_id._const_tab = __DL_DPCH_Information_RL_SetupRqstTDD_id_tab
    _DL_DPCH_Information_RL_SetupRqstTDD_id._const_tab_at = None
    _DL_DPCH_Information_RL_SetupRqstTDD_id._const_tab_id = 'id'
    _DL_DPCH_Information_RL_SetupRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DL_DPCH_Information_RL_SetupRqstTDD_criticality._const_tab = __DL_DPCH_Information_RL_SetupRqstTDD_id_tab
    _DL_DPCH_Information_RL_SetupRqstTDD_criticality._const_tab_at = ('..', 'id')
    _DL_DPCH_Information_RL_SetupRqstTDD_criticality._const_tab_id = 'criticality'
    _DL_DPCH_Information_RL_SetupRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DL_DPCH_Information_RL_SetupRqstTDD_value._const_tab = __DL_DPCH_Information_RL_SetupRqstTDD_id_tab
    _DL_DPCH_Information_RL_SetupRqstTDD_value._const_tab_at = ('..', 'id')
    _DL_DPCH_Information_RL_SetupRqstTDD_value._const_tab_id = 'Value'
    DL_DPCH_Information_RL_SetupRqstTDD._cont = ASN1Dict([
        ('id', _DL_DPCH_Information_RL_SetupRqstTDD_id),
        ('criticality', _DL_DPCH_Information_RL_SetupRqstTDD_criticality),
        ('value', _DL_DPCH_Information_RL_SetupRqstTDD_value),
        ])
    DL_DPCH_Information_RL_SetupRqstTDD._ext = None
    
    #-----< DL-DPCH-InformationIE-RL-SetupRqstTDD >-----#
    DL_DPCH_InformationIE_RL_SetupRqstTDD = CLASS(name='DL-DPCH-InformationIE-RL-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_DPCH_InformationIE_RL_SetupRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-SetupRqstTDD')))
    DL_DPCH_InformationIE_RL_SetupRqstTDD._val = ASN1Set(rv=[dict([('id', 79), ('criticality', 'notify'), ('Value', _DL_DPCH_InformationIE_RL_SetupRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationItem-RL-SetupRqstTDD >-----#
    DL_DPCH_InformationItem_RL_SetupRqstTDD = SEQ(name='DL-DPCH-InformationItem-RL-SetupRqstTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationItem_RL_SetupRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationItem_RL_SetupRqstTDD_dL_Timeslot_Information = SEQ_OF(name='dL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Timeslot-Information')))
    _DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._cont = __DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_
    _DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationItem_RL_SetupRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_InformationItem_RL_SetupRqstTDD_tdd_DPCHOffset),
        ('dL-Timeslot-Information', _DL_DPCH_InformationItem_RL_SetupRqstTDD_dL_Timeslot_Information),
        ('iE-Extensions', _DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions),
        ])
    DL_DPCH_InformationItem_RL_SetupRqstTDD._ext = []
    
    #-----< DL-DPCH-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    DL_DPCH_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name='DL-DPCH-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-LCR-Information-RL-SetupRqstTDD >-----#
    DL_DPCH_LCR_Information_RL_SetupRqstTDD = SEQ(name='DL-DPCH-LCR-Information-RL-SetupRqstTDD', mode=MODE_TYPE)
    _DL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_LCR_Information_RL_SetupRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_LCR_Information_RL_SetupRqstTDD_dL_TimeslotLCR_Information = SEQ_OF(name='dL-TimeslotLCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotLCR-Information')))
    _DL_DPCH_LCR_Information_RL_SetupRqstTDD_tstdIndicator = ENUM(name='tstdIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    _DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions._cont = __DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item_
    _DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_LCR_Information_RL_SetupRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_LCR_Information_RL_SetupRqstTDD_tdd_DPCHOffset),
        ('dL-TimeslotLCR-Information', _DL_DPCH_LCR_Information_RL_SetupRqstTDD_dL_TimeslotLCR_Information),
        ('tstdIndicator', _DL_DPCH_LCR_Information_RL_SetupRqstTDD_tstdIndicator),
        ('iE-Extensions', _DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions),
        ])
    DL_DPCH_LCR_Information_RL_SetupRqstTDD._ext = []
    
    #-----< DL-DPCH-LCR-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    DL_DPCH_LCR_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name='DL-DPCH-LCR-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_LCR_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-768-Information-RL-SetupRqstTDD >-----#
    DL_DPCH_768_Information_RL_SetupRqstTDD = SEQ(name='DL-DPCH-768-Information-RL-SetupRqstTDD', mode=MODE_TYPE)
    _DL_DPCH_768_Information_RL_SetupRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_768_Information_RL_SetupRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_768_Information_RL_SetupRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_768_Information_RL_SetupRqstTDD_dL_Timeslot768_Information = SEQ_OF(name='dL-Timeslot768-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Timeslot768-Information')))
    _DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions._cont = __DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item_
    _DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_768_Information_RL_SetupRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_768_Information_RL_SetupRqstTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_768_Information_RL_SetupRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_768_Information_RL_SetupRqstTDD_tdd_DPCHOffset),
        ('dL-Timeslot768-Information', _DL_DPCH_768_Information_RL_SetupRqstTDD_dL_Timeslot768_Information),
        ('iE-Extensions', _DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions),
        ])
    DL_DPCH_768_Information_RL_SetupRqstTDD._ext = []
    
    #-----< DL-DPCH-768-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    DL_DPCH_768_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name='DL-DPCH-768-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_768_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Information-RL-SetupRqstTDD >-----#
    RL_Information_RL_SetupRqstTDD = SEQ(name='RL-Information-RL-SetupRqstTDD', mode=MODE_TYPE)
    _RL_Information_RL_SetupRqstTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_Information_RL_SetupRqstTDD_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _RL_Information_RL_SetupRqstTDD_frameOffset = INT(name='frameOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FrameOffset')))
    _RL_Information_RL_SetupRqstTDD_specialBurstScheduling = INT(name='specialBurstScheduling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SpecialBurstScheduling')))
    _RL_Information_RL_SetupRqstTDD_initialDL_transmissionPower = INT(name='initialDL-transmissionPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _RL_Information_RL_SetupRqstTDD_maximumDL_power = INT(name='maximumDL-power', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _RL_Information_RL_SetupRqstTDD_minimumDL_power = INT(name='minimumDL-power', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _RL_Information_RL_SetupRqstTDD_dL_TimeSlotISCPInfo = SEQ_OF(name='dL-TimeSlotISCPInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfo')), opt=True)
    _RL_Information_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfoLCR')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DelayedActivation')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 468), ('criticality', 'reject'), ('Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 554), ('criticality', 'reject'), ('Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Information_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id),
        ('criticality', ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _RL_Information_RL_SetupRqstTDD_iE_Extensions._cont = __RL_Information_RL_SetupRqstTDD_iE_Extensions__item_
    _RL_Information_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_RL_SetupRqstTDD._cont = ASN1Dict([
        ('rL-ID', _RL_Information_RL_SetupRqstTDD_rL_ID),
        ('c-ID', _RL_Information_RL_SetupRqstTDD_c_ID),
        ('frameOffset', _RL_Information_RL_SetupRqstTDD_frameOffset),
        ('specialBurstScheduling', _RL_Information_RL_SetupRqstTDD_specialBurstScheduling),
        ('initialDL-transmissionPower', _RL_Information_RL_SetupRqstTDD_initialDL_transmissionPower),
        ('maximumDL-power', _RL_Information_RL_SetupRqstTDD_maximumDL_power),
        ('minimumDL-power', _RL_Information_RL_SetupRqstTDD_minimumDL_power),
        ('dL-TimeSlotISCPInfo', _RL_Information_RL_SetupRqstTDD_dL_TimeSlotISCPInfo),
        ('iE-Extensions', _RL_Information_RL_SetupRqstTDD_iE_Extensions),
        ])
    RL_Information_RL_SetupRqstTDD._ext = []
    
    #-----< RL-Information-RL-SetupRqstTDD-ExtIEs >-----#
    RL_Information_RL_SetupRqstTDD_ExtIEs = CLASS(name='RL-Information-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfoLCR')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DelayedActivation')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    RL_Information_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 468), ('criticality', 'reject'), ('Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 554), ('criticality', 'reject'), ('Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupResponseFDD >-----#
    RadioLinkSetupResponseFDD = SEQ(name='RadioLinkSetupResponseFDD', mode=MODE_TYPE)
    _RadioLinkSetupResponseFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupResponseFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupResponseFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseList-RL-SetupRspFDD')))
    _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 143), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 224), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupResponseFDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupResponseFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupResponseFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkSetupResponseFDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkSetupResponseFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkSetupResponseFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupResponseFDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkSetupResponseFDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupResponseFDD_protocolIEs__item_._ext = None
    _RadioLinkSetupResponseFDD_protocolIEs._cont = __RadioLinkSetupResponseFDD_protocolIEs__item_
    _RadioLinkSetupResponseFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupResponseFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupResponseFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information-Response')))
    _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-List')))
    ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 531), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 835), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1038), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1121), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkSetupResponseFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupResponseFDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupResponseFDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupResponseFDD_protocolExtensions._cont = __RadioLinkSetupResponseFDD_protocolExtensions__item_
    _RadioLinkSetupResponseFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupResponseFDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkSetupResponseFDD_protocolIEs),
        ('protocolExtensions', _RadioLinkSetupResponseFDD_protocolExtensions),
        ])
    RadioLinkSetupResponseFDD._ext = []
    
    #-----< RadioLinkSetupResponseFDD-IEs >-----#
    RadioLinkSetupResponseFDD_IEs = CLASS(name='RadioLinkSetupResponseFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkSetupResponseFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkSetupResponseFDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkSetupResponseFDD_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _RadioLinkSetupResponseFDD_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseList-RL-SetupRspFDD')))
    _RadioLinkSetupResponseFDD_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkSetupResponseFDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkSetupResponseFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 143), ('criticality', 'ignore'), ('Value', _RadioLinkSetupResponseFDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _RadioLinkSetupResponseFDD_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 224), ('criticality', 'ignore'), ('Value', _RadioLinkSetupResponseFDD_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkSetupResponseFDD_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupResponseFDD-Extensions >-----#
    RadioLinkSetupResponseFDD_Extensions = CLASS(name='RadioLinkSetupResponseFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkSetupResponseFDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _RadioLinkSetupResponseFDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information-Response')))
    _RadioLinkSetupResponseFDD_Extensions_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _RadioLinkSetupResponseFDD_Extensions_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-List')))
    RadioLinkSetupResponseFDD_Extensions._val = ASN1Set(rv=[dict([('id', 531), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseFDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 835), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseFDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 1038), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseFDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 1121), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseFDD_Extensions_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-Response-List >-----#
    Additional_HS_Cell_Information_Response_List = SEQ_OF(name='Additional-HS-Cell-Information-Response-List', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-ItemIEs')))
    Additional_HS_Cell_Information_Response_List._cont = _Additional_HS_Cell_Information_Response_List__item_
    Additional_HS_Cell_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Information-Response-ItemIEs >-----#
    Additional_HS_Cell_Information_Response_ItemIEs = SEQ(name='Additional-HS-Cell-Information-Response-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_Response_ItemIEs_hSPDSCH_RL_ID = INT(name='hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_Response_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_Response = SEQ(name='hS-DSCH-FDD-Secondary-Serving-Information-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information-Response')))
    _Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_Response_ItemIEs._cont = ASN1Dict([
        ('hSPDSCH-RL-ID', _Additional_HS_Cell_Information_Response_ItemIEs_hSPDSCH_RL_ID),
        ('hS-DSCH-FDD-Secondary-Serving-Information-Response', _Additional_HS_Cell_Information_Response_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_Response),
        ('iE-Extensions', _Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_Response_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-Response-ItemIEs-ExtIEs >-----#
    Additional_HS_Cell_Information_Response_ItemIEs_ExtIEs = CLASS(name='Additional-HS-Cell-Information-Response-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_Response_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponseList-RL-SetupRspFDD >-----#
    RL_InformationResponseList_RL_SetupRspFDD = SEQ_OF(name='RL-InformationResponseList-RL-SetupRspFDD', mode=MODE_TYPE)
    _RL_InformationResponseList_RL_SetupRspFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationResponseList_RL_SetupRspFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationResponseList_RL_SetupRspFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseItem-RL-SetupRspFDD')))
    ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 220), ('criticality', 'ignore'), ('Value', ____RL_InformationResponseList_RL_SetupRspFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationResponseList_RL_SetupRspFDD__item__id._const_tab = ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab
    __RL_InformationResponseList_RL_SetupRspFDD__item__id._const_tab_at = None
    __RL_InformationResponseList_RL_SetupRspFDD__item__id._const_tab_id = 'id'
    __RL_InformationResponseList_RL_SetupRspFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationResponseList_RL_SetupRspFDD__item__criticality._const_tab = ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab
    __RL_InformationResponseList_RL_SetupRspFDD__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationResponseList_RL_SetupRspFDD__item__criticality._const_tab_id = 'criticality'
    __RL_InformationResponseList_RL_SetupRspFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationResponseList_RL_SetupRspFDD__item__value._const_tab = ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab
    __RL_InformationResponseList_RL_SetupRspFDD__item__value._const_tab_at = ('..', 'id')
    __RL_InformationResponseList_RL_SetupRspFDD__item__value._const_tab_id = 'Value'
    _RL_InformationResponseList_RL_SetupRspFDD__item_._cont = ASN1Dict([
        ('id', __RL_InformationResponseList_RL_SetupRspFDD__item__id),
        ('criticality', __RL_InformationResponseList_RL_SetupRspFDD__item__criticality),
        ('value', __RL_InformationResponseList_RL_SetupRspFDD__item__value),
        ])
    _RL_InformationResponseList_RL_SetupRspFDD__item_._ext = None
    RL_InformationResponseList_RL_SetupRspFDD._cont = _RL_InformationResponseList_RL_SetupRspFDD__item_
    RL_InformationResponseList_RL_SetupRspFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationResponseItemIE-RL-SetupRspFDD >-----#
    RL_InformationResponseItemIE_RL_SetupRspFDD = CLASS(name='RL-InformationResponseItemIE-RL-SetupRspFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationResponseItemIE_RL_SetupRspFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseItem-RL-SetupRspFDD')))
    RL_InformationResponseItemIE_RL_SetupRspFDD._val = ASN1Set(rv=[dict([('id', 220), ('criticality', 'ignore'), ('Value', _RL_InformationResponseItemIE_RL_SetupRspFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationResponseItem-RL-SetupRspFDD >-----#
    RL_InformationResponseItem_RL_SetupRspFDD = SEQ(name='RL-InformationResponseItem-RL-SetupRspFDD', mode=MODE_TYPE)
    _RL_InformationResponseItem_RL_SetupRspFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationResponseItem_RL_SetupRspFDD_rL_Set_ID = INT(name='rL-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_SetupRspFDD_received_total_wide_band_power = INT(name='received-total-wide-band-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')))
    _RL_InformationResponseItem_RL_SetupRspFDD_diversityIndication = CHOICE(name='diversityIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DiversityIndication-RL-SetupRspFDD')))
    _RL_InformationResponseItem_RL_SetupRspFDD_not_Used_dSCH_InformationResponseList = NULL(name='not-Used-dSCH-InformationResponseList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_sSDT_SupportIndicator = ENUM(name='sSDT-SupportIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SSDT-SupportIndicator')))
    _RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 651), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id),
        ('criticality', ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item_._ext = None
    _RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions._cont = __RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item_
    _RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponseItem_RL_SetupRspFDD._cont = ASN1Dict([
        ('rL-ID', _RL_InformationResponseItem_RL_SetupRspFDD_rL_ID),
        ('rL-Set-ID', _RL_InformationResponseItem_RL_SetupRspFDD_rL_Set_ID),
        ('received-total-wide-band-power', _RL_InformationResponseItem_RL_SetupRspFDD_received_total_wide_band_power),
        ('diversityIndication', _RL_InformationResponseItem_RL_SetupRspFDD_diversityIndication),
        ('not-Used-dSCH-InformationResponseList', _RL_InformationResponseItem_RL_SetupRspFDD_not_Used_dSCH_InformationResponseList),
        ('sSDT-SupportIndicator', _RL_InformationResponseItem_RL_SetupRspFDD_sSDT_SupportIndicator),
        ('iE-Extensions', _RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions),
        ])
    RL_InformationResponseItem_RL_SetupRspFDD._ext = []
    
    #-----< RL-InformationResponseItem-RL-SetupRspFDD-ExtIEs >-----#
    RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs = CLASS(name='RL-InformationResponseItem-RL-SetupRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 651), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DiversityIndication-RL-SetupRspFDD >-----#
    DiversityIndication_RL_SetupRspFDD = CHOICE(name='DiversityIndication-RL-SetupRspFDD', mode=MODE_TYPE)
    _DiversityIndication_RL_SetupRspFDD_combining = SEQ(name='combining', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Combining-RL-SetupRspFDD')))
    _DiversityIndication_RL_SetupRspFDD_nonCombiningOrFirstRL = SEQ(name='nonCombiningOrFirstRL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'NonCombiningOrFirstRL-RL-SetupRspFDD')))
    DiversityIndication_RL_SetupRspFDD._cont = ASN1Dict([
        ('combining', _DiversityIndication_RL_SetupRspFDD_combining),
        ('nonCombiningOrFirstRL', _DiversityIndication_RL_SetupRspFDD_nonCombiningOrFirstRL),
        ])
    DiversityIndication_RL_SetupRspFDD._ext = None
    
    #-----< Combining-RL-SetupRspFDD >-----#
    Combining_RL_SetupRspFDD = SEQ(name='Combining-RL-SetupRspFDD', mode=MODE_TYPE)
    _Combining_RL_SetupRspFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Combining_RL_SetupRspFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Combining_RL_SetupRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__id._const_tab = ____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Combining_RL_SetupRspFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Combining_RL_SetupRspFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab = ____Combining_RL_SetupRspFDD_iE_Extensions__item__criticality_tab
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab = ____Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue_tab
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Combining_RL_SetupRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Combining_RL_SetupRspFDD_iE_Extensions__item__id),
        ('criticality', ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue),
        ])
    __Combining_RL_SetupRspFDD_iE_Extensions__item_._ext = None
    _Combining_RL_SetupRspFDD_iE_Extensions._cont = __Combining_RL_SetupRspFDD_iE_Extensions__item_
    _Combining_RL_SetupRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Combining_RL_SetupRspFDD._cont = ASN1Dict([
        ('rL-ID', _Combining_RL_SetupRspFDD_rL_ID),
        ('iE-Extensions', _Combining_RL_SetupRspFDD_iE_Extensions),
        ])
    Combining_RL_SetupRspFDD._ext = []
    
    #-----< Combining-RL-SetupRspFDD-ExtIEs >-----#
    Combining_RL_SetupRspFDD_ExtIEs = CLASS(name='Combining-RL-SetupRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Combining_RL_SetupRspFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NonCombiningOrFirstRL-RL-SetupRspFDD >-----#
    NonCombiningOrFirstRL_RL_SetupRspFDD = SEQ(name='NonCombiningOrFirstRL-RL-SetupRspFDD', mode=MODE_TYPE)
    _NonCombiningOrFirstRL_RL_SetupRspFDD_dCH_InformationResponse = SEQ_OF(name='dCH-InformationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponse')))
    _NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id._const_tab = ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab = ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab = ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id),
        ('criticality', ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue),
        ])
    __NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item_._ext = None
    _NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions._cont = __NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item_
    _NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonCombiningOrFirstRL_RL_SetupRspFDD._cont = ASN1Dict([
        ('dCH-InformationResponse', _NonCombiningOrFirstRL_RL_SetupRspFDD_dCH_InformationResponse),
        ('iE-Extensions', _NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions),
        ])
    NonCombiningOrFirstRL_RL_SetupRspFDD._ext = []
    
    #-----< NonCombiningOrFirstRLItem-RL-SetupRspFDD-ExtIEs >-----#
    NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs = CLASS(name='NonCombiningOrFirstRLItem-RL-SetupRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupResponseTDD >-----#
    RadioLinkSetupResponseTDD = SEQ(name='RadioLinkSetupResponseTDD', mode=MODE_TYPE)
    _RadioLinkSetupResponseTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupResponseTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupResponseTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponse-RL-SetupRspTDD')))
    _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 143), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupResponseTDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupResponseTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupResponseTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkSetupResponseTDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkSetupResponseTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkSetupResponseTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupResponseTDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkSetupResponseTDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupResponseTDD_protocolIEs__item_._ext = None
    _RadioLinkSetupResponseTDD_protocolIEs._cont = __RadioLinkSetupResponseTDD_protocolIEs__item_
    _RadioLinkSetupResponseTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupResponseTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupResponseTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponse-LCR-RL-SetupRspTDD')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Response')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-Response')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_10 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 463), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 537), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 800), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1055), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1057), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1058), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1150), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1189), ('criticality', 'ignore'), ('Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1193), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1256), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1257), ('criticality', 'reject'), ('Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkSetupResponseTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupResponseTDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupResponseTDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupResponseTDD_protocolExtensions._cont = __RadioLinkSetupResponseTDD_protocolExtensions__item_
    _RadioLinkSetupResponseTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupResponseTDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkSetupResponseTDD_protocolIEs),
        ('protocolExtensions', _RadioLinkSetupResponseTDD_protocolExtensions),
        ])
    RadioLinkSetupResponseTDD._ext = []
    
    #-----< RadioLinkSetupResponseTDD-IEs >-----#
    RadioLinkSetupResponseTDD_IEs = CLASS(name='RadioLinkSetupResponseTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkSetupResponseTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkSetupResponseTDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkSetupResponseTDD_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _RadioLinkSetupResponseTDD_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponse-RL-SetupRspTDD')))
    _RadioLinkSetupResponseTDD_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkSetupResponseTDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkSetupResponseTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 143), ('criticality', 'ignore'), ('Value', _RadioLinkSetupResponseTDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _RadioLinkSetupResponseTDD_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _RadioLinkSetupResponseTDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkSetupResponseTDD_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupResponseTDD-Extensions >-----#
    RadioLinkSetupResponseTDD_Extensions = CLASS(name='RadioLinkSetupResponseTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponse-LCR-RL-SetupRspTDD')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Response')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-Response')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_10 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    RadioLinkSetupResponseTDD_Extensions._val = ASN1Set(rv=[dict([('id', 463), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 537), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 800), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 1055), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 1057), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 1058), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 1150), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 1189), ('criticality', 'ignore'), ('Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 1193), ('criticality', 'reject'), ('Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 1256), ('criticality', 'reject'), ('Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 1257), ('criticality', 'reject'), ('Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_10), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponse-RL-SetupRspTDD >-----#
    RL_InformationResponse_RL_SetupRspTDD = SEQ(name='RL-InformationResponse-RL-SetupRspTDD', mode=MODE_TYPE)
    _RL_InformationResponse_RL_SetupRspTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationResponse_RL_SetupRspTDD_uL_TimeSlot_ISCP_Info = SEQ_OF(name='uL-TimeSlot-ISCP-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeSlot-ISCP-Info')))
    _RL_InformationResponse_RL_SetupRspTDD_ul_PhysCH_SF_Variation = ENUM(name='ul-PhysCH-SF-Variation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-PhysCH-SF-Variation')))
    _RL_InformationResponse_RL_SetupRspTDD_dCH_InformationResponseList = SEQ(name='dCH-InformationResponseList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-InformationResponseList-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_dSCH_InformationResponseList = SEQ(name='dSCH-InformationResponseList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-InformationResponseList-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_uSCH_InformationResponseList = SEQ(name='uSCH-InformationResponseList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-InformationResponseList-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality_tab
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id),
        ('criticality', ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _RL_InformationResponse_RL_SetupRspTDD_iE_Extensions._cont = __RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_
    _RL_InformationResponse_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponse_RL_SetupRspTDD._cont = ASN1Dict([
        ('rL-ID', _RL_InformationResponse_RL_SetupRspTDD_rL_ID),
        ('uL-TimeSlot-ISCP-Info', _RL_InformationResponse_RL_SetupRspTDD_uL_TimeSlot_ISCP_Info),
        ('ul-PhysCH-SF-Variation', _RL_InformationResponse_RL_SetupRspTDD_ul_PhysCH_SF_Variation),
        ('dCH-InformationResponseList', _RL_InformationResponse_RL_SetupRspTDD_dCH_InformationResponseList),
        ('dSCH-InformationResponseList', _RL_InformationResponse_RL_SetupRspTDD_dSCH_InformationResponseList),
        ('uSCH-InformationResponseList', _RL_InformationResponse_RL_SetupRspTDD_uSCH_InformationResponseList),
        ('iE-Extensions', _RL_InformationResponse_RL_SetupRspTDD_iE_Extensions),
        ])
    RL_InformationResponse_RL_SetupRspTDD._ext = []
    
    #-----< RL-InformationResponseList-RL-SetupRspTDD-ExtIEs >-----#
    RL_InformationResponseList_RL_SetupRspTDD_ExtIEs = CLASS(name='RL-InformationResponseList-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_InformationResponseList_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-InformationResponseList-RL-SetupRspTDD >-----#
    DCH_InformationResponseList_RL_SetupRspTDD = SEQ(name='DCH-InformationResponseList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DCH_InformationResponseList_RL_SetupRspTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DCH_InformationResponseList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponse')))
    __DCH_InformationResponseList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'ignore'), ('Value', ___DCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DCH_InformationResponseList_RL_SetupRspTDD_id._const_tab = __DCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _DCH_InformationResponseList_RL_SetupRspTDD_id._const_tab_at = None
    _DCH_InformationResponseList_RL_SetupRspTDD_id._const_tab_id = 'id'
    _DCH_InformationResponseList_RL_SetupRspTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab = __DCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _DCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab_at = ('..', 'id')
    _DCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab_id = 'criticality'
    _DCH_InformationResponseList_RL_SetupRspTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DCH_InformationResponseList_RL_SetupRspTDD_value._const_tab = __DCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _DCH_InformationResponseList_RL_SetupRspTDD_value._const_tab_at = ('..', 'id')
    _DCH_InformationResponseList_RL_SetupRspTDD_value._const_tab_id = 'Value'
    DCH_InformationResponseList_RL_SetupRspTDD._cont = ASN1Dict([
        ('id', _DCH_InformationResponseList_RL_SetupRspTDD_id),
        ('criticality', _DCH_InformationResponseList_RL_SetupRspTDD_criticality),
        ('value', _DCH_InformationResponseList_RL_SetupRspTDD_value),
        ])
    DCH_InformationResponseList_RL_SetupRspTDD._ext = None
    
    #-----< DCH-InformationResponseListIEs-RL-SetupRspTDD >-----#
    DCH_InformationResponseListIEs_RL_SetupRspTDD = CLASS(name='DCH-InformationResponseListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponse')))
    DCH_InformationResponseListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'ignore'), ('Value', _DCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DSCH-InformationResponseList-RL-SetupRspTDD >-----#
    DSCH_InformationResponseList_RL_SetupRspTDD = SEQ(name='DSCH-InformationResponseList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DSCH_InformationResponseList_RL_SetupRspTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DSCH_InformationResponseList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DSCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-InformationResponse')))
    __DSCH_InformationResponseList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([('id', 105), ('criticality', 'ignore'), ('Value', ___DSCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DSCH_InformationResponseList_RL_SetupRspTDD_id._const_tab = __DSCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _DSCH_InformationResponseList_RL_SetupRspTDD_id._const_tab_at = None
    _DSCH_InformationResponseList_RL_SetupRspTDD_id._const_tab_id = 'id'
    _DSCH_InformationResponseList_RL_SetupRspTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DSCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab = __DSCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _DSCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab_at = ('..', 'id')
    _DSCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab_id = 'criticality'
    _DSCH_InformationResponseList_RL_SetupRspTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DSCH_InformationResponseList_RL_SetupRspTDD_value._const_tab = __DSCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _DSCH_InformationResponseList_RL_SetupRspTDD_value._const_tab_at = ('..', 'id')
    _DSCH_InformationResponseList_RL_SetupRspTDD_value._const_tab_id = 'Value'
    DSCH_InformationResponseList_RL_SetupRspTDD._cont = ASN1Dict([
        ('id', _DSCH_InformationResponseList_RL_SetupRspTDD_id),
        ('criticality', _DSCH_InformationResponseList_RL_SetupRspTDD_criticality),
        ('value', _DSCH_InformationResponseList_RL_SetupRspTDD_value),
        ])
    DSCH_InformationResponseList_RL_SetupRspTDD._ext = None
    
    #-----< DSCH-InformationResponseListIEs-RL-SetupRspTDD >-----#
    DSCH_InformationResponseListIEs_RL_SetupRspTDD = CLASS(name='DSCH-InformationResponseListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DSCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-InformationResponse')))
    DSCH_InformationResponseListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([('id', 105), ('criticality', 'ignore'), ('Value', _DSCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< USCH-InformationResponseList-RL-SetupRspTDD >-----#
    USCH_InformationResponseList_RL_SetupRspTDD = SEQ(name='USCH-InformationResponseList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _USCH_InformationResponseList_RL_SetupRspTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __USCH_InformationResponseList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___USCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-InformationResponse')))
    __USCH_InformationResponseList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([('id', 309), ('criticality', 'ignore'), ('Value', ___USCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _USCH_InformationResponseList_RL_SetupRspTDD_id._const_tab = __USCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _USCH_InformationResponseList_RL_SetupRspTDD_id._const_tab_at = None
    _USCH_InformationResponseList_RL_SetupRspTDD_id._const_tab_id = 'id'
    _USCH_InformationResponseList_RL_SetupRspTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _USCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab = __USCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _USCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab_at = ('..', 'id')
    _USCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab_id = 'criticality'
    _USCH_InformationResponseList_RL_SetupRspTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _USCH_InformationResponseList_RL_SetupRspTDD_value._const_tab = __USCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _USCH_InformationResponseList_RL_SetupRspTDD_value._const_tab_at = ('..', 'id')
    _USCH_InformationResponseList_RL_SetupRspTDD_value._const_tab_id = 'Value'
    USCH_InformationResponseList_RL_SetupRspTDD._cont = ASN1Dict([
        ('id', _USCH_InformationResponseList_RL_SetupRspTDD_id),
        ('criticality', _USCH_InformationResponseList_RL_SetupRspTDD_criticality),
        ('value', _USCH_InformationResponseList_RL_SetupRspTDD_value),
        ])
    USCH_InformationResponseList_RL_SetupRspTDD._ext = None
    
    #-----< USCH-InformationResponseListIEs-RL-SetupRspTDD >-----#
    USCH_InformationResponseListIEs_RL_SetupRspTDD = CLASS(name='USCH-InformationResponseListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _USCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-InformationResponse')))
    USCH_InformationResponseListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([('id', 309), ('criticality', 'ignore'), ('Value', _USCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationResponse-LCR-RL-SetupRspTDD >-----#
    RL_InformationResponse_LCR_RL_SetupRspTDD = SEQ(name='RL-InformationResponse-LCR-RL-SetupRspTDD', mode=MODE_TYPE)
    _RL_InformationResponse_LCR_RL_SetupRspTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationResponse_LCR_RL_SetupRspTDD_uL_TimeSlot_ISCP_LCR_Info = SEQ_OF(name='uL-TimeSlot-ISCP-LCR-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeSlot-ISCP-LCR-Info')))
    _RL_InformationResponse_LCR_RL_SetupRspTDD_ul_PhysCH_SF_Variation = ENUM(name='ul-PhysCH-SF-Variation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-PhysCH-SF-Variation')))
    _RL_InformationResponse_LCR_RL_SetupRspTDD_dCH_InformationResponseList = SEQ(name='dCH-InformationResponseList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-InformationResponseList-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_LCR_RL_SetupRspTDD_dSCH_InformationResponseList = SEQ(name='dSCH-InformationResponseList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-InformationResponseList-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_LCR_RL_SetupRspTDD_uSCH_InformationResponseList = SEQ(name='uSCH-InformationResponseList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-InformationResponseList-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__criticality_tab
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__id),
        ('criticality', ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions._cont = __RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item_
    _RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponse_LCR_RL_SetupRspTDD._cont = ASN1Dict([
        ('rL-ID', _RL_InformationResponse_LCR_RL_SetupRspTDD_rL_ID),
        ('uL-TimeSlot-ISCP-LCR-Info', _RL_InformationResponse_LCR_RL_SetupRspTDD_uL_TimeSlot_ISCP_LCR_Info),
        ('ul-PhysCH-SF-Variation', _RL_InformationResponse_LCR_RL_SetupRspTDD_ul_PhysCH_SF_Variation),
        ('dCH-InformationResponseList', _RL_InformationResponse_LCR_RL_SetupRspTDD_dCH_InformationResponseList),
        ('dSCH-InformationResponseList', _RL_InformationResponse_LCR_RL_SetupRspTDD_dSCH_InformationResponseList),
        ('uSCH-InformationResponseList', _RL_InformationResponse_LCR_RL_SetupRspTDD_uSCH_InformationResponseList),
        ('iE-Extensions', _RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions),
        ])
    RL_InformationResponse_LCR_RL_SetupRspTDD._ext = []
    
    #-----< RL-InformationResponseList-LCR-RL-SetupRspTDD-ExtIEs >-----#
    RL_InformationResponseList_LCR_RL_SetupRspTDD_ExtIEs = CLASS(name='RL-InformationResponseList-LCR-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_InformationResponseList_LCR_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupFailureFDD >-----#
    RadioLinkSetupFailureFDD = SEQ(name='RadioLinkSetupFailureFDD', mode=MODE_TYPE)
    _RadioLinkSetupFailureFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupFailureFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupFailureFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-RL-SetupFailureFDD')))
    _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 143), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'conditional')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureFDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupFailureFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupFailureFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkSetupFailureFDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkSetupFailureFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkSetupFailureFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupFailureFDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkSetupFailureFDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupFailureFDD_protocolIEs__item_._ext = None
    _RadioLinkSetupFailureFDD_protocolIEs._cont = __RadioLinkSetupFailureFDD_protocolIEs__item_
    _RadioLinkSetupFailureFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupFailureFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupFailureFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupFailureFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupFailureFDD_protocolExtensions__item__criticality_tab
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkSetupFailureFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupFailureFDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupFailureFDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupFailureFDD_protocolExtensions._cont = __RadioLinkSetupFailureFDD_protocolExtensions__item_
    _RadioLinkSetupFailureFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupFailureFDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkSetupFailureFDD_protocolIEs),
        ('protocolExtensions', _RadioLinkSetupFailureFDD_protocolExtensions),
        ])
    RadioLinkSetupFailureFDD._ext = []
    
    #-----< RadioLinkSetupFailureFDD-IEs >-----#
    RadioLinkSetupFailureFDD_IEs = CLASS(name='RadioLinkSetupFailureFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkSetupFailureFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkSetupFailureFDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkSetupFailureFDD_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _RadioLinkSetupFailureFDD_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-RL-SetupFailureFDD')))
    _RadioLinkSetupFailureFDD_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkSetupFailureFDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkSetupFailureFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 143), ('criticality', 'ignore'), ('Value', _RadioLinkSetupFailureFDD_IEs_val_Value_1), ('presence', 'conditional')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _RadioLinkSetupFailureFDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Value', _RadioLinkSetupFailureFDD_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkSetupFailureFDD_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupFailureFDD-Extensions >-----#
    RadioLinkSetupFailureFDD_Extensions = CLASS(name='RadioLinkSetupFailureFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkSetupFailureFDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-RL-SetupFailureFDD >-----#
    CauseLevel_RL_SetupFailureFDD = CHOICE(name='CauseLevel-RL-SetupFailureFDD', mode=MODE_TYPE)
    _CauseLevel_RL_SetupFailureFDD_generalCause = SEQ(name='generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'GeneralCauseList-RL-SetupFailureFDD')))
    _CauseLevel_RL_SetupFailureFDD_rLSpecificCause = SEQ(name='rLSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RLSpecificCauseList-RL-SetupFailureFDD')))
    CauseLevel_RL_SetupFailureFDD._cont = ASN1Dict([
        ('generalCause', _CauseLevel_RL_SetupFailureFDD_generalCause),
        ('rLSpecificCause', _CauseLevel_RL_SetupFailureFDD_rLSpecificCause),
        ])
    CauseLevel_RL_SetupFailureFDD._ext = []
    
    #-----< GeneralCauseList-RL-SetupFailureFDD >-----#
    GeneralCauseList_RL_SetupFailureFDD = SEQ(name='GeneralCauseList-RL-SetupFailureFDD', mode=MODE_TYPE)
    _GeneralCauseList_RL_SetupFailureFDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _GeneralCauseList_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id),
        ('criticality', ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _GeneralCauseList_RL_SetupFailureFDD_iE_Extensions._cont = __GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item_
    _GeneralCauseList_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_RL_SetupFailureFDD._cont = ASN1Dict([
        ('cause', _GeneralCauseList_RL_SetupFailureFDD_cause),
        ('iE-Extensions', _GeneralCauseList_RL_SetupFailureFDD_iE_Extensions),
        ])
    GeneralCauseList_RL_SetupFailureFDD._ext = []
    
    #-----< GeneralCauseItem-RL-SetupFailureFDD-ExtIEs >-----#
    GeneralCauseItem_RL_SetupFailureFDD_ExtIEs = CLASS(name='GeneralCauseItem-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GeneralCauseItem_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLSpecificCauseList-RL-SetupFailureFDD >-----#
    RLSpecificCauseList_RL_SetupFailureFDD = SEQ(name='RLSpecificCauseList-RL-SetupFailureFDD', mode=MODE_TYPE)
    _RLSpecificCauseList_RL_SetupFailureFDD_unsuccessful_RL_InformationRespList_RL_SetupFailureFDD = SEQ_OF(name='unsuccessful-RL-InformationRespList-RL-SetupFailureFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationRespList-RL-SetupFailureFDD')))
    _RLSpecificCauseList_RL_SetupFailureFDD_successful_RL_InformationRespList_RL_SetupFailureFDD = SEQ_OF(name='successful-RL-InformationRespList-RL-SetupFailureFDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Successful-RL-InformationRespList-RL-SetupFailureFDD')), opt=True)
    _RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information-Response')))
    _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-List')))
    ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 531), ('criticality', 'ignore'), ('Extension', _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 835), ('criticality', 'ignore'), ('Extension', _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1038), ('criticality', 'ignore'), ('Extension', _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1121), ('criticality', 'ignore'), ('Extension', _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id),
        ('criticality', ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions._cont = __RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item_
    _RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLSpecificCauseList_RL_SetupFailureFDD._cont = ASN1Dict([
        ('unsuccessful-RL-InformationRespList-RL-SetupFailureFDD', _RLSpecificCauseList_RL_SetupFailureFDD_unsuccessful_RL_InformationRespList_RL_SetupFailureFDD),
        ('successful-RL-InformationRespList-RL-SetupFailureFDD', _RLSpecificCauseList_RL_SetupFailureFDD_successful_RL_InformationRespList_RL_SetupFailureFDD),
        ('iE-Extensions', _RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions),
        ])
    RLSpecificCauseList_RL_SetupFailureFDD._ext = []
    
    #-----< RLSpecificCauseItem-RL-SetupFailureFDD-ExtIEs >-----#
    RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs = CLASS(name='RLSpecificCauseItem-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information-Response')))
    _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-List')))
    RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 531), ('criticality', 'ignore'), ('Extension', _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 835), ('criticality', 'ignore'), ('Extension', _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1038), ('criticality', 'ignore'), ('Extension', _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 1121), ('criticality', 'ignore'), ('Extension', _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Unsuccessful-RL-InformationRespList-RL-SetupFailureFDD >-----#
    Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD = SEQ_OF(name='Unsuccessful-RL-InformationRespList-RL-SetupFailureFDD', mode=MODE_TYPE)
    _Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD')))
    ___Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 297), ('criticality', 'ignore'), ('Value', ____Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id._const_tab = ___Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id._const_tab_at = None
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id._const_tab_id = 'id'
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality._const_tab = ___Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality._const_tab_at = ('..', 'id')
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality._const_tab_id = 'criticality'
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__value._const_tab = ___Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__value._const_tab_at = ('..', 'id')
    __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__value._const_tab_id = 'Value'
    _Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item_._cont = ASN1Dict([
        ('id', __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id),
        ('criticality', __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality),
        ('value', __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__value),
        ])
    _Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item_._ext = None
    Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD._cont = _Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item_
    Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureFDD >-----#
    Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureFDD = CLASS(name='Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD')))
    Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureFDD._val = ASN1Set(rv=[dict([('id', 297), ('criticality', 'ignore'), ('Value', _Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD >-----#
    Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD = SEQ(name='Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD', mode=MODE_TYPE)
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id),
        ('criticality', ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions._cont = __Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item_
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD._cont = ASN1Dict([
        ('rL-ID', _Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_rL_ID),
        ('cause', _Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_cause),
        ('iE-Extensions', _Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions),
        ])
    Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD._ext = []
    
    #-----< Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD-ExtIEs >-----#
    Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs = CLASS(name='Unsuccessful-RL-InformationRespItem-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Successful-RL-InformationRespList-RL-SetupFailureFDD >-----#
    Successful_RL_InformationRespList_RL_SetupFailureFDD = SEQ_OF(name='Successful-RL-InformationRespList-RL-SetupFailureFDD', mode=MODE_TYPE)
    _Successful_RL_InformationRespList_RL_SetupFailureFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Successful-RL-InformationRespItem-RL-SetupFailureFDD')))
    ___Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 271), ('criticality', 'ignore'), ('Value', ____Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id._const_tab = ___Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id._const_tab_at = None
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id._const_tab_id = 'id'
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality._const_tab = ___Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality._const_tab_at = ('..', 'id')
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality._const_tab_id = 'criticality'
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__value._const_tab = ___Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__value._const_tab_at = ('..', 'id')
    __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__value._const_tab_id = 'Value'
    _Successful_RL_InformationRespList_RL_SetupFailureFDD__item_._cont = ASN1Dict([
        ('id', __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id),
        ('criticality', __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality),
        ('value', __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__value),
        ])
    _Successful_RL_InformationRespList_RL_SetupFailureFDD__item_._ext = None
    Successful_RL_InformationRespList_RL_SetupFailureFDD._cont = _Successful_RL_InformationRespList_RL_SetupFailureFDD__item_
    Successful_RL_InformationRespList_RL_SetupFailureFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Successful-RL-InformationRespItemIE-RL-SetupFailureFDD >-----#
    Successful_RL_InformationRespItemIE_RL_SetupFailureFDD = CLASS(name='Successful-RL-InformationRespItemIE-RL-SetupFailureFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Successful_RL_InformationRespItemIE_RL_SetupFailureFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Successful-RL-InformationRespItem-RL-SetupFailureFDD')))
    Successful_RL_InformationRespItemIE_RL_SetupFailureFDD._val = ASN1Set(rv=[dict([('id', 271), ('criticality', 'ignore'), ('Value', _Successful_RL_InformationRespItemIE_RL_SetupFailureFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Successful-RL-InformationRespItem-RL-SetupFailureFDD >-----#
    Successful_RL_InformationRespItem_RL_SetupFailureFDD = SEQ(name='Successful-RL-InformationRespItem-RL-SetupFailureFDD', mode=MODE_TYPE)
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_rL_Set_ID = INT(name='rL-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_received_total_wide_band_power = INT(name='received-total-wide-band-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')))
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_diversityIndication = CHOICE(name='diversityIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DiversityIndication-RL-SetupFailureFDD')))
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_not_Used_dSCH_InformationResponseList = NULL(name='not-Used-dSCH-InformationResponseList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_not_Used_tFCI2_BearerInformationResponse = NULL(name='not-Used-tFCI2-BearerInformationResponse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_sSDT_SupportIndicator = ENUM(name='sSDT-SupportIndicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SSDT-SupportIndicator')))
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    ____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 651), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id),
        ('criticality', ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions._cont = __Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item_
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Successful_RL_InformationRespItem_RL_SetupFailureFDD._cont = ASN1Dict([
        ('rL-ID', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_rL_ID),
        ('rL-Set-ID', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_rL_Set_ID),
        ('received-total-wide-band-power', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_received_total_wide_band_power),
        ('diversityIndication', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_diversityIndication),
        ('not-Used-dSCH-InformationResponseList', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_not_Used_dSCH_InformationResponseList),
        ('not-Used-tFCI2-BearerInformationResponse', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_not_Used_tFCI2_BearerInformationResponse),
        ('sSDT-SupportIndicator', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_sSDT_SupportIndicator),
        ('iE-Extensions', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions),
        ])
    Successful_RL_InformationRespItem_RL_SetupFailureFDD._ext = []
    
    #-----< Successful-RL-InformationRespItem-RL-SetupFailureFDD-ExtIEs >-----#
    Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs = CLASS(name='Successful-RL-InformationRespItem-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 651), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DiversityIndication-RL-SetupFailureFDD >-----#
    DiversityIndication_RL_SetupFailureFDD = CHOICE(name='DiversityIndication-RL-SetupFailureFDD', mode=MODE_TYPE)
    _DiversityIndication_RL_SetupFailureFDD_combining = SEQ(name='combining', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Combining-RL-SetupFailureFDD')))
    _DiversityIndication_RL_SetupFailureFDD_nonCombiningOrFirstRL = SEQ(name='nonCombiningOrFirstRL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'NonCombiningOrFirstRL-RL-SetupFailureFDD')))
    DiversityIndication_RL_SetupFailureFDD._cont = ASN1Dict([
        ('combining', _DiversityIndication_RL_SetupFailureFDD_combining),
        ('nonCombiningOrFirstRL', _DiversityIndication_RL_SetupFailureFDD_nonCombiningOrFirstRL),
        ])
    DiversityIndication_RL_SetupFailureFDD._ext = None
    
    #-----< Combining-RL-SetupFailureFDD >-----#
    Combining_RL_SetupFailureFDD = SEQ(name='Combining-RL-SetupFailureFDD', mode=MODE_TYPE)
    _Combining_RL_SetupFailureFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Combining_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Combining_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Combining_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id),
        ('criticality', ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __Combining_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _Combining_RL_SetupFailureFDD_iE_Extensions._cont = __Combining_RL_SetupFailureFDD_iE_Extensions__item_
    _Combining_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Combining_RL_SetupFailureFDD._cont = ASN1Dict([
        ('rL-ID', _Combining_RL_SetupFailureFDD_rL_ID),
        ('iE-Extensions', _Combining_RL_SetupFailureFDD_iE_Extensions),
        ])
    Combining_RL_SetupFailureFDD._ext = []
    
    #-----< CombiningItem-RL-SetupFailureFDD-ExtIEs >-----#
    CombiningItem_RL_SetupFailureFDD_ExtIEs = CLASS(name='CombiningItem-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CombiningItem_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NonCombiningOrFirstRL-RL-SetupFailureFDD >-----#
    NonCombiningOrFirstRL_RL_SetupFailureFDD = SEQ(name='NonCombiningOrFirstRL-RL-SetupFailureFDD', mode=MODE_TYPE)
    _NonCombiningOrFirstRL_RL_SetupFailureFDD_dCH_InformationResponse = SEQ_OF(name='dCH-InformationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponse')))
    _NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id),
        ('criticality', ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions._cont = __NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item_
    _NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonCombiningOrFirstRL_RL_SetupFailureFDD._cont = ASN1Dict([
        ('dCH-InformationResponse', _NonCombiningOrFirstRL_RL_SetupFailureFDD_dCH_InformationResponse),
        ('iE-Extensions', _NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions),
        ])
    NonCombiningOrFirstRL_RL_SetupFailureFDD._ext = []
    
    #-----< NonCombiningOrFirstRLItem-RL-SetupFailureFDD-ExtIEs >-----#
    NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs = CLASS(name='NonCombiningOrFirstRLItem-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupFailureTDD >-----#
    RadioLinkSetupFailureTDD = SEQ(name='RadioLinkSetupFailureTDD', mode=MODE_TYPE)
    _RadioLinkSetupFailureTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupFailureTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupFailureTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-RL-SetupFailureTDD')))
    _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 329), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureTDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupFailureTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupFailureTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkSetupFailureTDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkSetupFailureTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkSetupFailureTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupFailureTDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkSetupFailureTDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupFailureTDD_protocolIEs__item_._ext = None
    _RadioLinkSetupFailureTDD_protocolIEs._cont = __RadioLinkSetupFailureTDD_protocolIEs__item_
    _RadioLinkSetupFailureTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupFailureTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupFailureTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupFailureTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupFailureTDD_protocolExtensions__item__criticality_tab
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkSetupFailureTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkSetupFailureTDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupFailureTDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupFailureTDD_protocolExtensions._cont = __RadioLinkSetupFailureTDD_protocolExtensions__item_
    _RadioLinkSetupFailureTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupFailureTDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkSetupFailureTDD_protocolIEs),
        ('protocolExtensions', _RadioLinkSetupFailureTDD_protocolExtensions),
        ])
    RadioLinkSetupFailureTDD._ext = []
    
    #-----< RadioLinkSetupFailureTDD-IEs >-----#
    RadioLinkSetupFailureTDD_IEs = CLASS(name='RadioLinkSetupFailureTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkSetupFailureTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkSetupFailureTDD_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-RL-SetupFailureTDD')))
    _RadioLinkSetupFailureTDD_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkSetupFailureTDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkSetupFailureTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 329), ('criticality', 'ignore'), ('Value', _RadioLinkSetupFailureTDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkSetupFailureTDD_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupFailureTDD-Extensions >-----#
    RadioLinkSetupFailureTDD_Extensions = CLASS(name='RadioLinkSetupFailureTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkSetupFailureTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-RL-SetupFailureTDD >-----#
    CauseLevel_RL_SetupFailureTDD = CHOICE(name='CauseLevel-RL-SetupFailureTDD', mode=MODE_TYPE)
    _CauseLevel_RL_SetupFailureTDD_generalCause = SEQ(name='generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'GeneralCauseList-RL-SetupFailureTDD')))
    _CauseLevel_RL_SetupFailureTDD_rLSpecificCause = SEQ(name='rLSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RLSpecificCauseList-RL-SetupFailureTDD')))
    CauseLevel_RL_SetupFailureTDD._cont = ASN1Dict([
        ('generalCause', _CauseLevel_RL_SetupFailureTDD_generalCause),
        ('rLSpecificCause', _CauseLevel_RL_SetupFailureTDD_rLSpecificCause),
        ])
    CauseLevel_RL_SetupFailureTDD._ext = []
    
    #-----< GeneralCauseList-RL-SetupFailureTDD >-----#
    GeneralCauseList_RL_SetupFailureTDD = SEQ(name='GeneralCauseList-RL-SetupFailureTDD', mode=MODE_TYPE)
    _GeneralCauseList_RL_SetupFailureTDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _GeneralCauseList_RL_SetupFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab = ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id),
        ('criticality', ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item_._ext = None
    _GeneralCauseList_RL_SetupFailureTDD_iE_Extensions._cont = __GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item_
    _GeneralCauseList_RL_SetupFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_RL_SetupFailureTDD._cont = ASN1Dict([
        ('cause', _GeneralCauseList_RL_SetupFailureTDD_cause),
        ('iE-Extensions', _GeneralCauseList_RL_SetupFailureTDD_iE_Extensions),
        ])
    GeneralCauseList_RL_SetupFailureTDD._ext = []
    
    #-----< GeneralCauseItem-RL-SetupFailureTDD-ExtIEs >-----#
    GeneralCauseItem_RL_SetupFailureTDD_ExtIEs = CLASS(name='GeneralCauseItem-RL-SetupFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GeneralCauseItem_RL_SetupFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLSpecificCauseList-RL-SetupFailureTDD >-----#
    RLSpecificCauseList_RL_SetupFailureTDD = SEQ(name='RLSpecificCauseList-RL-SetupFailureTDD', mode=MODE_TYPE)
    _RLSpecificCauseList_RL_SetupFailureTDD_unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD = SEQ(name='unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD')))
    _RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab = ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab = ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id),
        ('criticality', ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item_._ext = None
    _RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions._cont = __RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item_
    _RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLSpecificCauseList_RL_SetupFailureTDD._cont = ASN1Dict([
        ('unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD', _RLSpecificCauseList_RL_SetupFailureTDD_unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD),
        ('iE-Extensions', _RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions),
        ])
    RLSpecificCauseList_RL_SetupFailureTDD._ext = []
    
    #-----< RLSpecificCauseItem-RL-SetupFailureTDD-ExtIEs >-----#
    RLSpecificCauseItem_RL_SetupFailureTDD_ExtIEs = CLASS(name='RLSpecificCauseItem-RL-SetupFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RLSpecificCauseItem_RL_SetupFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD >-----#
    Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD = SEQ(name='Unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationResp-RL-SetupFailureTDD')))
    __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab._val = ASN1Set(rv=[dict([('id', 301), ('criticality', 'ignore'), ('Value', ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id._const_tab = __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id._const_tab_at = None
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id._const_tab_id = 'id'
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality._const_tab = __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality._const_tab_at = ('..', 'id')
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality._const_tab_id = 'criticality'
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value._const_tab = __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value._const_tab_at = ('..', 'id')
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value._const_tab_id = 'Value'
    Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD._cont = ASN1Dict([
        ('id', _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id),
        ('criticality', _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality),
        ('value', _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value),
        ])
    Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD._ext = None
    
    #-----< Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureTDD >-----#
    Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD = CLASS(name='Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationResp-RL-SetupFailureTDD')))
    Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD._val = ASN1Set(rv=[dict([('id', 301), ('criticality', 'ignore'), ('Value', _Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Unsuccessful-RL-InformationResp-RL-SetupFailureTDD >-----#
    Unsuccessful_RL_InformationResp_RL_SetupFailureTDD = SEQ(name='Unsuccessful-RL-InformationResp-RL-SetupFailureTDD', mode=MODE_TYPE)
    _Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab = ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__id_tab
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab = ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__id),
        ('criticality', ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item_._ext = None
    _Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions._cont = __Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item_
    _Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Unsuccessful_RL_InformationResp_RL_SetupFailureTDD._cont = ASN1Dict([
        ('rL-ID', _Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_rL_ID),
        ('cause', _Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_cause),
        ('iE-Extensions', _Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions),
        ])
    Unsuccessful_RL_InformationResp_RL_SetupFailureTDD._ext = []
    
    #-----< Unsuccessful-RL-InformationResp-RL-SetupFailureTDD-ExtIEs >-----#
    Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_ExtIEs = CLASS(name='Unsuccessful-RL-InformationResp-RL-SetupFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionRequestFDD >-----#
    RadioLinkAdditionRequestFDD = SEQ(name='RadioLinkAdditionRequestFDD', mode=MODE_TYPE)
    _RadioLinkAdditionRequestFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Compressed-Mode-Deactivation-Flag')))
    _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-AdditionRqstFDD')))
    ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'notify'), ('Value', _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkAdditionRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionRequestFDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkAdditionRequestFDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionRequestFDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionRequestFDD_protocolIEs._cont = __RadioLinkAdditionRequestFDD_protocolIEs__item_
    _RadioLinkAdditionRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionRequestFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Initial-DL-DPCH-TimingAdjustment-Allowed')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Serving-E-DCH-RL-ID')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Serving-Cell-Change-Info')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DPCH-Information-RL-AdditionReqFDD')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Addition-List')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Add-Req')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Active-Pattern-Sequence-Information')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Decoupling-Indication')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_12 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH2-Information')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Downlink-TPC-enhancements-Information')))
    ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 652), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 679), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 702), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 700), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 772), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 667), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'conditional')]), dict([('id', 1039), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1092), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1122), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 315), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1208), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 1295), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 1296), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 1297), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 1307), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkAdditionRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionRequestFDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionRequestFDD_protocolExtensions._cont = __RadioLinkAdditionRequestFDD_protocolExtensions__item_
    _RadioLinkAdditionRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionRequestFDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkAdditionRequestFDD_protocolIEs),
        ('protocolExtensions', _RadioLinkAdditionRequestFDD_protocolExtensions),
        ])
    RadioLinkAdditionRequestFDD._ext = []
    
    #-----< RadioLinkAdditionRequestFDD-IEs >-----#
    RadioLinkAdditionRequestFDD_IEs = CLASS(name='RadioLinkAdditionRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkAdditionRequestFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkAdditionRequestFDD_IEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Compressed-Mode-Deactivation-Flag')))
    _RadioLinkAdditionRequestFDD_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-AdditionRqstFDD')))
    RadioLinkAdditionRequestFDD_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _RadioLinkAdditionRequestFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _RadioLinkAdditionRequestFDD_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'notify'), ('Value', _RadioLinkAdditionRequestFDD_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionRequestFDD-Extensions >-----#
    RadioLinkAdditionRequestFDD_Extensions = CLASS(name='RadioLinkAdditionRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Initial-DL-DPCH-TimingAdjustment-Allowed')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Serving-E-DCH-RL-ID')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Serving-Cell-Change-Info')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DPCH-Information-RL-AdditionReqFDD')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Addition-List')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Add-Req')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Active-Pattern-Sequence-Information')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Decoupling-Indication')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_12 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH2-Information')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Downlink-TPC-enhancements-Information')))
    RadioLinkAdditionRequestFDD_Extensions._val = ASN1Set(rv=[dict([('id', 652), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 679), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 702), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 700), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 772), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 667), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_5), ('presence', 'conditional')]), dict([('id', 1039), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 1092), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 1122), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 315), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 1208), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 1295), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 1296), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 1297), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 1307), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_14), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Addition-List >-----#
    Additional_HS_Cell_Information_RL_Addition_List = SEQ_OF(name='Additional-HS-Cell-Information-RL-Addition-List', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Addition_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Addition-ItemIEs')))
    Additional_HS_Cell_Information_RL_Addition_List._cont = _Additional_HS_Cell_Information_RL_Addition_List__item_
    Additional_HS_Cell_Information_RL_Addition_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Cell-Information-RL-Add-Req >-----#
    Additional_EDCH_Cell_Information_RL_Add_Req = SEQ(name='Additional-EDCH-Cell-Information-RL-Add-Req', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_RL_Add_Req_setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency = CHOICE(name='setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency')))
    _Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions._cont = __Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_RL_Add_Req._cont = ASN1Dict([
        ('setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency', _Additional_EDCH_Cell_Information_RL_Add_Req_setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency),
        ('iE-Extensions', _Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_RL_Add_Req._ext = []
    
    #-----< Additional-EDCH-Cell-Information-RL-Add-Req-ExtIEs >-----#
    Additional_EDCH_Cell_Information_RL_Add_Req_ExtIEs = CLASS(name='Additional-EDCH-Cell-Information-RL-Add-Req-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_RL_Add_Req_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency >-----#
    Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency = CHOICE(name='Setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency', mode=MODE_TYPE)
    _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_setup = SEQ(name='setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Setup-Info')))
    _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_addition = SEQ_OF(name='addition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-To-Add-List')))
    Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency._cont = ASN1Dict([
        ('setup', _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_setup),
        ('addition', _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_addition),
        ])
    Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency._ext = []
    
    #-----< Additional-HS-Cell-Information-RL-Addition-ItemIEs >-----#
    Additional_HS_Cell_Information_RL_Addition_ItemIEs = SEQ(name='Additional-HS-Cell-Information-RL-Addition-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hSPDSCH_RL_ID = INT(name='hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information = SEQ(name='hS-DSCH-FDD-Secondary-Serving-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information')))
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_RL_Addition_ItemIEs._cont = ASN1Dict([
        ('hSPDSCH-RL-ID', _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hSPDSCH_RL_ID),
        ('c-ID', _Additional_HS_Cell_Information_RL_Addition_ItemIEs_c_ID),
        ('hS-DSCH-FDD-Secondary-Serving-Information', _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information),
        ('iE-Extensions', _Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_RL_Addition_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-RL-Addition-ItemIEs-ExtIEs >-----#
    Additional_HS_Cell_Information_RL_Addition_ItemIEs_ExtIEs = CLASS(name='Additional-HS-Cell-Information-RL-Addition-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_RL_Addition_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-AdditionRqstFDD >-----#
    RL_InformationList_RL_AdditionRqstFDD = SEQ_OF(name='RL-InformationList-RL-AdditionRqstFDD', mode=MODE_TYPE)
    _RL_InformationList_RL_AdditionRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_AdditionRqstFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_AdditionRqstFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-AdditionRqstFDD')))
    ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 205), ('criticality', 'notify'), ('Value', ____RL_InformationList_RL_AdditionRqstFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_AdditionRqstFDD__item__id._const_tab = ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab
    __RL_InformationList_RL_AdditionRqstFDD__item__id._const_tab_at = None
    __RL_InformationList_RL_AdditionRqstFDD__item__id._const_tab_id = 'id'
    __RL_InformationList_RL_AdditionRqstFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationList_RL_AdditionRqstFDD__item__criticality._const_tab = ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab
    __RL_InformationList_RL_AdditionRqstFDD__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_AdditionRqstFDD__item__criticality._const_tab_id = 'criticality'
    __RL_InformationList_RL_AdditionRqstFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationList_RL_AdditionRqstFDD__item__value._const_tab = ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab
    __RL_InformationList_RL_AdditionRqstFDD__item__value._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_AdditionRqstFDD__item__value._const_tab_id = 'Value'
    _RL_InformationList_RL_AdditionRqstFDD__item_._cont = ASN1Dict([
        ('id', __RL_InformationList_RL_AdditionRqstFDD__item__id),
        ('criticality', __RL_InformationList_RL_AdditionRqstFDD__item__criticality),
        ('value', __RL_InformationList_RL_AdditionRqstFDD__item__value),
        ])
    _RL_InformationList_RL_AdditionRqstFDD__item_._ext = None
    RL_InformationList_RL_AdditionRqstFDD._cont = _RL_InformationList_RL_AdditionRqstFDD__item_
    RL_InformationList_RL_AdditionRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< RL-InformationItemIE-RL-AdditionRqstFDD >-----#
    RL_InformationItemIE_RL_AdditionRqstFDD = CLASS(name='RL-InformationItemIE-RL-AdditionRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationItemIE_RL_AdditionRqstFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-AdditionRqstFDD')))
    RL_InformationItemIE_RL_AdditionRqstFDD._val = ASN1Set(rv=[dict([('id', 205), ('criticality', 'notify'), ('Value', _RL_InformationItemIE_RL_AdditionRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-RL-AdditionRqstFDD >-----#
    RL_InformationItem_RL_AdditionRqstFDD = SEQ(name='RL-InformationItem-RL-AdditionRqstFDD', mode=MODE_TYPE)
    _RL_InformationItem_RL_AdditionRqstFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationItem_RL_AdditionRqstFDD_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _RL_InformationItem_RL_AdditionRqstFDD_frameOffset = INT(name='frameOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FrameOffset')))
    _RL_InformationItem_RL_AdditionRqstFDD_chipOffset = INT(name='chipOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ChipOffset')))
    _RL_InformationItem_RL_AdditionRqstFDD_diversityControlField = ENUM(name='diversityControlField', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DiversityControlField')))
    _RL_InformationItem_RL_AdditionRqstFDD_dl_CodeInformation = SEQ_OF(name='dl-CodeInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-CodeInformation')))
    _RL_InformationItem_RL_AdditionRqstFDD_initialDL_TransmissionPower = INT(name='initialDL-TransmissionPower', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationItem_RL_AdditionRqstFDD_maximumDL_Power = INT(name='maximumDL-Power', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationItem_RL_AdditionRqstFDD_minimumDL_Power = INT(name='minimumDL-Power', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationItem_RL_AdditionRqstFDD_not_Used_sSDT_CellIdentity = NULL(name='not-Used-sSDT-CellIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationItem_RL_AdditionRqstFDD_transmitDiversityIndicator = ENUM(name='transmitDiversityIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransmitDiversityIndicator')), opt=True)
    _RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DelayedActivation')))
    _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RL-Indication')))
    _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-E-DCH-Info')))
    _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationIndicator')))
    _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')))
    _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information')))
    _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    ____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 674), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 686), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 657), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 870), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1033), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1174), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1215), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id._const_tab = ____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id),
        ('criticality', ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item_._ext = None
    _RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions._cont = __RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item_
    _RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_RL_AdditionRqstFDD._cont = ASN1Dict([
        ('rL-ID', _RL_InformationItem_RL_AdditionRqstFDD_rL_ID),
        ('c-ID', _RL_InformationItem_RL_AdditionRqstFDD_c_ID),
        ('frameOffset', _RL_InformationItem_RL_AdditionRqstFDD_frameOffset),
        ('chipOffset', _RL_InformationItem_RL_AdditionRqstFDD_chipOffset),
        ('diversityControlField', _RL_InformationItem_RL_AdditionRqstFDD_diversityControlField),
        ('dl-CodeInformation', _RL_InformationItem_RL_AdditionRqstFDD_dl_CodeInformation),
        ('initialDL-TransmissionPower', _RL_InformationItem_RL_AdditionRqstFDD_initialDL_TransmissionPower),
        ('maximumDL-Power', _RL_InformationItem_RL_AdditionRqstFDD_maximumDL_Power),
        ('minimumDL-Power', _RL_InformationItem_RL_AdditionRqstFDD_minimumDL_Power),
        ('not-Used-sSDT-CellIdentity', _RL_InformationItem_RL_AdditionRqstFDD_not_Used_sSDT_CellIdentity),
        ('transmitDiversityIndicator', _RL_InformationItem_RL_AdditionRqstFDD_transmitDiversityIndicator),
        ('iE-Extensions', _RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions),
        ])
    RL_InformationItem_RL_AdditionRqstFDD._ext = []
    
    #-----< RL-InformationItem-RL-AdditionRqstFDD-ExtIEs >-----#
    RL_InformationItem_RL_AdditionRqstFDD_ExtIEs = CLASS(name='RL-InformationItem-RL-AdditionRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DelayedActivation')))
    _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RL-Indication')))
    _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-E-DCH-Info')))
    _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationIndicator')))
    _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')))
    _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information')))
    _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    RL_InformationItem_RL_AdditionRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Extension', _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 674), ('criticality', 'reject'), ('Extension', _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 686), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 657), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 870), ('criticality', 'reject'), ('Extension', _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 1033), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 1174), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 1215), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_10), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DPCH-Information-RL-AdditionReqFDD >-----#
    E_DPCH_Information_RL_AdditionReqFDD = SEQ(name='E-DPCH-Information-RL-AdditionReqFDD', mode=MODE_TYPE)
    _E_DPCH_Information_RL_AdditionReqFDD_maxSet_E_DPDCHs = ENUM(name='maxSet-E-DPDCHs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-Set-E-DPDCHs')))
    _E_DPCH_Information_RL_AdditionReqFDD_ul_PunctureLimit = INT(name='ul-PunctureLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')))
    _E_DPCH_Information_RL_AdditionReqFDD_e_TFCS_Information = SEQ(name='e-TFCS-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information')))
    _E_DPCH_Information_RL_AdditionReqFDD_e_TTI = ENUM(name='e-TTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TTI')))
    _E_DPCH_Information_RL_AdditionReqFDD_e_DPCCH_PO = INT(name='e-DPCCH-PO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-PO')))
    _E_DPCH_Information_RL_AdditionReqFDD_e_RGCH_2_IndexStepThreshold = INT(name='e-RGCH-2-IndexStepThreshold', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-2-IndexStepThreshold')))
    _E_DPCH_Information_RL_AdditionReqFDD_e_RGCH_3_IndexStepThreshold = INT(name='e-RGCH-3-IndexStepThreshold', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-3-IndexStepThreshold')))
    _E_DPCH_Information_RL_AdditionReqFDD_hARQ_Info_for_E_DCH = ENUM(name='hARQ-Info-for-E-DCH', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Info-for-E-DCH')))
    _E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Configured-Indicator')))
    _____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    ____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 783), ('criticality', 'reject'), ('Extension', _____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'mandatory')]), dict([('id', 999), ('criticality', 'ignore'), ('Extension', _____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id._const_tab = ____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id._const_tab_at = None
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__criticality._const_tab = ____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__extensionValue._const_tab = ____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id),
        ('criticality', ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__extensionValue),
        ])
    __E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item_._ext = None
    _E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions._cont = __E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item_
    _E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DPCH_Information_RL_AdditionReqFDD._cont = ASN1Dict([
        ('maxSet-E-DPDCHs', _E_DPCH_Information_RL_AdditionReqFDD_maxSet_E_DPDCHs),
        ('ul-PunctureLimit', _E_DPCH_Information_RL_AdditionReqFDD_ul_PunctureLimit),
        ('e-TFCS-Information', _E_DPCH_Information_RL_AdditionReqFDD_e_TFCS_Information),
        ('e-TTI', _E_DPCH_Information_RL_AdditionReqFDD_e_TTI),
        ('e-DPCCH-PO', _E_DPCH_Information_RL_AdditionReqFDD_e_DPCCH_PO),
        ('e-RGCH-2-IndexStepThreshold', _E_DPCH_Information_RL_AdditionReqFDD_e_RGCH_2_IndexStepThreshold),
        ('e-RGCH-3-IndexStepThreshold', _E_DPCH_Information_RL_AdditionReqFDD_e_RGCH_3_IndexStepThreshold),
        ('hARQ-Info-for-E-DCH', _E_DPCH_Information_RL_AdditionReqFDD_hARQ_Info_for_E_DCH),
        ('iE-Extensions', _E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions),
        ])
    E_DPCH_Information_RL_AdditionReqFDD._ext = []
    
    #-----< E-DPCH-Information-RL-AdditionReqFDD-ExtIEs >-----#
    E_DPCH_Information_RL_AdditionReqFDD_ExtIEs = CLASS(name='E-DPCH-Information-RL-AdditionReqFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DPCH_Information_RL_AdditionReqFDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Configured-Indicator')))
    _E_DPCH_Information_RL_AdditionReqFDD_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    E_DPCH_Information_RL_AdditionReqFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 783), ('criticality', 'reject'), ('Extension', _E_DPCH_Information_RL_AdditionReqFDD_ExtIEs_val_Extension_0), ('presence', 'mandatory')]), dict([('id', 999), ('criticality', 'ignore'), ('Extension', _E_DPCH_Information_RL_AdditionReqFDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionRequestTDD >-----#
    RadioLinkAdditionRequestTDD = SEQ(name='RadioLinkAdditionRequestTDD', mode=MODE_TYPE)
    _RadioLinkAdditionRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationList-RL-AdditionRqstTDD')))
    _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationList-RL-AdditionRqstTDD')))
    _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Information-RL-AdditionRqstTDD')))
    ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 285), ('criticality', 'reject'), ('Value', _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'reject'), ('Value', _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 227), ('criticality', 'reject'), ('Value', _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkAdditionRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionRequestTDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkAdditionRequestTDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionRequestTDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionRequestTDD_protocolIEs._cont = __RadioLinkAdditionRequestTDD_protocolIEs__item_
    _RadioLinkAdditionRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-768-Information')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LCR-Information')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-InformationLCR')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-LCR')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-LCR')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IdleIntervalInformation')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_12 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Selected-MBMS-Service-Information')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Info')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_16 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-InformationLCR')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 536), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 799), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 809), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 813), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 847), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 941), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1054), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1049), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1048), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 1063), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 1074), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 1154), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 1167), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 1187), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 1192), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 1258), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_17), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkAdditionRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionRequestTDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionRequestTDD_protocolExtensions._cont = __RadioLinkAdditionRequestTDD_protocolExtensions__item_
    _RadioLinkAdditionRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkAdditionRequestTDD_protocolIEs),
        ('protocolExtensions', _RadioLinkAdditionRequestTDD_protocolExtensions),
        ])
    RadioLinkAdditionRequestTDD._ext = []
    
    #-----< RadioLinkAdditionRequestTDD-IEs >-----#
    RadioLinkAdditionRequestTDD_IEs = CLASS(name='RadioLinkAdditionRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkAdditionRequestTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkAdditionRequestTDD_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationList-RL-AdditionRqstTDD')))
    _RadioLinkAdditionRequestTDD_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationList-RL-AdditionRqstTDD')))
    _RadioLinkAdditionRequestTDD_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Information-RL-AdditionRqstTDD')))
    RadioLinkAdditionRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _RadioLinkAdditionRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 285), ('criticality', 'reject'), ('Value', _RadioLinkAdditionRequestTDD_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'reject'), ('Value', _RadioLinkAdditionRequestTDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 227), ('criticality', 'reject'), ('Value', _RadioLinkAdditionRequestTDD_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionRequestTDD-Extensions >-----#
    RadioLinkAdditionRequestTDD_Extensions = CLASS(name='RadioLinkAdditionRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-768-Information')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LCR-Information')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-InformationLCR')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-LCR')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-LCR')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IdleIntervalInformation')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_12 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Selected-MBMS-Service-Information')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_13 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_14 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Info')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_16 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-InformationLCR')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    RadioLinkAdditionRequestTDD_Extensions._val = ASN1Set(rv=[dict([('id', 536), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_1), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 799), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 809), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 813), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 847), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 941), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 1054), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 1049), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 1048), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 1063), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 1074), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 1154), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 1167), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 1187), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_15), ('presence', 'optional')]), dict([('id', 1192), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_16), ('presence', 'optional')]), dict([('id', 1258), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_17), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationList-RL-AdditionRqstTDD >-----#
    UL_CCTrCH_InformationList_RL_AdditionRqstTDD = SEQ_OF(name='UL-CCTrCH-InformationList-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD')))
    UL_CCTrCH_InformationList_RL_AdditionRqstTDD._cont = _UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_
    UL_CCTrCH_InformationList_RL_AdditionRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationItem-RL-AdditionRqstTDD >-----#
    UL_CCTrCH_InformationItem_RL_AdditionRqstTDD = SEQ(name='UL-CCTrCH-InformationItem-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_uL_DPCH_Information = SEQ(name='uL-DPCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationList-RL-AdditionRqstTDD')), opt=True)
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD')))
    _____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationItem-768-RL-AdditionRqstTDD')))
    ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 473), ('criticality', 'notify'), ('Extension', _____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 561), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 748), ('criticality', 'notify'), ('Extension', _____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id),
        ('criticality', ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._cont = __UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationItem_RL_AdditionRqstTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID),
        ('uL-DPCH-Information', _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_uL_DPCH_Information),
        ('iE-Extensions', _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationItem_RL_AdditionRqstTDD._ext = []
    
    #-----< UL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs >-----#
    UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs = CLASS(name='UL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD')))
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationItem-768-RL-AdditionRqstTDD')))
    UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 473), ('criticality', 'notify'), ('Extension', _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 561), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 748), ('criticality', 'notify'), ('Extension', _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationList-RL-AdditionRqstTDD >-----#
    UL_DPCH_InformationList_RL_AdditionRqstTDD = SEQ(name='UL-DPCH-InformationList-RL-AdditionRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __UL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-AdditionRqstTDD')))
    __UL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 289), ('criticality', 'notify'), ('Value', ___UL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_id._const_tab = __UL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_id._const_tab_at = None
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_id._const_tab_id = 'id'
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_criticality._const_tab = __UL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_criticality._const_tab_at = ('..', 'id')
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_criticality._const_tab_id = 'criticality'
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_value._const_tab = __UL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_value._const_tab_at = ('..', 'id')
    _UL_DPCH_InformationList_RL_AdditionRqstTDD_value._const_tab_id = 'Value'
    UL_DPCH_InformationList_RL_AdditionRqstTDD._cont = ASN1Dict([
        ('id', _UL_DPCH_InformationList_RL_AdditionRqstTDD_id),
        ('criticality', _UL_DPCH_InformationList_RL_AdditionRqstTDD_criticality),
        ('value', _UL_DPCH_InformationList_RL_AdditionRqstTDD_value),
        ])
    UL_DPCH_InformationList_RL_AdditionRqstTDD._ext = None
    
    #-----< UL-DPCH-InformationItemIE-RL-AdditionRqstTDD >-----#
    UL_DPCH_InformationItemIE_RL_AdditionRqstTDD = CLASS(name='UL-DPCH-InformationItemIE-RL-AdditionRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UL_DPCH_InformationItemIE_RL_AdditionRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-AdditionRqstTDD')))
    UL_DPCH_InformationItemIE_RL_AdditionRqstTDD._val = ASN1Set(rv=[dict([('id', 289), ('criticality', 'notify'), ('Value', _UL_DPCH_InformationItemIE_RL_AdditionRqstTDD_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationItem-RL-AdditionRqstTDD >-----#
    UL_DPCH_InformationItem_RL_AdditionRqstTDD = SEQ(name='UL-DPCH-InformationItem-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationItem_RL_AdditionRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationItem_RL_AdditionRqstTDD_uL_Timeslot_Information = SEQ_OF(name='uL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-Timeslot-Information')))
    _UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._cont = __UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_
    _UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationItem_RL_AdditionRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_InformationItem_RL_AdditionRqstTDD_tdd_DPCHOffset),
        ('uL-Timeslot-Information', _UL_DPCH_InformationItem_RL_AdditionRqstTDD_uL_Timeslot_Information),
        ('iE-Extensions', _UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions),
        ])
    UL_DPCH_InformationItem_RL_AdditionRqstTDD._ext = []
    
    #-----< UL-DPCH-InformationItem-RL-AdditionRqstTDD-ExtIEs >-----#
    UL_DPCH_InformationItem_RL_AdditionRqstTDD_ExtIEs = CLASS(name='UL-DPCH-InformationItem-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationItem_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD >-----#
    UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD = SEQ(name='UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_uL_TimeslotLCR_Information = SEQ_OF(name='uL-TimeslotLCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotLCR-Information')))
    _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions._cont = __UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item_
    _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_tdd_DPCHOffset),
        ('uL-TimeslotLCR-Information', _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_uL_TimeslotLCR_Information),
        ('iE-Extensions', _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions),
        ])
    UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD._ext = []
    
    #-----< UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD-ExtIEs >-----#
    UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_ExtIEs = CLASS(name='UL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationItem-768-RL-AdditionRqstTDD >-----#
    UL_DPCH_InformationItem_768_RL_AdditionRqstTDD = SEQ(name='UL-DPCH-InformationItem-768-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_uL_Timeslot768_Information = SEQ_OF(name='uL-Timeslot768-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-Timeslot768-Information')))
    _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions._cont = __UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item_
    _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationItem_768_RL_AdditionRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_tdd_DPCHOffset),
        ('uL-Timeslot768-Information', _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_uL_Timeslot768_Information),
        ('iE-Extensions', _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions),
        ])
    UL_DPCH_InformationItem_768_RL_AdditionRqstTDD._ext = []
    
    #-----< UL-DPCH-InformationItem-768-RL-AdditionRqstTDD-ExtIEs >-----#
    UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_ExtIEs = CLASS(name='UL-DPCH-InformationItem-768-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationList-RL-AdditionRqstTDD >-----#
    DL_CCTrCH_InformationList_RL_AdditionRqstTDD = SEQ_OF(name='DL-CCTrCH-InformationList-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD')))
    DL_CCTrCH_InformationList_RL_AdditionRqstTDD._cont = _DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_
    DL_CCTrCH_InformationList_RL_AdditionRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationItem-RL-AdditionRqstTDD >-----#
    DL_CCTrCH_InformationItem_RL_AdditionRqstTDD = SEQ(name='DL-CCTrCH-InformationItem-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_dL_DPCH_Information = SEQ(name='dL-DPCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationList-RL-AdditionRqstTDD')), opt=True)
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD')))
    _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationItem-768-RL-AdditionRqstTDD')))
    ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 472), ('criticality', 'notify'), ('Extension', _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 518), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 562), ('criticality', 'reject'), ('Extension', _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 569), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 570), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 747), ('criticality', 'notify'), ('Extension', _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._cont = __DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationItem_RL_AdditionRqstTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID),
        ('dL-DPCH-Information', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_dL_DPCH_Information),
        ('iE-Extensions', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationItem_RL_AdditionRqstTDD._ext = []
    
    #-----< DL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs >-----#
    DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs = CLASS(name='DL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD')))
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationItem-768-RL-AdditionRqstTDD')))
    DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 472), ('criticality', 'notify'), ('Extension', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 518), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 562), ('criticality', 'reject'), ('Extension', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 569), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 570), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 747), ('criticality', 'notify'), ('Extension', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationList-RL-AdditionRqstTDD >-----#
    DL_DPCH_InformationList_RL_AdditionRqstTDD = SEQ(name='DL-DPCH-InformationList-RL-AdditionRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-AdditionRqstTDD')))
    __DL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 77), ('criticality', 'notify'), ('Value', ___DL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_id._const_tab = __DL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_id._const_tab_at = None
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_id._const_tab_id = 'id'
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_criticality._const_tab = __DL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_criticality._const_tab_at = ('..', 'id')
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_criticality._const_tab_id = 'criticality'
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_value._const_tab = __DL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_value._const_tab_at = ('..', 'id')
    _DL_DPCH_InformationList_RL_AdditionRqstTDD_value._const_tab_id = 'Value'
    DL_DPCH_InformationList_RL_AdditionRqstTDD._cont = ASN1Dict([
        ('id', _DL_DPCH_InformationList_RL_AdditionRqstTDD_id),
        ('criticality', _DL_DPCH_InformationList_RL_AdditionRqstTDD_criticality),
        ('value', _DL_DPCH_InformationList_RL_AdditionRqstTDD_value),
        ])
    DL_DPCH_InformationList_RL_AdditionRqstTDD._ext = None
    
    #-----< DL-DPCH-InformationItemIE-RL-AdditionRqstTDD >-----#
    DL_DPCH_InformationItemIE_RL_AdditionRqstTDD = CLASS(name='DL-DPCH-InformationItemIE-RL-AdditionRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_DPCH_InformationItemIE_RL_AdditionRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-AdditionRqstTDD')))
    DL_DPCH_InformationItemIE_RL_AdditionRqstTDD._val = ASN1Set(rv=[dict([('id', 77), ('criticality', 'notify'), ('Value', _DL_DPCH_InformationItemIE_RL_AdditionRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationItem-RL-AdditionRqstTDD >-----#
    DL_DPCH_InformationItem_RL_AdditionRqstTDD = SEQ(name='DL-DPCH-InformationItem-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationItem_RL_AdditionRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationItem_RL_AdditionRqstTDD_dL_Timeslot_Information = SEQ_OF(name='dL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Timeslot-Information')))
    _DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._cont = __DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_
    _DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationItem_RL_AdditionRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_InformationItem_RL_AdditionRqstTDD_tdd_DPCHOffset),
        ('dL-Timeslot-Information', _DL_DPCH_InformationItem_RL_AdditionRqstTDD_dL_Timeslot_Information),
        ('iE-Extensions', _DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions),
        ])
    DL_DPCH_InformationItem_RL_AdditionRqstTDD._ext = []
    
    #-----< DL-DPCH-InformationItem-RL-AdditionRqstTDD-ExtIEs >-----#
    DL_DPCH_InformationItem_RL_AdditionRqstTDD_ExtIEs = CLASS(name='DL-DPCH-InformationItem-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationItem_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD >-----#
    DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD = SEQ(name='DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_dL_TimeslotLCR_Information = SEQ_OF(name='dL-TimeslotLCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotLCR-Information')))
    _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions._cont = __DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item_
    _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_tdd_DPCHOffset),
        ('dL-TimeslotLCR-Information', _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_dL_TimeslotLCR_Information),
        ('iE-Extensions', _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions),
        ])
    DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD._ext = []
    
    #-----< DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD-ExtIEs >-----#
    DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_ExtIEs = CLASS(name='DL-DPCH-InformationItem-LCR-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationItem-768-RL-AdditionRqstTDD >-----#
    DL_DPCH_InformationItem_768_RL_AdditionRqstTDD = SEQ(name='DL-DPCH-InformationItem-768-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_dL_Timeslot768_Information = SEQ_OF(name='dL-Timeslot768-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Timeslot768-Information')))
    _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions._cont = __DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item_
    _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationItem_768_RL_AdditionRqstTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_tdd_DPCHOffset),
        ('dL-Timeslot768-Information', _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_dL_Timeslot768_Information),
        ('iE-Extensions', _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions),
        ])
    DL_DPCH_InformationItem_768_RL_AdditionRqstTDD._ext = []
    
    #-----< DL-DPCH-InformationItem-768-RL-AdditionRqstTDD-ExtIEs >-----#
    DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_ExtIEs = CLASS(name='DL-DPCH-InformationItem-768-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Information-RL-AdditionRqstTDD >-----#
    RL_Information_RL_AdditionRqstTDD = SEQ(name='RL-Information-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _RL_Information_RL_AdditionRqstTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_Information_RL_AdditionRqstTDD_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _RL_Information_RL_AdditionRqstTDD_frameOffset = INT(name='frameOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FrameOffset')))
    _RL_Information_RL_AdditionRqstTDD_diversityControlField = ENUM(name='diversityControlField', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DiversityControlField')))
    _RL_Information_RL_AdditionRqstTDD_initial_DL_Transmission_Power = INT(name='initial-DL-Transmission-Power', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_Information_RL_AdditionRqstTDD_maximumDL_Power = INT(name='maximumDL-Power', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_Information_RL_AdditionRqstTDD_minimumDL_Power = INT(name='minimumDL-Power', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_Information_RL_AdditionRqstTDD_dL_TimeSlotISCPInfo = SEQ_OF(name='dL-TimeSlotISCPInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfo')), opt=True)
    _RL_Information_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfoLCR')))
    _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DelayedActivation')))
    _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 474), ('criticality', 'reject'), ('Extension', _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Extension', _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 554), ('criticality', 'reject'), ('Extension', _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Information_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id),
        ('criticality', ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _RL_Information_RL_AdditionRqstTDD_iE_Extensions._cont = __RL_Information_RL_AdditionRqstTDD_iE_Extensions__item_
    _RL_Information_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_RL_AdditionRqstTDD._cont = ASN1Dict([
        ('rL-ID', _RL_Information_RL_AdditionRqstTDD_rL_ID),
        ('c-ID', _RL_Information_RL_AdditionRqstTDD_c_ID),
        ('frameOffset', _RL_Information_RL_AdditionRqstTDD_frameOffset),
        ('diversityControlField', _RL_Information_RL_AdditionRqstTDD_diversityControlField),
        ('initial-DL-Transmission-Power', _RL_Information_RL_AdditionRqstTDD_initial_DL_Transmission_Power),
        ('maximumDL-Power', _RL_Information_RL_AdditionRqstTDD_maximumDL_Power),
        ('minimumDL-Power', _RL_Information_RL_AdditionRqstTDD_minimumDL_Power),
        ('dL-TimeSlotISCPInfo', _RL_Information_RL_AdditionRqstTDD_dL_TimeSlotISCPInfo),
        ('iE-Extensions', _RL_Information_RL_AdditionRqstTDD_iE_Extensions),
        ])
    RL_Information_RL_AdditionRqstTDD._ext = []
    
    #-----< RL-information-RL-AdditionRqstTDD-ExtIEs >-----#
    RL_information_RL_AdditionRqstTDD_ExtIEs = CLASS(name='RL-information-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfoLCR')))
    _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DelayedActivation')))
    _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    RL_information_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 474), ('criticality', 'reject'), ('Extension', _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Extension', _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 554), ('criticality', 'reject'), ('Extension', _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionResponseFDD >-----#
    RadioLinkAdditionResponseFDD = SEQ(name='RadioLinkAdditionResponseFDD', mode=MODE_TYPE)
    _RadioLinkAdditionResponseFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionResponseFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseList-RL-AdditionRspFDD')))
    _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 221), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkAdditionResponseFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionResponseFDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkAdditionResponseFDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionResponseFDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionResponseFDD_protocolIEs._cont = __RadioLinkAdditionResponseFDD_protocolIEs__item_
    _RadioLinkAdditionResponseFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionResponseFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionResponseFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Serving-Cell-Change-Info-Response')))
    _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Serving-Cell-Change-Info-Response')))
    _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAChs-ResetIndicator')))
    _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Change-Information-Response-List')))
    _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-RL-Add-List')))
    ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 701), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 699), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 826), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1040), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1123), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkAdditionResponseFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionResponseFDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionResponseFDD_protocolExtensions._cont = __RadioLinkAdditionResponseFDD_protocolExtensions__item_
    _RadioLinkAdditionResponseFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionResponseFDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkAdditionResponseFDD_protocolIEs),
        ('protocolExtensions', _RadioLinkAdditionResponseFDD_protocolExtensions),
        ])
    RadioLinkAdditionResponseFDD._ext = []
    
    #-----< RadioLinkAdditionResponseFDD-IEs >-----#
    RadioLinkAdditionResponseFDD_IEs = CLASS(name='RadioLinkAdditionResponseFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkAdditionResponseFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkAdditionResponseFDD_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseList-RL-AdditionRspFDD')))
    _RadioLinkAdditionResponseFDD_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkAdditionResponseFDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionResponseFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 221), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionResponseFDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionResponseFDD_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionResponseFDD-Extensions >-----#
    RadioLinkAdditionResponseFDD_Extensions = CLASS(name='RadioLinkAdditionResponseFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkAdditionResponseFDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Serving-Cell-Change-Info-Response')))
    _RadioLinkAdditionResponseFDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Serving-Cell-Change-Info-Response')))
    _RadioLinkAdditionResponseFDD_Extensions_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAChs-ResetIndicator')))
    _RadioLinkAdditionResponseFDD_Extensions_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Change-Information-Response-List')))
    _RadioLinkAdditionResponseFDD_Extensions_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-RL-Add-List')))
    RadioLinkAdditionResponseFDD_Extensions._val = ASN1Set(rv=[dict([('id', 701), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseFDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 699), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseFDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 826), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseFDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 1040), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseFDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 1123), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseFDD_Extensions_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Change-Information-Response-List >-----#
    Additional_HS_Cell_Change_Information_Response_List = SEQ_OF(name='Additional-HS-Cell-Change-Information-Response-List', mode=MODE_TYPE)
    _Additional_HS_Cell_Change_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Change-Information-Response-ItemIEs')))
    Additional_HS_Cell_Change_Information_Response_List._cont = _Additional_HS_Cell_Change_Information_Response_List__item_
    Additional_HS_Cell_Change_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Change-Information-Response-ItemIEs >-----#
    Additional_HS_Cell_Change_Information_Response_ItemIEs = SEQ(name='Additional-HS-Cell-Change-Information-Response-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Change_Information_Response_ItemIEs_hSPDSCH_RL_ID = INT(name='hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Change_Information_Response_ItemIEs_hS_DSCH_Secondary_Serving_Cell_Change_Information_Response = SEQ(name='hS-DSCH-Secondary-Serving-Cell-Change-Information-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response')))
    _Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Change_Information_Response_ItemIEs._cont = ASN1Dict([
        ('hSPDSCH-RL-ID', _Additional_HS_Cell_Change_Information_Response_ItemIEs_hSPDSCH_RL_ID),
        ('hS-DSCH-Secondary-Serving-Cell-Change-Information-Response', _Additional_HS_Cell_Change_Information_Response_ItemIEs_hS_DSCH_Secondary_Serving_Cell_Change_Information_Response),
        ('iE-Extensions', _Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Change_Information_Response_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Change-Information-Response-ItemIEs-ExtIEs >-----#
    Additional_HS_Cell_Change_Information_Response_ItemIEs_ExtIEs = CLASS(name='Additional-HS-Cell-Change-Information-Response-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Change_Information_Response_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponseList-RL-AdditionRspFDD >-----#
    RL_InformationResponseList_RL_AdditionRspFDD = SEQ_OF(name='RL-InformationResponseList-RL-AdditionRspFDD', mode=MODE_TYPE)
    _RL_InformationResponseList_RL_AdditionRspFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationResponseList_RL_AdditionRspFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseItem-RL-AdditionRspFDD')))
    ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 217), ('criticality', 'ignore'), ('Value', ____RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationResponseList_RL_AdditionRspFDD__item__id._const_tab = ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab
    __RL_InformationResponseList_RL_AdditionRspFDD__item__id._const_tab_at = None
    __RL_InformationResponseList_RL_AdditionRspFDD__item__id._const_tab_id = 'id'
    __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality._const_tab = ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab
    __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality._const_tab_id = 'criticality'
    __RL_InformationResponseList_RL_AdditionRspFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationResponseList_RL_AdditionRspFDD__item__value._const_tab = ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab
    __RL_InformationResponseList_RL_AdditionRspFDD__item__value._const_tab_at = ('..', 'id')
    __RL_InformationResponseList_RL_AdditionRspFDD__item__value._const_tab_id = 'Value'
    _RL_InformationResponseList_RL_AdditionRspFDD__item_._cont = ASN1Dict([
        ('id', __RL_InformationResponseList_RL_AdditionRspFDD__item__id),
        ('criticality', __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality),
        ('value', __RL_InformationResponseList_RL_AdditionRspFDD__item__value),
        ])
    _RL_InformationResponseList_RL_AdditionRspFDD__item_._ext = None
    RL_InformationResponseList_RL_AdditionRspFDD._cont = _RL_InformationResponseList_RL_AdditionRspFDD__item_
    RL_InformationResponseList_RL_AdditionRspFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< RL-InformationResponseItemIE-RL-AdditionRspFDD >-----#
    RL_InformationResponseItemIE_RL_AdditionRspFDD = CLASS(name='RL-InformationResponseItemIE-RL-AdditionRspFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationResponseItemIE_RL_AdditionRspFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseItem-RL-AdditionRspFDD')))
    RL_InformationResponseItemIE_RL_AdditionRspFDD._val = ASN1Set(rv=[dict([('id', 217), ('criticality', 'ignore'), ('Value', _RL_InformationResponseItemIE_RL_AdditionRspFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationResponseItem-RL-AdditionRspFDD >-----#
    RL_InformationResponseItem_RL_AdditionRspFDD = SEQ(name='RL-InformationResponseItem-RL-AdditionRspFDD', mode=MODE_TYPE)
    _RL_InformationResponseItem_RL_AdditionRspFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_rL_Set_ID = INT(name='rL-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_received_total_wide_band_power = INT(name='received-total-wide-band-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_diversityIndication = CHOICE(name='diversityIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DiversityIndication-RL-AdditionRspFDD')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_sSDT_SupportIndicator = ENUM(name='sSDT-SupportIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SSDT-SupportIndicator')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 651), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id),
        ('criticality', ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item_._ext = None
    _RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions._cont = __RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item_
    _RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponseItem_RL_AdditionRspFDD._cont = ASN1Dict([
        ('rL-ID', _RL_InformationResponseItem_RL_AdditionRspFDD_rL_ID),
        ('rL-Set-ID', _RL_InformationResponseItem_RL_AdditionRspFDD_rL_Set_ID),
        ('received-total-wide-band-power', _RL_InformationResponseItem_RL_AdditionRspFDD_received_total_wide_band_power),
        ('diversityIndication', _RL_InformationResponseItem_RL_AdditionRspFDD_diversityIndication),
        ('sSDT-SupportIndicator', _RL_InformationResponseItem_RL_AdditionRspFDD_sSDT_SupportIndicator),
        ('iE-Extensions', _RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions),
        ])
    RL_InformationResponseItem_RL_AdditionRspFDD._ext = []
    
    #-----< RL-InformationResponseItem-RL-AdditionRspFDD-ExtIEs >-----#
    RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs = CLASS(name='RL-InformationResponseItem-RL-AdditionRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 651), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DiversityIndication-RL-AdditionRspFDD >-----#
    DiversityIndication_RL_AdditionRspFDD = CHOICE(name='DiversityIndication-RL-AdditionRspFDD', mode=MODE_TYPE)
    _DiversityIndication_RL_AdditionRspFDD_combining = SEQ(name='combining', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Combining-RL-AdditionRspFDD')))
    _DiversityIndication_RL_AdditionRspFDD_non_combining = SEQ(name='non-combining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Non-Combining-RL-AdditionRspFDD')))
    DiversityIndication_RL_AdditionRspFDD._cont = ASN1Dict([
        ('combining', _DiversityIndication_RL_AdditionRspFDD_combining),
        ('non-combining', _DiversityIndication_RL_AdditionRspFDD_non_combining),
        ])
    DiversityIndication_RL_AdditionRspFDD._ext = None
    
    #-----< Combining-RL-AdditionRspFDD >-----#
    Combining_RL_AdditionRspFDD = SEQ(name='Combining-RL-AdditionRspFDD', mode=MODE_TYPE)
    _Combining_RL_AdditionRspFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Combining_RL_AdditionRspFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Combining_RL_AdditionRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab = ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab = ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab = ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Combining_RL_AdditionRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id),
        ('criticality', ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue),
        ])
    __Combining_RL_AdditionRspFDD_iE_Extensions__item_._ext = None
    _Combining_RL_AdditionRspFDD_iE_Extensions._cont = __Combining_RL_AdditionRspFDD_iE_Extensions__item_
    _Combining_RL_AdditionRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Combining_RL_AdditionRspFDD._cont = ASN1Dict([
        ('rL-ID', _Combining_RL_AdditionRspFDD_rL_ID),
        ('iE-Extensions', _Combining_RL_AdditionRspFDD_iE_Extensions),
        ])
    Combining_RL_AdditionRspFDD._ext = []
    
    #-----< CombiningItem-RL-AdditionRspFDD-ExtIEs >-----#
    CombiningItem_RL_AdditionRspFDD_ExtIEs = CLASS(name='CombiningItem-RL-AdditionRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    CombiningItem_RL_AdditionRspFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Non-Combining-RL-AdditionRspFDD >-----#
    Non_Combining_RL_AdditionRspFDD = SEQ(name='Non-Combining-RL-AdditionRspFDD', mode=MODE_TYPE)
    _Non_Combining_RL_AdditionRspFDD_dCH_InformationResponse = SEQ_OF(name='dCH-InformationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponse')))
    _Non_Combining_RL_AdditionRspFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Non_Combining_RL_AdditionRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    ____Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _____Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab = ____Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab = ____Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab = ____Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Non_Combining_RL_AdditionRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id),
        ('criticality', ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue),
        ])
    __Non_Combining_RL_AdditionRspFDD_iE_Extensions__item_._ext = None
    _Non_Combining_RL_AdditionRspFDD_iE_Extensions._cont = __Non_Combining_RL_AdditionRspFDD_iE_Extensions__item_
    _Non_Combining_RL_AdditionRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Non_Combining_RL_AdditionRspFDD._cont = ASN1Dict([
        ('dCH-InformationResponse', _Non_Combining_RL_AdditionRspFDD_dCH_InformationResponse),
        ('iE-Extensions', _Non_Combining_RL_AdditionRspFDD_iE_Extensions),
        ])
    Non_Combining_RL_AdditionRspFDD._ext = []
    
    #-----< Non-CombiningItem-RL-AdditionRspFDD-ExtIEs >-----#
    Non_CombiningItem_RL_AdditionRspFDD_ExtIEs = CLASS(name='Non-CombiningItem-RL-AdditionRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Non_CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    Non_CombiningItem_RL_AdditionRspFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _Non_CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionResponseTDD >-----#
    RadioLinkAdditionResponseTDD = SEQ(name='RadioLinkAdditionResponseTDD', mode=MODE_TYPE)
    _RadioLinkAdditionResponseTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionResponseTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponse-RL-AdditionRspTDD')))
    _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 225), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkAdditionResponseTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionResponseTDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkAdditionResponseTDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionResponseTDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionResponseTDD_protocolIEs._cont = __RadioLinkAdditionResponseTDD_protocolIEs__item_
    _RadioLinkAdditionResponseTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionResponseTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionResponseTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponse-LCR-RL-AdditionRspTDD')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Response')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-Response')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_9 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 537), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 800), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1055), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1057), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1058), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1189), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1193), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1256), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1257), ('criticality', 'reject'), ('Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkAdditionResponseTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionResponseTDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionResponseTDD_protocolExtensions._cont = __RadioLinkAdditionResponseTDD_protocolExtensions__item_
    _RadioLinkAdditionResponseTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionResponseTDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkAdditionResponseTDD_protocolIEs),
        ('protocolExtensions', _RadioLinkAdditionResponseTDD_protocolExtensions),
        ])
    RadioLinkAdditionResponseTDD._ext = []
    
    #-----< RadioLinkAdditionResponseTDD-IEs >-----#
    RadioLinkAdditionResponseTDD_IEs = CLASS(name='RadioLinkAdditionResponseTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkAdditionResponseTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkAdditionResponseTDD_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponse-RL-AdditionRspTDD')))
    _RadioLinkAdditionResponseTDD_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkAdditionResponseTDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionResponseTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 225), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionResponseTDD_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionResponseTDD_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionResponseTDD-Extensions >-----#
    RadioLinkAdditionResponseTDD_Extensions = CLASS(name='RadioLinkAdditionResponseTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponse-LCR-RL-AdditionRspTDD')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Response')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-Response')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_9 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    RadioLinkAdditionResponseTDD_Extensions._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 537), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 800), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 1055), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 1057), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 1058), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 1189), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 1193), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 1256), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 1257), ('criticality', 'reject'), ('Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_9), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponse-RL-AdditionRspTDD >-----#
    RL_InformationResponse_RL_AdditionRspTDD = SEQ(name='RL-InformationResponse-RL-AdditionRspTDD', mode=MODE_TYPE)
    _RL_InformationResponse_RL_AdditionRspTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationResponse_RL_AdditionRspTDD_uL_TimeSlot_ISCP_Info = SEQ_OF(name='uL-TimeSlot-ISCP-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeSlot-ISCP-Info')))
    _RL_InformationResponse_RL_AdditionRspTDD_ul_PhysCH_SF_Variation = ENUM(name='ul-PhysCH-SF-Variation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-PhysCH-SF-Variation')))
    _RL_InformationResponse_RL_AdditionRspTDD_dCH_Information = SEQ(name='dCH-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-Information-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_dSCH_InformationResponseList = SEQ(name='dSCH-InformationResponseList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-InformationResponseList-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_uSCH_InformationResponseList = SEQ(name='uSCH-InformationResponseList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-InformationResponseList-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id),
        ('criticality', ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions._cont = __RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_
    _RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponse_RL_AdditionRspTDD._cont = ASN1Dict([
        ('rL-ID', _RL_InformationResponse_RL_AdditionRspTDD_rL_ID),
        ('uL-TimeSlot-ISCP-Info', _RL_InformationResponse_RL_AdditionRspTDD_uL_TimeSlot_ISCP_Info),
        ('ul-PhysCH-SF-Variation', _RL_InformationResponse_RL_AdditionRspTDD_ul_PhysCH_SF_Variation),
        ('dCH-Information', _RL_InformationResponse_RL_AdditionRspTDD_dCH_Information),
        ('dSCH-InformationResponseList', _RL_InformationResponse_RL_AdditionRspTDD_dSCH_InformationResponseList),
        ('uSCH-InformationResponseList', _RL_InformationResponse_RL_AdditionRspTDD_uSCH_InformationResponseList),
        ('iE-Extensions', _RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions),
        ])
    RL_InformationResponse_RL_AdditionRspTDD._ext = []
    
    #-----< RL-InformationResponse-RL-AdditionRspTDD-ExtIEs >-----#
    RL_InformationResponse_RL_AdditionRspTDD_ExtIEs = CLASS(name='RL-InformationResponse-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_InformationResponse_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-Information-RL-AdditionRspTDD >-----#
    DCH_Information_RL_AdditionRspTDD = SEQ(name='DCH-Information-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DCH_Information_RL_AdditionRspTDD_diversityIndication = CHOICE(name='diversityIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DiversityIndication-RL-AdditionRspTDD')))
    _DCH_Information_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_Information_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_Information_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id),
        ('criticality', ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_Information_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _DCH_Information_RL_AdditionRspTDD_iE_Extensions._cont = __DCH_Information_RL_AdditionRspTDD_iE_Extensions__item_
    _DCH_Information_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_Information_RL_AdditionRspTDD._cont = ASN1Dict([
        ('diversityIndication', _DCH_Information_RL_AdditionRspTDD_diversityIndication),
        ('iE-Extensions', _DCH_Information_RL_AdditionRspTDD_iE_Extensions),
        ])
    DCH_Information_RL_AdditionRspTDD._ext = []
    
    #-----< DCH-Information-RL-AdditionRspTDD-ExtIEs >-----#
    DCH_Information_RL_AdditionRspTDD_ExtIEs = CLASS(name='DCH-Information-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DCH_Information_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DiversityIndication-RL-AdditionRspTDD >-----#
    DiversityIndication_RL_AdditionRspTDD = CHOICE(name='DiversityIndication-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DiversityIndication_RL_AdditionRspTDD_combining = SEQ(name='combining', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Combining-RL-AdditionRspTDD')))
    _DiversityIndication_RL_AdditionRspTDD_non_Combining = SEQ(name='non-Combining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Non-Combining-RL-AdditionRspTDD')))
    DiversityIndication_RL_AdditionRspTDD._cont = ASN1Dict([
        ('combining', _DiversityIndication_RL_AdditionRspTDD_combining),
        ('non-Combining', _DiversityIndication_RL_AdditionRspTDD_non_Combining),
        ])
    DiversityIndication_RL_AdditionRspTDD._ext = None
    
    #-----< Combining-RL-AdditionRspTDD >-----#
    Combining_RL_AdditionRspTDD = SEQ(name='Combining-RL-AdditionRspTDD', mode=MODE_TYPE)
    _Combining_RL_AdditionRspTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Combining_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Combining_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Combining_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id),
        ('criticality', ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __Combining_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _Combining_RL_AdditionRspTDD_iE_Extensions._cont = __Combining_RL_AdditionRspTDD_iE_Extensions__item_
    _Combining_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Combining_RL_AdditionRspTDD._cont = ASN1Dict([
        ('rL-ID', _Combining_RL_AdditionRspTDD_rL_ID),
        ('iE-Extensions', _Combining_RL_AdditionRspTDD_iE_Extensions),
        ])
    Combining_RL_AdditionRspTDD._ext = []
    
    #-----< CombiningItem-RL-AdditionRspTDD-ExtIEs >-----#
    CombiningItem_RL_AdditionRspTDD_ExtIEs = CLASS(name='CombiningItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CombiningItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Non-Combining-RL-AdditionRspTDD >-----#
    Non_Combining_RL_AdditionRspTDD = SEQ(name='Non-Combining-RL-AdditionRspTDD', mode=MODE_TYPE)
    _Non_Combining_RL_AdditionRspTDD_dCH_InformationResponse = SEQ_OF(name='dCH-InformationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponse')))
    _Non_Combining_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Non_Combining_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Non_Combining_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__id),
        ('criticality', ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __Non_Combining_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _Non_Combining_RL_AdditionRspTDD_iE_Extensions._cont = __Non_Combining_RL_AdditionRspTDD_iE_Extensions__item_
    _Non_Combining_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Non_Combining_RL_AdditionRspTDD._cont = ASN1Dict([
        ('dCH-InformationResponse', _Non_Combining_RL_AdditionRspTDD_dCH_InformationResponse),
        ('iE-Extensions', _Non_Combining_RL_AdditionRspTDD_iE_Extensions),
        ])
    Non_Combining_RL_AdditionRspTDD._ext = []
    
    #-----< Non-CombiningItem-RL-AdditionRspTDD-ExtIEs >-----#
    Non_CombiningItem_RL_AdditionRspTDD_ExtIEs = CLASS(name='Non-CombiningItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Non_CombiningItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DSCH-InformationResponseList-RL-AdditionRspTDD >-----#
    DSCH_InformationResponseList_RL_AdditionRspTDD = SEQ(name='DSCH-InformationResponseList-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DSCH_InformationResponseList_RL_AdditionRspTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DSCH_InformationResponseList_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DSCH_InformationResponseList_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-InformationResponse')))
    __DSCH_InformationResponseList_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([('id', 105), ('criticality', 'ignore'), ('Value', ___DSCH_InformationResponseList_RL_AdditionRspTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DSCH_InformationResponseList_RL_AdditionRspTDD_id._const_tab = __DSCH_InformationResponseList_RL_AdditionRspTDD_id_tab
    _DSCH_InformationResponseList_RL_AdditionRspTDD_id._const_tab_at = None
    _DSCH_InformationResponseList_RL_AdditionRspTDD_id._const_tab_id = 'id'
    _DSCH_InformationResponseList_RL_AdditionRspTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DSCH_InformationResponseList_RL_AdditionRspTDD_criticality._const_tab = __DSCH_InformationResponseList_RL_AdditionRspTDD_id_tab
    _DSCH_InformationResponseList_RL_AdditionRspTDD_criticality._const_tab_at = ('..', 'id')
    _DSCH_InformationResponseList_RL_AdditionRspTDD_criticality._const_tab_id = 'criticality'
    _DSCH_InformationResponseList_RL_AdditionRspTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DSCH_InformationResponseList_RL_AdditionRspTDD_value._const_tab = __DSCH_InformationResponseList_RL_AdditionRspTDD_id_tab
    _DSCH_InformationResponseList_RL_AdditionRspTDD_value._const_tab_at = ('..', 'id')
    _DSCH_InformationResponseList_RL_AdditionRspTDD_value._const_tab_id = 'Value'
    DSCH_InformationResponseList_RL_AdditionRspTDD._cont = ASN1Dict([
        ('id', _DSCH_InformationResponseList_RL_AdditionRspTDD_id),
        ('criticality', _DSCH_InformationResponseList_RL_AdditionRspTDD_criticality),
        ('value', _DSCH_InformationResponseList_RL_AdditionRspTDD_value),
        ])
    DSCH_InformationResponseList_RL_AdditionRspTDD._ext = None
    
    #-----< DSCH-InformationResponseListIEs-RL-AdditionRspTDD >-----#
    DSCH_InformationResponseListIEs_RL_AdditionRspTDD = CLASS(name='DSCH-InformationResponseListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DSCH_InformationResponseListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-InformationResponse')))
    DSCH_InformationResponseListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([('id', 105), ('criticality', 'ignore'), ('Value', _DSCH_InformationResponseListIEs_RL_AdditionRspTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< USCH-InformationResponseList-RL-AdditionRspTDD >-----#
    USCH_InformationResponseList_RL_AdditionRspTDD = SEQ(name='USCH-InformationResponseList-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _USCH_InformationResponseList_RL_AdditionRspTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __USCH_InformationResponseList_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___USCH_InformationResponseList_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-InformationResponse')))
    __USCH_InformationResponseList_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([('id', 309), ('criticality', 'ignore'), ('Value', ___USCH_InformationResponseList_RL_AdditionRspTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _USCH_InformationResponseList_RL_AdditionRspTDD_id._const_tab = __USCH_InformationResponseList_RL_AdditionRspTDD_id_tab
    _USCH_InformationResponseList_RL_AdditionRspTDD_id._const_tab_at = None
    _USCH_InformationResponseList_RL_AdditionRspTDD_id._const_tab_id = 'id'
    _USCH_InformationResponseList_RL_AdditionRspTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _USCH_InformationResponseList_RL_AdditionRspTDD_criticality._const_tab = __USCH_InformationResponseList_RL_AdditionRspTDD_id_tab
    _USCH_InformationResponseList_RL_AdditionRspTDD_criticality._const_tab_at = ('..', 'id')
    _USCH_InformationResponseList_RL_AdditionRspTDD_criticality._const_tab_id = 'criticality'
    _USCH_InformationResponseList_RL_AdditionRspTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _USCH_InformationResponseList_RL_AdditionRspTDD_value._const_tab = __USCH_InformationResponseList_RL_AdditionRspTDD_id_tab
    _USCH_InformationResponseList_RL_AdditionRspTDD_value._const_tab_at = ('..', 'id')
    _USCH_InformationResponseList_RL_AdditionRspTDD_value._const_tab_id = 'Value'
    USCH_InformationResponseList_RL_AdditionRspTDD._cont = ASN1Dict([
        ('id', _USCH_InformationResponseList_RL_AdditionRspTDD_id),
        ('criticality', _USCH_InformationResponseList_RL_AdditionRspTDD_criticality),
        ('value', _USCH_InformationResponseList_RL_AdditionRspTDD_value),
        ])
    USCH_InformationResponseList_RL_AdditionRspTDD._ext = None
    
    #-----< USCH-InformationResponseListIEs-RL-AdditionRspTDD >-----#
    USCH_InformationResponseListIEs_RL_AdditionRspTDD = CLASS(name='USCH-InformationResponseListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _USCH_InformationResponseListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-InformationResponse')))
    USCH_InformationResponseListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([('id', 309), ('criticality', 'ignore'), ('Value', _USCH_InformationResponseListIEs_RL_AdditionRspTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationResponse-LCR-RL-AdditionRspTDD >-----#
    RL_InformationResponse_LCR_RL_AdditionRspTDD = SEQ(name='RL-InformationResponse-LCR-RL-AdditionRspTDD', mode=MODE_TYPE)
    _RL_InformationResponse_LCR_RL_AdditionRspTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationResponse_LCR_RL_AdditionRspTDD_uL_TimeSlot_ISCP_InfoLCR = SEQ_OF(name='uL-TimeSlot-ISCP-InfoLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeSlot-ISCP-LCR-Info')))
    _RL_InformationResponse_LCR_RL_AdditionRspTDD_ul_PhysCH_SF_Variation = ENUM(name='ul-PhysCH-SF-Variation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-PhysCH-SF-Variation')))
    _RL_InformationResponse_LCR_RL_AdditionRspTDD_dCH_Information = SEQ(name='dCH-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-Information-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_LCR_RL_AdditionRspTDD_dSCH_InformationResponseList = SEQ(name='dSCH-InformationResponseList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-InformationResponseList-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_LCR_RL_AdditionRspTDD_uSCH_InformationResponseList = SEQ(name='uSCH-InformationResponseList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-InformationResponseList-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__id),
        ('criticality', ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions._cont = __RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item_
    _RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponse_LCR_RL_AdditionRspTDD._cont = ASN1Dict([
        ('rL-ID', _RL_InformationResponse_LCR_RL_AdditionRspTDD_rL_ID),
        ('uL-TimeSlot-ISCP-InfoLCR', _RL_InformationResponse_LCR_RL_AdditionRspTDD_uL_TimeSlot_ISCP_InfoLCR),
        ('ul-PhysCH-SF-Variation', _RL_InformationResponse_LCR_RL_AdditionRspTDD_ul_PhysCH_SF_Variation),
        ('dCH-Information', _RL_InformationResponse_LCR_RL_AdditionRspTDD_dCH_Information),
        ('dSCH-InformationResponseList', _RL_InformationResponse_LCR_RL_AdditionRspTDD_dSCH_InformationResponseList),
        ('uSCH-InformationResponseList', _RL_InformationResponse_LCR_RL_AdditionRspTDD_uSCH_InformationResponseList),
        ('iE-Extensions', _RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions),
        ])
    RL_InformationResponse_LCR_RL_AdditionRspTDD._ext = []
    
    #-----< RL-InformationResponse-LCR-RL-AdditionRspTDD-ExtIEs >-----#
    RL_InformationResponse_LCR_RL_AdditionRspTDD_ExtIEs = CLASS(name='RL-InformationResponse-LCR-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_InformationResponse_LCR_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionFailureFDD >-----#
    RadioLinkAdditionFailureFDD = SEQ(name='RadioLinkAdditionFailureFDD', mode=MODE_TYPE)
    _RadioLinkAdditionFailureFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionFailureFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-RL-AdditionFailureFDD')))
    _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 325), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkAdditionFailureFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionFailureFDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkAdditionFailureFDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionFailureFDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionFailureFDD_protocolIEs._cont = __RadioLinkAdditionFailureFDD_protocolIEs__item_
    _RadioLinkAdditionFailureFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionFailureFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionFailureFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Serving-Cell-Change-Info-Response')))
    _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Serving-Cell-Change-Info-Response')))
    _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Change-Information-Response-List')))
    _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAChs-ResetIndicator')))
    _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-RL-Add-List')))
    ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 701), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 699), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1040), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 826), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1123), ('criticality', 'ignore'), ('Extension', _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkAdditionFailureFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionFailureFDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionFailureFDD_protocolExtensions._cont = __RadioLinkAdditionFailureFDD_protocolExtensions__item_
    _RadioLinkAdditionFailureFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionFailureFDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkAdditionFailureFDD_protocolIEs),
        ('protocolExtensions', _RadioLinkAdditionFailureFDD_protocolExtensions),
        ])
    RadioLinkAdditionFailureFDD._ext = []
    
    #-----< RadioLinkAdditionFailureFDD-IEs >-----#
    RadioLinkAdditionFailureFDD_IEs = CLASS(name='RadioLinkAdditionFailureFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkAdditionFailureFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkAdditionFailureFDD_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-RL-AdditionFailureFDD')))
    _RadioLinkAdditionFailureFDD_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkAdditionFailureFDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionFailureFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 325), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionFailureFDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionFailureFDD_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionFailureFDD-Extensions >-----#
    RadioLinkAdditionFailureFDD_Extensions = CLASS(name='RadioLinkAdditionFailureFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkAdditionFailureFDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Serving-Cell-Change-Info-Response')))
    _RadioLinkAdditionFailureFDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Serving-Cell-Change-Info-Response')))
    _RadioLinkAdditionFailureFDD_Extensions_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Change-Information-Response-List')))
    _RadioLinkAdditionFailureFDD_Extensions_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAChs-ResetIndicator')))
    _RadioLinkAdditionFailureFDD_Extensions_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-RL-Add-List')))
    RadioLinkAdditionFailureFDD_Extensions._val = ASN1Set(rv=[dict([('id', 701), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionFailureFDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 699), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionFailureFDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 1040), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionFailureFDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 826), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionFailureFDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 1123), ('criticality', 'ignore'), ('Extension', _RadioLinkAdditionFailureFDD_Extensions_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-RL-AdditionFailureFDD >-----#
    CauseLevel_RL_AdditionFailureFDD = CHOICE(name='CauseLevel-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _CauseLevel_RL_AdditionFailureFDD_generalCause = SEQ(name='generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'GeneralCauseList-RL-AdditionFailureFDD')))
    _CauseLevel_RL_AdditionFailureFDD_rLSpecificCause = SEQ(name='rLSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RLSpecificCauseList-RL-AdditionFailureFDD')))
    CauseLevel_RL_AdditionFailureFDD._cont = ASN1Dict([
        ('generalCause', _CauseLevel_RL_AdditionFailureFDD_generalCause),
        ('rLSpecificCause', _CauseLevel_RL_AdditionFailureFDD_rLSpecificCause),
        ])
    CauseLevel_RL_AdditionFailureFDD._ext = []
    
    #-----< GeneralCauseList-RL-AdditionFailureFDD >-----#
    GeneralCauseList_RL_AdditionFailureFDD = SEQ(name='GeneralCauseList-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _GeneralCauseList_RL_AdditionFailureFDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id),
        ('criticality', ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions._cont = __GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item_
    _GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_RL_AdditionFailureFDD._cont = ASN1Dict([
        ('cause', _GeneralCauseList_RL_AdditionFailureFDD_cause),
        ('iE-Extensions', _GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions),
        ])
    GeneralCauseList_RL_AdditionFailureFDD._ext = []
    
    #-----< GeneralCauseItem-RL-AdditionFailureFDD-ExtIEs >-----#
    GeneralCauseItem_RL_AdditionFailureFDD_ExtIEs = CLASS(name='GeneralCauseItem-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GeneralCauseItem_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLSpecificCauseList-RL-AdditionFailureFDD >-----#
    RLSpecificCauseList_RL_AdditionFailureFDD = SEQ(name='RLSpecificCauseList-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _RLSpecificCauseList_RL_AdditionFailureFDD_unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD = SEQ_OF(name='unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD')))
    _RLSpecificCauseList_RL_AdditionFailureFDD_successful_RL_InformationRespList_RL_AdditionFailureFDD = SEQ_OF(name='successful-RL-InformationRespList-RL-AdditionFailureFDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Successful-RL-InformationRespList-RL-AdditionFailureFDD')), opt=True)
    _RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id),
        ('criticality', ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions._cont = __RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item_
    _RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLSpecificCauseList_RL_AdditionFailureFDD._cont = ASN1Dict([
        ('unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD', _RLSpecificCauseList_RL_AdditionFailureFDD_unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD),
        ('successful-RL-InformationRespList-RL-AdditionFailureFDD', _RLSpecificCauseList_RL_AdditionFailureFDD_successful_RL_InformationRespList_RL_AdditionFailureFDD),
        ('iE-Extensions', _RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions),
        ])
    RLSpecificCauseList_RL_AdditionFailureFDD._ext = []
    
    #-----< RLSpecificCauseItem-RL-AdditionFailureFDD-ExtIEs >-----#
    RLSpecificCauseItem_RL_AdditionFailureFDD_ExtIEs = CLASS(name='RLSpecificCauseItem-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RLSpecificCauseItem_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD >-----#
    Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD = SEQ_OF(name='Unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD')))
    ___Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 296), ('criticality', 'ignore'), ('Value', ____Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id._const_tab = ___Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id._const_tab_at = None
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id._const_tab_id = 'id'
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality._const_tab = ___Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality._const_tab_at = ('..', 'id')
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality._const_tab_id = 'criticality'
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__value._const_tab = ___Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__value._const_tab_at = ('..', 'id')
    __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__value._const_tab_id = 'Value'
    _Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item_._cont = ASN1Dict([
        ('id', __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id),
        ('criticality', __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality),
        ('value', __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__value),
        ])
    _Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item_._ext = None
    Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD._cont = _Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item_
    Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureFDD >-----#
    Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureFDD = CLASS(name='Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD')))
    Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureFDD._val = ASN1Set(rv=[dict([('id', 296), ('criticality', 'ignore'), ('Value', _Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD >-----#
    Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD = SEQ(name='Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id),
        ('criticality', ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions._cont = __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item_
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD._cont = ASN1Dict([
        ('rL-ID', _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_rL_ID),
        ('cause', _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_cause),
        ('iE-Extensions', _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions),
        ])
    Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD._ext = []
    
    #-----< Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD-ExtIEs >-----#
    Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs = CLASS(name='Unsuccessful-RL-InformationRespItem-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Successful-RL-InformationRespList-RL-AdditionFailureFDD >-----#
    Successful_RL_InformationRespList_RL_AdditionFailureFDD = SEQ_OF(name='Successful-RL-InformationRespList-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _Successful_RL_InformationRespList_RL_AdditionFailureFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Successful-RL-InformationRespItem-RL-AdditionFailureFDD')))
    ___Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 270), ('criticality', 'ignore'), ('Value', ____Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id._const_tab = ___Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id._const_tab_at = None
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id._const_tab_id = 'id'
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality._const_tab = ___Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality._const_tab_at = ('..', 'id')
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality._const_tab_id = 'criticality'
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__value._const_tab = ___Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__value._const_tab_at = ('..', 'id')
    __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__value._const_tab_id = 'Value'
    _Successful_RL_InformationRespList_RL_AdditionFailureFDD__item_._cont = ASN1Dict([
        ('id', __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id),
        ('criticality', __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality),
        ('value', __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__value),
        ])
    _Successful_RL_InformationRespList_RL_AdditionFailureFDD__item_._ext = None
    Successful_RL_InformationRespList_RL_AdditionFailureFDD._cont = _Successful_RL_InformationRespList_RL_AdditionFailureFDD__item_
    Successful_RL_InformationRespList_RL_AdditionFailureFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    
    #-----< Successful-RL-InformationRespItemIE-RL-AdditionFailureFDD >-----#
    Successful_RL_InformationRespItemIE_RL_AdditionFailureFDD = CLASS(name='Successful-RL-InformationRespItemIE-RL-AdditionFailureFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Successful_RL_InformationRespItemIE_RL_AdditionFailureFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Successful-RL-InformationRespItem-RL-AdditionFailureFDD')))
    Successful_RL_InformationRespItemIE_RL_AdditionFailureFDD._val = ASN1Set(rv=[dict([('id', 270), ('criticality', 'ignore'), ('Value', _Successful_RL_InformationRespItemIE_RL_AdditionFailureFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Successful-RL-InformationRespItem-RL-AdditionFailureFDD >-----#
    Successful_RL_InformationRespItem_RL_AdditionFailureFDD = SEQ(name='Successful-RL-InformationRespItem-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_rL_Set_ID = INT(name='rL-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_received_total_wide_band_power = INT(name='received-total-wide-band-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Received-total-wide-band-power-Value')))
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_diversityIndication = CHOICE(name='diversityIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DiversityIndication-RL-AdditionFailureFDD')))
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_sSDT_SupportIndicator = ENUM(name='sSDT-SupportIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SSDT-SupportIndicator')))
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    ____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 651), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id),
        ('criticality', ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions._cont = __Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item_
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Successful_RL_InformationRespItem_RL_AdditionFailureFDD._cont = ASN1Dict([
        ('rL-ID', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_rL_ID),
        ('rL-Set-ID', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_rL_Set_ID),
        ('received-total-wide-band-power', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_received_total_wide_band_power),
        ('diversityIndication', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_diversityIndication),
        ('sSDT-SupportIndicator', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_sSDT_SupportIndicator),
        ('iE-Extensions', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions),
        ])
    Successful_RL_InformationRespItem_RL_AdditionFailureFDD._ext = []
    
    #-----< Successful-RL-InformationRespItem-RL-AdditionFailureFDD-ExtIEs >-----#
    Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs = CLASS(name='Successful-RL-InformationRespItem-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 651), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DiversityIndication-RL-AdditionFailureFDD >-----#
    DiversityIndication_RL_AdditionFailureFDD = CHOICE(name='DiversityIndication-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _DiversityIndication_RL_AdditionFailureFDD_combining = SEQ(name='combining', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Combining-RL-AdditionFailureFDD')))
    _DiversityIndication_RL_AdditionFailureFDD_non_Combining = SEQ(name='non-Combining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Non-Combining-RL-AdditionFailureFDD')))
    DiversityIndication_RL_AdditionFailureFDD._cont = ASN1Dict([
        ('combining', _DiversityIndication_RL_AdditionFailureFDD_combining),
        ('non-Combining', _DiversityIndication_RL_AdditionFailureFDD_non_Combining),
        ])
    DiversityIndication_RL_AdditionFailureFDD._ext = None
    
    #-----< Combining-RL-AdditionFailureFDD >-----#
    Combining_RL_AdditionFailureFDD = SEQ(name='Combining-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _Combining_RL_AdditionFailureFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Combining_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Combining_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Combining_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id),
        ('criticality', ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __Combining_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _Combining_RL_AdditionFailureFDD_iE_Extensions._cont = __Combining_RL_AdditionFailureFDD_iE_Extensions__item_
    _Combining_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Combining_RL_AdditionFailureFDD._cont = ASN1Dict([
        ('rL-ID', _Combining_RL_AdditionFailureFDD_rL_ID),
        ('iE-Extensions', _Combining_RL_AdditionFailureFDD_iE_Extensions),
        ])
    Combining_RL_AdditionFailureFDD._ext = []
    
    #-----< CombiningItem-RL-AdditionFailureFDD-ExtIEs >-----#
    CombiningItem_RL_AdditionFailureFDD_ExtIEs = CLASS(name='CombiningItem-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    CombiningItem_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Non-Combining-RL-AdditionFailureFDD >-----#
    Non_Combining_RL_AdditionFailureFDD = SEQ(name='Non-Combining-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _Non_Combining_RL_AdditionFailureFDD_dCH_InformationResponse = SEQ_OF(name='dCH-InformationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponse')))
    _Non_Combining_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    ____Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _____Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id),
        ('criticality', ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _Non_Combining_RL_AdditionFailureFDD_iE_Extensions._cont = __Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item_
    _Non_Combining_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Non_Combining_RL_AdditionFailureFDD._cont = ASN1Dict([
        ('dCH-InformationResponse', _Non_Combining_RL_AdditionFailureFDD_dCH_InformationResponse),
        ('iE-Extensions', _Non_Combining_RL_AdditionFailureFDD_iE_Extensions),
        ])
    Non_Combining_RL_AdditionFailureFDD._ext = []
    
    #-----< Non-CombiningItem-RL-AdditionFailureFDD-ExtIEs >-----#
    Non_CombiningItem_RL_AdditionFailureFDD_ExtIEs = CLASS(name='Non-CombiningItem-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Non_CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    Non_CombiningItem_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 668), ('criticality', 'ignore'), ('Extension', _Non_CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionFailureTDD >-----#
    RadioLinkAdditionFailureTDD = SEQ(name='RadioLinkAdditionFailureTDD', mode=MODE_TYPE)
    _RadioLinkAdditionFailureTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionFailureTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-RL-AdditionFailureTDD')))
    _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 326), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkAdditionFailureTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionFailureTDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkAdditionFailureTDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionFailureTDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionFailureTDD_protocolIEs._cont = __RadioLinkAdditionFailureTDD_protocolIEs__item_
    _RadioLinkAdditionFailureTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionFailureTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionFailureTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionFailureTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality_tab
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkAdditionFailureTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionFailureTDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionFailureTDD_protocolExtensions._cont = __RadioLinkAdditionFailureTDD_protocolExtensions__item_
    _RadioLinkAdditionFailureTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionFailureTDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkAdditionFailureTDD_protocolIEs),
        ('protocolExtensions', _RadioLinkAdditionFailureTDD_protocolExtensions),
        ])
    RadioLinkAdditionFailureTDD._ext = []
    
    #-----< RadioLinkAdditionFailureTDD-IEs >-----#
    RadioLinkAdditionFailureTDD_IEs = CLASS(name='RadioLinkAdditionFailureTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkAdditionFailureTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkAdditionFailureTDD_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-RL-AdditionFailureTDD')))
    _RadioLinkAdditionFailureTDD_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkAdditionFailureTDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionFailureTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 326), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionFailureTDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkAdditionFailureTDD_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionFailureTDD-Extensions >-----#
    RadioLinkAdditionFailureTDD_Extensions = CLASS(name='RadioLinkAdditionFailureTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkAdditionFailureTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-RL-AdditionFailureTDD >-----#
    CauseLevel_RL_AdditionFailureTDD = CHOICE(name='CauseLevel-RL-AdditionFailureTDD', mode=MODE_TYPE)
    _CauseLevel_RL_AdditionFailureTDD_generalCause = SEQ(name='generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'GeneralCauseList-RL-AdditionFailureTDD')))
    _CauseLevel_RL_AdditionFailureTDD_rLSpecificCause = SEQ(name='rLSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RLSpecificCauseList-RL-AdditionFailureTDD')))
    CauseLevel_RL_AdditionFailureTDD._cont = ASN1Dict([
        ('generalCause', _CauseLevel_RL_AdditionFailureTDD_generalCause),
        ('rLSpecificCause', _CauseLevel_RL_AdditionFailureTDD_rLSpecificCause),
        ])
    CauseLevel_RL_AdditionFailureTDD._ext = []
    
    #-----< GeneralCauseList-RL-AdditionFailureTDD >-----#
    GeneralCauseList_RL_AdditionFailureTDD = SEQ(name='GeneralCauseList-RL-AdditionFailureTDD', mode=MODE_TYPE)
    _GeneralCauseList_RL_AdditionFailureTDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab = ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id),
        ('criticality', ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item_._ext = None
    _GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions._cont = __GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item_
    _GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_RL_AdditionFailureTDD._cont = ASN1Dict([
        ('cause', _GeneralCauseList_RL_AdditionFailureTDD_cause),
        ('iE-Extensions', _GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions),
        ])
    GeneralCauseList_RL_AdditionFailureTDD._ext = []
    
    #-----< GeneralCauseItem-RL-AdditionFailureTDD-ExtIEs >-----#
    GeneralCauseItem_RL_AdditionFailureTDD_ExtIEs = CLASS(name='GeneralCauseItem-RL-AdditionFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GeneralCauseItem_RL_AdditionFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLSpecificCauseList-RL-AdditionFailureTDD >-----#
    RLSpecificCauseList_RL_AdditionFailureTDD = SEQ(name='RLSpecificCauseList-RL-AdditionFailureTDD', mode=MODE_TYPE)
    _RLSpecificCauseList_RL_AdditionFailureTDD_unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD = SEQ(name='unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD')))
    _RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab = ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab = ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id),
        ('criticality', ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item_._ext = None
    _RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions._cont = __RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item_
    _RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLSpecificCauseList_RL_AdditionFailureTDD._cont = ASN1Dict([
        ('unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD', _RLSpecificCauseList_RL_AdditionFailureTDD_unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD),
        ('iE-Extensions', _RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions),
        ])
    RLSpecificCauseList_RL_AdditionFailureTDD._ext = []
    
    #-----< RLSpecificCauseItem-RL-AdditionFailureTDD-ExtIEs >-----#
    RLSpecificCauseItem_RL_AdditionFailureTDD_ExtIEs = CLASS(name='RLSpecificCauseItem-RL-AdditionFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RLSpecificCauseItem_RL_AdditionFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD >-----#
    Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD = SEQ(name='Unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD')))
    __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab._val = ASN1Set(rv=[dict([('id', 300), ('criticality', 'ignore'), ('Value', ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id._const_tab = __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id._const_tab_at = None
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id._const_tab_id = 'id'
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality._const_tab = __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality._const_tab_at = ('..', 'id')
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality._const_tab_id = 'criticality'
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value._const_tab = __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value._const_tab_at = ('..', 'id')
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value._const_tab_id = 'Value'
    Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD._cont = ASN1Dict([
        ('id', _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id),
        ('criticality', _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality),
        ('value', _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value),
        ])
    Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD._ext = None
    
    #-----< Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureTDD >-----#
    Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD = CLASS(name='Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD')))
    Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD._val = ASN1Set(rv=[dict([('id', 300), ('criticality', 'ignore'), ('Value', _Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD >-----#
    Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD = SEQ(name='Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD', mode=MODE_TYPE)
    _Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab = ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__id_tab
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab = ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__id),
        ('criticality', ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item_._ext = None
    _Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions._cont = __Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item_
    _Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD._cont = ASN1Dict([
        ('rL-ID', _Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_rL_ID),
        ('cause', _Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_cause),
        ('iE-Extensions', _Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions),
        ])
    Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD._ext = []
    
    #-----< Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD-ExtIEs >-----#
    Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_ExtIEs = CLASS(name='Unsuccessful-RL-InformationResp-RL-AdditionFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationPrepareFDD >-----#
    RadioLinkReconfigurationPrepareFDD = SEQ(name='RadioLinkReconfigurationPrepareFDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationPrepareFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationPrepareFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-Information-RL-ReconfPrepFDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-Information-RL-ReconfPrepFDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FDD-DCHs-to-Modify')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-FDD-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfPrepFDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-ReconfPrepFDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 293), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 81), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 62), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 52), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 214), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkReconfigurationPrepareFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationPrepareFDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationPrepareFDD_protocolIEs._cont = __RadioLinkReconfigurationPrepareFDD_protocolIEs__item_
    _RadioLinkReconfigurationPrepareFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationPrepareFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationPrepareFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SignallingBearerRequestIndicator')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Information-to-Modify')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DPCH-Information-RL-ReconfPrepFDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-to-Modify')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-to-Delete')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_12 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Serving-E-DCH-RL-ID')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'F-DPCH-Information-RL-ReconfPrepFDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-Reconfiguration-Mode')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CPC-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_16 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Prep')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_18 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Reconf-Prep')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_19 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information-Reconf')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_20 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Decoupling-Indication')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_21 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-ENH-Information-Reconf')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_22 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_23 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH2-Information-Reconf')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_24 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Downlink-TPC-enhancements-Reconf')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_25 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Improved-Synchronized-Indicator')))
    ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 530), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 534), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 613), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 614), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 676), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 667), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 669), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 670), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 671), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 679), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 631), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 827), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 836), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 1041), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 1092), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_17), ('presence', 'optional')]), dict([('id', 1124), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 1209), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_19), ('presence', 'optional')]), dict([('id', 1295), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_20), ('presence', 'optional')]), dict([('id', 1293), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_21), ('presence', 'optional')]), dict([('id', 1296), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_22), ('presence', 'optional')]), dict([('id', 1298), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_23), ('presence', 'optional')]), dict([('id', 1308), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_24), ('presence', 'optional')]), dict([('id', 1306), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_25), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkReconfigurationPrepareFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationPrepareFDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationPrepareFDD_protocolExtensions._cont = __RadioLinkReconfigurationPrepareFDD_protocolExtensions__item_
    _RadioLinkReconfigurationPrepareFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationPrepareFDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkReconfigurationPrepareFDD_protocolIEs),
        ('protocolExtensions', _RadioLinkReconfigurationPrepareFDD_protocolExtensions),
        ])
    RadioLinkReconfigurationPrepareFDD._ext = []
    
    #-----< RadioLinkReconfigurationPrepareFDD-IEs >-----#
    RadioLinkReconfigurationPrepareFDD_IEs = CLASS(name='RadioLinkReconfigurationPrepareFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-Information-RL-ReconfPrepFDD')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-Information-RL-ReconfPrepFDD')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FDD-DCHs-to-Modify')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-FDD-Information')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfPrepFDD')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-ReconfPrepFDD')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    RadioLinkReconfigurationPrepareFDD_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 293), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 81), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 62), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 52), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 214), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationPrepareFDD-Extensions >-----#
    RadioLinkReconfigurationPrepareFDD_Extensions = CLASS(name='RadioLinkReconfigurationPrepareFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SignallingBearerRequestIndicator')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Information-to-Modify')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DPCH-Information-RL-ReconfPrepFDD')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-to-Modify')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-Information')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_11 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-to-Delete')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_12 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Serving-E-DCH-RL-ID')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'F-DPCH-Information-RL-ReconfPrepFDD')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-Reconfiguration-Mode')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CPC-Information')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_16 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Prep')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_18 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Reconf-Prep')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_19 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information-Reconf')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_20 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Decoupling-Indication')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_21 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-ENH-Information-Reconf')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_22 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_23 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH2-Information-Reconf')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_24 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Downlink-TPC-enhancements-Reconf')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_25 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Improved-Synchronized-Indicator')))
    RadioLinkReconfigurationPrepareFDD_Extensions._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 530), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 534), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 613), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 614), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_5), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 676), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 667), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 669), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 670), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 671), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 679), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 631), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 827), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 836), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_15), ('presence', 'optional')]), dict([('id', 1041), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_16), ('presence', 'optional')]), dict([('id', 1092), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_17), ('presence', 'optional')]), dict([('id', 1124), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_18), ('presence', 'optional')]), dict([('id', 1209), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_19), ('presence', 'optional')]), dict([('id', 1295), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_20), ('presence', 'optional')]), dict([('id', 1293), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_21), ('presence', 'optional')]), dict([('id', 1296), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_22), ('presence', 'optional')]), dict([('id', 1298), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_23), ('presence', 'optional')]), dict([('id', 1308), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_24), ('presence', 'optional')]), dict([('id', 1306), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_25), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Prep >-----#
    Additional_HS_Cell_Information_RL_Reconf_Prep = SEQ_OF(name='Additional-HS-Cell-Information-RL-Reconf-Prep', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Reconf_Prep__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs')))
    Additional_HS_Cell_Information_RL_Reconf_Prep._cont = _Additional_HS_Cell_Information_RL_Reconf_Prep__item_
    Additional_HS_Cell_Information_RL_Reconf_Prep._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs >-----#
    Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs = SEQ(name='Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hSPDSCH_RL_ID = INT(name='hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information = SEQ(name='hS-DSCH-FDD-Secondary-Serving-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_Secondary_Serving_Information_To_Modify = SEQ(name='hS-DSCH-Secondary-Serving-Information-To-Modify', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Secondary-Serving-Information-To-Modify')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_HS_DSCH_Secondary_Serving_Remove = NULL(name='hS-HS-DSCH-Secondary-Serving-Remove', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Secondary-Serving-Remove')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs._cont = ASN1Dict([
        ('hSPDSCH-RL-ID', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hSPDSCH_RL_ID),
        ('c-ID', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_c_ID),
        ('hS-DSCH-FDD-Secondary-Serving-Information', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information),
        ('hS-DSCH-Secondary-Serving-Information-To-Modify', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_Secondary_Serving_Information_To_Modify),
        ('hS-HS-DSCH-Secondary-Serving-Remove', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_HS_DSCH_Secondary_Serving_Remove),
        ('iE-Extensions', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs-ExtIEs >-----#
    Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_ExtIEs = CLASS(name='Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-RL-Reconf-Prep >-----#
    Additional_EDCH_Cell_Information_RL_Reconf_Prep = SEQ(name='Additional-EDCH-Cell-Information-RL-Reconf-Prep', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_RL_Reconf_Prep_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency = CHOICE(name='setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency')))
    _Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions._cont = __Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_RL_Reconf_Prep._cont = ASN1Dict([
        ('setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency', _Additional_EDCH_Cell_Information_RL_Reconf_Prep_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency),
        ('iE-Extensions', _Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_RL_Reconf_Prep._ext = []
    
    #-----< Additional-EDCH-Cell-Information-RL-Reconf-Prep-ExtIEs >-----#
    Additional_EDCH_Cell_Information_RL_Reconf_Prep_ExtIEs = CLASS(name='Additional-EDCH-Cell-Information-RL-Reconf-Prep-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_RL_Reconf_Prep_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-Information-RL-ReconfPrepFDD >-----#
    UL_DPCH_Information_RL_ReconfPrepFDD = SEQ(name='UL-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _UL_DPCH_Information_RL_ReconfPrepFDD_ul_ScramblingCode = SEQ(name='ul-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-ScramblingCode')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_ul_SIR_Target = INT(name='ul-SIR-Target', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_minUL_ChannelisationCodeLength = ENUM(name='minUL-ChannelisationCodeLength', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MinUL-ChannelisationCodeLength')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_maxNrOfUL_DPDCHs = INT(name='maxNrOfUL-DPDCHs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaxNrOfUL-DPDCHs')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_ul_PunctureLimit = INT(name='ul-PunctureLimit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_ul_DPCCH_SlotFormat = INT(name='ul-DPCCH-SlotFormat', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH-SlotFormat')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_diversityMode = ENUM(name='diversityMode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DiversityMode')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_sSDT_CellIDLength = NULL(name='not-Used-sSDT-CellIDLength', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_s_FieldLength = NULL(name='not-Used-s-FieldLength', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPDCH-Indicator-For-E-DCH-Operation')))
    ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 680), ('criticality', 'reject'), ('Extension', _____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._cont = __UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_
    _UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_Information_RL_ReconfPrepFDD._cont = ASN1Dict([
        ('ul-ScramblingCode', _UL_DPCH_Information_RL_ReconfPrepFDD_ul_ScramblingCode),
        ('ul-SIR-Target', _UL_DPCH_Information_RL_ReconfPrepFDD_ul_SIR_Target),
        ('minUL-ChannelisationCodeLength', _UL_DPCH_Information_RL_ReconfPrepFDD_minUL_ChannelisationCodeLength),
        ('maxNrOfUL-DPDCHs', _UL_DPCH_Information_RL_ReconfPrepFDD_maxNrOfUL_DPDCHs),
        ('ul-PunctureLimit', _UL_DPCH_Information_RL_ReconfPrepFDD_ul_PunctureLimit),
        ('tFCS', _UL_DPCH_Information_RL_ReconfPrepFDD_tFCS),
        ('ul-DPCCH-SlotFormat', _UL_DPCH_Information_RL_ReconfPrepFDD_ul_DPCCH_SlotFormat),
        ('diversityMode', _UL_DPCH_Information_RL_ReconfPrepFDD_diversityMode),
        ('not-Used-sSDT-CellIDLength', _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_sSDT_CellIDLength),
        ('not-Used-s-FieldLength', _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_s_FieldLength),
        ('iE-Extensions', _UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions),
        ])
    UL_DPCH_Information_RL_ReconfPrepFDD._ext = []
    
    #-----< UL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs >-----#
    UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs = CLASS(name='UL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPDCH-Indicator-For-E-DCH-Operation')))
    UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 680), ('criticality', 'reject'), ('Extension', _UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-Information-RL-ReconfPrepFDD >-----#
    DL_DPCH_Information_RL_ReconfPrepFDD = SEQ(name='DL-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _DL_DPCH_Information_RL_ReconfPrepFDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_dl_DPCH_SlotFormat = INT(name='dl-DPCH-SlotFormat', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-SlotFormat')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_SignallingMode = SEQ(name='tFCI-SignallingMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-SignallingMode')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_multiplexingPosition = ENUM(name='multiplexingPosition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MultiplexingPosition')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_not_Used_pDSCH_CodeMapping = NULL(name='not-Used-pDSCH-CodeMapping', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_not_Used_pDSCH_RL_ID = NULL(name='not-Used-pDSCH-RL-ID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease = ENUM(name='limitedPowerIncrease', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LimitedPowerIncrease')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-Power-Information-RL-ReconfPrepFDD')))
    ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 630), ('criticality', 'reject'), ('Extension', _____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._cont = __DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_
    _DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_Information_RL_ReconfPrepFDD._cont = ASN1Dict([
        ('tFCS', _DL_DPCH_Information_RL_ReconfPrepFDD_tFCS),
        ('dl-DPCH-SlotFormat', _DL_DPCH_Information_RL_ReconfPrepFDD_dl_DPCH_SlotFormat),
        ('tFCI-SignallingMode', _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_SignallingMode),
        ('tFCI-Presence', _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_Presence),
        ('multiplexingPosition', _DL_DPCH_Information_RL_ReconfPrepFDD_multiplexingPosition),
        ('not-Used-pDSCH-CodeMapping', _DL_DPCH_Information_RL_ReconfPrepFDD_not_Used_pDSCH_CodeMapping),
        ('not-Used-pDSCH-RL-ID', _DL_DPCH_Information_RL_ReconfPrepFDD_not_Used_pDSCH_RL_ID),
        ('limitedPowerIncrease', _DL_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease),
        ('iE-Extensions', _DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions),
        ])
    DL_DPCH_Information_RL_ReconfPrepFDD._ext = []
    
    #-----< DL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs >-----#
    DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs = CLASS(name='DL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-Power-Information-RL-ReconfPrepFDD')))
    DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 630), ('criticality', 'reject'), ('Extension', _DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-Power-Information-RL-ReconfPrepFDD >-----#
    DL_DPCH_Power_Information_RL_ReconfPrepFDD = SEQ(name='DL-DPCH-Power-Information-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_powerOffsetInformation = SEQ(name='powerOffsetInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PowerOffsetInformation-RL-ReconfPrepFDD')))
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_fdd_TPC_DownlinkStepSize = ENUM(name='fdd-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-TPC-DownlinkStepSize')))
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus = ENUM(name='innerLoopDLPCStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InnerLoopDLPCStatus')))
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions._cont = __DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item_
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_Power_Information_RL_ReconfPrepFDD._cont = ASN1Dict([
        ('powerOffsetInformation', _DL_DPCH_Power_Information_RL_ReconfPrepFDD_powerOffsetInformation),
        ('fdd-TPC-DownlinkStepSize', _DL_DPCH_Power_Information_RL_ReconfPrepFDD_fdd_TPC_DownlinkStepSize),
        ('innerLoopDLPCStatus', _DL_DPCH_Power_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus),
        ('iE-Extensions', _DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions),
        ])
    DL_DPCH_Power_Information_RL_ReconfPrepFDD._ext = []
    
    #-----< DL-DPCH-Power-Information-RL-ReconfPrepFDD-ExtIEs >-----#
    DL_DPCH_Power_Information_RL_ReconfPrepFDD_ExtIEs = CLASS(name='DL-DPCH-Power-Information-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_Power_Information_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PowerOffsetInformation-RL-ReconfPrepFDD >-----#
    PowerOffsetInformation_RL_ReconfPrepFDD = SEQ(name='PowerOffsetInformation-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _PowerOffsetInformation_RL_ReconfPrepFDD_pO1_ForTFCI_Bits = INT(name='pO1-ForTFCI-Bits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_ReconfPrepFDD_pO2_ForTPC_Bits = INT(name='pO2-ForTPC-Bits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_ReconfPrepFDD_pO3_ForPilotBits = INT(name='pO3-ForPilotBits', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id),
        ('criticality', ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions._cont = __PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item_
    _PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerOffsetInformation_RL_ReconfPrepFDD._cont = ASN1Dict([
        ('pO1-ForTFCI-Bits', _PowerOffsetInformation_RL_ReconfPrepFDD_pO1_ForTFCI_Bits),
        ('pO2-ForTPC-Bits', _PowerOffsetInformation_RL_ReconfPrepFDD_pO2_ForTPC_Bits),
        ('pO3-ForPilotBits', _PowerOffsetInformation_RL_ReconfPrepFDD_pO3_ForPilotBits),
        ('iE-Extensions', _PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions),
        ])
    PowerOffsetInformation_RL_ReconfPrepFDD._ext = []
    
    #-----< PowerOffsetInformation-RL-ReconfPrepFDD-ExtIEs >-----#
    PowerOffsetInformation_RL_ReconfPrepFDD_ExtIEs = CLASS(name='PowerOffsetInformation-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PowerOffsetInformation_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-DeleteList-RL-ReconfPrepFDD >-----#
    DCH_DeleteList_RL_ReconfPrepFDD = SEQ_OF(name='DCH-DeleteList-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _DCH_DeleteList_RL_ReconfPrepFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteItem-RL-ReconfPrepFDD')))
    DCH_DeleteList_RL_ReconfPrepFDD._cont = _DCH_DeleteList_RL_ReconfPrepFDD__item_
    DCH_DeleteList_RL_ReconfPrepFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-DeleteItem-RL-ReconfPrepFDD >-----#
    DCH_DeleteItem_RL_ReconfPrepFDD = SEQ(name='DCH-DeleteItem-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _DCH_DeleteItem_RL_ReconfPrepFDD_dCH_ID = INT(name='dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    _DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id),
        ('criticality', ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions._cont = __DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item_
    _DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_DeleteItem_RL_ReconfPrepFDD._cont = ASN1Dict([
        ('dCH-ID', _DCH_DeleteItem_RL_ReconfPrepFDD_dCH_ID),
        ('iE-Extensions', _DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions),
        ])
    DCH_DeleteItem_RL_ReconfPrepFDD._ext = []
    
    #-----< DCH-DeleteItem-RL-ReconfPrepFDD-ExtIEs >-----#
    DCH_DeleteItem_RL_ReconfPrepFDD_ExtIEs = CLASS(name='DCH-DeleteItem-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DCH_DeleteItem_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-ReconfPrepFDD >-----#
    RL_InformationList_RL_ReconfPrepFDD = SEQ_OF(name='RL-InformationList-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _RL_InformationList_RL_ReconfPrepFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_ReconfPrepFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_ReconfPrepFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-ReconfPrepFDD')))
    ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 208), ('criticality', 'reject'), ('Value', ____RL_InformationList_RL_ReconfPrepFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_ReconfPrepFDD__item__id._const_tab = ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab
    __RL_InformationList_RL_ReconfPrepFDD__item__id._const_tab_at = None
    __RL_InformationList_RL_ReconfPrepFDD__item__id._const_tab_id = 'id'
    __RL_InformationList_RL_ReconfPrepFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationList_RL_ReconfPrepFDD__item__criticality._const_tab = ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab
    __RL_InformationList_RL_ReconfPrepFDD__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_ReconfPrepFDD__item__criticality._const_tab_id = 'criticality'
    __RL_InformationList_RL_ReconfPrepFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationList_RL_ReconfPrepFDD__item__value._const_tab = ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab
    __RL_InformationList_RL_ReconfPrepFDD__item__value._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_ReconfPrepFDD__item__value._const_tab_id = 'Value'
    _RL_InformationList_RL_ReconfPrepFDD__item_._cont = ASN1Dict([
        ('id', __RL_InformationList_RL_ReconfPrepFDD__item__id),
        ('criticality', __RL_InformationList_RL_ReconfPrepFDD__item__criticality),
        ('value', __RL_InformationList_RL_ReconfPrepFDD__item__value),
        ])
    _RL_InformationList_RL_ReconfPrepFDD__item_._ext = None
    RL_InformationList_RL_ReconfPrepFDD._cont = _RL_InformationList_RL_ReconfPrepFDD__item_
    RL_InformationList_RL_ReconfPrepFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIE-RL-ReconfPrepFDD >-----#
    RL_InformationItemIE_RL_ReconfPrepFDD = CLASS(name='RL-InformationItemIE-RL-ReconfPrepFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationItemIE_RL_ReconfPrepFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-ReconfPrepFDD')))
    RL_InformationItemIE_RL_ReconfPrepFDD._val = ASN1Set(rv=[dict([('id', 208), ('criticality', 'reject'), ('Value', _RL_InformationItemIE_RL_ReconfPrepFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-RL-ReconfPrepFDD >-----#
    RL_InformationItem_RL_ReconfPrepFDD = SEQ(name='RL-InformationItem-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _RL_InformationItem_RL_ReconfPrepFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationItem_RL_ReconfPrepFDD_dl_CodeInformation = SEQ_OF(name='dl-CodeInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-CodeInformation')), opt=True)
    _RL_InformationItem_RL_ReconfPrepFDD_maxDL_Power = INT(name='maxDL-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationItem_RL_ReconfPrepFDD_minDL_Power = INT(name='minDL-Power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationItem_RL_ReconfPrepFDD_not_Used_sSDT_Indication = NULL(name='not-Used-sSDT-Indication', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationItem_RL_ReconfPrepFDD_not_Used_sSDT_Cell_Identity = NULL(name='not-Used-sSDT-Cell-Identity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationItem_RL_ReconfPrepFDD_transmitDiversityIndicator = ENUM(name='transmitDiversityIndicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransmitDiversityIndicator')), opt=True)
    _RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Primary-CPICH-Usage-for-Channel-Estimation')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Secondary-CPICH-Information-Change')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RL-Indication')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-E-DCH-Info')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information-Reconf')))
    _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    ____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 21), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 594), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 595), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 674), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 686), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 870), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1033), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1174), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1175), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 1216), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id),
        ('criticality', ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions._cont = __RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item_
    _RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_RL_ReconfPrepFDD._cont = ASN1Dict([
        ('rL-ID', _RL_InformationItem_RL_ReconfPrepFDD_rL_ID),
        ('dl-CodeInformation', _RL_InformationItem_RL_ReconfPrepFDD_dl_CodeInformation),
        ('maxDL-Power', _RL_InformationItem_RL_ReconfPrepFDD_maxDL_Power),
        ('minDL-Power', _RL_InformationItem_RL_ReconfPrepFDD_minDL_Power),
        ('not-Used-sSDT-Indication', _RL_InformationItem_RL_ReconfPrepFDD_not_Used_sSDT_Indication),
        ('not-Used-sSDT-Cell-Identity', _RL_InformationItem_RL_ReconfPrepFDD_not_Used_sSDT_Cell_Identity),
        ('transmitDiversityIndicator', _RL_InformationItem_RL_ReconfPrepFDD_transmitDiversityIndicator),
        ('iE-Extensions', _RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions),
        ])
    RL_InformationItem_RL_ReconfPrepFDD._ext = []
    
    #-----< RL-InformationItem-RL-ReconfPrepFDD-ExtIEs >-----#
    RL_InformationItem_RL_ReconfPrepFDD_ExtIEs = CLASS(name='RL-InformationItem-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Primary-CPICH-Usage-for-Channel-Estimation')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Secondary-CPICH-Information-Change')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RL-Indication')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-E-DCH-Info')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information-Reconf')))
    _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    RL_InformationItem_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 21), ('criticality', 'reject'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 594), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 595), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 674), ('criticality', 'reject'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 686), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 870), ('criticality', 'reject'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 1033), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 1174), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 1175), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 1216), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_12), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DPCH-Information-RL-ReconfPrepFDD >-----#
    E_DPCH_Information_RL_ReconfPrepFDD = SEQ(name='E-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _E_DPCH_Information_RL_ReconfPrepFDD_maxSet_E_DPDCHs = ENUM(name='maxSet-E-DPDCHs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-Set-E-DPDCHs')), opt=True)
    _E_DPCH_Information_RL_ReconfPrepFDD_ul_PunctureLimit = INT(name='ul-PunctureLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')), opt=True)
    _E_DPCH_Information_RL_ReconfPrepFDD_e_TFCS_Information = SEQ(name='e-TFCS-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information')), opt=True)
    _E_DPCH_Information_RL_ReconfPrepFDD_e_TTI = ENUM(name='e-TTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TTI')), opt=True)
    _E_DPCH_Information_RL_ReconfPrepFDD_e_DPCCH_PO = INT(name='e-DPCCH-PO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-PO')), opt=True)
    _E_DPCH_Information_RL_ReconfPrepFDD_e_RGCH_2_IndexStepThreshold = INT(name='e-RGCH-2-IndexStepThreshold', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-2-IndexStepThreshold')), opt=True)
    _E_DPCH_Information_RL_ReconfPrepFDD_e_RGCH_3_IndexStepThreshold = INT(name='e-RGCH-3-IndexStepThreshold', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-3-IndexStepThreshold')), opt=True)
    _E_DPCH_Information_RL_ReconfPrepFDD_hARQ_Info_for_E_DCH = ENUM(name='hARQ-Info-for-E-DCH', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Info-for-E-DCH')), opt=True)
    _E_DPCH_Information_RL_ReconfPrepFDD_hSDSCH_Configured_Indicator = ENUM(name='hSDSCH-Configured-Indicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Configured-Indicator')), opt=True)
    _E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    ____E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 999), ('criticality', 'ignore'), ('Extension', _____E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id),
        ('criticality', ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._cont = __E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_
    _E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DPCH_Information_RL_ReconfPrepFDD._cont = ASN1Dict([
        ('maxSet-E-DPDCHs', _E_DPCH_Information_RL_ReconfPrepFDD_maxSet_E_DPDCHs),
        ('ul-PunctureLimit', _E_DPCH_Information_RL_ReconfPrepFDD_ul_PunctureLimit),
        ('e-TFCS-Information', _E_DPCH_Information_RL_ReconfPrepFDD_e_TFCS_Information),
        ('e-TTI', _E_DPCH_Information_RL_ReconfPrepFDD_e_TTI),
        ('e-DPCCH-PO', _E_DPCH_Information_RL_ReconfPrepFDD_e_DPCCH_PO),
        ('e-RGCH-2-IndexStepThreshold', _E_DPCH_Information_RL_ReconfPrepFDD_e_RGCH_2_IndexStepThreshold),
        ('e-RGCH-3-IndexStepThreshold', _E_DPCH_Information_RL_ReconfPrepFDD_e_RGCH_3_IndexStepThreshold),
        ('hARQ-Info-for-E-DCH', _E_DPCH_Information_RL_ReconfPrepFDD_hARQ_Info_for_E_DCH),
        ('hSDSCH-Configured-Indicator', _E_DPCH_Information_RL_ReconfPrepFDD_hSDSCH_Configured_Indicator),
        ('iE-Extensions', _E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions),
        ])
    E_DPCH_Information_RL_ReconfPrepFDD._ext = []
    
    #-----< E-DPCH-Information-RL-ReconfPrepFDD-ExtIEs >-----#
    E_DPCH_Information_RL_ReconfPrepFDD_ExtIEs = CLASS(name='E-DPCH-Information-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    E_DPCH_Information_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 999), ('criticality', 'ignore'), ('Extension', _E_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< F-DPCH-Information-RL-ReconfPrepFDD >-----#
    F_DPCH_Information_RL_ReconfPrepFDD = SEQ(name='F-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _F_DPCH_Information_RL_ReconfPrepFDD_powerOffsetInformation = SEQ(name='powerOffsetInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD')))
    _F_DPCH_Information_RL_ReconfPrepFDD_fdd_TPC_DownlinkStepSize = ENUM(name='fdd-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-TPC-DownlinkStepSize')))
    _F_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease = ENUM(name='limitedPowerIncrease', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LimitedPowerIncrease')))
    _F_DPCH_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus = ENUM(name='innerLoopDLPCStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'InnerLoopDLPCStatus')))
    _F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id),
        ('criticality', ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._cont = __F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_
    _F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    F_DPCH_Information_RL_ReconfPrepFDD._cont = ASN1Dict([
        ('powerOffsetInformation', _F_DPCH_Information_RL_ReconfPrepFDD_powerOffsetInformation),
        ('fdd-TPC-DownlinkStepSize', _F_DPCH_Information_RL_ReconfPrepFDD_fdd_TPC_DownlinkStepSize),
        ('limitedPowerIncrease', _F_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease),
        ('innerLoopDLPCStatus', _F_DPCH_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus),
        ('iE-Extensions', _F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions),
        ])
    F_DPCH_Information_RL_ReconfPrepFDD._ext = []
    
    #-----< F-DPCH-Information-RL-ReconfPrepFDD-ExtIEs >-----#
    F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs = CLASS(name='F-DPCH-Information-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD >-----#
    PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD = SEQ(name='PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_pO2_ForTPC_Bits = INT(name='pO2-ForTPC-Bits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id),
        ('criticality', ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions._cont = __PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item_
    _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD._cont = ASN1Dict([
        ('pO2-ForTPC-Bits', _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_pO2_ForTPC_Bits),
        ('iE-Extensions', _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions),
        ])
    PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD._ext = []
    
    #-----< PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD-ExtIEs >-----#
    PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_ExtIEs = CLASS(name='PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationPrepareTDD >-----#
    RadioLinkReconfigurationPrepareTDD = SEQ(name='RadioLinkReconfigurationPrepareTDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationPrepareTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationPrepareTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DCHs-to-Modify')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-TDD-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-Information-ModifyList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-TDD-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-Information-DeleteList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-Information-ModifyList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-Information-DeleteList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Information-RL-ReconfPrepTDD')))
    ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 396), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 401), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 398), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 351), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 348), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 53), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 100), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 302), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 304), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 229), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkReconfigurationPrepareTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationPrepareTDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationPrepareTDD_protocolIEs._cont = __RadioLinkReconfigurationPrepareTDD_protocolIEs__item_
    _RadioLinkReconfigurationPrepareTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationPrepareTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationPrepareTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SignallingBearerRequestIndicator')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Information-to-Modify')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-Information-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Reconfig')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_10 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-768-Information-Reconfig')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LCR-Information-Reconfig')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_13 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CPC-InformationLCR')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IdleIntervalInformation')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_16 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Selected-MBMS-Service-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_18 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_19 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_20 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Reconfigure')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_21 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-InformationLCR')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_22 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-To-ReconfigureLCR')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_23 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 536), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 534), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 613), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 614), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 66), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 628), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 801), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 809), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 814), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 848), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 941), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 1056), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 1063), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 1074), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 1154), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_17), ('presence', 'optional')]), dict([('id', 1167), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 1149), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_19), ('presence', 'optional')]), dict([('id', 1188), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_20), ('presence', 'optional')]), dict([('id', 1192), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_21), ('presence', 'optional')]), dict([('id', 1194), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_22), ('presence', 'optional')]), dict([('id', 1258), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_23), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkReconfigurationPrepareTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationPrepareTDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationPrepareTDD_protocolExtensions._cont = __RadioLinkReconfigurationPrepareTDD_protocolExtensions__item_
    _RadioLinkReconfigurationPrepareTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationPrepareTDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkReconfigurationPrepareTDD_protocolIEs),
        ('protocolExtensions', _RadioLinkReconfigurationPrepareTDD_protocolExtensions),
        ])
    RadioLinkReconfigurationPrepareTDD._ext = []
    
    #-----< RadioLinkReconfigurationPrepareTDD-IEs >-----#
    RadioLinkReconfigurationPrepareTDD_IEs = CLASS(name='RadioLinkReconfigurationPrepareTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DCHs-to-Modify')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-TDD-Information')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-Information-ModifyList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-TDD-Information')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-Information-DeleteList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_13 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-Information-ModifyList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-Information')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_15 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-Information-DeleteList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Information-RL-ReconfPrepTDD')))
    RadioLinkReconfigurationPrepareTDD_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 396), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 401), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 398), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 351), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 348), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 53), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 100), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 302), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 304), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_15), ('presence', 'optional')]), dict([('id', 229), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_16), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationPrepareTDD-Extensions >-----#
    RadioLinkReconfigurationPrepareTDD_Extensions = CLASS(name='RadioLinkReconfigurationPrepareTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SignallingBearerRequestIndicator')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Information-to-Modify')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-Information-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Reconfig')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_10 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-768-Information-Reconfig')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LCR-Information-Reconfig')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_13 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CPC-InformationLCR')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IdleIntervalInformation')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_16 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Selected-MBMS-Service-Information')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_17 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_18 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_19 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_20 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Reconfigure')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_21 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-InformationLCR')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_22 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-To-ReconfigureLCR')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_23 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    RadioLinkReconfigurationPrepareTDD_Extensions._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 536), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 534), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 613), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 614), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_5), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 66), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 628), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 801), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 809), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 814), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 848), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 941), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 1056), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 1063), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_15), ('presence', 'optional')]), dict([('id', 1074), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_16), ('presence', 'optional')]), dict([('id', 1154), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_17), ('presence', 'optional')]), dict([('id', 1167), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_18), ('presence', 'optional')]), dict([('id', 1149), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_19), ('presence', 'optional')]), dict([('id', 1188), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_20), ('presence', 'optional')]), dict([('id', 1192), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_21), ('presence', 'optional')]), dict([('id', 1194), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_22), ('presence', 'optional')]), dict([('id', 1258), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_23), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD = SEQ_OF(name='UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD')))
    UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._cont = _UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_
    UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD = SEQ(name='UL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCI_Coding = ENUM(name='tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Coding')))
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_punctureLimit = INT(name='punctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')))
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ul_DPCH_InformationList = SEQ(name='ul-DPCH-InformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationAddList-RL-ReconfPrepTDD')), opt=True)
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD')))
    _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-UL-DPCH-InformationAddList-RL-ReconfPrepTDD')))
    _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-768-InformationAddList-RL-ReconfPrepTDD')))
    ____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 481), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 510), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 563), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'ignore'), ('Extension', _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 606), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 749), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_ID),
        ('tFCS', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCS),
        ('tFCI-Coding', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCI_Coding),
        ('punctureLimit', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_punctureLimit),
        ('ul-DPCH-InformationList', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ul_DPCH_InformationList),
        ('iE-Extensions', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD')))
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-UL-DPCH-InformationAddList-RL-ReconfPrepTDD')))
    _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-768-InformationAddList-RL-ReconfPrepTDD')))
    UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 481), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 510), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 563), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'ignore'), ('Extension', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 606), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 749), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationAddList-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationAddList_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationAddItem-RL-ReconfPrepTDD')))
    __UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab._val = ASN1Set(rv=[dict([('id', 403), ('criticality', 'reject'), ('Value', ___UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id._const_tab = __UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id._const_tab_at = None
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id._const_tab_id = 'id'
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality._const_tab = __UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality._const_tab_at = ('..', 'id')
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality._const_tab_id = 'criticality'
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_value._const_tab = __UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_value._const_tab_at = ('..', 'id')
    _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_value._const_tab_id = 'Value'
    UL_DPCH_InformationAddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('id', _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id),
        ('criticality', _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality),
        ('value', _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_value),
        ])
    UL_DPCH_InformationAddList_RL_ReconfPrepTDD._ext = None
    
    #-----< UL-DPCH-InformationAddListIEs-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD = CLASS(name='UL-DPCH-InformationAddListIEs-RL-ReconfPrepTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationAddItem-RL-ReconfPrepTDD')))
    UL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD._val = ASN1Set(rv=[dict([('id', 403), ('criticality', 'reject'), ('Value', _UL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationAddItem-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationAddItem_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-InformationAddItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_uL_Timeslot_Information = SEQ_OF(name='uL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-Timeslot-Information')))
    _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationAddItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('uL-Timeslot-Information', _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_uL_Timeslot_Information),
        ('iE-Extensions', _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_DPCH_InformationAddItem_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-DPCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-DPCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD >-----#
    UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_uL_Timeslot_InformationLCR = SEQ_OF(name='uL-Timeslot-InformationLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotLCR-Information')))
    _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('uL-Timeslot-InformationLCR', _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_uL_Timeslot_InformationLCR),
        ('iE-Extensions', _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-DPCH-LCR-InformationAddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_DPCH_LCR_InformationAddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-DPCH-LCR-InformationAddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_LCR_InformationAddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultipleRL-UL-DPCH-InformationAddList-RL-ReconfPrepTDD >-----#
    MultipleRL_UL_DPCH_InformationAddList_RL_ReconfPrepTDD = SEQ_OF(name='MultipleRL-UL-DPCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _MultipleRL_UL_DPCH_InformationAddList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD')))
    MultipleRL_UL_DPCH_InformationAddList_RL_ReconfPrepTDD._cont = _MultipleRL_UL_DPCH_InformationAddList_RL_ReconfPrepTDD__item_
    MultipleRL_UL_DPCH_InformationAddList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< MultipleRL-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD >-----#
    MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD = SEQ(name='MultipleRL-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ul_DPCH_InformationList = SEQ(name='ul-DPCH-InformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationAddList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ul_DPCH_InformationListLCR = SEQ(name='ul-DPCH-InformationListLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ul_sir_target = INT(name='ul-sir-target', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')), opt=True)
    _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_tDD_TPC_UplinkStepSize_LCR = ENUM(name='tDD-TPC-UplinkStepSize-LCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')), opt=True)
    _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')), opt=True)
    _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-768-InformationAddList-RL-ReconfPrepTDD')))
    ____MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 750), ('criticality', 'reject'), ('Extension', _____MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions._cont = __MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item_
    _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('ul-DPCH-InformationList', _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ul_DPCH_InformationList),
        ('ul-DPCH-InformationListLCR', _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ul_DPCH_InformationListLCR),
        ('ul-sir-target', _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ul_sir_target),
        ('tDD-TPC-UplinkStepSize-LCR', _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_tDD_TPC_UplinkStepSize_LCR),
        ('rL-ID', _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_rL_ID),
        ('iE-Extensions', _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions),
        ])
    MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD._ext = []
    
    #-----< MultipleRL-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD-ExtIEs >-----#
    MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs = CLASS(name='MultipleRL-UL-DPCH-InformationAddListIE-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-768-InformationAddList-RL-ReconfPrepTDD')))
    MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 750), ('criticality', 'reject'), ('Extension', _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-768-InformationAddList-RL-ReconfPrepTDD >-----#
    UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-768-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_uL_Timeslot_Information768 = SEQ_OF(name='uL-Timeslot-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-Timeslot768-Information')))
    _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('uL-Timeslot-Information768', _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_uL_Timeslot_Information768),
        ('iE-Extensions', _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_DPCH_768_InformationAddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_768_InformationAddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD = SEQ_OF(name='UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD')))
    UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._cont = _UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_
    UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD = SEQ(name='UL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')), opt=True)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCI_Coding = ENUM(name='tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Coding')), opt=True)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_punctureLimit = INT(name='punctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')), opt=True)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ul_DPCH_InformationAddList = SEQ(name='ul-DPCH-InformationAddList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD')), opt=True)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ul_DPCH_InformationModifyList = SEQ(name='ul-DPCH-InformationModifyList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD')), opt=True)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ul_DPCH_InformationDeleteList = SEQ(name='ul-DPCH-InformationDeleteList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD')), opt=True)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD')))
    _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-UL-DPCH-InformationModifyList-RL-ReconfPrepTDD')))
    _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD')))
    ____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 483), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 510), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 564), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'ignore'), ('Extension', _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 607), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 751), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_ID),
        ('tFCS', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCS),
        ('tFCI-Coding', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCI_Coding),
        ('punctureLimit', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_punctureLimit),
        ('ul-DPCH-InformationAddList', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ul_DPCH_InformationAddList),
        ('ul-DPCH-InformationModifyList', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ul_DPCH_InformationModifyList),
        ('ul-DPCH-InformationDeleteList', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ul_DPCH_InformationDeleteList),
        ('iE-Extensions', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD')))
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-UL-DPCH-InformationModifyList-RL-ReconfPrepTDD')))
    _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD')))
    UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 483), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 510), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 564), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'ignore'), ('Extension', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 607), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 751), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD')))
    __UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab._val = ASN1Set(rv=[dict([('id', 405), ('criticality', 'reject'), ('Value', ___UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id._const_tab = __UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id._const_tab_at = None
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id._const_tab_id = 'id'
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality._const_tab = __UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality._const_tab_at = ('..', 'id')
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality._const_tab_id = 'criticality'
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value._const_tab = __UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value._const_tab_at = ('..', 'id')
    _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value._const_tab_id = 'Value'
    UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('id', _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id),
        ('criticality', _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality),
        ('value', _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value),
        ])
    UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD._ext = None
    
    #-----< UL-DPCH-InformationModify-AddListIEs-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD = CLASS(name='UL-DPCH-InformationModify-AddListIEs-RL-ReconfPrepTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD')))
    UL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD._val = ASN1Set(rv=[dict([('id', 405), ('criticality', 'reject'), ('Value', _UL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_uL_Timeslot_Information = SEQ_OF(name='uL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-Timeslot-Information')))
    _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('uL-Timeslot-Information', _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_uL_Timeslot_Information),
        ('iE-Extensions', _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    __UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab._val = ASN1Set(rv=[dict([('id', 407), ('criticality', 'reject'), ('Value', ___UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id._const_tab = __UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id._const_tab_at = None
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id._const_tab_id = 'id'
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality._const_tab = __UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality._const_tab_at = ('..', 'id')
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality._const_tab_id = 'criticality'
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value._const_tab = __UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value._const_tab_at = ('..', 'id')
    _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value._const_tab_id = 'Value'
    UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('id', _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id),
        ('criticality', _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality),
        ('value', _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value),
        ])
    UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD._ext = None
    
    #-----< UL-DPCH-InformationModify-ModifyListIEs-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD = CLASS(name='UL-DPCH-InformationModify-ModifyListIEs-RL-ReconfPrepTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    UL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD._val = ASN1Set(rv=[dict([('id', 407), ('criticality', 'reject'), ('Value', _UL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')), opt=True)
    _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')), opt=True)
    _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')), opt=True)
    _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='uL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD')), opt=True)
    _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-TimeslotLCR-InformationModify-ModifyList-RL-ReconfPrepTDD')))
    _____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot768-InformationModify-ModifyList-RL-ReconfPrepTDD')))
    ____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 485), ('criticality', 'reject'), ('Extension', _____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 753), ('criticality', 'reject'), ('Extension', _____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('uL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD', _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD),
        ('iE-Extensions', _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-TimeslotLCR-InformationModify-ModifyList-RL-ReconfPrepTDD')))
    _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot768-InformationModify-ModifyList-RL-ReconfPrepTDD')))
    UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 485), ('criticality', 'reject'), ('Extension', _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 753), ('criticality', 'reject'), ('Extension', _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    UL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='UL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    UL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = _UL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD__item_
    UL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='UL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='uL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD')), opt=True)
    _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('timeSlot', _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot),
        ('midambleShiftAndBurstType', _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType),
        ('tFCI-Presence', _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence),
        ('uL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD', _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD),
        ('iE-Extensions', _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = _UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD__item_
    UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('dPCH-ID', _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID),
        ('tdd-ChannelisationCode', _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCode),
        ('iE-Extensions', _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-TimeslotLCR-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    UL_TimeslotLCR_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='UL-TimeslotLCR-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_TimeslotLCR_InformationModify_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    UL_TimeslotLCR_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = _UL_TimeslotLCR_InformationModify_ModifyList_RL_ReconfPrepTDD__item_
    UL_TimeslotLCR_InformationModify_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='UL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')), opt=True)
    _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Code_InformationModify_ModifyList_RL_ReconfPrepTDDLCR = SEQ_OF(name='uL-Code-InformationModify-ModifyList-RL-ReconfPrepTDDLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDDLCR')), opt=True)
    _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PLCCHinformation')))
    ____UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 713), ('criticality', 'reject'), ('Extension', _____UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('timeSlotLCR', _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlotLCR),
        ('midambleShiftLCR', _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftLCR),
        ('tFCI-Presence', _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence),
        ('uL-Code-InformationModify-ModifyList-RL-ReconfPrepTDDLCR', _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Code_InformationModify_ModifyList_RL_ReconfPrepTDDLCR),
        ('iE-Extensions', _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PLCCHinformation')))
    UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 713), ('criticality', 'reject'), ('Extension', _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDDLCR >-----#
    UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDDLCR = SEQ_OF(name='UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDDLCR', mode=MODE_TYPE)
    _UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDDLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDDLCR')))
    UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDDLCR._cont = _UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDDLCR__item_
    UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDDLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDDLCR >-----#
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR = SEQ(name='UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDDLCR', mode=MODE_TYPE)
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')), opt=True)
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-DPCH-TimeSlotFormat-LCR')))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 559), ('criticality', 'reject'), ('Extension', _____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id._const_tab = ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id_tab
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id._const_tab_at = None
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__criticality._const_tab = ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id_tab
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__extensionValue._const_tab = ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id_tab
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id),
        ('criticality', ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__extensionValue),
        ])
    __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item_._ext = None
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions._cont = __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item_
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR._cont = ASN1Dict([
        ('dPCH-ID', _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_dPCH_ID),
        ('tdd-ChannelisationCodeLCR', _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_tdd_ChannelisationCodeLCR),
        ('iE-Extensions', _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions),
        ])
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR._ext = []
    
    #-----< UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDDLCR-ExtIEs >-----#
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_ExtIEs = CLASS(name='UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDDLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-DPCH-TimeSlotFormat-LCR')))
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_ExtIEs._val = ASN1Set(rv=[dict([('id', 559), ('criticality', 'reject'), ('Extension', _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot768-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    UL_Timeslot768_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='UL-Timeslot768-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_Timeslot768_InformationModify_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    UL_Timeslot768_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = _UL_Timeslot768_InformationModify_ModifyList_RL_ReconfPrepTDD__item_
    UL_Timeslot768_InformationModify_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='UL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')), opt=True)
    _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD768 = SEQ_OF(name='uL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD768')), opt=True)
    _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('timeSlot', _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot),
        ('midambleShiftAndBurstType768', _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType768),
        ('tFCI-Presence', _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence),
        ('uL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD768', _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD768),
        ('iE-Extensions', _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD768 >-----#
    UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD768 = SEQ_OF(name='UL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD768', mode=MODE_TYPE)
    _UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD768')))
    UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD768._cont = _UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD768__item_
    UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD768 >-----#
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768 = SEQ(name='UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD768', mode=MODE_TYPE)
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')), opt=True)
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__id._const_tab = ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__id_tab
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__id._const_tab_at = None
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__criticality._const_tab = ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__criticality_tab
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__extensionValue._const_tab = ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__extensionValue_tab
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__id),
        ('criticality', ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__extensionValue),
        ])
    __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item_._ext = None
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions._cont = __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item_
    _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768._cont = ASN1Dict([
        ('dPCH-ID', _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_dPCH_ID),
        ('tdd-ChannelisationCode768', _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_tdd_ChannelisationCode768),
        ('iE-Extensions', _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions),
        ])
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768._ext = []
    
    #-----< UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD768-ExtIEs >-----#
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_ExtIEs = CLASS(name='UL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD')))
    __UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab._val = ASN1Set(rv=[dict([('id', 406), ('criticality', 'reject'), ('Value', ___UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id._const_tab = __UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id._const_tab_at = None
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id._const_tab_id = 'id'
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality._const_tab = __UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality._const_tab_at = ('..', 'id')
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality._const_tab_id = 'criticality'
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value._const_tab = __UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value._const_tab_at = ('..', 'id')
    _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value._const_tab_id = 'Value'
    UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('id', _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id),
        ('criticality', _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality),
        ('value', _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value),
        ])
    UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD._ext = None
    
    #-----< UL-DPCH-InformationModify-DeleteListIEs-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD = CLASS(name='UL-DPCH-InformationModify-DeleteListIEs-RL-ReconfPrepTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD')))
    UL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD._val = ASN1Set(rv=[dict([('id', 406), ('criticality', 'reject'), ('Value', _UL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD = SEQ_OF(name='UL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD')))
    UL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD._cont = _UL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD__item_
    UL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< UL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD >-----#
    UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('dPCH-ID', _UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_dPCH_ID),
        ('iE-Extensions', _UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD >-----#
    UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_uL_Timeslot_InformationLCR = SEQ_OF(name='uL-Timeslot-InformationLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-TimeslotLCR-Information')))
    _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('uL-Timeslot-InformationLCR', _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_uL_Timeslot_InformationLCR),
        ('iE-Extensions', _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-DPCH-LCR-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_DPCH_LCR_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-DPCH-LCR-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_LCR_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultipleRL-UL-DPCH-InformationModifyList-RL-ReconfPrepTDD >-----#
    MultipleRL_UL_DPCH_InformationModifyList_RL_ReconfPrepTDD = SEQ_OF(name='MultipleRL-UL-DPCH-InformationModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _MultipleRL_UL_DPCH_InformationModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-UL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD')))
    MultipleRL_UL_DPCH_InformationModifyList_RL_ReconfPrepTDD._cont = _MultipleRL_UL_DPCH_InformationModifyList_RL_ReconfPrepTDD__item_
    MultipleRL_UL_DPCH_InformationModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< MultipleRL-UL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD >-----#
    MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD = SEQ(name='MultipleRL-UL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationAddList = SEQ(name='ul-DPCH-InformationAddList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationModifyList = SEQ(name='ul-DPCH-InformationModifyList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationDeleteList = SEQ(name='ul-DPCH-InformationDeleteList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationAddListLCR = SEQ(name='ul-DPCH-InformationAddListLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_sir_target = INT(name='ul-sir-target', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')), opt=True)
    _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_tDD_TPC_UplinkStepSize_LCR = ENUM(name='tDD-TPC-UplinkStepSize-LCR', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')), opt=True)
    _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')), opt=True)
    _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD')))
    ____MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 752), ('criticality', 'reject'), ('Extension', _____MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions._cont = __MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item_
    _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('ul-DPCH-InformationAddList', _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationAddList),
        ('ul-DPCH-InformationModifyList', _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationModifyList),
        ('ul-DPCH-InformationDeleteList', _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationDeleteList),
        ('ul-DPCH-InformationAddListLCR', _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationAddListLCR),
        ('ul-sir-target', _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_sir_target),
        ('tDD-TPC-UplinkStepSize-LCR', _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_tDD_TPC_UplinkStepSize_LCR),
        ('rL-ID', _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_rL_ID),
        ('iE-Extensions', _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions),
        ])
    MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD._ext = []
    
    #-----< MultipleRL-UL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD-ExtIEs >-----#
    MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs = CLASS(name='MultipleRL-UL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD')))
    MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 752), ('criticality', 'reject'), ('Extension', _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD >-----#
    UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD = SEQ(name='UL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_uL_Timeslot_Information768 = SEQ_OF(name='uL-Timeslot-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UL-Timeslot768-Information')))
    _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('uL-Timeslot-Information768', _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_uL_Timeslot_Information768),
        ('iE-Extensions', _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_DPCH_768_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_DPCH_768_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD = SEQ_OF(name='UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD')))
    UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._cont = _UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_
    UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD = SEQ(name='UL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_cCTrCH_ID),
        ('iE-Extensions', _UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='UL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD = SEQ_OF(name='DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD')))
    DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._cont = _DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_
    DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD = SEQ(name='DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCI_Coding = ENUM(name='tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Coding')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_punctureLimit = INT(name='punctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_TPCList = SEQ_OF(name='cCTrCH-TPCList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-TPCAddList-RL-ReconfPrepTDD')), opt=True)
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_dl_DPCH_InformationList = SEQ(name='dl-DPCH-InformationList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationAddList-RL-ReconfPrepTDD')), opt=True)
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD')))
    _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-DL-DPCH-InformationAddList-RL-ReconfPrepTDD')))
    _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD')))
    ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 475), ('criticality', 'reject'), ('Extension', _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 519), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 566), ('criticality', 'reject'), ('Extension', _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 571), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 572), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 604), ('criticality', 'reject'), ('Extension', _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 754), ('criticality', 'reject'), ('Extension', _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_ID),
        ('tFCS', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCS),
        ('tFCI-Coding', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCI_Coding),
        ('punctureLimit', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_punctureLimit),
        ('cCTrCH-TPCList', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_TPCList),
        ('dl-DPCH-InformationList', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_dl_DPCH_InformationList),
        ('iE-Extensions', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-DL-DPCH-InformationAddList-RL-ReconfPrepTDD')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD')))
    DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 475), ('criticality', 'reject'), ('Extension', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 519), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 566), ('criticality', 'reject'), ('Extension', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 571), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 572), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 604), ('criticality', 'reject'), ('Extension', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 754), ('criticality', 'reject'), ('Extension', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-TPCAddList-RL-ReconfPrepTDD >-----#
    CCTrCH_TPCAddList_RL_ReconfPrepTDD = SEQ_OF(name='CCTrCH-TPCAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _CCTrCH_TPCAddList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-TPCAddItem-RL-ReconfPrepTDD')))
    CCTrCH_TPCAddList_RL_ReconfPrepTDD._cont = _CCTrCH_TPCAddList_RL_ReconfPrepTDD__item_
    CCTrCH_TPCAddList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CCTrCH-TPCAddItem-RL-ReconfPrepTDD >-----#
    CCTrCH_TPCAddItem_RL_ReconfPrepTDD = SEQ(name='CCTrCH-TPCAddItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions._cont = __CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_TPCAddItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_cCTrCH_ID),
        ('iE-Extensions', _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    CCTrCH_TPCAddItem_RL_ReconfPrepTDD._ext = []
    
    #-----< CCTrCH-TPCAddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    CCTrCH_TPCAddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='CCTrCH-TPCAddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CCTrCH_TPCAddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationAddList-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationAddList_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationAddItem-RL-ReconfPrepTDD')))
    __DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab._val = ASN1Set(rv=[dict([('id', 353), ('criticality', 'reject'), ('Value', ___DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id._const_tab = __DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id._const_tab_at = None
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id._const_tab_id = 'id'
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality._const_tab = __DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality._const_tab_at = ('..', 'id')
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality._const_tab_id = 'criticality'
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_value._const_tab = __DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_value._const_tab_at = ('..', 'id')
    _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_value._const_tab_id = 'Value'
    DL_DPCH_InformationAddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('id', _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id),
        ('criticality', _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality),
        ('value', _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_value),
        ])
    DL_DPCH_InformationAddList_RL_ReconfPrepTDD._ext = None
    
    #-----< DL-DPCH-InformationAddListIEs-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD = CLASS(name='DL-DPCH-InformationAddListIEs-RL-ReconfPrepTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationAddItem-RL-ReconfPrepTDD')))
    DL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD._val = ASN1Set(rv=[dict([('id', 353), ('criticality', 'reject'), ('Value', _DL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationAddItem-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationAddItem_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-InformationAddItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_dL_Timeslot_Information = SEQ_OF(name='dL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Timeslot-Information')))
    _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationAddItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('dL-Timeslot-Information', _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_dL_Timeslot_Information),
        ('iE-Extensions', _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_DPCH_InformationAddItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-DPCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-DPCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD >-----#
    DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_dL_Timeslot_InformationLCR = SEQ_OF(name='dL-Timeslot-InformationLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotLCR-Information')))
    _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('dL-Timeslot-InformationLCR', _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_dL_Timeslot_InformationLCR),
        ('iE-Extensions', _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-DPCH-LCR-InformationAddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_DPCH_LCR_InformationAddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-DPCH-LCR-InformationAddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_LCR_InformationAddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultipleRL-DL-DPCH-InformationAddList-RL-ReconfPrepTDD >-----#
    MultipleRL_DL_DPCH_InformationAddList_RL_ReconfPrepTDD = SEQ_OF(name='MultipleRL-DL-DPCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _MultipleRL_DL_DPCH_InformationAddList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD')))
    MultipleRL_DL_DPCH_InformationAddList_RL_ReconfPrepTDD._cont = _MultipleRL_DL_DPCH_InformationAddList_RL_ReconfPrepTDD__item_
    MultipleRL_DL_DPCH_InformationAddList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< MultipleRL-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD >-----#
    MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD = SEQ(name='MultipleRL-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_dl_DPCH_InformationList = SEQ(name='dl-DPCH-InformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationAddList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_dl_DPCH_InformationListLCR = SEQ(name='dl-DPCH-InformationListLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-LCR-InformationAddList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_cCTrCH_Initial_DL_Power = INT(name='cCTrCH-Initial-DL-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_tDD_TPC_DownlinkStepSize = ENUM(name='tDD-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')), opt=True)
    _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_cCTrCH_Maximum_DL_Power_InformationAdd_RL_ReconfPrepTDD = INT(name='cCTrCH-Maximum-DL-Power-InformationAdd-RL-ReconfPrepTDD', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_cCTrCH_Minimum_DL_Power_InformationAdd_RL_ReconfPrepTDD = INT(name='cCTrCH-Minimum-DL-Power-InformationAdd-RL-ReconfPrepTDD', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')), opt=True)
    _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD')))
    ____MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 755), ('criticality', 'reject'), ('Extension', _____MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions._cont = __MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item_
    _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('dl-DPCH-InformationList', _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_dl_DPCH_InformationList),
        ('dl-DPCH-InformationListLCR', _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_dl_DPCH_InformationListLCR),
        ('cCTrCH-Initial-DL-Power', _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_cCTrCH_Initial_DL_Power),
        ('tDD-TPC-DownlinkStepSize', _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_tDD_TPC_DownlinkStepSize),
        ('cCTrCH-Maximum-DL-Power-InformationAdd-RL-ReconfPrepTDD', _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_cCTrCH_Maximum_DL_Power_InformationAdd_RL_ReconfPrepTDD),
        ('cCTrCH-Minimum-DL-Power-InformationAdd-RL-ReconfPrepTDD', _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_cCTrCH_Minimum_DL_Power_InformationAdd_RL_ReconfPrepTDD),
        ('rL-ID', _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_rL_ID),
        ('iE-Extensions', _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions),
        ])
    MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD._ext = []
    
    #-----< MultipleRL-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD-ExtIEs >-----#
    MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs = CLASS(name='MultipleRL-DL-DPCH-InformationAddListIE-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD')))
    MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 755), ('criticality', 'reject'), ('Extension', _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD >-----#
    DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-768-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_dL_Timeslot_Information768 = SEQ_OF(name='dL-Timeslot-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Timeslot768-Information')))
    _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('dL-Timeslot-Information768', _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_dL_Timeslot_Information768),
        ('iE-Extensions', _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_DPCH_768_InformationAddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-DPCH-768-InformationAddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_768_InformationAddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD = SEQ_OF(name='DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD')))
    DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._cont = _DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_
    DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD = SEQ(name='DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCI_Coding = ENUM(name='tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Coding')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_punctureLimit = INT(name='punctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_TPCList = SEQ_OF(name='cCTrCH-TPCList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-TPCModifyList-RL-ReconfPrepTDD')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_dl_DPCH_InformationAddList = SEQ(name='dl-DPCH-InformationAddList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_dl_DPCH_InformationModifyList = SEQ(name='dl-DPCH-InformationModifyList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_dl_DPCH_InformationDeleteList = SEQ(name='dl-DPCH-InformationDeleteList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-DL-DPCH-InformationModifyList-RL-ReconfPrepTDD')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD')))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 477), ('criticality', 'reject'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 565), ('criticality', 'reject'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 573), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 574), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 605), ('criticality', 'reject'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 756), ('criticality', 'reject'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_ID),
        ('tFCS', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCS),
        ('tFCI-Coding', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCI_Coding),
        ('punctureLimit', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_punctureLimit),
        ('cCTrCH-TPCList', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_TPCList),
        ('dl-DPCH-InformationAddList', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_dl_DPCH_InformationAddList),
        ('dl-DPCH-InformationModifyList', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_dl_DPCH_InformationModifyList),
        ('dl-DPCH-InformationDeleteList', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_dl_DPCH_InformationDeleteList),
        ('iE-Extensions', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-DL-DPCH-InformationModifyList-RL-ReconfPrepTDD')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD')))
    DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 477), ('criticality', 'reject'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 565), ('criticality', 'reject'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 573), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 574), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 605), ('criticality', 'reject'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 756), ('criticality', 'reject'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-TPCModifyList-RL-ReconfPrepTDD >-----#
    CCTrCH_TPCModifyList_RL_ReconfPrepTDD = SEQ_OF(name='CCTrCH-TPCModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _CCTrCH_TPCModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD')))
    CCTrCH_TPCModifyList_RL_ReconfPrepTDD._cont = _CCTrCH_TPCModifyList_RL_ReconfPrepTDD__item_
    CCTrCH_TPCModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CCTrCH-TPCModifyItem-RL-ReconfPrepTDD >-----#
    CCTrCH_TPCModifyItem_RL_ReconfPrepTDD = SEQ(name='CCTrCH-TPCModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_TPCModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_cCTrCH_ID),
        ('iE-Extensions', _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    CCTrCH_TPCModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< CCTrCH-TPCModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='CCTrCH-TPCModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD')))
    __DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab._val = ASN1Set(rv=[dict([('id', 355), ('criticality', 'reject'), ('Value', ___DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id._const_tab = __DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id._const_tab_at = None
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id._const_tab_id = 'id'
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality._const_tab = __DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality._const_tab_at = ('..', 'id')
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality._const_tab_id = 'criticality'
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value._const_tab = __DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value._const_tab_at = ('..', 'id')
    _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value._const_tab_id = 'Value'
    DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('id', _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id),
        ('criticality', _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality),
        ('value', _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value),
        ])
    DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD._ext = None
    
    #-----< DL-DPCH-InformationModify-AddListIEs-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD = CLASS(name='DL-DPCH-InformationModify-AddListIEs-RL-ReconfPrepTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD')))
    DL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD._val = ASN1Set(rv=[dict([('id', 355), ('criticality', 'reject'), ('Value', _DL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_dL_Timeslot_Information = SEQ_OF(name='dL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Timeslot-Information')))
    _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('dL-Timeslot-Information', _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_dL_Timeslot_Information),
        ('iE-Extensions', _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-DPCH-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    __DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab._val = ASN1Set(rv=[dict([('id', 357), ('criticality', 'reject'), ('Value', ___DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id._const_tab = __DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id._const_tab_at = None
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id._const_tab_id = 'id'
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality._const_tab = __DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality._const_tab_at = ('..', 'id')
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality._const_tab_id = 'criticality'
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value._const_tab = __DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value._const_tab_at = ('..', 'id')
    _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value._const_tab_id = 'Value'
    DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('id', _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id),
        ('criticality', _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality),
        ('value', _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value),
        ])
    DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD._ext = None
    
    #-----< DL-DPCH-InformationModify-ModifyListIEs-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD = CLASS(name='DL-DPCH-InformationModify-ModifyListIEs-RL-ReconfPrepTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    DL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD._val = ASN1Set(rv=[dict([('id', 357), ('criticality', 'reject'), ('Value', _DL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')), opt=True)
    _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')), opt=True)
    _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')), opt=True)
    _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Timeslot_InformationAddModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='dL-Timeslot-InformationAddModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD')), opt=True)
    _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD')))
    _____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-768-InformationModify-ModifyList-RL-ReconfPrepTDD')))
    ____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 479), ('criticality', 'reject'), ('Extension', _____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 758), ('criticality', 'reject'), ('Extension', _____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('dL-Timeslot-InformationAddModify-ModifyList-RL-ReconfPrepTDD', _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Timeslot_InformationAddModify_ModifyList_RL_ReconfPrepTDD),
        ('iE-Extensions', _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-DPCH-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD')))
    _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-768-InformationModify-ModifyList-RL-ReconfPrepTDD')))
    DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 479), ('criticality', 'reject'), ('Extension', _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 758), ('criticality', 'reject'), ('Extension', _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    DL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='DL-Timeslot-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    DL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = _DL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD__item_
    DL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='DL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='dL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD')), opt=True)
    _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('timeSlot', _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot),
        ('midambleShiftAndBurstType', _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType),
        ('tFCI-Presence', _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence),
        ('dL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD', _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD),
        ('iE-Extensions', _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-Timeslot-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    DL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='DL-Code-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    DL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = _DL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD__item_
    DL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=240)], ev=None, er=[])
    
    #-----< DL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='DL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('dPCH-ID', _DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID),
        ('tdd-ChannelisationCode', _DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCode),
        ('iE-Extensions', _DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-Code-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = _DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD__item_
    DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')), opt=True)
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Code_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='dL-Code-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD')), opt=True)
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 575), ('criticality', 'ignore'), ('Extension', _____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 576), ('criticality', 'ignore'), ('Extension', _____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('timeSlotLCR', _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlotLCR),
        ('midambleShiftLCR', _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftLCR),
        ('tFCI-Presence', _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence),
        ('dL-Code-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD', _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Code_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD),
        ('iE-Extensions', _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 575), ('criticality', 'ignore'), ('Extension', _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 576), ('criticality', 'ignore'), ('Extension', _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-Code-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    DL_Code_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='DL-Code-LCR-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Code_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    DL_Code_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = _DL_Code_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD__item_
    DL_Code_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< DL-Code-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='DL-Code-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')), opt=True)
    _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    ____DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 558), ('criticality', 'reject'), ('Extension', _____DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('dPCH-ID', _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID),
        ('tdd-ChannelisationCodeLCR', _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCodeLCR),
        ('iE-Extensions', _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-Code-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-Code-LCR-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 558), ('criticality', 'reject'), ('Extension', _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-768-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    DL_Timeslot_768_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='DL-Timeslot-768-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Timeslot_768_InformationModify_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    DL_Timeslot_768_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = _DL_Timeslot_768_InformationModify_ModifyList_RL_ReconfPrepTDD__item_
    DL_Timeslot_768_InformationModify_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='DL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Code_768_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='dL-Code-768-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-768-InformationModify-ModifyList-RL-ReconfPrepTDD')), opt=True)
    _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('timeSlot', _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot),
        ('midambleShiftAndBurstType', _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType),
        ('tFCI-Presence', _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence),
        ('dL-Code-768-InformationModify-ModifyList-RL-ReconfPrepTDD', _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Code_768_InformationModify_ModifyList_RL_ReconfPrepTDD),
        ('iE-Extensions', _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-Timeslot-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Code-768-InformationModify-ModifyList-RL-ReconfPrepTDD >-----#
    DL_Code_768_InformationModify_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='DL-Code-768-InformationModify-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Code_768_InformationModify_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-768-InformationModify-ModifyItem-RL-ReconfPrepTDD')))
    DL_Code_768_InformationModify_ModifyList_RL_ReconfPrepTDD._cont = _DL_Code_768_InformationModify_ModifyList_RL_ReconfPrepTDD__item_
    DL_Code_768_InformationModify_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=480)], ev=None, er=[])
    
    #-----< DL-Code-768-InformationModify-ModifyItem-RL-ReconfPrepTDD >-----#
    DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD = SEQ(name='DL-Code-768-InformationModify-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID768 = INT(name='dPCH-ID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID768')))
    _DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')), opt=True)
    _DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('dPCH-ID768', _DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID768),
        ('tdd-ChannelisationCode768', _DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCode768),
        ('iE-Extensions', _DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-Code-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-Code-768-InformationModify-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD')))
    __DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab._val = ASN1Set(rv=[dict([('id', 356), ('criticality', 'reject'), ('Value', ___DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id._const_tab = __DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id._const_tab_at = None
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id._const_tab_id = 'id'
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality._const_tab = __DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality._const_tab_at = ('..', 'id')
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality._const_tab_id = 'criticality'
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value._const_tab = __DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value._const_tab_at = ('..', 'id')
    _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value._const_tab_id = 'Value'
    DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('id', _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id),
        ('criticality', _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality),
        ('value', _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value),
        ])
    DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD._ext = None
    
    #-----< DL-DPCH-InformationModify-DeleteListIEs-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD = CLASS(name='DL-DPCH-InformationModify-DeleteListIEs-RL-ReconfPrepTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD')))
    DL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD._val = ASN1Set(rv=[dict([('id', 356), ('criticality', 'reject'), ('Value', _DL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD = SEQ_OF(name='DL-DPCH-InformationModify-DeleteListIE-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD')))
    DL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD._cont = _DL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD__item_
    DL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< DL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD >-----#
    DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('dPCH-ID', _DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_dPCH_ID),
        ('iE-Extensions', _DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-DPCH-InformationModify-DeleteItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD >-----#
    DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_dL_Timeslot_InformationLCR = SEQ_OF(name='dL-Timeslot-InformationLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotLCR-Information')))
    _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('dL-Timeslot-InformationLCR', _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_dL_Timeslot_InformationLCR),
        ('iE-Extensions', _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-DPCH-LCR-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_DPCH_LCR_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-DPCH-LCR-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_LCR_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultipleRL-DL-DPCH-InformationModifyList-RL-ReconfPrepTDD >-----#
    MultipleRL_DL_DPCH_InformationModifyList_RL_ReconfPrepTDD = SEQ_OF(name='MultipleRL-DL-DPCH-InformationModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _MultipleRL_DL_DPCH_InformationModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-DL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD')))
    MultipleRL_DL_DPCH_InformationModifyList_RL_ReconfPrepTDD._cont = _MultipleRL_DL_DPCH_InformationModifyList_RL_ReconfPrepTDD__item_
    MultipleRL_DL_DPCH_InformationModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< MultipleRL-DL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD >-----#
    MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD = SEQ(name='MultipleRL-DL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationAddList = SEQ(name='dl-DPCH-InformationAddList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-AddList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationModifyList = SEQ(name='dl-DPCH-InformationModifyList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-ModifyList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationDeleteList = SEQ(name='dl-DPCH-InformationDeleteList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-InformationModify-DeleteList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationAddListLCR = SEQ(name='dl-DPCH-InformationAddListLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-LCR-InformationModify-AddList-RL-ReconfPrepTDD')), opt=True)
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_tDD_TPC_DownlinkStepSize_InformationModify_RL_ReconfPrepTDD = ENUM(name='tDD-TPC-DownlinkStepSize-InformationModify-RL-ReconfPrepTDD', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')), opt=True)
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_cCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfPrepTDD = INT(name='cCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfPrepTDD', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_cCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfPrepTDD = INT(name='cCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfPrepTDD', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')), opt=True)
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD')))
    ____MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 757), ('criticality', 'reject'), ('Extension', _____MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions._cont = __MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item_
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('dl-DPCH-InformationAddList', _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationAddList),
        ('dl-DPCH-InformationModifyList', _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationModifyList),
        ('dl-DPCH-InformationDeleteList', _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationDeleteList),
        ('dl-DPCH-InformationAddListLCR', _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationAddListLCR),
        ('tDD-TPC-DownlinkStepSize-InformationModify-RL-ReconfPrepTDD', _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_tDD_TPC_DownlinkStepSize_InformationModify_RL_ReconfPrepTDD),
        ('cCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfPrepTDD', _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_cCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfPrepTDD),
        ('cCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfPrepTDD', _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_cCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfPrepTDD),
        ('rL-ID', _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_rL_ID),
        ('iE-Extensions', _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions),
        ])
    MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD._ext = []
    
    #-----< MultipleRL-DL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD-ExtIEs >-----#
    MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs = CLASS(name='MultipleRL-DL-DPCH-InformationModifyListIE-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD')))
    MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 757), ('criticality', 'reject'), ('Extension', _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD >-----#
    DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD = SEQ(name='DL-DPCH-768-InformationModify-AddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_dL_Timeslot_Information768 = SEQ_OF(name='dL-Timeslot-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Timeslot768-Information')))
    _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('repetitionPeriod', _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod),
        ('repetitionLength', _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength),
        ('tdd-DPCHOffset', _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset),
        ('dL-Timeslot-Information768', _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_dL_Timeslot_Information768),
        ('iE-Extensions', _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_DPCH_768_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-DPCH-768-InformationModify-AddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_768_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD = SEQ_OF(name='DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD')))
    DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._cont = _DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_
    DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD = SEQ(name='DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_cCTrCH_ID),
        ('iE-Extensions', _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-DeleteList-RL-ReconfPrepTDD >-----#
    DCH_DeleteList_RL_ReconfPrepTDD = SEQ_OF(name='DCH-DeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DCH_DeleteList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteItem-RL-ReconfPrepTDD')))
    DCH_DeleteList_RL_ReconfPrepTDD._cont = _DCH_DeleteList_RL_ReconfPrepTDD__item_
    DCH_DeleteList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-DeleteItem-RL-ReconfPrepTDD >-----#
    DCH_DeleteItem_RL_ReconfPrepTDD = SEQ(name='DCH-DeleteItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DCH_DeleteItem_RL_ReconfPrepTDD_dCH_ID = INT(name='dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    _DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_DeleteItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('dCH-ID', _DCH_DeleteItem_RL_ReconfPrepTDD_dCH_ID),
        ('iE-Extensions', _DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DCH_DeleteItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DSCH-Information-ModifyList-RL-ReconfPrepTDD >-----#
    DSCH_Information_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='DSCH-Information-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DSCH_Information_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-Information-ModifyItem-RL-ReconfPrepTDD')))
    DSCH_Information_ModifyList_RL_ReconfPrepTDD._cont = _DSCH_Information_ModifyList_RL_ReconfPrepTDD__item_
    DSCH_Information_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DSCH-Information-ModifyItem-RL-ReconfPrepTDD >-----#
    DSCH_Information_ModifyItem_RL_ReconfPrepTDD = SEQ(name='DSCH-Information-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_dSCH_ID = INT(name='dSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DSCH-ID')))
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')), opt=True)
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_transportFormatSet = SEQ(name='transportFormatSet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')), opt=True)
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_frameHandlingPriority = INT(name='frameHandlingPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FrameHandlingPriority')), opt=True)
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_toAWS = INT(name='toAWS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWS')), opt=True)
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_toAWE = INT(name='toAWE', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'ToAWE')), opt=True)
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator = ENUM(name='transportBearerRequestIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCH_Information_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('dSCH-ID', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_dSCH_ID),
        ('cCTrCH-ID', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_cCTrCH_ID),
        ('transportFormatSet', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_transportFormatSet),
        ('allocationRetentionPriority', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority),
        ('frameHandlingPriority', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_frameHandlingPriority),
        ('toAWS', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_toAWS),
        ('toAWE', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_toAWE),
        ('transportBearerRequestIndicator', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator),
        ('iE-Extensions', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DSCH_Information_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DSCH-Information-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DSCH-Information-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DSCH-Information-DeleteList-RL-ReconfPrepTDD >-----#
    DSCH_Information_DeleteList_RL_ReconfPrepTDD = SEQ_OF(name='DSCH-Information-DeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DSCH_Information_DeleteList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-Information-DeleteItem-RL-ReconfPrepTDD')))
    DSCH_Information_DeleteList_RL_ReconfPrepTDD._cont = _DSCH_Information_DeleteList_RL_ReconfPrepTDD__item_
    DSCH_Information_DeleteList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DSCH-Information-DeleteItem-RL-ReconfPrepTDD >-----#
    DSCH_Information_DeleteItem_RL_ReconfPrepTDD = SEQ(name='DSCH-Information-DeleteItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DSCH_Information_DeleteItem_RL_ReconfPrepTDD_dSCH_ID = INT(name='dSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DSCH-ID')))
    _DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCH_Information_DeleteItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('dSCH-ID', _DSCH_Information_DeleteItem_RL_ReconfPrepTDD_dSCH_ID),
        ('iE-Extensions', _DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DSCH_Information_DeleteItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DSCH-Information-DeleteItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DSCH_Information_DeleteItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='DSCH-Information-DeleteItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DSCH_Information_DeleteItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< USCH-Information-ModifyList-RL-ReconfPrepTDD >-----#
    USCH_Information_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name='USCH-Information-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _USCH_Information_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-Information-ModifyItem-RL-ReconfPrepTDD')))
    USCH_Information_ModifyList_RL_ReconfPrepTDD._cont = _USCH_Information_ModifyList_RL_ReconfPrepTDD__item_
    USCH_Information_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< USCH-Information-ModifyItem-RL-ReconfPrepTDD >-----#
    USCH_Information_ModifyItem_RL_ReconfPrepTDD = SEQ(name='USCH-Information-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _USCH_Information_ModifyItem_RL_ReconfPrepTDD_uSCH_ID = INT(name='uSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'USCH-ID')))
    _USCH_Information_ModifyItem_RL_ReconfPrepTDD_transportFormatSet = SEQ(name='transportFormatSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportFormatSet')), opt=True)
    _USCH_Information_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _USCH_Information_ModifyItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')), opt=True)
    _USCH_Information_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator = ENUM(name='transportBearerRequestIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TransportBearerRequestIndicator')))
    _USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    ____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCH_Information_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('uSCH-ID', _USCH_Information_ModifyItem_RL_ReconfPrepTDD_uSCH_ID),
        ('transportFormatSet', _USCH_Information_ModifyItem_RL_ReconfPrepTDD_transportFormatSet),
        ('allocationRetentionPriority', _USCH_Information_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority),
        ('cCTrCH-ID', _USCH_Information_ModifyItem_RL_ReconfPrepTDD_cCTrCH_ID),
        ('transportBearerRequestIndicator', _USCH_Information_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator),
        ('iE-Extensions', _USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    USCH_Information_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< USCH-Information-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='USCH-Information-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'BindingID')))
    _USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TransportLayerAddress')))
    _USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TnlQos')))
    USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 102), ('criticality', 'ignore'), ('Extension', _USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 616), ('criticality', 'ignore'), ('Extension', _USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< USCH-Information-DeleteList-RL-ReconfPrepTDD >-----#
    USCH_Information_DeleteList_RL_ReconfPrepTDD = SEQ_OF(name='USCH-Information-DeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _USCH_Information_DeleteList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-Information-DeleteItem-RL-ReconfPrepTDD')))
    USCH_Information_DeleteList_RL_ReconfPrepTDD._cont = _USCH_Information_DeleteList_RL_ReconfPrepTDD__item_
    USCH_Information_DeleteList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< USCH-Information-DeleteItem-RL-ReconfPrepTDD >-----#
    USCH_Information_DeleteItem_RL_ReconfPrepTDD = SEQ(name='USCH-Information-DeleteItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _USCH_Information_DeleteItem_RL_ReconfPrepTDD_uSCH_ID = INT(name='uSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'USCH-ID')))
    _USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._cont = __USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCH_Information_DeleteItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('uSCH-ID', _USCH_Information_DeleteItem_RL_ReconfPrepTDD_uSCH_ID),
        ('iE-Extensions', _USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    USCH_Information_DeleteItem_RL_ReconfPrepTDD._ext = []
    
    #-----< USCH-Information-DeleteItem-RL-ReconfPrepTDD-ExtIEs >-----#
    USCH_Information_DeleteItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name='USCH-Information-DeleteItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    USCH_Information_DeleteItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultipleRL-Information-RL-ReconfPrepTDD >-----#
    MultipleRL_Information_RL_ReconfPrepTDD = SEQ_OF(name='MultipleRL-Information-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _MultipleRL_Information_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Information-RL-ReconfPrepTDD')))
    MultipleRL_Information_RL_ReconfPrepTDD._cont = _MultipleRL_Information_RL_ReconfPrepTDD__item_
    MultipleRL_Information_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< RL-Information-RL-ReconfPrepTDD >-----#
    RL_Information_RL_ReconfPrepTDD = SEQ(name='RL-Information-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _RL_Information_RL_ReconfPrepTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_Information_RL_ReconfPrepTDD_maxDL_Power = INT(name='maxDL-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_Information_RL_ReconfPrepTDD_minDL_Power = INT(name='minDL-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_Information_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfoLCR')))
    _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 509), ('criticality', 'ignore'), ('Extension', _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 554), ('criticality', 'ignore'), ('Extension', _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 599), ('criticality', 'ignore'), ('Extension', _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Information_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id),
        ('criticality', ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _RL_Information_RL_ReconfPrepTDD_iE_Extensions._cont = __RL_Information_RL_ReconfPrepTDD_iE_Extensions__item_
    _RL_Information_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_RL_ReconfPrepTDD._cont = ASN1Dict([
        ('rL-ID', _RL_Information_RL_ReconfPrepTDD_rL_ID),
        ('maxDL-Power', _RL_Information_RL_ReconfPrepTDD_maxDL_Power),
        ('minDL-Power', _RL_Information_RL_ReconfPrepTDD_minDL_Power),
        ('iE-Extensions', _RL_Information_RL_ReconfPrepTDD_iE_Extensions),
        ])
    RL_Information_RL_ReconfPrepTDD._ext = []
    
    #-----< RL-Information-RL-ReconfPrepTDD-ExtIEs >-----#
    RL_Information_RL_ReconfPrepTDD_ExtIEs = CLASS(name='RL-Information-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfoLCR')))
    _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    RL_Information_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 509), ('criticality', 'ignore'), ('Extension', _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 554), ('criticality', 'ignore'), ('Extension', _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 599), ('criticality', 'ignore'), ('Extension', _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationReady >-----#
    RadioLinkReconfigurationReady = SEQ(name='RadioLinkReconfigurationReady', mode=MODE_TYPE)
    _RadioLinkReconfigurationReady_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationReady_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationReady_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkReconfigurationReady_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationReady_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkReconfigurationReady_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseList-RL-ReconfReady')))
    _____RadioLinkReconfigurationReady_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkReconfigurationReady_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationReady_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationReady_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationReady_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationReady_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationReady_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationReady_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationReady_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationReady_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkReconfigurationReady_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationReady_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationReady_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationReady_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationReady_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkReconfigurationReady_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationReady_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationReady_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationReady_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkReconfigurationReady_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationReady_protocolIEs__item__id),
        ('criticality', ___RadioLinkReconfigurationReady_protocolIEs__item__criticality),
        ('value', ___RadioLinkReconfigurationReady_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationReady_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationReady_protocolIEs._cont = __RadioLinkReconfigurationReady_protocolIEs__item_
    _RadioLinkReconfigurationReady_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationReady_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationReady_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationReady_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Response')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAChs-ResetIndicator')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-Reconfiguration-Permission')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information-Response')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_11 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLReconf-List')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_12 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_13 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-Response')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_15 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_16 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    ____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 139), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 531), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 537), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 800), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 826), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 828), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 835), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1038), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1055), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1057), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1058), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 1158), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 1150), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 1189), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 1193), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 1256), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 1257), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_16), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationReady_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationReady_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationReady_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationReady_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkReconfigurationReady_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationReady_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationReady_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationReady_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkReconfigurationReady_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationReady_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationReady_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkReconfigurationReady_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationReady_protocolExtensions__item__id),
        ('criticality', ___RadioLinkReconfigurationReady_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkReconfigurationReady_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationReady_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationReady_protocolExtensions._cont = __RadioLinkReconfigurationReady_protocolExtensions__item_
    _RadioLinkReconfigurationReady_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationReady._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkReconfigurationReady_protocolIEs),
        ('protocolExtensions', _RadioLinkReconfigurationReady_protocolExtensions),
        ])
    RadioLinkReconfigurationReady._ext = []
    
    #-----< RadioLinkReconfigurationReady-IEs >-----#
    RadioLinkReconfigurationReady_IEs = CLASS(name='RadioLinkReconfigurationReady-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationReady_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkReconfigurationReady_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseList-RL-ReconfReady')))
    _RadioLinkReconfigurationReady_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkReconfigurationReady_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationReady_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationReady_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationReady_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationReady-Extensions >-----#
    RadioLinkReconfigurationReady_Extensions = CLASS(name='RadioLinkReconfigurationReady-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Response')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAChs-ResetIndicator')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-Reconfiguration-Permission')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information-Response')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_11 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLReconf-List')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_12 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_13 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-Response')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_15 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _RadioLinkReconfigurationReady_Extensions_val_Extension_16 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    RadioLinkReconfigurationReady_Extensions._val = ASN1Set(rv=[dict([('id', 139), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 531), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 537), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 800), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 826), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 828), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 835), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 1038), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 1055), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 1057), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 1058), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 1158), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 1150), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 1189), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 1193), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 1256), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_15), ('presence', 'optional')]), dict([('id', 1257), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationReady_Extensions_val_Extension_16), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponseList-RL-ReconfReady >-----#
    RL_InformationResponseList_RL_ReconfReady = SEQ_OF(name='RL-InformationResponseList-RL-ReconfReady', mode=MODE_TYPE)
    _RL_InformationResponseList_RL_ReconfReady__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationResponseList_RL_ReconfReady__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationResponseList_RL_ReconfReady__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationResponseList_RL_ReconfReady__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseItem-RL-ReconfReady')))
    ___RL_InformationResponseList_RL_ReconfReady__item__id_tab._val = ASN1Set(rv=[dict([('id', 218), ('criticality', 'ignore'), ('Value', ____RL_InformationResponseList_RL_ReconfReady__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationResponseList_RL_ReconfReady__item__id._const_tab = ___RL_InformationResponseList_RL_ReconfReady__item__id_tab
    __RL_InformationResponseList_RL_ReconfReady__item__id._const_tab_at = None
    __RL_InformationResponseList_RL_ReconfReady__item__id._const_tab_id = 'id'
    __RL_InformationResponseList_RL_ReconfReady__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationResponseList_RL_ReconfReady__item__criticality._const_tab = ___RL_InformationResponseList_RL_ReconfReady__item__id_tab
    __RL_InformationResponseList_RL_ReconfReady__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationResponseList_RL_ReconfReady__item__criticality._const_tab_id = 'criticality'
    __RL_InformationResponseList_RL_ReconfReady__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationResponseList_RL_ReconfReady__item__value._const_tab = ___RL_InformationResponseList_RL_ReconfReady__item__id_tab
    __RL_InformationResponseList_RL_ReconfReady__item__value._const_tab_at = ('..', 'id')
    __RL_InformationResponseList_RL_ReconfReady__item__value._const_tab_id = 'Value'
    _RL_InformationResponseList_RL_ReconfReady__item_._cont = ASN1Dict([
        ('id', __RL_InformationResponseList_RL_ReconfReady__item__id),
        ('criticality', __RL_InformationResponseList_RL_ReconfReady__item__criticality),
        ('value', __RL_InformationResponseList_RL_ReconfReady__item__value),
        ])
    _RL_InformationResponseList_RL_ReconfReady__item_._ext = None
    RL_InformationResponseList_RL_ReconfReady._cont = _RL_InformationResponseList_RL_ReconfReady__item_
    RL_InformationResponseList_RL_ReconfReady._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationResponseItemIE-RL-ReconfReady >-----#
    RL_InformationResponseItemIE_RL_ReconfReady = CLASS(name='RL-InformationResponseItemIE-RL-ReconfReady', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationResponseItemIE_RL_ReconfReady_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseItem-RL-ReconfReady')))
    RL_InformationResponseItemIE_RL_ReconfReady._val = ASN1Set(rv=[dict([('id', 218), ('criticality', 'ignore'), ('Value', _RL_InformationResponseItemIE_RL_ReconfReady_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationResponseItem-RL-ReconfReady >-----#
    RL_InformationResponseItem_RL_ReconfReady = SEQ(name='RL-InformationResponseItem-RL-ReconfReady', mode=MODE_TYPE)
    _RL_InformationResponseItem_RL_ReconfReady_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationResponseItem_RL_ReconfReady_dCH_InformationResponseList_RL_ReconfReady = SEQ(name='dCH-InformationResponseList-RL-ReconfReady', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-InformationResponseList-RL-ReconfReady')), opt=True)
    _RL_InformationResponseItem_RL_ReconfReady_dSCH_InformationResponseList_RL_ReconfReady = SEQ(name='dSCH-InformationResponseList-RL-ReconfReady', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-InformationResponseList-RL-ReconfReady')), opt=True)
    _RL_InformationResponseItem_RL_ReconfReady_uSCH_InformationResponseList_RL_ReconfReady = SEQ(name='uSCH-InformationResponseList-RL-ReconfReady', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-InformationResponseList-RL-ReconfReady')), opt=True)
    _RL_InformationResponseItem_RL_ReconfReady_not_Used_tFCI2_BearerInformationResponse = NULL(name='not-Used-tFCI2-BearerInformationResponse', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationResponseItem_RL_ReconfReady_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-UpdatedIndicator')))
    _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    ____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 668), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id._const_tab = ____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id),
        ('criticality', ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item_._ext = None
    _RL_InformationResponseItem_RL_ReconfReady_iE_Extensions._cont = __RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item_
    _RL_InformationResponseItem_RL_ReconfReady_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponseItem_RL_ReconfReady._cont = ASN1Dict([
        ('rL-ID', _RL_InformationResponseItem_RL_ReconfReady_rL_ID),
        ('dCH-InformationResponseList-RL-ReconfReady', _RL_InformationResponseItem_RL_ReconfReady_dCH_InformationResponseList_RL_ReconfReady),
        ('dSCH-InformationResponseList-RL-ReconfReady', _RL_InformationResponseItem_RL_ReconfReady_dSCH_InformationResponseList_RL_ReconfReady),
        ('uSCH-InformationResponseList-RL-ReconfReady', _RL_InformationResponseItem_RL_ReconfReady_uSCH_InformationResponseList_RL_ReconfReady),
        ('not-Used-tFCI2-BearerInformationResponse', _RL_InformationResponseItem_RL_ReconfReady_not_Used_tFCI2_BearerInformationResponse),
        ('iE-Extensions', _RL_InformationResponseItem_RL_ReconfReady_iE_Extensions),
        ])
    RL_InformationResponseItem_RL_ReconfReady._ext = []
    
    #-----< RL-InformationResponseItem-RL-ReconfReady-ExtIEs >-----#
    RL_InformationResponseItem_RL_ReconfReady_ExtIEs = CLASS(name='RL-InformationResponseItem-RL-ReconfReady-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-UpdatedIndicator')))
    _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    RL_InformationResponseItem_RL_ReconfReady_ExtIEs._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 668), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-InformationResponseList-RL-ReconfReady >-----#
    DCH_InformationResponseList_RL_ReconfReady = SEQ(name='DCH-InformationResponseList-RL-ReconfReady', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DCH_InformationResponseList_RL_ReconfReady_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DCH_InformationResponseList_RL_ReconfReady_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DCH_InformationResponseList_RL_ReconfReady_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponse')))
    __DCH_InformationResponseList_RL_ReconfReady_id_tab._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'ignore'), ('Value', ___DCH_InformationResponseList_RL_ReconfReady_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DCH_InformationResponseList_RL_ReconfReady_id._const_tab = __DCH_InformationResponseList_RL_ReconfReady_id_tab
    _DCH_InformationResponseList_RL_ReconfReady_id._const_tab_at = None
    _DCH_InformationResponseList_RL_ReconfReady_id._const_tab_id = 'id'
    _DCH_InformationResponseList_RL_ReconfReady_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DCH_InformationResponseList_RL_ReconfReady_criticality._const_tab = __DCH_InformationResponseList_RL_ReconfReady_id_tab
    _DCH_InformationResponseList_RL_ReconfReady_criticality._const_tab_at = ('..', 'id')
    _DCH_InformationResponseList_RL_ReconfReady_criticality._const_tab_id = 'criticality'
    _DCH_InformationResponseList_RL_ReconfReady_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DCH_InformationResponseList_RL_ReconfReady_value._const_tab = __DCH_InformationResponseList_RL_ReconfReady_id_tab
    _DCH_InformationResponseList_RL_ReconfReady_value._const_tab_at = ('..', 'id')
    _DCH_InformationResponseList_RL_ReconfReady_value._const_tab_id = 'Value'
    DCH_InformationResponseList_RL_ReconfReady._cont = ASN1Dict([
        ('id', _DCH_InformationResponseList_RL_ReconfReady_id),
        ('criticality', _DCH_InformationResponseList_RL_ReconfReady_criticality),
        ('value', _DCH_InformationResponseList_RL_ReconfReady_value),
        ])
    DCH_InformationResponseList_RL_ReconfReady._ext = None
    
    #-----< DCH-InformationResponseListIEs-RL-ReconfReady >-----#
    DCH_InformationResponseListIEs_RL_ReconfReady = CLASS(name='DCH-InformationResponseListIEs-RL-ReconfReady', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DCH_InformationResponseListIEs_RL_ReconfReady_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponse')))
    DCH_InformationResponseListIEs_RL_ReconfReady._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'ignore'), ('Value', _DCH_InformationResponseListIEs_RL_ReconfReady_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DSCH-InformationResponseList-RL-ReconfReady >-----#
    DSCH_InformationResponseList_RL_ReconfReady = SEQ(name='DSCH-InformationResponseList-RL-ReconfReady', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DSCH_InformationResponseList_RL_ReconfReady_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DSCH_InformationResponseList_RL_ReconfReady_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DSCH_InformationResponseList_RL_ReconfReady_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-InformationResponse')))
    __DSCH_InformationResponseList_RL_ReconfReady_id_tab._val = ASN1Set(rv=[dict([('id', 105), ('criticality', 'ignore'), ('Value', ___DSCH_InformationResponseList_RL_ReconfReady_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DSCH_InformationResponseList_RL_ReconfReady_id._const_tab = __DSCH_InformationResponseList_RL_ReconfReady_id_tab
    _DSCH_InformationResponseList_RL_ReconfReady_id._const_tab_at = None
    _DSCH_InformationResponseList_RL_ReconfReady_id._const_tab_id = 'id'
    _DSCH_InformationResponseList_RL_ReconfReady_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DSCH_InformationResponseList_RL_ReconfReady_criticality._const_tab = __DSCH_InformationResponseList_RL_ReconfReady_id_tab
    _DSCH_InformationResponseList_RL_ReconfReady_criticality._const_tab_at = ('..', 'id')
    _DSCH_InformationResponseList_RL_ReconfReady_criticality._const_tab_id = 'criticality'
    _DSCH_InformationResponseList_RL_ReconfReady_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DSCH_InformationResponseList_RL_ReconfReady_value._const_tab = __DSCH_InformationResponseList_RL_ReconfReady_id_tab
    _DSCH_InformationResponseList_RL_ReconfReady_value._const_tab_at = ('..', 'id')
    _DSCH_InformationResponseList_RL_ReconfReady_value._const_tab_id = 'Value'
    DSCH_InformationResponseList_RL_ReconfReady._cont = ASN1Dict([
        ('id', _DSCH_InformationResponseList_RL_ReconfReady_id),
        ('criticality', _DSCH_InformationResponseList_RL_ReconfReady_criticality),
        ('value', _DSCH_InformationResponseList_RL_ReconfReady_value),
        ])
    DSCH_InformationResponseList_RL_ReconfReady._ext = None
    
    #-----< DSCH-InformationResponseListIEs-RL-ReconfReady >-----#
    DSCH_InformationResponseListIEs_RL_ReconfReady = CLASS(name='DSCH-InformationResponseListIEs-RL-ReconfReady', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DSCH_InformationResponseListIEs_RL_ReconfReady_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DSCH-InformationResponse')))
    DSCH_InformationResponseListIEs_RL_ReconfReady._val = ASN1Set(rv=[dict([('id', 105), ('criticality', 'ignore'), ('Value', _DSCH_InformationResponseListIEs_RL_ReconfReady_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< USCH-InformationResponseList-RL-ReconfReady >-----#
    USCH_InformationResponseList_RL_ReconfReady = SEQ(name='USCH-InformationResponseList-RL-ReconfReady', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _USCH_InformationResponseList_RL_ReconfReady_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __USCH_InformationResponseList_RL_ReconfReady_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___USCH_InformationResponseList_RL_ReconfReady_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-InformationResponse')))
    __USCH_InformationResponseList_RL_ReconfReady_id_tab._val = ASN1Set(rv=[dict([('id', 309), ('criticality', 'ignore'), ('Value', ___USCH_InformationResponseList_RL_ReconfReady_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _USCH_InformationResponseList_RL_ReconfReady_id._const_tab = __USCH_InformationResponseList_RL_ReconfReady_id_tab
    _USCH_InformationResponseList_RL_ReconfReady_id._const_tab_at = None
    _USCH_InformationResponseList_RL_ReconfReady_id._const_tab_id = 'id'
    _USCH_InformationResponseList_RL_ReconfReady_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _USCH_InformationResponseList_RL_ReconfReady_criticality._const_tab = __USCH_InformationResponseList_RL_ReconfReady_id_tab
    _USCH_InformationResponseList_RL_ReconfReady_criticality._const_tab_at = ('..', 'id')
    _USCH_InformationResponseList_RL_ReconfReady_criticality._const_tab_id = 'criticality'
    _USCH_InformationResponseList_RL_ReconfReady_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _USCH_InformationResponseList_RL_ReconfReady_value._const_tab = __USCH_InformationResponseList_RL_ReconfReady_id_tab
    _USCH_InformationResponseList_RL_ReconfReady_value._const_tab_at = ('..', 'id')
    _USCH_InformationResponseList_RL_ReconfReady_value._const_tab_id = 'Value'
    USCH_InformationResponseList_RL_ReconfReady._cont = ASN1Dict([
        ('id', _USCH_InformationResponseList_RL_ReconfReady_id),
        ('criticality', _USCH_InformationResponseList_RL_ReconfReady_criticality),
        ('value', _USCH_InformationResponseList_RL_ReconfReady_value),
        ])
    USCH_InformationResponseList_RL_ReconfReady._ext = None
    
    #-----< USCH-InformationResponseListIEs-RL-ReconfReady >-----#
    USCH_InformationResponseListIEs_RL_ReconfReady = CLASS(name='USCH-InformationResponseListIEs-RL-ReconfReady', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _USCH_InformationResponseListIEs_RL_ReconfReady_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'USCH-InformationResponse')))
    USCH_InformationResponseListIEs_RL_ReconfReady._val = ASN1Set(rv=[dict([('id', 309), ('criticality', 'ignore'), ('Value', _USCH_InformationResponseListIEs_RL_ReconfReady_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RadioLinkReconfigurationFailure >-----#
    RadioLinkReconfigurationFailure = SEQ(name='RadioLinkReconfigurationFailure', mode=MODE_TYPE)
    _RadioLinkReconfigurationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-RL-ReconfFailure')))
    _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 327), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationFailure_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkReconfigurationFailure_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkReconfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationFailure_protocolIEs__item__id),
        ('criticality', ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality),
        ('value', ___RadioLinkReconfigurationFailure_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationFailure_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationFailure_protocolIEs._cont = __RadioLinkReconfigurationFailure_protocolIEs__item_
    _RadioLinkReconfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationFailure_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationFailure_protocolExtensions__item__criticality_tab
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue_tab
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkReconfigurationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationFailure_protocolExtensions__item__id),
        ('criticality', ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationFailure_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationFailure_protocolExtensions._cont = __RadioLinkReconfigurationFailure_protocolExtensions__item_
    _RadioLinkReconfigurationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationFailure._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkReconfigurationFailure_protocolIEs),
        ('protocolExtensions', _RadioLinkReconfigurationFailure_protocolExtensions),
        ])
    RadioLinkReconfigurationFailure._ext = []
    
    #-----< RadioLinkReconfigurationFailure-IEs >-----#
    RadioLinkReconfigurationFailure_IEs = CLASS(name='RadioLinkReconfigurationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkReconfigurationFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-RL-ReconfFailure')))
    _RadioLinkReconfigurationFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkReconfigurationFailure_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 327), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationFailure_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationFailure-Extensions >-----#
    RadioLinkReconfigurationFailure_Extensions = CLASS(name='RadioLinkReconfigurationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkReconfigurationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-RL-ReconfFailure >-----#
    CauseLevel_RL_ReconfFailure = CHOICE(name='CauseLevel-RL-ReconfFailure', mode=MODE_TYPE)
    _CauseLevel_RL_ReconfFailure_generalCause = SEQ(name='generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'GeneralCauseList-RL-ReconfFailure')))
    _CauseLevel_RL_ReconfFailure_rLSpecificCause = SEQ(name='rLSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RLSpecificCauseList-RL-ReconfFailure')))
    CauseLevel_RL_ReconfFailure._cont = ASN1Dict([
        ('generalCause', _CauseLevel_RL_ReconfFailure_generalCause),
        ('rLSpecificCause', _CauseLevel_RL_ReconfFailure_rLSpecificCause),
        ])
    CauseLevel_RL_ReconfFailure._ext = []
    
    #-----< GeneralCauseList-RL-ReconfFailure >-----#
    GeneralCauseList_RL_ReconfFailure = SEQ(name='GeneralCauseList-RL-ReconfFailure', mode=MODE_TYPE)
    _GeneralCauseList_RL_ReconfFailure_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _GeneralCauseList_RL_ReconfFailure_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_RL_ReconfFailure_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab = ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeneralCauseList_RL_ReconfFailure_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id),
        ('criticality', ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality),
        ('extensionValue', ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_RL_ReconfFailure_iE_Extensions__item_._ext = None
    _GeneralCauseList_RL_ReconfFailure_iE_Extensions._cont = __GeneralCauseList_RL_ReconfFailure_iE_Extensions__item_
    _GeneralCauseList_RL_ReconfFailure_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_RL_ReconfFailure._cont = ASN1Dict([
        ('cause', _GeneralCauseList_RL_ReconfFailure_cause),
        ('iE-Extensions', _GeneralCauseList_RL_ReconfFailure_iE_Extensions),
        ])
    GeneralCauseList_RL_ReconfFailure._ext = []
    
    #-----< GeneralCauseItem-RL-ReconfFailure-ExtIEs >-----#
    GeneralCauseItem_RL_ReconfFailure_ExtIEs = CLASS(name='GeneralCauseItem-RL-ReconfFailure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GeneralCauseItem_RL_ReconfFailure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLSpecificCauseList-RL-ReconfFailure >-----#
    RLSpecificCauseList_RL_ReconfFailure = SEQ(name='RLSpecificCauseList-RL-ReconfFailure', mode=MODE_TYPE)
    _RLSpecificCauseList_RL_ReconfFailure_rL_ReconfigurationFailureList_RL_ReconfFailure = SEQ_OF(name='rL-ReconfigurationFailureList-RL-ReconfFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-ReconfigurationFailureList-RL-ReconfFailure')), opt=True)
    _RLSpecificCauseList_RL_ReconfFailure_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab = ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab_at = None
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab = ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab = ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id),
        ('criticality', ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality),
        ('extensionValue', ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue),
        ])
    __RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item_._ext = None
    _RLSpecificCauseList_RL_ReconfFailure_iE_Extensions._cont = __RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item_
    _RLSpecificCauseList_RL_ReconfFailure_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLSpecificCauseList_RL_ReconfFailure._cont = ASN1Dict([
        ('rL-ReconfigurationFailureList-RL-ReconfFailure', _RLSpecificCauseList_RL_ReconfFailure_rL_ReconfigurationFailureList_RL_ReconfFailure),
        ('iE-Extensions', _RLSpecificCauseList_RL_ReconfFailure_iE_Extensions),
        ])
    RLSpecificCauseList_RL_ReconfFailure._ext = []
    
    #-----< RLSpecificCauseItem-RL-ReconfFailure-ExtIEs >-----#
    RLSpecificCauseItem_RL_ReconfFailure_ExtIEs = CLASS(name='RLSpecificCauseItem-RL-ReconfFailure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RLSpecificCauseItem_RL_ReconfFailure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-ReconfigurationFailureList-RL-ReconfFailure >-----#
    RL_ReconfigurationFailureList_RL_ReconfFailure = SEQ_OF(name='RL-ReconfigurationFailureList-RL-ReconfFailure', mode=MODE_TYPE)
    _RL_ReconfigurationFailureList_RL_ReconfFailure__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-ReconfigurationFailureItem-RL-ReconfFailure')))
    ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab._val = ASN1Set(rv=[dict([('id', 236), ('criticality', 'ignore'), ('Value', ____RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id._const_tab = ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id._const_tab_at = None
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id._const_tab_id = 'id'
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality._const_tab = ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality._const_tab_at = ('..', 'id')
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality._const_tab_id = 'criticality'
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value._const_tab = ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value._const_tab_at = ('..', 'id')
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value._const_tab_id = 'Value'
    _RL_ReconfigurationFailureList_RL_ReconfFailure__item_._cont = ASN1Dict([
        ('id', __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id),
        ('criticality', __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality),
        ('value', __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value),
        ])
    _RL_ReconfigurationFailureList_RL_ReconfFailure__item_._ext = None
    RL_ReconfigurationFailureList_RL_ReconfFailure._cont = _RL_ReconfigurationFailureList_RL_ReconfFailure__item_
    RL_ReconfigurationFailureList_RL_ReconfFailure._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-ReconfigurationFailureItemIE-RL-ReconfFailure >-----#
    RL_ReconfigurationFailureItemIE_RL_ReconfFailure = CLASS(name='RL-ReconfigurationFailureItemIE-RL-ReconfFailure', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_ReconfigurationFailureItemIE_RL_ReconfFailure_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-ReconfigurationFailureItem-RL-ReconfFailure')))
    RL_ReconfigurationFailureItemIE_RL_ReconfFailure._val = ASN1Set(rv=[dict([('id', 236), ('criticality', 'ignore'), ('Value', _RL_ReconfigurationFailureItemIE_RL_ReconfFailure_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-ReconfigurationFailureItem-RL-ReconfFailure >-----#
    RL_ReconfigurationFailureItem_RL_ReconfFailure = SEQ(name='RL-ReconfigurationFailureItem-RL-ReconfFailure', mode=MODE_TYPE)
    _RL_ReconfigurationFailureItem_RL_ReconfFailure_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_ReconfigurationFailureItem_RL_ReconfFailure_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__id._const_tab = ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__id_tab
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__id._const_tab_at = None
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab = ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__criticality_tab
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab = ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__id),
        ('criticality', ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__extensionValue),
        ])
    __RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item_._ext = None
    _RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions._cont = __RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item_
    _RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_ReconfigurationFailureItem_RL_ReconfFailure._cont = ASN1Dict([
        ('rL-ID', _RL_ReconfigurationFailureItem_RL_ReconfFailure_rL_ID),
        ('cause', _RL_ReconfigurationFailureItem_RL_ReconfFailure_cause),
        ('iE-Extensions', _RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions),
        ])
    RL_ReconfigurationFailureItem_RL_ReconfFailure._ext = []
    
    #-----< RL-ReconfigurationFailureItem-RL-ReconfFailure-ExtIEs >-----#
    RL_ReconfigurationFailureItem_RL_ReconfFailure_ExtIEs = CLASS(name='RL-ReconfigurationFailureItem-RL-ReconfFailure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_ReconfigurationFailureItem_RL_ReconfFailure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationCommit >-----#
    RadioLinkReconfigurationCommit = SEQ(name='RadioLinkReconfigurationCommit', mode=MODE_TYPE)
    _RadioLinkReconfigurationCommit_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationCommit_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationCommit_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Active-Pattern-Sequence-Information')))
    ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 315), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCommit_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationCommit_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationCommit_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkReconfigurationCommit_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationCommit_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkReconfigurationCommit_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationCommit_protocolIEs__item__id),
        ('criticality', ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality),
        ('value', ___RadioLinkReconfigurationCommit_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationCommit_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationCommit_protocolIEs._cont = __RadioLinkReconfigurationCommit_protocolIEs__item_
    _RadioLinkReconfigurationCommit_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationCommit_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationCommit_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-Reconfiguration-Mode')))
    _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ActivationDelay')))
    ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 827), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1301), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkReconfigurationCommit_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationCommit_protocolExtensions__item__id),
        ('criticality', ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationCommit_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationCommit_protocolExtensions._cont = __RadioLinkReconfigurationCommit_protocolExtensions__item_
    _RadioLinkReconfigurationCommit_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationCommit._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkReconfigurationCommit_protocolIEs),
        ('protocolExtensions', _RadioLinkReconfigurationCommit_protocolExtensions),
        ])
    RadioLinkReconfigurationCommit._ext = []
    
    #-----< RadioLinkReconfigurationCommit-IEs >-----#
    RadioLinkReconfigurationCommit_IEs = CLASS(name='RadioLinkReconfigurationCommit-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationCommit_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkReconfigurationCommit_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    _RadioLinkReconfigurationCommit_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Active-Pattern-Sequence-Information')))
    RadioLinkReconfigurationCommit_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationCommit_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationCommit_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 315), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationCommit_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationCommit-Extensions >-----#
    RadioLinkReconfigurationCommit_Extensions = CLASS(name='RadioLinkReconfigurationCommit-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationCommit_Extensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Fast-Reconfiguration-Mode')))
    _RadioLinkReconfigurationCommit_Extensions_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ActivationDelay')))
    RadioLinkReconfigurationCommit_Extensions._val = ASN1Set(rv=[dict([('id', 827), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationCommit_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 1301), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationCommit_Extensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationCancel >-----#
    RadioLinkReconfigurationCancel = SEQ(name='RadioLinkReconfigurationCancel', mode=MODE_TYPE)
    _RadioLinkReconfigurationCancel_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationCancel_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    ____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCancel_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationCancel_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationCancel_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationCancel_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkReconfigurationCancel_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationCancel_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationCancel_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkReconfigurationCancel_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationCancel_protocolIEs__item__id),
        ('criticality', ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality),
        ('value', ___RadioLinkReconfigurationCancel_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationCancel_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationCancel_protocolIEs._cont = __RadioLinkReconfigurationCancel_protocolIEs__item_
    _RadioLinkReconfigurationCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationCancel_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationCancel_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationCancel_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationCancel_protocolExtensions__item__criticality_tab
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue_tab
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkReconfigurationCancel_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationCancel_protocolExtensions__item__id),
        ('criticality', ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationCancel_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationCancel_protocolExtensions._cont = __RadioLinkReconfigurationCancel_protocolExtensions__item_
    _RadioLinkReconfigurationCancel_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationCancel._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkReconfigurationCancel_protocolIEs),
        ('protocolExtensions', _RadioLinkReconfigurationCancel_protocolExtensions),
        ])
    RadioLinkReconfigurationCancel._ext = []
    
    #-----< RadioLinkReconfigurationCancel-IEs >-----#
    RadioLinkReconfigurationCancel_IEs = CLASS(name='RadioLinkReconfigurationCancel-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationCancel_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    RadioLinkReconfigurationCancel_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationCancel_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationCancel-Extensions >-----#
    RadioLinkReconfigurationCancel_Extensions = CLASS(name='RadioLinkReconfigurationCancel-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkReconfigurationCancel_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationRequestFDD >-----#
    RadioLinkReconfigurationRequestFDD = SEQ(name='RadioLinkReconfigurationRequestFDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationRequestFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-Information-RL-ReconfRqstFDD')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-Information-RL-ReconfRqstFDD')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FDD-DCHs-to-Modify')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-FDD-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfRqstFDD')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-ReconfRqstFDD')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 294), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 62), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkReconfigurationRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationRequestFDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationRequestFDD_protocolIEs._cont = __RadioLinkReconfigurationRequestFDD_protocolIEs__item_
    _RadioLinkReconfigurationRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationRequestFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SignallingBearerRequestIndicator')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Information-to-Modify-Unsynchronised')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DPCH-Information-RL-ReconfRqstFDD')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-to-Modify')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-to-Delete')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_12 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Serving-E-DCH-RL-ID')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CPC-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_14 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NoOfTargetCellHS-SCCH-Order')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Req')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_16 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Reconf-Req')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_18 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information-Reconf')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Decoupling-Indication')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_20 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_21 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH2-Information-Reconf')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_22 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Downlink-TPC-enhancements-Reconf')))
    ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 530), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 615), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 613), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 614), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 682), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 667), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 669), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 670), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 671), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 679), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 836), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 1035), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 1042), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 1092), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 1125), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_17), ('presence', 'optional')]), dict([('id', 1209), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 1295), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_19), ('presence', 'optional')]), dict([('id', 1296), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_20), ('presence', 'optional')]), dict([('id', 1298), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_21), ('presence', 'optional')]), dict([('id', 1308), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_22), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkReconfigurationRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationRequestFDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationRequestFDD_protocolExtensions._cont = __RadioLinkReconfigurationRequestFDD_protocolExtensions__item_
    _RadioLinkReconfigurationRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationRequestFDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkReconfigurationRequestFDD_protocolIEs),
        ('protocolExtensions', _RadioLinkReconfigurationRequestFDD_protocolExtensions),
        ])
    RadioLinkReconfigurationRequestFDD._ext = []
    
    #-----< RadioLinkReconfigurationRequestFDD-IEs >-----#
    RadioLinkReconfigurationRequestFDD_IEs = CLASS(name='RadioLinkReconfigurationRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-DPCH-Information-RL-ReconfRqstFDD')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-Information-RL-ReconfRqstFDD')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FDD-DCHs-to-Modify')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-FDD-Information')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfRqstFDD')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-ReconfRqstFDD')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    RadioLinkReconfigurationRequestFDD_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 294), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 62), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationRequestFDD-Extensions >-----#
    RadioLinkReconfigurationRequestFDD_Extensions = CLASS(name='RadioLinkReconfigurationRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SignallingBearerRequestIndicator')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Information-to-Modify-Unsynchronised')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DPCH-Information-RL-ReconfRqstFDD')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-to-Modify')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-Information')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_11 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-to-Delete')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_12 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Serving-E-DCH-RL-ID')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CPC-Information')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_14 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NoOfTargetCellHS-SCCH-Order')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_15 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Req')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_16 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Reconf-Req')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_18 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-Information-Reconf')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_19 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Decoupling-Indication')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_20 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_21 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPCCH2-Information-Reconf')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_22 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Downlink-TPC-enhancements-Reconf')))
    RadioLinkReconfigurationRequestFDD_Extensions._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 530), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 615), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 613), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 614), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_5), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 682), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 667), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 669), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 670), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 671), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 679), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 836), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 1035), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 1042), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_15), ('presence', 'optional')]), dict([('id', 1092), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_16), ('presence', 'optional')]), dict([('id', 1125), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_17), ('presence', 'optional')]), dict([('id', 1209), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_18), ('presence', 'optional')]), dict([('id', 1295), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_19), ('presence', 'optional')]), dict([('id', 1296), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_20), ('presence', 'optional')]), dict([('id', 1298), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_21), ('presence', 'optional')]), dict([('id', 1308), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_22), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Req >-----#
    Additional_HS_Cell_Information_RL_Reconf_Req = SEQ_OF(name='Additional-HS-Cell-Information-RL-Reconf-Req', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Reconf_Req__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Req-ItemIEs')))
    Additional_HS_Cell_Information_RL_Reconf_Req._cont = _Additional_HS_Cell_Information_RL_Reconf_Req__item_
    Additional_HS_Cell_Information_RL_Reconf_Req._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Req-ItemIEs >-----#
    Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs = SEQ(name='Additional-HS-Cell-Information-RL-Reconf-Req-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hSPDSCH_RL_ID = INT(name='hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information = SEQ(name='hS-DSCH-FDD-Secondary-Serving-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised = SEQ(name='hS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_Secondary_Serving_Remove = NULL(name='hS-DSCH-Secondary-Serving-Remove', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Secondary-Serving-Remove')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs._cont = ASN1Dict([
        ('hSPDSCH-RL-ID', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hSPDSCH_RL_ID),
        ('c-ID', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_c_ID),
        ('hS-DSCH-FDD-Secondary-Serving-Information', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information),
        ('hS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised),
        ('hS-DSCH-Secondary-Serving-Remove', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_Secondary_Serving_Remove),
        ('iE-Extensions', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Req-ExtIEs >-----#
    Additional_HS_Cell_Information_RL_Reconf_Req_ExtIEs = CLASS(name='Additional-HS-Cell-Information-RL-Reconf-Req-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_RL_Reconf_Req_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-RL-Reconf-Req >-----#
    Additional_EDCH_Cell_Information_RL_Reconf_Req = SEQ(name='Additional-EDCH-Cell-Information-RL-Reconf-Req', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_RL_Reconf_Req_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency = CHOICE(name='setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency')))
    _Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions._cont = __Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_RL_Reconf_Req._cont = ASN1Dict([
        ('setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency', _Additional_EDCH_Cell_Information_RL_Reconf_Req_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency),
        ('iE-Extensions', _Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_RL_Reconf_Req._ext = []
    
    #-----< Additional-EDCH-Cell-Information-RL-Reconf-Req-ExtIEs >-----#
    Additional_EDCH_Cell_Information_RL_Reconf_Req_ExtIEs = CLASS(name='Additional-EDCH-Cell-Information-RL-Reconf-Req-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_RL_Reconf_Req_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-Information-RL-ReconfRqstFDD >-----#
    UL_DPCH_Information_RL_ReconfRqstFDD = SEQ(name='UL-DPCH-Information-RL-ReconfRqstFDD', mode=MODE_TYPE)
    _UL_DPCH_Information_RL_ReconfRqstFDD_ul_TFCS = SEQ(name='ul-TFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')), opt=True)
    _UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPDCH-Indicator-For-E-DCH-Operation')))
    ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 680), ('criticality', 'reject'), ('Extension', _____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions._cont = __UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_
    _UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_Information_RL_ReconfRqstFDD._cont = ASN1Dict([
        ('ul-TFCS', _UL_DPCH_Information_RL_ReconfRqstFDD_ul_TFCS),
        ('iE-Extensions', _UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions),
        ])
    UL_DPCH_Information_RL_ReconfRqstFDD._ext = []
    
    #-----< UL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs >-----#
    UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs = CLASS(name='UL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-DPDCH-Indicator-For-E-DCH-Operation')))
    UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 680), ('criticality', 'reject'), ('Extension', _UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-Information-RL-ReconfRqstFDD >-----#
    DL_DPCH_Information_RL_ReconfRqstFDD = SEQ(name='DL-DPCH-Information-RL-ReconfRqstFDD', mode=MODE_TYPE)
    _DL_DPCH_Information_RL_ReconfRqstFDD_dl_TFCS = SEQ(name='dl-TFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')), opt=True)
    _DL_DPCH_Information_RL_ReconfRqstFDD_tFCI_SignallingMode = SEQ(name='tFCI-SignallingMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-SignallingMode')), opt=True)
    _DL_DPCH_Information_RL_ReconfRqstFDD_limitedPowerIncrease = ENUM(name='limitedPowerIncrease', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LimitedPowerIncrease')), opt=True)
    _DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions._cont = __DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_
    _DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_Information_RL_ReconfRqstFDD._cont = ASN1Dict([
        ('dl-TFCS', _DL_DPCH_Information_RL_ReconfRqstFDD_dl_TFCS),
        ('tFCI-SignallingMode', _DL_DPCH_Information_RL_ReconfRqstFDD_tFCI_SignallingMode),
        ('limitedPowerIncrease', _DL_DPCH_Information_RL_ReconfRqstFDD_limitedPowerIncrease),
        ('iE-Extensions', _DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions),
        ])
    DL_DPCH_Information_RL_ReconfRqstFDD._ext = []
    
    #-----< DL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs >-----#
    DL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs = CLASS(name='DL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-DeleteList-RL-ReconfRqstFDD >-----#
    DCH_DeleteList_RL_ReconfRqstFDD = SEQ_OF(name='DCH-DeleteList-RL-ReconfRqstFDD', mode=MODE_TYPE)
    _DCH_DeleteList_RL_ReconfRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteItem-RL-ReconfRqstFDD')))
    DCH_DeleteList_RL_ReconfRqstFDD._cont = _DCH_DeleteList_RL_ReconfRqstFDD__item_
    DCH_DeleteList_RL_ReconfRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-DeleteItem-RL-ReconfRqstFDD >-----#
    DCH_DeleteItem_RL_ReconfRqstFDD = SEQ(name='DCH-DeleteItem-RL-ReconfRqstFDD', mode=MODE_TYPE)
    _DCH_DeleteItem_RL_ReconfRqstFDD_dCH_ID = INT(name='dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    _DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions._cont = __DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item_
    _DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_DeleteItem_RL_ReconfRqstFDD._cont = ASN1Dict([
        ('dCH-ID', _DCH_DeleteItem_RL_ReconfRqstFDD_dCH_ID),
        ('iE-Extensions', _DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions),
        ])
    DCH_DeleteItem_RL_ReconfRqstFDD._ext = []
    
    #-----< DCH-DeleteItem-RL-ReconfRqstFDD-ExtIEs >-----#
    DCH_DeleteItem_RL_ReconfRqstFDD_ExtIEs = CLASS(name='DCH-DeleteItem-RL-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DCH_DeleteItem_RL_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-ReconfRqstFDD >-----#
    RL_InformationList_RL_ReconfRqstFDD = SEQ_OF(name='RL-InformationList-RL-ReconfRqstFDD', mode=MODE_TYPE)
    _RL_InformationList_RL_ReconfRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_ReconfRqstFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationList_RL_ReconfRqstFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_ReconfRqstFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-ReconfRqstFDD')))
    ___RL_InformationList_RL_ReconfRqstFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 209), ('criticality', 'reject'), ('Value', ____RL_InformationList_RL_ReconfRqstFDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_ReconfRqstFDD__item__id._const_tab = ___RL_InformationList_RL_ReconfRqstFDD__item__id_tab
    __RL_InformationList_RL_ReconfRqstFDD__item__id._const_tab_at = None
    __RL_InformationList_RL_ReconfRqstFDD__item__id._const_tab_id = 'id'
    __RL_InformationList_RL_ReconfRqstFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationList_RL_ReconfRqstFDD__item__criticality._const_tab = ___RL_InformationList_RL_ReconfRqstFDD__item__id_tab
    __RL_InformationList_RL_ReconfRqstFDD__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_ReconfRqstFDD__item__criticality._const_tab_id = 'criticality'
    __RL_InformationList_RL_ReconfRqstFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationList_RL_ReconfRqstFDD__item__value._const_tab = ___RL_InformationList_RL_ReconfRqstFDD__item__id_tab
    __RL_InformationList_RL_ReconfRqstFDD__item__value._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_ReconfRqstFDD__item__value._const_tab_id = 'Value'
    _RL_InformationList_RL_ReconfRqstFDD__item_._cont = ASN1Dict([
        ('id', __RL_InformationList_RL_ReconfRqstFDD__item__id),
        ('criticality', __RL_InformationList_RL_ReconfRqstFDD__item__criticality),
        ('value', __RL_InformationList_RL_ReconfRqstFDD__item__value),
        ])
    _RL_InformationList_RL_ReconfRqstFDD__item_._ext = None
    RL_InformationList_RL_ReconfRqstFDD._cont = _RL_InformationList_RL_ReconfRqstFDD__item_
    RL_InformationList_RL_ReconfRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIE-RL-ReconfRqstFDD >-----#
    RL_InformationItemIE_RL_ReconfRqstFDD = CLASS(name='RL-InformationItemIE-RL-ReconfRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationItemIE_RL_ReconfRqstFDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-ReconfRqstFDD')))
    RL_InformationItemIE_RL_ReconfRqstFDD._val = ASN1Set(rv=[dict([('id', 209), ('criticality', 'reject'), ('Value', _RL_InformationItemIE_RL_ReconfRqstFDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-RL-ReconfRqstFDD >-----#
    RL_InformationItem_RL_ReconfRqstFDD = SEQ(name='RL-InformationItem-RL-ReconfRqstFDD', mode=MODE_TYPE)
    _RL_InformationItem_RL_ReconfRqstFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationItem_RL_ReconfRqstFDD_maxDL_Power = INT(name='maxDL-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationItem_RL_ReconfRqstFDD_minDL_Power = INT(name='minDL-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationItem_RL_ReconfRqstFDD_dl_CodeInformation = SEQ_OF(name='dl-CodeInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FDD-DL-CodeInformation')), opt=True)
    _RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RL-Indication')))
    _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-E-DCH-Info')))
    _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')))
    _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information-Reconf')))
    _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    ____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 674), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 686), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 870), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1033), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1174), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1175), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1216), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions._cont = __RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item_
    _RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_RL_ReconfRqstFDD._cont = ASN1Dict([
        ('rL-ID', _RL_InformationItem_RL_ReconfRqstFDD_rL_ID),
        ('maxDL-Power', _RL_InformationItem_RL_ReconfRqstFDD_maxDL_Power),
        ('minDL-Power', _RL_InformationItem_RL_ReconfRqstFDD_minDL_Power),
        ('dl-CodeInformation', _RL_InformationItem_RL_ReconfRqstFDD_dl_CodeInformation),
        ('iE-Extensions', _RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions),
        ])
    RL_InformationItem_RL_ReconfRqstFDD._ext = []
    
    #-----< RL-InformationItem-RL-ReconfRqstFDD-ExtIEs >-----#
    RL_InformationItem_RL_ReconfRqstFDD_ExtIEs = CLASS(name='RL-InformationItem-RL-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-RL-Indication')))
    _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-E-DCH-Info')))
    _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'F-DPCH-SlotFormat')))
    _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FTPICH-Information-Reconf')))
    _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TPC-slot-position')))
    RL_InformationItem_RL_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 674), ('criticality', 'reject'), ('Extension', _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 686), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 870), ('criticality', 'reject'), ('Extension', _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1033), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 1174), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 1175), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 1216), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 1309), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_9), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DPCH-Information-RL-ReconfRqstFDD >-----#
    E_DPCH_Information_RL_ReconfRqstFDD = SEQ(name='E-DPCH-Information-RL-ReconfRqstFDD', mode=MODE_TYPE)
    _E_DPCH_Information_RL_ReconfRqstFDD_maxSet_E_DPDCHs = ENUM(name='maxSet-E-DPDCHs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Max-Set-E-DPDCHs')), opt=True)
    _E_DPCH_Information_RL_ReconfRqstFDD_ul_PunctureLimit = INT(name='ul-PunctureLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')), opt=True)
    _E_DPCH_Information_RL_ReconfRqstFDD_e_TFCS_Information = SEQ(name='e-TFCS-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TFCS-Information')), opt=True)
    _E_DPCH_Information_RL_ReconfRqstFDD_e_TTI = ENUM(name='e-TTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-TTI')), opt=True)
    _E_DPCH_Information_RL_ReconfRqstFDD_e_DPCCH_PO = INT(name='e-DPCCH-PO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DPCCH-PO')), opt=True)
    _E_DPCH_Information_RL_ReconfRqstFDD_e_RGCH_2_IndexStepThreshold = INT(name='e-RGCH-2-IndexStepThreshold', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-2-IndexStepThreshold')), opt=True)
    _E_DPCH_Information_RL_ReconfRqstFDD_e_RGCH_3_IndexStepThreshold = INT(name='e-RGCH-3-IndexStepThreshold', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-3-IndexStepThreshold')), opt=True)
    _E_DPCH_Information_RL_ReconfRqstFDD_hARQ_Info_for_E_DCH = ENUM(name='hARQ-Info-for-E-DCH', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HARQ-Info-for-E-DCH')), opt=True)
    _E_DPCH_Information_RL_ReconfRqstFDD_hSDSCH_Configured_Indicator = ENUM(name='hSDSCH-Configured-Indicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Configured-Indicator')), opt=True)
    _E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    ____E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 999), ('criticality', 'ignore'), ('Extension', _____E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id),
        ('criticality', ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions._cont = __E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_
    _E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DPCH_Information_RL_ReconfRqstFDD._cont = ASN1Dict([
        ('maxSet-E-DPDCHs', _E_DPCH_Information_RL_ReconfRqstFDD_maxSet_E_DPDCHs),
        ('ul-PunctureLimit', _E_DPCH_Information_RL_ReconfRqstFDD_ul_PunctureLimit),
        ('e-TFCS-Information', _E_DPCH_Information_RL_ReconfRqstFDD_e_TFCS_Information),
        ('e-TTI', _E_DPCH_Information_RL_ReconfRqstFDD_e_TTI),
        ('e-DPCCH-PO', _E_DPCH_Information_RL_ReconfRqstFDD_e_DPCCH_PO),
        ('e-RGCH-2-IndexStepThreshold', _E_DPCH_Information_RL_ReconfRqstFDD_e_RGCH_2_IndexStepThreshold),
        ('e-RGCH-3-IndexStepThreshold', _E_DPCH_Information_RL_ReconfRqstFDD_e_RGCH_3_IndexStepThreshold),
        ('hARQ-Info-for-E-DCH', _E_DPCH_Information_RL_ReconfRqstFDD_hARQ_Info_for_E_DCH),
        ('hSDSCH-Configured-Indicator', _E_DPCH_Information_RL_ReconfRqstFDD_hSDSCH_Configured_Indicator),
        ('iE-Extensions', _E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions),
        ])
    E_DPCH_Information_RL_ReconfRqstFDD._ext = []
    
    #-----< E-DPCH-Information-RL-ReconfRqstFDD-ExtIEs >-----#
    E_DPCH_Information_RL_ReconfRqstFDD_ExtIEs = CLASS(name='E-DPCH-Information-RL-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DPCH_Information_RL_ReconfRqstFDD_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    E_DPCH_Information_RL_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 999), ('criticality', 'ignore'), ('Extension', _E_DPCH_Information_RL_ReconfRqstFDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationRequestTDD >-----#
    RadioLinkReconfigurationRequestTDD = SEQ(name='RadioLinkReconfigurationRequestTDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DCHs-to-Modify')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-TDD-Information')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfRqstTDD')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Information-RL-ReconfRqstTDD')))
    ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'notify'), ('Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 399), ('criticality', 'notify'), ('Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'notify'), ('Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 349), ('criticality', 'notify'), ('Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'reject'), ('Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkReconfigurationRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationRequestTDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationRequestTDD_protocolIEs._cont = __RadioLinkReconfigurationRequestTDD_protocolIEs__item_
    _RadioLinkReconfigurationRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SignallingBearerRequestIndicator')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-RL-Information-RL-ReconfRqstTDD')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Information-to-Modify-Unsynchronised')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Reconfig')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_9 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-768-Information-Reconfig')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LCR-Information-Reconfig')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_12 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CPC-InformationLCR')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IdleIntervalInformation')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_15 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Selected-MBMS-Service-Information')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_18 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_19 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Reconfigure')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_20 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-InformationLCR')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_21 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-To-ReconfigureLCR')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_22 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 629), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 536), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 615), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 613), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 614), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 801), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 809), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 814), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 848), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 941), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 1056), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 1063), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 1074), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 1154), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 1167), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_17), ('presence', 'optional')]), dict([('id', 1149), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 1188), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_19), ('presence', 'optional')]), dict([('id', 1192), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_20), ('presence', 'optional')]), dict([('id', 1194), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_21), ('presence', 'optional')]), dict([('id', 1258), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_22), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkReconfigurationRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationRequestTDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationRequestTDD_protocolExtensions._cont = __RadioLinkReconfigurationRequestTDD_protocolExtensions__item_
    _RadioLinkReconfigurationRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkReconfigurationRequestTDD_protocolIEs),
        ('protocolExtensions', _RadioLinkReconfigurationRequestTDD_protocolExtensions),
        ])
    RadioLinkReconfigurationRequestTDD._ext = []
    
    #-----< RadioLinkReconfigurationRequestTDD-IEs >-----#
    RadioLinkReconfigurationRequestTDD_IEs = CLASS(name='RadioLinkReconfigurationRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DCHs-to-Modify')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-TDD-Information')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfRqstTDD')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Information-RL-ReconfRqstTDD')))
    RadioLinkReconfigurationRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 402), ('criticality', 'notify'), ('Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 399), ('criticality', 'notify'), ('Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'notify'), ('Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 349), ('criticality', 'notify'), ('Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'reject'), ('Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationRequestTDD-Extensions >-----#
    RadioLinkReconfigurationRequestTDD_Extensions = CLASS(name='RadioLinkReconfigurationRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SignallingBearerRequestIndicator')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-RL-Information-RL-ReconfRqstTDD')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Information-to-Modify-Unsynchronised')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_7 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Reconfig')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_9 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-768-Information-Reconfig')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-LCR-Information-Reconfig')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_12 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CPC-InformationLCR')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'IdleIntervalInformation')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_15 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Selected-MBMS-Service-Information')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_17 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_18 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_19 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Reconfigure')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_20 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-InformationLCR')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_21 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-To-ReconfigureLCR')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_22 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    RadioLinkReconfigurationRequestTDD_Extensions._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 629), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 536), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 615), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 613), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 614), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 535), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_6), ('presence', 'conditional')]), dict([('id', 541), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 801), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 809), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 814), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 848), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 941), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 1056), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 1063), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 1074), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_15), ('presence', 'optional')]), dict([('id', 1154), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_16), ('presence', 'optional')]), dict([('id', 1167), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_17), ('presence', 'optional')]), dict([('id', 1149), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_18), ('presence', 'optional')]), dict([('id', 1188), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_19), ('presence', 'optional')]), dict([('id', 1192), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_20), ('presence', 'optional')]), dict([('id', 1194), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_21), ('presence', 'optional')]), dict([('id', 1258), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_22), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD >-----#
    UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = SEQ_OF(name='UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD')))
    ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 400), ('criticality', 'notify'), ('Value', ____UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab = ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab_at = None
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab_id = 'id'
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab = ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab_at = ('..', 'id')
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab_id = 'criticality'
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab = ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab_at = ('..', 'id')
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab_id = 'Value'
    _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_._cont = ASN1Dict([
        ('id', __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id),
        ('criticality', __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality),
        ('value', __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value),
        ])
    _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_._ext = None
    UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._cont = _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_
    UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationModifyItemIE-RL-ReconfRqstTDD >-----#
    UL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD = CLASS(name='UL-CCTrCH-InformationModifyItemIE-RL-ReconfRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD')))
    UL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD._val = ASN1Set(rv=[dict([('id', 400), ('criticality', 'notify'), ('Value', _UL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD >-----#
    UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD = SEQ(name='UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')), opt=True)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_punctureLimit = INT(name='punctureLimit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')), opt=True)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 510), ('criticality', 'reject'), ('Extension', _____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions._cont = __UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID),
        ('tFCS', _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS),
        ('punctureLimit', _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_punctureLimit),
        ('iE-Extensions', _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._ext = []
    
    #-----< UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs >-----#
    UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name='UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-SIR')))
    UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 510), ('criticality', 'reject'), ('Extension', _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD >-----#
    UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD = SEQ_OF(name='UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD')))
    ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 397), ('criticality', 'notify'), ('Value', ____UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab = ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab_at = None
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab_id = 'id'
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab = ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab_at = ('..', 'id')
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab_id = 'criticality'
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab = ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab_at = ('..', 'id')
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab_id = 'Value'
    _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_._cont = ASN1Dict([
        ('id', __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id),
        ('criticality', __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality),
        ('value', __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value),
        ])
    _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_._ext = None
    UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._cont = _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_
    UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationDeleteItemIE-RL-ReconfRqstTDD >-----#
    UL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD = CLASS(name='UL-CCTrCH-InformationDeleteItemIE-RL-ReconfRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD')))
    UL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD._val = ASN1Set(rv=[dict([('id', 397), ('criticality', 'notify'), ('Value', _UL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD >-----#
    UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD = SEQ(name='UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions._cont = __UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID),
        ('iE-Extensions', _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._ext = []
    
    #-----< UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs >-----#
    UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name='UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD >-----#
    DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = SEQ_OF(name='DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD')))
    ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 350), ('criticality', 'notify'), ('Value', ____DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab = ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab_at = None
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab_id = 'id'
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab = ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab_at = ('..', 'id')
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab_id = 'criticality'
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab = ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab_at = ('..', 'id')
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab_id = 'Value'
    _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_._cont = ASN1Dict([
        ('id', __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id),
        ('criticality', __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality),
        ('value', __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value),
        ])
    _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_._ext = None
    DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._cont = _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_
    DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationModifyItemIE-RL-ReconfRqstTDD >-----#
    DL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD = CLASS(name='DL-CCTrCH-InformationModifyItemIE-RL-ReconfRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD')))
    DL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD._val = ASN1Set(rv=[dict([('id', 350), ('criticality', 'notify'), ('Value', _DL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD >-----#
    DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD = SEQ(name='DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS = SEQ(name='tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCS')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_punctureLimit = INT(name='punctureLimit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PunctureLimit')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD')))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 577), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 578), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 579), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'ignore'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 692), ('criticality', 'reject'), ('Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions._cont = __DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID),
        ('tFCS', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS),
        ('punctureLimit', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_punctureLimit),
        ('iE-Extensions', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._ext = []
    
    #-----< DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs >-----#
    DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name='DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD')))
    DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 577), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 578), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 579), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 608), ('criticality', 'ignore'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 692), ('criticality', 'reject'), ('Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MultipleRL-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD >-----#
    MultipleRL_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = SEQ_OF(name='MultipleRL-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _MultipleRL_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleRL-DL-CCTrCH-InformationModifyListIE-RL-ReconfRqstTDD')))
    MultipleRL_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._cont = _MultipleRL_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_
    MultipleRL_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< MultipleRL-DL-CCTrCH-InformationModifyListIE-RL-ReconfRqstTDD >-----#
    MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD = SEQ(name='MultipleRL-DL-CCTrCH-InformationModifyListIE-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_dl_DPCH_LCR_InformationModifyList = SEQ(name='dl-DPCH-LCR-InformationModifyList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD')), opt=True)
    _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_cCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfRqstTDD = INT(name='cCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfRqstTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_cCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfRqstTDD = INT(name='cCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfRqstTDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')), opt=True)
    MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD._cont = ASN1Dict([
        ('dl-DPCH-LCR-InformationModifyList', _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_dl_DPCH_LCR_InformationModifyList),
        ('cCTrCH-Maximum-DL-Power-InformationModify-RL-ReconfRqstTDD', _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_cCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfRqstTDD),
        ('cCTrCH-Minimum-DL-Power-InformationModify-RL-ReconfRqstTDD', _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_cCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfRqstTDD),
        ('rL-ID', _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_rL_ID),
        ])
    MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD._ext = []
    
    #-----< DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD >-----#
    DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD = SEQ(name='DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_dL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD = SEQ_OF(name='dL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD')), opt=True)
    _DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions._cont = __DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item_
    _DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD._cont = ASN1Dict([
        ('dL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD', _DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_dL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD),
        ('iE-Extensions', _DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions),
        ])
    DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD._ext = []
    
    #-----< DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD-ExtIEs >-----#
    DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_ExtIEs = CLASS(name='DL-DPCH-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD >-----#
    DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD = SEQ_OF(name='DL-Timeslot-LCR-InformationModify-ModifyList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfRqstTDD')))
    DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD._cont = _DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD__item_
    DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfRqstTDD >-----#
    DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD = SEQ(name='DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_maxPowerLCR = INT(name='maxPowerLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_minPowerLCR = INT(name='minPowerLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions._cont = __DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_
    _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD._cont = ASN1Dict([
        ('timeSlotLCR', _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_timeSlotLCR),
        ('maxPowerLCR', _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_maxPowerLCR),
        ('minPowerLCR', _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_minPowerLCR),
        ('iE-Extensions', _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions),
        ])
    DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD._ext = []
    
    #-----< DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfRqstTDD-ExtIEs >-----#
    DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name='DL-Timeslot-LCR-InformationModify-ModifyItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD >-----#
    DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD = SEQ_OF(name='DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD')))
    ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 347), ('criticality', 'notify'), ('Value', ____DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab = ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab_at = None
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab_id = 'id'
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab = ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab_at = ('..', 'id')
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab_id = 'criticality'
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab = ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab_at = ('..', 'id')
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab_id = 'Value'
    _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_._cont = ASN1Dict([
        ('id', __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id),
        ('criticality', __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality),
        ('value', __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value),
        ])
    _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_._ext = None
    DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._cont = _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_
    DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationDeleteItemIE-RL-ReconfRqstTDD >-----#
    DL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD = CLASS(name='DL-CCTrCH-InformationDeleteItemIE-RL-ReconfRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD')))
    DL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD._val = ASN1Set(rv=[dict([('id', 347), ('criticality', 'notify'), ('Value', _DL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD >-----#
    DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD = SEQ(name='DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions._cont = __DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._cont = ASN1Dict([
        ('cCTrCH-ID', _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID),
        ('iE-Extensions', _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._ext = []
    
    #-----< DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs >-----#
    DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name='DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-DeleteList-RL-ReconfRqstTDD >-----#
    DCH_DeleteList_RL_ReconfRqstTDD = SEQ_OF(name='DCH-DeleteList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DCH_DeleteList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-DeleteItem-RL-ReconfRqstTDD')))
    DCH_DeleteList_RL_ReconfRqstTDD._cont = _DCH_DeleteList_RL_ReconfRqstTDD__item_
    DCH_DeleteList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-DeleteItem-RL-ReconfRqstTDD >-----#
    DCH_DeleteItem_RL_ReconfRqstTDD = SEQ(name='DCH-DeleteItem-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DCH_DeleteItem_RL_ReconfRqstTDD_dCH_ID = INT(name='dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    _DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions._cont = __DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_
    _DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_DeleteItem_RL_ReconfRqstTDD._cont = ASN1Dict([
        ('dCH-ID', _DCH_DeleteItem_RL_ReconfRqstTDD_dCH_ID),
        ('iE-Extensions', _DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions),
        ])
    DCH_DeleteItem_RL_ReconfRqstTDD._ext = []
    
    #-----< DCH-DeleteItem-RL-ReconfRqstTDD-ExtIEs >-----#
    DCH_DeleteItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name='DCH-DeleteItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DCH_DeleteItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multiple-RL-Information-RL-ReconfRqstTDD >-----#
    Multiple_RL_Information_RL_ReconfRqstTDD = SEQ_OF(name='Multiple-RL-Information-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _Multiple_RL_Information_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Information-RL-ReconfRqstTDD')))
    Multiple_RL_Information_RL_ReconfRqstTDD._cont = _Multiple_RL_Information_RL_ReconfRqstTDD__item_
    Multiple_RL_Information_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< RL-Information-RL-ReconfRqstTDD >-----#
    RL_Information_RL_ReconfRqstTDD = SEQ(name='RL-Information-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _RL_Information_RL_ReconfRqstTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_Information_RL_ReconfRqstTDD_maxDL_Power = INT(name='maxDL-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_Information_RL_ReconfRqstTDD_minDL_Power = INT(name='minDL-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _RL_Information_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    ____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 554), ('criticality', 'ignore'), ('Extension', _____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Information_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _RL_Information_RL_ReconfRqstTDD_iE_Extensions._cont = __RL_Information_RL_ReconfRqstTDD_iE_Extensions__item_
    _RL_Information_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_RL_ReconfRqstTDD._cont = ASN1Dict([
        ('rL-ID', _RL_Information_RL_ReconfRqstTDD_rL_ID),
        ('maxDL-Power', _RL_Information_RL_ReconfRqstTDD_maxDL_Power),
        ('minDL-Power', _RL_Information_RL_ReconfRqstTDD_minDL_Power),
        ('iE-Extensions', _RL_Information_RL_ReconfRqstTDD_iE_Extensions),
        ])
    RL_Information_RL_ReconfRqstTDD._ext = []
    
    #-----< RL-InformationItem-RL-ReconfRqstTDD-ExtIEs >-----#
    RL_InformationItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name='RL-InformationItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_InformationItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    RL_InformationItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 554), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationResponse >-----#
    RadioLinkReconfigurationResponse = SEQ(name='RadioLinkReconfigurationResponse', mode=MODE_TYPE)
    _RadioLinkReconfigurationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseList-RL-ReconfRsp')))
    _____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 223), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationResponse_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationResponse_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkReconfigurationResponse_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkReconfigurationResponse_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkReconfigurationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationResponse_protocolIEs__item__id),
        ('criticality', ___RadioLinkReconfigurationResponse_protocolIEs__item__criticality),
        ('value', ___RadioLinkReconfigurationResponse_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationResponse_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationResponse_protocolIEs._cont = __RadioLinkReconfigurationResponse_protocolIEs__item_
    _RadioLinkReconfigurationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Response')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAChs-ResetIndicator')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information-Response')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_10 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLReconf-List')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_11 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_12 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-Response')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_15 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    ____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 139), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 531), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 537), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 800), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 826), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 835), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 1038), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1055), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1057), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1058), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1158), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 1150), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 1189), ('criticality', 'ignore'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 1193), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 1256), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 1257), ('criticality', 'reject'), ('Extension', _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkReconfigurationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkReconfigurationResponse_protocolExtensions__item__id),
        ('criticality', ___RadioLinkReconfigurationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkReconfigurationResponse_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationResponse_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationResponse_protocolExtensions._cont = __RadioLinkReconfigurationResponse_protocolExtensions__item_
    _RadioLinkReconfigurationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationResponse._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkReconfigurationResponse_protocolIEs),
        ('protocolExtensions', _RadioLinkReconfigurationResponse_protocolExtensions),
        ])
    RadioLinkReconfigurationResponse._ext = []
    
    #-----< RadioLinkReconfigurationResponse-IEs >-----#
    RadioLinkReconfigurationResponse_IEs = CLASS(name='RadioLinkReconfigurationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkReconfigurationResponse_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseList-RL-ReconfRsp')))
    _RadioLinkReconfigurationResponse_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkReconfigurationResponse_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 223), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationResponse_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkReconfigurationResponse_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationResponse-Extensions >-----#
    RadioLinkReconfigurationResponse_Extensions = CLASS(name='RadioLinkReconfigurationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Information-Response')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MAChs-ResetIndicator')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivityHS-SCCH-less-Information-Response')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_10 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLReconf-List')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_11 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RNTI')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_12 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MU-MIMO-Information-Response')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _RadioLinkReconfigurationResponse_Extensions_val_Extension_15 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    RadioLinkReconfigurationResponse_Extensions._val = ASN1Set(rv=[dict([('id', 139), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 531), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 537), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 800), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 826), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 835), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 1038), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 1055), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 1057), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 1058), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 1158), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 1150), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 1189), ('criticality', 'ignore'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 1193), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 1256), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 1257), ('criticality', 'reject'), ('Extension', _RadioLinkReconfigurationResponse_Extensions_val_Extension_15), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponseList-RL-ReconfRsp >-----#
    RL_InformationResponseList_RL_ReconfRsp = SEQ_OF(name='RL-InformationResponseList-RL-ReconfRsp', mode=MODE_TYPE)
    _RL_InformationResponseList_RL_ReconfRsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationResponseList_RL_ReconfRsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationResponseList_RL_ReconfRsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationResponseList_RL_ReconfRsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseItem-RL-ReconfRsp')))
    ___RL_InformationResponseList_RL_ReconfRsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 219), ('criticality', 'ignore'), ('Value', ____RL_InformationResponseList_RL_ReconfRsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationResponseList_RL_ReconfRsp__item__id._const_tab = ___RL_InformationResponseList_RL_ReconfRsp__item__id_tab
    __RL_InformationResponseList_RL_ReconfRsp__item__id._const_tab_at = None
    __RL_InformationResponseList_RL_ReconfRsp__item__id._const_tab_id = 'id'
    __RL_InformationResponseList_RL_ReconfRsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationResponseList_RL_ReconfRsp__item__criticality._const_tab = ___RL_InformationResponseList_RL_ReconfRsp__item__id_tab
    __RL_InformationResponseList_RL_ReconfRsp__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationResponseList_RL_ReconfRsp__item__criticality._const_tab_id = 'criticality'
    __RL_InformationResponseList_RL_ReconfRsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationResponseList_RL_ReconfRsp__item__value._const_tab = ___RL_InformationResponseList_RL_ReconfRsp__item__id_tab
    __RL_InformationResponseList_RL_ReconfRsp__item__value._const_tab_at = ('..', 'id')
    __RL_InformationResponseList_RL_ReconfRsp__item__value._const_tab_id = 'Value'
    _RL_InformationResponseList_RL_ReconfRsp__item_._cont = ASN1Dict([
        ('id', __RL_InformationResponseList_RL_ReconfRsp__item__id),
        ('criticality', __RL_InformationResponseList_RL_ReconfRsp__item__criticality),
        ('value', __RL_InformationResponseList_RL_ReconfRsp__item__value),
        ])
    _RL_InformationResponseList_RL_ReconfRsp__item_._ext = None
    RL_InformationResponseList_RL_ReconfRsp._cont = _RL_InformationResponseList_RL_ReconfRsp__item_
    RL_InformationResponseList_RL_ReconfRsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationResponseItemIE-RL-ReconfRsp >-----#
    RL_InformationResponseItemIE_RL_ReconfRsp = CLASS(name='RL-InformationResponseItemIE-RL-ReconfRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationResponseItemIE_RL_ReconfRsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationResponseItem-RL-ReconfRsp')))
    RL_InformationResponseItemIE_RL_ReconfRsp._val = ASN1Set(rv=[dict([('id', 219), ('criticality', 'ignore'), ('Value', _RL_InformationResponseItemIE_RL_ReconfRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationResponseItem-RL-ReconfRsp >-----#
    RL_InformationResponseItem_RL_ReconfRsp = SEQ(name='RL-InformationResponseItem-RL-ReconfRsp', mode=MODE_TYPE)
    _RL_InformationResponseItem_RL_ReconfRsp_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationResponseItem_RL_ReconfRsp_dCH_InformationResponseList_RL_ReconfRsp = SEQ(name='dCH-InformationResponseList-RL-ReconfRsp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-InformationResponseList-RL-ReconfRsp')), opt=True)
    _RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-UpdatedIndicator')))
    _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    ____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 668), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id._const_tab = ____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id),
        ('criticality', ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item_._ext = None
    _RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions._cont = __RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item_
    _RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponseItem_RL_ReconfRsp._cont = ASN1Dict([
        ('rL-ID', _RL_InformationResponseItem_RL_ReconfRsp_rL_ID),
        ('dCH-InformationResponseList-RL-ReconfRsp', _RL_InformationResponseItem_RL_ReconfRsp_dCH_InformationResponseList_RL_ReconfRsp),
        ('iE-Extensions', _RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions),
        ])
    RL_InformationResponseItem_RL_ReconfRsp._ext = []
    
    #-----< RL-InformationResponseItem-RL-ReconfRsp-ExtIEs >-----#
    RL_InformationResponseItem_RL_ReconfRsp_ExtIEs = CLASS(name='RL-InformationResponseItem-RL-ReconfRsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-PowerBalancing-UpdatedIndicator')))
    _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-DL-Control-Channel-Information')))
    _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Information-Response')))
    _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    RL_InformationResponseItem_RL_ReconfRsp_ExtIEs._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 675), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 666), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 668), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 1034), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 1173), ('criticality', 'ignore'), ('Extension', _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-InformationResponseList-RL-ReconfRsp >-----#
    DCH_InformationResponseList_RL_ReconfRsp = SEQ(name='DCH-InformationResponseList-RL-ReconfRsp', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _DCH_InformationResponseList_RL_ReconfRsp_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __DCH_InformationResponseList_RL_ReconfRsp_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___DCH_InformationResponseList_RL_ReconfRsp_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponse')))
    __DCH_InformationResponseList_RL_ReconfRsp_id_tab._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'ignore'), ('Value', ___DCH_InformationResponseList_RL_ReconfRsp_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _DCH_InformationResponseList_RL_ReconfRsp_id._const_tab = __DCH_InformationResponseList_RL_ReconfRsp_id_tab
    _DCH_InformationResponseList_RL_ReconfRsp_id._const_tab_at = None
    _DCH_InformationResponseList_RL_ReconfRsp_id._const_tab_id = 'id'
    _DCH_InformationResponseList_RL_ReconfRsp_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _DCH_InformationResponseList_RL_ReconfRsp_criticality._const_tab = __DCH_InformationResponseList_RL_ReconfRsp_id_tab
    _DCH_InformationResponseList_RL_ReconfRsp_criticality._const_tab_at = ('..', 'id')
    _DCH_InformationResponseList_RL_ReconfRsp_criticality._const_tab_id = 'criticality'
    _DCH_InformationResponseList_RL_ReconfRsp_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _DCH_InformationResponseList_RL_ReconfRsp_value._const_tab = __DCH_InformationResponseList_RL_ReconfRsp_id_tab
    _DCH_InformationResponseList_RL_ReconfRsp_value._const_tab_at = ('..', 'id')
    _DCH_InformationResponseList_RL_ReconfRsp_value._const_tab_id = 'Value'
    DCH_InformationResponseList_RL_ReconfRsp._cont = ASN1Dict([
        ('id', _DCH_InformationResponseList_RL_ReconfRsp_id),
        ('criticality', _DCH_InformationResponseList_RL_ReconfRsp_criticality),
        ('value', _DCH_InformationResponseList_RL_ReconfRsp_value),
        ])
    DCH_InformationResponseList_RL_ReconfRsp._ext = None
    
    #-----< DCH-InformationResponseListIEs-RL-ReconfRsp >-----#
    DCH_InformationResponseListIEs_RL_ReconfRsp = CLASS(name='DCH-InformationResponseListIEs-RL-ReconfRsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DCH_InformationResponseListIEs_RL_ReconfRsp_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DCH-InformationResponse')))
    DCH_InformationResponseListIEs_RL_ReconfRsp._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'ignore'), ('Value', _DCH_InformationResponseListIEs_RL_ReconfRsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RadioLinkDeletionRequest >-----#
    RadioLinkDeletionRequest = SEQ(name='RadioLinkDeletionRequest', mode=MODE_TYPE)
    _RadioLinkDeletionRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkDeletionRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkDeletionRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkDeletionRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-informationList-RL-DeletionRqst')))
    ____RadioLinkDeletionRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 213), ('criticality', 'notify'), ('Value', _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkDeletionRequest_protocolIEs__item__id._const_tab = ____RadioLinkDeletionRequest_protocolIEs__item__id_tab
    ___RadioLinkDeletionRequest_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkDeletionRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkDeletionRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkDeletionRequest_protocolIEs__item__criticality._const_tab = ____RadioLinkDeletionRequest_protocolIEs__item__id_tab
    ___RadioLinkDeletionRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkDeletionRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkDeletionRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkDeletionRequest_protocolIEs__item__value._const_tab = ____RadioLinkDeletionRequest_protocolIEs__item__id_tab
    ___RadioLinkDeletionRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkDeletionRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkDeletionRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkDeletionRequest_protocolIEs__item__id),
        ('criticality', ___RadioLinkDeletionRequest_protocolIEs__item__criticality),
        ('value', ___RadioLinkDeletionRequest_protocolIEs__item__value),
        ])
    __RadioLinkDeletionRequest_protocolIEs__item_._ext = None
    _RadioLinkDeletionRequest_protocolIEs._cont = __RadioLinkDeletionRequest_protocolIEs__item_
    _RadioLinkDeletionRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkDeletionRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkDeletionRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkDeletionRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkDeletionRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionRequest_protocolExtensions__item__id._const_tab = ____RadioLinkDeletionRequest_protocolExtensions__item__id_tab
    ___RadioLinkDeletionRequest_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkDeletionRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkDeletionRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkDeletionRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionRequest_protocolExtensions__item__criticality._const_tab = ____RadioLinkDeletionRequest_protocolExtensions__item__criticality_tab
    ___RadioLinkDeletionRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkDeletionRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkDeletionRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkDeletionRequest_protocolExtensions__item__extensionValue_tab
    ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkDeletionRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkDeletionRequest_protocolExtensions__item__id),
        ('criticality', ___RadioLinkDeletionRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkDeletionRequest_protocolExtensions__item_._ext = None
    _RadioLinkDeletionRequest_protocolExtensions._cont = __RadioLinkDeletionRequest_protocolExtensions__item_
    _RadioLinkDeletionRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkDeletionRequest._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkDeletionRequest_protocolIEs),
        ('protocolExtensions', _RadioLinkDeletionRequest_protocolExtensions),
        ])
    RadioLinkDeletionRequest._ext = []
    
    #-----< RadioLinkDeletionRequest-IEs >-----#
    RadioLinkDeletionRequest_IEs = CLASS(name='RadioLinkDeletionRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkDeletionRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkDeletionRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkDeletionRequest_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-informationList-RL-DeletionRqst')))
    RadioLinkDeletionRequest_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _RadioLinkDeletionRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _RadioLinkDeletionRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 213), ('criticality', 'notify'), ('Value', _RadioLinkDeletionRequest_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkDeletionRequest-Extensions >-----#
    RadioLinkDeletionRequest_Extensions = CLASS(name='RadioLinkDeletionRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkDeletionRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-informationList-RL-DeletionRqst >-----#
    RL_informationList_RL_DeletionRqst = SEQ_OF(name='RL-informationList-RL-DeletionRqst', mode=MODE_TYPE)
    _RL_informationList_RL_DeletionRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_informationList_RL_DeletionRqst__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_informationList_RL_DeletionRqst__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_informationList_RL_DeletionRqst__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-informationItem-RL-DeletionRqst')))
    ___RL_informationList_RL_DeletionRqst__item__id_tab._val = ASN1Set(rv=[dict([('id', 206), ('criticality', 'notify'), ('Value', ____RL_informationList_RL_DeletionRqst__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_informationList_RL_DeletionRqst__item__id._const_tab = ___RL_informationList_RL_DeletionRqst__item__id_tab
    __RL_informationList_RL_DeletionRqst__item__id._const_tab_at = None
    __RL_informationList_RL_DeletionRqst__item__id._const_tab_id = 'id'
    __RL_informationList_RL_DeletionRqst__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_informationList_RL_DeletionRqst__item__criticality._const_tab = ___RL_informationList_RL_DeletionRqst__item__id_tab
    __RL_informationList_RL_DeletionRqst__item__criticality._const_tab_at = ('..', 'id')
    __RL_informationList_RL_DeletionRqst__item__criticality._const_tab_id = 'criticality'
    __RL_informationList_RL_DeletionRqst__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_informationList_RL_DeletionRqst__item__value._const_tab = ___RL_informationList_RL_DeletionRqst__item__id_tab
    __RL_informationList_RL_DeletionRqst__item__value._const_tab_at = ('..', 'id')
    __RL_informationList_RL_DeletionRqst__item__value._const_tab_id = 'Value'
    _RL_informationList_RL_DeletionRqst__item_._cont = ASN1Dict([
        ('id', __RL_informationList_RL_DeletionRqst__item__id),
        ('criticality', __RL_informationList_RL_DeletionRqst__item__criticality),
        ('value', __RL_informationList_RL_DeletionRqst__item__value),
        ])
    _RL_informationList_RL_DeletionRqst__item_._ext = None
    RL_informationList_RL_DeletionRqst._cont = _RL_informationList_RL_DeletionRqst__item_
    RL_informationList_RL_DeletionRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-informationItemIE-RL-DeletionRqst >-----#
    RL_informationItemIE_RL_DeletionRqst = CLASS(name='RL-informationItemIE-RL-DeletionRqst', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_informationItemIE_RL_DeletionRqst_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-informationItem-RL-DeletionRqst')))
    RL_informationItemIE_RL_DeletionRqst._val = ASN1Set(rv=[dict([('id', 206), ('criticality', 'notify'), ('Value', _RL_informationItemIE_RL_DeletionRqst_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-informationItem-RL-DeletionRqst >-----#
    RL_informationItem_RL_DeletionRqst = SEQ(name='RL-informationItem-RL-DeletionRqst', mode=MODE_TYPE)
    _RL_informationItem_RL_DeletionRqst_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_informationItem_RL_DeletionRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_informationItem_RL_DeletionRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__id._const_tab = ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__id_tab
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__id._const_tab_at = None
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__criticality._const_tab = ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__criticality_tab
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__extensionValue._const_tab = ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__extensionValue_tab
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_informationItem_RL_DeletionRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__id),
        ('criticality', ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__extensionValue),
        ])
    __RL_informationItem_RL_DeletionRqst_iE_Extensions__item_._ext = None
    _RL_informationItem_RL_DeletionRqst_iE_Extensions._cont = __RL_informationItem_RL_DeletionRqst_iE_Extensions__item_
    _RL_informationItem_RL_DeletionRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_informationItem_RL_DeletionRqst._cont = ASN1Dict([
        ('rL-ID', _RL_informationItem_RL_DeletionRqst_rL_ID),
        ('iE-Extensions', _RL_informationItem_RL_DeletionRqst_iE_Extensions),
        ])
    RL_informationItem_RL_DeletionRqst._ext = []
    
    #-----< RL-informationItem-RL-DeletionRqst-ExtIEs >-----#
    RL_informationItem_RL_DeletionRqst_ExtIEs = CLASS(name='RL-informationItem-RL-DeletionRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_informationItem_RL_DeletionRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkDeletionResponse >-----#
    RadioLinkDeletionResponse = SEQ(name='RadioLinkDeletionResponse', mode=MODE_TYPE)
    _RadioLinkDeletionResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkDeletionResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkDeletionResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkDeletionResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkDeletionResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkDeletionResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkDeletionResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkDeletionResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RadioLinkDeletionResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkDeletionResponse_protocolIEs__item__id._const_tab = ____RadioLinkDeletionResponse_protocolIEs__item__id_tab
    ___RadioLinkDeletionResponse_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkDeletionResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkDeletionResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkDeletionResponse_protocolIEs__item__criticality._const_tab = ____RadioLinkDeletionResponse_protocolIEs__item__id_tab
    ___RadioLinkDeletionResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkDeletionResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkDeletionResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkDeletionResponse_protocolIEs__item__value._const_tab = ____RadioLinkDeletionResponse_protocolIEs__item__id_tab
    ___RadioLinkDeletionResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkDeletionResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkDeletionResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkDeletionResponse_protocolIEs__item__id),
        ('criticality', ___RadioLinkDeletionResponse_protocolIEs__item__criticality),
        ('value', ___RadioLinkDeletionResponse_protocolIEs__item__value),
        ])
    __RadioLinkDeletionResponse_protocolIEs__item_._ext = None
    _RadioLinkDeletionResponse_protocolIEs._cont = __RadioLinkDeletionResponse_protocolIEs__item_
    _RadioLinkDeletionResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkDeletionResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkDeletionResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkDeletionResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkDeletionResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionResponse_protocolExtensions__item__id._const_tab = ____RadioLinkDeletionResponse_protocolExtensions__item__id_tab
    ___RadioLinkDeletionResponse_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkDeletionResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkDeletionResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkDeletionResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionResponse_protocolExtensions__item__criticality._const_tab = ____RadioLinkDeletionResponse_protocolExtensions__item__criticality_tab
    ___RadioLinkDeletionResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkDeletionResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkDeletionResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkDeletionResponse_protocolExtensions__item__extensionValue_tab
    ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkDeletionResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkDeletionResponse_protocolExtensions__item__id),
        ('criticality', ___RadioLinkDeletionResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkDeletionResponse_protocolExtensions__item_._ext = None
    _RadioLinkDeletionResponse_protocolExtensions._cont = __RadioLinkDeletionResponse_protocolExtensions__item_
    _RadioLinkDeletionResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkDeletionResponse._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkDeletionResponse_protocolIEs),
        ('protocolExtensions', _RadioLinkDeletionResponse_protocolExtensions),
        ])
    RadioLinkDeletionResponse._ext = []
    
    #-----< RadioLinkDeletionResponse-IEs >-----#
    RadioLinkDeletionResponse_IEs = CLASS(name='RadioLinkDeletionResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkDeletionResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkDeletionResponse_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkDeletionResponse_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkDeletionResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _RadioLinkDeletionResponse_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkDeletionResponse-Extensions >-----#
    RadioLinkDeletionResponse_Extensions = CLASS(name='RadioLinkDeletionResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkDeletionResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PowerControlRequest >-----#
    DL_PowerControlRequest = SEQ(name='DL-PowerControlRequest', mode=MODE_TYPE)
    _DL_PowerControlRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __DL_PowerControlRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___DL_PowerControlRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____DL_PowerControlRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PowerAdjustmentType')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InnerLoopDLPCStatus')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-ReferencePowerInformationList-DL-PC-Rqst')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaxAdjustmentStep')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AdjustmentPeriod')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ScaledAdjustmentRatio')))
    ____DL_PowerControlRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 169), ('criticality', 'ignore'), ('Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'conditional')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'conditional')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'conditional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'conditional')]), dict([('id', 317), ('criticality', 'ignore'), ('Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___DL_PowerControlRequest_protocolIEs__item__id._const_tab = ____DL_PowerControlRequest_protocolIEs__item__id_tab
    ___DL_PowerControlRequest_protocolIEs__item__id._const_tab_at = None
    ___DL_PowerControlRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___DL_PowerControlRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___DL_PowerControlRequest_protocolIEs__item__criticality._const_tab = ____DL_PowerControlRequest_protocolIEs__item__id_tab
    ___DL_PowerControlRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DL_PowerControlRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DL_PowerControlRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___DL_PowerControlRequest_protocolIEs__item__value._const_tab = ____DL_PowerControlRequest_protocolIEs__item__id_tab
    ___DL_PowerControlRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DL_PowerControlRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __DL_PowerControlRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DL_PowerControlRequest_protocolIEs__item__id),
        ('criticality', ___DL_PowerControlRequest_protocolIEs__item__criticality),
        ('value', ___DL_PowerControlRequest_protocolIEs__item__value),
        ])
    __DL_PowerControlRequest_protocolIEs__item_._ext = None
    _DL_PowerControlRequest_protocolIEs._cont = __DL_PowerControlRequest_protocolIEs__item_
    _DL_PowerControlRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DL_PowerControlRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_PowerControlRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_PowerControlRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_PowerControlRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_PowerControlRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerControlRequest_protocolExtensions__item__id._const_tab = ____DL_PowerControlRequest_protocolExtensions__item__id_tab
    ___DL_PowerControlRequest_protocolExtensions__item__id._const_tab_at = None
    ___DL_PowerControlRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___DL_PowerControlRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_PowerControlRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_PowerControlRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerControlRequest_protocolExtensions__item__criticality._const_tab = ____DL_PowerControlRequest_protocolExtensions__item__criticality_tab
    ___DL_PowerControlRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_PowerControlRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DL_PowerControlRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_PowerControlRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_PowerControlRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerControlRequest_protocolExtensions__item__extensionValue._const_tab = ____DL_PowerControlRequest_protocolExtensions__item__extensionValue_tab
    ___DL_PowerControlRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_PowerControlRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_PowerControlRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DL_PowerControlRequest_protocolExtensions__item__id),
        ('criticality', ___DL_PowerControlRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___DL_PowerControlRequest_protocolExtensions__item__extensionValue),
        ])
    __DL_PowerControlRequest_protocolExtensions__item_._ext = None
    _DL_PowerControlRequest_protocolExtensions._cont = __DL_PowerControlRequest_protocolExtensions__item_
    _DL_PowerControlRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_PowerControlRequest._cont = ASN1Dict([
        ('protocolIEs', _DL_PowerControlRequest_protocolIEs),
        ('protocolExtensions', _DL_PowerControlRequest_protocolExtensions),
        ])
    DL_PowerControlRequest._ext = []
    
    #-----< DL-PowerControlRequest-IEs >-----#
    DL_PowerControlRequest_IEs = CLASS(name='DL-PowerControlRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_PowerControlRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _DL_PowerControlRequest_IEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PowerAdjustmentType')))
    _DL_PowerControlRequest_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_PowerControlRequest_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InnerLoopDLPCStatus')))
    _DL_PowerControlRequest_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-ReferencePowerInformationList-DL-PC-Rqst')))
    _DL_PowerControlRequest_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaxAdjustmentStep')))
    _DL_PowerControlRequest_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AdjustmentPeriod')))
    _DL_PowerControlRequest_IEs_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ScaledAdjustmentRatio')))
    DL_PowerControlRequest_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _DL_PowerControlRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 169), ('criticality', 'ignore'), ('Value', _DL_PowerControlRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _DL_PowerControlRequest_IEs_val_Value_2), ('presence', 'conditional')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _DL_PowerControlRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _DL_PowerControlRequest_IEs_val_Value_4), ('presence', 'conditional')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _DL_PowerControlRequest_IEs_val_Value_5), ('presence', 'conditional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _DL_PowerControlRequest_IEs_val_Value_6), ('presence', 'conditional')]), dict([('id', 317), ('criticality', 'ignore'), ('Value', _DL_PowerControlRequest_IEs_val_Value_7), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< DL-PowerControlRequest-Extensions >-----#
    DL_PowerControlRequest_Extensions = CLASS(name='DL-PowerControlRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_PowerControlRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-ReferencePowerInformationList-DL-PC-Rqst >-----#
    DL_ReferencePowerInformationList_DL_PC_Rqst = SEQ_OF(name='DL-ReferencePowerInformationList-DL-PC-Rqst', mode=MODE_TYPE)
    _DL_ReferencePowerInformationList_DL_PC_Rqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-ReferencePowerInformationItem-DL-PC-Rqst')))
    ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab._val = ASN1Set(rv=[dict([('id', 84), ('criticality', 'ignore'), ('Value', ____DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id._const_tab = ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id._const_tab_at = None
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id._const_tab_id = 'id'
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality._const_tab = ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality._const_tab_at = ('..', 'id')
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality._const_tab_id = 'criticality'
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value._const_tab = ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value._const_tab_at = ('..', 'id')
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value._const_tab_id = 'Value'
    _DL_ReferencePowerInformationList_DL_PC_Rqst__item_._cont = ASN1Dict([
        ('id', __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id),
        ('criticality', __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality),
        ('value', __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value),
        ])
    _DL_ReferencePowerInformationList_DL_PC_Rqst__item_._ext = None
    DL_ReferencePowerInformationList_DL_PC_Rqst._cont = _DL_ReferencePowerInformationList_DL_PC_Rqst__item_
    DL_ReferencePowerInformationList_DL_PC_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-ReferencePowerInformationItemIE-DL-PC-Rqst >-----#
    DL_ReferencePowerInformationItemIE_DL_PC_Rqst = CLASS(name='DL-ReferencePowerInformationItemIE-DL-PC-Rqst', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_ReferencePowerInformationItemIE_DL_PC_Rqst_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-ReferencePowerInformationItem-DL-PC-Rqst')))
    DL_ReferencePowerInformationItemIE_DL_PC_Rqst._val = ASN1Set(rv=[dict([('id', 84), ('criticality', 'ignore'), ('Value', _DL_ReferencePowerInformationItemIE_DL_PC_Rqst_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-ReferencePowerInformationItem-DL-PC-Rqst >-----#
    DL_ReferencePowerInformationItem_DL_PC_Rqst = SEQ(name='DL-ReferencePowerInformationItem-DL-PC-Rqst', mode=MODE_TYPE)
    _DL_ReferencePowerInformationItem_DL_PC_Rqst_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _DL_ReferencePowerInformationItem_DL_PC_Rqst_dl_ReferencePower = INT(name='dl-ReferencePower', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__id._const_tab = ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__id_tab
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__criticality._const_tab = ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__criticality_tab
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__extensionValue._const_tab = ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__extensionValue_tab
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__id),
        ('criticality', ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__extensionValue),
        ])
    __DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item_._ext = None
    _DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions._cont = __DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item_
    _DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_ReferencePowerInformationItem_DL_PC_Rqst._cont = ASN1Dict([
        ('rL-ID', _DL_ReferencePowerInformationItem_DL_PC_Rqst_rL_ID),
        ('dl-ReferencePower', _DL_ReferencePowerInformationItem_DL_PC_Rqst_dl_ReferencePower),
        ('iE-Extensions', _DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions),
        ])
    DL_ReferencePowerInformationItem_DL_PC_Rqst._ext = []
    
    #-----< DL-ReferencePowerInformationItem-DL-PC-Rqst-ExtIEs >-----#
    DL_ReferencePowerInformationItem_DL_PC_Rqst_ExtIEs = CLASS(name='DL-ReferencePowerInformationItem-DL-PC-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_ReferencePowerInformationItem_DL_PC_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PowerTimeslotControlRequest >-----#
    DL_PowerTimeslotControlRequest = SEQ(name='DL-PowerTimeslotControlRequest', mode=MODE_TYPE)
    _DL_PowerTimeslotControlRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __DL_PowerTimeslotControlRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfo')))
    ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__id._const_tab = ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__id._const_tab_at = None
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality._const_tab = ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__value._const_tab = ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __DL_PowerTimeslotControlRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DL_PowerTimeslotControlRequest_protocolIEs__item__id),
        ('criticality', ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality),
        ('value', ___DL_PowerTimeslotControlRequest_protocolIEs__item__value),
        ])
    __DL_PowerTimeslotControlRequest_protocolIEs__item_._ext = None
    _DL_PowerTimeslotControlRequest_protocolIEs._cont = __DL_PowerTimeslotControlRequest_protocolIEs__item_
    _DL_PowerTimeslotControlRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DL_PowerTimeslotControlRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_PowerTimeslotControlRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfoLCR')))
    _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrimaryCCPCH-RSCP')))
    _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrimaryCCPCH-RSCP-Delta')))
    ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 480), ('criticality', 'ignore'), ('Extension', _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 542), ('criticality', 'ignore'), ('Extension', _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 623), ('criticality', 'ignore'), ('Extension', _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id._const_tab = ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id._const_tab_at = None
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality._const_tab = ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue._const_tab = ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_PowerTimeslotControlRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id),
        ('criticality', ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue),
        ])
    __DL_PowerTimeslotControlRequest_protocolExtensions__item_._ext = None
    _DL_PowerTimeslotControlRequest_protocolExtensions._cont = __DL_PowerTimeslotControlRequest_protocolExtensions__item_
    _DL_PowerTimeslotControlRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_PowerTimeslotControlRequest._cont = ASN1Dict([
        ('protocolIEs', _DL_PowerTimeslotControlRequest_protocolIEs),
        ('protocolExtensions', _DL_PowerTimeslotControlRequest_protocolExtensions),
        ])
    DL_PowerTimeslotControlRequest._ext = []
    
    #-----< DL-PowerTimeslotControlRequest-IEs >-----#
    DL_PowerTimeslotControlRequest_IEs = CLASS(name='DL-PowerTimeslotControlRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DL_PowerTimeslotControlRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _DL_PowerTimeslotControlRequest_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfo')))
    DL_PowerTimeslotControlRequest_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _DL_PowerTimeslotControlRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _DL_PowerTimeslotControlRequest_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-PowerTimeslotControlRequest-Extensions >-----#
    DL_PowerTimeslotControlRequest_Extensions = CLASS(name='DL-PowerTimeslotControlRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_PowerTimeslotControlRequest_Extensions_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-TimeslotISCPInfoLCR')))
    _DL_PowerTimeslotControlRequest_Extensions_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrimaryCCPCH-RSCP')))
    _DL_PowerTimeslotControlRequest_Extensions_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PrimaryCCPCH-RSCP-Delta')))
    DL_PowerTimeslotControlRequest_Extensions._val = ASN1Set(rv=[dict([('id', 480), ('criticality', 'ignore'), ('Extension', _DL_PowerTimeslotControlRequest_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 542), ('criticality', 'ignore'), ('Extension', _DL_PowerTimeslotControlRequest_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 623), ('criticality', 'ignore'), ('Extension', _DL_PowerTimeslotControlRequest_Extensions_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementInitiationRequest >-----#
    DedicatedMeasurementInitiationRequest = SEQ(name='DedicatedMeasurementInitiationRequest', mode=MODE_TYPE)
    _DedicatedMeasurementInitiationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rqst')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementType')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementFilterCoefficient')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristics')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FNReportingIndicator')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'reject'), ('Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'reject'), ('Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 70), ('criticality', 'reject'), ('Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 132), ('criticality', 'reject'), ('Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'reject'), ('Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id._const_tab = ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value._const_tab = ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __DedicatedMeasurementInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id),
        ('criticality', ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality),
        ('value', ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value),
        ])
    __DedicatedMeasurementInitiationRequest_protocolIEs__item_._ext = None
    _DedicatedMeasurementInitiationRequest_protocolIEs._cont = __DedicatedMeasurementInitiationRequest_protocolIEs__item_
    _DedicatedMeasurementInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementInitiationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementInitiationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NumberOfReportedCellPortions')))
    _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoveryBehavior')))
    _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AlternativeFormatReportingIndicator')))
    _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NumberOfReportedCellPortionsLCR')))
    ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 596), ('criticality', 'reject'), ('Extension', _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'conditional')]), dict([('id', 624), ('criticality', 'ignore'), ('Extension', _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 821), ('criticality', 'ignore'), ('Extension', _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1114), ('criticality', 'reject'), ('Extension', _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DedicatedMeasurementInitiationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id),
        ('criticality', ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementInitiationRequest_protocolExtensions__item_._ext = None
    _DedicatedMeasurementInitiationRequest_protocolExtensions._cont = __DedicatedMeasurementInitiationRequest_protocolExtensions__item_
    _DedicatedMeasurementInitiationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementInitiationRequest._cont = ASN1Dict([
        ('protocolIEs', _DedicatedMeasurementInitiationRequest_protocolIEs),
        ('protocolExtensions', _DedicatedMeasurementInitiationRequest_protocolExtensions),
        ])
    DedicatedMeasurementInitiationRequest._ext = []
    
    #-----< DedicatedMeasurementInitiationRequest-IEs >-----#
    DedicatedMeasurementInitiationRequest_IEs = CLASS(name='DedicatedMeasurementInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rqst')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementType')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementFilterCoefficient')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_5 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ReportCharacteristics')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'FNReportingIndicator')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    DedicatedMeasurementInitiationRequest_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'reject'), ('Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'reject'), ('Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'reject'), ('Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 70), ('criticality', 'reject'), ('Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 132), ('criticality', 'reject'), ('Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'reject'), ('Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementInitiationRequest-Extensions >-----#
    DedicatedMeasurementInitiationRequest_Extensions = CLASS(name='DedicatedMeasurementInitiationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NumberOfReportedCellPortions')))
    _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_1 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoveryBehavior')))
    _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'AlternativeFormatReportingIndicator')))
    _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NumberOfReportedCellPortionsLCR')))
    DedicatedMeasurementInitiationRequest_Extensions._val = ASN1Set(rv=[dict([('id', 596), ('criticality', 'reject'), ('Extension', _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_0), ('presence', 'conditional')]), dict([('id', 624), ('criticality', 'ignore'), ('Extension', _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 821), ('criticality', 'ignore'), ('Extension', _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 1114), ('criticality', 'reject'), ('Extension', _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_3), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementObjectType-DM-Rqst >-----#
    DedicatedMeasurementObjectType_DM_Rqst = CHOICE(name='DedicatedMeasurementObjectType-DM-Rqst', mode=MODE_TYPE)
    _DedicatedMeasurementObjectType_DM_Rqst_rL = SEQ(name='rL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-DM-Rqst')))
    _DedicatedMeasurementObjectType_DM_Rqst_rLS = SEQ(name='rLS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-DM-Rqst')))
    _DedicatedMeasurementObjectType_DM_Rqst_all_RL = NULL(name='all-RL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'AllRL-DM-Rqst')))
    _DedicatedMeasurementObjectType_DM_Rqst_all_RLS = NULL(name='all-RLS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'AllRL-Set-DM-Rqst')))
    DedicatedMeasurementObjectType_DM_Rqst._cont = ASN1Dict([
        ('rL', _DedicatedMeasurementObjectType_DM_Rqst_rL),
        ('rLS', _DedicatedMeasurementObjectType_DM_Rqst_rLS),
        ('all-RL', _DedicatedMeasurementObjectType_DM_Rqst_all_RL),
        ('all-RLS', _DedicatedMeasurementObjectType_DM_Rqst_all_RLS),
        ])
    DedicatedMeasurementObjectType_DM_Rqst._ext = []
    
    #-----< RL-DM-Rqst >-----#
    RL_DM_Rqst = SEQ(name='RL-DM-Rqst', mode=MODE_TYPE)
    _RL_DM_Rqst_rL_InformationList = SEQ_OF(name='rL-InformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-DM-Rqst')))
    _RL_DM_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_DM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_DM_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_DM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rqst_iE_Extensions__item__id._const_tab = ____RL_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_DM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___RL_DM_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_DM_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_DM_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rqst_iE_Extensions__item__criticality._const_tab = ____RL_DM_Rqst_iE_Extensions__item__criticality_tab
    ___RL_DM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_DM_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_DM_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_DM_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____RL_DM_Rqst_iE_Extensions__item__extensionValue_tab
    ___RL_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_DM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_DM_Rqst_iE_Extensions__item__id),
        ('criticality', ___RL_DM_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_DM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __RL_DM_Rqst_iE_Extensions__item_._ext = None
    _RL_DM_Rqst_iE_Extensions._cont = __RL_DM_Rqst_iE_Extensions__item_
    _RL_DM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_DM_Rqst._cont = ASN1Dict([
        ('rL-InformationList', _RL_DM_Rqst_rL_InformationList),
        ('iE-Extensions', _RL_DM_Rqst_iE_Extensions),
        ])
    RL_DM_Rqst._ext = []
    
    #-----< RLItem-DM-Rqst-ExtIEs >-----#
    RLItem_DM_Rqst_ExtIEs = CLASS(name='RLItem-DM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RLItem_DM_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-DM-Rqst >-----#
    RL_InformationList_DM_Rqst = SEQ_OF(name='RL-InformationList-DM-Rqst', mode=MODE_TYPE)
    _RL_InformationList_DM_Rqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_DM_Rqst__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationList_DM_Rqst__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationList_DM_Rqst__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-DM-Rqst')))
    ___RL_InformationList_DM_Rqst__item__id_tab._val = ASN1Set(rv=[dict([('id', 203), ('criticality', 'reject'), ('Value', ____RL_InformationList_DM_Rqst__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_DM_Rqst__item__id._const_tab = ___RL_InformationList_DM_Rqst__item__id_tab
    __RL_InformationList_DM_Rqst__item__id._const_tab_at = None
    __RL_InformationList_DM_Rqst__item__id._const_tab_id = 'id'
    __RL_InformationList_DM_Rqst__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationList_DM_Rqst__item__criticality._const_tab = ___RL_InformationList_DM_Rqst__item__id_tab
    __RL_InformationList_DM_Rqst__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationList_DM_Rqst__item__criticality._const_tab_id = 'criticality'
    __RL_InformationList_DM_Rqst__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationList_DM_Rqst__item__value._const_tab = ___RL_InformationList_DM_Rqst__item__id_tab
    __RL_InformationList_DM_Rqst__item__value._const_tab_at = ('..', 'id')
    __RL_InformationList_DM_Rqst__item__value._const_tab_id = 'Value'
    _RL_InformationList_DM_Rqst__item_._cont = ASN1Dict([
        ('id', __RL_InformationList_DM_Rqst__item__id),
        ('criticality', __RL_InformationList_DM_Rqst__item__criticality),
        ('value', __RL_InformationList_DM_Rqst__item__value),
        ])
    _RL_InformationList_DM_Rqst__item_._ext = None
    RL_InformationList_DM_Rqst._cont = _RL_InformationList_DM_Rqst__item_
    RL_InformationList_DM_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIE-DM-Rqst >-----#
    RL_InformationItemIE_DM_Rqst = CLASS(name='RL-InformationItemIE-DM-Rqst', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationItemIE_DM_Rqst_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-DM-Rqst')))
    RL_InformationItemIE_DM_Rqst._val = ASN1Set(rv=[dict([('id', 203), ('criticality', 'reject'), ('Value', _RL_InformationItemIE_DM_Rqst_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-DM-Rqst >-----#
    RL_InformationItem_DM_Rqst = SEQ(name='RL-InformationItem-DM-Rqst', mode=MODE_TYPE)
    _RL_InformationItem_DM_Rqst_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationItem_DM_Rqst_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')), opt=True)
    _RL_InformationItem_DM_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_DM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Info-DM-Rqst')))
    _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HSSICH-Info-DM-Rqst')))
    _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID768')))
    _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HSSICH-InfoExt-DM-Rqst')))
    ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 505), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 591), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 759), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 937), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab = ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationItem_DM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id),
        ('criticality', ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_DM_Rqst_iE_Extensions__item_._ext = None
    _RL_InformationItem_DM_Rqst_iE_Extensions._cont = __RL_InformationItem_DM_Rqst_iE_Extensions__item_
    _RL_InformationItem_DM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_DM_Rqst._cont = ASN1Dict([
        ('rL-ID', _RL_InformationItem_DM_Rqst_rL_ID),
        ('dPCH-ID', _RL_InformationItem_DM_Rqst_dPCH_ID),
        ('iE-Extensions', _RL_InformationItem_DM_Rqst_iE_Extensions),
        ])
    RL_InformationItem_DM_Rqst._ext = []
    
    #-----< RL-InformationItem-DM-Rqst-ExtIEs >-----#
    RL_InformationItem_DM_Rqst_ExtIEs = CLASS(name='RL-InformationItem-DM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Info-DM-Rqst')))
    _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HSSICH-Info-DM-Rqst')))
    _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID768')))
    _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HSSICH-InfoExt-DM-Rqst')))
    RL_InformationItem_DM_Rqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 505), ('criticality', 'reject'), ('Extension', _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 591), ('criticality', 'reject'), ('Extension', _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 759), ('criticality', 'reject'), ('Extension', _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 937), ('criticality', 'reject'), ('Extension', _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PUSCH-Info-DM-Rqst >-----#
    PUSCH_Info_DM_Rqst = SEQ_OF(name='PUSCH-Info-DM-Rqst', mode=MODE_TYPE)
    _PUSCH_Info_DM_Rqst__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PUSCH-ID')))
    PUSCH_Info_DM_Rqst._cont = _PUSCH_Info_DM_Rqst__item_
    PUSCH_Info_DM_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< HSSICH-Info-DM-Rqst >-----#
    HSSICH_Info_DM_Rqst = SEQ_OF(name='HSSICH-Info-DM-Rqst', mode=MODE_TYPE)
    _HSSICH_Info_DM_Rqst__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    HSSICH_Info_DM_Rqst._cont = _HSSICH_Info_DM_Rqst__item_
    HSSICH_Info_DM_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HSSICH-InfoExt-DM-Rqst >-----#
    HSSICH_InfoExt_DM_Rqst = SEQ_OF(name='HSSICH-InfoExt-DM-Rqst', mode=MODE_TYPE)
    _HSSICH_InfoExt_DM_Rqst__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    HSSICH_InfoExt_DM_Rqst._cont = _HSSICH_InfoExt_DM_Rqst__item_
    HSSICH_InfoExt_DM_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< RL-Set-DM-Rqst >-----#
    RL_Set_DM_Rqst = SEQ(name='RL-Set-DM-Rqst', mode=MODE_TYPE)
    _RL_Set_DM_Rqst_rL_Set_InformationList_DM_Rqst = SEQ_OF(name='rL-Set-InformationList-DM-Rqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationList-DM-Rqst')))
    _RL_Set_DM_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_DM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_DM_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Set_DM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rqst_iE_Extensions__item__id._const_tab = ____RL_Set_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_Set_DM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_DM_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Set_DM_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Set_DM_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rqst_iE_Extensions__item__criticality._const_tab = ____RL_Set_DM_Rqst_iE_Extensions__item__criticality_tab
    ___RL_Set_DM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Set_DM_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Set_DM_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_DM_Rqst_iE_Extensions__item__extensionValue_tab
    ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Set_DM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Set_DM_Rqst_iE_Extensions__item__id),
        ('criticality', ___RL_Set_DM_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_DM_Rqst_iE_Extensions__item_._ext = None
    _RL_Set_DM_Rqst_iE_Extensions._cont = __RL_Set_DM_Rqst_iE_Extensions__item_
    _RL_Set_DM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_DM_Rqst._cont = ASN1Dict([
        ('rL-Set-InformationList-DM-Rqst', _RL_Set_DM_Rqst_rL_Set_InformationList_DM_Rqst),
        ('iE-Extensions', _RL_Set_DM_Rqst_iE_Extensions),
        ])
    RL_Set_DM_Rqst._ext = []
    
    #-----< RL-SetItem-DM-Rqst-ExtIEs >-----#
    RL_SetItem_DM_Rqst_ExtIEs = CLASS(name='RL-SetItem-DM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_SetItem_DM_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-InformationList-DM-Rqst >-----#
    RL_Set_InformationList_DM_Rqst = SEQ_OF(name='RL-Set-InformationList-DM-Rqst', mode=MODE_TYPE)
    _RL_Set_InformationList_DM_Rqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationItem-DM-Rqst')))
    RL_Set_InformationList_DM_Rqst._cont = _RL_Set_InformationList_DM_Rqst__item_
    RL_Set_InformationList_DM_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-InformationItem-DM-Rqst >-----#
    RL_Set_InformationItem_DM_Rqst = SEQ(name='RL-Set-InformationItem-DM-Rqst', mode=MODE_TYPE)
    _RL_Set_InformationItem_DM_Rqst_rL_Set_ID = INT(name='rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _RL_Set_InformationItem_DM_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_InformationItem_DM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab = ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab = ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality_tab
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue_tab
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Set_InformationItem_DM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id),
        ('criticality', ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_InformationItem_DM_Rqst_iE_Extensions__item_._ext = None
    _RL_Set_InformationItem_DM_Rqst_iE_Extensions._cont = __RL_Set_InformationItem_DM_Rqst_iE_Extensions__item_
    _RL_Set_InformationItem_DM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_InformationItem_DM_Rqst._cont = ASN1Dict([
        ('rL-Set-ID', _RL_Set_InformationItem_DM_Rqst_rL_Set_ID),
        ('iE-Extensions', _RL_Set_InformationItem_DM_Rqst_iE_Extensions),
        ])
    RL_Set_InformationItem_DM_Rqst._ext = []
    
    #-----< RL-Set-InformationItem-DM-Rqst-ExtIEs >-----#
    RL_Set_InformationItem_DM_Rqst_ExtIEs = CLASS(name='RL-Set-InformationItem-DM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_Set_InformationItem_DM_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AllRL-DM-Rqst >-----#
    AllRL_DM_Rqst = NULL(name='AllRL-DM-Rqst', mode=MODE_TYPE)
    
    #-----< AllRL-Set-DM-Rqst >-----#
    AllRL_Set_DM_Rqst = NULL(name='AllRL-Set-DM-Rqst', mode=MODE_TYPE)
    
    #-----< DedicatedMeasurementInitiationResponse >-----#
    DedicatedMeasurementInitiationResponse = SEQ(name='DedicatedMeasurementInitiationResponse', mode=MODE_TYPE)
    _DedicatedMeasurementInitiationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rsp')))
    _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 69), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id._const_tab = ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value._const_tab = ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __DedicatedMeasurementInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id),
        ('criticality', ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality),
        ('value', ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value),
        ])
    __DedicatedMeasurementInitiationResponse_protocolIEs__item_._ext = None
    _DedicatedMeasurementInitiationResponse_protocolIEs._cont = __DedicatedMeasurementInitiationResponse_protocolIEs__item_
    _DedicatedMeasurementInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementInitiationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementInitiationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoverySupportIndicator')))
    ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 626), ('criticality', 'ignore'), ('Extension', _____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DedicatedMeasurementInitiationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id),
        ('criticality', ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementInitiationResponse_protocolExtensions__item_._ext = None
    _DedicatedMeasurementInitiationResponse_protocolExtensions._cont = __DedicatedMeasurementInitiationResponse_protocolExtensions__item_
    _DedicatedMeasurementInitiationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementInitiationResponse._cont = ASN1Dict([
        ('protocolIEs', _DedicatedMeasurementInitiationResponse_protocolIEs),
        ('protocolExtensions', _DedicatedMeasurementInitiationResponse_protocolExtensions),
        ])
    DedicatedMeasurementInitiationResponse._ext = []
    
    #-----< DedicatedMeasurementInitiationResponse-IEs >-----#
    DedicatedMeasurementInitiationResponse_IEs = CLASS(name='DedicatedMeasurementInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DedicatedMeasurementInitiationResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _DedicatedMeasurementInitiationResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _DedicatedMeasurementInitiationResponse_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rsp')))
    _DedicatedMeasurementInitiationResponse_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    DedicatedMeasurementInitiationResponse_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementInitiationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementInitiationResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 69), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementInitiationResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementInitiationResponse_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementInitiationResponse-Extensions >-----#
    DedicatedMeasurementInitiationResponse_Extensions = CLASS(name='DedicatedMeasurementInitiationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DedicatedMeasurementInitiationResponse_Extensions_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoverySupportIndicator')))
    DedicatedMeasurementInitiationResponse_Extensions._val = ASN1Set(rv=[dict([('id', 626), ('criticality', 'ignore'), ('Extension', _DedicatedMeasurementInitiationResponse_Extensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementObjectType-DM-Rsp >-----#
    DedicatedMeasurementObjectType_DM_Rsp = CHOICE(name='DedicatedMeasurementObjectType-DM-Rsp', mode=MODE_TYPE)
    _DedicatedMeasurementObjectType_DM_Rsp_rL = SEQ(name='rL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-DM-Rsp')))
    _DedicatedMeasurementObjectType_DM_Rsp_rLS = SEQ(name='rLS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-DM-Rsp')))
    _DedicatedMeasurementObjectType_DM_Rsp_all_RL = SEQ(name='all-RL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-DM-Rsp')))
    _DedicatedMeasurementObjectType_DM_Rsp_all_RLS = SEQ(name='all-RLS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-DM-Rsp')))
    DedicatedMeasurementObjectType_DM_Rsp._cont = ASN1Dict([
        ('rL', _DedicatedMeasurementObjectType_DM_Rsp_rL),
        ('rLS', _DedicatedMeasurementObjectType_DM_Rsp_rLS),
        ('all-RL', _DedicatedMeasurementObjectType_DM_Rsp_all_RL),
        ('all-RLS', _DedicatedMeasurementObjectType_DM_Rsp_all_RLS),
        ])
    DedicatedMeasurementObjectType_DM_Rsp._ext = []
    
    #-----< RL-DM-Rsp >-----#
    RL_DM_Rsp = SEQ(name='RL-DM-Rsp', mode=MODE_TYPE)
    _RL_DM_Rsp_rL_InformationList_DM_Rsp = SEQ_OF(name='rL-InformationList-DM-Rsp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-DM-Rsp')))
    _RL_DM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_DM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rsp_iE_Extensions__item__id._const_tab = ____RL_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___RL_DM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_DM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____RL_DM_Rsp_iE_Extensions__item__criticality_tab
    ___RL_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____RL_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___RL_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_DM_Rsp_iE_Extensions__item__id),
        ('criticality', ___RL_DM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __RL_DM_Rsp_iE_Extensions__item_._ext = None
    _RL_DM_Rsp_iE_Extensions._cont = __RL_DM_Rsp_iE_Extensions__item_
    _RL_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_DM_Rsp._cont = ASN1Dict([
        ('rL-InformationList-DM-Rsp', _RL_DM_Rsp_rL_InformationList_DM_Rsp),
        ('iE-Extensions', _RL_DM_Rsp_iE_Extensions),
        ])
    RL_DM_Rsp._ext = []
    
    #-----< RLItem-DM-Rsp-ExtIEs >-----#
    RLItem_DM_Rsp_ExtIEs = CLASS(name='RLItem-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RLItem_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-DM-Rsp >-----#
    RL_InformationList_DM_Rsp = SEQ_OF(name='RL-InformationList-DM-Rsp', mode=MODE_TYPE)
    _RL_InformationList_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_DM_Rsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationList_DM_Rsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationList_DM_Rsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-DM-Rsp')))
    ___RL_InformationList_DM_Rsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 204), ('criticality', 'ignore'), ('Value', ____RL_InformationList_DM_Rsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_DM_Rsp__item__id._const_tab = ___RL_InformationList_DM_Rsp__item__id_tab
    __RL_InformationList_DM_Rsp__item__id._const_tab_at = None
    __RL_InformationList_DM_Rsp__item__id._const_tab_id = 'id'
    __RL_InformationList_DM_Rsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationList_DM_Rsp__item__criticality._const_tab = ___RL_InformationList_DM_Rsp__item__id_tab
    __RL_InformationList_DM_Rsp__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationList_DM_Rsp__item__criticality._const_tab_id = 'criticality'
    __RL_InformationList_DM_Rsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationList_DM_Rsp__item__value._const_tab = ___RL_InformationList_DM_Rsp__item__id_tab
    __RL_InformationList_DM_Rsp__item__value._const_tab_at = ('..', 'id')
    __RL_InformationList_DM_Rsp__item__value._const_tab_id = 'Value'
    _RL_InformationList_DM_Rsp__item_._cont = ASN1Dict([
        ('id', __RL_InformationList_DM_Rsp__item__id),
        ('criticality', __RL_InformationList_DM_Rsp__item__criticality),
        ('value', __RL_InformationList_DM_Rsp__item__value),
        ])
    _RL_InformationList_DM_Rsp__item_._ext = None
    RL_InformationList_DM_Rsp._cont = _RL_InformationList_DM_Rsp__item_
    RL_InformationList_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIE-DM-Rsp >-----#
    RL_InformationItemIE_DM_Rsp = CLASS(name='RL-InformationItemIE-DM-Rsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationItemIE_DM_Rsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-DM-Rsp')))
    RL_InformationItemIE_DM_Rsp._val = ASN1Set(rv=[dict([('id', 204), ('criticality', 'ignore'), ('Value', _RL_InformationItemIE_DM_Rsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-DM-Rsp >-----#
    RL_InformationItem_DM_Rsp = SEQ(name='RL-InformationItem-DM-Rsp', mode=MODE_TYPE)
    _RL_InformationItem_DM_Rsp_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationItem_DM_Rsp_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')), opt=True)
    _RL_InformationItem_DM_Rsp_dedicatedMeasurementValue = CHOICE(name='dedicatedMeasurementValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementValue')))
    _RL_InformationItem_DM_Rsp_cFN = INT(name='cFN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CFN')), opt=True)
    _RL_InformationItem_DM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Info-DM-Rsp')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-PUSCH-InfoList-DM-Rsp')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID768')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-768-TDD-DM-Rsp')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 506), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 592), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 688), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 689), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 696), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 710), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 761), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 760), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 936), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab = ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationItem_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id),
        ('criticality', ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_DM_Rsp_iE_Extensions__item_._ext = None
    _RL_InformationItem_DM_Rsp_iE_Extensions._cont = __RL_InformationItem_DM_Rsp_iE_Extensions__item_
    _RL_InformationItem_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_DM_Rsp._cont = ASN1Dict([
        ('rL-ID', _RL_InformationItem_DM_Rsp_rL_ID),
        ('dPCH-ID', _RL_InformationItem_DM_Rsp_dPCH_ID),
        ('dedicatedMeasurementValue', _RL_InformationItem_DM_Rsp_dedicatedMeasurementValue),
        ('cFN', _RL_InformationItem_DM_Rsp_cFN),
        ('iE-Extensions', _RL_InformationItem_DM_Rsp_iE_Extensions),
        ])
    RL_InformationItem_DM_Rsp._ext = []
    
    #-----< RL-InformationItem-DM-Rsp-ExtIEs >-----#
    RL_InformationItem_DM_Rsp_ExtIEs = CLASS(name='RL-InformationItem-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Info-DM-Rsp')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-PUSCH-InfoList-DM-Rsp')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID768')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-768-TDD-DM-Rsp')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    RL_InformationItem_DM_Rsp_ExtIEs._val = ASN1Set(rv=[dict([('id', 506), ('criticality', 'reject'), ('Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 592), ('criticality', 'reject'), ('Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 688), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 689), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 696), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 710), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 761), ('criticality', 'reject'), ('Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 760), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 936), ('criticality', 'reject'), ('Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PUSCH-Info-DM-Rsp >-----#
    PUSCH_Info_DM_Rsp = SEQ_OF(name='PUSCH-Info-DM-Rsp', mode=MODE_TYPE)
    _PUSCH_Info_DM_Rsp__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PUSCH-ID')))
    PUSCH_Info_DM_Rsp._cont = _PUSCH_Info_DM_Rsp__item_
    PUSCH_Info_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Multiple-PUSCH-InfoList-DM-Rsp >-----#
    Multiple_PUSCH_InfoList_DM_Rsp = SEQ_OF(name='Multiple-PUSCH-InfoList-DM-Rsp', mode=MODE_TYPE)
    _Multiple_PUSCH_InfoList_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-PUSCH-InfoListIE-DM-Rsp')))
    Multiple_PUSCH_InfoList_DM_Rsp._cont = _Multiple_PUSCH_InfoList_DM_Rsp__item_
    Multiple_PUSCH_InfoList_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< Multiple-PUSCH-InfoListIE-DM-Rsp >-----#
    Multiple_PUSCH_InfoListIE_DM_Rsp = SEQ(name='Multiple-PUSCH-InfoListIE-DM-Rsp', mode=MODE_TYPE)
    _Multiple_PUSCH_InfoListIE_DM_Rsp_pUSCH_ID = INT(name='pUSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCH-ID')), opt=True)
    _Multiple_PUSCH_InfoListIE_DM_Rsp_dedicatedMeasurementValue = CHOICE(name='dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementValue')), opt=True)
    _Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__id._const_tab = ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__criticality_tab
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__id),
        ('criticality', ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item_._ext = None
    _Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions._cont = __Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item_
    _Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiple_PUSCH_InfoListIE_DM_Rsp._cont = ASN1Dict([
        ('pUSCH-ID', _Multiple_PUSCH_InfoListIE_DM_Rsp_pUSCH_ID),
        ('dedicatedMeasurementValue', _Multiple_PUSCH_InfoListIE_DM_Rsp_dedicatedMeasurementValue),
        ('iE-Extensions', _Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions),
        ])
    Multiple_PUSCH_InfoListIE_DM_Rsp._ext = []
    
    #-----< Multiple-PUSCH-InfoListIE-DM-Rsp-ExtIEs >-----#
    Multiple_PUSCH_InfoListIE_DM_Rsp_ExtIEs = CLASS(name='Multiple-PUSCH-InfoListIE-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multiple_PUSCH_InfoListIE_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp = SEQ_OF(name='Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp')))
    Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp._cont = _Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp__item_
    Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=239)], ev=None, er=[])
    
    #-----< Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp = SEQ(name='Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue = CHOICE(name='dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementValue')))
    _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab = ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality_tab
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id),
        ('criticality', ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_._ext = None
    _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions._cont = __Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_
    _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp._cont = ASN1Dict([
        ('dPCH-ID', _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dPCH_ID),
        ('dedicatedMeasurementValue', _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue),
        ('iE-Extensions', _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions),
        ])
    Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp._ext = []
    
    #-----< Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp-ExtIEs >-----#
    Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_ExtIEs = CLASS(name='Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp = SEQ_OF(name='Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp')))
    Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp._cont = _Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp__item_
    Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=95)], ev=None, er=[])
    
    #-----< Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp = SEQ(name='Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')))
    _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dedicatedMeasurementValue = CHOICE(name='dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementValue')))
    _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id._const_tab = ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality_tab
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id),
        ('criticality', ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item_._ext = None
    _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions._cont = __Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item_
    _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp._cont = ASN1Dict([
        ('dPCH-ID', _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dPCH_ID),
        ('dedicatedMeasurementValue', _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dedicatedMeasurementValue),
        ('iE-Extensions', _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions),
        ])
    Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp._ext = []
    
    #-----< Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp-ExtIEs >-----#
    Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_ExtIEs = CLASS(name='Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp >-----#
    Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp = SEQ_OF(name='Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp')))
    Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp._cont = _Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp__item_
    Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp >-----#
    Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp = SEQ(name='Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_hsSICH_ID = INT(name='hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue = CHOICE(name='dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementValue')))
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 936), ('criticality', 'ignore'), ('Extension', _____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab = ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id),
        ('criticality', ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_._ext = None
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions._cont = __Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp._cont = ASN1Dict([
        ('hsSICH-ID', _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_hsSICH_ID),
        ('dedicatedMeasurementValue', _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue),
        ('iE-Extensions', _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions),
        ])
    Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp._ext = []
    
    #-----< Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp-ExtIEs >-----#
    Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs = CLASS(name='Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs._val = ASN1Set(rv=[dict([('id', 936), ('criticality', 'ignore'), ('Extension', _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Multiple-DedicatedMeasurementValueList-768-TDD-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueList_768_TDD_DM_Rsp = SEQ_OF(name='Multiple-DedicatedMeasurementValueList-768-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueList_768_TDD_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueItem-768-TDD-DM-Rsp')))
    Multiple_DedicatedMeasurementValueList_768_TDD_DM_Rsp._cont = _Multiple_DedicatedMeasurementValueList_768_TDD_DM_Rsp__item_
    Multiple_DedicatedMeasurementValueList_768_TDD_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=479)], ev=None, er=[])
    
    #-----< Multiple-DedicatedMeasurementValueItem-768-TDD-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp = SEQ(name='Multiple-DedicatedMeasurementValueItem-768-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_dPCH_ID768 = INT(name='dPCH-ID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID768')))
    _Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_dedicatedMeasurementValue = CHOICE(name='dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementValue')))
    _Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__id._const_tab = ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__criticality_tab
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__id),
        ('criticality', ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item_._ext = None
    _Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions._cont = __Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item_
    _Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp._cont = ASN1Dict([
        ('dPCH-ID768', _Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_dPCH_ID768),
        ('dedicatedMeasurementValue', _Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_dedicatedMeasurementValue),
        ('iE-Extensions', _Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions),
        ])
    Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp._ext = []
    
    #-----< Multiple-DedicatedMeasurementValueItem-768-TDD-DM-Rsp-ExtIEs >-----#
    Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_ExtIEs = CLASS(name='Multiple-DedicatedMeasurementValueItem-768-TDD-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-DM-Rsp >-----#
    RL_Set_DM_Rsp = SEQ(name='RL-Set-DM-Rsp', mode=MODE_TYPE)
    _RL_Set_DM_Rsp_rL_Set_InformationList_DM_Rsp = SEQ_OF(name='rL-Set-InformationList-DM-Rsp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationList-DM-Rsp')))
    _RL_Set_DM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_DM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Set_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rsp_iE_Extensions__item__id._const_tab = ____RL_Set_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_Set_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_DM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Set_DM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Set_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____RL_Set_DM_Rsp_iE_Extensions__item__criticality_tab
    ___RL_Set_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Set_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Set_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Set_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Set_DM_Rsp_iE_Extensions__item__id),
        ('criticality', ___RL_Set_DM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_DM_Rsp_iE_Extensions__item_._ext = None
    _RL_Set_DM_Rsp_iE_Extensions._cont = __RL_Set_DM_Rsp_iE_Extensions__item_
    _RL_Set_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_DM_Rsp._cont = ASN1Dict([
        ('rL-Set-InformationList-DM-Rsp', _RL_Set_DM_Rsp_rL_Set_InformationList_DM_Rsp),
        ('iE-Extensions', _RL_Set_DM_Rsp_iE_Extensions),
        ])
    RL_Set_DM_Rsp._ext = []
    
    #-----< RL-SetItem-DM-Rsp-ExtIEs >-----#
    RL_SetItem_DM_Rsp_ExtIEs = CLASS(name='RL-SetItem-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_SetItem_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-InformationList-DM-Rsp >-----#
    RL_Set_InformationList_DM_Rsp = SEQ_OF(name='RL-Set-InformationList-DM-Rsp', mode=MODE_TYPE)
    _RL_Set_InformationList_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_InformationList_DM_Rsp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_Set_InformationList_DM_Rsp__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_Set_InformationList_DM_Rsp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationItem-DM-Rsp')))
    ___RL_Set_InformationList_DM_Rsp__item__id_tab._val = ASN1Set(rv=[dict([('id', 240), ('criticality', 'ignore'), ('Value', ____RL_Set_InformationList_DM_Rsp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_InformationList_DM_Rsp__item__id._const_tab = ___RL_Set_InformationList_DM_Rsp__item__id_tab
    __RL_Set_InformationList_DM_Rsp__item__id._const_tab_at = None
    __RL_Set_InformationList_DM_Rsp__item__id._const_tab_id = 'id'
    __RL_Set_InformationList_DM_Rsp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_Set_InformationList_DM_Rsp__item__criticality._const_tab = ___RL_Set_InformationList_DM_Rsp__item__id_tab
    __RL_Set_InformationList_DM_Rsp__item__criticality._const_tab_at = ('..', 'id')
    __RL_Set_InformationList_DM_Rsp__item__criticality._const_tab_id = 'criticality'
    __RL_Set_InformationList_DM_Rsp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_Set_InformationList_DM_Rsp__item__value._const_tab = ___RL_Set_InformationList_DM_Rsp__item__id_tab
    __RL_Set_InformationList_DM_Rsp__item__value._const_tab_at = ('..', 'id')
    __RL_Set_InformationList_DM_Rsp__item__value._const_tab_id = 'Value'
    _RL_Set_InformationList_DM_Rsp__item_._cont = ASN1Dict([
        ('id', __RL_Set_InformationList_DM_Rsp__item__id),
        ('criticality', __RL_Set_InformationList_DM_Rsp__item__criticality),
        ('value', __RL_Set_InformationList_DM_Rsp__item__value),
        ])
    _RL_Set_InformationList_DM_Rsp__item_._ext = None
    RL_Set_InformationList_DM_Rsp._cont = _RL_Set_InformationList_DM_Rsp__item_
    RL_Set_InformationList_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-InformationItemIE-DM-Rsp >-----#
    RL_Set_InformationItemIE_DM_Rsp = CLASS(name='RL-Set-InformationItemIE-DM-Rsp', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_Set_InformationItemIE_DM_Rsp_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationItem-DM-Rsp')))
    RL_Set_InformationItemIE_DM_Rsp._val = ASN1Set(rv=[dict([('id', 240), ('criticality', 'ignore'), ('Value', _RL_Set_InformationItemIE_DM_Rsp_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-InformationItem-DM-Rsp >-----#
    RL_Set_InformationItem_DM_Rsp = SEQ(name='RL-Set-InformationItem-DM-Rsp', mode=MODE_TYPE)
    _RL_Set_InformationItem_DM_Rsp_rL_Set_ID = INT(name='rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _RL_Set_InformationItem_DM_Rsp_dedicatedMeasurementValue = CHOICE(name='dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementValue')))
    _RL_Set_InformationItem_DM_Rsp_cFN = INT(name='cFN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CFN')), opt=True)
    _RL_Set_InformationItem_DM_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_InformationItem_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab = ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality_tab
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Set_InformationItem_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id),
        ('criticality', ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_InformationItem_DM_Rsp_iE_Extensions__item_._ext = None
    _RL_Set_InformationItem_DM_Rsp_iE_Extensions._cont = __RL_Set_InformationItem_DM_Rsp_iE_Extensions__item_
    _RL_Set_InformationItem_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_InformationItem_DM_Rsp._cont = ASN1Dict([
        ('rL-Set-ID', _RL_Set_InformationItem_DM_Rsp_rL_Set_ID),
        ('dedicatedMeasurementValue', _RL_Set_InformationItem_DM_Rsp_dedicatedMeasurementValue),
        ('cFN', _RL_Set_InformationItem_DM_Rsp_cFN),
        ('iE-Extensions', _RL_Set_InformationItem_DM_Rsp_iE_Extensions),
        ])
    RL_Set_InformationItem_DM_Rsp._ext = []
    
    #-----< RL-Set-InformationItem-DM-Rsp-ExtIEs >-----#
    RL_Set_InformationItem_DM_Rsp_ExtIEs = CLASS(name='RL-Set-InformationItem-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_Set_InformationItem_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementInitiationFailure >-----#
    DedicatedMeasurementInitiationFailure = SEQ(name='DedicatedMeasurementInitiationFailure', mode=MODE_TYPE)
    _DedicatedMeasurementInitiationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id._const_tab = ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value._const_tab = ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __DedicatedMeasurementInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id),
        ('criticality', ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality),
        ('value', ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value),
        ])
    __DedicatedMeasurementInitiationFailure_protocolIEs__item_._ext = None
    _DedicatedMeasurementInitiationFailure_protocolIEs._cont = __DedicatedMeasurementInitiationFailure_protocolIEs__item_
    _DedicatedMeasurementInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementInitiationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementInitiationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality_tab
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DedicatedMeasurementInitiationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id),
        ('criticality', ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementInitiationFailure_protocolExtensions__item_._ext = None
    _DedicatedMeasurementInitiationFailure_protocolExtensions._cont = __DedicatedMeasurementInitiationFailure_protocolExtensions__item_
    _DedicatedMeasurementInitiationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementInitiationFailure._cont = ASN1Dict([
        ('protocolIEs', _DedicatedMeasurementInitiationFailure_protocolIEs),
        ('protocolExtensions', _DedicatedMeasurementInitiationFailure_protocolExtensions),
        ])
    DedicatedMeasurementInitiationFailure._ext = []
    
    #-----< DedicatedMeasurementInitiationFailure-IEs >-----#
    DedicatedMeasurementInitiationFailure_IEs = CLASS(name='DedicatedMeasurementInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DedicatedMeasurementInitiationFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _DedicatedMeasurementInitiationFailure_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _DedicatedMeasurementInitiationFailure_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _DedicatedMeasurementInitiationFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    DedicatedMeasurementInitiationFailure_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementInitiationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementInitiationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementInitiationFailure_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementInitiationFailure_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementInitiationFailure-Extensions >-----#
    DedicatedMeasurementInitiationFailure_Extensions = CLASS(name='DedicatedMeasurementInitiationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DedicatedMeasurementInitiationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementReport >-----#
    DedicatedMeasurementReport = SEQ(name='DedicatedMeasurementReport', mode=MODE_TYPE)
    _DedicatedMeasurementReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____DedicatedMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rprt')))
    ____DedicatedMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementReport_protocolIEs__item__id._const_tab = ____DedicatedMeasurementReport_protocolIEs__item__id_tab
    ___DedicatedMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementReport_protocolIEs__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___DedicatedMeasurementReport_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementReport_protocolIEs__item__id_tab
    ___DedicatedMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___DedicatedMeasurementReport_protocolIEs__item__value._const_tab = ____DedicatedMeasurementReport_protocolIEs__item__id_tab
    ___DedicatedMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementReport_protocolIEs__item__value._const_tab_id = 'Value'
    __DedicatedMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementReport_protocolIEs__item__id),
        ('criticality', ___DedicatedMeasurementReport_protocolIEs__item__criticality),
        ('value', ___DedicatedMeasurementReport_protocolIEs__item__value),
        ])
    __DedicatedMeasurementReport_protocolIEs__item_._ext = None
    _DedicatedMeasurementReport_protocolIEs._cont = __DedicatedMeasurementReport_protocolIEs__item_
    _DedicatedMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementReport_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementReport_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DedicatedMeasurementReport_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DedicatedMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoveryReportingIndicator')))
    ____DedicatedMeasurementReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 625), ('criticality', 'ignore'), ('Extension', _____DedicatedMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementReport_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementReport_protocolExtensions__item__id_tab
    ___DedicatedMeasurementReport_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementReport_protocolExtensions__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementReport_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DedicatedMeasurementReport_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementReport_protocolExtensions__item__id_tab
    ___DedicatedMeasurementReport_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementReport_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementReport_protocolExtensions__item__id_tab
    ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DedicatedMeasurementReport_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementReport_protocolExtensions__item__id),
        ('criticality', ___DedicatedMeasurementReport_protocolExtensions__item__criticality),
        ('extensionValue', ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementReport_protocolExtensions__item_._ext = None
    _DedicatedMeasurementReport_protocolExtensions._cont = __DedicatedMeasurementReport_protocolExtensions__item_
    _DedicatedMeasurementReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementReport._cont = ASN1Dict([
        ('protocolIEs', _DedicatedMeasurementReport_protocolIEs),
        ('protocolExtensions', _DedicatedMeasurementReport_protocolExtensions),
        ])
    DedicatedMeasurementReport._ext = []
    
    #-----< DedicatedMeasurementReport-IEs >-----#
    DedicatedMeasurementReport_IEs = CLASS(name='DedicatedMeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DedicatedMeasurementReport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _DedicatedMeasurementReport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _DedicatedMeasurementReport_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rprt')))
    DedicatedMeasurementReport_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementReport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementReport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementReport_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementReport-Extensions >-----#
    DedicatedMeasurementReport_Extensions = CLASS(name='DedicatedMeasurementReport-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DedicatedMeasurementReport_Extensions_val_Extension_0 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementRecoveryReportingIndicator')))
    DedicatedMeasurementReport_Extensions._val = ASN1Set(rv=[dict([('id', 625), ('criticality', 'ignore'), ('Extension', _DedicatedMeasurementReport_Extensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementObjectType-DM-Rprt >-----#
    DedicatedMeasurementObjectType_DM_Rprt = CHOICE(name='DedicatedMeasurementObjectType-DM-Rprt', mode=MODE_TYPE)
    _DedicatedMeasurementObjectType_DM_Rprt_rL = SEQ(name='rL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-DM-Rprt')))
    _DedicatedMeasurementObjectType_DM_Rprt_rLS = SEQ(name='rLS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-DM-Rprt')))
    _DedicatedMeasurementObjectType_DM_Rprt_all_RL = SEQ(name='all-RL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-DM-Rprt')))
    _DedicatedMeasurementObjectType_DM_Rprt_all_RLS = SEQ(name='all-RLS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-DM-Rprt')))
    DedicatedMeasurementObjectType_DM_Rprt._cont = ASN1Dict([
        ('rL', _DedicatedMeasurementObjectType_DM_Rprt_rL),
        ('rLS', _DedicatedMeasurementObjectType_DM_Rprt_rLS),
        ('all-RL', _DedicatedMeasurementObjectType_DM_Rprt_all_RL),
        ('all-RLS', _DedicatedMeasurementObjectType_DM_Rprt_all_RLS),
        ])
    DedicatedMeasurementObjectType_DM_Rprt._ext = []
    
    #-----< RL-DM-Rprt >-----#
    RL_DM_Rprt = SEQ(name='RL-DM-Rprt', mode=MODE_TYPE)
    _RL_DM_Rprt_rL_InformationList_DM_Rprt = SEQ_OF(name='rL-InformationList-DM-Rprt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-DM-Rprt')))
    _RL_DM_Rprt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_DM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_DM_Rprt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_DM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rprt_iE_Extensions__item__id._const_tab = ____RL_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_DM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___RL_DM_Rprt_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_DM_Rprt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_DM_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rprt_iE_Extensions__item__criticality._const_tab = ____RL_DM_Rprt_iE_Extensions__item__criticality_tab
    ___RL_DM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_DM_Rprt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_DM_Rprt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_DM_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____RL_DM_Rprt_iE_Extensions__item__extensionValue_tab
    ___RL_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_DM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_DM_Rprt_iE_Extensions__item__id),
        ('criticality', ___RL_DM_Rprt_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_DM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __RL_DM_Rprt_iE_Extensions__item_._ext = None
    _RL_DM_Rprt_iE_Extensions._cont = __RL_DM_Rprt_iE_Extensions__item_
    _RL_DM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_DM_Rprt._cont = ASN1Dict([
        ('rL-InformationList-DM-Rprt', _RL_DM_Rprt_rL_InformationList_DM_Rprt),
        ('iE-Extensions', _RL_DM_Rprt_iE_Extensions),
        ])
    RL_DM_Rprt._ext = []
    
    #-----< RLItem-DM-Rprt-ExtIEs >-----#
    RLItem_DM_Rprt_ExtIEs = CLASS(name='RLItem-DM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RLItem_DM_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-DM-Rprt >-----#
    RL_InformationList_DM_Rprt = SEQ_OF(name='RL-InformationList-DM-Rprt', mode=MODE_TYPE)
    _RL_InformationList_DM_Rprt__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_DM_Rprt__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationList_DM_Rprt__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationList_DM_Rprt__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-DM-Rprt')))
    ___RL_InformationList_DM_Rprt__item__id_tab._val = ASN1Set(rv=[dict([('id', 202), ('criticality', 'ignore'), ('Value', ____RL_InformationList_DM_Rprt__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_DM_Rprt__item__id._const_tab = ___RL_InformationList_DM_Rprt__item__id_tab
    __RL_InformationList_DM_Rprt__item__id._const_tab_at = None
    __RL_InformationList_DM_Rprt__item__id._const_tab_id = 'id'
    __RL_InformationList_DM_Rprt__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationList_DM_Rprt__item__criticality._const_tab = ___RL_InformationList_DM_Rprt__item__id_tab
    __RL_InformationList_DM_Rprt__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationList_DM_Rprt__item__criticality._const_tab_id = 'criticality'
    __RL_InformationList_DM_Rprt__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationList_DM_Rprt__item__value._const_tab = ___RL_InformationList_DM_Rprt__item__id_tab
    __RL_InformationList_DM_Rprt__item__value._const_tab_at = ('..', 'id')
    __RL_InformationList_DM_Rprt__item__value._const_tab_id = 'Value'
    _RL_InformationList_DM_Rprt__item_._cont = ASN1Dict([
        ('id', __RL_InformationList_DM_Rprt__item__id),
        ('criticality', __RL_InformationList_DM_Rprt__item__criticality),
        ('value', __RL_InformationList_DM_Rprt__item__value),
        ])
    _RL_InformationList_DM_Rprt__item_._ext = None
    RL_InformationList_DM_Rprt._cont = _RL_InformationList_DM_Rprt__item_
    RL_InformationList_DM_Rprt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIE-DM-Rprt >-----#
    RL_InformationItemIE_DM_Rprt = CLASS(name='RL-InformationItemIE-DM-Rprt', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationItemIE_DM_Rprt_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-DM-Rprt')))
    RL_InformationItemIE_DM_Rprt._val = ASN1Set(rv=[dict([('id', 202), ('criticality', 'ignore'), ('Value', _RL_InformationItemIE_DM_Rprt_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-DM-Rprt >-----#
    RL_InformationItem_DM_Rprt = SEQ(name='RL-InformationItem-DM-Rprt', mode=MODE_TYPE)
    _RL_InformationItem_DM_Rprt_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationItem_DM_Rprt_dPCH_ID = INT(name='dPCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID')), opt=True)
    _RL_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation = CHOICE(name='dedicatedMeasurementValueInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementValueInformation')))
    _RL_InformationItem_DM_Rprt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_DM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Info-DM-Rprt')))
    _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-PUSCH-InfoList-DM-Rprt')))
    _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID768')))
    _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 507), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 590), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 697), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 763), ('criticality', 'reject'), ('Extension', _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 936), ('criticality', 'ignore'), ('Extension', _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab = ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationItem_DM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id),
        ('criticality', ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_DM_Rprt_iE_Extensions__item_._ext = None
    _RL_InformationItem_DM_Rprt_iE_Extensions._cont = __RL_InformationItem_DM_Rprt_iE_Extensions__item_
    _RL_InformationItem_DM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_DM_Rprt._cont = ASN1Dict([
        ('rL-ID', _RL_InformationItem_DM_Rprt_rL_ID),
        ('dPCH-ID', _RL_InformationItem_DM_Rprt_dPCH_ID),
        ('dedicatedMeasurementValueInformation', _RL_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation),
        ('iE-Extensions', _RL_InformationItem_DM_Rprt_iE_Extensions),
        ])
    RL_InformationItem_DM_Rprt._ext = []
    
    #-----< RL-InformationItem-DM-Rprt-ExtIEs >-----#
    RL_InformationItem_DM_Rprt_ExtIEs = CLASS(name='RL-InformationItem-DM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Info-DM-Rprt')))
    _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-PUSCH-InfoList-DM-Rprt')))
    _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DPCH-ID768')))
    _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    RL_InformationItem_DM_Rprt_ExtIEs._val = ASN1Set(rv=[dict([('id', 507), ('criticality', 'reject'), ('Extension', _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 590), ('criticality', 'reject'), ('Extension', _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 697), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 763), ('criticality', 'reject'), ('Extension', _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 936), ('criticality', 'ignore'), ('Extension', _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PUSCH-Info-DM-Rprt >-----#
    PUSCH_Info_DM_Rprt = SEQ_OF(name='PUSCH-Info-DM-Rprt', mode=MODE_TYPE)
    _PUSCH_Info_DM_Rprt__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'PUSCH-ID')))
    PUSCH_Info_DM_Rprt._cont = _PUSCH_Info_DM_Rprt__item_
    PUSCH_Info_DM_Rprt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< Multiple-PUSCH-InfoList-DM-Rprt >-----#
    Multiple_PUSCH_InfoList_DM_Rprt = SEQ_OF(name='Multiple-PUSCH-InfoList-DM-Rprt', mode=MODE_TYPE)
    _Multiple_PUSCH_InfoList_DM_Rprt__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Multiple-PUSCH-InfoListIE-DM-Rprt')))
    Multiple_PUSCH_InfoList_DM_Rprt._cont = _Multiple_PUSCH_InfoList_DM_Rprt__item_
    Multiple_PUSCH_InfoList_DM_Rprt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< Multiple-PUSCH-InfoListIE-DM-Rprt >-----#
    Multiple_PUSCH_InfoListIE_DM_Rprt = SEQ(name='Multiple-PUSCH-InfoListIE-DM-Rprt', mode=MODE_TYPE)
    _Multiple_PUSCH_InfoListIE_DM_Rprt_pUSCH_ID = INT(name='pUSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCH-ID')), opt=True)
    _Multiple_PUSCH_InfoListIE_DM_Rprt_dedicatedMeasurementValue = CHOICE(name='dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementValue')), opt=True)
    _Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__id._const_tab = ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__id_tab
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__id._const_tab_id = 'id'
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__criticality._const_tab = ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__criticality_tab
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__extensionValue_tab
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__id),
        ('criticality', ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__criticality),
        ('extensionValue', ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item_._ext = None
    _Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions._cont = __Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item_
    _Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiple_PUSCH_InfoListIE_DM_Rprt._cont = ASN1Dict([
        ('pUSCH-ID', _Multiple_PUSCH_InfoListIE_DM_Rprt_pUSCH_ID),
        ('dedicatedMeasurementValue', _Multiple_PUSCH_InfoListIE_DM_Rprt_dedicatedMeasurementValue),
        ('iE-Extensions', _Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions),
        ])
    Multiple_PUSCH_InfoListIE_DM_Rprt._ext = []
    
    #-----< Multiple-PUSCH-InfoListIE-DM-Rprt-ExtIEs >-----#
    Multiple_PUSCH_InfoListIE_DM_Rprt_ExtIEs = CLASS(name='Multiple-PUSCH-InfoListIE-DM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Multiple_PUSCH_InfoListIE_DM_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-DM-Rprt >-----#
    RL_Set_DM_Rprt = SEQ(name='RL-Set-DM-Rprt', mode=MODE_TYPE)
    _RL_Set_DM_Rprt_rL_Set_InformationList_DM_Rprt = SEQ_OF(name='rL-Set-InformationList-DM-Rprt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationList-DM-Rprt')))
    _RL_Set_DM_Rprt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_DM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_DM_Rprt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Set_DM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rprt_iE_Extensions__item__id._const_tab = ____RL_Set_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_Set_DM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_DM_Rprt_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Set_DM_Rprt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Set_DM_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rprt_iE_Extensions__item__criticality._const_tab = ____RL_Set_DM_Rprt_iE_Extensions__item__criticality_tab
    ___RL_Set_DM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Set_DM_Rprt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Set_DM_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_DM_Rprt_iE_Extensions__item__extensionValue_tab
    ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Set_DM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Set_DM_Rprt_iE_Extensions__item__id),
        ('criticality', ___RL_Set_DM_Rprt_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_DM_Rprt_iE_Extensions__item_._ext = None
    _RL_Set_DM_Rprt_iE_Extensions._cont = __RL_Set_DM_Rprt_iE_Extensions__item_
    _RL_Set_DM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_DM_Rprt._cont = ASN1Dict([
        ('rL-Set-InformationList-DM-Rprt', _RL_Set_DM_Rprt_rL_Set_InformationList_DM_Rprt),
        ('iE-Extensions', _RL_Set_DM_Rprt_iE_Extensions),
        ])
    RL_Set_DM_Rprt._ext = []
    
    #-----< RL-SetItem-DM-Rprt-ExtIEs >-----#
    RL_SetItem_DM_Rprt_ExtIEs = CLASS(name='RL-SetItem-DM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_SetItem_DM_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-InformationList-DM-Rprt >-----#
    RL_Set_InformationList_DM_Rprt = SEQ_OF(name='RL-Set-InformationList-DM-Rprt', mode=MODE_TYPE)
    _RL_Set_InformationList_DM_Rprt__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_InformationList_DM_Rprt__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_Set_InformationList_DM_Rprt__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_Set_InformationList_DM_Rprt__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationItem-DM-Rprt')))
    ___RL_Set_InformationList_DM_Rprt__item__id_tab._val = ASN1Set(rv=[dict([('id', 238), ('criticality', 'ignore'), ('Value', ____RL_Set_InformationList_DM_Rprt__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_InformationList_DM_Rprt__item__id._const_tab = ___RL_Set_InformationList_DM_Rprt__item__id_tab
    __RL_Set_InformationList_DM_Rprt__item__id._const_tab_at = None
    __RL_Set_InformationList_DM_Rprt__item__id._const_tab_id = 'id'
    __RL_Set_InformationList_DM_Rprt__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_Set_InformationList_DM_Rprt__item__criticality._const_tab = ___RL_Set_InformationList_DM_Rprt__item__id_tab
    __RL_Set_InformationList_DM_Rprt__item__criticality._const_tab_at = ('..', 'id')
    __RL_Set_InformationList_DM_Rprt__item__criticality._const_tab_id = 'criticality'
    __RL_Set_InformationList_DM_Rprt__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_Set_InformationList_DM_Rprt__item__value._const_tab = ___RL_Set_InformationList_DM_Rprt__item__id_tab
    __RL_Set_InformationList_DM_Rprt__item__value._const_tab_at = ('..', 'id')
    __RL_Set_InformationList_DM_Rprt__item__value._const_tab_id = 'Value'
    _RL_Set_InformationList_DM_Rprt__item_._cont = ASN1Dict([
        ('id', __RL_Set_InformationList_DM_Rprt__item__id),
        ('criticality', __RL_Set_InformationList_DM_Rprt__item__criticality),
        ('value', __RL_Set_InformationList_DM_Rprt__item__value),
        ])
    _RL_Set_InformationList_DM_Rprt__item_._ext = None
    RL_Set_InformationList_DM_Rprt._cont = _RL_Set_InformationList_DM_Rprt__item_
    RL_Set_InformationList_DM_Rprt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-InformationItemIE-DM-Rprt >-----#
    RL_Set_InformationItemIE_DM_Rprt = CLASS(name='RL-Set-InformationItemIE-DM-Rprt', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_Set_InformationItemIE_DM_Rprt_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationItem-DM-Rprt')))
    RL_Set_InformationItemIE_DM_Rprt._val = ASN1Set(rv=[dict([('id', 238), ('criticality', 'ignore'), ('Value', _RL_Set_InformationItemIE_DM_Rprt_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-InformationItem-DM-Rprt >-----#
    RL_Set_InformationItem_DM_Rprt = SEQ(name='RL-Set-InformationItem-DM-Rprt', mode=MODE_TYPE)
    _RL_Set_InformationItem_DM_Rprt_rL_Set_ID = INT(name='rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _RL_Set_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation = CHOICE(name='dedicatedMeasurementValueInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DedicatedMeasurementValueInformation')))
    _RL_Set_InformationItem_DM_Rprt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_InformationItem_DM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab = ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab = ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality_tab
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue_tab
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Set_InformationItem_DM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id),
        ('criticality', ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_InformationItem_DM_Rprt_iE_Extensions__item_._ext = None
    _RL_Set_InformationItem_DM_Rprt_iE_Extensions._cont = __RL_Set_InformationItem_DM_Rprt_iE_Extensions__item_
    _RL_Set_InformationItem_DM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_InformationItem_DM_Rprt._cont = ASN1Dict([
        ('rL-Set-ID', _RL_Set_InformationItem_DM_Rprt_rL_Set_ID),
        ('dedicatedMeasurementValueInformation', _RL_Set_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation),
        ('iE-Extensions', _RL_Set_InformationItem_DM_Rprt_iE_Extensions),
        ])
    RL_Set_InformationItem_DM_Rprt._ext = []
    
    #-----< RL-Set-InformationItem-DM-Rprt-ExtIEs >-----#
    RL_Set_InformationItem_DM_Rprt_ExtIEs = CLASS(name='RL-Set-InformationItem-DM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_Set_InformationItem_DM_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementTerminationRequest >-----#
    DedicatedMeasurementTerminationRequest = SEQ(name='DedicatedMeasurementTerminationRequest', mode=MODE_TYPE)
    _DedicatedMeasurementTerminationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementTerminationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id._const_tab = ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value._const_tab = ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __DedicatedMeasurementTerminationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id),
        ('criticality', ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality),
        ('value', ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value),
        ])
    __DedicatedMeasurementTerminationRequest_protocolIEs__item_._ext = None
    _DedicatedMeasurementTerminationRequest_protocolIEs._cont = __DedicatedMeasurementTerminationRequest_protocolIEs__item_
    _DedicatedMeasurementTerminationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementTerminationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementTerminationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__id_tab
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality_tab
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DedicatedMeasurementTerminationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id),
        ('criticality', ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementTerminationRequest_protocolExtensions__item_._ext = None
    _DedicatedMeasurementTerminationRequest_protocolExtensions._cont = __DedicatedMeasurementTerminationRequest_protocolExtensions__item_
    _DedicatedMeasurementTerminationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementTerminationRequest._cont = ASN1Dict([
        ('protocolIEs', _DedicatedMeasurementTerminationRequest_protocolIEs),
        ('protocolExtensions', _DedicatedMeasurementTerminationRequest_protocolExtensions),
        ])
    DedicatedMeasurementTerminationRequest._ext = []
    
    #-----< DedicatedMeasurementTerminationRequest-IEs >-----#
    DedicatedMeasurementTerminationRequest_IEs = CLASS(name='DedicatedMeasurementTerminationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DedicatedMeasurementTerminationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _DedicatedMeasurementTerminationRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    DedicatedMeasurementTerminationRequest_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementTerminationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementTerminationRequest_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementTerminationRequest-Extensions >-----#
    DedicatedMeasurementTerminationRequest_Extensions = CLASS(name='DedicatedMeasurementTerminationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DedicatedMeasurementTerminationRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementFailureIndication >-----#
    DedicatedMeasurementFailureIndication = SEQ(name='DedicatedMeasurementFailureIndication', mode=MODE_TYPE)
    _DedicatedMeasurementFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __DedicatedMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementFailureIndication_protocolIEs__item__id),
        ('criticality', ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality),
        ('value', ___DedicatedMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __DedicatedMeasurementFailureIndication_protocolIEs__item_._ext = None
    _DedicatedMeasurementFailureIndication_protocolIEs._cont = __DedicatedMeasurementFailureIndication_protocolIEs__item_
    _DedicatedMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementFailureIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementFailureIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality_tab
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DedicatedMeasurementFailureIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id),
        ('criticality', ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementFailureIndication_protocolExtensions__item_._ext = None
    _DedicatedMeasurementFailureIndication_protocolExtensions._cont = __DedicatedMeasurementFailureIndication_protocolExtensions__item_
    _DedicatedMeasurementFailureIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _DedicatedMeasurementFailureIndication_protocolIEs),
        ('protocolExtensions', _DedicatedMeasurementFailureIndication_protocolExtensions),
        ])
    DedicatedMeasurementFailureIndication._ext = []
    
    #-----< DedicatedMeasurementFailureIndication-IEs >-----#
    DedicatedMeasurementFailureIndication_IEs = CLASS(name='DedicatedMeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DedicatedMeasurementFailureIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _DedicatedMeasurementFailureIndication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _DedicatedMeasurementFailureIndication_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    DedicatedMeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementFailureIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementFailureIndication_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _DedicatedMeasurementFailureIndication_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementFailureIndication-Extensions >-----#
    DedicatedMeasurementFailureIndication_Extensions = CLASS(name='DedicatedMeasurementFailureIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DedicatedMeasurementFailureIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkFailureIndication >-----#
    RadioLinkFailureIndication = SEQ(name='RadioLinkFailureIndication', mode=MODE_TYPE)
    _RadioLinkFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkFailureIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Reporting-Object-RL-FailureInd')))
    ____RadioLinkFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 199), ('criticality', 'ignore'), ('Value', _____RadioLinkFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkFailureIndication_protocolIEs__item__id._const_tab = ____RadioLinkFailureIndication_protocolIEs__item__id_tab
    ___RadioLinkFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkFailureIndication_protocolIEs__item__criticality._const_tab = ____RadioLinkFailureIndication_protocolIEs__item__id_tab
    ___RadioLinkFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkFailureIndication_protocolIEs__item__value._const_tab = ____RadioLinkFailureIndication_protocolIEs__item__id_tab
    ___RadioLinkFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkFailureIndication_protocolIEs__item__id),
        ('criticality', ___RadioLinkFailureIndication_protocolIEs__item__criticality),
        ('value', ___RadioLinkFailureIndication_protocolIEs__item__value),
        ])
    __RadioLinkFailureIndication_protocolIEs__item_._ext = None
    _RadioLinkFailureIndication_protocolIEs._cont = __RadioLinkFailureIndication_protocolIEs__item_
    _RadioLinkFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkFailureIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkFailureIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkFailureIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkFailureIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkFailureIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkFailureIndication_protocolExtensions__item__id._const_tab = ____RadioLinkFailureIndication_protocolExtensions__item__id_tab
    ___RadioLinkFailureIndication_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkFailureIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkFailureIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkFailureIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkFailureIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkFailureIndication_protocolExtensions__item__criticality._const_tab = ____RadioLinkFailureIndication_protocolExtensions__item__criticality_tab
    ___RadioLinkFailureIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkFailureIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkFailureIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkFailureIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkFailureIndication_protocolExtensions__item__extensionValue_tab
    ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkFailureIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkFailureIndication_protocolExtensions__item__id),
        ('criticality', ___RadioLinkFailureIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkFailureIndication_protocolExtensions__item_._ext = None
    _RadioLinkFailureIndication_protocolExtensions._cont = __RadioLinkFailureIndication_protocolExtensions__item_
    _RadioLinkFailureIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkFailureIndication_protocolIEs),
        ('protocolExtensions', _RadioLinkFailureIndication_protocolExtensions),
        ])
    RadioLinkFailureIndication._ext = []
    
    #-----< RadioLinkFailureIndication-IEs >-----#
    RadioLinkFailureIndication_IEs = CLASS(name='RadioLinkFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkFailureIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkFailureIndication_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Reporting-Object-RL-FailureInd')))
    RadioLinkFailureIndication_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkFailureIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 199), ('criticality', 'ignore'), ('Value', _RadioLinkFailureIndication_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkFailureIndication-Extensions >-----#
    RadioLinkFailureIndication_Extensions = CLASS(name='RadioLinkFailureIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkFailureIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Reporting-Object-RL-FailureInd >-----#
    Reporting_Object_RL_FailureInd = CHOICE(name='Reporting-Object-RL-FailureInd', mode=MODE_TYPE)
    _Reporting_Object_RL_FailureInd_rL = SEQ(name='rL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-RL-FailureInd')))
    _Reporting_Object_RL_FailureInd_rL_Set = SEQ(name='rL-Set', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-RL-FailureInd')))
    _Reporting_Object_RL_FailureInd_cCTrCH = SEQ(name='cCTrCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-RL-FailureInd')))
    Reporting_Object_RL_FailureInd._cont = ASN1Dict([
        ('rL', _Reporting_Object_RL_FailureInd_rL),
        ('rL-Set', _Reporting_Object_RL_FailureInd_rL_Set),
        ('cCTrCH', _Reporting_Object_RL_FailureInd_cCTrCH),
        ])
    Reporting_Object_RL_FailureInd._ext = ['cCTrCH']
    
    #-----< RL-RL-FailureInd >-----#
    RL_RL_FailureInd = SEQ(name='RL-RL-FailureInd', mode=MODE_TYPE)
    _RL_RL_FailureInd_rL_InformationList_RL_FailureInd = SEQ_OF(name='rL-InformationList-RL-FailureInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-FailureInd')))
    _RL_RL_FailureInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_RL_FailureInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_FailureInd_iE_Extensions__item__id._const_tab = ____RL_RL_FailureInd_iE_Extensions__item__id_tab
    ___RL_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_RL_FailureInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____RL_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___RL_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____RL_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___RL_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_RL_FailureInd_iE_Extensions__item__id),
        ('criticality', ___RL_RL_FailureInd_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __RL_RL_FailureInd_iE_Extensions__item_._ext = None
    _RL_RL_FailureInd_iE_Extensions._cont = __RL_RL_FailureInd_iE_Extensions__item_
    _RL_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_RL_FailureInd._cont = ASN1Dict([
        ('rL-InformationList-RL-FailureInd', _RL_RL_FailureInd_rL_InformationList_RL_FailureInd),
        ('iE-Extensions', _RL_RL_FailureInd_iE_Extensions),
        ])
    RL_RL_FailureInd._ext = []
    
    #-----< RLItem-RL-FailureInd-ExtIEs >-----#
    RLItem_RL_FailureInd_ExtIEs = CLASS(name='RLItem-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RLItem_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-FailureInd >-----#
    RL_InformationList_RL_FailureInd = SEQ_OF(name='RL-InformationList-RL-FailureInd', mode=MODE_TYPE)
    _RL_InformationList_RL_FailureInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_FailureInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationList_RL_FailureInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_FailureInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-FailureInd')))
    ___RL_InformationList_RL_FailureInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 207), ('criticality', 'ignore'), ('Value', ____RL_InformationList_RL_FailureInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_FailureInd__item__id._const_tab = ___RL_InformationList_RL_FailureInd__item__id_tab
    __RL_InformationList_RL_FailureInd__item__id._const_tab_at = None
    __RL_InformationList_RL_FailureInd__item__id._const_tab_id = 'id'
    __RL_InformationList_RL_FailureInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationList_RL_FailureInd__item__criticality._const_tab = ___RL_InformationList_RL_FailureInd__item__id_tab
    __RL_InformationList_RL_FailureInd__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_FailureInd__item__criticality._const_tab_id = 'criticality'
    __RL_InformationList_RL_FailureInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationList_RL_FailureInd__item__value._const_tab = ___RL_InformationList_RL_FailureInd__item__id_tab
    __RL_InformationList_RL_FailureInd__item__value._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_FailureInd__item__value._const_tab_id = 'Value'
    _RL_InformationList_RL_FailureInd__item_._cont = ASN1Dict([
        ('id', __RL_InformationList_RL_FailureInd__item__id),
        ('criticality', __RL_InformationList_RL_FailureInd__item__criticality),
        ('value', __RL_InformationList_RL_FailureInd__item__value),
        ])
    _RL_InformationList_RL_FailureInd__item_._ext = None
    RL_InformationList_RL_FailureInd._cont = _RL_InformationList_RL_FailureInd__item_
    RL_InformationList_RL_FailureInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIE-RL-FailureInd >-----#
    RL_InformationItemIE_RL_FailureInd = CLASS(name='RL-InformationItemIE-RL-FailureInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationItemIE_RL_FailureInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-FailureInd')))
    RL_InformationItemIE_RL_FailureInd._val = ASN1Set(rv=[dict([('id', 207), ('criticality', 'ignore'), ('Value', _RL_InformationItemIE_RL_FailureInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-RL-FailureInd >-----#
    RL_InformationItem_RL_FailureInd = SEQ(name='RL-InformationItem-RL-FailureInd', mode=MODE_TYPE)
    _RL_InformationItem_RL_FailureInd_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationItem_RL_FailureInd_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _RL_InformationItem_RL_FailureInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab = ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationItem_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__id),
        ('criticality', ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_RL_FailureInd_iE_Extensions__item_._ext = None
    _RL_InformationItem_RL_FailureInd_iE_Extensions._cont = __RL_InformationItem_RL_FailureInd_iE_Extensions__item_
    _RL_InformationItem_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_RL_FailureInd._cont = ASN1Dict([
        ('rL-ID', _RL_InformationItem_RL_FailureInd_rL_ID),
        ('cause', _RL_InformationItem_RL_FailureInd_cause),
        ('iE-Extensions', _RL_InformationItem_RL_FailureInd_iE_Extensions),
        ])
    RL_InformationItem_RL_FailureInd._ext = []
    
    #-----< RL-InformationItem-RL-FailureInd-ExtIEs >-----#
    RL_InformationItem_RL_FailureInd_ExtIEs = CLASS(name='RL-InformationItem-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_InformationItem_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-RL-FailureInd >-----#
    RL_Set_RL_FailureInd = SEQ(name='RL-Set-RL-FailureInd', mode=MODE_TYPE)
    _RL_Set_RL_FailureInd_rL_Set_InformationList_RL_FailureInd = SEQ_OF(name='rL-Set-InformationList-RL-FailureInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationList-RL-FailureInd')))
    _RL_Set_RL_FailureInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_RL_FailureInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_FailureInd_iE_Extensions__item__id._const_tab = ____RL_Set_RL_FailureInd_iE_Extensions__item__id_tab
    ___RL_Set_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_RL_FailureInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____RL_Set_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Set_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Set_RL_FailureInd_iE_Extensions__item__id),
        ('criticality', ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_RL_FailureInd_iE_Extensions__item_._ext = None
    _RL_Set_RL_FailureInd_iE_Extensions._cont = __RL_Set_RL_FailureInd_iE_Extensions__item_
    _RL_Set_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_RL_FailureInd._cont = ASN1Dict([
        ('rL-Set-InformationList-RL-FailureInd', _RL_Set_RL_FailureInd_rL_Set_InformationList_RL_FailureInd),
        ('iE-Extensions', _RL_Set_RL_FailureInd_iE_Extensions),
        ])
    RL_Set_RL_FailureInd._ext = []
    
    #-----< RL-SetItem-RL-FailureInd-ExtIEs >-----#
    RL_SetItem_RL_FailureInd_ExtIEs = CLASS(name='RL-SetItem-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_SetItem_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-InformationList-RL-FailureInd >-----#
    RL_Set_InformationList_RL_FailureInd = SEQ_OF(name='RL-Set-InformationList-RL-FailureInd', mode=MODE_TYPE)
    _RL_Set_InformationList_RL_FailureInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_InformationList_RL_FailureInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_Set_InformationList_RL_FailureInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_Set_InformationList_RL_FailureInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationItem-RL-FailureInd')))
    ___RL_Set_InformationList_RL_FailureInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 241), ('criticality', 'ignore'), ('Value', ____RL_Set_InformationList_RL_FailureInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_InformationList_RL_FailureInd__item__id._const_tab = ___RL_Set_InformationList_RL_FailureInd__item__id_tab
    __RL_Set_InformationList_RL_FailureInd__item__id._const_tab_at = None
    __RL_Set_InformationList_RL_FailureInd__item__id._const_tab_id = 'id'
    __RL_Set_InformationList_RL_FailureInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_Set_InformationList_RL_FailureInd__item__criticality._const_tab = ___RL_Set_InformationList_RL_FailureInd__item__id_tab
    __RL_Set_InformationList_RL_FailureInd__item__criticality._const_tab_at = ('..', 'id')
    __RL_Set_InformationList_RL_FailureInd__item__criticality._const_tab_id = 'criticality'
    __RL_Set_InformationList_RL_FailureInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_Set_InformationList_RL_FailureInd__item__value._const_tab = ___RL_Set_InformationList_RL_FailureInd__item__id_tab
    __RL_Set_InformationList_RL_FailureInd__item__value._const_tab_at = ('..', 'id')
    __RL_Set_InformationList_RL_FailureInd__item__value._const_tab_id = 'Value'
    _RL_Set_InformationList_RL_FailureInd__item_._cont = ASN1Dict([
        ('id', __RL_Set_InformationList_RL_FailureInd__item__id),
        ('criticality', __RL_Set_InformationList_RL_FailureInd__item__criticality),
        ('value', __RL_Set_InformationList_RL_FailureInd__item__value),
        ])
    _RL_Set_InformationList_RL_FailureInd__item_._ext = None
    RL_Set_InformationList_RL_FailureInd._cont = _RL_Set_InformationList_RL_FailureInd__item_
    RL_Set_InformationList_RL_FailureInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-InformationItemIE-RL-FailureInd >-----#
    RL_Set_InformationItemIE_RL_FailureInd = CLASS(name='RL-Set-InformationItemIE-RL-FailureInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_Set_InformationItemIE_RL_FailureInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationItem-RL-FailureInd')))
    RL_Set_InformationItemIE_RL_FailureInd._val = ASN1Set(rv=[dict([('id', 241), ('criticality', 'ignore'), ('Value', _RL_Set_InformationItemIE_RL_FailureInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-InformationItem-RL-FailureInd >-----#
    RL_Set_InformationItem_RL_FailureInd = SEQ(name='RL-Set-InformationItem-RL-FailureInd', mode=MODE_TYPE)
    _RL_Set_InformationItem_RL_FailureInd_rL_Set_ID = INT(name='rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _RL_Set_InformationItem_RL_FailureInd_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _RL_Set_InformationItem_RL_FailureInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab = ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__id),
        ('criticality', ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item_._ext = None
    _RL_Set_InformationItem_RL_FailureInd_iE_Extensions._cont = __RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item_
    _RL_Set_InformationItem_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_InformationItem_RL_FailureInd._cont = ASN1Dict([
        ('rL-Set-ID', _RL_Set_InformationItem_RL_FailureInd_rL_Set_ID),
        ('cause', _RL_Set_InformationItem_RL_FailureInd_cause),
        ('iE-Extensions', _RL_Set_InformationItem_RL_FailureInd_iE_Extensions),
        ])
    RL_Set_InformationItem_RL_FailureInd._ext = []
    
    #-----< RL-Set-InformationItem-RL-FailureInd-ExtIEs >-----#
    RL_Set_InformationItem_RL_FailureInd_ExtIEs = CLASS(name='RL-Set-InformationItem-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_Set_InformationItem_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-RL-FailureInd >-----#
    CCTrCH_RL_FailureInd = SEQ(name='CCTrCH-RL-FailureInd', mode=MODE_TYPE)
    _CCTrCH_RL_FailureInd_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _CCTrCH_RL_FailureInd_cCTrCH_InformationList_RL_FailureInd = SEQ_OF(name='cCTrCH-InformationList-RL-FailureInd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-InformationList-RL-FailureInd')))
    _CCTrCH_RL_FailureInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__id._const_tab = ____CCTrCH_RL_FailureInd_iE_Extensions__item__id_tab
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____CCTrCH_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CCTrCH_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CCTrCH_RL_FailureInd_iE_Extensions__item__id),
        ('criticality', ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality),
        ('extensionValue', ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_RL_FailureInd_iE_Extensions__item_._ext = None
    _CCTrCH_RL_FailureInd_iE_Extensions._cont = __CCTrCH_RL_FailureInd_iE_Extensions__item_
    _CCTrCH_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_RL_FailureInd._cont = ASN1Dict([
        ('rL-ID', _CCTrCH_RL_FailureInd_rL_ID),
        ('cCTrCH-InformationList-RL-FailureInd', _CCTrCH_RL_FailureInd_cCTrCH_InformationList_RL_FailureInd),
        ('iE-Extensions', _CCTrCH_RL_FailureInd_iE_Extensions),
        ])
    CCTrCH_RL_FailureInd._ext = []
    
    #-----< CCTrCHItem-RL-FailureInd-ExtIEs >-----#
    CCTrCHItem_RL_FailureInd_ExtIEs = CLASS(name='CCTrCHItem-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CCTrCHItem_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-InformationList-RL-FailureInd >-----#
    CCTrCH_InformationList_RL_FailureInd = SEQ_OF(name='CCTrCH-InformationList-RL-FailureInd', mode=MODE_TYPE)
    _CCTrCH_InformationList_RL_FailureInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __CCTrCH_InformationList_RL_FailureInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___CCTrCH_InformationList_RL_FailureInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____CCTrCH_InformationList_RL_FailureInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-InformationItem-RL-FailureInd')))
    ___CCTrCH_InformationList_RL_FailureInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 46), ('criticality', 'ignore'), ('Value', ____CCTrCH_InformationList_RL_FailureInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CCTrCH_InformationList_RL_FailureInd__item__id._const_tab = ___CCTrCH_InformationList_RL_FailureInd__item__id_tab
    __CCTrCH_InformationList_RL_FailureInd__item__id._const_tab_at = None
    __CCTrCH_InformationList_RL_FailureInd__item__id._const_tab_id = 'id'
    __CCTrCH_InformationList_RL_FailureInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __CCTrCH_InformationList_RL_FailureInd__item__criticality._const_tab = ___CCTrCH_InformationList_RL_FailureInd__item__id_tab
    __CCTrCH_InformationList_RL_FailureInd__item__criticality._const_tab_at = ('..', 'id')
    __CCTrCH_InformationList_RL_FailureInd__item__criticality._const_tab_id = 'criticality'
    __CCTrCH_InformationList_RL_FailureInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __CCTrCH_InformationList_RL_FailureInd__item__value._const_tab = ___CCTrCH_InformationList_RL_FailureInd__item__id_tab
    __CCTrCH_InformationList_RL_FailureInd__item__value._const_tab_at = ('..', 'id')
    __CCTrCH_InformationList_RL_FailureInd__item__value._const_tab_id = 'Value'
    _CCTrCH_InformationList_RL_FailureInd__item_._cont = ASN1Dict([
        ('id', __CCTrCH_InformationList_RL_FailureInd__item__id),
        ('criticality', __CCTrCH_InformationList_RL_FailureInd__item__criticality),
        ('value', __CCTrCH_InformationList_RL_FailureInd__item__value),
        ])
    _CCTrCH_InformationList_RL_FailureInd__item_._ext = None
    CCTrCH_InformationList_RL_FailureInd._cont = _CCTrCH_InformationList_RL_FailureInd__item_
    CCTrCH_InformationList_RL_FailureInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CCTrCH-InformationItemIE-RL-FailureInd >-----#
    CCTrCH_InformationItemIE_RL_FailureInd = CLASS(name='CCTrCH-InformationItemIE-RL-FailureInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CCTrCH_InformationItemIE_RL_FailureInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-InformationItem-RL-FailureInd')))
    CCTrCH_InformationItemIE_RL_FailureInd._val = ASN1Set(rv=[dict([('id', 46), ('criticality', 'ignore'), ('Value', _CCTrCH_InformationItemIE_RL_FailureInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CCTrCH-InformationItem-RL-FailureInd >-----#
    CCTrCH_InformationItem_RL_FailureInd = SEQ(name='CCTrCH-InformationItem-RL-FailureInd', mode=MODE_TYPE)
    _CCTrCH_InformationItem_RL_FailureInd_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _CCTrCH_InformationItem_RL_FailureInd_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _CCTrCH_InformationItem_RL_FailureInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab = ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id),
        ('criticality', ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality),
        ('extensionValue', ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item_._ext = None
    _CCTrCH_InformationItem_RL_FailureInd_iE_Extensions._cont = __CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item_
    _CCTrCH_InformationItem_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_InformationItem_RL_FailureInd._cont = ASN1Dict([
        ('cCTrCH-ID', _CCTrCH_InformationItem_RL_FailureInd_cCTrCH_ID),
        ('cause', _CCTrCH_InformationItem_RL_FailureInd_cause),
        ('iE-Extensions', _CCTrCH_InformationItem_RL_FailureInd_iE_Extensions),
        ])
    CCTrCH_InformationItem_RL_FailureInd._ext = []
    
    #-----< CCTrCH-InformationItem-RL-FailureInd-ExtIEs >-----#
    CCTrCH_InformationItem_RL_FailureInd_ExtIEs = CLASS(name='CCTrCH-InformationItem-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CCTrCH_InformationItem_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkPreemptionRequiredIndication >-----#
    RadioLinkPreemptionRequiredIndication = SEQ(name='RadioLinkPreemptionRequiredIndication', mode=MODE_TYPE)
    _RadioLinkPreemptionRequiredIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkPreemptionRequiredIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-PreemptRequiredInd')))
    ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 237), ('criticality', 'ignore'), ('Value', _____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkPreemptionRequiredIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id),
        ('criticality', ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality),
        ('value', ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value),
        ])
    __RadioLinkPreemptionRequiredIndication_protocolIEs__item_._ext = None
    _RadioLinkPreemptionRequiredIndication_protocolIEs._cont = __RadioLinkPreemptionRequiredIndication_protocolIEs__item_
    _RadioLinkPreemptionRequiredIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkPreemptionRequiredIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkPreemptionRequiredIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality_tab
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue_tab
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkPreemptionRequiredIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id),
        ('criticality', ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkPreemptionRequiredIndication_protocolExtensions__item_._ext = None
    _RadioLinkPreemptionRequiredIndication_protocolExtensions._cont = __RadioLinkPreemptionRequiredIndication_protocolExtensions__item_
    _RadioLinkPreemptionRequiredIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkPreemptionRequiredIndication._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkPreemptionRequiredIndication_protocolIEs),
        ('protocolExtensions', _RadioLinkPreemptionRequiredIndication_protocolExtensions),
        ])
    RadioLinkPreemptionRequiredIndication._ext = []
    
    #-----< RadioLinkPreemptionRequiredIndication-IEs >-----#
    RadioLinkPreemptionRequiredIndication_IEs = CLASS(name='RadioLinkPreemptionRequiredIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkPreemptionRequiredIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkPreemptionRequiredIndication_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-PreemptRequiredInd')))
    RadioLinkPreemptionRequiredIndication_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkPreemptionRequiredIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 237), ('criticality', 'ignore'), ('Value', _RadioLinkPreemptionRequiredIndication_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkPreemptionRequiredIndication-Extensions >-----#
    RadioLinkPreemptionRequiredIndication_Extensions = CLASS(name='RadioLinkPreemptionRequiredIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkPreemptionRequiredIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-PreemptRequiredInd >-----#
    RL_InformationList_RL_PreemptRequiredInd = SEQ_OF(name='RL-InformationList-RL-PreemptRequiredInd', mode=MODE_TYPE)
    _RL_InformationList_RL_PreemptRequiredInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_PreemptRequiredInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-PreemptRequiredInd')))
    ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 286), ('criticality', 'ignore'), ('Value', ____RL_InformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_PreemptRequiredInd__item__id._const_tab = ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab
    __RL_InformationList_RL_PreemptRequiredInd__item__id._const_tab_at = None
    __RL_InformationList_RL_PreemptRequiredInd__item__id._const_tab_id = 'id'
    __RL_InformationList_RL_PreemptRequiredInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationList_RL_PreemptRequiredInd__item__criticality._const_tab = ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab
    __RL_InformationList_RL_PreemptRequiredInd__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_PreemptRequiredInd__item__criticality._const_tab_id = 'criticality'
    __RL_InformationList_RL_PreemptRequiredInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationList_RL_PreemptRequiredInd__item__value._const_tab = ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab
    __RL_InformationList_RL_PreemptRequiredInd__item__value._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_PreemptRequiredInd__item__value._const_tab_id = 'Value'
    _RL_InformationList_RL_PreemptRequiredInd__item_._cont = ASN1Dict([
        ('id', __RL_InformationList_RL_PreemptRequiredInd__item__id),
        ('criticality', __RL_InformationList_RL_PreemptRequiredInd__item__criticality),
        ('value', __RL_InformationList_RL_PreemptRequiredInd__item__value),
        ])
    _RL_InformationList_RL_PreemptRequiredInd__item_._ext = None
    RL_InformationList_RL_PreemptRequiredInd._cont = _RL_InformationList_RL_PreemptRequiredInd__item_
    RL_InformationList_RL_PreemptRequiredInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIE-RL-PreemptRequiredInd >-----#
    RL_InformationItemIE_RL_PreemptRequiredInd = CLASS(name='RL-InformationItemIE-RL-PreemptRequiredInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationItemIE_RL_PreemptRequiredInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-PreemptRequiredInd')))
    RL_InformationItemIE_RL_PreemptRequiredInd._val = ASN1Set(rv=[dict([('id', 286), ('criticality', 'ignore'), ('Value', _RL_InformationItemIE_RL_PreemptRequiredInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationItem-RL-PreemptRequiredInd >-----#
    RL_InformationItem_RL_PreemptRequiredInd = SEQ(name='RL-InformationItem-RL-PreemptRequiredInd', mode=MODE_TYPE)
    _RL_InformationItem_RL_PreemptRequiredInd_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab = ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id),
        ('criticality', ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item_._ext = None
    _RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions._cont = __RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item_
    _RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_RL_PreemptRequiredInd._cont = ASN1Dict([
        ('rL-ID', _RL_InformationItem_RL_PreemptRequiredInd_rL_ID),
        ('iE-Extensions', _RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions),
        ])
    RL_InformationItem_RL_PreemptRequiredInd._ext = []
    
    #-----< RL-InformationItem-RL-PreemptRequiredInd-ExtIEs >-----#
    RL_InformationItem_RL_PreemptRequiredInd_ExtIEs = CLASS(name='RL-InformationItem-RL-PreemptRequiredInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_InformationItem_RL_PreemptRequiredInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkRestoreIndication >-----#
    RadioLinkRestoreIndication = SEQ(name='RadioLinkRestoreIndication', mode=MODE_TYPE)
    _RadioLinkRestoreIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkRestoreIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkRestoreIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkRestoreIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkRestoreIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkRestoreIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Reporting-Object-RL-RestoreInd')))
    ____RadioLinkRestoreIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkRestoreIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 200), ('criticality', 'ignore'), ('Value', _____RadioLinkRestoreIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkRestoreIndication_protocolIEs__item__id._const_tab = ____RadioLinkRestoreIndication_protocolIEs__item__id_tab
    ___RadioLinkRestoreIndication_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkRestoreIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkRestoreIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkRestoreIndication_protocolIEs__item__criticality._const_tab = ____RadioLinkRestoreIndication_protocolIEs__item__id_tab
    ___RadioLinkRestoreIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkRestoreIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkRestoreIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkRestoreIndication_protocolIEs__item__value._const_tab = ____RadioLinkRestoreIndication_protocolIEs__item__id_tab
    ___RadioLinkRestoreIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkRestoreIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkRestoreIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkRestoreIndication_protocolIEs__item__id),
        ('criticality', ___RadioLinkRestoreIndication_protocolIEs__item__criticality),
        ('value', ___RadioLinkRestoreIndication_protocolIEs__item__value),
        ])
    __RadioLinkRestoreIndication_protocolIEs__item_._ext = None
    _RadioLinkRestoreIndication_protocolIEs._cont = __RadioLinkRestoreIndication_protocolIEs__item_
    _RadioLinkRestoreIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkRestoreIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkRestoreIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkRestoreIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkRestoreIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkRestoreIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkRestoreIndication_protocolExtensions__item__id._const_tab = ____RadioLinkRestoreIndication_protocolExtensions__item__id_tab
    ___RadioLinkRestoreIndication_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkRestoreIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkRestoreIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkRestoreIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkRestoreIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkRestoreIndication_protocolExtensions__item__criticality._const_tab = ____RadioLinkRestoreIndication_protocolExtensions__item__criticality_tab
    ___RadioLinkRestoreIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkRestoreIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkRestoreIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkRestoreIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkRestoreIndication_protocolExtensions__item__extensionValue_tab
    ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkRestoreIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkRestoreIndication_protocolExtensions__item__id),
        ('criticality', ___RadioLinkRestoreIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkRestoreIndication_protocolExtensions__item_._ext = None
    _RadioLinkRestoreIndication_protocolExtensions._cont = __RadioLinkRestoreIndication_protocolExtensions__item_
    _RadioLinkRestoreIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkRestoreIndication._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkRestoreIndication_protocolIEs),
        ('protocolExtensions', _RadioLinkRestoreIndication_protocolExtensions),
        ])
    RadioLinkRestoreIndication._ext = []
    
    #-----< RadioLinkRestoreIndication-IEs >-----#
    RadioLinkRestoreIndication_IEs = CLASS(name='RadioLinkRestoreIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkRestoreIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkRestoreIndication_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Reporting-Object-RL-RestoreInd')))
    RadioLinkRestoreIndication_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkRestoreIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 200), ('criticality', 'ignore'), ('Value', _RadioLinkRestoreIndication_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkRestoreIndication-Extensions >-----#
    RadioLinkRestoreIndication_Extensions = CLASS(name='RadioLinkRestoreIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkRestoreIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Reporting-Object-RL-RestoreInd >-----#
    Reporting_Object_RL_RestoreInd = CHOICE(name='Reporting-Object-RL-RestoreInd', mode=MODE_TYPE)
    _Reporting_Object_RL_RestoreInd_rL = SEQ(name='rL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-RL-RestoreInd')))
    _Reporting_Object_RL_RestoreInd_rL_Set = SEQ(name='rL-Set', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-RL-RestoreInd')))
    _Reporting_Object_RL_RestoreInd_cCTrCH = SEQ(name='cCTrCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-RL-RestoreInd')))
    Reporting_Object_RL_RestoreInd._cont = ASN1Dict([
        ('rL', _Reporting_Object_RL_RestoreInd_rL),
        ('rL-Set', _Reporting_Object_RL_RestoreInd_rL_Set),
        ('cCTrCH', _Reporting_Object_RL_RestoreInd_cCTrCH),
        ])
    Reporting_Object_RL_RestoreInd._ext = ['cCTrCH']
    
    #-----< RL-RL-RestoreInd >-----#
    RL_RL_RestoreInd = SEQ(name='RL-RL-RestoreInd', mode=MODE_TYPE)
    _RL_RL_RestoreInd_rL_InformationList_RL_RestoreInd = SEQ_OF(name='rL-InformationList-RL-RestoreInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationList-RL-RestoreInd')))
    _RL_RL_RestoreInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_RL_RestoreInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____RL_RL_RestoreInd_iE_Extensions__item__id_tab
    ___RL_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____RL_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___RL_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____RL_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_RL_RestoreInd_iE_Extensions__item__id),
        ('criticality', ___RL_RL_RestoreInd_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __RL_RL_RestoreInd_iE_Extensions__item_._ext = None
    _RL_RL_RestoreInd_iE_Extensions._cont = __RL_RL_RestoreInd_iE_Extensions__item_
    _RL_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_RL_RestoreInd._cont = ASN1Dict([
        ('rL-InformationList-RL-RestoreInd', _RL_RL_RestoreInd_rL_InformationList_RL_RestoreInd),
        ('iE-Extensions', _RL_RL_RestoreInd_iE_Extensions),
        ])
    RL_RL_RestoreInd._ext = []
    
    #-----< RLItem-RL-RestoreInd-ExtIEs >-----#
    RLItem_RL_RestoreInd_ExtIEs = CLASS(name='RLItem-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RLItem_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-RestoreInd >-----#
    RL_InformationList_RL_RestoreInd = SEQ_OF(name='RL-InformationList-RL-RestoreInd', mode=MODE_TYPE)
    _RL_InformationList_RL_RestoreInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_RestoreInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_InformationList_RL_RestoreInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_RestoreInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-RestoreInd')))
    ___RL_InformationList_RL_RestoreInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 210), ('criticality', 'ignore'), ('Value', ____RL_InformationList_RL_RestoreInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_RestoreInd__item__id._const_tab = ___RL_InformationList_RL_RestoreInd__item__id_tab
    __RL_InformationList_RL_RestoreInd__item__id._const_tab_at = None
    __RL_InformationList_RL_RestoreInd__item__id._const_tab_id = 'id'
    __RL_InformationList_RL_RestoreInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_InformationList_RL_RestoreInd__item__criticality._const_tab = ___RL_InformationList_RL_RestoreInd__item__id_tab
    __RL_InformationList_RL_RestoreInd__item__criticality._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_RestoreInd__item__criticality._const_tab_id = 'criticality'
    __RL_InformationList_RL_RestoreInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_InformationList_RL_RestoreInd__item__value._const_tab = ___RL_InformationList_RL_RestoreInd__item__id_tab
    __RL_InformationList_RL_RestoreInd__item__value._const_tab_at = ('..', 'id')
    __RL_InformationList_RL_RestoreInd__item__value._const_tab_id = 'Value'
    _RL_InformationList_RL_RestoreInd__item_._cont = ASN1Dict([
        ('id', __RL_InformationList_RL_RestoreInd__item__id),
        ('criticality', __RL_InformationList_RL_RestoreInd__item__criticality),
        ('value', __RL_InformationList_RL_RestoreInd__item__value),
        ])
    _RL_InformationList_RL_RestoreInd__item_._ext = None
    RL_InformationList_RL_RestoreInd._cont = _RL_InformationList_RL_RestoreInd__item_
    RL_InformationList_RL_RestoreInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIE-RL-RestoreInd >-----#
    RL_InformationItemIE_RL_RestoreInd = CLASS(name='RL-InformationItemIE-RL-RestoreInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_InformationItemIE_RL_RestoreInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-InformationItem-RL-RestoreInd')))
    RL_InformationItemIE_RL_RestoreInd._val = ASN1Set(rv=[dict([('id', 210), ('criticality', 'ignore'), ('Value', _RL_InformationItemIE_RL_RestoreInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-RL-RestoreInd >-----#
    RL_InformationItem_RL_RestoreInd = SEQ(name='RL-InformationItem-RL-RestoreInd', mode=MODE_TYPE)
    _RL_InformationItem_RL_RestoreInd_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _RL_InformationItem_RL_RestoreInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_InformationItem_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__id),
        ('criticality', ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_RL_RestoreInd_iE_Extensions__item_._ext = None
    _RL_InformationItem_RL_RestoreInd_iE_Extensions._cont = __RL_InformationItem_RL_RestoreInd_iE_Extensions__item_
    _RL_InformationItem_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_RL_RestoreInd._cont = ASN1Dict([
        ('rL-ID', _RL_InformationItem_RL_RestoreInd_rL_ID),
        ('iE-Extensions', _RL_InformationItem_RL_RestoreInd_iE_Extensions),
        ])
    RL_InformationItem_RL_RestoreInd._ext = []
    
    #-----< RL-InformationItem-RL-RestoreInd-ExtIEs >-----#
    RL_InformationItem_RL_RestoreInd_ExtIEs = CLASS(name='RL-InformationItem-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_InformationItem_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-RL-RestoreInd >-----#
    RL_Set_RL_RestoreInd = SEQ(name='RL-Set-RL-RestoreInd', mode=MODE_TYPE)
    _RL_Set_RL_RestoreInd_rL_Set_InformationList_RL_RestoreInd = SEQ_OF(name='rL-Set-InformationList-RL-RestoreInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationList-RL-RestoreInd')))
    _RL_Set_RL_RestoreInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____RL_Set_RL_RestoreInd_iE_Extensions__item__id_tab
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____RL_Set_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Set_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Set_RL_RestoreInd_iE_Extensions__item__id),
        ('criticality', ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_RL_RestoreInd_iE_Extensions__item_._ext = None
    _RL_Set_RL_RestoreInd_iE_Extensions._cont = __RL_Set_RL_RestoreInd_iE_Extensions__item_
    _RL_Set_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_RL_RestoreInd._cont = ASN1Dict([
        ('rL-Set-InformationList-RL-RestoreInd', _RL_Set_RL_RestoreInd_rL_Set_InformationList_RL_RestoreInd),
        ('iE-Extensions', _RL_Set_RL_RestoreInd_iE_Extensions),
        ])
    RL_Set_RL_RestoreInd._ext = []
    
    #-----< RL-SetItem-RL-RestoreInd-ExtIEs >-----#
    RL_SetItem_RL_RestoreInd_ExtIEs = CLASS(name='RL-SetItem-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_SetItem_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-InformationList-RL-RestoreInd >-----#
    RL_Set_InformationList_RL_RestoreInd = SEQ_OF(name='RL-Set-InformationList-RL-RestoreInd', mode=MODE_TYPE)
    _RL_Set_InformationList_RL_RestoreInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_InformationList_RL_RestoreInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___RL_Set_InformationList_RL_RestoreInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____RL_Set_InformationList_RL_RestoreInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationItem-RL-RestoreInd')))
    ___RL_Set_InformationList_RL_RestoreInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 242), ('criticality', 'ignore'), ('Value', ____RL_Set_InformationList_RL_RestoreInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_InformationList_RL_RestoreInd__item__id._const_tab = ___RL_Set_InformationList_RL_RestoreInd__item__id_tab
    __RL_Set_InformationList_RL_RestoreInd__item__id._const_tab_at = None
    __RL_Set_InformationList_RL_RestoreInd__item__id._const_tab_id = 'id'
    __RL_Set_InformationList_RL_RestoreInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __RL_Set_InformationList_RL_RestoreInd__item__criticality._const_tab = ___RL_Set_InformationList_RL_RestoreInd__item__id_tab
    __RL_Set_InformationList_RL_RestoreInd__item__criticality._const_tab_at = ('..', 'id')
    __RL_Set_InformationList_RL_RestoreInd__item__criticality._const_tab_id = 'criticality'
    __RL_Set_InformationList_RL_RestoreInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __RL_Set_InformationList_RL_RestoreInd__item__value._const_tab = ___RL_Set_InformationList_RL_RestoreInd__item__id_tab
    __RL_Set_InformationList_RL_RestoreInd__item__value._const_tab_at = ('..', 'id')
    __RL_Set_InformationList_RL_RestoreInd__item__value._const_tab_id = 'Value'
    _RL_Set_InformationList_RL_RestoreInd__item_._cont = ASN1Dict([
        ('id', __RL_Set_InformationList_RL_RestoreInd__item__id),
        ('criticality', __RL_Set_InformationList_RL_RestoreInd__item__criticality),
        ('value', __RL_Set_InformationList_RL_RestoreInd__item__value),
        ])
    _RL_Set_InformationList_RL_RestoreInd__item_._ext = None
    RL_Set_InformationList_RL_RestoreInd._cont = _RL_Set_InformationList_RL_RestoreInd__item_
    RL_Set_InformationList_RL_RestoreInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-InformationItemIE-RL-RestoreInd >-----#
    RL_Set_InformationItemIE_RL_RestoreInd = CLASS(name='RL-Set-InformationItemIE-RL-RestoreInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RL_Set_InformationItemIE_RL_RestoreInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RL-Set-InformationItem-RL-RestoreInd')))
    RL_Set_InformationItemIE_RL_RestoreInd._val = ASN1Set(rv=[dict([('id', 242), ('criticality', 'ignore'), ('Value', _RL_Set_InformationItemIE_RL_RestoreInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-InformationItem-RL-RestoreInd >-----#
    RL_Set_InformationItem_RL_RestoreInd = SEQ(name='RL-Set-InformationItem-RL-RestoreInd', mode=MODE_TYPE)
    _RL_Set_InformationItem_RL_RestoreInd_rL_Set_ID = INT(name='rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-Set-ID')))
    _RL_Set_InformationItem_RL_RestoreInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__id),
        ('criticality', ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality),
        ('extensionValue', ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item_._ext = None
    _RL_Set_InformationItem_RL_RestoreInd_iE_Extensions._cont = __RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item_
    _RL_Set_InformationItem_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_InformationItem_RL_RestoreInd._cont = ASN1Dict([
        ('rL-Set-ID', _RL_Set_InformationItem_RL_RestoreInd_rL_Set_ID),
        ('iE-Extensions', _RL_Set_InformationItem_RL_RestoreInd_iE_Extensions),
        ])
    RL_Set_InformationItem_RL_RestoreInd._ext = []
    
    #-----< RL-Set-InformationItem-RL-RestoreInd-ExtIEs >-----#
    RL_Set_InformationItem_RL_RestoreInd_ExtIEs = CLASS(name='RL-Set-InformationItem-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RL_Set_InformationItem_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-RL-RestoreInd >-----#
    CCTrCH_RL_RestoreInd = SEQ(name='CCTrCH-RL-RestoreInd', mode=MODE_TYPE)
    _CCTrCH_RL_RestoreInd_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _CCTrCH_RL_RestoreInd_cCTrCH_InformationList_RL_RestoreInd = SEQ_OF(name='cCTrCH-InformationList-RL-RestoreInd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-InformationList-RL-RestoreInd')))
    _CCTrCH_RL_RestoreInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____CCTrCH_RL_RestoreInd_iE_Extensions__item__id_tab
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CCTrCH_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id),
        ('criticality', ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality),
        ('extensionValue', ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_RL_RestoreInd_iE_Extensions__item_._ext = None
    _CCTrCH_RL_RestoreInd_iE_Extensions._cont = __CCTrCH_RL_RestoreInd_iE_Extensions__item_
    _CCTrCH_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_RL_RestoreInd._cont = ASN1Dict([
        ('rL-ID', _CCTrCH_RL_RestoreInd_rL_ID),
        ('cCTrCH-InformationList-RL-RestoreInd', _CCTrCH_RL_RestoreInd_cCTrCH_InformationList_RL_RestoreInd),
        ('iE-Extensions', _CCTrCH_RL_RestoreInd_iE_Extensions),
        ])
    CCTrCH_RL_RestoreInd._ext = []
    
    #-----< CCTrCHItem-RL-RestoreInd-ExtIEs >-----#
    CCTrCHItem_RL_RestoreInd_ExtIEs = CLASS(name='CCTrCHItem-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CCTrCHItem_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-InformationList-RL-RestoreInd >-----#
    CCTrCH_InformationList_RL_RestoreInd = SEQ_OF(name='CCTrCH-InformationList-RL-RestoreInd', mode=MODE_TYPE)
    _CCTrCH_InformationList_RL_RestoreInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __CCTrCH_InformationList_RL_RestoreInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____CCTrCH_InformationList_RL_RestoreInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-InformationItem-RL-RestoreInd')))
    ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'ignore'), ('Value', ____CCTrCH_InformationList_RL_RestoreInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CCTrCH_InformationList_RL_RestoreInd__item__id._const_tab = ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab
    __CCTrCH_InformationList_RL_RestoreInd__item__id._const_tab_at = None
    __CCTrCH_InformationList_RL_RestoreInd__item__id._const_tab_id = 'id'
    __CCTrCH_InformationList_RL_RestoreInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __CCTrCH_InformationList_RL_RestoreInd__item__criticality._const_tab = ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab
    __CCTrCH_InformationList_RL_RestoreInd__item__criticality._const_tab_at = ('..', 'id')
    __CCTrCH_InformationList_RL_RestoreInd__item__criticality._const_tab_id = 'criticality'
    __CCTrCH_InformationList_RL_RestoreInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __CCTrCH_InformationList_RL_RestoreInd__item__value._const_tab = ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab
    __CCTrCH_InformationList_RL_RestoreInd__item__value._const_tab_at = ('..', 'id')
    __CCTrCH_InformationList_RL_RestoreInd__item__value._const_tab_id = 'Value'
    _CCTrCH_InformationList_RL_RestoreInd__item_._cont = ASN1Dict([
        ('id', __CCTrCH_InformationList_RL_RestoreInd__item__id),
        ('criticality', __CCTrCH_InformationList_RL_RestoreInd__item__criticality),
        ('value', __CCTrCH_InformationList_RL_RestoreInd__item__value),
        ])
    _CCTrCH_InformationList_RL_RestoreInd__item_._ext = None
    CCTrCH_InformationList_RL_RestoreInd._cont = _CCTrCH_InformationList_RL_RestoreInd__item_
    CCTrCH_InformationList_RL_RestoreInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CCTrCH-InformationItemIE-RL-RestoreInd >-----#
    CCTrCH_InformationItemIE_RL_RestoreInd = CLASS(name='CCTrCH-InformationItemIE-RL-RestoreInd', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CCTrCH_InformationItemIE_RL_RestoreInd_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CCTrCH-InformationItem-RL-RestoreInd')))
    CCTrCH_InformationItemIE_RL_RestoreInd._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'ignore'), ('Value', _CCTrCH_InformationItemIE_RL_RestoreInd_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CCTrCH-InformationItem-RL-RestoreInd >-----#
    CCTrCH_InformationItem_RL_RestoreInd = SEQ(name='CCTrCH-InformationItem-RL-RestoreInd', mode=MODE_TYPE)
    _CCTrCH_InformationItem_RL_RestoreInd_cCTrCH_ID = INT(name='cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CCTrCH-ID')))
    _CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id),
        ('criticality', ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality),
        ('extensionValue', ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item_._ext = None
    _CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions._cont = __CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item_
    _CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_InformationItem_RL_RestoreInd._cont = ASN1Dict([
        ('cCTrCH-ID', _CCTrCH_InformationItem_RL_RestoreInd_cCTrCH_ID),
        ('iE-Extensions', _CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions),
        ])
    CCTrCH_InformationItem_RL_RestoreInd._ext = []
    
    #-----< CCTrCH-InformationItem-RL-RestoreInd-ExtIEs >-----#
    CCTrCH_InformationItem_RL_RestoreInd_ExtIEs = CLASS(name='CCTrCH-InformationItem-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CCTrCH_InformationItem_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompressedModeCommand >-----#
    CompressedModeCommand = SEQ(name='CompressedModeCommand', mode=MODE_TYPE)
    _CompressedModeCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CompressedModeCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CompressedModeCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CompressedModeCommand_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CompressedModeCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____CompressedModeCommand_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Active-Pattern-Sequence-Information')))
    ____CompressedModeCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _____CompressedModeCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 315), ('criticality', 'ignore'), ('Value', _____CompressedModeCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CompressedModeCommand_protocolIEs__item__id._const_tab = ____CompressedModeCommand_protocolIEs__item__id_tab
    ___CompressedModeCommand_protocolIEs__item__id._const_tab_at = None
    ___CompressedModeCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___CompressedModeCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CompressedModeCommand_protocolIEs__item__criticality._const_tab = ____CompressedModeCommand_protocolIEs__item__id_tab
    ___CompressedModeCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CompressedModeCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CompressedModeCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CompressedModeCommand_protocolIEs__item__value._const_tab = ____CompressedModeCommand_protocolIEs__item__id_tab
    ___CompressedModeCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CompressedModeCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __CompressedModeCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CompressedModeCommand_protocolIEs__item__id),
        ('criticality', ___CompressedModeCommand_protocolIEs__item__criticality),
        ('value', ___CompressedModeCommand_protocolIEs__item__value),
        ])
    __CompressedModeCommand_protocolIEs__item_._ext = None
    _CompressedModeCommand_protocolIEs._cont = __CompressedModeCommand_protocolIEs__item_
    _CompressedModeCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CompressedModeCommand_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompressedModeCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CompressedModeCommand_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CompressedModeCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CompressedModeCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompressedModeCommand_protocolExtensions__item__id._const_tab = ____CompressedModeCommand_protocolExtensions__item__id_tab
    ___CompressedModeCommand_protocolExtensions__item__id._const_tab_at = None
    ___CompressedModeCommand_protocolExtensions__item__id._const_tab_id = 'id'
    ___CompressedModeCommand_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompressedModeCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CompressedModeCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompressedModeCommand_protocolExtensions__item__criticality._const_tab = ____CompressedModeCommand_protocolExtensions__item__criticality_tab
    ___CompressedModeCommand_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompressedModeCommand_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CompressedModeCommand_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompressedModeCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CompressedModeCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompressedModeCommand_protocolExtensions__item__extensionValue._const_tab = ____CompressedModeCommand_protocolExtensions__item__extensionValue_tab
    ___CompressedModeCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompressedModeCommand_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CompressedModeCommand_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CompressedModeCommand_protocolExtensions__item__id),
        ('criticality', ___CompressedModeCommand_protocolExtensions__item__criticality),
        ('extensionValue', ___CompressedModeCommand_protocolExtensions__item__extensionValue),
        ])
    __CompressedModeCommand_protocolExtensions__item_._ext = None
    _CompressedModeCommand_protocolExtensions._cont = __CompressedModeCommand_protocolExtensions__item_
    _CompressedModeCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompressedModeCommand._cont = ASN1Dict([
        ('protocolIEs', _CompressedModeCommand_protocolIEs),
        ('protocolExtensions', _CompressedModeCommand_protocolExtensions),
        ])
    CompressedModeCommand._ext = []
    
    #-----< CompressedModeCommand-IEs >-----#
    CompressedModeCommand_IEs = CLASS(name='CompressedModeCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CompressedModeCommand_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _CompressedModeCommand_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Active-Pattern-Sequence-Information')))
    CompressedModeCommand_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _CompressedModeCommand_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 315), ('criticality', 'ignore'), ('Value', _CompressedModeCommand_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CompressedModeCommand-Extensions >-----#
    CompressedModeCommand_Extensions = CLASS(name='CompressedModeCommand-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CompressedModeCommand_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 143), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ErrorIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ErrorIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ErrorIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ErrorIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__id._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__id._const_tab_at = None
    ___ErrorIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ErrorIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab = ____ErrorIndication_protocolExtensions__item__criticality_tab
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ErrorIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab = ____ErrorIndication_protocolExtensions__item__extensionValue_tab
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ErrorIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolExtensions__item__id),
        ('criticality', ___ErrorIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___ErrorIndication_protocolExtensions__item__extensionValue),
        ])
    __ErrorIndication_protocolExtensions__item_._ext = None
    _ErrorIndication_protocolExtensions._cont = __ErrorIndication_protocolExtensions__item_
    _ErrorIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ('protocolExtensions', _ErrorIndication_protocolExtensions),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndication-IEs >-----#
    ErrorIndication_IEs = CLASS(name='ErrorIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _ErrorIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _ErrorIndication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _ErrorIndication_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _ErrorIndication_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ErrorIndication_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 143), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication-Extensions >-----#
    ErrorIndication_Extensions = CLASS(name='ErrorIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ErrorIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_NBAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_NBAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_NBAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name='PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PhysicalSharedChannelReconfigurationRequestFDD >-----#
    PhysicalSharedChannelReconfigurationRequestFDD = SEQ(name='PhysicalSharedChannelReconfigurationRequestFDD', mode=MODE_TYPE)
    _PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-ScramblingCode')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-PDSCH-FDD-Code-Information')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-FDD-Code-Information')))
    ____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 522), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 523), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 524), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 525), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id._const_tab = ____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab = ____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__value._const_tab = ____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id),
        ('criticality', ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__criticality),
        ('value', ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__value),
        ])
    __PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item_._ext = None
    _PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs._cont = __PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item_
    _PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-ScramblingCode')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-FDD-Code-Information')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-E-HICH-FDD-Code-Information')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HSDPA-And-EDCH-CellPortion-InformationList-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Target-ReceivedTotalWideBandPower')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPower')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Target-NonServing-EDCH-To-Total-EDCH-Power-Ratio')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Common-System-InformationFDD')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlows-to-DeleteFDD')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Paging-System-InformationFDD')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlows-to-DeleteFDD')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-System-InformationFDD')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_12 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlows-to-DeleteFDD')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-to-Delete')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-InformationFDD')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Further-Enhanced-UE-DRX-InformationFDD')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-RGCH-Operation-Indicator')))
    _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-DRX-InformationFDD')))
    ____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 663), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 664), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 678), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 658), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 683), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 698), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 693), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 897), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 943), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 899), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 944), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 989), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 990), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 991), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 995), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 1252), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 1253), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 1312), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_17), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id._const_tab = ____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab = ____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id),
        ('criticality', ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item_._ext = None
    _PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions._cont = __PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item_
    _PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PhysicalSharedChannelReconfigurationRequestFDD._cont = ASN1Dict([
        ('protocolIEs', _PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs),
        ('protocolExtensions', _PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions),
        ])
    PhysicalSharedChannelReconfigurationRequestFDD._ext = []
    
    #-----< PhysicalSharedChannelReconfigurationRequestFDD-IEs >-----#
    PhysicalSharedChannelReconfigurationRequestFDD_IEs = CLASS(name='PhysicalSharedChannelReconfigurationRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')))
    _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-ScramblingCode')))
    _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-PDSCH-FDD-Code-Information')))
    _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_6 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-FDD-Code-Information')))
    PhysicalSharedChannelReconfigurationRequestFDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 522), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 523), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 524), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 525), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PhysicalSharedChannelReconfigurationRequestFDD-Extensions >-----#
    PhysicalSharedChannelReconfigurationRequestFDD_Extensions = CLASS(name='PhysicalSharedChannelReconfigurationRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DL-ScramblingCode')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-FDD-Code-Information')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-E-HICH-FDD-Code-Information')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HSDPA-And-EDCH-CellPortion-InformationList-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Target-ReceivedTotalWideBandPower')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPower')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Target-NonServing-EDCH-To-Total-EDCH-Power-Ratio')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Common-System-InformationFDD')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlows-to-DeleteFDD')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Paging-System-InformationFDD')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_10 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlows-to-DeleteFDD')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-System-InformationFDD')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_12 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlows-to-DeleteFDD')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_13 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-to-Delete')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-InformationFDD')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Further-Enhanced-UE-DRX-InformationFDD')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_16 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-RGCH-Operation-Indicator')))
    _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-DRX-InformationFDD')))
    PhysicalSharedChannelReconfigurationRequestFDD_Extensions._val = ASN1Set(rv=[dict([('id', 663), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 664), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 678), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 658), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 683), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 698), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 693), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 897), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 943), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 899), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 944), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 989), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 990), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 991), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 995), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 1252), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_15), ('presence', 'optional')]), dict([('id', 1253), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_16), ('presence', 'optional')]), dict([('id', 1312), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_17), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDPA-And-EDCH-CellPortion-InformationList-PSCH-ReconfRqst >-----#
    HSDPA_And_EDCH_CellPortion_InformationList_PSCH_ReconfRqst = SEQ_OF(name='HSDPA-And-EDCH-CellPortion-InformationList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HSDPA_And_EDCH_CellPortion_InformationList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HSDPA-And-EDCH-CellPortion-InformationItem-PSCH-ReconfRqst')))
    HSDPA_And_EDCH_CellPortion_InformationList_PSCH_ReconfRqst._cont = _HSDPA_And_EDCH_CellPortion_InformationList_PSCH_ReconfRqst__item_
    HSDPA_And_EDCH_CellPortion_InformationList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< HSDPA-And-EDCH-CellPortion-InformationItem-PSCH-ReconfRqst >-----#
    HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst = SEQ(name='HSDPA-And-EDCH-CellPortion-InformationItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_cellPortionID = INT(name='cellPortionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionID')))
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_PDSCH_HS_SCCH_ScramblingCode_PSCH_ReconfRqst = INT(name='hS-PDSCH-HS-SCCH-ScramblingCode-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-ScramblingCode')), opt=True)
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_PDSCH_FDD_Code_Information_PSCH_ReconfRqst = SEQ(name='hS-PDSCH-FDD-Code-Information-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-PDSCH-FDD-Code-Information')), opt=True)
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_SCCH_FDD_Code_Information_PSCH_ReconfRqst = CHOICE(name='hS-SCCH-FDD-Code-Information-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-FDD-Code-Information')), opt=True)
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_PDSCH_HS_SCCH_E_AGCH_E_RGCH_E_HICH_MaxPower_PSCH_ReconfRqst = INT(name='hS-PDSCH-HS-SCCH-E-AGCH-E-RGCH-E-HICH-MaxPower-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')), opt=True)
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_e_AGCH_And_E_RGCH_E_HICH_FDD_Scrambling_Code = INT(name='e-AGCH-And-E-RGCH-E-HICH-FDD-Scrambling-Code', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-ScramblingCode')), opt=True)
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_e_AGCH_FDD_Code_Information = CHOICE(name='e-AGCH-FDD-Code-Information', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-FDD-Code-Information')), opt=True)
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_e_RGCH_E_HICH_FDD_Code_Information = CHOICE(name='e-RGCH-E-HICH-FDD-Code-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-RGCH-E-HICH-FDD-Code-Information')), opt=True)
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Target-ReceivedTotalWideBandPower')))
    _____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPower')))
    ____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 683), ('criticality', 'ignore'), ('Extension', _____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 698), ('criticality', 'ignore'), ('Extension', _____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions._cont = __HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('cellPortionID', _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_cellPortionID),
        ('hS-PDSCH-HS-SCCH-ScramblingCode-PSCH-ReconfRqst', _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_PDSCH_HS_SCCH_ScramblingCode_PSCH_ReconfRqst),
        ('hS-PDSCH-FDD-Code-Information-PSCH-ReconfRqst', _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_PDSCH_FDD_Code_Information_PSCH_ReconfRqst),
        ('hS-SCCH-FDD-Code-Information-PSCH-ReconfRqst', _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_SCCH_FDD_Code_Information_PSCH_ReconfRqst),
        ('hS-PDSCH-HS-SCCH-E-AGCH-E-RGCH-E-HICH-MaxPower-PSCH-ReconfRqst', _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_PDSCH_HS_SCCH_E_AGCH_E_RGCH_E_HICH_MaxPower_PSCH_ReconfRqst),
        ('e-AGCH-And-E-RGCH-E-HICH-FDD-Scrambling-Code', _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_e_AGCH_And_E_RGCH_E_HICH_FDD_Scrambling_Code),
        ('e-AGCH-FDD-Code-Information', _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_e_AGCH_FDD_Code_Information),
        ('e-RGCH-E-HICH-FDD-Code-Information', _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_e_RGCH_E_HICH_FDD_Code_Information),
        ('iE-Extensions', _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst._ext = []
    
    #-----< HSDPA-And-EDCH-CellPortion-InformationItem-PSCH-ReconfRqst-ExtIEs >-----#
    HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='HSDPA-And-EDCH-CellPortion-InformationItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Target-ReceivedTotalWideBandPower')))
    _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Reference-ReceivedTotalWideBandPower')))
    HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 683), ('criticality', 'ignore'), ('Extension', _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 698), ('criticality', 'ignore'), ('Extension', _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PhysicalSharedChannelReconfigurationRequestTDD >-----#
    PhysicalSharedChannelReconfigurationRequestTDD = SEQ(name='PhysicalSharedChannelReconfigurationRequestTDD', mode=MODE_TYPE)
    _PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCHSets-AddList-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCHSets-ModifyList-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCHSets-DeleteList-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCHSets-AddList-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCHSets-ModifyList-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCHSets-DeleteList-PSCH-ReconfRqst')))
    ____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 163), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 164), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'reject'), ('Value', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id._const_tab = ____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab = ____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__value._const_tab = ____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id),
        ('criticality', ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__criticality),
        ('value', ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__value),
        ])
    __PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item_._ext = None
    _PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs._cont = __PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item_
    _PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-PDSCH-TDD-Information-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-HS-SCCH-Resource-Pool-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Information-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-E-AGCH-Resource-Pool-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-Information-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_10 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Generated-ReceivedTotalWideBandPowerInOtherCells')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Information-768-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-Information-768-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Information-LCR-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_16 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_18 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_19 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_20 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-E-HICH-Resource-Pool-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_21 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNC-UL-Partition-LCR')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_22 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Target-ReceivedTotalWideBandPower-LCR')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_23 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-HS-SCCH-Resource-PoolExt-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_24 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Common-System-InformationLCR')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_25 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlows-to-DeleteLCR')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_26 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Paging-System-InformationLCR')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_27 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlows-to-DeleteLCR')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_28 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-System-InformationLCR')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_29 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlows-to-DeleteLCR')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_30 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-to-DeleteLCR')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_31 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-InformationLCR')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_32 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_33 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_34 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_35 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_36 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_37 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_38 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Out-of-Sychronization-Window')))
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_39 = NULL(name='Extension', mode=MODE_TYPE)
    _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_40 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'In-Sync-Information-LCR')))
    ____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 526), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 527), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 528), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 529), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 43), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 802), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 803), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 804), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 805), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 806), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 808), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 815), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 816), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 817), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 818), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 852), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 853), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_16), ('presence', 'optional')]), dict([('id', 854), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_17), ('presence', 'optional')]), dict([('id', 855), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_18), ('presence', 'optional')]), dict([('id', 856), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_19), ('presence', 'optional')]), dict([('id', 857), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_20), ('presence', 'optional')]), dict([('id', 846), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_21), ('presence', 'optional')]), dict([('id', 950), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_22), ('presence', 'optional')]), dict([('id', 938), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_23), ('presence', 'optional')]), dict([('id', 1021), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_24), ('presence', 'optional')]), dict([('id', 1025), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_25), ('presence', 'optional')]), dict([('id', 1023), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_26), ('presence', 'optional')]), dict([('id', 1026), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_27), ('presence', 'optional')]), dict([('id', 1027), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_28), ('presence', 'optional')]), dict([('id', 1028), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_29), ('presence', 'optional')]), dict([('id', 1029), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_30), ('presence', 'optional')]), dict([('id', 1032), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_31), ('presence', 'optional')]), dict([('id', 1050), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_32), ('presence', 'optional')]), dict([('id', 1051), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_33), ('presence', 'optional')]), dict([('id', 1052), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_34), ('presence', 'optional')]), dict([('id', 1145), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_35), ('presence', 'optional')]), dict([('id', 1152), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_36), ('presence', 'optional')]), dict([('id', 1163), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_37), ('presence', 'optional')]), dict([('id', 1151), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_38), ('presence', 'optional')]), dict([('id', 1172), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_39), ('presence', 'optional')]), dict([('id', 1201), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_40), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id._const_tab = ____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab = ____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id),
        ('criticality', ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item_._ext = None
    _PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions._cont = __PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item_
    _PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PhysicalSharedChannelReconfigurationRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs),
        ('protocolExtensions', _PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions),
        ])
    PhysicalSharedChannelReconfigurationRequestTDD._ext = []
    
    #-----< PhysicalSharedChannelReconfigurationRequestTDD-IEs >-----#
    PhysicalSharedChannelReconfigurationRequestTDD_IEs = CLASS(name='PhysicalSharedChannelReconfigurationRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCHSets-AddList-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCHSets-ModifyList-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCHSets-DeleteList-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCHSets-AddList-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCHSets-ModifyList-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCHSets-DeleteList-PSCH-ReconfRqst')))
    PhysicalSharedChannelReconfigurationRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 163), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 164), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'reject'), ('Value', _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PhysicalSharedChannelReconfigurationRequestTDD-Extensions >-----#
    PhysicalSharedChannelReconfigurationRequestTDD_Extensions = CLASS(name='PhysicalSharedChannelReconfigurationRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-PDSCH-TDD-Information-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-HS-SCCH-Resource-Pool-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ConfigurationGenerationID')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Information-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-E-AGCH-Resource-Pool-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-Information-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_10 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Generated-ReceivedTotalWideBandPowerInOtherCells')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Information-768-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_12 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_13 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_14 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-Information-768-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_15 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Information-LCR-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_16 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_17 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_18 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_19 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_20 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-E-HICH-Resource-Pool-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_21 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNC-UL-Partition-LCR')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_22 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Target-ReceivedTotalWideBandPower-LCR')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_23 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-HS-SCCH-Resource-PoolExt-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_24 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Common-System-InformationLCR')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_25 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlows-to-DeleteLCR')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_26 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Paging-System-InformationLCR')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_27 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Paging-MACFlows-to-DeleteLCR')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_28 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-System-InformationLCR')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_29 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-MACFlows-to-DeleteLCR')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_30 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlows-to-DeleteLCR')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_31 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Enhanced-UE-DRX-InformationLCR')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_32 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Add-To-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_33 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Modify-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_34 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_35 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ControlGAP')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_36 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_37 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Delete-From-Non-HS-SCCH-Associated-HS-SICH-Resource-Pool-LCR-PSCH-ReconfRqst-Ext')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_38 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Out-of-Sychronization-Window')))
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_39 = NULL(name='Extension', mode=MODE_TYPE)
    _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_40 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'In-Sync-Information-LCR')))
    PhysicalSharedChannelReconfigurationRequestTDD_Extensions._val = ASN1Set(rv=[dict([('id', 526), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 527), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 528), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 529), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 43), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 802), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 803), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 804), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 805), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 806), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 808), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 815), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 816), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 817), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 818), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 852), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_15), ('presence', 'optional')]), dict([('id', 853), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_16), ('presence', 'optional')]), dict([('id', 854), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_17), ('presence', 'optional')]), dict([('id', 855), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_18), ('presence', 'optional')]), dict([('id', 856), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_19), ('presence', 'optional')]), dict([('id', 857), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_20), ('presence', 'optional')]), dict([('id', 846), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_21), ('presence', 'optional')]), dict([('id', 950), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_22), ('presence', 'optional')]), dict([('id', 938), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_23), ('presence', 'optional')]), dict([('id', 1021), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_24), ('presence', 'optional')]), dict([('id', 1025), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_25), ('presence', 'optional')]), dict([('id', 1023), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_26), ('presence', 'optional')]), dict([('id', 1026), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_27), ('presence', 'optional')]), dict([('id', 1027), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_28), ('presence', 'optional')]), dict([('id', 1028), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_29), ('presence', 'optional')]), dict([('id', 1029), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_30), ('presence', 'optional')]), dict([('id', 1032), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_31), ('presence', 'optional')]), dict([('id', 1050), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_32), ('presence', 'optional')]), dict([('id', 1051), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_33), ('presence', 'optional')]), dict([('id', 1052), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_34), ('presence', 'optional')]), dict([('id', 1145), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_35), ('presence', 'optional')]), dict([('id', 1152), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_36), ('presence', 'optional')]), dict([('id', 1163), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_37), ('presence', 'optional')]), dict([('id', 1151), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_38), ('presence', 'optional')]), dict([('id', 1172), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_39), ('presence', 'optional')]), dict([('id', 1201), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_40), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDSCHSets-AddList-PSCH-ReconfRqst >-----#
    PDSCHSets_AddList_PSCH_ReconfRqst = SEQ_OF(name='PDSCHSets-AddList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCHSets_AddList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCHSets-AddItem-PSCH-ReconfRqst')))
    PDSCHSets_AddList_PSCH_ReconfRqst._cont = _PDSCHSets_AddList_PSCH_ReconfRqst__item_
    PDSCHSets_AddList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDSCHSets-AddItem-PSCH-ReconfRqst >-----#
    PDSCHSets_AddItem_PSCH_ReconfRqst = SEQ(name='PDSCHSets-AddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCHSets_AddItem_PSCH_ReconfRqst_pDSCHSet_ID = INT(name='pDSCHSet-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PDSCHSet-ID')))
    _PDSCHSets_AddItem_PSCH_ReconfRqst_pDSCH_InformationList = SEQ(name='pDSCH-InformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-Information-AddList-PSCH-ReconfRqst')), opt=True)
    _PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst')))
    _____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-AddInformation-768-AddItem-PSCH-ReconfRqst')))
    ____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 486), ('criticality', 'reject'), ('Extension', _____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 764), ('criticality', 'reject'), ('Extension', _____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions._cont = __PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDSCHSets_AddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pDSCHSet-ID', _PDSCHSets_AddItem_PSCH_ReconfRqst_pDSCHSet_ID),
        ('pDSCH-InformationList', _PDSCHSets_AddItem_PSCH_ReconfRqst_pDSCH_InformationList),
        ('iE-Extensions', _PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PDSCHSets_AddItem_PSCH_ReconfRqst._ext = []
    
    #-----< PDSCHSets-AddItem-PSCH-ReconfRqst-ExtIEs >-----#
    PDSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PDSCHSets-AddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PDSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst')))
    _PDSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-AddInformation-768-AddItem-PSCH-ReconfRqst')))
    PDSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 486), ('criticality', 'reject'), ('Extension', _PDSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 764), ('criticality', 'reject'), ('Extension', _PDSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDSCH-Information-AddList-PSCH-ReconfRqst >-----#
    PDSCH_Information_AddList_PSCH_ReconfRqst = SEQ(name='PDSCH-Information-AddList-PSCH-ReconfRqst', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PDSCH_Information_AddList_PSCH_ReconfRqst_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PDSCH_Information_AddList_PSCH_ReconfRqst_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PDSCH_Information_AddList_PSCH_ReconfRqst_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-Information-AddItem-PSCH-ReconfRqst')))
    __PDSCH_Information_AddList_PSCH_ReconfRqst_id_tab._val = ASN1Set(rv=[dict([('id', 161), ('criticality', 'reject'), ('Value', ___PDSCH_Information_AddList_PSCH_ReconfRqst_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _PDSCH_Information_AddList_PSCH_ReconfRqst_id._const_tab = __PDSCH_Information_AddList_PSCH_ReconfRqst_id_tab
    _PDSCH_Information_AddList_PSCH_ReconfRqst_id._const_tab_at = None
    _PDSCH_Information_AddList_PSCH_ReconfRqst_id._const_tab_id = 'id'
    _PDSCH_Information_AddList_PSCH_ReconfRqst_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PDSCH_Information_AddList_PSCH_ReconfRqst_criticality._const_tab = __PDSCH_Information_AddList_PSCH_ReconfRqst_id_tab
    _PDSCH_Information_AddList_PSCH_ReconfRqst_criticality._const_tab_at = ('..', 'id')
    _PDSCH_Information_AddList_PSCH_ReconfRqst_criticality._const_tab_id = 'criticality'
    _PDSCH_Information_AddList_PSCH_ReconfRqst_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PDSCH_Information_AddList_PSCH_ReconfRqst_value._const_tab = __PDSCH_Information_AddList_PSCH_ReconfRqst_id_tab
    _PDSCH_Information_AddList_PSCH_ReconfRqst_value._const_tab_at = ('..', 'id')
    _PDSCH_Information_AddList_PSCH_ReconfRqst_value._const_tab_id = 'Value'
    PDSCH_Information_AddList_PSCH_ReconfRqst._cont = ASN1Dict([
        ('id', _PDSCH_Information_AddList_PSCH_ReconfRqst_id),
        ('criticality', _PDSCH_Information_AddList_PSCH_ReconfRqst_criticality),
        ('value', _PDSCH_Information_AddList_PSCH_ReconfRqst_value),
        ])
    PDSCH_Information_AddList_PSCH_ReconfRqst._ext = None
    
    #-----< PDSCH-Information-AddListIEs-PSCH-ReconfRqst >-----#
    PDSCH_Information_AddListIEs_PSCH_ReconfRqst = CLASS(name='PDSCH-Information-AddListIEs-PSCH-ReconfRqst', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PDSCH_Information_AddListIEs_PSCH_ReconfRqst_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-Information-AddItem-PSCH-ReconfRqst')))
    PDSCH_Information_AddListIEs_PSCH_ReconfRqst._val = ASN1Set(rv=[dict([('id', 161), ('criticality', 'reject'), ('Value', _PDSCH_Information_AddListIEs_PSCH_ReconfRqst_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PDSCH-Information-AddItem-PSCH-ReconfRqst >-----#
    PDSCH_Information_AddItem_PSCH_ReconfRqst = SEQ(name='PDSCH-Information-AddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCH_Information_AddItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PDSCH_Information_AddItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PDSCH_Information_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PDSCH_Information_AddItem_PSCH_ReconfRqst_dL_Timeslot_InformationAddList_PSCH_ReconfRqst = SEQ_OF(name='dL-Timeslot-InformationAddList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-InformationAddList-PSCH-ReconfRqst')))
    _PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions._cont = __PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDSCH_Information_AddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PDSCH_Information_AddItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PDSCH_Information_AddItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PDSCH_Information_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('dL-Timeslot-InformationAddList-PSCH-ReconfRqst', _PDSCH_Information_AddItem_PSCH_ReconfRqst_dL_Timeslot_InformationAddList_PSCH_ReconfRqst),
        ('iE-Extensions', _PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PDSCH_Information_AddItem_PSCH_ReconfRqst._ext = []
    
    #-----< PDSCH-Information-AddItem-PSCH-ReconfRqst-ExtIEs >-----#
    PDSCH_Information_AddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PDSCH-Information-AddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PDSCH_Information_AddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-InformationAddList-PSCH-ReconfRqst >-----#
    DL_Timeslot_InformationAddList_PSCH_ReconfRqst = SEQ_OF(name='DL-Timeslot-InformationAddList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_InformationAddList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-InformationAddItem-PSCH-ReconfRqst')))
    DL_Timeslot_InformationAddList_PSCH_ReconfRqst._cont = _DL_Timeslot_InformationAddList_PSCH_ReconfRqst__item_
    DL_Timeslot_InformationAddList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationAddItem-PSCH-ReconfRqst >-----#
    DL_Timeslot_InformationAddItem_PSCH_ReconfRqst = SEQ(name='DL-Timeslot-InformationAddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_dL_Code_InformationAddList_PSCH_ReconfRqst = SEQ_OF(name='dL-Code-InformationAddList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-InformationAddList-PSCH-ReconfRqst')))
    _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationAddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlot', _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('tFCI-Presence', _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_tFCI_Presence),
        ('dL-Code-InformationAddList-PSCH-ReconfRqst', _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_dL_Code_InformationAddList_PSCH_ReconfRqst),
        ('iE-Extensions', _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Timeslot_InformationAddItem_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Timeslot-InformationAddItem-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Timeslot-InformationAddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Code-InformationAddList-PSCH-ReconfRqst >-----#
    DL_Code_InformationAddList_PSCH_ReconfRqst = SEQ_OF(name='DL-Code-InformationAddList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_InformationAddList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-InformationAddItem-PSCH-ReconfRqst')))
    DL_Code_InformationAddList_PSCH_ReconfRqst._cont = _DL_Code_InformationAddList_PSCH_ReconfRqst__item_
    DL_Code_InformationAddList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DL-Code-InformationAddItem-PSCH-ReconfRqst >-----#
    DL_Code_InformationAddItem_PSCH_ReconfRqst = SEQ(name='DL-Code-InformationAddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_InformationAddItem_PSCH_ReconfRqst_pDSCH_ID = INT(name='pDSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PDSCH-ID')))
    _DL_Code_InformationAddItem_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Code_InformationAddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pDSCH-ID', _DL_Code_InformationAddItem_PSCH_ReconfRqst_pDSCH_ID),
        ('tdd-ChannelisationCode', _DL_Code_InformationAddItem_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('iE-Extensions', _DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Code_InformationAddItem_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Code-InformationAddItem-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Code_InformationAddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Code-InformationAddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Code_InformationAddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst >-----#
    PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst = SEQ(name='PDSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_dL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst = SEQ_OF(name='dL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst')))
    _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    ____PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 627), ('criticality', 'reject'), ('Extension', _____PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions._cont = __PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('dL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst', _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_dL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst._ext = []
    
    #-----< PDSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst-ExtIEs >-----#
    PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PDSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TSTD-Indicator')))
    PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 627), ('criticality', 'reject'), ('Extension', _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst >-----#
    DL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst = SEQ_OF(name='DL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst')))
    DL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst._cont = _DL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst__item_
    DL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst >-----#
    DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst = SEQ(name='DL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_dL_Code_InformationAddList_LCR_PSCH_ReconfRqst = SEQ_OF(name='dL-Code-InformationAddList-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-InformationAddList-LCR-PSCH-ReconfRqst')))
    _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlotLCR', _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_midambleShiftLCR),
        ('tFCI-Presence', _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_tFCI_Presence),
        ('dL-Code-InformationAddList-LCR-PSCH-ReconfRqst', _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_dL_Code_InformationAddList_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Code-InformationAddList-LCR-PSCH-ReconfRqst >-----#
    DL_Code_InformationAddList_LCR_PSCH_ReconfRqst = SEQ_OF(name='DL-Code-InformationAddList-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_InformationAddList_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-InformationAddItem-LCR-PSCH-ReconfRqst')))
    DL_Code_InformationAddList_LCR_PSCH_ReconfRqst._cont = _DL_Code_InformationAddList_LCR_PSCH_ReconfRqst__item_
    DL_Code_InformationAddList_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DL-Code-InformationAddItem-LCR-PSCH-ReconfRqst >-----#
    DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst = SEQ(name='DL-Code-InformationAddItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_pDSCH_ID = INT(name='pDSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PDSCH-ID')))
    _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    ____DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 775), ('criticality', 'reject'), ('Extension', _____DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pDSCH-ID', _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_pDSCH_ID),
        ('tdd-ChannelisationCodeLCR', _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR),
        ('iE-Extensions', _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Code-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Code-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 775), ('criticality', 'reject'), ('Extension', _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDSCH-AddInformation-768-AddItem-PSCH-ReconfRqst >-----#
    PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst = SEQ(name='PDSCH-AddInformation-768-AddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_dL_Timeslot_InformationAddList_768_PSCH_ReconfRqst = SEQ_OF(name='dL-Timeslot-InformationAddList-768-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-InformationAddList-768-PSCH-ReconfRqst')))
    _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions._cont = __PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('dL-Timeslot-InformationAddList-768-PSCH-ReconfRqst', _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_dL_Timeslot_InformationAddList_768_PSCH_ReconfRqst),
        ('iE-Extensions', _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst._ext = []
    
    #-----< PDSCH-AddInformation-768-AddItem-PSCH-ReconfRqst-ExtIEs >-----#
    PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PDSCH-AddInformation-768-AddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-InformationAddList-768-PSCH-ReconfRqst >-----#
    DL_Timeslot_InformationAddList_768_PSCH_ReconfRqst = SEQ_OF(name='DL-Timeslot-InformationAddList-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_InformationAddList_768_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst')))
    DL_Timeslot_InformationAddList_768_PSCH_ReconfRqst._cont = _DL_Timeslot_InformationAddList_768_PSCH_ReconfRqst__item_
    DL_Timeslot_InformationAddList_768_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst >-----#
    DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst = SEQ(name='DL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_dL_Code_InformationAddList_768_PSCH_ReconfRqst = SEQ_OF(name='dL-Code-InformationAddList-768-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-InformationAddList-768-PSCH-ReconfRqst')))
    _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlot', _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType768', _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('tFCI-Presence', _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_tFCI_Presence),
        ('dL-Code-InformationAddList-768-PSCH-ReconfRqst', _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_dL_Code_InformationAddList_768_PSCH_ReconfRqst),
        ('iE-Extensions', _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Code-InformationAddList-768-PSCH-ReconfRqst >-----#
    DL_Code_InformationAddList_768_PSCH_ReconfRqst = SEQ_OF(name='DL-Code-InformationAddList-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_InformationAddList_768_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-InformationAddItem-768-PSCH-ReconfRqst')))
    DL_Code_InformationAddList_768_PSCH_ReconfRqst._cont = _DL_Code_InformationAddList_768_PSCH_ReconfRqst__item_
    DL_Code_InformationAddList_768_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DL-Code-InformationAddItem-768-PSCH-ReconfRqst >-----#
    DL_Code_InformationAddItem_768_PSCH_ReconfRqst = SEQ(name='DL-Code-InformationAddItem-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_InformationAddItem_768_PSCH_ReconfRqst_pDSCH_ID768 = INT(name='pDSCH-ID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PDSCH-ID768')))
    _DL_Code_InformationAddItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Code_InformationAddItem_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pDSCH-ID768', _DL_Code_InformationAddItem_768_PSCH_ReconfRqst_pDSCH_ID768),
        ('tdd-ChannelisationCode768', _DL_Code_InformationAddItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768),
        ('iE-Extensions', _DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Code_InformationAddItem_768_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Code-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Code_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Code-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Code_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDSCHSets-ModifyList-PSCH-ReconfRqst >-----#
    PDSCHSets_ModifyList_PSCH_ReconfRqst = SEQ_OF(name='PDSCHSets-ModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCHSets_ModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCHSets-ModifyItem-PSCH-ReconfRqst')))
    PDSCHSets_ModifyList_PSCH_ReconfRqst._cont = _PDSCHSets_ModifyList_PSCH_ReconfRqst__item_
    PDSCHSets_ModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDSCHSets-ModifyItem-PSCH-ReconfRqst >-----#
    PDSCHSets_ModifyItem_PSCH_ReconfRqst = SEQ(name='PDSCHSets-ModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCHSets_ModifyItem_PSCH_ReconfRqst_pDSCHSet_ID = INT(name='pDSCHSet-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PDSCHSet-ID')))
    _PDSCHSets_ModifyItem_PSCH_ReconfRqst_pDSCH_InformationList = SEQ(name='pDSCH-InformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-Information-ModifyList-PSCH-ReconfRqst')))
    _PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst')))
    ____PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 765), ('criticality', 'reject'), ('Extension', _____PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDSCHSets_ModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pDSCHSet-ID', _PDSCHSets_ModifyItem_PSCH_ReconfRqst_pDSCHSet_ID),
        ('pDSCH-InformationList', _PDSCHSets_ModifyItem_PSCH_ReconfRqst_pDSCH_InformationList),
        ('iE-Extensions', _PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PDSCHSets_ModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< PDSCHSets-ModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    PDSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PDSCHSets-ModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PDSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst')))
    PDSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 765), ('criticality', 'reject'), ('Extension', _PDSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDSCH-Information-ModifyList-PSCH-ReconfRqst >-----#
    PDSCH_Information_ModifyList_PSCH_ReconfRqst = SEQ(name='PDSCH-Information-ModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-Information-ModifyItem-PSCH-ReconfRqst')))
    ___PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst')))
    __PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab._val = ASN1Set(rv=[dict([('id', 162), ('criticality', 'reject'), ('Value', ___PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 488), ('criticality', 'reject'), ('Value', ___PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_id._const_tab = __PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_id._const_tab_at = None
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_id._const_tab_id = 'id'
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_criticality._const_tab = __PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_criticality._const_tab_at = ('..', 'id')
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_criticality._const_tab_id = 'criticality'
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_value._const_tab = __PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_value._const_tab_at = ('..', 'id')
    _PDSCH_Information_ModifyList_PSCH_ReconfRqst_value._const_tab_id = 'Value'
    PDSCH_Information_ModifyList_PSCH_ReconfRqst._cont = ASN1Dict([
        ('id', _PDSCH_Information_ModifyList_PSCH_ReconfRqst_id),
        ('criticality', _PDSCH_Information_ModifyList_PSCH_ReconfRqst_criticality),
        ('value', _PDSCH_Information_ModifyList_PSCH_ReconfRqst_value),
        ])
    PDSCH_Information_ModifyList_PSCH_ReconfRqst._ext = None
    
    #-----< PDSCH-Information-ModifyListIEs-PSCH-ReconfRqst >-----#
    PDSCH_Information_ModifyListIEs_PSCH_ReconfRqst = CLASS(name='PDSCH-Information-ModifyListIEs-PSCH-ReconfRqst', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PDSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-Information-ModifyItem-PSCH-ReconfRqst')))
    _PDSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst')))
    PDSCH_Information_ModifyListIEs_PSCH_ReconfRqst._val = ASN1Set(rv=[dict([('id', 162), ('criticality', 'reject'), ('Value', _PDSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_0), ('presence', 'optional')]), dict([('id', 488), ('criticality', 'reject'), ('Value', _PDSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< PDSCH-Information-ModifyItem-PSCH-ReconfRqst >-----#
    PDSCH_Information_ModifyItem_PSCH_ReconfRqst = SEQ(name='PDSCH-Information-ModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')), opt=True)
    _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')), opt=True)
    _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')), opt=True)
    _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_dL_Timeslot_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='dL-Timeslot-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDSCH_Information_ModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('dL-Timeslot-InformationModifyList-PSCH-ReconfRqst', _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_dL_Timeslot_InformationModifyList_PSCH_ReconfRqst),
        ('iE-Extensions', _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PDSCH_Information_ModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< PDSCH-Information-ModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    PDSCH_Information_ModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PDSCH-Information-ModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PDSCH_Information_ModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-InformationModifyList-PSCH-ReconfRqst >-----#
    DL_Timeslot_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='DL-Timeslot-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-InformationModifyItem-PSCH-ReconfRqst')))
    DL_Timeslot_InformationModifyList_PSCH_ReconfRqst._cont = _DL_Timeslot_InformationModifyList_PSCH_ReconfRqst__item_
    DL_Timeslot_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationModifyItem-PSCH-ReconfRqst >-----#
    DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='DL-Timeslot-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_dL_Code_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='dL-Code-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlot', _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('tFCI-Presence', _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence),
        ('dL-Code-InformationModifyList-PSCH-ReconfRqst', _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_dL_Code_InformationModifyList_PSCH_ReconfRqst),
        ('iE-Extensions', _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Timeslot-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Timeslot-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Code-InformationModifyList-PSCH-ReconfRqst >-----#
    DL_Code_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='DL-Code-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-InformationModifyItem-PSCH-ReconfRqst')))
    DL_Code_InformationModifyList_PSCH_ReconfRqst._cont = _DL_Code_InformationModifyList_PSCH_ReconfRqst__item_
    DL_Code_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DL-Code-InformationModifyItem-PSCH-ReconfRqst >-----#
    DL_Code_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='DL-Code-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_InformationModifyItem_PSCH_ReconfRqst_pDSCH_ID = INT(name='pDSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PDSCH-ID')))
    _DL_Code_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Code_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pDSCH-ID', _DL_Code_InformationModifyItem_PSCH_ReconfRqst_pDSCH_ID),
        ('tdd-ChannelisationCode', _DL_Code_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('iE-Extensions', _DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Code_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Code-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Code_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Code-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Code_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst >-----#
    PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst = SEQ(name='PDSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')), opt=True)
    _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')), opt=True)
    _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')), opt=True)
    _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_dL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='dL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('dL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst', _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_dL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst),
        ('iE-Extensions', _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< PDSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst-ExtIEs >-----#
    PDSCH_ModifyInformation_LCR_ModifyListIE_PSCH_ReconfRqst_ExtIEs = CLASS(name='PDSCH-ModifyInformation-LCR-ModifyListIE-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PDSCH_ModifyInformation_LCR_ModifyListIE_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst >-----#
    DL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='DL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst')))
    DL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst._cont = _DL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst__item_
    DL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst >-----#
    DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='DL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')), opt=True)
    _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_dL_Code_LCR_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='dL-Code-LCR-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-LCR-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlotLCR', _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_midambleShiftLCR),
        ('tFCI-Presence', _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence),
        ('dL-Code-LCR-InformationModifyList-PSCH-ReconfRqst', _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_dL_Code_LCR_InformationModifyList_PSCH_ReconfRqst),
        ('iE-Extensions', _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Code-LCR-InformationModifyList-PSCH-ReconfRqst >-----#
    DL_Code_LCR_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='DL-Code-LCR-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_LCR_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst')))
    DL_Code_LCR_InformationModifyList_PSCH_ReconfRqst._cont = _DL_Code_LCR_InformationModifyList_PSCH_ReconfRqst__item_
    DL_Code_LCR_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst >-----#
    DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='DL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_pDSCH_ID = INT(name='pDSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PDSCH-ID')))
    _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    ____DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 775), ('criticality', 'reject'), ('Extension', _____DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pDSCH-ID', _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_pDSCH_ID),
        ('tdd-ChannelisationCodeLCR', _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR),
        ('iE-Extensions', _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 775), ('criticality', 'reject'), ('Extension', _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst >-----#
    PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst = SEQ(name='PDSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')), opt=True)
    _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')), opt=True)
    _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')), opt=True)
    _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_dL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='dL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('dL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst', _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_dL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst),
        ('iE-Extensions', _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< PDSCH-ModifyInformation-768-ModifyListIE-PSCH-ReconfRqst-ExtIEs >-----#
    PDSCH_ModifyInformation_768_ModifyListIE_PSCH_ReconfRqst_ExtIEs = CLASS(name='PDSCH-ModifyInformation-768-ModifyListIE-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PDSCH_ModifyInformation_768_ModifyListIE_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst >-----#
    DL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='DL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst')))
    DL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst._cont = _DL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst__item_
    DL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst >-----#
    DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='DL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')), opt=True)
    _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_dL_Code_768_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='dL-Code-768-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-768-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlot', _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType768', _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('tFCI-Presence', _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence),
        ('dL-Code-768-InformationModifyList-PSCH-ReconfRqst', _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_dL_Code_768_InformationModifyList_PSCH_ReconfRqst),
        ('iE-Extensions', _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Code-768-InformationModifyList-PSCH-ReconfRqst >-----#
    DL_Code_768_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='DL-Code-768-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_768_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-Code-768-InformationModifyItem-PSCH-ReconfRqst')))
    DL_Code_768_InformationModifyList_PSCH_ReconfRqst._cont = _DL_Code_768_InformationModifyList_PSCH_ReconfRqst__item_
    DL_Code_768_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DL-Code-768-InformationModifyItem-PSCH-ReconfRqst >-----#
    DL_Code_768_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='DL-Code-768-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_pDSCH_ID768 = INT(name='pDSCH-ID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PDSCH-ID768')))
    _DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Code_768_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pDSCH-ID768', _DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_pDSCH_ID768),
        ('tdd-ChannelisationCode768', _DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode768),
        ('iE-Extensions', _DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_Code_768_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< DL-Code-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-Code-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDSCHSets-DeleteList-PSCH-ReconfRqst >-----#
    PDSCHSets_DeleteList_PSCH_ReconfRqst = SEQ_OF(name='PDSCHSets-DeleteList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCHSets_DeleteList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PDSCHSets-DeleteItem-PSCH-ReconfRqst')))
    PDSCHSets_DeleteList_PSCH_ReconfRqst._cont = _PDSCHSets_DeleteList_PSCH_ReconfRqst__item_
    PDSCHSets_DeleteList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDSCHSets-DeleteItem-PSCH-ReconfRqst >-----#
    PDSCHSets_DeleteItem_PSCH_ReconfRqst = SEQ(name='PDSCHSets-DeleteItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PDSCHSets_DeleteItem_PSCH_ReconfRqst_pDSCHSet_ID = INT(name='pDSCHSet-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PDSCHSet-ID')))
    _PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions._cont = __PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDSCHSets_DeleteItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pDSCHSet-ID', _PDSCHSets_DeleteItem_PSCH_ReconfRqst_pDSCHSet_ID),
        ('iE-Extensions', _PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PDSCHSets_DeleteItem_PSCH_ReconfRqst._ext = []
    
    #-----< PDSCHSets-DeleteItem-PSCH-ReconfRqst-ExtIEs >-----#
    PDSCHSets_DeleteItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PDSCHSets-DeleteItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PDSCHSets_DeleteItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PUSCHSets-AddList-PSCH-ReconfRqst >-----#
    PUSCHSets_AddList_PSCH_ReconfRqst = SEQ_OF(name='PUSCHSets-AddList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCHSets_AddList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCHSets-AddItem-PSCH-ReconfRqst')))
    PUSCHSets_AddList_PSCH_ReconfRqst._cont = _PUSCHSets_AddList_PSCH_ReconfRqst__item_
    PUSCHSets_AddList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PUSCHSets-AddItem-PSCH-ReconfRqst >-----#
    PUSCHSets_AddItem_PSCH_ReconfRqst = SEQ(name='PUSCHSets-AddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCHSets_AddItem_PSCH_ReconfRqst_pUSCHSet_ID = INT(name='pUSCHSet-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCHSet-ID')))
    _PUSCHSets_AddItem_PSCH_ReconfRqst_pUSCH_InformationList = SEQ(name='pUSCH-InformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Information-AddList-PSCH-ReconfRqst')), opt=True)
    _PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst')))
    _____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-AddInformation-768-AddItem-PSCH-ReconfRqst')))
    ____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 490), ('criticality', 'reject'), ('Extension', _____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 766), ('criticality', 'reject'), ('Extension', _____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions._cont = __PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PUSCHSets_AddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pUSCHSet-ID', _PUSCHSets_AddItem_PSCH_ReconfRqst_pUSCHSet_ID),
        ('pUSCH-InformationList', _PUSCHSets_AddItem_PSCH_ReconfRqst_pUSCH_InformationList),
        ('iE-Extensions', _PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PUSCHSets_AddItem_PSCH_ReconfRqst._ext = []
    
    #-----< PUSCHSets-AddItem-PSCH-ReconfRqst-ExtIEs >-----#
    PUSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PUSCHSets-AddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PUSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst')))
    _PUSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-AddInformation-768-AddItem-PSCH-ReconfRqst')))
    PUSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 490), ('criticality', 'reject'), ('Extension', _PUSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 766), ('criticality', 'reject'), ('Extension', _PUSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PUSCH-Information-AddList-PSCH-ReconfRqst >-----#
    PUSCH_Information_AddList_PSCH_ReconfRqst = SEQ(name='PUSCH-Information-AddList-PSCH-ReconfRqst', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PUSCH_Information_AddList_PSCH_ReconfRqst_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PUSCH_Information_AddList_PSCH_ReconfRqst_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PUSCH_Information_AddList_PSCH_ReconfRqst_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Information-AddItem-PSCH-ReconfRqst')))
    __PUSCH_Information_AddList_PSCH_ReconfRqst_id_tab._val = ASN1Set(rv=[dict([('id', 185), ('criticality', 'reject'), ('Value', ___PUSCH_Information_AddList_PSCH_ReconfRqst_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _PUSCH_Information_AddList_PSCH_ReconfRqst_id._const_tab = __PUSCH_Information_AddList_PSCH_ReconfRqst_id_tab
    _PUSCH_Information_AddList_PSCH_ReconfRqst_id._const_tab_at = None
    _PUSCH_Information_AddList_PSCH_ReconfRqst_id._const_tab_id = 'id'
    _PUSCH_Information_AddList_PSCH_ReconfRqst_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PUSCH_Information_AddList_PSCH_ReconfRqst_criticality._const_tab = __PUSCH_Information_AddList_PSCH_ReconfRqst_id_tab
    _PUSCH_Information_AddList_PSCH_ReconfRqst_criticality._const_tab_at = ('..', 'id')
    _PUSCH_Information_AddList_PSCH_ReconfRqst_criticality._const_tab_id = 'criticality'
    _PUSCH_Information_AddList_PSCH_ReconfRqst_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PUSCH_Information_AddList_PSCH_ReconfRqst_value._const_tab = __PUSCH_Information_AddList_PSCH_ReconfRqst_id_tab
    _PUSCH_Information_AddList_PSCH_ReconfRqst_value._const_tab_at = ('..', 'id')
    _PUSCH_Information_AddList_PSCH_ReconfRqst_value._const_tab_id = 'Value'
    PUSCH_Information_AddList_PSCH_ReconfRqst._cont = ASN1Dict([
        ('id', _PUSCH_Information_AddList_PSCH_ReconfRqst_id),
        ('criticality', _PUSCH_Information_AddList_PSCH_ReconfRqst_criticality),
        ('value', _PUSCH_Information_AddList_PSCH_ReconfRqst_value),
        ])
    PUSCH_Information_AddList_PSCH_ReconfRqst._ext = None
    
    #-----< PUSCH-Information-AddListIEs-PSCH-ReconfRqst >-----#
    PUSCH_Information_AddListIEs_PSCH_ReconfRqst = CLASS(name='PUSCH-Information-AddListIEs-PSCH-ReconfRqst', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PUSCH_Information_AddListIEs_PSCH_ReconfRqst_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Information-AddItem-PSCH-ReconfRqst')))
    PUSCH_Information_AddListIEs_PSCH_ReconfRqst._val = ASN1Set(rv=[dict([('id', 185), ('criticality', 'reject'), ('Value', _PUSCH_Information_AddListIEs_PSCH_ReconfRqst_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PUSCH-Information-AddItem-PSCH-ReconfRqst >-----#
    PUSCH_Information_AddItem_PSCH_ReconfRqst = SEQ(name='PUSCH-Information-AddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCH_Information_AddItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PUSCH_Information_AddItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PUSCH_Information_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PUSCH_Information_AddItem_PSCH_ReconfRqst_uL_Timeslot_InformationAddList_PSCH_ReconfRqst = SEQ_OF(name='uL-Timeslot-InformationAddList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-InformationAddList-PSCH-ReconfRqst')))
    _PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions._cont = __PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PUSCH_Information_AddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PUSCH_Information_AddItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PUSCH_Information_AddItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PUSCH_Information_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('uL-Timeslot-InformationAddList-PSCH-ReconfRqst', _PUSCH_Information_AddItem_PSCH_ReconfRqst_uL_Timeslot_InformationAddList_PSCH_ReconfRqst),
        ('iE-Extensions', _PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PUSCH_Information_AddItem_PSCH_ReconfRqst._ext = []
    
    #-----< PUSCH-Information-AddItem-PSCH-ReconfRqst-ExtIEs >-----#
    PUSCH_Information_AddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PUSCH-Information-AddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PUSCH_Information_AddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-InformationAddList-PSCH-ReconfRqst >-----#
    UL_Timeslot_InformationAddList_PSCH_ReconfRqst = SEQ_OF(name='UL-Timeslot-InformationAddList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_InformationAddList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-InformationAddItem-PSCH-ReconfRqst')))
    UL_Timeslot_InformationAddList_PSCH_ReconfRqst._cont = _UL_Timeslot_InformationAddList_PSCH_ReconfRqst__item_
    UL_Timeslot_InformationAddList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationAddItem-PSCH-ReconfRqst >-----#
    UL_Timeslot_InformationAddItem_PSCH_ReconfRqst = SEQ(name='UL-Timeslot-InformationAddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_uL_Code_InformationAddList_PSCH_ReconfRqst = SEQ_OF(name='uL-Code-InformationAddList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationAddList-PSCH-ReconfRqst')))
    _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationAddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlot', _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('tFCI-Presence', _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_tFCI_Presence),
        ('uL-Code-InformationAddList-PSCH-ReconfRqst', _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_uL_Code_InformationAddList_PSCH_ReconfRqst),
        ('iE-Extensions', _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Timeslot_InformationAddItem_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Timeslot-InformationAddItem-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Timeslot-InformationAddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Code-InformationAddList-PSCH-ReconfRqst >-----#
    UL_Code_InformationAddList_PSCH_ReconfRqst = SEQ_OF(name='UL-Code-InformationAddList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_InformationAddList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationAddItem-PSCH-ReconfRqst')))
    UL_Code_InformationAddList_PSCH_ReconfRqst._cont = _UL_Code_InformationAddList_PSCH_ReconfRqst__item_
    UL_Code_InformationAddList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UL-Code-InformationAddItem-PSCH-ReconfRqst >-----#
    UL_Code_InformationAddItem_PSCH_ReconfRqst = SEQ(name='UL-Code-InformationAddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_InformationAddItem_PSCH_ReconfRqst_pUSCH_ID = INT(name='pUSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCH-ID')))
    _UL_Code_InformationAddItem_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Code_InformationAddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pUSCH-ID', _UL_Code_InformationAddItem_PSCH_ReconfRqst_pUSCH_ID),
        ('tdd-ChannelisationCode', _UL_Code_InformationAddItem_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('iE-Extensions', _UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Code_InformationAddItem_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Code-InformationAddItem-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Code_InformationAddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Code-InformationAddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Code_InformationAddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PUSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst >-----#
    PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst = SEQ(name='PUSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_uL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst = SEQ_OF(name='uL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst')))
    _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions._cont = __PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('uL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst', _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_uL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst._ext = []
    
    #-----< PUSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst-ExtIEs >-----#
    PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PUSCH-AddInformation-LCR-AddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst >-----#
    UL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst = SEQ_OF(name='UL-Timeslot-InformationAddList-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst')))
    UL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst._cont = _UL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst__item_
    UL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst >-----#
    UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst = SEQ(name='UL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_uL_Code_InformationAddList_LCR_PSCH_ReconfRqst = SEQ_OF(name='uL-Code-InformationAddList-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationAddList-LCR-PSCH-ReconfRqst')))
    _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlotLCR', _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_midambleShiftLCR),
        ('tFCI-Presence', _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_tFCI_Presence),
        ('uL-Code-InformationAddList-LCR-PSCH-ReconfRqst', _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_uL_Code_InformationAddList_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Timeslot-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Code-InformationAddList-LCR-PSCH-ReconfRqst >-----#
    UL_Code_InformationAddList_LCR_PSCH_ReconfRqst = SEQ_OF(name='UL-Code-InformationAddList-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_InformationAddList_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationAddItem-LCR-PSCH-ReconfRqst')))
    UL_Code_InformationAddList_LCR_PSCH_ReconfRqst._cont = _UL_Code_InformationAddList_LCR_PSCH_ReconfRqst__item_
    UL_Code_InformationAddList_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UL-Code-InformationAddItem-LCR-PSCH-ReconfRqst >-----#
    UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst = SEQ(name='UL-Code-InformationAddItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_pUSCH_ID = INT(name='pUSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCH-ID')))
    _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-DPCH-TimeSlotFormat-LCR')))
    ____UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 780), ('criticality', 'reject'), ('Extension', _____UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pUSCH-ID', _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_pUSCH_ID),
        ('tdd-ChannelisationCodeLCR', _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR),
        ('iE-Extensions', _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Code-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Code-InformationAddItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-DPCH-TimeSlotFormat-LCR')))
    UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 780), ('criticality', 'reject'), ('Extension', _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PUSCH-AddInformation-768-AddItem-PSCH-ReconfRqst >-----#
    PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst = SEQ(name='PUSCH-AddInformation-768-AddItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')))
    _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')))
    _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')))
    _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_uL_Timeslot_InformationAddList_768_PSCH_ReconfRqst = SEQ_OF(name='uL-Timeslot-InformationAddList-768-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-InformationAddList-768-PSCH-ReconfRqst')))
    _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions._cont = __PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('uL-Timeslot-InformationAddList-768-PSCH-ReconfRqst', _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_uL_Timeslot_InformationAddList_768_PSCH_ReconfRqst),
        ('iE-Extensions', _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst._ext = []
    
    #-----< PUSCH-AddInformation-768-AddItem-PSCH-ReconfRqst-ExtIEs >-----#
    PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PUSCH-AddInformation-768-AddItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-InformationAddList-768-PSCH-ReconfRqst >-----#
    UL_Timeslot_InformationAddList_768_PSCH_ReconfRqst = SEQ_OF(name='UL-Timeslot-InformationAddList-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_InformationAddList_768_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst')))
    UL_Timeslot_InformationAddList_768_PSCH_ReconfRqst._cont = _UL_Timeslot_InformationAddList_768_PSCH_ReconfRqst__item_
    UL_Timeslot_InformationAddList_768_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst >-----#
    UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst = SEQ(name='UL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')))
    _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_uL_Code_InformationAddList_768_PSCH_ReconfRqst = SEQ_OF(name='uL-Code-InformationAddList-768-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationAddList-768-PSCH-ReconfRqst')))
    _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlot', _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType768', _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('tFCI-Presence', _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_tFCI_Presence),
        ('uL-Code-InformationAddList-768-PSCH-ReconfRqst', _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_uL_Code_InformationAddList_768_PSCH_ReconfRqst),
        ('iE-Extensions', _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Timeslot-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Code-InformationAddList-768-PSCH-ReconfRqst >-----#
    UL_Code_InformationAddList_768_PSCH_ReconfRqst = SEQ_OF(name='UL-Code-InformationAddList-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_InformationAddList_768_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationAddItem-768-PSCH-ReconfRqst')))
    UL_Code_InformationAddList_768_PSCH_ReconfRqst._cont = _UL_Code_InformationAddList_768_PSCH_ReconfRqst__item_
    UL_Code_InformationAddList_768_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UL-Code-InformationAddItem-768-PSCH-ReconfRqst >-----#
    UL_Code_InformationAddItem_768_PSCH_ReconfRqst = SEQ(name='UL-Code-InformationAddItem-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_InformationAddItem_768_PSCH_ReconfRqst_pUSCH_ID = INT(name='pUSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCH-ID')))
    _UL_Code_InformationAddItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Code_InformationAddItem_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pUSCH-ID', _UL_Code_InformationAddItem_768_PSCH_ReconfRqst_pUSCH_ID),
        ('tdd-ChannelisationCode768', _UL_Code_InformationAddItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768),
        ('iE-Extensions', _UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Code_InformationAddItem_768_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Code-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Code_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Code-InformationAddItem-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Code_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PUSCHSets-ModifyList-PSCH-ReconfRqst >-----#
    PUSCHSets_ModifyList_PSCH_ReconfRqst = SEQ_OF(name='PUSCHSets-ModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCHSets_ModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCHSets-ModifyItem-PSCH-ReconfRqst')))
    PUSCHSets_ModifyList_PSCH_ReconfRqst._cont = _PUSCHSets_ModifyList_PSCH_ReconfRqst__item_
    PUSCHSets_ModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PUSCHSets-ModifyItem-PSCH-ReconfRqst >-----#
    PUSCHSets_ModifyItem_PSCH_ReconfRqst = SEQ(name='PUSCHSets-ModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCHSets_ModifyItem_PSCH_ReconfRqst_pUSCHSet_ID = INT(name='pUSCHSet-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCHSet-ID')))
    _PUSCHSets_ModifyItem_PSCH_ReconfRqst_pUSCH_InformationList = SEQ(name='pUSCH-InformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Information-ModifyList-PSCH-ReconfRqst')))
    _PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst')))
    ____PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 767), ('criticality', 'reject'), ('Extension', _____PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PUSCHSets_ModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pUSCHSet-ID', _PUSCHSets_ModifyItem_PSCH_ReconfRqst_pUSCHSet_ID),
        ('pUSCH-InformationList', _PUSCHSets_ModifyItem_PSCH_ReconfRqst_pUSCH_InformationList),
        ('iE-Extensions', _PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PUSCHSets_ModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< PUSCHSets-ModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    PUSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PUSCHSets-ModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PUSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst')))
    PUSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 767), ('criticality', 'reject'), ('Extension', _PUSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PUSCH-Information-ModifyList-PSCH-ReconfRqst >-----#
    PUSCH_Information_ModifyList_PSCH_ReconfRqst = SEQ(name='PUSCH-Information-ModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Information-ModifyItem-PSCH-ReconfRqst')))
    ___PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst')))
    __PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab._val = ASN1Set(rv=[dict([('id', 186), ('criticality', 'reject'), ('Value', ___PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 492), ('criticality', 'reject'), ('Value', ___PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_id._const_tab = __PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_id._const_tab_at = None
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_id._const_tab_id = 'id'
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_criticality._const_tab = __PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_criticality._const_tab_at = ('..', 'id')
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_criticality._const_tab_id = 'criticality'
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_value._const_tab = __PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_value._const_tab_at = ('..', 'id')
    _PUSCH_Information_ModifyList_PSCH_ReconfRqst_value._const_tab_id = 'Value'
    PUSCH_Information_ModifyList_PSCH_ReconfRqst._cont = ASN1Dict([
        ('id', _PUSCH_Information_ModifyList_PSCH_ReconfRqst_id),
        ('criticality', _PUSCH_Information_ModifyList_PSCH_ReconfRqst_criticality),
        ('value', _PUSCH_Information_ModifyList_PSCH_ReconfRqst_value),
        ])
    PUSCH_Information_ModifyList_PSCH_ReconfRqst._ext = None
    
    #-----< PUSCH-Information-ModifyListIEs-PSCH-ReconfRqst >-----#
    PUSCH_Information_ModifyListIEs_PSCH_ReconfRqst = CLASS(name='PUSCH-Information-ModifyListIEs-PSCH-ReconfRqst', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PUSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-Information-ModifyItem-PSCH-ReconfRqst')))
    _PUSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst')))
    PUSCH_Information_ModifyListIEs_PSCH_ReconfRqst._val = ASN1Set(rv=[dict([('id', 186), ('criticality', 'reject'), ('Value', _PUSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_0), ('presence', 'optional')]), dict([('id', 492), ('criticality', 'reject'), ('Value', _PUSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< PUSCH-Information-ModifyItem-PSCH-ReconfRqst >-----#
    PUSCH_Information_ModifyItem_PSCH_ReconfRqst = SEQ(name='PUSCH-Information-ModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')), opt=True)
    _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')), opt=True)
    _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')), opt=True)
    _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_uL_Timeslot_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='uL-Timeslot-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PUSCH_Information_ModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('uL-Timeslot-InformationModifyList-PSCH-ReconfRqst', _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_uL_Timeslot_InformationModifyList_PSCH_ReconfRqst),
        ('iE-Extensions', _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PUSCH_Information_ModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< PUSCH-Information-ModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    PUSCH_Information_ModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PUSCH-Information-ModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PUSCH_Information_ModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-InformationModifyList-PSCH-ReconfRqst >-----#
    UL_Timeslot_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='UL-Timeslot-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-InformationModifyItem-PSCH-ReconfRqst')))
    UL_Timeslot_InformationModifyList_PSCH_ReconfRqst._cont = _UL_Timeslot_InformationModifyList_PSCH_ReconfRqst__item_
    UL_Timeslot_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationModifyItem-PSCH-ReconfRqst >-----#
    UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='UL-Timeslot-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_uL_Code_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='uL-Code-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlot', _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('tFCI-Presence', _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence),
        ('uL-Code-InformationModifyList-PSCH-ReconfRqst', _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_uL_Code_InformationModifyList_PSCH_ReconfRqst),
        ('iE-Extensions', _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Timeslot-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Timeslot-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Code-InformationModifyList-PSCH-ReconfRqst >-----#
    UL_Code_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='UL-Code-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-InformationModifyItem-PSCH-ReconfRqst')))
    UL_Code_InformationModifyList_PSCH_ReconfRqst._cont = _UL_Code_InformationModifyList_PSCH_ReconfRqst__item_
    UL_Code_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UL-Code-InformationModifyItem-PSCH-ReconfRqst >-----#
    UL_Code_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='UL-Code-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_InformationModifyItem_PSCH_ReconfRqst_pUSCH_ID = INT(name='pUSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCH-ID')))
    _UL_Code_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Code_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pUSCH-ID', _UL_Code_InformationModifyItem_PSCH_ReconfRqst_pUSCH_ID),
        ('tdd-ChannelisationCode', _UL_Code_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('iE-Extensions', _UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Code_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Code-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Code_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Code-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Code_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PUSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst >-----#
    PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst = SEQ(name='PUSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')), opt=True)
    _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')), opt=True)
    _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')), opt=True)
    _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_uL_Timeslot_InformationModifyList_LCR_PSCH_ReconfRqst = SEQ_OF(name='uL-Timeslot-InformationModifyList-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('uL-Timeslot-InformationModifyList-LCR-PSCH-ReconfRqst', _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_uL_Timeslot_InformationModifyList_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< PUSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PUSCH-ModifyInformation-LCR-ModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst >-----#
    UL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='UL-Timeslot-LCR-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst')))
    UL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst._cont = _UL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst__item_
    UL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst >-----#
    UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='UL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')), opt=True)
    _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_uL_Code_LCR_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='uL-Code-LCR-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-LCR-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlotLCR', _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_midambleShiftLCR),
        ('tFCI-Presence', _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence),
        ('uL-Code-LCR-InformationModifyList-PSCH-ReconfRqst', _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_uL_Code_LCR_InformationModifyList_PSCH_ReconfRqst),
        ('iE-Extensions', _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Timeslot-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Code-LCR-InformationModifyList-PSCH-ReconfRqst >-----#
    UL_Code_LCR_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='UL-Code-LCR-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_LCR_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst')))
    UL_Code_LCR_InformationModifyList_PSCH_ReconfRqst._cont = _UL_Code_LCR_InformationModifyList_PSCH_ReconfRqst__item_
    UL_Code_LCR_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst >-----#
    UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='UL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_pUSCH_ID = INT(name='pUSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCH-ID')))
    _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR = SEQ(name='tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-DPCH-TimeSlotFormat-LCR')))
    ____UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 780), ('criticality', 'reject'), ('Extension', _____UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pUSCH-ID', _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_pUSCH_ID),
        ('tdd-ChannelisationCodeLCR', _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR),
        ('iE-Extensions', _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Code-LCR-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-UL-DPCH-TimeSlotFormat-LCR')))
    UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 780), ('criticality', 'reject'), ('Extension', _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PUSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst >-----#
    PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst = SEQ(name='PUSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionPeriod')), opt=True)
    _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RepetitionLength')), opt=True)
    _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset = INT(name='tdd-PhysicalChannelOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-PhysicalChannelOffset')), opt=True)
    _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_uL_Timeslot_InformationModifyList_768_PSCH_ReconfRqst = SEQ_OF(name='uL-Timeslot-InformationModifyList-768-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('repetitionPeriod', _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionPeriod),
        ('repetitionLength', _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionLength),
        ('tdd-PhysicalChannelOffset', _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset),
        ('uL-Timeslot-InformationModifyList-768-PSCH-ReconfRqst', _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_uL_Timeslot_InformationModifyList_768_PSCH_ReconfRqst),
        ('iE-Extensions', _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< PUSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PUSCH-ModifyInformation-768-ModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst >-----#
    UL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='UL-Timeslot-768-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst')))
    UL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst._cont = _UL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst__item_
    UL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst >-----#
    UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='UL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')), opt=True)
    _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence = ENUM(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_uL_Code_768_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='uL-Code-768-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-768-InformationModifyList-PSCH-ReconfRqst')), opt=True)
    _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlot', _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType768', _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('tFCI-Presence', _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence),
        ('uL-Code-768-InformationModifyList-PSCH-ReconfRqst', _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_uL_Code_768_InformationModifyList_PSCH_ReconfRqst),
        ('iE-Extensions', _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Timeslot-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Code-768-InformationModifyList-PSCH-ReconfRqst >-----#
    UL_Code_768_InformationModifyList_PSCH_ReconfRqst = SEQ_OF(name='UL-Code-768-InformationModifyList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_768_InformationModifyList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UL-Code-768-InformationModifyItem-PSCH-ReconfRqst')))
    UL_Code_768_InformationModifyList_PSCH_ReconfRqst._cont = _UL_Code_768_InformationModifyList_PSCH_ReconfRqst__item_
    UL_Code_768_InformationModifyList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UL-Code-768-InformationModifyItem-PSCH-ReconfRqst >-----#
    UL_Code_768_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='UL-Code-768-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_pUSCH_ID = INT(name='pUSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCH-ID')))
    _UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Code_768_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pUSCH-ID', _UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_pUSCH_ID),
        ('tdd-ChannelisationCode768', _UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode768),
        ('iE-Extensions', _UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    UL_Code_768_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< UL-Code-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='UL-Code-768-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PUSCHSets-DeleteList-PSCH-ReconfRqst >-----#
    PUSCHSets_DeleteList_PSCH_ReconfRqst = SEQ_OF(name='PUSCHSets-DeleteList-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCHSets_DeleteList_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PUSCHSets-DeleteItem-PSCH-ReconfRqst')))
    PUSCHSets_DeleteList_PSCH_ReconfRqst._cont = _PUSCHSets_DeleteList_PSCH_ReconfRqst__item_
    PUSCHSets_DeleteList_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PUSCHSets-DeleteItem-PSCH-ReconfRqst >-----#
    PUSCHSets_DeleteItem_PSCH_ReconfRqst = SEQ(name='PUSCHSets-DeleteItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _PUSCHSets_DeleteItem_PSCH_ReconfRqst_pUSCHSet_ID = INT(name='pUSCHSet-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCHSet-ID')))
    _PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions._cont = __PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item_
    _PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PUSCHSets_DeleteItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('pUSCHSet-ID', _PUSCHSets_DeleteItem_PSCH_ReconfRqst_pUSCHSet_ID),
        ('iE-Extensions', _PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    PUSCHSets_DeleteItem_PSCH_ReconfRqst._ext = []
    
    #-----< PUSCHSets-DeleteItem-PSCH-ReconfRqst-ExtIEs >-----#
    PUSCHSets_DeleteItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='PUSCHSets-DeleteItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    PUSCHSets_DeleteItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-PDSCH-TDD-Information-PSCH-ReconfRqst >-----#
    HS_PDSCH_TDD_Information_PSCH_ReconfRqst = SEQ(name='HS-PDSCH-TDD-Information-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_dL_HS_PDSCH_Timeslot_Information_PSCH_ReconfRqst = SEQ_OF(name='dL-HS-PDSCH-Timeslot-Information-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-HS-PDSCH-Timeslot-Information-PSCH-ReconfRqst')), opt=True)
    _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='dL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst')), opt=True)
    _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-HS-PDSCH-Timeslot-Information-768-PSCH-ReconfRqst')))
    _____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst')))
    ____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 768), ('criticality', 'reject'), ('Extension', _____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 925), ('criticality', 'reject'), ('Extension', _____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions._cont = __HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_PDSCH_TDD_Information_PSCH_ReconfRqst._cont = ASN1Dict([
        ('dL-HS-PDSCH-Timeslot-Information-PSCH-ReconfRqst', _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_dL_HS_PDSCH_Timeslot_Information_PSCH_ReconfRqst),
        ('dL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst', _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_PDSCH_TDD_Information_PSCH_ReconfRqst._ext = []
    
    #-----< HS-PDSCH-TDD-Information-PSCH-ReconfRqst-ExtIEs >-----#
    HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-PDSCH-TDD-Information-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-HS-PDSCH-Timeslot-Information-768-PSCH-ReconfRqst')))
    _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst')))
    HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 768), ('criticality', 'reject'), ('Extension', _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 925), ('criticality', 'reject'), ('Extension', _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-HS-PDSCH-Timeslot-Information-PSCH-ReconfRqst >-----#
    DL_HS_PDSCH_Timeslot_Information_PSCH_ReconfRqst = SEQ_OF(name='DL-HS-PDSCH-Timeslot-Information-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_HS_PDSCH_Timeslot_Information_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-HS-PDSCH-Timeslot-InformationItem-PSCH-ReconfRqst')))
    DL_HS_PDSCH_Timeslot_Information_PSCH_ReconfRqst._cont = _DL_HS_PDSCH_Timeslot_Information_PSCH_ReconfRqst__item_
    DL_HS_PDSCH_Timeslot_Information_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-HS-PDSCH-Timeslot-InformationItem-PSCH-ReconfRqst >-----#
    DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst = SEQ(name='DL-HS-PDSCH-Timeslot-InformationItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_dl_HS_PDSCH_Codelist_PSCH_ReconfRqst = SEQ_OF(name='dl-HS-PDSCH-Codelist-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-HS-PDSCH-Codelist-PSCH-ReconfRqst')))
    _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_maxHSDSCH_HSSCCH_Power = INT(name='maxHSDSCH-HSSCCH-Power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')), opt=True)
    _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions._cont = __DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlot', _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('dl-HS-PDSCH-Codelist-PSCH-ReconfRqst', _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_dl_HS_PDSCH_Codelist_PSCH_ReconfRqst),
        ('maxHSDSCH-HSSCCH-Power', _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_maxHSDSCH_HSSCCH_Power),
        ('iE-Extensions', _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst._ext = []
    
    #-----< DL-HS-PDSCH-Timeslot-InformationItem-PSCH-ReconfRqst-ExtIEs >-----#
    DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-HS-PDSCH-Timeslot-InformationItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-HS-PDSCH-Codelist-PSCH-ReconfRqst >-----#
    DL_HS_PDSCH_Codelist_PSCH_ReconfRqst = SEQ_OF(name='DL-HS-PDSCH-Codelist-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_HS_PDSCH_Codelist_PSCH_ReconfRqst__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    DL_HS_PDSCH_Codelist_PSCH_ReconfRqst._cont = _DL_HS_PDSCH_Codelist_PSCH_ReconfRqst__item_
    DL_HS_PDSCH_Codelist_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-HS-PDSCH-Timeslot-Information-768-PSCH-ReconfRqst >-----#
    DL_HS_PDSCH_Timeslot_Information_768_PSCH_ReconfRqst = SEQ_OF(name='DL-HS-PDSCH-Timeslot-Information-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_HS_PDSCH_Timeslot_Information_768_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-HS-PDSCH-Timeslot-InformationItem-768-PSCH-ReconfRqst')))
    DL_HS_PDSCH_Timeslot_Information_768_PSCH_ReconfRqst._cont = _DL_HS_PDSCH_Timeslot_Information_768_PSCH_ReconfRqst__item_
    DL_HS_PDSCH_Timeslot_Information_768_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-HS-PDSCH-Timeslot-InformationItem-768-PSCH-ReconfRqst >-----#
    DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst = SEQ(name='DL-HS-PDSCH-Timeslot-InformationItem-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_dl_HS_PDSCH_Codelist_768_PSCH_ReconfRqst = SEQ_OF(name='dl-HS-PDSCH-Codelist-768-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-HS-PDSCH-Codelist-768-PSCH-ReconfRqst')))
    _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_maxHSDSCH_HSSCCH_Power = INT(name='maxHSDSCH-HSSCCH-Power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MaximumTransmissionPower')), opt=True)
    _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions._cont = __DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_
    _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('timeSlot', _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType768', _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('dl-HS-PDSCH-Codelist-768-PSCH-ReconfRqst', _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_dl_HS_PDSCH_Codelist_768_PSCH_ReconfRqst),
        ('maxHSDSCH-HSSCCH-Power', _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_maxHSDSCH_HSSCCH_Power),
        ('iE-Extensions', _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst._ext = []
    
    #-----< DL-HS-PDSCH-Timeslot-InformationItem-768-PSCH-ReconfRqst-ExtIEs >-----#
    DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='DL-HS-PDSCH-Timeslot-InformationItem-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-HS-PDSCH-Codelist-768-PSCH-ReconfRqst >-----#
    DL_HS_PDSCH_Codelist_768_PSCH_ReconfRqst = SEQ_OF(name='DL-HS-PDSCH-Codelist-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _DL_HS_PDSCH_Codelist_768_PSCH_ReconfRqst__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    DL_HS_PDSCH_Codelist_768_PSCH_ReconfRqst._cont = _DL_HS_PDSCH_Codelist_768_PSCH_ReconfRqst__item_
    DL_HS_PDSCH_Codelist_768_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst >-----#
    MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst')))
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id_tab._val = ASN1Set(rv=[dict([('id', 933), ('criticality', 'reject'), ('Value', ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id._const_tab = ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id_tab
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id._const_tab_at = None
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id._const_tab_id = 'id'
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__criticality._const_tab = ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id_tab
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__criticality._const_tab_at = ('..', 'id')
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__criticality._const_tab_id = 'criticality'
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__value._const_tab = ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id_tab
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__value._const_tab_at = ('..', 'id')
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__value._const_tab_id = 'Value'
    _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item_._cont = ASN1Dict([
        ('id', __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id),
        ('criticality', __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__criticality),
        ('value', __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__value),
        ])
    _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item_._ext = None
    MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst._cont = _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item_
    MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItemIE-PSCH-ReconfRqst >-----#
    MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItemIE_PSCH_ReconfRqst = CLASS(name='MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItemIE-PSCH-ReconfRqst', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItemIE_PSCH_ReconfRqst_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst')))
    MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItemIE_PSCH_ReconfRqst._val = ASN1Set(rv=[dict([('id', 933), ('criticality', 'reject'), ('Value', _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItemIE_PSCH_ReconfRqst_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst >-----#
    MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst = SEQ(name='MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='dL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst')), opt=True)
    _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions._cont = __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item_
    _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('dL-HS-PDSCH-Timeslot-Information-LCR-PSCH-ReconfRqst', _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst),
        ('uARFCN', _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_uARFCN),
        ('iE-Extensions', _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst._ext = []
    
    #-----< MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst-ExtIEs >-----#
    MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='MultipleFreq-DL-HS-PDSCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst >-----#
    Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst = SEQ(name='Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_Information_PSCH_ReconfRqst = SEQ_OF(name='hS-SCCH-Information-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-Information-PSCH-ReconfRqst')), opt=True)
    _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='hS-SCCH-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-Information-LCR-PSCH-ReconfRqst')), opt=True)
    _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-Information-768-PSCH-ReconfRqst')))
    _____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationExt-LCR-PSCH-ReconfRqst')))
    ____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 769), ('criticality', 'reject'), ('Extension', _____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 939), ('criticality', 'ignore'), ('Extension', _____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions._cont = __Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_
    _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hS-SCCH-Information-PSCH-ReconfRqst', _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_Information_PSCH_ReconfRqst),
        ('hS-SCCH-Information-LCR-PSCH-ReconfRqst', _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_Information_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions),
        ])
    Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst._ext = []
    
    #-----< Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs >-----#
    Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs = CLASS(name='Add-To-HS-SCCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-Information-768-PSCH-ReconfRqst')))
    _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationExt-LCR-PSCH-ReconfRqst')))
    Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 769), ('criticality', 'reject'), ('Extension', _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 939), ('criticality', 'ignore'), ('Extension', _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-Information-PSCH-ReconfRqst >-----#
    HS_SCCH_Information_PSCH_ReconfRqst = SEQ_OF(name='HS-SCCH-Information-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_Information_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationItem-PSCH-ReconfRqst')))
    HS_SCCH_Information_PSCH_ReconfRqst._cont = _HS_SCCH_Information_PSCH_ReconfRqst__item_
    HS_SCCH_Information_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< HS-SCCH-InformationItem-PSCH-ReconfRqst >-----#
    HS_SCCH_InformationItem_PSCH_ReconfRqst = SEQ(name='HS-SCCH-InformationItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_InformationItem_PSCH_ReconfRqst_hS_SCCH_ID = INT(name='hS-SCCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-ID')))
    _HS_SCCH_InformationItem_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _HS_SCCH_InformationItem_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _HS_SCCH_InformationItem_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _HS_SCCH_InformationItem_PSCH_ReconfRqst_hS_SCCH_MaxPower = INT(name='hS-SCCH-MaxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _HS_SCCH_InformationItem_PSCH_ReconfRqst_hS_SICH_Information = SEQ(name='hS-SICH-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SICH-Information-PSCH-ReconfRqst')))
    _HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_InformationItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hS-SCCH-ID', _HS_SCCH_InformationItem_PSCH_ReconfRqst_hS_SCCH_ID),
        ('timeSlot', _HS_SCCH_InformationItem_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _HS_SCCH_InformationItem_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('tdd-ChannelisationCode', _HS_SCCH_InformationItem_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('hS-SCCH-MaxPower', _HS_SCCH_InformationItem_PSCH_ReconfRqst_hS_SCCH_MaxPower),
        ('hS-SICH-Information', _HS_SCCH_InformationItem_PSCH_ReconfRqst_hS_SICH_Information),
        ('iE-Extensions', _HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SCCH_InformationItem_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SCCH-InformationItem-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SCCH_InformationItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SCCH-InformationItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_SCCH_InformationItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-Information-PSCH-ReconfRqst >-----#
    HS_SICH_Information_PSCH_ReconfRqst = SEQ(name='HS-SICH-Information-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SICH_Information_PSCH_ReconfRqst_hsSICH_ID = INT(name='hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _HS_SICH_Information_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _HS_SICH_Information_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _HS_SICH_Information_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SICH_Information_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hsSICH-ID', _HS_SICH_Information_PSCH_ReconfRqst_hsSICH_ID),
        ('timeSlot', _HS_SICH_Information_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _HS_SICH_Information_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('tdd-ChannelisationCode', _HS_SICH_Information_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('iE-Extensions', _HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SICH_Information_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SICH-Information-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SICH_Information_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SICH-Information-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_SICH_Information_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-Information-LCR-PSCH-ReconfRqst >-----#
    HS_SCCH_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='HS-SCCH-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_Information_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationItem-LCR-PSCH-ReconfRqst')))
    HS_SCCH_Information_LCR_PSCH_ReconfRqst._cont = _HS_SCCH_Information_LCR_PSCH_ReconfRqst__item_
    HS_SCCH_Information_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< HS-SCCH-InformationItem-LCR-PSCH-ReconfRqst >-----#
    HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst = SEQ(name='HS-SCCH-InformationItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_hS_SCCH_ID = INT(name='hS-SCCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-ID')))
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode = ENUM(name='first-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode = ENUM(name='second-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_hS_SCCH_MaxPower = INT(name='hS-SCCH-MaxPower', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_hS_SICH_Information_LCR = SEQ(name='hS-SICH-Information-LCR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SICH-Information-LCR-PSCH-ReconfRqst')))
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SCCH-ID')))
    _____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSICH-ReferenceSignal-InformationLCR')))
    ____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 935), ('criticality', 'ignore'), ('Extension', _____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1070), ('criticality', 'ignore'), ('Extension', _____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hS-SCCH-ID', _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_hS_SCCH_ID),
        ('timeSlotLCR', _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftLCR),
        ('first-TDD-ChannelisationCode', _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode),
        ('second-TDD-ChannelisationCode', _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode),
        ('hS-SCCH-MaxPower', _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_hS_SCCH_MaxPower),
        ('hS-SICH-Information-LCR', _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_hS_SICH_Information_LCR),
        ('iE-Extensions', _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SCCH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SCCH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SCCH-ID')))
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSICH-ReferenceSignal-InformationLCR')))
    HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 935), ('criticality', 'ignore'), ('Extension', _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1070), ('criticality', 'ignore'), ('Extension', _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-Information-LCR-PSCH-ReconfRqst >-----#
    HS_SICH_Information_LCR_PSCH_ReconfRqst = SEQ(name='HS-SICH-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SICH_Information_LCR_PSCH_ReconfRqst_hsSICH_ID = INT(name='hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _HS_SICH_Information_LCR_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _HS_SICH_Information_LCR_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _HS_SICH_Information_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    ____HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 936), ('criticality', 'ignore'), ('Extension', _____HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SICH_Information_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hsSICH-ID', _HS_SICH_Information_LCR_PSCH_ReconfRqst_hsSICH_ID),
        ('timeSlotLCR', _HS_SICH_Information_LCR_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _HS_SICH_Information_LCR_PSCH_ReconfRqst_midambleShiftLCR),
        ('tdd-ChannelisationCode', _HS_SICH_Information_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('iE-Extensions', _HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SICH_Information_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SICH-Information-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SICH_Information_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SICH-Information-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_SICH_Information_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    HS_SICH_Information_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 936), ('criticality', 'ignore'), ('Extension', _HS_SICH_Information_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-Information-768-PSCH-ReconfRqst >-----#
    HS_SCCH_Information_768_PSCH_ReconfRqst = SEQ_OF(name='HS-SCCH-Information-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_Information_768_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationItem-768-PSCH-ReconfRqst')))
    HS_SCCH_Information_768_PSCH_ReconfRqst._cont = _HS_SCCH_Information_768_PSCH_ReconfRqst__item_
    HS_SCCH_Information_768_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< HS-SCCH-InformationItem-768-PSCH-ReconfRqst >-----#
    HS_SCCH_InformationItem_768_PSCH_ReconfRqst = SEQ(name='HS-SCCH-InformationItem-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_hS_SCCH_ID = INT(name='hS-SCCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-ID')))
    _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_hS_SCCH_MaxPower = INT(name='hS-SCCH-MaxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_hS_SICH_Information_768 = SEQ(name='hS-SICH-Information-768', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SICH-Information-768-PSCH-ReconfRqst')))
    _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_InformationItem_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hS-SCCH-ID', _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_hS_SCCH_ID),
        ('timeSlot', _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType768', _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('tdd-ChannelisationCode768', _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768),
        ('hS-SCCH-MaxPower', _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_hS_SCCH_MaxPower),
        ('hS-SICH-Information-768', _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_hS_SICH_Information_768),
        ('iE-Extensions', _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SCCH_InformationItem_768_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SCCH-InformationItem-768-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SCCH_InformationItem_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SCCH-InformationItem-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_SCCH_InformationItem_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-Information-768-PSCH-ReconfRqst >-----#
    HS_SICH_Information_768_PSCH_ReconfRqst = SEQ(name='HS-SICH-Information-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SICH_Information_768_PSCH_ReconfRqst_hsSICH_ID = INT(name='hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _HS_SICH_Information_768_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _HS_SICH_Information_768_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _HS_SICH_Information_768_PSCH_ReconfRqst_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SICH_Information_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hsSICH-ID', _HS_SICH_Information_768_PSCH_ReconfRqst_hsSICH_ID),
        ('timeSlot', _HS_SICH_Information_768_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType768', _HS_SICH_Information_768_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('tdd-ChannelisationCode768', _HS_SICH_Information_768_PSCH_ReconfRqst_tdd_ChannelisationCode768),
        ('iE-Extensions', _HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SICH_Information_768_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SICH-Information-768-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SICH_Information_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SICH-Information-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_SICH_Information_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-InformationExt-LCR-PSCH-ReconfRqst >-----#
    HS_SCCH_InformationExt_LCR_PSCH_ReconfRqst = SEQ_OF(name='HS-SCCH-InformationExt-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_InformationExt_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationItem-LCR-PSCH-ReconfRqst')))
    HS_SCCH_InformationExt_LCR_PSCH_ReconfRqst._cont = _HS_SCCH_InformationExt_LCR_PSCH_ReconfRqst__item_
    HS_SCCH_InformationExt_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=224)], ev=None, er=[])
    
    #-----< Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst >-----#
    Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst = SEQ(name='Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_InformationModify_PSCH_ReconfRqst = SEQ_OF(name='hS-SCCH-InformationModify-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationModify-PSCH-ReconfRqst')), opt=True)
    _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_InformationModify_LCR_PSCH_ReconfRqst = SEQ_OF(name='hS-SCCH-InformationModify-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationModify-LCR-PSCH-ReconfRqst')), opt=True)
    _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationModify-768-PSCH-ReconfRqst')))
    _____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationModifyExt-LCR-PSCH-ReconfRqst')))
    ____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 770), ('criticality', 'reject'), ('Extension', _____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 940), ('criticality', 'ignore'), ('Extension', _____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions._cont = __Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_
    _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hS-SCCH-InformationModify-PSCH-ReconfRqst', _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_InformationModify_PSCH_ReconfRqst),
        ('hS-SCCH-InformationModify-LCR-PSCH-ReconfRqst', _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_InformationModify_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions),
        ])
    Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst._ext = []
    
    #-----< Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs >-----#
    Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs = CLASS(name='Modify-HS-SCCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationModify-768-PSCH-ReconfRqst')))
    _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationModifyExt-LCR-PSCH-ReconfRqst')))
    Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 770), ('criticality', 'reject'), ('Extension', _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 940), ('criticality', 'ignore'), ('Extension', _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-InformationModifyItem-PSCH-ReconfRqst >-----#
    HS_SCCH_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='HS-SCCH-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_hS_SCCH_ID = INT(name='hS-SCCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-ID')))
    _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')), opt=True)
    _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_hS_SCCH_MaxPower = INT(name='hS-SCCH-MaxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_hS_SICH_Information = SEQ(name='hS-SICH-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SICH-InformationModify-PSCH-ReconfRqst')), opt=True)
    _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hS-SCCH-ID', _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_hS_SCCH_ID),
        ('timeSlot', _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('tdd-ChannelisationCode', _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('hS-SCCH-MaxPower', _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_hS_SCCH_MaxPower),
        ('hS-SICH-Information', _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_hS_SICH_Information),
        ('iE-Extensions', _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SCCH_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SCCH-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SCCH-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-InformationModify-PSCH-ReconfRqst >-----#
    HS_SICH_InformationModify_PSCH_ReconfRqst = SEQ(name='HS-SICH-InformationModify-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SICH_InformationModify_PSCH_ReconfRqst_hsSICH_ID = INT(name='hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _HS_SICH_InformationModify_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')), opt=True)
    _HS_SICH_InformationModify_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _HS_SICH_InformationModify_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SICH_InformationModify_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hsSICH-ID', _HS_SICH_InformationModify_PSCH_ReconfRqst_hsSICH_ID),
        ('timeSlot', _HS_SICH_InformationModify_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _HS_SICH_InformationModify_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('tdd-ChannelisationCode', _HS_SICH_InformationModify_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('iE-Extensions', _HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SICH_InformationModify_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SICH-InformationModify-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SICH_InformationModify_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SICH-InformationModify-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_SICH_InformationModify_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-InformationModify-LCR-PSCH-ReconfRqst >-----#
    HS_SCCH_InformationModify_LCR_PSCH_ReconfRqst = SEQ_OF(name='HS-SCCH-InformationModify-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_InformationModify_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationModifyItem-LCR-PSCH-ReconfRqst')))
    HS_SCCH_InformationModify_LCR_PSCH_ReconfRqst._cont = _HS_SCCH_InformationModify_LCR_PSCH_ReconfRqst__item_
    HS_SCCH_InformationModify_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< HS-SCCH-InformationModifyItem-LCR-PSCH-ReconfRqst >-----#
    HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst = SEQ(name='HS-SCCH-InformationModifyItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_hS_SCCH_ID = INT(name='hS-SCCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-ID')))
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')), opt=True)
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')), opt=True)
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode = ENUM(name='first-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode = ENUM(name='second-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_hS_SCCH_MaxPower = INT(name='hS-SCCH-MaxPower', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_hS_SICH_Information_LCR = SEQ(name='hS-SICH-Information-LCR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SICH-InformationModify-LCR-PSCH-ReconfRqst')), opt=True)
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SCCH-ID')))
    _____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSICH-ReferenceSignal-InformationModifyLCR')))
    ____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 935), ('criticality', 'ignore'), ('Extension', _____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1080), ('criticality', 'reject'), ('Extension', _____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hS-SCCH-ID', _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_hS_SCCH_ID),
        ('timeSlotLCR', _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_midambleShiftLCR),
        ('first-TDD-ChannelisationCode', _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode),
        ('second-TDD-ChannelisationCode', _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode),
        ('hS-SCCH-MaxPower', _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_hS_SCCH_MaxPower),
        ('hS-SICH-Information-LCR', _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_hS_SICH_Information_LCR),
        ('iE-Extensions', _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SCCH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SCCH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SCCH-ID')))
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSSICH-ReferenceSignal-InformationModifyLCR')))
    HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 935), ('criticality', 'ignore'), ('Extension', _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 1080), ('criticality', 'reject'), ('Extension', _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-InformationModifyExt-LCR-PSCH-ReconfRqst >-----#
    HS_SCCH_InformationModifyExt_LCR_PSCH_ReconfRqst = SEQ_OF(name='HS-SCCH-InformationModifyExt-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_InformationModifyExt_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationModifyItem-LCR-PSCH-ReconfRqst')))
    HS_SCCH_InformationModifyExt_LCR_PSCH_ReconfRqst._cont = _HS_SCCH_InformationModifyExt_LCR_PSCH_ReconfRqst__item_
    HS_SCCH_InformationModifyExt_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=224)], ev=None, er=[])
    
    #-----< HS-SICH-InformationModify-LCR-PSCH-ReconfRqst >-----#
    HS_SICH_InformationModify_LCR_PSCH_ReconfRqst = SEQ(name='HS-SICH-InformationModify-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_hsSICH_ID = INT(name='hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')), opt=True)
    _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')), opt=True)
    _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    ____HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 936), ('criticality', 'ignore'), ('Extension', _____HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SICH_InformationModify_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hsSICH-ID', _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_hsSICH_ID),
        ('timeSlotLCR', _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_midambleShiftLCR),
        ('tdd-ChannelisationCode', _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('iE-Extensions', _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SICH_InformationModify_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SICH-InformationModify-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SICH-InformationModify-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SICH-ID')))
    HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 936), ('criticality', 'ignore'), ('Extension', _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-InformationModify-768-PSCH-ReconfRqst >-----#
    HS_SCCH_InformationModify_768_PSCH_ReconfRqst = SEQ_OF(name='HS-SCCH-InformationModify-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_InformationModify_768_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationModifyItem-768-PSCH-ReconfRqst')))
    HS_SCCH_InformationModify_768_PSCH_ReconfRqst._cont = _HS_SCCH_InformationModify_768_PSCH_ReconfRqst__item_
    HS_SCCH_InformationModify_768_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< HS-SCCH-InformationModifyItem-768-PSCH-ReconfRqst >-----#
    HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst = SEQ(name='HS-SCCH-InformationModifyItem-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_hS_SCCH_ID = INT(name='hS-SCCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-ID')))
    _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')), opt=True)
    _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_hS_SCCH_MaxPower = INT(name='hS-SCCH-MaxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_hS_SICH_Information_768 = SEQ(name='hS-SICH-Information-768', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SICH-InformationModify-768-PSCH-ReconfRqst')), opt=True)
    _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hS-SCCH-ID', _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_hS_SCCH_ID),
        ('timeSlot', _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType768', _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('tdd-ChannelisationCode768', _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768),
        ('hS-SCCH-MaxPower', _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_hS_SCCH_MaxPower),
        ('hS-SICH-Information-768', _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_hS_SICH_Information_768),
        ('iE-Extensions', _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SCCH-InformationModifyItem-768-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SCCH-InformationModifyItem-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-InformationModify-768-PSCH-ReconfRqst >-----#
    HS_SICH_InformationModify_768_PSCH_ReconfRqst = SEQ(name='HS-SICH-InformationModify-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SICH_InformationModify_768_PSCH_ReconfRqst_hsSICH_ID = INT(name='hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SICH-ID')))
    _HS_SICH_InformationModify_768_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')), opt=True)
    _HS_SICH_InformationModify_768_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _HS_SICH_InformationModify_768_PSCH_ReconfRqst_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions._cont = __HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item_
    _HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SICH_InformationModify_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hsSICH-ID', _HS_SICH_InformationModify_768_PSCH_ReconfRqst_hsSICH_ID),
        ('timeSlot', _HS_SICH_InformationModify_768_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType768', _HS_SICH_InformationModify_768_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('tdd-ChannelisationCode768', _HS_SICH_InformationModify_768_PSCH_ReconfRqst_tdd_ChannelisationCode768),
        ('iE-Extensions', _HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    HS_SICH_InformationModify_768_PSCH_ReconfRqst._ext = []
    
    #-----< HS-SICH-InformationModify-768-PSCH-ReconfRqst-ExtIEs >-----#
    HS_SICH_InformationModify_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='HS-SICH-InformationModify-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HS_SICH_InformationModify_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-InformationModify-PSCH-ReconfRqst >-----#
    HS_SCCH_InformationModify_PSCH_ReconfRqst = SEQ_OF(name='HS-SCCH-InformationModify-PSCH-ReconfRqst', mode=MODE_TYPE)
    _HS_SCCH_InformationModify_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HS-SCCH-InformationModifyItem-PSCH-ReconfRqst')))
    HS_SCCH_InformationModify_PSCH_ReconfRqst._cont = _HS_SCCH_InformationModify_PSCH_ReconfRqst__item_
    HS_SCCH_InformationModify_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Delete-From-HS-SCCH-Resource-Pool-PSCH-ReconfRqst >-----#
    Delete_From_HS_SCCH_Resource_Pool_PSCH_ReconfRqst = SEQ_OF(name='Delete-From-HS-SCCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Delete_From_HS_SCCH_Resource_Pool_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-HS-SCCH-Resource-PoolItem-PSCH-ReconfRqst')))
    Delete_From_HS_SCCH_Resource_Pool_PSCH_ReconfRqst._cont = _Delete_From_HS_SCCH_Resource_Pool_PSCH_ReconfRqst__item_
    Delete_From_HS_SCCH_Resource_Pool_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Delete-From-HS-SCCH-Resource-PoolItem-PSCH-ReconfRqst >-----#
    Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst = SEQ(name='Delete-From-HS-SCCH-Resource-PoolItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_hS_SCCH_ID = INT(name='hS-SCCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-SCCH-ID')))
    _Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SCCH-ID')))
    ____Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 935), ('criticality', 'ignore'), ('Extension', _____Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions._cont = __Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_
    _Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('hS-SCCH-ID', _Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_hS_SCCH_ID),
        ('iE-Extensions', _Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst._ext = []
    
    #-----< Delete-From-HS-SCCH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs >-----#
    Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='Delete-From-HS-SCCH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-HS-SCCH-ID')))
    Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 935), ('criticality', 'ignore'), ('Extension', _Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-PUCH-Information-PSCH-ReconfRqst >-----#
    E_PUCH_Information_PSCH_ReconfRqst = SEQ(name='E-PUCH-Information-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_PUCH_Information_PSCH_ReconfRqst_lTGI_Presence = BOOL(name='lTGI-Presence', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LTGI-Presence')))
    _E_PUCH_Information_PSCH_ReconfRqst_sNPL_Reporting_Type = ENUM(name='sNPL-Reporting-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SNPL-Reporting-Type')))
    _E_PUCH_Information_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _E_PUCH_Information_PSCH_ReconfRqst_e_PUCH_Timeslot_Info = SEQ_OF(name='e-PUCH-Timeslot-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Timeslot-Info')))
    _E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions._cont = __E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item_
    _E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_PUCH_Information_PSCH_ReconfRqst._cont = ASN1Dict([
        ('lTGI-Presence', _E_PUCH_Information_PSCH_ReconfRqst_lTGI_Presence),
        ('sNPL-Reporting-Type', _E_PUCH_Information_PSCH_ReconfRqst_sNPL_Reporting_Type),
        ('midambleShiftAndBurstType', _E_PUCH_Information_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('e-PUCH-Timeslot-Info', _E_PUCH_Information_PSCH_ReconfRqst_e_PUCH_Timeslot_Info),
        ('iE-Extensions', _E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_PUCH_Information_PSCH_ReconfRqst._ext = []
    
    #-----< E-PUCH-Information-PSCH-ReconfRqst-ExtIEs >-----#
    E_PUCH_Information_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-PUCH-Information-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_PUCH_Information_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-PUCH-Timeslot-Info >-----#
    E_PUCH_Timeslot_Info = SEQ_OF(name='E-PUCH-Timeslot-Info', mode=MODE_TYPE)
    _E_PUCH_Timeslot_Info__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    E_PUCH_Timeslot_Info._cont = _E_PUCH_Timeslot_Info__item_
    E_PUCH_Timeslot_Info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst >-----#
    Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst = SEQ(name='Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_e_AGCH_Information_PSCH_ReconfRqst = SEQ_OF(name='e-AGCH-Information-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-Information-PSCH-ReconfRqst')), opt=True)
    _Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions._cont = __Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_
    _Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-Information-PSCH-ReconfRqst', _Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_e_AGCH_Information_PSCH_ReconfRqst),
        ('iE-Extensions', _Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions),
        ])
    Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst._ext = []
    
    #-----< Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs >-----#
    Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs = CLASS(name='Add-To-E-AGCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-Information-PSCH-ReconfRqst >-----#
    E_AGCH_Information_PSCH_ReconfRqst = SEQ_OF(name='E-AGCH-Information-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_Information_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-InformationItem-PSCH-ReconfRqst')))
    E_AGCH_Information_PSCH_ReconfRqst._cont = _E_AGCH_Information_PSCH_ReconfRqst__item_
    E_AGCH_Information_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-AGCH-InformationItem-PSCH-ReconfRqst >-----#
    E_AGCH_InformationItem_PSCH_ReconfRqst = SEQ(name='E-AGCH-InformationItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_InformationItem_PSCH_ReconfRqst_e_AGCH_ID = INT(name='e-AGCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Id')))
    _E_AGCH_InformationItem_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _E_AGCH_InformationItem_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _E_AGCH_InformationItem_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _E_AGCH_InformationItem_PSCH_ReconfRqst_e_AGCH_MaxPower = INT(name='e-AGCH-MaxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions._cont = __E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_
    _E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_InformationItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-ID', _E_AGCH_InformationItem_PSCH_ReconfRqst_e_AGCH_ID),
        ('timeSlot', _E_AGCH_InformationItem_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _E_AGCH_InformationItem_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('tdd-ChannelisationCode', _E_AGCH_InformationItem_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('e-AGCH-MaxPower', _E_AGCH_InformationItem_PSCH_ReconfRqst_e_AGCH_MaxPower),
        ('iE-Extensions', _E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_AGCH_InformationItem_PSCH_ReconfRqst._ext = []
    
    #-----< E-AGCH-InformationItem-PSCH-ReconfRqst-ExtIEs >-----#
    E_AGCH_InformationItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-AGCH-InformationItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_AGCH_InformationItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst >-----#
    Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst = SEQ(name='Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_e_AGCH_InformationModify_PSCH_ReconfRqst = SEQ_OF(name='e-AGCH-InformationModify-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-InformationModify-PSCH-ReconfRqst')), opt=True)
    _Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions._cont = __Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_
    _Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-InformationModify-PSCH-ReconfRqst', _Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_e_AGCH_InformationModify_PSCH_ReconfRqst),
        ('iE-Extensions', _Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions),
        ])
    Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst._ext = []
    
    #-----< Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs >-----#
    Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs = CLASS(name='Modify-E-AGCH-Resource-Pool-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-InformationModify-PSCH-ReconfRqst >-----#
    E_AGCH_InformationModify_PSCH_ReconfRqst = SEQ_OF(name='E-AGCH-InformationModify-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_InformationModify_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-InformationModifyItem-PSCH-ReconfRqst')))
    E_AGCH_InformationModify_PSCH_ReconfRqst._cont = _E_AGCH_InformationModify_PSCH_ReconfRqst__item_
    E_AGCH_InformationModify_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-AGCH-InformationModifyItem-PSCH-ReconfRqst >-----#
    E_AGCH_InformationModifyItem_PSCH_ReconfRqst = SEQ(name='E-AGCH-InformationModifyItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_e_AGCH_ID = INT(name='e-AGCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Id')))
    _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')), opt=True)
    _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_e_AGCH_MaxPower = INT(name='e-AGCH-MaxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._cont = __E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_
    _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_InformationModifyItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-ID', _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_e_AGCH_ID),
        ('timeSlot', _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType', _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('tdd-ChannelisationCode', _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('e-AGCH-MaxPower', _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_e_AGCH_MaxPower),
        ('iE-Extensions', _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_AGCH_InformationModifyItem_PSCH_ReconfRqst._ext = []
    
    #-----< E-AGCH-InformationModifyItem-PSCH-ReconfRqst-ExtIEs >-----#
    E_AGCH_InformationModifyItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-AGCH-InformationModifyItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_AGCH_InformationModifyItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Delete-From-E-AGCH-Resource-Pool-PSCH-ReconfRqst >-----#
    Delete_From_E_AGCH_Resource_Pool_PSCH_ReconfRqst = SEQ_OF(name='Delete-From-E-AGCH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Delete_From_E_AGCH_Resource_Pool_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-E-AGCH-Resource-PoolItem-PSCH-ReconfRqst')))
    Delete_From_E_AGCH_Resource_Pool_PSCH_ReconfRqst._cont = _Delete_From_E_AGCH_Resource_Pool_PSCH_ReconfRqst__item_
    Delete_From_E_AGCH_Resource_Pool_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Delete-From-E-AGCH-Resource-PoolItem-PSCH-ReconfRqst >-----#
    Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst = SEQ(name='Delete-From-E-AGCH-Resource-PoolItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_e_AGCH_ID = INT(name='e-AGCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Id')))
    _Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions._cont = __Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_
    _Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-ID', _Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_e_AGCH_ID),
        ('iE-Extensions', _Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst._ext = []
    
    #-----< Delete-From-E-AGCH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs >-----#
    Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='Delete-From-E-AGCH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-Information-PSCH-ReconfRqst >-----#
    E_HICH_Information_PSCH_ReconfRqst = SEQ(name='E-HICH-Information-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_HICH_Information_PSCH_ReconfRqst_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType')))
    _E_HICH_Information_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _E_HICH_Information_PSCH_ReconfRqst_e_HICH_MaxPower = INT(name='e-HICH-MaxPower', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _E_HICH_Information_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_HICH_Information_PSCH_ReconfRqst_iE_Extensions._cont = __E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item_
    _E_HICH_Information_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_HICH_Information_PSCH_ReconfRqst._cont = ASN1Dict([
        ('midambleShiftAndBurstType', _E_HICH_Information_PSCH_ReconfRqst_midambleShiftAndBurstType),
        ('tdd-ChannelisationCode', _E_HICH_Information_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('e-HICH-MaxPower', _E_HICH_Information_PSCH_ReconfRqst_e_HICH_MaxPower),
        ('iE-Extensions', _E_HICH_Information_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_HICH_Information_PSCH_ReconfRqst._ext = []
    
    #-----< E-HICH-Information-PSCH-ReconfRqst-ExtIEs >-----#
    E_HICH_Information_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-HICH-Information-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_HICH_Information_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-PUCH-Information-768-PSCH-ReconfRqst >-----#
    E_PUCH_Information_768_PSCH_ReconfRqst = SEQ(name='E-PUCH-Information-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_PUCH_Information_768_PSCH_ReconfRqst_lTGI_Presence = BOOL(name='lTGI-Presence', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LTGI-Presence')))
    _E_PUCH_Information_768_PSCH_ReconfRqst_sNPL_Reporting_Type = ENUM(name='sNPL-Reporting-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SNPL-Reporting-Type')))
    _E_PUCH_Information_768_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _E_PUCH_Information_768_PSCH_ReconfRqst_e_PUCH_Timeslot_Info = SEQ_OF(name='e-PUCH-Timeslot-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Timeslot-Info')))
    _E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions._cont = __E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_
    _E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_PUCH_Information_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('lTGI-Presence', _E_PUCH_Information_768_PSCH_ReconfRqst_lTGI_Presence),
        ('sNPL-Reporting-Type', _E_PUCH_Information_768_PSCH_ReconfRqst_sNPL_Reporting_Type),
        ('midambleShiftAndBurstType768', _E_PUCH_Information_768_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('e-PUCH-Timeslot-Info', _E_PUCH_Information_768_PSCH_ReconfRqst_e_PUCH_Timeslot_Info),
        ('iE-Extensions', _E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_PUCH_Information_768_PSCH_ReconfRqst._ext = []
    
    #-----< E-PUCH-Information-768-PSCH-ReconfRqst-ExtIEs >-----#
    E_PUCH_Information_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-PUCH-Information-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_PUCH_Information_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst >-----#
    Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst = SEQ(name='Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_e_AGCH_Information_768_PSCH_ReconfRqst = SEQ_OF(name='e-AGCH-Information-768-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-Information-768-PSCH-ReconfRqst')), opt=True)
    _Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions._cont = __Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item_
    _Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-Information-768-PSCH-ReconfRqst', _Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_e_AGCH_Information_768_PSCH_ReconfRqst),
        ('iE-Extensions', _Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst._ext = []
    
    #-----< Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst-ExtIEs >-----#
    Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='Add-To-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-Information-768-PSCH-ReconfRqst >-----#
    E_AGCH_Information_768_PSCH_ReconfRqst = SEQ_OF(name='E-AGCH-Information-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_Information_768_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-InformationItem-768-PSCH-ReconfRqst')))
    E_AGCH_Information_768_PSCH_ReconfRqst._cont = _E_AGCH_Information_768_PSCH_ReconfRqst__item_
    E_AGCH_Information_768_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-AGCH-InformationItem-768-PSCH-ReconfRqst >-----#
    E_AGCH_InformationItem_768_PSCH_ReconfRqst = SEQ(name='E-AGCH-InformationItem-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_InformationItem_768_PSCH_ReconfRqst_e_AGCH_ID = INT(name='e-AGCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Id')))
    _E_AGCH_InformationItem_768_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _E_AGCH_InformationItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _E_AGCH_InformationItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _E_AGCH_InformationItem_768_PSCH_ReconfRqst_e_AGCH_MaxPower = INT(name='e-AGCH-MaxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions._cont = __E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_
    _E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_InformationItem_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-ID', _E_AGCH_InformationItem_768_PSCH_ReconfRqst_e_AGCH_ID),
        ('timeSlot', _E_AGCH_InformationItem_768_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType768', _E_AGCH_InformationItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('tdd-ChannelisationCode768', _E_AGCH_InformationItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768),
        ('e-AGCH-MaxPower', _E_AGCH_InformationItem_768_PSCH_ReconfRqst_e_AGCH_MaxPower),
        ('iE-Extensions', _E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_AGCH_InformationItem_768_PSCH_ReconfRqst._ext = []
    
    #-----< E-AGCH-InformationItem-768-PSCH-ReconfRqst-ExtIEs >-----#
    E_AGCH_InformationItem_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-AGCH-InformationItem-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_AGCH_InformationItem_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst >-----#
    Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst = SEQ(name='Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_e_AGCH_InformationModify_768_PSCH_ReconfRqst = SEQ_OF(name='e-AGCH-InformationModify-768-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-InformationModify-768-PSCH-ReconfRqst')), opt=True)
    _Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions._cont = __Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item_
    _Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-InformationModify-768-PSCH-ReconfRqst', _Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_e_AGCH_InformationModify_768_PSCH_ReconfRqst),
        ('iE-Extensions', _Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst._ext = []
    
    #-----< Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst-ExtIEs >-----#
    Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='Modify-E-AGCH-Resource-Pool-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-InformationModify-768-PSCH-ReconfRqst >-----#
    E_AGCH_InformationModify_768_PSCH_ReconfRqst = SEQ_OF(name='E-AGCH-InformationModify-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_InformationModify_768_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-InformationModifyItem-768-PSCH-ReconfRqst')))
    E_AGCH_InformationModify_768_PSCH_ReconfRqst._cont = _E_AGCH_InformationModify_768_PSCH_ReconfRqst__item_
    E_AGCH_InformationModify_768_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-AGCH-InformationModifyItem-768-PSCH-ReconfRqst >-----#
    E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst = SEQ(name='E-AGCH-InformationModifyItem-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_e_AGCH_ID = INT(name='e-AGCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Id')))
    _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')), opt=True)
    _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')), opt=True)
    _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')), opt=True)
    _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_e_AGCH_MaxPower = INT(name='e-AGCH-MaxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions._cont = __E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item_
    _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-ID', _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_e_AGCH_ID),
        ('timeSlot', _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_timeSlot),
        ('midambleShiftAndBurstType768', _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('tdd-ChannelisationCode768', _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768),
        ('e-AGCH-MaxPower', _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_e_AGCH_MaxPower),
        ('iE-Extensions', _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst._ext = []
    
    #-----< E-AGCH-InformationModifyItem-768-PSCH-ReconfRqst-ExtIEs >-----#
    E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-AGCH-InformationModifyItem-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-Information-768-PSCH-ReconfRqst >-----#
    E_HICH_Information_768_PSCH_ReconfRqst = SEQ(name='E-HICH-Information-768-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_HICH_Information_768_PSCH_ReconfRqst_midambleShiftAndBurstType768 = CHOICE(name='midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftAndBurstType768')))
    _E_HICH_Information_768_PSCH_ReconfRqst_tdd_ChannelisationCode768 = ENUM(name='tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode768')))
    _E_HICH_Information_768_PSCH_ReconfRqst_e_HICH_MaxPower = INT(name='e-HICH-MaxPower', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions._cont = __E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_
    _E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_HICH_Information_768_PSCH_ReconfRqst._cont = ASN1Dict([
        ('midambleShiftAndBurstType768', _E_HICH_Information_768_PSCH_ReconfRqst_midambleShiftAndBurstType768),
        ('tdd-ChannelisationCode768', _E_HICH_Information_768_PSCH_ReconfRqst_tdd_ChannelisationCode768),
        ('e-HICH-MaxPower', _E_HICH_Information_768_PSCH_ReconfRqst_e_HICH_MaxPower),
        ('iE-Extensions', _E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_HICH_Information_768_PSCH_ReconfRqst._ext = []
    
    #-----< E-HICH-Information-768-PSCH-ReconfRqst-ExtIEs >-----#
    E_HICH_Information_768_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-HICH-Information-768-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_HICH_Information_768_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-PUCH-Information-LCR-PSCH-ReconfRqst >-----#
    E_PUCH_Information_LCR_PSCH_ReconfRqst = SEQ(name='E-PUCH-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_PUCH_Information_LCR_PSCH_ReconfRqst_lTGI_Presence = BOOL(name='lTGI-Presence', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'LTGI-Presence')))
    _E_PUCH_Information_LCR_PSCH_ReconfRqst_sNPL_Reporting_Type = ENUM(name='sNPL-Reporting-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SNPL-Reporting-Type')))
    _E_PUCH_Information_LCR_PSCH_ReconfRqst_e_PUCH_Timeslot_InfoLCR = SEQ_OF(name='e-PUCH-Timeslot-InfoLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Timeslot-InfoLCR')), opt=True)
    _E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-E-PUCH-Timeslot-InformationList-LCR-PSCH-ReconfRqst')))
    ____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 955), ('criticality', 'reject'), ('Extension', _____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_PUCH_Information_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('lTGI-Presence', _E_PUCH_Information_LCR_PSCH_ReconfRqst_lTGI_Presence),
        ('sNPL-Reporting-Type', _E_PUCH_Information_LCR_PSCH_ReconfRqst_sNPL_Reporting_Type),
        ('e-PUCH-Timeslot-InfoLCR', _E_PUCH_Information_LCR_PSCH_ReconfRqst_e_PUCH_Timeslot_InfoLCR),
        ('iE-Extensions', _E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_PUCH_Information_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< E-PUCH-Information-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    E_PUCH_Information_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-PUCH-Information-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_PUCH_Information_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _E_PUCH_Information_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-E-PUCH-Timeslot-InformationList-LCR-PSCH-ReconfRqst')))
    E_PUCH_Information_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _E_PUCH_Information_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 955), ('criticality', 'reject'), ('Extension', _E_PUCH_Information_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-PUCH-Timeslot-InfoLCR >-----#
    E_PUCH_Timeslot_InfoLCR = SEQ_OF(name='E-PUCH-Timeslot-InfoLCR', mode=MODE_TYPE)
    _E_PUCH_Timeslot_InfoLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Timeslot-Item-InfoLCR')))
    E_PUCH_Timeslot_InfoLCR._cont = _E_PUCH_Timeslot_InfoLCR__item_
    E_PUCH_Timeslot_InfoLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< E-PUCH-Timeslot-Item-InfoLCR >-----#
    E_PUCH_Timeslot_Item_InfoLCR = SEQ(name='E-PUCH-Timeslot-Item-InfoLCR', mode=MODE_TYPE)
    _E_PUCH_Timeslot_Item_InfoLCR_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _E_PUCH_Timeslot_Item_InfoLCR_midambleShiftAndBurstType = SEQ(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _E_PUCH_Timeslot_Item_InfoLCR_e_PUCH_Codelist_LCR = SEQ_OF(name='e-PUCH-Codelist-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Codelist-LCR')))
    _E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__id._const_tab = ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__id_tab
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__id._const_tab_at = None
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__criticality._const_tab = ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__criticality_tab
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__extensionValue._const_tab = ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__extensionValue_tab
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__id),
        ('criticality', ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__extensionValue),
        ])
    __E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item_._ext = None
    _E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions._cont = __E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item_
    _E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_PUCH_Timeslot_Item_InfoLCR._cont = ASN1Dict([
        ('timeSlot', _E_PUCH_Timeslot_Item_InfoLCR_timeSlot),
        ('midambleShiftAndBurstType', _E_PUCH_Timeslot_Item_InfoLCR_midambleShiftAndBurstType),
        ('e-PUCH-Codelist-LCR', _E_PUCH_Timeslot_Item_InfoLCR_e_PUCH_Codelist_LCR),
        ('iE-Extensions', _E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions),
        ])
    E_PUCH_Timeslot_Item_InfoLCR._ext = []
    
    #-----< E-PUCH-Timeslot-Item-InfoLCR-ExtIEs >-----#
    E_PUCH_Timeslot_Item_InfoLCR_ExtIEs = CLASS(name='E-PUCH-Timeslot-Item-InfoLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    E_PUCH_Timeslot_Item_InfoLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-PUCH-Codelist-LCR >-----#
    E_PUCH_Codelist_LCR = SEQ_OF(name='E-PUCH-Codelist-LCR', mode=MODE_TYPE)
    _E_PUCH_Codelist_LCR__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    E_PUCH_Codelist_LCR._cont = _E_PUCH_Codelist_LCR__item_
    E_PUCH_Codelist_LCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst = SEQ(name='Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_e_AGCH_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='e-AGCH-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-Information-LCR-PSCH-ReconfRqst')))
    _Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-Information-LCR-PSCH-ReconfRqst', _Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_e_AGCH_Information_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='Add-To-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-Information-LCR-PSCH-ReconfRqst >-----#
    E_AGCH_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='E-AGCH-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_Information_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-InformationItem-LCR-PSCH-ReconfRqst')))
    E_AGCH_Information_LCR_PSCH_ReconfRqst._cont = _E_AGCH_Information_LCR_PSCH_ReconfRqst__item_
    E_AGCH_Information_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-AGCH-InformationItem-LCR-PSCH-ReconfRqst >-----#
    E_AGCH_InformationItem_LCR_PSCH_ReconfRqst = SEQ(name='E-AGCH-InformationItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_e_AGCH_ID = INT(name='e-AGCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Id')))
    _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode = ENUM(name='first-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode = ENUM(name='second-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_e_AGCH_MaxPower = INT(name='e-AGCH-MaxPower', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_InformationItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-ID', _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_e_AGCH_ID),
        ('timeSlotLCR', _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftLCR),
        ('first-TDD-ChannelisationCode', _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode),
        ('second-TDD-ChannelisationCode', _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode),
        ('e-AGCH-MaxPower', _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_e_AGCH_MaxPower),
        ('iE-Extensions', _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_AGCH_InformationItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< E-AGCH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-AGCH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst = SEQ(name='Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_e_AGCH_InformationModify_LCR_PSCH_ReconfRqst = SEQ_OF(name='e-AGCH-InformationModify-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-InformationModify-LCR-PSCH-ReconfRqst')))
    _Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-InformationModify-LCR-PSCH-ReconfRqst', _Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_e_AGCH_InformationModify_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='Modify-E-AGCH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-InformationModify-LCR-PSCH-ReconfRqst >-----#
    E_AGCH_InformationModify_LCR_PSCH_ReconfRqst = SEQ_OF(name='E-AGCH-InformationModify-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_InformationModify_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-AGCH-InformationModifyItem-LCR-PSCH-ReconfRqst')))
    E_AGCH_InformationModify_LCR_PSCH_ReconfRqst._cont = _E_AGCH_InformationModify_LCR_PSCH_ReconfRqst__item_
    E_AGCH_InformationModify_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-AGCH-InformationModifyItem-LCR-PSCH-ReconfRqst >-----#
    E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst = SEQ(name='E-AGCH-InformationModifyItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_AGCH_ID = INT(name='e-AGCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-AGCH-Id')))
    _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')), opt=True)
    _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')), opt=True)
    _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode = ENUM(name='first-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode = ENUM(name='second-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_AGCH_MaxPower = INT(name='e-AGCH-MaxPower', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-AGCH-ID', _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_AGCH_ID),
        ('timeSlotLCR', _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_midambleShiftLCR),
        ('first-TDD-ChannelisationCode', _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode),
        ('second-TDD-ChannelisationCode', _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode),
        ('e-AGCH-MaxPower', _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_AGCH_MaxPower),
        ('iE-Extensions', _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< E-AGCH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-AGCH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 280), ('criticality', 'ignore'), ('Extension', _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst = SEQ(name='Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_e_HICH_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='e-HICH-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-Information-LCR-PSCH-ReconfRqst')))
    _Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-HICH-Information-LCR-PSCH-ReconfRqst', _Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_e_HICH_Information_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='Add-To-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-Information-LCR-PSCH-ReconfRqst >-----#
    E_HICH_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='E-HICH-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_HICH_Information_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-InformationItem-LCR-PSCH-ReconfRqst')))
    E_HICH_Information_LCR_PSCH_ReconfRqst._cont = _E_HICH_Information_LCR_PSCH_ReconfRqst__item_
    E_HICH_Information_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-HICH-InformationItem-LCR-PSCH-ReconfRqst >-----#
    E_HICH_InformationItem_LCR_PSCH_ReconfRqst = SEQ(name='E-HICH-InformationItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_e_HICH_ID_TDD = INT(name='e-HICH-ID-TDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-ID-TDD')))
    _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_e_HICH_Type = ENUM(name='e-HICH-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-Type')))
    _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')))
    _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')))
    _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')))
    _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_e_HICH_MaxPower = INT(name='e-HICH-MaxPower', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-HICH-ID-TDD')))
    _____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 957), ('criticality', 'ignore'), ('Extension', _____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_HICH_InformationItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-HICH-ID-TDD', _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_e_HICH_ID_TDD),
        ('e-HICH-Type', _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_e_HICH_Type),
        ('tdd-ChannelisationCode', _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('timeSlotLCR', _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftLCR),
        ('e-HICH-MaxPower', _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_e_HICH_MaxPower),
        ('iE-Extensions', _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_HICH_InformationItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< E-HICH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    E_HICH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-HICH-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-HICH-ID-TDD')))
    _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    E_HICH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 957), ('criticality', 'ignore'), ('Extension', _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst >-----#
    Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst = SEQ(name='Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_e_HICH_InformationModify_LCR_PSCH_ReconfRqst = SEQ_OF(name='e-HICH-InformationModify-LCR-PSCH-ReconfRqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-InformationModify-LCR-PSCH-ReconfRqst')))
    _Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-HICH-InformationModify-LCR-PSCH-ReconfRqst', _Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_e_HICH_InformationModify_LCR_PSCH_ReconfRqst),
        ('iE-Extensions', _Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='Modify-E-HICH-Resource-Pool-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-InformationModify-LCR-PSCH-ReconfRqst >-----#
    E_HICH_InformationModify_LCR_PSCH_ReconfRqst = SEQ_OF(name='E-HICH-InformationModify-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_HICH_InformationModify_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-InformationModifyItem-LCR-PSCH-ReconfRqst')))
    E_HICH_InformationModify_LCR_PSCH_ReconfRqst._cont = _E_HICH_InformationModify_LCR_PSCH_ReconfRqst__item_
    E_HICH_InformationModify_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-HICH-InformationModifyItem-LCR-PSCH-ReconfRqst >-----#
    E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst = SEQ(name='E-HICH-InformationModifyItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_HICH_ID_TDD = INT(name='e-HICH-ID-TDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-ID-TDD')))
    _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_HICH_Type = ENUM(name='e-HICH-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-Type')), opt=True)
    _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_timeSlotLCR = INT(name='timeSlotLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimeSlotLCR')), opt=True)
    _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_midambleShiftLCR = SEQ(name='midambleShiftLCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MidambleShiftLCR')), opt=True)
    _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_HICH_MaxPower = INT(name='e-HICH-MaxPower', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-HICH-ID-TDD')))
    _____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    ____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 957), ('criticality', 'ignore'), ('Extension', _____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-HICH-ID-TDD', _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_HICH_ID_TDD),
        ('e-HICH-Type', _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_HICH_Type),
        ('tdd-ChannelisationCode', _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode),
        ('timeSlotLCR', _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_timeSlotLCR),
        ('midambleShiftLCR', _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_midambleShiftLCR),
        ('e-HICH-MaxPower', _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_HICH_MaxPower),
        ('iE-Extensions', _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< E-HICH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='E-HICH-InformationModifyItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-HICH-ID-TDD')))
    _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 957), ('criticality', 'ignore'), ('Extension', _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Delete-From-E-HICH-Resource-Pool-PSCH-ReconfRqst >-----#
    Delete_From_E_HICH_Resource_Pool_PSCH_ReconfRqst = SEQ_OF(name='Delete-From-E-HICH-Resource-Pool-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Delete_From_E_HICH_Resource_Pool_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-E-HICH-Resource-PoolItem-PSCH-ReconfRqst')))
    Delete_From_E_HICH_Resource_Pool_PSCH_ReconfRqst._cont = _Delete_From_E_HICH_Resource_Pool_PSCH_ReconfRqst__item_
    Delete_From_E_HICH_Resource_Pool_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Delete-From-E-HICH-Resource-PoolItem-PSCH-ReconfRqst >-----#
    Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst = SEQ(name='Delete-From-E-HICH-Resource-PoolItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_e_HICH_ID_TDD = INT(name='e-HICH-ID-TDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-ID-TDD')))
    _Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-HICH-ID-TDD')))
    ____Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 957), ('criticality', 'ignore'), ('Extension', _____Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions._cont = __Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_
    _Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-HICH-ID-TDD', _Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_e_HICH_ID_TDD),
        ('iE-Extensions', _Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst._ext = []
    
    #-----< Delete-From-E-HICH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs >-----#
    Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='Delete-From-E-HICH-Resource-PoolItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Extended-E-HICH-ID-TDD')))
    Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[dict([('id', 957), ('criticality', 'ignore'), ('Extension', _Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SYNC-UL-Partition-LCR >-----#
    SYNC_UL_Partition_LCR = SEQ(name='SYNC-UL-Partition-LCR', mode=MODE_TYPE)
    _SYNC_UL_Partition_LCR_eRUCCH_SYNC_UL_codes_bitmap = BIT_STR(name='eRUCCH-SYNC-UL-codes-bitmap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SYNC_UL_Partition_LCR_eRUCCH_SYNC_UL_codes_bitmap._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SYNC_UL_Partition_LCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SYNC_UL_Partition_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SYNC_UL_Partition_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNC_UL_Partition_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__id._const_tab = ____SYNC_UL_Partition_LCR_iE_Extensions__item__id_tab
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__id._const_tab_at = None
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SYNC_UL_Partition_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNC_UL_Partition_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__criticality._const_tab = ____SYNC_UL_Partition_LCR_iE_Extensions__item__criticality_tab
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SYNC_UL_Partition_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNC_UL_Partition_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__extensionValue._const_tab = ____SYNC_UL_Partition_LCR_iE_Extensions__item__extensionValue_tab
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SYNC_UL_Partition_LCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SYNC_UL_Partition_LCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SYNC_UL_Partition_LCR_iE_Extensions__item__id),
        ('criticality', ___SYNC_UL_Partition_LCR_iE_Extensions__item__criticality),
        ('extensionValue', ___SYNC_UL_Partition_LCR_iE_Extensions__item__extensionValue),
        ])
    __SYNC_UL_Partition_LCR_iE_Extensions__item_._ext = None
    _SYNC_UL_Partition_LCR_iE_Extensions._cont = __SYNC_UL_Partition_LCR_iE_Extensions__item_
    _SYNC_UL_Partition_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SYNC_UL_Partition_LCR._cont = ASN1Dict([
        ('eRUCCH-SYNC-UL-codes-bitmap', _SYNC_UL_Partition_LCR_eRUCCH_SYNC_UL_codes_bitmap),
        ('iE-Extensions', _SYNC_UL_Partition_LCR_iE_Extensions),
        ])
    SYNC_UL_Partition_LCR._ext = []
    
    #-----< SYNC-UL-Partition-LCR-ExtIEs >-----#
    SYNC_UL_Partition_LCR_ExtIEs = CLASS(name='SYNC-UL-Partition-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SYNC_UL_Partition_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Delete-From-HS-SCCH-Resource-PoolExt-PSCH-ReconfRqst >-----#
    Delete_From_HS_SCCH_Resource_PoolExt_PSCH_ReconfRqst = SEQ_OF(name='Delete-From-HS-SCCH-Resource-PoolExt-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Delete_From_HS_SCCH_Resource_PoolExt_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Delete-From-HS-SCCH-Resource-PoolItem-PSCH-ReconfRqst')))
    Delete_From_HS_SCCH_Resource_PoolExt_PSCH_ReconfRqst._cont = _Delete_From_HS_SCCH_Resource_PoolExt_PSCH_ReconfRqst__item_
    Delete_From_HS_SCCH_Resource_PoolExt_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=224)], ev=None, er=[])
    
    #-----< MultipleFreq-E-PUCH-Timeslot-InformationList-LCR-PSCH-ReconfRqst >-----#
    MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst = SEQ_OF(name='MultipleFreq-E-PUCH-Timeslot-InformationList-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst')))
    ___MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id_tab._val = ASN1Set(rv=[dict([('id', 956), ('criticality', 'ignore'), ('Value', ____MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id._const_tab = ___MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id_tab
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id._const_tab_at = None
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id._const_tab_id = 'id'
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__criticality._const_tab = ___MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id_tab
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__criticality._const_tab_at = ('..', 'id')
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__criticality._const_tab_id = 'criticality'
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__value._const_tab = ___MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id_tab
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__value._const_tab_at = ('..', 'id')
    __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__value._const_tab_id = 'Value'
    _MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item_._cont = ASN1Dict([
        ('id', __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id),
        ('criticality', __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__criticality),
        ('value', __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__value),
        ])
    _MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item_._ext = None
    MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst._cont = _MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item_
    MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< MultipleFreq-E-PUCH-Timeslot-InformationItemIE-LCR-PSCH-ReconfRqst >-----#
    MultipleFreq_E_PUCH_Timeslot_InformationItemIE_LCR_PSCH_ReconfRqst = CLASS(name='MultipleFreq-E-PUCH-Timeslot-InformationItemIE-LCR-PSCH-ReconfRqst', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _MultipleFreq_E_PUCH_Timeslot_InformationItemIE_LCR_PSCH_ReconfRqst_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst')))
    MultipleFreq_E_PUCH_Timeslot_InformationItemIE_LCR_PSCH_ReconfRqst._val = ASN1Set(rv=[dict([('id', 956), ('criticality', 'ignore'), ('Value', _MultipleFreq_E_PUCH_Timeslot_InformationItemIE_LCR_PSCH_ReconfRqst_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst >-----#
    MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst = SEQ(name='MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst', mode=MODE_TYPE)
    _MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_e_PUCH_Timeslot_InfoLCR = SEQ_OF(name='e-PUCH-Timeslot-InfoLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-PUCH-Timeslot-InfoLCR')), opt=True)
    _MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions._cont = __MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item_
    _MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst._cont = ASN1Dict([
        ('e-PUCH-Timeslot-InfoLCR', _MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_e_PUCH_Timeslot_InfoLCR),
        ('uARFCN', _MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_uARFCN),
        ('iE-Extensions', _MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions),
        ])
    MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst._ext = []
    
    #-----< MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst-ExtIEs >-----#
    MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_ExtIEs = CLASS(name='MultipleFreq-E-PUCH-Timeslot-Information-LCRItem-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst >-----#
    Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst = SEQ_OF(name='Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst-Item')))
    Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst._cont = _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst__item_
    Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst-Item >-----#
    Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item = SEQ(name='Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst-Item', mode=MODE_TYPE)
    _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_maximum_Target_ReceivedTotalWideBandPower_LCR = INT(name='maximum-Target-ReceivedTotalWideBandPower-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Target-ReceivedTotalWideBandPower-LCR')))
    _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Max-RTWP-perCellPortion-InformationList-LCR-PSCH-ReconfRqst')))
    ____Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1205), ('criticality', 'ignore'), ('Extension', _____Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id._const_tab = ____Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id_tab
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id._const_tab_at = None
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__criticality._const_tab = ____Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id_tab
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__extensionValue._const_tab = ____Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id_tab
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id),
        ('criticality', ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__extensionValue),
        ])
    __Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item_._ext = None
    _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions._cont = __Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item_
    _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item._cont = ASN1Dict([
        ('uARFCN', _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_uARFCN),
        ('maximum-Target-ReceivedTotalWideBandPower-LCR', _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_maximum_Target_ReceivedTotalWideBandPower_LCR),
        ('iE-Extensions', _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions),
        ])
    Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item._ext = []
    
    #-----< Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst-Item-ExtIEs >-----#
    Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_ExtIEs = CLASS(name='Max-RTWP-perUARFCN-Information-LCR-PSCH-ReconfRqst-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Max-RTWP-perCellPortion-InformationList-LCR-PSCH-ReconfRqst')))
    Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 1205), ('criticality', 'ignore'), ('Extension', _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Max-RTWP-perCellPortion-InformationList-LCR-PSCH-ReconfRqst >-----#
    Max_RTWP_perCellPortion_InformationList_LCR_PSCH_ReconfRqst = SEQ_OF(name='Max-RTWP-perCellPortion-InformationList-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Max_RTWP_perCellPortion_InformationList_LCR_PSCH_ReconfRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Max-RTWP-perCellPortion-InformationItem-LCR-PSCH-ReconfRqst')))
    Max_RTWP_perCellPortion_InformationList_LCR_PSCH_ReconfRqst._cont = _Max_RTWP_perCellPortion_InformationList_LCR_PSCH_ReconfRqst__item_
    Max_RTWP_perCellPortion_InformationList_LCR_PSCH_ReconfRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Max-RTWP-perCellPortion-InformationItem-LCR-PSCH-ReconfRqst >-----#
    Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst = SEQ(name='Max-RTWP-perCellPortion-InformationItem-LCR-PSCH-ReconfRqst', mode=MODE_TYPE)
    _Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_cellPortionLCRID = INT(name='cellPortionLCRID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellPortionLCRID')))
    _Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_maximum_Target_ReceivedTotalWideBandPower_LCR = INT(name='maximum-Target-ReceivedTotalWideBandPower-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Maximum-Target-ReceivedTotalWideBandPower-LCR')))
    _Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab = ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_at = None
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab = ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab = ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id),
        ('criticality', ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue),
        ])
    __Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_._ext = None
    _Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions._cont = __Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_
    _Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst._cont = ASN1Dict([
        ('cellPortionLCRID', _Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_cellPortionLCRID),
        ('maximum-Target-ReceivedTotalWideBandPower-LCR', _Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_maximum_Target_ReceivedTotalWideBandPower_LCR),
        ('iE-Extensions', _Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions),
        ])
    Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst._ext = []
    
    #-----< Max-RTWP-perCellPortion-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs >-----#
    Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs = CLASS(name='Max-RTWP-perCellPortion-InformationItem-LCR-PSCH-ReconfRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PhysicalSharedChannelReconfigurationResponse >-----#
    PhysicalSharedChannelReconfigurationResponse = SEQ(name='PhysicalSharedChannelReconfigurationResponse', mode=MODE_TYPE)
    _PhysicalSharedChannelReconfigurationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __PhysicalSharedChannelReconfigurationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id._const_tab = ____PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id._const_tab_at = None
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__criticality._const_tab = ____PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__value._const_tab = ____PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PhysicalSharedChannelReconfigurationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id),
        ('criticality', ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__criticality),
        ('value', ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__value),
        ])
    __PhysicalSharedChannelReconfigurationResponse_protocolIEs__item_._ext = None
    _PhysicalSharedChannelReconfigurationResponse_protocolIEs._cont = __PhysicalSharedChannelReconfigurationResponse_protocolIEs__item_
    _PhysicalSharedChannelReconfigurationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PhysicalSharedChannelReconfigurationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-TimeOffset')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-TimeOffsetLCR')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Common-System-Information-ResponseFDD')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Paging-System-Information-ResponseFDD')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-TimeOffset-ExtensionLCR')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-System-Information-ResponseFDD')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Common-System-Information-ResponseLCR')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Paging-System-Information-ResponseLCR')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-System-Information-ResponseLCR')))
    _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-RGCH-InfoFDD')))
    ____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 807), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 858), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 898), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 900), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 963), ('criticality', 'reject'), ('Extension', _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 992), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 1222), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 1024), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 1030), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 1254), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id._const_tab = ____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id._const_tab_at = None
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__criticality._const_tab = ____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab = ____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id),
        ('criticality', ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__extensionValue),
        ])
    __PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item_._ext = None
    _PhysicalSharedChannelReconfigurationResponse_protocolExtensions._cont = __PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item_
    _PhysicalSharedChannelReconfigurationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PhysicalSharedChannelReconfigurationResponse._cont = ASN1Dict([
        ('protocolIEs', _PhysicalSharedChannelReconfigurationResponse_protocolIEs),
        ('protocolExtensions', _PhysicalSharedChannelReconfigurationResponse_protocolExtensions),
        ])
    PhysicalSharedChannelReconfigurationResponse._ext = []
    
    #-----< PhysicalSharedChannelReconfigurationResponse-IEs >-----#
    PhysicalSharedChannelReconfigurationResponse_IEs = CLASS(name='PhysicalSharedChannelReconfigurationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PhysicalSharedChannelReconfigurationResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    PhysicalSharedChannelReconfigurationResponse_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _PhysicalSharedChannelReconfigurationResponse_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PhysicalSharedChannelReconfigurationResponse-Extensions >-----#
    PhysicalSharedChannelReconfigurationResponse_Extensions = CLASS(name='PhysicalSharedChannelReconfigurationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-TimeOffset')))
    _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-TimeOffsetLCR')))
    _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Common-System-Information-ResponseFDD')))
    _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Paging-System-Information-ResponseFDD')))
    _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-TimeOffset-ExtensionLCR')))
    _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-System-Information-ResponseFDD')))
    _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Common-System-Information-ResponseLCR')))
    _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Paging-System-Information-ResponseLCR')))
    _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-System-Information-ResponseLCR')))
    _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Common-E-RGCH-InfoFDD')))
    PhysicalSharedChannelReconfigurationResponse_Extensions._val = ASN1Set(rv=[dict([('id', 807), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 858), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 898), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 900), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 963), ('criticality', 'reject'), ('Extension', _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 992), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 1222), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 1024), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 1030), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 1254), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_10), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-HICH-TimeOffset-ExtensionLCR >-----#
    E_HICH_TimeOffset_ExtensionLCR = SEQ_OF(name='E-HICH-TimeOffset-ExtensionLCR', mode=MODE_TYPE)
    _E_HICH_TimeOffset_ExtensionLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __E_HICH_TimeOffset_ExtensionLCR__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___E_HICH_TimeOffset_ExtensionLCR__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____E_HICH_TimeOffset_ExtensionLCR__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-E-HICH-TimeOffsetLCR')))
    ___E_HICH_TimeOffset_ExtensionLCR__item__id_tab._val = ASN1Set(rv=[dict([('id', 964), ('criticality', 'reject'), ('Value', ____E_HICH_TimeOffset_ExtensionLCR__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __E_HICH_TimeOffset_ExtensionLCR__item__id._const_tab = ___E_HICH_TimeOffset_ExtensionLCR__item__id_tab
    __E_HICH_TimeOffset_ExtensionLCR__item__id._const_tab_at = None
    __E_HICH_TimeOffset_ExtensionLCR__item__id._const_tab_id = 'id'
    __E_HICH_TimeOffset_ExtensionLCR__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __E_HICH_TimeOffset_ExtensionLCR__item__criticality._const_tab = ___E_HICH_TimeOffset_ExtensionLCR__item__id_tab
    __E_HICH_TimeOffset_ExtensionLCR__item__criticality._const_tab_at = ('..', 'id')
    __E_HICH_TimeOffset_ExtensionLCR__item__criticality._const_tab_id = 'criticality'
    __E_HICH_TimeOffset_ExtensionLCR__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __E_HICH_TimeOffset_ExtensionLCR__item__value._const_tab = ___E_HICH_TimeOffset_ExtensionLCR__item__id_tab
    __E_HICH_TimeOffset_ExtensionLCR__item__value._const_tab_at = ('..', 'id')
    __E_HICH_TimeOffset_ExtensionLCR__item__value._const_tab_id = 'Value'
    _E_HICH_TimeOffset_ExtensionLCR__item_._cont = ASN1Dict([
        ('id', __E_HICH_TimeOffset_ExtensionLCR__item__id),
        ('criticality', __E_HICH_TimeOffset_ExtensionLCR__item__criticality),
        ('value', __E_HICH_TimeOffset_ExtensionLCR__item__value),
        ])
    _E_HICH_TimeOffset_ExtensionLCR__item_._ext = None
    E_HICH_TimeOffset_ExtensionLCR._cont = _E_HICH_TimeOffset_ExtensionLCR__item_
    E_HICH_TimeOffset_ExtensionLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< Multiple-E-HICH-TimeOffsetLCR >-----#
    Multiple_E_HICH_TimeOffsetLCR = CLASS(name='Multiple-E-HICH-TimeOffsetLCR', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Multiple_E_HICH_TimeOffsetLCR_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-E-HICH-TimeOffsetLCR')))
    Multiple_E_HICH_TimeOffsetLCR._val = ASN1Set(rv=[dict([('id', 964), ('criticality', 'reject'), ('Value', _Multiple_E_HICH_TimeOffsetLCR_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< MultipleFreq-E-HICH-TimeOffsetLCR >-----#
    MultipleFreq_E_HICH_TimeOffsetLCR = SEQ(name='MultipleFreq-E-HICH-TimeOffsetLCR', mode=MODE_TYPE)
    _MultipleFreq_E_HICH_TimeOffsetLCR_e_HICH_TimeOffsetLCR = INT(name='e-HICH-TimeOffsetLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-HICH-TimeOffsetLCR')))
    _MultipleFreq_E_HICH_TimeOffsetLCR_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__id._const_tab = ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__id_tab
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__id._const_tab_at = None
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__criticality._const_tab = ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__criticality_tab
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__extensionValue._const_tab = ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__extensionValue_tab
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__id),
        ('criticality', ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__extensionValue),
        ])
    __MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item_._ext = None
    _MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions._cont = __MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item_
    _MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleFreq_E_HICH_TimeOffsetLCR._cont = ASN1Dict([
        ('e-HICH-TimeOffsetLCR', _MultipleFreq_E_HICH_TimeOffsetLCR_e_HICH_TimeOffsetLCR),
        ('uARFCN', _MultipleFreq_E_HICH_TimeOffsetLCR_uARFCN),
        ('iE-Extensions', _MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions),
        ])
    MultipleFreq_E_HICH_TimeOffsetLCR._ext = []
    
    #-----< MultipleFreq-E-HICH-TimeOffsetLCR-ExtIEs >-----#
    MultipleFreq_E_HICH_TimeOffsetLCR_ExtIEs = CLASS(name='MultipleFreq-E-HICH-TimeOffsetLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MultipleFreq_E_HICH_TimeOffsetLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PhysicalSharedChannelReconfigurationFailure >-----#
    PhysicalSharedChannelReconfigurationFailure = SEQ(name='PhysicalSharedChannelReconfigurationFailure', mode=MODE_TYPE)
    _PhysicalSharedChannelReconfigurationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __PhysicalSharedChannelReconfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-PSCH-ReconfFailure')))
    _____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 324), ('criticality', 'ignore'), ('Value', _____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id._const_tab = ____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__criticality._const_tab = ____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__value._const_tab = ____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PhysicalSharedChannelReconfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id),
        ('criticality', ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__criticality),
        ('value', ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__value),
        ])
    __PhysicalSharedChannelReconfigurationFailure_protocolIEs__item_._ext = None
    _PhysicalSharedChannelReconfigurationFailure_protocolIEs._cont = __PhysicalSharedChannelReconfigurationFailure_protocolIEs__item_
    _PhysicalSharedChannelReconfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PhysicalSharedChannelReconfigurationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-TimeOffset-ReconfFailureTDD')))
    _____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Common-System-Information-ResponseLCR')))
    ____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1153), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1157), ('criticality', 'ignore'), ('Extension', _____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id._const_tab = ____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id._const_tab_at = None
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__criticality._const_tab = ____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab = ____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id),
        ('criticality', ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__extensionValue),
        ])
    __PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item_._ext = None
    _PhysicalSharedChannelReconfigurationFailure_protocolExtensions._cont = __PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item_
    _PhysicalSharedChannelReconfigurationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PhysicalSharedChannelReconfigurationFailure._cont = ASN1Dict([
        ('protocolIEs', _PhysicalSharedChannelReconfigurationFailure_protocolIEs),
        ('protocolExtensions', _PhysicalSharedChannelReconfigurationFailure_protocolExtensions),
        ])
    PhysicalSharedChannelReconfigurationFailure._ext = []
    
    #-----< PhysicalSharedChannelReconfigurationFailure-IEs >-----#
    PhysicalSharedChannelReconfigurationFailure_IEs = CLASS(name='PhysicalSharedChannelReconfigurationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _PhysicalSharedChannelReconfigurationFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-PSCH-ReconfFailure')))
    _PhysicalSharedChannelReconfigurationFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    PhysicalSharedChannelReconfigurationFailure_IEs._val = ASN1Set(rv=[dict([('id', 324), ('criticality', 'ignore'), ('Value', _PhysicalSharedChannelReconfigurationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _PhysicalSharedChannelReconfigurationFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PhysicalSharedChannelReconfigurationFailure-Extensions >-----#
    PhysicalSharedChannelReconfigurationFailure_Extensions = CLASS(name='PhysicalSharedChannelReconfigurationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _PhysicalSharedChannelReconfigurationFailure_Extensions_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-HICH-TimeOffset-ReconfFailureTDD')))
    _PhysicalSharedChannelReconfigurationFailure_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Common-System-Information-ResponseLCR')))
    PhysicalSharedChannelReconfigurationFailure_Extensions._val = ASN1Set(rv=[dict([('id', 1153), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationFailure_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 1157), ('criticality', 'ignore'), ('Extension', _PhysicalSharedChannelReconfigurationFailure_Extensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-PSCH-ReconfFailure >-----#
    CauseLevel_PSCH_ReconfFailure = CHOICE(name='CauseLevel-PSCH-ReconfFailure', mode=MODE_TYPE)
    _CauseLevel_PSCH_ReconfFailure_generalCause = SEQ(name='generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'GeneralCauseList-PSCH-ReconfFailure')))
    _CauseLevel_PSCH_ReconfFailure_setSpecificCause = SEQ(name='setSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SetSpecificCauseList-PSCH-ReconfFailureTDD')))
    _CauseLevel_PSCH_ReconfFailure_extension_CauseLevel_PSCH_ReconfFailure = SEQ(name='extension-CauseLevel-PSCH-ReconfFailure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Extension-CauseLevel-PSCH-ReconfFailure')))
    CauseLevel_PSCH_ReconfFailure._cont = ASN1Dict([
        ('generalCause', _CauseLevel_PSCH_ReconfFailure_generalCause),
        ('setSpecificCause', _CauseLevel_PSCH_ReconfFailure_setSpecificCause),
        ('extension-CauseLevel-PSCH-ReconfFailure', _CauseLevel_PSCH_ReconfFailure_extension_CauseLevel_PSCH_ReconfFailure),
        ])
    CauseLevel_PSCH_ReconfFailure._ext = ['extension-CauseLevel-PSCH-ReconfFailure']
    
    #-----< GeneralCauseList-PSCH-ReconfFailure >-----#
    GeneralCauseList_PSCH_ReconfFailure = SEQ(name='GeneralCauseList-PSCH-ReconfFailure', mode=MODE_TYPE)
    _GeneralCauseList_PSCH_ReconfFailure_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _GeneralCauseList_PSCH_ReconfFailure_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__id._const_tab = ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__id_tab
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__id),
        ('criticality', ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__criticality),
        ('extensionValue', ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item_._ext = None
    _GeneralCauseList_PSCH_ReconfFailure_iE_Extensions._cont = __GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item_
    _GeneralCauseList_PSCH_ReconfFailure_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_PSCH_ReconfFailure._cont = ASN1Dict([
        ('cause', _GeneralCauseList_PSCH_ReconfFailure_cause),
        ('iE-Extensions', _GeneralCauseList_PSCH_ReconfFailure_iE_Extensions),
        ])
    GeneralCauseList_PSCH_ReconfFailure._ext = []
    
    #-----< GeneralCauseItem-PSCH-ReconfFailure-ExtIEs >-----#
    GeneralCauseItem_PSCH_ReconfFailure_ExtIEs = CLASS(name='GeneralCauseItem-PSCH-ReconfFailure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GeneralCauseItem_PSCH_ReconfFailure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SetSpecificCauseList-PSCH-ReconfFailureTDD >-----#
    SetSpecificCauseList_PSCH_ReconfFailureTDD = SEQ(name='SetSpecificCauseList-PSCH-ReconfFailureTDD', mode=MODE_TYPE)
    _SetSpecificCauseList_PSCH_ReconfFailureTDD_unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD = SEQ_OF(name='unsuccessful-PDSCHSetList-PSCH-ReconfFailureTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-PDSCHSetList-PSCH-ReconfFailureTDD')), opt=True)
    _SetSpecificCauseList_PSCH_ReconfFailureTDD_unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD = SEQ_OF(name='unsuccessful-PUSCHSetList-PSCH-ReconfFailureTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-PUSCHSetList-PSCH-ReconfFailureTDD')), opt=True)
    _SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab = ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab = ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__id),
        ('criticality', ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item_._ext = None
    _SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions._cont = __SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item_
    _SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SetSpecificCauseList_PSCH_ReconfFailureTDD._cont = ASN1Dict([
        ('unsuccessful-PDSCHSetList-PSCH-ReconfFailureTDD', _SetSpecificCauseList_PSCH_ReconfFailureTDD_unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD),
        ('unsuccessful-PUSCHSetList-PSCH-ReconfFailureTDD', _SetSpecificCauseList_PSCH_ReconfFailureTDD_unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD),
        ('iE-Extensions', _SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions),
        ])
    SetSpecificCauseList_PSCH_ReconfFailureTDD._ext = []
    
    #-----< SetSpecificCauseItem-PSCH-ReconfFailureTDD-ExtIEs >-----#
    SetSpecificCauseItem_PSCH_ReconfFailureTDD_ExtIEs = CLASS(name='SetSpecificCauseItem-PSCH-ReconfFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SetSpecificCauseItem_PSCH_ReconfFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Unsuccessful-PDSCHSetList-PSCH-ReconfFailureTDD >-----#
    Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD = SEQ_OF(name='Unsuccessful-PDSCHSetList-PSCH-ReconfFailureTDD', mode=MODE_TYPE)
    _Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD')))
    ___Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 408), ('criticality', 'ignore'), ('Value', ____Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id._const_tab = ___Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id_tab
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id._const_tab_at = None
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id._const_tab_id = 'id'
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__criticality._const_tab = ___Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id_tab
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__criticality._const_tab_at = ('..', 'id')
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__criticality._const_tab_id = 'criticality'
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__value._const_tab = ___Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id_tab
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__value._const_tab_at = ('..', 'id')
    __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__value._const_tab_id = 'Value'
    _Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item_._cont = ASN1Dict([
        ('id', __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id),
        ('criticality', __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__criticality),
        ('value', __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__value),
        ])
    _Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item_._ext = None
    Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD._cont = _Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item_
    Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< Unsuccessful-PDSCHSetItemIE-PSCH-ReconfFailureTDD >-----#
    Unsuccessful_PDSCHSetItemIE_PSCH_ReconfFailureTDD = CLASS(name='Unsuccessful-PDSCHSetItemIE-PSCH-ReconfFailureTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Unsuccessful_PDSCHSetItemIE_PSCH_ReconfFailureTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD')))
    Unsuccessful_PDSCHSetItemIE_PSCH_ReconfFailureTDD._val = ASN1Set(rv=[dict([('id', 408), ('criticality', 'ignore'), ('Value', _Unsuccessful_PDSCHSetItemIE_PSCH_ReconfFailureTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD >-----#
    Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD = SEQ(name='Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD', mode=MODE_TYPE)
    _Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_pDSCHSet_ID = INT(name='pDSCHSet-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PDSCHSet-ID')))
    _Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab = ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab = ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id),
        ('criticality', ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item_._ext = None
    _Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions._cont = __Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item_
    _Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD._cont = ASN1Dict([
        ('pDSCHSet-ID', _Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_pDSCHSet_ID),
        ('cause', _Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_cause),
        ('iE-Extensions', _Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions),
        ])
    Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD._ext = []
    
    #-----< Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD-ExtIEs >-----#
    Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_ExtIEs = CLASS(name='Unsuccessful-PDSCHSetItem-PSCH-ReconfFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Unsuccessful-PUSCHSetList-PSCH-ReconfFailureTDD >-----#
    Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD = SEQ_OF(name='Unsuccessful-PUSCHSetList-PSCH-ReconfFailureTDD', mode=MODE_TYPE)
    _Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD')))
    ___Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 409), ('criticality', 'ignore'), ('Value', ____Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id._const_tab = ___Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id_tab
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id._const_tab_at = None
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id._const_tab_id = 'id'
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__criticality._const_tab = ___Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id_tab
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__criticality._const_tab_at = ('..', 'id')
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__criticality._const_tab_id = 'criticality'
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__value._const_tab = ___Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id_tab
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__value._const_tab_at = ('..', 'id')
    __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__value._const_tab_id = 'Value'
    _Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item_._cont = ASN1Dict([
        ('id', __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id),
        ('criticality', __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__criticality),
        ('value', __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__value),
        ])
    _Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item_._ext = None
    Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD._cont = _Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item_
    Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< Unsuccessful-PUSCHSetItemIE-PSCH-ReconfFailureTDD >-----#
    Unsuccessful_PUSCHSetItemIE_PSCH_ReconfFailureTDD = CLASS(name='Unsuccessful-PUSCHSetItemIE-PSCH-ReconfFailureTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Unsuccessful_PUSCHSetItemIE_PSCH_ReconfFailureTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD')))
    Unsuccessful_PUSCHSetItemIE_PSCH_ReconfFailureTDD._val = ASN1Set(rv=[dict([('id', 409), ('criticality', 'ignore'), ('Value', _Unsuccessful_PUSCHSetItemIE_PSCH_ReconfFailureTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD >-----#
    Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD = SEQ(name='Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD', mode=MODE_TYPE)
    _Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_pUSCHSet_ID = INT(name='pUSCHSet-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'PUSCHSet-ID')))
    _Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab = ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab = ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id),
        ('criticality', ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item_._ext = None
    _Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions._cont = __Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item_
    _Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD._cont = ASN1Dict([
        ('pUSCHSet-ID', _Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_pUSCHSet_ID),
        ('cause', _Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_cause),
        ('iE-Extensions', _Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions),
        ])
    Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD._ext = []
    
    #-----< Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD-ExtIEs >-----#
    Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_ExtIEs = CLASS(name='Unsuccessful-PUSCHSetItem-PSCH-ReconfFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extension-CauseLevel-PSCH-ReconfFailure >-----#
    Extension_CauseLevel_PSCH_ReconfFailure = SEQ(name='Extension-CauseLevel-PSCH-ReconfFailure', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_CauseLevel_PSCH_ReconfFailure_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __Extension_CauseLevel_PSCH_ReconfFailure_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___Extension_CauseLevel_PSCH_ReconfFailure_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UARFCNSpecificCauseList-PSCH-ReconfFailureTDD')))
    __Extension_CauseLevel_PSCH_ReconfFailure_id_tab._val = ASN1Set(rv=[dict([('id', 931), ('criticality', 'ignore'), ('Value', ___Extension_CauseLevel_PSCH_ReconfFailure_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_CauseLevel_PSCH_ReconfFailure_id._const_tab = __Extension_CauseLevel_PSCH_ReconfFailure_id_tab
    _Extension_CauseLevel_PSCH_ReconfFailure_id._const_tab_at = None
    _Extension_CauseLevel_PSCH_ReconfFailure_id._const_tab_id = 'id'
    _Extension_CauseLevel_PSCH_ReconfFailure_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _Extension_CauseLevel_PSCH_ReconfFailure_criticality._const_tab = __Extension_CauseLevel_PSCH_ReconfFailure_id_tab
    _Extension_CauseLevel_PSCH_ReconfFailure_criticality._const_tab_at = ('..', 'id')
    _Extension_CauseLevel_PSCH_ReconfFailure_criticality._const_tab_id = 'criticality'
    _Extension_CauseLevel_PSCH_ReconfFailure_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _Extension_CauseLevel_PSCH_ReconfFailure_value._const_tab = __Extension_CauseLevel_PSCH_ReconfFailure_id_tab
    _Extension_CauseLevel_PSCH_ReconfFailure_value._const_tab_at = ('..', 'id')
    _Extension_CauseLevel_PSCH_ReconfFailure_value._const_tab_id = 'Value'
    Extension_CauseLevel_PSCH_ReconfFailure._cont = ASN1Dict([
        ('id', _Extension_CauseLevel_PSCH_ReconfFailure_id),
        ('criticality', _Extension_CauseLevel_PSCH_ReconfFailure_criticality),
        ('value', _Extension_CauseLevel_PSCH_ReconfFailure_value),
        ])
    Extension_CauseLevel_PSCH_ReconfFailure._ext = None
    
    #-----< Extension-CauseLevel-PSCH-ReconfFailureIE >-----#
    Extension_CauseLevel_PSCH_ReconfFailureIE = CLASS(name='Extension-CauseLevel-PSCH-ReconfFailureIE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Extension_CauseLevel_PSCH_ReconfFailureIE_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UARFCNSpecificCauseList-PSCH-ReconfFailureTDD')))
    Extension_CauseLevel_PSCH_ReconfFailureIE._val = ASN1Set(rv=[dict([('id', 931), ('criticality', 'ignore'), ('Value', _Extension_CauseLevel_PSCH_ReconfFailureIE_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UARFCNSpecificCauseList-PSCH-ReconfFailureTDD >-----#
    UARFCNSpecificCauseList_PSCH_ReconfFailureTDD = SEQ_OF(name='UARFCNSpecificCauseList-PSCH-ReconfFailureTDD', mode=MODE_TYPE)
    _UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD')))
    ___UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 928), ('criticality', 'ignore'), ('Value', ____UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id._const_tab = ___UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id_tab
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id._const_tab_at = None
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id._const_tab_id = 'id'
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__criticality._const_tab = ___UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id_tab
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__criticality._const_tab_at = ('..', 'id')
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__criticality._const_tab_id = 'criticality'
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__value._const_tab = ___UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id_tab
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__value._const_tab_at = ('..', 'id')
    __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__value._const_tab_id = 'Value'
    _UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item_._cont = ASN1Dict([
        ('id', __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id),
        ('criticality', __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__criticality),
        ('value', __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__value),
        ])
    _UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item_._ext = None
    UARFCNSpecificCauseList_PSCH_ReconfFailureTDD._cont = _UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item_
    UARFCNSpecificCauseList_PSCH_ReconfFailureTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=12)], ev=None, er=[])
    
    #-----< Unsuccessful-UARFCNItemIE-PSCH-ReconfFailureTDD >-----#
    Unsuccessful_UARFCNItemIE_PSCH_ReconfFailureTDD = CLASS(name='Unsuccessful-UARFCNItemIE-PSCH-ReconfFailureTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Unsuccessful_UARFCNItemIE_PSCH_ReconfFailureTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD')))
    Unsuccessful_UARFCNItemIE_PSCH_ReconfFailureTDD._val = ASN1Set(rv=[dict([('id', 928), ('criticality', 'ignore'), ('Value', _Unsuccessful_UARFCNItemIE_PSCH_ReconfFailureTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD >-----#
    Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD = SEQ(name='Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD', mode=MODE_TYPE)
    _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    ____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 984), ('criticality', 'ignore'), ('Extension', _____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 985), ('criticality', 'ignore'), ('Extension', _____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab = ____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab = ____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id),
        ('criticality', ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item_._ext = None
    _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions._cont = __Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item_
    _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD._cont = ASN1Dict([
        ('uARFCN', _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_uARFCN),
        ('cause', _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_cause),
        ('iE-Extensions', _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions),
        ])
    Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD._ext = []
    
    #-----< Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD-ExtIEs >-----#
    Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_ExtIEs = CLASS(name='Unsuccessful-UARFCNItem-PSCH-ReconfFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 984), ('criticality', 'ignore'), ('Extension', _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 985), ('criticality', 'ignore'), ('Extension', _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-HICH-TimeOffset-ReconfFailureTDD >-----#
    E_HICH_TimeOffset_ReconfFailureTDD = SEQ_OF(name='E-HICH-TimeOffset-ReconfFailureTDD', mode=MODE_TYPE)
    _E_HICH_TimeOffset_ReconfFailureTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __E_HICH_TimeOffset_ReconfFailureTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___E_HICH_TimeOffset_ReconfFailureTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____E_HICH_TimeOffset_ReconfFailureTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MultipleFreq-E-HICH-TimeOffsetLCR')))
    ___E_HICH_TimeOffset_ReconfFailureTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 964), ('criticality', 'reject'), ('Value', ____E_HICH_TimeOffset_ReconfFailureTDD__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __E_HICH_TimeOffset_ReconfFailureTDD__item__id._const_tab = ___E_HICH_TimeOffset_ReconfFailureTDD__item__id_tab
    __E_HICH_TimeOffset_ReconfFailureTDD__item__id._const_tab_at = None
    __E_HICH_TimeOffset_ReconfFailureTDD__item__id._const_tab_id = 'id'
    __E_HICH_TimeOffset_ReconfFailureTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __E_HICH_TimeOffset_ReconfFailureTDD__item__criticality._const_tab = ___E_HICH_TimeOffset_ReconfFailureTDD__item__id_tab
    __E_HICH_TimeOffset_ReconfFailureTDD__item__criticality._const_tab_at = ('..', 'id')
    __E_HICH_TimeOffset_ReconfFailureTDD__item__criticality._const_tab_id = 'criticality'
    __E_HICH_TimeOffset_ReconfFailureTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __E_HICH_TimeOffset_ReconfFailureTDD__item__value._const_tab = ___E_HICH_TimeOffset_ReconfFailureTDD__item__id_tab
    __E_HICH_TimeOffset_ReconfFailureTDD__item__value._const_tab_at = ('..', 'id')
    __E_HICH_TimeOffset_ReconfFailureTDD__item__value._const_tab_id = 'Value'
    _E_HICH_TimeOffset_ReconfFailureTDD__item_._cont = ASN1Dict([
        ('id', __E_HICH_TimeOffset_ReconfFailureTDD__item__id),
        ('criticality', __E_HICH_TimeOffset_ReconfFailureTDD__item__criticality),
        ('value', __E_HICH_TimeOffset_ReconfFailureTDD__item__value),
        ])
    _E_HICH_TimeOffset_ReconfFailureTDD__item_._ext = None
    E_HICH_TimeOffset_ReconfFailureTDD._cont = _E_HICH_TimeOffset_ReconfFailureTDD__item_
    E_HICH_TimeOffset_ReconfFailureTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< Common-System-Information-ResponseLCR >-----#
    Common_System_Information_ResponseLCR = SEQ(name='Common-System-Information-ResponseLCR', mode=MODE_TYPE)
    _Common_System_Information_ResponseLCR_hSDSCH_Common_System_Information_ResponseLCR = SEQ(name='hSDSCH-Common-System-Information-ResponseLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Common-System-Information-ResponseLCR')))
    _Common_System_Information_ResponseLCR_hSDSCH_Paging_System_Information_ResponseLCR = SEQ_OF(name='hSDSCH-Paging-System-Information-ResponseLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-Paging-System-Information-ResponseLCR')), opt=True)
    _Common_System_Information_ResponseLCR_common_EDCH_System_Information_ResponseLCR = SEQ(name='common-EDCH-System-Information-ResponseLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Common-EDCH-System-Information-ResponseLCR')))
    _Common_System_Information_ResponseLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_System_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Common_System_Information_ResponseLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_System_Information_ResponseLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____Common_System_Information_ResponseLCR_iE_Extensions__item__criticality_tab
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Common_System_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Common_System_Information_ResponseLCR_iE_Extensions__item__id),
        ('criticality', ___Common_System_Information_ResponseLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __Common_System_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _Common_System_Information_ResponseLCR_iE_Extensions._cont = __Common_System_Information_ResponseLCR_iE_Extensions__item_
    _Common_System_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_System_Information_ResponseLCR._cont = ASN1Dict([
        ('hSDSCH-Common-System-Information-ResponseLCR', _Common_System_Information_ResponseLCR_hSDSCH_Common_System_Information_ResponseLCR),
        ('hSDSCH-Paging-System-Information-ResponseLCR', _Common_System_Information_ResponseLCR_hSDSCH_Paging_System_Information_ResponseLCR),
        ('common-EDCH-System-Information-ResponseLCR', _Common_System_Information_ResponseLCR_common_EDCH_System_Information_ResponseLCR),
        ('iE-Extensions', _Common_System_Information_ResponseLCR_iE_Extensions),
        ])
    Common_System_Information_ResponseLCR._ext = []
    
    #-----< Common-System-Information-ResponseLCR-ExtIEs >-----#
    Common_System_Information_ResponseLCR_ExtIEs = CLASS(name='Common-System-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Common_System_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResetRequest >-----#
    ResetRequest = SEQ(name='ResetRequest', mode=MODE_TYPE)
    _ResetRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __ResetRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___ResetRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____ResetRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____ResetRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetIndicator')))
    ____ResetRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 416), ('criticality', 'ignore'), ('Value', _____ResetRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ResetRequest_protocolIEs__item__id._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__id._const_tab_at = None
    ___ResetRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___ResetRequest_protocolIEs__item__criticality._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___ResetRequest_protocolIEs__item__value._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetRequest_protocolIEs__item__id),
        ('criticality', ___ResetRequest_protocolIEs__item__criticality),
        ('value', ___ResetRequest_protocolIEs__item__value),
        ])
    __ResetRequest_protocolIEs__item_._ext = None
    _ResetRequest_protocolIEs._cont = __ResetRequest_protocolIEs__item_
    _ResetRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ResetRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ResetRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ResetRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ResetRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResetRequest_protocolExtensions__item__id._const_tab = ____ResetRequest_protocolExtensions__item__id_tab
    ___ResetRequest_protocolExtensions__item__id._const_tab_at = None
    ___ResetRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___ResetRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResetRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ResetRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResetRequest_protocolExtensions__item__criticality._const_tab = ____ResetRequest_protocolExtensions__item__criticality_tab
    ___ResetRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResetRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ResetRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResetRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ResetRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResetRequest_protocolExtensions__item__extensionValue._const_tab = ____ResetRequest_protocolExtensions__item__extensionValue_tab
    ___ResetRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResetRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ResetRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ResetRequest_protocolExtensions__item__id),
        ('criticality', ___ResetRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___ResetRequest_protocolExtensions__item__extensionValue),
        ])
    __ResetRequest_protocolExtensions__item_._ext = None
    _ResetRequest_protocolExtensions._cont = __ResetRequest_protocolExtensions__item_
    _ResetRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetRequest._cont = ASN1Dict([
        ('protocolIEs', _ResetRequest_protocolIEs),
        ('protocolExtensions', _ResetRequest_protocolExtensions),
        ])
    ResetRequest._ext = []
    
    #-----< ResetRequest-IEs >-----#
    ResetRequest_IEs = CLASS(name='ResetRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _ResetRequest_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetIndicator')))
    ResetRequest_IEs._val = ASN1Set(rv=[dict([('id', 416), ('criticality', 'ignore'), ('Value', _ResetRequest_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetRequest-Extensions >-----#
    ResetRequest_Extensions = CLASS(name='ResetRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ResetRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResetIndicator >-----#
    ResetIndicator = CHOICE(name='ResetIndicator', mode=MODE_TYPE)
    _ResetIndicator_communicationContext = SEQ(name='communicationContext', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommunicationContextList-Reset')))
    _ResetIndicator_communicationControlPort = SEQ(name='communicationControlPort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommunicationControlPortList-Reset')))
    _ResetIndicator_nodeB = NULL(name='nodeB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ResetIndicator._cont = ASN1Dict([
        ('communicationContext', _ResetIndicator_communicationContext),
        ('communicationControlPort', _ResetIndicator_communicationControlPort),
        ('nodeB', _ResetIndicator_nodeB),
        ])
    ResetIndicator._ext = []
    
    #-----< CommunicationContextList-Reset >-----#
    CommunicationContextList_Reset = SEQ(name='CommunicationContextList-Reset', mode=MODE_TYPE)
    _CommunicationContextList_Reset_communicationContextInfoList_Reset = SEQ_OF(name='communicationContextInfoList-Reset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommunicationContextInfoList-Reset')))
    _CommunicationContextList_Reset_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommunicationContextList_Reset_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommunicationContextList_Reset_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommunicationContextList_Reset_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationContextList_Reset_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationContextList_Reset_iE_Extensions__item__id._const_tab = ____CommunicationContextList_Reset_iE_Extensions__item__id_tab
    ___CommunicationContextList_Reset_iE_Extensions__item__id._const_tab_at = None
    ___CommunicationContextList_Reset_iE_Extensions__item__id._const_tab_id = 'id'
    ___CommunicationContextList_Reset_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommunicationContextList_Reset_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationContextList_Reset_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationContextList_Reset_iE_Extensions__item__criticality._const_tab = ____CommunicationContextList_Reset_iE_Extensions__item__criticality_tab
    ___CommunicationContextList_Reset_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommunicationContextList_Reset_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CommunicationContextList_Reset_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommunicationContextList_Reset_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationContextList_Reset_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationContextList_Reset_iE_Extensions__item__extensionValue._const_tab = ____CommunicationContextList_Reset_iE_Extensions__item__extensionValue_tab
    ___CommunicationContextList_Reset_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommunicationContextList_Reset_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CommunicationContextList_Reset_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CommunicationContextList_Reset_iE_Extensions__item__id),
        ('criticality', ___CommunicationContextList_Reset_iE_Extensions__item__criticality),
        ('extensionValue', ___CommunicationContextList_Reset_iE_Extensions__item__extensionValue),
        ])
    __CommunicationContextList_Reset_iE_Extensions__item_._ext = None
    _CommunicationContextList_Reset_iE_Extensions._cont = __CommunicationContextList_Reset_iE_Extensions__item_
    _CommunicationContextList_Reset_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommunicationContextList_Reset._cont = ASN1Dict([
        ('communicationContextInfoList-Reset', _CommunicationContextList_Reset_communicationContextInfoList_Reset),
        ('iE-Extensions', _CommunicationContextList_Reset_iE_Extensions),
        ])
    CommunicationContextList_Reset._ext = []
    
    #-----< CommunicationContextItem-Reset-ExtIEs >-----#
    CommunicationContextItem_Reset_ExtIEs = CLASS(name='CommunicationContextItem-Reset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommunicationContextItem_Reset_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommunicationContextInfoList-Reset >-----#
    CommunicationContextInfoList_Reset = SEQ_OF(name='CommunicationContextInfoList-Reset', mode=MODE_TYPE)
    _CommunicationContextInfoList_Reset__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __CommunicationContextInfoList_Reset__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___CommunicationContextInfoList_Reset__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____CommunicationContextInfoList_Reset__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommunicationContextInfoItem-Reset')))
    ___CommunicationContextInfoList_Reset__item__id_tab._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'reject'), ('Value', ____CommunicationContextInfoList_Reset__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CommunicationContextInfoList_Reset__item__id._const_tab = ___CommunicationContextInfoList_Reset__item__id_tab
    __CommunicationContextInfoList_Reset__item__id._const_tab_at = None
    __CommunicationContextInfoList_Reset__item__id._const_tab_id = 'id'
    __CommunicationContextInfoList_Reset__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __CommunicationContextInfoList_Reset__item__criticality._const_tab = ___CommunicationContextInfoList_Reset__item__id_tab
    __CommunicationContextInfoList_Reset__item__criticality._const_tab_at = ('..', 'id')
    __CommunicationContextInfoList_Reset__item__criticality._const_tab_id = 'criticality'
    __CommunicationContextInfoList_Reset__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __CommunicationContextInfoList_Reset__item__value._const_tab = ___CommunicationContextInfoList_Reset__item__id_tab
    __CommunicationContextInfoList_Reset__item__value._const_tab_at = ('..', 'id')
    __CommunicationContextInfoList_Reset__item__value._const_tab_id = 'Value'
    _CommunicationContextInfoList_Reset__item_._cont = ASN1Dict([
        ('id', __CommunicationContextInfoList_Reset__item__id),
        ('criticality', __CommunicationContextInfoList_Reset__item__criticality),
        ('value', __CommunicationContextInfoList_Reset__item__value),
        ])
    _CommunicationContextInfoList_Reset__item_._ext = None
    CommunicationContextInfoList_Reset._cont = _CommunicationContextInfoList_Reset__item_
    CommunicationContextInfoList_Reset._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1048575)], ev=None, er=[])
    
    #-----< CommunicationContextInfoItemIE-Reset >-----#
    CommunicationContextInfoItemIE_Reset = CLASS(name='CommunicationContextInfoItemIE-Reset', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommunicationContextInfoItemIE_Reset_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommunicationContextInfoItem-Reset')))
    CommunicationContextInfoItemIE_Reset._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'reject'), ('Value', _CommunicationContextInfoItemIE_Reset_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CommunicationContextInfoItem-Reset >-----#
    CommunicationContextInfoItem_Reset = SEQ(name='CommunicationContextInfoItem-Reset', mode=MODE_TYPE)
    _CommunicationContextInfoItem_Reset_communicationContextType_Reset = CHOICE(name='communicationContextType-Reset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommunicationContextType-Reset')))
    _CommunicationContextInfoItem_Reset_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommunicationContextInfoItem_Reset_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommunicationContextInfoItem_Reset_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationContextInfoItem_Reset_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__id._const_tab = ____CommunicationContextInfoItem_Reset_iE_Extensions__item__id_tab
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__id._const_tab_at = None
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__id._const_tab_id = 'id'
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommunicationContextInfoItem_Reset_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationContextInfoItem_Reset_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__criticality._const_tab = ____CommunicationContextInfoItem_Reset_iE_Extensions__item__criticality_tab
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommunicationContextInfoItem_Reset_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationContextInfoItem_Reset_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab = ____CommunicationContextInfoItem_Reset_iE_Extensions__item__extensionValue_tab
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommunicationContextInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CommunicationContextInfoItem_Reset_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CommunicationContextInfoItem_Reset_iE_Extensions__item__id),
        ('criticality', ___CommunicationContextInfoItem_Reset_iE_Extensions__item__criticality),
        ('extensionValue', ___CommunicationContextInfoItem_Reset_iE_Extensions__item__extensionValue),
        ])
    __CommunicationContextInfoItem_Reset_iE_Extensions__item_._ext = None
    _CommunicationContextInfoItem_Reset_iE_Extensions._cont = __CommunicationContextInfoItem_Reset_iE_Extensions__item_
    _CommunicationContextInfoItem_Reset_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommunicationContextInfoItem_Reset._cont = ASN1Dict([
        ('communicationContextType-Reset', _CommunicationContextInfoItem_Reset_communicationContextType_Reset),
        ('iE-Extensions', _CommunicationContextInfoItem_Reset_iE_Extensions),
        ])
    CommunicationContextInfoItem_Reset._ext = []
    
    #-----< CommunicationContextInfoItem-Reset-ExtIEs >-----#
    CommunicationContextInfoItem_Reset_ExtIEs = CLASS(name='CommunicationContextInfoItem-Reset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommunicationContextInfoItem_Reset_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommunicationContextType-Reset >-----#
    CommunicationContextType_Reset = CHOICE(name='CommunicationContextType-Reset', mode=MODE_TYPE)
    _CommunicationContextType_Reset_cRNC_CommunicationContextID = INT(name='cRNC-CommunicationContextID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _CommunicationContextType_Reset_nodeB_CommunicationContextID = INT(name='nodeB-CommunicationContextID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    CommunicationContextType_Reset._cont = ASN1Dict([
        ('cRNC-CommunicationContextID', _CommunicationContextType_Reset_cRNC_CommunicationContextID),
        ('nodeB-CommunicationContextID', _CommunicationContextType_Reset_nodeB_CommunicationContextID),
        ])
    CommunicationContextType_Reset._ext = []
    
    #-----< CommunicationControlPortList-Reset >-----#
    CommunicationControlPortList_Reset = SEQ(name='CommunicationControlPortList-Reset', mode=MODE_TYPE)
    _CommunicationControlPortList_Reset_communicationControlPortInfoList_Reset = SEQ_OF(name='communicationControlPortInfoList-Reset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommunicationControlPortInfoList-Reset')))
    _CommunicationControlPortList_Reset_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommunicationControlPortList_Reset_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommunicationControlPortList_Reset_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommunicationControlPortList_Reset_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationControlPortList_Reset_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationControlPortList_Reset_iE_Extensions__item__id._const_tab = ____CommunicationControlPortList_Reset_iE_Extensions__item__id_tab
    ___CommunicationControlPortList_Reset_iE_Extensions__item__id._const_tab_at = None
    ___CommunicationControlPortList_Reset_iE_Extensions__item__id._const_tab_id = 'id'
    ___CommunicationControlPortList_Reset_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommunicationControlPortList_Reset_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationControlPortList_Reset_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationControlPortList_Reset_iE_Extensions__item__criticality._const_tab = ____CommunicationControlPortList_Reset_iE_Extensions__item__criticality_tab
    ___CommunicationControlPortList_Reset_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommunicationControlPortList_Reset_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CommunicationControlPortList_Reset_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommunicationControlPortList_Reset_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationControlPortList_Reset_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationControlPortList_Reset_iE_Extensions__item__extensionValue._const_tab = ____CommunicationControlPortList_Reset_iE_Extensions__item__extensionValue_tab
    ___CommunicationControlPortList_Reset_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommunicationControlPortList_Reset_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CommunicationControlPortList_Reset_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CommunicationControlPortList_Reset_iE_Extensions__item__id),
        ('criticality', ___CommunicationControlPortList_Reset_iE_Extensions__item__criticality),
        ('extensionValue', ___CommunicationControlPortList_Reset_iE_Extensions__item__extensionValue),
        ])
    __CommunicationControlPortList_Reset_iE_Extensions__item_._ext = None
    _CommunicationControlPortList_Reset_iE_Extensions._cont = __CommunicationControlPortList_Reset_iE_Extensions__item_
    _CommunicationControlPortList_Reset_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommunicationControlPortList_Reset._cont = ASN1Dict([
        ('communicationControlPortInfoList-Reset', _CommunicationControlPortList_Reset_communicationControlPortInfoList_Reset),
        ('iE-Extensions', _CommunicationControlPortList_Reset_iE_Extensions),
        ])
    CommunicationControlPortList_Reset._ext = []
    
    #-----< CommunicationControlPortItem-Reset-ExtIEs >-----#
    CommunicationControlPortItem_Reset_ExtIEs = CLASS(name='CommunicationControlPortItem-Reset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommunicationControlPortItem_Reset_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommunicationControlPortInfoList-Reset >-----#
    CommunicationControlPortInfoList_Reset = SEQ_OF(name='CommunicationControlPortInfoList-Reset', mode=MODE_TYPE)
    _CommunicationControlPortInfoList_Reset__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __CommunicationControlPortInfoList_Reset__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___CommunicationControlPortInfoList_Reset__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____CommunicationControlPortInfoList_Reset__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommunicationControlPortInfoItem-Reset')))
    ___CommunicationControlPortInfoList_Reset__item__id_tab._val = ASN1Set(rv=[dict([('id', 414), ('criticality', 'reject'), ('Value', ____CommunicationControlPortInfoList_Reset__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CommunicationControlPortInfoList_Reset__item__id._const_tab = ___CommunicationControlPortInfoList_Reset__item__id_tab
    __CommunicationControlPortInfoList_Reset__item__id._const_tab_at = None
    __CommunicationControlPortInfoList_Reset__item__id._const_tab_id = 'id'
    __CommunicationControlPortInfoList_Reset__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __CommunicationControlPortInfoList_Reset__item__criticality._const_tab = ___CommunicationControlPortInfoList_Reset__item__id_tab
    __CommunicationControlPortInfoList_Reset__item__criticality._const_tab_at = ('..', 'id')
    __CommunicationControlPortInfoList_Reset__item__criticality._const_tab_id = 'criticality'
    __CommunicationControlPortInfoList_Reset__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __CommunicationControlPortInfoList_Reset__item__value._const_tab = ___CommunicationControlPortInfoList_Reset__item__id_tab
    __CommunicationControlPortInfoList_Reset__item__value._const_tab_at = ('..', 'id')
    __CommunicationControlPortInfoList_Reset__item__value._const_tab_id = 'Value'
    _CommunicationControlPortInfoList_Reset__item_._cont = ASN1Dict([
        ('id', __CommunicationControlPortInfoList_Reset__item__id),
        ('criticality', __CommunicationControlPortInfoList_Reset__item__criticality),
        ('value', __CommunicationControlPortInfoList_Reset__item__value),
        ])
    _CommunicationControlPortInfoList_Reset__item_._ext = None
    CommunicationControlPortInfoList_Reset._cont = _CommunicationControlPortInfoList_Reset__item_
    CommunicationControlPortInfoList_Reset._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CommunicationControlPortInfoItemIE-Reset >-----#
    CommunicationControlPortInfoItemIE_Reset = CLASS(name='CommunicationControlPortInfoItemIE-Reset', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CommunicationControlPortInfoItemIE_Reset_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommunicationControlPortInfoItem-Reset')))
    CommunicationControlPortInfoItemIE_Reset._val = ASN1Set(rv=[dict([('id', 414), ('criticality', 'reject'), ('Value', _CommunicationControlPortInfoItemIE_Reset_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CommunicationControlPortInfoItem-Reset >-----#
    CommunicationControlPortInfoItem_Reset = SEQ(name='CommunicationControlPortInfoItem-Reset', mode=MODE_TYPE)
    _CommunicationControlPortInfoItem_Reset_communicationControlPortID = INT(name='communicationControlPortID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CommunicationControlPortID')))
    _CommunicationControlPortInfoItem_Reset_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommunicationControlPortInfoItem_Reset_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__id._const_tab = ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__id_tab
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__id._const_tab_at = None
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__id._const_tab_id = 'id'
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__criticality._const_tab = ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__criticality_tab
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab = ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__extensionValue_tab
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CommunicationControlPortInfoItem_Reset_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__id),
        ('criticality', ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__criticality),
        ('extensionValue', ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__extensionValue),
        ])
    __CommunicationControlPortInfoItem_Reset_iE_Extensions__item_._ext = None
    _CommunicationControlPortInfoItem_Reset_iE_Extensions._cont = __CommunicationControlPortInfoItem_Reset_iE_Extensions__item_
    _CommunicationControlPortInfoItem_Reset_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommunicationControlPortInfoItem_Reset._cont = ASN1Dict([
        ('communicationControlPortID', _CommunicationControlPortInfoItem_Reset_communicationControlPortID),
        ('iE-Extensions', _CommunicationControlPortInfoItem_Reset_iE_Extensions),
        ])
    CommunicationControlPortInfoItem_Reset._ext = []
    
    #-----< CommunicationControlPortInfoItem-Reset-ExtIEs >-----#
    CommunicationControlPortInfoItem_Reset_ExtIEs = CLASS(name='CommunicationControlPortInfoItem-Reset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CommunicationControlPortInfoItem_Reset_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResetResponse >-----#
    ResetResponse = SEQ(name='ResetResponse', mode=MODE_TYPE)
    _ResetResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __ResetResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___ResetResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____ResetResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____ResetResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____ResetResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____ResetResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetResponse_protocolIEs__item__id._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__id._const_tab_at = None
    ___ResetResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___ResetResponse_protocolIEs__item__criticality._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___ResetResponse_protocolIEs__item__value._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetResponse_protocolIEs__item__id),
        ('criticality', ___ResetResponse_protocolIEs__item__criticality),
        ('value', ___ResetResponse_protocolIEs__item__value),
        ])
    __ResetResponse_protocolIEs__item_._ext = None
    _ResetResponse_protocolIEs._cont = __ResetResponse_protocolIEs__item_
    _ResetResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ResetResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___ResetResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____ResetResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ResetResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResetResponse_protocolExtensions__item__id._const_tab = ____ResetResponse_protocolExtensions__item__id_tab
    ___ResetResponse_protocolExtensions__item__id._const_tab_at = None
    ___ResetResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___ResetResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResetResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ResetResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResetResponse_protocolExtensions__item__criticality._const_tab = ____ResetResponse_protocolExtensions__item__criticality_tab
    ___ResetResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResetResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ResetResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResetResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____ResetResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResetResponse_protocolExtensions__item__extensionValue._const_tab = ____ResetResponse_protocolExtensions__item__extensionValue_tab
    ___ResetResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResetResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ResetResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ResetResponse_protocolExtensions__item__id),
        ('criticality', ___ResetResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___ResetResponse_protocolExtensions__item__extensionValue),
        ])
    __ResetResponse_protocolExtensions__item_._ext = None
    _ResetResponse_protocolExtensions._cont = __ResetResponse_protocolExtensions__item_
    _ResetResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetResponse._cont = ASN1Dict([
        ('protocolIEs', _ResetResponse_protocolIEs),
        ('protocolExtensions', _ResetResponse_protocolExtensions),
        ])
    ResetResponse._ext = []
    
    #-----< ResetResponse-IEs >-----#
    ResetResponse_IEs = CLASS(name='ResetResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _ResetResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ResetResponse_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _ResetResponse_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResponse-Extensions >-----#
    ResetResponse_Extensions = CLASS(name='ResetResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ResetResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationRequest >-----#
    InformationExchangeInitiationRequest = SEQ(name='InformationExchangeInitiationRequest', mode=MODE_TYPE)
    _InformationExchangeInitiationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeInitiationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rqst')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationType')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationReportCharacteristics')))
    ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'reject'), ('Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 445), ('criticality', 'reject'), ('Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 446), ('criticality', 'reject'), ('Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 447), ('criticality', 'reject'), ('Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationRequest_protocolIEs__item__id._const_tab = ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab
    ___InformationExchangeInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeInitiationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality._const_tab = ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___InformationExchangeInitiationRequest_protocolIEs__item__value._const_tab = ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab
    ___InformationExchangeInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationExchangeInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationRequest_protocolIEs__item__id),
        ('criticality', ___InformationExchangeInitiationRequest_protocolIEs__item__criticality),
        ('value', ___InformationExchangeInitiationRequest_protocolIEs__item__value),
        ])
    __InformationExchangeInitiationRequest_protocolIEs__item_._ext = None
    _InformationExchangeInitiationRequest_protocolIEs._cont = __InformationExchangeInitiationRequest_protocolIEs__item_
    _InformationExchangeInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeInitiationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeInitiationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id._const_tab = ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality._const_tab = ____InformationExchangeInitiationRequest_protocolExtensions__item__criticality_tab
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationExchangeInitiationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationRequest_protocolExtensions__item__id),
        ('criticality', ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeInitiationRequest_protocolExtensions__item_._ext = None
    _InformationExchangeInitiationRequest_protocolExtensions._cont = __InformationExchangeInitiationRequest_protocolExtensions__item_
    _InformationExchangeInitiationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeInitiationRequest._cont = ASN1Dict([
        ('protocolIEs', _InformationExchangeInitiationRequest_protocolIEs),
        ('protocolExtensions', _InformationExchangeInitiationRequest_protocolExtensions),
        ])
    InformationExchangeInitiationRequest._ext = []
    
    #-----< InformationExchangeInitiationRequest-IEs >-----#
    InformationExchangeInitiationRequest_IEs = CLASS(name='InformationExchangeInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _InformationExchangeInitiationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    _InformationExchangeInitiationRequest_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rqst')))
    _InformationExchangeInitiationRequest_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationType')))
    _InformationExchangeInitiationRequest_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationReportCharacteristics')))
    InformationExchangeInitiationRequest_IEs._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'reject'), ('Value', _InformationExchangeInitiationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 445), ('criticality', 'reject'), ('Value', _InformationExchangeInitiationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 446), ('criticality', 'reject'), ('Value', _InformationExchangeInitiationRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 447), ('criticality', 'reject'), ('Value', _InformationExchangeInitiationRequest_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationRequest-Extensions >-----#
    InformationExchangeInitiationRequest_Extensions = CLASS(name='InformationExchangeInitiationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    InformationExchangeInitiationRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeObjectType-InfEx-Rqst >-----#
    InformationExchangeObjectType_InfEx_Rqst = CHOICE(name='InformationExchangeObjectType-InfEx-Rqst', mode=MODE_TYPE)
    _InformationExchangeObjectType_InfEx_Rqst_cell = SEQ(name='cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-InfEx-Rqst')))
    InformationExchangeObjectType_InfEx_Rqst._cont = ASN1Dict([
        ('cell', _InformationExchangeObjectType_InfEx_Rqst_cell),
        ])
    InformationExchangeObjectType_InfEx_Rqst._ext = []
    
    #-----< Cell-InfEx-Rqst >-----#
    Cell_InfEx_Rqst = SEQ(name='Cell-InfEx-Rqst', mode=MODE_TYPE)
    _Cell_InfEx_Rqst_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _Cell_InfEx_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_InfEx_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_InfEx_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_InfEx_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rqst_iE_Extensions__item__id._const_tab = ____Cell_InfEx_Rqst_iE_Extensions__item__id_tab
    ___Cell_InfEx_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___Cell_InfEx_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_InfEx_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rqst_iE_Extensions__item__criticality._const_tab = ____Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab
    ___Cell_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab = ____Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab
    ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_InfEx_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_InfEx_Rqst_iE_Extensions__item__id),
        ('criticality', ___Cell_InfEx_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue),
        ])
    __Cell_InfEx_Rqst_iE_Extensions__item_._ext = None
    _Cell_InfEx_Rqst_iE_Extensions._cont = __Cell_InfEx_Rqst_iE_Extensions__item_
    _Cell_InfEx_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_InfEx_Rqst._cont = ASN1Dict([
        ('c-ID', _Cell_InfEx_Rqst_c_ID),
        ('iE-Extensions', _Cell_InfEx_Rqst_iE_Extensions),
        ])
    Cell_InfEx_Rqst._ext = []
    
    #-----< CellItem-InfEx-Rqst-ExtIEs >-----#
    CellItem_InfEx_Rqst_ExtIEs = CLASS(name='CellItem-InfEx-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellItem_InfEx_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationResponse >-----#
    InformationExchangeInitiationResponse = SEQ(name='InformationExchangeInitiationResponse', mode=MODE_TYPE)
    _InformationExchangeInitiationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeInitiationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rsp')))
    _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 448), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolIEs__item__id._const_tab = ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab
    ___InformationExchangeInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeInitiationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality._const_tab = ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___InformationExchangeInitiationResponse_protocolIEs__item__value._const_tab = ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab
    ___InformationExchangeInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationExchangeInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationResponse_protocolIEs__item__id),
        ('criticality', ___InformationExchangeInitiationResponse_protocolIEs__item__criticality),
        ('value', ___InformationExchangeInitiationResponse_protocolIEs__item__value),
        ])
    __InformationExchangeInitiationResponse_protocolIEs__item_._ext = None
    _InformationExchangeInitiationResponse_protocolIEs._cont = __InformationExchangeInitiationResponse_protocolIEs__item_
    _InformationExchangeInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeInitiationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeInitiationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id._const_tab = ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality._const_tab = ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationExchangeInitiationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationResponse_protocolExtensions__item__id),
        ('criticality', ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeInitiationResponse_protocolExtensions__item_._ext = None
    _InformationExchangeInitiationResponse_protocolExtensions._cont = __InformationExchangeInitiationResponse_protocolExtensions__item_
    _InformationExchangeInitiationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeInitiationResponse._cont = ASN1Dict([
        ('protocolIEs', _InformationExchangeInitiationResponse_protocolIEs),
        ('protocolExtensions', _InformationExchangeInitiationResponse_protocolExtensions),
        ])
    InformationExchangeInitiationResponse._ext = []
    
    #-----< InformationExchangeInitiationResponse-IEs >-----#
    InformationExchangeInitiationResponse_IEs = CLASS(name='InformationExchangeInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _InformationExchangeInitiationResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    _InformationExchangeInitiationResponse_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rsp')))
    _InformationExchangeInitiationResponse_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    InformationExchangeInitiationResponse_IEs._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 448), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationResponse_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationResponse_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationResponse-Extensions >-----#
    InformationExchangeInitiationResponse_Extensions = CLASS(name='InformationExchangeInitiationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    InformationExchangeInitiationResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeObjectType-InfEx-Rsp >-----#
    InformationExchangeObjectType_InfEx_Rsp = CHOICE(name='InformationExchangeObjectType-InfEx-Rsp', mode=MODE_TYPE)
    _InformationExchangeObjectType_InfEx_Rsp_cell = SEQ(name='cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-InfEx-Rsp')))
    InformationExchangeObjectType_InfEx_Rsp._cont = ASN1Dict([
        ('cell', _InformationExchangeObjectType_InfEx_Rsp_cell),
        ])
    InformationExchangeObjectType_InfEx_Rsp._ext = []
    
    #-----< Cell-InfEx-Rsp >-----#
    Cell_InfEx_Rsp = SEQ(name='Cell-InfEx-Rsp', mode=MODE_TYPE)
    _Cell_InfEx_Rsp_requestedDataValue = SEQ(name='requestedDataValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RequestedDataValue')))
    _Cell_InfEx_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_InfEx_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_InfEx_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_InfEx_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rsp_iE_Extensions__item__id._const_tab = ____Cell_InfEx_Rsp_iE_Extensions__item__id_tab
    ___Cell_InfEx_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Cell_InfEx_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_InfEx_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cell_InfEx_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rsp_iE_Extensions__item__criticality._const_tab = ____Cell_InfEx_Rsp_iE_Extensions__item__criticality_tab
    ___Cell_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cell_InfEx_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Cell_InfEx_Rsp_iE_Extensions__item__extensionValue_tab
    ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_InfEx_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_InfEx_Rsp_iE_Extensions__item__id),
        ('criticality', ___Cell_InfEx_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Cell_InfEx_Rsp_iE_Extensions__item_._ext = None
    _Cell_InfEx_Rsp_iE_Extensions._cont = __Cell_InfEx_Rsp_iE_Extensions__item_
    _Cell_InfEx_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_InfEx_Rsp._cont = ASN1Dict([
        ('requestedDataValue', _Cell_InfEx_Rsp_requestedDataValue),
        ('iE-Extensions', _Cell_InfEx_Rsp_iE_Extensions),
        ])
    Cell_InfEx_Rsp._ext = []
    
    #-----< CellItem-InfEx-Rsp-ExtIEs >-----#
    CellItem_InfEx_Rsp_ExtIEs = CLASS(name='CellItem-InfEx-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellItem_InfEx_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationFailure >-----#
    InformationExchangeInitiationFailure = SEQ(name='InformationExchangeInitiationFailure', mode=MODE_TYPE)
    _InformationExchangeInitiationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeInitiationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolIEs__item__id._const_tab = ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab
    ___InformationExchangeInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeInitiationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality._const_tab = ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___InformationExchangeInitiationFailure_protocolIEs__item__value._const_tab = ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab
    ___InformationExchangeInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationExchangeInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationFailure_protocolIEs__item__id),
        ('criticality', ___InformationExchangeInitiationFailure_protocolIEs__item__criticality),
        ('value', ___InformationExchangeInitiationFailure_protocolIEs__item__value),
        ])
    __InformationExchangeInitiationFailure_protocolIEs__item_._ext = None
    _InformationExchangeInitiationFailure_protocolIEs._cont = __InformationExchangeInitiationFailure_protocolIEs__item_
    _InformationExchangeInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeInitiationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeInitiationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id._const_tab = ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality._const_tab = ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationExchangeInitiationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationFailure_protocolExtensions__item__id),
        ('criticality', ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeInitiationFailure_protocolExtensions__item_._ext = None
    _InformationExchangeInitiationFailure_protocolExtensions._cont = __InformationExchangeInitiationFailure_protocolExtensions__item_
    _InformationExchangeInitiationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeInitiationFailure._cont = ASN1Dict([
        ('protocolIEs', _InformationExchangeInitiationFailure_protocolIEs),
        ('protocolExtensions', _InformationExchangeInitiationFailure_protocolExtensions),
        ])
    InformationExchangeInitiationFailure._ext = []
    
    #-----< InformationExchangeInitiationFailure-IEs >-----#
    InformationExchangeInitiationFailure_IEs = CLASS(name='InformationExchangeInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _InformationExchangeInitiationFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    _InformationExchangeInitiationFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _InformationExchangeInitiationFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    InformationExchangeInitiationFailure_IEs._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationFailure_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationFailure-Extensions >-----#
    InformationExchangeInitiationFailure_Extensions = CLASS(name='InformationExchangeInitiationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    InformationExchangeInitiationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationReport >-----#
    InformationReport = SEQ(name='InformationReport', mode=MODE_TYPE)
    _InformationReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __InformationReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___InformationReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____InformationReport_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____InformationReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    _____InformationReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rprt')))
    ____InformationReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Value', _____InformationReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 449), ('criticality', 'ignore'), ('Value', _____InformationReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InformationReport_protocolIEs__item__id._const_tab = ____InformationReport_protocolIEs__item__id_tab
    ___InformationReport_protocolIEs__item__id._const_tab_at = None
    ___InformationReport_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___InformationReport_protocolIEs__item__criticality._const_tab = ____InformationReport_protocolIEs__item__id_tab
    ___InformationReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___InformationReport_protocolIEs__item__value._const_tab = ____InformationReport_protocolIEs__item__id_tab
    ___InformationReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationReport_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationReport_protocolIEs__item__id),
        ('criticality', ___InformationReport_protocolIEs__item__criticality),
        ('value', ___InformationReport_protocolIEs__item__value),
        ])
    __InformationReport_protocolIEs__item_._ext = None
    _InformationReport_protocolIEs._cont = __InformationReport_protocolIEs__item_
    _InformationReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationReport_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___InformationReport_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationReport_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReport_protocolExtensions__item__id._const_tab = ____InformationReport_protocolExtensions__item__id_tab
    ___InformationReport_protocolExtensions__item__id._const_tab_at = None
    ___InformationReport_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationReport_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationReport_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationReport_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReport_protocolExtensions__item__criticality._const_tab = ____InformationReport_protocolExtensions__item__criticality_tab
    ___InformationReport_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationReport_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationReport_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationReport_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationReport_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReport_protocolExtensions__item__extensionValue._const_tab = ____InformationReport_protocolExtensions__item__extensionValue_tab
    ___InformationReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationReport_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationReport_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationReport_protocolExtensions__item__id),
        ('criticality', ___InformationReport_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationReport_protocolExtensions__item__extensionValue),
        ])
    __InformationReport_protocolExtensions__item_._ext = None
    _InformationReport_protocolExtensions._cont = __InformationReport_protocolExtensions__item_
    _InformationReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationReport._cont = ASN1Dict([
        ('protocolIEs', _InformationReport_protocolIEs),
        ('protocolExtensions', _InformationReport_protocolExtensions),
        ])
    InformationReport._ext = []
    
    #-----< InformationReport-IEs >-----#
    InformationReport_IEs = CLASS(name='InformationReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _InformationReport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    _InformationReport_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rprt')))
    InformationReport_IEs._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Value', _InformationReport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 449), ('criticality', 'ignore'), ('Value', _InformationReport_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationReport-Extensions >-----#
    InformationReport_Extensions = CLASS(name='InformationReport-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    InformationReport_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeObjectType-InfEx-Rprt >-----#
    InformationExchangeObjectType_InfEx_Rprt = CHOICE(name='InformationExchangeObjectType-InfEx-Rprt', mode=MODE_TYPE)
    _InformationExchangeObjectType_InfEx_Rprt_cell = SEQ(name='cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Cell-Inf-Rprt')))
    InformationExchangeObjectType_InfEx_Rprt._cont = ASN1Dict([
        ('cell', _InformationExchangeObjectType_InfEx_Rprt_cell),
        ])
    InformationExchangeObjectType_InfEx_Rprt._ext = []
    
    #-----< Cell-Inf-Rprt >-----#
    Cell_Inf_Rprt = SEQ(name='Cell-Inf-Rprt', mode=MODE_TYPE)
    _Cell_Inf_Rprt_requestedDataValueInformation = CHOICE(name='requestedDataValueInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RequestedDataValueInformation')))
    _Cell_Inf_Rprt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_Inf_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Cell_Inf_Rprt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_Inf_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Inf_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Inf_Rprt_iE_Extensions__item__id._const_tab = ____Cell_Inf_Rprt_iE_Extensions__item__id_tab
    ___Cell_Inf_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___Cell_Inf_Rprt_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_Inf_Rprt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cell_Inf_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Inf_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Inf_Rprt_iE_Extensions__item__criticality._const_tab = ____Cell_Inf_Rprt_iE_Extensions__item__criticality_tab
    ___Cell_Inf_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_Inf_Rprt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_Inf_Rprt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cell_Inf_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Cell_Inf_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Inf_Rprt_iE_Extensions__item__extensionValue._const_tab = ____Cell_Inf_Rprt_iE_Extensions__item__extensionValue_tab
    ___Cell_Inf_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_Inf_Rprt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_Inf_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_Inf_Rprt_iE_Extensions__item__id),
        ('criticality', ___Cell_Inf_Rprt_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_Inf_Rprt_iE_Extensions__item__extensionValue),
        ])
    __Cell_Inf_Rprt_iE_Extensions__item_._ext = None
    _Cell_Inf_Rprt_iE_Extensions._cont = __Cell_Inf_Rprt_iE_Extensions__item_
    _Cell_Inf_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_Inf_Rprt._cont = ASN1Dict([
        ('requestedDataValueInformation', _Cell_Inf_Rprt_requestedDataValueInformation),
        ('iE-Extensions', _Cell_Inf_Rprt_iE_Extensions),
        ])
    Cell_Inf_Rprt._ext = []
    
    #-----< CellItem-Inf-Rprt-ExtIEs >-----#
    CellItem_Inf_Rprt_ExtIEs = CLASS(name='CellItem-Inf-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellItem_Inf_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeTerminationRequest >-----#
    InformationExchangeTerminationRequest = SEQ(name='InformationExchangeTerminationRequest', mode=MODE_TYPE)
    _InformationExchangeTerminationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeTerminationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeTerminationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____InformationExchangeTerminationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Value', _____InformationExchangeTerminationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolIEs__item__id._const_tab = ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab
    ___InformationExchangeTerminationRequest_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeTerminationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality._const_tab = ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeTerminationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___InformationExchangeTerminationRequest_protocolIEs__item__value._const_tab = ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab
    ___InformationExchangeTerminationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationExchangeTerminationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationExchangeTerminationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeTerminationRequest_protocolIEs__item__id),
        ('criticality', ___InformationExchangeTerminationRequest_protocolIEs__item__criticality),
        ('value', ___InformationExchangeTerminationRequest_protocolIEs__item__value),
        ])
    __InformationExchangeTerminationRequest_protocolIEs__item_._ext = None
    _InformationExchangeTerminationRequest_protocolIEs._cont = __InformationExchangeTerminationRequest_protocolIEs__item_
    _InformationExchangeTerminationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeTerminationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeTerminationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id._const_tab = ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality._const_tab = ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationExchangeTerminationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeTerminationRequest_protocolExtensions__item__id),
        ('criticality', ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeTerminationRequest_protocolExtensions__item_._ext = None
    _InformationExchangeTerminationRequest_protocolExtensions._cont = __InformationExchangeTerminationRequest_protocolExtensions__item_
    _InformationExchangeTerminationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeTerminationRequest._cont = ASN1Dict([
        ('protocolIEs', _InformationExchangeTerminationRequest_protocolIEs),
        ('protocolExtensions', _InformationExchangeTerminationRequest_protocolExtensions),
        ])
    InformationExchangeTerminationRequest._ext = []
    
    #-----< InformationExchangeTerminationRequest-IEs >-----#
    InformationExchangeTerminationRequest_IEs = CLASS(name='InformationExchangeTerminationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _InformationExchangeTerminationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    InformationExchangeTerminationRequest_IEs._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Value', _InformationExchangeTerminationRequest_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeTerminationRequest-Extensions >-----#
    InformationExchangeTerminationRequest_Extensions = CLASS(name='InformationExchangeTerminationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    InformationExchangeTerminationRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeFailureIndication >-----#
    InformationExchangeFailureIndication = SEQ(name='InformationExchangeFailureIndication', mode=MODE_TYPE)
    _InformationExchangeFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____InformationExchangeFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    ____InformationExchangeFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Value', _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolIEs__item__id._const_tab = ____InformationExchangeFailureIndication_protocolIEs__item__id_tab
    ___InformationExchangeFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality._const_tab = ____InformationExchangeFailureIndication_protocolIEs__item__id_tab
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___InformationExchangeFailureIndication_protocolIEs__item__value._const_tab = ____InformationExchangeFailureIndication_protocolIEs__item__id_tab
    ___InformationExchangeFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationExchangeFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationExchangeFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeFailureIndication_protocolIEs__item__id),
        ('criticality', ___InformationExchangeFailureIndication_protocolIEs__item__criticality),
        ('value', ___InformationExchangeFailureIndication_protocolIEs__item__value),
        ])
    __InformationExchangeFailureIndication_protocolIEs__item_._ext = None
    _InformationExchangeFailureIndication_protocolIEs._cont = __InformationExchangeFailureIndication_protocolIEs__item_
    _InformationExchangeFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeFailureIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeFailureIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeFailureIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolExtensions__item__id._const_tab = ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab
    ___InformationExchangeFailureIndication_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeFailureIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality._const_tab = ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationExchangeFailureIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeFailureIndication_protocolExtensions__item__id),
        ('criticality', ___InformationExchangeFailureIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeFailureIndication_protocolExtensions__item_._ext = None
    _InformationExchangeFailureIndication_protocolExtensions._cont = __InformationExchangeFailureIndication_protocolExtensions__item_
    _InformationExchangeFailureIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _InformationExchangeFailureIndication_protocolIEs),
        ('protocolExtensions', _InformationExchangeFailureIndication_protocolExtensions),
        ])
    InformationExchangeFailureIndication._ext = []
    
    #-----< InformationExchangeFailureIndication-IEs >-----#
    InformationExchangeFailureIndication_IEs = CLASS(name='InformationExchangeFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _InformationExchangeFailureIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'InformationExchangeID')))
    _InformationExchangeFailureIndication_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    InformationExchangeFailureIndication_IEs._val = ASN1Set(rv=[dict([('id', 444), ('criticality', 'ignore'), ('Value', _InformationExchangeFailureIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _InformationExchangeFailureIndication_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeFailureIndication-Extensions >-----#
    InformationExchangeFailureIndication_Extensions = CLASS(name='InformationExchangeFailureIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    InformationExchangeFailureIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationInitiationRequestTDD >-----#
    CellSynchronisationInitiationRequestTDD = SEQ(name='CellSynchronisationInitiationRequestTDD', mode=MODE_TYPE)
    _CellSynchronisationInitiationRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationInitiationRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstRepetitionPeriod')))
    _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeslotInfo-CellSyncInitiationRqstTDD')))
    _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstTransInit-CellSyncInitiationRqstTDD')))
    _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD')))
    ____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 511), ('criticality', 'reject'), ('Value', _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 496), ('criticality', 'reject'), ('Value', _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 422), ('criticality', 'reject'), ('Value', _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 423), ('criticality', 'reject'), ('Value', _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationInitiationRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationInitiationRequestTDD_protocolIEs__item_._ext = None
    _CellSynchronisationInitiationRequestTDD_protocolIEs._cont = __CellSynchronisationInitiationRequestTDD_protocolIEs__item_
    _CellSynchronisationInitiationRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationInitiationRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationInitiationRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD')))
    _____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD')))
    ____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 543), ('criticality', 'reject'), ('Extension', _____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 544), ('criticality', 'reject'), ('Extension', _____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationInitiationRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationInitiationRequestTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationInitiationRequestTDD_protocolExtensions._cont = __CellSynchronisationInitiationRequestTDD_protocolExtensions__item_
    _CellSynchronisationInitiationRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationInitiationRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationInitiationRequestTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationInitiationRequestTDD_protocolExtensions),
        ])
    CellSynchronisationInitiationRequestTDD._ext = []
    
    #-----< CellSynchronisationInitiationRequestTDD-IEs >-----#
    CellSynchronisationInitiationRequestTDD_IEs = CLASS(name='CellSynchronisationInitiationRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationInitiationRequestTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CellSynchronisationInitiationRequestTDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstRepetitionPeriod')))
    _CellSynchronisationInitiationRequestTDD_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'TimeslotInfo-CellSyncInitiationRqstTDD')))
    _CellSynchronisationInitiationRequestTDD_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstTransInit-CellSyncInitiationRqstTDD')))
    _CellSynchronisationInitiationRequestTDD_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD')))
    CellSynchronisationInitiationRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _CellSynchronisationInitiationRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 511), ('criticality', 'reject'), ('Value', _CellSynchronisationInitiationRequestTDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 496), ('criticality', 'reject'), ('Value', _CellSynchronisationInitiationRequestTDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 422), ('criticality', 'reject'), ('Value', _CellSynchronisationInitiationRequestTDD_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 423), ('criticality', 'reject'), ('Value', _CellSynchronisationInitiationRequestTDD_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationInitiationRequestTDD-Extensions >-----#
    CellSynchronisationInitiationRequestTDD_Extensions = CLASS(name='CellSynchronisationInitiationRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CellSynchronisationInitiationRequestTDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD')))
    _CellSynchronisationInitiationRequestTDD_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD')))
    CellSynchronisationInitiationRequestTDD_Extensions._val = ASN1Set(rv=[dict([('id', 543), ('criticality', 'reject'), ('Extension', _CellSynchronisationInitiationRequestTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 544), ('criticality', 'reject'), ('Extension', _CellSynchronisationInitiationRequestTDD_Extensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TimeslotInfo-CellSyncInitiationRqstTDD >-----#
    TimeslotInfo_CellSyncInitiationRqstTDD = SEQ_OF(name='TimeslotInfo-CellSyncInitiationRqstTDD', mode=MODE_TYPE)
    _TimeslotInfo_CellSyncInitiationRqstTDD__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    TimeslotInfo_CellSyncInitiationRqstTDD._cont = _TimeslotInfo_CellSyncInitiationRqstTDD__item_
    TimeslotInfo_CellSyncInitiationRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< CellSyncBurstTransInit-CellSyncInitiationRqstTDD >-----#
    CellSyncBurstTransInit_CellSyncInitiationRqstTDD = SEQ(name='CellSyncBurstTransInit-CellSyncInitiationRqstTDD', mode=MODE_TYPE)
    _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_cSBTransmissionID = INT(name='cSBTransmissionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CSBTransmissionID')))
    _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_cellSyncBurstCode = INT(name='cellSyncBurstCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstCode')))
    _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_cellSyncBurstCodeShift = INT(name='cellSyncBurstCodeShift', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstCodeShift')))
    _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_initialDLTransPower = INT(name='initialDLTransPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')))
    _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab = ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab = ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id),
        ('criticality', ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item_._ext = None
    _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions._cont = __CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item_
    _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSyncBurstTransInit_CellSyncInitiationRqstTDD._cont = ASN1Dict([
        ('cSBTransmissionID', _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_cSBTransmissionID),
        ('sfn', _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_sfn),
        ('cellSyncBurstCode', _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_cellSyncBurstCode),
        ('cellSyncBurstCodeShift', _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_cellSyncBurstCodeShift),
        ('initialDLTransPower', _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_initialDLTransPower),
        ('iE-Extensions', _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions),
        ])
    CellSyncBurstTransInit_CellSyncInitiationRqstTDD._ext = []
    
    #-----< CellSyncBurstTransInit-CellSyncInitiationRqstTDD-ExtIEs >-----#
    CellSyncBurstTransInit_CellSyncInitiationRqstTDD_ExtIEs = CLASS(name='CellSyncBurstTransInit-CellSyncInitiationRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSyncBurstTransInit_CellSyncInitiationRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD >-----#
    CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD = SEQ(name='CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD', mode=MODE_TYPE)
    _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_cSBMeasurementID = INT(name='cSBMeasurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CSBMeasurementID')))
    _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_cellSyncBurstCode = INT(name='cellSyncBurstCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstCode')))
    _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_cellSyncBurstCodeShift = INT(name='cellSyncBurstCodeShift', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstCodeShift')))
    _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_synchronisationReportType = ENUM(name='synchronisationReportType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportType')))
    _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFN')), opt=True)
    _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_synchronisationReportCharacteristics = SEQ(name='synchronisationReportCharacteristics', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportCharacteristics')))
    _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab = ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab = ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id),
        ('criticality', ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item_._ext = None
    _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions._cont = __CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item_
    _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD._cont = ASN1Dict([
        ('cSBMeasurementID', _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_cSBMeasurementID),
        ('cellSyncBurstCode', _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_cellSyncBurstCode),
        ('cellSyncBurstCodeShift', _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_cellSyncBurstCodeShift),
        ('synchronisationReportType', _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_synchronisationReportType),
        ('sfn', _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_sfn),
        ('synchronisationReportCharacteristics', _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_synchronisationReportCharacteristics),
        ('iE-Extensions', _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions),
        ])
    CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD._ext = []
    
    #-----< CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD-ExtIEs >-----#
    CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_ExtIEs = CLASS(name='CellSyncBurstMeasureInit-CellSyncInitiationRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD >-----#
    SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD = SEQ(name='SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD', mode=MODE_TYPE)
    _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_cSBTransmissionID = INT(name='cSBTransmissionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CSBTransmissionID')))
    _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_sYNCDlCodeId = INT(name='sYNCDlCodeId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SYNCDlCodeId')))
    _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_dwPCH_Power = INT(name='dwPCH-Power', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DwPCH-Power')))
    _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab = ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab = ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id),
        ('criticality', ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item_._ext = None
    _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions._cont = __SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item_
    _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD._cont = ASN1Dict([
        ('cSBTransmissionID', _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_cSBTransmissionID),
        ('sfn', _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_sfn),
        ('uARFCN', _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_uARFCN),
        ('sYNCDlCodeId', _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_sYNCDlCodeId),
        ('dwPCH-Power', _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_dwPCH_Power),
        ('iE-Extensions', _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions),
        ])
    SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD._ext = []
    
    #-----< SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD-ExtIEs >-----#
    SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_ExtIEs = CLASS(name='SYNCDlCodeId-TransInitLCR-CellSyncInitiationRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD >-----#
    SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD = SEQ(name='SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD', mode=MODE_TYPE)
    _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_cSBMeasurementID = INT(name='cSBMeasurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CSBMeasurementID')))
    _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFN')), opt=True)
    _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_sYNCDlCodeId = INT(name='sYNCDlCodeId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SYNCDlCodeId')))
    _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_synchronisationReportType = ENUM(name='synchronisationReportType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportType')))
    _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_synchronisationReportCharacteristics = SEQ(name='synchronisationReportCharacteristics', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportCharacteristics')))
    _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab = ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab = ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id),
        ('criticality', ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item_._ext = None
    _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions._cont = __SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item_
    _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD._cont = ASN1Dict([
        ('cSBMeasurementID', _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_cSBMeasurementID),
        ('sfn', _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_sfn),
        ('uARFCN', _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_uARFCN),
        ('sYNCDlCodeId', _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_sYNCDlCodeId),
        ('synchronisationReportType', _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_synchronisationReportType),
        ('synchronisationReportCharacteristics', _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_synchronisationReportCharacteristics),
        ('iE-Extensions', _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions),
        ])
    SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD._ext = []
    
    #-----< SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD-ExtIEs >-----#
    SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_ExtIEs = CLASS(name='SYNCDlCodeId-MeasureInitLCR-CellSyncInitiationRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationInitiationResponseTDD >-----#
    CellSynchronisationInitiationResponseTDD = SEQ(name='CellSynchronisationInitiationResponseTDD', mode=MODE_TYPE)
    _CellSynchronisationInitiationResponseTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationInitiationResponseTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationInitiationResponseTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationInitiationResponseTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CellSynchronisationInitiationResponseTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CellSynchronisationInitiationResponseTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationInitiationResponseTDD_protocolIEs__item__id_tab
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationInitiationResponseTDD_protocolIEs__item__id_tab
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationInitiationResponseTDD_protocolIEs__item__id_tab
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationInitiationResponseTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationInitiationResponseTDD_protocolIEs__item_._ext = None
    _CellSynchronisationInitiationResponseTDD_protocolIEs._cont = __CellSynchronisationInitiationResponseTDD_protocolIEs__item_
    _CellSynchronisationInitiationResponseTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationInitiationResponseTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationInitiationResponseTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__criticality_tab
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__extensionValue_tab
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationInitiationResponseTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationInitiationResponseTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationInitiationResponseTDD_protocolExtensions._cont = __CellSynchronisationInitiationResponseTDD_protocolExtensions__item_
    _CellSynchronisationInitiationResponseTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationInitiationResponseTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationInitiationResponseTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationInitiationResponseTDD_protocolExtensions),
        ])
    CellSynchronisationInitiationResponseTDD._ext = []
    
    #-----< CellSynchronisationInitiationResponseTDD-Extensions >-----#
    CellSynchronisationInitiationResponseTDD_Extensions = CLASS(name='CellSynchronisationInitiationResponseTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSynchronisationInitiationResponseTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationInitiationResponseTDD-IEs >-----#
    CellSynchronisationInitiationResponseTDD_IEs = CLASS(name='CellSynchronisationInitiationResponseTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationInitiationResponseTDD_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CellSynchronisationInitiationResponseTDD_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _CellSynchronisationInitiationResponseTDD_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationInitiationFailureTDD >-----#
    CellSynchronisationInitiationFailureTDD = SEQ(name='CellSynchronisationInitiationFailureTDD', mode=MODE_TYPE)
    _CellSynchronisationInitiationFailureTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationInitiationFailureTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationInitiationFailureTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationInitiationFailureTDD_protocolIEs__item_._ext = None
    _CellSynchronisationInitiationFailureTDD_protocolIEs._cont = __CellSynchronisationInitiationFailureTDD_protocolIEs__item_
    _CellSynchronisationInitiationFailureTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationInitiationFailureTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationInitiationFailureTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__criticality_tab
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__extensionValue_tab
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationInitiationFailureTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationInitiationFailureTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationInitiationFailureTDD_protocolExtensions._cont = __CellSynchronisationInitiationFailureTDD_protocolExtensions__item_
    _CellSynchronisationInitiationFailureTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationInitiationFailureTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationInitiationFailureTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationInitiationFailureTDD_protocolExtensions),
        ])
    CellSynchronisationInitiationFailureTDD._ext = []
    
    #-----< CellSynchronisationInitiationFailureTDD-Extensions >-----#
    CellSynchronisationInitiationFailureTDD_Extensions = CLASS(name='CellSynchronisationInitiationFailureTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSynchronisationInitiationFailureTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationInitiationFailureTDD-IEs >-----#
    CellSynchronisationInitiationFailureTDD_IEs = CLASS(name='CellSynchronisationInitiationFailureTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationInitiationFailureTDD_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _CellSynchronisationInitiationFailureTDD_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CellSynchronisationInitiationFailureTDD_IEs._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _CellSynchronisationInitiationFailureTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _CellSynchronisationInitiationFailureTDD_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationReconfigurationRequestTDD >-----#
    CellSynchronisationReconfigurationRequestTDD = SEQ(name='CellSynchronisationReconfigurationRequestTDD', mode=MODE_TYPE)
    _CellSynchronisationReconfigurationRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationReconfigurationRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NCyclesPerSFNperiod')))
    _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NRepetitionsPerCyclePeriod')))
    _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstTransReconfInfo-CellSyncReconfRqstTDD')))
    _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstMeasInfo-CellSyncReconfRqstTDD')))
    ____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 495), ('criticality', 'reject'), ('Value', _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 433), ('criticality', 'reject'), ('Value', _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 434), ('criticality', 'reject'), ('Value', _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 428), ('criticality', 'reject'), ('Value', _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 425), ('criticality', 'reject'), ('Value', _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationReconfigurationRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationReconfigurationRequestTDD_protocolIEs__item_._ext = None
    _CellSynchronisationReconfigurationRequestTDD_protocolIEs._cont = __CellSynchronisationReconfigurationRequestTDD_protocolIEs__item_
    _CellSynchronisationReconfigurationRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationReconfigurationRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NSubCyclesPerCyclePeriod')))
    _____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD')))
    _____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeIdMeasInfoLCR-CellSyncReconfRqstTDD')))
    ____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 550), ('criticality', 'reject'), ('Extension', _____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 545), ('criticality', 'reject'), ('Extension', _____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 546), ('criticality', 'reject'), ('Extension', _____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationReconfigurationRequestTDD_protocolExtensions._cont = __CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item_
    _CellSynchronisationReconfigurationRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationReconfigurationRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationReconfigurationRequestTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationReconfigurationRequestTDD_protocolExtensions),
        ])
    CellSynchronisationReconfigurationRequestTDD._ext = []
    
    #-----< CellSynchronisationReconfigurationRequestTDD-IEs >-----#
    CellSynchronisationReconfigurationRequestTDD_IEs = CLASS(name='CellSynchronisationReconfigurationRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimeSlot')))
    _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NCyclesPerSFNperiod')))
    _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NRepetitionsPerCyclePeriod')))
    _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstTransReconfInfo-CellSyncReconfRqstTDD')))
    _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstMeasInfo-CellSyncReconfRqstTDD')))
    CellSynchronisationReconfigurationRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 495), ('criticality', 'reject'), ('Value', _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 433), ('criticality', 'reject'), ('Value', _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 434), ('criticality', 'reject'), ('Value', _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 428), ('criticality', 'reject'), ('Value', _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 425), ('criticality', 'reject'), ('Value', _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationReconfigurationRequestTDD-Extensions >-----#
    CellSynchronisationReconfigurationRequestTDD_Extensions = CLASS(name='CellSynchronisationReconfigurationRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CellSynchronisationReconfigurationRequestTDD_Extensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NSubCyclesPerCyclePeriod')))
    _CellSynchronisationReconfigurationRequestTDD_Extensions_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD')))
    _CellSynchronisationReconfigurationRequestTDD_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeIdMeasInfoLCR-CellSyncReconfRqstTDD')))
    CellSynchronisationReconfigurationRequestTDD_Extensions._val = ASN1Set(rv=[dict([('id', 550), ('criticality', 'reject'), ('Extension', _CellSynchronisationReconfigurationRequestTDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 545), ('criticality', 'reject'), ('Extension', _CellSynchronisationReconfigurationRequestTDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 546), ('criticality', 'reject'), ('Extension', _CellSynchronisationReconfigurationRequestTDD_Extensions_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSyncBurstTransReconfInfo-CellSyncReconfRqstTDD >-----#
    CellSyncBurstTransReconfInfo_CellSyncReconfRqstTDD = SEQ_OF(name='CellSyncBurstTransReconfInfo-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _CellSyncBurstTransReconfInfo_CellSyncReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstTransInfoItem-CellSyncReconfRqstTDD')))
    CellSyncBurstTransReconfInfo_CellSyncReconfRqstTDD._cont = _CellSyncBurstTransReconfInfo_CellSyncReconfRqstTDD__item_
    CellSyncBurstTransReconfInfo_CellSyncReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< CellSyncBurstTransInfoItem-CellSyncReconfRqstTDD >-----#
    CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD = SEQ(name='CellSyncBurstTransInfoItem-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_cSBTransmissionID = INT(name='cSBTransmissionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CSBTransmissionID')))
    _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_syncFrameNumberToTransmit = INT(name='syncFrameNumberToTransmit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SyncFrameNumber')))
    _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCode = INT(name='cellSyncBurstCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstCode')), opt=True)
    _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCodeShift = INT(name='cellSyncBurstCodeShift', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstCodeShift')), opt=True)
    _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_dlTransPower = INT(name='dlTransPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab = ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_._ext = None
    _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions._cont = __CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_
    _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD._cont = ASN1Dict([
        ('cSBTransmissionID', _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_cSBTransmissionID),
        ('syncFrameNumberToTransmit', _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_syncFrameNumberToTransmit),
        ('cellSyncBurstCode', _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCode),
        ('cellSyncBurstCodeShift', _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCodeShift),
        ('dlTransPower', _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_dlTransPower),
        ('iE-Extensions', _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions),
        ])
    CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD._ext = []
    
    #-----< CellSyncBurstTransInfoItem-CellSyncReconfRqstTDD-ExtIEs >-----#
    CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_ExtIEs = CLASS(name='CellSyncBurstTransInfoItem-CellSyncReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSyncBurstMeasInfo-CellSyncReconfRqstTDD >-----#
    CellSyncBurstMeasInfo_CellSyncReconfRqstTDD = SEQ(name='CellSyncBurstMeasInfo-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_cellSyncBurstMeasInfoList_CellSyncReconfRqstTDD = SEQ(name='cellSyncBurstMeasInfoList-CellSyncReconfRqstTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstMeasInfoList-CellSyncReconfRqstTDD')))
    _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_synchronisationReportType = SEQ(name='synchronisationReportType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SynchronisationReportTypeIE')), opt=True)
    _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_synchronisationReportCharacteristics = SEQ(name='synchronisationReportCharacteristics', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SynchronisationReportCharacteristicsIE')), opt=True)
    _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab = ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item_._ext = None
    _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions._cont = __CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item_
    _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSyncBurstMeasInfo_CellSyncReconfRqstTDD._cont = ASN1Dict([
        ('cellSyncBurstMeasInfoList-CellSyncReconfRqstTDD', _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_cellSyncBurstMeasInfoList_CellSyncReconfRqstTDD),
        ('synchronisationReportType', _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_synchronisationReportType),
        ('synchronisationReportCharacteristics', _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_synchronisationReportCharacteristics),
        ('iE-Extensions', _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions),
        ])
    CellSyncBurstMeasInfo_CellSyncReconfRqstTDD._ext = []
    
    #-----< CellSyncBurstMeasInfo-CellSyncReconfRqstTDD-ExtIEs >-----#
    CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_ExtIEs = CLASS(name='CellSyncBurstMeasInfo-CellSyncReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSyncBurstMeasInfoList-CellSyncReconfRqstTDD >-----#
    CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD = SEQ(name='CellSyncBurstMeasInfoList-CellSyncReconfRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstMeasInfoListIE-CellSyncReconfRqstTDD')))
    __CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id_tab._val = ASN1Set(rv=[dict([('id', 427), ('criticality', 'reject'), ('Value', ___CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id._const_tab = __CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id_tab
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id._const_tab_at = None
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id._const_tab_id = 'id'
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_criticality._const_tab = __CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id_tab
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_criticality._const_tab_at = ('..', 'id')
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_criticality._const_tab_id = 'criticality'
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_value._const_tab = __CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id_tab
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_value._const_tab_at = ('..', 'id')
    _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_value._const_tab_id = 'Value'
    CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD._cont = ASN1Dict([
        ('id', _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id),
        ('criticality', _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_criticality),
        ('value', _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_value),
        ])
    CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD._ext = None
    
    #-----< CellSyncBurstMeasInfoListIEs-CellSyncReconfRqstTDD >-----#
    CellSyncBurstMeasInfoListIEs_CellSyncReconfRqstTDD = CLASS(name='CellSyncBurstMeasInfoListIEs-CellSyncReconfRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSyncBurstMeasInfoListIEs_CellSyncReconfRqstTDD_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstMeasInfoListIE-CellSyncReconfRqstTDD')))
    CellSyncBurstMeasInfoListIEs_CellSyncReconfRqstTDD._val = ASN1Set(rv=[dict([('id', 427), ('criticality', 'reject'), ('Value', _CellSyncBurstMeasInfoListIEs_CellSyncReconfRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SynchronisationReportTypeIE >-----#
    SynchronisationReportTypeIE = SEQ(name='SynchronisationReportTypeIE', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _SynchronisationReportTypeIE_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __SynchronisationReportTypeIE_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___SynchronisationReportTypeIE_id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportType')))
    __SynchronisationReportTypeIE_id_tab._val = ASN1Set(rv=[dict([('id', 438), ('criticality', 'reject'), ('Value', ___SynchronisationReportTypeIE_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _SynchronisationReportTypeIE_id._const_tab = __SynchronisationReportTypeIE_id_tab
    _SynchronisationReportTypeIE_id._const_tab_at = None
    _SynchronisationReportTypeIE_id._const_tab_id = 'id'
    _SynchronisationReportTypeIE_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _SynchronisationReportTypeIE_criticality._const_tab = __SynchronisationReportTypeIE_id_tab
    _SynchronisationReportTypeIE_criticality._const_tab_at = ('..', 'id')
    _SynchronisationReportTypeIE_criticality._const_tab_id = 'criticality'
    _SynchronisationReportTypeIE_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _SynchronisationReportTypeIE_value._const_tab = __SynchronisationReportTypeIE_id_tab
    _SynchronisationReportTypeIE_value._const_tab_at = ('..', 'id')
    _SynchronisationReportTypeIE_value._const_tab_id = 'Value'
    SynchronisationReportTypeIE._cont = ASN1Dict([
        ('id', _SynchronisationReportTypeIE_id),
        ('criticality', _SynchronisationReportTypeIE_criticality),
        ('value', _SynchronisationReportTypeIE_value),
        ])
    SynchronisationReportTypeIE._ext = None
    
    #-----< SynchronisationReportTypeIEs >-----#
    SynchronisationReportTypeIEs = CLASS(name='SynchronisationReportTypeIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SynchronisationReportTypeIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportType')))
    SynchronisationReportTypeIEs._val = ASN1Set(rv=[dict([('id', 438), ('criticality', 'reject'), ('Value', _SynchronisationReportTypeIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SynchronisationReportCharacteristicsIE >-----#
    SynchronisationReportCharacteristicsIE = SEQ(name='SynchronisationReportCharacteristicsIE', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _SynchronisationReportCharacteristicsIE_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __SynchronisationReportCharacteristicsIE_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___SynchronisationReportCharacteristicsIE_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportCharacteristics')))
    __SynchronisationReportCharacteristicsIE_id_tab._val = ASN1Set(rv=[dict([('id', 439), ('criticality', 'reject'), ('Value', ___SynchronisationReportCharacteristicsIE_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _SynchronisationReportCharacteristicsIE_id._const_tab = __SynchronisationReportCharacteristicsIE_id_tab
    _SynchronisationReportCharacteristicsIE_id._const_tab_at = None
    _SynchronisationReportCharacteristicsIE_id._const_tab_id = 'id'
    _SynchronisationReportCharacteristicsIE_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _SynchronisationReportCharacteristicsIE_criticality._const_tab = __SynchronisationReportCharacteristicsIE_id_tab
    _SynchronisationReportCharacteristicsIE_criticality._const_tab_at = ('..', 'id')
    _SynchronisationReportCharacteristicsIE_criticality._const_tab_id = 'criticality'
    _SynchronisationReportCharacteristicsIE_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _SynchronisationReportCharacteristicsIE_value._const_tab = __SynchronisationReportCharacteristicsIE_id_tab
    _SynchronisationReportCharacteristicsIE_value._const_tab_at = ('..', 'id')
    _SynchronisationReportCharacteristicsIE_value._const_tab_id = 'Value'
    SynchronisationReportCharacteristicsIE._cont = ASN1Dict([
        ('id', _SynchronisationReportCharacteristicsIE_id),
        ('criticality', _SynchronisationReportCharacteristicsIE_criticality),
        ('value', _SynchronisationReportCharacteristicsIE_value),
        ])
    SynchronisationReportCharacteristicsIE._ext = None
    
    #-----< SynchronisationReportCharacteristicsIEs >-----#
    SynchronisationReportCharacteristicsIEs = CLASS(name='SynchronisationReportCharacteristicsIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SynchronisationReportCharacteristicsIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportCharacteristics')))
    SynchronisationReportCharacteristicsIEs._val = ASN1Set(rv=[dict([('id', 439), ('criticality', 'reject'), ('Value', _SynchronisationReportCharacteristicsIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellSyncBurstMeasInfoListIE-CellSyncReconfRqstTDD >-----#
    CellSyncBurstMeasInfoListIE_CellSyncReconfRqstTDD = SEQ_OF(name='CellSyncBurstMeasInfoListIE-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _CellSyncBurstMeasInfoListIE_CellSyncReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstMeasInfoItem-CellSyncReconfRqstTDD')))
    CellSyncBurstMeasInfoListIE_CellSyncReconfRqstTDD._cont = _CellSyncBurstMeasInfoListIE_CellSyncReconfRqstTDD__item_
    CellSyncBurstMeasInfoListIE_CellSyncReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< CellSyncBurstMeasInfoItem-CellSyncReconfRqstTDD >-----#
    CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD = SEQ(name='CellSyncBurstMeasInfoItem-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_syncFrameNrToReceive = INT(name='syncFrameNrToReceive', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SyncFrameNumber')))
    _CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_syncBurstInfo = SEQ_OF(name='syncBurstInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstInfoList-CellSyncReconfRqstTDD')))
    _CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab = ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_._ext = None
    _CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions._cont = __CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_
    _CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD._cont = ASN1Dict([
        ('syncFrameNrToReceive', _CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_syncFrameNrToReceive),
        ('syncBurstInfo', _CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_syncBurstInfo),
        ('iE-Extensions', _CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions),
        ])
    CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD._ext = []
    
    #-----< CellSyncBurstMeasInfoItem-CellSyncReconfRqstTDD-ExtIEs >-----#
    CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_ExtIEs = CLASS(name='CellSyncBurstMeasInfoItem-CellSyncReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSyncBurstInfoList-CellSyncReconfRqstTDD >-----#
    CellSyncBurstInfoList_CellSyncReconfRqstTDD = SEQ_OF(name='CellSyncBurstInfoList-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _CellSyncBurstInfoList_CellSyncReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstInfoItem-CellSyncReconfRqstTDD')))
    CellSyncBurstInfoList_CellSyncReconfRqstTDD._cont = _CellSyncBurstInfoList_CellSyncReconfRqstTDD__item_
    CellSyncBurstInfoList_CellSyncReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CellSyncBurstInfoItem-CellSyncReconfRqstTDD >-----#
    CellSyncBurstInfoItem_CellSyncReconfRqstTDD = SEQ(name='CellSyncBurstInfoItem-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_cSBMeasurementID = INT(name='cSBMeasurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CSBMeasurementID')))
    _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCode = INT(name='cellSyncBurstCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstCode')))
    _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCodeShift = INT(name='cellSyncBurstCodeShift', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstCodeShift')))
    _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab = ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_._ext = None
    _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions._cont = __CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_
    _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSyncBurstInfoItem_CellSyncReconfRqstTDD._cont = ASN1Dict([
        ('cSBMeasurementID', _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_cSBMeasurementID),
        ('cellSyncBurstCode', _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCode),
        ('cellSyncBurstCodeShift', _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCodeShift),
        ('iE-Extensions', _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions),
        ])
    CellSyncBurstInfoItem_CellSyncReconfRqstTDD._ext = []
    
    #-----< CellSyncBurstInfoItem-CellSyncReconfRqstTDD-ExtIEs >-----#
    CellSyncBurstInfoItem_CellSyncReconfRqstTDD_ExtIEs = CLASS(name='CellSyncBurstInfoItem-CellSyncReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSyncBurstInfoItem_CellSyncReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD >-----#
    SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD = SEQ_OF(name='SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeIdTransReconfItemLCR-CellSyncReconfRqstTDD')))
    SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD._cont = _SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD__item_
    SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< SYNCDlCodeIdTransReconfItemLCR-CellSyncReconfRqstTDD >-----#
    SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD = SEQ(name='SYNCDlCodeIdTransReconfItemLCR-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_cSBTransmissionID = INT(name='cSBTransmissionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CSBTransmissionID')))
    _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_syncFrameNumberforTransmit = INT(name='syncFrameNumberforTransmit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SyncFrameNumber')))
    _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_sYNCDlCodeId = INT(name='sYNCDlCodeId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SYNCDlCodeId')), opt=True)
    _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_dwPCH_Power = INT(name='dwPCH-Power', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DwPCH-Power')), opt=True)
    _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab = ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item_._ext = None
    _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions._cont = __SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item_
    _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD._cont = ASN1Dict([
        ('cSBTransmissionID', _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_cSBTransmissionID),
        ('syncFrameNumberforTransmit', _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_syncFrameNumberforTransmit),
        ('uARFCN', _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_uARFCN),
        ('sYNCDlCodeId', _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_sYNCDlCodeId),
        ('dwPCH-Power', _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_dwPCH_Power),
        ('iE-Extensions', _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions),
        ])
    SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD._ext = []
    
    #-----< SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD-ExtIEs >-----#
    SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD_ExtIEs = CLASS(name='SYNCDlCodeIdTransReconfInfoLCR-CellSyncReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SYNCDlCodeIdMeasInfoLCR-CellSyncReconfRqstTDD >-----#
    SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD = SEQ(name='SYNCDlCodeIdMeasInfoLCR-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_sYNCDlCodeIdMeasInfoList = SEQ_OF(name='sYNCDlCodeIdMeasInfoList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeIdMeasInfoList-CellSyncReconfRqstTDD')))
    _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_synchronisationReportType = ENUM(name='synchronisationReportType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportType')), opt=True)
    _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_synchronisationReportCharacteristics = SEQ(name='synchronisationReportCharacteristics', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SynchronisationReportCharacteristics')), opt=True)
    _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab = ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item_._ext = None
    _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions._cont = __SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item_
    _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD._cont = ASN1Dict([
        ('sYNCDlCodeIdMeasInfoList', _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_sYNCDlCodeIdMeasInfoList),
        ('synchronisationReportType', _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_synchronisationReportType),
        ('synchronisationReportCharacteristics', _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_synchronisationReportCharacteristics),
        ('iE-Extensions', _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions),
        ])
    SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD._ext = []
    
    #-----< SYNCDlCodeIdMeasInfoLCR-CellSyncReconfRqstTDD-ExtIEs >-----#
    SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_ExtIEs = CLASS(name='SYNCDlCodeIdMeasInfoLCR-CellSyncReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SYNCDlCodeIdMeasInfoList-CellSyncReconfRqstTDD >-----#
    SYNCDlCodeIdMeasInfoList_CellSyncReconfRqstTDD = SEQ_OF(name='SYNCDlCodeIdMeasInfoList-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _SYNCDlCodeIdMeasInfoList_CellSyncReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeIdMeasInfoItem-CellSyncReconfRqstTDD')))
    SYNCDlCodeIdMeasInfoList_CellSyncReconfRqstTDD._cont = _SYNCDlCodeIdMeasInfoList_CellSyncReconfRqstTDD__item_
    SYNCDlCodeIdMeasInfoList_CellSyncReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SYNCDlCodeIdMeasInfoItem-CellSyncReconfRqstTDD >-----#
    SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD = SEQ(name='SYNCDlCodeIdMeasInfoItem-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_syncFrameNrToReceive = INT(name='syncFrameNrToReceive', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SyncFrameNumber')))
    _SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_sYNCDlCodeIdInfoLCR = SEQ_OF(name='sYNCDlCodeIdInfoLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeIdInfoListLCR-CellSyncReconfRqstTDD')))
    _SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab = ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_._ext = None
    _SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions._cont = __SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_
    _SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD._cont = ASN1Dict([
        ('syncFrameNrToReceive', _SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_syncFrameNrToReceive),
        ('sYNCDlCodeIdInfoLCR', _SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_sYNCDlCodeIdInfoLCR),
        ('iE-Extensions', _SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions),
        ])
    SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD._ext = []
    
    #-----< SYNCDlCodeIdMeasInfoItem-CellSyncReconfRqstTDD-ExtIEs >-----#
    SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_ExtIEs = CLASS(name='SYNCDlCodeIdMeasInfoItem-CellSyncReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SYNCDlCodeIdInfoListLCR-CellSyncReconfRqstTDD >-----#
    SYNCDlCodeIdInfoListLCR_CellSyncReconfRqstTDD = SEQ_OF(name='SYNCDlCodeIdInfoListLCR-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _SYNCDlCodeIdInfoListLCR_CellSyncReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SYNCDlCodeIdInfoItemLCR-CellSyncReconfRqstTDD')))
    SYNCDlCodeIdInfoListLCR_CellSyncReconfRqstTDD._cont = _SYNCDlCodeIdInfoListLCR_CellSyncReconfRqstTDD__item_
    SYNCDlCodeIdInfoListLCR_CellSyncReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SYNCDlCodeIdInfoItemLCR-CellSyncReconfRqstTDD >-----#
    SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD = SEQ(name='SYNCDlCodeIdInfoItemLCR-CellSyncReconfRqstTDD', mode=MODE_TYPE)
    _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_cSBMeasurementID = INT(name='cSBMeasurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CSBMeasurementID')))
    _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_sYNCDlCodeId = INT(name='sYNCDlCodeId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SYNCDlCodeId')))
    _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UARFCN')))
    _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_propagationDelayCompensation = CHOICE(name='propagationDelayCompensation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimingAdjustmentValueLCR')), opt=True)
    _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab = ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id),
        ('criticality', ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item_._ext = None
    _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions._cont = __SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item_
    _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD._cont = ASN1Dict([
        ('cSBMeasurementID', _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_cSBMeasurementID),
        ('sYNCDlCodeId', _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_sYNCDlCodeId),
        ('uARFCN', _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_uARFCN),
        ('propagationDelayCompensation', _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_propagationDelayCompensation),
        ('iE-Extensions', _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions),
        ])
    SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD._ext = []
    
    #-----< SYNCDlCodeIdInfoItemLCR-CellSyncReconfRqstTDD-ExtIEs >-----#
    SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_ExtIEs = CLASS(name='SYNCDlCodeIdInfoItemLCR-CellSyncReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationReconfigurationResponseTDD >-----#
    CellSynchronisationReconfigurationResponseTDD = SEQ(name='CellSynchronisationReconfigurationResponseTDD', mode=MODE_TYPE)
    _CellSynchronisationReconfigurationResponseTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationReconfigurationResponseTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationReconfigurationResponseTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationReconfigurationResponseTDD_protocolIEs__item_._ext = None
    _CellSynchronisationReconfigurationResponseTDD_protocolIEs._cont = __CellSynchronisationReconfigurationResponseTDD_protocolIEs__item_
    _CellSynchronisationReconfigurationResponseTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationReconfigurationResponseTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__criticality_tab
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__extensionValue_tab
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationReconfigurationResponseTDD_protocolExtensions._cont = __CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item_
    _CellSynchronisationReconfigurationResponseTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationReconfigurationResponseTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationReconfigurationResponseTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationReconfigurationResponseTDD_protocolExtensions),
        ])
    CellSynchronisationReconfigurationResponseTDD._ext = []
    
    #-----< CellSynchronisationReconfigurationResponseTDD-Extensions >-----#
    CellSynchronisationReconfigurationResponseTDD_Extensions = CLASS(name='CellSynchronisationReconfigurationResponseTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSynchronisationReconfigurationResponseTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationReconfigurationResponseTDD-IEs >-----#
    CellSynchronisationReconfigurationResponseTDD_IEs = CLASS(name='CellSynchronisationReconfigurationResponseTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationReconfigurationResponseTDD_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CellSynchronisationReconfigurationResponseTDD_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _CellSynchronisationReconfigurationResponseTDD_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationReconfigurationFailureTDD >-----#
    CellSynchronisationReconfigurationFailureTDD = SEQ(name='CellSynchronisationReconfigurationFailureTDD', mode=MODE_TYPE)
    _CellSynchronisationReconfigurationFailureTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationReconfigurationFailureTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationReconfigurationFailureTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationReconfigurationFailureTDD_protocolIEs__item_._ext = None
    _CellSynchronisationReconfigurationFailureTDD_protocolIEs._cont = __CellSynchronisationReconfigurationFailureTDD_protocolIEs__item_
    _CellSynchronisationReconfigurationFailureTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationReconfigurationFailureTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__criticality_tab
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__extensionValue_tab
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationReconfigurationFailureTDD_protocolExtensions._cont = __CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item_
    _CellSynchronisationReconfigurationFailureTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationReconfigurationFailureTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationReconfigurationFailureTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationReconfigurationFailureTDD_protocolExtensions),
        ])
    CellSynchronisationReconfigurationFailureTDD._ext = []
    
    #-----< CellSynchronisationReconfigurationFailureTDD-Extensions >-----#
    CellSynchronisationReconfigurationFailureTDD_Extensions = CLASS(name='CellSynchronisationReconfigurationFailureTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSynchronisationReconfigurationFailureTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationReconfigurationFailureTDD-IEs >-----#
    CellSynchronisationReconfigurationFailureTDD_IEs = CLASS(name='CellSynchronisationReconfigurationFailureTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationReconfigurationFailureTDD_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _CellSynchronisationReconfigurationFailureTDD_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CellSynchronisationReconfigurationFailureTDD_IEs._val = ASN1Set(rv=[dict([('id', 13), ('criticality', 'ignore'), ('Value', _CellSynchronisationReconfigurationFailureTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _CellSynchronisationReconfigurationFailureTDD_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationAdjustmentRequestTDD >-----#
    CellSynchronisationAdjustmentRequestTDD = SEQ(name='CellSynchronisationAdjustmentRequestTDD', mode=MODE_TYPE)
    _CellSynchronisationAdjustmentRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationAdjustmentRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellAdjustmentInfo-SyncAdjustmentRqstTDD')))
    ____CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 421), ('criticality', 'ignore'), ('Value', _____CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationAdjustmentRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationAdjustmentRequestTDD_protocolIEs__item_._ext = None
    _CellSynchronisationAdjustmentRequestTDD_protocolIEs._cont = __CellSynchronisationAdjustmentRequestTDD_protocolIEs__item_
    _CellSynchronisationAdjustmentRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationAdjustmentRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__criticality_tab
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__extensionValue_tab
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationAdjustmentRequestTDD_protocolExtensions._cont = __CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item_
    _CellSynchronisationAdjustmentRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationAdjustmentRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationAdjustmentRequestTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationAdjustmentRequestTDD_protocolExtensions),
        ])
    CellSynchronisationAdjustmentRequestTDD._ext = []
    
    #-----< CellSynchronisationAdjustmentRequestTDD-Extensions >-----#
    CellSynchronisationAdjustmentRequestTDD_Extensions = CLASS(name='CellSynchronisationAdjustmentRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSynchronisationAdjustmentRequestTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationAdjustmentRequestTDD-IEs >-----#
    CellSynchronisationAdjustmentRequestTDD_IEs = CLASS(name='CellSynchronisationAdjustmentRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationAdjustmentRequestTDD_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellAdjustmentInfo-SyncAdjustmentRqstTDD')))
    CellSynchronisationAdjustmentRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 421), ('criticality', 'ignore'), ('Value', _CellSynchronisationAdjustmentRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellAdjustmentInfo-SyncAdjustmentRqstTDD >-----#
    CellAdjustmentInfo_SyncAdjustmentRqstTDD = SEQ_OF(name='CellAdjustmentInfo-SyncAdjustmentRqstTDD', mode=MODE_TYPE)
    _CellAdjustmentInfo_SyncAdjustmentRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellAdjustmentInfoItem-SyncAdjustmentRqstTDD')))
    ___CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 494), ('criticality', 'ignore'), ('Value', ____CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id._const_tab = ___CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id_tab
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id._const_tab_at = None
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id._const_tab_id = 'id'
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__criticality._const_tab = ___CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id_tab
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__criticality._const_tab_at = ('..', 'id')
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__criticality._const_tab_id = 'criticality'
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__value._const_tab = ___CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id_tab
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__value._const_tab_at = ('..', 'id')
    __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__value._const_tab_id = 'Value'
    _CellAdjustmentInfo_SyncAdjustmentRqstTDD__item_._cont = ASN1Dict([
        ('id', __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id),
        ('criticality', __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__criticality),
        ('value', __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__value),
        ])
    _CellAdjustmentInfo_SyncAdjustmentRqstTDD__item_._ext = None
    CellAdjustmentInfo_SyncAdjustmentRqstTDD._cont = _CellAdjustmentInfo_SyncAdjustmentRqstTDD__item_
    CellAdjustmentInfo_SyncAdjustmentRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellAdjustmentInfoItemIE-SyncAdjustmntRqstTDD >-----#
    CellAdjustmentInfoItemIE_SyncAdjustmntRqstTDD = CLASS(name='CellAdjustmentInfoItemIE-SyncAdjustmntRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellAdjustmentInfoItemIE_SyncAdjustmntRqstTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellAdjustmentInfoItem-SyncAdjustmentRqstTDD')))
    CellAdjustmentInfoItemIE_SyncAdjustmntRqstTDD._val = ASN1Set(rv=[dict([('id', 494), ('criticality', 'ignore'), ('Value', _CellAdjustmentInfoItemIE_SyncAdjustmntRqstTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellAdjustmentInfoItem-SyncAdjustmentRqstTDD >-----#
    CellAdjustmentInfoItem_SyncAdjustmentRqstTDD = SEQ(name='CellAdjustmentInfoItem-SyncAdjustmentRqstTDD', mode=MODE_TYPE)
    _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_frameAdjustmentValue = INT(name='frameAdjustmentValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'FrameAdjustmentValue')), opt=True)
    _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_timingAdjustmentValue = CHOICE(name='timingAdjustmentValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'TimingAdjustmentValue')), opt=True)
    _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_dLTransPower = INT(name='dLTransPower', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DL-Power')), opt=True)
    _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFN')), opt=True)
    _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DwPCH-Power')))
    _____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimingAdjustmentValueLCR')))
    ____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 551), ('criticality', 'ignore'), ('Extension', _____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 603), ('criticality', 'ignore'), ('Extension', _____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id._const_tab = ____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__criticality._const_tab = ____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id),
        ('criticality', ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item_._ext = None
    _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions._cont = __CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item_
    _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellAdjustmentInfoItem_SyncAdjustmentRqstTDD._cont = ASN1Dict([
        ('c-ID', _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_c_ID),
        ('frameAdjustmentValue', _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_frameAdjustmentValue),
        ('timingAdjustmentValue', _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_timingAdjustmentValue),
        ('dLTransPower', _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_dLTransPower),
        ('sfn', _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_sfn),
        ('iE-Extensions', _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions),
        ])
    CellAdjustmentInfoItem_SyncAdjustmentRqstTDD._ext = []
    
    #-----< CellAdjustmentInfoItem-SyncAdjustmntRqstTDD-ExtIEs >-----#
    CellAdjustmentInfoItem_SyncAdjustmntRqstTDD_ExtIEs = CLASS(name='CellAdjustmentInfoItem-SyncAdjustmntRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _CellAdjustmentInfoItem_SyncAdjustmntRqstTDD_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'DwPCH-Power')))
    _CellAdjustmentInfoItem_SyncAdjustmntRqstTDD_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimingAdjustmentValueLCR')))
    CellAdjustmentInfoItem_SyncAdjustmntRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 551), ('criticality', 'ignore'), ('Extension', _CellAdjustmentInfoItem_SyncAdjustmntRqstTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 603), ('criticality', 'ignore'), ('Extension', _CellAdjustmentInfoItem_SyncAdjustmntRqstTDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationAdjustmentResponseTDD >-----#
    CellSynchronisationAdjustmentResponseTDD = SEQ(name='CellSynchronisationAdjustmentResponseTDD', mode=MODE_TYPE)
    _CellSynchronisationAdjustmentResponseTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationAdjustmentResponseTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id_tab
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id_tab
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id_tab
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationAdjustmentResponseTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationAdjustmentResponseTDD_protocolIEs__item_._ext = None
    _CellSynchronisationAdjustmentResponseTDD_protocolIEs._cont = __CellSynchronisationAdjustmentResponseTDD_protocolIEs__item_
    _CellSynchronisationAdjustmentResponseTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationAdjustmentResponseTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__criticality_tab
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__extensionValue_tab
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationAdjustmentResponseTDD_protocolExtensions._cont = __CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item_
    _CellSynchronisationAdjustmentResponseTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationAdjustmentResponseTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationAdjustmentResponseTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationAdjustmentResponseTDD_protocolExtensions),
        ])
    CellSynchronisationAdjustmentResponseTDD._ext = []
    
    #-----< CellSynchronisationAdjustmentResponseTDD-Extensions >-----#
    CellSynchronisationAdjustmentResponseTDD_Extensions = CLASS(name='CellSynchronisationAdjustmentResponseTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSynchronisationAdjustmentResponseTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationAdjustmentResponseTDD-IEs >-----#
    CellSynchronisationAdjustmentResponseTDD_IEs = CLASS(name='CellSynchronisationAdjustmentResponseTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationAdjustmentResponseTDD_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CellSynchronisationAdjustmentResponseTDD_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _CellSynchronisationAdjustmentResponseTDD_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationAdjustmentFailureTDD >-----#
    CellSynchronisationAdjustmentFailureTDD = SEQ(name='CellSynchronisationAdjustmentFailureTDD', mode=MODE_TYPE)
    _CellSynchronisationAdjustmentFailureTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationAdjustmentFailureTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-SyncAdjustmntFailureTDD')))
    _____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    ____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 420), ('criticality', 'ignore'), ('Value', _____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationAdjustmentFailureTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationAdjustmentFailureTDD_protocolIEs__item_._ext = None
    _CellSynchronisationAdjustmentFailureTDD_protocolIEs._cont = __CellSynchronisationAdjustmentFailureTDD_protocolIEs__item_
    _CellSynchronisationAdjustmentFailureTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationAdjustmentFailureTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__criticality_tab
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__extensionValue_tab
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationAdjustmentFailureTDD_protocolExtensions._cont = __CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item_
    _CellSynchronisationAdjustmentFailureTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationAdjustmentFailureTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationAdjustmentFailureTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationAdjustmentFailureTDD_protocolExtensions),
        ])
    CellSynchronisationAdjustmentFailureTDD._ext = []
    
    #-----< CellSynchronisationAdjustmentFailureTDD-Extensions >-----#
    CellSynchronisationAdjustmentFailureTDD_Extensions = CLASS(name='CellSynchronisationAdjustmentFailureTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSynchronisationAdjustmentFailureTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationAdjustmentFailureTDD-IEs >-----#
    CellSynchronisationAdjustmentFailureTDD_IEs = CLASS(name='CellSynchronisationAdjustmentFailureTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationAdjustmentFailureTDD_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CauseLevel-SyncAdjustmntFailureTDD')))
    _CellSynchronisationAdjustmentFailureTDD_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CriticalityDiagnostics')))
    CellSynchronisationAdjustmentFailureTDD_IEs._val = ASN1Set(rv=[dict([('id', 420), ('criticality', 'ignore'), ('Value', _CellSynchronisationAdjustmentFailureTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _CellSynchronisationAdjustmentFailureTDD_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-SyncAdjustmntFailureTDD >-----#
    CauseLevel_SyncAdjustmntFailureTDD = CHOICE(name='CauseLevel-SyncAdjustmntFailureTDD', mode=MODE_TYPE)
    _CauseLevel_SyncAdjustmntFailureTDD_generalCause = SEQ(name='generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'GeneralCauseList-SyncAdjustmntFailureTDD')))
    _CauseLevel_SyncAdjustmntFailureTDD_cellSpecificCause = SEQ(name='cellSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSpecificCauseList-SyncAdjustmntFailureTDD')))
    CauseLevel_SyncAdjustmntFailureTDD._cont = ASN1Dict([
        ('generalCause', _CauseLevel_SyncAdjustmntFailureTDD_generalCause),
        ('cellSpecificCause', _CauseLevel_SyncAdjustmntFailureTDD_cellSpecificCause),
        ])
    CauseLevel_SyncAdjustmntFailureTDD._ext = []
    
    #-----< GeneralCauseList-SyncAdjustmntFailureTDD >-----#
    GeneralCauseList_SyncAdjustmntFailureTDD = SEQ(name='GeneralCauseList-SyncAdjustmntFailureTDD', mode=MODE_TYPE)
    _GeneralCauseList_SyncAdjustmntFailureTDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id._const_tab = ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id),
        ('criticality', ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item_._ext = None
    _GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions._cont = __GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item_
    _GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_SyncAdjustmntFailureTDD._cont = ASN1Dict([
        ('cause', _GeneralCauseList_SyncAdjustmntFailureTDD_cause),
        ('iE-Extensions', _GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions),
        ])
    GeneralCauseList_SyncAdjustmntFailureTDD._ext = []
    
    #-----< GeneralCauseList-SyncAdjustmntFailureTDD-ExtIEs >-----#
    GeneralCauseList_SyncAdjustmntFailureTDD_ExtIEs = CLASS(name='GeneralCauseList-SyncAdjustmntFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    GeneralCauseList_SyncAdjustmntFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSpecificCauseList-SyncAdjustmntFailureTDD >-----#
    CellSpecificCauseList_SyncAdjustmntFailureTDD = SEQ(name='CellSpecificCauseList-SyncAdjustmntFailureTDD', mode=MODE_TYPE)
    _CellSpecificCauseList_SyncAdjustmntFailureTDD_unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD = SEQ_OF(name='unsuccessful-cell-InformationRespList-SyncAdjustmntFailureTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-cell-InformationRespList-SyncAdjustmntFailureTDD')))
    _CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id._const_tab = ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality._const_tab = ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id),
        ('criticality', ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item_._ext = None
    _CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions._cont = __CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item_
    _CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSpecificCauseList_SyncAdjustmntFailureTDD._cont = ASN1Dict([
        ('unsuccessful-cell-InformationRespList-SyncAdjustmntFailureTDD', _CellSpecificCauseList_SyncAdjustmntFailureTDD_unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD),
        ('iE-Extensions', _CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions),
        ])
    CellSpecificCauseList_SyncAdjustmntFailureTDD._ext = []
    
    #-----< CellSpecificCauseList-SyncAdjustmntFailureTDD-ExtIEs >-----#
    CellSpecificCauseList_SyncAdjustmntFailureTDD_ExtIEs = CLASS(name='CellSpecificCauseList-SyncAdjustmntFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSpecificCauseList_SyncAdjustmntFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Unsuccessful-cell-InformationRespList-SyncAdjustmntFailureTDD >-----#
    Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD = SEQ_OF(name='Unsuccessful-cell-InformationRespList-SyncAdjustmntFailureTDD', mode=MODE_TYPE)
    _Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD')))
    ___Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 440), ('criticality', 'ignore'), ('Value', ____Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id._const_tab = ___Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id_tab
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id._const_tab_at = None
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id._const_tab_id = 'id'
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__criticality._const_tab = ___Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id_tab
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__criticality._const_tab_at = ('..', 'id')
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__criticality._const_tab_id = 'criticality'
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__value._const_tab = ___Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id_tab
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__value._const_tab_at = ('..', 'id')
    __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__value._const_tab_id = 'Value'
    _Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item_._cont = ASN1Dict([
        ('id', __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id),
        ('criticality', __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__criticality),
        ('value', __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__value),
        ])
    _Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item_._ext = None
    Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD._cont = _Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item_
    Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Unsuccessful-cell-InformationRespItemIE-SyncAdjustmntFailureTDD >-----#
    Unsuccessful_cell_InformationRespItemIE_SyncAdjustmntFailureTDD = CLASS(name='Unsuccessful-cell-InformationRespItemIE-SyncAdjustmntFailureTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _Unsuccessful_cell_InformationRespItemIE_SyncAdjustmntFailureTDD_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD')))
    Unsuccessful_cell_InformationRespItemIE_SyncAdjustmntFailureTDD._val = ASN1Set(rv=[dict([('id', 440), ('criticality', 'ignore'), ('Value', _Unsuccessful_cell_InformationRespItemIE_SyncAdjustmntFailureTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD >-----#
    Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD = SEQ(name='Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD', mode=MODE_TYPE)
    _Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    _Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__id._const_tab = ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality._const_tab = ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__id),
        ('criticality', ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item_._ext = None
    _Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions._cont = __Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item_
    _Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD._cont = ASN1Dict([
        ('c-ID', _Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_c_ID),
        ('cause', _Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_cause),
        ('iE-Extensions', _Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions),
        ])
    Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD._ext = []
    
    #-----< Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD-ExtIEs >-----#
    Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_ExtIEs = CLASS(name='Unsuccessful-cell-InformationRespItem-SyncAdjustmntFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationTerminationRequestTDD >-----#
    CellSynchronisationTerminationRequestTDD = SEQ(name='CellSynchronisationTerminationRequestTDD', mode=MODE_TYPE)
    _CellSynchronisationTerminationRequestTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationTerminationRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CSBTransmissionID')))
    _____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CSBMeasurementID')))
    ____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 430), ('criticality', 'ignore'), ('Value', _____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 431), ('criticality', 'ignore'), ('Value', _____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationTerminationRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationTerminationRequestTDD_protocolIEs__item_._ext = None
    _CellSynchronisationTerminationRequestTDD_protocolIEs._cont = __CellSynchronisationTerminationRequestTDD_protocolIEs__item_
    _CellSynchronisationTerminationRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationTerminationRequestTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationTerminationRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__criticality_tab
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__extensionValue_tab
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationTerminationRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationTerminationRequestTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationTerminationRequestTDD_protocolExtensions._cont = __CellSynchronisationTerminationRequestTDD_protocolExtensions__item_
    _CellSynchronisationTerminationRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationTerminationRequestTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationTerminationRequestTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationTerminationRequestTDD_protocolExtensions),
        ])
    CellSynchronisationTerminationRequestTDD._ext = []
    
    #-----< CellSynchronisationTerminationRequestTDD-Extensions >-----#
    CellSynchronisationTerminationRequestTDD_Extensions = CLASS(name='CellSynchronisationTerminationRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSynchronisationTerminationRequestTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationTerminationRequestTDD-IEs >-----#
    CellSynchronisationTerminationRequestTDD_IEs = CLASS(name='CellSynchronisationTerminationRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationTerminationRequestTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CellSynchronisationTerminationRequestTDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CSBTransmissionID')))
    _CellSynchronisationTerminationRequestTDD_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CSBMeasurementID')))
    CellSynchronisationTerminationRequestTDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _CellSynchronisationTerminationRequestTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 430), ('criticality', 'ignore'), ('Value', _CellSynchronisationTerminationRequestTDD_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 431), ('criticality', 'ignore'), ('Value', _CellSynchronisationTerminationRequestTDD_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationFailureIndicationTDD >-----#
    CellSynchronisationFailureIndicationTDD = SEQ(name='CellSynchronisationFailureIndicationTDD', mode=MODE_TYPE)
    _CellSynchronisationFailureIndicationTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationFailureIndicationTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CSBTransmissionID')))
    _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CSBMeasurementID')))
    _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    ____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 430), ('criticality', 'ignore'), ('Value', _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 431), ('criticality', 'ignore'), ('Value', _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationFailureIndicationTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationFailureIndicationTDD_protocolIEs__item_._ext = None
    _CellSynchronisationFailureIndicationTDD_protocolIEs._cont = __CellSynchronisationFailureIndicationTDD_protocolIEs__item_
    _CellSynchronisationFailureIndicationTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationFailureIndicationTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationFailureIndicationTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__criticality_tab
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__extensionValue_tab
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationFailureIndicationTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationFailureIndicationTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationFailureIndicationTDD_protocolExtensions._cont = __CellSynchronisationFailureIndicationTDD_protocolExtensions__item_
    _CellSynchronisationFailureIndicationTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationFailureIndicationTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationFailureIndicationTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationFailureIndicationTDD_protocolExtensions),
        ])
    CellSynchronisationFailureIndicationTDD._ext = []
    
    #-----< CellSynchronisationFailureIndicationTDD-Extensions >-----#
    CellSynchronisationFailureIndicationTDD_Extensions = CLASS(name='CellSynchronisationFailureIndicationTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSynchronisationFailureIndicationTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationFailureIndicationTDD-IEs >-----#
    CellSynchronisationFailureIndicationTDD_IEs = CLASS(name='CellSynchronisationFailureIndicationTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationFailureIndicationTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _CellSynchronisationFailureIndicationTDD_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CSBTransmissionID')))
    _CellSynchronisationFailureIndicationTDD_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CSBMeasurementID')))
    _CellSynchronisationFailureIndicationTDD_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cause')))
    CellSynchronisationFailureIndicationTDD_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _CellSynchronisationFailureIndicationTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 430), ('criticality', 'ignore'), ('Value', _CellSynchronisationFailureIndicationTDD_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 431), ('criticality', 'ignore'), ('Value', _CellSynchronisationFailureIndicationTDD_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _CellSynchronisationFailureIndicationTDD_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationReportTDD >-----#
    CellSynchronisationReportTDD = SEQ(name='CellSynchronisationReportTDD', mode=MODE_TYPE)
    _CellSynchronisationReportTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __CellSynchronisationReportTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___CellSynchronisationReportTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____CellSynchronisationReportTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____CellSynchronisationReportTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncInfo-CellSyncReprtTDD')))
    ____CellSynchronisationReportTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 429), ('criticality', 'ignore'), ('Value', _____CellSynchronisationReportTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CellSynchronisationReportTDD_protocolIEs__item__id._const_tab = ____CellSynchronisationReportTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReportTDD_protocolIEs__item__id._const_tab_at = None
    ___CellSynchronisationReportTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___CellSynchronisationReportTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___CellSynchronisationReportTDD_protocolIEs__item__criticality._const_tab = ____CellSynchronisationReportTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReportTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationReportTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationReportTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___CellSynchronisationReportTDD_protocolIEs__item__value._const_tab = ____CellSynchronisationReportTDD_protocolIEs__item__id_tab
    ___CellSynchronisationReportTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellSynchronisationReportTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __CellSynchronisationReportTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationReportTDD_protocolIEs__item__id),
        ('criticality', ___CellSynchronisationReportTDD_protocolIEs__item__criticality),
        ('value', ___CellSynchronisationReportTDD_protocolIEs__item__value),
        ])
    __CellSynchronisationReportTDD_protocolIEs__item_._ext = None
    _CellSynchronisationReportTDD_protocolIEs._cont = __CellSynchronisationReportTDD_protocolIEs__item_
    _CellSynchronisationReportTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CellSynchronisationReportTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSynchronisationReportTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSynchronisationReportTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSynchronisationReportTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationReportTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationReportTDD_protocolExtensions__item__id._const_tab = ____CellSynchronisationReportTDD_protocolExtensions__item__id_tab
    ___CellSynchronisationReportTDD_protocolExtensions__item__id._const_tab_at = None
    ___CellSynchronisationReportTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___CellSynchronisationReportTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSynchronisationReportTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationReportTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationReportTDD_protocolExtensions__item__criticality._const_tab = ____CellSynchronisationReportTDD_protocolExtensions__item__criticality_tab
    ___CellSynchronisationReportTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSynchronisationReportTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CellSynchronisationReportTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSynchronisationReportTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSynchronisationReportTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSynchronisationReportTDD_protocolExtensions__item__extensionValue._const_tab = ____CellSynchronisationReportTDD_protocolExtensions__item__extensionValue_tab
    ___CellSynchronisationReportTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSynchronisationReportTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSynchronisationReportTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CellSynchronisationReportTDD_protocolExtensions__item__id),
        ('criticality', ___CellSynchronisationReportTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___CellSynchronisationReportTDD_protocolExtensions__item__extensionValue),
        ])
    __CellSynchronisationReportTDD_protocolExtensions__item_._ext = None
    _CellSynchronisationReportTDD_protocolExtensions._cont = __CellSynchronisationReportTDD_protocolExtensions__item_
    _CellSynchronisationReportTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSynchronisationReportTDD._cont = ASN1Dict([
        ('protocolIEs', _CellSynchronisationReportTDD_protocolIEs),
        ('protocolExtensions', _CellSynchronisationReportTDD_protocolExtensions),
        ])
    CellSynchronisationReportTDD._ext = []
    
    #-----< CellSynchronisationReportTDD-Extensions >-----#
    CellSynchronisationReportTDD_Extensions = CLASS(name='CellSynchronisationReportTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSynchronisationReportTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSynchronisationReportTDD-IEs >-----#
    CellSynchronisationReportTDD_IEs = CLASS(name='CellSynchronisationReportTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _CellSynchronisationReportTDD_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncInfo-CellSyncReprtTDD')))
    CellSynchronisationReportTDD_IEs._val = ASN1Set(rv=[dict([('id', 429), ('criticality', 'ignore'), ('Value', _CellSynchronisationReportTDD_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellSyncInfo-CellSyncReprtTDD >-----#
    CellSyncInfo_CellSyncReprtTDD = SEQ_OF(name='CellSyncInfo-CellSyncReprtTDD', mode=MODE_TYPE)
    _CellSyncInfo_CellSyncReprtTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncInfoItemIE-CellSyncReprtTDD')))
    CellSyncInfo_CellSyncReprtTDD._cont = _CellSyncInfo_CellSyncReprtTDD__item_
    CellSyncInfo_CellSyncReprtTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellSyncInfoItemIE-CellSyncReprtTDD >-----#
    CellSyncInfoItemIE_CellSyncReprtTDD = SEQ(name='CellSyncInfoItemIE-CellSyncReprtTDD', mode=MODE_TYPE)
    _CellSyncInfoItemIE_CellSyncReprtTDD_c_ID_CellSyncReprtTDD = SEQ(name='c-ID-CellSyncReprtTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'C-ID-IE-CellSyncReprtTDD')))
    _CellSyncInfoItemIE_CellSyncReprtTDD_syncReportType_CellSyncReprtTDD = SEQ(name='syncReportType-CellSyncReprtTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncReportTypeIE-CellSyncReprtTDD')), opt=True)
    CellSyncInfoItemIE_CellSyncReprtTDD._cont = ASN1Dict([
        ('c-ID-CellSyncReprtTDD', _CellSyncInfoItemIE_CellSyncReprtTDD_c_ID_CellSyncReprtTDD),
        ('syncReportType-CellSyncReprtTDD', _CellSyncInfoItemIE_CellSyncReprtTDD_syncReportType_CellSyncReprtTDD),
        ])
    CellSyncInfoItemIE_CellSyncReprtTDD._ext = []
    
    #-----< C-ID-IE-CellSyncReprtTDD >-----#
    C_ID_IE_CellSyncReprtTDD = SEQ(name='C-ID-IE-CellSyncReprtTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _C_ID_IE_CellSyncReprtTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __C_ID_IE_CellSyncReprtTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___C_ID_IE_CellSyncReprtTDD_id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    __C_ID_IE_CellSyncReprtTDD_id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', ___C_ID_IE_CellSyncReprtTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _C_ID_IE_CellSyncReprtTDD_id._const_tab = __C_ID_IE_CellSyncReprtTDD_id_tab
    _C_ID_IE_CellSyncReprtTDD_id._const_tab_at = None
    _C_ID_IE_CellSyncReprtTDD_id._const_tab_id = 'id'
    _C_ID_IE_CellSyncReprtTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _C_ID_IE_CellSyncReprtTDD_criticality._const_tab = __C_ID_IE_CellSyncReprtTDD_id_tab
    _C_ID_IE_CellSyncReprtTDD_criticality._const_tab_at = ('..', 'id')
    _C_ID_IE_CellSyncReprtTDD_criticality._const_tab_id = 'criticality'
    _C_ID_IE_CellSyncReprtTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _C_ID_IE_CellSyncReprtTDD_value._const_tab = __C_ID_IE_CellSyncReprtTDD_id_tab
    _C_ID_IE_CellSyncReprtTDD_value._const_tab_at = ('..', 'id')
    _C_ID_IE_CellSyncReprtTDD_value._const_tab_id = 'Value'
    C_ID_IE_CellSyncReprtTDD._cont = ASN1Dict([
        ('id', _C_ID_IE_CellSyncReprtTDD_id),
        ('criticality', _C_ID_IE_CellSyncReprtTDD_criticality),
        ('value', _C_ID_IE_CellSyncReprtTDD_value),
        ])
    C_ID_IE_CellSyncReprtTDD._ext = None
    
    #-----< C-ID-IEs-CellSyncReprtTDD >-----#
    C_ID_IEs_CellSyncReprtTDD = CLASS(name='C-ID-IEs-CellSyncReprtTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _C_ID_IEs_CellSyncReprtTDD_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    C_ID_IEs_CellSyncReprtTDD._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _C_ID_IEs_CellSyncReprtTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SyncReportTypeIE-CellSyncReprtTDD >-----#
    SyncReportTypeIE_CellSyncReprtTDD = SEQ(name='SyncReportTypeIE-CellSyncReprtTDD', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    _SyncReportTypeIE_CellSyncReprtTDD_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    __SyncReportTypeIE_CellSyncReprtTDD_id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ___SyncReportTypeIE_CellSyncReprtTDD_id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncReportType-CellSyncReprtTDD')))
    __SyncReportTypeIE_CellSyncReprtTDD_id_tab._val = ASN1Set(rv=[dict([('id', 497), ('criticality', 'ignore'), ('Value', ___SyncReportTypeIE_CellSyncReprtTDD_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _SyncReportTypeIE_CellSyncReprtTDD_id._const_tab = __SyncReportTypeIE_CellSyncReprtTDD_id_tab
    _SyncReportTypeIE_CellSyncReprtTDD_id._const_tab_at = None
    _SyncReportTypeIE_CellSyncReprtTDD_id._const_tab_id = 'id'
    _SyncReportTypeIE_CellSyncReprtTDD_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    _SyncReportTypeIE_CellSyncReprtTDD_criticality._const_tab = __SyncReportTypeIE_CellSyncReprtTDD_id_tab
    _SyncReportTypeIE_CellSyncReprtTDD_criticality._const_tab_at = ('..', 'id')
    _SyncReportTypeIE_CellSyncReprtTDD_criticality._const_tab_id = 'criticality'
    _SyncReportTypeIE_CellSyncReprtTDD_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    _SyncReportTypeIE_CellSyncReprtTDD_value._const_tab = __SyncReportTypeIE_CellSyncReprtTDD_id_tab
    _SyncReportTypeIE_CellSyncReprtTDD_value._const_tab_at = ('..', 'id')
    _SyncReportTypeIE_CellSyncReprtTDD_value._const_tab_id = 'Value'
    SyncReportTypeIE_CellSyncReprtTDD._cont = ASN1Dict([
        ('id', _SyncReportTypeIE_CellSyncReprtTDD_id),
        ('criticality', _SyncReportTypeIE_CellSyncReprtTDD_criticality),
        ('value', _SyncReportTypeIE_CellSyncReprtTDD_value),
        ])
    SyncReportTypeIE_CellSyncReprtTDD._ext = None
    
    #-----< SyncReportTypeIEs-CellSyncReprtTDD >-----#
    SyncReportTypeIEs_CellSyncReprtTDD = CLASS(name='SyncReportTypeIEs-CellSyncReprtTDD', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SyncReportTypeIEs_CellSyncReprtTDD_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncReportType-CellSyncReprtTDD')))
    SyncReportTypeIEs_CellSyncReprtTDD._val = ASN1Set(rv=[dict([('id', 497), ('criticality', 'ignore'), ('Value', _SyncReportTypeIEs_CellSyncReprtTDD_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SyncReportType-CellSyncReprtTDD >-----#
    SyncReportType_CellSyncReprtTDD = CHOICE(name='SyncReportType-CellSyncReprtTDD', mode=MODE_TYPE)
    _SyncReportType_CellSyncReprtTDD_intStdPhSyncInfo_CellSyncReprtTDD = SEQ(name='intStdPhSyncInfo-CellSyncReprtTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'IntStdPhCellSyncInfo-CellSyncReprtTDD')))
    _SyncReportType_CellSyncReprtTDD_lateEntrantCell = NULL(name='lateEntrantCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SyncReportType_CellSyncReprtTDD_frequencyAcquisition = NULL(name='frequencyAcquisition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SyncReportType_CellSyncReprtTDD._cont = ASN1Dict([
        ('intStdPhSyncInfo-CellSyncReprtTDD', _SyncReportType_CellSyncReprtTDD_intStdPhSyncInfo_CellSyncReprtTDD),
        ('lateEntrantCell', _SyncReportType_CellSyncReprtTDD_lateEntrantCell),
        ('frequencyAcquisition', _SyncReportType_CellSyncReprtTDD_frequencyAcquisition),
        ])
    SyncReportType_CellSyncReprtTDD._ext = []
    
    #-----< IntStdPhCellSyncInfo-CellSyncReprtTDD >-----#
    IntStdPhCellSyncInfo_CellSyncReprtTDD = SEQ(name='IntStdPhCellSyncInfo-CellSyncReprtTDD', mode=MODE_TYPE)
    _IntStdPhCellSyncInfo_CellSyncReprtTDD_cellSyncBurstMeasuredInfo = SEQ_OF(name='cellSyncBurstMeasuredInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstMeasInfoList-CellSyncReprtTDD')))
    _IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimingAdjustmentValue')))
    _____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncDLCodeIdsMeasInfoList-CellSyncReprtTDD')))
    ____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 552), ('criticality', 'ignore'), ('Extension', _____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 548), ('criticality', 'ignore'), ('Extension', _____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id._const_tab = ____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id._const_tab_at = None
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab = ____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab = ____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id),
        ('criticality', ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__extensionValue),
        ])
    __IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item_._ext = None
    _IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions._cont = __IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item_
    _IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntStdPhCellSyncInfo_CellSyncReprtTDD._cont = ASN1Dict([
        ('cellSyncBurstMeasuredInfo', _IntStdPhCellSyncInfo_CellSyncReprtTDD_cellSyncBurstMeasuredInfo),
        ('iE-Extensions', _IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions),
        ])
    IntStdPhCellSyncInfo_CellSyncReprtTDD._ext = []
    
    #-----< IntStdPhCellSyncInfoList-CellSyncReprtTDD-ExtIEs >-----#
    IntStdPhCellSyncInfoList_CellSyncReprtTDD_ExtIEs = CLASS(name='IntStdPhCellSyncInfoList-CellSyncReprtTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _IntStdPhCellSyncInfoList_CellSyncReprtTDD_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'TimingAdjustmentValue')))
    _IntStdPhCellSyncInfoList_CellSyncReprtTDD_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncDLCodeIdsMeasInfoList-CellSyncReprtTDD')))
    IntStdPhCellSyncInfoList_CellSyncReprtTDD_ExtIEs._val = ASN1Set(rv=[dict([('id', 552), ('criticality', 'ignore'), ('Extension', _IntStdPhCellSyncInfoList_CellSyncReprtTDD_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 548), ('criticality', 'ignore'), ('Extension', _IntStdPhCellSyncInfoList_CellSyncReprtTDD_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellSyncBurstMeasInfoList-CellSyncReprtTDD >-----#
    CellSyncBurstMeasInfoList_CellSyncReprtTDD = SEQ_OF(name='CellSyncBurstMeasInfoList-CellSyncReprtTDD', mode=MODE_TYPE)
    _CellSyncBurstMeasInfoList_CellSyncReprtTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstMeasInfoItem-CellSyncReprtTDD')))
    CellSyncBurstMeasInfoList_CellSyncReprtTDD._cont = _CellSyncBurstMeasInfoList_CellSyncReprtTDD__item_
    CellSyncBurstMeasInfoList_CellSyncReprtTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< CellSyncBurstMeasInfoItem-CellSyncReprtTDD >-----#
    CellSyncBurstMeasInfoItem_CellSyncReprtTDD = SEQ(name='CellSyncBurstMeasInfoItem-CellSyncReprtTDD', mode=MODE_TYPE)
    _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_sFN = INT(name='sFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_cellSyncBurstInfo_CellSyncReprtTDD = SEQ_OF(name='cellSyncBurstInfo-CellSyncReprtTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CellSyncBurstMeasInfoItem_CellSyncReprtTDD_cellSyncBurstInfo_CellSyncReprtTDD__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstInfo-CellSyncReprtTDD')))
    _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_cellSyncBurstInfo_CellSyncReprtTDD._cont = __CellSyncBurstMeasInfoItem_CellSyncReprtTDD_cellSyncBurstInfo_CellSyncReprtTDD__item_
    _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_cellSyncBurstInfo_CellSyncReprtTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id._const_tab = ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id_tab
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id._const_tab_at = None
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab = ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality_tab
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab = ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id),
        ('criticality', ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue),
        ])
    __CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item_._ext = None
    _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions._cont = __CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item_
    _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSyncBurstMeasInfoItem_CellSyncReprtTDD._cont = ASN1Dict([
        ('sFN', _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_sFN),
        ('cellSyncBurstInfo-CellSyncReprtTDD', _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_cellSyncBurstInfo_CellSyncReprtTDD),
        ('iE-Extensions', _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions),
        ])
    CellSyncBurstMeasInfoItem_CellSyncReprtTDD._ext = []
    
    #-----< CellSyncBurstMeasInfoItem-CellSyncReprtTDD-ExtIEs >-----#
    CellSyncBurstMeasInfoItem_CellSyncReprtTDD_ExtIEs = CLASS(name='CellSyncBurstMeasInfoItem-CellSyncReprtTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSyncBurstMeasInfoItem_CellSyncReprtTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSyncBurstInfo-CellSyncReprtTDD >-----#
    CellSyncBurstInfo_CellSyncReprtTDD = CHOICE(name='CellSyncBurstInfo-CellSyncReprtTDD', mode=MODE_TYPE)
    _CellSyncBurstInfo_CellSyncReprtTDD_cellSyncBurstAvailable = SEQ(name='cellSyncBurstAvailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSyncBurstAvailable-CellSyncReprtTDD')))
    _CellSyncBurstInfo_CellSyncReprtTDD_cellSyncBurstNotAvailable = NULL(name='cellSyncBurstNotAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CellSyncBurstInfo_CellSyncReprtTDD._cont = ASN1Dict([
        ('cellSyncBurstAvailable', _CellSyncBurstInfo_CellSyncReprtTDD_cellSyncBurstAvailable),
        ('cellSyncBurstNotAvailable', _CellSyncBurstInfo_CellSyncReprtTDD_cellSyncBurstNotAvailable),
        ])
    CellSyncBurstInfo_CellSyncReprtTDD._ext = []
    
    #-----< CellSyncBurstAvailable-CellSyncReprtTDD >-----#
    CellSyncBurstAvailable_CellSyncReprtTDD = SEQ(name='CellSyncBurstAvailable-CellSyncReprtTDD', mode=MODE_TYPE)
    _CellSyncBurstAvailable_CellSyncReprtTDD_cellSyncBurstTiming = CHOICE(name='cellSyncBurstTiming', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstTiming')))
    _CellSyncBurstAvailable_CellSyncReprtTDD_cellSyncBurstSIR = INT(name='cellSyncBurstSIR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstSIR')))
    _CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__id._const_tab = ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__id_tab
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__id._const_tab_at = None
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab = ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality_tab
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab = ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__id),
        ('criticality', ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue),
        ])
    __CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item_._ext = None
    _CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions._cont = __CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item_
    _CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellSyncBurstAvailable_CellSyncReprtTDD._cont = ASN1Dict([
        ('cellSyncBurstTiming', _CellSyncBurstAvailable_CellSyncReprtTDD_cellSyncBurstTiming),
        ('cellSyncBurstSIR', _CellSyncBurstAvailable_CellSyncReprtTDD_cellSyncBurstSIR),
        ('iE-Extensions', _CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions),
        ])
    CellSyncBurstAvailable_CellSyncReprtTDD._ext = []
    
    #-----< CellSyncBurstAvailable-CellSyncReprtTDD-ExtIEs >-----#
    CellSyncBurstAvailable_CellSyncReprtTDD_ExtIEs = CLASS(name='CellSyncBurstAvailable-CellSyncReprtTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    CellSyncBurstAvailable_CellSyncReprtTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SyncDLCodeIdsMeasInfoList-CellSyncReprtTDD >-----#
    SyncDLCodeIdsMeasInfoList_CellSyncReprtTDD = SEQ_OF(name='SyncDLCodeIdsMeasInfoList-CellSyncReprtTDD', mode=MODE_TYPE)
    _SyncDLCodeIdsMeasInfoList_CellSyncReprtTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncDLCodeIdsMeasInfoItem-CellSyncReprtTDD')))
    SyncDLCodeIdsMeasInfoList_CellSyncReprtTDD._cont = _SyncDLCodeIdsMeasInfoList_CellSyncReprtTDD__item_
    SyncDLCodeIdsMeasInfoList_CellSyncReprtTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=512)], ev=None, er=[])
    
    #-----< SyncDLCodeIdsMeasInfoItem-CellSyncReprtTDD >-----#
    SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD = SEQ(name='SyncDLCodeIdsMeasInfoItem-CellSyncReprtTDD', mode=MODE_TYPE)
    _SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_sFN = INT(name='sFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'SFN')))
    _SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_syncDLCodeIdInfo_CellSyncReprtTDD = SEQ_OF(name='syncDLCodeIdInfo-CellSyncReprtTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncDLCodeIdInfo-CellSyncReprtTDD')))
    _SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id._const_tab = ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id_tab
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id._const_tab_at = None
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab = ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality_tab
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab = ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id),
        ('criticality', ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue),
        ])
    __SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item_._ext = None
    _SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions._cont = __SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item_
    _SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD._cont = ASN1Dict([
        ('sFN', _SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_sFN),
        ('syncDLCodeIdInfo-CellSyncReprtTDD', _SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_syncDLCodeIdInfo_CellSyncReprtTDD),
        ('iE-Extensions', _SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions),
        ])
    SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD._ext = []
    
    #-----< SyncDLCodeIdsMeasInfoItem-CellSyncReprtTDD-ExtIEs >-----#
    SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_ExtIEs = CLASS(name='SyncDLCodeIdsMeasInfoItem-CellSyncReprtTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SyncDLCodeIdInfo-CellSyncReprtTDD >-----#
    SyncDLCodeIdInfo_CellSyncReprtTDD = SEQ_OF(name='SyncDLCodeIdInfo-CellSyncReprtTDD', mode=MODE_TYPE)
    _SyncDLCodeIdInfo_CellSyncReprtTDD__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncDLCodeIdItem-CellSyncReprtTDD')))
    SyncDLCodeIdInfo_CellSyncReprtTDD._cont = _SyncDLCodeIdInfo_CellSyncReprtTDD__item_
    SyncDLCodeIdInfo_CellSyncReprtTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SyncDLCodeIdItem-CellSyncReprtTDD >-----#
    SyncDLCodeIdItem_CellSyncReprtTDD = CHOICE(name='SyncDLCodeIdItem-CellSyncReprtTDD', mode=MODE_TYPE)
    _SyncDLCodeIdItem_CellSyncReprtTDD_syncDLCodeIdAvailable = SEQ(name='syncDLCodeIdAvailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'SyncDLCodeIdAvailable-CellSyncReprtTDD')))
    _SyncDLCodeIdItem_CellSyncReprtTDD_syncDLCodeIDNotAvailable = NULL(name='syncDLCodeIDNotAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SyncDLCodeIdItem_CellSyncReprtTDD._cont = ASN1Dict([
        ('syncDLCodeIdAvailable', _SyncDLCodeIdItem_CellSyncReprtTDD_syncDLCodeIdAvailable),
        ('syncDLCodeIDNotAvailable', _SyncDLCodeIdItem_CellSyncReprtTDD_syncDLCodeIDNotAvailable),
        ])
    SyncDLCodeIdItem_CellSyncReprtTDD._ext = []
    
    #-----< SyncDLCodeIdAvailable-CellSyncReprtTDD >-----#
    SyncDLCodeIdAvailable_CellSyncReprtTDD = SEQ(name='SyncDLCodeIdAvailable-CellSyncReprtTDD', mode=MODE_TYPE)
    _SyncDLCodeIdAvailable_CellSyncReprtTDD_syncDLCodeIdTiming = CHOICE(name='syncDLCodeIdTiming', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstTimingLCR')))
    _SyncDLCodeIdAvailable_CellSyncReprtTDD_syncDLCodeIdSIR = INT(name='syncDLCodeIdSIR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'CellSyncBurstSIR')))
    _SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__id._const_tab = ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__id_tab
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__id._const_tab_at = None
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab = ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality_tab
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab = ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__id),
        ('criticality', ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue),
        ])
    __SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item_._ext = None
    _SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions._cont = __SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item_
    _SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SyncDLCodeIdAvailable_CellSyncReprtTDD._cont = ASN1Dict([
        ('syncDLCodeIdTiming', _SyncDLCodeIdAvailable_CellSyncReprtTDD_syncDLCodeIdTiming),
        ('syncDLCodeIdSIR', _SyncDLCodeIdAvailable_CellSyncReprtTDD_syncDLCodeIdSIR),
        ('iE-Extensions', _SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions),
        ])
    SyncDLCodeIdAvailable_CellSyncReprtTDD._ext = []
    
    #-----< SyncDLCodeIdAvailable-CellSyncReprtTDD-ExtIEs >-----#
    SyncDLCodeIdAvailable_CellSyncReprtTDD_ExtIEs = CLASS(name='SyncDLCodeIdAvailable-CellSyncReprtTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SyncDLCodeIdAvailable_CellSyncReprtTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BearerRearrangementIndication >-----#
    BearerRearrangementIndication = SEQ(name='BearerRearrangementIndication', mode=MODE_TYPE)
    _BearerRearrangementIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __BearerRearrangementIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___BearerRearrangementIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____BearerRearrangementIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SignallingBearerRequestIndicator')))
    _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-RearrangeList-Bearer-RearrangeInd')))
    _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-RearrangeList-Bearer-RearrangeInd')))
    _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-RearrangeList-Bearer-RearrangeInd')))
    _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HSDSCH-RearrangeList-Bearer-RearrangeInd')))
    ____BearerRearrangementIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 138), ('criticality', 'ignore'), ('Value', _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 135), ('criticality', 'ignore'), ('Value', _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 136), ('criticality', 'ignore'), ('Value', _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 141), ('criticality', 'ignore'), ('Value', _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 553), ('criticality', 'ignore'), ('Value', _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BearerRearrangementIndication_protocolIEs__item__id._const_tab = ____BearerRearrangementIndication_protocolIEs__item__id_tab
    ___BearerRearrangementIndication_protocolIEs__item__id._const_tab_at = None
    ___BearerRearrangementIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___BearerRearrangementIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___BearerRearrangementIndication_protocolIEs__item__criticality._const_tab = ____BearerRearrangementIndication_protocolIEs__item__id_tab
    ___BearerRearrangementIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BearerRearrangementIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BearerRearrangementIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___BearerRearrangementIndication_protocolIEs__item__value._const_tab = ____BearerRearrangementIndication_protocolIEs__item__id_tab
    ___BearerRearrangementIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BearerRearrangementIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __BearerRearrangementIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BearerRearrangementIndication_protocolIEs__item__id),
        ('criticality', ___BearerRearrangementIndication_protocolIEs__item__criticality),
        ('value', ___BearerRearrangementIndication_protocolIEs__item__value),
        ])
    __BearerRearrangementIndication_protocolIEs__item_._ext = None
    _BearerRearrangementIndication_protocolIEs._cont = __BearerRearrangementIndication_protocolIEs__item_
    _BearerRearrangementIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _BearerRearrangementIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BearerRearrangementIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___BearerRearrangementIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____BearerRearrangementIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____BearerRearrangementIndication_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DCH-RearrangeList-Bearer-RearrangeInd')))
    ____BearerRearrangementIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 690), ('criticality', 'ignore'), ('Extension', _____BearerRearrangementIndication_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BearerRearrangementIndication_protocolExtensions__item__id._const_tab = ____BearerRearrangementIndication_protocolExtensions__item__id_tab
    ___BearerRearrangementIndication_protocolExtensions__item__id._const_tab_at = None
    ___BearerRearrangementIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___BearerRearrangementIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___BearerRearrangementIndication_protocolExtensions__item__criticality._const_tab = ____BearerRearrangementIndication_protocolExtensions__item__id_tab
    ___BearerRearrangementIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___BearerRearrangementIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___BearerRearrangementIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___BearerRearrangementIndication_protocolExtensions__item__extensionValue._const_tab = ____BearerRearrangementIndication_protocolExtensions__item__id_tab
    ___BearerRearrangementIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BearerRearrangementIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __BearerRearrangementIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___BearerRearrangementIndication_protocolExtensions__item__id),
        ('criticality', ___BearerRearrangementIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___BearerRearrangementIndication_protocolExtensions__item__extensionValue),
        ])
    __BearerRearrangementIndication_protocolExtensions__item_._ext = None
    _BearerRearrangementIndication_protocolExtensions._cont = __BearerRearrangementIndication_protocolExtensions__item_
    _BearerRearrangementIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BearerRearrangementIndication._cont = ASN1Dict([
        ('protocolIEs', _BearerRearrangementIndication_protocolIEs),
        ('protocolExtensions', _BearerRearrangementIndication_protocolExtensions),
        ])
    BearerRearrangementIndication._ext = []
    
    #-----< BearerRearrangementIndication-IEs >-----#
    BearerRearrangementIndication_IEs = CLASS(name='BearerRearrangementIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _BearerRearrangementIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _BearerRearrangementIndication_IEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'SignallingBearerRequestIndicator')))
    _BearerRearrangementIndication_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-RearrangeList-Bearer-RearrangeInd')))
    _BearerRearrangementIndication_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-RearrangeList-Bearer-RearrangeInd')))
    _BearerRearrangementIndication_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-RearrangeList-Bearer-RearrangeInd')))
    _BearerRearrangementIndication_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HSDSCH-RearrangeList-Bearer-RearrangeInd')))
    BearerRearrangementIndication_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _BearerRearrangementIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 138), ('criticality', 'ignore'), ('Value', _BearerRearrangementIndication_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 135), ('criticality', 'ignore'), ('Value', _BearerRearrangementIndication_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 136), ('criticality', 'ignore'), ('Value', _BearerRearrangementIndication_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 141), ('criticality', 'ignore'), ('Value', _BearerRearrangementIndication_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 553), ('criticality', 'ignore'), ('Value', _BearerRearrangementIndication_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BearerRearrangementIndication-Extensions >-----#
    BearerRearrangementIndication_Extensions = CLASS(name='BearerRearrangementIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _BearerRearrangementIndication_Extensions_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DCH-RearrangeList-Bearer-RearrangeInd')))
    BearerRearrangementIndication_Extensions._val = ASN1Set(rv=[dict([('id', 690), ('criticality', 'ignore'), ('Extension', _BearerRearrangementIndication_Extensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-RearrangeList-Bearer-RearrangeInd >-----#
    DCH_RearrangeList_Bearer_RearrangeInd = SEQ_OF(name='DCH-RearrangeList-Bearer-RearrangeInd', mode=MODE_TYPE)
    _DCH_RearrangeList_Bearer_RearrangeInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DCH-RearrangeItem-Bearer-RearrangeInd')))
    DCH_RearrangeList_Bearer_RearrangeInd._cont = _DCH_RearrangeList_Bearer_RearrangeInd__item_
    DCH_RearrangeList_Bearer_RearrangeInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-RearrangeItem-Bearer-RearrangeInd >-----#
    DCH_RearrangeItem_Bearer_RearrangeInd = SEQ(name='DCH-RearrangeItem-Bearer-RearrangeInd', mode=MODE_TYPE)
    _DCH_RearrangeItem_Bearer_RearrangeInd_dCH_ID = INT(name='dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DCH-ID')))
    _DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab = ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab_at = None
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab = ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab = ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id),
        ('criticality', ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue),
        ])
    __DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_._ext = None
    _DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions._cont = __DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_
    _DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_RearrangeItem_Bearer_RearrangeInd._cont = ASN1Dict([
        ('dCH-ID', _DCH_RearrangeItem_Bearer_RearrangeInd_dCH_ID),
        ('iE-Extensions', _DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions),
        ])
    DCH_RearrangeItem_Bearer_RearrangeInd._ext = []
    
    #-----< DCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs >-----#
    DCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs = CLASS(name='DCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DSCH-RearrangeList-Bearer-RearrangeInd >-----#
    DSCH_RearrangeList_Bearer_RearrangeInd = SEQ_OF(name='DSCH-RearrangeList-Bearer-RearrangeInd', mode=MODE_TYPE)
    _DSCH_RearrangeList_Bearer_RearrangeInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DSCH-RearrangeItem-Bearer-RearrangeInd')))
    DSCH_RearrangeList_Bearer_RearrangeInd._cont = _DSCH_RearrangeList_Bearer_RearrangeInd__item_
    DSCH_RearrangeList_Bearer_RearrangeInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DSCH-RearrangeItem-Bearer-RearrangeInd >-----#
    DSCH_RearrangeItem_Bearer_RearrangeInd = SEQ(name='DSCH-RearrangeItem-Bearer-RearrangeInd', mode=MODE_TYPE)
    _DSCH_RearrangeItem_Bearer_RearrangeInd_dSCH_ID = INT(name='dSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DSCH-ID')))
    _DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab = ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab_at = None
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab = ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab = ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id),
        ('criticality', ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality),
        ('extensionValue', ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue),
        ])
    __DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_._ext = None
    _DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions._cont = __DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_
    _DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCH_RearrangeItem_Bearer_RearrangeInd._cont = ASN1Dict([
        ('dSCH-ID', _DSCH_RearrangeItem_Bearer_RearrangeInd_dSCH_ID),
        ('iE-Extensions', _DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions),
        ])
    DSCH_RearrangeItem_Bearer_RearrangeInd._ext = []
    
    #-----< DSCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs >-----#
    DSCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs = CLASS(name='DSCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DSCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< USCH-RearrangeList-Bearer-RearrangeInd >-----#
    USCH_RearrangeList_Bearer_RearrangeInd = SEQ_OF(name='USCH-RearrangeList-Bearer-RearrangeInd', mode=MODE_TYPE)
    _USCH_RearrangeList_Bearer_RearrangeInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'USCH-RearrangeItem-Bearer-RearrangeInd')))
    USCH_RearrangeList_Bearer_RearrangeInd._cont = _USCH_RearrangeList_Bearer_RearrangeInd__item_
    USCH_RearrangeList_Bearer_RearrangeInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< USCH-RearrangeItem-Bearer-RearrangeInd >-----#
    USCH_RearrangeItem_Bearer_RearrangeInd = SEQ(name='USCH-RearrangeItem-Bearer-RearrangeInd', mode=MODE_TYPE)
    _USCH_RearrangeItem_Bearer_RearrangeInd_uSCH_ID = INT(name='uSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'USCH-ID')))
    _USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab = ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab_at = None
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab = ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab = ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id),
        ('criticality', ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality),
        ('extensionValue', ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue),
        ])
    __USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_._ext = None
    _USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions._cont = __USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_
    _USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCH_RearrangeItem_Bearer_RearrangeInd._cont = ASN1Dict([
        ('uSCH-ID', _USCH_RearrangeItem_Bearer_RearrangeInd_uSCH_ID),
        ('iE-Extensions', _USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions),
        ])
    USCH_RearrangeItem_Bearer_RearrangeInd._ext = []
    
    #-----< USCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs >-----#
    USCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs = CLASS(name='USCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    USCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-RearrangeList-Bearer-RearrangeInd >-----#
    HSDSCH_RearrangeList_Bearer_RearrangeInd = SEQ_OF(name='HSDSCH-RearrangeList-Bearer-RearrangeInd', mode=MODE_TYPE)
    _HSDSCH_RearrangeList_Bearer_RearrangeInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'HSDSCH-RearrangeItem-Bearer-RearrangeInd')))
    HSDSCH_RearrangeList_Bearer_RearrangeInd._cont = _HSDSCH_RearrangeList_Bearer_RearrangeInd__item_
    HSDSCH_RearrangeList_Bearer_RearrangeInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSDSCH-RearrangeItem-Bearer-RearrangeInd >-----#
    HSDSCH_RearrangeItem_Bearer_RearrangeInd = SEQ(name='HSDSCH-RearrangeItem-Bearer-RearrangeInd', mode=MODE_TYPE)
    _HSDSCH_RearrangeItem_Bearer_RearrangeInd_hsDSCH_MACdFlow_ID = INT(name='hsDSCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab = ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab = ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id),
        ('criticality', ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality),
        ('extensionValue', ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_._ext = None
    _HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions._cont = __HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_
    _HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_RearrangeItem_Bearer_RearrangeInd._cont = ASN1Dict([
        ('hsDSCH-MACdFlow-ID', _HSDSCH_RearrangeItem_Bearer_RearrangeInd_hsDSCH_MACdFlow_ID),
        ('iE-Extensions', _HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions),
        ])
    HSDSCH_RearrangeItem_Bearer_RearrangeInd._ext = []
    
    #-----< HSDSCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs >-----#
    HSDSCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs = CLASS(name='HSDSCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    HSDSCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-RearrangeList-Bearer-RearrangeInd >-----#
    E_DCH_RearrangeList_Bearer_RearrangeInd = SEQ_OF(name='E-DCH-RearrangeList-Bearer-RearrangeInd', mode=MODE_TYPE)
    _E_DCH_RearrangeList_Bearer_RearrangeInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'E-DCH-RearrangeItem-Bearer-RearrangeInd')))
    E_DCH_RearrangeList_Bearer_RearrangeInd._cont = _E_DCH_RearrangeList_Bearer_RearrangeInd__item_
    E_DCH_RearrangeList_Bearer_RearrangeInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-RearrangeItem-Bearer-RearrangeInd >-----#
    E_DCH_RearrangeItem_Bearer_RearrangeInd = SEQ(name='E-DCH-RearrangeItem-Bearer-RearrangeInd', mode=MODE_TYPE)
    _E_DCH_RearrangeItem_Bearer_RearrangeInd_e_DCH_MACdFlow_ID = INT(name='e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-MACdFlow-ID')))
    _E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-Bearer-Rearrangement-List')))
    ____E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 1126), ('criticality', 'ignore'), ('Extension', _____E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab = ____E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab = ____E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id),
        ('criticality', ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_._ext = None
    _E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions._cont = __E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_
    _E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_RearrangeItem_Bearer_RearrangeInd._cont = ASN1Dict([
        ('e-DCH-MACdFlow-ID', _E_DCH_RearrangeItem_Bearer_RearrangeInd_e_DCH_MACdFlow_ID),
        ('iE-Extensions', _E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions),
        ])
    E_DCH_RearrangeItem_Bearer_RearrangeInd._ext = []
    
    #-----< E-DCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs >-----#
    E_DCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs = CLASS(name='E-DCH-RearrangeItem-Bearer-RearrangeInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _E_DCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-Bearer-Rearrangement-List')))
    E_DCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs._val = ASN1Set(rv=[dict([('id', 1126), ('criticality', 'ignore'), ('Extension', _E_DCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-Bearer-Rearrangement-List >-----#
    Additional_EDCH_Cell_Information_Bearer_Rearrangement_List = SEQ_OF(name='Additional-EDCH-Cell-Information-Bearer-Rearrangement-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Bearer_Rearrangement_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-Bearer-Rearrangement-ItemIEs')))
    Additional_EDCH_Cell_Information_Bearer_Rearrangement_List._cont = _Additional_EDCH_Cell_Information_Bearer_Rearrangement_List__item_
    Additional_EDCH_Cell_Information_Bearer_Rearrangement_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Cell-Information-Bearer-Rearrangement-ItemIEs >-----#
    Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs = SEQ(name='Additional-EDCH-Cell-Information-Bearer-Rearrangement-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_transport_Bearer_Rearrangement_Indicator_for_Additional_EDCH_Separate_Mode = ENUM(name='transport-Bearer-Rearrangement-Indicator-for-Additional-EDCH-Separate-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Contents', 'Transport-Bearer-Rearrangement-Indicator-for-Additional-EDCH-Separate-Mode')))
    _Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions._cont = __Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs._cont = ASN1Dict([
        ('transport-Bearer-Rearrangement-Indicator-for-Additional-EDCH-Separate-Mode', _Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_transport_Bearer_Rearrangement_Indicator_for_Additional_EDCH_Separate_Mode),
        ('iE-Extensions', _Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs._ext = []
    
    #-----< Additional-EDCH-Cell-Information-Bearer-Rearrangement-ItemIEs-ExtIEs >-----#
    Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_ExtIEs = CLASS(name='Additional-EDCH-Cell-Information-Bearer-Rearrangement-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transport-Bearer-Rearrangement-Indicator-for-Additional-EDCH-Separate-Mode >-----#
    Transport_Bearer_Rearrangement_Indicator_for_Additional_EDCH_Separate_Mode = ENUM(name='Transport-Bearer-Rearrangement-Indicator-for-Additional-EDCH-Separate-Mode', mode=MODE_TYPE)
    Transport_Bearer_Rearrangement_Indicator_for_Additional_EDCH_Separate_Mode._cont = ASN1Dict([('bearer-for-primary-carrier', 0), ('bearer-for-secondary-carrier', 1), ('bearers-for-both-primary-and-secondary-carriers', 2)])
    Transport_Bearer_Rearrangement_Indicator_for_Additional_EDCH_Separate_Mode._ext = []
    
    #-----< RadioLinkActivationCommandFDD >-----#
    RadioLinkActivationCommandFDD = SEQ(name='RadioLinkActivationCommandFDD', mode=MODE_TYPE)
    _RadioLinkActivationCommandFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkActivationCommandFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkActivationCommandFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DelayedActivationInformationList-RL-ActivationCmdFDD')))
    ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 232), ('criticality', 'ignore'), ('Value', _____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandFDD_protocolIEs__item__id._const_tab = ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkActivationCommandFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkActivationCommandFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkActivationCommandFDD_protocolIEs__item__value._const_tab = ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkActivationCommandFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkActivationCommandFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkActivationCommandFDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkActivationCommandFDD_protocolIEs__item__value),
        ])
    __RadioLinkActivationCommandFDD_protocolIEs__item_._ext = None
    _RadioLinkActivationCommandFDD_protocolIEs._cont = __RadioLinkActivationCommandFDD_protocolIEs__item_
    _RadioLinkActivationCommandFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkActivationCommandFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkActivationCommandFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__id._const_tab = ____RadioLinkActivationCommandFDD_protocolExtensions__item__id_tab
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkActivationCommandFDD_protocolExtensions__item__criticality_tab
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkActivationCommandFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkActivationCommandFDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkActivationCommandFDD_protocolExtensions__item_._ext = None
    _RadioLinkActivationCommandFDD_protocolExtensions._cont = __RadioLinkActivationCommandFDD_protocolExtensions__item_
    _RadioLinkActivationCommandFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkActivationCommandFDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkActivationCommandFDD_protocolIEs),
        ('protocolExtensions', _RadioLinkActivationCommandFDD_protocolExtensions),
        ])
    RadioLinkActivationCommandFDD._ext = []
    
    #-----< RadioLinkActivationCommandFDD-IEs >-----#
    RadioLinkActivationCommandFDD_IEs = CLASS(name='RadioLinkActivationCommandFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkActivationCommandFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkActivationCommandFDD_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DelayedActivationInformationList-RL-ActivationCmdFDD')))
    RadioLinkActivationCommandFDD_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _RadioLinkActivationCommandFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 232), ('criticality', 'ignore'), ('Value', _RadioLinkActivationCommandFDD_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkActivationCommandFDD-Extensions >-----#
    RadioLinkActivationCommandFDD_Extensions = CLASS(name='RadioLinkActivationCommandFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkActivationCommandFDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DelayedActivationInformationList-RL-ActivationCmdFDD >-----#
    DelayedActivationInformationList_RL_ActivationCmdFDD = SEQ_OF(name='DelayedActivationInformationList-RL-ActivationCmdFDD', mode=MODE_TYPE)
    _DelayedActivationInformationList_RL_ActivationCmdFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DelayedActivationInformation-RL-ActivationCmdFDD')))
    ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 233), ('criticality', 'ignore'), ('Value', ____DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id._const_tab_at = None
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id._const_tab_id = 'id'
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality._const_tab_at = ('..', 'id')
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality._const_tab_id = 'criticality'
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value._const_tab_at = ('..', 'id')
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value._const_tab_id = 'Value'
    _DelayedActivationInformationList_RL_ActivationCmdFDD__item_._cont = ASN1Dict([
        ('id', __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id),
        ('criticality', __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality),
        ('value', __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value),
        ])
    _DelayedActivationInformationList_RL_ActivationCmdFDD__item_._ext = None
    DelayedActivationInformationList_RL_ActivationCmdFDD._cont = _DelayedActivationInformationList_RL_ActivationCmdFDD__item_
    DelayedActivationInformationList_RL_ActivationCmdFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DelayedActivationInformation-RL-ActivationCmdFDD-IEs >-----#
    DelayedActivationInformation_RL_ActivationCmdFDD_IEs = CLASS(name='DelayedActivationInformation-RL-ActivationCmdFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DelayedActivationInformation_RL_ActivationCmdFDD_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DelayedActivationInformation-RL-ActivationCmdFDD')))
    DelayedActivationInformation_RL_ActivationCmdFDD_IEs._val = ASN1Set(rv=[dict([('id', 233), ('criticality', 'ignore'), ('Value', _DelayedActivationInformation_RL_ActivationCmdFDD_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< DelayedActivationInformation-RL-ActivationCmdFDD >-----#
    DelayedActivationInformation_RL_ActivationCmdFDD = SEQ(name='DelayedActivationInformation-RL-ActivationCmdFDD', mode=MODE_TYPE)
    _DelayedActivationInformation_RL_ActivationCmdFDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _DelayedActivationInformation_RL_ActivationCmdFDD_delayed_activation_update = CHOICE(name='delayed-activation-update', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DelayedActivationUpdate')))
    _DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id._const_tab = ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id_tab
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id._const_tab_at = None
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality._const_tab = ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality_tab
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue._const_tab = ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue_tab
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id),
        ('criticality', ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue),
        ])
    __DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item_._ext = None
    _DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions._cont = __DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item_
    _DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DelayedActivationInformation_RL_ActivationCmdFDD._cont = ASN1Dict([
        ('rL-ID', _DelayedActivationInformation_RL_ActivationCmdFDD_rL_ID),
        ('delayed-activation-update', _DelayedActivationInformation_RL_ActivationCmdFDD_delayed_activation_update),
        ('iE-Extensions', _DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions),
        ])
    DelayedActivationInformation_RL_ActivationCmdFDD._ext = []
    
    #-----< DelayedActivationInformation-RL-ActivationCmdFDD-ExtIEs >-----#
    DelayedActivationInformation_RL_ActivationCmdFDD_ExtIEs = CLASS(name='DelayedActivationInformation-RL-ActivationCmdFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DelayedActivationInformation_RL_ActivationCmdFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkActivationCommandTDD >-----#
    RadioLinkActivationCommandTDD = SEQ(name='RadioLinkActivationCommandTDD', mode=MODE_TYPE)
    _RadioLinkActivationCommandTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkActivationCommandTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkActivationCommandTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DelayedActivationInformationList-RL-ActivationCmdTDD')))
    ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandTDD_protocolIEs__item__id._const_tab = ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkActivationCommandTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkActivationCommandTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkActivationCommandTDD_protocolIEs__item__value._const_tab = ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkActivationCommandTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkActivationCommandTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkActivationCommandTDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkActivationCommandTDD_protocolIEs__item__value),
        ])
    __RadioLinkActivationCommandTDD_protocolIEs__item_._ext = None
    _RadioLinkActivationCommandTDD_protocolIEs._cont = __RadioLinkActivationCommandTDD_protocolIEs__item_
    _RadioLinkActivationCommandTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkActivationCommandTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkActivationCommandTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__id._const_tab = ____RadioLinkActivationCommandTDD_protocolExtensions__item__id_tab
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkActivationCommandTDD_protocolExtensions__item__criticality_tab
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkActivationCommandTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkActivationCommandTDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkActivationCommandTDD_protocolExtensions__item_._ext = None
    _RadioLinkActivationCommandTDD_protocolExtensions._cont = __RadioLinkActivationCommandTDD_protocolExtensions__item_
    _RadioLinkActivationCommandTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkActivationCommandTDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkActivationCommandTDD_protocolIEs),
        ('protocolExtensions', _RadioLinkActivationCommandTDD_protocolExtensions),
        ])
    RadioLinkActivationCommandTDD._ext = []
    
    #-----< RadioLinkActivationCommandTDD-IEs >-----#
    RadioLinkActivationCommandTDD_IEs = CLASS(name='RadioLinkActivationCommandTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkActivationCommandTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _RadioLinkActivationCommandTDD_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DelayedActivationInformationList-RL-ActivationCmdTDD')))
    RadioLinkActivationCommandTDD_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _RadioLinkActivationCommandTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _RadioLinkActivationCommandTDD_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkActivationCommandTDD-Extensions >-----#
    RadioLinkActivationCommandTDD_Extensions = CLASS(name='RadioLinkActivationCommandTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkActivationCommandTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DelayedActivationInformationList-RL-ActivationCmdTDD >-----#
    DelayedActivationInformationList_RL_ActivationCmdTDD = SEQ_OF(name='DelayedActivationInformationList-RL-ActivationCmdTDD', mode=MODE_TYPE)
    _DelayedActivationInformationList_RL_ActivationCmdTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Single-Container')))
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    ____DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DelayedActivationInformation-RL-ActivationCmdTDD')))
    ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab._val = ASN1Set(rv=[dict([('id', 235), ('criticality', 'ignore'), ('Value', ____DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id._const_tab_at = None
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id._const_tab_id = 'id'
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality._const_tab_at = ('..', 'id')
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality._const_tab_id = 'criticality'
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value._const_tab_at = ('..', 'id')
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value._const_tab_id = 'Value'
    _DelayedActivationInformationList_RL_ActivationCmdTDD__item_._cont = ASN1Dict([
        ('id', __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id),
        ('criticality', __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality),
        ('value', __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value),
        ])
    _DelayedActivationInformationList_RL_ActivationCmdTDD__item_._ext = None
    DelayedActivationInformationList_RL_ActivationCmdTDD._cont = _DelayedActivationInformationList_RL_ActivationCmdTDD__item_
    DelayedActivationInformationList_RL_ActivationCmdTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DelayedActivationInformation-RL-ActivationCmdTDD-IEs >-----#
    DelayedActivationInformation_RL_ActivationCmdTDD_IEs = CLASS(name='DelayedActivationInformation-RL-ActivationCmdTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _DelayedActivationInformation_RL_ActivationCmdTDD_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DelayedActivationInformation-RL-ActivationCmdTDD')))
    DelayedActivationInformation_RL_ActivationCmdTDD_IEs._val = ASN1Set(rv=[dict([('id', 235), ('criticality', 'ignore'), ('Value', _DelayedActivationInformation_RL_ActivationCmdTDD_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    
    #-----< DelayedActivationInformation-RL-ActivationCmdTDD >-----#
    DelayedActivationInformation_RL_ActivationCmdTDD = SEQ(name='DelayedActivationInformation-RL-ActivationCmdTDD', mode=MODE_TYPE)
    _DelayedActivationInformation_RL_ActivationCmdTDD_rL_ID = INT(name='rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _DelayedActivationInformation_RL_ActivationCmdTDD_delayed_activation_update = CHOICE(name='delayed-activation-update', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'DelayedActivationUpdate')))
    _DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id._const_tab = ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id_tab
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id._const_tab_at = None
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality._const_tab = ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality_tab
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue._const_tab = ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue_tab
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id),
        ('criticality', ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue),
        ])
    __DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item_._ext = None
    _DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions._cont = __DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item_
    _DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DelayedActivationInformation_RL_ActivationCmdTDD._cont = ASN1Dict([
        ('rL-ID', _DelayedActivationInformation_RL_ActivationCmdTDD_rL_ID),
        ('delayed-activation-update', _DelayedActivationInformation_RL_ActivationCmdTDD_delayed_activation_update),
        ('iE-Extensions', _DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions),
        ])
    DelayedActivationInformation_RL_ActivationCmdTDD._ext = []
    
    #-----< DelayedActivationInformation-RL-ActivationCmdTDD-ExtIEs >-----#
    DelayedActivationInformation_RL_ActivationCmdTDD_ExtIEs = CLASS(name='DelayedActivationInformation-RL-ActivationCmdTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    DelayedActivationInformation_RL_ActivationCmdTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkParameterUpdateIndicationFDD >-----#
    RadioLinkParameterUpdateIndicationFDD = SEQ(name='RadioLinkParameterUpdateIndicationFDD', mode=MODE_TYPE)
    _RadioLinkParameterUpdateIndicationFDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkParameterUpdateIndicationFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Update-Information')))
    ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 555), ('criticality', 'ignore'), ('Value', _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkParameterUpdateIndicationFDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value),
        ])
    __RadioLinkParameterUpdateIndicationFDD_protocolIEs__item_._ext = None
    _RadioLinkParameterUpdateIndicationFDD_protocolIEs._cont = __RadioLinkParameterUpdateIndicationFDD_protocolIEs__item_
    _RadioLinkParameterUpdateIndicationFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkParameterUpdateIndicationFDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Update-Information')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Param-Upd')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Param-Upd')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CPC-RecoveryReport')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-State-Update-Information')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UE-Measurement-Forwarding')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 706), ('criticality', 'ignore'), ('Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 1043), ('criticality', 'ignore'), ('Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 1127), ('criticality', 'ignore'), ('Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 1214), ('criticality', 'ignore'), ('Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 1211), ('criticality', 'ignore'), ('Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 1277), ('criticality', 'ignore'), ('Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 24), ('criticality', 'ignore'), ('Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item_._ext = None
    _RadioLinkParameterUpdateIndicationFDD_protocolExtensions._cont = __RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item_
    _RadioLinkParameterUpdateIndicationFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkParameterUpdateIndicationFDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkParameterUpdateIndicationFDD_protocolIEs),
        ('protocolExtensions', _RadioLinkParameterUpdateIndicationFDD_protocolExtensions),
        ])
    RadioLinkParameterUpdateIndicationFDD._ext = []
    
    #-----< RadioLinkParameterUpdateIndicationFDD-IEs >-----#
    RadioLinkParameterUpdateIndicationFDD_IEs = CLASS(name='RadioLinkParameterUpdateIndicationFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-FDD-Update-Information')))
    RadioLinkParameterUpdateIndicationFDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 555), ('criticality', 'ignore'), ('Value', _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkParameterUpdateIndicationFDD-Extensions >-----#
    RadioLinkParameterUpdateIndicationFDD_Extensions = CLASS(name='RadioLinkParameterUpdateIndicationFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'E-DCH-FDD-Update-Information')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Param-Upd')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Param-Upd')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CPC-RecoveryReport')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'UL-CLTD-State-Update-Information')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UE-Measurement-Forwarding')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CFN')))
    RadioLinkParameterUpdateIndicationFDD_Extensions._val = ASN1Set(rv=[dict([('id', 706), ('criticality', 'ignore'), ('Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 1043), ('criticality', 'ignore'), ('Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 1127), ('criticality', 'ignore'), ('Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 1214), ('criticality', 'ignore'), ('Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 1211), ('criticality', 'ignore'), ('Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 1277), ('criticality', 'ignore'), ('Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 24), ('criticality', 'ignore'), ('Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Param-Upd >-----#
    Additional_HS_Cell_Information_RL_Param_Upd = SEQ_OF(name='Additional-HS-Cell-Information-RL-Param-Upd', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Param_Upd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Param-Upd-ItemIEs')))
    Additional_HS_Cell_Information_RL_Param_Upd._cont = _Additional_HS_Cell_Information_RL_Param_Upd__item_
    Additional_HS_Cell_Information_RL_Param_Upd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Param-Upd-ItemIEs >-----#
    Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs = SEQ(name='Additional-HS-Cell-Information-RL-Param-Upd-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hSPDSCH_RL_ID = INT(name='hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Update_Information = SEQ(name='hS-DSCH-FDD-Secondary-Serving-Update-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Update-Information')))
    _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs._cont = ASN1Dict([
        ('hSPDSCH-RL-ID', _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hSPDSCH_RL_ID),
        ('hS-DSCH-FDD-Secondary-Serving-Update-Information', _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Update_Information),
        ('iE-Extensions', _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-RL-Setup-ExtIEs >-----#
    Additional_HS_Cell_Information_RL_Setup_ExtIEs = CLASS(name='Additional-HS-Cell-Information-RL-Setup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_RL_Setup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-RL-Param-Upd >-----#
    Additional_EDCH_Cell_Information_RL_Param_Upd = SEQ_OF(name='Additional-EDCH-Cell-Information-RL-Param-Upd', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_RL_Param_Upd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs')))
    Additional_EDCH_Cell_Information_RL_Param_Upd._cont = _Additional_EDCH_Cell_Information_RL_Param_Upd__item_
    Additional_EDCH_Cell_Information_RL_Param_Upd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs >-----#
    Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs = SEQ(name='Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_additional_EDCH_FDD_Update_Information = SEQ(name='additional-EDCH-FDD-Update-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'Additional-EDCH-FDD-Update-Information')))
    _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id),
        ('criticality', ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions._cont = __Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs._cont = ASN1Dict([
        ('additional-EDCH-FDD-Update-Information', _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_additional_EDCH_FDD_Update_Information),
        ('iE-Extensions', _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs._ext = []
    
    #-----< Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs-ExtIEs >-----#
    Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_ExtIEs = CLASS(name='Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-Measurement-Forwarding >-----#
    UE_Measurement_Forwarding = SEQ(name='UE-Measurement-Forwarding', mode=MODE_TYPE)
    _UE_Measurement_Forwarding_measurementID = INT(name='measurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'MeasurementID')))
    _UE_Measurement_Forwarding_uE_Measurement_Value = CHOICE(name='uE-Measurement-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-IEs', 'UE-Measurement-Value')))
    _UE_Measurement_Forwarding_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_Measurement_Forwarding_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UE_Measurement_Forwarding_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_Measurement_Forwarding_iE_Extensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UE_Measurement_Forwarding_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Measurement_Forwarding_iE_Extensions__item__id._const_tab = ____UE_Measurement_Forwarding_iE_Extensions__item__id_tab
    ___UE_Measurement_Forwarding_iE_Extensions__item__id._const_tab_at = None
    ___UE_Measurement_Forwarding_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_Measurement_Forwarding_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_Measurement_Forwarding_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UE_Measurement_Forwarding_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Measurement_Forwarding_iE_Extensions__item__criticality._const_tab = ____UE_Measurement_Forwarding_iE_Extensions__item__criticality_tab
    ___UE_Measurement_Forwarding_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_Measurement_Forwarding_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_Measurement_Forwarding_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UE_Measurement_Forwarding_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue._const_tab = ____UE_Measurement_Forwarding_iE_Extensions__item__extensionValue_tab
    ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_Measurement_Forwarding_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_Measurement_Forwarding_iE_Extensions__item__id),
        ('criticality', ___UE_Measurement_Forwarding_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue),
        ])
    __UE_Measurement_Forwarding_iE_Extensions__item_._ext = None
    _UE_Measurement_Forwarding_iE_Extensions._cont = __UE_Measurement_Forwarding_iE_Extensions__item_
    _UE_Measurement_Forwarding_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_Measurement_Forwarding._cont = ASN1Dict([
        ('measurementID', _UE_Measurement_Forwarding_measurementID),
        ('uE-Measurement-Value', _UE_Measurement_Forwarding_uE_Measurement_Value),
        ('iE-Extensions', _UE_Measurement_Forwarding_iE_Extensions),
        ])
    UE_Measurement_Forwarding._ext = []
    
    #-----< UE-Measurement-Forwarding-ExtIEs >-----#
    UE_Measurement_Forwarding_ExtIEs = CLASS(name='UE-Measurement-Forwarding-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UE_Measurement_Forwarding_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkParameterUpdateIndicationTDD >-----#
    RadioLinkParameterUpdateIndicationTDD = SEQ(name='RadioLinkParameterUpdateIndicationTDD', mode=MODE_TYPE)
    _RadioLinkParameterUpdateIndicationTDD_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkParameterUpdateIndicationTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Update-Information')))
    ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 556), ('criticality', 'ignore'), ('Value', _____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id._const_tab_id = 'id'
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value._const_tab_id = 'Value'
    __RadioLinkParameterUpdateIndicationTDD_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id),
        ('criticality', ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality),
        ('value', ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value),
        ])
    __RadioLinkParameterUpdateIndicationTDD_protocolIEs__item_._ext = None
    _RadioLinkParameterUpdateIndicationTDD_protocolIEs._cont = __RadioLinkParameterUpdateIndicationTDD_protocolIEs__item_
    _RadioLinkParameterUpdateIndicationTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkParameterUpdateIndicationTDD_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id._const_tab_id = 'id'
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id),
        ('criticality', ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality),
        ('extensionValue', ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item_._ext = None
    _RadioLinkParameterUpdateIndicationTDD_protocolExtensions._cont = __RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item_
    _RadioLinkParameterUpdateIndicationTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkParameterUpdateIndicationTDD._cont = ASN1Dict([
        ('protocolIEs', _RadioLinkParameterUpdateIndicationTDD_protocolIEs),
        ('protocolExtensions', _RadioLinkParameterUpdateIndicationTDD_protocolExtensions),
        ])
    RadioLinkParameterUpdateIndicationTDD._ext = []
    
    #-----< RadioLinkParameterUpdateIndicationTDD-IEs >-----#
    RadioLinkParameterUpdateIndicationTDD_IEs = CLASS(name='RadioLinkParameterUpdateIndicationTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _RadioLinkParameterUpdateIndicationTDD_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _RadioLinkParameterUpdateIndicationTDD_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'HSDSCH-TDD-Update-Information')))
    RadioLinkParameterUpdateIndicationTDD_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _RadioLinkParameterUpdateIndicationTDD_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 556), ('criticality', 'ignore'), ('Value', _RadioLinkParameterUpdateIndicationTDD_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkParameterUpdateIndicationTDD-Extensions >-----#
    RadioLinkParameterUpdateIndicationTDD_Extensions = CLASS(name='RadioLinkParameterUpdateIndicationTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    RadioLinkParameterUpdateIndicationTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSNotificationUpdateCommand >-----#
    MBMSNotificationUpdateCommand = SEQ(name='MBMSNotificationUpdateCommand', mode=MODE_TYPE)
    _MBMSNotificationUpdateCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __MBMSNotificationUpdateCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___MBMSNotificationUpdateCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Modification-Period')))
    _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MICH-CFN')))
    _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NI-Information')))
    ____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 35), ('criticality', 'ignore'), ('Value', _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 644), ('criticality', 'ignore'), ('Value', _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 637), ('criticality', 'ignore'), ('Value', _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 645), ('criticality', 'ignore'), ('Value', _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MBMSNotificationUpdateCommand_protocolIEs__item__id._const_tab = ____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab
    ___MBMSNotificationUpdateCommand_protocolIEs__item__id._const_tab_at = None
    ___MBMSNotificationUpdateCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSNotificationUpdateCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSNotificationUpdateCommand_protocolIEs__item__criticality._const_tab = ____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab
    ___MBMSNotificationUpdateCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSNotificationUpdateCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSNotificationUpdateCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___MBMSNotificationUpdateCommand_protocolIEs__item__value._const_tab = ____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab
    ___MBMSNotificationUpdateCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSNotificationUpdateCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSNotificationUpdateCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSNotificationUpdateCommand_protocolIEs__item__id),
        ('criticality', ___MBMSNotificationUpdateCommand_protocolIEs__item__criticality),
        ('value', ___MBMSNotificationUpdateCommand_protocolIEs__item__value),
        ])
    __MBMSNotificationUpdateCommand_protocolIEs__item_._ext = None
    _MBMSNotificationUpdateCommand_protocolIEs._cont = __MBMSNotificationUpdateCommand_protocolIEs__item_
    _MBMSNotificationUpdateCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSNotificationUpdateCommand_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSNotificationUpdateCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSNotificationUpdateCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MBMSNotificationUpdateCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__id._const_tab = ____MBMSNotificationUpdateCommand_protocolExtensions__item__id_tab
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__id._const_tab_at = None
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSNotificationUpdateCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MBMSNotificationUpdateCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__criticality._const_tab = ____MBMSNotificationUpdateCommand_protocolExtensions__item__criticality_tab
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSNotificationUpdateCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____MBMSNotificationUpdateCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__extensionValue._const_tab = ____MBMSNotificationUpdateCommand_protocolExtensions__item__extensionValue_tab
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSNotificationUpdateCommand_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSNotificationUpdateCommand_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSNotificationUpdateCommand_protocolExtensions__item__id),
        ('criticality', ___MBMSNotificationUpdateCommand_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSNotificationUpdateCommand_protocolExtensions__item__extensionValue),
        ])
    __MBMSNotificationUpdateCommand_protocolExtensions__item_._ext = None
    _MBMSNotificationUpdateCommand_protocolExtensions._cont = __MBMSNotificationUpdateCommand_protocolExtensions__item_
    _MBMSNotificationUpdateCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSNotificationUpdateCommand._cont = ASN1Dict([
        ('protocolIEs', _MBMSNotificationUpdateCommand_protocolIEs),
        ('protocolExtensions', _MBMSNotificationUpdateCommand_protocolExtensions),
        ])
    MBMSNotificationUpdateCommand._ext = []
    
    #-----< MBMSNotificationUpdateCommand-IEs >-----#
    MBMSNotificationUpdateCommand_IEs = CLASS(name='MBMSNotificationUpdateCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _MBMSNotificationUpdateCommand_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'C-ID')))
    _MBMSNotificationUpdateCommand_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CommonPhysicalChannelID')))
    _MBMSNotificationUpdateCommand_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Modification-Period')))
    _MBMSNotificationUpdateCommand_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'MICH-CFN')))
    _MBMSNotificationUpdateCommand_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NI-Information')))
    MBMSNotificationUpdateCommand_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _MBMSNotificationUpdateCommand_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 35), ('criticality', 'ignore'), ('Value', _MBMSNotificationUpdateCommand_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 644), ('criticality', 'ignore'), ('Value', _MBMSNotificationUpdateCommand_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 637), ('criticality', 'ignore'), ('Value', _MBMSNotificationUpdateCommand_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 645), ('criticality', 'ignore'), ('Value', _MBMSNotificationUpdateCommand_IEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MBMSNotificationUpdateCommand-Extensions >-----#
    MBMSNotificationUpdateCommand_Extensions = CLASS(name='MBMSNotificationUpdateCommand-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    MBMSNotificationUpdateCommand_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEStatusUpdateCommand >-----#
    UEStatusUpdateCommand = SEQ(name='UEStatusUpdateCommand', mode=MODE_TYPE)
    _UEStatusUpdateCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __UEStatusUpdateCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___UEStatusUpdateCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____UEStatusUpdateCommand_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____UEStatusUpdateCommand_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-ERNTI-Status-Information')))
    ____UEStatusUpdateCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 993), ('criticality', 'ignore'), ('Value', _____UEStatusUpdateCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UEStatusUpdateCommand_protocolIEs__item__id._const_tab = ____UEStatusUpdateCommand_protocolIEs__item__id_tab
    ___UEStatusUpdateCommand_protocolIEs__item__id._const_tab_at = None
    ___UEStatusUpdateCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___UEStatusUpdateCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___UEStatusUpdateCommand_protocolIEs__item__criticality._const_tab = ____UEStatusUpdateCommand_protocolIEs__item__id_tab
    ___UEStatusUpdateCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEStatusUpdateCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEStatusUpdateCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___UEStatusUpdateCommand_protocolIEs__item__value._const_tab = ____UEStatusUpdateCommand_protocolIEs__item__id_tab
    ___UEStatusUpdateCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEStatusUpdateCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __UEStatusUpdateCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEStatusUpdateCommand_protocolIEs__item__id),
        ('criticality', ___UEStatusUpdateCommand_protocolIEs__item__criticality),
        ('value', ___UEStatusUpdateCommand_protocolIEs__item__value),
        ])
    __UEStatusUpdateCommand_protocolIEs__item_._ext = None
    _UEStatusUpdateCommand_protocolIEs._cont = __UEStatusUpdateCommand_protocolIEs__item_
    _UEStatusUpdateCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UEStatusUpdateCommand_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEStatusUpdateCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UEStatusUpdateCommand_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UEStatusUpdateCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UEStatusUpdateCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEStatusUpdateCommand_protocolExtensions__item__id._const_tab = ____UEStatusUpdateCommand_protocolExtensions__item__id_tab
    ___UEStatusUpdateCommand_protocolExtensions__item__id._const_tab_at = None
    ___UEStatusUpdateCommand_protocolExtensions__item__id._const_tab_id = 'id'
    ___UEStatusUpdateCommand_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEStatusUpdateCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UEStatusUpdateCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEStatusUpdateCommand_protocolExtensions__item__criticality._const_tab = ____UEStatusUpdateCommand_protocolExtensions__item__criticality_tab
    ___UEStatusUpdateCommand_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEStatusUpdateCommand_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UEStatusUpdateCommand_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEStatusUpdateCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UEStatusUpdateCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEStatusUpdateCommand_protocolExtensions__item__extensionValue._const_tab = ____UEStatusUpdateCommand_protocolExtensions__item__extensionValue_tab
    ___UEStatusUpdateCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEStatusUpdateCommand_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UEStatusUpdateCommand_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UEStatusUpdateCommand_protocolExtensions__item__id),
        ('criticality', ___UEStatusUpdateCommand_protocolExtensions__item__criticality),
        ('extensionValue', ___UEStatusUpdateCommand_protocolExtensions__item__extensionValue),
        ])
    __UEStatusUpdateCommand_protocolExtensions__item_._ext = None
    _UEStatusUpdateCommand_protocolExtensions._cont = __UEStatusUpdateCommand_protocolExtensions__item_
    _UEStatusUpdateCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEStatusUpdateCommand._cont = ASN1Dict([
        ('protocolIEs', _UEStatusUpdateCommand_protocolIEs),
        ('protocolExtensions', _UEStatusUpdateCommand_protocolExtensions),
        ])
    UEStatusUpdateCommand._ext = []
    
    #-----< UEStatusUpdateCommand-IEs >-----#
    UEStatusUpdateCommand_IEs = CLASS(name='UEStatusUpdateCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UEStatusUpdateCommand_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-ERNTI-Status-Information')))
    UEStatusUpdateCommand_IEs._val = ASN1Set(rv=[dict([('id', 993), ('criticality', 'ignore'), ('Value', _UEStatusUpdateCommand_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEStatusUpdateCommand-Extensions >-----#
    UEStatusUpdateCommand_Extensions = CLASS(name='UEStatusUpdateCommand-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UEStatusUpdateCommand_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryULFrequencyReport >-----#
    SecondaryULFrequencyReport = SEQ(name='SecondaryULFrequencyReport', mode=MODE_TYPE)
    _SecondaryULFrequencyReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __SecondaryULFrequencyReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___SecondaryULFrequencyReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____SecondaryULFrequencyReport_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____SecondaryULFrequencyReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _____SecondaryULFrequencyReport_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ActivationInformation')))
    ____SecondaryULFrequencyReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _____SecondaryULFrequencyReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1119), ('criticality', 'ignore'), ('Value', _____SecondaryULFrequencyReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyReport_protocolIEs__item__id._const_tab = ____SecondaryULFrequencyReport_protocolIEs__item__id_tab
    ___SecondaryULFrequencyReport_protocolIEs__item__id._const_tab_at = None
    ___SecondaryULFrequencyReport_protocolIEs__item__id._const_tab_id = 'id'
    ___SecondaryULFrequencyReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___SecondaryULFrequencyReport_protocolIEs__item__criticality._const_tab = ____SecondaryULFrequencyReport_protocolIEs__item__id_tab
    ___SecondaryULFrequencyReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryULFrequencyReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SecondaryULFrequencyReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___SecondaryULFrequencyReport_protocolIEs__item__value._const_tab = ____SecondaryULFrequencyReport_protocolIEs__item__id_tab
    ___SecondaryULFrequencyReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SecondaryULFrequencyReport_protocolIEs__item__value._const_tab_id = 'Value'
    __SecondaryULFrequencyReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SecondaryULFrequencyReport_protocolIEs__item__id),
        ('criticality', ___SecondaryULFrequencyReport_protocolIEs__item__criticality),
        ('value', ___SecondaryULFrequencyReport_protocolIEs__item__value),
        ])
    __SecondaryULFrequencyReport_protocolIEs__item_._ext = None
    _SecondaryULFrequencyReport_protocolIEs._cont = __SecondaryULFrequencyReport_protocolIEs__item_
    _SecondaryULFrequencyReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SecondaryULFrequencyReport_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryULFrequencyReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryULFrequencyReport_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecondaryULFrequencyReport_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyReport_protocolExtensions__item__id._const_tab = ____SecondaryULFrequencyReport_protocolExtensions__item__id_tab
    ___SecondaryULFrequencyReport_protocolExtensions__item__id._const_tab_at = None
    ___SecondaryULFrequencyReport_protocolExtensions__item__id._const_tab_id = 'id'
    ___SecondaryULFrequencyReport_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecondaryULFrequencyReport_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyReport_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyReport_protocolExtensions__item__criticality._const_tab = ____SecondaryULFrequencyReport_protocolExtensions__item__criticality_tab
    ___SecondaryULFrequencyReport_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryULFrequencyReport_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecondaryULFrequencyReport_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyReport_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue._const_tab = ____SecondaryULFrequencyReport_protocolExtensions__item__extensionValue_tab
    ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SecondaryULFrequencyReport_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SecondaryULFrequencyReport_protocolExtensions__item__id),
        ('criticality', ___SecondaryULFrequencyReport_protocolExtensions__item__criticality),
        ('extensionValue', ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue),
        ])
    __SecondaryULFrequencyReport_protocolExtensions__item_._ext = None
    _SecondaryULFrequencyReport_protocolExtensions._cont = __SecondaryULFrequencyReport_protocolExtensions__item_
    _SecondaryULFrequencyReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryULFrequencyReport._cont = ASN1Dict([
        ('protocolIEs', _SecondaryULFrequencyReport_protocolIEs),
        ('protocolExtensions', _SecondaryULFrequencyReport_protocolExtensions),
        ])
    SecondaryULFrequencyReport._ext = []
    
    #-----< SecondaryULFrequencyReport-IEs >-----#
    SecondaryULFrequencyReport_IEs = CLASS(name='SecondaryULFrequencyReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SecondaryULFrequencyReport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'NodeB-CommunicationContextID')))
    _SecondaryULFrequencyReport_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ActivationInformation')))
    SecondaryULFrequencyReport_IEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Value', _SecondaryULFrequencyReport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1119), ('criticality', 'ignore'), ('Value', _SecondaryULFrequencyReport_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SecondaryULFrequencyReport-Extensions >-----#
    SecondaryULFrequencyReport_Extensions = CLASS(name='SecondaryULFrequencyReport-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SecondaryULFrequencyReport_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryULFrequencyUpdateIndication >-----#
    SecondaryULFrequencyUpdateIndication = SEQ(name='SecondaryULFrequencyUpdateIndication', mode=MODE_TYPE)
    _SecondaryULFrequencyUpdateIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __SecondaryULFrequencyUpdateIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ActivationInformation')))
    ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1119), ('criticality', 'ignore'), ('Value', _____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id._const_tab_at = None
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __SecondaryULFrequencyUpdateIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id),
        ('criticality', ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality),
        ('value', ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value),
        ])
    __SecondaryULFrequencyUpdateIndication_protocolIEs__item_._ext = None
    _SecondaryULFrequencyUpdateIndication_protocolIEs._cont = __SecondaryULFrequencyUpdateIndication_protocolIEs__item_
    _SecondaryULFrequencyUpdateIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SecondaryULFrequencyUpdateIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryULFrequencyUpdateIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id_tab
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id._const_tab_at = None
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality_tab
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue_tab
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SecondaryULFrequencyUpdateIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id),
        ('criticality', ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue),
        ])
    __SecondaryULFrequencyUpdateIndication_protocolExtensions__item_._ext = None
    _SecondaryULFrequencyUpdateIndication_protocolExtensions._cont = __SecondaryULFrequencyUpdateIndication_protocolExtensions__item_
    _SecondaryULFrequencyUpdateIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryULFrequencyUpdateIndication._cont = ASN1Dict([
        ('protocolIEs', _SecondaryULFrequencyUpdateIndication_protocolIEs),
        ('protocolExtensions', _SecondaryULFrequencyUpdateIndication_protocolExtensions),
        ])
    SecondaryULFrequencyUpdateIndication._ext = []
    
    #-----< SecondaryULFrequencyUpdateIndication-IEs >-----#
    SecondaryULFrequencyUpdateIndication_IEs = CLASS(name='SecondaryULFrequencyUpdateIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _SecondaryULFrequencyUpdateIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'CRNC-CommunicationContextID')))
    _SecondaryULFrequencyUpdateIndication_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ActivationInformation')))
    SecondaryULFrequencyUpdateIndication_IEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'ignore'), ('Value', _SecondaryULFrequencyUpdateIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1119), ('criticality', 'ignore'), ('Value', _SecondaryULFrequencyUpdateIndication_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SecondaryULFrequencyUpdateIndication-Extensions >-----#
    SecondaryULFrequencyUpdateIndication_Extensions = CLASS(name='SecondaryULFrequencyUpdateIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    SecondaryULFrequencyUpdateIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEStatusUpdateConfirmRequest >-----#
    UEStatusUpdateConfirmRequest = SEQ(name='UEStatusUpdateConfirmRequest', mode=MODE_TYPE)
    _UEStatusUpdateConfirmRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __UEStatusUpdateConfirmRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____UEStatusUpdateConfirmRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____UEStatusUpdateConfirmRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-ERNTI-Status-Information')))
    ____UEStatusUpdateConfirmRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 993), ('criticality', 'ignore'), ('Value', _____UEStatusUpdateConfirmRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__id._const_tab = ____UEStatusUpdateConfirmRequest_protocolIEs__item__id_tab
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__id._const_tab_at = None
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__criticality._const_tab = ____UEStatusUpdateConfirmRequest_protocolIEs__item__id_tab
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__value._const_tab = ____UEStatusUpdateConfirmRequest_protocolIEs__item__id_tab
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEStatusUpdateConfirmRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEStatusUpdateConfirmRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEStatusUpdateConfirmRequest_protocolIEs__item__id),
        ('criticality', ___UEStatusUpdateConfirmRequest_protocolIEs__item__criticality),
        ('value', ___UEStatusUpdateConfirmRequest_protocolIEs__item__value),
        ])
    __UEStatusUpdateConfirmRequest_protocolIEs__item_._ext = None
    _UEStatusUpdateConfirmRequest_protocolIEs._cont = __UEStatusUpdateConfirmRequest_protocolIEs__item_
    _UEStatusUpdateConfirmRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UEStatusUpdateConfirmRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEStatusUpdateConfirmRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UEStatusUpdateConfirmRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UEStatusUpdateConfirmRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__id._const_tab = ____UEStatusUpdateConfirmRequest_protocolExtensions__item__id_tab
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__id._const_tab_at = None
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEStatusUpdateConfirmRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UEStatusUpdateConfirmRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__criticality._const_tab = ____UEStatusUpdateConfirmRequest_protocolExtensions__item__criticality_tab
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEStatusUpdateConfirmRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UEStatusUpdateConfirmRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__extensionValue._const_tab = ____UEStatusUpdateConfirmRequest_protocolExtensions__item__extensionValue_tab
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEStatusUpdateConfirmRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UEStatusUpdateConfirmRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UEStatusUpdateConfirmRequest_protocolExtensions__item__id),
        ('criticality', ___UEStatusUpdateConfirmRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___UEStatusUpdateConfirmRequest_protocolExtensions__item__extensionValue),
        ])
    __UEStatusUpdateConfirmRequest_protocolExtensions__item_._ext = None
    _UEStatusUpdateConfirmRequest_protocolExtensions._cont = __UEStatusUpdateConfirmRequest_protocolExtensions__item_
    _UEStatusUpdateConfirmRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEStatusUpdateConfirmRequest._cont = ASN1Dict([
        ('protocolIEs', _UEStatusUpdateConfirmRequest_protocolIEs),
        ('protocolExtensions', _UEStatusUpdateConfirmRequest_protocolExtensions),
        ])
    UEStatusUpdateConfirmRequest._ext = []
    
    #-----< UEStatusUpdateConfirmRequest-IEs >-----#
    UEStatusUpdateConfirmRequest_IEs = CLASS(name='UEStatusUpdateConfirmRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UEStatusUpdateConfirmRequest_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'Cell-ERNTI-Status-Information')))
    UEStatusUpdateConfirmRequest_IEs._val = ASN1Set(rv=[dict([('id', 993), ('criticality', 'ignore'), ('Value', _UEStatusUpdateConfirmRequest_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEStatusUpdateConfirmRequest-Extensions >-----#
    UEStatusUpdateConfirmRequest_Extensions = CLASS(name='UEStatusUpdateConfirmRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UEStatusUpdateConfirmRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEStatusUpdateConfirmResponse >-----#
    UEStatusUpdateConfirmResponse = SEQ(name='UEStatusUpdateConfirmResponse', mode=MODE_TYPE)
    _UEStatusUpdateConfirmResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Container')))
    __UEStatusUpdateConfirmResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolIE-Field')))
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['id']))
    ____UEStatusUpdateConfirmResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _____UEStatusUpdateConfirmResponse_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ERNTI-Release-Status')))
    ____UEStatusUpdateConfirmResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1203), ('criticality', 'ignore'), ('Value', _____UEStatusUpdateConfirmResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__id._const_tab = ____UEStatusUpdateConfirmResponse_protocolIEs__item__id_tab
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__id._const_tab_at = None
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['criticality']))
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__criticality._const_tab = ____UEStatusUpdateConfirmResponse_protocolIEs__item__id_tab
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-IES'), ['Value']))
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__value._const_tab = ____UEStatusUpdateConfirmResponse_protocolIEs__item__id_tab
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEStatusUpdateConfirmResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UEStatusUpdateConfirmResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEStatusUpdateConfirmResponse_protocolIEs__item__id),
        ('criticality', ___UEStatusUpdateConfirmResponse_protocolIEs__item__criticality),
        ('value', ___UEStatusUpdateConfirmResponse_protocolIEs__item__value),
        ])
    __UEStatusUpdateConfirmResponse_protocolIEs__item_._ext = None
    _UEStatusUpdateConfirmResponse_protocolIEs._cont = __UEStatusUpdateConfirmResponse_protocolIEs__item_
    _UEStatusUpdateConfirmResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UEStatusUpdateConfirmResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEStatusUpdateConfirmResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-Containers', 'ProtocolExtensionField')))
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['id']))
    ____UEStatusUpdateConfirmResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UEStatusUpdateConfirmResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__id._const_tab = ____UEStatusUpdateConfirmResponse_protocolExtensions__item__id_tab
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__id._const_tab_at = None
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEStatusUpdateConfirmResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UEStatusUpdateConfirmResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__criticality._const_tab = ____UEStatusUpdateConfirmResponse_protocolExtensions__item__criticality_tab
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEStatusUpdateConfirmResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_NBAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    ____UEStatusUpdateConfirmResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__extensionValue._const_tab = ____UEStatusUpdateConfirmResponse_protocolExtensions__item__extensionValue_tab
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEStatusUpdateConfirmResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UEStatusUpdateConfirmResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UEStatusUpdateConfirmResponse_protocolExtensions__item__id),
        ('criticality', ___UEStatusUpdateConfirmResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___UEStatusUpdateConfirmResponse_protocolExtensions__item__extensionValue),
        ])
    __UEStatusUpdateConfirmResponse_protocolExtensions__item_._ext = None
    _UEStatusUpdateConfirmResponse_protocolExtensions._cont = __UEStatusUpdateConfirmResponse_protocolExtensions__item_
    _UEStatusUpdateConfirmResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEStatusUpdateConfirmResponse._cont = ASN1Dict([
        ('protocolIEs', _UEStatusUpdateConfirmResponse_protocolIEs),
        ('protocolExtensions', _UEStatusUpdateConfirmResponse_protocolExtensions),
        ])
    UEStatusUpdateConfirmResponse._ext = []
    
    #-----< UEStatusUpdateConfirmResponse-IEs >-----#
    UEStatusUpdateConfirmResponse_IEs = CLASS(name='UEStatusUpdateConfirmResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-IES')))
    _UEStatusUpdateConfirmResponse_IEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-IEs', 'ERNTI-Release-Status')))
    UEStatusUpdateConfirmResponse_IEs._val = ASN1Set(rv=[dict([('id', 1203), ('criticality', 'ignore'), ('Value', _UEStatusUpdateConfirmResponse_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEStatusUpdateConfirmResponse-Extensions >-----#
    UEStatusUpdateConfirmResponse_Extensions = CLASS(name='UEStatusUpdateConfirmResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('NBAP-Containers', 'NBAP-PROTOCOL-EXTENSION')))
    UEStatusUpdateConfirmResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        ____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab,
        _____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1,
        _____CommonTransportChannelSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2,
        ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__id,
        ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__criticality,
        ___CommonTransportChannelSetupRequestFDD_protocolIEs__item__value,
        __CommonTransportChannelSetupRequestFDD_protocolIEs__item_,
        _CommonTransportChannelSetupRequestFDD_protocolIEs,
        ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__id_tab,
        ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__id,
        ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__criticality_tab,
        ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__criticality,
        ____CommonTransportChannelSetupRequestFDD_protocolExtensions__item__extensionValue_tab,
        ___CommonTransportChannelSetupRequestFDD_protocolExtensions__item__extensionValue,
        __CommonTransportChannelSetupRequestFDD_protocolExtensions__item_,
        _CommonTransportChannelSetupRequestFDD_protocolExtensions,
        CommonTransportChannelSetupRequestFDD,
        CommonTransportChannelSetupRequestFDD_Extensions,
        CommonTransportChannelSetupRequestFDD_IEs,
        _CommonTransportChannelSetupRequestFDD_IEs_val_Value_0,
        _CommonTransportChannelSetupRequestFDD_IEs_val_Value_1,
        _CommonTransportChannelSetupRequestFDD_IEs_val_Value_2,
        _CommonPhysicalChannelType_CTCH_SetupRqstFDD_secondary_CCPCH_parameters,
        _CommonPhysicalChannelType_CTCH_SetupRqstFDD_pRACH_parameters,
        _CommonPhysicalChannelType_CTCH_SetupRqstFDD_notUsed_pCPCHes_parameters,
        CommonPhysicalChannelType_CTCH_SetupRqstFDD,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_commonPhysicalChannelID,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_fdd_S_CCPCH_Offset,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_dl_ScramblingCode,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_fdd_DL_ChannelisationCodeNumber,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_tFCS,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_secondary_CCPCH_SlotFormat,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_tFCI_Presence,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_multiplexingPosition,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_powerOffsetInformation,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_sTTD_Indicator,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_fACH_Parameters,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_pCH_Parameters,
        ____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab,
        _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__id,
        ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality,
        ___Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions__item_,
        _Secondary_CCPCH_CTCH_SetupRqstFDD_iE_Extensions,
        Secondary_CCPCH_CTCH_SetupRqstFDD,
        Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs,
        _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0,
        _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1,
        _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2,
        _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_3,
        _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_4,
        _Secondary_CCPCHItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_5,
        _PowerOffsetInformation_CTCH_SetupRqstFDD_pO1_ForTFCI_Bits,
        _PowerOffsetInformation_CTCH_SetupRqstFDD_pO3_ForPilotBits,
        ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__id,
        ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__criticality,
        ____PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions__item_,
        _PowerOffsetInformation_CTCH_SetupRqstFDD_iE_Extensions,
        PowerOffsetInformation_CTCH_SetupRqstFDD,
        PowerOffsetInformation_CTCH_SetupRqstFDD_ExtIEs,
        __FACH_ParametersList_CTCH_SetupRqstFDD_id_tab,
        ___FACH_ParametersList_CTCH_SetupRqstFDD_id_tab_val_Value_0,
        _FACH_ParametersList_CTCH_SetupRqstFDD_id,
        _FACH_ParametersList_CTCH_SetupRqstFDD_criticality,
        _FACH_ParametersList_CTCH_SetupRqstFDD_value,
        FACH_ParametersList_CTCH_SetupRqstFDD,
        FACH_ParametersListIEs_CTCH_SetupRqstFDD,
        _FACH_ParametersListIEs_CTCH_SetupRqstFDD_val_Value_0,
        _FACH_ParametersListIE_CTCH_SetupRqstFDD__item_,
        FACH_ParametersListIE_CTCH_SetupRqstFDD,
        _FACH_ParametersItem_CTCH_SetupRqstFDD_commonTransportChannelID,
        _FACH_ParametersItem_CTCH_SetupRqstFDD_transportFormatSet,
        _FACH_ParametersItem_CTCH_SetupRqstFDD_toAWS,
        _FACH_ParametersItem_CTCH_SetupRqstFDD_toAWE,
        _FACH_ParametersItem_CTCH_SetupRqstFDD_maxFACH_Power,
        ____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab,
        _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4,
        ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id,
        ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality,
        ___FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_,
        _FACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions,
        FACH_ParametersItem_CTCH_SetupRqstFDD,
        FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs,
        _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0,
        _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1,
        _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2,
        _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_3,
        _FACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_4,
        __PCH_Parameters_CTCH_SetupRqstFDD_id_tab,
        ___PCH_Parameters_CTCH_SetupRqstFDD_id_tab_val_Value_0,
        _PCH_Parameters_CTCH_SetupRqstFDD_id,
        _PCH_Parameters_CTCH_SetupRqstFDD_criticality,
        _PCH_Parameters_CTCH_SetupRqstFDD_value,
        PCH_Parameters_CTCH_SetupRqstFDD,
        PCH_ParametersIE_CTCH_SetupRqstFDD,
        _PCH_ParametersIE_CTCH_SetupRqstFDD_val_Value_0,
        _PCH_ParametersItem_CTCH_SetupRqstFDD_commonTransportChannelID,
        _PCH_ParametersItem_CTCH_SetupRqstFDD_transportFormatSet,
        _PCH_ParametersItem_CTCH_SetupRqstFDD_toAWS,
        _PCH_ParametersItem_CTCH_SetupRqstFDD_toAWE,
        _PCH_ParametersItem_CTCH_SetupRqstFDD_pCH_Power,
        _PCH_ParametersItem_CTCH_SetupRqstFDD_pICH_Parameters,
        ____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab,
        _____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2,
        ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id,
        ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality,
        ___PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_,
        _PCH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions,
        PCH_ParametersItem_CTCH_SetupRqstFDD,
        PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs,
        _PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0,
        _PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1,
        _PCH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2,
        _PICH_Parameters_CTCH_SetupRqstFDD_commonPhysicalChannelID,
        _PICH_Parameters_CTCH_SetupRqstFDD_fdd_dl_ChannelisationCodeNumber,
        _PICH_Parameters_CTCH_SetupRqstFDD_pICH_Power,
        _PICH_Parameters_CTCH_SetupRqstFDD_pICH_Mode,
        _PICH_Parameters_CTCH_SetupRqstFDD_sTTD_Indicator,
        ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id,
        ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality,
        ____PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_,
        _PICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions,
        PICH_Parameters_CTCH_SetupRqstFDD,
        PICH_Parameters_CTCH_SetupRqstFDD_ExtIEs,
        _MICH_Parameters_CTCH_SetupRqstFDD_commonPhysicalChannelID,
        _MICH_Parameters_CTCH_SetupRqstFDD_fdd_dl_ChannelisationCodeNumber,
        _MICH_Parameters_CTCH_SetupRqstFDD_mICH_Power,
        _MICH_Parameters_CTCH_SetupRqstFDD_mICH_Mode,
        _MICH_Parameters_CTCH_SetupRqstFDD_sTTD_Indicator,
        ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id,
        ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality,
        ____MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_,
        _MICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions,
        MICH_Parameters_CTCH_SetupRqstFDD,
        MICH_Parameters_CTCH_SetupRqstFDD_ExtIEs,
        _PRACH_CTCH_SetupRqstFDD_commonPhysicalChannelID,
        _PRACH_CTCH_SetupRqstFDD_scramblingCodeNumber,
        _PRACH_CTCH_SetupRqstFDD_tFCS,
        _PRACH_CTCH_SetupRqstFDD_preambleSignatures,
        _PRACH_CTCH_SetupRqstFDD_allowedSlotFormatInformation,
        _PRACH_CTCH_SetupRqstFDD_rACH_SubChannelNumbers,
        _PRACH_CTCH_SetupRqstFDD_ul_punctureLimit,
        _PRACH_CTCH_SetupRqstFDD_preambleThreshold,
        _PRACH_CTCH_SetupRqstFDD_rACH_Parameters,
        _PRACH_CTCH_SetupRqstFDD_aICH_Parameters,
        ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__id,
        ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__criticality,
        ____PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PRACH_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __PRACH_CTCH_SetupRqstFDD_iE_Extensions__item_,
        _PRACH_CTCH_SetupRqstFDD_iE_Extensions,
        PRACH_CTCH_SetupRqstFDD,
        PRACHItem_CTCH_SetupRqstFDD_ExtIEs,
        _AllowedSlotFormatInformationList_CTCH_SetupRqstFDD__item_,
        AllowedSlotFormatInformationList_CTCH_SetupRqstFDD,
        _AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_rACHSlotFormat,
        ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__id,
        ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality,
        ____AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions__item_,
        _AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_iE_Extensions,
        AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD,
        AllowedSlotFormatInformationItem_CTCH_SetupRqstFDD_ExtIEs,
        __RACH_Parameters_CTCH_SetupRqstFDD_id_tab,
        ___RACH_Parameters_CTCH_SetupRqstFDD_id_tab_val_Value_0,
        _RACH_Parameters_CTCH_SetupRqstFDD_id,
        _RACH_Parameters_CTCH_SetupRqstFDD_criticality,
        _RACH_Parameters_CTCH_SetupRqstFDD_value,
        RACH_Parameters_CTCH_SetupRqstFDD,
        RACH_ParametersIE_CTCH_SetupRqstFDD,
        _RACH_ParametersIE_CTCH_SetupRqstFDD_val_Value_0,
        _RACH_ParametersItem_CTCH_SetupRqstFDD_commonTransportChannelID,
        _RACH_ParametersItem_CTCH_SetupRqstFDD_transportFormatSet,
        ____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab,
        _____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2,
        ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__id,
        ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__criticality,
        ___RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions__item_,
        _RACH_ParametersItem_CTCH_SetupRqstFDD_iE_Extensions,
        RACH_ParametersItem_CTCH_SetupRqstFDD,
        RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs,
        _RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_0,
        _RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_1,
        _RACH_ParametersItem_CTCH_SetupRqstFDD_ExtIEs_val_Extension_2,
        _AICH_Parameters_CTCH_SetupRqstFDD_commonPhysicalChannelID,
        _AICH_Parameters_CTCH_SetupRqstFDD_aICH_TransmissionTiming,
        _AICH_Parameters_CTCH_SetupRqstFDD_fdd_dl_ChannelisationCodeNumber,
        _AICH_Parameters_CTCH_SetupRqstFDD_aICH_Power,
        _AICH_Parameters_CTCH_SetupRqstFDD_sTTD_Indicator,
        ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__id,
        ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__criticality,
        ____AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions__item_,
        _AICH_Parameters_CTCH_SetupRqstFDD_iE_Extensions,
        AICH_Parameters_CTCH_SetupRqstFDD,
        AICH_Parameters_CTCH_SetupRqstFDD_ExtIEs,
        ____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab,
        _____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____CommonTransportChannelSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__id,
        ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__criticality,
        ___CommonTransportChannelSetupRequestTDD_protocolIEs__item__value,
        __CommonTransportChannelSetupRequestTDD_protocolIEs__item_,
        _CommonTransportChannelSetupRequestTDD_protocolIEs,
        ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__id_tab,
        ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__id,
        ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__criticality_tab,
        ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__criticality,
        ____CommonTransportChannelSetupRequestTDD_protocolExtensions__item__extensionValue_tab,
        ___CommonTransportChannelSetupRequestTDD_protocolExtensions__item__extensionValue,
        __CommonTransportChannelSetupRequestTDD_protocolExtensions__item_,
        _CommonTransportChannelSetupRequestTDD_protocolExtensions,
        CommonTransportChannelSetupRequestTDD,
        CommonTransportChannelSetupRequestTDD_IEs,
        _CommonTransportChannelSetupRequestTDD_IEs_val_Value_0,
        _CommonTransportChannelSetupRequestTDD_IEs_val_Value_1,
        _CommonTransportChannelSetupRequestTDD_IEs_val_Value_2,
        CommonTransportChannelSetupRequestTDD_Extensions,
        _CommonPhysicalChannelType_CTCH_SetupRqstTDD_secondary_CCPCH_parameters,
        _CommonPhysicalChannelType_CTCH_SetupRqstTDD_pRACH_parameters,
        _CommonPhysicalChannelType_CTCH_SetupRqstTDD_extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD,
        CommonPhysicalChannelType_CTCH_SetupRqstTDD,
        __Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab,
        ___Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab_val_Value_0,
        ___Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab_val_Value_1,
        ___Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id_tab_val_Value_2,
        _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_id,
        _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_criticality,
        _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD_value,
        Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDD,
        Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE,
        _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE_val_Value_0,
        _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE_val_Value_1,
        _Extension_CommonPhysicalChannelType_CTCH_SetupRqstTDDIE_val_Value_2,
        _Secondary_CCPCH_CTCH_SetupRqstTDD_sCCPCH_CCTrCH_ID,
        _Secondary_CCPCH_CTCH_SetupRqstTDD_tFCS,
        _Secondary_CCPCH_CTCH_SetupRqstTDD_tFCI_Coding,
        _Secondary_CCPCH_CTCH_SetupRqstTDD_punctureLimit,
        _Secondary_CCPCH_CTCH_SetupRqstTDD_secondaryCCPCH_parameterList,
        _Secondary_CCPCH_CTCH_SetupRqstTDD_fACH_ParametersList,
        _Secondary_CCPCH_CTCH_SetupRqstTDD_pCH_Parameters,
        ____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_7,
        ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ___Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _Secondary_CCPCH_CTCH_SetupRqstTDD_iE_Extensions,
        Secondary_CCPCH_CTCH_SetupRqstTDD,
        Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs,
        _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0,
        _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1,
        _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2,
        _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_3,
        _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_4,
        _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_5,
        _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_6,
        _Secondary_CCPCHItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_7,
        __Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab,
        ___Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab_val_Value_0,
        ___Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id_tab_val_Value_1,
        _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_id,
        _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_criticality,
        _Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD_value,
        Secondary_CCPCH_parameterList_CTCH_SetupRqstTDD,
        Secondary_CCPCH_parameterListIEs_CTCH_SetupRqstTDD,
        _Secondary_CCPCH_parameterListIEs_CTCH_SetupRqstTDD_val_Value_0,
        _Secondary_CCPCH_parameterListIEs_CTCH_SetupRqstTDD_val_Value_1,
        _Secondary_CCPCH_parameterListIE_CTCH_SetupRqstTDD__item_,
        Secondary_CCPCH_parameterListIE_CTCH_SetupRqstTDD,
        _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_commonPhysicalChannelID,
        _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode,
        _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_timeslot,
        _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_midambleShiftandBurstType,
        _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset,
        _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_repetitionPeriod,
        _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_repetitionLength,
        _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_Power,
        ____Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ___Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_iE_Extensions,
        Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD,
        Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_ExtIEs,
        _Secondary_CCPCH_parameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0,
        _Secondary_CCPCH_LCR_parameterList_CTCH_SetupRqstTDD__item_,
        Secondary_CCPCH_LCR_parameterList_CTCH_SetupRqstTDD,
        _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_commonPhysicalChannelID,
        _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR,
        _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_timeslotLCR,
        _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_midambleShiftLCR,
        _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset,
        _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_repetitionPeriod,
        _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_repetitionLength,
        _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_Power,
        _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_TimeSlotFormat_LCR,
        ____Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ___Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_iE_Extensions,
        Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD,
        Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_ExtIEs,
        _Secondary_CCPCH_LCR_parameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0,
        _Secondary_CCPCH_768_parameterList_CTCH_SetupRqstTDD__item_,
        Secondary_CCPCH_768_parameterList_CTCH_SetupRqstTDD,
        _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_commonPhysicalChannelID768,
        _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode768,
        _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_timeslot,
        _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_tFCI_Presence768,
        _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_midambleShiftandBurstType768,
        _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset,
        _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_repetitionPeriod,
        _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_repetitionLength,
        _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_s_CCPCH_Power,
        ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ____Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD_iE_Extensions,
        Secondary_CCPCH_768_parameterItem_CTCH_SetupRqstTDD,
        Secondary_CCPCH_parameterItem_768_CTCH_SetupRqstTDD_ExtIEs,
        __FACH_ParametersList_CTCH_SetupRqstTDD_id_tab,
        ___FACH_ParametersList_CTCH_SetupRqstTDD_id_tab_val_Value_0,
        _FACH_ParametersList_CTCH_SetupRqstTDD_id,
        _FACH_ParametersList_CTCH_SetupRqstTDD_criticality,
        _FACH_ParametersList_CTCH_SetupRqstTDD_value,
        FACH_ParametersList_CTCH_SetupRqstTDD,
        FACH_ParametersListIEs_CTCH_SetupRqstTDD,
        _FACH_ParametersListIEs_CTCH_SetupRqstTDD_val_Value_0,
        _FACH_ParametersListIE_CTCH_SetupRqstTDD__item_,
        FACH_ParametersListIE_CTCH_SetupRqstTDD,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_commonTransportChannelID,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_fACH_CCTrCH_ID,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_dl_TransportFormatSet,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_toAWS,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_toAWE,
        ____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ___FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions,
        FACH_ParametersItem_CTCH_SetupRqstTDD,
        FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_3,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_4,
        _FACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_5,
        __PCH_Parameters_CTCH_SetupRqstTDD_id_tab,
        ___PCH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_0,
        _PCH_Parameters_CTCH_SetupRqstTDD_id,
        _PCH_Parameters_CTCH_SetupRqstTDD_criticality,
        _PCH_Parameters_CTCH_SetupRqstTDD_value,
        PCH_Parameters_CTCH_SetupRqstTDD,
        PCH_ParametersIE_CTCH_SetupRqstTDD,
        _PCH_ParametersIE_CTCH_SetupRqstTDD_val_Value_0,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_commonTransportChannelID,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_pCH_CCTrCH_ID,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_dl_TransportFormatSet,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_toAWS,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_toAWE,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_pICH_Parameters,
        ____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4,
        ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ___PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions,
        PCH_ParametersItem_CTCH_SetupRqstTDD,
        PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_3,
        _PCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_4,
        __PICH_Parameters_CTCH_SetupRqstTDD_id_tab,
        ___PICH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_0,
        ___PICH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_1,
        _PICH_Parameters_CTCH_SetupRqstTDD_id,
        _PICH_Parameters_CTCH_SetupRqstTDD_criticality,
        _PICH_Parameters_CTCH_SetupRqstTDD_value,
        PICH_Parameters_CTCH_SetupRqstTDD,
        PICH_ParametersIE_CTCH_SetupRqstTDD,
        _PICH_ParametersIE_CTCH_SetupRqstTDD_val_Value_0,
        _PICH_ParametersIE_CTCH_SetupRqstTDD_val_Value_1,
        _PICH_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID,
        _PICH_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode,
        _PICH_ParametersItem_CTCH_SetupRqstTDD_timeSlot,
        _PICH_ParametersItem_CTCH_SetupRqstTDD_midambleshiftAndBurstType,
        _PICH_ParametersItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset,
        _PICH_ParametersItem_CTCH_SetupRqstTDD_repetitionPeriod,
        _PICH_ParametersItem_CTCH_SetupRqstTDD_repetitionLength,
        _PICH_ParametersItem_CTCH_SetupRqstTDD_pagingIndicatorLength,
        _PICH_ParametersItem_CTCH_SetupRqstTDD_pICH_Power,
        ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ____PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _PICH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions,
        PICH_ParametersItem_CTCH_SetupRqstTDD,
        PICH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        _PICH_LCR_Parameters_CTCH_SetupRqstTDD_commonPhysicalChannelID,
        _PICH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR,
        _PICH_LCR_Parameters_CTCH_SetupRqstTDD_timeSlotLCR,
        _PICH_LCR_Parameters_CTCH_SetupRqstTDD_midambleShiftLCR,
        _PICH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset,
        _PICH_LCR_Parameters_CTCH_SetupRqstTDD_repetitionPeriod,
        _PICH_LCR_Parameters_CTCH_SetupRqstTDD_repetitionLength,
        _PICH_LCR_Parameters_CTCH_SetupRqstTDD_pagingIndicatorLength,
        _PICH_LCR_Parameters_CTCH_SetupRqstTDD_pICH_Power,
        _PICH_LCR_Parameters_CTCH_SetupRqstTDD_second_TDD_ChannelisationCodeLCR,
        ____PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ___PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _PICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions,
        PICH_LCR_Parameters_CTCH_SetupRqstTDD,
        PICH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        _PICH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0,
        _PICH_768_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID768,
        _PICH_768_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode768,
        _PICH_768_ParametersItem_CTCH_SetupRqstTDD_timeSlot,
        _PICH_768_ParametersItem_CTCH_SetupRqstTDD_midambleshiftAndBurstType78,
        _PICH_768_ParametersItem_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset,
        _PICH_768_ParametersItem_CTCH_SetupRqstTDD_repetitionPeriod,
        _PICH_768_ParametersItem_CTCH_SetupRqstTDD_repetitionLength,
        _PICH_768_ParametersItem_CTCH_SetupRqstTDD_pagingIndicatorLength,
        _PICH_768_ParametersItem_CTCH_SetupRqstTDD_pICH_Power,
        ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ____PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _PICH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions,
        PICH_768_ParametersItem_CTCH_SetupRqstTDD,
        PICH_768_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        _MICH_Parameters_CTCH_SetupRqstTDD_commonPhysicalChannelID,
        _MICH_Parameters_CTCH_SetupRqstTDD_tdd_PhysicalChannelOffset,
        _MICH_Parameters_CTCH_SetupRqstTDD_repetitionPeriod,
        _MICH_Parameters_CTCH_SetupRqstTDD_repetitionLength,
        _MICH_Parameters_CTCH_SetupRqstTDD_notificationIndicatorLength,
        _MICH_Parameters_CTCH_SetupRqstTDD_mICH_Power,
        _MICH_Parameters_CTCH_SetupRqstTDD_mICH_TDDOption_Specific_Parameters,
        ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ____MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _MICH_Parameters_CTCH_SetupRqstTDD_iE_Extensions,
        MICH_Parameters_CTCH_SetupRqstTDD,
        MICH_Parameters_CTCH_SetupRqstTDD_ExtIEs,
        _MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD_hCR_TDD,
        _MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD_lCR_TDD,
        _MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD_cHipRate768_TDD,
        MICH_TDDOption_Specific_Parameters_CTCH_SetupRqstTDD,
        _MICH_HCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCode,
        _MICH_HCR_Parameters_CTCH_SetupRqstTDD_timeSlot,
        _MICH_HCR_Parameters_CTCH_SetupRqstTDD_midambleshiftAndBurstType,
        ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ____MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _MICH_HCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions,
        MICH_HCR_Parameters_CTCH_SetupRqstTDD,
        MICH_HCR_Parameters_CTCH_SetupRqstTDD_ExtIEs,
        _MICH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR,
        _MICH_LCR_Parameters_CTCH_SetupRqstTDD_timeSlotLCR,
        _MICH_LCR_Parameters_CTCH_SetupRqstTDD_midambleShiftLCR,
        _MICH_LCR_Parameters_CTCH_SetupRqstTDD_second_TDD_ChannelisationCodeLCR,
        _MICH_LCR_Parameters_CTCH_SetupRqstTDD_tSTD_Indicator,
        ____MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ___MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _MICH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions,
        MICH_LCR_Parameters_CTCH_SetupRqstTDD,
        MICH_LCR_Parameters_CTCH_SetupRqstTDD_ExtIEs,
        _MICH_LCR_Parameters_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0,
        _MICH_768_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCode768,
        _MICH_768_Parameters_CTCH_SetupRqstTDD_timeSlot,
        _MICH_768_Parameters_CTCH_SetupRqstTDD_midambleshiftAndBurstType768,
        ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ____MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _MICH_768_Parameters_CTCH_SetupRqstTDD_iE_Extensions,
        MICH_768_Parameters_CTCH_SetupRqstTDD,
        MICH_768_Parameters_CTCH_SetupRqstTDD_ExtIEs,
        _TimeSlotConfigurationList_LCR_CTCH_SetupRqstTDD__item_,
        TimeSlotConfigurationList_LCR_CTCH_SetupRqstTDD,
        _TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_timeslotLCR,
        _TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_timeslotLCR_Parameter_ID,
        ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ____TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_iE_Extensions,
        TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD,
        TimeSlotConfigurationItem_LCR_CTCH_SetupRqstTDD_ExtIEs,
        _Secondary_CCPCH_parameterExtendedList_CTCH_SetupRqstTDD__item_,
        Secondary_CCPCH_parameterExtendedList_CTCH_SetupRqstTDD,
        _Secondary_CCPCH_LCR_parameterExtendedList_CTCH_SetupRqstTDD__item_,
        Secondary_CCPCH_LCR_parameterExtendedList_CTCH_SetupRqstTDD,
        _PRACH_CTCH_SetupRqstTDD_pRACH_Parameters_CTCH_SetupRqstTDD,
        ____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ___PRACH_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __PRACH_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _PRACH_CTCH_SetupRqstTDD_iE_Extensions,
        PRACH_CTCH_SetupRqstTDD,
        PRACH_CTCH_SetupRqstTDD_ExtIEs,
        _PRACH_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0,
        _PRACH_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1,
        __PRACH_Parameters_CTCH_SetupRqstTDD_id_tab,
        ___PRACH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_0,
        ___PRACH_Parameters_CTCH_SetupRqstTDD_id_tab_val_Value_1,
        _PRACH_Parameters_CTCH_SetupRqstTDD_id,
        _PRACH_Parameters_CTCH_SetupRqstTDD_criticality,
        _PRACH_Parameters_CTCH_SetupRqstTDD_value,
        PRACH_Parameters_CTCH_SetupRqstTDD,
        PRACH_ParametersIE_CTCH_SetupRqstTDD,
        _PRACH_ParametersIE_CTCH_SetupRqstTDD_val_Value_0,
        _PRACH_ParametersIE_CTCH_SetupRqstTDD_val_Value_1,
        _PRACH_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID,
        _PRACH_ParametersItem_CTCH_SetupRqstTDD_tFCS,
        _PRACH_ParametersItem_CTCH_SetupRqstTDD_timeslot,
        _PRACH_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode,
        _PRACH_ParametersItem_CTCH_SetupRqstTDD_maxPRACH_MidambleShifts,
        _PRACH_ParametersItem_CTCH_SetupRqstTDD_pRACH_Midamble,
        _PRACH_ParametersItem_CTCH_SetupRqstTDD_rACH,
        ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ____PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _PRACH_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions,
        PRACH_ParametersItem_CTCH_SetupRqstTDD,
        PRACH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        __RACH_Parameter_CTCH_SetupRqstTDD_id_tab,
        ___RACH_Parameter_CTCH_SetupRqstTDD_id_tab_val_Value_0,
        _RACH_Parameter_CTCH_SetupRqstTDD_id,
        _RACH_Parameter_CTCH_SetupRqstTDD_criticality,
        _RACH_Parameter_CTCH_SetupRqstTDD_value,
        RACH_Parameter_CTCH_SetupRqstTDD,
        RACH_ParameterIE_CTCH_SetupRqstTDD,
        _RACH_ParameterIE_CTCH_SetupRqstTDD_val_Value_0,
        _RACH_ParameterItem_CTCH_SetupRqstTDD_commonTransportChannelID,
        _RACH_ParameterItem_CTCH_SetupRqstTDD_uL_TransportFormatSet,
        ____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ___RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _RACH_ParameterItem_CTCH_SetupRqstTDD_iE_Extensions,
        RACH_ParameterItem_CTCH_SetupRqstTDD,
        RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs,
        _RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0,
        _RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_1,
        _RACH_ParameterItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_2,
        _PRACH_LCR_ParametersList_CTCH_SetupRqstTDD__item_,
        PRACH_LCR_ParametersList_CTCH_SetupRqstTDD,
        _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID,
        _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_tFCS,
        _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_timeslotLCR,
        _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR,
        _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_midambleShiftLCR,
        _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_rACH,
        ____PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ___PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions,
        PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD,
        PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        _PRACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0,
        _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_commonPhysicalChannelID768,
        _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_tFCS,
        _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_timeslot,
        _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_tdd_ChannelisationCode768,
        _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_maxPRACH_MidambleShifts,
        _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_pRACH_Midamble,
        _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_rACH,
        ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ____PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _PRACH_768_ParametersItem_CTCH_SetupRqstTDD_iE_Extensions,
        PRACH_768_ParametersItem_CTCH_SetupRqstTDD,
        PRACH_768_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_commonPhysicalChannelID,
        _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_tdd_ChannelisationCodeLCR,
        _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_timeslotLCR,
        _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_midambleShiftLCR,
        _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_fPACH_Power,
        ____FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__id,
        ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__criticality,
        ___FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions__item_,
        _FPACH_LCR_Parameters_CTCH_SetupRqstTDD_iE_Extensions,
        FPACH_LCR_Parameters_CTCH_SetupRqstTDD,
        FPACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        _FPACH_LCR_ParametersItem_CTCH_SetupRqstTDD_ExtIEs_val_Extension_0,
        _PLCCH_parameters_maxPowerPLCCH,
        _PLCCH_parameters_commonPhysicalChannelID,
        _PLCCH_parameters_tdd_ChannelisationCode,
        _PLCCH_parameters_timeslotLCR,
        _PLCCH_parameters_midambleShiftLCR,
        ____PLCCH_parameters_iE_Extensions__item__id_tab,
        ___PLCCH_parameters_iE_Extensions__item__id,
        ____PLCCH_parameters_iE_Extensions__item__criticality_tab,
        ___PLCCH_parameters_iE_Extensions__item__criticality,
        ____PLCCH_parameters_iE_Extensions__item__extensionValue_tab,
        ___PLCCH_parameters_iE_Extensions__item__extensionValue,
        __PLCCH_parameters_iE_Extensions__item_,
        _PLCCH_parameters_iE_Extensions,
        PLCCH_parameters,
        PLCCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        _E_RUCCH_parameters_commonPhysicalChannelID,
        _E_RUCCH_parameters_timeslot,
        _E_RUCCH_parameters_tdd_ChannelisationCode,
        _E_RUCCH_parameters_maxE_RUCCH_MidambleShifts,
        _E_RUCCH_parameters_e_RUCCH_Midamble,
        ____E_RUCCH_parameters_iE_Extensions__item__id_tab,
        ___E_RUCCH_parameters_iE_Extensions__item__id,
        ____E_RUCCH_parameters_iE_Extensions__item__criticality_tab,
        ___E_RUCCH_parameters_iE_Extensions__item__criticality,
        ____E_RUCCH_parameters_iE_Extensions__item__extensionValue_tab,
        ___E_RUCCH_parameters_iE_Extensions__item__extensionValue,
        __E_RUCCH_parameters_iE_Extensions__item_,
        _E_RUCCH_parameters_iE_Extensions,
        E_RUCCH_parameters,
        E_RUCCH_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        _E_RUCCH_768_parameters_commonPhysicalChannelID768,
        _E_RUCCH_768_parameters_timeslot,
        _E_RUCCH_768_parameters_tdd_ChannelisationCode768,
        _E_RUCCH_768_parameters_maxE_RUCCH_MidambleShifts,
        _E_RUCCH_768_parameters_e_RUCCH_Midamble,
        ____E_RUCCH_768_parameters_iE_Extensions__item__id_tab,
        ___E_RUCCH_768_parameters_iE_Extensions__item__id,
        ____E_RUCCH_768_parameters_iE_Extensions__item__criticality_tab,
        ___E_RUCCH_768_parameters_iE_Extensions__item__criticality,
        ____E_RUCCH_768_parameters_iE_Extensions__item__extensionValue_tab,
        ___E_RUCCH_768_parameters_iE_Extensions__item__extensionValue,
        __E_RUCCH_768_parameters_iE_Extensions__item_,
        _E_RUCCH_768_parameters_iE_Extensions,
        E_RUCCH_768_parameters,
        E_RUCCH_768_ParametersItem_CTCH_SetupRqstTDD_ExtIEs,
        ____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab,
        _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____CommonTransportChannelSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___CommonTransportChannelSetupResponse_protocolIEs__item__id,
        ___CommonTransportChannelSetupResponse_protocolIEs__item__criticality,
        ___CommonTransportChannelSetupResponse_protocolIEs__item__value,
        __CommonTransportChannelSetupResponse_protocolIEs__item_,
        _CommonTransportChannelSetupResponse_protocolIEs,
        ____CommonTransportChannelSetupResponse_protocolExtensions__item__id_tab,
        ___CommonTransportChannelSetupResponse_protocolExtensions__item__id,
        ____CommonTransportChannelSetupResponse_protocolExtensions__item__criticality_tab,
        ___CommonTransportChannelSetupResponse_protocolExtensions__item__criticality,
        ____CommonTransportChannelSetupResponse_protocolExtensions__item__extensionValue_tab,
        ___CommonTransportChannelSetupResponse_protocolExtensions__item__extensionValue,
        __CommonTransportChannelSetupResponse_protocolExtensions__item_,
        _CommonTransportChannelSetupResponse_protocolExtensions,
        CommonTransportChannelSetupResponse,
        CommonTransportChannelSetupResponse_IEs,
        _CommonTransportChannelSetupResponse_IEs_val_Value_0,
        _CommonTransportChannelSetupResponse_IEs_val_Value_1,
        _CommonTransportChannelSetupResponse_IEs_val_Value_2,
        _CommonTransportChannelSetupResponse_IEs_val_Value_3,
        _CommonTransportChannelSetupResponse_IEs_val_Value_4,
        CommonTransportChannelSetupResponse_Extensions,
        _FACH_CommonTransportChannel_InformationResponse__item_,
        FACH_CommonTransportChannel_InformationResponse,
        ____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab,
        _____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        ___CommonTransportChannelSetupFailure_protocolIEs__item__id,
        ___CommonTransportChannelSetupFailure_protocolIEs__item__criticality,
        ___CommonTransportChannelSetupFailure_protocolIEs__item__value,
        __CommonTransportChannelSetupFailure_protocolIEs__item_,
        _CommonTransportChannelSetupFailure_protocolIEs,
        ____CommonTransportChannelSetupFailure_protocolExtensions__item__id_tab,
        ___CommonTransportChannelSetupFailure_protocolExtensions__item__id,
        ____CommonTransportChannelSetupFailure_protocolExtensions__item__criticality_tab,
        ___CommonTransportChannelSetupFailure_protocolExtensions__item__criticality,
        ____CommonTransportChannelSetupFailure_protocolExtensions__item__extensionValue_tab,
        ___CommonTransportChannelSetupFailure_protocolExtensions__item__extensionValue,
        __CommonTransportChannelSetupFailure_protocolExtensions__item_,
        _CommonTransportChannelSetupFailure_protocolExtensions,
        CommonTransportChannelSetupFailure,
        CommonTransportChannelSetupFailure_IEs,
        _CommonTransportChannelSetupFailure_IEs_val_Value_0,
        _CommonTransportChannelSetupFailure_IEs_val_Value_1,
        CommonTransportChannelSetupFailure_Extensions,
        ____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab,
        _____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1,
        _____CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2,
        ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__id,
        ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__criticality,
        ___CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item__value,
        __CommonTransportChannelReconfigurationRequestFDD_protocolIEs__item_,
        _CommonTransportChannelReconfigurationRequestFDD_protocolIEs,
        ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab,
        ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__id,
        ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__criticality_tab,
        ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__criticality,
        ____CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue_tab,
        ___CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue,
        __CommonTransportChannelReconfigurationRequestFDD_protocolExtensions__item_,
        _CommonTransportChannelReconfigurationRequestFDD_protocolExtensions,
        CommonTransportChannelReconfigurationRequestFDD,
        CommonTransportChannelReconfigurationRequestFDD_IEs,
        _CommonTransportChannelReconfigurationRequestFDD_IEs_val_Value_0,
        _CommonTransportChannelReconfigurationRequestFDD_IEs_val_Value_1,
        _CommonTransportChannelReconfigurationRequestFDD_IEs_val_Value_2,
        CommonTransportChannelReconfigurationRequestFDD_Extensions,
        _CommonPhysicalChannelType_CTCH_ReconfRqstFDD_secondary_CCPCH_parameters,
        _CommonPhysicalChannelType_CTCH_ReconfRqstFDD_pRACH_parameters,
        _CommonPhysicalChannelType_CTCH_ReconfRqstFDD_notUsed_cPCH_parameters,
        CommonPhysicalChannelType_CTCH_ReconfRqstFDD,
        _Secondary_CCPCHList_CTCH_ReconfRqstFDD_fACH_ParametersList_CTCH_ReconfRqstFDD,
        _Secondary_CCPCHList_CTCH_ReconfRqstFDD_pCH_Parameters_CTCH_ReconfRqstFDD,
        _Secondary_CCPCHList_CTCH_ReconfRqstFDD_pICH_Parameters_CTCH_ReconfRqstFDD,
        ____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab,
        _____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id,
        ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality,
        ___Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions__item_,
        _Secondary_CCPCHList_CTCH_ReconfRqstFDD_iE_Extensions,
        Secondary_CCPCHList_CTCH_ReconfRqstFDD,
        Secondary_CCPCH_CTCH_ReconfRqstFDD_ExtIEs,
        _Secondary_CCPCH_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0,
        _Secondary_CCPCH_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_1,
        __FACH_ParametersList_CTCH_ReconfRqstFDD_id_tab,
        ___FACH_ParametersList_CTCH_ReconfRqstFDD_id_tab_val_Value_0,
        _FACH_ParametersList_CTCH_ReconfRqstFDD_id,
        _FACH_ParametersList_CTCH_ReconfRqstFDD_criticality,
        _FACH_ParametersList_CTCH_ReconfRqstFDD_value,
        FACH_ParametersList_CTCH_ReconfRqstFDD,
        FACH_ParametersListIEs_CTCH_ReconfRqstFDD,
        _FACH_ParametersListIEs_CTCH_ReconfRqstFDD_val_Value_0,
        _FACH_ParametersListIE_CTCH_ReconfRqstFDD__item_,
        FACH_ParametersListIE_CTCH_ReconfRqstFDD,
        _FACH_ParametersItem_CTCH_ReconfRqstFDD_commonTransportChannelID,
        _FACH_ParametersItem_CTCH_ReconfRqstFDD_maxFACH_Power,
        _FACH_ParametersItem_CTCH_ReconfRqstFDD_toAWS,
        _FACH_ParametersItem_CTCH_ReconfRqstFDD_toAWE,
        ____FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab,
        _____FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id,
        ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality,
        ___FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_,
        _FACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions,
        FACH_ParametersItem_CTCH_ReconfRqstFDD,
        FACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs,
        _FACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0,
        __PCH_Parameters_CTCH_ReconfRqstFDD_id_tab,
        ___PCH_Parameters_CTCH_ReconfRqstFDD_id_tab_val_Value_0,
        _PCH_Parameters_CTCH_ReconfRqstFDD_id,
        _PCH_Parameters_CTCH_ReconfRqstFDD_criticality,
        _PCH_Parameters_CTCH_ReconfRqstFDD_value,
        PCH_Parameters_CTCH_ReconfRqstFDD,
        PCH_ParametersIE_CTCH_ReconfRqstFDD,
        _PCH_ParametersIE_CTCH_ReconfRqstFDD_val_Value_0,
        _PCH_ParametersItem_CTCH_ReconfRqstFDD_commonTransportChannelID,
        _PCH_ParametersItem_CTCH_ReconfRqstFDD_pCH_Power,
        _PCH_ParametersItem_CTCH_ReconfRqstFDD_toAWS,
        _PCH_ParametersItem_CTCH_ReconfRqstFDD_toAWE,
        ____PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab,
        _____PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id,
        ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality,
        ___PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_,
        _PCH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions,
        PCH_ParametersItem_CTCH_ReconfRqstFDD,
        PCH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs,
        _PCH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0,
        __PICH_Parameters_CTCH_ReconfRqstFDD_id_tab,
        ___PICH_Parameters_CTCH_ReconfRqstFDD_id_tab_val_Value_0,
        _PICH_Parameters_CTCH_ReconfRqstFDD_id,
        _PICH_Parameters_CTCH_ReconfRqstFDD_criticality,
        _PICH_Parameters_CTCH_ReconfRqstFDD_value,
        PICH_Parameters_CTCH_ReconfRqstFDD,
        PICH_ParametersIE_CTCH_ReconfRqstFDD,
        _PICH_ParametersIE_CTCH_ReconfRqstFDD_val_Value_0,
        _PICH_ParametersItem_CTCH_ReconfRqstFDD_commonPhysicalChannelID,
        _PICH_ParametersItem_CTCH_ReconfRqstFDD_pICH_Power,
        ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id,
        ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_,
        _PICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions,
        PICH_ParametersItem_CTCH_ReconfRqstFDD,
        PICH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs,
        _MICH_Parameters_CTCH_ReconfRqstFDD_commonPhysicalChannelID,
        _MICH_Parameters_CTCH_ReconfRqstFDD_mICH_Power,
        ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id,
        ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item_,
        _MICH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions,
        MICH_Parameters_CTCH_ReconfRqstFDD,
        MICH_Parameters_CTCH_ReconfRqstFDD_ExtIEs,
        _BCH_Parameters_CTCH_ReconfRqstFDD_commonTransportChannelID,
        _BCH_Parameters_CTCH_ReconfRqstFDD_bCH_Power,
        ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__id,
        ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions__item_,
        _BCH_Parameters_CTCH_ReconfRqstFDD_iE_Extensions,
        BCH_Parameters_CTCH_ReconfRqstFDD,
        BCH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs,
        _PRACHList_CTCH_ReconfRqstFDD_pRACH_ParametersList_CTCH_ReconfRqstFDD,
        _PRACHList_CTCH_ReconfRqstFDD_aICH_ParametersList_CTCH_ReconfRqstFDD,
        ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__id,
        ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __PRACHList_CTCH_ReconfRqstFDD_iE_Extensions__item_,
        _PRACHList_CTCH_ReconfRqstFDD_iE_Extensions,
        PRACHList_CTCH_ReconfRqstFDD,
        PRACH_CTCH_ReconfRqstFDD_ExtIEs,
        __PRACH_ParametersList_CTCH_ReconfRqstFDD_id_tab,
        ___PRACH_ParametersList_CTCH_ReconfRqstFDD_id_tab_val_Value_0,
        _PRACH_ParametersList_CTCH_ReconfRqstFDD_id,
        _PRACH_ParametersList_CTCH_ReconfRqstFDD_criticality,
        _PRACH_ParametersList_CTCH_ReconfRqstFDD_value,
        PRACH_ParametersList_CTCH_ReconfRqstFDD,
        PRACH_ParametersListIEs_CTCH_ReconfRqstFDD,
        _PRACH_ParametersListIEs_CTCH_ReconfRqstFDD_val_Value_0,
        _PRACH_ParametersListIE_CTCH_ReconfRqstFDD__item_,
        PRACH_ParametersListIE_CTCH_ReconfRqstFDD,
        _PRACH_ParametersItem_CTCH_ReconfRqstFDD_commonPhysicalChannelID,
        _PRACH_ParametersItem_CTCH_ReconfRqstFDD_preambleSignatures,
        _PRACH_ParametersItem_CTCH_ReconfRqstFDD_allowedSlotFormatInformation,
        _PRACH_ParametersItem_CTCH_ReconfRqstFDD_rACH_SubChannelNumbers,
        ____PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab,
        _____PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id,
        ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality,
        ___PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_,
        _PRACH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions,
        PRACH_ParametersItem_CTCH_ReconfRqstFDD,
        PRACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs,
        _PRACH_ParametersItem_CTCH_ReconfRqstFDD_ExtIEs_val_Extension_0,
        _AllowedSlotFormatInformationList_CTCH_ReconfRqstFDD__item_,
        AllowedSlotFormatInformationList_CTCH_ReconfRqstFDD,
        _AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_rACH_SlotFormat,
        ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id,
        ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions__item_,
        _AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_iE_Extensions,
        AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD,
        AllowedSlotFormatInformationItem_CTCH_ReconfRqstFDD_ExtIEs,
        __AICH_ParametersList_CTCH_ReconfRqstFDD_id_tab,
        ___AICH_ParametersList_CTCH_ReconfRqstFDD_id_tab_val_Value_0,
        _AICH_ParametersList_CTCH_ReconfRqstFDD_id,
        _AICH_ParametersList_CTCH_ReconfRqstFDD_criticality,
        _AICH_ParametersList_CTCH_ReconfRqstFDD_value,
        AICH_ParametersList_CTCH_ReconfRqstFDD,
        AICH_ParametersListIEs_CTCH_ReconfRqstFDD,
        _AICH_ParametersListIEs_CTCH_ReconfRqstFDD_val_Value_0,
        _AICH_ParametersListIE_CTCH_ReconfRqstFDD__item_,
        AICH_ParametersListIE_CTCH_ReconfRqstFDD,
        _AICH_ParametersItem_CTCH_ReconfRqstFDD_commonPhysicalChannelID,
        _AICH_ParametersItem_CTCH_ReconfRqstFDD_aICH_Power,
        ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__id,
        ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions__item_,
        _AICH_ParametersItem_CTCH_ReconfRqstFDD_iE_Extensions,
        AICH_ParametersItem_CTCH_ReconfRqstFDD,
        AICH_ParametersItemIE_CTCH_ReconfRqstFDD_ExtIEs,
        ____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5,
        ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__id,
        ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__criticality,
        ___CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item__value,
        __CommonTransportChannelReconfigurationRequestTDD_protocolIEs__item_,
        _CommonTransportChannelReconfigurationRequestTDD_protocolIEs,
        ____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6,
        ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__id,
        ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__criticality,
        ___CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue,
        __CommonTransportChannelReconfigurationRequestTDD_protocolExtensions__item_,
        _CommonTransportChannelReconfigurationRequestTDD_protocolExtensions,
        CommonTransportChannelReconfigurationRequestTDD,
        CommonTransportChannelReconfigurationRequestTDD_IEs,
        _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_0,
        _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_1,
        _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_2,
        _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_3,
        _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_4,
        _CommonTransportChannelReconfigurationRequestTDD_IEs_val_Value_5,
        CommonTransportChannelReconfigurationRequestTDD_Extensions,
        _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_0,
        _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_1,
        _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_2,
        _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_3,
        _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_4,
        _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_5,
        _CommonTransportChannelReconfigurationRequestTDD_Extensions_val_Extension_6,
        _Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_cCTrCH_ID,
        _Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_secondaryCCPCHList,
        ____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        _____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ___Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions,
        Secondary_CCPCH_Parameters_CTCH_ReconfRqstTDD,
        Secondary_CCPCH_CTCH_ReconfRqstTDD_ExtIEs,
        _Secondary_CCPCH_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_0,
        _Secondary_CCPCH_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_1,
        __Secondary_CCPCHList_CTCH_ReconfRqstTDD_id_tab,
        ___Secondary_CCPCHList_CTCH_ReconfRqstTDD_id_tab_val_Value_0,
        _Secondary_CCPCHList_CTCH_ReconfRqstTDD_id,
        _Secondary_CCPCHList_CTCH_ReconfRqstTDD_criticality,
        _Secondary_CCPCHList_CTCH_ReconfRqstTDD_value,
        Secondary_CCPCHList_CTCH_ReconfRqstTDD,
        Secondary_CCPCHListIEs_CTCH_ReconfRqstTDD,
        _Secondary_CCPCHListIEs_CTCH_ReconfRqstTDD_val_Value_0,
        _Secondary_CCPCHListIE_CTCH_ReconfRqstTDD__item_,
        Secondary_CCPCHListIE_CTCH_ReconfRqstTDD,
        _Secondary_CCPCHItem_CTCH_ReconfRqstTDD_commonPhysicalChannelID,
        _Secondary_CCPCHItem_CTCH_ReconfRqstTDD_sCCPCH_Power,
        ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _Secondary_CCPCHItem_CTCH_ReconfRqstTDD_iE_Extensions,
        Secondary_CCPCHItem_CTCH_ReconfRqstTDD,
        Secondary_CCPCHItem_CTCH_ReconfRqstTDD_ExtIEs,
        _Secondary_CCPCH_parameterExtendedList_CTCH_ReconfRqstTDD__item_,
        Secondary_CCPCH_parameterExtendedList_CTCH_ReconfRqstTDD,
        _Secondary_CCPCH_LCR_parameterExtendedList_CTCH_ReconfRqstTDD__item_,
        Secondary_CCPCH_LCR_parameterExtendedList_CTCH_ReconfRqstTDD,
        _PICH_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID,
        _PICH_Parameters_CTCH_ReconfRqstTDD_pICH_Power,
        ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _PICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions,
        PICH_Parameters_CTCH_ReconfRqstTDD,
        PICH_Parameters_CTCH_ReconfRqstTDD_ExtIEs,
        _FACH_ParametersList_CTCH_ReconfRqstTDD__item_,
        FACH_ParametersList_CTCH_ReconfRqstTDD,
        _FACH_ParametersItem_CTCH_ReconfRqstTDD_commonTransportChannelID,
        _FACH_ParametersItem_CTCH_ReconfRqstTDD_toAWS,
        _FACH_ParametersItem_CTCH_ReconfRqstTDD_toAWE,
        ____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        _____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ___FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _FACH_ParametersItem_CTCH_ReconfRqstTDD_iE_Extensions,
        FACH_ParametersItem_CTCH_ReconfRqstTDD,
        FACH_ParametersItem_CTCH_ReconfRqstTDD_ExtIEs,
        _FACH_ParametersItem_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_0,
        _FACH_ParametersItem_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_1,
        _PCH_Parameters_CTCH_ReconfRqstTDD_commonTransportChannelID,
        _PCH_Parameters_CTCH_ReconfRqstTDD_toAWS,
        _PCH_Parameters_CTCH_ReconfRqstTDD_toAWE,
        ____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        _____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ___PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _PCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions,
        PCH_Parameters_CTCH_ReconfRqstTDD,
        PCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs,
        _PCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_0,
        _PCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs_val_Extension_1,
        _FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelId,
        _FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_fPACHPower,
        ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions,
        FPACH_LCR_Parameters_CTCH_ReconfRqstTDD,
        FPACH_LCR_Parameters_CTCH_ReconfRqstTDD_ExtIEs,
        _MICH_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID,
        _MICH_Parameters_CTCH_ReconfRqstTDD_mICH_Power,
        ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _MICH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions,
        MICH_Parameters_CTCH_ReconfRqstTDD,
        MICH_Parameters_CTCH_ReconfRqstTDD_ExtIEs,
        _PLCCH_Parameters_CTCH_ReconfRqstTDD_maxPowerPLCCH,
        ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _PLCCH_Parameters_CTCH_ReconfRqstTDD_iE_Extensions,
        PLCCH_Parameters_CTCH_ReconfRqstTDD,
        PLCCH_Parameters_CTCH_ReconfRqstTDD_ExtIEs,
        _Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_cCTrCH_ID,
        _Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_secondaryCCPCH768List,
        ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions,
        Secondary_CCPCH_768_Parameters_CTCH_ReconfRqstTDD,
        Secondary_CCPCH_768_CTCH_ReconfRqstTDD_ExtIEs,
        _Secondary_CCPCH_768_List_CTCH_ReconfRqstTDD__item_,
        Secondary_CCPCH_768_List_CTCH_ReconfRqstTDD,
        _Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_commonPhysicalChannelID768,
        _Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_sCCPCH_Power,
        ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_iE_Extensions,
        Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD,
        Secondary_CCPCH_768_Item_CTCH_ReconfRqstTDD_ExtIEs,
        _PICH_768_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID768,
        _PICH_768_Parameters_CTCH_ReconfRqstTDD_pICH_Power,
        ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _PICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions,
        PICH_768_Parameters_CTCH_ReconfRqstTDD,
        PICH_768_Parameters_CTCH_ReconfRqstTDD_ExtIEs,
        _MICH_768_Parameters_CTCH_ReconfRqstTDD_commonPhysicalChannelID768,
        _MICH_768_Parameters_CTCH_ReconfRqstTDD_mICH_Power,
        ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _MICH_768_Parameters_CTCH_ReconfRqstTDD_iE_Extensions,
        MICH_768_Parameters_CTCH_ReconfRqstTDD,
        MICH_768_Parameters_CTCH_ReconfRqstTDD_ExtIEs,
        _UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_uPPCHPositionLCR,
        _UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_uARFCN,
        ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__id,
        ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions__item_,
        _UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_iE_Extensions,
        UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD,
        UPPCH_LCR_Parameters_CTCH_ReconfRqstTDD_ExtIEs,
        ____CommonTransportChannelReconfigurationResponse_protocolIEs__item__id_tab,
        _____CommonTransportChannelReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0,
        ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__id,
        ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__criticality,
        ___CommonTransportChannelReconfigurationResponse_protocolIEs__item__value,
        __CommonTransportChannelReconfigurationResponse_protocolIEs__item_,
        _CommonTransportChannelReconfigurationResponse_protocolIEs,
        ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__id_tab,
        ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__id,
        ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__criticality_tab,
        ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__criticality,
        ____CommonTransportChannelReconfigurationResponse_protocolExtensions__item__extensionValue_tab,
        ___CommonTransportChannelReconfigurationResponse_protocolExtensions__item__extensionValue,
        __CommonTransportChannelReconfigurationResponse_protocolExtensions__item_,
        _CommonTransportChannelReconfigurationResponse_protocolExtensions,
        CommonTransportChannelReconfigurationResponse,
        CommonTransportChannelReconfigurationResponse_IEs,
        _CommonTransportChannelReconfigurationResponse_IEs_val_Value_0,
        CommonTransportChannelReconfigurationResponse_Extensions,
        ____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab,
        _____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__id,
        ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__criticality,
        ___CommonTransportChannelReconfigurationFailure_protocolIEs__item__value,
        __CommonTransportChannelReconfigurationFailure_protocolIEs__item_,
        _CommonTransportChannelReconfigurationFailure_protocolIEs,
        ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__id_tab,
        ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__id,
        ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__criticality_tab,
        ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__criticality,
        ____CommonTransportChannelReconfigurationFailure_protocolExtensions__item__extensionValue_tab,
        ___CommonTransportChannelReconfigurationFailure_protocolExtensions__item__extensionValue,
        __CommonTransportChannelReconfigurationFailure_protocolExtensions__item_,
        _CommonTransportChannelReconfigurationFailure_protocolExtensions,
        CommonTransportChannelReconfigurationFailure,
        CommonTransportChannelReconfigurationFailure_IEs,
        _CommonTransportChannelReconfigurationFailure_IEs_val_Value_0,
        _CommonTransportChannelReconfigurationFailure_IEs_val_Value_1,
        CommonTransportChannelReconfigurationFailure_Extensions,
        ____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab,
        _____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab_val_Value_1,
        _____CommonTransportChannelDeletionRequest_protocolIEs__item__id_tab_val_Value_2,
        ___CommonTransportChannelDeletionRequest_protocolIEs__item__id,
        ___CommonTransportChannelDeletionRequest_protocolIEs__item__criticality,
        ___CommonTransportChannelDeletionRequest_protocolIEs__item__value,
        __CommonTransportChannelDeletionRequest_protocolIEs__item_,
        _CommonTransportChannelDeletionRequest_protocolIEs,
        ____CommonTransportChannelDeletionRequest_protocolExtensions__item__id_tab,
        _____CommonTransportChannelDeletionRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___CommonTransportChannelDeletionRequest_protocolExtensions__item__id,
        ___CommonTransportChannelDeletionRequest_protocolExtensions__item__criticality,
        ___CommonTransportChannelDeletionRequest_protocolExtensions__item__extensionValue,
        __CommonTransportChannelDeletionRequest_protocolExtensions__item_,
        _CommonTransportChannelDeletionRequest_protocolExtensions,
        CommonTransportChannelDeletionRequest,
        CommonTransportChannelDeletionRequest_IEs,
        _CommonTransportChannelDeletionRequest_IEs_val_Value_0,
        _CommonTransportChannelDeletionRequest_IEs_val_Value_1,
        _CommonTransportChannelDeletionRequest_IEs_val_Value_2,
        CommonTransportChannelDeletionRequest_Extensions,
        _CommonTransportChannelDeletionRequest_Extensions_val_Extension_0,
        ____CommonTransportChannelDeletionResponse_protocolIEs__item__id_tab,
        _____CommonTransportChannelDeletionResponse_protocolIEs__item__id_tab_val_Value_0,
        ___CommonTransportChannelDeletionResponse_protocolIEs__item__id,
        ___CommonTransportChannelDeletionResponse_protocolIEs__item__criticality,
        ___CommonTransportChannelDeletionResponse_protocolIEs__item__value,
        __CommonTransportChannelDeletionResponse_protocolIEs__item_,
        _CommonTransportChannelDeletionResponse_protocolIEs,
        ____CommonTransportChannelDeletionResponse_protocolExtensions__item__id_tab,
        ___CommonTransportChannelDeletionResponse_protocolExtensions__item__id,
        ____CommonTransportChannelDeletionResponse_protocolExtensions__item__criticality_tab,
        ___CommonTransportChannelDeletionResponse_protocolExtensions__item__criticality,
        ____CommonTransportChannelDeletionResponse_protocolExtensions__item__extensionValue_tab,
        ___CommonTransportChannelDeletionResponse_protocolExtensions__item__extensionValue,
        __CommonTransportChannelDeletionResponse_protocolExtensions__item_,
        _CommonTransportChannelDeletionResponse_protocolExtensions,
        CommonTransportChannelDeletionResponse,
        CommonTransportChannelDeletionResponse_IEs,
        _CommonTransportChannelDeletionResponse_IEs_val_Value_0,
        CommonTransportChannelDeletionResponse_Extensions,
        ____BlockResourceRequest_protocolIEs__item__id_tab,
        _____BlockResourceRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BlockResourceRequest_protocolIEs__item__id_tab_val_Value_1,
        _____BlockResourceRequest_protocolIEs__item__id_tab_val_Value_2,
        ___BlockResourceRequest_protocolIEs__item__id,
        ___BlockResourceRequest_protocolIEs__item__criticality,
        ___BlockResourceRequest_protocolIEs__item__value,
        __BlockResourceRequest_protocolIEs__item_,
        _BlockResourceRequest_protocolIEs,
        ____BlockResourceRequest_protocolExtensions__item__id_tab,
        ___BlockResourceRequest_protocolExtensions__item__id,
        ____BlockResourceRequest_protocolExtensions__item__criticality_tab,
        ___BlockResourceRequest_protocolExtensions__item__criticality,
        ____BlockResourceRequest_protocolExtensions__item__extensionValue_tab,
        ___BlockResourceRequest_protocolExtensions__item__extensionValue,
        __BlockResourceRequest_protocolExtensions__item_,
        _BlockResourceRequest_protocolExtensions,
        BlockResourceRequest,
        BlockResourceRequest_IEs,
        _BlockResourceRequest_IEs_val_Value_0,
        _BlockResourceRequest_IEs_val_Value_1,
        _BlockResourceRequest_IEs_val_Value_2,
        BlockResourceRequest_Extensions,
        ____BlockResourceResponse_protocolIEs__item__id_tab,
        _____BlockResourceResponse_protocolIEs__item__id_tab_val_Value_0,
        ___BlockResourceResponse_protocolIEs__item__id,
        ___BlockResourceResponse_protocolIEs__item__criticality,
        ___BlockResourceResponse_protocolIEs__item__value,
        __BlockResourceResponse_protocolIEs__item_,
        _BlockResourceResponse_protocolIEs,
        ____BlockResourceResponse_protocolExtensions__item__id_tab,
        ___BlockResourceResponse_protocolExtensions__item__id,
        ____BlockResourceResponse_protocolExtensions__item__criticality_tab,
        ___BlockResourceResponse_protocolExtensions__item__criticality,
        ____BlockResourceResponse_protocolExtensions__item__extensionValue_tab,
        ___BlockResourceResponse_protocolExtensions__item__extensionValue,
        __BlockResourceResponse_protocolExtensions__item_,
        _BlockResourceResponse_protocolExtensions,
        BlockResourceResponse,
        BlockResourceResponse_IEs,
        _BlockResourceResponse_IEs_val_Value_0,
        BlockResourceResponse_Extensions,
        ____BlockResourceFailure_protocolIEs__item__id_tab,
        _____BlockResourceFailure_protocolIEs__item__id_tab_val_Value_0,
        _____BlockResourceFailure_protocolIEs__item__id_tab_val_Value_1,
        ___BlockResourceFailure_protocolIEs__item__id,
        ___BlockResourceFailure_protocolIEs__item__criticality,
        ___BlockResourceFailure_protocolIEs__item__value,
        __BlockResourceFailure_protocolIEs__item_,
        _BlockResourceFailure_protocolIEs,
        ____BlockResourceFailure_protocolExtensions__item__id_tab,
        ___BlockResourceFailure_protocolExtensions__item__id,
        ____BlockResourceFailure_protocolExtensions__item__criticality_tab,
        ___BlockResourceFailure_protocolExtensions__item__criticality,
        ____BlockResourceFailure_protocolExtensions__item__extensionValue_tab,
        ___BlockResourceFailure_protocolExtensions__item__extensionValue,
        __BlockResourceFailure_protocolExtensions__item_,
        _BlockResourceFailure_protocolExtensions,
        BlockResourceFailure,
        BlockResourceFailure_IEs,
        _BlockResourceFailure_IEs_val_Value_0,
        _BlockResourceFailure_IEs_val_Value_1,
        BlockResourceFailure_Extensions,
        ____UnblockResourceIndication_protocolIEs__item__id_tab,
        _____UnblockResourceIndication_protocolIEs__item__id_tab_val_Value_0,
        ___UnblockResourceIndication_protocolIEs__item__id,
        ___UnblockResourceIndication_protocolIEs__item__criticality,
        ___UnblockResourceIndication_protocolIEs__item__value,
        __UnblockResourceIndication_protocolIEs__item_,
        _UnblockResourceIndication_protocolIEs,
        ____UnblockResourceIndication_protocolExtensions__item__id_tab,
        ___UnblockResourceIndication_protocolExtensions__item__id,
        ____UnblockResourceIndication_protocolExtensions__item__criticality_tab,
        ___UnblockResourceIndication_protocolExtensions__item__criticality,
        ____UnblockResourceIndication_protocolExtensions__item__extensionValue_tab,
        ___UnblockResourceIndication_protocolExtensions__item__extensionValue,
        __UnblockResourceIndication_protocolExtensions__item_,
        _UnblockResourceIndication_protocolExtensions,
        UnblockResourceIndication,
        UnblockResourceIndication_IEs,
        _UnblockResourceIndication_IEs_val_Value_0,
        UnblockResourceIndication_Extensions,
        ____AuditRequiredIndication_protocolIEs__item__id_tab,
        ___AuditRequiredIndication_protocolIEs__item__id,
        ____AuditRequiredIndication_protocolIEs__item__criticality_tab,
        ___AuditRequiredIndication_protocolIEs__item__criticality,
        ____AuditRequiredIndication_protocolIEs__item__value_tab,
        ___AuditRequiredIndication_protocolIEs__item__value,
        __AuditRequiredIndication_protocolIEs__item_,
        _AuditRequiredIndication_protocolIEs,
        ____AuditRequiredIndication_protocolExtensions__item__id_tab,
        ___AuditRequiredIndication_protocolExtensions__item__id,
        ____AuditRequiredIndication_protocolExtensions__item__criticality_tab,
        ___AuditRequiredIndication_protocolExtensions__item__criticality,
        ____AuditRequiredIndication_protocolExtensions__item__extensionValue_tab,
        ___AuditRequiredIndication_protocolExtensions__item__extensionValue,
        __AuditRequiredIndication_protocolExtensions__item_,
        _AuditRequiredIndication_protocolExtensions,
        AuditRequiredIndication,
        AuditRequiredIndication_IEs,
        AuditRequiredIndication_Extensions,
        ____AuditRequest_protocolIEs__item__id_tab,
        _____AuditRequest_protocolIEs__item__id_tab_val_Value_0,
        ___AuditRequest_protocolIEs__item__id,
        ___AuditRequest_protocolIEs__item__criticality,
        ___AuditRequest_protocolIEs__item__value,
        __AuditRequest_protocolIEs__item_,
        _AuditRequest_protocolIEs,
        ____AuditRequest_protocolExtensions__item__id_tab,
        ___AuditRequest_protocolExtensions__item__id,
        ____AuditRequest_protocolExtensions__item__criticality_tab,
        ___AuditRequest_protocolExtensions__item__criticality,
        ____AuditRequest_protocolExtensions__item__extensionValue_tab,
        ___AuditRequest_protocolExtensions__item__extensionValue,
        __AuditRequest_protocolExtensions__item_,
        _AuditRequest_protocolExtensions,
        AuditRequest,
        AuditRequest_IEs,
        _AuditRequest_IEs_val_Value_0,
        AuditRequest_Extensions,
        ____AuditResponse_protocolIEs__item__id_tab,
        _____AuditResponse_protocolIEs__item__id_tab_val_Value_0,
        _____AuditResponse_protocolIEs__item__id_tab_val_Value_1,
        _____AuditResponse_protocolIEs__item__id_tab_val_Value_2,
        _____AuditResponse_protocolIEs__item__id_tab_val_Value_3,
        _____AuditResponse_protocolIEs__item__id_tab_val_Value_4,
        _____AuditResponse_protocolIEs__item__id_tab_val_Value_5,
        ___AuditResponse_protocolIEs__item__id,
        ___AuditResponse_protocolIEs__item__criticality,
        ___AuditResponse_protocolIEs__item__value,
        __AuditResponse_protocolIEs__item_,
        _AuditResponse_protocolIEs,
        ____AuditResponse_protocolExtensions__item__id_tab,
        _____AuditResponse_protocolExtensions__item__id_tab_val_Extension_0,
        ___AuditResponse_protocolExtensions__item__id,
        ___AuditResponse_protocolExtensions__item__criticality,
        ___AuditResponse_protocolExtensions__item__extensionValue,
        __AuditResponse_protocolExtensions__item_,
        _AuditResponse_protocolExtensions,
        AuditResponse,
        AuditResponse_IEs,
        _AuditResponse_IEs_val_Value_0,
        _AuditResponse_IEs_val_Value_1,
        _AuditResponse_IEs_val_Value_2,
        _AuditResponse_IEs_val_Value_3,
        _AuditResponse_IEs_val_Value_4,
        _AuditResponse_IEs_val_Value_5,
        AuditResponse_Extensions,
        _AuditResponse_Extensions_val_Extension_0,
        ___Cell_InformationList_AuditRsp__item__id_tab,
        ____Cell_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __Cell_InformationList_AuditRsp__item__id,
        __Cell_InformationList_AuditRsp__item__criticality,
        __Cell_InformationList_AuditRsp__item__value,
        _Cell_InformationList_AuditRsp__item_,
        Cell_InformationList_AuditRsp,
        Cell_InformationItemIE_AuditRsp,
        _Cell_InformationItemIE_AuditRsp_val_Value_0,
        _Cell_InformationItem_AuditRsp_c_ID,
        _Cell_InformationItem_AuditRsp_configurationGenerationID,
        _Cell_InformationItem_AuditRsp_resourceOperationalState,
        _Cell_InformationItem_AuditRsp_availabilityStatus,
        _Cell_InformationItem_AuditRsp_local_Cell_ID,
        _Cell_InformationItem_AuditRsp_primary_SCH_Information,
        _Cell_InformationItem_AuditRsp_secondary_SCH_Information,
        _Cell_InformationItem_AuditRsp_primary_CPICH_Information,
        _Cell_InformationItem_AuditRsp_secondary_CPICH_InformationList,
        _Cell_InformationItem_AuditRsp_primary_CCPCH_Information,
        _Cell_InformationItem_AuditRsp_bCH_Information,
        _Cell_InformationItem_AuditRsp_secondary_CCPCH_InformationList,
        _Cell_InformationItem_AuditRsp_pCH_Information,
        _Cell_InformationItem_AuditRsp_pICH_Information,
        _Cell_InformationItem_AuditRsp_fACH_InformationList,
        _Cell_InformationItem_AuditRsp_pRACH_InformationList,
        _Cell_InformationItem_AuditRsp_rACH_InformationList,
        _Cell_InformationItem_AuditRsp_aICH_InformationList,
        _Cell_InformationItem_AuditRsp_notUsed_1_pCPCH_InformationList,
        _Cell_InformationItem_AuditRsp_notUsed_2_cPCH_InformationList,
        _Cell_InformationItem_AuditRsp_notUsed_3_aP_AICH_InformationList,
        _Cell_InformationItem_AuditRsp_notUsed_4_cDCA_ICH_InformationList,
        _Cell_InformationItem_AuditRsp_sCH_Information,
        ____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_1,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_2,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_3,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_4,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_5,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_6,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_7,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_8,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_9,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_10,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_11,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_12,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_13,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_14,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_15,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_16,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_17,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_18,
        _____Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_19,
        ___Cell_InformationItem_AuditRsp_iE_Extensions__item__id,
        ___Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality,
        ___Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue,
        __Cell_InformationItem_AuditRsp_iE_Extensions__item_,
        _Cell_InformationItem_AuditRsp_iE_Extensions,
        Cell_InformationItem_AuditRsp,
        Cell_InformationItem_AuditRsp_ExtIEs,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_0,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_1,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_2,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_3,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_4,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_5,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_6,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_7,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_8,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_9,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_10,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_11,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_12,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_13,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_14,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_15,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_16,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_17,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_18,
        _Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_19,
        __P_SCH_Information_AuditRsp_id_tab,
        ___P_SCH_Information_AuditRsp_id_tab_val_Value_0,
        _P_SCH_Information_AuditRsp_id,
        _P_SCH_Information_AuditRsp_criticality,
        _P_SCH_Information_AuditRsp_value,
        P_SCH_Information_AuditRsp,
        P_SCH_InformationIE_AuditRsp,
        _P_SCH_InformationIE_AuditRsp_val_Value_0,
        __S_SCH_Information_AuditRsp_id_tab,
        ___S_SCH_Information_AuditRsp_id_tab_val_Value_0,
        _S_SCH_Information_AuditRsp_id,
        _S_SCH_Information_AuditRsp_criticality,
        _S_SCH_Information_AuditRsp_value,
        S_SCH_Information_AuditRsp,
        S_SCH_InformationIE_AuditRsp,
        _S_SCH_InformationIE_AuditRsp_val_Value_0,
        __P_CPICH_Information_AuditRsp_id_tab,
        ___P_CPICH_Information_AuditRsp_id_tab_val_Value_0,
        _P_CPICH_Information_AuditRsp_id,
        _P_CPICH_Information_AuditRsp_criticality,
        _P_CPICH_Information_AuditRsp_value,
        P_CPICH_Information_AuditRsp,
        P_CPICH_InformationIE_AuditRsp,
        _P_CPICH_InformationIE_AuditRsp_val_Value_0,
        ___S_CPICH_InformationList_AuditRsp__item__id_tab,
        ____S_CPICH_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __S_CPICH_InformationList_AuditRsp__item__id,
        __S_CPICH_InformationList_AuditRsp__item__criticality,
        __S_CPICH_InformationList_AuditRsp__item__value,
        _S_CPICH_InformationList_AuditRsp__item_,
        S_CPICH_InformationList_AuditRsp,
        S_CPICH_InformationItemIE_AuditRsp,
        _S_CPICH_InformationItemIE_AuditRsp_val_Value_0,
        __P_CCPCH_Information_AuditRsp_id_tab,
        ___P_CCPCH_Information_AuditRsp_id_tab_val_Value_0,
        _P_CCPCH_Information_AuditRsp_id,
        _P_CCPCH_Information_AuditRsp_criticality,
        _P_CCPCH_Information_AuditRsp_value,
        P_CCPCH_Information_AuditRsp,
        P_CCPCH_InformationIE_AuditRsp,
        _P_CCPCH_InformationIE_AuditRsp_val_Value_0,
        __BCH_Information_AuditRsp_id_tab,
        ___BCH_Information_AuditRsp_id_tab_val_Value_0,
        _BCH_Information_AuditRsp_id,
        _BCH_Information_AuditRsp_criticality,
        _BCH_Information_AuditRsp_value,
        BCH_Information_AuditRsp,
        BCH_InformationIE_AuditRsp,
        _BCH_InformationIE_AuditRsp_val_Value_0,
        ___S_CCPCH_InformationList_AuditRsp__item__id_tab,
        ____S_CCPCH_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __S_CCPCH_InformationList_AuditRsp__item__id,
        __S_CCPCH_InformationList_AuditRsp__item__criticality,
        __S_CCPCH_InformationList_AuditRsp__item__value,
        _S_CCPCH_InformationList_AuditRsp__item_,
        S_CCPCH_InformationList_AuditRsp,
        S_CCPCH_InformationItemIE_AuditRsp,
        _S_CCPCH_InformationItemIE_AuditRsp_val_Value_0,
        __PCH_Information_AuditRsp_id_tab,
        ___PCH_Information_AuditRsp_id_tab_val_Value_0,
        _PCH_Information_AuditRsp_id,
        _PCH_Information_AuditRsp_criticality,
        _PCH_Information_AuditRsp_value,
        PCH_Information_AuditRsp,
        PCH_InformationIE_AuditRsp,
        _PCH_InformationIE_AuditRsp_val_Value_0,
        __PICH_Information_AuditRsp_id_tab,
        ___PICH_Information_AuditRsp_id_tab_val_Value_0,
        _PICH_Information_AuditRsp_id,
        _PICH_Information_AuditRsp_criticality,
        _PICH_Information_AuditRsp_value,
        PICH_Information_AuditRsp,
        PICH_InformationIE_AuditRsp,
        _PICH_InformationIE_AuditRsp_val_Value_0,
        ___FACH_InformationList_AuditRsp__item__id_tab,
        ____FACH_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __FACH_InformationList_AuditRsp__item__id,
        __FACH_InformationList_AuditRsp__item__criticality,
        __FACH_InformationList_AuditRsp__item__value,
        _FACH_InformationList_AuditRsp__item_,
        FACH_InformationList_AuditRsp,
        FACH_InformationItemIE_AuditRsp,
        _FACH_InformationItemIE_AuditRsp_val_Value_0,
        ___PRACH_InformationList_AuditRsp__item__id_tab,
        ____PRACH_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __PRACH_InformationList_AuditRsp__item__id,
        __PRACH_InformationList_AuditRsp__item__criticality,
        __PRACH_InformationList_AuditRsp__item__value,
        _PRACH_InformationList_AuditRsp__item_,
        PRACH_InformationList_AuditRsp,
        PRACH_InformationItemIE_AuditRsp,
        _PRACH_InformationItemIE_AuditRsp_val_Value_0,
        ___RACH_InformationList_AuditRsp__item__id_tab,
        ____RACH_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __RACH_InformationList_AuditRsp__item__id,
        __RACH_InformationList_AuditRsp__item__criticality,
        __RACH_InformationList_AuditRsp__item__value,
        _RACH_InformationList_AuditRsp__item_,
        RACH_InformationList_AuditRsp,
        RACH_InformationItemIE_AuditRsp,
        _RACH_InformationItemIE_AuditRsp_val_Value_0,
        ___AICH_InformationList_AuditRsp__item__id_tab,
        ____AICH_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __AICH_InformationList_AuditRsp__item__id,
        __AICH_InformationList_AuditRsp__item__criticality,
        __AICH_InformationList_AuditRsp__item__value,
        _AICH_InformationList_AuditRsp__item_,
        AICH_InformationList_AuditRsp,
        AICH_InformationItemIE_AuditRsp,
        _AICH_InformationItemIE_AuditRsp_val_Value_0,
        __SCH_Information_AuditRsp_id_tab,
        ___SCH_Information_AuditRsp_id_tab_val_Value_0,
        _SCH_Information_AuditRsp_id,
        _SCH_Information_AuditRsp_criticality,
        _SCH_Information_AuditRsp_value,
        SCH_Information_AuditRsp,
        SCH_InformationIE_AuditRsp,
        _SCH_InformationIE_AuditRsp_val_Value_0,
        ___FPACH_LCR_InformationList_AuditRsp__item__id_tab,
        ____FPACH_LCR_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __FPACH_LCR_InformationList_AuditRsp__item__id,
        __FPACH_LCR_InformationList_AuditRsp__item__criticality,
        __FPACH_LCR_InformationList_AuditRsp__item__value,
        _FPACH_LCR_InformationList_AuditRsp__item_,
        FPACH_LCR_InformationList_AuditRsp,
        FPACH_LCR_InformationItemIE_AuditRsp,
        _FPACH_LCR_InformationItemIE_AuditRsp_val_Value_0,
        _HS_DSCH_Resources_Information_AuditRsp_resourceOperationalState,
        _HS_DSCH_Resources_Information_AuditRsp_availabilityStatus,
        ____HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab,
        _____HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__id,
        ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality,
        ___HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue,
        __HS_DSCH_Resources_Information_AuditRsp_iE_Extensions__item_,
        _HS_DSCH_Resources_Information_AuditRsp_iE_Extensions,
        HS_DSCH_Resources_Information_AuditRsp,
        HS_DSCH_Resources_Information_AuditRsp_ExtIEs,
        _HS_DSCH_Resources_Information_AuditRsp_ExtIEs_val_Extension_0,
        ___S_CCPCH_InformationListExt_AuditRsp__item__id_tab,
        ____S_CCPCH_InformationListExt_AuditRsp__item__id_tab_val_Value_0,
        __S_CCPCH_InformationListExt_AuditRsp__item__id,
        __S_CCPCH_InformationListExt_AuditRsp__item__criticality,
        __S_CCPCH_InformationListExt_AuditRsp__item__value,
        _S_CCPCH_InformationListExt_AuditRsp__item_,
        S_CCPCH_InformationListExt_AuditRsp,
        ___S_CCPCH_LCR_InformationListExt_AuditRsp__item__id_tab,
        ____S_CCPCH_LCR_InformationListExt_AuditRsp__item__id_tab_val_Value_0,
        __S_CCPCH_LCR_InformationListExt_AuditRsp__item__id,
        __S_CCPCH_LCR_InformationListExt_AuditRsp__item__criticality,
        __S_CCPCH_LCR_InformationListExt_AuditRsp__item__value,
        _S_CCPCH_LCR_InformationListExt_AuditRsp__item_,
        S_CCPCH_LCR_InformationListExt_AuditRsp,
        _E_DCH_Resources_Information_AuditRsp_resourceOperationalState,
        _E_DCH_Resources_Information_AuditRsp_availabilityStatus,
        ____E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab,
        _____E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__id,
        ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__criticality,
        ___E_DCH_Resources_Information_AuditRsp_iE_Extensions__item__extensionValue,
        __E_DCH_Resources_Information_AuditRsp_iE_Extensions__item_,
        _E_DCH_Resources_Information_AuditRsp_iE_Extensions,
        E_DCH_Resources_Information_AuditRsp,
        E_DCH_Resources_Information_AuditRsp_ExtIEs,
        _E_DCH_Resources_Information_AuditRsp_ExtIEs_val_Extension_0,
        ___PLCCH_InformationList_AuditRsp__item__id_tab,
        ____PLCCH_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __PLCCH_InformationList_AuditRsp__item__id,
        __PLCCH_InformationList_AuditRsp__item__criticality,
        __PLCCH_InformationList_AuditRsp__item__value,
        _PLCCH_InformationList_AuditRsp__item_,
        PLCCH_InformationList_AuditRsp,
        PLCCH_InformationItemIE_AuditRsp,
        _PLCCH_InformationItemIE_AuditRsp_val_Value_0,
        ___S_CCPCH_768_InformationList_AuditRsp__item__id_tab,
        ____S_CCPCH_768_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __S_CCPCH_768_InformationList_AuditRsp__item__id,
        __S_CCPCH_768_InformationList_AuditRsp__item__criticality,
        __S_CCPCH_768_InformationList_AuditRsp__item__value,
        _S_CCPCH_768_InformationList_AuditRsp__item_,
        S_CCPCH_768_InformationList_AuditRsp,
        S_CCPCH_768_InformationItemIE_AuditRsp,
        _S_CCPCH_768_InformationItemIE_AuditRsp_val_Value_0,
        ___PRACH_768_InformationList_AuditRsp__item__id_tab,
        ____PRACH_768_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __PRACH_768_InformationList_AuditRsp__item__id,
        __PRACH_768_InformationList_AuditRsp__item__criticality,
        __PRACH_768_InformationList_AuditRsp__item__value,
        _PRACH_768_InformationList_AuditRsp__item_,
        PRACH_768_InformationList_AuditRsp,
        PRACH_768_InformationItemIE_AuditRsp,
        _PRACH_768_InformationItemIE_AuditRsp_val_Value_0,
        ___E_RUCCH_InformationList_AuditRsp__item__id_tab,
        ____E_RUCCH_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __E_RUCCH_InformationList_AuditRsp__item__id,
        __E_RUCCH_InformationList_AuditRsp__item__criticality,
        __E_RUCCH_InformationList_AuditRsp__item__value,
        _E_RUCCH_InformationList_AuditRsp__item_,
        E_RUCCH_InformationList_AuditRsp,
        E_RUCCH_InformationItemIE_AuditRsp,
        _E_RUCCH_InformationItemIE_AuditRsp_val_Value_0,
        ___E_RUCCH_768_InformationList_AuditRsp__item__id_tab,
        ____E_RUCCH_768_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __E_RUCCH_768_InformationList_AuditRsp__item__id,
        __E_RUCCH_768_InformationList_AuditRsp__item__criticality,
        __E_RUCCH_768_InformationList_AuditRsp__item__value,
        _E_RUCCH_768_InformationList_AuditRsp__item_,
        E_RUCCH_768_InformationList_AuditRsp,
        E_RUCCH_768_InformationItemIE_AuditRsp,
        _E_RUCCH_768_InformationItemIE_AuditRsp_val_Value_0,
        ___Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id_tab,
        ____Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id_tab_val_Value_0,
        __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__id,
        __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__criticality,
        __Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item__value,
        _Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp__item_,
        Cell_Frequency_List_Information_LCR_MulFreq_AuditRsp,
        Cell_Frequency_List_InformationIE_LCR_MulFreq_AuditRsp,
        _Cell_Frequency_List_InformationIE_LCR_MulFreq_AuditRsp_val_Value_0,
        _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_uARFCN,
        _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_resourceOperationalState,
        _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_availabilityStatus,
        ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__id_tab,
        ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__id,
        ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__criticality_tab,
        ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__criticality,
        ____Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__extensionValue_tab,
        ___Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item__extensionValue,
        __Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions__item_,
        _Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_iE_Extensions,
        Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp,
        Cell_Frequency_List_InformationItem_LCR_MulFreq_AuditRsp_ExtIEs,
        ___UPPCH_LCR_InformationList_AuditRsp__item__id_tab,
        ____UPPCH_LCR_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __UPPCH_LCR_InformationList_AuditRsp__item__id,
        __UPPCH_LCR_InformationList_AuditRsp__item__criticality,
        __UPPCH_LCR_InformationList_AuditRsp__item__value,
        _UPPCH_LCR_InformationList_AuditRsp__item_,
        UPPCH_LCR_InformationList_AuditRsp,
        UPPCH_LCR_InformationIE_AuditRsp,
        _UPPCH_LCR_InformationIE_AuditRsp_val_Value_0,
        _UPPCH_LCR_InformationItem_AuditRsp_uARFCN,
        _UPPCH_LCR_InformationItem_AuditRsp_uPPCHPositionLCR,
        _UPPCH_LCR_InformationItem_AuditRsp_resourceOperationalState,
        _UPPCH_LCR_InformationItem_AuditRsp_availabilityStatus,
        ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__id_tab,
        ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__id,
        ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab,
        ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__criticality,
        ____UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab,
        ___UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item__extensionValue,
        __UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions__item_,
        _UPPCH_LCR_InformationItem_AuditRsp_iE_Extensions,
        UPPCH_LCR_InformationItem_AuditRsp,
        UPPCH_LCR_InformationItem_AuditRsp_ExtIEs,
        ___MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id_tab,
        ____MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__id,
        __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__criticality,
        __MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item__value,
        _MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp__item_,
        MultipleFreq_HS_DSCH_Resources_InformationList_AuditRsp,
        MultipleFreq_HS_DSCH_Resources_InformationItem_AuditRsp,
        _MultipleFreq_HS_DSCH_Resources_InformationItem_AuditRsp_val_Value_0,
        ___MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id_tab,
        ____MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__id,
        __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__criticality,
        __MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item__value,
        _MultipleFreq_E_DCH_Resources_InformationList_AuditRsp__item_,
        MultipleFreq_E_DCH_Resources_InformationList_AuditRsp,
        MultipleFreq_E_DCH_Resources_InformationItem_AuditRsp,
        _MultipleFreq_E_DCH_Resources_InformationItem_AuditRsp_val_Value_0,
        ___CCP_InformationList_AuditRsp__item__id_tab,
        ____CCP_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __CCP_InformationList_AuditRsp__item__id,
        __CCP_InformationList_AuditRsp__item__criticality,
        __CCP_InformationList_AuditRsp__item__value,
        _CCP_InformationList_AuditRsp__item_,
        CCP_InformationList_AuditRsp,
        CCP_InformationItemIE_AuditRsp,
        _CCP_InformationItemIE_AuditRsp_val_Value_0,
        _CCP_InformationItem_AuditRsp_communicationControlPortID,
        _CCP_InformationItem_AuditRsp_resourceOperationalState,
        _CCP_InformationItem_AuditRsp_availabilityStatus,
        ____CCP_InformationItem_AuditRsp_iE_Extensions__item__id_tab,
        ___CCP_InformationItem_AuditRsp_iE_Extensions__item__id,
        ____CCP_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab,
        ___CCP_InformationItem_AuditRsp_iE_Extensions__item__criticality,
        ____CCP_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab,
        ___CCP_InformationItem_AuditRsp_iE_Extensions__item__extensionValue,
        __CCP_InformationItem_AuditRsp_iE_Extensions__item_,
        _CCP_InformationItem_AuditRsp_iE_Extensions,
        CCP_InformationItem_AuditRsp,
        CCP_InformationItem_AuditRsp_ExtIEs,
        ___Local_Cell_InformationList_AuditRsp__item__id_tab,
        ____Local_Cell_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __Local_Cell_InformationList_AuditRsp__item__id,
        __Local_Cell_InformationList_AuditRsp__item__criticality,
        __Local_Cell_InformationList_AuditRsp__item__value,
        _Local_Cell_InformationList_AuditRsp__item_,
        Local_Cell_InformationList_AuditRsp,
        Local_Cell_InformationItemIE_AuditRsp,
        _Local_Cell_InformationItemIE_AuditRsp_val_Value_0,
        _Local_Cell_InformationItem_AuditRsp_local_Cell_ID,
        _Local_Cell_InformationItem_AuditRsp_dl_or_global_capacityCredit,
        _Local_Cell_InformationItem_AuditRsp_ul_capacityCredit,
        _Local_Cell_InformationItem_AuditRsp_commonChannelsCapacityConsumptionLaw,
        _Local_Cell_InformationItem_AuditRsp_dedicatedChannelsCapacityConsumptionLaw,
        _Local_Cell_InformationItem_AuditRsp_maximumDL_PowerCapability,
        _Local_Cell_InformationItem_AuditRsp_minSpreadingFactor,
        _Local_Cell_InformationItem_AuditRsp_minimumDL_PowerCapability,
        _Local_Cell_InformationItem_AuditRsp_local_Cell_Group_ID,
        ____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_1,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_2,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_3,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_4,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_5,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_6,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_7,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_8,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_9,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_10,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_11,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_12,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_13,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_14,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_15,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_16,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_17,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_18,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_19,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_20,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_21,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_22,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_23,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_24,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_25,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_26,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_27,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_28,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_29,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_30,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_31,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_32,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_33,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_34,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_35,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_36,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_37,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_38,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_39,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_40,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_41,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_42,
        _____Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_43,
        ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__id,
        ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__criticality,
        ___Local_Cell_InformationItem_AuditRsp_iE_Extensions__item__extensionValue,
        __Local_Cell_InformationItem_AuditRsp_iE_Extensions__item_,
        _Local_Cell_InformationItem_AuditRsp_iE_Extensions,
        Local_Cell_InformationItem_AuditRsp,
        Local_Cell_InformationItem_AuditRsp_ExtIEs,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_0,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_1,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_2,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_3,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_4,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_5,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_6,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_7,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_8,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_9,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_10,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_11,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_12,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_13,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_14,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_15,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_16,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_17,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_18,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_19,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_20,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_21,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_22,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_23,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_24,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_25,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_26,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_27,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_28,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_29,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_30,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_31,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_32,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_33,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_34,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_35,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_36,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_37,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_38,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_39,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_40,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_41,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_42,
        _Local_Cell_InformationItem_AuditRsp_ExtIEs_val_Extension_43,
        ___Local_Cell_Group_InformationList_AuditRsp__item__id_tab,
        ____Local_Cell_Group_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __Local_Cell_Group_InformationList_AuditRsp__item__id,
        __Local_Cell_Group_InformationList_AuditRsp__item__criticality,
        __Local_Cell_Group_InformationList_AuditRsp__item__value,
        _Local_Cell_Group_InformationList_AuditRsp__item_,
        Local_Cell_Group_InformationList_AuditRsp,
        Local_Cell_Group_InformationItemIE_AuditRsp,
        _Local_Cell_Group_InformationItemIE_AuditRsp_val_Value_0,
        _Local_Cell_Group_InformationItem_AuditRsp_local_Cell_Group_ID,
        _Local_Cell_Group_InformationItem_AuditRsp_dl_or_global_capacityCredit,
        _Local_Cell_Group_InformationItem_AuditRsp_ul_capacityCredit,
        _Local_Cell_Group_InformationItem_AuditRsp_commonChannelsCapacityConsumptionLaw,
        _Local_Cell_Group_InformationItem_AuditRsp_dedicatedChannelsCapacityConsumptionLaw,
        ____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab,
        _____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_0,
        _____Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab_val_Extension_1,
        ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id,
        ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality,
        ___Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue,
        __Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item_,
        _Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions,
        Local_Cell_Group_InformationItem_AuditRsp,
        Local_Cell_Group_InformationItem_AuditRsp_ExtIEs,
        _Local_Cell_Group_InformationItem_AuditRsp_ExtIEs_val_Extension_0,
        _Local_Cell_Group_InformationItem_AuditRsp_ExtIEs_val_Extension_1,
        ___Power_Local_Cell_Group_InformationList_AuditRsp__item__id_tab,
        ____Power_Local_Cell_Group_InformationList_AuditRsp__item__id_tab_val_Value_0,
        __Power_Local_Cell_Group_InformationList_AuditRsp__item__id,
        __Power_Local_Cell_Group_InformationList_AuditRsp__item__criticality,
        __Power_Local_Cell_Group_InformationList_AuditRsp__item__value,
        _Power_Local_Cell_Group_InformationList_AuditRsp__item_,
        Power_Local_Cell_Group_InformationList_AuditRsp,
        Power_Local_Cell_Group_InformationItemIE_AuditRsp,
        _Power_Local_Cell_Group_InformationItemIE_AuditRsp_val_Value_0,
        _Power_Local_Cell_Group_InformationItem_AuditRsp_power_Local_Cell_Group_ID,
        _Power_Local_Cell_Group_InformationItem_AuditRsp_maximumDL_PowerCapability,
        ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id_tab,
        ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__id,
        ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality_tab,
        ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__criticality,
        ____Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue_tab,
        ___Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item__extensionValue,
        __Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions__item_,
        _Power_Local_Cell_Group_InformationItem_AuditRsp_iE_Extensions,
        Power_Local_Cell_Group_InformationItem_AuditRsp,
        Power_Local_Cell_Group_InformationItem_AuditRsp_ExtIEs,
        ____AuditFailure_protocolIEs__item__id_tab,
        _____AuditFailure_protocolIEs__item__id_tab_val_Value_0,
        _____AuditFailure_protocolIEs__item__id_tab_val_Value_1,
        ___AuditFailure_protocolIEs__item__id,
        ___AuditFailure_protocolIEs__item__criticality,
        ___AuditFailure_protocolIEs__item__value,
        __AuditFailure_protocolIEs__item_,
        _AuditFailure_protocolIEs,
        ____AuditFailure_protocolExtensions__item__id_tab,
        ___AuditFailure_protocolExtensions__item__id,
        ____AuditFailure_protocolExtensions__item__criticality_tab,
        ___AuditFailure_protocolExtensions__item__criticality,
        ____AuditFailure_protocolExtensions__item__extensionValue_tab,
        ___AuditFailure_protocolExtensions__item__extensionValue,
        __AuditFailure_protocolExtensions__item_,
        _AuditFailure_protocolExtensions,
        AuditFailure,
        AuditFailure_IEs,
        _AuditFailure_IEs_val_Value_0,
        _AuditFailure_IEs_val_Value_1,
        AuditFailure_Extensions,
        ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6,
        ___CommonMeasurementInitiationRequest_protocolIEs__item__id,
        ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality,
        ___CommonMeasurementInitiationRequest_protocolIEs__item__value,
        __CommonMeasurementInitiationRequest_protocolIEs__item_,
        _CommonMeasurementInitiationRequest_protocolIEs,
        ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab,
        _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_3,
        _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_4,
        _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_5,
        ___CommonMeasurementInitiationRequest_protocolExtensions__item__id,
        ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality,
        ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue,
        __CommonMeasurementInitiationRequest_protocolExtensions__item_,
        _CommonMeasurementInitiationRequest_protocolExtensions,
        CommonMeasurementInitiationRequest,
        CommonMeasurementInitiationRequest_IEs,
        _CommonMeasurementInitiationRequest_IEs_val_Value_0,
        _CommonMeasurementInitiationRequest_IEs_val_Value_1,
        _CommonMeasurementInitiationRequest_IEs_val_Value_2,
        _CommonMeasurementInitiationRequest_IEs_val_Value_3,
        _CommonMeasurementInitiationRequest_IEs_val_Value_4,
        _CommonMeasurementInitiationRequest_IEs_val_Value_5,
        _CommonMeasurementInitiationRequest_IEs_val_Value_6,
        CommonMeasurementInitiationRequest_Extensions,
        _CommonMeasurementInitiationRequest_Extensions_val_Extension_0,
        _CommonMeasurementInitiationRequest_Extensions_val_Extension_1,
        _CommonMeasurementInitiationRequest_Extensions_val_Extension_2,
        _CommonMeasurementInitiationRequest_Extensions_val_Extension_3,
        _CommonMeasurementInitiationRequest_Extensions_val_Extension_4,
        _CommonMeasurementInitiationRequest_Extensions_val_Extension_5,
        _CommonMeasurementObjectType_CM_Rqst_cell,
        _CommonMeasurementObjectType_CM_Rqst_rACH,
        _CommonMeasurementObjectType_CM_Rqst_notUsed_cPCH,
        _CommonMeasurementObjectType_CM_Rqst_extension_CommonMeasurementObjectType_CM_Rqst,
        CommonMeasurementObjectType_CM_Rqst,
        __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab,
        ___Extension_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_0,
        ___Extension_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_1,
        _Extension_CommonMeasurementObjectType_CM_Rqst_id,
        _Extension_CommonMeasurementObjectType_CM_Rqst_criticality,
        _Extension_CommonMeasurementObjectType_CM_Rqst_value,
        Extension_CommonMeasurementObjectType_CM_Rqst,
        Extension_CommonMeasurementObjectType_CM_RqstIE,
        _Extension_CommonMeasurementObjectType_CM_RqstIE_val_Value_0,
        _Extension_CommonMeasurementObjectType_CM_RqstIE_val_Value_1,
        _ERACH_CM_Rqst_c_ID,
        ____ERACH_CM_Rqst_iE_Extensions__item__id_tab,
        ___ERACH_CM_Rqst_iE_Extensions__item__id,
        ____ERACH_CM_Rqst_iE_Extensions__item__criticality_tab,
        ___ERACH_CM_Rqst_iE_Extensions__item__criticality,
        ____ERACH_CM_Rqst_iE_Extensions__item__extensionValue_tab,
        ___ERACH_CM_Rqst_iE_Extensions__item__extensionValue,
        __ERACH_CM_Rqst_iE_Extensions__item_,
        _ERACH_CM_Rqst_iE_Extensions,
        ERACH_CM_Rqst,
        ERACHItem_CM_Rqst_ExtIEs,
        _Cell_CM_Rqst_c_ID,
        _Cell_CM_Rqst_timeSlot,
        ____Cell_CM_Rqst_iE_Extensions__item__id_tab,
        _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_1,
        _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_2,
        _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_3,
        _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_4,
        ___Cell_CM_Rqst_iE_Extensions__item__id,
        ___Cell_CM_Rqst_iE_Extensions__item__criticality,
        ___Cell_CM_Rqst_iE_Extensions__item__extensionValue,
        __Cell_CM_Rqst_iE_Extensions__item_,
        _Cell_CM_Rqst_iE_Extensions,
        Cell_CM_Rqst,
        CellItem_CM_Rqst_ExtIEs,
        _CellItem_CM_Rqst_ExtIEs_val_Extension_0,
        _CellItem_CM_Rqst_ExtIEs_val_Extension_1,
        _CellItem_CM_Rqst_ExtIEs_val_Extension_2,
        _CellItem_CM_Rqst_ExtIEs_val_Extension_3,
        _CellItem_CM_Rqst_ExtIEs_val_Extension_4,
        _RACH_CM_Rqst_c_ID,
        _RACH_CM_Rqst_commonTransportChannelID,
        ____RACH_CM_Rqst_iE_Extensions__item__id_tab,
        ___RACH_CM_Rqst_iE_Extensions__item__id,
        ____RACH_CM_Rqst_iE_Extensions__item__criticality_tab,
        ___RACH_CM_Rqst_iE_Extensions__item__criticality,
        ____RACH_CM_Rqst_iE_Extensions__item__extensionValue_tab,
        ___RACH_CM_Rqst_iE_Extensions__item__extensionValue,
        __RACH_CM_Rqst_iE_Extensions__item_,
        _RACH_CM_Rqst_iE_Extensions,
        RACH_CM_Rqst,
        RACHItem_CM_Rqst_ExtIEs,
        _PowerLocalCellGroup_CM_Rqst_powerLocalCellGroupID,
        ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__id_tab,
        ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__id,
        ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__criticality_tab,
        ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__criticality,
        ____PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__extensionValue_tab,
        ___PowerLocalCellGroup_CM_Rqst_iE_Extensions__item__extensionValue,
        __PowerLocalCellGroup_CM_Rqst_iE_Extensions__item_,
        _PowerLocalCellGroup_CM_Rqst_iE_Extensions,
        PowerLocalCellGroup_CM_Rqst,
        PowerLocalCellGroup_CM_Rqst_ExtIEs,
        ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab,
        _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___CommonMeasurementInitiationResponse_protocolIEs__item__id,
        ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality,
        ___CommonMeasurementInitiationResponse_protocolIEs__item__value,
        __CommonMeasurementInitiationResponse_protocolIEs__item_,
        _CommonMeasurementInitiationResponse_protocolIEs,
        ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab,
        _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_1,
        _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_2,
        _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_3,
        ___CommonMeasurementInitiationResponse_protocolExtensions__item__id,
        ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality,
        ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue,
        __CommonMeasurementInitiationResponse_protocolExtensions__item_,
        _CommonMeasurementInitiationResponse_protocolExtensions,
        CommonMeasurementInitiationResponse,
        CommonMeasurementInitiationResponse_IEs,
        _CommonMeasurementInitiationResponse_IEs_val_Value_0,
        _CommonMeasurementInitiationResponse_IEs_val_Value_1,
        _CommonMeasurementInitiationResponse_IEs_val_Value_2,
        _CommonMeasurementInitiationResponse_IEs_val_Value_3,
        CommonMeasurementInitiationResponse_Extensions,
        _CommonMeasurementInitiationResponse_Extensions_val_Extension_0,
        _CommonMeasurementInitiationResponse_Extensions_val_Extension_1,
        _CommonMeasurementInitiationResponse_Extensions_val_Extension_2,
        _CommonMeasurementInitiationResponse_Extensions_val_Extension_3,
        _CommonMeasurementObjectType_CM_Rsp_cell,
        _CommonMeasurementObjectType_CM_Rsp_rACH,
        _CommonMeasurementObjectType_CM_Rsp_notUsed_cPCH,
        _CommonMeasurementObjectType_CM_Rsp_extension_CommonMeasurementObjectType_CM_Rsp,
        CommonMeasurementObjectType_CM_Rsp,
        __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab,
        ___Extension_CommonMeasurementObjectType_CM_Rsp_id_tab_val_Value_0,
        ___Extension_CommonMeasurementObjectType_CM_Rsp_id_tab_val_Value_1,
        _Extension_CommonMeasurementObjectType_CM_Rsp_id,
        _Extension_CommonMeasurementObjectType_CM_Rsp_criticality,
        _Extension_CommonMeasurementObjectType_CM_Rsp_value,
        Extension_CommonMeasurementObjectType_CM_Rsp,
        Extension_CommonMeasurementObjectType_CM_RspIE,
        _Extension_CommonMeasurementObjectType_CM_RspIE_val_Value_0,
        _Extension_CommonMeasurementObjectType_CM_RspIE_val_Value_1,
        _ERACH_CM_Rsp_commonMeasurementValue,
        ____ERACH_CM_Rsp_iE_Extensions__item__id_tab,
        ___ERACH_CM_Rsp_iE_Extensions__item__id,
        ____ERACH_CM_Rsp_iE_Extensions__item__criticality_tab,
        ___ERACH_CM_Rsp_iE_Extensions__item__criticality,
        ____ERACH_CM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___ERACH_CM_Rsp_iE_Extensions__item__extensionValue,
        __ERACH_CM_Rsp_iE_Extensions__item_,
        _ERACH_CM_Rsp_iE_Extensions,
        ERACH_CM_Rsp,
        ERACHItem_CM_Rsp_ExtIEs,
        _Cell_CM_Rsp_commonMeasurementValue,
        ____Cell_CM_Rsp_iE_Extensions__item__id_tab,
        _____Cell_CM_Rsp_iE_Extensions__item__id_tab_val_Extension_0,
        _____Cell_CM_Rsp_iE_Extensions__item__id_tab_val_Extension_1,
        ___Cell_CM_Rsp_iE_Extensions__item__id,
        ___Cell_CM_Rsp_iE_Extensions__item__criticality,
        ___Cell_CM_Rsp_iE_Extensions__item__extensionValue,
        __Cell_CM_Rsp_iE_Extensions__item_,
        _Cell_CM_Rsp_iE_Extensions,
        Cell_CM_Rsp,
        CellItem_CM_Rsp_ExtIEs,
        _CellItem_CM_Rsp_ExtIEs_val_Extension_0,
        _CellItem_CM_Rsp_ExtIEs_val_Extension_1,
        _RACH_CM_Rsp_commonMeasurementValue,
        ____RACH_CM_Rsp_iE_Extensions__item__id_tab,
        ___RACH_CM_Rsp_iE_Extensions__item__id,
        ____RACH_CM_Rsp_iE_Extensions__item__criticality_tab,
        ___RACH_CM_Rsp_iE_Extensions__item__criticality,
        ____RACH_CM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___RACH_CM_Rsp_iE_Extensions__item__extensionValue,
        __RACH_CM_Rsp_iE_Extensions__item_,
        _RACH_CM_Rsp_iE_Extensions,
        RACH_CM_Rsp,
        RACHItem_CM_Rsp_ExtIEs,
        _PowerLocalCellGroup_CM_Rsp_commonMeasurementValue,
        ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__id_tab,
        ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__id,
        ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__criticality_tab,
        ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__criticality,
        ____PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___PowerLocalCellGroup_CM_Rsp_iE_Extensions__item__extensionValue,
        __PowerLocalCellGroup_CM_Rsp_iE_Extensions__item_,
        _PowerLocalCellGroup_CM_Rsp_iE_Extensions,
        PowerLocalCellGroup_CM_Rsp,
        PowerLocalCellGroup_CM_Rsp_ExtIEs,
        ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab,
        _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___CommonMeasurementInitiationFailure_protocolIEs__item__id,
        ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality,
        ___CommonMeasurementInitiationFailure_protocolIEs__item__value,
        __CommonMeasurementInitiationFailure_protocolIEs__item_,
        _CommonMeasurementInitiationFailure_protocolIEs,
        ____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab,
        ___CommonMeasurementInitiationFailure_protocolExtensions__item__id,
        ____CommonMeasurementInitiationFailure_protocolExtensions__item__criticality_tab,
        ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality,
        ____CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab,
        ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue,
        __CommonMeasurementInitiationFailure_protocolExtensions__item_,
        _CommonMeasurementInitiationFailure_protocolExtensions,
        CommonMeasurementInitiationFailure,
        CommonMeasurementInitiationFailure_IEs,
        _CommonMeasurementInitiationFailure_IEs_val_Value_0,
        _CommonMeasurementInitiationFailure_IEs_val_Value_1,
        _CommonMeasurementInitiationFailure_IEs_val_Value_2,
        CommonMeasurementInitiationFailure_Extensions,
        ____CommonMeasurementReport_protocolIEs__item__id_tab,
        _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        ___CommonMeasurementReport_protocolIEs__item__id,
        ___CommonMeasurementReport_protocolIEs__item__criticality,
        ___CommonMeasurementReport_protocolIEs__item__value,
        __CommonMeasurementReport_protocolIEs__item_,
        _CommonMeasurementReport_protocolIEs,
        ____CommonMeasurementReport_protocolExtensions__item__id_tab,
        _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_1,
        ___CommonMeasurementReport_protocolExtensions__item__id,
        ___CommonMeasurementReport_protocolExtensions__item__criticality,
        ___CommonMeasurementReport_protocolExtensions__item__extensionValue,
        __CommonMeasurementReport_protocolExtensions__item_,
        _CommonMeasurementReport_protocolExtensions,
        CommonMeasurementReport,
        CommonMeasurementReport_IEs,
        _CommonMeasurementReport_IEs_val_Value_0,
        _CommonMeasurementReport_IEs_val_Value_1,
        _CommonMeasurementReport_IEs_val_Value_2,
        CommonMeasurementReport_Extensions,
        _CommonMeasurementReport_Extensions_val_Extension_0,
        _CommonMeasurementReport_Extensions_val_Extension_1,
        _CommonMeasurementObjectType_CM_Rprt_cell,
        _CommonMeasurementObjectType_CM_Rprt_rACH,
        _CommonMeasurementObjectType_CM_Rprt_notUsed_cPCH,
        _CommonMeasurementObjectType_CM_Rprt_extension_CommonMeasurementObjectType_CM_Rprt,
        CommonMeasurementObjectType_CM_Rprt,
        __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab,
        ___Extension_CommonMeasurementObjectType_CM_Rprt_id_tab_val_Value_0,
        ___Extension_CommonMeasurementObjectType_CM_Rprt_id_tab_val_Value_1,
        _Extension_CommonMeasurementObjectType_CM_Rprt_id,
        _Extension_CommonMeasurementObjectType_CM_Rprt_criticality,
        _Extension_CommonMeasurementObjectType_CM_Rprt_value,
        Extension_CommonMeasurementObjectType_CM_Rprt,
        Extension_CommonMeasurementObjectType_CM_RprtIE,
        _Extension_CommonMeasurementObjectType_CM_RprtIE_val_Value_0,
        _Extension_CommonMeasurementObjectType_CM_RprtIE_val_Value_1,
        _ERACH_CM_Rprt_commonMeasurementValueInformation,
        ____ERACH_CM_Rprt_iE_Extensions__item__id_tab,
        ___ERACH_CM_Rprt_iE_Extensions__item__id,
        ____ERACH_CM_Rprt_iE_Extensions__item__criticality_tab,
        ___ERACH_CM_Rprt_iE_Extensions__item__criticality,
        ____ERACH_CM_Rprt_iE_Extensions__item__extensionValue_tab,
        ___ERACH_CM_Rprt_iE_Extensions__item__extensionValue,
        __ERACH_CM_Rprt_iE_Extensions__item_,
        _ERACH_CM_Rprt_iE_Extensions,
        ERACH_CM_Rprt,
        ERACHItem_CM_Rprt_ExtIEs,
        _Cell_CM_Rprt_commonMeasurementValueInformation,
        ____Cell_CM_Rprt_iE_Extensions__item__id_tab,
        _____Cell_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_0,
        _____Cell_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_1,
        _____Cell_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_2,
        ___Cell_CM_Rprt_iE_Extensions__item__id,
        ___Cell_CM_Rprt_iE_Extensions__item__criticality,
        ___Cell_CM_Rprt_iE_Extensions__item__extensionValue,
        __Cell_CM_Rprt_iE_Extensions__item_,
        _Cell_CM_Rprt_iE_Extensions,
        Cell_CM_Rprt,
        CellItem_CM_Rprt_ExtIEs,
        _CellItem_CM_Rprt_ExtIEs_val_Extension_0,
        _CellItem_CM_Rprt_ExtIEs_val_Extension_1,
        _CellItem_CM_Rprt_ExtIEs_val_Extension_2,
        _RACH_CM_Rprt_commonMeasurementValueInformation,
        ____RACH_CM_Rprt_iE_Extensions__item__id_tab,
        _____RACH_CM_Rprt_iE_Extensions__item__id_tab_val_Extension_0,
        ___RACH_CM_Rprt_iE_Extensions__item__id,
        ___RACH_CM_Rprt_iE_Extensions__item__criticality,
        ___RACH_CM_Rprt_iE_Extensions__item__extensionValue,
        __RACH_CM_Rprt_iE_Extensions__item_,
        _RACH_CM_Rprt_iE_Extensions,
        RACH_CM_Rprt,
        RACHItem_CM_Rprt_ExtIEs,
        _RACHItem_CM_Rprt_ExtIEs_val_Extension_0,
        _PowerLocalCellGroup_CM_Rprt_commonMeasurementValueInformation,
        ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__id_tab,
        ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__id,
        ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__criticality_tab,
        ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__criticality,
        ____PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__extensionValue_tab,
        ___PowerLocalCellGroup_CM_Rprt_iE_Extensions__item__extensionValue,
        __PowerLocalCellGroup_CM_Rprt_iE_Extensions__item_,
        _PowerLocalCellGroup_CM_Rprt_iE_Extensions,
        PowerLocalCellGroup_CM_Rprt,
        PowerLocalCellGroup_CM_Rprt_ExtIEs,
        ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab,
        _____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___CommonMeasurementTerminationRequest_protocolIEs__item__id,
        ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality,
        ___CommonMeasurementTerminationRequest_protocolIEs__item__value,
        __CommonMeasurementTerminationRequest_protocolIEs__item_,
        _CommonMeasurementTerminationRequest_protocolIEs,
        ____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab,
        ___CommonMeasurementTerminationRequest_protocolExtensions__item__id,
        ____CommonMeasurementTerminationRequest_protocolExtensions__item__criticality_tab,
        ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality,
        ____CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab,
        ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue,
        __CommonMeasurementTerminationRequest_protocolExtensions__item_,
        _CommonMeasurementTerminationRequest_protocolExtensions,
        CommonMeasurementTerminationRequest,
        CommonMeasurementTerminationRequest_IEs,
        _CommonMeasurementTerminationRequest_IEs_val_Value_0,
        CommonMeasurementTerminationRequest_Extensions,
        ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___CommonMeasurementFailureIndication_protocolIEs__item__id,
        ___CommonMeasurementFailureIndication_protocolIEs__item__criticality,
        ___CommonMeasurementFailureIndication_protocolIEs__item__value,
        __CommonMeasurementFailureIndication_protocolIEs__item_,
        _CommonMeasurementFailureIndication_protocolIEs,
        ____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab,
        ___CommonMeasurementFailureIndication_protocolExtensions__item__id,
        ____CommonMeasurementFailureIndication_protocolExtensions__item__criticality_tab,
        ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality,
        ____CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab,
        ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue,
        __CommonMeasurementFailureIndication_protocolExtensions__item_,
        _CommonMeasurementFailureIndication_protocolExtensions,
        CommonMeasurementFailureIndication,
        CommonMeasurementFailureIndication_IEs,
        _CommonMeasurementFailureIndication_IEs_val_Value_0,
        _CommonMeasurementFailureIndication_IEs_val_Value_1,
        CommonMeasurementFailureIndication_Extensions,
        ____CellSetupRequestFDD_protocolIEs__item__id_tab,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_3,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_4,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_5,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_6,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_7,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_8,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_9,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_10,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_11,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_12,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_13,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_14,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_15,
        _____CellSetupRequestFDD_protocolIEs__item__id_tab_val_Value_16,
        ___CellSetupRequestFDD_protocolIEs__item__id,
        ___CellSetupRequestFDD_protocolIEs__item__criticality,
        ___CellSetupRequestFDD_protocolIEs__item__value,
        __CellSetupRequestFDD_protocolIEs__item_,
        _CellSetupRequestFDD_protocolIEs,
        ____CellSetupRequestFDD_protocolExtensions__item__id_tab,
        _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____CellSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_4,
        ___CellSetupRequestFDD_protocolExtensions__item__id,
        ___CellSetupRequestFDD_protocolExtensions__item__criticality,
        ___CellSetupRequestFDD_protocolExtensions__item__extensionValue,
        __CellSetupRequestFDD_protocolExtensions__item_,
        _CellSetupRequestFDD_protocolExtensions,
        CellSetupRequestFDD,
        CellSetupRequestFDD_IEs,
        _CellSetupRequestFDD_IEs_val_Value_0,
        _CellSetupRequestFDD_IEs_val_Value_1,
        _CellSetupRequestFDD_IEs_val_Value_2,
        _CellSetupRequestFDD_IEs_val_Value_3,
        _CellSetupRequestFDD_IEs_val_Value_4,
        _CellSetupRequestFDD_IEs_val_Value_5,
        _CellSetupRequestFDD_IEs_val_Value_6,
        _CellSetupRequestFDD_IEs_val_Value_7,
        _CellSetupRequestFDD_IEs_val_Value_8,
        _CellSetupRequestFDD_IEs_val_Value_9,
        _CellSetupRequestFDD_IEs_val_Value_10,
        _CellSetupRequestFDD_IEs_val_Value_11,
        _CellSetupRequestFDD_IEs_val_Value_12,
        _CellSetupRequestFDD_IEs_val_Value_13,
        _CellSetupRequestFDD_IEs_val_Value_14,
        _CellSetupRequestFDD_IEs_val_Value_15,
        _CellSetupRequestFDD_IEs_val_Value_16,
        CellSetupRequestFDD_Extensions,
        _CellSetupRequestFDD_Extensions_val_Extension_0,
        _CellSetupRequestFDD_Extensions_val_Extension_1,
        _CellSetupRequestFDD_Extensions_val_Extension_2,
        _CellSetupRequestFDD_Extensions_val_Extension_3,
        _CellSetupRequestFDD_Extensions_val_Extension_4,
        _Synchronisation_Configuration_Cell_SetupRqst_n_INSYNC_IND,
        _Synchronisation_Configuration_Cell_SetupRqst_n_OUTSYNC_IND,
        _Synchronisation_Configuration_Cell_SetupRqst_t_RLFAILURE,
        ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__id_tab,
        ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__id,
        ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__criticality_tab,
        ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__criticality,
        ____Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__extensionValue_tab,
        ___Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item__extensionValue,
        __Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions__item_,
        _Synchronisation_Configuration_Cell_SetupRqst_iE_Extensions,
        Synchronisation_Configuration_Cell_SetupRqst,
        Synchronisation_Configuration_Cell_SetupRqst_ExtIEs,
        _PrimarySCH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID,
        _PrimarySCH_Information_Cell_SetupRqstFDD_primarySCH_Power,
        _PrimarySCH_Information_Cell_SetupRqstFDD_tSTD_Indicator,
        ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id,
        ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality,
        ____PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_,
        _PrimarySCH_Information_Cell_SetupRqstFDD_iE_Extensions,
        PrimarySCH_Information_Cell_SetupRqstFDD,
        PrimarySCH_Information_Cell_SetupRqstFDD_ExtIEs,
        _SecondarySCH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID,
        _SecondarySCH_Information_Cell_SetupRqstFDD_secondarySCH_Power,
        _SecondarySCH_Information_Cell_SetupRqstFDD_tSTD_Indicator,
        ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id,
        ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality,
        ____SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_,
        _SecondarySCH_Information_Cell_SetupRqstFDD_iE_Extensions,
        SecondarySCH_Information_Cell_SetupRqstFDD,
        SecondarySCH_Information_Cell_SetupRqstFDD_ExtIEs,
        _PrimaryCPICH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID,
        _PrimaryCPICH_Information_Cell_SetupRqstFDD_primaryCPICH_Power,
        _PrimaryCPICH_Information_Cell_SetupRqstFDD_transmitDiversityIndicator,
        ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id,
        ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality,
        ____PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions__item_,
        _PrimaryCPICH_Information_Cell_SetupRqstFDD_iE_Extensions,
        PrimaryCPICH_Information_Cell_SetupRqstFDD,
        PrimaryCPICH_Information_Cell_SetupRqstFDD_ExtIEs,
        ___SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id_tab,
        ____SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id_tab_val_Value_0,
        __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__id,
        __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__criticality,
        __SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item__value,
        _SecondaryCPICH_InformationList_Cell_SetupRqstFDD__item_,
        SecondaryCPICH_InformationList_Cell_SetupRqstFDD,
        SecondaryCPICH_InformationItemIE_Cell_SetupRqstFDD,
        _SecondaryCPICH_InformationItemIE_Cell_SetupRqstFDD_val_Value_0,
        _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_commonPhysicalChannelID,
        _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_dl_ScramblingCode,
        _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_fDD_DL_ChannelisationCodeNumber,
        _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_secondaryCPICH_Power,
        _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_transmitDiversityIndicator,
        ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id,
        ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality,
        ____SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item_,
        _SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_iE_Extensions,
        SecondaryCPICH_InformationItem_Cell_SetupRqstFDD,
        SecondaryCPICH_InformationItem_Cell_SetupRqstFDD_ExtIEs,
        _PrimaryCCPCH_Information_Cell_SetupRqstFDD_commonPhysicalChannelID,
        _PrimaryCCPCH_Information_Cell_SetupRqstFDD_bCH_information,
        _PrimaryCCPCH_Information_Cell_SetupRqstFDD_sTTD_Indicator,
        ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id,
        ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality,
        ____PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_,
        _PrimaryCCPCH_Information_Cell_SetupRqstFDD_iE_Extensions,
        PrimaryCCPCH_Information_Cell_SetupRqstFDD,
        PrimaryCCPCH_Information_Cell_SetupRqstFDD_ExtIEs,
        _BCH_Information_Cell_SetupRqstFDD_commonTransportChannelID,
        _BCH_Information_Cell_SetupRqstFDD_bCH_Power,
        ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__id,
        ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality,
        ____BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __BCH_Information_Cell_SetupRqstFDD_iE_Extensions__item_,
        _BCH_Information_Cell_SetupRqstFDD_iE_Extensions,
        BCH_Information_Cell_SetupRqstFDD,
        BCH_Information_Cell_SetupRqstFDD_ExtIEs,
        _Limited_power_increase_information_Cell_SetupRqstFDD_powerRaiseLimit,
        _Limited_power_increase_information_Cell_SetupRqstFDD_dLPowerAveragingWindowSize,
        ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__id,
        ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__criticality,
        ____Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions__item_,
        _Limited_power_increase_information_Cell_SetupRqstFDD_iE_Extensions,
        Limited_power_increase_information_Cell_SetupRqstFDD,
        Limited_power_increase_information_Cell_SetupRqstFDD_ExtIEs,
        _IPDLParameter_Information_Cell_SetupRqstFDD_iPDL_FDD_Parameters,
        _IPDLParameter_Information_Cell_SetupRqstFDD_iPDL_Indicator,
        ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__id,
        ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__criticality,
        ____IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions__item_,
        _IPDLParameter_Information_Cell_SetupRqstFDD_iE_Extensions,
        IPDLParameter_Information_Cell_SetupRqstFDD,
        IPDLParameter_Information_Cell_SetupRqstFDD_ExtIEs,
        ___CellPortion_InformationList_Cell_SetupRqstFDD__item__id_tab,
        ____CellPortion_InformationList_Cell_SetupRqstFDD__item__id_tab_val_Value_0,
        __CellPortion_InformationList_Cell_SetupRqstFDD__item__id,
        __CellPortion_InformationList_Cell_SetupRqstFDD__item__criticality,
        __CellPortion_InformationList_Cell_SetupRqstFDD__item__value,
        _CellPortion_InformationList_Cell_SetupRqstFDD__item_,
        CellPortion_InformationList_Cell_SetupRqstFDD,
        CellPortion_InformationItemIE_Cell_SetupRqstFDD,
        _CellPortion_InformationItemIE_Cell_SetupRqstFDD_val_Value_0,
        _CellPortion_InformationItem_Cell_SetupRqstFDD_cellPortionID,
        _CellPortion_InformationItem_Cell_SetupRqstFDD_associatedSecondaryCPICH,
        _CellPortion_InformationItem_Cell_SetupRqstFDD_maximumTransmissionPowerforCellPortion,
        ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__id,
        ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__criticality,
        ____CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions__item_,
        _CellPortion_InformationItem_Cell_SetupRqstFDD_iE_Extensions,
        CellPortion_InformationItem_Cell_SetupRqstFDD,
        CellPortion_InformationItem_Cell_SetupRqstFDD_ExtIEs,
        ____CellSetupRequestTDD_protocolIEs__item__id_tab,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_3,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_4,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_5,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_6,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_7,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_8,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_9,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_10,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_11,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_12,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_13,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_14,
        _____CellSetupRequestTDD_protocolIEs__item__id_tab_val_Value_15,
        ___CellSetupRequestTDD_protocolIEs__item__id,
        ___CellSetupRequestTDD_protocolIEs__item__criticality,
        ___CellSetupRequestTDD_protocolIEs__item__value,
        __CellSetupRequestTDD_protocolIEs__item_,
        _CellSetupRequestTDD_protocolIEs,
        ____CellSetupRequestTDD_protocolExtensions__item__id_tab,
        _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____CellSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_9,
        ___CellSetupRequestTDD_protocolExtensions__item__id,
        ___CellSetupRequestTDD_protocolExtensions__item__criticality,
        ___CellSetupRequestTDD_protocolExtensions__item__extensionValue,
        __CellSetupRequestTDD_protocolExtensions__item_,
        _CellSetupRequestTDD_protocolExtensions,
        CellSetupRequestTDD,
        CellSetupRequestTDD_IEs,
        _CellSetupRequestTDD_IEs_val_Value_0,
        _CellSetupRequestTDD_IEs_val_Value_1,
        _CellSetupRequestTDD_IEs_val_Value_2,
        _CellSetupRequestTDD_IEs_val_Value_3,
        _CellSetupRequestTDD_IEs_val_Value_4,
        _CellSetupRequestTDD_IEs_val_Value_5,
        _CellSetupRequestTDD_IEs_val_Value_6,
        _CellSetupRequestTDD_IEs_val_Value_7,
        _CellSetupRequestTDD_IEs_val_Value_8,
        _CellSetupRequestTDD_IEs_val_Value_9,
        _CellSetupRequestTDD_IEs_val_Value_10,
        _CellSetupRequestTDD_IEs_val_Value_11,
        _CellSetupRequestTDD_IEs_val_Value_12,
        _CellSetupRequestTDD_IEs_val_Value_13,
        _CellSetupRequestTDD_IEs_val_Value_14,
        _CellSetupRequestTDD_IEs_val_Value_15,
        CellSetupRequestTDD_Extensions,
        _CellSetupRequestTDD_Extensions_val_Extension_0,
        _CellSetupRequestTDD_Extensions_val_Extension_1,
        _CellSetupRequestTDD_Extensions_val_Extension_2,
        _CellSetupRequestTDD_Extensions_val_Extension_3,
        _CellSetupRequestTDD_Extensions_val_Extension_4,
        _CellSetupRequestTDD_Extensions_val_Extension_5,
        _CellSetupRequestTDD_Extensions_val_Extension_6,
        _CellSetupRequestTDD_Extensions_val_Extension_7,
        _CellSetupRequestTDD_Extensions_val_Extension_8,
        _CellSetupRequestTDD_Extensions_val_Extension_9,
        _SCH_Information_Cell_SetupRqstTDD_commonPhysicalChannelID,
        _SCH_Information_Cell_SetupRqstTDD_syncCaseIndicator,
        _SCH_Information_Cell_SetupRqstTDD_sCH_Power,
        _SCH_Information_Cell_SetupRqstTDD_tSTD_Indicator,
        ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ____SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __SCH_Information_Cell_SetupRqstTDD_iE_Extensions__item_,
        _SCH_Information_Cell_SetupRqstTDD_iE_Extensions,
        SCH_Information_Cell_SetupRqstTDD,
        SCH_Information_Cell_SetupRqstTDD_ExtIEs,
        __SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id_tab,
        ___SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id_tab_val_Value_0,
        _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_id,
        _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_criticality,
        _SyncCaseIndicator_Cell_SetupRqstTDD_PSCH_value,
        SyncCaseIndicator_Cell_SetupRqstTDD_PSCH,
        SyncCaseIndicatorIE_Cell_SetupRqstTDD_PSCH,
        _SyncCaseIndicatorIE_Cell_SetupRqstTDD_PSCH_val_Value_0,
        _SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH_case1,
        _SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH_case2,
        SyncCaseIndicatorItem_Cell_SetupRqstTDD_PSCH,
        _Case1_Cell_SetupRqstTDD_timeSlot,
        ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ____Case1_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___Case1_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __Case1_Cell_SetupRqstTDD_iE_Extensions__item_,
        _Case1_Cell_SetupRqstTDD_iE_Extensions,
        Case1_Cell_SetupRqstTDD,
        Case1Item_Cell_SetupRqstTDD_ExtIEs,
        _Case2_Cell_SetupRqstTDD_sCH_TimeSlot,
        ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ____Case2_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___Case2_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __Case2_Cell_SetupRqstTDD_iE_Extensions__item_,
        _Case2_Cell_SetupRqstTDD_iE_Extensions,
        Case2_Cell_SetupRqstTDD,
        Case2Item_Cell_SetupRqstTDD_ExtIEs,
        _PCCPCH_Information_Cell_SetupRqstTDD_commonPhysicalChannelID,
        _PCCPCH_Information_Cell_SetupRqstTDD_tdd_PhysicalChannelOffset,
        _PCCPCH_Information_Cell_SetupRqstTDD_repetitionPeriod,
        _PCCPCH_Information_Cell_SetupRqstTDD_repetitionLength,
        _PCCPCH_Information_Cell_SetupRqstTDD_pCCPCH_Power,
        _PCCPCH_Information_Cell_SetupRqstTDD_sCTD_Indicator,
        ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ____PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions__item_,
        _PCCPCH_Information_Cell_SetupRqstTDD_iE_Extensions,
        PCCPCH_Information_Cell_SetupRqstTDD,
        PCCPCH_Information_Cell_SetupRqstTDD_ExtIEs,
        _TimeSlotConfigurationList_Cell_SetupRqstTDD__item_,
        TimeSlotConfigurationList_Cell_SetupRqstTDD,
        _TimeSlotConfigurationItem_Cell_SetupRqstTDD_timeSlot,
        _TimeSlotConfigurationItem_Cell_SetupRqstTDD_timeSlotStatus,
        _TimeSlotConfigurationItem_Cell_SetupRqstTDD_timeSlotDirection,
        ____TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ___TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions__item_,
        _TimeSlotConfigurationItem_Cell_SetupRqstTDD_iE_Extensions,
        TimeSlotConfigurationItem_Cell_SetupRqstTDD,
        TimeSlotConfigurationItem_Cell_SetupRqstTDD_ExtIEs,
        _TimeSlotConfigurationItem_Cell_SetupRqstTDD_ExtIEs_val_Extension_0,
        _TimeSlotConfigurationList_LCR_Cell_SetupRqstTDD__item_,
        TimeSlotConfigurationList_LCR_Cell_SetupRqstTDD,
        _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_timeSlotLCR,
        _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_timeSlotStatus,
        _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_timeSlotDirection,
        ____TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ___TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions__item_,
        _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_iE_Extensions,
        TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD,
        TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_ExtIEs,
        _TimeSlotConfigurationItem_LCR_Cell_SetupRqstTDD_ExtIEs_val_Extension_0,
        _PCCPCH_LCR_Information_Cell_SetupRqstTDD_commonPhysicalChannelID,
        _PCCPCH_LCR_Information_Cell_SetupRqstTDD_tdd_PhysicalChannelOffset,
        _PCCPCH_LCR_Information_Cell_SetupRqstTDD_repetitionPeriod,
        _PCCPCH_LCR_Information_Cell_SetupRqstTDD_repetitionLength,
        _PCCPCH_LCR_Information_Cell_SetupRqstTDD_pCCPCH_Power,
        _PCCPCH_LCR_Information_Cell_SetupRqstTDD_sCTD_Indicator,
        _PCCPCH_LCR_Information_Cell_SetupRqstTDD_tSTD_Indicator,
        ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ____PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item_,
        _PCCPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions,
        PCCPCH_LCR_Information_Cell_SetupRqstTDD,
        PCCPCH_LCR_Information_Cell_SetupRqstTDD_ExtIEs,
        _DwPCH_LCR_Information_Cell_SetupRqstTDD_commonPhysicalChannelId,
        _DwPCH_LCR_Information_Cell_SetupRqstTDD_tSTD_Indicator,
        _DwPCH_LCR_Information_Cell_SetupRqstTDD_dwPCH_Power,
        ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ____DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions__item_,
        _DwPCH_LCR_Information_Cell_SetupRqstTDD_iE_Extensions,
        DwPCH_LCR_Information_Cell_SetupRqstTDD,
        DwPCH_LCR_Information_Cell_SetupRqstTDD_ExtIEs,
        _IPDLParameter_Information_Cell_SetupRqstTDD_iPDL_TDD_Parameters,
        _IPDLParameter_Information_Cell_SetupRqstTDD_iPDL_Indicator,
        ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ____IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions__item_,
        _IPDLParameter_Information_Cell_SetupRqstTDD_iE_Extensions,
        IPDLParameter_Information_Cell_SetupRqstTDD,
        IPDLParameter_Information_Cell_SetupRqstTDD_ExtIEs,
        _IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iPDL_TDD_Parameters_LCR,
        _IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iPDL_Indicator,
        ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ____IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions__item_,
        _IPDLParameter_Information_LCR_Cell_SetupRqstTDD_iE_Extensions,
        IPDLParameter_Information_LCR_Cell_SetupRqstTDD,
        IPDLParameter_Information_LCR_Cell_SetupRqstTDD_ExtIEs,
        _PCCPCH_768_Information_Cell_SetupRqstTDD_commonPhysicalChannelID768,
        _PCCPCH_768_Information_Cell_SetupRqstTDD_tdd_PhysicalChannelOffset,
        _PCCPCH_768_Information_Cell_SetupRqstTDD_repetitionPeriod,
        _PCCPCH_768_Information_Cell_SetupRqstTDD_repetitionLength,
        _PCCPCH_768_Information_Cell_SetupRqstTDD_pCCPCH_Power,
        _PCCPCH_768_Information_Cell_SetupRqstTDD_sCTD_Indicator,
        ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ____PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item_,
        _PCCPCH_768_Information_Cell_SetupRqstTDD_iE_Extensions,
        PCCPCH_768_Information_Cell_SetupRqstTDD,
        PCCPCH_768_Information_Cell_SetupRqstTDD_ExtIEs,
        _SCH_768_Information_Cell_SetupRqstTDD_commonPhysicalChannelID768,
        _SCH_768_Information_Cell_SetupRqstTDD_syncCaseIndicator,
        _SCH_768_Information_Cell_SetupRqstTDD_sCH_Power,
        _SCH_768_Information_Cell_SetupRqstTDD_tSTD_Indicator,
        ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ____SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions__item_,
        _SCH_768_Information_Cell_SetupRqstTDD_iE_Extensions,
        SCH_768_Information_Cell_SetupRqstTDD,
        SCH_768_Information_Cell_SetupRqstTDD_ExtIEs,
        _Cell_Frequency_List_LCR_MulFreq_Cell_SetupRqstTDD__item_,
        Cell_Frequency_List_LCR_MulFreq_Cell_SetupRqstTDD,
        _Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_uARFCN,
        _Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_timeSlotConfigurationList_LCR_Cell_SetupRqstTDD,
        ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__id,
        ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__criticality,
        ____Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions__item_,
        _Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_iE_Extensions,
        Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD,
        Cell_Frequency_Item_LCR_MulFreq_Cell_SetupRqstTDD_ExtIEs,
        ____CellSetupResponse_protocolIEs__item__id_tab,
        _____CellSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        ___CellSetupResponse_protocolIEs__item__id,
        ___CellSetupResponse_protocolIEs__item__criticality,
        ___CellSetupResponse_protocolIEs__item__value,
        __CellSetupResponse_protocolIEs__item_,
        _CellSetupResponse_protocolIEs,
        ____CellSetupResponse_protocolExtensions__item__id_tab,
        ___CellSetupResponse_protocolExtensions__item__id,
        ____CellSetupResponse_protocolExtensions__item__criticality_tab,
        ___CellSetupResponse_protocolExtensions__item__criticality,
        ____CellSetupResponse_protocolExtensions__item__extensionValue_tab,
        ___CellSetupResponse_protocolExtensions__item__extensionValue,
        __CellSetupResponse_protocolExtensions__item_,
        _CellSetupResponse_protocolExtensions,
        CellSetupResponse,
        CellSetupResponse_IEs,
        _CellSetupResponse_IEs_val_Value_0,
        CellSetupResponse_Extensions,
        ____CellSetupFailure_protocolIEs__item__id_tab,
        _____CellSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____CellSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        ___CellSetupFailure_protocolIEs__item__id,
        ___CellSetupFailure_protocolIEs__item__criticality,
        ___CellSetupFailure_protocolIEs__item__value,
        __CellSetupFailure_protocolIEs__item_,
        _CellSetupFailure_protocolIEs,
        ____CellSetupFailure_protocolExtensions__item__id_tab,
        ___CellSetupFailure_protocolExtensions__item__id,
        ____CellSetupFailure_protocolExtensions__item__criticality_tab,
        ___CellSetupFailure_protocolExtensions__item__criticality,
        ____CellSetupFailure_protocolExtensions__item__extensionValue_tab,
        ___CellSetupFailure_protocolExtensions__item__extensionValue,
        __CellSetupFailure_protocolExtensions__item_,
        _CellSetupFailure_protocolExtensions,
        CellSetupFailure,
        CellSetupFailure_IEs,
        _CellSetupFailure_IEs_val_Value_0,
        _CellSetupFailure_IEs_val_Value_1,
        CellSetupFailure_Extensions,
        ____CellReconfigurationRequestFDD_protocolIEs__item__id_tab,
        _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1,
        _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2,
        _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3,
        _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4,
        _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5,
        _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6,
        _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_7,
        _____CellReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_8,
        ___CellReconfigurationRequestFDD_protocolIEs__item__id,
        ___CellReconfigurationRequestFDD_protocolIEs__item__criticality,
        ___CellReconfigurationRequestFDD_protocolIEs__item__value,
        __CellReconfigurationRequestFDD_protocolIEs__item_,
        _CellReconfigurationRequestFDD_protocolIEs,
        ____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab,
        _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____CellReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5,
        ___CellReconfigurationRequestFDD_protocolExtensions__item__id,
        ___CellReconfigurationRequestFDD_protocolExtensions__item__criticality,
        ___CellReconfigurationRequestFDD_protocolExtensions__item__extensionValue,
        __CellReconfigurationRequestFDD_protocolExtensions__item_,
        _CellReconfigurationRequestFDD_protocolExtensions,
        CellReconfigurationRequestFDD,
        CellReconfigurationRequestFDD_IEs,
        _CellReconfigurationRequestFDD_IEs_val_Value_0,
        _CellReconfigurationRequestFDD_IEs_val_Value_1,
        _CellReconfigurationRequestFDD_IEs_val_Value_2,
        _CellReconfigurationRequestFDD_IEs_val_Value_3,
        _CellReconfigurationRequestFDD_IEs_val_Value_4,
        _CellReconfigurationRequestFDD_IEs_val_Value_5,
        _CellReconfigurationRequestFDD_IEs_val_Value_6,
        _CellReconfigurationRequestFDD_IEs_val_Value_7,
        _CellReconfigurationRequestFDD_IEs_val_Value_8,
        CellReconfigurationRequestFDD_Extensions,
        _CellReconfigurationRequestFDD_Extensions_val_Extension_0,
        _CellReconfigurationRequestFDD_Extensions_val_Extension_1,
        _CellReconfigurationRequestFDD_Extensions_val_Extension_2,
        _CellReconfigurationRequestFDD_Extensions_val_Extension_3,
        _CellReconfigurationRequestFDD_Extensions_val_Extension_4,
        _CellReconfigurationRequestFDD_Extensions_val_Extension_5,
        _Synchronisation_Configuration_Cell_ReconfRqst_n_INSYNC_IND,
        _Synchronisation_Configuration_Cell_ReconfRqst_n_OUTSYNC_IND,
        _Synchronisation_Configuration_Cell_ReconfRqst_t_RLFAILURE,
        ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__id_tab,
        ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__id,
        ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__criticality,
        ____Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item__extensionValue,
        __Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions__item_,
        _Synchronisation_Configuration_Cell_ReconfRqst_iE_Extensions,
        Synchronisation_Configuration_Cell_ReconfRqst,
        Synchronisation_Configuration_Cell_ReconfRqst_ExtIEs,
        _PrimarySCH_Information_Cell_ReconfRqstFDD_commonPhysicalChannelID,
        _PrimarySCH_Information_Cell_ReconfRqstFDD_primarySCH_Power,
        ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id,
        ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_,
        _PrimarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions,
        PrimarySCH_Information_Cell_ReconfRqstFDD,
        PrimarySCH_Information_Cell_ReconfRqstFDD_ExtIEs,
        _SecondarySCH_Information_Cell_ReconfRqstFDD_commonPhysicalChannelID,
        _SecondarySCH_Information_Cell_ReconfRqstFDD_secondarySCH_Power,
        ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id,
        ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_,
        _SecondarySCH_Information_Cell_ReconfRqstFDD_iE_Extensions,
        SecondarySCH_Information_Cell_ReconfRqstFDD,
        SecondarySCH_Information_Cell_ReconfRqstFDD_ExtIEs,
        _PrimaryCPICH_Information_Cell_ReconfRqstFDD_commonPhysicalChannelID,
        _PrimaryCPICH_Information_Cell_ReconfRqstFDD_primaryCPICH_Power,
        ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id,
        ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_,
        _PrimaryCPICH_Information_Cell_ReconfRqstFDD_iE_Extensions,
        PrimaryCPICH_Information_Cell_ReconfRqstFDD,
        PrimaryCPICH_Information_Cell_ReconfRqstFDD_ExtIEs,
        ___SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id_tab,
        ____SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id_tab_val_Value_0,
        __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__id,
        __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__criticality,
        __SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item__value,
        _SecondaryCPICH_InformationList_Cell_ReconfRqstFDD__item_,
        SecondaryCPICH_InformationList_Cell_ReconfRqstFDD,
        SecondaryCPICH_InformationItemIE_Cell_ReconfRqstFDD,
        _SecondaryCPICH_InformationItemIE_Cell_ReconfRqstFDD_val_Value_0,
        _SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_commonPhysicalChannelID,
        _SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_secondaryCPICH_Power,
        ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id,
        ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item_,
        _SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_iE_Extensions,
        SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD,
        SecondaryCPICH_InformationItem_Cell_ReconfRqstFDD_ExtIEs,
        _PrimaryCCPCH_Information_Cell_ReconfRqstFDD_bCH_information,
        ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id,
        ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions__item_,
        _PrimaryCCPCH_Information_Cell_ReconfRqstFDD_iE_Extensions,
        PrimaryCCPCH_Information_Cell_ReconfRqstFDD,
        PrimaryCCPCH_Information_Cell_ReconfRqstFDD_ExtIEs,
        _BCH_information_Cell_ReconfRqstFDD_commonTransportChannelID,
        _BCH_information_Cell_ReconfRqstFDD_bCH_Power,
        ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__id,
        ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __BCH_information_Cell_ReconfRqstFDD_iE_Extensions__item_,
        _BCH_information_Cell_ReconfRqstFDD_iE_Extensions,
        BCH_information_Cell_ReconfRqstFDD,
        BCH_information_Cell_ReconfRqstFDD_ExtIEs,
        _IPDLParameter_Information_Cell_ReconfRqstFDD_iPDL_FDD_Parameters,
        _IPDLParameter_Information_Cell_ReconfRqstFDD_iPDL_Indicator,
        ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__id,
        ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions__item_,
        _IPDLParameter_Information_Cell_ReconfRqstFDD_iE_Extensions,
        IPDLParameter_Information_Cell_ReconfRqstFDD,
        IPDLParameter_Information_Cell_ReconfRqstFDD_ExtIEs,
        ___CellPortion_InformationList_Cell_ReconfRqstFDD__item__id_tab,
        ____CellPortion_InformationList_Cell_ReconfRqstFDD__item__id_tab_val_Value_0,
        __CellPortion_InformationList_Cell_ReconfRqstFDD__item__id,
        __CellPortion_InformationList_Cell_ReconfRqstFDD__item__criticality,
        __CellPortion_InformationList_Cell_ReconfRqstFDD__item__value,
        _CellPortion_InformationList_Cell_ReconfRqstFDD__item_,
        CellPortion_InformationList_Cell_ReconfRqstFDD,
        CellPortion_InformationItemIE_Cell_ReconfRqstFDD,
        _CellPortion_InformationItemIE_Cell_ReconfRqstFDD_val_Value_0,
        _CellPortion_InformationItem_Cell_ReconfRqstFDD_cellPortionID,
        _CellPortion_InformationItem_Cell_ReconfRqstFDD_maximumTransmissionPowerforCellPortion,
        ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__id,
        ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions__item_,
        _CellPortion_InformationItem_Cell_ReconfRqstFDD_iE_Extensions,
        CellPortion_InformationItem_Cell_ReconfRqstFDD,
        CellPortion_InformationItem_Cell_ReconfRqstFDD_ExtIEs,
        ____CellReconfigurationRequestTDD_protocolIEs__item__id_tab,
        _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3,
        _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4,
        _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5,
        _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6,
        _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7,
        _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_8,
        _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_9,
        _____CellReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_10,
        ___CellReconfigurationRequestTDD_protocolIEs__item__id,
        ___CellReconfigurationRequestTDD_protocolIEs__item__criticality,
        ___CellReconfigurationRequestTDD_protocolIEs__item__value,
        __CellReconfigurationRequestTDD_protocolIEs__item_,
        _CellReconfigurationRequestTDD_protocolIEs,
        ____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab,
        _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____CellReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7,
        ___CellReconfigurationRequestTDD_protocolExtensions__item__id,
        ___CellReconfigurationRequestTDD_protocolExtensions__item__criticality,
        ___CellReconfigurationRequestTDD_protocolExtensions__item__extensionValue,
        __CellReconfigurationRequestTDD_protocolExtensions__item_,
        _CellReconfigurationRequestTDD_protocolExtensions,
        CellReconfigurationRequestTDD,
        CellReconfigurationRequestTDD_IEs,
        _CellReconfigurationRequestTDD_IEs_val_Value_0,
        _CellReconfigurationRequestTDD_IEs_val_Value_1,
        _CellReconfigurationRequestTDD_IEs_val_Value_2,
        _CellReconfigurationRequestTDD_IEs_val_Value_3,
        _CellReconfigurationRequestTDD_IEs_val_Value_4,
        _CellReconfigurationRequestTDD_IEs_val_Value_5,
        _CellReconfigurationRequestTDD_IEs_val_Value_6,
        _CellReconfigurationRequestTDD_IEs_val_Value_7,
        _CellReconfigurationRequestTDD_IEs_val_Value_8,
        _CellReconfigurationRequestTDD_IEs_val_Value_9,
        _CellReconfigurationRequestTDD_IEs_val_Value_10,
        CellReconfigurationRequestTDD_Extensions,
        _CellReconfigurationRequestTDD_Extensions_val_Extension_0,
        _CellReconfigurationRequestTDD_Extensions_val_Extension_1,
        _CellReconfigurationRequestTDD_Extensions_val_Extension_2,
        _CellReconfigurationRequestTDD_Extensions_val_Extension_3,
        _CellReconfigurationRequestTDD_Extensions_val_Extension_4,
        _CellReconfigurationRequestTDD_Extensions_val_Extension_5,
        _CellReconfigurationRequestTDD_Extensions_val_Extension_6,
        _CellReconfigurationRequestTDD_Extensions_val_Extension_7,
        _SCH_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID,
        _SCH_Information_Cell_ReconfRqstTDD_sCH_Power,
        ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __SCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _SCH_Information_Cell_ReconfRqstTDD_iE_Extensions,
        SCH_Information_Cell_ReconfRqstTDD,
        PSCH_Information_Cell_ReconfRqstTDD_ExtIEs,
        _PCCPCH_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID,
        _PCCPCH_Information_Cell_ReconfRqstTDD_pCCPCH_Power,
        ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _PCCPCH_Information_Cell_ReconfRqstTDD_iE_Extensions,
        PCCPCH_Information_Cell_ReconfRqstTDD,
        PCCPCH_Information_Cell_ReconfRqstTDD_ExtIEs,
        _TimeSlotConfigurationList_Cell_ReconfRqstTDD__item_,
        TimeSlotConfigurationList_Cell_ReconfRqstTDD,
        _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_timeSlot,
        _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_timeSlotStatus,
        _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_timeSlotDirection,
        ____TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        _____TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ___TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_iE_Extensions,
        TimeSlotConfigurationItem_Cell_ReconfRqstTDD,
        TimeSlotConfigurationItem_Cell_ReconfRqstTDD_ExtIEs,
        _TimeSlotConfigurationItem_Cell_ReconfRqstTDD_ExtIEs_val_Extension_0,
        _TimeSlotConfigurationList_LCR_Cell_ReconfRqstTDD__item_,
        TimeSlotConfigurationList_LCR_Cell_ReconfRqstTDD,
        _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_timeSlotLCR,
        _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_timeSlotStatus,
        _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_timeSlotDirection,
        ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_iE_Extensions,
        TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD,
        TimeSlotConfigurationItem_LCR_Cell_ReconfRqstTDD_ExtIEs,
        _DwPCH_LCR_Information_Cell_ReconfRqstTDD_commonPhysicalChannelId,
        _DwPCH_LCR_Information_Cell_ReconfRqstTDD_dwPCH_Power,
        ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _DwPCH_LCR_Information_Cell_ReconfRqstTDD_iE_Extensions,
        DwPCH_LCR_Information_Cell_ReconfRqstTDD,
        DwPCH_LCR_Information_Cell_ReconfRqstTDD_ExtIEs,
        _IPDLParameter_Information_Cell_ReconfRqstTDD_iPDL_TDD_Parameters,
        _IPDLParameter_Information_Cell_ReconfRqstTDD_iPDL_Indicator,
        ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _IPDLParameter_Information_Cell_ReconfRqstTDD_iE_Extensions,
        IPDLParameter_Information_Cell_ReconfRqstTDD,
        IPDLParameter_Information_Cell_ReconfRqstTDD_ExtIEs,
        _IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iPDL_TDD_Parameters_LCR,
        _IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iPDL_Indicator,
        ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_iE_Extensions,
        IPDLParameter_Information_LCR_Cell_ReconfRqstTDD,
        IPDLParameter_Information_LCR_Cell_ReconfRqstTDD_ExtIEs,
        _SCH_768_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID768,
        _SCH_768_Information_Cell_ReconfRqstTDD_sCH_Power,
        ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _SCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions,
        SCH_768_Information_Cell_ReconfRqstTDD,
        PSCH_768_Information_Cell_ReconfRqstTDD_ExtIEs,
        _PCCPCH_768_Information_Cell_ReconfRqstTDD_commonPhysicalChannelID768,
        _PCCPCH_768_Information_Cell_ReconfRqstTDD_pCCPCH_Power,
        ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _PCCPCH_768_Information_Cell_ReconfRqstTDD_iE_Extensions,
        PCCPCH_768_Information_Cell_ReconfRqstTDD,
        PCCPCH_768_Information_Cell_ReconfRqstTDD_ExtIEs,
        _UARFCN_Adjustment_cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD,
        _UARFCN_Adjustment_cell_Frequency_ModifyList_LCR_MulFreq_Cell_ReconfRqstTDD,
        _UARFCN_Adjustment_cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD,
        UARFCN_Adjustment,
        _Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_uARFCN,
        _Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_timeSlotConfigurationList_LCR_Cell_ReconfRqstTDD,
        ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions,
        Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD,
        Cell_Frequency_Add_LCR_MulFreq_Cell_ReconfRqstTDD_ExtIEs,
        _Cell_Frequency_ModifyList_LCR_MulFreq_Cell_ReconfRqstTDD__item_,
        Cell_Frequency_ModifyList_LCR_MulFreq_Cell_ReconfRqstTDD,
        _Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_uARFCN,
        _Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_timeSlotConfigurationList_LCR_Cell_ReconfRqstTDD,
        ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions,
        Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD,
        Cell_Frequency_ModifyItem_LCR_MulFreq_Cell_ReconfRqstTDD_ExtIEs,
        _Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_uARFCN,
        ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__id,
        ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions__item_,
        _Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_iE_Extensions,
        Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD,
        Cell_Frequency_Delete_LCR_MulFreq_Cell_ReconfRqstTDD_ExtIEs,
        ____CellReconfigurationResponse_protocolIEs__item__id_tab,
        _____CellReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0,
        ___CellReconfigurationResponse_protocolIEs__item__id,
        ___CellReconfigurationResponse_protocolIEs__item__criticality,
        ___CellReconfigurationResponse_protocolIEs__item__value,
        __CellReconfigurationResponse_protocolIEs__item_,
        _CellReconfigurationResponse_protocolIEs,
        ____CellReconfigurationResponse_protocolExtensions__item__id_tab,
        ___CellReconfigurationResponse_protocolExtensions__item__id,
        ____CellReconfigurationResponse_protocolExtensions__item__criticality_tab,
        ___CellReconfigurationResponse_protocolExtensions__item__criticality,
        ____CellReconfigurationResponse_protocolExtensions__item__extensionValue_tab,
        ___CellReconfigurationResponse_protocolExtensions__item__extensionValue,
        __CellReconfigurationResponse_protocolExtensions__item_,
        _CellReconfigurationResponse_protocolExtensions,
        CellReconfigurationResponse,
        CellReconfigurationResponse_IEs,
        _CellReconfigurationResponse_IEs_val_Value_0,
        CellReconfigurationResponse_Extensions,
        ____CellReconfigurationFailure_protocolIEs__item__id_tab,
        _____CellReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____CellReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___CellReconfigurationFailure_protocolIEs__item__id,
        ___CellReconfigurationFailure_protocolIEs__item__criticality,
        ___CellReconfigurationFailure_protocolIEs__item__value,
        __CellReconfigurationFailure_protocolIEs__item_,
        _CellReconfigurationFailure_protocolIEs,
        ____CellReconfigurationFailure_protocolExtensions__item__id_tab,
        ___CellReconfigurationFailure_protocolExtensions__item__id,
        ____CellReconfigurationFailure_protocolExtensions__item__criticality_tab,
        ___CellReconfigurationFailure_protocolExtensions__item__criticality,
        ____CellReconfigurationFailure_protocolExtensions__item__extensionValue_tab,
        ___CellReconfigurationFailure_protocolExtensions__item__extensionValue,
        __CellReconfigurationFailure_protocolExtensions__item_,
        _CellReconfigurationFailure_protocolExtensions,
        CellReconfigurationFailure,
        CellReconfigurationFailure_IEs,
        _CellReconfigurationFailure_IEs_val_Value_0,
        _CellReconfigurationFailure_IEs_val_Value_1,
        CellReconfigurationFailure_Extensions,
        ____CellDeletionRequest_protocolIEs__item__id_tab,
        _____CellDeletionRequest_protocolIEs__item__id_tab_val_Value_0,
        ___CellDeletionRequest_protocolIEs__item__id,
        ___CellDeletionRequest_protocolIEs__item__criticality,
        ___CellDeletionRequest_protocolIEs__item__value,
        __CellDeletionRequest_protocolIEs__item_,
        _CellDeletionRequest_protocolIEs,
        ____CellDeletionRequest_protocolExtensions__item__id_tab,
        ___CellDeletionRequest_protocolExtensions__item__id,
        ____CellDeletionRequest_protocolExtensions__item__criticality_tab,
        ___CellDeletionRequest_protocolExtensions__item__criticality,
        ____CellDeletionRequest_protocolExtensions__item__extensionValue_tab,
        ___CellDeletionRequest_protocolExtensions__item__extensionValue,
        __CellDeletionRequest_protocolExtensions__item_,
        _CellDeletionRequest_protocolExtensions,
        CellDeletionRequest,
        CellDeletionRequest_IEs,
        _CellDeletionRequest_IEs_val_Value_0,
        CellDeletionRequest_Extensions,
        ____CellDeletionResponse_protocolIEs__item__id_tab,
        _____CellDeletionResponse_protocolIEs__item__id_tab_val_Value_0,
        ___CellDeletionResponse_protocolIEs__item__id,
        ___CellDeletionResponse_protocolIEs__item__criticality,
        ___CellDeletionResponse_protocolIEs__item__value,
        __CellDeletionResponse_protocolIEs__item_,
        _CellDeletionResponse_protocolIEs,
        ____CellDeletionResponse_protocolExtensions__item__id_tab,
        ___CellDeletionResponse_protocolExtensions__item__id,
        ____CellDeletionResponse_protocolExtensions__item__criticality_tab,
        ___CellDeletionResponse_protocolExtensions__item__criticality,
        ____CellDeletionResponse_protocolExtensions__item__extensionValue_tab,
        ___CellDeletionResponse_protocolExtensions__item__extensionValue,
        __CellDeletionResponse_protocolExtensions__item_,
        _CellDeletionResponse_protocolExtensions,
        CellDeletionResponse,
        CellDeletionResponse_IEs,
        _CellDeletionResponse_IEs_val_Value_0,
        CellDeletionResponse_Extensions,
        ____ResourceStatusIndication_protocolIEs__item__id_tab,
        _____ResourceStatusIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusIndication_protocolIEs__item__id_tab_val_Value_1,
        ___ResourceStatusIndication_protocolIEs__item__id,
        ___ResourceStatusIndication_protocolIEs__item__criticality,
        ___ResourceStatusIndication_protocolIEs__item__value,
        __ResourceStatusIndication_protocolIEs__item_,
        _ResourceStatusIndication_protocolIEs,
        ____ResourceStatusIndication_protocolExtensions__item__id_tab,
        ___ResourceStatusIndication_protocolExtensions__item__id,
        ____ResourceStatusIndication_protocolExtensions__item__criticality_tab,
        ___ResourceStatusIndication_protocolExtensions__item__criticality,
        ____ResourceStatusIndication_protocolExtensions__item__extensionValue_tab,
        ___ResourceStatusIndication_protocolExtensions__item__extensionValue,
        __ResourceStatusIndication_protocolExtensions__item_,
        _ResourceStatusIndication_protocolExtensions,
        ResourceStatusIndication,
        ResourceStatusIndication_IEs,
        _ResourceStatusIndication_IEs_val_Value_0,
        _ResourceStatusIndication_IEs_val_Value_1,
        ResourceStatusIndication_Extensions,
        _IndicationType_ResourceStatusInd_no_Failure,
        _IndicationType_ResourceStatusInd_serviceImpacting,
        IndicationType_ResourceStatusInd,
        _No_Failure_ResourceStatusInd_local_Cell_InformationList,
        _No_Failure_ResourceStatusInd_local_Cell_Group_InformationList,
        ____No_Failure_ResourceStatusInd_iE_Extensions__item__id_tab,
        _____No_Failure_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0,
        ___No_Failure_ResourceStatusInd_iE_Extensions__item__id,
        ___No_Failure_ResourceStatusInd_iE_Extensions__item__criticality,
        ___No_Failure_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __No_Failure_ResourceStatusInd_iE_Extensions__item_,
        _No_Failure_ResourceStatusInd_iE_Extensions,
        No_Failure_ResourceStatusInd,
        No_FailureItem_ResourceStatusInd_ExtIEs,
        _No_FailureItem_ResourceStatusInd_ExtIEs_val_Extension_0,
        ___Local_Cell_InformationList_ResourceStatusInd__item__id_tab,
        ____Local_Cell_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __Local_Cell_InformationList_ResourceStatusInd__item__id,
        __Local_Cell_InformationList_ResourceStatusInd__item__criticality,
        __Local_Cell_InformationList_ResourceStatusInd__item__value,
        _Local_Cell_InformationList_ResourceStatusInd__item_,
        Local_Cell_InformationList_ResourceStatusInd,
        Local_Cell_InformationItemIE_ResourceStatusInd,
        _Local_Cell_InformationItemIE_ResourceStatusInd_val_Value_0,
        _Local_Cell_InformationItem_ResourceStatusInd_local_CellID,
        _Local_Cell_InformationItem_ResourceStatusInd_addorDeleteIndicator,
        _Local_Cell_InformationItem_ResourceStatusInd_dl_or_global_capacityCredit,
        _Local_Cell_InformationItem_ResourceStatusInd_ul_capacityCredit,
        _Local_Cell_InformationItem_ResourceStatusInd_commonChannelsCapacityConsumptionLaw,
        _Local_Cell_InformationItem_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw,
        _Local_Cell_InformationItem_ResourceStatusInd_maximumDL_PowerCapability,
        _Local_Cell_InformationItem_ResourceStatusInd_minSpreadingFactor,
        _Local_Cell_InformationItem_ResourceStatusInd_minimumDL_PowerCapability,
        _Local_Cell_InformationItem_ResourceStatusInd_local_Cell_Group_ID,
        ____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_2,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_3,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_4,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_5,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_6,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_7,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_8,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_9,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_10,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_11,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_12,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_13,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_14,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_15,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_16,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_17,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_18,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_19,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_20,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_21,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_22,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_23,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_24,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_25,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_26,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_27,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_28,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_29,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_30,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_31,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_32,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_33,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_34,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_35,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_36,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_37,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_38,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_39,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_40,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_41,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_42,
        _____Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_43,
        ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id,
        ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality,
        ___Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions__item_,
        _Local_Cell_InformationItem_ResourceStatusInd_iE_Extensions,
        Local_Cell_InformationItem_ResourceStatusInd,
        Local_Cell_InformationItem_ResourceStatusInd_ExtIEs,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_0,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_1,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_2,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_3,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_4,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_5,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_6,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_7,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_8,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_9,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_10,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_11,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_12,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_13,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_14,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_15,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_16,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_17,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_18,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_19,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_20,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_21,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_22,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_23,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_24,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_25,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_26,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_27,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_28,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_29,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_30,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_31,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_32,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_33,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_34,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_35,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_36,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_37,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_38,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_39,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_40,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_41,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_42,
        _Local_Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_43,
        ___Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab,
        ____Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __Local_Cell_Group_InformationList_ResourceStatusInd__item__id,
        __Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality,
        __Local_Cell_Group_InformationList_ResourceStatusInd__item__value,
        _Local_Cell_Group_InformationList_ResourceStatusInd__item_,
        Local_Cell_Group_InformationList_ResourceStatusInd,
        Local_Cell_Group_InformationItemIE_ResourceStatusInd,
        _Local_Cell_Group_InformationItemIE_ResourceStatusInd_val_Value_0,
        _Local_Cell_Group_InformationItem_ResourceStatusInd_local_Cell_Group_ID,
        _Local_Cell_Group_InformationItem_ResourceStatusInd_dl_or_global_capacityCredit,
        _Local_Cell_Group_InformationItem_ResourceStatusInd_ul_capacityCredit,
        _Local_Cell_Group_InformationItem_ResourceStatusInd_commonChannelsCapacityConsumptionLaw,
        _Local_Cell_Group_InformationItem_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw,
        ____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab,
        _____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0,
        _____Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1,
        ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id,
        ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality,
        ___Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item_,
        _Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions,
        Local_Cell_Group_InformationItem_ResourceStatusInd,
        Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs,
        _Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_0,
        _Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_1,
        ___Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab,
        ____Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__id,
        __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__criticality,
        __Power_Local_Cell_Group_InformationList_ResourceStatusInd__item__value,
        _Power_Local_Cell_Group_InformationList_ResourceStatusInd__item_,
        Power_Local_Cell_Group_InformationList_ResourceStatusInd,
        Power_Local_Cell_Group_InformationItemIE_ResourceStatusInd,
        _Power_Local_Cell_Group_InformationItemIE_ResourceStatusInd_val_Value_0,
        _Power_Local_Cell_Group_InformationItem_ResourceStatusInd_power_Local_Cell_Group_ID,
        _Power_Local_Cell_Group_InformationItem_ResourceStatusInd_maximumDL_PowerCapability,
        ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab,
        ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__id,
        ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab,
        ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality,
        ____Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab,
        ___Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions__item_,
        _Power_Local_Cell_Group_InformationItem_ResourceStatusInd_iE_Extensions,
        Power_Local_Cell_Group_InformationItem_ResourceStatusInd,
        Power_Local_Cell_Group_InformationItem_ResourceStatusInd_ExtIEs,
        _ServiceImpacting_ResourceStatusInd_local_Cell_InformationList,
        _ServiceImpacting_ResourceStatusInd_local_Cell_Group_InformationList,
        _ServiceImpacting_ResourceStatusInd_cCP_InformationList,
        _ServiceImpacting_ResourceStatusInd_cell_InformationList,
        ____ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id_tab,
        _____ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0,
        ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__id,
        ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__criticality,
        ___ServiceImpacting_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __ServiceImpacting_ResourceStatusInd_iE_Extensions__item_,
        _ServiceImpacting_ResourceStatusInd_iE_Extensions,
        ServiceImpacting_ResourceStatusInd,
        ServiceImpactingItem_ResourceStatusInd_ExtIEs,
        _ServiceImpactingItem_ResourceStatusInd_ExtIEs_val_Extension_0,
        ___Local_Cell_InformationList2_ResourceStatusInd__item__id_tab,
        ____Local_Cell_InformationList2_ResourceStatusInd__item__id_tab_val_Value_0,
        __Local_Cell_InformationList2_ResourceStatusInd__item__id,
        __Local_Cell_InformationList2_ResourceStatusInd__item__criticality,
        __Local_Cell_InformationList2_ResourceStatusInd__item__value,
        _Local_Cell_InformationList2_ResourceStatusInd__item_,
        Local_Cell_InformationList2_ResourceStatusInd,
        Local_Cell_InformationItemIE2_ResourceStatusInd,
        _Local_Cell_InformationItemIE2_ResourceStatusInd_val_Value_0,
        _Local_Cell_InformationItem2_ResourceStatusInd_local_Cell_ID,
        _Local_Cell_InformationItem2_ResourceStatusInd_dl_or_global_capacityCredit,
        _Local_Cell_InformationItem2_ResourceStatusInd_ul_capacityCredit,
        _Local_Cell_InformationItem2_ResourceStatusInd_commonChannelsCapacityConsumptionLaw,
        _Local_Cell_InformationItem2_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw,
        _Local_Cell_InformationItem2_ResourceStatusInd_maximum_DL_PowerCapability,
        _Local_Cell_InformationItem2_ResourceStatusInd_minSpreadingFactor,
        _Local_Cell_InformationItem2_ResourceStatusInd_minimumDL_PowerCapability,
        ____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_2,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_3,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_4,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_5,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_6,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_7,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_8,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_9,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_10,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_11,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_12,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_13,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_14,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_15,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_16,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_17,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_18,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_19,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_20,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_21,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_22,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_23,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_24,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_25,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_26,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_27,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_28,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_29,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_30,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_31,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_32,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_33,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_34,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_35,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_36,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_37,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_38,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_39,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_40,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_41,
        _____Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_42,
        ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__id,
        ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality,
        ___Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions__item_,
        _Local_Cell_InformationItem2_ResourceStatusInd_iE_Extensions,
        Local_Cell_InformationItem2_ResourceStatusInd,
        Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_0,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_1,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_2,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_3,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_4,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_5,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_6,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_7,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_8,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_9,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_10,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_11,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_12,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_13,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_14,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_15,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_16,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_17,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_18,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_19,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_20,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_21,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_22,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_23,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_24,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_25,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_26,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_27,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_28,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_29,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_30,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_31,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_32,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_33,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_34,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_35,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_36,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_37,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_38,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_39,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_40,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_41,
        _Local_Cell_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_42,
        ___Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab,
        ____Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab_val_Value_0,
        __Local_Cell_Group_InformationList2_ResourceStatusInd__item__id,
        __Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality,
        __Local_Cell_Group_InformationList2_ResourceStatusInd__item__value,
        _Local_Cell_Group_InformationList2_ResourceStatusInd__item_,
        Local_Cell_Group_InformationList2_ResourceStatusInd,
        Local_Cell_Group_InformationItemIE2_ResourceStatusInd,
        _Local_Cell_Group_InformationItemIE2_ResourceStatusInd_val_Value_0,
        _Local_Cell_Group_InformationItem2_ResourceStatusInd_local_Cell_Group_ID,
        _Local_Cell_Group_InformationItem2_ResourceStatusInd_dl_or_global_capacityCredit,
        _Local_Cell_Group_InformationItem2_ResourceStatusInd_ul_capacityCredit,
        _Local_Cell_Group_InformationItem2_ResourceStatusInd_commonChannelsCapacityConsumptionLaw,
        _Local_Cell_Group_InformationItem2_ResourceStatusInd_dedicatedChannelsCapacityConsumptionLaw,
        ____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab,
        _____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0,
        _____Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1,
        ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id,
        ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality,
        ___Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item_,
        _Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions,
        Local_Cell_Group_InformationItem2_ResourceStatusInd,
        Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs,
        _Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_0,
        _Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs_val_Extension_1,
        ___CCP_InformationList_ResourceStatusInd__item__id_tab,
        ____CCP_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __CCP_InformationList_ResourceStatusInd__item__id,
        __CCP_InformationList_ResourceStatusInd__item__criticality,
        __CCP_InformationList_ResourceStatusInd__item__value,
        _CCP_InformationList_ResourceStatusInd__item_,
        CCP_InformationList_ResourceStatusInd,
        CCP_InformationItemIE_ResourceStatusInd,
        _CCP_InformationItemIE_ResourceStatusInd_val_Value_0,
        _CCP_InformationItem_ResourceStatusInd_communicationControlPortID,
        _CCP_InformationItem_ResourceStatusInd_resourceOperationalState,
        _CCP_InformationItem_ResourceStatusInd_availabilityStatus,
        ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab,
        ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__id,
        ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab,
        ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality,
        ____CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab,
        ___CCP_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __CCP_InformationItem_ResourceStatusInd_iE_Extensions__item_,
        _CCP_InformationItem_ResourceStatusInd_iE_Extensions,
        CCP_InformationItem_ResourceStatusInd,
        CCP_InformationItem_ResourceStatusInd_ExtIEs,
        ___Cell_InformationList_ResourceStatusInd__item__id_tab,
        ____Cell_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __Cell_InformationList_ResourceStatusInd__item__id,
        __Cell_InformationList_ResourceStatusInd__item__criticality,
        __Cell_InformationList_ResourceStatusInd__item__value,
        _Cell_InformationList_ResourceStatusInd__item_,
        Cell_InformationList_ResourceStatusInd,
        Cell_InformationItemIE_ResourceStatusInd,
        _Cell_InformationItemIE_ResourceStatusInd_val_Value_0,
        _Cell_InformationItem_ResourceStatusInd_c_ID,
        _Cell_InformationItem_ResourceStatusInd_resourceOperationalState,
        _Cell_InformationItem_ResourceStatusInd_availabilityStatus,
        _Cell_InformationItem_ResourceStatusInd_primary_SCH_Information,
        _Cell_InformationItem_ResourceStatusInd_secondary_SCH_Information,
        _Cell_InformationItem_ResourceStatusInd_primary_CPICH_Information,
        _Cell_InformationItem_ResourceStatusInd_secondary_CPICH_Information,
        _Cell_InformationItem_ResourceStatusInd_primary_CCPCH_Information,
        _Cell_InformationItem_ResourceStatusInd_bCH_Information,
        _Cell_InformationItem_ResourceStatusInd_secondary_CCPCH_InformationList,
        _Cell_InformationItem_ResourceStatusInd_pCH_Information,
        _Cell_InformationItem_ResourceStatusInd_pICH_Information,
        _Cell_InformationItem_ResourceStatusInd_fACH_InformationList,
        _Cell_InformationItem_ResourceStatusInd_pRACH_InformationList,
        _Cell_InformationItem_ResourceStatusInd_rACH_InformationList,
        _Cell_InformationItem_ResourceStatusInd_aICH_InformationList,
        _Cell_InformationItem_ResourceStatusInd_notUsed_1_pCPCH_InformationList,
        _Cell_InformationItem_ResourceStatusInd_notUsed_2_cPCH_InformationList,
        _Cell_InformationItem_ResourceStatusInd_notUsed_3_aP_AICH_InformationList,
        _Cell_InformationItem_ResourceStatusInd_notUsed_4_cDCA_ICH_InformationList,
        _Cell_InformationItem_ResourceStatusInd_sCH_Information,
        ____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_1,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_2,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_3,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_4,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_5,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_6,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_7,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_8,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_9,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_10,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_11,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_12,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_13,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_14,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_15,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_16,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_17,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_18,
        _____Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_19,
        ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__id,
        ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality,
        ___Cell_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __Cell_InformationItem_ResourceStatusInd_iE_Extensions__item_,
        _Cell_InformationItem_ResourceStatusInd_iE_Extensions,
        Cell_InformationItem_ResourceStatusInd,
        Cell_InformationItem_ResourceStatusInd_ExtIEs,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_0,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_1,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_2,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_3,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_4,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_5,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_6,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_7,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_8,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_9,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_10,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_11,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_12,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_13,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_14,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_15,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_16,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_17,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_18,
        _Cell_InformationItem_ResourceStatusInd_ExtIEs_val_Extension_19,
        __P_SCH_Information_ResourceStatusInd_id_tab,
        ___P_SCH_Information_ResourceStatusInd_id_tab_val_Value_0,
        _P_SCH_Information_ResourceStatusInd_id,
        _P_SCH_Information_ResourceStatusInd_criticality,
        _P_SCH_Information_ResourceStatusInd_value,
        P_SCH_Information_ResourceStatusInd,
        P_SCH_InformationIE_ResourceStatusInd,
        _P_SCH_InformationIE_ResourceStatusInd_val_Value_0,
        __S_SCH_Information_ResourceStatusInd_id_tab,
        ___S_SCH_Information_ResourceStatusInd_id_tab_val_Value_0,
        _S_SCH_Information_ResourceStatusInd_id,
        _S_SCH_Information_ResourceStatusInd_criticality,
        _S_SCH_Information_ResourceStatusInd_value,
        S_SCH_Information_ResourceStatusInd,
        S_SCH_InformationIE_ResourceStatusInd,
        _S_SCH_InformationIE_ResourceStatusInd_val_Value_0,
        __P_CPICH_Information_ResourceStatusInd_id_tab,
        ___P_CPICH_Information_ResourceStatusInd_id_tab_val_Value_0,
        _P_CPICH_Information_ResourceStatusInd_id,
        _P_CPICH_Information_ResourceStatusInd_criticality,
        _P_CPICH_Information_ResourceStatusInd_value,
        P_CPICH_Information_ResourceStatusInd,
        P_CPICH_InformationIE_ResourceStatusInd,
        _P_CPICH_InformationIE_ResourceStatusInd_val_Value_0,
        ___S_CPICH_InformationList_ResourceStatusInd__item__id_tab,
        ____S_CPICH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __S_CPICH_InformationList_ResourceStatusInd__item__id,
        __S_CPICH_InformationList_ResourceStatusInd__item__criticality,
        __S_CPICH_InformationList_ResourceStatusInd__item__value,
        _S_CPICH_InformationList_ResourceStatusInd__item_,
        S_CPICH_InformationList_ResourceStatusInd,
        S_CPICH_InformationItemIE_ResourceStatusInd,
        _S_CPICH_InformationItemIE_ResourceStatusInd_val_Value_0,
        __P_CCPCH_Information_ResourceStatusInd_id_tab,
        ___P_CCPCH_Information_ResourceStatusInd_id_tab_val_Value_0,
        _P_CCPCH_Information_ResourceStatusInd_id,
        _P_CCPCH_Information_ResourceStatusInd_criticality,
        _P_CCPCH_Information_ResourceStatusInd_value,
        P_CCPCH_Information_ResourceStatusInd,
        P_CCPCH_InformationIE_ResourceStatusInd,
        _P_CCPCH_InformationIE_ResourceStatusInd_val_Value_0,
        __BCH_Information_ResourceStatusInd_id_tab,
        ___BCH_Information_ResourceStatusInd_id_tab_val_Value_0,
        _BCH_Information_ResourceStatusInd_id,
        _BCH_Information_ResourceStatusInd_criticality,
        _BCH_Information_ResourceStatusInd_value,
        BCH_Information_ResourceStatusInd,
        BCH_InformationIE_ResourceStatusInd,
        _BCH_InformationIE_ResourceStatusInd_val_Value_0,
        ___S_CCPCH_InformationList_ResourceStatusInd__item__id_tab,
        ____S_CCPCH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __S_CCPCH_InformationList_ResourceStatusInd__item__id,
        __S_CCPCH_InformationList_ResourceStatusInd__item__criticality,
        __S_CCPCH_InformationList_ResourceStatusInd__item__value,
        _S_CCPCH_InformationList_ResourceStatusInd__item_,
        S_CCPCH_InformationList_ResourceStatusInd,
        S_CCPCH_InformationItemIE_ResourceStatusInd,
        _S_CCPCH_InformationItemIE_ResourceStatusInd_val_Value_0,
        __PCH_Information_ResourceStatusInd_id_tab,
        ___PCH_Information_ResourceStatusInd_id_tab_val_Value_0,
        _PCH_Information_ResourceStatusInd_id,
        _PCH_Information_ResourceStatusInd_criticality,
        _PCH_Information_ResourceStatusInd_value,
        PCH_Information_ResourceStatusInd,
        PCH_InformationIE_ResourceStatusInd,
        _PCH_InformationIE_ResourceStatusInd_val_Value_0,
        __PICH_Information_ResourceStatusInd_id_tab,
        ___PICH_Information_ResourceStatusInd_id_tab_val_Value_0,
        _PICH_Information_ResourceStatusInd_id,
        _PICH_Information_ResourceStatusInd_criticality,
        _PICH_Information_ResourceStatusInd_value,
        PICH_Information_ResourceStatusInd,
        PICH_InformationIE_ResourceStatusInd,
        _PICH_InformationIE_ResourceStatusInd_val_Value_0,
        ___FACH_InformationList_ResourceStatusInd__item__id_tab,
        ____FACH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __FACH_InformationList_ResourceStatusInd__item__id,
        __FACH_InformationList_ResourceStatusInd__item__criticality,
        __FACH_InformationList_ResourceStatusInd__item__value,
        _FACH_InformationList_ResourceStatusInd__item_,
        FACH_InformationList_ResourceStatusInd,
        FACH_InformationItemIE_ResourceStatusInd,
        _FACH_InformationItemIE_ResourceStatusInd_val_Value_0,
        ___PRACH_InformationList_ResourceStatusInd__item__id_tab,
        ____PRACH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __PRACH_InformationList_ResourceStatusInd__item__id,
        __PRACH_InformationList_ResourceStatusInd__item__criticality,
        __PRACH_InformationList_ResourceStatusInd__item__value,
        _PRACH_InformationList_ResourceStatusInd__item_,
        PRACH_InformationList_ResourceStatusInd,
        PRACH_InformationItemIE_ResourceStatusInd,
        _PRACH_InformationItemIE_ResourceStatusInd_val_Value_0,
        ___RACH_InformationList_ResourceStatusInd__item__id_tab,
        ____RACH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __RACH_InformationList_ResourceStatusInd__item__id,
        __RACH_InformationList_ResourceStatusInd__item__criticality,
        __RACH_InformationList_ResourceStatusInd__item__value,
        _RACH_InformationList_ResourceStatusInd__item_,
        RACH_InformationList_ResourceStatusInd,
        RACH_InformationItemIE_ResourceStatusInd,
        _RACH_InformationItemIE_ResourceStatusInd_val_Value_0,
        ___AICH_InformationList_ResourceStatusInd__item__id_tab,
        ____AICH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __AICH_InformationList_ResourceStatusInd__item__id,
        __AICH_InformationList_ResourceStatusInd__item__criticality,
        __AICH_InformationList_ResourceStatusInd__item__value,
        _AICH_InformationList_ResourceStatusInd__item_,
        AICH_InformationList_ResourceStatusInd,
        AICH_InformationItemIE_ResourceStatusInd,
        _AICH_InformationItemIE_ResourceStatusInd_val_Value_0,
        __SCH_Information_ResourceStatusInd_id_tab,
        ___SCH_Information_ResourceStatusInd_id_tab_val_Value_0,
        _SCH_Information_ResourceStatusInd_id,
        _SCH_Information_ResourceStatusInd_criticality,
        _SCH_Information_ResourceStatusInd_value,
        SCH_Information_ResourceStatusInd,
        SCH_InformationIE_ResourceStatusInd,
        _SCH_InformationIE_ResourceStatusInd_val_Value_0,
        ___FPACH_LCR_InformationList_ResourceStatusInd__item__id_tab,
        ____FPACH_LCR_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __FPACH_LCR_InformationList_ResourceStatusInd__item__id,
        __FPACH_LCR_InformationList_ResourceStatusInd__item__criticality,
        __FPACH_LCR_InformationList_ResourceStatusInd__item__value,
        _FPACH_LCR_InformationList_ResourceStatusInd__item_,
        FPACH_LCR_InformationList_ResourceStatusInd,
        FPACH_LCR_InformationItemIE_ResourceStatusInd,
        _FPACH_LCR_InformationItemIE_ResourceStatusInd_val_Value_0,
        __DwPCH_LCR_Information_ResourceStatusInd_id_tab,
        ___DwPCH_LCR_Information_ResourceStatusInd_id_tab_val_Value_0,
        _DwPCH_LCR_Information_ResourceStatusInd_id,
        _DwPCH_LCR_Information_ResourceStatusInd_criticality,
        _DwPCH_LCR_Information_ResourceStatusInd_value,
        DwPCH_LCR_Information_ResourceStatusInd,
        DwPCH_LCR_InformationIE_ResourceStatusInd,
        _DwPCH_LCR_InformationIE_ResourceStatusInd_val_Value_0,
        _HS_DSCH_Resources_Information_ResourceStatusInd_resourceOperationalState,
        _HS_DSCH_Resources_Information_ResourceStatusInd_availabilityStatus,
        ____HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab,
        _____HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id,
        ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality,
        ___HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions__item_,
        _HS_DSCH_Resources_Information_ResourceStatusInd_iE_Extensions,
        HS_DSCH_Resources_Information_ResourceStatusInd,
        HS_DSCH_Resources_Information_ResourceStatusInd_ExtIEs,
        _HS_DSCH_Resources_Information_ResourceStatusInd_ExtIEs_val_Extension_0,
        ___S_CCPCH_InformationListExt_ResourceStatusInd__item__id_tab,
        ____S_CCPCH_InformationListExt_ResourceStatusInd__item__id_tab_val_Value_0,
        __S_CCPCH_InformationListExt_ResourceStatusInd__item__id,
        __S_CCPCH_InformationListExt_ResourceStatusInd__item__criticality,
        __S_CCPCH_InformationListExt_ResourceStatusInd__item__value,
        _S_CCPCH_InformationListExt_ResourceStatusInd__item_,
        S_CCPCH_InformationListExt_ResourceStatusInd,
        ___S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id_tab,
        ____S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id_tab_val_Value_0,
        __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__id,
        __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__criticality,
        __S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item__value,
        _S_CCPCH_LCR_InformationListExt_ResourceStatusInd__item_,
        S_CCPCH_LCR_InformationListExt_ResourceStatusInd,
        _E_DCH_Resources_Information_ResourceStatusInd_resourceOperationalState,
        _E_DCH_Resources_Information_ResourceStatusInd_availabilityStatus,
        ____E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab,
        _____E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__id,
        ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__criticality,
        ___E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions__item_,
        _E_DCH_Resources_Information_ResourceStatusInd_iE_Extensions,
        E_DCH_Resources_Information_ResourceStatusInd,
        E_DCH_Resources_Information_ResourceStatusInd_ExtIEs,
        _E_DCH_Resources_Information_ResourceStatusInd_ExtIEs_val_Extension_0,
        ___PLCCH_InformationList_ResourceStatusInd__item__id_tab,
        ____PLCCH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __PLCCH_InformationList_ResourceStatusInd__item__id,
        __PLCCH_InformationList_ResourceStatusInd__item__criticality,
        __PLCCH_InformationList_ResourceStatusInd__item__value,
        _PLCCH_InformationList_ResourceStatusInd__item_,
        PLCCH_InformationList_ResourceStatusInd,
        PLCCH_InformationItemIE_ResourceStatusInd,
        _PLCCH_InformationItemIE_ResourceStatusInd_val_Value_0,
        ___S_CCPCH_768_InformationList_ResourceStatusInd__item__id_tab,
        ____S_CCPCH_768_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __S_CCPCH_768_InformationList_ResourceStatusInd__item__id,
        __S_CCPCH_768_InformationList_ResourceStatusInd__item__criticality,
        __S_CCPCH_768_InformationList_ResourceStatusInd__item__value,
        _S_CCPCH_768_InformationList_ResourceStatusInd__item_,
        S_CCPCH_768_InformationList_ResourceStatusInd,
        S_CCPCH_768_InformationItemIE_ResourceStatusInd,
        _S_CCPCH_768_InformationItemIE_ResourceStatusInd_val_Value_0,
        ___PRACH_768_InformationList_ResourceStatusInd__item__id_tab,
        ____PRACH_768_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __PRACH_768_InformationList_ResourceStatusInd__item__id,
        __PRACH_768_InformationList_ResourceStatusInd__item__criticality,
        __PRACH_768_InformationList_ResourceStatusInd__item__value,
        _PRACH_768_InformationList_ResourceStatusInd__item_,
        PRACH_768_InformationList_ResourceStatusInd,
        PRACH_768_InformationItemIE_ResourceStatusInd,
        _PRACH_768_InformationItemIE_ResourceStatusInd_val_Value_0,
        ___E_RUCCH_InformationList_ResourceStatusInd__item__id_tab,
        ____E_RUCCH_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __E_RUCCH_InformationList_ResourceStatusInd__item__id,
        __E_RUCCH_InformationList_ResourceStatusInd__item__criticality,
        __E_RUCCH_InformationList_ResourceStatusInd__item__value,
        _E_RUCCH_InformationList_ResourceStatusInd__item_,
        E_RUCCH_InformationList_ResourceStatusInd,
        E_RUCCH_InformationItemIE_ResourceStatusInd,
        _E_RUCCH_InformationItemIE_ResourceStatusInd_val_Value_0,
        ___E_RUCCH_768_InformationList_ResourceStatusInd__item__id_tab,
        ____E_RUCCH_768_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __E_RUCCH_768_InformationList_ResourceStatusInd__item__id,
        __E_RUCCH_768_InformationList_ResourceStatusInd__item__criticality,
        __E_RUCCH_768_InformationList_ResourceStatusInd__item__value,
        _E_RUCCH_768_InformationList_ResourceStatusInd__item_,
        E_RUCCH_768_InformationList_ResourceStatusInd,
        E_RUCCH_768_InformationItemIE_ResourceStatusInd,
        _E_RUCCH_768_InformationItemIE_ResourceStatusInd_val_Value_0,
        ___Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id_tab,
        ____Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id_tab_val_Value_0,
        __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__id,
        __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__criticality,
        __Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item__value,
        _Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd__item_,
        Cell_Frequency_List_Information_LCR_MulFreq_ResourceStatusInd,
        Cell_Frequency_List_InformationIE_LCR_MulFreq_ResourceStatusInd,
        _Cell_Frequency_List_InformationIE_LCR_MulFreq_ResourceStatusInd_val_Value_0,
        _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_uARFCN,
        _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_resourceOperationalState,
        _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_availabilityStatus,
        _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_cause,
        ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__id_tab,
        ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__id,
        ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__criticality_tab,
        ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__criticality,
        ____Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__extensionValue_tab,
        ___Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions__item_,
        _Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_iE_Extensions,
        Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd,
        Cell_Frequency_List_InformationItem_LCR_MulFreq_ResourceStatusInd_ExtIEs,
        ___UPPCH_LCR_InformationList_ResourceStatusInd__item__id_tab,
        ____UPPCH_LCR_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __UPPCH_LCR_InformationList_ResourceStatusInd__item__id,
        __UPPCH_LCR_InformationList_ResourceStatusInd__item__criticality,
        __UPPCH_LCR_InformationList_ResourceStatusInd__item__value,
        _UPPCH_LCR_InformationList_ResourceStatusInd__item_,
        UPPCH_LCR_InformationList_ResourceStatusInd,
        UPPCH_LCR_InformationIE_ResourceStatusInd,
        _UPPCH_LCR_InformationIE_ResourceStatusInd_val_Value_0,
        _UPPCH_LCR_InformationItem_ResourceStatusInd_uARFCN,
        _UPPCH_LCR_InformationItem_ResourceStatusInd_uPPCHPositionLCR,
        _UPPCH_LCR_InformationItem_ResourceStatusInd_resourceOperationalState,
        _UPPCH_LCR_InformationItem_ResourceStatusInd_availabilityStatus,
        ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__id_tab,
        ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__id,
        ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality_tab,
        ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__criticality,
        ____UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue_tab,
        ___UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions__item_,
        _UPPCH_LCR_InformationItem_ResourceStatusInd_iE_Extensions,
        UPPCH_LCR_InformationItem_ResourceStatusInd,
        UPPCH_LCR_InformationItem_ResourceStatusInd_ExtIEs,
        ___MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id_tab,
        ____MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__id,
        __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__criticality,
        __MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item__value,
        _MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd__item_,
        MultipleFreq_HS_DSCH_Resources_InformationList_ResourceStatusInd,
        MultipleFreq_HS_DSCH_Resources_InformationItem_ResourceStatusInd,
        _MultipleFreq_HS_DSCH_Resources_InformationItem_ResourceStatusInd_val_Value_0,
        ___Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab,
        ____Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id_tab_val_Value_0,
        __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__id,
        __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__criticality,
        __Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item__value,
        _Power_Local_Cell_Group_InformationList2_ResourceStatusInd__item_,
        Power_Local_Cell_Group_InformationList2_ResourceStatusInd,
        Power_Local_Cell_Group_InformationItemIE2_ResourceStatusInd,
        _Power_Local_Cell_Group_InformationItemIE2_ResourceStatusInd_val_Value_0,
        _Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_power_Local_Cell_Group_ID,
        _Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_maximumDL_PowerCapability,
        ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id_tab,
        ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__id,
        ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality_tab,
        ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__criticality,
        ____Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue_tab,
        ___Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item__extensionValue,
        __Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions__item_,
        _Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_iE_Extensions,
        Power_Local_Cell_Group_InformationItem2_ResourceStatusInd,
        Power_Local_Cell_Group_InformationItem2_ResourceStatusInd_ExtIEs,
        ___MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id_tab,
        ____MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id_tab_val_Value_0,
        __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__id,
        __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__criticality,
        __MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item__value,
        _MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd__item_,
        MultipleFreq_E_DCH_Resources_InformationList_ResourceStatusInd,
        MultipleFreq_E_DCH_Resources_InformationItem_ResourceStatusInd,
        _MultipleFreq_E_DCH_Resources_InformationItem_ResourceStatusInd_val_Value_0,
        ____SystemInformationUpdateRequest_protocolIEs__item__id_tab,
        _____SystemInformationUpdateRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SystemInformationUpdateRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SystemInformationUpdateRequest_protocolIEs__item__id_tab_val_Value_2,
        ___SystemInformationUpdateRequest_protocolIEs__item__id,
        ___SystemInformationUpdateRequest_protocolIEs__item__criticality,
        ___SystemInformationUpdateRequest_protocolIEs__item__value,
        __SystemInformationUpdateRequest_protocolIEs__item_,
        _SystemInformationUpdateRequest_protocolIEs,
        ____SystemInformationUpdateRequest_protocolExtensions__item__id_tab,
        _____SystemInformationUpdateRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___SystemInformationUpdateRequest_protocolExtensions__item__id,
        ___SystemInformationUpdateRequest_protocolExtensions__item__criticality,
        ___SystemInformationUpdateRequest_protocolExtensions__item__extensionValue,
        __SystemInformationUpdateRequest_protocolExtensions__item_,
        _SystemInformationUpdateRequest_protocolExtensions,
        SystemInformationUpdateRequest,
        SystemInformationUpdateRequest_IEs,
        _SystemInformationUpdateRequest_IEs_val_Value_0,
        _SystemInformationUpdateRequest_IEs_val_Value_1,
        _SystemInformationUpdateRequest_IEs_val_Value_2,
        SystemInformationUpdateRequest_Extensions,
        _SystemInformationUpdateRequest_Extensions_val_Extension_0,
        _MIB_SB_SIB_InformationList_SystemInfoUpdateRqst__item_,
        MIB_SB_SIB_InformationList_SystemInfoUpdateRqst,
        _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iB_Type,
        _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iB_OC_ID,
        _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_deletionIndicator,
        ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__id_tab,
        ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__id,
        ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__criticality_tab,
        ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__criticality,
        ____MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__extensionValue_tab,
        ___MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item__extensionValue,
        __MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions__item_,
        _MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_iE_Extensions,
        MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst,
        MIB_SB_SIB_InformationItem_SystemInfoUpdateRqst_ExtIEs,
        BCH_mappedOnSCCPCH_Indication,
        _DeletionIndicator_SystemInfoUpdate_no_Deletion,
        _DeletionIndicator_SystemInfoUpdate_yes_Deletion,
        DeletionIndicator_SystemInfoUpdate,
        _No_Deletion_SystemInfoUpdate_sIB_Originator,
        _No_Deletion_SystemInfoUpdate_iB_SG_REP,
        _No_Deletion_SystemInfoUpdate_segmentInformationList,
        ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__id_tab,
        ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__id,
        ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__criticality_tab,
        ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__criticality,
        ____No_Deletion_SystemInfoUpdate_iE_Extensions__item__extensionValue_tab,
        ___No_Deletion_SystemInfoUpdate_iE_Extensions__item__extensionValue,
        __No_Deletion_SystemInfoUpdate_iE_Extensions__item_,
        _No_Deletion_SystemInfoUpdate_iE_Extensions,
        No_Deletion_SystemInfoUpdate,
        No_DeletionItem_SystemInfoUpdate_ExtIEs,
        __SegmentInformationList_SystemInfoUpdate_id_tab,
        ___SegmentInformationList_SystemInfoUpdate_id_tab_val_Value_0,
        _SegmentInformationList_SystemInfoUpdate_id,
        _SegmentInformationList_SystemInfoUpdate_criticality,
        _SegmentInformationList_SystemInfoUpdate_value,
        SegmentInformationList_SystemInfoUpdate,
        SegmentInformationListIEs_SystemInfoUpdate,
        _SegmentInformationListIEs_SystemInfoUpdate_val_Value_0,
        _SegmentInformationListIE_SystemInfoUpdate__item_,
        SegmentInformationListIE_SystemInfoUpdate,
        _SegmentInformationItem_SystemInfoUpdate_iB_SG_POS,
        _SegmentInformationItem_SystemInfoUpdate_segment_Type,
        _SegmentInformationItem_SystemInfoUpdate_iB_SG_DATA,
        ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__id_tab,
        ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__id,
        ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__criticality_tab,
        ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__criticality,
        ____SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__extensionValue_tab,
        ___SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item__extensionValue,
        __SegmentInformationItem_SystemInfoUpdate_iE_Extensions__item_,
        _SegmentInformationItem_SystemInfoUpdate_iE_Extensions,
        SegmentInformationItem_SystemInfoUpdate,
        SegmentInformationItem_SystemInfoUpdate_ExtIEs,
        ____SystemInformationUpdateResponse_protocolIEs__item__id_tab,
        _____SystemInformationUpdateResponse_protocolIEs__item__id_tab_val_Value_0,
        ___SystemInformationUpdateResponse_protocolIEs__item__id,
        ___SystemInformationUpdateResponse_protocolIEs__item__criticality,
        ___SystemInformationUpdateResponse_protocolIEs__item__value,
        __SystemInformationUpdateResponse_protocolIEs__item_,
        _SystemInformationUpdateResponse_protocolIEs,
        ____SystemInformationUpdateResponse_protocolExtensions__item__id_tab,
        ___SystemInformationUpdateResponse_protocolExtensions__item__id,
        ____SystemInformationUpdateResponse_protocolExtensions__item__criticality_tab,
        ___SystemInformationUpdateResponse_protocolExtensions__item__criticality,
        ____SystemInformationUpdateResponse_protocolExtensions__item__extensionValue_tab,
        ___SystemInformationUpdateResponse_protocolExtensions__item__extensionValue,
        __SystemInformationUpdateResponse_protocolExtensions__item_,
        _SystemInformationUpdateResponse_protocolExtensions,
        SystemInformationUpdateResponse,
        SystemInformationUpdateResponse_IEs,
        _SystemInformationUpdateResponse_IEs_val_Value_0,
        SystemInformationUpdateResponse_Extensions,
        ____SystemInformationUpdateFailure_protocolIEs__item__id_tab,
        _____SystemInformationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____SystemInformationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        ___SystemInformationUpdateFailure_protocolIEs__item__id,
        ___SystemInformationUpdateFailure_protocolIEs__item__criticality,
        ___SystemInformationUpdateFailure_protocolIEs__item__value,
        __SystemInformationUpdateFailure_protocolIEs__item_,
        _SystemInformationUpdateFailure_protocolIEs,
        ____SystemInformationUpdateFailure_protocolExtensions__item__id_tab,
        ___SystemInformationUpdateFailure_protocolExtensions__item__id,
        ____SystemInformationUpdateFailure_protocolExtensions__item__criticality_tab,
        ___SystemInformationUpdateFailure_protocolExtensions__item__criticality,
        ____SystemInformationUpdateFailure_protocolExtensions__item__extensionValue_tab,
        ___SystemInformationUpdateFailure_protocolExtensions__item__extensionValue,
        __SystemInformationUpdateFailure_protocolExtensions__item_,
        _SystemInformationUpdateFailure_protocolExtensions,
        SystemInformationUpdateFailure,
        SystemInformationUpdateFailure_IEs,
        _SystemInformationUpdateFailure_IEs_val_Value_0,
        _SystemInformationUpdateFailure_IEs_val_Value_1,
        SystemInformationUpdateFailure_Extensions,
        ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_6,
        ___RadioLinkSetupRequestFDD_protocolIEs__item__id,
        ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality,
        ___RadioLinkSetupRequestFDD_protocolIEs__item__value,
        __RadioLinkSetupRequestFDD_protocolIEs__item_,
        _RadioLinkSetupRequestFDD_protocolIEs,
        ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_19,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_20,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_21,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_22,
        ___RadioLinkSetupRequestFDD_protocolExtensions__item__id,
        ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality,
        ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupRequestFDD_protocolExtensions__item_,
        _RadioLinkSetupRequestFDD_protocolExtensions,
        RadioLinkSetupRequestFDD,
        RadioLinkSetupRequestFDD_IEs,
        _RadioLinkSetupRequestFDD_IEs_val_Value_0,
        _RadioLinkSetupRequestFDD_IEs_val_Value_1,
        _RadioLinkSetupRequestFDD_IEs_val_Value_2,
        _RadioLinkSetupRequestFDD_IEs_val_Value_3,
        _RadioLinkSetupRequestFDD_IEs_val_Value_4,
        _RadioLinkSetupRequestFDD_IEs_val_Value_5,
        _RadioLinkSetupRequestFDD_IEs_val_Value_6,
        RadioLinkSetupRequestFDD_Extensions,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_0,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_1,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_2,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_3,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_4,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_5,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_6,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_7,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_8,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_9,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_10,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_11,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_12,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_13,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_14,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_15,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_16,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_17,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_18,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_19,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_20,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_21,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_22,
        _Additional_HS_Cell_Information_RL_Setup_List__item_,
        Additional_HS_Cell_Information_RL_Setup_List,
        _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_RL_Setup_ItemIEs_c_ID,
        _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information,
        ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_RL_Setup_ItemIEs,
        Additional_HS_Cell_Information_RL_Setup_ItemIEs_ExtIEs,
        _UL_DPCH_Information_RL_SetupRqstFDD_ul_ScramblingCode,
        _UL_DPCH_Information_RL_SetupRqstFDD_minUL_ChannelisationCodeLength,
        _UL_DPCH_Information_RL_SetupRqstFDD_maxNrOfUL_DPDCHs,
        _UL_DPCH_Information_RL_SetupRqstFDD_ul_PunctureLimit,
        _UL_DPCH_Information_RL_SetupRqstFDD_tFCS,
        _UL_DPCH_Information_RL_SetupRqstFDD_ul_DPCCH_SlotFormat,
        _UL_DPCH_Information_RL_SetupRqstFDD_ul_SIR_Target,
        _UL_DPCH_Information_RL_SetupRqstFDD_diversityMode,
        _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_sSDT_CellID_Length,
        _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_s_FieldLength,
        ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id,
        ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_,
        _UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions,
        UL_DPCH_Information_RL_SetupRqstFDD,
        UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs,
        _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0,
        _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1,
        _DL_DPCH_Information_RL_SetupRqstFDD_tFCS,
        _DL_DPCH_Information_RL_SetupRqstFDD_dl_DPCH_SlotFormat,
        _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_SignallingMode,
        _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_Presence,
        _DL_DPCH_Information_RL_SetupRqstFDD_multiplexingPosition,
        _DL_DPCH_Information_RL_SetupRqstFDD_not_Used_pDSCH_RL_ID,
        _DL_DPCH_Information_RL_SetupRqstFDD_not_Used_pDSCH_CodeMapping,
        _DL_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation,
        _DL_DPCH_Information_RL_SetupRqstFDD_fdd_TPC_DownlinkStepSize,
        _DL_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease,
        _DL_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus,
        ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id,
        ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_,
        _DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions,
        DL_DPCH_Information_RL_SetupRqstFDD,
        DL_DPCH_Information_RL_SetupRqstFDD_ExtIEs,
        _PowerOffsetInformation_RL_SetupRqstFDD_pO1_ForTFCI_Bits,
        _PowerOffsetInformation_RL_SetupRqstFDD_pO2_ForTPC_Bits,
        _PowerOffsetInformation_RL_SetupRqstFDD_pO3_ForPilotBits,
        ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id,
        ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item_,
        _PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions,
        PowerOffsetInformation_RL_SetupRqstFDD,
        PowerOffsetInformation_RL_SetupRqstFDD_ExtIEs,
        ___RL_InformationList_RL_SetupRqstFDD__item__id_tab,
        ____RL_InformationList_RL_SetupRqstFDD__item__id_tab_val_Value_0,
        __RL_InformationList_RL_SetupRqstFDD__item__id,
        __RL_InformationList_RL_SetupRqstFDD__item__criticality,
        __RL_InformationList_RL_SetupRqstFDD__item__value,
        _RL_InformationList_RL_SetupRqstFDD__item_,
        RL_InformationList_RL_SetupRqstFDD,
        RL_InformationItemIE_RL_SetupRqstFDD,
        _RL_InformationItemIE_RL_SetupRqstFDD_val_Value_0,
        _RL_InformationItem_RL_SetupRqstFDD_rL_ID,
        _RL_InformationItem_RL_SetupRqstFDD_c_ID,
        _RL_InformationItem_RL_SetupRqstFDD_firstRLS_indicator,
        _RL_InformationItem_RL_SetupRqstFDD_frameOffset,
        _RL_InformationItem_RL_SetupRqstFDD_chipOffset,
        _RL_InformationItem_RL_SetupRqstFDD_propagationDelay,
        _RL_InformationItem_RL_SetupRqstFDD_diversityControlField,
        _RL_InformationItem_RL_SetupRqstFDD_dl_CodeInformation,
        _RL_InformationItem_RL_SetupRqstFDD_initialDL_transmissionPower,
        _RL_InformationItem_RL_SetupRqstFDD_maximumDL_power,
        _RL_InformationItem_RL_SetupRqstFDD_minimumDL_power,
        _RL_InformationItem_RL_SetupRqstFDD_not_Used_sSDT_Cell_Identity,
        _RL_InformationItem_RL_SetupRqstFDD_transmitDiversityIndicator,
        ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_9,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_10,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_11,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_12,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_13,
        ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id,
        ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item_,
        _RL_InformationItem_RL_SetupRqstFDD_iE_Extensions,
        RL_InformationItem_RL_SetupRqstFDD,
        RL_InformationItem_RL_SetupRqstFDD_ExtIEs,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_0,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_1,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_2,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_3,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_4,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_5,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_6,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_7,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_8,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_9,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_10,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_11,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_12,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_13,
        _E_DPCH_Information_RL_SetupRqstFDD_maxSet_E_DPDCHs,
        _E_DPCH_Information_RL_SetupRqstFDD_ul_PunctureLimit,
        _E_DPCH_Information_RL_SetupRqstFDD_e_TFCS_Information,
        _E_DPCH_Information_RL_SetupRqstFDD_e_TTI,
        _E_DPCH_Information_RL_SetupRqstFDD_e_DPCCH_PO,
        _E_DPCH_Information_RL_SetupRqstFDD_e_RGCH_2_IndexStepThreshold,
        _E_DPCH_Information_RL_SetupRqstFDD_e_RGCH_3_IndexStepThreshold,
        _E_DPCH_Information_RL_SetupRqstFDD_hARQ_Info_for_E_DCH,
        _E_DPCH_Information_RL_SetupRqstFDD_hSDSCH_Configured_Indicator,
        ____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        _____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id,
        ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ___E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_,
        _E_DPCH_Information_RL_SetupRqstFDD_iE_Extensions,
        E_DPCH_Information_RL_SetupRqstFDD,
        E_DPCH_Information_RL_SetupRqstFDD_ExtIEs,
        _E_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0,
        _E_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1,
        _F_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation,
        _F_DPCH_Information_RL_SetupRqstFDD_fdd_TPC_DownlinkStepSize,
        _F_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease,
        _F_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus,
        ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id,
        ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_,
        _F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions,
        F_DPCH_Information_RL_SetupRqstFDD,
        F_DPCH_Information_RL_SetupRqstFDD_ExtIEs,
        _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_pO2_ForTPC_Bits,
        ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id,
        ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item_,
        _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions,
        PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD,
        PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_ExtIEs,
        ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_6,
        ___RadioLinkSetupRequestTDD_protocolIEs__item__id,
        ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality,
        ___RadioLinkSetupRequestTDD_protocolIEs__item__value,
        __RadioLinkSetupRequestTDD_protocolIEs__item_,
        _RadioLinkSetupRequestTDD_protocolIEs,
        ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_19,
        ___RadioLinkSetupRequestTDD_protocolExtensions__item__id,
        ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality,
        ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupRequestTDD_protocolExtensions__item_,
        _RadioLinkSetupRequestTDD_protocolExtensions,
        RadioLinkSetupRequestTDD,
        RadioLinkSetupRequestTDD_IEs,
        _RadioLinkSetupRequestTDD_IEs_val_Value_0,
        _RadioLinkSetupRequestTDD_IEs_val_Value_1,
        _RadioLinkSetupRequestTDD_IEs_val_Value_2,
        _RadioLinkSetupRequestTDD_IEs_val_Value_3,
        _RadioLinkSetupRequestTDD_IEs_val_Value_4,
        _RadioLinkSetupRequestTDD_IEs_val_Value_5,
        _RadioLinkSetupRequestTDD_IEs_val_Value_6,
        RadioLinkSetupRequestTDD_Extensions,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_0,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_1,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_2,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_3,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_4,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_5,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_6,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_7,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_8,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_9,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_10,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_11,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_12,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_13,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_14,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_15,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_16,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_17,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_18,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_19,
        ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab,
        ____UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0,
        __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id,
        __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality,
        __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value,
        _UL_CCTrCH_InformationList_RL_SetupRqstTDD__item_,
        UL_CCTrCH_InformationList_RL_SetupRqstTDD,
        UL_CCTrCH_InformationItemIE_RL_SetupRqstTDD,
        _UL_CCTrCH_InformationItemIE_RL_SetupRqstTDD_val_Value_0,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCS,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_punctureLimit,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_uL_DPCH_Information,
        ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id,
        ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions,
        UL_CCTrCH_InformationItem_RL_SetupRqstTDD,
        UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_2,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_3,
        __UL_DPCH_Information_RL_SetupRqstTDD_id_tab,
        ___UL_DPCH_Information_RL_SetupRqstTDD_id_tab_val_Value_0,
        _UL_DPCH_Information_RL_SetupRqstTDD_id,
        _UL_DPCH_Information_RL_SetupRqstTDD_criticality,
        _UL_DPCH_Information_RL_SetupRqstTDD_value,
        UL_DPCH_Information_RL_SetupRqstTDD,
        UL_DPCH_InformationIE_RL_SetupRqstTDD,
        _UL_DPCH_InformationIE_RL_SetupRqstTDD_val_Value_0,
        _UL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionPeriod,
        _UL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionLength,
        _UL_DPCH_InformationItem_RL_SetupRqstTDD_tdd_DPCHOffset,
        _UL_DPCH_InformationItem_RL_SetupRqstTDD_uL_Timeslot_Information,
        ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id,
        ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_,
        _UL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions,
        UL_DPCH_InformationItem_RL_SetupRqstTDD,
        UL_DPCH_InformationItem_RL_SetupRqstTDD_ExtIEs,
        _UL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionPeriod,
        _UL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionLength,
        _UL_DPCH_LCR_Information_RL_SetupRqstTDD_tdd_DPCHOffset,
        _UL_DPCH_LCR_Information_RL_SetupRqstTDD_uL_TimeslotLCR_Information,
        ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id,
        ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item_,
        _UL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions,
        UL_DPCH_LCR_Information_RL_SetupRqstTDD,
        UL_DPCH_LCR_InformationItem_RL_SetupRqstTDD_ExtIEs,
        _UL_DPCH_768_Information_RL_SetupRqstTDD_repetitionPeriod,
        _UL_DPCH_768_Information_RL_SetupRqstTDD_repetitionLength,
        _UL_DPCH_768_Information_RL_SetupRqstTDD_tdd_DPCHOffset,
        _UL_DPCH_768_Information_RL_SetupRqstTDD_uL_Timeslot768_Information,
        ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id,
        ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item_,
        _UL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions,
        UL_DPCH_768_Information_RL_SetupRqstTDD,
        UL_DPCH_768_InformationItem_RL_SetupRqstTDD_ExtIEs,
        ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab,
        ____DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0,
        __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id,
        __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality,
        __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value,
        _DL_CCTrCH_InformationList_RL_SetupRqstTDD__item_,
        DL_CCTrCH_InformationList_RL_SetupRqstTDD,
        DL_CCTrCH_InformationItemIE_RL_SetupRqstTDD,
        _DL_CCTrCH_InformationItemIE_RL_SetupRqstTDD_val_Value_0,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCS,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_punctureLimit,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tdd_TPC_DownlinkStepSize,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_TPCList,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_dL_DPCH_Information,
        ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4,
        ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id,
        ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions,
        DL_CCTrCH_InformationItem_RL_SetupRqstTDD,
        DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_2,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_3,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_4,
        _CCTrCH_TPCList_RL_SetupRqstTDD__item_,
        CCTrCH_TPCList_RL_SetupRqstTDD,
        _CCTrCH_TPCItem_RL_SetupRqstTDD_cCTrCH_ID,
        ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id,
        ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item_,
        _CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions,
        CCTrCH_TPCItem_RL_SetupRqstTDD,
        CCTrCH_TPCItem_RL_SetupRqstTDD_ExtIEs,
        __DL_DPCH_Information_RL_SetupRqstTDD_id_tab,
        ___DL_DPCH_Information_RL_SetupRqstTDD_id_tab_val_Value_0,
        _DL_DPCH_Information_RL_SetupRqstTDD_id,
        _DL_DPCH_Information_RL_SetupRqstTDD_criticality,
        _DL_DPCH_Information_RL_SetupRqstTDD_value,
        DL_DPCH_Information_RL_SetupRqstTDD,
        DL_DPCH_InformationIE_RL_SetupRqstTDD,
        _DL_DPCH_InformationIE_RL_SetupRqstTDD_val_Value_0,
        _DL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionPeriod,
        _DL_DPCH_InformationItem_RL_SetupRqstTDD_repetitionLength,
        _DL_DPCH_InformationItem_RL_SetupRqstTDD_tdd_DPCHOffset,
        _DL_DPCH_InformationItem_RL_SetupRqstTDD_dL_Timeslot_Information,
        ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_,
        _DL_DPCH_InformationItem_RL_SetupRqstTDD_iE_Extensions,
        DL_DPCH_InformationItem_RL_SetupRqstTDD,
        DL_DPCH_InformationItem_RL_SetupRqstTDD_ExtIEs,
        _DL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionPeriod,
        _DL_DPCH_LCR_Information_RL_SetupRqstTDD_repetitionLength,
        _DL_DPCH_LCR_Information_RL_SetupRqstTDD_tdd_DPCHOffset,
        _DL_DPCH_LCR_Information_RL_SetupRqstTDD_dL_TimeslotLCR_Information,
        _DL_DPCH_LCR_Information_RL_SetupRqstTDD_tstdIndicator,
        ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__id,
        ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions__item_,
        _DL_DPCH_LCR_Information_RL_SetupRqstTDD_iE_Extensions,
        DL_DPCH_LCR_Information_RL_SetupRqstTDD,
        DL_DPCH_LCR_InformationItem_RL_SetupRqstTDD_ExtIEs,
        _DL_DPCH_768_Information_RL_SetupRqstTDD_repetitionPeriod,
        _DL_DPCH_768_Information_RL_SetupRqstTDD_repetitionLength,
        _DL_DPCH_768_Information_RL_SetupRqstTDD_tdd_DPCHOffset,
        _DL_DPCH_768_Information_RL_SetupRqstTDD_dL_Timeslot768_Information,
        ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__id,
        ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions__item_,
        _DL_DPCH_768_Information_RL_SetupRqstTDD_iE_Extensions,
        DL_DPCH_768_Information_RL_SetupRqstTDD,
        DL_DPCH_768_InformationItem_RL_SetupRqstTDD_ExtIEs,
        _RL_Information_RL_SetupRqstTDD_rL_ID,
        _RL_Information_RL_SetupRqstTDD_c_ID,
        _RL_Information_RL_SetupRqstTDD_frameOffset,
        _RL_Information_RL_SetupRqstTDD_specialBurstScheduling,
        _RL_Information_RL_SetupRqstTDD_initialDL_transmissionPower,
        _RL_Information_RL_SetupRqstTDD_maximumDL_power,
        _RL_Information_RL_SetupRqstTDD_minimumDL_power,
        _RL_Information_RL_SetupRqstTDD_dL_TimeSlotISCPInfo,
        ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4,
        ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id,
        ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __RL_Information_RL_SetupRqstTDD_iE_Extensions__item_,
        _RL_Information_RL_SetupRqstTDD_iE_Extensions,
        RL_Information_RL_SetupRqstTDD,
        RL_Information_RL_SetupRqstTDD_ExtIEs,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_0,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_1,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_2,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_3,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_4,
        ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_4,
        ___RadioLinkSetupResponseFDD_protocolIEs__item__id,
        ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality,
        ___RadioLinkSetupResponseFDD_protocolIEs__item__value,
        __RadioLinkSetupResponseFDD_protocolIEs__item_,
        _RadioLinkSetupResponseFDD_protocolIEs,
        ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab,
        _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_3,
        ___RadioLinkSetupResponseFDD_protocolExtensions__item__id,
        ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality,
        ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupResponseFDD_protocolExtensions__item_,
        _RadioLinkSetupResponseFDD_protocolExtensions,
        RadioLinkSetupResponseFDD,
        RadioLinkSetupResponseFDD_IEs,
        _RadioLinkSetupResponseFDD_IEs_val_Value_0,
        _RadioLinkSetupResponseFDD_IEs_val_Value_1,
        _RadioLinkSetupResponseFDD_IEs_val_Value_2,
        _RadioLinkSetupResponseFDD_IEs_val_Value_3,
        _RadioLinkSetupResponseFDD_IEs_val_Value_4,
        RadioLinkSetupResponseFDD_Extensions,
        _RadioLinkSetupResponseFDD_Extensions_val_Extension_0,
        _RadioLinkSetupResponseFDD_Extensions_val_Extension_1,
        _RadioLinkSetupResponseFDD_Extensions_val_Extension_2,
        _RadioLinkSetupResponseFDD_Extensions_val_Extension_3,
        _Additional_HS_Cell_Information_Response_List__item_,
        Additional_HS_Cell_Information_Response_List,
        _Additional_HS_Cell_Information_Response_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_Response_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_Response,
        ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_Response_ItemIEs,
        Additional_HS_Cell_Information_Response_ItemIEs_ExtIEs,
        ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab,
        ____RL_InformationResponseList_RL_SetupRspFDD__item__id_tab_val_Value_0,
        __RL_InformationResponseList_RL_SetupRspFDD__item__id,
        __RL_InformationResponseList_RL_SetupRspFDD__item__criticality,
        __RL_InformationResponseList_RL_SetupRspFDD__item__value,
        _RL_InformationResponseList_RL_SetupRspFDD__item_,
        RL_InformationResponseList_RL_SetupRspFDD,
        RL_InformationResponseItemIE_RL_SetupRspFDD,
        _RL_InformationResponseItemIE_RL_SetupRspFDD_val_Value_0,
        _RL_InformationResponseItem_RL_SetupRspFDD_rL_ID,
        _RL_InformationResponseItem_RL_SetupRspFDD_rL_Set_ID,
        _RL_InformationResponseItem_RL_SetupRspFDD_received_total_wide_band_power,
        _RL_InformationResponseItem_RL_SetupRspFDD_diversityIndication,
        _RL_InformationResponseItem_RL_SetupRspFDD_not_Used_dSCH_InformationResponseList,
        _RL_InformationResponseItem_RL_SetupRspFDD_sSDT_SupportIndicator,
        ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id,
        ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality,
        ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item_,
        _RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions,
        RL_InformationResponseItem_RL_SetupRspFDD,
        RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_0,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_1,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_2,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_3,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_4,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_5,
        _DiversityIndication_RL_SetupRspFDD_combining,
        _DiversityIndication_RL_SetupRspFDD_nonCombiningOrFirstRL,
        DiversityIndication_RL_SetupRspFDD,
        _Combining_RL_SetupRspFDD_rL_ID,
        ____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab,
        ___Combining_RL_SetupRspFDD_iE_Extensions__item__id,
        ____Combining_RL_SetupRspFDD_iE_Extensions__item__criticality_tab,
        ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality,
        ____Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue_tab,
        ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue,
        __Combining_RL_SetupRspFDD_iE_Extensions__item_,
        _Combining_RL_SetupRspFDD_iE_Extensions,
        Combining_RL_SetupRspFDD,
        Combining_RL_SetupRspFDD_ExtIEs,
        _NonCombiningOrFirstRL_RL_SetupRspFDD_dCH_InformationResponse,
        ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab,
        _____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id,
        ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality,
        ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue,
        __NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item_,
        _NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions,
        NonCombiningOrFirstRL_RL_SetupRspFDD,
        NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs,
        _NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs_val_Extension_0,
        ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_4,
        ___RadioLinkSetupResponseTDD_protocolIEs__item__id,
        ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality,
        ___RadioLinkSetupResponseTDD_protocolIEs__item__value,
        __RadioLinkSetupResponseTDD_protocolIEs__item_,
        _RadioLinkSetupResponseTDD_protocolIEs,
        ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_10,
        ___RadioLinkSetupResponseTDD_protocolExtensions__item__id,
        ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality,
        ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupResponseTDD_protocolExtensions__item_,
        _RadioLinkSetupResponseTDD_protocolExtensions,
        RadioLinkSetupResponseTDD,
        RadioLinkSetupResponseTDD_IEs,
        _RadioLinkSetupResponseTDD_IEs_val_Value_0,
        _RadioLinkSetupResponseTDD_IEs_val_Value_1,
        _RadioLinkSetupResponseTDD_IEs_val_Value_2,
        _RadioLinkSetupResponseTDD_IEs_val_Value_3,
        _RadioLinkSetupResponseTDD_IEs_val_Value_4,
        RadioLinkSetupResponseTDD_Extensions,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_0,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_1,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_2,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_3,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_4,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_5,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_6,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_7,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_8,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_9,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_10,
        _RL_InformationResponse_RL_SetupRspTDD_rL_ID,
        _RL_InformationResponse_RL_SetupRspTDD_uL_TimeSlot_ISCP_Info,
        _RL_InformationResponse_RL_SetupRspTDD_ul_PhysCH_SF_Variation,
        _RL_InformationResponse_RL_SetupRspTDD_dCH_InformationResponseList,
        _RL_InformationResponse_RL_SetupRspTDD_dSCH_InformationResponseList,
        _RL_InformationResponse_RL_SetupRspTDD_uSCH_InformationResponseList,
        ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id,
        ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality_tab,
        ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab,
        ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_,
        _RL_InformationResponse_RL_SetupRspTDD_iE_Extensions,
        RL_InformationResponse_RL_SetupRspTDD,
        RL_InformationResponseList_RL_SetupRspTDD_ExtIEs,
        __DCH_InformationResponseList_RL_SetupRspTDD_id_tab,
        ___DCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0,
        _DCH_InformationResponseList_RL_SetupRspTDD_id,
        _DCH_InformationResponseList_RL_SetupRspTDD_criticality,
        _DCH_InformationResponseList_RL_SetupRspTDD_value,
        DCH_InformationResponseList_RL_SetupRspTDD,
        DCH_InformationResponseListIEs_RL_SetupRspTDD,
        _DCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0,
        __DSCH_InformationResponseList_RL_SetupRspTDD_id_tab,
        ___DSCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0,
        _DSCH_InformationResponseList_RL_SetupRspTDD_id,
        _DSCH_InformationResponseList_RL_SetupRspTDD_criticality,
        _DSCH_InformationResponseList_RL_SetupRspTDD_value,
        DSCH_InformationResponseList_RL_SetupRspTDD,
        DSCH_InformationResponseListIEs_RL_SetupRspTDD,
        _DSCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0,
        __USCH_InformationResponseList_RL_SetupRspTDD_id_tab,
        ___USCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0,
        _USCH_InformationResponseList_RL_SetupRspTDD_id,
        _USCH_InformationResponseList_RL_SetupRspTDD_criticality,
        _USCH_InformationResponseList_RL_SetupRspTDD_value,
        USCH_InformationResponseList_RL_SetupRspTDD,
        USCH_InformationResponseListIEs_RL_SetupRspTDD,
        _USCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0,
        _RL_InformationResponse_LCR_RL_SetupRspTDD_rL_ID,
        _RL_InformationResponse_LCR_RL_SetupRspTDD_uL_TimeSlot_ISCP_LCR_Info,
        _RL_InformationResponse_LCR_RL_SetupRspTDD_ul_PhysCH_SF_Variation,
        _RL_InformationResponse_LCR_RL_SetupRspTDD_dCH_InformationResponseList,
        _RL_InformationResponse_LCR_RL_SetupRspTDD_dSCH_InformationResponseList,
        _RL_InformationResponse_LCR_RL_SetupRspTDD_uSCH_InformationResponseList,
        ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__id,
        ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__criticality_tab,
        ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ____RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab,
        ___RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions__item_,
        _RL_InformationResponse_LCR_RL_SetupRspTDD_iE_Extensions,
        RL_InformationResponse_LCR_RL_SetupRspTDD,
        RL_InformationResponseList_LCR_RL_SetupRspTDD_ExtIEs,
        ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_4,
        ___RadioLinkSetupFailureFDD_protocolIEs__item__id,
        ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality,
        ___RadioLinkSetupFailureFDD_protocolIEs__item__value,
        __RadioLinkSetupFailureFDD_protocolIEs__item_,
        _RadioLinkSetupFailureFDD_protocolIEs,
        ____RadioLinkSetupFailureFDD_protocolExtensions__item__id_tab,
        ___RadioLinkSetupFailureFDD_protocolExtensions__item__id,
        ____RadioLinkSetupFailureFDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality,
        ____RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupFailureFDD_protocolExtensions__item_,
        _RadioLinkSetupFailureFDD_protocolExtensions,
        RadioLinkSetupFailureFDD,
        RadioLinkSetupFailureFDD_IEs,
        _RadioLinkSetupFailureFDD_IEs_val_Value_0,
        _RadioLinkSetupFailureFDD_IEs_val_Value_1,
        _RadioLinkSetupFailureFDD_IEs_val_Value_2,
        _RadioLinkSetupFailureFDD_IEs_val_Value_3,
        _RadioLinkSetupFailureFDD_IEs_val_Value_4,
        RadioLinkSetupFailureFDD_Extensions,
        _CauseLevel_RL_SetupFailureFDD_generalCause,
        _CauseLevel_RL_SetupFailureFDD_rLSpecificCause,
        CauseLevel_RL_SetupFailureFDD,
        _GeneralCauseList_RL_SetupFailureFDD_cause,
        ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id,
        ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item_,
        _GeneralCauseList_RL_SetupFailureFDD_iE_Extensions,
        GeneralCauseList_RL_SetupFailureFDD,
        GeneralCauseItem_RL_SetupFailureFDD_ExtIEs,
        _RLSpecificCauseList_RL_SetupFailureFDD_unsuccessful_RL_InformationRespList_RL_SetupFailureFDD,
        _RLSpecificCauseList_RL_SetupFailureFDD_successful_RL_InformationRespList_RL_SetupFailureFDD,
        ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3,
        ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id,
        ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item_,
        _RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions,
        RLSpecificCauseList_RL_SetupFailureFDD,
        RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs,
        _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0,
        _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1,
        _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_2,
        _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_3,
        ___Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab,
        ____Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab_val_Value_0,
        __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__id,
        __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality,
        __Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item__value,
        _Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD__item_,
        Unsuccessful_RL_InformationRespList_RL_SetupFailureFDD,
        Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureFDD,
        _Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureFDD_val_Value_0,
        _Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_rL_ID,
        _Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_cause,
        ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id,
        ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab,
        ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ____Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab,
        ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item_,
        _Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions,
        Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD,
        Unsuccessful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs,
        ___Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab,
        ____Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id_tab_val_Value_0,
        __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__id,
        __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__criticality,
        __Successful_RL_InformationRespList_RL_SetupFailureFDD__item__value,
        _Successful_RL_InformationRespList_RL_SetupFailureFDD__item_,
        Successful_RL_InformationRespList_RL_SetupFailureFDD,
        Successful_RL_InformationRespItemIE_RL_SetupFailureFDD,
        _Successful_RL_InformationRespItemIE_RL_SetupFailureFDD_val_Value_0,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_rL_ID,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_rL_Set_ID,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_received_total_wide_band_power,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_diversityIndication,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_not_Used_dSCH_InformationResponseList,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_not_Used_tFCI2_BearerInformationResponse,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_sSDT_SupportIndicator,
        ____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__id,
        ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ___Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions__item_,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_iE_Extensions,
        Successful_RL_InformationRespItem_RL_SetupFailureFDD,
        Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_2,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_3,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_4,
        _Successful_RL_InformationRespItem_RL_SetupFailureFDD_ExtIEs_val_Extension_5,
        _DiversityIndication_RL_SetupFailureFDD_combining,
        _DiversityIndication_RL_SetupFailureFDD_nonCombiningOrFirstRL,
        DiversityIndication_RL_SetupFailureFDD,
        _Combining_RL_SetupFailureFDD_rL_ID,
        ____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id,
        ____Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab,
        ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ____Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab,
        ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __Combining_RL_SetupFailureFDD_iE_Extensions__item_,
        _Combining_RL_SetupFailureFDD_iE_Extensions,
        Combining_RL_SetupFailureFDD,
        CombiningItem_RL_SetupFailureFDD_ExtIEs,
        _NonCombiningOrFirstRL_RL_SetupFailureFDD_dCH_InformationResponse,
        ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        _____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id,
        ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item_,
        _NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions,
        NonCombiningOrFirstRL_RL_SetupFailureFDD,
        NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs,
        _NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0,
        ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkSetupFailureTDD_protocolIEs__item__id,
        ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality,
        ___RadioLinkSetupFailureTDD_protocolIEs__item__value,
        __RadioLinkSetupFailureTDD_protocolIEs__item_,
        _RadioLinkSetupFailureTDD_protocolIEs,
        ____RadioLinkSetupFailureTDD_protocolExtensions__item__id_tab,
        ___RadioLinkSetupFailureTDD_protocolExtensions__item__id,
        ____RadioLinkSetupFailureTDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality,
        ____RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupFailureTDD_protocolExtensions__item_,
        _RadioLinkSetupFailureTDD_protocolExtensions,
        RadioLinkSetupFailureTDD,
        RadioLinkSetupFailureTDD_IEs,
        _RadioLinkSetupFailureTDD_IEs_val_Value_0,
        _RadioLinkSetupFailureTDD_IEs_val_Value_1,
        _RadioLinkSetupFailureTDD_IEs_val_Value_2,
        RadioLinkSetupFailureTDD_Extensions,
        _CauseLevel_RL_SetupFailureTDD_generalCause,
        _CauseLevel_RL_SetupFailureTDD_rLSpecificCause,
        CauseLevel_RL_SetupFailureTDD,
        _GeneralCauseList_RL_SetupFailureTDD_cause,
        ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab,
        ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id,
        ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality,
        ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue,
        __GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item_,
        _GeneralCauseList_RL_SetupFailureTDD_iE_Extensions,
        GeneralCauseList_RL_SetupFailureTDD,
        GeneralCauseItem_RL_SetupFailureTDD_ExtIEs,
        _RLSpecificCauseList_RL_SetupFailureTDD_unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD,
        ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab,
        ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id,
        ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab,
        ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality,
        ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue,
        __RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item_,
        _RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions,
        RLSpecificCauseList_RL_SetupFailureTDD,
        RLSpecificCauseItem_RL_SetupFailureTDD_ExtIEs,
        __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab,
        ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab_val_Value_0,
        _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id,
        _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality,
        _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value,
        Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD,
        Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD,
        _Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD_val_Value_0,
        _Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_rL_ID,
        _Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_cause,
        ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__id_tab,
        ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__id,
        ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab,
        ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__criticality,
        ____Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item__extensionValue,
        __Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions__item_,
        _Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_iE_Extensions,
        Unsuccessful_RL_InformationResp_RL_SetupFailureTDD,
        Unsuccessful_RL_InformationResp_RL_SetupFailureTDD_ExtIEs,
        ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkAdditionRequestFDD_protocolIEs__item__id,
        ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionRequestFDD_protocolIEs__item__value,
        __RadioLinkAdditionRequestFDD_protocolIEs__item_,
        _RadioLinkAdditionRequestFDD_protocolIEs,
        ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_14,
        ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id,
        ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality,
        ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionRequestFDD_protocolExtensions__item_,
        _RadioLinkAdditionRequestFDD_protocolExtensions,
        RadioLinkAdditionRequestFDD,
        RadioLinkAdditionRequestFDD_IEs,
        _RadioLinkAdditionRequestFDD_IEs_val_Value_0,
        _RadioLinkAdditionRequestFDD_IEs_val_Value_1,
        _RadioLinkAdditionRequestFDD_IEs_val_Value_2,
        RadioLinkAdditionRequestFDD_Extensions,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_0,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_1,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_2,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_3,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_4,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_5,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_6,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_7,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_8,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_9,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_10,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_11,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_12,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_13,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_14,
        _Additional_HS_Cell_Information_RL_Addition_List__item_,
        Additional_HS_Cell_Information_RL_Addition_List,
        _Additional_EDCH_Cell_Information_RL_Add_Req_setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency,
        ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions,
        Additional_EDCH_Cell_Information_RL_Add_Req,
        Additional_EDCH_Cell_Information_RL_Add_Req_ExtIEs,
        _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_setup,
        _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_addition,
        Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency,
        _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_RL_Addition_ItemIEs_c_ID,
        _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information,
        ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_RL_Addition_ItemIEs,
        Additional_HS_Cell_Information_RL_Addition_ItemIEs_ExtIEs,
        ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab,
        ____RL_InformationList_RL_AdditionRqstFDD__item__id_tab_val_Value_0,
        __RL_InformationList_RL_AdditionRqstFDD__item__id,
        __RL_InformationList_RL_AdditionRqstFDD__item__criticality,
        __RL_InformationList_RL_AdditionRqstFDD__item__value,
        _RL_InformationList_RL_AdditionRqstFDD__item_,
        RL_InformationList_RL_AdditionRqstFDD,
        RL_InformationItemIE_RL_AdditionRqstFDD,
        _RL_InformationItemIE_RL_AdditionRqstFDD_val_Value_0,
        _RL_InformationItem_RL_AdditionRqstFDD_rL_ID,
        _RL_InformationItem_RL_AdditionRqstFDD_c_ID,
        _RL_InformationItem_RL_AdditionRqstFDD_frameOffset,
        _RL_InformationItem_RL_AdditionRqstFDD_chipOffset,
        _RL_InformationItem_RL_AdditionRqstFDD_diversityControlField,
        _RL_InformationItem_RL_AdditionRqstFDD_dl_CodeInformation,
        _RL_InformationItem_RL_AdditionRqstFDD_initialDL_TransmissionPower,
        _RL_InformationItem_RL_AdditionRqstFDD_maximumDL_Power,
        _RL_InformationItem_RL_AdditionRqstFDD_minimumDL_Power,
        _RL_InformationItem_RL_AdditionRqstFDD_not_Used_sSDT_CellIdentity,
        _RL_InformationItem_RL_AdditionRqstFDD_transmitDiversityIndicator,
        ____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab,
        _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_9,
        _____RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_10,
        ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__id,
        ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__criticality,
        ___RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue,
        __RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions__item_,
        _RL_InformationItem_RL_AdditionRqstFDD_iE_Extensions,
        RL_InformationItem_RL_AdditionRqstFDD,
        RL_InformationItem_RL_AdditionRqstFDD_ExtIEs,
        _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_0,
        _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_1,
        _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_2,
        _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_3,
        _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_4,
        _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_5,
        _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_6,
        _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_7,
        _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_8,
        _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_9,
        _RL_InformationItem_RL_AdditionRqstFDD_ExtIEs_val_Extension_10,
        _E_DPCH_Information_RL_AdditionReqFDD_maxSet_E_DPDCHs,
        _E_DPCH_Information_RL_AdditionReqFDD_ul_PunctureLimit,
        _E_DPCH_Information_RL_AdditionReqFDD_e_TFCS_Information,
        _E_DPCH_Information_RL_AdditionReqFDD_e_TTI,
        _E_DPCH_Information_RL_AdditionReqFDD_e_DPCCH_PO,
        _E_DPCH_Information_RL_AdditionReqFDD_e_RGCH_2_IndexStepThreshold,
        _E_DPCH_Information_RL_AdditionReqFDD_e_RGCH_3_IndexStepThreshold,
        _E_DPCH_Information_RL_AdditionReqFDD_hARQ_Info_for_E_DCH,
        ____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab,
        _____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__id,
        ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__criticality,
        ___E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item__extensionValue,
        __E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions__item_,
        _E_DPCH_Information_RL_AdditionReqFDD_iE_Extensions,
        E_DPCH_Information_RL_AdditionReqFDD,
        E_DPCH_Information_RL_AdditionReqFDD_ExtIEs,
        _E_DPCH_Information_RL_AdditionReqFDD_ExtIEs_val_Extension_0,
        _E_DPCH_Information_RL_AdditionReqFDD_ExtIEs_val_Extension_1,
        ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_3,
        ___RadioLinkAdditionRequestTDD_protocolIEs__item__id,
        ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionRequestTDD_protocolIEs__item__value,
        __RadioLinkAdditionRequestTDD_protocolIEs__item_,
        _RadioLinkAdditionRequestTDD_protocolIEs,
        ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_17,
        ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id,
        ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality,
        ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionRequestTDD_protocolExtensions__item_,
        _RadioLinkAdditionRequestTDD_protocolExtensions,
        RadioLinkAdditionRequestTDD,
        RadioLinkAdditionRequestTDD_IEs,
        _RadioLinkAdditionRequestTDD_IEs_val_Value_0,
        _RadioLinkAdditionRequestTDD_IEs_val_Value_1,
        _RadioLinkAdditionRequestTDD_IEs_val_Value_2,
        _RadioLinkAdditionRequestTDD_IEs_val_Value_3,
        RadioLinkAdditionRequestTDD_Extensions,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_0,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_1,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_2,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_3,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_4,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_5,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_6,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_7,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_8,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_9,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_10,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_11,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_12,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_13,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_14,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_15,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_16,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_17,
        _UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_,
        UL_CCTrCH_InformationList_RL_AdditionRqstTDD,
        _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID,
        _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_uL_DPCH_Information,
        ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        _____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions,
        UL_CCTrCH_InformationItem_RL_AdditionRqstTDD,
        UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs,
        _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_0,
        _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_1,
        _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_2,
        __UL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab,
        ___UL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab_val_Value_0,
        _UL_DPCH_InformationList_RL_AdditionRqstTDD_id,
        _UL_DPCH_InformationList_RL_AdditionRqstTDD_criticality,
        _UL_DPCH_InformationList_RL_AdditionRqstTDD_value,
        UL_DPCH_InformationList_RL_AdditionRqstTDD,
        UL_DPCH_InformationItemIE_RL_AdditionRqstTDD,
        _UL_DPCH_InformationItemIE_RL_AdditionRqstTDD_val_Value_0,
        _UL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionPeriod,
        _UL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionLength,
        _UL_DPCH_InformationItem_RL_AdditionRqstTDD_tdd_DPCHOffset,
        _UL_DPCH_InformationItem_RL_AdditionRqstTDD_uL_Timeslot_Information,
        ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_,
        _UL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions,
        UL_DPCH_InformationItem_RL_AdditionRqstTDD,
        UL_DPCH_InformationItem_RL_AdditionRqstTDD_ExtIEs,
        _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionPeriod,
        _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionLength,
        _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_tdd_DPCHOffset,
        _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_uL_TimeslotLCR_Information,
        ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item_,
        _UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions,
        UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD,
        UL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_ExtIEs,
        _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionPeriod,
        _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionLength,
        _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_tdd_DPCHOffset,
        _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_uL_Timeslot768_Information,
        ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item_,
        _UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions,
        UL_DPCH_InformationItem_768_RL_AdditionRqstTDD,
        UL_DPCH_InformationItem_768_RL_AdditionRqstTDD_ExtIEs,
        _DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_,
        DL_CCTrCH_InformationList_RL_AdditionRqstTDD,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_dL_DPCH_Information,
        ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions,
        DL_CCTrCH_InformationItem_RL_AdditionRqstTDD,
        DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_0,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_1,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_2,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_3,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_4,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs_val_Extension_5,
        __DL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab,
        ___DL_DPCH_InformationList_RL_AdditionRqstTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationList_RL_AdditionRqstTDD_id,
        _DL_DPCH_InformationList_RL_AdditionRqstTDD_criticality,
        _DL_DPCH_InformationList_RL_AdditionRqstTDD_value,
        DL_DPCH_InformationList_RL_AdditionRqstTDD,
        DL_DPCH_InformationItemIE_RL_AdditionRqstTDD,
        _DL_DPCH_InformationItemIE_RL_AdditionRqstTDD_val_Value_0,
        _DL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionPeriod,
        _DL_DPCH_InformationItem_RL_AdditionRqstTDD_repetitionLength,
        _DL_DPCH_InformationItem_RL_AdditionRqstTDD_tdd_DPCHOffset,
        _DL_DPCH_InformationItem_RL_AdditionRqstTDD_dL_Timeslot_Information,
        ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_,
        _DL_DPCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions,
        DL_DPCH_InformationItem_RL_AdditionRqstTDD,
        DL_DPCH_InformationItem_RL_AdditionRqstTDD_ExtIEs,
        _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionPeriod,
        _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_repetitionLength,
        _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_tdd_DPCHOffset,
        _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_dL_TimeslotLCR_Information,
        ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions__item_,
        _DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_iE_Extensions,
        DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD,
        DL_DPCH_InformationItem_LCR_RL_AdditionRqstTDD_ExtIEs,
        _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionPeriod,
        _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_repetitionLength,
        _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_tdd_DPCHOffset,
        _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_dL_Timeslot768_Information,
        ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions__item_,
        _DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_iE_Extensions,
        DL_DPCH_InformationItem_768_RL_AdditionRqstTDD,
        DL_DPCH_InformationItem_768_RL_AdditionRqstTDD_ExtIEs,
        _RL_Information_RL_AdditionRqstTDD_rL_ID,
        _RL_Information_RL_AdditionRqstTDD_c_ID,
        _RL_Information_RL_AdditionRqstTDD_frameOffset,
        _RL_Information_RL_AdditionRqstTDD_diversityControlField,
        _RL_Information_RL_AdditionRqstTDD_initial_DL_Transmission_Power,
        _RL_Information_RL_AdditionRqstTDD_maximumDL_Power,
        _RL_Information_RL_AdditionRqstTDD_minimumDL_Power,
        _RL_Information_RL_AdditionRqstTDD_dL_TimeSlotISCPInfo,
        ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_4,
        ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __RL_Information_RL_AdditionRqstTDD_iE_Extensions__item_,
        _RL_Information_RL_AdditionRqstTDD_iE_Extensions,
        RL_Information_RL_AdditionRqstTDD,
        RL_information_RL_AdditionRqstTDD_ExtIEs,
        _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_0,
        _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_1,
        _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_2,
        _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_3,
        _RL_information_RL_AdditionRqstTDD_ExtIEs_val_Extension_4,
        ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkAdditionResponseFDD_protocolIEs__item__id,
        ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionResponseFDD_protocolIEs__item__value,
        __RadioLinkAdditionResponseFDD_protocolIEs__item_,
        _RadioLinkAdditionResponseFDD_protocolIEs,
        ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab,
        _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_4,
        ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id,
        ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality,
        ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionResponseFDD_protocolExtensions__item_,
        _RadioLinkAdditionResponseFDD_protocolExtensions,
        RadioLinkAdditionResponseFDD,
        RadioLinkAdditionResponseFDD_IEs,
        _RadioLinkAdditionResponseFDD_IEs_val_Value_0,
        _RadioLinkAdditionResponseFDD_IEs_val_Value_1,
        _RadioLinkAdditionResponseFDD_IEs_val_Value_2,
        RadioLinkAdditionResponseFDD_Extensions,
        _RadioLinkAdditionResponseFDD_Extensions_val_Extension_0,
        _RadioLinkAdditionResponseFDD_Extensions_val_Extension_1,
        _RadioLinkAdditionResponseFDD_Extensions_val_Extension_2,
        _RadioLinkAdditionResponseFDD_Extensions_val_Extension_3,
        _RadioLinkAdditionResponseFDD_Extensions_val_Extension_4,
        _Additional_HS_Cell_Change_Information_Response_List__item_,
        Additional_HS_Cell_Change_Information_Response_List,
        _Additional_HS_Cell_Change_Information_Response_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Change_Information_Response_ItemIEs_hS_DSCH_Secondary_Serving_Cell_Change_Information_Response,
        ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Change_Information_Response_ItemIEs,
        Additional_HS_Cell_Change_Information_Response_ItemIEs_ExtIEs,
        ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab,
        ____RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab_val_Value_0,
        __RL_InformationResponseList_RL_AdditionRspFDD__item__id,
        __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality,
        __RL_InformationResponseList_RL_AdditionRspFDD__item__value,
        _RL_InformationResponseList_RL_AdditionRspFDD__item_,
        RL_InformationResponseList_RL_AdditionRspFDD,
        RL_InformationResponseItemIE_RL_AdditionRspFDD,
        _RL_InformationResponseItemIE_RL_AdditionRspFDD_val_Value_0,
        _RL_InformationResponseItem_RL_AdditionRspFDD_rL_ID,
        _RL_InformationResponseItem_RL_AdditionRspFDD_rL_Set_ID,
        _RL_InformationResponseItem_RL_AdditionRspFDD_received_total_wide_band_power,
        _RL_InformationResponseItem_RL_AdditionRspFDD_diversityIndication,
        _RL_InformationResponseItem_RL_AdditionRspFDD_sSDT_SupportIndicator,
        ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id,
        ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality,
        ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item_,
        _RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions,
        RL_InformationResponseItem_RL_AdditionRspFDD,
        RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_1,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_2,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_3,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_4,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_5,
        _DiversityIndication_RL_AdditionRspFDD_combining,
        _DiversityIndication_RL_AdditionRspFDD_non_combining,
        DiversityIndication_RL_AdditionRspFDD,
        _Combining_RL_AdditionRspFDD_rL_ID,
        ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab,
        _____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id,
        ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality,
        ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue,
        __Combining_RL_AdditionRspFDD_iE_Extensions__item_,
        _Combining_RL_AdditionRspFDD_iE_Extensions,
        Combining_RL_AdditionRspFDD,
        CombiningItem_RL_AdditionRspFDD_ExtIEs,
        _CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0,
        _Non_Combining_RL_AdditionRspFDD_dCH_InformationResponse,
        ____Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab,
        _____Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__id,
        ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality,
        ___Non_Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue,
        __Non_Combining_RL_AdditionRspFDD_iE_Extensions__item_,
        _Non_Combining_RL_AdditionRspFDD_iE_Extensions,
        Non_Combining_RL_AdditionRspFDD,
        Non_CombiningItem_RL_AdditionRspFDD_ExtIEs,
        _Non_CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0,
        ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkAdditionResponseTDD_protocolIEs__item__id,
        ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionResponseTDD_protocolIEs__item__value,
        __RadioLinkAdditionResponseTDD_protocolIEs__item_,
        _RadioLinkAdditionResponseTDD_protocolIEs,
        ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_9,
        ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id,
        ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality,
        ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionResponseTDD_protocolExtensions__item_,
        _RadioLinkAdditionResponseTDD_protocolExtensions,
        RadioLinkAdditionResponseTDD,
        RadioLinkAdditionResponseTDD_IEs,
        _RadioLinkAdditionResponseTDD_IEs_val_Value_0,
        _RadioLinkAdditionResponseTDD_IEs_val_Value_1,
        _RadioLinkAdditionResponseTDD_IEs_val_Value_2,
        RadioLinkAdditionResponseTDD_Extensions,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_0,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_1,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_2,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_3,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_4,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_5,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_6,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_7,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_8,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_9,
        _RL_InformationResponse_RL_AdditionRspTDD_rL_ID,
        _RL_InformationResponse_RL_AdditionRspTDD_uL_TimeSlot_ISCP_Info,
        _RL_InformationResponse_RL_AdditionRspTDD_ul_PhysCH_SF_Variation,
        _RL_InformationResponse_RL_AdditionRspTDD_dCH_Information,
        _RL_InformationResponse_RL_AdditionRspTDD_dSCH_InformationResponseList,
        _RL_InformationResponse_RL_AdditionRspTDD_uSCH_InformationResponseList,
        ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_,
        _RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions,
        RL_InformationResponse_RL_AdditionRspTDD,
        RL_InformationResponse_RL_AdditionRspTDD_ExtIEs,
        _DCH_Information_RL_AdditionRspTDD_diversityIndication,
        ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __DCH_Information_RL_AdditionRspTDD_iE_Extensions__item_,
        _DCH_Information_RL_AdditionRspTDD_iE_Extensions,
        DCH_Information_RL_AdditionRspTDD,
        DCH_Information_RL_AdditionRspTDD_ExtIEs,
        _DiversityIndication_RL_AdditionRspTDD_combining,
        _DiversityIndication_RL_AdditionRspTDD_non_Combining,
        DiversityIndication_RL_AdditionRspTDD,
        _Combining_RL_AdditionRspTDD_rL_ID,
        ____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __Combining_RL_AdditionRspTDD_iE_Extensions__item_,
        _Combining_RL_AdditionRspTDD_iE_Extensions,
        Combining_RL_AdditionRspTDD,
        CombiningItem_RL_AdditionRspTDD_ExtIEs,
        _Non_Combining_RL_AdditionRspTDD_dCH_InformationResponse,
        ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___Non_Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __Non_Combining_RL_AdditionRspTDD_iE_Extensions__item_,
        _Non_Combining_RL_AdditionRspTDD_iE_Extensions,
        Non_Combining_RL_AdditionRspTDD,
        Non_CombiningItem_RL_AdditionRspTDD_ExtIEs,
        __DSCH_InformationResponseList_RL_AdditionRspTDD_id_tab,
        ___DSCH_InformationResponseList_RL_AdditionRspTDD_id_tab_val_Value_0,
        _DSCH_InformationResponseList_RL_AdditionRspTDD_id,
        _DSCH_InformationResponseList_RL_AdditionRspTDD_criticality,
        _DSCH_InformationResponseList_RL_AdditionRspTDD_value,
        DSCH_InformationResponseList_RL_AdditionRspTDD,
        DSCH_InformationResponseListIEs_RL_AdditionRspTDD,
        _DSCH_InformationResponseListIEs_RL_AdditionRspTDD_val_Value_0,
        __USCH_InformationResponseList_RL_AdditionRspTDD_id_tab,
        ___USCH_InformationResponseList_RL_AdditionRspTDD_id_tab_val_Value_0,
        _USCH_InformationResponseList_RL_AdditionRspTDD_id,
        _USCH_InformationResponseList_RL_AdditionRspTDD_criticality,
        _USCH_InformationResponseList_RL_AdditionRspTDD_value,
        USCH_InformationResponseList_RL_AdditionRspTDD,
        USCH_InformationResponseListIEs_RL_AdditionRspTDD,
        _USCH_InformationResponseListIEs_RL_AdditionRspTDD_val_Value_0,
        _RL_InformationResponse_LCR_RL_AdditionRspTDD_rL_ID,
        _RL_InformationResponse_LCR_RL_AdditionRspTDD_uL_TimeSlot_ISCP_InfoLCR,
        _RL_InformationResponse_LCR_RL_AdditionRspTDD_ul_PhysCH_SF_Variation,
        _RL_InformationResponse_LCR_RL_AdditionRspTDD_dCH_Information,
        _RL_InformationResponse_LCR_RL_AdditionRspTDD_dSCH_InformationResponseList,
        _RL_InformationResponse_LCR_RL_AdditionRspTDD_uSCH_InformationResponseList,
        ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions__item_,
        _RL_InformationResponse_LCR_RL_AdditionRspTDD_iE_Extensions,
        RL_InformationResponse_LCR_RL_AdditionRspTDD,
        RL_InformationResponse_LCR_RL_AdditionRspTDD_ExtIEs,
        ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkAdditionFailureFDD_protocolIEs__item__id,
        ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionFailureFDD_protocolIEs__item__value,
        __RadioLinkAdditionFailureFDD_protocolIEs__item_,
        _RadioLinkAdditionFailureFDD_protocolIEs,
        ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab,
        _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_4,
        ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id,
        ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality,
        ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionFailureFDD_protocolExtensions__item_,
        _RadioLinkAdditionFailureFDD_protocolExtensions,
        RadioLinkAdditionFailureFDD,
        RadioLinkAdditionFailureFDD_IEs,
        _RadioLinkAdditionFailureFDD_IEs_val_Value_0,
        _RadioLinkAdditionFailureFDD_IEs_val_Value_1,
        _RadioLinkAdditionFailureFDD_IEs_val_Value_2,
        RadioLinkAdditionFailureFDD_Extensions,
        _RadioLinkAdditionFailureFDD_Extensions_val_Extension_0,
        _RadioLinkAdditionFailureFDD_Extensions_val_Extension_1,
        _RadioLinkAdditionFailureFDD_Extensions_val_Extension_2,
        _RadioLinkAdditionFailureFDD_Extensions_val_Extension_3,
        _RadioLinkAdditionFailureFDD_Extensions_val_Extension_4,
        _CauseLevel_RL_AdditionFailureFDD_generalCause,
        _CauseLevel_RL_AdditionFailureFDD_rLSpecificCause,
        CauseLevel_RL_AdditionFailureFDD,
        _GeneralCauseList_RL_AdditionFailureFDD_cause,
        ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item_,
        _GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions,
        GeneralCauseList_RL_AdditionFailureFDD,
        GeneralCauseItem_RL_AdditionFailureFDD_ExtIEs,
        _RLSpecificCauseList_RL_AdditionFailureFDD_unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD,
        _RLSpecificCauseList_RL_AdditionFailureFDD_successful_RL_InformationRespList_RL_AdditionFailureFDD,
        ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab,
        ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab,
        ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item_,
        _RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions,
        RLSpecificCauseList_RL_AdditionFailureFDD,
        RLSpecificCauseItem_RL_AdditionFailureFDD_ExtIEs,
        ___Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab,
        ____Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab_val_Value_0,
        __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__id,
        __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality,
        __Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item__value,
        _Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD__item_,
        Unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD,
        Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureFDD,
        _Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureFDD_val_Value_0,
        _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_rL_ID,
        _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_cause,
        ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab,
        ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ____Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab,
        ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item_,
        _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions,
        Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD,
        Unsuccessful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs,
        ___Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab,
        ____Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id_tab_val_Value_0,
        __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__id,
        __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__criticality,
        __Successful_RL_InformationRespList_RL_AdditionFailureFDD__item__value,
        _Successful_RL_InformationRespList_RL_AdditionFailureFDD__item_,
        Successful_RL_InformationRespList_RL_AdditionFailureFDD,
        Successful_RL_InformationRespItemIE_RL_AdditionFailureFDD,
        _Successful_RL_InformationRespItemIE_RL_AdditionFailureFDD_val_Value_0,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_rL_ID,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_rL_Set_ID,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_received_total_wide_band_power,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_diversityIndication,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_sSDT_SupportIndicator,
        ____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ___Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions__item_,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_iE_Extensions,
        Successful_RL_InformationRespItem_RL_AdditionFailureFDD,
        Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_1,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_2,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_3,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_4,
        _Successful_RL_InformationRespItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_5,
        _DiversityIndication_RL_AdditionFailureFDD_combining,
        _DiversityIndication_RL_AdditionFailureFDD_non_Combining,
        DiversityIndication_RL_AdditionFailureFDD,
        _Combining_RL_AdditionFailureFDD_rL_ID,
        ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        _____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __Combining_RL_AdditionFailureFDD_iE_Extensions__item_,
        _Combining_RL_AdditionFailureFDD_iE_Extensions,
        Combining_RL_AdditionFailureFDD,
        CombiningItem_RL_AdditionFailureFDD_ExtIEs,
        _CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0,
        _Non_Combining_RL_AdditionFailureFDD_dCH_InformationResponse,
        ____Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        _____Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ___Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __Non_Combining_RL_AdditionFailureFDD_iE_Extensions__item_,
        _Non_Combining_RL_AdditionFailureFDD_iE_Extensions,
        Non_Combining_RL_AdditionFailureFDD,
        Non_CombiningItem_RL_AdditionFailureFDD_ExtIEs,
        _Non_CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0,
        ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkAdditionFailureTDD_protocolIEs__item__id,
        ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionFailureTDD_protocolIEs__item__value,
        __RadioLinkAdditionFailureTDD_protocolIEs__item_,
        _RadioLinkAdditionFailureTDD_protocolIEs,
        ____RadioLinkAdditionFailureTDD_protocolExtensions__item__id_tab,
        ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id,
        ____RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality,
        ____RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionFailureTDD_protocolExtensions__item_,
        _RadioLinkAdditionFailureTDD_protocolExtensions,
        RadioLinkAdditionFailureTDD,
        RadioLinkAdditionFailureTDD_IEs,
        _RadioLinkAdditionFailureTDD_IEs_val_Value_0,
        _RadioLinkAdditionFailureTDD_IEs_val_Value_1,
        _RadioLinkAdditionFailureTDD_IEs_val_Value_2,
        RadioLinkAdditionFailureTDD_Extensions,
        _CauseLevel_RL_AdditionFailureTDD_generalCause,
        _CauseLevel_RL_AdditionFailureTDD_rLSpecificCause,
        CauseLevel_RL_AdditionFailureTDD,
        _GeneralCauseList_RL_AdditionFailureTDD_cause,
        ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab,
        ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id,
        ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality,
        ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue,
        __GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item_,
        _GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions,
        GeneralCauseList_RL_AdditionFailureTDD,
        GeneralCauseItem_RL_AdditionFailureTDD_ExtIEs,
        _RLSpecificCauseList_RL_AdditionFailureTDD_unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD,
        ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab,
        ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id,
        ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab,
        ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality,
        ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue,
        __RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item_,
        _RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions,
        RLSpecificCauseList_RL_AdditionFailureTDD,
        RLSpecificCauseItem_RL_AdditionFailureTDD_ExtIEs,
        __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab,
        ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab_val_Value_0,
        _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id,
        _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality,
        _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value,
        Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD,
        Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD,
        _Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD_val_Value_0,
        _Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_rL_ID,
        _Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_cause,
        ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__id_tab,
        ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__id,
        ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab,
        ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__criticality,
        ____Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue,
        __Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions__item_,
        _Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_iE_Extensions,
        Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD,
        Unsuccessful_RL_InformationResp_RL_AdditionFailureTDD_ExtIEs,
        ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_6,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_7,
        ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value,
        __RadioLinkReconfigurationPrepareFDD_protocolIEs__item_,
        _RadioLinkReconfigurationPrepareFDD_protocolIEs,
        ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_19,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_20,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_21,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_22,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_23,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_24,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_25,
        ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationPrepareFDD_protocolExtensions__item_,
        _RadioLinkReconfigurationPrepareFDD_protocolExtensions,
        RadioLinkReconfigurationPrepareFDD,
        RadioLinkReconfigurationPrepareFDD_IEs,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_0,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_1,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_2,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_3,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_4,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_5,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_6,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_7,
        RadioLinkReconfigurationPrepareFDD_Extensions,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_5,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_6,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_7,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_8,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_9,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_10,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_11,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_12,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_13,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_14,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_15,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_16,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_17,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_18,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_19,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_20,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_21,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_22,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_23,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_24,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_25,
        _Additional_HS_Cell_Information_RL_Reconf_Prep__item_,
        Additional_HS_Cell_Information_RL_Reconf_Prep,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_c_ID,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_Secondary_Serving_Information_To_Modify,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_HS_DSCH_Secondary_Serving_Remove,
        ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs,
        Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_ExtIEs,
        _Additional_EDCH_Cell_Information_RL_Reconf_Prep_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions,
        Additional_EDCH_Cell_Information_RL_Reconf_Prep,
        Additional_EDCH_Cell_Information_RL_Reconf_Prep_ExtIEs,
        _UL_DPCH_Information_RL_ReconfPrepFDD_ul_ScramblingCode,
        _UL_DPCH_Information_RL_ReconfPrepFDD_ul_SIR_Target,
        _UL_DPCH_Information_RL_ReconfPrepFDD_minUL_ChannelisationCodeLength,
        _UL_DPCH_Information_RL_ReconfPrepFDD_maxNrOfUL_DPDCHs,
        _UL_DPCH_Information_RL_ReconfPrepFDD_ul_PunctureLimit,
        _UL_DPCH_Information_RL_ReconfPrepFDD_tFCS,
        _UL_DPCH_Information_RL_ReconfPrepFDD_ul_DPCCH_SlotFormat,
        _UL_DPCH_Information_RL_ReconfPrepFDD_diversityMode,
        _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_sSDT_CellIDLength,
        _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_s_FieldLength,
        ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        _____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_,
        _UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions,
        UL_DPCH_Information_RL_ReconfPrepFDD,
        UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs,
        _UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0,
        _DL_DPCH_Information_RL_ReconfPrepFDD_tFCS,
        _DL_DPCH_Information_RL_ReconfPrepFDD_dl_DPCH_SlotFormat,
        _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_SignallingMode,
        _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_Presence,
        _DL_DPCH_Information_RL_ReconfPrepFDD_multiplexingPosition,
        _DL_DPCH_Information_RL_ReconfPrepFDD_not_Used_pDSCH_CodeMapping,
        _DL_DPCH_Information_RL_ReconfPrepFDD_not_Used_pDSCH_RL_ID,
        _DL_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease,
        ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        _____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_,
        _DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions,
        DL_DPCH_Information_RL_ReconfPrepFDD,
        DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs,
        _DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0,
        _DL_DPCH_Power_Information_RL_ReconfPrepFDD_powerOffsetInformation,
        _DL_DPCH_Power_Information_RL_ReconfPrepFDD_fdd_TPC_DownlinkStepSize,
        _DL_DPCH_Power_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus,
        ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item_,
        _DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions,
        DL_DPCH_Power_Information_RL_ReconfPrepFDD,
        DL_DPCH_Power_Information_RL_ReconfPrepFDD_ExtIEs,
        _PowerOffsetInformation_RL_ReconfPrepFDD_pO1_ForTFCI_Bits,
        _PowerOffsetInformation_RL_ReconfPrepFDD_pO2_ForTPC_Bits,
        _PowerOffsetInformation_RL_ReconfPrepFDD_pO3_ForPilotBits,
        ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab,
        ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab,
        ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item_,
        _PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions,
        PowerOffsetInformation_RL_ReconfPrepFDD,
        PowerOffsetInformation_RL_ReconfPrepFDD_ExtIEs,
        _DCH_DeleteList_RL_ReconfPrepFDD__item_,
        DCH_DeleteList_RL_ReconfPrepFDD,
        _DCH_DeleteItem_RL_ReconfPrepFDD_dCH_ID,
        ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab,
        ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab,
        ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item_,
        _DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions,
        DCH_DeleteItem_RL_ReconfPrepFDD,
        DCH_DeleteItem_RL_ReconfPrepFDD_ExtIEs,
        ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab,
        ____RL_InformationList_RL_ReconfPrepFDD__item__id_tab_val_Value_0,
        __RL_InformationList_RL_ReconfPrepFDD__item__id,
        __RL_InformationList_RL_ReconfPrepFDD__item__criticality,
        __RL_InformationList_RL_ReconfPrepFDD__item__value,
        _RL_InformationList_RL_ReconfPrepFDD__item_,
        RL_InformationList_RL_ReconfPrepFDD,
        RL_InformationItemIE_RL_ReconfPrepFDD,
        _RL_InformationItemIE_RL_ReconfPrepFDD_val_Value_0,
        _RL_InformationItem_RL_ReconfPrepFDD_rL_ID,
        _RL_InformationItem_RL_ReconfPrepFDD_dl_CodeInformation,
        _RL_InformationItem_RL_ReconfPrepFDD_maxDL_Power,
        _RL_InformationItem_RL_ReconfPrepFDD_minDL_Power,
        _RL_InformationItem_RL_ReconfPrepFDD_not_Used_sSDT_Indication,
        _RL_InformationItem_RL_ReconfPrepFDD_not_Used_sSDT_Cell_Identity,
        _RL_InformationItem_RL_ReconfPrepFDD_transmitDiversityIndicator,
        ____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_9,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_10,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_11,
        _____RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_12,
        ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ___RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions__item_,
        _RL_InformationItem_RL_ReconfPrepFDD_iE_Extensions,
        RL_InformationItem_RL_ReconfPrepFDD,
        RL_InformationItem_RL_ReconfPrepFDD_ExtIEs,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_0,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_1,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_2,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_3,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_4,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_5,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_6,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_7,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_8,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_9,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_10,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_11,
        _RL_InformationItem_RL_ReconfPrepFDD_ExtIEs_val_Extension_12,
        _E_DPCH_Information_RL_ReconfPrepFDD_maxSet_E_DPDCHs,
        _E_DPCH_Information_RL_ReconfPrepFDD_ul_PunctureLimit,
        _E_DPCH_Information_RL_ReconfPrepFDD_e_TFCS_Information,
        _E_DPCH_Information_RL_ReconfPrepFDD_e_TTI,
        _E_DPCH_Information_RL_ReconfPrepFDD_e_DPCCH_PO,
        _E_DPCH_Information_RL_ReconfPrepFDD_e_RGCH_2_IndexStepThreshold,
        _E_DPCH_Information_RL_ReconfPrepFDD_e_RGCH_3_IndexStepThreshold,
        _E_DPCH_Information_RL_ReconfPrepFDD_hARQ_Info_for_E_DCH,
        _E_DPCH_Information_RL_ReconfPrepFDD_hSDSCH_Configured_Indicator,
        ____E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        _____E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ___E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_,
        _E_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions,
        E_DPCH_Information_RL_ReconfPrepFDD,
        E_DPCH_Information_RL_ReconfPrepFDD_ExtIEs,
        _E_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0,
        _F_DPCH_Information_RL_ReconfPrepFDD_powerOffsetInformation,
        _F_DPCH_Information_RL_ReconfPrepFDD_fdd_TPC_DownlinkStepSize,
        _F_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease,
        _F_DPCH_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus,
        ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab,
        ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab,
        ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_,
        _F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions,
        F_DPCH_Information_RL_ReconfPrepFDD,
        F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs,
        _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_pO2_ForTPC_Bits,
        ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab,
        ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab,
        ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item_,
        _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions,
        PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD,
        PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_ExtIEs,
        ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_6,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_7,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_8,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_9,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_10,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_11,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_12,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_13,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_14,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_15,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_16,
        ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value,
        __RadioLinkReconfigurationPrepareTDD_protocolIEs__item_,
        _RadioLinkReconfigurationPrepareTDD_protocolIEs,
        ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_19,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_20,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_21,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_22,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_23,
        ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationPrepareTDD_protocolExtensions__item_,
        _RadioLinkReconfigurationPrepareTDD_protocolExtensions,
        RadioLinkReconfigurationPrepareTDD,
        RadioLinkReconfigurationPrepareTDD_IEs,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_0,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_1,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_2,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_3,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_4,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_5,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_6,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_7,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_8,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_9,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_10,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_11,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_12,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_13,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_14,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_15,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_16,
        RadioLinkReconfigurationPrepareTDD_Extensions,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_5,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_6,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_7,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_8,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_9,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_10,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_11,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_12,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_13,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_14,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_15,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_16,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_17,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_18,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_19,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_20,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_21,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_22,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_23,
        _UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_,
        UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_ID,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCS,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCI_Coding,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_punctureLimit,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ul_DPCH_InformationList,
        ____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions,
        UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD,
        UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4,
        _UL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5,
        __UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab,
        ___UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab_val_Value_0,
        _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_id,
        _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality,
        _UL_DPCH_InformationAddList_RL_ReconfPrepTDD_value,
        UL_DPCH_InformationAddList_RL_ReconfPrepTDD,
        UL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD,
        _UL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD_val_Value_0,
        _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionPeriod,
        _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionLength,
        _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_uL_Timeslot_Information,
        ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions,
        UL_DPCH_InformationAddItem_RL_ReconfPrepTDD,
        UL_DPCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs,
        _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod,
        _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionLength,
        _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_uL_Timeslot_InformationLCR,
        ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions,
        UL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD,
        UL_DPCH_LCR_InformationAddItem_RL_ReconfPrepTDD_ExtIEs,
        _MultipleRL_UL_DPCH_InformationAddList_RL_ReconfPrepTDD__item_,
        MultipleRL_UL_DPCH_InformationAddList_RL_ReconfPrepTDD,
        _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ul_DPCH_InformationList,
        _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ul_DPCH_InformationListLCR,
        _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ul_sir_target,
        _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_tDD_TPC_UplinkStepSize_LCR,
        _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_rL_ID,
        ____MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item_,
        _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions,
        MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD,
        MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs,
        _MultipleRL_UL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod,
        _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionLength,
        _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_uL_Timeslot_Information768,
        ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions,
        UL_DPCH_768_InformationAddList_RL_ReconfPrepTDD,
        UL_DPCH_768_InformationAddItem_RL_ReconfPrepTDD_ExtIEs,
        _UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_,
        UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_ID,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCS,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCI_Coding,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_punctureLimit,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ul_DPCH_InformationAddList,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ul_DPCH_InformationModifyList,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ul_DPCH_InformationDeleteList,
        ____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD,
        UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5,
        __UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab,
        ___UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab_val_Value_0,
        _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id,
        _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality,
        _UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value,
        UL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD,
        UL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD,
        _UL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD_val_Value_0,
        _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionPeriod,
        _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionLength,
        _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_uL_Timeslot_Information,
        ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions,
        UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD,
        UL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs,
        __UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab,
        ___UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab_val_Value_0,
        _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id,
        _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality,
        _UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value,
        UL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD,
        UL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD,
        _UL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD_val_Value_0,
        _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionPeriod,
        _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionLength,
        _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD,
        ____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _UL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _UL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD__item_,
        UL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD,
        _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot,
        _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType,
        _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence,
        _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD,
        ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        UL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD__item_,
        UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD,
        _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID,
        _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCode,
        ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _UL_TimeslotLCR_InformationModify_ModifyList_RL_ReconfPrepTDD__item_,
        UL_TimeslotLCR_InformationModify_ModifyList_RL_ReconfPrepTDD,
        _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlotLCR,
        _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftLCR,
        _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence,
        _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Code_InformationModify_ModifyList_RL_ReconfPrepTDDLCR,
        ____UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _UL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDDLCR__item_,
        UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDDLCR,
        _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_dPCH_ID,
        _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_tdd_ChannelisationCodeLCR,
        ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id_tab,
        _____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__id,
        ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__criticality,
        ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item__extensionValue,
        __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions__item_,
        _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_iE_Extensions,
        UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR,
        UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_ExtIEs,
        _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDDLCR_ExtIEs_val_Extension_0,
        _UL_Timeslot768_InformationModify_ModifyList_RL_ReconfPrepTDD__item_,
        UL_Timeslot768_InformationModify_ModifyList_RL_ReconfPrepTDD,
        _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot,
        _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType768,
        _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence,
        _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_uL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD768,
        ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        UL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD768__item_,
        UL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD768,
        _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_dPCH_ID,
        _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_tdd_ChannelisationCode768,
        ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__id_tab,
        ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__id,
        ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__criticality_tab,
        ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__criticality,
        ____UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__extensionValue_tab,
        ___UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item__extensionValue,
        __UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions__item_,
        _UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_iE_Extensions,
        UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768,
        UL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD768_ExtIEs,
        __UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab,
        ___UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab_val_Value_0,
        _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id,
        _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality,
        _UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value,
        UL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD,
        UL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD,
        _UL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD_val_Value_0,
        _UL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD__item_,
        UL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD,
        _UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_dPCH_ID,
        ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions,
        UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD,
        UL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_ExtIEs,
        _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod,
        _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength,
        _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_uL_Timeslot_InformationLCR,
        ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions,
        UL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD,
        UL_DPCH_LCR_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs,
        _MultipleRL_UL_DPCH_InformationModifyList_RL_ReconfPrepTDD__item_,
        MultipleRL_UL_DPCH_InformationModifyList_RL_ReconfPrepTDD,
        _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationAddList,
        _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationModifyList,
        _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationDeleteList,
        _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_DPCH_InformationAddListLCR,
        _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ul_sir_target,
        _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_tDD_TPC_UplinkStepSize_LCR,
        _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_rL_ID,
        ____MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item_,
        _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions,
        MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD,
        MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs,
        _MultipleRL_UL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod,
        _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength,
        _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_uL_Timeslot_Information768,
        ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions,
        UL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD,
        UL_DPCH_768_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs,
        _UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_,
        UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD,
        _UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_cCTrCH_ID,
        ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions,
        UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD,
        UL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_,
        DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCS,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCI_Coding,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_punctureLimit,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_TPCList,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_dl_DPCH_InformationList,
        ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_7,
        ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD,
        DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_6,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_7,
        _CCTrCH_TPCAddList_RL_ReconfPrepTDD__item_,
        CCTrCH_TPCAddList_RL_ReconfPrepTDD,
        _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_cCTrCH_ID,
        ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions,
        CCTrCH_TPCAddItem_RL_ReconfPrepTDD,
        CCTrCH_TPCAddItem_RL_ReconfPrepTDD_ExtIEs,
        __DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab,
        ___DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_id,
        _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_criticality,
        _DL_DPCH_InformationAddList_RL_ReconfPrepTDD_value,
        DL_DPCH_InformationAddList_RL_ReconfPrepTDD,
        DL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD,
        _DL_DPCH_InformationAddListIEs_RL_ReconfPrepTDD_val_Value_0,
        _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionPeriod,
        _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_repetitionLength,
        _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_dL_Timeslot_Information,
        ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_DPCH_InformationAddItem_RL_ReconfPrepTDD,
        DL_DPCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod,
        _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_repetitionLength,
        _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_dL_Timeslot_InformationLCR,
        ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD_iE_Extensions,
        DL_DPCH_LCR_InformationAddList_RL_ReconfPrepTDD,
        DL_DPCH_LCR_InformationAddItem_RL_ReconfPrepTDD_ExtIEs,
        _MultipleRL_DL_DPCH_InformationAddList_RL_ReconfPrepTDD__item_,
        MultipleRL_DL_DPCH_InformationAddList_RL_ReconfPrepTDD,
        _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_dl_DPCH_InformationList,
        _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_dl_DPCH_InformationListLCR,
        _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_cCTrCH_Initial_DL_Power,
        _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_tDD_TPC_DownlinkStepSize,
        _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_cCTrCH_Maximum_DL_Power_InformationAdd_RL_ReconfPrepTDD,
        _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_cCTrCH_Minimum_DL_Power_InformationAdd_RL_ReconfPrepTDD,
        _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_rL_ID,
        ____MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions__item_,
        _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_iE_Extensions,
        MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD,
        MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs,
        _MultipleRL_DL_DPCH_InformationAddListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionPeriod,
        _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_repetitionLength,
        _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_dL_Timeslot_Information768,
        ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD_iE_Extensions,
        DL_DPCH_768_InformationAddList_RL_ReconfPrepTDD,
        DL_DPCH_768_InformationAddItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_,
        DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCS,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCI_Coding,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_punctureLimit,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_TPCList,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_dl_DPCH_InformationAddList,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_dl_DPCH_InformationModifyList,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_dl_DPCH_InformationDeleteList,
        ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_6,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD,
        DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_4,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_5,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_6,
        _CCTrCH_TPCModifyList_RL_ReconfPrepTDD__item_,
        CCTrCH_TPCModifyList_RL_ReconfPrepTDD,
        _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_cCTrCH_ID,
        ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        CCTrCH_TPCModifyItem_RL_ReconfPrepTDD,
        CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_ExtIEs,
        __DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab,
        ___DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_id,
        _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_criticality,
        _DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD_value,
        DL_DPCH_InformationModify_AddList_RL_ReconfPrepTDD,
        DL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD,
        _DL_DPCH_InformationModify_AddListIEs_RL_ReconfPrepTDD_val_Value_0,
        _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionPeriod,
        _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_repetitionLength,
        _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_dL_Timeslot_Information,
        ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD,
        DL_DPCH_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs,
        __DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab,
        ___DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_id,
        _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_criticality,
        _DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD_value,
        DL_DPCH_InformationModify_ModifyList_RL_ReconfPrepTDD,
        DL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD,
        _DL_DPCH_InformationModify_ModifyListIEs_RL_ReconfPrepTDD_val_Value_0,
        _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionPeriod,
        _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_repetitionLength,
        _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Timeslot_InformationAddModify_ModifyList_RL_ReconfPrepTDD,
        ____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _DL_DPCH_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _DL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD__item_,
        DL_Timeslot_InformationModify_ModifyList_RL_ReconfPrepTDD,
        _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot,
        _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType,
        _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence,
        _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD,
        ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        DL_Timeslot_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD__item_,
        DL_Code_InformationModify_ModifyList_RL_ReconfPrepTDD,
        _DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID,
        _DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCode,
        ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        DL_Code_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD__item_,
        DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD,
        _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlotLCR,
        _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftLCR,
        _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence,
        _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Code_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD,
        ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _DL_Code_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD__item_,
        DL_Code_LCR_InformationModify_ModifyList_RL_ReconfPrepTDD,
        _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID,
        _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCodeLCR,
        ____DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_Code_LCR_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _DL_Timeslot_768_InformationModify_ModifyList_RL_ReconfPrepTDD__item_,
        DL_Timeslot_768_InformationModify_ModifyList_RL_ReconfPrepTDD,
        _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_timeSlot,
        _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_midambleShiftAndBurstType,
        _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_tFCI_Presence,
        _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_dL_Code_768_InformationModify_ModifyList_RL_ReconfPrepTDD,
        ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        DL_Timeslot_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_Code_768_InformationModify_ModifyList_RL_ReconfPrepTDD__item_,
        DL_Code_768_InformationModify_ModifyList_RL_ReconfPrepTDD,
        _DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_dPCH_ID768,
        _DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_tdd_ChannelisationCode768,
        ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD,
        DL_Code_768_InformationModify_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        __DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab,
        ___DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_id,
        _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_criticality,
        _DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD_value,
        DL_DPCH_InformationModify_DeleteList_RL_ReconfPrepTDD,
        DL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD,
        _DL_DPCH_InformationModify_DeleteListIEs_RL_ReconfPrepTDD_val_Value_0,
        _DL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD__item_,
        DL_DPCH_InformationModify_DeleteListIE_RL_ReconfPrepTDD,
        _DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_dPCH_ID,
        ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD,
        DL_DPCH_InformationModify_DeleteItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod,
        _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength,
        _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_dL_Timeslot_InformationLCR,
        ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions,
        DL_DPCH_LCR_InformationModify_AddList_RL_ReconfPrepTDD,
        DL_DPCH_LCR_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs,
        _MultipleRL_DL_DPCH_InformationModifyList_RL_ReconfPrepTDD__item_,
        MultipleRL_DL_DPCH_InformationModifyList_RL_ReconfPrepTDD,
        _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationAddList,
        _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationModifyList,
        _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationDeleteList,
        _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_dl_DPCH_InformationAddListLCR,
        _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_tDD_TPC_DownlinkStepSize_InformationModify_RL_ReconfPrepTDD,
        _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_cCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfPrepTDD,
        _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_cCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfPrepTDD,
        _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_rL_ID,
        ____MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions__item_,
        _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_iE_Extensions,
        MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD,
        MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs,
        _MultipleRL_DL_DPCH_InformationModifyListIE_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionPeriod,
        _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_repetitionLength,
        _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_tdd_DPCHOffset,
        _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_dL_Timeslot_Information768,
        ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD_iE_Extensions,
        DL_DPCH_768_InformationModify_AddList_RL_ReconfPrepTDD,
        DL_DPCH_768_InformationModify_AddItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_,
        DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD,
        _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_cCTrCH_ID,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD,
        DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_ExtIEs,
        _DCH_DeleteList_RL_ReconfPrepTDD__item_,
        DCH_DeleteList_RL_ReconfPrepTDD,
        _DCH_DeleteItem_RL_ReconfPrepTDD_dCH_ID,
        ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions,
        DCH_DeleteItem_RL_ReconfPrepTDD,
        DCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs,
        _DSCH_Information_ModifyList_RL_ReconfPrepTDD__item_,
        DSCH_Information_ModifyList_RL_ReconfPrepTDD,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_dSCH_ID,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_cCTrCH_ID,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_transportFormatSet,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_frameHandlingPriority,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_toAWS,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_toAWE,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator,
        ____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2,
        ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        DSCH_Information_ModifyItem_RL_ReconfPrepTDD,
        DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _DSCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2,
        _DSCH_Information_DeleteList_RL_ReconfPrepTDD__item_,
        DSCH_Information_DeleteList_RL_ReconfPrepTDD,
        _DSCH_Information_DeleteItem_RL_ReconfPrepTDD_dSCH_ID,
        ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DSCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions,
        DSCH_Information_DeleteItem_RL_ReconfPrepTDD,
        DSCH_Information_DeleteItem_RL_ReconfPrepTDD_ExtIEs,
        _USCH_Information_ModifyList_RL_ReconfPrepTDD__item_,
        USCH_Information_ModifyList_RL_ReconfPrepTDD,
        _USCH_Information_ModifyItem_RL_ReconfPrepTDD_uSCH_ID,
        _USCH_Information_ModifyItem_RL_ReconfPrepTDD_transportFormatSet,
        _USCH_Information_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority,
        _USCH_Information_ModifyItem_RL_ReconfPrepTDD_cCTrCH_ID,
        _USCH_Information_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator,
        ____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2,
        ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _USCH_Information_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        USCH_Information_ModifyItem_RL_ReconfPrepTDD,
        USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _USCH_Information_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2,
        _USCH_Information_DeleteList_RL_ReconfPrepTDD__item_,
        USCH_Information_DeleteList_RL_ReconfPrepTDD,
        _USCH_Information_DeleteItem_RL_ReconfPrepTDD_uSCH_ID,
        ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _USCH_Information_DeleteItem_RL_ReconfPrepTDD_iE_Extensions,
        USCH_Information_DeleteItem_RL_ReconfPrepTDD,
        USCH_Information_DeleteItem_RL_ReconfPrepTDD_ExtIEs,
        _MultipleRL_Information_RL_ReconfPrepTDD__item_,
        MultipleRL_Information_RL_ReconfPrepTDD,
        _RL_Information_RL_ReconfPrepTDD_rL_ID,
        _RL_Information_RL_ReconfPrepTDD_maxDL_Power,
        _RL_Information_RL_ReconfPrepTDD_minDL_Power,
        ____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_4,
        ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___RL_Information_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __RL_Information_RL_ReconfPrepTDD_iE_Extensions__item_,
        _RL_Information_RL_ReconfPrepTDD_iE_Extensions,
        RL_Information_RL_ReconfPrepTDD,
        RL_Information_RL_ReconfPrepTDD_ExtIEs,
        _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_2,
        _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_3,
        _RL_Information_RL_ReconfPrepTDD_ExtIEs_val_Extension_4,
        ____RadioLinkReconfigurationReady_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationReady_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationReady_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationReady_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkReconfigurationReady_protocolIEs__item__id,
        ___RadioLinkReconfigurationReady_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationReady_protocolIEs__item__value,
        __RadioLinkReconfigurationReady_protocolIEs__item_,
        _RadioLinkReconfigurationReady_protocolIEs,
        ____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkReconfigurationReady_protocolExtensions__item__id_tab_val_Extension_16,
        ___RadioLinkReconfigurationReady_protocolExtensions__item__id,
        ___RadioLinkReconfigurationReady_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationReady_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationReady_protocolExtensions__item_,
        _RadioLinkReconfigurationReady_protocolExtensions,
        RadioLinkReconfigurationReady,
        RadioLinkReconfigurationReady_IEs,
        _RadioLinkReconfigurationReady_IEs_val_Value_0,
        _RadioLinkReconfigurationReady_IEs_val_Value_1,
        _RadioLinkReconfigurationReady_IEs_val_Value_2,
        RadioLinkReconfigurationReady_Extensions,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_0,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_1,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_2,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_3,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_4,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_5,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_6,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_7,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_8,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_9,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_10,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_11,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_12,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_13,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_14,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_15,
        _RadioLinkReconfigurationReady_Extensions_val_Extension_16,
        ___RL_InformationResponseList_RL_ReconfReady__item__id_tab,
        ____RL_InformationResponseList_RL_ReconfReady__item__id_tab_val_Value_0,
        __RL_InformationResponseList_RL_ReconfReady__item__id,
        __RL_InformationResponseList_RL_ReconfReady__item__criticality,
        __RL_InformationResponseList_RL_ReconfReady__item__value,
        _RL_InformationResponseList_RL_ReconfReady__item_,
        RL_InformationResponseList_RL_ReconfReady,
        RL_InformationResponseItemIE_RL_ReconfReady,
        _RL_InformationResponseItemIE_RL_ReconfReady_val_Value_0,
        _RL_InformationResponseItem_RL_ReconfReady_rL_ID,
        _RL_InformationResponseItem_RL_ReconfReady_dCH_InformationResponseList_RL_ReconfReady,
        _RL_InformationResponseItem_RL_ReconfReady_dSCH_InformationResponseList_RL_ReconfReady,
        _RL_InformationResponseItem_RL_ReconfReady_uSCH_InformationResponseList_RL_ReconfReady,
        _RL_InformationResponseItem_RL_ReconfReady_not_Used_tFCI2_BearerInformationResponse,
        ____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab,
        _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id_tab_val_Extension_5,
        ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__id,
        ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__criticality,
        ___RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item__extensionValue,
        __RL_InformationResponseItem_RL_ReconfReady_iE_Extensions__item_,
        _RL_InformationResponseItem_RL_ReconfReady_iE_Extensions,
        RL_InformationResponseItem_RL_ReconfReady,
        RL_InformationResponseItem_RL_ReconfReady_ExtIEs,
        _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_0,
        _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_1,
        _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_2,
        _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_3,
        _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_4,
        _RL_InformationResponseItem_RL_ReconfReady_ExtIEs_val_Extension_5,
        __DCH_InformationResponseList_RL_ReconfReady_id_tab,
        ___DCH_InformationResponseList_RL_ReconfReady_id_tab_val_Value_0,
        _DCH_InformationResponseList_RL_ReconfReady_id,
        _DCH_InformationResponseList_RL_ReconfReady_criticality,
        _DCH_InformationResponseList_RL_ReconfReady_value,
        DCH_InformationResponseList_RL_ReconfReady,
        DCH_InformationResponseListIEs_RL_ReconfReady,
        _DCH_InformationResponseListIEs_RL_ReconfReady_val_Value_0,
        __DSCH_InformationResponseList_RL_ReconfReady_id_tab,
        ___DSCH_InformationResponseList_RL_ReconfReady_id_tab_val_Value_0,
        _DSCH_InformationResponseList_RL_ReconfReady_id,
        _DSCH_InformationResponseList_RL_ReconfReady_criticality,
        _DSCH_InformationResponseList_RL_ReconfReady_value,
        DSCH_InformationResponseList_RL_ReconfReady,
        DSCH_InformationResponseListIEs_RL_ReconfReady,
        _DSCH_InformationResponseListIEs_RL_ReconfReady_val_Value_0,
        __USCH_InformationResponseList_RL_ReconfReady_id_tab,
        ___USCH_InformationResponseList_RL_ReconfReady_id_tab_val_Value_0,
        _USCH_InformationResponseList_RL_ReconfReady_id,
        _USCH_InformationResponseList_RL_ReconfReady_criticality,
        _USCH_InformationResponseList_RL_ReconfReady_value,
        USCH_InformationResponseList_RL_ReconfReady,
        USCH_InformationResponseListIEs_RL_ReconfReady,
        _USCH_InformationResponseListIEs_RL_ReconfReady_val_Value_0,
        ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkReconfigurationFailure_protocolIEs__item__id,
        ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationFailure_protocolIEs__item__value,
        __RadioLinkReconfigurationFailure_protocolIEs__item_,
        _RadioLinkReconfigurationFailure_protocolIEs,
        ____RadioLinkReconfigurationFailure_protocolExtensions__item__id_tab,
        ___RadioLinkReconfigurationFailure_protocolExtensions__item__id,
        ____RadioLinkReconfigurationFailure_protocolExtensions__item__criticality_tab,
        ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality,
        ____RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationFailure_protocolExtensions__item_,
        _RadioLinkReconfigurationFailure_protocolExtensions,
        RadioLinkReconfigurationFailure,
        RadioLinkReconfigurationFailure_IEs,
        _RadioLinkReconfigurationFailure_IEs_val_Value_0,
        _RadioLinkReconfigurationFailure_IEs_val_Value_1,
        _RadioLinkReconfigurationFailure_IEs_val_Value_2,
        RadioLinkReconfigurationFailure_Extensions,
        _CauseLevel_RL_ReconfFailure_generalCause,
        _CauseLevel_RL_ReconfFailure_rLSpecificCause,
        CauseLevel_RL_ReconfFailure,
        _GeneralCauseList_RL_ReconfFailure_cause,
        ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab,
        ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id,
        ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality,
        ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue,
        __GeneralCauseList_RL_ReconfFailure_iE_Extensions__item_,
        _GeneralCauseList_RL_ReconfFailure_iE_Extensions,
        GeneralCauseList_RL_ReconfFailure,
        GeneralCauseItem_RL_ReconfFailure_ExtIEs,
        _RLSpecificCauseList_RL_ReconfFailure_rL_ReconfigurationFailureList_RL_ReconfFailure,
        ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab,
        ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id,
        ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab,
        ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality,
        ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab,
        ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue,
        __RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item_,
        _RLSpecificCauseList_RL_ReconfFailure_iE_Extensions,
        RLSpecificCauseList_RL_ReconfFailure,
        RLSpecificCauseItem_RL_ReconfFailure_ExtIEs,
        ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab,
        ____RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab_val_Value_0,
        __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id,
        __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality,
        __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value,
        _RL_ReconfigurationFailureList_RL_ReconfFailure__item_,
        RL_ReconfigurationFailureList_RL_ReconfFailure,
        RL_ReconfigurationFailureItemIE_RL_ReconfFailure,
        _RL_ReconfigurationFailureItemIE_RL_ReconfFailure_val_Value_0,
        _RL_ReconfigurationFailureItem_RL_ReconfFailure_rL_ID,
        _RL_ReconfigurationFailureItem_RL_ReconfFailure_cause,
        ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__id_tab,
        ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__id,
        ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__criticality_tab,
        ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__criticality,
        ____RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab,
        ___RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item__extensionValue,
        __RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions__item_,
        _RL_ReconfigurationFailureItem_RL_ReconfFailure_iE_Extensions,
        RL_ReconfigurationFailureItem_RL_ReconfFailure,
        RL_ReconfigurationFailureItem_RL_ReconfFailure_ExtIEs,
        ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkReconfigurationCommit_protocolIEs__item__id,
        ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationCommit_protocolIEs__item__value,
        __RadioLinkReconfigurationCommit_protocolIEs__item_,
        _RadioLinkReconfigurationCommit_protocolIEs,
        ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_1,
        ___RadioLinkReconfigurationCommit_protocolExtensions__item__id,
        ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationCommit_protocolExtensions__item_,
        _RadioLinkReconfigurationCommit_protocolExtensions,
        RadioLinkReconfigurationCommit,
        RadioLinkReconfigurationCommit_IEs,
        _RadioLinkReconfigurationCommit_IEs_val_Value_0,
        _RadioLinkReconfigurationCommit_IEs_val_Value_1,
        _RadioLinkReconfigurationCommit_IEs_val_Value_2,
        RadioLinkReconfigurationCommit_Extensions,
        _RadioLinkReconfigurationCommit_Extensions_val_Extension_0,
        _RadioLinkReconfigurationCommit_Extensions_val_Extension_1,
        ____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab_val_Value_0,
        ___RadioLinkReconfigurationCancel_protocolIEs__item__id,
        ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationCancel_protocolIEs__item__value,
        __RadioLinkReconfigurationCancel_protocolIEs__item_,
        _RadioLinkReconfigurationCancel_protocolIEs,
        ____RadioLinkReconfigurationCancel_protocolExtensions__item__id_tab,
        ___RadioLinkReconfigurationCancel_protocolExtensions__item__id,
        ____RadioLinkReconfigurationCancel_protocolExtensions__item__criticality_tab,
        ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality,
        ____RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationCancel_protocolExtensions__item_,
        _RadioLinkReconfigurationCancel_protocolExtensions,
        RadioLinkReconfigurationCancel,
        RadioLinkReconfigurationCancel_IEs,
        _RadioLinkReconfigurationCancel_IEs_val_Value_0,
        RadioLinkReconfigurationCancel_Extensions,
        ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_7,
        ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value,
        __RadioLinkReconfigurationRequestFDD_protocolIEs__item_,
        _RadioLinkReconfigurationRequestFDD_protocolIEs,
        ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_19,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_20,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_21,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_22,
        ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationRequestFDD_protocolExtensions__item_,
        _RadioLinkReconfigurationRequestFDD_protocolExtensions,
        RadioLinkReconfigurationRequestFDD,
        RadioLinkReconfigurationRequestFDD_IEs,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_0,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_1,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_2,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_3,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_4,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_5,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_6,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_7,
        RadioLinkReconfigurationRequestFDD_Extensions,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_5,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_6,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_7,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_8,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_9,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_10,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_11,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_12,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_13,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_14,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_15,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_16,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_17,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_18,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_19,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_20,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_21,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_22,
        _Additional_HS_Cell_Information_RL_Reconf_Req__item_,
        Additional_HS_Cell_Information_RL_Reconf_Req,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_c_ID,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_Secondary_Serving_Remove,
        ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs,
        Additional_HS_Cell_Information_RL_Reconf_Req_ExtIEs,
        _Additional_EDCH_Cell_Information_RL_Reconf_Req_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions,
        Additional_EDCH_Cell_Information_RL_Reconf_Req,
        Additional_EDCH_Cell_Information_RL_Reconf_Req_ExtIEs,
        _UL_DPCH_Information_RL_ReconfRqstFDD_ul_TFCS,
        ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab,
        _____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id,
        ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality,
        ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_,
        _UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions,
        UL_DPCH_Information_RL_ReconfRqstFDD,
        UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs,
        _UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs_val_Extension_0,
        _DL_DPCH_Information_RL_ReconfRqstFDD_dl_TFCS,
        _DL_DPCH_Information_RL_ReconfRqstFDD_tFCI_SignallingMode,
        _DL_DPCH_Information_RL_ReconfRqstFDD_limitedPowerIncrease,
        ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id,
        ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_,
        _DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions,
        DL_DPCH_Information_RL_ReconfRqstFDD,
        DL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs,
        _DCH_DeleteList_RL_ReconfRqstFDD__item_,
        DCH_DeleteList_RL_ReconfRqstFDD,
        _DCH_DeleteItem_RL_ReconfRqstFDD_dCH_ID,
        ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id,
        ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item_,
        _DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions,
        DCH_DeleteItem_RL_ReconfRqstFDD,
        DCH_DeleteItem_RL_ReconfRqstFDD_ExtIEs,
        ___RL_InformationList_RL_ReconfRqstFDD__item__id_tab,
        ____RL_InformationList_RL_ReconfRqstFDD__item__id_tab_val_Value_0,
        __RL_InformationList_RL_ReconfRqstFDD__item__id,
        __RL_InformationList_RL_ReconfRqstFDD__item__criticality,
        __RL_InformationList_RL_ReconfRqstFDD__item__value,
        _RL_InformationList_RL_ReconfRqstFDD__item_,
        RL_InformationList_RL_ReconfRqstFDD,
        RL_InformationItemIE_RL_ReconfRqstFDD,
        _RL_InformationItemIE_RL_ReconfRqstFDD_val_Value_0,
        _RL_InformationItem_RL_ReconfRqstFDD_rL_ID,
        _RL_InformationItem_RL_ReconfRqstFDD_maxDL_Power,
        _RL_InformationItem_RL_ReconfRqstFDD_minDL_Power,
        _RL_InformationItem_RL_ReconfRqstFDD_dl_CodeInformation,
        ____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab,
        _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_9,
        ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__id,
        ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality,
        ___RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions__item_,
        _RL_InformationItem_RL_ReconfRqstFDD_iE_Extensions,
        RL_InformationItem_RL_ReconfRqstFDD,
        RL_InformationItem_RL_ReconfRqstFDD_ExtIEs,
        _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_0,
        _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_1,
        _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_2,
        _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_3,
        _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_4,
        _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_5,
        _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_6,
        _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_7,
        _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_8,
        _RL_InformationItem_RL_ReconfRqstFDD_ExtIEs_val_Extension_9,
        _E_DPCH_Information_RL_ReconfRqstFDD_maxSet_E_DPDCHs,
        _E_DPCH_Information_RL_ReconfRqstFDD_ul_PunctureLimit,
        _E_DPCH_Information_RL_ReconfRqstFDD_e_TFCS_Information,
        _E_DPCH_Information_RL_ReconfRqstFDD_e_TTI,
        _E_DPCH_Information_RL_ReconfRqstFDD_e_DPCCH_PO,
        _E_DPCH_Information_RL_ReconfRqstFDD_e_RGCH_2_IndexStepThreshold,
        _E_DPCH_Information_RL_ReconfRqstFDD_e_RGCH_3_IndexStepThreshold,
        _E_DPCH_Information_RL_ReconfRqstFDD_hARQ_Info_for_E_DCH,
        _E_DPCH_Information_RL_ReconfRqstFDD_hSDSCH_Configured_Indicator,
        ____E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab,
        _____E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id,
        ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality,
        ___E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_,
        _E_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions,
        E_DPCH_Information_RL_ReconfRqstFDD,
        E_DPCH_Information_RL_ReconfRqstFDD_ExtIEs,
        _E_DPCH_Information_RL_ReconfRqstFDD_ExtIEs_val_Extension_0,
        ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_8,
        ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value,
        __RadioLinkReconfigurationRequestTDD_protocolIEs__item_,
        _RadioLinkReconfigurationRequestTDD_protocolIEs,
        ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_19,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_20,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_21,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_22,
        ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationRequestTDD_protocolExtensions__item_,
        _RadioLinkReconfigurationRequestTDD_protocolExtensions,
        RadioLinkReconfigurationRequestTDD,
        RadioLinkReconfigurationRequestTDD_IEs,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_0,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_1,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_2,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_3,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_4,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_5,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_6,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_7,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_8,
        RadioLinkReconfigurationRequestTDD_Extensions,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_5,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_6,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_7,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_8,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_9,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_10,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_11,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_12,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_13,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_14,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_15,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_16,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_17,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_18,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_19,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_20,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_21,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_22,
        ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab,
        ____UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0,
        __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id,
        __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality,
        __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value,
        _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_,
        UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
        UL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD,
        _UL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD_val_Value_0,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_punctureLimit,
        ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        _____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions,
        UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD,
        UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0,
        ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab,
        ____UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0,
        __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id,
        __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality,
        __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value,
        _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_,
        UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD,
        UL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD,
        _UL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD_val_Value_0,
        _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID,
        ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions,
        UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD,
        UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs,
        ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab,
        ____DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0,
        __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id,
        __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality,
        __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value,
        _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_,
        DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
        DL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD,
        _DL_CCTrCH_InformationModifyItemIE_RL_ReconfRqstTDD_val_Value_0,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_punctureLimit,
        ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_4,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions,
        DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD,
        DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_1,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_2,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_3,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_4,
        _MultipleRL_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_,
        MultipleRL_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
        _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_dl_DPCH_LCR_InformationModifyList,
        _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_cCTrCH_Maximum_DL_Power_InformationModify_RL_ReconfRqstTDD,
        _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_cCTrCH_Minimum_DL_Power_InformationModify_RL_ReconfRqstTDD,
        _MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD_rL_ID,
        MultipleRL_DL_CCTrCH_InformationModifyListIE_RL_ReconfRqstTDD,
        _DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_dL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD,
        ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions__item_,
        _DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_iE_Extensions,
        DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD,
        DL_DPCH_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD_ExtIEs,
        _DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD__item_,
        DL_Timeslot_LCR_InformationModify_ModifyList_RL_ReconfRqstTDD,
        _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_timeSlotLCR,
        _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_maxPowerLCR,
        _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_minPowerLCR,
        ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_,
        _DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_iE_Extensions,
        DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD,
        DL_Timeslot_LCR_InformationModify_ModifyItem_RL_ReconfRqstTDD_ExtIEs,
        ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab,
        ____DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0,
        __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id,
        __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality,
        __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value,
        _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_,
        DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD,
        DL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD,
        _DL_CCTrCH_InformationDeleteItemIE_RL_ReconfRqstTDD_val_Value_0,
        _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions,
        DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD,
        DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs,
        _DCH_DeleteList_RL_ReconfRqstTDD__item_,
        DCH_DeleteList_RL_ReconfRqstTDD,
        _DCH_DeleteItem_RL_ReconfRqstTDD_dCH_ID,
        ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_,
        _DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions,
        DCH_DeleteItem_RL_ReconfRqstTDD,
        DCH_DeleteItem_RL_ReconfRqstTDD_ExtIEs,
        _Multiple_RL_Information_RL_ReconfRqstTDD__item_,
        Multiple_RL_Information_RL_ReconfRqstTDD,
        _RL_Information_RL_ReconfRqstTDD_rL_ID,
        _RL_Information_RL_ReconfRqstTDD_maxDL_Power,
        _RL_Information_RL_ReconfRqstTDD_minDL_Power,
        ____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        _____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ___RL_Information_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __RL_Information_RL_ReconfRqstTDD_iE_Extensions__item_,
        _RL_Information_RL_ReconfRqstTDD_iE_Extensions,
        RL_Information_RL_ReconfRqstTDD,
        RL_InformationItem_RL_ReconfRqstTDD_ExtIEs,
        _RL_InformationItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0,
        _RL_InformationItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_1,
        ____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkReconfigurationResponse_protocolIEs__item__id,
        ___RadioLinkReconfigurationResponse_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationResponse_protocolIEs__item__value,
        __RadioLinkReconfigurationResponse_protocolIEs__item_,
        _RadioLinkReconfigurationResponse_protocolIEs,
        ____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_15,
        ___RadioLinkReconfigurationResponse_protocolExtensions__item__id,
        ___RadioLinkReconfigurationResponse_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationResponse_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationResponse_protocolExtensions__item_,
        _RadioLinkReconfigurationResponse_protocolExtensions,
        RadioLinkReconfigurationResponse,
        RadioLinkReconfigurationResponse_IEs,
        _RadioLinkReconfigurationResponse_IEs_val_Value_0,
        _RadioLinkReconfigurationResponse_IEs_val_Value_1,
        _RadioLinkReconfigurationResponse_IEs_val_Value_2,
        RadioLinkReconfigurationResponse_Extensions,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_0,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_1,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_2,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_3,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_4,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_5,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_6,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_7,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_8,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_9,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_10,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_11,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_12,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_13,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_14,
        _RadioLinkReconfigurationResponse_Extensions_val_Extension_15,
        ___RL_InformationResponseList_RL_ReconfRsp__item__id_tab,
        ____RL_InformationResponseList_RL_ReconfRsp__item__id_tab_val_Value_0,
        __RL_InformationResponseList_RL_ReconfRsp__item__id,
        __RL_InformationResponseList_RL_ReconfRsp__item__criticality,
        __RL_InformationResponseList_RL_ReconfRsp__item__value,
        _RL_InformationResponseList_RL_ReconfRsp__item_,
        RL_InformationResponseList_RL_ReconfRsp,
        RL_InformationResponseItemIE_RL_ReconfRsp,
        _RL_InformationResponseItemIE_RL_ReconfRsp_val_Value_0,
        _RL_InformationResponseItem_RL_ReconfRsp_rL_ID,
        _RL_InformationResponseItem_RL_ReconfRsp_dCH_InformationResponseList_RL_ReconfRsp,
        ____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab,
        _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id_tab_val_Extension_5,
        ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__id,
        ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__criticality,
        ___RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item__extensionValue,
        __RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions__item_,
        _RL_InformationResponseItem_RL_ReconfRsp_iE_Extensions,
        RL_InformationResponseItem_RL_ReconfRsp,
        RL_InformationResponseItem_RL_ReconfRsp_ExtIEs,
        _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_0,
        _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_1,
        _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_2,
        _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_3,
        _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_4,
        _RL_InformationResponseItem_RL_ReconfRsp_ExtIEs_val_Extension_5,
        __DCH_InformationResponseList_RL_ReconfRsp_id_tab,
        ___DCH_InformationResponseList_RL_ReconfRsp_id_tab_val_Value_0,
        _DCH_InformationResponseList_RL_ReconfRsp_id,
        _DCH_InformationResponseList_RL_ReconfRsp_criticality,
        _DCH_InformationResponseList_RL_ReconfRsp_value,
        DCH_InformationResponseList_RL_ReconfRsp,
        DCH_InformationResponseListIEs_RL_ReconfRsp,
        _DCH_InformationResponseListIEs_RL_ReconfRsp_val_Value_0,
        ____RadioLinkDeletionRequest_protocolIEs__item__id_tab,
        _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkDeletionRequest_protocolIEs__item__id,
        ___RadioLinkDeletionRequest_protocolIEs__item__criticality,
        ___RadioLinkDeletionRequest_protocolIEs__item__value,
        __RadioLinkDeletionRequest_protocolIEs__item_,
        _RadioLinkDeletionRequest_protocolIEs,
        ____RadioLinkDeletionRequest_protocolExtensions__item__id_tab,
        ___RadioLinkDeletionRequest_protocolExtensions__item__id,
        ____RadioLinkDeletionRequest_protocolExtensions__item__criticality_tab,
        ___RadioLinkDeletionRequest_protocolExtensions__item__criticality,
        ____RadioLinkDeletionRequest_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue,
        __RadioLinkDeletionRequest_protocolExtensions__item_,
        _RadioLinkDeletionRequest_protocolExtensions,
        RadioLinkDeletionRequest,
        RadioLinkDeletionRequest_IEs,
        _RadioLinkDeletionRequest_IEs_val_Value_0,
        _RadioLinkDeletionRequest_IEs_val_Value_1,
        _RadioLinkDeletionRequest_IEs_val_Value_2,
        RadioLinkDeletionRequest_Extensions,
        ___RL_informationList_RL_DeletionRqst__item__id_tab,
        ____RL_informationList_RL_DeletionRqst__item__id_tab_val_Value_0,
        __RL_informationList_RL_DeletionRqst__item__id,
        __RL_informationList_RL_DeletionRqst__item__criticality,
        __RL_informationList_RL_DeletionRqst__item__value,
        _RL_informationList_RL_DeletionRqst__item_,
        RL_informationList_RL_DeletionRqst,
        RL_informationItemIE_RL_DeletionRqst,
        _RL_informationItemIE_RL_DeletionRqst_val_Value_0,
        _RL_informationItem_RL_DeletionRqst_rL_ID,
        ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__id_tab,
        ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__id,
        ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__criticality_tab,
        ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__criticality,
        ____RL_informationItem_RL_DeletionRqst_iE_Extensions__item__extensionValue_tab,
        ___RL_informationItem_RL_DeletionRqst_iE_Extensions__item__extensionValue,
        __RL_informationItem_RL_DeletionRqst_iE_Extensions__item_,
        _RL_informationItem_RL_DeletionRqst_iE_Extensions,
        RL_informationItem_RL_DeletionRqst,
        RL_informationItem_RL_DeletionRqst_ExtIEs,
        ____RadioLinkDeletionResponse_protocolIEs__item__id_tab,
        _____RadioLinkDeletionResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkDeletionResponse_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkDeletionResponse_protocolIEs__item__id,
        ___RadioLinkDeletionResponse_protocolIEs__item__criticality,
        ___RadioLinkDeletionResponse_protocolIEs__item__value,
        __RadioLinkDeletionResponse_protocolIEs__item_,
        _RadioLinkDeletionResponse_protocolIEs,
        ____RadioLinkDeletionResponse_protocolExtensions__item__id_tab,
        ___RadioLinkDeletionResponse_protocolExtensions__item__id,
        ____RadioLinkDeletionResponse_protocolExtensions__item__criticality_tab,
        ___RadioLinkDeletionResponse_protocolExtensions__item__criticality,
        ____RadioLinkDeletionResponse_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue,
        __RadioLinkDeletionResponse_protocolExtensions__item_,
        _RadioLinkDeletionResponse_protocolExtensions,
        RadioLinkDeletionResponse,
        RadioLinkDeletionResponse_IEs,
        _RadioLinkDeletionResponse_IEs_val_Value_0,
        _RadioLinkDeletionResponse_IEs_val_Value_1,
        RadioLinkDeletionResponse_Extensions,
        ____DL_PowerControlRequest_protocolIEs__item__id_tab,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_0,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_1,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_2,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_3,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_4,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_5,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_6,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_7,
        ___DL_PowerControlRequest_protocolIEs__item__id,
        ___DL_PowerControlRequest_protocolIEs__item__criticality,
        ___DL_PowerControlRequest_protocolIEs__item__value,
        __DL_PowerControlRequest_protocolIEs__item_,
        _DL_PowerControlRequest_protocolIEs,
        ____DL_PowerControlRequest_protocolExtensions__item__id_tab,
        ___DL_PowerControlRequest_protocolExtensions__item__id,
        ____DL_PowerControlRequest_protocolExtensions__item__criticality_tab,
        ___DL_PowerControlRequest_protocolExtensions__item__criticality,
        ____DL_PowerControlRequest_protocolExtensions__item__extensionValue_tab,
        ___DL_PowerControlRequest_protocolExtensions__item__extensionValue,
        __DL_PowerControlRequest_protocolExtensions__item_,
        _DL_PowerControlRequest_protocolExtensions,
        DL_PowerControlRequest,
        DL_PowerControlRequest_IEs,
        _DL_PowerControlRequest_IEs_val_Value_0,
        _DL_PowerControlRequest_IEs_val_Value_1,
        _DL_PowerControlRequest_IEs_val_Value_2,
        _DL_PowerControlRequest_IEs_val_Value_3,
        _DL_PowerControlRequest_IEs_val_Value_4,
        _DL_PowerControlRequest_IEs_val_Value_5,
        _DL_PowerControlRequest_IEs_val_Value_6,
        _DL_PowerControlRequest_IEs_val_Value_7,
        DL_PowerControlRequest_Extensions,
        ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab,
        ____DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab_val_Value_0,
        __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id,
        __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality,
        __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value,
        _DL_ReferencePowerInformationList_DL_PC_Rqst__item_,
        DL_ReferencePowerInformationList_DL_PC_Rqst,
        DL_ReferencePowerInformationItemIE_DL_PC_Rqst,
        _DL_ReferencePowerInformationItemIE_DL_PC_Rqst_val_Value_0,
        _DL_ReferencePowerInformationItem_DL_PC_Rqst_rL_ID,
        _DL_ReferencePowerInformationItem_DL_PC_Rqst_dl_ReferencePower,
        ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__id_tab,
        ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__id,
        ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__criticality_tab,
        ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__criticality,
        ____DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__extensionValue_tab,
        ___DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item__extensionValue,
        __DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions__item_,
        _DL_ReferencePowerInformationItem_DL_PC_Rqst_iE_Extensions,
        DL_ReferencePowerInformationItem_DL_PC_Rqst,
        DL_ReferencePowerInformationItem_DL_PC_Rqst_ExtIEs,
        ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab,
        _____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab_val_Value_0,
        _____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab_val_Value_1,
        ___DL_PowerTimeslotControlRequest_protocolIEs__item__id,
        ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality,
        ___DL_PowerTimeslotControlRequest_protocolIEs__item__value,
        __DL_PowerTimeslotControlRequest_protocolIEs__item_,
        _DL_PowerTimeslotControlRequest_protocolIEs,
        ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab,
        _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_2,
        ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id,
        ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality,
        ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue,
        __DL_PowerTimeslotControlRequest_protocolExtensions__item_,
        _DL_PowerTimeslotControlRequest_protocolExtensions,
        DL_PowerTimeslotControlRequest,
        DL_PowerTimeslotControlRequest_IEs,
        _DL_PowerTimeslotControlRequest_IEs_val_Value_0,
        _DL_PowerTimeslotControlRequest_IEs_val_Value_1,
        DL_PowerTimeslotControlRequest_Extensions,
        _DL_PowerTimeslotControlRequest_Extensions_val_Extension_0,
        _DL_PowerTimeslotControlRequest_Extensions_val_Extension_1,
        _DL_PowerTimeslotControlRequest_Extensions_val_Extension_2,
        ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7,
        ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id,
        ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality,
        ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value,
        __DedicatedMeasurementInitiationRequest_protocolIEs__item_,
        _DedicatedMeasurementInitiationRequest_protocolIEs,
        ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab,
        _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_3,
        ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id,
        ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality,
        ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementInitiationRequest_protocolExtensions__item_,
        _DedicatedMeasurementInitiationRequest_protocolExtensions,
        DedicatedMeasurementInitiationRequest,
        DedicatedMeasurementInitiationRequest_IEs,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_0,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_1,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_2,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_3,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_4,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_5,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_6,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_7,
        DedicatedMeasurementInitiationRequest_Extensions,
        _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_0,
        _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_1,
        _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_2,
        _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_3,
        _DedicatedMeasurementObjectType_DM_Rqst_rL,
        _DedicatedMeasurementObjectType_DM_Rqst_rLS,
        _DedicatedMeasurementObjectType_DM_Rqst_all_RL,
        _DedicatedMeasurementObjectType_DM_Rqst_all_RLS,
        DedicatedMeasurementObjectType_DM_Rqst,
        _RL_DM_Rqst_rL_InformationList,
        ____RL_DM_Rqst_iE_Extensions__item__id_tab,
        ___RL_DM_Rqst_iE_Extensions__item__id,
        ____RL_DM_Rqst_iE_Extensions__item__criticality_tab,
        ___RL_DM_Rqst_iE_Extensions__item__criticality,
        ____RL_DM_Rqst_iE_Extensions__item__extensionValue_tab,
        ___RL_DM_Rqst_iE_Extensions__item__extensionValue,
        __RL_DM_Rqst_iE_Extensions__item_,
        _RL_DM_Rqst_iE_Extensions,
        RL_DM_Rqst,
        RLItem_DM_Rqst_ExtIEs,
        ___RL_InformationList_DM_Rqst__item__id_tab,
        ____RL_InformationList_DM_Rqst__item__id_tab_val_Value_0,
        __RL_InformationList_DM_Rqst__item__id,
        __RL_InformationList_DM_Rqst__item__criticality,
        __RL_InformationList_DM_Rqst__item__value,
        _RL_InformationList_DM_Rqst__item_,
        RL_InformationList_DM_Rqst,
        RL_InformationItemIE_DM_Rqst,
        _RL_InformationItemIE_DM_Rqst_val_Value_0,
        _RL_InformationItem_DM_Rqst_rL_ID,
        _RL_InformationItem_DM_Rqst_dPCH_ID,
        ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab,
        _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_3,
        ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id,
        ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality,
        ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue,
        __RL_InformationItem_DM_Rqst_iE_Extensions__item_,
        _RL_InformationItem_DM_Rqst_iE_Extensions,
        RL_InformationItem_DM_Rqst,
        RL_InformationItem_DM_Rqst_ExtIEs,
        _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_0,
        _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_1,
        _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_2,
        _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_3,
        _PUSCH_Info_DM_Rqst__item_,
        PUSCH_Info_DM_Rqst,
        _HSSICH_Info_DM_Rqst__item_,
        HSSICH_Info_DM_Rqst,
        _HSSICH_InfoExt_DM_Rqst__item_,
        HSSICH_InfoExt_DM_Rqst,
        _RL_Set_DM_Rqst_rL_Set_InformationList_DM_Rqst,
        ____RL_Set_DM_Rqst_iE_Extensions__item__id_tab,
        ___RL_Set_DM_Rqst_iE_Extensions__item__id,
        ____RL_Set_DM_Rqst_iE_Extensions__item__criticality_tab,
        ___RL_Set_DM_Rqst_iE_Extensions__item__criticality,
        ____RL_Set_DM_Rqst_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue,
        __RL_Set_DM_Rqst_iE_Extensions__item_,
        _RL_Set_DM_Rqst_iE_Extensions,
        RL_Set_DM_Rqst,
        RL_SetItem_DM_Rqst_ExtIEs,
        _RL_Set_InformationList_DM_Rqst__item_,
        RL_Set_InformationList_DM_Rqst,
        _RL_Set_InformationItem_DM_Rqst_rL_Set_ID,
        ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id_tab,
        ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id,
        ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality_tab,
        ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality,
        ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue,
        __RL_Set_InformationItem_DM_Rqst_iE_Extensions__item_,
        _RL_Set_InformationItem_DM_Rqst_iE_Extensions,
        RL_Set_InformationItem_DM_Rqst,
        RL_Set_InformationItem_DM_Rqst_ExtIEs,
        AllRL_DM_Rqst,
        AllRL_Set_DM_Rqst,
        ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab,
        _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id,
        ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality,
        ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value,
        __DedicatedMeasurementInitiationResponse_protocolIEs__item_,
        _DedicatedMeasurementInitiationResponse_protocolIEs,
        ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab,
        _____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0,
        ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id,
        ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality,
        ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementInitiationResponse_protocolExtensions__item_,
        _DedicatedMeasurementInitiationResponse_protocolExtensions,
        DedicatedMeasurementInitiationResponse,
        DedicatedMeasurementInitiationResponse_IEs,
        _DedicatedMeasurementInitiationResponse_IEs_val_Value_0,
        _DedicatedMeasurementInitiationResponse_IEs_val_Value_1,
        _DedicatedMeasurementInitiationResponse_IEs_val_Value_2,
        _DedicatedMeasurementInitiationResponse_IEs_val_Value_3,
        DedicatedMeasurementInitiationResponse_Extensions,
        _DedicatedMeasurementInitiationResponse_Extensions_val_Extension_0,
        _DedicatedMeasurementObjectType_DM_Rsp_rL,
        _DedicatedMeasurementObjectType_DM_Rsp_rLS,
        _DedicatedMeasurementObjectType_DM_Rsp_all_RL,
        _DedicatedMeasurementObjectType_DM_Rsp_all_RLS,
        DedicatedMeasurementObjectType_DM_Rsp,
        _RL_DM_Rsp_rL_InformationList_DM_Rsp,
        ____RL_DM_Rsp_iE_Extensions__item__id_tab,
        ___RL_DM_Rsp_iE_Extensions__item__id,
        ____RL_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___RL_DM_Rsp_iE_Extensions__item__criticality,
        ____RL_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___RL_DM_Rsp_iE_Extensions__item__extensionValue,
        __RL_DM_Rsp_iE_Extensions__item_,
        _RL_DM_Rsp_iE_Extensions,
        RL_DM_Rsp,
        RLItem_DM_Rsp_ExtIEs,
        ___RL_InformationList_DM_Rsp__item__id_tab,
        ____RL_InformationList_DM_Rsp__item__id_tab_val_Value_0,
        __RL_InformationList_DM_Rsp__item__id,
        __RL_InformationList_DM_Rsp__item__criticality,
        __RL_InformationList_DM_Rsp__item__value,
        _RL_InformationList_DM_Rsp__item_,
        RL_InformationList_DM_Rsp,
        RL_InformationItemIE_DM_Rsp,
        _RL_InformationItemIE_DM_Rsp_val_Value_0,
        _RL_InformationItem_DM_Rsp_rL_ID,
        _RL_InformationItem_DM_Rsp_dPCH_ID,
        _RL_InformationItem_DM_Rsp_dedicatedMeasurementValue,
        _RL_InformationItem_DM_Rsp_cFN,
        ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_7,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_8,
        ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id,
        ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality,
        ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue,
        __RL_InformationItem_DM_Rsp_iE_Extensions__item_,
        _RL_InformationItem_DM_Rsp_iE_Extensions,
        RL_InformationItem_DM_Rsp,
        RL_InformationItem_DM_Rsp_ExtIEs,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_0,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_1,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_2,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_3,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_4,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_5,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_6,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_7,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_8,
        _PUSCH_Info_DM_Rsp__item_,
        PUSCH_Info_DM_Rsp,
        _Multiple_PUSCH_InfoList_DM_Rsp__item_,
        Multiple_PUSCH_InfoList_DM_Rsp,
        _Multiple_PUSCH_InfoListIE_DM_Rsp_pUSCH_ID,
        _Multiple_PUSCH_InfoListIE_DM_Rsp_dedicatedMeasurementValue,
        ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__id_tab,
        ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__id,
        ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__criticality,
        ____Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item__extensionValue,
        __Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions__item_,
        _Multiple_PUSCH_InfoListIE_DM_Rsp_iE_Extensions,
        Multiple_PUSCH_InfoListIE_DM_Rsp,
        Multiple_PUSCH_InfoListIE_DM_Rsp_ExtIEs,
        _Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp__item_,
        Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp,
        _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dPCH_ID,
        _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue,
        ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab,
        ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id,
        ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality,
        ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue,
        __Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_,
        _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions,
        Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp,
        Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_ExtIEs,
        _Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp__item_,
        Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp,
        _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dPCH_ID,
        _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dedicatedMeasurementValue,
        ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id_tab,
        ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id,
        ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality,
        ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue,
        __Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item_,
        _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions,
        Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp,
        Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_ExtIEs,
        _Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp__item_,
        Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp,
        _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_hsSICH_ID,
        _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue,
        ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab,
        _____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0,
        ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id,
        ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality,
        ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue,
        __Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_,
        _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions,
        Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp,
        Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs,
        _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs_val_Extension_0,
        _Multiple_DedicatedMeasurementValueList_768_TDD_DM_Rsp__item_,
        Multiple_DedicatedMeasurementValueList_768_TDD_DM_Rsp,
        _Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_dPCH_ID768,
        _Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_dedicatedMeasurementValue,
        ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__id_tab,
        ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__id,
        ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__criticality,
        ____Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item__extensionValue,
        __Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions__item_,
        _Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_iE_Extensions,
        Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp,
        Multiple_DedicatedMeasurementValueItem_768_TDD_DM_Rsp_ExtIEs,
        _RL_Set_DM_Rsp_rL_Set_InformationList_DM_Rsp,
        ____RL_Set_DM_Rsp_iE_Extensions__item__id_tab,
        ___RL_Set_DM_Rsp_iE_Extensions__item__id,
        ____RL_Set_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___RL_Set_DM_Rsp_iE_Extensions__item__criticality,
        ____RL_Set_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue,
        __RL_Set_DM_Rsp_iE_Extensions__item_,
        _RL_Set_DM_Rsp_iE_Extensions,
        RL_Set_DM_Rsp,
        RL_SetItem_DM_Rsp_ExtIEs,
        ___RL_Set_InformationList_DM_Rsp__item__id_tab,
        ____RL_Set_InformationList_DM_Rsp__item__id_tab_val_Value_0,
        __RL_Set_InformationList_DM_Rsp__item__id,
        __RL_Set_InformationList_DM_Rsp__item__criticality,
        __RL_Set_InformationList_DM_Rsp__item__value,
        _RL_Set_InformationList_DM_Rsp__item_,
        RL_Set_InformationList_DM_Rsp,
        RL_Set_InformationItemIE_DM_Rsp,
        _RL_Set_InformationItemIE_DM_Rsp_val_Value_0,
        _RL_Set_InformationItem_DM_Rsp_rL_Set_ID,
        _RL_Set_InformationItem_DM_Rsp_dedicatedMeasurementValue,
        _RL_Set_InformationItem_DM_Rsp_cFN,
        ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id_tab,
        ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id,
        ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality,
        ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue,
        __RL_Set_InformationItem_DM_Rsp_iE_Extensions__item_,
        _RL_Set_InformationItem_DM_Rsp_iE_Extensions,
        RL_Set_InformationItem_DM_Rsp,
        RL_Set_InformationItem_DM_Rsp_ExtIEs,
        ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab,
        _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id,
        ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality,
        ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value,
        __DedicatedMeasurementInitiationFailure_protocolIEs__item_,
        _DedicatedMeasurementInitiationFailure_protocolIEs,
        ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab,
        ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id,
        ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality_tab,
        ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality,
        ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab,
        ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementInitiationFailure_protocolExtensions__item_,
        _DedicatedMeasurementInitiationFailure_protocolExtensions,
        DedicatedMeasurementInitiationFailure,
        DedicatedMeasurementInitiationFailure_IEs,
        _DedicatedMeasurementInitiationFailure_IEs_val_Value_0,
        _DedicatedMeasurementInitiationFailure_IEs_val_Value_1,
        _DedicatedMeasurementInitiationFailure_IEs_val_Value_2,
        _DedicatedMeasurementInitiationFailure_IEs_val_Value_3,
        DedicatedMeasurementInitiationFailure_Extensions,
        ____DedicatedMeasurementReport_protocolIEs__item__id_tab,
        _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        ___DedicatedMeasurementReport_protocolIEs__item__id,
        ___DedicatedMeasurementReport_protocolIEs__item__criticality,
        ___DedicatedMeasurementReport_protocolIEs__item__value,
        __DedicatedMeasurementReport_protocolIEs__item_,
        _DedicatedMeasurementReport_protocolIEs,
        ____DedicatedMeasurementReport_protocolExtensions__item__id_tab,
        _____DedicatedMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0,
        ___DedicatedMeasurementReport_protocolExtensions__item__id,
        ___DedicatedMeasurementReport_protocolExtensions__item__criticality,
        ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementReport_protocolExtensions__item_,
        _DedicatedMeasurementReport_protocolExtensions,
        DedicatedMeasurementReport,
        DedicatedMeasurementReport_IEs,
        _DedicatedMeasurementReport_IEs_val_Value_0,
        _DedicatedMeasurementReport_IEs_val_Value_1,
        _DedicatedMeasurementReport_IEs_val_Value_2,
        DedicatedMeasurementReport_Extensions,
        _DedicatedMeasurementReport_Extensions_val_Extension_0,
        _DedicatedMeasurementObjectType_DM_Rprt_rL,
        _DedicatedMeasurementObjectType_DM_Rprt_rLS,
        _DedicatedMeasurementObjectType_DM_Rprt_all_RL,
        _DedicatedMeasurementObjectType_DM_Rprt_all_RLS,
        DedicatedMeasurementObjectType_DM_Rprt,
        _RL_DM_Rprt_rL_InformationList_DM_Rprt,
        ____RL_DM_Rprt_iE_Extensions__item__id_tab,
        ___RL_DM_Rprt_iE_Extensions__item__id,
        ____RL_DM_Rprt_iE_Extensions__item__criticality_tab,
        ___RL_DM_Rprt_iE_Extensions__item__criticality,
        ____RL_DM_Rprt_iE_Extensions__item__extensionValue_tab,
        ___RL_DM_Rprt_iE_Extensions__item__extensionValue,
        __RL_DM_Rprt_iE_Extensions__item_,
        _RL_DM_Rprt_iE_Extensions,
        RL_DM_Rprt,
        RLItem_DM_Rprt_ExtIEs,
        ___RL_InformationList_DM_Rprt__item__id_tab,
        ____RL_InformationList_DM_Rprt__item__id_tab_val_Value_0,
        __RL_InformationList_DM_Rprt__item__id,
        __RL_InformationList_DM_Rprt__item__criticality,
        __RL_InformationList_DM_Rprt__item__value,
        _RL_InformationList_DM_Rprt__item_,
        RL_InformationList_DM_Rprt,
        RL_InformationItemIE_DM_Rprt,
        _RL_InformationItemIE_DM_Rprt_val_Value_0,
        _RL_InformationItem_DM_Rprt_rL_ID,
        _RL_InformationItem_DM_Rprt_dPCH_ID,
        _RL_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation,
        ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab,
        _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_4,
        ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id,
        ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality,
        ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue,
        __RL_InformationItem_DM_Rprt_iE_Extensions__item_,
        _RL_InformationItem_DM_Rprt_iE_Extensions,
        RL_InformationItem_DM_Rprt,
        RL_InformationItem_DM_Rprt_ExtIEs,
        _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_0,
        _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_1,
        _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_2,
        _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_3,
        _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_4,
        _PUSCH_Info_DM_Rprt__item_,
        PUSCH_Info_DM_Rprt,
        _Multiple_PUSCH_InfoList_DM_Rprt__item_,
        Multiple_PUSCH_InfoList_DM_Rprt,
        _Multiple_PUSCH_InfoListIE_DM_Rprt_pUSCH_ID,
        _Multiple_PUSCH_InfoListIE_DM_Rprt_dedicatedMeasurementValue,
        ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__id_tab,
        ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__id,
        ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__criticality_tab,
        ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__criticality,
        ____Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__extensionValue_tab,
        ___Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item__extensionValue,
        __Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions__item_,
        _Multiple_PUSCH_InfoListIE_DM_Rprt_iE_Extensions,
        Multiple_PUSCH_InfoListIE_DM_Rprt,
        Multiple_PUSCH_InfoListIE_DM_Rprt_ExtIEs,
        _RL_Set_DM_Rprt_rL_Set_InformationList_DM_Rprt,
        ____RL_Set_DM_Rprt_iE_Extensions__item__id_tab,
        ___RL_Set_DM_Rprt_iE_Extensions__item__id,
        ____RL_Set_DM_Rprt_iE_Extensions__item__criticality_tab,
        ___RL_Set_DM_Rprt_iE_Extensions__item__criticality,
        ____RL_Set_DM_Rprt_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue,
        __RL_Set_DM_Rprt_iE_Extensions__item_,
        _RL_Set_DM_Rprt_iE_Extensions,
        RL_Set_DM_Rprt,
        RL_SetItem_DM_Rprt_ExtIEs,
        ___RL_Set_InformationList_DM_Rprt__item__id_tab,
        ____RL_Set_InformationList_DM_Rprt__item__id_tab_val_Value_0,
        __RL_Set_InformationList_DM_Rprt__item__id,
        __RL_Set_InformationList_DM_Rprt__item__criticality,
        __RL_Set_InformationList_DM_Rprt__item__value,
        _RL_Set_InformationList_DM_Rprt__item_,
        RL_Set_InformationList_DM_Rprt,
        RL_Set_InformationItemIE_DM_Rprt,
        _RL_Set_InformationItemIE_DM_Rprt_val_Value_0,
        _RL_Set_InformationItem_DM_Rprt_rL_Set_ID,
        _RL_Set_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation,
        ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id_tab,
        ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id,
        ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality_tab,
        ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality,
        ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue,
        __RL_Set_InformationItem_DM_Rprt_iE_Extensions__item_,
        _RL_Set_InformationItem_DM_Rprt_iE_Extensions,
        RL_Set_InformationItem_DM_Rprt,
        RL_Set_InformationItem_DM_Rprt_ExtIEs,
        ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab,
        _____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id,
        ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality,
        ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value,
        __DedicatedMeasurementTerminationRequest_protocolIEs__item_,
        _DedicatedMeasurementTerminationRequest_protocolIEs,
        ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__id_tab,
        ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id,
        ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality_tab,
        ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality,
        ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab,
        ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementTerminationRequest_protocolExtensions__item_,
        _DedicatedMeasurementTerminationRequest_protocolExtensions,
        DedicatedMeasurementTerminationRequest,
        DedicatedMeasurementTerminationRequest_IEs,
        _DedicatedMeasurementTerminationRequest_IEs_val_Value_0,
        _DedicatedMeasurementTerminationRequest_IEs_val_Value_1,
        DedicatedMeasurementTerminationRequest_Extensions,
        ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        ___DedicatedMeasurementFailureIndication_protocolIEs__item__id,
        ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality,
        ___DedicatedMeasurementFailureIndication_protocolIEs__item__value,
        __DedicatedMeasurementFailureIndication_protocolIEs__item_,
        _DedicatedMeasurementFailureIndication_protocolIEs,
        ____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab,
        ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id,
        ____DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality_tab,
        ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality,
        ____DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab,
        ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementFailureIndication_protocolExtensions__item_,
        _DedicatedMeasurementFailureIndication_protocolExtensions,
        DedicatedMeasurementFailureIndication,
        DedicatedMeasurementFailureIndication_IEs,
        _DedicatedMeasurementFailureIndication_IEs_val_Value_0,
        _DedicatedMeasurementFailureIndication_IEs_val_Value_1,
        _DedicatedMeasurementFailureIndication_IEs_val_Value_2,
        DedicatedMeasurementFailureIndication_Extensions,
        ____RadioLinkFailureIndication_protocolIEs__item__id_tab,
        _____RadioLinkFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkFailureIndication_protocolIEs__item__id,
        ___RadioLinkFailureIndication_protocolIEs__item__criticality,
        ___RadioLinkFailureIndication_protocolIEs__item__value,
        __RadioLinkFailureIndication_protocolIEs__item_,
        _RadioLinkFailureIndication_protocolIEs,
        ____RadioLinkFailureIndication_protocolExtensions__item__id_tab,
        ___RadioLinkFailureIndication_protocolExtensions__item__id,
        ____RadioLinkFailureIndication_protocolExtensions__item__criticality_tab,
        ___RadioLinkFailureIndication_protocolExtensions__item__criticality,
        ____RadioLinkFailureIndication_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue,
        __RadioLinkFailureIndication_protocolExtensions__item_,
        _RadioLinkFailureIndication_protocolExtensions,
        RadioLinkFailureIndication,
        RadioLinkFailureIndication_IEs,
        _RadioLinkFailureIndication_IEs_val_Value_0,
        _RadioLinkFailureIndication_IEs_val_Value_1,
        RadioLinkFailureIndication_Extensions,
        _Reporting_Object_RL_FailureInd_rL,
        _Reporting_Object_RL_FailureInd_rL_Set,
        _Reporting_Object_RL_FailureInd_cCTrCH,
        Reporting_Object_RL_FailureInd,
        _RL_RL_FailureInd_rL_InformationList_RL_FailureInd,
        ____RL_RL_FailureInd_iE_Extensions__item__id_tab,
        ___RL_RL_FailureInd_iE_Extensions__item__id,
        ____RL_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___RL_RL_FailureInd_iE_Extensions__item__criticality,
        ____RL_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___RL_RL_FailureInd_iE_Extensions__item__extensionValue,
        __RL_RL_FailureInd_iE_Extensions__item_,
        _RL_RL_FailureInd_iE_Extensions,
        RL_RL_FailureInd,
        RLItem_RL_FailureInd_ExtIEs,
        ___RL_InformationList_RL_FailureInd__item__id_tab,
        ____RL_InformationList_RL_FailureInd__item__id_tab_val_Value_0,
        __RL_InformationList_RL_FailureInd__item__id,
        __RL_InformationList_RL_FailureInd__item__criticality,
        __RL_InformationList_RL_FailureInd__item__value,
        _RL_InformationList_RL_FailureInd__item_,
        RL_InformationList_RL_FailureInd,
        RL_InformationItemIE_RL_FailureInd,
        _RL_InformationItemIE_RL_FailureInd_val_Value_0,
        _RL_InformationItem_RL_FailureInd_rL_ID,
        _RL_InformationItem_RL_FailureInd_cause,
        ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab,
        ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__id,
        ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__criticality,
        ____RL_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___RL_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue,
        __RL_InformationItem_RL_FailureInd_iE_Extensions__item_,
        _RL_InformationItem_RL_FailureInd_iE_Extensions,
        RL_InformationItem_RL_FailureInd,
        RL_InformationItem_RL_FailureInd_ExtIEs,
        _RL_Set_RL_FailureInd_rL_Set_InformationList_RL_FailureInd,
        ____RL_Set_RL_FailureInd_iE_Extensions__item__id_tab,
        ___RL_Set_RL_FailureInd_iE_Extensions__item__id,
        ____RL_Set_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality,
        ____RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue,
        __RL_Set_RL_FailureInd_iE_Extensions__item_,
        _RL_Set_RL_FailureInd_iE_Extensions,
        RL_Set_RL_FailureInd,
        RL_SetItem_RL_FailureInd_ExtIEs,
        ___RL_Set_InformationList_RL_FailureInd__item__id_tab,
        ____RL_Set_InformationList_RL_FailureInd__item__id_tab_val_Value_0,
        __RL_Set_InformationList_RL_FailureInd__item__id,
        __RL_Set_InformationList_RL_FailureInd__item__criticality,
        __RL_Set_InformationList_RL_FailureInd__item__value,
        _RL_Set_InformationList_RL_FailureInd__item_,
        RL_Set_InformationList_RL_FailureInd,
        RL_Set_InformationItemIE_RL_FailureInd,
        _RL_Set_InformationItemIE_RL_FailureInd_val_Value_0,
        _RL_Set_InformationItem_RL_FailureInd_rL_Set_ID,
        _RL_Set_InformationItem_RL_FailureInd_cause,
        ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab,
        ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__id,
        ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__criticality,
        ____RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue,
        __RL_Set_InformationItem_RL_FailureInd_iE_Extensions__item_,
        _RL_Set_InformationItem_RL_FailureInd_iE_Extensions,
        RL_Set_InformationItem_RL_FailureInd,
        RL_Set_InformationItem_RL_FailureInd_ExtIEs,
        _CCTrCH_RL_FailureInd_rL_ID,
        _CCTrCH_RL_FailureInd_cCTrCH_InformationList_RL_FailureInd,
        ____CCTrCH_RL_FailureInd_iE_Extensions__item__id_tab,
        ___CCTrCH_RL_FailureInd_iE_Extensions__item__id,
        ____CCTrCH_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality,
        ____CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue,
        __CCTrCH_RL_FailureInd_iE_Extensions__item_,
        _CCTrCH_RL_FailureInd_iE_Extensions,
        CCTrCH_RL_FailureInd,
        CCTrCHItem_RL_FailureInd_ExtIEs,
        ___CCTrCH_InformationList_RL_FailureInd__item__id_tab,
        ____CCTrCH_InformationList_RL_FailureInd__item__id_tab_val_Value_0,
        __CCTrCH_InformationList_RL_FailureInd__item__id,
        __CCTrCH_InformationList_RL_FailureInd__item__criticality,
        __CCTrCH_InformationList_RL_FailureInd__item__value,
        _CCTrCH_InformationList_RL_FailureInd__item_,
        CCTrCH_InformationList_RL_FailureInd,
        CCTrCH_InformationItemIE_RL_FailureInd,
        _CCTrCH_InformationItemIE_RL_FailureInd_val_Value_0,
        _CCTrCH_InformationItem_RL_FailureInd_cCTrCH_ID,
        _CCTrCH_InformationItem_RL_FailureInd_cause,
        ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab,
        ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id,
        ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality,
        ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue,
        __CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item_,
        _CCTrCH_InformationItem_RL_FailureInd_iE_Extensions,
        CCTrCH_InformationItem_RL_FailureInd,
        CCTrCH_InformationItem_RL_FailureInd_ExtIEs,
        ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab,
        _____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id,
        ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality,
        ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value,
        __RadioLinkPreemptionRequiredIndication_protocolIEs__item_,
        _RadioLinkPreemptionRequiredIndication_protocolIEs,
        ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab,
        ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id,
        ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality_tab,
        ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality,
        ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue,
        __RadioLinkPreemptionRequiredIndication_protocolExtensions__item_,
        _RadioLinkPreemptionRequiredIndication_protocolExtensions,
        RadioLinkPreemptionRequiredIndication,
        RadioLinkPreemptionRequiredIndication_IEs,
        _RadioLinkPreemptionRequiredIndication_IEs_val_Value_0,
        _RadioLinkPreemptionRequiredIndication_IEs_val_Value_1,
        RadioLinkPreemptionRequiredIndication_Extensions,
        ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab,
        ____RL_InformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0,
        __RL_InformationList_RL_PreemptRequiredInd__item__id,
        __RL_InformationList_RL_PreemptRequiredInd__item__criticality,
        __RL_InformationList_RL_PreemptRequiredInd__item__value,
        _RL_InformationList_RL_PreemptRequiredInd__item_,
        RL_InformationList_RL_PreemptRequiredInd,
        RL_InformationItemIE_RL_PreemptRequiredInd,
        _RL_InformationItemIE_RL_PreemptRequiredInd_val_Value_0,
        _RL_InformationItem_RL_PreemptRequiredInd_rL_ID,
        ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab,
        ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id,
        ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab,
        ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality,
        ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab,
        ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue,
        __RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item_,
        _RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions,
        RL_InformationItem_RL_PreemptRequiredInd,
        RL_InformationItem_RL_PreemptRequiredInd_ExtIEs,
        ____RadioLinkRestoreIndication_protocolIEs__item__id_tab,
        _____RadioLinkRestoreIndication_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkRestoreIndication_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkRestoreIndication_protocolIEs__item__id,
        ___RadioLinkRestoreIndication_protocolIEs__item__criticality,
        ___RadioLinkRestoreIndication_protocolIEs__item__value,
        __RadioLinkRestoreIndication_protocolIEs__item_,
        _RadioLinkRestoreIndication_protocolIEs,
        ____RadioLinkRestoreIndication_protocolExtensions__item__id_tab,
        ___RadioLinkRestoreIndication_protocolExtensions__item__id,
        ____RadioLinkRestoreIndication_protocolExtensions__item__criticality_tab,
        ___RadioLinkRestoreIndication_protocolExtensions__item__criticality,
        ____RadioLinkRestoreIndication_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue,
        __RadioLinkRestoreIndication_protocolExtensions__item_,
        _RadioLinkRestoreIndication_protocolExtensions,
        RadioLinkRestoreIndication,
        RadioLinkRestoreIndication_IEs,
        _RadioLinkRestoreIndication_IEs_val_Value_0,
        _RadioLinkRestoreIndication_IEs_val_Value_1,
        RadioLinkRestoreIndication_Extensions,
        _Reporting_Object_RL_RestoreInd_rL,
        _Reporting_Object_RL_RestoreInd_rL_Set,
        _Reporting_Object_RL_RestoreInd_cCTrCH,
        Reporting_Object_RL_RestoreInd,
        _RL_RL_RestoreInd_rL_InformationList_RL_RestoreInd,
        ____RL_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___RL_RL_RestoreInd_iE_Extensions__item__id,
        ____RL_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___RL_RL_RestoreInd_iE_Extensions__item__criticality,
        ____RL_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __RL_RL_RestoreInd_iE_Extensions__item_,
        _RL_RL_RestoreInd_iE_Extensions,
        RL_RL_RestoreInd,
        RLItem_RL_RestoreInd_ExtIEs,
        ___RL_InformationList_RL_RestoreInd__item__id_tab,
        ____RL_InformationList_RL_RestoreInd__item__id_tab_val_Value_0,
        __RL_InformationList_RL_RestoreInd__item__id,
        __RL_InformationList_RL_RestoreInd__item__criticality,
        __RL_InformationList_RL_RestoreInd__item__value,
        _RL_InformationList_RL_RestoreInd__item_,
        RL_InformationList_RL_RestoreInd,
        RL_InformationItemIE_RL_RestoreInd,
        _RL_InformationItemIE_RL_RestoreInd_val_Value_0,
        _RL_InformationItem_RL_RestoreInd_rL_ID,
        ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__id,
        ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality,
        ____RL_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___RL_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __RL_InformationItem_RL_RestoreInd_iE_Extensions__item_,
        _RL_InformationItem_RL_RestoreInd_iE_Extensions,
        RL_InformationItem_RL_RestoreInd,
        RL_InformationItem_RL_RestoreInd_ExtIEs,
        _RL_Set_RL_RestoreInd_rL_Set_InformationList_RL_RestoreInd,
        ____RL_Set_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___RL_Set_RL_RestoreInd_iE_Extensions__item__id,
        ____RL_Set_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality,
        ____RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __RL_Set_RL_RestoreInd_iE_Extensions__item_,
        _RL_Set_RL_RestoreInd_iE_Extensions,
        RL_Set_RL_RestoreInd,
        RL_SetItem_RL_RestoreInd_ExtIEs,
        ___RL_Set_InformationList_RL_RestoreInd__item__id_tab,
        ____RL_Set_InformationList_RL_RestoreInd__item__id_tab_val_Value_0,
        __RL_Set_InformationList_RL_RestoreInd__item__id,
        __RL_Set_InformationList_RL_RestoreInd__item__criticality,
        __RL_Set_InformationList_RL_RestoreInd__item__value,
        _RL_Set_InformationList_RL_RestoreInd__item_,
        RL_Set_InformationList_RL_RestoreInd,
        RL_Set_InformationItemIE_RL_RestoreInd,
        _RL_Set_InformationItemIE_RL_RestoreInd_val_Value_0,
        _RL_Set_InformationItem_RL_RestoreInd_rL_Set_ID,
        ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__id,
        ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality,
        ____RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __RL_Set_InformationItem_RL_RestoreInd_iE_Extensions__item_,
        _RL_Set_InformationItem_RL_RestoreInd_iE_Extensions,
        RL_Set_InformationItem_RL_RestoreInd,
        RL_Set_InformationItem_RL_RestoreInd_ExtIEs,
        _CCTrCH_RL_RestoreInd_rL_ID,
        _CCTrCH_RL_RestoreInd_cCTrCH_InformationList_RL_RestoreInd,
        ____CCTrCH_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id,
        ____CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality,
        ____CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __CCTrCH_RL_RestoreInd_iE_Extensions__item_,
        _CCTrCH_RL_RestoreInd_iE_Extensions,
        CCTrCH_RL_RestoreInd,
        CCTrCHItem_RL_RestoreInd_ExtIEs,
        ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab,
        ____CCTrCH_InformationList_RL_RestoreInd__item__id_tab_val_Value_0,
        __CCTrCH_InformationList_RL_RestoreInd__item__id,
        __CCTrCH_InformationList_RL_RestoreInd__item__criticality,
        __CCTrCH_InformationList_RL_RestoreInd__item__value,
        _CCTrCH_InformationList_RL_RestoreInd__item_,
        CCTrCH_InformationList_RL_RestoreInd,
        CCTrCH_InformationItemIE_RL_RestoreInd,
        _CCTrCH_InformationItemIE_RL_RestoreInd_val_Value_0,
        _CCTrCH_InformationItem_RL_RestoreInd_cCTrCH_ID,
        ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id,
        ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality,
        ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item_,
        _CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions,
        CCTrCH_InformationItem_RL_RestoreInd,
        CCTrCH_InformationItem_RL_RestoreInd_ExtIEs,
        ____CompressedModeCommand_protocolIEs__item__id_tab,
        _____CompressedModeCommand_protocolIEs__item__id_tab_val_Value_0,
        _____CompressedModeCommand_protocolIEs__item__id_tab_val_Value_1,
        ___CompressedModeCommand_protocolIEs__item__id,
        ___CompressedModeCommand_protocolIEs__item__criticality,
        ___CompressedModeCommand_protocolIEs__item__value,
        __CompressedModeCommand_protocolIEs__item_,
        _CompressedModeCommand_protocolIEs,
        ____CompressedModeCommand_protocolExtensions__item__id_tab,
        ___CompressedModeCommand_protocolExtensions__item__id,
        ____CompressedModeCommand_protocolExtensions__item__criticality_tab,
        ___CompressedModeCommand_protocolExtensions__item__criticality,
        ____CompressedModeCommand_protocolExtensions__item__extensionValue_tab,
        ___CompressedModeCommand_protocolExtensions__item__extensionValue,
        __CompressedModeCommand_protocolExtensions__item_,
        _CompressedModeCommand_protocolExtensions,
        CompressedModeCommand,
        CompressedModeCommand_IEs,
        _CompressedModeCommand_IEs_val_Value_0,
        _CompressedModeCommand_IEs_val_Value_1,
        CompressedModeCommand_Extensions,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ____ErrorIndication_protocolExtensions__item__id_tab,
        ___ErrorIndication_protocolExtensions__item__id,
        ____ErrorIndication_protocolExtensions__item__criticality_tab,
        ___ErrorIndication_protocolExtensions__item__criticality,
        ____ErrorIndication_protocolExtensions__item__extensionValue_tab,
        ___ErrorIndication_protocolExtensions__item__extensionValue,
        __ErrorIndication_protocolExtensions__item_,
        _ErrorIndication_protocolExtensions,
        ErrorIndication,
        ErrorIndication_IEs,
        _ErrorIndication_IEs_val_Value_0,
        _ErrorIndication_IEs_val_Value_1,
        _ErrorIndication_IEs_val_Value_2,
        _ErrorIndication_IEs_val_Value_3,
        ErrorIndication_Extensions,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6,
        ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__id,
        ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__criticality,
        ___PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item__value,
        __PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs__item_,
        _PhysicalSharedChannelReconfigurationRequestFDD_protocolIEs,
        ____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_17,
        ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__id,
        ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__criticality,
        ___PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue,
        __PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions__item_,
        _PhysicalSharedChannelReconfigurationRequestFDD_protocolExtensions,
        PhysicalSharedChannelReconfigurationRequestFDD,
        PhysicalSharedChannelReconfigurationRequestFDD_IEs,
        _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_0,
        _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_1,
        _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_2,
        _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_3,
        _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_4,
        _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_5,
        _PhysicalSharedChannelReconfigurationRequestFDD_IEs_val_Value_6,
        PhysicalSharedChannelReconfigurationRequestFDD_Extensions,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_0,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_1,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_2,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_3,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_4,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_5,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_6,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_7,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_8,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_9,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_10,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_11,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_12,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_13,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_14,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_15,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_16,
        _PhysicalSharedChannelReconfigurationRequestFDD_Extensions_val_Extension_17,
        _HSDPA_And_EDCH_CellPortion_InformationList_PSCH_ReconfRqst__item_,
        HSDPA_And_EDCH_CellPortion_InformationList_PSCH_ReconfRqst,
        _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_cellPortionID,
        _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_PDSCH_HS_SCCH_ScramblingCode_PSCH_ReconfRqst,
        _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_PDSCH_FDD_Code_Information_PSCH_ReconfRqst,
        _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_SCCH_FDD_Code_Information_PSCH_ReconfRqst,
        _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_hS_PDSCH_HS_SCCH_E_AGCH_E_RGCH_E_HICH_MaxPower_PSCH_ReconfRqst,
        _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_e_AGCH_And_E_RGCH_E_HICH_FDD_Scrambling_Code,
        _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_e_AGCH_FDD_Code_Information,
        _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_e_RGCH_E_HICH_FDD_Code_Information,
        ____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1,
        ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_iE_Extensions,
        HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst,
        HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_ExtIEs,
        _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _HSDPA_And_EDCH_CellPortion_InformationItem_PSCH_ReconfRqst_ExtIEs_val_Extension_1,
        ____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7,
        ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__id,
        ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__criticality,
        ___PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item__value,
        __PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs__item_,
        _PhysicalSharedChannelReconfigurationRequestTDD_protocolIEs,
        ____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_19,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_20,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_21,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_22,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_23,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_24,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_25,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_26,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_27,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_28,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_29,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_30,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_31,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_32,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_33,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_34,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_35,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_36,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_37,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_38,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_39,
        _____PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_40,
        ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__id,
        ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__criticality,
        ___PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue,
        __PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions__item_,
        _PhysicalSharedChannelReconfigurationRequestTDD_protocolExtensions,
        PhysicalSharedChannelReconfigurationRequestTDD,
        PhysicalSharedChannelReconfigurationRequestTDD_IEs,
        _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_0,
        _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_1,
        _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_2,
        _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_3,
        _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_4,
        _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_5,
        _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_6,
        _PhysicalSharedChannelReconfigurationRequestTDD_IEs_val_Value_7,
        PhysicalSharedChannelReconfigurationRequestTDD_Extensions,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_0,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_1,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_2,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_3,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_4,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_5,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_6,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_7,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_8,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_9,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_10,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_11,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_12,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_13,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_14,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_15,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_16,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_17,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_18,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_19,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_20,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_21,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_22,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_23,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_24,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_25,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_26,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_27,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_28,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_29,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_30,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_31,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_32,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_33,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_34,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_35,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_36,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_37,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_38,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_39,
        _PhysicalSharedChannelReconfigurationRequestTDD_Extensions_val_Extension_40,
        _PDSCHSets_AddList_PSCH_ReconfRqst__item_,
        PDSCHSets_AddList_PSCH_ReconfRqst,
        _PDSCHSets_AddItem_PSCH_ReconfRqst_pDSCHSet_ID,
        _PDSCHSets_AddItem_PSCH_ReconfRqst_pDSCH_InformationList,
        ____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1,
        ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PDSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions,
        PDSCHSets_AddItem_PSCH_ReconfRqst,
        PDSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs,
        _PDSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _PDSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_1,
        __PDSCH_Information_AddList_PSCH_ReconfRqst_id_tab,
        ___PDSCH_Information_AddList_PSCH_ReconfRqst_id_tab_val_Value_0,
        _PDSCH_Information_AddList_PSCH_ReconfRqst_id,
        _PDSCH_Information_AddList_PSCH_ReconfRqst_criticality,
        _PDSCH_Information_AddList_PSCH_ReconfRqst_value,
        PDSCH_Information_AddList_PSCH_ReconfRqst,
        PDSCH_Information_AddListIEs_PSCH_ReconfRqst,
        _PDSCH_Information_AddListIEs_PSCH_ReconfRqst_val_Value_0,
        _PDSCH_Information_AddItem_PSCH_ReconfRqst_repetitionPeriod,
        _PDSCH_Information_AddItem_PSCH_ReconfRqst_repetitionLength,
        _PDSCH_Information_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PDSCH_Information_AddItem_PSCH_ReconfRqst_dL_Timeslot_InformationAddList_PSCH_ReconfRqst,
        ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PDSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions,
        PDSCH_Information_AddItem_PSCH_ReconfRqst,
        PDSCH_Information_AddItem_PSCH_ReconfRqst_ExtIEs,
        _DL_Timeslot_InformationAddList_PSCH_ReconfRqst__item_,
        DL_Timeslot_InformationAddList_PSCH_ReconfRqst,
        _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_timeSlot,
        _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_tFCI_Presence,
        _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_dL_Code_InformationAddList_PSCH_ReconfRqst,
        ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions,
        DL_Timeslot_InformationAddItem_PSCH_ReconfRqst,
        DL_Timeslot_InformationAddItem_PSCH_ReconfRqst_ExtIEs,
        _DL_Code_InformationAddList_PSCH_ReconfRqst__item_,
        DL_Code_InformationAddList_PSCH_ReconfRqst,
        _DL_Code_InformationAddItem_PSCH_ReconfRqst_pDSCH_ID,
        _DL_Code_InformationAddItem_PSCH_ReconfRqst_tdd_ChannelisationCode,
        ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions,
        DL_Code_InformationAddItem_PSCH_ReconfRqst,
        DL_Code_InformationAddItem_PSCH_ReconfRqst_ExtIEs,
        _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionPeriod,
        _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionLength,
        _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_dL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst,
        ____PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions,
        PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst,
        PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_ExtIEs,
        _PDSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _DL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst__item_,
        DL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst,
        _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_timeSlotLCR,
        _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_midambleShiftLCR,
        _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_tFCI_Presence,
        _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_dL_Code_InformationAddList_LCR_PSCH_ReconfRqst,
        ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst,
        DL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs,
        _DL_Code_InformationAddList_LCR_PSCH_ReconfRqst__item_,
        DL_Code_InformationAddList_LCR_PSCH_ReconfRqst,
        _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_pDSCH_ID,
        _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR,
        ____DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst,
        DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs,
        _DL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionPeriod,
        _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionLength,
        _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_dL_Timeslot_InformationAddList_768_PSCH_ReconfRqst,
        ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions,
        PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst,
        PDSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_ExtIEs,
        _DL_Timeslot_InformationAddList_768_PSCH_ReconfRqst__item_,
        DL_Timeslot_InformationAddList_768_PSCH_ReconfRqst,
        _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_timeSlot,
        _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_tFCI_Presence,
        _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_dL_Code_InformationAddList_768_PSCH_ReconfRqst,
        ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions,
        DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst,
        DL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs,
        _DL_Code_InformationAddList_768_PSCH_ReconfRqst__item_,
        DL_Code_InformationAddList_768_PSCH_ReconfRqst,
        _DL_Code_InformationAddItem_768_PSCH_ReconfRqst_pDSCH_ID768,
        _DL_Code_InformationAddItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768,
        ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions,
        DL_Code_InformationAddItem_768_PSCH_ReconfRqst,
        DL_Code_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs,
        _PDSCHSets_ModifyList_PSCH_ReconfRqst__item_,
        PDSCHSets_ModifyList_PSCH_ReconfRqst,
        _PDSCHSets_ModifyItem_PSCH_ReconfRqst_pDSCHSet_ID,
        _PDSCHSets_ModifyItem_PSCH_ReconfRqst_pDSCH_InformationList,
        ____PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PDSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions,
        PDSCHSets_ModifyItem_PSCH_ReconfRqst,
        PDSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs,
        _PDSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        __PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab,
        ___PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_0,
        ___PDSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_1,
        _PDSCH_Information_ModifyList_PSCH_ReconfRqst_id,
        _PDSCH_Information_ModifyList_PSCH_ReconfRqst_criticality,
        _PDSCH_Information_ModifyList_PSCH_ReconfRqst_value,
        PDSCH_Information_ModifyList_PSCH_ReconfRqst,
        PDSCH_Information_ModifyListIEs_PSCH_ReconfRqst,
        _PDSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_0,
        _PDSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_1,
        _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionPeriod,
        _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionLength,
        _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_dL_Timeslot_InformationModifyList_PSCH_ReconfRqst,
        ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PDSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions,
        PDSCH_Information_ModifyItem_PSCH_ReconfRqst,
        PDSCH_Information_ModifyItem_PSCH_ReconfRqst_ExtIEs,
        _DL_Timeslot_InformationModifyList_PSCH_ReconfRqst__item_,
        DL_Timeslot_InformationModifyList_PSCH_ReconfRqst,
        _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_timeSlot,
        _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence,
        _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_dL_Code_InformationModifyList_PSCH_ReconfRqst,
        ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst,
        DL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _DL_Code_InformationModifyList_PSCH_ReconfRqst__item_,
        DL_Code_InformationModifyList_PSCH_ReconfRqst,
        _DL_Code_InformationModifyItem_PSCH_ReconfRqst_pDSCH_ID,
        _DL_Code_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode,
        ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        DL_Code_InformationModifyItem_PSCH_ReconfRqst,
        DL_Code_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionPeriod,
        _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionLength,
        _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_dL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst,
        ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions,
        PDSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst,
        PDSCH_ModifyInformation_LCR_ModifyListIE_PSCH_ReconfRqst_ExtIEs,
        _DL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst__item_,
        DL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst,
        _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_timeSlotLCR,
        _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_midambleShiftLCR,
        _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence,
        _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_dL_Code_LCR_InformationModifyList_PSCH_ReconfRqst,
        ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst,
        DL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _DL_Code_LCR_InformationModifyList_PSCH_ReconfRqst__item_,
        DL_Code_LCR_InformationModifyList_PSCH_ReconfRqst,
        _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_pDSCH_ID,
        _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR,
        ____DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst,
        DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _DL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionPeriod,
        _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionLength,
        _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_dL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst,
        ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions,
        PDSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst,
        PDSCH_ModifyInformation_768_ModifyListIE_PSCH_ReconfRqst_ExtIEs,
        _DL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst__item_,
        DL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst,
        _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_timeSlot,
        _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence,
        _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_dL_Code_768_InformationModifyList_PSCH_ReconfRqst,
        ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst,
        DL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _DL_Code_768_InformationModifyList_PSCH_ReconfRqst__item_,
        DL_Code_768_InformationModifyList_PSCH_ReconfRqst,
        _DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_pDSCH_ID768,
        _DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode768,
        ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        DL_Code_768_InformationModifyItem_PSCH_ReconfRqst,
        DL_Code_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _PDSCHSets_DeleteList_PSCH_ReconfRqst__item_,
        PDSCHSets_DeleteList_PSCH_ReconfRqst,
        _PDSCHSets_DeleteItem_PSCH_ReconfRqst_pDSCHSet_ID,
        ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PDSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions,
        PDSCHSets_DeleteItem_PSCH_ReconfRqst,
        PDSCHSets_DeleteItem_PSCH_ReconfRqst_ExtIEs,
        _PUSCHSets_AddList_PSCH_ReconfRqst__item_,
        PUSCHSets_AddList_PSCH_ReconfRqst,
        _PUSCHSets_AddItem_PSCH_ReconfRqst_pUSCHSet_ID,
        _PUSCHSets_AddItem_PSCH_ReconfRqst_pUSCH_InformationList,
        ____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1,
        ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PUSCHSets_AddItem_PSCH_ReconfRqst_iE_Extensions,
        PUSCHSets_AddItem_PSCH_ReconfRqst,
        PUSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs,
        _PUSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _PUSCHSets_AddItem_PSCH_ReconfRqst_ExtIEs_val_Extension_1,
        __PUSCH_Information_AddList_PSCH_ReconfRqst_id_tab,
        ___PUSCH_Information_AddList_PSCH_ReconfRqst_id_tab_val_Value_0,
        _PUSCH_Information_AddList_PSCH_ReconfRqst_id,
        _PUSCH_Information_AddList_PSCH_ReconfRqst_criticality,
        _PUSCH_Information_AddList_PSCH_ReconfRqst_value,
        PUSCH_Information_AddList_PSCH_ReconfRqst,
        PUSCH_Information_AddListIEs_PSCH_ReconfRqst,
        _PUSCH_Information_AddListIEs_PSCH_ReconfRqst_val_Value_0,
        _PUSCH_Information_AddItem_PSCH_ReconfRqst_repetitionPeriod,
        _PUSCH_Information_AddItem_PSCH_ReconfRqst_repetitionLength,
        _PUSCH_Information_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PUSCH_Information_AddItem_PSCH_ReconfRqst_uL_Timeslot_InformationAddList_PSCH_ReconfRqst,
        ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PUSCH_Information_AddItem_PSCH_ReconfRqst_iE_Extensions,
        PUSCH_Information_AddItem_PSCH_ReconfRqst,
        PUSCH_Information_AddItem_PSCH_ReconfRqst_ExtIEs,
        _UL_Timeslot_InformationAddList_PSCH_ReconfRqst__item_,
        UL_Timeslot_InformationAddList_PSCH_ReconfRqst,
        _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_timeSlot,
        _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_tFCI_Presence,
        _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_uL_Code_InformationAddList_PSCH_ReconfRqst,
        ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_iE_Extensions,
        UL_Timeslot_InformationAddItem_PSCH_ReconfRqst,
        UL_Timeslot_InformationAddItem_PSCH_ReconfRqst_ExtIEs,
        _UL_Code_InformationAddList_PSCH_ReconfRqst__item_,
        UL_Code_InformationAddList_PSCH_ReconfRqst,
        _UL_Code_InformationAddItem_PSCH_ReconfRqst_pUSCH_ID,
        _UL_Code_InformationAddItem_PSCH_ReconfRqst_tdd_ChannelisationCode,
        ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Code_InformationAddItem_PSCH_ReconfRqst_iE_Extensions,
        UL_Code_InformationAddItem_PSCH_ReconfRqst,
        UL_Code_InformationAddItem_PSCH_ReconfRqst_ExtIEs,
        _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionPeriod,
        _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_repetitionLength,
        _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_uL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst,
        ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_iE_Extensions,
        PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst,
        PUSCH_AddInformation_LCR_AddItem_PSCH_ReconfRqst_ExtIEs,
        _UL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst__item_,
        UL_Timeslot_InformationAddList_LCR_PSCH_ReconfRqst,
        _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_timeSlotLCR,
        _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_midambleShiftLCR,
        _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_tFCI_Presence,
        _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_uL_Code_InformationAddList_LCR_PSCH_ReconfRqst,
        ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst,
        UL_Timeslot_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs,
        _UL_Code_InformationAddList_LCR_PSCH_ReconfRqst__item_,
        UL_Code_InformationAddList_LCR_PSCH_ReconfRqst,
        _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_pUSCH_ID,
        _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR,
        ____UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst,
        UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs,
        _UL_Code_InformationAddItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionPeriod,
        _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_repetitionLength,
        _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_uL_Timeslot_InformationAddList_768_PSCH_ReconfRqst,
        ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_iE_Extensions,
        PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst,
        PUSCH_AddInformation_768_AddItem_PSCH_ReconfRqst_ExtIEs,
        _UL_Timeslot_InformationAddList_768_PSCH_ReconfRqst__item_,
        UL_Timeslot_InformationAddList_768_PSCH_ReconfRqst,
        _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_timeSlot,
        _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_tFCI_Presence,
        _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_uL_Code_InformationAddList_768_PSCH_ReconfRqst,
        ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions,
        UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst,
        UL_Timeslot_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs,
        _UL_Code_InformationAddList_768_PSCH_ReconfRqst__item_,
        UL_Code_InformationAddList_768_PSCH_ReconfRqst,
        _UL_Code_InformationAddItem_768_PSCH_ReconfRqst_pUSCH_ID,
        _UL_Code_InformationAddItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768,
        ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Code_InformationAddItem_768_PSCH_ReconfRqst_iE_Extensions,
        UL_Code_InformationAddItem_768_PSCH_ReconfRqst,
        UL_Code_InformationAddItem_768_PSCH_ReconfRqst_ExtIEs,
        _PUSCHSets_ModifyList_PSCH_ReconfRqst__item_,
        PUSCHSets_ModifyList_PSCH_ReconfRqst,
        _PUSCHSets_ModifyItem_PSCH_ReconfRqst_pUSCHSet_ID,
        _PUSCHSets_ModifyItem_PSCH_ReconfRqst_pUSCH_InformationList,
        ____PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PUSCHSets_ModifyItem_PSCH_ReconfRqst_iE_Extensions,
        PUSCHSets_ModifyItem_PSCH_ReconfRqst,
        PUSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs,
        _PUSCHSets_ModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        __PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab,
        ___PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_0,
        ___PUSCH_Information_ModifyList_PSCH_ReconfRqst_id_tab_val_Value_1,
        _PUSCH_Information_ModifyList_PSCH_ReconfRqst_id,
        _PUSCH_Information_ModifyList_PSCH_ReconfRqst_criticality,
        _PUSCH_Information_ModifyList_PSCH_ReconfRqst_value,
        PUSCH_Information_ModifyList_PSCH_ReconfRqst,
        PUSCH_Information_ModifyListIEs_PSCH_ReconfRqst,
        _PUSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_0,
        _PUSCH_Information_ModifyListIEs_PSCH_ReconfRqst_val_Value_1,
        _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionPeriod,
        _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_repetitionLength,
        _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_uL_Timeslot_InformationModifyList_PSCH_ReconfRqst,
        ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PUSCH_Information_ModifyItem_PSCH_ReconfRqst_iE_Extensions,
        PUSCH_Information_ModifyItem_PSCH_ReconfRqst,
        PUSCH_Information_ModifyItem_PSCH_ReconfRqst_ExtIEs,
        _UL_Timeslot_InformationModifyList_PSCH_ReconfRqst__item_,
        UL_Timeslot_InformationModifyList_PSCH_ReconfRqst,
        _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_timeSlot,
        _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence,
        _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_uL_Code_InformationModifyList_PSCH_ReconfRqst,
        ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst,
        UL_Timeslot_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _UL_Code_InformationModifyList_PSCH_ReconfRqst__item_,
        UL_Code_InformationModifyList_PSCH_ReconfRqst,
        _UL_Code_InformationModifyItem_PSCH_ReconfRqst_pUSCH_ID,
        _UL_Code_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode,
        ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Code_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        UL_Code_InformationModifyItem_PSCH_ReconfRqst,
        UL_Code_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionPeriod,
        _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_repetitionLength,
        _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_uL_Timeslot_InformationModifyList_LCR_PSCH_ReconfRqst,
        ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_iE_Extensions,
        PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst,
        PUSCH_ModifyInformation_LCR_ModifyItem_PSCH_ReconfRqst_ExtIEs,
        _UL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst__item_,
        UL_Timeslot_LCR_InformationModifyList_PSCH_ReconfRqst,
        _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_timeSlotLCR,
        _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_midambleShiftLCR,
        _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence,
        _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_uL_Code_LCR_InformationModifyList_PSCH_ReconfRqst,
        ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst,
        UL_Timeslot_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _UL_Code_LCR_InformationModifyList_PSCH_ReconfRqst__item_,
        UL_Code_LCR_InformationModifyList_PSCH_ReconfRqst,
        _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_pUSCH_ID,
        _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCodeLCR,
        ____UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst,
        UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _UL_Code_LCR_InformationModifyItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionPeriod,
        _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_repetitionLength,
        _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_tdd_PhysicalChannelOffset,
        _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_uL_Timeslot_InformationModifyList_768_PSCH_ReconfRqst,
        ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_iE_Extensions,
        PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst,
        PUSCH_ModifyInformation_768_ModifyItem_PSCH_ReconfRqst_ExtIEs,
        _UL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst__item_,
        UL_Timeslot_768_InformationModifyList_PSCH_ReconfRqst,
        _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_timeSlot,
        _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_tFCI_Presence,
        _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_uL_Code_768_InformationModifyList_PSCH_ReconfRqst,
        ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst,
        UL_Timeslot_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _UL_Code_768_InformationModifyList_PSCH_ReconfRqst__item_,
        UL_Code_768_InformationModifyList_PSCH_ReconfRqst,
        _UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_pUSCH_ID,
        _UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode768,
        ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        UL_Code_768_InformationModifyItem_PSCH_ReconfRqst,
        UL_Code_768_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _PUSCHSets_DeleteList_PSCH_ReconfRqst__item_,
        PUSCHSets_DeleteList_PSCH_ReconfRqst,
        _PUSCHSets_DeleteItem_PSCH_ReconfRqst_pUSCHSet_ID,
        ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _PUSCHSets_DeleteItem_PSCH_ReconfRqst_iE_Extensions,
        PUSCHSets_DeleteItem_PSCH_ReconfRqst,
        PUSCHSets_DeleteItem_PSCH_ReconfRqst_ExtIEs,
        _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_dL_HS_PDSCH_Timeslot_Information_PSCH_ReconfRqst,
        _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst,
        ____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1,
        _____HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_2,
        ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_iE_Extensions,
        HS_PDSCH_TDD_Information_PSCH_ReconfRqst,
        HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs,
        _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs_val_Extension_1,
        _HS_PDSCH_TDD_Information_PSCH_ReconfRqst_ExtIEs_val_Extension_2,
        _DL_HS_PDSCH_Timeslot_Information_PSCH_ReconfRqst__item_,
        DL_HS_PDSCH_Timeslot_Information_PSCH_ReconfRqst,
        _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_timeSlot,
        _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_dl_HS_PDSCH_Codelist_PSCH_ReconfRqst,
        _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_maxHSDSCH_HSSCCH_Power,
        ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_iE_Extensions,
        DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst,
        DL_HS_PDSCH_Timeslot_InformationItem_PSCH_ReconfRqst_ExtIEs,
        _DL_HS_PDSCH_Codelist_PSCH_ReconfRqst__item_,
        DL_HS_PDSCH_Codelist_PSCH_ReconfRqst,
        _DL_HS_PDSCH_Timeslot_Information_768_PSCH_ReconfRqst__item_,
        DL_HS_PDSCH_Timeslot_Information_768_PSCH_ReconfRqst,
        _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_timeSlot,
        _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_dl_HS_PDSCH_Codelist_768_PSCH_ReconfRqst,
        _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_maxHSDSCH_HSSCCH_Power,
        ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_iE_Extensions,
        DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst,
        DL_HS_PDSCH_Timeslot_InformationItem_768_PSCH_ReconfRqst_ExtIEs,
        _DL_HS_PDSCH_Codelist_768_PSCH_ReconfRqst__item_,
        DL_HS_PDSCH_Codelist_768_PSCH_ReconfRqst,
        ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id_tab,
        ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id_tab_val_Value_0,
        __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__id,
        __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__criticality,
        __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item__value,
        _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst__item_,
        MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst,
        MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItemIE_PSCH_ReconfRqst,
        _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItemIE_PSCH_ReconfRqst_val_Value_0,
        _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_dL_HS_PDSCH_Timeslot_Information_LCR_PSCH_ReconfRqst,
        _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_uARFCN,
        ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions,
        MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst,
        MultipleFreq_DL_HS_PDSCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_ExtIEs,
        _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_Information_PSCH_ReconfRqst,
        _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_Information_LCR_PSCH_ReconfRqst,
        ____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1,
        ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_,
        _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions,
        Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst,
        Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs,
        _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _Add_To_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_1,
        _HS_SCCH_Information_PSCH_ReconfRqst__item_,
        HS_SCCH_Information_PSCH_ReconfRqst,
        _HS_SCCH_InformationItem_PSCH_ReconfRqst_hS_SCCH_ID,
        _HS_SCCH_InformationItem_PSCH_ReconfRqst_timeSlot,
        _HS_SCCH_InformationItem_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _HS_SCCH_InformationItem_PSCH_ReconfRqst_tdd_ChannelisationCode,
        _HS_SCCH_InformationItem_PSCH_ReconfRqst_hS_SCCH_MaxPower,
        _HS_SCCH_InformationItem_PSCH_ReconfRqst_hS_SICH_Information,
        ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SCCH_InformationItem_PSCH_ReconfRqst_iE_Extensions,
        HS_SCCH_InformationItem_PSCH_ReconfRqst,
        HS_SCCH_InformationItem_PSCH_ReconfRqst_ExtIEs,
        _HS_SICH_Information_PSCH_ReconfRqst_hsSICH_ID,
        _HS_SICH_Information_PSCH_ReconfRqst_timeSlot,
        _HS_SICH_Information_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _HS_SICH_Information_PSCH_ReconfRqst_tdd_ChannelisationCode,
        ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SICH_Information_PSCH_ReconfRqst_iE_Extensions,
        HS_SICH_Information_PSCH_ReconfRqst,
        HS_SICH_Information_PSCH_ReconfRqst_ExtIEs,
        _HS_SCCH_Information_LCR_PSCH_ReconfRqst__item_,
        HS_SCCH_Information_LCR_PSCH_ReconfRqst,
        _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_hS_SCCH_ID,
        _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_timeSlotLCR,
        _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftLCR,
        _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode,
        _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode,
        _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_hS_SCCH_MaxPower,
        _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_hS_SICH_Information_LCR,
        ____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1,
        _____HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_2,
        ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst,
        HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs,
        _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1,
        _HS_SCCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_2,
        _HS_SICH_Information_LCR_PSCH_ReconfRqst_hsSICH_ID,
        _HS_SICH_Information_LCR_PSCH_ReconfRqst_timeSlotLCR,
        _HS_SICH_Information_LCR_PSCH_ReconfRqst_midambleShiftLCR,
        _HS_SICH_Information_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode,
        ____HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SICH_Information_LCR_PSCH_ReconfRqst_iE_Extensions,
        HS_SICH_Information_LCR_PSCH_ReconfRqst,
        HS_SICH_Information_LCR_PSCH_ReconfRqst_ExtIEs,
        _HS_SICH_Information_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _HS_SCCH_Information_768_PSCH_ReconfRqst__item_,
        HS_SCCH_Information_768_PSCH_ReconfRqst,
        _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_hS_SCCH_ID,
        _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_timeSlot,
        _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768,
        _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_hS_SCCH_MaxPower,
        _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_hS_SICH_Information_768,
        ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SCCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions,
        HS_SCCH_InformationItem_768_PSCH_ReconfRqst,
        HS_SCCH_InformationItem_768_PSCH_ReconfRqst_ExtIEs,
        _HS_SICH_Information_768_PSCH_ReconfRqst_hsSICH_ID,
        _HS_SICH_Information_768_PSCH_ReconfRqst_timeSlot,
        _HS_SICH_Information_768_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _HS_SICH_Information_768_PSCH_ReconfRqst_tdd_ChannelisationCode768,
        ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SICH_Information_768_PSCH_ReconfRqst_iE_Extensions,
        HS_SICH_Information_768_PSCH_ReconfRqst,
        HS_SICH_Information_768_PSCH_ReconfRqst_ExtIEs,
        _HS_SCCH_InformationExt_LCR_PSCH_ReconfRqst__item_,
        HS_SCCH_InformationExt_LCR_PSCH_ReconfRqst,
        _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_InformationModify_PSCH_ReconfRqst,
        _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_hS_SCCH_InformationModify_LCR_PSCH_ReconfRqst,
        ____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1,
        ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_,
        _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions,
        Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst,
        Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs,
        _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _Modify_HS_SCCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs_val_Extension_1,
        _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_hS_SCCH_ID,
        _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_timeSlot,
        _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode,
        _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_hS_SCCH_MaxPower,
        _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_hS_SICH_Information,
        ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        HS_SCCH_InformationModifyItem_PSCH_ReconfRqst,
        HS_SCCH_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _HS_SICH_InformationModify_PSCH_ReconfRqst_hsSICH_ID,
        _HS_SICH_InformationModify_PSCH_ReconfRqst_timeSlot,
        _HS_SICH_InformationModify_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _HS_SICH_InformationModify_PSCH_ReconfRqst_tdd_ChannelisationCode,
        ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SICH_InformationModify_PSCH_ReconfRqst_iE_Extensions,
        HS_SICH_InformationModify_PSCH_ReconfRqst,
        HS_SICH_InformationModify_PSCH_ReconfRqst_ExtIEs,
        _HS_SCCH_InformationModify_LCR_PSCH_ReconfRqst__item_,
        HS_SCCH_InformationModify_LCR_PSCH_ReconfRqst,
        _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_hS_SCCH_ID,
        _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_timeSlotLCR,
        _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_midambleShiftLCR,
        _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode,
        _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode,
        _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_hS_SCCH_MaxPower,
        _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_hS_SICH_Information_LCR,
        ____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1,
        _____HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_2,
        ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst,
        HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs,
        _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1,
        _HS_SCCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_2,
        _HS_SCCH_InformationModifyExt_LCR_PSCH_ReconfRqst__item_,
        HS_SCCH_InformationModifyExt_LCR_PSCH_ReconfRqst,
        _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_hsSICH_ID,
        _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_timeSlotLCR,
        _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_midambleShiftLCR,
        _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode,
        ____HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_iE_Extensions,
        HS_SICH_InformationModify_LCR_PSCH_ReconfRqst,
        HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_ExtIEs,
        _HS_SICH_InformationModify_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _HS_SCCH_InformationModify_768_PSCH_ReconfRqst__item_,
        HS_SCCH_InformationModify_768_PSCH_ReconfRqst,
        _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_hS_SCCH_ID,
        _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_timeSlot,
        _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768,
        _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_hS_SCCH_MaxPower,
        _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_hS_SICH_Information_768,
        ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions,
        HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst,
        HS_SCCH_InformationModifyItem_768_PSCH_ReconfRqst_ExtIEs,
        _HS_SICH_InformationModify_768_PSCH_ReconfRqst_hsSICH_ID,
        _HS_SICH_InformationModify_768_PSCH_ReconfRqst_timeSlot,
        _HS_SICH_InformationModify_768_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _HS_SICH_InformationModify_768_PSCH_ReconfRqst_tdd_ChannelisationCode768,
        ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _HS_SICH_InformationModify_768_PSCH_ReconfRqst_iE_Extensions,
        HS_SICH_InformationModify_768_PSCH_ReconfRqst,
        HS_SICH_InformationModify_768_PSCH_ReconfRqst_ExtIEs,
        _HS_SCCH_InformationModify_PSCH_ReconfRqst__item_,
        HS_SCCH_InformationModify_PSCH_ReconfRqst,
        _Delete_From_HS_SCCH_Resource_Pool_PSCH_ReconfRqst__item_,
        Delete_From_HS_SCCH_Resource_Pool_PSCH_ReconfRqst,
        _Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_hS_SCCH_ID,
        ____Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions,
        Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst,
        Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs,
        _Delete_From_HS_SCCH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _E_PUCH_Information_PSCH_ReconfRqst_lTGI_Presence,
        _E_PUCH_Information_PSCH_ReconfRqst_sNPL_Reporting_Type,
        _E_PUCH_Information_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _E_PUCH_Information_PSCH_ReconfRqst_e_PUCH_Timeslot_Info,
        ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_PUCH_Information_PSCH_ReconfRqst_iE_Extensions,
        E_PUCH_Information_PSCH_ReconfRqst,
        E_PUCH_Information_PSCH_ReconfRqst_ExtIEs,
        _E_PUCH_Timeslot_Info__item_,
        E_PUCH_Timeslot_Info,
        _Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_e_AGCH_Information_PSCH_ReconfRqst,
        ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_,
        _Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions,
        Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst,
        Add_To_E_AGCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs,
        _E_AGCH_Information_PSCH_ReconfRqst__item_,
        E_AGCH_Information_PSCH_ReconfRqst,
        _E_AGCH_InformationItem_PSCH_ReconfRqst_e_AGCH_ID,
        _E_AGCH_InformationItem_PSCH_ReconfRqst_timeSlot,
        _E_AGCH_InformationItem_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _E_AGCH_InformationItem_PSCH_ReconfRqst_tdd_ChannelisationCode,
        _E_AGCH_InformationItem_PSCH_ReconfRqst_e_AGCH_MaxPower,
        ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_AGCH_InformationItem_PSCH_ReconfRqst_iE_Extensions,
        E_AGCH_InformationItem_PSCH_ReconfRqst,
        E_AGCH_InformationItem_PSCH_ReconfRqst_ExtIEs,
        _Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_e_AGCH_InformationModify_PSCH_ReconfRqst,
        ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions__item_,
        _Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_iE_Extensions,
        Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst,
        Modify_E_AGCH_Resource_Pool_PSCH_ReconfRqst_ExtIEs,
        _E_AGCH_InformationModify_PSCH_ReconfRqst__item_,
        E_AGCH_InformationModify_PSCH_ReconfRqst,
        _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_e_AGCH_ID,
        _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_timeSlot,
        _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_tdd_ChannelisationCode,
        _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_e_AGCH_MaxPower,
        ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_AGCH_InformationModifyItem_PSCH_ReconfRqst_iE_Extensions,
        E_AGCH_InformationModifyItem_PSCH_ReconfRqst,
        E_AGCH_InformationModifyItem_PSCH_ReconfRqst_ExtIEs,
        _Delete_From_E_AGCH_Resource_Pool_PSCH_ReconfRqst__item_,
        Delete_From_E_AGCH_Resource_Pool_PSCH_ReconfRqst,
        _Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_e_AGCH_ID,
        ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions,
        Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst,
        Delete_From_E_AGCH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs,
        _E_HICH_Information_PSCH_ReconfRqst_midambleShiftAndBurstType,
        _E_HICH_Information_PSCH_ReconfRqst_tdd_ChannelisationCode,
        _E_HICH_Information_PSCH_ReconfRqst_e_HICH_MaxPower,
        ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_HICH_Information_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_HICH_Information_PSCH_ReconfRqst_iE_Extensions,
        E_HICH_Information_PSCH_ReconfRqst,
        E_HICH_Information_PSCH_ReconfRqst_ExtIEs,
        _E_PUCH_Information_768_PSCH_ReconfRqst_lTGI_Presence,
        _E_PUCH_Information_768_PSCH_ReconfRqst_sNPL_Reporting_Type,
        _E_PUCH_Information_768_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _E_PUCH_Information_768_PSCH_ReconfRqst_e_PUCH_Timeslot_Info,
        ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_PUCH_Information_768_PSCH_ReconfRqst_iE_Extensions,
        E_PUCH_Information_768_PSCH_ReconfRqst,
        E_PUCH_Information_768_PSCH_ReconfRqst_ExtIEs,
        _Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_e_AGCH_Information_768_PSCH_ReconfRqst,
        ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions,
        Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst,
        Add_To_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_ExtIEs,
        _E_AGCH_Information_768_PSCH_ReconfRqst__item_,
        E_AGCH_Information_768_PSCH_ReconfRqst,
        _E_AGCH_InformationItem_768_PSCH_ReconfRqst_e_AGCH_ID,
        _E_AGCH_InformationItem_768_PSCH_ReconfRqst_timeSlot,
        _E_AGCH_InformationItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _E_AGCH_InformationItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768,
        _E_AGCH_InformationItem_768_PSCH_ReconfRqst_e_AGCH_MaxPower,
        ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_AGCH_InformationItem_768_PSCH_ReconfRqst_iE_Extensions,
        E_AGCH_InformationItem_768_PSCH_ReconfRqst,
        E_AGCH_InformationItem_768_PSCH_ReconfRqst_ExtIEs,
        _Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_e_AGCH_InformationModify_768_PSCH_ReconfRqst,
        ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_iE_Extensions,
        Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst,
        Modify_E_AGCH_Resource_Pool_768_PSCH_ReconfRqst_ExtIEs,
        _E_AGCH_InformationModify_768_PSCH_ReconfRqst__item_,
        E_AGCH_InformationModify_768_PSCH_ReconfRqst,
        _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_e_AGCH_ID,
        _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_timeSlot,
        _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_tdd_ChannelisationCode768,
        _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_e_AGCH_MaxPower,
        ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_iE_Extensions,
        E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst,
        E_AGCH_InformationModifyItem_768_PSCH_ReconfRqst_ExtIEs,
        _E_HICH_Information_768_PSCH_ReconfRqst_midambleShiftAndBurstType768,
        _E_HICH_Information_768_PSCH_ReconfRqst_tdd_ChannelisationCode768,
        _E_HICH_Information_768_PSCH_ReconfRqst_e_HICH_MaxPower,
        ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_HICH_Information_768_PSCH_ReconfRqst_iE_Extensions,
        E_HICH_Information_768_PSCH_ReconfRqst,
        E_HICH_Information_768_PSCH_ReconfRqst_ExtIEs,
        _E_PUCH_Information_LCR_PSCH_ReconfRqst_lTGI_Presence,
        _E_PUCH_Information_LCR_PSCH_ReconfRqst_sNPL_Reporting_Type,
        _E_PUCH_Information_LCR_PSCH_ReconfRqst_e_PUCH_Timeslot_InfoLCR,
        ____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_PUCH_Information_LCR_PSCH_ReconfRqst_iE_Extensions,
        E_PUCH_Information_LCR_PSCH_ReconfRqst,
        E_PUCH_Information_LCR_PSCH_ReconfRqst_ExtIEs,
        _E_PUCH_Information_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _E_PUCH_Information_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1,
        _E_PUCH_Timeslot_InfoLCR__item_,
        E_PUCH_Timeslot_InfoLCR,
        _E_PUCH_Timeslot_Item_InfoLCR_timeSlot,
        _E_PUCH_Timeslot_Item_InfoLCR_midambleShiftAndBurstType,
        _E_PUCH_Timeslot_Item_InfoLCR_e_PUCH_Codelist_LCR,
        ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__id_tab,
        ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__id,
        ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__criticality_tab,
        ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__criticality,
        ____E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__extensionValue_tab,
        ___E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item__extensionValue,
        __E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions__item_,
        _E_PUCH_Timeslot_Item_InfoLCR_iE_Extensions,
        E_PUCH_Timeslot_Item_InfoLCR,
        E_PUCH_Timeslot_Item_InfoLCR_ExtIEs,
        _E_PUCH_Codelist_LCR__item_,
        E_PUCH_Codelist_LCR,
        _Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_e_AGCH_Information_LCR_PSCH_ReconfRqst,
        ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions,
        Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst,
        Add_To_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs,
        _E_AGCH_Information_LCR_PSCH_ReconfRqst__item_,
        E_AGCH_Information_LCR_PSCH_ReconfRqst,
        _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_e_AGCH_ID,
        _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_timeSlotLCR,
        _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftLCR,
        _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode,
        _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode,
        _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_e_AGCH_MaxPower,
        ____E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        E_AGCH_InformationItem_LCR_PSCH_ReconfRqst,
        E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs,
        _E_AGCH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_e_AGCH_InformationModify_LCR_PSCH_ReconfRqst,
        ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions,
        Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst,
        Modify_E_AGCH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs,
        _E_AGCH_InformationModify_LCR_PSCH_ReconfRqst__item_,
        E_AGCH_InformationModify_LCR_PSCH_ReconfRqst,
        _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_AGCH_ID,
        _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_timeSlotLCR,
        _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_midambleShiftLCR,
        _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_first_TDD_ChannelisationCode,
        _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_second_TDD_ChannelisationCode,
        _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_AGCH_MaxPower,
        ____E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst,
        E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs,
        _E_AGCH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_e_HICH_Information_LCR_PSCH_ReconfRqst,
        ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions,
        Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst,
        Add_To_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs,
        _E_HICH_Information_LCR_PSCH_ReconfRqst__item_,
        E_HICH_Information_LCR_PSCH_ReconfRqst,
        _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_e_HICH_ID_TDD,
        _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_e_HICH_Type,
        _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode,
        _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_timeSlotLCR,
        _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_midambleShiftLCR,
        _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_e_HICH_MaxPower,
        ____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        E_HICH_InformationItem_LCR_PSCH_ReconfRqst,
        E_HICH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs,
        _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _E_HICH_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1,
        _Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_e_HICH_InformationModify_LCR_PSCH_ReconfRqst,
        ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_iE_Extensions,
        Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst,
        Modify_E_HICH_Resource_Pool_LCR_PSCH_ReconfRqst_ExtIEs,
        _E_HICH_InformationModify_LCR_PSCH_ReconfRqst__item_,
        E_HICH_InformationModify_LCR_PSCH_ReconfRqst,
        _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_HICH_ID_TDD,
        _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_HICH_Type,
        _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_tdd_ChannelisationCode,
        _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_timeSlotLCR,
        _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_midambleShiftLCR,
        _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_e_HICH_MaxPower,
        ____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst,
        E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs,
        _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _E_HICH_InformationModifyItem_LCR_PSCH_ReconfRqst_ExtIEs_val_Extension_1,
        _Delete_From_E_HICH_Resource_Pool_PSCH_ReconfRqst__item_,
        Delete_From_E_HICH_Resource_Pool_PSCH_ReconfRqst,
        _Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_e_HICH_ID_TDD,
        ____Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        _____Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab_val_Extension_0,
        ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ___Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_iE_Extensions,
        Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst,
        Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs,
        _Delete_From_E_HICH_Resource_PoolItem_PSCH_ReconfRqst_ExtIEs_val_Extension_0,
        _SYNC_UL_Partition_LCR_eRUCCH_SYNC_UL_codes_bitmap,
        ____SYNC_UL_Partition_LCR_iE_Extensions__item__id_tab,
        ___SYNC_UL_Partition_LCR_iE_Extensions__item__id,
        ____SYNC_UL_Partition_LCR_iE_Extensions__item__criticality_tab,
        ___SYNC_UL_Partition_LCR_iE_Extensions__item__criticality,
        ____SYNC_UL_Partition_LCR_iE_Extensions__item__extensionValue_tab,
        ___SYNC_UL_Partition_LCR_iE_Extensions__item__extensionValue,
        __SYNC_UL_Partition_LCR_iE_Extensions__item_,
        _SYNC_UL_Partition_LCR_iE_Extensions,
        SYNC_UL_Partition_LCR,
        SYNC_UL_Partition_LCR_ExtIEs,
        _Delete_From_HS_SCCH_Resource_PoolExt_PSCH_ReconfRqst__item_,
        Delete_From_HS_SCCH_Resource_PoolExt_PSCH_ReconfRqst,
        ___MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id_tab,
        ____MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id_tab_val_Value_0,
        __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__id,
        __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__criticality,
        __MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item__value,
        _MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst__item_,
        MultipleFreq_E_PUCH_Timeslot_InformationList_LCR_PSCH_ReconfRqst,
        MultipleFreq_E_PUCH_Timeslot_InformationItemIE_LCR_PSCH_ReconfRqst,
        _MultipleFreq_E_PUCH_Timeslot_InformationItemIE_LCR_PSCH_ReconfRqst_val_Value_0,
        _MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_e_PUCH_Timeslot_InfoLCR,
        _MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_uARFCN,
        ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions__item_,
        _MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_iE_Extensions,
        MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst,
        MultipleFreq_E_PUCH_Timeslot_Information_LCRItem_PSCH_ReconfRqst_ExtIEs,
        _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst__item_,
        Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst,
        _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_uARFCN,
        _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_maximum_Target_ReceivedTotalWideBandPower_LCR,
        ____Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id_tab,
        _____Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__id,
        ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__criticality,
        ___Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item__extensionValue,
        __Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions__item_,
        _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_iE_Extensions,
        Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item,
        Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_ExtIEs,
        _Max_RTWP_perUARFCN_Information_LCR_PSCH_ReconfRqst_Item_ExtIEs_val_Extension_0,
        _Max_RTWP_perCellPortion_InformationList_LCR_PSCH_ReconfRqst__item_,
        Max_RTWP_perCellPortion_InformationList_LCR_PSCH_ReconfRqst,
        _Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_cellPortionLCRID,
        _Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_maximum_Target_ReceivedTotalWideBandPower_LCR,
        ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id_tab,
        ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__id,
        ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality_tab,
        ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__criticality,
        ____Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue_tab,
        ___Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item__extensionValue,
        __Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions__item_,
        _Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_iE_Extensions,
        Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst,
        Max_RTWP_perCellPortion_InformationItem_LCR_PSCH_ReconfRqst_ExtIEs,
        ____PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id_tab,
        _____PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id_tab_val_Value_0,
        ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__id,
        ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__criticality,
        ___PhysicalSharedChannelReconfigurationResponse_protocolIEs__item__value,
        __PhysicalSharedChannelReconfigurationResponse_protocolIEs__item_,
        _PhysicalSharedChannelReconfigurationResponse_protocolIEs,
        ____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab,
        _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_0,
        _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_1,
        _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_2,
        _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_3,
        _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_4,
        _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_5,
        _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_6,
        _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_7,
        _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_8,
        _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_9,
        _____PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id_tab_val_Extension_10,
        ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__id,
        ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__criticality,
        ___PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item__extensionValue,
        __PhysicalSharedChannelReconfigurationResponse_protocolExtensions__item_,
        _PhysicalSharedChannelReconfigurationResponse_protocolExtensions,
        PhysicalSharedChannelReconfigurationResponse,
        PhysicalSharedChannelReconfigurationResponse_IEs,
        _PhysicalSharedChannelReconfigurationResponse_IEs_val_Value_0,
        PhysicalSharedChannelReconfigurationResponse_Extensions,
        _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_0,
        _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_1,
        _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_2,
        _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_3,
        _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_4,
        _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_5,
        _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_6,
        _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_7,
        _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_8,
        _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_9,
        _PhysicalSharedChannelReconfigurationResponse_Extensions_val_Extension_10,
        ___E_HICH_TimeOffset_ExtensionLCR__item__id_tab,
        ____E_HICH_TimeOffset_ExtensionLCR__item__id_tab_val_Value_0,
        __E_HICH_TimeOffset_ExtensionLCR__item__id,
        __E_HICH_TimeOffset_ExtensionLCR__item__criticality,
        __E_HICH_TimeOffset_ExtensionLCR__item__value,
        _E_HICH_TimeOffset_ExtensionLCR__item_,
        E_HICH_TimeOffset_ExtensionLCR,
        Multiple_E_HICH_TimeOffsetLCR,
        _Multiple_E_HICH_TimeOffsetLCR_val_Value_0,
        _MultipleFreq_E_HICH_TimeOffsetLCR_e_HICH_TimeOffsetLCR,
        _MultipleFreq_E_HICH_TimeOffsetLCR_uARFCN,
        ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__id_tab,
        ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__id,
        ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__criticality_tab,
        ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__criticality,
        ____MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__extensionValue_tab,
        ___MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item__extensionValue,
        __MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions__item_,
        _MultipleFreq_E_HICH_TimeOffsetLCR_iE_Extensions,
        MultipleFreq_E_HICH_TimeOffsetLCR,
        MultipleFreq_E_HICH_TimeOffsetLCR_ExtIEs,
        ____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab,
        _____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__id,
        ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__criticality,
        ___PhysicalSharedChannelReconfigurationFailure_protocolIEs__item__value,
        __PhysicalSharedChannelReconfigurationFailure_protocolIEs__item_,
        _PhysicalSharedChannelReconfigurationFailure_protocolIEs,
        ____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab,
        _____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab_val_Extension_0,
        _____PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id_tab_val_Extension_1,
        ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__id,
        ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__criticality,
        ___PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item__extensionValue,
        __PhysicalSharedChannelReconfigurationFailure_protocolExtensions__item_,
        _PhysicalSharedChannelReconfigurationFailure_protocolExtensions,
        PhysicalSharedChannelReconfigurationFailure,
        PhysicalSharedChannelReconfigurationFailure_IEs,
        _PhysicalSharedChannelReconfigurationFailure_IEs_val_Value_0,
        _PhysicalSharedChannelReconfigurationFailure_IEs_val_Value_1,
        PhysicalSharedChannelReconfigurationFailure_Extensions,
        _PhysicalSharedChannelReconfigurationFailure_Extensions_val_Extension_0,
        _PhysicalSharedChannelReconfigurationFailure_Extensions_val_Extension_1,
        _CauseLevel_PSCH_ReconfFailure_generalCause,
        _CauseLevel_PSCH_ReconfFailure_setSpecificCause,
        _CauseLevel_PSCH_ReconfFailure_extension_CauseLevel_PSCH_ReconfFailure,
        CauseLevel_PSCH_ReconfFailure,
        _GeneralCauseList_PSCH_ReconfFailure_cause,
        ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__id_tab,
        ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__id,
        ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__criticality,
        ____GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item__extensionValue,
        __GeneralCauseList_PSCH_ReconfFailure_iE_Extensions__item_,
        _GeneralCauseList_PSCH_ReconfFailure_iE_Extensions,
        GeneralCauseList_PSCH_ReconfFailure,
        GeneralCauseItem_PSCH_ReconfFailure_ExtIEs,
        _SetSpecificCauseList_PSCH_ReconfFailureTDD_unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD,
        _SetSpecificCauseList_PSCH_ReconfFailureTDD_unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD,
        ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab,
        ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__id,
        ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab,
        ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality,
        ____SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue,
        __SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions__item_,
        _SetSpecificCauseList_PSCH_ReconfFailureTDD_iE_Extensions,
        SetSpecificCauseList_PSCH_ReconfFailureTDD,
        SetSpecificCauseItem_PSCH_ReconfFailureTDD_ExtIEs,
        ___Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id_tab,
        ____Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id_tab_val_Value_0,
        __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__id,
        __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__criticality,
        __Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item__value,
        _Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD__item_,
        Unsuccessful_PDSCHSetList_PSCH_ReconfFailureTDD,
        Unsuccessful_PDSCHSetItemIE_PSCH_ReconfFailureTDD,
        _Unsuccessful_PDSCHSetItemIE_PSCH_ReconfFailureTDD_val_Value_0,
        _Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_pDSCHSet_ID,
        _Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_cause,
        ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab,
        ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id,
        ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab,
        ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality,
        ____Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue,
        __Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item_,
        _Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions,
        Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD,
        Unsuccessful_PDSCHSetItem_PSCH_ReconfFailureTDD_ExtIEs,
        ___Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id_tab,
        ____Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id_tab_val_Value_0,
        __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__id,
        __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__criticality,
        __Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item__value,
        _Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD__item_,
        Unsuccessful_PUSCHSetList_PSCH_ReconfFailureTDD,
        Unsuccessful_PUSCHSetItemIE_PSCH_ReconfFailureTDD,
        _Unsuccessful_PUSCHSetItemIE_PSCH_ReconfFailureTDD_val_Value_0,
        _Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_pUSCHSet_ID,
        _Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_cause,
        ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab,
        ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id,
        ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality_tab,
        ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality,
        ____Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue,
        __Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions__item_,
        _Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_iE_Extensions,
        Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD,
        Unsuccessful_PUSCHSetItem_PSCH_ReconfFailureTDD_ExtIEs,
        __Extension_CauseLevel_PSCH_ReconfFailure_id_tab,
        ___Extension_CauseLevel_PSCH_ReconfFailure_id_tab_val_Value_0,
        _Extension_CauseLevel_PSCH_ReconfFailure_id,
        _Extension_CauseLevel_PSCH_ReconfFailure_criticality,
        _Extension_CauseLevel_PSCH_ReconfFailure_value,
        Extension_CauseLevel_PSCH_ReconfFailure,
        Extension_CauseLevel_PSCH_ReconfFailureIE,
        _Extension_CauseLevel_PSCH_ReconfFailureIE_val_Value_0,
        ___UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id_tab,
        ____UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id_tab_val_Value_0,
        __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__id,
        __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__criticality,
        __UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item__value,
        _UARFCNSpecificCauseList_PSCH_ReconfFailureTDD__item_,
        UARFCNSpecificCauseList_PSCH_ReconfFailureTDD,
        Unsuccessful_UARFCNItemIE_PSCH_ReconfFailureTDD,
        _Unsuccessful_UARFCNItemIE_PSCH_ReconfFailureTDD_val_Value_0,
        _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_uARFCN,
        _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_cause,
        ____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab,
        _____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__id,
        ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__criticality,
        ___Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item__extensionValue,
        __Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions__item_,
        _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_iE_Extensions,
        Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD,
        Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_ExtIEs,
        _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_ExtIEs_val_Extension_0,
        _Unsuccessful_UARFCNItem_PSCH_ReconfFailureTDD_ExtIEs_val_Extension_1,
        ___E_HICH_TimeOffset_ReconfFailureTDD__item__id_tab,
        ____E_HICH_TimeOffset_ReconfFailureTDD__item__id_tab_val_Value_0,
        __E_HICH_TimeOffset_ReconfFailureTDD__item__id,
        __E_HICH_TimeOffset_ReconfFailureTDD__item__criticality,
        __E_HICH_TimeOffset_ReconfFailureTDD__item__value,
        _E_HICH_TimeOffset_ReconfFailureTDD__item_,
        E_HICH_TimeOffset_ReconfFailureTDD,
        _Common_System_Information_ResponseLCR_hSDSCH_Common_System_Information_ResponseLCR,
        _Common_System_Information_ResponseLCR_hSDSCH_Paging_System_Information_ResponseLCR,
        _Common_System_Information_ResponseLCR_common_EDCH_System_Information_ResponseLCR,
        ____Common_System_Information_ResponseLCR_iE_Extensions__item__id_tab,
        ___Common_System_Information_ResponseLCR_iE_Extensions__item__id,
        ____Common_System_Information_ResponseLCR_iE_Extensions__item__criticality_tab,
        ___Common_System_Information_ResponseLCR_iE_Extensions__item__criticality,
        ____Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab,
        ___Common_System_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __Common_System_Information_ResponseLCR_iE_Extensions__item_,
        _Common_System_Information_ResponseLCR_iE_Extensions,
        Common_System_Information_ResponseLCR,
        Common_System_Information_ResponseLCR_ExtIEs,
        ____ResetRequest_protocolIEs__item__id_tab,
        _____ResetRequest_protocolIEs__item__id_tab_val_Value_0,
        ___ResetRequest_protocolIEs__item__id,
        ___ResetRequest_protocolIEs__item__criticality,
        ___ResetRequest_protocolIEs__item__value,
        __ResetRequest_protocolIEs__item_,
        _ResetRequest_protocolIEs,
        ____ResetRequest_protocolExtensions__item__id_tab,
        ___ResetRequest_protocolExtensions__item__id,
        ____ResetRequest_protocolExtensions__item__criticality_tab,
        ___ResetRequest_protocolExtensions__item__criticality,
        ____ResetRequest_protocolExtensions__item__extensionValue_tab,
        ___ResetRequest_protocolExtensions__item__extensionValue,
        __ResetRequest_protocolExtensions__item_,
        _ResetRequest_protocolExtensions,
        ResetRequest,
        ResetRequest_IEs,
        _ResetRequest_IEs_val_Value_0,
        ResetRequest_Extensions,
        _ResetIndicator_communicationContext,
        _ResetIndicator_communicationControlPort,
        _ResetIndicator_nodeB,
        ResetIndicator,
        _CommunicationContextList_Reset_communicationContextInfoList_Reset,
        ____CommunicationContextList_Reset_iE_Extensions__item__id_tab,
        ___CommunicationContextList_Reset_iE_Extensions__item__id,
        ____CommunicationContextList_Reset_iE_Extensions__item__criticality_tab,
        ___CommunicationContextList_Reset_iE_Extensions__item__criticality,
        ____CommunicationContextList_Reset_iE_Extensions__item__extensionValue_tab,
        ___CommunicationContextList_Reset_iE_Extensions__item__extensionValue,
        __CommunicationContextList_Reset_iE_Extensions__item_,
        _CommunicationContextList_Reset_iE_Extensions,
        CommunicationContextList_Reset,
        CommunicationContextItem_Reset_ExtIEs,
        ___CommunicationContextInfoList_Reset__item__id_tab,
        ____CommunicationContextInfoList_Reset__item__id_tab_val_Value_0,
        __CommunicationContextInfoList_Reset__item__id,
        __CommunicationContextInfoList_Reset__item__criticality,
        __CommunicationContextInfoList_Reset__item__value,
        _CommunicationContextInfoList_Reset__item_,
        CommunicationContextInfoList_Reset,
        CommunicationContextInfoItemIE_Reset,
        _CommunicationContextInfoItemIE_Reset_val_Value_0,
        _CommunicationContextInfoItem_Reset_communicationContextType_Reset,
        ____CommunicationContextInfoItem_Reset_iE_Extensions__item__id_tab,
        ___CommunicationContextInfoItem_Reset_iE_Extensions__item__id,
        ____CommunicationContextInfoItem_Reset_iE_Extensions__item__criticality_tab,
        ___CommunicationContextInfoItem_Reset_iE_Extensions__item__criticality,
        ____CommunicationContextInfoItem_Reset_iE_Extensions__item__extensionValue_tab,
        ___CommunicationContextInfoItem_Reset_iE_Extensions__item__extensionValue,
        __CommunicationContextInfoItem_Reset_iE_Extensions__item_,
        _CommunicationContextInfoItem_Reset_iE_Extensions,
        CommunicationContextInfoItem_Reset,
        CommunicationContextInfoItem_Reset_ExtIEs,
        _CommunicationContextType_Reset_cRNC_CommunicationContextID,
        _CommunicationContextType_Reset_nodeB_CommunicationContextID,
        CommunicationContextType_Reset,
        _CommunicationControlPortList_Reset_communicationControlPortInfoList_Reset,
        ____CommunicationControlPortList_Reset_iE_Extensions__item__id_tab,
        ___CommunicationControlPortList_Reset_iE_Extensions__item__id,
        ____CommunicationControlPortList_Reset_iE_Extensions__item__criticality_tab,
        ___CommunicationControlPortList_Reset_iE_Extensions__item__criticality,
        ____CommunicationControlPortList_Reset_iE_Extensions__item__extensionValue_tab,
        ___CommunicationControlPortList_Reset_iE_Extensions__item__extensionValue,
        __CommunicationControlPortList_Reset_iE_Extensions__item_,
        _CommunicationControlPortList_Reset_iE_Extensions,
        CommunicationControlPortList_Reset,
        CommunicationControlPortItem_Reset_ExtIEs,
        ___CommunicationControlPortInfoList_Reset__item__id_tab,
        ____CommunicationControlPortInfoList_Reset__item__id_tab_val_Value_0,
        __CommunicationControlPortInfoList_Reset__item__id,
        __CommunicationControlPortInfoList_Reset__item__criticality,
        __CommunicationControlPortInfoList_Reset__item__value,
        _CommunicationControlPortInfoList_Reset__item_,
        CommunicationControlPortInfoList_Reset,
        CommunicationControlPortInfoItemIE_Reset,
        _CommunicationControlPortInfoItemIE_Reset_val_Value_0,
        _CommunicationControlPortInfoItem_Reset_communicationControlPortID,
        ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__id_tab,
        ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__id,
        ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__criticality_tab,
        ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__criticality,
        ____CommunicationControlPortInfoItem_Reset_iE_Extensions__item__extensionValue_tab,
        ___CommunicationControlPortInfoItem_Reset_iE_Extensions__item__extensionValue,
        __CommunicationControlPortInfoItem_Reset_iE_Extensions__item_,
        _CommunicationControlPortInfoItem_Reset_iE_Extensions,
        CommunicationControlPortInfoItem_Reset,
        CommunicationControlPortInfoItem_Reset_ExtIEs,
        ____ResetResponse_protocolIEs__item__id_tab,
        _____ResetResponse_protocolIEs__item__id_tab_val_Value_0,
        ___ResetResponse_protocolIEs__item__id,
        ___ResetResponse_protocolIEs__item__criticality,
        ___ResetResponse_protocolIEs__item__value,
        __ResetResponse_protocolIEs__item_,
        _ResetResponse_protocolIEs,
        ____ResetResponse_protocolExtensions__item__id_tab,
        ___ResetResponse_protocolExtensions__item__id,
        ____ResetResponse_protocolExtensions__item__criticality_tab,
        ___ResetResponse_protocolExtensions__item__criticality,
        ____ResetResponse_protocolExtensions__item__extensionValue_tab,
        ___ResetResponse_protocolExtensions__item__extensionValue,
        __ResetResponse_protocolExtensions__item_,
        _ResetResponse_protocolExtensions,
        ResetResponse,
        ResetResponse_IEs,
        _ResetResponse_IEs_val_Value_0,
        ResetResponse_Extensions,
        ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        ___InformationExchangeInitiationRequest_protocolIEs__item__id,
        ___InformationExchangeInitiationRequest_protocolIEs__item__criticality,
        ___InformationExchangeInitiationRequest_protocolIEs__item__value,
        __InformationExchangeInitiationRequest_protocolIEs__item_,
        _InformationExchangeInitiationRequest_protocolIEs,
        ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab,
        ___InformationExchangeInitiationRequest_protocolExtensions__item__id,
        ____InformationExchangeInitiationRequest_protocolExtensions__item__criticality_tab,
        ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality,
        ____InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue,
        __InformationExchangeInitiationRequest_protocolExtensions__item_,
        _InformationExchangeInitiationRequest_protocolExtensions,
        InformationExchangeInitiationRequest,
        InformationExchangeInitiationRequest_IEs,
        _InformationExchangeInitiationRequest_IEs_val_Value_0,
        _InformationExchangeInitiationRequest_IEs_val_Value_1,
        _InformationExchangeInitiationRequest_IEs_val_Value_2,
        _InformationExchangeInitiationRequest_IEs_val_Value_3,
        InformationExchangeInitiationRequest_Extensions,
        _InformationExchangeObjectType_InfEx_Rqst_cell,
        InformationExchangeObjectType_InfEx_Rqst,
        _Cell_InfEx_Rqst_c_ID,
        ____Cell_InfEx_Rqst_iE_Extensions__item__id_tab,
        ___Cell_InfEx_Rqst_iE_Extensions__item__id,
        ____Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab,
        ___Cell_InfEx_Rqst_iE_Extensions__item__criticality,
        ____Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab,
        ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue,
        __Cell_InfEx_Rqst_iE_Extensions__item_,
        _Cell_InfEx_Rqst_iE_Extensions,
        Cell_InfEx_Rqst,
        CellItem_InfEx_Rqst_ExtIEs,
        ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab,
        _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___InformationExchangeInitiationResponse_protocolIEs__item__id,
        ___InformationExchangeInitiationResponse_protocolIEs__item__criticality,
        ___InformationExchangeInitiationResponse_protocolIEs__item__value,
        __InformationExchangeInitiationResponse_protocolIEs__item_,
        _InformationExchangeInitiationResponse_protocolIEs,
        ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab,
        ___InformationExchangeInitiationResponse_protocolExtensions__item__id,
        ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab,
        ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality,
        ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue,
        __InformationExchangeInitiationResponse_protocolExtensions__item_,
        _InformationExchangeInitiationResponse_protocolExtensions,
        InformationExchangeInitiationResponse,
        InformationExchangeInitiationResponse_IEs,
        _InformationExchangeInitiationResponse_IEs_val_Value_0,
        _InformationExchangeInitiationResponse_IEs_val_Value_1,
        _InformationExchangeInitiationResponse_IEs_val_Value_2,
        InformationExchangeInitiationResponse_Extensions,
        _InformationExchangeObjectType_InfEx_Rsp_cell,
        InformationExchangeObjectType_InfEx_Rsp,
        _Cell_InfEx_Rsp_requestedDataValue,
        ____Cell_InfEx_Rsp_iE_Extensions__item__id_tab,
        ___Cell_InfEx_Rsp_iE_Extensions__item__id,
        ____Cell_InfEx_Rsp_iE_Extensions__item__criticality_tab,
        ___Cell_InfEx_Rsp_iE_Extensions__item__criticality,
        ____Cell_InfEx_Rsp_iE_Extensions__item__extensionValue_tab,
        ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue,
        __Cell_InfEx_Rsp_iE_Extensions__item_,
        _Cell_InfEx_Rsp_iE_Extensions,
        Cell_InfEx_Rsp,
        CellItem_InfEx_Rsp_ExtIEs,
        ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab,
        _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___InformationExchangeInitiationFailure_protocolIEs__item__id,
        ___InformationExchangeInitiationFailure_protocolIEs__item__criticality,
        ___InformationExchangeInitiationFailure_protocolIEs__item__value,
        __InformationExchangeInitiationFailure_protocolIEs__item_,
        _InformationExchangeInitiationFailure_protocolIEs,
        ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab,
        ___InformationExchangeInitiationFailure_protocolExtensions__item__id,
        ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab,
        ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality,
        ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue,
        __InformationExchangeInitiationFailure_protocolExtensions__item_,
        _InformationExchangeInitiationFailure_protocolExtensions,
        InformationExchangeInitiationFailure,
        InformationExchangeInitiationFailure_IEs,
        _InformationExchangeInitiationFailure_IEs_val_Value_0,
        _InformationExchangeInitiationFailure_IEs_val_Value_1,
        _InformationExchangeInitiationFailure_IEs_val_Value_2,
        InformationExchangeInitiationFailure_Extensions,
        ____InformationReport_protocolIEs__item__id_tab,
        _____InformationReport_protocolIEs__item__id_tab_val_Value_0,
        _____InformationReport_protocolIEs__item__id_tab_val_Value_1,
        ___InformationReport_protocolIEs__item__id,
        ___InformationReport_protocolIEs__item__criticality,
        ___InformationReport_protocolIEs__item__value,
        __InformationReport_protocolIEs__item_,
        _InformationReport_protocolIEs,
        ____InformationReport_protocolExtensions__item__id_tab,
        ___InformationReport_protocolExtensions__item__id,
        ____InformationReport_protocolExtensions__item__criticality_tab,
        ___InformationReport_protocolExtensions__item__criticality,
        ____InformationReport_protocolExtensions__item__extensionValue_tab,
        ___InformationReport_protocolExtensions__item__extensionValue,
        __InformationReport_protocolExtensions__item_,
        _InformationReport_protocolExtensions,
        InformationReport,
        InformationReport_IEs,
        _InformationReport_IEs_val_Value_0,
        _InformationReport_IEs_val_Value_1,
        InformationReport_Extensions,
        _InformationExchangeObjectType_InfEx_Rprt_cell,
        InformationExchangeObjectType_InfEx_Rprt,
        _Cell_Inf_Rprt_requestedDataValueInformation,
        ____Cell_Inf_Rprt_iE_Extensions__item__id_tab,
        ___Cell_Inf_Rprt_iE_Extensions__item__id,
        ____Cell_Inf_Rprt_iE_Extensions__item__criticality_tab,
        ___Cell_Inf_Rprt_iE_Extensions__item__criticality,
        ____Cell_Inf_Rprt_iE_Extensions__item__extensionValue_tab,
        ___Cell_Inf_Rprt_iE_Extensions__item__extensionValue,
        __Cell_Inf_Rprt_iE_Extensions__item_,
        _Cell_Inf_Rprt_iE_Extensions,
        Cell_Inf_Rprt,
        CellItem_Inf_Rprt_ExtIEs,
        ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab,
        _____InformationExchangeTerminationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___InformationExchangeTerminationRequest_protocolIEs__item__id,
        ___InformationExchangeTerminationRequest_protocolIEs__item__criticality,
        ___InformationExchangeTerminationRequest_protocolIEs__item__value,
        __InformationExchangeTerminationRequest_protocolIEs__item_,
        _InformationExchangeTerminationRequest_protocolIEs,
        ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab,
        ___InformationExchangeTerminationRequest_protocolExtensions__item__id,
        ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab,
        ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality,
        ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue,
        __InformationExchangeTerminationRequest_protocolExtensions__item_,
        _InformationExchangeTerminationRequest_protocolExtensions,
        InformationExchangeTerminationRequest,
        InformationExchangeTerminationRequest_IEs,
        _InformationExchangeTerminationRequest_IEs_val_Value_0,
        InformationExchangeTerminationRequest_Extensions,
        ____InformationExchangeFailureIndication_protocolIEs__item__id_tab,
        _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___InformationExchangeFailureIndication_protocolIEs__item__id,
        ___InformationExchangeFailureIndication_protocolIEs__item__criticality,
        ___InformationExchangeFailureIndication_protocolIEs__item__value,
        __InformationExchangeFailureIndication_protocolIEs__item_,
        _InformationExchangeFailureIndication_protocolIEs,
        ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab,
        ___InformationExchangeFailureIndication_protocolExtensions__item__id,
        ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab,
        ___InformationExchangeFailureIndication_protocolExtensions__item__criticality,
        ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue,
        __InformationExchangeFailureIndication_protocolExtensions__item_,
        _InformationExchangeFailureIndication_protocolExtensions,
        InformationExchangeFailureIndication,
        InformationExchangeFailureIndication_IEs,
        _InformationExchangeFailureIndication_IEs_val_Value_0,
        _InformationExchangeFailureIndication_IEs_val_Value_1,
        InformationExchangeFailureIndication_Extensions,
        ____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_3,
        _____CellSynchronisationInitiationRequestTDD_protocolIEs__item__id_tab_val_Value_4,
        ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__id,
        ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__criticality,
        ___CellSynchronisationInitiationRequestTDD_protocolIEs__item__value,
        __CellSynchronisationInitiationRequestTDD_protocolIEs__item_,
        _CellSynchronisationInitiationRequestTDD_protocolIEs,
        ____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab,
        _____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__id,
        ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__criticality,
        ___CellSynchronisationInitiationRequestTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationInitiationRequestTDD_protocolExtensions__item_,
        _CellSynchronisationInitiationRequestTDD_protocolExtensions,
        CellSynchronisationInitiationRequestTDD,
        CellSynchronisationInitiationRequestTDD_IEs,
        _CellSynchronisationInitiationRequestTDD_IEs_val_Value_0,
        _CellSynchronisationInitiationRequestTDD_IEs_val_Value_1,
        _CellSynchronisationInitiationRequestTDD_IEs_val_Value_2,
        _CellSynchronisationInitiationRequestTDD_IEs_val_Value_3,
        _CellSynchronisationInitiationRequestTDD_IEs_val_Value_4,
        CellSynchronisationInitiationRequestTDD_Extensions,
        _CellSynchronisationInitiationRequestTDD_Extensions_val_Extension_0,
        _CellSynchronisationInitiationRequestTDD_Extensions_val_Extension_1,
        _TimeslotInfo_CellSyncInitiationRqstTDD__item_,
        TimeslotInfo_CellSyncInitiationRqstTDD,
        _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_cSBTransmissionID,
        _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_sfn,
        _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_cellSyncBurstCode,
        _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_cellSyncBurstCodeShift,
        _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_initialDLTransPower,
        ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab,
        ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id,
        ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab,
        ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality,
        ____CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue,
        __CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions__item_,
        _CellSyncBurstTransInit_CellSyncInitiationRqstTDD_iE_Extensions,
        CellSyncBurstTransInit_CellSyncInitiationRqstTDD,
        CellSyncBurstTransInit_CellSyncInitiationRqstTDD_ExtIEs,
        _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_cSBMeasurementID,
        _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_cellSyncBurstCode,
        _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_cellSyncBurstCodeShift,
        _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_synchronisationReportType,
        _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_sfn,
        _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_synchronisationReportCharacteristics,
        ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab,
        ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__id,
        ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab,
        ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality,
        ____CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue,
        __CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions__item_,
        _CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_iE_Extensions,
        CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD,
        CellSyncBurstMeasureInit_CellSyncInitiationRqstTDD_ExtIEs,
        _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_cSBTransmissionID,
        _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_sfn,
        _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_uARFCN,
        _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_sYNCDlCodeId,
        _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_dwPCH_Power,
        ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab,
        ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id,
        ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab,
        ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality,
        ____SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue,
        __SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item_,
        _SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_iE_Extensions,
        SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD,
        SYNCDlCodeId_TransInitLCR_CellSyncInitiationRqstTDD_ExtIEs,
        _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_cSBMeasurementID,
        _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_sfn,
        _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_uARFCN,
        _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_sYNCDlCodeId,
        _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_synchronisationReportType,
        _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_synchronisationReportCharacteristics,
        ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id_tab,
        ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__id,
        ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality_tab,
        ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__criticality,
        ____SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item__extensionValue,
        __SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions__item_,
        _SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_iE_Extensions,
        SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD,
        SYNCDlCodeId_MeasureInitLCR_CellSyncInitiationRqstTDD_ExtIEs,
        ____CellSynchronisationInitiationResponseTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationInitiationResponseTDD_protocolIEs__item__id_tab_val_Value_0,
        ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__id,
        ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__criticality,
        ___CellSynchronisationInitiationResponseTDD_protocolIEs__item__value,
        __CellSynchronisationInitiationResponseTDD_protocolIEs__item_,
        _CellSynchronisationInitiationResponseTDD_protocolIEs,
        ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__id_tab,
        ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__id,
        ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__criticality_tab,
        ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__criticality,
        ____CellSynchronisationInitiationResponseTDD_protocolExtensions__item__extensionValue_tab,
        ___CellSynchronisationInitiationResponseTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationInitiationResponseTDD_protocolExtensions__item_,
        _CellSynchronisationInitiationResponseTDD_protocolExtensions,
        CellSynchronisationInitiationResponseTDD,
        CellSynchronisationInitiationResponseTDD_Extensions,
        CellSynchronisationInitiationResponseTDD_IEs,
        _CellSynchronisationInitiationResponseTDD_IEs_val_Value_0,
        ____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CellSynchronisationInitiationFailureTDD_protocolIEs__item__id_tab_val_Value_1,
        ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__id,
        ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__criticality,
        ___CellSynchronisationInitiationFailureTDD_protocolIEs__item__value,
        __CellSynchronisationInitiationFailureTDD_protocolIEs__item_,
        _CellSynchronisationInitiationFailureTDD_protocolIEs,
        ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__id_tab,
        ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__id,
        ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__criticality_tab,
        ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__criticality,
        ____CellSynchronisationInitiationFailureTDD_protocolExtensions__item__extensionValue_tab,
        ___CellSynchronisationInitiationFailureTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationInitiationFailureTDD_protocolExtensions__item_,
        _CellSynchronisationInitiationFailureTDD_protocolExtensions,
        CellSynchronisationInitiationFailureTDD,
        CellSynchronisationInitiationFailureTDD_Extensions,
        CellSynchronisationInitiationFailureTDD_IEs,
        _CellSynchronisationInitiationFailureTDD_IEs_val_Value_0,
        _CellSynchronisationInitiationFailureTDD_IEs_val_Value_1,
        ____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3,
        _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4,
        _____CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5,
        ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__id,
        ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__criticality,
        ___CellSynchronisationReconfigurationRequestTDD_protocolIEs__item__value,
        __CellSynchronisationReconfigurationRequestTDD_protocolIEs__item_,
        _CellSynchronisationReconfigurationRequestTDD_protocolIEs,
        ____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab,
        _____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2,
        ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__id,
        ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__criticality,
        ___CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationReconfigurationRequestTDD_protocolExtensions__item_,
        _CellSynchronisationReconfigurationRequestTDD_protocolExtensions,
        CellSynchronisationReconfigurationRequestTDD,
        CellSynchronisationReconfigurationRequestTDD_IEs,
        _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_0,
        _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_1,
        _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_2,
        _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_3,
        _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_4,
        _CellSynchronisationReconfigurationRequestTDD_IEs_val_Value_5,
        CellSynchronisationReconfigurationRequestTDD_Extensions,
        _CellSynchronisationReconfigurationRequestTDD_Extensions_val_Extension_0,
        _CellSynchronisationReconfigurationRequestTDD_Extensions_val_Extension_1,
        _CellSynchronisationReconfigurationRequestTDD_Extensions_val_Extension_2,
        _CellSyncBurstTransReconfInfo_CellSyncReconfRqstTDD__item_,
        CellSyncBurstTransReconfInfo_CellSyncReconfRqstTDD,
        _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_cSBTransmissionID,
        _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_syncFrameNumberToTransmit,
        _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCode,
        _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCodeShift,
        _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_dlTransPower,
        ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab,
        ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id,
        ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality,
        ____CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue,
        __CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_,
        _CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_iE_Extensions,
        CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD,
        CellSyncBurstTransInfoItem_CellSyncReconfRqstTDD_ExtIEs,
        _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_cellSyncBurstMeasInfoList_CellSyncReconfRqstTDD,
        _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_synchronisationReportType,
        _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_synchronisationReportCharacteristics,
        ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab,
        ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__id,
        ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__criticality,
        ____CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue,
        __CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions__item_,
        _CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_iE_Extensions,
        CellSyncBurstMeasInfo_CellSyncReconfRqstTDD,
        CellSyncBurstMeasInfo_CellSyncReconfRqstTDD_ExtIEs,
        __CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id_tab,
        ___CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id_tab_val_Value_0,
        _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_id,
        _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_criticality,
        _CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD_value,
        CellSyncBurstMeasInfoList_CellSyncReconfRqstTDD,
        CellSyncBurstMeasInfoListIEs_CellSyncReconfRqstTDD,
        _CellSyncBurstMeasInfoListIEs_CellSyncReconfRqstTDD_val_Value_0,
        __SynchronisationReportTypeIE_id_tab,
        ___SynchronisationReportTypeIE_id_tab_val_Value_0,
        _SynchronisationReportTypeIE_id,
        _SynchronisationReportTypeIE_criticality,
        _SynchronisationReportTypeIE_value,
        SynchronisationReportTypeIE,
        SynchronisationReportTypeIEs,
        _SynchronisationReportTypeIEs_val_Value_0,
        __SynchronisationReportCharacteristicsIE_id_tab,
        ___SynchronisationReportCharacteristicsIE_id_tab_val_Value_0,
        _SynchronisationReportCharacteristicsIE_id,
        _SynchronisationReportCharacteristicsIE_criticality,
        _SynchronisationReportCharacteristicsIE_value,
        SynchronisationReportCharacteristicsIE,
        SynchronisationReportCharacteristicsIEs,
        _SynchronisationReportCharacteristicsIEs_val_Value_0,
        _CellSyncBurstMeasInfoListIE_CellSyncReconfRqstTDD__item_,
        CellSyncBurstMeasInfoListIE_CellSyncReconfRqstTDD,
        _CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_syncFrameNrToReceive,
        _CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_syncBurstInfo,
        ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab,
        ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id,
        ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality,
        ____CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue,
        __CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_,
        _CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions,
        CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD,
        CellSyncBurstMeasInfoItem_CellSyncReconfRqstTDD_ExtIEs,
        _CellSyncBurstInfoList_CellSyncReconfRqstTDD__item_,
        CellSyncBurstInfoList_CellSyncReconfRqstTDD,
        _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_cSBMeasurementID,
        _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCode,
        _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_cellSyncBurstCodeShift,
        ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab,
        ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id,
        ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality,
        ____CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue,
        __CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_,
        _CellSyncBurstInfoItem_CellSyncReconfRqstTDD_iE_Extensions,
        CellSyncBurstInfoItem_CellSyncReconfRqstTDD,
        CellSyncBurstInfoItem_CellSyncReconfRqstTDD_ExtIEs,
        _SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD__item_,
        SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD,
        _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_cSBTransmissionID,
        _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_syncFrameNumberforTransmit,
        _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_uARFCN,
        _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_sYNCDlCodeId,
        _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_dwPCH_Power,
        ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab,
        ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id,
        ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality,
        ____SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue,
        __SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item_,
        _SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD_iE_Extensions,
        SYNCDlCodeIdTransReconfItemLCR_CellSyncReconfRqstTDD,
        SYNCDlCodeIdTransReconfInfoLCR_CellSyncReconfRqstTDD_ExtIEs,
        _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_sYNCDlCodeIdMeasInfoList,
        _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_synchronisationReportType,
        _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_synchronisationReportCharacteristics,
        ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab,
        ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id,
        ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality,
        ____SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue,
        __SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions__item_,
        _SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_iE_Extensions,
        SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD,
        SYNCDlCodeIdMeasInfoLCR_CellSyncReconfRqstTDD_ExtIEs,
        _SYNCDlCodeIdMeasInfoList_CellSyncReconfRqstTDD__item_,
        SYNCDlCodeIdMeasInfoList_CellSyncReconfRqstTDD,
        _SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_syncFrameNrToReceive,
        _SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_sYNCDlCodeIdInfoLCR,
        ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab,
        ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__id,
        ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__criticality,
        ____SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue,
        __SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions__item_,
        _SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_iE_Extensions,
        SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD,
        SYNCDlCodeIdMeasInfoItem_CellSyncReconfRqstTDD_ExtIEs,
        _SYNCDlCodeIdInfoListLCR_CellSyncReconfRqstTDD__item_,
        SYNCDlCodeIdInfoListLCR_CellSyncReconfRqstTDD,
        _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_cSBMeasurementID,
        _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_sYNCDlCodeId,
        _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_uARFCN,
        _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_propagationDelayCompensation,
        ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id_tab,
        ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__id,
        ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__criticality,
        ____SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item__extensionValue,
        __SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions__item_,
        _SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_iE_Extensions,
        SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD,
        SYNCDlCodeIdInfoItemLCR_CellSyncReconfRqstTDD_ExtIEs,
        ____CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id_tab_val_Value_0,
        ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__id,
        ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__criticality,
        ___CellSynchronisationReconfigurationResponseTDD_protocolIEs__item__value,
        __CellSynchronisationReconfigurationResponseTDD_protocolIEs__item_,
        _CellSynchronisationReconfigurationResponseTDD_protocolIEs,
        ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__id_tab,
        ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__id,
        ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__criticality_tab,
        ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__criticality,
        ____CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__extensionValue_tab,
        ___CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationReconfigurationResponseTDD_protocolExtensions__item_,
        _CellSynchronisationReconfigurationResponseTDD_protocolExtensions,
        CellSynchronisationReconfigurationResponseTDD,
        CellSynchronisationReconfigurationResponseTDD_Extensions,
        CellSynchronisationReconfigurationResponseTDD_IEs,
        _CellSynchronisationReconfigurationResponseTDD_IEs_val_Value_0,
        ____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id_tab_val_Value_1,
        ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__id,
        ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__criticality,
        ___CellSynchronisationReconfigurationFailureTDD_protocolIEs__item__value,
        __CellSynchronisationReconfigurationFailureTDD_protocolIEs__item_,
        _CellSynchronisationReconfigurationFailureTDD_protocolIEs,
        ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__id_tab,
        ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__id,
        ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__criticality_tab,
        ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__criticality,
        ____CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__extensionValue_tab,
        ___CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationReconfigurationFailureTDD_protocolExtensions__item_,
        _CellSynchronisationReconfigurationFailureTDD_protocolExtensions,
        CellSynchronisationReconfigurationFailureTDD,
        CellSynchronisationReconfigurationFailureTDD_Extensions,
        CellSynchronisationReconfigurationFailureTDD_IEs,
        _CellSynchronisationReconfigurationFailureTDD_IEs_val_Value_0,
        _CellSynchronisationReconfigurationFailureTDD_IEs_val_Value_1,
        ____CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__id,
        ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__criticality,
        ___CellSynchronisationAdjustmentRequestTDD_protocolIEs__item__value,
        __CellSynchronisationAdjustmentRequestTDD_protocolIEs__item_,
        _CellSynchronisationAdjustmentRequestTDD_protocolIEs,
        ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__id_tab,
        ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__id,
        ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__criticality_tab,
        ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__criticality,
        ____CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__extensionValue_tab,
        ___CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationAdjustmentRequestTDD_protocolExtensions__item_,
        _CellSynchronisationAdjustmentRequestTDD_protocolExtensions,
        CellSynchronisationAdjustmentRequestTDD,
        CellSynchronisationAdjustmentRequestTDD_Extensions,
        CellSynchronisationAdjustmentRequestTDD_IEs,
        _CellSynchronisationAdjustmentRequestTDD_IEs_val_Value_0,
        ___CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id_tab,
        ____CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id_tab_val_Value_0,
        __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__id,
        __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__criticality,
        __CellAdjustmentInfo_SyncAdjustmentRqstTDD__item__value,
        _CellAdjustmentInfo_SyncAdjustmentRqstTDD__item_,
        CellAdjustmentInfo_SyncAdjustmentRqstTDD,
        CellAdjustmentInfoItemIE_SyncAdjustmntRqstTDD,
        _CellAdjustmentInfoItemIE_SyncAdjustmntRqstTDD_val_Value_0,
        _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_c_ID,
        _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_frameAdjustmentValue,
        _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_timingAdjustmentValue,
        _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_dLTransPower,
        _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_sfn,
        ____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab,
        _____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__id,
        ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__criticality,
        ___CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item__extensionValue,
        __CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions__item_,
        _CellAdjustmentInfoItem_SyncAdjustmentRqstTDD_iE_Extensions,
        CellAdjustmentInfoItem_SyncAdjustmentRqstTDD,
        CellAdjustmentInfoItem_SyncAdjustmntRqstTDD_ExtIEs,
        _CellAdjustmentInfoItem_SyncAdjustmntRqstTDD_ExtIEs_val_Extension_0,
        _CellAdjustmentInfoItem_SyncAdjustmntRqstTDD_ExtIEs_val_Extension_1,
        ____CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id_tab_val_Value_0,
        ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__id,
        ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__criticality,
        ___CellSynchronisationAdjustmentResponseTDD_protocolIEs__item__value,
        __CellSynchronisationAdjustmentResponseTDD_protocolIEs__item_,
        _CellSynchronisationAdjustmentResponseTDD_protocolIEs,
        ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__id_tab,
        ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__id,
        ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__criticality_tab,
        ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__criticality,
        ____CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__extensionValue_tab,
        ___CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationAdjustmentResponseTDD_protocolExtensions__item_,
        _CellSynchronisationAdjustmentResponseTDD_protocolExtensions,
        CellSynchronisationAdjustmentResponseTDD,
        CellSynchronisationAdjustmentResponseTDD_Extensions,
        CellSynchronisationAdjustmentResponseTDD_IEs,
        _CellSynchronisationAdjustmentResponseTDD_IEs_val_Value_0,
        ____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id_tab_val_Value_1,
        ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__id,
        ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__criticality,
        ___CellSynchronisationAdjustmentFailureTDD_protocolIEs__item__value,
        __CellSynchronisationAdjustmentFailureTDD_protocolIEs__item_,
        _CellSynchronisationAdjustmentFailureTDD_protocolIEs,
        ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__id_tab,
        ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__id,
        ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__criticality_tab,
        ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__criticality,
        ____CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__extensionValue_tab,
        ___CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationAdjustmentFailureTDD_protocolExtensions__item_,
        _CellSynchronisationAdjustmentFailureTDD_protocolExtensions,
        CellSynchronisationAdjustmentFailureTDD,
        CellSynchronisationAdjustmentFailureTDD_Extensions,
        CellSynchronisationAdjustmentFailureTDD_IEs,
        _CellSynchronisationAdjustmentFailureTDD_IEs_val_Value_0,
        _CellSynchronisationAdjustmentFailureTDD_IEs_val_Value_1,
        _CauseLevel_SyncAdjustmntFailureTDD_generalCause,
        _CauseLevel_SyncAdjustmntFailureTDD_cellSpecificCause,
        CauseLevel_SyncAdjustmntFailureTDD,
        _GeneralCauseList_SyncAdjustmntFailureTDD_cause,
        ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab,
        ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id,
        ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality,
        ____GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue,
        __GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item_,
        _GeneralCauseList_SyncAdjustmntFailureTDD_iE_Extensions,
        GeneralCauseList_SyncAdjustmntFailureTDD,
        GeneralCauseList_SyncAdjustmntFailureTDD_ExtIEs,
        _CellSpecificCauseList_SyncAdjustmntFailureTDD_unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD,
        ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab,
        ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__id,
        ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab,
        ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality,
        ____CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue,
        __CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions__item_,
        _CellSpecificCauseList_SyncAdjustmntFailureTDD_iE_Extensions,
        CellSpecificCauseList_SyncAdjustmntFailureTDD,
        CellSpecificCauseList_SyncAdjustmntFailureTDD_ExtIEs,
        ___Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id_tab,
        ____Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id_tab_val_Value_0,
        __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__id,
        __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__criticality,
        __Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item__value,
        _Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD__item_,
        Unsuccessful_cell_InformationRespList_SyncAdjustmntFailureTDD,
        Unsuccessful_cell_InformationRespItemIE_SyncAdjustmntFailureTDD,
        _Unsuccessful_cell_InformationRespItemIE_SyncAdjustmntFailureTDD_val_Value_0,
        _Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_c_ID,
        _Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_cause,
        ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__id_tab,
        ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__id,
        ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality_tab,
        ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__criticality,
        ____Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item__extensionValue,
        __Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions__item_,
        _Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_iE_Extensions,
        Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD,
        Unsuccessful_cell_InformationRespItem_SyncAdjustmntFailureTDD_ExtIEs,
        ____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____CellSynchronisationTerminationRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__id,
        ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__criticality,
        ___CellSynchronisationTerminationRequestTDD_protocolIEs__item__value,
        __CellSynchronisationTerminationRequestTDD_protocolIEs__item_,
        _CellSynchronisationTerminationRequestTDD_protocolIEs,
        ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__id_tab,
        ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__id,
        ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__criticality_tab,
        ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__criticality,
        ____CellSynchronisationTerminationRequestTDD_protocolExtensions__item__extensionValue_tab,
        ___CellSynchronisationTerminationRequestTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationTerminationRequestTDD_protocolExtensions__item_,
        _CellSynchronisationTerminationRequestTDD_protocolExtensions,
        CellSynchronisationTerminationRequestTDD,
        CellSynchronisationTerminationRequestTDD_Extensions,
        CellSynchronisationTerminationRequestTDD_IEs,
        _CellSynchronisationTerminationRequestTDD_IEs_val_Value_0,
        _CellSynchronisationTerminationRequestTDD_IEs_val_Value_1,
        _CellSynchronisationTerminationRequestTDD_IEs_val_Value_2,
        ____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_1,
        _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_2,
        _____CellSynchronisationFailureIndicationTDD_protocolIEs__item__id_tab_val_Value_3,
        ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__id,
        ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__criticality,
        ___CellSynchronisationFailureIndicationTDD_protocolIEs__item__value,
        __CellSynchronisationFailureIndicationTDD_protocolIEs__item_,
        _CellSynchronisationFailureIndicationTDD_protocolIEs,
        ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__id_tab,
        ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__id,
        ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__criticality_tab,
        ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__criticality,
        ____CellSynchronisationFailureIndicationTDD_protocolExtensions__item__extensionValue_tab,
        ___CellSynchronisationFailureIndicationTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationFailureIndicationTDD_protocolExtensions__item_,
        _CellSynchronisationFailureIndicationTDD_protocolExtensions,
        CellSynchronisationFailureIndicationTDD,
        CellSynchronisationFailureIndicationTDD_Extensions,
        CellSynchronisationFailureIndicationTDD_IEs,
        _CellSynchronisationFailureIndicationTDD_IEs_val_Value_0,
        _CellSynchronisationFailureIndicationTDD_IEs_val_Value_1,
        _CellSynchronisationFailureIndicationTDD_IEs_val_Value_2,
        _CellSynchronisationFailureIndicationTDD_IEs_val_Value_3,
        ____CellSynchronisationReportTDD_protocolIEs__item__id_tab,
        _____CellSynchronisationReportTDD_protocolIEs__item__id_tab_val_Value_0,
        ___CellSynchronisationReportTDD_protocolIEs__item__id,
        ___CellSynchronisationReportTDD_protocolIEs__item__criticality,
        ___CellSynchronisationReportTDD_protocolIEs__item__value,
        __CellSynchronisationReportTDD_protocolIEs__item_,
        _CellSynchronisationReportTDD_protocolIEs,
        ____CellSynchronisationReportTDD_protocolExtensions__item__id_tab,
        ___CellSynchronisationReportTDD_protocolExtensions__item__id,
        ____CellSynchronisationReportTDD_protocolExtensions__item__criticality_tab,
        ___CellSynchronisationReportTDD_protocolExtensions__item__criticality,
        ____CellSynchronisationReportTDD_protocolExtensions__item__extensionValue_tab,
        ___CellSynchronisationReportTDD_protocolExtensions__item__extensionValue,
        __CellSynchronisationReportTDD_protocolExtensions__item_,
        _CellSynchronisationReportTDD_protocolExtensions,
        CellSynchronisationReportTDD,
        CellSynchronisationReportTDD_Extensions,
        CellSynchronisationReportTDD_IEs,
        _CellSynchronisationReportTDD_IEs_val_Value_0,
        _CellSyncInfo_CellSyncReprtTDD__item_,
        CellSyncInfo_CellSyncReprtTDD,
        _CellSyncInfoItemIE_CellSyncReprtTDD_c_ID_CellSyncReprtTDD,
        _CellSyncInfoItemIE_CellSyncReprtTDD_syncReportType_CellSyncReprtTDD,
        CellSyncInfoItemIE_CellSyncReprtTDD,
        __C_ID_IE_CellSyncReprtTDD_id_tab,
        ___C_ID_IE_CellSyncReprtTDD_id_tab_val_Value_0,
        _C_ID_IE_CellSyncReprtTDD_id,
        _C_ID_IE_CellSyncReprtTDD_criticality,
        _C_ID_IE_CellSyncReprtTDD_value,
        C_ID_IE_CellSyncReprtTDD,
        C_ID_IEs_CellSyncReprtTDD,
        _C_ID_IEs_CellSyncReprtTDD_val_Value_0,
        __SyncReportTypeIE_CellSyncReprtTDD_id_tab,
        ___SyncReportTypeIE_CellSyncReprtTDD_id_tab_val_Value_0,
        _SyncReportTypeIE_CellSyncReprtTDD_id,
        _SyncReportTypeIE_CellSyncReprtTDD_criticality,
        _SyncReportTypeIE_CellSyncReprtTDD_value,
        SyncReportTypeIE_CellSyncReprtTDD,
        SyncReportTypeIEs_CellSyncReprtTDD,
        _SyncReportTypeIEs_CellSyncReprtTDD_val_Value_0,
        _SyncReportType_CellSyncReprtTDD_intStdPhSyncInfo_CellSyncReprtTDD,
        _SyncReportType_CellSyncReprtTDD_lateEntrantCell,
        _SyncReportType_CellSyncReprtTDD_frequencyAcquisition,
        SyncReportType_CellSyncReprtTDD,
        _IntStdPhCellSyncInfo_CellSyncReprtTDD_cellSyncBurstMeasuredInfo,
        ____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab,
        _____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__id,
        ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__criticality,
        ___IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item__extensionValue,
        __IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions__item_,
        _IntStdPhCellSyncInfo_CellSyncReprtTDD_iE_Extensions,
        IntStdPhCellSyncInfo_CellSyncReprtTDD,
        IntStdPhCellSyncInfoList_CellSyncReprtTDD_ExtIEs,
        _IntStdPhCellSyncInfoList_CellSyncReprtTDD_ExtIEs_val_Extension_0,
        _IntStdPhCellSyncInfoList_CellSyncReprtTDD_ExtIEs_val_Extension_1,
        _CellSyncBurstMeasInfoList_CellSyncReprtTDD__item_,
        CellSyncBurstMeasInfoList_CellSyncReprtTDD,
        _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_sFN,
        __CellSyncBurstMeasInfoItem_CellSyncReprtTDD_cellSyncBurstInfo_CellSyncReprtTDD__item_,
        _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_cellSyncBurstInfo_CellSyncReprtTDD,
        ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id_tab,
        ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id,
        ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality_tab,
        ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality,
        ____CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab,
        ___CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue,
        __CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item_,
        _CellSyncBurstMeasInfoItem_CellSyncReprtTDD_iE_Extensions,
        CellSyncBurstMeasInfoItem_CellSyncReprtTDD,
        CellSyncBurstMeasInfoItem_CellSyncReprtTDD_ExtIEs,
        _CellSyncBurstInfo_CellSyncReprtTDD_cellSyncBurstAvailable,
        _CellSyncBurstInfo_CellSyncReprtTDD_cellSyncBurstNotAvailable,
        CellSyncBurstInfo_CellSyncReprtTDD,
        _CellSyncBurstAvailable_CellSyncReprtTDD_cellSyncBurstTiming,
        _CellSyncBurstAvailable_CellSyncReprtTDD_cellSyncBurstSIR,
        ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__id_tab,
        ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__id,
        ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality_tab,
        ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality,
        ____CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab,
        ___CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue,
        __CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions__item_,
        _CellSyncBurstAvailable_CellSyncReprtTDD_iE_Extensions,
        CellSyncBurstAvailable_CellSyncReprtTDD,
        CellSyncBurstAvailable_CellSyncReprtTDD_ExtIEs,
        _SyncDLCodeIdsMeasInfoList_CellSyncReprtTDD__item_,
        SyncDLCodeIdsMeasInfoList_CellSyncReprtTDD,
        _SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_sFN,
        _SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_syncDLCodeIdInfo_CellSyncReprtTDD,
        ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id_tab,
        ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__id,
        ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality_tab,
        ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__criticality,
        ____SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab,
        ___SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item__extensionValue,
        __SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions__item_,
        _SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_iE_Extensions,
        SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD,
        SyncDLCodeIdsMeasInfoItem_CellSyncReprtTDD_ExtIEs,
        _SyncDLCodeIdInfo_CellSyncReprtTDD__item_,
        SyncDLCodeIdInfo_CellSyncReprtTDD,
        _SyncDLCodeIdItem_CellSyncReprtTDD_syncDLCodeIdAvailable,
        _SyncDLCodeIdItem_CellSyncReprtTDD_syncDLCodeIDNotAvailable,
        SyncDLCodeIdItem_CellSyncReprtTDD,
        _SyncDLCodeIdAvailable_CellSyncReprtTDD_syncDLCodeIdTiming,
        _SyncDLCodeIdAvailable_CellSyncReprtTDD_syncDLCodeIdSIR,
        ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__id_tab,
        ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__id,
        ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality_tab,
        ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__criticality,
        ____SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue_tab,
        ___SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item__extensionValue,
        __SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions__item_,
        _SyncDLCodeIdAvailable_CellSyncReprtTDD_iE_Extensions,
        SyncDLCodeIdAvailable_CellSyncReprtTDD,
        SyncDLCodeIdAvailable_CellSyncReprtTDD_ExtIEs,
        ____BearerRearrangementIndication_protocolIEs__item__id_tab,
        _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_0,
        _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_1,
        _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_2,
        _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_3,
        _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_4,
        _____BearerRearrangementIndication_protocolIEs__item__id_tab_val_Value_5,
        ___BearerRearrangementIndication_protocolIEs__item__id,
        ___BearerRearrangementIndication_protocolIEs__item__criticality,
        ___BearerRearrangementIndication_protocolIEs__item__value,
        __BearerRearrangementIndication_protocolIEs__item_,
        _BearerRearrangementIndication_protocolIEs,
        ____BearerRearrangementIndication_protocolExtensions__item__id_tab,
        _____BearerRearrangementIndication_protocolExtensions__item__id_tab_val_Extension_0,
        ___BearerRearrangementIndication_protocolExtensions__item__id,
        ___BearerRearrangementIndication_protocolExtensions__item__criticality,
        ___BearerRearrangementIndication_protocolExtensions__item__extensionValue,
        __BearerRearrangementIndication_protocolExtensions__item_,
        _BearerRearrangementIndication_protocolExtensions,
        BearerRearrangementIndication,
        BearerRearrangementIndication_IEs,
        _BearerRearrangementIndication_IEs_val_Value_0,
        _BearerRearrangementIndication_IEs_val_Value_1,
        _BearerRearrangementIndication_IEs_val_Value_2,
        _BearerRearrangementIndication_IEs_val_Value_3,
        _BearerRearrangementIndication_IEs_val_Value_4,
        _BearerRearrangementIndication_IEs_val_Value_5,
        BearerRearrangementIndication_Extensions,
        _BearerRearrangementIndication_Extensions_val_Extension_0,
        _DCH_RearrangeList_Bearer_RearrangeInd__item_,
        DCH_RearrangeList_Bearer_RearrangeInd,
        _DCH_RearrangeItem_Bearer_RearrangeInd_dCH_ID,
        ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab,
        ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id,
        ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab,
        ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality,
        ____DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab,
        ___DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue,
        __DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_,
        _DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions,
        DCH_RearrangeItem_Bearer_RearrangeInd,
        DCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs,
        _DSCH_RearrangeList_Bearer_RearrangeInd__item_,
        DSCH_RearrangeList_Bearer_RearrangeInd,
        _DSCH_RearrangeItem_Bearer_RearrangeInd_dSCH_ID,
        ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab,
        ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id,
        ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab,
        ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality,
        ____DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab,
        ___DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue,
        __DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_,
        _DSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions,
        DSCH_RearrangeItem_Bearer_RearrangeInd,
        DSCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs,
        _USCH_RearrangeList_Bearer_RearrangeInd__item_,
        USCH_RearrangeList_Bearer_RearrangeInd,
        _USCH_RearrangeItem_Bearer_RearrangeInd_uSCH_ID,
        ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab,
        ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id,
        ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab,
        ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality,
        ____USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab,
        ___USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue,
        __USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_,
        _USCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions,
        USCH_RearrangeItem_Bearer_RearrangeInd,
        USCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs,
        _HSDSCH_RearrangeList_Bearer_RearrangeInd__item_,
        HSDSCH_RearrangeList_Bearer_RearrangeInd,
        _HSDSCH_RearrangeItem_Bearer_RearrangeInd_hsDSCH_MACdFlow_ID,
        ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab,
        ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id,
        ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality_tab,
        ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality,
        ____HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue,
        __HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_,
        _HSDSCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions,
        HSDSCH_RearrangeItem_Bearer_RearrangeInd,
        HSDSCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs,
        _E_DCH_RearrangeList_Bearer_RearrangeInd__item_,
        E_DCH_RearrangeList_Bearer_RearrangeInd,
        _E_DCH_RearrangeItem_Bearer_RearrangeInd_e_DCH_MACdFlow_ID,
        ____E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab,
        _____E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__id,
        ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__criticality,
        ___E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item__extensionValue,
        __E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions__item_,
        _E_DCH_RearrangeItem_Bearer_RearrangeInd_iE_Extensions,
        E_DCH_RearrangeItem_Bearer_RearrangeInd,
        E_DCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs,
        _E_DCH_RearrangeItem_Bearer_RearrangeInd_ExtIEs_val_Extension_0,
        _Additional_EDCH_Cell_Information_Bearer_Rearrangement_List__item_,
        Additional_EDCH_Cell_Information_Bearer_Rearrangement_List,
        _Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_transport_Bearer_Rearrangement_Indicator_for_Additional_EDCH_Separate_Mode,
        ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_iE_Extensions,
        Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs,
        Additional_EDCH_Cell_Information_Bearer_Rearrangement_ItemIEs_ExtIEs,
        Transport_Bearer_Rearrangement_Indicator_for_Additional_EDCH_Separate_Mode,
        ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab,
        _____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkActivationCommandFDD_protocolIEs__item__id,
        ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality,
        ___RadioLinkActivationCommandFDD_protocolIEs__item__value,
        __RadioLinkActivationCommandFDD_protocolIEs__item_,
        _RadioLinkActivationCommandFDD_protocolIEs,
        ____RadioLinkActivationCommandFDD_protocolExtensions__item__id_tab,
        ___RadioLinkActivationCommandFDD_protocolExtensions__item__id,
        ____RadioLinkActivationCommandFDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality,
        ____RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue,
        __RadioLinkActivationCommandFDD_protocolExtensions__item_,
        _RadioLinkActivationCommandFDD_protocolExtensions,
        RadioLinkActivationCommandFDD,
        RadioLinkActivationCommandFDD_IEs,
        _RadioLinkActivationCommandFDD_IEs_val_Value_0,
        _RadioLinkActivationCommandFDD_IEs_val_Value_1,
        RadioLinkActivationCommandFDD_Extensions,
        ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab,
        ____DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab_val_Value_0,
        __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id,
        __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality,
        __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value,
        _DelayedActivationInformationList_RL_ActivationCmdFDD__item_,
        DelayedActivationInformationList_RL_ActivationCmdFDD,
        DelayedActivationInformation_RL_ActivationCmdFDD_IEs,
        _DelayedActivationInformation_RL_ActivationCmdFDD_IEs_val_Value_0,
        _DelayedActivationInformation_RL_ActivationCmdFDD_rL_ID,
        _DelayedActivationInformation_RL_ActivationCmdFDD_delayed_activation_update,
        ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id_tab,
        ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id,
        ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality_tab,
        ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality,
        ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue_tab,
        ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue,
        __DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item_,
        _DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions,
        DelayedActivationInformation_RL_ActivationCmdFDD,
        DelayedActivationInformation_RL_ActivationCmdFDD_ExtIEs,
        ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab,
        _____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkActivationCommandTDD_protocolIEs__item__id,
        ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality,
        ___RadioLinkActivationCommandTDD_protocolIEs__item__value,
        __RadioLinkActivationCommandTDD_protocolIEs__item_,
        _RadioLinkActivationCommandTDD_protocolIEs,
        ____RadioLinkActivationCommandTDD_protocolExtensions__item__id_tab,
        ___RadioLinkActivationCommandTDD_protocolExtensions__item__id,
        ____RadioLinkActivationCommandTDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality,
        ____RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue,
        __RadioLinkActivationCommandTDD_protocolExtensions__item_,
        _RadioLinkActivationCommandTDD_protocolExtensions,
        RadioLinkActivationCommandTDD,
        RadioLinkActivationCommandTDD_IEs,
        _RadioLinkActivationCommandTDD_IEs_val_Value_0,
        _RadioLinkActivationCommandTDD_IEs_val_Value_1,
        RadioLinkActivationCommandTDD_Extensions,
        ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab,
        ____DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab_val_Value_0,
        __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id,
        __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality,
        __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value,
        _DelayedActivationInformationList_RL_ActivationCmdTDD__item_,
        DelayedActivationInformationList_RL_ActivationCmdTDD,
        DelayedActivationInformation_RL_ActivationCmdTDD_IEs,
        _DelayedActivationInformation_RL_ActivationCmdTDD_IEs_val_Value_0,
        _DelayedActivationInformation_RL_ActivationCmdTDD_rL_ID,
        _DelayedActivationInformation_RL_ActivationCmdTDD_delayed_activation_update,
        ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id_tab,
        ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id,
        ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality_tab,
        ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality,
        ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue_tab,
        ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue,
        __DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item_,
        _DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions,
        DelayedActivationInformation_RL_ActivationCmdTDD,
        DelayedActivationInformation_RL_ActivationCmdTDD_ExtIEs,
        ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab,
        _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id,
        ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality,
        ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value,
        __RadioLinkParameterUpdateIndicationFDD_protocolIEs__item_,
        _RadioLinkParameterUpdateIndicationFDD_protocolIEs,
        ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_6,
        ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id,
        ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality,
        ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue,
        __RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item_,
        _RadioLinkParameterUpdateIndicationFDD_protocolExtensions,
        RadioLinkParameterUpdateIndicationFDD,
        RadioLinkParameterUpdateIndicationFDD_IEs,
        _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_0,
        _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_1,
        RadioLinkParameterUpdateIndicationFDD_Extensions,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_0,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_1,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_2,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_3,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_4,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_5,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_6,
        _Additional_HS_Cell_Information_RL_Param_Upd__item_,
        Additional_HS_Cell_Information_RL_Param_Upd,
        _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Update_Information,
        ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs,
        Additional_HS_Cell_Information_RL_Setup_ExtIEs,
        _Additional_EDCH_Cell_Information_RL_Param_Upd__item_,
        Additional_EDCH_Cell_Information_RL_Param_Upd,
        _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_additional_EDCH_FDD_Update_Information,
        ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions,
        Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs,
        Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_ExtIEs,
        _UE_Measurement_Forwarding_measurementID,
        _UE_Measurement_Forwarding_uE_Measurement_Value,
        ____UE_Measurement_Forwarding_iE_Extensions__item__id_tab,
        ___UE_Measurement_Forwarding_iE_Extensions__item__id,
        ____UE_Measurement_Forwarding_iE_Extensions__item__criticality_tab,
        ___UE_Measurement_Forwarding_iE_Extensions__item__criticality,
        ____UE_Measurement_Forwarding_iE_Extensions__item__extensionValue_tab,
        ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue,
        __UE_Measurement_Forwarding_iE_Extensions__item_,
        _UE_Measurement_Forwarding_iE_Extensions,
        UE_Measurement_Forwarding,
        UE_Measurement_Forwarding_ExtIEs,
        ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab,
        _____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id,
        ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality,
        ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value,
        __RadioLinkParameterUpdateIndicationTDD_protocolIEs__item_,
        _RadioLinkParameterUpdateIndicationTDD_protocolIEs,
        ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id_tab,
        ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id,
        ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality,
        ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue,
        __RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item_,
        _RadioLinkParameterUpdateIndicationTDD_protocolExtensions,
        RadioLinkParameterUpdateIndicationTDD,
        RadioLinkParameterUpdateIndicationTDD_IEs,
        _RadioLinkParameterUpdateIndicationTDD_IEs_val_Value_0,
        _RadioLinkParameterUpdateIndicationTDD_IEs_val_Value_1,
        RadioLinkParameterUpdateIndicationTDD_Extensions,
        ____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab,
        _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_2,
        _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_3,
        _____MBMSNotificationUpdateCommand_protocolIEs__item__id_tab_val_Value_4,
        ___MBMSNotificationUpdateCommand_protocolIEs__item__id,
        ___MBMSNotificationUpdateCommand_protocolIEs__item__criticality,
        ___MBMSNotificationUpdateCommand_protocolIEs__item__value,
        __MBMSNotificationUpdateCommand_protocolIEs__item_,
        _MBMSNotificationUpdateCommand_protocolIEs,
        ____MBMSNotificationUpdateCommand_protocolExtensions__item__id_tab,
        ___MBMSNotificationUpdateCommand_protocolExtensions__item__id,
        ____MBMSNotificationUpdateCommand_protocolExtensions__item__criticality_tab,
        ___MBMSNotificationUpdateCommand_protocolExtensions__item__criticality,
        ____MBMSNotificationUpdateCommand_protocolExtensions__item__extensionValue_tab,
        ___MBMSNotificationUpdateCommand_protocolExtensions__item__extensionValue,
        __MBMSNotificationUpdateCommand_protocolExtensions__item_,
        _MBMSNotificationUpdateCommand_protocolExtensions,
        MBMSNotificationUpdateCommand,
        MBMSNotificationUpdateCommand_IEs,
        _MBMSNotificationUpdateCommand_IEs_val_Value_0,
        _MBMSNotificationUpdateCommand_IEs_val_Value_1,
        _MBMSNotificationUpdateCommand_IEs_val_Value_2,
        _MBMSNotificationUpdateCommand_IEs_val_Value_3,
        _MBMSNotificationUpdateCommand_IEs_val_Value_4,
        MBMSNotificationUpdateCommand_Extensions,
        ____UEStatusUpdateCommand_protocolIEs__item__id_tab,
        _____UEStatusUpdateCommand_protocolIEs__item__id_tab_val_Value_0,
        ___UEStatusUpdateCommand_protocolIEs__item__id,
        ___UEStatusUpdateCommand_protocolIEs__item__criticality,
        ___UEStatusUpdateCommand_protocolIEs__item__value,
        __UEStatusUpdateCommand_protocolIEs__item_,
        _UEStatusUpdateCommand_protocolIEs,
        ____UEStatusUpdateCommand_protocolExtensions__item__id_tab,
        ___UEStatusUpdateCommand_protocolExtensions__item__id,
        ____UEStatusUpdateCommand_protocolExtensions__item__criticality_tab,
        ___UEStatusUpdateCommand_protocolExtensions__item__criticality,
        ____UEStatusUpdateCommand_protocolExtensions__item__extensionValue_tab,
        ___UEStatusUpdateCommand_protocolExtensions__item__extensionValue,
        __UEStatusUpdateCommand_protocolExtensions__item_,
        _UEStatusUpdateCommand_protocolExtensions,
        UEStatusUpdateCommand,
        UEStatusUpdateCommand_IEs,
        _UEStatusUpdateCommand_IEs_val_Value_0,
        UEStatusUpdateCommand_Extensions,
        ____SecondaryULFrequencyReport_protocolIEs__item__id_tab,
        _____SecondaryULFrequencyReport_protocolIEs__item__id_tab_val_Value_0,
        _____SecondaryULFrequencyReport_protocolIEs__item__id_tab_val_Value_1,
        ___SecondaryULFrequencyReport_protocolIEs__item__id,
        ___SecondaryULFrequencyReport_protocolIEs__item__criticality,
        ___SecondaryULFrequencyReport_protocolIEs__item__value,
        __SecondaryULFrequencyReport_protocolIEs__item_,
        _SecondaryULFrequencyReport_protocolIEs,
        ____SecondaryULFrequencyReport_protocolExtensions__item__id_tab,
        ___SecondaryULFrequencyReport_protocolExtensions__item__id,
        ____SecondaryULFrequencyReport_protocolExtensions__item__criticality_tab,
        ___SecondaryULFrequencyReport_protocolExtensions__item__criticality,
        ____SecondaryULFrequencyReport_protocolExtensions__item__extensionValue_tab,
        ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue,
        __SecondaryULFrequencyReport_protocolExtensions__item_,
        _SecondaryULFrequencyReport_protocolExtensions,
        SecondaryULFrequencyReport,
        SecondaryULFrequencyReport_IEs,
        _SecondaryULFrequencyReport_IEs_val_Value_0,
        _SecondaryULFrequencyReport_IEs_val_Value_1,
        SecondaryULFrequencyReport_Extensions,
        ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab,
        _____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab_val_Value_0,
        _____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab_val_Value_1,
        ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id,
        ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality,
        ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value,
        __SecondaryULFrequencyUpdateIndication_protocolIEs__item_,
        _SecondaryULFrequencyUpdateIndication_protocolIEs,
        ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id_tab,
        ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id,
        ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality_tab,
        ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality,
        ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue_tab,
        ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue,
        __SecondaryULFrequencyUpdateIndication_protocolExtensions__item_,
        _SecondaryULFrequencyUpdateIndication_protocolExtensions,
        SecondaryULFrequencyUpdateIndication,
        SecondaryULFrequencyUpdateIndication_IEs,
        _SecondaryULFrequencyUpdateIndication_IEs_val_Value_0,
        _SecondaryULFrequencyUpdateIndication_IEs_val_Value_1,
        SecondaryULFrequencyUpdateIndication_Extensions,
        ____UEStatusUpdateConfirmRequest_protocolIEs__item__id_tab,
        _____UEStatusUpdateConfirmRequest_protocolIEs__item__id_tab_val_Value_0,
        ___UEStatusUpdateConfirmRequest_protocolIEs__item__id,
        ___UEStatusUpdateConfirmRequest_protocolIEs__item__criticality,
        ___UEStatusUpdateConfirmRequest_protocolIEs__item__value,
        __UEStatusUpdateConfirmRequest_protocolIEs__item_,
        _UEStatusUpdateConfirmRequest_protocolIEs,
        ____UEStatusUpdateConfirmRequest_protocolExtensions__item__id_tab,
        ___UEStatusUpdateConfirmRequest_protocolExtensions__item__id,
        ____UEStatusUpdateConfirmRequest_protocolExtensions__item__criticality_tab,
        ___UEStatusUpdateConfirmRequest_protocolExtensions__item__criticality,
        ____UEStatusUpdateConfirmRequest_protocolExtensions__item__extensionValue_tab,
        ___UEStatusUpdateConfirmRequest_protocolExtensions__item__extensionValue,
        __UEStatusUpdateConfirmRequest_protocolExtensions__item_,
        _UEStatusUpdateConfirmRequest_protocolExtensions,
        UEStatusUpdateConfirmRequest,
        UEStatusUpdateConfirmRequest_IEs,
        _UEStatusUpdateConfirmRequest_IEs_val_Value_0,
        UEStatusUpdateConfirmRequest_Extensions,
        ____UEStatusUpdateConfirmResponse_protocolIEs__item__id_tab,
        _____UEStatusUpdateConfirmResponse_protocolIEs__item__id_tab_val_Value_0,
        ___UEStatusUpdateConfirmResponse_protocolIEs__item__id,
        ___UEStatusUpdateConfirmResponse_protocolIEs__item__criticality,
        ___UEStatusUpdateConfirmResponse_protocolIEs__item__value,
        __UEStatusUpdateConfirmResponse_protocolIEs__item_,
        _UEStatusUpdateConfirmResponse_protocolIEs,
        ____UEStatusUpdateConfirmResponse_protocolExtensions__item__id_tab,
        ___UEStatusUpdateConfirmResponse_protocolExtensions__item__id,
        ____UEStatusUpdateConfirmResponse_protocolExtensions__item__criticality_tab,
        ___UEStatusUpdateConfirmResponse_protocolExtensions__item__criticality,
        ____UEStatusUpdateConfirmResponse_protocolExtensions__item__extensionValue_tab,
        ___UEStatusUpdateConfirmResponse_protocolExtensions__item__extensionValue,
        __UEStatusUpdateConfirmResponse_protocolExtensions__item_,
        _UEStatusUpdateConfirmResponse_protocolExtensions,
        UEStatusUpdateConfirmResponse,
        UEStatusUpdateConfirmResponse_IEs,
        _UEStatusUpdateConfirmResponse_IEs_val_Value_0,
        UEStatusUpdateConfirmResponse_Extensions,
    ]

class NBAP_PDU_Descriptions:

    _name_  = 'NBAP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 20, 3, 2, 1, 0]
    
    _obj_ = [
        'NBAP-ELEMENTARY-PROCEDURE',
        'NBAP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'Outcome',
        'NBAP-ELEMENTARY-PROCEDURES',
        'NBAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'NBAP-ELEMENTARY-PROCEDURES-CLASS-2',
        'cellSetupFDD',
        'cellSetupTDD',
        'cellReconfigurationFDD',
        'cellReconfigurationTDD',
        'cellDeletion',
        'commonTransportChannelSetupFDD',
        'commonTransportChannelSetupTDD',
        'commonTransportChannelReconfigureFDD',
        'commonTransportChannelReconfigureTDD',
        'commonTransportChannelDelete',
        'audit',
        'blockResource',
        'radioLinkSetupFDD',
        'radioLinkSetupTDD',
        'systemInformationUpdate',
        'reset',
        'commonMeasurementInitiation',
        'radioLinkAdditionFDD',
        'radioLinkAdditionTDD',
        'radioLinkDeletion',
        'synchronisedRadioLinkReconfigurationPreparationFDD',
        'synchronisedRadioLinkReconfigurationPreparationTDD',
        'unSynchronisedRadioLinkReconfigurationFDD',
        'unSynchronisedRadioLinkReconfigurationTDD',
        'dedicatedMeasurementInitiation',
        'physicalSharedChannelReconfigurationFDD',
        'physicalSharedChannelReconfigurationTDD',
        'informationExchangeInitiation',
        'cellSynchronisationInitiationTDD',
        'cellSynchronisationReconfigurationTDD',
        'cellSynchronisationAdjustmentTDD',
        'ueStatusUpdateConfirmation',
        'resourceStatusIndication',
        'auditRequired',
        'commonMeasurementReport',
        'commonMeasurementTermination',
        'commonMeasurementFailure',
        'synchronisedRadioLinkReconfigurationCommit',
        'synchronisedRadioLinkReconfigurationCancellation',
        'radioLinkFailure',
        'radioLinkPreemption',
        'radioLinkRestoration',
        'dedicatedMeasurementReport',
        'dedicatedMeasurementTermination',
        'dedicatedMeasurementFailure',
        'downlinkPowerControlFDD',
        'downlinkPowerTimeslotControl',
        'compressedModeCommand',
        'unblockResource',
        'errorIndicationForDedicated',
        'errorIndicationForCommon',
        'cellSynchronisationReportingTDD',
        'cellSynchronisationTerminationTDD',
        'cellSynchronisationFailureTDD',
        'privateMessageForDedicated',
        'privateMessageForCommon',
        'informationReporting',
        'informationExchangeTermination',
        'informationExchangeFailure',
        'bearerRearrangement',
        'radioLinkActivationFDD',
        'radioLinkActivationTDD',
        'radioLinkParameterUpdateFDD',
        'radioLinkParameterUpdateTDD',
        'mBMSNotificationUpdate',
        'uEStatusUpdate',
        'secondaryULFrequencyReportingFDD',
        'secondaryULFrequencyUpdateFDD',
        ]
    _type_ = [
        'NBAP-ELEMENTARY-PROCEDURE',
        'NBAP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'Outcome',
        ]
    _set_ = [
        'NBAP-ELEMENTARY-PROCEDURES',
        'NBAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'NBAP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'cellSetupFDD',
        'cellSetupTDD',
        'cellReconfigurationFDD',
        'cellReconfigurationTDD',
        'cellDeletion',
        'commonTransportChannelSetupFDD',
        'commonTransportChannelSetupTDD',
        'commonTransportChannelReconfigureFDD',
        'commonTransportChannelReconfigureTDD',
        'commonTransportChannelDelete',
        'audit',
        'blockResource',
        'radioLinkSetupFDD',
        'radioLinkSetupTDD',
        'systemInformationUpdate',
        'reset',
        'commonMeasurementInitiation',
        'radioLinkAdditionFDD',
        'radioLinkAdditionTDD',
        'radioLinkDeletion',
        'synchronisedRadioLinkReconfigurationPreparationFDD',
        'synchronisedRadioLinkReconfigurationPreparationTDD',
        'unSynchronisedRadioLinkReconfigurationFDD',
        'unSynchronisedRadioLinkReconfigurationTDD',
        'dedicatedMeasurementInitiation',
        'physicalSharedChannelReconfigurationFDD',
        'physicalSharedChannelReconfigurationTDD',
        'informationExchangeInitiation',
        'cellSynchronisationInitiationTDD',
        'cellSynchronisationReconfigurationTDD',
        'cellSynchronisationAdjustmentTDD',
        'ueStatusUpdateConfirmation',
        'resourceStatusIndication',
        'auditRequired',
        'commonMeasurementReport',
        'commonMeasurementTermination',
        'commonMeasurementFailure',
        'synchronisedRadioLinkReconfigurationCommit',
        'synchronisedRadioLinkReconfigurationCancellation',
        'radioLinkFailure',
        'radioLinkPreemption',
        'radioLinkRestoration',
        'dedicatedMeasurementReport',
        'dedicatedMeasurementTermination',
        'dedicatedMeasurementFailure',
        'downlinkPowerControlFDD',
        'downlinkPowerTimeslotControl',
        'compressedModeCommand',
        'unblockResource',
        'errorIndicationForDedicated',
        'errorIndicationForCommon',
        'cellSynchronisationReportingTDD',
        'cellSynchronisationTerminationTDD',
        'cellSynchronisationFailureTDD',
        'privateMessageForDedicated',
        'privateMessageForCommon',
        'informationReporting',
        'informationExchangeTermination',
        'informationExchangeFailure',
        'bearerRearrangement',
        'radioLinkActivationFDD',
        'radioLinkActivationTDD',
        'radioLinkParameterUpdateFDD',
        'radioLinkParameterUpdateTDD',
        'mBMSNotificationUpdate',
        'uEStatusUpdate',
        'secondaryULFrequencyReportingFDD',
        'secondaryULFrequencyUpdateFDD',
        ]
    _class_ = [
        'NBAP-ELEMENTARY-PROCEDURE',
        'NBAP-ELEMENTARY-PROCEDURES',
        'NBAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'NBAP-ELEMENTARY-PROCEDURES-CLASS-2',
        'cellSetupFDD',
        'cellSetupTDD',
        'cellReconfigurationFDD',
        'cellReconfigurationTDD',
        'cellDeletion',
        'commonTransportChannelSetupFDD',
        'commonTransportChannelSetupTDD',
        'commonTransportChannelReconfigureFDD',
        'commonTransportChannelReconfigureTDD',
        'commonTransportChannelDelete',
        'audit',
        'blockResource',
        'radioLinkSetupFDD',
        'radioLinkSetupTDD',
        'systemInformationUpdate',
        'reset',
        'commonMeasurementInitiation',
        'radioLinkAdditionFDD',
        'radioLinkAdditionTDD',
        'radioLinkDeletion',
        'synchronisedRadioLinkReconfigurationPreparationFDD',
        'synchronisedRadioLinkReconfigurationPreparationTDD',
        'unSynchronisedRadioLinkReconfigurationFDD',
        'unSynchronisedRadioLinkReconfigurationTDD',
        'dedicatedMeasurementInitiation',
        'physicalSharedChannelReconfigurationFDD',
        'physicalSharedChannelReconfigurationTDD',
        'informationExchangeInitiation',
        'cellSynchronisationInitiationTDD',
        'cellSynchronisationReconfigurationTDD',
        'cellSynchronisationAdjustmentTDD',
        'ueStatusUpdateConfirmation',
        'resourceStatusIndication',
        'auditRequired',
        'commonMeasurementReport',
        'commonMeasurementTermination',
        'commonMeasurementFailure',
        'synchronisedRadioLinkReconfigurationCommit',
        'synchronisedRadioLinkReconfigurationCancellation',
        'radioLinkFailure',
        'radioLinkPreemption',
        'radioLinkRestoration',
        'dedicatedMeasurementReport',
        'dedicatedMeasurementTermination',
        'dedicatedMeasurementFailure',
        'downlinkPowerControlFDD',
        'downlinkPowerTimeslotControl',
        'compressedModeCommand',
        'unblockResource',
        'errorIndicationForDedicated',
        'errorIndicationForCommon',
        'cellSynchronisationReportingTDD',
        'cellSynchronisationTerminationTDD',
        'cellSynchronisationFailureTDD',
        'privateMessageForDedicated',
        'privateMessageForCommon',
        'informationReporting',
        'informationExchangeTermination',
        'informationExchangeFailure',
        'bearerRearrangement',
        'radioLinkActivationFDD',
        'radioLinkActivationTDD',
        'radioLinkParameterUpdateFDD',
        'radioLinkParameterUpdateTDD',
        'mBMSNotificationUpdate',
        'uEStatusUpdate',
        'secondaryULFrequencyReportingFDD',
        'secondaryULFrequencyUpdateFDD',
        ]
    _param_ = [
        ]
    
    #-----< NBAP-ELEMENTARY-PROCEDURE >-----#
    NBAP_ELEMENTARY_PROCEDURE = CLASS(name='NBAP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _NBAP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _NBAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _NBAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _NBAP_ELEMENTARY_PROCEDURE_Outcome = OPEN(name='Outcome', mode=MODE_TYPE, opt=True)
    _NBAP_ELEMENTARY_PROCEDURE_messageDiscriminator = ENUM(name='messageDiscriminator', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'MessageDiscriminator')))
    _NBAP_ELEMENTARY_PROCEDURE_procedureID = SEQ(name='procedureID', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'ProcedureID')), uniq=True)
    _NBAP_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-CommonDataTypes', 'Criticality')), default='ignore')
    NBAP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('Outcome', _NBAP_ELEMENTARY_PROCEDURE_Outcome),
        ('messageDiscriminator', _NBAP_ELEMENTARY_PROCEDURE_messageDiscriminator),
        ('procedureID', _NBAP_ELEMENTARY_PROCEDURE_procedureID),
        ('criticality', _NBAP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< NBAP-PDU >-----#
    NBAP_PDU = CHOICE(name='NBAP-PDU', mode=MODE_TYPE)
    _NBAP_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'InitiatingMessage')))
    _NBAP_PDU_succesfulOutcome = SEQ(name='succesfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'SuccessfulOutcome')))
    _NBAP_PDU_unsuccesfulOutcome = SEQ(name='unsuccesfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    _NBAP_PDU_outcome = SEQ(name='outcome', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'Outcome')))
    NBAP_PDU._cont = ASN1Dict([
        ('initiatingMessage', _NBAP_PDU_initiatingMessage),
        ('succesfulOutcome', _NBAP_PDU_succesfulOutcome),
        ('unsuccesfulOutcome', _NBAP_PDU_unsuccesfulOutcome),
        ('outcome', _NBAP_PDU_outcome),
        ])
    NBAP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureID = SEQ(name='procedureID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['procedureID']))
    __InitiatingMessage_procedureID_tab = CLASS(name='_tab_NBAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionResponse')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionResponse')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetResponse')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_23 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResourceStatusIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequiredIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementReport')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkFailureIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementReport')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerControlRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CompressedModeCommand')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UnblockResourceIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_47 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_47 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_48 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationResponseTDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_48 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationFailureTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_49 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationResponseTDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_49 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationFailureTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_50 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentResponseTDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_50 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentFailureTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_51 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_51 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_52 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmResponse')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationReport')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReportTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationTerminationRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationFailureIndicationTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BearerRearrangementIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MBMSNotificationUpdateCommand')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateCommand')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    __InitiatingMessage_procedureID_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_0), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_1), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_2), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_3), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_4), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 3), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_5), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_6), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_7), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_8), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_9), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 10), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_10), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 0), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_11), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 2), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_12), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_13), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_14), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 32), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_15), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 7), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_16), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_17), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_18), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 24), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_19), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 13), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_20), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_21), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_22), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_23), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_23), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_24), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 17), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_25), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_26), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 28), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_27), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 1), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_28), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 8), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_29), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 9), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_30), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 6), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_31), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 30), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_32), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 29), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_33), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 25), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_34), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 39), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_35), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 26), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_36), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 18), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_37), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 19), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_38), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 16), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_39), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 20), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_40), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 38), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_41), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 14), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_42), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 33), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_43), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 21), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_44), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 35), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_45), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 22), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_46), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 36), ('ddMode', 'common')])), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_47), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_47), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_47), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 41), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_48), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_48), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_48), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 45), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_49), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_49), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_49), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 46), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_50), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_50), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_50), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 44), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_51), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_51), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_51), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_52), ('SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_52), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 57), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_53), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 43), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_54), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 42), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_55), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 40), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_56), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 47), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_57), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 48), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_58), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 49), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_59), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 50), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_60), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_61), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_62), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_63), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_64), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 53), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_65), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 54), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_66), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 55), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_67), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 56), ('ddMode', 'fdd')])), ('criticality', 'ignore')])], er=[])
    _InitiatingMessage_procedureID._const_tab = __InitiatingMessage_procedureID_tab
    _InitiatingMessage_procedureID._const_tab_at = None
    _InitiatingMessage_procedureID._const_tab_id = 'procedureID'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureID_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureID')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_messageDiscriminator = ENUM(name='messageDiscriminator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['messageDiscriminator']))
    _InitiatingMessage_messageDiscriminator._const_tab = __InitiatingMessage_procedureID_tab
    _InitiatingMessage_messageDiscriminator._const_tab_at = ('..', 'procedureID')
    _InitiatingMessage_messageDiscriminator._const_tab_id = 'messageDiscriminator'
    _InitiatingMessage_transactionID = CHOICE(name='transactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'TransactionID')))
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureID_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureID')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureID', _InitiatingMessage_procedureID),
        ('criticality', _InitiatingMessage_criticality),
        ('messageDiscriminator', _InitiatingMessage_messageDiscriminator),
        ('transactionID', _InitiatingMessage_transactionID),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureID = SEQ(name='procedureID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['procedureID']))
    __SuccessfulOutcome_procedureID_tab = CLASS(name='_tab_NBAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_23 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResourceStatusIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequiredIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementReport')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkFailureIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementReport')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerControlRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CompressedModeCommand')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UnblockResourceIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_47 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_47 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_48 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationResponseTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_48 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationFailureTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_49 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationResponseTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_49 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationFailureTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_50 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentResponseTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_50 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentFailureTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_51 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_51 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_52 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationReport')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReportTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationTerminationRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationFailureIndicationTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BearerRearrangementIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MBMSNotificationUpdateCommand')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateCommand')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    __SuccessfulOutcome_procedureID_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 3), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 10), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 0), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 2), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_14), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 32), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_15), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 7), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_16), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_17), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_18), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 24), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_19), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 13), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_20), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_21), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_22), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_23), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_23), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_24), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 17), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_25), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 28), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 1), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 8), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 9), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 6), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 30), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 29), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 25), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 39), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 26), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 18), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 19), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 16), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 20), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 38), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 14), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 33), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 21), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 35), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 22), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 36), ('ddMode', 'common')])), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_47), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_47), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 41), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_48), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_48), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 45), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_49), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_49), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 46), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_50), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_50), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 44), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_51), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_51), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_52), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 57), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 43), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 42), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 40), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 47), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 48), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 49), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 50), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 53), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 54), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 55), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_67), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 56), ('ddMode', 'fdd')])), ('criticality', 'ignore')])], er=[])
    _SuccessfulOutcome_procedureID._const_tab = __SuccessfulOutcome_procedureID_tab
    _SuccessfulOutcome_procedureID._const_tab_at = None
    _SuccessfulOutcome_procedureID._const_tab_id = 'procedureID'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureID_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureID')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_messageDiscriminator = ENUM(name='messageDiscriminator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['messageDiscriminator']))
    _SuccessfulOutcome_messageDiscriminator._const_tab = __SuccessfulOutcome_procedureID_tab
    _SuccessfulOutcome_messageDiscriminator._const_tab_at = ('..', 'procedureID')
    _SuccessfulOutcome_messageDiscriminator._const_tab_id = 'messageDiscriminator'
    _SuccessfulOutcome_transactionID = CHOICE(name='transactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'TransactionID')))
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureID_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureID')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureID', _SuccessfulOutcome_procedureID),
        ('criticality', _SuccessfulOutcome_criticality),
        ('messageDiscriminator', _SuccessfulOutcome_messageDiscriminator),
        ('transactionID', _SuccessfulOutcome_transactionID),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureID = SEQ(name='procedureID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['procedureID']))
    __UnsuccessfulOutcome_procedureID_tab = CLASS(name='_tab_NBAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_23 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResourceStatusIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequiredIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementReport')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkFailureIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementReport')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerControlRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CompressedModeCommand')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UnblockResourceIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_47 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_47 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_48 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationResponseTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_48 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationFailureTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_49 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationResponseTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_49 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationFailureTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_50 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentResponseTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_50 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentFailureTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_51 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_51 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_52 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationReport')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReportTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationTerminationRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationFailureIndicationTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BearerRearrangementIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MBMSNotificationUpdateCommand')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateCommand')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    __UnsuccessfulOutcome_procedureID_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 3), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 10), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 0), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 2), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_14), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 32), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_15), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 7), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_16), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_17), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_18), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 24), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_19), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 13), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_20), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_21), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_22), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_23), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_23), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_24), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 17), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_25), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 28), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 1), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 8), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 9), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 6), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 30), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 29), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 25), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 39), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 26), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 18), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 19), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 16), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 20), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 38), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 14), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 33), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 21), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 35), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 22), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 36), ('ddMode', 'common')])), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_47), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_47), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 41), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_48), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_48), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 45), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_49), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_49), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 46), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_50), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_50), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 44), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_51), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_51), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_52), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 57), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 43), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 42), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 40), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 47), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 48), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 49), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 50), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 53), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 54), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 55), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_67), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 56), ('ddMode', 'fdd')])), ('criticality', 'ignore')])], er=[])
    _UnsuccessfulOutcome_procedureID._const_tab = __UnsuccessfulOutcome_procedureID_tab
    _UnsuccessfulOutcome_procedureID._const_tab_at = None
    _UnsuccessfulOutcome_procedureID._const_tab_id = 'procedureID'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureID_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureID')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_messageDiscriminator = ENUM(name='messageDiscriminator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['messageDiscriminator']))
    _UnsuccessfulOutcome_messageDiscriminator._const_tab = __UnsuccessfulOutcome_procedureID_tab
    _UnsuccessfulOutcome_messageDiscriminator._const_tab_at = ('..', 'procedureID')
    _UnsuccessfulOutcome_messageDiscriminator._const_tab_id = 'messageDiscriminator'
    _UnsuccessfulOutcome_transactionID = CHOICE(name='transactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'TransactionID')))
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureID_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureID')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureID', _UnsuccessfulOutcome_procedureID),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('messageDiscriminator', _UnsuccessfulOutcome_messageDiscriminator),
        ('transactionID', _UnsuccessfulOutcome_transactionID),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< Outcome >-----#
    Outcome = SEQ(name='Outcome', mode=MODE_TYPE)
    _Outcome_procedureID = SEQ(name='procedureID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['procedureID']))
    __Outcome_procedureID_tab = CLASS(name='_tab_NBAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionResponse')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionResponse')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetResponse')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_23 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResourceStatusIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequiredIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementReport')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkFailureIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementReport')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerControlRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CompressedModeCommand')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UnblockResourceIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_47 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_47 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_48 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationResponseTDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_48 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationFailureTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_49 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationResponseTDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_49 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationFailureTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_50 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentResponseTDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_50 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentFailureTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_51 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_51 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_52 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmResponse')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationReport')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReportTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationTerminationRequestTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationFailureIndicationTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BearerRearrangementIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MBMSNotificationUpdateCommand')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateCommand')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    __Outcome_procedureID_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_0), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_1), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_2), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_3), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_4), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 3), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_5), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_6), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_7), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_8), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_9), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 10), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_10), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 0), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_11), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 2), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_12), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_13), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_14), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 32), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_15), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 7), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_16), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_17), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_18), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 24), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_19), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 13), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_20), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_21), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_22), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_23), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_23), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_24), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 17), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_25), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_26), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 28), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_27), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 1), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_28), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 8), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_29), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 9), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_30), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 6), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_31), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 30), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_32), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 29), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_33), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 25), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_34), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 39), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_35), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 26), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_36), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 18), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_37), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 19), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_38), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 16), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_39), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 20), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_40), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 38), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_41), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 14), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_42), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 33), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_43), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 21), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_44), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 35), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_45), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 22), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_46), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 36), ('ddMode', 'common')])), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_47), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_47), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_47), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 41), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_48), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_48), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_48), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 45), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_49), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_49), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_49), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 46), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_50), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_50), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_50), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 44), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_51), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_51), ('UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_51), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_52), ('SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_52), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 57), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_53), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 43), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_54), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 42), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_55), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 40), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_56), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 47), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_57), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 48), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_58), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 49), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_59), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 50), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_60), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_61), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_62), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_63), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_64), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 53), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_65), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 54), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_66), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 55), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_67), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 56), ('ddMode', 'fdd')])), ('criticality', 'ignore')])], er=[])
    _Outcome_procedureID._const_tab = __Outcome_procedureID_tab
    _Outcome_procedureID._const_tab_at = None
    _Outcome_procedureID._const_tab_id = 'procedureID'
    _Outcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _Outcome_criticality._const_tab = __Outcome_procedureID_tab
    _Outcome_criticality._const_tab_at = ('..', 'procedureID')
    _Outcome_criticality._const_tab_id = 'criticality'
    _Outcome_messageDiscriminator = ENUM(name='messageDiscriminator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['messageDiscriminator']))
    _Outcome_messageDiscriminator._const_tab = __Outcome_procedureID_tab
    _Outcome_messageDiscriminator._const_tab_at = ('..', 'procedureID')
    _Outcome_messageDiscriminator._const_tab_id = 'messageDiscriminator'
    _Outcome_transactionID = CHOICE(name='transactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NBAP-CommonDataTypes', 'TransactionID')))
    _Outcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE'), ['Outcome']))
    _Outcome_value._const_tab = __Outcome_procedureID_tab
    _Outcome_value._const_tab_at = ('..', 'procedureID')
    _Outcome_value._const_tab_id = 'Outcome'
    Outcome._cont = ASN1Dict([
        ('procedureID', _Outcome_procedureID),
        ('criticality', _Outcome_criticality),
        ('messageDiscriminator', _Outcome_messageDiscriminator),
        ('transactionID', _Outcome_transactionID),
        ('value', _Outcome_value),
        ])
    Outcome._ext = None
    
    #-----< NBAP-ELEMENTARY-PROCEDURES >-----#
    NBAP_ELEMENTARY_PROCEDURES = CLASS(name='NBAP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_23 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResourceStatusIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequiredIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementReport')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkFailureIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementReport')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerControlRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CompressedModeCommand')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UnblockResourceIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_47 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_47 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_48 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationResponseTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_48 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationFailureTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_49 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationResponseTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_49 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationFailureTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_50 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentResponseTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_50 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentFailureTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_51 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_51 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_52 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationReport')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReportTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationTerminationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationFailureIndicationTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BearerRearrangementIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MBMSNotificationUpdateCommand')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateCommand')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    NBAP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 3), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 10), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 0), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 2), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 32), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 7), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 24), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 13), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_22), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_23), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 17), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 28), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 1), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 8), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 9), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 6), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 30), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 29), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 25), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 39), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 26), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 18), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 19), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 16), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 20), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 38), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 14), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 33), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 21), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 35), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 22), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 36), ('ddMode', 'common')])), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_47), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_47), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 41), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_48), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_48), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 45), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_49), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_49), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 46), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_50), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_50), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 44), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_51), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_51), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_52), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 57), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 43), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 42), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 40), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 47), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 48), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 49), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 50), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 53), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 54), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 55), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_67), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 56), ('ddMode', 'fdd')])), ('criticality', 'ignore')])], er=[])
    
    #-----< NBAP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    NBAP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='NBAP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_23 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_26 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_27 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationResponseTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_27 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationFailureTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationResponseTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_28 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationFailureTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_29 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentResponseTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_29 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentFailureTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_30 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_30 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_31 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmResponse')))
    NBAP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 3), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 10), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 0), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 2), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 32), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 7), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 24), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 13), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_22), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_23), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 17), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'tdd')])), ('criticality', 'reject')])], rr=[], ev=[dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_26), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 41), ('ddMode', 'common')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_27), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_27), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_27), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 45), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_28), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_28), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_28), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 46), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_29), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_29), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_29), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 44), ('ddMode', 'tdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_30), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_30), ('UnsuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_30), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'fdd')])), ('criticality', 'reject')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_31), ('SuccessfulOutcome', _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_31), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 57), ('ddMode', 'common')])), ('criticality', 'reject')])], er=[])
    
    #-----< NBAP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    NBAP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='NBAP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResourceStatusIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequiredIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementReport')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkFailureIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementReport')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerControlRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CompressedModeCommand')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UnblockResourceIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationReport')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReportTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationTerminationRequestTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationFailureIndicationTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BearerRearrangementIndication')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MBMSNotificationUpdateCommand')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateCommand')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    NBAP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 28), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 1), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 8), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 9), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 6), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 30), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 29), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 25), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 39), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 26), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 18), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 19), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 16), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 20), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 38), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 14), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 33), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 21), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 35), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 22), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 36), ('ddMode', 'common')])), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 43), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 42), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 40), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 47), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 48), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 49), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 50), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'tdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 53), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 54), ('ddMode', 'common')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 55), ('ddMode', 'fdd')])), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 56), ('ddMode', 'fdd')])), ('criticality', 'ignore')])], er=[])
    
    #-----< cellSetupFDD >-----#
    cellSetupFDD = CLASS(name='cellSetupFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _cellSetupFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestFDD')))
    _cellSetupFDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    _cellSetupFDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    cellSetupFDD._val = dict([('InitiatingMessage', _cellSetupFDD_val_InitiatingMessage), ('SuccessfulOutcome', _cellSetupFDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _cellSetupFDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'fdd')])), ('criticality', 'reject')])
    
    #-----< cellSetupTDD >-----#
    cellSetupTDD = CLASS(name='cellSetupTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _cellSetupTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupRequestTDD')))
    _cellSetupTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupResponse')))
    _cellSetupTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSetupFailure')))
    cellSetupTDD._val = dict([('InitiatingMessage', _cellSetupTDD_val_InitiatingMessage), ('SuccessfulOutcome', _cellSetupTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _cellSetupTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 5), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< cellReconfigurationFDD >-----#
    cellReconfigurationFDD = CLASS(name='cellReconfigurationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _cellReconfigurationFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestFDD')))
    _cellReconfigurationFDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    _cellReconfigurationFDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    cellReconfigurationFDD._val = dict([('InitiatingMessage', _cellReconfigurationFDD_val_InitiatingMessage), ('SuccessfulOutcome', _cellReconfigurationFDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _cellReconfigurationFDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'fdd')])), ('criticality', 'reject')])
    
    #-----< cellReconfigurationTDD >-----#
    cellReconfigurationTDD = CLASS(name='cellReconfigurationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _cellReconfigurationTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationRequestTDD')))
    _cellReconfigurationTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationResponse')))
    _cellReconfigurationTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellReconfigurationFailure')))
    cellReconfigurationTDD._val = dict([('InitiatingMessage', _cellReconfigurationTDD_val_InitiatingMessage), ('SuccessfulOutcome', _cellReconfigurationTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _cellReconfigurationTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 4), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< cellDeletion >-----#
    cellDeletion = CLASS(name='cellDeletion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _cellDeletion_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionRequest')))
    _cellDeletion_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellDeletionResponse')))
    cellDeletion._val = dict([('InitiatingMessage', _cellDeletion_val_InitiatingMessage), ('SuccessfulOutcome', _cellDeletion_val_SuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 3), ('ddMode', 'common')])), ('criticality', 'reject')])
    
    #-----< commonTransportChannelSetupFDD >-----#
    commonTransportChannelSetupFDD = CLASS(name='commonTransportChannelSetupFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _commonTransportChannelSetupFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestFDD')))
    _commonTransportChannelSetupFDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    _commonTransportChannelSetupFDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    commonTransportChannelSetupFDD._val = dict([('InitiatingMessage', _commonTransportChannelSetupFDD_val_InitiatingMessage), ('SuccessfulOutcome', _commonTransportChannelSetupFDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _commonTransportChannelSetupFDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'fdd')])), ('criticality', 'reject')])
    
    #-----< commonTransportChannelSetupTDD >-----#
    commonTransportChannelSetupTDD = CLASS(name='commonTransportChannelSetupTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _commonTransportChannelSetupTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupRequestTDD')))
    _commonTransportChannelSetupTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupResponse')))
    _commonTransportChannelSetupTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelSetupFailure')))
    commonTransportChannelSetupTDD._val = dict([('InitiatingMessage', _commonTransportChannelSetupTDD_val_InitiatingMessage), ('SuccessfulOutcome', _commonTransportChannelSetupTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _commonTransportChannelSetupTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 12), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< commonTransportChannelReconfigureFDD >-----#
    commonTransportChannelReconfigureFDD = CLASS(name='commonTransportChannelReconfigureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _commonTransportChannelReconfigureFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestFDD')))
    _commonTransportChannelReconfigureFDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    _commonTransportChannelReconfigureFDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    commonTransportChannelReconfigureFDD._val = dict([('InitiatingMessage', _commonTransportChannelReconfigureFDD_val_InitiatingMessage), ('SuccessfulOutcome', _commonTransportChannelReconfigureFDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _commonTransportChannelReconfigureFDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'fdd')])), ('criticality', 'reject')])
    
    #-----< commonTransportChannelReconfigureTDD >-----#
    commonTransportChannelReconfigureTDD = CLASS(name='commonTransportChannelReconfigureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _commonTransportChannelReconfigureTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationRequestTDD')))
    _commonTransportChannelReconfigureTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationResponse')))
    _commonTransportChannelReconfigureTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelReconfigurationFailure')))
    commonTransportChannelReconfigureTDD._val = dict([('InitiatingMessage', _commonTransportChannelReconfigureTDD_val_InitiatingMessage), ('SuccessfulOutcome', _commonTransportChannelReconfigureTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _commonTransportChannelReconfigureTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 11), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< commonTransportChannelDelete >-----#
    commonTransportChannelDelete = CLASS(name='commonTransportChannelDelete', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _commonTransportChannelDelete_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionRequest')))
    _commonTransportChannelDelete_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonTransportChannelDeletionResponse')))
    commonTransportChannelDelete._val = dict([('InitiatingMessage', _commonTransportChannelDelete_val_InitiatingMessage), ('SuccessfulOutcome', _commonTransportChannelDelete_val_SuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 10), ('ddMode', 'common')])), ('criticality', 'reject')])
    
    #-----< audit >-----#
    audit = CLASS(name='audit', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _audit_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequest')))
    _audit_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditResponse')))
    _audit_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditFailure')))
    audit._val = dict([('InitiatingMessage', _audit_val_InitiatingMessage), ('SuccessfulOutcome', _audit_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _audit_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 0), ('ddMode', 'common')])), ('criticality', 'reject')])
    
    #-----< blockResource >-----#
    blockResource = CLASS(name='blockResource', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _blockResource_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceRequest')))
    _blockResource_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceResponse')))
    _blockResource_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BlockResourceFailure')))
    blockResource._val = dict([('InitiatingMessage', _blockResource_val_InitiatingMessage), ('SuccessfulOutcome', _blockResource_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _blockResource_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 2), ('ddMode', 'common')])), ('criticality', 'reject')])
    
    #-----< radioLinkSetupFDD >-----#
    radioLinkSetupFDD = CLASS(name='radioLinkSetupFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkSetupFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    _radioLinkSetupFDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    _radioLinkSetupFDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    radioLinkSetupFDD._val = dict([('InitiatingMessage', _radioLinkSetupFDD_val_InitiatingMessage), ('SuccessfulOutcome', _radioLinkSetupFDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _radioLinkSetupFDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'fdd')])), ('criticality', 'reject')])
    
    #-----< radioLinkSetupTDD >-----#
    radioLinkSetupTDD = CLASS(name='radioLinkSetupTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkSetupTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    _radioLinkSetupTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    _radioLinkSetupTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    radioLinkSetupTDD._val = dict([('InitiatingMessage', _radioLinkSetupTDD_val_InitiatingMessage), ('SuccessfulOutcome', _radioLinkSetupTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _radioLinkSetupTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 27), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< systemInformationUpdate >-----#
    systemInformationUpdate = CLASS(name='systemInformationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _systemInformationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateRequest')))
    _systemInformationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateResponse')))
    _systemInformationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SystemInformationUpdateFailure')))
    systemInformationUpdate._val = dict([('InitiatingMessage', _systemInformationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _systemInformationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _systemInformationUpdate_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 32), ('ddMode', 'common')])), ('criticality', 'reject')])
    
    #-----< reset >-----#
    reset = CLASS(name='reset', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetRequest')))
    _reset_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResetResponse')))
    reset._val = dict([('InitiatingMessage', _reset_val_InitiatingMessage), ('SuccessfulOutcome', _reset_val_SuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 13), ('ddMode', 'common')])), ('criticality', 'reject')])
    
    #-----< commonMeasurementInitiation >-----#
    commonMeasurementInitiation = CLASS(name='commonMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _commonMeasurementInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    _commonMeasurementInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    _commonMeasurementInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    commonMeasurementInitiation._val = dict([('InitiatingMessage', _commonMeasurementInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _commonMeasurementInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _commonMeasurementInitiation_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 7), ('ddMode', 'common')])), ('criticality', 'reject')])
    
    #-----< radioLinkAdditionFDD >-----#
    radioLinkAdditionFDD = CLASS(name='radioLinkAdditionFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkAdditionFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    _radioLinkAdditionFDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    _radioLinkAdditionFDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    radioLinkAdditionFDD._val = dict([('InitiatingMessage', _radioLinkAdditionFDD_val_InitiatingMessage), ('SuccessfulOutcome', _radioLinkAdditionFDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _radioLinkAdditionFDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'fdd')])), ('criticality', 'reject')])
    
    #-----< radioLinkAdditionTDD >-----#
    radioLinkAdditionTDD = CLASS(name='radioLinkAdditionTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkAdditionTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    _radioLinkAdditionTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    _radioLinkAdditionTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    radioLinkAdditionTDD._val = dict([('InitiatingMessage', _radioLinkAdditionTDD_val_InitiatingMessage), ('SuccessfulOutcome', _radioLinkAdditionTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _radioLinkAdditionTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 23), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< radioLinkDeletion >-----#
    radioLinkDeletion = CLASS(name='radioLinkDeletion', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkDeletion_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    _radioLinkDeletion_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    radioLinkDeletion._val = dict([('InitiatingMessage', _radioLinkDeletion_val_InitiatingMessage), ('SuccessfulOutcome', _radioLinkDeletion_val_SuccessfulOutcome), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 24), ('ddMode', 'common')])), ('criticality', 'reject')])
    
    #-----< synchronisedRadioLinkReconfigurationPreparationFDD >-----#
    synchronisedRadioLinkReconfigurationPreparationFDD = CLASS(name='synchronisedRadioLinkReconfigurationPreparationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _synchronisedRadioLinkReconfigurationPreparationFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    _synchronisedRadioLinkReconfigurationPreparationFDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    _synchronisedRadioLinkReconfigurationPreparationFDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    synchronisedRadioLinkReconfigurationPreparationFDD._val = dict([('InitiatingMessage', _synchronisedRadioLinkReconfigurationPreparationFDD_val_InitiatingMessage), ('SuccessfulOutcome', _synchronisedRadioLinkReconfigurationPreparationFDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _synchronisedRadioLinkReconfigurationPreparationFDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'fdd')])), ('criticality', 'reject')])
    
    #-----< synchronisedRadioLinkReconfigurationPreparationTDD >-----#
    synchronisedRadioLinkReconfigurationPreparationTDD = CLASS(name='synchronisedRadioLinkReconfigurationPreparationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _synchronisedRadioLinkReconfigurationPreparationTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    _synchronisedRadioLinkReconfigurationPreparationTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationReady')))
    _synchronisedRadioLinkReconfigurationPreparationTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    synchronisedRadioLinkReconfigurationPreparationTDD._val = dict([('InitiatingMessage', _synchronisedRadioLinkReconfigurationPreparationTDD_val_InitiatingMessage), ('SuccessfulOutcome', _synchronisedRadioLinkReconfigurationPreparationTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _synchronisedRadioLinkReconfigurationPreparationTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 31), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< unSynchronisedRadioLinkReconfigurationFDD >-----#
    unSynchronisedRadioLinkReconfigurationFDD = CLASS(name='unSynchronisedRadioLinkReconfigurationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _unSynchronisedRadioLinkReconfigurationFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    _unSynchronisedRadioLinkReconfigurationFDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    _unSynchronisedRadioLinkReconfigurationFDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    unSynchronisedRadioLinkReconfigurationFDD._val = dict([('InitiatingMessage', _unSynchronisedRadioLinkReconfigurationFDD_val_InitiatingMessage), ('SuccessfulOutcome', _unSynchronisedRadioLinkReconfigurationFDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _unSynchronisedRadioLinkReconfigurationFDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'fdd')])), ('criticality', 'reject')])
    
    #-----< unSynchronisedRadioLinkReconfigurationTDD >-----#
    unSynchronisedRadioLinkReconfigurationTDD = CLASS(name='unSynchronisedRadioLinkReconfigurationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _unSynchronisedRadioLinkReconfigurationTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    _unSynchronisedRadioLinkReconfigurationTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationResponse')))
    _unSynchronisedRadioLinkReconfigurationTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    unSynchronisedRadioLinkReconfigurationTDD._val = dict([('InitiatingMessage', _unSynchronisedRadioLinkReconfigurationTDD_val_InitiatingMessage), ('SuccessfulOutcome', _unSynchronisedRadioLinkReconfigurationTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _unSynchronisedRadioLinkReconfigurationTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 34), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< dedicatedMeasurementInitiation >-----#
    dedicatedMeasurementInitiation = CLASS(name='dedicatedMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _dedicatedMeasurementInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    _dedicatedMeasurementInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    _dedicatedMeasurementInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    dedicatedMeasurementInitiation._val = dict([('InitiatingMessage', _dedicatedMeasurementInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _dedicatedMeasurementInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _dedicatedMeasurementInitiation_val_UnsuccessfulOutcome), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 17), ('ddMode', 'common')])), ('criticality', 'reject')])
    
    #-----< physicalSharedChannelReconfigurationFDD >-----#
    physicalSharedChannelReconfigurationFDD = CLASS(name='physicalSharedChannelReconfigurationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _physicalSharedChannelReconfigurationFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestFDD')))
    _physicalSharedChannelReconfigurationFDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    _physicalSharedChannelReconfigurationFDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    physicalSharedChannelReconfigurationFDD._val = dict([('InitiatingMessage', _physicalSharedChannelReconfigurationFDD_val_InitiatingMessage), ('SuccessfulOutcome', _physicalSharedChannelReconfigurationFDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _physicalSharedChannelReconfigurationFDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'fdd')])), ('criticality', 'reject')])
    
    #-----< physicalSharedChannelReconfigurationTDD >-----#
    physicalSharedChannelReconfigurationTDD = CLASS(name='physicalSharedChannelReconfigurationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _physicalSharedChannelReconfigurationTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationRequestTDD')))
    _physicalSharedChannelReconfigurationTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationResponse')))
    _physicalSharedChannelReconfigurationTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PhysicalSharedChannelReconfigurationFailure')))
    physicalSharedChannelReconfigurationTDD._val = dict([('InitiatingMessage', _physicalSharedChannelReconfigurationTDD_val_InitiatingMessage), ('SuccessfulOutcome', _physicalSharedChannelReconfigurationTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _physicalSharedChannelReconfigurationTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 37), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< informationExchangeInitiation >-----#
    informationExchangeInitiation = CLASS(name='informationExchangeInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _informationExchangeInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    _informationExchangeInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    _informationExchangeInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    informationExchangeInitiation._val = dict([('InitiatingMessage', _informationExchangeInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _informationExchangeInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _informationExchangeInitiation_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 41), ('ddMode', 'common')])), ('criticality', 'reject')])
    
    #-----< cellSynchronisationInitiationTDD >-----#
    cellSynchronisationInitiationTDD = CLASS(name='cellSynchronisationInitiationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _cellSynchronisationInitiationTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationRequestTDD')))
    _cellSynchronisationInitiationTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationResponseTDD')))
    _cellSynchronisationInitiationTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationInitiationFailureTDD')))
    cellSynchronisationInitiationTDD._val = dict([('InitiatingMessage', _cellSynchronisationInitiationTDD_val_InitiatingMessage), ('SuccessfulOutcome', _cellSynchronisationInitiationTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _cellSynchronisationInitiationTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 45), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< cellSynchronisationReconfigurationTDD >-----#
    cellSynchronisationReconfigurationTDD = CLASS(name='cellSynchronisationReconfigurationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _cellSynchronisationReconfigurationTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationRequestTDD')))
    _cellSynchronisationReconfigurationTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationResponseTDD')))
    _cellSynchronisationReconfigurationTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReconfigurationFailureTDD')))
    cellSynchronisationReconfigurationTDD._val = dict([('InitiatingMessage', _cellSynchronisationReconfigurationTDD_val_InitiatingMessage), ('SuccessfulOutcome', _cellSynchronisationReconfigurationTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _cellSynchronisationReconfigurationTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 46), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< cellSynchronisationAdjustmentTDD >-----#
    cellSynchronisationAdjustmentTDD = CLASS(name='cellSynchronisationAdjustmentTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _cellSynchronisationAdjustmentTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentRequestTDD')))
    _cellSynchronisationAdjustmentTDD_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentResponseTDD')))
    _cellSynchronisationAdjustmentTDD_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationAdjustmentFailureTDD')))
    cellSynchronisationAdjustmentTDD._val = dict([('InitiatingMessage', _cellSynchronisationAdjustmentTDD_val_InitiatingMessage), ('SuccessfulOutcome', _cellSynchronisationAdjustmentTDD_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _cellSynchronisationAdjustmentTDD_val_UnsuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 44), ('ddMode', 'tdd')])), ('criticality', 'reject')])
    
    #-----< ueStatusUpdateConfirmation >-----#
    ueStatusUpdateConfirmation = CLASS(name='ueStatusUpdateConfirmation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _ueStatusUpdateConfirmation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmRequest')))
    _ueStatusUpdateConfirmation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateConfirmResponse')))
    ueStatusUpdateConfirmation._val = dict([('InitiatingMessage', _ueStatusUpdateConfirmation_val_InitiatingMessage), ('SuccessfulOutcome', _ueStatusUpdateConfirmation_val_SuccessfulOutcome), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 57), ('ddMode', 'common')])), ('criticality', 'reject')])
    
    #-----< resourceStatusIndication >-----#
    resourceStatusIndication = CLASS(name='resourceStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _resourceStatusIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ResourceStatusIndication')))
    resourceStatusIndication._val = dict([('InitiatingMessage', _resourceStatusIndication_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 28), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< auditRequired >-----#
    auditRequired = CLASS(name='auditRequired', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _auditRequired_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'AuditRequiredIndication')))
    auditRequired._val = dict([('InitiatingMessage', _auditRequired_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 1), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< commonMeasurementReport >-----#
    commonMeasurementReport = CLASS(name='commonMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _commonMeasurementReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementReport')))
    commonMeasurementReport._val = dict([('InitiatingMessage', _commonMeasurementReport_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 8), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< commonMeasurementTermination >-----#
    commonMeasurementTermination = CLASS(name='commonMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _commonMeasurementTermination_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    commonMeasurementTermination._val = dict([('InitiatingMessage', _commonMeasurementTermination_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 9), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< commonMeasurementFailure >-----#
    commonMeasurementFailure = CLASS(name='commonMeasurementFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _commonMeasurementFailure_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    commonMeasurementFailure._val = dict([('InitiatingMessage', _commonMeasurementFailure_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 6), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< synchronisedRadioLinkReconfigurationCommit >-----#
    synchronisedRadioLinkReconfigurationCommit = CLASS(name='synchronisedRadioLinkReconfigurationCommit', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _synchronisedRadioLinkReconfigurationCommit_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    synchronisedRadioLinkReconfigurationCommit._val = dict([('InitiatingMessage', _synchronisedRadioLinkReconfigurationCommit_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 30), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< synchronisedRadioLinkReconfigurationCancellation >-----#
    synchronisedRadioLinkReconfigurationCancellation = CLASS(name='synchronisedRadioLinkReconfigurationCancellation', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _synchronisedRadioLinkReconfigurationCancellation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    synchronisedRadioLinkReconfigurationCancellation._val = dict([('InitiatingMessage', _synchronisedRadioLinkReconfigurationCancellation_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 29), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< radioLinkFailure >-----#
    radioLinkFailure = CLASS(name='radioLinkFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkFailure_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkFailureIndication')))
    radioLinkFailure._val = dict([('InitiatingMessage', _radioLinkFailure_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 25), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< radioLinkPreemption >-----#
    radioLinkPreemption = CLASS(name='radioLinkPreemption', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkPreemption_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    radioLinkPreemption._val = dict([('InitiatingMessage', _radioLinkPreemption_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 39), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< radioLinkRestoration >-----#
    radioLinkRestoration = CLASS(name='radioLinkRestoration', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkRestoration_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    radioLinkRestoration._val = dict([('InitiatingMessage', _radioLinkRestoration_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 26), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< dedicatedMeasurementReport >-----#
    dedicatedMeasurementReport = CLASS(name='dedicatedMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _dedicatedMeasurementReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementReport')))
    dedicatedMeasurementReport._val = dict([('InitiatingMessage', _dedicatedMeasurementReport_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 18), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< dedicatedMeasurementTermination >-----#
    dedicatedMeasurementTermination = CLASS(name='dedicatedMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _dedicatedMeasurementTermination_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    dedicatedMeasurementTermination._val = dict([('InitiatingMessage', _dedicatedMeasurementTermination_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 19), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< dedicatedMeasurementFailure >-----#
    dedicatedMeasurementFailure = CLASS(name='dedicatedMeasurementFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _dedicatedMeasurementFailure_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    dedicatedMeasurementFailure._val = dict([('InitiatingMessage', _dedicatedMeasurementFailure_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 16), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< downlinkPowerControlFDD >-----#
    downlinkPowerControlFDD = CLASS(name='downlinkPowerControlFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _downlinkPowerControlFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerControlRequest')))
    downlinkPowerControlFDD._val = dict([('InitiatingMessage', _downlinkPowerControlFDD_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 20), ('ddMode', 'fdd')])), ('criticality', 'ignore')])
    
    #-----< downlinkPowerTimeslotControl >-----#
    downlinkPowerTimeslotControl = CLASS(name='downlinkPowerTimeslotControl', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _downlinkPowerTimeslotControl_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    downlinkPowerTimeslotControl._val = dict([('InitiatingMessage', _downlinkPowerTimeslotControl_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 38), ('ddMode', 'tdd')])), ('criticality', 'ignore')])
    
    #-----< compressedModeCommand >-----#
    compressedModeCommand = CLASS(name='compressedModeCommand', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _compressedModeCommand_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CompressedModeCommand')))
    compressedModeCommand._val = dict([('InitiatingMessage', _compressedModeCommand_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 14), ('ddMode', 'fdd')])), ('criticality', 'ignore')])
    
    #-----< unblockResource >-----#
    unblockResource = CLASS(name='unblockResource', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _unblockResource_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UnblockResourceIndication')))
    unblockResource._val = dict([('InitiatingMessage', _unblockResource_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 33), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< errorIndicationForDedicated >-----#
    errorIndicationForDedicated = CLASS(name='errorIndicationForDedicated', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _errorIndicationForDedicated_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    errorIndicationForDedicated._val = dict([('InitiatingMessage', _errorIndicationForDedicated_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 21), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< errorIndicationForCommon >-----#
    errorIndicationForCommon = CLASS(name='errorIndicationForCommon', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _errorIndicationForCommon_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'ErrorIndication')))
    errorIndicationForCommon._val = dict([('InitiatingMessage', _errorIndicationForCommon_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 35), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< cellSynchronisationReportingTDD >-----#
    cellSynchronisationReportingTDD = CLASS(name='cellSynchronisationReportingTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _cellSynchronisationReportingTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationReportTDD')))
    cellSynchronisationReportingTDD._val = dict([('InitiatingMessage', _cellSynchronisationReportingTDD_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 47), ('ddMode', 'tdd')])), ('criticality', 'ignore')])
    
    #-----< cellSynchronisationTerminationTDD >-----#
    cellSynchronisationTerminationTDD = CLASS(name='cellSynchronisationTerminationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _cellSynchronisationTerminationTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationTerminationRequestTDD')))
    cellSynchronisationTerminationTDD._val = dict([('InitiatingMessage', _cellSynchronisationTerminationTDD_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 48), ('ddMode', 'tdd')])), ('criticality', 'ignore')])
    
    #-----< cellSynchronisationFailureTDD >-----#
    cellSynchronisationFailureTDD = CLASS(name='cellSynchronisationFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _cellSynchronisationFailureTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'CellSynchronisationFailureIndicationTDD')))
    cellSynchronisationFailureTDD._val = dict([('InitiatingMessage', _cellSynchronisationFailureTDD_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 49), ('ddMode', 'tdd')])), ('criticality', 'ignore')])
    
    #-----< privateMessageForDedicated >-----#
    privateMessageForDedicated = CLASS(name='privateMessageForDedicated', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _privateMessageForDedicated_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    privateMessageForDedicated._val = dict([('InitiatingMessage', _privateMessageForDedicated_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 22), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< privateMessageForCommon >-----#
    privateMessageForCommon = CLASS(name='privateMessageForCommon', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _privateMessageForCommon_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'PrivateMessage')))
    privateMessageForCommon._val = dict([('InitiatingMessage', _privateMessageForCommon_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 36), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< informationReporting >-----#
    informationReporting = CLASS(name='informationReporting', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _informationReporting_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationReport')))
    informationReporting._val = dict([('InitiatingMessage', _informationReporting_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 43), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< informationExchangeTermination >-----#
    informationExchangeTermination = CLASS(name='informationExchangeTermination', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _informationExchangeTermination_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    informationExchangeTermination._val = dict([('InitiatingMessage', _informationExchangeTermination_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 42), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< informationExchangeFailure >-----#
    informationExchangeFailure = CLASS(name='informationExchangeFailure', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _informationExchangeFailure_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    informationExchangeFailure._val = dict([('InitiatingMessage', _informationExchangeFailure_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 40), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< bearerRearrangement >-----#
    bearerRearrangement = CLASS(name='bearerRearrangement', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _bearerRearrangement_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'BearerRearrangementIndication')))
    bearerRearrangement._val = dict([('InitiatingMessage', _bearerRearrangement_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 50), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< radioLinkActivationFDD >-----#
    radioLinkActivationFDD = CLASS(name='radioLinkActivationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkActivationFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    radioLinkActivationFDD._val = dict([('InitiatingMessage', _radioLinkActivationFDD_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'fdd')])), ('criticality', 'ignore')])
    
    #-----< radioLinkActivationTDD >-----#
    radioLinkActivationTDD = CLASS(name='radioLinkActivationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkActivationTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    radioLinkActivationTDD._val = dict([('InitiatingMessage', _radioLinkActivationTDD_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 51), ('ddMode', 'tdd')])), ('criticality', 'ignore')])
    
    #-----< radioLinkParameterUpdateFDD >-----#
    radioLinkParameterUpdateFDD = CLASS(name='radioLinkParameterUpdateFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkParameterUpdateFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    radioLinkParameterUpdateFDD._val = dict([('InitiatingMessage', _radioLinkParameterUpdateFDD_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'fdd')])), ('criticality', 'ignore')])
    
    #-----< radioLinkParameterUpdateTDD >-----#
    radioLinkParameterUpdateTDD = CLASS(name='radioLinkParameterUpdateTDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _radioLinkParameterUpdateTDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    radioLinkParameterUpdateTDD._val = dict([('InitiatingMessage', _radioLinkParameterUpdateTDD_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 52), ('ddMode', 'tdd')])), ('criticality', 'ignore')])
    
    #-----< mBMSNotificationUpdate >-----#
    mBMSNotificationUpdate = CLASS(name='mBMSNotificationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _mBMSNotificationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'MBMSNotificationUpdateCommand')))
    mBMSNotificationUpdate._val = dict([('InitiatingMessage', _mBMSNotificationUpdate_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 53), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< uEStatusUpdate >-----#
    uEStatusUpdate = CLASS(name='uEStatusUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _uEStatusUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'UEStatusUpdateCommand')))
    uEStatusUpdate._val = dict([('InitiatingMessage', _uEStatusUpdate_val_InitiatingMessage), ('messageDiscriminator', 'common'), ('procedureID', dict([('procedureCode', 54), ('ddMode', 'common')])), ('criticality', 'ignore')])
    
    #-----< secondaryULFrequencyReportingFDD >-----#
    secondaryULFrequencyReportingFDD = CLASS(name='secondaryULFrequencyReportingFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _secondaryULFrequencyReportingFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    secondaryULFrequencyReportingFDD._val = dict([('InitiatingMessage', _secondaryULFrequencyReportingFDD_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 55), ('ddMode', 'fdd')])), ('criticality', 'ignore')])
    
    #-----< secondaryULFrequencyUpdateFDD >-----#
    secondaryULFrequencyUpdateFDD = CLASS(name='secondaryULFrequencyUpdateFDD', mode=MODE_VALUE, typeref=ASN1RefType(('NBAP-PDU-Descriptions', 'NBAP-ELEMENTARY-PROCEDURE')))
    _secondaryULFrequencyUpdateFDD_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NBAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    secondaryULFrequencyUpdateFDD._val = dict([('InitiatingMessage', _secondaryULFrequencyUpdateFDD_val_InitiatingMessage), ('messageDiscriminator', 'dedicated'), ('procedureID', dict([('procedureCode', 56), ('ddMode', 'fdd')])), ('criticality', 'ignore')])
    
    _all_ = [
        _NBAP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _NBAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _NBAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _NBAP_ELEMENTARY_PROCEDURE_Outcome,
        _NBAP_ELEMENTARY_PROCEDURE_messageDiscriminator,
        _NBAP_ELEMENTARY_PROCEDURE_procedureID,
        _NBAP_ELEMENTARY_PROCEDURE_criticality,
        NBAP_ELEMENTARY_PROCEDURE,
        _NBAP_PDU_initiatingMessage,
        _NBAP_PDU_succesfulOutcome,
        _NBAP_PDU_unsuccesfulOutcome,
        _NBAP_PDU_outcome,
        NBAP_PDU,
        __InitiatingMessage_procedureID_tab,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_5,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_8,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_10,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_11,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_12,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_13,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_13,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_14,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_14,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_15,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_15,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_16,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_16,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_17,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_17,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_18,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_19,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_20,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_20,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_21,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_21,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_22,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_22,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_23,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_23,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_24,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_24,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_25,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_25,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_38,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_39,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_40,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_41,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_42,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_43,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_44,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_45,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_46,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_47,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_47,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_47,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_48,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_48,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_48,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_49,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_49,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_49,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_50,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_50,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_50,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_51,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_51,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_51,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_52,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_52,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_53,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_54,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_55,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_56,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_57,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_58,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_59,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_60,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_61,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_62,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_63,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_64,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_65,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_66,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_67,
        _InitiatingMessage_procedureID,
        _InitiatingMessage_criticality,
        _InitiatingMessage_messageDiscriminator,
        _InitiatingMessage_transactionID,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureID_tab,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_18,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_19,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_20,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_20,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_21,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_21,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_22,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_22,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_23,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_23,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_24,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_24,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_25,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_25,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_47,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_47,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_48,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_48,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_49,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_49,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_50,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_50,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_51,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_51,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_52,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_67,
        _SuccessfulOutcome_procedureID,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_messageDiscriminator,
        _SuccessfulOutcome_transactionID,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureID_tab,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_18,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_19,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_20,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_20,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_21,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_21,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_22,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_22,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_23,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_23,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_24,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_24,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_25,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_25,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_47,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_47,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_48,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_48,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_49,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_49,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_50,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_50,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_51,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_51,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_52,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_67,
        _UnsuccessfulOutcome_procedureID,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_messageDiscriminator,
        _UnsuccessfulOutcome_transactionID,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        __Outcome_procedureID_tab,
        ___Outcome_procedureID_tab_val_InitiatingMessage_0,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_0,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_0,
        ___Outcome_procedureID_tab_val_InitiatingMessage_1,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_1,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_1,
        ___Outcome_procedureID_tab_val_InitiatingMessage_2,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_2,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_2,
        ___Outcome_procedureID_tab_val_InitiatingMessage_3,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_3,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_3,
        ___Outcome_procedureID_tab_val_InitiatingMessage_4,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_4,
        ___Outcome_procedureID_tab_val_InitiatingMessage_5,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_5,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_5,
        ___Outcome_procedureID_tab_val_InitiatingMessage_6,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_6,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_6,
        ___Outcome_procedureID_tab_val_InitiatingMessage_7,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_7,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_7,
        ___Outcome_procedureID_tab_val_InitiatingMessage_8,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_8,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_8,
        ___Outcome_procedureID_tab_val_InitiatingMessage_9,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_9,
        ___Outcome_procedureID_tab_val_InitiatingMessage_10,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_10,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_10,
        ___Outcome_procedureID_tab_val_InitiatingMessage_11,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_11,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_11,
        ___Outcome_procedureID_tab_val_InitiatingMessage_12,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_12,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_12,
        ___Outcome_procedureID_tab_val_InitiatingMessage_13,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_13,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_13,
        ___Outcome_procedureID_tab_val_InitiatingMessage_14,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_14,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_14,
        ___Outcome_procedureID_tab_val_InitiatingMessage_15,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_15,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_15,
        ___Outcome_procedureID_tab_val_InitiatingMessage_16,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_16,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_16,
        ___Outcome_procedureID_tab_val_InitiatingMessage_17,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_17,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_17,
        ___Outcome_procedureID_tab_val_InitiatingMessage_18,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_18,
        ___Outcome_procedureID_tab_val_InitiatingMessage_19,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_19,
        ___Outcome_procedureID_tab_val_InitiatingMessage_20,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_20,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_20,
        ___Outcome_procedureID_tab_val_InitiatingMessage_21,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_21,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_21,
        ___Outcome_procedureID_tab_val_InitiatingMessage_22,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_22,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_22,
        ___Outcome_procedureID_tab_val_InitiatingMessage_23,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_23,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_23,
        ___Outcome_procedureID_tab_val_InitiatingMessage_24,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_24,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_24,
        ___Outcome_procedureID_tab_val_InitiatingMessage_25,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_25,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_25,
        ___Outcome_procedureID_tab_val_InitiatingMessage_26,
        ___Outcome_procedureID_tab_val_InitiatingMessage_27,
        ___Outcome_procedureID_tab_val_InitiatingMessage_28,
        ___Outcome_procedureID_tab_val_InitiatingMessage_29,
        ___Outcome_procedureID_tab_val_InitiatingMessage_30,
        ___Outcome_procedureID_tab_val_InitiatingMessage_31,
        ___Outcome_procedureID_tab_val_InitiatingMessage_32,
        ___Outcome_procedureID_tab_val_InitiatingMessage_33,
        ___Outcome_procedureID_tab_val_InitiatingMessage_34,
        ___Outcome_procedureID_tab_val_InitiatingMessage_35,
        ___Outcome_procedureID_tab_val_InitiatingMessage_36,
        ___Outcome_procedureID_tab_val_InitiatingMessage_37,
        ___Outcome_procedureID_tab_val_InitiatingMessage_38,
        ___Outcome_procedureID_tab_val_InitiatingMessage_39,
        ___Outcome_procedureID_tab_val_InitiatingMessage_40,
        ___Outcome_procedureID_tab_val_InitiatingMessage_41,
        ___Outcome_procedureID_tab_val_InitiatingMessage_42,
        ___Outcome_procedureID_tab_val_InitiatingMessage_43,
        ___Outcome_procedureID_tab_val_InitiatingMessage_44,
        ___Outcome_procedureID_tab_val_InitiatingMessage_45,
        ___Outcome_procedureID_tab_val_InitiatingMessage_46,
        ___Outcome_procedureID_tab_val_InitiatingMessage_47,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_47,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_47,
        ___Outcome_procedureID_tab_val_InitiatingMessage_48,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_48,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_48,
        ___Outcome_procedureID_tab_val_InitiatingMessage_49,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_49,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_49,
        ___Outcome_procedureID_tab_val_InitiatingMessage_50,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_50,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_50,
        ___Outcome_procedureID_tab_val_InitiatingMessage_51,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_51,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_51,
        ___Outcome_procedureID_tab_val_InitiatingMessage_52,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_52,
        ___Outcome_procedureID_tab_val_InitiatingMessage_53,
        ___Outcome_procedureID_tab_val_InitiatingMessage_54,
        ___Outcome_procedureID_tab_val_InitiatingMessage_55,
        ___Outcome_procedureID_tab_val_InitiatingMessage_56,
        ___Outcome_procedureID_tab_val_InitiatingMessage_57,
        ___Outcome_procedureID_tab_val_InitiatingMessage_58,
        ___Outcome_procedureID_tab_val_InitiatingMessage_59,
        ___Outcome_procedureID_tab_val_InitiatingMessage_60,
        ___Outcome_procedureID_tab_val_InitiatingMessage_61,
        ___Outcome_procedureID_tab_val_InitiatingMessage_62,
        ___Outcome_procedureID_tab_val_InitiatingMessage_63,
        ___Outcome_procedureID_tab_val_InitiatingMessage_64,
        ___Outcome_procedureID_tab_val_InitiatingMessage_65,
        ___Outcome_procedureID_tab_val_InitiatingMessage_66,
        ___Outcome_procedureID_tab_val_InitiatingMessage_67,
        _Outcome_procedureID,
        _Outcome_criticality,
        _Outcome_messageDiscriminator,
        _Outcome_transactionID,
        _Outcome_value,
        Outcome,
        NBAP_ELEMENTARY_PROCEDURES,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_17,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_22,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_23,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_47,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_47,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_48,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_48,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_49,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_49,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_50,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_50,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_51,
        _NBAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_51,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52,
        _NBAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_52,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66,
        _NBAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_67,
        NBAP_ELEMENTARY_PROCEDURES_CLASS_1,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_22,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_23,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_26,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_27,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_27,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_27,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_28,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_28,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_28,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_29,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_29,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_29,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_30,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_30,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_30,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_31,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_31,
        NBAP_ELEMENTARY_PROCEDURES_CLASS_2,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34,
        _NBAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35,
        cellSetupFDD,
        _cellSetupFDD_val_InitiatingMessage,
        _cellSetupFDD_val_SuccessfulOutcome,
        _cellSetupFDD_val_UnsuccessfulOutcome,
        cellSetupTDD,
        _cellSetupTDD_val_InitiatingMessage,
        _cellSetupTDD_val_SuccessfulOutcome,
        _cellSetupTDD_val_UnsuccessfulOutcome,
        cellReconfigurationFDD,
        _cellReconfigurationFDD_val_InitiatingMessage,
        _cellReconfigurationFDD_val_SuccessfulOutcome,
        _cellReconfigurationFDD_val_UnsuccessfulOutcome,
        cellReconfigurationTDD,
        _cellReconfigurationTDD_val_InitiatingMessage,
        _cellReconfigurationTDD_val_SuccessfulOutcome,
        _cellReconfigurationTDD_val_UnsuccessfulOutcome,
        cellDeletion,
        _cellDeletion_val_InitiatingMessage,
        _cellDeletion_val_SuccessfulOutcome,
        commonTransportChannelSetupFDD,
        _commonTransportChannelSetupFDD_val_InitiatingMessage,
        _commonTransportChannelSetupFDD_val_SuccessfulOutcome,
        _commonTransportChannelSetupFDD_val_UnsuccessfulOutcome,
        commonTransportChannelSetupTDD,
        _commonTransportChannelSetupTDD_val_InitiatingMessage,
        _commonTransportChannelSetupTDD_val_SuccessfulOutcome,
        _commonTransportChannelSetupTDD_val_UnsuccessfulOutcome,
        commonTransportChannelReconfigureFDD,
        _commonTransportChannelReconfigureFDD_val_InitiatingMessage,
        _commonTransportChannelReconfigureFDD_val_SuccessfulOutcome,
        _commonTransportChannelReconfigureFDD_val_UnsuccessfulOutcome,
        commonTransportChannelReconfigureTDD,
        _commonTransportChannelReconfigureTDD_val_InitiatingMessage,
        _commonTransportChannelReconfigureTDD_val_SuccessfulOutcome,
        _commonTransportChannelReconfigureTDD_val_UnsuccessfulOutcome,
        commonTransportChannelDelete,
        _commonTransportChannelDelete_val_InitiatingMessage,
        _commonTransportChannelDelete_val_SuccessfulOutcome,
        audit,
        _audit_val_InitiatingMessage,
        _audit_val_SuccessfulOutcome,
        _audit_val_UnsuccessfulOutcome,
        blockResource,
        _blockResource_val_InitiatingMessage,
        _blockResource_val_SuccessfulOutcome,
        _blockResource_val_UnsuccessfulOutcome,
        radioLinkSetupFDD,
        _radioLinkSetupFDD_val_InitiatingMessage,
        _radioLinkSetupFDD_val_SuccessfulOutcome,
        _radioLinkSetupFDD_val_UnsuccessfulOutcome,
        radioLinkSetupTDD,
        _radioLinkSetupTDD_val_InitiatingMessage,
        _radioLinkSetupTDD_val_SuccessfulOutcome,
        _radioLinkSetupTDD_val_UnsuccessfulOutcome,
        systemInformationUpdate,
        _systemInformationUpdate_val_InitiatingMessage,
        _systemInformationUpdate_val_SuccessfulOutcome,
        _systemInformationUpdate_val_UnsuccessfulOutcome,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        commonMeasurementInitiation,
        _commonMeasurementInitiation_val_InitiatingMessage,
        _commonMeasurementInitiation_val_SuccessfulOutcome,
        _commonMeasurementInitiation_val_UnsuccessfulOutcome,
        radioLinkAdditionFDD,
        _radioLinkAdditionFDD_val_InitiatingMessage,
        _radioLinkAdditionFDD_val_SuccessfulOutcome,
        _radioLinkAdditionFDD_val_UnsuccessfulOutcome,
        radioLinkAdditionTDD,
        _radioLinkAdditionTDD_val_InitiatingMessage,
        _radioLinkAdditionTDD_val_SuccessfulOutcome,
        _radioLinkAdditionTDD_val_UnsuccessfulOutcome,
        radioLinkDeletion,
        _radioLinkDeletion_val_InitiatingMessage,
        _radioLinkDeletion_val_SuccessfulOutcome,
        synchronisedRadioLinkReconfigurationPreparationFDD,
        _synchronisedRadioLinkReconfigurationPreparationFDD_val_InitiatingMessage,
        _synchronisedRadioLinkReconfigurationPreparationFDD_val_SuccessfulOutcome,
        _synchronisedRadioLinkReconfigurationPreparationFDD_val_UnsuccessfulOutcome,
        synchronisedRadioLinkReconfigurationPreparationTDD,
        _synchronisedRadioLinkReconfigurationPreparationTDD_val_InitiatingMessage,
        _synchronisedRadioLinkReconfigurationPreparationTDD_val_SuccessfulOutcome,
        _synchronisedRadioLinkReconfigurationPreparationTDD_val_UnsuccessfulOutcome,
        unSynchronisedRadioLinkReconfigurationFDD,
        _unSynchronisedRadioLinkReconfigurationFDD_val_InitiatingMessage,
        _unSynchronisedRadioLinkReconfigurationFDD_val_SuccessfulOutcome,
        _unSynchronisedRadioLinkReconfigurationFDD_val_UnsuccessfulOutcome,
        unSynchronisedRadioLinkReconfigurationTDD,
        _unSynchronisedRadioLinkReconfigurationTDD_val_InitiatingMessage,
        _unSynchronisedRadioLinkReconfigurationTDD_val_SuccessfulOutcome,
        _unSynchronisedRadioLinkReconfigurationTDD_val_UnsuccessfulOutcome,
        dedicatedMeasurementInitiation,
        _dedicatedMeasurementInitiation_val_InitiatingMessage,
        _dedicatedMeasurementInitiation_val_SuccessfulOutcome,
        _dedicatedMeasurementInitiation_val_UnsuccessfulOutcome,
        physicalSharedChannelReconfigurationFDD,
        _physicalSharedChannelReconfigurationFDD_val_InitiatingMessage,
        _physicalSharedChannelReconfigurationFDD_val_SuccessfulOutcome,
        _physicalSharedChannelReconfigurationFDD_val_UnsuccessfulOutcome,
        physicalSharedChannelReconfigurationTDD,
        _physicalSharedChannelReconfigurationTDD_val_InitiatingMessage,
        _physicalSharedChannelReconfigurationTDD_val_SuccessfulOutcome,
        _physicalSharedChannelReconfigurationTDD_val_UnsuccessfulOutcome,
        informationExchangeInitiation,
        _informationExchangeInitiation_val_InitiatingMessage,
        _informationExchangeInitiation_val_SuccessfulOutcome,
        _informationExchangeInitiation_val_UnsuccessfulOutcome,
        cellSynchronisationInitiationTDD,
        _cellSynchronisationInitiationTDD_val_InitiatingMessage,
        _cellSynchronisationInitiationTDD_val_SuccessfulOutcome,
        _cellSynchronisationInitiationTDD_val_UnsuccessfulOutcome,
        cellSynchronisationReconfigurationTDD,
        _cellSynchronisationReconfigurationTDD_val_InitiatingMessage,
        _cellSynchronisationReconfigurationTDD_val_SuccessfulOutcome,
        _cellSynchronisationReconfigurationTDD_val_UnsuccessfulOutcome,
        cellSynchronisationAdjustmentTDD,
        _cellSynchronisationAdjustmentTDD_val_InitiatingMessage,
        _cellSynchronisationAdjustmentTDD_val_SuccessfulOutcome,
        _cellSynchronisationAdjustmentTDD_val_UnsuccessfulOutcome,
        ueStatusUpdateConfirmation,
        _ueStatusUpdateConfirmation_val_InitiatingMessage,
        _ueStatusUpdateConfirmation_val_SuccessfulOutcome,
        resourceStatusIndication,
        _resourceStatusIndication_val_InitiatingMessage,
        auditRequired,
        _auditRequired_val_InitiatingMessage,
        commonMeasurementReport,
        _commonMeasurementReport_val_InitiatingMessage,
        commonMeasurementTermination,
        _commonMeasurementTermination_val_InitiatingMessage,
        commonMeasurementFailure,
        _commonMeasurementFailure_val_InitiatingMessage,
        synchronisedRadioLinkReconfigurationCommit,
        _synchronisedRadioLinkReconfigurationCommit_val_InitiatingMessage,
        synchronisedRadioLinkReconfigurationCancellation,
        _synchronisedRadioLinkReconfigurationCancellation_val_InitiatingMessage,
        radioLinkFailure,
        _radioLinkFailure_val_InitiatingMessage,
        radioLinkPreemption,
        _radioLinkPreemption_val_InitiatingMessage,
        radioLinkRestoration,
        _radioLinkRestoration_val_InitiatingMessage,
        dedicatedMeasurementReport,
        _dedicatedMeasurementReport_val_InitiatingMessage,
        dedicatedMeasurementTermination,
        _dedicatedMeasurementTermination_val_InitiatingMessage,
        dedicatedMeasurementFailure,
        _dedicatedMeasurementFailure_val_InitiatingMessage,
        downlinkPowerControlFDD,
        _downlinkPowerControlFDD_val_InitiatingMessage,
        downlinkPowerTimeslotControl,
        _downlinkPowerTimeslotControl_val_InitiatingMessage,
        compressedModeCommand,
        _compressedModeCommand_val_InitiatingMessage,
        unblockResource,
        _unblockResource_val_InitiatingMessage,
        errorIndicationForDedicated,
        _errorIndicationForDedicated_val_InitiatingMessage,
        errorIndicationForCommon,
        _errorIndicationForCommon_val_InitiatingMessage,
        cellSynchronisationReportingTDD,
        _cellSynchronisationReportingTDD_val_InitiatingMessage,
        cellSynchronisationTerminationTDD,
        _cellSynchronisationTerminationTDD_val_InitiatingMessage,
        cellSynchronisationFailureTDD,
        _cellSynchronisationFailureTDD_val_InitiatingMessage,
        privateMessageForDedicated,
        _privateMessageForDedicated_val_InitiatingMessage,
        privateMessageForCommon,
        _privateMessageForCommon_val_InitiatingMessage,
        informationReporting,
        _informationReporting_val_InitiatingMessage,
        informationExchangeTermination,
        _informationExchangeTermination_val_InitiatingMessage,
        informationExchangeFailure,
        _informationExchangeFailure_val_InitiatingMessage,
        bearerRearrangement,
        _bearerRearrangement_val_InitiatingMessage,
        radioLinkActivationFDD,
        _radioLinkActivationFDD_val_InitiatingMessage,
        radioLinkActivationTDD,
        _radioLinkActivationTDD_val_InitiatingMessage,
        radioLinkParameterUpdateFDD,
        _radioLinkParameterUpdateFDD_val_InitiatingMessage,
        radioLinkParameterUpdateTDD,
        _radioLinkParameterUpdateTDD_val_InitiatingMessage,
        mBMSNotificationUpdate,
        _mBMSNotificationUpdate_val_InitiatingMessage,
        uEStatusUpdate,
        _uEStatusUpdate_val_InitiatingMessage,
        secondaryULFrequencyReportingFDD,
        _secondaryULFrequencyReportingFDD_val_InitiatingMessage,
        secondaryULFrequencyUpdateFDD,
        _secondaryULFrequencyUpdateFDD_val_InitiatingMessage,
    ]

init_modules(NBAP_CommonDataTypes, NBAP_Constants, NBAP_Containers, NBAP_IEs, NBAP_PDU_Contents, NBAP_PDU_Descriptions)
